/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var re=["require","exports","vs/base/common/lifecycle","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/base/common/async","vs/base/common/platform","vs/platform/log/common/log","vs/base/common/errors","vs/base/common/types","vs/nls!vs/code/node/sharedProcess/sharedProcessMain","vs/base/common/uri","vs/nls","vs/platform/files/common/files","vs/base/common/buffer","vs/base/common/path","vs/platform/environment/common/environment","vs/platform/userDataProfile/common/userDataProfile","vs/platform/configuration/common/configuration","vs/platform/storage/common/storage","vs/base/common/arrays","vs/platform/telemetry/common/telemetry","vs/base/common/network","vs/base/common/resources","vs/platform/product/common/productService","vs/platform/userDataSync/common/userDataSync","vs/base/common/cancellation","vs/platform/uriIdentity/common/uriIdentity","vs/base/common/strings","vs/platform/extensionManagement/common/extensionManagement","vs/base/common/objects","vs/base/node/pfs","vs/base/common/uuid","vs/platform/extensionManagement/common/extensionManagementUtil","vs/base/common/json","vs/base/common/map","os","vs/base/common/process","vs/base/common/errorMessage","vs/platform/userDataSync/common/abstractSynchronizer","vs/platform/registry/common/platform","vs/base/common/jsonFormatter","vs/base/common/stream","vs/base/parts/ipc/common/ipc","vs/platform/externalServices/common/serviceMachineId","vs/platform/extensions/common/extensions","vs/platform/telemetry/common/telemetryUtils","vs/base/common/ternarySearchTree","vs/base/common/extpath","vs/platform/configuration/common/configurationRegistry","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/base/common/hash","fs","vs/base/common/semver/semver","vs/platform/files/common/watcher","vs/platform/native/common/native","vs/platform/policy/common/policy","vs/platform/request/common/request","vs/platform/userDataProfile/common/userDataProfileStorageService","vs/base/common/iterator","vs/base/common/stopwatch","net","vs/base/common/date","vs/base/common/marshalling","child_process","vs/base/parts/ipc/common/ipc.net","vs/base/parts/storage/common/storage","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/descriptors","crypto","vs/platform/instantiation/common/serviceCollection","vs/platform/ipc/common/mainProcessService","vs/platform/languagePacks/common/languagePacks","vs/platform/configuration/common/configurationModels","vs/platform/remote/common/remoteHosts","vs/platform/storage/common/storageIpc","vs/platform/tunnel/common/tunnel","vs/platform/userDataSync/common/content","vs/platform/userDataSync/common/userDataSyncAccount","vs/platform/extensionManagement/common/extensionsScannerService","vs/platform/extensionManagement/common/extensionStorage","vs/platform/userDataSync/common/userDataSyncMachines","vs/base/node/zip","vs/base/common/decorators","vs/base/common/functional","vs/base/common/jsonEdit","vs/base/common/lazy","vs/base/common/linkedList","vs/base/common/normalization","vs/base/common/severity","vs/base/common/processes","vs/base/common/glob","vs/base/common/uriIpc","vs/base/parts/ipc/node/ipc.cp","vs/platform/contextkey/common/contextkey","vs/platform/diagnostics/common/diagnostics","vs/platform/download/common/download","vs/platform/extensionManagement/node/extensionSignatureVerificationService","vs/platform/extensionRecommendations/common/extensionRecommendations","vs/platform/files/common/io","vs/base/common/performance","vs/platform/lifecycle/node/sharedProcessLifecycleService","vs/platform/product/common/product","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/remote/common/remoteSocketFactoryService","vs/platform/remoteTunnel/common/remoteTunnel","vs/platform/sign/common/sign","vs/platform/telemetry/common/commonProperties","vs/platform/telemetry/common/telemetryIpc","vs/platform/telemetry/common/telemetryLogAppender","vs/platform/telemetry/common/telemetryService","vs/platform/userDataSync/common/ignoredExtensions","vs/platform/voiceRecognition/node/voiceRecognitionService","vs/platform/workspace/common/workspace","vs/platform/extensionManagement/common/extensionEnablementService","vs/platform/userDataSync/common/extensionsSync","vs/platform/userDataSync/common/globalStateSync","vs/platform/userDataSync/common/keybindingsSync","vs/platform/userDataSync/common/settingsSync","vs/platform/userDataSync/common/snippetsSync","vs/platform/userDataSync/common/tasksSync","vs/platform/userDataSync/common/userDataProfilesManifestSync","vs/platform/extensionManagement/node/extensionManagementService","vs/base/parts/ipc/node/ipc.net","vs/base/common/amd","vs/base/common/arraysFind","vs/base/common/assert","vs/base/common/skipList","vs/base/common/cache","vs/base/common/symbols","vs/base/node/macAddress","vs/base/node/id","vs/base/node/nodeStreams","vs/base/node/ports","vs/base/parts/sandbox/node/electronTypes","vs/nls!vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/nls!vs/base/common/platform","vs/base/common/mime","vs/base/common/console","vs/amdX","vs/base/node/extpath","vs/base/node/processes","vs/base/node/ps","vs/base/parts/ipc/node/ipc.mp","vs/nls!vs/base/node/zip","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionNls","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/languagePacks/common/languagePacks","vs/nls!vs/platform/remoteTunnel/common/remoteTunnel","vs/nls!vs/platform/remoteTunnel/node/remoteTunnelService","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/telemetry/common/telemetryLogAppender","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/userDataSync/common/abstractSynchronizer","vs/nls!vs/platform/userDataSync/common/keybindingsSync","vs/nls!vs/platform/userDataSync/common/settingsSync","vs/nls!vs/platform/userDataSync/common/userDataAutoSyncService","vs/nls!vs/platform/userDataSync/common/userDataSync","vs/nls!vs/platform/userDataSync/common/userDataSyncLog","vs/nls!vs/platform/userDataSync/common/userDataSyncMachines","vs/nls!vs/platform/userDataSync/common/userDataSyncResourceProvider","vs/nls!vs/platform/workspace/common/workspace","vs/platform/contextkey/common/scanner","vs/platform/environment/common/environmentService","vs/platform/environment/node/userDataPath","vs/platform/environment/node/environmentService","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensionRecommendations/common/extensionRecommendationsIpc","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/checksum/common/checksumService","vs/platform/extensionManagement/common/extensionManagementIpc","vs/platform/checksum/node/checksumService","vs/platform/files/common/diskFileSystemProviderClient","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/code/node/sharedProcess/contrib/localizationsUpdater","vs/code/node/sharedProcess/contrib/logsDataCleaner","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/platform/files/node/diskFileSystemProvider","vs/platform/log/common/logIpc","vs/platform/log/common/logService","vs/platform/policy/common/policyIpc","vs/code/node/sharedProcess/contrib/codeCacheCleaner","vs/code/node/sharedProcess/contrib/languagePackCachedDataCleaner","vs/platform/profiling/common/profiling","vs/platform/profiling/node/profilingService","vs/platform/configuration/common/configurations","vs/platform/configuration/common/configurationService","vs/platform/remote/common/managedSocket","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/remote/common/remoteAgentConnection","vs/platform/remote/common/sharedProcessTunnelService","vs/platform/download/common/downloadService","vs/platform/request/common/requestIpc","vs/platform/sharedProcess/common/sharedProcess","vs/platform/sign/common/abstractSignService","vs/platform/sign/node/signService","vs/platform/diagnostics/node/diagnosticsService","vs/platform/extensionManagement/common/extensionTipsService","vs/platform/extensionManagement/common/unsupportedExtensionsMigration","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/externalServices/common/marketplace","vs/platform/languagePacks/node/languagePacks","vs/platform/telemetry/common/1dsAppender","vs/platform/telemetry/node/1dsAppender","vs/platform/telemetry/node/customEndpointTelemetryService","vs/platform/tunnel/node/sharedProcessTunnelService","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/userData/common/fileUserDataProvider","vs/platform/userDataSync/common/extensionsMerge","vs/platform/userDataSync/common/keybindingsMerge","vs/platform/userDataSync/common/snippetsMerge","vs/platform/userDataSync/common/userDataProfilesManifestMerge","vs/platform/userDataSync/common/globalStateMerge","vs/platform/userDataSync/common/settingsMerge","vs/platform/userDataSync/common/userDataSyncIpc","vs/platform/userDataSync/common/userDataSyncLog","vs/code/node/sharedProcess/contrib/voiceTranscriber","vs/platform/windows/node/windowTracker","vs/code/node/sharedProcess/contrib/userDataProfilesCleaner","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/extensionManagement/node/extensionsProfileScannerService","vs/platform/extensionManagement/node/extensionsScannerService","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/extensionManagement/node/extensionTipsService","vs/platform/remoteTunnel/node/remoteTunnelService","vs/platform/storage/common/storageService","vs/platform/userDataProfile/common/userDataProfileIpc","vs/platform/userDataProfile/node/userDataProfileStorageService","vs/platform/userDataSync/common/userDataSyncBackupStoreService","vs/platform/userDataSync/common/userDataSyncEnablementService","vs/platform/userDataSync/common/userDataAutoSyncService","vs/platform/userDataSync/common/userDataSyncResourceProvider","vs/platform/userDataSync/common/userDataSyncService","vs/platform/userDataSync/common/userDataSyncServiceIpc","vs/platform/userDataSync/common/userDataSyncStoreService","vs/platform/userDataSync/node/userDataAutoSyncService","vs/platform/workspaces/node/workspaces","vs/code/node/sharedProcess/contrib/storageDataCleaner","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionManagementUtil","vs/code/node/sharedProcess/contrib/extensions","vs/platform/remote/node/nodeSocketFactory","vs/platform/tunnel/node/tunnelService","stream","util","path","graceful-fs","https","yauzl","yazl","zlib","vs/code/node/sharedProcess/sharedProcessMain"],oe=function(te){for(var e=[],L=0,N=te.length;L<N;L++)e[L]=re[te[L]];return e};define(re[124],oe([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$S=e.$R=void 0,e.$R=!1;class L{static get(){const O=new Map,j=new Map,A=new Map,R=new Map;function k(h,d){h.has(d.detail)||h.set(d.detail,-d.timestamp)}function m(h,d){const w=h.get(d.detail);w&&(w>=0||h.set(d.detail,w+d.timestamp))}let P=[];typeof te=="function"&&typeof te.getStats=="function"&&(P=te.getStats().slice(0).sort((h,d)=>h.timestamp-d.timestamp));for(const h of P)switch(h.type){case 10:k(O,h);break;case 11:case 12:m(O,h);break;case 21:k(j,h);break;case 22:m(j,h);break;case 33:k(A,h);break;case 34:m(A,h);break;case 31:k(R,h);break;case 32:m(R,h);break}let p=0;A.forEach(h=>p+=h);function g(h){const d=[];return h.forEach((w,f)=>d.push([f,w])),d}return{amdLoad:g(O),amdInvoke:g(j),nodeRequire:g(A),nodeEval:g(R),nodeRequireTotal:p}}static toMarkdownTable(O,j){let A="";const R=[];return O.forEach((k,m)=>{R[m]=k.length}),j.forEach(k=>{k.forEach((m,P)=>{typeof m>"u"&&(m=k[P]="-");const p=m.toString().length;R[P]=Math.max(p,R[P])})}),O.forEach((k,m)=>{A+=`| ${k+" ".repeat(R[m]-k.toString().length)} `}),A+=`|
`,O.forEach((k,m)=>{A+=`| ${"-".repeat(R[m])} `}),A+=`|
`,j.forEach(k=>{k.forEach((m,P)=>{typeof m<"u"&&(A+=`| ${m+" ".repeat(R[P]-m.toString().length)} `)}),A+=`|
`}),A}}e.$S=L}),define(re[125],oe([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lf=e.$kf=e.$jf=e.$if=e.$hf=e.$gf=e.$ff=e.$ef=e.$df=e.$cf=e.$bf=e.$af=e.$_e=void 0;function L(w,f,o){const l=N(w,f);if(l!==-1)return w[l]}e.$_e=L;function N(w,f,o=w.length-1){for(let l=o;l>=0;l--){const $=w[l];if(f($))return l}return-1}e.$af=N;function O(w,f){const o=j(w,f);return o===-1?void 0:w[o]}e.$bf=O;function j(w,f,o=0,l=w.length){let $=o,b=l;for(;$<b;){const I=Math.floor(($+b)/2);f(w[I])?$=I+1:b=I}return $-1}e.$cf=j;function A(w,f){const o=R(w,f);return o===w.length?void 0:w[o]}e.$df=A;function R(w,f,o=0,l=w.length){let $=o,b=l;for(;$<b;){const I=Math.floor(($+b)/2);f(w[I])?b=I:$=I+1}return $}e.$ef=R;function k(w,f,o=0,l=w.length){const $=R(w,f,o,l);return $===w.length?-1:$}e.$ff=k;class m{static{this.assertInvariants=!1}constructor(f){this.e=f,this.c=0}findLastMonotonous(f){if(m.assertInvariants){if(this.d){for(const l of this.e)if(this.d(l)&&!f(l))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this.d=f}const o=j(this.e,f,this.c);return this.c=o+1,o===-1?void 0:this.e[o]}}e.$gf=m;function P(w,f){if(w.length===0)return;let o=w[0];for(let l=1;l<w.length;l++){const $=w[l];f($,o)>0&&(o=$)}return o}e.$hf=P;function p(w,f){if(w.length===0)return;let o=w[0];for(let l=1;l<w.length;l++){const $=w[l];f($,o)>=0&&(o=$)}return o}e.$if=p;function g(w,f){return P(w,(o,l)=>-f(o,l))}e.$jf=g;function h(w,f){if(w.length===0)return-1;let o=0;for(let l=1;l<w.length;l++){const $=w[l];f($,w[o])>0&&(o=l)}return o}e.$kf=h;function d(w,f){for(const o of w){const l=f(o);if(l!==void 0)return l}}e.$lf=d}),define(re[83],oe([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6g=e.$5g=e.$4g=void 0;function L(A){return(R,k,m)=>{let P=null,p=null;if(typeof m.value=="function"?(P="value",p=m.value):typeof m.get=="function"&&(P="get",p=m.get),!p)throw new Error("not supported");m[P]=A(p,k)}}function N(A,R,k){let m=null,P=null;if(typeof k.value=="function"?(m="value",P=k.value,P.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof k.get=="function"&&(m="get",P=k.get),!P)throw new Error("not supported");const p=`$memoize$${R}`;k[m]=function(...g){return this.hasOwnProperty(p)||Object.defineProperty(this,p,{configurable:!1,enumerable:!1,writable:!1,value:P.apply(this,g)}),this[p]}}e.$4g=N;function O(A,R,k){return L((m,P)=>{const p=`$debounce$${P}`,g=`$debounce$result$${P}`;return function(...h){this[g]||(this[g]=k?k():void 0),clearTimeout(this[p]),R&&(this[g]=R(this[g],...h),h=[this[g]]),this[p]=setTimeout(()=>{m.apply(this,h),this[g]=k?k():void 0},A)}})}e.$5g=O;function j(A,R,k){return L((m,P)=>{const p=`$throttle$timer$${P}`,g=`$throttle$result$${P}`,h=`$throttle$lastRun$${P}`,d=`$throttle$pending$${P}`;return function(...w){if(this[g]||(this[g]=k?k():void 0),(this[h]===null||this[h]===void 0)&&(this[h]=-Number.MAX_VALUE),R&&(this[g]=R(this[g],...w)),this[d])return;const f=this[h]+A;f<=Date.now()?(this[h]=Date.now(),m.apply(this,[this[g]]),this[g]=k?k():void 0):(this[d]=!0,this[p]=setTimeout(()=>{this[d]=!1,this[h]=Date.now(),m.apply(this,[this[g]]),this[g]=k?k():void 0},f-Date.now()))}})}e.$6g=j}),define(re[8],oe([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ab=e.$_=e.$$=e.$0=e.$9=e.$8=e.$7=e.$6=e.$5=e.$4=e.$3=e.$2=e.$1=e.$Z=e.$Y=e.$X=e.setUnexpectedErrorHandler=e.$V=e.$U=void 0;class L{constructor(){this.b=[],this.a=function(t){setTimeout(()=>{throw t.stack?$.isErrorNoTelemetry(t)?new $(t.message+`

`+t.stack):new Error(t.message+`

`+t.stack):t},0)}}addListener(t){return this.b.push(t),()=>{this.d(t)}}c(t){this.b.forEach(c=>{c(t)})}d(t){this.b.splice(this.b.indexOf(t),1)}setUnexpectedErrorHandler(t){this.a=t}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(t){this.a(t),this.c(t)}onUnexpectedExternalError(t){this.a(t)}}e.$U=L,e.$V=new L;function N(I){e.$V.setUnexpectedErrorHandler(I)}e.setUnexpectedErrorHandler=N;function O(I){if(!I||typeof I!="object")return!1;const t=I;return t.code==="EPIPE"&&t.syscall?.toUpperCase()==="WRITE"}e.$X=O;function j(I){m(I)||e.$V.onUnexpectedError(I)}e.$Y=j;function A(I){m(I)||e.$V.onUnexpectedExternalError(I)}e.$Z=A;function R(I){if(I instanceof Error){const{name:t,message:c}=I,s=I.stacktrace||I.stack;return{$isError:!0,name:t,message:c,stack:s,noTelemetry:$.isErrorNoTelemetry(I)}}return I}e.$1=R;const k="Canceled";function m(I){return I instanceof P?!0:I instanceof Error&&I.name===k&&I.message===k}e.$2=m;class P extends Error{constructor(){super(k),this.name=this.message}}e.$3=P;function p(){const I=new Error(k);return I.name=I.message,I}e.$4=p;function g(I){return I?new Error(`Illegal argument: ${I}`):new Error("Illegal argument")}e.$5=g;function h(I){return I?new Error(`Illegal state: ${I}`):new Error("Illegal state")}e.$6=h;class d extends TypeError{constructor(t){super(t?`${t} is read-only and cannot be changed`:"Cannot change read-only property")}}e.$7=d;function w(I){return I?I.message?I.message:I.stack?I.stack.split(`
`)[0]:String(I):"Error"}e.$8=w;class f extends Error{constructor(t){super("NotImplemented"),t&&(this.message=t)}}e.$9=f;class o extends Error{constructor(t){super("NotSupported"),t&&(this.message=t)}}e.$0=o;class l extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.$$=l;class $ extends Error{constructor(t){super(t),this.name="CodeExpectedError"}static fromError(t){if(t instanceof $)return t;const c=new $;return c.message=t.message,c.stack=t.stack,c}static isErrorNoTelemetry(t){return t.name==="CodeExpectedError"}}e.$_=$;class b extends Error{constructor(t){super(t||"An unexpected bug occurred."),Object.setPrototypeOf(this,b.prototype)}}e.$ab=b}),define(re[20],oe([0,1,8,125]),function(te,e,L,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6f=e.$5f=e.$4f=e.$3f=e.$2f=e.$1f=e.$Zf=e.CompareResult=e.$Yf=e.$Xf=e.$Wf=e.$Vf=e.$Uf=e.$Tf=e.$Sf=e.$Rf=e.$Qf=e.$Pf=e.$Of=e.$Nf=e.$Mf=e.$Lf=e.$Kf=e.$Jf=e.$If=e.$Hf=e.$Gf=e.$Ff=e.$Ef=e.$Df=e.$Cf=e.$Bf=e.$Af=e.$zf=e.top=e.$xf=e.$wf=e.$vf=e.$uf=e.$tf=e.$sf=e.$rf=e.$qf=e.$pf=e.$of=e.$nf=e.$mf=void 0;function O(z,M=0){return z[z.length-(1+M)]}e.$mf=O;function j(z){if(z.length===0)throw new Error("Invalid tail call");return[z.slice(0,z.length-1),z[z.length-1]]}e.$nf=j;function A(z,M,J=(_,ae)=>_===ae){if(z===M)return!0;if(!z||!M||z.length!==M.length)return!1;for(let _=0,ae=z.length;_<ae;_++)if(!J(z[_],M[_]))return!1;return!0}e.$of=A;function R(z,M){const J=z.length-1;M<J&&(z[M]=z[J]),z.pop()}e.$pf=R;function k(z,M,J){return m(z.length,_=>J(z[_],M))}e.$qf=k;function m(z,M){let J=0,_=z-1;for(;J<=_;){const ae=(J+_)/2|0,he=M(ae);if(he<0)J=ae+1;else if(he>0)_=ae-1;else return ae}return-(J+1)}e.$rf=m;function P(z,M,J){if(z=z|0,z>=M.length)throw new TypeError("invalid index");const _=M[Math.floor(M.length*Math.random())],ae=[],he=[],fe=[];for(const le of M){const $e=J(le,_);$e<0?ae.push(le):$e>0?he.push(le):fe.push(le)}return z<ae.length?P(z,ae,J):z<ae.length+fe.length?fe[0]:P(z-(ae.length+fe.length),he,J)}e.$sf=P;function p(z,M){const J=[];let _;for(const ae of z.slice(0).sort(M))!_||M(_[0],ae)!==0?(_=[ae],J.push(_)):_.push(ae);return J}e.$tf=p;function*g(z,M){let J,_;for(const ae of z)_!==void 0&&M(_,ae)?J.push(ae):(J&&(yield J),J=[ae]),_=ae;J&&(yield J)}e.$uf=g;function h(z,M){for(let J=0;J<=z.length;J++)M(J===0?void 0:z[J-1],J===z.length?void 0:z[J])}e.$vf=h;function d(z,M,J){const _=[];function ae(le,$e,de){if($e===0&&de.length===0)return;const we=_[_.length-1];we&&we.start+we.deleteCount===le?(we.deleteCount+=$e,we.toInsert.push(...de)):_.push({start:le,deleteCount:$e,toInsert:de})}let he=0,fe=0;for(;;){if(he===z.length){ae(he,0,M.slice(fe));break}if(fe===M.length){ae(he,z.length-he,[]);break}const le=z[he],$e=M[fe],de=J(le,$e);de===0?(he+=1,fe+=1):de<0?(ae(he,1,[]),he+=1):de>0&&(ae(he,0,[$e]),fe+=1)}return _}e.$wf=d;function w(z,M,J){const _=d(z,M,J),ae=[],he=[];for(const fe of _)ae.push(...z.slice(fe.start,fe.start+fe.deleteCount)),he.push(...fe.toInsert);return{removed:ae,added:he}}e.$xf=w;function f(z,M,J){if(J===0)return[];const _=z.slice(0,J).sort(M);return l(z,M,_,J,z.length),_}e.top=f;function o(z,M,J,_,ae){return J===0?Promise.resolve([]):new Promise((he,fe)=>{(async()=>{const le=z.length,$e=z.slice(0,J).sort(M);for(let de=J,we=Math.min(J+_,le);de<le;de=we,we=Math.min(we+_,le)){if(de>J&&await new Promise(ke=>setTimeout(ke)),ae&&ae.isCancellationRequested)throw new L.$3;l(z,M,$e,de,we)}return $e})().then(he,fe)})}e.$zf=o;function l(z,M,J,_,ae){for(const he=J.length;_<ae;_++){const fe=z[_];if(M(fe,J[he-1])<0){J.pop();const le=(0,N.$ef)(J,$e=>M(fe,$e)<0);J.splice(le,0,fe)}}}function $(z){return z.filter(M=>!!M)}e.$Af=$;function b(z){let M=0;for(let J=0;J<z.length;J++)z[J]&&(z[M]=z[J],M+=1);z.length=M}e.$Bf=b;function I(z,M,J){z.splice(J,0,z.splice(M,1)[0])}e.$Cf=I;function t(z){return!Array.isArray(z)||z.length===0}e.$Df=t;function c(z){return Array.isArray(z)&&z.length>0}e.$Ef=c;function s(z,M=J=>J){const J=new Set;return z.filter(_=>{const ae=M(_);return J.has(ae)?!1:(J.add(ae),!0)})}e.$Ff=s;function n(z){const M=new Set;return J=>{const _=z(J);return M.has(_)?!1:(M.add(_),!0)}}e.$Gf=n;function i(z,M){return z.length>0?z[0]:M}e.$Hf=i;function r(z,M){return z.length>0?z[z.length-1]:M}e.$If=r;function a(z,M,J=(_,ae)=>_===ae){let _=0;for(let ae=0,he=Math.min(z.length,M.length);ae<he&&J(z[ae],M[ae]);ae++)_++;return _}e.$Jf=a;function v(z){return[].concat(...z)}e.$Kf=v;function y(z,M){let J=typeof M=="number"?z:0;typeof M=="number"?J=z:(J=0,M=z);const _=[];if(J<=M)for(let ae=J;ae<M;ae++)_.push(ae);else for(let ae=J;ae>M;ae--)_.push(ae);return _}e.$Lf=y;function u(z,M,J){return z.reduce((_,ae)=>(_[M(ae)]=J?J(ae):ae,_),Object.create(null))}e.$Mf=u;function E(z,M){return z.push(M),()=>D(z,M)}e.$Nf=E;function D(z,M){const J=z.indexOf(M);if(J>-1)return z.splice(J,1),M}e.$Of=D;function T(z,M,J){const _=z.slice(0,M),ae=z.slice(M);return _.concat(J,ae)}e.$Pf=T;function F(z,M){let J;if(typeof M=="number"){let _=M;J=()=>{const ae=Math.sin(_++)*179426549;return ae-Math.floor(ae)}}else J=Math.random;for(let _=z.length-1;_>0;_-=1){const ae=Math.floor(J()*(_+1)),he=z[_];z[_]=z[ae],z[ae]=he}}e.$Qf=F;function q(z,M){const J=z.indexOf(M);J>-1&&(z.splice(J,1),z.unshift(M))}e.$Rf=q;function W(z,M){const J=z.indexOf(M);J>-1&&(z.splice(J,1),z.push(M))}e.$Sf=W;function Z(z,M){for(const J of M)z.push(J)}e.$Tf=Z;function Y(z,M){return Array.isArray(z)?z.map(M):M(z)}e.$Uf=Y;function x(z){return Array.isArray(z)?z:[z]}e.$Vf=x;function G(z){return z[Math.floor(Math.random()*z.length)]}e.$Wf=G;function Q(z,M,J){const _=V(z,M),ae=z.length,he=J.length;z.length=ae+he;for(let fe=ae-1;fe>=_;fe--)z[fe+he]=z[fe];for(let fe=0;fe<he;fe++)z[fe+_]=J[fe]}e.$Xf=Q;function H(z,M,J,_){const ae=V(z,M);let he=z.splice(ae,J);return he===void 0&&(he=[]),Q(z,ae,_),he}e.$Yf=H;function V(z,M){return M<0?Math.max(M+z.length,0):Math.min(M,z.length)}var B;(function(z){function M(he){return he<0}z.isLessThan=M;function J(he){return he<=0}z.isLessThanOrEqual=J;function _(he){return he>0}z.isGreaterThan=_;function ae(he){return he===0}z.isNeitherLessOrGreaterThan=ae,z.greaterThan=1,z.lessThan=-1,z.neitherLessOrGreaterThan=0})(B||(e.CompareResult=B={}));function ee(z,M){return(J,_)=>M(z(J),z(_))}e.$Zf=ee;function ne(...z){return(M,J)=>{for(const _ of z){const ae=_(M,J);if(!B.isNeitherLessOrGreaterThan(ae))return ae}return B.neitherLessOrGreaterThan}}e.$1f=ne;const se=(z,M)=>z-M;e.$2f=se;const K=(z,M)=>(0,e.$2f)(z?1:0,M?1:0);e.$3f=K;function U(z){return(M,J)=>-z(M,J)}e.$4f=U;class S{constructor(M){this.g=M,this.c=0,this.d=this.g.length-1}get length(){return this.d-this.c+1}takeWhile(M){let J=this.c;for(;J<this.g.length&&M(this.g[J]);)J++;const _=J===this.c?null:this.g.slice(this.c,J);return this.c=J,_}takeFromEndWhile(M){let J=this.d;for(;J>=0&&M(this.g[J]);)J--;const _=J===this.d?null:this.g.slice(J+1,this.d+1);return this.d=J,_}peek(){if(this.length!==0)return this.g[this.c]}peekLast(){if(this.length!==0)return this.g[this.d]}dequeue(){const M=this.g[this.c];return this.c++,M}removeLast(){const M=this.g[this.d];return this.d--,M}takeCount(M){const J=this.g.slice(this.c,this.c+M);return this.c+=M,J}}e.$5f=S;class C{static{this.empty=new C(M=>{})}constructor(M){this.iterate=M}forEach(M){this.iterate(J=>(M(J),!0))}toArray(){const M=[];return this.iterate(J=>(M.push(J),!0)),M}filter(M){return new C(J=>this.iterate(_=>M(_)?J(_):!0))}map(M){return new C(J=>this.iterate(_=>J(M(_))))}some(M){let J=!1;return this.iterate(_=>(J=M(_),!J)),J}findFirst(M){let J;return this.iterate(_=>M(_)?(J=_,!1):!0),J}findLast(M){let J;return this.iterate(_=>(M(_)&&(J=_),!0)),J}findLastMaxBy(M){let J,_=!0;return this.iterate(ae=>((_||B.isGreaterThan(M(ae,J)))&&(_=!1,J=ae),!0)),J}}e.$6f=C}),define(re[126],oe([0,1,8]),function(te,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ab=e.$zb=e.$yb=e.$xb=e.ok=void 0;function N(k,m){if(!k)throw new Error(m?`Assertion failed (${m})`:"Assertion Failed")}e.ok=N;function O(k,m="Unreachable"){throw new Error(m)}e.$xb=O;function j(k){if(!k)throw new L.$ab("Assertion Failed")}e.$yb=j;function A(k){if(!k()){debugger;k(),(0,L.$Y)(new L.$ab("Assertion Failed"))}}e.$zb=A;function R(k,m){let P=0;for(;P<k.length-1;){const p=k[P],g=k[P+1];if(!m(p,g))return!1;P++}return!0}e.$Ab=R}),define(re[84],oe([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bb=void 0;function L(N){const O=this;let j=!1,A;return function(){return j||(j=!0,A=N.apply(O,arguments)),A}}e.$bb=L}),define(re[59],oe([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var L;(function(N){function O(b){return b&&typeof b=="object"&&typeof b[Symbol.iterator]=="function"}N.is=O;const j=Object.freeze([]);function A(){return j}N.empty=A;function*R(b){yield b}N.single=R;function k(b){return O(b)?b:R(b)}N.wrap=k;function m(b){return b||j}N.from=m;function P(b){return!b||b[Symbol.iterator]().next().done===!0}N.isEmpty=P;function p(b){return b[Symbol.iterator]().next().value}N.first=p;function g(b,I){for(const t of b)if(I(t))return!0;return!1}N.some=g;function h(b,I){for(const t of b)if(I(t))return t}N.find=h;function*d(b,I){for(const t of b)I(t)&&(yield t)}N.filter=d;function*w(b,I){let t=0;for(const c of b)yield I(c,t++)}N.map=w;function*f(...b){for(const I of b)for(const t of I)yield t}N.concat=f;function o(b,I,t){let c=t;for(const s of b)c=I(c,s);return c}N.reduce=o;function*l(b,I,t=b.length){for(I<0&&(I+=b.length),t<0?t+=b.length:t>b.length&&(t=b.length);I<t;I++)yield b[I]}N.slice=l;function $(b,I=Number.POSITIVE_INFINITY){const t=[];if(I===0)return[t,b];const c=b[Symbol.iterator]();for(let s=0;s<I;s++){const n=c.next();if(n.done)return[t,N.empty()];t.push(n.value)}return[t,{[Symbol.iterator](){return c}}]}N.consume=$})(L||(e.Iterable=L={}))}),define(re[34],oe([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sm=e.$Rm=e.$Qm=e.$Pm=e.$Om=e.$Nm=e.$Mm=e.$Lm=e.$Km=e.$Jm=e.$Im=e.$Hm=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var L;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(L||(e.ScanError=L={}));var N;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(N||(e.SyntaxKind=N={}));var O;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(O||(e.ParseErrorCode=O={}));var j;(function(t){t.DEFAULT={allowTrailingComma:!0}})(j||(e.ParseOptions=j={}));function A(t,c=!1){let s=0;const n=t.length;let i="",r=0,a=16,v=0;function y(W){let Z=0,Y=0;for(;Z<W;){const x=t.charCodeAt(s);if(x>=48&&x<=57)Y=Y*16+x-48;else if(x>=65&&x<=70)Y=Y*16+x-65+10;else if(x>=97&&x<=102)Y=Y*16+x-97+10;else break;s++,Z++}return Z<W&&(Y=-1),Y}function u(W){s=W,i="",r=0,a=16,v=0}function E(){const W=s;if(t.charCodeAt(s)===48)s++;else for(s++;s<t.length&&m(t.charCodeAt(s));)s++;if(s<t.length&&t.charCodeAt(s)===46)if(s++,s<t.length&&m(t.charCodeAt(s)))for(s++;s<t.length&&m(t.charCodeAt(s));)s++;else return v=3,t.substring(W,s);let Z=s;if(s<t.length&&(t.charCodeAt(s)===69||t.charCodeAt(s)===101))if(s++,(s<t.length&&t.charCodeAt(s)===43||t.charCodeAt(s)===45)&&s++,s<t.length&&m(t.charCodeAt(s))){for(s++;s<t.length&&m(t.charCodeAt(s));)s++;Z=s}else v=3;return t.substring(W,Z)}function D(){let W="",Z=s;for(;;){if(s>=n){W+=t.substring(Z,s),v=2;break}const Y=t.charCodeAt(s);if(Y===34){W+=t.substring(Z,s),s++;break}if(Y===92){if(W+=t.substring(Z,s),s++,s>=n){v=2;break}switch(t.charCodeAt(s++)){case 34:W+='"';break;case 92:W+="\\";break;case 47:W+="/";break;case 98:W+="\b";break;case 102:W+="\f";break;case 110:W+=`
`;break;case 114:W+="\r";break;case 116:W+="	";break;case 117:{const G=y(4);G>=0?W+=String.fromCharCode(G):v=4;break}default:v=5}Z=s;continue}if(Y>=0&&Y<=31)if(k(Y)){W+=t.substring(Z,s),v=2;break}else v=6;s++}return W}function T(){if(i="",v=0,r=s,s>=n)return r=n,a=17;let W=t.charCodeAt(s);if(R(W)){do s++,i+=String.fromCharCode(W),W=t.charCodeAt(s);while(R(W));return a=15}if(k(W))return s++,i+=String.fromCharCode(W),W===13&&t.charCodeAt(s)===10&&(s++,i+=`
`),a=14;switch(W){case 123:return s++,a=1;case 125:return s++,a=2;case 91:return s++,a=3;case 93:return s++,a=4;case 58:return s++,a=6;case 44:return s++,a=5;case 34:return s++,i=D(),a=10;case 47:{const Z=s-1;if(t.charCodeAt(s+1)===47){for(s+=2;s<n&&!k(t.charCodeAt(s));)s++;return i=t.substring(Z,s),a=12}if(t.charCodeAt(s+1)===42){s+=2;const Y=n-1;let x=!1;for(;s<Y;){if(t.charCodeAt(s)===42&&t.charCodeAt(s+1)===47){s+=2,x=!0;break}s++}return x||(s++,v=1),i=t.substring(Z,s),a=13}return i+=String.fromCharCode(W),s++,a=16}case 45:if(i+=String.fromCharCode(W),s++,s===n||!m(t.charCodeAt(s)))return a=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return i+=E(),a=11;default:for(;s<n&&F(W);)s++,W=t.charCodeAt(s);if(r!==s){switch(i=t.substring(r,s),i){case"true":return a=8;case"false":return a=9;case"null":return a=7}return a=16}return i+=String.fromCharCode(W),s++,a=16}}function F(W){if(R(W)||k(W))return!1;switch(W){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function q(){let W;do W=T();while(W>=12&&W<=15);return W}return{setPosition:u,getPosition:()=>s,scan:c?q:T,getToken:()=>a,getTokenValue:()=>i,getTokenOffset:()=>r,getTokenLength:()=>s-r,getTokenError:()=>v}}e.$Hm=A;function R(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function k(t){return t===10||t===13||t===8232||t===8233}function m(t){return t>=48&&t<=57}var P;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(P||(P={}));function p(t,c){const s=[],n=new Object;let i;const r={value:{},offset:0,length:0,type:"object",parent:void 0};let a=!1;function v(y,u,E,D){r.value=y,r.offset=u,r.length=E,r.type=D,r.colonOffset=void 0,i=r}try{$(t,{onObjectBegin:(y,u)=>{if(c<=y)throw n;i=void 0,a=c>y,s.push("")},onObjectProperty:(y,u,E)=>{if(c<u||(v(y,u,E,"property"),s[s.length-1]=y,c<=u+E))throw n},onObjectEnd:(y,u)=>{if(c<=y)throw n;i=void 0,s.pop()},onArrayBegin:(y,u)=>{if(c<=y)throw n;i=void 0,s.push(0)},onArrayEnd:(y,u)=>{if(c<=y)throw n;i=void 0,s.pop()},onLiteralValue:(y,u,E)=>{if(c<u||(v(y,u,E,I(y)),c<=u+E))throw n},onSeparator:(y,u,E)=>{if(c<=u)throw n;if(y===":"&&i&&i.type==="property")i.colonOffset=u,a=!1,i=void 0;else if(y===","){const D=s[s.length-1];typeof D=="number"?s[s.length-1]=D+1:(a=!0,s[s.length-1]=""),i=void 0}}})}catch(y){if(y!==n)throw y}return{path:s,previousNode:i,isAtPropertyKey:a,matches:y=>{let u=0;for(let E=0;u<y.length&&E<s.length;E++)if(y[u]===s[E]||y[u]==="*")u++;else if(y[u]!=="**")return!1;return u===y.length}}}e.$Im=p;function g(t,c=[],s=j.DEFAULT){let n=null,i=[];const r=[];function a(y){Array.isArray(i)?i.push(y):n!==null&&(i[n]=y)}return $(t,{onObjectBegin:()=>{const y={};a(y),r.push(i),i=y,n=null},onObjectProperty:y=>{n=y},onObjectEnd:()=>{i=r.pop()},onArrayBegin:()=>{const y=[];a(y),r.push(i),i=y,n=null},onArrayEnd:()=>{i=r.pop()},onLiteralValue:a,onError:(y,u,E)=>{c.push({error:y,offset:u,length:E})}},s),i[0]}e.$Jm=g;function h(t,c=[],s=j.DEFAULT){let n={type:"array",offset:-1,length:-1,children:[],parent:void 0};function i(y){n.type==="property"&&(n.length=y-n.offset,n=n.parent)}function r(y){return n.children.push(y),y}$(t,{onObjectBegin:y=>{n=r({type:"object",offset:y,length:-1,parent:n,children:[]})},onObjectProperty:(y,u,E)=>{n=r({type:"property",offset:u,length:-1,parent:n,children:[]}),n.children.push({type:"string",value:y,offset:u,length:E,parent:n})},onObjectEnd:(y,u)=>{n.length=y+u-n.offset,n=n.parent,i(y+u)},onArrayBegin:(y,u)=>{n=r({type:"array",offset:y,length:-1,parent:n,children:[]})},onArrayEnd:(y,u)=>{n.length=y+u-n.offset,n=n.parent,i(y+u)},onLiteralValue:(y,u,E)=>{r({type:I(y),offset:u,length:E,parent:n,value:y}),i(u+E)},onSeparator:(y,u,E)=>{n.type==="property"&&(y===":"?n.colonOffset=u:y===","&&i(u))},onError:(y,u,E)=>{c.push({error:y,offset:u,length:E})}},s);const v=n.children[0];return v&&delete v.parent,v}e.$Km=h;function d(t,c){if(!t)return;let s=t;for(const n of c)if(typeof n=="string"){if(s.type!=="object"||!Array.isArray(s.children))return;let i=!1;for(const r of s.children)if(Array.isArray(r.children)&&r.children[0].value===n){s=r.children[1],i=!0;break}if(!i)return}else{const i=n;if(s.type!=="array"||i<0||!Array.isArray(s.children)||i>=s.children.length)return;s=s.children[i]}return s}e.$Lm=d;function w(t){if(!t.parent||!t.parent.children)return[];const c=w(t.parent);if(t.parent.type==="property"){const s=t.parent.children[0].value;c.push(s)}else if(t.parent.type==="array"){const s=t.parent.children.indexOf(t);s!==-1&&c.push(s)}return c}e.$Mm=w;function f(t){switch(t.type){case"array":return t.children.map(f);case"object":{const c=Object.create(null);for(const s of t.children){const n=s.children[1];n&&(c[s.children[0].value]=f(n))}return c}case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.$Nm=f;function o(t,c,s=!1){return c>=t.offset&&c<t.offset+t.length||s&&c===t.offset+t.length}e.$Om=o;function l(t,c,s=!1){if(o(t,c,s)){const n=t.children;if(Array.isArray(n))for(let i=0;i<n.length&&n[i].offset<=c;i++){const r=l(n[i],c,s);if(r)return r}return t}}e.$Pm=l;function $(t,c,s=j.DEFAULT){const n=A(t,!1);function i(ne){return ne?()=>ne(n.getTokenOffset(),n.getTokenLength()):()=>!0}function r(ne){return ne?se=>ne(se,n.getTokenOffset(),n.getTokenLength()):()=>!0}const a=i(c.onObjectBegin),v=r(c.onObjectProperty),y=i(c.onObjectEnd),u=i(c.onArrayBegin),E=i(c.onArrayEnd),D=r(c.onLiteralValue),T=r(c.onSeparator),F=i(c.onComment),q=r(c.onError),W=s&&s.disallowComments,Z=s&&s.allowTrailingComma;function Y(){for(;;){const ne=n.scan();switch(n.getTokenError()){case 4:x(14);break;case 5:x(15);break;case 3:x(13);break;case 1:W||x(11);break;case 2:x(12);break;case 6:x(16);break}switch(ne){case 12:case 13:W?x(10):F();break;case 16:x(1);break;case 15:case 14:break;default:return ne}}}function x(ne,se=[],K=[]){if(q(ne),se.length+K.length>0){let U=n.getToken();for(;U!==17;){if(se.indexOf(U)!==-1){Y();break}else if(K.indexOf(U)!==-1)break;U=Y()}}}function G(ne){const se=n.getTokenValue();return ne?D(se):v(se),Y(),!0}function Q(){switch(n.getToken()){case 11:{let ne=0;try{ne=JSON.parse(n.getTokenValue()),typeof ne!="number"&&(x(2),ne=0)}catch{x(2)}D(ne);break}case 7:D(null);break;case 8:D(!0);break;case 9:D(!1);break;default:return!1}return Y(),!0}function H(){return n.getToken()!==10?(x(3,[],[2,5]),!1):(G(!1),n.getToken()===6?(T(":"),Y(),ee()||x(4,[],[2,5])):x(5,[],[2,5]),!0)}function V(){a(),Y();let ne=!1;for(;n.getToken()!==2&&n.getToken()!==17;){if(n.getToken()===5){if(ne||x(4,[],[]),T(","),Y(),n.getToken()===2&&Z)break}else ne&&x(6,[],[]);H()||x(4,[],[2,5]),ne=!0}return y(),n.getToken()!==2?x(7,[2],[]):Y(),!0}function B(){u(),Y();let ne=!1;for(;n.getToken()!==4&&n.getToken()!==17;){if(n.getToken()===5){if(ne||x(4,[],[]),T(","),Y(),n.getToken()===4&&Z)break}else ne&&x(6,[],[]);ee()||x(4,[],[4,5]),ne=!0}return E(),n.getToken()!==4?x(8,[4],[]):Y(),!0}function ee(){switch(n.getToken()){case 3:return B();case 1:return V();case 10:return G(!0);default:return Q()}}return Y(),n.getToken()===17?s.allowEmptyContent?!0:(x(4,[],[]),!1):ee()?(n.getToken()!==17&&x(9,[],[]),!0):(x(4,[],[]),!1)}e.$Qm=$;function b(t,c){const s=A(t),n=[];let i,r=0,a;do switch(a=s.getPosition(),i=s.scan(),i){case 12:case 13:case 17:r!==a&&n.push(t.substring(r,a)),c!==void 0&&n.push(s.getTokenValue().replace(/[^\r\n]/g,c)),r=s.getPosition();break}while(i!==17);return n.join("")}e.$Rm=b;function I(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.$Sm=I}),define(re[41],oe([0,1,34]),function(te,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pS=e.$oS=e.$nS=e.$mS=void 0;function N(m,P,p){let g,h,d,w,f;if(P){for(w=P.offset,f=w+P.length,d=w;d>0&&!k(m,d-1);)d--;let a=f;for(;a<m.length&&!k(m,a);)a++;h=m.substring(d,a),g=A(h,p)}else h=m,g=0,d=0,w=0,f=m.length;const o=R(p,m);let l=!1,$=0,b;p.insertSpaces?b=j(" ",p.tabSize||4):b="	";const I=(0,L.$Hm)(h,!1);let t=!1;function c(){return o+j(b,g+$)}function s(){let a=I.scan();for(l=!1;a===15||a===14;)l=l||a===14,a=I.scan();return t=a===16||I.getTokenError()!==0,a}const n=[];function i(a,v,y){!t&&v<f&&y>w&&m.substring(v,y)!==a&&n.push({offset:v,length:y-v,content:a})}let r=s();if(r!==17){const a=I.getTokenOffset()+d,v=j(b,g);i(v,d,a)}for(;r!==17;){let a=I.getTokenOffset()+I.getTokenLength()+d,v=s(),y="";for(;!l&&(v===12||v===13);){const E=I.getTokenOffset()+d;i(" ",a,E),a=I.getTokenOffset()+I.getTokenLength()+d,y=v===12?c():"",v=s()}if(v===2)r!==1&&($--,y=c());else if(v===4)r!==3&&($--,y=c());else{switch(r){case 3:case 1:$++,y=c();break;case 5:case 12:y=c();break;case 13:l?y=c():y=" ";break;case 6:y=" ";break;case 10:if(v===6){y="";break}case 7:case 8:case 9:case 11:case 2:case 4:v===12||v===13?y=" ":v!==5&&v!==17&&(t=!0);break;case 16:t=!0;break}l&&(v===12||v===13)&&(y=c())}const u=I.getTokenOffset()+d;i(y,a,u),r=v}return n}e.$mS=N;function O(m,P){const p=JSON.stringify(m,void 0,P.insertSpaces?P.tabSize||4:"	");return P.eol!==void 0?p.replace(/\r\n|\r|\n/g,P.eol):p}e.$nS=O;function j(m,P){let p="";for(let g=0;g<P;g++)p+=m;return p}function A(m,P){let p=0,g=0;const h=P.tabSize||4;for(;p<m.length;){const d=m.charAt(p);if(d===" ")g++;else if(d==="	")g+=h;else break;p++}return Math.floor(g/h)}function R(m,P){for(let p=0;p<P.length;p++){const g=P.charAt(p);if(g==="\r")return p+1<P.length&&P.charAt(p+1)===`
`?`\r
`:"\r";if(g===`
`)return`
`}return m&&m.eol||`
`}e.$oS=R;function k(m,P){return`\r
`.indexOf(m.charAt(P))!==-1}e.$pS=k}),define(re[85],oe([0,1,34,41]),function(te,e,L,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uS=e.$tS=e.$sS=e.$rS=e.$qS=void 0;function O(m,P,p){return j(m,P,void 0,p)}e.$qS=O;function j(m,P,p,g,h){const d=P.slice(),w=[],f=(0,L.$Km)(m,w);let o,l;for(;d.length>0&&(l=d.pop(),o=(0,L.$Lm)(f,d),o===void 0&&p!==void 0);)typeof l=="string"?p={[l]:p}:p=[p];if(o)if(o.type==="object"&&typeof l=="string"&&Array.isArray(o.children)){const $=(0,L.$Lm)(o,[l]);if($!==void 0)if(p===void 0){if(!$.parent)throw new Error("Malformed AST");const b=o.children.indexOf($.parent);let I,t=$.parent.offset+$.parent.length;if(b>0){const c=o.children[b-1];I=c.offset+c.length}else I=o.offset+1,o.children.length>1&&(t=o.children[1].offset);return A(m,{offset:I,length:t-I,content:""},g)}else return A(m,{offset:$.offset,length:$.length,content:JSON.stringify(p)},g);else{if(p===void 0)return[];const b=`${JSON.stringify(l)}: ${JSON.stringify(p)}`,I=h?h(o.children.map(c=>c.children[0].value)):o.children.length;let t;if(I>0){const c=o.children[I-1];t={offset:c.offset+c.length,length:0,content:","+b}}else o.children.length===0?t={offset:o.offset+1,length:0,content:b}:t={offset:o.offset+1,length:0,content:b+","};return A(m,t,g)}}else if(o.type==="array"&&typeof l=="number"&&Array.isArray(o.children))if(p!==void 0){const $=`${JSON.stringify(p)}`;let b;if(o.children.length===0||l===0)b={offset:o.offset+1,length:0,content:o.children.length===0?$:$+","};else{const I=l===-1||l>o.children.length?o.children.length:l,t=o.children[I-1];b={offset:t.offset+t.length,length:0,content:","+$}}return A(m,b,g)}else{const $=l,b=o.children[$];let I;if(o.children.length===1)I={offset:o.offset+1,length:o.length-2,content:""};else if(o.children.length-1===$){const t=o.children[$-1],c=t.offset+t.length,s=o.offset+o.length;I={offset:c,length:s-2-c,content:""}}else I={offset:b.offset,length:o.children[$+1].offset-b.offset,content:""};return A(m,I,g)}else throw new Error(`Can not add ${typeof l!="number"?"index":"property"} to parent of type ${o.type}`);else{if(p===void 0)throw new Error("Can not delete in empty document");return A(m,{offset:f?f.offset:0,length:f?f.length:0,content:JSON.stringify(p)},g)}}e.$rS=j;function A(m,P,p){let g=R(m,P),h=P.offset,d=P.offset+P.content.length;if(P.length===0||P.content.length===0){for(;h>0&&!(0,N.$pS)(g,h-1);)h--;for(;d<g.length&&!(0,N.$pS)(g,d);)d++}const w=(0,N.$mS)(g,{offset:h,length:d-h},p);for(let o=w.length-1;o>=0;o--){const l=w[o];g=R(g,l),h=Math.min(h,l.offset),d=Math.max(d,l.offset+l.length),d+=l.content.length-l.length}const f=m.length-(g.length-d)-h;return[{offset:h,length:f,content:g.substring(h,d)}]}e.$sS=A;function R(m,P){return m.substring(0,P.offset)+P.content+m.substring(P.offset+P.length)}e.$tS=R;function k(m,P){const p=P.slice(0).sort((h,d)=>{const w=h.offset-d.offset;return w===0?h.length-d.length:w});let g=m.length;for(let h=p.length-1;h>=0;h--){const d=p[h];if(d.offset+d.length<=g)m=R(m,d);else throw new Error("Overlapping edit");g=d.offset}return m}e.$uS=k}),define(re[86],oe([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$T=void 0;class L{constructor(O){this.d=O,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(O){this.c=O}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}e.$T=L}),define(re[2],oe([0,1,84,59]),function(te,e,L,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ub=e.$tb=e.$sb=e.$rb=e.$qb=e.$pb=e.$ob=e.$nb=e.$mb=e.$lb=e.$kb=e.$jb=e.$ib=e.$hb=e.$gb=e.$fb=e.$eb=e.$db=e.$cb=void 0;const O=!1;let j=null;function A(r){j=r}if(e.$cb=A,O){const r="__is_disposable_tracked__";A(new class{trackDisposable(a){const v=new Error("Potentially leaked disposable").stack;setTimeout(()=>{a[r]||console.log(v)},3e3)}setParent(a,v){if(a&&a!==l.None)try{a[r]=!0}catch{}}markAsDisposed(a){if(a&&a!==l.None)try{a[r]=!0}catch{}}markAsSingleton(a){}})}function R(r){return j?.trackDisposable(r),r}e.$db=R;function k(r){j?.markAsDisposed(r)}e.$eb=k;function m(r,a){j?.setParent(r,a)}function P(r,a){if(j)for(const v of r)j.setParent(v,a)}function p(r){return j?.markAsSingleton(r),r}e.$fb=p;function g(r){return typeof r.dispose=="function"&&r.dispose.length===0}e.$gb=g;function h(r){if(N.Iterable.is(r)){const a=[];for(const v of r)if(v)try{v.dispose()}catch(y){a.push(y)}if(a.length===1)throw a[0];if(a.length>1)throw new AggregateError(a,"Encountered errors while disposing of store");return Array.isArray(r)?[]:r}else if(r)return r.dispose(),r}e.$hb=h;function d(r){for(const a of r)g(a)&&a.dispose();return[]}e.$ib=d;function w(...r){const a=f(()=>h(r));return P(r,a),a}e.$jb=w;function f(r){const a=R({dispose:(0,L.$bb)(()=>{k(a),r()})});return a}e.$kb=f;class o{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this.f=new Set,this.g=!1,R(this)}dispose(){this.g||(k(this),this.g=!0,this.clear())}get isDisposed(){return this.g}clear(){if(this.f.size!==0)try{h(this.f)}finally{this.f.clear()}}add(a){if(!a)return a;if(a===this)throw new Error("Cannot register a disposable on itself!");return m(a,this),this.g?o.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.f.add(a),a}}e.$lb=o;class l{static{this.None=Object.freeze({dispose(){}})}constructor(){this.q=new o,R(this),m(this.q,this)}dispose(){k(this),this.q.dispose()}B(a){if(a===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(a)}}e.$mb=l;class ${constructor(){this.b=!1,R(this)}get value(){return this.b?void 0:this.a}set value(a){this.b||a===this.a||(this.a?.dispose(),a&&m(a,this),this.a=a)}clear(){this.value=void 0}dispose(){this.b=!0,k(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const a=this.a;return this.a=void 0,a&&m(a,null),a}}e.$nb=$;class b{constructor(a){this.b=a,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}e.$ob=b;class I{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,R(this)}set(a){let v=a;return this.unset=()=>v=void 0,this.isset=()=>v!==void 0,this.dispose=()=>{v&&(v(),v=void 0,k(this))},this}}e.$pb=I;class t{constructor(){this.a=new Map}acquire(a,...v){let y=this.a.get(a);y||(y={counter:0,object:this.b(a,...v)},this.a.set(a,y));const{object:u}=y,E=(0,L.$bb)(()=>{--y.counter===0&&(this.c(a,y.object),this.a.delete(a))});return y.counter++,{object:u,dispose:E}}}e.$qb=t;class c{constructor(a){this.a=a}async acquire(a,...v){const y=this.a.acquire(a,...v);try{return{object:await y.object,dispose:()=>y.dispose()}}catch(u){throw y.dispose(),u}}}e.$rb=c;class s{constructor(a){this.object=a}dispose(){}}e.$sb=s;function n(r){const a=new o;try{r(a)}finally{a.dispose()}}e.$tb=n;class i{constructor(){this.a=new Map,this.b=!1,R(this)}dispose(){k(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this.a.size)try{h(this.a.values())}finally{this.a.clear()}}has(a){return this.a.has(a)}get size(){return this.a.size}get(a){return this.a.get(a)}set(a,v,y=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),y||this.a.get(a)?.dispose(),this.a.set(a,v)}deleteAndDispose(a){this.a.get(a)?.dispose(),this.a.delete(a)}[Symbol.iterator](){return this.a[Symbol.iterator]()}}e.$ub=i}),define(re[87],oe([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vb=void 0;class L{static{this.Undefined=new L(void 0)}constructor(j){this.element=j,this.next=L.Undefined,this.prev=L.Undefined}}class N{constructor(){this.a=L.Undefined,this.b=L.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===L.Undefined}clear(){let j=this.a;for(;j!==L.Undefined;){const A=j.next;j.prev=L.Undefined,j.next=L.Undefined,j=A}this.a=L.Undefined,this.b=L.Undefined,this.c=0}unshift(j){return this.d(j,!1)}push(j){return this.d(j,!0)}d(j,A){const R=new L(j);if(this.a===L.Undefined)this.a=R,this.b=R;else if(A){const m=this.b;this.b=R,R.prev=m,m.next=R}else{const m=this.a;this.a=R,R.next=m,m.prev=R}this.c+=1;let k=!1;return()=>{k||(k=!0,this.e(R))}}shift(){if(this.a!==L.Undefined){const j=this.a.element;return this.e(this.a),j}}pop(){if(this.b!==L.Undefined){const j=this.b.element;return this.e(this.b),j}}e(j){if(j.prev!==L.Undefined&&j.next!==L.Undefined){const A=j.prev;A.next=j.next,j.next.prev=A}else j.prev===L.Undefined&&j.next===L.Undefined?(this.a=L.Undefined,this.b=L.Undefined):j.next===L.Undefined?(this.b=this.b.prev,this.b.next=L.Undefined):j.prev===L.Undefined&&(this.a=this.a.next,this.a.prev=L.Undefined);this.c-=1}*[Symbol.iterator](){let j=this.a;for(;j!==L.Undefined;)yield j.element,j=j.next}}e.$vb=N}),define(re[35],oe([0,1]),function(te,e){"use strict";var L,N,O;Object.defineProperty(e,"__esModule",{value:!0}),e.$Ci=e.$Bi=e.$Ai=e.$zi=e.Touch=e.$yi=e.$xi=e.$wi=e.$vi=e.$ui=void 0;function j(f,o,l){let $=f.get(o);return $===void 0&&($=l,f.set(o,$)),$}e.$ui=j;function A(f){const o=[];return f.forEach((l,$)=>{o.push(`${$} => ${l}`)}),`Map(${f.size}) {${o.join(", ")}}`}e.$vi=A;function R(f){const o=[];return f.forEach(l=>{o.push(l)}),`Set(${f.size}) {${o.join(", ")}}`}e.$wi=R;class k{constructor(o,l){this.uri=o,this.value=l}}class m{static{this.a=o=>o.toString()}constructor(o,l){this[L]="ResourceMap",o instanceof m?(this.b=new Map(o.b),this.c=l??m.a):(this.b=new Map,this.c=o??m.a)}set(o,l){return this.b.set(this.c(o),new k(o,l)),this}get(o){return this.b.get(this.c(o))?.value}has(o){return this.b.has(this.c(o))}get size(){return this.b.size}clear(){this.b.clear()}delete(o){return this.b.delete(this.c(o))}forEach(o,l){typeof l<"u"&&(o=o.bind(l));for(const[$,b]of this.b)o(b.value,b.uri,this)}*values(){for(const o of this.b.values())yield o.value}*keys(){for(const o of this.b.values())yield o.uri}*entries(){for(const o of this.b.values())yield[o.uri,o.value]}*[(L=Symbol.toStringTag,Symbol.iterator)](){for(const[,o]of this.b)yield[o.uri,o.value]}}e.$xi=m;class P{constructor(o,l){this[N]="ResourceSet",!o||typeof o=="function"?this.a=new m(o):(this.a=new m(l),o.forEach(this.add,this))}get size(){return this.a.size}add(o){return this.a.set(o,o),this}clear(){this.a.clear()}delete(o){return this.a.delete(o)}forEach(o,l){this.a.forEach(($,b)=>o.call(l,b,b,this))}has(o){return this.a.has(o)}entries(){return this.a.entries()}keys(){return this.a.keys()}values(){return this.a.keys()}[(N=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.$yi=P;var p;(function(f){f[f.None=0]="None",f[f.AsOld=1]="AsOld",f[f.AsNew=2]="AsNew"})(p||(e.Touch=p={}));class g{constructor(){this[O]="LinkedMap",this.a=new Map,this.b=void 0,this.c=void 0,this.d=0,this.e=0}clear(){this.a.clear(),this.b=void 0,this.c=void 0,this.d=0,this.e++}isEmpty(){return!this.b&&!this.c}get size(){return this.d}get first(){return this.b?.value}get last(){return this.c?.value}has(o){return this.a.has(o)}get(o,l=0){const $=this.a.get(o);if($)return l!==0&&this.j($,l),$.value}set(o,l,$=0){let b=this.a.get(o);if(b)b.value=l,$!==0&&this.j(b,$);else{switch(b={key:o,value:l,next:void 0,previous:void 0},$){case 0:this.h(b);break;case 1:this.g(b);break;case 2:this.h(b);break;default:this.h(b);break}this.a.set(o,b),this.d++}return this}delete(o){return!!this.remove(o)}remove(o){const l=this.a.get(o);if(l)return this.a.delete(o),this.i(l),this.d--,l.value}shift(){if(!this.b&&!this.c)return;if(!this.b||!this.c)throw new Error("Invalid list");const o=this.b;return this.a.delete(o.key),this.i(o),this.d--,o.value}forEach(o,l){const $=this.e;let b=this.b;for(;b;){if(l?o.bind(l)(b.value,b.key,this):o(b.value,b.key,this),this.e!==$)throw new Error("LinkedMap got modified during iteration.");b=b.next}}keys(){const o=this,l=this.e;let $=this.b;const b={[Symbol.iterator](){return b},next(){if(o.e!==l)throw new Error("LinkedMap got modified during iteration.");if($){const I={value:$.key,done:!1};return $=$.next,I}else return{value:void 0,done:!0}}};return b}values(){const o=this,l=this.e;let $=this.b;const b={[Symbol.iterator](){return b},next(){if(o.e!==l)throw new Error("LinkedMap got modified during iteration.");if($){const I={value:$.value,done:!1};return $=$.next,I}else return{value:void 0,done:!0}}};return b}entries(){const o=this,l=this.e;let $=this.b;const b={[Symbol.iterator](){return b},next(){if(o.e!==l)throw new Error("LinkedMap got modified during iteration.");if($){const I={value:[$.key,$.value],done:!1};return $=$.next,I}else return{value:void 0,done:!0}}};return b}[(O=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}f(o){if(o>=this.size)return;if(o===0){this.clear();return}let l=this.b,$=this.size;for(;l&&$>o;)this.a.delete(l.key),l=l.next,$--;this.b=l,this.d=$,l&&(l.previous=void 0),this.e++}g(o){if(!this.b&&!this.c)this.c=o;else if(this.b)o.next=this.b,this.b.previous=o;else throw new Error("Invalid list");this.b=o,this.e++}h(o){if(!this.b&&!this.c)this.b=o;else if(this.c)o.previous=this.c,this.c.next=o;else throw new Error("Invalid list");this.c=o,this.e++}i(o){if(o===this.b&&o===this.c)this.b=void 0,this.c=void 0;else if(o===this.b){if(!o.next)throw new Error("Invalid list");o.next.previous=void 0,this.b=o.next}else if(o===this.c){if(!o.previous)throw new Error("Invalid list");o.previous.next=void 0,this.c=o.previous}else{const l=o.next,$=o.previous;if(!l||!$)throw new Error("Invalid list");l.previous=$,$.next=l}o.next=void 0,o.previous=void 0,this.e++}j(o,l){if(!this.b||!this.c)throw new Error("Invalid list");if(!(l!==1&&l!==2)){if(l===1){if(o===this.b)return;const $=o.next,b=o.previous;o===this.c?(b.next=void 0,this.c=b):($.previous=b,b.next=$),o.previous=void 0,o.next=this.b,this.b.previous=o,this.b=o,this.e++}else if(l===2){if(o===this.c)return;const $=o.next,b=o.previous;o===this.b?($.previous=void 0,this.b=$):($.previous=b,b.next=$),o.next=void 0,o.previous=this.c,this.c.next=o,this.c=o,this.e++}}}toJSON(){const o=[];return this.forEach((l,$)=>{o.push([$,l])}),o}fromJSON(o){this.clear();for(const[l,$]of o)this.set(l,$)}}e.$zi=g;class h extends g{constructor(o,l=1){super(),this.k=o,this.l=Math.min(Math.max(0,l),1)}get limit(){return this.k}set limit(o){this.k=o,this.m()}get ratio(){return this.l}set ratio(o){this.l=Math.min(Math.max(0,o),1),this.m()}get(o,l=2){return super.get(o,l)}peek(o){return super.get(o,0)}set(o,l){return super.set(o,l,2),this.m(),this}m(){this.size>this.k&&this.f(Math.round(this.k*this.l))}}e.$Ai=h;class d{constructor(){this.a=new Map}add(o){return this.a.set(o,(this.a.get(o)||0)+1),this}delete(o){let l=this.a.get(o)||0;return l===0?!1:(l--,l===0?this.a.delete(o):this.a.set(o,l),!0)}has(o){return this.a.has(o)}}e.$Bi=d;class w{constructor(o){if(this.a=new Map,this.b=new Map,o)for(const[l,$]of o)this.set(l,$)}clear(){this.a.clear(),this.b.clear()}set(o,l){this.a.set(o,l),this.b.set(l,o)}get(o){return this.a.get(o)}getKey(o){return this.b.get(o)}delete(o){const l=this.a.get(o);return l===void 0?!1:(this.a.delete(o),this.b.delete(l),!0)}forEach(o,l){this.a.forEach(($,b)=>{o.call(l,$,b,this)})}keys(){return this.a.keys()}values(){return this.a.values()}}e.$Ci=w}),define(re[88],oe([0,1,35]),function(te,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hl=e.$gl=e.$fl=void 0;const N=new L.$Ai(1e4);function O(m){return k(m,"NFC",N)}e.$fl=O;const j=new L.$Ai(1e4);function A(m){return k(m,"NFD",j)}e.$gl=A;const R=/[^\u0000-\u0080]/;function k(m,P,p){if(!m)return m;const g=p.get(m);if(g)return g;let h;return R.test(m)?h=m.normalize(P):h=m,p.set(m,h),h}e.$hl=function(){const m=/[\u0300-\u036f]/g;return function(P){return A(P).replace(m,"")}}()}),function(){function te(O){const j=[];typeof O=="number"&&j.push("code/timeOrigin",O);function A(k){j.push(k,Date.now())}function R(){const k=[];for(let m=0;m<j.length;m+=2)k.push({name:j[m],startTime:j[m+1]});return k}return{mark:A,getMarks:R}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?te():{mark(O){performance.mark(O)},getMarks(){let O=performance.timeOrigin;typeof O!="number"&&(O=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const j=[{name:"code/timeOrigin",startTime:Math.round(O)}];for(const A of performance.getEntriesByType("mark"))j.push({name:A.name,startTime:Math.round(O+A.startTime)});return j}};if(typeof process=="object"){const O=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return te(O)}else return console.trace("perf-util loaded in UNKNOWN environment"),te()}function L(O){return O.MonacoPerformanceMarks||(O.MonacoPerformanceMarks=e()),O.MonacoPerformanceMarks}var N;typeof global=="object"?N=global:typeof self=="object"?N=self:N={},typeof define=="function"?define("vs/base/common/performance",[],function(){return L(N)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=L(N):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),N.perf=L(N))}(),function(te,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var L=e();for(var N in L)(typeof exports=="object"?exports:te)[N]=L[N]}}(typeof self<"u"?self:this,function(){return function(te){var e={};function L(N){if(e[N])return e[N].exports;var O=e[N]={i:N,l:!1,exports:{}};return te[N].call(O.exports,O,O.exports,L),O.l=!0,O.exports}return L.m=te,L.c=e,L.d=function(N,O,j){L.o(N,O)||Object.defineProperty(N,O,{enumerable:!0,get:j})},L.r=function(N){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(N,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(N,"__esModule",{value:!0})},L.t=function(N,O){if(1&O&&(N=L(N)),8&O||4&O&&typeof N=="object"&&N&&N.__esModule)return N;var j=Object.create(null);if(L.r(j),Object.defineProperty(j,"default",{enumerable:!0,value:N}),2&O&&typeof N!="string")for(var A in N)L.d(j,A,function(R){return N[R]}.bind(null,A));return j},L.n=function(N){var O=N&&N.__esModule?function(){return N.default}:function(){return N};return L.d(O,"a",O),O},L.o=function(N,O){return Object.prototype.hasOwnProperty.call(N,O)},L.p="",L(L.s=0)}([function(te,e,L){(function(N){var O;e=te.exports=K,O=typeof N=="object"&&N.env&&N.env.NODE_DEBUG&&/\bsemver\b/i.test(N.env.NODE_DEBUG)?function(){var ce=Array.prototype.slice.call(arguments,0);ce.unshift("SEMVER"),console.log.apply(console,ce)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var j=256,A=Number.MAX_SAFE_INTEGER||9007199254740991,R=e.re=[],k=e.src=[],m=0,P=m++;k[P]="0|[1-9]\\d*";var p=m++;k[p]="[0-9]+";var g=m++;k[g]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var h=m++;k[h]="("+k[P]+")\\.("+k[P]+")\\.("+k[P]+")";var d=m++;k[d]="("+k[p]+")\\.("+k[p]+")\\.("+k[p]+")";var w=m++;k[w]="(?:"+k[P]+"|"+k[g]+")";var f=m++;k[f]="(?:"+k[p]+"|"+k[g]+")";var o=m++;k[o]="(?:-("+k[w]+"(?:\\."+k[w]+")*))";var l=m++;k[l]="(?:-?("+k[f]+"(?:\\."+k[f]+")*))";var $=m++;k[$]="[0-9A-Za-z-]+";var b=m++;k[b]="(?:\\+("+k[$]+"(?:\\."+k[$]+")*))";var I=m++,t="v?"+k[h]+k[o]+"?"+k[b]+"?";k[I]="^"+t+"$";var c="[v=\\s]*"+k[d]+k[l]+"?"+k[b]+"?",s=m++;k[s]="^"+c+"$";var n=m++;k[n]="((?:<|>)?=?)";var i=m++;k[i]=k[p]+"|x|X|\\*";var r=m++;k[r]=k[P]+"|x|X|\\*";var a=m++;k[a]="[v=\\s]*("+k[r]+")(?:\\.("+k[r]+")(?:\\.("+k[r]+")(?:"+k[o]+")?"+k[b]+"?)?)?";var v=m++;k[v]="[v=\\s]*("+k[i]+")(?:\\.("+k[i]+")(?:\\.("+k[i]+")(?:"+k[l]+")?"+k[b]+"?)?)?";var y=m++;k[y]="^"+k[n]+"\\s*"+k[a]+"$";var u=m++;k[u]="^"+k[n]+"\\s*"+k[v]+"$";var E=m++;k[E]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var D=m++;k[D]="(?:~>?)";var T=m++;k[T]="(\\s*)"+k[D]+"\\s+",R[T]=new RegExp(k[T],"g");var F=m++;k[F]="^"+k[D]+k[a]+"$";var q=m++;k[q]="^"+k[D]+k[v]+"$";var W=m++;k[W]="(?:\\^)";var Z=m++;k[Z]="(\\s*)"+k[W]+"\\s+",R[Z]=new RegExp(k[Z],"g");var Y=m++;k[Y]="^"+k[W]+k[a]+"$";var x=m++;k[x]="^"+k[W]+k[v]+"$";var G=m++;k[G]="^"+k[n]+"\\s*("+c+")$|^$";var Q=m++;k[Q]="^"+k[n]+"\\s*("+t+")$|^$";var H=m++;k[H]="(\\s*)"+k[n]+"\\s*("+c+"|"+k[a]+")",R[H]=new RegExp(k[H],"g");var V=m++;k[V]="^\\s*("+k[a]+")\\s+-\\s+("+k[a]+")\\s*$";var B=m++;k[B]="^\\s*("+k[v]+")\\s+-\\s+("+k[v]+")\\s*$";var ee=m++;k[ee]="(<|>)?=?\\s*\\*";for(var ne=0;ne<35;ne++)O(ne,k[ne]),R[ne]||(R[ne]=new RegExp(k[ne]));function se(ce,ge){if(ce instanceof K)return ce;if(typeof ce!="string"||ce.length>j||!(ge?R[s]:R[I]).test(ce))return null;try{return new K(ce,ge)}catch{return null}}function K(ce,ge){if(ce instanceof K){if(ce.loose===ge)return ce;ce=ce.version}else if(typeof ce!="string")throw new TypeError("Invalid Version: "+ce);if(ce.length>j)throw new TypeError("version is longer than "+j+" characters");if(!(this instanceof K))return new K(ce,ge);O("SemVer",ce,ge),this.loose=ge;var be=ce.trim().match(ge?R[s]:R[I]);if(!be)throw new TypeError("Invalid Version: "+ce);if(this.raw=ce,this.major=+be[1],this.minor=+be[2],this.patch=+be[3],this.major>A||this.major<0)throw new TypeError("Invalid major version");if(this.minor>A||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>A||this.patch<0)throw new TypeError("Invalid patch version");be[4]?this.prerelease=be[4].split(".").map(function(Se){if(/^[0-9]+$/.test(Se)){var Pe=+Se;if(Pe>=0&&Pe<A)return Pe}return Se}):this.prerelease=[],this.build=be[5]?be[5].split("."):[],this.format()}e.parse=se,e.valid=function(ce,ge){var be=se(ce,ge);return be?be.version:null},e.clean=function(ce,ge){var be=se(ce.trim().replace(/^[=v]+/,""),ge);return be?be.version:null},e.SemVer=K,K.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},K.prototype.toString=function(){return this.version},K.prototype.compare=function(ce){return O("SemVer.compare",this.version,this.loose,ce),ce instanceof K||(ce=new K(ce,this.loose)),this.compareMain(ce)||this.comparePre(ce)},K.prototype.compareMain=function(ce){return ce instanceof K||(ce=new K(ce,this.loose)),S(this.major,ce.major)||S(this.minor,ce.minor)||S(this.patch,ce.patch)},K.prototype.comparePre=function(ce){if(ce instanceof K||(ce=new K(ce,this.loose)),this.prerelease.length&&!ce.prerelease.length)return-1;if(!this.prerelease.length&&ce.prerelease.length)return 1;if(!this.prerelease.length&&!ce.prerelease.length)return 0;var ge=0;do{var be=this.prerelease[ge],Se=ce.prerelease[ge];if(O("prerelease compare",ge,be,Se),be===void 0&&Se===void 0)return 0;if(Se===void 0)return 1;if(be===void 0)return-1;if(be!==Se)return S(be,Se)}while(++ge)},K.prototype.inc=function(ce,ge){switch(ce){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",ge);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",ge);break;case"prepatch":this.prerelease.length=0,this.inc("patch",ge),this.inc("pre",ge);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",ge),this.inc("pre",ge);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var be=this.prerelease.length;--be>=0;)typeof this.prerelease[be]=="number"&&(this.prerelease[be]++,be=-2);be===-1&&this.prerelease.push(0)}ge&&(this.prerelease[0]===ge?isNaN(this.prerelease[1])&&(this.prerelease=[ge,0]):this.prerelease=[ge,0]);break;default:throw new Error("invalid increment argument: "+ce)}return this.format(),this.raw=this.version,this},e.inc=function(ce,ge,be,Se){typeof be=="string"&&(Se=be,be=void 0);try{return new K(ce,be).inc(ge,Se).version}catch{return null}},e.diff=function(ce,ge){if(J(ce,ge))return null;var be=se(ce),Se=se(ge);if(be.prerelease.length||Se.prerelease.length){for(var Pe in be)if((Pe==="major"||Pe==="minor"||Pe==="patch")&&be[Pe]!==Se[Pe])return"pre"+Pe;return"prerelease"}for(var Pe in be)if((Pe==="major"||Pe==="minor"||Pe==="patch")&&be[Pe]!==Se[Pe])return Pe},e.compareIdentifiers=S;var U=/^[0-9]+$/;function S(ce,ge){var be=U.test(ce),Se=U.test(ge);return be&&Se&&(ce=+ce,ge=+ge),be&&!Se?-1:Se&&!be?1:ce<ge?-1:ce>ge?1:0}function C(ce,ge,be){return new K(ce,be).compare(new K(ge,be))}function z(ce,ge,be){return C(ce,ge,be)>0}function M(ce,ge,be){return C(ce,ge,be)<0}function J(ce,ge,be){return C(ce,ge,be)===0}function _(ce,ge,be){return C(ce,ge,be)!==0}function ae(ce,ge,be){return C(ce,ge,be)>=0}function he(ce,ge,be){return C(ce,ge,be)<=0}function fe(ce,ge,be,Se){var Pe;switch(ge){case"===":typeof ce=="object"&&(ce=ce.version),typeof be=="object"&&(be=be.version),Pe=ce===be;break;case"!==":typeof ce=="object"&&(ce=ce.version),typeof be=="object"&&(be=be.version),Pe=ce!==be;break;case"":case"=":case"==":Pe=J(ce,be,Se);break;case"!=":Pe=_(ce,be,Se);break;case">":Pe=z(ce,be,Se);break;case">=":Pe=ae(ce,be,Se);break;case"<":Pe=M(ce,be,Se);break;case"<=":Pe=he(ce,be,Se);break;default:throw new TypeError("Invalid operator: "+ge)}return Pe}function le(ce,ge){if(ce instanceof le){if(ce.loose===ge)return ce;ce=ce.value}if(!(this instanceof le))return new le(ce,ge);O("comparator",ce,ge),this.loose=ge,this.parse(ce),this.semver===$e?this.value="":this.value=this.operator+this.semver.version,O("comp",this)}e.rcompareIdentifiers=function(ce,ge){return S(ge,ce)},e.major=function(ce,ge){return new K(ce,ge).major},e.minor=function(ce,ge){return new K(ce,ge).minor},e.patch=function(ce,ge){return new K(ce,ge).patch},e.compare=C,e.compareLoose=function(ce,ge){return C(ce,ge,!0)},e.rcompare=function(ce,ge,be){return C(ge,ce,be)},e.sort=function(ce,ge){return ce.sort(function(be,Se){return e.compare(be,Se,ge)})},e.rsort=function(ce,ge){return ce.sort(function(be,Se){return e.rcompare(be,Se,ge)})},e.gt=z,e.lt=M,e.eq=J,e.neq=_,e.gte=ae,e.lte=he,e.cmp=fe,e.Comparator=le;var $e={};function de(ce,ge){if(ce instanceof de)return ce.loose===ge?ce:new de(ce.raw,ge);if(ce instanceof le)return new de(ce.value,ge);if(!(this instanceof de))return new de(ce,ge);if(this.loose=ge,this.raw=ce,this.set=ce.split(/\s*\|\|\s*/).map(function(be){return this.parseRange(be.trim())},this).filter(function(be){return be.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+ce);this.format()}function we(ce){return!ce||ce.toLowerCase()==="x"||ce==="*"}function ke(ce,ge,be,Se,Pe,Me,Ae,Fe,ze,ie,ue,me,pe){return((ge=we(be)?"":we(Se)?">="+be+".0.0":we(Pe)?">="+be+"."+Se+".0":">="+ge)+" "+(Fe=we(ze)?"":we(ie)?"<"+(+ze+1)+".0.0":we(ue)?"<"+ze+"."+(+ie+1)+".0":me?"<="+ze+"."+ie+"."+ue+"-"+me:"<="+Fe)).trim()}function Ie(ce,ge){for(var be=0;be<ce.length;be++)if(!ce[be].test(ge))return!1;if(ge.prerelease.length){for(be=0;be<ce.length;be++)if(O(ce[be].semver),ce[be].semver!==$e&&ce[be].semver.prerelease.length>0){var Se=ce[be].semver;if(Se.major===ge.major&&Se.minor===ge.minor&&Se.patch===ge.patch)return!0}return!1}return!0}function je(ce,ge,be){try{ge=new de(ge,be)}catch{return!1}return ge.test(ce)}function Ue(ce,ge,be,Se){var Pe,Me,Ae,Fe,ze;switch(ce=new K(ce,Se),ge=new de(ge,Se),be){case">":Pe=z,Me=he,Ae=M,Fe=">",ze=">=";break;case"<":Pe=M,Me=ae,Ae=z,Fe="<",ze="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(je(ce,ge,Se))return!1;for(var ie=0;ie<ge.set.length;++ie){var ue=ge.set[ie],me=null,pe=null;if(ue.forEach(function(Ee){Ee.semver===$e&&(Ee=new le(">=0.0.0")),me=me||Ee,pe=pe||Ee,Pe(Ee.semver,me.semver,Se)?me=Ee:Ae(Ee.semver,pe.semver,Se)&&(pe=Ee)}),me.operator===Fe||me.operator===ze||(!pe.operator||pe.operator===Fe)&&Me(ce,pe.semver)||pe.operator===ze&&Ae(ce,pe.semver))return!1}return!0}le.prototype.parse=function(ce){var ge=this.loose?R[G]:R[Q],be=ce.match(ge);if(!be)throw new TypeError("Invalid comparator: "+ce);this.operator=be[1],this.operator==="="&&(this.operator=""),be[2]?this.semver=new K(be[2],this.loose):this.semver=$e},le.prototype.toString=function(){return this.value},le.prototype.test=function(ce){return O("Comparator.test",ce,this.loose),this.semver===$e||(typeof ce=="string"&&(ce=new K(ce,this.loose)),fe(ce,this.operator,this.semver,this.loose))},le.prototype.intersects=function(ce,ge){if(!(ce instanceof le))throw new TypeError("a Comparator is required");var be;if(this.operator==="")return be=new de(ce.value,ge),je(this.value,be,ge);if(ce.operator==="")return be=new de(this.value,ge),je(ce.semver,be,ge);var Se=!(this.operator!==">="&&this.operator!==">"||ce.operator!==">="&&ce.operator!==">"),Pe=!(this.operator!=="<="&&this.operator!=="<"||ce.operator!=="<="&&ce.operator!=="<"),Me=this.semver.version===ce.semver.version,Ae=!(this.operator!==">="&&this.operator!=="<="||ce.operator!==">="&&ce.operator!=="<="),Fe=fe(this.semver,"<",ce.semver,ge)&&(this.operator===">="||this.operator===">")&&(ce.operator==="<="||ce.operator==="<"),ze=fe(this.semver,">",ce.semver,ge)&&(this.operator==="<="||this.operator==="<")&&(ce.operator===">="||ce.operator===">");return Se||Pe||Me&&Ae||Fe||ze},e.Range=de,de.prototype.format=function(){return this.range=this.set.map(function(ce){return ce.join(" ").trim()}).join("||").trim(),this.range},de.prototype.toString=function(){return this.range},de.prototype.parseRange=function(ce){var ge=this.loose;ce=ce.trim(),O("range",ce,ge);var be=ge?R[B]:R[V];ce=ce.replace(be,ke),O("hyphen replace",ce),ce=ce.replace(R[H],"$1$2$3"),O("comparator trim",ce,R[H]),ce=(ce=(ce=ce.replace(R[T],"$1~")).replace(R[Z],"$1^")).split(/\s+/).join(" ");var Se=ge?R[G]:R[Q],Pe=ce.split(" ").map(function(Me){return function(Ae,Fe){return O("comp",Ae),Ae=function(ze,ie){return ze.trim().split(/\s+/).map(function(ue){return function(me,pe){O("caret",me,pe);var Ee=pe?R[x]:R[Y];return me.replace(Ee,function(Re,Ce,Le,Oe,De){var Ne;return O("caret",me,Re,Ce,Le,Oe,De),we(Ce)?Ne="":we(Le)?Ne=">="+Ce+".0.0 <"+(+Ce+1)+".0.0":we(Oe)?Ne=Ce==="0"?">="+Ce+"."+Le+".0 <"+Ce+"."+(+Le+1)+".0":">="+Ce+"."+Le+".0 <"+(+Ce+1)+".0.0":De?(O("replaceCaret pr",De),De.charAt(0)!=="-"&&(De="-"+De),Ne=Ce==="0"?Le==="0"?">="+Ce+"."+Le+"."+Oe+De+" <"+Ce+"."+Le+"."+(+Oe+1):">="+Ce+"."+Le+"."+Oe+De+" <"+Ce+"."+(+Le+1)+".0":">="+Ce+"."+Le+"."+Oe+De+" <"+(+Ce+1)+".0.0"):(O("no pr"),Ne=Ce==="0"?Le==="0"?">="+Ce+"."+Le+"."+Oe+" <"+Ce+"."+Le+"."+(+Oe+1):">="+Ce+"."+Le+"."+Oe+" <"+Ce+"."+(+Le+1)+".0":">="+Ce+"."+Le+"."+Oe+" <"+(+Ce+1)+".0.0"),O("caret return",Ne),Ne})}(ue,ie)}).join(" ")}(Ae,Fe),O("caret",Ae),Ae=function(ze,ie){return ze.trim().split(/\s+/).map(function(ue){return function(me,pe){var Ee=pe?R[q]:R[F];return me.replace(Ee,function(Re,Ce,Le,Oe,De){var Ne;return O("tilde",me,Re,Ce,Le,Oe,De),we(Ce)?Ne="":we(Le)?Ne=">="+Ce+".0.0 <"+(+Ce+1)+".0.0":we(Oe)?Ne=">="+Ce+"."+Le+".0 <"+Ce+"."+(+Le+1)+".0":De?(O("replaceTilde pr",De),De.charAt(0)!=="-"&&(De="-"+De),Ne=">="+Ce+"."+Le+"."+Oe+De+" <"+Ce+"."+(+Le+1)+".0"):Ne=">="+Ce+"."+Le+"."+Oe+" <"+Ce+"."+(+Le+1)+".0",O("tilde return",Ne),Ne})}(ue,ie)}).join(" ")}(Ae,Fe),O("tildes",Ae),Ae=function(ze,ie){return O("replaceXRanges",ze,ie),ze.split(/\s+/).map(function(ue){return function(me,pe){me=me.trim();var Ee=pe?R[u]:R[y];return me.replace(Ee,function(Re,Ce,Le,Oe,De,Ne){O("xRange",me,Re,Ce,Le,Oe,De,Ne);var Be=we(Le),qe=Be||we(Oe),Ve=qe||we(De);return Ce==="="&&Ve&&(Ce=""),Be?Re=Ce===">"||Ce==="<"?"<0.0.0":"*":Ce&&Ve?(qe&&(Oe=0),Ve&&(De=0),Ce===">"?(Ce=">=",qe?(Le=+Le+1,Oe=0,De=0):Ve&&(Oe=+Oe+1,De=0)):Ce==="<="&&(Ce="<",qe?Le=+Le+1:Oe=+Oe+1),Re=Ce+Le+"."+Oe+"."+De):qe?Re=">="+Le+".0.0 <"+(+Le+1)+".0.0":Ve&&(Re=">="+Le+"."+Oe+".0 <"+Le+"."+(+Oe+1)+".0"),O("xRange return",Re),Re})}(ue,ie)}).join(" ")}(Ae,Fe),O("xrange",Ae),Ae=function(ze,ie){return O("replaceStars",ze,ie),ze.trim().replace(R[ee],"")}(Ae,Fe),O("stars",Ae),Ae}(Me,ge)}).join(" ").split(/\s+/);return this.loose&&(Pe=Pe.filter(function(Me){return!!Me.match(Se)})),Pe=Pe.map(function(Me){return new le(Me,ge)})},de.prototype.intersects=function(ce,ge){if(!(ce instanceof de))throw new TypeError("a Range is required");return this.set.some(function(be){return be.every(function(Se){return ce.set.some(function(Pe){return Pe.every(function(Me){return Se.intersects(Me,ge)})})})})},e.toComparators=function(ce,ge){return new de(ce,ge).set.map(function(be){return be.map(function(Se){return Se.value}).join(" ").trim().split(" ")})},de.prototype.test=function(ce){if(!ce)return!1;typeof ce=="string"&&(ce=new K(ce,this.loose));for(var ge=0;ge<this.set.length;ge++)if(Ie(this.set[ge],ce))return!0;return!1},e.satisfies=je,e.maxSatisfying=function(ce,ge,be){var Se=null,Pe=null;try{var Me=new de(ge,be)}catch{return null}return ce.forEach(function(Ae){Me.test(Ae)&&(Se&&Pe.compare(Ae)!==-1||(Pe=new K(Se=Ae,be)))}),Se},e.minSatisfying=function(ce,ge,be){var Se=null,Pe=null;try{var Me=new de(ge,be)}catch{return null}return ce.forEach(function(Ae){Me.test(Ae)&&(Se&&Pe.compare(Ae)!==1||(Pe=new K(Se=Ae,be)))}),Se},e.validRange=function(ce,ge){try{return new de(ce,ge).range||"*"}catch{return null}},e.ltr=function(ce,ge,be){return Ue(ce,ge,"<",be)},e.gtr=function(ce,ge,be){return Ue(ce,ge,">",be)},e.outside=Ue,e.prerelease=function(ce,ge){var be=se(ce,ge);return be&&be.prerelease.length?be.prerelease:null},e.intersects=function(ce,ge,be){return ce=new de(ce,be),ge=new de(ge,be),ce.intersects(ge)},e.coerce=function(ce){if(ce instanceof K)return ce;if(typeof ce!="string")return null;var ge=ce.match(R[E]);return ge==null?null:se((ge[1]||"0")+"."+(ge[2]||"0")+"."+(ge[3]||"0"))}}).call(this,L(1))},function(te,e){var L,N,O=te.exports={};function j(){throw new Error("setTimeout has not been defined")}function A(){throw new Error("clearTimeout has not been defined")}function R(f){if(L===setTimeout)return setTimeout(f,0);if((L===j||!L)&&setTimeout)return L=setTimeout,setTimeout(f,0);try{return L(f,0)}catch{try{return L.call(null,f,0)}catch{return L.call(this,f,0)}}}(function(){try{L=typeof setTimeout=="function"?setTimeout:j}catch{L=j}try{N=typeof clearTimeout=="function"?clearTimeout:A}catch{N=A}})();var k,m=[],P=!1,p=-1;function g(){P&&k&&(P=!1,k.length?m=k.concat(m):p=-1,m.length&&h())}function h(){if(!P){var f=R(g);P=!0;for(var o=m.length;o;){for(k=m,m=[];++p<o;)k&&k[p].run();p=-1,o=m.length}k=null,P=!1,function(l){if(N===clearTimeout)return clearTimeout(l);if((N===A||!N)&&clearTimeout)return N=clearTimeout,clearTimeout(l);try{N(l)}catch{try{return N.call(null,l)}catch{return N.call(this,l)}}}(f)}}function d(f,o){this.fun=f,this.array=o}function w(){}O.nextTick=function(f){var o=new Array(arguments.length-1);if(arguments.length>1)for(var l=1;l<arguments.length;l++)o[l-1]=arguments[l];m.push(new d(f,o)),m.length!==1||P||R(h)},d.prototype.run=function(){this.fun.apply(null,this.array)},O.title="browser",O.browser=!0,O.env={},O.argv=[],O.version="",O.versions={},O.on=w,O.addListener=w,O.once=w,O.off=w,O.removeListener=w,O.removeAllListeners=w,O.emit=w,O.prependListener=w,O.prependOnceListener=w,O.listeners=function(f){return[]},O.binding=function(f){throw new Error("process.binding is not supported")},O.cwd=function(){return"/"},O.chdir=function(f){throw new Error("process.chdir is not supported")},O.umask=function(){return 0}}])}),define(re[127],oe([0,1]),function(te,e){"use strict";var L;Object.defineProperty(e,"__esModule",{value:!0}),e.$lr=void 0;class N{constructor(R,k,m){this.level=R,this.key=k,this.value=m,this.forward=[]}}const O=void 0;class j{constructor(R,k=2**16){this.comparator=R,this[L]="SkipList",this.d=0,this.f=0,this.c=Math.max(1,Math.log2(k)|0),this.e=new N(this.c,O,O)}get size(){return this.f}clear(){this.e=new N(this.c,O,O)}has(R){return!!j.g(this,R,this.comparator)}get(R){return j.g(this,R,this.comparator)?.value}set(R,k){return j.h(this,R,k,this.comparator)&&(this.f+=1),this}delete(R){const k=j.k(this,R,this.comparator);return k&&(this.f-=1),k}forEach(R,k){let m=this.e.forward[0];for(;m;)R.call(k,m.value,m.key,this),m=m.forward[0]}[(L=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let R=this.e.forward[0];for(;R;)yield[R.key,R.value],R=R.forward[0]}*keys(){let R=this.e.forward[0];for(;R;)yield R.key,R=R.forward[0]}*values(){let R=this.e.forward[0];for(;R;)yield R.value,R=R.forward[0]}toString(){let R="[SkipList]:",k=this.e.forward[0];for(;k;)R+=`node(${k.key}, ${k.value}, lvl:${k.level})`,k=k.forward[0];return R}static g(R,k,m){let P=R.e;for(let p=R.d-1;p>=0;p--)for(;P.forward[p]&&m(P.forward[p].key,k)<0;)P=P.forward[p];if(P=P.forward[0],P&&m(P.key,k)===0)return P}static h(R,k,m,P){const p=[];let g=R.e;for(let h=R.d-1;h>=0;h--){for(;g.forward[h]&&P(g.forward[h].key,k)<0;)g=g.forward[h];p[h]=g}if(g=g.forward[0],g&&P(g.key,k)===0)return g.value=m,!1;{const h=j.j(R);if(h>R.d){for(let d=R.d;d<h;d++)p[d]=R.e;R.d=h}g=new N(h,k,m);for(let d=0;d<h;d++)g.forward[d]=p[d].forward[d],p[d].forward[d]=g;return!0}}static j(R,k=.5){let m=1;for(;Math.random()<k&&m<R.c;)m+=1;return m}static k(R,k,m){const P=[];let p=R.e;for(let g=R.d-1;g>=0;g--){for(;p.forward[g]&&m(p.forward[g].key,k)<0;)p=p.forward[g];P[g]=p}if(p=p.forward[0],!p||m(p.key,k)!==0)return!1;for(let g=0;g<R.d&&P[g].forward[g]===p;g++)P[g].forward[g]=p.forward[g];for(;R.d>0&&R.e.forward[R.d-1]===O;)R.d-=1;return!0}}e.$lr=j}),define(re[60],oe([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dc=void 0;const L=globalThis.performance&&typeof globalThis.performance.now=="function";class N{static create(j){return new N(j)}constructor(j){this.c=L&&j===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this.a=this.c(),this.b=-1}stop(){this.b=this.c()}reset(){this.a=this.c(),this.b=-1}elapsed(){return this.b!==-1?this.b-this.a:this.c()-this.a}}e.$dc=N}),define(re[3],oe([0,1,8,84,2,87,60]),function(te,e,L,N,O,j,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qc=e.$pc=e.$oc=e.$nc=e.$mc=e.$lc=e.$kc=e.$jc=e.$ic=e.$hc=e.$gc=e.$fc=e.Event=void 0;const R=!1,k=!1;var m;(function(y){y.None=()=>O.$mb.None;function u(fe){if(k){const{onDidAddListener:le}=fe,$e=d.create();let de=0;fe.onDidAddListener=()=>{++de===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),$e.print()),le?.()}}}function E(fe,le){return Q(fe,()=>{},0,void 0,!0,void 0,le)}y.defer=E;function D(fe){return(le,$e=null,de)=>{let we=!1,ke;return ke=fe(Ie=>{if(!we)return ke?ke.dispose():we=!0,le.call($e,Ie)},null,de),we&&ke.dispose(),ke}}y.once=D;function T(fe,le,$e){return x((de,we=null,ke)=>fe(Ie=>de.call(we,le(Ie)),null,ke),$e)}y.map=T;function F(fe,le,$e){return x((de,we=null,ke)=>fe(Ie=>{le(Ie),de.call(we,Ie)},null,ke),$e)}y.forEach=F;function q(fe,le,$e){return x((de,we=null,ke)=>fe(Ie=>le(Ie)&&de.call(we,Ie),null,ke),$e)}y.filter=q;function W(fe){return fe}y.signal=W;function Z(...fe){return(le,$e=null,de)=>{const we=(0,O.$jb)(...fe.map(ke=>ke(Ie=>le.call($e,Ie))));return G(we,de)}}y.any=Z;function Y(fe,le,$e,de){let we=$e;return T(fe,ke=>(we=le(we,ke),we),de)}y.reduce=Y;function x(fe,le){let $e;const de={onWillAddFirstListener(){$e=fe(we.fire,we)},onDidRemoveLastListener(){$e?.dispose()}};le||u(de);const we=new $(de);return le?.add(we),we.event}function G(fe,le){return le instanceof Array?le.push(fe):le&&le.add(fe),fe}function Q(fe,le,$e=100,de=!1,we=!1,ke,Ie){let je,Ue,ce,ge=0,be;const Se={leakWarningThreshold:ke,onWillAddFirstListener(){je=fe(Me=>{ge++,Ue=le(Ue,Me),de&&!ce&&(Pe.fire(Ue),Ue=void 0),be=()=>{const Ae=Ue;Ue=void 0,ce=void 0,(!de||ge>1)&&Pe.fire(Ae),ge=0},typeof $e=="number"?(clearTimeout(ce),ce=setTimeout(be,$e)):ce===void 0&&(ce=0,queueMicrotask(be))})},onWillRemoveListener(){we&&ge>0&&be?.()},onDidRemoveLastListener(){be=void 0,je.dispose()}};Ie||u(Se);const Pe=new $(Se);return Ie?.add(Pe),Pe.event}y.debounce=Q;function H(fe,le=0,$e){return y.debounce(fe,(de,we)=>de?(de.push(we),de):[we],le,void 0,!0,void 0,$e)}y.accumulate=H;function V(fe,le=(de,we)=>de===we,$e){let de=!0,we;return q(fe,ke=>{const Ie=de||!le(ke,we);return de=!1,we=ke,Ie},$e)}y.latch=V;function B(fe,le,$e){return[y.filter(fe,le,$e),y.filter(fe,de=>!le(de),$e)]}y.split=B;function ee(fe,le=!1,$e=[]){let de=$e.slice(),we=fe(je=>{de?de.push(je):Ie.fire(je)});const ke=()=>{de?.forEach(je=>Ie.fire(je)),de=null},Ie=new $({onWillAddFirstListener(){we||(we=fe(je=>Ie.fire(je)))},onDidAddFirstListener(){de&&(le?setTimeout(ke):ke())},onDidRemoveLastListener(){we&&we.dispose(),we=null}});return Ie.event}y.buffer=ee;function ne(fe,le){return(de,we,ke)=>{const Ie=le(new K);return fe(function(je){const Ue=Ie.evaluate(je);Ue!==se&&de.call(we,Ue)},void 0,ke)}}y.chain=ne;const se=Symbol("HaltChainable");class K{constructor(){this.f=[]}map(le){return this.f.push(le),this}forEach(le){return this.f.push($e=>(le($e),$e)),this}filter(le){return this.f.push($e=>le($e)?$e:se),this}reduce(le,$e){let de=$e;return this.f.push(we=>(de=le(de,we),de)),this}latch(le=($e,de)=>$e===de){let $e=!0,de;return this.f.push(we=>{const ke=$e||!le(we,de);return $e=!1,de=we,ke?we:se}),this}evaluate(le){for(const $e of this.f)if(le=$e(le),le===se)break;return le}}function U(fe,le,$e=de=>de){const de=(...je)=>Ie.fire($e(...je)),we=()=>fe.on(le,de),ke=()=>fe.removeListener(le,de),Ie=new $({onWillAddFirstListener:we,onDidRemoveLastListener:ke});return Ie.event}y.fromNodeEventEmitter=U;function S(fe,le,$e=de=>de){const de=(...je)=>Ie.fire($e(...je)),we=()=>fe.addEventListener(le,de),ke=()=>fe.removeEventListener(le,de),Ie=new $({onWillAddFirstListener:we,onDidRemoveLastListener:ke});return Ie.event}y.fromDOMEventEmitter=S;function C(fe){return new Promise(le=>D(fe)(le))}y.toPromise=C;function z(fe){const le=new $;return fe.then($e=>{le.fire($e)},()=>{le.fire(void 0)}).finally(()=>{le.dispose()}),le.event}y.fromPromise=z;function M(fe,le){return le(void 0),fe($e=>le($e))}y.runAndSubscribe=M;function J(fe,le){let $e=null;function de(ke){$e?.dispose(),$e=new O.$lb,le(ke,$e)}de(void 0);const we=fe(ke=>de(ke));return(0,O.$kb)(()=>{we.dispose(),$e?.dispose()})}y.runAndSubscribeWithStore=J;class _{constructor(le,$e){this._observable=le,this.f=0,this.g=!1;const de={onWillAddFirstListener:()=>{le.addObserver(this)},onDidRemoveLastListener:()=>{le.removeObserver(this)}};$e||u(de),this.emitter=new $(de),$e&&$e.add(this.emitter)}beginUpdate(le){this.f++}handlePossibleChange(le){}handleChange(le,$e){this.g=!0}endUpdate(le){this.f--,this.f===0&&(this._observable.reportChanges(),this.g&&(this.g=!1,this.emitter.fire(this._observable.get())))}}function ae(fe,le){return new _(fe,le).emitter.event}y.fromObservable=ae;function he(fe){return le=>{let $e=0,de=!1;const we={beginUpdate(){$e++},endUpdate(){$e--,$e===0&&(fe.reportChanges(),de&&(de=!1,le()))},handlePossibleChange(){},handleChange(){de=!0}};return fe.addObserver(we),fe.reportChanges(),{dispose(){fe.removeObserver(we)}}}}y.fromObservableLight=he})(m||(e.Event=m={}));class P{static{this.all=new Set}static{this.f=0}constructor(u){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${u}_${P.f++}`,P.all.add(this)}start(u){this.g=new A.$dc,this.listenerCount=u}stop(){if(this.g){const u=this.g.elapsed();this.durations.push(u),this.elapsedOverall+=u,this.invocationCount+=1,this.g=void 0}}}e.$fc=P;let p=-1;function g(y){const u=p;return p=y,{dispose(){p=u}}}e.$gc=g;class h{constructor(u,E=Math.random().toString(18).slice(2,5)){this.threshold=u,this.name=E,this.g=0}dispose(){this.f?.clear()}check(u,E){const D=this.threshold;if(D<=0||E<D)return;this.f||(this.f=new Map);const T=this.f.get(u.value)||0;if(this.f.set(u.value,T+1),this.g-=1,this.g<=0){this.g=D*.5;let F,q=0;for(const[W,Z]of this.f)(!F||q<Z)&&(F=W,q=Z);console.warn(`[${this.name}] potential listener LEAK detected, having ${E} listeners already. MOST frequent listener (${q}):`),console.warn(F)}return()=>{const F=this.f.get(u.value)||0;this.f.set(u.value,F-1)}}}class d{static create(){return new d(new Error().stack??"")}constructor(u){this.value=u}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}let w=0;class f{constructor(u){this.value=u,this.id=w++}}const o=2,l=(y,u)=>{if(y instanceof f)u(y);else for(let E=0;E<y.length;E++){const D=y[E];D&&u(D)}};class ${constructor(u){this.w=0,this.f=u,this.g=p>0||this.f?.leakWarningThreshold?new h(this.f?.leakWarningThreshold??p):void 0,this.j=this.f?._profName?new P(this.f._profName):void 0,this.u=this.f?.deliveryQueue}dispose(){if(!this.m){if(this.m=!0,this.u?.current===this&&this.u.reset(),this.t){if(R){const u=this.t;queueMicrotask(()=>{l(u,E=>E.stack?.print())})}this.t=void 0,this.w=0}this.f?.onDidRemoveLastListener?.(),this.g?.dispose()}}get event(){return this.q??=(u,E,D)=>{if(this.g&&this.w>this.g.threshold*3)return console.warn(`[${this.g.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),O.$mb.None;if(this.m)return O.$mb.None;E&&(u=u.bind(E));const T=new f(u);let F,q;this.g&&this.w>=Math.ceil(this.g.threshold*.2)&&(T.stack=d.create(),F=this.g.check(T.stack,this.w+1)),R&&(T.stack=q??d.create()),this.t?this.t instanceof f?(this.u??=new I,this.t=[this.t,T]):this.t.push(T):(this.f?.onWillAddFirstListener?.(this),this.t=T,this.f?.onDidAddFirstListener?.(this)),this.w++;const W=(0,O.$kb)(()=>{F?.(),this.x(T)});return D instanceof O.$lb?D.add(W):Array.isArray(D)&&D.push(W),W},this.q}x(u){if(this.f?.onWillRemoveListener?.(this),!this.t)return;if(this.w===1){this.t=void 0,this.f?.onDidRemoveLastListener?.(this),this.w=0;return}const E=this.t,D=E.indexOf(u);if(D===-1)throw console.log("disposed?",this.m),console.log("size?",this.w),console.log("arr?",JSON.stringify(this.t)),new Error("Attempted to dispose unknown listener");this.w--,E[D]=void 0;const T=this.u.current===this;if(this.w*o<=E.length){let F=0;for(let q=0;q<E.length;q++)E[q]?E[F++]=E[q]:T&&(this.u.end--,F<this.u.i&&this.u.i--);E.length=F}}y(u,E){if(!u)return;const D=this.f?.onListenerError||L.$Y;if(!D){u.value(E);return}try{u.value(E)}catch(T){D(T)}}z(u){const E=u.current.t;for(;u.i<u.end;)this.y(E[u.i++],u.value);u.reset()}fire(u){if(this.u?.current&&(this.z(this.u),this.j?.stop()),this.j?.start(this.w),this.t)if(this.t instanceof f)this.y(this.t,u);else{const E=this.u;E.enqueue(this,u,this.t.length),this.z(E)}this.j?.stop()}hasListeners(){return this.w>0}}e.$hc=$;const b=()=>new I;e.$ic=b;class I{constructor(){this.i=-1,this.end=0}enqueue(u,E,D){this.i=0,this.end=D,this.current=u,this.value=E}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class t extends ${async fireAsync(u,E,D){if(this.t)for(this.h||(this.h=new j.$vb),l(this.t,T=>this.h.push([T.value,u]));this.h.size>0&&!E.isCancellationRequested;){const[T,F]=this.h.shift(),q=[],W={...F,token:E,waitUntil:Z=>{if(Object.isFrozen(q))throw new Error("waitUntil can NOT be called asynchronous");D&&(Z=D(Z,T)),q.push(Z)}};try{T(W)}catch(Z){(0,L.$Y)(Z);continue}Object.freeze(q),await Promise.allSettled(q).then(Z=>{for(const Y of Z)Y.status==="rejected"&&(0,L.$Y)(Y.reason)})}}}e.$jc=t;class c extends ${get isPaused(){return this.h!==0}constructor(u){super(u),this.h=0,this.s=new j.$vb,this.A=u?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.A){if(this.s.size>0){const u=Array.from(this.s);this.s.clear(),super.fire(this.A(u))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(u){this.w&&(this.h!==0?this.s.push(u):super.fire(u))}}e.$kc=c;class s extends c{constructor(u){super(u),this.k=u.delay??100}fire(u){this.o||(this.pause(),this.o=setTimeout(()=>{this.o=void 0,this.resume()},this.k)),super.fire(u)}}e.$lc=s;class n extends ${constructor(u){super(u),this.h=[],this.k=u?.merge}fire(u){this.hasListeners()&&(this.h.push(u),this.h.length===1&&queueMicrotask(()=>{this.k?super.fire(this.k(this.h)):this.h.forEach(E=>super.fire(E)),this.h=[]}))}}e.$mc=n;class i{constructor(){this.g=!1,this.h=[],this.f=new $({onWillAddFirstListener:()=>this.j(),onDidRemoveLastListener:()=>this.k()})}get event(){return this.f.event}add(u){const E={event:u,listener:null};this.h.push(E),this.g&&this.m(E);const D=()=>{this.g&&this.o(E);const T=this.h.indexOf(E);this.h.splice(T,1)};return(0,O.$kb)((0,N.$bb)(D))}j(){this.g=!0,this.h.forEach(u=>this.m(u))}k(){this.g=!1,this.h.forEach(u=>this.o(u))}m(u){u.listener=u.event(E=>this.f.fire(E))}o(u){u.listener&&u.listener.dispose(),u.listener=null}dispose(){this.f.dispose()}}e.$nc=i;class r{constructor(u,E,D,T){this.f=new O.$lb;const F=this.f.add(new i),q=this.f.add(new O.$ub);function W(Z){q.set(Z,F.add(T(Z)))}for(const Z of u)W(Z);this.f.add(E(Z=>{W(Z)})),this.f.add(D(Z=>{q.deleteAndDispose(Z)})),this.event=F.event}dispose(){this.f.dispose()}}e.$oc=r;class a{constructor(){this.f=[]}wrapEvent(u){return(E,D,T)=>u(F=>{const q=this.f[this.f.length-1];q?q.push(()=>E.call(D,F)):E.call(D,F)},void 0,T)}bufferEvents(u){const E=[];this.f.push(E);const D=u();return this.f.pop(),E.forEach(T=>T()),D}}e.$pc=a;class v{constructor(){this.f=!1,this.g=m.None,this.h=O.$mb.None,this.j=new $({onDidAddFirstListener:()=>{this.f=!0,this.h=this.g(this.j.fire,this.j)},onDidRemoveLastListener:()=>{this.f=!1,this.h.dispose()}}),this.event=this.j.event}set input(u){this.g=u,this.f&&(this.h.dispose(),this.h=u(this.j.fire,this.j))}dispose(){this.h.dispose(),this.j.dispose()}}e.$qc=v}),define(re[26],oe([0,1,3]),function(te,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rc=e.CancellationToken=void 0;const N=Object.freeze(function(R,k){const m=setTimeout(R.bind(k),0);return{dispose(){clearTimeout(m)}}});var O;(function(R){function k(m){return m===R.None||m===R.Cancelled||m instanceof j?!0:!m||typeof m!="object"?!1:typeof m.isCancellationRequested=="boolean"&&typeof m.onCancellationRequested=="function"}R.isCancellationToken=k,R.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:L.Event.None}),R.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:N})})(O||(e.CancellationToken=O={}));class j{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?N:(this.b||(this.b=new L.$hc),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class A{constructor(k){this.f=void 0,this.g=void 0,this.g=k&&k.onCancellationRequested(this.cancel,this)}get token(){return this.f||(this.f=new j),this.f}cancel(){this.f?this.f instanceof j&&this.f.cancel():this.f=O.Cancelled}dispose(k=!1){k&&this.cancel(),this.g?.dispose(),this.f?this.f instanceof j&&this.f.dispose():this.f=O.None}}e.$rc=A}),define(re[128],oe([0,1,26]),function(te,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ld=e.$kd=e.$jd=void 0;class N{constructor(R){this.b=R,this.a=null}get(){if(this.a)return this.a;const R=new L.$rc,k=this.b(R.token);return this.a={promise:k,dispose:()=>{this.a=null,R.cancel(),R.dispose()}},this.a}}e.$jd=N;class O{constructor(R){this.c=R,this.a=void 0,this.b=void 0}get(R){const k=JSON.stringify(R);return this.b!==k&&(this.b=k,this.a=this.c(R)),this.a}}e.$kd=O;class j{get cachedValues(){return this.a}constructor(R){this.b=R,this.a=new Map}get(R){if(this.a.has(R))return this.a.get(R);const k=this.b(R);return this.a.set(R,k),k}}e.$ld=j}),define(re[42],oe([0,1,8,2]),function(te,e,L,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gc=e.$Fc=e.$Ec=e.$Dc=e.$Cc=e.$Bc=e.$Ac=e.$zc=e.$yc=e.$xc=e.$wc=e.$vc=e.$uc=e.$tc=e.$sc=void 0;function O(b){const I=b;return I?typeof I.read=="function":!1}e.$sc=O;function j(b){const I=b;return I?[I.on,I.pause,I.resume,I.destroy].every(t=>typeof t=="function"):!1}e.$tc=j;function A(b){const I=b;return I?j(I.stream)&&Array.isArray(I.buffer)&&typeof I.ended=="boolean":!1}e.$uc=A;function R(b,I){return new k(b,I)}e.$vc=R;class k{constructor(I,t){this.e=I,this.f=t,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(I){if(!this.a.destroyed){if(this.a.flowing)this.g(I);else if(this.b.data.push(I),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(t=>this.d.push(t))}}error(I){this.a.destroyed||(this.a.flowing?this.h(I):this.b.error.push(I))}end(I){this.a.destroyed||(typeof I<"u"&&this.write(I),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(I){this.c.data.slice(0).forEach(t=>t(I))}h(I){this.c.error.length===0?(0,L.$Y)(I):this.c.error.slice(0).forEach(t=>t(I))}i(){this.c.end.slice(0).forEach(I=>I())}on(I,t){if(!this.a.destroyed)switch(I){case"data":this.c.data.push(t),this.resume();break;case"end":this.c.end.push(t),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(t),this.a.flowing&&this.k();break}}removeListener(I,t){if(this.a.destroyed)return;let c;switch(I){case"data":c=this.c.data;break;case"end":c=this.c.end;break;case"error":c=this.c.error;break}if(c){const s=c.indexOf(t);s>=0&&c.splice(s,1)}}j(){if(this.b.data.length>0){const I=this.e(this.b.data);this.g(I),this.b.data.length=0;const t=[...this.d];this.d.length=0,t.forEach(c=>c())}}k(){if(this.c.error.length>0){for(const I of this.b.error)this.h(I);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function m(b,I){const t=[];let c;for(;(c=b.read())!==null;)t.push(c);return I(t)}e.$wc=m;function P(b,I,t){const c=[];let s;for(;(s=b.read())!==null&&c.length<t;)c.push(s);return s===null&&c.length>0?I(c):{read:()=>{if(c.length>0)return c.shift();if(typeof s<"u"){const n=s;return s=void 0,n}return b.read()}}}e.$xc=P;function p(b,I){return new Promise((t,c)=>{const s=[];g(b,{onData:n=>{I&&s.push(n)},onError:n=>{I?c(n):t(void 0)},onEnd:()=>{t(I?I(s):void 0)}})})}e.$yc=p;function g(b,I,t){b.on("error",c=>{t?.isCancellationRequested||I.onError(c)}),b.on("end",()=>{t?.isCancellationRequested||I.onEnd()}),b.on("data",c=>{t?.isCancellationRequested||I.onData(c)})}e.$zc=g;function h(b,I){return new Promise((t,c)=>{const s=new N.$lb,n=[],i=v=>{if(n.push(v),n.length>I)return s.dispose(),b.pause(),t({stream:b,buffer:n,ended:!1})},r=v=>(s.dispose(),c(v)),a=()=>(s.dispose(),t({stream:b,buffer:n,ended:!0}));s.add((0,N.$kb)(()=>b.removeListener("error",r))),b.on("error",r),s.add((0,N.$kb)(()=>b.removeListener("end",a))),b.on("end",a),s.add((0,N.$kb)(()=>b.removeListener("data",i))),b.on("data",i)})}e.$Ac=h;function d(b,I){const t=R(I);return t.end(b),t}e.$Bc=d;function w(){const b=R(()=>{throw new Error("not supported")});return b.end(),b}e.$Cc=w;function f(b){let I=!1;return{read:()=>I?null:(I=!0,b)}}e.$Dc=f;function o(b,I,t){const c=R(t);return g(b,{onData:s=>c.write(I.data(s)),onError:s=>c.error(I.error?I.error(s):s),onEnd:()=>c.end()}),c}e.$Ec=o;function l(b,I,t){let c=!1;return{read:()=>{const s=I.read();return c?s:(c=!0,s!==null?t([b,s]):b)}}}e.$Fc=l;function $(b,I,t){let c=!1;const s=R(t);return g(I,{onData:n=>c?s.write(n):(c=!0,s.write(t([b,n]))),onError:n=>s.error(n),onEnd:()=>{c||(c=!0,s.write(b)),s.end()}}),s}e.$Gc=$}),define(re[14],oe([0,1,86,42]),function(te,e,L,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2c=e.$1c=e.$Zc=e.$Yc=e.$Xc=e.$Wc=e.$Vc=e.$Uc=e.$Tc=e.$Sc=e.$Rc=e.$Qc=e.$Pc=e.$Oc=e.$Nc=e.$Mc=e.$Lc=e.$Kc=e.$Jc=e.$Ic=e.$Hc=void 0;const O=typeof Buffer<"u",j=new L.$T(()=>new Uint8Array(256));let A,R;class k{static alloc(E){return O?new k(Buffer.allocUnsafe(E)):new k(new Uint8Array(E))}static wrap(E){return O&&!Buffer.isBuffer(E)&&(E=Buffer.from(E.buffer,E.byteOffset,E.byteLength)),new k(E)}static fromString(E,D){return!(D?.dontUseNodeBuffer||!1)&&O?new k(Buffer.from(E)):(A||(A=new TextEncoder),new k(A.encode(E)))}static fromByteArray(E){const D=k.alloc(E.length);for(let T=0,F=E.length;T<F;T++)D.buffer[T]=E[T];return D}static concat(E,D){if(typeof D>"u"){D=0;for(let q=0,W=E.length;q<W;q++)D+=E[q].byteLength}const T=k.alloc(D);let F=0;for(let q=0,W=E.length;q<W;q++){const Z=E[q];T.set(Z,F),F+=Z.byteLength}return T}constructor(E){this.buffer=E,this.byteLength=this.buffer.byteLength}clone(){const E=k.alloc(this.byteLength);return E.set(this),E}toString(){return O?this.buffer.toString():(R||(R=new TextDecoder),R.decode(this.buffer))}slice(E,D){return new k(this.buffer.subarray(E,D))}set(E,D){if(E instanceof k)this.buffer.set(E.buffer,D);else if(E instanceof Uint8Array)this.buffer.set(E,D);else if(E instanceof ArrayBuffer)this.buffer.set(new Uint8Array(E),D);else if(ArrayBuffer.isView(E))this.buffer.set(new Uint8Array(E.buffer,E.byteOffset,E.byteLength),D);else throw new Error("Unknown argument 'array'")}readUInt32BE(E){return g(this.buffer,E)}writeUInt32BE(E,D){h(this.buffer,E,D)}readUInt32LE(E){return d(this.buffer,E)}writeUInt32LE(E,D){w(this.buffer,E,D)}readUInt8(E){return f(this.buffer,E)}writeUInt8(E,D){o(this.buffer,E,D)}indexOf(E,D=0){return m(this.buffer,E instanceof k?E.buffer:E,D)}}e.$Hc=k;function m(u,E,D=0){const T=E.byteLength,F=u.byteLength;if(T===0)return 0;if(T===1)return u.indexOf(E[0]);if(T>F-D)return-1;const q=j.value;q.fill(E.length);for(let x=0;x<E.length;x++)q[E[x]]=E.length-x-1;let W=D+E.length-1,Z=W,Y=-1;for(;W<F;)if(u[W]===E[Z]){if(Z===0){Y=W;break}W--,Z--}else W+=Math.max(E.length-Z,q[u[W]]),Z=E.length-1;return Y}e.$Ic=m;function P(u,E){return u[E+0]<<0>>>0|u[E+1]<<8>>>0}e.$Jc=P;function p(u,E,D){u[D+0]=E&255,E=E>>>8,u[D+1]=E&255}e.$Kc=p;function g(u,E){return u[E]*2**24+u[E+1]*2**16+u[E+2]*2**8+u[E+3]}e.$Lc=g;function h(u,E,D){u[D+3]=E,E=E>>>8,u[D+2]=E,E=E>>>8,u[D+1]=E,E=E>>>8,u[D]=E}e.$Mc=h;function d(u,E){return u[E+0]<<0>>>0|u[E+1]<<8>>>0|u[E+2]<<16>>>0|u[E+3]<<24>>>0}e.$Nc=d;function w(u,E,D){u[D+0]=E&255,E=E>>>8,u[D+1]=E&255,E=E>>>8,u[D+2]=E&255,E=E>>>8,u[D+3]=E&255}e.$Oc=w;function f(u,E){return u[E]}e.$Pc=f;function o(u,E,D){u[D]=E}e.$Qc=o;function l(u){return N.$wc(u,E=>k.concat(E))}e.$Rc=l;function $(u){return N.$Dc(u)}e.$Sc=$;function b(u){return N.$yc(u,E=>k.concat(E))}e.$Tc=b;async function I(u){return u.ended?k.concat(u.buffer):k.concat([...u.buffer,await b(u.stream)])}e.$Uc=I;function t(u){return N.$Bc(u,E=>k.concat(E))}e.$Vc=t;function c(u){return N.$Ec(u,{data:E=>typeof E=="string"?k.fromString(E):k.wrap(E)},E=>k.concat(E))}e.$Wc=c;function s(u){return N.$vc(E=>k.concat(E),u)}e.$Xc=s;function n(u,E){return N.$Fc(u,E,D=>k.concat(D))}e.$Yc=n;function i(u,E){return N.$Gc(u,E,D=>k.concat(D))}e.$Zc=i;function r(u){let E=0,D=0,T=0;const F=new Uint8Array(Math.floor(u.length/4*3)),q=Z=>{switch(D){case 3:F[T++]=E|Z,D=0;break;case 2:F[T++]=E|Z>>>2,E=Z<<6,D=3;break;case 1:F[T++]=E|Z>>>4,E=Z<<4,D=2;break;default:E=Z<<2,D=1}};for(let Z=0;Z<u.length;Z++){const Y=u.charCodeAt(Z);if(Y>=65&&Y<=90)q(Y-65);else if(Y>=97&&Y<=122)q(Y-97+26);else if(Y>=48&&Y<=57)q(Y-48+52);else if(Y===43||Y===45)q(62);else if(Y===47||Y===95)q(63);else{if(Y===61)break;throw new SyntaxError(`Unexpected base64 character ${u[Z]}`)}}const W=T;for(;D>0;)q(0);return k.wrap(F).slice(0,W)}e.$1c=r;const a="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",v="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function y({buffer:u},E=!0,D=!1){const T=D?v:a;let F="";const q=u.byteLength%3;let W=0;for(;W<u.byteLength-q;W+=3){const Z=u[W+0],Y=u[W+1],x=u[W+2];F+=T[Z>>>2],F+=T[(Z<<4|Y>>>4)&63],F+=T[(Y<<2|x>>>6)&63],F+=T[x&63]}if(q===1){const Z=u[W+0];F+=T[Z>>>2],F+=T[Z<<4&63],E&&(F+="==")}else if(q===2){const Z=u[W+0],Y=u[W+1];F+=T[Z>>>2],F+=T[(Z<<4|Y>>>4)&63],F+=T[Y<<2&63],E&&(F+="=")}return F}e.$2c=y}),define(re[28],oe([0,1,128,86]),function(te,e,L,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ke=e.$je=e.$ie=e.$he=e.GraphemeBreakType=e.$ge=e.$fe=e.$ee=e.$de=e.$ce=e.$be=e.$ae=e.$_d=e.$$d=e.$0d=e.$9d=e.$8d=e.$7d=e.$6d=e.$5d=e.$4d=e.$3d=e.$2d=e.$1d=e.$Zd=e.$Yd=e.$Xd=e.$Wd=e.$Vd=e.$Ud=e.$Td=e.$Sd=e.$Rd=e.$Qd=e.$Pd=e.$Od=e.$Nd=e.$Md=e.$Ld=e.$Kd=e.$Jd=e.$Id=e.$Hd=e.$Gd=e.$Fd=e.$Ed=e.$Dd=e.$Cd=e.$Bd=e.$Ad=e.$zd=e.$yd=e.$xd=e.$wd=e.$vd=e.$ud=e.$td=e.$sd=e.$rd=e.$qd=e.$pd=e.$od=void 0;function O(ie){return!ie||typeof ie!="string"?!0:ie.trim().length===0}e.$od=O;const j=/{(\d+)}/g;function A(ie,...ue){return ue.length===0?ie:ie.replace(j,function(me,pe){const Ee=parseInt(pe,10);return isNaN(Ee)||Ee<0||Ee>=ue.length?me:ue[Ee]})}e.$pd=A;const R=/{([^}]+)}/g;function k(ie,ue){return ie.replace(R,(me,pe)=>ue[pe]??me)}e.$qd=k;function m(ie){return ie.replace(/[<>&]/g,function(ue){switch(ue){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return ue}})}e.$rd=m;function P(ie){return ie.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.$sd=P;function p(ie,ue){let me=0;const pe=ue.charCodeAt(0);for(let Ee=ie.length-1;Ee>=0;Ee--)ie.charCodeAt(Ee)===pe&&me++;return me}e.$td=p;function g(ie,ue,me="\u2026"){return ie.length<=ue?ie:`${ie.substr(0,ue)}${me}`}e.$ud=g;function h(ie,ue=" "){const me=d(ie,ue);return w(me,ue)}e.$vd=h;function d(ie,ue){if(!ie||!ue)return ie;const me=ue.length;if(me===0||ie.length===0)return ie;let pe=0;for(;ie.indexOf(ue,pe)===pe;)pe=pe+me;return ie.substring(pe)}e.$wd=d;function w(ie,ue){if(!ie||!ue)return ie;const me=ue.length,pe=ie.length;if(me===0||pe===0)return ie;let Ee=pe,Re=-1;for(;Re=ie.lastIndexOf(ue,Ee-1),!(Re===-1||Re+me!==Ee);){if(Re===0)return"";Ee=Re}return ie.substring(0,Ee)}e.$xd=w;function f(ie){return ie.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.$yd=f;function o(ie){return ie.replace(/\*/g,"")}e.$zd=o;function l(ie,ue,me={}){if(!ie)throw new Error("Cannot create regex from empty string");ue||(ie=P(ie)),me.wholeWord&&(/\B/.test(ie.charAt(0))||(ie="\\b"+ie),/\B/.test(ie.charAt(ie.length-1))||(ie=ie+"\\b"));let pe="";return me.global&&(pe+="g"),me.matchCase||(pe+="i"),me.multiline&&(pe+="m"),me.unicode&&(pe+="u"),new RegExp(ie,pe)}e.$Ad=l;function $(ie){return ie.source==="^"||ie.source==="^$"||ie.source==="$"||ie.source==="^\\s*$"?!1:!!(ie.exec("")&&ie.lastIndex===0)}e.$Bd=$;function b(ie){return ie.split(/\r\n|\r|\n/)}e.$Cd=b;function I(ie){for(let ue=0,me=ie.length;ue<me;ue++){const pe=ie.charCodeAt(ue);if(pe!==32&&pe!==9)return ue}return-1}e.$Dd=I;function t(ie,ue=0,me=ie.length){for(let pe=ue;pe<me;pe++){const Ee=ie.charCodeAt(pe);if(Ee!==32&&Ee!==9)return ie.substring(ue,pe)}return ie.substring(ue,me)}e.$Ed=t;function c(ie,ue=ie.length-1){for(let me=ue;me>=0;me--){const pe=ie.charCodeAt(me);if(pe!==32&&pe!==9)return me}return-1}e.$Fd=c;function s(ie,ue,me){const pe=[];let Ee=0;for(const Re of ie.matchAll(ue)){if(pe.push(ie.slice(Ee,Re.index)),Re.index===void 0)throw new Error("match.index should be defined");Ee=Re.index+Re[0].length,pe.push(me(Re[0],...Re.slice(1),Re.index,ie,Re.groups))}return pe.push(ie.slice(Ee)),Promise.all(pe).then(Re=>Re.join(""))}e.$Gd=s;function n(ie,ue){return ie<ue?-1:ie>ue?1:0}e.$Hd=n;function i(ie,ue,me=0,pe=ie.length,Ee=0,Re=ue.length){for(;me<pe&&Ee<Re;me++,Ee++){const Oe=ie.charCodeAt(me),De=ue.charCodeAt(Ee);if(Oe<De)return-1;if(Oe>De)return 1}const Ce=pe-me,Le=Re-Ee;return Ce<Le?-1:Ce>Le?1:0}e.$Id=i;function r(ie,ue){return a(ie,ue,0,ie.length,0,ue.length)}e.$Jd=r;function a(ie,ue,me=0,pe=ie.length,Ee=0,Re=ue.length){for(;me<pe&&Ee<Re;me++,Ee++){let Oe=ie.charCodeAt(me),De=ue.charCodeAt(Ee);if(Oe===De)continue;if(Oe>=128||De>=128)return i(ie.toLowerCase(),ue.toLowerCase(),me,pe,Ee,Re);y(Oe)&&(Oe-=32),y(De)&&(De-=32);const Ne=Oe-De;if(Ne!==0)return Ne}const Ce=pe-me,Le=Re-Ee;return Ce<Le?-1:Ce>Le?1:0}e.$Kd=a;function v(ie){return ie>=48&&ie<=57}e.$Ld=v;function y(ie){return ie>=97&&ie<=122}e.$Md=y;function u(ie){return ie>=65&&ie<=90}e.$Nd=u;function E(ie,ue){return ie.length===ue.length&&a(ie,ue)===0}e.$Od=E;function D(ie,ue){const me=ue.length;return ue.length>ie.length?!1:a(ie,ue,0,me)===0}e.$Pd=D;function T(ie,ue){const me=Math.min(ie.length,ue.length);let pe;for(pe=0;pe<me;pe++)if(ie.charCodeAt(pe)!==ue.charCodeAt(pe))return pe;return me}e.$Qd=T;function F(ie,ue){const me=Math.min(ie.length,ue.length);let pe;const Ee=ie.length-1,Re=ue.length-1;for(pe=0;pe<me;pe++)if(ie.charCodeAt(Ee-pe)!==ue.charCodeAt(Re-pe))return pe;return me}e.$Rd=F;function q(ie){return 55296<=ie&&ie<=56319}e.$Sd=q;function W(ie){return 56320<=ie&&ie<=57343}e.$Td=W;function Z(ie,ue){return(ie-55296<<10)+(ue-56320)+65536}e.$Ud=Z;function Y(ie,ue,me){const pe=ie.charCodeAt(me);if(q(pe)&&me+1<ue){const Ee=ie.charCodeAt(me+1);if(W(Ee))return Z(pe,Ee)}return pe}e.$Vd=Y;function x(ie,ue){const me=ie.charCodeAt(ue-1);if(W(me)&&ue>1){const pe=ie.charCodeAt(ue-2);if(q(pe))return Z(pe,me)}return me}class G{get offset(){return this.e}constructor(ue,me=0){this.c=ue,this.d=ue.length,this.e=me}setOffset(ue){this.e=ue}prevCodePoint(){const ue=x(this.c,this.e);return this.e-=ue>=65536?2:1,ue}nextCodePoint(){const ue=Y(this.c,this.d,this.e);return this.e+=ue>=65536?2:1,ue}eol(){return this.e>=this.d}}e.$Wd=G;class Q{get offset(){return this.c.offset}constructor(ue,me=0){this.c=new G(ue,me)}nextGraphemeLength(){const ue=ge.getInstance(),me=this.c,pe=me.offset;let Ee=ue.getGraphemeBreakType(me.nextCodePoint());for(;!me.eol();){const Re=me.offset,Ce=ue.getGraphemeBreakType(me.nextCodePoint());if(Ue(Ee,Ce)){me.setOffset(Re);break}Ee=Ce}return me.offset-pe}prevGraphemeLength(){const ue=ge.getInstance(),me=this.c,pe=me.offset;let Ee=ue.getGraphemeBreakType(me.prevCodePoint());for(;me.offset>0;){const Re=me.offset,Ce=ue.getGraphemeBreakType(me.prevCodePoint());if(Ue(Ce,Ee)){me.setOffset(Re);break}Ee=Ce}return pe-me.offset}eol(){return this.c.eol()}}e.$Xd=Q;function H(ie,ue){return new Q(ie,ue).nextGraphemeLength()}e.$Yd=H;function V(ie,ue){return new Q(ie,ue).prevGraphemeLength()}e.$Zd=V;function B(ie,ue){ue>0&&W(ie.charCodeAt(ue))&&ue--;const me=ue+H(ie,ue);return[me-V(ie,me),me]}e.$1d=B;function ee(ie){const ue=new Q(ie);let me=0;for(;!ue.eol();)me++,ue.nextGraphemeLength();return me}e.$2d=ee;let ne;function se(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function K(ie){return ne||(ne=se()),ne.test(ie)}e.$3d=K;const U=/^[\t\n\r\x20-\x7E]*$/;function S(ie){return U.test(ie)}e.$4d=S,e.$5d=/[\u2028\u2029]/;function C(ie){return e.$5d.test(ie)}e.$6d=C;function z(ie){return ie>=11904&&ie<=55215||ie>=63744&&ie<=64255||ie>=65281&&ie<=65374}e.$7d=z;function M(ie){return ie>=127462&&ie<=127487||ie===8986||ie===8987||ie===9200||ie===9203||ie>=9728&&ie<=10175||ie===11088||ie===11093||ie>=127744&&ie<=128591||ie>=128640&&ie<=128764||ie>=128992&&ie<=129008||ie>=129280&&ie<=129535||ie>=129648&&ie<=129782}e.$8d=M;function J(ie,ue){if(ie.length<ue)return ie;const me=/\b/g;let pe=0;for(;me.test(ie)&&!(ie.length-me.lastIndex<ue);)pe=me.lastIndex,me.lastIndex+=1;return ie.substring(pe).replace(/^\s/,"")}e.$9d=J;const _=/(:?\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~]/g,ae=/\x1b\].*?\x07/g;function he(ie){return ie&&(ie=ie.replace(_,"").replace(ae,"")),ie}e.$0d=he,e.$$d=String.fromCharCode(65279);function fe(ie){return!!(ie&&ie.length>0&&ie.charCodeAt(0)===65279)}e.$_d=fe;function le(ie){return fe(ie)?ie.substr(1):ie}e.$ae=le;function $e(ie,ue){if(!ie||!ue||ie.length<ue.length)return!1;const me=ue.length,pe=ie.toLowerCase();let Ee=0,Re=-1;for(;Ee<me;){const Ce=pe.indexOf(ue[Ee],Re+1);if(Ce<0)return!1;Re=Ce,Ee++}return!0}e.$be=$e;function de(ie,ue=!1){return ie?(ue&&(ie=ie.replace(/\\./g,"")),ie.toLowerCase()!==ie):!1}e.$ce=de;function we(ie){return ie.charAt(0).toUpperCase()+ie.slice(1)}e.$de=we;function ke(ie,ue=1){if(ue===0)return"";let me=-1;do me=ie.indexOf(`
`,me+1),ue--;while(ue>0&&me>=0);return me===-1?ie:(ie[me-1]==="\r"&&me--,ie.substr(0,me))}e.$ee=ke;function Ie(ie){return ie=ie%(2*26),ie<26?String.fromCharCode(97+ie):String.fromCharCode(65+ie-26)}e.$fe=Ie;function je(ie){return ge.getInstance().getGraphemeBreakType(ie)}e.$ge=je;function Ue(ie,ue){return ie===0?ue!==5&&ue!==7:ie===2&&ue===3?!1:ie===4||ie===2||ie===3||ue===4||ue===2||ue===3?!0:!(ie===8&&(ue===8||ue===9||ue===11||ue===12)||(ie===11||ie===9)&&(ue===9||ue===10)||(ie===12||ie===10)&&ue===10||ue===5||ue===13||ue===7||ie===1||ie===13&&ue===14||ie===6&&ue===6)}var ce;(function(ie){ie[ie.Other=0]="Other",ie[ie.Prepend=1]="Prepend",ie[ie.CR=2]="CR",ie[ie.LF=3]="LF",ie[ie.Control=4]="Control",ie[ie.Extend=5]="Extend",ie[ie.Regional_Indicator=6]="Regional_Indicator",ie[ie.SpacingMark=7]="SpacingMark",ie[ie.L=8]="L",ie[ie.V=9]="V",ie[ie.T=10]="T",ie[ie.LV=11]="LV",ie[ie.LVT=12]="LVT",ie[ie.ZWJ=13]="ZWJ",ie[ie.Extended_Pictographic=14]="Extended_Pictographic"})(ce||(e.GraphemeBreakType=ce={}));class ge{static{this.c=null}static getInstance(){return ge.c||(ge.c=new ge),ge.c}constructor(){this.d=be()}getGraphemeBreakType(ue){if(ue<32)return ue===10?3:ue===13?2:4;if(ue<127)return 0;const me=this.d,pe=me.length/3;let Ee=1;for(;Ee<=pe;)if(ue<me[3*Ee])Ee=2*Ee;else if(ue>me[3*Ee+1])Ee=2*Ee+1;else return me[3*Ee+2];return 0}}function be(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function Se(ie,ue){if(ie===0)return 0;const me=Pe(ie,ue);if(me!==void 0)return me;const pe=new G(ue,ie);return pe.prevCodePoint(),pe.offset}e.$he=Se;function Pe(ie,ue){const me=new G(ue,ie);let pe=me.prevCodePoint();for(;Me(pe)||pe===65039||pe===8419;){if(me.offset===0)return;pe=me.prevCodePoint()}if(!M(pe))return;let Ee=me.offset;return Ee>0&&me.prevCodePoint()===8205&&(Ee=me.offset),Ee}function Me(ie){return 127995<=ie&&ie<=127999}var Ae;(function(ie){ie[ie.zwj=8205]="zwj",ie[ie.emojiVariantSelector=65039]="emojiVariantSelector",ie[ie.enclosingKeyCap=8419]="enclosingKeyCap"})(Ae||(Ae={})),e.$ie="\xA0";class Fe{static{this.c=new N.$T(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.d=new L.$kd(ue=>{function me(Ne){const Be=new Map;for(let qe=0;qe<Ne.length;qe+=2)Be.set(Ne[qe],Ne[qe+1]);return Be}function pe(Ne,Be){const qe=new Map(Ne);for(const[Ve,xe]of Be)qe.set(Ve,xe);return qe}function Ee(Ne,Be){if(!Ne)return Be;const qe=new Map;for(const[Ve,xe]of Ne)Be.has(Ve)&&qe.set(Ve,xe);return qe}const Re=this.c.value;let Ce=ue.filter(Ne=>!Ne.startsWith("_")&&Ne in Re);Ce.length===0&&(Ce=["_default"]);let Le;for(const Ne of Ce){const Be=me(Re[Ne]);Le=Ee(Le,Be)}const Oe=me(Re._common),De=pe(Oe,Le);return new Fe(De)})}static getInstance(ue){return Fe.d.get(Array.from(ue))}static{this.e=new N.$T(()=>Object.keys(Fe.c.value).filter(ue=>!ue.startsWith("_")))}static getLocales(){return Fe.e.value}constructor(ue){this.f=ue}isAmbiguous(ue){return this.f.has(ue)}getPrimaryConfusable(ue){return this.f.get(ue)}getConfusableCodePoints(){return new Set(this.f.keys())}}e.$je=Fe;class ze{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this.d=void 0}static e(){return this.d||(this.d=new Set(ze.c())),this.d}static isInvisibleCharacter(ue){return ze.e().has(ue)}static get codePoints(){return ze.e()}}e.$ke=ze}),define(re[51],oe([0,1,28]),function(te,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ti=e.$si=e.$ri=e.$qi=e.$pi=e.$oi=e.$ni=void 0;function N(o){return O(o,0)}e.$ni=N;function O(o,l){switch(typeof o){case"object":return o===null?j(349,l):Array.isArray(o)?k(o,l):m(o,l);case"string":return R(o,l);case"boolean":return A(o,l);case"number":return j(o,l);case"undefined":return j(937,l);default:return j(617,l)}}e.$oi=O;function j(o,l){return(l<<5)-l+o|0}e.$pi=j;function A(o,l){return j(o?433:863,l)}function R(o,l){l=j(149417,l);for(let $=0,b=o.length;$<b;$++)l=j(o.charCodeAt($),l);return l}e.$qi=R;function k(o,l){return l=j(104579,l),o.reduce(($,b)=>O(b,$),l)}function m(o,l){return l=j(181387,l),Object.keys(o).sort().reduce(($,b)=>($=R(b,$),O(o[b],$)),l)}class P{constructor(){this.g=0}get value(){return this.g}hash(l){return this.g=O(l,this.g),this.g}}e.$ri=P;var p;(function(o){o[o.BLOCK_SIZE=64]="BLOCK_SIZE",o[o.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(p||(p={}));function g(o,l,$=32){const b=$-l,I=~((1<<b)-1);return(o<<l|(I&o)>>>b)>>>0}function h(o,l=0,$=o.byteLength,b=0){for(let I=0;I<$;I++)o[l+I]=b}function d(o,l,$="0"){for(;o.length<l;)o=$+o;return o}function w(o,l=32){return o instanceof ArrayBuffer?Array.from(new Uint8Array(o)).map($=>$.toString(16).padStart(2,"0")).join(""):d((o>>>0).toString(16),l/4)}e.$si=w;class f{static{this.g=new DataView(new ArrayBuffer(320))}constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(64+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(l){const $=l.length;if($===0)return;const b=this.p;let I=this.r,t=this.u,c,s;for(t!==0?(c=t,s=-1,t=0):(c=l.charCodeAt(0),s=0);;){let n=c;if(L.$Sd(c))if(s+1<$){const i=l.charCodeAt(s+1);L.$Td(i)?(s++,n=L.$Ud(c,i)):n=65533}else{t=c;break}else L.$Td(c)&&(n=65533);if(I=this.w(b,I,n),s++,s<$)c=l.charCodeAt(s);else break}this.r=I,this.u=t}w(l,$,b){return b<128?l[$++]=b:b<2048?(l[$++]=192|(b&1984)>>>6,l[$++]=128|(b&63)>>>0):b<65536?(l[$++]=224|(b&61440)>>>12,l[$++]=128|(b&4032)>>>6,l[$++]=128|(b&63)>>>0):(l[$++]=240|(b&1835008)>>>18,l[$++]=128|(b&258048)>>>12,l[$++]=128|(b&4032)>>>6,l[$++]=128|(b&63)>>>0),$>=64&&(this.y(),$-=64,this.t+=64,l[0]=l[64+0],l[1]=l[64+1],l[2]=l[64+2]),$}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),w(this.h)+w(this.l)+w(this.m)+w(this.n)+w(this.o)}x(){this.p[this.r++]=128,h(this.p,this.r),this.r>56&&(this.y(),h(this.p));const l=8*this.t;this.q.setUint32(56,Math.floor(l/4294967296),!1),this.q.setUint32(60,l%4294967296,!1),this.y()}y(){const l=f.g,$=this.q;for(let a=0;a<64;a+=4)l.setUint32(a,$.getUint32(a,!1),!1);for(let a=64;a<320;a+=4)l.setUint32(a,g(l.getUint32(a-12,!1)^l.getUint32(a-32,!1)^l.getUint32(a-56,!1)^l.getUint32(a-64,!1),1),!1);let b=this.h,I=this.l,t=this.m,c=this.n,s=this.o,n,i,r;for(let a=0;a<80;a++)a<20?(n=I&t|~I&c,i=1518500249):a<40?(n=I^t^c,i=1859775393):a<60?(n=I&t|I&c|t&c,i=2400959708):(n=I^t^c,i=3395469782),r=g(b,5)+n+s+i+l.getUint32(a*4,!1)&4294967295,s=c,c=t,t=g(I,30),I=b,b=r;this.h=this.h+b&4294967295,this.l=this.l+I&4294967295,this.m=this.m+t&4294967295,this.n=this.n+c&4294967295,this.o=this.o+s&4294967295}}e.$ti=f}),define(re[89],oe([0,1,28]),function(te,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var N;(function(O){O[O.Ignore=0]="Ignore",O[O.Info=1]="Info",O[O.Warning=2]="Warning",O[O.Error=3]="Error"})(N||(N={})),function(O){const j="error",A="warning",R="warn",k="info",m="ignore";function P(g){return g?L.$Od(j,g)?O.Error:L.$Od(A,g)||L.$Od(R,g)?O.Warning:L.$Od(k,g)?O.Info:O.Ignore:O.Ignore}O.fromValue=P;function p(g){switch(g){case O.Error:return j;case O.Warning:return A;case O.Info:return k;default:return m}}O.toString=p}(N||(N={})),e.default=N}),define(re[129],oe([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ec=void 0,e.$ec=Symbol("MicrotaskDelay")}),define(re[47],oe([0,1,20,28]),function(te,e,L,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fh=e.$Eh=e.$Dh=e.$Ch=e.$Bh=void 0;class O{constructor(){this.b="",this.c=0}reset(h){return this.b=h,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(h){const d=h.charCodeAt(0),w=this.b.charCodeAt(this.c);return d-w}value(){return this.b[this.c]}}e.$Bh=O;class j{constructor(h=!0){this.e=h}reset(h){return this.b=h,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let h=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(h)this.c++;else break;else h=!1;return this}cmp(h){return this.e?(0,N.$Id)(h,this.b,0,h.length,this.c,this.d):(0,N.$Kd)(h,this.b,0,h.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$Ch=j;class A{constructor(h=!0,d=!0){this.f=h,this.g=d}reset(h){this.d=0,this.e=0,this.b=h,this.c=h.length;for(let d=h.length-1;d>=0;d--,this.c--){const w=this.b.charCodeAt(d);if(!(w===47||this.f&&w===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let h=!0;for(;this.e<this.c;this.e++){const d=this.b.charCodeAt(this.e);if(d===47||this.f&&d===92)if(h)this.d++;else break;else h=!1}return this}cmp(h){return this.g?(0,N.$Id)(h,this.b,0,h.length,this.d,this.e):(0,N.$Kd)(h,this.b,0,h.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$Dh=A;var R;(function(g){g[g.Scheme=1]="Scheme",g[g.Authority=2]="Authority",g[g.Path=3]="Path",g[g.Query=4]="Query",g[g.Fragment=5]="Fragment"})(R||(R={}));class k{constructor(h,d){this.f=h,this.g=d,this.d=[],this.e=0}reset(h){return this.c=h,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new A(!1,!this.f(h)),this.b.reset(h.path),this.b.value()&&this.d.push(3)),this.g(h)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(h){if(this.d[this.e]===1)return(0,N.$Jd)(h,this.c.scheme);if(this.d[this.e]===2)return(0,N.$Jd)(h,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(h);if(this.d[this.e]===4)return(0,N.$Hd)(h,this.c.query);if(this.d[this.e]===5)return(0,N.$Hd)(h,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.$Eh=k;class m{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const h=this.right;return this.right=h.left,h.left=this,this.updateHeight(),h.updateHeight(),h}rotateRight(){const h=this.left;return this.left=h.right,h.right=this,this.updateHeight(),h.updateHeight(),h}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var P;(function(g){g[g.Left=-1]="Left",g[g.Mid=0]="Mid",g[g.Right=1]="Right"})(P||(P={}));class p{static forUris(h=()=>!1,d=()=>!1){return new p(new k(h,d))}static forPaths(h=!1){return new p(new A(void 0,!h))}static forStrings(){return new p(new O)}static forConfigKeys(){return new p(new j)}constructor(h){this.b=h}clear(){this.c=void 0}fill(h,d){if(d){const w=d.slice(0);(0,L.$Qf)(w);for(const f of w)this.set(f,h)}else{const w=h.slice(0);(0,L.$Qf)(w);for(const f of w)this.set(f[0],f[1])}}set(h,d){const w=this.b.reset(h);let f;this.c||(this.c=new m,this.c.segment=w.value());const o=[];for(f=this.c;;){const $=w.cmp(f.segment);if($>0)f.left||(f.left=new m,f.left.segment=w.value()),o.push([-1,f]),f=f.left;else if($<0)f.right||(f.right=new m,f.right.segment=w.value()),o.push([1,f]),f=f.right;else if(w.hasNext())w.next(),f.mid||(f.mid=new m,f.mid.segment=w.value()),o.push([0,f]),f=f.mid;else break}const l=f.value;f.value=d,f.key=h;for(let $=o.length-1;$>=0;$--){const b=o[$][1];b.updateHeight();const I=b.balanceFactor();if(I<-1||I>1){const t=o[$][0],c=o[$+1][0];if(t===1&&c===1)o[$][1]=b.rotateLeft();else if(t===-1&&c===-1)o[$][1]=b.rotateRight();else if(t===1&&c===-1)b.right=o[$+1][1]=o[$+1][1].rotateRight(),o[$][1]=b.rotateLeft();else if(t===-1&&c===1)b.left=o[$+1][1]=o[$+1][1].rotateLeft(),o[$][1]=b.rotateRight();else throw new Error;if($>0)switch(o[$-1][0]){case-1:o[$-1][1].left=o[$][1];break;case 1:o[$-1][1].right=o[$][1];break;case 0:o[$-1][1].mid=o[$][1];break}else this.c=o[0][1]}}return l}get(h){return this.d(h)?.value}d(h){const d=this.b.reset(h);let w=this.c;for(;w;){const f=d.cmp(w.segment);if(f>0)w=w.left;else if(f<0)w=w.right;else if(d.hasNext())d.next(),w=w.mid;else break}return w}has(h){const d=this.d(h);return!(d?.value===void 0&&d?.mid===void 0)}delete(h){return this.e(h,!1)}deleteSuperstr(h){return this.e(h,!0)}e(h,d){const w=this.b.reset(h),f=[];let o=this.c;for(;o;){const l=w.cmp(o.segment);if(l>0)f.push([-1,o]),o=o.left;else if(l<0)f.push([1,o]),o=o.right;else if(w.hasNext())w.next(),f.push([0,o]),o=o.mid;else break}if(o){if(d?(o.left=void 0,o.mid=void 0,o.right=void 0,o.height=1):(o.key=void 0,o.value=void 0),!o.mid&&!o.value)if(o.left&&o.right){const l=this.f(o.right);if(l.key){const{key:$,value:b,segment:I}=l;this.e(l.key,!1),o.key=$,o.value=b,o.segment=I}}else{const l=o.left??o.right;if(f.length>0){const[$,b]=f[f.length-1];switch($){case-1:b.left=l;break;case 0:b.mid=l;break;case 1:b.right=l;break}}else this.c=l}for(let l=f.length-1;l>=0;l--){const $=f[l][1];$.updateHeight();const b=$.balanceFactor();if(b>1?($.right.balanceFactor()>=0||($.right=$.right.rotateRight()),f[l][1]=$.rotateLeft()):b<-1&&($.left.balanceFactor()<=0||($.left=$.left.rotateLeft()),f[l][1]=$.rotateRight()),l>0)switch(f[l-1][0]){case-1:f[l-1][1].left=f[l][1];break;case 1:f[l-1][1].right=f[l][1];break;case 0:f[l-1][1].mid=f[l][1];break}else this.c=f[0][1]}}}f(h){for(;h.left;)h=h.left;return h}findSubstr(h){const d=this.b.reset(h);let w=this.c,f;for(;w;){const o=d.cmp(w.segment);if(o>0)w=w.left;else if(o<0)w=w.right;else if(d.hasNext())d.next(),f=w.value||f,w=w.mid;else break}return w&&w.value||f}findSuperstr(h){return this.g(h,!1)}g(h,d){const w=this.b.reset(h);let f=this.c;for(;f;){const o=w.cmp(f.segment);if(o>0)f=f.left;else if(o<0)f=f.right;else if(w.hasNext())w.next(),f=f.mid;else return f.mid?this.h(f.mid):d?f.value:void 0}}hasElementOrSubtree(h){return this.g(h,!0)!==void 0}forEach(h){for(const[d,w]of this)h(w,d)}*[Symbol.iterator](){yield*this.h(this.c)}h(h){const d=[];return this.j(h,d),d[Symbol.iterator]()}j(h,d){h&&(h.left&&this.j(h.left,d),h.value&&d.push([h.key,h.value]),h.mid&&this.j(h.mid,d),h.right&&this.j(h.right,d))}_isBalanced(){const h=d=>{if(!d)return!0;const w=d.balanceFactor();return w<-1||w>1?!1:h(d.left)&&h(d.right)};return h(this.c)}}e.$Fh=p}),define(re[9],oe([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ce=e.$Be=e.$Ae=e.$ze=e.$ye=e.$xe=e.$we=e.$ve=e.$ue=e.$te=e.$se=e.$re=e.$qe=e.$pe=e.$oe=e.$ne=e.$me=e.$le=void 0;function L(I){return typeof I=="string"}e.$le=L;function N(I){return Array.isArray(I)&&I.every(t=>L(t))}e.$me=N;function O(I){return typeof I=="object"&&I!==null&&!Array.isArray(I)&&!(I instanceof RegExp)&&!(I instanceof Date)}e.$ne=O;function j(I){const t=Object.getPrototypeOf(Uint8Array);return typeof I=="object"&&I instanceof t}e.$oe=j;function A(I){return typeof I=="number"&&!isNaN(I)}e.$pe=A;function R(I){return!!I&&typeof I[Symbol.iterator]=="function"}e.$qe=R;function k(I){return I===!0||I===!1}e.$re=k;function m(I){return typeof I>"u"}e.$se=m;function P(I){return!p(I)}e.$te=P;function p(I){return m(I)||I===null}e.$ue=p;function g(I,t){if(!I)throw new Error(t?`Unexpected type, expected '${t}'`:"Unexpected type")}e.$ve=g;function h(I){if(p(I))throw new Error("Assertion Failed: argument is undefined or null");return I}e.$we=h;function d(...I){const t=[];for(let c=0;c<I.length;c++){const s=I[c];if(p(s))throw new Error(`Assertion Failed: argument at index ${c} is undefined or null`);t.push(s)}return t}e.$xe=d;const w=Object.prototype.hasOwnProperty;function f(I){if(!O(I))return!1;for(const t in I)if(w.call(I,t))return!1;return!0}e.$ye=f;function o(I){return typeof I=="function"}e.$ze=o;function l(...I){return I.length>0&&I.every(o)}e.$Ae=l;function $(I,t){const c=Math.min(I.length,t.length);for(let s=0;s<c;s++)b(I[s],t[s])}e.$Be=$;function b(I,t){if(L(t)){if(typeof I!==t)throw new Error(`argument does not match constraint: typeof ${t}`)}else if(o(t)){try{if(I instanceof t)return}catch{}if(!p(I)&&I.constructor===t||t.length===1&&t.call(void 0,I)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.$Ce=b}),define(re[30],oe([0,1,9]),function(te,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5m=e.$4m=e.$3m=e.$2m=e.$1m=e.$Zm=e.$Ym=e.$Xm=e.$Wm=e.$Vm=e.$Um=e.$Tm=void 0;function N(o){if(!o||typeof o!="object"||o instanceof RegExp)return o;const l=Array.isArray(o)?[]:{};return Object.entries(o).forEach(([$,b])=>{l[$]=b&&typeof b=="object"?N(b):b}),l}e.$Tm=N;function O(o){if(!o||typeof o!="object")return o;const l=[o];for(;l.length>0;){const $=l.shift();Object.freeze($);for(const b in $)if(j.call($,b)){const I=$[b];typeof I=="object"&&!Object.isFrozen(I)&&!(0,L.$oe)(I)&&l.push(I)}}return o}e.$Um=O;const j=Object.prototype.hasOwnProperty;function A(o,l){return R(o,l,new Set)}e.$Vm=A;function R(o,l,$){if((0,L.$ue)(o))return o;const b=l(o);if(typeof b<"u")return b;if(Array.isArray(o)){const I=[];for(const t of o)I.push(R(t,l,$));return I}if((0,L.$ne)(o)){if($.has(o))throw new Error("Cannot clone recursive data-structure");$.add(o);const I={};for(const t in o)j.call(o,t)&&(I[t]=R(o[t],l,$));return $.delete(o),I}return o}function k(o,l,$=!0){return(0,L.$ne)(o)?((0,L.$ne)(l)&&Object.keys(l).forEach(b=>{b in o?$&&((0,L.$ne)(o[b])&&(0,L.$ne)(l[b])?k(o[b],l[b],$):o[b]=l[b]):o[b]=l[b]}),o):l}e.$Wm=k;function m(o,l){if(o===l)return!0;if(o==null||l===null||l===void 0||typeof o!=typeof l||typeof o!="object"||Array.isArray(o)!==Array.isArray(l))return!1;let $,b;if(Array.isArray(o)){if(o.length!==l.length)return!1;for($=0;$<o.length;$++)if(!m(o[$],l[$]))return!1}else{const I=[];for(b in o)I.push(b);I.sort();const t=[];for(b in l)t.push(b);if(t.sort(),!m(I,t))return!1;for($=0;$<I.length;$++)if(!m(o[I[$]],l[I[$]]))return!1}return!0}e.$Xm=m;function P(o){const l=new Set;return JSON.stringify(o,($,b)=>{if((0,L.$ne)(b)||Array.isArray(b)){if(l.has(b))return"[Circular]";l.add(b)}return b})}e.$Ym=P;function p(o,l){const $=Object.create(null);return!o||!l||Object.keys(l).forEach(I=>{const t=o[I],c=l[I];m(t,c)||($[I]=c)}),$}e.$Zm=p;function g(o,l){const $=l.toLowerCase(),b=Object.keys(o).find(I=>I.toLowerCase()===$);return b?o[b]:o[l]}e.$1m=g;function h(o,l){const $=Object.create(null);for(const[b,I]of Object.entries(o))l(b,I)&&($[b]=I);return $}e.$2m=h;function d(o){let l=[];for(;Object.prototype!==o;)l=l.concat(Object.getOwnPropertyNames(o)),o=Object.getPrototypeOf(o);return l}e.$3m=d;function w(o){const l=[];for(const $ of d(o))typeof o[$]=="function"&&l.push($);return l}e.$4m=w;function f(o,l){const $=I=>function(){const t=Array.prototype.slice.call(arguments,0);return l(I,t)},b={};for(const I of o)b[I]=$(I);return b}e.$5m=f}),define(re[32],oe([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6e=e.$5e=void 0;const L=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function N(O){return L.test(O)}e.$5e=N,e.$6e=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let O;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?O=crypto.getRandomValues.bind(crypto):O=function(R){for(let k=0;k<R.length;k++)R[k]=Math.floor(Math.random()*256);return R};const j=new Uint8Array(16),A=[];for(let R=0;R<256;R++)A.push(R.toString(16).padStart(2,"0"));return function(){O(j),j[6]=j[6]&15|64,j[8]=j[8]&63|128;let k=0,m="";return m+=A[j[k++]],m+=A[j[k++]],m+=A[j[k++]],m+=A[j[k++]],m+="-",m+=A[j[k++]],m+=A[j[k++]],m+="-",m+=A[j[k++]],m+=A[j[k++]],m+="-",m+=A[j[k++]],m+=A[j[k++]],m+="-",m+=A[j[k++]],m+=A[j[k++]],m+=A[j[k++]],m+=A[j[k++]],m+=A[j[k++]],m+=A[j[k++]],m}}()}),define(re[130],oe([0,1,36]),function(te,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Em=void 0;const N=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function O(A){const R=A.replace(/\-/g,":").toLowerCase();return!N.has(R)}function j(){const A=(0,L.networkInterfaces)();for(const R in A){const k=A[R];if(k){for(const{mac:m}of k)if(O(m))return m}}throw new Error("Unable to retrieve mac address (unexpected format)")}e.$Em=j}),define(re[131],oe([0,1,36,47,32,130]),function(te,e,L,N,O,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gm=e.$Fm=void 0,e.$Fm=new class{c(m){return this.a||(this.a=N.$Fh.forStrings(),this.a.set("00-50-56",!0),this.a.set("00-0C-29",!0),this.a.set("00-05-69",!0),this.a.set("00-03-FF",!0),this.a.set("00-1C-42",!0),this.a.set("00-16-3E",!0),this.a.set("08-00-27",!0),this.a.set("00:50:56",!0),this.a.set("00:0C:29",!0),this.a.set("00:05:69",!0),this.a.set("00:03:FF",!0),this.a.set("00:1C:42",!0),this.a.set("00:16:3E",!0),this.a.set("08:00:27",!0)),!!this.a.findSubstr(m)}value(){if(this.b===void 0){let m=0,P=0;const p=(0,L.networkInterfaces)();for(const g in p){const h=p[g];if(h)for(const{mac:d,internal:w}of h)w||(P+=1,this.c(d.toUpperCase())&&(m+=1))}this.b=P>0?m/P:0}return this.b}};let A;async function R(m){return A||(A=(async()=>await k(m)||O.$6e())()),A}e.$Gm=R;async function k(m){try{const P=await new Promise((g,h)=>{te(["crypto"],g,h)}),p=(0,j.$Em)();return P.createHash("sha256").update(p,"utf8").digest("hex")}catch(P){m(P);return}}}),define(re[132],oe([0,1,267,14]),function(te,e,L,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$DS=void 0;class O extends L.Transform{constructor(A){if(super(),typeof A=="number")this.b=A,this.c=1;else{const R=Buffer.isBuffer(A)?A:Buffer.from(A);this.b=R.length===1?R[0]:R,this.c=R.length}}_transform(A,R,k){this.a?this.a=Buffer.concat([this.a,A]):this.a=A;let m=0;for(;m<this.a.length;){const P=typeof this.b=="number"?this.a.indexOf(this.b,m):(0,N.$Ic)(this.a,this.b,m);if(P===-1)break;this.push(this.a.slice(m,P+this.c)),m=P+this.c}this.a=m===this.a.length?void 0:this.a.slice(m),k()}_flush(A){this.a&&this.push(this.a),A()}}e.$DS=O}),define(re[133],oe([0,1,61]),function(te,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0e=e.$9e=e.$8e=void 0;function N(R,k,m,P=1){let p=!1;return new Promise(g=>{const h=setTimeout(()=>{if(!p)return p=!0,g(0)},m);O(R,k,P,d=>{if(!p)return p=!0,clearTimeout(h),g(d)})})}e.$8e=N;function O(R,k,m,P){if(k===0)return P(0);const p=new L.Socket;p.once("connect",()=>(A(p),O(R+m,k-1,m,P))),p.once("data",()=>{}),p.once("error",g=>(A(p),g.code!=="ECONNREFUSED"?O(R+m,k-1,m,P):P(R))),p.connect(R,"127.0.0.1")}e.$9e={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function j(R,k,m,P="127.0.0.1"){let p=!1,g,h=1;const d=L.createServer({pauseOnConnect:!0});function w(f,o){p||(p=!0,d.removeAllListeners(),d.close(),g&&clearTimeout(g),o(f))}return new Promise(f=>{g=setTimeout(()=>{w(0,f)},m),d.on("listening",()=>{w(R,f)}),d.on("error",o=>{o&&(o.code==="EADDRINUSE"||o.code==="EACCES")&&h<k?(R++,h++,d.listen(R,P)):w(0,f)}),d.on("close",()=>{w(0,f)}),d.listen(R,P)})}e.$0e=j;function A(R){try{R.removeAllListeners("connect"),R.removeAllListeners("error"),R.end(),R.destroy(),R.unref()}catch(k){console.error(k)}}}),define(re[134],oe([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$TS=void 0;function L(N){return!!N.parentPort}e.$TS=L}),define(re[135],oe([12,10]),function(te,e){return te.create("vs/base/common/date",e)}),define(re[62],oe([0,1,135]),function(te,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5l=e.$4l=void 0;const N=60,O=N*60,j=O*24,A=j*7,R=j*30,k=j*365;function m(p,g,h,d){typeof p!="number"&&(p=p.getTime());const w=Math.round((new Date().getTime()-p)/1e3);if(w<-30)return(0,L.localize)(0,null,m(new Date().getTime()+w*1e3,!1));if(!d&&w<30)return(0,L.localize)(1,null);let f;return w<N?(f=w,g?f===1?h?(0,L.localize)(2,null,f):(0,L.localize)(3,null,f):h?(0,L.localize)(4,null,f):(0,L.localize)(5,null,f):f===1?h?(0,L.localize)(6,null,f):(0,L.localize)(7,null,f):h?(0,L.localize)(8,null,f):(0,L.localize)(9,null,f)):w<O?(f=Math.floor(w/N),g?f===1?h?(0,L.localize)(10,null,f):(0,L.localize)(11,null,f):h?(0,L.localize)(12,null,f):(0,L.localize)(13,null,f):f===1?h?(0,L.localize)(14,null,f):(0,L.localize)(15,null,f):h?(0,L.localize)(16,null,f):(0,L.localize)(17,null,f)):w<j?(f=Math.floor(w/O),g?f===1?h?(0,L.localize)(18,null,f):(0,L.localize)(19,null,f):h?(0,L.localize)(20,null,f):(0,L.localize)(21,null,f):f===1?h?(0,L.localize)(22,null,f):(0,L.localize)(23,null,f):h?(0,L.localize)(24,null,f):(0,L.localize)(25,null,f)):w<A?(f=Math.floor(w/j),g?f===1?(0,L.localize)(26,null,f):(0,L.localize)(27,null,f):f===1?(0,L.localize)(28,null,f):(0,L.localize)(29,null,f)):w<R?(f=Math.floor(w/A),g?f===1?h?(0,L.localize)(30,null,f):(0,L.localize)(31,null,f):h?(0,L.localize)(32,null,f):(0,L.localize)(33,null,f):f===1?h?(0,L.localize)(34,null,f):(0,L.localize)(35,null,f):h?(0,L.localize)(36,null,f):(0,L.localize)(37,null,f)):w<k?(f=Math.floor(w/R),g?f===1?h?(0,L.localize)(38,null,f):(0,L.localize)(39,null,f):h?(0,L.localize)(40,null,f):(0,L.localize)(41,null,f):f===1?h?(0,L.localize)(42,null,f):(0,L.localize)(43,null,f):h?(0,L.localize)(44,null,f):(0,L.localize)(45,null,f)):(f=Math.floor(w/k),g?f===1?h?(0,L.localize)(46,null,f):(0,L.localize)(47,null,f):h?(0,L.localize)(48,null,f):(0,L.localize)(49,null,f):f===1?h?(0,L.localize)(50,null,f):(0,L.localize)(51,null,f):h?(0,L.localize)(52,null,f):(0,L.localize)(53,null,f))}e.$4l=m;function P(p){return p.getFullYear()+"-"+String(p.getMonth()+1).padStart(2,"0")+"-"+String(p.getDate()).padStart(2,"0")+"T"+String(p.getHours()).padStart(2,"0")+":"+String(p.getMinutes()).padStart(2,"0")+":"+String(p.getSeconds()).padStart(2,"0")+"."+(p.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.$5l=P}),define(re[136],oe([12,10]),function(te,e){return te.create("vs/base/common/errorMessage",e)}),define(re[38],oe([0,1,20,9,136]),function(te,e,L,N,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mi=e.$li=e.$ki=void 0;function j(p,g){return g&&(p.stack||p.stacktrace)?O.localize(0,null,R(p),A(p.stack)||A(p.stacktrace)):R(p)}function A(p){return Array.isArray(p)?p.join(`
`):p}function R(p){return p.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${p.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof p.code=="string"&&typeof p.errno=="number"&&typeof p.syscall=="string"?O.localize(1,null,p.message):p.message||O.localize(2,null)}function k(p=null,g=!1){if(!p)return O.localize(3,null);if(Array.isArray(p)){const h=L.$Af(p),d=k(h[0],g);return h.length>1?O.localize(4,null,d,h.length):d}if(N.$le(p))return p;if(p.detail){const h=p.detail;if(h.error)return j(h.error,g);if(h.exception)return j(h.exception,g)}return p.stack?j(p,g):p.message?p.message:O.localize(5,null)}e.$ki=k;function m(p){const g=p;return g instanceof Error&&Array.isArray(g.actions)}e.$li=m;function P(p,g){let h;return typeof p=="string"?h=new Error(p):h=p,h.actions=g,h}e.$mi=P}),define(re[137],oe([12,10]),function(te,e){return te.create("vs/base/common/jsonErrorMessages",e)}),define(re[138],oe([0,1,137]),function(te,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jp=void 0;function N(O){switch(O){case 1:return(0,L.localize)(0,null);case 2:return(0,L.localize)(1,null);case 3:return(0,L.localize)(2,null);case 4:return(0,L.localize)(3,null);case 5:return(0,L.localize)(4,null);case 6:return(0,L.localize)(5,null);case 7:return(0,L.localize)(6,null);case 8:return(0,L.localize)(7,null);case 9:return(0,L.localize)(8,null);default:return""}}e.$jp=N}),define(re[139],oe([12,10]),function(te,e){return te.create("vs/base/common/platform",e)}),define(re[6],oe([0,1,139]),function(te,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$H=e.$G=e.$F=e.$E=e.$D=e.$C=e.OS=e.OperatingSystem=e.$A=e.$z=e.$y=e.$x=e.$w=e.Language=e.$v=e.$u=e.$t=e.$s=e.$r=e.$q=e.$p=e.$o=e.$n=e.$m=e.$l=e.$k=e.$j=e.$i=e.$h=e.Platform=e.$g=e.$f=void 0,e.$f="en";let N=!1,O=!1,j=!1,A=!1,R=!1,k=!1,m=!1,P=!1,p=!1,g=!1,h,d=e.$f,w=e.$f,f,o;e.$g=typeof self=="object"?self:typeof global=="object"?global:{};let l;typeof e.$g.vscode<"u"&&typeof e.$g.vscode.process<"u"?l=e.$g.vscode.process:typeof process<"u"&&(l=process);const $=typeof l?.versions?.electron=="string",b=$&&l?.type==="renderer";if(typeof navigator=="object"&&!b)o=navigator.userAgent,N=o.indexOf("Windows")>=0,O=o.indexOf("Macintosh")>=0,P=(o.indexOf("Macintosh")>=0||o.indexOf("iPad")>=0||o.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,j=o.indexOf("Linux")>=0,g=o?.indexOf("Mobi")>=0,k=!0,h=L.getConfiguredDefaultLocale(L.localize(0,null))||e.$f,d=h,w=navigator.language;else if(typeof l=="object"){N=l.platform==="win32",O=l.platform==="darwin",j=l.platform==="linux",A=j&&!!l.env.SNAP&&!!l.env.SNAP_REVISION,m=$,p=!!l.env.CI||!!l.env.BUILD_ARTIFACTSTAGINGDIRECTORY,h=e.$f,d=e.$f;const v=l.env.VSCODE_NLS_CONFIG;if(v)try{const y=JSON.parse(v),u=y.availableLanguages["*"];h=y.locale,w=y.osLocale,d=u||e.$f,f=y._translationsConfigFile}catch{}R=!0}else console.error("Unable to resolve platform.");var I;(function(v){v[v.Web=0]="Web",v[v.Mac=1]="Mac",v[v.Linux=2]="Linux",v[v.Windows=3]="Windows"})(I||(e.Platform=I={}));function t(v){switch(v){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.$h=t;let c=0;O?c=1:N?c=3:j&&(c=2),e.$i=N,e.$j=O,e.$k=j,e.$l=A,e.$m=R,e.$n=m,e.$o=k,e.$p=k&&typeof e.$g.importScripts=="function",e.$q=P,e.$r=g,e.$s=p,e.$t=c,e.$u=o,e.$v=d;var s;(function(v){function y(){return e.$v}v.value=y;function u(){return e.$v.length===2?e.$v==="en":e.$v.length>=3?e.$v[0]==="e"&&e.$v[1]==="n"&&e.$v[2]==="-":!1}v.isDefaultVariant=u;function E(){return e.$v==="en"}v.isDefault=E})(s||(e.Language=s={})),e.$w=h,e.$x=w,e.$y=f,e.$z=typeof e.$g.postMessage=="function"&&!e.$g.importScripts,e.$A=(()=>{if(e.$z){const v=[];e.$g.addEventListener("message",u=>{if(u.data&&u.data.vscodeScheduleAsyncWork)for(let E=0,D=v.length;E<D;E++){const T=v[E];if(T.id===u.data.vscodeScheduleAsyncWork){v.splice(E,1),T.callback();return}}});let y=0;return u=>{const E=++y;v.push({id:E,callback:u}),e.$g.postMessage({vscodeScheduleAsyncWork:E},"*")}}return v=>setTimeout(v)})();var n;(function(v){v[v.Windows=1]="Windows",v[v.Macintosh=2]="Macintosh",v[v.Linux=3]="Linux"})(n||(e.OperatingSystem=n={})),e.OS=O||P?2:N?1:3;let i=!0,r=!1;function a(){if(!r){r=!0;const v=new Uint8Array(2);v[0]=1,v[1]=2,i=new Uint16Array(v.buffer)[0]===(2<<8)+1}return i}e.$C=a,e.$D=!!(e.$u&&e.$u.indexOf("Chrome")>=0),e.$E=!!(e.$u&&e.$u.indexOf("Firefox")>=0),e.$F=!!(!e.$D&&e.$u&&e.$u.indexOf("Safari")>=0),e.$G=!!(e.$u&&e.$u.indexOf("Edg/")>=0),e.$H=!!(e.$u&&e.$u.indexOf("Android")>=0)}),define(re[37],oe([0,1,6]),function(te,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6c=e.$5c=e.env=e.cwd=void 0;let N;if(typeof L.$g.vscode<"u"&&typeof L.$g.vscode.process<"u"){const O=L.$g.vscode.process;N={get platform(){return O.platform},get arch(){return O.arch},get env(){return O.env},cwd(){return O.cwd()}}}else typeof process<"u"?N={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:N={get platform(){return L.$i?"win32":L.$j?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=N.cwd,e.env=N.env,e.$5c=N.platform,e.$6c=N.arch}),define(re[15],oe([0,1,37]),function(te,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$id=e.sep=e.$gd=e.$fd=e.$ed=e.$dd=e.$cd=e.$bd=e.$ad=e.$_c=e.$$c=e.$0c=e.$9c=e.$8c=e.$7c=void 0;const N=65,O=97,j=90,A=122,R=46,k=47,m=92,P=58,p=63;class g extends Error{constructor(c,s,n){let i;typeof s=="string"&&s.indexOf("not ")===0?(i="must not be",s=s.replace(/^not /,"")):i="must be";const r=c.indexOf(".")!==-1?"property":"argument";let a=`The "${c}" ${r} ${i} of type ${s}`;a+=`. Received type ${typeof n}`,super(a),this.code="ERR_INVALID_ARG_TYPE"}}function h(t,c){if(t===null||typeof t!="object")throw new g(c,"Object",t)}function d(t,c){if(typeof t!="string")throw new g(c,"string",t)}const w=L.$5c==="win32";function f(t){return t===k||t===m}function o(t){return t===k}function l(t){return t>=N&&t<=j||t>=O&&t<=A}function $(t,c,s,n){let i="",r=0,a=-1,v=0,y=0;for(let u=0;u<=t.length;++u){if(u<t.length)y=t.charCodeAt(u);else{if(n(y))break;y=k}if(n(y)){if(!(a===u-1||v===1))if(v===2){if(i.length<2||r!==2||i.charCodeAt(i.length-1)!==R||i.charCodeAt(i.length-2)!==R){if(i.length>2){const E=i.lastIndexOf(s);E===-1?(i="",r=0):(i=i.slice(0,E),r=i.length-1-i.lastIndexOf(s)),a=u,v=0;continue}else if(i.length!==0){i="",r=0,a=u,v=0;continue}}c&&(i+=i.length>0?`${s}..`:"..",r=2)}else i.length>0?i+=`${s}${t.slice(a+1,u)}`:i=t.slice(a+1,u),r=u-a-1;a=u,v=0}else y===R&&v!==-1?++v:v=-1}return i}function b(t,c){h(c,"pathObject");const s=c.dir||c.root,n=c.base||`${c.name||""}${c.ext||""}`;return s?s===c.root?`${s}${n}`:`${s}${t}${n}`:n}e.$7c={resolve(...t){let c="",s="",n=!1;for(let i=t.length-1;i>=-1;i--){let r;if(i>=0){if(r=t[i],d(r,"path"),r.length===0)continue}else c.length===0?r=L.cwd():(r=L.env[`=${c}`]||L.cwd(),(r===void 0||r.slice(0,2).toLowerCase()!==c.toLowerCase()&&r.charCodeAt(2)===m)&&(r=`${c}\\`));const a=r.length;let v=0,y="",u=!1;const E=r.charCodeAt(0);if(a===1)f(E)&&(v=1,u=!0);else if(f(E))if(u=!0,f(r.charCodeAt(1))){let D=2,T=D;for(;D<a&&!f(r.charCodeAt(D));)D++;if(D<a&&D!==T){const F=r.slice(T,D);for(T=D;D<a&&f(r.charCodeAt(D));)D++;if(D<a&&D!==T){for(T=D;D<a&&!f(r.charCodeAt(D));)D++;(D===a||D!==T)&&(y=`\\\\${F}\\${r.slice(T,D)}`,v=D)}}}else v=1;else l(E)&&r.charCodeAt(1)===P&&(y=r.slice(0,2),v=2,a>2&&f(r.charCodeAt(2))&&(u=!0,v=3));if(y.length>0)if(c.length>0){if(y.toLowerCase()!==c.toLowerCase())continue}else c=y;if(n){if(c.length>0)break}else if(s=`${r.slice(v)}\\${s}`,n=u,u&&c.length>0)break}return s=$(s,!n,"\\",f),n?`${c}\\${s}`:`${c}${s}`||"."},normalize(t){d(t,"path");const c=t.length;if(c===0)return".";let s=0,n,i=!1;const r=t.charCodeAt(0);if(c===1)return o(r)?"\\":t;if(f(r))if(i=!0,f(t.charCodeAt(1))){let v=2,y=v;for(;v<c&&!f(t.charCodeAt(v));)v++;if(v<c&&v!==y){const u=t.slice(y,v);for(y=v;v<c&&f(t.charCodeAt(v));)v++;if(v<c&&v!==y){for(y=v;v<c&&!f(t.charCodeAt(v));)v++;if(v===c)return`\\\\${u}\\${t.slice(y)}\\`;v!==y&&(n=`\\\\${u}\\${t.slice(y,v)}`,s=v)}}}else s=1;else l(r)&&t.charCodeAt(1)===P&&(n=t.slice(0,2),s=2,c>2&&f(t.charCodeAt(2))&&(i=!0,s=3));let a=s<c?$(t.slice(s),!i,"\\",f):"";return a.length===0&&!i&&(a="."),a.length>0&&f(t.charCodeAt(c-1))&&(a+="\\"),n===void 0?i?`\\${a}`:a:i?`${n}\\${a}`:`${n}${a}`},isAbsolute(t){d(t,"path");const c=t.length;if(c===0)return!1;const s=t.charCodeAt(0);return f(s)||c>2&&l(s)&&t.charCodeAt(1)===P&&f(t.charCodeAt(2))},join(...t){if(t.length===0)return".";let c,s;for(let r=0;r<t.length;++r){const a=t[r];d(a,"path"),a.length>0&&(c===void 0?c=s=a:c+=`\\${a}`)}if(c===void 0)return".";let n=!0,i=0;if(typeof s=="string"&&f(s.charCodeAt(0))){++i;const r=s.length;r>1&&f(s.charCodeAt(1))&&(++i,r>2&&(f(s.charCodeAt(2))?++i:n=!1))}if(n){for(;i<c.length&&f(c.charCodeAt(i));)i++;i>=2&&(c=`\\${c.slice(i)}`)}return e.$7c.normalize(c)},relative(t,c){if(d(t,"from"),d(c,"to"),t===c)return"";const s=e.$7c.resolve(t),n=e.$7c.resolve(c);if(s===n||(t=s.toLowerCase(),c=n.toLowerCase(),t===c))return"";let i=0;for(;i<t.length&&t.charCodeAt(i)===m;)i++;let r=t.length;for(;r-1>i&&t.charCodeAt(r-1)===m;)r--;const a=r-i;let v=0;for(;v<c.length&&c.charCodeAt(v)===m;)v++;let y=c.length;for(;y-1>v&&c.charCodeAt(y-1)===m;)y--;const u=y-v,E=a<u?a:u;let D=-1,T=0;for(;T<E;T++){const q=t.charCodeAt(i+T);if(q!==c.charCodeAt(v+T))break;q===m&&(D=T)}if(T!==E){if(D===-1)return n}else{if(u>E){if(c.charCodeAt(v+T)===m)return n.slice(v+T+1);if(T===2)return n.slice(v+T)}a>E&&(t.charCodeAt(i+T)===m?D=T:T===2&&(D=3)),D===-1&&(D=0)}let F="";for(T=i+D+1;T<=r;++T)(T===r||t.charCodeAt(T)===m)&&(F+=F.length===0?"..":"\\..");return v+=D,F.length>0?`${F}${n.slice(v,y)}`:(n.charCodeAt(v)===m&&++v,n.slice(v,y))},toNamespacedPath(t){if(typeof t!="string"||t.length===0)return t;const c=e.$7c.resolve(t);if(c.length<=2)return t;if(c.charCodeAt(0)===m){if(c.charCodeAt(1)===m){const s=c.charCodeAt(2);if(s!==p&&s!==R)return`\\\\?\\UNC\\${c.slice(2)}`}}else if(l(c.charCodeAt(0))&&c.charCodeAt(1)===P&&c.charCodeAt(2)===m)return`\\\\?\\${c}`;return t},dirname(t){d(t,"path");const c=t.length;if(c===0)return".";let s=-1,n=0;const i=t.charCodeAt(0);if(c===1)return f(i)?t:".";if(f(i)){if(s=n=1,f(t.charCodeAt(1))){let v=2,y=v;for(;v<c&&!f(t.charCodeAt(v));)v++;if(v<c&&v!==y){for(y=v;v<c&&f(t.charCodeAt(v));)v++;if(v<c&&v!==y){for(y=v;v<c&&!f(t.charCodeAt(v));)v++;if(v===c)return t;v!==y&&(s=n=v+1)}}}}else l(i)&&t.charCodeAt(1)===P&&(s=c>2&&f(t.charCodeAt(2))?3:2,n=s);let r=-1,a=!0;for(let v=c-1;v>=n;--v)if(f(t.charCodeAt(v))){if(!a){r=v;break}}else a=!1;if(r===-1){if(s===-1)return".";r=s}return t.slice(0,r)},basename(t,c){c!==void 0&&d(c,"ext"),d(t,"path");let s=0,n=-1,i=!0,r;if(t.length>=2&&l(t.charCodeAt(0))&&t.charCodeAt(1)===P&&(s=2),c!==void 0&&c.length>0&&c.length<=t.length){if(c===t)return"";let a=c.length-1,v=-1;for(r=t.length-1;r>=s;--r){const y=t.charCodeAt(r);if(f(y)){if(!i){s=r+1;break}}else v===-1&&(i=!1,v=r+1),a>=0&&(y===c.charCodeAt(a)?--a===-1&&(n=r):(a=-1,n=v))}return s===n?n=v:n===-1&&(n=t.length),t.slice(s,n)}for(r=t.length-1;r>=s;--r)if(f(t.charCodeAt(r))){if(!i){s=r+1;break}}else n===-1&&(i=!1,n=r+1);return n===-1?"":t.slice(s,n)},extname(t){d(t,"path");let c=0,s=-1,n=0,i=-1,r=!0,a=0;t.length>=2&&t.charCodeAt(1)===P&&l(t.charCodeAt(0))&&(c=n=2);for(let v=t.length-1;v>=c;--v){const y=t.charCodeAt(v);if(f(y)){if(!r){n=v+1;break}continue}i===-1&&(r=!1,i=v+1),y===R?s===-1?s=v:a!==1&&(a=1):s!==-1&&(a=-1)}return s===-1||i===-1||a===0||a===1&&s===i-1&&s===n+1?"":t.slice(s,i)},format:b.bind(null,"\\"),parse(t){d(t,"path");const c={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return c;const s=t.length;let n=0,i=t.charCodeAt(0);if(s===1)return f(i)?(c.root=c.dir=t,c):(c.base=c.name=t,c);if(f(i)){if(n=1,f(t.charCodeAt(1))){let D=2,T=D;for(;D<s&&!f(t.charCodeAt(D));)D++;if(D<s&&D!==T){for(T=D;D<s&&f(t.charCodeAt(D));)D++;if(D<s&&D!==T){for(T=D;D<s&&!f(t.charCodeAt(D));)D++;D===s?n=D:D!==T&&(n=D+1)}}}}else if(l(i)&&t.charCodeAt(1)===P){if(s<=2)return c.root=c.dir=t,c;if(n=2,f(t.charCodeAt(2))){if(s===3)return c.root=c.dir=t,c;n=3}}n>0&&(c.root=t.slice(0,n));let r=-1,a=n,v=-1,y=!0,u=t.length-1,E=0;for(;u>=n;--u){if(i=t.charCodeAt(u),f(i)){if(!y){a=u+1;break}continue}v===-1&&(y=!1,v=u+1),i===R?r===-1?r=u:E!==1&&(E=1):r!==-1&&(E=-1)}return v!==-1&&(r===-1||E===0||E===1&&r===v-1&&r===a+1?c.base=c.name=t.slice(a,v):(c.name=t.slice(a,r),c.base=t.slice(a,v),c.ext=t.slice(r,v))),a>0&&a!==n?c.dir=t.slice(0,a-1):c.dir=c.root,c},sep:"\\",delimiter:";",win32:null,posix:null};const I=(()=>{if(w){const t=/\\/g;return()=>{const c=L.cwd().replace(t,"/");return c.slice(c.indexOf("/"))}}return()=>L.cwd()})();e.$8c={resolve(...t){let c="",s=!1;for(let n=t.length-1;n>=-1&&!s;n--){const i=n>=0?t[n]:I();d(i,"path"),i.length!==0&&(c=`${i}/${c}`,s=i.charCodeAt(0)===k)}return c=$(c,!s,"/",o),s?`/${c}`:c.length>0?c:"."},normalize(t){if(d(t,"path"),t.length===0)return".";const c=t.charCodeAt(0)===k,s=t.charCodeAt(t.length-1)===k;return t=$(t,!c,"/",o),t.length===0?c?"/":s?"./":".":(s&&(t+="/"),c?`/${t}`:t)},isAbsolute(t){return d(t,"path"),t.length>0&&t.charCodeAt(0)===k},join(...t){if(t.length===0)return".";let c;for(let s=0;s<t.length;++s){const n=t[s];d(n,"path"),n.length>0&&(c===void 0?c=n:c+=`/${n}`)}return c===void 0?".":e.$8c.normalize(c)},relative(t,c){if(d(t,"from"),d(c,"to"),t===c||(t=e.$8c.resolve(t),c=e.$8c.resolve(c),t===c))return"";const s=1,n=t.length,i=n-s,r=1,a=c.length-r,v=i<a?i:a;let y=-1,u=0;for(;u<v;u++){const D=t.charCodeAt(s+u);if(D!==c.charCodeAt(r+u))break;D===k&&(y=u)}if(u===v)if(a>v){if(c.charCodeAt(r+u)===k)return c.slice(r+u+1);if(u===0)return c.slice(r+u)}else i>v&&(t.charCodeAt(s+u)===k?y=u:u===0&&(y=0));let E="";for(u=s+y+1;u<=n;++u)(u===n||t.charCodeAt(u)===k)&&(E+=E.length===0?"..":"/..");return`${E}${c.slice(r+y)}`},toNamespacedPath(t){return t},dirname(t){if(d(t,"path"),t.length===0)return".";const c=t.charCodeAt(0)===k;let s=-1,n=!0;for(let i=t.length-1;i>=1;--i)if(t.charCodeAt(i)===k){if(!n){s=i;break}}else n=!1;return s===-1?c?"/":".":c&&s===1?"//":t.slice(0,s)},basename(t,c){c!==void 0&&d(c,"ext"),d(t,"path");let s=0,n=-1,i=!0,r;if(c!==void 0&&c.length>0&&c.length<=t.length){if(c===t)return"";let a=c.length-1,v=-1;for(r=t.length-1;r>=0;--r){const y=t.charCodeAt(r);if(y===k){if(!i){s=r+1;break}}else v===-1&&(i=!1,v=r+1),a>=0&&(y===c.charCodeAt(a)?--a===-1&&(n=r):(a=-1,n=v))}return s===n?n=v:n===-1&&(n=t.length),t.slice(s,n)}for(r=t.length-1;r>=0;--r)if(t.charCodeAt(r)===k){if(!i){s=r+1;break}}else n===-1&&(i=!1,n=r+1);return n===-1?"":t.slice(s,n)},extname(t){d(t,"path");let c=-1,s=0,n=-1,i=!0,r=0;for(let a=t.length-1;a>=0;--a){const v=t.charCodeAt(a);if(v===k){if(!i){s=a+1;break}continue}n===-1&&(i=!1,n=a+1),v===R?c===-1?c=a:r!==1&&(r=1):c!==-1&&(r=-1)}return c===-1||n===-1||r===0||r===1&&c===n-1&&c===s+1?"":t.slice(c,n)},format:b.bind(null,"/"),parse(t){d(t,"path");const c={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return c;const s=t.charCodeAt(0)===k;let n;s?(c.root="/",n=1):n=0;let i=-1,r=0,a=-1,v=!0,y=t.length-1,u=0;for(;y>=n;--y){const E=t.charCodeAt(y);if(E===k){if(!v){r=y+1;break}continue}a===-1&&(v=!1,a=y+1),E===R?i===-1?i=y:u!==1&&(u=1):i!==-1&&(u=-1)}if(a!==-1){const E=r===0&&s?1:r;i===-1||u===0||u===1&&i===a-1&&i===r+1?c.base=c.name=t.slice(E,a):(c.name=t.slice(E,i),c.base=t.slice(E,a),c.ext=t.slice(i,a))}return r>0?c.dir=t.slice(0,r-1):s&&(c.dir="/"),c},sep:"/",delimiter:":",win32:null,posix:null},e.$8c.win32=e.$7c.win32=e.$7c,e.$8c.posix=e.$7c.posix=e.$8c,e.$9c=w?e.$7c.normalize:e.$8c.normalize,e.$0c=w?e.$7c.isAbsolute:e.$8c.isAbsolute,e.$$c=w?e.$7c.join:e.$8c.join,e.$_c=w?e.$7c.resolve:e.$8c.resolve,e.$ad=w?e.$7c.relative:e.$8c.relative,e.$bd=w?e.$7c.dirname:e.$8c.dirname,e.$cd=w?e.$7c.basename:e.$8c.basename,e.$dd=w?e.$7c.extname:e.$8c.extname,e.$ed=w?e.$7c.format:e.$8c.format,e.$fd=w?e.$7c.parse:e.$8c.parse,e.$gd=w?e.$7c.toNamespacedPath:e.$8c.toNamespacedPath,e.sep=w?e.$7c.sep:e.$8c.sep,e.$id=w?e.$7c.delimiter:e.$8c.delimiter}),define(re[48],oe([0,1,15,6,28,9]),function(te,e,L,N,O,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Se=e.$Re=e.$Qe=e.$Pe=e.$Oe=e.$Ne=e.$Me=e.$Le=e.$Ke=e.$Je=e.$Ie=e.$He=e.$Ge=e.$Fe=e.$Ee=e.$De=void 0;function A(r){return r===47||r===92}e.$De=A;function R(r){return r.replace(/[\\/]/g,L.$8c.sep)}e.$Ee=R;function k(r){return r.indexOf("/")===-1&&(r=R(r)),/^[a-zA-Z]:(\/|$)/.test(r)&&(r="/"+r),r}e.$Fe=k;function m(r,a=L.$8c.sep){if(!r)return"";const v=r.length,y=r.charCodeAt(0);if(A(y)){if(A(r.charCodeAt(1))&&!A(r.charCodeAt(2))){let E=3;const D=E;for(;E<v&&!A(r.charCodeAt(E));E++);if(D!==E&&!A(r.charCodeAt(E+1))){for(E+=1;E<v;E++)if(A(r.charCodeAt(E)))return r.slice(0,E+1).replace(/[\\/]/g,a)}}return a}else if(o(y)&&r.charCodeAt(1)===58)return A(r.charCodeAt(2))?r.slice(0,2)+a:r.slice(0,2);let u=r.indexOf("://");if(u!==-1){for(u+=3;u<v;u++)if(A(r.charCodeAt(u)))return r.slice(0,u+1)}return""}e.$Ge=m;function P(r){if(!N.$i||!r||r.length<5)return!1;let a=r.charCodeAt(0);if(a!==92||(a=r.charCodeAt(1),a!==92))return!1;let v=2;const y=v;for(;v<r.length&&(a=r.charCodeAt(v),a!==92);v++);return!(y===v||(a=r.charCodeAt(v+1),isNaN(a)||a===92))}e.$He=P;const p=/[\\/:\*\?"<>\|]/g,g=/[\\/]/g,h=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function d(r,a=N.$i){const v=a?p:g;return!(!r||r.length===0||/^\s+$/.test(r)||(v.lastIndex=0,v.test(r))||a&&h.test(r)||r==="."||r===".."||a&&r[r.length-1]==="."||a&&r.length!==r.trim().length||r.length>255)}e.$Ie=d;function w(r,a,v){const y=r===a;return!v||y?y:!r||!a?!1:(0,O.$Od)(r,a)}e.$Je=w;function f(r,a,v,y=L.sep){if(r===a)return!0;if(!r||!a||a.length>r.length)return!1;if(v){if(!(0,O.$Pd)(r,a))return!1;if(a.length===r.length)return!0;let E=a.length;return a.charAt(a.length-1)===y&&E--,r.charAt(E)===y}return a.charAt(a.length-1)!==y&&(a+=y),r.indexOf(a)===0}e.$Ke=f;function o(r){return r>=65&&r<=90||r>=97&&r<=122}e.$Le=o;function l(r,a){return N.$i&&r.endsWith(":")&&(r+=L.sep),(0,L.$0c)(r)||(r=(0,L.$$c)(a,r)),r=(0,L.$9c)(r),N.$i?(r=(0,O.$xd)(r,L.sep),r.endsWith(":")&&(r+=L.sep)):(r=(0,O.$xd)(r,L.sep),r||(r=L.sep)),r}e.$Me=l;function $(r){const a=(0,L.$9c)(r);return N.$i?r.length>3?!1:b(a)&&(r.length===2||a.charCodeAt(2)===92):a===L.$8c.sep}e.$Ne=$;function b(r,a=N.$i){return a?o(r.charCodeAt(0))&&r.charCodeAt(1)===58:!1}e.$Oe=b;function I(r,a=N.$i){return b(r,a)?r[0]:void 0}e.$Pe=I;function t(r,a,v){return a.length>r.length?-1:r===a?0:(v&&(r=r.toLowerCase(),a=a.toLowerCase()),r.indexOf(a))}e.$Qe=t;function c(r){const a=r.split(":");let v,y,u;for(const E of a){const D=Number(E);(0,j.$pe)(D)?y===void 0?y=D:u===void 0&&(u=D):v=v?[v,E].join(":"):E}if(!v)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:v,line:y!==void 0?y:void 0,column:u!==void 0?u:y!==void 0?1:void 0}}e.$Re=c;const s="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",n="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function i(r,a,v=8){let y="";for(let E=0;E<v;E++){let D;E===0&&N.$i&&!a&&(v===3||v===4)?D=n:D=s,y+=D.charAt(Math.floor(Math.random()*D.length))}let u;return a?u=`${a}-${y}`:u=y,r?(0,L.$$c)(r,u):u}e.$Se=i}),define(re[140],oe([0,1,15]),function(te,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ir=e.$Hr=e.$Gr=e.$Fr=e.$Er=void 0,e.$Er=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const N={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},O={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function j(P){const p=(0,L.$dd)(P),g=N[p.toLowerCase()];return g!==void 0?g:A(P)}e.$Fr=j;function A(P){const p=(0,L.$dd)(P);return O[p.toLowerCase()]}e.$Gr=A;function R(P){for(const p in O)if(O[p]===P)return p}e.$Hr=R;const k=/^(.+)\/(.+?)(;.+)?$/;function m(P,p){const g=k.exec(P);return g?`${g[1].toLowerCase()}/${g[2].toLowerCase()}${g[3]??""}`:p?void 0:P}e.$Ir=m}),define(re[90],oe([0,1,6]),function(te,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rl=e.$ql=e.TerminateResponseCode=e.Source=void 0;var N;(function(R){R[R.stdout=0]="stdout",R[R.stderr=1]="stderr"})(N||(e.Source=N={}));var O;(function(R){R[R.Success=0]="Success",R[R.Unknown=1]="Unknown",R[R.AccessDenied=2]="AccessDenied",R[R.ProcessNotFound=3]="ProcessNotFound"})(O||(e.TerminateResponseCode=O={}));function j(R,...k){const m=k.reduce((g,h)=>(g[h]=!0,g),{}),P=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(R).filter(g=>!m[g]).forEach(g=>{for(let h=0;h<P.length;h++)if(g.search(P[h])!==-1){delete R[g];break}})}e.$ql=j;function A(R){R&&(delete R.DEBUG,L.$j&&delete R.DYLD_LIBRARY_PATH,L.$k&&delete R.LD_PRELOAD)}e.$rl=A}),define(re[11],oe([0,1,15,6]),function(te,e,L,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ve=e.$Ue=e.URI=void 0;const O=/^\w[\w\d+.-]*$/,j=/^\//,A=/^\/\//;function R(n,i){if(!n.scheme&&i)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${n.authority}", path: "${n.path}", query: "${n.query}", fragment: "${n.fragment}"}`);if(n.scheme&&!O.test(n.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(n.path){if(n.authority){if(!j.test(n.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(A.test(n.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function k(n,i){return!n&&!i?"file":n}function m(n,i){switch(n){case"https":case"http":case"file":i?i[0]!==p&&(i=p+i):i=p;break}return i}const P="",p="/",g=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class h{static isUri(i){return i instanceof h?!0:i?typeof i.authority=="string"&&typeof i.fragment=="string"&&typeof i.path=="string"&&typeof i.query=="string"&&typeof i.scheme=="string"&&typeof i.fsPath=="string"&&typeof i.with=="function"&&typeof i.toString=="function":!1}constructor(i,r,a,v,y,u=!1){typeof i=="object"?(this.scheme=i.scheme||P,this.authority=i.authority||P,this.path=i.path||P,this.query=i.query||P,this.fragment=i.fragment||P):(this.scheme=k(i,u),this.authority=r||P,this.path=m(this.scheme,a||P),this.query=v||P,this.fragment=y||P,R(this,u))}get fsPath(){return b(this,!1)}with(i){if(!i)return this;let{scheme:r,authority:a,path:v,query:y,fragment:u}=i;return r===void 0?r=this.scheme:r===null&&(r=P),a===void 0?a=this.authority:a===null&&(a=P),v===void 0?v=this.path:v===null&&(v=P),y===void 0?y=this.query:y===null&&(y=P),u===void 0?u=this.fragment:u===null&&(u=P),r===this.scheme&&a===this.authority&&v===this.path&&y===this.query&&u===this.fragment?this:new f(r,a,v,y,u)}static parse(i,r=!1){const a=g.exec(i);return a?new f(a[2]||P,s(a[4]||P),s(a[5]||P),s(a[7]||P),s(a[9]||P),r):new f(P,P,P,P,P)}static file(i){let r=P;if(N.$i&&(i=i.replace(/\\/g,p)),i[0]===p&&i[1]===p){const a=i.indexOf(p,2);a===-1?(r=i.substring(2),i=p):(r=i.substring(2,a),i=i.substring(a)||p)}return new f("file",r,i,P,P)}static from(i,r){return new f(i.scheme,i.authority,i.path,i.query,i.fragment,r)}static joinPath(i,...r){if(!i.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let a;return N.$i&&i.scheme==="file"?a=h.file(L.$7c.join(b(i,!0),...r)).path:a=L.$8c.join(i.path,...r),i.with({path:a})}toString(i=!1){return I(this,i)}toJSON(){return this}static revive(i){if(i){if(i instanceof h)return i;{const r=new f(i);return r._formatted=i.external??null,r._fsPath=i._sep===w?i.fsPath??null:null,r}}else return i}}e.URI=h;function d(n){return!n||typeof n!="object"?!1:typeof n.scheme=="string"&&(typeof n.authority=="string"||typeof n.authority>"u")&&(typeof n.path=="string"||typeof n.path>"u")&&(typeof n.query=="string"||typeof n.query>"u")&&(typeof n.fragment=="string"||typeof n.fragment>"u")}e.$Ue=d;const w=N.$i?1:void 0;class f extends h{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=b(this,!1)),this._fsPath}toString(i=!1){return i?I(this,!0):(this._formatted||(this._formatted=I(this,!1)),this._formatted)}toJSON(){const i={$mid:1};return this._fsPath&&(i.fsPath=this._fsPath,i._sep=w),this._formatted&&(i.external=this._formatted),this.path&&(i.path=this.path),this.scheme&&(i.scheme=this.scheme),this.authority&&(i.authority=this.authority),this.query&&(i.query=this.query),this.fragment&&(i.fragment=this.fragment),i}}const o={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function l(n,i,r){let a,v=-1;for(let y=0;y<n.length;y++){const u=n.charCodeAt(y);if(u>=97&&u<=122||u>=65&&u<=90||u>=48&&u<=57||u===45||u===46||u===95||u===126||i&&u===47||r&&u===91||r&&u===93||r&&u===58)v!==-1&&(a+=encodeURIComponent(n.substring(v,y)),v=-1),a!==void 0&&(a+=n.charAt(y));else{a===void 0&&(a=n.substr(0,y));const E=o[u];E!==void 0?(v!==-1&&(a+=encodeURIComponent(n.substring(v,y)),v=-1),a+=E):v===-1&&(v=y)}}return v!==-1&&(a+=encodeURIComponent(n.substring(v))),a!==void 0?a:n}function $(n){let i;for(let r=0;r<n.length;r++){const a=n.charCodeAt(r);a===35||a===63?(i===void 0&&(i=n.substr(0,r)),i+=o[a]):i!==void 0&&(i+=n[r])}return i!==void 0?i:n}function b(n,i){let r;return n.authority&&n.path.length>1&&n.scheme==="file"?r=`//${n.authority}${n.path}`:n.path.charCodeAt(0)===47&&(n.path.charCodeAt(1)>=65&&n.path.charCodeAt(1)<=90||n.path.charCodeAt(1)>=97&&n.path.charCodeAt(1)<=122)&&n.path.charCodeAt(2)===58?i?r=n.path.substr(1):r=n.path[1].toLowerCase()+n.path.substr(2):r=n.path,N.$i&&(r=r.replace(/\//g,"\\")),r}e.$Ve=b;function I(n,i){const r=i?$:l;let a="",{scheme:v,authority:y,path:u,query:E,fragment:D}=n;if(v&&(a+=v,a+=":"),(y||v==="file")&&(a+=p,a+=p),y){let T=y.indexOf("@");if(T!==-1){const F=y.substr(0,T);y=y.substr(T+1),T=F.lastIndexOf(":"),T===-1?a+=r(F,!1,!1):(a+=r(F.substr(0,T),!1,!1),a+=":",a+=r(F.substr(T+1),!1,!0)),a+="@"}y=y.toLowerCase(),T=y.lastIndexOf(":"),T===-1?a+=r(y,!1,!0):(a+=r(y.substr(0,T),!1,!0),a+=y.substr(T))}if(u){if(u.length>=3&&u.charCodeAt(0)===47&&u.charCodeAt(2)===58){const T=u.charCodeAt(1);T>=65&&T<=90&&(u=`/${String.fromCharCode(T+32)}:${u.substr(3)}`)}else if(u.length>=2&&u.charCodeAt(1)===58){const T=u.charCodeAt(0);T>=65&&T<=90&&(u=`${String.fromCharCode(T+32)}:${u.substr(2)}`)}a+=r(u,!0,!1)}return E&&(a+="?",a+=r(E,!1,!1)),D&&(a+="#",a+=i?D:l(D,!1,!1)),a}function t(n){try{return decodeURIComponent(n)}catch{return n.length>3?n.substr(0,3)+t(n.substr(3)):n}}const c=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function s(n){return n.match(c)?n.replace(c,i=>t(i)):n}}),define(re[141],oe([0,1,11]),function(te,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.$Mp=e.$Lp=e.$Kp=void 0;function N(m){const P=m;return P&&typeof P.type=="string"&&typeof P.severity=="string"}e.$Kp=N;function O(m){const P=[];let p;try{const g=JSON.parse(m.arguments),h=g[g.length-1];h&&h.__$stack&&(g.pop(),p=h.__$stack),P.push(...g)}catch{P.push("Unable to log remote console arguments",m.arguments)}return{args:P,stack:p}}e.$Lp=O;function j(m){if(typeof m!="string")return j(O(m).stack);const P=m;if(P){const p=A(P),g=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(p||"");if(g&&g.length===4)return{uri:L.URI.file(g[1]),line:Number(g[2]),column:Number(g[3])}}}e.$Mp=j;function A(m){if(!m)return m;const P=m.indexOf(`
`);return P===-1?m:m.substring(0,P)}function R(m,P){const{args:p,stack:g}=O(m),h=typeof p[0]=="string"&&p.length===1;let d=A(g);d&&(d=`(${d.trim()})`);let w=[];if(typeof p[0]=="string"?d&&h?w=[`%c[${P}] %c${p[0]} %c${d}`,k("blue"),k(""),k("grey")]:w=[`%c[${P}] %c${p[0]}`,k("blue"),k(""),...p.slice(1)]:w=[`%c[${P}]%`,k("blue"),...p],d&&!h&&w.push(d),typeof console[m.severity]!="function")throw new Error("Unknown console method");console[m.severity].apply(console,w)}e.log=R;function k(m){return`color: ${m}`}}),define(re[63],oe([0,1,14,11]),function(te,e,L,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9g=e.$8g=e.$7g=void 0;function O(k){return JSON.stringify(k,A)}e.$7g=O;function j(k){let m=JSON.parse(k);return m=R(m),m}e.$8g=j;function A(k,m){return m instanceof RegExp?{$mid:2,source:m.source,flags:m.flags}:m}function R(k,m=0){if(!k||m>200)return k;if(typeof k=="object"){switch(k.$mid){case 1:return N.URI.revive(k);case 2:return new RegExp(k.source,k.flags);case 16:return new Date(k.source)}if(k instanceof L.$Hc||k instanceof Uint8Array)return k;if(Array.isArray(k))for(let P=0;P<k.length;++P)k[P]=R(k[P],m+1);else for(const P in k)Object.hasOwnProperty.call(k,P)&&(k[P]=R(k[P],m+1))}return k}e.$9g=R}),define(re[22],oe([0,1,8,6,11]),function(te,e,L,N,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$4e=e.$3e=e.$2e=e.$1e=e.$Ze=e.$Ye=e.$Xe=e.$We=e.Schemas=void 0;var j;(function(m){m.inMemory="inmemory",m.vscode="vscode",m.internal="private",m.walkThrough="walkThrough",m.walkThroughSnippet="walkThroughSnippet",m.http="http",m.https="https",m.file="file",m.mailto="mailto",m.untitled="untitled",m.data="data",m.command="command",m.vscodeRemote="vscode-remote",m.vscodeRemoteResource="vscode-remote-resource",m.vscodeManagedRemoteResource="vscode-managed-remote-resource",m.vscodeUserData="vscode-userdata",m.vscodeCustomEditor="vscode-custom-editor",m.vscodeNotebookCell="vscode-notebook-cell",m.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",m.vscodeNotebookCellOutput="vscode-notebook-cell-output",m.vscodeInteractiveInput="vscode-interactive-input",m.vscodeSettings="vscode-settings",m.vscodeWorkspaceTrust="vscode-workspace-trust",m.vscodeTerminal="vscode-terminal",m.vscodeChatSesssion="vscode-chat-editor",m.webviewPanel="webview-panel",m.vscodeWebview="vscode-webview",m.extension="extension",m.vscodeFileResource="vscode-file",m.tmp="tmp",m.vsls="vsls",m.vscodeSourceControl="vscode-scm"})(j||(e.Schemas=j={})),e.$We="vscode-tkn",e.$Xe="tkn";class A{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f=`/${j.vscodeRemoteResource}`}setPreferredWebSchema(P){this.d=P}setDelegate(P){this.e=P}setServerRootPath(P){this.f=`${P}/${j.vscodeRemoteResource}`}set(P,p,g){this.a[P]=p,this.b[P]=g}setConnectionToken(P,p){this.c[P]=p}getPreferredWebSchema(){return this.d}rewrite(P){if(this.e)try{return this.e(P)}catch(f){return L.$Y(f),P}const p=P.authority;let g=this.a[p];g&&g.indexOf(":")!==-1&&g.indexOf("[")===-1&&(g=`[${g}]`);const h=this.b[p],d=this.c[p];let w=`path=${encodeURIComponent(P.path)}`;return typeof d=="string"&&(w+=`&${e.$Xe}=${encodeURIComponent(d)}`),O.URI.from({scheme:N.$o?this.d:j.vscodeRemoteResource,authority:`${g}:${h}`,path:this.f,query:w})}}e.$Ye=new A,e.$Ze="vs/../../extensions",e.$1e="vs/../../node_modules",e.$2e="vs/../../node_modules.asar",e.$3e="vs/../../node_modules.asar.unpacked";class R{static{this.a="vscode-app"}asBrowserUri(P){const p=this.b(P,te);return this.uriToBrowserUri(p)}uriToBrowserUri(P){return P.scheme===j.vscodeRemote?e.$Ye.rewrite(P):P.scheme===j.file&&(N.$m||N.$p&&N.$g.origin===`${j.vscodeFileResource}://${R.a}`)?P.with({scheme:j.vscodeFileResource,authority:P.authority||R.a,query:null,fragment:null}):P}asFileUri(P){const p=this.b(P,te);return this.uriToFileUri(p)}uriToFileUri(P){return P.scheme===j.vscodeFileResource?P.with({scheme:j.file,authority:P.authority!==R.a?P.authority:null,query:null,fragment:null}):P}b(P,p){return O.URI.isUri(P)?P:O.URI.parse(p.toUrl(P))}}e.$4e=new R;var k;(function(m){const P=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);m.CoopAndCoep=Object.freeze(P.get("3"));const p="vscode-coi";function g(d){let w;typeof d=="string"?w=new URL(d).searchParams:d instanceof URL?w=d.searchParams:O.URI.isUri(d)&&(w=new URL(d.toString(!0)).searchParams);const f=w?.get(p);if(f)return P.get(f)}m.getHeadersFromQuery=g;function h(d,w,f){if(!globalThis.crossOriginIsolated)return;const o=w&&f?"3":f?"2":"1";d instanceof URLSearchParams?d.set(p,o):d[p]=o}m.addSearchParam=h})(k||(e.COI=k={}))}),define(re[142],oe([0,1,124,22,6,11]),function(te,e,L,N,O,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9C=void 0;class A{constructor(g,h,d){this.id=g,this.dependencies=h,this.callback=d}}class R{static{this.INSTANCE=new R}constructor(){this.a=typeof self=="object"&&self.constructor&&self.constructor.name==="DedicatedWorkerGlobalScope",this.b=typeof document=="object",this.c=[],this.d=!1}g(){this.d||(this.d=!0,globalThis.define=(g,h,d)=>{typeof g!="string"&&(d=h,h=g,g=null),(typeof h!="object"||!Array.isArray(h))&&(d=h,h=null),this.c.push(new A(g,h,d))},globalThis.define.amd=!0,this.b?this.f=window.trustedTypes?.createPolicy("amdLoader",{createScriptURL(g){if(g.startsWith(window.location.origin)||g.startsWith("vscode-file://vscode-app"))return g;throw new Error(`[trusted_script_src] Invalid script url: ${g}`)}}):this.a&&(this.f=globalThis.trustedTypes?.createPolicy("amdLoader",{createScriptURL(g){return g}})))}async load(g){this.g();const h=await(this.a?this.i(g):this.b?this.h(g):this.j(g));if(!h)throw new Error(`Did not receive a define call from script ${g}`);if(Array.isArray(h.dependencies)&&h.dependencies.length>0)throw new Error(`Cannot resolve dependencies for script ${g}. The dependencies are: ${h.dependencies.join(", ")}`);return typeof h.callback=="function"?h.callback([]):h.callback}h(g){return new Promise((h,d)=>{const w=document.createElement("script");w.setAttribute("async","async"),w.setAttribute("type","text/javascript");const f=()=>{w.removeEventListener("load",o),w.removeEventListener("error",l)},o=$=>{f(),h(this.c.pop())},l=$=>{f(),d($)};w.addEventListener("load",o),w.addEventListener("error",l),this.f&&(g=this.f.createScriptURL(g)),w.setAttribute("src",g),document.getElementsByTagName("head")[0].appendChild(w)})}i(g){return new Promise((h,d)=>{try{this.f&&(g=this.f.createScriptURL(g)),importScripts(g),h(this.c.pop())}catch(w){d(w)}})}async j(g){try{const h=globalThis._VSCODE_NODE_MODULES.fs,d=globalThis._VSCODE_NODE_MODULES.vm,w=globalThis._VSCODE_NODE_MODULES.module,f=j.URI.parse(g).fsPath,o=h.readFileSync(f).toString(),l=w.wrap(o.replace(/^#!.*/,""));return new d.Script(l).runInThisContext().apply(),this.c.pop()}catch(h){throw h}}}const k=new Map;let m={};typeof globalThis.require=="object"&&(m=globalThis.require.paths??{});async function P(p,g,h){if(L.$R){h===void 0&&(h=!!(globalThis._VSCODE_PRODUCT_JSON??globalThis.vscode?.context?.configuration()?.product)?.commit),m[p]&&(p=m[p]);const d=`${p}/${g}`;if(k.has(d))return k.get(d);let w;if(/^\w[\w\d+.-]*:\/\//.test(d))w=d;else{const $=`${h&&!O.$o?N.$2e:N.$1e}/${d}`;w=N.$4e.asBrowserUri($).toString(!0)}const f=R.INSTANCE.load(w);return k.set(d,f),f}else return await new Promise((d,w)=>{te([p],d,w)})}e.$9C=P}),define(re[23],oe([0,1,48,22,15,6,28,11]),function(te,e,L,N,O,j,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qg=e.DataUri=e.$pg=e.$og=e.$ng=e.$mg=e.$lg=e.$kg=e.$jg=e.$ig=e.$hg=e.$gg=e.$fg=e.$eg=e.$dg=e.$cg=e.$bg=e.$ag=e.$_f=e.$$f=e.$0f=e.$9f=e.$8f=e.$7f=void 0;function k(h){return(0,R.$Ve)(h,!0)}e.$7f=k;class m{constructor(d){this.a=d}compare(d,w,f=!1){return d===w?0:(0,A.$Hd)(this.getComparisonKey(d,f),this.getComparisonKey(w,f))}isEqual(d,w,f=!1){return d===w?!0:!d||!w?!1:this.getComparisonKey(d,f)===this.getComparisonKey(w,f)}getComparisonKey(d,w=!1){return d.with({path:this.a(d)?d.path.toLowerCase():void 0,fragment:w?null:void 0}).toString()}ignorePathCasing(d){return this.a(d)}isEqualOrParent(d,w,f=!1){if(d.scheme===w.scheme){if(d.scheme===N.Schemas.file)return L.$Ke(k(d),k(w),this.a(d))&&d.query===w.query&&(f||d.fragment===w.fragment);if((0,e.$lg)(d.authority,w.authority))return L.$Ke(d.path,w.path,this.a(d),"/")&&d.query===w.query&&(f||d.fragment===w.fragment)}return!1}joinPath(d,...w){return R.URI.joinPath(d,...w)}basenameOrAuthority(d){return(0,e.$dg)(d)||d.authority}basename(d){return O.$8c.basename(d.path)}extname(d){return O.$8c.extname(d.path)}dirname(d){if(d.path.length===0)return d;let w;return d.scheme===N.Schemas.file?w=R.URI.file(O.$bd(k(d))).path:(w=O.$8c.dirname(d.path),d.authority&&w.length&&w.charCodeAt(0)!==47&&(console.error(`dirname("${d.toString})) resulted in a relative path`),w="/")),d.with({path:w})}normalizePath(d){if(!d.path.length)return d;let w;return d.scheme===N.Schemas.file?w=R.URI.file(O.$9c(k(d))).path:w=O.$8c.normalize(d.path),d.with({path:w})}relativePath(d,w){if(d.scheme!==w.scheme||!(0,e.$lg)(d.authority,w.authority))return;if(d.scheme===N.Schemas.file){const l=O.$ad(k(d),k(w));return j.$i?L.$Ee(l):l}let f=d.path||"/";const o=w.path||"/";if(this.a(d)){let l=0;for(const $=Math.min(f.length,o.length);l<$&&!(f.charCodeAt(l)!==o.charCodeAt(l)&&f.charAt(l).toLowerCase()!==o.charAt(l).toLowerCase());l++);f=o.substr(0,l)+f.substr(l)}return O.$8c.relative(f,o)}resolvePath(d,w){if(d.scheme===N.Schemas.file){const f=R.URI.file(O.$_c(k(d),w));return d.with({authority:f.authority,path:f.path})}return w=L.$Fe(w),d.with({path:O.$8c.resolve(d.path,w)})}isAbsolutePath(d){return!!d.path&&d.path[0]==="/"}isEqualAuthority(d,w){return d===w||d!==void 0&&w!==void 0&&(0,A.$Od)(d,w)}hasTrailingPathSeparator(d,w=O.sep){if(d.scheme===N.Schemas.file){const f=k(d);return f.length>L.$Ge(f).length&&f[f.length-1]===w}else{const f=d.path;return f.length>1&&f.charCodeAt(f.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(d.fsPath)}}removeTrailingPathSeparator(d,w=O.sep){return(0,e.$mg)(d,w)?d.with({path:d.path.substr(0,d.path.length-1)}):d}addTrailingPathSeparator(d,w=O.sep){let f=!1;if(d.scheme===N.Schemas.file){const o=k(d);f=o!==void 0&&o.length===L.$Ge(o).length&&o[o.length-1]===w}else{w="/";const o=d.path;f=o.length===1&&o.charCodeAt(o.length-1)===47}return!f&&!(0,e.$mg)(d,w)?d.with({path:d.path+"/"}):d}}e.$8f=m,e.$9f=new m(()=>!1),e.$0f=new m(h=>h.scheme===N.Schemas.file?!j.$k:!0),e.$$f=new m(h=>!0),e.$_f=e.$9f.isEqual.bind(e.$9f),e.$ag=e.$9f.isEqualOrParent.bind(e.$9f),e.$bg=e.$9f.getComparisonKey.bind(e.$9f),e.$cg=e.$9f.basenameOrAuthority.bind(e.$9f),e.$dg=e.$9f.basename.bind(e.$9f),e.$eg=e.$9f.extname.bind(e.$9f),e.$fg=e.$9f.dirname.bind(e.$9f),e.$gg=e.$9f.joinPath.bind(e.$9f),e.$hg=e.$9f.normalizePath.bind(e.$9f),e.$ig=e.$9f.relativePath.bind(e.$9f),e.$jg=e.$9f.resolvePath.bind(e.$9f),e.$kg=e.$9f.isAbsolutePath.bind(e.$9f),e.$lg=e.$9f.isEqualAuthority.bind(e.$9f),e.$mg=e.$9f.hasTrailingPathSeparator.bind(e.$9f),e.$ng=e.$9f.removeTrailingPathSeparator.bind(e.$9f),e.$og=e.$9f.addTrailingPathSeparator.bind(e.$9f);function P(h,d){const w=[];for(let f=0;f<h.length;f++){const o=d(h[f]);h.some((l,$)=>$===f?!1:(0,e.$ag)(o,d(l)))||w.push(h[f])}return w}e.$pg=P;var p;(function(h){h.META_DATA_LABEL="label",h.META_DATA_DESCRIPTION="description",h.META_DATA_SIZE="size",h.META_DATA_MIME="mime";function d(w){const f=new Map;w.path.substring(w.path.indexOf(";")+1,w.path.lastIndexOf(";")).split(";").forEach($=>{const[b,I]=$.split(":");b&&I&&f.set(b,I)});const l=w.path.substring(0,w.path.indexOf(";"));return l&&f.set(h.META_DATA_MIME,l),f}h.parseMetaData=d})(p||(e.DataUri=p={}));function g(h,d,w){if(d){let f=h.path;return f&&f[0]!==O.$8c.sep&&(f=O.$8c.sep+f),h.with({scheme:w,authority:d,path:f})}return h.with({scheme:w})}e.$qg=g}),define(re[5],oe([0,1,26,8,3,2,23,6,129]),function(te,e,L,N,O,j,A,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3g=e.$2g=e.$1g=e.Promises=e.$Zg=e.$Yg=e.$Xg=e.$Wg=e.$Vg=e.$Ug=e.$Tg=e.$Sg=e.$Rg=e.$Qg=e.$Pg=e.$Og=e.$Ng=e.$Mg=e.$Lg=e.$Kg=e.$Jg=e.$Ig=e.$Hg=e.$Gg=e.$Fg=e.$Eg=e.$Dg=e.$Cg=e.$Bg=e.$Ag=e.$zg=e.$yg=e.$xg=e.$wg=e.$vg=e.$ug=e.$tg=e.$sg=e.$rg=void 0;function m(S){return!!S&&typeof S.then=="function"}e.$rg=m;function P(S){const C=new L.$rc,z=S(C.token),M=new Promise((J,_)=>{const ae=C.token.onCancellationRequested(()=>{ae.dispose(),C.dispose(),_(new N.$3)});Promise.resolve(z).then(he=>{ae.dispose(),C.dispose(),J(he)},he=>{ae.dispose(),C.dispose(),_(he)})});return new class{cancel(){C.cancel()}then(J,_){return M.then(J,_)}catch(J){return this.then(void 0,J)}finally(J){return M.finally(J)}}}e.$sg=P;function p(S,C,z){return new Promise((M,J)=>{const _=C.onCancellationRequested(()=>{_.dispose(),M(z)});S.then(M,J).finally(()=>_.dispose())})}e.$tg=p;function g(S,C){return new Promise((z,M)=>{const J=C.onCancellationRequested(()=>{J.dispose(),M(new N.$3)});S.then(z,M).finally(()=>J.dispose())})}e.$ug=g;async function h(S){let C=-1;const z=S.map((M,J)=>M.then(_=>(C=J,_)));try{return await Promise.race(z)}finally{S.forEach((M,J)=>{J!==C&&M.cancel()})}}e.$vg=h;function d(S,C,z){let M;const J=setTimeout(()=>{M?.(void 0),z?.()},C);return Promise.race([S.finally(()=>clearTimeout(J)),new Promise(_=>M=_)])}e.$wg=d;function w(S){return new Promise((C,z)=>{const M=S();m(M)?M.then(C,z):C(M)})}e.$xg=w;class f{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(C){if(this.f)throw new Error("Throttler is disposed");if(this.a){if(this.d=C,!this.b){const z=()=>{if(this.b=null,this.f)return;const M=this.queue(this.d);return this.d=null,M};this.b=new Promise(M=>{this.a.then(z,z).then(M)})}return new Promise((z,M)=>{this.b.then(z,M)})}return this.a=C(),new Promise((z,M)=>{this.a.then(J=>{this.a=null,z(J)},J=>{this.a=null,M(J)})})}dispose(){this.f=!0}}e.$yg=f;class o{constructor(){this.a=Promise.resolve(null)}queue(C){return this.a=this.a.then(()=>C(),()=>C())}}e.$zg=o;class l{constructor(){this.a=new Map}queue(C,z){const J=(this.a.get(C)??Promise.resolve()).catch(()=>{}).then(z).finally(()=>{this.a.get(C)===J&&this.a.delete(C)});return this.a.set(C,J),J}}e.$Ag=l;const $=(S,C)=>{let z=!0;const M=setTimeout(()=>{z=!1,C()},S);return{isTriggered:()=>z,dispose:()=>{clearTimeout(M),z=!1}}},b=S=>{let C=!0;return queueMicrotask(()=>{C&&(C=!1,S())}),{isTriggered:()=>C,dispose:()=>{C=!1}}};class I{constructor(C){this.defaultDelay=C,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(C,z=this.defaultDelay){this.g=C,this.h(),this.b||(this.b=new Promise((J,_)=>{this.d=J,this.f=_}).then(()=>{if(this.b=null,this.d=null,this.g){const J=this.g;return this.g=null,J()}}));const M=()=>{this.a=null,this.d?.(null)};return this.a=z===k.$ec?b(M):$(z,M),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new N.$3),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$Bg=I;class t{constructor(C){this.a=new I(C),this.b=new f}trigger(C,z){return this.a.trigger(()=>this.b.queue(C),z)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$Cg=t;class c{constructor(){this.a=!1,this.b=new Promise((C,z)=>{this.d=C})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$Dg=c;class s extends c{constructor(C){super(),this.f=setTimeout(()=>this.open(),C)}open(){clearTimeout(this.f),super.open()}}e.$Eg=s;function n(S,C){return C?new Promise((z,M)=>{const J=setTimeout(()=>{_.dispose(),z()},S),_=C.onCancellationRequested(()=>{clearTimeout(J),_.dispose(),M(new N.$3)})}):P(z=>n(S,z))}e.$Fg=n;function i(S,C=0){const z=setTimeout(S,C);return(0,j.$kb)(()=>clearTimeout(z))}e.$Gg=i;function r(S){const C=[];let z=0;const M=S.length;function J(){return z<M?S[z++]():null}function _(ae){ae!=null&&C.push(ae);const he=J();return he?he.then(_):Promise.resolve(C)}return Promise.resolve(null).then(_)}e.$Hg=r;function a(S,C=M=>!!M,z=null){let M=0;const J=S.length,_=()=>{if(M>=J)return Promise.resolve(z);const ae=S[M++];return Promise.resolve(ae()).then(fe=>C(fe)?Promise.resolve(fe):_())};return _()}e.$Ig=a;function v(S,C=M=>!!M,z=null){if(S.length===0)return Promise.resolve(z);let M=S.length;const J=()=>{M=-1;for(const _ of S)_.cancel?.()};return new Promise((_,ae)=>{for(const he of S)he.then(fe=>{--M>=0&&C(fe)?(J(),_(fe)):M===0&&_(z)}).catch(fe=>{--M>=0&&(J(),ae(fe))})})}e.$Jg=v;class y{constructor(C){this.a=0,this.d=C,this.f=[],this.b=0,this.g=new O.$hc}get onDrained(){return this.g.event}get size(){return this.a}queue(C){return this.a++,new Promise((z,M)=>{this.f.push({factory:C,c:z,e:M}),this.h()})}h(){for(;this.f.length&&this.b<this.d;){const C=this.f.shift();this.b++;const z=C.factory();z.then(C.c,C.e),z.then(()=>this.j(),()=>this.j())}}j(){this.a--,this.b--,this.f.length>0?this.h():this.g.fire()}dispose(){this.g.dispose()}}e.$Kg=y;class u extends y{constructor(){super(1)}}e.$Lg=u;class E{constructor(){this.a=new Q,this.b=0}queue(C){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,C())):this.a.run(this.b++,C())}}e.$Mg=E;class D{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const C=new B;return this.b.add(C),C.p}g(){for(const[,C]of this.a)if(C.size>0)return!1;return!0}queueFor(C,z=A.$9f){const M=z.getComparisonKey(C);let J=this.a.get(M);if(!J){J=new u;const _=this.f++,ae=O.Event.once(J.onDrained)(()=>{J?.dispose(),this.a.delete(M),this.h(),this.d?.deleteAndDispose(_),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new j.$ub),this.d.set(_,ae),this.a.set(M,J)}return J}h(){this.g()&&this.j()}j(){for(const C of this.b)C.complete();this.b.clear()}dispose(){for(const[,C]of this.a)C.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$Ng=D;class T{constructor(C,z){this.a=-1,typeof C=="function"&&typeof z=="number"&&this.setIfNotSet(C,z)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(C,z){this.cancel(),this.a=setTimeout(()=>{this.a=-1,C()},z)}setIfNotSet(C,z){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,C()},z))}}e.$Og=T;class F{constructor(){this.a=-1}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearInterval(this.a),this.a=-1)}cancelAndSet(C,z){this.cancel(),this.a=setInterval(()=>{C()},z)}}e.$Pg=F;class q{constructor(C,z){this.b=-1,this.a=C,this.d=z,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(C=this.d){this.cancel(),this.b=setTimeout(this.f,C)}get delay(){return this.d}set delay(C){this.d=C}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$Qg=q;class W{constructor(C,z){z%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${z}ms is not a multiple of 1000ms.`),this.a=C,this.b=z,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(C=this.b){C%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${C}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(C/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$Rg=W;class Z extends q{constructor(C,z){super(C,z),this.j=[]}work(C){this.j.push(C),this.isScheduled()||this.schedule()}h(){const C=this.j;this.j=[],this.a?.(C)}dispose(){this.j=[],super.dispose()}}e.$Sg=Z;class Y extends j.$mb{constructor(C,z){super(),this.g=C,this.h=z,this.a=[],this.b=this.B(new j.$nb),this.f=!1}get pending(){return this.a.length}work(C){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+C.length>this.g.maxBufferedWork)return!1}else if(this.pending+C.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const z of C)this.a.push(z);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new q(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$Tg=Y,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.$Ug=S=>{(0,R.$A)(()=>{if(C)return;const z=Date.now()+15;S(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,z-Date.now())}}))});let C=!1;return{dispose(){C||(C=!0)}}}:e.$Ug=(S,C)=>{const z=requestIdleCallback(S,typeof C=="number"?{timeout:C}:void 0);let M=!1;return{dispose(){M||(M=!0,cancelIdleCallback(z))}}}}();class x{constructor(C){this.d=!1,this.a=()=>{try{this.f=C()}catch(z){this.g=z}finally{this.d=!0}},this.b=(0,e.$Ug)(()=>this.a())}dispose(){this.b.dispose()}get value(){if(this.d||(this.b.dispose(),this.a()),this.g)throw this.g;return this.f}get isInitialized(){return this.d}}e.$Vg=x;async function G(S,C,z){let M;for(let J=0;J<z;J++)try{return await S()}catch(_){M=_,await n(C)}throw M}e.$Wg=G;class Q{isRunning(C){return typeof C=="number"?this.a?.taskId===C:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(C,z,M){return this.a={taskId:C,cancel:()=>M?.(),promise:z},z.then(()=>this.d(C),()=>this.d(C)),z}d(C){this.a&&C===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const C=this.b;this.b=void 0,C.run().then(C.promiseResolve,C.promiseReject)}}queue(C){if(this.b)this.b.run=C;else{let z,M;const J=new Promise((_,ae)=>{z=_,M=ae});this.b={run:C,promise:J,promiseResolve:z,promiseReject:M}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$Xg=Q;class H{constructor(C,z=()=>Date.now()){this.d=C,this.f=z,this.a=0,this.b=0}increment(){const C=this.f();return C-this.a>this.d&&(this.a=C,this.b=0),this.b++,this.b}}e.$Yg=H;var V;(function(S){S[S.Resolved=0]="Resolved",S[S.Rejected=1]="Rejected"})(V||(V={}));class B{get isRejected(){return this.d?.outcome===1}get isResolved(){return this.d?.outcome===0}get isSettled(){return!!this.d}get value(){return this.d?.outcome===0?this.d?.value:void 0}constructor(){this.p=new Promise((C,z)=>{this.a=C,this.b=z})}complete(C){return new Promise(z=>{this.a(C),this.d={outcome:0,value:C},z()})}error(C){return new Promise(z=>{this.b(C),this.d={outcome:1,value:C},z()})}cancel(){return this.error(new N.$3)}}e.$Zg=B;var ee;(function(S){async function C(M){let J;const _=await Promise.all(M.map(ae=>ae.then(he=>he,he=>{J||(J=he)})));if(typeof J<"u")throw J;return _}S.settled=C;function z(M){return new Promise(async(J,_)=>{try{await M(J,_)}catch(ae){_(ae)}})}S.withAsyncBody=z})(ee||(e.Promises=ee={}));var ne;(function(S){S[S.Initial=0]="Initial",S[S.DoneOK=1]="DoneOK",S[S.DoneError=2]="DoneError"})(ne||(ne={}));class se{static fromArray(C){return new se(z=>{z.emitMany(C)})}static fromPromise(C){return new se(async z=>{z.emitMany(await C)})}static fromPromises(C){return new se(async z=>{await Promise.all(C.map(async M=>z.emitOne(await M)))})}static merge(C){return new se(async z=>{await Promise.all(C.map(async M=>{for await(const J of M)z.emitOne(J)}))})}static{this.EMPTY=se.fromArray([])}constructor(C){this.a=0,this.b=[],this.d=null,this.f=new O.$hc,queueMicrotask(async()=>{const z={emitOne:M=>this.g(M),emitMany:M=>this.h(M),reject:M=>this.k(M)};try{await Promise.resolve(C(z)),this.j()}catch(M){this.k(M)}finally{z.emitOne=void 0,z.emitMany=void 0,z.reject=void 0}})}[Symbol.asyncIterator](){let C=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(C<this.b.length)return{done:!1,value:this.b[C++]};if(this.a===1)return{done:!0,value:void 0};await O.Event.toPromise(this.f.event)}while(!0)}}}static map(C,z){return new se(async M=>{for await(const J of C)M.emitOne(z(J))})}map(C){return se.map(this,C)}static filter(C,z){return new se(async M=>{for await(const J of C)z(J)&&M.emitOne(J)})}filter(C){return se.filter(this,C)}static coalesce(C){return se.filter(C,z=>!!z)}coalesce(){return se.coalesce(this)}static async toPromise(C){const z=[];for await(const M of C)z.push(M);return z}toPromise(){return se.toPromise(this)}g(C){this.a===0&&(this.b.push(C),this.f.fire())}h(C){this.a===0&&(this.b=this.b.concat(C),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(C){this.a===0&&(this.a=2,this.d=C,this.f.fire())}}e.$1g=se;class K extends se{constructor(C,z){super(z),this.l=C}cancel(){this.l.cancel()}}e.$2g=K;function U(S){const C=new L.$rc,z=S(C.token);return new K(C,async M=>{const J=C.token.onCancellationRequested(()=>{J.dispose(),C.dispose(),M.reject(new N.$3)});try{for await(const _ of z){if(C.token.isCancellationRequested)return;M.emitOne(_)}J.dispose(),C.dispose()}catch(_){J.dispose(),C.dispose(),M.reject(_)}})}e.$3g=U}),define(re[91],oe([0,1,20,5,48,35,15,6,28]),function(te,e,L,N,O,j,A,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tj=e.$sj=e.$rj=e.$qj=e.$pj=e.$oj=e.$nj=e.$mj=e.$lj=e.$kj=void 0;function m(){return Object.create(null)}e.$kj=m,e.$lj="**",e.$mj="/";const P="[/\\\\]",p="[^/\\\\]",g=/\//g;function h(Q,H){switch(Q){case 0:return"";case 1:return`${p}*?`;default:return`(?:${P}|${p}+${P}${H?`|${P}${p}+`:""})*?`}}function d(Q,H){if(!Q)return[];const V=[];let B=!1,ee=!1,ne="";for(const se of Q){switch(se){case H:if(!B&&!ee){V.push(ne),ne="";continue}break;case"{":B=!0;break;case"}":B=!1;break;case"[":ee=!0;break;case"]":ee=!1;break}ne+=se}return ne&&V.push(ne),V}e.$nj=d;function w(Q){if(!Q)return"";let H="";const V=d(Q,e.$mj);if(V.every(B=>B===e.$lj))H=".*";else{let B=!1;V.forEach((ee,ne)=>{if(ee===e.$lj){if(B)return;H+=h(2,ne===V.length-1)}else{let se=!1,K="",U=!1,S="";for(const C of ee){if(C!=="}"&&se){K+=C;continue}if(U&&(C!=="]"||!S)){let z;C==="-"?z=C:(C==="^"||C==="!")&&!S?z="^":C===e.$mj?z="":z=(0,k.$sd)(C),S+=z;continue}switch(C){case"{":se=!0;continue;case"[":U=!0;continue;case"}":{const M=`(?:${d(K,",").map(J=>w(J)).join("|")})`;H+=M,se=!1,K="";break}case"]":{H+="["+S+"]",U=!1,S="";break}case"?":H+=p;continue;case"*":H+=h(1);continue;default:H+=(0,k.$sd)(C)}}ne<V.length-1&&(V[ne+1]!==e.$lj||ne+2<V.length)&&(H+=P)}B=ee===e.$lj})}return H}const f=/^\*\*\/\*\.[\w\.-]+$/,o=/^\*\*\/([\w\.-]+)\/?$/,l=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,$=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,b=/^\*\*((\/[\w\.-]+)+)\/?$/,I=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new j.$Ai(1e4),c=function(){return!1},s=function(){return null};function n(Q,H){if(!Q)return s;let V;typeof Q!="string"?V=Q.pattern:V=Q,V=V.trim();const B=`${V}_${!!H.trimForExclusions}`;let ee=t.get(B);if(ee)return i(ee,Q);let ne;return f.test(V)?ee=a(V.substr(4),V):(ne=o.exec(r(V,H)))?ee=v(ne[1],V):(H.trimForExclusions?$:l).test(V)?ee=y(V,H):(ne=b.exec(r(V,H)))?ee=u(ne[1].substr(1),V,!0):(ne=I.exec(r(V,H)))?ee=u(ne[1],V,!1):ee=E(V),t.set(B,ee),i(ee,Q)}function i(Q,H){if(typeof H=="string")return Q;const V=function(B,ee){return(0,O.$Ke)(B,H.base,!R.$k)?Q((0,k.$wd)(B.substr(H.base.length),A.sep),ee):null};return V.allBasenames=Q.allBasenames,V.allPaths=Q.allPaths,V.basenames=Q.basenames,V.patterns=Q.patterns,V}function r(Q,H){return H.trimForExclusions&&Q.endsWith("/**")?Q.substr(0,Q.length-2):Q}function a(Q,H){return function(V,B){return typeof V=="string"&&V.endsWith(Q)?H:null}}function v(Q,H){const V=`/${Q}`,B=`\\${Q}`,ee=function(se,K){return typeof se!="string"?null:K?K===Q?H:null:se===Q||se.endsWith(V)||se.endsWith(B)?H:null},ne=[Q];return ee.basenames=ne,ee.patterns=[H],ee.allBasenames=ne,ee}function y(Q,H){const V=x(Q.slice(1,-1).split(",").map(K=>n(K,H)).filter(K=>K!==s),Q),B=V.length;if(!B)return s;if(B===1)return V[0];const ee=function(K,U){for(let S=0,C=V.length;S<C;S++)if(V[S](K,U))return Q;return null},ne=V.find(K=>!!K.allBasenames);ne&&(ee.allBasenames=ne.allBasenames);const se=V.reduce((K,U)=>U.allPaths?K.concat(U.allPaths):K,[]);return se.length&&(ee.allPaths=se),ee}function u(Q,H,V){const B=A.sep===A.$8c.sep,ee=B?Q:Q.replace(g,A.sep),ne=A.sep+ee,se=A.$8c.sep+Q;let K;return V?K=function(U,S){return typeof U=="string"&&(U===ee||U.endsWith(ne)||!B&&(U===Q||U.endsWith(se)))?H:null}:K=function(U,S){return typeof U=="string"&&(U===ee||!B&&U===Q)?H:null},K.allPaths=[(V?"*/":"./")+Q],K}function E(Q){try{const H=new RegExp(`^${w(Q)}$`);return function(V){return H.lastIndex=0,typeof V=="string"&&H.test(V)?Q:null}}catch{return s}}function D(Q,H,V){return!Q||typeof H!="string"?!1:T(Q)(H,void 0,V)}e.$oj=D;function T(Q,H={}){if(!Q)return c;if(typeof Q=="string"||F(Q)){const V=n(Q,H);if(V===s)return c;const B=function(ee,ne){return!!V(ee,ne)};return V.allBasenames&&(B.allBasenames=V.allBasenames),V.allPaths&&(B.allPaths=V.allPaths),B}return Z(Q,H)}e.$pj=T;function F(Q){const H=Q;return H?typeof H.base=="string"&&typeof H.pattern=="string":!1}e.$qj=F;function q(Q){return Q.allBasenames||[]}e.$rj=q;function W(Q){return Q.allPaths||[]}e.$sj=W;function Z(Q,H){const V=x(Object.getOwnPropertyNames(Q).map(K=>Y(K,Q[K],H)).filter(K=>K!==s)),B=V.length;if(!B)return s;if(!V.some(K=>!!K.requiresSiblings)){if(B===1)return V[0];const K=function(C,z){let M;for(let J=0,_=V.length;J<_;J++){const ae=V[J](C,z);if(typeof ae=="string")return ae;(0,N.$rg)(ae)&&(M||(M=[]),M.push(ae))}return M?(async()=>{for(const J of M){const _=await J;if(typeof _=="string")return _}return null})():null},U=V.find(C=>!!C.allBasenames);U&&(K.allBasenames=U.allBasenames);const S=V.reduce((C,z)=>z.allPaths?C.concat(z.allPaths):C,[]);return S.length&&(K.allPaths=S),K}const ee=function(K,U,S){let C,z;for(let M=0,J=V.length;M<J;M++){const _=V[M];_.requiresSiblings&&S&&(U||(U=(0,A.$cd)(K)),C||(C=U.substr(0,U.length-(0,A.$dd)(K).length)));const ae=_(K,U,C,S);if(typeof ae=="string")return ae;(0,N.$rg)(ae)&&(z||(z=[]),z.push(ae))}return z?(async()=>{for(const M of z){const J=await M;if(typeof J=="string")return J}return null})():null},ne=V.find(K=>!!K.allBasenames);ne&&(ee.allBasenames=ne.allBasenames);const se=V.reduce((K,U)=>U.allPaths?K.concat(U.allPaths):K,[]);return se.length&&(ee.allPaths=se),ee}function Y(Q,H,V){if(H===!1)return s;const B=n(Q,V);if(B===s)return s;if(typeof H=="boolean")return B;if(H){const ee=H.when;if(typeof ee=="string"){const ne=(se,K,U,S)=>{if(!S||!B(se,K))return null;const C=ee.replace("$(basename)",()=>U),z=S(C);return(0,N.$rg)(z)?z.then(M=>M?Q:null):z?Q:null};return ne.requiresSiblings=!0,ne}}return B}function x(Q,H){const V=Q.filter(K=>!!K.basenames);if(V.length<2)return Q;const B=V.reduce((K,U)=>{const S=U.basenames;return S?K.concat(S):K},[]);let ee;if(H){ee=[];for(let K=0,U=B.length;K<U;K++)ee.push(H)}else ee=V.reduce((K,U)=>{const S=U.patterns;return S?K.concat(S):K},[]);const ne=function(K,U){if(typeof K!="string")return null;if(!U){let C;for(C=K.length;C>0;C--){const z=K.charCodeAt(C-1);if(z===47||z===92)break}U=K.substr(C)}const S=B.indexOf(U);return S!==-1?ee[S]:null};ne.basenames=B,ne.patterns=ee,ne.allBasenames=B;const se=Q.filter(K=>!K.basenames);return se.push(ne),se}function G(Q,H){return(0,L.$of)(Q,H,(V,B)=>typeof V=="string"&&typeof B=="string"?V===B:typeof V!="string"&&typeof B!="string"?V.base===B.base&&V.pattern===B.pattern:!1)}e.$tj=G}),define(re[92],oe([0,1,14,11]),function(te,e,L,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dm=e.$Cm=e.$Bm=e.$Am=e.$zm=void 0;function O(p){return p.toJSON()}class j{constructor(g){this.a=g}transformIncoming(g){const h=this.a.transformIncoming(g);return h===g?g:O(N.URI.from(h))}transformOutgoing(g){const h=this.a.transformOutgoing(g);return h===g?g:O(N.URI.from(h))}transformOutgoingURI(g){const h=this.a.transformOutgoing(g);return h===g?g:N.URI.from(h)}transformOutgoingScheme(g){return this.a.transformOutgoingScheme(g)}}e.$zm=j,e.$Am=new class{transformIncoming(p){return p}transformOutgoing(p){return p}transformOutgoingURI(p){return p}transformOutgoingScheme(p){return p}};function A(p,g,h){if(!p||h>200)return null;if(typeof p=="object"){if(p instanceof N.URI)return g.transformOutgoing(p);for(const d in p)if(Object.hasOwnProperty.call(p,d)){const w=A(p[d],g,h+1);w!==null&&(p[d]=w)}}return null}function R(p,g){const h=A(p,g,0);return h===null?p:h}e.$Bm=R;function k(p,g,h,d){if(!p||d>200)return null;if(typeof p=="object"){if(p.$mid===1)return h?N.URI.revive(g.transformIncoming(p)):g.transformIncoming(p);if(p instanceof L.$Hc)return null;for(const w in p)if(Object.hasOwnProperty.call(p,w)){const f=k(p[w],g,h,d+1);f!==null&&(p[w]=f)}}return null}function m(p,g){const h=k(p,g,!1,0);return h===null?p:h}e.$Cm=m;function P(p,g){const h=k(p,g,!0,0);return h===null?p:h}e.$Dm=P}),define(re[31],oe([0,1,52,36,268,5,48,88,15,6,23,11]),function(te,e,L,N,O,j,A,R,k,m,P,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.configureFlushOnWrite=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var g;(function(Y){Y[Y.UNLINK=0]="UNLINK",Y[Y.MOVE=1]="MOVE"})(g||(e.RimRafMode=g={}));async function h(Y,x=g.UNLINK,G){if((0,A.$Ne)(Y))throw new Error("rimraf - will refuse to recursively delete root");return x===g.UNLINK?w(Y):d(Y,G)}async function d(Y,x=(0,A.$Se)((0,N.tmpdir)())){try{try{await L.promises.rename(Y,x)}catch(G){return G.code==="ENOENT"?void 0:w(Y)}w(x).catch(G=>{})}catch(G){if(G.code!=="ENOENT")throw G}}async function w(Y){return(0,O.promisify)(L.rm)(Y,{recursive:!0,force:!0,maxRetries:3})}function f(Y){if((0,A.$Ne)(Y))throw new Error("rimraf - will refuse to recursively delete root");L.rmSync(Y,{recursive:!0,force:!0,maxRetries:3})}e.rimrafSync=f;async function o(Y,x){return b(await(x?l(Y):(0,O.promisify)(L.readdir)(Y)))}async function l(Y){try{return await(0,O.promisify)(L.readdir)(Y,{withFileTypes:!0})}catch(Q){console.warn("[node.js fs] readdir with filetypes failed with error: ",Q)}const x=[],G=await o(Y);for(const Q of G){let H=!1,V=!1,B=!1;try{const ee=await e.Promises.lstat((0,k.$$c)(Y,Q));H=ee.isFile(),V=ee.isDirectory(),B=ee.isSymbolicLink()}catch(ee){console.warn("[node.js fs] unexpected error from lstat after readdir: ",ee)}x.push({name:Q,isFile:()=>H,isDirectory:()=>V,isSymbolicLink:()=>B})}return x}function $(Y){return b(L.readdirSync(Y))}e.readdirSync=$;function b(Y){return Y.map(x=>typeof x=="string"?m.$j?(0,R.$fl)(x):x:(x.name=m.$j?(0,R.$fl)(x.name):x.name,x))}async function I(Y){const x=await o(Y),G=[];for(const Q of x)await c.existsDirectory((0,k.$$c)(Y,Q))&&G.push(Q);return G}function t(Y,x=1e3){return new Promise(G=>{let Q=!1;const H=setInterval(()=>{Q||(Q=!0,L.access(Y,V=>{Q=!1,V&&(clearInterval(H),G(void 0))}))},x)})}e.whenDeleted=t;var c;(function(Y){async function x(H){let V;try{if(V=await e.Promises.lstat(H),!V.isSymbolicLink())return{stat:V}}catch{}try{return{stat:await e.Promises.stat(H),symbolicLink:V?.isSymbolicLink()?{dangling:!1}:void 0}}catch(B){if(B.code==="ENOENT"&&V)return{stat:V,symbolicLink:{dangling:!0}};if(m.$i&&B.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(H)),symbolicLink:{dangling:!1}}}catch(ee){if(ee.code==="ENOENT"&&V)return{stat:V,symbolicLink:{dangling:!0}};throw ee}throw B}}Y.stat=x;async function G(H){try{const{stat:V,symbolicLink:B}=await Y.stat(H);return V.isFile()&&B?.dangling!==!0}catch{}return!1}Y.existsFile=G;async function Q(H){try{const{stat:V,symbolicLink:B}=await Y.stat(H);return V.isDirectory()&&B?.dangling!==!0}catch{}return!1}Y.existsDirectory=Q})(c||(e.SymlinkSupport=c={}));const s=new j.$Ng;function n(Y,x,G){return s.queueFor(p.URI.file(Y),P.$0f).queue(()=>{const Q=y(G);return new Promise((H,V)=>a(Y,x,Q,B=>B?V(B):H()))})}let i=!0;function r(Y){i=Y}e.configureFlushOnWrite=r;function a(Y,x,G,Q){if(!i)return L.writeFile(Y,x,{mode:G.mode,flag:G.flag},Q);L.open(Y,G.flag,G.mode,(H,V)=>{if(H)return Q(H);L.writeFile(V,x,B=>{if(B)return L.close(V,()=>Q(B));L.fdatasync(V,ee=>(ee&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",ee),r(!1)),L.close(V,ne=>Q(ne))))})})}function v(Y,x,G){const Q=y(G);if(!i)return L.writeFileSync(Y,x,{mode:Q.mode,flag:Q.flag});const H=L.openSync(Y,Q.flag,Q.mode);try{L.writeFileSync(H,x);try{L.fdatasyncSync(H)}catch(V){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",V),r(!1)}}finally{L.closeSync(H)}}e.writeFileSync=v;function y(Y){return Y?{mode:typeof Y.mode=="number"?Y.mode:438,flag:typeof Y.flag=="string"?Y.flag:"w"}:{mode:438,flag:"w"}}async function u(Y,x,G=6e4){if(Y!==x)try{m.$i&&typeof G=="number"?await E(Y,x,Date.now(),G):await(0,O.promisify)(L.rename)(Y,x)}catch(Q){if(Y.toLowerCase()!==x.toLowerCase()&&Q.code==="EXDEV"||Y.endsWith("."))await D(Y,x,{preserveSymlinks:!1}),await h(Y,g.MOVE);else throw Q}}async function E(Y,x,G,Q,H=0){try{return await(0,O.promisify)(L.rename)(Y,x)}catch(V){if(V.code!=="EACCES"&&V.code!=="EPERM"&&V.code!=="EBUSY")throw V;if(Date.now()-G>=Q)throw console.error(`[node.js fs] rename failed after ${H} retries with error: ${V}`),V;if(H===0){let B=!1;try{const{stat:ee}=await c.stat(x);ee.isFile()||(B=!0)}catch{}if(B)throw V}return await(0,j.$Fg)(Math.min(100,H*10)),E(Y,x,G,Q,H+1)}}async function D(Y,x,G){return F(Y,x,{root:{source:Y,target:x},options:G,handledSourcePaths:new Set})}const T=511;async function F(Y,x,G){if(G.handledSourcePaths.has(Y))return;G.handledSourcePaths.add(Y);const{stat:Q,symbolicLink:H}=await c.stat(Y);if(H){if(G.options.preserveSymlinks)try{return await Z(Y,x,G)}catch(V){console.warn("[node.js fs] copy of symlink failed: ",V)}if(H.dangling)return}return Q.isDirectory()?q(Y,x,Q.mode&T,G):W(Y,x,Q.mode&T)}async function q(Y,x,G,Q){await e.Promises.mkdir(x,{recursive:!0,mode:G});const H=await o(Y);for(const V of H)await F((0,k.$$c)(Y,V),(0,k.$$c)(x,V),Q)}async function W(Y,x,G){await e.Promises.copyFile(Y,x),await e.Promises.chmod(x,G)}async function Z(Y,x,G){let Q=await e.Promises.readlink(Y);(0,A.$Ke)(Q,G.root.source,!m.$k)&&(Q=(0,k.$$c)(G.root.target,Q.substr(G.root.source.length+1))),await e.Promises.symlink(Q,x)}e.Promises=new class{get access(){return(0,O.promisify)(L.access)}get stat(){return(0,O.promisify)(L.stat)}get lstat(){return(0,O.promisify)(L.lstat)}get utimes(){return(0,O.promisify)(L.utimes)}get read(){return(Y,x,G,Q,H)=>new Promise((V,B)=>{L.read(Y,x,G,Q,H,(ee,ne,se)=>ee?B(ee):V({bytesRead:ne,buffer:se}))})}get readFile(){return(0,O.promisify)(L.readFile)}get write(){return(Y,x,G,Q,H)=>new Promise((V,B)=>{L.write(Y,x,G,Q,H,(ee,ne,se)=>ee?B(ee):V({bytesWritten:ne,buffer:se}))})}get appendFile(){return(0,O.promisify)(L.appendFile)}get fdatasync(){return(0,O.promisify)(L.fdatasync)}get truncate(){return(0,O.promisify)(L.truncate)}get copyFile(){return(0,O.promisify)(L.copyFile)}get open(){return(0,O.promisify)(L.open)}get close(){return(0,O.promisify)(L.close)}get symlink(){return(0,O.promisify)(L.symlink)}get readlink(){return(0,O.promisify)(L.readlink)}get chmod(){return(0,O.promisify)(L.chmod)}get mkdir(){return(0,O.promisify)(L.mkdir)}get unlink(){return(0,O.promisify)(L.unlink)}get rmdir(){return(0,O.promisify)(L.rmdir)}get realpath(){return(0,O.promisify)(L.realpath)}async exists(Y){try{return await e.Promises.access(Y),!0}catch{return!1}}get readdir(){return o}get readDirsInDir(){return I}get writeFile(){return n}get rm(){return h}get rename(){return u}get copy(){return D}}}),define(re[143],oe([0,1,52,15,6,28,31]),function(te,e,L,N,O,j,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Up=e.$Tp=e.$Sp=e.$Rp=void 0;function R(g){if(O.$k)return g;const h=(0,N.$bd)(g);if(g===h)return g;const d=((0,N.$cd)(g)||g).toLowerCase();try{const f=(0,A.readdirSync)(h).filter(o=>o.toLowerCase()===d);if(f.length===1){const o=R(h);if(o)return(0,N.$$c)(o,f[0])}else if(f.length>1){const o=f.indexOf(d);if(o>=0){const l=R(h);if(l)return(0,N.$$c)(l,f[o])}}}catch{}return null}e.$Rp=R;async function k(g){if(O.$k)return g;const h=(0,N.$bd)(g);if(g===h)return g;const d=((0,N.$cd)(g)||g).toLowerCase();try{const f=(await A.Promises.readdir(h)).filter(o=>o.toLowerCase()===d);if(f.length===1){const o=await k(h);if(o)return(0,N.$$c)(o,f[0])}else if(f.length>1){const o=f.indexOf(d);if(o>=0){const l=await k(h);if(l)return(0,N.$$c)(l,f[o])}}}catch{}return null}e.$Sp=k;async function m(g){try{return await A.Promises.realpath(g)}catch{const d=p(g);return await A.Promises.access(d,L.constants.R_OK),d}}e.$Tp=m;function P(g){try{return L.realpathSync(g)}catch{const d=p(g);return L.accessSync(d,L.constants.R_OK),d}}e.$Up=P;function p(g){return(0,j.$xd)((0,N.$9c)(g),N.sep)}}),define(re[144],oe([0,1,15,6,37,90,9,31]),function(te,e,L,N,O,j,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.$tl=e.$sl=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return j.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return j.TerminateResponseCode}});function k(p=O.env){return p.comspec||"cmd.exe"}e.$sl=k;function m(p){let g=[],h=!1;const d=function(w){if(h){g.push(w);return}(!p.send(w,o=>{if(o&&console.error(o),h=!1,g.length>0){const l=g.slice(0);g=[],l.forEach($=>d($))}})||N.$i)&&(h=!0)};return{send:d}}e.$tl=m;var P;(function(p){async function g(h,d,w){if(L.$0c(h))return h;if(d===void 0&&(d=O.cwd()),L.$bd(h)!=="."||(w===void 0&&A.$le(O.env.PATH)&&(w=O.env.PATH.split(L.$id)),w===void 0||w.length===0))return L.$$c(d,h);async function o(l){if(await R.Promises.exists(l)){let $;try{$=await R.Promises.stat(l)}catch(b){b.message.startsWith("EACCES")&&($=await R.Promises.lstat(l))}return $?!$.isDirectory():!1}return!1}for(const l of w){let $;if(L.$0c(l)?$=L.$$c(l,h):$=L.$$c(d,l,h),await o($))return $;let b=$+".com";if(await o(b)||(b=$+".exe",await o(b)))return b}return L.$$c(d,h)}p.findExecutable=g})(P||(e.win32=P={}))}),define(re[145],oe([0,1,64,22]),function(te,e,L,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pr=void 0;function O(A){return new Promise((R,k)=>{let m;const P=new Map;function p(h,d,w,f,o){const l=P.get(d);if(h===A||l){const $={name:g(w),cmd:w,pid:h,ppid:d,load:f,mem:o};P.set(h,$),h===A&&(m=$),l&&(l.children||(l.children=[]),l.children.push($),l.children.length>1&&(l.children=l.children.sort((b,I)=>b.pid-I.pid)))}}function g(h){const d=/--utility-sub-type=network/i,w=/--ms-enable-electron-run-as-node/i,f=/--crashes-directory/i,o=/\\pipe\\winpty-control/i,l=/conhost\.exe.+--headless/i,$=/--type=([a-zA-Z-]+)/;if(f.exec(h))return"electron-crash-reporter";if(o.exec(h))return"winpty-agent";if(l.exec(h))return"conpty-agent";let b=$.exec(h);if(b&&b.length===2)return b[1]==="renderer"?"window":b[1]==="utility"?d.exec(h)?"utility-network-service":"utility-process":b[1]==="extensionHost"?"extension-host":b[1];const I=/[a-zA-Z-]+\.js/g;let t="";do b=I.exec(h),b&&(t+=b+" ");while(b);return t&&h.indexOf("node ")<0&&h.indexOf("node.exe")<0?`electron-nodejs (${t})`:w.exec(h)?`electron-nodejs (${h})`:h}if(process.platform==="win32"){const h=d=>d.indexOf("\\\\?\\")===0||d.indexOf("\\??\\")===0?d.substring(4):d.indexOf('"\\\\?\\')===0||d.indexOf('"\\??\\')===0?'"'+d.substring(5):d;new Promise((d,w)=>{te(["@vscode/windows-process-tree"],d,w)}).then(d=>{d.getProcessList(A,w=>{if(!w){k(new Error(`Root process ${A} not found`));return}d.getProcessCpuUsage(w,f=>{const o=new Map;f.forEach(l=>{const $=h(l.commandLine||"");o.set(l.pid,{name:g($),cmd:$,pid:l.pid,ppid:l.ppid,load:l.cpu||0,mem:l.memory||0})}),m=o.get(A),m?(o.forEach(l=>{const $=o.get(l.ppid);$&&($.children||($.children=[]),$.children.push(l))}),o.forEach(l=>{l.children&&(l.children=l.children.sort(($,b)=>$.pid-b.pid))}),R(m)):k(new Error(`Root process ${A} not found`))})},d.ProcessDataFlag.CommandLine|d.ProcessDataFlag.Memory)})}else{let h=function(){let d=[m];const w=[];for(;d.length;){const o=d.shift();o&&(w.push(o.pid),o.children&&(d=d.concat(o.children)))}let f=JSON.stringify(N.$4e.asFileUri("vs/base/node/cpuUsage.sh").fsPath);f+=" "+w.join(" "),(0,L.exec)(f,{},(o,l,$)=>{if(o||$)k(o||new Error($.toString()));else{const b=l.toString().split(`
`);for(let I=0;I<w.length;I++){const t=P.get(w[I]);t.load=parseFloat(b[I])}if(!m){k(new Error(`Root process ${A} not found`));return}R(m)}})};(0,L.exec)("which ps",{},(d,w,f)=>{if(d||f)if(process.platform!=="linux")k(d||new Error(f.toString()));else{const o=JSON.stringify(N.$4e.asFileUri("vs/base/node/ps.sh").fsPath);(0,L.exec)(o,{},(l,$,b)=>{l||b?k(l||new Error(b.toString())):(j($,p),h())})}else{const o=w.toString().trim(),l="-ax -o pid=,ppid=,pcpu=,pmem=,command=";(0,L.exec)(`${o} ${l}`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},($,b,I)=>{$||I&&!I.includes("screen size is bogus")?k($||new Error(I.toString())):(j(b,p),process.platform==="linux"?h():m?R(m):k(new Error(`Root process ${A} not found`)))})}})}})}e.$pr=O;function j(A,R){const k=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,m=A.toString().split(`
`);for(const P of m){const p=k.exec(P.trim());p&&p.length===6&&R(parseInt(p[1]),parseInt(p[2]),p[5],parseFloat(p[3]),parseFloat(p[4]))}}});var ye=this&&this.__decorate||function(te,e,L,N){var O=arguments.length,j=O<3?e:N===null?N=Object.getOwnPropertyDescriptor(e,L):N,A;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")j=Reflect.decorate(te,e,L,N);else for(var R=te.length-1;R>=0;R--)(A=te[R])&&(j=(O<3?A(j):O>3?A(e,L,j):A(e,L))||j);return O>3&&j&&Object.defineProperty(e,L,j),j};define(re[43],oe([0,1,20,5,14,26,83,8,3,2,63,28,9]),function(te,e,L,N,O,j,A,R,k,m,P,p,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ih=e.ProxyChannel=e.$hh=e.$gh=e.$fh=e.$eh=e.$dh=e.$ch=e.RequestInitiator=e.$bh=e.$ah=e.$_g=e.$$g=e.$0g=void 0;var h;(function(H){H[H.Promise=100]="Promise",H[H.PromiseCancel=101]="PromiseCancel",H[H.EventListen=102]="EventListen",H[H.EventDispose=103]="EventDispose"})(h||(h={}));function d(H){switch(H){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var w;(function(H){H[H.Initialize=200]="Initialize",H[H.PromiseSuccess=201]="PromiseSuccess",H[H.PromiseError=202]="PromiseError",H[H.PromiseErrorObj=203]="PromiseErrorObj",H[H.EventFire=204]="EventFire"})(w||(w={}));function f(H){switch(H){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var o;(function(H){H[H.Uninitialized=0]="Uninitialized",H[H.Idle=1]="Idle"})(o||(o={}));function l(H){let V=0;for(let B=0;;B+=7){const ee=H.read(1);if(V|=(ee.buffer[0]&127)<<B,!(ee.buffer[0]&128))return V}}const $=s(0);function b(H,V){if(V===0){H.write($);return}let B=0;for(let ne=V;ne!==0;ne=ne>>>7)B++;const ee=O.$Hc.alloc(B);for(let ne=0;V!==0;ne++)ee.buffer[ne]=V&127,V=V>>>7,V>0&&(ee.buffer[ne]|=128);H.write(ee)}class I{constructor(V){this.b=V,this.a=0}read(V){const B=this.b.slice(this.a,this.a+V);return this.a+=B.byteLength,B}}e.$0g=I;class t{constructor(){this.a=[]}get buffer(){return O.$Hc.concat(this.a)}write(V){this.a.push(V)}}e.$$g=t;var c;(function(H){H[H.Undefined=0]="Undefined",H[H.String=1]="String",H[H.Buffer=2]="Buffer",H[H.VSBuffer=3]="VSBuffer",H[H.Array=4]="Array",H[H.Object=5]="Object",H[H.Int=6]="Int"})(c||(c={}));function s(H){const V=O.$Hc.alloc(1);return V.writeUInt8(H,0),V}const n={Undefined:s(c.Undefined),String:s(c.String),Buffer:s(c.Buffer),VSBuffer:s(c.VSBuffer),Array:s(c.Array),Object:s(c.Object),Uint:s(c.Int)},i=typeof Buffer<"u";function r(H,V){if(typeof V>"u")H.write(n.Undefined);else if(typeof V=="string"){const B=O.$Hc.fromString(V);H.write(n.String),b(H,B.byteLength),H.write(B)}else if(i&&Buffer.isBuffer(V)){const B=O.$Hc.wrap(V);H.write(n.Buffer),b(H,B.byteLength),H.write(B)}else if(V instanceof O.$Hc)H.write(n.VSBuffer),b(H,V.byteLength),H.write(V);else if(Array.isArray(V)){H.write(n.Array),b(H,V.length);for(const B of V)r(H,B)}else if(typeof V=="number"&&(V|0)===V)H.write(n.Uint),b(H,V);else{const B=O.$Hc.fromString(JSON.stringify(V));H.write(n.Object),b(H,B.byteLength),H.write(B)}}e.$_g=r;function a(H){switch(H.read(1).readUInt8(0)){case c.Undefined:return;case c.String:return H.read(l(H)).toString();case c.Buffer:return H.read(l(H)).buffer;case c.VSBuffer:return H.read(l(H));case c.Array:{const B=l(H),ee=[];for(let ne=0;ne<B;ne++)ee.push(a(H));return ee}case c.Object:return JSON.parse(H.read(l(H)).toString());case c.Int:return l(H)}}e.$ah=a;class v{constructor(V,B,ee=null,ne=1e3){this.h=V,this.j=B,this.k=ee,this.l=ne,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(se=>this.q(se)),this.m({type:200})}registerChannel(V,B){this.b.set(V,B),setTimeout(()=>this.w(V),0)}m(V){switch(V.type){case 200:{const B=this.o([V.type]);this.k?.logOutgoing(B,0,1,f(V.type));return}case 201:case 202:case 204:case 203:{const B=this.o([V.type,V.id],V.data);this.k?.logOutgoing(B,V.id,1,f(V.type),V.data);return}}}o(V,B=void 0){const ee=new t;return r(ee,V),r(ee,B),this.p(ee.buffer)}p(V){try{return this.h.send(V),V.byteLength}catch{return 0}}q(V){const B=new I(V),ee=a(B),ne=a(B),se=ee[0];switch(se){case 100:return this.k?.logIncoming(V.byteLength,ee[1],1,`${d(se)}: ${ee[2]}.${ee[3]}`,ne),this.s({type:se,id:ee[1],channelName:ee[2],name:ee[3],arg:ne});case 102:return this.k?.logIncoming(V.byteLength,ee[1],1,`${d(se)}: ${ee[2]}.${ee[3]}`,ne),this.t({type:se,id:ee[1],channelName:ee[2],name:ee[3],arg:ne});case 101:return this.k?.logIncoming(V.byteLength,ee[1],1,`${d(se)}`),this.u({type:se,id:ee[1]});case 103:return this.k?.logIncoming(V.byteLength,ee[1],1,`${d(se)}`),this.u({type:se,id:ee[1]})}}s(V){const B=this.b.get(V.channelName);if(!B){this.v(V);return}const ee=new j.$rc;let ne;try{ne=B.call(this.j,V.name,V.arg,ee.token)}catch(U){ne=Promise.reject(U)}const se=V.id;ne.then(U=>{this.m({id:se,data:U,type:201}),this.d.delete(V.id)},U=>{U instanceof Error?this.m({id:se,data:{message:U.message,name:U.name,stack:U.stack?U.stack.split?U.stack.split(`
`):U.stack:void 0},type:202}):this.m({id:se,data:U,type:203}),this.d.delete(V.id)});const K=(0,m.$kb)(()=>ee.cancel());this.d.set(V.id,K)}t(V){const B=this.b.get(V.channelName);if(!B){this.v(V);return}const ee=V.id,se=B.listen(this.j,V.name,V.arg)(K=>this.m({id:ee,data:K,type:204}));this.d.set(V.id,se)}u(V){const B=this.d.get(V.id);B&&(B.dispose(),this.d.delete(V.id))}v(V){let B=this.g.get(V.channelName);B||(B=[],this.g.set(V.channelName,B));const ee=setTimeout(()=>{console.error(`Unknown channel: ${V.channelName}`),V.type===100&&this.m({id:V.id,data:{name:"Unknown channel",message:`Channel name '${V.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);B.push({request:V,timeoutTimer:ee})}w(V){const B=this.g.get(V);if(B){for(const ee of B)switch(clearTimeout(ee.timeoutTimer),ee.request.type){case 100:this.s(ee.request);break;case 102:this.t(ee.request);break}this.g.delete(V)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,m.$hb)(this.d.values()),this.d.clear()}}e.$bh=v;var y;(function(H){H[H.LocalSide=0]="LocalSide",H[H.OtherSide=1]="OtherSide"})(y||(e.RequestInitiator=y={}));class u{constructor(V,B=null){this.l=V,this.a=!1,this.b=o.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new k.$hc,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(ee=>this.s(ee)),this.j=B}getChannel(V){const B=this;return{call(ee,ne,se){return B.a?Promise.reject(new R.$3):B.m(V,ee,ne,se)},listen(ee,ne){return B.a?k.Event.None:B.o(V,ee,ne)}}}m(V,B,ee,ne=j.CancellationToken.None){const se=this.g++,U={id:se,type:100,channelName:V,name:B,arg:ee};if(ne.isCancellationRequested)return Promise.reject(new R.$3);let S;return new Promise((z,M)=>{if(ne.isCancellationRequested)return M(new R.$3);const J=()=>{const fe=le=>{switch(le.type){case 201:this.f.delete(se),z(le.data);break;case 202:{this.f.delete(se);const $e=new Error(le.data.message);$e.stack=Array.isArray(le.data.stack)?le.data.stack.join(`
`):le.data.stack,$e.name=le.data.name,M($e);break}case 203:this.f.delete(se),M(le.data);break}};this.f.set(se,fe),this.p(U)};let _=null;this.b===o.Idle?J():(_=(0,N.$sg)(fe=>this.u()),_.then(()=>{_=null,J()}));const ae=()=>{_?(_.cancel(),_=null):this.p({id:se,type:101}),M(new R.$3)},he=ne.onCancellationRequested(ae);S=(0,m.$jb)((0,m.$kb)(ae),he),this.d.add(S)}).finally(()=>{this.d.delete(S)})}o(V,B,ee){const ne=this.g++,K={id:ne,type:102,channelName:V,name:B,arg:ee};let U=null;const S=new k.$hc({onWillAddFirstListener:()=>{U=(0,N.$sg)(z=>this.u()),U.then(()=>{U=null,this.d.add(S),this.p(K)})},onDidRemoveLastListener:()=>{U?(U.cancel(),U=null):(this.d.delete(S),this.p({id:ne,type:103}))}}),C=z=>S.fire(z.data);return this.f.set(ne,C),S.event}p(V){switch(V.type){case 100:case 102:{const B=this.q([V.type,V.id,V.channelName,V.name],V.arg);this.j?.logOutgoing(B,V.id,0,`${d(V.type)}: ${V.channelName}.${V.name}`,V.arg);return}case 101:case 103:{const B=this.q([V.type,V.id]);this.j?.logOutgoing(B,V.id,0,d(V.type));return}}}q(V,B=void 0){const ee=new t;return r(ee,V),r(ee,B),this.r(ee.buffer)}r(V){try{return this.l.send(V),V.byteLength}catch{return 0}}s(V){const B=new I(V),ee=a(B),ne=a(B),se=ee[0];switch(se){case 200:return this.j?.logIncoming(V.byteLength,0,0,f(se)),this.t({type:ee[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(V.byteLength,ee[1],0,f(se),ne),this.t({type:ee[0],id:ee[1],data:ne})}}t(V){if(V.type===200){this.b=o.Idle,this.k.fire();return}this.f.get(V.id)?.(V)}get onDidInitializePromise(){return k.Event.toPromise(this.onDidInitialize)}u(){return this.b===o.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,m.$hb)(this.d.values()),this.d.clear()}}e.$ch=u,ye([A.$4g],u.prototype,"onDidInitializePromise",null);class E{get connections(){const V=[];return this.f.forEach(B=>V.push(B)),V}constructor(V){this.a=new Map,this.f=new Set,this.g=new k.$hc,this.onDidAddConnection=this.g.event,this.h=new k.$hc,this.onDidRemoveConnection=this.h.event,V(({protocol:B,onDidClientDisconnect:ee})=>{k.Event.once(B.onMessage)(se=>{const K=new I(se),U=a(K),S=new v(B,U),C=new u(B);this.a.forEach((M,J)=>S.registerChannel(J,M));const z={channelServer:S,channelClient:C,ctx:U};this.f.add(z),this.g.fire(z),ee(()=>{S.dispose(),C.dispose(),this.f.delete(z),this.h.fire(z)})})})}getChannel(V,B){const ee=this;return{call(ne,se,K){let U;if((0,g.$ze)(B)){const C=(0,L.$Wf)(ee.connections.filter(B));U=C?Promise.resolve(C):k.Event.toPromise(k.Event.filter(ee.onDidAddConnection,B))}else U=B.routeCall(ee,ne,se);const S=U.then(C=>C.channelClient.getChannel(V));return T(S).call(ne,se,K)},listen(ne,se){if((0,g.$ze)(B))return ee.j(V,B,ne,se);const K=B.routeEvent(ee,ne,se).then(U=>U.channelClient.getChannel(V));return T(K).listen(ne,se)}}}j(V,B,ee,ne){const se=this;let K=new m.$lb;const U=new k.$hc({onWillAddFirstListener:()=>{K=new m.$lb;const S=new k.$nc,C=new Map,z=J=>{const ae=J.channelClient.getChannel(V).listen(ee,ne),he=S.add(ae);C.set(J,he)},M=J=>{const _=C.get(J);_&&(_.dispose(),C.delete(J))};se.connections.filter(B).forEach(z),k.Event.filter(se.onDidAddConnection,B)(z,void 0,K),se.onDidRemoveConnection(M,void 0,K),S.event(U.fire,U,K),K.add(S)},onDidRemoveLastListener:()=>{K.dispose()}});return U.event}registerChannel(V,B){this.a.set(V,B),this.f.forEach(ee=>{ee.channelServer.registerChannel(V,B)})}dispose(){this.a.clear(),this.f.clear(),this.g.dispose(),this.h.dispose()}}e.$dh=E;class D{constructor(V,B,ee=null){const ne=new t;r(ne,B),V.send(ne.buffer),this.a=new u(V,ee),this.d=new v(V,B,ee)}getChannel(V){return this.a.getChannel(V)}registerChannel(V,B){this.d.registerChannel(V,B)}dispose(){this.a.dispose(),this.d.dispose()}}e.$eh=D;function T(H){return{call(V,B,ee){return H.then(ne=>ne.call(V,B,ee))},listen(V,B){const ee=new k.$qc;return H.then(ne=>ee.input=ne.listen(V,B)),ee.event}}}e.$fh=T;function F(H){let V=!1;return{call(B,ee,ne){return V?H.call(B,ee,ne):(0,N.$Fg)(0).then(()=>V=!0).then(()=>H.call(B,ee,ne))},listen(B,ee){if(V)return H.listen(B,ee);const ne=new k.$qc;return(0,N.$Fg)(0).then(()=>V=!0).then(()=>ne.input=H.listen(B,ee)),ne.event}}}e.$gh=F;class q{constructor(V){this.a=V}routeCall(V){return this.b(V)}routeEvent(V){return this.b(V)}async b(V){for(const B of V.connections)if(await Promise.resolve(this.a(B.ctx)))return Promise.resolve(B);return await k.Event.toPromise(V.onDidAddConnection),await this.b(V)}}e.$hh=q;var W;(function(H){function V(se,K){const U=se,S=K&&K.disableMarshalling,C=new Map;for(const z in U)ee(z)&&C.set(z,k.Event.buffer(U[z],!0));return new class{listen(z,M,J){const _=C.get(M);if(_)return _;if(ne(M)){const ae=U[M];if(typeof ae=="function")return ae.call(U,J)}throw new R.$_(`Event not found: ${M}`)}call(z,M,J){const _=U[M];if(typeof _=="function"){if(!S&&Array.isArray(J))for(let ae=0;ae<J.length;ae++)J[ae]=(0,P.$9g)(J[ae]);return _.apply(U,J)}throw new R.$_(`Method not found: ${M}`)}}}H.fromService=V;function B(se,K){const U=K&&K.disableMarshalling;return new Proxy({},{get(S,C){if(typeof C=="string")return K?.properties?.has(C)?K.properties.get(C):ne(C)?function(z){return se.listen(C,z)}:ee(C)?se.listen(C):async function(...z){let M;K&&!(0,g.$ue)(K.context)?M=[K.context,...z]:M=z;const J=await se.call(C,M);return U?J:(0,P.$9g)(J)};throw new R.$_(`Property not found: ${String(C)}`)}})}H.toService=B;function ee(se){return se[0]==="o"&&se[1]==="n"&&p.$Nd(se.charCodeAt(2))}function ne(se){return/^onDynamic/.test(se)&&p.$Nd(se.charCodeAt(9))}})(W||(e.ProxyChannel=W={}));const Z=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function Y(H){if(Array.isArray(H))return H;if(H&&typeof H=="object"&&typeof H.toString=="function"){const V=H.toString();if(V!=="[object Object]")return V}return H}function x(H){return Array.isArray(H)?H.map(Y):Y(H)}function G(H,V,B,ee,ne,se,K){K=x(K);const U=Z[ne],S=U[ee%U.length];let C=[`%c[${H}]%c[${String(V).padStart(7," ")}]%c[len: ${String(B).padStart(5," ")}]%c${String(ee).padStart(5," ")} - ${se}`,"color: darkgreen","color: grey","color: grey",`color: ${S}`];/\($/.test(se)?(C=C.concat(K),C.push(")")):C.push(K),console.log.apply(console,C)}class Q{constructor(V,B){this.d=V,this.f=B,this.a=0,this.b=0}logOutgoing(V,B,ee,ne,se){this.b+=V,G(this.d,this.b,V,B,ee,ne,se)}logIncoming(V,B,ee,ne,se){this.a+=V,G(this.f,this.a,V,B,ee,ne,se)}}e.$ih=Q}),define(re[65],oe([0,1,14,3,2,43]),function(te,e,L,N,O,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nh=e.$mh=e.$lh=e.$kh=e.ProtocolConstants=e.$jh=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var A;(function(n){n.Created="created",n.Read="read",n.Write="write",n.Open="open",n.Error="error",n.Close="close",n.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",n.NodeEndReceived="nodeEndReceived",n.NodeEndSent="nodeEndSent",n.NodeDrainBegin="nodeDrainBegin",n.NodeDrainEnd="nodeDrainEnd",n.zlibInflateError="zlibInflateError",n.zlibInflateData="zlibInflateData",n.zlibInflateInitialWrite="zlibInflateInitialWrite",n.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",n.zlibInflateWrite="zlibInflateWrite",n.zlibInflateFlushFired="zlibInflateFlushFired",n.zlibDeflateError="zlibDeflateError",n.zlibDeflateData="zlibDeflateData",n.zlibDeflateWrite="zlibDeflateWrite",n.zlibDeflateFlushFired="zlibDeflateFlushFired",n.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",n.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",n.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",n.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",n.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",n.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",n.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",n.ProtocolHeaderRead="protocolHeaderRead",n.ProtocolMessageRead="protocolMessageRead",n.ProtocolHeaderWrite="protocolHeaderWrite",n.ProtocolMessageWrite="protocolMessageWrite",n.ProtocolWrite="protocolWrite"})(A||(e.SocketDiagnosticsEventType=A={}));var R;(function(n){n.enableDiagnostics=!1,n.records=[];const i=new WeakMap;let r=0;function a(y,u){if(!i.has(y)){const E=String(++r);i.set(y,E)}return i.get(y)}function v(y,u,E,D){if(!n.enableDiagnostics)return;const T=a(y,u);if(D instanceof L.$Hc||D instanceof Uint8Array||D instanceof ArrayBuffer||ArrayBuffer.isView(D)){const F=L.$Hc.alloc(D.byteLength);F.set(D),n.records.push({timestamp:Date.now(),id:T,label:u,type:E,buff:F})}else n.records.push({timestamp:Date.now(),id:T,label:u,type:E,data:D})}n.traceSocketEvent=v})(R||(e.SocketDiagnostics=R={}));var k;(function(n){n[n.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",n[n.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(k||(e.SocketCloseEventType=k={}));let m=null;function P(){return m||(m=L.$Hc.alloc(0)),m}class p{get byteLength(){return this.b}constructor(){this.a=[],this.b=0}acceptChunk(i){this.a.push(i),this.b+=i.byteLength}read(i){return this.c(i,!0)}peek(i){return this.c(i,!1)}c(i,r){if(i===0)return P();if(i>this.b)throw new Error("Cannot read so many bytes!");if(this.a[0].byteLength===i){const u=this.a[0];return r&&(this.a.shift(),this.b-=i),u}if(this.a[0].byteLength>i){const u=this.a[0].slice(0,i);return r&&(this.a[0]=this.a[0].slice(i),this.b-=i),u}const a=L.$Hc.alloc(i);let v=0,y=0;for(;i>0;){const u=this.a[y];if(u.byteLength>i){const E=u.slice(0,i);a.set(E,v),v+=i,r&&(this.a[y]=u.slice(i),this.b-=i),i-=i}else a.set(u,v),v+=u.byteLength,r?(this.a.shift(),this.b-=u.byteLength):y++,i-=u.byteLength}return a}}e.$jh=p;var g;(function(n){n[n.None=0]="None",n[n.Regular=1]="Regular",n[n.Control=2]="Control",n[n.Ack=3]="Ack",n[n.Disconnect=5]="Disconnect",n[n.ReplayRequest=6]="ReplayRequest",n[n.Pause=7]="Pause",n[n.Resume=8]="Resume",n[n.KeepAlive=9]="KeepAlive"})(g||(g={}));function h(n){switch(n){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting";case 9:return"KeepAlive"}}var d;(function(n){n[n.HeaderLength=13]="HeaderLength",n[n.AcknowledgeTime=2e3]="AcknowledgeTime",n[n.TimeoutTime=2e4]="TimeoutTime",n[n.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",n[n.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime",n[n.KeepAliveSendTime=5e3]="KeepAliveSendTime"})(d||(e.ProtocolConstants=d={}));class w{constructor(i,r,a,v){this.type=i,this.id=r,this.ack=a,this.data=v,this.writtenTime=0}get size(){return this.data.byteLength}}class f extends O.$mb{constructor(i){super(),this.f=this.B(new N.$hc),this.onMessage=this.f.event,this.g={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this.a=i,this.b=!1,this.c=new p,this.B(this.a.onData(r=>this.acceptChunk(r))),this.lastReadTime=Date.now()}acceptChunk(i){if(!(!i||i.byteLength===0))for(this.lastReadTime=Date.now(),this.c.acceptChunk(i);this.c.byteLength>=this.g.readLen;){const r=this.c.read(this.g.readLen);if(this.g.readHead)this.g.readHead=!1,this.g.readLen=r.readUInt32BE(9),this.g.messageType=r.readUInt8(0),this.g.id=r.readUInt32BE(1),this.g.ack=r.readUInt32BE(5),this.a.traceSocketEvent("protocolHeaderRead",{messageType:h(this.g.messageType),id:this.g.id,ack:this.g.ack,messageSize:this.g.readLen});else{const a=this.g.messageType,v=this.g.id,y=this.g.ack;if(this.g.readHead=!0,this.g.readLen=13,this.g.messageType=0,this.g.id=0,this.g.ack=0,this.a.traceSocketEvent("protocolMessageRead",r),this.f.fire(new w(a,v,y,r)),this.b)break}}}readEntireBuffer(){return this.c.read(this.c.byteLength)}dispose(){this.b=!0,super.dispose()}}class o{constructor(i){this.k=null,this.a=!1,this.b=!1,this.c=i,this.d=[],this.f=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this.a=!0}drain(){return this.flush(),this.c.drain()}flush(){this.m()}pause(){this.b=!0}resume(){this.b=!1,this.l()}write(i){if(this.a)return;i.writtenTime=Date.now(),this.lastWriteTime=Date.now();const r=L.$Hc.alloc(13);r.writeUInt8(i.type,0),r.writeUInt32BE(i.id,1),r.writeUInt32BE(i.ack,5),r.writeUInt32BE(i.data.byteLength,9),this.c.traceSocketEvent("protocolHeaderWrite",{messageType:h(i.type),id:i.id,ack:i.ack,messageSize:i.data.byteLength}),this.c.traceSocketEvent("protocolMessageWrite",i.data),this.j(r,i.data)}g(i,r){const a=this.f===0;return this.d.push(i,r),this.f+=i.byteLength+r.byteLength,a}h(){const i=L.$Hc.concat(this.d,this.f);return this.d.length=0,this.f=0,i}j(i,r){this.g(i,r)&&this.l()}l(){this.k||(this.k=setTimeout(()=>{this.k=null,this.m()}))}m(){if(this.f===0||this.b)return;const i=this.h();this.c.traceSocketEvent("protocolWrite",{byteLength:i.byteLength}),this.c.write(i)}}class l extends O.$mb{constructor(i){super(),this.f=new N.$hc,this.onMessage=this.f.event,this.g=new N.$hc,this.onDidDispose=this.g.event,this.a=i,this.b=this.B(new o(this.a)),this.c=this.B(new f(this.a)),this.B(this.c.onMessage(r=>{r.type===1&&this.f.fire(r.data)})),this.B(this.a.onClose(()=>this.g.fire()))}drain(){return this.b.drain()}getSocket(){return this.a}sendDisconnect(){}send(i){this.b.write(new w(1,0,0,i))}}e.$kh=l;class $ extends j.$eh{static fromSocket(i,r){return new $(new l(i),r)}get onDidDispose(){return this.b.onDidDispose}constructor(i,r,a=null){super(i,r,a),this.b=i}dispose(){super.dispose();const i=this.b.getSocket();this.b.sendDisconnect(),this.b.dispose(),i.end()}}e.$lh=$;class b{constructor(){this.b=!1,this.c=!1,this.d=[],this.a=new N.$hc({onWillAddFirstListener:()=>{this.b=!0,queueMicrotask(()=>this.f())},onDidRemoveLastListener:()=>{this.b=!1}}),this.event=this.a.event}f(){if(!this.c){for(this.c=!0;this.b&&this.d.length>0;)this.a.fire(this.d.shift());this.c=!1}}fire(i){this.b?this.d.length>0?this.d.push(i):this.a.fire(i):this.d.push(i)}flushBuffer(){this.d=[]}}e.$mh=b;class I{constructor(i){this.data=i,this.next=null}}class t{constructor(){this.a=null,this.b=null}length(){let i=0,r=this.a;for(;r;)r=r.next,i++;return i}peek(){return this.a?this.a.data:null}toArray(){const i=[];let r=0,a=this.a;for(;a;)i[r++]=a.data,a=a.next;return i}pop(){if(this.a){if(this.a===this.b){this.a=null,this.b=null;return}this.a=this.a.next}}push(i){const r=new I(i);if(!this.a){this.a=r,this.b=r;return}this.b.next=r,this.b=r}}class c{static{this.a=10}static{this.b=null}static getInstance(){return c.b||(c.b=new c),c.b}constructor(){this.c=[];const i=Date.now();for(let r=0;r<c.a;r++)this.c[r]=i-1e3*r;setInterval(()=>{for(let r=c.a;r>=1;r--)this.c[r]=this.c[r-1];this.c[0]=Date.now()},1e3)}d(){const i=Date.now(),r=(1+c.a)*1e3;let a=0;for(let v=0;v<c.a;v++)i-this.c[v]<=r&&a++;return 1-a/c.a}hasHighLoad(){return this.d()>=.5}}class s{get unacknowledgedCount(){return this.c-this.d}constructor(i){this.u=new b,this.onControlMessage=this.u.event,this.v=new b,this.onMessage=this.v.event,this.w=new b,this.onDidDispose=this.w.event,this.x=new b,this.onSocketClose=this.x.event,this.y=new b,this.onSocketTimeout=this.y.event,this.s=i.loadEstimator??c.getInstance(),this.t=i.sendKeepAlive??!0,this.a=!1,this.b=new t,this.c=0,this.d=0,this.f=null,this.g=0,this.h=0,this.j=0,this.k=null,this.m=0,this.n=Date.now(),this.r=new O.$lb,this.o=i.socket,this.p=this.r.add(new o(this.o)),this.q=this.r.add(new f(this.o)),this.r.add(this.q.onMessage(r=>this.z(r))),this.r.add(this.o.onClose(r=>this.x.fire(r))),i.initialChunk&&this.q.acceptChunk(i.initialChunk),this.t?this.l=setInterval(()=>{this.D()},5e3):this.l=null}dispose(){this.f&&(clearTimeout(this.f),this.f=null),this.k&&(clearTimeout(this.k),this.k=null),this.l&&(clearInterval(this.l),this.l=null),this.r.dispose()}drain(){return this.p.drain()}sendDisconnect(){const i=new w(5,0,0,P());this.p.write(i),this.p.flush()}sendPause(){const i=new w(7,0,0,P());this.p.write(i)}sendResume(){const i=new w(8,0,0,P());this.p.write(i)}pauseSocketWriting(){this.p.pause()}getSocket(){return this.o}getMillisSinceLastIncomingData(){return Date.now()-this.q.lastReadTime}beginAcceptReconnection(i,r){this.a=!0,this.r.dispose(),this.r=new O.$lb,this.u.flushBuffer(),this.x.flushBuffer(),this.y.flushBuffer(),this.o.dispose(),this.m=0,this.n=Date.now(),this.o=i,this.p=this.r.add(new o(this.o)),this.q=this.r.add(new f(this.o)),this.r.add(this.q.onMessage(a=>this.z(a))),this.r.add(this.o.onClose(a=>this.x.fire(a))),this.q.acceptChunk(r)}endAcceptReconnection(){this.a=!1,this.h=this.g;const i=new w(3,0,this.h,P());this.p.write(i);const r=this.b.toArray();for(let a=0,v=r.length;a<v;a++)this.p.write(r[a]);this.B()}acceptDisconnect(){this.w.fire()}z(i){if(i.ack>this.d){this.d=i.ack;do{const r=this.b.peek();if(r&&r.id<=i.ack)this.b.pop();else break}while(!0)}switch(i.type){case 0:break;case 1:{if(i.id>this.g)if(i.id!==this.g+1){const r=Date.now();r-this.m>1e4&&(this.m=r,this.p.write(new w(6,0,0,P())))}else this.g=i.id,this.j=Date.now(),this.A(),this.v.fire(i.data);break}case 2:{this.u.fire(i.data);break}case 3:break;case 5:{this.w.fire();break}case 6:{const r=this.b.toArray();for(let a=0,v=r.length;a<v;a++)this.p.write(r[a]);this.B();break}case 7:{this.p.pause();break}case 8:{this.p.resume();break}case 9:break}}readEntireBuffer(){return this.q.readEntireBuffer()}flush(){this.p.flush()}send(i){const r=++this.c;this.h=this.g;const a=new w(1,r,this.h,i);this.b.push(a),this.a||(this.p.write(a),this.B())}sendControl(i){const r=new w(2,0,0,i);this.p.write(r)}A(){if(this.g<=this.h||this.k)return;const i=Date.now()-this.j;if(i>=2e3){this.C();return}this.k=setTimeout(()=>{this.k=null,this.A()},2e3-i+5)}B(){if(this.c<=this.d||this.f||this.a)return;const i=this.b.peek(),r=Date.now()-i.writtenTime,a=Date.now()-this.q.lastReadTime,v=Date.now()-this.n;if(r>=2e4&&a>=2e4&&v>=2e4&&!this.s.hasHighLoad()){this.n=Date.now(),this.y.fire({unacknowledgedMsgCount:this.b.length(),timeSinceOldestUnacknowledgedMsg:r,timeSinceLastReceivedSomeData:a});return}const y=Math.max(2e4-r,2e4-a,2e4-v,500);this.f=setTimeout(()=>{this.f=null,this.B()},y)}C(){if(this.g<=this.h)return;this.h=this.g;const i=new w(3,0,this.h,P());this.p.write(i)}D(){this.h=this.g;const i=new w(9,0,this.h,P());this.p.write(i)}}e.$nh=s}),define(re[93],oe([0,1,64,5,14,26,141,8,3,2,30,144,90,43]),function(te,e,L,N,O,j,A,R,k,m,P,p,g,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pp=e.$Op=void 0;class d extends h.$bh{constructor(o){super({send:l=>{try{process.send?.(l.buffer.toString("base64"))}catch{}},onMessage:k.Event.fromNodeEventEmitter(process,"message",l=>O.$Hc.wrap(Buffer.from(l,"base64")))},o),process.once("disconnect",()=>this.dispose())}}e.$Op=d;class w{constructor(o,l){this.i=o,this.j=l,this.c=new Set,this.g=new Map,this.h=new k.$hc,this.onDidProcessExit=this.h.event;const $=l&&l.timeout?l.timeout:6e4;this.b=new N.$Bg($),this.d=null,this.f=null}getChannel(o){const l=this;return{call($,b,I){return l.k(o,$,b,I)},listen($,b){return l.l(o,$,b)}}}k(o,l,$,b=j.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(b.isCancellationRequested)return Promise.reject(R.$4());this.b.cancel();const I=this.n(o),t=(0,N.$sg)(n=>I.call(l,$,n)),c=b.onCancellationRequested(()=>t.cancel()),s=(0,m.$kb)(()=>t.cancel());return this.c.add(s),t.finally(()=>{c.dispose(),this.c.delete(s),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),t}l(o,l,$){if(!this.b)return k.Event.None;this.b.cancel();let b;const I=new k.$hc({onWillAddFirstListener:()=>{b=this.n(o).listen(l,$)(I.fire,I),this.c.add(b)},onDidRemoveLastListener:()=>{this.c.delete(b),b.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return I.event}get m(){if(!this.f){const o=this.j&&this.j.args?this.j.args:[],l=Object.create(null);l.env={...(0,P.$Tm)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(l.env={...l.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(l.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(l.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(l.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),l.execArgv===void 0&&(l.execArgv=process.execArgv.filter(i=>!/^--inspect(-brk)?=/.test(i)).filter(i=>!i.startsWith("--vscode-"))),(0,g.$rl)(l.env),this.d=(0,L.fork)(this.i,o,l);const $=new k.$hc;k.Event.fromNodeEventEmitter(this.d,"message",i=>i)(i=>{if((0,A.$Kp)(i)){(0,A.log)(i,`IPC Library: ${this.j.serverName}`);return}$.fire(O.$Hc.wrap(Buffer.from(i,"base64")))});const I=this.j.useQueue?(0,p.$tl)(this.d):this.d,t=i=>this.d&&this.d.connected&&I.send(i.buffer.toString("base64")),c=$.event,s={send:t,onMessage:c};this.f=new h.$ch(s);const n=()=>this.o();process.once("exit",n),this.d.on("error",i=>console.warn('IPC "'+this.j.serverName+'" errored with '+i)),this.d.on("exit",(i,r)=>{process.removeListener("exit",n),this.c.forEach(a=>(0,m.$hb)(a)),this.c.clear(),i!==0&&r!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+i+" and signal "+r),this.b?.cancel(),this.o(),this.h.fire({code:i,signal:r})})}return this.f}n(o){let l=this.g.get(o);return l||(l=this.m.getChannel(o),this.g.set(o,l)),l}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.$Pp=w}),define(re[146],oe([0,1,134,14,43,3,9,20]),function(te,e,L,N,O,j,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$VS=e.$US=void 0;class k{constructor(g){this.a=g,this.onMessage=j.Event.fromNodeEventEmitter(this.a,"message",h=>N.$Hc.wrap(h.data)),g.start()}send(g){this.a.postMessage(g.buffer)}disconnect(){this.a.close()}}class m extends O.$dh{static b(g){(0,A.$ve)((0,L.$TS)(process),"Electron Utility Process");const h=new j.$hc;return process.parentPort.on("message",d=>{if(g?.handledClientConnection(d))return;const w=(0,R.$Hf)(d.ports);w&&h.fire(w)}),j.Event.map(h.event,d=>({protocol:new k(d),onDidClientDisconnect:j.Event.fromNodeEventEmitter(d,"close")}))}constructor(g){super(m.b(g))}}e.$US=m;function P(p,g,h){const d=w=>{w.data===g&&(p.removeListener("message",d),h())};p.on("message",d)}e.$VS=P}),define(re[66],oe([0,1,5,3,2,63,9]),function(te,e,L,N,O,j,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Po=e.$Oo=e.StorageState=e.$No=e.StorageHint=void 0;var R;(function(g){g[g.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",g[g.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(R||(e.StorageHint=R={}));function k(g){const h=g;return h?.changed instanceof Map||h?.deleted instanceof Set}e.$No=k;var m;(function(g){g[g.None=0]="None",g[g.Initialized=1]="Initialized",g[g.Closed=2]="Closed"})(m||(e.StorageState=m={}));class P extends O.$mb{static{this.a=100}constructor(h,d=Object.create(null)){super(),this.m=h,this.n=d,this.b=this.B(new N.$kc),this.onDidChangeStorage=this.b.event,this.c=m.None,this.f=new Map,this.g=this.B(new L.$Cg(P.a)),this.h=new Set,this.j=new Map,this.k=void 0,this.l=[],this.p()}p(){this.B(this.m.onDidChangeItemsExternal(h=>this.r(h)))}r(h){this.b.pause();try{h.changed?.forEach((d,w)=>this.s(w,d)),h.deleted?.forEach(d=>this.s(d,void 0))}finally{this.b.resume()}}s(h,d){if(this.c===m.Closed)return;let w=!1;(0,A.$ue)(d)?w=this.f.delete(h):this.f.get(h)!==d&&(this.f.set(h,d),w=!0),w&&this.b.fire({key:h,external:!0})}get items(){return this.f}get size(){return this.f.size}async init(){this.c===m.None&&(this.c=m.Initialized,this.n.hint!==R.STORAGE_DOES_NOT_EXIST&&(this.f=await this.m.getItems()))}get(h,d){const w=this.f.get(h);return(0,A.$ue)(w)?d:w}getBoolean(h,d){const w=this.get(h);return(0,A.$ue)(w)?d:w==="true"}getNumber(h,d){const w=this.get(h);return(0,A.$ue)(w)?d:parseInt(w,10)}getObject(h,d){const w=this.get(h);return(0,A.$ue)(w)?d:(0,j.$8g)(w)}async set(h,d,w=!1){if(this.c===m.Closed)return;if((0,A.$ue)(d))return this.delete(h,w);const f=(0,A.$ne)(d)||Array.isArray(d)?(0,j.$7g)(d):String(d);if(this.f.get(h)!==f)return this.f.set(h,f),this.j.set(h,f),this.h.delete(h),this.b.fire({key:h,external:w}),this.w()}async delete(h,d=!1){if(!(this.c===m.Closed||!this.f.delete(h)))return this.h.has(h)||this.h.add(h),this.j.delete(h),this.b.fire({key:h,external:d}),this.w()}async optimize(){if(this.c!==m.Closed)return await this.flush(0),this.m.optimize()}async close(){return this.k||(this.k=this.t()),this.k}async t(){this.c=m.Closed;try{await this.w(0)}catch{}await this.m.close(()=>this.f)}get u(){return this.j.size>0||this.h.size>0}async v(){if(!this.u)return;const h={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.m.updateItems(h).finally(()=>{if(!this.u)for(;this.l.length;)this.l.pop()?.()})}async flush(h){if(this.u)return this.w(h)}async w(h){return this.n.hint===R.STORAGE_IN_MEMORY?this.v():this.g.trigger(()=>this.v(),h)}async whenFlushed(){if(this.u)return new Promise(h=>this.l.push(h))}isInMemory(){return this.n.hint===R.STORAGE_IN_MEMORY}}e.$Oo=P;class p{constructor(){this.onDidChangeItemsExternal=N.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(h){h.insert?.forEach((d,w)=>this.a.set(w,d)),h.delete?.forEach(d=>this.a.delete(d))}async optimize(){}async close(){}}e.$Po=p}),define(re[147],oe([12,10]),function(te,e){return te.create("vs/base/node/zip",e)}),define(re[148],oe([12,10]),function(te,e){return te.create("vs/platform/configuration/common/configurationRegistry",e)}),define(re[149],oe([12,10]),function(te,e){return te.create("vs/platform/contextkey/common/contextkey",e)}),define(re[150],oe([12,10]),function(te,e){return te.create("vs/platform/contextkey/common/scanner",e)}),define(re[151],oe([12,10]),function(te,e){return te.create("vs/platform/extensionManagement/common/abstractExtensionManagementService",e)}),define(re[152],oe([12,10]),function(te,e){return te.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(re[153],oe([12,10]),function(te,e){return te.create("vs/platform/extensionManagement/common/extensionNls",e)}),define(re[154],oe([12,10]),function(te,e){return te.create("vs/platform/extensionManagement/common/extensionsScannerService",e)}),define(re[155],oe([12,10]),function(te,e){return te.create("vs/platform/extensionManagement/node/extensionManagementService",e)}),define(re[156],oe([12,10]),function(te,e){return te.create("vs/platform/extensionManagement/node/extensionManagementUtil",e)}),define(re[157],oe([12,10]),function(te,e){return te.create("vs/platform/extensions/common/extensionValidator",e)}),define(re[158],oe([12,10]),function(te,e){return te.create("vs/platform/files/common/fileService",e)}),define(re[159],oe([12,10]),function(te,e){return te.create("vs/platform/files/common/files",e)}),define(re[160],oe([12,10]),function(te,e){return te.create("vs/platform/files/common/io",e)}),define(re[161],oe([12,10]),function(te,e){return te.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(re[162],oe([12,10]),function(te,e){return te.create("vs/platform/languagePacks/common/languagePacks",e)}),define(re[163],oe([12,10]),function(te,e){return te.create("vs/platform/remoteTunnel/common/remoteTunnel",e)}),define(re[164],oe([12,10]),function(te,e){return te.create("vs/platform/remoteTunnel/node/remoteTunnelService",e)}),define(re[165],oe([12,10]),function(te,e){return te.create("vs/platform/request/common/request",e)}),define(re[166],oe([12,10]),function(te,e){return te.create("vs/platform/telemetry/common/telemetryLogAppender",e)}),define(re[167],oe([12,10]),function(te,e){return te.create("vs/platform/telemetry/common/telemetryService",e)}),define(re[168],oe([12,10]),function(te,e){return te.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(re[169],oe([12,10]),function(te,e){return te.create("vs/platform/userDataSync/common/abstractSynchronizer",e)}),define(re[170],oe([12,10]),function(te,e){return te.create("vs/platform/userDataSync/common/keybindingsSync",e)}),define(re[171],oe([12,10]),function(te,e){return te.create("vs/platform/userDataSync/common/settingsSync",e)}),define(re[172],oe([12,10]),function(te,e){return te.create("vs/platform/userDataSync/common/userDataAutoSyncService",e)}),define(re[173],oe([12,10]),function(te,e){return te.create("vs/platform/userDataSync/common/userDataSync",e)}),define(re[174],oe([12,10]),function(te,e){return te.create("vs/platform/userDataSync/common/userDataSyncLog",e)}),define(re[175],oe([12,10]),function(te,e){return te.create("vs/platform/userDataSync/common/userDataSyncMachines",e)}),define(re[176],oe([12,10]),function(te,e){return te.create("vs/platform/userDataSync/common/userDataSyncResourceProvider",e)}),define(re[177],oe([12,10]),function(te,e){return te.create("vs/platform/workspace/common/workspace",e)}),define(re[178],oe([0,1,8,150]),function(te,e,L,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Di=e.TokenType=void 0;var O;(function(m){m[m.LParen=0]="LParen",m[m.RParen=1]="RParen",m[m.Neg=2]="Neg",m[m.Eq=3]="Eq",m[m.NotEq=4]="NotEq",m[m.Lt=5]="Lt",m[m.LtEq=6]="LtEq",m[m.Gt=7]="Gt",m[m.GtEq=8]="GtEq",m[m.RegexOp=9]="RegexOp",m[m.RegexStr=10]="RegexStr",m[m.True=11]="True",m[m.False=12]="False",m[m.In=13]="In",m[m.Not=14]="Not",m[m.And=15]="And",m[m.Or=16]="Or",m[m.Str=17]="Str",m[m.QuotedStr=18]="QuotedStr",m[m.Error=19]="Error",m[m.EOF=20]="EOF"})(O||(e.TokenType=O={}));function j(...m){switch(m.length){case 1:return(0,N.localize)(0,null,m[0]);case 2:return(0,N.localize)(1,null,m[0],m[1]);case 3:return(0,N.localize)(2,null,m[0],m[1],m[2]);default:return}}const A=(0,N.localize)(3,null),R=(0,N.localize)(4,null);class k{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(P){switch(P.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return P.isTripleEq?"===":"==";case 4:return P.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return P.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return P.lexeme;case 18:return P.lexeme;case 19:return P.lexeme;case 20:return"EOF";default:throw(0,L.$6)(`unhandled token type: ${JSON.stringify(P)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(P=>P.charCodeAt(0)))}static{this.b=new Map([["not",14],["in",13],["false",12],["true",11]])}get errors(){return this.g}reset(P){return this.c=P,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case 40:this.k(0);break;case 41:this.k(1);break;case 33:if(this.h(61)){const p=this.h(61);this.f.push({type:4,offset:this.d,isTripleEq:p})}else this.k(2);break;case 39:this.o();break;case 47:this.q();break;case 61:if(this.h(61)){const p=this.h(61);this.f.push({type:3,offset:this.d,isTripleEq:p})}else this.h(126)?this.k(9):this.l(j("==","=~"));break;case 60:this.k(this.h(61)?6:5);break;case 62:this.k(this.h(61)?8:7);break;case 38:this.h(38)?this.k(15):this.l(j("&&"));break;case 124:this.h(124)?this.k(16):this.l(j("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this.n()}return this.d=this.e,this.k(20),Array.from(this.f)}h(P){return this.r()||this.c.charCodeAt(this.e)!==P?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?0:this.c.charCodeAt(this.e)}k(P){this.f.push({type:P,offset:this.d})}l(P){const p=this.d,g=this.c.substring(this.d,this.e),h={type:19,offset:this.d,lexeme:g};this.g.push({offset:p,lexeme:g,additionalInfo:P}),this.f.push(h)}n(){this.m.lastIndex=this.d;const P=this.m.exec(this.c);if(P){this.e=this.d+P[0].length;const p=this.c.substring(this.d,this.e),g=k.b.get(p);g?this.k(g):this.f.push({type:17,lexeme:p,offset:this.d})}}o(){for(;this.j()!==39&&!this.r();)this.i();if(this.r()){this.l(A);return}this.i(),this.f.push({type:18,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let P=this.e,p=!1,g=!1;for(;;){if(P>=this.c.length){this.e=P,this.l(R);return}const d=this.c.charCodeAt(P);if(p)p=!1;else if(d===47&&!g){P++;break}else d===91?g=!0:d===92?p=!0:d===93&&(g=!1);P++}for(;P<this.c.length&&k.a.has(this.c.charCodeAt(P));)P++;this.e=P;const h=this.c.substring(this.d,this.e);this.f.push({type:10,lexeme:h,offset:this.d})}r(){return this.e>=this.c.length}}e.$Di=k}),define(re[179],oe([0,1,62,83,22,15,37,23,11]),function(te,e,L,N,O,j,A,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9l=e.$8l=e.$7l=e.$6l=void 0,e.$6l=/^([^.]+\..+):(.+)$/;class m{get appRoot(){return(0,j.$bd)(O.$4e.asFileUri("").fsPath)}get userHome(){return k.URI.file(this.b.homeDir)}get userDataPath(){return this.b.userDataDir}get appSettingsHome(){return k.URI.file((0,j.$$c)(this.userDataPath,"User"))}get tmpDir(){return k.URI.file(this.b.tmpDir)}get cacheHome(){return k.URI.file(this.userDataPath)}get stateResource(){return(0,R.$gg)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome.with({scheme:O.Schemas.vscodeUserData})}get userDataSyncHome(){return(0,R.$gg)(this.appSettingsHome,"sync")}get logsHome(){if(!this.args.logsPath){const h=(0,L.$5l)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,j.$$c)(this.userDataPath,"logs",h)}return k.URI.file(this.args.logsPath)}get sync(){return this.args.sync}get machineSettingsResource(){return(0,R.$gg)(k.URI.file((0,j.$$c)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,R.$gg)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,R.$gg)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,R.$gg)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const h=A.env.VSCODE_PORTABLE;return h?k.URI.file((0,j.$$c)(h,"argv.json")):(0,R.$gg)(this.userHome,this.c.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return k.URI.file((0,j.$$c)(this.userDataPath,"Workspaces"))}get builtinExtensionsPath(){const h=this.args["builtin-extensions-dir"];return h?(0,j.$_c)(h):(0,j.$9c)((0,j.$$c)(O.$4e.asFileUri("").fsPath,"..","extensions"))}get extensionsDownloadLocation(){const h=this.args["extensions-download-dir"];return h?k.URI.file((0,j.$_c)(h)):k.URI.file((0,j.$$c)(this.userDataPath,"CachedExtensionVSIXs"))}get extensionsPath(){const h=this.args["extensions-dir"];if(h)return(0,j.$_c)(h);const d=A.env.VSCODE_EXTENSIONS;if(d)return d;const w=A.env.VSCODE_PORTABLE;return w?(0,j.$$c)(w,"extensions"):(0,R.$gg)(this.userHome,this.c.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const h=this.args.extensionDevelopmentPath;if(Array.isArray(h))return h.map(d=>/^[^:/?#]+?:\/\//.test(d)?k.URI.parse(d):k.URI.file((0,j.$9c)(d)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(h=>h==="ui"||h==="workspace"||h==="web"?h:"workspace")}get extensionTestsLocationURI(){const h=this.args.extensionTestsPath;if(h)return/^[^:/?#]+?:\/\//.test(h)?k.URI.parse(h):k.URI.file((0,j.$9c)(h))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const h=this.args["disable-extension"];if(h){if(typeof h=="string")return[h];if(Array.isArray(h)&&h.length>0)return h}return!1}get debugExtensionHost(){return P(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!A.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find(h=>!e.$6l.test(h))}get extensionLogLevel(){const h=[];for(const d of this.args.log||[]){const w=e.$6l.exec(d);w&&w[1]&&w[2]&&h.push([w[1],w[2]])}return h.length?h:void 0}get serviceMachineIdResource(){return(0,R.$gg)(k.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get useInMemorySecretStorage(){return!!this.args["use-inmemory-secretstorage"]}get policyFile(){if(this.args["__enable-file-policy"]){const h=A.env.VSCODE_PORTABLE;return h?k.URI.file((0,j.$$c)(h,"policy.json")):(0,R.$gg)(this.userHome,this.c.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn(h){this.args.continueOn=h}get args(){return this.a}constructor(h,d,w){this.a=h,this.b=d,this.c=w,this.editSessionId=this.args.editSessionId}}e.$7l=m,ye([N.$4g],m.prototype,"appRoot",null),ye([N.$4g],m.prototype,"userHome",null),ye([N.$4g],m.prototype,"userDataPath",null),ye([N.$4g],m.prototype,"appSettingsHome",null),ye([N.$4g],m.prototype,"tmpDir",null),ye([N.$4g],m.prototype,"cacheHome",null),ye([N.$4g],m.prototype,"stateResource",null),ye([N.$4g],m.prototype,"userRoamingDataHome",null),ye([N.$4g],m.prototype,"userDataSyncHome",null),ye([N.$4g],m.prototype,"sync",null),ye([N.$4g],m.prototype,"machineSettingsResource",null),ye([N.$4g],m.prototype,"workspaceStorageHome",null),ye([N.$4g],m.prototype,"localHistoryHome",null),ye([N.$4g],m.prototype,"keyboardLayoutResource",null),ye([N.$4g],m.prototype,"argvResource",null),ye([N.$4g],m.prototype,"isExtensionDevelopment",null),ye([N.$4g],m.prototype,"untitledWorkspacesHome",null),ye([N.$4g],m.prototype,"builtinExtensionsPath",null),ye([N.$4g],m.prototype,"extensionsPath",null),ye([N.$4g],m.prototype,"extensionDevelopmentLocationURI",null),ye([N.$4g],m.prototype,"extensionDevelopmentKind",null),ye([N.$4g],m.prototype,"extensionTestsLocationURI",null),ye([N.$4g],m.prototype,"debugExtensionHost",null),ye([N.$4g],m.prototype,"logLevel",null),ye([N.$4g],m.prototype,"extensionLogLevel",null),ye([N.$4g],m.prototype,"serviceMachineIdResource",null),ye([N.$4g],m.prototype,"disableTelemetry",null),ye([N.$4g],m.prototype,"disableWorkspaceTrust",null),ye([N.$4g],m.prototype,"useInMemorySecretStorage",null),ye([N.$4g],m.prototype,"policyFile",null);function P(g,h){return p(g["inspect-extensions"],g["inspect-brk-extensions"],5870,h,g.debugId,g.extensionEnvironment)}e.$8l=P;function p(g,h,d,w,f,o){const $=Number(h||g)||(w?null:d),b=$?!!h:!1;let I;if(o)try{I=JSON.parse(o)}catch{}return{port:$,break:b,debugId:f,env:I}}e.$9l=p}),function(){"use strict";function te(e,L,N){function O(A,R){const k=j(A,R),m=[k];return e.isAbsolute(k)||m.unshift(N),e.resolve(...m)}function j(A,R){process.env.VSCODE_DEV&&(R="code-oss-dev");const k=process.env.VSCODE_PORTABLE;if(k)return e.join(k,"user-data");let m=process.env.VSCODE_APPDATA;if(m)return e.join(m,R);const P=A["user-data-dir"];if(P)return P;switch(process.platform){case"win32":if(m=process.env.APPDATA,!m){const p=process.env.USERPROFILE;if(typeof p!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");m=e.join(p,"AppData","Roaming")}break;case"darwin":m=e.join(L.homedir(),"Library","Application Support");break;case"linux":m=process.env.XDG_CONFIG_HOME||e.join(L.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(m,R)}return{getUserDataPath:O}}if(typeof define=="function")define(re[180],oe([269,36,37]),function(e,L,N){return te(e,L,N.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),L=require("os");module.exports=te(e,L,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(re[181],oe([0,1,36,179,180]),function(te,e,L,N,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_l=e.$$l=e.$0l=void 0;class j extends N.$7l{constructor(m,P){super(m,{homeDir:(0,L.homedir)(),tmpDir:(0,L.tmpdir)(),userDataDir:(0,O.getUserDataPath)(m,P.nameShort)},P)}}e.$0l=j;function A(k,m){return(0,N.$9l)(k["inspect-ptyhost"],k["inspect-brk-ptyhost"],5877,m,k.extensionEnvironment)}e.$$l=A;function R(k,m){return(0,N.$9l)(k["inspect-sharedprocess"],k["inspect-brk-sharedprocess"],5879,m,k.extensionEnvironment)}e.$_l=R}),define(re[182],oe([0,1,9,153]),function(te,e,L,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kp=void 0;function O(A,R,k,m){try{j(A,R,k,m)}catch(P){A.error(P?.message??P)}return R}e.$kp=O;function j(A,R,k,m){const P=(p,g,h)=>{const d=p[g];if((0,L.$le)(d)){const w=d,f=w.length;if(f>1&&w[0]==="%"&&w[f-1]==="%"){const o=w.substr(1,f-2);let l=k[o];l===void 0&&m&&(l=m[o]);const $=typeof l=="string"?l:l?.message,b=m?.[o],I=typeof b=="string"?b:b?.message;if(!$){I||A.warn(`[${R.name}]: ${(0,N.localize)(0,null,o)}`);return}if(h&&(g==="title"||g==="category")&&I&&I!==$){const t={value:$,original:I};p[g]=t}else p[g]=$}}else if((0,L.$ne)(d))for(const w in d)d.hasOwnProperty(w)&&(w==="commands"?P(d,w,!0):P(d,w,h));else if(Array.isArray(d))for(let w=0;w<d.length;w++)P(d,w,h)};for(const p in R)R.hasOwnProperty(p)&&P(R,p)}}),define(re[183],oe([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$I7b=e.$H7b=void 0;class L{constructor(j){this.a=j}get ignoredRecommendations(){throw new Error("not supported")}promptImportantExtensionsInstallNotification(j){return this.a.call("promptImportantExtensionsInstallNotification",[j])}promptWorkspaceRecommendations(j){throw new Error("not supported")}hasToIgnoreRecommendationNotifications(){throw new Error("not supported")}}e.$H7b=L;class N{constructor(j){this.a=j}listen(j,A){throw new Error(`Event not found: ${A}`)}call(j,A,R){switch(A){case"promptImportantExtensionsInstallNotification":return this.a.promptImportantExtensionsInstallNotification(R[0])}throw new Error(`Call not found: ${A}`)}}e.$I7b=N}),define(re[67],oe([0,1,23,89,157,53]),function(te,e,L,N,O,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fo=e.$Eo=e.$Do=e.$Co=e.$Bo=e.$Ao=e.$zo=void 0;const A=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,R=/^-(\d{4})(\d{2})(\d{2})$/;function k(o){return o=o.trim(),o==="*"||A.test(o)}e.$zo=k;function m(o){if(!k(o))return null;if(o=o.trim(),o==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const l=o.match(A);return l?{hasCaret:l[1]==="^",hasGreaterEquals:l[1]===">=",majorBase:l[2]==="x"?0:parseInt(l[2],10),majorMustEqual:l[2]!=="x",minorBase:l[4]==="x"?0:parseInt(l[4],10),minorMustEqual:l[4]!=="x",patchBase:l[6]==="x"?0:parseInt(l[6],10),patchMustEqual:l[6]!=="x",preRelease:l[8]||null}:null}e.$Ao=m;function P(o){if(!o)return null;const l=o.majorBase,$=o.majorMustEqual,b=o.minorBase;let I=o.minorMustEqual;const t=o.patchBase;let c=o.patchMustEqual;o.hasCaret&&(l===0||(I=!1),c=!1);let s=0;if(o.preRelease){const n=R.exec(o.preRelease);if(n){const[,i,r,a]=n;s=Date.UTC(Number(i),Number(r)-1,Number(a))}}return{majorBase:l,majorMustEqual:$,minorBase:b,minorMustEqual:I,patchBase:t,patchMustEqual:c,isMinimum:o.hasGreaterEquals,notBefore:s}}e.$Bo=P;function p(o,l,$){let b;typeof o=="string"?b=P(m(o)):b=o;let I;l instanceof Date?I=l.getTime():typeof l=="string"&&(I=new Date(l).getTime());let t;if(typeof $=="string"?t=P(m($)):t=$,!b||!t)return!1;const c=b.majorBase,s=b.minorBase,n=b.patchBase;let i=t.majorBase,r=t.minorBase,a=t.patchBase;const v=t.notBefore;let y=t.majorMustEqual,u=t.minorMustEqual,E=t.patchMustEqual;return t.isMinimum?c>i?!0:c<i?!1:s>r?!0:s<r||I&&I<v?!1:n>=a:(c===1&&i===0&&(!y||!u||!E)&&(i=1,r=0,a=0,y=!0,u=!1,E=!1),c<i?!1:c>i?!y:s<r?!1:s>r?!u:n<a?!1:n>a?!E:!(I&&I<v))}e.$Co=p;function g(o,l,$,b,I){const t=[];if(typeof b.publisher<"u"&&typeof b.publisher!="string")return t.push([N.default.Error,O.localize(0,null)]),t;if(typeof b.name!="string")return t.push([N.default.Error,O.localize(1,null,"name")]),t;if(typeof b.version!="string")return t.push([N.default.Error,O.localize(2,null,"version")]),t;if(!b.engines)return t.push([N.default.Error,O.localize(3,null,"engines")]),t;if(typeof b.engines.vscode!="string")return t.push([N.default.Error,O.localize(4,null,"engines.vscode")]),t;if(typeof b.extensionDependencies<"u"&&!f(b.extensionDependencies))return t.push([N.default.Error,O.localize(5,null,"extensionDependencies")]),t;if(typeof b.activationEvents<"u"){if(!f(b.activationEvents))return t.push([N.default.Error,O.localize(6,null,"activationEvents")]),t;if(typeof b.main>"u"&&typeof b.browser>"u")return t.push([N.default.Error,O.localize(7,null,"activationEvents","main","browser")]),t}if(typeof b.extensionKind<"u"&&typeof b.main>"u"&&t.push([N.default.Warning,O.localize(8,null,"extensionKind")]),typeof b.main<"u"){if(typeof b.main!="string")return t.push([N.default.Error,O.localize(9,null,"main")]),t;{const n=(0,L.$gg)($,b.main);(0,L.$ag)(n,$)||t.push([N.default.Warning,O.localize(10,null,n.path,$.path)])}}if(typeof b.browser<"u"){if(typeof b.browser!="string")return t.push([N.default.Error,O.localize(11,null,"browser")]),t;{const n=(0,L.$gg)($,b.browser);(0,L.$ag)(n,$)||t.push([N.default.Warning,O.localize(12,null,n.path,$.path)])}}if(!j.valid(b.version))return t.push([N.default.Error,O.localize(13,null)]),t;const c=[];if(!h(o,l,b,I,c))for(const n of c)t.push([N.default.Error,n]);return t}e.$Do=g;function h(o,l,$,b,I){return b||typeof $.main>"u"&&typeof $.browser>"u"?!0:w(o,l,$.engines.vscode,I)}e.$Eo=h;function d(o,l,$){return o==="*"||w(l,$,o)}e.$Fo=d;function w(o,l,$,b=[]){const I=P(m($));if(!I)return b.push(O.localize(14,null,$)),!1;if(I.majorBase===0){if(!I.majorMustEqual||!I.minorMustEqual)return b.push(O.localize(15,null,$)),!1}else if(!I.majorMustEqual)return b.push(O.localize(16,null,$)),!1;return p(o,l,I)?!0:(b.push(O.localize(17,null,o,$)),!1)}function f(o){if(!Array.isArray(o))return!1;for(let l=0,$=o.length;l<$;l++)if(typeof o[l]!="string")return!1;return!0}}),define(re[44],oe([0,1,14,32]),function(te,e,L,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yo=void 0;async function O(j,A,R){let k=R&&R.get("storage.serviceMachineId",-1)||null;if(k)return k;try{const P=(await A.readFile(j.serviceMachineIdResource)).value.toString();k=(0,N.$5e)(P)?P:null}catch{k=null}if(!k){k=(0,N.$6e)();try{await A.writeFile(j.serviceMachineIdResource,L.$Hc.fromString(k))}catch{}}return R?.store("storage.serviceMachineId",k,-1,1),k}e.$Yo=O}),define(re[68],oe([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wh=void 0;class L{constructor(O,j=[],A=!1){this.ctor=O,this.staticArguments=j,this.supportsDelayedInstantiation=A}}e.$wh=L}),define(re[184],oe([0,1,68]),function(te,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kr=e.$jr=e.InstantiationType=void 0;const N=[];var O;(function(R){R[R.Eager=0]="Eager",R[R.Delayed=1]="Delayed"})(O||(e.InstantiationType=O={}));function j(R,k,m){k instanceof L.$wh||(k=new L.$wh(k,[],!!m)),N.push([R,k])}e.$jr=j;function A(){return N}e.$kr=A}),define(re[185],oe([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2p=e.$1p=void 0;class L{constructor(j,A){this.key=j,this.data=A,this.incoming=new Map,this.outgoing=new Map}}e.$1p=L;class N{constructor(j){this.b=j,this.a=new Map}roots(){const j=[];for(const A of this.a.values())A.outgoing.size===0&&j.push(A);return j}insertEdge(j,A){const R=this.lookupOrInsertNode(j),k=this.lookupOrInsertNode(A);R.outgoing.set(k.key,k),k.incoming.set(R.key,R)}removeNode(j){const A=this.b(j);this.a.delete(A);for(const R of this.a.values())R.outgoing.delete(A),R.incoming.delete(A)}lookupOrInsertNode(j){const A=this.b(j);let R=this.a.get(A);return R||(R=new L(A,j),this.a.set(A,R)),R}lookup(j){return this.a.get(this.b(j))}isEmpty(){return this.a.size===0}toString(){const j=[];for(const[A,R]of this.a)j.push(`${A}
	(-> incoming)[${[...R.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...R.outgoing.keys()].join(",")}]
`);return j.join(`
`)}findCycleSlow(){for(const[j,A]of this.a){const R=new Set([j]),k=this.c(A,R);if(k)return k}}c(j,A){for(const[R,k]of j.outgoing){if(A.has(R))return[...A,R].join(" -> ");A.add(R);const m=this.c(k,A);if(m)return m;A.delete(R)}}}e.$2p=N}),define(re[4],oe([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ah=e.$zh=e.$yh=e._util=void 0;var L;(function(A){A.serviceIds=new Map,A.DI_TARGET="$di$target",A.DI_DEPENDENCIES="$di$dependencies";function R(k){return k[A.DI_DEPENDENCIES]||[]}A.getServiceDependencies=R})(L||(e._util=L={})),e.$yh=O("instantiationService");function N(A,R,k){R[L.DI_TARGET]===R?R[L.DI_DEPENDENCIES].push({id:A,index:k}):(R[L.DI_DEPENDENCIES]=[{id:A,index:k}],R[L.DI_TARGET]=R)}function O(A){if(L.serviceIds.has(A))return L.serviceIds.get(A);const R=function(k,m,P){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");N(R,k,P)};return R.toString=()=>A,L.serviceIds.set(A,R),R}e.$zh=O;function j(A){return A}e.$Ah=j}),define(re[186],oe([0,1,4]),function(te,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$e7b=void 0,e.$e7b=(0,L.$zh)("checksumService")}),define(re[18],oe([0,1,9,11,4]),function(te,e,L,N,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$di=e.$ci=e.$bi=e.$ai=e.$_h=e.$$h=e.$0h=e.$9h=e.ConfigurationTarget=e.$8h=e.$7h=e.$6h=void 0,e.$6h=(0,O.$zh)("configurationService");function j(o){return o&&typeof o=="object"&&(!o.overrideIdentifier||typeof o.overrideIdentifier=="string")&&(!o.resource||o.resource instanceof N.URI)}e.$7h=j;function A(o){return o&&typeof o=="object"&&(!o.overrideIdentifiers||Array.isArray(o.overrideIdentifiers))&&!o.overrideIdentifier&&(!o.resource||o.resource instanceof N.URI)}e.$8h=A;var R;(function(o){o[o.APPLICATION=1]="APPLICATION",o[o.USER=2]="USER",o[o.USER_LOCAL=3]="USER_LOCAL",o[o.USER_REMOTE=4]="USER_REMOTE",o[o.WORKSPACE=5]="WORKSPACE",o[o.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",o[o.DEFAULT=7]="DEFAULT",o[o.MEMORY=8]="MEMORY"})(R||(e.ConfigurationTarget=R={}));function k(o){switch(o){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.$9h=k;function m(o){return o.applicationValue!==void 0||o.userValue!==void 0||o.userLocalValue!==void 0||o.userRemoteValue!==void 0||o.workspaceValue!==void 0||o.workspaceFolderValue!==void 0}e.$0h=m;function P(o,l){const $=Object.create(null);for(const b in o)p($,b,o[b],l);return $}e.$$h=P;function p(o,l,$,b){const I=l.split("."),t=I.pop();let c=o;for(let s=0;s<I.length;s++){const n=I[s];let i=c[n];switch(typeof i){case"undefined":i=c[n]=Object.create(null);break;case"object":break;default:b(`Ignoring ${l} as ${I.slice(0,s+1).join(".")} is ${JSON.stringify(i)}`);return}c=i}if(typeof c=="object"&&c!==null)try{c[t]=$}catch{b(`Ignoring ${l} as ${I.join(".")} is ${JSON.stringify(c)}`)}else b(`Ignoring ${l} as ${I.join(".")} is ${JSON.stringify(c)}`)}e.$_h=p;function g(o,l){const $=l.split(".");h(o,$)}e.$ai=g;function h(o,l){const $=l.shift();if(l.length===0){delete o[$];return}if(Object.keys(o).indexOf($)!==-1){const b=o[$];typeof b=="object"&&!Array.isArray(b)&&(h(b,l),Object.keys(b).length===0&&delete o[$])}}function d(o,l,$){function b(c,s){let n=c;for(const i of s){if(typeof n!="object"||n===null)return;n=n[i]}return n}const I=l.split("."),t=b(o,I);return typeof t>"u"?$:t}e.$bi=d;function w(o,l,$){Object.keys(l).forEach(b=>{b!=="__proto__"&&(b in o?L.$ne(o[b])&&L.$ne(l[b])?w(o[b],l[b],$):$&&(o[b]=l[b]):o[b]=l[b])})}e.$ci=w;function f(o){return o.replace(/[\[\]]/g,"")}e.$di=f}),define(re[94],oe([0,1,6,28,178,4,149,8]),function(te,e,L,N,O,j,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2i=e.$1i=e.$Zi=e.$Yi=e.$Xi=e.$Wi=e.$Vi=e.$Ui=e.$Ti=e.$Si=e.$Ri=e.$Qi=e.$Pi=e.$Oi=e.$Ni=e.$Mi=e.$Li=e.$Ki=e.$Ji=e.$Ii=e.$Hi=e.$Gi=e.$Fi=e.ContextKeyExprType=e.$Ei=void 0;const k=new Map;k.set("false",!1),k.set("true",!0),k.set("isMac",L.$j),k.set("isLinux",L.$k),k.set("isWindows",L.$i),k.set("isWeb",L.$o),k.set("isMacNative",L.$j&&!L.$o),k.set("isEdge",L.$G),k.set("isFirefox",L.$E),k.set("isChrome",L.$D),k.set("isSafari",L.$F);function m(U,S){if(k.get(U)!==void 0)throw(0,R.$5)("contextkey.setConstant(k, v) invoked with already set constant `k`");k.set(U,S)}e.$Ei=m;const P=Object.prototype.hasOwnProperty;var p;(function(U){U[U.False=0]="False",U[U.True=1]="True",U[U.Defined=2]="Defined",U[U.Not=3]="Not",U[U.Equals=4]="Equals",U[U.NotEquals=5]="NotEquals",U[U.And=6]="And",U[U.Regex=7]="Regex",U[U.NotRegex=8]="NotRegex",U[U.Or=9]="Or",U[U.In=10]="In",U[U.NotIn=11]="NotIn",U[U.Greater=12]="Greater",U[U.GreaterEquals=13]="GreaterEquals",U[U.Smaller=14]="Smaller",U[U.SmallerEquals=15]="SmallerEquals"})(p||(e.ContextKeyExprType=p={}));const g={regexParsingWithErrorRecovery:!0},h=(0,A.localize)(0,null),d=(0,A.localize)(1,null),w=(0,A.localize)(2,null),f=(0,A.localize)(3,null),o=(0,A.localize)(4,null),l=(0,A.localize)(5,null),$=(0,A.localize)(6,null),b=(0,A.localize)(7,null);class I{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(S=g){this.k=S,this.d=new O.$Di,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(S){if(S===""){this.h.push({message:h,offset:0,lexeme:"",additionalInfo:d});return}this.f=this.d.reset(S).scan(),this.g=0,this.h=[];try{const C=this.l();if(!this.E()){const z=this.D(),M=z.type===17?l:void 0;throw this.h.push({message:o,offset:z.offset,lexeme:O.$Di.getLexeme(z),additionalInfo:M}),I.c}return C}catch(C){if(C!==I.c)throw C;return}}l(){return this.m()}m(){const S=[this.o()];for(;this.y(16);){const C=this.o();S.push(C)}return S.length===1?S[0]:t.or(...S)}o(){const S=[this.s()];for(;this.y(15);){const C=this.s();S.push(C)}return S.length===1?S[0]:t.and(...S)}s(){if(this.y(2)){const S=this.D();switch(S.type){case 11:return this.z(),i.INSTANCE;case 12:return this.z(),r.INSTANCE;case 0:{this.z();const C=this.l();return this.A(1,f),C?.negate()}case 17:return this.z(),D.create(S.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",S)}}return this.t()}t(){const S=this.D();switch(S.type){case 11:return this.z(),t.true();case 12:return this.z(),t.false();case 0:{this.z();const C=this.l();return this.A(1,f),C}case 17:{const C=S.lexeme;if(this.z(),this.y(9)){const M=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),M.type!==10)throw this.B("REGEX",M);const J=M.lexeme,_=J.lastIndexOf("/"),ae=_===J.length-1?void 0:this.w(J.substring(_+1));let he;try{he=new RegExp(J.substring(1,_),ae)}catch{throw this.B("REGEX",M)}return Y.create(C,he)}switch(M.type){case 10:case 19:{const J=[M.lexeme];this.z();let _=this.D(),ae=0;for(let de=0;de<M.lexeme.length;de++)M.lexeme.charCodeAt(de)===40?ae++:M.lexeme.charCodeAt(de)===41&&ae--;for(;!this.E()&&_.type!==15&&_.type!==16;){switch(_.type){case 0:ae++;break;case 1:ae--;break;case 10:case 18:for(let de=0;de<_.lexeme.length;de++)_.lexeme.charCodeAt(de)===40?ae++:M.lexeme.charCodeAt(de)===41&&ae--}if(ae<0)break;J.push(O.$Di.getLexeme(_)),this.z(),_=this.D()}const he=J.join(""),fe=he.lastIndexOf("/"),le=fe===he.length-1?void 0:this.w(he.substring(fe+1));let $e;try{$e=new RegExp(he.substring(1,fe),le)}catch{throw this.B("REGEX",M)}return t.regex(C,$e)}case 18:{const J=M.lexeme;this.z();let _=null;if(!(0,N.$od)(J)){const ae=J.indexOf("/"),he=J.lastIndexOf("/");if(ae!==he&&ae>=0){const fe=J.slice(ae+1,he),le=J[he+1]==="i"?"i":"";try{_=new RegExp(fe,le)}catch{throw this.B("REGEX",M)}}}if(_===null)throw this.B("REGEX",M);return Y.create(C,_)}default:throw this.B("REGEX",this.D())}}if(this.y(14)){this.A(13,w);const M=this.u();return t.notIn(C,M)}switch(this.D().type){case 3:{this.z();const M=this.u();if(this.x().type===18)return t.equals(C,M);switch(M){case"true":return t.has(C);case"false":return t.not(C);default:return t.equals(C,M)}}case 4:{this.z();const M=this.u();if(this.x().type===18)return t.notEquals(C,M);switch(M){case"true":return t.not(C);case"false":return t.has(C);default:return t.notEquals(C,M)}}case 5:return this.z(),W.create(C,this.u());case 6:return this.z(),Z.create(C,this.u());case 7:return this.z(),F.create(C,this.u());case 8:return this.z(),q.create(C,this.u());case 13:return this.z(),t.in(C,this.u());default:return t.has(C)}}case 20:throw this.h.push({message:$,offset:S.offset,lexeme:"",additionalInfo:b}),I.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const S=this.D();switch(S.type){case 17:case 18:return this.z(),S.lexeme;case 11:return this.z(),"true";case 12:return this.z(),"false";case 13:return this.z(),"in";default:return""}}w(S){return S.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(S){return this.C(S)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(S,C){if(this.C(S))return this.z();throw this.B(C,this.D())}B(S,C,z){const M=(0,A.localize)(8,null,S,O.$Di.getLexeme(C)),J=C.offset,_=O.$Di.getLexeme(C);return this.h.push({message:M,offset:J,lexeme:_,additionalInfo:z}),I.c}C(S){return this.D().type===S}D(){return this.f[this.g]}E(){return this.D().type===20}}e.$Fi=I;class t{static false(){return i.INSTANCE}static true(){return r.INSTANCE}static has(S){return a.create(S)}static equals(S,C){return v.create(S,C)}static notEquals(S,C){return E.create(S,C)}static regex(S,C){return Y.create(S,C)}static in(S,C){return y.create(S,C)}static notIn(S,C){return u.create(S,C)}static not(S){return D.create(S)}static and(...S){return Q.create(S,null,!0)}static or(...S){return H.create(S,null,!0)}static greater(S,C){return F.create(S,C)}static greaterEquals(S,C){return q.create(S,C)}static smaller(S,C){return W.create(S,C)}static smallerEquals(S,C){return Z.create(S,C)}static{this.c=new I({regexParsingWithErrorRecovery:!1})}static deserialize(S){return S==null?void 0:this.c.parse(S)}}e.$Gi=t;function c(U){const S=new I({regexParsingWithErrorRecovery:!1});return U.map(C=>(S.parse(C),S.lexingErrors.length>0?S.lexingErrors.map(z=>({errorMessage:z.additionalInfo?(0,A.localize)(9,null,z.additionalInfo):(0,A.localize)(10,null),offset:z.offset,length:z.lexeme.length})):S.parsingErrors.length>0?S.parsingErrors.map(z=>({errorMessage:z.additionalInfo?`${z.message}. ${z.additionalInfo}`:z.message,offset:z.offset,length:z.lexeme.length})):[]))}e.$Hi=c;function s(U,S){const C=U?U.substituteConstants():void 0,z=S?S.substituteConstants():void 0;return!C&&!z?!0:!C||!z?!1:C.equals(z)}e.$Ii=s;function n(U,S){return U.cmp(S)}class i{static{this.INSTANCE=new i}constructor(){this.type=0}cmp(S){return this.type-S.type}equals(S){return S.type===this.type}substituteConstants(){return this}evaluate(S){return!1}serialize(){return"false"}keys(){return[]}map(S){return this}negate(){return r.INSTANCE}}e.$Ji=i;class r{static{this.INSTANCE=new r}constructor(){this.type=1}cmp(S){return this.type-S.type}equals(S){return S.type===this.type}substituteConstants(){return this}evaluate(S){return!0}serialize(){return"true"}keys(){return[]}map(S){return this}negate(){return i.INSTANCE}}e.$Ki=r;class a{static create(S,C=null){const z=k.get(S);return typeof z=="boolean"?z?r.INSTANCE:i.INSTANCE:new a(S,C)}constructor(S,C){this.key=S,this.c=C,this.type=2}cmp(S){return S.type!==this.type?this.type-S.type:B(this.key,S.key)}equals(S){return S.type===this.type?this.key===S.key:!1}substituteConstants(){const S=k.get(this.key);return typeof S=="boolean"?S?r.INSTANCE:i.INSTANCE:this}evaluate(S){return!!S.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(S){return S.mapDefined(this.key)}negate(){return this.c||(this.c=D.create(this.key,this)),this.c}}e.$Li=a;class v{static create(S,C,z=null){if(typeof C=="boolean")return C?a.create(S,z):D.create(S,z);const M=k.get(S);return typeof M=="boolean"?C===(M?"true":"false")?r.INSTANCE:i.INSTANCE:new v(S,C,z)}constructor(S,C,z){this.c=S,this.d=C,this.f=z,this.type=4}cmp(S){return S.type!==this.type?this.type-S.type:ee(this.c,this.d,S.c,S.d)}equals(S){return S.type===this.type?this.c===S.c&&this.d===S.d:!1}substituteConstants(){const S=k.get(this.c);if(typeof S=="boolean"){const C=S?"true":"false";return this.d===C?r.INSTANCE:i.INSTANCE}return this}evaluate(S){return S.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(S){return S.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=E.create(this.c,this.d,this)),this.f}}e.$Mi=v;class y{static create(S,C){return new y(S,C)}constructor(S,C){this.d=S,this.f=C,this.type=10,this.c=null}cmp(S){return S.type!==this.type?this.type-S.type:ee(this.d,this.f,S.d,S.f)}equals(S){return S.type===this.type?this.d===S.d&&this.f===S.f:!1}substituteConstants(){return this}evaluate(S){const C=S.getValue(this.f),z=S.getValue(this.d);return Array.isArray(C)?C.includes(z):typeof z=="string"&&typeof C=="object"&&C!==null?P.call(C,z):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(S){return S.mapIn(this.d,this.f)}negate(){return this.c||(this.c=u.create(this.d,this.f)),this.c}}e.$Ni=y;class u{static create(S,C){return new u(S,C)}constructor(S,C){this.d=S,this.f=C,this.type=11,this.c=y.create(S,C)}cmp(S){return S.type!==this.type?this.type-S.type:this.c.cmp(S.c)}equals(S){return S.type===this.type?this.c.equals(S.c):!1}substituteConstants(){return this}evaluate(S){return!this.c.evaluate(S)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(S){return S.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$Oi=u;class E{static create(S,C,z=null){if(typeof C=="boolean")return C?D.create(S,z):a.create(S,z);const M=k.get(S);return typeof M=="boolean"?C===(M?"true":"false")?i.INSTANCE:r.INSTANCE:new E(S,C,z)}constructor(S,C,z){this.c=S,this.d=C,this.f=z,this.type=5}cmp(S){return S.type!==this.type?this.type-S.type:ee(this.c,this.d,S.c,S.d)}equals(S){return S.type===this.type?this.c===S.c&&this.d===S.d:!1}substituteConstants(){const S=k.get(this.c);if(typeof S=="boolean"){const C=S?"true":"false";return this.d===C?i.INSTANCE:r.INSTANCE}return this}evaluate(S){return S.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(S){return S.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=v.create(this.c,this.d,this)),this.f}}e.$Pi=E;class D{static create(S,C=null){const z=k.get(S);return typeof z=="boolean"?z?i.INSTANCE:r.INSTANCE:new D(S,C)}constructor(S,C){this.c=S,this.d=C,this.type=3}cmp(S){return S.type!==this.type?this.type-S.type:B(this.c,S.c)}equals(S){return S.type===this.type?this.c===S.c:!1}substituteConstants(){const S=k.get(this.c);return typeof S=="boolean"?S?i.INSTANCE:r.INSTANCE:this}evaluate(S){return!S.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(S){return S.mapNot(this.c)}negate(){return this.d||(this.d=a.create(this.c,this)),this.d}}e.$Qi=D;function T(U,S){if(typeof U=="string"){const C=parseFloat(U);isNaN(C)||(U=C)}return typeof U=="string"||typeof U=="number"?S(U):i.INSTANCE}class F{static create(S,C,z=null){return T(C,M=>new F(S,M,z))}constructor(S,C,z){this.c=S,this.d=C,this.f=z,this.type=12}cmp(S){return S.type!==this.type?this.type-S.type:ee(this.c,this.d,S.c,S.d)}equals(S){return S.type===this.type?this.c===S.c&&this.d===S.d:!1}substituteConstants(){return this}evaluate(S){return typeof this.d=="string"?!1:parseFloat(S.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(S){return S.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=Z.create(this.c,this.d,this)),this.f}}e.$Ri=F;class q{static create(S,C,z=null){return T(C,M=>new q(S,M,z))}constructor(S,C,z){this.c=S,this.d=C,this.f=z,this.type=13}cmp(S){return S.type!==this.type?this.type-S.type:ee(this.c,this.d,S.c,S.d)}equals(S){return S.type===this.type?this.c===S.c&&this.d===S.d:!1}substituteConstants(){return this}evaluate(S){return typeof this.d=="string"?!1:parseFloat(S.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(S){return S.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=W.create(this.c,this.d,this)),this.f}}e.$Si=q;class W{static create(S,C,z=null){return T(C,M=>new W(S,M,z))}constructor(S,C,z){this.c=S,this.d=C,this.f=z,this.type=14}cmp(S){return S.type!==this.type?this.type-S.type:ee(this.c,this.d,S.c,S.d)}equals(S){return S.type===this.type?this.c===S.c&&this.d===S.d:!1}substituteConstants(){return this}evaluate(S){return typeof this.d=="string"?!1:parseFloat(S.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(S){return S.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=q.create(this.c,this.d,this)),this.f}}e.$Ti=W;class Z{static create(S,C,z=null){return T(C,M=>new Z(S,M,z))}constructor(S,C,z){this.c=S,this.d=C,this.f=z,this.type=15}cmp(S){return S.type!==this.type?this.type-S.type:ee(this.c,this.d,S.c,S.d)}equals(S){return S.type===this.type?this.c===S.c&&this.d===S.d:!1}substituteConstants(){return this}evaluate(S){return typeof this.d=="string"?!1:parseFloat(S.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(S){return S.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=F.create(this.c,this.d,this)),this.f}}e.$Ui=Z;class Y{static create(S,C){return new Y(S,C)}constructor(S,C){this.d=S,this.f=C,this.type=7,this.c=null}cmp(S){if(S.type!==this.type)return this.type-S.type;if(this.d<S.d)return-1;if(this.d>S.d)return 1;const C=this.f?this.f.source:"",z=S.f?S.f.source:"";return C<z?-1:C>z?1:0}equals(S){if(S.type===this.type){const C=this.f?this.f.source:"",z=S.f?S.f.source:"";return this.d===S.d&&C===z}return!1}substituteConstants(){return this}evaluate(S){const C=S.getValue(this.d);return this.f?this.f.test(C):!1}serialize(){const S=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${S}`}keys(){return[this.d]}map(S){return S.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=x.create(this)),this.c}}e.$Vi=Y;class x{static create(S){return new x(S)}constructor(S){this.c=S,this.type=8}cmp(S){return S.type!==this.type?this.type-S.type:this.c.cmp(S.c)}equals(S){return S.type===this.type?this.c.equals(S.c):!1}substituteConstants(){return this}evaluate(S){return!this.c.evaluate(S)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(S){return new x(this.c.map(S))}negate(){return this.c}}e.$Wi=x;function G(U){let S=null;for(let C=0,z=U.length;C<z;C++){const M=U[C].substituteConstants();if(U[C]!==M&&S===null){S=[];for(let J=0;J<C;J++)S[J]=U[J]}S!==null&&(S[C]=M)}return S===null?U:S}class Q{static create(S,C,z){return Q.d(S,C,z)}constructor(S,C){this.expr=S,this.c=C,this.type=6}cmp(S){if(S.type!==this.type)return this.type-S.type;if(this.expr.length<S.expr.length)return-1;if(this.expr.length>S.expr.length)return 1;for(let C=0,z=this.expr.length;C<z;C++){const M=n(this.expr[C],S.expr[C]);if(M!==0)return M}return 0}equals(S){if(S.type===this.type){if(this.expr.length!==S.expr.length)return!1;for(let C=0,z=this.expr.length;C<z;C++)if(!this.expr[C].equals(S.expr[C]))return!1;return!0}return!1}substituteConstants(){const S=G(this.expr);return S===this.expr?this:Q.create(S,this.c,!1)}evaluate(S){for(let C=0,z=this.expr.length;C<z;C++)if(!this.expr[C].evaluate(S))return!1;return!0}static d(S,C,z){const M=[];let J=!1;for(const _ of S)if(_){if(_.type===1){J=!0;continue}if(_.type===0)return i.INSTANCE;if(_.type===6){M.push(..._.expr);continue}M.push(_)}if(M.length===0&&J)return r.INSTANCE;if(M.length!==0){if(M.length===1)return M[0];M.sort(n);for(let _=1;_<M.length;_++)M[_-1].equals(M[_])&&(M.splice(_,1),_--);if(M.length===1)return M[0];for(;M.length>1;){const _=M[M.length-1];if(_.type!==9)break;M.pop();const ae=M.pop(),he=M.length===0,fe=H.create(_.expr.map(le=>Q.create([le,ae],null,z)),null,he);fe&&(M.push(fe),M.sort(n))}if(M.length===1)return M[0];if(z){for(let _=0;_<M.length;_++)for(let ae=_+1;ae<M.length;ae++)if(M[_].negate().equals(M[ae]))return i.INSTANCE;if(M.length===1)return M[0]}return new Q(M,C)}}serialize(){return this.expr.map(S=>S.serialize()).join(" && ")}keys(){const S=[];for(const C of this.expr)S.push(...C.keys());return S}map(S){return new Q(this.expr.map(C=>C.map(S)),null)}negate(){if(!this.c){const S=[];for(const C of this.expr)S.push(C.negate());this.c=H.create(S,this,!0)}return this.c}}e.$Xi=Q;class H{static create(S,C,z){return H.d(S,C,z)}constructor(S,C){this.expr=S,this.c=C,this.type=9}cmp(S){if(S.type!==this.type)return this.type-S.type;if(this.expr.length<S.expr.length)return-1;if(this.expr.length>S.expr.length)return 1;for(let C=0,z=this.expr.length;C<z;C++){const M=n(this.expr[C],S.expr[C]);if(M!==0)return M}return 0}equals(S){if(S.type===this.type){if(this.expr.length!==S.expr.length)return!1;for(let C=0,z=this.expr.length;C<z;C++)if(!this.expr[C].equals(S.expr[C]))return!1;return!0}return!1}substituteConstants(){const S=G(this.expr);return S===this.expr?this:H.create(S,this.c,!1)}evaluate(S){for(let C=0,z=this.expr.length;C<z;C++)if(this.expr[C].evaluate(S))return!0;return!1}static d(S,C,z){let M=[],J=!1;if(S){for(let _=0,ae=S.length;_<ae;_++){const he=S[_];if(he){if(he.type===0){J=!0;continue}if(he.type===1)return r.INSTANCE;if(he.type===9){M=M.concat(he.expr);continue}M.push(he)}}if(M.length===0&&J)return i.INSTANCE;M.sort(n)}if(M.length!==0){if(M.length===1)return M[0];for(let _=1;_<M.length;_++)M[_-1].equals(M[_])&&(M.splice(_,1),_--);if(M.length===1)return M[0];if(z){for(let _=0;_<M.length;_++)for(let ae=_+1;ae<M.length;ae++)if(M[_].negate().equals(M[ae]))return r.INSTANCE;if(M.length===1)return M[0]}return new H(M,C)}}serialize(){return this.expr.map(S=>S.serialize()).join(" || ")}keys(){const S=[];for(const C of this.expr)S.push(...C.keys());return S}map(S){return new H(this.expr.map(C=>C.map(S)),null)}negate(){if(!this.c){const S=[];for(const C of this.expr)S.push(C.negate());for(;S.length>1;){const C=S.shift(),z=S.shift(),M=[];for(const J of K(C))for(const _ of K(z))M.push(Q.create([J,_],null,!1));S.unshift(H.create(M,null,!1))}this.c=H.create(S,this,!0)}return this.c}}e.$Yi=H;class V extends a{static{this.d=[]}static all(){return V.d.values()}constructor(S,C,z){super(S,null),this.f=C,typeof z=="object"?V.d.push({...z,key:S}):z!==!0&&V.d.push({key:S,description:z,type:C!=null?typeof C:void 0})}bindTo(S){return S.createKey(this.key,this.f)}getValue(S){return S.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(S){return v.create(this.key,S)}notEqualsTo(S){return E.create(this.key,S)}}e.$Zi=V,e.$1i=(0,j.$zh)("contextKeyService");function B(U,S){return U<S?-1:U>S?1:0}function ee(U,S,C,z){return U<C?-1:U>C?1:S<z?-1:S>z?1:0}function ne(U,S){if(U.type===0||S.type===1)return!0;if(U.type===9)return S.type===9?se(U.expr,S.expr):!1;if(S.type===9){for(const C of S.expr)if(ne(U,C))return!0;return!1}if(U.type===6){if(S.type===6)return se(S.expr,U.expr);for(const C of U.expr)if(ne(C,S))return!0;return!1}return U.equals(S)}e.$2i=ne;function se(U,S){let C=0,z=0;for(;C<U.length&&z<S.length;){const M=U[C].cmp(S[z]);if(M<0)return!1;M===0&&C++,z++}return C===U.length}function K(U){return U.type===9?U.expr:[U]}}),define(re[95],oe([0,1,4]),function(te,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gm=e.$fm=e.$em=e.ID=void 0,e.ID="diagnosticsService",e.$em=(0,L.$zh)(e.ID);function N(j){return!!j.hostName&&!!j.errorMessage}e.$fm=N;class O{async getPerformanceInfo(A,R){return{}}async getSystemInfo(A,R){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(A,R){return""}async getWorkspaceFileExtensions(A){return{extensions:[]}}async reportWorkspaceStats(A){}}e.$gm=O}),define(re[96],oe([0,1,4]),function(te,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bn=void 0,e.$Bn=(0,L.$zh)("downloadService")}),define(re[16],oe([0,1,4]),function(te,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hh=e.$Gh=void 0,e.$Gh=(0,L.$zh)("environmentService"),e.$Hh=(0,L.$Ah)(e.$Gh)}),define(re[29],oe([0,1,152,4]),function(te,e,L,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7n=e.$6n=e.$5n=e.$4n=e.$3n=e.$2n=e.$1n=e.$Zn=e.$Yn=e.ExtensionSignaturetErrorCode=e.ExtensionManagementErrorCode=e.$Xn=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.$Wn=e.$Vn=e.$Un=e.$Tn=e.$Sn=e.$Rn=e.$Qn=e.$Pn=e.$On=e.$Nn=e.$Mn=e.$Ln=e.$Kn=void 0,e.$Kn="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$Ln=new RegExp(e.$Kn),e.$Mn="__web_extension",e.$Nn="skipWalkthrough",e.$On="extensionsSync",e.$Pn="dependecyOrPackExtensionInstall";function O(l){switch(l){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.$Qn=O;function j(l){switch(l){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.$Rn=j;function A(l,$){switch(l){case 3:return $==="x64"?"win32-x64":$==="ia32"?"win32-ia32":$==="arm64"?"win32-arm64":"unknown";case 2:return $==="x64"?"linux-x64":$==="arm64"?"linux-arm64":$==="arm"?"linux-armhf":"unknown";case"alpine":return $==="x64"?"alpine-x64":$==="arm64"?"alpine-arm64":"unknown";case 1:return $==="x64"?"darwin-x64":$==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.$Sn=A;function R(l,$){return $==="web"&&!l.includes("web")}e.$Tn=R;function k(l,$,b){return R($,b)?!1:l==="undefined"||l==="universal"?!0:l==="unknown"?!1:l===b?!0:m(b).includes(l)}e.$Un=k;function m(l){switch(l){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.$Vn=m;function P(l){return l&&typeof l=="object"&&typeof l.id=="string"&&(!l.uuid||typeof l.uuid=="string")}e.$Wn=P;var p;(function(l){l[l.NoneOrRelevance=0]="NoneOrRelevance",l[l.LastUpdatedDate=1]="LastUpdatedDate",l[l.Title=2]="Title",l[l.PublisherName=3]="PublisherName",l[l.InstallCount=4]="InstallCount",l[l.PublishedDate=10]="PublishedDate",l[l.AverageRating=6]="AverageRating",l[l.WeightedRating=12]="WeightedRating"})(p||(e.SortBy=p={}));var g;(function(l){l[l.Default=0]="Default",l[l.Ascending=1]="Ascending",l[l.Descending=2]="Descending"})(g||(e.SortOrder=g={}));var h;(function(l){l.Install="install",l.Uninstall="uninstall"})(h||(e.StatisticType=h={}));var d;(function(l){l[l.None=1]="None",l[l.Install=2]="Install",l[l.Update=3]="Update",l[l.Migrate=4]="Migrate"})(d||(e.InstallOperation=d={})),e.$Xn=(0,N.$zh)("extensionGalleryService");var w;(function(l){l.Unsupported="Unsupported",l.Deprecated="Deprecated",l.Malicious="Malicious",l.Incompatible="Incompatible",l.IncompatibleTargetPlatform="IncompatibleTargetPlatform",l.ReleaseVersionNotFound="ReleaseVersionNotFound",l.Invalid="Invalid",l.Download="Download",l.Extract="Extract",l.Delete="Delete",l.Rename="Rename",l.CorruptZip="CorruptZip",l.IncompleteZip="IncompleteZip",l.Signature="Signature",l.Internal="Internal"})(w||(e.ExtensionManagementErrorCode=w={}));var f;(function(l){l.UnknownError="UnknownError",l.PackageIsInvalidZip="PackageIsInvalidZip",l.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip"})(f||(e.ExtensionSignaturetErrorCode=f={}));class o extends Error{constructor($,b){super($),this.code=b,this.name=b}}e.$Yn=o,e.$Zn=(0,N.$zh)("extensionManagementService"),e.$1n="extensionsIdentifiers/disabled",e.$2n="extensionsIdentifiers/enabled",e.$3n=(0,N.$zh)("IGlobalExtensionEnablementService"),e.$4n=(0,N.$zh)("IExtensionTipsService"),e.$5n=(0,L.localize)(0,null),e.$6n={value:e.$5n,original:"Extensions"},e.$7n={value:(0,L.localize)(1,null),original:"Preferences"}}),define(re[187],oe([0,1,3,2,30,11,92,29]),function(te,e,L,N,O,j,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9o=e.$8o=e.$7o=void 0;function k(f,o){return f?j.URI.revive(o?o.transformIncoming(f):f):void 0}function m(f,o){return o?o.transformOutgoingURI(f):f}function P(f,o){o=o||A.$Am;const l=f.manifest;return{...(0,A.$Dm)({...f,manifest:void 0},o),manifest:l}}function p(f,o){return f?.profileLocation?(0,A.$Dm)(f,o??A.$Am):f}function g(f,o){return o?(0,O.$Vm)(f,l=>l instanceof j.URI?o.transformOutgoingURI(l):void 0):f}class h{constructor(o,l){this.a=o,this.b=l,this.onInstallExtension=L.Event.buffer(o.onInstallExtension,!0),this.onDidInstallExtensions=L.Event.buffer(o.onDidInstallExtensions,!0),this.onUninstallExtension=L.Event.buffer(o.onUninstallExtension,!0),this.onDidUninstallExtension=L.Event.buffer(o.onDidUninstallExtension,!0),this.onDidUpdateExtensionMetadata=L.Event.buffer(o.onDidUpdateExtensionMetadata,!0)}listen(o,l){const $=this.b(o);switch(l){case"onInstallExtension":return L.Event.map(this.onInstallExtension,b=>({...b,profileLocation:b.profileLocation?m(b.profileLocation,$):b.profileLocation}));case"onDidInstallExtensions":return L.Event.map(this.onDidInstallExtensions,b=>b.map(I=>({...I,local:I.local?g(I.local,$):I.local,profileLocation:I.profileLocation?m(I.profileLocation,$):I.profileLocation})));case"onUninstallExtension":return L.Event.map(this.onUninstallExtension,b=>({...b,profileLocation:b.profileLocation?m(b.profileLocation,$):b.profileLocation}));case"onDidUninstallExtension":return L.Event.map(this.onDidUninstallExtension,b=>({...b,profileLocation:b.profileLocation?m(b.profileLocation,$):b.profileLocation}));case"onDidUpdateExtensionMetadata":return L.Event.map(this.onDidUpdateExtensionMetadata,b=>g(b,$))}throw new Error("Invalid listen")}async call(o,l,$){const b=this.b(o);switch(l){case"zip":{const I=P($[0],b),t=await this.a.zip(I);return m(t,b)}case"unzip":return this.a.unzip(k($[0],b));case"install":return this.a.install(k($[0],b),p($[1],b));case"installFromLocation":return this.a.installFromLocation(k($[0],b),k($[1],b));case"installExtensionsFromProfile":return this.a.installExtensionsFromProfile($[0],k($[1],b),k($[2],b));case"getManifest":return this.a.getManifest(k($[0],b));case"getTargetPlatform":return this.a.getTargetPlatform();case"canInstall":return this.a.canInstall($[0]);case"installFromGallery":return this.a.installFromGallery($[0],p($[1],b));case"installGalleryExtensions":{const I=$[0];return this.a.installGalleryExtensions(I.map(({extension:t,options:c})=>({extension:t,options:p(c,b)??{}})))}case"uninstall":return this.a.uninstall(P($[0],b),p($[1],b));case"reinstallFromGallery":return this.a.reinstallFromGallery(P($[0],b));case"getInstalled":return(await this.a.getInstalled($[0],k($[1],b))).map(t=>g(t,b));case"toggleAppliationScope":{const I=await this.a.toggleAppliationScope(P($[0],b),k($[1],b));return g(I,b)}case"copyExtensions":return this.a.copyExtensions(k($[0],b),k($[1],b));case"updateMetadata":{const I=await this.a.updateMetadata(P($[0],b),$[1],k($[2],b));return g(I,b)}case"getExtensionsControlManifest":return this.a.getExtensionsControlManifest();case"download":return this.a.download($[0],$[1],$[2]);case"cleanUp":return this.a.cleanUp()}throw new Error("Invalid call")}}e.$7o=h;class d extends N.$mb{get onInstallExtension(){return this.c.event}get onDidInstallExtensions(){return this.f.event}get onUninstallExtension(){return this.g.event}get onDidUninstallExtension(){return this.h.event}get onDidUpdateExtensionMetadata(){return this.j.event}constructor(o){super(),this.k=o,this.c=this.B(new L.$hc),this.f=this.B(new L.$hc),this.g=this.B(new L.$hc),this.h=this.B(new L.$hc),this.j=this.B(new L.$hc),this.B(this.k.listen("onInstallExtension")(l=>this.l(this.c,{...l,source:this.m(l.source)?j.URI.revive(l.source):l.source,profileLocation:j.URI.revive(l.profileLocation)}))),this.B(this.k.listen("onDidInstallExtensions")(l=>this.l(this.f,l.map($=>({...$,local:$.local?P($.local,null):$.local,source:this.m($.source)?j.URI.revive($.source):$.source,profileLocation:j.URI.revive($.profileLocation)}))))),this.B(this.k.listen("onUninstallExtension")(l=>this.l(this.g,{...l,profileLocation:j.URI.revive(l.profileLocation)}))),this.B(this.k.listen("onDidUninstallExtension")(l=>this.l(this.h,{...l,profileLocation:j.URI.revive(l.profileLocation)}))),this.B(this.k.listen("onDidUpdateExtensionMetadata")(l=>this.j.fire(P(l,null))))}l(o,l){o.fire(l)}m(o){return o?typeof o.path=="string"&&typeof o.scheme=="string":!1}getTargetPlatform(){return this.n||(this.n=this.k.call("getTargetPlatform")),this.n}async canInstall(o){const l=await this.getTargetPlatform();return o.allTargetPlatforms.some($=>(0,R.$Un)($,o.allTargetPlatforms,l))}zip(o){return Promise.resolve(this.k.call("zip",[o]).then(l=>j.URI.revive(l)))}unzip(o){return Promise.resolve(this.k.call("unzip",[o]))}install(o,l){return Promise.resolve(this.k.call("install",[o,l])).then($=>P($,null))}installFromLocation(o,l){return Promise.resolve(this.k.call("installFromLocation",[o,l])).then($=>P($,null))}async installExtensionsFromProfile(o,l,$){return(await this.k.call("installExtensionsFromProfile",[o,l,$])).map(I=>P(I,null))}getManifest(o){return Promise.resolve(this.k.call("getManifest",[o]))}installFromGallery(o,l){return Promise.resolve(this.k.call("installFromGallery",[o,l])).then($=>P($,null))}async installGalleryExtensions(o){return(await this.k.call("installGalleryExtensions",[o])).map($=>({...$,local:$.local?P($.local,null):$.local,source:this.m($.source)?j.URI.revive($.source):$.source,profileLocation:j.URI.revive($.profileLocation)}))}uninstall(o,l){return Promise.resolve(this.k.call("uninstall",[o,l]))}reinstallFromGallery(o){return Promise.resolve(this.k.call("reinstallFromGallery",[o])).then(l=>P(l,null))}getInstalled(o=null,l){return Promise.resolve(this.k.call("getInstalled",[o,l])).then($=>$.map(b=>P(b,null)))}updateMetadata(o,l,$){return Promise.resolve(this.k.call("updateMetadata",[o,l,$])).then(b=>P(b,null))}toggleAppliationScope(o,l){return this.k.call("toggleAppliationScope",[o,l]).then($=>P($,null))}copyExtensions(o,l){return this.k.call("copyExtensions",[o,l])}getExtensionsControlManifest(){return Promise.resolve(this.k.call("getExtensionsControlManifest"))}async download(o,l,$){const b=await this.k.call("download",[o,l,$]);return j.URI.revive(b)}async cleanUp(){return this.k.call("cleanUp")}registerParticipant(){throw new Error("Not Supported")}}e.$8o=d;class w{constructor(o){this.a=o}listen(o,l){throw new Error("Invalid listen")}call(o,l,$){switch(l){case"getConfigBasedTips":return this.a.getConfigBasedTips(j.URI.revive($[0]));case"getImportantExecutableBasedTips":return this.a.getImportantExecutableBasedTips();case"getOtherExecutableBasedTips":return this.a.getOtherExecutableBasedTips()}throw new Error("Invalid call")}}e.$9o=w}),define(re[97],oe([0,1,4]),function(te,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5o=e.$4o=void 0,e.$4o=(0,L.$zh)("IExtensionSignatureVerificationService");class N{b(){return this.a||(this.a=new Promise((j,A)=>te(["node-vsce-sign"],async R=>j(R),A))),this.a}async verify(j,A,R){let k;try{k=await this.b()}catch{return!1}return k.verify(j,A,R)}}e.$5o=N}),define(re[98],oe([0,1,4]),function(te,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bUb=e.RecommendationsNotificationResult=e.$aUb=e.RecommendationSource=void 0;var N;(function(A){A[A.FILE=1]="FILE",A[A.WORKSPACE=2]="WORKSPACE",A[A.EXE=3]="EXE"})(N||(e.RecommendationSource=N={}));function O(A){switch(A){case 1:return"file";case 2:return"workspace";case 3:return"exe"}}e.$aUb=O;var j;(function(A){A.Ignored="ignored",A.Cancelled="cancelled",A.TooMany="toomany",A.IncompatibleWindow="incompatibleWindow",A.Accepted="reacted"})(j||(e.RecommendationsNotificationResult=j={})),e.$bUb=(0,L.$zh)("IExtensionRecommendationNotificationService")}),define(re[13],oe([0,1,47,15,28,9,11,159,4,6,22]),function(te,e,L,N,O,j,A,R,k,m,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zk=e.$yk=e.$xk=e.$wk=e.$vk=e.FileKind=e.$uk=e.$tk=e.$sk=e.$rk=e.$qk=e.$pk=e.$ok=e.FileOperationResult=e.$nk=e.$mk=e.$lk=e.$kk=e.$jk=e.FileChangeType=e.$ik=e.FileOperation=e.$hk=e.$gk=e.$fk=e.$ek=e.$dk=e.$ck=e.FileSystemProviderErrorCode=e.$bk=e.$ak=e.$_j=e.$$j=e.$0j=e.$9j=e.$8j=e.$7j=e.$6j=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.$5j=e.$4j=void 0,e.$4j=(0,k.$zh)("fileService");function p(B){return B.create===!0}e.$5j=p;var g;(function(B){B[B.Unknown=0]="Unknown",B[B.File=1]="File",B[B.Directory=2]="Directory",B[B.SymbolicLink=64]="SymbolicLink"})(g||(e.FileType=g={}));var h;(function(B){B[B.Readonly=1]="Readonly",B[B.Locked=2]="Locked"})(h||(e.FilePermission=h={}));var d;(function(B){B[B.None=0]="None",B[B.FileReadWrite=2]="FileReadWrite",B[B.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",B[B.FileReadStream=16]="FileReadStream",B[B.FileFolderCopy=8]="FileFolderCopy",B[B.PathCaseSensitive=1024]="PathCaseSensitive",B[B.Readonly=2048]="Readonly",B[B.Trash=4096]="Trash",B[B.FileWriteUnlock=8192]="FileWriteUnlock",B[B.FileAtomicRead=16384]="FileAtomicRead",B[B.FileAtomicWrite=32768]="FileAtomicWrite",B[B.FileAtomicDelete=65536]="FileAtomicDelete",B[B.FileClone=131072]="FileClone"})(d||(e.FileSystemProviderCapabilities=d={}));function w(B){return!!(B.capabilities&2)}e.$6j=w;function f(B){return!!(B.capabilities&8)}e.$7j=f;function o(B){return!!(B.capabilities&131072)}e.$8j=o;function l(B){return!!(B.capabilities&4)}e.$9j=l;function $(B){return!!(B.capabilities&16)}e.$0j=$;function b(B){return w(B)?!!(B.capabilities&16384):!1}e.$$j=b;function I(B){return w(B)?!!(B.capabilities&32768):!1}e.$_j=I;function t(B){return!!(B.capabilities&65536)}e.$ak=t;function c(B){return!!(B.capabilities&2048)}e.$bk=c;var s;(function(B){B.FileExists="EntryExists",B.FileNotFound="EntryNotFound",B.FileNotADirectory="EntryNotADirectory",B.FileIsADirectory="EntryIsADirectory",B.FileExceedsStorageQuota="EntryExceedsStorageQuota",B.FileTooLarge="EntryTooLarge",B.FileWriteLocked="EntryWriteLocked",B.NoPermissions="NoPermissions",B.Unavailable="Unavailable",B.Unknown="Unknown"})(s||(e.FileSystemProviderErrorCode=s={}));class n extends Error{static create(ee,ne){const se=new n(ee.toString(),ne);return a(se,ne),se}constructor(ee,ne){super(ee),this.code=ne}}e.$ck=n;function i(B,ee){return n.create(B,ee)}e.$dk=i;function r(B){return B||i((0,R.localize)(0,null),s.Unknown)}e.$ek=r;function a(B,ee){return B.name=ee?`${ee} (FileSystemError)`:"FileSystemError",B}e.$fk=a;function v(B){if(!B)return s.Unknown;if(B instanceof n)return B.code;const ee=/^(.+) \(FileSystemError\)$/.exec(B.name);if(!ee)return s.Unknown;switch(ee[1]){case s.FileExists:return s.FileExists;case s.FileIsADirectory:return s.FileIsADirectory;case s.FileNotADirectory:return s.FileNotADirectory;case s.FileNotFound:return s.FileNotFound;case s.FileTooLarge:return s.FileTooLarge;case s.FileWriteLocked:return s.FileWriteLocked;case s.NoPermissions:return s.NoPermissions;case s.Unavailable:return s.Unavailable}return s.Unknown}e.$gk=v;function y(B){if(B instanceof q)return B.fileOperationResult;switch(v(B)){case s.FileNotFound:return 1;case s.FileIsADirectory:return 0;case s.FileNotADirectory:return 9;case s.FileWriteLocked:return 5;case s.NoPermissions:return 6;case s.FileExists:return 4;case s.FileTooLarge:return 7;default:return 10}}e.$hk=y;var u;(function(B){B[B.CREATE=0]="CREATE",B[B.DELETE=1]="DELETE",B[B.MOVE=2]="MOVE",B[B.COPY=3]="COPY",B[B.WRITE=4]="WRITE"})(u||(e.FileOperation=u={}));class E{constructor(ee,ne,se){this.resource=ee,this.operation=ne,this.target=se}isOperation(ee){return this.operation===ee}}e.$ik=E;var D;(function(B){B[B.UPDATED=0]="UPDATED",B[B.ADDED=1]="ADDED",B[B.DELETED=2]="DELETED"})(D||(e.FileChangeType=D={}));class T{constructor(ee,ne){this.a=void 0,this.b=void 0,this.c=void 0,this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];const se=new Map;for(const K of ee){const U=se.get(K.type);switch(U?U.push([K.resource,K]):se.set(K.type,[[K.resource,K]]),K.type){case 1:this.rawAdded.push(K.resource);break;case 0:this.rawUpdated.push(K.resource);break;case 2:this.rawDeleted.push(K.resource);break}}for(const[K,U]of se)switch(K){case 1:this.a=L.$Fh.forUris(()=>ne),this.a.fill(U);break;case 0:this.b=L.$Fh.forUris(()=>ne),this.b.fill(U);break;case 2:this.c=L.$Fh.forUris(()=>ne),this.c.fill(U);break}}contains(ee,...ne){return this.d(ee,{includeChildren:!1},...ne)}affects(ee,...ne){return this.d(ee,{includeChildren:!0},...ne)}d(ee,ne,...se){if(!ee)return!1;const K=se.length>0;return!!((!K||se.includes(1))&&(this.a?.get(ee)||ne.includeChildren&&this.a?.findSuperstr(ee))||(!K||se.includes(0))&&(this.b?.get(ee)||ne.includeChildren&&this.b?.findSuperstr(ee))||(!K||se.includes(2))&&(this.c?.findSubstr(ee)||ne.includeChildren&&this.c?.findSuperstr(ee)))}gotAdded(){return!!this.a}gotDeleted(){return!!this.c}gotUpdated(){return!!this.b}}e.$jk=T;function F(B,ee,ne){return!B||!ee||B===ee||ee.length>B.length?!1:(ee.charAt(ee.length-1)!==N.sep&&(ee+=N.sep),ne?(0,O.$Pd)(B,ee):B.indexOf(ee)===0)}e.$kk=F;class q extends Error{constructor(ee,ne,se){super(ee),this.fileOperationResult=ne,this.options=se}}e.$lk=q;class W extends q{constructor(ee,ne,se,K){super(ee,ne,K),this.fileOperationResult=ne,this.size=se}}e.$mk=W;class Z extends q{constructor(ee,ne,se){super(ee,2,se),this.stat=ne}}e.$nk=Z;var Y;(function(B){B[B.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",B[B.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",B[B.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",B[B.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",B[B.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",B[B.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",B[B.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",B[B.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",B[B.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",B[B.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",B[B.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(Y||(e.FileOperationResult=Y={})),e.$ok={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$pk={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$qk="files.associations",e.$rk="files.exclude",e.$sk="files.readonlyInclude",e.$tk="files.readonlyExclude",e.$uk="files.readonlyFromPermissions";var x;(function(B){B[B.FILE=0]="FILE",B[B.FOLDER=1]="FOLDER",B[B.ROOT_FOLDER=2]="ROOT_FOLDER"})(x||(e.FileKind=x={})),e.$vk="";function G(B){if(!(typeof B.size!="number"||typeof B.mtime!="number"))return B.mtime.toString(29)+B.size.toString(31)}e.$wk=G;async function Q(B,ee){if(!ee.hasProvider(A.URI.from({scheme:B.scheme})))return new Promise(ne=>{const se=ee.onDidChangeFileSystemProviderRegistrations(K=>{K.scheme===B.scheme&&K.added&&(se.dispose(),ne())})})}e.$xk=Q;class H{static{this.KB=1024}static{this.MB=H.KB*H.KB}static{this.GB=H.MB*H.KB}static{this.TB=H.GB*H.KB}static formatSize(ee){return(0,j.$pe)(ee)||(ee=0),ee<H.KB?(0,R.localize)(1,null,ee.toFixed(0)):ee<H.MB?(0,R.localize)(2,null,(ee/H.KB).toFixed(2)):ee<H.GB?(0,R.localize)(3,null,(ee/H.MB).toFixed(2)):ee<H.TB?(0,R.localize)(4,null,(ee/H.GB).toFixed(2)):(0,R.localize)(5,null,(ee/H.TB).toFixed(2))}}e.$yk=H;function V(B){const ee=typeof B=="string"||B?.scheme===P.Schemas.vscodeRemote;return typeof B!="string"&&B?.scheme===P.Schemas.file?1024*H.MB:ee?10*H.MB:m.$o?50*H.MB:1024*H.MB}e.$zk=V});var X=this&&this.__param||function(te,e){return function(L,N){e(L,N,te)}};define(re[188],oe([0,1,69,42,13]),function(te,e,L,N,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$f7b=void 0;let j=class{constructor(R){this.a=R}async checksum(R){const k=(await this.a.readFileStream(R)).value;return new Promise((m,P)=>{const p=(0,L.createHash)("md5");(0,N.$zc)(k,{onData:g=>p.update(g.buffer),onError:g=>P(g),onEnd:()=>m(p.digest("base64").replace(/=+$/,""))})})}};e.$f7b=j,e.$f7b=j=ye([X(0,O.$4j)],j)}),define(re[189],oe([0,1,14,38,8,3,2,42,11,32,13]),function(te,e,L,N,O,j,A,R,k,m,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1M=e.$ZM=void 0,e.$ZM="localFilesystem";class p extends A.$mb{constructor(h,d){super(),this.a=h,this.b=d,this.onDidChangeCapabilities=j.Event.None,this.f=this.B(new j.$hc),this.onDidChangeFile=this.f.event,this.g=this.B(new j.$hc),this.onDidWatchError=this.g.event,this.h=(0,m.$6e)(),this.i()}get capabilities(){return this.c||(this.c=253982,this.b.pathCaseSensitive&&(this.c|=1024),this.b.trash&&(this.c|=4096)),this.c}stat(h){return this.a.call("stat",[h])}readdir(h){return this.a.call("readdir",[h])}async readFile(h,d){const{buffer:w}=await this.a.call("readFile",[h,d]);return w}readFileStream(h,d,w){const f=(0,R.$vc)(l=>L.$Hc.concat(l.map($=>L.$Hc.wrap($))).buffer),o=this.a.listen("readFileStream",[h,d])(l=>{if(l instanceof L.$Hc)f.write(l.buffer);else{if(l==="end")f.end();else{let $;if(l instanceof Error)$=l;else{const b=l;$=(0,P.$dk)(b.message??(0,N.$ki)(b),b.code??P.FileSystemProviderErrorCode.Unknown)}f.error($),f.end()}o.dispose()}});return w.onCancellationRequested(()=>{f.error((0,O.$4)()),f.end(),o.dispose()}),f}writeFile(h,d,w){return this.a.call("writeFile",[h,L.$Hc.wrap(d),w])}open(h,d){return this.a.call("open",[h,d])}close(h){return this.a.call("close",[h])}async read(h,d,w,f,o){const[l,$]=await this.a.call("read",[h,d,o]);return w.set(l.buffer.slice(0,$),f),$}write(h,d,w,f,o){return this.a.call("write",[h,d,L.$Hc.wrap(w),f,o])}mkdir(h){return this.a.call("mkdir",[h])}delete(h,d){return this.a.call("delete",[h,d])}rename(h,d,w){return this.a.call("rename",[h,d,w])}copy(h,d,w){return this.a.call("copy",[h,d,w])}cloneFile(h,d){return this.a.call("cloneFile",[h,d])}i(){this.B(this.a.listen("fileChange",[this.h])(h=>{if(Array.isArray(h)){const d=h;this.f.fire(d.map(w=>({resource:k.URI.revive(w.resource),type:w.type})))}else{const d=h;this.g.fire(d)}}))}watch(h,d){const w=(0,m.$6e)();return this.a.call("watch",[this.h,w,h,d]),(0,A.$kb)(()=>this.a.call("unwatch",[this.h,w]))}}e.$1M=p}),define(re[99],oe([0,1,14,8,160,13]),function(te,e,L,N,O,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zp=void 0;async function A(P,p,g,h,d,w){let f;try{await R(P,p,g,h,d,w)}catch(o){f=o}finally{f&&d.errorTransformer&&(f=d.errorTransformer(f)),typeof f<"u"&&g.error(f),g.end()}}e.$zp=A;async function R(P,p,g,h,d,w){k(w);const f=await P.open(p,{create:!1});try{k(w);let o=0,l=0,$=d&&typeof d.length=="number"?d.length:void 0,b=L.$Hc.alloc(Math.min(d.bufferSize,typeof $=="number"?$:d.bufferSize)),I=d&&typeof d.position=="number"?d.position:0,t=0;do l=await P.read(f,I,b.buffer,t,b.byteLength-t),I+=l,t+=l,o+=l,typeof $=="number"&&($-=l),t===b.byteLength&&(await g.write(h(b)),b=L.$Hc.alloc(Math.min(d.bufferSize,typeof $=="number"?$:d.bufferSize)),t=0);while(l>0&&(typeof $!="number"||$>0)&&k(w)&&m(o,d));if(t>0){let c=t;typeof $=="number"&&(c=Math.min(t,$)),g.write(h(b.slice(0,c)))}}catch(o){throw(0,j.$ek)(o)}finally{await P.close(f)}}function k(P){if(P.isCancellationRequested)throw(0,N.$4)();return!0}function m(P,p){if(typeof p?.limits?.size=="number"&&P>p.limits.size)throw(0,j.$dk)((0,O.localize)(0,null),j.FileSystemProviderErrorCode.FileTooLarge);return!0}}),define(re[54],oe([0,1,91,2,15,6,11,13]),function(te,e,L,N,O,j,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ip=e.$Hp=e.$Gp=e.$Fp=e.$Ep=e.$Dp=e.$Cp=e.$Bp=void 0;function k(o){return o.recursive===!0}e.$Bp=k;class m extends N.$mb{static{this.a=5}constructor(l,$,b,I){super(),this.h=l,this.i=$,this.j=b,this.k=I,this.c=this.B(new N.$nb),this.f=void 0,this.g=0}m(){const l=new N.$lb;this.c.value=l,this.b=this.l(l),this.b.setVerboseLogging(this.j),l.add(this.b.onDidChangeFile($=>this.h($))),l.add(this.b.onDidLogMessage($=>this.i($))),l.add(this.b.onDidError($=>this.n($)))}n(l){this.k.restartOnError?this.g<m.a&&this.f?(this.r(`restarting watcher after error: ${l}`),this.p(this.f)):this.r(`gave up attempting to restart watcher after error: ${l}`):this.r(l)}p(l){this.g++,this.m(),this.watch(l)}async watch(l){this.f=l,await this.b?.watch(l)}async setVerboseLogging(l){this.j=l,await this.b?.setVerboseLogging(l)}r(l){this.i({type:"error",message:`[File Watcher (${this.k.type})] ${l}`})}s(l){this.i({type:"trace",message:`[File Watcher (${this.k.type})] ${l}`})}dispose(){return this.b=void 0,super.dispose()}}e.$Cp=m;class P extends m{constructor(l,$,b){super(l,$,b,{type:"node.js",restartOnError:!1})}}e.$Dp=P;class p extends m{constructor(l,$,b){super(l,$,b,{type:"universal",restartOnError:!0})}}e.$Ep=p;function g(o){return o.map(l=>({type:l.type,resource:A.URI.file(l.path)}))}e.$Fp=g;function h(o){const l=new f;for(const $ of o)l.processEvent($);return l.coalesce()}e.$Gp=h;function d(o,l){return typeof l=="string"&&!l.startsWith(L.$lj)&&!(0,O.$0c)(l)?{base:o,pattern:l}:l}e.$Hp=d;function w(o,l){const $=[];for(const b of l)$.push((0,L.$pj)(d(o,b)));return $}e.$Ip=w;class f{constructor(){this.a=new Set,this.b=new Map}c(l){return j.$k?l.path:l.path.toLowerCase()}processEvent(l){const $=this.b.get(this.c(l));let b=!1;if($){const I=$.type,t=l.type;$.path!==l.path&&(l.type===2||l.type===1)?b=!0:I===1&&t===2?(this.b.delete(this.c(l)),this.a.delete($)):I===2&&t===1?$.type=0:I===1&&t===0||($.type=t)}else b=!0;b&&(this.a.add(l),this.b.set(this.c(l),l))}coalesce(){const l=[],$=[];return Array.from(this.a).filter(b=>b.type!==2?(l.push(b),!1):!0).sort((b,I)=>b.path.length-I.path.length).filter(b=>$.some(I=>(0,R.$kk)(b.path,I,!j.$k))?!1:($.push(b.path),!0)).concat(l)}}}),define(re[190],oe([0,1,52,5,26,48,2,88,15,6,143,31,54]),function(te,e,L,N,O,j,A,R,k,m,P,p,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wp=e.$Vp=void 0;class h extends A.$mb{static{this.a=100}static{this.b=75}constructor(f,o,l,$){super(),this.j=f,this.k=o,this.l=l,this.m=$,this.c=this.B(new N.$Tg({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},b=>this.k(b))),this.f=this.B(new N.$Sg(b=>this.u(b),h.b)),this.g=(0,g.$Ip)(this.j.path,this.j.excludes),this.h=this.j.includes?(0,g.$Ip)(this.j.path,this.j.includes):void 0,this.i=new O.$rc,this.ready=this.n()}async n(){try{const f=await this.r(this.j);if(this.i.token.isCancellationRequested)return;const o=await p.Promises.stat(f);this.B(await this.s(f,o.isDirectory()))}catch(f){f.code!=="ENOENT"?this.w(f):this.z(f)}}async r(f){let o=f.path;try{o=await p.Promises.realpath(f.path),f.path===o&&(o=await(0,P.$Sp)(f.path)??f.path),f.path!==o&&this.z(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${f.path}, real: ${o})`)}catch{}return o}async s(f,o){if(m.$j&&(0,j.$Ke)(f,"/Volumes/",!0))return this.w(`Refusing to watch ${f} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),A.$mb.None;const l=new O.$rc(this.i.token),$=new A.$lb;try{const b=(0,k.$cd)(f),I=(0,L.watch)(f);$.add((0,A.$kb)(()=>{I.removeAllListeners(),I.close()})),this.z(`Started watching: '${f}'`);const t=new Set;if(o)try{for(const s of await p.Promises.readdir(f))t.add(s)}catch(s){this.w(s)}const c=new Map;$.add((0,A.$kb)(()=>{for(const[,s]of c)s.dispose();c.clear()})),I.on("error",(s,n)=>{this.w(`Failed to watch ${f} for changes using fs.watch() (${s}, ${n})`),this.dispose()}),I.on("change",(s,n)=>{if(l.token.isCancellationRequested)return;this.z(`[raw] ["${s}"] ${n}`);let i="";if(n&&(i=n.toString(),m.$j&&(i=(0,R.$fl)(i))),!(!i||s!=="change"&&s!=="rename"))if(o)if(s==="rename"){c.get(i)?.dispose();const r=setTimeout(async()=>{if(c.delete(i),i===b&&!await p.Promises.exists(f)){this.y("Watcher shutdown because watched path got deleted"),this.dispose();return}const a=await this.v((0,k.$$c)(f,i));if(l.token.isCancellationRequested)return;let v;a?t.has(i)?v=0:(v=1,t.add(i)):(t.delete(i),v=2),this.t({path:(0,k.$$c)(this.j.path,i),type:v})},h.a);c.set(i,(0,A.$kb)(()=>clearTimeout(r)))}else{let r;t.has(i)?r=0:(r=1,t.add(i)),this.t({path:(0,k.$$c)(this.j.path,i),type:r})}else if(s==="rename"||i!==b){const r=setTimeout(async()=>{const a=await p.Promises.exists(f);l.token.isCancellationRequested||(a?(this.t({path:this.j.path,type:0},!0),$.add(await this.s(f,!1))):(this.t({path:this.j.path,type:2},!0),this.f.flush(),this.dispose()))},h.a);$.clear(),$.add((0,A.$kb)(()=>clearTimeout(r)))}else this.t({path:this.j.path,type:0},!0)})}catch(b){await p.Promises.exists(f)&&!l.token.isCancellationRequested&&this.w(`Failed to watch ${f} for changes using fs.watch() (${b.toString()})`)}return(0,A.$kb)(()=>{l.dispose(!0),$.dispose()})}t(f,o=!1){this.i.token.isCancellationRequested||(this.m&&this.z(`${f.type===1?"[ADDED]":f.type===2?"[DELETED]":"[CHANGED]"} ${f.path}`),!o&&this.g.some(l=>l(f.path))?this.m&&this.z(` >> ignored (excluded) ${f.path}`):!o&&this.h&&this.h.length>0&&!this.h.some(l=>l(f.path))?this.m&&this.z(` >> ignored (not included) ${f.path}`):this.f.work(f))}u(f){const o=(0,g.$Gp)(f);if(o.length>0){if(this.m)for(const $ of o)this.z(`>> normalized ${$.type===1?"[ADDED]":$.type===2?"[DELETED]":"[CHANGED]"} ${$.path}`);this.c.work(o)?this.c.pending>0&&this.z(`started throttling events due to large amount of file change events at once (pending: ${this.c.pending}, most recent change: ${o[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.y(`started ignoring events due to too many file change events at once (incoming: ${o.length}, most recent change: ${o[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}}async v(f){if(m.$k)return p.Promises.exists(f);try{const o=(0,k.$cd)(f);return(await p.Promises.readdir((0,k.$bd)(f))).some($=>$===o)}catch(o){return this.z(o),!1}}setVerboseLogging(f){this.m=f}w(f){this.i.token.isCancellationRequested||this.l?.({type:"error",message:`[File Watcher (node.js)] ${f}`})}y(f){this.i.token.isCancellationRequested||this.l?.({type:"warn",message:`[File Watcher (node.js)] ${f}`})}z(f){!this.i.token.isCancellationRequested&&this.m&&this.l?.({type:"trace",message:`[File Watcher (node.js)] ${f}`})}dispose(){this.z(`stopping file watcher on ${this.j.path}`),this.i.dispose(!0),super.dispose()}}e.$Vp=h;async function d(w,f,o,l,$=512){const b=await p.Promises.open(w,"r"),I=Buffer.allocUnsafe($),t=new O.$rc(l);let c,s=!1;const n={path:w,excludes:[],recursive:!1},i=new h(n,r=>{(async()=>{for(const{type:a}of r)if(a===0){if(s)return;s=!0;try{for(;!t.token.isCancellationRequested;){const{bytesRead:v}=await p.Promises.read(b,I,0,$,null);if(!v||t.token.isCancellationRequested)break;f(I.slice(0,v))}}catch(v){c=new Error(v),t.dispose(!0)}finally{s=!1}}})()});return await i.ready,o(),new Promise((r,a)=>{t.token.onCancellationRequested(async()=>{i.dispose();try{await p.Promises.close(b)}catch(v){c=new Error(v)}c?a(c):r()})})}e.$Wp=d}),define(re[191],oe([0,1,3,91,2,6,190]),function(te,e,L,N,O,j,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xp=void 0;class R extends O.$mb{constructor(){super(...arguments),this.a=this.B(new L.$hc),this.onDidChangeFile=this.a.event,this.b=this.B(new L.$hc),this.onDidLogMessage=this.b.event,this.onDidError=L.Event.None,this.c=new Map,this.f=!1}async watch(m){const P=this.i(m),p=P.filter(h=>{const d=this.c.get(h.path);return d?!(0,N.$tj)(d.request.excludes,h.excludes)||!(0,N.$tj)(d.request.includes,h.includes):!0}),g=Array.from(this.c.values()).filter(({request:h})=>!P.find(d=>d.path===h.path&&(0,N.$tj)(d.excludes,h.excludes)&&(0,N.$tj)(d.includes,h.includes))).map(({request:h})=>h.path);p.length&&this.j(`Request to start watching: ${p.map(h=>`${h.path} (excludes: ${h.excludes.length>0?h.excludes:"<none>"}, includes: ${h.includes&&h.includes.length>0?JSON.stringify(h.includes):"<all>"})`).join(",")}`),g.length&&this.j(`Request to stop watching: ${g.join(",")}`);for(const h of g)this.h(h);for(const h of p)this.g(h)}g(m){const P=new A.$Vp(m,g=>this.a.fire(g),g=>this.b.fire(g),this.f),p={request:m,instance:P};this.c.set(m.path,p)}async stop(){for(const[m]of this.c)this.h(m);this.c.clear()}h(m){const P=this.c.get(m);P&&(this.c.delete(m),P.instance.dispose())}i(m){const P=new Map;for(const p of m){const g=j.$k?p.path:p.path.toLowerCase();P.set(g,p)}return Array.from(P.values())}async setVerboseLogging(m){this.f=m;for(const[,P]of this.c)P.instance.setVerboseLogging(m)}j(m){this.f&&this.b.fire({type:"trace",message:this.k(m)})}k(m,P){return P?`[File Watcher (node.js)] ${m} (path: ${P.request.path})`:`[File Watcher (node.js)] ${m}`}}e.$Xp=R}),define(re[192],oe([0,1,54,191]),function(te,e,L,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yp=void 0;class O extends L.$Dp{constructor(A,R,k){super(A,R,k),this.m()}l(A){return A.add(new N.$Xp)}}e.$Yp=O}),define(re[193],oe([0,1,22,43,93,54]),function(te,e,L,N,O,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qp=void 0;class A extends j.$Ep{constructor(k,m,P){super(k,m,P),this.m()}l(k){const m=k.add(new O.$Pp(L.$4e.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return k.add(m.onDidProcessExit(({code:P,signal:p})=>this.n(`terminated by itself with code ${P}, signal: ${p}`))),N.ProxyChannel.toService((0,N.$gh)(m.getChannel("watcher")))}}e.$Qp=A}),define(re[70],oe([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xh=void 0;class L{constructor(...O){this.a=new Map;for(const[j,A]of O)this.set(j,A)}set(O,j){const A=this.a.get(O);return this.a.set(O,j),A}has(O){return this.a.has(O)}get(O){return this.a.get(O)}}e.$xh=L}),define(re[194],oe([0,1,5,8,2,68,185,4,70,87]),function(te,e,L,N,O,j,A,R,k,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4p=e.$3p=void 0;const P=!1;class p extends Error{constructor(f){super("cyclic dependency between services"),this.message=f.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${f.toString()}`}}class g{constructor(f=new k.$xh,o=!1,l,$=P){this.f=f,this.g=o,this.h=l,this.i=$,this.o=new Set,this.f.set(R.$yh,this),this._globalGraph=$?l?._globalGraph??new A.$2p(b=>b):void 0}createChild(f){return new g(f,this.g,this,this.i)}invokeFunction(f,...o){const l=d.traceInvocation(this.i,f);let $=!1;try{return f({get:I=>{if($)throw(0,N.$6)("service accessor is only valid during the invocation of its target method");const t=this.m(I,l);if(!t)throw new Error(`[invokeFunction] unknown service '${I}'`);return t}},...o)}finally{$=!0,l.stop()}}createInstance(f,...o){let l,$;return f instanceof j.$wh?(l=d.traceCreation(this.i,f.ctor),$=this.j(f.ctor,f.staticArguments.concat(o),l)):(l=d.traceCreation(this.i,f),$=this.j(f,o,l)),l.stop(),$}j(f,o=[],l){const $=R._util.getServiceDependencies(f).sort((t,c)=>t.index-c.index),b=[];for(const t of $){const c=this.m(t.id,l);c||this.u(`[createInstance] ${f.name} depends on UNKNOWN service ${t.id}.`,!1),b.push(c)}const I=$.length>0?$[0].index:o.length;if(o.length!==I){console.trace(`[createInstance] First service dependency of ${f.name} at position ${I+1} conflicts with ${o.length} static arguments`);const t=I-o.length;t>0?o=o.concat(new Array(t)):o=o.slice(0,I)}return Reflect.construct(f,o.concat(b))}k(f,o){if(this.f.get(f)instanceof j.$wh)this.f.set(f,o);else if(this.h)this.h.k(f,o);else throw new Error("illegalState - setting UNKNOWN service instance")}l(f){const o=this.f.get(f);return!o&&this.h?this.h.l(f):o}m(f,o){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(f));const l=this.l(f);return l instanceof j.$wh?this.q(f,l,o.branch(f,!0)):(o.branch(f,!1),l)}q(f,o,l){if(this.o.has(f))throw new Error(`illegal state - RECURSIVELY instantiating service '${f}'`);this.o.add(f);try{return this.r(f,o,l)}finally{this.o.delete(f)}}r(f,o,l){const $=new A.$2p(t=>t.id.toString());let b=0;const I=[{id:f,desc:o,_trace:l}];for(;I.length;){const t=I.pop();if($.lookupOrInsertNode(t),b++>1e3)throw new p($);for(const c of R._util.getServiceDependencies(t.desc.ctor)){const s=this.l(c.id);if(s||this.u(`[createInstance] ${f} depends on ${c.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(t.id),String(c.id)),s instanceof j.$wh){const n={id:c.id,desc:s,_trace:t._trace.branch(c.id,!0)};$.insertEdge(t,n),I.push(n)}}}for(;;){const t=$.roots();if(t.length===0){if(!$.isEmpty())throw new p($);break}for(const{data:c}of t){if(this.l(c.id)instanceof j.$wh){const n=this.s(c.id,c.desc.ctor,c.desc.staticArguments,c.desc.supportsDelayedInstantiation,c._trace);this.k(c.id,n)}$.removeNode(c)}}return this.l(f)}s(f,o,l=[],$,b){if(this.f.get(f)instanceof j.$wh)return this.t(f,o,l,$,b);if(this.h)return this.h.s(f,o,l,$,b);throw new Error(`illegalState - creating UNKNOWN service instance ${o.name}`)}t(f,o,l=[],$,b){if($){const I=new g(void 0,this.g,this,this.i);I.c=String(f);const t=new Map,c=new L.$Vg(()=>{const s=I.j(o,l,b);for(const[n,i]of t){const r=s[n];if(typeof r=="function")for(const a of i)r.apply(s,a)}return t.clear(),s});return new Proxy(Object.create(null),{get(s,n){if(!c.isInitialized&&typeof n=="string"&&(n.startsWith("onDid")||n.startsWith("onWill"))){let a=t.get(n);return a||(a=new m.$vb,t.set(n,a)),(y,u,E)=>{const D=a.push([y,u,E]);return(0,O.$kb)(D)}}if(n in s)return s[n];const i=c.value;let r=i[n];return typeof r!="function"||(r=r.bind(i),s[n]=r),r},set(s,n,i){return c.value[n]=i,!0},getPrototypeOf(s){return o.prototype}})}else return this.j(o,l,b)}u(f,o){if(o&&console.warn(f),this.g)throw new Error(f)}}e.$3p=g;var h;(function(w){w[w.None=0]="None",w[w.Creation=1]="Creation",w[w.Invocation=2]="Invocation",w[w.Branch=3]="Branch"})(h||(h={}));class d{static{this.all=new Set}static{this.c=new class extends d{constructor(){super(0,null)}stop(){}branch(){return this}}}static traceInvocation(f,o){return f?new d(2,o.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):d.c}static traceCreation(f,o){return f?new d(1,o.name):d.c}static{this.f=0}constructor(f,o){this.type=f,this.name=o,this.g=Date.now(),this.h=[]}branch(f,o){const l=new d(3,f.toString());return this.h.push([f,o,l]),l}stop(){const f=Date.now()-this.g;d.f+=f;let o=!1;function l(b,I){const t=[],c=new Array(b+1).join("	");for(const[s,n,i]of I.h)if(n&&i){o=!0,t.push(`${c}CREATES -> ${s}`);const r=l(b+1,i);r&&t.push(r)}else t.push(`${c}uses -> ${s}`);return t.join(`
`)}const $=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${l(1,this)}`,`DONE, took ${f.toFixed(2)}ms (grand total ${d.f.toFixed(2)}ms)`];(f>2||o)&&d.all.add($.join(`
`))}}e.$4p=d}),define(re[71],oe([0,1,4]),function(te,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$P6b=e.$O6b=void 0,e.$O6b=(0,L.$zh)("mainProcessService");class N{constructor(j,A){this.a=j,this.b=A}getChannel(j){return this.a.getChannel(j,this.b)}registerChannel(j,A){this.a.registerChannel(j,A)}}e.$P6b=N}),define(re[72],oe([0,1,26,2,6,162,29,4]),function(te,e,L,N,O,j,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gq=e.$Fq=e.$Eq=void 0;function k(P){return P.tags.find(p=>p.startsWith("lp-"))?.split("lp-")[1]}e.$Eq=k,e.$Fq=(0,R.$zh)("languagePackService");let m=class extends N.$mb{constructor(p){super(),this.c=p}async getAvailableLanguages(){const p=new L.$rc;setTimeout(()=>p.cancel(),1e3);let g;try{g=await this.c.query({text:'category:"language packs"',pageSize:20},p.token)}catch{return[]}const d=g.firstPage.filter(w=>w.properties.localizedLanguages?.length&&w.tags.some(f=>f.startsWith("lp-"))).map(w=>{const f=w.properties.localizedLanguages?.[0],o=k(w);return{...this.f(o,f,w),extensionId:w.identifier.id,galleryExtension:w}});return d.push(this.f("en","English")),d}f(p,g,h){const d=g??p;let w;if(d!==p&&(w=`(${p})`),p.toLowerCase()===O.$v.toLowerCase()&&(w??="",w+=(0,j.localize)(0,null)),h?.installCount){w??="";const f=h.installCount;let o;f>1e6?o=`${Math.floor(f/1e5)/10}M`:f>1e3?o=`${Math.floor(f/1e3)}K`:o=String(f),w+=` $(cloud-download) ${o}`}return{id:p,label:d,description:w}}};e.$Gq=m,e.$Gq=m=ye([X(0,A.$Xn)],m)}),define(re[195],oe([0,1,2,72]),function(te,e,L,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$b7b=void 0;let O=class extends L.$mb{constructor(A){super(),this.a=A,this.b()}b(){this.a.update()}};e.$b7b=O,e.$b7b=O=ye([X(0,N.$Fq)],O)}),define(re[7],oe([0,1,38,3,51,2,35,6,23,9,11,94,4]),function(te,e,L,N,O,j,A,R,k,m,P,p,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hj=e.$gj=e.$fj=e.$ej=e.$dj=e.$cj=e.$bj=e.$aj=e.$_i=e.$$i=e.$0i=e.$9i=e.$8i=e.log=e.$6i=e.LogLevel=e.$5i=e.$4i=e.$3i=void 0,e.$3i=(0,g.$zh)("logService"),e.$4i=(0,g.$zh)("loggerService");function h(){return new Date().toISOString()}function d(y){return(0,m.$pe)(y)}e.$5i=d;var w;(function(y){y[y.Off=0]="Off",y[y.Trace=1]="Trace",y[y.Debug=2]="Debug",y[y.Info=3]="Info",y[y.Warning=4]="Warning",y[y.Error=5]="Error"})(w||(e.LogLevel=w={})),e.$6i=w.Info;function f(y,u,E){switch(u){case w.Trace:y.trace(E);break;case w.Debug:y.debug(E);break;case w.Info:y.info(E);break;case w.Warning:y.warn(E);break;case w.Error:y.error(E);break;case w.Off:break;default:throw new Error(`Invalid log level ${u}`)}}e.log=f;function o(y,u=!1){let E="";for(let D=0;D<y.length;D++){let T=y[D];if(T instanceof Error&&(T=(0,L.$ki)(T,u)),typeof T=="object")try{T=JSON.stringify(T)}catch{}E+=(D>0?" ":"")+T}return E}class l extends j.$mb{constructor(){super(...arguments),this.b=e.$6i,this.c=this.B(new N.$hc),this.onDidChangeLogLevel=this.c.event}setLevel(u){this.b!==u&&(this.b=u,this.c.fire(this.b))}getLevel(){return this.b}f(u){return this.b!==w.Off&&this.b<=u}}e.$8i=l;class $ extends l{constructor(u){super(),this.h=u}f(u){return this.h||super.f(u)}trace(u,...E){this.f(w.Trace)&&this.g(w.Trace,o([u,...E],!0))}debug(u,...E){this.f(w.Debug)&&this.g(w.Debug,o([u,...E]))}info(u,...E){this.f(w.Info)&&this.g(w.Info,o([u,...E]))}warn(u,...E){this.f(w.Warning)&&this.g(w.Warning,o([u,...E]))}error(u,...E){if(this.f(w.Error))if(u instanceof Error){const D=Array.prototype.slice.call(arguments);D[0]=u.stack,this.g(w.Error,o(D))}else this.g(w.Error,o([u,...E]))}flush(){}}e.$9i=$;class b extends l{constructor(u=e.$6i){super(),this.setLevel(u),this.g=!R.$i}trace(u,...E){this.f(w.Trace)&&(this.g?console.log(`\x1B[90m[main ${h()}]\x1B[0m`,u,...E):console.log(`[main ${h()}]`,u,...E))}debug(u,...E){this.f(w.Debug)&&(this.g?console.log(`\x1B[90m[main ${h()}]\x1B[0m`,u,...E):console.log(`[main ${h()}]`,u,...E))}info(u,...E){this.f(w.Info)&&(this.g?console.log(`\x1B[90m[main ${h()}]\x1B[0m`,u,...E):console.log(`[main ${h()}]`,u,...E))}warn(u,...E){this.f(w.Warning)&&(this.g?console.warn(`\x1B[93m[main ${h()}]\x1B[0m`,u,...E):console.warn(`[main ${h()}]`,u,...E))}error(u,...E){this.f(w.Error)&&(this.g?console.error(`\x1B[91m[main ${h()}]\x1B[0m`,u,...E):console.error(`[main ${h()}]`,u,...E))}dispose(){}flush(){}}e.$0i=b;class I extends l{constructor(u=e.$6i,E=!0){super(),this.g=E,this.setLevel(u)}trace(u,...E){this.f(w.Trace)&&(this.g?console.log("%cTRACE","color: #888",u,...E):console.log(u,...E))}debug(u,...E){this.f(w.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",u,...E):console.log(u,...E))}info(u,...E){this.f(w.Info)&&(this.g?console.log("%c INFO","color: #33f",u,...E):console.log(u,...E))}warn(u,...E){this.f(w.Warning)&&(this.g?console.log("%c WARN","color: #993",u,...E):console.log(u,...E))}error(u,...E){this.f(w.Error)&&(this.g?console.log("%c  ERR","color: #f33",u,...E):console.error(u,...E))}dispose(){}flush(){}}e.$$i=I;class t extends l{constructor(u,E=e.$6i){super(),this.g=u,this.setLevel(E)}trace(u,...E){this.f(w.Trace)&&this.g.log(w.Trace,[this.h(u),...E])}debug(u,...E){this.f(w.Debug)&&this.g.log(w.Debug,[this.h(u),...E])}info(u,...E){this.f(w.Info)&&this.g.log(w.Info,[this.h(u),...E])}warn(u,...E){this.f(w.Warning)&&this.g.log(w.Warning,[this.h(u),...E])}error(u,...E){this.f(w.Error)&&this.g.log(w.Error,[this.h(u),...E])}h(u){return typeof u=="string"?u:(0,L.$ki)(u,this.f(w.Trace))}dispose(){}flush(){}}e.$_i=t;class c extends l{constructor(u){super(),this.g=u,u.length&&this.setLevel(u[0].getLevel())}setLevel(u){for(const E of this.g)E.setLevel(u);super.setLevel(u)}trace(u,...E){for(const D of this.g)D.trace(u,...E)}debug(u,...E){for(const D of this.g)D.debug(u,...E)}info(u,...E){for(const D of this.g)D.info(u,...E)}warn(u,...E){for(const D of this.g)D.warn(u,...E)}error(u,...E){for(const D of this.g)D.error(u,...E)}flush(){for(const u of this.g)u.flush()}dispose(){for(const u of this.g)u.dispose()}}e.$aj=c;class s extends j.$mb{constructor(u,E,D){if(super(),this.h=u,this.j=E,this.b=new A.$xi,this.c=this.B(new N.$hc),this.onDidChangeLoggers=this.c.event,this.f=this.B(new N.$hc),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new N.$hc),this.onDidChangeVisibility=this.g.event,D)for(const T of D)this.b.set(T.resource,{logger:void 0,info:T})}k(u){return(0,m.$le)(u)?[...this.b.values()].find(E=>E.info.id===u):this.b.get(u)}getLogger(u){return this.k(u)?.logger}createLogger(u,E){const D=this.l(u),T=(0,m.$le)(u)?u:E?.id??(0,O.$ni)(D.toString()).toString(16);let F=this.b.get(D)?.logger;const q=E?.logLevel==="always"?w.Trace:E?.logLevel;F||(F=this.m(D,q??this.getLogLevel(D)??this.h,{...E,id:T}));const W={logger:F,info:{resource:D,id:T,logLevel:q,name:E?.name,hidden:E?.hidden,extensionId:E?.extensionId,when:E?.when}};return this.registerLogger(W.info),this.b.set(D,W),F}l(u){return(0,m.$le)(u)?(0,k.$gg)(this.j,`${u}.log`):u}setLogLevel(u,E){if(P.URI.isUri(u)){const D=u,T=E,F=this.b.get(D);F&&T!==F.info.logLevel&&(F.info.logLevel=T===this.h?void 0:T,F.logger?.setLevel(T),this.b.set(F.info.resource,F),this.f.fire([D,T]))}else{this.h=u;for(const[D,T]of this.b.entries())this.b.get(D)?.info.logLevel===void 0&&T.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(u,E){const D=this.k(u);D&&E!==!D.info.hidden&&(D.info.hidden=!E,this.b.set(D.info.resource,D),this.g.fire([D.info.resource,E]))}getLogLevel(u){let E;return u&&(E=this.b.get(u)?.info.logLevel),E??this.h}registerLogger(u){const E=this.b.get(u.resource);E?E.info.hidden!==u.hidden&&this.setVisibility(u.resource,!u.hidden):(this.b.set(u.resource,{info:u,logger:void 0}),this.c.fire({added:[u],removed:[]}))}deregisterLogger(u){const E=this.b.get(u);E&&(E.logger&&E.logger.dispose(),this.b.delete(u),this.c.fire({added:[],removed:[E.info]}))}*getRegisteredLoggers(){for(const u of this.b.values())yield u.info}getRegisteredLogger(u){return this.b.get(u)?.info}dispose(){this.b.forEach(u=>u.logger?.dispose()),this.b.clear(),super.dispose()}}e.$bj=s;class n{constructor(){this.onDidChangeLogLevel=new N.$hc().event}setLevel(u){}getLevel(){return w.Info}trace(u,...E){}debug(u,...E){}info(u,...E){}warn(u,...E){}error(u,...E){}critical(u,...E){}dispose(){}flush(){}}e.$cj=n;class i extends n{}e.$dj=i;function r(y){if(y.verbose)return w.Trace;if(typeof y.logLevel=="string"){const u=v(y.logLevel.toLowerCase());if(u!==void 0)return u}return e.$6i}e.$ej=r;function a(y){switch(y){case w.Trace:return"trace";case w.Debug:return"debug";case w.Info:return"info";case w.Warning:return"warn";case w.Error:return"error";case w.Off:return"off"}}e.$fj=a;function v(y){switch(y){case"trace":return w.Trace;case"debug":return w.Debug;case"info":return w.Info;case"warn":return w.Warning;case"error":return w.Error;case"critical":return w.Error;case"off":return w.Off}}e.$gj=v,e.$hj=new p.$Zi("logLevel",a(w.Info))}),define(re[196],oe([0,1,5,8,2,22,15,23,31,16,7]),function(te,e,L,N,O,j,A,R,k,m,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$c7b=void 0;let p=class extends O.$mb{constructor(h,d){super(),this.a=h,this.b=d,this.B(new L.$Qg(()=>{this.c()},10*1e3)).schedule()}async c(){this.b.trace("[logs cleanup]: Starting to clean up old logs.");try{const h=(0,R.$dg)(this.a.logsHome),d=(0,R.$fg)(this.a.logsHome.with({scheme:j.Schemas.file})).fsPath,o=(await k.Promises.readdir(d)).filter($=>/^\d{8}T\d{6}$/.test($)).sort().filter($=>$!==h),l=o.slice(0,Math.max(0,o.length-9));l.length>0&&(this.b.trace(`[logs cleanup]: Removing log folders '${l.join(", ")}'`),await Promise.all(l.map($=>k.Promises.rm((0,A.$$c)(d,$)))))}catch(h){(0,N.$Y)(h)}}};e.$c7b=p,e.$c7b=p=ye([X(0,m.$Gh),X(1,P.$3i)],p)}),define(re[197],oe([0,1,20,5,8,3,2,15,54,7]),function(te,e,L,N,O,j,A,R,k,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jp=void 0;class P extends A.$mb{constructor(g,h){super(),this.a=g,this.b=h,this.c=this.B(new j.$hc),this.onDidChangeFile=this.c.event,this.g=this.B(new j.$hc),this.onDidWatchError=this.g.event,this.j=[],this.k=this.B(new N.$Cg(0)),this.s=[],this.t=this.B(new N.$Cg(0))}watch(g,h){return h.recursive||this.b?.watcher?.forceUniversal?this.l(g,h):this.u(g,h)}l(g,h){const d={path:this.C(g),excludes:h.excludes,includes:h.includes,recursive:h.recursive},w=(0,L.$Nf)(this.j,d);return this.m(),(0,A.$kb)(()=>{w(),this.m()})}m(){this.k.trigger(()=>this.n()).catch(g=>(0,O.$Y)(g))}n(){this.h||(this.h=this.B(this.p(h=>this.c.fire((0,k.$Fp)(h)),h=>this.z(h),this.a.getLevel()===m.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===m.LogLevel.Trace)})));const g=this.b?.watcher?.recursive?.usePolling;if(g===!0)for(const h of this.j)(0,k.$Bp)(h)&&(h.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(g))for(const h of this.j)(0,k.$Bp)(h)&&g.includes(h.path)&&(h.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}u(g,h){const d={path:this.C(g),excludes:h.excludes,includes:h.includes,recursive:!1},w=(0,L.$Nf)(this.s,d);return this.v(),(0,A.$kb)(()=>{w(),this.v()})}v(){this.t.trigger(()=>this.w()).catch(g=>(0,O.$Y)(g))}w(){return this.r||(this.r=this.B(this.y(g=>this.c.fire((0,k.$Fp)(g)),g=>this.z(g),this.a.getLevel()===m.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.r?.setVerboseLogging(this.a.getLevel()===m.LogLevel.Trace)}))),this.r.watch(this.s)}z(g){g.type==="error"&&this.g.fire(g.message),this.a[g.type](g.message)}C(g){return(0,R.$9c)(g.fsPath)}}e.$Jp=P}),define(re[198],oe([0,1,20,5,14,26,3,51,59,2,47,22,100,23,42,158,13,99,7,8]),function(te,e,L,N,O,j,A,R,k,m,P,p,g,h,d,w,f,o,l,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ap=void 0;let b=class extends m.$mb{constructor(t){super(),this.b=t,this.a=256*1024,this.c=this.B(new A.$hc),this.onDidChangeFileSystemProviderRegistrations=this.c.event,this.f=this.B(new A.$hc),this.onWillActivateFileSystemProvider=this.f.event,this.g=this.B(new A.$hc),this.onDidChangeFileSystemProviderCapabilities=this.g.event,this.h=new Map,this.m=this.B(new A.$hc),this.onDidRunOperation=this.m.event,this.R=this.B(new A.$hc),this.onDidFilesChange=this.R.event,this.S=this.B(new A.$hc),this.onDidWatchError=this.S.event,this.U=new Map,this.X=this.B(new N.$Ng)}registerProvider(t,c){if(this.h.has(t))throw new Error(`A filesystem provider for the scheme '${t}' is already registered.`);(0,g.mark)(`code/registerFilesystem/${t}`);const s=new m.$lb;return this.h.set(t,c),this.c.fire({added:!0,scheme:t,provider:c}),s.add(c.onDidChangeFile(n=>this.R.fire(new f.$jk(n,!this.O(c))))),typeof c.onDidWatchError=="function"&&s.add(c.onDidWatchError(n=>this.S.fire(new Error(n)))),s.add(c.onDidChangeCapabilities(()=>this.g.fire({provider:c,scheme:t}))),(0,m.$kb)(()=>{this.c.fire({added:!1,scheme:t,provider:c}),this.h.delete(t),(0,m.$hb)(s)})}getProvider(t){return this.h.get(t)}async activateProvider(t){const c=[];this.f.fire({scheme:t,join(s){c.push(s)}}),!this.h.has(t)&&await N.Promises.settled(c)}async canHandleResource(t){return await this.activateProvider(t.scheme),this.hasProvider(t)}hasProvider(t){return this.h.has(t.scheme)}hasCapability(t,c){const s=this.h.get(t.scheme);return!!(s&&s.capabilities&c)}listCapabilities(){return k.Iterable.map(this.h,([t,c])=>({scheme:t,capabilities:c.capabilities}))}async j(t){if(!(0,h.$kg)(t))throw new f.$lk((0,w.localize)(0,null,this.nb(t)),8);await this.activateProvider(t.scheme);const c=this.h.get(t.scheme);if(!c){const s=new $.$_;throw s.message=(0,w.localize)(1,null,t.toString()),s}return c}async k(t){const c=await this.j(t);if((0,f.$9j)(c)||(0,f.$6j)(c)||(0,f.$0j)(c))return c;throw new Error(`Filesystem provider for scheme '${t.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async l(t){const c=await this.j(t);if((0,f.$9j)(c)||(0,f.$6j)(c))return c;throw new Error(`Filesystem provider for scheme '${t.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(t,c){try{return await this.n(t,c)}catch(s){throw(0,f.$gk)(s)===f.FileSystemProviderErrorCode.FileNotFound?new f.$lk((0,w.localize)(2,null,this.nb(t)),1):(0,f.$ek)(s)}}async n(t,c){const s=await this.j(t),n=this.O(s),i=c?.resolveTo,r=c?.resolveSingleChildDescendants,a=c?.resolveMetadata,v=await s.stat(t);let y;return this.p(s,t,v,void 0,!!a,(u,E)=>(y||(y=P.$Fh.forUris(()=>!n),y.set(t,!0),i&&y.fill(!0,i)),y.get(u.resource)||y.findSuperstr(u.resource.with({query:null,fragment:null}))?!0:u.isDirectory&&r?E===1:!1))}async p(t,c,s,n,i,r){const{providerExtUri:a}=this.N(t),v={resource:c,name:a.basename(c),isFile:(s.type&f.FileType.File)!==0,isDirectory:(s.type&f.FileType.Directory)!==0,isSymbolicLink:(s.type&f.FileType.SymbolicLink)!==0,mtime:s.mtime,ctime:s.ctime,size:s.size,readonly:!!((s.permissions??0)&f.FilePermission.Readonly)||!!(t.capabilities&2048),locked:!!((s.permissions??0)&f.FilePermission.Locked),etag:(0,f.$wk)({mtime:s.mtime,size:s.size}),children:void 0};if(v.isDirectory&&r(v,n)){try{const y=await t.readdir(c),u=await N.Promises.settled(y.map(async([E,D])=>{try{const T=a.joinPath(c,E),F=i?await t.stat(T):{type:D};return await this.p(t,T,F,y.length,i,r)}catch(T){return this.b.trace(T),null}}));v.children=(0,L.$Af)(u)}catch(y){this.b.trace(y),v.children=[]}return v}return v}async resolveAll(t){return N.Promises.settled(t.map(async c=>{try{return{stat:await this.n(c.resource,c.options),success:!0}}catch(s){return this.b.trace(s),{stat:void 0,success:!1}}}))}async stat(t){const c=await this.j(t),s=await c.stat(t);return this.p(c,t,s,void 0,!0,()=>!1)}async exists(t){const c=await this.j(t);try{return!!await c.stat(t)}catch{return!1}}async canCreateFile(t,c){try{await this.r(t,c)}catch(s){return s}return!0}async r(t,c){if(!c?.overwrite&&await this.exists(t))throw new f.$lk((0,w.localize)(3,null,this.nb(t)),3,c)}async createFile(t,c=O.$Hc.fromString(""),s){await this.r(t,s);const n=await this.writeFile(t,c);return this.m.fire(new f.$ik(t,0,n)),n}async writeFile(t,c,s){const n=this.lb(await this.l(t),t),{providerExtUri:i}=this.N(n);try{await this.s(n,t,s)||await this.P(n,i.dirname(t));let a;if((0,f.$6j)(n)&&!(c instanceof O.$Hc))if((0,d.$tc)(c)){const v=await(0,d.$Ac)(c,3);v.ended?a=O.$Hc.concat(v.buffer):a=v}else a=(0,d.$xc)(c,v=>O.$Hc.concat(v),3);else a=c;if(!(0,f.$9j)(n)||(0,f.$6j)(n)&&a instanceof O.$Hc)await this.cb(n,t,s,a);else{const v=a instanceof O.$Hc?(0,O.$Sc)(a):a;s?.atomic!==!1&&s?.atomic?.postfix?await this.Y(n,t,(0,h.$gg)((0,h.$fg)(t),`${(0,h.$dg)(t)}${s.atomic.postfix}`),s,v):await this.Z(n,t,s,v)}this.m.fire(new f.$ik(t,4))}catch(r){throw new f.$lk((0,w.localize)(4,null,this.nb(t),(0,f.$ek)(r).toString()),(0,f.$hk)(r),s)}return this.resolve(t,{resolveMetadata:!0})}async s(t,c,s){const n=!!s?.unlock;if(n&&!(t.capabilities&8192))throw new Error((0,w.localize)(5,null,this.nb(c)));if(!!s?.atomic){if(!(t.capabilities&32768))throw new Error((0,w.localize)(6,null,this.nb(c)));if(n)throw new Error((0,w.localize)(7,null,this.nb(c)))}let r;try{r=await t.stat(c)}catch{return}if(r.type&f.FileType.Directory)throw new f.$lk((0,w.localize)(8,null,this.nb(c)),0,s);if(this.mb(c,r),typeof s?.mtime=="number"&&typeof s.etag=="string"&&s.etag!==f.$vk&&typeof r.mtime=="number"&&typeof r.size=="number"&&s.mtime<r.mtime&&s.etag!==(0,f.$wk)({mtime:s.mtime,size:r.size}))throw new f.$lk((0,w.localize)(9,null),3,s);return r}async readFile(t,c,s){const n=await this.k(t);return c?.atomic?this.t(n,t,c,s):this.u(n,t,c,s)}async t(t,c,s,n){return new Promise((i,r)=>{this.X.queueFor(c,this.N(t).providerExtUri).queue(async()=>{try{const a=await this.u(t,c,s,n);i(a)}catch(a){r(a)}})})}async u(t,c,s,n){const i=await this.v(t,c,{...s,preferUnbuffered:!0},n);return{...i,value:await(0,O.$Tc)(i.value)}}async readFileStream(t,c,s){const n=await this.k(t);return this.v(n,t,c,s)}async v(t,c,s,n){const i=new j.$rc(n),r=this.F(c,s).then(v=>v,v=>{throw i.dispose(!0),v});let a;try{return typeof s?.etag=="string"&&s.etag!==f.$vk&&await r,s?.atomic&&(0,f.$$j)(t)||!((0,f.$9j)(t)||(0,f.$0j)(t))||(0,f.$6j)(t)&&s?.preferUnbuffered?a=this.D(t,c,s):(0,f.$0j)(t)?a=this.z(t,c,i.token,s):a=this.C(t,c,i.token,s),a.on("end",()=>i.dispose()),a.on("error",()=>i.dispose()),{...await r,value:a}}catch(v){throw a&&await(0,d.$yc)(a),this.w(v,c,s)}}w(t,c,s){const n=(0,w.localize)(10,null,this.nb(c),(0,f.$ek)(t).toString());return t instanceof f.$nk?new f.$nk(n,t.stat,s):t instanceof f.$mk?new f.$mk(n,t.fileOperationResult,t.size,t.options):new f.$lk(n,(0,f.$hk)(t),s)}z(t,c,s,n=Object.create(null)){const i=t.readFileStream(c,n,s);return(0,d.$Ec)(i,{data:r=>r instanceof O.$Hc?r:O.$Hc.wrap(r),error:r=>this.w(r,c,n)},r=>O.$Hc.concat(r))}C(t,c,s,n=Object.create(null)){const i=(0,O.$Xc)();return(0,o.$zp)(t,c,i,r=>r,{...n,bufferSize:this.a,errorTransformer:r=>this.w(r,c,n)},s),i}D(t,c,s){const n=(0,d.$vc)(i=>O.$Hc.concat(i));return(async()=>{try{let i;s?.atomic&&(0,f.$$j)(t)?i=await t.readFile(c,{atomic:!0}):i=await t.readFile(c),typeof s?.position=="number"&&(i=i.slice(s.position)),typeof s?.length=="number"&&(i=i.slice(0,s.length)),this.G(c,i.byteLength,s),n.end(O.$Hc.wrap(i))}catch(i){n.error(i),n.end()}})(),n}async F(t,c){const s=await this.resolve(t,{resolveMetadata:!0});if(s.isDirectory)throw new f.$lk((0,w.localize)(11,null,this.nb(t)),0,c);if(typeof c?.etag=="string"&&c.etag!==f.$vk&&c.etag===s.etag)throw new f.$nk((0,w.localize)(12,null),s,c);return this.G(t,s.size,c),s}G(t,c,s){if(typeof s?.limits?.size=="number"&&c>s.limits.size)throw new f.$mk((0,w.localize)(13,null,this.nb(t)),7,c,s)}async canMove(t,c,s){return this.H(t,c,"move",s)}async canCopy(t,c,s){return this.H(t,c,"copy",s)}async H(t,c,s,n){if(t.toString()!==c.toString())try{const i=s==="move"?this.lb(await this.l(t),t):await this.k(t),r=this.lb(await this.l(c),c);await this.M(i,t,r,c,s,n)}catch(i){return i}return!0}async move(t,c,s){const n=this.lb(await this.l(t),t),i=this.lb(await this.l(c),c),r=await this.I(n,t,i,c,"move",!!s),a=await this.resolve(c,{resolveMetadata:!0});return this.m.fire(new f.$ik(t,r==="move"?2:3,a)),a}async copy(t,c,s){const n=await this.k(t),i=this.lb(await this.l(c),c),r=await this.I(n,t,i,c,"copy",!!s),a=await this.resolve(c,{resolveMetadata:!0});return this.m.fire(new f.$ik(t,r==="copy"?3:2,a)),a}async I(t,c,s,n,i,r){if(c.toString()===n.toString())return i;const{exists:a,isSameResourceWithDifferentPathCase:v}=await this.M(t,c,s,n,i,r);if(a&&!v&&r&&await this.del(n,{recursive:!0}),await this.P(s,this.N(s).providerExtUri.dirname(n)),i==="copy"){if(t===s&&(0,f.$7j)(t))await t.copy(c,n,{overwrite:r});else{const y=await this.resolve(c);y.isDirectory?await this.L(t,y,s,n):await this.J(t,c,s,n)}return i}else return t===s?(await t.rename(c,n,{overwrite:r}),i):(await this.I(t,c,s,n,"copy",r),await this.del(c,{recursive:!0}),"copy")}async J(t,c,s,n){if((0,f.$9j)(t)&&(0,f.$9j)(s))return this.eb(t,c,s,n);if((0,f.$9j)(t)&&(0,f.$6j)(s))return this.kb(t,c,s,n);if((0,f.$6j)(t)&&(0,f.$9j)(s))return this.ib(t,c,s,n);if((0,f.$6j)(t)&&(0,f.$6j)(s))return this.gb(t,c,s,n)}async L(t,c,s,n){await s.mkdir(n),Array.isArray(c.children)&&await N.Promises.settled(c.children.map(async i=>{const r=this.N(s).providerExtUri.joinPath(n,i.name);return i.isDirectory?this.L(t,await this.resolve(i.resource),s,r):this.J(t,i.resource,s,r)}))}async M(t,c,s,n,i,r){let a=!1;if(t===s){const{providerExtUri:y,isPathCaseSensitive:u}=this.N(t);if(u||(a=y.isEqual(c,n)),a&&i==="copy")throw new Error((0,w.localize)(14,null,this.nb(c),this.nb(n)));if(!a&&y.isEqualOrParent(n,c))throw new Error((0,w.localize)(15,null,this.nb(c),this.nb(n)))}const v=await this.exists(n);if(v&&!a){if(!r)throw new f.$lk((0,w.localize)(16,null,this.nb(c),this.nb(n)),4);if(t===s){const{providerExtUri:y}=this.N(t);if(y.isEqualOrParent(c,n))throw new Error((0,w.localize)(17,null,this.nb(c),this.nb(n)))}}return{exists:v,isSameResourceWithDifferentPathCase:a}}N(t){const c=this.O(t);return{providerExtUri:c?h.$9f:h.$$f,isPathCaseSensitive:c}}O(t){return!!(t.capabilities&1024)}async createFolder(t){const c=this.lb(await this.j(t),t);await this.P(c,t);const s=await this.resolve(t,{resolveMetadata:!0});return this.m.fire(new f.$ik(t,0,s)),s}async P(t,c){const s=[],{providerExtUri:n}=this.N(t);for(;!n.isEqual(c,n.dirname(c));)try{if(!((await t.stat(c)).type&f.FileType.Directory))throw new Error((0,w.localize)(18,null,this.nb(c)));break}catch(i){if((0,f.$gk)(i)!==f.FileSystemProviderErrorCode.FileNotFound)throw i;s.push(n.basename(c)),c=n.dirname(c)}for(let i=s.length-1;i>=0;i--){c=n.joinPath(c,s[i]);try{await t.mkdir(c)}catch(r){if((0,f.$gk)(r)!==f.FileSystemProviderErrorCode.FileExists)throw r}}}async canDelete(t,c){try{await this.Q(t,c)}catch(s){return s}return!0}async Q(t,c){const s=this.lb(await this.j(t),t),n=!!c?.useTrash;if(n&&!(s.capabilities&4096))throw new Error((0,w.localize)(19,null,this.nb(t)));const i=c?.atomic;if(i&&!(s.capabilities&65536))throw new Error((0,w.localize)(20,null,this.nb(t)));if(n&&i)throw new Error((0,w.localize)(21,null,this.nb(t)));let r;try{r=await s.stat(t)}catch{}if(r)this.mb(t,r);else throw new f.$lk((0,w.localize)(22,null,this.nb(t)),1);if(!!!c?.recursive){const v=await this.resolve(t);if(v.isDirectory&&Array.isArray(v.children)&&v.children.length>0)throw new Error((0,w.localize)(23,null,this.nb(t)))}return s}async del(t,c){const s=await this.Q(t,c),n=!!c?.useTrash,i=!!c?.recursive,r=c?.atomic??!1;await s.delete(t,{recursive:i,useTrash:n,atomic:r}),this.m.fire(new f.$ik(t,1))}async cloneFile(t,c){const s=await this.j(t),n=this.lb(await this.l(c),c);if(s===n&&this.N(s).providerExtUri.isEqual(t,c))return;if(s===n&&(0,f.$8j)(s))return s.cloneFile(t,c);await this.P(n,this.N(n).providerExtUri.dirname(c));const i=this.X.queueFor(t,this.N(s).providerExtUri);return s===n&&(0,f.$7j)(s)?i.queue(()=>s.copy(t,c,{overwrite:!0})):i.queue(()=>this.J(s,t,n,c))}watch(t,c={recursive:!1,excludes:[]}){const s=new m.$lb;let n=!1,i=()=>{n=!0};return s.add((0,m.$kb)(()=>i())),(async()=>{try{const r=await this.W(t,c);n?(0,m.$hb)(r):i=()=>(0,m.$hb)(r)}catch(r){this.b.error(r)}})(),s}async W(t,c){const s=await this.j(t),n=(0,R.$ni)([this.N(s).providerExtUri.getComparisonKey(t),c]);let i=this.U.get(n);return i||(i={count:0,disposable:s.watch(t,c)},this.U.set(n,i)),i.count+=1,(0,m.$kb)(()=>{i&&(i.count--,i.count===0&&((0,m.$hb)(i.disposable),this.U.delete(n)))})}dispose(){super.dispose();for(const[,t]of this.U)(0,m.$hb)(t.disposable);this.U.clear()}async Y(t,c,s,n,i){await this.Z(t,s,n,i);try{await t.rename(s,c,{overwrite:!0})}catch(r){try{await t.delete(s,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw r}}async Z(t,c,s,n){return this.X.queueFor(c,this.N(t).providerExtUri).queue(async()=>{const i=await t.open(c,{create:!0,unlock:s?.unlock??!1});try{(0,d.$tc)(n)||(0,d.$uc)(n)?await this.$(t,i,n):await this.ab(t,i,n)}catch(r){throw(0,f.$ek)(r)}finally{await t.close(i)}})}async $(t,c,s){let n=0,i;if((0,d.$uc)(s)){if(s.buffer.length>0){const r=O.$Hc.concat(s.buffer);await this.bb(t,c,r,r.byteLength,n,0),n+=r.byteLength}if(s.ended)return;i=s.stream}else i=s;return new Promise((r,a)=>{(0,d.$zc)(i,{onData:async v=>{i.pause();try{await this.bb(t,c,v,v.byteLength,n,0)}catch(y){return a(y)}n+=v.byteLength,setTimeout(()=>i.resume())},onError:v=>a(v),onEnd:()=>r()})})}async ab(t,c,s){let n=0,i;for(;(i=s.read())!==null;)await this.bb(t,c,i,i.byteLength,n,0),n+=i.byteLength}async bb(t,c,s,n,i,r){let a=0;for(;a<n;){const v=await t.write(c,i+a,s.buffer,r+a,n-a);a+=v}}async cb(t,c,s,n){return this.X.queueFor(c,this.N(t).providerExtUri).queue(()=>this.db(t,c,s,n))}async db(t,c,s,n){let i;n instanceof O.$Hc?i=n:(0,d.$tc)(n)?i=await(0,O.$Tc)(n):(0,d.$uc)(n)?i=await(0,O.$Uc)(n):i=(0,O.$Rc)(n),await t.writeFile(c,i.buffer,{create:!0,overwrite:!0,unlock:s?.unlock??!1,atomic:s?.atomic??!1})}async eb(t,c,s,n){return this.X.queueFor(n,this.N(s).providerExtUri).queue(()=>this.fb(t,c,s,n))}async fb(t,c,s,n){let i,r;try{i=await t.open(c,{create:!1}),r=await s.open(n,{create:!0,unlock:!1});const a=O.$Hc.alloc(this.a);let v=0,y=0,u=0;do u=await t.read(i,v,a.buffer,y,a.byteLength-y),await this.bb(s,r,a,u,v,y),v+=u,y+=u,y===a.byteLength&&(y=0);while(u>0)}catch(a){throw(0,f.$ek)(a)}finally{await N.Promises.settled([typeof i=="number"?t.close(i):Promise.resolve(),typeof r=="number"?s.close(r):Promise.resolve()])}}async gb(t,c,s,n){return this.X.queueFor(n,this.N(s).providerExtUri).queue(()=>this.hb(t,c,s,n))}async hb(t,c,s,n){return s.writeFile(n,await t.readFile(c),{create:!0,overwrite:!0,unlock:!1,atomic:!1})}async ib(t,c,s,n){return this.X.queueFor(n,this.N(s).providerExtUri).queue(()=>this.jb(t,c,s,n))}async jb(t,c,s,n){const i=await s.open(n,{create:!0,unlock:!1});try{const r=await t.readFile(c);await this.bb(s,i,O.$Hc.wrap(r),r.byteLength,0,0)}catch(r){throw(0,f.$ek)(r)}finally{await s.close(i)}}async kb(t,c,s,n){const i=await(0,O.$Tc)(this.C(t,c,j.CancellationToken.None));await this.cb(s,n,void 0,i)}lb(t,c){if(t.capabilities&2048)throw new f.$lk((0,w.localize)(24,null,this.nb(c)),6);return t}mb(t,c){if((c.permissions??0)&f.FilePermission.Readonly)throw new f.$lk((0,w.localize)(25,null,this.nb(t)),6)}nb(t){return t.scheme===p.Schemas.file?t.fsPath:t.toString(!0)}};e.$Ap=b,e.$Ap=b=ye([X(0,l.$3i)],b)}),define(re[199],oe([0,1,52,270,5,35,14,3,48,2,15,6,23,42,31,161,13,99,197,38,193,192]),function(te,e,L,N,O,j,A,R,k,m,P,p,g,h,d,w,f,o,l,$,b,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zp=void 0,(()=>{try{(0,N.gracefulify)(L)}catch(c){console.error(`Error enabling graceful-fs: ${(0,$.$ki)(c)}`)}})();class t extends l.$Jp{static{this.D=!1}constructor(s,n){super(s,n),this.onDidChangeCapabilities=R.Event.None,this.I=new j.$xi(i=>g.$0f.getComparisonKey(i)),this.O=new Map,this.P=new Map,this.Q=new Map}get capabilities(){return this.F||(this.F=253982,p.$k&&(this.F|=1024)),this.F}async stat(s){try{const{stat:n,symbolicLink:i}=await d.SymlinkSupport.stat(this.C(s));return{type:this.H(n,i),ctime:n.birthtime.getTime(),mtime:n.mtime.getTime(),size:n.size,permissions:n.mode&128?void 0:f.FilePermission.Locked}}catch(n){throw this.ab(n)}}async G(s){try{return await this.stat(s)}catch{return}}async readdir(s){try{const n=await d.Promises.readdir(this.C(s),{withFileTypes:!0}),i=[];return await Promise.all(n.map(async r=>{try{let a;r.isSymbolicLink()?a=(await this.stat((0,g.$gg)(s,r.name))).type:a=this.H(r),i.push([r.name,a])}catch(a){this.a.trace(a)}})),i}catch(n){throw this.ab(n)}}H(s,n){let i;return n?.dangling?i=f.FileType.Unknown:s.isFile()?i=f.FileType.File:s.isDirectory()?i=f.FileType.Directory:i=f.FileType.Unknown,n&&(i|=f.FileType.SymbolicLink),i}async J(s){const n=this.C(s);this.L(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${n})`);let i;for(;i=this.I.get(s);)this.L(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${n})`),await i.wait();const r=new O.$Dg;return this.I.set(s,r),this.L(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${n})`),(0,m.$kb)(()=>{this.L(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${n})`),this.I.get(s)===r&&(this.L(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${n})`),this.I.delete(s)),this.L(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${n})`),r.open()})}async readFile(s,n){let i;try{n?.atomic&&(this.L(`[Disk FileSystemProvider]: atomic read operation started (${this.C(s)})`),i=await this.J(s));const r=this.C(s);return await d.Promises.readFile(r)}catch(r){throw this.ab(r)}finally{i?.dispose()}}L(s){t.D&&this.a.trace(s)}readFileStream(s,n,i){const r=(0,h.$vc)(a=>A.$Hc.concat(a.map(v=>A.$Hc.wrap(v))).buffer);return(0,o.$zp)(this,s,r,a=>a.buffer,{...n,bufferSize:256*1024},i),r}async writeFile(s,n,i){return i?.atomic!==!1&&i?.atomic?.postfix?this.M(s,(0,g.$gg)((0,g.$fg)(s),`${(0,g.$dg)(s)}${i.atomic.postfix}`),n,i):this.N(s,n,i)}async M(s,n,i,r){await this.N(n,i,r);try{await this.rename(n,s,{overwrite:!0})}catch(a){try{await this.delete(n,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw a}}async N(s,n,i){let r;try{const a=this.C(s);if(!i.create||!i.overwrite){if(await d.Promises.exists(a)){if(!i.overwrite)throw(0,f.$dk)((0,w.localize)(0,null),f.FileSystemProviderErrorCode.FileExists)}else if(!i.create)throw(0,f.$dk)((0,w.localize)(1,null),f.FileSystemProviderErrorCode.FileNotFound)}r=await this.open(s,{create:!0,unlock:i.unlock}),await this.write(r,0,n,0,n.byteLength)}catch(a){throw await this.bb(s,a)}finally{typeof r=="number"&&await this.close(r)}}static{this.R=!0}static configureFlushOnWrite(s){t.R=s}async open(s,n){const i=this.C(s);let r;(0,f.$5j)(n)&&(r=await this.J(s));let a;try{if((0,f.$5j)(n)&&n.unlock)try{const{stat:y}=await d.SymlinkSupport.stat(i);y.mode&128||await d.Promises.chmod(i,y.mode|128)}catch(y){y.code!=="ENOENT"&&this.a.trace(y)}let v;if((0,f.$5j)(n)){if(p.$i)try{await d.Promises.truncate(i,0),v="r+"}catch(y){y.code!=="ENOENT"&&this.a.trace(y)}v||(v="w")}else v="r";a=await d.Promises.open(i,v)}catch(v){throw r?.dispose(),(0,f.$5j)(n)?await this.bb(s,v):this.ab(v)}if(this.O.set(a,0),(0,f.$5j)(n)&&this.Q.set(a,s),r){const v=this.P.get(a);this.L(`[Disk FileSystemProvider]: open() - storing lock for handle ${a} (${i})`),this.P.set(a,r),v&&(this.L(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${a} (${i})`),v.dispose())}return a}async close(s){const n=this.P.get(s);try{if(this.O.delete(s),this.Q.delete(s)&&t.R)try{await d.Promises.fdatasync(s)}catch(i){t.configureFlushOnWrite(!1),this.a.error(i)}return await d.Promises.close(s)}catch(i){throw this.ab(i)}finally{n&&(this.P.get(s)===n&&(this.L(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${s}`),this.P.delete(s)),this.L(`[Disk FileSystemProvider]: close() - disposing lock for handle ${s}`),n.dispose())}}async read(s,n,i,r,a){const v=this.S(s,n);let y=null;try{y=(await d.Promises.read(s,i,r,a,v)).bytesRead}catch(u){throw this.ab(u)}finally{this.U(s,v,y)}return y}S(s,n){return n===this.O.get(s)?null:n}U(s,n,i){const r=this.O.get(s);typeof r=="number"&&(typeof n=="number"||(typeof i=="number"?this.O.set(s,r+i):this.O.delete(s)))}async write(s,n,i,r,a){return(0,O.$Wg)(()=>this.W(s,n,i,r,a),100,3)}async W(s,n,i,r,a){const v=this.S(s,n);let y=null;try{y=(await d.Promises.write(s,i,r,a,v)).bytesWritten}catch(u){throw await this.bb(this.Q.get(s),u)}finally{this.U(s,v,y)}return y}async mkdir(s){try{await d.Promises.mkdir(this.C(s))}catch(n){throw this.ab(n)}}async delete(s,n){try{const i=this.C(s);if(n.recursive){let r;n?.atomic!==!1&&n.atomic.postfix&&(r=(0,P.$$c)((0,P.$bd)(i),`${(0,P.$cd)(i)}${n.atomic.postfix}`)),await d.Promises.rm(i,d.RimRafMode.MOVE,r)}else try{await d.Promises.unlink(i)}catch(r){if(r.code==="EPERM"||r.code==="EISDIR"){let a=!1;try{const{stat:v,symbolicLink:y}=await d.SymlinkSupport.stat(i);a=v.isDirectory()&&!y}catch{}if(a)await d.Promises.rmdir(i);else throw r}else throw r}}catch(i){throw this.ab(i)}}async rename(s,n,i){const r=this.C(s),a=this.C(n);if(r!==a)try{await this.X(s,n,"move",i.overwrite),await d.Promises.rename(r,a)}catch(v){throw(v.code==="EINVAL"||v.code==="EBUSY"||v.code==="ENAMETOOLONG")&&(v=new Error((0,w.localize)(2,null,(0,P.$cd)(r),(0,P.$cd)((0,P.$bd)(a)),v.toString()))),this.ab(v)}}async copy(s,n,i){const r=this.C(s),a=this.C(n);if(r!==a)try{await this.X(s,n,"copy",i.overwrite),await d.Promises.copy(r,a,{preserveSymlinks:!0})}catch(v){throw(v.code==="EINVAL"||v.code==="EBUSY"||v.code==="ENAMETOOLONG")&&(v=new Error((0,w.localize)(3,null,(0,P.$cd)(r),(0,P.$cd)((0,P.$bd)(a)),v.toString()))),this.ab(v)}}async X(s,n,i,r){const a=this.C(s),v=this.C(n);let y=!1;if(!!(this.capabilities&1024)||(y=(0,k.$Je)(a,v,!0)),y){if(i==="copy")throw(0,f.$dk)((0,w.localize)(4,null),f.FileSystemProviderErrorCode.FileExists);if(i==="move")return}const E=await this.G(s);if(!E)throw(0,f.$dk)((0,w.localize)(5,null),f.FileSystemProviderErrorCode.FileNotFound);const D=await this.G(n);if(D){if(!r)throw(0,f.$dk)((0,w.localize)(6,null),f.FileSystemProviderErrorCode.FileExists);E.type&f.FileType.File&&D.type&f.FileType.File||await this.delete(n,{recursive:!0,useTrash:!1,atomic:!1})}}async cloneFile(s,n){return this.Y(s,n,!1)}async Y(s,n,i){const r=this.C(s),a=this.C(n),v=!!(this.capabilities&1024);if((0,k.$Je)(r,a,!v))return;const y=new m.$lb;try{const[u,E]=await Promise.all([this.J(s),this.J(n)]);y.add(u),y.add(E),i&&await d.Promises.mkdir((0,P.$bd)(a),{recursive:!0}),await d.Promises.copyFile(r,a)}catch(u){if(u.code==="ENOENT"&&!i)return this.Y(s,n,!0);throw this.ab(u)}finally{y.dispose()}}p(s,n,i){return new b.$Qp(r=>s(r),r=>n(r),i)}y(s,n,i){return new I.$Yp(r=>s(r),r=>n(r),i)}ab(s){if(s instanceof f.$ck)return s;let n=s,i;switch(s.code){case"ENOENT":i=f.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":i=f.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":i=f.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":i=f.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":i=f.FileSystemProviderErrorCode.NoPermissions;break;case"ERR_UNC_HOST_NOT_ALLOWED":n=`${s.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`,i=f.FileSystemProviderErrorCode.Unknown;break;default:i=f.FileSystemProviderErrorCode.Unknown}return(0,f.$dk)(n,i)}async bb(s,n){let i=this.ab(n);if(s&&i.code===f.FileSystemProviderErrorCode.NoPermissions)try{const{stat:r}=await d.SymlinkSupport.stat(this.C(s));r.mode&128||(i=(0,f.$dk)(n,f.FileSystemProviderErrorCode.FileWriteLocked))}catch(r){this.a.trace(r)}return i}}e.$Zp=t}),define(re[101],oe([0,1,3,2,4,7]),function(te,e,L,N,O,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$F7b=e.$E7b=void 0,e.$E7b=(0,O.$zh)("sharedProcessLifecycleService");let A=class extends N.$mb{constructor(k){super(),this.b=k,this.a=this.B(new L.$hc),this.onWillShutdown=this.a.event}fireOnWillShutdown(){this.b.trace("Lifecycle#onWillShutdown.fire()"),this.a.fire()}};e.$F7b=A,e.$F7b=A=ye([X(0,j.$3i)],A)}),define(re[200],oe([0,1,11,3,7,2]),function(te,e,L,N,O,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zq=e.$Yq=e.$Xq=void 0;class A extends O.$bj{constructor(p,g,h,d,w){super(g,h,d),this.n=p,this.p=w,this.B(w.listen("onDidChangeLogLevel",p)(f=>{(0,O.$5i)(f)?super.setLogLevel(f):super.setLogLevel(L.URI.revive(f[0]),f[1])})),this.B(w.listen("onDidChangeVisibility",p)(([f,o])=>super.setVisibility(L.URI.revive(f),o))),this.B(w.listen("onDidChangeLoggers",p)(({added:f,removed:o})=>{for(const l of f)super.registerLogger({...l,resource:L.URI.revive(l.resource)});for(const l of o)super.deregisterLogger(l.resource)}))}createConsoleMainLogger(){return new O.$_i({log:(p,g)=>{this.p.call("consoleLog",[p,g])}})}registerLogger(p){super.registerLogger(p),this.p.call("registerLogger",[p,this.n])}deregisterLogger(p){super.deregisterLogger(p),this.p.call("deregisterLogger",[p,this.n])}setLogLevel(p,g){super.setLogLevel(p,g),this.p.call("setLogLevel",[p,g])}setVisibility(p,g){super.setVisibility(p,g),this.p.call("setVisibility",[this.l(p),g])}m(p,g,h){return new R(this.p,p,g,h,this.n)}static setLogLevel(p,g,h){return p.call("setLogLevel",[g,h])}}e.$Xq=A;class R extends O.$9i{constructor(p,g,h,d,w){super(d?.logLevel==="always"),this.m=p,this.n=g,this.k=!1,this.l=[],this.setLevel(h),this.m.call("createLogger",[g,d,w]).then(()=>{this.r(this.l),this.k=!0})}g(p,g){const h=[[p,g]];this.k?this.r(h):this.l.push(...h)}r(p){this.m.call("log",[this.n,p])}}class k{constructor(p,g){this.a=p,this.b=g}listen(p,g){const h=this.b(p);switch(g){case"onDidChangeLoggers":return N.Event.map(this.a.onDidChangeLoggers,d=>({added:[...d.added].map(w=>this.c(w,h)),removed:[...d.removed].map(w=>this.c(w,h))}));case"onDidChangeVisibility":return N.Event.map(this.a.onDidChangeVisibility,d=>[h.transformOutgoingURI(d[0]),d[1]]);case"onDidChangeLogLevel":return N.Event.map(this.a.onDidChangeLogLevel,d=>(0,O.$5i)(d)?d:[h.transformOutgoingURI(d[0]),d[1]])}throw new Error(`Event not found: ${g}`)}async call(p,g,h){const d=this.b(p);switch(g){case"setLogLevel":return(0,O.$5i)(h[0])?this.a.setLogLevel(h[0]):this.a.setLogLevel(L.URI.revive(d.transformIncoming(h[0][0])),h[0][1]);case"getRegisteredLoggers":return Promise.resolve([...this.a.getRegisteredLoggers()].map(w=>this.c(w,d)))}throw new Error(`Call not found: ${g}`)}c(p,g){return{...p,resource:g.transformOutgoingURI(p.resource)}}}e.$Yq=k;class m extends j.$mb{constructor(p,g){super(),g.call("setLogLevel",[p.getLogLevel()]),this.B(p.onDidChangeLogLevel(h=>g.call("setLogLevel",[h]))),g.call("getRegisteredLoggers").then(h=>{for(const d of h)p.registerLogger({...d,resource:L.URI.revive(d.resource)})}),this.B(g.listen("onDidChangeVisibility")(([h,d])=>p.setVisibility(L.URI.revive(h),d))),this.B(g.listen("onDidChangeLoggers")(({added:h,removed:d})=>{for(const w of h)p.registerLogger({...w,resource:L.URI.revive(w.resource)});for(const w of d)p.deregisterLogger(w.resource)}))}}e.$Zq=m}),define(re[201],oe([0,1,2,7]),function(te,e,L,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fN=void 0;class O extends L.$mb{constructor(A,R=[]){super(),this.a=new N.$aj([A,...R]),this.B(A.onDidChangeLogLevel(k=>this.setLevel(k)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(A){this.a.setLevel(A)}getLevel(){return this.a.getLevel()}trace(A,...R){this.a.trace(A,...R)}debug(A,...R){this.a.debug(A,...R)}info(A,...R){this.a.info(A,...R)}warn(A,...R){this.a.warn(A,...R)}error(A,...R){this.a.error(A,...R)}flush(){this.a.flush()}}e.$fN=O}),define(re[55],oe([0,1,4]),function(te,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$x5b=void 0,e.$x5b=(0,L.$zh)("nativeHostService")}),define(re[56],oe([0,1,3,59,2,4]),function(te,e,L,N,O,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0m=e.$9m=e.$8m=void 0,e.$8m=(0,j.$zh)("policy");class A extends O.$mb{constructor(){super(...arguments),this.f={},this.g=new Map,this.h=this.B(new L.$hc),this.onDidChange=this.h.event}async updatePolicyDefinitions(m){const P=Object.keys(this.f).length;return this.f={...m,...this.f},P!==Object.keys(this.f).length&&await this.i(m),N.Iterable.reduce(this.g.entries(),(p,[g,h])=>({...p,[g]:h}),{})}getPolicyValue(m){return this.g.get(m)}serialize(){return N.Iterable.reduce(Object.entries(this.f),(m,[P,p])=>({...m,[P]:{definition:p,value:this.g.get(P)}}),{})}}e.$9m=A;class R{constructor(){this.onDidChange=L.Event.None}async updatePolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.$0m=R}),define(re[202],oe([0,1,3,2,56]),function(te,e,L,N,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$o6b=e.$n6b=void 0;class j{constructor(k){this.b=k,this.a=new N.$lb}listen(k,m){switch(m){case"onDidChange":return L.Event.map(this.b.onDidChange,P=>P.reduce((p,g)=>({...p,[g]:this.b.getPolicyValue(g)??null}),{}),this.a)}throw new Error(`Event not found: ${m}`)}call(k,m,P){switch(m){case"updatePolicyDefinitions":return this.b.updatePolicyDefinitions(P)}throw new Error(`Call not found: ${m}`)}dispose(){this.a.dispose()}}e.$n6b=j;class A extends O.$9m{constructor(k,m){super(),this.a=m;for(const P in k){const{definition:p,value:g}=k[P];this.f[P]=p,g!==void 0&&this.g.set(P,g)}this.a.listen("onDidChange")(P=>{for(const p in P){const g=P[p];g===null?this.g.delete(p):this.g.set(p,g)}this.h.fire(Object.keys(P))})}async i(k){const m=await this.a.call("updatePolicyDefinitions",k);for(const P in m)this.g.set(P,m[P])}}e.$o6b=A}),define(re[102],oe([0,1,6,37]),function(te,e,L,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let O;if(typeof L.$g.vscode<"u"&&typeof L.$g.vscode.context<"u"){const j=L.$g.vscode.context.configuration();if(j)O=j.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){if(O=globalThis._VSCODE_PRODUCT_JSON,N.env.VSCODE_DEV&&Object.assign(O,{nameShort:`${O.nameShort} Dev`,nameLong:`${O.nameLong} Dev`,dataFolderName:`${O.dataFolderName}-dev`,serverDataFolderName:O.serverDataFolderName?`${O.serverDataFolderName}-dev`:void 0}),!O.version){const j=globalThis._VSCODE_PACKAGE_JSON;Object.assign(O,{version:j.version})}}else O={},Object.keys(O).length===0&&Object.assign(O,{version:"1.82.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",serverLicenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=O}),define(re[24],oe([0,1,4]),function(te,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jj=e.$ij=void 0,e.$ij=(0,L.$zh)("productService"),e.$jj="vscode://schemas/vscode-product"}),define(re[203],oe([0,1,5,8,2,15,31,7,24]),function(te,e,L,N,O,j,A,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_6b=void 0;let m=class extends O.$mb{constructor(p,g,h){super(),this.b=g,this.c=h,this.a=this.b.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,p&&this.B(new L.$Qg(()=>{this.f(p)},3e4)).schedule()}async f(p){this.c.trace("[code cache cleanup]: Starting to clean up old code cache folders.");try{const g=Date.now(),h=(0,j.$bd)(p),d=(0,j.$cd)(p),w=await A.Promises.readdir(h);await Promise.all(w.map(async f=>{if(f===d)return;const o=(0,j.$$c)(h,f),l=await A.Promises.stat(o);if(l.isDirectory()&&g-l.mtime.getTime()>this.a)return this.c.trace(`[code cache cleanup]: Removing code cache folder ${f}.`),A.Promises.rm(o)}))}catch(g){(0,N.$Y)(g)}}};e.$_6b=m,e.$_6b=m=ye([X(1,k.$ij),X(2,R.$3i)],m)}),define(re[204],oe([0,1,5,8,2,15,31,16,7,24]),function(te,e,L,N,O,j,A,R,k,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$a7b=void 0;let P=class extends O.$mb{constructor(g,h,d){super(),this.b=g,this.c=h,this.f=d,this.a=this.f.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,this.b.isBuilt&&this.B(new L.$Qg(()=>{this.g()},4e4)).schedule()}async g(){this.c.trace("[language pack cache cleanup]: Starting to clean up unused language packs.");try{const g=Object.create(null),h=JSON.parse(await A.Promises.readFile((0,j.$$c)(this.b.userDataPath,"languagepacks.json"),"utf8"));for(const l of Object.keys(h)){const $=h[l];g[`${$.hash}.${l}`]=!0}const d=(0,j.$$c)(this.b.userDataPath,"clp");if(!await A.Promises.exists(d))return;const f=await A.Promises.readdir(d);for(const l of f){if(g[l]){this.c.trace(`[language pack cache cleanup]: Skipping folder ${l}. Language pack still in use.`);continue}this.c.trace(`[language pack cache cleanup]: Removing unused language pack: ${l}`),await A.Promises.rm((0,j.$$c)(d,l))}const o=Date.now();for(const l of Object.keys(g)){const $=(0,j.$$c)(d,l),b=await A.Promises.readdir($);for(const I of b){if(I==="tcf.json")continue;const t=(0,j.$$c)($,I),c=await A.Promises.stat(t);c.isDirectory()&&o-c.mtime.getTime()>this.a&&(this.c.trace(`[language pack cache cleanup]: Removing language pack cache folder: ${(0,j.$$c)(l,I)}`),await A.Promises.rm(t))}}}catch(g){(0,N.$Y)(g)}}};e.$a7b=P,e.$a7b=P=ye([X(0,R.$Hh),X(1,k.$3i),X(2,m.$ij)],P)}),define(re[205],oe([0,1,15,4]),function(te,e,L,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Utils=e.$yF=void 0,e.$yF=(0,N.$zh)("IV8InspectProfilingService");var O;(function(j){function A(k){return!!(k.samples&&k.timeDeltas)}j.isValidProfile=A;function R(k,m="noAbsolutePaths"){for(const P of k.nodes)P.callFrame&&P.callFrame.url&&((0,L.$0c)(P.callFrame.url)||/^\w[\w\d+.-]*:\/\/\/?/.test(P.callFrame.url))&&(P.callFrame.url=(0,L.$$c)(m,(0,L.$cd)(P.callFrame.url)));return k}j.rewriteAbsolutePaths=R})(O||(e.Utils=O={}))}),define(re[206],oe([0,1,32]),function(te,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$u7b=void 0;class N{constructor(){this.a=new Map}async startProfiling(j){const R=await(await new Promise((m,P)=>{te(["v8-inspect-profiler"],m,P)})).startProfiling({port:j.port,checkForPaused:!0}),k=(0,L.$6e)();return this.a.set(k,R),k}async stopProfiling(j){const A=this.a.get(j);if(!A)throw new Error(`UNKNOWN session '${j}'`);const R=await A.stop();return this.a.delete(j),R.profile}}e.$u7b=N}),define(re[40],oe([0,1,126,9]),function(te,e,L,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6m=void 0;class O{constructor(){this.a=new Map}add(A,R){L.ok(N.$le(A)),L.ok(N.$ne(R)),L.ok(!this.a.has(A),"There is already an extension with this id"),this.a.set(A,R)}knows(A){return this.a.has(A)}as(A){return this.a.get(A)||null}}e.$6m=new O}),define(re[103],oe([0,1,3,40]),function(te,e,L,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7m=void 0,e.$7m={JSONContribution:"base.contributions.json"};function O(R){return R.length>0&&R.charAt(R.length-1)==="#"?R.substring(0,R.length-1):R}class j{constructor(){this.b=new L.$hc,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(k,m){this.a[O(k)]=m,this.b.fire(k)}notifySchemaChanged(k){this.b.fire(k)}getSchemaContributions(){return{schemas:this.a}}}const A=new j;N.$6m.add(e.$7m.JSONContribution,A)}),define(re[49],oe([0,1,20,3,9,148,18,103,40]),function(te,e,L,N,O,j,A,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nn=e.$mn=e.$ln=e.$kn=e.$jn=e.$in=e.$hn=e.$gn=e.$fn=e.$en=e.$dn=e.$cn=e.$bn=e.$an=e.$_m=e.ConfigurationScope=e.$$m=e.EditPresentationTypes=void 0;var m;(function(I){I.Multiline="multilineText",I.Singleline="singlelineText"})(m||(e.EditPresentationTypes=m={})),e.$$m={Configuration:"base.contributions.configuration"};var P;(function(I){I[I.APPLICATION=1]="APPLICATION",I[I.MACHINE=2]="MACHINE",I[I.WINDOW=3]="WINDOW",I[I.RESOURCE=4]="RESOURCE",I[I.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",I[I.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(P||(e.ConfigurationScope=P={})),e.$_m={properties:{},patternProperties:{}},e.$an={properties:{},patternProperties:{}},e.$bn={properties:{},patternProperties:{}},e.$cn={properties:{},patternProperties:{}},e.$dn={properties:{},patternProperties:{}},e.$en={properties:{},patternProperties:{}},e.$fn="vscode://schemas/settings/resourceLanguage",e.$gn="vscode://schemas/settings/configurationDefaults";const p=k.$6m.as(R.$7m.JSONContribution);class g{constructor(){this.h=new Set,this.i=new N.$hc,this.onDidSchemaChange=this.i.event,this.j=new N.$hc,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:j.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},p.registerSchema(e.$fn,this.g),this.v()}registerConfiguration(t,c=!0){this.registerConfigurations([t],c)}registerConfigurations(t,c=!0){const s=new Set;this.n(t,c,s),p.registerSchema(e.$fn,this.g),this.i.fire(),this.j.fire({properties:s})}deregisterConfigurations(t){const c=new Set;this.o(t,c),p.registerSchema(e.$fn,this.g),this.i.fire(),this.j.fire({properties:c})}updateConfigurations({add:t,remove:c}){const s=new Set;this.o(c,s),this.n(t,!1,s),p.registerSchema(e.$fn,this.g),this.i.fire(),this.j.fire({properties:s})}registerDefaultConfigurations(t){const c=new Set;this.k(t,c),this.i.fire(),this.j.fire({properties:c,defaultsOverrides:!0})}k(t,c){const s=[];for(const{overrides:n,source:i}of t)for(const r in n)if(c.add(r),e.$in.test(r)){const a=this.a.get(r),v=a?.valuesSources??new Map;if(i)for(const D of Object.keys(n[r]))v.set(D,i);const y={...a?.value||{},...n[r]};this.a.set(r,{source:i,value:y,valuesSources:v});const u=(0,A.$di)(r),E={type:"object",default:y,description:j.localize(1,null,u),$ref:e.$fn,defaultDefaultValue:y,source:O.$le(i)?void 0:i,defaultValueSource:i};s.push(...w(r)),this.d[r]=E,this.b.properties[r]=E}else{this.a.set(r,{value:n[r],source:i});const a=this.d[r];a&&(this.w(r,a),this.r(r,a))}this.m(s)}deregisterDefaultConfigurations(t){const c=new Set;this.l(t,c),this.i.fire(),this.j.fire({properties:c,defaultsOverrides:!0})}l(t,c){for(const{overrides:s,source:n}of t)for(const i in s){const r=this.a.get(i),a=O.$le(n)?n:n?.id,v=O.$le(r?.source)?r?.source:r?.source?.id;if(a===v)if(c.add(i),this.a.delete(i),e.$in.test(i))delete this.d[i],delete this.b.properties[i];else{const y=this.d[i];y&&(this.w(i,y),this.r(i,y))}}this.u()}deltaConfiguration(t){let c=!1;const s=new Set;t.removedDefaults&&(this.l(t.removedDefaults,s),c=!0),t.addedDefaults&&(this.k(t.addedDefaults,s),c=!0),t.removedConfigurations&&this.o(t.removedConfigurations,s),t.addedConfigurations&&this.n(t.addedConfigurations,!1,s),this.i.fire(),this.j.fire({properties:s,defaultsOverrides:c})}notifyConfigurationSchemaUpdated(...t){this.i.fire()}registerOverrideIdentifiers(t){this.m(t),this.i.fire()}m(t){for(const c of t)this.h.add(c);this.u()}n(t,c,s){t.forEach(n=>{this.p(n,c,n.extensionInfo,n.restrictedProperties,void 0,s),this.c.push(n),this.q(n)})}o(t,c){const s=n=>{if(n.properties)for(const i in n.properties){c.add(i);const r=this.d[i];r?.policy?.name&&this.e.delete(r.policy.name),delete this.d[i],this.s(i,n.properties[i])}n.allOf?.forEach(i=>s(i))};for(const n of t){s(n);const i=this.c.indexOf(n);i!==-1&&this.c.splice(i,1)}}p(t,c=!0,s,n,i=3,r){i=O.$ue(t.scope)?i:t.scope;const a=t.properties;if(a)for(const y in a){const u=a[y];if(c&&$(y,u)){delete a[y];continue}if(u.source=s,u.defaultDefaultValue=a[y].default,this.w(y,u),e.$in.test(y)?u.scope=void 0:(u.scope=O.$ue(u.scope)?i:u.scope,u.restricted=O.$ue(u.restricted)?!!n?.includes(y):u.restricted),a[y].hasOwnProperty("included")&&!a[y].included){this.f[y]=a[y],delete a[y];continue}else this.d[y]=a[y],a[y].policy?.name&&this.e.set(a[y].policy.name,y);!a[y].deprecationMessage&&a[y].markdownDeprecationMessage&&(a[y].deprecationMessage=a[y].markdownDeprecationMessage),r.add(y)}const v=t.allOf;if(v)for(const y of v)this.p(y,c,s,n,i,r)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(t){const c=s=>{const n=s.properties;if(n)for(const r in n)this.r(r,n[r]);s.allOf?.forEach(c)};c(t)}r(t,c){switch(e.$_m.properties[t]=c,c.scope){case 1:e.$an.properties[t]=c;break;case 2:e.$bn.properties[t]=c;break;case 6:e.$cn.properties[t]=c;break;case 3:e.$dn.properties[t]=c;break;case 4:e.$en.properties[t]=c;break;case 5:e.$en.properties[t]=c,this.g.properties[t]=c;break}}s(t,c){switch(delete e.$_m.properties[t],c.scope){case 1:delete e.$an.properties[t];break;case 2:delete e.$bn.properties[t];break;case 6:delete e.$cn.properties[t];break;case 3:delete e.$dn.properties[t];break;case 4:case 5:delete e.$en.properties[t],delete this.g.properties[t];break}}u(){for(const t of this.h.values()){const c=`[${t}]`,s={type:"object",description:j.localize(2,null),errorMessage:j.localize(3,null),$ref:e.$fn};this.w(c,s),e.$_m.properties[c]=s,e.$an.properties[c]=s,e.$bn.properties[c]=s,e.$cn.properties[c]=s,e.$dn.properties[c]=s,e.$en.properties[c]=s}}v(){const t={type:"object",description:j.localize(4,null),errorMessage:j.localize(5,null),$ref:e.$fn};e.$_m.patternProperties[e.$hn]=t,e.$an.patternProperties[e.$hn]=t,e.$bn.patternProperties[e.$hn]=t,e.$cn.patternProperties[e.$hn]=t,e.$dn.patternProperties[e.$hn]=t,e.$en.patternProperties[e.$hn]=t,this.i.fire()}w(t,c){const s=this.a.get(t);let n=s?.value,i=s?.source;O.$se(n)&&(n=c.defaultDefaultValue,i=void 0),O.$se(n)&&(n=o(c.type)),c.default=n,c.defaultValueSource=i}}const h="\\[([^\\]]+)\\]",d=new RegExp(h,"g");e.$hn=`^(${h})+$`,e.$in=new RegExp(e.$hn);function w(I){const t=[];if(e.$in.test(I)){let c=d.exec(I);for(;c?.length;){const s=c[1].trim();s&&t.push(s),c=d.exec(I)}}return(0,L.$Ff)(t)}e.$jn=w;function f(I){return I.reduce((t,c)=>`${t}[${c}]`,"")}e.$kn=f;function o(I){switch(Array.isArray(I)?I[0]:I){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.$ln=o;const l=new g;k.$6m.add(e.$$m.Configuration,l);function $(I,t){return I.trim()?e.$in.test(I)?j.localize(7,null,I):l.getConfigurationProperties()[I]!==void 0?j.localize(8,null,I):t.policy?.name&&l.getPolicyConfigurations().get(t.policy?.name)!==void 0?j.localize(9,null,I,t.policy?.name,l.getPolicyConfigurations().get(t.policy?.name)):null:j.localize(6,null)}e.$mn=$;function b(){const I=[],t=l.getConfigurationProperties();for(const c of Object.keys(t))I.push([c,t[c].scope]);return I.push(["launch",4]),I.push(["task",4]),I}e.$nn=b}),define(re[73],oe([0,1,20,3,34,2,35,30,9,11,18,49,40]),function(te,e,L,N,O,j,A,R,k,m,P,p,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tn=e.$sn=e.$rn=e.$qn=e.$pn=e.$on=void 0;function h(c){return Object.isFrozen(c)?c:R.$Um(c)}class d{constructor(s={},n=[],i=[],r){this.b=s,this.c=n,this.d=i,this.raw=r,this.a=new Map}get rawConfiguration(){if(!this.f)if(this.raw?.length){const s=this.raw.map(n=>{if(n instanceof d)return n;const i=new w("");return i.parseRaw(n),i.configurationModel});this.f=s.reduce((n,i)=>i===n?i:n.merge(i),s[0])}else this.f=this;return this.f}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(s){return s?(0,P.$bi)(this.contents,s):this.contents}inspect(s,n){const i=this.rawConfiguration.getValue(s),r=n?this.rawConfiguration.getOverrideValue(s,n):void 0,a=n?this.rawConfiguration.override(n).getValue(s):i;return{value:i,override:r,merged:a}}getOverrideValue(s,n){const i=this.i(n);return i?s?(0,P.$bi)(i,s):i:void 0}getKeysForOverrideIdentifier(s){const n=[];for(const i of this.overrides)i.identifiers.includes(s)&&n.push(...i.keys);return L.$Ff(n)}getAllOverrideIdentifiers(){const s=[];for(const n of this.overrides)s.push(...n.identifiers);return L.$Ff(s)}override(s){let n=this.a.get(s);return n||(n=this.g(s),this.a.set(s,n)),n}merge(...s){const n=R.$Tm(this.contents),i=R.$Tm(this.overrides),r=[...this.keys],a=this.raw?.length?[...this.raw]:[this];for(const v of s)if(a.push(...v.raw?.length?v.raw:[v]),!v.isEmpty()){this.h(n,v.contents);for(const y of v.overrides){const[u]=i.filter(E=>L.$of(E.identifiers,y.identifiers));u?(this.h(u.contents,y.contents),u.keys.push(...y.keys),u.keys=L.$Ff(u.keys)):i.push(R.$Tm(y))}for(const y of v.keys)r.indexOf(y)===-1&&r.push(y)}return new d(n,r,i,a.every(v=>v instanceof d)?void 0:a)}g(s){const n=this.i(s);if(!n||typeof n!="object"||!Object.keys(n).length)return this;const i={};for(const r of L.$Ff([...Object.keys(this.contents),...Object.keys(n)])){let a=this.contents[r];const v=n[r];v&&(typeof a=="object"&&typeof v=="object"?(a=R.$Tm(a),this.h(a,v)):a=v),i[r]=a}return new d(i,this.keys,this.overrides)}h(s,n){for(const i of Object.keys(n)){if(i in s&&k.$ne(s[i])&&k.$ne(n[i])){this.h(s[i],n[i]);continue}s[i]=R.$Tm(n[i])}}i(s){let n=null,i=null;const r=a=>{a&&(i?this.h(i,a):i=R.$Tm(a))};for(const a of this.overrides)a.identifiers.length===1&&a.identifiers[0]===s?n=a.contents:a.identifiers.includes(s)&&r(a.contents);return r(n),i}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(s,n){this.j(s,n,!0)}setValue(s,n){this.j(s,n,!1)}removeValue(s){const n=this.keys.indexOf(s);n!==-1&&(this.keys.splice(n,1),(0,P.$ai)(this.contents,s),p.$in.test(s)&&this.overrides.splice(this.overrides.findIndex(i=>L.$of(i.identifiers,(0,p.$jn)(s))),1))}j(s,n,i){(0,P.$_h)(this.contents,s,n,r=>console.error(r)),i=i||this.keys.indexOf(s)===-1,i&&this.keys.push(s),p.$in.test(s)&&this.overrides.push({identifiers:(0,p.$jn)(s),keys:Object.keys(this.contents[s]),contents:(0,P.$$h)(this.contents[s],r=>console.error(r))})}}e.$on=d;class w{constructor(s){this.f=s,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new d}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(s,n){if(!k.$ue(s)){const i=this.g(s);this.parseRaw(i,n)}}reparse(s){this.a&&this.parseRaw(this.a,s)}parseRaw(s,n){this.a=s;const{contents:i,keys:r,overrides:a,restricted:v,hasExcludedProperties:y}=this.h(s,n);this.b=new d(i,r,a,y?[s]:void 0),this.c=v||[]}g(s){let n={},i=null,r=[];const a=[],v=[];function y(E){Array.isArray(r)?r.push(E):i!==null&&(r[i]=E)}const u={onObjectBegin:()=>{const E={};y(E),a.push(r),r=E,i=null},onObjectProperty:E=>{i=E},onObjectEnd:()=>{r=a.pop()},onArrayBegin:()=>{const E=[];y(E),a.push(r),r=E,i=null},onArrayEnd:()=>{r=a.pop()},onLiteralValue:y,onError:(E,D,T)=>{v.push({error:E,offset:D,length:T})}};if(s)try{O.$Qm(s,u),n=r[0]||{}}catch(E){console.error(`Error while parsing settings file ${this.f}: ${E}`),this.d=[E]}return n}h(s,n){const i=g.$6m.as(p.$$m.Configuration).getConfigurationProperties(),r=this.i(s,i,!0,n);s=r.raw;const a=(0,P.$$h)(s,u=>console.error(`Conflict in settings file ${this.f}: ${u}`)),v=Object.keys(s),y=this.j(s,u=>console.error(`Conflict in settings file ${this.f}: ${u}`));return{contents:a,keys:v,overrides:y,restricted:r.restricted,hasExcludedProperties:r.hasExcludedProperties}}i(s,n,i,r){let a=!1;if(!r?.scopes&&!r?.skipRestricted&&!r?.exclude?.length)return{raw:s,restricted:[],hasExcludedProperties:a};const v={},y=[];for(const u in s)if(p.$in.test(u)&&i){const E=this.i(s[u],n,!1,r);v[u]=E.raw,a=a||E.hasExcludedProperties,y.push(...E.restricted)}else{const E=n[u],D=E?typeof E.scope<"u"?E.scope:3:void 0;E?.restricted&&y.push(u),!r.exclude?.includes(u)&&(r.include?.includes(u)||(D===void 0||r.scopes===void 0||r.scopes.includes(D))&&!(r.skipRestricted&&E?.restricted))?v[u]=s[u]:a=!0}return{raw:v,restricted:y,hasExcludedProperties:a}}j(s,n){const i=[];for(const r of Object.keys(s))if(p.$in.test(r)){const a={};for(const v in s[r])a[v]=s[r][v];i.push({identifiers:(0,p.$jn)(r),keys:Object.keys(a),contents:(0,P.$$h)(a,n)})}return i}}e.$pn=w;class f extends j.$mb{constructor(s,n,i,r){super(),this.c=s,this.f=n,this.g=r,this.b=this.B(new N.$hc),this.onDidChange=this.b.event,this.a=new w(this.c.toString()),this.B(this.g.watch(i.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(N.Event.any(N.Event.filter(this.g.onDidFilesChange,a=>a.contains(this.c)),N.Event.filter(this.g.onDidRunOperation,a=>(a.isOperation(0)||a.isOperation(3)||a.isOperation(1)||a.isOperation(4))&&i.isEqual(a.resource,s)))(()=>this.b.fire()))}async loadConfiguration(){try{const s=await this.g.readFile(this.c);return this.a.parse(s.value.toString()||"{}",this.f),this.a.configurationModel}catch{return new d}}reparse(s){return s&&(this.f=s),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$qn=f;class o{constructor(s,n,i,r,a,v,y,u,E,D,T,F,q){this.a=s,this.b=n,this.c=i,this.overrideIdentifiers=r,this.d=a,this.f=v,this.g=y,this.h=u,this.i=E,this.j=D,this.k=T,this.l=F,this.m=q}get value(){return h(this.c)}n(s,n,i){const r=s.inspect(n,i);return{get value(){return h(r.value)},get override(){return h(r.override)},get merged(){return h(r.merged)}}}get q(){return this.p||(this.p=this.n(this.d,this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.q.value!==void 0||this.q.override!==void 0?{value:this.q.value,override:this.q.override}:void 0}get s(){return this.r===void 0&&(this.r=this.f?this.n(this.f,this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.n(this.g,this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.u?.value!==void 0||this.u?.override!==void 0?{value:this.u.value,override:this.u.override}:void 0}get w(){return this.v||(this.v=this.n(this.h,this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.w.value!==void 0||this.w.override!==void 0?{value:this.w.value,override:this.w.override}:void 0}get y(){return this.x||(this.x=this.n(this.i,this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.y.value!==void 0||this.y.override!==void 0?{value:this.y.value,override:this.y.override}:void 0}get A(){return this.z||(this.z=this.n(this.j,this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.A.value!==void 0||this.A.override!==void 0?{value:this.A.value,override:this.A.override}:void 0}get D(){return this.B===void 0&&(this.B=this.k?this.n(this.k,this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.D?.value!==void 0||this.D?.override!==void 0?{value:this.D.value,override:this.D.override}:void 0}get F(){return this.E===void 0&&(this.E=this.l?this.n(this.l,this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.F?.value!==void 0||this.F?.override!==void 0?{value:this.F.value,override:this.F.override}:void 0}get H(){return this.G===void 0&&(this.G=this.n(this.m,this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.H.value!==void 0||this.H.override!==void 0?{value:this.H.value,override:this.H.override}:void 0}}class l{constructor(s,n,i,r,a=new d,v=new d,y=new A.$xi,u=new d,E=new A.$xi){this.c=s,this.d=n,this.f=i,this.g=r,this.h=a,this.i=v,this.j=y,this.l=u,this.m=E,this.a=null,this.b=new A.$xi,this.n=null}getValue(s,n,i){return this.q(s,n,i).getValue(s)}updateValue(s,n,i={}){let r;i.resource?(r=this.m.get(i.resource),r||(r=new d,this.m.set(i.resource,r))):r=this.l,n===void 0?r.removeValue(s):r.setValue(s,n),i.resource||(this.a=null)}inspect(s,n,i){const r=this.q(s,n,i),a=this.u(n.resource,i),v=n.resource?this.m.get(n.resource)||this.l:this.l,y=new Set;for(const u of r.overrides)for(const E of u.identifiers)r.getOverrideValue(s,E)!==void 0&&y.add(E);return new o(s,n,r.getValue(s),y.size?[...y]:void 0,this.c,this.d.isEmpty()?void 0:this.d,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,i?this.i:void 0,a||void 0,v)}keys(s){const n=this.u(void 0,s);return{default:this.c.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.i.keys.slice(0),workspaceFolder:n?n.keys.slice(0):[]}}updateDefaultConfiguration(s){this.c=s,this.a=null,this.b.clear()}updatePolicyConfiguration(s){this.d=s}updateApplicationConfiguration(s){this.f=s,this.a=null,this.b.clear()}updateLocalUserConfiguration(s){this.g=s,this.n=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(s){this.h=s,this.n=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(s){this.i=s,this.a=null,this.b.clear()}updateFolderConfiguration(s,n){this.j.set(s,n),this.b.delete(s)}deleteFolderConfiguration(s){this.p.delete(s),this.b.delete(s)}compareAndUpdateDefaultConfiguration(s,n){const i=[];if(!n){const{added:r,updated:a,removed:v}=I(this.c,s);n=[...r,...a,...v]}for(const r of n)for(const a of(0,p.$jn)(r)){const v=this.c.getKeysForOverrideIdentifier(a),y=s.getKeysForOverrideIdentifier(a),u=[...y.filter(E=>v.indexOf(E)===-1),...v.filter(E=>y.indexOf(E)===-1),...v.filter(E=>!R.$Xm(this.c.override(a).getValue(E),s.override(a).getValue(E)))];i.push([a,u])}return this.updateDefaultConfiguration(s),{keys:n,overrides:i}}compareAndUpdatePolicyConfiguration(s){const{added:n,updated:i,removed:r}=I(this.d,s),a=[...n,...i,...r];return a.length&&this.updatePolicyConfiguration(s),{keys:a,overrides:[]}}compareAndUpdateApplicationConfiguration(s){const{added:n,updated:i,removed:r,overrides:a}=I(this.applicationConfiguration,s),v=[...n,...i,...r];return v.length&&this.updateApplicationConfiguration(s),{keys:v,overrides:a}}compareAndUpdateLocalUserConfiguration(s){const{added:n,updated:i,removed:r,overrides:a}=I(this.localUserConfiguration,s),v=[...n,...i,...r];return v.length&&this.updateLocalUserConfiguration(s),{keys:v,overrides:a}}compareAndUpdateRemoteUserConfiguration(s){const{added:n,updated:i,removed:r,overrides:a}=I(this.remoteUserConfiguration,s),v=[...n,...i,...r];return v.length&&this.updateRemoteUserConfiguration(s),{keys:v,overrides:a}}compareAndUpdateWorkspaceConfiguration(s){const{added:n,updated:i,removed:r,overrides:a}=I(this.workspaceConfiguration,s),v=[...n,...i,...r];return v.length&&this.updateWorkspaceConfiguration(s),{keys:v,overrides:a}}compareAndUpdateFolderConfiguration(s,n){const i=this.p.get(s),{added:r,updated:a,removed:v,overrides:y}=I(i,n),u=[...r,...a,...v];return(u.length||!i)&&this.updateFolderConfiguration(s,n),{keys:u,overrides:y}}compareAndDeleteFolderConfiguration(s){const n=this.p.get(s);if(!n)throw new Error("Unknown folder");this.deleteFolderConfiguration(s);const{added:i,updated:r,removed:a,overrides:v}=I(n,void 0);return{keys:[...i,...r,...a],overrides:v}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.n||(this.n=this.h.isEmpty()?this.g:this.g.merge(this.h)),this.n}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.i}get p(){return this.j}q(s,n,i){let r=this.r(n,i);return n.overrideIdentifier&&(r=r.override(n.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(s)!==void 0&&(r=r.merge(this.d)),r}r({resource:s},n){let i=this.s();if(n&&s){const r=n.getFolder(s);r&&(i=this.t(r.uri)||i);const a=this.m.get(s);a&&(i=i.merge(a))}return i}s(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.i,this.l)),this.a}t(s){let n=this.b.get(s);if(!n){const i=this.s(),r=this.j.get(s);r?(n=i.merge(r),this.b.set(s,n)):n=i}return n}u(s,n){if(n&&s){const i=n.getFolder(s);if(i)return this.j.get(i.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.i.contents,overrides:this.i.overrides,keys:this.i.keys},folders:[...this.j.keys()].reduce((s,n)=>{const{contents:i,overrides:r,keys:a}=this.j.get(n);return s.push([n,{contents:i,overrides:r,keys:a}]),s},[])}}allKeys(){const s=new Set;return this.c.keys.forEach(n=>s.add(n)),this.userConfiguration.keys.forEach(n=>s.add(n)),this.i.keys.forEach(n=>s.add(n)),this.j.forEach(n=>n.keys.forEach(i=>s.add(i))),[...s.values()]}v(){const s=new Set;return this.c.getAllOverrideIdentifiers().forEach(n=>s.add(n)),this.userConfiguration.getAllOverrideIdentifiers().forEach(n=>s.add(n)),this.i.getAllOverrideIdentifiers().forEach(n=>s.add(n)),this.j.forEach(n=>n.getAllOverrideIdentifiers().forEach(i=>s.add(i))),[...s.values()]}w(s){const n=new Set;return this.c.getKeysForOverrideIdentifier(s).forEach(i=>n.add(i)),this.userConfiguration.getKeysForOverrideIdentifier(s).forEach(i=>n.add(i)),this.i.getKeysForOverrideIdentifier(s).forEach(i=>n.add(i)),this.j.forEach(i=>i.getKeysForOverrideIdentifier(s).forEach(r=>n.add(r))),[...n.values()]}static parse(s){const n=this.x(s.defaults),i=this.x(s.policy),r=this.x(s.application),a=this.x(s.user),v=this.x(s.workspace),y=s.folders.reduce((u,E)=>(u.set(m.URI.revive(E[0]),this.x(E[1])),u),new A.$xi);return new l(n,i,r,a,new d,v,y,new d,new A.$xi)}static x(s){return new d(s.contents,s.keys,s.overrides)}}e.$rn=l;function $(...c){if(c.length===0)return{keys:[],overrides:[]};if(c.length===1)return c[0];const s=new Set,n=new Map;for(const r of c)r.keys.forEach(a=>s.add(a)),r.overrides.forEach(([a,v])=>{const y=(0,A.$ui)(n,a,new Set);v.forEach(u=>y.add(u))});const i=[];return n.forEach((r,a)=>i.push([a,[...r.values()]])),{keys:[...s.values()],overrides:i}}e.$sn=$;class b{constructor(s,n,i,r){this.change=s,this.f=n,this.g=i,this.h=r,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=".".charCodeAt(0),this.affectedKeys=new Set,this.i=void 0;for(const a of s.keys)this.affectedKeys.add(a);for(const[,a]of s.overrides)for(const v of a)this.affectedKeys.add(v);this.d=this.a;for(const a of this.affectedKeys)this.d+=a+this.a}get previousConfiguration(){return!this.i&&this.f&&(this.i=l.parse(this.f.data)),this.i}affectsConfiguration(s,n){const i=this.a+s,r=this.d.indexOf(i);if(r<0)return!1;const a=r+i.length;if(a>=this.d.length)return!1;const v=this.d.charCodeAt(a);if(v!==this.b&&v!==this.c)return!1;if(n){const y=this.previousConfiguration?this.previousConfiguration.getValue(s,n,this.f?.workspace):void 0,u=this.g.getValue(s,n,this.h);return!R.$Xm(y,u)}return!0}}e.$tn=b;function I(c,s){const{added:n,removed:i,updated:r}=t(s?.rawConfiguration,c?.rawConfiguration),a=[],v=c?.getAllOverrideIdentifiers()||[],y=s?.getAllOverrideIdentifiers()||[];if(s){const u=y.filter(E=>!v.includes(E));for(const E of u)a.push([E,s.getKeysForOverrideIdentifier(E)])}if(c){const u=v.filter(E=>!y.includes(E));for(const E of u)a.push([E,c.getKeysForOverrideIdentifier(E)])}if(s&&c){for(const u of v)if(y.includes(u)){const E=t({contents:c.getOverrideValue(void 0,u)||{},keys:c.getKeysForOverrideIdentifier(u)},{contents:s.getOverrideValue(void 0,u)||{},keys:s.getKeysForOverrideIdentifier(u)});a.push([u,[...E.added,...E.removed,...E.updated]])}}return{added:n,removed:i,updated:r,overrides:a}}function t(c,s){const n=c?s?c.keys.filter(a=>s.keys.indexOf(a)===-1):[...c.keys]:[],i=s?c?s.keys.filter(a=>c.keys.indexOf(a)===-1):[...s.keys]:[],r=[];if(c&&s){for(const a of s.keys)if(c.keys.indexOf(a)!==-1){const v=(0,P.$bi)(s.contents,a),y=(0,P.$bi)(c.contents,a);R.$Xm(v,y)||r.push(a)}}return{added:n,removed:i,updated:r}}}),define(re[207],oe([0,1,20,3,2,30,9,73,49,7,56,40]),function(te,e,L,N,O,j,A,R,k,m,P,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wn=e.$vn=e.$un=void 0;class g extends O.$mb{constructor(){super(...arguments),this.a=this.B(new N.$hc),this.onDidChangeConfiguration=this.a.event,this.b=new R.$on}get configurationModel(){return this.b}async initialize(){return this.g(),this.B(p.$6m.as(k.$$m.Configuration).onDidUpdateConfiguration(({properties:f,defaultsOverrides:o})=>this.c(Array.from(f),o))),this.configurationModel}reload(){return this.g(),this.configurationModel}c(f,o){this.h(f,p.$6m.as(k.$$m.Configuration).getConfigurationProperties()),this.a.fire({defaults:this.configurationModel,properties:f})}f(){return{}}g(){this.b=new R.$on;const f=p.$6m.as(k.$$m.Configuration).getConfigurationProperties();this.h(Object.keys(f),f)}h(f,o){const l=this.f();for(const $ of f){const b=l[$],I=o[$];b!==void 0?this.b.addValue($,b):I?this.b.addValue($,I.default):this.b.removeValue($)}}}e.$un=g;class h{constructor(){this.onDidChangeConfiguration=N.Event.None,this.configurationModel=new R.$on}async initialize(){return this.configurationModel}}e.$vn=h;let d=class extends O.$mb{get configurationModel(){return this.b}constructor(f,o,l){super(),this.c=f,this.f=o,this.g=l,this.a=this.B(new N.$hc),this.onDidChangeConfiguration=this.a.event,this.b=new R.$on}async initialize(){return this.g.trace("PolicyConfiguration#initialize"),this.j(await this.h(this.c.configurationModel.keys),!1),this.B(this.f.onDidChange(f=>this.i(f))),this.B(this.c.onDidChangeConfiguration(async({properties:f})=>this.j(await this.h(f),!0))),this.b}async h(f){this.g.trace("PolicyConfiguration#updatePolicyDefinitions",f);const o={},l=[],$=p.$6m.as(k.$$m.Configuration).getConfigurationProperties();for(const b of f){const I=$[b];if(!I){l.push(b);continue}if(I.policy){if(I.type!=="string"&&I.type!=="number"){this.g.warn(`Policy ${I.policy.name} has unsupported type ${I.type}`);continue}l.push(b),o[I.policy.name]={type:I.type}}}return(0,A.$ye)(o)||await this.f.updatePolicyDefinitions(o),l}i(f){this.g.trace("PolicyConfiguration#onDidChangePolicies",f);const o=p.$6m.as(k.$$m.Configuration).getPolicyConfigurations(),l=(0,L.$Af)(f.map($=>o.get($)));this.j(l,!0)}j(f,o){this.g.trace("PolicyConfiguration#update",f);const l=p.$6m.as(k.$$m.Configuration).getConfigurationProperties(),$=[],b=this.b.isEmpty();for(const I of f){const t=l[I]?.policy?.name;if(t){const c=this.f.getPolicyValue(t);(b?c!==void 0:!(0,j.$Xm)(this.b.getValue(I),c))&&$.push([I,c])}else this.b.getValue(I)!==void 0&&$.push([I,void 0])}if($.length){this.g.trace("PolicyConfiguration#changed",$);const I=this.b;this.b=new R.$on;for(const t of I.keys)this.b.setValue(t,I.getValue(t));for(const[t,c]of $)c===void 0?this.b.removeValue(t):this.b.setValue(t,c);o&&this.a.fire(this.b)}}};e.$wn=d,e.$wn=d=ye([X(1,P.$8m),X(2,m.$3i)],d)}),define(re[208],oe([0,1,5,3,2,23,18,73,207,56]),function(te,e,L,N,O,j,A,R,k,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xn=void 0;class P extends O.$mb{constructor(g,h,d,w){super(),this.i=g,this.h=this.B(new N.$hc),this.onDidChangeConfiguration=this.h.event,this.b=this.B(new k.$un),this.c=d instanceof m.$0m?new k.$vn:this.B(new k.$wn(this.b,d,w)),this.f=this.B(new R.$qn(this.i,{},j.$0f,h)),this.a=new R.$rn(this.b.configurationModel,this.c.configurationModel,new R.$on,new R.$on),this.g=this.B(new L.$Qg(()=>this.reloadConfiguration(),50)),this.B(this.b.onDidChangeConfiguration(({defaults:f,properties:o})=>this.k(f,o))),this.B(this.c.onDidChangeConfiguration(f=>this.l(f))),this.B(this.f.onDidChange(()=>this.g.schedule()))}async initialize(){const[g,h,d]=await Promise.all([this.b.initialize(),this.c.initialize(),this.f.loadConfiguration()]);this.a=new R.$rn(g,h,new R.$on,d)}getConfigurationData(){return this.a.toData()}getValue(g,h){const d=typeof g=="string"?g:void 0,w=(0,A.$7h)(g)?g:(0,A.$7h)(h)?h:{};return this.a.getValue(d,w,void 0)}updateValue(g,h,d,w){return Promise.reject(new Error("not supported"))}inspect(g){return this.a.inspect(g,{},void 0)}keys(){return this.a.keys(void 0)}async reloadConfiguration(){const g=await this.f.loadConfiguration();this.j(g)}j(g){const h=this.a.toData(),d=this.a.compareAndUpdateLocalUserConfiguration(g);this.m(d,h,2)}k(g,h){const d=this.a.toData(),w=this.a.compareAndUpdateDefaultConfiguration(g,h);this.m(w,d,7)}l(g){const h=this.a.toData(),d=this.a.compareAndUpdatePolicyConfiguration(g);this.m(d,h,7)}m(g,h,d){const w=new R.$tn(g,{data:h},this.a);w.source=d,w.sourceConfig=this.n(d),this.h.fire(w)}n(g){switch(g){case 7:return this.a.defaults.contents;case 2:return this.a.localUserConfiguration.contents}return{}}}e.$xn=P}),define(re[209],oe([0,1,14,3,2,65]),function(te,e,L,N,O,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dkb=e.$ckb=e.$bkb=e.$akb=void 0;const A=(m,P,p)=>{const g=new Uint8Array(16);for(let w=0;w<16;w++)g[w]=Math.round(Math.random()*256);const h=(0,L.$2c)(L.$Hc.wrap(g));return[`GET ws://localhost${m}?${P}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${h}`].join(`\r
`)+`\r
\r
`};e.$akb=A,e.$bkb=L.$Hc.fromString(`\r
\r
`);async function R(m,P,p,g,h){m.write(L.$Hc.fromString((0,e.$akb)(P,p,g)));const d=new O.$lb;try{return await new Promise((w,f)=>{let o;d.add(m.onData(l=>{o?o=L.$Hc.concat([o,l],o.byteLength+l.byteLength):o=l;const $=o.indexOf(e.$bkb);if($===-1)return;w(m),m.pauseData();const b=o.slice($+e.$bkb.byteLength);b.byteLength&&h.onData.fire(b)})),d.add(m.onClose(l=>f(l??new Error("socket closed")))),d.add(m.onEnd(()=>f(new Error("socket ended"))))})}catch(w){throw m.dispose(),w}finally{d.dispose()}}e.$ckb=R;class k extends O.$mb{constructor(P,p){super(),this.g=P,this.a=this.B(new N.$kc),this.onData=(...g)=>(this.a.isPaused&&queueMicrotask(()=>this.a.resume()),this.a.event(...g)),this.b=this.B(new N.$hc),this.onDidDispose=this.b.event,this.f=!1,this.B(p.onData),this.B(p.onData.event(g=>this.a.fire(g))),this.onClose=this.B(p.onClose).event,this.onEnd=this.B(p.onEnd).event}pauseData(){this.a.pause()}drain(){return Promise.resolve()}end(){this.f=!0,this.h()}traceSocketEvent(P,p){j.SocketDiagnostics.traceSocketEvent(this,this.g,P,p)}dispose(){this.f||this.h(),this.b.fire(),super.dispose()}}e.$dkb=k}),define(re[210],oe([0,1,8,4]),function(te,e,L,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lk=e.$Kk=e.RemoteAuthorityResolverErrorCode=e.$Jk=e.$Ik=e.RemoteConnectionType=e.$Hk=void 0,e.$Hk=(0,N.$zh)("remoteAuthorityResolverService");var O;(function(P){P[P.WebSocket=0]="WebSocket",P[P.Managed=1]="Managed"})(O||(e.RemoteConnectionType=O={}));class j{constructor(p){this.id=p,this.type=1}toString(){return`Managed(${this.id})`}}e.$Ik=j;class A{constructor(p,g){this.host=p,this.port=g,this.type=0}toString(){return`WebSocket(${this.host}:${this.port})`}}e.$Jk=A;var R;(function(P){P.Unknown="Unknown",P.NotAvailable="NotAvailable",P.TemporarilyNotAvailable="TemporarilyNotAvailable",P.NoResolverFound="NoResolverFound",P.InvalidAuthority="InvalidAuthority"})(R||(e.RemoteAuthorityResolverErrorCode=R={}));class k extends L.$_{static isNotAvailable(p){return p instanceof k&&p._code===R.NotAvailable}static isTemporarilyNotAvailable(p){return p instanceof k&&p._code===R.TemporarilyNotAvailable}static isNoResolverFound(p){return p instanceof k&&p._code===R.NoResolverFound}static isInvalidAuthority(p){return p instanceof k&&p._code===R.InvalidAuthority}static isHandled(p){return p instanceof k&&p.isHandled}constructor(p,g=R.Unknown,h){super(p),this._message=p,this._code=g,this._detail=h,this.isHandled=g===R.NotAvailable&&h===!0,Object.setPrototypeOf(this,k.prototype)}}e.$Kk=k;function m(P){const p=P.indexOf("+");return p===-1?P:P.substring(0,p)}e.$Lk=m}),define(re[74],oe([0,1,22]),function(te,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qk=e.$Pk=e.$Ok=e.$Nk=e.$Mk=void 0;function N(m){return m.scheme===L.Schemas.vscodeRemote?m.authority:void 0}e.$Mk=N;function O(m){if(!m)return;const P=m.indexOf("+");return P<0?m:m.substr(0,P)}e.$Nk=O;function j(m){return`/${m.quality??"oss"}-${m.commit??"dev"}`}e.$Ok=j;function A(m){const{host:P,port:p}=k(m);if(typeof p>"u")throw new Error("Remote authority doesn't contain a port!");return{host:P,port:p}}e.$Pk=A;function R(m,P){let{host:p,port:g}=k(m);return typeof g>"u"&&(g=P),{host:p,port:g}}e.$Qk=R;function k(m){const P=m.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(P)return{host:P[1],port:parseInt(P[2],10)};const p=m.match(/^(\[[0-9a-z:]+\])$/);if(p)return{host:p[1],port:void 0};const g=m.match(/(.*):(\d+)$/);return g?{host:g[1],port:parseInt(g[2],10)}:{host:m,port:void 0}}}),define(re[45],oe([0,1,28,4,74]),function(te,e,L,N,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1l=e.$Zl=e.$Yl=e.$Xl=e.$Wl=e.$Vl=e.$Ul=e.$Tl=e.TargetPlatform=e.ExtensionType=e.$Sl=e.$Rl=e.$Ql=e.$Pl=e.$Ol=e.$Nl=void 0,e.$Nl="extensions.user.cache",e.$Ol="extensions.builtin.cache",e.$Pl="undefined_publisher",e.$Ql=["ui","workspace","web"];function j(w){if(typeof w=="object"&&w!==null&&w.supported!==!0)return w.description}e.$Rl=j,e.$Sl=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var A;(function(w){w[w.System=0]="System",w[w.User=1]="User"})(A||(e.ExtensionType=A={}));var R;(function(w){w.WIN32_X64="win32-x64",w.WIN32_IA32="win32-ia32",w.WIN32_ARM64="win32-arm64",w.LINUX_X64="linux-x64",w.LINUX_ARM64="linux-arm64",w.LINUX_ARMHF="linux-armhf",w.ALPINE_X64="alpine-x64",w.ALPINE_ARM64="alpine-arm64",w.DARWIN_X64="darwin-x64",w.DARWIN_ARM64="darwin-arm64",w.WEB="web",w.UNIVERSAL="universal",w.UNKNOWN="unknown",w.UNDEFINED="undefined"})(R||(e.TargetPlatform=R={}));class k{constructor(f){this.value=f,this._lower=f.toLowerCase()}static equals(f,o){if(typeof f>"u"||f===null)return typeof o>"u"||o===null;if(typeof o>"u"||o===null)return!1;if(typeof f=="string"||typeof o=="string"){const l=typeof f=="string"?f:f.value,$=typeof o=="string"?o:o.value;return L.$Od(l,$)}return f._lower===o._lower}static toKey(f){return typeof f=="string"?f.toLowerCase():f._lower}}e.$Tl=k;class m{get size(){return this.c.size}constructor(f){if(this.c=new Set,f)for(const o of f)this.add(o)}add(f){this.c.add(k.toKey(f))}delete(f){return this.c.delete(k.toKey(f))}has(f){return this.c.has(k.toKey(f))}}e.$Ul=m;class P{constructor(){this.c=new Map}clear(){this.c.clear()}delete(f){this.c.delete(k.toKey(f))}get(f){return this.c.get(k.toKey(f))}has(f){return this.c.has(k.toKey(f))}set(f,o){this.c.set(k.toKey(f),o)}values(){return this.c.values()}forEach(f){this.c.forEach(f)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$Vl=P;function p(w){return g(w)}e.$Wl=p;function g(w){return w.contributes&&w.contributes.localizations?w.contributes.localizations.length>0:!1}e.$Xl=g;function h(w){return w.contributes&&w.contributes.authentication?w.contributes.authentication.length>0:!1}e.$Yl=h;function d(w,f){if(f){const o=`onResolveRemoteAuthority:${(0,O.$Nk)(f)}`;return!!w.activationEvents?.includes(o)}return!1}e.$Zl=d,e.$1l=(0,N.$zh)("IBuiltinExtensionsScannerService")}),define(re[211],oe([0,1,2,45,13]),function(te,e,L,N,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tp=void 0;class j extends L.$mb{constructor(R,k,m,P,p){super(),this.a=R,this.b=k,this.c=m,this.f=p,this.B(P.onDidInstallExtensions(g=>this.g(g))),this.B(P.onDidUninstallExtension(g=>this.h(g)))}g(R){for(const k of R)k.local&&this.invalidate(k.profileLocation)}h(R){R.error||this.invalidate(R.profileLocation)}async invalidate(R){if(R)for(const k of this.a.profiles)this.c.extUri.isEqual(k.extensionsResource,R)&&await this.i(k);else await this.i(this.a.defaultProfile)}async i(R){try{await this.b.del(this.c.extUri.joinPath(R.cacheHome,N.$Nl))}catch(k){(0,O.$hk)(k)!==1&&this.f.error(k)}}}e.$tp=j}),define(re[212],oe([0,1,5,14,26,8,3,2,100,60,32,65,210,74]),function(te,e,L,N,O,j,A,R,k,m,P,p,g,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6k=e.$5k=e.$4k=e.$3k=e.$2k=e.$1k=e.$Zk=e.$Yk=e.PersistentConnectionEventType=e.$Xk=e.$Wk=e.$Vk=e.ConnectionType=void 0;const d=30*1e3;var w;(function(U){U[U.Management=1]="Management",U[U.ExtensionHost=2]="ExtensionHost",U[U.Tunnel=3]="Tunnel"})(w||(e.ConnectionType=w={}));function f(U){switch(U){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function o(U){const S=new O.$rc;return setTimeout(()=>S.cancel(),U),S.token}function l(U,S){if(U.isCancellationRequested||S.isCancellationRequested)return O.CancellationToken.Cancelled;const C=new O.$rc;return U.onCancellationRequested(()=>C.cancel()),S.onCancellationRequested(()=>C.cancel()),C.token}class ${get didTimeout(){return this.c==="timedout"}constructor(S){this.c="pending",this.d=new R.$lb,this.promise=new Promise((C,z)=>{this.f=C,this.g=z}),S.isCancellationRequested?this.h():this.d.add(S.onCancellationRequested(()=>this.h()))}registerDisposable(S){this.c==="pending"?this.d.add(S):S.dispose()}h(){this.c==="pending"&&(this.d.dispose(),this.c="timedout",this.g(this.i()))}i(){const S=new Error("Time limit reached");return S.code="ETIMEDOUT",S.syscall="connect",S}resolve(S){this.c==="pending"&&(this.d.dispose(),this.c="resolved",this.f(S))}reject(S){this.c==="pending"&&(this.d.dispose(),this.c="rejected",this.g(S))}}function b(U,S){const C=new $(S);return C.registerDisposable(U.onControlMessage(z=>{const M=JSON.parse(z.toString()),J=V(M);J?C.reject(J):C.resolve(M)})),C.promise}function I(U,S,C,z,M,J,_,ae){const he=new $(ae),fe=m.$dc.create(!1);return U.info(`Creating a socket (${_})...`),k.mark(`code/willCreateSocket/${J}`),S.connect(C,z,M,_).then(le=>{he.didTimeout?(k.mark(`code/didCreateSocketError/${J}`),U.info(`Creating a socket (${_}) finished after ${fe.elapsed()} ms, but this is too late and has timed out already.`),le?.dispose()):(k.mark(`code/didCreateSocketOK/${J}`),U.info(`Creating a socket (${_}) was successful after ${fe.elapsed()} ms.`),he.resolve(le))},le=>{k.mark(`code/didCreateSocketError/${J}`),U.info(`Creating a socket (${_}) returned an error after ${fe.elapsed()} ms.`),U.error(le),he.reject(le)}),he.promise}function t(U,S){const C=new $(S);return U.then(z=>{C.didTimeout||C.resolve(z)},z=>{C.didTimeout||C.reject(z)}),C.promise}async function c(U,S,C,z){const M=se(U,S);U.logService.trace(`${M} 1/6. invoking socketFactory.connect().`);let J;try{J=await I(U.logService,U.remoteSocketFactoryService,U.connectTo,(0,h.$Ok)(U),`reconnectionToken=${U.reconnectionToken}&reconnection=${U.reconnectionProtocol?"true":"false"}`,f(S),`renderer-${f(S)}-${U.reconnectionToken}`,z)}catch(le){throw U.logService.error(`${M} socketFactory.connect() failed or timed out. Error:`),U.logService.error(le),le}U.logService.trace(`${M} 2/6. socketFactory.connect() was successful.`);let _,ae;U.reconnectionProtocol?(U.reconnectionProtocol.beginAcceptReconnection(J,null),_=U.reconnectionProtocol,ae=!1):(_=new p.$nh({socket:J}),ae=!0),U.logService.trace(`${M} 3/6. sending AuthRequest control message.`);const he=await t(U.signService.createNewMessage((0,P.$6e)()),z),fe={type:"auth",auth:U.connectionToken||"00000000000000000000",data:he.data};_.sendControl(N.$Hc.fromString(JSON.stringify(fe)));try{const le=await b(_,l(z,o(1e4)));if(le.type!=="sign"||typeof le.data!="string"){const ke=new Error("Unexpected handshake message");throw ke.code="VSCODE_CONNECTION_ERROR",ke}if(U.logService.trace(`${M} 4/6. received SignRequest control message.`),!await t(U.signService.validate(he,le.signedData),z)){const ke=new Error("Refused to connect to unsupported server");throw ke.code="VSCODE_CONNECTION_ERROR",ke}const de=await t(U.signService.sign(le.data),z),we={type:"connectionType",commit:U.commit,signedData:de,desiredConnectionType:S};return C&&(we.args=C),U.logService.trace(`${M} 5/6. sending ConnectionTypeRequest control message.`),_.sendControl(N.$Hc.fromString(JSON.stringify(we))),{protocol:_,ownsProtocol:ae}}catch(le){throw le&&le.code==="ETIMEDOUT"&&(U.logService.error(`${M} the handshake timed out. Error:`),U.logService.error(le)),le&&le.code==="VSCODE_CONNECTION_ERROR"&&(U.logService.error(`${M} received error control message when negotiating connection. Error:`),U.logService.error(le)),ae&&H(_),le}}async function s(U,S,C,z){const M=Date.now(),J=se(U,S),{protocol:_,ownsProtocol:ae}=await c(U,S,C,z),he=new $(z);return he.registerDisposable(_.onControlMessage(fe=>{const le=JSON.parse(fe.toString()),$e=V(le);$e?(U.logService.error(`${J} received error control message when negotiating connection. Error:`),U.logService.error($e),ae&&H(_),he.reject($e)):(U.reconnectionProtocol?.endAcceptReconnection(),U.logService.trace(`${J} 6/6. handshake finished, connection is up and running after ${K(M)}!`),he.resolve({protocol:_,firstMessage:le}))})),he.promise}async function n(U,S){const{protocol:C}=await s(U,1,void 0,S);return{protocol:C}}async function i(U,S,C){const{protocol:z,firstMessage:M}=await s(U,2,S,C),J=M&&M.debugPort;return{protocol:z,debugPort:J}}async function r(U,S,C){const z=Date.now(),M=se(U,3),{protocol:J}=await c(U,3,S,C);return U.logService.trace(`${M} 6/6. handshake finished, connection is up and running after ${K(z)}!`),J}async function a(U,S,C){const{connectTo:z,connectionToken:M}=await U.addressProvider.getAddress();return{commit:U.commit,quality:U.quality,connectTo:z,connectionToken:M,reconnectionToken:S,reconnectionProtocol:C,remoteSocketFactoryService:U.remoteSocketFactoryService,signService:U.signService,logService:U.logService}}async function v(U,S,C){return u(U,async z=>{const{protocol:M}=await n(z,O.CancellationToken.None);return new G(U,S,C,z.reconnectionToken,M)})}e.$Vk=v;async function y(U,S){return u(U,async C=>{const{protocol:z,debugPort:M}=await i(C,S,O.CancellationToken.None);return new Q(U,S,C.reconnectionToken,z,M)})}e.$Wk=y;async function u(U,S){for(let z=1;;z++)try{const M=(0,P.$6e)(),J=await a(U,M,null);return await S(J)}catch(M){if(z<5)U.logService.error(`[remote-connection][attempt ${z}] An error occurred in initial connection! Will retry... Error:`),U.logService.error(M);else throw U.logService.error(`[remote-connection][attempt ${z}]  An error occurred in initial connection! It will be treated as a permanent error. Error:`),U.logService.error(M),x.triggerPermanentFailure(0,0,g.$Kk.isHandled(M)),M}}async function E(U,S,C){const z=await a(U,(0,P.$6e)(),null);return await r(z,{host:S,port:C},O.CancellationToken.None)}e.$Xk=E;function D(U){return(0,L.$sg)(S=>new Promise((C,z)=>{const M=setTimeout(C,U*1e3);S.onCancellationRequested(()=>{clearTimeout(M),C()})}))}var T;(function(U){U[U.ConnectionLost=0]="ConnectionLost",U[U.ReconnectionWait=1]="ReconnectionWait",U[U.ReconnectionRunning=2]="ReconnectionRunning",U[U.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",U[U.ConnectionGain=4]="ConnectionGain"})(T||(e.PersistentConnectionEventType=T={}));class F{constructor(S,C){this.reconnectionToken=S,this.millisSinceLastIncomingData=C,this.type=0}}e.$Yk=F;class q{constructor(S,C,z,M){this.reconnectionToken=S,this.millisSinceLastIncomingData=C,this.durationSeconds=z,this.c=M,this.type=1}skipWait(){this.c.cancel()}}e.$Zk=q;class W{constructor(S,C,z){this.reconnectionToken=S,this.millisSinceLastIncomingData=C,this.attempt=z,this.type=2}}e.$1k=W;class Z{constructor(S,C,z){this.reconnectionToken=S,this.millisSinceLastIncomingData=C,this.attempt=z,this.type=4}}e.$2k=Z;class Y{constructor(S,C,z,M){this.reconnectionToken=S,this.millisSinceLastIncomingData=C,this.attempt=z,this.handled=M,this.type=3}}e.$3k=Y;class x extends R.$mb{static triggerPermanentFailure(S,C,z){this._permanentFailure=!0,this.f=S,this.g=C,this.h=z,this.i.forEach(M=>M.v(this.f,this.g,this.h))}static debugTriggerReconnection(){this.i.forEach(S=>S.s())}static debugPauseSocketWriting(){this.i.forEach(S=>S.w())}static{this._permanentFailure=!1}static{this.f=0}static{this.g=0}static{this.h=!1}static{this.i=[]}get k(){return this.c||x._permanentFailure}constructor(S,C,z,M,J){super(),this.n=S,this.p=C,this.reconnectionToken=z,this.protocol=M,this.r=J,this.j=this.B(new A.$hc),this.onDidStateChange=this.j.event,this.c=!1,this.l=!1,this.m=!1,this.j.fire(new Z(this.reconnectionToken,0,0)),this.B(M.onSocketClose(_=>{const ae=ne(this.n,this.reconnectionToken,!0);_?_.type===0?(this.p.logService.info(`${ae} received socket close event (hadError: ${_.hadError}).`),_.error&&this.p.logService.error(_.error)):(this.p.logService.info(`${ae} received socket close event (wasClean: ${_.wasClean}, code: ${_.code}, reason: ${_.reason}).`),_.event&&this.p.logService.error(_.event)):this.p.logService.info(`${ae} received socket close event.`),this.s()})),this.B(M.onSocketTimeout(_=>{const ae=ne(this.n,this.reconnectionToken,!0);this.p.logService.info(`${ae} received socket timeout event (unacknowledgedMsgCount: ${_.unacknowledgedMsgCount}, timeSinceOldestUnacknowledgedMsg: ${_.timeSinceOldestUnacknowledgedMsg}, timeSinceLastReceivedSomeData: ${_.timeSinceLastReceivedSomeData}).`),this.s()})),x.i.push(this),this.B((0,R.$kb)(()=>{const _=x.i.indexOf(this);_>=0&&x.i.splice(_,1)})),this.k&&this.v(x.f,x.g,x.h)}dispose(){super.dispose(),this.m=!0}async s(){if(!this.l)try{this.l=!0,await this.t()}finally{this.l=!1}}async t(){if(this.k||this.m)return;const S=ne(this.n,this.reconnectionToken,!0);this.p.logService.info(`${S} starting reconnecting loop. You can get more information with the trace log level.`),this.j.fire(new F(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const C=[0,5,5,10,10,10,10,10,30];let z=-1;do{z++;const M=z<C.length?C[z]:C[C.length-1];try{if(M>0){const _=D(M);this.j.fire(new q(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),M,_)),this.p.logService.info(`${S} waiting for ${M} seconds before reconnecting...`);try{await _}catch{}}if(this.k){this.p.logService.error(`${S} permanent failure occurred while running the reconnecting loop.`);break}this.j.fire(new W(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),z+1)),this.p.logService.info(`${S} resolving connection...`);const J=await a(this.p,this.reconnectionToken,this.protocol);this.p.logService.info(`${S} connecting to ${J.connectTo}...`),await this.y(J,o(d)),this.p.logService.info(`${S} reconnected!`),this.j.fire(new Z(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),z+1));break}catch(J){if(J.code==="VSCODE_CONNECTION_ERROR"){this.p.logService.error(`${S} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this.p.logService.error(J),this.u(this.protocol.getMillisSinceLastIncomingData(),z+1,!1);break}if(z>360){this.p.logService.error(`${S} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this.p.logService.error(J),this.u(this.protocol.getMillisSinceLastIncomingData(),z+1,!1);break}if(g.$Kk.isTemporarilyNotAvailable(J)){this.p.logService.info(`${S} A temporarily not available error occurred while trying to reconnect, will try again...`),this.p.logService.trace(J);continue}if((J.code==="ETIMEDOUT"||J.code==="ENETUNREACH"||J.code==="ECONNREFUSED"||J.code==="ECONNRESET")&&J.syscall==="connect"){this.p.logService.info(`${S} A network error occurred while trying to reconnect, will try again...`),this.p.logService.trace(J);continue}if((0,j.$2)(J)){this.p.logService.info(`${S} A promise cancelation error occurred while trying to reconnect, will try again...`),this.p.logService.trace(J);continue}if(J instanceof g.$Kk){this.p.logService.error(`${S} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this.p.logService.error(J),this.u(this.protocol.getMillisSinceLastIncomingData(),z+1,g.$Kk.isHandled(J));break}this.p.logService.error(`${S} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this.p.logService.error(J),this.u(this.protocol.getMillisSinceLastIncomingData(),z+1,!1);break}}while(!this.k&&!this.m)}u(S,C,z){this.r?x.triggerPermanentFailure(S,C,z):this.v(S,C,z)}v(S,C,z){this.j.fire(new Y(this.reconnectionToken,S,C,z)),H(this.protocol)}w(){this.protocol.pauseSocketWriting()}}e.$4k=x;class G extends x{constructor(S,C,z,M,J){super(1,S,M,J,!0),this.client=this.B(new p.$lh(J,{remoteAuthority:C,clientId:z},S.ipcLogger))}async y(S,C){await n(S,C)}}e.$5k=G;class Q extends x{constructor(S,C,z,M,J){super(2,S,z,M,!1),this.z=C,this.debugPort=J}async y(S,C){await i(S,this.z,C)}}e.$6k=Q;function H(U){try{U.acceptDisconnect();const S=U.getSocket();U.dispose(),S.dispose()}catch(S){(0,j.$Y)(S)}}function V(U){if(U&&U.type==="error"){const S=new Error(`Connection error: ${U.reason}`);return S.code="VSCODE_CONNECTION_ERROR",S}return null}function B(U,S){for(;U.length<S;)U+=" ";return U}function ee(U,S){return`[remote-connection][${B(f(U),13)}][${S.substr(0,5)}\u2026]`}function ne(U,S,C){return`${ee(U,S)}[${C?"reconnect":"initial"}]`}function se(U,S){return`${ne(S,U.reconnectionToken,!!U.reconnectionProtocol)}[${U.connectTo}]`}function K(U){return`${Date.now()-U} ms`}}),define(re[104],oe([0,1,2,4]),function(te,e,L,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sk=e.$Rk=void 0,e.$Rk=(0,N.$zh)("remoteSocketFactoryService");class O{constructor(){this.a={}}register(A,R){return this.a[A]??=[],this.a[A].push(R),(0,L.$kb)(()=>{const k=this.a[A]?.indexOf(R);typeof k=="number"&&k>=0&&this.a[A]?.splice(k,1)})}b(A){return(this.a[A.type]||[]).find(k=>k.supports(A))}connect(A,R,k,m){const P=this.b(A);if(!P)throw new Error(`No socket factory found for ${A}`);return P.connect(A,R,k,m)}}e.$Sk=O}),define(re[213],oe([0,1,4]),function(te,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$s7b=e.$r7b=void 0,e.$r7b=(0,L.$zh)("sharedProcessTunnelService"),e.$s7b="sharedProcessTunnel"}),define(re[105],oe([0,1,4,163]),function(te,e,L,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$C7b=e.$B7b=e.$A7b=e.$z7b=e.$y7b=e.TunnelStates=e.$x7b=e.$w7b=void 0,e.$w7b=(0,L.$zh)("IRemoteTunnelService"),e.$x7b={active:!1};var O;(function(j){j.disconnected=A=>({type:"disconnected",onTokenFailed:A}),j.connected=(A,R)=>({type:"connected",info:A,serviceInstallFailed:R}),j.connecting=A=>({type:"connecting",progress:A}),j.uninitialized={type:"uninitialized"}})(O||(e.TunnelStates=O={})),e.$y7b="remote.tunnels.access",e.$z7b=e.$y7b+".hostNameOverride",e.$A7b=e.$y7b+".preventSleep",e.$B7b="remoteTunnelService",e.$C7b=(0,N.localize)(0,null)}),define(re[57],oe([0,1,14,8,2,165,49,4,7,40]),function(te,e,L,N,O,j,A,R,k,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mo=e.$Lo=e.$Ko=e.$Jo=e.$Io=e.$Ho=e.$Go=void 0,e.$Go=(0,R.$zh)("requestService");class P{constructor(I){this.b=I}toJSON(){if(!this.a){const I=Object.create(null);for(const t in this.b)t.toLowerCase()==="authorization"||t.toLowerCase()==="proxy-authorization"?I[t]="*****":I[t]=this.b[t];this.a=I}return this.a}}class p extends O.$mb{constructor(I){super(),this.b=0,this.a=I.createLogger("network",{name:(0,j.localize)(0,null),when:k.$hj.isEqualTo((0,k.$fj)(k.LogLevel.Trace)).serialize()})}async c(I,t,c){const s=`${I} #${++this.b}: ${t.url}`;this.a.trace(`${s} - begin`,t.type,new P(t.headers??{}));try{const n=await c();return this.a.trace(`${s} - end`,t.type,n.res.statusCode,n.res.headers),n}catch(n){throw this.a.error(`${s} - error`,t.type,(0,N.$8)(n)),n}}}e.$Ho=p;function g(b){return b.res.statusCode&&b.res.statusCode>=200&&b.res.statusCode<300||b.res.statusCode===1223}e.$Io=g;function h(b){return b.res.statusCode===204}async function d(b){return h(b)?null:(await(0,L.$Tc)(b.stream)).toString()}e.$Jo=d;async function w(b){if(!g(b))throw new Error("Server returned "+b.res.statusCode);return d(b)}e.$Ko=w;async function f(b){if(!g(b))throw new Error("Server returned "+b.res.statusCode);if(h(b))return null;const t=(await(0,L.$Tc)(b.stream)).toString();try{return JSON.parse(t)}catch(c){throw c.message+=`:
`+t,c}}e.$Lo=f;function o(b){$(b)}e.$Mo=o;let l;function $(b){const I=m.$6m.as(A.$$m.Configuration),t=l;l={id:"http",order:15,title:(0,j.localize)(1,null),type:"object",scope:b,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks|socks4a?|socks5h?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,j.localize)(2,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,j.localize)(3,null),restricted:!0},"http.proxyKerberosServicePrincipal":{type:"string",markdownDescription:(0,j.localize)(4,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,j.localize)(5,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,j.localize)(6,null),(0,j.localize)(7,null),(0,j.localize)(8,null),(0,j.localize)(9,null)],default:"override",description:(0,j.localize)(10,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,j.localize)(11,null),restricted:!0}}},I.updateConfigurations({add:[l],remove:t?[t]:[]})}$(1)}),define(re[214],oe([0,1,26,22,13,57]),function(te,e,L,N,O,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uN=void 0;let A=class{constructor(k,m){this.a=k,this.b=m}async download(k,m,P=L.CancellationToken.None){if(k.scheme===N.Schemas.file||k.scheme===N.Schemas.vscodeRemote){await this.b.copy(k,m);return}const p={type:"GET",url:k.toString(!0)},g=await this.a.request(p,P);if(g.res.statusCode===200)await this.b.writeFile(m,g.stream);else{const h=await(0,j.$Ko)(g);throw new Error(`Expected 200, got back ${g.res.statusCode} instead.

${h}`)}}};e.$uN=A,e.$uN=A=ye([X(0,j.$Go),X(1,O.$4j)],A)}),define(re[215],oe([0,1,14,26]),function(te,e,L,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jq=e.$Iq=void 0;class O{constructor(R){this.a=R}listen(R,k){throw new Error("Invalid listen")}call(R,k,m,P=N.CancellationToken.None){switch(k){case"request":return this.a.request(m[0],P).then(async({res:p,stream:g})=>{const h=await(0,L.$Tc)(g);return[{statusCode:p.statusCode,headers:p.headers},h]});case"resolveProxy":return this.a.resolveProxy(m[0])}throw new Error("Invalid call")}}e.$Iq=O;class j{constructor(R){this.a=R}async request(R,k){const[m,P]=await this.a.call("request",[R],k);return{res:m,stream:(0,L.$Vc)(P)}}async resolveProxy(R){return this.a.call("resolveProxy",[R])}}e.$Jq=j}),define(re[216],oe([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Y5b=e.$X5b=e.$W5b=void 0,e.$W5b={exit:"vscode:electron-main->shared-process=exit",ipcReady:"vscode:shared-process->electron-main=ipc-ready",initDone:"vscode:shared-process->electron-main=init-done"},e.$X5b={request:"vscode:createSharedProcessChannelConnection",response:"vscode:createSharedProcessChannelConnectionResult"},e.$Y5b={request:"vscode:createSharedProcessRawConnection",response:"vscode:createSharedProcessRawConnectionResult"}}),define(re[217],oe([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Y1b=void 0;class L{constructor(){this.b=new Map}static{this.a=1}async createNewMessage(O){try{const j=await this.c();if(j){const A=String(L.a++);return this.b.set(A,j),{id:A,data:j.createNewMessage(O)}}}catch{}return{id:"",data:O}}async validate(O,j){if(!O.id)return!0;const A=this.b.get(O.id);if(!A)return!1;this.b.delete(O.id);try{return A.validate(j)==="ok"}catch{return!1}finally{A.dispose?.()}}async sign(O){try{return await this.d(O)}catch{}return O}}e.$Y1b=L}),define(re[106],oe([0,1,4]),function(te,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uk=e.$Tk=void 0,e.$Tk="signService",e.$Uk=(0,L.$zh)(e.$Tk)}),define(re[218],oe([0,1,217]),function(te,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$K6b=void 0;class N extends L.$Y1b{c(){return this.h().then(j=>new j.validator)}d(j){return this.h().then(A=>new A.signer().sign(j))}h(){return new Promise((j,A)=>te(["vsda"],j,A))}}e.$K6b=N}),define(re[75],oe([0,1,3,2]),function(te,e,L,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mzb=e.$Lzb=e.$Kzb=e.$Jzb=void 0;class O extends N.$mb{constructor(p,g,h){super(),this.a=p,this.b=g,this.c=h}async getItems(){const p={profile:this.b,workspace:this.c},g=await this.a.call("getItems",p);return new Map(g)}updateItems(p){const g={profile:this.b,workspace:this.c};return p.insert&&(g.insert=Array.from(p.insert.entries())),p.delete&&(g.delete=Array.from(p.delete.values())),this.a.call("updateItems",g)}optimize(){const p={profile:this.b,workspace:this.c};return this.a.call("optimize",p)}}class j extends O{constructor(p,g){super(p,g,void 0),this.f=this.B(new L.$hc),this.onDidChangeItemsExternal=this.f.event,this.g()}g(){this.B(this.a.listen("onDidChangeStorage",{profile:this.b})(p=>this.h(p)))}h(p){(Array.isArray(p.changed)||Array.isArray(p.deleted))&&this.f.fire({changed:p.changed?new Map(p.changed):void 0,deleted:p.deleted?new Set(p.deleted):void 0})}}class A extends j{constructor(p){super(p,void 0)}async close(){this.dispose()}}e.$Jzb=A;class R extends j{constructor(p,g){super(p,g)}async close(){this.dispose()}}e.$Kzb=R;class k extends O{constructor(p,g){super(p,void 0,g),this.onDidChangeItemsExternal=L.Event.None}async close(){this.dispose()}}e.$Lzb=k;class m{constructor(p){this.a=p}isUsed(p){const g={payload:p,profile:void 0,workspace:void 0};return this.a.call("isUsed",g)}}e.$Mzb=m}),define(re[107],oe([0,1,6,37,32]),function(te,e,L,N,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9n=e.$8n=void 0;function j(k){if(L.$t===2&&/^penguin(\.|$)/i.test(k))return"chromebook"}function A(k,m,P,p,g,h,d,w){const f=Object.create(null);f["common.machineId"]=h,f.sessionID=(0,O.$6e)()+Date.now(),f.commitHash=p,f.version=g,f["common.platformVersion"]=(k||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),f["common.platform"]=(0,L.$h)(L.$t),f["common.nodePlatform"]=N.$5c,f["common.nodeArch"]=P,f["common.product"]=w||"desktop",d&&(f["common.msftInternal"]=d);let o=0;const l=Date.now();Object.defineProperties(f,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-l,enumerable:!0},"common.sequence":{get:()=>o++,enumerable:!0}}),L.$l&&(f["common.snap"]="true");const $=j(m);return $&&(f["common.platformDetail"]=$),f}e.$8n=A;function R(k){const m=N.env.USERDNSDOMAIN;if(!m)return!1;const P=m.toLowerCase();return k.some(p=>P===p)}e.$9n=R}),define(re[21],oe([0,1,4]),function(te,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$dl=e.$cl=e.$bl=e.$al=e.$_k=e.$$k=e.$0k=e.$9k=e.$8k=e.$7k=void 0,e.$7k=(0,L.$zh)("telemetryService"),e.$8k=(0,L.$zh)("customEndpointTelemetryService"),e.$9k="telemetry.currentSessionDate",e.$0k="telemetry.firstSessionDate",e.$$k="telemetry.lastSessionDate",e.$_k="telemetry.machineId",e.$al="telemetry",e.$bl="telemetry.telemetryLevel",e.$cl="telemetry.enableCrashReporter",e.$dl="telemetry.enableTelemetry";var N;(function(j){j[j.NONE=0]="NONE",j[j.CRASH=1]="CRASH",j[j.ERROR=2]="ERROR",j[j.USAGE=3]="USAGE"})(N||(e.TelemetryLevel=N={}));var O;(function(j){j.OFF="off",j.CRASH="crash",j.ERROR="error",j.ON="all"})(O||(e.TelemetryConfiguration=O={}))}),define(re[219],oe([0,1,36,5,34,22,15,6,11,131,31,145,95,13,24,21]),function(te,e,L,N,O,j,A,R,k,m,P,p,g,h,d,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tr=e.$sr=e.$rr=e.$qr=void 0;const f=new Map;async function o(t,c){const s=`${t}::${c.join(":")}`,n=f.get(s);if(n)return n;const i=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.ya?ml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i},{tag:"devcontainer.json",filePattern:/^devcontainer\.json$/i},{tag:"dockerfile",filePattern:/^(dockerfile|docker\-compose\.ya?ml)$/i}],r=new Map,a=new Map,v=2e4;function y(E,D,T,F){const q=D.substring(E.length+1);return N.Promises.withAsyncBody(async W=>{let Z;try{Z=await P.Promises.readdir(D,{withFileTypes:!0})}catch{W();return}if(F.count>=v){F.count+=Z.length,F.maxReached=!0,W();return}let Y=Z.length;if(Y===0){W();return}let x=Z;F.count+Z.length>v&&(F.maxReached=!0,Y=v-F.count,x=Z.slice(0,Y)),F.count+=Z.length;for(const G of x)if(G.isDirectory()){if(T.includes(G.name)||await y(E,(0,A.$$c)(D,G.name),T,F),--Y===0){W();return}}else{const Q=G.name.lastIndexOf(".");if(Q>=0){const H=G.name.substring(Q+1);H&&r.set(H,(r.get(H)??0)+1)}for(const H of i)H.relativePathPattern?.test(q)!==!1&&H.filePattern.test(G.name)&&a.set(H.tag,(a.get(H.tag)??0)+1);if(--Y===0){W();return}}})}const u=N.Promises.withAsyncBody(async E=>{const D={count:0,maxReached:!1};await y(t,t,c,D);const T=await b(t);E({configFiles:l(a),fileTypes:l(r),fileCount:D.count,maxFilesReached:D.maxReached,launchConfigFiles:T})});return f.set(s,u),u}e.$qr=o;function l(t){return Array.from(t.entries(),([c,s])=>({name:c,count:s})).sort((c,s)=>s.count-c.count)}function $(){const t={os:`${L.type()} ${L.arch()} ${L.release()}`,memory:`${(L.totalmem()/h.$yk.GB).toFixed(2)}GB (${(L.freemem()/h.$yk.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(m.$Fm.value()*100)}%`},c=L.cpus();return c&&c.length>0&&(t.cpus=`${c[0].model} (${c.length} x ${c[0].speed})`),t}e.$rr=$;async function b(t){try{const c=new Map,s=(0,A.$$c)(t,".vscode","launch.json"),n=await P.Promises.readFile(s),i=[],r=(0,O.$Jm)(n.toString(),i);if(i.length)return console.log(`Unable to parse ${s}`),[];if((0,O.$Sm)(r)==="object"&&r.configurations)for(const a of r.configurations){const v=a.type;v&&(c.has(v)?c.set(v,c.get(v)+1):c.set(v,1))}return l(c)}catch{return[]}}e.$sr=b;let I=class{constructor(c,s){this.c=c,this.d=s}f(c){const s=[];return s.push(`OS Version:       ${c.os}`),s.push(`CPUs:             ${c.cpus}`),s.push(`Memory (System):  ${c.memory}`),s.push(`VM:               ${c.vmHint}`),s.join(`
`)}g(c){const s=[];s.push(`Version:          ${this.d.nameShort} ${this.d.version} (${this.d.commit||"Commit unknown"}, ${this.d.date||"Date unknown"})`),s.push(`OS Version:       ${L.type()} ${L.arch()} ${L.release()}`);const n=L.cpus();return n&&n.length>0&&s.push(`CPUs:             ${n[0].model} (${n.length} x ${n[0].speed})`),s.push(`Memory (System):  ${(L.totalmem()/h.$yk.GB).toFixed(2)}GB (${(L.freemem()/h.$yk.GB).toFixed(2)}GB free)`),R.$i||s.push(`Load (avg):       ${L.loadavg().map(i=>Math.round(i)).join(", ")}`),s.push(`VM:               ${Math.round(m.$Fm.value()*100)}%`),s.push(`Screen Reader:    ${c.screenReader?"yes":"no"}`),s.push(`Process Argv:     ${c.mainArguments.join(" ")}`),s.push(`GPU Status:       ${this.j(c.gpuFeatureStatus)}`),s.join(`
`)}async getPerformanceInfo(c,s){return Promise.all([(0,p.$pr)(c.mainPID),this.k(c)]).then(async n=>{let[i,r]=n,a=this.m(c,i);return s.forEach(v=>{if((0,g.$fm)(v))a+=`
${v.errorMessage}`,r+=`
${v.errorMessage}`;else if(a+=`

Remote: ${v.hostName}`,v.processes&&(a+=`
${this.m(c,v.processes)}`),v.workspaceMetadata){r+=`
|  Remote: ${v.hostName}`;for(const y of Object.keys(v.workspaceMetadata)){const u=v.workspaceMetadata[y];let E=`${u.fileCount} files`;u.maxFilesReached&&(E=`more than ${E}`),r+=`|    Folder (${y}): ${E}`,r+=this.h(u)}}}),{processInfo:a,workspaceInfo:r}})}async getSystemInfo(c,s){const{memory:n,vmHint:i,os:r,cpus:a}=$(),v={os:r,memory:n,cpus:a,vmHint:i,processArgs:`${c.mainArguments.join(" ")}`,gpuStatus:c.gpuFeatureStatus,screenReader:`${c.screenReader?"yes":"no"}`,remoteData:s};return R.$i||(v.load=`${L.loadavg().map(y=>Math.round(y)).join(", ")}`),R.$k&&(v.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(v)}async getDiagnostics(c,s){const n=[];return(0,p.$pr)(c.mainPID).then(async i=>(n.push(""),n.push(this.g(c)),n.push(""),n.push(this.m(c,i)),c.windows.some(r=>r.folderURIs&&r.folderURIs.length>0&&!r.remoteAuthority)&&(n.push(""),n.push("Workspace Stats: "),n.push(await this.k(c))),s.forEach(r=>{if((0,g.$fm)(r))n.push(`
${r.errorMessage}`);else if(n.push(`

`),n.push(`Remote:           ${r.hostName}`),n.push(this.f(r.machineInfo)),r.processes&&n.push(this.m(c,r.processes)),r.workspaceMetadata)for(const a of Object.keys(r.workspaceMetadata)){const v=r.workspaceMetadata[a];let y=`${v.fileCount} files`;v.maxFilesReached&&(y=`more than ${y}`),n.push(`Folder (${a}): ${y}`),n.push(this.h(v))}}),n.push(""),n.push(""),n.join(`
`)))}h(c){const s=[];let i=0;const r=(u,E)=>{const D=` ${u}(${E})`;i+D.length>60?(s.push(a),a="|                 ",i=a.length):i+=D.length,a+=D};let a="|      File types:";const v=10,y=c.fileTypes.length>v?v:c.fileTypes.length;for(let u=0;u<y;u++){const E=c.fileTypes[u];r(E.name,E.count)}if(s.push(a),c.configFiles.length>=0&&(a="|      Conf files:",i=0,c.configFiles.forEach(u=>{r(u.name,u.count)}),s.push(a)),c.launchConfigFiles.length>0){let u="|      Launch Configs:";c.launchConfigFiles.forEach(E=>{const D=E.count>1?` ${E.name}(${E.count})`:` ${E.name}`;u+=D}),s.push(u)}return s.join(`
`)}j(c){const s=Math.max(...Object.keys(c).map(n=>n.length));return Object.keys(c).map(n=>`${n}:  ${" ".repeat(s-n.length)}  ${c[n]}`).join(`
                  `)}k(c){const s=[],n=[];return c.windows.forEach(i=>{i.folderURIs.length===0||i.remoteAuthority||(s.push(`|  Window (${i.title})`),i.folderURIs.forEach(r=>{const a=k.URI.revive(r);if(a.scheme===j.Schemas.file){const v=a.fsPath;n.push(o(v,["node_modules",".git"]).then(y=>{let u=`${y.fileCount} files`;y.maxFilesReached&&(u=`more than ${u}`),s.push(`|    Folder (${(0,A.$cd)(v)}): ${u}`),s.push(this.h(y))}).catch(y=>{s.push(`|      Error: Unable to collect workspace stats for folder ${v} (${y.toString()})`)}))}else s.push(`|    Folder (${a.toString()}): Workspace stats not available.`)}))}),Promise.all(n).then(i=>s.join(`
`)).catch(i=>`Unable to collect workspace stats: ${i}`)}m(c,s){const n=new Map;c.windows.forEach(r=>n.set(r.pid,`window [${r.id}] (${r.title})`)),c.pidToNames.forEach(({pid:r,name:a})=>n.set(r,a));const i=[];return i.push("CPU %	Mem MB	   PID	Process"),s&&this.n(c.mainPID,n,i,s,0),i.join(`
`)}n(c,s,n,i,r){const a=r===0;let v;a?v=i.pid===c?`${this.d.applicationName} main`:"remote agent":s.has(i.pid)?v=s.get(i.pid):v=`${"  ".repeat(r)} ${i.name}`;const y=process.platform==="win32"?i.mem:L.totalmem()*(i.mem/100);n.push(`${i.load.toFixed(0).padStart(5," ")}	${(y/h.$yk.MB).toFixed(0).padStart(6," ")}	${i.pid.toFixed(0).padStart(6," ")}	${v}`),Array.isArray(i.children)&&i.children.forEach(u=>this.n(c,s,n,u,r+1))}async getWorkspaceFileExtensions(c){const s=new Set;for(const{uri:n}of c.folders){const i=k.URI.revive(n);if(i.scheme!==j.Schemas.file)continue;const r=i.fsPath;try{(await o(r,["node_modules",".git"])).fileTypes.forEach(v=>s.add(v.name))}catch{}}return{extensions:[...s]}}async reportWorkspaceStats(c){for(const{uri:s}of c.folders){const n=k.URI.revive(s);if(n.scheme!==j.Schemas.file)continue;const i=n.fsPath;try{const r=await o(i,["node_modules",".git"]);this.c.publicLog2("workspace.stats",{"workspace.id":c.telemetryId,rendererSessionId:c.rendererSessionId}),r.fileTypes.forEach(a=>{this.c.publicLog2("workspace.stats.file",{rendererSessionId:c.rendererSessionId,type:a.name,count:a.count})}),r.launchConfigFiles.forEach(a=>{this.c.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:c.rendererSessionId,type:a.name,count:a.count})}),r.configFiles.forEach(a=>{this.c.publicLog2("workspace.stats.configFiles",{rendererSessionId:c.rendererSessionId,type:a.name,count:a.count})})}catch{}}}};e.$tr=I,e.$tr=I=ye([X(0,w.$7k),X(1,d.$ij)],I)}),define(re[108],oe([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$35b=e.$25b=void 0;class L{constructor(j){this.b=j}listen(j,A){throw new Error(`Event not found: ${A}`)}call(j,A,{eventName:R,data:k}){return this.b.forEach(m=>m.log(R,k)),Promise.resolve(null)}}e.$25b=L;class N{constructor(j){this.b=j}log(j,A){return this.b.call("log",{eventName:j,data:A}).then(void 0,R=>`Failed to log telemetry: ${console.warn(R)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.$35b=N}),define(re[46],oe([0,1,30,9,3,18,74,107,21]),function(te,e,L,N,O,j,A,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mo=e.$lo=e.$ko=e.$jo=e.$io=e.$ho=e.$go=e.$fo=e.$eo=e.$do=e.$co=e.$bo=e.$ao=e.$_n=e.$$n=e.$0n=void 0;class m{constructor(i){this.value=i,this.isTrustedTelemetryValue=!0}}e.$0n=m;class P{constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$$n=P,e.$_n=new P;class p{async publicLog(i,r,a){}async publicLogError(i,r,a){}}e.$ao=p,e.$bo="telemetry",e.$co="extensionTelemetryLog",e.$do={log:()=>null,flush:()=>Promise.resolve(null)};function g(n,i){return O.Event.debounce(i.onDidChangeConfiguration,(a,v)=>{const y=a?new Set([...a.affectedKeys,...v.affectedKeys]):v.affectedKeys;return{...v,affectedKeys:y}},1e3,!0)(a=>{a.source!==7&&n.publicLog2("updateConfiguration",{configurationSource:(0,j.$9h)(a.source),configurationKeys:Array.from(a.affectedKeys)})})}e.$eo=g;function h(n,i){return!i.isBuilt&&!i.disableTelemetry?!0:!(i.disableTelemetry||!n.enableTelemetry||i.extensionTestsLocationURI)}e.$fo=h;function d(n,i){return!(i.isBuilt||i.disableTelemetry||n.enableTelemetry&&n.aiConfig?.ariaKey)}e.$go=d;function w(n){const i=n.getValue(k.$bl),r=n.getValue(k.$cl);if(n.getValue(k.$dl)===!1||r===!1)return 0;switch(i??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.$ho=w;function f(n){const i={},r={},a={};$(n,a);for(let v in a){v=v.length>150?v.substr(v.length-149):v;const y=a[v];typeof y=="number"?r[v]=y:typeof y=="boolean"?r[v]=y?1:0:typeof y=="string"?(y.length>8192&&console.warn(`Telemetry property: ${v} has been trimmed to 8192, the original length is ${y.length}`),i[v]=y.substring(0,8191)):typeof y<"u"&&y!==null&&(i[v]=y)}return{properties:i,measurements:r}}e.$io=f;const o=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function l(n){if(!n)return"none";const i=(0,A.$Nk)(n);return o.has(i)?i:"other"}e.$jo=l;function $(n,i,r=0,a){if(n)for(const v of Object.getOwnPropertyNames(n)){const y=n[v],u=a?a+v:v;Array.isArray(y)?i[u]=(0,L.$Ym)(y):y instanceof Date?i[u]=y.toISOString():(0,N.$ne)(y)?r<2?$(y,i,r+1,u+"."):i[u]=(0,L.$Ym)(y):i[u]=y}}function b(n,i){const r=n.msftInternalDomains||[],a=i.getValue("telemetry.internalTesting");return(0,R.$9n)(r)||a}e.$ko=b;function I(n){return[n.appRoot,n.extensionsPath,n.userHome.fsPath,n.tmpDir.fsPath,n.userDataPath]}e.$lo=I;function t(n,i){if(!n||!n.includes("/")&&!n.includes("\\"))return n;let r=n;const a=[];for(const E of i)for(;;){const D=E.exec(n);if(!D)break;a.push([D.index,E.lastIndex])}const v=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,y=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let u=0;for(r="";;){const E=y.exec(n);if(!E)break;const D=a.some(([T,F])=>E.index<F&&T<y.lastIndex);!v.test(E[0])&&!D&&(r+=n.substring(u,E.index)+"<REDACTED: user-file-path>",u=y.lastIndex)}return u<n.length&&(r+=n.substr(u)),r}function c(n){if(!n)return n;const i=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const r of i)if(r.regex.test(n))return`<REDACTED: ${r.label}>`;return n}function s(n,i){return(0,L.$Vm)(n,r=>{if(r instanceof m||Object.hasOwnProperty.call(r,"isTrustedTelemetryValue"))return r.value;if(typeof r=="string"){let a=r.replaceAll("%20"," ");a=t(a,i);for(const v of i)a=a.replace(v,"");return a=c(a),a}})}e.$mo=s}),define(re[33],oe([0,1,28,29,45,6,11,8,37,46]),function(te,e,L,N,O,j,A,R,k,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yo=e.$xo=e.$wo=e.$vo=e.$uo=e.$to=e.$so=e.$ro=e.$qo=e.$po=e.$oo=e.$no=void 0;function P(s,n){return s.uuid&&n.uuid?s.uuid===n.uuid:s.id===n.id?!0:(0,L.$Jd)(s.id,n.id)===0}e.$no=P;const p=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class g{static create(n){const i=n.manifest?n.manifest.version:n.version,r=n.manifest?n.targetPlatform:n.properties.targetPlatform;return new g(n.identifier,i,r)}static parse(n){const i=p.exec(n);return i&&i[1]&&i[2]?new g({id:i[1]},i[2],i[4]||void 0):null}constructor(n,i,r="undefined"){this.version=i,this.targetPlatform=r,this.id=n.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(n){return n instanceof g?P(this,n)&&this.version===n.version&&this.targetPlatform===n.targetPlatform:!1}}e.$oo=g;const h=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function d(s){const n=h.exec(s);return n&&n[1]?[f(n[1]),n[2]]:[f(s),void 0]}e.$po=d;function w(s,n){return`${s}.${n}`}e.$qo=w;function f(s){return s.toLowerCase()}e.$ro=f;function o(s,n){return f(w(s??O.$Pl,n))}e.$so=o;function l(s,n){const i=[],r=a=>{for(const v of i)if(v.some(y=>P(n(y),n(a))))return v;return null};for(const a of s){const v=r(a);v?v.push(a):i.push([a])}return i}e.$to=l;function $(s){return{id:s.identifier.id,name:s.manifest.name,galleryId:null,publisherId:s.publisherId,publisherName:s.manifest.publisher,publisherDisplayName:s.publisherDisplayName,dependencies:s.manifest.extensionDependencies&&s.manifest.extensionDependencies.length>0}}e.$uo=$;function b(s){return{id:new m.$0n(s.identifier.id),name:new m.$0n(s.name),galleryId:s.identifier.uuid,publisherId:s.publisherId,publisherName:s.publisher,publisherDisplayName:s.publisherDisplayName,isPreReleaseVersion:s.properties.isPreReleaseVersion,dependencies:!!(s.properties.dependencies&&s.properties.dependencies.length>0),isSigned:s.isSigned,...s.telemetryData}}e.$vo=b,e.$wo=new O.$Tl("pprice.better-merge");function I(s,n){const i=[],r=n.manifest.extensionDependencies?.slice(0)??[];for(;r.length;){const a=r.shift();if(a&&i.every(v=>!P(v.identifier,{id:a}))){const v=s.filter(y=>P(y.identifier,{id:a}));v.length===1&&(i.push(v[0]),r.push(...v[0].manifest.extensionDependencies?.slice(0)??[]))}}return i}e.$xo=I;async function t(s,n){if(!j.$k)return!1;let i;try{i=(await s.readFile(A.URI.file("/etc/os-release"))).value.toString()}catch{try{i=(await s.readFile(A.URI.file("/usr/lib/os-release"))).value.toString()}catch(a){n.debug("Error while getting the os-release file.",(0,R.$8)(a))}}return!!i&&(i.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function c(s,n){const i=await t(s,n),r=(0,N.$Sn)(i?"alpine":j.$t,k.$6c);return n.debug("ComputeTargetPlatform:",r),r}e.$yo=c}),define(re[220],oe([0,1,20,2,23,11,13,24,5,3,15,6,37,33]),function(te,e,L,N,O,j,A,R,k,m,P,p,g,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$53b=e.$43b=void 0;let d=class extends N.$mb{constructor($,b){super(),this.b=$,this.c=b,this.a=new Map,this.c.configBasedExtensionTips&&Object.entries(this.c.configBasedExtensionTips).forEach(([,I])=>this.a.set(I.configPath,I))}getConfigBasedTips($){return this.f($)}async getImportantExecutableBasedTips(){return[]}async getOtherExecutableBasedTips(){return[]}async f($){const b=[];for(const[I,t]of this.a)if(!(t.configScheme&&t.configScheme!==$.scheme))try{const c=(await this.b.readFile((0,O.$gg)($,I))).value.toString();for(const[s,n]of Object.entries(t.recommendations))(!n.contentPattern||new RegExp(n.contentPattern,"mig").test(c))&&b.push({extensionId:s,extensionName:n.name,configName:t.configName,important:!!n.important,isExtensionPack:!!n.isExtensionPack,whenNotInstalled:n.whenNotInstalled})}catch{}return b}};e.$43b=d,e.$43b=d=ye([X(0,A.$4j),X(1,R.$ij)],d);const w="extensionTips/promptedExecutableTips",f="extensionTips/lastPromptedMediumImpExeTime";class o extends d{constructor($,b,I,t,c,s,n,i){super(n,i),this.m=$,this.n=b,this.r=I,this.s=t,this.t=c,this.u=s,this.g=new Map,this.h=new Map,this.j=new Map,this.k=new Map,this.l=new Map,i.exeBasedExtensionTips&&Object.entries(i.exeBasedExtensionTips).forEach(([r,a])=>{const v=[],y=[],u=[];Object.entries(a.recommendations).forEach(([E,D])=>{D.important?a.important?v.push({extensionId:E,extensionName:D.name,isExtensionPack:!!D.isExtensionPack}):y.push({extensionId:E,extensionName:D.name,isExtensionPack:!!D.isExtensionPack}):u.push({extensionId:E,extensionName:D.name,isExtensionPack:!!D.isExtensionPack})}),v.length&&this.g.set(r,{exeFriendlyName:a.friendlyName,windowsPath:a.windowsPath,recommendations:v}),y.length&&this.h.set(r,{exeFriendlyName:a.friendlyName,windowsPath:a.windowsPath,recommendations:y}),u.length&&this.j.set(r,{exeFriendlyName:a.friendlyName,windowsPath:a.windowsPath,recommendations:u})}),this.B((0,k.$Gg)(async()=>{await this.v(),this.z(),this.C()},3e3))}async getImportantExecutableBasedTips(){const $=await this.L(this.g),b=await this.L(this.h);return[...$,...b]}getOtherExecutableBasedTips(){return this.L(this.j)}async v(){const $=await this.L(this.g),b=await this.L(this.h),I=await this.s.getInstalled();this.k=this.w($,I),this.l=this.w(b,I)}w($,b){const I=new Map;$.forEach(i=>I.set(i.extensionId.toLowerCase(),i));const{installed:t,uninstalled:c}=this.J([...I.keys()],b);for(const i of t){const r=I.get(i);r&&this.r.publicLog2("exeExtensionRecommendations:alreadyInstalled",{extensionId:i,exeName:r.exeName})}for(const i of c){const r=I.get(i);r&&this.r.publicLog2("exeExtensionRecommendations:notInstalled",{extensionId:i,exeName:r.exeName})}const s=this.H(),n=new Map;for(const i of c){const r=I.get(i);if(r&&(!s[r.exeName]||!s[r.exeName].includes(r.extensionId))){let a=n.get(r.exeName);a||(a=[],n.set(r.exeName,a)),a.push(r)}}return n}z(){if(this.k.size===0)return;const[$,b]=[...this.k.entries()][0];this.D(b).then(I=>{switch(I){case"reacted":this.I(b[0].exeName,b);break;case"ignored":this.k.delete($);break;case"incompatibleWindow":{const t=m.Event.once(m.Event.latch(m.Event.any(this.n.onDidOpenWindow,this.n.onDidFocusWindow)));this.B(t(()=>this.z()));break}case"toomany":{const t=this.B((0,k.$Gg)(()=>{t.dispose(),this.z()},36e5));break}}})}C(){if(this.l.size===0)return;const $=this.F(),b=Date.now()-$,I=7*24*60*60*1e3;if(b<I){const s=this.B((0,k.$Gg)(()=>{s.dispose(),this.C()},I-b));return}const[t,c]=[...this.l.entries()][0];this.D(c).then(s=>{switch(s){case"reacted":{this.G(Date.now()),this.l.delete(t),this.I(c[0].exeName,c);const n=this.B((0,k.$Gg)(()=>{n.dispose(),this.C()},I));break}case"ignored":this.l.delete(t),this.C();break;case"incompatibleWindow":{const n=m.Event.once(m.Event.latch(m.Event.any(this.n.onDidOpenWindow,this.n.onDidFocusWindow)));this.B(n(()=>this.C()));break}case"toomany":{const n=this.B((0,k.$Gg)(()=>{n.dispose(),this.C()},36e5));break}}})}async D($){const b=await this.s.getInstalled(1),I=$.filter(t=>!t.whenNotInstalled||t.whenNotInstalled.every(c=>b.every(s=>!(0,h.$no)(s.identifier,{id:c})))).map(({extensionId:t})=>t.toLowerCase());return this.u.promptImportantExtensionsInstallNotification({extensions:I,source:3,name:$[0].exeFriendlyName,searchValue:`@exe:"${$[0].exeName}"`})}F(){let $=this.t.getNumber(f,-1);return $||($=Date.now(),this.G($)),$}G($){this.t.store(f,$,-1,1)}H(){return JSON.parse(this.t.get(w,-1,"{}"))}I($,b){const I=this.H();I[$]=b.map(({extensionId:t})=>t.toLowerCase()),this.t.store(w,JSON.stringify(I),-1,0)}J($,b){const I=[],t=[],c=b.reduce((s,n)=>(s.add(n.identifier.id.toLowerCase()),s),new Set);return $.forEach(s=>{c.has(s.toLowerCase())?I.push(s):t.push(s)}),{installed:I,uninstalled:t}}async L($){const b=[],I=new Map;for(const t of $.keys()){const c=$.get(t);if(!c||!(0,L.$Ef)(c.recommendations))continue;const s=[];p.$i?c.windowsPath&&s.push(c.windowsPath.replace("%USERPROFILE%",()=>g.env.USERPROFILE).replace("%ProgramFiles(x86)%",()=>g.env["ProgramFiles(x86)"]).replace("%ProgramFiles%",()=>g.env.ProgramFiles).replace("%APPDATA%",()=>g.env.APPDATA).replace("%WINDIR%",()=>g.env.WINDIR)):(s.push((0,P.$$c)("/usr/local/bin",t)),s.push((0,P.$$c)("/usr/bin",t)),s.push((0,P.$$c)(this.m.fsPath,t)));for(const n of s){let i=I.get(n);if(i===void 0&&(i=await this.b.exists(j.URI.file(n)),I.set(n,i)),i)for(const{extensionId:r,extensionName:a,isExtensionPack:v,whenNotInstalled:y}of c.recommendations)b.push({extensionId:r,extensionName:a,isExtensionPack:v,exeName:t,exeFriendlyName:c.exeFriendlyName,windowsPath:c.windowsPath,whenNotInstalled:y})}}return b}}e.$53b=o}),define(re[221],oe([0,1,26,33]),function(te,e,L,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rUb=void 0;async function O(j,A,R,k,m){try{const P=await j.getExtensionsControlManifest();if(!P.deprecated)return;const p=await j.getInstalled(1);for(const[g,h]of Object.entries(P.deprecated)){if(!h?.extension)continue;const{id:d,autoMigrate:w,preRelease:f}=h.extension;if(!w)continue;const o=p.find($=>(0,N.$no)($.identifier,{id:g}));if(!o)continue;const l=(await A.getExtensions([{id:d,preRelease:f}],{targetPlatform:await j.getTargetPlatform(),compatible:!0},L.CancellationToken.None))[0];if(!l){m.info(`Skipping migrating '${o.identifier.id}' extension because, the comaptible target '${d}' extension is not found`);continue}try{m.info(`Migrating '${o.identifier.id}' extension to '${d}' extension...`);const $=!k.getDisabledExtensions().some(I=>(0,N.$no)(I,o.identifier));await j.uninstall(o),m.info(`Uninstalled the unsupported extension '${o.identifier.id}'`);let b=p.find(I=>(0,N.$no)(I.identifier,{id:d}));(!b||!b.isPreReleaseVersion&&$)&&(b=await j.installFromGallery(l,{installPreReleaseVersion:!0,isMachineScoped:o.isMachineScoped,operation:4}),m.info(`Installed the pre-release extension '${b.identifier.id}'`),$||(await k.disableExtension(b.identifier),m.info(`Disabled the pre-release extension '${b.identifier.id}' because the unsupported extension '${o.identifier.id}' is disabled`)),w.storage&&(R.addToMigrationList((0,N.$qo)(o.manifest.publisher,o.manifest.name),(0,N.$qo)(b.manifest.publisher,b.manifest.name)),m.info("Added pre-release extension to the storage migration list"))),m.info(`Migrated '${o.identifier.id}' extension to '${d}' extension.`)}catch($){m.error($)}}}catch(P){m.error(P)}}e.$rUb=O}),define(re[222],oe([0,1,3,2,35,33,45]),function(te,e,L,N,O,j,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$up=void 0;class R extends N.$mb{constructor(m,P,p,g,h,d,w){super(),this.f=m,this.g=P,this.h=p,this.i=g,this.j=h,this.k=d,this.l=w,this.a=this.B(new L.$hc),this.onDidChangeExtensionsByAnotherSource=this.a.event,this.b=new Map,this.c=this.B(new N.$ub),this.m().then(null,f=>w.error(f))}async m(){await this.g.initializeDefaultProfileExtensions(),await this.p(this.h.profiles),this.n(),await this.z()}n(){this.B(this.h.onDidChangeProfiles(m=>this.p(m.added))),this.B(this.i.onAddExtensions(m=>this.r(m))),this.B(this.i.onDidAddExtensions(m=>this.s(m))),this.B(this.i.onRemoveExtensions(m=>this.t(m))),this.B(this.i.onDidRemoveExtensions(m=>this.u(m))),this.B(this.k.onDidFilesChange(m=>this.v(m)))}async p(m){try{m.length&&await Promise.all(m.map(P=>(this.c.set(P.id,(0,N.$jb)(this.k.watch(this.j.extUri.dirname(P.extensionsResource)),this.k.watch(P.extensionsResource))),this.y(P.extensionsResource))))}catch(P){throw this.l.error(P),P}}async r(m){for(const P of m.extensions)this.C(this.F(P.identifier,P.version),m.profileLocation)}async s(m){for(const P of m.extensions){const p=this.F(P.identifier,P.version);m.error?this.D(p,m.profileLocation):this.C(p,m.profileLocation)}}async t(m){for(const P of m.extensions)this.D(this.F(P.identifier,P.version),m.profileLocation)}async u(m){const P=[],p=[];for(const g of m.extensions){const h=this.F(g.identifier,g.version);m.error?this.C(h,m.profileLocation):(this.D(h,m.profileLocation),this.b.has(h)||(this.l.debug("Extension is removed from all profiles",g.identifier.id,g.version),p.push(this.f.scanInstalledExtensionAtLocation(g.location).then(d=>{d?P.push(d):this.l.info("Extension not found at the location",g.location.toString())},d=>this.l.error(d)))))}try{await Promise.all(p),P.length&&await this.z(P)}catch(g){this.l.error(g)}}v(m){for(const P of this.h.profiles)m.contains(P.extensionsResource,0,1)&&this.w(P.extensionsResource)}async w(m){const P=[],p=[],g=await this.i.scanProfileExtensions(m),h=new Set,d=new Set;for(const[w,f]of this.b)f.has(m)&&d.add(w);for(const w of g){const f=this.F(w.identifier,w.version);h.add(f),d.has(f)||(P.push(w.identifier),this.C(f,m))}for(const w of d)if(!h.has(w)){const f=this.G(w);f&&(p.push(f.identifier),this.D(w,m))}(P.length||p.length)&&this.a.fire({added:P.length?{extensions:P,profileLocation:m}:void 0,removed:p.length?{extensions:p,profileLocation:m}:void 0})}async y(m){const P=await this.i.scanProfileExtensions(m);for(const p of P)this.C(this.F(p.identifier,p.version),m)}async z(m){m||(m=(await this.f.scanAllUserInstalledExtensions()).filter(p=>!this.b.has(this.F(p.identifier,p.manifest.version)))),m.length&&await this.f.markAsUninstalled(...m)}C(m,P){let p=this.b.get(m);p||this.b.set(m,p=new O.$yi(g=>this.j.extUri.getComparisonKey(g))),p.add(P)}D(m,P){const p=this.b.get(m);p&&p.delete(P),p?.size||this.b.delete(m)}F(m,P){return`${A.$Tl.toKey(m.id)}@${P}`}G(m){const[P,p]=(0,j.$po)(m);return p?{identifier:{id:P},version:p}:void 0}}e.$up=R}),define(re[223],oe([0,1,44,46]),function(te,e,L,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zo=void 0;async function O(j,A,R,k,m,P,p){const g={"X-Market-Client-Id":`VSCode ${j}`,"User-Agent":`VSCode ${j} (${A.nameShort})`};if((0,N.$fo)(A,R)&&(0,N.$ho)(k)===3){const h=await(0,L.$Yo)(R,m,P);g["X-Market-User-Id"]=h,g["VSCode-SessionId"]=p.machineId||h}return g}e.$Zo=O}),define(re[224],oe([0,1,69,20,5,2,22,15,31,16,29,33,7,72,11]),function(te,e,L,N,O,j,A,R,k,m,P,p,g,h,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hq=void 0;let w=class extends h.$Gq{constructor($,b,I,t){super(I),this.h=$,this.i=t,this.g=this.B(new f(b,t)),this.h.registerParticipant({postInstall:async c=>this.j(c),postUninstall:async c=>this.k(c)})}async getBuiltInExtensionTranslationsUri($,b){const t=(await this.g.getLanguagePacks())[b];if(!t){this.i.warn(`No language pack found for ${b}`);return}const c=t.translations[$];return c?d.URI.file(c):void 0}async getInstalledLanguages(){const $=await this.g.getLanguagePacks(),b=Object.keys($).map(I=>{const t=$[I];return{...this.f(I,t.label),extensionId:t.extensions[0].extensionIdentifier.id}});return b.push(this.f("en","English")),b.sort((I,t)=>I.label.localeCompare(t.label)),b}async j($){$&&$.manifest&&$.manifest.contributes&&$.manifest.contributes.localizations&&$.manifest.contributes.localizations.length&&(this.i.info("Adding language packs from the extension",$.identifier.id),await this.update())}async k($){const b=await this.g.getLanguagePacks();Object.keys(b).some(I=>b[I]&&b[I].extensions.some(t=>(0,p.$no)(t.extensionIdentifier,$.identifier)))&&(this.i.info("Removing language packs from the extension",$.identifier.id),await this.update())}async update(){const[$,b]=await Promise.all([this.g.getLanguagePacks(),this.h.getInstalled()]),I=await this.g.update(b);return!(0,N.$of)(Object.keys($),Object.keys(I))}};e.$Hq=w,e.$Hq=w=ye([X(0,P.$Zn),X(1,m.$Hh),X(2,P.$Xn),X(3,g.$3i)],w);let f=class extends j.$mb{constructor($,b){super(),this.i=b,this.c={},this.f=(0,R.$$c)($.userDataPath,"languagepacks.json"),this.g=new O.$Lg}getLanguagePacks(){return this.g.size||!this.h?this.m().then(()=>this.c):Promise.resolve(this.c)}update($){return this.m(b=>{Object.keys(b).forEach(I=>delete b[I]),this.j(b,...$)}).then(()=>this.c)}j($,...b){for(const I of b)I&&I.manifest&&I.manifest.contributes&&I.manifest.contributes.localizations&&I.manifest.contributes.localizations.length&&this.k($,I);Object.keys($).forEach(I=>this.l($[I]))}k($,b){const I=b.identifier,t=b.manifest.contributes&&b.manifest.contributes.localizations?b.manifest.contributes.localizations:[];for(const c of t)if(b.location.scheme===A.Schemas.file&&o(c)){let s=$[c.languageId];s||(s={hash:"",extensions:[],translations:{},label:c.localizedLanguageName??c.languageName},$[c.languageId]=s);const n=s.extensions.filter(i=>(0,p.$no)(i.extensionIdentifier,I))[0];n?n.version=b.manifest.version:s.extensions.push({extensionIdentifier:I,version:b.manifest.version});for(const i of c.translations)s.translations[i.id]=(0,R.$$c)(b.location.fsPath,i.path)}}l($){if($){const b=(0,L.createHash)("md5");for(const I of $.extensions)b.update(I.extensionIdentifier.uuid||I.extensionIdentifier.id).update(I.version);$.hash=b.digest("hex")}}m($=()=>null){return this.g.queue(()=>{let b=null;return k.Promises.readFile(this.f,"utf8").then(void 0,I=>I.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(I)).then(I=>{try{return JSON.parse(I)}catch{return{}}}).then(I=>(b=$(I),I)).then(I=>{for(const c of Object.keys(I))I[c]||delete I[c];this.c=I,this.h=!0;const t=JSON.stringify(this.c);return this.i.debug("Writing language packs",t),k.Promises.writeFile(this.f,t)}).then(()=>b,I=>this.i.error(I))})}};f=ye([X(0,m.$Hh),X(1,g.$3i)],f);function o(l){if(typeof l.languageId!="string"||!Array.isArray(l.translations)||l.translations.length===0)return!1;for(const $ of l.translations)if(typeof $.id!="string"||typeof $.path!="string")return!1;return!(l.languageName&&typeof l.languageName!="string"||l.localizedLanguageName&&typeof l.localizedLanguageName!="string")}}),define(re[225],oe([0,1,142,8,30,46]),function(te,e,L,N,O,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5M=void 0;const A="https://mobile.events.data.microsoft.com/OneCollector/1.0",R="https://mobile.events.data.microsoft.com/ping";async function k(P,p,g){const h=await(0,L.$9C)("@microsoft/1ds-core-js","dist/ms.core.js"),d=await(0,L.$9C)("@microsoft/1ds-post-js","dist/ms.post.js"),w=new h.AppInsightsCore,f=new d.PostChannel,o={instrumentationKey:P,endpointUrl:A,loggingLevelTelemetry:0,loggingLevelConsole:0,disableCookiesUsage:!0,disableDbgExt:!0,disableInstrumentationKeyValidation:!0,channels:[[f]]};if(g){o.extensionConfig={};const l={alwaysUseXhrOverride:!0,httpXHROverride:g};o.extensionConfig[f.identifier]=l}return w.initialize(o,[]),w.addTelemetryInitializer(l=>{p&&(l.ext=l.ext??{},l.ext.utc=l.ext.utc??{},l.ext.utc.flags=8462029)}),w}class m{constructor(p,g,h,d,w){this.e=p,this.f=g,this.g=h,this.h=w,this.c=A,this.d=R,this.g||(this.g={}),typeof d=="function"?this.a=d():this.a=d,this.b=null}i(p){if(this.a){if(typeof this.a!="string"){p(this.a);return}this.b||(this.b=k(this.a,this.e,this.h)),this.b.then(g=>{p(g)},g=>{(0,N.$Y)(g),console.error(g)})}}log(p,g){if(!this.a)return;g=(0,O.$Wm)(g,this.g),g=(0,j.$io)(g);const h=this.f+"/"+p;try{this.i(d=>{d.pluginVersionString=g?.properties.version??"Unknown",d.track({name:h,baseData:{name:h,properties:g?.properties,measurements:g?.measurements}})})}catch{}}flush(){return this.a?new Promise(p=>{this.i(g=>{g.unload(!0,()=>{this.a=void 0,p(void 0)})})}):Promise.resolve(void 0)}}e.$5M=m}),define(re[109],oe([0,1,2,166,16,7,24,46]),function(te,e,L,N,O,j,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$s3b=void 0;let k=class extends L.$mb{constructor(P,p,g,h,d=""){super(),this.b=d;const w=p.getLogger(R.$bo);if(w)this.a=this.B(w);else{const o=(0,R.$go)(h,g)?" (Not Sent)":"",l=()=>(0,R.$fo)(h,g)&&P.getLevel()===j.LogLevel.Trace;this.a=this.B(p.createLogger(R.$bo,{name:(0,N.localize)(0,null,o),hidden:!l()})),this.B(P.onDidChangeLogLevel(()=>p.setVisibility(R.$bo,l()))),this.a.info("Below are logs for every telemetry event sent from VS Code once the log level is set to trace."),this.a.info("===========================================================")}}flush(){return Promise.resolve(void 0)}log(P,p){this.a.trace(`${this.b}telemetry/${P}`,(0,R.$io)(p))}};e.$s3b=k,e.$s3b=k=ye([X(0,j.$3i),X(1,j.$4i),X(2,O.$Gh),X(3,A.$ij)],k)}),define(re[110],oe([0,1,2,30,6,28,167,18,49,102,24,40,21,46]),function(te,e,L,N,O,j,A,R,k,m,P,p,g,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nq=void 0;let d=class{static{this.IDLE_START_EVENT_NAME="UserIdleStart"}static{this.IDLE_STOP_EVENT_NAME="UserIdleStop"}constructor(o,l,$){this.k=l,this.l=$,this.d={},this.i=new L.$lb,this.j=[],this.b=o.appenders,this.c=o.commonProperties??Object.create(null),this.sessionId=this.c.sessionID,this.machineId=this.c["common.machineId"],this.firstSessionDate=this.c["common.firstSessionDate"],this.msftInternal=this.c["common.msftInternal"],this.f=o.piiPaths||[],this.g=3,this.h=!!o.sendErrorTelemetry,this.j=[/(vscode-)?file:\/\/\/.*?\/resources\/app\//gi];for(const b of this.f)this.j.push(new RegExp((0,j.$sd)(b),"gi")),b.indexOf("\\")>=0&&this.j.push(new RegExp((0,j.$sd)(b.replace(/\\/g,"/")),"gi"));this.m(),this.i.add(this.k.onDidChangeConfiguration(b=>{(b.affectsConfiguration(g.$bl)||b.affectsConfiguration(g.$dl)||b.affectsConfiguration(g.$cl))&&this.m()}))}setExperimentProperty(o,l){this.d[o]=l}m(){let o=(0,h.$ho)(this.k);const l=this.l.enabledTelemetryLevels;if(l){this.h=this.sendErrorTelemetry?l.error:!1;const $=l.usage?3:l.error?2:0;o=Math.min(o,$)}this.g=o}get sendErrorTelemetry(){return this.h}get telemetryLevel(){return this.g}dispose(){this.i.dispose()}n(o,l,$){this.g<l||($=(0,N.$Wm)($,this.d),$=(0,h.$mo)($,this.j),$=(0,N.$Wm)($,this.c),this.b.forEach(b=>b.log(o,$)))}publicLog(o,l){this.n(o,3,l)}publicLog2(o,l){this.publicLog(o,l)}publicLogError(o,l){this.h&&this.n(o,2,l)}publicLogError2(o,l){this.publicLogError(o,l)}};e.$Nq=d,e.$Nq=d=ye([X(1,R.$6h),X(2,P.$ij)],d);function w(){const f=(0,A.localize)(0,null,m.default.nameLong),o=m.default.privacyStatementUrl?(0,A.localize)(2,null,"https://aka.ms/vscode-telemetry",m.default.privacyStatementUrl):(0,A.localize)(1,null,"https://aka.ms/vscode-telemetry"),l=O.$o?"":(0,A.localize)(3,null),$=(0,A.localize)(4,null),b=(0,A.localize)(5,null),I=(0,A.localize)(6,null),t=(0,A.localize)(7,null),c=`
|       | ${$} | ${b} | ${I} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,s=(0,A.localize)(8,null);return`
${f} ${o} ${l}

&nbsp;

${t}
${c}

&nbsp;

${s}
`}p.$6m.as(k.$$m.Configuration).registerConfiguration({id:g.$al,order:1,type:"object",title:(0,A.localize)(9,null),properties:{[g.$bl]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,A.localize)(10,null),(0,A.localize)(11,null),(0,A.localize)(12,null),(0,A.localize)(13,null)],markdownDescription:w(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),p.$6m.as(k.$$m.Configuration).registerConfiguration({id:g.$al,order:110,type:"object",title:(0,A.localize)(14,null),properties:{[g.$dl]:{type:"boolean",markdownDescription:m.default.privacyStatementUrl?(0,A.localize)(16,null,m.default.nameLong,m.default.privacyStatementUrl):(0,A.localize)(15,null,m.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,A.localize)(17,null,`\`#${g.$bl}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(re[226],oe([0,1,14,26,271,225]),function(te,e,L,N,O,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6M=void 0;async function A(P,p){const g=await p.request(P,N.CancellationToken.None),h=(await(0,L.$Tc)(g.stream)).toString(),d=g.res.statusCode??200;return{headers:g.res.headers,statusCode:d,responseData:h}}async function R(P){const p={method:P.type,headers:P.headers};return new Promise((h,d)=>{const w=O.request(P.url??"",p,f=>{f.on("data",function(o){h({headers:f.headers,statusCode:f.statusCode??200,responseData:o.toString()})}),f.on("error",function(o){d(o)})});w.write(P.data,f=>{f&&d(f)}),w.end()})}async function k(P,p,g){const h=typeof p.data=="string"?p.data:new TextDecoder().decode(p.data),d={type:"POST",headers:{...p.headers,"Content-Type":"application/json","Content-Length":Buffer.byteLength(p.data).toString()},url:p.urlString,data:h};try{const w=P?await A(d,P):await R(d);g(w.statusCode,w.headers,w.responseData)}catch{g(0,{})}}class m extends j.$5M{constructor(p,g,h,d,w){const f={sendPOST:(o,l)=>{k(p,o,l)}};super(g,h,d,w,f)}}e.$6M=m}),define(re[227],oe([0,1,22,93,18,16,7,24,21,108,109,110]),function(te,e,L,N,O,j,A,R,k,m,P,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$g7b=void 0;let g=class{constructor(d,w,f,o,l,$){this.b=d,this.c=w,this.d=f,this.e=o,this.f=l,this.g=$,this.a=new Map}h(d){if(!this.a.has(d.id)){const w=Object.create(null);w["common.vscodemachineid"]=this.c.machineId,w["common.vscodesessionid"]=this.c.sessionId;const f=[d.id,JSON.stringify(w),d.aiKey],l=new N.$Pp(L.$4e.asFileUri("bootstrap-fork").fsPath,{serverName:"Debug Telemetry",timeout:1e3*60*5,args:f,env:{ELECTRON_RUN_AS_NODE:1,VSCODE_PIPE_LOGGING:"true",VSCODE_AMD_ENTRYPOINT:"vs/workbench/contrib/debug/node/telemetryApp"}}).getChannel("telemetryAppender"),$=[new m.$35b(l),new P.$s3b(this.d,this.e,this.f,this.g,`[${d.id}] `)];this.a.set(d.id,new p.$Nq({appenders:$,sendErrorTelemetry:d.sendErrorTelemetry},this.b,this.g))}return this.a.get(d.id)}publicLog(d,w,f){this.h(d).publicLog(w,f)}publicLogError(d,w,f){this.h(d).publicLogError(w,f)}};e.$g7b=g,e.$g7b=g=ye([X(0,O.$6h),X(1,k.$7k),X(2,A.$3i),X(3,A.$4i),X(4,j.$Gh),X(5,R.$ij)],g)}),define(re[76],oe([0,1,3,18,4,7]),function(te,e,L,N,O,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3z=e.$2z=e.$1z=e.$Zz=e.$Yz=e.$Xz=e.$Wz=e.$Vz=e.ProvidedOnAutoForward=e.$Uz=e.TunnelPrivacyId=e.TunnelProtocol=e.$Tz=e.$Sz=void 0,e.$Sz=(0,O.$zh)("tunnelService"),e.$Tz=(0,O.$zh)("sharedTunnelsService");var A;(function(f){f.Http="http",f.Https="https"})(A||(e.TunnelProtocol=A={}));var R;(function(f){f.ConstantPrivate="constantPrivate",f.Private="private",f.Public="public"})(R||(e.TunnelPrivacyId=R={}));function k(f){return!!f.forwardPort}e.$Uz=k;var m;(function(f){f[f.Notify=1]="Notify",f[f.OpenBrowser=2]="OpenBrowser",f[f.OpenPreview=3]="OpenPreview",f[f.Silent=4]="Silent",f[f.Ignore=5]="Ignore",f[f.OpenBrowserOnce=6]="OpenBrowserOnce"})(m||(e.ProvidedOnAutoForward=m={}));function P(f){if(f.scheme!=="http"&&f.scheme!=="https")return;const o=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(f.authority);if(o)return{address:o[1],port:+o[2]}}e.$Vz=P,e.$Wz=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function p(f){return e.$Wz.indexOf(f)>=0}e.$Xz=p,e.$Yz=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function g(f){return e.$Yz.indexOf(f)>=0}e.$Zz=g;function h(f,o,l,$){if(l===1)return!1;if(l===2&&g(o)){const b=/(\d+)\.(\d+)\.(\d+)/g.exec($);if(b?.length===4&&parseInt(b[1])>=18)return!1}return f<1024}e.$1z=h;class d{constructor(o,l,$){this.remoteAddress=o,this.localAddress=l,this.b=$,this.a=new L.$hc,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.$2z=d;let w=class{constructor(o,l){this.j=o,this.k=l,this.a=new L.$hc,this.onTunnelOpened=this.a.event,this.b=new L.$hc,this.onTunnelClosed=this.b.event,this.c=new L.$hc,this.onAddedTunnelProvider=this.c.event,this.e=new Map,this.g=!1,this.h=[],this.i=new Set}get hasTunnelProvider(){return!!this.f}get l(){const o=this.k.getValue("remote.localPortHost");return!o||o==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(o){return this.f=o,o?(this.c.fire(),{dispose:()=>{this.f=void 0,this.g=!1,this.h=[]}}):(this.g=!1,this.h=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(o){this.g=o.elevation,this.h=o.privacyOptions}get canElevate(){return this.g}get canChangePrivacy(){return this.h.length>0}get privacyOptions(){return this.h}get tunnels(){return this.m()}async m(){const o=[],l=Array.from(this.e.values());for(const $ of l){const b=Array.from($.values());for(const I of b){const t=await I.value;t&&typeof t!="string"&&o.push(t)}}return o}async dispose(){for(const o of this.e.values()){for(const{value:l}of o.values())await l.then($=>typeof $!="string"?$?.dispose():void 0);o.clear()}this.e.clear()}setEnvironmentTunnel(o,l,$,b,I){this.p(o,l,Promise.resolve({tunnelRemoteHost:o,tunnelRemotePort:l,localAddress:$,privacy:b,protocol:I,dispose:()=>Promise.resolve()}))}async getExistingTunnel(o,l){(g(o)||p(o))&&(o=e.$Wz[0]);const $=this.r(o,l);if($)return++$.refcount,$.value}openTunnel(o,l,$,b,I,t=!1,c,s){this.j.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${l}:${$} on local port ${I}.`);const n=this.f??o;if(!n)return;if(l||(l="localhost"),b||(b=this.l),this.f&&this.i.has($)){this.j.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const i=this.s(n,l,$,b,I,t,c,s);return i?i.then(r=>{if(r){if(typeof r=="string")return this.j.trace("ForwardedPorts: (TunnelService) The tunnel provider returned an error when creating the tunnel."),this.q(l,$),r}else{this.j.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.q(l,$);return}this.j.trace("ForwardedPorts: (TunnelService) New tunnel established.");const a=this.n(r);return(r.tunnelRemoteHost!==l||r.tunnelRemotePort!==$)&&this.j.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),c&&r.privacy!==c&&this.j.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this.a.fire(a),a}):(this.j.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),i)}n(o){return{tunnelRemotePort:o.tunnelRemotePort,tunnelRemoteHost:o.tunnelRemoteHost,tunnelLocalPort:o.tunnelLocalPort,localAddress:o.localAddress,privacy:o.privacy,protocol:o.protocol,dispose:async()=>{this.j.trace(`ForwardedPorts: (TunnelService) dispose request for ${o.tunnelRemoteHost}:${o.tunnelRemotePort} `);const l=this.e.get(o.tunnelRemoteHost);if(l){const $=l.get(o.tunnelRemotePort);$&&($.refcount--,await this.o(o.tunnelRemoteHost,o.tunnelRemotePort,$))}}}}async o(o,l,$){if($.refcount<=0){this.j.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${o}:${l}.`);const b=$.value.then(async I=>{I&&typeof I!="string"&&(await I.dispose(!0),this.b.fire({host:I.tunnelRemoteHost,port:I.tunnelRemotePort}))});return this.e.has(o)&&this.e.get(o).delete(l),b}}async closeTunnel(o,l){this.j.trace(`ForwardedPorts: (TunnelService) close request for ${o}:${l} `);const $=this.e.get(o);if($&&$.has(l)){const b=$.get(l);b.refcount=0,await this.o(o,l,b)}}p(o,l,$){this.e.has(o)||this.e.set(o,new Map),this.e.get(o).set(l,{refcount:1,value:$})}async q(o,l){const $=this.e.get(o);if($){const b=$.get(l),I=b?await b.value:void 0;(!I||typeof I=="string")&&$.delete(l),$.size===0&&this.e.delete(o)}}r(o,l){const $=[o];p(o)?($.push(...e.$Wz),$.push(...e.$Yz)):g(o)&&$.push(...e.$Yz);const b=$.map(I=>this.e.get(I));for(const I of b){const t=I?.get(l);if(t)return t}}canTunnel(o){return!!P(o)}t(o,l,$,b,I,t,c){this.j.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${l}:${$} on local port ${b}.`);const s=$;this.i.add(s);const n=b===void 0?$:b,i={elevationRequired:I?this.isPortPrivileged(n):!1},r={remoteAddress:{host:l,port:$},localAddressPort:b,privacy:t,public:t?t!==R.Private:void 0,protocol:c},a=o.forwardPort(r,i);return a?(this.p(l,$,a),a.finally(()=>{this.j.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.i.delete(s)})):this.i.delete(s),a}};e.$3z=w,e.$3z=w=ye([X(0,j.$3i),X(1,N.$6h)],w)}),define(re[228],oe([0,1,7,76,2,8,5]),function(te,e,L,N,O,j,A){"use strict";var R;Object.defineProperty(e,"__esModule",{value:!0}),e.$t7b=void 0;class k extends O.$mb{constructor(){super(),this.a=null,this.b=null}async getAddress(){return this.a?this.a:(this.b||(this.b=new A.$Zg),this.b.p)}setAddress(p){this.a=p,this.b&&(this.b.complete(p),this.b=null)}setTunnel(p){this.B(p)}}let m=class extends O.$mb{static{R=this}static{this.a=0}constructor(p,g){super(),this.f=p,this.g=g,this.b=new Map,this.c=new Set}dispose(){super.dispose(),this.b.forEach(p=>p.dispose())}async createTunnel(){return{id:String(++R.a)}}async startTunnel(p,g,h,d,w,f,o){const l=new k,$=await Promise.resolve(this.f.openTunnel(p,l,h,d,w,f,o));if(!$||typeof $=="string")throw this.g.info(`[SharedProcessTunnelService] Could not create a tunnel to ${h}:${d} (remote).`),l.dispose(),new Error("Could not create tunnel");if(this.c.has(g))throw this.c.delete(g),l.dispose(),await $.dispose(),(0,j.$4)();return l.setTunnel($),this.b.set(g,l),this.g.info(`[SharedProcessTunnelService] Created tunnel ${g}: ${$.localAddress} (local) to ${h}:${d} (remote).`),{tunnelLocalPort:$.tunnelLocalPort,localAddress:$.localAddress}}async setAddress(p,g){const h=this.b.get(p);h&&h.setAddress(g)}async destroyTunnel(p){const g=this.b.get(p);if(g){this.g.info(`[SharedProcessTunnelService] Disposing tunnel ${p}.`),this.b.delete(p),await g.dispose();return}this.c.add(p)}};e.$t7b=m,e.$t7b=m=R=ye([X(0,N.$Tz),X(1,L.$3i)],m)}),define(re[27],oe([0,1,4]),function(te,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ak=void 0,e.$Ak=(0,L.$zh)("IUriIdentityService")}),define(re[229],oe([0,1,27,184,13,23,127,3,2]),function(te,e,L,N,O,j,A,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mr=void 0;class m{static{this._clock=0}constructor(g){this.uri=g,this.time=m._clock++}touch(){return this.time=m._clock++,this}}let P=class{constructor(g){this.g=g,this.c=new k.$lb,this.f=2**16;const h=new Map,d=w=>{let f=h.get(w.scheme);return f===void 0&&(f=g.hasProvider(w)&&!this.g.hasCapability(w,1024),h.set(w.scheme,f)),f};this.c.add(R.Event.any(g.onDidChangeFileSystemProviderRegistrations,g.onDidChangeFileSystemProviderCapabilities)(w=>{h.delete(w.scheme)})),this.extUri=new j.$8f(d),this.d=new A.$lr((w,f)=>this.extUri.compare(w,f,!0),this.f)}dispose(){this.c.dispose(),this.d.clear()}asCanonicalUri(g){this.g.hasProvider(g)&&(g=(0,j.$hg)(g));const h=this.d.get(g);return h?h.touch().uri.with({fragment:g.fragment}):(this.d.set(g,new m(g)),this.h(),g)}h(){if(this.d.size<this.f)return;const g=[...this.d.entries()].sort((d,w)=>d[1].time<w[1].time?1:d[1].time>w[1].time?-1:0);m._clock=0,this.d.clear();const h=this.f*.5;for(let d=0;d<h;d++)this.d.set(g[d][0],g[d][1].touch())}};e.$mr=P,e.$mr=P=ye([X(0,O.$4j)],P),(0,N.$jr)(L.$Ak,P,1)}),define(re[230],oe([0,1,3,2,13,42,47,14,9]),function(te,e,L,N,O,j,A,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$N6b=void 0;class m extends N.$mb{get capabilities(){return this.f.capabilities&-5}constructor(p,g,h,d){super(),this.c=p,this.f=g,this.g=h,this.h=d,this.onDidChangeCapabilities=this.f.onDidChangeCapabilities,this.a=this.B(new L.$hc),this.onDidChangeFile=this.a.event,this.b=A.$Fh.forUris(()=>!(this.capabilities&1024)),this.B(this.f.onDidChangeFile(w=>this.i(w)))}watch(p,g){this.b.set(p,p);const h=this.f.watch(this.j(p),g);return(0,N.$kb)(()=>{this.b.delete(p),h.dispose()})}stat(p){return this.f.stat(this.j(p))}mkdir(p){return this.f.mkdir(this.j(p))}rename(p,g,h){return this.f.rename(this.j(p),this.j(g),h)}readFile(p){return this.f.readFile(this.j(p),{atomic:!0})}readFileStream(p,g,h){const d=(0,j.$vc)(w=>R.$Hc.concat(w.map(f=>R.$Hc.wrap(f))).buffer);return(async()=>{try{const w=await this.readFile(p);d.end(w)}catch(w){d.error(w),d.end()}})(),d}readdir(p){return this.f.readdir(this.j(p))}writeFile(p,g,h){return!(0,k.$ne)(h.atomic)&&(0,O.$_j)(this.f)&&(h={...h,atomic:{postfix:".vsctmp"}}),this.f.writeFile(this.j(p),g,h)}delete(p,g){return this.f.delete(this.j(p),g)}copy(p,g,h){if((0,O.$7j)(this.f))return this.f.copy(this.j(p),this.j(g),h);throw new Error("copy not supported")}i(p){const g=[];for(const h of p){if(h.resource.scheme!==this.c)continue;const d=this.k(h.resource);this.b.findSubstr(d)&&g.push({resource:d,type:h.type})}g.length&&(this.h.debug("User data changed"),this.a.fire(g))}j(p){return p.with({scheme:this.c})}k(p){return p.with({scheme:this.g})}}e.$N6b=m}),define(re[77],oe([0,1,85]),function(te,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qzb=e.$pzb=e.edit=void 0;function N(A,R,k,m){const P=(0,L.$rS)(A,R,k,m)[0];return P&&(A=A.substring(0,P.offset)+P.content+A.substring(P.offset+P.length)),A}e.edit=N;function O(A,R,k){let m=k;for(;m>=0;){if(A.charAt(m)===R.charAt(R.length-1)&&R.length===1)return m+1;if(m--,R.length===2&&m>=0&&A.charAt(m)===R.charAt(0))return m+2}return 0}e.$pzb=O;function j(A,R,k){let m=k;for(;m>=0;)if(A.charAt(m)===R.charAt(R.length-1)&&R.length===1||(m++,R.length===2&&m>=0&&A.charAt(m)===R.charAt(1)))return m;return A.length-1}e.$qzb=j}),define(re[231],oe([0,1,30,53,9]),function(te,e,L,N,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$a2b=void 0;function j(h,d,w,f,o,l){const $=[],b=[],I=[];if(!d){const W=h.filter(({identifier:Z})=>o.every(Y=>Y.toLowerCase()!==Z.id.toLowerCase()));return{local:{added:$,removed:b,updated:I},remote:W.length>0?{added:W,updated:[],removed:[],all:W}:null}}h=h.map(p),d=d.map(p),w=w?w.map(p):null;const t=new Map,c=W=>{W.uuid&&t.set(W.id.toLowerCase(),W.uuid)};h.forEach(({identifier:W})=>c(W)),d.forEach(({identifier:W})=>c(W)),w?.forEach(({identifier:W})=>c(W));const s=W=>{const Z=W.identifier.uuid||t.get(W.identifier.id.toLowerCase());return Z?`uuid:${Z}`:`id:${W.identifier.id.toLowerCase()}`},n=(W,Z)=>(W.set(s(Z),Z),W),i=h.reduce(n,new Map),r=d.reduce(n,new Map),a=d.reduce((W,Z)=>n(W,(0,L.$Tm)(Z)),new Map),v=w?w.reduce(n,new Map):null,y=f.reduce(n,new Map),u=o.reduce((W,Z)=>{const Y=t.get(Z.toLowerCase());return W.add(Y?`uuid:${Y}`:`id:${Z.toLowerCase()}`)},new Set),E=l?l.reduce((W,{id:Z,uuid:Y})=>(Y=Y??t.get(Z.toLowerCase()),W.add(Y?`uuid:${Y}`:`id:${Z.toLowerCase()}`)),new Set):null,D=A(i,r,u,!1);if(D.added.size>0||D.removed.size>0||D.updated.size>0){const W=A(v,i,u,!1),Z=A(v,r,u,!0),Y=(x,G,Q,H)=>{let V,B,ee;return G.installed?(V=H.pinned,ee=H.preRelease,V&&(B=H.version)):(V=Q.pinned,ee=Q.preRelease,V&&(B=Q.version)),V===void 0&&(V=G.pinned,V&&(B=G.version)),ee===void 0&&(ee=G.preRelease),{...H,installed:G.installed||Q.installed,pinned:V,preRelease:ee,version:B??(Q.version&&(!G.installed||N.gt(Q.version,G.version))?Q.version:G.version),state:k(G,Q,v?.get(x))}};for(const x of Z.removed.values()){const G=i.get(x);if(!G)continue;const Q=(0,O.$we)(v?.get(x)),H=E&&!E.has(x)&&Q.installed;G.installed&&H?b.push(G.identifier):a.set(x,G)}for(const x of Z.added.values()){const G=(0,O.$we)(r.get(x)),Q=i.get(x);if(Q){if(D.updated.has(x)){const H=Y(x,Q,G,G);R(Q,G,!1,!1)||I.push(g(H,x)),a.set(x,H)}}else G.installed&&$.push(g(G,x))}for(const x of Z.updated.values()){const G=(0,O.$we)(r.get(x)),Q=(0,O.$we)(v?.get(x)),H=i.get(x);if(H)if(E&&!E.has(x)&&Q.installed&&H.installed&&!G.installed)b.push(H.identifier);else{const B=Y(x,H,G,G);I.push(g(B,x)),a.set(x,B)}else G.installed&&$.push(g(G,x))}for(const x of W.added.values())Z.added.has(x)||a.set(x,(0,O.$we)(i.get(x)));for(const x of W.updated.values()){if(Z.removed.has(x)||Z.updated.has(x))continue;const G=(0,O.$we)(i.get(x)),Q=(0,O.$we)(r.get(x));a.set(x,Y(x,G,Q,G))}for(const x of W.removed.values())Z.updated.has(x)||Z.removed.has(x)||y.has(x)||(0,O.$we)(r.get(x)).installed&&E&&(E.has(x)||!(0,O.$we)(v?.get(x)).installed||a.delete(x))}const T=[],F=A(r,a,new Set,!0),q=F.added.size>0||F.updated.size>0||F.removed.size>0;return q&&a.forEach((W,Z)=>T.push(g(W,Z))),{local:{added:$,removed:b,updated:I},remote:q?{added:[...F.added].map(W=>a.get(W)),updated:[...F.updated].map(W=>a.get(W)),removed:[...F.removed].map(W=>r.get(W)),all:T}:null}}e.$a2b=j;function A(h,d,w,f){const o=h?[...h.keys()].filter(t=>!w.has(t)):[],l=[...d.keys()].filter(t=>!w.has(t)),$=l.filter(t=>!o.includes(t)).reduce((t,c)=>(t.add(c),t),new Set),b=o.filter(t=>!l.includes(t)).reduce((t,c)=>(t.add(c),t),new Set),I=new Set;for(const t of o){if(b.has(t))continue;const c=h.get(t),s=d.get(t);(!s||!R(c,s,f,!0))&&I.add(t)}return{added:$,removed:b,updated:I}}function R(h,d,w,f){return!(h.disabled!==d.disabled||!!h.isApplicationScoped!=!!d.isApplicationScoped||f&&h.installed!==d.installed||h.installed&&d.installed&&(h.preRelease!==d.preRelease||h.pinned!==d.pinned||d.pinned&&h.version!==d.version)||!P(h.state,d.state)||w&&h.version!==d.version)}function k(h,d,w){const f=h.state,o=d.state,l=w?.state;if(!d.version||f&&N.gt(h.version,d.version))return f;if(o&&N.gt(d.version,h.version)||!f)return o;if(!o)return f;const $=(0,L.$Tm)(f),b=l?m(l,o):{added:Object.keys(o).reduce((t,c)=>(t.add(c),t),new Set),removed:new Set,updated:new Set},I=l?m(l,f):{added:Object.keys(f).reduce((t,c)=>(t.add(c),t),new Set),removed:new Set,updated:new Set};for(const t of[...b.added.values(),...b.updated.values()])$[t]=o[t];for(const t of b.removed.values())I.updated.has(t)||delete $[t];return $}function m(h,d){const w=Object.keys(h),f=Object.keys(d),o=f.filter(b=>!w.includes(b)).reduce((b,I)=>(b.add(I),b),new Set),l=w.filter(b=>!f.includes(b)).reduce((b,I)=>(b.add(I),b),new Set),$=new Set;for(const b of w){if(l.has(b))continue;const I=h[b],t=d[b];(0,L.$Xm)(I,t)||$.add(b)}return{added:o,removed:l,updated:$}}function P(h={},d={}){const{added:w,removed:f,updated:o}=m(h,d);return w.size===0&&f.size===0&&o.size===0}function p(h){return{...h,disabled:!!h.disabled,installed:!!h.installed}}function g(h,d){const w={...h,identifier:{id:h.identifier.id,uuid:d.startsWith("uuid:")?d.substring(5):void 0},preRelease:!!h.preRelease,pinned:!!h.pinned};return h.disabled||delete w.disabled,h.installed||delete w.installed,h.state||delete w.state,h.isApplicationScoped||delete w.isApplicationScoped,w}}),define(re[111],oe([0,1,20,18,4]),function(te,e,L,N,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nBb=e.$mBb=void 0,e.$mBb=(0,O.$zh)("IIgnoredExtensionsManagementService");let j=class{constructor(R){this.a=R}hasToNeverSyncExtension(R){return this.b().includes(R.toLowerCase())}hasToAlwaysSyncExtension(R){return this.b().includes(`-${R.toLowerCase()}`)}updateIgnoredExtensions(R,k){let m=[...this.a.getValue("settingsSync.ignoredExtensions")].map(P=>P.toLowerCase());return m=m.filter(P=>P!==R&&P!==`-${R}`),k&&m.push(R.toLowerCase()),this.a.updateValue("settingsSync.ignoredExtensions",m.length?m:void 0,2)}updateSynchronizedExtensions(R,k){let m=[...this.a.getValue("settingsSync.ignoredExtensions")].map(P=>P.toLowerCase());return m=m.filter(P=>P!==R&&P!==`-${R}`),k&&m.push(`-${R.toLowerCase()}`),this.a.updateValue("settingsSync.ignoredExtensions",m.length?m:void 0,2)}getIgnoredExtensions(R){const k=R.filter(g=>g.isMachineScoped).map(g=>g.identifier.id.toLowerCase()),m=this.b().map(g=>g.toLowerCase()),P=[],p=[];if(Array.isArray(m))for(const g of m)g.startsWith("-")?p.push(g.substring(1)):P.push(g);return(0,L.$Ff)([...k,...P].filter(g=>!p.includes(g)))}b(){let R=this.a.inspect("settingsSync.ignoredExtensions").userValue;return R!==void 0||(R=this.a.inspect("sync.ignoredExtensions").userValue,R!==void 0)?R:(this.a.getValue("settingsSync.ignoredExtensions")||[]).map(k=>k.toLowerCase())}};e.$nBb=j,e.$nBb=j=ye([X(0,N.$6h)],j)}),define(re[232],oe([0,1,20,34,30,94,77]),function(te,e,L,N,O,j,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$g2b=void 0;function R(b){return(0,N.$Jm)(b)||[]}async function k(b,I,t,c,s){const n=R(b),i=R(I),r=t?R(t):null,a=[...n,...i,...r||[]].map(Y=>Y.key),v=await s.resolveUserBindings(a),y=P(n,i,r,v);if(!y.hasLocalForwarded&&!y.hasRemoteForwarded)return{mergeContent:b,hasChanges:!1,hasConflicts:!1};if(!y.hasLocalForwarded&&y.hasRemoteForwarded)return{mergeContent:I,hasChanges:!0,hasConflicts:!1};if(y.hasLocalForwarded&&!y.hasRemoteForwarded)return{mergeContent:b,hasChanges:!0,hasConflicts:!1};const u=g(n),E=g(i),D=r?g(r):null,T=d(u,E,v),F=D?d(D,u,v):{added:[...u.keys()].reduce((Y,x)=>(Y.add(x),Y),new Set),removed:new Set,updated:new Set},q=D?d(D,E,v):{added:[...E.keys()].reduce((Y,x)=>(Y.add(x),Y),new Set),removed:new Set,updated:new Set},W=m(T,F,q);let Z=b;for(const Y of W.removed.values())W.conflicts.has(Y)||(Z=l(Z,Y,c));for(const Y of W.added.values()){if(W.conflicts.has(Y))continue;const x=E.get(Y);if(x.some(G=>G.command!==`-${Y}`&&y.conflicts.has(v[G.key]))){W.conflicts.add(Y);continue}Z=o(Z,x,c)}for(const Y of W.updated.values()){if(W.conflicts.has(Y))continue;const x=E.get(Y);if(x.some(G=>G.command!==`-${Y}`&&y.conflicts.has(v[G.key]))){W.conflicts.add(Y);continue}Z=$(Z,Y,x,c)}return{mergeContent:Z,hasChanges:!0,hasConflicts:W.conflicts.size>0}}e.$g2b=k;function m(b,I,t){const c=new Set,s=new Set,n=new Set,i=new Set;for(const r of I.removed.values())t.updated.has(r)&&i.add(r);for(const r of t.removed.values())i.has(r)||(I.updated.has(r)?i.add(r):s.add(r));for(const r of I.added.values())i.has(r)||t.added.has(r)&&b.updated.has(r)&&i.add(r);for(const r of t.added.values())i.has(r)||(I.added.has(r)?b.updated.has(r)&&i.add(r):c.add(r));for(const r of I.updated.values())i.has(r)||t.updated.has(r)&&b.updated.has(r)&&i.add(r);for(const r of t.updated.values())i.has(r)||(I.updated.has(r)?b.updated.has(r)&&i.add(r):n.add(r));return{added:c,removed:s,updated:n,conflicts:i}}function P(b,I,t,c){const s=new Set,n=p(b,c),i=p(I,c),r=t?p(t,c):null,a=h(n,i);if(a.added.size===0&&a.removed.size===0&&a.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!1,added:s,removed:s,updated:s,conflicts:s};const v=r?h(r,n):{added:[...n.keys()].reduce((F,q)=>(F.add(q),F),new Set),removed:new Set,updated:new Set};if(v.added.size===0&&v.removed.size===0&&v.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!0,added:s,removed:s,updated:s,conflicts:s};const y=r?h(r,i):{added:[...i.keys()].reduce((F,q)=>(F.add(q),F),new Set),removed:new Set,updated:new Set};if(y.added.size===0&&y.removed.size===0&&y.updated.size===0)return{hasLocalForwarded:!0,hasRemoteForwarded:!1,added:s,removed:s,updated:s,conflicts:s};const{added:u,removed:E,updated:D,conflicts:T}=m(a,v,y);return{hasLocalForwarded:!0,hasRemoteForwarded:!0,added:u,removed:E,updated:D,conflicts:T}}function p(b,I){const t=new Map;for(const c of b){const s=I[c.key];let n=t.get(s);n||(n=[],t.set(s,n)),n.push(c)}return t}function g(b){const I=new Map;for(const t of b){const c=t.command[0]==="-"?t.command.substring(1):t.command;let s=I.get(c);s||(s=[],I.set(c,s)),s.push(t)}return I}function h(b,I){const t=[...b.keys()],c=[...I.keys()],s=c.filter(r=>!t.includes(r)).reduce((r,a)=>(r.add(a),r),new Set),n=t.filter(r=>!c.includes(r)).reduce((r,a)=>(r.add(a),r),new Set),i=new Set;for(const r of t){if(n.has(r))continue;const a=b.get(r).map(y=>({...y,key:r})),v=I.get(r).map(y=>({...y,key:r}));(0,L.$of)(a,v,(y,u)=>f(y,u))||i.add(r)}return{added:s,removed:n,updated:i}}function d(b,I,t){const c=[...b.keys()],s=[...I.keys()],n=s.filter(a=>!c.includes(a)).reduce((a,v)=>(a.add(v),a),new Set),i=c.filter(a=>!s.includes(a)).reduce((a,v)=>(a.add(v),a),new Set),r=new Set;for(const a of c){if(i.has(a))continue;const v=b.get(a).map(u=>({...u,key:t[u.key]})),y=I.get(a).map(u=>({...u,key:t[u.key]}));w(v,y)||r.add(a)}return{added:n,removed:i,updated:r}}function w(b,I){return!(!(0,L.$of)(b.filter(({command:t})=>t[0]!=="-"),I.filter(({command:t})=>t[0]!=="-"),(t,c)=>f(t,c))||!(0,L.$of)(b.filter(({command:t})=>t[0]==="-"),I.filter(({command:t})=>t[0]==="-"),(t,c)=>f(t,c)))}function f(b,I){if(b.command!==I.command||b.key!==I.key)return!1;const t=j.$Gi.deserialize(b.when),c=j.$Gi.deserialize(I.when);return!(t&&!c||!t&&c||t&&c&&!t.equals(c)||!O.$Xm(b.args,I.args))}function o(b,I,t){for(const c of I)b=A.edit(b,[-1],c,t);return b}function l(b,I,t){const c=R(b);for(let s=c.length-1;s>=0;s--)(c[s].command===I||c[s].command===`-${I}`)&&(b=A.edit(b,[s],void 0,t));return b}function $(b,I,t,c){const s=R(b),n=s.findIndex(i=>i.command===I||i.command===`-${I}`);for(let i=s.length-1;i>=0;i--)(s[i].command===I||s[i].command===`-${I}`)&&(b=A.edit(b,[i],void 0,c));for(let i=t.length-1;i>=0;i--)b=A.edit(b,[n],t[i],c);return b}}),define(re[233],oe([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$o2b=e.$n2b=void 0;function L(j,A,R){const k={},m={},P=new Set;if(!A)return{local:{added:k,updated:m,removed:[...P.values()]},remote:{added:j,updated:{},removed:[]},conflicts:[]};const p=N(j,A);if(p.added.size===0&&p.removed.size===0&&p.updated.size===0)return{local:{added:k,updated:m,removed:[...P.values()]},remote:{added:{},updated:{},removed:[]},conflicts:[]};const g=N(R,j),h=N(R,A),d={},w={},f=new Set,o=new Set;for(const l of g.removed.values())h.updated.has(l)?k[l]=A[l]:f.add(l);for(const l of h.removed.values())o.has(l)||(g.updated.has(l)?o.add(l):P.add(l));for(const l of g.updated.values())o.has(l)||(h.updated.has(l)?p.updated.has(l)&&o.add(l):w[l]=j[l]);for(const l of h.updated.values())o.has(l)||(g.updated.has(l)?p.updated.has(l)&&o.add(l):j[l]!==void 0&&(m[l]=A[l]));for(const l of g.added.values())o.has(l)||(h.added.has(l)?p.updated.has(l)&&o.add(l):d[l]=j[l]);for(const l of h.added.values())o.has(l)||(g.added.has(l)?p.updated.has(l)&&o.add(l):k[l]=A[l]);return{local:{added:k,removed:[...P.values()],updated:m},remote:{added:d,removed:[...f.values()],updated:w},conflicts:[...o.values()]}}e.$n2b=L;function N(j,A){const R=j?Object.keys(j):[],k=A?Object.keys(A):[],m=k.filter(g=>!R.includes(g)).reduce((g,h)=>(g.add(h),g),new Set),P=R.filter(g=>!k.includes(g)).reduce((g,h)=>(g.add(h),g),new Set),p=new Set;for(const g of R){if(P.has(g))continue;const h=j[g],d=A[g];h!==d&&p.add(g)}return{added:m,removed:P,updated:p}}function O(j,A){const{added:R,removed:k,updated:m}=N(j,A);return R.size===0&&k.size===0&&m.size===0}e.$o2b=O}),define(re[234],oe([0,1,30]),function(te,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$83b=void 0;function N(j,A,R,k){const m={added:[],removed:[],updated:[]};let P={added:[],removed:[],updated:[]};if(!A){const g=j.filter(({id:h})=>!k.includes(h));return g.length?P.added=g:P=null,{local:m,remote:P}}const p=O(j,A,k);if(p.added.length>0||p.removed.length>0||p.updated.length>0){const g=O(R,j,k),h=O(R,A,k);for(const d of h.removed){const w=j.find(f=>f.id===d);w&&m.removed.push(w)}for(const d of h.added){const w=A.find(f=>f.id===d);g.added.includes(d)?p.updated.includes(d)&&m.updated.push(w):m.added.push(w)}for(const d of h.updated)m.updated.push(A.find(w=>w.id===d));for(const d of g.added)h.added.includes(d)||P.added.push(j.find(w=>w.id===d));for(const d of g.updated)h.removed.includes(d)||h.updated.includes(d)||P.updated.push(j.find(w=>w.id===d));for(const d of g.removed){const w=A.find(f=>f.id===d);w&&P.removed.push(w)}}return P.added.length===0&&P.removed.length===0&&P.updated.length===0&&(P=null),{local:m,remote:P}}e.$83b=N;function O(j,A,R){j=j?j.filter(({id:h})=>!R.includes(h)):[],A=A.filter(({id:h})=>!R.includes(h));const k=j.map(({id:h})=>h),m=A.map(({id:h})=>h),P=m.filter(h=>!k.includes(h)),p=k.filter(h=>!m.includes(h)),g=[];for(const{id:h,name:d,shortName:w,useDefaultFlags:f}of j){if(p.includes(h))continue;const o=A.find(l=>l.id===h);(!o||o.name!==d||o.shortName!==w||!(0,L.$Xm)(o.useDefaultFlags,f))&&g.push(h)}return{added:P,removed:p,updated:g}}}),define(re[25],oe([0,1,20,9,173,49,29,4,103,40]),function(te,e,L,N,O,j,A,R,k,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ygb=e.$xgb=e.$wgb=e.$vgb=e.$ugb=e.$tgb=e.$sgb=e.$rgb=e.$qgb=e.$pgb=e.$ogb=e.MergeState=e.Change=e.SyncStatus=e.$ngb=e.$mgb=e.$lgb=e.UserDataSyncErrorCode=e.$kgb=e.$jgb=e.$igb=e.$hgb=e.$ggb=e.$fgb=e.$egb=e.$dgb=e.$cgb=e.SyncResource=e.$bgb=e.$agb=e.$_fb=e.$$fb=e.$0fb=e.$9fb=void 0;function P(){const i=m.$6m.as(j.$$m.Configuration).getConfigurationProperties();return Object.keys(i).filter(r=>!!i[r].disallowSyncIgnore)}e.$9fb=P;function p(){const i=m.$6m.as(j.$$m.Configuration).getConfigurationProperties(),r=Object.keys(i).filter(y=>!!i[y].ignoreSync),a=Object.keys(i).filter(y=>i[y].scope===2||i[y].scope===6),v=P();return(0,L.$Ff)([...r,...a,...v])}e.$0fb=p,e.$$fb="settingsSync",e.$_fb="settingsSync.keybindingsPerPlatform";function g(){const i="vscode://schemas/ignoredSettings",r=m.$6m.as(j.$$m.Configuration);r.registerConfiguration({id:"settingsSync",order:30,title:(0,O.localize)(0,null),type:"object",properties:{[e.$_fb]:{type:"boolean",description:(0,O.localize)(1,null),default:!0,scope:1,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredExtensions":{type:"array",markdownDescription:(0,O.localize)(2,null),items:[{type:"string",pattern:A.$Kn,errorMessage:(0,O.localize)(3,null)}],default:[],scope:1,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredSettings":{type:"array",description:(0,O.localize)(4,null),default:[],scope:1,$ref:i,additionalProperties:!0,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]}}});const a=m.$6m.as(k.$7m.JSONContribution),v=()=>{const y=P(),u=p(),E=Object.keys(j.$_m.properties).filter(F=>!u.includes(F)),D=u.filter(F=>!y.includes(F)),T={items:{type:"string",enum:[...E,...D.map(F=>`-${F}`)]}};a.registerSchema(i,T)};return r.onDidUpdateConfiguration(()=>v())}e.$agb=g;function h(i){return i&&(0,N.$ne)(i)&&(0,N.$le)(i.id)&&Array.isArray(i.scopes)}e.$bgb=h;var d;(function(i){i.Settings="settings",i.Keybindings="keybindings",i.Snippets="snippets",i.Tasks="tasks",i.Extensions="extensions",i.GlobalState="globalState",i.Profiles="profiles",i.WorkspaceState="workspaceState"})(d||(e.SyncResource=d={})),e.$cgb=["settings","keybindings","snippets","tasks","extensions","globalState","profiles"];function w(i,...r){return i?[i,...r]:r}e.$dgb=w;function f(i,r,a,v){return v.joinPath(a.userDataSyncHome,...w(i,r,`lastSync${r}.json`))}e.$egb=f,e.$fgb=(0,R.$zh)("IUserDataSyncStoreManagementService"),e.$ggb=(0,R.$zh)("IUserDataSyncStoreService"),e.$hgb=(0,R.$zh)("IUserDataSyncBackupStoreService"),e.$igb="x-operation-id",e.$jgb="X-Execution-Id";function o(i){const r={};return r[e.$jgb]=i,r}e.$kgb=o;var l;(function(i){i.Unauthorized="Unauthorized",i.Forbidden="Forbidden",i.NotFound="NotFound",i.MethodNotFound="MethodNotFound",i.Conflict="Conflict",i.Gone="Gone",i.PreconditionFailed="PreconditionFailed",i.TooLarge="TooLarge",i.UpgradeRequired="UpgradeRequired",i.PreconditionRequired="PreconditionRequired",i.TooManyRequests="RemoteTooManyRequests",i.TooManyRequestsAndRetryAfter="TooManyRequestsAndRetryAfter",i.RequestFailed="RequestFailed",i.RequestCanceled="RequestCanceled",i.RequestTimeout="RequestTimeout",i.RequestProtocolNotSupported="RequestProtocolNotSupported",i.RequestPathNotEscaped="RequestPathNotEscaped",i.RequestHeadersNotObject="RequestHeadersNotObject",i.NoCollection="NoCollection",i.NoRef="NoRef",i.EmptyResponse="EmptyResponse",i.TurnedOff="TurnedOff",i.SessionExpired="SessionExpired",i.ServiceChanged="ServiceChanged",i.DefaultServiceChanged="DefaultServiceChanged",i.LocalTooManyProfiles="LocalTooManyProfiles",i.LocalTooManyRequests="LocalTooManyRequests",i.LocalPreconditionFailed="LocalPreconditionFailed",i.LocalInvalidContent="LocalInvalidContent",i.LocalError="LocalError",i.IncompatibleLocalContent="IncompatibleLocalContent",i.IncompatibleRemoteContent="IncompatibleRemoteContent",i.Unknown="Unknown"})(l||(e.UserDataSyncErrorCode=l={}));class $ extends Error{constructor(r,a,v,y){super(r),this.code=a,this.resource=v,this.operationId=y,this.name=`${this.code} (UserDataSyncError) syncResource:${this.resource||"unknown"} operationId:${this.operationId||"unknown"}`}}e.$lgb=$;class b extends ${constructor(r,a,v,y,u){super(r,v,void 0,u),this.url=a,this.serverCode=y}}e.$mgb=b;class I extends ${constructor(r,a){super(r,a)}}e.$ngb=I,function(i){function r(a){if(a instanceof i)return a;const v=/^(.+) \(UserDataSyncError\) syncResource:(.+) operationId:(.+)$/.exec(a.name);if(v&&v[1]){const y=v[2]==="unknown"?void 0:v[2],u=v[3]==="unknown"?void 0:v[3];return new i(a.message,v[1],y,u)}return new i(a.message,"Unknown")}i.toUserDataSyncError=r}($||(e.$lgb=$={}));var t;(function(i){i.Uninitialized="uninitialized",i.Idle="idle",i.Syncing="syncing",i.HasConflicts="hasConflicts"})(t||(e.SyncStatus=t={}));var c;(function(i){i[i.None=0]="None",i[i.Added=1]="Added",i[i.Modified=2]="Modified",i[i.Deleted=3]="Deleted"})(c||(e.Change=c={}));var s;(function(i){i.Preview="preview",i.Conflict="conflict",i.Accepted="accepted"})(s||(e.MergeState=s={})),e.$ogb="sync.store.url.type";function n(i){return`sync.enable.${i}`}e.$pgb=n,e.$qgb=(0,R.$zh)("IUserDataSyncEnablementService"),e.$rgb=(0,R.$zh)("IUserDataSyncService"),e.$sgb=(0,R.$zh)("IUserDataSyncResourceProviderService"),e.$tgb=(0,R.$zh)("IUserDataAutoSyncService"),e.$ugb=(0,R.$zh)("IUserDataSyncUtilService"),e.$vgb=(0,R.$zh)("IUserDataSyncLogService"),e.$wgb="userDataSync",e.$xgb="vscode-userdata-sync",e.$ygb="preview"}),define(re[235],oe([0,1,30,25]),function(te,e,L,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$IAb=void 0;function O(A,R,k,m,P){if(!R)return{remote:{added:Object.keys(A),removed:[],updated:[],all:Object.keys(A).length>0?A:null},local:{added:{},removed:[],updated:{}}};const p=j(A,R);if(p.added.size===0&&p.removed.size===0&&p.updated.size===0)return{remote:{added:[],removed:[],updated:[],all:null},local:{added:{},removed:[],updated:{}}};const g=k?j(k,R):{added:Object.keys(R).reduce((l,$)=>(l.add($),l),new Set),removed:new Set,updated:new Set},h=k?j(k,A):{added:Object.keys(A).reduce((l,$)=>(l.add($),l),new Set),removed:new Set,updated:new Set},d={added:{},removed:[],updated:{}},w=L.$Tm(R),f=!k;for(const l of h.added.values())l!==N.$ogb&&f&&g.added.has(l)||(w[l]=A[l]);for(const l of h.updated.values())w[l]=A[l];for(const l of h.removed.values())m.unregistered.includes(l)||delete w[l];for(const l of g.added.values()){const $=R[l];if(m.machine.includes(l)){P.info(`GlobalState: Skipped adding ${l} in local storage because it is declared as machine scoped.`);continue}if(k&&h.added.has(l))continue;const b=A[l];b&&b.value===$.value||l===N.$ogb&&f&&h.added.has(l)||(b?d.updated[l]=$:d.added[l]=$)}for(const l of g.updated.values()){const $=R[l];if(m.machine.includes(l)){P.info(`GlobalState: Skipped updating ${l} in local storage because it is declared as machine scoped.`);continue}if(h.updated.has(l)||h.removed.has(l))continue;const b=A[l];b&&b.value===$.value||(d.updated[l]=$)}for(const l of g.removed.values()){if(m.machine.includes(l)){P.trace(`GlobalState: Skipped removing ${l} in local storage because it is declared as machine scoped.`);continue}h.updated.has(l)||h.removed.has(l)||d.removed.push(l)}const o=j(R,w);return{local:d,remote:{added:[...o.added],updated:[...o.updated],removed:[...o.removed],all:o.added.size===0&&o.removed.size===0&&o.updated.size===0?null:w}}}e.$IAb=O;function j(A,R){const k=Object.keys(A),m=Object.keys(R),P=m.filter(h=>!k.includes(h)).reduce((h,d)=>(h.add(d),h),new Set),p=k.filter(h=>!m.includes(h)).reduce((h,d)=>(h.add(d),h),new Set),g=new Set;for(const h of k){if(p.has(h))continue;const d=A[h],w=R[h];L.$Xm(d,w)||g.add(h)}return{added:P,removed:p,updated:g}}}),define(re[236],oe([0,1,20,34,85,41,30,77,25]),function(te,e,L,N,O,j,A,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wzb=e.$vzb=e.$uzb=e.$tzb=e.$szb=e.$rzb=void 0;function m(a,v,y){let u=[];y?u=p(y):u=P(v);const E=[],D=[...(0,k.$9fb)()];if(Array.isArray(u))for(const T of u)T.startsWith("-")?D.push(T.substring(1)):E.push(T);return(0,L.$Ff)([...a,...E].filter(T=>!D.includes(T)))}e.$rzb=m;function P(a){let v=a.inspect("settingsSync.ignoredSettings").userValue;return v!==void 0||(v=a.inspect("sync.ignoredSettings").userValue,v!==void 0)?v:a.getValue("settingsSync.ignoredSettings")||[]}function p(a){const v=(0,N.$Jm)(a);return v?v["settingsSync.ignoredSettings"]||v["sync.ignoredSettings"]||[]:[]}function g(a,v){const y=(0,N.$Jm)(a)||{};let u="{}";for(const E of Object.keys(y)){const D=(0,O.$rS)(u,[E],y[E],v);u=(0,O.$uS)(u,D)}return u}e.$szb=g;function h(a,v,y,u){if(y.length){const E=r(v),D=(0,N.$Jm)(v)||{},T=(0,N.$Jm)(a);if(!T)return a;const F=[];for(const q of y){const W=D[q],Z=T[q];W===void 0?a=R.edit(a,[q],void 0,u):Z!==void 0?a=R.edit(a,[q],W,u):F.push(t(q,E))}F.sort((q,W)=>q.startOffset-W.startOffset),F.forEach(q=>a=l(q.setting.key,v,a,u))}return a}e.$tzb=h;function d(a,v,y,u,E,D){const T=h(a,v,u,D),F=y!==T,q=y!==v;if(!F&&!q)return{conflictsSettings:[],localContent:null,remoteContent:null,hasConflicts:!1};if(F&&!q)return{conflictsSettings:[],localContent:null,remoteContent:T,hasConflicts:!1};if(q&&!F)return{conflictsSettings:[],localContent:h(v,a,u,D),remoteContent:null,hasConflicts:!1};if(y===null&&f(a)){const C=w(a,v,u)?null:h(v,a,u,D);return{conflictsSettings:[],localContent:C,remoteContent:null,hasConflicts:!1}}let W=a,Z=v;const Y=(0,N.$Jm)(a),x=(0,N.$Jm)(v),G=y?(0,N.$Jm)(y):null,Q=u.reduce((C,z)=>(C.add(z),C),new Set),H=o(Y,x,Q),V=o(G,Y,Q),B=o(G,x,Q),ee=new Map,ne=new Set,se=C=>{ne.add(C);const z=E.filter(({key:M})=>M===C)[0];z?(W=R.edit(W,[C],z.value,D),Z=R.edit(Z,[C],z.value,D)):ee.set(C,{key:C,localValue:Y[C],remoteValue:x[C]})};for(const C of V.removed.values())B.updated.has(C)?se(C):Z=R.edit(Z,[C],void 0,D);for(const C of B.removed.values())ne.has(C)||(V.updated.has(C)?se(C):W=R.edit(W,[C],void 0,D));for(const C of V.updated.values())ne.has(C)||(B.updated.has(C)?H.updated.has(C)&&se(C):Z=R.edit(Z,[C],Y[C],D));for(const C of B.updated.values())ne.has(C)||(V.updated.has(C)?H.updated.has(C)&&se(C):W=R.edit(W,[C],x[C],D));for(const C of V.added.values())ne.has(C)||(B.added.has(C)?H.updated.has(C)&&se(C):Z=l(C,W,Z,D));for(const C of B.added.values())ne.has(C)||(V.added.has(C)?H.updated.has(C)&&se(C):W=l(C,Z,W,D));const K=ee.size>0||!w(W,Z,u),U=K||!w(W,a,[]),S=K||!w(Z,v,[]);return{localContent:U?W:null,remoteContent:S?Z:null,conflictsSettings:[...ee.values()],hasConflicts:K}}e.$uzb=d;function w(a,v,y){if(a===v)return!0;const u=(0,N.$Jm)(a),E=(0,N.$Jm)(v),D=y.reduce((q,W)=>(q.add(W),q),new Set),T=r(a).filter(q=>!(q.setting&&D.has(q.setting.key))),F=r(v).filter(q=>!(q.setting&&D.has(q.setting.key)));if(T.length!==F.length)return!1;for(let q=0;q<T.length;q++){const W=T[q],Z=F[q];if(W.setting&&Z.setting){if(W.setting.key!==Z.setting.key||!A.$Xm(u[W.setting.key],E[W.setting.key]))return!1}else if(!W.setting&&!Z.setting){if(W.value!==Z.value)return!1}else return!1}return!0}function f(a){return a?r(a).length===0:!0}e.$vzb=f;function o(a,v,y){const u=a?Object.keys(a).filter(q=>!y.has(q)):[],E=Object.keys(v).filter(q=>!y.has(q)),D=E.filter(q=>!u.includes(q)).reduce((q,W)=>(q.add(W),q),new Set),T=u.filter(q=>!E.includes(q)).reduce((q,W)=>(q.add(W),q),new Set),F=new Set;if(a)for(const q of u){if(T.has(q))continue;const W=a[q],Z=v[q];A.$Xm(W,Z)||F.add(q)}return{added:D,removed:T,updated:F}}function l(a,v,y,u){const E=(0,N.$Jm)(v),D=r(v),T=r(y),F=$(a,D,T);return b(y,a,E[a],F,T,u)}e.$wzb=l;function $(a,v,y){const u=v.findIndex(D=>D.setting?.key===a),E=v[u-1];if(E){if(E.setting){const T=t(E.setting.key,y);if(T)return{index:y.indexOf(T),insertAfter:!0}}else{const T=c(u,v);if(T){const F=t(T.setting.key,y);if(F){const q=s(y.indexOf(F),y),W=n(v,T,v[u]);if(q){const Z=n(y,F,q),Y=i(W,Z);return Y?{index:y.indexOf(Y),insertAfter:!0}:{index:y.indexOf(q),insertAfter:!1}}else{const Z=n(y,F,y[y.length-1]),Y=i(W,Z);return Y?{index:y.indexOf(Y),insertAfter:!0}:{index:y.length-1,insertAfter:!0}}}}}const D=v[u+1];if(D)if(D.setting){const T=t(D.setting.key,y);if(T)return{index:y.indexOf(T),insertAfter:!1}}else{const T=s(u,v);if(T){const F=t(T.setting.key,y);if(F){const q=c(y.indexOf(F),y),W=n(v,v[u],T);if(q){const Z=n(y,q,F),Y=i(W.reverse(),Z.reverse());return Y?{index:y.indexOf(Y),insertAfter:!1}:{index:y.indexOf(q),insertAfter:!0}}else{const Z=n(y,y[0],F),Y=i(W.reverse(),Z.reverse());return Y?{index:y.indexOf(Y),insertAfter:!1}:{index:0,insertAfter:!1}}}}}}return{index:y.length-1,insertAfter:!0}}function b(a,v,y,u,E,D){let T;return u.index===-1?T=(0,O.$rS)(a,[v],y,D):T=I(a,v,y,u,E,D).map(F=>(0,O.$sS)(a,F,D)[0]),(0,O.$uS)(a,T)}function I(a,v,y,u,E,D){const T=`${JSON.stringify(v)}: ${JSON.stringify(y)}`,F=(0,j.$oS)(D,a),q=E[u.index];if(u.insertAfter){const W=[];if(q.setting)W.push({offset:q.endOffset,length:0,content:","+T});else{const Z=s(u.index,E),Y=c(u.index,E),x=Y?.setting?.commaOffset;Y&&x===void 0&&W.push({offset:Y.endOffset,length:0,content:","});const G=x!==void 0&&x>q.endOffset;W.push({offset:G?x+1:q.endOffset,length:0,content:Z?F+T+",":F+T})}return W}else{if(q.setting)return[{offset:q.startOffset,length:0,content:T+","}];const W=(E[u.index-1]&&!E[u.index-1].setting?F:"")+T+(s(u.index,E)?",":"")+F;return[{offset:q.startOffset,length:0,content:W}]}}function t(a,v){return v.filter(y=>y.setting?.key===a)[0]}function c(a,v){for(let y=a-1;y>=0;y--)if(v[y].setting)return v[y]}function s(a,v){for(let y=a+1;y<v.length;y++)if(v[y].setting)return v[y]}function n(a,v,y){const u=a.indexOf(v),E=a.indexOf(y);return a.filter((D,T)=>u<T&&T<E)}function i(a,v){if(a.length&&v.length){let y=0;for(;y<v.length&&y<a.length;y++)if(a[y].value!==v[y].value)return v[y-1];return v[y-1]}}function r(a){const v=[];let y=-1,u,E;const D={onObjectBegin:T=>{y++},onObjectProperty:(T,F,q)=>{y===0&&(u=F,E=T)},onObjectEnd:(T,F)=>{y--,y===0&&v.push({startOffset:u,endOffset:T+F,value:a.substring(u,T+F),setting:{key:E,commaOffset:void 0}})},onArrayBegin:(T,F)=>{y++},onArrayEnd:(T,F)=>{y--,y===0&&v.push({startOffset:u,endOffset:T+F,value:a.substring(u,T+F),setting:{key:E,commaOffset:void 0}})},onLiteralValue:(T,F,q)=>{y===0&&v.push({startOffset:u,endOffset:F+q,value:a.substring(u,F+q),setting:{key:E,commaOffset:void 0}})},onSeparator:(T,F,q)=>{if(y===0&&T===","){let W=v.length-1;for(;W>=0&&!v[W].setting;W--);const Z=v[W];Z&&v.splice(W,1,{startOffset:Z.startOffset,endOffset:Z.endOffset,value:Z.value,setting:{key:Z.setting.key,commaOffset:F}})}},onComment:(T,F)=>{y===0&&v.push({startOffset:T,endOffset:T+F,value:a.substring(T,T+F)})}};return(0,N.$Qm)(a,D),v}}),define(re[78],oe([0,1,3,2,4,25]),function(te,e,L,N,O,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$czb=e.$bzb=void 0,e.$bzb=(0,O.$zh)("IUserDataSyncAccountService");let A=class extends N.$mb{get account(){return this.a}constructor(k,m){super(),this.g=k,this.h=m,this.b=this.B(new L.$hc),this.onDidChangeAccount=this.b.event,this.c=this.B(new L.$hc),this.onTokenFailed=this.c.event,this.f=!1,this.B(k.onTokenFailed(P=>{this.h.info("Settings Sync auth token failed",this.account?.authenticationProviderId,this.f,P),this.updateAccount(void 0),P==="Forbidden"?this.c.fire(!0):this.c.fire(this.f),this.f=!0})),this.B(k.onTokenSucceed(()=>this.f=!1))}async updateAccount(k){(k&&this.a?k.token!==this.a.token||k.authenticationProviderId!==this.a.authenticationProviderId:k!==this.a)&&(this.a=k,this.a&&this.g.setAuthToken(this.a.token,this.a.authenticationProviderId),this.b.fire(k))}};e.$czb=A,e.$czb=A=ye([X(0,j.$ggb),X(1,j.$vgb)],A)}),define(re[237],oe([0,1,2,11]),function(te,e,L,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$n7b=e.$m7b=e.$l7b=e.$k7b=e.$j7b=e.$i7b=e.$h7b=void 0;class O{constructor(g){this.a=g}listen(g,h){switch(h){case"onError":return this.a.onError}throw new Error(`Event not found: ${h}`)}call(g,h,d){switch(h){case"triggerSync":return this.a.triggerSync(d[0],d[1],d[2]);case"turnOn":return this.a.turnOn();case"turnOff":return this.a.turnOff(d[0])}throw new Error("Invalid call")}}e.$h7b=O;class j{constructor(g){this.a=g}listen(g,h){throw new Error(`Event not found: ${h}`)}call(g,h,d){switch(h){case"resolveDefaultIgnoredSettings":return this.a.resolveDefaultIgnoredSettings();case"resolveUserKeybindings":return this.a.resolveUserBindings(d[0]);case"resolveFormattingOptions":return this.a.resolveFormattingOptions(N.URI.revive(d[0]))}throw new Error("Invalid call")}}e.$i7b=j;class A{constructor(g){this.a=g}async resolveDefaultIgnoredSettings(){return this.a.call("resolveDefaultIgnoredSettings")}async resolveUserBindings(g){return this.a.call("resolveUserKeybindings",[g])}async resolveFormattingOptions(g){return this.a.call("resolveFormattingOptions",[g])}}e.$j7b=A;class R{constructor(g){this.a=g}listen(g,h){switch(h){case"onDidChange":return this.a.onDidChange}throw new Error(`Event not found: ${h}`)}async call(g,h,d){switch(h){case"getMachines":return this.a.getMachines();case"addCurrentMachine":return this.a.addCurrentMachine();case"removeCurrentMachine":return this.a.removeCurrentMachine();case"renameMachine":return this.a.renameMachine(d[0],d[1]);case"setEnablements":return this.a.setEnablements(d)}throw new Error("Invalid call")}}e.$k7b=R;class k{constructor(g){this.a=g}listen(g,h){switch(h){case"onDidChangeAccount":return this.a.onDidChangeAccount;case"onTokenFailed":return this.a.onTokenFailed}throw new Error(`Event not found: ${h}`)}call(g,h,d){switch(h){case"_getInitialData":return Promise.resolve(this.a.account);case"updateAccount":return this.a.updateAccount(d)}throw new Error("Invalid call")}}e.$l7b=k;class m{constructor(g){this.a=g}listen(g,h){switch(h){case"onDidChangeUserDataSyncStore":return this.a.onDidChangeUserDataSyncStore}throw new Error(`Event not found: ${h}`)}call(g,h,d){switch(h){case"switch":return this.a.switch(d[0]);case"getPreviousUserDataSyncStore":return this.a.getPreviousUserDataSyncStore()}throw new Error("Invalid call")}}e.$m7b=m;class P extends L.$mb{constructor(g){super(),this.a=g,this.onDidChangeUserDataSyncStore=this.a.listen("onDidChangeUserDataSyncStore")}async switch(g){return this.a.call("switch",[g])}async getPreviousUserDataSyncStore(){const g=await this.a.call("getPreviousUserDataSyncStore");return this.b(g)}b(g){return{url:N.URI.revive(g.url),type:g.type,defaultUrl:N.URI.revive(g.defaultUrl),insidersUrl:N.URI.revive(g.insidersUrl),stableUrl:N.URI.revive(g.stableUrl),canSwitch:g.canSwitch,authenticationProviders:g.authenticationProviders}}}e.$n7b=P}),define(re[238],oe([0,1,174,7,25]),function(te,e,L,N,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oBb=void 0;let j=class extends N.$8i{constructor(R){super(),this.g=this.B(R.createLogger(O.$wgb,{name:(0,L.localize)(0,null)}))}trace(R,...k){this.g.trace(R,...k)}debug(R,...k){this.g.debug(R,...k)}info(R,...k){this.g.info(R,...k)}warn(R,...k){this.g.warn(R,...k)}error(R,...k){this.g.error(R,...k)}flush(){this.g.flush()}};e.$oBb=j,e.$oBb=j=ye([X(0,N.$4i)],j)}),define(re[112],oe([0,1,7,4,24]),function(te,e,L,N,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$O7b=e.$N7b=void 0,e.$N7b=(0,N.$zh)("voiceRecognitionService");let j=class{constructor(R,k){this.a=R,this.b=k}async transcribe(R,k){this.a.info(`[voice] transcribe(${R.length}): Begin`);const m=process.env.VSCODE_VOICE_MODULE_PATH;if(!m||this.b.quality==="stable")throw this.a.error(`[voice] transcribe(${R.length}): Voice recognition not yet supported`),new Error("Voice recognition not yet supported!");const P=Date.now();this.a.info(`[voice] transcribe(${R.length}): Getting module from ${m}`);try{const p=te.__$__nodeRequire(m),g=new AbortController;k.onCancellationRequested(()=>g.abort());const h=await p.transcribe({samplingRate:16e3,bitDepth:16,channelCount:1,channelData:R},{language:"en",suppressNonSpeechTokens:!0,signal:g.signal});return this.a.info(`[voice] transcribe(${R.length}): End (text: "${h}", took: ${Date.now()-P}ms)`),h}catch(p){throw this.a.error(`[voice] transcribe(${R.length}): Failed (error: "${p}", took: ${Date.now()-P}ms)`),p}}};e.$O7b=j,e.$O7b=j=ye([X(0,L.$3i),X(1,O.$ij)],j)}),define(re[239],oe([0,1,2,112,7,26,5]),function(te,e,L,N,O,j,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$P7b=void 0;let R=class extends L.$mb{constructor(P,p,g){super(),this.a=P,this.b=p,this.c=g,this.f()}f(){this.B(this.a(P=>{this.B(new k(P,this.b,this.c))}))}};e.$P7b=R,e.$P7b=R=ye([X(1,N.$N7b),X(2,O.$3i)],R);class k extends L.$mb{static{this.a=30*16e3*16*1/8}constructor(P,p,g){super(),this.f=P,this.g=p,this.h=g,this.b=new A.$Mg,this.c=void 0,this.i()}i(){this.h.info("[voice] transcriber: new connection");const P=new j.$rc;this.B((0,L.$kb)(()=>P.dispose(!0)));const p=g=>this.j(g,P.token);this.f.on("message",p),this.B((0,L.$kb)(()=>this.f.off("message",p))),this.f.start(),this.B((0,L.$kb)(()=>this.f.close())),this.f.on("close",()=>{this.h.info("[voice] transcriber: closed connection"),P.dispose(!0)})}async j(P,p){if(!Array.isArray(P.data))return;const g=[];for(const d of P.data)d instanceof Float32Array&&g.push(d);const h=this.l(this.c?[this.c,...g]:g);if(h.length>k.a){this.h.warn("[voice] transcriber: refusing to accept more than 30s of audio data");return}this.c=h,this.b.queue(()=>this.k(p))}async k(P){if(P.isCancellationRequested)return;const p=this.c?.slice(0);if(!p)return;const g=await this.g.transcribe(p,P);P.isCancellationRequested||this.f.postMessage(g)}l(P){const p=new Float32Array(P.reduce((h,d)=>h+d.length,0));let g=0;for(const h of P)p.set(h,g),g+=h.length;return p}}}),define(re[240],oe([0,1,5,3,2]),function(te,e,L,N,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$l6b=void 0;class j extends O.$mb{constructor({onDidOpenWindow:R,onDidFocusWindow:k,getActiveWindowId:m}){super(),this.a=this.B(new O.$lb),N.Event.latch(N.Event.any(R,k))(this.f,this,this.a),this.b=(0,L.$sg)(()=>m()),(async()=>{try{const p=await this.b;this.c=typeof this.c=="number"?this.c:p}catch{}finally{this.b=void 0}})()}f(R){this.b&&(this.b.cancel(),this.b=void 0),this.c=R}async getActiveClientId(){return`window:${this.b?await this.b:this.c}`}}e.$l6b=j}),define(re[113],oe([0,1,177,15,47,23,11,4,22]),function(te,e,L,N,O,j,A,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5h=e.$4h=e.$3h=e.$2h=e.$1h=e.$Zh=e.$Yh=e.$Xh=e.$Wh=e.$Vh=e.$Uh=e.$Th=e.$Sh=e.$Rh=e.$Qh=e.WorkbenchState=e.$Ph=e.$Oh=e.$Nh=e.$Mh=e.$Lh=e.$Kh=e.$Jh=e.$Ih=void 0,e.$Ih=(0,R.$zh)("contextService");function m(n){const i=n;return typeof i?.id=="string"&&A.URI.isUri(i.uri)}e.$Jh=m;function P(n){return typeof n?.id=="string"&&!m(n)&&!g(n)}e.$Kh=P,e.$Lh={id:"ext-dev"},e.$Mh={id:"empty-window"};function p(n,i){if(typeof n=="string"||typeof n>"u")return typeof n=="string"?{id:(0,N.$cd)(n)}:i?e.$Lh:e.$Mh;const r=n;return r.configuration?{id:r.id,configPath:r.configuration}:r.folders.length===1?{id:r.id,uri:r.folders[0].uri}:{id:r.id}}e.$Nh=p;function g(n){const i=n;return typeof i?.id=="string"&&A.URI.isUri(i.configPath)}e.$Oh=g;function h(n){const i=n;if(i?.uri)return{id:i.id,uri:A.URI.revive(i.uri)};const r=n;if(r?.configPath)return{id:r.id,configPath:A.URI.revive(r.configPath)};if(n?.id)return{id:n.id}}e.$Ph=h;var d;(function(n){n[n.EMPTY=1]="EMPTY",n[n.FOLDER=2]="FOLDER",n[n.WORKSPACE=3]="WORKSPACE"})(d||(e.WorkbenchState=d={}));function w(n){const i=n;return!!(i&&typeof i=="object"&&typeof i.id=="string"&&Array.isArray(i.folders))}e.$Qh=w;function f(n){const i=n;return!!(i&&typeof i=="object"&&A.URI.isUri(i.uri)&&typeof i.name=="string"&&typeof i.toResource=="function")}e.$Rh=f;class o{constructor(i,r,a,v,y){this.h=i,this.j=a,this.k=v,this.l=y,this.c=O.$Fh.forUris(this.l,()=>!0),this.folders=r}update(i){this.h=i.id,this.k=i.configuration,this.j=i.transient,this.l=i.l,this.folders=i.folders}get folders(){return this.g}set folders(i){this.g=i,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(i){this.k=i}getFolder(i){return i&&this.c.findSubstr(i)||null}n(){this.c=O.$Fh.forUris(this.l,()=>!0);for(const i of this.folders)this.c.set(i.uri,i)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$Sh=o;class l{constructor(i,r){this.raw=r,this.uri=i.uri,this.index=i.index,this.name=i.name}toResource(i){return(0,j.$gg)(this.uri,i)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$Th=l;function $(n){return new l({uri:n,index:0,name:(0,j.$cg)(n)},{uri:n.toString()})}e.$Uh=$,e.$Vh="code-workspace",e.$Wh=`.${e.$Vh}`,e.$Xh=[{name:(0,L.localize)(0,null),extensions:[e.$Vh]}],e.$Yh="workspace.json";function b(n,i){return j.$0f.isEqualOrParent(n,i.untitledWorkspacesHome)}e.$Zh=b;function I(n){let i;return A.URI.isUri(n)?i=n:i=n.configuration,i?.scheme===k.Schemas.tmp}e.$1h=I,e.$2h="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function t(n){return n.id===e.$2h}e.$3h=t;function c(n,i){return!b(n,i)&&!I(n)}e.$4h=c;function s(n){return(typeof n=="string"?(0,N.$dd)(n):(0,j.$eg)(n))===e.$Wh}e.$5h=s}),define(re[17],oe([0,1,51,3,2,23,11,168,16,13,4,7,113,35,27,5,32,28,9]),function(te,e,L,N,O,j,A,R,k,m,P,p,g,h,d,w,f,o,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gk=e.$Fk=e.$Ek=e.$Dk=e.$Ck=e.$Bk=e.ProfileResourceType=void 0;var $;(function(n){n.Settings="settings",n.Keybindings="keybindings",n.Snippets="snippets",n.Tasks="tasks",n.Extensions="extensions",n.GlobalState="globalState"})($||(e.ProfileResourceType=$={}));function b(n){const i=n;return!!(i&&typeof i=="object"&&typeof i.id=="string"&&typeof i.isDefault=="boolean"&&typeof i.name=="string"&&A.URI.isUri(i.location)&&A.URI.isUri(i.globalStorageHome)&&A.URI.isUri(i.settingsResource)&&A.URI.isUri(i.keybindingsResource)&&A.URI.isUri(i.tasksResource)&&A.URI.isUri(i.snippetsHome)&&A.URI.isUri(i.extensionsResource))}e.$Bk=b,e.$Ck=(0,P.$zh)("IUserDataProfilesService");function I(n,i){return{id:n.id,isDefault:n.isDefault,name:n.name,shortName:n.shortName,location:A.URI.revive(n.location).with({scheme:i}),globalStorageHome:A.URI.revive(n.globalStorageHome).with({scheme:i}),settingsResource:A.URI.revive(n.settingsResource).with({scheme:i}),keybindingsResource:A.URI.revive(n.keybindingsResource).with({scheme:i}),tasksResource:A.URI.revive(n.tasksResource).with({scheme:i}),snippetsHome:A.URI.revive(n.snippetsHome).with({scheme:i}),extensionsResource:A.URI.revive(n.extensionsResource).with({scheme:i}),cacheHome:A.URI.revive(n.cacheHome).with({scheme:i}),useDefaultFlags:n.useDefaultFlags,isTransient:n.isTransient}}e.$Dk=I;function t(n,i,r,a,v,y){return{id:n,name:i,location:r,isDefault:!1,shortName:v?.shortName,globalStorageHome:y&&v?.useDefaultFlags?.globalState?y.globalStorageHome:(0,j.$gg)(r,"globalStorage"),settingsResource:y&&v?.useDefaultFlags?.settings?y.settingsResource:(0,j.$gg)(r,"settings.json"),keybindingsResource:y&&v?.useDefaultFlags?.keybindings?y.keybindingsResource:(0,j.$gg)(r,"keybindings.json"),tasksResource:y&&v?.useDefaultFlags?.tasks?y.tasksResource:(0,j.$gg)(r,"tasks.json"),snippetsHome:y&&v?.useDefaultFlags?.snippets?y.snippetsHome:(0,j.$gg)(r,"snippets"),extensionsResource:y&&v?.useDefaultFlags?.extensions?y.extensionsResource:(0,j.$gg)(r,"extensions.json"),cacheHome:(0,j.$gg)(a,n),useDefaultFlags:v?.useDefaultFlags,isTransient:v?.transient}}e.$Ek=t;let c=class extends O.$mb{static{this.b="userDataProfiles"}static{this.c="profileAssociations"}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.v.profiles,...this.m.profiles]}constructor(i,r,a,v){super(),this.n=i,this.r=r,this.s=a,this.t=v,this.f=!0,this.h=this.B(new N.$hc),this.onDidChangeProfiles=this.h.event,this.i=this.B(new N.$hc),this.onWillCreateProfile=this.i.event,this.j=this.B(new N.$hc),this.onWillRemoveProfile=this.j.event,this.k=this.B(new N.$hc),this.onDidResetWorkspaces=this.k.event,this.l=new Map,this.m={profiles:[],workspaces:new h.$xi,emptyWindows:new Map},this.profilesHome=(0,j.$gg)(this.n.userRoamingDataHome,"profiles"),this.g=(0,j.$gg)(this.n.cacheHome,"CachedProfilesData")}init(){this.u=void 0}setEnablement(i){this.f!==i&&(this.u=void 0,this.f=i)}isEnabled(){return this.f}get v(){if(!this.u){const i=this.w(),r=[i];if(this.f)try{for(const y of this.J()){if(!y.name||!(0,l.$le)(y.name)||!y.location){this.t.warn("Skipping the invalid stored profile",y.location||y.name);continue}r.push(t((0,j.$dg)(y.location),y.name,y.location,this.g,{shortName:y.shortName,useDefaultFlags:y.useDefaultFlags},i))}}catch(y){this.t.error(y)}const a=new h.$xi,v=new Map;if(r.length)try{const y=this.M();if(y.workspaces)for(const[u,E]of Object.entries(y.workspaces)){const D=A.URI.parse(u),T=r.find(F=>F.id===E);T&&a.set(D,T)}if(y.emptyWindows)for(const[u,E]of Object.entries(y.emptyWindows)){const D=r.find(T=>T.id===E);D&&v.set(u,D)}}catch(y){this.t.error(y)}this.u={profiles:r,workspaces:a,emptyWindows:v}}return this.u}w(){const i=t("__default__profile__",(0,R.localize)(0,null),this.n.userRoamingDataHome,this.g);return{...i,extensionsResource:this.O()??i.extensionsResource,isDefault:!0}}async createTransientProfile(i){const r="Temp",a=new RegExp(`${(0,o.$sd)(r)}\\s(\\d+)`);let v=0;for(const u of this.profiles){const E=a.exec(u.name),D=E?parseInt(E[1]):0;v=D>v?D:v}const y=`${r} ${v+1}`;return this.createProfile((0,L.$ni)((0,f.$6e)()).toString(16),y,{transient:!0},i)}async createNamedProfile(i,r,a){return this.createProfile((0,L.$ni)((0,f.$6e)()).toString(16),i,r,a)}async createProfile(i,r,a,v){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const y=await this.y(i,r,a);return v&&await this.setProfileForWorkspace(v,y),y}async y(i,r,a){if(!(0,l.$le)(r)||!r)throw new Error("Name of the profile is mandatory and must be of type `string`");let v=this.l.get(r);return v||(v=(async()=>{try{const y=this.profiles.find(D=>D.name===r||D.id===i);if(y)return y;const u=t(i,r,(0,j.$gg)(this.profilesHome,i),this.g,a,this.defaultProfile);await this.r.createFolder(u.location);const E=[];return this.i.fire({profile:u,join(D){E.push(D)}}),await w.Promises.settled(E),this.D([u],[],[]),u}finally{this.l.delete(r)}})(),this.l.set(r,v)),v}async updateProfile(i,r){if(!this.f)throw new Error("Profiles are disabled in the current environment.");let a=this.profiles.find(v=>v.id===i.id);if(!a)throw new Error(`Profile '${i.name}' does not exist`);return a=t(a.id,r.name??a.name,a.location,this.g,{shortName:r.shortName??a.shortName,transient:r.transient??a.isTransient,useDefaultFlags:r.useDefaultFlags??a.useDefaultFlags},this.defaultProfile),this.D([],[],[a]),a}async removeProfile(i){if(!this.f)throw new Error("Profiles are disabled in the current environment.");if(i.isDefault)throw new Error("Cannot remove default profile");const r=this.profiles.find(v=>v.id===i.id);if(!r)throw new Error(`Profile '${i.name}' does not exist`);const a=[];this.j.fire({profile:r,join(v){a.push(v)}});try{await Promise.allSettled(a)}catch(v){this.t.error(v)}for(const v of[...this.v.emptyWindows.keys()])r.id===this.v.emptyWindows.get(v)?.id&&this.v.emptyWindows.delete(v);for(const v of[...this.v.workspaces.keys()])r.id===this.v.workspaces.get(v)?.id&&this.v.workspaces.delete(v);this.H(),this.D([],[r],[]);try{await this.r.del(r.cacheHome,{recursive:!0})}catch(v){(0,m.$hk)(v)!==1&&this.t.error(v)}}async setProfileForWorkspace(i,r){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const a=this.profiles.find(v=>v.id===r.id);if(!a)throw new Error(`Profile '${r.name}' does not exist`);this.G(i,a)}unsetWorkspace(i,r){if(!this.f)throw new Error("Profiles are disabled in the current environment.");this.G(i,void 0,r)}async resetWorkspaces(){this.m.workspaces.clear(),this.m.emptyWindows.clear(),this.v.workspaces.clear(),this.v.emptyWindows.clear(),this.H(),this.k.fire()}async cleanUp(){if(this.f&&await this.r.exists(this.profilesHome)){const i=await this.r.resolve(this.profilesHome);await Promise.all((i.children||[]).filter(r=>r.isDirectory&&this.profiles.every(a=>!this.s.extUri.isEqual(a.location,r.resource))).map(r=>this.r.del(r.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const i=this.m.profiles.filter(r=>!this.C(r));await Promise.allSettled(i.map(r=>this.removeProfile(r)))}getProfileForWorkspace(i){const r=this.z(i);return A.URI.isUri(r)?this.m.workspaces.get(r)??this.v.workspaces.get(r):this.m.emptyWindows.get(r)??this.v.emptyWindows.get(r)}z(i){return(0,g.$Jh)(i)?i.uri:(0,g.$Oh)(i)?i.configPath:i.id}C(i){return!!([...this.m.emptyWindows.values()].some(r=>this.s.extUri.isEqual(r.location,i.location))||[...this.m.workspaces.values()].some(r=>this.s.extUri.isEqual(r.location,i.location))||[...this.v.emptyWindows.values()].some(r=>this.s.extUri.isEqual(r.location,i.location))||[...this.v.workspaces.values()].some(r=>this.s.extUri.isEqual(r.location,i.location)))}D(i,r,a){const v=[...this.profiles,...i],y=[];this.m.profiles=[];for(let u of v)u.isDefault||r.some(E=>u.id===E.id)||(u=a.find(E=>u.id===E.id)??u,u.isTransient?this.m.profiles.push(u):y.push({location:u.location,name:u.name,shortName:u.shortName,useDefaultFlags:u.useDefaultFlags}));this.L(y),this.u=void 0,this.F(i,r,a)}F(i,r,a){this.h.fire({added:i,removed:r,updated:a,all:this.profiles})}G(i,r,a){a=r?.isTransient?!0:a,a||this.G(i,void 0,!0);const v=this.z(i),y=a?this.m:this.v;A.URI.isUri(v)?(y.workspaces.delete(v),r&&y.workspaces.set(v,r)):(y.emptyWindows.delete(v),r&&y.emptyWindows.set(v,r)),a||this.H()}H(){const i={};for(const[a,v]of this.v.workspaces.entries())i[a.toString()]=v.id;const r={};for(const[a,v]of this.v.emptyWindows.entries())r[a.toString()]=v.id;this.N({workspaces:i,emptyWindows:r}),this.u=void 0}I(i){const r={},a=this.w();if(i.workspaces)for(const[y,u]of Object.entries(i.workspaces)){const E=A.URI.parse(u);r[y]=this.s.extUri.isEqual(E,a.location)?a.id:this.s.extUri.basename(E)}const v={};if(i.emptyWindows)for(const[y,u]of Object.entries(i.emptyWindows)){const E=A.URI.parse(u);v[y]=this.s.extUri.isEqual(E,a.location)?a.id:this.s.extUri.basename(E)}return{workspaces:r,emptyWindows:v}}J(){return[]}L(i){throw new Error("not implemented")}M(){return{}}N(i){throw new Error("not implemented")}O(){}};e.$Fk=c,e.$Fk=c=ye([X(0,k.$Gh),X(1,m.$4j),X(2,d.$Ak),X(3,p.$3i)],c);class s extends c{constructor(){super(...arguments),this.a=[],this.R={}}J(){return this.a}L(i){this.a=i}M(){return this.R}N(i){this.R=i}}e.$Gk=s}),define(re[241],oe([0,1,5,2,17]),function(te,e,L,N,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$v7b=void 0;let j=class extends N.$mb{constructor(R){super(),this.B(new L.$Qg(()=>{R.cleanUp()},10*1e3)).schedule()}};e.$v7b=j,e.$v7b=j=ye([X(0,O.$Ck)],j)}),define(re[242],oe([0,1,20,5,26,8,3,2,6,9,11,151,29,33,45,7,24,21,27,17]),function(te,e,L,N,O,j,A,R,k,m,P,p,g,h,d,w,f,o,l,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fp=e.$ep=e.$dp=e.$cp=void 0;let b=class extends R.$mb{get onInstallExtension(){return this.l.event}get onDidInstallExtensions(){return this.m.event}get onUninstallExtension(){return this.n.event}get onDidUninstallExtension(){return this.p.event}get onDidUpdateExtensionMetadata(){return this.s.event}constructor(i,r,a,v,y,u){super(),this.u=i,this.v=r,this.w=a,this.y=v,this.z=y,this.C=u,this.h=0,this.j=new Map,this.k=new Map,this.l=this.B(new A.$hc),this.m=this.B(new A.$hc),this.n=this.B(new A.$hc),this.p=this.B(new A.$hc),this.s=this.B(new A.$hc),this.t=[],this.B((0,R.$kb)(()=>{this.j.forEach(({task:E})=>E.cancel()),this.k.forEach(E=>E.cancel()),this.j.clear(),this.k.clear()}))}async canInstall(i){const r=await this.getTargetPlatform();return i.allTargetPlatforms.some(a=>(0,g.$Un)(a,i.allTargetPlatforms,r))}async installFromGallery(i,r={}){try{const v=(await this.installGalleryExtensions([{extension:i,options:r}])).find(({identifier:y})=>(0,h.$no)(y,i.identifier));if(v?.local)return v?.local;throw v?.error?v.error:t(new Error(`Unknown error while installing extension ${i.identifier.id}`))}catch(a){throw t(a)}}async installGalleryExtensions(i){if(!this.u.isEnabled())throw new g.$Yn(p.localize(0,null),g.ExtensionManagementErrorCode.Internal);const r=[],a=[];await Promise.allSettled(i.map(async({extension:v,options:y})=>{try{const u=await this.J(v,!!y?.installGivenVersion,!!y?.installPreReleaseVersion);a.push({...u,options:y})}catch(u){r.push({identifier:v.identifier,operation:2,source:v,error:u})}})),a.length&&r.push(...await this.D(a));for(const v of r)v.error&&(this.y.error("Failed to install extension.",v.identifier.id),this.y.error(v.error),v.source&&!P.URI.isUri(v.source)&&c(this.v,"extensionGallery:install",{extensionData:(0,h.$vo)(v.source),error:v.error}));return r}async uninstall(i,r={}){return this.y.trace("ExtensionManagementService#uninstall",i.identifier.id),this.M(i,r)}async toggleAppliationScope(i,r){if((0,d.$Wl)(i.manifest)||i.isBuiltin)return i;if(i.isApplicationScoped){let a=await this.updateMetadata(i,{isApplicationScoped:!1},this.C.defaultProfile.extensionsResource);this.w.extUri.isEqual(r,this.C.defaultProfile.extensionsResource)||(a=await this.X(i,this.C.defaultProfile.extensionsResource,r));for(const v of this.C.profiles){const y=(await this.getInstalled(1,v.extensionsResource)).find(u=>(0,h.$no)(u.identifier,i.identifier));y?this.s.fire(y):this.p.fire({identifier:i.identifier,profileLocation:v.extensionsResource})}return a}else{const a=this.w.extUri.isEqual(r,this.C.defaultProfile.extensionsResource)?await this.updateMetadata(i,{isApplicationScoped:!0},this.C.defaultProfile.extensionsResource):await this.X(i,r,this.C.defaultProfile.extensionsResource,{isApplicationScoped:!0});return this.m.fire([{identifier:a.identifier,operation:2,local:a,profileLocation:this.C.defaultProfile.extensionsResource,applicationScoped:!0}]),a}}getExtensionsControlManifest(){const i=new Date().getTime();return(!this.g||i-this.h>1e3*60*5)&&(this.g=this.R(),this.h=i),this.g}registerParticipant(i){this.t.push(i)}async D(i){const r=[];return await Promise.allSettled(i.map(async a=>{try{const v=await this.F(a);r.push(...v)}catch(v){r.push({identifier:{id:(0,h.$so)(a.manifest.publisher,a.manifest.name)},operation:2,source:a.extension,error:v})}})),this.m.fire(r),r}async F({manifest:i,extension:r,options:a}){const v=a.isApplicationScoped||a.isBuiltin||(0,d.$Wl)(i),y={...a,installOnlyNewlyAddedFromExtensionPack:P.URI.isUri(r)?a.installOnlyNewlyAddedFromExtensionPack:!0,isApplicationScoped:v,profileLocation:v?this.C.defaultProfile.extensionsResource:a.profileLocation??this.S()},u=W=>`${h.$oo.create(W).toString()}${y.profileLocation?`-${y.profileLocation.toString()}`:""}`;if(!P.URI.isUri(r)){const W=this.j.get(u(r));if(W)return this.y.info("Extensions is already requested to install",r.identifier.id),await W.task.waitUntilTaskIsFinished(),[]}const E=[],D=[],T=[],F=this.U(i,r,y);P.URI.isUri(r)||this.j.set(u(r),{task:F,waitingTasks:[]}),this.l.fire({identifier:F.identifier,source:r,profileLocation:y.profileLocation}),this.y.info("Installing extension:",F.identifier.id),E.push({task:F,manifest:i});let q=!1;try{if(y.donotIncludePackAndDependencies)this.y.info("Installing the extension without checking dependencies and pack",F.identifier.id);else try{const Z=await this.I(F.identifier,i,!!y.installOnlyNewlyAddedFromExtensionPack,!!y.installPreReleaseVersion,y.profileLocation),Y=await this.getInstalled(void 0,y.profileLocation),x={...y,donotIncludePackAndDependencies:!0,context:{...y.context,[g.$Pn]:!0}};for(const{gallery:G,manifest:Q}of(0,L.$Ff)(Z,({gallery:H})=>H.identifier.id)){q=q||!!Q.extensionDependencies?.some(B=>(0,h.$no)({id:B},F.identifier));const H=u(G),V=this.j.get(H);if(V){if(this.G(F,V.task)){const B=V.task.identifier;this.y.info("Waiting for already requested installing extension",B.id,F.identifier.id),V.waitingTasks.push(F),D.push(A.Event.toPromise(A.Event.filter(this.onDidInstallExtensions,ee=>ee.some(ne=>(0,h.$no)(ne.identifier,B)))).then(ee=>{if(this.y.info("Finished waiting for already requested installing extension",B.id,F.identifier.id),!ee.find(se=>(0,h.$no)(se.identifier,B))?.local)throw new Error(`Extension ${B.id} is not installed`)}))}}else if(!Y.some(({identifier:B})=>(0,h.$no)(B,G.identifier))){const B=this.U(Q,G,x);this.j.set(H,{task:B,waitingTasks:[F]}),this.l.fire({identifier:B.identifier,source:G,profileLocation:y.profileLocation}),this.y.info("Installing extension:",B.identifier.id,F.identifier.id),E.push({task:B,manifest:Q})}}}catch(Z){if(P.URI.isUri(F.source))(0,L.$Ef)(i.extensionDependencies)&&this.y.warn("Cannot install dependencies of extension:",F.identifier.id,Z.message),(0,L.$Ef)(i.extensionPack)&&this.y.warn("Cannot install packed extensions of extension:",F.identifier.id,Z.message);else throw this.y.error("Error while preparing to install dependencies and extension packs of the extension:",F.identifier.id),Z}const W=E.reduce((Z,{task:Y,manifest:x})=>(Z.set(Y.identifier.id.toLowerCase(),{task:Y,manifest:x}),Z),new Map);for(;W.size;){let Z;const Y=[...W.values()].filter(({manifest:x})=>!x.extensionDependencies?.some(G=>W.has(G.toLowerCase())));Y.length?Z=W.size===1?Y:Y.filter(({task:x})=>!(x===F&&!q)):(this.y.info("Found extensions with circular dependencies",Y.map(({task:x})=>x.identifier.id)),Z=[...W.values()]),await this.H(Z.map(async({task:x})=>{const G=new Date().getTime();try{const Q=await x.run();if(await this.H(this.t.map(H=>H.postInstall(Q,x.source,y,O.CancellationToken.None))),!P.URI.isUri(x.source)){const H=x.operation===3,V=H?void 0:(new Date().getTime()-x.source.lastUpdated)/1e3;if(c(this.v,H?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,h.$vo)(x.source),verificationStatus:x.verificationStatus,duration:new Date().getTime()-G,durationSinceUpdate:V}),k.$o&&x.operation!==3)try{await this.u.reportStatistic(Q.manifest.publisher,Q.manifest.name,Q.manifest.version,"install")}catch{}}T.push({local:Q,identifier:x.identifier,operation:x.operation,source:x.source,context:x.options.context,profileLocation:x.profileLocation,applicationScoped:Q.isApplicationScoped})}catch(Q){throw P.URI.isUri(x.source)||c(this.v,x.operation===3?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,h.$vo)(x.source),verificationStatus:x.verificationStatus,duration:new Date().getTime()-G,error:Q}),this.y.error("Error while installing the extension:",x.identifier.id),Q}finally{W.delete(x.identifier.id.toLowerCase())}}))}return D.length&&await this.H(D),T.forEach(({identifier:Z})=>this.y.info("Extension installed successfully:",Z.id)),T}catch(W){if(E.forEach(({task:Z})=>Z.cancel()),T.length)try{const Z=await Promise.allSettled(T.map(({local:Y})=>this.W(Y,{versionOnly:!0,profileLocation:y.profileLocation}).run()));for(let Y=0;Y<Z.length;Y++){const x=Z[Y],{identifier:G}=T[Y];x.status==="fulfilled"?this.y.info("Rollback: Uninstalled extension",G.id):this.y.warn("Rollback: Error while uninstalling extension",G.id,(0,j.$8)(x.reason))}}catch(Z){this.y.warn("Error while rolling back extensions",(0,j.$8)(Z),T.map(({identifier:Y})=>Y.id))}return E.map(({task:Z})=>({identifier:Z.identifier,operation:2,source:Z.source,context:y.context,profileLocation:y.profileLocation,error:W}))}finally{for(const{task:W}of E)W.source&&!P.URI.isUri(W.source)&&this.j.delete(u(W.source))}}G(i,r){for(const[,{task:a,waitingTasks:v}]of this.j.entries())if(a===i&&(v.includes(r)||v.some(y=>this.G(y,r)))||a===r&&v[0]&&!this.G(i,v[0]))return!1;return!0}async H(i){const r=[],a=[],v=await Promise.allSettled(i);for(const y of v)y.status==="fulfilled"?r.push(y.value):a.push(y.reason);if(a.length)throw I(a);return r}async I(i,r,a,v,y){if(!this.u.isEnabled())return[];const u=await this.getInstalled(void 0,y),E=[],D=[],T=async(F,q)=>{E.push(F);const W=q.extensionDependencies||[],Z=[...W];if(q.extensionPack){const Y=a?u.find(x=>(0,h.$no)(x.identifier,F)):void 0;for(const x of q.extensionPack)Y&&Y.manifest.extensionPack&&Y.manifest.extensionPack.some(G=>(0,h.$no)({id:G},{id:x}))||Z.every(G=>!(0,h.$no)({id:G},{id:x}))&&Z.push(x)}if(Z.length){const Y=Z.filter(x=>E.every(G=>!(0,h.$no)(G,{id:x})));if(Y.length){const x=await this.u.getExtensions(Y.map(G=>({id:G,preRelease:v})),O.CancellationToken.None);for(const G of x){if(E.find(V=>(0,h.$no)(V,G.identifier)))continue;const Q=W.some(V=>(0,h.$no)({id:V},G.identifier));let H;try{H=await this.J(G,!1,v)}catch(V){if(Q)throw V;this.y.info("Skipping the packed extension as it cannot be installed",G.identifier.id,(0,j.$8)(V));continue}D.push({gallery:H.extension,manifest:H.manifest}),await T(H.extension.identifier,H.manifest)}}}};return await T(i,r),D}async J(i,r,a){let v;const y=await this.getExtensionsControlManifest();if(y.malicious.some(D=>(0,h.$no)(i.identifier,D)))throw new g.$Yn(p.localize(1,null,i.identifier.id),g.ExtensionManagementErrorCode.Malicious);const u=y.deprecated[i.identifier.id.toLowerCase()];if(u?.extension?.autoMigrate){if(this.y.info(`The '${i.identifier.id}' extension is deprecated, fetching the compatible '${u.extension.id}' extension instead.`),v=(await this.u.getExtensions([{id:u.extension.id,preRelease:u.extension.preRelease}],{targetPlatform:await this.getTargetPlatform(),compatible:!0},O.CancellationToken.None))[0],!v)throw new g.$Yn(p.localize(2,null,i.identifier.id,u.extension.id),g.ExtensionManagementErrorCode.Deprecated)}else{if(!await this.canInstall(i)){const D=await this.getTargetPlatform();throw new g.$Yn(p.localize(3,null,i.identifier.id,this.z.nameLong,(0,g.$Qn)(D)),g.ExtensionManagementErrorCode.IncompatibleTargetPlatform)}if(v=await this.L(i,r,a),!v)throw!a&&i.properties.isPreReleaseVersion&&(await this.u.getExtensions([i.identifier],O.CancellationToken.None))[0]?new g.$Yn(p.localize(4,null,i.identifier.id),g.ExtensionManagementErrorCode.ReleaseVersionNotFound):new g.$Yn(p.localize(5,null,i.identifier.id,this.z.nameLong,this.z.version),g.ExtensionManagementErrorCode.Incompatible)}this.y.info("Getting Manifest...",v.identifier.id);const E=await this.u.getManifest(v,O.CancellationToken.None);if(E===null)throw new g.$Yn(`Missing manifest for extension ${v.identifier.id}`,g.ExtensionManagementErrorCode.Invalid);if(E.version!==v.version)throw new g.$Yn(`Cannot install '${v.identifier.id}' extension because of version mismatch in Marketplace`,g.ExtensionManagementErrorCode.Invalid);return{extension:v,manifest:E}}async L(i,r,a){const v=await this.getTargetPlatform();let y=null;return!r&&i.hasPreReleaseVersion&&i.properties.isPreReleaseVersion!==a&&(y=(await this.u.getExtensions([{...i.identifier,preRelease:a}],{targetPlatform:v,compatible:!0},O.CancellationToken.None))[0]||null),!y&&await this.u.isExtensionCompatible(i,a,v)&&(y=i),y||(r?y=(await this.u.getExtensions([{...i.identifier,version:i.version}],{targetPlatform:v,compatible:!0},O.CancellationToken.None))[0]||null:y=await this.u.getCompatibleExtension(i,a,v)),y}async M(i,r){const a={...r,profileLocation:i.isApplicationScoped?this.C.defaultProfile.extensionsResource:r.profileLocation??this.S()},v=F=>`${F.id.toLowerCase()}${a.versionOnly?`-${i.manifest.version}`:""}${a.profileLocation?`@${a.profileLocation.toString()}`:""}`,y=this.k.get(v(i.identifier));if(y)return this.y.info("Extensions is already requested to uninstall",i.identifier.id),y.waitUntilTaskIsFinished();const u=F=>{const q=this.W(F,a);return this.k.set(v(q.extension.identifier),q),a.profileLocation?this.y.info("Uninstalling extension from the profile:",`${F.identifier.id}@${F.manifest.version}`,a.profileLocation.toString()):this.y.info("Uninstalling extension:",`${F.identifier.id}@${F.manifest.version}`),this.n.fire({identifier:F.identifier,profileLocation:a.profileLocation,applicationScoped:F.isApplicationScoped}),q},E=(F,q)=>{q?a.profileLocation?this.y.error("Failed to uninstall extension from the profile:",`${F.identifier.id}@${F.manifest.version}`,a.profileLocation.toString(),q.message):this.y.error("Failed to uninstall extension:",`${F.identifier.id}@${F.manifest.version}`,q.message):a.profileLocation?this.y.info("Successfully uninstalled extension from the profile",`${F.identifier.id}@${F.manifest.version}`,a.profileLocation.toString()):this.y.info("Successfully uninstalled extension:",`${F.identifier.id}@${F.manifest.version}`),c(this.v,"extensionGallery:uninstall",{extensionData:(0,h.$uo)(F),error:q}),this.p.fire({identifier:F.identifier,error:q?.code,profileLocation:a.profileLocation,applicationScoped:F.isApplicationScoped})},D=[],T=[];try{D.push(u(i));const F=await this.getInstalled(1,a.profileLocation);if(a.donotIncludePack)this.y.info("Uninstalling the extension without including packed extension",`${i.identifier.id}@${i.manifest.version}`);else{const q=this.P(i,F);for(const W of q)this.k.has(v(W.identifier))?this.y.info("Extensions is already requested to uninstall",W.identifier.id):D.push(u(W))}a.donotCheckDependents?this.y.info("Uninstalling the extension without checking dependents",`${i.identifier.id}@${i.manifest.version}`):this.N(D.map(q=>q.extension),F,i),await this.H(D.map(async q=>{try{if(await q.run(),await this.H(this.t.map(W=>W.postUninstall(q.extension,a,O.CancellationToken.None))),q.extension.identifier.uuid)try{await this.u.reportStatistic(q.extension.manifest.publisher,q.extension.manifest.name,q.extension.manifest.version,"uninstall")}catch{}E(q.extension)}catch(W){const Z=W instanceof g.$Yn?W:new g.$Yn((0,j.$8)(W),g.ExtensionManagementErrorCode.Internal);throw E(q.extension,Z),Z}finally{T.push(q)}}))}catch(F){const q=F instanceof g.$Yn?F:new g.$Yn((0,j.$8)(F),g.ExtensionManagementErrorCode.Internal);for(const W of D){try{W.cancel()}catch{}T.includes(W)||E(W.extension,q)}throw q}finally{for(const F of D)this.k.delete(v(F.extension.identifier))||this.y.warn("Uninstallation task is not found in the cache",F.extension.identifier.id)}}N(i,r,a){for(const v of i){const y=this.Q(v,r);if(y.length){const u=y.filter(E=>!i.some(D=>(0,h.$no)(D.identifier,E.identifier)));if(u.length)throw new Error(this.O(v,u,a))}}}O(i,r,a){return a===i?r.length===1?p.localize(6,null,a.manifest.displayName||a.manifest.name,r[0].manifest.displayName||r[0].manifest.name):r.length===2?p.localize(7,null,a.manifest.displayName||a.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):p.localize(8,null,a.manifest.displayName||a.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):r.length===1?p.localize(9,null,a.manifest.displayName||a.manifest.name,i.manifest.displayName||i.manifest.name,r[0].manifest.displayName||r[0].manifest.name):r.length===2?p.localize(10,null,a.manifest.displayName||a.manifest.name,i.manifest.displayName||i.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):p.localize(11,null,a.manifest.displayName||a.manifest.name,i.manifest.displayName||i.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name)}P(i,r,a=[]){if(a.indexOf(i)!==-1)return[];a.push(i);const v=i.manifest.extensionPack?i.manifest.extensionPack:[];if(v.length){const y=r.filter(E=>!E.isBuiltin&&v.some(D=>(0,h.$no)({id:D},E.identifier))),u=[];for(const E of y)u.push(...this.P(E,r,a));return[...y,...u]}return[]}Q(i,r){return r.filter(a=>a.manifest.extensionDependencies&&a.manifest.extensionDependencies.some(v=>(0,h.$no)({id:v},i.identifier)))}async R(){try{this.y.trace("ExtensionManagementService.refreshReportedCache");const i=await this.u.getExtensionsControlManifest();return this.y.trace("ExtensionManagementService.refreshControlCache",i),i}catch{return this.y.trace("ExtensionManagementService.refreshControlCache - failed to get extension control manifest"),{malicious:[],deprecated:{},search:[]}}}};e.$cp=b,e.$cp=b=ye([X(0,g.$Xn),X(1,o.$7k),X(2,l.$Ak),X(3,w.$3i),X(4,f.$ij),X(5,$.$Ck)],b);function I(n){const i=Array.isArray(n)?n:[n];return i.length===1?i[0]instanceof Error?i[0]:new Error(i[0]):i.reduce((r,a)=>new Error(`${r.message}${r.message?",":""}${a instanceof Error?a.message:a}`),new Error(""))}e.$dp=I;function t(n){if(n instanceof g.$Yn)return n;const i=new g.$Yn(n.message,g.ExtensionManagementErrorCode.Internal);return i.stack=n.stack,i}e.$ep=t;function c(n,i,{extensionData:r,verificationStatus:a,duration:v,error:y,durationSinceUpdate:u}){let E,D;(0,m.$te)(a)&&(a===!0?a="Verified":(a===!1||(E=g.ExtensionManagementErrorCode.Signature,D=a),a="Unverified")),y&&(y instanceof g.$Yn?(E=y.code,y.code===g.ExtensionManagementErrorCode.Signature&&(D=y.message)):E=g.ExtensionManagementErrorCode.Internal),n.publicLog(i,{...r,verificationStatus:a,success:!y,duration:v,errorcode:E,errorcodeDetail:D,durationSinceUpdate:u})}class s{constructor(){this.d=new N.$Dg}async waitUntilTaskIsFinished(){return await this.d.wait(),this.g}async run(){return this.g||(this.g=(0,N.$sg)(i=>this.h(i))),this.d.open(),this.g}cancel(){this.g||(this.g=(0,N.$sg)(i=>new Promise((r,a)=>{const v=i.onCancellationRequested(()=>{v.dispose(),a(new j.$3)})})),this.d.open()),this.g.cancel()}}e.$fp=s}),define(re[50],oe([0,1,5,14,2,3,35,11,29,33,13,4,7,17,27,9,8,21]),function(te,e,L,N,O,j,A,R,k,m,P,p,g,h,d,w,f,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ip=e.$hp=e.$gp=e.ExtensionsProfileScanningErrorCode=void 0;var l;(function(c){c.ERROR_PROFILE_NOT_FOUND="ERROR_PROFILE_NOT_FOUND",c.ERROR_INVALID_CONTENT="ERROR_INVALID_CONTENT"})(l||(e.ExtensionsProfileScanningErrorCode=l={}));class $ extends Error{constructor(s,n){super(s),this.code=n}}e.$gp=$,e.$hp=(0,p.$zh)("IExtensionsProfileScannerService");let b=class extends O.$mb{constructor(s,n,i,r,a,v){super(),this.i=s,this.j=n,this.k=i,this.l=r,this.m=a,this.n=v,this.b=this.B(new j.$hc),this.onAddExtensions=this.b.event,this.c=this.B(new j.$hc),this.onDidAddExtensions=this.c.event,this.f=this.B(new j.$hc),this.onRemoveExtensions=this.f.event,this.g=this.B(new j.$hc),this.onDidRemoveExtensions=this.g.event,this.h=new A.$xi}scanProfileExtensions(s,n){return this.p(s,void 0,n)}async addExtensionsToProfile(s,n){const i=[],r=[];try{return await this.p(n,a=>{const v=[];for(const y of a)s.some(([u])=>(0,m.$no)(u.identifier,y.identifier)&&u.manifest.version!==y.version)?i.push(y):v.push(y);for(const[y,u]of s){const E=v.findIndex(T=>(0,m.$no)(T.identifier,y.identifier)&&T.version===y.manifest.version),D={identifier:y.identifier,version:y.manifest.version,location:y.location,metadata:u};E===-1?(r.push(D),v.push(D)):v.splice(E,1,D)}return r.length&&this.b.fire({extensions:r,profileLocation:n}),i.length&&this.f.fire({extensions:i,profileLocation:n}),v}),r.length&&this.c.fire({extensions:r,profileLocation:n}),i.length&&this.g.fire({extensions:i,profileLocation:n}),r}catch(a){throw r.length&&this.c.fire({extensions:r,error:a,profileLocation:n}),i.length&&this.g.fire({extensions:i,error:a,profileLocation:n}),a}}async updateMetadata(s,n){const i=[];return await this.p(n,r=>{const a=[];for(const v of r){const y=s.find(([u])=>(0,m.$no)(u.identifier,v.identifier)&&u.manifest.version===v.version);y&&(v.metadata={...v.metadata,...y[1]},i.push(v)),a.push(v)}return a}),i}async removeExtensionFromProfile(s,n){const i=[];try{await this.p(n,r=>{const a=[];for(const v of r)(0,m.$no)(v.identifier,s.identifier)?i.push(v):a.push(v);return i.length&&this.f.fire({extensions:i,profileLocation:n}),a}),i.length&&this.g.fire({extensions:i,profileLocation:n})}catch(r){throw i.length&&this.g.fire({extensions:i,error:r,profileLocation:n}),r}}async p(s,n,i){return this.w(s).queue(async()=>{let r=[],a;try{const v=await this.j.readFile(s);a=JSON.parse(v.value.toString().trim()||"[]")}catch(v){if((0,P.$hk)(v)!==1)throw v;if(this.l.extUri.isEqual(s,this.k.defaultProfile.extensionsResource)&&(a=await this.v()),!a&&i?.bailOutWhenFileNotFound)throw new $((0,f.$8)(v),"ERROR_PROFILE_NOT_FOUND")}if(a){Array.isArray(a)||this.r(s);let v=!1;for(const y of a){I(y)||this.r(s);let u;if((0,w.$le)(y.relativeLocation)&&y.relativeLocation)u=this.t(y.relativeLocation);else if((0,w.$le)(y.location))u=this.t(y.location),v=!0,y.relativeLocation=y.location,y.location=u.toJSON();else{u=R.URI.revive(y.location);const E=this.s(u);E&&(v=!0,y.relativeLocation=E)}r.push({identifier:y.identifier,location:u,version:y.version,metadata:y.metadata})}v&&await this.j.writeFile(s,N.$Hc.fromString(JSON.stringify(a)))}if(n){r=n(r);const v=r.map(y=>({identifier:y.identifier,version:y.version,location:y.location.toJSON(),relativeLocation:this.s(y.location),metadata:y.metadata}));await this.j.writeFile(s,N.$Hc.fromString(JSON.stringify(v)))}return r})}r(s){const n=new $(`Invalid extensions content in ${s.toString()}`,"ERROR_INVALID_CONTENT");throw this.m.publicLogError2("extensionsProfileScanningError",{code:n.code}),n}s(s){return this.l.extUri.isEqual(this.l.extUri.dirname(s),this.i)?this.l.extUri.basename(s):void 0}t(s){return this.l.extUri.joinPath(this.i,s)}async v(){return this.u||(this.u=(async()=>{const s=this.l.extUri.joinPath(this.k.defaultProfile.location,"extensions.json"),n=this.l.extUri.joinPath(this.i,".init-default-profile-extensions");let i;try{i=(await this.j.readFile(s)).value.toString()}catch(a){if((0,P.$hk)(a)===1)return;throw a}this.n.info("Migrating extensions from old default profile location",s.toString());let r;try{const a=JSON.parse(i);Array.isArray(a)&&a.every(v=>I(v))?r=a:this.n.warn("Skipping migrating from old default profile locaiton: Found invalid data",a)}catch(a){this.n.error(a)}if(r)try{await this.j.createFile(this.k.defaultProfile.extensionsResource,N.$Hc.fromString(JSON.stringify(r)),{overwrite:!1}),this.n.info("Migrated extensions from old default profile location to new location",s.toString(),this.k.defaultProfile.extensionsResource.toString())}catch(a){if((0,P.$hk)(a)===3)this.n.info("Migration from old default profile location to new location is done by another window",s.toString(),this.k.defaultProfile.extensionsResource.toString());else throw a}try{await this.j.del(s)}catch(a){(0,P.$hk)(a)!==1&&this.n.error(a)}try{await this.j.del(n)}catch(a){(0,P.$hk)(a)!==1&&this.n.error(a)}return r})()),this.u}w(s){let n=this.h.get(s);return n||(n=new L.$Lg,this.h.set(s,n)),n}};e.$ip=b,e.$ip=b=ye([X(1,P.$4j),X(2,h.$Ck),X(3,d.$Ak),X(4,o.$7k),X(5,g.$3i)],b);function I(c){return(0,w.$ne)(c)&&(0,k.$Wn)(c.identifier)&&(t(c.location)||(0,w.$le)(c.location)&&c.location)&&((0,w.$se)(c.relativeLocation)||(0,w.$le)(c.relativeLocation))&&c.version&&(0,w.$le)(c.version)}function t(c){return c?(0,w.$le)(c.path)&&(0,w.$le)(c.scheme):!1}}),define(re[79],oe([0,1,20,5,30,14,8,34,138,2,22,15,6,23,53,89,9,11,154,16,33,45,67,13,4,7,24,3,63,50,17,27,182]),function(te,e,L,N,O,j,A,R,k,m,P,p,g,h,d,w,f,o,l,$,b,I,t,c,s,n,i,r,a,v,y,u,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pp=e.$op=e.$np=e.$mp=e.$lp=e.Translations=void 0;var D;(function(x){function G(Q,H){if(Q===H)return!0;const V=Object.keys(Q),B=new Set;for(const ee of Object.keys(H))B.add(ee);if(V.length!==B.size)return!1;for(const ee of V){if(Q[ee]!==H[ee])return!1;B.delete(ee)}return B.size===0}x.equals=G})(D||(e.Translations=D={})),e.$lp=(0,s.$zh)("IExtensionsScannerService");let T=class extends m.$mb{constructor(G,Q,H,V,B,ee,ne,se,K,U,S,C){super(),this.systemExtensionsLocation=G,this.userExtensionsLocation=Q,this.l=H,this.m=V,this.n=B,this.r=ee,this.s=ne,this.t=se,this.u=K,this.v=U,this.w=S,this.y=C,this.g=this.B(new r.$hc),this.onDidChangeCache=this.g.event,this.h=(0,h.$gg)(this.userExtensionsLocation,".obsolete"),this.i=this.B(this.y.createInstance(W,this.m,this.h)),this.j=this.B(this.y.createInstance(W,this.m,this.h)),this.k=this.B(this.y.createInstance(q,this.h)),this.C=void 0,this.B(this.i.onDidChangeCache(()=>this.g.fire(0))),this.B(this.j.onDidChangeCache(()=>this.g.fire(1)))}getTargetPlatform(){return this.z||(this.z=(0,b.$yo)(this.s,this.t)),this.z}async scanAllExtensions(G,Q,H){const[V,B]=await Promise.all([this.scanSystemExtensions(G),this.scanUserExtensions(Q)]),ee=H?await this.scanExtensionsUnderDevelopment(G,[...V,...B]):[];return this.G(V,B,ee,await this.getTargetPlatform(),!0)}async scanSystemExtensions(G){const Q=[];Q.push(this.H(!!G.useCache,G.language)),Q.push(this.I(G.language,!!G.checkControlFile));const[H,V]=await Promise.all(Q);return this.F([...H,...V],0,G,!1)}async scanUserExtensions(G){const Q=G.profileLocation??this.userExtensionsLocation;this.t.trace("Started scanning user extensions",Q);const H=this.w.extUri.isEqual(G.profileLocation,this.n.defaultProfile.extensionsResource)?{bailOutWhenFileNotFound:!0}:void 0,V=await this.L(Q,!!G.profileLocation,1,!G.includeUninstalled,G.language,!0,H),B=G.useCache&&!V.devMode&&V.excludeObsolete?this.j:this.k;let ee;try{ee=await B.scanExtensions(V)}catch(ne){if(ne instanceof v.$gp&&ne.code==="ERROR_PROFILE_NOT_FOUND")await this.D(),ee=await B.scanExtensions(V);else throw ne}return ee=await this.F(ee,1,G,!0),this.t.trace("Scanned user extensions:",ee.length),ee}async scanExtensionsUnderDevelopment(G,Q){if(this.u.isExtensionDevelopment&&this.u.extensionDevelopmentLocationURI){const H=(await Promise.all(this.u.extensionDevelopmentLocationURI.filter(V=>V.scheme===P.Schemas.file).map(async V=>{const B=await this.L(V,!1,1,!0,G.language,!1,void 0);return(await this.k.scanOneOrMultipleExtensions(B)).map(ne=>(ne.type=Q.find(se=>(0,b.$no)(se.identifier,ne.identifier))?.type??ne.type,this.k.validate(ne,B)))}))).flat();return this.F(H,"development",G,!0)}return[]}async scanExistingExtension(G,Q,H){const V=await this.L(G,!1,Q,!0,H.language,!0,void 0),B=await this.k.scanExtension(V);return!B||!H.includeInvalid&&!B.isValid?null:B}async scanOneOrMultipleExtensions(G,Q,H){const V=await this.L(G,!1,Q,!0,H.language,!0,void 0),B=await this.k.scanOneOrMultipleExtensions(V);return this.F(B,Q,H,!0)}async scanMetadata(G){const Q=(0,h.$gg)(G,"package.json"),H=(await this.s.readFile(Q)).value.toString();return JSON.parse(H).__metadata}async updateMetadata(G,Q){const H=(0,h.$gg)(G,"package.json"),V=(await this.s.readFile(H)).value.toString(),B=JSON.parse(V);Q.isMachineScoped=Q.isMachineScoped||void 0,Q.isBuiltin=Q.isBuiltin||void 0,B.__metadata={...B.__metadata,...Q},await this.s.writeFile((0,h.$gg)(G,"package.json"),j.$Hc.fromString(JSON.stringify(B,null,"	")))}async initializeDefaultProfileExtensions(){try{await this.r.scanProfileExtensions(this.n.defaultProfile.extensionsResource,{bailOutWhenFileNotFound:!0})}catch(G){if(G instanceof v.$gp&&G.code==="ERROR_PROFILE_NOT_FOUND")await this.D();else throw G}}async D(){return this.C||(this.C=(async()=>{try{this.t.info("Started initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString());const G=await this.scanUserExtensions({includeInvalid:!0});if(G.length)await this.r.addExtensionsToProfile(G.map(Q=>[Q,Q.metadata]),this.n.defaultProfile.extensionsResource);else try{await this.s.createFile(this.n.defaultProfile.extensionsResource,j.$Hc.fromString(JSON.stringify([])))}catch(Q){(0,c.$hk)(Q)!==1&&this.t.warn("Failed to create default profile extensions manifest in extensions installation folder.",this.userExtensionsLocation.toString(),(0,A.$8)(Q))}this.t.info("Completed initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString())}catch(G){this.t.error(G)}finally{this.C=void 0}})()),this.C}async F(G,Q,H,V){return H.includeAllVersions||(G=this.G(Q===0?G:void 0,Q===1?G:void 0,Q==="development"?G:void 0,await this.getTargetPlatform(),V)),H.includeInvalid||(G=G.filter(B=>B.isValid)),G.sort((B,ee)=>{const ne=p.$cd(B.location.fsPath),se=p.$cd(ee.location.fsPath);return ne<se?-1:ne>se?1:0})}G(G,Q,H,V,B){const ee=(se,K,U)=>{if(se.isValid&&!K.isValid)return!1;if(se.isValid===K.isValid){if(B&&d.gt(se.manifest.version,K.manifest.version))return this.t.debug(`Skipping extension ${K.location.path} with lower version ${K.manifest.version} in favour of ${se.location.path} with version ${se.manifest.version}`),!1;if(d.eq(se.manifest.version,K.manifest.version)){if(se.type===0)return this.t.debug(`Skipping extension ${K.location.path} in favour of system extension ${se.location.path} with same version`),!1;if(se.targetPlatform===V)return this.t.debug(`Skipping extension ${K.location.path} from different target platform ${K.targetPlatform}`),!1}}return U?this.t.warn(`Overwriting user extension ${se.location.path} with ${K.location.path}.`):this.t.debug(`Overwriting user extension ${se.location.path} with ${K.location.path}.`),!0},ne=new I.$Vl;return G?.forEach(se=>{const K=ne.get(se.identifier.id);(!K||ee(K,se,!1))&&ne.set(se.identifier.id,se)}),Q?.forEach(se=>{const K=ne.get(se.identifier.id);if(!K&&G&&se.type===0){this.t.debug(`Skipping obsolete system extension ${se.location.path}.`);return}(!K||ee(K,se,!1))&&ne.set(se.identifier.id,se)}),H?.forEach(se=>{const K=ne.get(se.identifier.id);(!K||ee(K,se,!0))&&ne.set(se.identifier.id,se),ne.set(se.identifier.id,se)}),[...ne.values()]}async H(G,Q){this.t.trace("Started scanning system extensions");const H=await this.L(this.systemExtensionsLocation,!1,0,!0,Q,!0,void 0),B=await(G&&!H.devMode?this.i:this.k).scanExtensions(H);return this.t.trace("Scanned system extensions:",B.length),B}async I(G,Q){const H=this.u.isBuilt?[]:this.v.builtInExtensions;if(!H?.length)return[];this.t.trace("Started scanning dev system extensions");const V=Q?await this.J():{},B=[],ee=o.URI.file(p.$9c(p.$$c(P.$4e.asFileUri("").fsPath,"..",".build","builtInExtensions")));for(const se of H){const K=V[se.name]||"marketplace";switch(K){case"disabled":break;case"marketplace":B.push((0,h.$gg)(ee,se.name));break;default:B.push(o.URI.file(K));break}}const ne=await Promise.all(B.map(async se=>this.k.scanExtension(await this.L(se,!1,0,!0,G,!0,void 0))));return this.t.trace("Scanned dev system extensions:",ne.length),(0,L.$Af)(ne)}async J(){try{const G=await this.s.readFile(this.l);return JSON.parse(G.value.toString())}catch{return{}}}async L(G,Q,H,V,B,ee,ne){const se=await this.f(B??g.$v),K=await this.M(G),U=Q&&!this.w.extUri.isEqual(G,this.n.defaultProfile.extensionsResource)?this.n.defaultProfile.extensionsResource:void 0,S=U?await this.M(U):void 0;return new F(G,K,U,S,Q,ne,H,V,ee,this.v.version,this.v.date,this.v.commit,!this.u.isBuilt,B,se)}async M(G){try{const Q=await this.s.stat(G);if(typeof Q.mtime=="number")return Q.mtime}catch{}}};e.$mp=T,e.$mp=T=ye([X(4,y.$Ck),X(5,v.$hp),X(6,c.$4j),X(7,n.$3i),X(8,$.$Gh),X(9,i.$ij),X(10,u.$Ak),X(11,s.$yh)],T);class F{constructor(G,Q,H,V,B,ee,ne,se,K,U,S,C,z,M,J){this.location=G,this.mtime=Q,this.applicationExtensionslocation=H,this.applicationExtensionslocationMtime=V,this.profile=B,this.profileScanOptions=ee,this.type=ne,this.excludeObsolete=se,this.validate=K,this.productVersion=U,this.productDate=S,this.productCommit=C,this.devMode=z,this.language=M,this.translations=J}static createNlsConfiguration(G){return{language:G.language,pseudo:G.language==="pseudo",devMode:G.devMode,translations:G.translations}}static equals(G,Q){return(0,h.$_f)(G.location,Q.location)&&G.mtime===Q.mtime&&(0,h.$_f)(G.applicationExtensionslocation,Q.applicationExtensionslocation)&&G.applicationExtensionslocationMtime===Q.applicationExtensionslocationMtime&&G.profile===Q.profile&&O.$Xm(G.profileScanOptions,Q.profileScanOptions)&&G.type===Q.type&&G.excludeObsolete===Q.excludeObsolete&&G.validate===Q.validate&&G.productVersion===Q.productVersion&&G.productDate===Q.productDate&&G.productCommit===Q.productCommit&&G.devMode===Q.devMode&&G.language===Q.language&&D.equals(G.translations,Q.translations)}}e.$np=F;let q=class extends m.$mb{constructor(G,Q,H,V,B){super(),this.f=G,this.g=Q,this.h=H,this.i=V,this.j=B}async scanExtensions(G){const Q=G.profile?await this.l(G):await this.k(G);let H={};if(G.excludeObsolete&&G.type===1)try{const V=(await this.i.readFile(this.f)).value.toString();H=JSON.parse(V)}catch{}return(0,f.$ye)(H)?Q:Q.filter(V=>!H[b.$oo.create(V).toString()])}async k(G){const Q=await this.i.resolve(G.location);if(!Q.children?.length)return[];const H=await Promise.all(Q.children.map(async V=>{if(!V.isDirectory||G.type===1&&(0,h.$dg)(V.resource).indexOf(".")===0)return null;const B=new F(V.resource,G.mtime,G.applicationExtensionslocation,G.applicationExtensionslocationMtime,G.profile,G.profileScanOptions,G.type,G.excludeObsolete,G.validate,G.productVersion,G.productDate,G.productCommit,G.devMode,G.language,G.translations);return this.scanExtension(B)}));return(0,L.$Af)(H).sort((V,B)=>V.location.path<B.location.path?-1:1)}async l(G){let Q=await this.m(G.location,()=>!0,G);if(G.applicationExtensionslocation&&!this.h.extUri.isEqual(G.location,G.applicationExtensionslocation)){Q=Q.filter(V=>!V.metadata?.isApplicationScoped);const H=await this.m(G.applicationExtensionslocation,V=>!!V.metadata?.isBuiltin||!!V.metadata?.isApplicationScoped,G);Q.push(...H)}return Q}async m(G,Q,H){const V=await this.g.scanProfileExtensions(G,H.profileScanOptions);if(!V.length)return[];const B=await Promise.all(V.map(async ee=>{if(Q(ee)){const ne=new F(ee.location,H.mtime,H.applicationExtensionslocation,H.applicationExtensionslocationMtime,H.profile,H.profileScanOptions,H.type,H.excludeObsolete,H.validate,H.productVersion,H.productDate,H.productCommit,H.devMode,H.language,H.translations);return this.scanExtension(ne,ee.metadata)}return null}));return(0,L.$Af)(B)}async scanOneOrMultipleExtensions(G){try{if(await this.i.exists((0,h.$gg)(G.location,"package.json"))){const Q=await this.scanExtension(G);return Q?[Q]:[]}else return await this.scanExtensions(G)}catch(Q){return this.j.error(`Error scanning extensions at ${G.location.path}:`,(0,A.$8)(Q)),[]}}async scanExtension(G,Q){try{let H=await this.scanExtensionManifest(G.location);if(H){H.publisher||(H.publisher=I.$Pl),Q=Q??H.__metadata,delete H.__metadata;const V=(0,b.$so)(H.publisher,H.name),B=Q?.id?{id:V,uuid:Q.id}:{id:V},ee=Q?.isSystem?0:G.type,ne=ee===0||!!Q?.isBuiltin;H=await this.n(G.location,H,F.createNlsConfiguration(G));const se={type:ee,identifier:B,manifest:H,location:G.location,isBuiltin:ne,targetPlatform:Q?.targetPlatform??"undefined",metadata:Q,isValid:!0,validations:[]};return G.validate?this.validate(se,G):se}}catch(H){G.type!==0&&this.j.error(H)}return null}validate(G,Q){let H=!0;const V=(0,t.$Do)(Q.productVersion,Q.productDate,Q.location,G.manifest,G.isBuiltin);for(const[B,ee]of V)B===w.default.Error&&(H=!1,this.j.error(this.u(Q.location,ee)));return G.isValid=H,G.validations=V,G}async scanExtensionManifest(G){const Q=(0,h.$gg)(G,"package.json");let H;try{H=(await this.i.readFile(Q)).value.toString()}catch(B){return(0,c.$hk)(B)!==1&&this.j.error(this.u(G,(0,l.localize)(0,null,Q.path,B.message))),null}let V;try{V=JSON.parse(H)}catch{const ee=[];(0,R.$Jm)(H,ee);for(const ne of ee)this.j.error(this.u(G,(0,l.localize)(1,null,Q.path,ne.offset,ne.length,(0,k.$jp)(ne.error))));return null}return(0,R.$Sm)(V)!=="object"?(this.j.error(this.u(G,(0,l.localize)(2,null,Q.path))),null):V}async n(G,Q,H){const V=await this.r(G,Q,H);if(V)try{const B=[],ee=await this.s(V.default,B);if(B.length>0)return B.forEach(se=>{this.j.error(this.u(G,(0,l.localize)(3,null,V.default?.path,(0,k.$jp)(se.error))))}),Q;if((0,R.$Sm)(V)!=="object")return this.j.error(this.u(G,(0,l.localize)(4,null,V.default?.path))),Q;const ne=V.values||Object.create(null);return(0,E.$kp)(this.j,Q,ne,ee)}catch{}return Q}async r(G,Q,H){const V=(0,h.$gg)(G,"package.nls.json"),B=(K,U)=>{U.forEach(S=>{this.j.error(this.u(G,(0,l.localize)(5,null,K?.path,(0,k.$jp)(S.error))))})},ee=K=>{this.j.error(this.u(G,(0,l.localize)(6,null,K?.path)))},ne=`${Q.publisher}.${Q.name}`,se=H.translations[ne];if(se)try{const K=o.URI.file(se),U=(await this.i.readFile(K)).value.toString(),S=[],C=(0,R.$Jm)(U,S);return S.length>0?(B(K,S),{values:void 0,default:V}):(0,R.$Sm)(C)!=="object"?(ee(K),{values:void 0,default:V}):{values:C.contents?C.contents.package:void 0,default:V}}catch{return{values:void 0,default:V}}else{if(!await this.i.exists(V))return;let U;try{U=await this.t(G,H)}catch{return}if(!U.localized)return{values:void 0,default:U.original};try{const S=(await this.i.readFile(U.localized)).value.toString(),C=[],z=(0,R.$Jm)(S,C);return C.length>0?(B(U.localized,C),{values:void 0,default:U.original}):(0,R.$Sm)(z)!=="object"?(ee(U.localized),{values:void 0,default:U.original}):{values:z,default:U.original}}catch{return{values:void 0,default:U.original}}}}async s(G,Q){if(G)try{const H=(await this.i.readFile(G)).value.toString();return(0,R.$Jm)(H,Q)}catch{}}t(G,Q){return new Promise((H,V)=>{const B=ee=>{const ne=(0,h.$gg)(G,`package.nls.${ee}.json`);this.i.exists(ne).then(se=>{se&&H({localized:ne,original:(0,h.$gg)(G,"package.nls.json")});const K=ee.lastIndexOf("-");K===-1?H({localized:(0,h.$gg)(G,"package.nls.json"),original:null}):(ee=ee.substring(0,K),B(ee))})};if(Q.devMode||Q.pseudo||!Q.language)return H({localized:(0,h.$gg)(G,"package.nls.json"),original:null});B(Q.language)})}u(G,Q){return`[${G.path}]: ${Q}`}};q=ye([X(1,v.$hp),X(2,u.$Ak),X(3,c.$4j),X(4,n.$3i)],q);let W=class extends q{constructor(G,Q,H,V,B,ee,ne){super(Q,V,B,ee,ne),this.z=G,this.C=H,this.w=this.B(new N.$Cg(3e3)),this.y=this.B(new r.$hc),this.onDidChangeCache=this.y.event}async scanExtensions(G){const Q=this.H(G),H=await this.D(Q);if(this.v=G,H&&H.input&&F.equals(H.input,this.v))return this.j.debug("Using cached extensions scan result",G.location.toString()),this.w.trigger(()=>this.G()),H.result.map(B=>(B.location=o.URI.revive(B.location),B));const V=await super.scanExtensions(G);return await this.F(Q,{input:G,result:V}),V}async D(G){try{const Q=await this.i.readFile(G),H=JSON.parse(Q.value.toString());return{result:H.result,input:(0,a.$9g)(H.input)}}catch(Q){this.j.debug("Error while reading the extension cache file:",G.path,(0,A.$8)(Q))}return null}async F(G,Q){try{await this.i.writeFile(G,j.$Hc.fromString(JSON.stringify(Q)))}catch(H){this.j.debug("Error while writing the extension cache file:",G.path,(0,A.$8)(H))}}async G(){if(!this.v)return;const G=this.H(this.v),Q=await this.D(G);if(!Q)return;const H=Q.result,V=JSON.parse(JSON.stringify(await super.scanExtensions(this.v)));if(!O.$Xm(V,H))try{this.j.info("Invalidating Cache",H,V),await this.i.del(G),this.y.fire()}catch(B){this.j.error(B)}}H(G){const Q=this.I(G);return this.h.extUri.joinPath(Q.cacheHome,G.type===0?I.$Ol:I.$Nl)}I(G){return G.type===0?this.C.defaultProfile:G.profile?this.h.extUri.isEqual(G.location,this.z.extensionsResource)?this.z:this.C.profiles.find(Q=>this.h.extUri.isEqual(G.location,Q.extensionsResource))??this.z:this.C.defaultProfile}};W=ye([X(2,y.$Ck),X(3,v.$hp),X(4,u.$Ak),X(5,c.$4j),X(6,n.$3i)],W);function Z(x,G){const Q=(0,b.$qo)(x.manifest.publisher,x.manifest.name);return{id:Q,identifier:new I.$Tl(Q),isBuiltin:x.type===0,isUserBuiltin:x.type===1&&x.isBuiltin,isUnderDevelopment:G,extensionLocation:x.location,uuid:x.identifier.uuid,targetPlatform:x.targetPlatform,...x.manifest}}e.$op=Z;class Y extends T{constructor(G,Q,H,V,B,ee,ne,se,K,U,S,C){super(G,Q,(0,h.$gg)(H,".vscode-oss-dev","extensions","control.json"),V,B,ee,ne,se,K,U,S,C),this.N=(async()=>{if(g.$y)try{const z=await this.s.readFile(o.URI.file(g.$y));return JSON.parse(z.value.toString())}catch{}return Object.create(null)})()}f(G){return this.N}}e.$pp=Y}),define(re[243],oe([0,1,64,5,38,3,2,22,15,31,7,17]),function(te,e,L,N,O,j,A,R,k,m,P,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rp=void 0;let g=class extends A.$mb{constructor(d,w){super(),this.b=d,this.f=w,this.a=new N.$Kg(5)}async postUninstall(d){const w=this.g(d,"uninstall");w&&(this.f.info(d.identifier.id,d.manifest.version,"Running post uninstall script"),await this.a.queue(async()=>{try{await this.h(w.script,"uninstall",w.args,!0,d),this.f.info("Finished running post uninstall script",d.identifier.id,d.manifest.version)}catch(f){this.f.error("Failed to run post uninstall script",d.identifier.id,d.manifest.version),this.f.error(f)}}));try{await m.Promises.rm(this.j(d))}catch(f){this.f.error("Error while removing extension storage path",d.identifier.id),this.f.error(f)}}g(d,w){const f=`vscode:${w}`;if(d.location.scheme===R.Schemas.file&&d.manifest&&d.manifest.scripts&&typeof d.manifest.scripts[f]=="string"){const o=d.manifest.scripts[f].split(" ");return o.length<2||o[0]!=="node"||!o[1]?(this.f.warn(d.identifier.id,d.manifest.version,`${f} should be a node script`),null):{script:(0,k.$$c)(d.location.fsPath,o[1]),args:o.slice(2)||[]}}return null}h(d,w,f,o,l){return new Promise(($,b)=>{const I=this.i(d,w,f,l);let t;const c=s=>{t&&(clearTimeout(t),t=null),s?b(s):$(void 0)};I.on("error",s=>{c((0,O.$ki)(s)||"Unknown")}),I.on("exit",(s,n)=>{c(s?`post-${w} process exited with code ${s}`:void 0)}),o&&(t=setTimeout(()=>{t=null,I.kill(),b("timed out")},5e3))})}i(d,w,f,o){const l={silent:!0,execArgv:void 0},$=(0,L.fork)(d,[`--type=extension-post-${w}`,...f],l);$.stdout.setEncoding("utf8"),$.stderr.setEncoding("utf8");const b=j.Event.fromNodeEventEmitter($.stdout,"data"),I=j.Event.fromNodeEventEmitter($.stderr,"data");b(s=>this.f.info(o.identifier.id,o.manifest.version,`post-${w}`,s)),I(s=>this.f.error(o.identifier.id,o.manifest.version,`post-${w}`,s));const t=j.Event.any(j.Event.map(b,s=>({data:`%c${s}`,format:[""]})),j.Event.map(I,s=>({data:`%c${s}`,format:["color: red"]})));return j.Event.debounce(t,(s,n)=>s?{data:s.data+n.data,format:[...s.format,...n.format]}:{data:n.data,format:n.format},100)(s=>{console.group(o.identifier.id),console.log(s.data,...s.format),console.groupEnd()}),$}j(d){return(0,k.$$c)(this.b.defaultProfile.globalStorageHome.fsPath,d.identifier.id.toLowerCase())}};e.$rp=g,e.$rp=g=ye([X(0,p.$Ck),X(1,P.$3i)],g)}),define(re[244],oe([0,1,7,17,27,21,50,13,16,11]),function(te,e,L,N,O,j,A,R,k,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eN=void 0;let P=class extends A.$ip{constructor(g,h,d,w,f,o){super(m.URI.file(g.extensionsPath),h,d,w,f,o)}};e.$eN=P,e.$eN=P=ye([X(0,k.$Hh),X(1,R.$4j),X(2,N.$Ck),X(3,O.$Ak),X(4,j.$7k),X(5,L.$3i)],P)}),define(re[245],oe([0,1,11,16,50,79,13,4,7,24,27,17]),function(te,e,L,N,O,j,A,R,k,m,P,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$p6b=void 0;let g=class extends j.$pp{constructor(d,w,f,o,l,$,b,I){super(L.URI.file(l.builtinExtensionsPath),L.URI.file(l.extensionsPath),l.userHome,d.defaultProfile,d,w,f,o,l,$,b,I)}};e.$p6b=g,e.$p6b=g=ye([X(0,p.$Ck),X(1,O.$hp),X(2,A.$4j),X(3,k.$3i),X(4,N.$Hh),X(5,m.$ij),X(6,P.$Ak),X(7,R.$yh)],g)}),define(re[19],oe([0,1,5,3,2,100,9,66,4,17]),function(te,e,L,N,O,j,A,R,k,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xo=e.$Wo=e.$Vo=e.$Uo=e.$To=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.$So=e.$Ro=e.$Qo=void 0,e.$Qo="__$__isNewStorageMarker",e.$Ro="__$__targetStorageMarker",e.$So=(0,k.$zh)("storageService");var P;(function(l){l[l.NONE=0]="NONE",l[l.SHUTDOWN=1]="SHUTDOWN"})(P||(e.WillSaveStateReason=P={}));var p;(function(l){l[l.APPLICATION=-1]="APPLICATION",l[l.PROFILE=0]="PROFILE",l[l.WORKSPACE=1]="WORKSPACE"})(p||(e.StorageScope=p={}));var g;(function(l){l[l.USER=0]="USER",l[l.MACHINE=1]="MACHINE"})(g||(e.StorageTarget=g={}));function h(l){const $=l.get(e.$Ro);if($)try{return JSON.parse($)}catch{}return Object.create(null)}e.$To=h;class d extends O.$mb{static{this.a=60*1e3}constructor($={flushInterval:d.a}){super(),this.j=$,this.b=this.B(new N.$kc),this.c=this.B(new N.$kc),this.onDidChangeTarget=this.c.event,this.f=this.B(new N.$hc),this.onWillSaveState=this.f.event,this.h=this.B(new L.$Qg(()=>this.k(),this.j.flushInterval)),this.i=this.B(new O.$nb),this.v=void 0,this.y=void 0,this.C=void 0}onDidChangeValue($,b,I){return N.Event.filter(this.b.event,t=>t.scope===$&&(b===void 0||t.key===b),I)}k(){this.i.value=(0,L.$Ug)(()=>{this.l()&&this.flush(),this.h.schedule()})}l(){return!0}m(){(0,O.$hb)([this.i,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,j.mark)("code/willInitStorage");try{await this.J()}finally{(0,j.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}n($,b){const{key:I,external:t}=b;if(I===e.$Ro){switch($){case-1:this.C=void 0;break;case 0:this.y=void 0;break;case 1:this.v=void 0;break}this.c.fire({scope:$})}else this.b.fire({scope:$,key:I,target:this.F($)[I],external:t})}r($){this.f.fire({reason:$})}get($,b,I){return this.L(b)?.get($,I)}getBoolean($,b,I){return this.L(b)?.getBoolean($,I)}getNumber($,b,I){return this.L(b)?.getNumber($,I)}getObject($,b,I){return this.L(b)?.getObject($,I)}storeAll($,b){this.t(()=>{for(const I of $)this.store(I.key,I.value,I.scope,I.target,b)})}store($,b,I,t,c=!1){if((0,A.$ue)(b)){this.remove($,I,c);return}this.t(()=>{this.u($,I,t),this.L(I)?.set($,b,c)})}remove($,b,I=!1){this.t(()=>{this.u($,b,void 0),this.L(b)?.delete($,I)})}t($){this.b.pause(),this.c.pause();try{$()}finally{this.b.resume(),this.c.resume()}}keys($,b){const I=[],t=this.F($);for(const c of Object.keys(t))t[c]===b&&I.push(c);return I}u($,b,I,t=!1){const c=this.F(b);typeof I=="number"?c[$]!==I&&(c[$]=I,this.L(b)?.set(e.$Ro,JSON.stringify(c),t)):typeof c[$]=="number"&&(delete c[$],this.L(b)?.set(e.$Ro,JSON.stringify(c),t))}get w(){return this.v||(this.v=this.G(1)),this.v}get z(){return this.y||(this.y=this.G(0)),this.y}get D(){return this.C||(this.C=this.G(-1)),this.C}F($){switch($){case-1:return this.D;case 0:return this.z;default:return this.w}}G($){const b=this.L($);return b?h(b):Object.create(null)}isNew($){return this.getBoolean(e.$Qo,$)===!0}async flush($=P.NONE){this.f.fire({reason:$});const b=this.L(-1),I=this.L(0),t=this.L(1);switch($){case P.NONE:await L.Promises.settled([b?.whenFlushed()??Promise.resolve(),I?.whenFlushed()??Promise.resolve(),t?.whenFlushed()??Promise.resolve()]);break;case P.SHUTDOWN:await L.Promises.settled([b?.flush(0)??Promise.resolve(),I?.flush(0)??Promise.resolve(),t?.flush(0)??Promise.resolve()]);break}}async log(){const $=this.L(-1)?.items??new Map,b=this.L(0)?.items??new Map,I=this.L(1)?.items??new Map;return o($,b,I,this.M(-1)??"",this.M(0)??"",this.M(1)??"")}async optimize($){return await this.flush(),this.L($)?.optimize()}async switch($,b){return this.r(P.NONE),(0,m.$Bk)($)?this.N($,b):this.O($,b)}H($,b){return!($.id===b.id||w(b)&&w($))}I($,b,I){this.t(()=>{const t=new Set;for(const[c,s]of $)t.add(c),b.get(c)!==s&&this.n(I,{key:c,external:!0});for(const[c]of b.items)t.has(c)||this.n(I,{key:c,external:!0})})}}e.$Uo=d;function w(l){return l.isDefault||!!l.useDefaultFlags?.globalState}e.$Vo=w;class f extends d{constructor(){super(),this.p=this.B(new R.$Oo(new R.$Po,{hint:R.StorageHint.STORAGE_IN_MEMORY})),this.P=this.B(new R.$Oo(new R.$Po,{hint:R.StorageHint.STORAGE_IN_MEMORY})),this.Q=this.B(new R.$Oo(new R.$Po,{hint:R.StorageHint.STORAGE_IN_MEMORY})),this.B(this.Q.onDidChangeStorage($=>this.n(1,$))),this.B(this.P.onDidChangeStorage($=>this.n(0,$))),this.B(this.p.onDidChangeStorage($=>this.n(-1,$)))}L($){switch($){case-1:return this.p;case 0:return this.P;default:return this.Q}}M($){switch($){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async J(){}async N(){}async O(){}l(){return!1}hasScope($){return!1}}e.$Wo=f;async function o(l,$,b,I,t,c){const s=D=>{try{return JSON.parse(D)}catch{return D}},n=new Map,i=new Map;l.forEach((D,T)=>{n.set(T,D),i.set(T,s(D))});const r=new Map,a=new Map;$.forEach((D,T)=>{r.set(T,D),a.set(T,s(D))});const v=new Map,y=new Map;b.forEach((D,T)=>{v.set(T,D),y.set(T,s(D))}),console.group(I!==t?`Storage: Application (path: ${I})`:`Storage: Application & Profile (path: ${I}, default profile)`);const u=[];if(n.forEach((D,T)=>{u.push({key:T,value:D})}),console.table(u),console.groupEnd(),console.log(i),I!==t){console.group(`Storage: Profile (path: ${t}, profile specific)`);const D=[];r.forEach((T,F)=>{D.push({key:F,value:T})}),console.table(D),console.groupEnd(),console.log(a)}console.group(`Storage: Workspace (path: ${c})`);const E=[];v.forEach((D,T)=>{E.push({key:T,value:D})}),console.table(E),console.groupEnd(),console.log(y)}e.$Xo=o}),define(re[114],oe([0,1,3,2,9,29,33,19]),function(te,e,L,N,O,j,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$azb=e.$_yb=void 0;let k=class extends N.$mb{constructor(p,g){super(),this.a=new L.$hc,this.onDidChangeEnablement=this.a.event,this.b=this.B(new m(p)),this.B(this.b.onDidChange(h=>this.a.fire({extensions:h,source:"storage"}))),this.B(g.onDidInstallExtensions(h=>h.forEach(({local:d,operation:w})=>{d&&w===4&&this.f(d.identifier)})))}async enableExtension(p,g){return this.f(p)?(this.a.fire({extensions:[p],source:g}),!0):!1}async disableExtension(p,g){return this.c(p)?(this.a.fire({extensions:[p],source:g}),!0):!1}getDisabledExtensions(){return this.h(j.$1n)}async getDisabledExtensionsAsync(){return this.getDisabledExtensions()}c(p){const g=this.getDisabledExtensions();return g.every(h=>!(0,A.$no)(h,p))?(g.push(p),this.g(g),!0):!1}f(p){const g=this.getDisabledExtensions();for(let h=0;h<g.length;h++){const d=g[h];if((0,A.$no)(d,p))return g.splice(h,1),this.g(g),!0}return!1}g(p){this.i(j.$1n,p)}h(p){return this.b.get(p,0)}i(p,g){this.b.set(p,g,0)}};e.$_yb=k,e.$_yb=k=ye([X(0,R.$So),X(1,j.$Zn)],k);class m extends N.$mb{constructor(p){super(),this.c=p,this.a=Object.create(null),this.b=this.B(new L.$hc),this.onDidChange=this.b.event,this.B(p.onDidChangeValue(0,void 0,this.B(new N.$lb))(g=>this.f(g)))}get(p,g){let h;return g===0?((0,O.$ue)(this.a[p])&&(this.a[p]=this.g(p,g)),h=this.a[p]):h=this.g(p,g),JSON.parse(h)}set(p,g,h){const d=JSON.stringify(g.map(({id:f,uuid:o})=>({id:f,uuid:o})));this.g(p,h)!==d&&(h===0&&(g.length?this.a[p]=d:delete this.a[p]),this.h(p,g.length?d:void 0,h))}f(p){if(!(0,O.$ue)(this.a[p.key])&&this.g(p.key,p.scope)!==this.a[p.key]){const h=this.get(p.key,p.scope);delete this.a[p.key];const d=this.get(p.key,p.scope),w=h.filter(o=>!d.some(l=>(0,A.$no)(o,l))),f=d.filter(o=>!h.some(l=>(0,A.$no)(l,o)));(w.length||f.length)&&this.b.fire([...w,...f])}}g(p,g){return this.c.get(p,g,"[]")}h(p,g,h){g?this.c.store(p,g,h,1):this.c.remove(p,h)}}e.$azb=m}),define(re[246],oe([0,1,20,26,8,6,37,9,11,18,16,29,33,67,13,7,24,57,223,19,21,60]),function(te,e,L,N,O,j,A,R,k,m,P,p,g,h,d,w,f,o,l,$,b,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3o=e.$2o=e.$1o=void 0;const t=j.$o?"web":(0,p.$Sn)(j.$t,A.$6c),c="X-Market-Search-Activity-Id";var s;(function(S){S[S.None=0]="None",S[S.IncludeVersions=1]="IncludeVersions",S[S.IncludeFiles=2]="IncludeFiles",S[S.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",S[S.IncludeSharedAccounts=8]="IncludeSharedAccounts",S[S.IncludeVersionProperties=16]="IncludeVersionProperties",S[S.ExcludeNonValidated=32]="ExcludeNonValidated",S[S.IncludeInstallationTargets=64]="IncludeInstallationTargets",S[S.IncludeAssetUri=128]="IncludeAssetUri",S[S.IncludeStatistics=256]="IncludeStatistics",S[S.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",S[S.Unpublished=4096]="Unpublished",S[S.IncludeNameConflictInfo=32768]="IncludeNameConflictInfo"})(s||(s={}));function n(...S){return String(S.reduce((C,z)=>C|z,0))}var i;(function(S){S[S.Tag=1]="Tag",S[S.ExtensionId=4]="ExtensionId",S[S.Category=5]="Category",S[S.ExtensionName=7]="ExtensionName",S[S.Target=8]="Target",S[S.Featured=9]="Featured",S[S.SearchText=10]="SearchText",S[S.ExcludeWithFlags=12]="ExcludeWithFlags"})(i||(i={}));const r={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source",Signature:"Microsoft.VisualStudio.Services.VsixSignature"},a={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",PreRelease:"Microsoft.VisualStudio.Code.PreRelease",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension",SponsorLink:"Microsoft.VisualStudio.Code.SponsorLink"},y={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:s.None,criteria:[],assetTypes:[]};class u{constructor(C=y){this.d=C}get pageNumber(){return this.d.pageNumber}get pageSize(){return this.d.pageSize}get sortBy(){return this.d.sortBy}get sortOrder(){return this.d.sortOrder}get flags(){return this.d.flags}get criteria(){return this.d.criteria}withPage(C,z=this.d.pageSize){return new u({...this.d,pageNumber:C,pageSize:z})}withFilter(C,...z){const M=[...this.d.criteria,...z.length?z.map(J=>({filterType:C,value:J})):[{filterType:C}]];return new u({...this.d,criteria:M})}withSortBy(C){return new u({...this.d,sortBy:C})}withSortOrder(C){return new u({...this.d,sortOrder:C})}withFlags(...C){return new u({...this.d,flags:C.reduce((z,M)=>z|M,0)})}withAssetTypes(...C){return new u({...this.d,assetTypes:C})}withSource(C){return new u({...this.d,source:C})}get raw(){const{criteria:C,pageNumber:z,pageSize:M,sortBy:J,sortOrder:_,flags:ae,assetTypes:he}=this.d;return{filters:[{criteria:C,pageNumber:z,pageSize:M,sortBy:J,sortOrder:_}],assetTypes:he,flags:ae}}get searchText(){const C=this.d.criteria.filter(z=>z.filterType===i.SearchText)[0];return C&&C.value?C.value:""}get telemetryData(){return{filterTypes:this.d.criteria.map(C=>String(C.filterType)),flags:this.d.flags,sortBy:String(this.sortBy),sortOrder:String(this.sortOrder),pageNumber:String(this.pageNumber),source:this.d.source,searchTextLength:this.searchText.length}}}function E(S,C){const z=(S||[]).filter(M=>M.statisticName===C)[0];return z?z.value:0}function D(S){const C="Microsoft.VisualStudio.Code.Translation.";return S.files.filter(M=>M.assetType.indexOf(C)===0).reduce((M,J)=>{const _=q(S,J.assetType);return _&&M.push([J.assetType.substring(C.length),_]),M},[])}function T(S){if(S.properties){const C=S.properties.filter(J=>J.key===r.Repository),z=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),M=C.filter(J=>z.test(J.value))[0];return M?{uri:M.value,fallbackUri:M.value}:null}return q(S,r.Repository)}function F(S){return{uri:`${S.fallbackAssetUri}/${r.VSIX}?redirect=true${S.targetPlatform?`&targetPlatform=${S.targetPlatform}`:""}`,fallbackUri:`${S.fallbackAssetUri}/${r.VSIX}${S.targetPlatform?`?targetPlatform=${S.targetPlatform}`:""}`}}function q(S,C){return S.files.filter(M=>M.assetType===C)[0]?{uri:`${S.assetUri}/${C}${S.targetPlatform?`?targetPlatform=${S.targetPlatform}`:""}`,fallbackUri:`${S.fallbackAssetUri}/${C}${S.targetPlatform?`?targetPlatform=${S.targetPlatform}`:""}`}:null}function W(S,C){const z=S.properties?S.properties.filter(J=>J.key===C):[],M=z.length>0&&z[0].value;return M?M.split(",").map(J=>(0,g.$ro)(J)):[]}function Z(S){const C=S.properties?S.properties.filter(z=>z.key===a.Engine):[];return C.length>0&&C[0].value||""}function Y(S){const C=S.properties?S.properties.filter(z=>z.key===a.PreRelease):[];return C.length>0&&C[0].value==="true"}function x(S){const C=S.properties?S.properties.filter(M=>M.key===a.LocalizedLanguages):[],z=C.length>0&&C[0].value||"";return z?z.split(","):[]}function G(S){return S.properties?.find(C=>C.key===a.SponsorLink)?.value}function Q(S){return S.indexOf("preview")!==-1}function H(S){return S.targetPlatform?(0,p.$Rn)(S.targetPlatform):"undefined"}function V(S){const C=(0,L.$Ff)(S.versions.map(H)),z=!!S.tags?.includes(p.$Mn),M=C.indexOf("web");return z?M===-1&&C.push("web"):M!==-1&&C.splice(M,1),C}function B(S,C){const z=(0,p.$Vn)(C);for(let M=0;M<S.length;M++){const J=S[M];if(J.version===S[M-1]?.version){let _=M;const ae=H(J);if(ae===C)for(;_>0&&S[_-1].version===J.version;)_--;else if(z.includes(ae))for(;_>0&&S[_-1].version===J.version&&H(S[_-1])!==C;)_--;_!==M&&(S.splice(M,1),S.splice(_,0,J))}}return S}e.$1o=B;function ee(S,C,z){S.telemetryData={index:C,querySource:z,queryActivityId:S.queryContext?.[c]}}function ne(S,C,z,M){const J=S.versions[0],_={manifest:q(C,r.Manifest),readme:q(C,r.Details),changelog:q(C,r.Changelog),license:q(C,r.License),repository:T(C),download:F(C),icon:q(C,r.Icon),signature:q(C,r.Signature),coreTranslations:D(C)};return{identifier:{id:(0,g.$so)(S.publisher.publisherName,S.extensionName),uuid:S.extensionId},name:S.extensionName,version:C.version,displayName:S.displayName,publisherId:S.publisher.publisherId,publisher:S.publisher.publisherName,publisherDisplayName:S.publisher.displayName,publisherDomain:S.publisher.domain?{link:S.publisher.domain,verified:!!S.publisher.isDomainVerified}:void 0,publisherSponsorLink:G(J),description:S.shortDescription||"",installCount:E(S.statistics,"install"),rating:E(S.statistics,"averagerating"),ratingCount:E(S.statistics,"ratingcount"),categories:S.categories||[],tags:S.tags||[],releaseDate:Date.parse(S.releaseDate),lastUpdated:Date.parse(S.lastUpdated),allTargetPlatforms:z,assets:_,properties:{dependencies:W(C,a.Dependency),extensionPack:W(C,a.ExtensionPack),engine:Z(C),localizedLanguages:x(C),targetPlatform:H(C),isPreReleaseVersion:Y(C)},hasPreReleaseVersion:Y(J),hasReleaseVersion:!0,preview:Q(S.flags),isSigned:!!_.signature,queryContext:M}}let se=class{constructor(C,z,M,J,_,ae,he,fe){this.k=z,this.l=M,this.n=J,this.o=_,this.q=ae,this.u=he,this.w=fe;const le=he.extensionsGallery,$e=le?.servicePPEUrl&&fe.getValue("_extensionsGallery.enablePPE");this.d=$e?le.servicePPEUrl:le?.serviceUrl,this.g=$e?void 0:le?.searchUrl,this.h=le?.controlUrl,this.j=(0,l.$Zo)(he.version,he,this.n,this.w,this.q,C,this.o)}x(C=""){return`${this.d}${C}`}isEnabled(){return!!this.d}async getExtensions(C,z,M){const J=N.CancellationToken.isCancellationToken(z)?{}:z,_=N.CancellationToken.isCancellationToken(z)?z:M,ae=[],he=[],fe=[],le=[];let $e=!0;for(const ke of C){ke.uuid?he.push(ke.uuid):ae.push(ke.id);const Ie=!!(ke.version||ke.preRelease);fe.push({id:ke.id,uuid:ke.uuid,includePreRelease:Ie}),ke.version&&le.push({id:ke.id,uuid:ke.uuid,version:ke.version}),$e=$e&&!!ke.hasPreRelease&&!Ie}if(!he.length&&!ae.length)return[];let de=new u().withPage(1,C.length);he.length&&(de=de.withFilter(i.ExtensionId,...he)),ae.length&&(de=de.withFilter(i.ExtensionName,...ae)),(J.queryAllVersions||$e)&&(de=de.withFlags(de.flags,s.IncludeVersions)),J.source&&(de=de.withSource(J.source));const{extensions:we}=await this.z(de,{targetPlatform:J.targetPlatform??t,includePreRelease:fe,versions:le,compatible:!!J.compatible},_);return J.source&&we.forEach((ke,Ie)=>ee(ke,Ie,J.source)),we}async getCompatibleExtension(C,z,M){if((0,p.$Tn)(C.allTargetPlatforms,M))return null;if(await this.isExtensionCompatible(C,z,M))return C;const J=new u().withFlags(s.IncludeVersions).withPage(1,1).withFilter(i.ExtensionId,C.identifier.uuid),{extensions:_}=await this.z(J,{targetPlatform:M,compatible:!0,includePreRelease:z},N.CancellationToken.None);return _[0]||null}async isExtensionCompatible(C,z,M){if(!(0,p.$Un)(C.properties.targetPlatform,C.allTargetPlatforms,M)||!z&&C.properties.isPreReleaseVersion)return!1;let J=C.properties.engine;if(!J){const _=await this.getManifest(C,N.CancellationToken.None);if(!_)throw new Error("Manifest was not found");J=_.engines.vscode}return(0,h.$Fo)(J,this.u.version,this.u.date)}async y(C,z,M,J,_){if(!(0,p.$Un)(H(C),J,_)||z!=="any"&&Y(C)!==(z==="prerelease"))return!1;if(M)try{const ae=await this.E(C);if(!(0,h.$Fo)(ae,this.u.version,this.u.date))return!1}catch(ae){return this.l.error(`Error while getting the engine for the version ${C.version}.`,(0,O.$8)(ae)),!1}return!0}async query(C,z){let M=C.text||"";const J=C.pageSize??50;let _=new u().withPage(1,J);M?(M=M.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,($e,de,we)=>(_=_.withFilter(i.Category,we||de),"")),M=M.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,($e,de,we)=>(_=_.withFilter(i.Tag,we||de),"")),M=M.replace(/\bfeatured(\s+|\b|$)/g,()=>(_=_.withFilter(i.Featured),"")),M=M.trim(),M&&(M=M.length<200?M:M.substring(0,200),_=_.withFilter(i.SearchText,M)),_=_.withSortBy(0)):C.ids?_=_.withFilter(i.ExtensionId,...C.ids):C.names?_=_.withFilter(i.ExtensionName,...C.names):_=_.withSortBy(4),typeof C.sortBy=="number"&&(_=_.withSortBy(C.sortBy)),typeof C.sortOrder=="number"&&(_=_.withSortOrder(C.sortOrder)),C.source&&(_=_.withSource(C.source));const ae=async($e,de)=>{const{extensions:we,total:ke}=await this.z($e,{targetPlatform:t,compatible:!1,includePreRelease:!!C.includePreRelease},de);return we.forEach((Ie,je)=>ee(Ie,($e.pageNumber-1)*$e.pageSize+je,C.source)),{extensions:we,total:ke}},{extensions:he,total:fe}=await ae(_,z),le=async($e,de)=>{if(de.isCancellationRequested)throw new O.$3;const{extensions:we}=await ae(_.withPage($e+1),de);return we};return{firstPage:he,total:fe,pageSize:_.pageSize,getPage:le}}async z(C,z,M){const J=C.flags;C.flags&s.IncludeLatestVersionOnly&&C.flags&s.IncludeVersions&&(C=C.withFlags(C.flags&~s.IncludeVersions,s.IncludeLatestVersionOnly)),!(C.flags&s.IncludeLatestVersionOnly)&&!(C.flags&s.IncludeVersions)&&(C=C.withFlags(C.flags,s.IncludeLatestVersionOnly)),z.versions?.length&&(C=C.withFlags(C.flags&~s.IncludeLatestVersionOnly,s.IncludeVersions)),C=C.withFlags(C.flags,s.IncludeAssetUri,s.IncludeCategoryAndTags,s.IncludeFiles,s.IncludeStatistics,s.IncludeVersionProperties);const{galleryExtensions:_,total:ae,context:he}=await this.B(C,M);if(!(C.flags&s.IncludeLatestVersionOnly)){const de=[];for(const we of _){const ke=await this.A(we,z,he);ke&&de.push(ke)}return{extensions:de,total:ae}}const le=[],$e=new Map;for(let de=0;de<_.length;de++){const we=_[de],ke={id:(0,g.$so)(we.publisher.publisherName,we.extensionName),uuid:we.extensionId},Ie=(0,R.$re)(z.includePreRelease)?z.includePreRelease:!!z.includePreRelease.find(Ue=>(0,g.$no)(Ue,ke))?.includePreRelease;if(z.compatible&&(0,p.$Tn)(V(we),z.targetPlatform))continue;const je=await this.A(we,z,he);!je||je.properties.isPreReleaseVersion&&(!Ie||!je.hasReleaseVersion)||!je.properties.isPreReleaseVersion&&je.properties.targetPlatform!==z.targetPlatform&&je.hasPreReleaseVersion?$e.set(we.extensionId,de):le.push([de,je])}if($e.size){const de=new I.$dc,we=new u().withFlags(J&~s.IncludeLatestVersionOnly,s.IncludeVersions).withPage(1,$e.size).withFilter(i.ExtensionId,...$e.keys()),{extensions:ke}=await this.z(we,z,M);this.o.publicLog2("galleryService:additionalQuery",{duration:de.elapsed(),count:$e.size});for(const Ie of ke){const je=$e.get(Ie.identifier.uuid);le.push([je,Ie])}}return{extensions:le.sort((de,we)=>de[0]-we[0]).map(([,de])=>de),total:ae}}async A(C,z,M){const J={id:(0,g.$so)(C.publisher.publisherName,C.extensionName),uuid:C.extensionId},_=z.versions?.find(le=>(0,g.$no)(le,J))?.version,ae=(0,R.$re)(z.includePreRelease)?z.includePreRelease:!!z.includePreRelease.find(le=>(0,g.$no)(le,J))?.includePreRelease,he=V(C),fe=B(C.versions,z.targetPlatform);if(z.compatible&&(0,p.$Tn)(he,z.targetPlatform))return null;for(let le=0;le<fe.length;le++){const $e=fe[le];if(!(_&&$e.version!==_)){if(await this.y($e,ae?"any":"release",z.compatible,he,z.targetPlatform))return ne(C,$e,he,M);if(_&&$e.version===_)return null}}return _||z.compatible?null:ne(C,C.versions[0],he)}async B(C,z){if(!this.isEnabled())throw new Error("No extension gallery service configured.");C=C.withFlags(C.flags,s.ExcludeNonValidated).withFilter(i.Target,"Microsoft.VisualStudio.Code").withFilter(i.ExcludeWithFlags,n(s.Unpublished));const M=await this.j,J=JSON.stringify(C.raw),_={...M,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(J.length)},ae=new I.$dc;let he,fe,le=0;try{if(he=await this.k.request({type:"POST",url:this.g&&C.criteria.some(de=>de.filterType===i.SearchText)?this.g:this.x("/extensionquery"),data:J,headers:_},z),he.res.statusCode&&he.res.statusCode>=400&&he.res.statusCode<500)return{galleryExtensions:[],total:le};const $e=await(0,o.$Lo)(he);if($e){const de=$e.results[0],we=de.extensions,ke=de.resultMetadata&&de.resultMetadata.filter(Ie=>Ie.metadataType==="ResultCount")[0];return le=ke&&ke.metadataItems.filter(Ie=>Ie.name==="TotalCount")[0].count||0,{galleryExtensions:we,total:le,context:{[c]:he.res.headers.activityid}}}return{galleryExtensions:[],total:le}}catch($e){throw fe=$e,$e}finally{this.o.publicLog2("galleryService:query",{...C.telemetryData,requestBodySize:String(J.length),duration:ae.elapsed(),success:!!he&&(0,o.$Io)(he),responseBodySize:he?.res.headers["Content-Length"],statusCode:he?String(he.res.statusCode):void 0,errorCode:fe?(0,O.$2)(fe)?"canceled":(0,O.$8)(fe).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(le)})}}async reportStatistic(C,z,M,J){if(!this.isEnabled())return;const _=j.$o?this.x(`/itemName/${C}.${z}/version/${M}/statType/${J==="install"?"1":"3"}/vscodewebextension`):this.x(`/publishers/${C}/extensions/${z}/${M}/stats?statType=${J}`),ae=j.$o?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",fe={...await this.j,Accept:ae};try{await this.k.request({type:"POST",url:_,headers:fe},N.CancellationToken.None)}catch{}}async download(C,z,M){this.l.trace("ExtensionGalleryService#download",C.identifier.id);const J=(0,g.$vo)(C),_=new Date().getTime(),ae=de=>this.o.publicLog("galleryService:downloadVSIX",{...J,duration:de}),he=M===2?"install":M===3?"update":"",fe=he?{uri:`${C.assets.download.uri}${k.URI.parse(C.assets.download.uri).query?"&":"?"}${he}=true`,fallbackUri:`${C.assets.download.fallbackUri}${k.URI.parse(C.assets.download.fallbackUri).query?"&":"?"}${he}=true`}:C.assets.download,le=C.queryContext?.[c]?{[c]:C.queryContext[c]}:void 0,$e=await this.D(fe,le?{headers:le}:void 0);await this.q.writeFile(z,$e.stream),ae(new Date().getTime()-_)}async downloadSignatureArchive(C,z){if(!C.assets.signature)throw new Error("No signature asset found");this.l.trace("ExtensionGalleryService#downloadSignatureArchive",C.identifier.id);const M=await this.D(C.assets.signature);await this.q.writeFile(z,M.stream)}async getReadme(C,z){if(C.assets.readme){const M=await this.D(C.assets.readme,{},z);return await(0,o.$Ko)(M)||""}return""}async getManifest(C,z){if(C.assets.manifest){const M=await this.D(C.assets.manifest,{},z),J=await(0,o.$Ko)(M);return J?JSON.parse(J):null}return null}async C(C,z){const M=q(C,r.Manifest);if(!M)throw new Error("Manifest was not found");const J={"Accept-Encoding":"gzip"},_=await this.D(M,{headers:J});return await(0,o.$Lo)(_)}async getCoreTranslation(C,z){const M=C.assets.coreTranslations.filter(J=>J[0]===z.toUpperCase())[0];if(M){const J=await this.D(M[1]),_=await(0,o.$Ko)(J);return _?JSON.parse(_):null}return null}async getChangelog(C,z){if(C.assets.changelog){const M=await this.D(C.assets.changelog,{},z);return await(0,o.$Ko)(M)||""}return""}async getAllCompatibleVersions(C,z,M){let J=new u().withFlags(s.IncludeVersions,s.IncludeCategoryAndTags,s.IncludeFiles,s.IncludeVersionProperties).withPage(1,1);C.identifier.uuid?J=J.withFilter(i.ExtensionId,C.identifier.uuid):J=J.withFilter(i.ExtensionName,C.identifier.id);const{galleryExtensions:_}=await this.B(J,N.CancellationToken.None);if(!_.length)return[];const ae=V(_[0]);if((0,p.$Tn)(ae,M))return[];const he=[];await Promise.all(_[0].versions.map(async $e=>{try{await this.y($e,z?"any":"release",!0,ae,M)&&he.push($e)}catch{}}));const fe=[],le=new Set;for(const $e of B(he,M))le.has($e.version)||(le.add($e.version),fe.push({version:$e.version,date:$e.lastUpdated,isPreReleaseVersion:Y($e)}));return fe}async D(C,z={},M=N.CancellationToken.None){const J=await this.j,_={type:"GET"},ae={...J,...z.headers||{}};z={...z,..._,headers:ae};const he=C.uri,fe=C.fallbackUri,le={...z,url:he};try{const $e=await this.k.request(le,M);if($e.res.statusCode===200)return $e;const de=await(0,o.$Ko)($e);throw new Error(`Expected 200, got back ${$e.res.statusCode} instead.

${de}`)}catch($e){if((0,O.$2)($e))throw $e;const de=(0,O.$8)($e);this.o.publicLog2("galleryService:cdnFallback",{url:he,message:de});const we={...z,url:fe};return this.k.request(we,M)}}async E(C){let z=Z(C);if(!z){const M=await this.C(C,N.CancellationToken.None);if(!M)throw new Error("Manifest was not found");z=M.engines.vscode}return z}async getExtensionsControlManifest(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.h)return{malicious:[],deprecated:{},search:[]};const C=await this.k.request({type:"GET",url:this.h},N.CancellationToken.None);if(C.res.statusCode!==200)throw new Error("Could not get extensions report.");const z=await(0,o.$Lo)(C),M=[],J={},_=[];if(z){for(const ae of z.malicious)M.push({id:ae});if(z.migrateToPreRelease)for(const[ae,he]of Object.entries(z.migrateToPreRelease))(!he.engine||(0,h.$Fo)(he.engine,this.u.version,this.u.date))&&(J[ae.toLowerCase()]={disallowInstall:!0,extension:{id:he.id,displayName:he.displayName,autoMigrate:{storage:!!he.migrateStorage},preRelease:!0}});if(z.deprecated)for(const[ae,he]of Object.entries(z.deprecated))he&&(J[ae.toLowerCase()]=(0,R.$re)(he)?{}:he);if(z.search)for(const ae of z.search)_.push(ae)}return{malicious:M,deprecated:J,search:_}}};se=ye([X(1,o.$Go),X(2,w.$3i),X(3,P.$Gh),X(4,b.$7k),X(5,d.$4j),X(6,f.$ij),X(7,m.$6h)],se);let K=class extends se{constructor(C,z,M,J,_,ae,he,fe){super(C,z,M,J,_,ae,he,fe)}};e.$2o=K,e.$2o=K=ye([X(0,$.$So),X(1,o.$Go),X(2,w.$3i),X(3,P.$Gh),X(4,b.$7k),X(5,d.$4j),X(6,f.$ij),X(7,m.$6h)],K);let U=class extends se{constructor(C,z,M,J,_,ae,he){super(void 0,C,z,M,J,_,ae,he)}};e.$3o=U,e.$3o=U=ye([X(0,o.$Go),X(1,w.$3i),X(2,P.$Gh),X(3,b.$7k),X(4,d.$4j),X(5,f.$ij),X(6,m.$6h)],U)}),define(re[80],oe([0,1,4,3,2,19,33,24,20,7,9]),function(te,e,L,N,O,j,A,R,k,m,P){"use strict";var p;Object.defineProperty(e,"__esModule",{value:!0}),e.$Qz=e.$Pz=void 0,e.$Pz=(0,L.$zh)("IExtensionStorageService");const g=/^extensionKeys\/([^.]+\..+)@(\d+\.\d+\.\d+(-.*)?)$/;let h=class extends O.$mb{static{p=this}static{this.a=512*1024}static b(w){return`extensionKeys/${(0,A.$ro)(w.id)}@${w.version}`}static c(w){const f=g.exec(w);if(f&&f[1])return{id:f[1],version:f[2]}}static async removeOutdatedExtensionVersions(w,f){const o=await w.getInstalled(),l=[];for(const[$,b]of p.f(f)){const I=o.find(t=>(0,A.$no)(t.identifier,{id:$}))?.manifest.version;for(const t of b)I!==t&&l.push(p.b({id:$,version:t}))}for(const $ of l)f.remove($,0)}static f(w){const f=new Map,o=w.keys(0,1);for(const l of o){const $=p.c(l);if($){let b=f.get($.id.toLowerCase());b||f.set($.id.toLowerCase(),b=[]),b.push($.version)}}return f}constructor(w,f,o){super(),this.i=w,this.j=f,this.k=o,this.g=this.B(new N.$hc),this.onDidChangeExtensionStorageToSync=this.g.event,this.h=p.f(w),this.B(this.i.onDidChangeValue(0,void 0,this.B(new O.$lb))(l=>this.l(l)))}l(w){if(this.h.has(w.key.toLowerCase())){this.g.fire();return}const f=p.c(w.key);if(f){if(this.i.get(w.key,0)===void 0)this.h.delete(f.id.toLowerCase());else{let o=this.h.get(f.id.toLowerCase());o||this.h.set(f.id.toLowerCase(),o=[]),o.push(f.version),this.g.fire()}return}}m(w){if((0,P.$le)(w))return w;const f=w.manifest?w.manifest.publisher:w.publisher,o=w.manifest?w.manifest.name:w.name;return(0,A.$qo)(f,o)}getExtensionState(w,f){const o=this.m(w),l=this.getExtensionStateRaw(w,f);if(l)try{return JSON.parse(l)}catch($){this.k.error(`[mainThreadStorage] unexpected error parsing storage contents (extensionId: ${o}, global: ${f}): ${$}`)}}getExtensionStateRaw(w,f){const o=this.m(w),l=this.i.get(o,f?0:1);return l&&l?.length>p.a&&this.k.warn(`[mainThreadStorage] large extension state detected (extensionId: ${o}, global: ${f}): ${l.length/1024}kb. Consider to use 'storageUri' or 'globalStorageUri' to store this data on disk instead.`),l}setExtensionState(w,f,o){const l=this.m(w);f===void 0?this.i.remove(l,o?0:1):this.i.store(l,JSON.stringify(f),o?0:1,1)}setKeysForSync(w,f){this.i.store(p.b(w),JSON.stringify(f),0,1)}getKeysForSync(w){const f=this.j.extensionSyncedKeys?.[w.id.toLowerCase()],o=this.i.get(p.b(w),0),l=o?JSON.parse(o):void 0;return l&&f?(0,k.$Ff)([...l,...f]):l||f}addToMigrationList(w,f){if(w!==f){const o=this.n.filter(l=>!l.includes(w)&&!l.includes(f));o.push([w,f]),this.n=o}}getSourceExtensionToMigrate(w){const f=this.n.find(([,o])=>w===o);return f?f[0]:void 0}get n(){const w=this.i.get("extensionStorage.migrationList",-1,"[]");try{const f=JSON.parse(w);if(Array.isArray(f))return f}catch{}return[]}set n(w){w.length?this.i.store("extensionStorage.migrationList",JSON.stringify(w),-1,1):this.i.remove("extensionStorage.migrationList",-1)}};e.$Qz=h,e.$Qz=h=p=ye([X(0,j.$So),X(1,R.$ij),X(2,m.$3i)],h)}),define(re[247],oe([0,1,29,13,24,16,98,55,19,21,220]),function(te,e,L,N,O,j,A,R,k,m,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$K7b=void 0;let p=class extends P.$53b{constructor(h,d,w,f,o,l,$,b){super(h.userHome,o,d,w,f,l,$,b)}};e.$K7b=p,e.$K7b=p=ye([X(0,j.$Hh),X(1,m.$7k),X(2,L.$Zn),X(3,k.$So),X(4,R.$x5b),X(5,A.$bUb),X(6,N.$4j),X(7,O.$ij)],p)}),define(re[248],oe([0,1,105,3,21,16,2,7,15,64,24,6,5,101,18,164,36,19,9,132]),function(te,e,L,N,O,j,A,R,k,m,P,p,g,h,d,w,f,o,l,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$G7b=void 0;const b=[L.$z7b,L.$A7b],I="remoteTunnelSession",t="remoteTunnelIsService";let c=class extends A.$mb{constructor(r,a,v,y,u,E,D){super(),this.t=r,this.u=a,this.v=v,this.w=E,this.y=D,this.f=new N.$hc,this.onDidTokenFailed=this.f.event,this.g=new N.$hc,this.onDidChangeTunnelStatus=this.g.event,this.h=new N.$hc,this.onDidChangeMode=this.h.event,this.j=L.$x7b,this.s=!1,this.D=(T,F)=>{F?this.i.error(T):this.i.info(T)},this.i=this.B(y.createLogger(L.$B7b,{name:L.$C7b})),this.p=new g.$Bg(100),this.B(this.i.onDidChangeLogLevel(T=>this.i.info("Log level changed to "+(0,R.$fj)(T)))),this.B(u.onWillShutdown(()=>{this.k?.cancel(),this.k=void 0,this.dispose()})),this.B(E.onDidChangeConfiguration(T=>{b.some(F=>T.affectsConfiguration(F))&&this.p.trigger(()=>this.G())})),this.j=this.N(),this.n=L.TunnelStates.uninitialized}async getTunnelStatus(){return this.n}z(r){this.n=r,this.g.fire(r)}C(r){n(this.j,r)||(this.j=r,this.O(r),this.h.fire(this.j),r.active?(this.i.info(`Session updated: ${r.session.accountLabel} (${r.session.providerId}) (service=${r.asService})`),r.session.token&&this.i.info(`Session token updated: ${r.session.accountLabel} (${r.session.providerId})`)):this.i.info("Session reset"))}getMode(){return Promise.resolve(this.j)}async initialize(r){if(this.s)return this.n;this.s=!0,this.C(r);try{await this.p.trigger(()=>this.G())}catch(a){this.i.error(a)}return this.n}F(){if(!this.r){let r;p.$j?r=this.v.appRoot:r=(0,k.$bd)((0,k.$bd)(this.v.appRoot)),this.r=(0,k.$$c)(r,"bin",`${this.u.tunnelApplicationName}${p.$i?".exe":""}`)}return this.r}async startTunnel(r){if(n(this.j,r)&&this.n.type!=="disconnected")return this.n;this.C(r);try{await this.p.trigger(()=>this.G())}catch(a){this.i.error(a)}return this.n}async stopTunnel(){if(this.k&&(this.k.cancel(),this.k=void 0),!this.j.active)return;const r=this.j.asService;this.C(L.$x7b);try{r&&this.J("uninstallService",["service","uninstall"])}catch(a){this.i.error(a)}try{await this.J("stop",["kill"])}catch(a){this.i.error(a)}this.z(L.TunnelStates.disconnected())}async G(){this.t.publicLog2("remoteTunnel.enablement",{enabled:this.j.active,service:this.j.active&&this.j.asService}),this.k&&(this.k.cancel(),this.k=void 0);let r="",a=!1;const v=(F,q)=>{q?this.i.error(F):r+=F,!this.v.isBuilt&&F.startsWith("   Compiling")&&this.z(L.TunnelStates.connecting((0,w.localize)(0,null)))},y=this.J("status",["status"],v);this.k=y;try{if(await y,this.k!==y)return;const F=JSON.parse(r.trim().split(`
`).find(q=>q.startsWith("{")));if(a=F.service_installed,this.i.info(F.tunnel?"Other tunnel running, attaching...":"No other tunnel running"),!F.tunnel&&!this.j.active){this.z(L.TunnelStates.disconnected());return}}catch(F){this.i.error(F),this.z(L.TunnelStates.disconnected());return}finally{this.k===y&&(this.k=void 0)}const u=this.j.active?this.j.session:void 0;if(u&&u.token){const F=u.token;this.z(L.TunnelStates.connecting((0,w.localize)(1,null,u.accountLabel,u.providerId)));const q=(Z,Y)=>{Z=Z.replaceAll(F,"*".repeat(4)),v(Z,Y)},W=this.J("login",["user","login","--provider",u.providerId,"--access-token",F,"--log",(0,R.$fj)(this.i.getLevel())],q);this.k=W;try{if(await W,this.k!==W)return}catch(Z){this.i.error(Z),this.k=void 0,this.f.fire(u),this.z(L.TunnelStates.disconnected(u));return}}const E=this.M();E?this.z(L.TunnelStates.connecting((0,w.localize)(2,null,E))):this.z(L.TunnelStates.connecting((0,w.localize)(3,null)));const D=["--accept-server-license-terms","--log",(0,R.$fj)(this.i.getLevel())];E?D.push("--name",E):D.push("--random-name");let T=!1;return this.j.active&&this.j.asService&&!a&&(T=await this.H(D)===!1),this.I(u,D,T)}async H(r){let a;try{a=await this.J("serviceInstall",["service","install",...r])}catch(v){this.i.error(v),a=1}if(a!==0){const v=(0,w.localize)(4,null);return this.i.warn(v),this.z(L.TunnelStates.connecting(v)),!1}return!0}async I(r,a,v){a.push("--parent-process-id",String(process.pid)),this.L()&&a.push("--no-sleep");let y=!1;const u=this.J("tunnel",a,(E,D)=>{D?this.i.error(E):this.i.info(E),E.includes("Connected to an existing tunnel process")&&(y=!0);const T=E.match(/Open this link in your browser (https:\/\/([^\/\s]+)\/([^\/\s]+)\/([^\/\s]+))/);if(T){const F={link:T[1],domain:T[2],tunnelName:T[4],isAttached:y};this.z(L.TunnelStates.connected(F,v))}else E.match(/error refreshing token/)&&(u.cancel(),this.f.fire(r),this.z(L.TunnelStates.disconnected(r)))});this.k=u,u.finally(()=>{u===this.k&&(this.i.info("tunnel process terminated"),this.k=void 0,this.j=L.$x7b,this.z(L.TunnelStates.disconnected()))})}J(r,a,v=this.D){return(0,g.$sg)(y=>new Promise((u,E)=>{y.isCancellationRequested&&u(-1);let D;const T=["ignore","pipe","pipe"];if(y.onCancellationRequested(()=>{D&&(this.i.info(`${r} terminating(${D.pid})`),D.kill())}),!this.v.isBuilt)v(`Building tunnel CLI from sources and run
`,!1),v(`${r} Spawning: cargo run -- tunnel ${a.join(" ")}
`,!1),D=(0,m.spawn)("cargo",["run","--","tunnel",...a],{cwd:(0,k.$$c)(this.v.appRoot,"cli"),stdio:T});else{v(`Running tunnel CLI
`,!1);const F=this.F();v(`${r} Spawning: ${F} tunnel ${a.join(" ")}
`,!1),D=(0,m.spawn)(F,["tunnel",...a],{cwd:(0,f.homedir)(),stdio:T})}D.stdout.pipe(new $.$DS(`
`)).on("data",F=>{if(D){const q=F.toString();v(q,!1)}}),D.stderr.pipe(new $.$DS(`
`)).on("data",F=>{if(D){const q=F.toString();v(q,!0)}}),D.on("exit",F=>{D&&(v(`${r} exit(${D.pid}): + ${F} `,!1),D=void 0,u(F||0))}),D.on("error",F=>{D&&(v(`${r} error(${D.pid}): + ${F} `,!0),D=void 0,E())})}))}async getTunnelName(){return this.M()}L(){return!!this.w.getValue(L.$A7b)}M(){let r=this.w.getValue(L.$z7b)||(0,f.hostname)();return r=r.replace(/^-+/g,"").replace(/[^\w-]/g,"").substring(0,20),r||void 0}N(){try{const r=this.y.get(I,-1),a=this.y.getBoolean(t,-1,!1);if(r){const v=JSON.parse(r);if(v&&(0,l.$le)(v.accountLabel)&&(0,l.$le)(v.sessionId)&&(0,l.$le)(v.providerId))return{active:!0,session:v,asService:a};this.i.error("Problems restoring session from storage, invalid format",v)}}catch(r){this.i.error("Problems restoring session from storage",r)}return L.$x7b}O(r){if(r.active){const a={providerId:r.session.providerId,sessionId:r.session.sessionId,accountLabel:r.session.accountLabel};this.y.store(I,JSON.stringify(a),-1,1),this.y.store(t,r.asService,-1,1)}else this.y.remove(I,-1),this.y.remove(t,-1)}};e.$G7b=c,e.$G7b=c=ye([X(0,O.$7k),X(1,P.$ij),X(2,j.$Hh),X(3,R.$4i),X(4,h.$E7b),X(5,d.$6h),X(6,o.$So)],c);function s(i,r){return i&&r?i.sessionId===r.sessionId&&i.providerId===r.providerId&&i.token===r.token:i===r}const n=(i,r)=>i.active!==r.active?!1:i.active&&r.active?i.asService===r.asService&&s(i.session,r.session):!0}),define(re[249],oe([0,1,5,2,22,23,66,19,75,17]),function(te,e,L,N,O,j,A,R,k,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$L7b=void 0;class P extends R.$Uo{constructor(g,h,d,w){super(),this.X=g,this.Y=h,this.Z=d,this.$=w,this.p=this.Y.defaultProfile,this.s=this.ab(),this.P=this.Y.currentProfile,this.Q=this.B(new N.$lb),this.R=this.bb(this.P),this.S=this.X?.id,this.U=this.B(new N.$lb),this.W=this.cb(this.X)}ab(){const g=this.B(new k.$Jzb(this.Z.getChannel("storage"))),h=this.B(new A.$Oo(g));return this.B(h.onDidChangeStorage(d=>this.n(-1,d))),h}bb(g){this.Q.clear(),this.P=g;let h;if((0,R.$Vo)(g))h=this.s;else{const d=this.Q.add(new k.$Kzb(this.Z.getChannel("storage"),g));h=this.Q.add(new A.$Oo(d))}return this.Q.add(h.onDidChangeStorage(d=>this.n(0,d))),h}cb(g){this.U.clear(),this.S=g?.id;let h;if(g){const d=this.U.add(new k.$Lzb(this.Z.getChannel("storage"),g));h=this.U.add(new A.$Oo(d)),this.U.add(h.onDidChangeStorage(w=>this.n(1,w)))}return h}async J(){await L.Promises.settled([this.s.init(),this.R.init(),this.W?.init()??Promise.resolve()])}L(g){switch(g){case-1:return this.s;case 0:return this.R;default:return this.W}}M(g){switch(g){case-1:return this.p.globalStorageHome.with({scheme:O.Schemas.file}).fsPath;case 0:return this.P?.globalStorageHome.with({scheme:O.Schemas.file}).fsPath;default:return this.S?`${(0,j.$gg)(this.$.workspaceStorageHome,this.S,"state.vscdb").with({scheme:O.Schemas.file}).fsPath}`:void 0}}async close(){this.m(),this.r(R.WillSaveStateReason.SHUTDOWN),await L.Promises.settled([this.s.close(),this.R.close(),this.W?.close()??Promise.resolve()])}async N(g){if(!this.H(this.P,g))return;const h=this.R,d=h.items;h!==this.s&&await h.close(),this.R=this.bb(g),await this.R.init(),this.I(d,this.R,0)}async O(g,h){const d=this.W,w=d?.items??new Map;await d?.close(),this.W=this.cb(g),await this.W.init(),this.I(w,this.W,1)}hasScope(g){return(0,m.$Bk)(g)?this.P.id===g.id:this.S===g.id}}e.$L7b=P}),define(re[250],oe([0,1,3,2,17,92]),function(te,e,L,N,O,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mN=e.$lN=void 0;class A{constructor(m,P){this.a=m,this.b=P}listen(m,P){const p=this.b(m);switch(P){case"onDidChangeProfiles":return L.Event.map(this.a.onDidChangeProfiles,g=>({all:g.all.map(h=>(0,j.$Bm)({...h},p)),added:g.added.map(h=>(0,j.$Bm)({...h},p)),removed:g.removed.map(h=>(0,j.$Bm)({...h},p)),updated:g.updated.map(h=>(0,j.$Bm)({...h},p))}))}throw new Error(`Invalid listen ${P}`)}async call(m,P,p){const g=this.b(m);switch(P){case"createProfile":{const h=await this.a.createProfile(p[0],p[1],p[2]);return(0,j.$Bm)({...h},g)}case"updateProfile":{let h=(0,O.$Dk)((0,j.$Cm)(p[0],g),this.a.profilesHome.scheme);return h=await this.a.updateProfile(h,p[1]),(0,j.$Bm)({...h},g)}case"removeProfile":{const h=(0,O.$Dk)((0,j.$Cm)(p[0],g),this.a.profilesHome.scheme);return this.a.removeProfile(h)}}throw new Error(`Invalid call ${P}`)}}e.$lN=A;class R extends N.$mb{get defaultProfile(){return this.profiles[0]}get profiles(){return this.a}constructor(m,P,p){super(),this.profilesHome=P,this.f=p,this.a=[],this.b=this.B(new L.$hc),this.onDidChangeProfiles=this.b.event,this.c=!0,this.a=m.map(g=>(0,O.$Dk)(g,this.profilesHome.scheme)),this.B(this.f.listen("onDidChangeProfiles")(g=>{const h=g.added.map(f=>(0,O.$Dk)(f,this.profilesHome.scheme)),d=g.removed.map(f=>(0,O.$Dk)(f,this.profilesHome.scheme)),w=g.updated.map(f=>(0,O.$Dk)(f,this.profilesHome.scheme));this.a=g.all.map(f=>(0,O.$Dk)(f,this.profilesHome.scheme)),this.b.fire({added:h,removed:d,updated:w,all:this.profiles})})),this.onDidResetWorkspaces=this.f.listen("onDidResetWorkspaces")}setEnablement(m){this.c=m}isEnabled(){return this.c}async createNamedProfile(m,P,p){const g=await this.f.call("createNamedProfile",[m,P,p]);return(0,O.$Dk)(g,this.profilesHome.scheme)}async createProfile(m,P,p,g){const h=await this.f.call("createProfile",[m,P,p,g]);return(0,O.$Dk)(h,this.profilesHome.scheme)}async createTransientProfile(m){const P=await this.f.call("createTransientProfile",[m]);return(0,O.$Dk)(P,this.profilesHome.scheme)}async setProfileForWorkspace(m,P){await this.f.call("setProfileForWorkspace",[m,P])}removeProfile(m){return this.f.call("removeProfile",[m])}async updateProfile(m,P){const p=await this.f.call("updateProfile",[m,P]);return(0,O.$Dk)(p,this.profilesHome.scheme)}resetWorkspaces(){return this.f.call("resetWorkspaces")}cleanUp(){return this.f.call("cleanUp")}cleanUpTransientProfiles(){return this.f.call("cleanUpTransientProfiles")}}e.$mN=R}),define(re[58],oe([0,1,2,66,4,19,3,75,17]),function(te,e,L,N,O,j,A,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pzb=e.$Ozb=e.$Nzb=void 0,e.$Nzb=(0,O.$zh)("IUserDataProfileStorageService");let m=class extends L.$mb{constructor(h){super(),this.a=h}async readStorageData(h){return this.withProfileScopedStorageService(h,async d=>this.b(d))}async updateStorageData(h,d,w){return this.withProfileScopedStorageService(h,async f=>this.c(f,d,w))}async withProfileScopedStorageService(h,d){if(this.a.hasScope(h))return d(this.a);const w=await this.g(h),f=new p(w);try{await f.initialize();const o=await d(f);return await f.flush(),o}finally{f.dispose(),await this.f(w)}}b(h){const d=new Map,w=f=>{for(const o of h.keys(0,f))d.set(o,{value:h.get(o,0),target:f})};return w(0),w(1),d}c(h,d,w){h.storeAll(Array.from(d.entries()).map(([f,o])=>({key:f,value:o,scope:0,target:w})),!0)}async f(h){try{await h.close()}finally{(0,L.$gb)(h)&&h.dispose()}}};e.$Ozb=m,e.$Ozb=m=ye([X(0,j.$So)],m);class P extends m{constructor(h,d,w,f){super(w),this.i=h;const o=h.getChannel("profileStorageListener"),l=this.B(new L.$nb);this.h=this.B(new A.$hc({onWillAddFirstListener:()=>{l.value=o.listen("onDidChange")($=>{f.trace("profile storage changes",$),this.h.fire({targetChanges:$.targetChanges.map(b=>(0,k.$Dk)(b,d.profilesHome.scheme)),valueChanges:$.valueChanges.map(b=>({...b,profile:(0,k.$Dk)(b.profile,d.profilesHome.scheme)}))})})},onDidRemoveLastListener:()=>l.value=void 0})),this.onDidChange=this.h.event}async g(h){const d=this.i.getChannel("storage");return(0,j.$Vo)(h)?new R.$Jzb(d):new R.$Kzb(d,h)}}e.$Pzb=P;class p extends j.$Uo{constructor(h){super({flushInterval:100}),this.p=this.B(new N.$Oo(h))}J(){return this.p.init()}L(h){return h===0?this.p:void 0}M(){}async N(){}async O(){}hasScope(){return!1}}}),define(re[251],oe([0,1,19,7,17,71,58]),function(te,e,L,N,O,j,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$q7b=void 0;let R=class extends A.$Pzb{constructor(m,P,p,g){super(m,P,p,g)}};e.$q7b=R,e.$q7b=R=ye([X(0,j.$O6b),X(1,O.$Ck),X(2,L.$So),X(3,N.$3i)],R)}),define(re[39],oe([0,1,20,5,14,26,3,34,2,28,9,169,18,16,13,7,44,19,21,27,25,17]),function(te,e,L,N,O,j,A,R,k,m,P,p,g,h,d,w,f,o,l,$,b,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$HAb=e.$GAb=e.$FAb=e.$EAb=e.$DAb=e.$CAb=e.$BAb=void 0;function t(v){return!!(v&&v.ref!==void 0&&typeof v.ref=="string"&&v.ref!==""&&v.syncData!==void 0&&(v.syncData===null||c(v.syncData)))}e.$BAb=t;function c(v){return!!(v&&v.version!==void 0&&typeof v.version=="number"&&v.content!==void 0&&typeof v.content=="string"&&(Object.keys(v).length===2||Object.keys(v).length===3&&v.machineId!==void 0&&typeof v.machineId=="string"))}e.$CAb=c;function s(v,y){return`${(0,m.$de)(v)}${y.isDefault?"":` (${y.name})`}`}e.$DAb=s;let n=class extends k.$mb{get status(){return this.k}get conflicts(){return{...this.syncResource,conflicts:this.m}}constructor(y,u,E,D,T,F,q,W,Z,Y,x,G){super(),this.syncResource=y,this.collection=u,this.C=E,this.D=D,this.F=T,this.G=F,this.H=q,this.I=W,this.J=Z,this.L=Y,this.M=x,this.c=null,this.k="idle",this.l=this.B(new A.$hc),this.onDidChangeStatus=this.l.event,this.m=[],this.n=this.B(new A.$hc),this.onDidChangeConflicts=this.n.event,this.s=this.B(new N.$Cg(50)),this.t=this.B(new A.$hc),this.onDidChangeLocal=this.t.event,this.v=`${this.collection?`${this.collection}.`:""}${this.syncResource.syncResource}.lastSyncUserData`,this.w=!1,this.z={},this.resource=this.syncResource.syncResource,this.y=s(y.syncResource,y.profile),this.h=G.extUri,this.f=this.h.joinPath(D.userDataSyncHome,...(0,b.$dgb)(y.profile.isDefault?void 0:y.profile.id,y.syncResource)),this.g=this.h.joinPath(this.f,b.$ygb),this.u=(0,b.$egb)(y.profile.isDefault?void 0:y.profile.id,y.syncResource,D,this.h),this.j=(0,f.$Yo)(D,E,T)}N(){this.s.trigger(()=>this.O())}async O(){if(this.status==="hasConflicts"){this.L.info(`${this.y}: In conflicts state and local change detected. Syncing again...`);const y=await this.c;this.c=null;const u=await this.U(y.remoteUserData,y.lastSyncUserData,!0,this.lb());this.P(u)}else{this.L.trace(`${this.y}: Checking for local changes...`);const y=await this.getLastSyncUserData();(y?await this.rb(y):!0)&&this.t.fire()}}P(y){this.k!==y&&(this.k=y,this.l.fire(y))}async sync(y,u={}){await this.Q(y,!0,this.lb(),u)}async preview(y,u,E={}){return this.Q(y,!1,u,E)}async apply(y,u={}){try{this.z={...u};const E=await this.Y(y);return this.P(E),this.c}finally{this.z={}}}async Q(y,u,E,D){try{if(this.z={...D},this.status==="hasConflicts")return this.L.info(`${this.y}: Skipped synchronizing ${this.resource.toLowerCase()} as there are conflicts.`),this.c;if(this.status==="syncing")return this.L.info(`${this.y}: Skipped synchronizing ${this.resource.toLowerCase()} as it is running already.`),this.c;this.L.trace(`${this.y}: Started synchronizing ${this.resource.toLowerCase()}...`),this.P("syncing");let T="idle";try{const F=await this.getLastSyncUserData(),q=await this.S(y,F);return T=await this.U(q,F,u,E),T==="hasConflicts"?this.L.info(`${this.y}: Detected conflicts while synchronizing ${this.resource.toLowerCase()}.`):T==="idle"&&this.L.trace(`${this.y}: Finished synchronizing ${this.resource.toLowerCase()}.`),this.c||null}finally{this.P(T)}}finally{this.z={}}}async replace(y){const u=this.hb(y);if(!u)return!1;await this.stop();try{this.L.trace(`${this.y}: Started resetting ${this.resource.toLowerCase()}...`),this.P("syncing");const E=await this.getLastSyncUserData(),D=await this.S(null,E),T=await this.R(D),F=await this.nb({ref:D.ref,syncData:u},E,T,this.lb(),j.CancellationToken.None),q=[];for(const W of F){const Z=await this.pb(W,W.remoteResource,void 0,j.CancellationToken.None),{remoteChange:Y}=await this.pb(W,W.previewResource,W.remoteContent,j.CancellationToken.None);q.push([W,{...Z,remoteChange:Y!==0?Y:2}])}await this.qb(D,E,q,!1),this.L.info(`${this.y}: Finished resetting ${this.resource.toLowerCase()}.`)}finally{this.P("idle")}return!0}async R(y){const u=await this.j;return!!y.syncData?.machineId&&y.syncData.machineId===u}async S(y,u){if(u){const E=y?y[this.resource]:void 0;if(u.ref===E||E===void 0&&u.syncData===null)return u}return this.getRemoteUserData(u)}async U(y,u,E,D){if(y.syncData&&y.syncData.version>this.mb)throw this.J.publicLog2("sync/incompatible",{source:this.resource}),new b.$lgb((0,p.localize)(0,null,this.resource,this.mb,y.syncData.version),"IncompatibleLocalContent",this.resource);try{return await this.W(y,u,E,D)}catch(T){if(T instanceof b.$lgb)switch(T.code){case"LocalPreconditionFailed":return this.L.info(`${this.y}: Failed to synchronize ${this.y} as there is a new local version available. Synchronizing again...`),this.U(y,u,E,D);case"Conflict":case"PreconditionFailed":return this.L.info(`${this.y}: Failed to synchronize as there is a new remote version available. Synchronizing again...`),y=await this.getRemoteUserData(null),u=await this.getLastSyncUserData(),this.U(y,u,E,D)}throw T}}async W(y,u,E,D){try{const T=await this.R(y),F=!T&&u===null&&this.db()!==void 0,q=E&&!F;this.c||(this.c=(0,N.$sg)(Z=>this.bb(y,u,T,q,D,Z)));let W=await this.c;if(E&&F){this.L.info(`${this.y}: Accepting remote because it was synced before and the last sync data is not available.`);for(const Z of W.resourcePreviews)W=await this.accept(Z.remoteResource)||W}return this.$(W.resourcePreviews),W.resourcePreviews.some(({mergeState:Z})=>Z==="conflict")?"hasConflicts":E?await this.Y(!1):"syncing"}catch(T){throw this.c=null,T}}async merge(y){return await this.X(y,async u=>{const E=await this.ob(u,j.CancellationToken.None);await this.C.writeFile(u.previewResource,O.$Hc.fromString(E?.content||""));const D=E&&!E.hasConflicts?await this.pb(u,u.previewResource,void 0,j.CancellationToken.None):void 0;return u.acceptResult=D,u.mergeState=E.hasConflicts?"conflict":D?"accepted":"preview",u.localChange=D?D.localChange:E.localChange,u.remoteChange=D?D.remoteChange:E.remoteChange,u}),this.c}async accept(y,u){return await this.X(y,async E=>{const D=await this.pb(E,y,u,j.CancellationToken.None);return E.acceptResult=D,E.mergeState="accepted",E.localChange=D.localChange,E.remoteChange=D.remoteChange,E}),this.c}async discard(y){return await this.X(y,async u=>{const E=await this.ob(u,j.CancellationToken.None);return await this.C.writeFile(u.previewResource,O.$Hc.fromString(E.content||"")),u.acceptResult=void 0,u.mergeState="preview",u.localChange=E.localChange,u.remoteChange=E.remoteChange,u}),this.c}async X(y,u){if(!this.c)return;let E=await this.c;const D=E.resourcePreviews.findIndex(({localResource:T,remoteResource:F,previewResource:q})=>this.h.isEqual(T,y)||this.h.isEqual(F,y)||this.h.isEqual(q,y));D!==-1&&(this.c=(0,N.$sg)(async T=>{const F=[...E.resourcePreviews];return F[D]=await u(F[D]),{...E,resourcePreviews:F}}),E=await this.c,this.$(E.resourcePreviews),E.resourcePreviews.some(({mergeState:T})=>T==="conflict")?this.P("hasConflicts"):this.P("syncing"))}async Y(y){if(!this.c)return"idle";const u=await this.c;return u.resourcePreviews.some(({mergeState:E})=>E==="conflict")?"hasConflicts":u.resourcePreviews.some(({mergeState:E})=>E!=="accepted")?"syncing":(await this.qb(u.remoteUserData,u.lastSyncUserData,u.resourcePreviews.map(E=>[E,E.acceptResult]),y),this.c=null,await this.Z(),"idle")}async Z(){try{await this.C.del(this.g,{recursive:!0})}catch{}}$(y){const u=y.filter(({mergeState:E})=>E==="conflict");(0,L.$of)(this.m,u,(E,D)=>this.h.isEqual(E.previewResource,D.previewResource))||(this.m=u,this.n.fire(this.conflicts))}async hasPreviouslySynced(){const y=await this.getLastSyncUserData();return!!y&&y.syncData!==null}async ab(y){const u=this.c?await this.c:null;if(u)for(const E of u.resourcePreviews){if(this.h.isEqual(E.acceptedResource,y))return E.acceptResult?E.acceptResult.content:null;if(this.h.isEqual(E.remoteResource,y))return E.remoteContent;if(this.h.isEqual(E.localResource,y))return E.localContent;if(this.h.isEqual(E.baseResource,y))return E.baseContent}return null}async resetLocal(){this.F.remove(this.v,-1);try{await this.C.del(this.u)}catch(y){(0,d.$hk)(y)!==1&&this.L.error(y)}}async bb(y,u,E,D,T,F){const q=await this.nb(y,u,E,T,F),W=[];for(const Z of q){const Y=Z.previewResource.with({scheme:b.$xgb,authority:"accepted"});if(Z.localChange===0&&Z.remoteChange===0)W.push({...Z,acceptedResource:Y,acceptResult:{content:null,localChange:0,remoteChange:0},mergeState:"accepted"});else{const x=D?await this.ob(Z,F):void 0;if(F.isCancellationRequested)break;await this.C.writeFile(Z.previewResource,O.$Hc.fromString(x?.content||""));const G=x&&!x.hasConflicts?await this.pb(Z,Z.previewResource,void 0,F):void 0;W.push({...Z,acceptResult:G,mergeState:x?.hasConflicts?"conflict":G?"accepted":"preview",localChange:G?G.localChange:x?x.localChange:Z.localChange,remoteChange:G?G.remoteChange:x?x.remoteChange:Z.remoteChange})}}return{syncResource:this.resource,profile:this.syncResource.profile,remoteUserData:y,lastSyncUserData:u,resourcePreviews:W,isLastSyncFromCurrentMachine:E}}async getLastSyncUserData(){let y=this.db();if(y||(y=await this.gb()),!y)return this.L.info(`${this.y}: Last sync data state does not exist.`),null;const u=JSON.parse(y),E=this.I.getResourceSyncStateVersion(this.resource);if(this.w=!!u.version&&!!E&&u.version!==E,this.w)return this.L.info(`${this.y}: Reset last sync state because last sync state version ${u.version} is not compatible with current sync state version ${E}.`),await this.resetLocal(),null;let D,T=1;for(;D===void 0&&T++<6;)try{const F=await this.eb();F&&(F.ref===u.ref?D=F.syncData:this.L.info(`${this.y}: Last sync data stored locally is not same as the last sync state.`));break}catch(F){if(F instanceof d.$lk&&F.fileOperationResult===1){this.L.info(`${this.y}: Last sync resource does not exist locally.`);break}else{if(F instanceof b.$lgb)throw F;this.L.error(F,T)}}if(D===void 0)try{const F=await this.G.resolveResourceContent(this.resource,u.ref,this.collection,this.z);D=F===null?null:this.hb(F),await this.fb({ref:u.ref,syncData:D})}catch(F){if(F instanceof b.$lgb&&F.code==="NotFound")this.L.info(`${this.y}: Last sync resource does not exist remotely.`);else throw F}return D===void 0?null:{...u,syncData:D}}async cb(y,u={}){if(u.ref||u.version)throw new Error("Cannot have core properties as additional");const E=this.I.getResourceSyncStateVersion(this.resource),D={ref:y.ref,version:E,...u};this.F.store(this.v,JSON.stringify(D),-1,1),await this.fb(y)}db(){return this.F.get(this.v,-1)}async eb(){const y=(await this.C.readFile(this.u)).value.toString();try{const u=y?JSON.parse(y):void 0;if(t(u))return u}catch(u){this.L.error(u)}}async fb(y){await this.C.writeFile(this.u,O.$Hc.fromString(JSON.stringify(y)))}async gb(){try{const y=await this.C.readFile(this.u),u=JSON.parse(y.value.toString());await this.C.del(this.u),u.ref&&u.content!==void 0?(this.F.store(this.v,JSON.stringify({...u,content:void 0}),-1,1),await this.fb({ref:u.ref,syncData:u.content===null?null:JSON.parse(u.content)})):this.L.info(`${this.y}: Migrating last sync user data. Invalid data.`,u)}catch(y){y instanceof d.$lk&&y.fileOperationResult===1?this.L.info(`${this.y}: Migrating last sync user data. Resource does not exist.`):this.L.error(y)}return this.F.get(this.v,-1)}async getRemoteUserData(y){const{ref:u,content:E}=await this.ib(y);let D=null;return E!==null&&(D=this.hb(E)),{ref:u,syncData:D}}hb(y){try{const u=JSON.parse(y);if(c(u))return u}catch(u){this.L.error(u)}throw new b.$lgb((0,p.localize)(1,null),"IncompatibleRemoteContent",this.resource)}async ib(y){const u=y?{ref:y.ref,content:y.syncData?JSON.stringify(y.syncData):null}:null;return this.G.readResource(this.resource,u,this.collection,this.z)}async jb(y,u){const E=await this.j,D={version:this.mb,machineId:E,content:y};try{return u=await this.G.writeResource(this.resource,JSON.stringify(D),u,this.collection,this.z),{ref:u,syncData:D}}catch(T){throw T instanceof b.$lgb&&T.code==="TooLarge"&&(T=new b.$lgb(T.message,T.code,this.resource)),T}}async kb(y){const u={version:this.mb,content:y};return this.H.backup(this.syncResource.profile,this.resource,JSON.stringify(u))}async stop(){this.status!=="idle"&&(this.L.trace(`${this.y}: Stopping synchronizing ${this.resource.toLowerCase()}.`),this.c&&(this.c.cancel(),this.c=null),this.$([]),await this.Z(),this.P("idle"),this.L.info(`${this.y}: Stopped synchronizing ${this.resource.toLowerCase()}.`))}lb(){return this.M.getValue(b.$$fb)}};e.$EAb=n,e.$EAb=n=ye([X(2,d.$4j),X(3,h.$Gh),X(4,o.$So),X(5,b.$ggb),X(6,b.$hgb),X(7,b.$qgb),X(8,l.$7k),X(9,b.$vgb),X(10,g.$6h),X(11,$.$Ak)],n);let i=class extends n{constructor(y,u,E,D,T,F,q,W,Z,Y,x,G,Q){super(u,E,D,T,F,q,W,Z,Y,x,G,Q),this.i=y,this.B(this.C.watch(this.h.dirname(y))),this.B(this.C.onDidFilesChange(H=>this.tb(H)))}async p(){try{return await this.C.readFile(this.i)}catch{return null}}async r(y,u,E){try{u?await this.C.writeFile(this.i,O.$Hc.fromString(y),E?void 0:u):await this.C.createFile(this.i,O.$Hc.fromString(y),{overwrite:E})}catch(D){throw D instanceof d.$lk&&D.fileOperationResult===1||D instanceof d.$lk&&D.fileOperationResult===3?new b.$lgb(D.message,"LocalPreconditionFailed"):D}}async sb(){try{await this.C.del(this.i)}catch(y){if(!(y instanceof d.$lk&&y.fileOperationResult===1))throw y}}tb(y){y.contains(this.i)&&this.N()}};e.$FAb=i,e.$FAb=i=ye([X(3,d.$4j),X(4,h.$Gh),X(5,o.$So),X(6,b.$ggb),X(7,b.$hgb),X(8,b.$qgb),X(9,l.$7k),X(10,b.$vgb),X(11,g.$6h),X(12,$.$Ak)],i);let r=class extends i{constructor(y,u,E,D,T,F,q,W,Z,Y,x,G,Q,H){super(y,u,E,D,T,F,q,W,Z,Y,x,Q,H),this.ub=G,this.wb=void 0}vb(y,u){const E=[],D=(0,R.$Jm)(y,E,{allowEmptyContent:!0,allowTrailingComma:!0});return E.length>0||!(0,P.$se)(D)&&u!==Array.isArray(D)}xb(){return this.wb||(this.wb=this.ub.resolveFormattingOptions(this.i)),this.wb}};e.$GAb=r,e.$GAb=r=ye([X(3,d.$4j),X(4,h.$Gh),X(5,o.$So),X(6,b.$ggb),X(7,b.$hgb),X(8,b.$qgb),X(9,l.$7k),X(10,b.$vgb),X(11,b.$ugb),X(12,g.$6h),X(13,$.$Ak)],r);let a=class{constructor(y,u,E,D,T,F,q){this.resource=y,this.g=u,this.h=E,this.j=D,this.k=T,this.l=F,this.d=q.extUri,this.f=(0,b.$egb)(void 0,this.resource,E,this.d)}async initialize({ref:y,content:u}){if(!u){this.j.info("Remote content does not exist.",this.resource);return}const E=this.m(u);if(E)try{await this.o({ref:y,syncData:E})}catch(D){this.j.error(D)}}m(y){try{const u=JSON.parse(y);if(c(u))return u}catch(u){this.j.error(u)}this.j.info("Cannot parse sync data as it is not compatible with the current version.",this.resource)}async n(y,u={}){if(u.ref||u.version)throw new Error("Cannot have core properties as additional");const E={ref:y.ref,version:void 0,...u};this.l.store(`${this.resource}.lastSyncUserData`,JSON.stringify(E),-1,1),await this.k.writeFile(this.f,O.$Hc.fromString(JSON.stringify(y)))}};e.$HAb=a,e.$HAb=a=ye([X(1,I.$Ck),X(2,h.$Gh),X(3,w.$3i),X(4,d.$4j),X(5,o.$So),X(6,$.$Ak)],a)}),define(re[115],oe([0,1,5,26,8,3,41,2,28,18,16,114,29,33,80,45,13,4,70,7,19,21,27,17,39,231,111,25,58]),function(te,e,L,N,O,j,A,R,k,m,P,p,g,h,d,w,f,o,l,$,b,I,t,c,s,n,i,r,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$f2b=e.$e2b=e.$d2b=e.$c2b=e.$b2b=void 0;async function v(F,q){const W=JSON.parse(F.content);if(F.version===1||F.version===2){const Z=(await q.getInstalled(0)).filter(Y=>Y.isBuiltin);for(const Y of W)F.version===1&&(Y.enabled===!1&&(Y.disabled=!0),delete Y.enabled),F.version===2&&Z.every(x=>!(0,h.$no)(x.identifier,Y.identifier))&&(Y.installed=!0)}return W}function y(F){return JSON.parse(F.content)}e.$b2b=y;function u(F,q){return F.sort((W,Z)=>!W.identifier.uuid&&Z.identifier.uuid?-1:W.identifier.uuid&&!Z.identifier.uuid?1:(0,k.$Hd)(W.identifier.id,Z.identifier.id)),q?(0,A.$nS)(F,{}):JSON.stringify(F)}e.$c2b=u;let E=class extends s.$EAb{constructor(q,W,Z,Y,x,G,Q,H,V,B,ee,ne,se,K,U,S,C){super({syncResource:"extensions",profile:q},W,Y,Z,x,G,Q,ne,se,B,ee,U),this.yb=H,this.zb=V,this.Ab=C,this.mb=6,this.sb=this.h.joinPath(this.g,"extensions.json"),this.tb=this.sb.with({scheme:r.$xgb,authority:"base"}),this.ub=this.sb.with({scheme:r.$xgb,authority:"local"}),this.vb=this.sb.with({scheme:r.$xgb,authority:"remote"}),this.wb=this.sb.with({scheme:r.$xgb,authority:"accepted"}),this.xb=this.Ab.createInstance(D),this.B(j.Event.any(j.Event.filter(this.yb.onDidInstallExtensions,z=>z.some(({local:M})=>!!M)),j.Event.filter(this.yb.onDidUninstallExtension,z=>!z.error),j.Event.filter(S.onDidChange,z=>z.valueChanges.some(({profile:M,changes:J})=>this.syncResource.profile.id===M.id&&J.some(_=>_.key===g.$1n))),K.onDidChangeExtensionStorageToSync)(()=>this.N()))}async nb(q,W){const Z=q.syncData?await v(q.syncData,this.yb):null,Y=W?.skippedExtensions??[],x=W?.builtinExtensions??null,G=W?.syncData?await v(W.syncData,this.yb):null,{localExtensions:Q,ignoredExtensions:H}=await this.xb.getLocalExtensions(this.syncResource.profile);Z?this.L.trace(`${this.y}: Merging remote extensions with local extensions...`):this.L.trace(`${this.y}: Remote extensions does not exist. Synchronizing extensions for the first time.`);const{local:V,remote:B}=(0,n.$a2b)(Q,Z,G,Y,H,x),ee={local:V,remote:B,content:this.Db(Q,V.added,V.updated,V.removed),localChange:V.added.length>0||V.removed.length>0||V.updated.length>0?2:0,remoteChange:B!==null?2:0},ne=this.Kb(Q,!1);return[{skippedExtensions:Y,builtinExtensions:x,baseResource:this.tb,baseContent:G?this.Kb(G,!1):ne,localResource:this.ub,localContent:ne,localExtensions:Q,remoteResource:this.vb,remoteExtensions:Z,remoteContent:Z?this.Kb(Z,!1):null,previewResource:this.sb,previewResult:ee,localChange:ee.localChange,remoteChange:ee.remoteChange,acceptedResource:this.wb}]}async rb(q){const W=q.syncData?await v(q.syncData,this.yb):null,{localExtensions:Z,ignoredExtensions:Y}=await this.xb.getLocalExtensions(this.syncResource.profile),{remote:x}=(0,n.$a2b)(Z,W,W,q.skippedExtensions||[],Y,q.builtinExtensions||[]);return x!==null}Db(q,W,Z,Y){const x=[...W,...Z],G=new Set,Q=H=>{G.add(H.id.toLowerCase()),H.uuid&&G.add(H.uuid)};x.forEach(({identifier:H})=>Q(H)),Y.forEach(Q);for(const H of q)G.has(H.identifier.id.toLowerCase())||H.identifier.uuid&&G.has(H.identifier.uuid)||x.push(H);return this.Kb(x,!1)}async ob(q,W){return{...q.previewResult,hasConflicts:!1}}async pb(q,W,Z,Y){if(this.h.isEqual(W,this.ub))return this.Gb(q);if(this.h.isEqual(W,this.vb))return this.Hb(q);if(this.h.isEqual(W,this.sb))return q.previewResult;throw new Error(`Invalid Resource: ${W.toString()}`)}async Gb(q){const W=await this.yb.getInstalled(void 0,this.syncResource.profile.extensionsResource),Z=this.zb.getIgnoredExtensions(W),Y=(0,n.$a2b)(q.localExtensions,null,null,q.skippedExtensions,Z,q.builtinExtensions),{local:x,remote:G}=Y;return{content:q.localContent,local:x,remote:G,localChange:x.added.length>0||x.removed.length>0||x.updated.length>0?2:0,remoteChange:G!==null?2:0}}async Hb(q){const W=await this.yb.getInstalled(void 0,this.syncResource.profile.extensionsResource),Z=this.zb.getIgnoredExtensions(W),Y=q.remoteContent?JSON.parse(q.remoteContent):null;if(Y!==null){const x=(0,n.$a2b)(q.localExtensions,Y,q.localExtensions,[],Z,q.builtinExtensions),{local:G,remote:Q}=x;return{content:q.remoteContent,local:G,remote:Q,localChange:G.added.length>0||G.removed.length>0||G.updated.length>0?2:0,remoteChange:Q!==null?2:0}}else return{content:q.remoteContent,local:{added:[],removed:[],updated:[]},remote:null,localChange:0,remoteChange:0}}async qb(q,W,Z,Y){let{skippedExtensions:x,builtinExtensions:G,localExtensions:Q}=Z[0][0];const{local:H,remote:V,localChange:B,remoteChange:ee}=Z[0][1];if(B===0&&ee===0&&this.L.info(`${this.y}: No changes found during synchronizing extensions.`),B!==0&&(await this.kb(JSON.stringify(Q)),x=await this.xb.updateLocalExtensions(H.added,H.removed,H.updated,x,this.syncResource.profile)),V){this.L.trace(`${this.y}: Updating remote extensions...`);const ne=JSON.stringify(V.all);q=await this.jb(ne,Y?null:q.ref),this.L.info(`${this.y}: Updated remote extensions.${V.added.length?` Added: ${JSON.stringify(V.added.map(se=>se.identifier.id))}.`:""}${V.updated.length?` Updated: ${JSON.stringify(V.updated.map(se=>se.identifier.id))}.`:""}${V.removed.length?` Removed: ${JSON.stringify(V.removed.map(se=>se.identifier.id))}.`:""}`)}W?.ref!==q.ref&&(this.L.trace(`${this.y}: Updating last synchronized extensions...`),G=this.Jb(Q,G),await this.cb(q,{skippedExtensions:x,builtinExtensions:G}),this.L.info(`${this.y}: Updated last synchronized extensions.${x.length?` Skipped: ${JSON.stringify(x.map(ne=>ne.identifier.id))}.`:""}`))}Jb(q,W){const Z=new Set,Y=[];for(const x of q)Z.add(x.identifier.id.toLowerCase()),x.installed||Y.push(x.identifier);if(W)for(const x of W)Z.has(x.id.toLowerCase())||Y.push(x);return Y}async resolveContent(q){if(this.h.isEqual(this.vb,q)||this.h.isEqual(this.tb,q)||this.h.isEqual(this.ub,q)||this.h.isEqual(this.wb,q)){const W=await this.ab(q);return W&&this.Kb(JSON.parse(W),!0)}return null}Kb(q,W){return u(q,W)}async hasLocalData(){try{const{localExtensions:q}=await this.xb.getLocalExtensions(this.syncResource.profile);if(q.some(W=>W.installed||W.disabled))return!0}catch{}return!1}};e.$d2b=E,e.$d2b=E=ye([X(2,P.$Gh),X(3,f.$4j),X(4,b.$So),X(5,r.$ggb),X(6,r.$hgb),X(7,g.$Zn),X(8,i.$mBb),X(9,r.$vgb),X(10,m.$6h),X(11,r.$qgb),X(12,I.$7k),X(13,d.$Pz),X(14,t.$Ak),X(15,a.$Nzb),X(16,o.$yh)],E);let D=class{constructor(q,W,Z,Y,x,G){this.a=q,this.b=W,this.c=Z,this.d=Y,this.f=x,this.g=G}async getLocalExtensions(q){const W=await this.a.getInstalled(void 0,q.extensionsResource),Z=this.d.getIgnoredExtensions(W);return{localExtensions:await this.j(q,async(x,G)=>{const Q=x.getDisabledExtensions();return W.map(H=>{const{identifier:V,isBuiltin:B,manifest:ee,preRelease:ne,pinned:se,isApplicationScoped:K}=H,U={identifier:V,preRelease:ne,version:ee.version,pinned:!!se};K&&!(0,w.$Wl)(ee)&&(U.isApplicationScoped=K),Q.some(S=>(0,h.$no)(S,V))&&(U.disabled=!0),B||(U.installed=!0);try{const S=G.getKeysForSync({id:V.id,version:ee.version});if(S){const C=G.getExtensionState(H,!0)||{};U.state=Object.keys(C).reduce((z,M)=>(S.includes(M)&&(z[M]=C[M]),z),{})}}catch(S){this.g.info(`${(0,s.$DAb)("extensions",q)}: Error while parsing extension state`,(0,O.$8)(S))}return U})}),ignoredExtensions:Z}}async updateLocalExtensions(q,W,Z,Y,x){const G=(0,s.$DAb)("extensions",x),Q=[],H=new Map,V=[],B=[],ee=await this.a.getInstalled(void 0,x.extensionsResource);if((q.length||Z.length)&&await this.j(x,async(K,U)=>{await L.Promises.settled([...q,...Z].map(async S=>{const C=ee.find(J=>(0,h.$no)(J.identifier,S.identifier));if(C&&C.isBuiltin){S.state&&C.manifest.version===S.version&&this.h(S.state,C,C.manifest.version,U),K.getDisabledExtensions().some(_=>(0,h.$no)(_,S.identifier))!==!!S.disabled&&(S.disabled?(this.g.trace(`${G}: Disabling extension...`,S.identifier.id),await K.disableExtension(S.identifier),this.g.info(`${G}: Disabled extension`,S.identifier.id)):(this.g.trace(`${G}: Enabling extension...`,S.identifier.id),await K.enableExtension(S.identifier),this.g.info(`${G}: Enabled extension`,S.identifier.id))),V.push(S.identifier);return}const z=S.pinned?S.version:void 0,M=(await this.c.getExtensions([{...S.identifier,version:z,preRelease:z?void 0:S.preRelease}],N.CancellationToken.None))[0];if(S.state&&(C?C.manifest.version===S.version:M)&&this.h(S.state,C||M,C?.manifest.version,U),M)try{K.getDisabledExtensions().some(_=>(0,h.$no)(_,S.identifier))!==!!S.disabled&&(S.disabled?(this.g.trace(`${G}: Disabling extension...`,S.identifier.id,M.version),await K.disableExtension(M.identifier),this.g.info(`${G}: Disabled extension`,S.identifier.id,M.version)):(this.g.trace(`${G}: Enabling extension...`,S.identifier.id,M.version),await K.enableExtension(M.identifier),this.g.info(`${G}: Enabled extension`,S.identifier.id,M.version))),(!C||C.preRelease!==S.preRelease||C.pinned!==S.pinned||z&&C.manifest.version!==z)&&(await this.a.canInstall(M)?(Q.push({extension:M,options:{isMachineScoped:!1,donotIncludePackAndDependencies:!0,installGivenVersion:S.pinned&&!!S.version,installPreReleaseVersion:S.preRelease,profileLocation:x.extensionsResource,isApplicationScoped:S.isApplicationScoped,context:{[g.$Nn]:!0,[g.$On]:!0}}}),H.set(M.identifier.id.toLowerCase(),S)):(this.g.info(`${G}: Skipped synchronizing extension because it cannot be installed.`,M.displayName||M.identifier.id),B.push(S)))}catch(J){B.push(S),this.g.error(J),this.g.info(`${G}: Skipped synchronizing extension`,M.displayName||M.identifier.id)}else B.push(S),this.g.info(`${G}: Skipped synchronizing extension because the extension is not found.`,S.identifier.id)}))}),W.length){const K=ee.filter(({identifier:U,isBuiltin:S})=>!S&&W.some(C=>(0,h.$no)(U,C)));await L.Promises.settled(K.map(async U=>{this.g.trace(`${G}: Uninstalling local extension...`,U.identifier.id),await this.a.uninstall(U,{donotIncludePack:!0,donotCheckDependents:!0,profileLocation:x.extensionsResource}),this.g.info(`${G}: Uninstalled local extension.`,U.identifier.id),V.push(U.identifier)}))}const ne=await this.a.installGalleryExtensions(Q);for(const{identifier:K,local:U,error:S,source:C}of ne){const z=C;if(U)this.g.info(`${G}: Installed extension.`,K.id,z.version),V.push(K);else{const M=H.get(K.id.toLowerCase());M&&(B.push(M),this.g.info(`${G}: Skipped synchronizing extension`,z.displayName||z.identifier.id)),S instanceof g.$Yn&&[g.ExtensionManagementErrorCode.Incompatible,g.ExtensionManagementErrorCode.IncompatibleTargetPlatform].includes(S.code)?this.g.info(`${G}: Skipped synchronizing extension because the compatible extension is not found.`,z.displayName||z.identifier.id):S&&this.g.error(S)}}const se=[];for(const K of Y)V.some(U=>(0,h.$no)(U,K.identifier))||se.push(K);for(const K of B)se.some(U=>(0,h.$no)(U.identifier,K.identifier))||se.push(K);return se}h(q,W,Z,Y){const x=Y.getExtensionState(W,!0)||{},G=Z?Y.getKeysForSync({id:W.identifier.id,version:Z}):void 0;G?G.forEach(Q=>{x[Q]=q[Q]}):Object.keys(q).forEach(Q=>x[Q]=q[Q]),Y.setExtensionState(W,x,!0)}async j(q,W){return this.b.withProfileScopedStorageService(q,async Z=>{const Y=new R.$lb,x=this.f.createChild(new l.$xh([b.$So,Z])),G=Y.add(x.createInstance(p.$_yb)),Q=Y.add(x.createInstance(d.$Qz));try{return await W(G,Q)}finally{Y.dispose()}})}};e.$e2b=D,e.$e2b=D=ye([X(0,g.$Zn),X(1,a.$Nzb),X(2,g.$Xn),X(3,i.$mBb),X(4,o.$yh),X(5,r.$vgb)],D);let T=class extends s.$HAb{constructor(q,W,Z,Y,x,G,Q,H){super("extensions",Y,x,G,Z,Q,H),this.p=q,this.q=W}async t(q){return q.syncData?await v(q.syncData,this.p):null}u(q,W){const Z=[],Y=[],x=[];for(const G of q){if(this.q.hasToNeverSyncExtension(G.identifier.id))continue;const Q=W.find(H=>(0,h.$no)(H.identifier,G.identifier));Q?(Z.push(Q),G.disabled&&x.push(G.identifier)):G.installed&&(Y.push({...G.identifier,preRelease:!!G.preRelease}),G.disabled&&x.push(G.identifier))}return{installedExtensions:Z,newExtensions:Y,disabledExtensions:x,remoteExtensions:q}}};e.$f2b=T,e.$f2b=T=ye([X(0,g.$Zn),X(1,i.$mBb),X(2,f.$4j),X(3,c.$Ck),X(4,P.$Gh),X(5,$.$3i),X(6,b.$So),X(7,t.$Ak)],T)}),define(re[116],oe([0,1,14,8,3,34,41,6,32,18,16,13,7,44,19,21,27,39,77,235,25,17,58,4]),function(te,e,L,N,O,j,A,R,k,m,P,p,g,h,d,w,f,o,l,$,b,I,t,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$NAb=e.$MAb=e.$LAb=e.$KAb=e.$JAb=void 0;const s="globalState.argv.",n=["locale"];function i(E,D){const T=E.storage?Object.keys(E.storage).sort():[],F={};return T.forEach(q=>F[q]=E.storage[q]),E.storage=F,D?(0,A.$nS)(E,{}):JSON.stringify(E)}e.$JAb=i;const r=1;let a=class extends o.$EAb{constructor(D,T,F,q,W,Z,Y,x,G,Q,H,V,B,ee){super({syncResource:"globalState",profile:D},T,q,x,V,W,Z,G,Q,Y,H,B),this.wb=F,this.mb=r,this.p=this.h.joinPath(this.g,"globalState.json"),this.r=this.p.with({scheme:b.$xgb,authority:"base"}),this.sb=this.p.with({scheme:b.$xgb,authority:"local"}),this.tb=this.p.with({scheme:b.$xgb,authority:"remote"}),this.ub=this.p.with({scheme:b.$xgb,authority:"accepted"}),this.vb=ee.createInstance(v),this.B(q.watch(this.h.dirname(this.D.argvResource))),this.B(O.Event.any(O.Event.filter(q.onDidFilesChange,ne=>ne.contains(this.D.argvResource)),O.Event.filter(F.onDidChange,ne=>!!(ne.targetChanges.some(se=>this.syncResource.profile.id===se.id)||ne.valueChanges.some(({profile:se,changes:K})=>this.syncResource.profile.id===se.id&&K.some(U=>U.target===0)))))(()=>this.N()))}async nb(D,T,F){const q=D.syncData?JSON.parse(D.syncData.content):null;T=T===null&&F?D:T;const W=T&&T.syncData?JSON.parse(T.syncData.content):null,Z=await this.vb.getLocalGlobalState(this.syncResource.profile);q?this.L.trace(`${this.y}: Merging remote ui state with local ui state...`):this.L.trace(`${this.y}: Remote ui state does not exist. Synchronizing ui state for the first time.`);const Y=await this.Eb(W),{local:x,remote:G}=(0,$.$IAb)(Z.storage,q?q.storage:null,W?W.storage:null,Y,this.L),Q={content:null,local:x,remote:G,localChange:Object.keys(x.added).length>0||Object.keys(x.updated).length>0||x.removed.length>0?2:0,remoteChange:G.all!==null?2:0},H=i(Z,!1);return[{baseResource:this.r,baseContent:W?i(W,!1):H,localResource:this.sb,localContent:H,localUserData:Z,remoteResource:this.tb,remoteContent:q?i(q,!1):null,previewResource:this.p,previewResult:Q,localChange:Q.localChange,remoteChange:Q.remoteChange,acceptedResource:this.ub,storageKeys:Y}]}async rb(D){const T=D.syncData?JSON.parse(D.syncData.content):null;if(T===null)return!0;const F=await this.vb.getLocalGlobalState(this.syncResource.profile),q=await this.Eb(T),{remote:W}=(0,$.$IAb)(F.storage,T.storage,T.storage,q,this.L);return W.all!==null}async ob(D,T){return{...D.previewResult,hasConflicts:!1}}async pb(D,T,F,q){if(this.h.isEqual(T,this.sb))return this.Bb(D);if(this.h.isEqual(T,this.tb))return this.Cb(D);if(this.h.isEqual(T,this.p))return D.previewResult;throw new Error(`Invalid Resource: ${T.toString()}`)}async Bb(D){return{content:D.localContent,local:{added:{},removed:[],updated:{}},remote:{added:Object.keys(D.localUserData.storage),removed:[],updated:[],all:D.localUserData.storage},localChange:0,remoteChange:2}}async Cb(D){if(D.remoteContent!==null){const T=JSON.parse(D.remoteContent),{local:F,remote:q}=(0,$.$IAb)(D.localUserData.storage,T.storage,null,D.storageKeys,this.L);return{content:D.remoteContent,local:F,remote:q,localChange:Object.keys(F.added).length>0||Object.keys(F.updated).length>0||F.removed.length>0?2:0,remoteChange:q!==null?2:0}}else return{content:D.remoteContent,local:{added:{},removed:[],updated:{}},remote:{added:[],removed:[],updated:[],all:null},localChange:0,remoteChange:0}}async qb(D,T,F,q){const{localUserData:W}=F[0][0],{local:Z,remote:Y,localChange:x,remoteChange:G}=F[0][1];if(x===0&&G===0&&this.L.info(`${this.y}: No changes found during synchronizing ui state.`),x!==0&&(this.L.trace(`${this.y}: Updating local ui state...`),await this.kb(JSON.stringify(W)),await this.vb.writeLocalGlobalState(Z,this.syncResource.profile),this.L.info(`${this.y}: Updated local ui state`)),G!==0){this.L.trace(`${this.y}: Updating remote ui state...`);const Q=JSON.stringify({storage:Y.all});D=await this.jb(Q,q?null:D.ref),this.L.info(`${this.y}: Updated remote ui state.${Y.added.length?` Added: ${Y.added}.`:""}${Y.updated.length?` Updated: ${Y.updated}.`:""}${Y.removed.length?` Removed: ${Y.removed}.`:""}`)}T?.ref!==D.ref&&(this.L.trace(`${this.y}: Updating last synchronized ui state...`),await this.cb(D),this.L.info(`${this.y}: Updated last synchronized ui state`))}async resolveContent(D){if(this.h.isEqual(this.tb,D)||this.h.isEqual(this.r,D)||this.h.isEqual(this.sb,D)||this.h.isEqual(this.ub,D)){const T=await this.ab(D);return T&&i(JSON.parse(T),!0)}return null}async hasLocalData(){try{const{storage:D}=await this.vb.getLocalGlobalState(this.syncResource.profile);if(Object.keys(D).length>1||D[`${s}.locale`]?.value!=="en")return!0}catch{}return!1}async Eb(D){const T=await this.wb.readStorageData(this.syncResource.profile),F=[],q=[];for(const[Y,x]of T)x.target===0?F.push(Y):x.target===1&&q.push(Y);const W=[...F,...q],Z=D?.storage?Object.keys(D.storage).filter(Y=>!Y.startsWith(s)&&!W.includes(Y)&&T.get(Y)!==void 0):[];if(!R.$o){const Y=[...b.$cgb.map(x=>(0,b.$pgb)(x)),b.$ogb];Z.push(...Y),q.push(...Y)}return{user:F,machine:q,unregistered:Z}}};e.$KAb=a,e.$KAb=a=ye([X(2,t.$Nzb),X(3,p.$4j),X(4,b.$ggb),X(5,b.$hgb),X(6,b.$vgb),X(7,P.$Gh),X(8,b.$qgb),X(9,w.$7k),X(10,m.$6h),X(11,d.$So),X(12,f.$Ak),X(13,c.$yh)],a);let v=class{constructor(D,T,F,q){this.a=D,this.b=T,this.c=F,this.d=q}async getLocalGlobalState(D){const T={};if(D.isDefault){const q=await this.f(),W=(0,j.$Jm)(q);for(const Z of n)W[Z]!==void 0&&(T[`${s}${Z}`]={version:1,value:W[Z]})}const F=await this.c.readStorageData(D);for(const[q,W]of F)W.value&&W.target===0&&(T[q]={version:1,value:W.value});return{storage:T}}async f(){try{this.d.debug("GlobalStateSync#getLocalArgvContent",this.b.argvResource);const D=await this.a.readFile(this.b.argvResource);return this.d.debug("GlobalStateSync#getLocalArgvContent - Resolved",this.b.argvResource),D.value.toString()}catch(D){this.d.debug((0,N.$8)(D))}return"{}"}async writeLocalGlobalState({added:D,removed:T,updated:F},q){const W=(0,o.$DAb)("globalState",q),Z={},Y=new Map,x=await this.c.readStorageData(q),G=(Q,H)=>{for(const V of Q){if(V.startsWith(s)){Z[V.substring(s.length)]=H?H[V].value:void 0;continue}if(H){const B=H[V];B.value!==x.get(V)?.value&&Y.set(V,B.value)}else x.get(V)!==void 0&&Y.set(V,void 0)}};if(G(Object.keys(D),D),G(Object.keys(F),F),G(T),Object.keys(Z).length){this.d.trace(`${W}: Updating locale...`);const Q=await this.f();let H=Q;for(const V of Object.keys(Z))H=(0,l.edit)(H,[V],Z[V],{});Q!==H&&(this.d.trace(`${W}: Updating locale...`),await this.a.writeFile(this.b.argvResource,L.$Hc.fromString(H)),this.d.info(`${W}: Updated locale.`)),this.d.info(`${W}: Updated locale`)}Y.size&&(this.d.trace(`${W}: Updating global state...`),await this.c.updateStorageData(q,Y,0),this.d.info(`${W}: Updated global state`,[...Y.keys()]))}};e.$LAb=v,e.$LAb=v=ye([X(0,p.$4j),X(1,P.$Gh),X(2,t.$Nzb),X(3,b.$vgb)],v);let y=class extends o.$HAb{constructor(D,T,F,q,W,Z){super("globalState",F,q,W,T,D,Z)}async o(D){const T=D.syncData?JSON.parse(D.syncData.content):null;if(!T){this.j.info("Skipping initializing global state because remote global state does not exist.");return}const F={},q={};for(const W of Object.keys(T.storage))W.startsWith(s)?F[W.substring(s.length)]=T.storage[W].value:this.l.get(W,0)===void 0&&(q[W]=T.storage[W].value);if(Object.keys(F).length){let W="{}";try{W=(await this.k.readFile(this.h.argvResource)).value.toString()}catch{}for(const Z of Object.keys(F))W=(0,l.edit)(W,[Z],F[Z],{});await this.k.writeFile(this.h.argvResource,L.$Hc.fromString(W))}if(Object.keys(q).length){const W=[];for(const Z of Object.keys(q))W.push({key:Z,value:q[Z],scope:0,target:0});this.l.storeAll(W,!0)}}};e.$MAb=y,e.$MAb=y=ye([X(0,d.$So),X(1,p.$4j),X(2,I.$Ck),X(3,P.$Gh),X(4,b.$vgb),X(5,f.$Ak)],y);let u=class{constructor(D,T,F,q,W){this.a=D,this.b=T,this.c=F,this.d=q,this.f=W}getSyncStoreType(D){return this.h(D)?.storage[b.$ogb]?.value}async sync(D){const T=(0,b.$kgb)((0,k.$6e)());try{return await this.g(D,T)}catch(F){if(F instanceof b.$lgb)switch(F.code){case"PreconditionFailed":return this.f.info("Failed to synchronize UserDataSyncStoreType as there is a new remote version available. Synchronizing again..."),this.g(D,T)}throw F}}async g(D,T){const F=await this.a.readResource("globalState",null,void 0,T),q=this.h(F)||{storage:{}};q.storage[b.$ogb]={value:D,version:r};const W=await(0,h.$Yo)(this.c,this.d,this.b),Z={version:r,machineId:W,content:i(q,!1)};await this.a.writeResource("globalState",JSON.stringify(Z),F.ref,void 0,T)}h({content:D}){if(!D)return null;const T=JSON.parse(D);if((0,o.$CAb)(T))return T?JSON.parse(T.content):null;throw new Error("Invalid remote data")}};e.$NAb=u,e.$NAb=u=ye([X(1,d.$So),X(2,P.$Gh),X(3,p.$4j),X(4,g.$3i)],u)}),define(re[117],oe([0,1,20,14,3,34,6,9,170,18,16,13,19,21,27,17,39,232,25]),function(te,e,L,N,O,j,A,R,k,m,P,p,g,h,d,w,f,o,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$j2b=e.$i2b=e.$h2b=void 0;function $(t,c,s){try{const n=JSON.parse(t);if(!c)return(0,R.$se)(n.all)?null:n.all;switch(A.OS){case 2:return(0,R.$se)(n.mac)?null:n.mac;case 3:return(0,R.$se)(n.linux)?null:n.linux;case 1:return(0,R.$se)(n.windows)?null:n.windows}}catch(n){return s.error(n),null}}e.$h2b=$;let b=class extends f.$GAb{constructor(c,s,n,i,r,a,v,y,u,E,D,T,F){super(c.keybindingsResource,{syncResource:"keybindings",profile:c},s,y,u,E,n,i,v,T,r,D,a,F),this.mb=2,this.zb=this.h.joinPath(this.g,"keybindings.json"),this.Ab=this.zb.with({scheme:l.$xgb,authority:"base"}),this.Bb=this.zb.with({scheme:l.$xgb,authority:"local"}),this.Cb=this.zb.with({scheme:l.$xgb,authority:"remote"}),this.Db=this.zb.with({scheme:l.$xgb,authority:"accepted"}),this.B(O.Event.filter(a.onDidChangeConfiguration,q=>q.affectsConfiguration("settingsSync.keybindingsPerPlatform"))(()=>this.N()))}async nb(c,s,n,i){const r=c.syncData?$(c.syncData.content,i.keybindingsPerPlatform??this.Lb(),this.L):null;s=s===null&&n?c:s;const a=s?this.Jb(s):null,v=await this.p(),y=await this.xb();let u=null,E=!1,D=!1,T=!1;if(r){let W=v?v.value.toString():"[]";if(W=W||"[]",this.vb(W,!0))throw new l.$lgb((0,k.localize)(0,null),"LocalInvalidContent",this.resource);if(!a||a!==W||a!==r){this.L.trace(`${this.y}: Merging remote keybindings with local keybindings...`);const Z=await(0,o.$g2b)(W,r,a,y,this.ub);Z.hasChanges&&(u=Z.mergeContent,T=Z.hasConflicts,E=T||Z.mergeContent!==W,D=T||Z.mergeContent!==r)}}else v&&(this.L.trace(`${this.y}: Remote keybindings does not exist. Synchronizing keybindings for the first time.`),u=v.value.toString(),D=!0);const F={content:T?a:u,localChange:E?v?2:1:0,remoteChange:D?2:0,hasConflicts:T},q=v?v.value.toString():null;return[{fileContent:v,baseResource:this.Ab,baseContent:a,localResource:this.Bb,localContent:q,localChange:F.localChange,remoteResource:this.Cb,remoteContent:r,remoteChange:F.remoteChange,previewResource:this.zb,previewResult:F,acceptedResource:this.Db}]}async rb(c){const s=this.Jb(c);if(s===null)return!0;const n=await this.p(),i=n?n.value.toString():"",r=await this.xb(),a=await(0,o.$g2b)(i||"[]",s,s,r,this.ub);return a.hasConflicts||a.mergeContent!==s}async ob(c,s){return c.previewResult}async pb(c,s,n,i){if(this.h.isEqual(s,this.Bb))return{content:c.fileContent?c.fileContent.value.toString():null,localChange:0,remoteChange:2};if(this.h.isEqual(s,this.Cb))return{content:c.remoteContent,localChange:2,remoteChange:0};if(this.h.isEqual(s,this.zb))return n===void 0?{content:c.previewResult.content,localChange:c.previewResult.localChange,remoteChange:c.previewResult.remoteChange}:{content:n,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${s.toString()}`)}async qb(c,s,n,i){const{fileContent:r}=n[0][0];let{content:a,localChange:v,remoteChange:y}=n[0][1];if(v===0&&y===0&&this.L.info(`${this.y}: No changes found during synchronizing keybindings.`),a!==null&&(a=a.trim(),a=a||"[]",this.vb(a,!0)))throw new l.$lgb((0,k.localize)(1,null),"LocalInvalidContent",this.resource);if(v!==0&&(this.L.trace(`${this.y}: Updating local keybindings...`),r&&await this.kb(this.Kb(r.value.toString())),await this.r(a||"[]",r,i),this.L.info(`${this.y}: Updated local keybindings`)),y!==0){this.L.trace(`${this.y}: Updating remote keybindings...`);const u=this.Kb(a||"[]",c.syncData?.content);c=await this.jb(u,i?null:c.ref),this.L.info(`${this.y}: Updated remote keybindings`)}try{await this.C.del(this.zb)}catch{}s?.ref!==c.ref&&(this.L.trace(`${this.y}: Updating last synchronized keybindings...`),await this.cb(c,{platformSpecific:this.Lb()}),this.L.info(`${this.y}: Updated last synchronized keybindings`))}async hasLocalData(){try{const c=await this.p();if(c){const s=(0,j.$Jm)(c.value.toString());if((0,L.$Ef)(s))return!0}}catch(c){if(c.fileOperationResult!==1)return!0}return!1}async resolveContent(c){return this.h.isEqual(this.Cb,c)||this.h.isEqual(this.Ab,c)||this.h.isEqual(this.Bb,c)||this.h.isEqual(this.Db,c)?this.ab(c):null}Jb(c){return!c.syncData||c.platformSpecific!==void 0&&c.platformSpecific!==this.Lb()?null:$(c.syncData.content,this.Lb(),this.L)}Kb(c,s){let n={};try{n=JSON.parse(s||"{}")}catch(i){this.L.error(i)}switch(this.Lb()?delete n.all:n.all=c,A.OS){case 2:n.mac=c;break;case 3:n.linux=c;break;case 1:n.windows=c;break}return JSON.stringify(n)}Lb(){return!!this.M.getValue(l.$_fb)}};e.$i2b=b,e.$i2b=b=ye([X(2,l.$ggb),X(3,l.$hgb),X(4,l.$vgb),X(5,m.$6h),X(6,l.$qgb),X(7,p.$4j),X(8,P.$Gh),X(9,g.$So),X(10,l.$ugb),X(11,h.$7k),X(12,d.$Ak)],b);let I=class extends f.$HAb{constructor(c,s,n,i,r,a){super("keybindings",s,n,i,c,r,a)}async o(c){const s=c.syncData?this.p(c.syncData.content):null;if(!s){this.j.info("Skipping initializing keybindings because remote keybindings does not exist.");return}if(!await this.i()){this.j.info("Skipping initializing keybindings because local keybindings exist.");return}await this.k.writeFile(this.g.defaultProfile.keybindingsResource,N.$Hc.fromString(s)),await this.n(c)}async i(){try{const c=await this.k.readFile(this.g.defaultProfile.settingsResource),s=(0,j.$Jm)(c.value.toString());return!(0,L.$Ef)(s)}catch(c){return c.fileOperationResult===1}}p(c){try{return $(c,!0,this.j)}catch(s){return this.j.error(s),null}}};e.$j2b=I,e.$j2b=I=ye([X(0,p.$4j),X(1,w.$Ck),X(2,P.$Gh),X(3,l.$vgb),X(4,g.$So),X(5,d.$Ak)],I)}),define(re[118],oe([0,1,14,3,171,18,73,16,29,13,19,21,27,17,39,236,25]),function(te,e,L,N,O,j,A,R,k,m,P,p,g,h,d,w,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$m2b=e.$l2b=e.$k2b=void 0;function o(I){return I&&I.settings&&typeof I.settings=="string"&&Object.keys(I).length===1}function l(I){const t=JSON.parse(I);return o(t)?t:{settings:I}}e.$k2b=l;let $=class extends d.$GAb{constructor(t,c,s,n,i,r,a,v,y,u,E,D,T,F){super(t.settingsResource,{syncResource:"settings",profile:t},c,s,n,i,r,a,E,D,v,y,u,F),this.zb=T,this.mb=2,this.previewResource=this.h.joinPath(this.g,"settings.json"),this.baseResource=this.previewResource.with({scheme:f.$xgb,authority:"base"}),this.localResource=this.previewResource.with({scheme:f.$xgb,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:f.$xgb,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:f.$xgb,authority:"accepted"}),this.Jb=void 0}async getRemoteUserDataSyncConfiguration(t){const c=await this.getLastSyncUserData(),s=await this.S(t,c),n=this.Gb(s),i=new A.$pn(f.$$fb);return n?.settings&&i.parse(n.settings),i.configurationModel.getValue(f.$$fb)||{}}async nb(t,c,s){const n=await this.p(),i=await this.xb(),r=this.Gb(t);c=c===null&&s?t:c;const a=c?this.Gb(c):null,v=await this.Kb();let y=null,u=!1,E=!1,D=!1;if(r){let W=n?n.value.toString().trim():"{}";W=W||"{}",this.Lb(W),this.L.trace(`${this.y}: Merging remote settings with local settings...`);const Z=(0,w.$uzb)(W,r.settings,a?a.settings:null,v,[],i);y=Z.localContent||Z.remoteContent,u=Z.localContent!==null,E=Z.remoteContent!==null,D=Z.hasConflicts}else n&&(this.L.trace(`${this.y}: Remote settings does not exist. Synchronizing settings for the first time.`),y=n.value.toString().trim()||"{}",this.Lb(y),E=!0);const T=n?n.value.toString():null,F=a?.settings??null,q={content:D?F:y,localChange:u?2:0,remoteChange:E?2:0,hasConflicts:D};return[{fileContent:n,baseResource:this.baseResource,baseContent:F,localResource:this.localResource,localContent:T,localChange:q.localChange,remoteResource:this.remoteResource,remoteContent:r?r.settings:null,remoteChange:q.remoteChange,previewResource:this.previewResource,previewResult:q,acceptedResource:this.acceptedResource}]}async rb(t){const c=this.Gb(t);if(c===null)return!0;const s=await this.p(),n=s?s.value.toString().trim():"",i=await this.Kb(),r=await this.xb();return(0,w.$uzb)(n||"{}",c.settings,c.settings,i,[],r).remoteContent!==null}async ob(t,c){const s=await this.xb(),n=await this.Kb();return{...t.previewResult,content:t.previewResult.content?(0,w.$tzb)(t.previewResult.content,"{}",n,s):null}}async pb(t,c,s,n){const i=await this.xb(),r=await this.Kb();if(this.h.isEqual(c,this.localResource))return{content:t.fileContent?(0,w.$tzb)(t.fileContent.value.toString(),"{}",r,i):null,localChange:0,remoteChange:2};if(this.h.isEqual(c,this.remoteResource))return{content:t.remoteContent!==null?(0,w.$tzb)(t.remoteContent,t.fileContent?t.fileContent.value.toString():"{}",r,i):null,localChange:2,remoteChange:0};if(this.h.isEqual(c,this.previewResource))return s===void 0?{content:t.previewResult.content,localChange:t.previewResult.localChange,remoteChange:t.previewResult.remoteChange}:{content:s!==null?(0,w.$tzb)(s,t.fileContent?t.fileContent.value.toString():"{}",r,i):null,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${c.toString()}`)}async qb(t,c,s,n){const{fileContent:i}=s[0][0];let{content:r,localChange:a,remoteChange:v}=s[0][1];if(a===0&&v===0&&this.L.info(`${this.y}: No changes found during synchronizing settings.`),r=r?r.trim():"{}",r=r||"{}",this.Lb(r),a!==0&&(this.L.trace(`${this.y}: Updating local settings...`),i&&await this.kb(JSON.stringify(this.Ib(i.value.toString()))),await this.r(r,i,n),await this.M.reloadConfiguration(3),this.L.info(`${this.y}: Updated local settings`)),v!==0){const y=await this.xb(),u=this.Gb(t),E=await this.Kb(r);r=(0,w.$tzb)(r,u?u.settings:"{}",E,y),this.L.trace(`${this.y}: Updating remote settings...`),t=await this.jb(JSON.stringify(this.Ib(r)),n?null:t.ref),this.L.info(`${this.y}: Updated remote settings`)}try{await this.C.del(this.previewResource)}catch{}c?.ref!==t.ref&&(this.L.trace(`${this.y}: Updating last synchronized settings...`),await this.cb(t),this.L.info(`${this.y}: Updated last synchronized settings`))}async hasLocalData(){try{const t=await this.p();if(t)return!(0,w.$vzb)(t.value.toString())}catch(t){if(t.fileOperationResult!==1)return!0}return!1}async resolveContent(t){return this.h.isEqual(this.remoteResource,t)||this.h.isEqual(this.localResource,t)||this.h.isEqual(this.acceptedResource,t)||this.h.isEqual(this.baseResource,t)?this.ab(t):null}async ab(t){let c=await super.ab(t);if(c){const s=await this.xb(),n=await this.Kb();c=(0,w.$tzb)(c,"{}",n,s)}return c}Gb(t){return t.syncData?this.Hb(t.syncData.content):null}Hb(t){try{return l(t)}catch(c){this.L.error(c)}return null}Ib(t){return{settings:t}}async Kb(t){if(!this.Jb){this.Jb=this.ub.resolveDefaultIgnoredSettings();const s=this.B(N.Event.any(N.Event.filter(this.zb.onDidInstallExtensions,n=>n.some(({local:i})=>!!i)),N.Event.filter(this.zb.onDidUninstallExtension,n=>!n.error))(()=>{s.dispose(),this.Jb=void 0}))}const c=await this.Jb;return(0,w.$rzb)(c,this.M,t)}Lb(t){if(this.vb(t,!1))throw new f.$lgb((0,O.localize)(0,null),"LocalInvalidContent",this.resource)}};e.$l2b=$,e.$l2b=$=ye([X(2,m.$4j),X(3,R.$Gh),X(4,P.$So),X(5,f.$ggb),X(6,f.$hgb),X(7,f.$vgb),X(8,f.$ugb),X(9,j.$6h),X(10,f.$qgb),X(11,p.$7k),X(12,k.$Zn),X(13,g.$Ak)],$);let b=class extends d.$HAb{constructor(t,c,s,n,i,r){super("settings",c,s,n,t,i,r)}async o(t){const c=t.syncData?this.p(t.syncData.content):null;if(!c){this.j.info("Skipping initializing settings because remote settings does not exist.");return}if(!await this.i()){this.j.info("Skipping initializing settings because local settings exist.");return}await this.k.writeFile(this.g.defaultProfile.settingsResource,L.$Hc.fromString(c.settings)),await this.n(t)}async i(){try{const t=await this.k.readFile(this.g.defaultProfile.settingsResource);return(0,w.$vzb)(t.value.toString().trim())}catch(t){return t.fileOperationResult===1}}p(t){try{return l(t)}catch(c){this.j.error(c)}return null}};e.$m2b=b,e.$m2b=b=ye([X(0,m.$4j),X(1,h.$Ck),X(2,R.$Gh),X(3,f.$vgb),X(4,P.$So),X(5,g.$Ak)],b)}),define(re[119],oe([0,1,14,3,30,18,16,13,19,21,27,17,39,233,25]),function(te,e,L,N,O,j,A,R,k,m,P,p,g,h,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$r2b=e.$q2b=e.$p2b=void 0;function w(l){return JSON.parse(l.content)}e.$p2b=w;let f=class extends g.$EAb{constructor($,b,I,t,c,s,n,i,r,a,v,y){super({syncResource:"snippets",profile:$},b,t,I,c,s,n,a,v,i,r,y),this.mb=1,this.p=$.snippetsHome,this.B(this.C.watch(I.userRoamingDataHome)),this.B(this.C.watch(this.p)),this.B(N.Event.filter(this.C.onDidFilesChange,u=>u.affects(this.p))(()=>this.N()))}async nb($,b,I){const t=await this.Cb(),c=this.Bb(t),s=$.syncData?this.Ab($.syncData):null;b=b===null&&I?$:b;const n=b&&b.syncData?this.Ab(b.syncData):null;s?this.L.trace(`${this.y}: Merging remote snippets with local snippets...`):this.L.trace(`${this.y}: Remote snippets does not exist. Synchronizing snippets for the first time.`);const i=(0,h.$n2b)(c,s,n);return this.wb(i,t,s||{},n||{})}async rb($){const b=$.syncData?this.Ab($.syncData):null;if(b===null)return!0;const I=await this.Cb(),t=this.Bb(I),c=(0,h.$n2b)(t,b,b);return Object.keys(c.remote.added).length>0||Object.keys(c.remote.updated).length>0||c.remote.removed.length>0||c.conflicts.length>0}async ob($,b){return $.previewResult}async pb($,b,I,t){if(this.h.isEqualOrParent(b,this.g.with({scheme:d.$xgb,authority:"local"})))return{content:$.fileContent?$.fileContent.value.toString():null,localChange:0,remoteChange:$.fileContent?$.remoteContent!==null?2:1:3};if(this.h.isEqualOrParent(b,this.g.with({scheme:d.$xgb,authority:"remote"})))return{content:$.remoteContent,localChange:$.remoteContent!==null?$.fileContent?2:1:3,remoteChange:0};if(this.h.isEqualOrParent(b,this.g))return I===void 0?{content:$.previewResult.content,localChange:$.previewResult.localChange,remoteChange:$.previewResult.remoteChange}:{content:I,localChange:I===null?$.fileContent!==null?3:0:2,remoteChange:I===null?$.remoteContent!==null?3:0:2};throw new Error(`Invalid Resource: ${b.toString()}`)}async qb($,b,I,t){const c=I.map(([s,n])=>({...s,acceptResult:n}));c.every(({localChange:s,remoteChange:n})=>s===0&&n===0)&&this.L.info(`${this.y}: No changes found during synchronizing snippets.`),c.some(({localChange:s})=>s!==0)&&(await this.xb(c),await this.yb(c,t)),c.some(({remoteChange:s})=>s!==0)&&($=await this.zb(c,$,t)),b?.ref!==$.ref&&(this.L.trace(`${this.y}: Updating last synchronized snippets...`),await this.cb($),this.L.info(`${this.y}: Updated last synchronized snippets`));for(const{previewResource:s}of c)try{await this.C.del(s)}catch{}}wb($,b,I,t){const c=new Map;for(const s of Object.keys($.local.added)){const n={content:$.local.added[s],hasConflicts:!1,localChange:1,remoteChange:0};c.set(s,{baseResource:this.h.joinPath(this.g,s).with({scheme:d.$xgb,authority:"base"}),baseContent:null,fileContent:null,localResource:this.h.joinPath(this.g,s).with({scheme:d.$xgb,authority:"local"}),localContent:null,remoteResource:this.h.joinPath(this.g,s).with({scheme:d.$xgb,authority:"remote"}),remoteContent:I[s],previewResource:this.h.joinPath(this.g,s),previewResult:n,localChange:n.localChange,remoteChange:n.remoteChange,acceptedResource:this.h.joinPath(this.g,s).with({scheme:d.$xgb,authority:"accepted"})})}for(const s of Object.keys($.local.updated)){const n={content:$.local.updated[s],hasConflicts:!1,localChange:2,remoteChange:0},i=b[s]?b[s].value.toString():null;c.set(s,{baseResource:this.h.joinPath(this.g,s).with({scheme:d.$xgb,authority:"base"}),baseContent:t[s]??null,localResource:this.h.joinPath(this.g,s).with({scheme:d.$xgb,authority:"local"}),fileContent:b[s],localContent:i,remoteResource:this.h.joinPath(this.g,s).with({scheme:d.$xgb,authority:"remote"}),remoteContent:I[s],previewResource:this.h.joinPath(this.g,s),previewResult:n,localChange:n.localChange,remoteChange:n.remoteChange,acceptedResource:this.h.joinPath(this.g,s).with({scheme:d.$xgb,authority:"accepted"})})}for(const s of $.local.removed){const n={content:null,hasConflicts:!1,localChange:3,remoteChange:0},i=b[s]?b[s].value.toString():null;c.set(s,{baseResource:this.h.joinPath(this.g,s).with({scheme:d.$xgb,authority:"base"}),baseContent:t[s]??null,localResource:this.h.joinPath(this.g,s).with({scheme:d.$xgb,authority:"local"}),fileContent:b[s],localContent:i,remoteResource:this.h.joinPath(this.g,s).with({scheme:d.$xgb,authority:"remote"}),remoteContent:null,previewResource:this.h.joinPath(this.g,s),previewResult:n,localChange:n.localChange,remoteChange:n.remoteChange,acceptedResource:this.h.joinPath(this.g,s).with({scheme:d.$xgb,authority:"accepted"})})}for(const s of Object.keys($.remote.added)){const n={content:$.remote.added[s],hasConflicts:!1,localChange:0,remoteChange:1},i=b[s]?b[s].value.toString():null;c.set(s,{baseResource:this.h.joinPath(this.g,s).with({scheme:d.$xgb,authority:"base"}),baseContent:t[s]??null,localResource:this.h.joinPath(this.g,s).with({scheme:d.$xgb,authority:"local"}),fileContent:b[s],localContent:i,remoteResource:this.h.joinPath(this.g,s).with({scheme:d.$xgb,authority:"remote"}),remoteContent:null,previewResource:this.h.joinPath(this.g,s),previewResult:n,localChange:n.localChange,remoteChange:n.remoteChange,acceptedResource:this.h.joinPath(this.g,s).with({scheme:d.$xgb,authority:"accepted"})})}for(const s of Object.keys($.remote.updated)){const n={content:$.remote.updated[s],hasConflicts:!1,localChange:0,remoteChange:2},i=b[s]?b[s].value.toString():null;c.set(s,{baseResource:this.h.joinPath(this.g,s).with({scheme:d.$xgb,authority:"base"}),baseContent:t[s]??null,localResource:this.h.joinPath(this.g,s).with({scheme:d.$xgb,authority:"local"}),fileContent:b[s],localContent:i,remoteResource:this.h.joinPath(this.g,s).with({scheme:d.$xgb,authority:"remote"}),remoteContent:I[s],previewResource:this.h.joinPath(this.g,s),previewResult:n,localChange:n.localChange,remoteChange:n.remoteChange,acceptedResource:this.h.joinPath(this.g,s).with({scheme:d.$xgb,authority:"accepted"})})}for(const s of $.remote.removed){const n={content:null,hasConflicts:!1,localChange:0,remoteChange:3};c.set(s,{baseResource:this.h.joinPath(this.g,s).with({scheme:d.$xgb,authority:"base"}),baseContent:t[s]??null,localResource:this.h.joinPath(this.g,s).with({scheme:d.$xgb,authority:"local"}),fileContent:null,localContent:null,remoteResource:this.h.joinPath(this.g,s).with({scheme:d.$xgb,authority:"remote"}),remoteContent:I[s],previewResource:this.h.joinPath(this.g,s),previewResult:n,localChange:n.localChange,remoteChange:n.remoteChange,acceptedResource:this.h.joinPath(this.g,s).with({scheme:d.$xgb,authority:"accepted"})})}for(const s of $.conflicts){const n={content:t[s]??null,hasConflicts:!0,localChange:b[s]?2:1,remoteChange:I[s]?2:1},i=b[s]?b[s].value.toString():null;c.set(s,{baseResource:this.h.joinPath(this.g,s).with({scheme:d.$xgb,authority:"base"}),baseContent:t[s]??null,localResource:this.h.joinPath(this.g,s).with({scheme:d.$xgb,authority:"local"}),fileContent:b[s]||null,localContent:i,remoteResource:this.h.joinPath(this.g,s).with({scheme:d.$xgb,authority:"remote"}),remoteContent:I[s]||null,previewResource:this.h.joinPath(this.g,s),previewResult:n,localChange:n.localChange,remoteChange:n.remoteChange,acceptedResource:this.h.joinPath(this.g,s).with({scheme:d.$xgb,authority:"accepted"})})}for(const s of Object.keys(b))if(!c.has(s)){const n={content:b[s]?b[s].value.toString():null,hasConflicts:!1,localChange:0,remoteChange:0},i=b[s]?b[s].value.toString():null;c.set(s,{baseResource:this.h.joinPath(this.g,s).with({scheme:d.$xgb,authority:"base"}),baseContent:t[s]??null,localResource:this.h.joinPath(this.g,s).with({scheme:d.$xgb,authority:"local"}),fileContent:b[s]||null,localContent:i,remoteResource:this.h.joinPath(this.g,s).with({scheme:d.$xgb,authority:"remote"}),remoteContent:I[s]||null,previewResource:this.h.joinPath(this.g,s),previewResult:n,localChange:n.localChange,remoteChange:n.remoteChange,acceptedResource:this.h.joinPath(this.g,s).with({scheme:d.$xgb,authority:"accepted"})})}return[...c.values()]}async resolveContent($){return this.h.isEqualOrParent($,this.g.with({scheme:d.$xgb,authority:"remote"}))||this.h.isEqualOrParent($,this.g.with({scheme:d.$xgb,authority:"local"}))||this.h.isEqualOrParent($,this.g.with({scheme:d.$xgb,authority:"base"}))||this.h.isEqualOrParent($,this.g.with({scheme:d.$xgb,authority:"accepted"}))?this.ab($):null}async hasLocalData(){try{const $=await this.Cb();if(Object.keys($).length)return!0}catch{}return!1}async xb($){const b={};for(const I of $)I.fileContent&&(b[this.h.basename(I.localResource)]=I.fileContent);await this.kb(JSON.stringify(this.Bb(b)))}async yb($,b){for(const{fileContent:I,acceptResult:t,localResource:c,remoteResource:s,localChange:n}of $)if(n!==0){const i=s?this.h.basename(s):this.h.basename(c),r=this.h.joinPath(this.p,i);n===3?(this.L.trace(`${this.y}: Deleting snippet...`,this.h.basename(r)),await this.C.del(r),this.L.info(`${this.y}: Deleted snippet`,this.h.basename(r))):n===1?(this.L.trace(`${this.y}: Creating snippet...`,this.h.basename(r)),await this.C.createFile(r,L.$Hc.fromString(t.content),{overwrite:b}),this.L.info(`${this.y}: Created snippet`,this.h.basename(r))):(this.L.trace(`${this.y}: Updating snippet...`,this.h.basename(r)),await this.C.writeFile(r,L.$Hc.fromString(t.content),b?void 0:I),this.L.info(`${this.y}: Updated snippet`,this.h.basename(r)))}}async zb($,b,I){const t=b.syncData?this.Ab(b.syncData):{},c=(0,O.$Tm)(t);for(const{acceptResult:s,localResource:n,remoteResource:i,remoteChange:r}of $)if(r!==0){const a=n?this.h.basename(n):this.h.basename(i);r===3?delete c[a]:c[a]=s.content}return(0,h.$o2b)(t,c)||(this.L.trace(`${this.y}: Updating remote snippets...`),b=await this.jb(JSON.stringify(c),I?null:b.ref),this.L.info(`${this.y}: Updated remote snippets`)),b}Ab($){return w($)}Bb($){const b={};for(const I of Object.keys($))b[I]=$[I].value.toString();return b}async Cb(){const $={};let b;try{b=await this.C.resolve(this.p)}catch(I){if(I instanceof R.$lk&&I.fileOperationResult===1)return $;throw I}for(const I of b.children||[]){const t=I.resource,c=this.h.extname(t);if(c===".json"||c===".code-snippets"){const s=this.h.relativePath(this.p,t),n=await this.C.readFile(t);$[s]=n}}return $}};e.$q2b=f,e.$q2b=f=ye([X(2,A.$Gh),X(3,R.$4j),X(4,k.$So),X(5,d.$ggb),X(6,d.$hgb),X(7,d.$vgb),X(8,j.$6h),X(9,d.$qgb),X(10,m.$7k),X(11,P.$Ak)],f);let o=class extends g.$HAb{constructor($,b,I,t,c,s){super("snippets",b,I,t,$,c,s)}async o($){const b=$.syncData?JSON.parse($.syncData.content):null;if(!b){this.j.info("Skipping initializing snippets because remote snippets does not exist.");return}if(!await this.i()){this.j.info("Skipping initializing snippets because local snippets exist.");return}for(const t of Object.keys(b)){const c=b[t];if(c){const s=this.d.joinPath(this.g.defaultProfile.snippetsHome,t);await this.k.createFile(s,L.$Hc.fromString(c)),this.j.info("Created snippet",this.d.basename(s))}}await this.n($)}async i(){try{return!(await this.k.resolve(this.g.defaultProfile.snippetsHome)).children?.length}catch($){return $.fileOperationResult===1}}};e.$r2b=o,e.$r2b=o=ye([X(0,R.$4j),X(1,p.$Ck),X(2,A.$Gh),X(3,d.$vgb),X(4,k.$So),X(5,P.$Ak)],o)}),define(re[120],oe([0,1,14,18,16,13,19,21,27,17,39,25]),function(te,e,L,N,O,j,A,R,k,m,P,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$u2b=e.$t2b=e.$s2b=void 0;function g(f,o){try{return JSON.parse(f).tasks??null}catch(l){return o.error(l),null}}e.$s2b=g;let h=class extends P.$FAb{constructor(o,l,$,b,I,t,c,s,n,i,r,a){super(o.tasksResource,{syncResource:"tasks",profile:o},l,s,n,i,$,b,c,r,I,t,a),this.mb=1,this.vb=this.h.joinPath(this.g,"tasks.json"),this.wb=this.vb.with({scheme:p.$xgb,authority:"base"}),this.xb=this.vb.with({scheme:p.$xgb,authority:"local"}),this.yb=this.vb.with({scheme:p.$xgb,authority:"remote"}),this.zb=this.vb.with({scheme:p.$xgb,authority:"accepted"})}async nb(o,l,$,b){const I=o.syncData?g(o.syncData.content,this.L):null;l=l===null&&$?o:l;const t=l?.syncData?g(l.syncData.content,this.L):null,c=await this.p();let s=null,n=!1,i=!1,r=!1;if(o.syncData){const y=c?c.value.toString():null;if(!t||t!==y||t!==I){this.L.trace(`${this.y}: Merging remote tasks with local tasks...`);const u=w(y,I,t);s=u.content,r=u.hasConflicts,n=u.hasLocalChanged,i=u.hasRemoteChanged}}else c&&(this.L.trace(`${this.y}: Remote tasks does not exist. Synchronizing tasks for the first time.`),s=c.value.toString(),i=!0);const a={content:r?t:s,localChange:n?c?2:1:0,remoteChange:i?2:0,hasConflicts:r},v=c?c.value.toString():null;return[{fileContent:c,baseResource:this.wb,baseContent:t,localResource:this.xb,localContent:v,localChange:a.localChange,remoteResource:this.yb,remoteContent:I,remoteChange:a.remoteChange,previewResource:this.vb,previewResult:a,acceptedResource:this.zb}]}async rb(o){const l=o?.syncData?g(o.syncData.content,this.L):null;if(l===null)return!0;const $=await this.p(),b=$?$.value.toString():null,I=w(b,l,l);return I.hasLocalChanged||I.hasRemoteChanged}async ob(o,l){return o.previewResult}async pb(o,l,$,b){if(this.h.isEqual(l,this.xb))return{content:o.fileContent?o.fileContent.value.toString():null,localChange:0,remoteChange:2};if(this.h.isEqual(l,this.yb))return{content:o.remoteContent,localChange:2,remoteChange:0};if(this.h.isEqual(l,this.vb))return $===void 0?{content:o.previewResult.content,localChange:o.previewResult.localChange,remoteChange:o.previewResult.remoteChange}:{content:$,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${l.toString()}`)}async qb(o,l,$,b){const{fileContent:I}=$[0][0],{content:t,localChange:c,remoteChange:s}=$[0][1];if(c===0&&s===0&&this.L.info(`${this.y}: No changes found during synchronizing tasks.`),c!==0&&(this.L.trace(`${this.y}: Updating local tasks...`),I&&await this.kb(JSON.stringify(this.Fb(I.value.toString()))),t?await this.r(t,I,b):await this.sb(),this.L.info(`${this.y}: Updated local tasks`)),s!==0){this.L.trace(`${this.y}: Updating remote tasks...`);const n=JSON.stringify(this.Fb(t));o=await this.jb(n,b?null:o.ref),this.L.info(`${this.y}: Updated remote tasks`)}try{await this.C.del(this.vb)}catch{}l?.ref!==o.ref&&(this.L.trace(`${this.y}: Updating last synchronized tasks...`),await this.cb(o),this.L.info(`${this.y}: Updated last synchronized tasks`))}async hasLocalData(){return this.C.exists(this.i)}async resolveContent(o){return this.h.isEqual(this.yb,o)||this.h.isEqual(this.wb,o)||this.h.isEqual(this.xb,o)||this.h.isEqual(this.zb,o)?this.ab(o):null}Fb(o){return o?{tasks:o}:{}}};e.$t2b=h,e.$t2b=h=ye([X(2,p.$ggb),X(3,p.$hgb),X(4,p.$vgb),X(5,N.$6h),X(6,p.$qgb),X(7,j.$4j),X(8,O.$Gh),X(9,A.$So),X(10,R.$7k),X(11,k.$Ak)],h);let d=class extends P.$HAb{constructor(o,l,$,b,I,t){super("tasks",l,$,b,o,I,t),this.c=this.g.defaultProfile.tasksResource}async o(o){const l=o.syncData?g(o.syncData.content,this.j):null;if(!l){this.j.info("Skipping initializing tasks because remote tasks does not exist.");return}if(!await this.p()){this.j.info("Skipping initializing tasks because local tasks exist.");return}await this.k.writeFile(this.c,L.$Hc.fromString(l)),await this.n(o)}async p(){return this.k.exists(this.c)}};e.$u2b=d,e.$u2b=d=ye([X(0,j.$4j),X(1,m.$Ck),X(2,O.$Gh),X(3,p.$vgb),X(4,A.$So),X(5,k.$Ak)],d);function w(f,o,l){if(f===null&&o===null&&l===null)return{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1};if(f===o)return{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1};const $=l!==f,b=l!==o;return!$&&!b?{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1}:$&&!b?{content:f,hasRemoteChanged:!0,hasLocalChanged:!1,hasConflicts:!1}:b&&!$?{content:o,hasLocalChanged:!0,hasRemoteChanged:!1,hasConflicts:!1}:{content:f,hasLocalChanged:!0,hasRemoteChanged:!0,hasConflicts:!0}}}),define(re[121],oe([0,1,41,18,16,13,19,21,27,17,39,234,25]),function(te,e,L,N,O,j,A,R,k,m,P,p,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$3b=e.$03b=e.$93b=void 0;let h=class extends P.$EAb{constructor(o,l,$,b,I,t,c,s,n,i,r,a,v){super({syncResource:"profiles",profile:o},l,b,I,t,c,s,r,a,n,i,v),this.r=$,this.mb=2,this.previewResource=this.h.joinPath(this.g,"profiles.json"),this.baseResource=this.previewResource.with({scheme:g.$xgb,authority:"base"}),this.localResource=this.previewResource.with({scheme:g.$xgb,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:g.$xgb,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:g.$xgb,authority:"accepted"}),this.B($.onDidChangeProfiles(()=>this.N()))}async getLastSyncedProfiles(){const o=await this.getLastSyncUserData();return o?.syncData?w(o.syncData):null}async getRemoteSyncedProfiles(o){const l=await this.getLastSyncUserData(),$=await this.S(o,l);return $?.syncData?w($.syncData):null}async nb(o,l,$){if(!this.r.isEnabled())throw new g.$lgb("Cannot sync profiles because they are disabled","LocalError");const b=o.syncData?w(o.syncData):null,I=l?.syncData?w(l.syncData):null,t=this.zb(),{local:c,remote:s}=(0,p.$83b)(t,b,I,[]),n={local:c,remote:s,content:I?this.Ab(I):null,localChange:c.added.length>0||c.removed.length>0||c.updated.length>0?2:0,remoteChange:s!==null?2:0},i=d(t,!1);return[{baseResource:this.baseResource,baseContent:I?this.Ab(I):null,localResource:this.localResource,localContent:i,remoteResource:this.remoteResource,remoteContent:b?this.Ab(b):null,remoteProfiles:b,previewResource:this.previewResource,previewResult:n,localChange:n.localChange,remoteChange:n.remoteChange,acceptedResource:this.acceptedResource}]}async rb(o){const l=o?.syncData?w(o.syncData):null,$=this.zb(),{remote:b}=(0,p.$83b)($,l,l,[]);return!!b?.added.length||!!b?.removed.length||!!b?.updated.length}async ob(o,l){return{...o.previewResult,hasConflicts:!1}}async pb(o,l,$,b){if(this.h.isEqual(l,this.localResource))return this.wb(o);if(this.h.isEqual(l,this.remoteResource))return this.xb(o);if(this.h.isEqual(l,this.previewResource))return o.previewResult;throw new Error(`Invalid Resource: ${l.toString()}`)}async wb(o){const l=this.zb(),$=(0,p.$83b)(l,null,null,[]),{local:b,remote:I}=$;return{content:o.localContent,local:b,remote:I,localChange:b.added.length>0||b.removed.length>0||b.updated.length>0?2:0,remoteChange:I!==null?2:0}}async xb(o){const l=o.remoteContent?JSON.parse(o.remoteContent):null,$=[],b=[];for(const I of this.zb()){const t=l?.find(c=>c.id===I.id);t&&($.push({id:I.id,name:I.name,collection:t.collection}),b.push(I))}if(l!==null){const I=(0,p.$83b)(b,l,$,[]),{local:t,remote:c}=I;return{content:o.remoteContent,local:t,remote:c,localChange:t.added.length>0||t.removed.length>0||t.updated.length>0?2:0,remoteChange:c!==null?2:0}}else return{content:o.remoteContent,local:{added:[],removed:[],updated:[]},remote:null,localChange:0,remoteChange:0}}async qb(o,l,$,b){const{local:I,remote:t,localChange:c,remoteChange:s}=$[0][1];c===0&&s===0&&this.L.info(`${this.y}: No changes found during synchronizing profiles.`);const n=$[0][0].remoteProfiles||[];if(n.length+(t?.added.length??0)-(t?.removed.length??0)>20)throw new g.$lgb("Too many profiles to sync. Please remove some profiles and try again.","LocalTooManyProfiles");if(c!==0){await this.kb(d(this.zb(),!1));const i=[];for(const r of I.added)i.push((async()=>{this.L.trace(`${this.y}: Creating '${r.name}' profile...`),await this.r.createProfile(r.id,r.name,{shortName:r.shortName,useDefaultFlags:r.useDefaultFlags}),this.L.info(`${this.y}: Created profile '${r.name}'.`)})());for(const r of I.removed)i.push((async()=>{this.L.trace(`${this.y}: Removing '${r.name}' profile...`),await this.r.removeProfile(r),this.L.info(`${this.y}: Removed profile '${r.name}'.`)})());for(const r of I.updated){const a=this.r.profiles.find(v=>v.id===r.id);a?i.push((async()=>{this.L.trace(`${this.y}: Updating '${r.name}' profile...`),await this.r.updateProfile(a,{name:r.name,shortName:r.shortName,useDefaultFlags:r.useDefaultFlags}),this.L.info(`${this.y}: Updated profile '${r.name}'.`)})()):this.L.info(`${this.y}: Could not find profile with id '${r.id}' to update.`)}await Promise.all(i)}if(s!==0){this.L.trace(`${this.y}: Updating remote profiles...`);const i=[],r=n.length+(t?.added.length??0)<=20;if(r)for(const a of t?.added||[]){const v=await this.G.createCollection(this.z);i.push(v),n.push({id:a.id,name:a.name,collection:v,shortName:a.shortName,useDefaultFlags:a.useDefaultFlags})}else this.L.info(`${this.y}: Could not create remote profiles as there are too many profiles.`);for(const a of t?.removed||[])n.splice(n.findIndex(({id:v})=>a.id===v),1);for(const a of t?.updated||[]){const v=n.find(({id:y})=>a.id===y);v&&n.splice(n.indexOf(v),1,{...v,id:a.id,name:a.name,shortName:a.shortName,useDefaultFlags:a.useDefaultFlags})}try{o=await this.updateRemoteProfiles(n,b?null:o.ref),this.L.info(`${this.y}: Updated remote profiles.${r&&t?.added.length?` Added: ${JSON.stringify(t.added.map(a=>a.name))}.`:""}${t?.updated.length?` Updated: ${JSON.stringify(t.updated.map(a=>a.name))}.`:""}${t?.removed.length?` Removed: ${JSON.stringify(t.removed.map(a=>a.name))}.`:""}`)}catch(a){if(i.length){this.L.info(`${this.y}: Failed to update remote profiles. Cleaning up added collections...`);for(const v of i)await this.G.deleteCollection(v,this.z)}throw a}for(const a of t?.removed||[])await this.G.deleteCollection(a.collection,this.z)}l?.ref!==o.ref&&(this.L.trace(`${this.y}: Updating last synchronized profiles...`),await this.cb(o),this.L.info(`${this.y}: Updated last synchronized profiles.`))}async updateRemoteProfiles(o,l){return this.jb(this.Ab(o),l)}async hasLocalData(){return this.zb().length>0}async resolveContent(o){if(this.h.isEqual(this.remoteResource,o)||this.h.isEqual(this.baseResource,o)||this.h.isEqual(this.localResource,o)||this.h.isEqual(this.acceptedResource,o)){const l=await this.ab(o);return l&&(0,L.$nS)(JSON.parse(l),{})}return null}zb(){return this.r.profiles.filter(o=>!o.isDefault&&!o.isTransient)}Ab(o){return JSON.stringify([...o].sort((l,$)=>l.name.localeCompare($.name)))}};e.$93b=h,e.$93b=h=ye([X(2,m.$Ck),X(3,j.$4j),X(4,O.$Gh),X(5,A.$So),X(6,g.$ggb),X(7,g.$hgb),X(8,g.$vgb),X(9,N.$6h),X(10,g.$qgb),X(11,R.$7k),X(12,k.$Ak)],h);function d(f,o){const l=[...f].sort(($,b)=>$.name.localeCompare(b.name)).map($=>({id:$.id,name:$.name}));return o?(0,L.$nS)(l,{}):JSON.stringify(l)}e.$03b=d;function w(f){return JSON.parse(f.content)}e.$$3b=w}),define(re[252],oe([0,1,5,14,62,2,23,18,16,13,17,25]),function(te,e,L,N,O,j,A,R,k,m,P,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$73b=void 0;let g=class extends j.$mb{constructor(d,w,f,o,l){super(),this.a=d,this.b=w,this.c=f,this.f=o,this.g=l,this.h()}async h(){for(const w of this.g.profiles)for(const f of p.$cgb)try{await this.j(this.i(w,f))}catch(o){this.f.error(o)}let d;try{d=await this.b.resolve(this.a.userDataSyncHome)}catch(w){(0,m.$hk)(w)!==1&&this.f.error(w);return}if(d.children){for(const w of d.children)if(w.isDirectory&&!this.g.profiles.some(f=>f.id===w.name))try{this.f.info("Deleting non existing profile from backup",w.resource.path),await this.b.del(w.resource,{recursive:!0})}catch(f){this.f.error(f)}}}async getAllRefs(d,w){const f=this.i(d,w);try{const o=await this.b.resolve(f);if(o.children)return o.children.filter($=>$.isFile&&/^\d{8}T\d{6}(\.json)?$/.test($.name)).sort().reverse().map($=>({ref:$.name,created:this.k($)}))}catch(o){if((0,m.$hk)(o)!==1)throw o}return[]}async resolveContent(d,w,f){const o=this.i(d,w),l=(0,A.$gg)(o,f);try{return(await this.b.readFile(l)).value.toString()}catch($){return this.f.error($),null}}async backup(d,w,f){const o=this.i(d,w),l=(0,A.$gg)(o,`${(0,O.$5l)(new Date).replace(/-|:|\.\d+Z$/g,"")}.json`);try{await this.b.writeFile(l,N.$Hc.fromString(f))}catch($){this.f.error($)}try{this.j(o)}catch{}}i(d,w){return(0,A.$gg)(this.a.userDataSyncHome,...d.isDefault?[w]:[d.id,w])}async j(d){try{try{if(!await this.b.exists(d))return}catch{return}const w=await this.b.resolve(d);if(w.children){const f=w.children.filter(b=>b.isFile&&/^\d{8}T\d{6}(\.json)?$/.test(b.name)).sort(),o=1e3*60*60*24*(this.c.getValue("sync.localBackupDuration")||30);let l=f.filter(b=>Date.now()-this.k(b)>o);const $=f.length-l.length;$<10&&(l=l.slice(10-$)),await L.Promises.settled(l.map(async b=>{this.f.info("Deleting from backup",b.resource.path),await this.b.del(b.resource)}))}}catch(w){this.f.error(w)}}k(d){return d.ctime||new Date(parseInt(d.name.substring(0,4)),parseInt(d.name.substring(4,6))-1,parseInt(d.name.substring(6,8)),parseInt(d.name.substring(9,11)),parseInt(d.name.substring(11,13)),parseInt(d.name.substring(13,15))).getTime()}};e.$73b=g,e.$73b=g=ye([X(0,k.$Gh),X(1,m.$4j),X(2,R.$6h),X(3,p.$vgb),X(4,P.$Ck)],g)}),define(re[253],oe([0,1,3,2,6,16,19,21,25]),function(te,e,L,N,O,j,A,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$V3b=void 0;const m="sync.enable";let P=class extends N.$mb{constructor(g,h,d,w){super(),this.c=g,this.f=h,this.g=d,this.h=w,this.a=new L.$hc,this.onDidChangeEnablement=this.a.event,this.b=new L.$hc,this.onDidChangeResourceEnablement=this.b.event,this.B(g.onDidChangeValue(-1,void 0,this.B(new N.$lb))(f=>this.j(f)))}isEnabled(){switch(this.g.sync){case"on":return!0;case"off":return!1}return this.c.getBoolean(m,-1,!1)}canToggleEnablement(){return this.h.userDataSyncStore!==void 0&&this.g.sync===void 0}setEnablement(g){g&&!this.canToggleEnablement()||(this.f.publicLog2(m,{enabled:g}),this.c.store(m,g,-1,1))}isResourceEnabled(g){return this.c.getBoolean((0,k.$pgb)(g),-1,!0)}setResourceEnablement(g,h){if(this.isResourceEnabled(g)!==h){const d=(0,k.$pgb)(g);this.i(d,h)}}getResourceSyncStateVersion(g){}i(g,h){this.c.store(g,h,-1,O.$o?0:1)}j(g){if(m===g.key){this.a.fire(this.isEnabled());return}const h=k.$cgb.filter(d=>(0,k.$pgb)(d)===g.key)[0];if(h){this.b.fire([h,this.isResourceEnabled(h)]);return}}};e.$V3b=P,e.$V3b=P=ye([X(0,A.$So),X(1,R.$7k),X(2,j.$Gh),X(3,k.$fgb)],P)}),define(re[81],oe([0,1,3,2,6,28,175,16,13,4,24,44,19,25]),function(te,e,L,N,O,j,A,R,k,m,P,p,g,h){"use strict";var d;Object.defineProperty(e,"__esModule",{value:!0}),e.$8Yb=e.$7Yb=e.$6Yb=void 0,e.$6Yb=(0,m.$zh)("IUserDataSyncMachinesService");const w="sync.currentMachineName",f="Safari",o="Chrome",l="Edge",$="Firefox",b="Android";function I(s){switch(s){case f:case o:case l:case $:case b:case(0,O.$h)(0):return!0}return!1}e.$7Yb=I;function t(){return O.$F?f:O.$D?o:O.$G?l:O.$E?$:O.$H?b:(0,O.$h)(O.$o?0:O.$t)}let c=class extends N.$mb{static{d=this}static{this.a=1}static{this.b="machines"}constructor(n,i,r,a,v,y){super(),this.h=r,this.i=a,this.j=v,this.k=y,this.c=this.B(new L.$hc),this.onDidChange=this.c.event,this.g=null,this.f=(0,p.$Yo)(n,i,r)}async getMachines(n){const i=await this.f;return(await this.m(n)).machines.map(a=>({...a,isCurrent:a.id===i}))}async addCurrentMachine(n){const i=await this.f,r=await this.m(n);r.machines.some(({id:a})=>a===i)||(r.machines.push({id:i,name:this.l(r.machines),platform:t()}),await this.n(r))}async removeCurrentMachine(n){const i=await this.f,r=await this.m(n),a=r.machines.filter(({id:v})=>v!==i);a.length!==r.machines.length&&(r.machines=a,await this.n(r))}async renameMachine(n,i,r){const a=await this.m(r),v=a.machines.find(({id:y})=>y===n);if(v){v.name=i,await this.n(a);const y=await this.f;n===y&&this.h.store(w,i,-1,1)}}async setEnablements(n){const i=await this.m();for(const[r,a]of n){const v=i.machines.find(y=>y.id===r);v&&(v.disabled=a?void 0:!0)}await this.n(i)}l(n){const i=this.h.get(w,-1);if(i)return i;const r=`${this.k.embedderIdentifier?`${this.k.embedderIdentifier} - `:""}${t()} (${this.k.nameShort})`,a=new RegExp(`${(0,j.$sd)(r)}\\s#(\\d+)`);let v=0;for(const y of n){const u=a.exec(y.name),E=u?parseInt(u[1]):0;v=E>v?E:v}return`${r} #${v+1}`}async m(n){this.g=await this.p(n);const i=this.r(this.g);if(i.version!==d.a)throw new Error((0,A.localize)(0,null,this.k.nameLong));return i}async n(n){const i=JSON.stringify(n),r=await this.i.writeResource(d.b,i,this.g?.ref||null);this.g={ref:r,content:i},this.c.fire()}async p(n){if(this.g){const i=n&&n.latest?n.latest[d.b]:void 0;if(this.g.ref===i)return this.g;if(i===void 0&&this.g.content===null)return this.g}return this.i.readResource(d.b,this.g)}r(n){if(n.content!==null)try{return JSON.parse(n.content)}catch(i){this.j.error(i)}return{version:d.a,machines:[]}}};e.$8Yb=c,e.$8Yb=c=d=ye([X(0,R.$Gh),X(1,k.$4j),X(2,g.$So),X(3,h.$ggb),X(4,h.$vgb),X(5,P.$ij)],c)}),define(re[254],oe([0,1,5,62,38,8,3,2,6,23,11,172,24,19,21,25,78,81]),function(te,e,L,N,O,j,A,R,k,m,P,p,g,h,d,w,f,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$a4b=void 0;const l="sync.disableMachineEventually",$="sync.sessionId",b="sync.storeUrl",I="sync.productQuality";let t=class extends R.$mb{get j(){const n=this.z.get(b,-1);return n?P.URI.parse(n):void 0}set j(n){n?this.z.store(b,n.toString(),-1,1):this.z.remove(b,-1)}get l(){return this.z.get(I,-1)}set l(n){n?this.z.store(I,n,-1,1):this.z.remove(I,-1)}constructor(n,i,r,a,v,y,u,E,D,T){super(),this.n=i,this.p=r,this.r=a,this.s=v,this.u=y,this.v=u,this.w=E,this.y=D,this.z=T,this.a=this.B(new R.$nb),this.b=0,this.c=void 0,this.g=!1,this.h=this.B(new A.$hc),this.onError=this.h.event,this.N=[],this.f=this.B(new L.$Cg(this.O())),this.i=this.j,this.j=i.userDataSyncStore?.url,this.k=this.l,this.l=n.quality,this.j&&(this.u.info("Using settings sync service",this.j.toString()),this.B(i.onDidChangeUserDataSyncStore(()=>{(0,m.$_f)(this.j,i.userDataSyncStore?.url)||(this.i=this.j,this.j=i.userDataSyncStore?.url,this.j&&this.u.info("Using settings sync service",this.j.toString()))})),this.r.isEnabled()?this.u.info("Auto Sync is enabled."):this.u.info("Auto Sync is disabled."),this.C(),this.L()&&this.J(),this.B(u.onDidChangeAccount(()=>this.C())),this.B(r.onDidChangeDonotMakeRequestsUntil(()=>this.C())),this.B(v.onDidChangeLocal(F=>this.triggerSync([F],!1,!1))),this.B(A.Event.filter(this.r.onDidChangeResourceEnablement,([,F])=>F)(()=>this.triggerSync(["resourceEnablement"],!1,!1))),this.B(this.n.onDidChangeUserDataSyncStore(()=>this.triggerSync(["userDataSyncStoreChanged"],!1,!1))))}C(){const{enabled:n,message:i}=this.F();n?this.a.value===void 0&&(this.a.value=new c(this.i,1e3*60*5,this.n,this.p,this.s,this.y,this.u,this.w,this.z),this.a.value.register(this.a.value.onDidStartSync(()=>this.c=new Date().getTime())),this.a.value.register(this.a.value.onDidFinishSync(r=>this.I(r))),this.D()&&this.a.value.start()):(this.f.cancel(),this.a.value!==void 0?(i&&this.u.info(i),this.a.clear()):i&&this.r.isEnabled()&&this.u.info(i))}D(){return!0}F(){return this.r.isEnabled()?this.v.account?this.p.donotMakeRequestsUntil?{enabled:!1,message:`Auto Sync: Suspended until ${(0,N.$5l)(this.p.donotMakeRequestsUntil)} because server is not accepting requests until then.`}:this.g?{enabled:!1,message:"Auto Sync: Suspended until restart."}:{enabled:!0}:{enabled:!1,message:"Auto Sync: Suspended until auth token is available."}:{enabled:!1,message:"Auto Sync: Disabled."}}async turnOn(){this.M(),this.i=this.j,this.G(!0)}async turnOff(n,i,r){try{this.v.account&&!r&&await this.y.removeCurrentMachine(),this.G(!1),this.z.remove($,-1),n?(this.w.publicLog2("sync/turnOffEveryWhere"),await this.s.reset()):await this.s.resetLocal()}catch(a){if(this.u.error(a),i)this.G(!1);else throw a}}G(n){this.r.isEnabled()!==n&&(this.r.setEnablement(n),this.C())}H(){return!!this.k&&!!this.l&&this.k!==this.l}async I(n){if(!n){this.b=0;return}const i=w.$lgb.toUserDataSyncError(n);i instanceof w.$ngb&&this.w.publicLog2("autosync/error",{code:i.code,service:this.n.userDataSyncStore.url.toString()}),i.code==="SessionExpired"?(await this.turnOff(!1,!0),this.u.info("Auto Sync: Turned off sync because current session is expired")):i.code==="TurnedOff"?(await this.turnOff(!1,!0),this.u.info("Auto Sync: Turned off sync because sync is turned off in the cloud")):i.code==="LocalTooManyRequests"?(this.g=!0,this.u.info("Auto Sync: Suspended sync because of making too many requests to server"),this.C()):i.code==="RemoteTooManyRequests"?(await this.turnOff(!1,!0,!0),this.J(),this.u.info("Auto Sync: Turned off sync because of making too many requests to server")):i.code==="MethodNotFound"?(await this.turnOff(!1,!0),this.u.info("Auto Sync: Turned off sync because current client is making requests to server that are not supported")):i.code==="UpgradeRequired"||i.code==="Gone"?(await this.turnOff(!1,!0,!0),this.J(),this.u.info("Auto Sync: Turned off sync because current client is not compatible with server. Requires client upgrade.")):i.code==="IncompatibleLocalContent"?(await this.turnOff(!1,!0),this.u.info(`Auto Sync: Turned off sync because server has ${i.resource} content with newer version than of client. Requires client upgrade.`)):i.code==="IncompatibleRemoteContent"?(await this.turnOff(!1,!0),this.u.info(`Auto Sync: Turned off sync because server has ${i.resource} content with older version than of client. Requires server reset.`)):i.code==="ServiceChanged"||i.code==="DefaultServiceChanged"?k.$o&&i.code==="DefaultServiceChanged"&&!this.H()?(await this.turnOff(!1,!0),this.u.info("Auto Sync: Turned off sync because default sync service is changed.")):(await this.turnOff(!1,!0,!0),await this.turnOn(),this.u.info("Auto Sync: Sync Service changed. Turned off auto sync, reset local state and turned on auto sync.")):(this.u.error(i),this.b++),this.h.fire(i)}async J(){this.z.store(l,!0,-1,1),await(0,L.$Fg)(1e3*60*10),this.L()&&(this.M(),!this.r.isEnabled()&&this.v.account&&await this.y.removeCurrentMachine())}L(){return this.z.getBoolean(l,-1,!1)}M(){this.z.remove(l,-1)}async triggerSync(n,i,r){if(this.a.value===void 0)return this.f.cancel();if(i&&this.c&&Math.round((new Date().getTime()-this.c)/1e3)<10){this.u.debug("Auto Sync: Skipped. Limited to once per 10 seconds.");return}return this.N.push(...n),this.f.trigger(async()=>{this.u.trace("activity sources",...this.N);const a=this.v.account?.authenticationProviderId||"";this.w.publicLog2("sync/triggered",{sources:this.N,providerId:a}),this.N=[],this.a.value&&await this.a.value.sync("Activity",r)},this.b?this.O()*1*Math.min(Math.pow(2,this.b),60):this.O())}O(){return 2e3}};e.$a4b=t,e.$a4b=t=ye([X(0,g.$ij),X(1,w.$fgb),X(2,w.$ggb),X(3,w.$qgb),X(4,w.$rgb),X(5,w.$vgb),X(6,f.$bzb),X(7,d.$7k),X(8,o.$6Yb),X(9,h.$So)],t);class c extends R.$mb{static{this.a="Interval"}constructor(n,i,r,a,v,y,u,E,D){super(),this.j=n,this.k=i,this.l=r,this.m=a,this.n=v,this.p=y,this.r=u,this.s=E,this.u=D,this.b=this.B(new R.$nb),this.c=this.B(new A.$hc),this.onDidStartSync=this.c.event,this.f=this.B(new A.$hc),this.onDidFinishSync=this.f.event,this.g=null}start(){this.B(this.onDidFinishSync(()=>this.v())),this.B((0,R.$kb)(()=>{this.i&&(this.i.cancel(),this.r.info("Auto sync: Cancelled sync that is in progress"),this.i=void 0),this.h?.stop(),this.r.info("Auto Sync: Stopped")})),this.sync(c.a,!1)}v(){this.b.value=(0,L.$Gg)(()=>this.sync(c.a,!1),this.k)}sync(n,i){const r=(0,L.$sg)(async a=>{if(this.i)try{this.r.debug("Auto Sync: Waiting until sync is finished."),await this.i}catch(v){if((0,j.$2)(v))return}return this.z(n,i,a)});return this.i=r,this.i.finally(()=>this.i=void 0),this.i}w(){return this.j!==void 0&&!(0,m.$_f)(this.j,this.l.userDataSyncStore?.url)}async y(){const n=await this.l.getPreviousUserDataSyncStore(),i=this.l.userDataSyncStore;return!!i&&!!n&&(!(0,m.$_f)(i.defaultUrl,n.defaultUrl)||!(0,m.$_f)(i.insidersUrl,n.insidersUrl)||!(0,m.$_f)(i.stableUrl,n.stableUrl))}async z(n,i,r){this.r.info(`Auto Sync: Triggered by ${n}`),this.c.fire();let a;try{await this.C(i,r)}catch(v){if(this.r.error(v),a=v,w.$lgb.toUserDataSyncError(v).code==="MethodNotFound")try{this.r.info("Auto Sync: Client is making invalid requests. Cleaning up data..."),await this.n.cleanUpRemoteData(),this.r.info("Auto Sync: Retrying sync..."),await this.C(i,r),a=void 0}catch(y){this.r.error(y),a=y}}this.f.fire(a)}async C(n,i){if(this.h=await this.n.createSyncTask(this.g,n),i.isCancellationRequested)return;if(this.g=this.h.manifest,this.g===null&&await this.n.hasPreviouslySynced())throw this.w()?await this.y()?new w.$ngb((0,p.localize)(0,null),"DefaultServiceChanged"):new w.$ngb((0,p.localize)(1,null),"ServiceChanged"):new w.$ngb((0,p.localize)(2,null),"TurnedOff");const r=this.u.get($,-1);if(r&&this.g&&r!==this.g.session)throw this.w()?await this.y()?new w.$ngb((0,p.localize)(3,null),"DefaultServiceChanged"):new w.$ngb((0,p.localize)(4,null),"ServiceChanged"):new w.$ngb((0,p.localize)(5,null),"SessionExpired");const a=await this.p.getMachines(this.g||void 0);if(i.isCancellationRequested)return;const v=a.find(u=>u.isCurrent);if(v?.disabled)throw new w.$ngb((0,p.localize)(6,null),"TurnedOff");const y=new Date().getTime();if(await this.h.run(),this.s.publicLog2("settingsSync:sync",{duration:new Date().getTime()-y}),this.g===null)try{this.g=await this.m.manifest(null)}catch(u){throw new w.$ngb((0,O.$ki)(u),u instanceof w.$lgb?u.code:"Unknown")}this.g&&this.g.session!==r&&this.u.store($,this.g.session,-1,1),!i.isCancellationRequested&&(v||await this.p.addCurrentMachine(this.g||void 0))}register(n){return super.B(n)}}}),define(re[255],oe([0,1,11,176,16,13,44,19,27,25,17,39,119,118,117,18,120,115,116,4,121,41]),function(te,e,L,N,O,j,A,R,k,m,P,p,g,h,d,w,f,o,l,$,b,I){"use strict";var t;Object.defineProperty(e,"__esModule",{value:!0}),e.$L4b=void 0;let c=class{static{t=this}static{this.a="not-existing-resource"}static{this.b="remote-backup"}static{this.c="local-backup"}constructor(n,i,r,a,v,y,u,E,D,T){this.e=n,this.f=i,this.g=r,this.h=v,this.i=y,this.j=u,this.k=E,this.l=D,this.m=T,this.d=a.extUri}async getRemoteSyncedProfiles(){const n=await this.e.readResource("profiles",null,void 0);if(n.content){const i=this.K(n.content,"profiles");return(0,b.$$3b)(i)}return[]}async getRemoteSyncResourceHandles(n,i){return(await this.e.getAllResourceRefs(n,i?.collection)).map(({created:a,ref:v})=>({created:a,uri:this.I({remote:!0,syncResource:n,profile:i?.id??this.k.defaultProfile.id,collection:i?.collection,ref:v,node:void 0})}))}async getLocalSyncResourceHandles(n,i){return(await this.f.getAllRefs(i,n)).map(({created:a,ref:v})=>({created:a,uri:this.I({remote:!1,syncResource:n,profile:i.id,collection:void 0,ref:v,node:void 0})}))}resolveUserDataSyncResource({uri:n}){const i=this.J(n),r=i?this.k.profiles.find(a=>a.id===i.profile):void 0;return i&&r?{profile:r,syncResource:i?.syncResource}:void 0}async getAssociatedResources({uri:n}){const i=this.J(n);if(!i)return[];const r=this.k.profiles.find(a=>a.id===i.profile);switch(i.syncResource){case"settings":return this.r(n,r);case"keybindings":return this.t(n,r);case"tasks":return this.v(n,r);case"snippets":return this.x(n,r);case"globalState":return this.C(n,r);case"extensions":return this.z(n,r);case"profiles":return this.F(n,r);case"workspaceState":return[]}}async getMachineId({uri:n}){const i=this.J(n);if(i){if(i.remote){if(i.ref){const{content:r}=await this.L(i.syncResource,i.ref,i.collection);if(r)return this.K(r,i.syncResource)?.machineId}return}return(0,A.$Yo)(this.h,this.j,this.i)}}async resolveContent(n){const i=this.J(n);if(!i||i.node===t.a)return null;if(i.ref){const r=await this.n(i.remote,i.syncResource,i.profile,i.collection,i.ref);return i.node&&r?this.o(i.syncResource,r,i.node):r}return!i.remote&&!i.node?this.q(i.syncResource,i.profile):null}async n(n,i,r,a,v){if(n){const{content:u}=await this.L(i,v,a);return u}const y=this.k.profiles.find(u=>u.id===r);return y?this.f.resolveContent(y,i,v):null}o(n,i,r){const a=this.K(i,n);switch(n){case"settings":return this.s(a,r);case"keybindings":return this.u(a,r);case"tasks":return this.w(a,r);case"snippets":return this.y(a,r);case"globalState":return this.D(a,r);case"extensions":return this.A(a,r);case"profiles":return this.G(a,r);case"workspaceState":return null}}async q(n,i){const r=this.k.profiles.find(a=>a.id===i);if(!r)return null;switch(n){case"globalState":return this.E(r);case"extensions":return this.B(r);case"profiles":return this.H(r);case"settings":return null;case"keybindings":return null;case"tasks":return null;case"snippets":return null;case"workspaceState":return null}}r(n,i){const r=this.d.joinPath(n,"settings.json"),a=i?i.settingsResource:this.d.joinPath(n,t.a);return[{resource:r,comparableResource:a}]}s(n,i){switch(i){case"settings.json":return(0,h.$k2b)(n.content).settings}return null}t(n,i){const r=this.d.joinPath(n,"keybindings.json"),a=i?i.keybindingsResource:this.d.joinPath(n,t.a);return[{resource:r,comparableResource:a}]}u(n,i){switch(i){case"keybindings.json":return(0,d.$h2b)(n.content,!!this.l.getValue(m.$_fb),this.g)}return null}v(n,i){const r=this.d.joinPath(n,"tasks.json"),a=i?i.tasksResource:this.d.joinPath(n,t.a);return[{resource:r,comparableResource:a}]}w(n,i){switch(i){case"tasks.json":return(0,f.$s2b)(n.content,this.g)}return null}async x(n,i){const r=await this.resolveContent(n);if(r){const a=this.K(r,"snippets");if(a){const v=(0,g.$p2b)(a),y=[];for(const u of Object.keys(v)){const E=this.d.joinPath(n,u),D=i?this.d.joinPath(i.snippetsHome,u):this.d.joinPath(n,t.a);y.push({resource:E,comparableResource:D})}return y}}return[]}y(n,i){return(0,g.$p2b)(n)[i]||null}z(n,i){const r=this.d.joinPath(n,"extensions.json"),a=i?this.I({remote:!1,syncResource:"extensions",profile:i.id,collection:void 0,ref:void 0,node:void 0}):this.d.joinPath(n,t.a);return[{resource:r,comparableResource:a}]}A(n,i){switch(i){case"extensions.json":return(0,o.$c2b)((0,o.$b2b)(n),!0)}return null}async B(n){const{localExtensions:i}=await this.m.createInstance(o.$e2b).getLocalExtensions(n);return(0,o.$c2b)(i,!0)}C(n,i){const r=this.d.joinPath(n,"globalState.json"),a=i?this.I({remote:!1,syncResource:"globalState",profile:i.id,collection:void 0,ref:void 0,node:void 0}):this.d.joinPath(n,t.a);return[{resource:r,comparableResource:a}]}D(n,i){switch(i){case"globalState.json":return(0,l.$JAb)(JSON.parse(n.content),!0)}return null}async E(n){const i=await this.m.createInstance(l.$LAb).getLocalGlobalState(n);return(0,l.$JAb)(i,!0)}F(n,i){const r=this.d.joinPath(n,"profiles.json"),a=this.I({remote:!1,syncResource:"profiles",profile:this.k.defaultProfile.id,collection:void 0,ref:void 0,node:void 0});return[{resource:r,comparableResource:a}]}G(n,i){switch(i){case"profiles.json":return(0,I.$nS)(JSON.parse(n.content),{})}return null}async H(n){return(0,b.$03b)(this.k.profiles.filter(i=>!i.isDefault&&!i.isTransient),!0)}I(n){const i=n.remote?t.b:t.c,r=[n.syncResource,n.profile];return n.collection&&r.push(`collection:${n.collection}`),n.ref&&r.push(`ref:${n.ref}`),n.node&&r.push(n.node),this.d.joinPath(L.URI.from({scheme:m.$xgb,authority:i,path:"/"}),...r)}J(n){if(n.scheme!==m.$xgb||n.authority!==t.c&&n.authority!==t.b)return;const i=[];for(;n.path!=="/";)i.unshift(this.d.basename(n)),n=this.d.dirname(n);if(i.length<2)return;const r=n.authority===t.b,a=i.shift(),v=i.shift();let y,u,E;for(;i.length;){const D=i.shift();D.startsWith("collection:")?y=D.substring(11):D.startsWith("ref:")?u=D.substring(4):E=D}return{remote:r,syncResource:a,profile:v,collection:y,ref:u,node:E}}K(n,i){try{const r=JSON.parse(n);if((0,p.$CAb)(r))return r}catch(r){this.g.error(r)}throw new m.$lgb((0,N.localize)(0,null),"IncompatibleRemoteContent",i)}async L(n,i,r){const a=await this.e.resolveResourceContent(n,i,r);return{ref:i,content:a}}};e.$L4b=c,e.$L4b=c=t=ye([X(0,m.$ggb),X(1,m.$hgb),X(2,m.$vgb),X(3,k.$Ak),X(4,O.$Gh),X(5,R.$So),X(6,j.$4j),X(7,P.$Ck),X(8,w.$6h),X(9,$.$yh)],c)}),define(re[256],oe([0,1,20,5,26,38,3,2,23,9,32,18,29,4,19,21,17,115,116,117,118,119,120,121,25]),function(te,e,L,N,O,j,A,R,k,m,P,p,g,h,d,w,f,o,l,$,b,I,t,c,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_3b=void 0;const n="sync.lastSyncTime";let i=class extends R.$mb{get status(){return this.f}get conflicts(){return this.i}get lastSyncTime(){return this.m}constructor(u,E,D,T,F,q,W,Z,Y){super(),this.v=u,this.w=E,this.y=D,this.z=T,this.C=F,this.D=q,this.F=W,this.G=Z,this.H=Y,this.f="uninitialized",this.g=this.B(new A.$hc),this.onDidChangeStatus=this.g.event,this.h=this.B(new A.$hc),this.onDidChangeLocal=this.h.event,this.i=[],this.j=this.B(new A.$hc),this.onDidChangeConflicts=this.j.event,this.k=[],this.l=this.B(new A.$hc),this.onSyncErrors=this.l.event,this.m=void 0,this.n=this.B(new A.$hc),this.onDidChangeLastSyncTime=this.n.event,this.r=this.B(new A.$hc),this.onDidResetLocal=this.r.event,this.t=this.B(new A.$hc),this.onDidResetRemote=this.t.event,this.u=new Map,this.f=E.userDataSyncStore?"idle":"uninitialized",this.m=this.D.getNumber(n,-1,void 0),this.B((0,R.$kb)(()=>this.W()))}async createSyncTask(u,E){this.X(),this.z.info("Sync started.");const D=new Date().getTime(),T=(0,P.$6e)();try{const Z=(0,s.$kgb)(T);E&&(Z["Cache-Control"]="no-cache"),u=await this.v.manifest(u,Z)}catch(Z){const Y=s.$lgb.toUserDataSyncError(Z);throw v(Y,T,this.w,this.C),Y}const F=!1,q=this;let W;return{manifest:u,async run(){if(F)throw new Error("Can run a task only once");W=(0,N.$sg)(Z=>q.I(u,!1,T,Z)),await W.finally(()=>W=void 0),q.z.info(`Sync done. Took ${new Date().getTime()-D}ms`),q.S()},stop(){return W?.cancel(),q.N()}}}async createManualSyncTask(){if(this.X(),this.F.isEnabled())throw new s.$lgb("Cannot start manual sync when sync is enabled","LocalError");this.z.info("Sync started.");const u=new Date().getTime(),E=(0,P.$6e)(),D=(0,s.$kgb)(E);let T;try{T=await this.v.manifest(null,D)}catch(W){const Z=s.$lgb.toUserDataSyncError(W);throw v(Z,E,this.w,this.C),Z}await this.resetLocal();const F=this,q=new O.$rc;return{id:E,async merge(){return F.I(T,!0,E,q.token)},async apply(){try{try{await F.L(T,E,q.token)}catch(W){if(s.$lgb.toUserDataSyncError(W).code==="MethodNotFound")F.z.info("Client is making invalid requests. Cleaning up data..."),await F.cleanUpRemoteData(),F.z.info("Applying manual sync again..."),await F.L(T,E,q.token);else throw W}}catch(W){throw F.z.error(W),W}F.z.info(`Sync done. Took ${new Date().getTime()-u}ms`),F.S()},async stop(){q.cancel(),await F.N(),await F.resetLocal()}}}async I(u,E,D,T){this.k=[];try{this.status!=="hasConflicts"&&this.Q("syncing");const F=this.getOrCreateActiveProfileSynchronizer(this.G.defaultProfile,void 0);this.k.push(...await this.M(F,u,E,D,T));const q=F.enabled.find(W=>W.resource==="profiles");if(q){const W=await q.getLastSyncedProfiles()||[];if(T.isCancellationRequested)return;await this.J(W,u,E,D,T)}}finally{this.l.fire(this.k)}}async J(u,E,D,T,F){for(const q of u){if(F.isCancellationRequested)return;const W=this.G.profiles.find(Y=>Y.id===q.id);if(!W){this.z.error(`Profile with id:${q.id} and name: ${q.name} does not exist locally to sync.`);continue}this.z.info("Syncing profile.",q.name);const Z=this.getOrCreateActiveProfileSynchronizer(W,q);this.k.push(...await this.M(Z,E,D,T,F))}for(const[q,W]of this.u.entries())this.G.profiles.some(Z=>Z.id===W[0].profile.id)||(W[1].dispose(),this.u.delete(q))}async L(u,E,D){const T=this.U();for(const Y of T){if(D.isCancellationRequested)return;await Y.apply(E,D)}const F=T.find(Y=>Y.profile.isDefault);if(!F)return;const q=F.enabled.find(Y=>Y.resource==="profiles");if(!q)return;const Z=(await q.getRemoteSyncedProfiles(u?.latest??null)||[]).filter(Y=>T.every(x=>x.profile.id!==Y.id));Z.length&&await this.J(Z,u,!1,E,D)}async M(u,E,D,T,F){return(await u.sync(E,D,T,F)).map(([W,Z])=>({profile:u.profile,syncResource:W,error:Z}))}async N(){this.status!=="idle"&&await Promise.allSettled(this.U().map(u=>u.stop()))}async resolveContent(u){const E=await this.H.resolveContent(u);if(E)return E;for(const D of this.U())for(const T of D.enabled){const F=await T.resolveContent(u);if(F)return F}return null}async replace(u){this.X();const E=this.H.resolveUserDataSyncResource(u);if(!E)return;const D=await this.resolveContent(u.uri);D&&await this.O(E.profile,async T=>{if(E.syncResource===T.resource)return await T.replace(D),!0})}async accept(u,E,D,T){this.X(),await this.O(u.profile,async F=>{if(u.syncResource===F.resource)return await F.accept(E,D),T&&await F.apply((0,m.$re)(T)?!1:T.force,(0,s.$kgb)((0,P.$6e)())),!0})}getRemoteProfiles(){return this.H.getRemoteSyncedProfiles()}getRemoteSyncResourceHandles(u,E){return this.H.getRemoteSyncResourceHandles(u,E)}async getLocalSyncResourceHandles(u,E){return this.H.getLocalSyncResourceHandles(u,E??this.G.defaultProfile)}async getAssociatedResources(u){return this.H.getAssociatedResources(u)}async getMachineId(u){return this.H.getMachineId(u)}async hasLocalData(){return!!await this.O(this.G.defaultProfile,async E=>{if(E.resource!=="globalState"&&await E.hasLocalData())return!0})}async hasPreviouslySynced(){return!!await this.O(this.G.defaultProfile,async E=>{if(await E.hasPreviouslySynced())return!0})}async reset(){this.X(),await this.resetRemote(),await this.resetLocal()}async resetRemote(){this.X();try{await this.v.clear(),this.z.info("Cleared data on server")}catch(u){this.z.error(u)}this.t.fire()}async resetLocal(){this.X(),this.m=void 0,this.D.remove(n,-1);for(const[u]of this.u.values())try{await u.resetLocal()}catch(E){this.z.error(E)}this.W(),this.r.fire(),this.z.info("Did reset the local sync state.")}async cleanUpRemoteData(){const u=await this.H.getRemoteSyncedProfiles(),E=u.map(q=>q.collection),D=await this.v.getAllCollections(),T=D.filter(q=>!E.includes(q));T.length&&(this.z.info(`Deleting ${T.length} redundant collections on server`),await Promise.allSettled(T.map(q=>this.v.deleteCollection(q))),this.z.info("Deleted redundant collections on server"));const F=u.filter(q=>D.includes(q.collection));if(F.length!==u.length){const q=this.y.createInstance(c.$93b,this.G.defaultProfile,void 0);try{this.z.info("Resetting the last synced state of profiles"),await q.resetLocal(),this.z.info("Did reset the last synced state of profiles"),this.z.info("Updating remote profiles with invalid collections on server"),await q.updateRemoteProfiles(F,null),this.z.info("Updated remote profiles on server")}finally{q.dispose()}}}async O(u,E){const D=new R.$lb;try{const T=this.u.get(u.id);if(T){const Y=await this.P(T[0],E,D);return(0,m.$se)(Y)?null:Y}if(u.isDefault){const Y=D.add(this.y.createInstance(r,u,void 0)),x=await this.P(Y,E,D);return(0,m.$se)(x)?null:x}if(this.G.isEnabled())return null;const F=D.add(this.y.createInstance(c.$93b,u,void 0)),q=await this.v.manifest(null),Z=(await F.getRemoteSyncedProfiles(q?.latest??null)||[]).find(Y=>Y.id===u.id);if(Z){const Y=D.add(this.y.createInstance(r,u,Z.collection)),x=await this.P(Y,E,D);return(0,m.$se)(x)?null:x}return null}finally{D.dispose()}}async P(u,E,D){const T=[...u.enabled,...u.disabled.reduce((F,q)=>(q!=="workspaceState"&&F.push(D.add(u.createSynchronizer(q))),F),[])];for(const F of T){const q=await E(F);if(!(0,m.$se)(q))return q}}Q(u){const E=this.f;this.f!==u&&(this.f=u,this.g.fire(u),E==="hasConflicts"&&this.S())}R(){const u=this.U().map(E=>E.conflicts).flat();(0,L.$of)(this.i,u,(E,D)=>E.profile.id===D.profile.id&&E.syncResource===D.syncResource&&(0,L.$of)(E.conflicts,D.conflicts,(T,F)=>(0,k.$_f)(T.previewResource,F.previewResource)))||(this.i=u,this.j.fire(u))}S(){this.status==="idle"&&(this.m=new Date().getTime(),this.D.store(n,this.m,-1,1),this.n.fire(this.m))}getOrCreateActiveProfileSynchronizer(u,E){let D=this.u.get(u.id);if(D&&D[0].collection!==E?.collection&&(this.z.error("Profile synchronizer collection does not match with the remote sync profile collection"),D[1].dispose(),D=void 0,this.u.delete(u.id)),!D){const T=new R.$lb,F=T.add(this.y.createInstance(r,u,E?.collection));T.add(F.onDidChangeStatus(q=>this.Q(q))),T.add(F.onDidChangeConflicts(q=>this.R())),T.add(F.onDidChangeLocal(q=>this.h.fire(q))),this.u.set(u.id,D=[F,T])}return D[0]}U(){const u=[];for(const[E]of this.u.values())u.push(E);return u}W(){this.u.forEach(([,u])=>u.dispose()),this.u.clear()}X(){if(!this.w.userDataSyncStore)throw new Error("Not enabled")}};e.$_3b=i,e.$_3b=i=ye([X(0,s.$ggb),X(1,s.$fgb),X(2,h.$yh),X(3,s.$vgb),X(4,w.$7k),X(5,d.$So),X(6,s.$qgb),X(7,f.$Ck),X(8,s.$sgb)],i);let r=class extends R.$mb{get enabled(){return this.f.sort((u,E)=>u[1]-E[1]).map(([u])=>u)}get disabled(){return s.$cgb.filter(u=>!this.l.isResourceEnabled(u))}get status(){return this.g}get conflicts(){return this.j}constructor(u,E,D,T,F,q,W,Z,Y,x){super(),this.profile=u,this.collection=E,this.l=D,this.m=T,this.n=F,this.r=q,this.t=W,this.u=Z,this.v=Y,this.w=x,this.f=[],this.g="idle",this.h=this.B(new A.$hc),this.onDidChangeStatus=this.h.event,this.i=this.B(new A.$hc),this.onDidChangeLocal=this.i.event,this.j=[],this.k=this.B(new A.$hc),this.onDidChangeConflicts=this.k.event,this.B(D.onDidChangeResourceEnablement(([G,Q])=>this.y(G,Q))),this.B((0,R.$kb)(()=>this.f.splice(0,this.f.length).forEach(([,,G])=>G.dispose())));for(const G of s.$cgb)D.isResourceEnabled(G)&&this.z(G)}y(u,E){E?this.z(u):this.C(u)}z(u){if(this.f.some(([F])=>F.resource===u))return;if(u==="extensions"&&!this.n.isEnabled()){this.u.info("Skipping extensions sync because gallery is not configured");return}if(u==="profiles"&&(!this.profile.isDefault||!this.v.isEnabled())||u==="workspaceState")return;if(u!=="profiles"&&this.profile.useDefaultFlags?.[u]){this.u.debug(`Skipping syncing ${u} in ${this.profile.name} because it is already synced by default profile`);return}const E=new R.$lb,D=E.add(this.createSynchronizer(u));E.add(D.onDidChangeStatus(()=>this.G())),E.add(D.onDidChangeConflicts(()=>this.H())),E.add(D.onDidChangeLocal(()=>this.i.fire(u)));const T=this.I(u);this.f.push([D,T,E])}C(u){const E=this.f.findIndex(([D])=>D.resource===u);if(E!==-1){const[[D,,T]]=this.f.splice(E,1);T.dispose(),this.G(),Promise.allSettled([D.stop(),D.resetLocal()]).then(null,F=>this.u.error(F))}}createSynchronizer(u){switch(u){case"settings":return this.m.createInstance(b.$l2b,this.profile,this.collection);case"keybindings":return this.m.createInstance($.$i2b,this.profile,this.collection);case"snippets":return this.m.createInstance(I.$q2b,this.profile,this.collection);case"tasks":return this.m.createInstance(t.$t2b,this.profile,this.collection);case"globalState":return this.m.createInstance(l.$KAb,this.profile,this.collection);case"extensions":return this.m.createInstance(o.$d2b,this.profile,this.collection);case"profiles":return this.m.createInstance(c.$93b,this.profile,this.collection)}}async sync(u,E,D,T){if(T.isCancellationRequested)return[];const F=this.enabled;if(!F.length)return[];try{const q=[],W=(0,s.$kgb)(D),Z=(this.collection?u?.collections?.[this.collection]?.latest:u?.latest)??null,Y=E?await this.D(Z):{};for(const x of F){if(T.isCancellationRequested)return[];if(!this.l.isResourceEnabled(x.resource))return[];try{if(E){const G=await x.preview(Z,Y,W);if(G)for(const Q of G.resourcePreviews)(Q.localChange!==0||Q.remoteChange!==0)&&Q.mergeState==="preview"&&await x.merge(Q.previewResource)}else await x.sync(Z,W)}catch(G){const Q=s.$lgb.toUserDataSyncError(G);if(v(Q,D,this.r,this.t),a(G))throw Q;this.u.error(G),this.u.error(`${x.resource}: ${(0,j.$ki)(G)}`),q.push([x.resource,Q])}}return q}finally{this.G()}}async apply(u,E){const D=(0,s.$kgb)(u);for(const T of this.enabled){if(E.isCancellationRequested)return;try{await T.apply(!1,D)}catch(F){const q=s.$lgb.toUserDataSyncError(F);if(v(q,u,this.r,this.t),a(F))throw q;this.u.error(F),this.u.error(`${T.resource}: ${(0,j.$ki)(F)}`)}}}async stop(){for(const u of this.enabled)try{u.status!=="idle"&&await u.stop()}catch(E){this.u.error(E)}}async resetLocal(){for(const u of this.enabled)try{await u.resetLocal()}catch(E){this.u.error(`${u.resource}: ${(0,j.$ki)(E)}`),this.u.error(E)}}async D(u){if(!this.profile.isDefault)return{};const E=this.w.getValue(s.$$fb),D=this.enabled.find(T=>T instanceof b.$l2b);if(D){const T=await D.getRemoteUserDataSyncConfiguration(u);return{...E,...T}}return E}F(u){this.g!==u&&(this.g=u,this.h.fire(u))}G(){return this.H(),this.enabled.some(u=>u.status==="hasConflicts")?this.F("hasConflicts"):this.enabled.some(u=>u.status==="syncing")?this.F("syncing"):this.F("idle")}H(){const u=this.enabled.filter(E=>E.status==="hasConflicts").filter(E=>E.conflicts.conflicts.length>0).map(E=>E.conflicts);(0,L.$of)(this.j,u,(E,D)=>E.syncResource===D.syncResource&&(0,L.$of)(E.conflicts,D.conflicts,(T,F)=>(0,k.$_f)(T.previewResource,F.previewResource)))||(this.j=u,this.k.fire(u))}I(u){switch(u){case"settings":return 0;case"keybindings":return 1;case"snippets":return 2;case"tasks":return 3;case"globalState":return 4;case"extensions":return 5;case"profiles":return 6;case"workspaceState":return 7}}};r=ye([X(2,s.$qgb),X(3,h.$yh),X(4,g.$Xn),X(5,s.$fgb),X(6,w.$7k),X(7,s.$vgb),X(8,f.$Ck),X(9,p.$6h)],r);function a(y){if(y instanceof s.$lgb)switch(y.code){case"MethodNotFound":case"TooLarge":case"RemoteTooManyRequests":case"TooManyRequestsAndRetryAfter":case"LocalTooManyRequests":case"LocalTooManyProfiles":case"Gone":case"UpgradeRequired":case"IncompatibleRemoteContent":case"IncompatibleLocalContent":return!0}return!1}function v(y,u,E,D){D.publicLog2("sync/error",{code:y.code,serverCode:y instanceof s.$mgb?String(y.serverCode):void 0,url:y instanceof s.$mgb?y.url:void 0,resource:y.resource,executionId:u,service:E.userDataSyncStore.url.toString()})}}),define(re[257],oe([0,1,3,2,11,17,25]),function(te,e,L,N,O,j,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$p7b=e.$o7b=void 0;function R(g,h){return{...g,profile:(0,j.$Dk)(g.profile,h.profilesHome.scheme)}}function k(g){return{created:g.created,uri:O.URI.revive(g.uri)}}class m{constructor(h,d,w){this.c=h,this.d=d,this.f=w,this.a=new Map,this.b=new L.$hc}listen(h,d){switch(d){case"onDidChangeStatus":return this.c.onDidChangeStatus;case"onDidChangeConflicts":return this.c.onDidChangeConflicts;case"onDidChangeLocal":return this.c.onDidChangeLocal;case"onDidChangeLastSyncTime":return this.c.onDidChangeLastSyncTime;case"onSyncErrors":return this.c.onSyncErrors;case"onDidResetLocal":return this.c.onDidResetLocal;case"onDidResetRemote":return this.c.onDidResetRemote;case"manualSync/onSynchronizeResources":return this.b.event}throw new Error(`Event not found: ${d}`)}async call(h,d,w){try{return await this.g(h,d,w)}catch(f){throw this.f.error(f),f}}async g(h,d,w){switch(d){case"_getInitialData":return Promise.resolve([this.c.status,this.c.conflicts,this.c.lastSyncTime]);case"reset":return this.c.reset();case"resetRemote":return this.c.resetRemote();case"resetLocal":return this.c.resetLocal();case"hasPreviouslySynced":return this.c.hasPreviouslySynced();case"hasLocalData":return this.c.hasLocalData();case"resolveContent":return this.c.resolveContent(O.URI.revive(w[0]));case"accept":return this.c.accept(R(w[0],this.d),O.URI.revive(w[1]),w[2],w[3]);case"getRemoteProfiles":return this.c.getRemoteProfiles();case"getLocalSyncResourceHandles":return this.c.getLocalSyncResourceHandles(w[0],w[1]?(0,j.$Dk)(w[1],this.d.profilesHome.scheme):void 0);case"getRemoteSyncResourceHandles":return this.c.getRemoteSyncResourceHandles(w[0],w[1]);case"replace":return this.c.replace(k(w[0]));case"getAssociatedResources":return this.c.getAssociatedResources(k(w[0]));case"getMachineId":return this.c.getMachineId(k(w[0]));case"cleanUpRemoteData":return this.c.cleanUpRemoteData();case"createManualSyncTask":return this.i()}if(d.startsWith("manualSync/")){const f=d.substring(11),o=w[0],l=this.h(o);switch(w=w.slice(1),f){case"merge":return l.merge();case"apply":return l.apply().then(()=>this.a.delete(this.j(l.id)));case"stop":return l.stop().finally(()=>this.a.delete(this.j(l.id)))}}throw new Error("Invalid call")}h(h){const d=this.a.get(this.j(h));if(!d)throw new Error(`Manual sync taks not found: ${h}`);return d}async i(){const h=await this.c.createManualSyncTask();return this.a.set(this.j(h.id),h),h.id}j(h){return`manualSyncTask-${h}`}}e.$o7b=m;let P=class extends N.$mb{get status(){return this.b}get onDidChangeLocal(){return this.a.listen("onDidChangeLocal")}get conflicts(){return this.f}get lastSyncTime(){return this.h}get onDidResetLocal(){return this.a.listen("onDidResetLocal")}get onDidResetRemote(){return this.a.listen("onDidResetRemote")}constructor(h,d){super(),this.k=d,this.b="uninitialized",this.c=this.B(new L.$hc),this.onDidChangeStatus=this.c.event,this.f=[],this.g=this.B(new L.$hc),this.onDidChangeConflicts=this.g.event,this.h=void 0,this.i=this.B(new L.$hc),this.onDidChangeLastSyncTime=this.i.event,this.j=this.B(new L.$hc),this.onSyncErrors=this.j.event,this.a={call(w,f,o){return h.call(w,f,o).then(null,l=>{throw A.$lgb.toUserDataSyncError(l)})},listen(w,f){return h.listen(w,f)}},this.a.call("_getInitialData").then(([w,f,o])=>{this.l(w),this.m(f),o&&this.n(o),this.B(this.a.listen("onDidChangeStatus")(l=>this.l(l))),this.B(this.a.listen("onDidChangeLastSyncTime")(l=>this.n(l)))}),this.B(this.a.listen("onDidChangeConflicts")(w=>this.m(w))),this.B(this.a.listen("onSyncErrors")(w=>this.j.fire(w.map(f=>({...f,error:A.$lgb.toUserDataSyncError(f.error)})))))}createSyncTask(){throw new Error("not supported")}async createManualSyncTask(){const h=await this.a.call("createManualSyncTask"),d=this;return new p(h,{async call(f,o,l){return d.a.call(`manualSync/${f}`,[h,...Array.isArray(o)?o:[o]],l)},listen(){throw new Error("not supported")}})}reset(){return this.a.call("reset")}resetRemote(){return this.a.call("resetRemote")}resetLocal(){return this.a.call("resetLocal")}hasPreviouslySynced(){return this.a.call("hasPreviouslySynced")}hasLocalData(){return this.a.call("hasLocalData")}accept(h,d,w,f){return this.a.call("accept",[h,d,w,f])}resolveContent(h){return this.a.call("resolveContent",[h])}getRemoteProfiles(){return this.a.call("getRemoteProfiles")}async getLocalSyncResourceHandles(h,d){return(await this.a.call("getLocalSyncResourceHandles",[h,d])).map(({created:f,uri:o})=>({created:f,uri:O.URI.revive(o)}))}async getRemoteSyncResourceHandles(h,d){return(await this.a.call("getRemoteSyncResourceHandles",[h,d])).map(({created:f,uri:o})=>({created:f,uri:O.URI.revive(o)}))}async getAssociatedResources(h){return(await this.a.call("getAssociatedResources",[h])).map(({resource:w,comparableResource:f})=>({resource:O.URI.revive(w),comparableResource:O.URI.revive(f)}))}getMachineId(h){return this.a.call("getMachineId",[h])}cleanUpRemoteData(){return this.a.call("cleanUpRemoteData")}replace(h){return this.a.call("replace",[h])}async l(h){this.b=h,this.c.fire(h)}async m(h){this.f=h.map(d=>({syncResource:d.syncResource,profile:(0,j.$Dk)(d.profile,this.k.profilesHome.scheme),conflicts:d.conflicts.map(w=>({...w,baseResource:O.URI.revive(w.baseResource),localResource:O.URI.revive(w.localResource),remoteResource:O.URI.revive(w.remoteResource),previewResource:O.URI.revive(w.previewResource)}))})),this.g.fire(this.f)}n(h){this.h!==h&&(this.h=h,this.i.fire(h))}};e.$p7b=P,e.$p7b=P=ye([X(1,j.$Ck)],P);class p extends N.$mb{constructor(h,d){super(),this.id=h,this.a=d}async merge(){return this.a.call("merge")}async apply(){return this.a.call("apply")}stop(){return this.a.call("stop")}dispose(){this.a.call("dispose")}}}),define(re[258],oe([0,1,5,26,8,3,2,140,6,23,9,11,32,18,16,13,24,57,44,19,25]),function(te,e,L,N,O,j,A,R,k,m,P,p,g,h,d,w,f,o,l,$,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$AAb=e.$zAb=e.$yAb=e.$xAb=e.$wAb=void 0;const I="configurationSync.store",t="sync.previous.store",c="sync.donot-make-requests-until",s="sync.user-session-id",n="sync.machine-session-id",i=100,r=1e3*60*5;let a=class extends A.$mb{get userDataSyncStore(){return this.b}get c(){return this.h.get(b.$ogb,-1)}set c(T){this.h.store(b.$ogb,T,-1,k.$o?0:1)}constructor(T,F,q){super(),this.f=T,this.g=F,this.h=q,this.a=this.B(new j.$hc),this.onDidChangeUserDataSyncStore=this.a.event,this.i();const W=this.B(new A.$lb);this.B(j.Event.filter(q.onDidChangeValue(-1,b.$ogb,W),()=>this.c!==this.userDataSyncStore?.type,W)(()=>this.i()))}i(){this.b=this.j(this.f[I]),this.a.fire()}j(T){if(T&&(T=k.$o&&T.web?{...T,...T.web}:T,(0,P.$le)(T.url)&&(0,P.$ne)(T.authenticationProviders)&&Object.keys(T.authenticationProviders).every(F=>Array.isArray(T.authenticationProviders[F].scopes)))){const F=T,q=!!F.canSwitch,W=F.url===F.insidersUrl?"insiders":"stable",Z=(q?this.c:void 0)||W,Y=Z==="insiders"?F.insidersUrl:Z==="stable"?F.stableUrl:F.url;return{url:p.URI.parse(Y),type:Z,defaultType:W,defaultUrl:p.URI.parse(F.url),stableUrl:p.URI.parse(F.stableUrl),insidersUrl:p.URI.parse(F.insidersUrl),canSwitch:q,authenticationProviders:Object.keys(F.authenticationProviders).reduce((x,G)=>(x.push({id:G,scopes:F.authenticationProviders[G].scopes}),x),[])}}}};e.$wAb=a,e.$wAb=a=ye([X(0,f.$ij),X(1,h.$6h),X(2,$.$So)],a);let v=class extends a{constructor(T,F,q){super(T,F,q);const W=this.h.get(t,-1);W&&(this.k=JSON.parse(W));const Z=this.f[I];Z?this.h.store(t,JSON.stringify(Z),-1,1):this.h.remove(t,-1)}async switch(T){T!==this.c&&(this.c=T,this.i())}async getPreviousUserDataSyncStore(){return this.j(this.k)}};e.$xAb=v,e.$xAb=v=ye([X(0,f.$ij),X(1,h.$6h),X(2,$.$So)],v);let y=class extends A.$mb{get donotMakeRequestsUntil(){return this.i}constructor(T,F,q,W,Z,Y,x){super(),this.k=q,this.l=W,this.m=x,this.g=this.B(new j.$hc),this.onTokenFailed=this.g.event,this.h=this.B(new j.$hc),this.onTokenSucceed=this.h.event,this.i=void 0,this.j=this.B(new j.$hc),this.onDidChangeDonotMakeRequestsUntil=this.j.event,this.r=void 0,this.n(T),this.c=(0,l.$Yo)(Z,Y,x).then(G=>{const Q={"X-Client-Name":`${F.applicationName}${k.$o?"-web":""}`,"X-Client-Version":F.version};return F.commit&&(Q["X-Client-Commit"]=F.commit),Q}),this.f=new E(i,r,this.k,this.l),this.p(),this.B((0,A.$kb)(()=>{this.r&&(this.r.cancel(),this.r=void 0)}))}setAuthToken(T,F){this.b={token:T,type:F}}n(T){this.a=T?(0,m.$gg)(T,"v1"):void 0}p(){const T=this.m.getNumber(c,-1);T&&Date.now()<T&&this.s(new Date(T))}s(T){this.i?.getTime()!==T?.getTime()&&(this.i=T,this.r&&(this.r.cancel(),this.r=void 0),this.i?(this.m.store(c,this.i.getTime(),-1,1),this.r=(0,L.$sg)(F=>(0,L.$Fg)(this.i.getTime()-Date.now(),F).then(()=>this.s(void 0))),this.r.then(null,F=>null)):this.m.remove(c,-1),this.j.fire())}async getAllCollections(T={}){if(!this.a)throw new Error("No settings sync store url configured.");const F=(0,m.$gg)(this.a,"collection").toString();T={...T},T["Content-Type"]="application/json";const q=await this.v(F,{type:"GET",headers:T},[],N.CancellationToken.None);return(await(0,o.$Lo)(q))?.map(({id:W})=>W)||[]}async createCollection(T={}){if(!this.a)throw new Error("No settings sync store url configured.");const F=(0,m.$gg)(this.a,"collection").toString();T={...T},T["Content-Type"]=R.$Er.text;const q=await this.v(F,{type:"POST",headers:T},[],N.CancellationToken.None),W=await(0,o.$Ko)(q);if(!W)throw new b.$mgb("Server did not return the collection id",F,"NoCollection",q.res.statusCode,q.res.headers[b.$igb]);return W}async deleteCollection(T,F={}){if(!this.a)throw new Error("No settings sync store url configured.");const q=T?(0,m.$gg)(this.a,"collection",T).toString():(0,m.$gg)(this.a,"collection").toString();F={...F},await this.v(q,{type:"DELETE",headers:F},[],N.CancellationToken.None)}async getAllResourceRefs(T,F){if(!this.a)throw new Error("No settings sync store url configured.");const q=this.t(this.a,F,T),W={},Z=await this.v(q.toString(),{type:"GET",headers:W},[],N.CancellationToken.None);return(await(0,o.$Lo)(Z)||[]).map(({url:x,created:G})=>({ref:(0,m.$ig)(q,q.with({path:x})),created:G*1e3}))}async resolveResourceContent(T,F,q,W={}){if(!this.a)throw new Error("No settings sync store url configured.");const Z=(0,m.$gg)(this.t(this.a,q,T),F).toString();W={...W},W["Cache-Control"]="no-cache";const Y=await this.v(Z,{type:"GET",headers:W},[],N.CancellationToken.None);return await(0,o.$Ko)(Y)}async deleteResource(T,F,q){if(!this.a)throw new Error("No settings sync store url configured.");const W=F!==null?(0,m.$gg)(this.t(this.a,q,T),F).toString():this.t(this.a,q,T).toString(),Z={};await this.v(W,{type:"DELETE",headers:Z},[],N.CancellationToken.None)}async deleteResources(){if(!this.a)throw new Error("No settings sync store url configured.");const T=(0,m.$gg)(this.a,"resource").toString(),F={"Content-Type":R.$Er.text};await this.v(T,{type:"DELETE",headers:F},[],N.CancellationToken.None)}async readResource(T,F,q,W={}){if(!this.a)throw new Error("No settings sync store url configured.");const Z=(0,m.$gg)(this.t(this.a,q,T),"latest").toString();W={...W},W["Cache-Control"]="no-cache",F&&(W["If-None-Match"]=F.ref);const Y=await this.v(Z,{type:"GET",headers:W},[304],N.CancellationToken.None);let x=null;if(Y.res.statusCode===304&&(x=F),x===null){const G=Y.res.headers.etag;if(!G)throw new b.$mgb("Server did not return the ref",Z,"NoRef",Y.res.statusCode,Y.res.headers[b.$igb]);const Q=await(0,o.$Ko)(Y);if(!Q&&Y.res.statusCode===304)throw new b.$mgb("Empty response",Z,"EmptyResponse",Y.res.statusCode,Y.res.headers[b.$igb]);x={ref:G,content:Q}}return x}async writeResource(T,F,q,W,Z={}){if(!this.a)throw new Error("No settings sync store url configured.");const Y=this.t(this.a,W,T).toString();Z={...Z},Z["Content-Type"]=R.$Er.text,q&&(Z["If-Match"]=q);const x=await this.v(Y,{type:"POST",data:F,headers:Z},[],N.CancellationToken.None),G=x.res.headers.etag;if(!G)throw new b.$mgb("Server did not return the ref",Y,"NoRef",x.res.statusCode,x.res.headers[b.$igb]);return G}async manifest(T,F={}){if(!this.a)throw new Error("No settings sync store url configured.");const q=(0,m.$gg)(this.a,"manifest").toString();F={...F},F["Content-Type"]="application/json",T&&(F["If-None-Match"]=T.ref);const W=await this.v(q,{type:"GET",headers:F},[304],N.CancellationToken.None);let Z=null;if(W.res.statusCode===304&&(Z=T),!Z){const x=W.res.headers.etag;if(!x)throw new b.$mgb("Server did not return the ref",q,"NoRef",W.res.statusCode,W.res.headers[b.$igb]);const G=await(0,o.$Ko)(W);if(!G&&W.res.statusCode===304)throw new b.$mgb("Empty response",q,"EmptyResponse",W.res.statusCode,W.res.headers[b.$igb]);G&&(Z={...JSON.parse(G),ref:x})}const Y=this.m.get(s,-1);return Y&&Z&&Y!==Z.session&&this.u(),Z===null&&Y&&this.u(),Z&&this.m.store(s,Z.session,-1,1),Z}async clear(){if(!this.a)throw new Error("No settings sync store url configured.");await this.deleteCollection(),await this.deleteResources(),this.u()}t(T,F,q){return F?(0,m.$gg)(T,"collection",F,"resource",q):(0,m.$gg)(T,"resource",q)}u(){this.m.remove(s,-1),this.m.remove(n,-1)}async v(T,F,q,W){if(!this.b)throw new b.$mgb("No Auth Token Available",T,"Unauthorized",void 0,void 0);if(this.i&&Date.now()<this.i.getTime())throw new b.$mgb(`${F.type} request '${T}' failed because of too many requests (429).`,T,"TooManyRequestsAndRetryAfter",void 0,void 0);this.s(void 0);const Z=await this.c;F.headers={...F.headers||{},...Z,"X-Account-Type":this.b.type,authorization:`Bearer ${this.b.token}`},this.w(F.headers),this.l.trace("Sending request to server",{url:T,type:F.type,headers:{...F.headers,authorization:void 0}});let Y;try{Y=await this.f.request(T,F,W)}catch(V){if(!(V instanceof b.$mgb)){let B="RequestFailed";const ee=(0,O.$8)(V).toLowerCase();ee.includes("xhr timeout")?B="RequestTimeout":ee.includes("protocol")&&ee.includes("not supported")?B="RequestProtocolNotSupported":ee.includes("request path contains unescaped characters")?B="RequestPathNotEscaped":ee.includes("headers must be an object")?B="RequestHeadersNotObject":(0,O.$2)(V)&&(B="RequestCanceled"),V=new b.$mgb(`Connection refused for the request '${T}'.`,T,B,void 0,void 0)}throw this.l.info("Request failed",T),V}const x=Y.res.headers[b.$igb],G={url:T,status:Y.res.statusCode,"execution-id":F.headers[b.$jgb],"operation-id":x},Q=(0,o.$Io)(Y)||Y.res.statusCode&&q.includes(Y.res.statusCode);let H="";if(Q?this.l.trace("Request succeeded",G):(H=await(0,o.$Jo)(Y)||"",this.l.info("Request failed",G,H)),Y.res.statusCode===401||Y.res.statusCode===403){if(this.b=void 0,Y.res.statusCode===401)throw this.g.fire("Unauthorized"),new b.$mgb(`${F.type} request '${T}' failed because of Unauthorized (401).`,T,"Unauthorized",Y.res.statusCode,x);if(Y.res.statusCode===403)throw this.g.fire("Forbidden"),new b.$mgb(`${F.type} request '${T}' failed because the access is forbidden (403).`,T,"Forbidden",Y.res.statusCode,x)}if(this.h.fire(),Y.res.statusCode===404)throw new b.$mgb(`${F.type} request '${T}' failed because the requested resource is not found (404).`,T,"NotFound",Y.res.statusCode,x);if(Y.res.statusCode===405)throw new b.$mgb(`${F.type} request '${T}' failed because the requested endpoint is not found (405). ${H}`,T,"MethodNotFound",Y.res.statusCode,x);if(Y.res.statusCode===409)throw new b.$mgb(`${F.type} request '${T}' failed because of Conflict (409). There is new data for this resource. Make the request again with latest data.`,T,"Conflict",Y.res.statusCode,x);if(Y.res.statusCode===410)throw new b.$mgb(`${F.type} request '${T}' failed because the requested resource is not longer available (410).`,T,"Gone",Y.res.statusCode,x);if(Y.res.statusCode===412)throw new b.$mgb(`${F.type} request '${T}' failed because of Precondition Failed (412). There is new data for this resource. Make the request again with latest data.`,T,"PreconditionFailed",Y.res.statusCode,x);if(Y.res.statusCode===413)throw new b.$mgb(`${F.type} request '${T}' failed because of too large payload (413).`,T,"TooLarge",Y.res.statusCode,x);if(Y.res.statusCode===426)throw new b.$mgb(`${F.type} request '${T}' failed with status Upgrade Required (426). Please upgrade the client and try again.`,T,"UpgradeRequired",Y.res.statusCode,x);if(Y.res.statusCode===429){const V=Y.res.headers["retry-after"];throw V?(this.s(new Date(Date.now()+parseInt(V)*1e3)),new b.$mgb(`${F.type} request '${T}' failed because of too many requests (429).`,T,"TooManyRequestsAndRetryAfter",Y.res.statusCode,x)):new b.$mgb(`${F.type} request '${T}' failed because of too many requests (429).`,T,"RemoteTooManyRequests",Y.res.statusCode,x)}if(!Q)throw new b.$mgb("Server returned "+Y.res.statusCode,T,"Unknown",Y.res.statusCode,x);return Y}w(T){let F=this.m.get(n,-1);F===void 0&&(F=(0,g.$6e)(),this.m.store(n,F,-1,1)),T["X-Machine-Session-Id"]=F;const q=this.m.get(s,-1);q!==void 0&&(T["X-User-Session-Id"]=q)}};e.$yAb=y,e.$yAb=y=ye([X(1,f.$ij),X(2,o.$Go),X(3,b.$vgb),X(4,d.$Gh),X(5,w.$4j),X(6,$.$So)],y);let u=class extends y{constructor(T,F,q,W,Z,Y,x){super(T.userDataSyncStore?.url,F,q,W,Z,Y,x),this.B(T.onDidChangeUserDataSyncStore(()=>this.n(T.userDataSyncStore?.url)))}};e.$zAb=u,e.$zAb=u=ye([X(0,b.$fgb),X(1,f.$ij),X(2,o.$Go),X(3,b.$vgb),X(4,d.$Gh),X(5,w.$4j),X(6,$.$So)],u);class E{constructor(T,F,q,W){this.c=T,this.d=F,this.f=q,this.g=W,this.a=[],this.b=void 0}request(T,F,q){if(this.h()&&this.i(),F.url=T,this.a.length>=this.c)throw this.g.info("Too many requests",...this.a),new b.$mgb(`Too many requests. Only ${this.c} requests allowed in ${this.d/(1e3*60)} minutes.`,T,"LocalTooManyRequests",void 0,void 0);return this.b=this.b||new Date,this.a.push(T),this.f.request(F,q)}h(){return this.b!==void 0&&new Date().getTime()-this.b.getTime()>this.d}i(){this.a=[],this.b=void 0}}e.$AAb=E}),define(re[259],oe([0,1,3,55,24,19,21,254,25,78,81]),function(te,e,L,N,O,j,A,R,k,m,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$J7b=void 0;let p=class extends R.$a4b{constructor(h,d,w,f,o,l,$,b,I,t,c){super(h,d,w,f,o,$,b,I,t,c),this.B(L.Event.debounce(L.Event.any(L.Event.map(l.onDidFocusWindow,()=>"windowFocus"),L.Event.map(l.onDidOpenWindow,()=>"windowOpen")),(s,n)=>s?[...s,n]:[n],1e3)(s=>this.triggerSync(s,!0,!1)))}};e.$J7b=p,e.$J7b=p=ye([X(0,O.$ij),X(1,k.$fgb),X(2,k.$ggb),X(3,k.$qgb),X(4,k.$rgb),X(5,N.$x5b),X(6,k.$vgb),X(7,m.$bzb),X(8,A.$7k),X(9,P.$6Yb),X(10,j.$So)],p)}),define(re[260],oe([0,1,69,22,6,23]),function(te,e,L,N,O,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_4b=e.$$4b=e.$04b=e.$94b=void 0,e.$94b=128/4;function A(m){function P(){let p=m.scheme===N.Schemas.file?(0,j.$7f)(m):m.toString();return O.$k||(p=p.toLowerCase()),(0,L.createHash)("md5").update(p).digest("hex")}return{id:P(),configPath:m}}e.$04b=A;function R(m,P){function p(){if(m.scheme!==N.Schemas.file)return(0,L.createHash)("md5").update(m.toString()).digest("hex");if(!P)return;let h;return O.$k?h=P.ino:O.$j?h=P.birthtime.getTime():O.$i&&(typeof P.birthtimeMs=="number"?h=Math.floor(P.birthtimeMs):h=P.birthtime.getTime()),(0,L.createHash)("md5").update(m.fsPath).update(h?String(h):"").digest("hex")}const g=p();if(typeof g=="string")return{id:g,uri:m}}e.$$4b=R;function k(){return{id:(Date.now()+Math.round(Math.random()*1e3)).toString()}}e.$_4b=k}),define(re[261],oe([0,1,5,8,2,15,31,16,7,75,113,260,55,71,22]),function(te,e,L,N,O,j,A,R,k,m,P,p,g,h,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$d7b=void 0;let w=class extends O.$mb{constructor(o,l,$,b){super(),this.a=o,this.b=l,this.c=$,this.f=b,this.B(new L.$Qg(()=>{this.g()},30*1e3)).schedule()}async g(){this.b.trace("[storage cleanup]: Starting to clean up workspace storage folders for unused empty workspaces.");try{const o=this.a.workspaceStorageHome.with({scheme:d.Schemas.file}).fsPath,l=await A.Promises.readdir(o),$=new m.$Mzb(this.f.getChannel("storage"));await Promise.all(l.map(async b=>{const I=(0,j.$$c)(o,b);b.length===p.$94b||b===P.$Lh.id||(await this.c.getWindows()).some(s=>s.workspace?.id===b)||await $.isUsed(I)||(this.b.trace(`[storage cleanup]: Deleting workspace storage folder ${b} as it seems to be an unused empty workspace.`),await A.Promises.rm(I))}))}catch(o){(0,N.$Y)(o)}}};e.$d7b=w,e.$d7b=w=ye([X(0,R.$Hh),X(1,k.$3i),X(2,g.$x5b),X(3,h.$O6b)],w)}),define(re[82],oe([0,1,52,5,15,9,31,147,272,273]),function(te,e,L,N,O,j,A,R,k,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bp=e.$ap=e.zip=e.$$o=e.$0o=void 0,e.$0o="end of central directory record signature not found";const P=new RegExp(e.$0o);class p extends Error{constructor(c,s){let n=s.message;switch(c){case"CorruptZip":n=`Corrupt ZIP: ${n}`;break}super(n),this.type=c,this.cause=s}}e.$$o=p;function g(t){const c=t.externalFileAttributes>>16||33188;return[448,56,7].map(s=>c&s).reduce((s,n)=>s+n,c&61440)}function h(t){if(t instanceof p)return t;let c;return P.test(t.message)&&(c="CorruptZip"),new p(c,t)}function d(t,c,s,n,i,r){const a=O.$bd(c),v=O.$$c(n,a);if(!v.startsWith(n))return Promise.reject(new Error(R.localize(0,null,c)));const y=O.$$c(n,c);let u;return r.onCancellationRequested(()=>{u?.destroy()}),Promise.resolve(A.Promises.mkdir(v,{recursive:!0})).then(()=>new Promise((E,D)=>{if(!r.isCancellationRequested)try{u=(0,L.createWriteStream)(y,{mode:s}),u.once("close",()=>E()),u.once("error",D),t.once("error",D),t.pipe(u)}catch(T){D(T)}}))}function w(t,c,s,n){let i=(0,N.$sg)(()=>Promise.resolve()),r=0;const a=n.onCancellationRequested(()=>{i.cancel(),t.close()});return new Promise((v,y)=>{const u=new N.$zg,E=D=>{D.isCancellationRequested||(r++,t.readEntry())};t.once("error",y),t.once("close",()=>i.then(()=>{n.isCancellationRequested||t.entryCount===r?v():y(new p("Incomplete",new Error(R.localize(1,null,r,t.entryCount))))},y)),t.readEntry(),t.on("entry",D=>{if(n.isCancellationRequested)return;if(!s.sourcePathRegex.test(D.fileName)){E(n);return}const T=D.fileName.replace(s.sourcePathRegex,"");if(/\/$/.test(T)){const W=O.$$c(c,T);i=(0,N.$sg)(Z=>A.Promises.mkdir(W,{recursive:!0}).then(()=>E(Z)).then(void 0,y));return}const F=o(t,D),q=g(D);i=(0,N.$sg)(W=>u.queue(()=>F.then(Z=>d(Z,T,q,c,s,W).then(()=>E(W)))).then(null,y))})}).finally(()=>a.dispose())}function f(t,c=!1){return new Promise((s,n)=>{(0,k.open)(t,c?{lazyEntries:!0}:void 0,(i,r)=>{i?n(h(i)):s((0,j.$we)(r))})})}function o(t,c){return new Promise((s,n)=>{t.openReadStream(c,(i,r)=>{i?n(h(i)):s((0,j.$we)(r))})})}function l(t,c){return new Promise((s,n)=>{const i=new m.ZipFile;c.forEach(a=>{a.contents?i.addBuffer(typeof a.contents=="string"?Buffer.from(a.contents,"utf8"):a.contents,a.path):a.localPath&&i.addFile(a.localPath,a.path)}),i.end();const r=(0,L.createWriteStream)(t);i.outputStream.pipe(r),i.outputStream.once("error",n),r.once("error",n),r.once("finish",()=>s(t))})}e.zip=l;function $(t,c,s={},n){const i=new RegExp(s.sourcePath?`^${s.sourcePath}`:"");let r=f(t,!0);return s.overwrite&&(r=r.then(a=>A.Promises.rm(c).then(()=>a))),r.then(a=>w(a,c,{sourcePathRegex:i},n))}e.$ap=$;function b(t,c){return f(t).then(s=>new Promise((n,i)=>{s.on("entry",r=>{r.fileName===c&&o(s,r).then(a=>n(a),a=>i(a))}),s.once("close",()=>i(new Error(R.localize(2,null,c))))}))}function I(t,c){return b(t,c).then(s=>new Promise((n,i)=>{const r=[];s.once("error",i),s.on("data",a=>r.push(a)),s.on("end",()=>n(Buffer.concat(r)))}))}e.$bp=I}),define(re[262],oe([0,1,5,8,2,22,23,53,9,32,31,82,18,16,29,33,97,13,7]),function(te,e,L,N,O,j,A,R,k,m,P,p,g,h,d,w,f,o,l){"use strict";var $;Object.defineProperty(e,"__esModule",{value:!0}),e.$qp=void 0;let b=class extends O.$mb{static{$=this}static{this.c=".sigzip"}constructor(t,c,s,n,i,r){super(),this.h=c,this.i=s,this.j=n,this.k=i,this.l=r,this.extensionsDownloadDir=t.extensionsDownloadLocation,this.f=20,this.g=this.t()}async download(t,c,s){await this.g;const n=(0,A.$gg)(this.extensionsDownloadDir,this.u(t));try{await this.r(t,n,r=>this.i.download(t,r,c))}catch(r){throw new d.$Yn(r.message,d.ExtensionManagementErrorCode.Download)}let i=!1;if(s&&this.m(t)){const r=await this.n(t);try{i=await this.k.verify(n.fsPath,r.fsPath,this.l.getLevel()===l.LogLevel.Trace)}catch(a){const v=a;if(i=v.code,v.output&&this.l.trace(`Extension signature verification details for ${t.identifier.id} ${t.version}:
${v.output}`),i===d.ExtensionSignaturetErrorCode.PackageIsInvalidZip||i===d.ExtensionSignaturetErrorCode.SignatureArchiveIsInvalidZip)throw new d.$Yn(p.$0o,d.ExtensionManagementErrorCode.CorruptZip)}finally{try{await this.delete(r)}catch(a){this.l.error(a)}}}return i===!0?this.l.info(`Extension signature is verified: ${t.identifier.id}`):i===!1?this.l.info(`Extension signature verification is not done: ${t.identifier.id}`):this.l.warn(`Extension signature verification failed with error '${i}': ${t.identifier.id}`),{location:n,verificationStatus:i}}m(t){if(!t.isSigned)return!1;const c=this.j.getValue("extensions.verifySignature");return(0,k.$re)(c)?c:!0}async n(t){await this.g;const c=(0,A.$gg)(this.extensionsDownloadDir,`${this.u(t)}${$.c}`);return await this.r(t,c,s=>this.i.downloadSignatureArchive(t,s)),c}async r(t,c,s){if(await this.h.exists(c))return;if(c.scheme!==j.Schemas.file){await s(c);return}const n=(0,A.$gg)(this.extensionsDownloadDir,`.${(0,m.$6e)()}`);await this.h.exists(n)||await s(n);try{await P.Promises.rename(n.fsPath,c.fsPath,2*60*1e3)}catch(i){try{await this.h.del(n)}catch{}if(i.code==="ENOTEMPTY")this.l.info("Rename failed because the file was downloaded by another source. So ignoring renaming.",t.identifier.id,c.path);else throw this.l.info(`Rename failed because of ${(0,N.$8)(i)}. Deleted the file from downloaded location`,n.path),i}}async delete(t){await this.g,await this.h.del(t)}async t(){try{if(!await this.h.exists(this.extensionsDownloadDir)){this.l.trace("Extension VSIX downloads cache dir does not exist");return}const t=await this.h.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(t.children){const c=[],s=[],n=[];for(const a of t.children)if(a.name.endsWith($.c))n.push(a.resource);else{const v=w.$oo.parse(a.name);v&&s.push([v,a])}const i=(0,w.$to)(s,([a])=>a),r=[];for(const a of i)a.sort((v,y)=>R.rcompare(v[0].version,y[0].version)),c.push(...a.slice(1).map(v=>v[1].resource)),r.push(a[0][1]);r.sort((a,v)=>a.mtime-v.mtime),c.push(...r.slice(0,Math.max(0,r.length-this.f)).map(a=>a.resource)),c.push(...n),await L.Promises.settled(c.map(a=>(this.l.trace("Deleting from cache",a.path),this.h.del(a))))}}catch(t){this.l.error(t)}}u(t){return this.f?w.$oo.create(t).toString().toLowerCase():(0,m.$6e)()}};e.$qp=b,e.$qp=b=$=ye([X(0,h.$Hh),X(1,o.$4j),X(2,d.$Xn),X(3,g.$6h),X(4,f.$4o),X(5,l.$3i)],b)}),define(re[263],oe([0,1,82,156]),function(te,e,L,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sp=void 0;function O(j){return(0,L.$bp)(j,"extension/package.json").then(A=>{try{return JSON.parse(A.toString("utf8"))}catch{throw new Error((0,N.localize)(0,null))}})}e.$sp=O}),define(re[122],oe([0,1,5,14,26,38,8,3,51,2,35,22,15,23,53,9,11,32,31,82,155,96,16,242,29,33,50,79,262,243,263,211,222,67,13,4,7,24,21,27,17]),function(te,e,L,N,O,j,A,R,k,m,P,p,g,h,d,w,f,o,l,$,b,I,t,c,s,n,i,r,a,v,y,u,E,D,T,F,q,W,Z,Y,x){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yp=e.$xp=e.$wp=e.$vp=void 0,e.$vp=(0,F.$Ah)(s.$Zn);const G=".vsctmp";let Q=class extends c.$cp{constructor(K,U,S,C,z,M,J,_,ae,he,fe,le){super(K,U,fe,S,he,le),this.bb=z,this.cb=M,this.db=J,this.eb=ae,this.ab=new Map,this.nb=new P.$yi;const $e=this.B(_.createInstance(v.$rp));this.Y=this.B(_.createInstance(H,we=>$e.postUninstall(we))),this.Z=this.B(new u.$tp(le,ae,fe,this,this.y)),this.$=this.B(_.createInstance(a.$qp));const de=this.B(new E.$up(this,this.bb,le,M,fe,ae,S));this.B(de.onDidChangeExtensionsByAnotherSource(we=>this.mb(we))),this.ob()}getTargetPlatform(){return this.fb||(this.fb=(0,n.$yo)(this.eb,this.y)),this.fb}async zip(K){this.y.trace("ExtensionManagementService#zip",K.identifier.id);const U=await this.lb(K),S=await(0,$.zip)((0,h.$gg)(this.$.extensionsDownloadDir,(0,o.$6e)()).fsPath,U);return f.URI.file(S)}async unzip(K){return this.y.trace("ExtensionManagementService#unzip",K.toString()),(await this.install(K)).identifier}async getManifest(K){const{location:U,cleanup:S}=await this.hb(K),C=g.$_c(U.fsPath);try{return await(0,y.$sp)(C)}finally{await S()}}getInstalled(K,U=this.C.defaultProfile.extensionsResource){return this.Y.scanExtensions(K??null,U)}scanAllUserInstalledExtensions(){return this.Y.scanAllUserExtensions(!1)}scanInstalledExtensionAtLocation(K){return this.Y.scanUserExtensionAtLocation(K)}async install(K,U={}){this.y.trace("ExtensionManagementService#install",K.toString());const{location:S,cleanup:C}=await this.hb(K);try{const z=await(0,y.$sp)(g.$_c(S.fsPath)),M=(0,n.$so)(z.publisher,z.name);if(z.engines&&z.engines.vscode&&!(0,D.$Fo)(z.engines.vscode,this.z.version,this.z.date))throw new Error(b.localize(0,null,M,this.z.version));const _=(await this.D([{manifest:z,extension:S,options:U}])).find(({identifier:ae})=>(0,n.$no)(ae,{id:M}));if(_?.local)return _.local;throw _?.error?_.error:(0,c.$ep)(new Error(`Unknown error while installing extension ${M}`))}finally{await C()}}async installFromLocation(K,U){this.y.trace("ExtensionManagementService#installFromLocation",K.toString());const S=await this.Y.scanUserExtensionAtLocation(K);if(!S)throw new Error(`Cannot find a valid extension from the location ${K.toString()}`);return await this.qb([[S,void 0]],U),this.y.info("Successfully installed extension",S.identifier.id,U.toString()),S}async installExtensionsFromProfile(K,U,S){this.y.trace("ExtensionManagementService#installExtensionsFromProfile",K,U.toString(),S.toString());const C=(await this.Y.scanExtensions(1,U)).filter(z=>K.some(M=>(0,n.$no)(M,z.identifier)));if(C.length){const z=await Promise.all(C.map(M=>this.Y.scanMetadata(M,U)));await this.qb(C.map((M,J)=>[M,z[J]]),S),this.y.info("Successfully installed extensions",C.map(M=>M.identifier.id),S.toString())}return C}async updateMetadata(K,U,S=this.C.defaultProfile.extensionsResource){return this.y.trace("ExtensionManagementService#updateMetadata",K.identifier.id),U.isPreReleaseVersion&&(U.preRelease=!0),U.isMachineScoped=U.isMachineScoped||void 0,U.isBuiltin=U.isBuiltin||void 0,U.pinned=U.pinned||void 0,K=await this.Y.updateMetadata(K,U,S),this.Z.invalidate(S),this.s.fire(K),K}async reinstallFromGallery(K){if(this.y.trace("ExtensionManagementService#reinstallFromGallery",K.identifier.id),!this.u.isEnabled())throw new Error(b.localize(1,null));const U=await this.getTargetPlatform(),[S]=await this.u.getExtensions([{...K.identifier,preRelease:K.preRelease}],{targetPlatform:U,compatible:!0},O.CancellationToken.None);if(!S)throw new Error(b.localize(2,null));await this.Y.setUninstalled(K);try{await this.Y.removeUninstalledExtension(K)}catch(C){throw new Error(b.localize(3,null,(0,j.$ki)(C)))}return this.installFromGallery(S)}X(K,U,S,C){return this.Y.copyExtension(K,U,S,C)}copyExtensions(K,U){return this.Y.copyExtensions(K,U)}markAsUninstalled(...K){return this.Y.setUninstalled(...K)}async cleanUp(){this.y.trace("ExtensionManagementService#cleanUp");try{await this.Y.cleanUp()}catch(K){this.y.error(K)}}async download(K,U,S){const{location:C}=await this.$.download(K,U,!S);return C}async hb(K){if(K.scheme===p.Schemas.file)return{location:K,async cleanup(){}};this.y.trace("Downloading extension from",K.toString());const U=(0,h.$gg)(this.$.extensionsDownloadDir,(0,o.$6e)());return await this.db.download(K,U),this.y.info("Downloaded extension to",U.toString()),{location:U,cleanup:async()=>{try{await this.eb.del(U)}catch(C){this.y.error(C)}}}}S(){return this.C.defaultProfile.extensionsResource}U(K,U,S){if(f.URI.isUri(U))return new ee(K,U,S,this.u,this.Y,this.w,this.C,this.bb,this.cb,this.y);const C=n.$oo.create(U).toString();let z=this.ab.get(C);return z||(this.ab.set(C,z=new B(K,U,S,this.$,this.Y,this.w,this.C,this.bb,this.cb,this.y)),z.waitUntilTaskIsFinished().finally(()=>this.ab.delete(C))),z}W(K,U){return new ne(K,U.profileLocation,this.cb)}async lb(K){const U=async C=>{let z=await l.Promises.readdir(C);z=z.map(_=>g.$$c(C,_));const M=await Promise.all(z.map(_=>l.Promises.stat(_)));let J=Promise.resolve([]);return M.forEach((_,ae)=>{const he=z[ae];_.isFile()&&(J=J.then(fe=>[...fe,he])),_.isDirectory()&&(J=J.then(fe=>U(he).then(le=>[...fe,...le])))}),J};return(await U(K.location.fsPath)).map(C=>({path:`extension/${g.$ad(K.location.fsPath,C)}`,localPath:C}))}async mb({added:K,removed:U}){if(U)for(const S of U.extensions)this.y.info("Extensions removed from another source",S.id,U.profileLocation.toString()),this.p.fire({identifier:S,profileLocation:U.profileLocation});if(K){const C=(await this.Y.scanExtensions(1,K.profileLocation)).filter(z=>K.extensions.some(M=>(0,n.$no)(M,z.identifier)));this.m.fire(C.map(z=>(this.y.info("Extensions added from another source",z.identifier.id,K.profileLocation.toString()),{identifier:z.identifier,local:z,profileLocation:K.profileLocation,operation:1})))}}async ob(){this.B(this.Y.onExtract(U=>this.nb.add(U)));const K=await this.eb.resolve(this.bb.userExtensionsLocation);for(const U of K.children??[])U.isDirectory&&this.nb.add(U.resource);this.B(this.eb.watch(this.bb.userExtensionsLocation)),this.B(this.eb.onDidFilesChange(U=>this.pb(U)))}async pb(K){if(!K.affects(this.bb.userExtensionsLocation,1))return;const U=[];for(const S of K.rawAdded){if(this.nb.has(S)||!this.w.extUri.isEqual(this.w.extUri.dirname(S),this.bb.userExtensionsLocation)||this.w.extUri.isEqual(S,this.w.extUri.joinPath(this.bb.userExtensionsLocation,".obsolete"))||this.w.extUri.basename(S).startsWith(".")||!(await this.eb.stat(S)).isDirectory)continue;const C=await this.Y.scanUserExtensionAtLocation(S);C&&C.installedTimestamp===void 0&&(this.nb.add(S),U.push(C))}U.length&&(await this.qb(U.map(S=>[S,void 0]),this.C.defaultProfile.extensionsResource),this.y.info("Added extensions to default profile from external source",U.map(S=>S.identifier.id)))}async qb(K,U){const S=K.map(C=>C[0]);await this.rb(S),await this.cb.addExtensionsToProfile(K,U),this.m.fire(S.map(C=>({local:C,identifier:C.identifier,operation:1,profileLocation:U})))}async rb(K){const U=await this.Y.getUninstalledExtensions();for(const S of K){const C=n.$oo.create(S);U[C.toString()]&&(this.y.trace("Removing the extension from uninstalled list:",C.id),await this.Y.setInstalled(C),this.y.info("Removed the extension from uninstalled list:",C.id))}}};e.$wp=Q,e.$wp=Q=ye([X(0,s.$Xn),X(1,Z.$7k),X(2,q.$3i),X(3,t.$Hh),X(4,r.$lp),X(5,i.$hp),X(6,I.$Bn),X(7,F.$yh),X(8,T.$4j),X(9,W.$ij),X(10,Y.$Ak),X(11,x.$Ck)],Q);let H=class extends m.$mb{constructor(K,U,S,C,z,M){super(),this.j=K,this.k=U,this.l=S,this.m=C,this.n=z,this.p=M,this.h=this.B(new R.$hc),this.onExtract=this.h.event,this.c=(0,h.$gg)(this.l.userExtensionsLocation,".obsolete"),this.g=new L.$Lg}async cleanUp(){await this.C(),await this.z()}async scanExtensions(K,U){const S={includeInvalid:!0,profileLocation:U};let C=[];return K===null||K===0?C.push(...await this.l.scanAllExtensions({includeInvalid:!0},S,!1)):K===1&&C.push(...await this.l.scanUserExtensions(S)),C=K!==null?C.filter(z=>z.type===K):C,Promise.all(C.map(z=>this.y(z)))}async scanAllUserExtensions(K){const U=await this.l.scanUserExtensions({includeAllVersions:!K,includeInvalid:!0});return Promise.all(U.map(S=>this.y(S)))}async scanUserExtensionAtLocation(K){try{const U=await this.l.scanExistingExtension(K,1,{includeInvalid:!0});if(U)return await this.y(U)}catch(U){this.p.error(U)}return null}async extractUserExtension(K,U,S,C,z){const M=K.toString(),J=f.URI.file(g.$$c(this.l.userExtensionsLocation.fsPath,`.${(0,o.$6e)()}`)),_=f.URI.file(g.$$c(this.l.userExtensionsLocation.fsPath,M));let ae=await this.k.exists(_);if(ae&&C){try{await this.t(K.id,_,"removeExisting")}catch{throw new s.$Yn(b.localize(4,null,_.fsPath,K.id),s.ExtensionManagementErrorCode.Delete)}ae=!1}if(!ae)try{try{this.p.trace(`Started extracting the extension from ${U} to ${_.fsPath}`),await(0,$.$ap)(U,J.fsPath,{sourcePath:"extension",overwrite:!0},z),this.p.info(`Extracted extension to ${_}:`,K.id)}catch(he){let fe=s.ExtensionManagementErrorCode.Extract;throw he instanceof $.$$o&&(he.type==="CorruptZip"?fe=s.ExtensionManagementErrorCode.CorruptZip:he.type==="Incomplete"&&(fe=s.ExtensionManagementErrorCode.IncompleteZip)),new s.$Yn(he.message,fe)}await this.l.updateMetadata(J,S);try{this.p.trace(`Started renaming the extension from ${J.fsPath} to ${_.fsPath}`),await this.v(J.fsPath,_.fsPath),this.p.info("Renamed to",_.fsPath)}catch(he){if(he.code==="ENOTEMPTY")this.p.info("Rename failed because extension was installed by another source. So ignoring renaming.",K.id);else throw this.p.info(`Rename failed because of ${(0,A.$8)(he)}. Deleted from extracted location`,J),he}this.h.fire(_)}catch(he){try{await this.k.del(J,{recursive:!0})}catch{}throw he}return this.w(_,1)}async scanMetadata(K,U){return U?(await this.s(K,U))?.metadata:this.l.scanMetadata(K.location)}async s(K,U){return(await this.m.scanProfileExtensions(U)).find(C=>(0,n.$no)(C.identifier,K.identifier))}async updateMetadata(K,U,S){return S?await this.m.updateMetadata([[K,U]],S):await this.l.updateMetadata(K.location,U),this.w(K.location,K.type,S)}getUninstalledExtensions(){return this.u()}async setUninstalled(...K){const U=K.map(S=>n.$oo.create(S));await this.u(S=>U.forEach(C=>{S[C.toString()]=!0,this.p.info("Marked extension as uninstalled",C.toString())}))}async setInstalled(K){await this.u(U=>delete U[K.toString()])}async removeExtension(K,U){if(this.n.extUri.isEqualOrParent(K.location,this.l.userExtensionsLocation))return this.t(K.identifier.id,K.location,U)}async removeUninstalledExtension(K){await this.removeExtension(K,"uninstalled"),await this.u(U=>delete U[n.$oo.create(K).toString()])}async copyExtension(K,U,S,C){const z=await this.s(K,U),M=await this.s(K,S);return C={...z?.metadata,...C},M?await this.m.updateMetadata([[K,{...M.metadata,...C}]],S):await this.m.addExtensionsToProfile([[K,C]],S),this.w(K.location,K.type,S)}async copyExtensions(K,U){const S=await this.scanExtensions(1,K),C=await Promise.all(S.filter(z=>!z.isApplicationScoped).map(async z=>[z,await this.scanMetadata(z,K)]));await this.m.addExtensionsToProfile(C,U)}async t(K,U,S){this.p.trace(`Deleting ${S} extension from disk`,K,U.fsPath);const C=this.n.extUri.joinPath(this.n.extUri.dirname(U),`${this.n.extUri.basename(U)}.${(0,k.$ni)((0,o.$6e)()).toString(16)}${G}`);await this.v(U.fsPath,C.fsPath),await this.k.del(C,{recursive:!0}),this.p.info(`Deleted ${S} extension from disk`,K,U.fsPath)}async u(K){return this.g.queue(async()=>{let U;try{U=(await this.k.readFile(this.c,"utf8")).value.toString()}catch(C){if((0,T.$hk)(C)!==1)throw C}let S={};if(U)try{S=JSON.parse(U)}catch{}return K&&(K(S),Object.keys(S).length?await this.k.writeFile(this.c,N.$Hc.fromString(JSON.stringify(S))):await this.k.del(this.c)),S})}async v(K,U){try{await l.Promises.rename(K,U,2*60*1e3)}catch(S){throw new s.$Yn(S.message||b.localize(5,null,K,U),S.code||s.ExtensionManagementErrorCode.Rename)}}async w(K,U,S){if(S){const z=(await this.l.scanUserExtensions({profileLocation:S})).find(M=>this.n.extUri.isEqual(M.location,K));if(z)return this.y(z)}else{const C=await this.l.scanExistingExtension(K,U,{includeInvalid:!0});if(C)return this.y(C)}throw new Error(b.localize(6,null,K.path))}async y(K){const U=await this.k.resolve(K.location);let S,C;return U.children&&(S=U.children.find(({name:z})=>/^readme(\.txt|\.md|)$/i.test(z))?.resource,C=U.children.find(({name:z})=>/^changelog(\.txt|\.md|)$/i.test(z))?.resource),{identifier:K.identifier,type:K.type,isBuiltin:K.isBuiltin||!!K.metadata?.isBuiltin,location:K.location,manifest:K.manifest,targetPlatform:K.targetPlatform,validations:K.validations,isValid:K.isValid,readmeUrl:S,changelogUrl:C,publisherDisplayName:K.metadata?.publisherDisplayName||null,publisherId:K.metadata?.publisherId||null,isApplicationScoped:!!K.metadata?.isApplicationScoped,isMachineScoped:!!K.metadata?.isMachineScoped,isPreReleaseVersion:!!K.metadata?.isPreReleaseVersion,preRelease:!!K.metadata?.preRelease,installedTimestamp:K.metadata?.installedTimestamp,updated:!!K.metadata?.updated,pinned:!!K.metadata?.pinned}}async z(){const K=await this.getUninstalledExtensions();if(Object.keys(K).length===0){this.p.debug("No uninstalled extensions found.");return}this.p.debug("Removing uninstalled extensions:",Object.keys(K));const U=await this.l.scanUserExtensions({includeAllVersions:!0,includeUninstalled:!0,includeInvalid:!0}),S=new Set;for(const z of U)K[n.$oo.create(z).toString()]||S.add(z.identifier.id.toLowerCase());try{const z=(0,n.$to)(U,M=>M.identifier);await L.Promises.settled(z.map(async M=>{const J=M.sort((_,ae)=>d.rcompare(_.manifest.version,ae.manifest.version))[0];S.has(J.identifier.id.toLowerCase())||await this.j(await this.y(J))}))}catch(z){this.p.error(z)}const C=U.filter(z=>z.metadata&&K[n.$oo.create(z).toString()]);await Promise.allSettled(C.map(z=>this.removeUninstalledExtension(z)))}async C(){this.p.trace("ExtensionManagementService#removeTempDeleteFolders");let K;try{K=await this.k.resolve(this.l.userExtensionsLocation)}catch(U){(0,T.$hk)(U)!==1&&this.p.error(U);return}if(K?.children)try{await Promise.allSettled(K.children.map(async U=>{if(!(!U.isDirectory||!U.name.endsWith(G))){this.p.trace("Deleting the temporarily deleted folder",U.resource.toString());try{await this.k.del(U.resource,{recursive:!0}),this.p.trace("Deleted the temporarily deleted folder",U.resource.toString())}catch(S){(0,T.$hk)(S)!==1&&this.p.error(S)}}}))}catch{}}};e.$xp=H,e.$xp=H=ye([X(1,T.$4j),X(2,r.$lp),X(3,i.$hp),X(4,Y.$Ak),X(5,q.$3i)],H);class V extends c.$fp{get profileLocation(){return this.j}get verificationStatus(){return this.k}get operation(){return(0,w.$se)(this.options.operation)?this.l:this.options.operation}constructor(K,U,S,C,z,M,J,_,ae){super(),this.identifier=K,this.source=U,this.options=S,this.m=C,this.n=z,this.o=M,this.p=J,this.q=_,this.s=ae,this.j=this.options.profileLocation,this.k=!1,this.l=2}async h(K){const[U,S]=await this.x(K);return this.j=U.isBuiltin||U.isApplicationScoped?this.o.defaultProfile.extensionsResource:this.options.profileLocation,this.n.extUri.isEqual(this.o.defaultProfile.extensionsResource,this.j)&&await this.p.initializeDefaultProfileExtensions(),await this.q.addExtensionsToProfile([[U,S]],this.j),U}async u({zipPath:K,key:U,metadata:S},C,z){let M=await this.v(U);return M||(this.s.trace("Extracting extension...",U.id),M=await this.m.extractUserExtension(U,K,S,C,z),this.s.info("Extracting extension completed.",U.id)),M}async v(K){return await this.w(K)?(this.s.trace("Removing the extension from uninstalled list:",K.id),await this.m.setInstalled(K),this.s.info("Removed the extension from uninstalled list:",K.id),(await this.m.scanAllUserExtensions(!0)).find(C=>n.$oo.create(C).equals(K))):void 0}async w(K){return!!(await this.m.getUninstalledExtensions())[K.toString()]}}class B extends V{constructor(K,U,S,C,z,M,J,_,ae,he){super(U.identifier,U,S,z,M,J,_,ae,he),this.y=U,this.z=C}async x(K){const S=(await this.m.scanExtensions(null,this.options.profileLocation)).find(J=>(0,n.$no)(J.identifier,this.y.identifier));S&&(this.l=3);const C={id:this.y.identifier.uuid,publisherId:this.y.publisherId,publisherDisplayName:this.y.publisherDisplayName,targetPlatform:this.y.properties.targetPlatform,isApplicationScoped:this.options.isApplicationScoped||S?.isApplicationScoped,isMachineScoped:this.options.isMachineScoped||S?.isMachineScoped,isBuiltin:this.options.isBuiltin||S?.isBuiltin,isSystem:S?.type===0?!0:void 0,updated:!!S,isPreReleaseVersion:this.y.properties.isPreReleaseVersion,installedTimestamp:Date.now(),pinned:this.options.installGivenVersion?!0:void 0,preRelease:this.y.properties.isPreReleaseVersion||((0,w.$re)(this.options.installPreReleaseVersion)?this.options.installPreReleaseVersion:S?.preRelease)};if(S?.manifest.version===this.y.version)return[await this.m.updateMetadata(S,C),C];const{location:z,verificationStatus:M}=await this.z.download(this.y,this.l,!this.options.donotVerifySignature);try{return this.k=M,this.B(z.fsPath),[await this.u({zipPath:z.fsPath,key:n.$oo.create(this.y),metadata:C},!1,K),C]}catch(J){try{await this.z.delete(z)}catch(_){this.s.warn("Error while deleting the downloaded file",z.toString(),(0,A.$8)(_))}throw J}}async B(K){try{await(0,y.$sp)(K)}catch(U){throw new s.$Yn((0,c.$dp)(U).message,s.ExtensionManagementErrorCode.Invalid)}}}e.$yp=B;class ee extends V{constructor(K,U,S,C,z,M,J,_,ae,he){super({id:(0,n.$so)(K.publisher,K.name)},U,S,z,M,J,_,ae,he),this.y=K,this.z=U,this.A=C}async h(K){const U=await super.h(K);return this.D(U,K),U}async x(K){const U=new n.$oo(this.identifier,this.y.version),C=(await this.m.scanExtensions(1,this.options.profileLocation)).find(J=>(0,n.$no)(this.identifier,J.identifier)),z={isApplicationScoped:this.options.isApplicationScoped||C?.isApplicationScoped,isMachineScoped:this.options.isMachineScoped||C?.isMachineScoped,isBuiltin:this.options.isBuiltin||C?.isBuiltin,installedTimestamp:Date.now(),pinned:this.options.installGivenVersion?!0:void 0};if(C)if(this.l=3,U.equals(new n.$oo(C.identifier,C.manifest.version)))try{await this.m.removeExtension(C,"existing")}catch{throw new Error(b.localize(7,null,this.y.displayName||this.y.name))}else!this.options.profileLocation&&d.gt(C.manifest.version,this.y.version)&&await this.m.setUninstalled(C);else{const J=await this.v(U);if(J)try{await this.m.removeExtension(J,"existing")}catch{throw new Error(b.localize(8,null,this.y.displayName||this.y.name))}}return[await this.u({zipPath:g.$_c(this.z.fsPath),key:U,metadata:z},!0,K),z]}async D(K,U){try{let[S]=await this.A.getExtensions([{id:K.identifier.id,version:K.manifest.version}],U);if(S||([S]=await this.A.getExtensions([{id:K.identifier.id}],U)),S){const C={id:S.identifier.uuid,publisherDisplayName:S.publisherDisplayName,publisherId:S.publisherId,isPreReleaseVersion:S.properties.isPreReleaseVersion,preRelease:S.properties.isPreReleaseVersion||this.options.installPreReleaseVersion};await this.m.updateMetadata(K,C,this.options.profileLocation)}}catch{}}}class ne extends c.$fp{constructor(K,U,S){super(),this.extension=K,this.j=U,this.k=S}async h(K){await this.k.removeExtensionFromProfile(this.extension,this.j)}}}),define(re[264],oe([0,1,2,29,80,221,122,7,19]),function(te,e,L,N,O,j,A,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$D7b=void 0;let m=class extends L.$mb{constructor(p,g,h,d,w,f){super(),p.cleanUp(),(0,j.$rUb)(p,g,h,d,f),O.$Qz.removeOutdatedExtensionVersions(p,w)}};e.$D7b=m,e.$D7b=m=ye([X(0,A.$vp),X(1,N.$Xn),X(2,O.$Pz),X(3,N.$3n),X(4,k.$So),X(5,R.$3i)],m)}),define(re[123],oe([0,1,69,61,36,274,14,8,3,2,15,6,32,43,65]),function(te,e,L,N,O,j,A,R,k,m,P,p,g,h,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vh=e.$uh=e.$th=e.$sh=e.$rh=e.$qh=e.$ph=e.$oh=void 0;class w{traceSocketEvent(u,E){d.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,u,E)}constructor(u,E=""){this.f=!0,this.debugLabel=E,this.socket=u,this.traceSocketEvent("created",{type:"NodeSocket"}),this.a=D=>{if(this.traceSocketEvent("error",{code:D?.code,message:D?.message}),D){if(D.code==="EPIPE")return;(0,R.$Y)(D)}},this.socket.on("error",this.a),this.b=D=>{this.traceSocketEvent("close",{hadError:D}),this.f=!1},this.socket.on("close",this.b),this.d=()=>{this.traceSocketEvent("nodeEndReceived"),this.f=!1},this.socket.on("end",this.d)}dispose(){this.socket.off("error",this.a),this.socket.off("close",this.b),this.socket.off("end",this.d),this.socket.destroy()}onData(u){const E=D=>{this.traceSocketEvent("read",D),u(A.$Hc.wrap(D))};return this.socket.on("data",E),{dispose:()=>this.socket.off("data",E)}}onClose(u){const E=D=>{u({type:0,hadError:D,error:void 0})};return this.socket.on("close",E),{dispose:()=>this.socket.off("close",E)}}onEnd(u){const E=()=>{u()};return this.socket.on("end",E),{dispose:()=>this.socket.off("end",E)}}write(u){if(!(this.socket.destroyed||!this.f))try{this.traceSocketEvent("write",u),this.socket.write(u.buffer,E=>{if(E){if(E.code==="EPIPE")return;(0,R.$Y)(E)}})}catch(E){if(E.code==="EPIPE")return;(0,R.$Y)(E)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((u,E)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),u();return}const D=()=>{this.socket.off("close",D),this.socket.off("end",D),this.socket.off("error",D),this.socket.off("timeout",D),this.socket.off("drain",D),this.traceSocketEvent("nodeDrainEnd"),u()};this.socket.on("close",D),this.socket.on("end",D),this.socket.on("error",D),this.socket.on("timeout",D),this.socket.on("drain",D)})}}e.$oh=w;var f;(function(y){y[y.MinHeaderByteSize=2]="MinHeaderByteSize",y[y.MaxWebSocketMessageLength=262144]="MaxWebSocketMessageLength"})(f||(f={}));var o;(function(y){y[y.PeekHeader=1]="PeekHeader",y[y.ReadHeader=2]="ReadHeader",y[y.ReadBody=3]="ReadBody",y[y.Fin=4]="Fin"})(o||(o={}));class l extends m.$mb{get permessageDeflate(){return this.a.permessageDeflate}get recordedInflateBytes(){return this.a.recordedInflateBytes}traceSocketEvent(u,E){this.socket.traceSocketEvent(u,E)}constructor(u,E,D,T){super(),this.f=this.B(new k.$hc),this.g=this.B(new k.$hc),this.h=!1,this.j={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0},this.socket=u,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:E,inflateBytesLength:D?.byteLength||0,recordInflateBytes:T}),this.a=this.B(new $(this,E,D,T,this.f,(F,q)=>this.k(F,q))),this.B(this.a.onError(F=>{console.error(F),(0,R.$Y)(F),this.g.fire({type:0,hadError:!0,error:F})})),this.b=new d.$jh,this.B(this.socket.onData(F=>this.l(F))),this.B(this.socket.onClose(async F=>{this.a.isProcessingReadQueue()&&await k.Event.toPromise(this.a.onDidFinishProcessingReadQueue),this.g.fire(F)}))}dispose(){this.a.isProcessingWriteQueue()?this.B(this.a.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(u){return this.f.event(u)}onClose(u){return this.g.event(u)}onEnd(u){return this.socket.onEnd(u)}write(u){let E=0;for(;E<u.byteLength;)this.a.writeMessage(u.slice(E,Math.min(E+262144,u.byteLength))),E+=262144}k(u,E){if(this.h)return;this.traceSocketEvent("webSocketNodeSocketWrite",u);let D=2;u.byteLength<126?D+=0:u.byteLength<2**16?D+=2:D+=8;const T=A.$Hc.alloc(D);if(E?T.writeUInt8(194,0):T.writeUInt8(130,0),u.byteLength<126)T.writeUInt8(u.byteLength,1);else if(u.byteLength<2**16){T.writeUInt8(126,1);let F=1;T.writeUInt8(u.byteLength>>>8&255,++F),T.writeUInt8(u.byteLength>>>0&255,++F)}else{T.writeUInt8(127,1);let F=1;T.writeUInt8(0,++F),T.writeUInt8(0,++F),T.writeUInt8(0,++F),T.writeUInt8(0,++F),T.writeUInt8(u.byteLength>>>24&255,++F),T.writeUInt8(u.byteLength>>>16&255,++F),T.writeUInt8(u.byteLength>>>8&255,++F),T.writeUInt8(u.byteLength>>>0&255,++F)}this.socket.write(A.$Hc.concat([T,u]))}end(){this.h=!0,this.socket.end()}l(u){if(u.byteLength!==0){for(this.b.acceptChunk(u);this.b.byteLength>=this.j.readLen;)if(this.j.state===1){const E=this.b.peek(this.j.readLen),D=E.readUInt8(0),T=(D&128)>>>7,F=(D&64)>>>6,q=E.readUInt8(1),W=(q&128)>>>7,Z=q&127;this.j.state=2,this.j.readLen=2+(W?4:0)+(Z===126?2:0)+(Z===127?8:0),this.j.fin=T,this.j.firstFrameOfMessage&&(this.j.compressed=!!F),this.j.firstFrameOfMessage=!!T,this.j.mask=0,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin})}else if(this.j.state===2){const E=this.b.read(this.j.readLen),D=E.readUInt8(1),T=(D&128)>>>7;let F=D&127,q=1;F===126?F=E.readUInt8(++q)*2**8+E.readUInt8(++q):F===127&&(F=E.readUInt8(++q)*0+E.readUInt8(++q)*0+E.readUInt8(++q)*0+E.readUInt8(++q)*0+E.readUInt8(++q)*2**24+E.readUInt8(++q)*2**16+E.readUInt8(++q)*2**8+E.readUInt8(++q));let W=0;T&&(W=E.readUInt8(++q)*2**24+E.readUInt8(++q)*2**16+E.readUInt8(++q)*2**8+E.readUInt8(++q)),this.j.state=3,this.j.readLen=F,this.j.mask=W,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,mask:this.j.mask})}else if(this.j.state===3){const E=this.b.read(this.j.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",E),t(E,this.j.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",E),this.j.state=1,this.j.readLen=2,this.j.mask=0,this.a.acceptFrame(E,this.j.compressed,!!this.j.fin)}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this.a.isProcessingWriteQueue()&&await k.Event.toPromise(this.a.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.$ph=l;class $ extends m.$mb{get permessageDeflate(){return!!(this.b&&this.f)}get recordedInflateBytes(){return this.b?this.b.recordedInflateBytes:A.$Hc.alloc(0)}constructor(u,E,D,T,F,q){super(),this.l=u,this.m=F,this.n=q,this.a=this.B(new k.$hc),this.onError=this.a.event,this.g=[],this.h=[],this.j=this.B(new k.$hc),this.onDidFinishProcessingReadQueue=this.j.event,this.k=this.B(new k.$hc),this.onDidFinishProcessingWriteQueue=this.k.event,this.p=!1,this.t=!1,E?(this.b=this.B(new b(this.l,T,D,{windowBits:15})),this.f=this.B(new I(this.l,{windowBits:15})),this.B(this.b.onError(W=>this.a.fire(W))),this.B(this.f.onError(W=>this.a.fire(W)))):(this.b=null,this.f=null)}writeMessage(u){this.g.push(u),this.r()}async r(){if(!this.p){for(this.p=!0;this.g.length>0;){const u=this.g.shift();if(this.f){const E=await this.s(this.f,u);this.n(E,!0)}else this.n(u,!1)}this.p=!1,this.k.fire()}}isProcessingWriteQueue(){return this.p}s(u,E){return new Promise((D,T)=>{u.write(E),u.flush(F=>D(F))})}acceptFrame(u,E,D){this.h.push({data:u,isCompressed:E,isLastFrameOfMessage:D}),this.u()}async u(){if(!this.t){for(this.t=!0;this.h.length>0;){const u=this.h.shift();if(this.b&&u.isCompressed){const E=await this.w(this.b,u.data,u.isLastFrameOfMessage);this.m.fire(E)}else this.m.fire(u.data)}this.t=!1,this.j.fire()}}isProcessingReadQueue(){return this.t}w(u,E,D){return new Promise((T,F)=>{u.write(E),D&&u.write(A.$Hc.fromByteArray([0,0,255,255])),u.flush(q=>T(q))})}}class b extends m.$mb{get recordedInflateBytes(){return this.j?A.$Hc.concat(this.f):A.$Hc.alloc(0)}constructor(u,E,D,T){super(),this.h=u,this.j=E,this.a=this.B(new k.$hc),this.onError=this.a.event,this.f=[],this.g=[],this.b=(0,j.createInflateRaw)(T),this.b.on("error",F=>{this.h.traceSocketEvent("zlibInflateError",{message:F?.message,code:F?.code}),this.a.fire(F)}),this.b.on("data",F=>{this.h.traceSocketEvent("zlibInflateData",F),this.g.push(A.$Hc.wrap(F))}),D&&(this.h.traceSocketEvent("zlibInflateInitialWrite",D.buffer),this.b.write(D.buffer),this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateInitialFlushFired"),this.g.length=0}))}write(u){this.j&&this.f.push(u.clone()),this.h.traceSocketEvent("zlibInflateWrite",u),this.b.write(u.buffer)}flush(u){this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateFlushFired");const E=A.$Hc.concat(this.g);this.g.length=0,u(E)})}}class I extends m.$mb{constructor(u,E){super(),this.g=u,this.a=this.B(new k.$hc),this.onError=this.a.event,this.f=[],this.b=(0,j.createDeflateRaw)({windowBits:15}),this.b.on("error",D=>{this.g.traceSocketEvent("zlibDeflateError",{message:D?.message,code:D?.code}),this.a.fire(D)}),this.b.on("data",D=>{this.g.traceSocketEvent("zlibDeflateData",D),this.f.push(A.$Hc.wrap(D))})}write(u){this.g.traceSocketEvent("zlibDeflateWrite",u.buffer),this.b.write(u.buffer)}flush(u){this.b.flush(2,()=>{this.g.traceSocketEvent("zlibDeflateFlushFired");let E=A.$Hc.concat(this.f);this.f.length=0,E=E.slice(0,E.byteLength-4),u(E)})}}function t(y,u){if(u===0)return;const E=y.byteLength>>>2;for(let Z=0;Z<E;Z++){const Y=y.readUInt32BE(Z*4);y.writeUInt32BE(Y^u,Z*4)}const D=E*4,T=y.byteLength-D,F=u>>>24&255,q=u>>>16&255,W=u>>>8&255;T>=1&&y.writeUInt8(y.readUInt8(D)^F,D),T>=2&&y.writeUInt8(y.readUInt8(D+1)^q,D+1),T>=3&&y.writeUInt8(y.readUInt8(D+2)^W,D+2)}e.$qh=process.env.XDG_RUNTIME_DIR;const c={[2]:107,[1]:103};function s(){const y=(0,g.$6e)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${y}-sock`;const u=process.platform!=="darwin"&&e.$qh?e.$qh:(0,O.tmpdir)(),E=(0,P.$$c)(u,`vscode-ipc-${y}.sock`);return i(E),E}e.$rh=s;function n(y,u,E){const D=(0,L.createHash)("md5").update(y).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${D}-${E}-${u}-sock`;const T=E.substr(0,4),F=u.substr(0,6),q=D.substr(0,8);let W;return process.platform!=="darwin"&&e.$qh&&!process.env.VSCODE_PORTABLE?W=(0,P.$$c)(e.$qh,`vscode-${q}-${T}-${F}.sock`):W=(0,P.$$c)(y,`${T}-${F}.sock`),i(W),W}e.$sh=n;function i(y){const u=c[p.$t];typeof u=="number"&&y.length>=u&&console.warn(`WARNING: IPC handle "${y}" is longer than ${u} chars, try a shorter --user-data-dir`)}class r extends h.$dh{static b(u){const E=k.Event.fromNodeEventEmitter(u,"connection");return k.Event.map(E,D=>({protocol:new d.$kh(new w(D,"ipc-server-connection")),onDidClientDisconnect:k.Event.once(k.Event.fromNodeEventEmitter(D,"close"))}))}constructor(u){super(r.b(u)),this.d=u}dispose(){super.dispose(),this.d&&(this.d.close(),this.d=null)}}e.$th=r;function a(y){return new Promise((u,E)=>{const D=(0,N.createServer)();D.on("error",E),D.listen(y,()=>{D.removeListener("error",E),u(new r(D))})})}e.$uh=a;function v(y,u){return new Promise((E,D)=>{const T=(0,N.createConnection)(y,()=>{T.removeListener("error",D),E(d.$lh.fromSocket(new w(T,`ipc-client${u}`),u))});T.once("error",D)})}e.$vh=v}),define(re[265],oe([0,1,61,123,209]),function(te,e,L,N,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$M7b=void 0,e.$M7b=new class{supports(j){return!0}connect({host:j,port:A},R,k,m){return new Promise((P,p)=>{const g=L.createConnection({host:j,port:A},()=>{g.removeListener("error",p),g.write((0,O.$akb)(R,k,m));const h=d=>{d.toString().indexOf(`\r
\r
`)>=0&&(g.off("data",h),P(new N.$oh(g,m)))};g.on("data",h)});g.setNoDelay(!0),g.once("error",p)})}}}),define(re[266],oe([0,1,61,36,133,123,5,2,6,18,7,24,212,104,106,76,14]),function(te,e,L,N,O,j,A,R,k,m,P,p,g,h,d,w,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$I6b=e.$H6b=e.$G6b=e.$F6b=void 0;async function o(t,c,s,n,i){let r;for(let a=3;a&&(r?.dispose(),r=await new l(t,c,s,n,i).waitForReady(),!(i&&O.$9e[i]||!O.$9e[r.tunnelLocalPort]));a--);return r}class l extends R.$mb{constructor(c,s,n,i,r){super(),this.j=s,this.k=r,this.privacy=w.TunnelPrivacyId.Private,this.i=new Map,this.a=c,this.b=L.createServer(),this.c=new A.$Dg,this.f=()=>this.c.open(),this.b.on("listening",this.f),this.g=a=>this.l(a),this.b.on("connection",this.g),this.h=()=>{},this.b.on("error",this.h),this.tunnelRemotePort=i,this.tunnelRemoteHost=n}async dispose(){super.dispose(),this.b.removeListener("listening",this.f),this.b.removeListener("connection",this.g),this.b.removeListener("error",this.h),this.b.close(),Array.from(this.i.values()).forEach(s=>{s()})}async waitForReady(){const c=this.k??this.tunnelRemotePort,s=(0,w.$Zz)(this.j)?"0.0.0.0":"127.0.0.1";let n=await(0,O.$0e)(c,2,1e3,s),i=null;return this.b.listen(n,this.j),await this.c.wait(),i=this.b.address(),i||(n=0,this.b.listen(n,this.j),await this.c.wait(),i=this.b.address()),this.tunnelLocalPort=i.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${i.port}`,this}async l(c){c.pause();const s=(0,w.$Xz)(this.tunnelRemoteHost)||(0,w.$Zz)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,n=await(0,g.$Xk)(this.a,s,this.tunnelRemotePort),i=n.getSocket(),r=n.readEntireBuffer();n.dispose(),r.byteLength>0&&c.write(r.buffer),c.on("end",()=>{c.localAddress&&this.i.delete(c.localAddress),i.end()}),c.on("close",()=>i.end()),c.on("error",()=>{c.localAddress&&this.i.delete(c.localAddress),i instanceof j.$oh?i.socket.destroy():i.end()}),i instanceof j.$oh?this.n(c,i):this.m(c,i),c.localAddress&&this.i.set(c.localAddress,()=>{c.end(),i.end()})}m(c,s){s.onClose(()=>c.destroy()),s.onEnd(()=>c.end()),s.onData(n=>c.write(n.buffer)),c.on("data",n=>s.write(f.$Hc.wrap(n))),c.resume()}n(c,s){const n=s.socket;n.on("end",()=>c.end()),n.on("close",()=>c.end()),n.on("error",()=>{c.destroy()}),n.pipe(c),c.pipe(n)}}e.$F6b=l;let $=class extends w.$3z{constructor(c,s,n,i,r){super(s,r),this.u=c,this.v=n,this.w=i}isPortPrivileged(c){return(0,w.$1z)(c,this.l,k.OS,N.release())}s(c,s,n,i,r,a,v,y){const u=this.r(s,n);if(u)return++u.refcount,u.value;if((0,w.$Uz)(c))return this.t(c,s,n,r,a,v,y);{this.j.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${s}:${n} on local port ${r}.`);const E={commit:this.w.commit,quality:this.w.quality,addressProvider:c,remoteSocketFactoryService:this.u,signService:this.v,logService:this.j,ipcLogger:null},D=o(E,i,s,n,r);return this.j.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.p(s,n,D),D}}};e.$G6b=$,e.$G6b=$=ye([X(0,h.$Rk),X(1,P.$3i),X(2,d.$Uk),X(3,p.$ij),X(4,m.$6h)],$);let b=class extends ${constructor(c,s,n,i,r){super(c,s,n,i,r)}};e.$H6b=b,e.$H6b=b=ye([X(0,h.$Rk),X(1,P.$3i),X(2,d.$Uk),X(3,p.$ij),X(4,m.$6h)],b);let I=class extends R.$mb{constructor(c,s,n,i,r){super(),this.b=c,this.c=s,this.f=n,this.g=i,this.h=r,this.a=new Map}async openTunnel(c,s,n,i,r,a,v,y,u){if(this.c.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${n}:${i} on local port ${a}.`),!this.a.has(c)){const E=new b(this.b,this.c,this.g,this.f,this.h);this.B(E),this.a.set(c,E),E.onTunnelClosed(async()=>{(await E.tunnels).length===0&&(E.dispose(),this.a.delete(c))})}return this.a.get(c).openTunnel(s,n,i,r,a,v,y,u)}};e.$I6b=I,e.$I6b=I=ye([X(0,h.$Rk),X(1,P.$3i),X(2,p.$ij),X(3,d.$Uk),X(4,m.$6h)],I)}),define(re[275],oe([0,1,36,38,8,2,22,11,20,3,43,146,203,204,195,196,261,186,188,18,208,95,219,96,214,16,114,246,29,97,187,122,98,13,198,199,68,4,194,70,72,224,7,200,102,24,57,19,107,21,108,109,110,46,227,80,111,25,78,252,237,238,81,253,256,257,258,58,251,240,106,218,76,266,213,228,27,229,6,230,189,206,205,79,245,17,50,202,56,250,226,241,105,255,264,10,201,101,248,244,215,183,55,259,247,71,249,104,265,181,112,239,216]),function(te,e,L,N,O,j,A,R,k,m,P,p,g,h,d,w,f,o,l,$,b,I,t,c,s,n,i,r,a,v,y,u,E,D,T,F,q,W,Z,Y,x,G,Q,H,V,B,ee,ne,se,K,U,S,C,z,M,J,_,ae,he,fe,le,$e,de,we,ke,Ie,je,Ue,ce,ge,be,Se,Pe,Me,Ae,Fe,ze,ie,ue,me,pe,Ee,Re,Ce,Le,Oe,De,Ne,Be,qe,Ve,xe,ht,pt,vt,Et,kt,ut,St,Ct,Pt,Rt,It,Lt,At,ft,Ot,dt,jt,Dt,gt,Nt,tt){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.main=void 0;class zt extends j.$mb{constructor(ve){super(),this.f=ve,this.a=this.B(new p.$US(this)),this.b=void 0,this.c=this.B(new m.$hc),this.g()}g(){let ve=!1;const Te=()=>{ve||(ve=!0,this.b?.fireOnWillShutdown(),this.dispose())};process.once("exit",Te),(0,p.$VS)(process.parentPort,tt.$W5b.exit,Te)}async init(){const ve=await this.h();(0,ae.$agb)(),ve.invokeFunction(Te=>{const Ke=Te.get(Q.$3i);Ke.trace("sharedProcess configuration",JSON.stringify(this.f)),this.i(Te),this.j(Ke)}),this.B((0,j.$jb)(ve.createInstance(g.$_6b,this.f.codeCachePath),ve.createInstance(h.$a7b),ve.createInstance(f.$d7b),ve.createInstance(w.$c7b),ve.createInstance(d.$b7b),ve.createInstance(vt.$D7b),ve.createInstance(xe.$v7b),ve.createInstance(Nt.$P7b,this.c.event)))}async h(){const ve=new Y.$xh,Te={_serviceBrand:void 0,...V.default};ve.set(B.$ij,Te);const Ke=new P.$hh(We=>We==="main"),He=new ft.$P6b(this.a,Ke);ve.set(ft.$O6b,He);const nt=this.f.policiesData?new Ne.$o6b(this.f.policiesData,He.getChannel("policy")):new Be.$0m;ve.set(Be.$8m,nt);const Ge=new Dt.$0l(this.f.args,Te);ve.set(n.$Hh,Ge);const Qe=new H.$Xq(void 0,this.f.logLevel,Ge.logsHome,this.f.loggers.map(We=>({...We,resource:R.URI.revive(We.resource)})),He.getChannel("logger"));ve.set(Q.$4i,Qe);const st=this.B(Qe.createLogger("sharedprocess",{name:(0,Et.localize)(0,null)})),at=this.B(new Q.$$i(st.getLevel())),Je=this.B(new kt.$fN(st,[at]));ve.set(Q.$3i,Je),this.b=this.B(new ut.$F7b(Je)),ve.set(ut.$E7b,this.b);const Ye=this.B(new T.$Ap(Je));ve.set(D.$4j,Ye);const ct=this.B(new F.$Zp(Je));Ye.registerProvider(A.Schemas.file,ct);const lt=this.B(new me.$N6b(A.Schemas.file,this.B(new pe.$1M(He.getChannel(pe.$ZM),{pathCaseSensitive:ue.$k})),A.Schemas.vscodeUserData,Je));Ye.registerProvider(A.Schemas.vscodeUserData,lt);const Ze=this.B(new qe.$mN(this.f.profiles.all,R.URI.revive(this.f.profiles.home).with({scheme:Ge.userRoamingDataHome.scheme}),He.getChannel("userDataProfiles")));ve.set(Oe.$Ck,Ze);const Xe=this.B(new b.$xn(Ze.defaultProfile.settingsResource,Ye,nt,Je));ve.set($.$6h,Xe);const _e=new Ot.$L7b(void 0,{defaultProfile:Ze.defaultProfile,currentProfile:Ze.defaultProfile},He,Ge);ve.set(ne.$So,_e),this.B((0,j.$kb)(()=>_e.flush())),await Promise.all([Xe.initialize(),_e.initialize()]);const Tt=new ie.$mr(Ye);ve.set(ze.$Ak,Tt);const mt=new Pt.$Jq(He.getChannel("request"));ve.set(ee.$Go,mt),ve.set(o.$e7b,new q.$wh(l.$f7b,void 0,!1)),ve.set(Re.$yF,new q.$wh(Ee.$u7b,void 0,!1));const bt=P.ProxyChannel.toService(He.getChannel("nativeHost"));ve.set(It.$x5b,bt),ve.set(c.$Bn,new q.$wh(s.$uN,void 0,!0));const Mt=this.B(new ge.$l6b(bt)),Ft=new P.$hh(We=>Mt.getActiveClientId().then(ot=>We===ot));ve.set(E.$bUb,new Rt.$H7b(this.a.getChannel("extensionRecommendationNotification",Ft)));let rt;const et=[],wt=(0,z.$ko)(Te,Xe);if((0,z.$fo)(Te,Ge)){const We=new S.$s3b(Je,Qe,Ge,Te);if(et.push(We),Te.aiConfig?.ariaKey){const ot=new Ve.$6M(mt,wt,"monacoworkbench",null,Te.aiConfig.ariaKey);this.B((0,j.$kb)(()=>ot.flush())),et.push(ot)}rt=new C.$Nq({appenders:et,commonProperties:(0,se.$8n)((0,L.release)(),(0,L.hostname)(),process.arch,Te.commit,Te.version,this.f.machineId,wt),sendErrorTelemetry:!0,piiPaths:(0,z.$lo)(Ge)},Xe,Te)}else{rt=z.$_n;const We=z.$do;et.push(We)}this.a.registerChannel("telemetryAppender",new U.$25b(et)),ve.set(K.$7k,rt);const Ut=new M.$g7b(Xe,rt,Je,Qe,Ge,Te);ve.set(K.$8k,Ut),ve.set(De.$hp,new q.$wh(Ct.$eN,void 0,!0)),ve.set(Ce.$lp,new q.$wh(Le.$p6b,void 0,!0)),ve.set(v.$4o,new q.$wh(v.$5o,void 0,!0)),ve.set(u.$vp,new q.$wh(u.$wp,void 0,!0)),ve.set(a.$Xn,new q.$wh(r.$2o,void 0,!0)),ve.set(a.$4n,new q.$wh(At.$K7b,void 0,!1)),ve.set(x.$Fq,new q.$wh(G.$Hq,void 0,!1)),ve.set(I.$em,new q.$wh(t.$tr,void 0,!1)),ve.set(he.$bzb,new q.$wh(he.$czb,void 0,!0)),ve.set(ae.$vgb,new q.$wh($e.$oBb,void 0,!0)),ve.set(ae.$ugb,new le.$j7b(this.a.getChannel("userDataSyncUtil",We=>We.ctx!=="main"))),ve.set(a.$3n,new q.$wh(i.$_yb,void 0,!1)),ve.set(_.$mBb,new q.$wh(_.$nBb,void 0,!0)),ve.set(J.$Pz,new q.$wh(J.$Qz)),ve.set(ae.$fgb,new q.$wh(je.$xAb,void 0,!0)),ve.set(ae.$ggb,new q.$wh(je.$zAb,void 0,!0)),ve.set(de.$6Yb,new q.$wh(de.$8Yb,void 0,!0)),ve.set(ae.$hgb,new q.$wh(fe.$73b,void 0,!1)),ve.set(ae.$qgb,new q.$wh(we.$V3b,void 0,!0)),ve.set(ae.$rgb,new q.$wh(ke.$_3b,void 0,!1)),ve.set(Ue.$Nzb,new q.$wh(ce.$q7b,void 0,!0)),ve.set(ae.$sgb,new q.$wh(pt.$L4b,void 0,!0)),ve.set(be.$Uk,new q.$wh(Se.$K6b,void 0,!1));const yt=new dt.$Sk;return ve.set(dt.$Rk,yt),yt.register(0,jt.$M7b),ve.set(Pe.$Tz,new q.$wh(Me.$I6b)),ve.set(Ae.$r7b,new q.$wh(Fe.$t7b)),ve.set(ht.$w7b,new q.$wh(St.$G7b)),ve.set(gt.$N7b,new q.$wh(gt.$O7b)),new Z.$3p(ve)}i(ve){const Te=new y.$7o(ve.get(a.$Zn),()=>null);this.a.registerChannel("extensions",Te);const Ke=P.ProxyChannel.fromService(ve.get(x.$Fq));this.a.registerChannel("languagePacks",Ke);const He=P.ProxyChannel.fromService(ve.get(I.$em));this.a.registerChannel("diagnostics",He);const nt=new y.$9o(ve.get(a.$4n));this.a.registerChannel("extensionTipsService",nt);const Ge=P.ProxyChannel.fromService(ve.get(o.$e7b));this.a.registerChannel("checksum",Ge);const Qe=P.ProxyChannel.fromService(ve.get(Re.$yF));this.a.registerChannel("v8InspectProfiling",Qe);const st=new le.$k7b(ve.get(de.$6Yb));this.a.registerChannel("userDataSyncMachines",st);const at=P.ProxyChannel.fromService(ve.get(K.$8k));this.a.registerChannel("customEndpointTelemetry",at);const Je=new le.$l7b(ve.get(he.$bzb));this.a.registerChannel("userDataSyncAccount",Je);const Ye=new le.$m7b(ve.get(ae.$fgb));this.a.registerChannel("userDataSyncStoreManagement",Ye);const ct=new Ie.$o7b(ve.get(ae.$rgb),ve.get(Oe.$Ck),ve.get(Q.$3i));this.a.registerChannel("userDataSync",ct);const lt=this.B(ve.get(W.$yh).createInstance(Lt.$J7b)),Ze=new le.$h7b(lt);this.a.registerChannel("userDataAutoSync",Ze);const Xe=P.ProxyChannel.fromService(ve.get(Ae.$r7b));this.a.registerChannel(Ae.$s7b,Xe);const _e=P.ProxyChannel.fromService(ve.get(ht.$w7b));this.a.registerChannel("remoteTunnel",_e)}j(ve){process.on("uncaughtException",Te=>(0,O.$Y)(Te)),process.on("unhandledRejection",Te=>(0,O.$Y)(Te)),(0,O.setUnexpectedErrorHandler)(Te=>{const Ke=(0,N.$ki)(Te,!0);Ke&&ve.error(`[uncaught exception in sharedProcess]: ${Ke}`)})}handledClientConnection(ve){if(ve.data!==tt.$Y5b.response)return!1;const Te=(0,k.$Hf)(ve.ports);return Te?(this.c.fire(Te),!0):!1}}async function $t(it){const ve=new zt(it);process.parentPort.postMessage(tt.$W5b.ipcReady),await ve.init(),process.parentPort.postMessage(tt.$W5b.initDone)}e.main=$t,process.parentPort.once("message",it=>{$t(it.data)})})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/3c133b63c6e17e2fe33f37db93a6d43e78a262c5/core/vs/code/node/sharedProcess/sharedProcessMain.js.map
