/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var De=["exports","require","vs/base/common/uri","vs/base/common/lifecycle","vs/base/common/event","vs/workbench/api/common/extHost.protocol","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHostTypes","vs/base/common/errors","vs/base/common/platform","vs/workbench/api/common/extHostTypeConverters","vs/nls","vs/nls!vs/workbench/api/node/extensionHostProcess","vs/base/common/async","vs/base/common/path","vs/base/common/strings","vs/base/common/network","vs/platform/log/common/log","vs/base/common/types","vs/base/common/arrays","vs/workbench/api/common/extHostRpcService","vs/base/common/buffer","vs/base/common/cancellation","vs/base/common/objects","vs/base/common/resources","vs/platform/extensions/common/extensions","vs/workbench/api/common/extHostInitDataService","vs/workbench/services/extensions/common/extensions","vs/base/common/map","vs/base/node/pfs","vs/platform/files/common/files","vs/base/common/uuid","vs/base/common/extpath","vs/workbench/api/common/extHostCommands","vs/editor/common/core/range","vs/base/common/glob","vs/workbench/services/search/common/search","vs/base/common/stopwatch","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/base/common/severity","vs/platform/registry/common/platform","vs/workbench/api/common/extHostTerminalService","vs/workbench/api/common/extHostExtensionService","vs/base/common/errorMessage","vs/base/common/process","child_process","vs/platform/contextkey/common/contextkey","vs/base/common/iterator","fs","vs/platform/configuration/common/configuration","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostVariableResolverService","vs/base/common/assert","vs/base/common/lazy","vs/base/common/themables","net","vs/editor/common/core/position","os","vs/platform/remote/common/remoteHosts","vs/base/common/performance","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/contrib/testing/common/testId","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/api/common/extHostDocumentsAndEditors","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostTunnelService","vs/base/common/collections","vs/base/common/decorators","vs/base/common/functional","vs/base/common/linkedList","vs/base/common/normalization","vs/base/common/hash","vs/base/common/ternarySearchTree","vs/base/common/codicons","vs/base/common/marshalling","vs/base/common/htmlContent","vs/base/parts/ipc/common/ipc","vs/base/parts/ipc/common/ipc.net","vs/editor/common/languages","vs/platform/files/common/watcher","vs/platform/progress/common/progress","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/telemetry/common/telemetryUtils","vs/workbench/api/common/cache","vs/workbench/contrib/testing/common/testTypes","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostStoragePaths","vs/workbench/api/common/extHostWebview","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/stream","vs/base/common/mime","vs/base/common/processes","vs/base/node/extpath","vs/base/node/processes","vs/platform/instantiation/common/descriptors","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/serviceCollection","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/sign/common/sign","vs/platform/tunnel/common/tunnel","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/contrib/webview/common/webview","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostLocalizationService","vs/workbench/api/common/extHostManagedSockets","vs/workbench/api/common/extHostSecretState","vs/workbench/api/common/extHostStorage","vs/workbench/services/search/node/ripgrepSearchUtils","vs/base/parts/ipc/node/ipc.net","vs/base/common/arraysFind","vs/base/common/idGenerator","vs/base/common/numbers","vs/base/common/filters","vs/base/common/uint","vs/editor/common/core/characterClassifier","vs/editor/common/core/wordHelper","vs/editor/common/model","vs/base/common/comparers","vs/base/common/fuzzyScorer","vs/base/common/labels","vs/base/common/uriIpc","vs/editor/common/services/semanticTokensDto","vs/editor/common/config/editorOptions","vs/platform/extensionManagement/common/extensionManagement","vs/platform/markers/common/markers","vs/platform/opener/common/opener","vs/platform/product/common/productService","vs/platform/configuration/common/configurationRegistry","vs/platform/extensionManagement/common/implicitActivationEvents","vs/platform/sign/node/signService","vs/workbench/common/editor","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/api/common/extHostDocumentData","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTestItem","vs/workbench/api/common/extHostTextEditor","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostWindow","vs/workbench/api/common/extHostOutput","vs/workbench/services/search/common/textSearchManager","vs/workbench/services/search/node/textSearchManager","vs/workbench/services/search/node/ripgrepTextSearchEngine","vs/base/common/amd","vs/base/common/json","vs/base/common/marked/marked","vs/base/common/cache","vs/base/common/symbols","vs/base/common/iconLabels","vs/base/common/dataTransfer","vs/base/node/ports","vs/editor/common/core/editOperation","vs/editor/common/core/selection","vs/editor/common/core/textModelDefaults","vs/editor/common/core/wordCharacterClassifier","vs/editor/common/languages/languageConfiguration","vs/editor/common/languages/linkComputer","vs/editor/common/model/prefixSumComputer","vs/editor/common/model/mirrorTextModel","vs/editor/common/model/textModelSearch","vs/editor/common/services/treeViewsDnd","vs/editor/common/tokenizationRegistry","vs/nls!vs/base/common/actions","vs/base/common/actions","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/platform","vs/base/common/console","vs/amdX","vs/base/parts/ipc/node/ipc.cp","vs/editor/common/languageSelector","vs/nls!vs/editor/common/config/editorOptions","vs/nls!vs/editor/common/languages","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/theme/common/iconRegistry","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/workbench/api/common/extHostChat","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostLanguageFeatures","vs/nls!vs/workbench/api/common/extHostLogService","vs/nls!vs/workbench/api/common/extHostNotebook","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTelemetry","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostTunnelService","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/api/node/extHostDebugService","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/common/views","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/common/debug","vs/nls!vs/workbench/contrib/debug/node/debugAdapter","vs/nls!vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/nls!vs/workbench/contrib/tasks/common/tasks","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/extensions/common/extensionsRegistry","vs/nls!vs/workbench/services/search/common/queryBuilder","vs/platform/contextkey/common/scanner","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/platform/environment/common/environment","vs/platform/externalTerminal/common/externalTerminal","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/files/common/io","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/node/diskFileSystemProvider","vs/platform/log/common/logService","vs/platform/log/node/spdlogLog","vs/platform/notification/common/notification","vs/platform/product/common/product","vs/platform/configuration/common/configurationModels","vs/platform/remote/common/managedSocket","vs/platform/remote/common/remoteAgentConnection","vs/platform/remote/common/remoteSocketFactoryService","vs/platform/sign/common/abstractSignService","vs/platform/telemetry/common/commonProperties","vs/platform/telemetry/common/telemetry","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/iconRegistry","vs/platform/workspace/common/editSessions","vs/platform/workspace/common/virtualWorkspace","vs/workbench/api/common/extHostLogService","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/node/proxyResolver","http","vs/workbench/api/node/uriTransformer","vs/workbench/common/views","vs/workbench/contrib/debug/common/debug","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/debug/node/debugAdapter","vs/workbench/contrib/debug/node/terminals","vs/workbench/api/common/extHostTheming","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/api/common/extHostCodeInsets","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostProgress","vs/workbench/services/environment/common/environmentService","vs/workbench/services/extensions/common/extensionHostEnv","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/api/common/extHostTreeViews","vs/workbench/services/extensions/common/extensionsApiProposals","vs/workbench/services/extensions/common/extensionsRegistry","vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/workbench/contrib/tasks/common/tasks","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAiRelatedInformation","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostChat","vs/workbench/api/common/extHostChatProvider","vs/workbench/api/common/extHostChatSlashCommand","vs/workbench/api/common/extHostChatVariables","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostConsoleForwarder","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostEmbeddingVector","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostInlineChat","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostIssueReporter","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebook","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostProfileContentHandler","vs/workbench/api/common/extHostQuickDiff","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostShare","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/node/extHostConsoleForwarder","vs/workbench/api/node/extHostDiskFileSystemProvider","vs/workbench/api/node/extHostDownloadService","vs/workbench/api/node/extHostLoggerService","vs/workbench/api/node/extHostStoragePaths","vs/workbench/api/node/extHostTerminalService","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/output/common/output","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/path/common/pathService","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/queryBuilder","vs/workbench/services/extensions/common/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/common/extensionHostMain","vs/workbench/api/node/extHostDebugService","vs/workbench/api/node/extHostTask","vs/workbench/api/node/extHostVariableResolverService","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/services/search/node/ripgrepFileSearch","@vscode/ripgrep","vs/workbench/services/search/node/fileSearch","string_decoder","vs/workbench/services/textfile/common/encoding","vs/workbench/services/search/node/ripgrepSearchProvider","vs/workbench/services/search/node/textSearchAdapter","vs/workbench/services/search/node/rawSearchService","vs/workbench/api/node/extHostSearch","vs/platform/tunnel/node/tunnelService","vs/workbench/api/node/extHostCLIServer","vs/workbench/api/node/extHostExtensionService","vs/workbench/api/node/extHostTunnelService","vs/workbench/api/node/extHost.node.services","util","vs/base/common/semver/semver","graceful-fs","https","tls","@vscode/proxy-agent","events","vscode-regexpp","crypto","zlib","vs/workbench/api/node/extensionHostProcess","minimist"],Ce=function($e){for(var e=[],D=0,M=$e.length;D<M;D++)e[D]=De[$e[D]];return e};define(De[154],Ce([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$S=e.$R=void 0,e.$R=!1;class D{static get(){const h=new Map,R=new Map,A=new Map,g=new Map;function E(S,C){S.has(C.detail)||S.set(C.detail,-C.timestamp)}function $(S,C){const y=S.get(C.detail);y&&(y>=0||S.set(C.detail,y+C.timestamp))}let P=[];typeof $e=="function"&&typeof $e.getStats=="function"&&(P=$e.getStats().slice(0).sort((S,C)=>S.timestamp-C.timestamp));for(const S of P)switch(S.type){case 10:E(h,S);break;case 11:case 12:$(h,S);break;case 21:E(R,S);break;case 22:$(R,S);break;case 33:E(A,S);break;case 34:$(A,S);break;case 31:E(g,S);break;case 32:$(g,S);break}let I=0;A.forEach(S=>I+=S);function b(S){const C=[];return S.forEach((y,r)=>C.push([r,y])),C}return{amdLoad:b(h),amdInvoke:b(R),nodeRequire:b(A),nodeEval:b(g),nodeRequireTotal:I}}static toMarkdownTable(h,R){let A="";const g=[];return h.forEach((E,$)=>{g[$]=E.length}),R.forEach(E=>{E.forEach(($,P)=>{typeof $>"u"&&($=E[P]="-");const I=$.toString().length;g[P]=Math.max(I,g[P])})}),h.forEach((E,$)=>{A+=`| ${E+" ".repeat(g[$]-E.toString().length)} `}),A+=`|
`,h.forEach((E,$)=>{A+=`| ${"-".repeat(g[$])} `}),A+=`|
`,R.forEach(E=>{E.forEach(($,P)=>{typeof $<"u"&&(A+=`| ${$+" ".repeat(g[P]-$.toString().length)} `)}),A+=`|
`}),A}}e.$S=D}),define(De[117],Ce([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lf=e.$kf=e.$jf=e.$if=e.$hf=e.$gf=e.$ff=e.$ef=e.$df=e.$cf=e.$bf=e.$af=e.$_e=void 0;function D(y,r,i){const a=M(y,r);if(a!==-1)return y[a]}e.$_e=D;function M(y,r,i=y.length-1){for(let a=i;a>=0;a--){const m=y[a];if(r(m))return a}return-1}e.$af=M;function h(y,r){const i=R(y,r);return i===-1?void 0:y[i]}e.$bf=h;function R(y,r,i=0,a=y.length){let m=i,p=a;for(;m<p;){const f=Math.floor((m+p)/2);r(y[f])?m=f+1:p=f}return m-1}e.$cf=R;function A(y,r){const i=g(y,r);return i===y.length?void 0:y[i]}e.$df=A;function g(y,r,i=0,a=y.length){let m=i,p=a;for(;m<p;){const f=Math.floor((m+p)/2);r(y[f])?p=f:m=f+1}return m}e.$ef=g;function E(y,r,i=0,a=y.length){const m=g(y,r,i,a);return m===y.length?-1:m}e.$ff=E;class ${static{this.assertInvariants=!1}constructor(r){this.e=r,this.c=0}findLastMonotonous(r){if($.assertInvariants){if(this.d){for(const a of this.e)if(this.d(a)&&!r(a))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this.d=r}const i=R(this.e,r,this.c);return this.c=i+1,i===-1?void 0:this.e[i]}}e.$gf=$;function P(y,r){if(y.length===0)return;let i=y[0];for(let a=1;a<y.length;a++){const m=y[a];r(m,i)>0&&(i=m)}return i}e.$hf=P;function I(y,r){if(y.length===0)return;let i=y[0];for(let a=1;a<y.length;a++){const m=y[a];r(m,i)>=0&&(i=m)}return i}e.$if=I;function b(y,r){return P(y,(i,a)=>-r(i,a))}e.$jf=b;function S(y,r){if(y.length===0)return-1;let i=0;for(let a=1;a<y.length;a++){const m=y[a];r(m,y[i])>0&&(i=a)}return i}e.$kf=S;function C(y,r){for(const i of y){const a=r(i);if(a!==void 0)return a}}e.$lf=C}),define(De[69],Ce([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$L=e.$K=e.$J=e.$I=void 0;function D(A,g){const E=Object.create(null);for(const $ of A){const P=g($);let I=E[P];I||(I=E[P]=[]),I.push($)}return E}e.$I=D;function M(A,g){const E=[],$=[];for(const P of A)g.has(P)||E.push(P);for(const P of g)A.has(P)||$.push(P);return{removed:E,added:$}}e.$J=M;function h(A,g){const E=[],$=[];for(const[P,I]of A)g.has(P)||E.push(I);for(const[P,I]of g)A.has(P)||$.push(I);return{removed:E,added:$}}e.$K=h;class R{constructor(){this.a=new Map}add(g,E){let $=this.a.get(g);$||($=new Set,this.a.set(g,$)),$.add(E)}delete(g,E){const $=this.a.get(g);$&&($.delete(E),$.size===0&&this.a.delete(g))}forEach(g,E){const $=this.a.get(g);$&&$.forEach(E)}get(g){const E=this.a.get(g);return E||new Set}}e.$L=R}),define(De[70],Ce([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6g=e.$5g=e.$4g=void 0;function D(A){return(g,E,$)=>{let P=null,I=null;if(typeof $.value=="function"?(P="value",I=$.value):typeof $.get=="function"&&(P="get",I=$.get),!I)throw new Error("not supported");$[P]=A(I,E)}}function M(A,g,E){let $=null,P=null;if(typeof E.value=="function"?($="value",P=E.value,P.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof E.get=="function"&&($="get",P=E.get),!P)throw new Error("not supported");const I=`$memoize$${g}`;E[$]=function(...b){return this.hasOwnProperty(I)||Object.defineProperty(this,I,{configurable:!1,enumerable:!1,writable:!1,value:P.apply(this,b)}),this[I]}}e.$4g=M;function h(A,g,E){return D(($,P)=>{const I=`$debounce$${P}`,b=`$debounce$result$${P}`;return function(...S){this[b]||(this[b]=E?E():void 0),clearTimeout(this[I]),g&&(this[b]=g(this[b],...S),S=[this[b]]),this[I]=setTimeout(()=>{$.apply(this,S),this[b]=E?E():void 0},A)}})}e.$5g=h;function R(A,g,E){return D(($,P)=>{const I=`$throttle$timer$${P}`,b=`$throttle$result$${P}`,S=`$throttle$lastRun$${P}`,C=`$throttle$pending$${P}`;return function(...y){if(this[b]||(this[b]=E?E():void 0),(this[S]===null||this[S]===void 0)&&(this[S]=-Number.MAX_VALUE),g&&(this[b]=g(this[b],...y)),this[C])return;const r=this[S]+A;r<=Date.now()?(this[S]=Date.now(),$.apply(this,[this[b]]),this[b]=E?E():void 0):(this[C]=!0,this[I]=setTimeout(()=>{this[C]=!1,this[S]=Date.now(),$.apply(this,[this[b]]),this[b]=E?E():void 0},r-Date.now()))}})}e.$6g=R}),define(De[8],Ce([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ab=e.$_=e.$$=e.$0=e.$9=e.$8=e.$7=e.$6=e.$5=e.$4=e.$3=e.$2=e.$1=e.$Z=e.$Y=e.$X=e.setUnexpectedErrorHandler=e.$V=e.$U=void 0;class D{constructor(){this.b=[],this.a=function(t){setTimeout(()=>{throw t.stack?m.isErrorNoTelemetry(t)?new m(t.message+`

`+t.stack):new Error(t.message+`

`+t.stack):t},0)}}addListener(t){return this.b.push(t),()=>{this.d(t)}}c(t){this.b.forEach(s=>{s(t)})}d(t){this.b.splice(this.b.indexOf(t),1)}setUnexpectedErrorHandler(t){this.a=t}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(t){this.a(t),this.c(t)}onUnexpectedExternalError(t){this.a(t)}}e.$U=D,e.$V=new D;function M(f){e.$V.setUnexpectedErrorHandler(f)}e.setUnexpectedErrorHandler=M;function h(f){if(!f||typeof f!="object")return!1;const t=f;return t.code==="EPIPE"&&t.syscall?.toUpperCase()==="WRITE"}e.$X=h;function R(f){$(f)||e.$V.onUnexpectedError(f)}e.$Y=R;function A(f){$(f)||e.$V.onUnexpectedExternalError(f)}e.$Z=A;function g(f){if(f instanceof Error){const{name:t,message:s}=f,o=f.stacktrace||f.stack;return{$isError:!0,name:t,message:s,stack:o,noTelemetry:m.isErrorNoTelemetry(f)}}return f}e.$1=g;const E="Canceled";function $(f){return f instanceof P?!0:f instanceof Error&&f.name===E&&f.message===E}e.$2=$;class P extends Error{constructor(){super(E),this.name=this.message}}e.$3=P;function I(){const f=new Error(E);return f.name=f.message,f}e.$4=I;function b(f){return f?new Error(`Illegal argument: ${f}`):new Error("Illegal argument")}e.$5=b;function S(f){return f?new Error(`Illegal state: ${f}`):new Error("Illegal state")}e.$6=S;class C extends TypeError{constructor(t){super(t?`${t} is read-only and cannot be changed`:"Cannot change read-only property")}}e.$7=C;function y(f){return f?f.message?f.message:f.stack?f.stack.split(`
`)[0]:String(f):"Error"}e.$8=y;class r extends Error{constructor(t){super("NotImplemented"),t&&(this.message=t)}}e.$9=r;class i extends Error{constructor(t){super("NotSupported"),t&&(this.message=t)}}e.$0=i;class a extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.$$=a;class m extends Error{constructor(t){super(t),this.name="CodeExpectedError"}static fromError(t){if(t instanceof m)return t;const s=new m;return s.message=t.message,s.stack=t.stack,s}static isErrorNoTelemetry(t){return t.name==="CodeExpectedError"}}e.$_=m;class p extends Error{constructor(t){super(t||"An unexpected bug occurred."),Object.setPrototypeOf(this,p.prototype)}}e.$ab=p}),define(De[19],Ce([1,0,8,117]),function($e,e,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6f=e.$5f=e.$4f=e.$3f=e.$2f=e.$1f=e.$Zf=e.CompareResult=e.$Yf=e.$Xf=e.$Wf=e.$Vf=e.$Uf=e.$Tf=e.$Sf=e.$Rf=e.$Qf=e.$Pf=e.$Of=e.$Nf=e.$Mf=e.$Lf=e.$Kf=e.$Jf=e.$If=e.$Hf=e.$Gf=e.$Ff=e.$Ef=e.$Df=e.$Cf=e.$Bf=e.$Af=e.$zf=e.top=e.$xf=e.$wf=e.$vf=e.$uf=e.$tf=e.$sf=e.$rf=e.$qf=e.$pf=e.$of=e.$nf=e.$mf=void 0;function h(G,ae=0){return G[G.length-(1+ae)]}e.$mf=h;function R(G){if(G.length===0)throw new Error("Invalid tail call");return[G.slice(0,G.length-1),G[G.length-1]]}e.$nf=R;function A(G,ae,ne=(he,Ee)=>he===Ee){if(G===ae)return!0;if(!G||!ae||G.length!==ae.length)return!1;for(let he=0,Ee=G.length;he<Ee;he++)if(!ne(G[he],ae[he]))return!1;return!0}e.$of=A;function g(G,ae){const ne=G.length-1;ae<ne&&(G[ae]=G[ne]),G.pop()}e.$pf=g;function E(G,ae,ne){return $(G.length,he=>ne(G[he],ae))}e.$qf=E;function $(G,ae){let ne=0,he=G-1;for(;ne<=he;){const Ee=(ne+he)/2|0,de=ae(Ee);if(de<0)ne=Ee+1;else if(de>0)he=Ee-1;else return Ee}return-(ne+1)}e.$rf=$;function P(G,ae,ne){if(G=G|0,G>=ae.length)throw new TypeError("invalid index");const he=ae[Math.floor(ae.length*Math.random())],Ee=[],de=[],ge=[];for(const ie of ae){const ue=ne(ie,he);ue<0?Ee.push(ie):ue>0?de.push(ie):ge.push(ie)}return G<Ee.length?P(G,Ee,ne):G<Ee.length+ge.length?ge[0]:P(G-(Ee.length+ge.length),de,ne)}e.$sf=P;function I(G,ae){const ne=[];let he;for(const Ee of G.slice(0).sort(ae))!he||ae(he[0],Ee)!==0?(he=[Ee],ne.push(he)):he.push(Ee);return ne}e.$tf=I;function*b(G,ae){let ne,he;for(const Ee of G)he!==void 0&&ae(he,Ee)?ne.push(Ee):(ne&&(yield ne),ne=[Ee]),he=Ee;ne&&(yield ne)}e.$uf=b;function S(G,ae){for(let ne=0;ne<=G.length;ne++)ae(ne===0?void 0:G[ne-1],ne===G.length?void 0:G[ne])}e.$vf=S;function C(G,ae,ne){const he=[];function Ee(ie,ue,we){if(ue===0&&we.length===0)return;const Pe=he[he.length-1];Pe&&Pe.start+Pe.deleteCount===ie?(Pe.deleteCount+=ue,Pe.toInsert.push(...we)):he.push({start:ie,deleteCount:ue,toInsert:we})}let de=0,ge=0;for(;;){if(de===G.length){Ee(de,0,ae.slice(ge));break}if(ge===ae.length){Ee(de,G.length-de,[]);break}const ie=G[de],ue=ae[ge],we=ne(ie,ue);we===0?(de+=1,ge+=1):we<0?(Ee(de,1,[]),de+=1):we>0&&(Ee(de,0,[ue]),ge+=1)}return he}e.$wf=C;function y(G,ae,ne){const he=C(G,ae,ne),Ee=[],de=[];for(const ge of he)Ee.push(...G.slice(ge.start,ge.start+ge.deleteCount)),de.push(...ge.toInsert);return{removed:Ee,added:de}}e.$xf=y;function r(G,ae,ne){if(ne===0)return[];const he=G.slice(0,ne).sort(ae);return a(G,ae,he,ne,G.length),he}e.top=r;function i(G,ae,ne,he,Ee){return ne===0?Promise.resolve([]):new Promise((de,ge)=>{(async()=>{const ie=G.length,ue=G.slice(0,ne).sort(ae);for(let we=ne,Pe=Math.min(ne+he,ie);we<ie;we=Pe,Pe=Math.min(Pe+he,ie)){if(we>ne&&await new Promise(U=>setTimeout(U)),Ee&&Ee.isCancellationRequested)throw new D.$3;a(G,ae,ue,we,Pe)}return ue})().then(de,ge)})}e.$zf=i;function a(G,ae,ne,he,Ee){for(const de=ne.length;he<Ee;he++){const ge=G[he];if(ae(ge,ne[de-1])<0){ne.pop();const ie=(0,M.$ef)(ne,ue=>ae(ge,ue)<0);ne.splice(ie,0,ge)}}}function m(G){return G.filter(ae=>!!ae)}e.$Af=m;function p(G){let ae=0;for(let ne=0;ne<G.length;ne++)G[ne]&&(G[ae]=G[ne],ae+=1);G.length=ae}e.$Bf=p;function f(G,ae,ne){G.splice(ne,0,G.splice(ae,1)[0])}e.$Cf=f;function t(G){return!Array.isArray(G)||G.length===0}e.$Df=t;function s(G){return Array.isArray(G)&&G.length>0}e.$Ef=s;function o(G,ae=ne=>ne){const ne=new Set;return G.filter(he=>{const Ee=ae(he);return ne.has(Ee)?!1:(ne.add(Ee),!0)})}e.$Ff=o;function n(G){const ae=new Set;return ne=>{const he=G(ne);return ae.has(he)?!1:(ae.add(he),!0)}}e.$Gf=n;function c(G,ae){return G.length>0?G[0]:ae}e.$Hf=c;function d(G,ae){return G.length>0?G[G.length-1]:ae}e.$If=d;function v(G,ae,ne=(he,Ee)=>he===Ee){let he=0;for(let Ee=0,de=Math.min(G.length,ae.length);Ee<de&&ne(G[Ee],ae[Ee]);Ee++)he++;return he}e.$Jf=v;function k(G){return[].concat(...G)}e.$Kf=k;function u(G,ae){let ne=typeof ae=="number"?G:0;typeof ae=="number"?ne=G:(ne=0,ae=G);const he=[];if(ne<=ae)for(let Ee=ne;Ee<ae;Ee++)he.push(Ee);else for(let Ee=ne;Ee>ae;Ee--)he.push(Ee);return he}e.$Lf=u;function l(G,ae,ne){return G.reduce((he,Ee)=>(he[ae(Ee)]=ne?ne(Ee):Ee,he),Object.create(null))}e.$Mf=l;function w(G,ae){return G.push(ae),()=>L(G,ae)}e.$Nf=w;function L(G,ae){const ne=G.indexOf(ae);if(ne>-1)return G.splice(ne,1),ae}e.$Of=L;function N(G,ae,ne){const he=G.slice(0,ae),Ee=G.slice(ae);return he.concat(ne,Ee)}e.$Pf=N;function j(G,ae){let ne;if(typeof ae=="number"){let he=ae;ne=()=>{const Ee=Math.sin(he++)*179426549;return Ee-Math.floor(Ee)}}else ne=Math.random;for(let he=G.length-1;he>0;he-=1){const Ee=Math.floor(ne()*(he+1)),de=G[he];G[he]=G[Ee],G[Ee]=de}}e.$Qf=j;function T(G,ae){const ne=G.indexOf(ae);ne>-1&&(G.splice(ne,1),G.unshift(ae))}e.$Rf=T;function O(G,ae){const ne=G.indexOf(ae);ne>-1&&(G.splice(ne,1),G.push(ae))}e.$Sf=O;function B(G,ae){for(const ne of ae)G.push(ne)}e.$Tf=B;function F(G,ae){return Array.isArray(G)?G.map(ae):ae(G)}e.$Uf=F;function J(G){return Array.isArray(G)?G:[G]}e.$Vf=J;function K(G){return G[Math.floor(Math.random()*G.length)]}e.$Wf=K;function me(G,ae,ne){const he=x(G,ae),Ee=G.length,de=ne.length;G.length=Ee+de;for(let ge=Ee-1;ge>=he;ge--)G[ge+de]=G[ge];for(let ge=0;ge<de;ge++)G[ge+he]=ne[ge]}e.$Xf=me;function re(G,ae,ne,he){const Ee=x(G,ae);let de=G.splice(Ee,ne);return de===void 0&&(de=[]),me(G,Ee,he),de}e.$Yf=re;function x(G,ae){return ae<0?Math.max(ae+G.length,0):Math.min(ae,G.length)}var q;(function(G){function ae(de){return de<0}G.isLessThan=ae;function ne(de){return de<=0}G.isLessThanOrEqual=ne;function he(de){return de>0}G.isGreaterThan=he;function Ee(de){return de===0}G.isNeitherLessOrGreaterThan=Ee,G.greaterThan=1,G.lessThan=-1,G.neitherLessOrGreaterThan=0})(q||(e.CompareResult=q={}));function ee(G,ae){return(ne,he)=>ae(G(ne),G(he))}e.$Zf=ee;function pe(...G){return(ae,ne)=>{for(const he of G){const Ee=he(ae,ne);if(!q.isNeitherLessOrGreaterThan(Ee))return Ee}return q.neitherLessOrGreaterThan}}e.$1f=pe;const ce=(G,ae)=>G-ae;e.$2f=ce;const _=(G,ae)=>(0,e.$2f)(G?1:0,ae?1:0);e.$3f=_;function Q(G){return(ae,ne)=>-G(ae,ne)}e.$4f=Q;class z{constructor(ae){this.g=ae,this.c=0,this.d=this.g.length-1}get length(){return this.d-this.c+1}takeWhile(ae){let ne=this.c;for(;ne<this.g.length&&ae(this.g[ne]);)ne++;const he=ne===this.c?null:this.g.slice(this.c,ne);return this.c=ne,he}takeFromEndWhile(ae){let ne=this.d;for(;ne>=0&&ae(this.g[ne]);)ne--;const he=ne===this.d?null:this.g.slice(ne+1,this.d+1);return this.d=ne,he}peek(){if(this.length!==0)return this.g[this.c]}peekLast(){if(this.length!==0)return this.g[this.d]}dequeue(){const ae=this.g[this.c];return this.c++,ae}removeLast(){const ae=this.g[this.d];return this.d--,ae}takeCount(ae){const ne=this.g.slice(this.c,this.c+ae);return this.c+=ae,ne}}e.$5f=z;class V{static{this.empty=new V(ae=>{})}constructor(ae){this.iterate=ae}forEach(ae){this.iterate(ne=>(ae(ne),!0))}toArray(){const ae=[];return this.iterate(ne=>(ae.push(ne),!0)),ae}filter(ae){return new V(ne=>this.iterate(he=>ae(he)?ne(he):!0))}map(ae){return new V(ne=>this.iterate(he=>ne(ae(he))))}some(ae){let ne=!1;return this.iterate(he=>(ne=ae(he),!ne)),ne}findFirst(ae){let ne;return this.iterate(he=>ae(he)?(ne=he,!1):!0),ne}findLast(ae){let ne;return this.iterate(he=>(ae(he)&&(ne=he),!0)),ne}findLastMaxBy(ae){let ne,he=!0;return this.iterate(Ee=>((he||q.isGreaterThan(ae(Ee,ne)))&&(he=!1,ne=Ee),!0)),ne}}e.$6f=V}),define(De[54],Ce([1,0,8]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ab=e.$zb=e.$yb=e.$xb=e.ok=void 0;function M(E,$){if(!E)throw new Error($?`Assertion failed (${$})`:"Assertion Failed")}e.ok=M;function h(E,$="Unreachable"){throw new Error($)}e.$xb=h;function R(E){if(!E)throw new D.$ab("Assertion Failed")}e.$yb=R;function A(E){if(!E()){debugger;E(),(0,D.$Y)(new D.$ab("Assertion Failed"))}}e.$zb=A;function g(E,$){let P=0;for(;P<E.length-1;){const I=E[P],b=E[P+1];if(!$(I,b))return!1;P++}return!0}e.$Ab=g}),define(De[71],Ce([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bb=void 0;function D(M){const h=this;let R=!1,A;return function(){return R||(R=!0,A=M.apply(h,arguments)),A}}e.$bb=D}),define(De[118],Ce([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1L=e.$ZL=void 0;class D{constructor(h){this.a=h,this.b=0}nextId(){return this.a+ ++this.b}}e.$ZL=D,e.$1L=new D("id#")}),define(De[48],Ce([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var D;(function(M){function h(p){return p&&typeof p=="object"&&typeof p[Symbol.iterator]=="function"}M.is=h;const R=Object.freeze([]);function A(){return R}M.empty=A;function*g(p){yield p}M.single=g;function E(p){return h(p)?p:g(p)}M.wrap=E;function $(p){return p||R}M.from=$;function P(p){return!p||p[Symbol.iterator]().next().done===!0}M.isEmpty=P;function I(p){return p[Symbol.iterator]().next().value}M.first=I;function b(p,f){for(const t of p)if(f(t))return!0;return!1}M.some=b;function S(p,f){for(const t of p)if(f(t))return t}M.find=S;function*C(p,f){for(const t of p)f(t)&&(yield t)}M.filter=C;function*y(p,f){let t=0;for(const s of p)yield f(s,t++)}M.map=y;function*r(...p){for(const f of p)for(const t of f)yield t}M.concat=r;function i(p,f,t){let s=t;for(const o of p)s=f(s,o);return s}M.reduce=i;function*a(p,f,t=p.length){for(f<0&&(f+=p.length),t<0?t+=p.length:t>p.length&&(t=p.length);f<t;f++)yield p[f]}M.slice=a;function m(p,f=Number.POSITIVE_INFINITY){const t=[];if(f===0)return[t,p];const s=p[Symbol.iterator]();for(let o=0;o<f;o++){const n=s.next();if(n.done)return[t,M.empty()];t.push(n.value)}return[t,{[Symbol.iterator](){return s}}]}M.consume=m})(D||(e.Iterable=D={}))}),define(De[155],Ce([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sm=e.$Rm=e.$Qm=e.$Pm=e.$Om=e.$Nm=e.$Mm=e.$Lm=e.$Km=e.$Jm=e.$Im=e.$Hm=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var D;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(D||(e.ScanError=D={}));var M;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(M||(e.SyntaxKind=M={}));var h;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(h||(e.ParseErrorCode=h={}));var R;(function(t){t.DEFAULT={allowTrailingComma:!0}})(R||(e.ParseOptions=R={}));function A(t,s=!1){let o=0;const n=t.length;let c="",d=0,v=16,k=0;function u(O){let B=0,F=0;for(;B<O;){const J=t.charCodeAt(o);if(J>=48&&J<=57)F=F*16+J-48;else if(J>=65&&J<=70)F=F*16+J-65+10;else if(J>=97&&J<=102)F=F*16+J-97+10;else break;o++,B++}return B<O&&(F=-1),F}function l(O){o=O,c="",d=0,v=16,k=0}function w(){const O=o;if(t.charCodeAt(o)===48)o++;else for(o++;o<t.length&&$(t.charCodeAt(o));)o++;if(o<t.length&&t.charCodeAt(o)===46)if(o++,o<t.length&&$(t.charCodeAt(o)))for(o++;o<t.length&&$(t.charCodeAt(o));)o++;else return k=3,t.substring(O,o);let B=o;if(o<t.length&&(t.charCodeAt(o)===69||t.charCodeAt(o)===101))if(o++,(o<t.length&&t.charCodeAt(o)===43||t.charCodeAt(o)===45)&&o++,o<t.length&&$(t.charCodeAt(o))){for(o++;o<t.length&&$(t.charCodeAt(o));)o++;B=o}else k=3;return t.substring(O,B)}function L(){let O="",B=o;for(;;){if(o>=n){O+=t.substring(B,o),k=2;break}const F=t.charCodeAt(o);if(F===34){O+=t.substring(B,o),o++;break}if(F===92){if(O+=t.substring(B,o),o++,o>=n){k=2;break}switch(t.charCodeAt(o++)){case 34:O+='"';break;case 92:O+="\\";break;case 47:O+="/";break;case 98:O+="\b";break;case 102:O+="\f";break;case 110:O+=`
`;break;case 114:O+="\r";break;case 116:O+="	";break;case 117:{const K=u(4);K>=0?O+=String.fromCharCode(K):k=4;break}default:k=5}B=o;continue}if(F>=0&&F<=31)if(E(F)){O+=t.substring(B,o),k=2;break}else k=6;o++}return O}function N(){if(c="",k=0,d=o,o>=n)return d=n,v=17;let O=t.charCodeAt(o);if(g(O)){do o++,c+=String.fromCharCode(O),O=t.charCodeAt(o);while(g(O));return v=15}if(E(O))return o++,c+=String.fromCharCode(O),O===13&&t.charCodeAt(o)===10&&(o++,c+=`
`),v=14;switch(O){case 123:return o++,v=1;case 125:return o++,v=2;case 91:return o++,v=3;case 93:return o++,v=4;case 58:return o++,v=6;case 44:return o++,v=5;case 34:return o++,c=L(),v=10;case 47:{const B=o-1;if(t.charCodeAt(o+1)===47){for(o+=2;o<n&&!E(t.charCodeAt(o));)o++;return c=t.substring(B,o),v=12}if(t.charCodeAt(o+1)===42){o+=2;const F=n-1;let J=!1;for(;o<F;){if(t.charCodeAt(o)===42&&t.charCodeAt(o+1)===47){o+=2,J=!0;break}o++}return J||(o++,k=1),c=t.substring(B,o),v=13}return c+=String.fromCharCode(O),o++,v=16}case 45:if(c+=String.fromCharCode(O),o++,o===n||!$(t.charCodeAt(o)))return v=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return c+=w(),v=11;default:for(;o<n&&j(O);)o++,O=t.charCodeAt(o);if(d!==o){switch(c=t.substring(d,o),c){case"true":return v=8;case"false":return v=9;case"null":return v=7}return v=16}return c+=String.fromCharCode(O),o++,v=16}}function j(O){if(g(O)||E(O))return!1;switch(O){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function T(){let O;do O=N();while(O>=12&&O<=15);return O}return{setPosition:l,getPosition:()=>o,scan:s?T:N,getToken:()=>v,getTokenValue:()=>c,getTokenOffset:()=>d,getTokenLength:()=>o-d,getTokenError:()=>k}}e.$Hm=A;function g(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function E(t){return t===10||t===13||t===8232||t===8233}function $(t){return t>=48&&t<=57}var P;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(P||(P={}));function I(t,s){const o=[],n=new Object;let c;const d={value:{},offset:0,length:0,type:"object",parent:void 0};let v=!1;function k(u,l,w,L){d.value=u,d.offset=l,d.length=w,d.type=L,d.colonOffset=void 0,c=d}try{m(t,{onObjectBegin:(u,l)=>{if(s<=u)throw n;c=void 0,v=s>u,o.push("")},onObjectProperty:(u,l,w)=>{if(s<l||(k(u,l,w,"property"),o[o.length-1]=u,s<=l+w))throw n},onObjectEnd:(u,l)=>{if(s<=u)throw n;c=void 0,o.pop()},onArrayBegin:(u,l)=>{if(s<=u)throw n;c=void 0,o.push(0)},onArrayEnd:(u,l)=>{if(s<=u)throw n;c=void 0,o.pop()},onLiteralValue:(u,l,w)=>{if(s<l||(k(u,l,w,f(u)),s<=l+w))throw n},onSeparator:(u,l,w)=>{if(s<=l)throw n;if(u===":"&&c&&c.type==="property")c.colonOffset=l,v=!1,c=void 0;else if(u===","){const L=o[o.length-1];typeof L=="number"?o[o.length-1]=L+1:(v=!0,o[o.length-1]=""),c=void 0}}})}catch(u){if(u!==n)throw u}return{path:o,previousNode:c,isAtPropertyKey:v,matches:u=>{let l=0;for(let w=0;l<u.length&&w<o.length;w++)if(u[l]===o[w]||u[l]==="*")l++;else if(u[l]!=="**")return!1;return l===u.length}}}e.$Im=I;function b(t,s=[],o=R.DEFAULT){let n=null,c=[];const d=[];function v(u){Array.isArray(c)?c.push(u):n!==null&&(c[n]=u)}return m(t,{onObjectBegin:()=>{const u={};v(u),d.push(c),c=u,n=null},onObjectProperty:u=>{n=u},onObjectEnd:()=>{c=d.pop()},onArrayBegin:()=>{const u=[];v(u),d.push(c),c=u,n=null},onArrayEnd:()=>{c=d.pop()},onLiteralValue:v,onError:(u,l,w)=>{s.push({error:u,offset:l,length:w})}},o),c[0]}e.$Jm=b;function S(t,s=[],o=R.DEFAULT){let n={type:"array",offset:-1,length:-1,children:[],parent:void 0};function c(u){n.type==="property"&&(n.length=u-n.offset,n=n.parent)}function d(u){return n.children.push(u),u}m(t,{onObjectBegin:u=>{n=d({type:"object",offset:u,length:-1,parent:n,children:[]})},onObjectProperty:(u,l,w)=>{n=d({type:"property",offset:l,length:-1,parent:n,children:[]}),n.children.push({type:"string",value:u,offset:l,length:w,parent:n})},onObjectEnd:(u,l)=>{n.length=u+l-n.offset,n=n.parent,c(u+l)},onArrayBegin:(u,l)=>{n=d({type:"array",offset:u,length:-1,parent:n,children:[]})},onArrayEnd:(u,l)=>{n.length=u+l-n.offset,n=n.parent,c(u+l)},onLiteralValue:(u,l,w)=>{d({type:f(u),offset:l,length:w,parent:n,value:u}),c(l+w)},onSeparator:(u,l,w)=>{n.type==="property"&&(u===":"?n.colonOffset=l:u===","&&c(l))},onError:(u,l,w)=>{s.push({error:u,offset:l,length:w})}},o);const k=n.children[0];return k&&delete k.parent,k}e.$Km=S;function C(t,s){if(!t)return;let o=t;for(const n of s)if(typeof n=="string"){if(o.type!=="object"||!Array.isArray(o.children))return;let c=!1;for(const d of o.children)if(Array.isArray(d.children)&&d.children[0].value===n){o=d.children[1],c=!0;break}if(!c)return}else{const c=n;if(o.type!=="array"||c<0||!Array.isArray(o.children)||c>=o.children.length)return;o=o.children[c]}return o}e.$Lm=C;function y(t){if(!t.parent||!t.parent.children)return[];const s=y(t.parent);if(t.parent.type==="property"){const o=t.parent.children[0].value;s.push(o)}else if(t.parent.type==="array"){const o=t.parent.children.indexOf(t);o!==-1&&s.push(o)}return s}e.$Mm=y;function r(t){switch(t.type){case"array":return t.children.map(r);case"object":{const s=Object.create(null);for(const o of t.children){const n=o.children[1];n&&(s[o.children[0].value]=r(n))}return s}case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.$Nm=r;function i(t,s,o=!1){return s>=t.offset&&s<t.offset+t.length||o&&s===t.offset+t.length}e.$Om=i;function a(t,s,o=!1){if(i(t,s,o)){const n=t.children;if(Array.isArray(n))for(let c=0;c<n.length&&n[c].offset<=s;c++){const d=a(n[c],s,o);if(d)return d}return t}}e.$Pm=a;function m(t,s,o=R.DEFAULT){const n=A(t,!1);function c(pe){return pe?()=>pe(n.getTokenOffset(),n.getTokenLength()):()=>!0}function d(pe){return pe?ce=>pe(ce,n.getTokenOffset(),n.getTokenLength()):()=>!0}const v=c(s.onObjectBegin),k=d(s.onObjectProperty),u=c(s.onObjectEnd),l=c(s.onArrayBegin),w=c(s.onArrayEnd),L=d(s.onLiteralValue),N=d(s.onSeparator),j=c(s.onComment),T=d(s.onError),O=o&&o.disallowComments,B=o&&o.allowTrailingComma;function F(){for(;;){const pe=n.scan();switch(n.getTokenError()){case 4:J(14);break;case 5:J(15);break;case 3:J(13);break;case 1:O||J(11);break;case 2:J(12);break;case 6:J(16);break}switch(pe){case 12:case 13:O?J(10):j();break;case 16:J(1);break;case 15:case 14:break;default:return pe}}}function J(pe,ce=[],_=[]){if(T(pe),ce.length+_.length>0){let Q=n.getToken();for(;Q!==17;){if(ce.indexOf(Q)!==-1){F();break}else if(_.indexOf(Q)!==-1)break;Q=F()}}}function K(pe){const ce=n.getTokenValue();return pe?L(ce):k(ce),F(),!0}function me(){switch(n.getToken()){case 11:{let pe=0;try{pe=JSON.parse(n.getTokenValue()),typeof pe!="number"&&(J(2),pe=0)}catch{J(2)}L(pe);break}case 7:L(null);break;case 8:L(!0);break;case 9:L(!1);break;default:return!1}return F(),!0}function re(){return n.getToken()!==10?(J(3,[],[2,5]),!1):(K(!1),n.getToken()===6?(N(":"),F(),ee()||J(4,[],[2,5])):J(5,[],[2,5]),!0)}function x(){v(),F();let pe=!1;for(;n.getToken()!==2&&n.getToken()!==17;){if(n.getToken()===5){if(pe||J(4,[],[]),N(","),F(),n.getToken()===2&&B)break}else pe&&J(6,[],[]);re()||J(4,[],[2,5]),pe=!0}return u(),n.getToken()!==2?J(7,[2],[]):F(),!0}function q(){l(),F();let pe=!1;for(;n.getToken()!==4&&n.getToken()!==17;){if(n.getToken()===5){if(pe||J(4,[],[]),N(","),F(),n.getToken()===4&&B)break}else pe&&J(6,[],[]);ee()||J(4,[],[4,5]),pe=!0}return w(),n.getToken()!==4?J(8,[4],[]):F(),!0}function ee(){switch(n.getToken()){case 3:return q();case 1:return x();case 10:return K(!0);default:return me()}}return F(),n.getToken()===17?o.allowEmptyContent?!0:(J(4,[],[]),!1):ee()?(n.getToken()!==17&&J(9,[],[]),!0):(J(4,[],[]),!1)}e.$Qm=m;function p(t,s){const o=A(t),n=[];let c,d=0,v;do switch(v=o.getPosition(),c=o.scan(),c){case 12:case 13:case 17:d!==v&&n.push(t.substring(d,v)),s!==void 0&&n.push(o.getTokenValue().replace(/[^\r\n]/g,s)),d=o.getPosition();break}while(c!==17);return n.join("")}e.$Rm=p;function f(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.$Sm=f}),define(De[55],Ce([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$T=void 0;class D{constructor(h){this.d=h,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(h){this.c=h}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}e.$T=D}),define(De[3],Ce([1,0,71,48]),function($e,e,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ub=e.$tb=e.$sb=e.$rb=e.$qb=e.$pb=e.$ob=e.$nb=e.$mb=e.$lb=e.$kb=e.$jb=e.$ib=e.$hb=e.$gb=e.$fb=e.$eb=e.$db=e.$cb=void 0;const h=!1;let R=null;function A(d){R=d}if(e.$cb=A,h){const d="__is_disposable_tracked__";A(new class{trackDisposable(v){const k=new Error("Potentially leaked disposable").stack;setTimeout(()=>{v[d]||console.log(k)},3e3)}setParent(v,k){if(v&&v!==a.None)try{v[d]=!0}catch{}}markAsDisposed(v){if(v&&v!==a.None)try{v[d]=!0}catch{}}markAsSingleton(v){}})}function g(d){return R?.trackDisposable(d),d}e.$db=g;function E(d){R?.markAsDisposed(d)}e.$eb=E;function $(d,v){R?.setParent(d,v)}function P(d,v){if(R)for(const k of d)R.setParent(k,v)}function I(d){return R?.markAsSingleton(d),d}e.$fb=I;function b(d){return typeof d.dispose=="function"&&d.dispose.length===0}e.$gb=b;function S(d){if(M.Iterable.is(d)){const v=[];for(const k of d)if(k)try{k.dispose()}catch(u){v.push(u)}if(v.length===1)throw v[0];if(v.length>1)throw new AggregateError(v,"Encountered errors while disposing of store");return Array.isArray(d)?[]:d}else if(d)return d.dispose(),d}e.$hb=S;function C(d){for(const v of d)b(v)&&v.dispose();return[]}e.$ib=C;function y(...d){const v=r(()=>S(d));return P(d,v),v}e.$jb=y;function r(d){const v=g({dispose:(0,D.$bb)(()=>{E(v),d()})});return v}e.$kb=r;class i{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this.f=new Set,this.g=!1,g(this)}dispose(){this.g||(E(this),this.g=!0,this.clear())}get isDisposed(){return this.g}clear(){if(this.f.size!==0)try{S(this.f)}finally{this.f.clear()}}add(v){if(!v)return v;if(v===this)throw new Error("Cannot register a disposable on itself!");return $(v,this),this.g?i.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.f.add(v),v}}e.$lb=i;class a{static{this.None=Object.freeze({dispose(){}})}constructor(){this.q=new i,g(this),$(this.q,this)}dispose(){E(this),this.q.dispose()}B(v){if(v===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(v)}}e.$mb=a;class m{constructor(){this.b=!1,g(this)}get value(){return this.b?void 0:this.a}set value(v){this.b||v===this.a||(this.a?.dispose(),v&&$(v,this),this.a=v)}clear(){this.value=void 0}dispose(){this.b=!0,E(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const v=this.a;return this.a=void 0,v&&$(v,null),v}}e.$nb=m;class p{constructor(v){this.b=v,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}e.$ob=p;class f{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,g(this)}set(v){let k=v;return this.unset=()=>k=void 0,this.isset=()=>k!==void 0,this.dispose=()=>{k&&(k(),k=void 0,E(this))},this}}e.$pb=f;class t{constructor(){this.a=new Map}acquire(v,...k){let u=this.a.get(v);u||(u={counter:0,object:this.b(v,...k)},this.a.set(v,u));const{object:l}=u,w=(0,D.$bb)(()=>{--u.counter===0&&(this.c(v,u.object),this.a.delete(v))});return u.counter++,{object:l,dispose:w}}}e.$qb=t;class s{constructor(v){this.a=v}async acquire(v,...k){const u=this.a.acquire(v,...k);try{return{object:await u.object,dispose:()=>u.dispose()}}catch(l){throw u.dispose(),l}}}e.$rb=s;class o{constructor(v){this.object=v}dispose(){}}e.$sb=o;function n(d){const v=new i;try{d(v)}finally{v.dispose()}}e.$tb=n;class c{constructor(){this.a=new Map,this.b=!1,g(this)}dispose(){E(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this.a.size)try{S(this.a.values())}finally{this.a.clear()}}has(v){return this.a.has(v)}get size(){return this.a.size}get(v){return this.a.get(v)}set(v,k,u=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),u||this.a.get(v)?.dispose(),this.a.set(v,k)}deleteAndDispose(v){this.a.get(v)?.dispose(),this.a.delete(v)}[Symbol.iterator](){return this.a[Symbol.iterator]()}}e.$ub=c}),define(De[72],Ce([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vb=void 0;class D{static{this.Undefined=new D(void 0)}constructor(R){this.element=R,this.next=D.Undefined,this.prev=D.Undefined}}class M{constructor(){this.a=D.Undefined,this.b=D.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===D.Undefined}clear(){let R=this.a;for(;R!==D.Undefined;){const A=R.next;R.prev=D.Undefined,R.next=D.Undefined,R=A}this.a=D.Undefined,this.b=D.Undefined,this.c=0}unshift(R){return this.d(R,!1)}push(R){return this.d(R,!0)}d(R,A){const g=new D(R);if(this.a===D.Undefined)this.a=g,this.b=g;else if(A){const $=this.b;this.b=g,g.prev=$,$.next=g}else{const $=this.a;this.a=g,g.next=$,$.prev=g}this.c+=1;let E=!1;return()=>{E||(E=!0,this.e(g))}}shift(){if(this.a!==D.Undefined){const R=this.a.element;return this.e(this.a),R}}pop(){if(this.b!==D.Undefined){const R=this.b.element;return this.e(this.b),R}}e(R){if(R.prev!==D.Undefined&&R.next!==D.Undefined){const A=R.prev;A.next=R.next,R.next.prev=A}else R.prev===D.Undefined&&R.next===D.Undefined?(this.a=D.Undefined,this.b=D.Undefined):R.next===D.Undefined?(this.b=this.b.prev,this.b.next=D.Undefined):R.prev===D.Undefined&&(this.a=this.a.next,this.a.prev=D.Undefined);this.c-=1}*[Symbol.iterator](){let R=this.a;for(;R!==D.Undefined;)yield R.element,R=R.next}}e.$vb=M}),define(De[28],Ce([1,0]),function($e,e){"use strict";var D,M,h;Object.defineProperty(e,"__esModule",{value:!0}),e.$Ci=e.$Bi=e.$Ai=e.$zi=e.Touch=e.$yi=e.$xi=e.$wi=e.$vi=e.$ui=void 0;function R(r,i,a){let m=r.get(i);return m===void 0&&(m=a,r.set(i,m)),m}e.$ui=R;function A(r){const i=[];return r.forEach((a,m)=>{i.push(`${m} => ${a}`)}),`Map(${r.size}) {${i.join(", ")}}`}e.$vi=A;function g(r){const i=[];return r.forEach(a=>{i.push(a)}),`Set(${r.size}) {${i.join(", ")}}`}e.$wi=g;class E{constructor(i,a){this.uri=i,this.value=a}}class ${static{this.a=i=>i.toString()}constructor(i,a){this[D]="ResourceMap",i instanceof $?(this.b=new Map(i.b),this.c=a??$.a):(this.b=new Map,this.c=i??$.a)}set(i,a){return this.b.set(this.c(i),new E(i,a)),this}get(i){return this.b.get(this.c(i))?.value}has(i){return this.b.has(this.c(i))}get size(){return this.b.size}clear(){this.b.clear()}delete(i){return this.b.delete(this.c(i))}forEach(i,a){typeof a<"u"&&(i=i.bind(a));for(const[m,p]of this.b)i(p.value,p.uri,this)}*values(){for(const i of this.b.values())yield i.value}*keys(){for(const i of this.b.values())yield i.uri}*entries(){for(const i of this.b.values())yield[i.uri,i.value]}*[(D=Symbol.toStringTag,Symbol.iterator)](){for(const[,i]of this.b)yield[i.uri,i.value]}}e.$xi=$;class P{constructor(i,a){this[M]="ResourceSet",!i||typeof i=="function"?this.a=new $(i):(this.a=new $(a),i.forEach(this.add,this))}get size(){return this.a.size}add(i){return this.a.set(i,i),this}clear(){this.a.clear()}delete(i){return this.a.delete(i)}forEach(i,a){this.a.forEach((m,p)=>i.call(a,p,p,this))}has(i){return this.a.has(i)}entries(){return this.a.entries()}keys(){return this.a.keys()}values(){return this.a.keys()}[(M=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.$yi=P;var I;(function(r){r[r.None=0]="None",r[r.AsOld=1]="AsOld",r[r.AsNew=2]="AsNew"})(I||(e.Touch=I={}));class b{constructor(){this[h]="LinkedMap",this.a=new Map,this.b=void 0,this.c=void 0,this.d=0,this.e=0}clear(){this.a.clear(),this.b=void 0,this.c=void 0,this.d=0,this.e++}isEmpty(){return!this.b&&!this.c}get size(){return this.d}get first(){return this.b?.value}get last(){return this.c?.value}has(i){return this.a.has(i)}get(i,a=0){const m=this.a.get(i);if(m)return a!==0&&this.j(m,a),m.value}set(i,a,m=0){let p=this.a.get(i);if(p)p.value=a,m!==0&&this.j(p,m);else{switch(p={key:i,value:a,next:void 0,previous:void 0},m){case 0:this.h(p);break;case 1:this.g(p);break;case 2:this.h(p);break;default:this.h(p);break}this.a.set(i,p),this.d++}return this}delete(i){return!!this.remove(i)}remove(i){const a=this.a.get(i);if(a)return this.a.delete(i),this.i(a),this.d--,a.value}shift(){if(!this.b&&!this.c)return;if(!this.b||!this.c)throw new Error("Invalid list");const i=this.b;return this.a.delete(i.key),this.i(i),this.d--,i.value}forEach(i,a){const m=this.e;let p=this.b;for(;p;){if(a?i.bind(a)(p.value,p.key,this):i(p.value,p.key,this),this.e!==m)throw new Error("LinkedMap got modified during iteration.");p=p.next}}keys(){const i=this,a=this.e;let m=this.b;const p={[Symbol.iterator](){return p},next(){if(i.e!==a)throw new Error("LinkedMap got modified during iteration.");if(m){const f={value:m.key,done:!1};return m=m.next,f}else return{value:void 0,done:!0}}};return p}values(){const i=this,a=this.e;let m=this.b;const p={[Symbol.iterator](){return p},next(){if(i.e!==a)throw new Error("LinkedMap got modified during iteration.");if(m){const f={value:m.value,done:!1};return m=m.next,f}else return{value:void 0,done:!0}}};return p}entries(){const i=this,a=this.e;let m=this.b;const p={[Symbol.iterator](){return p},next(){if(i.e!==a)throw new Error("LinkedMap got modified during iteration.");if(m){const f={value:[m.key,m.value],done:!1};return m=m.next,f}else return{value:void 0,done:!0}}};return p}[(h=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}f(i){if(i>=this.size)return;if(i===0){this.clear();return}let a=this.b,m=this.size;for(;a&&m>i;)this.a.delete(a.key),a=a.next,m--;this.b=a,this.d=m,a&&(a.previous=void 0),this.e++}g(i){if(!this.b&&!this.c)this.c=i;else if(this.b)i.next=this.b,this.b.previous=i;else throw new Error("Invalid list");this.b=i,this.e++}h(i){if(!this.b&&!this.c)this.b=i;else if(this.c)i.previous=this.c,this.c.next=i;else throw new Error("Invalid list");this.c=i,this.e++}i(i){if(i===this.b&&i===this.c)this.b=void 0,this.c=void 0;else if(i===this.b){if(!i.next)throw new Error("Invalid list");i.next.previous=void 0,this.b=i.next}else if(i===this.c){if(!i.previous)throw new Error("Invalid list");i.previous.next=void 0,this.c=i.previous}else{const a=i.next,m=i.previous;if(!a||!m)throw new Error("Invalid list");a.previous=m,m.next=a}i.next=void 0,i.previous=void 0,this.e++}j(i,a){if(!this.b||!this.c)throw new Error("Invalid list");if(!(a!==1&&a!==2)){if(a===1){if(i===this.b)return;const m=i.next,p=i.previous;i===this.c?(p.next=void 0,this.c=p):(m.previous=p,p.next=m),i.previous=void 0,i.next=this.b,this.b.previous=i,this.b=i,this.e++}else if(a===2){if(i===this.c)return;const m=i.next,p=i.previous;i===this.b?(m.previous=void 0,this.b=m):(m.previous=p,p.next=m),i.next=void 0,i.previous=this.c,this.c.next=i,this.c=i,this.e++}}}toJSON(){const i=[];return this.forEach((a,m)=>{i.push([m,a])}),i}fromJSON(i){this.clear();for(const[a,m]of i)this.set(a,m)}}e.$zi=b;class S extends b{constructor(i,a=1){super(),this.k=i,this.l=Math.min(Math.max(0,a),1)}get limit(){return this.k}set limit(i){this.k=i,this.m()}get ratio(){return this.l}set ratio(i){this.l=Math.min(Math.max(0,i),1),this.m()}get(i,a=2){return super.get(i,a)}peek(i){return super.get(i,0)}set(i,a){return super.set(i,a,2),this.m(),this}m(){this.size>this.k&&this.f(Math.round(this.k*this.l))}}e.$Ai=S;class C{constructor(){this.a=new Map}add(i){return this.a.set(i,(this.a.get(i)||0)+1),this}delete(i){let a=this.a.get(i)||0;return a===0?!1:(a--,a===0?this.a.delete(i):this.a.set(i,a),!0)}has(i){return this.a.has(i)}}e.$Bi=C;class y{constructor(i){if(this.a=new Map,this.b=new Map,i)for(const[a,m]of i)this.set(a,m)}clear(){this.a.clear(),this.b.clear()}set(i,a){this.a.set(i,a),this.b.set(a,i)}get(i){return this.a.get(i)}getKey(i){return this.b.get(i)}delete(i){const a=this.a.get(i);return a===void 0?!1:(this.a.delete(i),this.b.delete(a),!0)}forEach(i,a){this.a.forEach((m,p)=>{i.call(a,m,p,this)})}keys(){return this.a.keys()}values(){return this.a.values()}}e.$Ci=y}),function($e,e){typeof define=="function"&&define.amd?define(De[156],Ce([0]),e):typeof exports=="object"&&typeof module<"u"?e(exports):($e=typeof globalThis<"u"?globalThis:$e||self,e($e.marked={}))}(this,function($e){"use strict";function e(ne,he){for(var Ee=0;Ee<he.length;Ee++){var de=he[Ee];de.enumerable=de.enumerable||!1,de.configurable=!0,"value"in de&&(de.writable=!0),Object.defineProperty(ne,de.key,de)}}function D(ne,he,Ee){return he&&e(ne.prototype,he),Ee&&e(ne,Ee),Object.defineProperty(ne,"prototype",{writable:!1}),ne}function M(ne,he){if(ne){if(typeof ne=="string")return h(ne,he);var Ee=Object.prototype.toString.call(ne).slice(8,-1);if(Ee==="Object"&&ne.constructor&&(Ee=ne.constructor.name),Ee==="Map"||Ee==="Set")return Array.from(ne);if(Ee==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(Ee))return h(ne,he)}}function h(ne,he){(he==null||he>ne.length)&&(he=ne.length);for(var Ee=0,de=new Array(he);Ee<he;Ee++)de[Ee]=ne[Ee];return de}function R(ne,he){var Ee=typeof Symbol<"u"&&ne[Symbol.iterator]||ne["@@iterator"];if(Ee)return(Ee=Ee.call(ne)).next.bind(Ee);if(Array.isArray(ne)||(Ee=M(ne))||he&&ne&&typeof ne.length=="number"){Ee&&(ne=Ee);var de=0;return function(){return de>=ne.length?{done:!0}:{done:!1,value:ne[de++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function A(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}$e.defaults=A();function g(ne){$e.defaults=ne}var E=/[&<>"']/,$=/[&<>"']/g,P=/[<>"']|&(?!#?\w+;)/,I=/[<>"']|&(?!#?\w+;)/g,b={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},S=function(he){return b[he]};function C(ne,he){if(he){if(E.test(ne))return ne.replace($,S)}else if(P.test(ne))return ne.replace(I,S);return ne}var y=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function r(ne){return ne.replace(y,function(he,Ee){return Ee=Ee.toLowerCase(),Ee==="colon"?":":Ee.charAt(0)==="#"?Ee.charAt(1)==="x"?String.fromCharCode(parseInt(Ee.substring(2),16)):String.fromCharCode(+Ee.substring(1)):""})}var i=/(^|[^\[])\^/g;function a(ne,he){ne=typeof ne=="string"?ne:ne.source,he=he||"";var Ee={replace:function(ge,ie){return ie=ie.source||ie,ie=ie.replace(i,"$1"),ne=ne.replace(ge,ie),Ee},getRegex:function(){return new RegExp(ne,he)}};return Ee}var m=/[^\w:]/g,p=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function f(ne,he,Ee){if(ne){var de;try{de=decodeURIComponent(r(Ee)).replace(m,"").toLowerCase()}catch{return null}if(de.indexOf("javascript:")===0||de.indexOf("vbscript:")===0||de.indexOf("data:")===0)return null}he&&!p.test(Ee)&&(Ee=c(he,Ee));try{Ee=encodeURI(Ee).replace(/%25/g,"%")}catch{return null}return Ee}var t={},s=/^[^:]+:\/*[^/]*$/,o=/^([^:]+:)[\s\S]*$/,n=/^([^:]+:\/*[^/]*)[\s\S]*$/;function c(ne,he){t[" "+ne]||(s.test(ne)?t[" "+ne]=ne+"/":t[" "+ne]=u(ne,"/",!0)),ne=t[" "+ne];var Ee=ne.indexOf(":")===-1;return he.substring(0,2)==="//"?Ee?he:ne.replace(o,"$1")+he:he.charAt(0)==="/"?Ee?he:ne.replace(n,"$1")+he:ne+he}var d={exec:function(){}};function v(ne){for(var he=1,Ee,de;he<arguments.length;he++){Ee=arguments[he];for(de in Ee)Object.prototype.hasOwnProperty.call(Ee,de)&&(ne[de]=Ee[de])}return ne}function k(ne,he){var Ee=ne.replace(/\|/g,function(ie,ue,we){for(var Pe=!1,U=ue;--U>=0&&we[U]==="\\";)Pe=!Pe;return Pe?"|":" |"}),de=Ee.split(/ \|/),ge=0;if(de[0].trim()||de.shift(),de.length>0&&!de[de.length-1].trim()&&de.pop(),de.length>he)de.splice(he);else for(;de.length<he;)de.push("");for(;ge<de.length;ge++)de[ge]=de[ge].trim().replace(/\\\|/g,"|");return de}function u(ne,he,Ee){var de=ne.length;if(de===0)return"";for(var ge=0;ge<de;){var ie=ne.charAt(de-ge-1);if(ie===he&&!Ee)ge++;else if(ie!==he&&Ee)ge++;else break}return ne.slice(0,de-ge)}function l(ne,he){if(ne.indexOf(he[1])===-1)return-1;for(var Ee=ne.length,de=0,ge=0;ge<Ee;ge++)if(ne[ge]==="\\")ge++;else if(ne[ge]===he[0])de++;else if(ne[ge]===he[1]&&(de--,de<0))return ge;return-1}function w(ne){ne&&ne.sanitize&&!ne.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function L(ne,he){if(he<1)return"";for(var Ee="";he>1;)he&1&&(Ee+=ne),he>>=1,ne+=ne;return Ee+ne}function N(ne,he,Ee,de){var ge=he.href,ie=he.title?C(he.title):null,ue=ne[1].replace(/\\([\[\]])/g,"$1");if(ne[0].charAt(0)!=="!"){de.state.inLink=!0;var we={type:"link",raw:Ee,href:ge,title:ie,text:ue,tokens:de.inlineTokens(ue)};return de.state.inLink=!1,we}return{type:"image",raw:Ee,href:ge,title:ie,text:C(ue)}}function j(ne,he){var Ee=ne.match(/^(\s+)(?:```)/);if(Ee===null)return he;var de=Ee[1];return he.split(`
`).map(function(ge){var ie=ge.match(/^\s+/);if(ie===null)return ge;var ue=ie[0];return ue.length>=de.length?ge.slice(de.length):ge}).join(`
`)}var T=function(){function ne(Ee){this.options=Ee||$e.defaults}var he=ne.prototype;return he.space=function(de){var ge=this.rules.block.newline.exec(de);if(ge&&ge[0].length>0)return{type:"space",raw:ge[0]}},he.code=function(de){var ge=this.rules.block.code.exec(de);if(ge){var ie=ge[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:ge[0],codeBlockStyle:"indented",text:this.options.pedantic?ie:u(ie,`
`)}}},he.fences=function(de){var ge=this.rules.block.fences.exec(de);if(ge){var ie=ge[0],ue=j(ie,ge[3]||"");return{type:"code",raw:ie,lang:ge[2]?ge[2].trim():ge[2],text:ue}}},he.heading=function(de){var ge=this.rules.block.heading.exec(de);if(ge){var ie=ge[2].trim();if(/#$/.test(ie)){var ue=u(ie,"#");(this.options.pedantic||!ue||/ $/.test(ue))&&(ie=ue.trim())}return{type:"heading",raw:ge[0],depth:ge[1].length,text:ie,tokens:this.lexer.inline(ie)}}},he.hr=function(de){var ge=this.rules.block.hr.exec(de);if(ge)return{type:"hr",raw:ge[0]}},he.blockquote=function(de){var ge=this.rules.block.blockquote.exec(de);if(ge){var ie=ge[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:ge[0],tokens:this.lexer.blockTokens(ie,[]),text:ie}}},he.list=function(de){var ge=this.rules.block.list.exec(de);if(ge){var ie,ue,we,Pe,U,Z,X,oe,Y,fe,ye,ze,Be=ge[1].trim(),xe=Be.length>1,Ye={type:"list",raw:"",ordered:xe,start:xe?+Be.slice(0,-1):"",loose:!1,items:[]};Be=xe?"\\d{1,9}\\"+Be.slice(-1):"\\"+Be,this.options.pedantic&&(Be=xe?Be:"[*+-]");for(var it=new RegExp("^( {0,3}"+Be+")((?:[	 ][^\\n]*)?(?:\\n|$))");de&&(ze=!1,!(!(ge=it.exec(de))||this.rules.block.hr.test(de)));){if(ie=ge[0],de=de.substring(ie.length),oe=ge[2].split(`
`,1)[0],Y=de.split(`
`,1)[0],this.options.pedantic?(Pe=2,ye=oe.trimLeft()):(Pe=ge[2].search(/[^ ]/),Pe=Pe>4?1:Pe,ye=oe.slice(Pe),Pe+=ge[1].length),Z=!1,!oe&&/^ *$/.test(Y)&&(ie+=Y+`
`,de=de.substring(Y.length+1),ze=!0),!ze)for(var et=new RegExp("^ {0,"+Math.min(3,Pe-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),Ae=new RegExp("^ {0,"+Math.min(3,Pe-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),Ne=new RegExp("^ {0,"+Math.min(3,Pe-1)+"}(?:```|~~~)"),We=new RegExp("^ {0,"+Math.min(3,Pe-1)+"}#");de&&(fe=de.split(`
`,1)[0],oe=fe,this.options.pedantic&&(oe=oe.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(Ne.test(oe)||We.test(oe)||et.test(oe)||Ae.test(de)));){if(oe.search(/[^ ]/)>=Pe||!oe.trim())ye+=`
`+oe.slice(Pe);else if(!Z)ye+=`
`+oe;else break;!Z&&!oe.trim()&&(Z=!0),ie+=fe+`
`,de=de.substring(fe.length+1)}Ye.loose||(X?Ye.loose=!0:/\n *\n *$/.test(ie)&&(X=!0)),this.options.gfm&&(ue=/^\[[ xX]\] /.exec(ye),ue&&(we=ue[0]!=="[ ] ",ye=ye.replace(/^\[[ xX]\] +/,""))),Ye.items.push({type:"list_item",raw:ie,task:!!ue,checked:we,loose:!1,text:ye}),Ye.raw+=ie}Ye.items[Ye.items.length-1].raw=ie.trimRight(),Ye.items[Ye.items.length-1].text=ye.trimRight(),Ye.raw=Ye.raw.trimRight();var Le=Ye.items.length;for(U=0;U<Le;U++){this.lexer.state.top=!1,Ye.items[U].tokens=this.lexer.blockTokens(Ye.items[U].text,[]);var Qe=Ye.items[U].tokens.filter(function(se){return se.type==="space"}),le=Qe.every(function(se){for(var Ie=se.raw.split(""),qe=0,je=R(Ie),Xe;!(Xe=je()).done;){var nt=Xe.value;if(nt===`
`&&(qe+=1),qe>1)return!0}return!1});!Ye.loose&&Qe.length&&le&&(Ye.loose=!0,Ye.items[U].loose=!0)}return Ye}},he.html=function(de){var ge=this.rules.block.html.exec(de);if(ge){var ie={type:"html",raw:ge[0],pre:!this.options.sanitizer&&(ge[1]==="pre"||ge[1]==="script"||ge[1]==="style"),text:ge[0]};if(this.options.sanitize){var ue=this.options.sanitizer?this.options.sanitizer(ge[0]):C(ge[0]);ie.type="paragraph",ie.text=ue,ie.tokens=this.lexer.inline(ue)}return ie}},he.def=function(de){var ge=this.rules.block.def.exec(de);if(ge){ge[3]&&(ge[3]=ge[3].substring(1,ge[3].length-1));var ie=ge[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:ie,raw:ge[0],href:ge[2],title:ge[3]}}},he.table=function(de){var ge=this.rules.block.table.exec(de);if(ge){var ie={type:"table",header:k(ge[1]).map(function(X){return{text:X}}),align:ge[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:ge[3]&&ge[3].trim()?ge[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(ie.header.length===ie.align.length){ie.raw=ge[0];var ue=ie.align.length,we,Pe,U,Z;for(we=0;we<ue;we++)/^ *-+: *$/.test(ie.align[we])?ie.align[we]="right":/^ *:-+: *$/.test(ie.align[we])?ie.align[we]="center":/^ *:-+ *$/.test(ie.align[we])?ie.align[we]="left":ie.align[we]=null;for(ue=ie.rows.length,we=0;we<ue;we++)ie.rows[we]=k(ie.rows[we],ie.header.length).map(function(X){return{text:X}});for(ue=ie.header.length,Pe=0;Pe<ue;Pe++)ie.header[Pe].tokens=this.lexer.inline(ie.header[Pe].text);for(ue=ie.rows.length,Pe=0;Pe<ue;Pe++)for(Z=ie.rows[Pe],U=0;U<Z.length;U++)Z[U].tokens=this.lexer.inline(Z[U].text);return ie}}},he.lheading=function(de){var ge=this.rules.block.lheading.exec(de);if(ge)return{type:"heading",raw:ge[0],depth:ge[2].charAt(0)==="="?1:2,text:ge[1],tokens:this.lexer.inline(ge[1])}},he.paragraph=function(de){var ge=this.rules.block.paragraph.exec(de);if(ge){var ie=ge[1].charAt(ge[1].length-1)===`
`?ge[1].slice(0,-1):ge[1];return{type:"paragraph",raw:ge[0],text:ie,tokens:this.lexer.inline(ie)}}},he.text=function(de){var ge=this.rules.block.text.exec(de);if(ge)return{type:"text",raw:ge[0],text:ge[0],tokens:this.lexer.inline(ge[0])}},he.escape=function(de){var ge=this.rules.inline.escape.exec(de);if(ge)return{type:"escape",raw:ge[0],text:C(ge[1])}},he.tag=function(de){var ge=this.rules.inline.tag.exec(de);if(ge)return!this.lexer.state.inLink&&/^<a /i.test(ge[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(ge[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(ge[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(ge[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:ge[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(ge[0]):C(ge[0]):ge[0]}},he.link=function(de){var ge=this.rules.inline.link.exec(de);if(ge){var ie=ge[2].trim();if(!this.options.pedantic&&/^</.test(ie)){if(!/>$/.test(ie))return;var ue=u(ie.slice(0,-1),"\\");if((ie.length-ue.length)%2===0)return}else{var we=l(ge[2],"()");if(we>-1){var Pe=ge[0].indexOf("!")===0?5:4,U=Pe+ge[1].length+we;ge[2]=ge[2].substring(0,we),ge[0]=ge[0].substring(0,U).trim(),ge[3]=""}}var Z=ge[2],X="";if(this.options.pedantic){var oe=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(Z);oe&&(Z=oe[1],X=oe[3])}else X=ge[3]?ge[3].slice(1,-1):"";return Z=Z.trim(),/^</.test(Z)&&(this.options.pedantic&&!/>$/.test(ie)?Z=Z.slice(1):Z=Z.slice(1,-1)),N(ge,{href:Z&&Z.replace(this.rules.inline._escapes,"$1"),title:X&&X.replace(this.rules.inline._escapes,"$1")},ge[0],this.lexer)}},he.reflink=function(de,ge){var ie;if((ie=this.rules.inline.reflink.exec(de))||(ie=this.rules.inline.nolink.exec(de))){var ue=(ie[2]||ie[1]).replace(/\s+/g," ");if(ue=ge[ue.toLowerCase()],!ue||!ue.href){var we=ie[0].charAt(0);return{type:"text",raw:we,text:we}}return N(ie,ue,ie[0],this.lexer)}},he.emStrong=function(de,ge,ie){ie===void 0&&(ie="");var ue=this.rules.inline.emStrong.lDelim.exec(de);if(ue&&!(ue[3]&&ie.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var we=ue[1]||ue[2]||"";if(!we||we&&(ie===""||this.rules.inline.punctuation.exec(ie))){var Pe=ue[0].length-1,U,Z,X=Pe,oe=0,Y=ue[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(Y.lastIndex=0,ge=ge.slice(-1*de.length+Pe);(ue=Y.exec(ge))!=null;)if(U=ue[1]||ue[2]||ue[3]||ue[4]||ue[5]||ue[6],!!U){if(Z=U.length,ue[3]||ue[4]){X+=Z;continue}else if((ue[5]||ue[6])&&Pe%3&&!((Pe+Z)%3)){oe+=Z;continue}if(X-=Z,!(X>0)){if(Z=Math.min(Z,Z+X+oe),Math.min(Pe,Z)%2){var fe=de.slice(1,Pe+ue.index+Z);return{type:"em",raw:de.slice(0,Pe+ue.index+Z+1),text:fe,tokens:this.lexer.inlineTokens(fe)}}var ye=de.slice(2,Pe+ue.index+Z-1);return{type:"strong",raw:de.slice(0,Pe+ue.index+Z+1),text:ye,tokens:this.lexer.inlineTokens(ye)}}}}}},he.codespan=function(de){var ge=this.rules.inline.code.exec(de);if(ge){var ie=ge[2].replace(/\n/g," "),ue=/[^ ]/.test(ie),we=/^ /.test(ie)&&/ $/.test(ie);return ue&&we&&(ie=ie.substring(1,ie.length-1)),ie=C(ie,!0),{type:"codespan",raw:ge[0],text:ie}}},he.br=function(de){var ge=this.rules.inline.br.exec(de);if(ge)return{type:"br",raw:ge[0]}},he.del=function(de){var ge=this.rules.inline.del.exec(de);if(ge)return{type:"del",raw:ge[0],text:ge[2],tokens:this.lexer.inlineTokens(ge[2])}},he.autolink=function(de,ge){var ie=this.rules.inline.autolink.exec(de);if(ie){var ue,we;return ie[2]==="@"?(ue=C(this.options.mangle?ge(ie[1]):ie[1]),we="mailto:"+ue):(ue=C(ie[1]),we=ue),{type:"link",raw:ie[0],text:ue,href:we,tokens:[{type:"text",raw:ue,text:ue}]}}},he.url=function(de,ge){var ie;if(ie=this.rules.inline.url.exec(de)){var ue,we;if(ie[2]==="@")ue=C(this.options.mangle?ge(ie[0]):ie[0]),we="mailto:"+ue;else{var Pe;do Pe=ie[0],ie[0]=this.rules.inline._backpedal.exec(ie[0])[0];while(Pe!==ie[0]);ue=C(ie[0]),ie[1]==="www."?we="http://"+ue:we=ue}return{type:"link",raw:ie[0],text:ue,href:we,tokens:[{type:"text",raw:ue,text:ue}]}}},he.inlineText=function(de,ge){var ie=this.rules.inline.text.exec(de);if(ie){var ue;return this.lexer.state.inRawBlock?ue=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(ie[0]):C(ie[0]):ie[0]:ue=C(this.options.smartypants?ge(ie[0]):ie[0]),{type:"text",raw:ie[0],text:ue}}},ne}(),O={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:d,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};O._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,O._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,O.def=a(O.def).replace("label",O._label).replace("title",O._title).getRegex(),O.bullet=/(?:[*+-]|\d{1,9}[.)])/,O.listItemStart=a(/^( *)(bull) */).replace("bull",O.bullet).getRegex(),O.list=a(O.list).replace(/bull/g,O.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+O.def.source+")").getRegex(),O._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",O._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,O.html=a(O.html,"i").replace("comment",O._comment).replace("tag",O._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),O.paragraph=a(O._paragraph).replace("hr",O.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",O._tag).getRegex(),O.blockquote=a(O.blockquote).replace("paragraph",O.paragraph).getRegex(),O.normal=v({},O),O.gfm=v({},O.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),O.gfm.table=a(O.gfm.table).replace("hr",O.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",O._tag).getRegex(),O.gfm.paragraph=a(O._paragraph).replace("hr",O.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",O.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",O._tag).getRegex(),O.pedantic=v({},O.normal,{html:a(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",O._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:d,paragraph:a(O.normal._paragraph).replace("hr",O.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",O.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var B={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:d,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:d,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};B._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",B.punctuation=a(B.punctuation).replace(/punctuation/g,B._punctuation).getRegex(),B.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,B.escapedEmSt=/\\\*|\\_/g,B._comment=a(O._comment).replace("(?:-->|$)","-->").getRegex(),B.emStrong.lDelim=a(B.emStrong.lDelim).replace(/punct/g,B._punctuation).getRegex(),B.emStrong.rDelimAst=a(B.emStrong.rDelimAst,"g").replace(/punct/g,B._punctuation).getRegex(),B.emStrong.rDelimUnd=a(B.emStrong.rDelimUnd,"g").replace(/punct/g,B._punctuation).getRegex(),B._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,B._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,B._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,B.autolink=a(B.autolink).replace("scheme",B._scheme).replace("email",B._email).getRegex(),B._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,B.tag=a(B.tag).replace("comment",B._comment).replace("attribute",B._attribute).getRegex(),B._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,B._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,B._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,B.link=a(B.link).replace("label",B._label).replace("href",B._href).replace("title",B._title).getRegex(),B.reflink=a(B.reflink).replace("label",B._label).replace("ref",O._label).getRegex(),B.nolink=a(B.nolink).replace("ref",O._label).getRegex(),B.reflinkSearch=a(B.reflinkSearch,"g").replace("reflink",B.reflink).replace("nolink",B.nolink).getRegex(),B.normal=v({},B),B.pedantic=v({},B.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:a(/^!?\[(label)\]\((.*?)\)/).replace("label",B._label).getRegex(),reflink:a(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",B._label).getRegex()}),B.gfm=v({},B.normal,{escape:a(B.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),B.gfm.url=a(B.gfm.url,"i").replace("email",B.gfm._extended_email).getRegex(),B.breaks=v({},B.gfm,{br:a(B.br).replace("{2,}","*").getRegex(),text:a(B.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function F(ne){return ne.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function J(ne){var he="",Ee,de,ge=ne.length;for(Ee=0;Ee<ge;Ee++)de=ne.charCodeAt(Ee),Math.random()>.5&&(de="x"+de.toString(16)),he+="&#"+de+";";return he}var K=function(){function ne(Ee){this.tokens=[],this.tokens.links=Object.create(null),this.options=Ee||$e.defaults,this.options.tokenizer=this.options.tokenizer||new T,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var de={block:O.normal,inline:B.normal};this.options.pedantic?(de.block=O.pedantic,de.inline=B.pedantic):this.options.gfm&&(de.block=O.gfm,this.options.breaks?de.inline=B.breaks:de.inline=B.gfm),this.tokenizer.rules=de}ne.lex=function(de,ge){var ie=new ne(ge);return ie.lex(de)},ne.lexInline=function(de,ge){var ie=new ne(ge);return ie.inlineTokens(de)};var he=ne.prototype;return he.lex=function(de){de=de.replace(/\r\n|\r/g,`
`),this.blockTokens(de,this.tokens);for(var ge;ge=this.inlineQueue.shift();)this.inlineTokens(ge.src,ge.tokens);return this.tokens},he.blockTokens=function(de,ge){var ie=this;ge===void 0&&(ge=[]),this.options.pedantic?de=de.replace(/\t/g,"    ").replace(/^ +$/gm,""):de=de.replace(/^( *)(\t+)/gm,function(X,oe,Y){return oe+"    ".repeat(Y.length)});for(var ue,we,Pe,U;de;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(X){return(ue=X.call({lexer:ie},de,ge))?(de=de.substring(ue.raw.length),ge.push(ue),!0):!1}))){if(ue=this.tokenizer.space(de)){de=de.substring(ue.raw.length),ue.raw.length===1&&ge.length>0?ge[ge.length-1].raw+=`
`:ge.push(ue);continue}if(ue=this.tokenizer.code(de)){de=de.substring(ue.raw.length),we=ge[ge.length-1],we&&(we.type==="paragraph"||we.type==="text")?(we.raw+=`
`+ue.raw,we.text+=`
`+ue.text,this.inlineQueue[this.inlineQueue.length-1].src=we.text):ge.push(ue);continue}if(ue=this.tokenizer.fences(de)){de=de.substring(ue.raw.length),ge.push(ue);continue}if(ue=this.tokenizer.heading(de)){de=de.substring(ue.raw.length),ge.push(ue);continue}if(ue=this.tokenizer.hr(de)){de=de.substring(ue.raw.length),ge.push(ue);continue}if(ue=this.tokenizer.blockquote(de)){de=de.substring(ue.raw.length),ge.push(ue);continue}if(ue=this.tokenizer.list(de)){de=de.substring(ue.raw.length),ge.push(ue);continue}if(ue=this.tokenizer.html(de)){de=de.substring(ue.raw.length),ge.push(ue);continue}if(ue=this.tokenizer.def(de)){de=de.substring(ue.raw.length),we=ge[ge.length-1],we&&(we.type==="paragraph"||we.type==="text")?(we.raw+=`
`+ue.raw,we.text+=`
`+ue.raw,this.inlineQueue[this.inlineQueue.length-1].src=we.text):this.tokens.links[ue.tag]||(this.tokens.links[ue.tag]={href:ue.href,title:ue.title});continue}if(ue=this.tokenizer.table(de)){de=de.substring(ue.raw.length),ge.push(ue);continue}if(ue=this.tokenizer.lheading(de)){de=de.substring(ue.raw.length),ge.push(ue);continue}if(Pe=de,this.options.extensions&&this.options.extensions.startBlock&&function(){var X=1/0,oe=de.slice(1),Y=void 0;ie.options.extensions.startBlock.forEach(function(fe){Y=fe.call({lexer:this},oe),typeof Y=="number"&&Y>=0&&(X=Math.min(X,Y))}),X<1/0&&X>=0&&(Pe=de.substring(0,X+1))}(),this.state.top&&(ue=this.tokenizer.paragraph(Pe))){we=ge[ge.length-1],U&&we.type==="paragraph"?(we.raw+=`
`+ue.raw,we.text+=`
`+ue.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=we.text):ge.push(ue),U=Pe.length!==de.length,de=de.substring(ue.raw.length);continue}if(ue=this.tokenizer.text(de)){de=de.substring(ue.raw.length),we=ge[ge.length-1],we&&we.type==="text"?(we.raw+=`
`+ue.raw,we.text+=`
`+ue.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=we.text):ge.push(ue);continue}if(de){var Z="Infinite loop on byte: "+de.charCodeAt(0);if(this.options.silent){console.error(Z);break}else throw new Error(Z)}}return this.state.top=!0,ge},he.inline=function(de,ge){return ge===void 0&&(ge=[]),this.inlineQueue.push({src:de,tokens:ge}),ge},he.inlineTokens=function(de,ge){var ie=this;ge===void 0&&(ge=[]);var ue,we,Pe,U=de,Z,X,oe;if(this.tokens.links){var Y=Object.keys(this.tokens.links);if(Y.length>0)for(;(Z=this.tokenizer.rules.inline.reflinkSearch.exec(U))!=null;)Y.includes(Z[0].slice(Z[0].lastIndexOf("[")+1,-1))&&(U=U.slice(0,Z.index)+"["+L("a",Z[0].length-2)+"]"+U.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(Z=this.tokenizer.rules.inline.blockSkip.exec(U))!=null;)U=U.slice(0,Z.index)+"["+L("a",Z[0].length-2)+"]"+U.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(Z=this.tokenizer.rules.inline.escapedEmSt.exec(U))!=null;)U=U.slice(0,Z.index)+"++"+U.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;de;)if(X||(oe=""),X=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(ye){return(ue=ye.call({lexer:ie},de,ge))?(de=de.substring(ue.raw.length),ge.push(ue),!0):!1}))){if(ue=this.tokenizer.escape(de)){de=de.substring(ue.raw.length),ge.push(ue);continue}if(ue=this.tokenizer.tag(de)){de=de.substring(ue.raw.length),we=ge[ge.length-1],we&&ue.type==="text"&&we.type==="text"?(we.raw+=ue.raw,we.text+=ue.text):ge.push(ue);continue}if(ue=this.tokenizer.link(de)){de=de.substring(ue.raw.length),ge.push(ue);continue}if(ue=this.tokenizer.reflink(de,this.tokens.links)){de=de.substring(ue.raw.length),we=ge[ge.length-1],we&&ue.type==="text"&&we.type==="text"?(we.raw+=ue.raw,we.text+=ue.text):ge.push(ue);continue}if(ue=this.tokenizer.emStrong(de,U,oe)){de=de.substring(ue.raw.length),ge.push(ue);continue}if(ue=this.tokenizer.codespan(de)){de=de.substring(ue.raw.length),ge.push(ue);continue}if(ue=this.tokenizer.br(de)){de=de.substring(ue.raw.length),ge.push(ue);continue}if(ue=this.tokenizer.del(de)){de=de.substring(ue.raw.length),ge.push(ue);continue}if(ue=this.tokenizer.autolink(de,J)){de=de.substring(ue.raw.length),ge.push(ue);continue}if(!this.state.inLink&&(ue=this.tokenizer.url(de,J))){de=de.substring(ue.raw.length),ge.push(ue);continue}if(Pe=de,this.options.extensions&&this.options.extensions.startInline&&function(){var ye=1/0,ze=de.slice(1),Be=void 0;ie.options.extensions.startInline.forEach(function(xe){Be=xe.call({lexer:this},ze),typeof Be=="number"&&Be>=0&&(ye=Math.min(ye,Be))}),ye<1/0&&ye>=0&&(Pe=de.substring(0,ye+1))}(),ue=this.tokenizer.inlineText(Pe,F)){de=de.substring(ue.raw.length),ue.raw.slice(-1)!=="_"&&(oe=ue.raw.slice(-1)),X=!0,we=ge[ge.length-1],we&&we.type==="text"?(we.raw+=ue.raw,we.text+=ue.text):ge.push(ue);continue}if(de){var fe="Infinite loop on byte: "+de.charCodeAt(0);if(this.options.silent){console.error(fe);break}else throw new Error(fe)}}return ge},D(ne,null,[{key:"rules",get:function(){return{block:O,inline:B}}}]),ne}(),me=function(){function ne(Ee){this.options=Ee||$e.defaults}var he=ne.prototype;return he.code=function(de,ge,ie){var ue=(ge||"").match(/\S*/)[0];if(this.options.highlight){var we=this.options.highlight(de,ue);we!=null&&we!==de&&(ie=!0,de=we)}return de=de.replace(/\n$/,"")+`
`,ue?'<pre><code class="'+this.options.langPrefix+C(ue,!0)+'">'+(ie?de:C(de,!0))+`</code></pre>
`:"<pre><code>"+(ie?de:C(de,!0))+`</code></pre>
`},he.blockquote=function(de){return`<blockquote>
`+de+`</blockquote>
`},he.html=function(de){return de},he.heading=function(de,ge,ie,ue){if(this.options.headerIds){var we=this.options.headerPrefix+ue.slug(ie);return"<h"+ge+' id="'+we+'">'+de+"</h"+ge+`>
`}return"<h"+ge+">"+de+"</h"+ge+`>
`},he.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},he.list=function(de,ge,ie){var ue=ge?"ol":"ul",we=ge&&ie!==1?' start="'+ie+'"':"";return"<"+ue+we+`>
`+de+"</"+ue+`>
`},he.listitem=function(de){return"<li>"+de+`</li>
`},he.checkbox=function(de){return"<input "+(de?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},he.paragraph=function(de){return"<p>"+de+`</p>
`},he.table=function(de,ge){return ge&&(ge="<tbody>"+ge+"</tbody>"),`<table>
<thead>
`+de+`</thead>
`+ge+`</table>
`},he.tablerow=function(de){return`<tr>
`+de+`</tr>
`},he.tablecell=function(de,ge){var ie=ge.header?"th":"td",ue=ge.align?"<"+ie+' align="'+ge.align+'">':"<"+ie+">";return ue+de+("</"+ie+`>
`)},he.strong=function(de){return"<strong>"+de+"</strong>"},he.em=function(de){return"<em>"+de+"</em>"},he.codespan=function(de){return"<code>"+de+"</code>"},he.br=function(){return this.options.xhtml?"<br/>":"<br>"},he.del=function(de){return"<del>"+de+"</del>"},he.link=function(de,ge,ie){if(de=f(this.options.sanitize,this.options.baseUrl,de),de===null)return ie;var ue='<a href="'+C(de)+'"';return ge&&(ue+=' title="'+ge+'"'),ue+=">"+ie+"</a>",ue},he.image=function(de,ge,ie){if(de=f(this.options.sanitize,this.options.baseUrl,de),de===null)return ie;var ue='<img src="'+de+'" alt="'+ie+'"';return ge&&(ue+=' title="'+ge+'"'),ue+=this.options.xhtml?"/>":">",ue},he.text=function(de){return de},ne}(),re=function(){function ne(){}var he=ne.prototype;return he.strong=function(de){return de},he.em=function(de){return de},he.codespan=function(de){return de},he.del=function(de){return de},he.html=function(de){return de},he.text=function(de){return de},he.link=function(de,ge,ie){return""+ie},he.image=function(de,ge,ie){return""+ie},he.br=function(){return""},ne}(),x=function(){function ne(){this.seen={}}var he=ne.prototype;return he.serialize=function(de){return de.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},he.getNextSafeSlug=function(de,ge){var ie=de,ue=0;if(this.seen.hasOwnProperty(ie)){ue=this.seen[de];do ue++,ie=de+"-"+ue;while(this.seen.hasOwnProperty(ie))}return ge||(this.seen[de]=ue,this.seen[ie]=0),ie},he.slug=function(de,ge){ge===void 0&&(ge={});var ie=this.serialize(de);return this.getNextSafeSlug(ie,ge.dryrun)},ne}(),q=function(){function ne(Ee){this.options=Ee||$e.defaults,this.options.renderer=this.options.renderer||new me,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new re,this.slugger=new x}ne.parse=function(de,ge){var ie=new ne(ge);return ie.parse(de)},ne.parseInline=function(de,ge){var ie=new ne(ge);return ie.parseInline(de)};var he=ne.prototype;return he.parse=function(de,ge){ge===void 0&&(ge=!0);var ie="",ue,we,Pe,U,Z,X,oe,Y,fe,ye,ze,Be,xe,Ye,it,et,Ae,Ne,We,Le=de.length;for(ue=0;ue<Le;ue++){if(ye=de[ue],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[ye.type]&&(We=this.options.extensions.renderers[ye.type].call({parser:this},ye),We!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(ye.type))){ie+=We||"";continue}switch(ye.type){case"space":continue;case"hr":{ie+=this.renderer.hr();continue}case"heading":{ie+=this.renderer.heading(this.parseInline(ye.tokens),ye.depth,r(this.parseInline(ye.tokens,this.textRenderer)),this.slugger);continue}case"code":{ie+=this.renderer.code(ye.text,ye.lang,ye.escaped);continue}case"table":{for(Y="",oe="",U=ye.header.length,we=0;we<U;we++)oe+=this.renderer.tablecell(this.parseInline(ye.header[we].tokens),{header:!0,align:ye.align[we]});for(Y+=this.renderer.tablerow(oe),fe="",U=ye.rows.length,we=0;we<U;we++){for(X=ye.rows[we],oe="",Z=X.length,Pe=0;Pe<Z;Pe++)oe+=this.renderer.tablecell(this.parseInline(X[Pe].tokens),{header:!1,align:ye.align[Pe]});fe+=this.renderer.tablerow(oe)}ie+=this.renderer.table(Y,fe);continue}case"blockquote":{fe=this.parse(ye.tokens),ie+=this.renderer.blockquote(fe);continue}case"list":{for(ze=ye.ordered,Be=ye.start,xe=ye.loose,U=ye.items.length,fe="",we=0;we<U;we++)it=ye.items[we],et=it.checked,Ae=it.task,Ye="",it.task&&(Ne=this.renderer.checkbox(et),xe?it.tokens.length>0&&it.tokens[0].type==="paragraph"?(it.tokens[0].text=Ne+" "+it.tokens[0].text,it.tokens[0].tokens&&it.tokens[0].tokens.length>0&&it.tokens[0].tokens[0].type==="text"&&(it.tokens[0].tokens[0].text=Ne+" "+it.tokens[0].tokens[0].text)):it.tokens.unshift({type:"text",text:Ne}):Ye+=Ne),Ye+=this.parse(it.tokens,xe),fe+=this.renderer.listitem(Ye,Ae,et);ie+=this.renderer.list(fe,ze,Be);continue}case"html":{ie+=this.renderer.html(ye.text);continue}case"paragraph":{ie+=this.renderer.paragraph(this.parseInline(ye.tokens));continue}case"text":{for(fe=ye.tokens?this.parseInline(ye.tokens):ye.text;ue+1<Le&&de[ue+1].type==="text";)ye=de[++ue],fe+=`
`+(ye.tokens?this.parseInline(ye.tokens):ye.text);ie+=ge?this.renderer.paragraph(fe):fe;continue}default:{var Qe='Token with "'+ye.type+'" type was not found.';if(this.options.silent){console.error(Qe);return}else throw new Error(Qe)}}}return ie},he.parseInline=function(de,ge){ge=ge||this.renderer;var ie="",ue,we,Pe,U=de.length;for(ue=0;ue<U;ue++){if(we=de[ue],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[we.type]&&(Pe=this.options.extensions.renderers[we.type].call({parser:this},we),Pe!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(we.type))){ie+=Pe||"";continue}switch(we.type){case"escape":{ie+=ge.text(we.text);break}case"html":{ie+=ge.html(we.text);break}case"link":{ie+=ge.link(we.href,we.title,this.parseInline(we.tokens,ge));break}case"image":{ie+=ge.image(we.href,we.title,we.text);break}case"strong":{ie+=ge.strong(this.parseInline(we.tokens,ge));break}case"em":{ie+=ge.em(this.parseInline(we.tokens,ge));break}case"codespan":{ie+=ge.codespan(we.text);break}case"br":{ie+=ge.br();break}case"del":{ie+=ge.del(this.parseInline(we.tokens,ge));break}case"text":{ie+=ge.text(we.text);break}default:{var Z='Token with "'+we.type+'" type was not found.';if(this.options.silent){console.error(Z);return}else throw new Error(Z)}}}return ie},ne}();function ee(ne,he,Ee){if(typeof ne>"u"||ne===null)throw new Error("marked(): input parameter is undefined or null");if(typeof ne!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(ne)+", string expected");if(typeof he=="function"&&(Ee=he,he=null),he=v({},ee.defaults,he||{}),w(he),Ee){var de=he.highlight,ge;try{ge=K.lex(ne,he)}catch(U){return Ee(U)}var ie=function(Z){var X;if(!Z)try{he.walkTokens&&ee.walkTokens(ge,he.walkTokens),X=q.parse(ge,he)}catch(oe){Z=oe}return he.highlight=de,Z?Ee(Z):Ee(null,X)};if(!de||de.length<3||(delete he.highlight,!ge.length))return ie();var ue=0;ee.walkTokens(ge,function(U){U.type==="code"&&(ue++,setTimeout(function(){de(U.text,U.lang,function(Z,X){if(Z)return ie(Z);X!=null&&X!==U.text&&(U.text=X,U.escaped=!0),ue--,ue===0&&ie()})},0))}),ue===0&&ie();return}function we(U){if(U.message+=`
Please report this to https://github.com/markedjs/marked.`,he.silent)return"<p>An error occurred:</p><pre>"+C(U.message+"",!0)+"</pre>";throw U}try{var Pe=K.lex(ne,he);if(he.walkTokens){if(he.async)return Promise.all(ee.walkTokens(Pe,he.walkTokens)).then(function(){return q.parse(Pe,he)}).catch(we);ee.walkTokens(Pe,he.walkTokens)}return q.parse(Pe,he)}catch(U){we(U)}}ee.options=ee.setOptions=function(ne){return v(ee.defaults,ne),g(ee.defaults),ee},ee.getDefaults=A,ee.defaults=$e.defaults,ee.use=function(){for(var ne=arguments.length,he=new Array(ne),Ee=0;Ee<ne;Ee++)he[Ee]=arguments[Ee];var de=v.apply(void 0,[{}].concat(he)),ge=ee.defaults.extensions||{renderers:{},childTokens:{}},ie;he.forEach(function(ue){if(ue.extensions&&(ie=!0,ue.extensions.forEach(function(Pe){if(!Pe.name)throw new Error("extension name required");if(Pe.renderer){var U=ge.renderers?ge.renderers[Pe.name]:null;U?ge.renderers[Pe.name]=function(){for(var Z=arguments.length,X=new Array(Z),oe=0;oe<Z;oe++)X[oe]=arguments[oe];var Y=Pe.renderer.apply(this,X);return Y===!1&&(Y=U.apply(this,X)),Y}:ge.renderers[Pe.name]=Pe.renderer}if(Pe.tokenizer){if(!Pe.level||Pe.level!=="block"&&Pe.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");ge[Pe.level]?ge[Pe.level].unshift(Pe.tokenizer):ge[Pe.level]=[Pe.tokenizer],Pe.start&&(Pe.level==="block"?ge.startBlock?ge.startBlock.push(Pe.start):ge.startBlock=[Pe.start]:Pe.level==="inline"&&(ge.startInline?ge.startInline.push(Pe.start):ge.startInline=[Pe.start]))}Pe.childTokens&&(ge.childTokens[Pe.name]=Pe.childTokens)})),ue.renderer&&function(){var Pe=ee.defaults.renderer||new me,U=function(oe){var Y=Pe[oe];Pe[oe]=function(){for(var fe=arguments.length,ye=new Array(fe),ze=0;ze<fe;ze++)ye[ze]=arguments[ze];var Be=ue.renderer[oe].apply(Pe,ye);return Be===!1&&(Be=Y.apply(Pe,ye)),Be}};for(var Z in ue.renderer)U(Z);de.renderer=Pe}(),ue.tokenizer&&function(){var Pe=ee.defaults.tokenizer||new T,U=function(oe){var Y=Pe[oe];Pe[oe]=function(){for(var fe=arguments.length,ye=new Array(fe),ze=0;ze<fe;ze++)ye[ze]=arguments[ze];var Be=ue.tokenizer[oe].apply(Pe,ye);return Be===!1&&(Be=Y.apply(Pe,ye)),Be}};for(var Z in ue.tokenizer)U(Z);de.tokenizer=Pe}(),ue.walkTokens){var we=ee.defaults.walkTokens;de.walkTokens=function(Pe){var U=[];return U.push(ue.walkTokens.call(this,Pe)),we&&(U=U.concat(we.call(this,Pe))),U}}ie&&(de.extensions=ge),ee.setOptions(de)})},ee.walkTokens=function(ne,he){for(var Ee=[],de=function(){var we=ie.value;switch(Ee=Ee.concat(he.call(ee,we)),we.type){case"table":{for(var Pe=R(we.header),U;!(U=Pe()).done;){var Z=U.value;Ee=Ee.concat(ee.walkTokens(Z.tokens,he))}for(var X=R(we.rows),oe;!(oe=X()).done;)for(var Y=oe.value,fe=R(Y),ye;!(ye=fe()).done;){var ze=ye.value;Ee=Ee.concat(ee.walkTokens(ze.tokens,he))}break}case"list":{Ee=Ee.concat(ee.walkTokens(we.items,he));break}default:ee.defaults.extensions&&ee.defaults.extensions.childTokens&&ee.defaults.extensions.childTokens[we.type]?ee.defaults.extensions.childTokens[we.type].forEach(function(Be){Ee=Ee.concat(ee.walkTokens(we[Be],he))}):we.tokens&&(Ee=Ee.concat(ee.walkTokens(we.tokens,he)))}},ge=R(ne),ie;!(ie=ge()).done;)de();return Ee},ee.parseInline=function(ne,he){if(typeof ne>"u"||ne===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof ne!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(ne)+", string expected");he=v({},ee.defaults,he||{}),w(he);try{var Ee=K.lexInline(ne,he);return he.walkTokens&&ee.walkTokens(Ee,he.walkTokens),q.parseInline(Ee,he)}catch(de){if(de.message+=`
Please report this to https://github.com/markedjs/marked.`,he.silent)return"<p>An error occurred:</p><pre>"+C(de.message+"",!0)+"</pre>";throw de}},ee.Parser=q,ee.parser=q.parse,ee.Renderer=me,ee.TextRenderer=re,ee.Lexer=K,ee.lexer=K.lex,ee.Tokenizer=T,ee.Slugger=x,ee.parse=ee;var pe=ee.options,ce=ee.setOptions,_=ee.use,Q=ee.walkTokens,z=ee.parseInline,V=ee,G=q.parse,ae=K.lex;$e.Lexer=K,$e.Parser=q,$e.Renderer=me,$e.Slugger=x,$e.TextRenderer=re,$e.Tokenizer=T,$e.getDefaults=A,$e.lexer=ae,$e.marked=ee,$e.options=pe,$e.parse=V,$e.parseInline=z,$e.parser=G,$e.setOptions=ce,$e.use=_,$e.walkTokens=Q,Object.defineProperty($e,"__esModule",{value:!0})}),define(De[73],Ce([1,0,28]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hl=e.$gl=e.$fl=void 0;const M=new D.$Ai(1e4);function h($){return E($,"NFC",M)}e.$fl=h;const R=new D.$Ai(1e4);function A($){return E($,"NFD",R)}e.$gl=A;const g=/[^\u0000-\u0080]/;function E($,P,I){if(!$)return $;const b=I.get($);if(b)return b;let S;return g.test($)?S=$.normalize(P):S=$,I.set($,S),S}e.$hl=function(){const $=/[\u0300-\u036f]/g;return function(P){return A(P).replace($,"")}}()}),define(De[119],Ce([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jl=e.$Il=e.$Hl=e.rot=e.$Fl=void 0;function D(g,E,$){return Math.min(Math.max(g,E),$)}e.$Fl=D;function M(g,E){return(E+g%E)%E}e.rot=M;class h{constructor(){this.a=0}getNext(){return this.a++}}e.$Hl=h;class R{constructor(){this.a=1,this.b=0}update(E){return this.b=this.b+(E-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.$Il=R;class A{constructor(E){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(E),this.c.fill(0,0,E)}update(E){const $=this.c[this.d];return this.c[this.d]=E,this.d=(this.d+1)%this.c.length,this.e-=$,this.e+=E,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.$Jl=A}),function(){function $e(h){const R=[];typeof h=="number"&&R.push("code/timeOrigin",h);function A(E){R.push(E,Date.now())}function g(){const E=[];for(let $=0;$<R.length;$+=2)E.push({name:R[$],startTime:R[$+1]});return E}return{mark:A,getMarks:g}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?$e():{mark(h){performance.mark(h)},getMarks(){let h=performance.timeOrigin;typeof h!="number"&&(h=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const R=[{name:"code/timeOrigin",startTime:Math.round(h)}];for(const A of performance.getEntriesByType("mark"))R.push({name:A.name,startTime:Math.round(h+A.startTime)});return R}};if(typeof process=="object"){const h=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return $e(h)}else return console.trace("perf-util loaded in UNKNOWN environment"),$e()}function D(h){return h.MonacoPerformanceMarks||(h.MonacoPerformanceMarks=e()),h.MonacoPerformanceMarks}var M;typeof global=="object"?M=global:typeof self=="object"?M=self:M={},typeof define=="function"?define("vs/base/common/performance",[],function(){return D(M)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=D(M):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),M.perf=D(M))}(),function($e,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var D=e();for(var M in D)(typeof exports=="object"?exports:$e)[M]=D[M]}}(typeof self<"u"?self:this,function(){return function($e){var e={};function D(M){if(e[M])return e[M].exports;var h=e[M]={i:M,l:!1,exports:{}};return $e[M].call(h.exports,h,h.exports,D),h.l=!0,h.exports}return D.m=$e,D.c=e,D.d=function(M,h,R){D.o(M,h)||Object.defineProperty(M,h,{enumerable:!0,get:R})},D.r=function(M){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(M,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(M,"__esModule",{value:!0})},D.t=function(M,h){if(1&h&&(M=D(M)),8&h||4&h&&typeof M=="object"&&M&&M.__esModule)return M;var R=Object.create(null);if(D.r(R),Object.defineProperty(R,"default",{enumerable:!0,value:M}),2&h&&typeof M!="string")for(var A in M)D.d(R,A,function(g){return M[g]}.bind(null,A));return R},D.n=function(M){var h=M&&M.__esModule?function(){return M.default}:function(){return M};return D.d(h,"a",h),h},D.o=function(M,h){return Object.prototype.hasOwnProperty.call(M,h)},D.p="",D(D.s=0)}([function($e,e,D){(function(M){var h;e=$e.exports=_,h=typeof M=="object"&&M.env&&M.env.NODE_DEBUG&&/\bsemver\b/i.test(M.env.NODE_DEBUG)?function(){var Y=Array.prototype.slice.call(arguments,0);Y.unshift("SEMVER"),console.log.apply(console,Y)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var R=256,A=Number.MAX_SAFE_INTEGER||9007199254740991,g=e.re=[],E=e.src=[],$=0,P=$++;E[P]="0|[1-9]\\d*";var I=$++;E[I]="[0-9]+";var b=$++;E[b]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var S=$++;E[S]="("+E[P]+")\\.("+E[P]+")\\.("+E[P]+")";var C=$++;E[C]="("+E[I]+")\\.("+E[I]+")\\.("+E[I]+")";var y=$++;E[y]="(?:"+E[P]+"|"+E[b]+")";var r=$++;E[r]="(?:"+E[I]+"|"+E[b]+")";var i=$++;E[i]="(?:-("+E[y]+"(?:\\."+E[y]+")*))";var a=$++;E[a]="(?:-?("+E[r]+"(?:\\."+E[r]+")*))";var m=$++;E[m]="[0-9A-Za-z-]+";var p=$++;E[p]="(?:\\+("+E[m]+"(?:\\."+E[m]+")*))";var f=$++,t="v?"+E[S]+E[i]+"?"+E[p]+"?";E[f]="^"+t+"$";var s="[v=\\s]*"+E[C]+E[a]+"?"+E[p]+"?",o=$++;E[o]="^"+s+"$";var n=$++;E[n]="((?:<|>)?=?)";var c=$++;E[c]=E[I]+"|x|X|\\*";var d=$++;E[d]=E[P]+"|x|X|\\*";var v=$++;E[v]="[v=\\s]*("+E[d]+")(?:\\.("+E[d]+")(?:\\.("+E[d]+")(?:"+E[i]+")?"+E[p]+"?)?)?";var k=$++;E[k]="[v=\\s]*("+E[c]+")(?:\\.("+E[c]+")(?:\\.("+E[c]+")(?:"+E[a]+")?"+E[p]+"?)?)?";var u=$++;E[u]="^"+E[n]+"\\s*"+E[v]+"$";var l=$++;E[l]="^"+E[n]+"\\s*"+E[k]+"$";var w=$++;E[w]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var L=$++;E[L]="(?:~>?)";var N=$++;E[N]="(\\s*)"+E[L]+"\\s+",g[N]=new RegExp(E[N],"g");var j=$++;E[j]="^"+E[L]+E[v]+"$";var T=$++;E[T]="^"+E[L]+E[k]+"$";var O=$++;E[O]="(?:\\^)";var B=$++;E[B]="(\\s*)"+E[O]+"\\s+",g[B]=new RegExp(E[B],"g");var F=$++;E[F]="^"+E[O]+E[v]+"$";var J=$++;E[J]="^"+E[O]+E[k]+"$";var K=$++;E[K]="^"+E[n]+"\\s*("+s+")$|^$";var me=$++;E[me]="^"+E[n]+"\\s*("+t+")$|^$";var re=$++;E[re]="(\\s*)"+E[n]+"\\s*("+s+"|"+E[v]+")",g[re]=new RegExp(E[re],"g");var x=$++;E[x]="^\\s*("+E[v]+")\\s+-\\s+("+E[v]+")\\s*$";var q=$++;E[q]="^\\s*("+E[k]+")\\s+-\\s+("+E[k]+")\\s*$";var ee=$++;E[ee]="(<|>)?=?\\s*\\*";for(var pe=0;pe<35;pe++)h(pe,E[pe]),g[pe]||(g[pe]=new RegExp(E[pe]));function ce(Y,fe){if(Y instanceof _)return Y;if(typeof Y!="string"||Y.length>R||!(fe?g[o]:g[f]).test(Y))return null;try{return new _(Y,fe)}catch{return null}}function _(Y,fe){if(Y instanceof _){if(Y.loose===fe)return Y;Y=Y.version}else if(typeof Y!="string")throw new TypeError("Invalid Version: "+Y);if(Y.length>R)throw new TypeError("version is longer than "+R+" characters");if(!(this instanceof _))return new _(Y,fe);h("SemVer",Y,fe),this.loose=fe;var ye=Y.trim().match(fe?g[o]:g[f]);if(!ye)throw new TypeError("Invalid Version: "+Y);if(this.raw=Y,this.major=+ye[1],this.minor=+ye[2],this.patch=+ye[3],this.major>A||this.major<0)throw new TypeError("Invalid major version");if(this.minor>A||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>A||this.patch<0)throw new TypeError("Invalid patch version");ye[4]?this.prerelease=ye[4].split(".").map(function(ze){if(/^[0-9]+$/.test(ze)){var Be=+ze;if(Be>=0&&Be<A)return Be}return ze}):this.prerelease=[],this.build=ye[5]?ye[5].split("."):[],this.format()}e.parse=ce,e.valid=function(Y,fe){var ye=ce(Y,fe);return ye?ye.version:null},e.clean=function(Y,fe){var ye=ce(Y.trim().replace(/^[=v]+/,""),fe);return ye?ye.version:null},e.SemVer=_,_.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},_.prototype.toString=function(){return this.version},_.prototype.compare=function(Y){return h("SemVer.compare",this.version,this.loose,Y),Y instanceof _||(Y=new _(Y,this.loose)),this.compareMain(Y)||this.comparePre(Y)},_.prototype.compareMain=function(Y){return Y instanceof _||(Y=new _(Y,this.loose)),z(this.major,Y.major)||z(this.minor,Y.minor)||z(this.patch,Y.patch)},_.prototype.comparePre=function(Y){if(Y instanceof _||(Y=new _(Y,this.loose)),this.prerelease.length&&!Y.prerelease.length)return-1;if(!this.prerelease.length&&Y.prerelease.length)return 1;if(!this.prerelease.length&&!Y.prerelease.length)return 0;var fe=0;do{var ye=this.prerelease[fe],ze=Y.prerelease[fe];if(h("prerelease compare",fe,ye,ze),ye===void 0&&ze===void 0)return 0;if(ze===void 0)return 1;if(ye===void 0)return-1;if(ye!==ze)return z(ye,ze)}while(++fe)},_.prototype.inc=function(Y,fe){switch(Y){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",fe);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",fe);break;case"prepatch":this.prerelease.length=0,this.inc("patch",fe),this.inc("pre",fe);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",fe),this.inc("pre",fe);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var ye=this.prerelease.length;--ye>=0;)typeof this.prerelease[ye]=="number"&&(this.prerelease[ye]++,ye=-2);ye===-1&&this.prerelease.push(0)}fe&&(this.prerelease[0]===fe?isNaN(this.prerelease[1])&&(this.prerelease=[fe,0]):this.prerelease=[fe,0]);break;default:throw new Error("invalid increment argument: "+Y)}return this.format(),this.raw=this.version,this},e.inc=function(Y,fe,ye,ze){typeof ye=="string"&&(ze=ye,ye=void 0);try{return new _(Y,ye).inc(fe,ze).version}catch{return null}},e.diff=function(Y,fe){if(ne(Y,fe))return null;var ye=ce(Y),ze=ce(fe);if(ye.prerelease.length||ze.prerelease.length){for(var Be in ye)if((Be==="major"||Be==="minor"||Be==="patch")&&ye[Be]!==ze[Be])return"pre"+Be;return"prerelease"}for(var Be in ye)if((Be==="major"||Be==="minor"||Be==="patch")&&ye[Be]!==ze[Be])return Be},e.compareIdentifiers=z;var Q=/^[0-9]+$/;function z(Y,fe){var ye=Q.test(Y),ze=Q.test(fe);return ye&&ze&&(Y=+Y,fe=+fe),ye&&!ze?-1:ze&&!ye?1:Y<fe?-1:Y>fe?1:0}function V(Y,fe,ye){return new _(Y,ye).compare(new _(fe,ye))}function G(Y,fe,ye){return V(Y,fe,ye)>0}function ae(Y,fe,ye){return V(Y,fe,ye)<0}function ne(Y,fe,ye){return V(Y,fe,ye)===0}function he(Y,fe,ye){return V(Y,fe,ye)!==0}function Ee(Y,fe,ye){return V(Y,fe,ye)>=0}function de(Y,fe,ye){return V(Y,fe,ye)<=0}function ge(Y,fe,ye,ze){var Be;switch(fe){case"===":typeof Y=="object"&&(Y=Y.version),typeof ye=="object"&&(ye=ye.version),Be=Y===ye;break;case"!==":typeof Y=="object"&&(Y=Y.version),typeof ye=="object"&&(ye=ye.version),Be=Y!==ye;break;case"":case"=":case"==":Be=ne(Y,ye,ze);break;case"!=":Be=he(Y,ye,ze);break;case">":Be=G(Y,ye,ze);break;case">=":Be=Ee(Y,ye,ze);break;case"<":Be=ae(Y,ye,ze);break;case"<=":Be=de(Y,ye,ze);break;default:throw new TypeError("Invalid operator: "+fe)}return Be}function ie(Y,fe){if(Y instanceof ie){if(Y.loose===fe)return Y;Y=Y.value}if(!(this instanceof ie))return new ie(Y,fe);h("comparator",Y,fe),this.loose=fe,this.parse(Y),this.semver===ue?this.value="":this.value=this.operator+this.semver.version,h("comp",this)}e.rcompareIdentifiers=function(Y,fe){return z(fe,Y)},e.major=function(Y,fe){return new _(Y,fe).major},e.minor=function(Y,fe){return new _(Y,fe).minor},e.patch=function(Y,fe){return new _(Y,fe).patch},e.compare=V,e.compareLoose=function(Y,fe){return V(Y,fe,!0)},e.rcompare=function(Y,fe,ye){return V(fe,Y,ye)},e.sort=function(Y,fe){return Y.sort(function(ye,ze){return e.compare(ye,ze,fe)})},e.rsort=function(Y,fe){return Y.sort(function(ye,ze){return e.rcompare(ye,ze,fe)})},e.gt=G,e.lt=ae,e.eq=ne,e.neq=he,e.gte=Ee,e.lte=de,e.cmp=ge,e.Comparator=ie;var ue={};function we(Y,fe){if(Y instanceof we)return Y.loose===fe?Y:new we(Y.raw,fe);if(Y instanceof ie)return new we(Y.value,fe);if(!(this instanceof we))return new we(Y,fe);if(this.loose=fe,this.raw=Y,this.set=Y.split(/\s*\|\|\s*/).map(function(ye){return this.parseRange(ye.trim())},this).filter(function(ye){return ye.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+Y);this.format()}function Pe(Y){return!Y||Y.toLowerCase()==="x"||Y==="*"}function U(Y,fe,ye,ze,Be,xe,Ye,it,et,Ae,Ne,We,Le){return((fe=Pe(ye)?"":Pe(ze)?">="+ye+".0.0":Pe(Be)?">="+ye+"."+ze+".0":">="+fe)+" "+(it=Pe(et)?"":Pe(Ae)?"<"+(+et+1)+".0.0":Pe(Ne)?"<"+et+"."+(+Ae+1)+".0":We?"<="+et+"."+Ae+"."+Ne+"-"+We:"<="+it)).trim()}function Z(Y,fe){for(var ye=0;ye<Y.length;ye++)if(!Y[ye].test(fe))return!1;if(fe.prerelease.length){for(ye=0;ye<Y.length;ye++)if(h(Y[ye].semver),Y[ye].semver!==ue&&Y[ye].semver.prerelease.length>0){var ze=Y[ye].semver;if(ze.major===fe.major&&ze.minor===fe.minor&&ze.patch===fe.patch)return!0}return!1}return!0}function X(Y,fe,ye){try{fe=new we(fe,ye)}catch{return!1}return fe.test(Y)}function oe(Y,fe,ye,ze){var Be,xe,Ye,it,et;switch(Y=new _(Y,ze),fe=new we(fe,ze),ye){case">":Be=G,xe=de,Ye=ae,it=">",et=">=";break;case"<":Be=ae,xe=Ee,Ye=G,it="<",et="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(X(Y,fe,ze))return!1;for(var Ae=0;Ae<fe.set.length;++Ae){var Ne=fe.set[Ae],We=null,Le=null;if(Ne.forEach(function(Qe){Qe.semver===ue&&(Qe=new ie(">=0.0.0")),We=We||Qe,Le=Le||Qe,Be(Qe.semver,We.semver,ze)?We=Qe:Ye(Qe.semver,Le.semver,ze)&&(Le=Qe)}),We.operator===it||We.operator===et||(!Le.operator||Le.operator===it)&&xe(Y,Le.semver)||Le.operator===et&&Ye(Y,Le.semver))return!1}return!0}ie.prototype.parse=function(Y){var fe=this.loose?g[K]:g[me],ye=Y.match(fe);if(!ye)throw new TypeError("Invalid comparator: "+Y);this.operator=ye[1],this.operator==="="&&(this.operator=""),ye[2]?this.semver=new _(ye[2],this.loose):this.semver=ue},ie.prototype.toString=function(){return this.value},ie.prototype.test=function(Y){return h("Comparator.test",Y,this.loose),this.semver===ue||(typeof Y=="string"&&(Y=new _(Y,this.loose)),ge(Y,this.operator,this.semver,this.loose))},ie.prototype.intersects=function(Y,fe){if(!(Y instanceof ie))throw new TypeError("a Comparator is required");var ye;if(this.operator==="")return ye=new we(Y.value,fe),X(this.value,ye,fe);if(Y.operator==="")return ye=new we(this.value,fe),X(Y.semver,ye,fe);var ze=!(this.operator!==">="&&this.operator!==">"||Y.operator!==">="&&Y.operator!==">"),Be=!(this.operator!=="<="&&this.operator!=="<"||Y.operator!=="<="&&Y.operator!=="<"),xe=this.semver.version===Y.semver.version,Ye=!(this.operator!==">="&&this.operator!=="<="||Y.operator!==">="&&Y.operator!=="<="),it=ge(this.semver,"<",Y.semver,fe)&&(this.operator===">="||this.operator===">")&&(Y.operator==="<="||Y.operator==="<"),et=ge(this.semver,">",Y.semver,fe)&&(this.operator==="<="||this.operator==="<")&&(Y.operator===">="||Y.operator===">");return ze||Be||xe&&Ye||it||et},e.Range=we,we.prototype.format=function(){return this.range=this.set.map(function(Y){return Y.join(" ").trim()}).join("||").trim(),this.range},we.prototype.toString=function(){return this.range},we.prototype.parseRange=function(Y){var fe=this.loose;Y=Y.trim(),h("range",Y,fe);var ye=fe?g[q]:g[x];Y=Y.replace(ye,U),h("hyphen replace",Y),Y=Y.replace(g[re],"$1$2$3"),h("comparator trim",Y,g[re]),Y=(Y=(Y=Y.replace(g[N],"$1~")).replace(g[B],"$1^")).split(/\s+/).join(" ");var ze=fe?g[K]:g[me],Be=Y.split(" ").map(function(xe){return function(Ye,it){return h("comp",Ye),Ye=function(et,Ae){return et.trim().split(/\s+/).map(function(Ne){return function(We,Le){h("caret",We,Le);var Qe=Le?g[J]:g[F];return We.replace(Qe,function(le,se,Ie,qe,je){var Xe;return h("caret",We,le,se,Ie,qe,je),Pe(se)?Xe="":Pe(Ie)?Xe=">="+se+".0.0 <"+(+se+1)+".0.0":Pe(qe)?Xe=se==="0"?">="+se+"."+Ie+".0 <"+se+"."+(+Ie+1)+".0":">="+se+"."+Ie+".0 <"+(+se+1)+".0.0":je?(h("replaceCaret pr",je),je.charAt(0)!=="-"&&(je="-"+je),Xe=se==="0"?Ie==="0"?">="+se+"."+Ie+"."+qe+je+" <"+se+"."+Ie+"."+(+qe+1):">="+se+"."+Ie+"."+qe+je+" <"+se+"."+(+Ie+1)+".0":">="+se+"."+Ie+"."+qe+je+" <"+(+se+1)+".0.0"):(h("no pr"),Xe=se==="0"?Ie==="0"?">="+se+"."+Ie+"."+qe+" <"+se+"."+Ie+"."+(+qe+1):">="+se+"."+Ie+"."+qe+" <"+se+"."+(+Ie+1)+".0":">="+se+"."+Ie+"."+qe+" <"+(+se+1)+".0.0"),h("caret return",Xe),Xe})}(Ne,Ae)}).join(" ")}(Ye,it),h("caret",Ye),Ye=function(et,Ae){return et.trim().split(/\s+/).map(function(Ne){return function(We,Le){var Qe=Le?g[T]:g[j];return We.replace(Qe,function(le,se,Ie,qe,je){var Xe;return h("tilde",We,le,se,Ie,qe,je),Pe(se)?Xe="":Pe(Ie)?Xe=">="+se+".0.0 <"+(+se+1)+".0.0":Pe(qe)?Xe=">="+se+"."+Ie+".0 <"+se+"."+(+Ie+1)+".0":je?(h("replaceTilde pr",je),je.charAt(0)!=="-"&&(je="-"+je),Xe=">="+se+"."+Ie+"."+qe+je+" <"+se+"."+(+Ie+1)+".0"):Xe=">="+se+"."+Ie+"."+qe+" <"+se+"."+(+Ie+1)+".0",h("tilde return",Xe),Xe})}(Ne,Ae)}).join(" ")}(Ye,it),h("tildes",Ye),Ye=function(et,Ae){return h("replaceXRanges",et,Ae),et.split(/\s+/).map(function(Ne){return function(We,Le){We=We.trim();var Qe=Le?g[l]:g[u];return We.replace(Qe,function(le,se,Ie,qe,je,Xe){h("xRange",We,le,se,Ie,qe,je,Xe);var nt=Pe(Ie),ot=nt||Pe(qe),bt=ot||Pe(je);return se==="="&&bt&&(se=""),nt?le=se===">"||se==="<"?"<0.0.0":"*":se&&bt?(ot&&(qe=0),bt&&(je=0),se===">"?(se=">=",ot?(Ie=+Ie+1,qe=0,je=0):bt&&(qe=+qe+1,je=0)):se==="<="&&(se="<",ot?Ie=+Ie+1:qe=+qe+1),le=se+Ie+"."+qe+"."+je):ot?le=">="+Ie+".0.0 <"+(+Ie+1)+".0.0":bt&&(le=">="+Ie+"."+qe+".0 <"+Ie+"."+(+qe+1)+".0"),h("xRange return",le),le})}(Ne,Ae)}).join(" ")}(Ye,it),h("xrange",Ye),Ye=function(et,Ae){return h("replaceStars",et,Ae),et.trim().replace(g[ee],"")}(Ye,it),h("stars",Ye),Ye}(xe,fe)}).join(" ").split(/\s+/);return this.loose&&(Be=Be.filter(function(xe){return!!xe.match(ze)})),Be=Be.map(function(xe){return new ie(xe,fe)})},we.prototype.intersects=function(Y,fe){if(!(Y instanceof we))throw new TypeError("a Range is required");return this.set.some(function(ye){return ye.every(function(ze){return Y.set.some(function(Be){return Be.every(function(xe){return ze.intersects(xe,fe)})})})})},e.toComparators=function(Y,fe){return new we(Y,fe).set.map(function(ye){return ye.map(function(ze){return ze.value}).join(" ").trim().split(" ")})},we.prototype.test=function(Y){if(!Y)return!1;typeof Y=="string"&&(Y=new _(Y,this.loose));for(var fe=0;fe<this.set.length;fe++)if(Z(this.set[fe],Y))return!0;return!1},e.satisfies=X,e.maxSatisfying=function(Y,fe,ye){var ze=null,Be=null;try{var xe=new we(fe,ye)}catch{return null}return Y.forEach(function(Ye){xe.test(Ye)&&(ze&&Be.compare(Ye)!==-1||(Be=new _(ze=Ye,ye)))}),ze},e.minSatisfying=function(Y,fe,ye){var ze=null,Be=null;try{var xe=new we(fe,ye)}catch{return null}return Y.forEach(function(Ye){xe.test(Ye)&&(ze&&Be.compare(Ye)!==1||(Be=new _(ze=Ye,ye)))}),ze},e.validRange=function(Y,fe){try{return new we(Y,fe).range||"*"}catch{return null}},e.ltr=function(Y,fe,ye){return oe(Y,fe,"<",ye)},e.gtr=function(Y,fe,ye){return oe(Y,fe,">",ye)},e.outside=oe,e.prerelease=function(Y,fe){var ye=ce(Y,fe);return ye&&ye.prerelease.length?ye.prerelease:null},e.intersects=function(Y,fe,ye){return Y=new we(Y,ye),fe=new we(fe,ye),Y.intersects(fe)},e.coerce=function(Y){if(Y instanceof _)return Y;if(typeof Y!="string")return null;var fe=Y.match(g[w]);return fe==null?null:ce((fe[1]||"0")+"."+(fe[2]||"0")+"."+(fe[3]||"0"))}}).call(this,D(1))},function($e,e){var D,M,h=$e.exports={};function R(){throw new Error("setTimeout has not been defined")}function A(){throw new Error("clearTimeout has not been defined")}function g(r){if(D===setTimeout)return setTimeout(r,0);if((D===R||!D)&&setTimeout)return D=setTimeout,setTimeout(r,0);try{return D(r,0)}catch{try{return D.call(null,r,0)}catch{return D.call(this,r,0)}}}(function(){try{D=typeof setTimeout=="function"?setTimeout:R}catch{D=R}try{M=typeof clearTimeout=="function"?clearTimeout:A}catch{M=A}})();var E,$=[],P=!1,I=-1;function b(){P&&E&&(P=!1,E.length?$=E.concat($):I=-1,$.length&&S())}function S(){if(!P){var r=g(b);P=!0;for(var i=$.length;i;){for(E=$,$=[];++I<i;)E&&E[I].run();I=-1,i=$.length}E=null,P=!1,function(a){if(M===clearTimeout)return clearTimeout(a);if((M===A||!M)&&clearTimeout)return M=clearTimeout,clearTimeout(a);try{M(a)}catch{try{return M.call(null,a)}catch{return M.call(this,a)}}}(r)}}function C(r,i){this.fun=r,this.array=i}function y(){}h.nextTick=function(r){var i=new Array(arguments.length-1);if(arguments.length>1)for(var a=1;a<arguments.length;a++)i[a-1]=arguments[a];$.push(new C(r,i)),$.length!==1||P||g(S)},C.prototype.run=function(){this.fun.apply(null,this.array)},h.title="browser",h.browser=!0,h.env={},h.argv=[],h.version="",h.versions={},h.on=y,h.addListener=y,h.once=y,h.off=y,h.removeListener=y,h.removeAllListeners=y,h.emit=y,h.prependListener=y,h.prependOnceListener=y,h.listeners=function(r){return[]},h.binding=function(r){throw new Error("process.binding is not supported")},h.cwd=function(){return"/"},h.chdir=function(r){throw new Error("process.chdir is not supported")},h.umask=function(){return 0}}])}),define(De[37],Ce([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dc=void 0;const D=globalThis.performance&&typeof globalThis.performance.now=="function";class M{static create(R){return new M(R)}constructor(R){this.c=D&&R===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this.a=this.c(),this.b=-1}stop(){this.b=this.c()}reset(){this.a=this.c(),this.b=-1}elapsed(){return this.b!==-1?this.b-this.a:this.c()-this.a}}e.$dc=M}),define(De[4],Ce([1,0,8,71,3,72,37]),function($e,e,D,M,h,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qc=e.$pc=e.$oc=e.$nc=e.$mc=e.$lc=e.$kc=e.$jc=e.$ic=e.$hc=e.$gc=e.$fc=e.Event=void 0;const g=!1,E=!1;var $;(function(u){u.None=()=>h.$mb.None;function l(ge){if(E){const{onDidAddListener:ie}=ge,ue=C.create();let we=0;ge.onDidAddListener=()=>{++we===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),ue.print()),ie?.()}}}function w(ge,ie){return me(ge,()=>{},0,void 0,!0,void 0,ie)}u.defer=w;function L(ge){return(ie,ue=null,we)=>{let Pe=!1,U;return U=ge(Z=>{if(!Pe)return U?U.dispose():Pe=!0,ie.call(ue,Z)},null,we),Pe&&U.dispose(),U}}u.once=L;function N(ge,ie,ue){return J((we,Pe=null,U)=>ge(Z=>we.call(Pe,ie(Z)),null,U),ue)}u.map=N;function j(ge,ie,ue){return J((we,Pe=null,U)=>ge(Z=>{ie(Z),we.call(Pe,Z)},null,U),ue)}u.forEach=j;function T(ge,ie,ue){return J((we,Pe=null,U)=>ge(Z=>ie(Z)&&we.call(Pe,Z),null,U),ue)}u.filter=T;function O(ge){return ge}u.signal=O;function B(...ge){return(ie,ue=null,we)=>{const Pe=(0,h.$jb)(...ge.map(U=>U(Z=>ie.call(ue,Z))));return K(Pe,we)}}u.any=B;function F(ge,ie,ue,we){let Pe=ue;return N(ge,U=>(Pe=ie(Pe,U),Pe),we)}u.reduce=F;function J(ge,ie){let ue;const we={onWillAddFirstListener(){ue=ge(Pe.fire,Pe)},onDidRemoveLastListener(){ue?.dispose()}};ie||l(we);const Pe=new m(we);return ie?.add(Pe),Pe.event}function K(ge,ie){return ie instanceof Array?ie.push(ge):ie&&ie.add(ge),ge}function me(ge,ie,ue=100,we=!1,Pe=!1,U,Z){let X,oe,Y,fe=0,ye;const ze={leakWarningThreshold:U,onWillAddFirstListener(){X=ge(xe=>{fe++,oe=ie(oe,xe),we&&!Y&&(Be.fire(oe),oe=void 0),ye=()=>{const Ye=oe;oe=void 0,Y=void 0,(!we||fe>1)&&Be.fire(Ye),fe=0},typeof ue=="number"?(clearTimeout(Y),Y=setTimeout(ye,ue)):Y===void 0&&(Y=0,queueMicrotask(ye))})},onWillRemoveListener(){Pe&&fe>0&&ye?.()},onDidRemoveLastListener(){ye=void 0,X.dispose()}};Z||l(ze);const Be=new m(ze);return Z?.add(Be),Be.event}u.debounce=me;function re(ge,ie=0,ue){return u.debounce(ge,(we,Pe)=>we?(we.push(Pe),we):[Pe],ie,void 0,!0,void 0,ue)}u.accumulate=re;function x(ge,ie=(we,Pe)=>we===Pe,ue){let we=!0,Pe;return T(ge,U=>{const Z=we||!ie(U,Pe);return we=!1,Pe=U,Z},ue)}u.latch=x;function q(ge,ie,ue){return[u.filter(ge,ie,ue),u.filter(ge,we=>!ie(we),ue)]}u.split=q;function ee(ge,ie=!1,ue=[]){let we=ue.slice(),Pe=ge(X=>{we?we.push(X):Z.fire(X)});const U=()=>{we?.forEach(X=>Z.fire(X)),we=null},Z=new m({onWillAddFirstListener(){Pe||(Pe=ge(X=>Z.fire(X)))},onDidAddFirstListener(){we&&(ie?setTimeout(U):U())},onDidRemoveLastListener(){Pe&&Pe.dispose(),Pe=null}});return Z.event}u.buffer=ee;function pe(ge,ie){return(we,Pe,U)=>{const Z=ie(new _);return ge(function(X){const oe=Z.evaluate(X);oe!==ce&&we.call(Pe,oe)},void 0,U)}}u.chain=pe;const ce=Symbol("HaltChainable");class _{constructor(){this.f=[]}map(ie){return this.f.push(ie),this}forEach(ie){return this.f.push(ue=>(ie(ue),ue)),this}filter(ie){return this.f.push(ue=>ie(ue)?ue:ce),this}reduce(ie,ue){let we=ue;return this.f.push(Pe=>(we=ie(we,Pe),we)),this}latch(ie=(ue,we)=>ue===we){let ue=!0,we;return this.f.push(Pe=>{const U=ue||!ie(Pe,we);return ue=!1,we=Pe,U?Pe:ce}),this}evaluate(ie){for(const ue of this.f)if(ie=ue(ie),ie===ce)break;return ie}}function Q(ge,ie,ue=we=>we){const we=(...X)=>Z.fire(ue(...X)),Pe=()=>ge.on(ie,we),U=()=>ge.removeListener(ie,we),Z=new m({onWillAddFirstListener:Pe,onDidRemoveLastListener:U});return Z.event}u.fromNodeEventEmitter=Q;function z(ge,ie,ue=we=>we){const we=(...X)=>Z.fire(ue(...X)),Pe=()=>ge.addEventListener(ie,we),U=()=>ge.removeEventListener(ie,we),Z=new m({onWillAddFirstListener:Pe,onDidRemoveLastListener:U});return Z.event}u.fromDOMEventEmitter=z;function V(ge){return new Promise(ie=>L(ge)(ie))}u.toPromise=V;function G(ge){const ie=new m;return ge.then(ue=>{ie.fire(ue)},()=>{ie.fire(void 0)}).finally(()=>{ie.dispose()}),ie.event}u.fromPromise=G;function ae(ge,ie){return ie(void 0),ge(ue=>ie(ue))}u.runAndSubscribe=ae;function ne(ge,ie){let ue=null;function we(U){ue?.dispose(),ue=new h.$lb,ie(U,ue)}we(void 0);const Pe=ge(U=>we(U));return(0,h.$kb)(()=>{Pe.dispose(),ue?.dispose()})}u.runAndSubscribeWithStore=ne;class he{constructor(ie,ue){this._observable=ie,this.f=0,this.g=!1;const we={onWillAddFirstListener:()=>{ie.addObserver(this)},onDidRemoveLastListener:()=>{ie.removeObserver(this)}};ue||l(we),this.emitter=new m(we),ue&&ue.add(this.emitter)}beginUpdate(ie){this.f++}handlePossibleChange(ie){}handleChange(ie,ue){this.g=!0}endUpdate(ie){this.f--,this.f===0&&(this._observable.reportChanges(),this.g&&(this.g=!1,this.emitter.fire(this._observable.get())))}}function Ee(ge,ie){return new he(ge,ie).emitter.event}u.fromObservable=Ee;function de(ge){return ie=>{let ue=0,we=!1;const Pe={beginUpdate(){ue++},endUpdate(){ue--,ue===0&&(ge.reportChanges(),we&&(we=!1,ie()))},handlePossibleChange(){},handleChange(){we=!0}};return ge.addObserver(Pe),ge.reportChanges(),{dispose(){ge.removeObserver(Pe)}}}}u.fromObservableLight=de})($||(e.Event=$={}));class P{static{this.all=new Set}static{this.f=0}constructor(l){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${l}_${P.f++}`,P.all.add(this)}start(l){this.g=new A.$dc,this.listenerCount=l}stop(){if(this.g){const l=this.g.elapsed();this.durations.push(l),this.elapsedOverall+=l,this.invocationCount+=1,this.g=void 0}}}e.$fc=P;let I=-1;function b(u){const l=I;return I=u,{dispose(){I=l}}}e.$gc=b;class S{constructor(l,w=Math.random().toString(18).slice(2,5)){this.threshold=l,this.name=w,this.g=0}dispose(){this.f?.clear()}check(l,w){const L=this.threshold;if(L<=0||w<L)return;this.f||(this.f=new Map);const N=this.f.get(l.value)||0;if(this.f.set(l.value,N+1),this.g-=1,this.g<=0){this.g=L*.5;let j,T=0;for(const[O,B]of this.f)(!j||T<B)&&(j=O,T=B);console.warn(`[${this.name}] potential listener LEAK detected, having ${w} listeners already. MOST frequent listener (${T}):`),console.warn(j)}return()=>{const j=this.f.get(l.value)||0;this.f.set(l.value,j-1)}}}class C{static create(){return new C(new Error().stack??"")}constructor(l){this.value=l}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}let y=0;class r{constructor(l){this.value=l,this.id=y++}}const i=2,a=(u,l)=>{if(u instanceof r)l(u);else for(let w=0;w<u.length;w++){const L=u[w];L&&l(L)}};class m{constructor(l){this.w=0,this.f=l,this.g=I>0||this.f?.leakWarningThreshold?new S(this.f?.leakWarningThreshold??I):void 0,this.j=this.f?._profName?new P(this.f._profName):void 0,this.u=this.f?.deliveryQueue}dispose(){if(!this.m){if(this.m=!0,this.u?.current===this&&this.u.reset(),this.t){if(g){const l=this.t;queueMicrotask(()=>{a(l,w=>w.stack?.print())})}this.t=void 0,this.w=0}this.f?.onDidRemoveLastListener?.(),this.g?.dispose()}}get event(){return this.q??=(l,w,L)=>{if(this.g&&this.w>this.g.threshold*3)return console.warn(`[${this.g.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),h.$mb.None;if(this.m)return h.$mb.None;w&&(l=l.bind(w));const N=new r(l);let j,T;this.g&&this.w>=Math.ceil(this.g.threshold*.2)&&(N.stack=C.create(),j=this.g.check(N.stack,this.w+1)),g&&(N.stack=T??C.create()),this.t?this.t instanceof r?(this.u??=new f,this.t=[this.t,N]):this.t.push(N):(this.f?.onWillAddFirstListener?.(this),this.t=N,this.f?.onDidAddFirstListener?.(this)),this.w++;const O=(0,h.$kb)(()=>{j?.(),this.x(N)});return L instanceof h.$lb?L.add(O):Array.isArray(L)&&L.push(O),O},this.q}x(l){if(this.f?.onWillRemoveListener?.(this),!this.t)return;if(this.w===1){this.t=void 0,this.f?.onDidRemoveLastListener?.(this),this.w=0;return}const w=this.t,L=w.indexOf(l);if(L===-1)throw console.log("disposed?",this.m),console.log("size?",this.w),console.log("arr?",JSON.stringify(this.t)),new Error("Attempted to dispose unknown listener");this.w--,w[L]=void 0;const N=this.u.current===this;if(this.w*i<=w.length){let j=0;for(let T=0;T<w.length;T++)w[T]?w[j++]=w[T]:N&&(this.u.end--,j<this.u.i&&this.u.i--);w.length=j}}y(l,w){if(!l)return;const L=this.f?.onListenerError||D.$Y;if(!L){l.value(w);return}try{l.value(w)}catch(N){L(N)}}z(l){const w=l.current.t;for(;l.i<l.end;)this.y(w[l.i++],l.value);l.reset()}fire(l){if(this.u?.current&&(this.z(this.u),this.j?.stop()),this.j?.start(this.w),this.t)if(this.t instanceof r)this.y(this.t,l);else{const w=this.u;w.enqueue(this,l,this.t.length),this.z(w)}this.j?.stop()}hasListeners(){return this.w>0}}e.$hc=m;const p=()=>new f;e.$ic=p;class f{constructor(){this.i=-1,this.end=0}enqueue(l,w,L){this.i=0,this.end=L,this.current=l,this.value=w}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class t extends m{async fireAsync(l,w,L){if(this.t)for(this.h||(this.h=new R.$vb),a(this.t,N=>this.h.push([N.value,l]));this.h.size>0&&!w.isCancellationRequested;){const[N,j]=this.h.shift(),T=[],O={...j,token:w,waitUntil:B=>{if(Object.isFrozen(T))throw new Error("waitUntil can NOT be called asynchronous");L&&(B=L(B,N)),T.push(B)}};try{N(O)}catch(B){(0,D.$Y)(B);continue}Object.freeze(T),await Promise.allSettled(T).then(B=>{for(const F of B)F.status==="rejected"&&(0,D.$Y)(F.reason)})}}}e.$jc=t;class s extends m{get isPaused(){return this.h!==0}constructor(l){super(l),this.h=0,this.s=new R.$vb,this.A=l?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.A){if(this.s.size>0){const l=Array.from(this.s);this.s.clear(),super.fire(this.A(l))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(l){this.w&&(this.h!==0?this.s.push(l):super.fire(l))}}e.$kc=s;class o extends s{constructor(l){super(l),this.k=l.delay??100}fire(l){this.o||(this.pause(),this.o=setTimeout(()=>{this.o=void 0,this.resume()},this.k)),super.fire(l)}}e.$lc=o;class n extends m{constructor(l){super(l),this.h=[],this.k=l?.merge}fire(l){this.hasListeners()&&(this.h.push(l),this.h.length===1&&queueMicrotask(()=>{this.k?super.fire(this.k(this.h)):this.h.forEach(w=>super.fire(w)),this.h=[]}))}}e.$mc=n;class c{constructor(){this.g=!1,this.h=[],this.f=new m({onWillAddFirstListener:()=>this.j(),onDidRemoveLastListener:()=>this.k()})}get event(){return this.f.event}add(l){const w={event:l,listener:null};this.h.push(w),this.g&&this.m(w);const L=()=>{this.g&&this.o(w);const N=this.h.indexOf(w);this.h.splice(N,1)};return(0,h.$kb)((0,M.$bb)(L))}j(){this.g=!0,this.h.forEach(l=>this.m(l))}k(){this.g=!1,this.h.forEach(l=>this.o(l))}m(l){l.listener=l.event(w=>this.f.fire(w))}o(l){l.listener&&l.listener.dispose(),l.listener=null}dispose(){this.f.dispose()}}e.$nc=c;class d{constructor(l,w,L,N){this.f=new h.$lb;const j=this.f.add(new c),T=this.f.add(new h.$ub);function O(B){T.set(B,j.add(N(B)))}for(const B of l)O(B);this.f.add(w(B=>{O(B)})),this.f.add(L(B=>{T.deleteAndDispose(B)})),this.event=j.event}dispose(){this.f.dispose()}}e.$oc=d;class v{constructor(){this.f=[]}wrapEvent(l){return(w,L,N)=>l(j=>{const T=this.f[this.f.length-1];T?T.push(()=>w.call(L,j)):w.call(L,j)},void 0,N)}bufferEvents(l){const w=[];this.f.push(w);const L=l();return this.f.pop(),w.forEach(N=>N()),L}}e.$pc=v;class k{constructor(){this.f=!1,this.g=$.None,this.h=h.$mb.None,this.j=new m({onDidAddFirstListener:()=>{this.f=!0,this.h=this.g(this.j.fire,this.j)},onDidRemoveLastListener:()=>{this.f=!1,this.h.dispose()}}),this.event=this.j.event}set input(l){this.g=l,this.f&&(this.h.dispose(),this.h=l(this.j.fire,this.j))}dispose(){this.h.dispose(),this.j.dispose()}}e.$qc=k}),define(De[22],Ce([1,0,4]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rc=e.CancellationToken=void 0;const M=Object.freeze(function(g,E){const $=setTimeout(g.bind(E),0);return{dispose(){clearTimeout($)}}});var h;(function(g){function E($){return $===g.None||$===g.Cancelled||$ instanceof R?!0:!$||typeof $!="object"?!1:typeof $.isCancellationRequested=="boolean"&&typeof $.onCancellationRequested=="function"}g.isCancellationToken=E,g.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:D.Event.None}),g.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:M})})(h||(e.CancellationToken=h={}));class R{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?M:(this.b||(this.b=new D.$hc),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class A{constructor(E){this.f=void 0,this.g=void 0,this.g=E&&E.onCancellationRequested(this.cancel,this)}get token(){return this.f||(this.f=new R),this.f}cancel(){this.f?this.f instanceof R&&this.f.cancel():this.f=h.Cancelled}dispose(E=!1){E&&this.cancel(),this.g?.dispose(),this.f?this.f instanceof R&&this.f.dispose():this.f=h.None}}e.$rc=A}),define(De[157],Ce([1,0,22]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ld=e.$kd=e.$jd=void 0;class M{constructor(g){this.b=g,this.a=null}get(){if(this.a)return this.a;const g=new D.$rc,E=this.b(g.token);return this.a={promise:E,dispose:()=>{this.a=null,g.cancel(),g.dispose()}},this.a}}e.$jd=M;class h{constructor(g){this.c=g,this.a=void 0,this.b=void 0}get(g){const E=JSON.stringify(g);return this.b!==E&&(this.b=E,this.a=this.c(g)),this.a}}e.$kd=h;class R{get cachedValues(){return this.a}constructor(g){this.b=g,this.a=new Map}get(g){if(this.a.has(g))return this.a.get(g);const E=this.b(g);return this.a.set(g,E),E}}e.$ld=R}),define(De[96],Ce([1,0,8,3]),function($e,e,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gc=e.$Fc=e.$Ec=e.$Dc=e.$Cc=e.$Bc=e.$Ac=e.$zc=e.$yc=e.$xc=e.$wc=e.$vc=e.$uc=e.$tc=e.$sc=void 0;function h(p){const f=p;return f?typeof f.read=="function":!1}e.$sc=h;function R(p){const f=p;return f?[f.on,f.pause,f.resume,f.destroy].every(t=>typeof t=="function"):!1}e.$tc=R;function A(p){const f=p;return f?R(f.stream)&&Array.isArray(f.buffer)&&typeof f.ended=="boolean":!1}e.$uc=A;function g(p,f){return new E(p,f)}e.$vc=g;class E{constructor(f,t){this.e=f,this.f=t,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(f){if(!this.a.destroyed){if(this.a.flowing)this.g(f);else if(this.b.data.push(f),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(t=>this.d.push(t))}}error(f){this.a.destroyed||(this.a.flowing?this.h(f):this.b.error.push(f))}end(f){this.a.destroyed||(typeof f<"u"&&this.write(f),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(f){this.c.data.slice(0).forEach(t=>t(f))}h(f){this.c.error.length===0?(0,D.$Y)(f):this.c.error.slice(0).forEach(t=>t(f))}i(){this.c.end.slice(0).forEach(f=>f())}on(f,t){if(!this.a.destroyed)switch(f){case"data":this.c.data.push(t),this.resume();break;case"end":this.c.end.push(t),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(t),this.a.flowing&&this.k();break}}removeListener(f,t){if(this.a.destroyed)return;let s;switch(f){case"data":s=this.c.data;break;case"end":s=this.c.end;break;case"error":s=this.c.error;break}if(s){const o=s.indexOf(t);o>=0&&s.splice(o,1)}}j(){if(this.b.data.length>0){const f=this.e(this.b.data);this.g(f),this.b.data.length=0;const t=[...this.d];this.d.length=0,t.forEach(s=>s())}}k(){if(this.c.error.length>0){for(const f of this.b.error)this.h(f);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function $(p,f){const t=[];let s;for(;(s=p.read())!==null;)t.push(s);return f(t)}e.$wc=$;function P(p,f,t){const s=[];let o;for(;(o=p.read())!==null&&s.length<t;)s.push(o);return o===null&&s.length>0?f(s):{read:()=>{if(s.length>0)return s.shift();if(typeof o<"u"){const n=o;return o=void 0,n}return p.read()}}}e.$xc=P;function I(p,f){return new Promise((t,s)=>{const o=[];b(p,{onData:n=>{f&&o.push(n)},onError:n=>{f?s(n):t(void 0)},onEnd:()=>{t(f?f(o):void 0)}})})}e.$yc=I;function b(p,f,t){p.on("error",s=>{t?.isCancellationRequested||f.onError(s)}),p.on("end",()=>{t?.isCancellationRequested||f.onEnd()}),p.on("data",s=>{t?.isCancellationRequested||f.onData(s)})}e.$zc=b;function S(p,f){return new Promise((t,s)=>{const o=new M.$lb,n=[],c=k=>{if(n.push(k),n.length>f)return o.dispose(),p.pause(),t({stream:p,buffer:n,ended:!1})},d=k=>(o.dispose(),s(k)),v=()=>(o.dispose(),t({stream:p,buffer:n,ended:!0}));o.add((0,M.$kb)(()=>p.removeListener("error",d))),p.on("error",d),o.add((0,M.$kb)(()=>p.removeListener("end",v))),p.on("end",v),o.add((0,M.$kb)(()=>p.removeListener("data",c))),p.on("data",c)})}e.$Ac=S;function C(p,f){const t=g(f);return t.end(p),t}e.$Bc=C;function y(){const p=g(()=>{throw new Error("not supported")});return p.end(),p}e.$Cc=y;function r(p){let f=!1;return{read:()=>f?null:(f=!0,p)}}e.$Dc=r;function i(p,f,t){const s=g(t);return b(p,{onData:o=>s.write(f.data(o)),onError:o=>s.error(f.error?f.error(o):o),onEnd:()=>s.end()}),s}e.$Ec=i;function a(p,f,t){let s=!1;return{read:()=>{const o=f.read();return s?o:(s=!0,o!==null?t([p,o]):p)}}}e.$Fc=a;function m(p,f,t){let s=!1;const o=g(t);return b(f,{onData:n=>s?o.write(n):(s=!0,o.write(t([p,n]))),onError:n=>o.error(n),onEnd:()=>{s||(s=!0,o.write(p)),o.end()}}),o}e.$Gc=m}),define(De[21],Ce([1,0,55,96]),function($e,e,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2c=e.$1c=e.$Zc=e.$Yc=e.$Xc=e.$Wc=e.$Vc=e.$Uc=e.$Tc=e.$Sc=e.$Rc=e.$Qc=e.$Pc=e.$Oc=e.$Nc=e.$Mc=e.$Lc=e.$Kc=e.$Jc=e.$Ic=e.$Hc=void 0;const h=typeof Buffer<"u",R=new D.$T(()=>new Uint8Array(256));let A,g;class E{static alloc(w){return h?new E(Buffer.allocUnsafe(w)):new E(new Uint8Array(w))}static wrap(w){return h&&!Buffer.isBuffer(w)&&(w=Buffer.from(w.buffer,w.byteOffset,w.byteLength)),new E(w)}static fromString(w,L){return!(L?.dontUseNodeBuffer||!1)&&h?new E(Buffer.from(w)):(A||(A=new TextEncoder),new E(A.encode(w)))}static fromByteArray(w){const L=E.alloc(w.length);for(let N=0,j=w.length;N<j;N++)L.buffer[N]=w[N];return L}static concat(w,L){if(typeof L>"u"){L=0;for(let T=0,O=w.length;T<O;T++)L+=w[T].byteLength}const N=E.alloc(L);let j=0;for(let T=0,O=w.length;T<O;T++){const B=w[T];N.set(B,j),j+=B.byteLength}return N}constructor(w){this.buffer=w,this.byteLength=this.buffer.byteLength}clone(){const w=E.alloc(this.byteLength);return w.set(this),w}toString(){return h?this.buffer.toString():(g||(g=new TextDecoder),g.decode(this.buffer))}slice(w,L){return new E(this.buffer.subarray(w,L))}set(w,L){if(w instanceof E)this.buffer.set(w.buffer,L);else if(w instanceof Uint8Array)this.buffer.set(w,L);else if(w instanceof ArrayBuffer)this.buffer.set(new Uint8Array(w),L);else if(ArrayBuffer.isView(w))this.buffer.set(new Uint8Array(w.buffer,w.byteOffset,w.byteLength),L);else throw new Error("Unknown argument 'array'")}readUInt32BE(w){return b(this.buffer,w)}writeUInt32BE(w,L){S(this.buffer,w,L)}readUInt32LE(w){return C(this.buffer,w)}writeUInt32LE(w,L){y(this.buffer,w,L)}readUInt8(w){return r(this.buffer,w)}writeUInt8(w,L){i(this.buffer,w,L)}indexOf(w,L=0){return $(this.buffer,w instanceof E?w.buffer:w,L)}}e.$Hc=E;function $(l,w,L=0){const N=w.byteLength,j=l.byteLength;if(N===0)return 0;if(N===1)return l.indexOf(w[0]);if(N>j-L)return-1;const T=R.value;T.fill(w.length);for(let J=0;J<w.length;J++)T[w[J]]=w.length-J-1;let O=L+w.length-1,B=O,F=-1;for(;O<j;)if(l[O]===w[B]){if(B===0){F=O;break}O--,B--}else O+=Math.max(w.length-B,T[l[O]]),B=w.length-1;return F}e.$Ic=$;function P(l,w){return l[w+0]<<0>>>0|l[w+1]<<8>>>0}e.$Jc=P;function I(l,w,L){l[L+0]=w&255,w=w>>>8,l[L+1]=w&255}e.$Kc=I;function b(l,w){return l[w]*2**24+l[w+1]*2**16+l[w+2]*2**8+l[w+3]}e.$Lc=b;function S(l,w,L){l[L+3]=w,w=w>>>8,l[L+2]=w,w=w>>>8,l[L+1]=w,w=w>>>8,l[L]=w}e.$Mc=S;function C(l,w){return l[w+0]<<0>>>0|l[w+1]<<8>>>0|l[w+2]<<16>>>0|l[w+3]<<24>>>0}e.$Nc=C;function y(l,w,L){l[L+0]=w&255,w=w>>>8,l[L+1]=w&255,w=w>>>8,l[L+2]=w&255,w=w>>>8,l[L+3]=w&255}e.$Oc=y;function r(l,w){return l[w]}e.$Pc=r;function i(l,w,L){l[L]=w}e.$Qc=i;function a(l){return M.$wc(l,w=>E.concat(w))}e.$Rc=a;function m(l){return M.$Dc(l)}e.$Sc=m;function p(l){return M.$yc(l,w=>E.concat(w))}e.$Tc=p;async function f(l){return l.ended?E.concat(l.buffer):E.concat([...l.buffer,await p(l.stream)])}e.$Uc=f;function t(l){return M.$Bc(l,w=>E.concat(w))}e.$Vc=t;function s(l){return M.$Ec(l,{data:w=>typeof w=="string"?E.fromString(w):E.wrap(w)},w=>E.concat(w))}e.$Wc=s;function o(l){return M.$vc(w=>E.concat(w),l)}e.$Xc=o;function n(l,w){return M.$Fc(l,w,L=>E.concat(L))}e.$Yc=n;function c(l,w){return M.$Gc(l,w,L=>E.concat(L))}e.$Zc=c;function d(l){let w=0,L=0,N=0;const j=new Uint8Array(Math.floor(l.length/4*3)),T=B=>{switch(L){case 3:j[N++]=w|B,L=0;break;case 2:j[N++]=w|B>>>2,w=B<<6,L=3;break;case 1:j[N++]=w|B>>>4,w=B<<4,L=2;break;default:w=B<<2,L=1}};for(let B=0;B<l.length;B++){const F=l.charCodeAt(B);if(F>=65&&F<=90)T(F-65);else if(F>=97&&F<=122)T(F-97+26);else if(F>=48&&F<=57)T(F-48+52);else if(F===43||F===45)T(62);else if(F===47||F===95)T(63);else{if(F===61)break;throw new SyntaxError(`Unexpected base64 character ${l[B]}`)}}const O=N;for(;L>0;)T(0);return E.wrap(j).slice(0,O)}e.$1c=d;const v="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",k="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function u({buffer:l},w=!0,L=!1){const N=L?k:v;let j="";const T=l.byteLength%3;let O=0;for(;O<l.byteLength-T;O+=3){const B=l[O+0],F=l[O+1],J=l[O+2];j+=N[B>>>2],j+=N[(B<<4|F>>>4)&63],j+=N[(F<<2|J>>>6)&63],j+=N[J&63]}if(T===1){const B=l[O+0];j+=N[B>>>2],j+=N[B<<4&63],w&&(j+="==")}else if(T===2){const B=l[O+0],F=l[O+1];j+=N[B>>>2],j+=N[(B<<4|F>>>4)&63],j+=N[F<<2&63],w&&(j+="=")}return j}e.$2c=u}),define(De[15],Ce([1,0,157,55]),function($e,e,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ke=e.$je=e.$ie=e.$he=e.GraphemeBreakType=e.$ge=e.$fe=e.$ee=e.$de=e.$ce=e.$be=e.$ae=e.$_d=e.$$d=e.$0d=e.$9d=e.$8d=e.$7d=e.$6d=e.$5d=e.$4d=e.$3d=e.$2d=e.$1d=e.$Zd=e.$Yd=e.$Xd=e.$Wd=e.$Vd=e.$Ud=e.$Td=e.$Sd=e.$Rd=e.$Qd=e.$Pd=e.$Od=e.$Nd=e.$Md=e.$Ld=e.$Kd=e.$Jd=e.$Id=e.$Hd=e.$Gd=e.$Fd=e.$Ed=e.$Dd=e.$Cd=e.$Bd=e.$Ad=e.$zd=e.$yd=e.$xd=e.$wd=e.$vd=e.$ud=e.$td=e.$sd=e.$rd=e.$qd=e.$pd=e.$od=void 0;function h(Ae){return!Ae||typeof Ae!="string"?!0:Ae.trim().length===0}e.$od=h;const R=/{(\d+)}/g;function A(Ae,...Ne){return Ne.length===0?Ae:Ae.replace(R,function(We,Le){const Qe=parseInt(Le,10);return isNaN(Qe)||Qe<0||Qe>=Ne.length?We:Ne[Qe]})}e.$pd=A;const g=/{([^}]+)}/g;function E(Ae,Ne){return Ae.replace(g,(We,Le)=>Ne[Le]??We)}e.$qd=E;function $(Ae){return Ae.replace(/[<>&]/g,function(Ne){switch(Ne){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return Ne}})}e.$rd=$;function P(Ae){return Ae.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.$sd=P;function I(Ae,Ne){let We=0;const Le=Ne.charCodeAt(0);for(let Qe=Ae.length-1;Qe>=0;Qe--)Ae.charCodeAt(Qe)===Le&&We++;return We}e.$td=I;function b(Ae,Ne,We="\u2026"){return Ae.length<=Ne?Ae:`${Ae.substr(0,Ne)}${We}`}e.$ud=b;function S(Ae,Ne=" "){const We=C(Ae,Ne);return y(We,Ne)}e.$vd=S;function C(Ae,Ne){if(!Ae||!Ne)return Ae;const We=Ne.length;if(We===0||Ae.length===0)return Ae;let Le=0;for(;Ae.indexOf(Ne,Le)===Le;)Le=Le+We;return Ae.substring(Le)}e.$wd=C;function y(Ae,Ne){if(!Ae||!Ne)return Ae;const We=Ne.length,Le=Ae.length;if(We===0||Le===0)return Ae;let Qe=Le,le=-1;for(;le=Ae.lastIndexOf(Ne,Qe-1),!(le===-1||le+We!==Qe);){if(le===0)return"";Qe=le}return Ae.substring(0,Qe)}e.$xd=y;function r(Ae){return Ae.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.$yd=r;function i(Ae){return Ae.replace(/\*/g,"")}e.$zd=i;function a(Ae,Ne,We={}){if(!Ae)throw new Error("Cannot create regex from empty string");Ne||(Ae=P(Ae)),We.wholeWord&&(/\B/.test(Ae.charAt(0))||(Ae="\\b"+Ae),/\B/.test(Ae.charAt(Ae.length-1))||(Ae=Ae+"\\b"));let Le="";return We.global&&(Le+="g"),We.matchCase||(Le+="i"),We.multiline&&(Le+="m"),We.unicode&&(Le+="u"),new RegExp(Ae,Le)}e.$Ad=a;function m(Ae){return Ae.source==="^"||Ae.source==="^$"||Ae.source==="$"||Ae.source==="^\\s*$"?!1:!!(Ae.exec("")&&Ae.lastIndex===0)}e.$Bd=m;function p(Ae){return Ae.split(/\r\n|\r|\n/)}e.$Cd=p;function f(Ae){for(let Ne=0,We=Ae.length;Ne<We;Ne++){const Le=Ae.charCodeAt(Ne);if(Le!==32&&Le!==9)return Ne}return-1}e.$Dd=f;function t(Ae,Ne=0,We=Ae.length){for(let Le=Ne;Le<We;Le++){const Qe=Ae.charCodeAt(Le);if(Qe!==32&&Qe!==9)return Ae.substring(Ne,Le)}return Ae.substring(Ne,We)}e.$Ed=t;function s(Ae,Ne=Ae.length-1){for(let We=Ne;We>=0;We--){const Le=Ae.charCodeAt(We);if(Le!==32&&Le!==9)return We}return-1}e.$Fd=s;function o(Ae,Ne,We){const Le=[];let Qe=0;for(const le of Ae.matchAll(Ne)){if(Le.push(Ae.slice(Qe,le.index)),le.index===void 0)throw new Error("match.index should be defined");Qe=le.index+le[0].length,Le.push(We(le[0],...le.slice(1),le.index,Ae,le.groups))}return Le.push(Ae.slice(Qe)),Promise.all(Le).then(le=>le.join(""))}e.$Gd=o;function n(Ae,Ne){return Ae<Ne?-1:Ae>Ne?1:0}e.$Hd=n;function c(Ae,Ne,We=0,Le=Ae.length,Qe=0,le=Ne.length){for(;We<Le&&Qe<le;We++,Qe++){const qe=Ae.charCodeAt(We),je=Ne.charCodeAt(Qe);if(qe<je)return-1;if(qe>je)return 1}const se=Le-We,Ie=le-Qe;return se<Ie?-1:se>Ie?1:0}e.$Id=c;function d(Ae,Ne){return v(Ae,Ne,0,Ae.length,0,Ne.length)}e.$Jd=d;function v(Ae,Ne,We=0,Le=Ae.length,Qe=0,le=Ne.length){for(;We<Le&&Qe<le;We++,Qe++){let qe=Ae.charCodeAt(We),je=Ne.charCodeAt(Qe);if(qe===je)continue;if(qe>=128||je>=128)return c(Ae.toLowerCase(),Ne.toLowerCase(),We,Le,Qe,le);u(qe)&&(qe-=32),u(je)&&(je-=32);const Xe=qe-je;if(Xe!==0)return Xe}const se=Le-We,Ie=le-Qe;return se<Ie?-1:se>Ie?1:0}e.$Kd=v;function k(Ae){return Ae>=48&&Ae<=57}e.$Ld=k;function u(Ae){return Ae>=97&&Ae<=122}e.$Md=u;function l(Ae){return Ae>=65&&Ae<=90}e.$Nd=l;function w(Ae,Ne){return Ae.length===Ne.length&&v(Ae,Ne)===0}e.$Od=w;function L(Ae,Ne){const We=Ne.length;return Ne.length>Ae.length?!1:v(Ae,Ne,0,We)===0}e.$Pd=L;function N(Ae,Ne){const We=Math.min(Ae.length,Ne.length);let Le;for(Le=0;Le<We;Le++)if(Ae.charCodeAt(Le)!==Ne.charCodeAt(Le))return Le;return We}e.$Qd=N;function j(Ae,Ne){const We=Math.min(Ae.length,Ne.length);let Le;const Qe=Ae.length-1,le=Ne.length-1;for(Le=0;Le<We;Le++)if(Ae.charCodeAt(Qe-Le)!==Ne.charCodeAt(le-Le))return Le;return We}e.$Rd=j;function T(Ae){return 55296<=Ae&&Ae<=56319}e.$Sd=T;function O(Ae){return 56320<=Ae&&Ae<=57343}e.$Td=O;function B(Ae,Ne){return(Ae-55296<<10)+(Ne-56320)+65536}e.$Ud=B;function F(Ae,Ne,We){const Le=Ae.charCodeAt(We);if(T(Le)&&We+1<Ne){const Qe=Ae.charCodeAt(We+1);if(O(Qe))return B(Le,Qe)}return Le}e.$Vd=F;function J(Ae,Ne){const We=Ae.charCodeAt(Ne-1);if(O(We)&&Ne>1){const Le=Ae.charCodeAt(Ne-2);if(T(Le))return B(Le,We)}return We}class K{get offset(){return this.e}constructor(Ne,We=0){this.c=Ne,this.d=Ne.length,this.e=We}setOffset(Ne){this.e=Ne}prevCodePoint(){const Ne=J(this.c,this.e);return this.e-=Ne>=65536?2:1,Ne}nextCodePoint(){const Ne=F(this.c,this.d,this.e);return this.e+=Ne>=65536?2:1,Ne}eol(){return this.e>=this.d}}e.$Wd=K;class me{get offset(){return this.c.offset}constructor(Ne,We=0){this.c=new K(Ne,We)}nextGraphemeLength(){const Ne=fe.getInstance(),We=this.c,Le=We.offset;let Qe=Ne.getGraphemeBreakType(We.nextCodePoint());for(;!We.eol();){const le=We.offset,se=Ne.getGraphemeBreakType(We.nextCodePoint());if(oe(Qe,se)){We.setOffset(le);break}Qe=se}return We.offset-Le}prevGraphemeLength(){const Ne=fe.getInstance(),We=this.c,Le=We.offset;let Qe=Ne.getGraphemeBreakType(We.prevCodePoint());for(;We.offset>0;){const le=We.offset,se=Ne.getGraphemeBreakType(We.prevCodePoint());if(oe(se,Qe)){We.setOffset(le);break}Qe=se}return Le-We.offset}eol(){return this.c.eol()}}e.$Xd=me;function re(Ae,Ne){return new me(Ae,Ne).nextGraphemeLength()}e.$Yd=re;function x(Ae,Ne){return new me(Ae,Ne).prevGraphemeLength()}e.$Zd=x;function q(Ae,Ne){Ne>0&&O(Ae.charCodeAt(Ne))&&Ne--;const We=Ne+re(Ae,Ne);return[We-x(Ae,We),We]}e.$1d=q;function ee(Ae){const Ne=new me(Ae);let We=0;for(;!Ne.eol();)We++,Ne.nextGraphemeLength();return We}e.$2d=ee;let pe;function ce(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function _(Ae){return pe||(pe=ce()),pe.test(Ae)}e.$3d=_;const Q=/^[\t\n\r\x20-\x7E]*$/;function z(Ae){return Q.test(Ae)}e.$4d=z,e.$5d=/[\u2028\u2029]/;function V(Ae){return e.$5d.test(Ae)}e.$6d=V;function G(Ae){return Ae>=11904&&Ae<=55215||Ae>=63744&&Ae<=64255||Ae>=65281&&Ae<=65374}e.$7d=G;function ae(Ae){return Ae>=127462&&Ae<=127487||Ae===8986||Ae===8987||Ae===9200||Ae===9203||Ae>=9728&&Ae<=10175||Ae===11088||Ae===11093||Ae>=127744&&Ae<=128591||Ae>=128640&&Ae<=128764||Ae>=128992&&Ae<=129008||Ae>=129280&&Ae<=129535||Ae>=129648&&Ae<=129782}e.$8d=ae;function ne(Ae,Ne){if(Ae.length<Ne)return Ae;const We=/\b/g;let Le=0;for(;We.test(Ae)&&!(Ae.length-We.lastIndex<Ne);)Le=We.lastIndex,We.lastIndex+=1;return Ae.substring(Le).replace(/^\s/,"")}e.$9d=ne;const he=/(:?\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~]/g,Ee=/\x1b\].*?\x07/g;function de(Ae){return Ae&&(Ae=Ae.replace(he,"").replace(Ee,"")),Ae}e.$0d=de,e.$$d=String.fromCharCode(65279);function ge(Ae){return!!(Ae&&Ae.length>0&&Ae.charCodeAt(0)===65279)}e.$_d=ge;function ie(Ae){return ge(Ae)?Ae.substr(1):Ae}e.$ae=ie;function ue(Ae,Ne){if(!Ae||!Ne||Ae.length<Ne.length)return!1;const We=Ne.length,Le=Ae.toLowerCase();let Qe=0,le=-1;for(;Qe<We;){const se=Le.indexOf(Ne[Qe],le+1);if(se<0)return!1;le=se,Qe++}return!0}e.$be=ue;function we(Ae,Ne=!1){return Ae?(Ne&&(Ae=Ae.replace(/\\./g,"")),Ae.toLowerCase()!==Ae):!1}e.$ce=we;function Pe(Ae){return Ae.charAt(0).toUpperCase()+Ae.slice(1)}e.$de=Pe;function U(Ae,Ne=1){if(Ne===0)return"";let We=-1;do We=Ae.indexOf(`
`,We+1),Ne--;while(Ne>0&&We>=0);return We===-1?Ae:(Ae[We-1]==="\r"&&We--,Ae.substr(0,We))}e.$ee=U;function Z(Ae){return Ae=Ae%(2*26),Ae<26?String.fromCharCode(97+Ae):String.fromCharCode(65+Ae-26)}e.$fe=Z;function X(Ae){return fe.getInstance().getGraphemeBreakType(Ae)}e.$ge=X;function oe(Ae,Ne){return Ae===0?Ne!==5&&Ne!==7:Ae===2&&Ne===3?!1:Ae===4||Ae===2||Ae===3||Ne===4||Ne===2||Ne===3?!0:!(Ae===8&&(Ne===8||Ne===9||Ne===11||Ne===12)||(Ae===11||Ae===9)&&(Ne===9||Ne===10)||(Ae===12||Ae===10)&&Ne===10||Ne===5||Ne===13||Ne===7||Ae===1||Ae===13&&Ne===14||Ae===6&&Ne===6)}var Y;(function(Ae){Ae[Ae.Other=0]="Other",Ae[Ae.Prepend=1]="Prepend",Ae[Ae.CR=2]="CR",Ae[Ae.LF=3]="LF",Ae[Ae.Control=4]="Control",Ae[Ae.Extend=5]="Extend",Ae[Ae.Regional_Indicator=6]="Regional_Indicator",Ae[Ae.SpacingMark=7]="SpacingMark",Ae[Ae.L=8]="L",Ae[Ae.V=9]="V",Ae[Ae.T=10]="T",Ae[Ae.LV=11]="LV",Ae[Ae.LVT=12]="LVT",Ae[Ae.ZWJ=13]="ZWJ",Ae[Ae.Extended_Pictographic=14]="Extended_Pictographic"})(Y||(e.GraphemeBreakType=Y={}));class fe{static{this.c=null}static getInstance(){return fe.c||(fe.c=new fe),fe.c}constructor(){this.d=ye()}getGraphemeBreakType(Ne){if(Ne<32)return Ne===10?3:Ne===13?2:4;if(Ne<127)return 0;const We=this.d,Le=We.length/3;let Qe=1;for(;Qe<=Le;)if(Ne<We[3*Qe])Qe=2*Qe;else if(Ne>We[3*Qe+1])Qe=2*Qe+1;else return We[3*Qe+2];return 0}}function ye(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function ze(Ae,Ne){if(Ae===0)return 0;const We=Be(Ae,Ne);if(We!==void 0)return We;const Le=new K(Ne,Ae);return Le.prevCodePoint(),Le.offset}e.$he=ze;function Be(Ae,Ne){const We=new K(Ne,Ae);let Le=We.prevCodePoint();for(;xe(Le)||Le===65039||Le===8419;){if(We.offset===0)return;Le=We.prevCodePoint()}if(!ae(Le))return;let Qe=We.offset;return Qe>0&&We.prevCodePoint()===8205&&(Qe=We.offset),Qe}function xe(Ae){return 127995<=Ae&&Ae<=127999}var Ye;(function(Ae){Ae[Ae.zwj=8205]="zwj",Ae[Ae.emojiVariantSelector=65039]="emojiVariantSelector",Ae[Ae.enclosingKeyCap=8419]="enclosingKeyCap"})(Ye||(Ye={})),e.$ie="\xA0";class it{static{this.c=new M.$T(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.d=new D.$kd(Ne=>{function We(Xe){const nt=new Map;for(let ot=0;ot<Xe.length;ot+=2)nt.set(Xe[ot],Xe[ot+1]);return nt}function Le(Xe,nt){const ot=new Map(Xe);for(const[bt,Dt]of nt)ot.set(bt,Dt);return ot}function Qe(Xe,nt){if(!Xe)return nt;const ot=new Map;for(const[bt,Dt]of Xe)nt.has(bt)&&ot.set(bt,Dt);return ot}const le=this.c.value;let se=Ne.filter(Xe=>!Xe.startsWith("_")&&Xe in le);se.length===0&&(se=["_default"]);let Ie;for(const Xe of se){const nt=We(le[Xe]);Ie=Qe(Ie,nt)}const qe=We(le._common),je=Le(qe,Ie);return new it(je)})}static getInstance(Ne){return it.d.get(Array.from(Ne))}static{this.e=new M.$T(()=>Object.keys(it.c.value).filter(Ne=>!Ne.startsWith("_")))}static getLocales(){return it.e.value}constructor(Ne){this.f=Ne}isAmbiguous(Ne){return this.f.has(Ne)}getPrimaryConfusable(Ne){return this.f.get(Ne)}getConfusableCodePoints(){return new Set(this.f.keys())}}e.$je=it;class et{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this.d=void 0}static e(){return this.d||(this.d=new Set(et.c())),this.d}static isInvisibleCharacter(Ne){return et.e().has(Ne)}static get codePoints(){return et.e()}}e.$ke=et}),define(De[120],Ce([1,0,28,15]),function($e,e,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kj=e.$Jj=e.$Ij=e.$Hj=e.FuzzyScore=e.$Gj=e.$Fj=e.$Ej=e.$Dj=e.$Cj=e.$Bj=e.$Aj=e.$zj=e.$yj=e.$xj=e.$wj=e.$vj=e.or=void 0;function h(...ie){return function(ue,we){for(let Pe=0,U=ie.length;Pe<U;Pe++){const Z=ie[Pe](ue,we);if(Z)return Z}return null}}e.or=h,e.$vj=R.bind(void 0,!1),e.$wj=R.bind(void 0,!0);function R(ie,ue,we){if(!we||we.length<ue.length)return null;let Pe;return ie?Pe=M.$Pd(we,ue):Pe=we.indexOf(ue)===0,Pe?ue.length>0?[{start:0,end:ue.length}]:[]:null}function A(ie,ue){const we=ue.toLowerCase().indexOf(ie.toLowerCase());return we===-1?null:[{start:we,end:we+ie.length}]}e.$xj=A;function g(ie,ue){return E(ie.toLowerCase(),ue.toLowerCase(),0,0)}e.$yj=g;function E(ie,ue,we,Pe){if(we===ie.length)return[];if(Pe===ue.length)return null;if(ie[we]===ue[Pe]){let U=null;return(U=E(ie,ue,we+1,Pe+1))?i({start:Pe,end:Pe+1},U):null}return E(ie,ue,we,Pe+1)}function $(ie){return 97<=ie&&ie<=122}function P(ie){return 65<=ie&&ie<=90}e.$zj=P;function I(ie){return 48<=ie&&ie<=57}function b(ie){return ie===32||ie===9||ie===10||ie===13}const S=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(ie=>S.add(ie.charCodeAt(0)));function C(ie){return b(ie)||S.has(ie)}function y(ie,ue){return ie===ue||C(ie)&&C(ue)}function r(ie){return $(ie)||P(ie)||I(ie)}function i(ie,ue){return ue.length===0?ue=[ie]:ie.end===ue[0].start?ue[0].start=ie.start:ue.unshift(ie),ue}function a(ie,ue){for(let we=ue;we<ie.length;we++){const Pe=ie.charCodeAt(we);if(P(Pe)||I(Pe)||we>0&&!r(ie.charCodeAt(we-1)))return we}return ie.length}function m(ie,ue,we,Pe){if(we===ie.length)return[];if(Pe===ue.length)return null;if(ie[we]!==ue[Pe].toLowerCase())return null;{let U=null,Z=Pe+1;for(U=m(ie,ue,we+1,Pe+1);!U&&(Z=a(ue,Z))<ue.length;)U=m(ie,ue,we+1,Z),Z++;return U===null?null:i({start:Pe,end:Pe+1},U)}}function p(ie){let ue=0,we=0,Pe=0,U=0,Z=0;for(let ye=0;ye<ie.length;ye++)Z=ie.charCodeAt(ye),P(Z)&&ue++,$(Z)&&we++,r(Z)&&Pe++,I(Z)&&U++;const X=ue/ie.length,oe=we/ie.length,Y=Pe/ie.length,fe=U/ie.length;return{upperPercent:X,lowerPercent:oe,alphaPercent:Y,numericPercent:fe}}function f(ie){const{upperPercent:ue,lowerPercent:we}=ie;return we===0&&ue>.6}function t(ie){const{upperPercent:ue,lowerPercent:we,alphaPercent:Pe,numericPercent:U}=ie;return we>.2&&ue<.8&&Pe>.6&&U<.2}function s(ie){let ue=0,we=0,Pe=0,U=0;for(let Z=0;Z<ie.length;Z++)Pe=ie.charCodeAt(Z),P(Pe)&&ue++,$(Pe)&&we++,b(Pe)&&U++;return(ue===0||we===0)&&U===0?ie.length<=30:ue<=5}function o(ie,ue){if(!ue||(ue=ue.trim(),ue.length===0)||!s(ie)||ue.length>60)return null;const we=p(ue);if(!t(we)){if(!f(we))return null;ue=ue.toLowerCase()}let Pe=null,U=0;for(ie=ie.toLowerCase();U<ue.length&&(Pe=m(ie,ue,0,U))===null;)U=a(ue,U+1);return Pe}e.$Aj=o;function n(ie,ue,we=!1){if(!ue||ue.length===0)return null;let Pe=null,U=0;for(ie=ie.toLowerCase(),ue=ue.toLowerCase();U<ue.length&&(Pe=c(ie,ue,0,U,we))===null;)U=d(ue,U+1);return Pe}e.$Bj=n;function c(ie,ue,we,Pe,U){if(we===ie.length)return[];if(Pe===ue.length)return null;if(y(ie.charCodeAt(we),ue.charCodeAt(Pe))){let Z=null,X=Pe+1;if(Z=c(ie,ue,we+1,Pe+1,U),!U)for(;!Z&&(X=d(ue,X))<ue.length;)Z=c(ie,ue,we+1,X,U),X++;return Z?ie.charCodeAt(we)!==ue.charCodeAt(Pe)?Z:i({start:Pe,end:Pe+1},Z):null}else return null}function d(ie,ue){for(let we=ue;we<ie.length;we++)if(C(ie.charCodeAt(we))||we>0&&C(ie.charCodeAt(we-1)))return we;return ie.length}const v=h(e.$wj,o,A),k=h(e.$wj,o,g),u=new D.$Ai(1e4);function l(ie,ue,we=!1){if(typeof ie!="string"||typeof ue!="string")return null;let Pe=u.get(ie);Pe||(Pe=new RegExp(M.$yd(ie),"i"),u.set(ie,Pe));const U=Pe.exec(ue);return U?[{start:U.index,end:U.index+U[0].length}]:we?k(ie,ue):v(ie,ue)}e.$Cj=l;function w(ie,ue){const we=G(ie,ie.toLowerCase(),0,ue,ue.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return we?N(we):null}e.$Dj=w;function L(ie,ue,we,Pe,U,Z){const X=Math.min(13,ie.length);for(;we<X;we++){const oe=G(ie,ue,we,Pe,U,Z,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(oe)return oe}return[0,Z]}e.$Ej=L;function N(ie){if(typeof ie>"u")return[];const ue=[],we=ie[1];for(let Pe=ie.length-1;Pe>1;Pe--){const U=ie[Pe]+we,Z=ue[ue.length-1];Z&&Z.end===U?Z.end=U+1:ue.push({start:U,end:U+1})}return ue}e.$Fj=N;const j=128;function T(){const ie=[],ue=[];for(let we=0;we<=j;we++)ue[we]=0;for(let we=0;we<=j;we++)ie.push(ue.slice(0));return ie}function O(ie){const ue=[];for(let we=0;we<=ie;we++)ue[we]=0;return ue}const B=O(2*j),F=O(2*j),J=T(),K=T(),me=T(),re=!1;function x(ie,ue,we,Pe,U){function Z(oe,Y,fe=" "){for(;oe.length<Y;)oe=fe+oe;return oe}let X=` |   |${Pe.split("").map(oe=>Z(oe,3)).join("|")}
`;for(let oe=0;oe<=we;oe++)oe===0?X+=" |":X+=`${ue[oe-1]}|`,X+=ie[oe].slice(0,U+1).map(Y=>Z(Y.toString(),3)).join("|")+`
`;return X}function q(ie,ue,we,Pe){ie=ie.substr(ue),we=we.substr(Pe),console.log(x(K,ie,ie.length,we,we.length)),console.log(x(me,ie,ie.length,we,we.length)),console.log(x(J,ie,ie.length,we,we.length))}function ee(ie,ue){if(ue<0||ue>=ie.length)return!1;const we=ie.codePointAt(ue);switch(we){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!M.$8d(we)}}function pe(ie,ue){if(ue<0||ue>=ie.length)return!1;switch(ie.charCodeAt(ue)){case 32:case 9:return!0;default:return!1}}function ce(ie,ue,we){return ue[ie]!==we[ie]}function _(ie,ue,we,Pe,U,Z,X=!1){for(;ue<we&&U<Z;)ie[ue]===Pe[U]&&(X&&(B[ue]=U),ue+=1),U+=1;return ue===we}e.$Gj=_;var Q;(function(ie){ie[ie.Diag=1]="Diag",ie[ie.Left=2]="Left",ie[ie.LeftLeft=3]="LeftLeft"})(Q||(Q={}));var z;(function(ie){ie.Default=[-100,0];function ue(we){return!we||we.length===2&&we[0]===-100&&we[1]===0}ie.isDefault=ue})(z||(e.FuzzyScore=z={}));class V{static{this.default={boostFullMatch:!0,firstMatchCanBeWeak:!1}}constructor(ue,we){this.firstMatchCanBeWeak=ue,this.boostFullMatch=we}}e.$Hj=V;function G(ie,ue,we,Pe,U,Z,X=V.default){const oe=ie.length>j?j:ie.length,Y=Pe.length>j?j:Pe.length;if(we>=oe||Z>=Y||oe-we>Y-Z||!_(ue,we,oe,U,Z,Y,!0))return;ae(oe,Y,we,Z,ue,U);let fe=1,ye=1,ze=we,Be=Z;const xe=[!1];for(fe=1,ze=we;ze<oe;fe++,ze++){const Ne=B[ze],We=F[ze],Le=ze+1<oe?F[ze+1]:Y;for(ye=Ne-Z+1,Be=Ne;Be<Le;ye++,Be++){let Qe=Number.MIN_SAFE_INTEGER,le=!1;Be<=We&&(Qe=ne(ie,ue,ze,we,Pe,U,Be,Y,Z,J[fe-1][ye-1]===0,xe));let se=0;Qe!==Number.MAX_SAFE_INTEGER&&(le=!0,se=Qe+K[fe-1][ye-1]);const Ie=Be>Ne,qe=Ie?K[fe][ye-1]+(J[fe][ye-1]>0?-5:0):0,je=Be>Ne+1&&J[fe][ye-1]>0,Xe=je?K[fe][ye-2]+(J[fe][ye-2]>0?-5:0):0;if(je&&(!Ie||Xe>=qe)&&(!le||Xe>=se))K[fe][ye]=Xe,me[fe][ye]=3,J[fe][ye]=0;else if(Ie&&(!le||qe>=se))K[fe][ye]=qe,me[fe][ye]=2,J[fe][ye]=0;else if(le)K[fe][ye]=se,me[fe][ye]=1,J[fe][ye]=J[fe-1][ye-1]+1;else throw new Error("not possible")}}if(re&&q(ie,we,Pe,Z),!xe[0]&&!X.firstMatchCanBeWeak)return;fe--,ye--;const Ye=[K[fe][ye],Z];let it=0,et=0;for(;fe>=1;){let Ne=ye;do{const We=me[fe][Ne];if(We===3)Ne=Ne-2;else if(We===2)Ne=Ne-1;else break}while(Ne>=1);it>1&&ue[we+fe-1]===U[Z+ye-1]&&!ce(Ne+Z-1,Pe,U)&&it+1>J[fe][Ne]&&(Ne=ye),Ne===ye?it++:it=1,et||(et=Ne),fe--,ye=Ne-1,Ye.push(ye)}Y===oe&&X.boostFullMatch&&(Ye[0]+=2);const Ae=et-oe;return Ye[0]-=Ae,Ye}e.$Ij=G;function ae(ie,ue,we,Pe,U,Z){let X=ie-1,oe=ue-1;for(;X>=we&&oe>=Pe;)U[X]===Z[oe]&&(F[X]=oe,X--),oe--}function ne(ie,ue,we,Pe,U,Z,X,oe,Y,fe,ye){if(ue[we]!==Z[X])return Number.MIN_SAFE_INTEGER;let ze=1,Be=!1;return X===we-Pe?ze=ie[we]===U[X]?7:5:ce(X,U,Z)&&(X===0||!ce(X-1,U,Z))?(ze=ie[we]===U[X]?7:5,Be=!0):ee(Z,X)&&(X===0||!ee(Z,X-1))?ze=5:(ee(Z,X-1)||pe(Z,X-1))&&(ze=5,Be=!0),ze>1&&we===Pe&&(ye[0]=!0),Be||(Be=ce(X,U,Z)||ee(Z,X-1)||pe(Z,X-1)),we===Pe?X>Y&&(ze-=Be?3:5):fe?ze+=Be?2:0:ze+=Be?0:1,X+1===oe&&(ze-=Be?3:5),ze}function he(ie,ue,we,Pe,U,Z,X){return de(ie,ue,we,Pe,U,Z,!0,X)}e.$Jj=he;function Ee(ie,ue,we,Pe,U,Z,X){return de(ie,ue,we,Pe,U,Z,!1,X)}e.$Kj=Ee;function de(ie,ue,we,Pe,U,Z,X,oe){let Y=G(ie,ue,we,Pe,U,Z,oe);if(Y&&!X)return Y;if(ie.length>=3){const fe=Math.min(7,ie.length-1);for(let ye=we+1;ye<fe;ye++){const ze=ge(ie,ye);if(ze){const Be=G(ze,ze.toLowerCase(),we,Pe,U,Z,oe);Be&&(Be[0]-=3,(!Y||Be[0]>Y[0])&&(Y=Be))}}}return Y}function ge(ie,ue){if(ue+1>=ie.length)return;const we=ie[ue],Pe=ie[ue+1];if(we!==Pe)return ie.slice(0,ue)+Pe+we+ie.slice(ue+2)}}),define(De[74],Ce([1,0,15]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ti=e.$si=e.$ri=e.$qi=e.$pi=e.$oi=e.$ni=void 0;function M(i){return h(i,0)}e.$ni=M;function h(i,a){switch(typeof i){case"object":return i===null?R(349,a):Array.isArray(i)?E(i,a):$(i,a);case"string":return g(i,a);case"boolean":return A(i,a);case"number":return R(i,a);case"undefined":return R(937,a);default:return R(617,a)}}e.$oi=h;function R(i,a){return(a<<5)-a+i|0}e.$pi=R;function A(i,a){return R(i?433:863,a)}function g(i,a){a=R(149417,a);for(let m=0,p=i.length;m<p;m++)a=R(i.charCodeAt(m),a);return a}e.$qi=g;function E(i,a){return a=R(104579,a),i.reduce((m,p)=>h(p,m),a)}function $(i,a){return a=R(181387,a),Object.keys(i).sort().reduce((m,p)=>(m=g(p,m),h(i[p],m)),a)}class P{constructor(){this.g=0}get value(){return this.g}hash(a){return this.g=h(a,this.g),this.g}}e.$ri=P;var I;(function(i){i[i.BLOCK_SIZE=64]="BLOCK_SIZE",i[i.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(I||(I={}));function b(i,a,m=32){const p=m-a,f=~((1<<p)-1);return(i<<a|(f&i)>>>p)>>>0}function S(i,a=0,m=i.byteLength,p=0){for(let f=0;f<m;f++)i[a+f]=p}function C(i,a,m="0"){for(;i.length<a;)i=m+i;return i}function y(i,a=32){return i instanceof ArrayBuffer?Array.from(new Uint8Array(i)).map(m=>m.toString(16).padStart(2,"0")).join(""):C((i>>>0).toString(16),a/4)}e.$si=y;class r{static{this.g=new DataView(new ArrayBuffer(320))}constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(64+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(a){const m=a.length;if(m===0)return;const p=this.p;let f=this.r,t=this.u,s,o;for(t!==0?(s=t,o=-1,t=0):(s=a.charCodeAt(0),o=0);;){let n=s;if(D.$Sd(s))if(o+1<m){const c=a.charCodeAt(o+1);D.$Td(c)?(o++,n=D.$Ud(s,c)):n=65533}else{t=s;break}else D.$Td(s)&&(n=65533);if(f=this.w(p,f,n),o++,o<m)s=a.charCodeAt(o);else break}this.r=f,this.u=t}w(a,m,p){return p<128?a[m++]=p:p<2048?(a[m++]=192|(p&1984)>>>6,a[m++]=128|(p&63)>>>0):p<65536?(a[m++]=224|(p&61440)>>>12,a[m++]=128|(p&4032)>>>6,a[m++]=128|(p&63)>>>0):(a[m++]=240|(p&1835008)>>>18,a[m++]=128|(p&258048)>>>12,a[m++]=128|(p&4032)>>>6,a[m++]=128|(p&63)>>>0),m>=64&&(this.y(),m-=64,this.t+=64,a[0]=a[64+0],a[1]=a[64+1],a[2]=a[64+2]),m}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),y(this.h)+y(this.l)+y(this.m)+y(this.n)+y(this.o)}x(){this.p[this.r++]=128,S(this.p,this.r),this.r>56&&(this.y(),S(this.p));const a=8*this.t;this.q.setUint32(56,Math.floor(a/4294967296),!1),this.q.setUint32(60,a%4294967296,!1),this.y()}y(){const a=r.g,m=this.q;for(let v=0;v<64;v+=4)a.setUint32(v,m.getUint32(v,!1),!1);for(let v=64;v<320;v+=4)a.setUint32(v,b(a.getUint32(v-12,!1)^a.getUint32(v-32,!1)^a.getUint32(v-56,!1)^a.getUint32(v-64,!1),1),!1);let p=this.h,f=this.l,t=this.m,s=this.n,o=this.o,n,c,d;for(let v=0;v<80;v++)v<20?(n=f&t|~f&s,c=1518500249):v<40?(n=f^t^s,c=1859775393):v<60?(n=f&t|f&s|t&s,c=2400959708):(n=f^t^s,c=3395469782),d=b(p,5)+n+o+c+a.getUint32(v*4,!1)&4294967295,o=s,s=t,t=b(f,30),f=p,p=d;this.h=this.h+p&4294967295,this.l=this.l+f&4294967295,this.m=this.m+t&4294967295,this.n=this.n+s&4294967295,this.o=this.o+o&4294967295}}e.$ti=r}),define(De[40],Ce([1,0,15]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var M;(function(h){h[h.Ignore=0]="Ignore",h[h.Info=1]="Info",h[h.Warning=2]="Warning",h[h.Error=3]="Error"})(M||(M={})),function(h){const R="error",A="warning",g="warn",E="info",$="ignore";function P(b){return b?D.$Od(R,b)?h.Error:D.$Od(A,b)||D.$Od(g,b)?h.Warning:D.$Od(E,b)?h.Info:h.Ignore:h.Ignore}h.fromValue=P;function I(b){switch(b){case h.Error:return R;case h.Warning:return A;case h.Info:return E;default:return $}}h.toString=I}(M||(M={})),e.default=M}),define(De[158],Ce([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ec=void 0,e.$ec=Symbol("MicrotaskDelay")}),define(De[75],Ce([1,0,19,15]),function($e,e,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fh=e.$Eh=e.$Dh=e.$Ch=e.$Bh=void 0;class h{constructor(){this.b="",this.c=0}reset(S){return this.b=S,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(S){const C=S.charCodeAt(0),y=this.b.charCodeAt(this.c);return C-y}value(){return this.b[this.c]}}e.$Bh=h;class R{constructor(S=!0){this.e=S}reset(S){return this.b=S,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let S=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(S)this.c++;else break;else S=!1;return this}cmp(S){return this.e?(0,M.$Id)(S,this.b,0,S.length,this.c,this.d):(0,M.$Kd)(S,this.b,0,S.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$Ch=R;class A{constructor(S=!0,C=!0){this.f=S,this.g=C}reset(S){this.d=0,this.e=0,this.b=S,this.c=S.length;for(let C=S.length-1;C>=0;C--,this.c--){const y=this.b.charCodeAt(C);if(!(y===47||this.f&&y===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let S=!0;for(;this.e<this.c;this.e++){const C=this.b.charCodeAt(this.e);if(C===47||this.f&&C===92)if(S)this.d++;else break;else S=!1}return this}cmp(S){return this.g?(0,M.$Id)(S,this.b,0,S.length,this.d,this.e):(0,M.$Kd)(S,this.b,0,S.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$Dh=A;var g;(function(b){b[b.Scheme=1]="Scheme",b[b.Authority=2]="Authority",b[b.Path=3]="Path",b[b.Query=4]="Query",b[b.Fragment=5]="Fragment"})(g||(g={}));class E{constructor(S,C){this.f=S,this.g=C,this.d=[],this.e=0}reset(S){return this.c=S,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new A(!1,!this.f(S)),this.b.reset(S.path),this.b.value()&&this.d.push(3)),this.g(S)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(S){if(this.d[this.e]===1)return(0,M.$Jd)(S,this.c.scheme);if(this.d[this.e]===2)return(0,M.$Jd)(S,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(S);if(this.d[this.e]===4)return(0,M.$Hd)(S,this.c.query);if(this.d[this.e]===5)return(0,M.$Hd)(S,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.$Eh=E;class ${constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const S=this.right;return this.right=S.left,S.left=this,this.updateHeight(),S.updateHeight(),S}rotateRight(){const S=this.left;return this.left=S.right,S.right=this,this.updateHeight(),S.updateHeight(),S}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var P;(function(b){b[b.Left=-1]="Left",b[b.Mid=0]="Mid",b[b.Right=1]="Right"})(P||(P={}));class I{static forUris(S=()=>!1,C=()=>!1){return new I(new E(S,C))}static forPaths(S=!1){return new I(new A(void 0,!S))}static forStrings(){return new I(new h)}static forConfigKeys(){return new I(new R)}constructor(S){this.b=S}clear(){this.c=void 0}fill(S,C){if(C){const y=C.slice(0);(0,D.$Qf)(y);for(const r of y)this.set(r,S)}else{const y=S.slice(0);(0,D.$Qf)(y);for(const r of y)this.set(r[0],r[1])}}set(S,C){const y=this.b.reset(S);let r;this.c||(this.c=new $,this.c.segment=y.value());const i=[];for(r=this.c;;){const m=y.cmp(r.segment);if(m>0)r.left||(r.left=new $,r.left.segment=y.value()),i.push([-1,r]),r=r.left;else if(m<0)r.right||(r.right=new $,r.right.segment=y.value()),i.push([1,r]),r=r.right;else if(y.hasNext())y.next(),r.mid||(r.mid=new $,r.mid.segment=y.value()),i.push([0,r]),r=r.mid;else break}const a=r.value;r.value=C,r.key=S;for(let m=i.length-1;m>=0;m--){const p=i[m][1];p.updateHeight();const f=p.balanceFactor();if(f<-1||f>1){const t=i[m][0],s=i[m+1][0];if(t===1&&s===1)i[m][1]=p.rotateLeft();else if(t===-1&&s===-1)i[m][1]=p.rotateRight();else if(t===1&&s===-1)p.right=i[m+1][1]=i[m+1][1].rotateRight(),i[m][1]=p.rotateLeft();else if(t===-1&&s===1)p.left=i[m+1][1]=i[m+1][1].rotateLeft(),i[m][1]=p.rotateRight();else throw new Error;if(m>0)switch(i[m-1][0]){case-1:i[m-1][1].left=i[m][1];break;case 1:i[m-1][1].right=i[m][1];break;case 0:i[m-1][1].mid=i[m][1];break}else this.c=i[0][1]}}return a}get(S){return this.d(S)?.value}d(S){const C=this.b.reset(S);let y=this.c;for(;y;){const r=C.cmp(y.segment);if(r>0)y=y.left;else if(r<0)y=y.right;else if(C.hasNext())C.next(),y=y.mid;else break}return y}has(S){const C=this.d(S);return!(C?.value===void 0&&C?.mid===void 0)}delete(S){return this.e(S,!1)}deleteSuperstr(S){return this.e(S,!0)}e(S,C){const y=this.b.reset(S),r=[];let i=this.c;for(;i;){const a=y.cmp(i.segment);if(a>0)r.push([-1,i]),i=i.left;else if(a<0)r.push([1,i]),i=i.right;else if(y.hasNext())y.next(),r.push([0,i]),i=i.mid;else break}if(i){if(C?(i.left=void 0,i.mid=void 0,i.right=void 0,i.height=1):(i.key=void 0,i.value=void 0),!i.mid&&!i.value)if(i.left&&i.right){const a=this.f(i.right);if(a.key){const{key:m,value:p,segment:f}=a;this.e(a.key,!1),i.key=m,i.value=p,i.segment=f}}else{const a=i.left??i.right;if(r.length>0){const[m,p]=r[r.length-1];switch(m){case-1:p.left=a;break;case 0:p.mid=a;break;case 1:p.right=a;break}}else this.c=a}for(let a=r.length-1;a>=0;a--){const m=r[a][1];m.updateHeight();const p=m.balanceFactor();if(p>1?(m.right.balanceFactor()>=0||(m.right=m.right.rotateRight()),r[a][1]=m.rotateLeft()):p<-1&&(m.left.balanceFactor()<=0||(m.left=m.left.rotateLeft()),r[a][1]=m.rotateRight()),a>0)switch(r[a-1][0]){case-1:r[a-1][1].left=r[a][1];break;case 1:r[a-1][1].right=r[a][1];break;case 0:r[a-1][1].mid=r[a][1];break}else this.c=r[0][1]}}}f(S){for(;S.left;)S=S.left;return S}findSubstr(S){const C=this.b.reset(S);let y=this.c,r;for(;y;){const i=C.cmp(y.segment);if(i>0)y=y.left;else if(i<0)y=y.right;else if(C.hasNext())C.next(),r=y.value||r,y=y.mid;else break}return y&&y.value||r}findSuperstr(S){return this.g(S,!1)}g(S,C){const y=this.b.reset(S);let r=this.c;for(;r;){const i=y.cmp(r.segment);if(i>0)r=r.left;else if(i<0)r=r.right;else if(y.hasNext())y.next(),r=r.mid;else return r.mid?this.h(r.mid):C?r.value:void 0}}hasElementOrSubtree(S){return this.g(S,!0)!==void 0}forEach(S){for(const[C,y]of this)S(y,C)}*[Symbol.iterator](){yield*this.h(this.c)}h(S){const C=[];return this.j(S,C),C[Symbol.iterator]()}j(S,C){S&&(S.left&&this.j(S.left,C),S.value&&C.push([S.key,S.value]),S.mid&&this.j(S.mid,C),S.right&&this.j(S.right,C))}_isBalanced(){const S=C=>{if(!C)return!0;const y=C.balanceFactor();return y<-1||y>1?!1:S(C.left)&&S(C.right)};return S(this.c)}}e.$Fh=I}),define(De[18],Ce([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ce=e.$Be=e.$Ae=e.$ze=e.$ye=e.$xe=e.$we=e.$ve=e.$ue=e.$te=e.$se=e.$re=e.$qe=e.$pe=e.$oe=e.$ne=e.$me=e.$le=void 0;function D(f){return typeof f=="string"}e.$le=D;function M(f){return Array.isArray(f)&&f.every(t=>D(t))}e.$me=M;function h(f){return typeof f=="object"&&f!==null&&!Array.isArray(f)&&!(f instanceof RegExp)&&!(f instanceof Date)}e.$ne=h;function R(f){const t=Object.getPrototypeOf(Uint8Array);return typeof f=="object"&&f instanceof t}e.$oe=R;function A(f){return typeof f=="number"&&!isNaN(f)}e.$pe=A;function g(f){return!!f&&typeof f[Symbol.iterator]=="function"}e.$qe=g;function E(f){return f===!0||f===!1}e.$re=E;function $(f){return typeof f>"u"}e.$se=$;function P(f){return!I(f)}e.$te=P;function I(f){return $(f)||f===null}e.$ue=I;function b(f,t){if(!f)throw new Error(t?`Unexpected type, expected '${t}'`:"Unexpected type")}e.$ve=b;function S(f){if(I(f))throw new Error("Assertion Failed: argument is undefined or null");return f}e.$we=S;function C(...f){const t=[];for(let s=0;s<f.length;s++){const o=f[s];if(I(o))throw new Error(`Assertion Failed: argument at index ${s} is undefined or null`);t.push(o)}return t}e.$xe=C;const y=Object.prototype.hasOwnProperty;function r(f){if(!h(f))return!1;for(const t in f)if(y.call(f,t))return!1;return!0}e.$ye=r;function i(f){return typeof f=="function"}e.$ze=i;function a(...f){return f.length>0&&f.every(i)}e.$Ae=a;function m(f,t){const s=Math.min(f.length,t.length);for(let o=0;o<s;o++)p(f[o],t[o])}e.$Be=m;function p(f,t){if(D(t)){if(typeof f!==t)throw new Error(`argument does not match constraint: typeof ${t}`)}else if(i(t)){try{if(f instanceof t)return}catch{}if(!I(f)&&f.constructor===t||t.length===1&&t.call(void 0,f)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.$Ce=p}),define(De[76],Ce([1,0,18]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nj=e.$Mj=e.$Lj=void 0;const M=Object.create(null);function h(g,E){if((0,D.$le)(E)){const $=M[E];if($===void 0)throw new Error(`${g} references an unknown codicon: ${E}`);E=$}return M[g]=E,{id:g}}function R(){return M}e.$Lj=R;function A(){return Object.values(e.$Nj)}e.$Mj=A,e.$Nj={add:h("add",6e4),plus:h("plus",6e4),gistNew:h("gist-new",6e4),repoCreate:h("repo-create",6e4),lightbulb:h("lightbulb",60001),lightBulb:h("light-bulb",60001),repo:h("repo",60002),repoDelete:h("repo-delete",60002),gistFork:h("gist-fork",60003),repoForked:h("repo-forked",60003),gitPullRequest:h("git-pull-request",60004),gitPullRequestAbandoned:h("git-pull-request-abandoned",60004),recordKeys:h("record-keys",60005),keyboard:h("keyboard",60005),tag:h("tag",60006),tagAdd:h("tag-add",60006),tagRemove:h("tag-remove",60006),gitPullRequestLabel:h("git-pull-request-label",60006),person:h("person",60007),personFollow:h("person-follow",60007),personOutline:h("person-outline",60007),personFilled:h("person-filled",60007),gitBranch:h("git-branch",60008),gitBranchCreate:h("git-branch-create",60008),gitBranchDelete:h("git-branch-delete",60008),sourceControl:h("source-control",60008),mirror:h("mirror",60009),mirrorPublic:h("mirror-public",60009),star:h("star",60010),starAdd:h("star-add",60010),starDelete:h("star-delete",60010),starEmpty:h("star-empty",60010),comment:h("comment",60011),commentAdd:h("comment-add",60011),alert:h("alert",60012),warning:h("warning",60012),search:h("search",60013),searchSave:h("search-save",60013),logOut:h("log-out",60014),signOut:h("sign-out",60014),logIn:h("log-in",60015),signIn:h("sign-in",60015),eye:h("eye",60016),eyeUnwatch:h("eye-unwatch",60016),eyeWatch:h("eye-watch",60016),circleFilled:h("circle-filled",60017),primitiveDot:h("primitive-dot",60017),closeDirty:h("close-dirty",60017),debugBreakpoint:h("debug-breakpoint",60017),debugBreakpointDisabled:h("debug-breakpoint-disabled",60017),debugHint:h("debug-hint",60017),primitiveSquare:h("primitive-square",60018),edit:h("edit",60019),pencil:h("pencil",60019),info:h("info",60020),issueOpened:h("issue-opened",60020),gistPrivate:h("gist-private",60021),gitForkPrivate:h("git-fork-private",60021),lock:h("lock",60021),mirrorPrivate:h("mirror-private",60021),close:h("close",60022),removeClose:h("remove-close",60022),x:h("x",60022),repoSync:h("repo-sync",60023),sync:h("sync",60023),clone:h("clone",60024),desktopDownload:h("desktop-download",60024),beaker:h("beaker",60025),microscope:h("microscope",60025),vm:h("vm",60026),deviceDesktop:h("device-desktop",60026),file:h("file",60027),fileText:h("file-text",60027),more:h("more",60028),ellipsis:h("ellipsis",60028),kebabHorizontal:h("kebab-horizontal",60028),mailReply:h("mail-reply",60029),reply:h("reply",60029),organization:h("organization",60030),organizationFilled:h("organization-filled",60030),organizationOutline:h("organization-outline",60030),newFile:h("new-file",60031),fileAdd:h("file-add",60031),newFolder:h("new-folder",60032),fileDirectoryCreate:h("file-directory-create",60032),trash:h("trash",60033),trashcan:h("trashcan",60033),history:h("history",60034),clock:h("clock",60034),folder:h("folder",60035),fileDirectory:h("file-directory",60035),symbolFolder:h("symbol-folder",60035),logoGithub:h("logo-github",60036),markGithub:h("mark-github",60036),github:h("github",60036),terminal:h("terminal",60037),console:h("console",60037),repl:h("repl",60037),zap:h("zap",60038),symbolEvent:h("symbol-event",60038),error:h("error",60039),stop:h("stop",60039),variable:h("variable",60040),symbolVariable:h("symbol-variable",60040),array:h("array",60042),symbolArray:h("symbol-array",60042),symbolModule:h("symbol-module",60043),symbolPackage:h("symbol-package",60043),symbolNamespace:h("symbol-namespace",60043),symbolObject:h("symbol-object",60043),symbolMethod:h("symbol-method",60044),symbolFunction:h("symbol-function",60044),symbolConstructor:h("symbol-constructor",60044),symbolBoolean:h("symbol-boolean",60047),symbolNull:h("symbol-null",60047),symbolNumeric:h("symbol-numeric",60048),symbolNumber:h("symbol-number",60048),symbolStructure:h("symbol-structure",60049),symbolStruct:h("symbol-struct",60049),symbolParameter:h("symbol-parameter",60050),symbolTypeParameter:h("symbol-type-parameter",60050),symbolKey:h("symbol-key",60051),symbolText:h("symbol-text",60051),symbolReference:h("symbol-reference",60052),goToFile:h("go-to-file",60052),symbolEnum:h("symbol-enum",60053),symbolValue:h("symbol-value",60053),symbolRuler:h("symbol-ruler",60054),symbolUnit:h("symbol-unit",60054),activateBreakpoints:h("activate-breakpoints",60055),archive:h("archive",60056),arrowBoth:h("arrow-both",60057),arrowDown:h("arrow-down",60058),arrowLeft:h("arrow-left",60059),arrowRight:h("arrow-right",60060),arrowSmallDown:h("arrow-small-down",60061),arrowSmallLeft:h("arrow-small-left",60062),arrowSmallRight:h("arrow-small-right",60063),arrowSmallUp:h("arrow-small-up",60064),arrowUp:h("arrow-up",60065),bell:h("bell",60066),bold:h("bold",60067),book:h("book",60068),bookmark:h("bookmark",60069),debugBreakpointConditionalUnverified:h("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:h("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:h("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:h("debug-breakpoint-data-unverified",60072),debugBreakpointData:h("debug-breakpoint-data",60073),debugBreakpointDataDisabled:h("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:h("debug-breakpoint-log-unverified",60074),debugBreakpointLog:h("debug-breakpoint-log",60075),debugBreakpointLogDisabled:h("debug-breakpoint-log-disabled",60075),briefcase:h("briefcase",60076),broadcast:h("broadcast",60077),browser:h("browser",60078),bug:h("bug",60079),calendar:h("calendar",60080),caseSensitive:h("case-sensitive",60081),check:h("check",60082),checklist:h("checklist",60083),chevronDown:h("chevron-down",60084),dropDownButton:h("drop-down-button",60084),chevronLeft:h("chevron-left",60085),chevronRight:h("chevron-right",60086),chevronUp:h("chevron-up",60087),chromeClose:h("chrome-close",60088),chromeMaximize:h("chrome-maximize",60089),chromeMinimize:h("chrome-minimize",60090),chromeRestore:h("chrome-restore",60091),circle:h("circle",60092),circleOutline:h("circle-outline",60092),debugBreakpointUnverified:h("debug-breakpoint-unverified",60092),circleSlash:h("circle-slash",60093),circuitBoard:h("circuit-board",60094),clearAll:h("clear-all",60095),clippy:h("clippy",60096),closeAll:h("close-all",60097),cloudDownload:h("cloud-download",60098),cloudUpload:h("cloud-upload",60099),code:h("code",60100),collapseAll:h("collapse-all",60101),colorMode:h("color-mode",60102),commentDiscussion:h("comment-discussion",60103),compareChanges:h("compare-changes",60157),creditCard:h("credit-card",60105),dash:h("dash",60108),dashboard:h("dashboard",60109),database:h("database",60110),debugContinue:h("debug-continue",60111),debugDisconnect:h("debug-disconnect",60112),debugPause:h("debug-pause",60113),debugRestart:h("debug-restart",60114),debugStart:h("debug-start",60115),debugStepInto:h("debug-step-into",60116),debugStepOut:h("debug-step-out",60117),debugStepOver:h("debug-step-over",60118),debugStop:h("debug-stop",60119),debug:h("debug",60120),deviceCameraVideo:h("device-camera-video",60121),deviceCamera:h("device-camera",60122),deviceMobile:h("device-mobile",60123),diffAdded:h("diff-added",60124),diffIgnored:h("diff-ignored",60125),diffModified:h("diff-modified",60126),diffRemoved:h("diff-removed",60127),diffRenamed:h("diff-renamed",60128),diff:h("diff",60129),discard:h("discard",60130),editorLayout:h("editor-layout",60131),emptyWindow:h("empty-window",60132),exclude:h("exclude",60133),extensions:h("extensions",60134),eyeClosed:h("eye-closed",60135),fileBinary:h("file-binary",60136),fileCode:h("file-code",60137),fileMedia:h("file-media",60138),filePdf:h("file-pdf",60139),fileSubmodule:h("file-submodule",60140),fileSymlinkDirectory:h("file-symlink-directory",60141),fileSymlinkFile:h("file-symlink-file",60142),fileZip:h("file-zip",60143),files:h("files",60144),filter:h("filter",60145),flame:h("flame",60146),foldDown:h("fold-down",60147),foldUp:h("fold-up",60148),fold:h("fold",60149),folderActive:h("folder-active",60150),folderOpened:h("folder-opened",60151),gear:h("gear",60152),gift:h("gift",60153),gistSecret:h("gist-secret",60154),gist:h("gist",60155),gitCommit:h("git-commit",60156),gitCompare:h("git-compare",60157),gitMerge:h("git-merge",60158),githubAction:h("github-action",60159),githubAlt:h("github-alt",60160),globe:h("globe",60161),grabber:h("grabber",60162),graph:h("graph",60163),gripper:h("gripper",60164),heart:h("heart",60165),home:h("home",60166),horizontalRule:h("horizontal-rule",60167),hubot:h("hubot",60168),inbox:h("inbox",60169),issueClosed:h("issue-closed",60324),issueReopened:h("issue-reopened",60171),issues:h("issues",60172),italic:h("italic",60173),jersey:h("jersey",60174),json:h("json",60175),bracket:h("bracket",60175),kebabVertical:h("kebab-vertical",60176),key:h("key",60177),law:h("law",60178),lightbulbAutofix:h("lightbulb-autofix",60179),linkExternal:h("link-external",60180),link:h("link",60181),listOrdered:h("list-ordered",60182),listUnordered:h("list-unordered",60183),liveShare:h("live-share",60184),loading:h("loading",60185),location:h("location",60186),mailRead:h("mail-read",60187),mail:h("mail",60188),markdown:h("markdown",60189),megaphone:h("megaphone",60190),mention:h("mention",60191),milestone:h("milestone",60192),gitPullRequestMilestone:h("git-pull-request-milestone",60192),mortarBoard:h("mortar-board",60193),move:h("move",60194),multipleWindows:h("multiple-windows",60195),mute:h("mute",60196),noNewline:h("no-newline",60197),note:h("note",60198),octoface:h("octoface",60199),openPreview:h("open-preview",60200),package_:h("package",60201),paintcan:h("paintcan",60202),pin:h("pin",60203),play:h("play",60204),run:h("run",60204),plug:h("plug",60205),preserveCase:h("preserve-case",60206),preview:h("preview",60207),project:h("project",60208),pulse:h("pulse",60209),question:h("question",60210),quote:h("quote",60211),radioTower:h("radio-tower",60212),reactions:h("reactions",60213),references:h("references",60214),refresh:h("refresh",60215),regex:h("regex",60216),remoteExplorer:h("remote-explorer",60217),remote:h("remote",60218),remove:h("remove",60219),replaceAll:h("replace-all",60220),replace:h("replace",60221),repoClone:h("repo-clone",60222),repoForcePush:h("repo-force-push",60223),repoPull:h("repo-pull",60224),repoPush:h("repo-push",60225),report:h("report",60226),requestChanges:h("request-changes",60227),rocket:h("rocket",60228),rootFolderOpened:h("root-folder-opened",60229),rootFolder:h("root-folder",60230),rss:h("rss",60231),ruby:h("ruby",60232),saveAll:h("save-all",60233),saveAs:h("save-as",60234),save:h("save",60235),screenFull:h("screen-full",60236),screenNormal:h("screen-normal",60237),searchStop:h("search-stop",60238),server:h("server",60240),settingsGear:h("settings-gear",60241),settings:h("settings",60242),shield:h("shield",60243),smiley:h("smiley",60244),sortPrecedence:h("sort-precedence",60245),splitHorizontal:h("split-horizontal",60246),splitVertical:h("split-vertical",60247),squirrel:h("squirrel",60248),starFull:h("star-full",60249),starHalf:h("star-half",60250),symbolClass:h("symbol-class",60251),symbolColor:h("symbol-color",60252),symbolCustomColor:h("symbol-customcolor",60252),symbolConstant:h("symbol-constant",60253),symbolEnumMember:h("symbol-enum-member",60254),symbolField:h("symbol-field",60255),symbolFile:h("symbol-file",60256),symbolInterface:h("symbol-interface",60257),symbolKeyword:h("symbol-keyword",60258),symbolMisc:h("symbol-misc",60259),symbolOperator:h("symbol-operator",60260),symbolProperty:h("symbol-property",60261),wrench:h("wrench",60261),wrenchSubaction:h("wrench-subaction",60261),symbolSnippet:h("symbol-snippet",60262),tasklist:h("tasklist",60263),telescope:h("telescope",60264),textSize:h("text-size",60265),threeBars:h("three-bars",60266),thumbsdown:h("thumbsdown",60267),thumbsup:h("thumbsup",60268),tools:h("tools",60269),triangleDown:h("triangle-down",60270),triangleLeft:h("triangle-left",60271),triangleRight:h("triangle-right",60272),triangleUp:h("triangle-up",60273),twitter:h("twitter",60274),unfold:h("unfold",60275),unlock:h("unlock",60276),unmute:h("unmute",60277),unverified:h("unverified",60278),verified:h("verified",60279),versions:h("versions",60280),vmActive:h("vm-active",60281),vmOutline:h("vm-outline",60282),vmRunning:h("vm-running",60283),watch:h("watch",60284),whitespace:h("whitespace",60285),wholeWord:h("whole-word",60286),window:h("window",60287),wordWrap:h("word-wrap",60288),zoomIn:h("zoom-in",60289),zoomOut:h("zoom-out",60290),listFilter:h("list-filter",60291),listFlat:h("list-flat",60292),listSelection:h("list-selection",60293),selection:h("selection",60293),listTree:h("list-tree",60294),debugBreakpointFunctionUnverified:h("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:h("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:h("debug-breakpoint-function-disabled",60296),debugStackframeActive:h("debug-stackframe-active",60297),circleSmallFilled:h("circle-small-filled",60298),debugStackframeDot:h("debug-stackframe-dot",60298),debugStackframe:h("debug-stackframe",60299),debugStackframeFocused:h("debug-stackframe-focused",60299),debugBreakpointUnsupported:h("debug-breakpoint-unsupported",60300),symbolString:h("symbol-string",60301),debugReverseContinue:h("debug-reverse-continue",60302),debugStepBack:h("debug-step-back",60303),debugRestartFrame:h("debug-restart-frame",60304),callIncoming:h("call-incoming",60306),callOutgoing:h("call-outgoing",60307),menu:h("menu",60308),expandAll:h("expand-all",60309),feedback:h("feedback",60310),gitPullRequestReviewer:h("git-pull-request-reviewer",60310),groupByRefType:h("group-by-ref-type",60311),ungroupByRefType:h("ungroup-by-ref-type",60312),account:h("account",60313),gitPullRequestAssignee:h("git-pull-request-assignee",60313),bellDot:h("bell-dot",60314),debugConsole:h("debug-console",60315),library:h("library",60316),output:h("output",60317),runAll:h("run-all",60318),syncIgnored:h("sync-ignored",60319),pinned:h("pinned",60320),githubInverted:h("github-inverted",60321),debugAlt:h("debug-alt",60305),serverProcess:h("server-process",60322),serverEnvironment:h("server-environment",60323),pass:h("pass",60324),stopCircle:h("stop-circle",60325),playCircle:h("play-circle",60326),record:h("record",60327),debugAltSmall:h("debug-alt-small",60328),vmConnect:h("vm-connect",60329),cloud:h("cloud",60330),merge:h("merge",60331),exportIcon:h("export",60332),graphLeft:h("graph-left",60333),magnet:h("magnet",60334),notebook:h("notebook",60335),redo:h("redo",60336),checkAll:h("check-all",60337),pinnedDirty:h("pinned-dirty",60338),passFilled:h("pass-filled",60339),circleLargeFilled:h("circle-large-filled",60340),circleLarge:h("circle-large",60341),circleLargeOutline:h("circle-large-outline",60341),combine:h("combine",60342),gather:h("gather",60342),table:h("table",60343),variableGroup:h("variable-group",60344),typeHierarchy:h("type-hierarchy",60345),typeHierarchySub:h("type-hierarchy-sub",60346),typeHierarchySuper:h("type-hierarchy-super",60347),gitPullRequestCreate:h("git-pull-request-create",60348),runAbove:h("run-above",60349),runBelow:h("run-below",60350),notebookTemplate:h("notebook-template",60351),debugRerun:h("debug-rerun",60352),workspaceTrusted:h("workspace-trusted",60353),workspaceUntrusted:h("workspace-untrusted",60354),workspaceUnspecified:h("workspace-unspecified",60355),terminalCmd:h("terminal-cmd",60356),terminalDebian:h("terminal-debian",60357),terminalLinux:h("terminal-linux",60358),terminalPowershell:h("terminal-powershell",60359),terminalTmux:h("terminal-tmux",60360),terminalUbuntu:h("terminal-ubuntu",60361),terminalBash:h("terminal-bash",60362),arrowSwap:h("arrow-swap",60363),copy:h("copy",60364),personAdd:h("person-add",60365),filterFilled:h("filter-filled",60366),wand:h("wand",60367),debugLineByLine:h("debug-line-by-line",60368),inspect:h("inspect",60369),layers:h("layers",60370),layersDot:h("layers-dot",60371),layersActive:h("layers-active",60372),compass:h("compass",60373),compassDot:h("compass-dot",60374),compassActive:h("compass-active",60375),azure:h("azure",60376),issueDraft:h("issue-draft",60377),gitPullRequestClosed:h("git-pull-request-closed",60378),gitPullRequestDraft:h("git-pull-request-draft",60379),debugAll:h("debug-all",60380),debugCoverage:h("debug-coverage",60381),runErrors:h("run-errors",60382),folderLibrary:h("folder-library",60383),debugContinueSmall:h("debug-continue-small",60384),beakerStop:h("beaker-stop",60385),graphLine:h("graph-line",60386),graphScatter:h("graph-scatter",60387),pieChart:h("pie-chart",60388),bracketDot:h("bracket-dot",60389),bracketError:h("bracket-error",60390),lockSmall:h("lock-small",60391),azureDevops:h("azure-devops",60392),verifiedFilled:h("verified-filled",60393),newLine:h("newline",60394),layout:h("layout",60395),layoutActivitybarLeft:h("layout-activitybar-left",60396),layoutActivitybarRight:h("layout-activitybar-right",60397),layoutPanelLeft:h("layout-panel-left",60398),layoutPanelCenter:h("layout-panel-center",60399),layoutPanelJustify:h("layout-panel-justify",60400),layoutPanelRight:h("layout-panel-right",60401),layoutPanel:h("layout-panel",60402),layoutSidebarLeft:h("layout-sidebar-left",60403),layoutSidebarRight:h("layout-sidebar-right",60404),layoutStatusbar:h("layout-statusbar",60405),layoutMenubar:h("layout-menubar",60406),layoutCentered:h("layout-centered",60407),layoutSidebarRightOff:h("layout-sidebar-right-off",60416),layoutPanelOff:h("layout-panel-off",60417),layoutSidebarLeftOff:h("layout-sidebar-left-off",60418),target:h("target",60408),indent:h("indent",60409),recordSmall:h("record-small",60410),errorSmall:h("error-small",60411),arrowCircleDown:h("arrow-circle-down",60412),arrowCircleLeft:h("arrow-circle-left",60413),arrowCircleRight:h("arrow-circle-right",60414),arrowCircleUp:h("arrow-circle-up",60415),heartFilled:h("heart-filled",60420),map:h("map",60421),mapFilled:h("map-filled",60422),circleSmall:h("circle-small",60423),bellSlash:h("bell-slash",60424),bellSlashDot:h("bell-slash-dot",60425),commentUnresolved:h("comment-unresolved",60426),gitPullRequestGoToChanges:h("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:h("git-pull-request-new-changes",60428),searchFuzzy:h("search-fuzzy",60429),commentDraft:h("comment-draft",60430),send:h("send",60431),sparkle:h("sparkle",60432),insert:h("insert",60433),mic:h("mic",60434),dialogError:h("dialog-error","error"),dialogWarning:h("dialog-warning","warning"),dialogInfo:h("dialog-info","info"),dialogClose:h("dialog-close","close"),treeItemExpanded:h("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:h("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:h("tree-filter-on-type-off","list-selection"),treeFilterClear:h("tree-filter-clear","close"),treeItemLoading:h("tree-item-loading","loading"),menuSelection:h("menu-selection","check"),menuSubmenu:h("menu-submenu","chevron-right"),menuBarMore:h("menubar-more","more"),scrollbarButtonLeft:h("scrollbar-button-left","triangle-left"),scrollbarButtonRight:h("scrollbar-button-right","triangle-right"),scrollbarButtonUp:h("scrollbar-button-up","triangle-up"),scrollbarButtonDown:h("scrollbar-button-down","triangle-down"),toolBarMore:h("toolbar-more","more"),quickInputBack:h("quick-input-back","arrow-left")}}),define(De[23],Ce([1,0,18]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5m=e.$4m=e.$3m=e.$2m=e.$1m=e.$Zm=e.$Ym=e.$Xm=e.$Wm=e.$Vm=e.$Um=e.$Tm=void 0;function M(i){if(!i||typeof i!="object"||i instanceof RegExp)return i;const a=Array.isArray(i)?[]:{};return Object.entries(i).forEach(([m,p])=>{a[m]=p&&typeof p=="object"?M(p):p}),a}e.$Tm=M;function h(i){if(!i||typeof i!="object")return i;const a=[i];for(;a.length>0;){const m=a.shift();Object.freeze(m);for(const p in m)if(R.call(m,p)){const f=m[p];typeof f=="object"&&!Object.isFrozen(f)&&!(0,D.$oe)(f)&&a.push(f)}}return i}e.$Um=h;const R=Object.prototype.hasOwnProperty;function A(i,a){return g(i,a,new Set)}e.$Vm=A;function g(i,a,m){if((0,D.$ue)(i))return i;const p=a(i);if(typeof p<"u")return p;if(Array.isArray(i)){const f=[];for(const t of i)f.push(g(t,a,m));return f}if((0,D.$ne)(i)){if(m.has(i))throw new Error("Cannot clone recursive data-structure");m.add(i);const f={};for(const t in i)R.call(i,t)&&(f[t]=g(i[t],a,m));return m.delete(i),f}return i}function E(i,a,m=!0){return(0,D.$ne)(i)?((0,D.$ne)(a)&&Object.keys(a).forEach(p=>{p in i?m&&((0,D.$ne)(i[p])&&(0,D.$ne)(a[p])?E(i[p],a[p],m):i[p]=a[p]):i[p]=a[p]}),i):a}e.$Wm=E;function $(i,a){if(i===a)return!0;if(i==null||a===null||a===void 0||typeof i!=typeof a||typeof i!="object"||Array.isArray(i)!==Array.isArray(a))return!1;let m,p;if(Array.isArray(i)){if(i.length!==a.length)return!1;for(m=0;m<i.length;m++)if(!$(i[m],a[m]))return!1}else{const f=[];for(p in i)f.push(p);f.sort();const t=[];for(p in a)t.push(p);if(t.sort(),!$(f,t))return!1;for(m=0;m<f.length;m++)if(!$(i[f[m]],a[f[m]]))return!1}return!0}e.$Xm=$;function P(i){const a=new Set;return JSON.stringify(i,(m,p)=>{if((0,D.$ne)(p)||Array.isArray(p)){if(a.has(p))return"[Circular]";a.add(p)}return p})}e.$Ym=P;function I(i,a){const m=Object.create(null);return!i||!a||Object.keys(a).forEach(f=>{const t=i[f],s=a[f];$(t,s)||(m[f]=s)}),m}e.$Zm=I;function b(i,a){const m=a.toLowerCase(),p=Object.keys(i).find(f=>f.toLowerCase()===m);return p?i[p]:i[a]}e.$1m=b;function S(i,a){const m=Object.create(null);for(const[p,f]of Object.entries(i))a(p,f)&&(m[p]=f);return m}e.$2m=S;function C(i){let a=[];for(;Object.prototype!==i;)a=a.concat(Object.getOwnPropertyNames(i)),i=Object.getPrototypeOf(i);return a}e.$3m=C;function y(i){const a=[];for(const m of C(i))typeof i[m]=="function"&&a.push(m);return a}e.$4m=y;function r(i,a){const m=f=>function(){const t=Array.prototype.slice.call(arguments,0);return a(f,t)},p={};for(const f of i)p[f]=m(f);return p}e.$5m=r}),define(De[56],Ce([1,0,76]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.$Oj=e.ThemeColor=void 0;var M;(function(A){function g(E){return E&&typeof E=="object"&&typeof E.id=="string"}A.isThemeColor=g})(M||(e.ThemeColor=M={}));function h(A){return{id:A}}e.$Oj=h;var R;(function(A){A.iconNameSegment="[A-Za-z0-9]+",A.iconNameExpression="[A-Za-z0-9-]+",A.iconModifierExpression="~[A-Za-z]+",A.iconNameCharacter="[A-Za-z0-9~-]";const g=new RegExp(`^(${A.iconNameExpression})(${A.iconModifierExpression})?$`);function E(a){const m=g.exec(a.id);if(!m)return E(D.$Nj.error);const[,p,f]=m,t=["codicon","codicon-"+p];return f&&t.push("codicon-modifier-"+f.substring(1)),t}A.asClassNameArray=E;function $(a){return E(a).join(" ")}A.asClassName=$;function P(a){return"."+E(a).join(".")}A.asCSSSelector=P;function I(a){return a&&typeof a=="object"&&typeof a.id=="string"&&(typeof a.color>"u"||M.isThemeColor(a.color))}A.isThemeIcon=I;const b=new RegExp(`^\\$\\((${A.iconNameExpression}(?:${A.iconModifierExpression})?)\\)$`);function S(a){const m=b.exec(a);if(!m)return;const[,p]=m;return{id:p}}A.fromString=S;function C(a){return{id:a}}A.fromId=C;function y(a,m){let p=a.id;const f=p.lastIndexOf("~");return f!==-1&&(p=p.substring(0,f)),m&&(p=`${p}~${m}`),{id:p}}A.modify=y;function r(a){const m=a.id.lastIndexOf("~");if(m!==-1)return a.id.substring(m+1)}A.getModifier=r;function i(a,m){return a.id===m.id&&a.color?.id===m.color?.id}A.isEqual=i})(R||(e.ThemeIcon=R={}))}),define(De[159],Ce([1,0,120,15,56]),function($e,e,D,M,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uj=e.$Tj=e.$Sj=e.$Rj=e.$Qj=e.$Pj=void 0;const R="$(",A=new RegExp(`\\$\\(${h.ThemeIcon.iconNameExpression}(?:${h.ThemeIcon.iconModifierExpression})?\\)`,"g"),g=new RegExp(`(\\\\)?${A.source}`,"g");function E(i){return i.replace(g,(a,m)=>m?a:`\\${a}`)}e.$Pj=E;const $=new RegExp(`\\\\${A.source}`,"g");function P(i){return i.replace($,a=>`\\${a}`)}e.$Qj=P;const I=new RegExp(`(\\s)?(\\\\)?${A.source}(\\s)?`,"g");function b(i){return i.indexOf(R)===-1?i:i.replace(I,(a,m,p,f)=>p?a:m||f||"")}e.$Rj=b;function S(i){return i?i.replace(/\$\((.*?)\)/g,(a,m)=>` ${m} `).trim():""}e.$Sj=S;const C=new RegExp(`\\$\\(${h.ThemeIcon.iconNameCharacter}+\\)`,"g");function y(i){C.lastIndex=0;let a="";const m=[];let p=0;for(;;){const f=C.lastIndex,t=C.exec(i),s=i.substring(f,t?.index);if(s.length>0){a+=s;for(let o=0;o<s.length;o++)m.push(p)}if(!t)break;p+=t[0].length}return{text:a,iconOffsets:m}}e.$Tj=y;function r(i,a,m=!1){const{text:p,iconOffsets:f}=a;if(!f||f.length===0)return(0,D.$Cj)(i,p,m);const t=(0,M.$wd)(p," "),s=p.length-t.length,o=(0,D.$Cj)(i,t,m);if(o)for(const n of o){const c=f[n.start+s]+s;n.start+=c,n.end+=c}return o}e.$Uj=r}),define(De[121],Ce([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nd=e.$md=e.Constants=void 0;var D;(function(R){R[R.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",R[R.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",R[R.MAX_UINT_8=255]="MAX_UINT_8",R[R.MAX_UINT_16=65535]="MAX_UINT_16",R[R.MAX_UINT_32=4294967295]="MAX_UINT_32",R[R.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(D||(e.Constants=D={}));function M(R){return R<0?0:R>255?255:R|0}e.$md=M;function h(R){return R<0?0:R>4294967295?4294967295:R|0}e.$nd=h}),define(De[31],Ce([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6e=e.$5e=void 0;const D=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function M(h){return D.test(h)}e.$5e=M,e.$6e=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let h;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?h=crypto.getRandomValues.bind(crypto):h=function(g){for(let E=0;E<g.length;E++)g[E]=Math.floor(Math.random()*256);return g};const R=new Uint8Array(16),A=[];for(let g=0;g<256;g++)A.push(g.toString(16).padStart(2,"0"));return function(){h(R),R[6]=R[6]&15|64,R[8]=R[8]&63|128;let E=0,$="";return $+=A[R[E++]],$+=A[R[E++]],$+=A[R[E++]],$+=A[R[E++]],$+="-",$+=A[R[E++]],$+=A[R[E++]],$+="-",$+=A[R[E++]],$+=A[R[E++]],$+="-",$+=A[R[E++]],$+=A[R[E++]],$+="-",$+=A[R[E++]],$+=A[R[E++]],$+=A[R[E++]],$+=A[R[E++]],$+=A[R[E++]],$+=A[R[E++]],$}}()}),define(De[160],Ce([1,0,19,48,31]),function($e,e,D,M,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qs=e.$Ps=e.$Os=e.$Ns=e.$Ms=void 0;function R(I){return{asString:async()=>I,asFile:()=>{},value:typeof I=="string"?I:void 0}}e.$Ms=R;function A(I,b,S){const C={id:(0,h.$6e)(),name:I,uri:b,data:S};return{asString:async()=>"",asFile:()=>C,value:void 0}}e.$Ns=A;class g{constructor(){this.a=new Map}get size(){let b=0;for(const S of this.a)b++;return b}has(b){return this.a.has(this.b(b))}matches(b){const S=[...this.a.keys()];return M.Iterable.some(this,([C,y])=>y.asFile())&&S.push("files"),P(E(b),S)}get(b){return this.a.get(this.b(b))?.[0]}append(b,S){const C=this.a.get(b);C?C.push(S):this.a.set(this.b(b),[S])}replace(b,S){this.a.set(this.b(b),[S])}delete(b){this.a.delete(this.b(b))}*[Symbol.iterator](){for(const[b,S]of this.a)for(const C of S)yield[b,C]}b(b){return E(b)}}e.$Os=g;function E(I){return I.toLowerCase()}function $(I,b){return P(E(I),b.map(E))}e.$Ps=$;function P(I,b){if(I==="*/*")return b.length>0;if(b.includes(I))return!0;const S=I.match(/^([a-z]+)\/([a-z]+|\*)$/i);if(!S)return!1;const[C,y,r]=S;return r==="*"?b.some(i=>i.startsWith(y+"/")):!1}e.$Qs=Object.freeze({create:I=>(0,D.$Ff)(I.map(b=>b.toString())).join(`\r
`),split:I=>I.split(`\r
`),parse:I=>e.$Qs.split(I).filter(b=>!b.startsWith("#"))})}),define(De[161],Ce([1,0,57]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0e=e.$9e=e.$8e=void 0;function M(g,E,$,P=1){let I=!1;return new Promise(b=>{const S=setTimeout(()=>{if(!I)return I=!0,b(0)},$);h(g,E,P,C=>{if(!I)return I=!0,clearTimeout(S),b(C)})})}e.$8e=M;function h(g,E,$,P){if(E===0)return P(0);const I=new D.Socket;I.once("connect",()=>(A(I),h(g+$,E-1,$,P))),I.once("data",()=>{}),I.once("error",b=>(A(I),b.code!=="ECONNREFUSED"?h(g+$,E-1,$,P):P(g))),I.connect(g,"127.0.0.1")}e.$9e={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function R(g,E,$,P="127.0.0.1"){let I=!1,b,S=1;const C=D.createServer({pauseOnConnect:!0});function y(r,i){I||(I=!0,C.removeAllListeners(),C.close(),b&&clearTimeout(b),i(r))}return new Promise(r=>{b=setTimeout(()=>{y(0,r)},$),C.on("listening",()=>{y(g,r)}),C.on("error",i=>{i&&(i.code==="EADDRINUSE"||i.code==="EACCES")&&S<E?(g++,S++,C.listen(g,P)):y(0,r)}),C.on("close",()=>{y(0,r)}),C.listen(g,P)})}e.$0e=R;function A(g){try{g.removeAllListeners("connect"),g.removeAllListeners("error"),g.end(),g.destroy(),g.unref()}catch(E){console.error(E)}}}),define(De[122],Ce([1,0,121]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fs=e.$Es=void 0;class M{constructor(g){const E=(0,D.$md)(g);this.c=E,this.a=M.d(E),this.b=new Map}static d(g){const E=new Uint8Array(256);return E.fill(g),E}set(g,E){const $=(0,D.$md)(E);g>=0&&g<256?this.a[g]=$:this.b.set(g,$)}get(g){return g>=0&&g<256?this.a[g]:this.b.get(g)||this.c}clear(){this.a.fill(this.c),this.b.clear()}}e.$Es=M;var h;(function(A){A[A.False=0]="False",A[A.True=1]="True"})(h||(h={}));class R{constructor(){this.a=new M(0)}add(g){this.a.set(g,1)}has(g){return this.a.get(g)===1}clear(){return this.a.clear()}}e.$Fs=R}),define(De[58],Ce([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gs=void 0;class D{constructor(h,R){this.lineNumber=h,this.column=R}with(h=this.lineNumber,R=this.column){return h===this.lineNumber&&R===this.column?this:new D(h,R)}delta(h=0,R=0){return this.with(this.lineNumber+h,this.column+R)}equals(h){return D.equals(this,h)}static equals(h,R){return!h&&!R?!0:!!h&&!!R&&h.lineNumber===R.lineNumber&&h.column===R.column}isBefore(h){return D.isBefore(this,h)}static isBefore(h,R){return h.lineNumber<R.lineNumber?!0:R.lineNumber<h.lineNumber?!1:h.column<R.column}isBeforeOrEqual(h){return D.isBeforeOrEqual(this,h)}static isBeforeOrEqual(h,R){return h.lineNumber<R.lineNumber?!0:R.lineNumber<h.lineNumber?!1:h.column<=R.column}static compare(h,R){const A=h.lineNumber|0,g=R.lineNumber|0;if(A===g){const E=h.column|0,$=R.column|0;return E-$}return A-g}clone(){return new D(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(h){return new D(h.lineNumber,h.column)}static isIPosition(h){return h&&typeof h.lineNumber=="number"&&typeof h.column=="number"}}e.$gs=D}),define(De[34],Ce([1,0,58]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hs=void 0;class M{constructor(R,A,g,E){R>g||R===g&&A>E?(this.startLineNumber=g,this.startColumn=E,this.endLineNumber=R,this.endColumn=A):(this.startLineNumber=R,this.startColumn=A,this.endLineNumber=g,this.endColumn=E)}isEmpty(){return M.isEmpty(this)}static isEmpty(R){return R.startLineNumber===R.endLineNumber&&R.startColumn===R.endColumn}containsPosition(R){return M.containsPosition(this,R)}static containsPosition(R,A){return!(A.lineNumber<R.startLineNumber||A.lineNumber>R.endLineNumber||A.lineNumber===R.startLineNumber&&A.column<R.startColumn||A.lineNumber===R.endLineNumber&&A.column>R.endColumn)}static strictContainsPosition(R,A){return!(A.lineNumber<R.startLineNumber||A.lineNumber>R.endLineNumber||A.lineNumber===R.startLineNumber&&A.column<=R.startColumn||A.lineNumber===R.endLineNumber&&A.column>=R.endColumn)}containsRange(R){return M.containsRange(this,R)}static containsRange(R,A){return!(A.startLineNumber<R.startLineNumber||A.endLineNumber<R.startLineNumber||A.startLineNumber>R.endLineNumber||A.endLineNumber>R.endLineNumber||A.startLineNumber===R.startLineNumber&&A.startColumn<R.startColumn||A.endLineNumber===R.endLineNumber&&A.endColumn>R.endColumn)}strictContainsRange(R){return M.strictContainsRange(this,R)}static strictContainsRange(R,A){return!(A.startLineNumber<R.startLineNumber||A.endLineNumber<R.startLineNumber||A.startLineNumber>R.endLineNumber||A.endLineNumber>R.endLineNumber||A.startLineNumber===R.startLineNumber&&A.startColumn<=R.startColumn||A.endLineNumber===R.endLineNumber&&A.endColumn>=R.endColumn)}plusRange(R){return M.plusRange(this,R)}static plusRange(R,A){let g,E,$,P;return A.startLineNumber<R.startLineNumber?(g=A.startLineNumber,E=A.startColumn):A.startLineNumber===R.startLineNumber?(g=A.startLineNumber,E=Math.min(A.startColumn,R.startColumn)):(g=R.startLineNumber,E=R.startColumn),A.endLineNumber>R.endLineNumber?($=A.endLineNumber,P=A.endColumn):A.endLineNumber===R.endLineNumber?($=A.endLineNumber,P=Math.max(A.endColumn,R.endColumn)):($=R.endLineNumber,P=R.endColumn),new M(g,E,$,P)}intersectRanges(R){return M.intersectRanges(this,R)}static intersectRanges(R,A){let g=R.startLineNumber,E=R.startColumn,$=R.endLineNumber,P=R.endColumn;const I=A.startLineNumber,b=A.startColumn,S=A.endLineNumber,C=A.endColumn;return g<I?(g=I,E=b):g===I&&(E=Math.max(E,b)),$>S?($=S,P=C):$===S&&(P=Math.min(P,C)),g>$||g===$&&E>P?null:new M(g,E,$,P)}equalsRange(R){return M.equalsRange(this,R)}static equalsRange(R,A){return!R&&!A?!0:!!R&&!!A&&R.startLineNumber===A.startLineNumber&&R.startColumn===A.startColumn&&R.endLineNumber===A.endLineNumber&&R.endColumn===A.endColumn}getEndPosition(){return M.getEndPosition(this)}static getEndPosition(R){return new D.$gs(R.endLineNumber,R.endColumn)}getStartPosition(){return M.getStartPosition(this)}static getStartPosition(R){return new D.$gs(R.startLineNumber,R.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(R,A){return new M(this.startLineNumber,this.startColumn,R,A)}setStartPosition(R,A){return new M(R,A,this.endLineNumber,this.endColumn)}collapseToStart(){return M.collapseToStart(this)}static collapseToStart(R){return new M(R.startLineNumber,R.startColumn,R.startLineNumber,R.startColumn)}collapseToEnd(){return M.collapseToEnd(this)}static collapseToEnd(R){return new M(R.endLineNumber,R.endColumn,R.endLineNumber,R.endColumn)}delta(R){return new M(this.startLineNumber+R,this.startColumn,this.endLineNumber+R,this.endColumn)}static fromPositions(R,A=R){return new M(R.lineNumber,R.column,A.lineNumber,A.column)}static lift(R){return R?new M(R.startLineNumber,R.startColumn,R.endLineNumber,R.endColumn):null}static isIRange(R){return R&&typeof R.startLineNumber=="number"&&typeof R.startColumn=="number"&&typeof R.endLineNumber=="number"&&typeof R.endColumn=="number"}static areIntersectingOrTouching(R,A){return!(R.endLineNumber<A.startLineNumber||R.endLineNumber===A.startLineNumber&&R.endColumn<A.startColumn||A.endLineNumber<R.startLineNumber||A.endLineNumber===R.startLineNumber&&A.endColumn<R.startColumn)}static areIntersecting(R,A){return!(R.endLineNumber<A.startLineNumber||R.endLineNumber===A.startLineNumber&&R.endColumn<=A.startColumn||A.endLineNumber<R.startLineNumber||A.endLineNumber===R.startLineNumber&&A.endColumn<=R.startColumn)}static compareRangesUsingStarts(R,A){if(R&&A){const $=R.startLineNumber|0,P=A.startLineNumber|0;if($===P){const I=R.startColumn|0,b=A.startColumn|0;if(I===b){const S=R.endLineNumber|0,C=A.endLineNumber|0;if(S===C){const y=R.endColumn|0,r=A.endColumn|0;return y-r}return S-C}return I-b}return $-P}return(R?1:0)-(A?1:0)}static compareRangesUsingEnds(R,A){return R.endLineNumber===A.endLineNumber?R.endColumn===A.endColumn?R.startLineNumber===A.startLineNumber?R.startColumn-A.startColumn:R.startLineNumber-A.startLineNumber:R.endColumn-A.endColumn:R.endLineNumber-A.endLineNumber}static spansMultipleLines(R){return R.endLineNumber>R.startLineNumber}toJSON(){return this}}e.$hs=M}),define(De[162],Ce([1,0,34]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$is=void 0;class M{static insert(R,A){return{range:new D.$hs(R.lineNumber,R.column,R.lineNumber,R.column),text:A,forceMoveMarkers:!0}}static delete(R){return{range:R,text:null}}static replace(R,A){return{range:R,text:A}}static replaceMove(R,A){return{range:R,text:A,forceMoveMarkers:!0}}}e.$is=M}),define(De[163],Ce([1,0,58,34]),function($e,e,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$js=e.SelectionDirection=void 0;var h;(function(A){A[A.LTR=0]="LTR",A[A.RTL=1]="RTL"})(h||(e.SelectionDirection=h={}));class R extends M.$hs{constructor(g,E,$,P){super(g,E,$,P),this.selectionStartLineNumber=g,this.selectionStartColumn=E,this.positionLineNumber=$,this.positionColumn=P}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(g){return R.selectionsEqual(this,g)}static selectionsEqual(g,E){return g.selectionStartLineNumber===E.selectionStartLineNumber&&g.selectionStartColumn===E.selectionStartColumn&&g.positionLineNumber===E.positionLineNumber&&g.positionColumn===E.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(g,E){return this.getDirection()===0?new R(this.startLineNumber,this.startColumn,g,E):new R(g,E,this.startLineNumber,this.startColumn)}getPosition(){return new D.$gs(this.positionLineNumber,this.positionColumn)}getSelectionStart(){return new D.$gs(this.selectionStartLineNumber,this.selectionStartColumn)}setStartPosition(g,E){return this.getDirection()===0?new R(g,E,this.endLineNumber,this.endColumn):new R(this.endLineNumber,this.endColumn,g,E)}static fromPositions(g,E=g){return new R(g.lineNumber,g.column,E.lineNumber,E.column)}static fromRange(g,E){return E===0?new R(g.startLineNumber,g.startColumn,g.endLineNumber,g.endColumn):new R(g.endLineNumber,g.endColumn,g.startLineNumber,g.startColumn)}static liftSelection(g){return new R(g.selectionStartLineNumber,g.selectionStartColumn,g.positionLineNumber,g.positionColumn)}static selectionsArrEqual(g,E){if(g&&!E||!g&&E)return!1;if(!g&&!E)return!0;if(g.length!==E.length)return!1;for(let $=0,P=g.length;$<P;$++)if(!this.selectionsEqual(g[$],E[$]))return!1;return!0}static isISelection(g){return g&&typeof g.selectionStartLineNumber=="number"&&typeof g.selectionStartColumn=="number"&&typeof g.positionLineNumber=="number"&&typeof g.positionColumn=="number"}static createWithDirection(g,E,$,P,I){return I===0?new R(g,E,$,P):new R($,P,g,E)}}e.$js=R}),define(De[164],Ce([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rr=void 0,e.$Rr={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!0,independentColorPoolPerBracketType:!1}}}),define(De[165],Ce([1,0,122]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hs=e.$Gs=e.WordCharacterClass=void 0;var M;(function(A){A[A.Regular=0]="Regular",A[A.Whitespace=1]="Whitespace",A[A.WordSeparator=2]="WordSeparator"})(M||(e.WordCharacterClass=M={}));class h extends D.$Es{constructor(g){super(0);for(let E=0,$=g.length;E<$;E++)this.set(g.charCodeAt(E),2);this.set(32,1),this.set(9,1)}}e.$Gs=h;function R(A){const g={};return E=>(g.hasOwnProperty(E)||(g[E]=A(E)),g[E])}e.$Hs=R(A=>new h(A))}),define(De[123],Ce([1,0,48,3,72]),function($e,e,D,M,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wr=e.$Vr=e.$Ur=e.$Tr=e.$Sr=void 0,e.$Sr="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function R(I=""){let b="(-?\\d*\\.\\d\\w*)|([^";for(const S of e.$Sr)I.indexOf(S)>=0||(b+="\\"+S);return b+="\\s]+)",new RegExp(b,"g")}e.$Tr=R();function A(I){let b=e.$Tr;if(I&&I instanceof RegExp)if(I.global)b=I;else{let S="g";I.ignoreCase&&(S+="i"),I.multiline&&(S+="m"),I.unicode&&(S+="u"),b=new RegExp(I.source,S)}return b.lastIndex=0,b}e.$Ur=A;const g=new h.$vb;g.unshift({maxLen:1e3,windowSize:15,timeBudget:150});function E(I){const b=g.unshift(I);return(0,M.$kb)(b)}e.$Vr=E;function $(I,b,S,C,y){if(y||(y=D.Iterable.first(g)),S.length>y.maxLen){let p=I-y.maxLen/2;return p<0?p=0:C+=p,S=S.substring(p,I+y.maxLen/2),$(I,b,S,C,y)}const r=Date.now(),i=I-1-C;let a=-1,m=null;for(let p=1;!(Date.now()-r>=y.timeBudget);p++){const f=i-y.windowSize*p;b.lastIndex=Math.max(0,f);const t=P(b,S,i,a);if(!t&&m||(m=t,f<=0))break;a=f}if(m){const p={word:m[0],startColumn:C+1+m.index,endColumn:C+1+m.index+m[0].length};return b.lastIndex=0,p}return null}e.$Wr=$;function P(I,b,S,C){let y;for(;y=I.exec(b);){const r=y.index||0;if(r<=S&&I.lastIndex>=S)return y;if(C>0&&r>C)return null}return null}}),define(De[166],Ce([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$et=e.$dt=e.IndentAction=void 0;var D;(function(A){A[A.None=0]="None",A[A.Indent=1]="Indent",A[A.IndentOutdent=2]="IndentOutdent",A[A.Outdent=3]="Outdent"})(D||(e.IndentAction=D={}));class M{constructor(g){if(this.e=null,this.f=!1,this.open=g.open,this.close=g.close,this.b=!0,this.c=!0,this.d=!0,Array.isArray(g.notIn))for(let E=0,$=g.notIn.length;E<$;E++)switch(g.notIn[E]){case"string":this.b=!1;break;case"comment":this.c=!1;break;case"regex":this.d=!1;break}}isOK(g){switch(g){case 0:return!0;case 1:return this.c;case 2:return this.b;case 3:return this.d}}shouldAutoClose(g,E){if(g.getTokenCount()===0)return!0;const $=g.findTokenIndexAtOffset(E-2),P=g.getStandardTokenType($);return this.isOK(P)}g(g,E){for(let $=g;$<=E;$++){const P=String.fromCharCode($);if(!this.open.includes(P)&&!this.close.includes(P))return P}return null}findNeutralCharacter(){return this.f||(this.f=!0,this.e||(this.e=this.g(48,57)),this.e||(this.e=this.g(97,122)),this.e||(this.e=this.g(65,90))),this.e}}e.$dt=M;class h{constructor(g){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const E of g)R(this.autoClosingPairsOpenByStart,E.open.charAt(0),E),R(this.autoClosingPairsOpenByEnd,E.open.charAt(E.open.length-1),E),R(this.autoClosingPairsCloseByStart,E.close.charAt(0),E),R(this.autoClosingPairsCloseByEnd,E.close.charAt(E.close.length-1),E),E.close.length===1&&E.open.length===1&&R(this.autoClosingPairsCloseSingleChar,E.close,E)}}e.$et=h;function R(A,g,E){A.has(g)?A.get(g).push(E):A.set(g,[E])}}),define(De[167],Ce([1,0,122]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oY=e.$nY=e.$mY=e.State=void 0;var M;(function(S){S[S.Invalid=0]="Invalid",S[S.Start=1]="Start",S[S.H=2]="H",S[S.HT=3]="HT",S[S.HTT=4]="HTT",S[S.HTTP=5]="HTTP",S[S.F=6]="F",S[S.FI=7]="FI",S[S.FIL=8]="FIL",S[S.BeforeColon=9]="BeforeColon",S[S.AfterColon=10]="AfterColon",S[S.AlmostThere=11]="AlmostThere",S[S.End=12]="End",S[S.Accept=13]="Accept",S[S.LastKnownState=14]="LastKnownState"})(M||(e.State=M={}));class h{constructor(C,y,r){const i=new Uint8Array(C*y);for(let a=0,m=C*y;a<m;a++)i[a]=r;this.a=i,this.rows=C,this.cols=y}get(C,y){return this.a[C*this.cols+y]}set(C,y,r){this.a[C*this.cols+y]=r}}class R{constructor(C){let y=0,r=0;for(let a=0,m=C.length;a<m;a++){const[p,f,t]=C[a];f>y&&(y=f),p>r&&(r=p),t>r&&(r=t)}y++,r++;const i=new h(r,y,0);for(let a=0,m=C.length;a<m;a++){const[p,f,t]=C[a];i.set(p,f,t)}this.a=i,this.b=y}nextState(C,y){return y<0||y>=this.b?0:this.a.get(C,y)}}e.$mY=R;let A=null;function g(){return A===null&&(A=new R([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),A}var E;(function(S){S[S.None=0]="None",S[S.ForceTermination=1]="ForceTermination",S[S.CannotEndIn=2]="CannotEndIn"})(E||(E={}));let $=null;function P(){if($===null){$=new D.$Es(0);const S=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u3008\u300C\u300E\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u300F\u300D\u3009\u2019\uFF40\uFF5E\u2026`;for(let y=0;y<S.length;y++)$.set(S.charCodeAt(y),1);const C=".,;:";for(let y=0;y<C.length;y++)$.set(C.charCodeAt(y),2)}return $}class I{static a(C,y,r,i,a){let m=a-1;do{const p=y.charCodeAt(m);if(C.get(p)!==2)break;m--}while(m>i);if(i>0){const p=y.charCodeAt(i-1),f=y.charCodeAt(m);(p===40&&f===41||p===91&&f===93||p===123&&f===125)&&m--}return{range:{startLineNumber:r,startColumn:i+1,endLineNumber:r,endColumn:m+2},url:y.substring(i,m+1)}}static computeLinks(C,y=g()){const r=P(),i=[];for(let a=1,m=C.getLineCount();a<=m;a++){const p=C.getLineContent(a),f=p.length;let t=0,s=0,o=0,n=1,c=!1,d=!1,v=!1,k=!1;for(;t<f;){let u=!1;const l=p.charCodeAt(t);if(n===13){let w;switch(l){case 40:c=!0,w=0;break;case 41:w=c?0:1;break;case 91:v=!0,d=!0,w=0;break;case 93:v=!1,w=d?0:1;break;case 123:k=!0,w=0;break;case 125:w=k?0:1;break;case 39:case 34:case 96:o===l?w=1:o===39||o===34||o===96?w=0:w=1;break;case 42:w=o===42?1:0;break;case 124:w=o===124?1:0;break;case 32:w=v?0:1;break;default:w=r.get(l)}w===1&&(i.push(I.a(r,p,a,s,t)),u=!0)}else if(n===12){let w;l===91?(d=!0,w=0):w=r.get(l),w===1?u=!0:n=13}else n=y.nextState(n,l),n===0&&(u=!0);u&&(n=1,c=!1,d=!1,k=!1,s=t+1,o=l),t++}n===13&&i.push(I.a(r,p,a,s,f))}return i}}e.$nY=I;function b(S){return!S||typeof S.getLineCount!="function"||typeof S.getLineContent!="function"?[]:I.computeLinks(S)}e.$oY=b}),define(De[124],Ce([1,0,23]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Du=e.$Cu=e.$Bu=e.$Au=e.ModelConstants=e.PositionAffinity=e.$zu=e.TrackedRangeStickiness=e.$yu=e.$xu=e.EndOfLineSequence=e.DefaultEndOfLine=e.EndOfLinePreference=e.InjectedTextCursorStops=e.MinimapPosition=e.GlyphMarginLane=e.OverviewRulerLane=void 0;var M;(function(p){p[p.Left=1]="Left",p[p.Center=2]="Center",p[p.Right=4]="Right",p[p.Full=7]="Full"})(M||(e.OverviewRulerLane=M={}));var h;(function(p){p[p.Left=1]="Left",p[p.Right=2]="Right"})(h||(e.GlyphMarginLane=h={}));var R;(function(p){p[p.Inline=1]="Inline",p[p.Gutter=2]="Gutter"})(R||(e.MinimapPosition=R={}));var A;(function(p){p[p.Both=0]="Both",p[p.Right=1]="Right",p[p.Left=2]="Left",p[p.None=3]="None"})(A||(e.InjectedTextCursorStops=A={}));var g;(function(p){p[p.TextDefined=0]="TextDefined",p[p.LF=1]="LF",p[p.CRLF=2]="CRLF"})(g||(e.EndOfLinePreference=g={}));var E;(function(p){p[p.LF=1]="LF",p[p.CRLF=2]="CRLF"})(E||(e.DefaultEndOfLine=E={}));var $;(function(p){p[p.LF=0]="LF",p[p.CRLF=1]="CRLF"})($||(e.EndOfLineSequence=$={}));class P{get originalIndentSize(){return this.a?"tabSize":this.indentSize}constructor(f){this._textModelResolvedOptionsBrand=void 0,this.tabSize=Math.max(1,f.tabSize|0),f.indentSize==="tabSize"?(this.indentSize=this.tabSize,this.a=!0):(this.indentSize=Math.max(1,f.indentSize|0),this.a=!1),this.insertSpaces=!!f.insertSpaces,this.defaultEOL=f.defaultEOL|0,this.trimAutoWhitespace=!!f.trimAutoWhitespace,this.bracketPairColorizationOptions=f.bracketPairColorizationOptions}equals(f){return this.tabSize===f.tabSize&&this.a===f.a&&this.indentSize===f.indentSize&&this.insertSpaces===f.insertSpaces&&this.defaultEOL===f.defaultEOL&&this.trimAutoWhitespace===f.trimAutoWhitespace&&(0,D.$Xm)(this.bracketPairColorizationOptions,f.bracketPairColorizationOptions)}createChangeEvent(f){return{tabSize:this.tabSize!==f.tabSize,indentSize:this.indentSize!==f.indentSize,insertSpaces:this.insertSpaces!==f.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==f.trimAutoWhitespace}}}e.$xu=P;class I{constructor(f,t){this._findMatchBrand=void 0,this.range=f,this.matches=t}}e.$yu=I;var b;(function(p){p[p.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",p[p.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",p[p.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",p[p.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(b||(e.TrackedRangeStickiness=b={}));function S(p){return p&&typeof p.read=="function"}e.$zu=S;var C;(function(p){p[p.Left=0]="Left",p[p.Right=1]="Right",p[p.None=2]="None",p[p.LeftOfInjectedText=3]="LeftOfInjectedText",p[p.RightOfInjectedText=4]="RightOfInjectedText"})(C||(e.PositionAffinity=C={}));var y;(function(p){p[p.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(y||(e.ModelConstants=y={}));class r{constructor(f,t,s,o,n,c){this.identifier=f,this.range=t,this.text=s,this.forceMoveMarkers=o,this.isAutoWhitespaceEdit=n,this._isTracked=c}}e.$Au=r;class i{constructor(f,t,s){this.regex=f,this.wordSeparators=t,this.simpleSearch=s}}e.$Bu=i;class a{constructor(f,t,s){this.reverseEdits=f,this.changes=t,this.trimAutoWhitespaceLineNumbers=s}}e.$Cu=a;function m(p){return!p.isTooLargeForSyncing()&&!p.isForSimpleWidget}e.$Du=m}),define(De[168],Ce([1,0,19,121]),function($e,e,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Iu=e.$Hu=e.$Gu=void 0;class h{constructor(E){this.a=E,this.b=new Uint32Array(E.length),this.c=new Int32Array(1),this.c[0]=-1}getCount(){return this.a.length}insertValues(E,$){E=(0,M.$nd)(E);const P=this.a,I=this.b,b=$.length;return b===0?!1:(this.a=new Uint32Array(P.length+b),this.a.set(P.subarray(0,E),0),this.a.set(P.subarray(E),E+b),this.a.set($,E),E-1<this.c[0]&&(this.c[0]=E-1),this.b=new Uint32Array(this.a.length),this.c[0]>=0&&this.b.set(I.subarray(0,this.c[0]+1)),!0)}setValue(E,$){return E=(0,M.$nd)(E),$=(0,M.$nd)($),this.a[E]===$?!1:(this.a[E]=$,E-1<this.c[0]&&(this.c[0]=E-1),!0)}removeValues(E,$){E=(0,M.$nd)(E),$=(0,M.$nd)($);const P=this.a,I=this.b;if(E>=P.length)return!1;const b=P.length-E;return $>=b&&($=b),$===0?!1:(this.a=new Uint32Array(P.length-$),this.a.set(P.subarray(0,E),0),this.a.set(P.subarray(E+$),E),this.b=new Uint32Array(this.a.length),E-1<this.c[0]&&(this.c[0]=E-1),this.c[0]>=0&&this.b.set(I.subarray(0,this.c[0]+1)),!0)}getTotalSum(){return this.a.length===0?0:this.d(this.a.length-1)}getPrefixSum(E){return E<0?0:(E=(0,M.$nd)(E),this.d(E))}d(E){if(E<=this.c[0])return this.b[E];let $=this.c[0]+1;$===0&&(this.b[0]=this.a[0],$++),E>=this.a.length&&(E=this.a.length-1);for(let P=$;P<=E;P++)this.b[P]=this.b[P-1]+this.a[P];return this.c[0]=Math.max(this.c[0],E),this.b[E]}getIndexOf(E){E=Math.floor(E),this.getTotalSum();let $=0,P=this.a.length-1,I=0,b=0,S=0;for(;$<=P;)if(I=$+(P-$)/2|0,b=this.b[I],S=b-this.a[I],E<S)P=I-1;else if(E>=b)$=I+1;else break;return new A(I,E-S)}}e.$Gu=h;class R{constructor(E){this.a=E,this.b=!1,this.c=-1,this.d=[],this.e=[]}getTotalSum(){return this.g(),this.e.length}getPrefixSum(E){return this.g(),E===0?0:this.d[E-1]}getIndexOf(E){this.g();const $=this.e[E],P=$>0?this.d[$-1]:0;return new A($,E-P)}removeValues(E,$){this.a.splice(E,$),this.f(E)}insertValues(E,$){this.a=(0,D.$Pf)(this.a,E,$),this.f(E)}f(E){this.b=!1,this.c=Math.min(this.c,E-1)}g(){if(!this.b){for(let E=this.c+1,$=this.a.length;E<$;E++){const P=this.a[E],I=E>0?this.d[E-1]:0;this.d[E]=I+P;for(let b=0;b<P;b++)this.e[I+b]=E}this.d.length=this.a.length,this.e.length=this.d[this.d.length-1],this.b=!0,this.c=this.a.length-1}}setValue(E,$){this.a[E]!==$&&(this.a[E]=$,this.f(E))}}e.$Hu=R;class A{constructor(E,$){this.index=E,this.remainder=$,this._prefixSumIndexOfResultBrand=void 0,this.index=E,this.remainder=$}}e.$Iu=A}),define(De[169],Ce([1,0,15,58,168]),function($e,e,D,M,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ju=void 0;class R{constructor(g,E,$,P){this.d=g,this.f=E,this.g=$,this.h=P,this.j=null,this.k=null}dispose(){this.f.length=0}get version(){return this.h}getText(){return this.k===null&&(this.k=this.f.join(this.g)),this.k}onEvents(g){g.eol&&g.eol!==this.g&&(this.g=g.eol,this.j=null);const E=g.changes;for(const $ of E)this.o($.range),this.p(new M.$gs($.range.startLineNumber,$.range.startColumn),$.text);this.h=g.versionId,this.k=null}l(){if(!this.j){const g=this.g.length,E=this.f.length,$=new Uint32Array(E);for(let P=0;P<E;P++)$[P]=this.f[P].length+g;this.j=new h.$Gu($)}}n(g,E){this.f[g]=E,this.j&&this.j.setValue(g,this.f[g].length+this.g.length)}o(g){if(g.startLineNumber===g.endLineNumber){if(g.startColumn===g.endColumn)return;this.n(g.startLineNumber-1,this.f[g.startLineNumber-1].substring(0,g.startColumn-1)+this.f[g.startLineNumber-1].substring(g.endColumn-1));return}this.n(g.startLineNumber-1,this.f[g.startLineNumber-1].substring(0,g.startColumn-1)+this.f[g.endLineNumber-1].substring(g.endColumn-1)),this.f.splice(g.startLineNumber,g.endLineNumber-g.startLineNumber),this.j&&this.j.removeValues(g.startLineNumber,g.endLineNumber-g.startLineNumber)}p(g,E){if(E.length===0)return;const $=(0,D.$Cd)(E);if($.length===1){this.n(g.lineNumber-1,this.f[g.lineNumber-1].substring(0,g.column-1)+$[0]+this.f[g.lineNumber-1].substring(g.column-1));return}$[$.length-1]+=this.f[g.lineNumber-1].substring(g.column-1),this.n(g.lineNumber-1,this.f[g.lineNumber-1].substring(0,g.column-1)+$[0]);const P=new Uint32Array($.length-1);for(let I=1;I<$.length;I++)this.f.splice(g.lineNumber+I-1,0,$[I]),P[I-1]=$[I].length+this.g.length;this.j&&this.j.insertValues(g.lineNumber,P)}}e.$Ju=R}),define(De[170],Ce([1,0,15,165,58,34,124]),function($e,e,D,M,h,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iC=e.$hC=e.$gC=e.$fC=e.$eC=e.$dC=void 0;const g=999;class E{constructor(a,m,p,f){this.searchString=a,this.isRegex=m,this.matchCase=p,this.wordSeparators=f}parseSearchRequest(){if(this.searchString==="")return null;let a;this.isRegex?a=$(this.searchString):a=this.searchString.indexOf(`
`)>=0;let m=null;try{m=D.$Ad(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:a,global:!0,unicode:!0})}catch{return null}if(!m)return null;let p=!this.isRegex&&!a;return p&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(p=this.matchCase),new A.$Bu(m,this.wordSeparators?(0,M.$Hs)(this.wordSeparators):null,p?this.searchString:null)}}e.$dC=E;function $(i){if(!i||i.length===0)return!1;for(let a=0,m=i.length;a<m;a++){const p=i.charCodeAt(a);if(p===10)return!0;if(p===92){if(a++,a>=m)break;const f=i.charCodeAt(a);if(f===110||f===114||f===87)return!0}}return!1}e.$eC=$;function P(i,a,m){if(!m)return new A.$yu(i,null);const p=[];for(let f=0,t=a.length;f<t;f++)p[f]=a[f];return new A.$yu(i,p)}e.$fC=P;class I{constructor(a){const m=[];let p=0;for(let f=0,t=a.length;f<t;f++)a.charCodeAt(f)===10&&(m[p++]=f);this.a=m}findLineFeedCountBeforeOffset(a){const m=this.a;let p=0,f=m.length-1;if(f===-1||a<=m[0])return 0;for(;p<f;){const t=p+((f-p)/2>>0);m[t]>=a?f=t-1:m[t+1]>=a?(p=t,f=t):p=t+1}return p+1}}class b{static findMatches(a,m,p,f,t){const s=m.parseSearchRequest();return s?s.regex.multiline?this.b(a,p,new r(s.wordSeparators,s.regex),f,t):this.c(a,p,s,f,t):[]}static a(a,m,p,f,t,s){let o,n=0;f?(n=f.findLineFeedCountBeforeOffset(t),o=m+t+n):o=m+t;let c;if(f){const u=f.findLineFeedCountBeforeOffset(t+s.length)-n;c=o+s.length+u}else c=o+s.length;const d=a.getPositionAt(o),v=a.getPositionAt(c);return new R.$hs(d.lineNumber,d.column,v.lineNumber,v.column)}static b(a,m,p,f,t){const s=a.getOffsetAt(m.getStartPosition()),o=a.getValueInRange(m,1),n=a.getEOL()===`\r
`?new I(o):null,c=[];let d=0,v;for(p.reset(0);v=p.next(o);)if(c[d++]=P(this.a(a,s,o,n,v.index,v[0]),v,f),d>=t)return c;return c}static c(a,m,p,f,t){const s=[];let o=0;if(m.startLineNumber===m.endLineNumber){const c=a.getLineContent(m.startLineNumber).substring(m.startColumn-1,m.endColumn-1);return o=this.d(p,c,m.startLineNumber,m.startColumn-1,o,s,f,t),s}const n=a.getLineContent(m.startLineNumber).substring(m.startColumn-1);o=this.d(p,n,m.startLineNumber,m.startColumn-1,o,s,f,t);for(let c=m.startLineNumber+1;c<m.endLineNumber&&o<t;c++)o=this.d(p,a.getLineContent(c),c,0,o,s,f,t);if(o<t){const c=a.getLineContent(m.endLineNumber).substring(0,m.endColumn-1);o=this.d(p,c,m.endLineNumber,0,o,s,f,t)}return s}static d(a,m,p,f,t,s,o,n){const c=a.wordSeparators;if(!o&&a.simpleSearch){const k=a.simpleSearch,u=k.length,l=m.length;let w=-u;for(;(w=m.indexOf(k,w+u))!==-1;)if((!c||y(c,m,l,w,u))&&(s[t++]=new A.$yu(new R.$hs(p,w+1+f,p,w+1+u+f),null),t>=n))return t;return t}const d=new r(a.wordSeparators,a.regex);let v;d.reset(0);do if(v=d.next(m),v&&(s[t++]=P(new R.$hs(p,v.index+1+f,p,v.index+1+v[0].length+f),v,o),t>=n))return t;while(v);return t}static findNextMatch(a,m,p,f){const t=m.parseSearchRequest();if(!t)return null;const s=new r(t.wordSeparators,t.regex);return t.regex.multiline?this.e(a,p,s,f):this.f(a,p,s,f)}static e(a,m,p,f){const t=new h.$gs(m.lineNumber,1),s=a.getOffsetAt(t),o=a.getLineCount(),n=a.getValueInRange(new R.$hs(t.lineNumber,t.column,o,a.getLineMaxColumn(o)),1),c=a.getEOL()===`\r
`?new I(n):null;p.reset(m.column-1);const d=p.next(n);return d?P(this.a(a,s,n,c,d.index,d[0]),d,f):m.lineNumber!==1||m.column!==1?this.e(a,new h.$gs(1,1),p,f):null}static f(a,m,p,f){const t=a.getLineCount(),s=m.lineNumber,o=a.getLineContent(s),n=this.g(p,o,s,m.column,f);if(n)return n;for(let c=1;c<=t;c++){const d=(s+c-1)%t,v=a.getLineContent(d+1),k=this.g(p,v,d+1,1,f);if(k)return k}return null}static g(a,m,p,f,t){a.reset(f-1);const s=a.next(m);return s?P(new R.$hs(p,s.index+1,p,s.index+1+s[0].length),s,t):null}static findPreviousMatch(a,m,p,f){const t=m.parseSearchRequest();if(!t)return null;const s=new r(t.wordSeparators,t.regex);return t.regex.multiline?this.h(a,p,s,f):this.j(a,p,s,f)}static h(a,m,p,f){const t=this.b(a,new R.$hs(1,1,m.lineNumber,m.column),p,f,10*g);if(t.length>0)return t[t.length-1];const s=a.getLineCount();return m.lineNumber!==s||m.column!==a.getLineMaxColumn(s)?this.h(a,new h.$gs(s,a.getLineMaxColumn(s)),p,f):null}static j(a,m,p,f){const t=a.getLineCount(),s=m.lineNumber,o=a.getLineContent(s).substring(0,m.column-1),n=this.k(p,o,s,f);if(n)return n;for(let c=1;c<=t;c++){const d=(t+s-c-1)%t,v=a.getLineContent(d+1),k=this.k(p,v,d+1,f);if(k)return k}return null}static k(a,m,p,f){let t=null,s;for(a.reset(0);s=a.next(m);)t=P(new R.$hs(p,s.index+1,p,s.index+1+s[0].length),s,f);return t}}e.$gC=b;function S(i,a,m,p,f){if(p===0)return!0;const t=a.charCodeAt(p-1);if(i.get(t)!==0||t===13||t===10)return!0;if(f>0){const s=a.charCodeAt(p);if(i.get(s)!==0)return!0}return!1}function C(i,a,m,p,f){if(p+f===m)return!0;const t=a.charCodeAt(p+f);if(i.get(t)!==0||t===13||t===10)return!0;if(f>0){const s=a.charCodeAt(p+f-1);if(i.get(s)!==0)return!0}return!1}function y(i,a,m,p,f){return S(i,a,m,p,f)&&C(i,a,m,p,f)}e.$hC=y;class r{constructor(a,m){this._wordSeparators=a,this.a=m,this.b=-1,this.c=0}reset(a){this.a.lastIndex=a,this.b=-1,this.c=0}next(a){const m=a.length;let p;do{if(this.b+this.c===m||(p=this.a.exec(a),!p))return null;const f=p.index,t=p[0].length;if(f===this.b&&t===this.c){if(t===0){D.$Vd(a,m,this.a.lastIndex)>65535?this.a.lastIndex+=2:this.a.lastIndex+=1;continue}return null}if(this.b=f,this.c=t,!this._wordSeparators||y(this._wordSeparators,a,m,f,t))return p}while(p);return null}}e.$iC=r}),define(De[171],Ce([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_6=e.$$6=void 0;class D{constructor(){this.a=new Map}removeDragOperationTransfer(R){if(R&&this.a.has(R)){const A=this.a.get(R);return this.a.delete(R),A}}addDragOperationTransfer(R,A){this.a.set(R,A)}}e.$$6=D;class M{constructor(R){this.identifier=R}}e.$_6=M}),define(De[172],Ce([1,0,4,3]),function($e,e,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ss=void 0;class h{constructor(){this.a=new Map,this.b=new Map,this.c=new D.$hc,this.onDidChange=this.c.event,this.d=null}handleChange(g){this.c.fire({changedLanguages:g,changedColorMap:!1})}register(g,E){return this.a.set(g,E),this.handleChange([g]),(0,M.$kb)(()=>{this.a.get(g)===E&&(this.a.delete(g),this.handleChange([g]))})}get(g){return this.a.get(g)||null}registerFactory(g,E){this.b.get(g)?.dispose();const $=new R(this,g,E);return this.b.set(g,$),(0,M.$kb)(()=>{const P=this.b.get(g);!P||P!==$||(this.b.delete(g),P.dispose())})}async getOrCreate(g){const E=this.get(g);if(E)return E;const $=this.b.get(g);return!$||$.isResolved?null:(await $.resolve(),this.get(g))}isResolved(g){if(this.get(g))return!0;const $=this.b.get(g);return!!(!$||$.isResolved)}setColorMap(g){this.d=g,this.c.fire({changedLanguages:Array.from(this.a.keys()),changedColorMap:!0})}getColorMap(){return this.d}getDefaultBackground(){return this.d&&this.d.length>2?this.d[2]:null}}e.$Ss=h;class R extends M.$mb{get isResolved(){return this.c}constructor(g,E,$){super(),this.f=g,this.g=E,this.h=$,this.a=!1,this.b=null,this.c=!1}dispose(){this.a=!0,super.dispose()}async resolve(){return this.b||(this.b=this.i()),this.b}async i(){const g=await this.h.tokenizationSupport;this.c=!0,g&&!this.a&&this.B(this.f.register(this.g,g))}}}),define(De[173],Ce([11,12]),function($e,e){return $e.create("vs/base/common/actions",e)}),define(De[174],Ce([1,0,4,3,173]),function($e,e,D,M,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ji=e.$ii=e.$hi=e.$gi=e.$fi=e.$ei=void 0;class R extends M.$mb{constructor(b,S="",C="",y=!0,r){super(),this.h=this.B(new D.$hc),this.onDidChange=this.h.event,this.w=!0,this.j=b,this.m=S,this.u=C,this.w=y,this.C=r}get id(){return this.j}get label(){return this.m}set label(b){this.D(b)}D(b){this.m!==b&&(this.m=b,this.h.fire({label:b}))}get tooltip(){return this.n||""}set tooltip(b){this.F(b)}F(b){this.n!==b&&(this.n=b,this.h.fire({tooltip:b}))}get class(){return this.u}set class(b){this.G(b)}G(b){this.u!==b&&(this.u=b,this.h.fire({class:b}))}get enabled(){return this.w}set enabled(b){this.H(b)}H(b){this.w!==b&&(this.w=b,this.h.fire({enabled:b}))}get checked(){return this.z}set checked(b){this.I(b)}I(b){this.z!==b&&(this.z=b,this.h.fire({checked:b}))}async run(b,S){this.C&&await this.C(b)}}e.$ei=R;class A extends M.$mb{constructor(){super(...arguments),this.f=this.B(new D.$hc),this.onWillRun=this.f.event,this.k=this.B(new D.$hc),this.onDidRun=this.k.event}async run(b,S){if(!b.enabled)return;this.f.fire({action:b});let C;try{await this.l(b,S)}catch(y){C=y}this.k.fire({action:b,error:C})}async l(b,S){await b.run(S)}}e.$fi=A;class g{constructor(){this.id=g.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...b){let S=[];for(const C of b)C.length&&(S.length?S=[...S,new g,...C]:S=C);return S}static{this.ID="vs.actions.separator"}async run(){}}e.$gi=g;class E{get actions(){return this.a}constructor(b,S,C,y){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=b,this.label=S,this.class=y,this.a=C}async run(){}}e.$hi=E;class $ extends R{static{this.ID="vs.actions.empty"}constructor(){super($.ID,h.localize(0,null),void 0,!1)}}e.$ii=$;function P(I){return{id:I.id,label:I.label,class:void 0,enabled:I.enabled??!0,checked:I.checked??!1,run:async()=>I.run(),tooltip:I.label}}e.$ji=P}),define(De[175],Ce([11,12]),function($e,e){return $e.create("vs/base/common/date",e)}),define(De[176],Ce([1,0,175]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5l=e.$4l=void 0;const M=60,h=M*60,R=h*24,A=R*7,g=R*30,E=R*365;function $(I,b,S,C){typeof I!="number"&&(I=I.getTime());const y=Math.round((new Date().getTime()-I)/1e3);if(y<-30)return(0,D.localize)(0,null,$(new Date().getTime()+y*1e3,!1));if(!C&&y<30)return(0,D.localize)(1,null);let r;return y<M?(r=y,b?r===1?S?(0,D.localize)(2,null,r):(0,D.localize)(3,null,r):S?(0,D.localize)(4,null,r):(0,D.localize)(5,null,r):r===1?S?(0,D.localize)(6,null,r):(0,D.localize)(7,null,r):S?(0,D.localize)(8,null,r):(0,D.localize)(9,null,r)):y<h?(r=Math.floor(y/M),b?r===1?S?(0,D.localize)(10,null,r):(0,D.localize)(11,null,r):S?(0,D.localize)(12,null,r):(0,D.localize)(13,null,r):r===1?S?(0,D.localize)(14,null,r):(0,D.localize)(15,null,r):S?(0,D.localize)(16,null,r):(0,D.localize)(17,null,r)):y<R?(r=Math.floor(y/h),b?r===1?S?(0,D.localize)(18,null,r):(0,D.localize)(19,null,r):S?(0,D.localize)(20,null,r):(0,D.localize)(21,null,r):r===1?S?(0,D.localize)(22,null,r):(0,D.localize)(23,null,r):S?(0,D.localize)(24,null,r):(0,D.localize)(25,null,r)):y<A?(r=Math.floor(y/R),b?r===1?(0,D.localize)(26,null,r):(0,D.localize)(27,null,r):r===1?(0,D.localize)(28,null,r):(0,D.localize)(29,null,r)):y<g?(r=Math.floor(y/A),b?r===1?S?(0,D.localize)(30,null,r):(0,D.localize)(31,null,r):S?(0,D.localize)(32,null,r):(0,D.localize)(33,null,r):r===1?S?(0,D.localize)(34,null,r):(0,D.localize)(35,null,r):S?(0,D.localize)(36,null,r):(0,D.localize)(37,null,r)):y<E?(r=Math.floor(y/g),b?r===1?S?(0,D.localize)(38,null,r):(0,D.localize)(39,null,r):S?(0,D.localize)(40,null,r):(0,D.localize)(41,null,r):r===1?S?(0,D.localize)(42,null,r):(0,D.localize)(43,null,r):S?(0,D.localize)(44,null,r):(0,D.localize)(45,null,r)):(r=Math.floor(y/E),b?r===1?S?(0,D.localize)(46,null,r):(0,D.localize)(47,null,r):S?(0,D.localize)(48,null,r):(0,D.localize)(49,null,r):r===1?S?(0,D.localize)(50,null,r):(0,D.localize)(51,null,r):S?(0,D.localize)(52,null,r):(0,D.localize)(53,null,r))}e.$4l=$;function P(I){return I.getFullYear()+"-"+String(I.getMonth()+1).padStart(2,"0")+"-"+String(I.getDate()).padStart(2,"0")+"T"+String(I.getHours()).padStart(2,"0")+":"+String(I.getMinutes()).padStart(2,"0")+":"+String(I.getSeconds()).padStart(2,"0")+"."+(I.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.$5l=P}),define(De[177],Ce([11,12]),function($e,e){return $e.create("vs/base/common/errorMessage",e)}),define(De[44],Ce([1,0,19,18,177]),function($e,e,D,M,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mi=e.$li=e.$ki=void 0;function R(I,b){return b&&(I.stack||I.stacktrace)?h.localize(0,null,g(I),A(I.stack)||A(I.stacktrace)):g(I)}function A(I){return Array.isArray(I)?I.join(`
`):I}function g(I){return I.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${I.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof I.code=="string"&&typeof I.errno=="number"&&typeof I.syscall=="string"?h.localize(1,null,I.message):I.message||h.localize(2,null)}function E(I=null,b=!1){if(!I)return h.localize(3,null);if(Array.isArray(I)){const S=D.$Af(I),C=E(S[0],b);return S.length>1?h.localize(4,null,C,S.length):C}if(M.$le(I))return I;if(I.detail){const S=I.detail;if(S.error)return R(S.error,b);if(S.exception)return R(S.exception,b)}return I.stack?R(I,b):I.message?I.message:h.localize(5,null)}e.$ki=E;function $(I){const b=I;return b instanceof Error&&Array.isArray(b.actions)}e.$li=$;function P(I,b){let S;return typeof I=="string"?S=new Error(I):S=I,S.actions=b,S}e.$mi=P}),define(De[178],Ce([11,12]),function($e,e){return $e.create("vs/base/common/platform",e)}),define(De[9],Ce([1,0,178]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$H=e.$G=e.$F=e.$E=e.$D=e.$C=e.OS=e.OperatingSystem=e.$A=e.$z=e.$y=e.$x=e.$w=e.Language=e.$v=e.$u=e.$t=e.$s=e.$r=e.$q=e.$p=e.$o=e.$n=e.$m=e.$l=e.$k=e.$j=e.$i=e.$h=e.Platform=e.$g=e.$f=void 0,e.$f="en";let M=!1,h=!1,R=!1,A=!1,g=!1,E=!1,$=!1,P=!1,I=!1,b=!1,S,C=e.$f,y=e.$f,r,i;e.$g=typeof self=="object"?self:typeof global=="object"?global:{};let a;typeof e.$g.vscode<"u"&&typeof e.$g.vscode.process<"u"?a=e.$g.vscode.process:typeof process<"u"&&(a=process);const m=typeof a?.versions?.electron=="string",p=m&&a?.type==="renderer";if(typeof navigator=="object"&&!p)i=navigator.userAgent,M=i.indexOf("Windows")>=0,h=i.indexOf("Macintosh")>=0,P=(i.indexOf("Macintosh")>=0||i.indexOf("iPad")>=0||i.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,R=i.indexOf("Linux")>=0,b=i?.indexOf("Mobi")>=0,E=!0,S=D.getConfiguredDefaultLocale(D.localize(0,null))||e.$f,C=S,y=navigator.language;else if(typeof a=="object"){M=a.platform==="win32",h=a.platform==="darwin",R=a.platform==="linux",A=R&&!!a.env.SNAP&&!!a.env.SNAP_REVISION,$=m,I=!!a.env.CI||!!a.env.BUILD_ARTIFACTSTAGINGDIRECTORY,S=e.$f,C=e.$f;const k=a.env.VSCODE_NLS_CONFIG;if(k)try{const u=JSON.parse(k),l=u.availableLanguages["*"];S=u.locale,y=u.osLocale,C=l||e.$f,r=u._translationsConfigFile}catch{}g=!0}else console.error("Unable to resolve platform.");var f;(function(k){k[k.Web=0]="Web",k[k.Mac=1]="Mac",k[k.Linux=2]="Linux",k[k.Windows=3]="Windows"})(f||(e.Platform=f={}));function t(k){switch(k){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.$h=t;let s=0;h?s=1:M?s=3:R&&(s=2),e.$i=M,e.$j=h,e.$k=R,e.$l=A,e.$m=g,e.$n=$,e.$o=E,e.$p=E&&typeof e.$g.importScripts=="function",e.$q=P,e.$r=b,e.$s=I,e.$t=s,e.$u=i,e.$v=C;var o;(function(k){function u(){return e.$v}k.value=u;function l(){return e.$v.length===2?e.$v==="en":e.$v.length>=3?e.$v[0]==="e"&&e.$v[1]==="n"&&e.$v[2]==="-":!1}k.isDefaultVariant=l;function w(){return e.$v==="en"}k.isDefault=w})(o||(e.Language=o={})),e.$w=S,e.$x=y,e.$y=r,e.$z=typeof e.$g.postMessage=="function"&&!e.$g.importScripts,e.$A=(()=>{if(e.$z){const k=[];e.$g.addEventListener("message",l=>{if(l.data&&l.data.vscodeScheduleAsyncWork)for(let w=0,L=k.length;w<L;w++){const N=k[w];if(N.id===l.data.vscodeScheduleAsyncWork){k.splice(w,1),N.callback();return}}});let u=0;return l=>{const w=++u;k.push({id:w,callback:l}),e.$g.postMessage({vscodeScheduleAsyncWork:w},"*")}}return k=>setTimeout(k)})();var n;(function(k){k[k.Windows=1]="Windows",k[k.Macintosh=2]="Macintosh",k[k.Linux=3]="Linux"})(n||(e.OperatingSystem=n={})),e.OS=h||P?2:M?1:3;let c=!0,d=!1;function v(){if(!d){d=!0;const k=new Uint8Array(2);k[0]=1,k[1]=2,c=new Uint16Array(k.buffer)[0]===(2<<8)+1}return c}e.$C=v,e.$D=!!(e.$u&&e.$u.indexOf("Chrome")>=0),e.$E=!!(e.$u&&e.$u.indexOf("Firefox")>=0),e.$F=!!(!e.$D&&e.$u&&e.$u.indexOf("Safari")>=0),e.$G=!!(e.$u&&e.$u.indexOf("Edg/")>=0),e.$H=!!(e.$u&&e.$u.indexOf("Android")>=0)}),define(De[45],Ce([1,0,9]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6c=e.$5c=e.env=e.cwd=void 0;let M;if(typeof D.$g.vscode<"u"&&typeof D.$g.vscode.process<"u"){const h=D.$g.vscode.process;M={get platform(){return h.platform},get arch(){return h.arch},get env(){return h.env},cwd(){return h.cwd()}}}else typeof process<"u"?M={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:M={get platform(){return D.$i?"win32":D.$j?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=M.cwd,e.env=M.env,e.$5c=M.platform,e.$6c=M.arch}),define(De[14],Ce([1,0,45]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$id=e.sep=e.$gd=e.$fd=e.$ed=e.$dd=e.$cd=e.$bd=e.$ad=e.$_c=e.$$c=e.$0c=e.$9c=e.$8c=e.$7c=void 0;const M=65,h=97,R=90,A=122,g=46,E=47,$=92,P=58,I=63;class b extends Error{constructor(s,o,n){let c;typeof o=="string"&&o.indexOf("not ")===0?(c="must not be",o=o.replace(/^not /,"")):c="must be";const d=s.indexOf(".")!==-1?"property":"argument";let v=`The "${s}" ${d} ${c} of type ${o}`;v+=`. Received type ${typeof n}`,super(v),this.code="ERR_INVALID_ARG_TYPE"}}function S(t,s){if(t===null||typeof t!="object")throw new b(s,"Object",t)}function C(t,s){if(typeof t!="string")throw new b(s,"string",t)}const y=D.$5c==="win32";function r(t){return t===E||t===$}function i(t){return t===E}function a(t){return t>=M&&t<=R||t>=h&&t<=A}function m(t,s,o,n){let c="",d=0,v=-1,k=0,u=0;for(let l=0;l<=t.length;++l){if(l<t.length)u=t.charCodeAt(l);else{if(n(u))break;u=E}if(n(u)){if(!(v===l-1||k===1))if(k===2){if(c.length<2||d!==2||c.charCodeAt(c.length-1)!==g||c.charCodeAt(c.length-2)!==g){if(c.length>2){const w=c.lastIndexOf(o);w===-1?(c="",d=0):(c=c.slice(0,w),d=c.length-1-c.lastIndexOf(o)),v=l,k=0;continue}else if(c.length!==0){c="",d=0,v=l,k=0;continue}}s&&(c+=c.length>0?`${o}..`:"..",d=2)}else c.length>0?c+=`${o}${t.slice(v+1,l)}`:c=t.slice(v+1,l),d=l-v-1;v=l,k=0}else u===g&&k!==-1?++k:k=-1}return c}function p(t,s){S(s,"pathObject");const o=s.dir||s.root,n=s.base||`${s.name||""}${s.ext||""}`;return o?o===s.root?`${o}${n}`:`${o}${t}${n}`:n}e.$7c={resolve(...t){let s="",o="",n=!1;for(let c=t.length-1;c>=-1;c--){let d;if(c>=0){if(d=t[c],C(d,"path"),d.length===0)continue}else s.length===0?d=D.cwd():(d=D.env[`=${s}`]||D.cwd(),(d===void 0||d.slice(0,2).toLowerCase()!==s.toLowerCase()&&d.charCodeAt(2)===$)&&(d=`${s}\\`));const v=d.length;let k=0,u="",l=!1;const w=d.charCodeAt(0);if(v===1)r(w)&&(k=1,l=!0);else if(r(w))if(l=!0,r(d.charCodeAt(1))){let L=2,N=L;for(;L<v&&!r(d.charCodeAt(L));)L++;if(L<v&&L!==N){const j=d.slice(N,L);for(N=L;L<v&&r(d.charCodeAt(L));)L++;if(L<v&&L!==N){for(N=L;L<v&&!r(d.charCodeAt(L));)L++;(L===v||L!==N)&&(u=`\\\\${j}\\${d.slice(N,L)}`,k=L)}}}else k=1;else a(w)&&d.charCodeAt(1)===P&&(u=d.slice(0,2),k=2,v>2&&r(d.charCodeAt(2))&&(l=!0,k=3));if(u.length>0)if(s.length>0){if(u.toLowerCase()!==s.toLowerCase())continue}else s=u;if(n){if(s.length>0)break}else if(o=`${d.slice(k)}\\${o}`,n=l,l&&s.length>0)break}return o=m(o,!n,"\\",r),n?`${s}\\${o}`:`${s}${o}`||"."},normalize(t){C(t,"path");const s=t.length;if(s===0)return".";let o=0,n,c=!1;const d=t.charCodeAt(0);if(s===1)return i(d)?"\\":t;if(r(d))if(c=!0,r(t.charCodeAt(1))){let k=2,u=k;for(;k<s&&!r(t.charCodeAt(k));)k++;if(k<s&&k!==u){const l=t.slice(u,k);for(u=k;k<s&&r(t.charCodeAt(k));)k++;if(k<s&&k!==u){for(u=k;k<s&&!r(t.charCodeAt(k));)k++;if(k===s)return`\\\\${l}\\${t.slice(u)}\\`;k!==u&&(n=`\\\\${l}\\${t.slice(u,k)}`,o=k)}}}else o=1;else a(d)&&t.charCodeAt(1)===P&&(n=t.slice(0,2),o=2,s>2&&r(t.charCodeAt(2))&&(c=!0,o=3));let v=o<s?m(t.slice(o),!c,"\\",r):"";return v.length===0&&!c&&(v="."),v.length>0&&r(t.charCodeAt(s-1))&&(v+="\\"),n===void 0?c?`\\${v}`:v:c?`${n}\\${v}`:`${n}${v}`},isAbsolute(t){C(t,"path");const s=t.length;if(s===0)return!1;const o=t.charCodeAt(0);return r(o)||s>2&&a(o)&&t.charCodeAt(1)===P&&r(t.charCodeAt(2))},join(...t){if(t.length===0)return".";let s,o;for(let d=0;d<t.length;++d){const v=t[d];C(v,"path"),v.length>0&&(s===void 0?s=o=v:s+=`\\${v}`)}if(s===void 0)return".";let n=!0,c=0;if(typeof o=="string"&&r(o.charCodeAt(0))){++c;const d=o.length;d>1&&r(o.charCodeAt(1))&&(++c,d>2&&(r(o.charCodeAt(2))?++c:n=!1))}if(n){for(;c<s.length&&r(s.charCodeAt(c));)c++;c>=2&&(s=`\\${s.slice(c)}`)}return e.$7c.normalize(s)},relative(t,s){if(C(t,"from"),C(s,"to"),t===s)return"";const o=e.$7c.resolve(t),n=e.$7c.resolve(s);if(o===n||(t=o.toLowerCase(),s=n.toLowerCase(),t===s))return"";let c=0;for(;c<t.length&&t.charCodeAt(c)===$;)c++;let d=t.length;for(;d-1>c&&t.charCodeAt(d-1)===$;)d--;const v=d-c;let k=0;for(;k<s.length&&s.charCodeAt(k)===$;)k++;let u=s.length;for(;u-1>k&&s.charCodeAt(u-1)===$;)u--;const l=u-k,w=v<l?v:l;let L=-1,N=0;for(;N<w;N++){const T=t.charCodeAt(c+N);if(T!==s.charCodeAt(k+N))break;T===$&&(L=N)}if(N!==w){if(L===-1)return n}else{if(l>w){if(s.charCodeAt(k+N)===$)return n.slice(k+N+1);if(N===2)return n.slice(k+N)}v>w&&(t.charCodeAt(c+N)===$?L=N:N===2&&(L=3)),L===-1&&(L=0)}let j="";for(N=c+L+1;N<=d;++N)(N===d||t.charCodeAt(N)===$)&&(j+=j.length===0?"..":"\\..");return k+=L,j.length>0?`${j}${n.slice(k,u)}`:(n.charCodeAt(k)===$&&++k,n.slice(k,u))},toNamespacedPath(t){if(typeof t!="string"||t.length===0)return t;const s=e.$7c.resolve(t);if(s.length<=2)return t;if(s.charCodeAt(0)===$){if(s.charCodeAt(1)===$){const o=s.charCodeAt(2);if(o!==I&&o!==g)return`\\\\?\\UNC\\${s.slice(2)}`}}else if(a(s.charCodeAt(0))&&s.charCodeAt(1)===P&&s.charCodeAt(2)===$)return`\\\\?\\${s}`;return t},dirname(t){C(t,"path");const s=t.length;if(s===0)return".";let o=-1,n=0;const c=t.charCodeAt(0);if(s===1)return r(c)?t:".";if(r(c)){if(o=n=1,r(t.charCodeAt(1))){let k=2,u=k;for(;k<s&&!r(t.charCodeAt(k));)k++;if(k<s&&k!==u){for(u=k;k<s&&r(t.charCodeAt(k));)k++;if(k<s&&k!==u){for(u=k;k<s&&!r(t.charCodeAt(k));)k++;if(k===s)return t;k!==u&&(o=n=k+1)}}}}else a(c)&&t.charCodeAt(1)===P&&(o=s>2&&r(t.charCodeAt(2))?3:2,n=o);let d=-1,v=!0;for(let k=s-1;k>=n;--k)if(r(t.charCodeAt(k))){if(!v){d=k;break}}else v=!1;if(d===-1){if(o===-1)return".";d=o}return t.slice(0,d)},basename(t,s){s!==void 0&&C(s,"ext"),C(t,"path");let o=0,n=-1,c=!0,d;if(t.length>=2&&a(t.charCodeAt(0))&&t.charCodeAt(1)===P&&(o=2),s!==void 0&&s.length>0&&s.length<=t.length){if(s===t)return"";let v=s.length-1,k=-1;for(d=t.length-1;d>=o;--d){const u=t.charCodeAt(d);if(r(u)){if(!c){o=d+1;break}}else k===-1&&(c=!1,k=d+1),v>=0&&(u===s.charCodeAt(v)?--v===-1&&(n=d):(v=-1,n=k))}return o===n?n=k:n===-1&&(n=t.length),t.slice(o,n)}for(d=t.length-1;d>=o;--d)if(r(t.charCodeAt(d))){if(!c){o=d+1;break}}else n===-1&&(c=!1,n=d+1);return n===-1?"":t.slice(o,n)},extname(t){C(t,"path");let s=0,o=-1,n=0,c=-1,d=!0,v=0;t.length>=2&&t.charCodeAt(1)===P&&a(t.charCodeAt(0))&&(s=n=2);for(let k=t.length-1;k>=s;--k){const u=t.charCodeAt(k);if(r(u)){if(!d){n=k+1;break}continue}c===-1&&(d=!1,c=k+1),u===g?o===-1?o=k:v!==1&&(v=1):o!==-1&&(v=-1)}return o===-1||c===-1||v===0||v===1&&o===c-1&&o===n+1?"":t.slice(o,c)},format:p.bind(null,"\\"),parse(t){C(t,"path");const s={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return s;const o=t.length;let n=0,c=t.charCodeAt(0);if(o===1)return r(c)?(s.root=s.dir=t,s):(s.base=s.name=t,s);if(r(c)){if(n=1,r(t.charCodeAt(1))){let L=2,N=L;for(;L<o&&!r(t.charCodeAt(L));)L++;if(L<o&&L!==N){for(N=L;L<o&&r(t.charCodeAt(L));)L++;if(L<o&&L!==N){for(N=L;L<o&&!r(t.charCodeAt(L));)L++;L===o?n=L:L!==N&&(n=L+1)}}}}else if(a(c)&&t.charCodeAt(1)===P){if(o<=2)return s.root=s.dir=t,s;if(n=2,r(t.charCodeAt(2))){if(o===3)return s.root=s.dir=t,s;n=3}}n>0&&(s.root=t.slice(0,n));let d=-1,v=n,k=-1,u=!0,l=t.length-1,w=0;for(;l>=n;--l){if(c=t.charCodeAt(l),r(c)){if(!u){v=l+1;break}continue}k===-1&&(u=!1,k=l+1),c===g?d===-1?d=l:w!==1&&(w=1):d!==-1&&(w=-1)}return k!==-1&&(d===-1||w===0||w===1&&d===k-1&&d===v+1?s.base=s.name=t.slice(v,k):(s.name=t.slice(v,d),s.base=t.slice(v,k),s.ext=t.slice(d,k))),v>0&&v!==n?s.dir=t.slice(0,v-1):s.dir=s.root,s},sep:"\\",delimiter:";",win32:null,posix:null};const f=(()=>{if(y){const t=/\\/g;return()=>{const s=D.cwd().replace(t,"/");return s.slice(s.indexOf("/"))}}return()=>D.cwd()})();e.$8c={resolve(...t){let s="",o=!1;for(let n=t.length-1;n>=-1&&!o;n--){const c=n>=0?t[n]:f();C(c,"path"),c.length!==0&&(s=`${c}/${s}`,o=c.charCodeAt(0)===E)}return s=m(s,!o,"/",i),o?`/${s}`:s.length>0?s:"."},normalize(t){if(C(t,"path"),t.length===0)return".";const s=t.charCodeAt(0)===E,o=t.charCodeAt(t.length-1)===E;return t=m(t,!s,"/",i),t.length===0?s?"/":o?"./":".":(o&&(t+="/"),s?`/${t}`:t)},isAbsolute(t){return C(t,"path"),t.length>0&&t.charCodeAt(0)===E},join(...t){if(t.length===0)return".";let s;for(let o=0;o<t.length;++o){const n=t[o];C(n,"path"),n.length>0&&(s===void 0?s=n:s+=`/${n}`)}return s===void 0?".":e.$8c.normalize(s)},relative(t,s){if(C(t,"from"),C(s,"to"),t===s||(t=e.$8c.resolve(t),s=e.$8c.resolve(s),t===s))return"";const o=1,n=t.length,c=n-o,d=1,v=s.length-d,k=c<v?c:v;let u=-1,l=0;for(;l<k;l++){const L=t.charCodeAt(o+l);if(L!==s.charCodeAt(d+l))break;L===E&&(u=l)}if(l===k)if(v>k){if(s.charCodeAt(d+l)===E)return s.slice(d+l+1);if(l===0)return s.slice(d+l)}else c>k&&(t.charCodeAt(o+l)===E?u=l:l===0&&(u=0));let w="";for(l=o+u+1;l<=n;++l)(l===n||t.charCodeAt(l)===E)&&(w+=w.length===0?"..":"/..");return`${w}${s.slice(d+u)}`},toNamespacedPath(t){return t},dirname(t){if(C(t,"path"),t.length===0)return".";const s=t.charCodeAt(0)===E;let o=-1,n=!0;for(let c=t.length-1;c>=1;--c)if(t.charCodeAt(c)===E){if(!n){o=c;break}}else n=!1;return o===-1?s?"/":".":s&&o===1?"//":t.slice(0,o)},basename(t,s){s!==void 0&&C(s,"ext"),C(t,"path");let o=0,n=-1,c=!0,d;if(s!==void 0&&s.length>0&&s.length<=t.length){if(s===t)return"";let v=s.length-1,k=-1;for(d=t.length-1;d>=0;--d){const u=t.charCodeAt(d);if(u===E){if(!c){o=d+1;break}}else k===-1&&(c=!1,k=d+1),v>=0&&(u===s.charCodeAt(v)?--v===-1&&(n=d):(v=-1,n=k))}return o===n?n=k:n===-1&&(n=t.length),t.slice(o,n)}for(d=t.length-1;d>=0;--d)if(t.charCodeAt(d)===E){if(!c){o=d+1;break}}else n===-1&&(c=!1,n=d+1);return n===-1?"":t.slice(o,n)},extname(t){C(t,"path");let s=-1,o=0,n=-1,c=!0,d=0;for(let v=t.length-1;v>=0;--v){const k=t.charCodeAt(v);if(k===E){if(!c){o=v+1;break}continue}n===-1&&(c=!1,n=v+1),k===g?s===-1?s=v:d!==1&&(d=1):s!==-1&&(d=-1)}return s===-1||n===-1||d===0||d===1&&s===n-1&&s===o+1?"":t.slice(s,n)},format:p.bind(null,"/"),parse(t){C(t,"path");const s={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return s;const o=t.charCodeAt(0)===E;let n;o?(s.root="/",n=1):n=0;let c=-1,d=0,v=-1,k=!0,u=t.length-1,l=0;for(;u>=n;--u){const w=t.charCodeAt(u);if(w===E){if(!k){d=u+1;break}continue}v===-1&&(k=!1,v=u+1),w===g?c===-1?c=u:l!==1&&(l=1):c!==-1&&(l=-1)}if(v!==-1){const w=d===0&&o?1:d;c===-1||l===0||l===1&&c===v-1&&c===d+1?s.base=s.name=t.slice(w,v):(s.name=t.slice(w,c),s.base=t.slice(w,v),s.ext=t.slice(c,v))}return d>0?s.dir=t.slice(0,d-1):o&&(s.dir="/"),s},sep:"/",delimiter:":",win32:null,posix:null},e.$8c.win32=e.$7c.win32=e.$7c,e.$8c.posix=e.$7c.posix=e.$8c,e.$9c=y?e.$7c.normalize:e.$8c.normalize,e.$0c=y?e.$7c.isAbsolute:e.$8c.isAbsolute,e.$$c=y?e.$7c.join:e.$8c.join,e.$_c=y?e.$7c.resolve:e.$8c.resolve,e.$ad=y?e.$7c.relative:e.$8c.relative,e.$bd=y?e.$7c.dirname:e.$8c.dirname,e.$cd=y?e.$7c.basename:e.$8c.basename,e.$dd=y?e.$7c.extname:e.$8c.extname,e.$ed=y?e.$7c.format:e.$8c.format,e.$fd=y?e.$7c.parse:e.$8c.parse,e.$gd=y?e.$7c.toNamespacedPath:e.$8c.toNamespacedPath,e.sep=y?e.$7c.sep:e.$8c.sep,e.$id=y?e.$7c.delimiter:e.$8c.delimiter}),define(De[125],Ce([1,0,55,14]),function($e,e,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gq=e.$fq=e.$eq=e.$dq=e.$cq=e.$bq=e.$aq=e.$_p=e.$$p=e.$0p=e.$9p=e.$8p=e.$7p=void 0;const h=new D.$T(()=>{const k=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:k,collatorIsNumeric:k.resolvedOptions().numeric}}),R=new D.$T(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),A=new D.$T(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function g(k,u,l=!1){const w=k||"",L=u||"",N=h.value.collator.compare(w,L);return h.value.collatorIsNumeric&&N===0&&w!==L?w<L?-1:1:N}e.$7p=g;function E(k,u){const l=R.value.collator;return k=k||"",u=u||"",p(l,k,u)}e.$8p=E;function $(k,u){const l=R.value.collator;return k=k||"",u=u||"",o(k,u)||p(l,k,u)}e.$9p=$;function P(k,u){const l=R.value.collator;return k=k||"",u=u||"",s(k,u)||p(l,k,u)}e.$0p=P;function I(k,u){return k=k||"",u=u||"",k===u?0:k<u?-1:1}e.$$p=I;function b(k,u){const[l,w]=a(k),[L,N]=a(u);let j=h.value.collator.compare(w,N);if(j===0){if(h.value.collatorIsNumeric&&w!==N)return w<N?-1:1;if(j=h.value.collator.compare(l,L),h.value.collatorIsNumeric&&j===0&&l!==L)return l<L?-1:1}return j}e.$_p=b;function S(k,u){k=k||"",u=u||"";const l=m(k),w=m(u),L=R.value.collator,N=A.value.collator;return p(N,l,w)||p(L,k,u)}e.$aq=S;function C(k,u){k=k||"",u=u||"";const l=m(k),w=m(u),L=R.value.collator,N=A.value.collator;return p(N,l,w)||o(k,u)||p(L,k,u)}e.$bq=C;function y(k,u){k=k||"",u=u||"";const l=m(k),w=m(u),L=R.value.collator,N=A.value.collator;return p(N,l,w)||s(k,u)||p(L,k,u)}e.$cq=y;function r(k,u){k=k||"",u=u||"";const l=m(k).toLowerCase(),w=m(u).toLowerCase();return l!==w?l<w?-1:1:k!==u?k<u?-1:1:0}e.$dq=r;const i=/^(.*?)(\.([^.]*))?$/;function a(k,u=!1){const l=k?i.exec(k):[];let w=[l&&l[1]||"",l&&l[3]||""];return u&&(!w[0]&&w[1]||w[0]&&w[0].charAt(0)===".")&&(w=[w[0]+"."+w[1],""]),w}function m(k){const u=k?i.exec(k):[];return u&&u[1]&&u[1].charAt(0)!=="."&&u[3]||""}function p(k,u,l){const w=k.compare(u,l);return w!==0?w:u.length!==l.length?u.length<l.length?-1:1:0}function f(k){const u=k.charAt(0);return u.toLocaleUpperCase()!==u}function t(k){const u=k.charAt(0);return u.toLocaleLowerCase()!==u}function s(k,u){return f(k)&&t(u)?-1:t(k)&&f(u)?1:0}function o(k,u){return t(k)&&f(u)?-1:f(k)&&t(u)?1:0}function n(k,u,l=!1){return l||(k=k&&k.toLowerCase(),u=u&&u.toLowerCase()),k===u?0:k<u?-1:1}function c(k,u,l=!1){const w=k.split(M.sep),L=u.split(M.sep),N=w.length-1,j=L.length-1;let T,O;for(let B=0;;B++){if(T=N===B,O=j===B,T&&O)return g(w[B],L[B],l);if(T)return-1;if(O)return 1;const F=n(w[B],L[B],l);if(F!==0)return F}}e.$eq=c;function d(k,u,l){const w=k.toLowerCase(),L=u.toLowerCase(),N=v(k,u,l);if(N)return N;const j=w.endsWith(l),T=L.endsWith(l);if(j!==T)return j?-1:1;const O=g(w,L);return O!==0?O:w.localeCompare(L)}e.$fq=d;function v(k,u,l){const w=k.toLowerCase(),L=u.toLowerCase(),N=w.startsWith(l),j=L.startsWith(l);if(N!==j)return N?-1:1;if(N&&j){if(w.length<L.length)return-1;if(w.length>L.length)return 1}return 0}e.$gq=v}),define(De[32],Ce([1,0,14,9,15,18]),function($e,e,D,M,h,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Se=e.$Re=e.$Qe=e.$Pe=e.$Oe=e.$Ne=e.$Me=e.$Le=e.$Ke=e.$Je=e.$Ie=e.$He=e.$Ge=e.$Fe=e.$Ee=e.$De=void 0;function A(d){return d===47||d===92}e.$De=A;function g(d){return d.replace(/[\\/]/g,D.$8c.sep)}e.$Ee=g;function E(d){return d.indexOf("/")===-1&&(d=g(d)),/^[a-zA-Z]:(\/|$)/.test(d)&&(d="/"+d),d}e.$Fe=E;function $(d,v=D.$8c.sep){if(!d)return"";const k=d.length,u=d.charCodeAt(0);if(A(u)){if(A(d.charCodeAt(1))&&!A(d.charCodeAt(2))){let w=3;const L=w;for(;w<k&&!A(d.charCodeAt(w));w++);if(L!==w&&!A(d.charCodeAt(w+1))){for(w+=1;w<k;w++)if(A(d.charCodeAt(w)))return d.slice(0,w+1).replace(/[\\/]/g,v)}}return v}else if(i(u)&&d.charCodeAt(1)===58)return A(d.charCodeAt(2))?d.slice(0,2)+v:d.slice(0,2);let l=d.indexOf("://");if(l!==-1){for(l+=3;l<k;l++)if(A(d.charCodeAt(l)))return d.slice(0,l+1)}return""}e.$Ge=$;function P(d){if(!M.$i||!d||d.length<5)return!1;let v=d.charCodeAt(0);if(v!==92||(v=d.charCodeAt(1),v!==92))return!1;let k=2;const u=k;for(;k<d.length&&(v=d.charCodeAt(k),v!==92);k++);return!(u===k||(v=d.charCodeAt(k+1),isNaN(v)||v===92))}e.$He=P;const I=/[\\/:\*\?"<>\|]/g,b=/[\\/]/g,S=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function C(d,v=M.$i){const k=v?I:b;return!(!d||d.length===0||/^\s+$/.test(d)||(k.lastIndex=0,k.test(d))||v&&S.test(d)||d==="."||d===".."||v&&d[d.length-1]==="."||v&&d.length!==d.trim().length||d.length>255)}e.$Ie=C;function y(d,v,k){const u=d===v;return!k||u?u:!d||!v?!1:(0,h.$Od)(d,v)}e.$Je=y;function r(d,v,k,u=D.sep){if(d===v)return!0;if(!d||!v||v.length>d.length)return!1;if(k){if(!(0,h.$Pd)(d,v))return!1;if(v.length===d.length)return!0;let w=v.length;return v.charAt(v.length-1)===u&&w--,d.charAt(w)===u}return v.charAt(v.length-1)!==u&&(v+=u),d.indexOf(v)===0}e.$Ke=r;function i(d){return d>=65&&d<=90||d>=97&&d<=122}e.$Le=i;function a(d,v){return M.$i&&d.endsWith(":")&&(d+=D.sep),(0,D.$0c)(d)||(d=(0,D.$$c)(v,d)),d=(0,D.$9c)(d),M.$i?(d=(0,h.$xd)(d,D.sep),d.endsWith(":")&&(d+=D.sep)):(d=(0,h.$xd)(d,D.sep),d||(d=D.sep)),d}e.$Me=a;function m(d){const v=(0,D.$9c)(d);return M.$i?d.length>3?!1:p(v)&&(d.length===2||v.charCodeAt(2)===92):v===D.$8c.sep}e.$Ne=m;function p(d,v=M.$i){return v?i(d.charCodeAt(0))&&d.charCodeAt(1)===58:!1}e.$Oe=p;function f(d,v=M.$i){return p(d,v)?d[0]:void 0}e.$Pe=f;function t(d,v,k){return v.length>d.length?-1:d===v?0:(k&&(d=d.toLowerCase(),v=v.toLowerCase()),d.indexOf(v))}e.$Qe=t;function s(d){const v=d.split(":");let k,u,l;for(const w of v){const L=Number(w);(0,R.$pe)(L)?u===void 0?u=L:l===void 0&&(l=L):k=k?[k,w].join(":"):w}if(!k)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:k,line:u!==void 0?u:void 0,column:l!==void 0?l:u!==void 0?1:void 0}}e.$Re=s;const o="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",n="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function c(d,v,k=8){let u="";for(let w=0;w<k;w++){let L;w===0&&M.$i&&!v&&(k===3||k===4)?L=n:L=o,u+=L.charAt(Math.floor(Math.random()*L.length))}let l;return v?l=`${v}-${u}`:l=u,d?(0,D.$$c)(d,l):l}e.$Se=c}),define(De[126],Ce([1,0,125,120,74,14,9,15]),function($e,e,D,M,h,R,A,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mq=e.$lq=e.$kq=e.$jq=e.$iq=e.$hq=void 0;const E=0,$=[E,[]];function P(J,K,me,re){if(!J||!K)return $;const x=J.length,q=K.length;if(x<q)return $;const ee=J.toLowerCase();return I(K,me,q,J,ee,x,re)}e.$hq=P;function I(J,K,me,re,x,q,ee){const pe=[],ce=[];for(let V=0;V<me;V++){const G=V*q,ae=G-q,ne=V>0,he=J[V],Ee=K[V];for(let de=0;de<q;de++){const ge=de>0,ie=G+de,ue=ie-1,we=ae+de-1,Pe=ge?pe[ue]:0,U=ne&&ge?pe[we]:0,Z=ne&&ge?ce[we]:0;let X;!U&&ne?X=0:X=b(he,Ee,re,x,de,Z),X&&U+X>=Pe&&(ee||ne||x.startsWith(K,de))?(ce[ie]=Z+1,pe[ie]=U+X):(ce[ie]=E,pe[ie]=Pe)}}const _=[];let Q=me-1,z=q-1;for(;Q>=0&&z>=0;){const V=Q*q+z;ce[V]===E||(_.push(z),Q--),z--}return[pe[me*q-1],_.reverse()]}function b(J,K,me,re,x,q){let ee=0;if(!S(K,re[x]))return ee;if(ee+=1,q>0&&(ee+=q*5),J===me[x]&&(ee+=1),x===0)ee+=8;else{const pe=C(me.charCodeAt(x-1));pe?ee+=pe:(0,M.$zj)(me.charCodeAt(x))&&q===0&&(ee+=2)}return ee}function S(J,K){return J===K?!0:J==="/"||J==="\\"?K==="/"||K==="\\":!1}function C(J){switch(J){case 47:case 92:return 5;case 95:case 45:case 46:case 32:case 39:case 34:case 58:return 4;default:return 0}}const y=[void 0,[]];function r(J,K,me=0,re=0){const x=K;return x.values&&x.values.length>1?i(J,x.values,me,re):a(J,K,me,re)}e.$iq=r;function i(J,K,me,re){let x=0;const q=[];for(const ee of K){const[pe,ce]=a(J,ee,me,re);if(typeof pe!="number")return y;x+=pe,q.push(...ce)}return[x,k(q)]}function a(J,K,me,re){const x=(0,M.$Ij)(K.original,K.originalLowercase,me,J,J.toLowerCase(),re,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return x?[x[0],(0,M.$Fj)(x)]:y}const m=Object.freeze({score:0}),p=1<<18,f=1<<17,t=1<<16;function s(J,K,me,re){const x=re.values?re.values:[re];return(0,h.$ni)({[re.normalized]:{values:x.map(ee=>({value:ee.normalized,expectContiguousMatch:ee.expectContiguousMatch})),label:J,description:K,allowNonContiguousMatches:me}})}function o(J,K,me,re,x){if(!J||!K.normalized)return m;const q=re.getItemLabel(J);if(!q)return m;const ee=re.getItemDescription(J),pe=s(q,ee,me,K),ce=x[pe];if(ce)return ce;const _=n(q,ee,re.getItemPath(J),K,me);return x[pe]=_,_}e.$jq=o;function n(J,K,me,re,x){const q=!me||!re.containsPathSeparator;return me&&(A.$k?re.pathNormalized===me:(0,g.$Od)(re.pathNormalized,me))?{score:p,labelMatch:[{start:0,end:J.length}],descriptionMatch:K?[{start:0,end:K.length}]:void 0}:re.values&&re.values.length>1?c(J,K,me,re.values,q,x):d(J,K,me,re,q,x)}function c(J,K,me,re,x,q){let ee=0;const pe=[],ce=[];for(const _ of re){const{score:Q,labelMatch:z,descriptionMatch:V}=d(J,K,me,_,x,q);if(Q===E)return m;ee+=Q,z&&pe.push(...z),V&&ce.push(...V)}return{score:ee,labelMatch:k(pe),descriptionMatch:k(ce)}}function d(J,K,me,re,x,q){if(x||!K){const[ee,pe]=P(J,re.normalized,re.normalizedLowercase,q&&!re.expectContiguousMatch);if(ee){const ce=(0,M.$wj)(re.normalized,J);let _;if(ce){_=f;const Q=Math.round(re.normalized.length/J.length*100);_+=Q}else _=t;return{score:_+ee,labelMatch:ce||v(pe)}}}if(K){let ee=K;me&&(ee=`${K}${R.sep}`);const pe=ee.length,ce=`${ee}${J}`,[_,Q]=P(ce,re.normalized,re.normalizedLowercase,q&&!re.expectContiguousMatch);if(_){const z=v(Q),V=[],G=[];return z.forEach(ae=>{ae.start<pe&&ae.end>pe?(V.push({start:0,end:ae.end-pe}),G.push({start:ae.start,end:pe})):ae.start>=pe?V.push({start:ae.start-pe,end:ae.end-pe}):G.push(ae)}),{score:_,labelMatch:V,descriptionMatch:G}}}return m}function v(J){const K=[];if(!J)return K;let me;for(const re of J)me&&me.end===re?me.end+=1:(me={start:re,end:re+1},K.push(me));return K}function k(J){const K=J.sort((x,q)=>x.start-q.start),me=[];let re;for(const x of K)!re||!u(re,x)?(re=x,me.push(x)):(re.start=Math.min(re.start,x.start),re.end=Math.max(re.end,x.end));return me}function u(J,K){return!(J.end<K.start||K.end<J.start)}function l(J,K,me,re,x,q){const ee=o(J,me,re,x,q),pe=o(K,me,re,x,q),ce=ee.score,_=pe.score;if((ce===p||_===p)&&ce!==_)return ce===p?-1:1;if(ce>t||_>t){if(ce!==_)return ce>_?-1:1;if(ce<f&&_<f){const he=L(ee.labelMatch,pe.labelMatch);if(he!==0)return he}const ae=x.getItemLabel(J)||"",ne=x.getItemLabel(K)||"";if(ae.length!==ne.length)return ae.length-ne.length}if(ce!==_)return ce>_?-1:1;const Q=Array.isArray(ee.labelMatch)&&ee.labelMatch.length>0,z=Array.isArray(pe.labelMatch)&&pe.labelMatch.length>0;if(Q&&!z)return-1;if(z&&!Q)return 1;const V=w(J,ee,x),G=w(K,pe,x);return V&&G&&V!==G?G>V?-1:1:N(J,K,me,x)}e.$kq=l;function w(J,K,me){let re=-1,x=-1;if(K.descriptionMatch&&K.descriptionMatch.length?re=K.descriptionMatch[0].start:K.labelMatch&&K.labelMatch.length&&(re=K.labelMatch[0].start),K.labelMatch&&K.labelMatch.length){if(x=K.labelMatch[K.labelMatch.length-1].end,K.descriptionMatch&&K.descriptionMatch.length){const q=me.getItemDescription(J);q&&(x+=q.length)}}else K.descriptionMatch&&K.descriptionMatch.length&&(x=K.descriptionMatch[K.descriptionMatch.length-1].end);return x-re}function L(J,K){if(!J&&!K||(!J||!J.length)&&(!K||!K.length))return 0;if(!K||!K.length)return-1;if(!J||!J.length)return 1;const me=J[0].start,x=J[J.length-1].end-me,q=K[0].start,pe=K[K.length-1].end-q;return x===pe?0:pe<x?1:-1}function N(J,K,me,re){const x=re.getItemLabel(J)||"",q=re.getItemLabel(K)||"",ee=re.getItemDescription(J),pe=re.getItemDescription(K),ce=x.length+(ee?ee.length:0),_=q.length+(pe?pe.length:0);if(ce!==_)return ce-_;const Q=re.getItemPath(J),z=re.getItemPath(K);return Q&&z&&Q.length!==z.length?Q.length-z.length:x!==q?(0,D.$fq)(x,q,me.normalized):ee&&pe&&ee!==pe?(0,D.$fq)(ee,pe,me.normalized):Q&&z&&Q!==z?(0,D.$fq)(Q,z,me.normalized):0}function j(J){return J.startsWith('"')&&J.endsWith('"')}const T=" ";function O(J){typeof J!="string"&&(J="");const K=J.toLowerCase(),{pathNormalized:me,normalized:re,normalizedLowercase:x}=B(J),q=me.indexOf(R.sep)>=0,ee=j(J);let pe;const ce=J.split(T);if(ce.length>1)for(const _ of ce){const Q=j(_),{pathNormalized:z,normalized:V,normalizedLowercase:G}=B(_);V&&(pe||(pe=[]),pe.push({original:_,originalLowercase:_.toLowerCase(),pathNormalized:z,normalized:V,normalizedLowercase:G,expectContiguousMatch:Q}))}return{original:J,originalLowercase:K,pathNormalized:me,normalized:re,normalizedLowercase:x,values:pe,containsPathSeparator:q,expectContiguousMatch:ee}}e.$lq=O;function B(J){let K;A.$i?K=J.replace(/\//g,R.sep):K=J.replace(/\\/g,R.sep);const me=(0,g.$zd)(K).replace(/\s|"/g,"");return{pathNormalized:K,normalized:me,normalizedLowercase:me.toLowerCase()}}function F(J){return Array.isArray(J)?O(J.map(K=>K.original).join(T)):O(J.original)}e.$mq=F}),define(De[97],Ce([1,0,14]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ir=e.$Hr=e.$Gr=e.$Fr=e.$Er=void 0,e.$Er=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const M={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},h={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function R(P){const I=(0,D.$dd)(P),b=M[I.toLowerCase()];return b!==void 0?b:A(P)}e.$Fr=R;function A(P){const I=(0,D.$dd)(P);return h[I.toLowerCase()]}e.$Gr=A;function g(P){for(const I in h)if(h[I]===P)return I}e.$Hr=g;const E=/^(.+)\/(.+?)(;.+)?$/;function $(P,I){const b=E.exec(P);return b?`${b[1].toLowerCase()}/${b[2].toLowerCase()}${b[3]??""}`:I?void 0:P}e.$Ir=$}),define(De[98],Ce([1,0,9]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rl=e.$ql=e.TerminateResponseCode=e.Source=void 0;var M;(function(g){g[g.stdout=0]="stdout",g[g.stderr=1]="stderr"})(M||(e.Source=M={}));var h;(function(g){g[g.Success=0]="Success",g[g.Unknown=1]="Unknown",g[g.AccessDenied=2]="AccessDenied",g[g.ProcessNotFound=3]="ProcessNotFound"})(h||(e.TerminateResponseCode=h={}));function R(g,...E){const $=E.reduce((b,S)=>(b[S]=!0,b),{}),P=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(g).filter(b=>!$[b]).forEach(b=>{for(let S=0;S<P.length;S++)if(b.search(P[S])!==-1){delete g[b];break}})}e.$ql=R;function A(g){g&&(delete g.DEBUG,D.$j&&delete g.DYLD_LIBRARY_PATH,D.$k&&delete g.LD_PRELOAD)}e.$rl=A}),define(De[2],Ce([1,0,14,9]),function($e,e,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ve=e.$Ue=e.URI=void 0;const h=/^\w[\w\d+.-]*$/,R=/^\//,A=/^\/\//;function g(n,c){if(!n.scheme&&c)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${n.authority}", path: "${n.path}", query: "${n.query}", fragment: "${n.fragment}"}`);if(n.scheme&&!h.test(n.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(n.path){if(n.authority){if(!R.test(n.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(A.test(n.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function E(n,c){return!n&&!c?"file":n}function $(n,c){switch(n){case"https":case"http":case"file":c?c[0]!==I&&(c=I+c):c=I;break}return c}const P="",I="/",b=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class S{static isUri(c){return c instanceof S?!0:c?typeof c.authority=="string"&&typeof c.fragment=="string"&&typeof c.path=="string"&&typeof c.query=="string"&&typeof c.scheme=="string"&&typeof c.fsPath=="string"&&typeof c.with=="function"&&typeof c.toString=="function":!1}constructor(c,d,v,k,u,l=!1){typeof c=="object"?(this.scheme=c.scheme||P,this.authority=c.authority||P,this.path=c.path||P,this.query=c.query||P,this.fragment=c.fragment||P):(this.scheme=E(c,l),this.authority=d||P,this.path=$(this.scheme,v||P),this.query=k||P,this.fragment=u||P,g(this,l))}get fsPath(){return p(this,!1)}with(c){if(!c)return this;let{scheme:d,authority:v,path:k,query:u,fragment:l}=c;return d===void 0?d=this.scheme:d===null&&(d=P),v===void 0?v=this.authority:v===null&&(v=P),k===void 0?k=this.path:k===null&&(k=P),u===void 0?u=this.query:u===null&&(u=P),l===void 0?l=this.fragment:l===null&&(l=P),d===this.scheme&&v===this.authority&&k===this.path&&u===this.query&&l===this.fragment?this:new r(d,v,k,u,l)}static parse(c,d=!1){const v=b.exec(c);return v?new r(v[2]||P,o(v[4]||P),o(v[5]||P),o(v[7]||P),o(v[9]||P),d):new r(P,P,P,P,P)}static file(c){let d=P;if(M.$i&&(c=c.replace(/\\/g,I)),c[0]===I&&c[1]===I){const v=c.indexOf(I,2);v===-1?(d=c.substring(2),c=I):(d=c.substring(2,v),c=c.substring(v)||I)}return new r("file",d,c,P,P)}static from(c,d){return new r(c.scheme,c.authority,c.path,c.query,c.fragment,d)}static joinPath(c,...d){if(!c.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let v;return M.$i&&c.scheme==="file"?v=S.file(D.$7c.join(p(c,!0),...d)).path:v=D.$8c.join(c.path,...d),c.with({path:v})}toString(c=!1){return f(this,c)}toJSON(){return this}static revive(c){if(c){if(c instanceof S)return c;{const d=new r(c);return d._formatted=c.external??null,d._fsPath=c._sep===y?c.fsPath??null:null,d}}else return c}}e.URI=S;function C(n){return!n||typeof n!="object"?!1:typeof n.scheme=="string"&&(typeof n.authority=="string"||typeof n.authority>"u")&&(typeof n.path=="string"||typeof n.path>"u")&&(typeof n.query=="string"||typeof n.query>"u")&&(typeof n.fragment=="string"||typeof n.fragment>"u")}e.$Ue=C;const y=M.$i?1:void 0;class r extends S{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=p(this,!1)),this._fsPath}toString(c=!1){return c?f(this,!0):(this._formatted||(this._formatted=f(this,!1)),this._formatted)}toJSON(){const c={$mid:1};return this._fsPath&&(c.fsPath=this._fsPath,c._sep=y),this._formatted&&(c.external=this._formatted),this.path&&(c.path=this.path),this.scheme&&(c.scheme=this.scheme),this.authority&&(c.authority=this.authority),this.query&&(c.query=this.query),this.fragment&&(c.fragment=this.fragment),c}}const i={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function a(n,c,d){let v,k=-1;for(let u=0;u<n.length;u++){const l=n.charCodeAt(u);if(l>=97&&l<=122||l>=65&&l<=90||l>=48&&l<=57||l===45||l===46||l===95||l===126||c&&l===47||d&&l===91||d&&l===93||d&&l===58)k!==-1&&(v+=encodeURIComponent(n.substring(k,u)),k=-1),v!==void 0&&(v+=n.charAt(u));else{v===void 0&&(v=n.substr(0,u));const w=i[l];w!==void 0?(k!==-1&&(v+=encodeURIComponent(n.substring(k,u)),k=-1),v+=w):k===-1&&(k=u)}}return k!==-1&&(v+=encodeURIComponent(n.substring(k))),v!==void 0?v:n}function m(n){let c;for(let d=0;d<n.length;d++){const v=n.charCodeAt(d);v===35||v===63?(c===void 0&&(c=n.substr(0,d)),c+=i[v]):c!==void 0&&(c+=n[d])}return c!==void 0?c:n}function p(n,c){let d;return n.authority&&n.path.length>1&&n.scheme==="file"?d=`//${n.authority}${n.path}`:n.path.charCodeAt(0)===47&&(n.path.charCodeAt(1)>=65&&n.path.charCodeAt(1)<=90||n.path.charCodeAt(1)>=97&&n.path.charCodeAt(1)<=122)&&n.path.charCodeAt(2)===58?c?d=n.path.substr(1):d=n.path[1].toLowerCase()+n.path.substr(2):d=n.path,M.$i&&(d=d.replace(/\//g,"\\")),d}e.$Ve=p;function f(n,c){const d=c?m:a;let v="",{scheme:k,authority:u,path:l,query:w,fragment:L}=n;if(k&&(v+=k,v+=":"),(u||k==="file")&&(v+=I,v+=I),u){let N=u.indexOf("@");if(N!==-1){const j=u.substr(0,N);u=u.substr(N+1),N=j.lastIndexOf(":"),N===-1?v+=d(j,!1,!1):(v+=d(j.substr(0,N),!1,!1),v+=":",v+=d(j.substr(N+1),!1,!0)),v+="@"}u=u.toLowerCase(),N=u.lastIndexOf(":"),N===-1?v+=d(u,!1,!0):(v+=d(u.substr(0,N),!1,!0),v+=u.substr(N))}if(l){if(l.length>=3&&l.charCodeAt(0)===47&&l.charCodeAt(2)===58){const N=l.charCodeAt(1);N>=65&&N<=90&&(l=`/${String.fromCharCode(N+32)}:${l.substr(3)}`)}else if(l.length>=2&&l.charCodeAt(1)===58){const N=l.charCodeAt(0);N>=65&&N<=90&&(l=`${String.fromCharCode(N+32)}:${l.substr(2)}`)}v+=d(l,!0,!1)}return w&&(v+="?",v+=d(w,!1,!1)),L&&(v+="#",v+=c?L:a(L,!1,!1)),v}function t(n){try{return decodeURIComponent(n)}catch{return n.length>3?n.substr(0,3)+t(n.substr(3)):n}}const s=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function o(n){return n.match(s)?n.replace(s,c=>t(c)):n}}),define(De[179],Ce([1,0,2]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.$Mp=e.$Lp=e.$Kp=void 0;function M($){const P=$;return P&&typeof P.type=="string"&&typeof P.severity=="string"}e.$Kp=M;function h($){const P=[];let I;try{const b=JSON.parse($.arguments),S=b[b.length-1];S&&S.__$stack&&(b.pop(),I=S.__$stack),P.push(...b)}catch{P.push("Unable to log remote console arguments",$.arguments)}return{args:P,stack:I}}e.$Lp=h;function R($){if(typeof $!="string")return R(h($).stack);const P=$;if(P){const I=A(P),b=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(I||"");if(b&&b.length===4)return{uri:D.URI.file(b[1]),line:Number(b[2]),column:Number(b[3])}}}e.$Mp=R;function A($){if(!$)return $;const P=$.indexOf(`
`);return P===-1?$:$.substring(0,P)}function g($,P){const{args:I,stack:b}=h($),S=typeof I[0]=="string"&&I.length===1;let C=A(b);C&&(C=`(${C.trim()})`);let y=[];if(typeof I[0]=="string"?C&&S?y=[`%c[${P}] %c${I[0]} %c${C}`,E("blue"),E(""),E("grey")]:y=[`%c[${P}] %c${I[0]}`,E("blue"),E(""),...I.slice(1)]:y=[`%c[${P}]%`,E("blue"),...I],C&&!S&&y.push(C),typeof console[$.severity]!="function")throw new Error("Unknown console method");console[$.severity].apply(console,y)}e.log=g;function E($){return`color: ${$}`}}),define(De[77],Ce([1,0,21,2]),function($e,e,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9g=e.$8g=e.$7g=void 0;function h(E){return JSON.stringify(E,A)}e.$7g=h;function R(E){let $=JSON.parse(E);return $=g($),$}e.$8g=R;function A(E,$){return $ instanceof RegExp?{$mid:2,source:$.source,flags:$.flags}:$}function g(E,$=0){if(!E||$>200)return E;if(typeof E=="object"){switch(E.$mid){case 1:return M.URI.revive(E);case 2:return new RegExp(E.source,E.flags);case 16:return new Date(E.source)}if(E instanceof D.$Hc||E instanceof Uint8Array)return E;if(Array.isArray(E))for(let P=0;P<E.length;++P)E[P]=g(E[P],$+1);else for(const P in E)Object.hasOwnProperty.call(E,P)&&(E[P]=g(E[P],$+1))}return E}e.$9g=g}),define(De[16],Ce([1,0,8,9,2]),function($e,e,D,M,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$4e=e.$3e=e.$2e=e.$1e=e.$Ze=e.$Ye=e.$Xe=e.$We=e.Schemas=void 0;var R;(function($){$.inMemory="inmemory",$.vscode="vscode",$.internal="private",$.walkThrough="walkThrough",$.walkThroughSnippet="walkThroughSnippet",$.http="http",$.https="https",$.file="file",$.mailto="mailto",$.untitled="untitled",$.data="data",$.command="command",$.vscodeRemote="vscode-remote",$.vscodeRemoteResource="vscode-remote-resource",$.vscodeManagedRemoteResource="vscode-managed-remote-resource",$.vscodeUserData="vscode-userdata",$.vscodeCustomEditor="vscode-custom-editor",$.vscodeNotebookCell="vscode-notebook-cell",$.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",$.vscodeNotebookCellOutput="vscode-notebook-cell-output",$.vscodeInteractiveInput="vscode-interactive-input",$.vscodeSettings="vscode-settings",$.vscodeWorkspaceTrust="vscode-workspace-trust",$.vscodeTerminal="vscode-terminal",$.vscodeChatSesssion="vscode-chat-editor",$.webviewPanel="webview-panel",$.vscodeWebview="vscode-webview",$.extension="extension",$.vscodeFileResource="vscode-file",$.tmp="tmp",$.vsls="vsls",$.vscodeSourceControl="vscode-scm"})(R||(e.Schemas=R={})),e.$We="vscode-tkn",e.$Xe="tkn";class A{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f=`/${R.vscodeRemoteResource}`}setPreferredWebSchema(P){this.d=P}setDelegate(P){this.e=P}setServerRootPath(P){this.f=`${P}/${R.vscodeRemoteResource}`}set(P,I,b){this.a[P]=I,this.b[P]=b}setConnectionToken(P,I){this.c[P]=I}getPreferredWebSchema(){return this.d}rewrite(P){if(this.e)try{return this.e(P)}catch(r){return D.$Y(r),P}const I=P.authority;let b=this.a[I];b&&b.indexOf(":")!==-1&&b.indexOf("[")===-1&&(b=`[${b}]`);const S=this.b[I],C=this.c[I];let y=`path=${encodeURIComponent(P.path)}`;return typeof C=="string"&&(y+=`&${e.$Xe}=${encodeURIComponent(C)}`),h.URI.from({scheme:M.$o?this.d:R.vscodeRemoteResource,authority:`${b}:${S}`,path:this.f,query:y})}}e.$Ye=new A,e.$Ze="vs/../../extensions",e.$1e="vs/../../node_modules",e.$2e="vs/../../node_modules.asar",e.$3e="vs/../../node_modules.asar.unpacked";class g{static{this.a="vscode-app"}asBrowserUri(P){const I=this.b(P,$e);return this.uriToBrowserUri(I)}uriToBrowserUri(P){return P.scheme===R.vscodeRemote?e.$Ye.rewrite(P):P.scheme===R.file&&(M.$m||M.$p&&M.$g.origin===`${R.vscodeFileResource}://${g.a}`)?P.with({scheme:R.vscodeFileResource,authority:P.authority||g.a,query:null,fragment:null}):P}asFileUri(P){const I=this.b(P,$e);return this.uriToFileUri(I)}uriToFileUri(P){return P.scheme===R.vscodeFileResource?P.with({scheme:R.file,authority:P.authority!==g.a?P.authority:null,query:null,fragment:null}):P}b(P,I){return h.URI.isUri(P)?P:h.URI.parse(I.toUrl(P))}}e.$4e=new g;var E;(function($){const P=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);$.CoopAndCoep=Object.freeze(P.get("3"));const I="vscode-coi";function b(C){let y;typeof C=="string"?y=new URL(C).searchParams:C instanceof URL?y=C.searchParams:h.URI.isUri(C)&&(y=new URL(C.toString(!0)).searchParams);const r=y?.get(I);if(r)return P.get(r)}$.getHeadersFromQuery=b;function S(C,y,r){if(!globalThis.crossOriginIsolated)return;const i=y&&r?"3":r?"2":"1";C instanceof URLSearchParams?C.set(I,i):C[I]=i}$.addSearchParam=S})(E||(e.COI=E={}))}),define(De[180],Ce([1,0,154,16,9,2]),function($e,e,D,M,h,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9C=void 0;class A{constructor(b,S,C){this.id=b,this.dependencies=S,this.callback=C}}class g{static{this.INSTANCE=new g}constructor(){this.a=typeof self=="object"&&self.constructor&&self.constructor.name==="DedicatedWorkerGlobalScope",this.b=typeof document=="object",this.c=[],this.d=!1}g(){this.d||(this.d=!0,globalThis.define=(b,S,C)=>{typeof b!="string"&&(C=S,S=b,b=null),(typeof S!="object"||!Array.isArray(S))&&(C=S,S=null),this.c.push(new A(b,S,C))},globalThis.define.amd=!0,this.b?this.f=window.trustedTypes?.createPolicy("amdLoader",{createScriptURL(b){if(b.startsWith(window.location.origin)||b.startsWith("vscode-file://vscode-app"))return b;throw new Error(`[trusted_script_src] Invalid script url: ${b}`)}}):this.a&&(this.f=globalThis.trustedTypes?.createPolicy("amdLoader",{createScriptURL(b){return b}})))}async load(b){this.g();const S=await(this.a?this.i(b):this.b?this.h(b):this.j(b));if(!S)throw new Error(`Did not receive a define call from script ${b}`);if(Array.isArray(S.dependencies)&&S.dependencies.length>0)throw new Error(`Cannot resolve dependencies for script ${b}. The dependencies are: ${S.dependencies.join(", ")}`);return typeof S.callback=="function"?S.callback([]):S.callback}h(b){return new Promise((S,C)=>{const y=document.createElement("script");y.setAttribute("async","async"),y.setAttribute("type","text/javascript");const r=()=>{y.removeEventListener("load",i),y.removeEventListener("error",a)},i=m=>{r(),S(this.c.pop())},a=m=>{r(),C(m)};y.addEventListener("load",i),y.addEventListener("error",a),this.f&&(b=this.f.createScriptURL(b)),y.setAttribute("src",b),document.getElementsByTagName("head")[0].appendChild(y)})}i(b){return new Promise((S,C)=>{try{this.f&&(b=this.f.createScriptURL(b)),importScripts(b),S(this.c.pop())}catch(y){C(y)}})}async j(b){try{const S=globalThis._VSCODE_NODE_MODULES.fs,C=globalThis._VSCODE_NODE_MODULES.vm,y=globalThis._VSCODE_NODE_MODULES.module,r=R.URI.parse(b).fsPath,i=S.readFileSync(r).toString(),a=y.wrap(i.replace(/^#!.*/,""));return new C.Script(a).runInThisContext().apply(),this.c.pop()}catch(S){throw S}}}const E=new Map;let $={};typeof globalThis.require=="object"&&($=globalThis.require.paths??{});async function P(I,b,S){if(D.$R){S===void 0&&(S=!!(globalThis._VSCODE_PRODUCT_JSON??globalThis.vscode?.context?.configuration()?.product)?.commit),$[I]&&(I=$[I]);const C=`${I}/${b}`;if(E.has(C))return E.get(C);let y;if(/^\w[\w\d+.-]*:\/\//.test(C))y=C;else{const m=`${S&&!h.$o?M.$2e:M.$1e}/${C}`;y=M.$4e.asBrowserUri(m).toString(!0)}const r=g.INSTANCE.load(y);return E.set(C,r),r}else return await new Promise((C,y)=>{$e([I],C,y)})}e.$9C=P}),define(De[24],Ce([1,0,32,16,14,9,15,2]),function($e,e,D,M,h,R,A,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qg=e.DataUri=e.$pg=e.$og=e.$ng=e.$mg=e.$lg=e.$kg=e.$jg=e.$ig=e.$hg=e.$gg=e.$fg=e.$eg=e.$dg=e.$cg=e.$bg=e.$ag=e.$_f=e.$$f=e.$0f=e.$9f=e.$8f=e.$7f=void 0;function E(S){return(0,g.$Ve)(S,!0)}e.$7f=E;class ${constructor(C){this.a=C}compare(C,y,r=!1){return C===y?0:(0,A.$Hd)(this.getComparisonKey(C,r),this.getComparisonKey(y,r))}isEqual(C,y,r=!1){return C===y?!0:!C||!y?!1:this.getComparisonKey(C,r)===this.getComparisonKey(y,r)}getComparisonKey(C,y=!1){return C.with({path:this.a(C)?C.path.toLowerCase():void 0,fragment:y?null:void 0}).toString()}ignorePathCasing(C){return this.a(C)}isEqualOrParent(C,y,r=!1){if(C.scheme===y.scheme){if(C.scheme===M.Schemas.file)return D.$Ke(E(C),E(y),this.a(C))&&C.query===y.query&&(r||C.fragment===y.fragment);if((0,e.$lg)(C.authority,y.authority))return D.$Ke(C.path,y.path,this.a(C),"/")&&C.query===y.query&&(r||C.fragment===y.fragment)}return!1}joinPath(C,...y){return g.URI.joinPath(C,...y)}basenameOrAuthority(C){return(0,e.$dg)(C)||C.authority}basename(C){return h.$8c.basename(C.path)}extname(C){return h.$8c.extname(C.path)}dirname(C){if(C.path.length===0)return C;let y;return C.scheme===M.Schemas.file?y=g.URI.file(h.$bd(E(C))).path:(y=h.$8c.dirname(C.path),C.authority&&y.length&&y.charCodeAt(0)!==47&&(console.error(`dirname("${C.toString})) resulted in a relative path`),y="/")),C.with({path:y})}normalizePath(C){if(!C.path.length)return C;let y;return C.scheme===M.Schemas.file?y=g.URI.file(h.$9c(E(C))).path:y=h.$8c.normalize(C.path),C.with({path:y})}relativePath(C,y){if(C.scheme!==y.scheme||!(0,e.$lg)(C.authority,y.authority))return;if(C.scheme===M.Schemas.file){const a=h.$ad(E(C),E(y));return R.$i?D.$Ee(a):a}let r=C.path||"/";const i=y.path||"/";if(this.a(C)){let a=0;for(const m=Math.min(r.length,i.length);a<m&&!(r.charCodeAt(a)!==i.charCodeAt(a)&&r.charAt(a).toLowerCase()!==i.charAt(a).toLowerCase());a++);r=i.substr(0,a)+r.substr(a)}return h.$8c.relative(r,i)}resolvePath(C,y){if(C.scheme===M.Schemas.file){const r=g.URI.file(h.$_c(E(C),y));return C.with({authority:r.authority,path:r.path})}return y=D.$Fe(y),C.with({path:h.$8c.resolve(C.path,y)})}isAbsolutePath(C){return!!C.path&&C.path[0]==="/"}isEqualAuthority(C,y){return C===y||C!==void 0&&y!==void 0&&(0,A.$Od)(C,y)}hasTrailingPathSeparator(C,y=h.sep){if(C.scheme===M.Schemas.file){const r=E(C);return r.length>D.$Ge(r).length&&r[r.length-1]===y}else{const r=C.path;return r.length>1&&r.charCodeAt(r.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(C.fsPath)}}removeTrailingPathSeparator(C,y=h.sep){return(0,e.$mg)(C,y)?C.with({path:C.path.substr(0,C.path.length-1)}):C}addTrailingPathSeparator(C,y=h.sep){let r=!1;if(C.scheme===M.Schemas.file){const i=E(C);r=i!==void 0&&i.length===D.$Ge(i).length&&i[i.length-1]===y}else{y="/";const i=C.path;r=i.length===1&&i.charCodeAt(i.length-1)===47}return!r&&!(0,e.$mg)(C,y)?C.with({path:C.path+"/"}):C}}e.$8f=$,e.$9f=new $(()=>!1),e.$0f=new $(S=>S.scheme===M.Schemas.file?!R.$k:!0),e.$$f=new $(S=>!0),e.$_f=e.$9f.isEqual.bind(e.$9f),e.$ag=e.$9f.isEqualOrParent.bind(e.$9f),e.$bg=e.$9f.getComparisonKey.bind(e.$9f),e.$cg=e.$9f.basenameOrAuthority.bind(e.$9f),e.$dg=e.$9f.basename.bind(e.$9f),e.$eg=e.$9f.extname.bind(e.$9f),e.$fg=e.$9f.dirname.bind(e.$9f),e.$gg=e.$9f.joinPath.bind(e.$9f),e.$hg=e.$9f.normalizePath.bind(e.$9f),e.$ig=e.$9f.relativePath.bind(e.$9f),e.$jg=e.$9f.resolvePath.bind(e.$9f),e.$kg=e.$9f.isAbsolutePath.bind(e.$9f),e.$lg=e.$9f.isEqualAuthority.bind(e.$9f),e.$mg=e.$9f.hasTrailingPathSeparator.bind(e.$9f),e.$ng=e.$9f.removeTrailingPathSeparator.bind(e.$9f),e.$og=e.$9f.addTrailingPathSeparator.bind(e.$9f);function P(S,C){const y=[];for(let r=0;r<S.length;r++){const i=C(S[r]);S.some((a,m)=>m===r?!1:(0,e.$ag)(i,C(a)))||y.push(S[r])}return y}e.$pg=P;var I;(function(S){S.META_DATA_LABEL="label",S.META_DATA_DESCRIPTION="description",S.META_DATA_SIZE="size",S.META_DATA_MIME="mime";function C(y){const r=new Map;y.path.substring(y.path.indexOf(";")+1,y.path.lastIndexOf(";")).split(";").forEach(m=>{const[p,f]=m.split(":");p&&f&&r.set(p,f)});const a=y.path.substring(0,y.path.indexOf(";"));return a&&r.set(S.META_DATA_MIME,a),r}S.parseMetaData=C})(I||(e.DataUri=I={}));function b(S,C,y){if(C){let r=S.path;return r&&r[0]!==h.$8c.sep&&(r=h.$8c.sep+r),S.with({scheme:y,authority:C,path:r})}return S.with({scheme:y})}e.$qg=b}),define(De[13],Ce([1,0,22,8,4,3,24,9,158]),function($e,e,D,M,h,R,A,g,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3g=e.$2g=e.$1g=e.Promises=e.$Zg=e.$Yg=e.$Xg=e.$Wg=e.$Vg=e.$Ug=e.$Tg=e.$Sg=e.$Rg=e.$Qg=e.$Pg=e.$Og=e.$Ng=e.$Mg=e.$Lg=e.$Kg=e.$Jg=e.$Ig=e.$Hg=e.$Gg=e.$Fg=e.$Eg=e.$Dg=e.$Cg=e.$Bg=e.$Ag=e.$zg=e.$yg=e.$xg=e.$wg=e.$vg=e.$ug=e.$tg=e.$sg=e.$rg=void 0;function $(z){return!!z&&typeof z.then=="function"}e.$rg=$;function P(z){const V=new D.$rc,G=z(V.token),ae=new Promise((ne,he)=>{const Ee=V.token.onCancellationRequested(()=>{Ee.dispose(),V.dispose(),he(new M.$3)});Promise.resolve(G).then(de=>{Ee.dispose(),V.dispose(),ne(de)},de=>{Ee.dispose(),V.dispose(),he(de)})});return new class{cancel(){V.cancel()}then(ne,he){return ae.then(ne,he)}catch(ne){return this.then(void 0,ne)}finally(ne){return ae.finally(ne)}}}e.$sg=P;function I(z,V,G){return new Promise((ae,ne)=>{const he=V.onCancellationRequested(()=>{he.dispose(),ae(G)});z.then(ae,ne).finally(()=>he.dispose())})}e.$tg=I;function b(z,V){return new Promise((G,ae)=>{const ne=V.onCancellationRequested(()=>{ne.dispose(),ae(new M.$3)});z.then(G,ae).finally(()=>ne.dispose())})}e.$ug=b;async function S(z){let V=-1;const G=z.map((ae,ne)=>ae.then(he=>(V=ne,he)));try{return await Promise.race(G)}finally{z.forEach((ae,ne)=>{ne!==V&&ae.cancel()})}}e.$vg=S;function C(z,V,G){let ae;const ne=setTimeout(()=>{ae?.(void 0),G?.()},V);return Promise.race([z.finally(()=>clearTimeout(ne)),new Promise(he=>ae=he)])}e.$wg=C;function y(z){return new Promise((V,G)=>{const ae=z();$(ae)?ae.then(V,G):V(ae)})}e.$xg=y;class r{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(V){if(this.f)throw new Error("Throttler is disposed");if(this.a){if(this.d=V,!this.b){const G=()=>{if(this.b=null,this.f)return;const ae=this.queue(this.d);return this.d=null,ae};this.b=new Promise(ae=>{this.a.then(G,G).then(ae)})}return new Promise((G,ae)=>{this.b.then(G,ae)})}return this.a=V(),new Promise((G,ae)=>{this.a.then(ne=>{this.a=null,G(ne)},ne=>{this.a=null,ae(ne)})})}dispose(){this.f=!0}}e.$yg=r;class i{constructor(){this.a=Promise.resolve(null)}queue(V){return this.a=this.a.then(()=>V(),()=>V())}}e.$zg=i;class a{constructor(){this.a=new Map}queue(V,G){const ne=(this.a.get(V)??Promise.resolve()).catch(()=>{}).then(G).finally(()=>{this.a.get(V)===ne&&this.a.delete(V)});return this.a.set(V,ne),ne}}e.$Ag=a;const m=(z,V)=>{let G=!0;const ae=setTimeout(()=>{G=!1,V()},z);return{isTriggered:()=>G,dispose:()=>{clearTimeout(ae),G=!1}}},p=z=>{let V=!0;return queueMicrotask(()=>{V&&(V=!1,z())}),{isTriggered:()=>V,dispose:()=>{V=!1}}};class f{constructor(V){this.defaultDelay=V,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(V,G=this.defaultDelay){this.g=V,this.h(),this.b||(this.b=new Promise((ne,he)=>{this.d=ne,this.f=he}).then(()=>{if(this.b=null,this.d=null,this.g){const ne=this.g;return this.g=null,ne()}}));const ae=()=>{this.a=null,this.d?.(null)};return this.a=G===E.$ec?p(ae):m(G,ae),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new M.$3),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$Bg=f;class t{constructor(V){this.a=new f(V),this.b=new r}trigger(V,G){return this.a.trigger(()=>this.b.queue(V),G)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$Cg=t;class s{constructor(){this.a=!1,this.b=new Promise((V,G)=>{this.d=V})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$Dg=s;class o extends s{constructor(V){super(),this.f=setTimeout(()=>this.open(),V)}open(){clearTimeout(this.f),super.open()}}e.$Eg=o;function n(z,V){return V?new Promise((G,ae)=>{const ne=setTimeout(()=>{he.dispose(),G()},z),he=V.onCancellationRequested(()=>{clearTimeout(ne),he.dispose(),ae(new M.$3)})}):P(G=>n(z,G))}e.$Fg=n;function c(z,V=0){const G=setTimeout(z,V);return(0,R.$kb)(()=>clearTimeout(G))}e.$Gg=c;function d(z){const V=[];let G=0;const ae=z.length;function ne(){return G<ae?z[G++]():null}function he(Ee){Ee!=null&&V.push(Ee);const de=ne();return de?de.then(he):Promise.resolve(V)}return Promise.resolve(null).then(he)}e.$Hg=d;function v(z,V=ae=>!!ae,G=null){let ae=0;const ne=z.length,he=()=>{if(ae>=ne)return Promise.resolve(G);const Ee=z[ae++];return Promise.resolve(Ee()).then(ge=>V(ge)?Promise.resolve(ge):he())};return he()}e.$Ig=v;function k(z,V=ae=>!!ae,G=null){if(z.length===0)return Promise.resolve(G);let ae=z.length;const ne=()=>{ae=-1;for(const he of z)he.cancel?.()};return new Promise((he,Ee)=>{for(const de of z)de.then(ge=>{--ae>=0&&V(ge)?(ne(),he(ge)):ae===0&&he(G)}).catch(ge=>{--ae>=0&&(ne(),Ee(ge))})})}e.$Jg=k;class u{constructor(V){this.a=0,this.d=V,this.f=[],this.b=0,this.g=new h.$hc}get onDrained(){return this.g.event}get size(){return this.a}queue(V){return this.a++,new Promise((G,ae)=>{this.f.push({factory:V,c:G,e:ae}),this.h()})}h(){for(;this.f.length&&this.b<this.d;){const V=this.f.shift();this.b++;const G=V.factory();G.then(V.c,V.e),G.then(()=>this.j(),()=>this.j())}}j(){this.a--,this.b--,this.f.length>0?this.h():this.g.fire()}dispose(){this.g.dispose()}}e.$Kg=u;class l extends u{constructor(){super(1)}}e.$Lg=l;class w{constructor(){this.a=new me,this.b=0}queue(V){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,V())):this.a.run(this.b++,V())}}e.$Mg=w;class L{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const V=new q;return this.b.add(V),V.p}g(){for(const[,V]of this.a)if(V.size>0)return!1;return!0}queueFor(V,G=A.$9f){const ae=G.getComparisonKey(V);let ne=this.a.get(ae);if(!ne){ne=new l;const he=this.f++,Ee=h.Event.once(ne.onDrained)(()=>{ne?.dispose(),this.a.delete(ae),this.h(),this.d?.deleteAndDispose(he),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new R.$ub),this.d.set(he,Ee),this.a.set(ae,ne)}return ne}h(){this.g()&&this.j()}j(){for(const V of this.b)V.complete();this.b.clear()}dispose(){for(const[,V]of this.a)V.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$Ng=L;class N{constructor(V,G){this.a=-1,typeof V=="function"&&typeof G=="number"&&this.setIfNotSet(V,G)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(V,G){this.cancel(),this.a=setTimeout(()=>{this.a=-1,V()},G)}setIfNotSet(V,G){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,V()},G))}}e.$Og=N;class j{constructor(){this.a=-1}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearInterval(this.a),this.a=-1)}cancelAndSet(V,G){this.cancel(),this.a=setInterval(()=>{V()},G)}}e.$Pg=j;class T{constructor(V,G){this.b=-1,this.a=V,this.d=G,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(V=this.d){this.cancel(),this.b=setTimeout(this.f,V)}get delay(){return this.d}set delay(V){this.d=V}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$Qg=T;class O{constructor(V,G){G%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${G}ms is not a multiple of 1000ms.`),this.a=V,this.b=G,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(V=this.b){V%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${V}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(V/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$Rg=O;class B extends T{constructor(V,G){super(V,G),this.j=[]}work(V){this.j.push(V),this.isScheduled()||this.schedule()}h(){const V=this.j;this.j=[],this.a?.(V)}dispose(){this.j=[],super.dispose()}}e.$Sg=B;class F extends R.$mb{constructor(V,G){super(),this.g=V,this.h=G,this.a=[],this.b=this.B(new R.$nb),this.f=!1}get pending(){return this.a.length}work(V){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+V.length>this.g.maxBufferedWork)return!1}else if(this.pending+V.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const G of V)this.a.push(G);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new T(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$Tg=F,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.$Ug=z=>{(0,g.$A)(()=>{if(V)return;const G=Date.now()+15;z(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,G-Date.now())}}))});let V=!1;return{dispose(){V||(V=!0)}}}:e.$Ug=(z,V)=>{const G=requestIdleCallback(z,typeof V=="number"?{timeout:V}:void 0);let ae=!1;return{dispose(){ae||(ae=!0,cancelIdleCallback(G))}}}}();class J{constructor(V){this.d=!1,this.a=()=>{try{this.f=V()}catch(G){this.g=G}finally{this.d=!0}},this.b=(0,e.$Ug)(()=>this.a())}dispose(){this.b.dispose()}get value(){if(this.d||(this.b.dispose(),this.a()),this.g)throw this.g;return this.f}get isInitialized(){return this.d}}e.$Vg=J;async function K(z,V,G){let ae;for(let ne=0;ne<G;ne++)try{return await z()}catch(he){ae=he,await n(V)}throw ae}e.$Wg=K;class me{isRunning(V){return typeof V=="number"?this.a?.taskId===V:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(V,G,ae){return this.a={taskId:V,cancel:()=>ae?.(),promise:G},G.then(()=>this.d(V),()=>this.d(V)),G}d(V){this.a&&V===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const V=this.b;this.b=void 0,V.run().then(V.promiseResolve,V.promiseReject)}}queue(V){if(this.b)this.b.run=V;else{let G,ae;const ne=new Promise((he,Ee)=>{G=he,ae=Ee});this.b={run:V,promise:ne,promiseResolve:G,promiseReject:ae}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$Xg=me;class re{constructor(V,G=()=>Date.now()){this.d=V,this.f=G,this.a=0,this.b=0}increment(){const V=this.f();return V-this.a>this.d&&(this.a=V,this.b=0),this.b++,this.b}}e.$Yg=re;var x;(function(z){z[z.Resolved=0]="Resolved",z[z.Rejected=1]="Rejected"})(x||(x={}));class q{get isRejected(){return this.d?.outcome===1}get isResolved(){return this.d?.outcome===0}get isSettled(){return!!this.d}get value(){return this.d?.outcome===0?this.d?.value:void 0}constructor(){this.p=new Promise((V,G)=>{this.a=V,this.b=G})}complete(V){return new Promise(G=>{this.a(V),this.d={outcome:0,value:V},G()})}error(V){return new Promise(G=>{this.b(V),this.d={outcome:1,value:V},G()})}cancel(){return this.error(new M.$3)}}e.$Zg=q;var ee;(function(z){async function V(ae){let ne;const he=await Promise.all(ae.map(Ee=>Ee.then(de=>de,de=>{ne||(ne=de)})));if(typeof ne<"u")throw ne;return he}z.settled=V;function G(ae){return new Promise(async(ne,he)=>{try{await ae(ne,he)}catch(Ee){he(Ee)}})}z.withAsyncBody=G})(ee||(e.Promises=ee={}));var pe;(function(z){z[z.Initial=0]="Initial",z[z.DoneOK=1]="DoneOK",z[z.DoneError=2]="DoneError"})(pe||(pe={}));class ce{static fromArray(V){return new ce(G=>{G.emitMany(V)})}static fromPromise(V){return new ce(async G=>{G.emitMany(await V)})}static fromPromises(V){return new ce(async G=>{await Promise.all(V.map(async ae=>G.emitOne(await ae)))})}static merge(V){return new ce(async G=>{await Promise.all(V.map(async ae=>{for await(const ne of ae)G.emitOne(ne)}))})}static{this.EMPTY=ce.fromArray([])}constructor(V){this.a=0,this.b=[],this.d=null,this.f=new h.$hc,queueMicrotask(async()=>{const G={emitOne:ae=>this.g(ae),emitMany:ae=>this.h(ae),reject:ae=>this.k(ae)};try{await Promise.resolve(V(G)),this.j()}catch(ae){this.k(ae)}finally{G.emitOne=void 0,G.emitMany=void 0,G.reject=void 0}})}[Symbol.asyncIterator](){let V=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(V<this.b.length)return{done:!1,value:this.b[V++]};if(this.a===1)return{done:!0,value:void 0};await h.Event.toPromise(this.f.event)}while(!0)}}}static map(V,G){return new ce(async ae=>{for await(const ne of V)ae.emitOne(G(ne))})}map(V){return ce.map(this,V)}static filter(V,G){return new ce(async ae=>{for await(const ne of V)G(ne)&&ae.emitOne(ne)})}filter(V){return ce.filter(this,V)}static coalesce(V){return ce.filter(V,G=>!!G)}coalesce(){return ce.coalesce(this)}static async toPromise(V){const G=[];for await(const ae of V)G.push(ae);return G}toPromise(){return ce.toPromise(this)}g(V){this.a===0&&(this.b.push(V),this.f.fire())}h(V){this.a===0&&(this.b=this.b.concat(V),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(V){this.a===0&&(this.a=2,this.d=V,this.f.fire())}}e.$1g=ce;class _ extends ce{constructor(V,G){super(G),this.l=V}cancel(){this.l.cancel()}}e.$2g=_;function Q(z){const V=new D.$rc,G=z(V.token);return new _(V,async ae=>{const ne=V.token.onCancellationRequested(()=>{ne.dispose(),V.dispose(),ae.reject(new M.$3)});try{for await(const he of G){if(V.token.isCancellationRequested)return;ae.emitOne(he)}ne.dispose(),V.dispose()}catch(he){ne.dispose(),V.dispose(),ae.reject(he)}})}e.$3g=Q}),define(De[35],Ce([1,0,19,13,32,28,14,9,15]),function($e,e,D,M,h,R,A,g,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tj=e.$sj=e.$rj=e.$qj=e.$pj=e.$oj=e.$nj=e.$mj=e.$lj=e.$kj=void 0;function $(){return Object.create(null)}e.$kj=$,e.$lj="**",e.$mj="/";const P="[/\\\\]",I="[^/\\\\]",b=/\//g;function S(me,re){switch(me){case 0:return"";case 1:return`${I}*?`;default:return`(?:${P}|${I}+${P}${re?`|${P}${I}+`:""})*?`}}function C(me,re){if(!me)return[];const x=[];let q=!1,ee=!1,pe="";for(const ce of me){switch(ce){case re:if(!q&&!ee){x.push(pe),pe="";continue}break;case"{":q=!0;break;case"}":q=!1;break;case"[":ee=!0;break;case"]":ee=!1;break}pe+=ce}return pe&&x.push(pe),x}e.$nj=C;function y(me){if(!me)return"";let re="";const x=C(me,e.$mj);if(x.every(q=>q===e.$lj))re=".*";else{let q=!1;x.forEach((ee,pe)=>{if(ee===e.$lj){if(q)return;re+=S(2,pe===x.length-1)}else{let ce=!1,_="",Q=!1,z="";for(const V of ee){if(V!=="}"&&ce){_+=V;continue}if(Q&&(V!=="]"||!z)){let G;V==="-"?G=V:(V==="^"||V==="!")&&!z?G="^":V===e.$mj?G="":G=(0,E.$sd)(V),z+=G;continue}switch(V){case"{":ce=!0;continue;case"[":Q=!0;continue;case"}":{const ae=`(?:${C(_,",").map(ne=>y(ne)).join("|")})`;re+=ae,ce=!1,_="";break}case"]":{re+="["+z+"]",Q=!1,z="";break}case"?":re+=I;continue;case"*":re+=S(1);continue;default:re+=(0,E.$sd)(V)}}pe<x.length-1&&(x[pe+1]!==e.$lj||pe+2<x.length)&&(re+=P)}q=ee===e.$lj})}return re}const r=/^\*\*\/\*\.[\w\.-]+$/,i=/^\*\*\/([\w\.-]+)\/?$/,a=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,m=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,p=/^\*\*((\/[\w\.-]+)+)\/?$/,f=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new R.$Ai(1e4),s=function(){return!1},o=function(){return null};function n(me,re){if(!me)return o;let x;typeof me!="string"?x=me.pattern:x=me,x=x.trim();const q=`${x}_${!!re.trimForExclusions}`;let ee=t.get(q);if(ee)return c(ee,me);let pe;return r.test(x)?ee=v(x.substr(4),x):(pe=i.exec(d(x,re)))?ee=k(pe[1],x):(re.trimForExclusions?m:a).test(x)?ee=u(x,re):(pe=p.exec(d(x,re)))?ee=l(pe[1].substr(1),x,!0):(pe=f.exec(d(x,re)))?ee=l(pe[1],x,!1):ee=w(x),t.set(q,ee),c(ee,me)}function c(me,re){if(typeof re=="string")return me;const x=function(q,ee){return(0,h.$Ke)(q,re.base,!g.$k)?me((0,E.$wd)(q.substr(re.base.length),A.sep),ee):null};return x.allBasenames=me.allBasenames,x.allPaths=me.allPaths,x.basenames=me.basenames,x.patterns=me.patterns,x}function d(me,re){return re.trimForExclusions&&me.endsWith("/**")?me.substr(0,me.length-2):me}function v(me,re){return function(x,q){return typeof x=="string"&&x.endsWith(me)?re:null}}function k(me,re){const x=`/${me}`,q=`\\${me}`,ee=function(ce,_){return typeof ce!="string"?null:_?_===me?re:null:ce===me||ce.endsWith(x)||ce.endsWith(q)?re:null},pe=[me];return ee.basenames=pe,ee.patterns=[re],ee.allBasenames=pe,ee}function u(me,re){const x=J(me.slice(1,-1).split(",").map(_=>n(_,re)).filter(_=>_!==o),me),q=x.length;if(!q)return o;if(q===1)return x[0];const ee=function(_,Q){for(let z=0,V=x.length;z<V;z++)if(x[z](_,Q))return me;return null},pe=x.find(_=>!!_.allBasenames);pe&&(ee.allBasenames=pe.allBasenames);const ce=x.reduce((_,Q)=>Q.allPaths?_.concat(Q.allPaths):_,[]);return ce.length&&(ee.allPaths=ce),ee}function l(me,re,x){const q=A.sep===A.$8c.sep,ee=q?me:me.replace(b,A.sep),pe=A.sep+ee,ce=A.$8c.sep+me;let _;return x?_=function(Q,z){return typeof Q=="string"&&(Q===ee||Q.endsWith(pe)||!q&&(Q===me||Q.endsWith(ce)))?re:null}:_=function(Q,z){return typeof Q=="string"&&(Q===ee||!q&&Q===me)?re:null},_.allPaths=[(x?"*/":"./")+me],_}function w(me){try{const re=new RegExp(`^${y(me)}$`);return function(x){return re.lastIndex=0,typeof x=="string"&&re.test(x)?me:null}}catch{return o}}function L(me,re,x){return!me||typeof re!="string"?!1:N(me)(re,void 0,x)}e.$oj=L;function N(me,re={}){if(!me)return s;if(typeof me=="string"||j(me)){const x=n(me,re);if(x===o)return s;const q=function(ee,pe){return!!x(ee,pe)};return x.allBasenames&&(q.allBasenames=x.allBasenames),x.allPaths&&(q.allPaths=x.allPaths),q}return B(me,re)}e.$pj=N;function j(me){const re=me;return re?typeof re.base=="string"&&typeof re.pattern=="string":!1}e.$qj=j;function T(me){return me.allBasenames||[]}e.$rj=T;function O(me){return me.allPaths||[]}e.$sj=O;function B(me,re){const x=J(Object.getOwnPropertyNames(me).map(_=>F(_,me[_],re)).filter(_=>_!==o)),q=x.length;if(!q)return o;if(!x.some(_=>!!_.requiresSiblings)){if(q===1)return x[0];const _=function(V,G){let ae;for(let ne=0,he=x.length;ne<he;ne++){const Ee=x[ne](V,G);if(typeof Ee=="string")return Ee;(0,M.$rg)(Ee)&&(ae||(ae=[]),ae.push(Ee))}return ae?(async()=>{for(const ne of ae){const he=await ne;if(typeof he=="string")return he}return null})():null},Q=x.find(V=>!!V.allBasenames);Q&&(_.allBasenames=Q.allBasenames);const z=x.reduce((V,G)=>G.allPaths?V.concat(G.allPaths):V,[]);return z.length&&(_.allPaths=z),_}const ee=function(_,Q,z){let V,G;for(let ae=0,ne=x.length;ae<ne;ae++){const he=x[ae];he.requiresSiblings&&z&&(Q||(Q=(0,A.$cd)(_)),V||(V=Q.substr(0,Q.length-(0,A.$dd)(_).length)));const Ee=he(_,Q,V,z);if(typeof Ee=="string")return Ee;(0,M.$rg)(Ee)&&(G||(G=[]),G.push(Ee))}return G?(async()=>{for(const ae of G){const ne=await ae;if(typeof ne=="string")return ne}return null})():null},pe=x.find(_=>!!_.allBasenames);pe&&(ee.allBasenames=pe.allBasenames);const ce=x.reduce((_,Q)=>Q.allPaths?_.concat(Q.allPaths):_,[]);return ce.length&&(ee.allPaths=ce),ee}function F(me,re,x){if(re===!1)return o;const q=n(me,x);if(q===o)return o;if(typeof re=="boolean")return q;if(re){const ee=re.when;if(typeof ee=="string"){const pe=(ce,_,Q,z)=>{if(!z||!q(ce,_))return null;const V=ee.replace("$(basename)",()=>Q),G=z(V);return(0,M.$rg)(G)?G.then(ae=>ae?me:null):G?me:null};return pe.requiresSiblings=!0,pe}}return q}function J(me,re){const x=me.filter(_=>!!_.basenames);if(x.length<2)return me;const q=x.reduce((_,Q)=>{const z=Q.basenames;return z?_.concat(z):_},[]);let ee;if(re){ee=[];for(let _=0,Q=q.length;_<Q;_++)ee.push(re)}else ee=x.reduce((_,Q)=>{const z=Q.patterns;return z?_.concat(z):_},[]);const pe=function(_,Q){if(typeof _!="string")return null;if(!Q){let V;for(V=_.length;V>0;V--){const G=_.charCodeAt(V-1);if(G===47||G===92)break}Q=_.substr(V)}const z=q.indexOf(Q);return z!==-1?ee[z]:null};pe.basenames=q,pe.patterns=ee,pe.allBasenames=q;const ce=me.filter(_=>!_.basenames);return ce.push(pe),ce}function K(me,re){return(0,D.$of)(me,re,(x,q)=>typeof x=="string"&&typeof q=="string"?x===q:typeof x!="string"&&typeof q!="string"?x.base===q.base&&x.pattern===q.pattern:!1)}e.$tj=K}),define(De[78],Ce([1,0,8,159,24,15,2]),function($e,e,D,M,h,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3j=e.$2j=e.$1j=e.$Zj=e.$Yj=e.$Xj=e.$Wj=e.$Vj=e.MarkdownStringTextNewlineStyle=void 0;var g;(function(r){r[r.Paragraph=0]="Paragraph",r[r.Break=1]="Break"})(g||(e.MarkdownStringTextNewlineStyle=g={}));class E{constructor(i="",a=!1){if(this.value=i,typeof this.value!="string")throw(0,D.$5)("value");typeof a=="boolean"?(this.isTrusted=a,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=a.isTrusted??void 0,this.supportThemeIcons=a.supportThemeIcons??!1,this.supportHtml=a.supportHtml??!1)}appendText(i,a=0){return this.value+=b(this.supportThemeIcons?(0,M.$Pj)(i):i).replace(/([ \t]+)/g,(m,p)=>"&nbsp;".repeat(p.length)).replace(/\>/gm,"\\>").replace(/\n/g,a===1?`\\
`:`

`),this}appendMarkdown(i){return this.value+=i,this}appendCodeblock(i,a){return this.value+="\n```",this.value+=i,this.value+=`
`,this.value+=a,this.value+="\n```\n",this}appendLink(i,a,m){return this.value+="[",this.value+=this.c(a,"]"),this.value+="](",this.value+=this.c(String(i),")"),m&&(this.value+=` "${this.c(this.c(m,'"'),")")}"`),this.value+=")",this}c(i,a){const m=new RegExp((0,R.$sd)(a),"g");return i.replace(m,(p,f)=>i.charAt(f-1)!=="\\"?`\\${p}`:p)}}e.$Vj=E;function $(r){return P(r)?!r.value:Array.isArray(r)?r.every($):!0}e.$Wj=$;function P(r){return r instanceof E?!0:r&&typeof r=="object"?typeof r.value=="string"&&(typeof r.isTrusted=="boolean"||typeof r.isTrusted=="object"||r.isTrusted===void 0)&&(typeof r.supportThemeIcons=="boolean"||r.supportThemeIcons===void 0):!1}e.$Xj=P;function I(r,i){return r===i?!0:!r||!i?!1:r.value===i.value&&r.isTrusted===i.isTrusted&&r.supportThemeIcons===i.supportThemeIcons&&r.supportHtml===i.supportHtml&&(r.baseUri===i.baseUri||!!r.baseUri&&!!i.baseUri&&(0,h.$_f)(A.URI.from(r.baseUri),A.URI.from(i.baseUri)))}e.$Yj=I;function b(r){return r.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}e.$Zj=b;function S(r){return r.replace(/"/g,"&quot;")}e.$1j=S;function C(r){return r&&r.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}e.$2j=C;function y(r){const i=[],a=r.split("|").map(p=>p.trim());r=a[0];const m=a[1];if(m){const p=/height=(\d+)/.exec(m),f=/width=(\d+)/.exec(m),t=p?p[1]:"",s=f?f[1]:"",o=isFinite(parseInt(s)),n=isFinite(parseInt(t));o&&i.push(`width="${s}"`),n&&i.push(`height="${t}"`)}return{href:r,dimensions:i}}e.$3j=y}),define(De[127],Ce([1,0,19,32,14,9,24,15]),function($e,e,D,M,h,R,A,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jA=e.$iA=e.$hA=e.$gA=e.$fA=e.$eA=e.$dA=e.$cA=e.$bA=e.$aA=void 0;function E(n,c){const{os:d,tildify:v,relative:k}=c;if(k){const w=$(n,k,d);if(typeof w=="string")return w}let u=n.fsPath;if(d===1&&!R.$i?u=u.replace(/\//g,"\\"):d!==1&&R.$i&&(u=u.replace(/\\/g,"/")),d!==1&&v?.userHome){const w=v.userHome.fsPath;let L;n.scheme!==v.userHome.scheme&&n.path.startsWith(h.$8c.sep)?L=v.userHome.with({path:n.path}).fsPath:L=n.fsPath,u=b(L,w,d)}return(d===1?h.$7c:h.$8c).normalize(P(u,d===1))}e.$aA=E;function $(n,c,d){const v=d===1?h.$7c:h.$8c,k=d===3?A.$9f:A.$$f,u=c.getWorkspace(),l=(0,D.$Hf)(u.folders);if(!l)return;n.scheme!==l.uri.scheme&&n.path.startsWith(h.$8c.sep)&&(n=l.uri.with({path:n.path}));const w=c.getWorkspaceFolder(n);if(!w)return;let L;if(k.isEqual(w.uri,n)?L="":L=k.relativePath(w.uri,n)??"",L&&(L=v.normalize(L)),u.folders.length>1&&!c.noPrefix){const N=w.name?w.name:k.basenameOrAuthority(w.uri);L=L?`${N} \u2022 ${L}`:N}return L}function P(n,c=R.$i){return(0,M.$Oe)(n,c)?n.charAt(0).toUpperCase()+n.slice(1):n}e.$bA=P;let I=Object.create(null);function b(n,c,d=R.OS){if(d===1||!n||!c)return n;let v=I.original===c?I.normalized:void 0;v||(v=c,R.$i&&(v=(0,M.$Ee)(v)),v=`${(0,g.$xd)(v,h.$8c.sep)}${h.$8c.sep}`,I={original:c,normalized:v});let k=n;return R.$i&&(k=(0,M.$Ee)(k)),(d===3?k.startsWith(v):(0,g.$Pd)(k,v))?`~/${k.substr(v.length)}`:n}e.$cA=b;function S(n,c){return n.replace(/^~($|\/|\\)/,`${c}$1`)}e.$dA=S;const C="\u2026",y="\\\\",r="~";function i(n,c=h.sep){const d=new Array(n.length);let v=!1;for(let k=0;k<n.length;k++){const u=n[k];if(u===""){d[k]=`.${c}`;continue}if(!u){d[k]=u;continue}v=!0;let l="",w=u;w.indexOf(y)===0?(l=w.substr(0,w.indexOf(y)+y.length),w=w.substr(w.indexOf(y)+y.length)):w.indexOf(c)===0?(l=w.substr(0,w.indexOf(c)+c.length),w=w.substr(w.indexOf(c)+c.length)):w.indexOf(r)===0&&(l=w.substr(0,w.indexOf(r)+r.length),w=w.substr(w.indexOf(r)+r.length));const L=w.split(c);for(let N=1;v&&N<=L.length;N++)for(let j=L.length-N;v&&j>=0;j--){v=!1;let T=L.slice(j,j+N).join(c);for(let O=0;!v&&O<n.length;O++)if(O!==k&&n[O]&&n[O].indexOf(T)>-1){const B=j+N===L.length,F=j>0&&n[O].indexOf(c)>-1?c+T:T,J=n[O].endsWith(F);v=!B||J}if(!v){let O="";(L[0].endsWith(":")||l!=="")&&(j===1&&(j=0,N++,T=L[0]+c+T),j>0&&(O=L[0]+c),O=l+O),j>0&&(O=O+C+c),O=O+T,j+N<L.length&&(O=O+c+C),d[k]=O}}v&&(d[k]=u)}return d}e.$eA=i;var a;(function(n){n[n.TEXT=0]="TEXT",n[n.VARIABLE=1]="VARIABLE",n[n.SEPARATOR=2]="SEPARATOR"})(a||(a={}));function m(n,c=Object.create(null)){const d=[];let v=!1,k="";for(const u of n)if(u==="$"||v&&u==="{")k&&d.push({value:k,type:a.TEXT}),k="",v=!0;else if(u==="}"&&v){const l=c[k];if(typeof l=="string")l.length&&d.push({value:l,type:a.VARIABLE});else if(l){const w=d[d.length-1];(!w||w.type!==a.SEPARATOR)&&d.push({value:l.label,type:a.SEPARATOR})}k="",v=!1}else k+=u;return k&&!v&&d.push({value:k,type:a.TEXT}),d.filter((u,l)=>{if(u.type===a.SEPARATOR){const w=d[l-1],L=d[l+1];return[w,L].every(N=>N&&(N.type===a.VARIABLE||N.type===a.TEXT)&&N.value.length>0)}return!0}).map(u=>u.value).join("")}e.$fA=m;function p(n,c){return R.$j||c?n.replace(/\(&&\w\)|&&/g,"").replace(/&/g,R.$j?"&":"&&"):n.replace(/&&|&/g,d=>d==="&"?"&&":"&")}e.$gA=p;function f(n,c){return R.$j||c?n.replace(/\(&&\w\)|&&/g,""):R.$i?n.replace(/&&|&/g,d=>d==="&"?"&&":"&"):n.replace(/&&/g,"_")}e.$hA=f;function t(n){return n.replace(/&/g,"&&")}e.$iA=t;function s(n){if(n.endsWith("]")){const c=n.lastIndexOf(" [",n.length-2);if(c!==-1){const d=o(n.substring(0,c));return{name:d.name,parentPath:d.parentPath+n.substring(c)}}}return o(n)}e.$jA=s;function o(n){const c=n.indexOf("/")!==-1?h.$8c:h.$7c,d=c.basename(n),v=c.dirname(n);return d.length?{name:d,parentPath:v}:{name:v,parentPath:""}}}),define(De[128],Ce([1,0,21,2]),function($e,e,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dm=e.$Cm=e.$Bm=e.$Am=e.$zm=void 0;function h(I){return I.toJSON()}class R{constructor(b){this.a=b}transformIncoming(b){const S=this.a.transformIncoming(b);return S===b?b:h(M.URI.from(S))}transformOutgoing(b){const S=this.a.transformOutgoing(b);return S===b?b:h(M.URI.from(S))}transformOutgoingURI(b){const S=this.a.transformOutgoing(b);return S===b?b:M.URI.from(S)}transformOutgoingScheme(b){return this.a.transformOutgoingScheme(b)}}e.$zm=R,e.$Am=new class{transformIncoming(I){return I}transformOutgoing(I){return I}transformOutgoingURI(I){return I}transformOutgoingScheme(I){return I}};function A(I,b,S){if(!I||S>200)return null;if(typeof I=="object"){if(I instanceof M.URI)return b.transformOutgoing(I);for(const C in I)if(Object.hasOwnProperty.call(I,C)){const y=A(I[C],b,S+1);y!==null&&(I[C]=y)}}return null}function g(I,b){const S=A(I,b,0);return S===null?I:S}e.$Bm=g;function E(I,b,S,C){if(!I||C>200)return null;if(typeof I=="object"){if(I.$mid===1)return S?M.URI.revive(b.transformIncoming(I)):b.transformIncoming(I);if(I instanceof D.$Hc)return null;for(const y in I)if(Object.hasOwnProperty.call(I,y)){const r=E(I[y],b,S,C+1);r!==null&&(I[y]=r)}}return null}function $(I,b){const S=E(I,b,!1,0);return S===null?I:S}e.$Cm=$;function P(I,b){const S=E(I,b,!0,0);return S===null?I:S}e.$Dm=P}),define(De[29],Ce([1,0,49,59,361,13,32,73,14,9,24,2]),function($e,e,D,M,h,R,A,g,E,$,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.configureFlushOnWrite=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var b;(function(F){F[F.UNLINK=0]="UNLINK",F[F.MOVE=1]="MOVE"})(b||(e.RimRafMode=b={}));async function S(F,J=b.UNLINK,K){if((0,A.$Ne)(F))throw new Error("rimraf - will refuse to recursively delete root");return J===b.UNLINK?y(F):C(F,K)}async function C(F,J=(0,A.$Se)((0,M.tmpdir)())){try{try{await D.promises.rename(F,J)}catch(K){return K.code==="ENOENT"?void 0:y(F)}y(J).catch(K=>{})}catch(K){if(K.code!=="ENOENT")throw K}}async function y(F){return(0,h.promisify)(D.rm)(F,{recursive:!0,force:!0,maxRetries:3})}function r(F){if((0,A.$Ne)(F))throw new Error("rimraf - will refuse to recursively delete root");D.rmSync(F,{recursive:!0,force:!0,maxRetries:3})}e.rimrafSync=r;async function i(F,J){return p(await(J?a(F):(0,h.promisify)(D.readdir)(F)))}async function a(F){try{return await(0,h.promisify)(D.readdir)(F,{withFileTypes:!0})}catch(me){console.warn("[node.js fs] readdir with filetypes failed with error: ",me)}const J=[],K=await i(F);for(const me of K){let re=!1,x=!1,q=!1;try{const ee=await e.Promises.lstat((0,E.$$c)(F,me));re=ee.isFile(),x=ee.isDirectory(),q=ee.isSymbolicLink()}catch(ee){console.warn("[node.js fs] unexpected error from lstat after readdir: ",ee)}J.push({name:me,isFile:()=>re,isDirectory:()=>x,isSymbolicLink:()=>q})}return J}function m(F){return p(D.readdirSync(F))}e.readdirSync=m;function p(F){return F.map(J=>typeof J=="string"?$.$j?(0,g.$fl)(J):J:(J.name=$.$j?(0,g.$fl)(J.name):J.name,J))}async function f(F){const J=await i(F),K=[];for(const me of J)await s.existsDirectory((0,E.$$c)(F,me))&&K.push(me);return K}function t(F,J=1e3){return new Promise(K=>{let me=!1;const re=setInterval(()=>{me||(me=!0,D.access(F,x=>{me=!1,x&&(clearInterval(re),K(void 0))}))},J)})}e.whenDeleted=t;var s;(function(F){async function J(re){let x;try{if(x=await e.Promises.lstat(re),!x.isSymbolicLink())return{stat:x}}catch{}try{return{stat:await e.Promises.stat(re),symbolicLink:x?.isSymbolicLink()?{dangling:!1}:void 0}}catch(q){if(q.code==="ENOENT"&&x)return{stat:x,symbolicLink:{dangling:!0}};if($.$i&&q.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(re)),symbolicLink:{dangling:!1}}}catch(ee){if(ee.code==="ENOENT"&&x)return{stat:x,symbolicLink:{dangling:!0}};throw ee}throw q}}F.stat=J;async function K(re){try{const{stat:x,symbolicLink:q}=await F.stat(re);return x.isFile()&&q?.dangling!==!0}catch{}return!1}F.existsFile=K;async function me(re){try{const{stat:x,symbolicLink:q}=await F.stat(re);return x.isDirectory()&&q?.dangling!==!0}catch{}return!1}F.existsDirectory=me})(s||(e.SymlinkSupport=s={}));const o=new R.$Ng;function n(F,J,K){return o.queueFor(I.URI.file(F),P.$0f).queue(()=>{const me=u(K);return new Promise((re,x)=>v(F,J,me,q=>q?x(q):re()))})}let c=!0;function d(F){c=F}e.configureFlushOnWrite=d;function v(F,J,K,me){if(!c)return D.writeFile(F,J,{mode:K.mode,flag:K.flag},me);D.open(F,K.flag,K.mode,(re,x)=>{if(re)return me(re);D.writeFile(x,J,q=>{if(q)return D.close(x,()=>me(q));D.fdatasync(x,ee=>(ee&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",ee),d(!1)),D.close(x,pe=>me(pe))))})})}function k(F,J,K){const me=u(K);if(!c)return D.writeFileSync(F,J,{mode:me.mode,flag:me.flag});const re=D.openSync(F,me.flag,me.mode);try{D.writeFileSync(re,J);try{D.fdatasyncSync(re)}catch(x){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",x),d(!1)}}finally{D.closeSync(re)}}e.writeFileSync=k;function u(F){return F?{mode:typeof F.mode=="number"?F.mode:438,flag:typeof F.flag=="string"?F.flag:"w"}:{mode:438,flag:"w"}}async function l(F,J,K=6e4){if(F!==J)try{$.$i&&typeof K=="number"?await w(F,J,Date.now(),K):await(0,h.promisify)(D.rename)(F,J)}catch(me){if(F.toLowerCase()!==J.toLowerCase()&&me.code==="EXDEV"||F.endsWith("."))await L(F,J,{preserveSymlinks:!1}),await S(F,b.MOVE);else throw me}}async function w(F,J,K,me,re=0){try{return await(0,h.promisify)(D.rename)(F,J)}catch(x){if(x.code!=="EACCES"&&x.code!=="EPERM"&&x.code!=="EBUSY")throw x;if(Date.now()-K>=me)throw console.error(`[node.js fs] rename failed after ${re} retries with error: ${x}`),x;if(re===0){let q=!1;try{const{stat:ee}=await s.stat(J);ee.isFile()||(q=!0)}catch{}if(q)throw x}return await(0,R.$Fg)(Math.min(100,re*10)),w(F,J,K,me,re+1)}}async function L(F,J,K){return j(F,J,{root:{source:F,target:J},options:K,handledSourcePaths:new Set})}const N=511;async function j(F,J,K){if(K.handledSourcePaths.has(F))return;K.handledSourcePaths.add(F);const{stat:me,symbolicLink:re}=await s.stat(F);if(re){if(K.options.preserveSymlinks)try{return await B(F,J,K)}catch(x){console.warn("[node.js fs] copy of symlink failed: ",x)}if(re.dangling)return}return me.isDirectory()?T(F,J,me.mode&N,K):O(F,J,me.mode&N)}async function T(F,J,K,me){await e.Promises.mkdir(J,{recursive:!0,mode:K});const re=await i(F);for(const x of re)await j((0,E.$$c)(F,x),(0,E.$$c)(J,x),me)}async function O(F,J,K){await e.Promises.copyFile(F,J),await e.Promises.chmod(J,K)}async function B(F,J,K){let me=await e.Promises.readlink(F);(0,A.$Ke)(me,K.root.source,!$.$k)&&(me=(0,E.$$c)(K.root.target,me.substr(K.root.source.length+1))),await e.Promises.symlink(me,J)}e.Promises=new class{get access(){return(0,h.promisify)(D.access)}get stat(){return(0,h.promisify)(D.stat)}get lstat(){return(0,h.promisify)(D.lstat)}get utimes(){return(0,h.promisify)(D.utimes)}get read(){return(F,J,K,me,re)=>new Promise((x,q)=>{D.read(F,J,K,me,re,(ee,pe,ce)=>ee?q(ee):x({bytesRead:pe,buffer:ce}))})}get readFile(){return(0,h.promisify)(D.readFile)}get write(){return(F,J,K,me,re)=>new Promise((x,q)=>{D.write(F,J,K,me,re,(ee,pe,ce)=>ee?q(ee):x({bytesWritten:pe,buffer:ce}))})}get appendFile(){return(0,h.promisify)(D.appendFile)}get fdatasync(){return(0,h.promisify)(D.fdatasync)}get truncate(){return(0,h.promisify)(D.truncate)}get copyFile(){return(0,h.promisify)(D.copyFile)}get open(){return(0,h.promisify)(D.open)}get close(){return(0,h.promisify)(D.close)}get symlink(){return(0,h.promisify)(D.symlink)}get readlink(){return(0,h.promisify)(D.readlink)}get chmod(){return(0,h.promisify)(D.chmod)}get mkdir(){return(0,h.promisify)(D.mkdir)}get unlink(){return(0,h.promisify)(D.unlink)}get rmdir(){return(0,h.promisify)(D.rmdir)}get realpath(){return(0,h.promisify)(D.realpath)}async exists(F){try{return await e.Promises.access(F),!0}catch{return!1}}get readdir(){return i}get readDirsInDir(){return f}get writeFile(){return n}get rm(){return S}get rename(){return l}get copy(){return L}}}),define(De[99],Ce([1,0,49,14,9,15,29]),function($e,e,D,M,h,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Up=e.$Tp=e.$Sp=e.$Rp=void 0;function g(b){if(h.$k)return b;const S=(0,M.$bd)(b);if(b===S)return b;const C=((0,M.$cd)(b)||b).toLowerCase();try{const r=(0,A.readdirSync)(S).filter(i=>i.toLowerCase()===C);if(r.length===1){const i=g(S);if(i)return(0,M.$$c)(i,r[0])}else if(r.length>1){const i=r.indexOf(C);if(i>=0){const a=g(S);if(a)return(0,M.$$c)(a,r[i])}}}catch{}return null}e.$Rp=g;async function E(b){if(h.$k)return b;const S=(0,M.$bd)(b);if(b===S)return b;const C=((0,M.$cd)(b)||b).toLowerCase();try{const r=(await A.Promises.readdir(S)).filter(i=>i.toLowerCase()===C);if(r.length===1){const i=await E(S);if(i)return(0,M.$$c)(i,r[0])}else if(r.length>1){const i=r.indexOf(C);if(i>=0){const a=await E(S);if(a)return(0,M.$$c)(a,r[i])}}}catch{}return null}e.$Sp=E;async function $(b){try{return await A.Promises.realpath(b)}catch{const C=I(b);return await A.Promises.access(C,D.constants.R_OK),C}}e.$Tp=$;function P(b){try{return D.realpathSync(b)}catch{const C=I(b);return D.accessSync(C,D.constants.R_OK),C}}e.$Up=P;function I(b){return(0,R.$xd)((0,M.$9c)(b),M.sep)}}),define(De[100],Ce([1,0,14,9,45,98,18,29]),function($e,e,D,M,h,R,A,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.$tl=e.$sl=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return R.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return R.TerminateResponseCode}});function E(I=h.env){return I.comspec||"cmd.exe"}e.$sl=E;function $(I){let b=[],S=!1;const C=function(y){if(S){b.push(y);return}(!I.send(y,i=>{if(i&&console.error(i),S=!1,b.length>0){const a=b.slice(0);b=[],a.forEach(m=>C(m))}})||M.$i)&&(S=!0)};return{send:C}}e.$tl=$;var P;(function(I){async function b(S,C,y){if(D.$0c(S))return S;if(C===void 0&&(C=h.cwd()),D.$bd(S)!=="."||(y===void 0&&A.$le(h.env.PATH)&&(y=h.env.PATH.split(D.$id)),y===void 0||y.length===0))return D.$$c(C,S);async function i(a){if(await g.Promises.exists(a)){let m;try{m=await g.Promises.stat(a)}catch(p){p.message.startsWith("EACCES")&&(m=await g.Promises.lstat(a))}return m?!m.isDirectory():!1}return!1}for(const a of y){let m;if(D.$0c(a)?m=D.$$c(a,S):m=D.$$c(C,a,S),await i(m))return m;let p=m+".com";if(await i(p)||(p=m+".exe",await i(p)))return p}return D.$$c(C,S)}I.findExecutable=b})(P||(e.win32=P={}))});var Ke=this&&this.__decorate||function($e,e,D,M){var h=arguments.length,R=h<3?e:M===null?M=Object.getOwnPropertyDescriptor(e,D):M,A;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")R=Reflect.decorate($e,e,D,M);else for(var g=$e.length-1;g>=0;g--)(A=$e[g])&&(R=(h<3?A(R):h>3?A(e,D,R):A(e,D))||R);return h>3&&R&&Object.defineProperty(e,D,R),R};define(De[79],Ce([1,0,19,13,21,22,70,8,4,3,77,15,18]),function($e,e,D,M,h,R,A,g,E,$,P,I,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ih=e.ProxyChannel=e.$hh=e.$gh=e.$fh=e.$eh=e.$dh=e.$ch=e.RequestInitiator=e.$bh=e.$ah=e.$_g=e.$$g=e.$0g=void 0;var S;(function(re){re[re.Promise=100]="Promise",re[re.PromiseCancel=101]="PromiseCancel",re[re.EventListen=102]="EventListen",re[re.EventDispose=103]="EventDispose"})(S||(S={}));function C(re){switch(re){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var y;(function(re){re[re.Initialize=200]="Initialize",re[re.PromiseSuccess=201]="PromiseSuccess",re[re.PromiseError=202]="PromiseError",re[re.PromiseErrorObj=203]="PromiseErrorObj",re[re.EventFire=204]="EventFire"})(y||(y={}));function r(re){switch(re){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var i;(function(re){re[re.Uninitialized=0]="Uninitialized",re[re.Idle=1]="Idle"})(i||(i={}));function a(re){let x=0;for(let q=0;;q+=7){const ee=re.read(1);if(x|=(ee.buffer[0]&127)<<q,!(ee.buffer[0]&128))return x}}const m=o(0);function p(re,x){if(x===0){re.write(m);return}let q=0;for(let pe=x;pe!==0;pe=pe>>>7)q++;const ee=h.$Hc.alloc(q);for(let pe=0;x!==0;pe++)ee.buffer[pe]=x&127,x=x>>>7,x>0&&(ee.buffer[pe]|=128);re.write(ee)}class f{constructor(x){this.b=x,this.a=0}read(x){const q=this.b.slice(this.a,this.a+x);return this.a+=q.byteLength,q}}e.$0g=f;class t{constructor(){this.a=[]}get buffer(){return h.$Hc.concat(this.a)}write(x){this.a.push(x)}}e.$$g=t;var s;(function(re){re[re.Undefined=0]="Undefined",re[re.String=1]="String",re[re.Buffer=2]="Buffer",re[re.VSBuffer=3]="VSBuffer",re[re.Array=4]="Array",re[re.Object=5]="Object",re[re.Int=6]="Int"})(s||(s={}));function o(re){const x=h.$Hc.alloc(1);return x.writeUInt8(re,0),x}const n={Undefined:o(s.Undefined),String:o(s.String),Buffer:o(s.Buffer),VSBuffer:o(s.VSBuffer),Array:o(s.Array),Object:o(s.Object),Uint:o(s.Int)},c=typeof Buffer<"u";function d(re,x){if(typeof x>"u")re.write(n.Undefined);else if(typeof x=="string"){const q=h.$Hc.fromString(x);re.write(n.String),p(re,q.byteLength),re.write(q)}else if(c&&Buffer.isBuffer(x)){const q=h.$Hc.wrap(x);re.write(n.Buffer),p(re,q.byteLength),re.write(q)}else if(x instanceof h.$Hc)re.write(n.VSBuffer),p(re,x.byteLength),re.write(x);else if(Array.isArray(x)){re.write(n.Array),p(re,x.length);for(const q of x)d(re,q)}else if(typeof x=="number"&&(x|0)===x)re.write(n.Uint),p(re,x);else{const q=h.$Hc.fromString(JSON.stringify(x));re.write(n.Object),p(re,q.byteLength),re.write(q)}}e.$_g=d;function v(re){switch(re.read(1).readUInt8(0)){case s.Undefined:return;case s.String:return re.read(a(re)).toString();case s.Buffer:return re.read(a(re)).buffer;case s.VSBuffer:return re.read(a(re));case s.Array:{const q=a(re),ee=[];for(let pe=0;pe<q;pe++)ee.push(v(re));return ee}case s.Object:return JSON.parse(re.read(a(re)).toString());case s.Int:return a(re)}}e.$ah=v;class k{constructor(x,q,ee=null,pe=1e3){this.h=x,this.j=q,this.k=ee,this.l=pe,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(ce=>this.q(ce)),this.m({type:200})}registerChannel(x,q){this.b.set(x,q),setTimeout(()=>this.w(x),0)}m(x){switch(x.type){case 200:{const q=this.o([x.type]);this.k?.logOutgoing(q,0,1,r(x.type));return}case 201:case 202:case 204:case 203:{const q=this.o([x.type,x.id],x.data);this.k?.logOutgoing(q,x.id,1,r(x.type),x.data);return}}}o(x,q=void 0){const ee=new t;return d(ee,x),d(ee,q),this.p(ee.buffer)}p(x){try{return this.h.send(x),x.byteLength}catch{return 0}}q(x){const q=new f(x),ee=v(q),pe=v(q),ce=ee[0];switch(ce){case 100:return this.k?.logIncoming(x.byteLength,ee[1],1,`${C(ce)}: ${ee[2]}.${ee[3]}`,pe),this.s({type:ce,id:ee[1],channelName:ee[2],name:ee[3],arg:pe});case 102:return this.k?.logIncoming(x.byteLength,ee[1],1,`${C(ce)}: ${ee[2]}.${ee[3]}`,pe),this.t({type:ce,id:ee[1],channelName:ee[2],name:ee[3],arg:pe});case 101:return this.k?.logIncoming(x.byteLength,ee[1],1,`${C(ce)}`),this.u({type:ce,id:ee[1]});case 103:return this.k?.logIncoming(x.byteLength,ee[1],1,`${C(ce)}`),this.u({type:ce,id:ee[1]})}}s(x){const q=this.b.get(x.channelName);if(!q){this.v(x);return}const ee=new R.$rc;let pe;try{pe=q.call(this.j,x.name,x.arg,ee.token)}catch(Q){pe=Promise.reject(Q)}const ce=x.id;pe.then(Q=>{this.m({id:ce,data:Q,type:201}),this.d.delete(x.id)},Q=>{Q instanceof Error?this.m({id:ce,data:{message:Q.message,name:Q.name,stack:Q.stack?Q.stack.split?Q.stack.split(`
`):Q.stack:void 0},type:202}):this.m({id:ce,data:Q,type:203}),this.d.delete(x.id)});const _=(0,$.$kb)(()=>ee.cancel());this.d.set(x.id,_)}t(x){const q=this.b.get(x.channelName);if(!q){this.v(x);return}const ee=x.id,ce=q.listen(this.j,x.name,x.arg)(_=>this.m({id:ee,data:_,type:204}));this.d.set(x.id,ce)}u(x){const q=this.d.get(x.id);q&&(q.dispose(),this.d.delete(x.id))}v(x){let q=this.g.get(x.channelName);q||(q=[],this.g.set(x.channelName,q));const ee=setTimeout(()=>{console.error(`Unknown channel: ${x.channelName}`),x.type===100&&this.m({id:x.id,data:{name:"Unknown channel",message:`Channel name '${x.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);q.push({request:x,timeoutTimer:ee})}w(x){const q=this.g.get(x);if(q){for(const ee of q)switch(clearTimeout(ee.timeoutTimer),ee.request.type){case 100:this.s(ee.request);break;case 102:this.t(ee.request);break}this.g.delete(x)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,$.$hb)(this.d.values()),this.d.clear()}}e.$bh=k;var u;(function(re){re[re.LocalSide=0]="LocalSide",re[re.OtherSide=1]="OtherSide"})(u||(e.RequestInitiator=u={}));class l{constructor(x,q=null){this.l=x,this.a=!1,this.b=i.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new E.$hc,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(ee=>this.s(ee)),this.j=q}getChannel(x){const q=this;return{call(ee,pe,ce){return q.a?Promise.reject(new g.$3):q.m(x,ee,pe,ce)},listen(ee,pe){return q.a?E.Event.None:q.o(x,ee,pe)}}}m(x,q,ee,pe=R.CancellationToken.None){const ce=this.g++,Q={id:ce,type:100,channelName:x,name:q,arg:ee};if(pe.isCancellationRequested)return Promise.reject(new g.$3);let z;return new Promise((G,ae)=>{if(pe.isCancellationRequested)return ae(new g.$3);const ne=()=>{const ge=ie=>{switch(ie.type){case 201:this.f.delete(ce),G(ie.data);break;case 202:{this.f.delete(ce);const ue=new Error(ie.data.message);ue.stack=Array.isArray(ie.data.stack)?ie.data.stack.join(`
`):ie.data.stack,ue.name=ie.data.name,ae(ue);break}case 203:this.f.delete(ce),ae(ie.data);break}};this.f.set(ce,ge),this.p(Q)};let he=null;this.b===i.Idle?ne():(he=(0,M.$sg)(ge=>this.u()),he.then(()=>{he=null,ne()}));const Ee=()=>{he?(he.cancel(),he=null):this.p({id:ce,type:101}),ae(new g.$3)},de=pe.onCancellationRequested(Ee);z=(0,$.$jb)((0,$.$kb)(Ee),de),this.d.add(z)}).finally(()=>{this.d.delete(z)})}o(x,q,ee){const pe=this.g++,_={id:pe,type:102,channelName:x,name:q,arg:ee};let Q=null;const z=new E.$hc({onWillAddFirstListener:()=>{Q=(0,M.$sg)(G=>this.u()),Q.then(()=>{Q=null,this.d.add(z),this.p(_)})},onDidRemoveLastListener:()=>{Q?(Q.cancel(),Q=null):(this.d.delete(z),this.p({id:pe,type:103}))}}),V=G=>z.fire(G.data);return this.f.set(pe,V),z.event}p(x){switch(x.type){case 100:case 102:{const q=this.q([x.type,x.id,x.channelName,x.name],x.arg);this.j?.logOutgoing(q,x.id,0,`${C(x.type)}: ${x.channelName}.${x.name}`,x.arg);return}case 101:case 103:{const q=this.q([x.type,x.id]);this.j?.logOutgoing(q,x.id,0,C(x.type));return}}}q(x,q=void 0){const ee=new t;return d(ee,x),d(ee,q),this.r(ee.buffer)}r(x){try{return this.l.send(x),x.byteLength}catch{return 0}}s(x){const q=new f(x),ee=v(q),pe=v(q),ce=ee[0];switch(ce){case 200:return this.j?.logIncoming(x.byteLength,0,0,r(ce)),this.t({type:ee[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(x.byteLength,ee[1],0,r(ce),pe),this.t({type:ee[0],id:ee[1],data:pe})}}t(x){if(x.type===200){this.b=i.Idle,this.k.fire();return}this.f.get(x.id)?.(x)}get onDidInitializePromise(){return E.Event.toPromise(this.onDidInitialize)}u(){return this.b===i.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,$.$hb)(this.d.values()),this.d.clear()}}e.$ch=l,Ke([A.$4g],l.prototype,"onDidInitializePromise",null);class w{get connections(){const x=[];return this.f.forEach(q=>x.push(q)),x}constructor(x){this.a=new Map,this.f=new Set,this.g=new E.$hc,this.onDidAddConnection=this.g.event,this.h=new E.$hc,this.onDidRemoveConnection=this.h.event,x(({protocol:q,onDidClientDisconnect:ee})=>{E.Event.once(q.onMessage)(ce=>{const _=new f(ce),Q=v(_),z=new k(q,Q),V=new l(q);this.a.forEach((ae,ne)=>z.registerChannel(ne,ae));const G={channelServer:z,channelClient:V,ctx:Q};this.f.add(G),this.g.fire(G),ee(()=>{z.dispose(),V.dispose(),this.f.delete(G),this.h.fire(G)})})})}getChannel(x,q){const ee=this;return{call(pe,ce,_){let Q;if((0,b.$ze)(q)){const V=(0,D.$Wf)(ee.connections.filter(q));Q=V?Promise.resolve(V):E.Event.toPromise(E.Event.filter(ee.onDidAddConnection,q))}else Q=q.routeCall(ee,pe,ce);const z=Q.then(V=>V.channelClient.getChannel(x));return N(z).call(pe,ce,_)},listen(pe,ce){if((0,b.$ze)(q))return ee.j(x,q,pe,ce);const _=q.routeEvent(ee,pe,ce).then(Q=>Q.channelClient.getChannel(x));return N(_).listen(pe,ce)}}}j(x,q,ee,pe){const ce=this;let _=new $.$lb;const Q=new E.$hc({onWillAddFirstListener:()=>{_=new $.$lb;const z=new E.$nc,V=new Map,G=ne=>{const Ee=ne.channelClient.getChannel(x).listen(ee,pe),de=z.add(Ee);V.set(ne,de)},ae=ne=>{const he=V.get(ne);he&&(he.dispose(),V.delete(ne))};ce.connections.filter(q).forEach(G),E.Event.filter(ce.onDidAddConnection,q)(G,void 0,_),ce.onDidRemoveConnection(ae,void 0,_),z.event(Q.fire,Q,_),_.add(z)},onDidRemoveLastListener:()=>{_.dispose()}});return Q.event}registerChannel(x,q){this.a.set(x,q),this.f.forEach(ee=>{ee.channelServer.registerChannel(x,q)})}dispose(){this.a.clear(),this.f.clear(),this.g.dispose(),this.h.dispose()}}e.$dh=w;class L{constructor(x,q,ee=null){const pe=new t;d(pe,q),x.send(pe.buffer),this.a=new l(x,ee),this.d=new k(x,q,ee)}getChannel(x){return this.a.getChannel(x)}registerChannel(x,q){this.d.registerChannel(x,q)}dispose(){this.a.dispose(),this.d.dispose()}}e.$eh=L;function N(re){return{call(x,q,ee){return re.then(pe=>pe.call(x,q,ee))},listen(x,q){const ee=new E.$qc;return re.then(pe=>ee.input=pe.listen(x,q)),ee.event}}}e.$fh=N;function j(re){let x=!1;return{call(q,ee,pe){return x?re.call(q,ee,pe):(0,M.$Fg)(0).then(()=>x=!0).then(()=>re.call(q,ee,pe))},listen(q,ee){if(x)return re.listen(q,ee);const pe=new E.$qc;return(0,M.$Fg)(0).then(()=>x=!0).then(()=>pe.input=re.listen(q,ee)),pe.event}}}e.$gh=j;class T{constructor(x){this.a=x}routeCall(x){return this.b(x)}routeEvent(x){return this.b(x)}async b(x){for(const q of x.connections)if(await Promise.resolve(this.a(q.ctx)))return Promise.resolve(q);return await E.Event.toPromise(x.onDidAddConnection),await this.b(x)}}e.$hh=T;var O;(function(re){function x(ce,_){const Q=ce,z=_&&_.disableMarshalling,V=new Map;for(const G in Q)ee(G)&&V.set(G,E.Event.buffer(Q[G],!0));return new class{listen(G,ae,ne){const he=V.get(ae);if(he)return he;if(pe(ae)){const Ee=Q[ae];if(typeof Ee=="function")return Ee.call(Q,ne)}throw new g.$_(`Event not found: ${ae}`)}call(G,ae,ne){const he=Q[ae];if(typeof he=="function"){if(!z&&Array.isArray(ne))for(let Ee=0;Ee<ne.length;Ee++)ne[Ee]=(0,P.$9g)(ne[Ee]);return he.apply(Q,ne)}throw new g.$_(`Method not found: ${ae}`)}}}re.fromService=x;function q(ce,_){const Q=_&&_.disableMarshalling;return new Proxy({},{get(z,V){if(typeof V=="string")return _?.properties?.has(V)?_.properties.get(V):pe(V)?function(G){return ce.listen(V,G)}:ee(V)?ce.listen(V):async function(...G){let ae;_&&!(0,b.$ue)(_.context)?ae=[_.context,...G]:ae=G;const ne=await ce.call(V,ae);return Q?ne:(0,P.$9g)(ne)};throw new g.$_(`Property not found: ${String(V)}`)}})}re.toService=q;function ee(ce){return ce[0]==="o"&&ce[1]==="n"&&I.$Nd(ce.charCodeAt(2))}function pe(ce){return/^onDynamic/.test(ce)&&I.$Nd(ce.charCodeAt(9))}})(O||(e.ProxyChannel=O={}));const B=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function F(re){if(Array.isArray(re))return re;if(re&&typeof re=="object"&&typeof re.toString=="function"){const x=re.toString();if(x!=="[object Object]")return x}return re}function J(re){return Array.isArray(re)?re.map(F):F(re)}function K(re,x,q,ee,pe,ce,_){_=J(_);const Q=B[pe],z=Q[ee%Q.length];let V=[`%c[${re}]%c[${String(x).padStart(7," ")}]%c[len: ${String(q).padStart(5," ")}]%c${String(ee).padStart(5," ")} - ${ce}`,"color: darkgreen","color: grey","color: grey",`color: ${z}`];/\($/.test(ce)?(V=V.concat(_),V.push(")")):V.push(_),console.log.apply(console,V)}class me{constructor(x,q){this.d=x,this.f=q,this.a=0,this.b=0}logOutgoing(x,q,ee,pe,ce){this.b+=x,K(this.d,this.b,x,q,ee,pe,ce)}logIncoming(x,q,ee,pe,ce){this.a+=x,K(this.f,this.a,x,q,ee,pe,ce)}}e.$ih=me}),define(De[80],Ce([1,0,21,4,3,79]),function($e,e,D,M,h,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nh=e.$mh=e.$lh=e.$kh=e.ProtocolConstants=e.$jh=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var A;(function(n){n.Created="created",n.Read="read",n.Write="write",n.Open="open",n.Error="error",n.Close="close",n.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",n.NodeEndReceived="nodeEndReceived",n.NodeEndSent="nodeEndSent",n.NodeDrainBegin="nodeDrainBegin",n.NodeDrainEnd="nodeDrainEnd",n.zlibInflateError="zlibInflateError",n.zlibInflateData="zlibInflateData",n.zlibInflateInitialWrite="zlibInflateInitialWrite",n.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",n.zlibInflateWrite="zlibInflateWrite",n.zlibInflateFlushFired="zlibInflateFlushFired",n.zlibDeflateError="zlibDeflateError",n.zlibDeflateData="zlibDeflateData",n.zlibDeflateWrite="zlibDeflateWrite",n.zlibDeflateFlushFired="zlibDeflateFlushFired",n.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",n.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",n.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",n.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",n.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",n.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",n.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",n.ProtocolHeaderRead="protocolHeaderRead",n.ProtocolMessageRead="protocolMessageRead",n.ProtocolHeaderWrite="protocolHeaderWrite",n.ProtocolMessageWrite="protocolMessageWrite",n.ProtocolWrite="protocolWrite"})(A||(e.SocketDiagnosticsEventType=A={}));var g;(function(n){n.enableDiagnostics=!1,n.records=[];const c=new WeakMap;let d=0;function v(u,l){if(!c.has(u)){const w=String(++d);c.set(u,w)}return c.get(u)}function k(u,l,w,L){if(!n.enableDiagnostics)return;const N=v(u,l);if(L instanceof D.$Hc||L instanceof Uint8Array||L instanceof ArrayBuffer||ArrayBuffer.isView(L)){const j=D.$Hc.alloc(L.byteLength);j.set(L),n.records.push({timestamp:Date.now(),id:N,label:l,type:w,buff:j})}else n.records.push({timestamp:Date.now(),id:N,label:l,type:w,data:L})}n.traceSocketEvent=k})(g||(e.SocketDiagnostics=g={}));var E;(function(n){n[n.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",n[n.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(E||(e.SocketCloseEventType=E={}));let $=null;function P(){return $||($=D.$Hc.alloc(0)),$}class I{get byteLength(){return this.b}constructor(){this.a=[],this.b=0}acceptChunk(c){this.a.push(c),this.b+=c.byteLength}read(c){return this.c(c,!0)}peek(c){return this.c(c,!1)}c(c,d){if(c===0)return P();if(c>this.b)throw new Error("Cannot read so many bytes!");if(this.a[0].byteLength===c){const l=this.a[0];return d&&(this.a.shift(),this.b-=c),l}if(this.a[0].byteLength>c){const l=this.a[0].slice(0,c);return d&&(this.a[0]=this.a[0].slice(c),this.b-=c),l}const v=D.$Hc.alloc(c);let k=0,u=0;for(;c>0;){const l=this.a[u];if(l.byteLength>c){const w=l.slice(0,c);v.set(w,k),k+=c,d&&(this.a[u]=l.slice(c),this.b-=c),c-=c}else v.set(l,k),k+=l.byteLength,d?(this.a.shift(),this.b-=l.byteLength):u++,c-=l.byteLength}return v}}e.$jh=I;var b;(function(n){n[n.None=0]="None",n[n.Regular=1]="Regular",n[n.Control=2]="Control",n[n.Ack=3]="Ack",n[n.Disconnect=5]="Disconnect",n[n.ReplayRequest=6]="ReplayRequest",n[n.Pause=7]="Pause",n[n.Resume=8]="Resume",n[n.KeepAlive=9]="KeepAlive"})(b||(b={}));function S(n){switch(n){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting";case 9:return"KeepAlive"}}var C;(function(n){n[n.HeaderLength=13]="HeaderLength",n[n.AcknowledgeTime=2e3]="AcknowledgeTime",n[n.TimeoutTime=2e4]="TimeoutTime",n[n.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",n[n.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime",n[n.KeepAliveSendTime=5e3]="KeepAliveSendTime"})(C||(e.ProtocolConstants=C={}));class y{constructor(c,d,v,k){this.type=c,this.id=d,this.ack=v,this.data=k,this.writtenTime=0}get size(){return this.data.byteLength}}class r extends h.$mb{constructor(c){super(),this.f=this.B(new M.$hc),this.onMessage=this.f.event,this.g={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this.a=c,this.b=!1,this.c=new I,this.B(this.a.onData(d=>this.acceptChunk(d))),this.lastReadTime=Date.now()}acceptChunk(c){if(!(!c||c.byteLength===0))for(this.lastReadTime=Date.now(),this.c.acceptChunk(c);this.c.byteLength>=this.g.readLen;){const d=this.c.read(this.g.readLen);if(this.g.readHead)this.g.readHead=!1,this.g.readLen=d.readUInt32BE(9),this.g.messageType=d.readUInt8(0),this.g.id=d.readUInt32BE(1),this.g.ack=d.readUInt32BE(5),this.a.traceSocketEvent("protocolHeaderRead",{messageType:S(this.g.messageType),id:this.g.id,ack:this.g.ack,messageSize:this.g.readLen});else{const v=this.g.messageType,k=this.g.id,u=this.g.ack;if(this.g.readHead=!0,this.g.readLen=13,this.g.messageType=0,this.g.id=0,this.g.ack=0,this.a.traceSocketEvent("protocolMessageRead",d),this.f.fire(new y(v,k,u,d)),this.b)break}}}readEntireBuffer(){return this.c.read(this.c.byteLength)}dispose(){this.b=!0,super.dispose()}}class i{constructor(c){this.k=null,this.a=!1,this.b=!1,this.c=c,this.d=[],this.f=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this.a=!0}drain(){return this.flush(),this.c.drain()}flush(){this.m()}pause(){this.b=!0}resume(){this.b=!1,this.l()}write(c){if(this.a)return;c.writtenTime=Date.now(),this.lastWriteTime=Date.now();const d=D.$Hc.alloc(13);d.writeUInt8(c.type,0),d.writeUInt32BE(c.id,1),d.writeUInt32BE(c.ack,5),d.writeUInt32BE(c.data.byteLength,9),this.c.traceSocketEvent("protocolHeaderWrite",{messageType:S(c.type),id:c.id,ack:c.ack,messageSize:c.data.byteLength}),this.c.traceSocketEvent("protocolMessageWrite",c.data),this.j(d,c.data)}g(c,d){const v=this.f===0;return this.d.push(c,d),this.f+=c.byteLength+d.byteLength,v}h(){const c=D.$Hc.concat(this.d,this.f);return this.d.length=0,this.f=0,c}j(c,d){this.g(c,d)&&this.l()}l(){this.k||(this.k=setTimeout(()=>{this.k=null,this.m()}))}m(){if(this.f===0||this.b)return;const c=this.h();this.c.traceSocketEvent("protocolWrite",{byteLength:c.byteLength}),this.c.write(c)}}class a extends h.$mb{constructor(c){super(),this.f=new M.$hc,this.onMessage=this.f.event,this.g=new M.$hc,this.onDidDispose=this.g.event,this.a=c,this.b=this.B(new i(this.a)),this.c=this.B(new r(this.a)),this.B(this.c.onMessage(d=>{d.type===1&&this.f.fire(d.data)})),this.B(this.a.onClose(()=>this.g.fire()))}drain(){return this.b.drain()}getSocket(){return this.a}sendDisconnect(){}send(c){this.b.write(new y(1,0,0,c))}}e.$kh=a;class m extends R.$eh{static fromSocket(c,d){return new m(new a(c),d)}get onDidDispose(){return this.b.onDidDispose}constructor(c,d,v=null){super(c,d,v),this.b=c}dispose(){super.dispose();const c=this.b.getSocket();this.b.sendDisconnect(),this.b.dispose(),c.end()}}e.$lh=m;class p{constructor(){this.b=!1,this.c=!1,this.d=[],this.a=new M.$hc({onWillAddFirstListener:()=>{this.b=!0,queueMicrotask(()=>this.f())},onDidRemoveLastListener:()=>{this.b=!1}}),this.event=this.a.event}f(){if(!this.c){for(this.c=!0;this.b&&this.d.length>0;)this.a.fire(this.d.shift());this.c=!1}}fire(c){this.b?this.d.length>0?this.d.push(c):this.a.fire(c):this.d.push(c)}flushBuffer(){this.d=[]}}e.$mh=p;class f{constructor(c){this.data=c,this.next=null}}class t{constructor(){this.a=null,this.b=null}length(){let c=0,d=this.a;for(;d;)d=d.next,c++;return c}peek(){return this.a?this.a.data:null}toArray(){const c=[];let d=0,v=this.a;for(;v;)c[d++]=v.data,v=v.next;return c}pop(){if(this.a){if(this.a===this.b){this.a=null,this.b=null;return}this.a=this.a.next}}push(c){const d=new f(c);if(!this.a){this.a=d,this.b=d;return}this.b.next=d,this.b=d}}class s{static{this.a=10}static{this.b=null}static getInstance(){return s.b||(s.b=new s),s.b}constructor(){this.c=[];const c=Date.now();for(let d=0;d<s.a;d++)this.c[d]=c-1e3*d;setInterval(()=>{for(let d=s.a;d>=1;d--)this.c[d]=this.c[d-1];this.c[0]=Date.now()},1e3)}d(){const c=Date.now(),d=(1+s.a)*1e3;let v=0;for(let k=0;k<s.a;k++)c-this.c[k]<=d&&v++;return 1-v/s.a}hasHighLoad(){return this.d()>=.5}}class o{get unacknowledgedCount(){return this.c-this.d}constructor(c){this.u=new p,this.onControlMessage=this.u.event,this.v=new p,this.onMessage=this.v.event,this.w=new p,this.onDidDispose=this.w.event,this.x=new p,this.onSocketClose=this.x.event,this.y=new p,this.onSocketTimeout=this.y.event,this.s=c.loadEstimator??s.getInstance(),this.t=c.sendKeepAlive??!0,this.a=!1,this.b=new t,this.c=0,this.d=0,this.f=null,this.g=0,this.h=0,this.j=0,this.k=null,this.m=0,this.n=Date.now(),this.r=new h.$lb,this.o=c.socket,this.p=this.r.add(new i(this.o)),this.q=this.r.add(new r(this.o)),this.r.add(this.q.onMessage(d=>this.z(d))),this.r.add(this.o.onClose(d=>this.x.fire(d))),c.initialChunk&&this.q.acceptChunk(c.initialChunk),this.t?this.l=setInterval(()=>{this.D()},5e3):this.l=null}dispose(){this.f&&(clearTimeout(this.f),this.f=null),this.k&&(clearTimeout(this.k),this.k=null),this.l&&(clearInterval(this.l),this.l=null),this.r.dispose()}drain(){return this.p.drain()}sendDisconnect(){const c=new y(5,0,0,P());this.p.write(c),this.p.flush()}sendPause(){const c=new y(7,0,0,P());this.p.write(c)}sendResume(){const c=new y(8,0,0,P());this.p.write(c)}pauseSocketWriting(){this.p.pause()}getSocket(){return this.o}getMillisSinceLastIncomingData(){return Date.now()-this.q.lastReadTime}beginAcceptReconnection(c,d){this.a=!0,this.r.dispose(),this.r=new h.$lb,this.u.flushBuffer(),this.x.flushBuffer(),this.y.flushBuffer(),this.o.dispose(),this.m=0,this.n=Date.now(),this.o=c,this.p=this.r.add(new i(this.o)),this.q=this.r.add(new r(this.o)),this.r.add(this.q.onMessage(v=>this.z(v))),this.r.add(this.o.onClose(v=>this.x.fire(v))),this.q.acceptChunk(d)}endAcceptReconnection(){this.a=!1,this.h=this.g;const c=new y(3,0,this.h,P());this.p.write(c);const d=this.b.toArray();for(let v=0,k=d.length;v<k;v++)this.p.write(d[v]);this.B()}acceptDisconnect(){this.w.fire()}z(c){if(c.ack>this.d){this.d=c.ack;do{const d=this.b.peek();if(d&&d.id<=c.ack)this.b.pop();else break}while(!0)}switch(c.type){case 0:break;case 1:{if(c.id>this.g)if(c.id!==this.g+1){const d=Date.now();d-this.m>1e4&&(this.m=d,this.p.write(new y(6,0,0,P())))}else this.g=c.id,this.j=Date.now(),this.A(),this.v.fire(c.data);break}case 2:{this.u.fire(c.data);break}case 3:break;case 5:{this.w.fire();break}case 6:{const d=this.b.toArray();for(let v=0,k=d.length;v<k;v++)this.p.write(d[v]);this.B();break}case 7:{this.p.pause();break}case 8:{this.p.resume();break}case 9:break}}readEntireBuffer(){return this.q.readEntireBuffer()}flush(){this.p.flush()}send(c){const d=++this.c;this.h=this.g;const v=new y(1,d,this.h,c);this.b.push(v),this.a||(this.p.write(v),this.B())}sendControl(c){const d=new y(2,0,0,c);this.p.write(d)}A(){if(this.g<=this.h||this.k)return;const c=Date.now()-this.j;if(c>=2e3){this.C();return}this.k=setTimeout(()=>{this.k=null,this.A()},2e3-c+5)}B(){if(this.c<=this.d||this.f||this.a)return;const c=this.b.peek(),d=Date.now()-c.writtenTime,v=Date.now()-this.q.lastReadTime,k=Date.now()-this.n;if(d>=2e4&&v>=2e4&&k>=2e4&&!this.s.hasHighLoad()){this.n=Date.now(),this.y.fire({unacknowledgedMsgCount:this.b.length(),timeSinceOldestUnacknowledgedMsg:d,timeSinceLastReceivedSomeData:v});return}const u=Math.max(2e4-d,2e4-v,2e4-k,500);this.f=setTimeout(()=>{this.f=null,this.B()},u)}C(){if(this.g<=this.h)return;this.h=this.g;const c=new y(3,0,this.h,P());this.p.write(c)}D(){this.h=this.g;const c=new y(9,0,this.h,P());this.p.write(c)}}e.$nh=o}),define(De[181],Ce([1,0,46,13,21,22,179,8,4,3,23,100,98,79]),function($e,e,D,M,h,R,A,g,E,$,P,I,b,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pp=e.$Op=void 0;class C extends S.$bh{constructor(i){super({send:a=>{try{process.send?.(a.buffer.toString("base64"))}catch{}},onMessage:E.Event.fromNodeEventEmitter(process,"message",a=>h.$Hc.wrap(Buffer.from(a,"base64")))},i),process.once("disconnect",()=>this.dispose())}}e.$Op=C;class y{constructor(i,a){this.i=i,this.j=a,this.c=new Set,this.g=new Map,this.h=new E.$hc,this.onDidProcessExit=this.h.event;const m=a&&a.timeout?a.timeout:6e4;this.b=new M.$Bg(m),this.d=null,this.f=null}getChannel(i){const a=this;return{call(m,p,f){return a.k(i,m,p,f)},listen(m,p){return a.l(i,m,p)}}}k(i,a,m,p=R.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(p.isCancellationRequested)return Promise.reject(g.$4());this.b.cancel();const f=this.n(i),t=(0,M.$sg)(n=>f.call(a,m,n)),s=p.onCancellationRequested(()=>t.cancel()),o=(0,$.$kb)(()=>t.cancel());return this.c.add(o),t.finally(()=>{s.dispose(),this.c.delete(o),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),t}l(i,a,m){if(!this.b)return E.Event.None;this.b.cancel();let p;const f=new E.$hc({onWillAddFirstListener:()=>{p=this.n(i).listen(a,m)(f.fire,f),this.c.add(p)},onDidRemoveLastListener:()=>{this.c.delete(p),p.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return f.event}get m(){if(!this.f){const i=this.j&&this.j.args?this.j.args:[],a=Object.create(null);a.env={...(0,P.$Tm)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(a.env={...a.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(a.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(a.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(a.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),a.execArgv===void 0&&(a.execArgv=process.execArgv.filter(c=>!/^--inspect(-brk)?=/.test(c)).filter(c=>!c.startsWith("--vscode-"))),(0,b.$rl)(a.env),this.d=(0,D.fork)(this.i,i,a);const m=new E.$hc;E.Event.fromNodeEventEmitter(this.d,"message",c=>c)(c=>{if((0,A.$Kp)(c)){(0,A.log)(c,`IPC Library: ${this.j.serverName}`);return}m.fire(h.$Hc.wrap(Buffer.from(c,"base64")))});const f=this.j.useQueue?(0,I.$tl)(this.d):this.d,t=c=>this.d&&this.d.connected&&f.send(c.buffer.toString("base64")),s=m.event,o={send:t,onMessage:s};this.f=new S.$ch(o);const n=()=>this.o();process.once("exit",n),this.d.on("error",c=>console.warn('IPC "'+this.j.serverName+'" errored with '+c)),this.d.on("exit",(c,d)=>{process.removeListener("exit",n),this.c.forEach(v=>(0,$.$hb)(v)),this.c.clear(),c!==0&&d!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+c+" and signal "+d),this.b?.cancel(),this.o(),this.h.fire({code:c,signal:d})})}return this.f}n(i){let a=this.g.get(i);return a||(a=this.m.getChannel(i),this.g.set(i,a)),a}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.$Pp=y}),define(De[182],Ce([1,0,35,14]),function($e,e,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$E=void 0;function h(R,A,g,E,$,P){if(Array.isArray(R)){let I=0;for(const b of R){const S=h(b,A,g,E,$,P);if(S===10)return S;S>I&&(I=S)}return I}else{if(typeof R=="string")return E?R==="*"?5:R===g?10:0:0;if(R){const{language:I,pattern:b,scheme:S,hasAccessToAllModels:C,notebookType:y}=R;if(!E&&!C)return 0;y&&$&&(A=$);let r=0;if(S)if(S===A.scheme)r=10;else if(S==="*")r=5;else return 0;if(I)if(I===g)r=10;else if(I==="*")r=Math.max(r,5);else return 0;if(y)if(y===P)r=10;else if(y==="*"&&P!==void 0)r=Math.max(r,5);else return 0;if(b){let i;if(typeof b=="string"?i=b:i={...b,base:(0,M.$9c)(b.base)},i===A.fsPath||(0,D.$oj)(i,A.fsPath))r=10;else return 0}return r}else return 0}}e.$$E=h}),define(De[129],Ce([1,0,21,9]),function($e,e,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$j0=e.$i0=void 0;var h;(function(I){I[I.Full=1]="Full",I[I.Delta=2]="Delta"})(h||(h={}));function R(I){for(let b=0,S=I.length;b<S;b+=4){const C=I[b+0],y=I[b+1],r=I[b+2],i=I[b+3];I[b+0]=i,I[b+1]=r,I[b+2]=y,I[b+3]=C}}function A(I){const b=new Uint8Array(I.buffer,I.byteOffset,I.length*4);return M.$C()||R(b),D.$Hc.wrap(b)}function g(I){const b=I.buffer;if(M.$C()||R(b),b.byteOffset%4===0)return new Uint32Array(b.buffer,b.byteOffset,b.length/4);{const S=new Uint8Array(b.byteLength);return S.set(b),new Uint32Array(S.buffer,S.byteOffset,S.length/4)}}function E(I){const b=new Uint32Array($(I));let S=0;if(b[S++]=I.id,I.type==="full")b[S++]=1,b[S++]=I.data.length,b.set(I.data,S),S+=I.data.length;else{b[S++]=2,b[S++]=I.deltas.length;for(const C of I.deltas)b[S++]=C.start,b[S++]=C.deleteCount,C.data?(b[S++]=C.data.length,b.set(C.data,S),S+=C.data.length):b[S++]=0}return A(b)}e.$i0=E;function $(I){let b=0;if(b+=1+1,I.type==="full")b+=1+I.data.length;else{b+=1,b+=(1+1+1)*I.deltas.length;for(const S of I.deltas)S.data&&(b+=S.data.length)}return b}function P(I){const b=g(I);let S=0;const C=b[S++];if(b[S++]===1){const a=b[S++],m=b.subarray(S,S+a);return S+=a,{id:C,type:"full",data:m}}const r=b[S++],i=[];for(let a=0;a<r;a++){const m=b[S++],p=b[S++],f=b[S++];let t;f>0&&(t=b.subarray(S,S+f),S+=f),i[a]={start:m,deleteCount:p,data:t}}return{id:C,type:"delta",deltas:i}}e.$j0=P}),define(De[183],Ce([11,12]),function($e,e){return $e.create("vs/editor/common/config/editorOptions",e)}),define(De[130],Ce([1,0,19,23,9,164,123,183]),function($e,e,D,M,h,R,A,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontVariations=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.clampedFloat=e.clampedInt=e.boolean=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var E;(function(le){le[le.None=0]="None",le[le.Keep=1]="Keep",le[le.Brackets=2]="Brackets",le[le.Advanced=3]="Advanced",le[le.Full=4]="Full"})(E||(e.EditorAutoIndentStrategy=E={})),e.MINIMAP_GUTTER_WIDTH=8;class ${constructor(se){this.c=se}hasChanged(se){return this.c[se]}}e.ConfigurationChangedEvent=$;class P{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=P;class I{constructor(se,Ie,qe,je){this.id=se,this.name=Ie,this.defaultValue=qe,this.schema=je}applyUpdate(se,Ie){return S(se,Ie)}compute(se,Ie,qe){return qe}}class b{constructor(se,Ie){this.newValue=se,this.didChange=Ie}}e.ApplyUpdateResult=b;function S(le,se){if(typeof le!="object"||typeof se!="object"||!le||!se)return new b(se,le!==se);if(Array.isArray(le)||Array.isArray(se)){const qe=Array.isArray(le)&&Array.isArray(se)&&D.$of(le,se);return new b(se,!qe)}let Ie=!1;for(const qe in se)if(se.hasOwnProperty(qe)){const je=S(le[qe],se[qe]);je.didChange&&(le[qe]=je.newValue,Ie=!0)}return new b(le,Ie)}class C{constructor(se){this.schema=void 0,this.id=se,this.name="_never_",this.defaultValue=void 0}applyUpdate(se,Ie){return S(se,Ie)}validate(se){return this.defaultValue}}class y{constructor(se,Ie,qe,je){this.id=se,this.name=Ie,this.defaultValue=qe,this.schema=je}applyUpdate(se,Ie){return S(se,Ie)}validate(se){return typeof se>"u"?this.defaultValue:se}compute(se,Ie,qe){return qe}}function r(le,se){return typeof le>"u"?se:le==="false"?!1:!!le}e.boolean=r;class i extends y{constructor(se,Ie,qe,je=void 0){typeof je<"u"&&(je.type="boolean",je.default=qe),super(se,Ie,qe,je)}validate(se){return r(se,this.defaultValue)}}function a(le,se,Ie,qe){if(typeof le>"u")return se;let je=parseInt(le,10);return isNaN(je)?se:(je=Math.max(Ie,je),je=Math.min(qe,je),je|0)}e.clampedInt=a;class m extends y{static clampedInt(se,Ie,qe,je){return a(se,Ie,qe,je)}constructor(se,Ie,qe,je,Xe,nt=void 0){typeof nt<"u"&&(nt.type="integer",nt.default=qe,nt.minimum=je,nt.maximum=Xe),super(se,Ie,qe,nt),this.minimum=je,this.maximum=Xe}validate(se){return m.clampedInt(se,this.defaultValue,this.minimum,this.maximum)}}function p(le,se,Ie,qe){if(typeof le>"u")return se;const je=f.float(le,se);return f.clamp(je,Ie,qe)}e.clampedFloat=p;class f extends y{static clamp(se,Ie,qe){return se<Ie?Ie:se>qe?qe:se}static float(se,Ie){if(typeof se=="number")return se;if(typeof se>"u")return Ie;const qe=parseFloat(se);return isNaN(qe)?Ie:qe}constructor(se,Ie,qe,je,Xe){typeof Xe<"u"&&(Xe.type="number",Xe.default=qe),super(se,Ie,qe,Xe),this.validationFn=je}validate(se){return this.validationFn(f.float(se,this.defaultValue))}}class t extends y{static string(se,Ie){return typeof se!="string"?Ie:se}constructor(se,Ie,qe,je=void 0){typeof je<"u"&&(je.type="string",je.default=qe),super(se,Ie,qe,je)}validate(se){return t.string(se,this.defaultValue)}}function s(le,se,Ie,qe){return typeof le!="string"?se:qe&&le in qe?qe[le]:Ie.indexOf(le)===-1?se:le}e.stringSet=s;class o extends y{constructor(se,Ie,qe,je,Xe=void 0){typeof Xe<"u"&&(Xe.type="string",Xe.enum=je,Xe.default=qe),super(se,Ie,qe,Xe),this.c=je}validate(se){return s(se,this.defaultValue,this.c)}}class n extends I{constructor(se,Ie,qe,je,Xe,nt,ot=void 0){typeof ot<"u"&&(ot.type="string",ot.enum=Xe,ot.default=je),super(se,Ie,qe,ot),this.c=Xe,this.d=nt}validate(se){return typeof se!="string"?this.defaultValue:this.c.indexOf(se)===-1?this.defaultValue:this.d(se)}}function c(le){switch(le){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class d extends I{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[g.localize(0,null),g.localize(1,null),g.localize(2,null)],default:"auto",tags:["accessibility"],description:g.localize(3,null)})}validate(se){switch(se){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(se,Ie,qe){return qe===0?se.accessibilitySupport:qe}}class v extends I{constructor(){const se={insertSpace:!0,ignoreEmptyLines:!0};super(23,"comments",se,{"editor.comments.insertSpace":{type:"boolean",default:se.insertSpace,description:g.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:se.ignoreEmptyLines,description:g.localize(5,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const Ie=se;return{insertSpace:r(Ie.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:r(Ie.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var k;(function(le){le[le.Hidden=0]="Hidden",le[le.Blink=1]="Blink",le[le.Smooth=2]="Smooth",le[le.Phase=3]="Phase",le[le.Expand=4]="Expand",le[le.Solid=5]="Solid"})(k||(e.TextEditorCursorBlinkingStyle=k={}));function u(le){switch(le){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var l;(function(le){le[le.Line=1]="Line",le[le.Block=2]="Block",le[le.Underline=3]="Underline",le[le.LineThin=4]="LineThin",le[le.BlockOutline=5]="BlockOutline",le[le.UnderlineThin=6]="UnderlineThin"})(l||(e.TextEditorCursorStyle=l={}));function w(le){switch(le){case l.Line:return"line";case l.Block:return"block";case l.Underline:return"underline";case l.LineThin:return"line-thin";case l.BlockOutline:return"block-outline";case l.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=w;function L(le){switch(le){case"line":return l.Line;case"block":return l.Block;case"underline":return l.Underline;case"line-thin":return l.LineThin;case"block-outline":return l.BlockOutline;case"underline-thin":return l.UnderlineThin}}class N extends C{constructor(){super(140)}compute(se,Ie,qe){const je=["monaco-editor"];return Ie.get(39)&&je.push(Ie.get(39)),se.extraEditorClassName&&je.push(se.extraEditorClassName),Ie.get(73)==="default"?je.push("mouse-default"):Ie.get(73)==="copy"&&je.push("mouse-copy"),Ie.get(110)&&je.push("showUnused"),Ie.get(138)&&je.push("showDeprecated"),je.join(" ")}}class j extends i{constructor(){super(37,"emptySelectionClipboard",!0,{description:g.localize(6,null)})}compute(se,Ie,qe){return qe&&se.emptySelectionClipboard}}class T extends I{constructor(){const se={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(41,"find",se,{"editor.find.cursorMoveOnType":{type:"boolean",default:se.cursorMoveOnType,description:g.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:se.seedSearchStringFromSelection,enumDescriptions:[g.localize(8,null),g.localize(9,null),g.localize(10,null)],description:g.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:se.autoFindInSelection,enumDescriptions:[g.localize(12,null),g.localize(13,null),g.localize(14,null)],description:g.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:se.globalFindClipboard,description:g.localize(16,null),included:h.$j},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:se.addExtraSpaceOnTop,description:g.localize(17,null)},"editor.find.loop":{type:"boolean",default:se.loop,description:g.localize(18,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const Ie=se;return{cursorMoveOnType:r(Ie.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof se.seedSearchStringFromSelection=="boolean"?se.seedSearchStringFromSelection?"always":"never":s(Ie.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof se.autoFindInSelection=="boolean"?se.autoFindInSelection?"always":"never":s(Ie.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:r(Ie.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:r(Ie.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:r(Ie.loop,this.defaultValue.loop)}}}class O extends I{static{this.OFF='"liga" off, "calt" off'}static{this.ON='"liga" on, "calt" on'}constructor(){super(51,"fontLigatures",O.OFF,{anyOf:[{type:"boolean",description:g.localize(19,null)},{type:"string",description:g.localize(20,null)}],description:g.localize(21,null),default:!1})}validate(se){return typeof se>"u"?this.defaultValue:typeof se=="string"?se==="false"?O.OFF:se==="true"?O.ON:se:se?O.ON:O.OFF}}e.EditorFontLigatures=O;class B extends I{static{this.OFF="normal"}static{this.TRANSLATE="translate"}constructor(){super(54,"fontVariations",B.OFF,{anyOf:[{type:"boolean",description:g.localize(22,null)},{type:"string",description:g.localize(23,null)}],description:g.localize(24,null),default:!1})}validate(se){return typeof se>"u"?this.defaultValue:typeof se=="string"?se==="false"?B.OFF:se==="true"?B.TRANSLATE:se:se?B.TRANSLATE:B.OFF}compute(se,Ie,qe){return se.fontInfo.fontVariationSettings}}e.EditorFontVariations=B;class F extends C{constructor(){super(50)}compute(se,Ie,qe){return se.fontInfo}}class J extends y{constructor(){super(52,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:g.localize(25,null)})}validate(se){const Ie=f.float(se,this.defaultValue);return Ie===0?e.EDITOR_FONT_DEFAULTS.fontSize:f.clamp(Ie,6,100)}compute(se,Ie,qe){return se.fontInfo.fontSize}}class K extends I{static{this.c=["normal","bold","100","200","300","400","500","600","700","800","900"]}static{this.d=1}static{this.e=1e3}constructor(){super(53,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:K.d,maximum:K.e,errorMessage:g.localize(26,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:K.c}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:g.localize(27,null)})}validate(se){return se==="normal"||se==="bold"?se:String(m.clampedInt(se,e.EDITOR_FONT_DEFAULTS.fontWeight,K.d,K.e))}}class me extends I{constructor(){const se={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},Ie={type:"string",enum:["peek","gotoAndPeek","goto"],default:se.multiple,enumDescriptions:[g.localize(28,null),g.localize(29,null),g.localize(30,null)]},qe=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(58,"gotoLocation",se,{"editor.gotoLocation.multiple":{deprecationMessage:g.localize(31,null)},"editor.gotoLocation.multipleDefinitions":{description:g.localize(32,null),...Ie},"editor.gotoLocation.multipleTypeDefinitions":{description:g.localize(33,null),...Ie},"editor.gotoLocation.multipleDeclarations":{description:g.localize(34,null),...Ie},"editor.gotoLocation.multipleImplementations":{description:g.localize(35,null),...Ie},"editor.gotoLocation.multipleReferences":{description:g.localize(36,null),...Ie},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:se.alternativeDefinitionCommand,enum:qe,description:g.localize(37,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:se.alternativeTypeDefinitionCommand,enum:qe,description:g.localize(38,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:se.alternativeDeclarationCommand,enum:qe,description:g.localize(39,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:se.alternativeImplementationCommand,enum:qe,description:g.localize(40,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:se.alternativeReferenceCommand,enum:qe,description:g.localize(41,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const Ie=se;return{multiple:s(Ie.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:Ie.multipleDefinitions??s(Ie.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:Ie.multipleTypeDefinitions??s(Ie.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:Ie.multipleDeclarations??s(Ie.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:Ie.multipleImplementations??s(Ie.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:Ie.multipleReferences??s(Ie.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:t.string(Ie.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:t.string(Ie.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:t.string(Ie.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:t.string(Ie.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:t.string(Ie.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class re extends I{constructor(){const se={enabled:!0,delay:300,sticky:!0,above:!0};super(60,"hover",se,{"editor.hover.enabled":{type:"boolean",default:se.enabled,description:g.localize(42,null)},"editor.hover.delay":{type:"number",default:se.delay,minimum:0,maximum:1e4,description:g.localize(43,null)},"editor.hover.sticky":{type:"boolean",default:se.sticky,description:g.localize(44,null)},"editor.hover.above":{type:"boolean",default:se.above,description:g.localize(45,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const Ie=se;return{enabled:r(Ie.enabled,this.defaultValue.enabled),delay:m.clampedInt(Ie.delay,this.defaultValue.delay,0,1e4),sticky:r(Ie.sticky,this.defaultValue.sticky),above:r(Ie.above,this.defaultValue.above)}}}var x;(function(le){le[le.None=0]="None",le[le.Text=1]="Text",le[le.Blocks=2]="Blocks"})(x||(e.RenderMinimap=x={}));class q extends C{constructor(){super(143)}compute(se,Ie,qe){return q.computeLayout(Ie,{memory:se.memory,outerWidth:se.outerWidth,outerHeight:se.outerHeight,isDominatedByLongLines:se.isDominatedByLongLines,lineHeight:se.fontInfo.lineHeight,viewLineCount:se.viewLineCount,lineNumbersDigitCount:se.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:se.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:se.fontInfo.maxDigitWidth,pixelRatio:se.pixelRatio,glyphMarginDecorationLaneCount:se.glyphMarginDecorationLaneCount})}static computeContainedMinimapLineCount(se){const Ie=se.height/se.lineHeight,qe=Math.floor(se.paddingTop/se.lineHeight);let je=Math.floor(se.paddingBottom/se.lineHeight);se.scrollBeyondLastLine&&(je=Math.max(je,Ie-1));const Xe=(qe+se.viewLineCount+je)/(se.pixelRatio*se.height),nt=Math.floor(se.viewLineCount/Xe);return{typicalViewportLineCount:Ie,extraLinesBeforeFirstLine:qe,extraLinesBeyondLastLine:je,desiredRatio:Xe,minimapLineCount:nt}}static c(se,Ie){const qe=se.outerWidth,je=se.outerHeight,Xe=se.pixelRatio;if(!se.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(Xe*je),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:je};const nt=Ie.stableMinimapLayoutInput,ot=nt&&se.outerHeight===nt.outerHeight&&se.lineHeight===nt.lineHeight&&se.typicalHalfwidthCharacterWidth===nt.typicalHalfwidthCharacterWidth&&se.pixelRatio===nt.pixelRatio&&se.scrollBeyondLastLine===nt.scrollBeyondLastLine&&se.paddingTop===nt.paddingTop&&se.paddingBottom===nt.paddingBottom&&se.minimap.enabled===nt.minimap.enabled&&se.minimap.side===nt.minimap.side&&se.minimap.size===nt.minimap.size&&se.minimap.showSlider===nt.minimap.showSlider&&se.minimap.renderCharacters===nt.minimap.renderCharacters&&se.minimap.maxColumn===nt.minimap.maxColumn&&se.minimap.scale===nt.minimap.scale&&se.verticalScrollbarWidth===nt.verticalScrollbarWidth&&se.isViewportWrapping===nt.isViewportWrapping,bt=se.lineHeight,Dt=se.typicalHalfwidthCharacterWidth,Qt=se.scrollBeyondLastLine,Vt=se.minimap.renderCharacters;let vt=Xe>=2?Math.round(se.minimap.scale*2):se.minimap.scale;const Tt=se.minimap.maxColumn,Nt=se.minimap.size,Kt=se.minimap.side,At=se.verticalScrollbarWidth,Rt=se.viewLineCount,Ot=se.remainingWidth,Ut=se.isViewportWrapping,qt=Vt?2:3;let Bt=Math.floor(Xe*je);const ct=Bt/Xe;let lt=!1,Jt=!1,Pt=qt*vt,kt=vt/Xe,dt=1;if(Nt==="fill"||Nt==="fit"){const{typicalViewportLineCount:Te,extraLinesBeforeFirstLine:Se,extraLinesBeyondLastLine:te,desiredRatio:Fe,minimapLineCount:He}=q.computeContainedMinimapLineCount({viewLineCount:Rt,scrollBeyondLastLine:Qt,paddingTop:se.paddingTop,paddingBottom:se.paddingBottom,height:je,lineHeight:bt,pixelRatio:Xe});if(Rt/He>1)lt=!0,Jt=!0,vt=1,Pt=1,kt=vt/Xe;else{let Je=!1,rt=vt+1;if(Nt==="fit"){const pt=Math.ceil((Se+Rt+te)*Pt);Ut&&ot&&Ot<=Ie.stableFitRemainingWidth?(Je=!0,rt=Ie.stableFitMaxMinimapScale):Je=pt>Bt}if(Nt==="fill"||Je){lt=!0;const pt=vt;Pt=Math.min(bt*Xe,Math.max(1,Math.floor(1/Fe))),Ut&&ot&&Ot<=Ie.stableFitRemainingWidth&&(rt=Ie.stableFitMaxMinimapScale),vt=Math.min(rt,Math.max(1,Math.floor(Pt/qt))),vt>pt&&(dt=Math.min(2,vt/pt)),kt=vt/Xe/dt,Bt=Math.ceil(Math.max(Te,Se+Rt+te)*Pt),Ut?(Ie.stableMinimapLayoutInput=se,Ie.stableFitRemainingWidth=Ot,Ie.stableFitMaxMinimapScale=vt):(Ie.stableMinimapLayoutInput=null,Ie.stableFitRemainingWidth=0)}}}const Ct=Math.floor(Tt*kt),Ft=Math.min(Ct,Math.max(0,Math.floor((Ot-At-2)*kt/(Dt+kt)))+e.MINIMAP_GUTTER_WIDTH);let Et=Math.floor(Xe*Ft);const Ge=Et/Xe;Et=Math.floor(Et*dt);const zt=Vt?1:2,Me=Kt==="left"?0:qe-Ft-At;return{renderMinimap:zt,minimapLeft:Me,minimapWidth:Ft,minimapHeightIsEditorHeight:lt,minimapIsSampling:Jt,minimapScale:vt,minimapLineHeight:Pt,minimapCanvasInnerWidth:Et,minimapCanvasInnerHeight:Bt,minimapCanvasOuterWidth:Ge,minimapCanvasOuterHeight:ct}}static computeLayout(se,Ie){const qe=Ie.outerWidth|0,je=Ie.outerHeight|0,Xe=Ie.lineHeight|0,nt=Ie.lineNumbersDigitCount|0,ot=Ie.typicalHalfwidthCharacterWidth,bt=Ie.maxDigitWidth,Dt=Ie.pixelRatio,Qt=Ie.viewLineCount,Vt=se.get(135),vt=Vt==="inherit"?se.get(134):Vt,Tt=vt==="inherit"?se.get(130):vt,Nt=se.get(133),Kt=Ie.isDominatedByLongLines,At=se.get(57),Rt=se.get(67).renderType!==0,Ot=se.get(68),Ut=se.get(104),qt=se.get(83),Bt=se.get(72),ct=se.get(102),lt=ct.verticalScrollbarSize,Jt=ct.verticalHasArrows,Pt=ct.arrowSize,kt=ct.horizontalScrollbarSize,dt=se.get(43),Ct=se.get(109)!=="never";let Ft=se.get(65);dt&&Ct&&(Ft+=16);let Et=0;if(Rt){const ft=Math.max(nt,Ot);Et=Math.round(ft*bt)}let Ge=0;At&&(Ge=Xe*Ie.glyphMarginDecorationLaneCount);let zt=0,Me=zt+Ge,Te=Me+Et,Se=Te+Ft;const te=qe-Ge-Et-Ft;let Fe=!1,He=!1,_e=-1;vt==="inherit"&&Kt?(Fe=!0,He=!0):Tt==="on"||Tt==="bounded"?He=!0:Tt==="wordWrapColumn"&&(_e=Nt);const Je=q.c({outerWidth:qe,outerHeight:je,lineHeight:Xe,typicalHalfwidthCharacterWidth:ot,pixelRatio:Dt,scrollBeyondLastLine:Ut,paddingTop:qt.top,paddingBottom:qt.bottom,minimap:Bt,verticalScrollbarWidth:lt,viewLineCount:Qt,remainingWidth:te,isViewportWrapping:He},Ie.memory||new P);Je.renderMinimap!==0&&Je.minimapLeft===0&&(zt+=Je.minimapWidth,Me+=Je.minimapWidth,Te+=Je.minimapWidth,Se+=Je.minimapWidth);const rt=te-Je.minimapWidth,pt=Math.max(1,Math.floor((rt-lt-2)/ot)),wt=Jt?Pt:0;return He&&(_e=Math.max(1,pt),Tt==="bounded"&&(_e=Math.min(_e,Nt))),{width:qe,height:je,glyphMarginLeft:zt,glyphMarginWidth:Ge,glyphMarginDecorationLaneCount:Ie.glyphMarginDecorationLaneCount,lineNumbersLeft:Me,lineNumbersWidth:Et,decorationsLeft:Te,decorationsWidth:Ft,contentLeft:Se,contentWidth:rt,minimap:Je,viewportColumn:pt,isWordWrapMinified:Fe,isViewportWrapping:He,wrappingColumn:_e,verticalScrollbarWidth:lt,horizontalScrollbarHeight:kt,overviewRuler:{top:wt,width:lt,height:je-2*wt,right:0}}}}e.EditorLayoutInfoComputer=q;class ee extends I{constructor(){super(137,"wrappingStrategy","simple",{"editor.wrappingStrategy":{enumDescriptions:[g.localize(46,null),g.localize(47,null)],type:"string",enum:["simple","advanced"],default:"simple",description:g.localize(48,null)}})}validate(se){return s(se,"simple",["simple","advanced"])}compute(se,Ie,qe){return Ie.get(2)===2?"advanced":qe}}class pe extends I{constructor(){const se={enabled:!0};super(64,"lightbulb",se,{"editor.lightbulb.enabled":{type:"boolean",default:se.enabled,description:g.localize(49,null)}})}validate(se){return!se||typeof se!="object"?this.defaultValue:{enabled:r(se.enabled,this.defaultValue.enabled)}}}class ce extends I{constructor(){const se={enabled:!1,maxLineCount:5,defaultModel:"outlineModel",scrollWithEditor:!0};super(114,"stickyScroll",se,{"editor.stickyScroll.enabled":{type:"boolean",default:se.enabled,description:g.localize(50,null)},"editor.stickyScroll.maxLineCount":{type:"number",default:se.maxLineCount,minimum:1,maximum:10,description:g.localize(51,null)},"editor.stickyScroll.defaultModel":{type:"string",enum:["outlineModel","foldingProviderModel","indentationModel"],default:se.defaultModel,description:g.localize(52,null)},"editor.stickyScroll.scrollWithEditor":{type:"boolean",default:se.scrollWithEditor,description:g.localize(53,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const Ie=se;return{enabled:r(Ie.enabled,this.defaultValue.enabled),maxLineCount:m.clampedInt(Ie.maxLineCount,this.defaultValue.maxLineCount,1,10),defaultModel:s(Ie.defaultModel,this.defaultValue.defaultModel,["outlineModel","foldingProviderModel","indentationModel"]),scrollWithEditor:r(Ie.scrollWithEditor,this.defaultValue.scrollWithEditor)}}}class _ extends I{constructor(){const se={enabled:"on",fontSize:0,fontFamily:"",padding:!1};super(139,"inlayHints",se,{"editor.inlayHints.enabled":{type:"string",default:se.enabled,description:g.localize(54,null),enum:["on","onUnlessPressed","offUnlessPressed","off"],markdownEnumDescriptions:[g.localize(55,null),g.localize(56,null,h.$j?"Ctrl+Option":"Ctrl+Alt"),g.localize(57,null,h.$j?"Ctrl+Option":"Ctrl+Alt"),g.localize(58,null)]},"editor.inlayHints.fontSize":{type:"number",default:se.fontSize,markdownDescription:g.localize(59,null,"`#editor.fontSize#`","`5`")},"editor.inlayHints.fontFamily":{type:"string",default:se.fontFamily,markdownDescription:g.localize(60,null,"`#editor.fontFamily#`")},"editor.inlayHints.padding":{type:"boolean",default:se.padding,description:g.localize(61,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const Ie=se;return typeof Ie.enabled=="boolean"&&(Ie.enabled=Ie.enabled?"on":"off"),{enabled:s(Ie.enabled,this.defaultValue.enabled,["on","off","offUnlessPressed","onUnlessPressed"]),fontSize:m.clampedInt(Ie.fontSize,this.defaultValue.fontSize,0,100),fontFamily:t.string(Ie.fontFamily,this.defaultValue.fontFamily),padding:r(Ie.padding,this.defaultValue.padding)}}}class Q extends I{constructor(){super(65,"lineDecorationsWidth",10)}validate(se){return typeof se=="string"&&/^\d+(\.\d+)?ch$/.test(se)?-parseFloat(se.substring(0,se.length-2)):m.clampedInt(se,this.defaultValue,0,1e3)}compute(se,Ie,qe){return qe<0?m.clampedInt(-qe*se.fontInfo.typicalHalfwidthCharacterWidth,this.defaultValue,0,1e3):qe}}class z extends f{constructor(){super(66,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,se=>f.clamp(se,0,150),{markdownDescription:g.localize(62,null)})}compute(se,Ie,qe){return se.fontInfo.lineHeight}}class V extends I{constructor(){const se={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",autohide:!1,renderCharacters:!0,maxColumn:120,scale:1};super(72,"minimap",se,{"editor.minimap.enabled":{type:"boolean",default:se.enabled,description:g.localize(63,null)},"editor.minimap.autohide":{type:"boolean",default:se.autohide,description:g.localize(64,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[g.localize(65,null),g.localize(66,null),g.localize(67,null)],default:se.size,description:g.localize(68,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:se.side,description:g.localize(69,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:se.showSlider,description:g.localize(70,null)},"editor.minimap.scale":{type:"number",default:se.scale,minimum:1,maximum:3,enum:[1,2,3],description:g.localize(71,null)},"editor.minimap.renderCharacters":{type:"boolean",default:se.renderCharacters,description:g.localize(72,null)},"editor.minimap.maxColumn":{type:"number",default:se.maxColumn,description:g.localize(73,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const Ie=se;return{enabled:r(Ie.enabled,this.defaultValue.enabled),autohide:r(Ie.autohide,this.defaultValue.autohide),size:s(Ie.size,this.defaultValue.size,["proportional","fill","fit"]),side:s(Ie.side,this.defaultValue.side,["right","left"]),showSlider:s(Ie.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:r(Ie.renderCharacters,this.defaultValue.renderCharacters),scale:m.clampedInt(Ie.scale,1,1,3),maxColumn:m.clampedInt(Ie.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function G(le){return le==="ctrlCmd"?h.$j?"metaKey":"ctrlKey":"altKey"}class ae extends I{constructor(){super(83,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:g.localize(74,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:g.localize(75,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const Ie=se;return{top:m.clampedInt(Ie.top,0,0,1e3),bottom:m.clampedInt(Ie.bottom,0,0,1e3)}}}class ne extends I{constructor(){const se={enabled:!0,cycle:!0};super(85,"parameterHints",se,{"editor.parameterHints.enabled":{type:"boolean",default:se.enabled,description:g.localize(76,null)},"editor.parameterHints.cycle":{type:"boolean",default:se.cycle,description:g.localize(77,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const Ie=se;return{enabled:r(Ie.enabled,this.defaultValue.enabled),cycle:r(Ie.cycle,this.defaultValue.cycle)}}}class he extends C{constructor(){super(141)}compute(se,Ie,qe){return se.pixelRatio}}class Ee extends I{constructor(){const se={other:"on",comments:"off",strings:"off"},Ie=[{type:"boolean"},{type:"string",enum:["on","inline","off"],enumDescriptions:[g.localize(78,null),g.localize(79,null),g.localize(80,null)]}];super(88,"quickSuggestions",se,{type:"object",additionalProperties:!1,properties:{strings:{anyOf:Ie,default:se.strings,description:g.localize(81,null)},comments:{anyOf:Ie,default:se.comments,description:g.localize(82,null)},other:{anyOf:Ie,default:se.other,description:g.localize(83,null)}},default:se,markdownDescription:g.localize(84,null,"#editor.suggestOnTriggerCharacters#")}),this.defaultValue=se}validate(se){if(typeof se=="boolean"){const Dt=se?"on":"off";return{comments:Dt,strings:Dt,other:Dt}}if(!se||typeof se!="object")return this.defaultValue;const{other:Ie,comments:qe,strings:je}=se,Xe=["on","inline","off"];let nt,ot,bt;return typeof Ie=="boolean"?nt=Ie?"on":"off":nt=s(Ie,this.defaultValue.other,Xe),typeof qe=="boolean"?ot=qe?"on":"off":ot=s(qe,this.defaultValue.comments,Xe),typeof je=="boolean"?bt=je?"on":"off":bt=s(je,this.defaultValue.strings,Xe),{other:nt,comments:ot,strings:bt}}}var de;(function(le){le[le.Off=0]="Off",le[le.On=1]="On",le[le.Relative=2]="Relative",le[le.Interval=3]="Interval",le[le.Custom=4]="Custom"})(de||(e.RenderLineNumbersType=de={}));class ge extends I{constructor(){super(67,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[g.localize(85,null),g.localize(86,null),g.localize(87,null),g.localize(88,null)],default:"on",description:g.localize(89,null)})}validate(se){let Ie=this.defaultValue.renderType,qe=this.defaultValue.renderFn;return typeof se<"u"&&(typeof se=="function"?(Ie=4,qe=se):se==="interval"?Ie=3:se==="relative"?Ie=2:se==="on"?Ie=1:Ie=0),{renderType:Ie,renderFn:qe}}}function ie(le){const se=le.get(97);return se==="editable"?le.get(90):se!=="on"}e.filterValidationDecorations=ie;class ue extends I{constructor(){const se=[],Ie={type:"number",description:g.localize(90,null)};super(101,"rulers",se,{type:"array",items:{anyOf:[Ie,{type:["object"],properties:{column:Ie,color:{type:"string",description:g.localize(91,null),format:"color-hex"}}}]},default:se,description:g.localize(92,null)})}validate(se){if(Array.isArray(se)){const Ie=[];for(const qe of se)if(typeof qe=="number")Ie.push({column:m.clampedInt(qe,0,0,1e4),color:null});else if(qe&&typeof qe=="object"){const je=qe;Ie.push({column:m.clampedInt(je.column,0,0,1e4),color:je.color})}return Ie.sort((qe,je)=>qe.column-je.column),Ie}return this.defaultValue}}class we extends I{constructor(){super(91,"readOnlyMessage",void 0)}validate(se){return!se||typeof se!="object"?this.defaultValue:se}}function Pe(le,se){if(typeof le!="string")return se;switch(le){case"hidden":return 2;case"visible":return 3;default:return 1}}class U extends I{constructor(){const se={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1};super(102,"scrollbar",se,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[g.localize(93,null),g.localize(94,null),g.localize(95,null)],default:"auto",description:g.localize(96,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[g.localize(97,null),g.localize(98,null),g.localize(99,null)],default:"auto",description:g.localize(100,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:se.verticalScrollbarSize,description:g.localize(101,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:se.horizontalScrollbarSize,description:g.localize(102,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:se.scrollByPage,description:g.localize(103,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const Ie=se,qe=m.clampedInt(Ie.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),je=m.clampedInt(Ie.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:m.clampedInt(Ie.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:Pe(Ie.vertical,this.defaultValue.vertical),horizontal:Pe(Ie.horizontal,this.defaultValue.horizontal),useShadows:r(Ie.useShadows,this.defaultValue.useShadows),verticalHasArrows:r(Ie.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:r(Ie.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:r(Ie.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:r(Ie.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:qe,horizontalSliderSize:m.clampedInt(Ie.horizontalSliderSize,qe,0,1e3),verticalScrollbarSize:je,verticalSliderSize:m.clampedInt(Ie.verticalSliderSize,je,0,1e3),scrollByPage:r(Ie.scrollByPage,this.defaultValue.scrollByPage)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class Z extends I{constructor(){const se={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(124,"unicodeHighlight",se,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:se.nonBasicASCII,description:g.localize(104,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:se.invisibleCharacters,description:g.localize(105,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:se.ambiguousCharacters,description:g.localize(106,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:se.includeComments,description:g.localize(107,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:se.includeStrings,description:g.localize(108,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:se.allowedCharacters,description:g.localize(109,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:se.allowedLocales,description:g.localize(110,null)}})}applyUpdate(se,Ie){let qe=!1;Ie.allowedCharacters&&se&&(M.$Xm(se.allowedCharacters,Ie.allowedCharacters)||(se={...se,allowedCharacters:Ie.allowedCharacters},qe=!0)),Ie.allowedLocales&&se&&(M.$Xm(se.allowedLocales,Ie.allowedLocales)||(se={...se,allowedLocales:Ie.allowedLocales},qe=!0));const je=super.applyUpdate(se,Ie);return qe?new b(je.newValue,!0):je}validate(se){if(!se||typeof se!="object")return this.defaultValue;const Ie=se;return{nonBasicASCII:fe(Ie.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:r(Ie.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:r(Ie.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:fe(Ie.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:fe(Ie.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.c(se.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.c(se.allowedLocales,this.defaultValue.allowedLocales)}}c(se,Ie){if(typeof se!="object"||!se)return Ie;const qe={};for(const[je,Xe]of Object.entries(se))Xe===!0&&(qe[je]=!0);return qe}}class X extends I{constructor(){const se={enabled:!0,mode:"subwordSmart",showToolbar:"onHover",suppressSuggestions:!1,keepOnBlur:!1};super(62,"inlineSuggest",se,{"editor.inlineSuggest.enabled":{type:"boolean",default:se.enabled,description:g.localize(111,null)},"editor.inlineSuggest.showToolbar":{type:"string",default:se.showToolbar,enum:["always","onHover"],enumDescriptions:[g.localize(112,null),g.localize(113,null)],description:g.localize(114,null)},"editor.inlineSuggest.suppressSuggestions":{type:"boolean",default:se.suppressSuggestions,description:g.localize(115,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const Ie=se;return{enabled:r(Ie.enabled,this.defaultValue.enabled),mode:s(Ie.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"]),showToolbar:s(Ie.showToolbar,this.defaultValue.showToolbar,["always","onHover"]),suppressSuggestions:r(Ie.suppressSuggestions,this.defaultValue.suppressSuggestions),keepOnBlur:r(Ie.keepOnBlur,this.defaultValue.keepOnBlur)}}}class oe extends I{constructor(){const se={enabled:R.$Rr.bracketPairColorizationOptions.enabled,independentColorPoolPerBracketType:R.$Rr.bracketPairColorizationOptions.independentColorPoolPerBracketType};super(15,"bracketPairColorization",se,{"editor.bracketPairColorization.enabled":{type:"boolean",default:se.enabled,markdownDescription:g.localize(116,null,"`#workbench.colorCustomizations#`")},"editor.bracketPairColorization.independentColorPoolPerBracketType":{type:"boolean",default:se.independentColorPoolPerBracketType,description:g.localize(117,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const Ie=se;return{enabled:r(Ie.enabled,this.defaultValue.enabled),independentColorPoolPerBracketType:r(Ie.independentColorPoolPerBracketType,this.defaultValue.independentColorPoolPerBracketType)}}}class Y extends I{constructor(){const se={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(16,"guides",se,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[g.localize(118,null),g.localize(119,null),g.localize(120,null)],default:se.bracketPairs,description:g.localize(121,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[g.localize(122,null),g.localize(123,null),g.localize(124,null)],default:se.bracketPairsHorizontal,description:g.localize(125,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:se.highlightActiveBracketPair,description:g.localize(126,null)},"editor.guides.indentation":{type:"boolean",default:se.indentation,description:g.localize(127,null)},"editor.guides.highlightActiveIndentation":{type:["boolean","string"],enum:[!0,"always",!1],enumDescriptions:[g.localize(128,null),g.localize(129,null),g.localize(130,null)],default:se.highlightActiveIndentation,description:g.localize(131,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const Ie=se;return{bracketPairs:fe(Ie.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:fe(Ie.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:r(Ie.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:r(Ie.indentation,this.defaultValue.indentation),highlightActiveIndentation:fe(Ie.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation,[!0,!1,"always"])}}}function fe(le,se,Ie){const qe=Ie.indexOf(le);return qe===-1?se:Ie[qe]}class ye extends I{constructor(){const se={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!1,localityBonus:!1,shareSuggestSelections:!1,selectionMode:"always",showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,matchOnWordStartOnly:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(117,"suggest",se,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[g.localize(132,null),g.localize(133,null)],default:se.insertMode,description:g.localize(134,null)},"editor.suggest.filterGraceful":{type:"boolean",default:se.filterGraceful,description:g.localize(135,null)},"editor.suggest.localityBonus":{type:"boolean",default:se.localityBonus,description:g.localize(136,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:se.shareSuggestSelections,markdownDescription:g.localize(137,null)},"editor.suggest.selectionMode":{type:"string",enum:["always","never","whenTriggerCharacter","whenQuickSuggestion"],enumDescriptions:[g.localize(138,null),g.localize(139,null),g.localize(140,null),g.localize(141,null)],default:se.selectionMode,markdownDescription:g.localize(142,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:se.snippetsPreventQuickSuggestions,description:g.localize(143,null)},"editor.suggest.showIcons":{type:"boolean",default:se.showIcons,description:g.localize(144,null)},"editor.suggest.showStatusBar":{type:"boolean",default:se.showStatusBar,description:g.localize(145,null)},"editor.suggest.preview":{type:"boolean",default:se.preview,description:g.localize(146,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:se.showInlineDetails,description:g.localize(147,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:g.localize(148,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:g.localize(149,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:g.localize(150,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:g.localize(151,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:g.localize(152,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:g.localize(153,null)},"editor.suggest.matchOnWordStartOnly":{type:"boolean",default:!0,markdownDescription:g.localize(154,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:g.localize(155,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:g.localize(156,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:g.localize(157,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:g.localize(158,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:g.localize(159,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:g.localize(160,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:g.localize(161,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:g.localize(162,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:g.localize(163,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:g.localize(164,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:g.localize(165,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:g.localize(166,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:g.localize(167,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:g.localize(168,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:g.localize(169,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:g.localize(170,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:g.localize(171,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:g.localize(172,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:g.localize(173,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:g.localize(174,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:g.localize(175,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:g.localize(176,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:g.localize(177,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:g.localize(178,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:g.localize(179,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const Ie=se;return{insertMode:s(Ie.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:r(Ie.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:r(Ie.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:r(Ie.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:r(Ie.shareSuggestSelections,this.defaultValue.shareSuggestSelections),selectionMode:s(Ie.selectionMode,this.defaultValue.selectionMode,["always","never","whenQuickSuggestion","whenTriggerCharacter"]),showIcons:r(Ie.showIcons,this.defaultValue.showIcons),showStatusBar:r(Ie.showStatusBar,this.defaultValue.showStatusBar),preview:r(Ie.preview,this.defaultValue.preview),previewMode:s(Ie.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:r(Ie.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:r(Ie.showMethods,this.defaultValue.showMethods),showFunctions:r(Ie.showFunctions,this.defaultValue.showFunctions),showConstructors:r(Ie.showConstructors,this.defaultValue.showConstructors),showDeprecated:r(Ie.showDeprecated,this.defaultValue.showDeprecated),matchOnWordStartOnly:r(Ie.matchOnWordStartOnly,this.defaultValue.matchOnWordStartOnly),showFields:r(Ie.showFields,this.defaultValue.showFields),showVariables:r(Ie.showVariables,this.defaultValue.showVariables),showClasses:r(Ie.showClasses,this.defaultValue.showClasses),showStructs:r(Ie.showStructs,this.defaultValue.showStructs),showInterfaces:r(Ie.showInterfaces,this.defaultValue.showInterfaces),showModules:r(Ie.showModules,this.defaultValue.showModules),showProperties:r(Ie.showProperties,this.defaultValue.showProperties),showEvents:r(Ie.showEvents,this.defaultValue.showEvents),showOperators:r(Ie.showOperators,this.defaultValue.showOperators),showUnits:r(Ie.showUnits,this.defaultValue.showUnits),showValues:r(Ie.showValues,this.defaultValue.showValues),showConstants:r(Ie.showConstants,this.defaultValue.showConstants),showEnums:r(Ie.showEnums,this.defaultValue.showEnums),showEnumMembers:r(Ie.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:r(Ie.showKeywords,this.defaultValue.showKeywords),showWords:r(Ie.showWords,this.defaultValue.showWords),showColors:r(Ie.showColors,this.defaultValue.showColors),showFiles:r(Ie.showFiles,this.defaultValue.showFiles),showReferences:r(Ie.showReferences,this.defaultValue.showReferences),showFolders:r(Ie.showFolders,this.defaultValue.showFolders),showTypeParameters:r(Ie.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:r(Ie.showSnippets,this.defaultValue.showSnippets),showUsers:r(Ie.showUsers,this.defaultValue.showUsers),showIssues:r(Ie.showIssues,this.defaultValue.showIssues)}}}class ze extends I{constructor(){super(112,"smartSelect",{selectLeadingAndTrailingWhitespace:!0,selectSubwords:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:g.localize(180,null),default:!0,type:"boolean"},"editor.smartSelect.selectSubwords":{description:g.localize(181,null),default:!0,type:"boolean"}})}validate(se){return!se||typeof se!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:r(se.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace),selectSubwords:r(se.selectSubwords,this.defaultValue.selectSubwords)}}}var Be;(function(le){le[le.None=0]="None",le[le.Same=1]="Same",le[le.Indent=2]="Indent",le[le.DeepIndent=3]="DeepIndent"})(Be||(e.WrappingIndent=Be={}));class xe extends I{constructor(){super(136,"wrappingIndent",1,{"editor.wrappingIndent":{type:"string",enum:["none","same","indent","deepIndent"],enumDescriptions:[g.localize(182,null),g.localize(183,null),g.localize(184,null),g.localize(185,null)],description:g.localize(186,null),default:"same"}})}validate(se){switch(se){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}return 1}compute(se,Ie,qe){return Ie.get(2)===2?0:qe}}class Ye extends C{constructor(){super(144)}compute(se,Ie,qe){const je=Ie.get(143);return{isDominatedByLongLines:se.isDominatedByLongLines,isWordWrapMinified:je.isWordWrapMinified,isViewportWrapping:je.isViewportWrapping,wrappingColumn:je.wrappingColumn}}}class it extends I{constructor(){const se={enabled:!0,showDropSelector:"afterDrop"};super(36,"dropIntoEditor",se,{"editor.dropIntoEditor.enabled":{type:"boolean",default:se.enabled,markdownDescription:g.localize(187,null)},"editor.dropIntoEditor.showDropSelector":{type:"string",markdownDescription:g.localize(188,null),enum:["afterDrop","never"],enumDescriptions:[g.localize(189,null),g.localize(190,null)],default:"afterDrop"}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const Ie=se;return{enabled:r(Ie.enabled,this.defaultValue.enabled),showDropSelector:s(Ie.showDropSelector,this.defaultValue.showDropSelector,["afterDrop","never"])}}}class et extends I{constructor(){const se={enabled:!0,showPasteSelector:"afterPaste"};super(84,"pasteAs",se,{"editor.pasteAs.enabled":{type:"boolean",default:se.enabled,markdownDescription:g.localize(191,null)},"editor.pasteAs.showPasteSelector":{type:"string",markdownDescription:g.localize(192,null),enum:["afterPaste","never"],enumDescriptions:[g.localize(193,null),g.localize(194,null)],default:"afterPaste"}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const Ie=se;return{enabled:r(Ie.enabled,this.defaultValue.enabled),showPasteSelector:s(Ie.showPasteSelector,this.defaultValue.showPasteSelector,["afterPaste","never"])}}}const Ae="Consolas, 'Courier New', monospace",Ne="Menlo, Monaco, 'Courier New', monospace",We="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:h.$j?Ne:h.$k?We:Ae,fontWeight:"normal",fontSize:h.$j?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function Le(le){return e.editorOptionsRegistry[le.id]=le,le}var Qe;(function(le){le[le.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",le[le.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",le[le.accessibilitySupport=2]="accessibilitySupport",le[le.accessibilityPageSize=3]="accessibilityPageSize",le[le.ariaLabel=4]="ariaLabel",le[le.ariaRequired=5]="ariaRequired",le[le.autoClosingBrackets=6]="autoClosingBrackets",le[le.autoClosingComments=7]="autoClosingComments",le[le.screenReaderAnnounceInlineSuggestion=8]="screenReaderAnnounceInlineSuggestion",le[le.autoClosingDelete=9]="autoClosingDelete",le[le.autoClosingOvertype=10]="autoClosingOvertype",le[le.autoClosingQuotes=11]="autoClosingQuotes",le[le.autoIndent=12]="autoIndent",le[le.automaticLayout=13]="automaticLayout",le[le.autoSurround=14]="autoSurround",le[le.bracketPairColorization=15]="bracketPairColorization",le[le.guides=16]="guides",le[le.codeLens=17]="codeLens",le[le.codeLensFontFamily=18]="codeLensFontFamily",le[le.codeLensFontSize=19]="codeLensFontSize",le[le.colorDecorators=20]="colorDecorators",le[le.colorDecoratorsLimit=21]="colorDecoratorsLimit",le[le.columnSelection=22]="columnSelection",le[le.comments=23]="comments",le[le.contextmenu=24]="contextmenu",le[le.copyWithSyntaxHighlighting=25]="copyWithSyntaxHighlighting",le[le.cursorBlinking=26]="cursorBlinking",le[le.cursorSmoothCaretAnimation=27]="cursorSmoothCaretAnimation",le[le.cursorStyle=28]="cursorStyle",le[le.cursorSurroundingLines=29]="cursorSurroundingLines",le[le.cursorSurroundingLinesStyle=30]="cursorSurroundingLinesStyle",le[le.cursorWidth=31]="cursorWidth",le[le.disableLayerHinting=32]="disableLayerHinting",le[le.disableMonospaceOptimizations=33]="disableMonospaceOptimizations",le[le.domReadOnly=34]="domReadOnly",le[le.dragAndDrop=35]="dragAndDrop",le[le.dropIntoEditor=36]="dropIntoEditor",le[le.emptySelectionClipboard=37]="emptySelectionClipboard",le[le.experimentalWhitespaceRendering=38]="experimentalWhitespaceRendering",le[le.extraEditorClassName=39]="extraEditorClassName",le[le.fastScrollSensitivity=40]="fastScrollSensitivity",le[le.find=41]="find",le[le.fixedOverflowWidgets=42]="fixedOverflowWidgets",le[le.folding=43]="folding",le[le.foldingStrategy=44]="foldingStrategy",le[le.foldingHighlight=45]="foldingHighlight",le[le.foldingImportsByDefault=46]="foldingImportsByDefault",le[le.foldingMaximumRegions=47]="foldingMaximumRegions",le[le.unfoldOnClickAfterEndOfLine=48]="unfoldOnClickAfterEndOfLine",le[le.fontFamily=49]="fontFamily",le[le.fontInfo=50]="fontInfo",le[le.fontLigatures=51]="fontLigatures",le[le.fontSize=52]="fontSize",le[le.fontWeight=53]="fontWeight",le[le.fontVariations=54]="fontVariations",le[le.formatOnPaste=55]="formatOnPaste",le[le.formatOnType=56]="formatOnType",le[le.glyphMargin=57]="glyphMargin",le[le.gotoLocation=58]="gotoLocation",le[le.hideCursorInOverviewRuler=59]="hideCursorInOverviewRuler",le[le.hover=60]="hover",le[le.inDiffEditor=61]="inDiffEditor",le[le.inlineSuggest=62]="inlineSuggest",le[le.letterSpacing=63]="letterSpacing",le[le.lightbulb=64]="lightbulb",le[le.lineDecorationsWidth=65]="lineDecorationsWidth",le[le.lineHeight=66]="lineHeight",le[le.lineNumbers=67]="lineNumbers",le[le.lineNumbersMinChars=68]="lineNumbersMinChars",le[le.linkedEditing=69]="linkedEditing",le[le.links=70]="links",le[le.matchBrackets=71]="matchBrackets",le[le.minimap=72]="minimap",le[le.mouseStyle=73]="mouseStyle",le[le.mouseWheelScrollSensitivity=74]="mouseWheelScrollSensitivity",le[le.mouseWheelZoom=75]="mouseWheelZoom",le[le.multiCursorMergeOverlapping=76]="multiCursorMergeOverlapping",le[le.multiCursorModifier=77]="multiCursorModifier",le[le.multiCursorPaste=78]="multiCursorPaste",le[le.multiCursorLimit=79]="multiCursorLimit",le[le.occurrencesHighlight=80]="occurrencesHighlight",le[le.overviewRulerBorder=81]="overviewRulerBorder",le[le.overviewRulerLanes=82]="overviewRulerLanes",le[le.padding=83]="padding",le[le.pasteAs=84]="pasteAs",le[le.parameterHints=85]="parameterHints",le[le.peekWidgetDefaultFocus=86]="peekWidgetDefaultFocus",le[le.definitionLinkOpensInPeek=87]="definitionLinkOpensInPeek",le[le.quickSuggestions=88]="quickSuggestions",le[le.quickSuggestionsDelay=89]="quickSuggestionsDelay",le[le.readOnly=90]="readOnly",le[le.readOnlyMessage=91]="readOnlyMessage",le[le.renameOnType=92]="renameOnType",le[le.renderControlCharacters=93]="renderControlCharacters",le[le.renderFinalNewline=94]="renderFinalNewline",le[le.renderLineHighlight=95]="renderLineHighlight",le[le.renderLineHighlightOnlyWhenFocus=96]="renderLineHighlightOnlyWhenFocus",le[le.renderValidationDecorations=97]="renderValidationDecorations",le[le.renderWhitespace=98]="renderWhitespace",le[le.revealHorizontalRightPadding=99]="revealHorizontalRightPadding",le[le.roundedSelection=100]="roundedSelection",le[le.rulers=101]="rulers",le[le.scrollbar=102]="scrollbar",le[le.scrollBeyondLastColumn=103]="scrollBeyondLastColumn",le[le.scrollBeyondLastLine=104]="scrollBeyondLastLine",le[le.scrollPredominantAxis=105]="scrollPredominantAxis",le[le.selectionClipboard=106]="selectionClipboard",le[le.selectionHighlight=107]="selectionHighlight",le[le.selectOnLineNumbers=108]="selectOnLineNumbers",le[le.showFoldingControls=109]="showFoldingControls",le[le.showUnused=110]="showUnused",le[le.snippetSuggestions=111]="snippetSuggestions",le[le.smartSelect=112]="smartSelect",le[le.smoothScrolling=113]="smoothScrolling",le[le.stickyScroll=114]="stickyScroll",le[le.stickyTabStops=115]="stickyTabStops",le[le.stopRenderingLineAfter=116]="stopRenderingLineAfter",le[le.suggest=117]="suggest",le[le.suggestFontSize=118]="suggestFontSize",le[le.suggestLineHeight=119]="suggestLineHeight",le[le.suggestOnTriggerCharacters=120]="suggestOnTriggerCharacters",le[le.suggestSelection=121]="suggestSelection",le[le.tabCompletion=122]="tabCompletion",le[le.tabIndex=123]="tabIndex",le[le.unicodeHighlighting=124]="unicodeHighlighting",le[le.unusualLineTerminators=125]="unusualLineTerminators",le[le.useShadowDOM=126]="useShadowDOM",le[le.useTabStops=127]="useTabStops",le[le.wordBreak=128]="wordBreak",le[le.wordSeparators=129]="wordSeparators",le[le.wordWrap=130]="wordWrap",le[le.wordWrapBreakAfterCharacters=131]="wordWrapBreakAfterCharacters",le[le.wordWrapBreakBeforeCharacters=132]="wordWrapBreakBeforeCharacters",le[le.wordWrapColumn=133]="wordWrapColumn",le[le.wordWrapOverride1=134]="wordWrapOverride1",le[le.wordWrapOverride2=135]="wordWrapOverride2",le[le.wrappingIndent=136]="wrappingIndent",le[le.wrappingStrategy=137]="wrappingStrategy",le[le.showDeprecated=138]="showDeprecated",le[le.inlayHints=139]="inlayHints",le[le.editorClassName=140]="editorClassName",le[le.pixelRatio=141]="pixelRatio",le[le.tabFocusMode=142]="tabFocusMode",le[le.layoutInfo=143]="layoutInfo",le[le.wrappingInfo=144]="wrappingInfo",le[le.defaultColorDecorators=145]="defaultColorDecorators",le[le.colorDecoratorsActivatedOn=146]="colorDecoratorsActivatedOn",le[le.inlineCompletionsAccessibilityVerbose=147]="inlineCompletionsAccessibilityVerbose"})(Qe||(e.EditorOption=Qe={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:Le(new i(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:g.localize(195,null)})),acceptSuggestionOnEnter:Le(new o(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",g.localize(196,null),""],markdownDescription:g.localize(197,null)})),accessibilitySupport:Le(new d),accessibilityPageSize:Le(new m(3,"accessibilityPageSize",10,1,1073741824,{description:g.localize(198,null),tags:["accessibility"]})),ariaLabel:Le(new t(4,"ariaLabel",g.localize(199,null))),ariaRequired:Le(new i(5,"ariaRequired",!1,void 0)),screenReaderAnnounceInlineSuggestion:Le(new i(8,"screenReaderAnnounceInlineSuggestion",!0,{description:g.localize(200,null),tags:["accessibility"]})),autoClosingBrackets:Le(new o(6,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",g.localize(201,null),g.localize(202,null),""],description:g.localize(203,null)})),autoClosingComments:Le(new o(7,"autoClosingComments","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",g.localize(204,null),g.localize(205,null),""],description:g.localize(206,null)})),autoClosingDelete:Le(new o(9,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",g.localize(207,null),""],description:g.localize(208,null)})),autoClosingOvertype:Le(new o(10,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",g.localize(209,null),""],description:g.localize(210,null)})),autoClosingQuotes:Le(new o(11,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",g.localize(211,null),g.localize(212,null),""],description:g.localize(213,null)})),autoIndent:Le(new n(12,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],c,{enumDescriptions:[g.localize(214,null),g.localize(215,null),g.localize(216,null),g.localize(217,null),g.localize(218,null)],description:g.localize(219,null)})),automaticLayout:Le(new i(13,"automaticLayout",!1)),autoSurround:Le(new o(14,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[g.localize(220,null),g.localize(221,null),g.localize(222,null),""],description:g.localize(223,null)})),bracketPairColorization:Le(new oe),bracketPairGuides:Le(new Y),stickyTabStops:Le(new i(115,"stickyTabStops",!1,{description:g.localize(224,null)})),codeLens:Le(new i(17,"codeLens",!0,{description:g.localize(225,null)})),codeLensFontFamily:Le(new t(18,"codeLensFontFamily","",{description:g.localize(226,null)})),codeLensFontSize:Le(new m(19,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:g.localize(227,null)})),colorDecorators:Le(new i(20,"colorDecorators",!0,{description:g.localize(228,null)})),colorDecoratorActivatedOn:Le(new o(146,"colorDecoratorsActivatedOn","clickAndHover",["clickAndHover","hover","click"],{enumDescriptions:[g.localize(229,null),g.localize(230,null),g.localize(231,null)],description:g.localize(232,null)})),colorDecoratorsLimit:Le(new m(21,"colorDecoratorsLimit",500,1,1e6,{markdownDescription:g.localize(233,null)})),columnSelection:Le(new i(22,"columnSelection",!1,{description:g.localize(234,null)})),comments:Le(new v),contextmenu:Le(new i(24,"contextmenu",!0)),copyWithSyntaxHighlighting:Le(new i(25,"copyWithSyntaxHighlighting",!0,{description:g.localize(235,null)})),cursorBlinking:Le(new n(26,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],u,{description:g.localize(236,null)})),cursorSmoothCaretAnimation:Le(new o(27,"cursorSmoothCaretAnimation","off",["off","explicit","on"],{enumDescriptions:[g.localize(237,null),g.localize(238,null),g.localize(239,null)],description:g.localize(240,null)})),cursorStyle:Le(new n(28,"cursorStyle",l.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],L,{description:g.localize(241,null)})),cursorSurroundingLines:Le(new m(29,"cursorSurroundingLines",0,0,1073741824,{description:g.localize(242,null)})),cursorSurroundingLinesStyle:Le(new o(30,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[g.localize(243,null),g.localize(244,null)],markdownDescription:g.localize(245,null)})),cursorWidth:Le(new m(31,"cursorWidth",0,0,1073741824,{markdownDescription:g.localize(246,null)})),disableLayerHinting:Le(new i(32,"disableLayerHinting",!1)),disableMonospaceOptimizations:Le(new i(33,"disableMonospaceOptimizations",!1)),domReadOnly:Le(new i(34,"domReadOnly",!1)),dragAndDrop:Le(new i(35,"dragAndDrop",!0,{description:g.localize(247,null)})),emptySelectionClipboard:Le(new j),dropIntoEditor:Le(new it),stickyScroll:Le(new ce),experimentalWhitespaceRendering:Le(new o(38,"experimentalWhitespaceRendering","svg",["svg","font","off"],{enumDescriptions:[g.localize(248,null),g.localize(249,null),g.localize(250,null)],description:g.localize(251,null)})),extraEditorClassName:Le(new t(39,"extraEditorClassName","")),fastScrollSensitivity:Le(new f(40,"fastScrollSensitivity",5,le=>le<=0?5:le,{markdownDescription:g.localize(252,null)})),find:Le(new T),fixedOverflowWidgets:Le(new i(42,"fixedOverflowWidgets",!1)),folding:Le(new i(43,"folding",!0,{description:g.localize(253,null)})),foldingStrategy:Le(new o(44,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[g.localize(254,null),g.localize(255,null)],description:g.localize(256,null)})),foldingHighlight:Le(new i(45,"foldingHighlight",!0,{description:g.localize(257,null)})),foldingImportsByDefault:Le(new i(46,"foldingImportsByDefault",!1,{description:g.localize(258,null)})),foldingMaximumRegions:Le(new m(47,"foldingMaximumRegions",5e3,10,65e3,{description:g.localize(259,null)})),unfoldOnClickAfterEndOfLine:Le(new i(48,"unfoldOnClickAfterEndOfLine",!1,{description:g.localize(260,null)})),fontFamily:Le(new t(49,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:g.localize(261,null)})),fontInfo:Le(new F),fontLigatures2:Le(new O),fontSize:Le(new J),fontWeight:Le(new K),fontVariations:Le(new B),formatOnPaste:Le(new i(55,"formatOnPaste",!1,{description:g.localize(262,null)})),formatOnType:Le(new i(56,"formatOnType",!1,{description:g.localize(263,null)})),glyphMargin:Le(new i(57,"glyphMargin",!0,{description:g.localize(264,null)})),gotoLocation:Le(new me),hideCursorInOverviewRuler:Le(new i(59,"hideCursorInOverviewRuler",!1,{description:g.localize(265,null)})),hover:Le(new re),inDiffEditor:Le(new i(61,"inDiffEditor",!1)),letterSpacing:Le(new f(63,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,le=>f.clamp(le,-5,20),{description:g.localize(266,null)})),lightbulb:Le(new pe),lineDecorationsWidth:Le(new Q),lineHeight:Le(new z),lineNumbers:Le(new ge),lineNumbersMinChars:Le(new m(68,"lineNumbersMinChars",5,1,300)),linkedEditing:Le(new i(69,"linkedEditing",!1,{description:g.localize(267,null)})),links:Le(new i(70,"links",!0,{description:g.localize(268,null)})),matchBrackets:Le(new o(71,"matchBrackets","always",["always","near","never"],{description:g.localize(269,null)})),minimap:Le(new V),mouseStyle:Le(new o(73,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:Le(new f(74,"mouseWheelScrollSensitivity",1,le=>le===0?1:le,{markdownDescription:g.localize(270,null)})),mouseWheelZoom:Le(new i(75,"mouseWheelZoom",!1,{markdownDescription:g.localize(271,null)})),multiCursorMergeOverlapping:Le(new i(76,"multiCursorMergeOverlapping",!0,{description:g.localize(272,null)})),multiCursorModifier:Le(new n(77,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],G,{markdownEnumDescriptions:[g.localize(273,null),g.localize(274,null)],markdownDescription:g.localize(275,null)})),multiCursorPaste:Le(new o(78,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[g.localize(276,null),g.localize(277,null)],markdownDescription:g.localize(278,null)})),multiCursorLimit:Le(new m(79,"multiCursorLimit",1e4,1,1e5,{markdownDescription:g.localize(279,null)})),occurrencesHighlight:Le(new i(80,"occurrencesHighlight",!0,{description:g.localize(280,null)})),overviewRulerBorder:Le(new i(81,"overviewRulerBorder",!0,{description:g.localize(281,null)})),overviewRulerLanes:Le(new m(82,"overviewRulerLanes",3,0,3)),padding:Le(new ae),pasteAs:Le(new et),parameterHints:Le(new ne),peekWidgetDefaultFocus:Le(new o(86,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[g.localize(282,null),g.localize(283,null)],description:g.localize(284,null)})),definitionLinkOpensInPeek:Le(new i(87,"definitionLinkOpensInPeek",!1,{description:g.localize(285,null)})),quickSuggestions:Le(new Ee),quickSuggestionsDelay:Le(new m(89,"quickSuggestionsDelay",10,0,1073741824,{description:g.localize(286,null)})),readOnly:Le(new i(90,"readOnly",!1)),readOnlyMessage:Le(new we),renameOnType:Le(new i(92,"renameOnType",!1,{description:g.localize(287,null),markdownDeprecationMessage:g.localize(288,null)})),renderControlCharacters:Le(new i(93,"renderControlCharacters",!0,{description:g.localize(289,null),restricted:!0})),renderFinalNewline:Le(new o(94,"renderFinalNewline",h.$k?"dimmed":"on",["off","on","dimmed"],{description:g.localize(290,null)})),renderLineHighlight:Le(new o(95,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",g.localize(291,null)],description:g.localize(292,null)})),renderLineHighlightOnlyWhenFocus:Le(new i(96,"renderLineHighlightOnlyWhenFocus",!1,{description:g.localize(293,null)})),renderValidationDecorations:Le(new o(97,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:Le(new o(98,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",g.localize(294,null),g.localize(295,null),g.localize(296,null),""],description:g.localize(297,null)})),revealHorizontalRightPadding:Le(new m(99,"revealHorizontalRightPadding",15,0,1e3)),roundedSelection:Le(new i(100,"roundedSelection",!0,{description:g.localize(298,null)})),rulers:Le(new ue),scrollbar:Le(new U),scrollBeyondLastColumn:Le(new m(103,"scrollBeyondLastColumn",4,0,1073741824,{description:g.localize(299,null)})),scrollBeyondLastLine:Le(new i(104,"scrollBeyondLastLine",!0,{description:g.localize(300,null)})),scrollPredominantAxis:Le(new i(105,"scrollPredominantAxis",!0,{description:g.localize(301,null)})),selectionClipboard:Le(new i(106,"selectionClipboard",!0,{description:g.localize(302,null),included:h.$k})),selectionHighlight:Le(new i(107,"selectionHighlight",!0,{description:g.localize(303,null)})),selectOnLineNumbers:Le(new i(108,"selectOnLineNumbers",!0)),showFoldingControls:Le(new o(109,"showFoldingControls","mouseover",["always","never","mouseover"],{enumDescriptions:[g.localize(304,null),g.localize(305,null),g.localize(306,null)],description:g.localize(307,null)})),showUnused:Le(new i(110,"showUnused",!0,{description:g.localize(308,null)})),showDeprecated:Le(new i(138,"showDeprecated",!0,{description:g.localize(309,null)})),inlayHints:Le(new _),snippetSuggestions:Le(new o(111,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[g.localize(310,null),g.localize(311,null),g.localize(312,null),g.localize(313,null)],description:g.localize(314,null)})),smartSelect:Le(new ze),smoothScrolling:Le(new i(113,"smoothScrolling",!1,{description:g.localize(315,null)})),stopRenderingLineAfter:Le(new m(116,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:Le(new ye),inlineSuggest:Le(new X),inlineCompletionsAccessibilityVerbose:Le(new i(147,"inlineCompletionsAccessibilityVerbose",!1,{description:g.localize(316,null)})),suggestFontSize:Le(new m(118,"suggestFontSize",0,0,1e3,{markdownDescription:g.localize(317,null,"`0`","`#editor.fontSize#`")})),suggestLineHeight:Le(new m(119,"suggestLineHeight",0,0,1e3,{markdownDescription:g.localize(318,null,"`0`","`#editor.lineHeight#`")})),suggestOnTriggerCharacters:Le(new i(120,"suggestOnTriggerCharacters",!0,{description:g.localize(319,null)})),suggestSelection:Le(new o(121,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[g.localize(320,null),g.localize(321,null),g.localize(322,null)],description:g.localize(323,null)})),tabCompletion:Le(new o(122,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[g.localize(324,null),g.localize(325,null),g.localize(326,null)],description:g.localize(327,null)})),tabIndex:Le(new m(123,"tabIndex",0,-1,1073741824)),unicodeHighlight:Le(new Z),unusualLineTerminators:Le(new o(125,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[g.localize(328,null),g.localize(329,null),g.localize(330,null)],description:g.localize(331,null)})),useShadowDOM:Le(new i(126,"useShadowDOM",!0)),useTabStops:Le(new i(127,"useTabStops",!0,{description:g.localize(332,null)})),wordBreak:Le(new o(128,"wordBreak","normal",["normal","keepAll"],{markdownEnumDescriptions:[g.localize(333,null),g.localize(334,null)],description:g.localize(335,null)})),wordSeparators:Le(new t(129,"wordSeparators",A.$Sr,{description:g.localize(336,null)})),wordWrap:Le(new o(130,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[g.localize(337,null),g.localize(338,null),g.localize(339,null),g.localize(340,null)],description:g.localize(341,null)})),wordWrapBreakAfterCharacters:Le(new t(131,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:Le(new t(132,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:Le(new m(133,"wordWrapColumn",80,1,1073741824,{markdownDescription:g.localize(342,null)})),wordWrapOverride1:Le(new o(134,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:Le(new o(135,"wordWrapOverride2","inherit",["off","on","inherit"])),editorClassName:Le(new N),defaultColorDecorators:Le(new i(145,"defaultColorDecorators",!1,{markdownDescription:g.localize(343,null)})),pixelRatio:Le(new he),tabFocusMode:Le(new i(142,"tabFocusMode",!1,{markdownDescription:g.localize(344,null)})),layoutInfo:Le(new q),wrappingInfo:Le(new Ye),wrappingIndent:Le(new xe),wrappingStrategy:Le(new ee)}}),define(De[184],Ce([11,12]),function($e,e){return $e.create("vs/editor/common/languages",e)}),define(De[81],Ce([1,0,76,2,162,34,172,184]),function($e,e,D,M,h,R,A,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExternalUriOpenerPriority=e.$$s=e.$0s=e.InlayHintKind=e.CommentState=e.CommentMode=e.CommentThreadState=e.CommentThreadCollapsibleState=e.Command=e.$9s=e.$8s=e.SymbolKinds=e.SymbolTag=e.$7s=e.$6s=e.SymbolKind=e.$5s=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.CodeActionTriggerType=e.$4s=e.InlineCompletionTriggerKind=e.CompletionTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.CompletionItemKinds=e.CompletionItemKind=e.$3s=e.$2s=e.$1s=void 0;class E{constructor(O,B,F){this.offset=O,this.type=B,this.language=F,this._tokenBrand=void 0}toString(){return"("+this.offset+", "+this.type+")"}}e.$1s=E;class ${constructor(O,B){this.tokens=O,this.endState=B,this._tokenizationResultBrand=void 0}}e.$2s=$;class P{constructor(O,B){this.tokens=O,this.endState=B,this._encodedTokenizationResultBrand=void 0}}e.$3s=P;var I;(function(T){T[T.Method=0]="Method",T[T.Function=1]="Function",T[T.Constructor=2]="Constructor",T[T.Field=3]="Field",T[T.Variable=4]="Variable",T[T.Class=5]="Class",T[T.Struct=6]="Struct",T[T.Interface=7]="Interface",T[T.Module=8]="Module",T[T.Property=9]="Property",T[T.Event=10]="Event",T[T.Operator=11]="Operator",T[T.Unit=12]="Unit",T[T.Value=13]="Value",T[T.Constant=14]="Constant",T[T.Enum=15]="Enum",T[T.EnumMember=16]="EnumMember",T[T.Keyword=17]="Keyword",T[T.Text=18]="Text",T[T.Color=19]="Color",T[T.File=20]="File",T[T.Reference=21]="Reference",T[T.Customcolor=22]="Customcolor",T[T.Folder=23]="Folder",T[T.TypeParameter=24]="TypeParameter",T[T.User=25]="User",T[T.Issue=26]="Issue",T[T.Snippet=27]="Snippet"})(I||(e.CompletionItemKind=I={}));var b;(function(T){const O=new Map;O.set(0,D.$Nj.symbolMethod),O.set(1,D.$Nj.symbolFunction),O.set(2,D.$Nj.symbolConstructor),O.set(3,D.$Nj.symbolField),O.set(4,D.$Nj.symbolVariable),O.set(5,D.$Nj.symbolClass),O.set(6,D.$Nj.symbolStruct),O.set(7,D.$Nj.symbolInterface),O.set(8,D.$Nj.symbolModule),O.set(9,D.$Nj.symbolProperty),O.set(10,D.$Nj.symbolEvent),O.set(11,D.$Nj.symbolOperator),O.set(12,D.$Nj.symbolUnit),O.set(13,D.$Nj.symbolValue),O.set(15,D.$Nj.symbolEnum),O.set(14,D.$Nj.symbolConstant),O.set(15,D.$Nj.symbolEnum),O.set(16,D.$Nj.symbolEnumMember),O.set(17,D.$Nj.symbolKeyword),O.set(27,D.$Nj.symbolSnippet),O.set(18,D.$Nj.symbolText),O.set(19,D.$Nj.symbolColor),O.set(20,D.$Nj.symbolFile),O.set(21,D.$Nj.symbolReference),O.set(22,D.$Nj.symbolCustomColor),O.set(23,D.$Nj.symbolFolder),O.set(24,D.$Nj.symbolTypeParameter),O.set(25,D.$Nj.account),O.set(26,D.$Nj.issues);function B(K){let me=O.get(K);return me||(console.info("No codicon found for CompletionItemKind "+K),me=D.$Nj.symbolProperty),me}T.toIcon=B;const F=new Map;F.set("method",0),F.set("function",1),F.set("constructor",2),F.set("field",3),F.set("variable",4),F.set("class",5),F.set("struct",6),F.set("interface",7),F.set("module",8),F.set("property",9),F.set("event",10),F.set("operator",11),F.set("unit",12),F.set("value",13),F.set("constant",14),F.set("enum",15),F.set("enum-member",16),F.set("enumMember",16),F.set("keyword",17),F.set("snippet",27),F.set("text",18),F.set("color",19),F.set("file",20),F.set("reference",21),F.set("customcolor",22),F.set("folder",23),F.set("type-parameter",24),F.set("typeParameter",24),F.set("account",25),F.set("issue",26);function J(K,me){let re=F.get(K);return typeof re>"u"&&!me&&(re=9),re}T.fromString=J})(b||(e.CompletionItemKinds=b={}));var S;(function(T){T[T.Deprecated=1]="Deprecated"})(S||(e.CompletionItemTag=S={}));var C;(function(T){T[T.None=0]="None",T[T.KeepWhitespace=1]="KeepWhitespace",T[T.InsertAsSnippet=4]="InsertAsSnippet"})(C||(e.CompletionItemInsertTextRule=C={}));var y;(function(T){T[T.Invoke=0]="Invoke",T[T.TriggerCharacter=1]="TriggerCharacter",T[T.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(y||(e.CompletionTriggerKind=y={}));var r;(function(T){T[T.Automatic=0]="Automatic",T[T.Explicit=1]="Explicit"})(r||(e.InlineCompletionTriggerKind=r={}));class i{constructor(O,B,F,J){this.range=O,this.text=B,this.completionKind=F,this.isSnippetText=J}equals(O){return R.$hs.lift(this.range).equalsRange(O.range)&&this.text===O.text&&this.completionKind===O.completionKind&&this.isSnippetText===O.isSnippetText}}e.$4s=i;var a;(function(T){T[T.Invoke=1]="Invoke",T[T.Auto=2]="Auto"})(a||(e.CodeActionTriggerType=a={}));var m;(function(T){T[T.Invoke=1]="Invoke",T[T.TriggerCharacter=2]="TriggerCharacter",T[T.ContentChange=3]="ContentChange"})(m||(e.SignatureHelpTriggerKind=m={}));var p;(function(T){T[T.Text=0]="Text",T[T.Read=1]="Read",T[T.Write=2]="Write"})(p||(e.DocumentHighlightKind=p={}));function f(T){return T&&M.URI.isUri(T.uri)&&R.$hs.isIRange(T.range)&&(R.$hs.isIRange(T.originSelectionRange)||R.$hs.isIRange(T.targetSelectionRange))}e.$5s=f;var t;(function(T){T[T.File=0]="File",T[T.Module=1]="Module",T[T.Namespace=2]="Namespace",T[T.Package=3]="Package",T[T.Class=4]="Class",T[T.Method=5]="Method",T[T.Property=6]="Property",T[T.Field=7]="Field",T[T.Constructor=8]="Constructor",T[T.Enum=9]="Enum",T[T.Interface=10]="Interface",T[T.Function=11]="Function",T[T.Variable=12]="Variable",T[T.Constant=13]="Constant",T[T.String=14]="String",T[T.Number=15]="Number",T[T.Boolean=16]="Boolean",T[T.Array=17]="Array",T[T.Object=18]="Object",T[T.Key=19]="Key",T[T.Null=20]="Null",T[T.EnumMember=21]="EnumMember",T[T.Struct=22]="Struct",T[T.Event=23]="Event",T[T.Operator=24]="Operator",T[T.TypeParameter=25]="TypeParameter"})(t||(e.SymbolKind=t={})),e.$6s={[17]:(0,g.localize)(0,null),[16]:(0,g.localize)(1,null),[4]:(0,g.localize)(2,null),[13]:(0,g.localize)(3,null),[8]:(0,g.localize)(4,null),[9]:(0,g.localize)(5,null),[21]:(0,g.localize)(6,null),[23]:(0,g.localize)(7,null),[7]:(0,g.localize)(8,null),[0]:(0,g.localize)(9,null),[11]:(0,g.localize)(10,null),[10]:(0,g.localize)(11,null),[19]:(0,g.localize)(12,null),[5]:(0,g.localize)(13,null),[1]:(0,g.localize)(14,null),[2]:(0,g.localize)(15,null),[20]:(0,g.localize)(16,null),[15]:(0,g.localize)(17,null),[18]:(0,g.localize)(18,null),[24]:(0,g.localize)(19,null),[3]:(0,g.localize)(20,null),[6]:(0,g.localize)(21,null),[14]:(0,g.localize)(22,null),[22]:(0,g.localize)(23,null),[25]:(0,g.localize)(24,null),[12]:(0,g.localize)(25,null)};function s(T,O){return(0,g.localize)(26,null,T,e.$6s[O])}e.$7s=s;var o;(function(T){T[T.Deprecated=1]="Deprecated"})(o||(e.SymbolTag=o={}));var n;(function(T){const O=new Map;O.set(0,D.$Nj.symbolFile),O.set(1,D.$Nj.symbolModule),O.set(2,D.$Nj.symbolNamespace),O.set(3,D.$Nj.symbolPackage),O.set(4,D.$Nj.symbolClass),O.set(5,D.$Nj.symbolMethod),O.set(6,D.$Nj.symbolProperty),O.set(7,D.$Nj.symbolField),O.set(8,D.$Nj.symbolConstructor),O.set(9,D.$Nj.symbolEnum),O.set(10,D.$Nj.symbolInterface),O.set(11,D.$Nj.symbolFunction),O.set(12,D.$Nj.symbolVariable),O.set(13,D.$Nj.symbolConstant),O.set(14,D.$Nj.symbolString),O.set(15,D.$Nj.symbolNumber),O.set(16,D.$Nj.symbolBoolean),O.set(17,D.$Nj.symbolArray),O.set(18,D.$Nj.symbolObject),O.set(19,D.$Nj.symbolKey),O.set(20,D.$Nj.symbolNull),O.set(21,D.$Nj.symbolEnumMember),O.set(22,D.$Nj.symbolStruct),O.set(23,D.$Nj.symbolEvent),O.set(24,D.$Nj.symbolOperator),O.set(25,D.$Nj.symbolTypeParameter);function B(F){let J=O.get(F);return J||(console.info("No codicon found for SymbolKind "+F),J=D.$Nj.symbolProperty),J}T.toIcon=B})(n||(e.SymbolKinds=n={}));class c{static asEditOperation(O){return h.$is.replace(R.$hs.lift(O.range),O.text)}}e.$8s=c;class d{static{this.Comment=new d("comment")}static{this.Imports=new d("imports")}static{this.Region=new d("region")}static fromValue(O){switch(O){case"comment":return d.Comment;case"imports":return d.Imports;case"region":return d.Region}return new d(O)}constructor(O){this.value=O}}e.$9s=d;var v;(function(T){function O(B){return!B||typeof B!="object"?!1:typeof B.id=="string"&&typeof B.title=="string"}T.is=O})(v||(e.Command=v={}));var k;(function(T){T[T.Collapsed=0]="Collapsed",T[T.Expanded=1]="Expanded"})(k||(e.CommentThreadCollapsibleState=k={}));var u;(function(T){T[T.Unresolved=0]="Unresolved",T[T.Resolved=1]="Resolved"})(u||(e.CommentThreadState=u={}));var l;(function(T){T[T.Editing=0]="Editing",T[T.Preview=1]="Preview"})(l||(e.CommentMode=l={}));var w;(function(T){T[T.Published=0]="Published",T[T.Draft=1]="Draft"})(w||(e.CommentState=w={}));var L;(function(T){T[T.Type=1]="Type",T[T.Parameter=2]="Parameter"})(L||(e.InlayHintKind=L={}));class N{constructor(O){this.b=O,this.a=null}dispose(){this.a&&this.a.then(O=>{O&&O.dispose()})}get tokenizationSupport(){return this.a||(this.a=this.b()),this.a}}e.$0s=N,e.$$s=new A.$Ss;var j;(function(T){T[T.None=0]="None",T[T.Option=1]="Option",T[T.Default=2]="Default",T[T.Preferred=3]="Preferred"})(j||(e.ExternalUriOpenerPriority=j={}))}),define(De[185],Ce([11,12]),function($e,e){return $e.create("vs/platform/configuration/common/configurationRegistry",e)}),define(De[186],Ce([11,12]),function($e,e){return $e.create("vs/platform/contextkey/common/contextkey",e)}),define(De[187],Ce([11,12]),function($e,e){return $e.create("vs/platform/contextkey/common/scanner",e)}),define(De[188],Ce([11,12]),function($e,e){return $e.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(De[189],Ce([11,12]),function($e,e){return $e.create("vs/platform/extensions/common/extensionValidator",e)}),define(De[190],Ce([11,12]),function($e,e){return $e.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(De[191],Ce([11,12]),function($e,e){return $e.create("vs/platform/files/common/files",e)}),define(De[192],Ce([11,12]),function($e,e){return $e.create("vs/platform/files/common/io",e)}),define(De[193],Ce([11,12]),function($e,e){return $e.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(De[194],Ce([11,12]),function($e,e){return $e.create("vs/platform/markers/common/markers",e)}),define(De[195],Ce([11,12]),function($e,e){return $e.create("vs/platform/theme/common/iconRegistry",e)}),define(De[196],Ce([11,12]),function($e,e){return $e.create("vs/platform/workspace/common/workspace",e)}),define(De[197],Ce([11,12]),function($e,e){return $e.create("vs/workbench/api/common/extHostChat",e)}),define(De[198],Ce([11,12]),function($e,e){return $e.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(De[199],Ce([11,12]),function($e,e){return $e.create("vs/workbench/api/common/extHostExtensionService",e)}),define(De[200],Ce([11,12]),function($e,e){return $e.create("vs/workbench/api/common/extHostLanguageFeatures",e)}),define(De[201],Ce([11,12]),function($e,e){return $e.create("vs/workbench/api/common/extHostLogService",e)}),define(De[202],Ce([11,12]),function($e,e){return $e.create("vs/workbench/api/common/extHostNotebook",e)}),define(De[203],Ce([11,12]),function($e,e){return $e.create("vs/workbench/api/common/extHostProgress",e)}),define(De[204],Ce([11,12]),function($e,e){return $e.create("vs/workbench/api/common/extHostStatusBar",e)}),define(De[205],Ce([11,12]),function($e,e){return $e.create("vs/workbench/api/common/extHostTelemetry",e)}),define(De[206],Ce([11,12]),function($e,e){return $e.create("vs/workbench/api/common/extHostTerminalService",e)}),define(De[207],Ce([11,12]),function($e,e){return $e.create("vs/workbench/api/common/extHostTreeViews",e)}),define(De[208],Ce([11,12]),function($e,e){return $e.create("vs/workbench/api/common/extHostTunnelService",e)}),define(De[209],Ce([11,12]),function($e,e){return $e.create("vs/workbench/api/common/extHostWorkspace",e)}),define(De[210],Ce([11,12]),function($e,e){return $e.create("vs/workbench/api/node/extHostDebugService",e)}),define(De[211],Ce([11,12]),function($e,e){return $e.create("vs/workbench/common/editor",e)}),define(De[212],Ce([11,12]),function($e,e){return $e.create("vs/workbench/common/views",e)}),define(De[213],Ce([11,12]),function($e,e){return $e.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(De[214],Ce([11,12]),function($e,e){return $e.create("vs/workbench/contrib/debug/common/debug",e)}),define(De[215],Ce([11,12]),function($e,e){return $e.create("vs/workbench/contrib/debug/node/debugAdapter",e)}),define(De[216],Ce([11,12]),function($e,e){return $e.create("vs/workbench/contrib/tasks/common/taskDefinitionRegistry",e)}),define(De[217],Ce([11,12]),function($e,e){return $e.create("vs/workbench/contrib/tasks/common/tasks",e)}),define(De[218],Ce([11,12]),function($e,e){return $e.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(De[219],Ce([11,12]),function($e,e){return $e.create("vs/workbench/services/extensions/common/extensionsRegistry",e)}),define(De[220],Ce([11,12]),function($e,e){return $e.create("vs/workbench/services/search/common/queryBuilder",e)}),define(De[221],Ce([1,0,8,187]),function($e,e,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Di=e.TokenType=void 0;var h;(function($){$[$.LParen=0]="LParen",$[$.RParen=1]="RParen",$[$.Neg=2]="Neg",$[$.Eq=3]="Eq",$[$.NotEq=4]="NotEq",$[$.Lt=5]="Lt",$[$.LtEq=6]="LtEq",$[$.Gt=7]="Gt",$[$.GtEq=8]="GtEq",$[$.RegexOp=9]="RegexOp",$[$.RegexStr=10]="RegexStr",$[$.True=11]="True",$[$.False=12]="False",$[$.In=13]="In",$[$.Not=14]="Not",$[$.And=15]="And",$[$.Or=16]="Or",$[$.Str=17]="Str",$[$.QuotedStr=18]="QuotedStr",$[$.Error=19]="Error",$[$.EOF=20]="EOF"})(h||(e.TokenType=h={}));function R(...$){switch($.length){case 1:return(0,M.localize)(0,null,$[0]);case 2:return(0,M.localize)(1,null,$[0],$[1]);case 3:return(0,M.localize)(2,null,$[0],$[1],$[2]);default:return}}const A=(0,M.localize)(3,null),g=(0,M.localize)(4,null);class E{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(P){switch(P.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return P.isTripleEq?"===":"==";case 4:return P.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return P.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return P.lexeme;case 18:return P.lexeme;case 19:return P.lexeme;case 20:return"EOF";default:throw(0,D.$6)(`unhandled token type: ${JSON.stringify(P)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(P=>P.charCodeAt(0)))}static{this.b=new Map([["not",14],["in",13],["false",12],["true",11]])}get errors(){return this.g}reset(P){return this.c=P,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case 40:this.k(0);break;case 41:this.k(1);break;case 33:if(this.h(61)){const I=this.h(61);this.f.push({type:4,offset:this.d,isTripleEq:I})}else this.k(2);break;case 39:this.o();break;case 47:this.q();break;case 61:if(this.h(61)){const I=this.h(61);this.f.push({type:3,offset:this.d,isTripleEq:I})}else this.h(126)?this.k(9):this.l(R("==","=~"));break;case 60:this.k(this.h(61)?6:5);break;case 62:this.k(this.h(61)?8:7);break;case 38:this.h(38)?this.k(15):this.l(R("&&"));break;case 124:this.h(124)?this.k(16):this.l(R("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this.n()}return this.d=this.e,this.k(20),Array.from(this.f)}h(P){return this.r()||this.c.charCodeAt(this.e)!==P?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?0:this.c.charCodeAt(this.e)}k(P){this.f.push({type:P,offset:this.d})}l(P){const I=this.d,b=this.c.substring(this.d,this.e),S={type:19,offset:this.d,lexeme:b};this.g.push({offset:I,lexeme:b,additionalInfo:P}),this.f.push(S)}n(){this.m.lastIndex=this.d;const P=this.m.exec(this.c);if(P){this.e=this.d+P[0].length;const I=this.c.substring(this.d,this.e),b=E.b.get(I);b?this.k(b):this.f.push({type:17,lexeme:I,offset:this.d})}}o(){for(;this.j()!==39&&!this.r();)this.i();if(this.r()){this.l(A);return}this.i(),this.f.push({type:18,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let P=this.e,I=!1,b=!1;for(;;){if(P>=this.c.length){this.e=P,this.l(g);return}const C=this.c.charCodeAt(P);if(I)I=!1;else if(C===47&&!b){P++;break}else C===91?b=!0:C===92?I=!0:C===93&&(b=!1);P++}for(;P<this.c.length&&E.a.has(this.c.charCodeAt(P));)P++;this.e=P;const S=this.c.substring(this.d,this.e);this.f.push({type:10,lexeme:S,offset:this.d})}r(){return this.e>=this.c.length}}e.$Di=E}),define(De[222],Ce([1,0,24,40,189,362]),function($e,e,D,M,h,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fo=e.$Eo=e.$Do=e.$Co=e.$Bo=e.$Ao=e.$zo=void 0;const A=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,g=/^-(\d{4})(\d{2})(\d{2})$/;function E(i){return i=i.trim(),i==="*"||A.test(i)}e.$zo=E;function $(i){if(!E(i))return null;if(i=i.trim(),i==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const a=i.match(A);return a?{hasCaret:a[1]==="^",hasGreaterEquals:a[1]===">=",majorBase:a[2]==="x"?0:parseInt(a[2],10),majorMustEqual:a[2]!=="x",minorBase:a[4]==="x"?0:parseInt(a[4],10),minorMustEqual:a[4]!=="x",patchBase:a[6]==="x"?0:parseInt(a[6],10),patchMustEqual:a[6]!=="x",preRelease:a[8]||null}:null}e.$Ao=$;function P(i){if(!i)return null;const a=i.majorBase,m=i.majorMustEqual,p=i.minorBase;let f=i.minorMustEqual;const t=i.patchBase;let s=i.patchMustEqual;i.hasCaret&&(a===0||(f=!1),s=!1);let o=0;if(i.preRelease){const n=g.exec(i.preRelease);if(n){const[,c,d,v]=n;o=Date.UTC(Number(c),Number(d)-1,Number(v))}}return{majorBase:a,majorMustEqual:m,minorBase:p,minorMustEqual:f,patchBase:t,patchMustEqual:s,isMinimum:i.hasGreaterEquals,notBefore:o}}e.$Bo=P;function I(i,a,m){let p;typeof i=="string"?p=P($(i)):p=i;let f;a instanceof Date?f=a.getTime():typeof a=="string"&&(f=new Date(a).getTime());let t;if(typeof m=="string"?t=P($(m)):t=m,!p||!t)return!1;const s=p.majorBase,o=p.minorBase,n=p.patchBase;let c=t.majorBase,d=t.minorBase,v=t.patchBase;const k=t.notBefore;let u=t.majorMustEqual,l=t.minorMustEqual,w=t.patchMustEqual;return t.isMinimum?s>c?!0:s<c?!1:o>d?!0:o<d||f&&f<k?!1:n>=v:(s===1&&c===0&&(!u||!l||!w)&&(c=1,d=0,v=0,u=!0,l=!1,w=!1),s<c?!1:s>c?!u:o<d?!1:o>d?!l:n<v?!1:n>v?!w:!(f&&f<k))}e.$Co=I;function b(i,a,m,p,f){const t=[];if(typeof p.publisher<"u"&&typeof p.publisher!="string")return t.push([M.default.Error,h.localize(0,null)]),t;if(typeof p.name!="string")return t.push([M.default.Error,h.localize(1,null,"name")]),t;if(typeof p.version!="string")return t.push([M.default.Error,h.localize(2,null,"version")]),t;if(!p.engines)return t.push([M.default.Error,h.localize(3,null,"engines")]),t;if(typeof p.engines.vscode!="string")return t.push([M.default.Error,h.localize(4,null,"engines.vscode")]),t;if(typeof p.extensionDependencies<"u"&&!r(p.extensionDependencies))return t.push([M.default.Error,h.localize(5,null,"extensionDependencies")]),t;if(typeof p.activationEvents<"u"){if(!r(p.activationEvents))return t.push([M.default.Error,h.localize(6,null,"activationEvents")]),t;if(typeof p.main>"u"&&typeof p.browser>"u")return t.push([M.default.Error,h.localize(7,null,"activationEvents","main","browser")]),t}if(typeof p.extensionKind<"u"&&typeof p.main>"u"&&t.push([M.default.Warning,h.localize(8,null,"extensionKind")]),typeof p.main<"u"){if(typeof p.main!="string")return t.push([M.default.Error,h.localize(9,null,"main")]),t;{const n=(0,D.$gg)(m,p.main);(0,D.$ag)(n,m)||t.push([M.default.Warning,h.localize(10,null,n.path,m.path)])}}if(typeof p.browser<"u"){if(typeof p.browser!="string")return t.push([M.default.Error,h.localize(11,null,"browser")]),t;{const n=(0,D.$gg)(m,p.browser);(0,D.$ag)(n,m)||t.push([M.default.Warning,h.localize(12,null,n.path,m.path)])}}if(!R.valid(p.version))return t.push([M.default.Error,h.localize(13,null)]),t;const s=[];if(!S(i,a,p,f,s))for(const n of s)t.push([M.default.Error,n]);return t}e.$Do=b;function S(i,a,m,p,f){return p||typeof m.main>"u"&&typeof m.browser>"u"?!0:y(i,a,m.engines.vscode,f)}e.$Eo=S;function C(i,a,m){return i==="*"||y(a,m,i)}e.$Fo=C;function y(i,a,m,p=[]){const f=P($(m));if(!f)return p.push(h.localize(14,null,m)),!1;if(f.majorBase===0){if(!f.majorMustEqual||!f.minorMustEqual)return p.push(h.localize(15,null,m)),!1}else if(!f.majorMustEqual)return p.push(h.localize(16,null,m)),!1;return I(i,a,f)?!0:(p.push(h.localize(17,null,i,m)),!1)}function r(i){if(!Array.isArray(i))return!1;for(let a=0,m=i.length;a<m;a++)if(typeof i[a]!="string")return!1;return!0}}),define(De[101],Ce([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wh=void 0;class D{constructor(h,R=[],A=!1){this.ctor=h,this.staticArguments=R,this.supportsDelayedInstantiation=A}}e.$wh=D}),define(De[102],Ce([1,0,101]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kr=e.$jr=e.InstantiationType=void 0;const M=[];var h;(function(g){g[g.Eager=0]="Eager",g[g.Delayed=1]="Delayed"})(h||(e.InstantiationType=h={}));function R(g,E,$){E instanceof D.$wh||(E=new D.$wh(E,[],!!$)),M.push([g,E])}e.$jr=R;function A(){return M}e.$kr=A}),define(De[223],Ce([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2p=e.$1p=void 0;class D{constructor(R,A){this.key=R,this.data=A,this.incoming=new Map,this.outgoing=new Map}}e.$1p=D;class M{constructor(R){this.b=R,this.a=new Map}roots(){const R=[];for(const A of this.a.values())A.outgoing.size===0&&R.push(A);return R}insertEdge(R,A){const g=this.lookupOrInsertNode(R),E=this.lookupOrInsertNode(A);g.outgoing.set(E.key,E),E.incoming.set(g.key,g)}removeNode(R){const A=this.b(R);this.a.delete(A);for(const g of this.a.values())g.outgoing.delete(A),g.incoming.delete(A)}lookupOrInsertNode(R){const A=this.b(R);let g=this.a.get(A);return g||(g=new D(A,R),this.a.set(A,g)),g}lookup(R){return this.a.get(this.b(R))}isEmpty(){return this.a.size===0}toString(){const R=[];for(const[A,g]of this.a)R.push(`${A}
	(-> incoming)[${[...g.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...g.outgoing.keys()].join(",")}]
`);return R.join(`
`)}findCycleSlow(){for(const[R,A]of this.a){const g=new Set([R]),E=this.c(A,g);if(E)return E}}c(R,A){for(const[g,E]of R.outgoing){if(A.has(g))return[...A,g].join(" -> ");A.add(g);const $=this.c(E,A);if($)return $;A.delete(g)}}}e.$2p=M}),define(De[6],Ce([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ah=e.$zh=e.$yh=e._util=void 0;var D;(function(A){A.serviceIds=new Map,A.DI_TARGET="$di$target",A.DI_DEPENDENCIES="$di$dependencies";function g(E){return E[A.DI_DEPENDENCIES]||[]}A.getServiceDependencies=g})(D||(e._util=D={})),e.$yh=h("instantiationService");function M(A,g,E){g[D.DI_TARGET]===g?g[D.DI_DEPENDENCIES].push({id:A,index:E}):(g[D.DI_DEPENDENCIES]=[{id:A,index:E}],g[D.DI_TARGET]=g)}function h(A){if(D.serviceIds.has(A))return D.serviceIds.get(A);const g=function(E,$,P){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");M(g,E,P)};return g.toString=()=>A,D.serviceIds.set(A,g),g}e.$zh=h;function R(A){return A}e.$Ah=R}),define(De[50],Ce([1,0,18,2,6]),function($e,e,D,M,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$di=e.$ci=e.$bi=e.$ai=e.$_h=e.$$h=e.$0h=e.$9h=e.ConfigurationTarget=e.$8h=e.$7h=e.$6h=void 0,e.$6h=(0,h.$zh)("configurationService");function R(i){return i&&typeof i=="object"&&(!i.overrideIdentifier||typeof i.overrideIdentifier=="string")&&(!i.resource||i.resource instanceof M.URI)}e.$7h=R;function A(i){return i&&typeof i=="object"&&(!i.overrideIdentifiers||Array.isArray(i.overrideIdentifiers))&&!i.overrideIdentifier&&(!i.resource||i.resource instanceof M.URI)}e.$8h=A;var g;(function(i){i[i.APPLICATION=1]="APPLICATION",i[i.USER=2]="USER",i[i.USER_LOCAL=3]="USER_LOCAL",i[i.USER_REMOTE=4]="USER_REMOTE",i[i.WORKSPACE=5]="WORKSPACE",i[i.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",i[i.DEFAULT=7]="DEFAULT",i[i.MEMORY=8]="MEMORY"})(g||(e.ConfigurationTarget=g={}));function E(i){switch(i){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.$9h=E;function $(i){return i.applicationValue!==void 0||i.userValue!==void 0||i.userLocalValue!==void 0||i.userRemoteValue!==void 0||i.workspaceValue!==void 0||i.workspaceFolderValue!==void 0}e.$0h=$;function P(i,a){const m=Object.create(null);for(const p in i)I(m,p,i[p],a);return m}e.$$h=P;function I(i,a,m,p){const f=a.split("."),t=f.pop();let s=i;for(let o=0;o<f.length;o++){const n=f[o];let c=s[n];switch(typeof c){case"undefined":c=s[n]=Object.create(null);break;case"object":break;default:p(`Ignoring ${a} as ${f.slice(0,o+1).join(".")} is ${JSON.stringify(c)}`);return}s=c}if(typeof s=="object"&&s!==null)try{s[t]=m}catch{p(`Ignoring ${a} as ${f.join(".")} is ${JSON.stringify(s)}`)}else p(`Ignoring ${a} as ${f.join(".")} is ${JSON.stringify(s)}`)}e.$_h=I;function b(i,a){const m=a.split(".");S(i,m)}e.$ai=b;function S(i,a){const m=a.shift();if(a.length===0){delete i[m];return}if(Object.keys(i).indexOf(m)!==-1){const p=i[m];typeof p=="object"&&!Array.isArray(p)&&(S(p,a),Object.keys(p).length===0&&delete i[m])}}function C(i,a,m){function p(s,o){let n=s;for(const c of o){if(typeof n!="object"||n===null)return;n=n[c]}return n}const f=a.split("."),t=p(i,f);return typeof t>"u"?m:t}e.$bi=C;function y(i,a,m){Object.keys(a).forEach(p=>{p!=="__proto__"&&(p in i?D.$ne(i[p])&&D.$ne(a[p])?y(i[p],a[p],m):m&&(i[p]=a[p]):i[p]=a[p])})}e.$ci=y;function r(i){return i.replace(/[\[\]]/g,"")}e.$di=r}),define(De[47],Ce([1,0,9,15,221,6,186,8]),function($e,e,D,M,h,R,A,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2i=e.$1i=e.$Zi=e.$Yi=e.$Xi=e.$Wi=e.$Vi=e.$Ui=e.$Ti=e.$Si=e.$Ri=e.$Qi=e.$Pi=e.$Oi=e.$Ni=e.$Mi=e.$Li=e.$Ki=e.$Ji=e.$Ii=e.$Hi=e.$Gi=e.$Fi=e.ContextKeyExprType=e.$Ei=void 0;const E=new Map;E.set("false",!1),E.set("true",!0),E.set("isMac",D.$j),E.set("isLinux",D.$k),E.set("isWindows",D.$i),E.set("isWeb",D.$o),E.set("isMacNative",D.$j&&!D.$o),E.set("isEdge",D.$G),E.set("isFirefox",D.$E),E.set("isChrome",D.$D),E.set("isSafari",D.$F);function $(Q,z){if(E.get(Q)!==void 0)throw(0,g.$5)("contextkey.setConstant(k, v) invoked with already set constant `k`");E.set(Q,z)}e.$Ei=$;const P=Object.prototype.hasOwnProperty;var I;(function(Q){Q[Q.False=0]="False",Q[Q.True=1]="True",Q[Q.Defined=2]="Defined",Q[Q.Not=3]="Not",Q[Q.Equals=4]="Equals",Q[Q.NotEquals=5]="NotEquals",Q[Q.And=6]="And",Q[Q.Regex=7]="Regex",Q[Q.NotRegex=8]="NotRegex",Q[Q.Or=9]="Or",Q[Q.In=10]="In",Q[Q.NotIn=11]="NotIn",Q[Q.Greater=12]="Greater",Q[Q.GreaterEquals=13]="GreaterEquals",Q[Q.Smaller=14]="Smaller",Q[Q.SmallerEquals=15]="SmallerEquals"})(I||(e.ContextKeyExprType=I={}));const b={regexParsingWithErrorRecovery:!0},S=(0,A.localize)(0,null),C=(0,A.localize)(1,null),y=(0,A.localize)(2,null),r=(0,A.localize)(3,null),i=(0,A.localize)(4,null),a=(0,A.localize)(5,null),m=(0,A.localize)(6,null),p=(0,A.localize)(7,null);class f{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(z=b){this.k=z,this.d=new h.$Di,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(z){if(z===""){this.h.push({message:S,offset:0,lexeme:"",additionalInfo:C});return}this.f=this.d.reset(z).scan(),this.g=0,this.h=[];try{const V=this.l();if(!this.E()){const G=this.D(),ae=G.type===17?a:void 0;throw this.h.push({message:i,offset:G.offset,lexeme:h.$Di.getLexeme(G),additionalInfo:ae}),f.c}return V}catch(V){if(V!==f.c)throw V;return}}l(){return this.m()}m(){const z=[this.o()];for(;this.y(16);){const V=this.o();z.push(V)}return z.length===1?z[0]:t.or(...z)}o(){const z=[this.s()];for(;this.y(15);){const V=this.s();z.push(V)}return z.length===1?z[0]:t.and(...z)}s(){if(this.y(2)){const z=this.D();switch(z.type){case 11:return this.z(),c.INSTANCE;case 12:return this.z(),d.INSTANCE;case 0:{this.z();const V=this.l();return this.A(1,r),V?.negate()}case 17:return this.z(),L.create(z.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",z)}}return this.t()}t(){const z=this.D();switch(z.type){case 11:return this.z(),t.true();case 12:return this.z(),t.false();case 0:{this.z();const V=this.l();return this.A(1,r),V}case 17:{const V=z.lexeme;if(this.z(),this.y(9)){const ae=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),ae.type!==10)throw this.B("REGEX",ae);const ne=ae.lexeme,he=ne.lastIndexOf("/"),Ee=he===ne.length-1?void 0:this.w(ne.substring(he+1));let de;try{de=new RegExp(ne.substring(1,he),Ee)}catch{throw this.B("REGEX",ae)}return F.create(V,de)}switch(ae.type){case 10:case 19:{const ne=[ae.lexeme];this.z();let he=this.D(),Ee=0;for(let we=0;we<ae.lexeme.length;we++)ae.lexeme.charCodeAt(we)===40?Ee++:ae.lexeme.charCodeAt(we)===41&&Ee--;for(;!this.E()&&he.type!==15&&he.type!==16;){switch(he.type){case 0:Ee++;break;case 1:Ee--;break;case 10:case 18:for(let we=0;we<he.lexeme.length;we++)he.lexeme.charCodeAt(we)===40?Ee++:ae.lexeme.charCodeAt(we)===41&&Ee--}if(Ee<0)break;ne.push(h.$Di.getLexeme(he)),this.z(),he=this.D()}const de=ne.join(""),ge=de.lastIndexOf("/"),ie=ge===de.length-1?void 0:this.w(de.substring(ge+1));let ue;try{ue=new RegExp(de.substring(1,ge),ie)}catch{throw this.B("REGEX",ae)}return t.regex(V,ue)}case 18:{const ne=ae.lexeme;this.z();let he=null;if(!(0,M.$od)(ne)){const Ee=ne.indexOf("/"),de=ne.lastIndexOf("/");if(Ee!==de&&Ee>=0){const ge=ne.slice(Ee+1,de),ie=ne[de+1]==="i"?"i":"";try{he=new RegExp(ge,ie)}catch{throw this.B("REGEX",ae)}}}if(he===null)throw this.B("REGEX",ae);return F.create(V,he)}default:throw this.B("REGEX",this.D())}}if(this.y(14)){this.A(13,y);const ae=this.u();return t.notIn(V,ae)}switch(this.D().type){case 3:{this.z();const ae=this.u();if(this.x().type===18)return t.equals(V,ae);switch(ae){case"true":return t.has(V);case"false":return t.not(V);default:return t.equals(V,ae)}}case 4:{this.z();const ae=this.u();if(this.x().type===18)return t.notEquals(V,ae);switch(ae){case"true":return t.not(V);case"false":return t.has(V);default:return t.notEquals(V,ae)}}case 5:return this.z(),O.create(V,this.u());case 6:return this.z(),B.create(V,this.u());case 7:return this.z(),j.create(V,this.u());case 8:return this.z(),T.create(V,this.u());case 13:return this.z(),t.in(V,this.u());default:return t.has(V)}}case 20:throw this.h.push({message:m,offset:z.offset,lexeme:"",additionalInfo:p}),f.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const z=this.D();switch(z.type){case 17:case 18:return this.z(),z.lexeme;case 11:return this.z(),"true";case 12:return this.z(),"false";case 13:return this.z(),"in";default:return""}}w(z){return z.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(z){return this.C(z)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(z,V){if(this.C(z))return this.z();throw this.B(V,this.D())}B(z,V,G){const ae=(0,A.localize)(8,null,z,h.$Di.getLexeme(V)),ne=V.offset,he=h.$Di.getLexeme(V);return this.h.push({message:ae,offset:ne,lexeme:he,additionalInfo:G}),f.c}C(z){return this.D().type===z}D(){return this.f[this.g]}E(){return this.D().type===20}}e.$Fi=f;class t{static false(){return c.INSTANCE}static true(){return d.INSTANCE}static has(z){return v.create(z)}static equals(z,V){return k.create(z,V)}static notEquals(z,V){return w.create(z,V)}static regex(z,V){return F.create(z,V)}static in(z,V){return u.create(z,V)}static notIn(z,V){return l.create(z,V)}static not(z){return L.create(z)}static and(...z){return me.create(z,null,!0)}static or(...z){return re.create(z,null,!0)}static greater(z,V){return j.create(z,V)}static greaterEquals(z,V){return T.create(z,V)}static smaller(z,V){return O.create(z,V)}static smallerEquals(z,V){return B.create(z,V)}static{this.c=new f({regexParsingWithErrorRecovery:!1})}static deserialize(z){return z==null?void 0:this.c.parse(z)}}e.$Gi=t;function s(Q){const z=new f({regexParsingWithErrorRecovery:!1});return Q.map(V=>(z.parse(V),z.lexingErrors.length>0?z.lexingErrors.map(G=>({errorMessage:G.additionalInfo?(0,A.localize)(9,null,G.additionalInfo):(0,A.localize)(10,null),offset:G.offset,length:G.lexeme.length})):z.parsingErrors.length>0?z.parsingErrors.map(G=>({errorMessage:G.additionalInfo?`${G.message}. ${G.additionalInfo}`:G.message,offset:G.offset,length:G.lexeme.length})):[]))}e.$Hi=s;function o(Q,z){const V=Q?Q.substituteConstants():void 0,G=z?z.substituteConstants():void 0;return!V&&!G?!0:!V||!G?!1:V.equals(G)}e.$Ii=o;function n(Q,z){return Q.cmp(z)}class c{static{this.INSTANCE=new c}constructor(){this.type=0}cmp(z){return this.type-z.type}equals(z){return z.type===this.type}substituteConstants(){return this}evaluate(z){return!1}serialize(){return"false"}keys(){return[]}map(z){return this}negate(){return d.INSTANCE}}e.$Ji=c;class d{static{this.INSTANCE=new d}constructor(){this.type=1}cmp(z){return this.type-z.type}equals(z){return z.type===this.type}substituteConstants(){return this}evaluate(z){return!0}serialize(){return"true"}keys(){return[]}map(z){return this}negate(){return c.INSTANCE}}e.$Ki=d;class v{static create(z,V=null){const G=E.get(z);return typeof G=="boolean"?G?d.INSTANCE:c.INSTANCE:new v(z,V)}constructor(z,V){this.key=z,this.c=V,this.type=2}cmp(z){return z.type!==this.type?this.type-z.type:q(this.key,z.key)}equals(z){return z.type===this.type?this.key===z.key:!1}substituteConstants(){const z=E.get(this.key);return typeof z=="boolean"?z?d.INSTANCE:c.INSTANCE:this}evaluate(z){return!!z.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(z){return z.mapDefined(this.key)}negate(){return this.c||(this.c=L.create(this.key,this)),this.c}}e.$Li=v;class k{static create(z,V,G=null){if(typeof V=="boolean")return V?v.create(z,G):L.create(z,G);const ae=E.get(z);return typeof ae=="boolean"?V===(ae?"true":"false")?d.INSTANCE:c.INSTANCE:new k(z,V,G)}constructor(z,V,G){this.c=z,this.d=V,this.f=G,this.type=4}cmp(z){return z.type!==this.type?this.type-z.type:ee(this.c,this.d,z.c,z.d)}equals(z){return z.type===this.type?this.c===z.c&&this.d===z.d:!1}substituteConstants(){const z=E.get(this.c);if(typeof z=="boolean"){const V=z?"true":"false";return this.d===V?d.INSTANCE:c.INSTANCE}return this}evaluate(z){return z.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(z){return z.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=w.create(this.c,this.d,this)),this.f}}e.$Mi=k;class u{static create(z,V){return new u(z,V)}constructor(z,V){this.d=z,this.f=V,this.type=10,this.c=null}cmp(z){return z.type!==this.type?this.type-z.type:ee(this.d,this.f,z.d,z.f)}equals(z){return z.type===this.type?this.d===z.d&&this.f===z.f:!1}substituteConstants(){return this}evaluate(z){const V=z.getValue(this.f),G=z.getValue(this.d);return Array.isArray(V)?V.includes(G):typeof G=="string"&&typeof V=="object"&&V!==null?P.call(V,G):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(z){return z.mapIn(this.d,this.f)}negate(){return this.c||(this.c=l.create(this.d,this.f)),this.c}}e.$Ni=u;class l{static create(z,V){return new l(z,V)}constructor(z,V){this.d=z,this.f=V,this.type=11,this.c=u.create(z,V)}cmp(z){return z.type!==this.type?this.type-z.type:this.c.cmp(z.c)}equals(z){return z.type===this.type?this.c.equals(z.c):!1}substituteConstants(){return this}evaluate(z){return!this.c.evaluate(z)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(z){return z.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$Oi=l;class w{static create(z,V,G=null){if(typeof V=="boolean")return V?L.create(z,G):v.create(z,G);const ae=E.get(z);return typeof ae=="boolean"?V===(ae?"true":"false")?c.INSTANCE:d.INSTANCE:new w(z,V,G)}constructor(z,V,G){this.c=z,this.d=V,this.f=G,this.type=5}cmp(z){return z.type!==this.type?this.type-z.type:ee(this.c,this.d,z.c,z.d)}equals(z){return z.type===this.type?this.c===z.c&&this.d===z.d:!1}substituteConstants(){const z=E.get(this.c);if(typeof z=="boolean"){const V=z?"true":"false";return this.d===V?c.INSTANCE:d.INSTANCE}return this}evaluate(z){return z.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(z){return z.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=k.create(this.c,this.d,this)),this.f}}e.$Pi=w;class L{static create(z,V=null){const G=E.get(z);return typeof G=="boolean"?G?c.INSTANCE:d.INSTANCE:new L(z,V)}constructor(z,V){this.c=z,this.d=V,this.type=3}cmp(z){return z.type!==this.type?this.type-z.type:q(this.c,z.c)}equals(z){return z.type===this.type?this.c===z.c:!1}substituteConstants(){const z=E.get(this.c);return typeof z=="boolean"?z?c.INSTANCE:d.INSTANCE:this}evaluate(z){return!z.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(z){return z.mapNot(this.c)}negate(){return this.d||(this.d=v.create(this.c,this)),this.d}}e.$Qi=L;function N(Q,z){if(typeof Q=="string"){const V=parseFloat(Q);isNaN(V)||(Q=V)}return typeof Q=="string"||typeof Q=="number"?z(Q):c.INSTANCE}class j{static create(z,V,G=null){return N(V,ae=>new j(z,ae,G))}constructor(z,V,G){this.c=z,this.d=V,this.f=G,this.type=12}cmp(z){return z.type!==this.type?this.type-z.type:ee(this.c,this.d,z.c,z.d)}equals(z){return z.type===this.type?this.c===z.c&&this.d===z.d:!1}substituteConstants(){return this}evaluate(z){return typeof this.d=="string"?!1:parseFloat(z.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(z){return z.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=B.create(this.c,this.d,this)),this.f}}e.$Ri=j;class T{static create(z,V,G=null){return N(V,ae=>new T(z,ae,G))}constructor(z,V,G){this.c=z,this.d=V,this.f=G,this.type=13}cmp(z){return z.type!==this.type?this.type-z.type:ee(this.c,this.d,z.c,z.d)}equals(z){return z.type===this.type?this.c===z.c&&this.d===z.d:!1}substituteConstants(){return this}evaluate(z){return typeof this.d=="string"?!1:parseFloat(z.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(z){return z.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=O.create(this.c,this.d,this)),this.f}}e.$Si=T;class O{static create(z,V,G=null){return N(V,ae=>new O(z,ae,G))}constructor(z,V,G){this.c=z,this.d=V,this.f=G,this.type=14}cmp(z){return z.type!==this.type?this.type-z.type:ee(this.c,this.d,z.c,z.d)}equals(z){return z.type===this.type?this.c===z.c&&this.d===z.d:!1}substituteConstants(){return this}evaluate(z){return typeof this.d=="string"?!1:parseFloat(z.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(z){return z.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=T.create(this.c,this.d,this)),this.f}}e.$Ti=O;class B{static create(z,V,G=null){return N(V,ae=>new B(z,ae,G))}constructor(z,V,G){this.c=z,this.d=V,this.f=G,this.type=15}cmp(z){return z.type!==this.type?this.type-z.type:ee(this.c,this.d,z.c,z.d)}equals(z){return z.type===this.type?this.c===z.c&&this.d===z.d:!1}substituteConstants(){return this}evaluate(z){return typeof this.d=="string"?!1:parseFloat(z.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(z){return z.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=j.create(this.c,this.d,this)),this.f}}e.$Ui=B;class F{static create(z,V){return new F(z,V)}constructor(z,V){this.d=z,this.f=V,this.type=7,this.c=null}cmp(z){if(z.type!==this.type)return this.type-z.type;if(this.d<z.d)return-1;if(this.d>z.d)return 1;const V=this.f?this.f.source:"",G=z.f?z.f.source:"";return V<G?-1:V>G?1:0}equals(z){if(z.type===this.type){const V=this.f?this.f.source:"",G=z.f?z.f.source:"";return this.d===z.d&&V===G}return!1}substituteConstants(){return this}evaluate(z){const V=z.getValue(this.d);return this.f?this.f.test(V):!1}serialize(){const z=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${z}`}keys(){return[this.d]}map(z){return z.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=J.create(this)),this.c}}e.$Vi=F;class J{static create(z){return new J(z)}constructor(z){this.c=z,this.type=8}cmp(z){return z.type!==this.type?this.type-z.type:this.c.cmp(z.c)}equals(z){return z.type===this.type?this.c.equals(z.c):!1}substituteConstants(){return this}evaluate(z){return!this.c.evaluate(z)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(z){return new J(this.c.map(z))}negate(){return this.c}}e.$Wi=J;function K(Q){let z=null;for(let V=0,G=Q.length;V<G;V++){const ae=Q[V].substituteConstants();if(Q[V]!==ae&&z===null){z=[];for(let ne=0;ne<V;ne++)z[ne]=Q[ne]}z!==null&&(z[V]=ae)}return z===null?Q:z}class me{static create(z,V,G){return me.d(z,V,G)}constructor(z,V){this.expr=z,this.c=V,this.type=6}cmp(z){if(z.type!==this.type)return this.type-z.type;if(this.expr.length<z.expr.length)return-1;if(this.expr.length>z.expr.length)return 1;for(let V=0,G=this.expr.length;V<G;V++){const ae=n(this.expr[V],z.expr[V]);if(ae!==0)return ae}return 0}equals(z){if(z.type===this.type){if(this.expr.length!==z.expr.length)return!1;for(let V=0,G=this.expr.length;V<G;V++)if(!this.expr[V].equals(z.expr[V]))return!1;return!0}return!1}substituteConstants(){const z=K(this.expr);return z===this.expr?this:me.create(z,this.c,!1)}evaluate(z){for(let V=0,G=this.expr.length;V<G;V++)if(!this.expr[V].evaluate(z))return!1;return!0}static d(z,V,G){const ae=[];let ne=!1;for(const he of z)if(he){if(he.type===1){ne=!0;continue}if(he.type===0)return c.INSTANCE;if(he.type===6){ae.push(...he.expr);continue}ae.push(he)}if(ae.length===0&&ne)return d.INSTANCE;if(ae.length!==0){if(ae.length===1)return ae[0];ae.sort(n);for(let he=1;he<ae.length;he++)ae[he-1].equals(ae[he])&&(ae.splice(he,1),he--);if(ae.length===1)return ae[0];for(;ae.length>1;){const he=ae[ae.length-1];if(he.type!==9)break;ae.pop();const Ee=ae.pop(),de=ae.length===0,ge=re.create(he.expr.map(ie=>me.create([ie,Ee],null,G)),null,de);ge&&(ae.push(ge),ae.sort(n))}if(ae.length===1)return ae[0];if(G){for(let he=0;he<ae.length;he++)for(let Ee=he+1;Ee<ae.length;Ee++)if(ae[he].negate().equals(ae[Ee]))return c.INSTANCE;if(ae.length===1)return ae[0]}return new me(ae,V)}}serialize(){return this.expr.map(z=>z.serialize()).join(" && ")}keys(){const z=[];for(const V of this.expr)z.push(...V.keys());return z}map(z){return new me(this.expr.map(V=>V.map(z)),null)}negate(){if(!this.c){const z=[];for(const V of this.expr)z.push(V.negate());this.c=re.create(z,this,!0)}return this.c}}e.$Xi=me;class re{static create(z,V,G){return re.d(z,V,G)}constructor(z,V){this.expr=z,this.c=V,this.type=9}cmp(z){if(z.type!==this.type)return this.type-z.type;if(this.expr.length<z.expr.length)return-1;if(this.expr.length>z.expr.length)return 1;for(let V=0,G=this.expr.length;V<G;V++){const ae=n(this.expr[V],z.expr[V]);if(ae!==0)return ae}return 0}equals(z){if(z.type===this.type){if(this.expr.length!==z.expr.length)return!1;for(let V=0,G=this.expr.length;V<G;V++)if(!this.expr[V].equals(z.expr[V]))return!1;return!0}return!1}substituteConstants(){const z=K(this.expr);return z===this.expr?this:re.create(z,this.c,!1)}evaluate(z){for(let V=0,G=this.expr.length;V<G;V++)if(this.expr[V].evaluate(z))return!0;return!1}static d(z,V,G){let ae=[],ne=!1;if(z){for(let he=0,Ee=z.length;he<Ee;he++){const de=z[he];if(de){if(de.type===0){ne=!0;continue}if(de.type===1)return d.INSTANCE;if(de.type===9){ae=ae.concat(de.expr);continue}ae.push(de)}}if(ae.length===0&&ne)return c.INSTANCE;ae.sort(n)}if(ae.length!==0){if(ae.length===1)return ae[0];for(let he=1;he<ae.length;he++)ae[he-1].equals(ae[he])&&(ae.splice(he,1),he--);if(ae.length===1)return ae[0];if(G){for(let he=0;he<ae.length;he++)for(let Ee=he+1;Ee<ae.length;Ee++)if(ae[he].negate().equals(ae[Ee]))return d.INSTANCE;if(ae.length===1)return ae[0]}return new re(ae,V)}}serialize(){return this.expr.map(z=>z.serialize()).join(" || ")}keys(){const z=[];for(const V of this.expr)z.push(...V.keys());return z}map(z){return new re(this.expr.map(V=>V.map(z)),null)}negate(){if(!this.c){const z=[];for(const V of this.expr)z.push(V.negate());for(;z.length>1;){const V=z.shift(),G=z.shift(),ae=[];for(const ne of _(V))for(const he of _(G))ae.push(me.create([ne,he],null,!1));z.unshift(re.create(ae,null,!1))}this.c=re.create(z,this,!0)}return this.c}}e.$Yi=re;class x extends v{static{this.d=[]}static all(){return x.d.values()}constructor(z,V,G){super(z,null),this.f=V,typeof G=="object"?x.d.push({...G,key:z}):G!==!0&&x.d.push({key:z,description:G,type:V!=null?typeof V:void 0})}bindTo(z){return z.createKey(this.key,this.f)}getValue(z){return z.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(z){return k.create(this.key,z)}notEqualsTo(z){return w.create(this.key,z)}}e.$Zi=x,e.$1i=(0,R.$zh)("contextKeyService");function q(Q,z){return Q<z?-1:Q>z?1:0}function ee(Q,z,V,G){return Q<V?-1:Q>V?1:z<G?-1:z>G?1:0}function pe(Q,z){if(Q.type===0||z.type===1)return!0;if(Q.type===9)return z.type===9?ce(Q.expr,z.expr):!1;if(z.type===9){for(const V of z.expr)if(pe(Q,V))return!0;return!1}if(Q.type===6){if(z.type===6)return ce(z.expr,Q.expr);for(const V of Q.expr)if(pe(V,z))return!0;return!1}return Q.equals(z)}e.$2i=pe;function ce(Q,z){let V=0,G=0;for(;V<Q.length&&G<z.length;){const ae=Q[V].cmp(z[G]);if(ae<0)return!1;ae===0&&V++,G++}return V===Q.length}function _(Q){return Q.type===9?Q.expr:[Q]}}),define(De[224],Ce([1,0,6]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hh=e.$Gh=void 0,e.$Gh=(0,D.$zh)("environmentService"),e.$Hh=(0,D.$Ah)(e.$Gh)}),define(De[131],Ce([1,0,188,6]),function($e,e,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7n=e.$6n=e.$5n=e.$4n=e.$3n=e.$2n=e.$1n=e.$Zn=e.$Yn=e.ExtensionSignaturetErrorCode=e.ExtensionManagementErrorCode=e.$Xn=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.$Wn=e.$Vn=e.$Un=e.$Tn=e.$Sn=e.$Rn=e.$Qn=e.$Pn=e.$On=e.$Nn=e.$Mn=e.$Ln=e.$Kn=void 0,e.$Kn="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$Ln=new RegExp(e.$Kn),e.$Mn="__web_extension",e.$Nn="skipWalkthrough",e.$On="extensionsSync",e.$Pn="dependecyOrPackExtensionInstall";function h(a){switch(a){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.$Qn=h;function R(a){switch(a){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.$Rn=R;function A(a,m){switch(a){case 3:return m==="x64"?"win32-x64":m==="ia32"?"win32-ia32":m==="arm64"?"win32-arm64":"unknown";case 2:return m==="x64"?"linux-x64":m==="arm64"?"linux-arm64":m==="arm"?"linux-armhf":"unknown";case"alpine":return m==="x64"?"alpine-x64":m==="arm64"?"alpine-arm64":"unknown";case 1:return m==="x64"?"darwin-x64":m==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.$Sn=A;function g(a,m){return m==="web"&&!a.includes("web")}e.$Tn=g;function E(a,m,p){return g(m,p)?!1:a==="undefined"||a==="universal"?!0:a==="unknown"?!1:a===p?!0:$(p).includes(a)}e.$Un=E;function $(a){switch(a){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.$Vn=$;function P(a){return a&&typeof a=="object"&&typeof a.id=="string"&&(!a.uuid||typeof a.uuid=="string")}e.$Wn=P;var I;(function(a){a[a.NoneOrRelevance=0]="NoneOrRelevance",a[a.LastUpdatedDate=1]="LastUpdatedDate",a[a.Title=2]="Title",a[a.PublisherName=3]="PublisherName",a[a.InstallCount=4]="InstallCount",a[a.PublishedDate=10]="PublishedDate",a[a.AverageRating=6]="AverageRating",a[a.WeightedRating=12]="WeightedRating"})(I||(e.SortBy=I={}));var b;(function(a){a[a.Default=0]="Default",a[a.Ascending=1]="Ascending",a[a.Descending=2]="Descending"})(b||(e.SortOrder=b={}));var S;(function(a){a.Install="install",a.Uninstall="uninstall"})(S||(e.StatisticType=S={}));var C;(function(a){a[a.None=1]="None",a[a.Install=2]="Install",a[a.Update=3]="Update",a[a.Migrate=4]="Migrate"})(C||(e.InstallOperation=C={})),e.$Xn=(0,M.$zh)("extensionGalleryService");var y;(function(a){a.Unsupported="Unsupported",a.Deprecated="Deprecated",a.Malicious="Malicious",a.Incompatible="Incompatible",a.IncompatibleTargetPlatform="IncompatibleTargetPlatform",a.ReleaseVersionNotFound="ReleaseVersionNotFound",a.Invalid="Invalid",a.Download="Download",a.Extract="Extract",a.Delete="Delete",a.Rename="Rename",a.CorruptZip="CorruptZip",a.IncompleteZip="IncompleteZip",a.Signature="Signature",a.Internal="Internal"})(y||(e.ExtensionManagementErrorCode=y={}));var r;(function(a){a.UnknownError="UnknownError",a.PackageIsInvalidZip="PackageIsInvalidZip",a.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip"})(r||(e.ExtensionSignaturetErrorCode=r={}));class i extends Error{constructor(m,p){super(m),this.code=p,this.name=p}}e.$Yn=i,e.$Zn=(0,M.$zh)("extensionManagementService"),e.$1n="extensionsIdentifiers/disabled",e.$2n="extensionsIdentifiers/enabled",e.$3n=(0,M.$zh)("IGlobalExtensionEnablementService"),e.$4n=(0,M.$zh)("IExtensionTipsService"),e.$5n=(0,D.localize)(0,null),e.$6n={value:e.$5n,original:"Extensions"},e.$7n={value:(0,D.localize)(1,null),original:"Preferences"}}),define(De[225],Ce([1,0,6]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$FWb=e.$EWb=e.$DWb=void 0,e.$DWb=(0,D.$zh)("externalTerminal"),e.$EWb="Terminal.app",e.$FWb=(0,D.$zh)("externalTerminal")}),define(De[226],Ce([1,0,46,16,14,9,98,29,100,190,225]),function($e,e,D,M,h,R,A,g,E,$,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$v5b=e.$u5b=e.$t5b=void 0;const I=$.localize(0,null);class b{async getDefaultTerminalForPlatforms(){return{windows:S.getDefaultTerminalWindows(),linux:await y.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class S extends b{static{this.b="cmd.exe"}openTerminal(p,f){return this.spawnTerminal(D,p,E.$sl(),f)}spawnTerminal(p,f,t,s){const o=f.windowsExec||S.getDefaultTerminalWindows();s&&s[1]===":"&&(s=s[0].toUpperCase()+s.substr(1));const n=h.$cd(o,".exe").toLowerCase();if(n==="cmder")return p.spawn(o,s?[s]:void 0),Promise.resolve(void 0);const c=["/c","start","/wait"];return o.indexOf(" ")>=0&&c.push('""'),c.push(o),n==="wt"&&c.push("-d ."),new Promise((d,v)=>{const k=r(process),u=p.spawn(t,c,{cwd:s,env:k});u.on("error",v),u.on("exit",()=>d())})}runInTerminal(p,f,t,s,o){const n="windowsExec"in o&&o.windowsExec?o.windowsExec:S.getDefaultTerminalWindows();return new Promise((c,d)=>{const v=`"${f} - ${I}"`,k=`""${t.join('" "')}" & pause"`,u=Object.assign({},r(process),s);Object.keys(u).filter(j=>u[j]===null).forEach(j=>delete u[j]);const l={cwd:f,env:u,windowsVerbatimArguments:!0};let w,L;h.$cd(n,".exe")==="wt"?(w=n,L=["-d",".",S.b,"/c",k]):(w=S.b,L=["/c","start",v,"/wait",n,"/c",k]),D.spawn(w,L,l).on("error",j=>{d(i(j))}),c(void 0)})}static getDefaultTerminalWindows(){if(!S.d){const p=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");S.d=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${p?"Sysnative":"System32"}\\cmd.exe`}return S.d}}e.$t5b=S;class C extends b{static{this.b="/usr/bin/osascript"}openTerminal(p,f){return this.spawnTerminal(D,p,f)}runInTerminal(p,f,t,s,o){const n=o.osxExec||P.$EWb;return new Promise((c,d)=>{if(n===P.$EWb||n==="iTerm.app"){const v=n===P.$EWb?"TerminalHelper":"iTermHelper",u=[M.$4e.asFileUri(`vs/workbench/contrib/externalTerminal/node/${v}.scpt`).fsPath,"-t",p||I,"-w",f];for(const L of t)u.push("-a"),u.push(L);if(s){const L=Object.assign({},r(process),s);for(const N in L){const j=L[N];j===null?(u.push("-u"),u.push(N)):(u.push("-e"),u.push(`${N}=${j}`))}}let l="";const w=D.spawn(C.b,u);w.on("error",L=>{d(i(L))}),w.stderr.on("data",L=>{l+=L.toString()}),w.on("exit",L=>{if(L===0)c(void 0);else if(l){const N=l.split(`
`,1);d(new Error(N[0]))}else d(new Error($.localize(1,null,v,L)))})}else d(new Error($.localize(2,null,n)))})}spawnTerminal(p,f,t){const s=f.osxExec||P.$EWb;return new Promise((o,n)=>{const c=["-a",s];t&&c.push(t);const d=r(process),v=p.spawn("/usr/bin/open",c,{cwd:t,env:d});v.on("error",n),v.on("exit",()=>o())})}}e.$u5b=C;class y extends b{static{this.b=$.localize(3,null)}openTerminal(p,f){return this.spawnTerminal(D,p,f)}runInTerminal(p,f,t,s,o){const n=o.linuxExec?Promise.resolve(o.linuxExec):y.getDefaultTerminalLinuxReady();return new Promise((c,d)=>{const v=[];n.then(k=>{k.indexOf("gnome-terminal")>=0?v.push("-x"):v.push("-e"),v.push("bash"),v.push("-c");const u=`${a(t)}; echo; read -p "${y.b}" -n1;`;v.push(`''${u}''`);const l=Object.assign({},r(process),s);Object.keys(l).filter(j=>l[j]===null).forEach(j=>delete l[j]);const w={cwd:f,env:l};let L="";const N=D.spawn(k,v,w);N.on("error",j=>{d(i(j))}),N.stderr.on("data",j=>{L+=j.toString()}),N.on("exit",j=>{if(j===0)c(void 0);else if(L){const T=L.split(`
`,1);d(new Error(T[0]))}else d(new Error($.localize(4,null,k,j)))})})})}static async getDefaultTerminalLinuxReady(){if(!y.d)if(!R.$k)y.d=Promise.resolve("xterm");else{const p=await g.Promises.exists("/etc/debian_version");y.d=new Promise(f=>{p?f("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?f("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?f("konsole"):process.env.COLORTERM?f(process.env.COLORTERM):process.env.TERM?f(process.env.TERM):f("xterm")})}return y.d}spawnTerminal(p,f,t){const s=f.linuxExec?Promise.resolve(f.linuxExec):y.getDefaultTerminalLinuxReady();return new Promise((o,n)=>{s.then(c=>{const d=r(process),v=p.spawn(c,[],{cwd:t,env:d});v.on("error",n),v.on("exit",()=>o())})})}}e.$v5b=y;function r(m){const p={...m.env};return(0,A.$ql)(p),p}function i(m){return"errno"in m&&m.errno==="ENOENT"&&"path"in m&&typeof m.path=="string"?new Error($.localize(5,null,m.path)):m}function a(m){let p="";for(const f of m)f.indexOf(" ")>=0?p+='"'+f+'"':p+=f,p+=" ";return p}}),define(De[30],Ce([1,0,75,14,15,18,2,191,6,9,16]),function($e,e,D,M,h,R,A,g,E,$,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zk=e.$yk=e.$xk=e.$wk=e.$vk=e.FileKind=e.$uk=e.$tk=e.$sk=e.$rk=e.$qk=e.$pk=e.$ok=e.FileOperationResult=e.$nk=e.$mk=e.$lk=e.$kk=e.$jk=e.FileChangeType=e.$ik=e.FileOperation=e.$hk=e.$gk=e.$fk=e.$ek=e.$dk=e.$ck=e.FileSystemProviderErrorCode=e.$bk=e.$ak=e.$_j=e.$$j=e.$0j=e.$9j=e.$8j=e.$7j=e.$6j=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.$5j=e.$4j=void 0,e.$4j=(0,E.$zh)("fileService");function I(q){return q.create===!0}e.$5j=I;var b;(function(q){q[q.Unknown=0]="Unknown",q[q.File=1]="File",q[q.Directory=2]="Directory",q[q.SymbolicLink=64]="SymbolicLink"})(b||(e.FileType=b={}));var S;(function(q){q[q.Readonly=1]="Readonly",q[q.Locked=2]="Locked"})(S||(e.FilePermission=S={}));var C;(function(q){q[q.None=0]="None",q[q.FileReadWrite=2]="FileReadWrite",q[q.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",q[q.FileReadStream=16]="FileReadStream",q[q.FileFolderCopy=8]="FileFolderCopy",q[q.PathCaseSensitive=1024]="PathCaseSensitive",q[q.Readonly=2048]="Readonly",q[q.Trash=4096]="Trash",q[q.FileWriteUnlock=8192]="FileWriteUnlock",q[q.FileAtomicRead=16384]="FileAtomicRead",q[q.FileAtomicWrite=32768]="FileAtomicWrite",q[q.FileAtomicDelete=65536]="FileAtomicDelete",q[q.FileClone=131072]="FileClone"})(C||(e.FileSystemProviderCapabilities=C={}));function y(q){return!!(q.capabilities&2)}e.$6j=y;function r(q){return!!(q.capabilities&8)}e.$7j=r;function i(q){return!!(q.capabilities&131072)}e.$8j=i;function a(q){return!!(q.capabilities&4)}e.$9j=a;function m(q){return!!(q.capabilities&16)}e.$0j=m;function p(q){return y(q)?!!(q.capabilities&16384):!1}e.$$j=p;function f(q){return y(q)?!!(q.capabilities&32768):!1}e.$_j=f;function t(q){return!!(q.capabilities&65536)}e.$ak=t;function s(q){return!!(q.capabilities&2048)}e.$bk=s;var o;(function(q){q.FileExists="EntryExists",q.FileNotFound="EntryNotFound",q.FileNotADirectory="EntryNotADirectory",q.FileIsADirectory="EntryIsADirectory",q.FileExceedsStorageQuota="EntryExceedsStorageQuota",q.FileTooLarge="EntryTooLarge",q.FileWriteLocked="EntryWriteLocked",q.NoPermissions="NoPermissions",q.Unavailable="Unavailable",q.Unknown="Unknown"})(o||(e.FileSystemProviderErrorCode=o={}));class n extends Error{static create(ee,pe){const ce=new n(ee.toString(),pe);return v(ce,pe),ce}constructor(ee,pe){super(ee),this.code=pe}}e.$ck=n;function c(q,ee){return n.create(q,ee)}e.$dk=c;function d(q){return q||c((0,g.localize)(0,null),o.Unknown)}e.$ek=d;function v(q,ee){return q.name=ee?`${ee} (FileSystemError)`:"FileSystemError",q}e.$fk=v;function k(q){if(!q)return o.Unknown;if(q instanceof n)return q.code;const ee=/^(.+) \(FileSystemError\)$/.exec(q.name);if(!ee)return o.Unknown;switch(ee[1]){case o.FileExists:return o.FileExists;case o.FileIsADirectory:return o.FileIsADirectory;case o.FileNotADirectory:return o.FileNotADirectory;case o.FileNotFound:return o.FileNotFound;case o.FileTooLarge:return o.FileTooLarge;case o.FileWriteLocked:return o.FileWriteLocked;case o.NoPermissions:return o.NoPermissions;case o.Unavailable:return o.Unavailable}return o.Unknown}e.$gk=k;function u(q){if(q instanceof T)return q.fileOperationResult;switch(k(q)){case o.FileNotFound:return 1;case o.FileIsADirectory:return 0;case o.FileNotADirectory:return 9;case o.FileWriteLocked:return 5;case o.NoPermissions:return 6;case o.FileExists:return 4;case o.FileTooLarge:return 7;default:return 10}}e.$hk=u;var l;(function(q){q[q.CREATE=0]="CREATE",q[q.DELETE=1]="DELETE",q[q.MOVE=2]="MOVE",q[q.COPY=3]="COPY",q[q.WRITE=4]="WRITE"})(l||(e.FileOperation=l={}));class w{constructor(ee,pe,ce){this.resource=ee,this.operation=pe,this.target=ce}isOperation(ee){return this.operation===ee}}e.$ik=w;var L;(function(q){q[q.UPDATED=0]="UPDATED",q[q.ADDED=1]="ADDED",q[q.DELETED=2]="DELETED"})(L||(e.FileChangeType=L={}));class N{constructor(ee,pe){this.a=void 0,this.b=void 0,this.c=void 0,this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];const ce=new Map;for(const _ of ee){const Q=ce.get(_.type);switch(Q?Q.push([_.resource,_]):ce.set(_.type,[[_.resource,_]]),_.type){case 1:this.rawAdded.push(_.resource);break;case 0:this.rawUpdated.push(_.resource);break;case 2:this.rawDeleted.push(_.resource);break}}for(const[_,Q]of ce)switch(_){case 1:this.a=D.$Fh.forUris(()=>pe),this.a.fill(Q);break;case 0:this.b=D.$Fh.forUris(()=>pe),this.b.fill(Q);break;case 2:this.c=D.$Fh.forUris(()=>pe),this.c.fill(Q);break}}contains(ee,...pe){return this.d(ee,{includeChildren:!1},...pe)}affects(ee,...pe){return this.d(ee,{includeChildren:!0},...pe)}d(ee,pe,...ce){if(!ee)return!1;const _=ce.length>0;return!!((!_||ce.includes(1))&&(this.a?.get(ee)||pe.includeChildren&&this.a?.findSuperstr(ee))||(!_||ce.includes(0))&&(this.b?.get(ee)||pe.includeChildren&&this.b?.findSuperstr(ee))||(!_||ce.includes(2))&&(this.c?.findSubstr(ee)||pe.includeChildren&&this.c?.findSuperstr(ee)))}gotAdded(){return!!this.a}gotDeleted(){return!!this.c}gotUpdated(){return!!this.b}}e.$jk=N;function j(q,ee,pe){return!q||!ee||q===ee||ee.length>q.length?!1:(ee.charAt(ee.length-1)!==M.sep&&(ee+=M.sep),pe?(0,h.$Pd)(q,ee):q.indexOf(ee)===0)}e.$kk=j;class T extends Error{constructor(ee,pe,ce){super(ee),this.fileOperationResult=pe,this.options=ce}}e.$lk=T;class O extends T{constructor(ee,pe,ce,_){super(ee,pe,_),this.fileOperationResult=pe,this.size=ce}}e.$mk=O;class B extends T{constructor(ee,pe,ce){super(ee,2,ce),this.stat=pe}}e.$nk=B;var F;(function(q){q[q.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",q[q.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",q[q.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",q[q.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",q[q.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",q[q.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",q[q.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",q[q.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",q[q.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",q[q.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",q[q.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(F||(e.FileOperationResult=F={})),e.$ok={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$pk={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$qk="files.associations",e.$rk="files.exclude",e.$sk="files.readonlyInclude",e.$tk="files.readonlyExclude",e.$uk="files.readonlyFromPermissions";var J;(function(q){q[q.FILE=0]="FILE",q[q.FOLDER=1]="FOLDER",q[q.ROOT_FOLDER=2]="ROOT_FOLDER"})(J||(e.FileKind=J={})),e.$vk="";function K(q){if(!(typeof q.size!="number"||typeof q.mtime!="number"))return q.mtime.toString(29)+q.size.toString(31)}e.$wk=K;async function me(q,ee){if(!ee.hasProvider(A.URI.from({scheme:q.scheme})))return new Promise(pe=>{const ce=ee.onDidChangeFileSystemProviderRegistrations(_=>{_.scheme===q.scheme&&_.added&&(ce.dispose(),pe())})})}e.$xk=me;class re{static{this.KB=1024}static{this.MB=re.KB*re.KB}static{this.GB=re.MB*re.KB}static{this.TB=re.GB*re.KB}static formatSize(ee){return(0,R.$pe)(ee)||(ee=0),ee<re.KB?(0,g.localize)(1,null,ee.toFixed(0)):ee<re.MB?(0,g.localize)(2,null,(ee/re.KB).toFixed(2)):ee<re.GB?(0,g.localize)(3,null,(ee/re.MB).toFixed(2)):ee<re.TB?(0,g.localize)(4,null,(ee/re.GB).toFixed(2)):(0,g.localize)(5,null,(ee/re.TB).toFixed(2))}}e.$yk=re;function x(q){const ee=typeof q=="string"||q?.scheme===P.Schemas.vscodeRemote;return typeof q!="string"&&q?.scheme===P.Schemas.file?1024*re.MB:ee?10*re.MB:$.$o?50*re.MB:1024*re.MB}e.$zk=x}),define(De[227],Ce([1,0,21,8,192,30]),function($e,e,D,M,h,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zp=void 0;async function A(P,I,b,S,C,y){let r;try{await g(P,I,b,S,C,y)}catch(i){r=i}finally{r&&C.errorTransformer&&(r=C.errorTransformer(r)),typeof r<"u"&&b.error(r),b.end()}}e.$zp=A;async function g(P,I,b,S,C,y){E(y);const r=await P.open(I,{create:!1});try{E(y);let i=0,a=0,m=C&&typeof C.length=="number"?C.length:void 0,p=D.$Hc.alloc(Math.min(C.bufferSize,typeof m=="number"?m:C.bufferSize)),f=C&&typeof C.position=="number"?C.position:0,t=0;do a=await P.read(r,f,p.buffer,t,p.byteLength-t),f+=a,t+=a,i+=a,typeof m=="number"&&(m-=a),t===p.byteLength&&(await b.write(S(p)),p=D.$Hc.alloc(Math.min(C.bufferSize,typeof m=="number"?m:C.bufferSize)),t=0);while(a>0&&(typeof m!="number"||m>0)&&E(y)&&$(i,C));if(t>0){let s=t;typeof m=="number"&&(s=Math.min(t,m)),b.write(S(p.slice(0,s)))}}catch(i){throw(0,R.$ek)(i)}finally{await P.close(r)}}function E(P){if(P.isCancellationRequested)throw(0,M.$4)();return!0}function $(P,I){if(typeof I?.limits?.size=="number"&&P>I.limits.size)throw(0,R.$dk)((0,h.localize)(0,null),R.FileSystemProviderErrorCode.FileTooLarge);return!0}}),define(De[82],Ce([1,0,35,3,14,9,2,30]),function($e,e,D,M,h,R,A,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ip=e.$Hp=e.$Gp=e.$Fp=e.$Ep=e.$Dp=e.$Cp=e.$Bp=void 0;function E(i){return i.recursive===!0}e.$Bp=E;class $ extends M.$mb{static{this.a=5}constructor(a,m,p,f){super(),this.h=a,this.i=m,this.j=p,this.k=f,this.c=this.B(new M.$nb),this.f=void 0,this.g=0}m(){const a=new M.$lb;this.c.value=a,this.b=this.l(a),this.b.setVerboseLogging(this.j),a.add(this.b.onDidChangeFile(m=>this.h(m))),a.add(this.b.onDidLogMessage(m=>this.i(m))),a.add(this.b.onDidError(m=>this.n(m)))}n(a){this.k.restartOnError?this.g<$.a&&this.f?(this.r(`restarting watcher after error: ${a}`),this.p(this.f)):this.r(`gave up attempting to restart watcher after error: ${a}`):this.r(a)}p(a){this.g++,this.m(),this.watch(a)}async watch(a){this.f=a,await this.b?.watch(a)}async setVerboseLogging(a){this.j=a,await this.b?.setVerboseLogging(a)}r(a){this.i({type:"error",message:`[File Watcher (${this.k.type})] ${a}`})}s(a){this.i({type:"trace",message:`[File Watcher (${this.k.type})] ${a}`})}dispose(){return this.b=void 0,super.dispose()}}e.$Cp=$;class P extends ${constructor(a,m,p){super(a,m,p,{type:"node.js",restartOnError:!1})}}e.$Dp=P;class I extends ${constructor(a,m,p){super(a,m,p,{type:"universal",restartOnError:!0})}}e.$Ep=I;function b(i){return i.map(a=>({type:a.type,resource:A.URI.file(a.path)}))}e.$Fp=b;function S(i){const a=new r;for(const m of i)a.processEvent(m);return a.coalesce()}e.$Gp=S;function C(i,a){return typeof a=="string"&&!a.startsWith(D.$lj)&&!(0,h.$0c)(a)?{base:i,pattern:a}:a}e.$Hp=C;function y(i,a){const m=[];for(const p of a)m.push((0,D.$pj)(C(i,p)));return m}e.$Ip=y;class r{constructor(){this.a=new Set,this.b=new Map}c(a){return R.$k?a.path:a.path.toLowerCase()}processEvent(a){const m=this.b.get(this.c(a));let p=!1;if(m){const f=m.type,t=a.type;m.path!==a.path&&(a.type===2||a.type===1)?p=!0:f===1&&t===2?(this.b.delete(this.c(a)),this.a.delete(m)):f===2&&t===1?m.type=0:f===1&&t===0||(m.type=t)}else p=!0;p&&(this.a.add(a),this.b.set(this.c(a),a))}coalesce(){const a=[],m=[];return Array.from(this.a).filter(p=>p.type!==2?(a.push(p),!1):!0).sort((p,f)=>p.path.length-f.path.length).filter(p=>m.some(f=>(0,g.$kk)(p.path,f,!R.$k))?!1:(m.push(p.path),!0)).concat(a)}}}),define(De[228],Ce([1,0,49,13,22,32,3,73,14,9,99,29,82]),function($e,e,D,M,h,R,A,g,E,$,P,I,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wp=e.$Vp=void 0;class S extends A.$mb{static{this.a=100}static{this.b=75}constructor(r,i,a,m){super(),this.j=r,this.k=i,this.l=a,this.m=m,this.c=this.B(new M.$Tg({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},p=>this.k(p))),this.f=this.B(new M.$Sg(p=>this.u(p),S.b)),this.g=(0,b.$Ip)(this.j.path,this.j.excludes),this.h=this.j.includes?(0,b.$Ip)(this.j.path,this.j.includes):void 0,this.i=new h.$rc,this.ready=this.n()}async n(){try{const r=await this.r(this.j);if(this.i.token.isCancellationRequested)return;const i=await I.Promises.stat(r);this.B(await this.s(r,i.isDirectory()))}catch(r){r.code!=="ENOENT"?this.w(r):this.z(r)}}async r(r){let i=r.path;try{i=await I.Promises.realpath(r.path),r.path===i&&(i=await(0,P.$Sp)(r.path)??r.path),r.path!==i&&this.z(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${r.path}, real: ${i})`)}catch{}return i}async s(r,i){if($.$j&&(0,R.$Ke)(r,"/Volumes/",!0))return this.w(`Refusing to watch ${r} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),A.$mb.None;const a=new h.$rc(this.i.token),m=new A.$lb;try{const p=(0,E.$cd)(r),f=(0,D.watch)(r);m.add((0,A.$kb)(()=>{f.removeAllListeners(),f.close()})),this.z(`Started watching: '${r}'`);const t=new Set;if(i)try{for(const o of await I.Promises.readdir(r))t.add(o)}catch(o){this.w(o)}const s=new Map;m.add((0,A.$kb)(()=>{for(const[,o]of s)o.dispose();s.clear()})),f.on("error",(o,n)=>{this.w(`Failed to watch ${r} for changes using fs.watch() (${o}, ${n})`),this.dispose()}),f.on("change",(o,n)=>{if(a.token.isCancellationRequested)return;this.z(`[raw] ["${o}"] ${n}`);let c="";if(n&&(c=n.toString(),$.$j&&(c=(0,g.$fl)(c))),!(!c||o!=="change"&&o!=="rename"))if(i)if(o==="rename"){s.get(c)?.dispose();const d=setTimeout(async()=>{if(s.delete(c),c===p&&!await I.Promises.exists(r)){this.y("Watcher shutdown because watched path got deleted"),this.dispose();return}const v=await this.v((0,E.$$c)(r,c));if(a.token.isCancellationRequested)return;let k;v?t.has(c)?k=0:(k=1,t.add(c)):(t.delete(c),k=2),this.t({path:(0,E.$$c)(this.j.path,c),type:k})},S.a);s.set(c,(0,A.$kb)(()=>clearTimeout(d)))}else{let d;t.has(c)?d=0:(d=1,t.add(c)),this.t({path:(0,E.$$c)(this.j.path,c),type:d})}else if(o==="rename"||c!==p){const d=setTimeout(async()=>{const v=await I.Promises.exists(r);a.token.isCancellationRequested||(v?(this.t({path:this.j.path,type:0},!0),m.add(await this.s(r,!1))):(this.t({path:this.j.path,type:2},!0),this.f.flush(),this.dispose()))},S.a);m.clear(),m.add((0,A.$kb)(()=>clearTimeout(d)))}else this.t({path:this.j.path,type:0},!0)})}catch(p){await I.Promises.exists(r)&&!a.token.isCancellationRequested&&this.w(`Failed to watch ${r} for changes using fs.watch() (${p.toString()})`)}return(0,A.$kb)(()=>{a.dispose(!0),m.dispose()})}t(r,i=!1){this.i.token.isCancellationRequested||(this.m&&this.z(`${r.type===1?"[ADDED]":r.type===2?"[DELETED]":"[CHANGED]"} ${r.path}`),!i&&this.g.some(a=>a(r.path))?this.m&&this.z(` >> ignored (excluded) ${r.path}`):!i&&this.h&&this.h.length>0&&!this.h.some(a=>a(r.path))?this.m&&this.z(` >> ignored (not included) ${r.path}`):this.f.work(r))}u(r){const i=(0,b.$Gp)(r);if(i.length>0){if(this.m)for(const m of i)this.z(`>> normalized ${m.type===1?"[ADDED]":m.type===2?"[DELETED]":"[CHANGED]"} ${m.path}`);this.c.work(i)?this.c.pending>0&&this.z(`started throttling events due to large amount of file change events at once (pending: ${this.c.pending}, most recent change: ${i[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.y(`started ignoring events due to too many file change events at once (incoming: ${i.length}, most recent change: ${i[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}}async v(r){if($.$k)return I.Promises.exists(r);try{const i=(0,E.$cd)(r);return(await I.Promises.readdir((0,E.$bd)(r))).some(m=>m===i)}catch(i){return this.z(i),!1}}setVerboseLogging(r){this.m=r}w(r){this.i.token.isCancellationRequested||this.l?.({type:"error",message:`[File Watcher (node.js)] ${r}`})}y(r){this.i.token.isCancellationRequested||this.l?.({type:"warn",message:`[File Watcher (node.js)] ${r}`})}z(r){!this.i.token.isCancellationRequested&&this.m&&this.l?.({type:"trace",message:`[File Watcher (node.js)] ${r}`})}dispose(){this.z(`stopping file watcher on ${this.j.path}`),this.i.dispose(!0),super.dispose()}}e.$Vp=S;async function C(y,r,i,a,m=512){const p=await I.Promises.open(y,"r"),f=Buffer.allocUnsafe(m),t=new h.$rc(a);let s,o=!1;const n={path:y,excludes:[],recursive:!1},c=new S(n,d=>{(async()=>{for(const{type:v}of d)if(v===0){if(o)return;o=!0;try{for(;!t.token.isCancellationRequested;){const{bytesRead:k}=await I.Promises.read(p,f,0,m,null);if(!k||t.token.isCancellationRequested)break;r(f.slice(0,k))}}catch(k){s=new Error(k),t.dispose(!0)}finally{o=!1}}})()});return await c.ready,i(),new Promise((d,v)=>{t.token.onCancellationRequested(async()=>{c.dispose();try{await I.Promises.close(p)}catch(k){s=new Error(k)}s?v(s):d()})})}e.$Wp=C}),define(De[229],Ce([1,0,4,35,3,9,228]),function($e,e,D,M,h,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xp=void 0;class g extends h.$mb{constructor(){super(...arguments),this.a=this.B(new D.$hc),this.onDidChangeFile=this.a.event,this.b=this.B(new D.$hc),this.onDidLogMessage=this.b.event,this.onDidError=D.Event.None,this.c=new Map,this.f=!1}async watch($){const P=this.i($),I=P.filter(S=>{const C=this.c.get(S.path);return C?!(0,M.$tj)(C.request.excludes,S.excludes)||!(0,M.$tj)(C.request.includes,S.includes):!0}),b=Array.from(this.c.values()).filter(({request:S})=>!P.find(C=>C.path===S.path&&(0,M.$tj)(C.excludes,S.excludes)&&(0,M.$tj)(C.includes,S.includes))).map(({request:S})=>S.path);I.length&&this.j(`Request to start watching: ${I.map(S=>`${S.path} (excludes: ${S.excludes.length>0?S.excludes:"<none>"}, includes: ${S.includes&&S.includes.length>0?JSON.stringify(S.includes):"<all>"})`).join(",")}`),b.length&&this.j(`Request to stop watching: ${b.join(",")}`);for(const S of b)this.h(S);for(const S of I)this.g(S)}g($){const P=new A.$Vp($,b=>this.a.fire(b),b=>this.b.fire(b),this.f),I={request:$,instance:P};this.c.set($.path,I)}async stop(){for(const[$]of this.c)this.h($);this.c.clear()}h($){const P=this.c.get($);P&&(this.c.delete($),P.instance.dispose())}i($){const P=new Map;for(const I of $){const b=R.$k?I.path:I.path.toLowerCase();P.set(b,I)}return Array.from(P.values())}async setVerboseLogging($){this.f=$;for(const[,P]of this.c)P.instance.setVerboseLogging($)}j($){this.f&&this.b.fire({type:"trace",message:this.k($)})}k($,P){return P?`[File Watcher (node.js)] ${$} (path: ${P.request.path})`:`[File Watcher (node.js)] ${$}`}}e.$Xp=g}),define(De[230],Ce([1,0,82,229]),function($e,e,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yp=void 0;class h extends D.$Dp{constructor(A,g,E){super(A,g,E),this.m()}l(A){return A.add(new M.$Xp)}}e.$Yp=h}),define(De[231],Ce([1,0,16,79,181,82]),function($e,e,D,M,h,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qp=void 0;class A extends R.$Ep{constructor(E,$,P){super(E,$,P),this.m()}l(E){const $=E.add(new h.$Pp(D.$4e.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return E.add($.onDidProcessExit(({code:P,signal:I})=>this.n(`terminated by itself with code ${P}, signal: ${I}`))),M.ProxyChannel.toService((0,M.$gh)($.getChannel("watcher")))}}e.$Qp=A}),define(De[103],Ce([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xh=void 0;class D{constructor(...h){this.a=new Map;for(const[R,A]of h)this.set(R,A)}set(h,R){const A=this.a.get(h);return this.a.set(h,R),A}has(h){return this.a.has(h)}get(h){return this.a.get(h)}}e.$xh=D}),define(De[232],Ce([1,0,13,8,3,101,223,6,103,72]),function($e,e,D,M,h,R,A,g,E,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4p=e.$3p=void 0;const P=!1;class I extends Error{constructor(r){super("cyclic dependency between services"),this.message=r.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${r.toString()}`}}class b{constructor(r=new E.$xh,i=!1,a,m=P){this.f=r,this.g=i,this.h=a,this.i=m,this.o=new Set,this.f.set(g.$yh,this),this._globalGraph=m?a?._globalGraph??new A.$2p(p=>p):void 0}createChild(r){return new b(r,this.g,this,this.i)}invokeFunction(r,...i){const a=C.traceInvocation(this.i,r);let m=!1;try{return r({get:f=>{if(m)throw(0,M.$6)("service accessor is only valid during the invocation of its target method");const t=this.m(f,a);if(!t)throw new Error(`[invokeFunction] unknown service '${f}'`);return t}},...i)}finally{m=!0,a.stop()}}createInstance(r,...i){let a,m;return r instanceof R.$wh?(a=C.traceCreation(this.i,r.ctor),m=this.j(r.ctor,r.staticArguments.concat(i),a)):(a=C.traceCreation(this.i,r),m=this.j(r,i,a)),a.stop(),m}j(r,i=[],a){const m=g._util.getServiceDependencies(r).sort((t,s)=>t.index-s.index),p=[];for(const t of m){const s=this.m(t.id,a);s||this.u(`[createInstance] ${r.name} depends on UNKNOWN service ${t.id}.`,!1),p.push(s)}const f=m.length>0?m[0].index:i.length;if(i.length!==f){console.trace(`[createInstance] First service dependency of ${r.name} at position ${f+1} conflicts with ${i.length} static arguments`);const t=f-i.length;t>0?i=i.concat(new Array(t)):i=i.slice(0,f)}return Reflect.construct(r,i.concat(p))}k(r,i){if(this.f.get(r)instanceof R.$wh)this.f.set(r,i);else if(this.h)this.h.k(r,i);else throw new Error("illegalState - setting UNKNOWN service instance")}l(r){const i=this.f.get(r);return!i&&this.h?this.h.l(r):i}m(r,i){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(r));const a=this.l(r);return a instanceof R.$wh?this.q(r,a,i.branch(r,!0)):(i.branch(r,!1),a)}q(r,i,a){if(this.o.has(r))throw new Error(`illegal state - RECURSIVELY instantiating service '${r}'`);this.o.add(r);try{return this.r(r,i,a)}finally{this.o.delete(r)}}r(r,i,a){const m=new A.$2p(t=>t.id.toString());let p=0;const f=[{id:r,desc:i,_trace:a}];for(;f.length;){const t=f.pop();if(m.lookupOrInsertNode(t),p++>1e3)throw new I(m);for(const s of g._util.getServiceDependencies(t.desc.ctor)){const o=this.l(s.id);if(o||this.u(`[createInstance] ${r} depends on ${s.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(t.id),String(s.id)),o instanceof R.$wh){const n={id:s.id,desc:o,_trace:t._trace.branch(s.id,!0)};m.insertEdge(t,n),f.push(n)}}}for(;;){const t=m.roots();if(t.length===0){if(!m.isEmpty())throw new I(m);break}for(const{data:s}of t){if(this.l(s.id)instanceof R.$wh){const n=this.s(s.id,s.desc.ctor,s.desc.staticArguments,s.desc.supportsDelayedInstantiation,s._trace);this.k(s.id,n)}m.removeNode(s)}}return this.l(r)}s(r,i,a=[],m,p){if(this.f.get(r)instanceof R.$wh)return this.t(r,i,a,m,p);if(this.h)return this.h.s(r,i,a,m,p);throw new Error(`illegalState - creating UNKNOWN service instance ${i.name}`)}t(r,i,a=[],m,p){if(m){const f=new b(void 0,this.g,this,this.i);f.c=String(r);const t=new Map,s=new D.$Vg(()=>{const o=f.j(i,a,p);for(const[n,c]of t){const d=o[n];if(typeof d=="function")for(const v of c)d.apply(o,v)}return t.clear(),o});return new Proxy(Object.create(null),{get(o,n){if(!s.isInitialized&&typeof n=="string"&&(n.startsWith("onDid")||n.startsWith("onWill"))){let v=t.get(n);return v||(v=new $.$vb,t.set(n,v)),(u,l,w)=>{const L=v.push([u,l,w]);return(0,h.$kb)(L)}}if(n in o)return o[n];const c=s.value;let d=c[n];return typeof d!="function"||(d=d.bind(c),o[n]=d),d},set(o,n,c){return s.value[n]=c,!0},getPrototypeOf(o){return i.prototype}})}else return this.j(i,a,p)}u(r,i){if(i&&console.warn(r),this.g)throw new Error(r)}}e.$3p=b;var S;(function(y){y[y.None=0]="None",y[y.Creation=1]="Creation",y[y.Invocation=2]="Invocation",y[y.Branch=3]="Branch"})(S||(S={}));class C{static{this.all=new Set}static{this.c=new class extends C{constructor(){super(0,null)}stop(){}branch(){return this}}}static traceInvocation(r,i){return r?new C(2,i.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):C.c}static traceCreation(r,i){return r?new C(1,i.name):C.c}static{this.f=0}constructor(r,i){this.type=r,this.name=i,this.g=Date.now(),this.h=[]}branch(r,i){const a=new C(3,r.toString());return this.h.push([r,i,a]),a}stop(){const r=Date.now()-this.g;C.f+=r;let i=!1;function a(p,f){const t=[],s=new Array(p+1).join("	");for(const[o,n,c]of f.h)if(n&&c){i=!0,t.push(`${s}CREATES -> ${o}`);const d=a(p+1,c);d&&t.push(d)}else t.push(`${s}uses -> ${o}`);return t.join(`
`)}const m=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${a(1,this)}`,`DONE, took ${r.toFixed(2)}ms (grand total ${C.f.toFixed(2)}ms)`];(r>2||i)&&C.all.add(m.join(`
`))}}e.$4p=C}),define(De[17],Ce([1,0,44,4,74,3,28,9,24,18,2,47,6]),function($e,e,D,M,h,R,A,g,E,$,P,I,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hj=e.$gj=e.$fj=e.$ej=e.$dj=e.$cj=e.$bj=e.$aj=e.$_i=e.$$i=e.$0i=e.$9i=e.$8i=e.log=e.$6i=e.LogLevel=e.$5i=e.$4i=e.$3i=void 0,e.$3i=(0,b.$zh)("logService"),e.$4i=(0,b.$zh)("loggerService");function S(){return new Date().toISOString()}function C(u){return(0,$.$pe)(u)}e.$5i=C;var y;(function(u){u[u.Off=0]="Off",u[u.Trace=1]="Trace",u[u.Debug=2]="Debug",u[u.Info=3]="Info",u[u.Warning=4]="Warning",u[u.Error=5]="Error"})(y||(e.LogLevel=y={})),e.$6i=y.Info;function r(u,l,w){switch(l){case y.Trace:u.trace(w);break;case y.Debug:u.debug(w);break;case y.Info:u.info(w);break;case y.Warning:u.warn(w);break;case y.Error:u.error(w);break;case y.Off:break;default:throw new Error(`Invalid log level ${l}`)}}e.log=r;function i(u,l=!1){let w="";for(let L=0;L<u.length;L++){let N=u[L];if(N instanceof Error&&(N=(0,D.$ki)(N,l)),typeof N=="object")try{N=JSON.stringify(N)}catch{}w+=(L>0?" ":"")+N}return w}class a extends R.$mb{constructor(){super(...arguments),this.b=e.$6i,this.c=this.B(new M.$hc),this.onDidChangeLogLevel=this.c.event}setLevel(l){this.b!==l&&(this.b=l,this.c.fire(this.b))}getLevel(){return this.b}f(l){return this.b!==y.Off&&this.b<=l}}e.$8i=a;class m extends a{constructor(l){super(),this.h=l}f(l){return this.h||super.f(l)}trace(l,...w){this.f(y.Trace)&&this.g(y.Trace,i([l,...w],!0))}debug(l,...w){this.f(y.Debug)&&this.g(y.Debug,i([l,...w]))}info(l,...w){this.f(y.Info)&&this.g(y.Info,i([l,...w]))}warn(l,...w){this.f(y.Warning)&&this.g(y.Warning,i([l,...w]))}error(l,...w){if(this.f(y.Error))if(l instanceof Error){const L=Array.prototype.slice.call(arguments);L[0]=l.stack,this.g(y.Error,i(L))}else this.g(y.Error,i([l,...w]))}flush(){}}e.$9i=m;class p extends a{constructor(l=e.$6i){super(),this.setLevel(l),this.g=!g.$i}trace(l,...w){this.f(y.Trace)&&(this.g?console.log(`\x1B[90m[main ${S()}]\x1B[0m`,l,...w):console.log(`[main ${S()}]`,l,...w))}debug(l,...w){this.f(y.Debug)&&(this.g?console.log(`\x1B[90m[main ${S()}]\x1B[0m`,l,...w):console.log(`[main ${S()}]`,l,...w))}info(l,...w){this.f(y.Info)&&(this.g?console.log(`\x1B[90m[main ${S()}]\x1B[0m`,l,...w):console.log(`[main ${S()}]`,l,...w))}warn(l,...w){this.f(y.Warning)&&(this.g?console.warn(`\x1B[93m[main ${S()}]\x1B[0m`,l,...w):console.warn(`[main ${S()}]`,l,...w))}error(l,...w){this.f(y.Error)&&(this.g?console.error(`\x1B[91m[main ${S()}]\x1B[0m`,l,...w):console.error(`[main ${S()}]`,l,...w))}dispose(){}flush(){}}e.$0i=p;class f extends a{constructor(l=e.$6i,w=!0){super(),this.g=w,this.setLevel(l)}trace(l,...w){this.f(y.Trace)&&(this.g?console.log("%cTRACE","color: #888",l,...w):console.log(l,...w))}debug(l,...w){this.f(y.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",l,...w):console.log(l,...w))}info(l,...w){this.f(y.Info)&&(this.g?console.log("%c INFO","color: #33f",l,...w):console.log(l,...w))}warn(l,...w){this.f(y.Warning)&&(this.g?console.log("%c WARN","color: #993",l,...w):console.log(l,...w))}error(l,...w){this.f(y.Error)&&(this.g?console.log("%c  ERR","color: #f33",l,...w):console.error(l,...w))}dispose(){}flush(){}}e.$$i=f;class t extends a{constructor(l,w=e.$6i){super(),this.g=l,this.setLevel(w)}trace(l,...w){this.f(y.Trace)&&this.g.log(y.Trace,[this.h(l),...w])}debug(l,...w){this.f(y.Debug)&&this.g.log(y.Debug,[this.h(l),...w])}info(l,...w){this.f(y.Info)&&this.g.log(y.Info,[this.h(l),...w])}warn(l,...w){this.f(y.Warning)&&this.g.log(y.Warning,[this.h(l),...w])}error(l,...w){this.f(y.Error)&&this.g.log(y.Error,[this.h(l),...w])}h(l){return typeof l=="string"?l:(0,D.$ki)(l,this.f(y.Trace))}dispose(){}flush(){}}e.$_i=t;class s extends a{constructor(l){super(),this.g=l,l.length&&this.setLevel(l[0].getLevel())}setLevel(l){for(const w of this.g)w.setLevel(l);super.setLevel(l)}trace(l,...w){for(const L of this.g)L.trace(l,...w)}debug(l,...w){for(const L of this.g)L.debug(l,...w)}info(l,...w){for(const L of this.g)L.info(l,...w)}warn(l,...w){for(const L of this.g)L.warn(l,...w)}error(l,...w){for(const L of this.g)L.error(l,...w)}flush(){for(const l of this.g)l.flush()}dispose(){for(const l of this.g)l.dispose()}}e.$aj=s;class o extends R.$mb{constructor(l,w,L){if(super(),this.h=l,this.j=w,this.b=new A.$xi,this.c=this.B(new M.$hc),this.onDidChangeLoggers=this.c.event,this.f=this.B(new M.$hc),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new M.$hc),this.onDidChangeVisibility=this.g.event,L)for(const N of L)this.b.set(N.resource,{logger:void 0,info:N})}k(l){return(0,$.$le)(l)?[...this.b.values()].find(w=>w.info.id===l):this.b.get(l)}getLogger(l){return this.k(l)?.logger}createLogger(l,w){const L=this.l(l),N=(0,$.$le)(l)?l:w?.id??(0,h.$ni)(L.toString()).toString(16);let j=this.b.get(L)?.logger;const T=w?.logLevel==="always"?y.Trace:w?.logLevel;j||(j=this.m(L,T??this.getLogLevel(L)??this.h,{...w,id:N}));const O={logger:j,info:{resource:L,id:N,logLevel:T,name:w?.name,hidden:w?.hidden,extensionId:w?.extensionId,when:w?.when}};return this.registerLogger(O.info),this.b.set(L,O),j}l(l){return(0,$.$le)(l)?(0,E.$gg)(this.j,`${l}.log`):l}setLogLevel(l,w){if(P.URI.isUri(l)){const L=l,N=w,j=this.b.get(L);j&&N!==j.info.logLevel&&(j.info.logLevel=N===this.h?void 0:N,j.logger?.setLevel(N),this.b.set(j.info.resource,j),this.f.fire([L,N]))}else{this.h=l;for(const[L,N]of this.b.entries())this.b.get(L)?.info.logLevel===void 0&&N.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(l,w){const L=this.k(l);L&&w!==!L.info.hidden&&(L.info.hidden=!w,this.b.set(L.info.resource,L),this.g.fire([L.info.resource,w]))}getLogLevel(l){let w;return l&&(w=this.b.get(l)?.info.logLevel),w??this.h}registerLogger(l){const w=this.b.get(l.resource);w?w.info.hidden!==l.hidden&&this.setVisibility(l.resource,!l.hidden):(this.b.set(l.resource,{info:l,logger:void 0}),this.c.fire({added:[l],removed:[]}))}deregisterLogger(l){const w=this.b.get(l);w&&(w.logger&&w.logger.dispose(),this.b.delete(l),this.c.fire({added:[],removed:[w.info]}))}*getRegisteredLoggers(){for(const l of this.b.values())yield l.info}getRegisteredLogger(l){return this.b.get(l)?.info}dispose(){this.b.forEach(l=>l.logger?.dispose()),this.b.clear(),super.dispose()}}e.$bj=o;class n{constructor(){this.onDidChangeLogLevel=new M.$hc().event}setLevel(l){}getLevel(){return y.Info}trace(l,...w){}debug(l,...w){}info(l,...w){}warn(l,...w){}error(l,...w){}critical(l,...w){}dispose(){}flush(){}}e.$cj=n;class c extends n{}e.$dj=c;function d(u){if(u.verbose)return y.Trace;if(typeof u.logLevel=="string"){const l=k(u.logLevel.toLowerCase());if(l!==void 0)return l}return e.$6i}e.$ej=d;function v(u){switch(u){case y.Trace:return"trace";case y.Debug:return"debug";case y.Info:return"info";case y.Warning:return"warn";case y.Error:return"error";case y.Off:return"off"}}e.$fj=v;function k(u){switch(u){case"trace":return y.Trace;case"debug":return y.Debug;case"info":return y.Info;case"warn":return y.Warning;case"error":return y.Error;case"critical":return y.Error;case"off":return y.Off}}e.$gj=k,e.$hj=new I.$Zi("logLevel",v(y.Info))}),define(De[233],Ce([1,0,19,13,8,4,3,14,82,17]),function($e,e,D,M,h,R,A,g,E,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jp=void 0;class P extends A.$mb{constructor(b,S){super(),this.a=b,this.b=S,this.c=this.B(new R.$hc),this.onDidChangeFile=this.c.event,this.g=this.B(new R.$hc),this.onDidWatchError=this.g.event,this.j=[],this.k=this.B(new M.$Cg(0)),this.s=[],this.t=this.B(new M.$Cg(0))}watch(b,S){return S.recursive||this.b?.watcher?.forceUniversal?this.l(b,S):this.u(b,S)}l(b,S){const C={path:this.C(b),excludes:S.excludes,includes:S.includes,recursive:S.recursive},y=(0,D.$Nf)(this.j,C);return this.m(),(0,A.$kb)(()=>{y(),this.m()})}m(){this.k.trigger(()=>this.n()).catch(b=>(0,h.$Y)(b))}n(){this.h||(this.h=this.B(this.p(S=>this.c.fire((0,E.$Fp)(S)),S=>this.z(S),this.a.getLevel()===$.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===$.LogLevel.Trace)})));const b=this.b?.watcher?.recursive?.usePolling;if(b===!0)for(const S of this.j)(0,E.$Bp)(S)&&(S.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(b))for(const S of this.j)(0,E.$Bp)(S)&&b.includes(S.path)&&(S.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}u(b,S){const C={path:this.C(b),excludes:S.excludes,includes:S.includes,recursive:!1},y=(0,D.$Nf)(this.s,C);return this.v(),(0,A.$kb)(()=>{y(),this.v()})}v(){this.t.trigger(()=>this.w()).catch(b=>(0,h.$Y)(b))}w(){return this.r||(this.r=this.B(this.y(b=>this.c.fire((0,E.$Fp)(b)),b=>this.z(b),this.a.getLevel()===$.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.r?.setVerboseLogging(this.a.getLevel()===$.LogLevel.Trace)}))),this.r.watch(this.s)}z(b){b.type==="error"&&this.g.fire(b.message),this.a[b.type](b.message)}C(b){return(0,g.$9c)(b.fsPath)}}e.$Jp=P}),define(De[234],Ce([1,0,49,363,13,28,21,4,32,3,14,9,24,96,29,193,30,227,233,44,231,230]),function($e,e,D,M,h,R,A,g,E,$,P,I,b,S,C,y,r,i,a,m,p,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zp=void 0,(()=>{try{(0,M.gracefulify)(D)}catch(s){console.error(`Error enabling graceful-fs: ${(0,m.$ki)(s)}`)}})();class t extends a.$Jp{static{this.D=!1}constructor(o,n){super(o,n),this.onDidChangeCapabilities=g.Event.None,this.I=new R.$xi(c=>b.$0f.getComparisonKey(c)),this.O=new Map,this.P=new Map,this.Q=new Map}get capabilities(){return this.F||(this.F=253982,I.$k&&(this.F|=1024)),this.F}async stat(o){try{const{stat:n,symbolicLink:c}=await C.SymlinkSupport.stat(this.C(o));return{type:this.H(n,c),ctime:n.birthtime.getTime(),mtime:n.mtime.getTime(),size:n.size,permissions:n.mode&128?void 0:r.FilePermission.Locked}}catch(n){throw this.ab(n)}}async G(o){try{return await this.stat(o)}catch{return}}async readdir(o){try{const n=await C.Promises.readdir(this.C(o),{withFileTypes:!0}),c=[];return await Promise.all(n.map(async d=>{try{let v;d.isSymbolicLink()?v=(await this.stat((0,b.$gg)(o,d.name))).type:v=this.H(d),c.push([d.name,v])}catch(v){this.a.trace(v)}})),c}catch(n){throw this.ab(n)}}H(o,n){let c;return n?.dangling?c=r.FileType.Unknown:o.isFile()?c=r.FileType.File:o.isDirectory()?c=r.FileType.Directory:c=r.FileType.Unknown,n&&(c|=r.FileType.SymbolicLink),c}async J(o){const n=this.C(o);this.L(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${n})`);let c;for(;c=this.I.get(o);)this.L(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${n})`),await c.wait();const d=new h.$Dg;return this.I.set(o,d),this.L(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${n})`),(0,$.$kb)(()=>{this.L(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${n})`),this.I.get(o)===d&&(this.L(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${n})`),this.I.delete(o)),this.L(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${n})`),d.open()})}async readFile(o,n){let c;try{n?.atomic&&(this.L(`[Disk FileSystemProvider]: atomic read operation started (${this.C(o)})`),c=await this.J(o));const d=this.C(o);return await C.Promises.readFile(d)}catch(d){throw this.ab(d)}finally{c?.dispose()}}L(o){t.D&&this.a.trace(o)}readFileStream(o,n,c){const d=(0,S.$vc)(v=>A.$Hc.concat(v.map(k=>A.$Hc.wrap(k))).buffer);return(0,i.$zp)(this,o,d,v=>v.buffer,{...n,bufferSize:256*1024},c),d}async writeFile(o,n,c){return c?.atomic!==!1&&c?.atomic?.postfix?this.M(o,(0,b.$gg)((0,b.$fg)(o),`${(0,b.$dg)(o)}${c.atomic.postfix}`),n,c):this.N(o,n,c)}async M(o,n,c,d){await this.N(n,c,d);try{await this.rename(n,o,{overwrite:!0})}catch(v){try{await this.delete(n,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw v}}async N(o,n,c){let d;try{const v=this.C(o);if(!c.create||!c.overwrite){if(await C.Promises.exists(v)){if(!c.overwrite)throw(0,r.$dk)((0,y.localize)(0,null),r.FileSystemProviderErrorCode.FileExists)}else if(!c.create)throw(0,r.$dk)((0,y.localize)(1,null),r.FileSystemProviderErrorCode.FileNotFound)}d=await this.open(o,{create:!0,unlock:c.unlock}),await this.write(d,0,n,0,n.byteLength)}catch(v){throw await this.bb(o,v)}finally{typeof d=="number"&&await this.close(d)}}static{this.R=!0}static configureFlushOnWrite(o){t.R=o}async open(o,n){const c=this.C(o);let d;(0,r.$5j)(n)&&(d=await this.J(o));let v;try{if((0,r.$5j)(n)&&n.unlock)try{const{stat:u}=await C.SymlinkSupport.stat(c);u.mode&128||await C.Promises.chmod(c,u.mode|128)}catch(u){u.code!=="ENOENT"&&this.a.trace(u)}let k;if((0,r.$5j)(n)){if(I.$i)try{await C.Promises.truncate(c,0),k="r+"}catch(u){u.code!=="ENOENT"&&this.a.trace(u)}k||(k="w")}else k="r";v=await C.Promises.open(c,k)}catch(k){throw d?.dispose(),(0,r.$5j)(n)?await this.bb(o,k):this.ab(k)}if(this.O.set(v,0),(0,r.$5j)(n)&&this.Q.set(v,o),d){const k=this.P.get(v);this.L(`[Disk FileSystemProvider]: open() - storing lock for handle ${v} (${c})`),this.P.set(v,d),k&&(this.L(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${v} (${c})`),k.dispose())}return v}async close(o){const n=this.P.get(o);try{if(this.O.delete(o),this.Q.delete(o)&&t.R)try{await C.Promises.fdatasync(o)}catch(c){t.configureFlushOnWrite(!1),this.a.error(c)}return await C.Promises.close(o)}catch(c){throw this.ab(c)}finally{n&&(this.P.get(o)===n&&(this.L(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${o}`),this.P.delete(o)),this.L(`[Disk FileSystemProvider]: close() - disposing lock for handle ${o}`),n.dispose())}}async read(o,n,c,d,v){const k=this.S(o,n);let u=null;try{u=(await C.Promises.read(o,c,d,v,k)).bytesRead}catch(l){throw this.ab(l)}finally{this.U(o,k,u)}return u}S(o,n){return n===this.O.get(o)?null:n}U(o,n,c){const d=this.O.get(o);typeof d=="number"&&(typeof n=="number"||(typeof c=="number"?this.O.set(o,d+c):this.O.delete(o)))}async write(o,n,c,d,v){return(0,h.$Wg)(()=>this.W(o,n,c,d,v),100,3)}async W(o,n,c,d,v){const k=this.S(o,n);let u=null;try{u=(await C.Promises.write(o,c,d,v,k)).bytesWritten}catch(l){throw await this.bb(this.Q.get(o),l)}finally{this.U(o,k,u)}return u}async mkdir(o){try{await C.Promises.mkdir(this.C(o))}catch(n){throw this.ab(n)}}async delete(o,n){try{const c=this.C(o);if(n.recursive){let d;n?.atomic!==!1&&n.atomic.postfix&&(d=(0,P.$$c)((0,P.$bd)(c),`${(0,P.$cd)(c)}${n.atomic.postfix}`)),await C.Promises.rm(c,C.RimRafMode.MOVE,d)}else try{await C.Promises.unlink(c)}catch(d){if(d.code==="EPERM"||d.code==="EISDIR"){let v=!1;try{const{stat:k,symbolicLink:u}=await C.SymlinkSupport.stat(c);v=k.isDirectory()&&!u}catch{}if(v)await C.Promises.rmdir(c);else throw d}else throw d}}catch(c){throw this.ab(c)}}async rename(o,n,c){const d=this.C(o),v=this.C(n);if(d!==v)try{await this.X(o,n,"move",c.overwrite),await C.Promises.rename(d,v)}catch(k){throw(k.code==="EINVAL"||k.code==="EBUSY"||k.code==="ENAMETOOLONG")&&(k=new Error((0,y.localize)(2,null,(0,P.$cd)(d),(0,P.$cd)((0,P.$bd)(v)),k.toString()))),this.ab(k)}}async copy(o,n,c){const d=this.C(o),v=this.C(n);if(d!==v)try{await this.X(o,n,"copy",c.overwrite),await C.Promises.copy(d,v,{preserveSymlinks:!0})}catch(k){throw(k.code==="EINVAL"||k.code==="EBUSY"||k.code==="ENAMETOOLONG")&&(k=new Error((0,y.localize)(3,null,(0,P.$cd)(d),(0,P.$cd)((0,P.$bd)(v)),k.toString()))),this.ab(k)}}async X(o,n,c,d){const v=this.C(o),k=this.C(n);let u=!1;if(!!(this.capabilities&1024)||(u=(0,E.$Je)(v,k,!0)),u){if(c==="copy")throw(0,r.$dk)((0,y.localize)(4,null),r.FileSystemProviderErrorCode.FileExists);if(c==="move")return}const w=await this.G(o);if(!w)throw(0,r.$dk)((0,y.localize)(5,null),r.FileSystemProviderErrorCode.FileNotFound);const L=await this.G(n);if(L){if(!d)throw(0,r.$dk)((0,y.localize)(6,null),r.FileSystemProviderErrorCode.FileExists);w.type&r.FileType.File&&L.type&r.FileType.File||await this.delete(n,{recursive:!0,useTrash:!1,atomic:!1})}}async cloneFile(o,n){return this.Y(o,n,!1)}async Y(o,n,c){const d=this.C(o),v=this.C(n),k=!!(this.capabilities&1024);if((0,E.$Je)(d,v,!k))return;const u=new $.$lb;try{const[l,w]=await Promise.all([this.J(o),this.J(n)]);u.add(l),u.add(w),c&&await C.Promises.mkdir((0,P.$bd)(v),{recursive:!0}),await C.Promises.copyFile(d,v)}catch(l){if(l.code==="ENOENT"&&!c)return this.Y(o,n,!0);throw this.ab(l)}finally{u.dispose()}}p(o,n,c){return new p.$Qp(d=>o(d),d=>n(d),c)}y(o,n,c){return new f.$Yp(d=>o(d),d=>n(d),c)}ab(o){if(o instanceof r.$ck)return o;let n=o,c;switch(o.code){case"ENOENT":c=r.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":c=r.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":c=r.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":c=r.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":c=r.FileSystemProviderErrorCode.NoPermissions;break;case"ERR_UNC_HOST_NOT_ALLOWED":n=`${o.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`,c=r.FileSystemProviderErrorCode.Unknown;break;default:c=r.FileSystemProviderErrorCode.Unknown}return(0,r.$dk)(n,c)}async bb(o,n){let c=this.ab(n);if(o&&c.code===r.FileSystemProviderErrorCode.NoPermissions)try{const{stat:d}=await C.SymlinkSupport.stat(this.C(o));d.mode&128||(c=(0,r.$dk)(n,r.FileSystemProviderErrorCode.FileWriteLocked))}catch(d){this.a.trace(d)}return c}}e.$Zp=t}),define(De[235],Ce([1,0,3,17]),function($e,e,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fN=void 0;class h extends D.$mb{constructor(A,g=[]){super(),this.a=new M.$aj([A,...g]),this.B(A.onDidChangeLogLevel(E=>this.setLevel(E)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(A){this.a.setLevel(A)}getLevel(){return this.a.getLevel()}trace(A,...g){this.a.trace(A,...g)}debug(A,...g){this.a.debug(A,...g)}info(A,...g){this.a.info(A,...g)}warn(A,...g){this.a.warn(A,...g)}error(A,...g){this.a.error(A,...g)}flush(){this.a.flush()}}e.$fN=h}),define(De[236],Ce([1,0,30,17]),function($e,e,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7M=void 0;var h;(function($){$[$.Trace=0]="Trace",$[$.Debug=1]="Debug",$[$.Info=2]="Info",$[$.Warning=3]="Warning",$[$.Error=4]="Error",$[$.Critical=5]="Critical",$[$.Off=6]="Off"})(h||(h={}));async function R($,P,I,b,S){try{const C=await new Promise((r,i)=>{$e(["@vscode/spdlog"],r,i)});C.setFlushOn(h.Trace);const y=await C.createAsyncRotatingLogger($,P,I,b);return S?y.clearFormatters():y.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),y}catch(C){console.error(C)}return null}function A($,P,I){switch(P){case M.LogLevel.Trace:$.trace(I);break;case M.LogLevel.Debug:$.debug(I);break;case M.LogLevel.Info:$.info(I);break;case M.LogLevel.Warning:$.warn(I);break;case M.LogLevel.Error:$.error(I);break;case M.LogLevel.Off:break;default:throw new Error(`Invalid log level ${P}`)}}function g($,P){switch(P){case M.LogLevel.Trace:$.setLevel(h.Trace);break;case M.LogLevel.Debug:$.setLevel(h.Debug);break;case M.LogLevel.Info:$.setLevel(h.Info);break;case M.LogLevel.Warning:$.setLevel(h.Warning);break;case M.LogLevel.Error:$.setLevel(h.Error);break;case M.LogLevel.Off:$.setLevel(h.Off);break;default:throw new Error(`Invalid log level ${P}`)}}class E extends M.$9i{constructor(P,I,b,S,C){super(),this.k=[],this.setLevel(C),this.l=this.n(P,I,b,S),this.B(this.onDidChangeLogLevel(y=>{this.m&&g(this.m,y)}))}async n(P,I,b,S){const C=b?6:1,y=30/C*D.$yk.MB,r=await R(P,I,y,C,S);if(r){this.m=r,g(this.m,this.getLevel());for(const{level:i,message:a}of this.k)A(this.m,i,a);this.k=[]}}g(P,I){this.m?A(this.m,P,I):this.getLevel()<=P&&this.k.push({level:P,message:I})}flush(){this.m?this.m.flush():this.l.then(()=>this.flush())}dispose(){this.m?this.r():this.l.then(()=>this.r())}r(){this.m&&(this.m.drop(),this.m=void 0)}}e.$7M=E}),define(De[132],Ce([1,0,40,194,6]),function($e,e,D,M,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zs=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var R;(function(E){E[E.Unnecessary=1]="Unnecessary",E[E.Deprecated=2]="Deprecated"})(R||(e.MarkerTag=R={}));var A;(function(E){E[E.Hint=1]="Hint",E[E.Info=2]="Info",E[E.Warning=4]="Warning",E[E.Error=8]="Error"})(A||(e.MarkerSeverity=A={})),function(E){function $(C,y){return y-C}E.compare=$;const P=Object.create(null);P[E.Error]=(0,M.localize)(0,null),P[E.Warning]=(0,M.localize)(1,null),P[E.Info]=(0,M.localize)(2,null);function I(C){return P[C]||""}E.toString=I;function b(C){switch(C){case D.default.Error:return E.Error;case D.default.Warning:return E.Warning;case D.default.Info:return E.Info;case D.default.Ignore:return E.Hint}}E.fromSeverity=b;function S(C){switch(C){case E.Error:return D.default.Error;case E.Warning:return D.default.Warning;case E.Info:return D.default.Info;case E.Hint:return D.default.Ignore}}E.toSeverity=S}(A||(e.MarkerSeverity=A={}));var g;(function(E){const $="";function P(b){return I(b,!0)}E.makeKey=P;function I(b,S){const C=[$];return b.source?C.push(b.source.replace("\xA6","\\\xA6")):C.push($),b.code?typeof b.code=="string"?C.push(b.code.replace("\xA6","\\\xA6")):C.push(b.code.value.replace("\xA6","\\\xA6")):C.push($),b.severity!==void 0&&b.severity!==null?C.push(A.toString(b.severity)):C.push($),b.message&&S?C.push(b.message.replace("\xA6","\\\xA6")):C.push($),b.startLineNumber!==void 0&&b.startLineNumber!==null?C.push(b.startLineNumber.toString()):C.push($),b.startColumn!==void 0&&b.startColumn!==null?C.push(b.startColumn.toString()):C.push($),b.endLineNumber!==void 0&&b.endLineNumber!==null?C.push(b.endLineNumber.toString()):C.push($),b.endColumn!==void 0&&b.endColumn!==null?C.push(b.endColumn.toString()):C.push($),C.push($),C.join("\xA6")}E.makeKeyOptionalMessage=I})(g||(e.IMarkerData=g={})),e.$Zs=(0,h.$zh)("markerService")}),define(De[237],Ce([1,0,4,40,6]),function($e,e,D,M,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xu=e.$Wu=e.NotificationsFilter=e.NeverShowAgainScope=e.NotificationPriority=e.$Vu=e.Severity=void 0,e.Severity=M.default,e.$Vu=(0,h.$zh)("notificationService");var R;(function(P){P[P.DEFAULT=0]="DEFAULT",P[P.SILENT=1]="SILENT",P[P.URGENT=2]="URGENT"})(R||(e.NotificationPriority=R={}));var A;(function(P){P[P.WORKSPACE=0]="WORKSPACE",P[P.PROFILE=1]="PROFILE",P[P.APPLICATION=2]="APPLICATION"})(A||(e.NeverShowAgainScope=A={}));var g;(function(P){P[P.OFF=0]="OFF",P[P.SILENT=1]="SILENT",P[P.ERROR=2]="ERROR"})(g||(e.NotificationsFilter=g={}));class E{constructor(){this.progress=new $,this.onDidClose=D.Event.None,this.onDidChangeVisibility=D.Event.None}updateSeverity(I){}updateMessage(I){}updateActions(I){}close(){}}e.$Wu=E;class ${infinite(){}done(){}total(I){}worked(I){}}e.$Xu=$}),define(De[133],Ce([1,0,15,2,6]),function($e,e,D,M,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$FT=e.$ET=e.$DT=e.$CT=e.$BT=void 0,e.$BT=(0,h.$zh)("openerService");function R($,P){return M.URI.isUri($)?(0,D.$Od)($.scheme,P):(0,D.$Pd)($,P+":")}e.$CT=R;function A($,...P){return P.some(I=>R($,I))}e.$DT=A;function g($,P){return $.with({fragment:`${P.startLineNumber},${P.startColumn}${P.endLineNumber?`-${P.endLineNumber}${P.endColumn?`,${P.endColumn}`:""}`:""}`})}e.$ET=g;function E($){let P;const I=/^L?(\d+)(?:,(\d+))?(-L?(\d+)(?:,(\d+))?)?/.exec($.fragment);return I&&(P={startLineNumber:parseInt(I[1]),startColumn:I[2]?parseInt(I[2]):1,endLineNumber:I[4]?parseInt(I[4]):void 0,endColumn:I[4]?I[5]?parseInt(I[5]):1:void 0},$=$.with({fragment:""})),{selection:P,uri:$}}e.$FT=E}),define(De[238],Ce([1,0,9,45]),function($e,e,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let h;if(typeof D.$g.vscode<"u"&&typeof D.$g.vscode.context<"u"){const R=D.$g.vscode.context.configuration();if(R)h=R.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){if(h=globalThis._VSCODE_PRODUCT_JSON,M.env.VSCODE_DEV&&Object.assign(h,{nameShort:`${h.nameShort} Dev`,nameLong:`${h.nameLong} Dev`,dataFolderName:`${h.dataFolderName}-dev`,serverDataFolderName:h.serverDataFolderName?`${h.serverDataFolderName}-dev`:void 0}),!h.version){const R=globalThis._VSCODE_PACKAGE_JSON;Object.assign(h,{version:R.version})}}else h={},Object.keys(h).length===0&&Object.assign(h,{version:"1.82.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",serverLicenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=h}),define(De[134],Ce([1,0,6]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jj=e.$ij=void 0,e.$ij=(0,D.$zh)("productService"),e.$jj="vscode://schemas/vscode-product"});var Ve=this&&this.__param||function($e,e){return function(D,M){e(D,M,$e)}};define(De[83],Ce([1,0,13,22,3,6]),function($e,e,D,M,h,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4u=e.$3u=e.$2u=e.$1u=e.$Zu=e.ProgressLocation=e.$Yu=void 0,e.$Yu=(0,R.$zh)("progressService");var A;(function(P){P[P.Explorer=1]="Explorer",P[P.Scm=3]="Scm",P[P.Extensions=5]="Extensions",P[P.Window=10]="Window",P[P.Notification=15]="Notification",P[P.Dialog=20]="Dialog"})(A||(e.ProgressLocation=A={})),e.$Zu=Object.freeze({total(){},worked(){},done(){}});class g{static{this.None=Object.freeze({report(){}})}get value(){return this.a}constructor(I,b){this.c=I,this.report=b?.async?this.e.bind(this):this.d.bind(this)}d(I){this.a=I,this.c(this.a)}e(I){Promise.resolve(this.b).finally(()=>{this.a=I;const b=this.c(this.a);this.b=Promise.resolve(b).finally(()=>this.b=void 0)})}}e.$1u=g;let E=class extends h.$mb{constructor(I,b){super(),this.a=new D.$Zg,b.withProgress(I,S=>(this.b=S,this.c&&S.report(this.c),this.a.p)),this.B((0,h.$kb)(()=>this.a.complete()))}report(I){this.b?this.b.report(I):this.c=I}};e.$2u=E,e.$2u=E=Ke([Ve(1,e.$Yu)],E);class $ extends h.$mb{constructor(I){super(),this.g=I,this.a=0,this.b=this.B(new h.$lb)}start(I){this.stop();const b=++this.a,S=new M.$rc;return this.f=setTimeout(()=>{b===this.a&&(this.c=this.g.show(!0))},I),this.b.add((0,h.$kb)(()=>clearTimeout(this.f))),this.b.add((0,h.$kb)(()=>S.cancel())),this.b.add((0,h.$kb)(()=>this.c?this.c.done():void 0)),{id:b,token:S.token,stop:()=>this.h(b),isCurrent:()=>this.a===b}}stop(){this.h(this.a)}h(I){this.a===I&&this.b.clear()}}e.$3u=$,e.$4u=(0,R.$zh)("editorProgressService")}),define(De[41],Ce([1,0,54,18]),function($e,e,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6m=void 0;class h{constructor(){this.a=new Map}add(A,g){D.ok(M.$le(A)),D.ok(M.$ne(g)),D.ok(!this.a.has(A),"There is already an extension with this id"),this.a.set(A,g)}knows(A){return this.a.has(A)}as(A){return this.a.get(A)||null}}e.$6m=new h}),define(De[104],Ce([1,0,4,41]),function($e,e,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7m=void 0,e.$7m={JSONContribution:"base.contributions.json"};function h(g){return g.length>0&&g.charAt(g.length-1)==="#"?g.substring(0,g.length-1):g}class R{constructor(){this.b=new D.$hc,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(E,$){this.a[h(E)]=$,this.b.fire(E)}notifySchemaChanged(E){this.b.fire(E)}getSchemaContributions(){return{schemas:this.a}}}const A=new R;M.$6m.add(e.$7m.JSONContribution,A)}),define(De[135],Ce([1,0,19,4,18,185,50,104,41]),function($e,e,D,M,h,R,A,g,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nn=e.$mn=e.$ln=e.$kn=e.$jn=e.$in=e.$hn=e.$gn=e.$fn=e.$en=e.$dn=e.$cn=e.$bn=e.$an=e.$_m=e.ConfigurationScope=e.$$m=e.EditPresentationTypes=void 0;var $;(function(f){f.Multiline="multilineText",f.Singleline="singlelineText"})($||(e.EditPresentationTypes=$={})),e.$$m={Configuration:"base.contributions.configuration"};var P;(function(f){f[f.APPLICATION=1]="APPLICATION",f[f.MACHINE=2]="MACHINE",f[f.WINDOW=3]="WINDOW",f[f.RESOURCE=4]="RESOURCE",f[f.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",f[f.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(P||(e.ConfigurationScope=P={})),e.$_m={properties:{},patternProperties:{}},e.$an={properties:{},patternProperties:{}},e.$bn={properties:{},patternProperties:{}},e.$cn={properties:{},patternProperties:{}},e.$dn={properties:{},patternProperties:{}},e.$en={properties:{},patternProperties:{}},e.$fn="vscode://schemas/settings/resourceLanguage",e.$gn="vscode://schemas/settings/configurationDefaults";const I=E.$6m.as(g.$7m.JSONContribution);class b{constructor(){this.h=new Set,this.i=new M.$hc,this.onDidSchemaChange=this.i.event,this.j=new M.$hc,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:R.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},I.registerSchema(e.$fn,this.g),this.v()}registerConfiguration(t,s=!0){this.registerConfigurations([t],s)}registerConfigurations(t,s=!0){const o=new Set;this.n(t,s,o),I.registerSchema(e.$fn,this.g),this.i.fire(),this.j.fire({properties:o})}deregisterConfigurations(t){const s=new Set;this.o(t,s),I.registerSchema(e.$fn,this.g),this.i.fire(),this.j.fire({properties:s})}updateConfigurations({add:t,remove:s}){const o=new Set;this.o(s,o),this.n(t,!1,o),I.registerSchema(e.$fn,this.g),this.i.fire(),this.j.fire({properties:o})}registerDefaultConfigurations(t){const s=new Set;this.k(t,s),this.i.fire(),this.j.fire({properties:s,defaultsOverrides:!0})}k(t,s){const o=[];for(const{overrides:n,source:c}of t)for(const d in n)if(s.add(d),e.$in.test(d)){const v=this.a.get(d),k=v?.valuesSources??new Map;if(c)for(const L of Object.keys(n[d]))k.set(L,c);const u={...v?.value||{},...n[d]};this.a.set(d,{source:c,value:u,valuesSources:k});const l=(0,A.$di)(d),w={type:"object",default:u,description:R.localize(1,null,l),$ref:e.$fn,defaultDefaultValue:u,source:h.$le(c)?void 0:c,defaultValueSource:c};o.push(...y(d)),this.d[d]=w,this.b.properties[d]=w}else{this.a.set(d,{value:n[d],source:c});const v=this.d[d];v&&(this.w(d,v),this.r(d,v))}this.m(o)}deregisterDefaultConfigurations(t){const s=new Set;this.l(t,s),this.i.fire(),this.j.fire({properties:s,defaultsOverrides:!0})}l(t,s){for(const{overrides:o,source:n}of t)for(const c in o){const d=this.a.get(c),v=h.$le(n)?n:n?.id,k=h.$le(d?.source)?d?.source:d?.source?.id;if(v===k)if(s.add(c),this.a.delete(c),e.$in.test(c))delete this.d[c],delete this.b.properties[c];else{const u=this.d[c];u&&(this.w(c,u),this.r(c,u))}}this.u()}deltaConfiguration(t){let s=!1;const o=new Set;t.removedDefaults&&(this.l(t.removedDefaults,o),s=!0),t.addedDefaults&&(this.k(t.addedDefaults,o),s=!0),t.removedConfigurations&&this.o(t.removedConfigurations,o),t.addedConfigurations&&this.n(t.addedConfigurations,!1,o),this.i.fire(),this.j.fire({properties:o,defaultsOverrides:s})}notifyConfigurationSchemaUpdated(...t){this.i.fire()}registerOverrideIdentifiers(t){this.m(t),this.i.fire()}m(t){for(const s of t)this.h.add(s);this.u()}n(t,s,o){t.forEach(n=>{this.p(n,s,n.extensionInfo,n.restrictedProperties,void 0,o),this.c.push(n),this.q(n)})}o(t,s){const o=n=>{if(n.properties)for(const c in n.properties){s.add(c);const d=this.d[c];d?.policy?.name&&this.e.delete(d.policy.name),delete this.d[c],this.s(c,n.properties[c])}n.allOf?.forEach(c=>o(c))};for(const n of t){o(n);const c=this.c.indexOf(n);c!==-1&&this.c.splice(c,1)}}p(t,s=!0,o,n,c=3,d){c=h.$ue(t.scope)?c:t.scope;const v=t.properties;if(v)for(const u in v){const l=v[u];if(s&&m(u,l)){delete v[u];continue}if(l.source=o,l.defaultDefaultValue=v[u].default,this.w(u,l),e.$in.test(u)?l.scope=void 0:(l.scope=h.$ue(l.scope)?c:l.scope,l.restricted=h.$ue(l.restricted)?!!n?.includes(u):l.restricted),v[u].hasOwnProperty("included")&&!v[u].included){this.f[u]=v[u],delete v[u];continue}else this.d[u]=v[u],v[u].policy?.name&&this.e.set(v[u].policy.name,u);!v[u].deprecationMessage&&v[u].markdownDeprecationMessage&&(v[u].deprecationMessage=v[u].markdownDeprecationMessage),d.add(u)}const k=t.allOf;if(k)for(const u of k)this.p(u,s,o,n,c,d)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(t){const s=o=>{const n=o.properties;if(n)for(const d in n)this.r(d,n[d]);o.allOf?.forEach(s)};s(t)}r(t,s){switch(e.$_m.properties[t]=s,s.scope){case 1:e.$an.properties[t]=s;break;case 2:e.$bn.properties[t]=s;break;case 6:e.$cn.properties[t]=s;break;case 3:e.$dn.properties[t]=s;break;case 4:e.$en.properties[t]=s;break;case 5:e.$en.properties[t]=s,this.g.properties[t]=s;break}}s(t,s){switch(delete e.$_m.properties[t],s.scope){case 1:delete e.$an.properties[t];break;case 2:delete e.$bn.properties[t];break;case 6:delete e.$cn.properties[t];break;case 3:delete e.$dn.properties[t];break;case 4:case 5:delete e.$en.properties[t],delete this.g.properties[t];break}}u(){for(const t of this.h.values()){const s=`[${t}]`,o={type:"object",description:R.localize(2,null),errorMessage:R.localize(3,null),$ref:e.$fn};this.w(s,o),e.$_m.properties[s]=o,e.$an.properties[s]=o,e.$bn.properties[s]=o,e.$cn.properties[s]=o,e.$dn.properties[s]=o,e.$en.properties[s]=o}}v(){const t={type:"object",description:R.localize(4,null),errorMessage:R.localize(5,null),$ref:e.$fn};e.$_m.patternProperties[e.$hn]=t,e.$an.patternProperties[e.$hn]=t,e.$bn.patternProperties[e.$hn]=t,e.$cn.patternProperties[e.$hn]=t,e.$dn.patternProperties[e.$hn]=t,e.$en.patternProperties[e.$hn]=t,this.i.fire()}w(t,s){const o=this.a.get(t);let n=o?.value,c=o?.source;h.$se(n)&&(n=s.defaultDefaultValue,c=void 0),h.$se(n)&&(n=i(s.type)),s.default=n,s.defaultValueSource=c}}const S="\\[([^\\]]+)\\]",C=new RegExp(S,"g");e.$hn=`^(${S})+$`,e.$in=new RegExp(e.$hn);function y(f){const t=[];if(e.$in.test(f)){let s=C.exec(f);for(;s?.length;){const o=s[1].trim();o&&t.push(o),s=C.exec(f)}}return(0,D.$Ff)(t)}e.$jn=y;function r(f){return f.reduce((t,s)=>`${t}[${s}]`,"")}e.$kn=r;function i(f){switch(Array.isArray(f)?f[0]:f){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.$ln=i;const a=new b;E.$6m.add(e.$$m.Configuration,a);function m(f,t){return f.trim()?e.$in.test(f)?R.localize(7,null,f):a.getConfigurationProperties()[f]!==void 0?R.localize(8,null,f):t.policy?.name&&a.getPolicyConfigurations().get(t.policy?.name)!==void 0?R.localize(9,null,f,t.policy?.name,a.getPolicyConfigurations().get(t.policy?.name)):null:R.localize(6,null)}e.$mn=m;function p(){const f=[],t=a.getConfigurationProperties();for(const s of Object.keys(t))f.push([s,t[s].scope]);return f.push(["launch",4]),f.push(["task",4]),f}e.$nn=p}),define(De[239],Ce([1,0,19,4,155,3,28,23,18,2,50,135,41]),function($e,e,D,M,h,R,A,g,E,$,P,I,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tn=e.$sn=e.$rn=e.$qn=e.$pn=e.$on=void 0;function S(s){return Object.isFrozen(s)?s:g.$Um(s)}class C{constructor(o={},n=[],c=[],d){this.b=o,this.c=n,this.d=c,this.raw=d,this.a=new Map}get rawConfiguration(){if(!this.f)if(this.raw?.length){const o=this.raw.map(n=>{if(n instanceof C)return n;const c=new y("");return c.parseRaw(n),c.configurationModel});this.f=o.reduce((n,c)=>c===n?c:n.merge(c),o[0])}else this.f=this;return this.f}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(o){return o?(0,P.$bi)(this.contents,o):this.contents}inspect(o,n){const c=this.rawConfiguration.getValue(o),d=n?this.rawConfiguration.getOverrideValue(o,n):void 0,v=n?this.rawConfiguration.override(n).getValue(o):c;return{value:c,override:d,merged:v}}getOverrideValue(o,n){const c=this.i(n);return c?o?(0,P.$bi)(c,o):c:void 0}getKeysForOverrideIdentifier(o){const n=[];for(const c of this.overrides)c.identifiers.includes(o)&&n.push(...c.keys);return D.$Ff(n)}getAllOverrideIdentifiers(){const o=[];for(const n of this.overrides)o.push(...n.identifiers);return D.$Ff(o)}override(o){let n=this.a.get(o);return n||(n=this.g(o),this.a.set(o,n)),n}merge(...o){const n=g.$Tm(this.contents),c=g.$Tm(this.overrides),d=[...this.keys],v=this.raw?.length?[...this.raw]:[this];for(const k of o)if(v.push(...k.raw?.length?k.raw:[k]),!k.isEmpty()){this.h(n,k.contents);for(const u of k.overrides){const[l]=c.filter(w=>D.$of(w.identifiers,u.identifiers));l?(this.h(l.contents,u.contents),l.keys.push(...u.keys),l.keys=D.$Ff(l.keys)):c.push(g.$Tm(u))}for(const u of k.keys)d.indexOf(u)===-1&&d.push(u)}return new C(n,d,c,v.every(k=>k instanceof C)?void 0:v)}g(o){const n=this.i(o);if(!n||typeof n!="object"||!Object.keys(n).length)return this;const c={};for(const d of D.$Ff([...Object.keys(this.contents),...Object.keys(n)])){let v=this.contents[d];const k=n[d];k&&(typeof v=="object"&&typeof k=="object"?(v=g.$Tm(v),this.h(v,k)):v=k),c[d]=v}return new C(c,this.keys,this.overrides)}h(o,n){for(const c of Object.keys(n)){if(c in o&&E.$ne(o[c])&&E.$ne(n[c])){this.h(o[c],n[c]);continue}o[c]=g.$Tm(n[c])}}i(o){let n=null,c=null;const d=v=>{v&&(c?this.h(c,v):c=g.$Tm(v))};for(const v of this.overrides)v.identifiers.length===1&&v.identifiers[0]===o?n=v.contents:v.identifiers.includes(o)&&d(v.contents);return d(n),c}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(o,n){this.j(o,n,!0)}setValue(o,n){this.j(o,n,!1)}removeValue(o){const n=this.keys.indexOf(o);n!==-1&&(this.keys.splice(n,1),(0,P.$ai)(this.contents,o),I.$in.test(o)&&this.overrides.splice(this.overrides.findIndex(c=>D.$of(c.identifiers,(0,I.$jn)(o))),1))}j(o,n,c){(0,P.$_h)(this.contents,o,n,d=>console.error(d)),c=c||this.keys.indexOf(o)===-1,c&&this.keys.push(o),I.$in.test(o)&&this.overrides.push({identifiers:(0,I.$jn)(o),keys:Object.keys(this.contents[o]),contents:(0,P.$$h)(this.contents[o],d=>console.error(d))})}}e.$on=C;class y{constructor(o){this.f=o,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new C}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(o,n){if(!E.$ue(o)){const c=this.g(o);this.parseRaw(c,n)}}reparse(o){this.a&&this.parseRaw(this.a,o)}parseRaw(o,n){this.a=o;const{contents:c,keys:d,overrides:v,restricted:k,hasExcludedProperties:u}=this.h(o,n);this.b=new C(c,d,v,u?[o]:void 0),this.c=k||[]}g(o){let n={},c=null,d=[];const v=[],k=[];function u(w){Array.isArray(d)?d.push(w):c!==null&&(d[c]=w)}const l={onObjectBegin:()=>{const w={};u(w),v.push(d),d=w,c=null},onObjectProperty:w=>{c=w},onObjectEnd:()=>{d=v.pop()},onArrayBegin:()=>{const w=[];u(w),v.push(d),d=w,c=null},onArrayEnd:()=>{d=v.pop()},onLiteralValue:u,onError:(w,L,N)=>{k.push({error:w,offset:L,length:N})}};if(o)try{h.$Qm(o,l),n=d[0]||{}}catch(w){console.error(`Error while parsing settings file ${this.f}: ${w}`),this.d=[w]}return n}h(o,n){const c=b.$6m.as(I.$$m.Configuration).getConfigurationProperties(),d=this.i(o,c,!0,n);o=d.raw;const v=(0,P.$$h)(o,l=>console.error(`Conflict in settings file ${this.f}: ${l}`)),k=Object.keys(o),u=this.j(o,l=>console.error(`Conflict in settings file ${this.f}: ${l}`));return{contents:v,keys:k,overrides:u,restricted:d.restricted,hasExcludedProperties:d.hasExcludedProperties}}i(o,n,c,d){let v=!1;if(!d?.scopes&&!d?.skipRestricted&&!d?.exclude?.length)return{raw:o,restricted:[],hasExcludedProperties:v};const k={},u=[];for(const l in o)if(I.$in.test(l)&&c){const w=this.i(o[l],n,!1,d);k[l]=w.raw,v=v||w.hasExcludedProperties,u.push(...w.restricted)}else{const w=n[l],L=w?typeof w.scope<"u"?w.scope:3:void 0;w?.restricted&&u.push(l),!d.exclude?.includes(l)&&(d.include?.includes(l)||(L===void 0||d.scopes===void 0||d.scopes.includes(L))&&!(d.skipRestricted&&w?.restricted))?k[l]=o[l]:v=!0}return{raw:k,restricted:u,hasExcludedProperties:v}}j(o,n){const c=[];for(const d of Object.keys(o))if(I.$in.test(d)){const v={};for(const k in o[d])v[k]=o[d][k];c.push({identifiers:(0,I.$jn)(d),keys:Object.keys(v),contents:(0,P.$$h)(v,n)})}return c}}e.$pn=y;class r extends R.$mb{constructor(o,n,c,d){super(),this.c=o,this.f=n,this.g=d,this.b=this.B(new M.$hc),this.onDidChange=this.b.event,this.a=new y(this.c.toString()),this.B(this.g.watch(c.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(M.Event.any(M.Event.filter(this.g.onDidFilesChange,v=>v.contains(this.c)),M.Event.filter(this.g.onDidRunOperation,v=>(v.isOperation(0)||v.isOperation(3)||v.isOperation(1)||v.isOperation(4))&&c.isEqual(v.resource,o)))(()=>this.b.fire()))}async loadConfiguration(){try{const o=await this.g.readFile(this.c);return this.a.parse(o.value.toString()||"{}",this.f),this.a.configurationModel}catch{return new C}}reparse(o){return o&&(this.f=o),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$qn=r;class i{constructor(o,n,c,d,v,k,u,l,w,L,N,j,T){this.a=o,this.b=n,this.c=c,this.overrideIdentifiers=d,this.d=v,this.f=k,this.g=u,this.h=l,this.i=w,this.j=L,this.k=N,this.l=j,this.m=T}get value(){return S(this.c)}n(o,n,c){const d=o.inspect(n,c);return{get value(){return S(d.value)},get override(){return S(d.override)},get merged(){return S(d.merged)}}}get q(){return this.p||(this.p=this.n(this.d,this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.q.value!==void 0||this.q.override!==void 0?{value:this.q.value,override:this.q.override}:void 0}get s(){return this.r===void 0&&(this.r=this.f?this.n(this.f,this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.n(this.g,this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.u?.value!==void 0||this.u?.override!==void 0?{value:this.u.value,override:this.u.override}:void 0}get w(){return this.v||(this.v=this.n(this.h,this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.w.value!==void 0||this.w.override!==void 0?{value:this.w.value,override:this.w.override}:void 0}get y(){return this.x||(this.x=this.n(this.i,this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.y.value!==void 0||this.y.override!==void 0?{value:this.y.value,override:this.y.override}:void 0}get A(){return this.z||(this.z=this.n(this.j,this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.A.value!==void 0||this.A.override!==void 0?{value:this.A.value,override:this.A.override}:void 0}get D(){return this.B===void 0&&(this.B=this.k?this.n(this.k,this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.D?.value!==void 0||this.D?.override!==void 0?{value:this.D.value,override:this.D.override}:void 0}get F(){return this.E===void 0&&(this.E=this.l?this.n(this.l,this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.F?.value!==void 0||this.F?.override!==void 0?{value:this.F.value,override:this.F.override}:void 0}get H(){return this.G===void 0&&(this.G=this.n(this.m,this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.H.value!==void 0||this.H.override!==void 0?{value:this.H.value,override:this.H.override}:void 0}}class a{constructor(o,n,c,d,v=new C,k=new C,u=new A.$xi,l=new C,w=new A.$xi){this.c=o,this.d=n,this.f=c,this.g=d,this.h=v,this.i=k,this.j=u,this.l=l,this.m=w,this.a=null,this.b=new A.$xi,this.n=null}getValue(o,n,c){return this.q(o,n,c).getValue(o)}updateValue(o,n,c={}){let d;c.resource?(d=this.m.get(c.resource),d||(d=new C,this.m.set(c.resource,d))):d=this.l,n===void 0?d.removeValue(o):d.setValue(o,n),c.resource||(this.a=null)}inspect(o,n,c){const d=this.q(o,n,c),v=this.u(n.resource,c),k=n.resource?this.m.get(n.resource)||this.l:this.l,u=new Set;for(const l of d.overrides)for(const w of l.identifiers)d.getOverrideValue(o,w)!==void 0&&u.add(w);return new i(o,n,d.getValue(o),u.size?[...u]:void 0,this.c,this.d.isEmpty()?void 0:this.d,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,c?this.i:void 0,v||void 0,k)}keys(o){const n=this.u(void 0,o);return{default:this.c.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.i.keys.slice(0),workspaceFolder:n?n.keys.slice(0):[]}}updateDefaultConfiguration(o){this.c=o,this.a=null,this.b.clear()}updatePolicyConfiguration(o){this.d=o}updateApplicationConfiguration(o){this.f=o,this.a=null,this.b.clear()}updateLocalUserConfiguration(o){this.g=o,this.n=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(o){this.h=o,this.n=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(o){this.i=o,this.a=null,this.b.clear()}updateFolderConfiguration(o,n){this.j.set(o,n),this.b.delete(o)}deleteFolderConfiguration(o){this.p.delete(o),this.b.delete(o)}compareAndUpdateDefaultConfiguration(o,n){const c=[];if(!n){const{added:d,updated:v,removed:k}=f(this.c,o);n=[...d,...v,...k]}for(const d of n)for(const v of(0,I.$jn)(d)){const k=this.c.getKeysForOverrideIdentifier(v),u=o.getKeysForOverrideIdentifier(v),l=[...u.filter(w=>k.indexOf(w)===-1),...k.filter(w=>u.indexOf(w)===-1),...k.filter(w=>!g.$Xm(this.c.override(v).getValue(w),o.override(v).getValue(w)))];c.push([v,l])}return this.updateDefaultConfiguration(o),{keys:n,overrides:c}}compareAndUpdatePolicyConfiguration(o){const{added:n,updated:c,removed:d}=f(this.d,o),v=[...n,...c,...d];return v.length&&this.updatePolicyConfiguration(o),{keys:v,overrides:[]}}compareAndUpdateApplicationConfiguration(o){const{added:n,updated:c,removed:d,overrides:v}=f(this.applicationConfiguration,o),k=[...n,...c,...d];return k.length&&this.updateApplicationConfiguration(o),{keys:k,overrides:v}}compareAndUpdateLocalUserConfiguration(o){const{added:n,updated:c,removed:d,overrides:v}=f(this.localUserConfiguration,o),k=[...n,...c,...d];return k.length&&this.updateLocalUserConfiguration(o),{keys:k,overrides:v}}compareAndUpdateRemoteUserConfiguration(o){const{added:n,updated:c,removed:d,overrides:v}=f(this.remoteUserConfiguration,o),k=[...n,...c,...d];return k.length&&this.updateRemoteUserConfiguration(o),{keys:k,overrides:v}}compareAndUpdateWorkspaceConfiguration(o){const{added:n,updated:c,removed:d,overrides:v}=f(this.workspaceConfiguration,o),k=[...n,...c,...d];return k.length&&this.updateWorkspaceConfiguration(o),{keys:k,overrides:v}}compareAndUpdateFolderConfiguration(o,n){const c=this.p.get(o),{added:d,updated:v,removed:k,overrides:u}=f(c,n),l=[...d,...v,...k];return(l.length||!c)&&this.updateFolderConfiguration(o,n),{keys:l,overrides:u}}compareAndDeleteFolderConfiguration(o){const n=this.p.get(o);if(!n)throw new Error("Unknown folder");this.deleteFolderConfiguration(o);const{added:c,updated:d,removed:v,overrides:k}=f(n,void 0);return{keys:[...c,...d,...v],overrides:k}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.n||(this.n=this.h.isEmpty()?this.g:this.g.merge(this.h)),this.n}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.i}get p(){return this.j}q(o,n,c){let d=this.r(n,c);return n.overrideIdentifier&&(d=d.override(n.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(o)!==void 0&&(d=d.merge(this.d)),d}r({resource:o},n){let c=this.s();if(n&&o){const d=n.getFolder(o);d&&(c=this.t(d.uri)||c);const v=this.m.get(o);v&&(c=c.merge(v))}return c}s(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.i,this.l)),this.a}t(o){let n=this.b.get(o);if(!n){const c=this.s(),d=this.j.get(o);d?(n=c.merge(d),this.b.set(o,n)):n=c}return n}u(o,n){if(n&&o){const c=n.getFolder(o);if(c)return this.j.get(c.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.i.contents,overrides:this.i.overrides,keys:this.i.keys},folders:[...this.j.keys()].reduce((o,n)=>{const{contents:c,overrides:d,keys:v}=this.j.get(n);return o.push([n,{contents:c,overrides:d,keys:v}]),o},[])}}allKeys(){const o=new Set;return this.c.keys.forEach(n=>o.add(n)),this.userConfiguration.keys.forEach(n=>o.add(n)),this.i.keys.forEach(n=>o.add(n)),this.j.forEach(n=>n.keys.forEach(c=>o.add(c))),[...o.values()]}v(){const o=new Set;return this.c.getAllOverrideIdentifiers().forEach(n=>o.add(n)),this.userConfiguration.getAllOverrideIdentifiers().forEach(n=>o.add(n)),this.i.getAllOverrideIdentifiers().forEach(n=>o.add(n)),this.j.forEach(n=>n.getAllOverrideIdentifiers().forEach(c=>o.add(c))),[...o.values()]}w(o){const n=new Set;return this.c.getKeysForOverrideIdentifier(o).forEach(c=>n.add(c)),this.userConfiguration.getKeysForOverrideIdentifier(o).forEach(c=>n.add(c)),this.i.getKeysForOverrideIdentifier(o).forEach(c=>n.add(c)),this.j.forEach(c=>c.getKeysForOverrideIdentifier(o).forEach(d=>n.add(d))),[...n.values()]}static parse(o){const n=this.x(o.defaults),c=this.x(o.policy),d=this.x(o.application),v=this.x(o.user),k=this.x(o.workspace),u=o.folders.reduce((l,w)=>(l.set($.URI.revive(w[0]),this.x(w[1])),l),new A.$xi);return new a(n,c,d,v,new C,k,u,new C,new A.$xi)}static x(o){return new C(o.contents,o.keys,o.overrides)}}e.$rn=a;function m(...s){if(s.length===0)return{keys:[],overrides:[]};if(s.length===1)return s[0];const o=new Set,n=new Map;for(const d of s)d.keys.forEach(v=>o.add(v)),d.overrides.forEach(([v,k])=>{const u=(0,A.$ui)(n,v,new Set);k.forEach(l=>u.add(l))});const c=[];return n.forEach((d,v)=>c.push([v,[...d.values()]])),{keys:[...o.values()],overrides:c}}e.$sn=m;class p{constructor(o,n,c,d){this.change=o,this.f=n,this.g=c,this.h=d,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=".".charCodeAt(0),this.affectedKeys=new Set,this.i=void 0;for(const v of o.keys)this.affectedKeys.add(v);for(const[,v]of o.overrides)for(const k of v)this.affectedKeys.add(k);this.d=this.a;for(const v of this.affectedKeys)this.d+=v+this.a}get previousConfiguration(){return!this.i&&this.f&&(this.i=a.parse(this.f.data)),this.i}affectsConfiguration(o,n){const c=this.a+o,d=this.d.indexOf(c);if(d<0)return!1;const v=d+c.length;if(v>=this.d.length)return!1;const k=this.d.charCodeAt(v);if(k!==this.b&&k!==this.c)return!1;if(n){const u=this.previousConfiguration?this.previousConfiguration.getValue(o,n,this.f?.workspace):void 0,l=this.g.getValue(o,n,this.h);return!g.$Xm(u,l)}return!0}}e.$tn=p;function f(s,o){const{added:n,removed:c,updated:d}=t(o?.rawConfiguration,s?.rawConfiguration),v=[],k=s?.getAllOverrideIdentifiers()||[],u=o?.getAllOverrideIdentifiers()||[];if(o){const l=u.filter(w=>!k.includes(w));for(const w of l)v.push([w,o.getKeysForOverrideIdentifier(w)])}if(s){const l=k.filter(w=>!u.includes(w));for(const w of l)v.push([w,s.getKeysForOverrideIdentifier(w)])}if(o&&s){for(const l of k)if(u.includes(l)){const w=t({contents:s.getOverrideValue(void 0,l)||{},keys:s.getKeysForOverrideIdentifier(l)},{contents:o.getOverrideValue(void 0,l)||{},keys:o.getKeysForOverrideIdentifier(l)});v.push([l,[...w.added,...w.removed,...w.updated]])}}return{added:n,removed:c,updated:d,overrides:v}}function t(s,o){const n=s?o?s.keys.filter(v=>o.keys.indexOf(v)===-1):[...s.keys]:[],c=o?s?o.keys.filter(v=>s.keys.indexOf(v)===-1):[...o.keys]:[],d=[];if(s&&o){for(const v of o.keys)if(s.keys.indexOf(v)!==-1){const k=(0,P.$bi)(o.contents,v),u=(0,P.$bi)(s.contents,v);g.$Xm(k,u)||d.push(v)}}return{added:n,removed:c,updated:d}}}),define(De[240],Ce([1,0,21,4,3,80]),function($e,e,D,M,h,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dkb=e.$ckb=e.$bkb=e.$akb=void 0;const A=($,P,I)=>{const b=new Uint8Array(16);for(let y=0;y<16;y++)b[y]=Math.round(Math.random()*256);const S=(0,D.$2c)(D.$Hc.wrap(b));return[`GET ws://localhost${$}?${P}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${S}`].join(`\r
`)+`\r
\r
`};e.$akb=A,e.$bkb=D.$Hc.fromString(`\r
\r
`);async function g($,P,I,b,S){$.write(D.$Hc.fromString((0,e.$akb)(P,I,b)));const C=new h.$lb;try{return await new Promise((y,r)=>{let i;C.add($.onData(a=>{i?i=D.$Hc.concat([i,a],i.byteLength+a.byteLength):i=a;const m=i.indexOf(e.$bkb);if(m===-1)return;y($),$.pauseData();const p=i.slice(m+e.$bkb.byteLength);p.byteLength&&S.onData.fire(p)})),C.add($.onClose(a=>r(a??new Error("socket closed")))),C.add($.onEnd(()=>r(new Error("socket ended"))))})}catch(y){throw $.dispose(),y}finally{C.dispose()}}e.$ckb=g;class E extends h.$mb{constructor(P,I){super(),this.g=P,this.a=this.B(new M.$kc),this.onData=(...b)=>(this.a.isPaused&&queueMicrotask(()=>this.a.resume()),this.a.event(...b)),this.b=this.B(new M.$hc),this.onDidDispose=this.b.event,this.f=!1,this.B(I.onData),this.B(I.onData.event(b=>this.a.fire(b))),this.onClose=this.B(I.onClose).event,this.onEnd=this.B(I.onEnd).event}pauseData(){this.a.pause()}drain(){return Promise.resolve()}end(){this.f=!0,this.h()}traceSocketEvent(P,I){R.SocketDiagnostics.traceSocketEvent(this,this.g,P,I)}dispose(){this.f||this.h(),this.b.fire(),super.dispose()}}e.$dkb=E}),define(De[84],Ce([1,0,8,6]),function($e,e,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lk=e.$Kk=e.RemoteAuthorityResolverErrorCode=e.$Jk=e.$Ik=e.RemoteConnectionType=e.$Hk=void 0,e.$Hk=(0,M.$zh)("remoteAuthorityResolverService");var h;(function(P){P[P.WebSocket=0]="WebSocket",P[P.Managed=1]="Managed"})(h||(e.RemoteConnectionType=h={}));class R{constructor(I){this.id=I,this.type=1}toString(){return`Managed(${this.id})`}}e.$Ik=R;class A{constructor(I,b){this.host=I,this.port=b,this.type=0}toString(){return`WebSocket(${this.host}:${this.port})`}}e.$Jk=A;var g;(function(P){P.Unknown="Unknown",P.NotAvailable="NotAvailable",P.TemporarilyNotAvailable="TemporarilyNotAvailable",P.NoResolverFound="NoResolverFound",P.InvalidAuthority="InvalidAuthority"})(g||(e.RemoteAuthorityResolverErrorCode=g={}));class E extends D.$_{static isNotAvailable(I){return I instanceof E&&I._code===g.NotAvailable}static isTemporarilyNotAvailable(I){return I instanceof E&&I._code===g.TemporarilyNotAvailable}static isNoResolverFound(I){return I instanceof E&&I._code===g.NoResolverFound}static isInvalidAuthority(I){return I instanceof E&&I._code===g.InvalidAuthority}static isHandled(I){return I instanceof E&&I.isHandled}constructor(I,b=g.Unknown,S){super(I),this._message=I,this._code=b,this._detail=S,this.isHandled=b===g.NotAvailable&&S===!0,Object.setPrototypeOf(this,E.prototype)}}e.$Kk=E;function $(P){const I=P.indexOf("+");return I===-1?P:P.substring(0,I)}e.$Lk=$}),define(De[60],Ce([1,0,16]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qk=e.$Pk=e.$Ok=e.$Nk=e.$Mk=void 0;function M($){return $.scheme===D.Schemas.vscodeRemote?$.authority:void 0}e.$Mk=M;function h($){if(!$)return;const P=$.indexOf("+");return P<0?$:$.substr(0,P)}e.$Nk=h;function R($){return`/${$.quality??"oss"}-${$.commit??"dev"}`}e.$Ok=R;function A($){const{host:P,port:I}=E($);if(typeof I>"u")throw new Error("Remote authority doesn't contain a port!");return{host:P,port:I}}e.$Pk=A;function g($,P){let{host:I,port:b}=E($);return typeof b>"u"&&(b=P),{host:I,port:b}}e.$Qk=g;function E($){const P=$.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(P)return{host:P[1],port:parseInt(P[2],10)};const I=$.match(/^(\[[0-9a-z:]+\])$/);if(I)return{host:I[1],port:void 0};const b=$.match(/(.*):(\d+)$/);return b?{host:b[1],port:parseInt(b[2],10)}:{host:$,port:void 0}}}),define(De[25],Ce([1,0,15,6,60]),function($e,e,D,M,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1l=e.$Zl=e.$Yl=e.$Xl=e.$Wl=e.$Vl=e.$Ul=e.$Tl=e.TargetPlatform=e.ExtensionType=e.$Sl=e.$Rl=e.$Ql=e.$Pl=e.$Ol=e.$Nl=void 0,e.$Nl="extensions.user.cache",e.$Ol="extensions.builtin.cache",e.$Pl="undefined_publisher",e.$Ql=["ui","workspace","web"];function R(y){if(typeof y=="object"&&y!==null&&y.supported!==!0)return y.description}e.$Rl=R,e.$Sl=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var A;(function(y){y[y.System=0]="System",y[y.User=1]="User"})(A||(e.ExtensionType=A={}));var g;(function(y){y.WIN32_X64="win32-x64",y.WIN32_IA32="win32-ia32",y.WIN32_ARM64="win32-arm64",y.LINUX_X64="linux-x64",y.LINUX_ARM64="linux-arm64",y.LINUX_ARMHF="linux-armhf",y.ALPINE_X64="alpine-x64",y.ALPINE_ARM64="alpine-arm64",y.DARWIN_X64="darwin-x64",y.DARWIN_ARM64="darwin-arm64",y.WEB="web",y.UNIVERSAL="universal",y.UNKNOWN="unknown",y.UNDEFINED="undefined"})(g||(e.TargetPlatform=g={}));class E{constructor(r){this.value=r,this._lower=r.toLowerCase()}static equals(r,i){if(typeof r>"u"||r===null)return typeof i>"u"||i===null;if(typeof i>"u"||i===null)return!1;if(typeof r=="string"||typeof i=="string"){const a=typeof r=="string"?r:r.value,m=typeof i=="string"?i:i.value;return D.$Od(a,m)}return r._lower===i._lower}static toKey(r){return typeof r=="string"?r.toLowerCase():r._lower}}e.$Tl=E;class ${get size(){return this.c.size}constructor(r){if(this.c=new Set,r)for(const i of r)this.add(i)}add(r){this.c.add(E.toKey(r))}delete(r){return this.c.delete(E.toKey(r))}has(r){return this.c.has(E.toKey(r))}}e.$Ul=$;class P{constructor(){this.c=new Map}clear(){this.c.clear()}delete(r){this.c.delete(E.toKey(r))}get(r){return this.c.get(E.toKey(r))}has(r){return this.c.has(E.toKey(r))}set(r,i){this.c.set(E.toKey(r),i)}values(){return this.c.values()}forEach(r){this.c.forEach(r)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$Vl=P;function I(y){return b(y)}e.$Wl=I;function b(y){return y.contributes&&y.contributes.localizations?y.contributes.localizations.length>0:!1}e.$Xl=b;function S(y){return y.contributes&&y.contributes.authentication?y.contributes.authentication.length>0:!1}e.$Yl=S;function C(y,r){if(r){const i=`onResolveRemoteAuthority:${(0,h.$Nk)(r)}`;return!!y.activationEvents?.includes(i)}return!1}e.$Zl=C,e.$1l=(0,M.$zh)("IBuiltinExtensionsScannerService")}),define(De[136],Ce([1,0,8,25]),function($e,e,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xF=e.$wF=void 0;class h{constructor(){this.a=new Map,this.b=new WeakMap}register(A,g){this.a.set(A,g)}readActivationEvents(A){return this.b.has(A)||this.b.set(A,this.c(A)),this.b.get(A)}createActivationEventsMap(A){const g=Object.create(null);for(const E of A){const $=this.readActivationEvents(E);$.length>0&&(g[M.$Tl.toKey(E.identifier)]=$)}return g}c(A){if(typeof A.main>"u"&&typeof A.browser>"u")return[];const g=Array.isArray(A.activationEvents)?A.activationEvents.slice(0):[];if(!A.contributes)return g;for(const E in A.contributes){const $=this.a.get(E);if(!$)continue;const P=A.contributes[E],I=Array.isArray(P)?P:[P];try{$(I,g)}catch(b){(0,D.$Y)(b)}}return g}}e.$wF=h,e.$xF=new h}),define(De[241],Ce([1,0,13,21,22,8,4,3,61,37,31,80,84,60]),function($e,e,D,M,h,R,A,g,E,$,P,I,b,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6k=e.$5k=e.$4k=e.$3k=e.$2k=e.$1k=e.$Zk=e.$Yk=e.PersistentConnectionEventType=e.$Xk=e.$Wk=e.$Vk=e.ConnectionType=void 0;const C=30*1e3;var y;(function(Q){Q[Q.Management=1]="Management",Q[Q.ExtensionHost=2]="ExtensionHost",Q[Q.Tunnel=3]="Tunnel"})(y||(e.ConnectionType=y={}));function r(Q){switch(Q){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function i(Q){const z=new h.$rc;return setTimeout(()=>z.cancel(),Q),z.token}function a(Q,z){if(Q.isCancellationRequested||z.isCancellationRequested)return h.CancellationToken.Cancelled;const V=new h.$rc;return Q.onCancellationRequested(()=>V.cancel()),z.onCancellationRequested(()=>V.cancel()),V.token}class m{get didTimeout(){return this.c==="timedout"}constructor(z){this.c="pending",this.d=new g.$lb,this.promise=new Promise((V,G)=>{this.f=V,this.g=G}),z.isCancellationRequested?this.h():this.d.add(z.onCancellationRequested(()=>this.h()))}registerDisposable(z){this.c==="pending"?this.d.add(z):z.dispose()}h(){this.c==="pending"&&(this.d.dispose(),this.c="timedout",this.g(this.i()))}i(){const z=new Error("Time limit reached");return z.code="ETIMEDOUT",z.syscall="connect",z}resolve(z){this.c==="pending"&&(this.d.dispose(),this.c="resolved",this.f(z))}reject(z){this.c==="pending"&&(this.d.dispose(),this.c="rejected",this.g(z))}}function p(Q,z){const V=new m(z);return V.registerDisposable(Q.onControlMessage(G=>{const ae=JSON.parse(G.toString()),ne=x(ae);ne?V.reject(ne):V.resolve(ae)})),V.promise}function f(Q,z,V,G,ae,ne,he,Ee){const de=new m(Ee),ge=$.$dc.create(!1);return Q.info(`Creating a socket (${he})...`),E.mark(`code/willCreateSocket/${ne}`),z.connect(V,G,ae,he).then(ie=>{de.didTimeout?(E.mark(`code/didCreateSocketError/${ne}`),Q.info(`Creating a socket (${he}) finished after ${ge.elapsed()} ms, but this is too late and has timed out already.`),ie?.dispose()):(E.mark(`code/didCreateSocketOK/${ne}`),Q.info(`Creating a socket (${he}) was successful after ${ge.elapsed()} ms.`),de.resolve(ie))},ie=>{E.mark(`code/didCreateSocketError/${ne}`),Q.info(`Creating a socket (${he}) returned an error after ${ge.elapsed()} ms.`),Q.error(ie),de.reject(ie)}),de.promise}function t(Q,z){const V=new m(z);return Q.then(G=>{V.didTimeout||V.resolve(G)},G=>{V.didTimeout||V.reject(G)}),V.promise}async function s(Q,z,V,G){const ae=ce(Q,z);Q.logService.trace(`${ae} 1/6. invoking socketFactory.connect().`);let ne;try{ne=await f(Q.logService,Q.remoteSocketFactoryService,Q.connectTo,(0,S.$Ok)(Q),`reconnectionToken=${Q.reconnectionToken}&reconnection=${Q.reconnectionProtocol?"true":"false"}`,r(z),`renderer-${r(z)}-${Q.reconnectionToken}`,G)}catch(ie){throw Q.logService.error(`${ae} socketFactory.connect() failed or timed out. Error:`),Q.logService.error(ie),ie}Q.logService.trace(`${ae} 2/6. socketFactory.connect() was successful.`);let he,Ee;Q.reconnectionProtocol?(Q.reconnectionProtocol.beginAcceptReconnection(ne,null),he=Q.reconnectionProtocol,Ee=!1):(he=new I.$nh({socket:ne}),Ee=!0),Q.logService.trace(`${ae} 3/6. sending AuthRequest control message.`);const de=await t(Q.signService.createNewMessage((0,P.$6e)()),G),ge={type:"auth",auth:Q.connectionToken||"00000000000000000000",data:de.data};he.sendControl(M.$Hc.fromString(JSON.stringify(ge)));try{const ie=await p(he,a(G,i(1e4)));if(ie.type!=="sign"||typeof ie.data!="string"){const U=new Error("Unexpected handshake message");throw U.code="VSCODE_CONNECTION_ERROR",U}if(Q.logService.trace(`${ae} 4/6. received SignRequest control message.`),!await t(Q.signService.validate(de,ie.signedData),G)){const U=new Error("Refused to connect to unsupported server");throw U.code="VSCODE_CONNECTION_ERROR",U}const we=await t(Q.signService.sign(ie.data),G),Pe={type:"connectionType",commit:Q.commit,signedData:we,desiredConnectionType:z};return V&&(Pe.args=V),Q.logService.trace(`${ae} 5/6. sending ConnectionTypeRequest control message.`),he.sendControl(M.$Hc.fromString(JSON.stringify(Pe))),{protocol:he,ownsProtocol:Ee}}catch(ie){throw ie&&ie.code==="ETIMEDOUT"&&(Q.logService.error(`${ae} the handshake timed out. Error:`),Q.logService.error(ie)),ie&&ie.code==="VSCODE_CONNECTION_ERROR"&&(Q.logService.error(`${ae} received error control message when negotiating connection. Error:`),Q.logService.error(ie)),Ee&&re(he),ie}}async function o(Q,z,V,G){const ae=Date.now(),ne=ce(Q,z),{protocol:he,ownsProtocol:Ee}=await s(Q,z,V,G),de=new m(G);return de.registerDisposable(he.onControlMessage(ge=>{const ie=JSON.parse(ge.toString()),ue=x(ie);ue?(Q.logService.error(`${ne} received error control message when negotiating connection. Error:`),Q.logService.error(ue),Ee&&re(he),de.reject(ue)):(Q.reconnectionProtocol?.endAcceptReconnection(),Q.logService.trace(`${ne} 6/6. handshake finished, connection is up and running after ${_(ae)}!`),de.resolve({protocol:he,firstMessage:ie}))})),de.promise}async function n(Q,z){const{protocol:V}=await o(Q,1,void 0,z);return{protocol:V}}async function c(Q,z,V){const{protocol:G,firstMessage:ae}=await o(Q,2,z,V),ne=ae&&ae.debugPort;return{protocol:G,debugPort:ne}}async function d(Q,z,V){const G=Date.now(),ae=ce(Q,3),{protocol:ne}=await s(Q,3,z,V);return Q.logService.trace(`${ae} 6/6. handshake finished, connection is up and running after ${_(G)}!`),ne}async function v(Q,z,V){const{connectTo:G,connectionToken:ae}=await Q.addressProvider.getAddress();return{commit:Q.commit,quality:Q.quality,connectTo:G,connectionToken:ae,reconnectionToken:z,reconnectionProtocol:V,remoteSocketFactoryService:Q.remoteSocketFactoryService,signService:Q.signService,logService:Q.logService}}async function k(Q,z,V){return l(Q,async G=>{const{protocol:ae}=await n(G,h.CancellationToken.None);return new K(Q,z,V,G.reconnectionToken,ae)})}e.$Vk=k;async function u(Q,z){return l(Q,async V=>{const{protocol:G,debugPort:ae}=await c(V,z,h.CancellationToken.None);return new me(Q,z,V.reconnectionToken,G,ae)})}e.$Wk=u;async function l(Q,z){for(let G=1;;G++)try{const ae=(0,P.$6e)(),ne=await v(Q,ae,null);return await z(ne)}catch(ae){if(G<5)Q.logService.error(`[remote-connection][attempt ${G}] An error occurred in initial connection! Will retry... Error:`),Q.logService.error(ae);else throw Q.logService.error(`[remote-connection][attempt ${G}]  An error occurred in initial connection! It will be treated as a permanent error. Error:`),Q.logService.error(ae),J.triggerPermanentFailure(0,0,b.$Kk.isHandled(ae)),ae}}async function w(Q,z,V){const G=await v(Q,(0,P.$6e)(),null);return await d(G,{host:z,port:V},h.CancellationToken.None)}e.$Xk=w;function L(Q){return(0,D.$sg)(z=>new Promise((V,G)=>{const ae=setTimeout(V,Q*1e3);z.onCancellationRequested(()=>{clearTimeout(ae),V()})}))}var N;(function(Q){Q[Q.ConnectionLost=0]="ConnectionLost",Q[Q.ReconnectionWait=1]="ReconnectionWait",Q[Q.ReconnectionRunning=2]="ReconnectionRunning",Q[Q.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",Q[Q.ConnectionGain=4]="ConnectionGain"})(N||(e.PersistentConnectionEventType=N={}));class j{constructor(z,V){this.reconnectionToken=z,this.millisSinceLastIncomingData=V,this.type=0}}e.$Yk=j;class T{constructor(z,V,G,ae){this.reconnectionToken=z,this.millisSinceLastIncomingData=V,this.durationSeconds=G,this.c=ae,this.type=1}skipWait(){this.c.cancel()}}e.$Zk=T;class O{constructor(z,V,G){this.reconnectionToken=z,this.millisSinceLastIncomingData=V,this.attempt=G,this.type=2}}e.$1k=O;class B{constructor(z,V,G){this.reconnectionToken=z,this.millisSinceLastIncomingData=V,this.attempt=G,this.type=4}}e.$2k=B;class F{constructor(z,V,G,ae){this.reconnectionToken=z,this.millisSinceLastIncomingData=V,this.attempt=G,this.handled=ae,this.type=3}}e.$3k=F;class J extends g.$mb{static triggerPermanentFailure(z,V,G){this._permanentFailure=!0,this.f=z,this.g=V,this.h=G,this.i.forEach(ae=>ae.v(this.f,this.g,this.h))}static debugTriggerReconnection(){this.i.forEach(z=>z.s())}static debugPauseSocketWriting(){this.i.forEach(z=>z.w())}static{this._permanentFailure=!1}static{this.f=0}static{this.g=0}static{this.h=!1}static{this.i=[]}get k(){return this.c||J._permanentFailure}constructor(z,V,G,ae,ne){super(),this.n=z,this.p=V,this.reconnectionToken=G,this.protocol=ae,this.r=ne,this.j=this.B(new A.$hc),this.onDidStateChange=this.j.event,this.c=!1,this.l=!1,this.m=!1,this.j.fire(new B(this.reconnectionToken,0,0)),this.B(ae.onSocketClose(he=>{const Ee=pe(this.n,this.reconnectionToken,!0);he?he.type===0?(this.p.logService.info(`${Ee} received socket close event (hadError: ${he.hadError}).`),he.error&&this.p.logService.error(he.error)):(this.p.logService.info(`${Ee} received socket close event (wasClean: ${he.wasClean}, code: ${he.code}, reason: ${he.reason}).`),he.event&&this.p.logService.error(he.event)):this.p.logService.info(`${Ee} received socket close event.`),this.s()})),this.B(ae.onSocketTimeout(he=>{const Ee=pe(this.n,this.reconnectionToken,!0);this.p.logService.info(`${Ee} received socket timeout event (unacknowledgedMsgCount: ${he.unacknowledgedMsgCount}, timeSinceOldestUnacknowledgedMsg: ${he.timeSinceOldestUnacknowledgedMsg}, timeSinceLastReceivedSomeData: ${he.timeSinceLastReceivedSomeData}).`),this.s()})),J.i.push(this),this.B((0,g.$kb)(()=>{const he=J.i.indexOf(this);he>=0&&J.i.splice(he,1)})),this.k&&this.v(J.f,J.g,J.h)}dispose(){super.dispose(),this.m=!0}async s(){if(!this.l)try{this.l=!0,await this.t()}finally{this.l=!1}}async t(){if(this.k||this.m)return;const z=pe(this.n,this.reconnectionToken,!0);this.p.logService.info(`${z} starting reconnecting loop. You can get more information with the trace log level.`),this.j.fire(new j(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const V=[0,5,5,10,10,10,10,10,30];let G=-1;do{G++;const ae=G<V.length?V[G]:V[V.length-1];try{if(ae>0){const he=L(ae);this.j.fire(new T(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),ae,he)),this.p.logService.info(`${z} waiting for ${ae} seconds before reconnecting...`);try{await he}catch{}}if(this.k){this.p.logService.error(`${z} permanent failure occurred while running the reconnecting loop.`);break}this.j.fire(new O(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),G+1)),this.p.logService.info(`${z} resolving connection...`);const ne=await v(this.p,this.reconnectionToken,this.protocol);this.p.logService.info(`${z} connecting to ${ne.connectTo}...`),await this.y(ne,i(C)),this.p.logService.info(`${z} reconnected!`),this.j.fire(new B(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),G+1));break}catch(ne){if(ne.code==="VSCODE_CONNECTION_ERROR"){this.p.logService.error(`${z} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this.p.logService.error(ne),this.u(this.protocol.getMillisSinceLastIncomingData(),G+1,!1);break}if(G>360){this.p.logService.error(`${z} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this.p.logService.error(ne),this.u(this.protocol.getMillisSinceLastIncomingData(),G+1,!1);break}if(b.$Kk.isTemporarilyNotAvailable(ne)){this.p.logService.info(`${z} A temporarily not available error occurred while trying to reconnect, will try again...`),this.p.logService.trace(ne);continue}if((ne.code==="ETIMEDOUT"||ne.code==="ENETUNREACH"||ne.code==="ECONNREFUSED"||ne.code==="ECONNRESET")&&ne.syscall==="connect"){this.p.logService.info(`${z} A network error occurred while trying to reconnect, will try again...`),this.p.logService.trace(ne);continue}if((0,R.$2)(ne)){this.p.logService.info(`${z} A promise cancelation error occurred while trying to reconnect, will try again...`),this.p.logService.trace(ne);continue}if(ne instanceof b.$Kk){this.p.logService.error(`${z} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this.p.logService.error(ne),this.u(this.protocol.getMillisSinceLastIncomingData(),G+1,b.$Kk.isHandled(ne));break}this.p.logService.error(`${z} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this.p.logService.error(ne),this.u(this.protocol.getMillisSinceLastIncomingData(),G+1,!1);break}}while(!this.k&&!this.m)}u(z,V,G){this.r?J.triggerPermanentFailure(z,V,G):this.v(z,V,G)}v(z,V,G){this.j.fire(new F(this.reconnectionToken,z,V,G)),re(this.protocol)}w(){this.protocol.pauseSocketWriting()}}e.$4k=J;class K extends J{constructor(z,V,G,ae,ne){super(1,z,ae,ne,!0),this.client=this.B(new I.$lh(ne,{remoteAuthority:V,clientId:G},z.ipcLogger))}async y(z,V){await n(z,V)}}e.$5k=K;class me extends J{constructor(z,V,G,ae,ne){super(2,z,G,ae,!1),this.z=V,this.debugPort=ne}async y(z,V){await c(z,this.z,V)}}e.$6k=me;function re(Q){try{Q.acceptDisconnect();const z=Q.getSocket();Q.dispose(),z.dispose()}catch(z){(0,R.$Y)(z)}}function x(Q){if(Q&&Q.type==="error"){const z=new Error(`Connection error: ${Q.reason}`);return z.code="VSCODE_CONNECTION_ERROR",z}return null}function q(Q,z){for(;Q.length<z;)Q+=" ";return Q}function ee(Q,z){return`[remote-connection][${q(r(Q),13)}][${z.substr(0,5)}\u2026]`}function pe(Q,z,V){return`${ee(Q,z)}[${V?"reconnect":"initial"}]`}function ce(Q,z){return`${pe(z,Q.reconnectionToken,!!Q.reconnectionProtocol)}[${Q.connectTo}]`}function _(Q){return`${Date.now()-Q} ms`}}),define(De[242],Ce([1,0,3,6]),function($e,e,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sk=e.$Rk=void 0,e.$Rk=(0,M.$zh)("remoteSocketFactoryService");class h{constructor(){this.a={}}register(A,g){return this.a[A]??=[],this.a[A].push(g),(0,D.$kb)(()=>{const E=this.a[A]?.indexOf(g);typeof E=="number"&&E>=0&&this.a[A]?.splice(E,1)})}b(A){return(this.a[A.type]||[]).find(E=>E.supports(A))}connect(A,g,E,$){const P=this.b(A);if(!P)throw new Error(`No socket factory found for ${A}`);return P.connect(A,g,E,$)}}e.$Sk=h}),define(De[243],Ce([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Y1b=void 0;class D{constructor(){this.b=new Map}static{this.a=1}async createNewMessage(h){try{const R=await this.c();if(R){const A=String(D.a++);return this.b.set(A,R),{id:A,data:R.createNewMessage(h)}}}catch{}return{id:"",data:h}}async validate(h,R){if(!h.id)return!0;const A=this.b.get(h.id);if(!A)return!1;this.b.delete(h.id);try{return A.validate(R)==="ok"}catch{return!1}finally{A.dispose?.()}}async sign(h){try{return await this.d(h)}catch{}return h}}e.$Y1b=D}),define(De[105],Ce([1,0,6]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uk=e.$Tk=void 0,e.$Tk="signService",e.$Uk=(0,D.$zh)(e.$Tk)}),define(De[137],Ce([1,0,243]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$K6b=void 0;class M extends D.$Y1b{c(){return this.h().then(R=>new R.validator)}d(R){return this.h().then(A=>new A.signer().sign(R))}h(){return new Promise((R,A)=>$e(["vsda"],R,A))}}e.$K6b=M}),define(De[244],Ce([1,0,9,45,31]),function($e,e,D,M,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9n=e.$8n=void 0;function R(E){if(D.$t===2&&/^penguin(\.|$)/i.test(E))return"chromebook"}function A(E,$,P,I,b,S,C,y){const r=Object.create(null);r["common.machineId"]=S,r.sessionID=(0,h.$6e)()+Date.now(),r.commitHash=I,r.version=b,r["common.platformVersion"]=(E||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),r["common.platform"]=(0,D.$h)(D.$t),r["common.nodePlatform"]=M.$5c,r["common.nodeArch"]=P,r["common.product"]=y||"desktop",C&&(r["common.msftInternal"]=C);let i=0;const a=Date.now();Object.defineProperties(r,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-a,enumerable:!0},"common.sequence":{get:()=>i++,enumerable:!0}}),D.$l&&(r["common.snap"]="true");const m=R($);return m&&(r["common.platformDetail"]=m),r}e.$8n=A;function g(E){const $=M.env.USERDNSDOMAIN;if(!$)return!1;const P=$.toLowerCase();return E.some(I=>P===I)}e.$9n=g}),define(De[245],Ce([1,0,6]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$dl=e.$cl=e.$bl=e.$al=e.$_k=e.$$k=e.$0k=e.$9k=e.$8k=e.$7k=void 0,e.$7k=(0,D.$zh)("telemetryService"),e.$8k=(0,D.$zh)("customEndpointTelemetryService"),e.$9k="telemetry.currentSessionDate",e.$0k="telemetry.firstSessionDate",e.$$k="telemetry.lastSessionDate",e.$_k="telemetry.machineId",e.$al="telemetry",e.$bl="telemetry.telemetryLevel",e.$cl="telemetry.enableCrashReporter",e.$dl="telemetry.enableTelemetry";var M;(function(R){R[R.NONE=0]="NONE",R[R.CRASH=1]="CRASH",R[R.ERROR=2]="ERROR",R[R.USAGE=3]="USAGE"})(M||(e.TelemetryLevel=M={}));var h;(function(R){R.OFF="off",R.CRASH="crash",R.ERROR="error",R.ON="all"})(h||(e.TelemetryConfiguration=h={}))}),define(De[85],Ce([1,0,23,18,4,50,60,244,245]),function($e,e,D,M,h,R,A,g,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mo=e.$lo=e.$ko=e.$jo=e.$io=e.$ho=e.$go=e.$fo=e.$eo=e.$do=e.$co=e.$bo=e.$ao=e.$_n=e.$$n=e.$0n=void 0;class ${constructor(c){this.value=c,this.isTrustedTelemetryValue=!0}}e.$0n=$;class P{constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$$n=P,e.$_n=new P;class I{async publicLog(c,d,v){}async publicLogError(c,d,v){}}e.$ao=I,e.$bo="telemetry",e.$co="extensionTelemetryLog",e.$do={log:()=>null,flush:()=>Promise.resolve(null)};function b(n,c){return h.Event.debounce(c.onDidChangeConfiguration,(v,k)=>{const u=v?new Set([...v.affectedKeys,...k.affectedKeys]):k.affectedKeys;return{...k,affectedKeys:u}},1e3,!0)(v=>{v.source!==7&&n.publicLog2("updateConfiguration",{configurationSource:(0,R.$9h)(v.source),configurationKeys:Array.from(v.affectedKeys)})})}e.$eo=b;function S(n,c){return!c.isBuilt&&!c.disableTelemetry?!0:!(c.disableTelemetry||!n.enableTelemetry||c.extensionTestsLocationURI)}e.$fo=S;function C(n,c){return!(c.isBuilt||c.disableTelemetry||n.enableTelemetry&&n.aiConfig?.ariaKey)}e.$go=C;function y(n){const c=n.getValue(E.$bl),d=n.getValue(E.$cl);if(n.getValue(E.$dl)===!1||d===!1)return 0;switch(c??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.$ho=y;function r(n){const c={},d={},v={};m(n,v);for(let k in v){k=k.length>150?k.substr(k.length-149):k;const u=v[k];typeof u=="number"?d[k]=u:typeof u=="boolean"?d[k]=u?1:0:typeof u=="string"?(u.length>8192&&console.warn(`Telemetry property: ${k} has been trimmed to 8192, the original length is ${u.length}`),c[k]=u.substring(0,8191)):typeof u<"u"&&u!==null&&(c[k]=u)}return{properties:c,measurements:d}}e.$io=r;const i=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function a(n){if(!n)return"none";const c=(0,A.$Nk)(n);return i.has(c)?c:"other"}e.$jo=a;function m(n,c,d=0,v){if(n)for(const k of Object.getOwnPropertyNames(n)){const u=n[k],l=v?v+k:k;Array.isArray(u)?c[l]=(0,D.$Ym)(u):u instanceof Date?c[l]=u.toISOString():(0,M.$ne)(u)?d<2?m(u,c,d+1,l+"."):c[l]=(0,D.$Ym)(u):c[l]=u}}function p(n,c){const d=n.msftInternalDomains||[],v=c.getValue("telemetry.internalTesting");return(0,g.$9n)(d)||v}e.$ko=p;function f(n){return[n.appRoot,n.extensionsPath,n.userHome.fsPath,n.tmpDir.fsPath,n.userDataPath]}e.$lo=f;function t(n,c){if(!n||!n.includes("/")&&!n.includes("\\"))return n;let d=n;const v=[];for(const w of c)for(;;){const L=w.exec(n);if(!L)break;v.push([L.index,w.lastIndex])}const k=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,u=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let l=0;for(d="";;){const w=u.exec(n);if(!w)break;const L=v.some(([N,j])=>w.index<j&&N<u.lastIndex);!k.test(w[0])&&!L&&(d+=n.substring(l,w.index)+"<REDACTED: user-file-path>",l=u.lastIndex)}return l<n.length&&(d+=n.substr(l)),d}function s(n){if(!n)return n;const c=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const d of c)if(d.regex.test(n))return`<REDACTED: ${d.label}>`;return n}function o(n,c){return(0,D.$Vm)(n,d=>{if(d instanceof $||Object.hasOwnProperty.call(d,"isTrustedTelemetryValue"))return d.value;if(typeof d=="string"){let v=d.replaceAll("%20"," ");v=t(v,c);for(const k of c)v=v.replace(k,"");return v=s(v),v}})}e.$mo=o}),define(De[246],Ce([1,0,15,131,25,9,2,8,45,85]),function($e,e,D,M,h,R,A,g,E,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yo=e.$xo=e.$wo=e.$vo=e.$uo=e.$to=e.$so=e.$ro=e.$qo=e.$po=e.$oo=e.$no=void 0;function P(o,n){return o.uuid&&n.uuid?o.uuid===n.uuid:o.id===n.id?!0:(0,D.$Jd)(o.id,n.id)===0}e.$no=P;const I=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class b{static create(n){const c=n.manifest?n.manifest.version:n.version,d=n.manifest?n.targetPlatform:n.properties.targetPlatform;return new b(n.identifier,c,d)}static parse(n){const c=I.exec(n);return c&&c[1]&&c[2]?new b({id:c[1]},c[2],c[4]||void 0):null}constructor(n,c,d="undefined"){this.version=c,this.targetPlatform=d,this.id=n.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(n){return n instanceof b?P(this,n)&&this.version===n.version&&this.targetPlatform===n.targetPlatform:!1}}e.$oo=b;const S=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function C(o){const n=S.exec(o);return n&&n[1]?[r(n[1]),n[2]]:[r(o),void 0]}e.$po=C;function y(o,n){return`${o}.${n}`}e.$qo=y;function r(o){return o.toLowerCase()}e.$ro=r;function i(o,n){return r(y(o??h.$Pl,n))}e.$so=i;function a(o,n){const c=[],d=v=>{for(const k of c)if(k.some(u=>P(n(u),n(v))))return k;return null};for(const v of o){const k=d(v);k?k.push(v):c.push([v])}return c}e.$to=a;function m(o){return{id:o.identifier.id,name:o.manifest.name,galleryId:null,publisherId:o.publisherId,publisherName:o.manifest.publisher,publisherDisplayName:o.publisherDisplayName,dependencies:o.manifest.extensionDependencies&&o.manifest.extensionDependencies.length>0}}e.$uo=m;function p(o){return{id:new $.$0n(o.identifier.id),name:new $.$0n(o.name),galleryId:o.identifier.uuid,publisherId:o.publisherId,publisherName:o.publisher,publisherDisplayName:o.publisherDisplayName,isPreReleaseVersion:o.properties.isPreReleaseVersion,dependencies:!!(o.properties.dependencies&&o.properties.dependencies.length>0),isSigned:o.isSigned,...o.telemetryData}}e.$vo=p,e.$wo=new h.$Tl("pprice.better-merge");function f(o,n){const c=[],d=n.manifest.extensionDependencies?.slice(0)??[];for(;d.length;){const v=d.shift();if(v&&c.every(k=>!P(k.identifier,{id:v}))){const k=o.filter(u=>P(u.identifier,{id:v}));k.length===1&&(c.push(k[0]),d.push(...k[0].manifest.extensionDependencies?.slice(0)??[]))}}return c}e.$xo=f;async function t(o,n){if(!R.$k)return!1;let c;try{c=(await o.readFile(A.URI.file("/etc/os-release"))).value.toString()}catch{try{c=(await o.readFile(A.URI.file("/usr/lib/os-release"))).value.toString()}catch(v){n.debug("Error while getting the os-release file.",(0,g.$8)(v))}}return!!c&&(c.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function s(o,n){const c=await t(o,n),d=(0,M.$Sn)(c?"alpine":R.$t,E.$6c);return n.debug("ComputeTargetPlatform:",d),d}e.$yo=s}),define(De[247],Ce([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cr=e.$br=e.$ar=e.$_q=e.$$q=e.$0q=void 0;function D(E){return[...E.entries()]}e.$0q=D;function M(E){return E?[...E.entries()]:[]}e.$$q=M;function h(E){return new Map(E)}e.$_q=h;function R(E){return new Map(E??[])}e.$ar=R;function A(E){return Array.from(E.entries()).map($=>[$[0],D($[1].map),M($[1].descriptionMap)])}e.$br=A;function g(E){return new Map(E.map($=>[$[0],{map:h($[1]),descriptionMap:R($[2])}]))}e.$cr=g}),define(De[248],Ce([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tkb=void 0;class D{constructor(h){this.b=h,this.a=new Map}dispose(){for(const h of this.a.values())h.dispose()}startBuffering(h,R,A=5){const g=R(E=>{const $=typeof E=="string"?E:E.data;let P=this.a.get(h);if(P){P.data.push($);return}const I=setTimeout(()=>this.flushBuffer(h),A);P={data:[$],timeoutId:I,dispose:()=>{clearTimeout(I),this.flushBuffer(h),g.dispose()}},this.a.set(h,P)});return g}stopBuffering(h){this.a.get(h)?.dispose()}flushBuffer(h){const R=this.a.get(h);R&&(this.a.delete(h),this.b(h,R.data.join("")))}}e.$tkb=D}),define(De[249],Ce([1,0,13,76,56,4,18,2,195,104,41]),function($e,e,D,M,h,R,A,g,E,$,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$av=e.$_u=e.$$u=e.$0u=e.$9u=e.$8u=e.$7u=e.$6u=e.IconFontDefinition=e.IconContribution=e.$5u=void 0,e.$5u={IconContribution:"base.contributions.icons"};var I;(function(p){function f(t,s){let o=t.defaults;for(;h.ThemeIcon.isThemeIcon(o);){const n=C.getIcon(o.id);if(!n)return;o=n.defaults}return o}p.getDefinition=f})(I||(e.IconContribution=I={}));var b;(function(p){function f(s){return{weight:s.weight,style:s.style,src:s.src.map(o=>({format:o.format,location:o.location.toString()}))}}p.toJSONObject=f;function t(s){const o=n=>(0,A.$le)(n)?n:void 0;if(s&&Array.isArray(s.src)&&s.src.every(n=>(0,A.$le)(n.format)&&(0,A.$le)(n.location)))return{weight:o(s.weight),style:o(s.style),src:s.src.map(n=>({format:n.format,location:g.URI.parse(n.location)}))}}p.fromJSONObject=t})(b||(e.IconFontDefinition=b={}));class S{constructor(){this.a=new R.$hc,this.onDidChange=this.a.event,this.d={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,E.localize)(0,null)},fontCharacter:{type:"string",description:(0,E.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.e={type:"string",pattern:`^${h.ThemeIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.b={},this.f={}}registerIcon(f,t,s,o){const n=this.b[f];if(n){if(s&&!n.description){n.description=s,this.d.properties[f].markdownDescription=`${s} $(${f})`;const v=this.e.enum.indexOf(f);v!==-1&&(this.e.enumDescriptions[v]=s),this.a.fire()}return n}const c={id:f,description:s,defaults:t,deprecationMessage:o};this.b[f]=c;const d={$ref:"#/definitions/icons"};return o&&(d.deprecationMessage=o),s&&(d.markdownDescription=`${s}: $(${f})`),this.d.properties[f]=d,this.e.enum.push(f),this.e.enumDescriptions.push(s||""),this.a.fire(),{id:f}}deregisterIcon(f){delete this.b[f],delete this.d.properties[f];const t=this.e.enum.indexOf(f);t!==-1&&(this.e.enum.splice(t,1),this.e.enumDescriptions.splice(t,1)),this.a.fire()}getIcons(){return Object.keys(this.b).map(f=>this.b[f])}getIcon(f){return this.b[f]}getIconSchema(){return this.d}getIconReferenceSchema(){return this.e}registerIconFont(f,t){const s=this.f[f];return s||(this.f[f]=t,this.a.fire(),t)}deregisterIconFont(f){delete this.f[f]}getIconFont(f){return this.f[f]}toString(){const f=(n,c)=>n.id.localeCompare(c.id),t=n=>{for(;h.ThemeIcon.isThemeIcon(n.defaults);)n=this.b[n.defaults.id];return`codicon codicon-${n?n.id:""}`},s=[];s.push("| preview     | identifier                        | default codicon ID                | description"),s.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const o=Object.keys(this.b).map(n=>this.b[n]);for(const n of o.filter(c=>!!c.description).sort(f))s.push(`|<i class="${t(n)}"></i>|${n.id}|${h.ThemeIcon.isThemeIcon(n.defaults)?n.defaults.id:n.id}|${n.description||""}|`);s.push("| preview     | identifier                        "),s.push("| ----------- | --------------------------------- |");for(const n of o.filter(c=>!h.ThemeIcon.isThemeIcon(c.defaults)).sort(f))s.push(`|<i class="${t(n)}"></i>|${n.id}|`);return s.join(`
`)}}const C=new S;P.$6m.add(e.$5u.IconContribution,C);function y(p,f,t,s){return C.registerIcon(p,f,t,s)}e.$6u=y;function r(){return C}e.$7u=r;function i(){const p=(0,M.$Lj)();for(const f in p){const t="\\"+p[f].toString(16);C.registerIcon(f,{fontCharacter:t})}}i(),e.$8u="vscode://schemas/icons";const a=P.$6m.as($.$7m.JSONContribution);a.registerSchema(e.$8u,C.getIconSchema());const m=new D.$Qg(()=>a.notifySchemaChanged(e.$8u),200);C.onDidChange(()=>{m.isScheduled()||m.schedule()}),e.$9u=y("widget-close",M.$Nj.close,(0,E.localize)(2,null)),e.$0u=y("goto-previous-location",M.$Nj.arrowUp,(0,E.localize)(3,null)),e.$$u=y("goto-next-location",M.$Nj.arrowDown,(0,E.localize)(4,null)),e.$_u=h.ThemeIcon.modify(M.$Nj.sync,"spin"),e.$av=h.ThemeIcon.modify(M.$Nj.loading,"spin")}),define(De[106],Ce([1,0,4,50,6,17]),function($e,e,D,M,h,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3z=e.$2z=e.$1z=e.$Zz=e.$Yz=e.$Xz=e.$Wz=e.$Vz=e.ProvidedOnAutoForward=e.$Uz=e.TunnelPrivacyId=e.TunnelProtocol=e.$Tz=e.$Sz=void 0,e.$Sz=(0,h.$zh)("tunnelService"),e.$Tz=(0,h.$zh)("sharedTunnelsService");var A;(function(r){r.Http="http",r.Https="https"})(A||(e.TunnelProtocol=A={}));var g;(function(r){r.ConstantPrivate="constantPrivate",r.Private="private",r.Public="public"})(g||(e.TunnelPrivacyId=g={}));function E(r){return!!r.forwardPort}e.$Uz=E;var $;(function(r){r[r.Notify=1]="Notify",r[r.OpenBrowser=2]="OpenBrowser",r[r.OpenPreview=3]="OpenPreview",r[r.Silent=4]="Silent",r[r.Ignore=5]="Ignore",r[r.OpenBrowserOnce=6]="OpenBrowserOnce"})($||(e.ProvidedOnAutoForward=$={}));function P(r){if(r.scheme!=="http"&&r.scheme!=="https")return;const i=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(r.authority);if(i)return{address:i[1],port:+i[2]}}e.$Vz=P,e.$Wz=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function I(r){return e.$Wz.indexOf(r)>=0}e.$Xz=I,e.$Yz=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function b(r){return e.$Yz.indexOf(r)>=0}e.$Zz=b;function S(r,i,a,m){if(a===1)return!1;if(a===2&&b(i)){const p=/(\d+)\.(\d+)\.(\d+)/g.exec(m);if(p?.length===4&&parseInt(p[1])>=18)return!1}return r<1024}e.$1z=S;class C{constructor(i,a,m){this.remoteAddress=i,this.localAddress=a,this.b=m,this.a=new D.$hc,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.$2z=C;let y=class{constructor(i,a){this.j=i,this.k=a,this.a=new D.$hc,this.onTunnelOpened=this.a.event,this.b=new D.$hc,this.onTunnelClosed=this.b.event,this.c=new D.$hc,this.onAddedTunnelProvider=this.c.event,this.e=new Map,this.g=!1,this.h=[],this.i=new Set}get hasTunnelProvider(){return!!this.f}get l(){const i=this.k.getValue("remote.localPortHost");return!i||i==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(i){return this.f=i,i?(this.c.fire(),{dispose:()=>{this.f=void 0,this.g=!1,this.h=[]}}):(this.g=!1,this.h=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(i){this.g=i.elevation,this.h=i.privacyOptions}get canElevate(){return this.g}get canChangePrivacy(){return this.h.length>0}get privacyOptions(){return this.h}get tunnels(){return this.m()}async m(){const i=[],a=Array.from(this.e.values());for(const m of a){const p=Array.from(m.values());for(const f of p){const t=await f.value;t&&typeof t!="string"&&i.push(t)}}return i}async dispose(){for(const i of this.e.values()){for(const{value:a}of i.values())await a.then(m=>typeof m!="string"?m?.dispose():void 0);i.clear()}this.e.clear()}setEnvironmentTunnel(i,a,m,p,f){this.p(i,a,Promise.resolve({tunnelRemoteHost:i,tunnelRemotePort:a,localAddress:m,privacy:p,protocol:f,dispose:()=>Promise.resolve()}))}async getExistingTunnel(i,a){(b(i)||I(i))&&(i=e.$Wz[0]);const m=this.r(i,a);if(m)return++m.refcount,m.value}openTunnel(i,a,m,p,f,t=!1,s,o){this.j.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${a}:${m} on local port ${f}.`);const n=this.f??i;if(!n)return;if(a||(a="localhost"),p||(p=this.l),this.f&&this.i.has(m)){this.j.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const c=this.s(n,a,m,p,f,t,s,o);return c?c.then(d=>{if(d){if(typeof d=="string")return this.j.trace("ForwardedPorts: (TunnelService) The tunnel provider returned an error when creating the tunnel."),this.q(a,m),d}else{this.j.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.q(a,m);return}this.j.trace("ForwardedPorts: (TunnelService) New tunnel established.");const v=this.n(d);return(d.tunnelRemoteHost!==a||d.tunnelRemotePort!==m)&&this.j.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),s&&d.privacy!==s&&this.j.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this.a.fire(v),v}):(this.j.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),c)}n(i){return{tunnelRemotePort:i.tunnelRemotePort,tunnelRemoteHost:i.tunnelRemoteHost,tunnelLocalPort:i.tunnelLocalPort,localAddress:i.localAddress,privacy:i.privacy,protocol:i.protocol,dispose:async()=>{this.j.trace(`ForwardedPorts: (TunnelService) dispose request for ${i.tunnelRemoteHost}:${i.tunnelRemotePort} `);const a=this.e.get(i.tunnelRemoteHost);if(a){const m=a.get(i.tunnelRemotePort);m&&(m.refcount--,await this.o(i.tunnelRemoteHost,i.tunnelRemotePort,m))}}}}async o(i,a,m){if(m.refcount<=0){this.j.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${i}:${a}.`);const p=m.value.then(async f=>{f&&typeof f!="string"&&(await f.dispose(!0),this.b.fire({host:f.tunnelRemoteHost,port:f.tunnelRemotePort}))});return this.e.has(i)&&this.e.get(i).delete(a),p}}async closeTunnel(i,a){this.j.trace(`ForwardedPorts: (TunnelService) close request for ${i}:${a} `);const m=this.e.get(i);if(m&&m.has(a)){const p=m.get(a);p.refcount=0,await this.o(i,a,p)}}p(i,a,m){this.e.has(i)||this.e.set(i,new Map),this.e.get(i).set(a,{refcount:1,value:m})}async q(i,a){const m=this.e.get(i);if(m){const p=m.get(a),f=p?await p.value:void 0;(!f||typeof f=="string")&&m.delete(a),m.size===0&&this.e.delete(i)}}r(i,a){const m=[i];I(i)?(m.push(...e.$Wz),m.push(...e.$Yz)):b(i)&&m.push(...e.$Yz);const p=m.map(f=>this.e.get(f));for(const f of p){const t=f?.get(a);if(t)return t}}canTunnel(i){return!!P(i)}t(i,a,m,p,f,t,s){this.j.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${a}:${m} on local port ${p}.`);const o=m;this.i.add(o);const n=p===void 0?m:p,c={elevationRequired:f?this.isPortPrivileged(n):!1},d={remoteAddress:{host:a,port:m},localAddressPort:p,privacy:t,public:t?t!==g.Private:void 0,protocol:s},v=i.forwardPort(d,c);return v?(this.p(a,m,v),v.finally(()=>{this.j.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.i.delete(o)})):this.i.delete(o),v}};e.$3z=y,e.$3z=y=Ke([Ve(0,R.$3i),Ve(1,M.$6h)],y)}),define(De[250],Ce([1,0,6]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditSessionIdentityMatch=e.$4z=void 0,e.$4z=(0,D.$zh)("editSessionIdentityService");var M;(function(h){h[h.Complete=100]="Complete",h[h.Partial=50]="Partial",h[h.None=0]="None"})(M||(e.EditSessionIdentityMatch=M={}))}),define(De[251],Ce([1,0,16]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nJ=e.$mJ=e.$lJ=e.$kJ=e.$jJ=void 0;function M(E){return E.scheme!==D.Schemas.file&&E.scheme!==D.Schemas.vscodeRemote}e.$jJ=M;function h(E){if(E.folders.length)return E.folders.every($=>M($.uri))?E.folders[0].uri:void 0;if(E.configuration&&M(E.configuration))return E.configuration}e.$kJ=h;function R(E){return h(E)?.scheme}e.$lJ=R;function A(E){return h(E)?.authority}e.$mJ=A;function g(E){return h(E)!==void 0}e.$nJ=g}),define(De[51],Ce([1,0,196,14,75,24,2,6,16]),function($e,e,D,M,h,R,A,g,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5h=e.$4h=e.$3h=e.$2h=e.$1h=e.$Zh=e.$Yh=e.$Xh=e.$Wh=e.$Vh=e.$Uh=e.$Th=e.$Sh=e.$Rh=e.$Qh=e.WorkbenchState=e.$Ph=e.$Oh=e.$Nh=e.$Mh=e.$Lh=e.$Kh=e.$Jh=e.$Ih=void 0,e.$Ih=(0,g.$zh)("contextService");function $(n){const c=n;return typeof c?.id=="string"&&A.URI.isUri(c.uri)}e.$Jh=$;function P(n){return typeof n?.id=="string"&&!$(n)&&!b(n)}e.$Kh=P,e.$Lh={id:"ext-dev"},e.$Mh={id:"empty-window"};function I(n,c){if(typeof n=="string"||typeof n>"u")return typeof n=="string"?{id:(0,M.$cd)(n)}:c?e.$Lh:e.$Mh;const d=n;return d.configuration?{id:d.id,configPath:d.configuration}:d.folders.length===1?{id:d.id,uri:d.folders[0].uri}:{id:d.id}}e.$Nh=I;function b(n){const c=n;return typeof c?.id=="string"&&A.URI.isUri(c.configPath)}e.$Oh=b;function S(n){const c=n;if(c?.uri)return{id:c.id,uri:A.URI.revive(c.uri)};const d=n;if(d?.configPath)return{id:d.id,configPath:A.URI.revive(d.configPath)};if(n?.id)return{id:n.id}}e.$Ph=S;var C;(function(n){n[n.EMPTY=1]="EMPTY",n[n.FOLDER=2]="FOLDER",n[n.WORKSPACE=3]="WORKSPACE"})(C||(e.WorkbenchState=C={}));function y(n){const c=n;return!!(c&&typeof c=="object"&&typeof c.id=="string"&&Array.isArray(c.folders))}e.$Qh=y;function r(n){const c=n;return!!(c&&typeof c=="object"&&A.URI.isUri(c.uri)&&typeof c.name=="string"&&typeof c.toResource=="function")}e.$Rh=r;class i{constructor(c,d,v,k,u){this.h=c,this.j=v,this.k=k,this.l=u,this.c=h.$Fh.forUris(this.l,()=>!0),this.folders=d}update(c){this.h=c.id,this.k=c.configuration,this.j=c.transient,this.l=c.l,this.folders=c.folders}get folders(){return this.g}set folders(c){this.g=c,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(c){this.k=c}getFolder(c){return c&&this.c.findSubstr(c)||null}n(){this.c=h.$Fh.forUris(this.l,()=>!0);for(const c of this.folders)this.c.set(c.uri,c)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$Sh=i;class a{constructor(c,d){this.raw=d,this.uri=c.uri,this.index=c.index,this.name=c.name}toResource(c){return(0,R.$gg)(this.uri,c)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$Th=a;function m(n){return new a({uri:n,index:0,name:(0,R.$cg)(n)},{uri:n.toString()})}e.$Uh=m,e.$Vh="code-workspace",e.$Wh=`.${e.$Vh}`,e.$Xh=[{name:(0,D.localize)(0,null),extensions:[e.$Vh]}],e.$Yh="workspace.json";function p(n,c){return R.$0f.isEqualOrParent(n,c.untitledWorkspacesHome)}e.$Zh=p;function f(n){let c;return A.URI.isUri(n)?c=n:c=n.configuration,c?.scheme===E.Schemas.tmp}e.$1h=f,e.$2h="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function t(n){return n.id===e.$2h}e.$3h=t;function s(n,c){return!p(n,c)&&!f(n)}e.$4h=s;function o(n){return(typeof n=="string"?(0,M.$dd)(n):(0,R.$eg)(n))===e.$Wh}e.$5h=o}),define(De[86],Ce([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tac=void 0;class D{static{this.a=!1}constructor(h){this.d=h,this.b=new Map,this.c=1}add(h){const R=this.c++;return this.b.set(R,h),this.e(),R}get(h,R){return this.b.has(h)?this.b.get(h)[R]:void 0}delete(h){this.b.delete(h),this.e()}e(){D.a&&console.log(`${this.d} cache size - ${this.b.size}`)}}e.$tac=D}),define(De[52],Ce([1,0,16,24,6]),function($e,e,D,M,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wac=e.$vac=void 0;class R{constructor(){this.a=new Set(Object.keys(D.Schemas)),this.b=new Map,this.extUri=new M.$8f(g=>{const E=this.b.get(g.scheme);return!(E===void 0||E&1024)})}$acceptProviderInfos(g,E){E===null?this.b.delete(g.scheme):this.b.set(g.scheme,E)}isFreeScheme(g){return!this.b.has(g)&&!this.a.has(g)}getCapabilities(g){return this.b.get(g)}}e.$vac=R,e.$wac=(0,h.$zh)("IExtHostFileSystemInfo")}),define(De[26],Ce([1,0,6]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$L=void 0,e.$$L=(0,D.$zh)("IExtHostInitDataService")}),define(De[252],Ce([1,0,201,17,235,26]),function($e,e,D,M,h,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ccc=void 0;let A=class extends h.$fN{constructor(E,$,P){const I=P.remote.isRemote?"remoteexthost":E?"workerexthost":"exthost",b=P.remote.isRemote?(0,D.localize)(0,null):E?(0,D.localize)(1,null):(0,D.localize)(2,null);super($.createLogger(I,{name:b}))}};e.$Ccc=A,e.$Ccc=A=Ke([Ve(1,M.$4i),Ve(2,R.$$L)],A)}),define(De[253],Ce([1,0,13]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zac=e.$Yac=void 0;class M{constructor(A,g,E){this.h=new Map,this.a=A,this.b=g,this.c=E,this.d=this.c.initializeExtensionStorage(this.b,this.a,Object.create(null)).then($=>(this.f=$,this)),this.g=this.c.onDidChangeStorage($=>{$.shared===this.b&&$.key===this.a&&(this.f=$.value)}),this.i=new D.$Qg(()=>{const $=this.h;this.h=new Map,(async()=>{try{await this.c.setValue(this.b,this.a,this.f);for(const P of $.values())P.complete()}catch(P){for(const I of $.values())I.error(P)}})()},0)}keys(){return Object.entries(this.f??{}).filter(([,A])=>A!==void 0).map(([A])=>A)}get whenReady(){return this.d}get(A,g){let E=this.f[A];return typeof E>"u"&&(E=g),E}update(A,g){this.f[A]=g;const E=this.h.get(A);if(E!==void 0)return E.p;const $=new D.$Zg;return this.h.set(A,$),this.i.isScheduled()||this.i.schedule(),$.p}dispose(){this.g.dispose()}}e.$Yac=M;class h extends M{setKeysForSync(A){this.c.registerExtensionStorageKeysToSync({id:this.a,version:this.j.version},A)}constructor(A,g){super(A.identifier.value,!0,g),this.j=A}}e.$Zac=h}),define(De[254],Ce([1,0,4,2]),function($e,e,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lcc=void 0;class h{constructor(A){this.c=A,this.a=new D.$hc,this.onDidSaveNotebookDocument=this.a.event,this.b=new D.$hc,this.onDidChangeNotebookDocument=this.b.event}$acceptModelChanged(A,g,E,$){const I=this.c.getNotebookDocument(M.URI.revive(A)).acceptModelChanged(g.value,E,$);this.b.fire(I)}$acceptDirtyStateChanged(A,g){this.c.getNotebookDocument(M.URI.revive(A)).acceptDirty(g)}$acceptModelSaved(A){const g=this.c.getNotebookDocument(M.URI.revive(A));this.a.fire(g.apiNotebook)}}e.$lcc=h}),define(De[20],Ce([1,0,6]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$VL=e.$UL=void 0,e.$UL=(0,D.$zh)("IExtHostRpcService");class M{constructor(R){this.getProxy=R.getProxy.bind(R),this.set=R.set.bind(R),this.dispose=R.dispose.bind(R),this.assertRegistered=R.assertRegistered.bind(R),this.drain=R.drain.bind(R)}}e.$VL=M}),define(De[255],Ce([1,0,25,4]),function($e,e,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$ac=void 0;class h{#e;constructor(A,g){this.b=new M.$hc,this.onDidChange=this.b.event,this.a=D.$Tl.toKey(A.identifier),this.#e=g,this.#e.onDidChangePassword(E=>{E.extensionId===this.a&&this.b.fire({key:E.key})})}get(A){return this.#e.get(this.a,A)}store(A,g){return this.#e.store(this.a,A,g)}delete(A){return this.#e.delete(this.a,A)}}e.$$ac=h}),define(De[62],Ce([1,0,6]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hac=e.$Gac=void 0,e.$Gac=(0,D.$zh)("IURITransformerService");class M{constructor(R){R?(this.transformIncoming=R.transformIncoming.bind(R),this.transformOutgoing=R.transformOutgoing.bind(R),this.transformOutgoingURI=R.transformOutgoingURI.bind(R),this.transformOutgoingScheme=R.transformOutgoingScheme.bind(R)):(this.transformIncoming=A=>A,this.transformOutgoing=A=>A,this.transformOutgoingURI=A=>A,this.transformOutgoingScheme=A=>A)}}e.$Hac=M}),define(De[256],Ce([1,0,21]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pbb=e.$Obb=void 0;class M{constructor(){this.buffers=[]}add(E){let $=this.buffers.indexOf(E);return $<0&&($=this.buffers.length,this.buffers.push(E)),$}}function h(g,E){if(E.serializeBuffersForPostMessage){const $=new M,I=JSON.stringify(g,(S,C)=>{if(C instanceof ArrayBuffer)return{$$vscode_array_buffer_reference$$:!0,index:$.add(C)};if(ArrayBuffer.isView(C)){const y=R(C);if(y)return{$$vscode_array_buffer_reference$$:!0,index:$.add(C.buffer),view:{type:y,byteLength:C.byteLength,byteOffset:C.byteOffset}}}return C}),b=$.buffers.map(S=>{const C=new Uint8Array(S);return D.$Hc.wrap(C)});return{message:I,buffers:b}}else return{message:JSON.stringify(g),buffers:[]}}e.$Obb=h;function R(g){switch(g.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function A(g,E){const $=E.map(b=>{const S=new ArrayBuffer(b.byteLength);return new Uint8Array(S).set(b.buffer),S}),P=E.length?(b,S)=>{if(S&&typeof S=="object"&&S.$$vscode_array_buffer_reference$$){const C=S,{index:y}=C,r=$[y];if(C.view)switch(C.view.type){case 1:return new Int8Array(r,C.view.byteOffset,C.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(r,C.view.byteOffset,C.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(r,C.view.byteOffset,C.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(r,C.view.byteOffset,C.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(r,C.view.byteOffset,C.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(r,C.view.byteOffset,C.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(r,C.view.byteOffset,C.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(r,C.view.byteOffset,C.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(r,C.view.byteOffset,C.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(r,C.view.byteOffset,C.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(r,C.view.byteOffset,C.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return r}return S}:void 0;return{message:JSON.parse(g,P),arrayBuffers:$}}e.$Pbb=A}),define(De[257],Ce([1,0,258,364,365,57,2,366]),function($e,e,D,M,h,R,A,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$cc=void 0;const E=!1;function $(a,m,p,f,t,s){const o=s.environment.useHostProxy,n=typeof o=="boolean"?o:!s.remote.isRemote,c={resolveProxy:k=>a.resolveProxy(k),lookupProxyAuthorization:y.bind(void 0,f,t,m,{},s.remote.isRemote),getProxyURL:()=>m.getConfiguration("http").get("proxy"),getProxySupport:()=>m.getConfiguration("http").get("proxySupport")||"off",getSystemCertificatesV1:()=>I(m),getSystemCertificatesV2:()=>b(m),log:(k,u,...l)=>{switch(k){case g.LogLevel.Trace:f.trace(u,...l);break;case g.LogLevel.Debug:f.debug(u,...l);break;case g.LogLevel.Info:f.info(u,...l);break;case g.LogLevel.Warning:f.warn(u,...l);break;case g.LogLevel.Error:f.error(u,...l);break;case g.LogLevel.Critical:f.error(u,...l);break;case g.LogLevel.Off:break;default:w(k,u,l);break}function w(L,N,...j){f.error("Unknown log level",L),f.error(N,...j)}},getLogLevel:()=>f.getLevel(),proxyResolveTelemetry:()=>{},useHostProxy:n,addCertificates:[],env:process.env},d=(0,g.createProxyResolver)(c),v=P(c,d);return C(p,v)}e.$$cc=$;function P(a,m){return{http:Object.assign(D,(0,g.createHttpPatch)(a,D,m)),https:Object.assign(M,(0,g.createHttpPatch)(a,M,m)),net:Object.assign(R,(0,g.createNetPatch)(a,R)),tls:Object.assign(h,(0,g.createTlsPatch)(a,h))}}function I(a){const m=a.getConfiguration("http");return!m.get("experimental.systemCertificatesV2",E)&&!!m.get("systemCertificates")}function b(a){const m=a.getConfiguration("http");return!!m.get("experimental.systemCertificatesV2",E)&&!!m.get("systemCertificates")}const S=new Map;function C(a,m){return a.getExtensionPathIndex().then(p=>{const f=globalThis._VSCODE_NODE_MODULES.module,t=f._load;f._load=function(o,n,c){if(o==="net")return m.net;if(o==="tls")return m.tls;if(o!=="http"&&o!=="https")return t.apply(this,arguments);const d=p.findSubstr(A.URI.file(n.filename));let v=S.get(d);if(v||S.set(d,v={}),!v[o]){const k=m[o];v[o]={...k}}return v[o]}})}async function y(a,m,p,f,t,s,o,n){const c=f[s];o&&(f[s]=o),a.trace("ProxyResolver#lookupProxyAuthorization callback",`proxyURL:${s}`,`proxyAuthenticate:${o}`,`proxyAuthenticateCache:${c}`);const d=o||c,v=Array.isArray(d)?d:typeof d=="string"?[d]:[];if(i(m,v,t),v.some(k=>/^(Negotiate|Kerberos)( |$)/i.test(k))&&!n.kerberosRequested)try{n.kerberosRequested=!0;const k=await new Promise((N,j)=>{$e(["kerberos"],N,j)}),u=new URL(s),l=p.getConfiguration("http").get("proxyKerberosServicePrincipal")||(process.platform==="win32"?`HTTP/${u.hostname}`:`HTTP@${u.hostname}`);return a.debug("ProxyResolver#lookupProxyAuthorization Kerberos authentication lookup",`proxyURL:${s}`,`spn:${l}`),"Negotiate "+await(await k.initializeClient(l)).step("")}catch(k){a.error("ProxyResolver#lookupProxyAuthorization Kerberos authentication failed",k)}}let r=!1;function i(a,m,p){r||!m.length||(r=!0,a.$publicLog2("proxyAuthenticationRequest",{authenticationType:m.map(f=>f.split(" ")[0]).join(","),extensionHostType:p?"remote":"local"}))}}),define(De[259],Ce([1,0,128]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nr=void 0;function M(R){return{transformIncoming:A=>A.scheme==="vscode-remote"?{scheme:"file",path:A.path,query:A.query,fragment:A.fragment}:A.scheme==="file"?{scheme:"vscode-local",path:A.path,query:A.query,fragment:A.fragment}:A,transformOutgoing:A=>A.scheme==="file"?{scheme:"vscode-remote",authority:R,path:A.path,query:A.query,fragment:A.fragment}:A.scheme==="vscode-local"?{scheme:"file",path:A.path,query:A.query,fragment:A.fragment}:A,transformOutgoingScheme:A=>A==="file"?"vscode-remote":A==="vscode-local"?"file":A}}function h(R){return new D.$zm(M(R))}e.$nr=h}),define(De[138],Ce([1,0,211,18,2,3,6,41,30,16,44,174,40]),function($e,e,D,M,h,R,A,g,E,$,P,I,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3E=e.$2E=e.$1E=e.EditorsOrder=e.$ZE=e.CloseDirection=e.$YE=e.$XE=e.EditorCloseMethod=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.$WE=e.$VE=e.$UE=e.$TE=e.$SE=e.$RE=e.$QE=e.$PE=e.EditorInputCapabilities=e.$OE=e.SaveReason=e.Verbosity=e.$NE=e.$ME=e.$LE=e.$KE=e.$JE=e.$IE=e.$HE=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.$GE=e.$FE=e.$EE=e.$DE=e.$CE=void 0,e.$CE={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.$DE={id:"default",displayName:(0,D.localize)(0,null),providerDisplayName:(0,D.localize)(1,null)},e.$EE="workbench.editor.sidebysideEditor",e.$FE="workbench.editors.textDiffEditor",e.$GE="workbench.editors.binaryResourceDiffEditor";var S;(function(ce){ce[ce.PROGRAMMATIC=1]="PROGRAMMATIC",ce[ce.USER=2]="USER",ce[ce.EDIT=3]="EDIT",ce[ce.NAVIGATION=4]="NAVIGATION",ce[ce.JUMP=5]="JUMP"})(S||(e.EditorPaneSelectionChangeReason=S={}));var C;(function(ce){ce[ce.IDENTICAL=1]="IDENTICAL",ce[ce.SIMILAR=2]="SIMILAR",ce[ce.DIFFERENT=3]="DIFFERENT"})(C||(e.EditorPaneSelectionCompareResult=C={}));function y(ce){const _=ce;return!!_&&typeof _.getSelection=="function"&&!!_.onDidChangeSelection}e.$HE=y;function r(ce,_,Q){for(const z of Q.visibleEditorPanes)if(z.group.id===_&&ce.matches(z.input))return z.getViewState()}e.$IE=r;function i(ce){if(d(ce))return!1;const _=ce;return h.URI.isUri(_?.resource)}e.$JE=i;function a(ce){if(d(ce))return!1;const _=ce;return _?.original!==void 0&&_.modified!==void 0}e.$KE=a;function m(ce){if(d(ce)||a(ce))return!1;const _=ce;return _?.primary!==void 0&&_.secondary!==void 0}e.$LE=m;function p(ce){if(d(ce))return!1;const _=ce;return _?_.resource===void 0||_.resource.scheme===$.Schemas.untitled||_.forceUntitled===!0:!1}e.$ME=p;function f(ce){if(d(ce))return!1;const _=ce;return h.URI.isUri(_?.base?.resource)&&h.URI.isUri(_?.input1?.resource)&&h.URI.isUri(_?.input2?.resource)&&h.URI.isUri(_?.result?.resource)}e.$NE=f;var t;(function(ce){ce[ce.SHORT=0]="SHORT",ce[ce.MEDIUM=1]="MEDIUM",ce[ce.LONG=2]="LONG"})(t||(e.Verbosity=t={}));var s;(function(ce){ce[ce.EXPLICIT=1]="EXPLICIT",ce[ce.AUTO=2]="AUTO",ce[ce.FOCUS_CHANGE=3]="FOCUS_CHANGE",ce[ce.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(s||(e.SaveReason=s={}));class o{constructor(){this.a=new Map}registerSource(_,Q){let z=this.a.get(_);return z||(z={source:_,label:Q},this.a.set(_,z)),z.source}getSourceLabel(_){return this.a.get(_)?.label??_}}e.$OE=new o;var n;(function(ce){ce[ce.None=0]="None",ce[ce.Readonly=2]="Readonly",ce[ce.Untitled=4]="Untitled",ce[ce.Singleton=8]="Singleton",ce[ce.RequiresTrust=16]="RequiresTrust",ce[ce.CanSplitInGroup=32]="CanSplitInGroup",ce[ce.ForceDescription=64]="ForceDescription",ce[ce.CanDropIntoEditor=128]="CanDropIntoEditor",ce[ce.MultipleEditors=256]="MultipleEditors",ce[ce.Scratchpad=512]="Scratchpad"})(n||(e.EditorInputCapabilities=n={}));class c extends R.$mb{}e.$PE=c;function d(ce){return ce instanceof c}e.$QE=d;function v(ce){const _=ce;return h.URI.isUri(_?.preferredResource)}function k(ce){const _=ce;return d(_?.primary)&&d(_?.secondary)}e.$RE=k;function u(ce){const _=ce;return d(_?.modified)&&d(_?.original)}e.$SE=u;function l(ce,_,Q,z,V){return pe(z,[(0,I.$ji)({id:"workbench.action.openLargeFile",label:(0,D.localize)(2,null),run:()=>{const G={...Q,limits:{size:Number.MAX_VALUE}};ce.openEditor(_,G)}}),(0,I.$ji)({id:"workbench.action.configureEditorLargeFileConfirmation",label:(0,D.localize)(3,null),run:()=>V.openUserSettings({query:"workbench.editorLargeFileConfirmation"})})],{forceMessage:!0,forceSeverity:b.default.Warning})}e.$TE=l;function w(ce){return d(ce?.editor)}e.$UE=w;function L(ce){const _=ce;return w(ce)&&_?.group!==void 0}e.$VE=L;function N(ce){const _=ce;return typeof _?.groupId=="number"&&d(_.editor)}e.$WE=N;var j;(function(ce){ce[ce.UNKNOWN=0]="UNKNOWN",ce[ce.REPLACE=1]="REPLACE",ce[ce.MOVE=2]="MOVE",ce[ce.UNPIN=3]="UNPIN"})(j||(e.EditorCloseContext=j={}));var T;(function(ce){ce[ce.GROUP_ACTIVE=0]="GROUP_ACTIVE",ce[ce.GROUP_INDEX=1]="GROUP_INDEX",ce[ce.GROUP_LOCKED=2]="GROUP_LOCKED",ce[ce.EDITOR_OPEN=3]="EDITOR_OPEN",ce[ce.EDITOR_CLOSE=4]="EDITOR_CLOSE",ce[ce.EDITOR_MOVE=5]="EDITOR_MOVE",ce[ce.EDITOR_ACTIVE=6]="EDITOR_ACTIVE",ce[ce.EDITOR_LABEL=7]="EDITOR_LABEL",ce[ce.EDITOR_CAPABILITIES=8]="EDITOR_CAPABILITIES",ce[ce.EDITOR_PIN=9]="EDITOR_PIN",ce[ce.EDITOR_STICKY=10]="EDITOR_STICKY",ce[ce.EDITOR_DIRTY=11]="EDITOR_DIRTY",ce[ce.EDITOR_WILL_DISPOSE=12]="EDITOR_WILL_DISPOSE"})(T||(e.GroupModelChangeKind=T={}));var O;(function(ce){ce[ce.PRIMARY=1]="PRIMARY",ce[ce.SECONDARY=2]="SECONDARY",ce[ce.BOTH=3]="BOTH",ce[ce.ANY=4]="ANY"})(O||(e.SideBySideEditor=O={}));class B{getOriginalUri(_,Q){if(!_)return;if(f(_))return e.$YE.getOriginalUri(_.result,Q);if(Q?.supportSideBySide){const{primary:V,secondary:G}=this.a(_);if(V&&G){if(Q?.supportSideBySide===O.BOTH)return{primary:this.getOriginalUri(V,{filterByScheme:Q.filterByScheme}),secondary:this.getOriginalUri(G,{filterByScheme:Q.filterByScheme})};if(Q?.supportSideBySide===O.ANY)return this.getOriginalUri(V,{filterByScheme:Q.filterByScheme})??this.getOriginalUri(G,{filterByScheme:Q.filterByScheme});_=Q.supportSideBySide===O.PRIMARY?V:G}}if(a(_)||m(_)||f(_))return;const z=v(_)?_.preferredResource:_.resource;return!z||!Q||!Q.filterByScheme?z:this.b(z,Q.filterByScheme)}a(_){return k(_)||m(_)?{primary:_.primary,secondary:_.secondary}:u(_)||a(_)?{primary:_.modified,secondary:_.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(_,Q){if(!_)return;if(f(_))return e.$YE.getCanonicalUri(_.result,Q);if(Q?.supportSideBySide){const{primary:V,secondary:G}=this.a(_);if(V&&G){if(Q?.supportSideBySide===O.BOTH)return{primary:this.getCanonicalUri(V,{filterByScheme:Q.filterByScheme}),secondary:this.getCanonicalUri(G,{filterByScheme:Q.filterByScheme})};if(Q?.supportSideBySide===O.ANY)return this.getCanonicalUri(V,{filterByScheme:Q.filterByScheme})??this.getCanonicalUri(G,{filterByScheme:Q.filterByScheme});_=Q.supportSideBySide===O.PRIMARY?V:G}}if(a(_)||m(_)||f(_))return;const z=_.resource;return!z||!Q||!Q.filterByScheme?z:this.b(z,Q.filterByScheme)}b(_,Q){if(Array.isArray(Q)){if(Q.some(z=>_.scheme===z))return _}else if(Q===_.scheme)return _}}var F;(function(ce){ce[ce.UNKNOWN=0]="UNKNOWN",ce[ce.KEYBOARD=1]="KEYBOARD",ce[ce.MOUSE=2]="MOUSE"})(F||(e.EditorCloseMethod=F={}));function J(ce,_,Q,z){if(!ce.isSticky(_))return!1;switch(z.preventPinnedEditorClose){case"keyboardAndMouse":return Q===F.MOUSE||Q===F.KEYBOARD;case"mouse":return Q===F.MOUSE;case"keyboard":return Q===F.KEYBOARD}return!1}e.$XE=J,e.$YE=new B;var K;(function(ce){ce[ce.LEFT=0]="LEFT",ce[ce.RIGHT=1]="RIGHT"})(K||(e.CloseDirection=K={}));class me{constructor(){this.c=new Map,this.d=new Map}start(_){const Q=this.a=_.get(A.$yh);for(const[z,V]of this.c)this.e(z,V,Q);this.c.clear()}e(_,Q,z){const V=z.createInstance(Q);this.d.set(_,V)}registerFileEditorFactory(_){if(this.b)throw new Error("Can only register one file editor factory.");this.b=_}getFileEditorFactory(){return(0,M.$we)(this.b)}registerEditorSerializer(_,Q){if(this.c.has(_)||this.d.has(_))throw new Error(`A editor serializer with type ID '${_}' was already registered.`);return this.a?this.e(_,Q,this.a):this.c.set(_,Q),(0,R.$kb)(()=>{this.c.delete(_),this.d.delete(_)})}getEditorSerializer(_){return this.d.get(typeof _=="string"?_:_.typeId)}}g.$6m.add(e.$CE.EditorFactory,new me);async function re(ce,_,Q){return!ce||!ce.length?[]:await Promise.all(ce.map(async z=>{const V=h.URI.revive(z.fileUri);if(!V){Q.info("Cannot resolve the path because it is not valid.",z);return}if(!await _.canHandleResource(V)){Q.info("Cannot resolve the path because it cannot be handled",z);return}let ae=z.exists,ne=z.type;if(typeof ae!="boolean"||typeof ne!="number")try{ne=(await _.stat(V)).isDirectory?E.FileType.Directory:E.FileType.Unknown,ae=!0}catch(Ee){Q.error(Ee),ae=!1}if(!ae&&z.openOnlyIfExists){Q.info("Cannot resolve the path because it does not exist",z);return}if(ne===E.FileType.Directory){Q.info("Cannot resolve the path because it is a directory",z);return}const he={...z.options,pinned:!0};return ae?{resource:V,options:he}:{resource:V,options:he,forceUntitled:!0}}))}e.$ZE=re;var x;(function(ce){ce[ce.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",ce[ce.SEQUENTIAL=1]="SEQUENTIAL"})(x||(e.EditorsOrder=x={}));function q(ce){const _=ce;if(!_)return!1;const Q=_;if(Q.modified)return q(Q.modified);const z=_;return!!(z.contributionsState&&z.viewState&&Array.isArray(z.cursorState))}e.$1E=q;function ee(ce){return(0,P.$li)(ce)}e.$2E=ee;function pe(ce,_,Q){const z=(0,P.$mi)(ce,_);return z.forceMessage=Q?.forceMessage,z.forceSeverity=Q?.forceSeverity,z.allowDialog=Q?.allowDialog,z}e.$3E=pe}),define(De[260],Ce([1,0,4,212,6,3,28,41,19,69,23,76,249]),function($e,e,D,M,h,R,A,g,E,$,P,I,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0E=e.$9E=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.$8E=e.$7E=e.ViewContentGroups=e.$6E=e.$5E=e.ViewContainerLocation=e.Extensions=e.$4E=void 0,e.$4E=(0,b.$6u)("default-view-icon",I.$Nj.window,(0,M.localize)(0,null));var S;(function(o){o.ViewContainersRegistry="workbench.registry.view.containers",o.ViewsRegistry="workbench.registry.view"})(S||(e.Extensions=S={}));var C;(function(o){o[o.Sidebar=0]="Sidebar",o[o.Panel=1]="Panel",o[o.AuxiliaryBar=2]="AuxiliaryBar"})(C||(e.ViewContainerLocation=C={})),e.$5E=[0,1,2];function y(o){switch(o){case 0:return"sidebar";case 1:return"panel";case 2:return"auxiliarybar"}}e.$6E=y;class r extends R.$mb{constructor(){super(...arguments),this.c=this.B(new D.$hc),this.onDidRegister=this.c.event,this.f=this.B(new D.$hc),this.onDidDeregister=this.f.event,this.g=new Map,this.h=[]}get all(){return(0,E.$Kf)([...this.g.values()])}registerViewContainer(n,c,d){const v=this.get(n.id);if(v)return v;const k=n;return k.openCommandActionDescriptor=d?.doNotRegisterOpenCommand?void 0:k.openCommandActionDescriptor??{id:k.id},(0,A.$ui)(this.g,c,[]).push(k),d?.isDefault&&this.h.push(k),this.c.fire({viewContainer:k,viewContainerLocation:c}),k}deregisterViewContainer(n){for(const c of this.g.keys()){const d=this.g.get(c),v=d?.indexOf(n);if(v!==-1){d?.splice(v,1),d.length===0&&this.g.delete(c),this.f.fire({viewContainer:n,viewContainerLocation:c});return}}}get(n){return this.all.filter(c=>c.id===n)[0]}getViewContainers(n){return[...this.g.get(n)||[]]}getViewContainerLocation(n){return[...this.g.keys()].filter(c=>this.getViewContainers(c).filter(d=>d?.id===n.id).length>0)[0]}getDefaultViewContainer(n){return this.h.find(c=>this.getViewContainerLocation(c)===n)}}g.$6m.add(S.ViewContainersRegistry,new r);var i;(function(o){o.Open="2_open",o.Debug="4_debug",o.SCM="5_scm",o.More="9_more"})(i||(e.ViewContentGroups=i={}));function a(o,n){const c=o.group??i.More,d=n.group??i.More;return c!==d?c.localeCompare(d):(o.order??5)-(n.order??5)}class m extends R.$mb{constructor(){super(...arguments),this.c=this.B(new D.$hc),this.onViewsRegistered=this.c.event,this.f=this.B(new D.$hc),this.onViewsDeregistered=this.f.event,this.g=this.B(new D.$hc),this.onDidChangeContainer=this.g.event,this.h=this.B(new D.$hc),this.onDidChangeViewWelcomeContent=this.h.event,this.i=[],this.j=new Map,this.k=new $.$L}registerViews(n,c){this.registerViews2([{views:n,viewContainer:c}])}registerViews2(n){n.forEach(({views:c,viewContainer:d})=>this.l(c,d)),this.c.fire(n)}deregisterViews(n,c){const d=this.m(n,c);d.length&&this.f.fire({views:d,viewContainer:c})}moveViews(n,c){for(const d of this.j.keys())if(d!==c){const v=this.m(n,d);v.length&&(this.l(v,c),this.g.fire({views:v,from:d,to:c}))}}getViews(n){return this.j.get(n)||[]}getView(n){for(const c of this.i){const d=(this.j.get(c)||[]).filter(v=>v.id===n)[0];if(d)return d}return null}getViewContainer(n){for(const c of this.i)if((this.j.get(c)||[]).filter(v=>v.id===n)[0])return c;return null}registerViewWelcomeContent(n,c){return this.k.add(n,c),this.h.fire(n),(0,R.$kb)(()=>{this.k.delete(n,c),this.h.fire(n)})}registerViewWelcomeContent2(n,c){const d=new Map;for(const[v,k]of c)this.k.add(n,k),d.set(v,(0,R.$kb)(()=>{this.k.delete(n,k),this.h.fire(n)}));return this.h.fire(n),d}getViewWelcomeContent(n){const c=[];return this.k.forEach(n,d=>c.push(d)),c.sort(a)}l(n,c){let d=this.j.get(c);d||(d=[],this.j.set(c,d),this.i.push(c));for(const v of n){if(this.getView(v.id)!==null)throw new Error((0,M.localize)(1,null,v.id));d.push(v)}}m(n,c){const d=this.j.get(c);if(!d)return[];const v=[],k=[];for(const u of d)n.includes(u)?v.push(u):k.push(u);return v.length&&(k.length?this.j.set(c,k):(this.j.delete(c),this.i.splice(this.i.indexOf(c),1))),v}}g.$6m.add(S.ViewsRegistry,new m),e.$7E=(0,h.$zh)("viewsService"),e.$8E=(0,h.$zh)("viewDescriptorService");var p;(function(o){o[o.Default=0]="Default",o[o.Expand=1]="Expand"})(p||(e.ViewVisibilityState=p={}));var f;(function(o){o[o.None=0]="None",o[o.Collapsed=1]="Collapsed",o[o.Expanded=2]="Expanded"})(f||(e.TreeItemCollapsibleState=f={}));class t{constructor(n,c){this.c=!1,this.d=!1,(0,P.$Wm)(this,n),this.d=!!c,this.resolve=async d=>{if(c&&!this.c){const v=await c(d);v&&(this.tooltip=this.tooltip??v.tooltip,this.command=this.command??v.command)}d.isCancellationRequested||(this.c=!0)}}get hasResolve(){return this.d}resetResolve(){this.c=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.$9E=t;class s extends Error{constructor(n){super((0,M.localize)(2,null,n)),this.name="NoTreeViewError"}static is(n){return n.name==="NoTreeViewError"}}e.$0E=s}),define(De[139],Ce([1,0,4,13,213]),function($e,e,D,M,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$icb=void 0;class R{constructor(){this.f=new Map,this.k=[],this.m=new D.$hc,this.n=new D.$hc,this.d=1}get onError(){return this.m.event}get onExit(){return this.n.event}onMessage(g){this.j&&this.m.fire(new Error("attempt to set more than one 'Message' callback")),this.j=g}onEvent(g){this.i&&this.m.fire(new Error("attempt to set more than one 'Event' callback")),this.i=g}onRequest(g){this.g&&this.m.fire(new Error("attempt to set more than one 'Request' callback")),this.g=g}sendResponse(g){g.seq>0?this.m.fire(new Error(`attempt to send more than one response for command ${g.command}`)):this.s("response",g)}sendRequest(g,E,$,P){const I={command:g};if(E&&Object.keys(E).length>0&&(I.arguments=E),this.s("request",I),typeof P=="number"){const b=setTimeout(()=>{clearTimeout(b);const S=this.f.get(I.seq);if(S){this.f.delete(I.seq);const C={type:"response",seq:0,request_seq:I.seq,success:!1,command:g,message:(0,h.localize)(0,null,P,g)};S(C)}},P)}return $&&this.f.set(I.seq,$),I.seq}acceptMessage(g){this.j?this.j(g):(this.k.push(g),this.k.length===1&&this.q())}o(g,E){return g.type!=="event"||E.type!=="event"}async q(){let g;for(;this.k.length;){if((!g||this.o(this.k[0],g))&&await(0,M.$Fg)(0),g=this.k.shift(),!g)return;switch(g.type){case"event":this.i?.(g);break;case"request":this.g?.(g);break;case"response":{const E=g,$=this.f.get(E.request_seq);$&&(this.f.delete(E.request_seq),$(E));break}}}}s(g,E){E.type=g,E.seq=this.d++,this.sendMessage(E)}async u(){if(this.f.size===0)return Promise.resolve();const g=new Map;this.f.forEach((E,$)=>g.set($,E)),await(0,M.$Fg)(500),g.forEach((E,$)=>{E({type:"response",seq:0,request_seq:$,success:!1,command:"canceled",message:"canceled"}),this.f.delete($)})}getPendingRequestIds(){return Array.from(this.f.keys())}dispose(){this.k=[]}}e.$icb=R}),define(De[261],Ce([1,0,214,47,6]),function($e,e,D,M,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BreakpointWidgetContext=e.$jH=e.DebuggerString=e.DebugConfigurationProviderTriggerKind=e.$iH=e.MemoryRangeType=e.$hH=e.State=e.$gH=e.$fH=e.$eH=e.$dH=e.$cH=e.$bH=e.$aH=e.$_G=e.$$G=e.$0G=e.$9G=e.$8G=e.$7G=e.$6G=e.$5G=e.$4G=e.$3G=e.$2G=e.$1G=e.$ZG=e.$YG=e.$XG=e.$WG=e.$VG=e.$UG=e.$TG=e.$SG=e.$RG=e.$QG=e.$PG=e.$OG=e.$NG=e.$MG=e.$LG=e.$KG=e.$JG=e.$IG=e.$HG=e.$GG=e.$FG=e.$EG=e.$DG=e.$CG=e.$BG=e.$AG=e.$zG=e.$yG=e.$xG=e.$wG=e.$vG=e.$uG=e.$tG=e.$sG=e.$rG=e.$qG=e.$pG=e.$oG=e.$nG=e.$mG=e.$lG=e.$kG=e.$jG=e.$iG=e.$hG=e.$gG=e.$fG=void 0,e.$fG="workbench.view.debug",e.$gG="workbench.debug.variablesView",e.$hG="workbench.debug.watchExpressionsView",e.$iG="workbench.debug.callStackView",e.$jG="workbench.debug.loadedScriptsView",e.$kG="workbench.debug.breakPointsView",e.$lG="workbench.debug.disassemblyView",e.$mG="workbench.panel.repl",e.$nG="workbench.panel.repl.view",e.$oG=new M.$Zi("debugType",void 0,{type:"string",description:D.localize(0,null)}),e.$pG=new M.$Zi("debugConfigurationType",void 0,{type:"string",description:D.localize(1,null)}),e.$qG=new M.$Zi("debugState","inactive",{type:"string",description:D.localize(2,null)}),e.$rG="debugUx",e.$sG=new M.$Zi(e.$rG,"default",{type:"string",description:D.localize(3,null)}),e.$tG=new M.$Zi("hasDebugged",!1,{type:"boolean",description:D.localize(4,null)}),e.$uG=new M.$Zi("inDebugMode",!1,{type:"boolean",description:D.localize(5,null)}),e.$vG=new M.$Zi("inDebugRepl",!1,{type:"boolean",description:D.localize(6,null)}),e.$wG=new M.$Zi("breakpointWidgetVisible",!1,{type:"boolean",description:D.localize(7,null)}),e.$xG=new M.$Zi("inBreakpointWidget",!1,{type:"boolean",description:D.localize(8,null)}),e.$yG=new M.$Zi("breakpointsFocused",!0,{type:"boolean",description:D.localize(9,null)}),e.$zG=new M.$Zi("watchExpressionsFocused",!0,{type:"boolean",description:D.localize(10,null)}),e.$AG=new M.$Zi("watchExpressionsExist",!1,{type:"boolean",description:D.localize(11,null)}),e.$BG=new M.$Zi("variablesFocused",!0,{type:"boolean",description:D.localize(12,null)}),e.$CG=new M.$Zi("expressionSelected",!1,{type:"boolean",description:D.localize(13,null)}),e.$DG=new M.$Zi("breakpointInputFocused",!1,{type:"boolean",description:D.localize(14,null)}),e.$EG=new M.$Zi("callStackItemType",void 0,{type:"string",description:D.localize(15,null)}),e.$FG=new M.$Zi("callStackSessionIsAttach",!1,{type:"boolean",description:D.localize(16,null)}),e.$GG=new M.$Zi("callStackItemStopped",!1,{type:"boolean",description:D.localize(17,null)}),e.$HG=new M.$Zi("callStackSessionHasOneThread",!1,{type:"boolean",description:D.localize(18,null)}),e.$IG=new M.$Zi("watchItemType",void 0,{type:"string",description:D.localize(19,null)}),e.$JG=new M.$Zi("canViewMemory",void 0,{type:"boolean",description:D.localize(20,null)}),e.$KG=new M.$Zi("breakpointItemType",void 0,{type:"string",description:D.localize(21,null)}),e.$LG=new M.$Zi("breakpointSupportsCondition",!1,{type:"boolean",description:D.localize(22,null)}),e.$MG=new M.$Zi("loadedScriptsSupported",!1,{type:"boolean",description:D.localize(23,null)}),e.$NG=new M.$Zi("loadedScriptsItemType",void 0,{type:"string",description:D.localize(24,null)}),e.$OG=new M.$Zi("focusedSessionIsAttach",!1,{type:"boolean",description:D.localize(25,null)}),e.$PG=new M.$Zi("stepBackSupported",!1,{type:"boolean",description:D.localize(26,null)}),e.$QG=new M.$Zi("restartFrameSupported",!1,{type:"boolean",description:D.localize(27,null)}),e.$RG=new M.$Zi("stackFrameSupportsRestart",!1,{type:"boolean",description:D.localize(28,null)}),e.$SG=new M.$Zi("jumpToCursorSupported",!1,{type:"boolean",description:D.localize(29,null)}),e.$TG=new M.$Zi("stepIntoTargetsSupported",!1,{type:"boolean",description:D.localize(30,null)}),e.$UG=new M.$Zi("breakpointsExist",!1,{type:"boolean",description:D.localize(31,null)}),e.$VG=new M.$Zi("debuggersAvailable",!1,{type:"boolean",description:D.localize(32,null)}),e.$WG=new M.$Zi("debugExtensionAvailable",!0,{type:"boolean",description:D.localize(33,null)}),e.$XG=new M.$Zi("debugProtocolVariableMenuContext",void 0,{type:"string",description:D.localize(34,null)}),e.$YG=new M.$Zi("debugSetVariableSupported",!1,{type:"boolean",description:D.localize(35,null)}),e.$ZG=new M.$Zi("debugSetExpressionSupported",!1,{type:"boolean",description:D.localize(36,null)}),e.$1G=new M.$Zi("breakWhenValueChangesSupported",!1,{type:"boolean",description:D.localize(37,null)}),e.$2G=new M.$Zi("breakWhenValueIsAccessedSupported",!1,{type:"boolean",description:D.localize(38,null)}),e.$3G=new M.$Zi("breakWhenValueIsReadSupported",!1,{type:"boolean",description:D.localize(39,null)}),e.$4G=new M.$Zi("terminateDebuggeeSupported",!1,{type:"boolean",description:D.localize(40,null)}),e.$5G=new M.$Zi("suspendDebuggeeSupported",!1,{type:"boolean",description:D.localize(41,null)}),e.$6G=new M.$Zi("variableEvaluateNamePresent",!1,{type:"boolean",description:D.localize(42,null)}),e.$7G=new M.$Zi("variableIsReadonly",!1,{type:"boolean",description:D.localize(43,null)}),e.$8G=new M.$Zi("exceptionWidgetVisible",!1,{type:"boolean",description:D.localize(44,null)}),e.$9G=new M.$Zi("multiSessionRepl",!1,{type:"boolean",description:D.localize(45,null)}),e.$0G=new M.$Zi("multiSessionDebug",!1,{type:"boolean",description:D.localize(46,null)}),e.$$G=new M.$Zi("disassembleRequestSupported",!1,{type:"boolean",description:D.localize(47,null)}),e.$_G=new M.$Zi("disassemblyViewFocus",!1,{type:"boolean",description:D.localize(48,null)}),e.$aH=new M.$Zi("languageSupportsDisassembleRequest",!1,{type:"boolean",description:D.localize(49,null)}),e.$bH=new M.$Zi("focusedStackFrameHasInstructionReference",!1,{type:"boolean",description:D.localize(50,null)});const R=b=>D.localize(51,null,b);e.$cH=R,e.$dH="editor.contrib.debug",e.$eH="editor.contrib.breakpoint",e.$fH="debug",e.$gH={enum:["neverOpen","openOnSessionStart","openOnFirstSessionStart"],default:"openOnFirstSessionStart",description:D.localize(52,null)};var A;(function(b){b[b.Inactive=0]="Inactive",b[b.Initializing=1]="Initializing",b[b.Stopped=2]="Stopped",b[b.Running=3]="Running"})(A||(e.State=A={}));function g(b){switch(b){case 1:return"initializing";case 2:return"stopped";case 3:return"running";default:return"inactive"}}e.$hH=g;var E;(function(b){b[b.Valid=0]="Valid",b[b.Unreadable=1]="Unreadable",b[b.Error=2]="Error"})(E||(e.MemoryRangeType=E={})),e.$iH="vscode-debug-memory";var $;(function(b){b[b.Initial=1]="Initial",b[b.Dynamic=2]="Dynamic"})($||(e.DebugConfigurationProviderTriggerKind=$={}));var P;(function(b){b.UnverifiedBreakpoints="unverifiedBreakpoints"})(P||(e.DebuggerString=P={})),e.$jH=(0,h.$zh)("debugService");var I;(function(b){b[b.CONDITION=0]="CONDITION",b[b.HIT_COUNT=1]="HIT_COUNT",b[b.LOG_MESSAGE=2]="LOG_MESSAGE"})(I||(e.BreakpointWidgetContext=I={}))}),define(De[262],Ce([1,0,15,2,14,23,16,34,22,19]),function($e,e,D,M,h,R,A,g,E,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qF=e.$pF=e.$oF=e.$nF=e.$mF=e.$lF=e.$kF=e.$jF=e.$iF=e.$hF=e.$gF=e.$fF=e.$eF=void 0;const P=/{([^}]+)}/g;function I(k,u,l){return k.replace(P,function(w,L){return u&&L.length>0&&L[0]!=="_"?w:l&&l.hasOwnProperty(L)?l[L]:w})}e.$eF=I;function b(k){const u={};for(const l of Object.keys(k))l.startsWith("!")||(u[l]=k[l]);return u}e.$fF=b;function S(k){return k.configuration.request==="attach"&&!C(k)&&(!k.parentSession||S(k.parentSession))}e.$gF=S;function C(k){let u=k.configuration.type;if(u)return u==="vslsShare"&&(u=k.configuration.adapterProxy.configuration.type),(0,D.$Od)(u,"extensionhost")||(0,D.$Od)(u,"pwa-extensionhost")?k:k.parentSession?C(k.parentSession):void 0}e.$hF=C;function y(k){return k.type&&(k.label||k.program||k.runtime)}e.$iF=y;function r(k,u,l){let w,L=0;const N=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let j=null;for(;j=N.exec(k);){const T=j.index+1,O=T+j[0].length;if(T<=u&&O>=l){w=j[0],L=T;break}}if(w){const T=/\w+/g;let O=null;for(;(O=T.exec(w))&&!(O.index+1+L+O[0].length>=l););O&&(w=w.substring(0,T.lastIndex))}return w?{start:L,end:L+w.length-1}:{start:0,end:0}}e.$jF=r;async function i(k,u,l,w){if(k.evaluatableExpressionProvider.has(u)){const L=k.evaluatableExpressionProvider.ordered(u),N=(0,$.$Af)(await Promise.all(L.map(async j=>{try{return await j.provideEvaluatableExpression(u,l,w??E.CancellationToken.None)}catch{return}})));if(N.length>0){let j=N[0].expression;const T=N[0].range;return j||(j=u.getLineContent(l.lineNumber).substring(T.startColumn-1,T.endColumn-1)),{range:T,matchingExpression:j}}}else{const L=u.getLineContent(l.lineNumber),{start:N,end:j}=r(L,l.column,l.column),T=L.substring(N-1,j);return{matchingExpression:T,range:new g.$hs(l.lineNumber,N,l.lineNumber,N+T.length)}}return null}e.$kF=i;const a=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function m(k){return!!(k&&k.match(a))}e.$lF=m;function p(k){if(typeof k.path=="string"&&!(typeof k.sourceReference=="number"&&k.sourceReference>0)){if(m(k.path))return M.URI.parse(k.path);if((0,h.$0c)(k.path))return M.URI.file(k.path)}return k.path}function f(k){if(typeof k.path=="object"){const u=M.URI.revive(k.path);if(u)return u.scheme===A.Schemas.file?u.fsPath:u.toString()}return k.path}function t(k,u){const l=u?p:f,w=(0,R.$Tm)(k);return o(w,(L,N)=>{L&&N&&(N.path=l(N))}),w}e.$mF=t;function s(k,u){const l=u?p:f,w=(0,R.$Tm)(k);return o(w,(L,N)=>{!L&&N&&(N.path=l(N))}),w}e.$nF=s;function o(k,u){switch(k.type){case"event":{const l=k;switch(l.event){case"output":u(!1,l.body.source);break;case"loadedSource":u(!1,l.body.source);break;case"breakpoint":u(!1,l.body.breakpoint.source);break;default:break}break}case"request":{const l=k;switch(l.command){case"setBreakpoints":u(!0,l.arguments.source);break;case"breakpointLocations":u(!0,l.arguments.source);break;case"source":u(!0,l.arguments.source);break;case"gotoTargets":u(!0,l.arguments.source);break;case"launchVSCode":l.arguments.args.forEach(w=>u(!1,w));break;default:break}break}case"response":{const l=k;if(l.success&&l.body)switch(l.command){case"stackTrace":l.body.stackFrames.forEach(w=>u(!1,w.source));break;case"loadedSources":l.body.sources.forEach(w=>u(!1,w));break;case"scopes":l.body.scopes.forEach(w=>u(!1,w.source));break;case"setFunctionBreakpoints":l.body.breakpoints.forEach(w=>u(!1,w.source));break;case"setBreakpoints":l.body.breakpoints.forEach(w=>u(!1,w.source));break;case"disassemble":l.body?.instructions.forEach(L=>u(!1,L.location));break;default:break}break}}}function n(k){return k.filter(u=>!u.presentation?.hidden).sort((u,l)=>u.presentation?l.presentation?u.presentation.group?l.presentation.group?u.presentation.group!==l.presentation.group?u.presentation.group.localeCompare(l.presentation.group):c(u.presentation.order,l.presentation.order):-1:l.presentation.group?1:c(u.presentation.order,l.presentation.order):-1:l.presentation?1:0)}e.$oF=n;function c(k,u){return typeof k!="number"?typeof u!="number"?0:1:typeof u!="number"?-1:k-u}async function d(k,u){const l=k.getValue("debug.saveBeforeStart",{overrideIdentifier:u.activeTextEditorLanguageId});if(l!=="none"&&(await u.saveAll(),l==="allEditorsInActiveGroup")){const w=u.activeEditorPane;w&&w.input.resource?.scheme===A.Schemas.untitled&&await u.save({editor:w.input,groupId:w.group.id})}await k.reloadConfiguration()}e.$pF=d;const v=(k,u)=>!k||!u?k===u:k.name===u.name&&k.path===u.path&&k.sourceReference===u.sourceReference;e.$qF=v}),define(De[263],Ce([1,0,46,57,23,14,9,15,29,215,139]),function($e,e,D,M,h,R,A,g,E,$,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mcc=e.$Lcc=e.$Kcc=e.$Jcc=e.$Icc=void 0;class I extends P.$icb{static{this.a=`\r
\r
`}static{this.b=/\r?\n/}static{this.l=/: */}constructor(){super(),this.r=Buffer.allocUnsafe(0),this.t=-1}v(i,a){this.p=a,this.r=Buffer.allocUnsafe(0),this.t=-1,i.on("data",m=>this.w(m))}sendMessage(i){if(this.p){const a=JSON.stringify(i);this.p.write(`Content-Length: ${Buffer.byteLength(a,"utf8")}${I.a}${a}`,"utf8")}}w(i){for(this.r=Buffer.concat([this.r,i]);;){if(this.t>=0){if(this.r.length>=this.t){const a=this.r.toString("utf8",0,this.t);if(this.r=this.r.slice(this.t),this.t=-1,a.length>0)try{this.acceptMessage(JSON.parse(a))}catch(m){this.m.fire(new Error((m.message||m)+`
`+a))}continue}}else{const a=this.r.indexOf(I.a);if(a!==-1){const p=this.r.toString("utf8",0,a).split(I.b);for(const f of p){const t=f.split(I.l);t[0]==="Content-Length"&&(this.t=Number(t[1]))}this.r=this.r.slice(a+I.a.length);continue}}break}}}e.$Icc=I;class b extends I{startSession(){return new Promise((i,a)=>{let m=!1;this.x=this.y(()=>{this.v(this.x,this.x),i(),m=!0}),this.x.on("close",()=>{m?this.m.fire(new Error("connection closed")):a(new Error("connection closed"))}),this.x.on("error",p=>{m?this.m.fire(p):a(p)})})}async stopSession(){await this.u(),this.x&&(this.x.end(),this.x=void 0)}}e.$Jcc=b;class S extends b{constructor(i){super(),this.z=i}y(i){return M.createConnection(this.z.port,this.z.host||"127.0.0.1",i)}}e.$Kcc=S;class C extends b{constructor(i){super(),this.z=i}y(i){return M.createConnection(this.z.path,i)}}e.$Lcc=C;class y extends I{constructor(i,a){super(),this.y=i,this.z=a}async startSession(){const i=this.y.command,a=this.y.args,m=this.y.options||{};try{if(i)if(R.$0c(i)){if(!await E.Promises.exists(i))throw new Error($.localize(0,null,i))}else i.indexOf("/")<0&&i.indexOf("\\")<0;else throw new Error($.localize(1,null,this.z));let p=process.env;if(m.env&&Object.keys(m.env).length>0&&(p=h.$Wm(h.$Tm(process.env),m.env)),i==="node")if(Array.isArray(a)&&a.length>0){const f=!!process.env.ELECTRON_RUN_AS_NODE||!!process.versions.electron,t={env:p,execArgv:f?["-e","delete process.env.ELECTRON_RUN_AS_NODE;require(process.argv[1])"]:[],silent:!0};m.cwd&&(t.cwd=m.cwd);const s=D.fork(a[0],a.slice(1),t);if(!s.pid)throw new Error($.localize(2,null,a[0]));this.x=s}else throw new Error($.localize(3,null));else{const f={env:p};m.cwd&&(f.cwd=m.cwd),this.x=D.spawn(i,a,f)}this.x.on("error",f=>{this.m.fire(f)}),this.x.on("exit",(f,t)=>{this.n.fire(f)}),this.x.stdout.on("close",()=>{this.m.fire(new Error("read error"))}),this.x.stdout.on("error",f=>{this.m.fire(f)}),this.x.stdin.on("error",f=>{this.m.fire(f)}),this.x.stderr.resume(),this.v(this.x.stdout,this.x.stdin)}catch(p){this.m.fire(p)}}async stopSession(){return this.x?(await this.u(),A.$i?new Promise((i,a)=>{const m=D.exec(`taskkill /F /T /PID ${this.x.pid}`,function(p,f,t){if(p)return a(p)});m.on("exit",i),m.on("error",a)}):(this.x.kill("SIGTERM"),Promise.resolve(void 0))):Promise.resolve(void 0)}static A(i,a){if(!i)return;const m=Object.create(null);i.runtime&&(i.runtime.indexOf("./")===0?m.runtime=R.$$c(a,i.runtime):m.runtime=i.runtime),i.runtimeArgs&&(m.runtimeArgs=i.runtimeArgs),i.program&&(R.$0c(i.program)?m.program=i.program:m.program=R.$$c(a,i.program)),i.args&&(m.args=i.args);const p=i;return p.win&&(m.win=y.A(p.win,a)),p.winx86&&(m.winx86=y.A(p.winx86,a)),p.windows&&(m.windows=y.A(p.windows,a)),p.osx&&(m.osx=y.A(p.osx,a)),p.linux&&(m.linux=y.A(p.linux,a)),m}static platformAdapterExecutable(i,a){let m=Object.create(null);a=a.toLowerCase();for(const n of i)if(n.contributes){const c=n.contributes.debuggers;c&&c.length>0&&c.filter(d=>typeof d.type=="string"&&g.$Od(d.type,a)).forEach(d=>{const v=y.A(d,n.extensionLocation.fsPath);m=h.$Wm(m,v,n.isBuiltin)})}let p;A.$i&&!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432")?p=m.winx86||m.win||m.windows:A.$i?p=m.win||m.windows:A.$j?p=m.osx:A.$k&&(p=m.linux),p=p||m;const f=p.program||m.program,t=p.args||m.args,s=p.runtime||m.runtime,o=p.runtimeArgs||m.runtimeArgs;if(s)return{type:"executable",command:s,args:(o||[]).concat(typeof f=="string"?[f]:[]).concat(t||[])};if(f)return{type:"executable",command:f,args:t||[]}}}e.$Mcc=y}),define(De[264],Ce([1,0,46,32,9]),function($e,e,D,M,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Occ=e.$Ncc=void 0;function R($,P){return new Promise((I,b)=>{let S="";const C=D.spawn($,P);C.pid&&C.stdout.on("data",y=>{S+=y.toString()}),C.on("error",y=>{b(y)}),C.on("close",y=>{I(S)})})}async function A($){if($)if(h.$i){const P=await new Promise((I,b)=>{$e(["@vscode/windows-process-tree"],I,b)});return new Promise(I=>{P.getProcessTree($,b=>{I(!!b&&b.children.length>0)})})}else return R("/usr/bin/pgrep",["-lP",String($)]).then(P=>{const I=P.trim();return!(I.length===0||I.indexOf(" tmux")>=0)},P=>!0);return Promise.resolve(!0)}e.$Ncc=A;var g;(function($){$[$.cmd=0]="cmd",$[$.powershell=1]="powershell",$[$.bash=2]="bash"})(g||(g={}));function E($,P,I,b,S){$=$.trim().toLowerCase();let C;$.indexOf("powershell")>=0||$.indexOf("pwsh")>=0?C=1:$.indexOf("cmd.exe")>=0?C=0:$.indexOf("bash")>=0?C=2:h.$i?C=0:C=2;let y,r=" ";switch(C){case 1:if(y=i=>(i=i.replace(/\'/g,"''"),i.length>0&&i.charAt(i.length-1)==="\\"?`'${i}\\'`:`'${i}'`),b){const i=(0,M.$Pe)(b);i&&(r+=`${i}:; `),r+=`cd ${y(b)}; `}if(S)for(const i in S){const a=S[i];a===null?r+=`Remove-Item env:${i}; `:r+=`\${env:${i}}='${a}'; `}if(P.length>0){const i=P.shift(),a=I?i:y(i);r+=a[0]==="'"?`& ${a} `:`${a} `;for(const m of P)r+=m==="<"||m===">"||I?m:y(m),r+=" "}break;case 0:if(y=i=>(i=i.replace(/\"/g,'""'),i=i.replace(/([><!^&|])/g,"^$1"),' "'.split("").some(a=>i.includes(a))||i.length===0?`"${i}"`:i),b){const i=(0,M.$Pe)(b);i&&(r+=`${i}: && `),r+=`cd ${y(b)} && `}if(S){r+='cmd /C "';for(const i in S){let a=S[i];a===null?r+=`set "${i}=" && `:(a=a.replace(/[&^|<>]/g,m=>`^${m}`),r+=`set "${i}=${a}" && `)}}for(const i of P)r+=i==="<"||i===">"||I?i:y(i),r+=" ";S&&(r+='"');break;case 2:{y=a=>(a=a.replace(/(["'\\\$!><#()\[\]*&^| ;{}`])/g,"\\$1"),a.length===0?'""':a);const i=a=>/[^\w@%\/+=,.:^-]/.test(a)?`'${a.replace(/'/g,"'\\''")}'`:a;if(b&&(r+=`cd ${y(b)} ; `),S){r+="/usr/bin/env";for(const a in S){const m=S[a];m===null?r+=` -u ${i(a)}`:r+=` ${i(`${a}=${m}`)}`}r+=" "}for(const a of P)r+=a==="<"||a===">"||I?a:y(a),r+=" ";break}}return r}e.$Occ=E}),define(De[107],Ce([1,0,21,35,48,97,16,14,9,47]),function($e,e,D,M,h,R,A,g,E,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2H=e.$1H=e.$ZH=e.$YH=e.CellStatusbarAlignment=e.$XH=e.$WH=e.$VH=e.NotebookEditorPriority=e.$UH=e.$TH=e.$SH=e.$RH=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookExecutionState=e.NotebookCellExecutionState=e.NotebookRunState=e.$QH=e.$PH=e.$OH=e.$NH=e.CellKind=e.$MH=e.$LH=e.$KH=void 0,e.$KH="workbench.editor.notebook",e.$LH="workbench.editor.notebookTextDiffEditor",e.$MH="workbench.editor.interactive";var P;(function(F){F[F.Markup=1]="Markup",F[F.Code=2]="Code"})(P||(e.CellKind=P={})),e.$NH=["application/json","application/javascript","text/html","image/svg+xml",R.$Er.latex,R.$Er.markdown,"image/png","image/jpeg",R.$Er.text],e.$OH=[R.$Er.latex,R.$Er.markdown,"application/json","text/html","image/svg+xml","image/png","image/jpeg",R.$Er.text],e.$PH=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.$QH="_notAvailable";var I;(function(F){F[F.Running=1]="Running",F[F.Idle=2]="Idle"})(I||(e.NotebookRunState=I={}));var b;(function(F){F[F.Unconfirmed=1]="Unconfirmed",F[F.Pending=2]="Pending",F[F.Executing=3]="Executing"})(b||(e.NotebookCellExecutionState=b={}));var S;(function(F){F[F.Unconfirmed=1]="Unconfirmed",F[F.Pending=2]="Pending",F[F.Executing=3]="Executing"})(S||(e.NotebookExecutionState=S={}));var C;(function(F){F[F.WithHardKernelDependency=0]="WithHardKernelDependency",F[F.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",F[F.Pure=2]="Pure",F[F.Never=3]="Never"})(C||(e.NotebookRendererMatch=C={}));var y;(function(F){F.Always="always",F.Never="never",F.Optional="optional"})(y||(e.RendererMessagingSpec=y={}));var r;(function(F){F[F.ModelChange=1]="ModelChange",F[F.Move=2]="Move",F[F.ChangeCellLanguage=5]="ChangeCellLanguage",F[F.Initialize=6]="Initialize",F[F.ChangeCellMetadata=7]="ChangeCellMetadata",F[F.Output=8]="Output",F[F.OutputItem=9]="OutputItem",F[F.ChangeCellContent=10]="ChangeCellContent",F[F.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",F[F.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",F[F.ChangeCellMime=13]="ChangeCellMime",F[F.Unknown=100]="Unknown"})(r||(e.NotebookCellsChangeType=r={}));var i;(function(F){F[F.Handle=0]="Handle",F[F.Index=1]="Index"})(i||(e.SelectionStateType=i={}));var a;(function(F){F[F.Replace=1]="Replace",F[F.Output=2]="Output",F[F.Metadata=3]="Metadata",F[F.CellLanguage=4]="CellLanguage",F[F.DocumentMetadata=5]="DocumentMetadata",F[F.Move=6]="Move",F[F.OutputItems=7]="OutputItems",F[F.PartialMetadata=8]="PartialMetadata",F[F.PartialInternalMetadata=9]="PartialInternalMetadata"})(a||(e.CellEditType=a={}));var m;(function(F){F.scheme=A.Schemas.vscodeNotebookCell;const J=["W","X","Y","Z","a","b","c","d","e","f"],K=new RegExp(`^[${J.join("")}]+`),me=7;function re(_,Q){const z=Q.toString(me),G=`${z.length<J.length?J[z.length-1]:"z"}${z}s${(0,D.$2c)(D.$Hc.fromString(_.scheme),!0,!0)}`;return _.with({scheme:F.scheme,fragment:G})}F.generate=re;function x(_){if(_.scheme!==F.scheme)return;const Q=_.fragment.indexOf("s");if(Q<0)return;const z=parseInt(_.fragment.substring(0,Q).replace(K,""),me),V=(0,D.$1c)(_.fragment.substring(Q+1)).toString();if(!isNaN(z))return{handle:z,notebook:_.with({scheme:V,fragment:null})}}F.parse=x;function q(_,Q){return _.with({scheme:A.Schemas.vscodeNotebookCellOutput,fragment:`op${Q??""},${_.scheme!==A.Schemas.file?_.scheme:""}`})}F.generateCellOutputUri=q;function ee(_){if(_.scheme!==A.Schemas.vscodeNotebookCellOutput)return;const Q=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(_.fragment);if(!Q)return;const z=Q[1]&&Q[1]!==""?Q[1]:void 0,V=Q[2];return{outputId:z,notebook:_.with({scheme:V||A.Schemas.file,fragment:null})}}F.parseCellOutputUri=ee;function pe(_,Q,z){return F.generate(_,Q).with({scheme:z})}F.generateCellPropertyUri=pe;function ce(_,Q){if(_.scheme===Q)return F.parse(_.with({scheme:F.scheme}))}F.parseCellPropertyUri=ce})(m||(e.CellUri=m={}));const p=F=>E.$i?F.replace(/\//g,"\\"):F;class f{constructor(J=[],K=e.$NH){this.e=K,this.d=[...new Set(J)].map(me=>({pattern:me,matches:M.$pj(p(me))}))}sort(J){const K=new Map(h.Iterable.map(J,re=>[re,p(re)]));let me=[];for(const{matches:re}of this.d)for(const[x,q]of K)if(re(q)){me.push(x),K.delete(x);break}return K.size&&(me=me.concat([...K.keys()].sort((re,x)=>this.e.indexOf(re)-this.e.indexOf(x)))),me}prioritize(J,K){const me=this.f(J);if(me===-1){this.d.unshift({pattern:J,matches:M.$pj(p(J))});return}const re=new Set(K.map(q=>this.f(q,me)));re.delete(-1);const x=Array.from(re).sort();this.d.splice(me+1,0,...x.map(q=>this.d[q]));for(let q=x.length-1;q>=0;q--)this.d.splice(x[q],1)}toArray(){return this.d.map(J=>J.pattern)}f(J,K=this.d.length){const me=p(J);for(let re=0;re<K;re++)if(this.d[re].matches(me))return re;return-1}}e.$RH=f;function t(F,J,K,me=(re,x)=>re===x){const re=[];function x(pe,ce,_){if(ce===0&&_.length===0)return;const Q=re[re.length-1];Q&&Q.start+Q.deleteCount===pe?(Q.deleteCount+=ce,Q.toInsert.push(..._)):re.push({start:pe,deleteCount:ce,toInsert:_})}let q=0,ee=0;for(;;){if(q===F.length){x(q,0,J.slice(ee));break}if(ee===J.length){x(q,F.length-q,[]);break}const pe=F[q],ce=J[ee];if(me(pe,ce)){q+=1,ee+=1;continue}K(ce)?(x(q,1,[]),q+=1):(x(q,0,[ce]),ee+=1)}return re}e.$SH=t,e.$TH=new $.$Zi("notebookEditorCursorAtBoundary","none"),e.$UH=new $.$Zi("notebookEditorCursorAtLineBoundary","none");var s;(function(F){F.default="default",F.option="option"})(s||(e.NotebookEditorPriority=s={}));function o(F){const J=F;return!!((typeof J.include=="string"||M.$qj(J.include))&&(typeof J.exclude=="string"||M.$qj(J.exclude)))}e.$VH=o;function n(F,J,K){if(Array.isArray(F.viewType)&&F.viewType.indexOf(J)>=0||F.viewType===J)return!0;if(F.filenamePattern){const me=o(F.filenamePattern)?F.filenamePattern.include:F.filenamePattern,re=o(F.filenamePattern)?F.filenamePattern.exclude:void 0;if(M.$oj(me,(0,g.$cd)(K.fsPath).toLowerCase()))return!(re&&M.$oj(re,(0,g.$cd)(K.fsPath).toLowerCase()))}return!1}e.$WH=n,e.$XH={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",diffOverviewRuler:"notebook.diff.overviewRuler",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",stickyScroll:"notebook.stickyScroll.enabled",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputScrollingDeprecated:"notebook.experimental.outputScrolling",outputScrolling:"notebook.output.scrolling",textOutputLineLimit:"notebook.output.textLineLimit",formatOnSave:"notebook.formatOnSave.enabled",formatOnCellExecution:"notebook.formatOnCellExecution",codeActionsOnSave:"notebook.codeActionsOnSave",outputWordWrap:"notebook.output.wordWrap",outputLineHeightDeprecated:"notebook.outputLineHeight",outputLineHeight:"notebook.output.lineHeight",outputFontSizeDeprecated:"notebook.outputFontSize",outputFontSize:"notebook.output.fontSize",outputFontFamilyDeprecated:"notebook.outputFontFamily",outputFontFamily:"notebook.output.fontFamily",findScope:"notebook.find.scope",logging:"notebook.logging",confirmDeleteRunningCell:"notebook.confirmDeleteRunningCell",remoteSaving:"notebook.experimental.remoteSave"};var c;(function(F){F[F.Left=1]="Left",F[F.Right=2]="Right"})(c||(e.CellStatusbarAlignment=c={}));class d{static{this.d="notebook/"}static create(J){return`${d.d}${J}`}static parse(J){if(J.startsWith(d.d))return J.substring(d.d.length)}}e.$YH=d;function v(F){return["application/vnd.code.notebook.stdout","application/vnd.code.notebook.stderr"].includes(F)}e.$ZH=v;const k=new TextDecoder;function u(F){const J=[];let K=!1;for(const q of F)(J.length===0||K)&&(J.push(q),K=!0);let me=L(J);const re=D.$Hc.concat(J.map(q=>D.$Hc.wrap(q))),x=B(re);return me=me||x.byteLength!==re.byteLength,{data:x,didCompression:me}}e.$1H=u,e.$2H=`${String.fromCharCode(27)}[A`;const l=e.$2H.split("").map(F=>F.charCodeAt(0)),w=10;function L(F){let J=!1;return F.forEach((K,me)=>{if(me===0||K.length<e.$2H.length)return;const re=F[me-1],x=K.subarray(0,e.$2H.length);if(x[0]===l[0]&&x[1]===l[1]&&x[2]===l[2]){const q=re.lastIndexOf(w);if(q===-1)return;J=!0,F[me-1]=re.subarray(0,q),F[me]=K.subarray(e.$2H.length)}}),J}function N(F){let J=F;do F=J,J=F.replace(/[^\n]\x08/gm,"");while(J.length<F.length);return F}function j(F){for(F=F.replace(/\r+\n/gm,`
`);F.search(/\r[^$]/g)>-1;){const J=F.match(/^(.*)\r+/m)[1];let K=F.match(/\r+(.*)$/m)[1];K=K+J.slice(K.length,J.length),F=F.replace(/\r+.*$/m,"\r").replace(/^.*\r/m,K)}return F}const T="\b".charCodeAt(0),O="\r".charCodeAt(0);function B(F){return!F.buffer.includes(T)&&!F.buffer.includes(O)?F:D.$Hc.fromString(j(N(k.decode(F.buffer))))}}),define(De[7],Ce([1,0,19,8,78,28,97,15,18,2,31,25,30,84,107]),function($e,e,D,M,h,R,A,g,E,$,P,I,b,S,C){"use strict";var y,r,i,a,m,p,f,t,s,o,n,c,d,v,k,u,l,w;Object.defineProperty(e,"__esModule",{value:!0}),e.RelatedInformationType=e.$JL=e.ChatVariableLevel=e.ChatMessageRole=e.InteractiveEditorResponseFeedbackKind=e.InteractiveSessionCopyKind=e.InteractiveSessionVoteDirection=e.$IL=e.$HL=e.$GL=e.$FL=e.$EL=e.$DL=e.$CL=e.$BL=e.$AL=e.$zL=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.$yL=e.$xL=e.$wL=e.$vL=e.$uL=e.$tL=e.$sL=e.$rL=e.TestRunProfileKind=e.TestResultState=e.$qL=e.$pL=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.$oL=e.$nL=e.$mL=e.NotebookControllerAffinity2=e.NotebookControllerAffinity=e.$lL=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.$kL=e.$jL=e.$iL=e.$hL=e.$gL=e.ColorThemeKind=e.$fL=e.$eL=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.$dL=e.DebugConsoleMode=e.$cL=e.$bL=e.$aL=e.$_K=e.$$K=e.CommentThreadState=e.CommentState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.$0K=e.$9K=e.FileChangeType=e.$8K=e.$7K=e.$6K=e.$5K=e.InlineCompletionTriggerKind=e.$4K=e.$3K=e.$2K=e.$1K=e.$ZK=e.$YK=e.$XK=e.$WK=e.$VK=e.$UK=e.$TK=e.$SK=e.$RK=e.ConfigurationTarget=e.$QK=e.$PK=e.$OK=e.$NK=e.$MK=e.$LK=e.$KK=e.$JK=e.$IK=e.TreeItemCheckboxState=e.TreeItemCollapsibleState=e.$HK=e.ViewBadge=e.ProgressLocation=e.$GK=e.$FK=e.TaskScope=e.ShellQuoting=e.$EK=e.$DK=e.$CK=e.TaskPanelKind=e.TaskRevealKind=e.$BK=e.TerminalLocation=e.$AK=e.$zK=e.$yK=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.$xK=e.$wK=e.$vK=e.$uK=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.$tK=e.StatusBarAlignment=e.ViewColumn=e.$sK=e.$rK=e.$qK=e.$pK=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.$oK=e.$nK=e.InlayHintKind=e.SignatureHelpTriggerKind=e.$mK=e.$lK=e.$kK=e.$jK=e.$iK=e.LanguageStatusSeverity=e.$hK=e.$gK=e.$fK=e.$eK=e.$dK=e.$cK=e.$bK=e.CodeActionTriggerKind=e.$aK=e.$_J=e.SymbolTag=e.SymbolKind=e.$$J=e.DocumentHighlightKind=e.$0J=e.$9J=e.$8J=e.$7J=e.DiagnosticSeverity=e.DiagnosticTag=e.$6J=e.$5J=e.FileEditType=e.$4J=e.$3J=e.$2J=e.EnvironmentVariableMutatorType=e.EndOfLine=e.$1J=e.$ZJ=e.$YJ=e.$XJ=e.$WJ=e.$VJ=e.$UJ=e.TerminalQuickFixType=e.TerminalOutputAnchor=void 0;function L(H){return Object.assign(H,{apply:function(...ve){if(ve.length===0)return Reflect.construct(H,[]);{const Re=ve.length===1?[]:ve[1];return Reflect.construct(H,Re,ve[0].constructor)}},call:function(...ve){if(ve.length===0)return Reflect.construct(H,[]);{const[Re,...Ze]=ve;return Reflect.construct(H,Ze,Re.constructor)}}})}var N;(function(H){H[H.Top=0]="Top",H[H.Bottom=1]="Bottom"})(N||(e.TerminalOutputAnchor=N={}));var j;(function(H){H[H.TerminalCommand=0]="TerminalCommand",H[H.Opener=1]="Opener",H[H.Command=3]="Command"})(j||(e.TerminalQuickFixType=j={}));let T=y=class{static from(...W){let ve=W;return new y(function(){if(ve){for(const Re of ve)Re&&typeof Re.dispose=="function"&&Re.dispose();ve=void 0}})}#e;constructor(W){this.#e=W}dispose(){typeof this.#e=="function"&&(this.#e(),this.#e=void 0)}};e.$UJ=T,e.$UJ=T=y=Ke([L],T);let O=r=class{static Min(...W){if(W.length===0)throw new TypeError;let ve=W[0];for(let Re=1;Re<W.length;Re++){const Ze=W[Re];Ze.isBefore(ve)&&(ve=Ze)}return ve}static Max(...W){if(W.length===0)throw new TypeError;let ve=W[0];for(let Re=1;Re<W.length;Re++){const Ze=W[Re];Ze.isAfter(ve)&&(ve=Ze)}return ve}static isPosition(W){if(!W)return!1;if(W instanceof r)return!0;const{line:ve,character:Re}=W;return typeof ve=="number"&&typeof Re=="number"}static of(W){if(W instanceof r)return W;if(this.isPosition(W))return new r(W.line,W.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this.c}get character(){return this.e}constructor(W,ve){if(W<0)throw(0,M.$5)("line must be non-negative");if(ve<0)throw(0,M.$5)("character must be non-negative");this.c=W,this.e=ve}isBefore(W){return this.c<W.c?!0:W.c<this.c?!1:this.e<W.e}isBeforeOrEqual(W){return this.c<W.c?!0:W.c<this.c?!1:this.e<=W.e}isAfter(W){return!this.isBeforeOrEqual(W)}isAfterOrEqual(W){return!this.isBefore(W)}isEqual(W){return this.c===W.c&&this.e===W.e}compareTo(W){return this.c<W.c?-1:this.c>W.line?1:this.e<W.e?-1:this.e>W.e?1:0}translate(W,ve=0){if(W===null||ve===null)throw(0,M.$5)();let Re;return typeof W>"u"?Re=0:typeof W=="number"?Re=W:(Re=typeof W.lineDelta=="number"?W.lineDelta:0,ve=typeof W.characterDelta=="number"?W.characterDelta:0),Re===0&&ve===0?this:new r(this.line+Re,this.character+ve)}with(W,ve=this.character){if(W===null||ve===null)throw(0,M.$5)();let Re;return typeof W>"u"?Re=this.line:typeof W=="number"?Re=W:(Re=typeof W.line=="number"?W.line:this.line,ve=typeof W.character=="number"?W.character:this.character),Re===this.line&&ve===this.character?this:new r(Re,ve)}toJSON(){return{line:this.line,character:this.character}}};e.$VJ=O,e.$VJ=O=r=Ke([L],O);let B=i=class{static isRange(W){return W instanceof i?!0:W?O.isPosition(W.start)&&O.isPosition(W.end):!1}static of(W){if(W instanceof i)return W;if(this.isRange(W))return new i(W.start,W.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this.c}get end(){return this.e}constructor(W,ve,Re,Ze){let tt,at;if(typeof W=="number"&&typeof ve=="number"&&typeof Re=="number"&&typeof Ze=="number"?(tt=new O(W,ve),at=new O(Re,Ze)):O.isPosition(W)&&O.isPosition(ve)&&(tt=O.of(W),at=O.of(ve)),!tt||!at)throw new Error("Invalid arguments");tt.isBefore(at)?(this.c=tt,this.e=at):(this.c=at,this.e=tt)}contains(W){return i.isRange(W)?this.contains(W.start)&&this.contains(W.end):O.isPosition(W)?!(O.of(W).isBefore(this.c)||this.e.isBefore(W)):!1}isEqual(W){return this.c.isEqual(W.c)&&this.e.isEqual(W.e)}intersection(W){const ve=O.Max(W.start,this.c),Re=O.Min(W.end,this.e);if(!ve.isAfter(Re))return new i(ve,Re)}union(W){if(this.contains(W))return this;if(W.contains(this))return W;const ve=O.Min(W.start,this.c),Re=O.Max(W.end,this.end);return new i(ve,Re)}get isEmpty(){return this.c.isEqual(this.e)}get isSingleLine(){return this.c.line===this.e.line}with(W,ve=this.end){if(W===null||ve===null)throw(0,M.$5)();let Re;return W?O.isPosition(W)?Re=W:(Re=W.start||this.start,ve=W.end||this.end):Re=this.start,Re.isEqual(this.c)&&ve.isEqual(this.end)?this:new i(Re,ve)}toJSON(){return[this.start,this.end]}};e.$WJ=B,e.$WJ=B=i=Ke([L],B);let F=a=class extends B{static isSelection(W){return W instanceof a?!0:W?B.isRange(W)&&O.isPosition(W.anchor)&&O.isPosition(W.active)&&typeof W.isReversed=="boolean":!1}get anchor(){return this.f}get active(){return this.g}constructor(W,ve,Re,Ze){let tt,at;if(typeof W=="number"&&typeof ve=="number"&&typeof Re=="number"&&typeof Ze=="number"?(tt=new O(W,ve),at=new O(Re,Ze)):O.isPosition(W)&&O.isPosition(ve)&&(tt=O.of(W),at=O.of(ve)),!tt||!at)throw new Error("Invalid arguments");super(tt,at),this.f=tt,this.g=at}get isReversed(){return this.f===this.e}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};e.$XJ=F,e.$XJ=F=a=Ke([L],F);const J=H=>{if(typeof H!="string"||H.length===0||!/^[0-9A-Za-z_\-]+$/.test(H))throw(0,M.$5)("connectionToken")};class K{static isResolvedAuthority(W){return W&&typeof W=="object"&&typeof W.host=="string"&&typeof W.port=="number"&&(W.connectionToken===void 0||typeof W.connectionToken=="string")}constructor(W,ve,Re){if(typeof W!="string"||W.length===0)throw(0,M.$5)("host");if(typeof ve!="number"||ve===0||Math.round(ve)!==ve)throw(0,M.$5)("port");typeof Re<"u"&&J(Re),this.host=W,this.port=Math.round(ve),this.connectionToken=Re}}e.$YJ=K;class me{static isManagedResolvedAuthority(W){return W&&typeof W=="object"&&typeof W.makeConnection=="function"&&(W.connectionToken===void 0||typeof W.connectionToken=="string")}constructor(W,ve){this.makeConnection=W,this.connectionToken=ve,typeof ve<"u"&&J(ve)}}e.$ZJ=me;class re extends Error{static NotAvailable(W,ve){return new re(W,S.RemoteAuthorityResolverErrorCode.NotAvailable,ve)}static TemporarilyNotAvailable(W){return new re(W,S.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}constructor(W,ve=S.RemoteAuthorityResolverErrorCode.Unknown,Re){super(W),this._message=W,this._code=ve,this._detail=Re,Object.setPrototypeOf(this,re.prototype)}}e.$1J=re;var x;(function(H){H[H.LF=1]="LF",H[H.CRLF=2]="CRLF"})(x||(e.EndOfLine=x={}));var q;(function(H){H[H.Replace=1]="Replace",H[H.Append=2]="Append",H[H.Prepend=3]="Prepend"})(q||(e.EnvironmentVariableMutatorType=q={}));let ee=m=class{static isTextEdit(W){return W instanceof m?!0:W?B.isRange(W)&&typeof W.newText=="string":!1}static replace(W,ve){return new m(W,ve)}static insert(W,ve){return m.replace(new B(W,W),ve)}static delete(W){return m.replace(W,"")}static setEndOfLine(W){const ve=new m(new B(new O(0,0),new O(0,0)),"");return ve.newEol=W,ve}get range(){return this.c}set range(W){if(W&&!B.isRange(W))throw(0,M.$5)("range");this.c=W}get newText(){return this.e||""}set newText(W){if(W&&typeof W!="string")throw(0,M.$5)("newText");this.e=W}get newEol(){return this.f}set newEol(W){if(W&&typeof W!="number")throw(0,M.$5)("newEol");this.f=W}constructor(W,ve){this.c=W,this.e=ve}toJSON(){return{range:this.range,newText:this.newText,newEol:this.f}}};e.$2J=ee,e.$2J=ee=m=Ke([L],ee);let pe=p=class{static isNotebookCellEdit(W){return W instanceof p?!0:W?Xt.isNotebookRange(W)&&Array.isArray(W.newCells):!1}static replaceCells(W,ve){return new p(W,ve)}static insertCells(W,ve){return new p(new Xt(W,W),ve)}static deleteCells(W){return new p(W,[])}static updateCellMetadata(W,ve){const Re=new p(new Xt(W,W),[]);return Re.newCellMetadata=ve,Re}static updateNotebookMetadata(W){const ve=new p(new Xt(0,0),[]);return ve.newNotebookMetadata=W,ve}constructor(W,ve){this.range=W,this.newCells=ve}};e.$3J=pe,e.$3J=pe=p=Ke([L],pe);class ce{static isSnippetTextEdit(W){return W instanceof ce?!0:W?B.isRange(W.range)&&z.isSnippetString(W.snippet):!1}static replace(W,ve){return new ce(W,ve)}static insert(W,ve){return ce.replace(new B(W,W),ve)}constructor(W,ve){this.range=W,this.snippet=ve}}e.$4J=ce;var _;(function(H){H[H.File=1]="File",H[H.Text=2]="Text",H[H.Cell=3]="Cell",H[H.CellReplace=5]="CellReplace",H[H.Snippet=6]="Snippet"})(_||(e.FileEditType=_={}));let Q=class{constructor(){this.c=[]}_allEntries(){return this.c}renameFile(W,ve,Re,Ze){this.c.push({_type:1,from:W,to:ve,options:Re,metadata:Ze})}createFile(W,ve,Re){this.c.push({_type:1,from:void 0,to:W,options:ve,metadata:Re})}deleteFile(W,ve,Re){this.c.push({_type:1,from:W,to:void 0,options:ve,metadata:Re})}e(W,ve,Re){this.c.push({_type:3,metadata:Re,uri:W,edit:{editType:5,metadata:ve},notebookMetadata:ve})}f(W,ve,Re,Ze){const tt=ve.start,at=ve.end;(tt!==at||Re.length>0)&&this.c.push({_type:5,uri:W,index:tt,count:at-tt,cells:Re,metadata:Ze})}g(W,ve,Re,Ze){this.c.push({_type:3,metadata:Ze,uri:W,edit:{editType:3,index:ve,metadata:Re}})}replace(W,ve,Re,Ze){this.c.push({_type:2,uri:W,edit:new ee(ve,Re),metadata:Ze})}insert(W,ve,Re,Ze){this.replace(W,new B(ve,ve),Re,Ze)}delete(W,ve,Re){this.replace(W,ve,"",Re)}has(W){return this.c.some(ve=>ve._type===2&&ve.uri.toString()===W.toString())}set(W,ve){if(ve)for(const Re of ve){if(!Re)continue;let Ze,tt;Array.isArray(Re)?(Ze=Re[0],tt=Re[1]):Ze=Re,pe.isNotebookCellEdit(Ze)?Ze.newCellMetadata?this.g(W,Ze.range.start,Ze.newCellMetadata,tt):Ze.newNotebookMetadata?this.e(W,Ze.newNotebookMetadata,tt):this.f(W,Ze.range,Ze.newCells,tt):ce.isSnippetTextEdit(Ze)?this.c.push({_type:6,uri:W,range:Ze.range,edit:Ze.snippet,metadata:tt}):this.c.push({_type:2,uri:W,edit:Ze,metadata:tt})}else{for(let Re=0;Re<this.c.length;Re++){const Ze=this.c[Re];switch(Ze._type){case 2:case 6:case 3:case 5:Ze.uri.toString()===W.toString()&&(this.c[Re]=void 0);break}}(0,D.$Bf)(this.c)}}get(W){const ve=[];for(const Re of this.c)Re._type===2&&Re.uri.toString()===W.toString()&&ve.push(Re.edit);return ve}entries(){const W=new R.$xi;for(const ve of this.c)if(ve._type===2){let Re=W.get(ve.uri);Re||(Re=[ve.uri,[]],W.set(ve.uri,Re)),Re[1].push(ve.edit)}return[...W.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};e.$5J=Q,e.$5J=Q=Ke([L],Q);let z=f=class{static isSnippetString(W){return W instanceof f?!0:W?typeof W.value=="string":!1}static c(W){return W.replace(/\$|}|\\/g,"\\$&")}constructor(W){this.e=1,this.value=W||""}appendText(W){return this.value+=f.c(W),this}appendTabstop(W=this.e++){return this.value+="$",this.value+=W,this}appendPlaceholder(W,ve=this.e++){if(typeof W=="function"){const Re=new f;Re.e=this.e,W(Re),this.e=Re.e,W=Re.value}else W=f.c(W);return this.value+="${",this.value+=ve,this.value+=":",this.value+=W,this.value+="}",this}appendChoice(W,ve=this.e++){const Re=W.map(Ze=>Ze.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=ve,this.value+="|",this.value+=Re,this.value+="|}",this}appendVariable(W,ve){if(typeof ve=="function"){const Re=new f;Re.e=this.e,ve(Re),this.e=Re.e,ve=Re.value}else typeof ve=="string"&&(ve=ve.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=W,ve&&(this.value+=":",this.value+=ve),this.value+="}",this}};e.$6J=z,e.$6J=z=f=Ke([L],z);var V;(function(H){H[H.Unnecessary=1]="Unnecessary",H[H.Deprecated=2]="Deprecated"})(V||(e.DiagnosticTag=V={}));var G;(function(H){H[H.Hint=3]="Hint",H[H.Information=2]="Information",H[H.Warning=1]="Warning",H[H.Error=0]="Error"})(G||(e.DiagnosticSeverity=G={}));let ae=t=class{static isLocation(W){return W instanceof t?!0:W?B.isRange(W.range)&&$.URI.isUri(W.uri):!1}constructor(W,ve){if(this.uri=W,ve)if(B.isRange(ve))this.range=B.of(ve);else if(O.isPosition(ve))this.range=new B(ve,ve);else throw new Error("Illegal argument")}toJSON(){return{uri:this.uri,range:this.range}}};e.$7J=ae,e.$7J=ae=t=Ke([L],ae);let ne=class{static is(W){return W?typeof W.message=="string"&&W.location&&B.isRange(W.location.range)&&$.URI.isUri(W.location.uri):!1}constructor(W,ve){this.location=W,this.message=ve}static isEqual(W,ve){return W===ve?!0:!W||!ve?!1:W.message===ve.message&&W.location.range.isEqual(ve.location.range)&&W.location.uri.toString()===ve.location.uri.toString()}};e.$8J=ne,e.$8J=ne=Ke([L],ne);let he=class{constructor(W,ve,Re=G.Error){if(!B.isRange(W))throw new TypeError("range must be set");if(!ve)throw new TypeError("message must be set");this.range=W,this.message=ve,this.severity=Re}toJSON(){return{severity:G[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(W,ve){return W===ve?!0:!W||!ve?!1:W.message===ve.message&&W.severity===ve.severity&&W.code===ve.code&&W.severity===ve.severity&&W.source===ve.source&&W.range.isEqual(ve.range)&&(0,D.$of)(W.tags,ve.tags)&&(0,D.$of)(W.relatedInformation,ve.relatedInformation,ne.isEqual)}};e.$9J=he,e.$9J=he=Ke([L],he);let Ee=class{constructor(W,ve){if(!W)throw new Error("Illegal argument, contents must be defined");Array.isArray(W)?this.contents=W:this.contents=[W],this.range=ve}};e.$0J=Ee,e.$0J=Ee=Ke([L],Ee);var de;(function(H){H[H.Text=0]="Text",H[H.Read=1]="Read",H[H.Write=2]="Write"})(de||(e.DocumentHighlightKind=de={}));let ge=class{constructor(W,ve=de.Text){this.range=W,this.kind=ve}toJSON(){return{range:this.range,kind:de[this.kind]}}};e.$$J=ge,e.$$J=ge=Ke([L],ge);var ie;(function(H){H[H.File=0]="File",H[H.Module=1]="Module",H[H.Namespace=2]="Namespace",H[H.Package=3]="Package",H[H.Class=4]="Class",H[H.Method=5]="Method",H[H.Property=6]="Property",H[H.Field=7]="Field",H[H.Constructor=8]="Constructor",H[H.Enum=9]="Enum",H[H.Interface=10]="Interface",H[H.Function=11]="Function",H[H.Variable=12]="Variable",H[H.Constant=13]="Constant",H[H.String=14]="String",H[H.Number=15]="Number",H[H.Boolean=16]="Boolean",H[H.Array=17]="Array",H[H.Object=18]="Object",H[H.Key=19]="Key",H[H.Null=20]="Null",H[H.EnumMember=21]="EnumMember",H[H.Struct=22]="Struct",H[H.Event=23]="Event",H[H.Operator=24]="Operator",H[H.TypeParameter=25]="TypeParameter"})(ie||(e.SymbolKind=ie={}));var ue;(function(H){H[H.Deprecated=1]="Deprecated"})(ue||(e.SymbolTag=ue={}));let we=s=class{static validate(W){if(!W.name)throw new Error("name must not be falsy")}constructor(W,ve,Re,Ze,tt){this.name=W,this.kind=ve,this.containerName=tt,typeof Re=="string"&&(this.containerName=Re),Ze instanceof ae?this.location=Ze:Re instanceof B&&(this.location=new ae(Ze,Re)),s.validate(this)}toJSON(){return{name:this.name,kind:ie[this.kind],location:this.location,containerName:this.containerName}}};e.$_J=we,e.$_J=we=s=Ke([L],we);let Pe=o=class{static validate(W){if(!W.name)throw new Error("name must not be falsy");if(!W.range.contains(W.selectionRange))throw new Error("selectionRange must be contained in fullRange");W.children?.forEach(o.validate)}constructor(W,ve,Re,Ze,tt){this.name=W,this.detail=ve,this.kind=Re,this.range=Ze,this.selectionRange=tt,this.children=[],o.validate(this)}};e.$aK=Pe,e.$aK=Pe=o=Ke([L],Pe);var U;(function(H){H[H.Invoke=1]="Invoke",H[H.Automatic=2]="Automatic"})(U||(e.CodeActionTriggerKind=U={}));let Z=class{constructor(W,ve){this.title=W,this.kind=ve}};e.$bK=Z,e.$bK=Z=Ke([L],Z);let X=class{static{n=this}static{this.c="."}constructor(W){this.value=W}append(W){return new n(this.value?this.value+n.c+W:W)}intersects(W){return this.contains(W)||W.contains(this)}contains(W){return this.value===W.value||W.value.startsWith(this.value+n.c)}};e.$cK=X,e.$cK=X=n=Ke([L],X);class oe extends X{constructor(W){super(W),this.value=W}}e.$dK=oe,X.Empty=new X(""),X.QuickFix=X.Empty.append("quickfix"),X.Refactor=X.Empty.append("refactor"),X.RefactorExtract=X.Refactor.append("extract"),X.RefactorInline=X.Refactor.append("inline"),X.RefactorMove=X.Refactor.append("move"),X.RefactorRewrite=X.Refactor.append("rewrite"),X.Source=X.Empty.append("source"),X.SourceOrganizeImports=X.Source.append("organizeImports"),X.SourceFixAll=X.Source.append("fixAll"),X.Notebook=X.Empty.append("notebook");let Y=class{constructor(W,ve){if(this.range=W,this.parent=ve,ve&&!ve.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};e.$eK=Y,e.$eK=Y=Ke([L],Y);class fe{constructor(W,ve,Re,Ze,tt,at){this.kind=W,this.name=ve,this.detail=Re,this.uri=Ze,this.range=tt,this.selectionRange=at}}e.$fK=fe;class ye{constructor(W,ve){this.fromRanges=ve,this.from=W}}e.$gK=ye;class ze{constructor(W,ve){this.fromRanges=ve,this.to=W}}e.$hK=ze;var Be;(function(H){H[H.Information=0]="Information",H[H.Warning=1]="Warning",H[H.Error=2]="Error"})(Be||(e.LanguageStatusSeverity=Be={}));let xe=class{constructor(W,ve){this.range=W,this.command=ve}get isResolved(){return!!this.command}};e.$iK=xe,e.$iK=xe=Ke([L],xe);let Ye=c=class{#e;static isMarkdownString(W){return W instanceof c?!0:W&&W.appendCodeblock&&W.appendMarkdown&&W.appendText&&W.value!==void 0}constructor(W,ve=!1){this.#e=new h.$Vj(W,{supportThemeIcons:ve})}get value(){return this.#e.value}set value(W){this.#e.value=W}get isTrusted(){return this.#e.isTrusted}set isTrusted(W){this.#e.isTrusted=W}get supportThemeIcons(){return this.#e.supportThemeIcons}set supportThemeIcons(W){this.#e.supportThemeIcons=W}get supportHtml(){return this.#e.supportHtml}set supportHtml(W){this.#e.supportHtml=W}get baseUri(){return this.#e.baseUri}set baseUri(W){this.#e.baseUri=W}appendText(W){return this.#e.appendText(W),this}appendMarkdown(W){return this.#e.appendMarkdown(W),this}appendCodeblock(W,ve){return this.#e.appendCodeblock(ve??"",W),this}};e.$jK=Ye,e.$jK=Ye=c=Ke([L],Ye);let it=class{constructor(W,ve){this.label=W,this.documentation=ve}};e.$kK=it,e.$kK=it=Ke([L],it);let et=class{constructor(W,ve){this.label=W,this.documentation=ve,this.parameters=[]}};e.$lK=et,e.$lK=et=Ke([L],et);let Ae=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};e.$mK=Ae,e.$mK=Ae=Ke([L],Ae);var Ne;(function(H){H[H.Invoke=1]="Invoke",H[H.TriggerCharacter=2]="TriggerCharacter",H[H.ContentChange=3]="ContentChange"})(Ne||(e.SignatureHelpTriggerKind=Ne={}));var We;(function(H){H[H.Type=1]="Type",H[H.Parameter=2]="Parameter"})(We||(e.InlayHintKind=We={}));let Le=class{constructor(W){this.value=W}};e.$nK=Le,e.$nK=Le=Ke([L],Le);let Qe=class{constructor(W,ve,Re){this.position=W,this.label=ve,this.kind=Re}};e.$oK=Qe,e.$oK=Qe=Ke([L],Qe);var le;(function(H){H[H.Invoke=0]="Invoke",H[H.TriggerCharacter=1]="TriggerCharacter",H[H.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(le||(e.CompletionTriggerKind=le={}));var se;(function(H){H[H.Text=0]="Text",H[H.Method=1]="Method",H[H.Function=2]="Function",H[H.Constructor=3]="Constructor",H[H.Field=4]="Field",H[H.Variable=5]="Variable",H[H.Class=6]="Class",H[H.Interface=7]="Interface",H[H.Module=8]="Module",H[H.Property=9]="Property",H[H.Unit=10]="Unit",H[H.Value=11]="Value",H[H.Enum=12]="Enum",H[H.Keyword=13]="Keyword",H[H.Snippet=14]="Snippet",H[H.Color=15]="Color",H[H.File=16]="File",H[H.Reference=17]="Reference",H[H.Folder=18]="Folder",H[H.EnumMember=19]="EnumMember",H[H.Constant=20]="Constant",H[H.Struct=21]="Struct",H[H.Event=22]="Event",H[H.Operator=23]="Operator",H[H.TypeParameter=24]="TypeParameter",H[H.User=25]="User",H[H.Issue=26]="Issue"})(se||(e.CompletionItemKind=se={}));var Ie;(function(H){H[H.Deprecated=1]="Deprecated"})(Ie||(e.CompletionItemTag=Ie={}));let qe=class{constructor(W,ve){this.label=W,this.kind=ve}toJSON(){return{label:this.label,kind:this.kind&&se[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};e.$pK=qe,e.$pK=qe=Ke([L],qe);let je=class{constructor(W=[],ve=!1){this.items=W,this.isIncomplete=ve}};e.$qK=je,e.$qK=je=Ke([L],je);let Xe=class{constructor(W,ve,Re){this.insertText=W,this.range=ve,this.command=Re}};e.$rK=Xe,e.$rK=Xe=Ke([L],Xe);let nt=class{constructor(W){this.commands=void 0,this.suppressSuggestions=void 0,this.items=W}};e.$sK=nt,e.$sK=nt=Ke([L],nt);var ot;(function(H){H[H.Active=-1]="Active",H[H.Beside=-2]="Beside",H[H.One=1]="One",H[H.Two=2]="Two",H[H.Three=3]="Three",H[H.Four=4]="Four",H[H.Five=5]="Five",H[H.Six=6]="Six",H[H.Seven=7]="Seven",H[H.Eight=8]="Eight",H[H.Nine=9]="Nine"})(ot||(e.ViewColumn=ot={}));var bt;(function(H){H[H.Left=1]="Left",H[H.Right=2]="Right"})(bt||(e.StatusBarAlignment=bt={}));function Dt(H,W){return`${I.$Tl.toKey(H)}.${W}`}e.$tK=Dt;var Qt;(function(H){H[H.Off=0]="Off",H[H.On=1]="On",H[H.Relative=2]="Relative"})(Qt||(e.TextEditorLineNumbersStyle=Qt={}));var Vt;(function(H){H[H.Manual=1]="Manual",H[H.AfterDelay=2]="AfterDelay",H[H.FocusOut=3]="FocusOut"})(Vt||(e.TextDocumentSaveReason=Vt={}));var vt;(function(H){H[H.Default=0]="Default",H[H.InCenter=1]="InCenter",H[H.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",H[H.AtTop=3]="AtTop"})(vt||(e.TextEditorRevealType=vt={}));var Tt;(function(H){H[H.Keyboard=1]="Keyboard",H[H.Mouse=2]="Mouse",H[H.Command=3]="Command"})(Tt||(e.TextEditorSelectionChangeKind=Tt={}));var Nt;(function(H){H[H.Undo=1]="Undo",H[H.Redo=2]="Redo"})(Nt||(e.TextDocumentChangeReason=Nt={}));var Kt;(function(H){H[H.OpenOpen=0]="OpenOpen",H[H.ClosedClosed=1]="ClosedClosed",H[H.OpenClosed=2]="OpenClosed",H[H.ClosedOpen=3]="ClosedOpen"})(Kt||(e.DecorationRangeBehavior=Kt={})),function(H){function W(ve){switch(ve){case"keyboard":return H.Keyboard;case"mouse":return H.Mouse;case"api":return H.Command}}H.fromValue=W}(Tt||(e.TextEditorSelectionChangeKind=Tt={}));let At=class{constructor(W,ve){if(ve&&!$.URI.isUri(ve))throw(0,M.$5)("target");if(!B.isRange(W)||W.isEmpty)throw(0,M.$5)("range");this.range=W,this.target=ve}};e.$uK=At,e.$uK=At=Ke([L],At);let Rt=class{constructor(W,ve,Re,Ze){this.red=W,this.green=ve,this.blue=Re,this.alpha=Ze}};e.$vK=Rt,e.$vK=Rt=Ke([L],Rt);let Ot=class{constructor(W,ve){if(ve&&!(ve instanceof Rt))throw(0,M.$5)("color");if(!B.isRange(W)||W.isEmpty)throw(0,M.$5)("range");this.range=W,this.color=ve}};e.$wK=Ot,e.$wK=Ot=Ke([L],Ot);let Ut=class{constructor(W){if(!W||typeof W!="string")throw(0,M.$5)("label");this.label=W}};e.$xK=Ut,e.$xK=Ut=Ke([L],Ut);var qt;(function(H){H[H.RGB=0]="RGB",H[H.HEX=1]="HEX",H[H.HSL=2]="HSL"})(qt||(e.ColorFormat=qt={}));var Bt;(function(H){H[H.Error=0]="Error",H[H.Warning=1]="Warning",H[H.Information=2]="Information"})(Bt||(e.SourceControlInputBoxValidationType=Bt={}));var ct;(function(H){H[H.Unknown=0]="Unknown",H[H.Shutdown=1]="Shutdown",H[H.Process=2]="Process",H[H.User=3]="User",H[H.Extension=4]="Extension"})(ct||(e.TerminalExitReason=ct={}));class lt{constructor(W,ve,Re){if(this.startIndex=W,this.length=ve,this.tooltip=Re,typeof W!="number"||W<0)throw(0,M.$5)("startIndex");if(typeof ve!="number"||ve<1)throw(0,M.$5)("length");if(Re!==void 0&&typeof Re!="string")throw(0,M.$5)("tooltip")}}e.$yK=lt;class Jt{constructor(W){this.uri=W}}e.$zK=Jt;class Pt{constructor(W){this.terminalCommand=W}}e.$AK=Pt;var kt;(function(H){H[H.Panel=1]="Panel",H[H.Editor=2]="Editor"})(kt||(e.TerminalLocation=kt={}));class dt{constructor(W){if(this.options=W,typeof W!="object")throw(0,M.$5)("options")}}e.$BK=dt;var Ct;(function(H){H[H.Always=1]="Always",H[H.Silent=2]="Silent",H[H.Never=3]="Never"})(Ct||(e.TaskRevealKind=Ct={}));var Ft;(function(H){H[H.Shared=1]="Shared",H[H.Dedicated=2]="Dedicated",H[H.New=3]="New"})(Ft||(e.TaskPanelKind=Ft={}));let Et=class{static{d=this}static{this.Clean=new d("clean","Clean")}static{this.Build=new d("build","Build")}static{this.Rebuild=new d("rebuild","Rebuild")}static{this.Test=new d("test","Test")}static from(W){switch(W){case"clean":return d.Clean;case"build":return d.Build;case"rebuild":return d.Rebuild;case"test":return d.Test;default:return}}constructor(W,ve){if(this.label=ve,typeof W!="string"||typeof ve!="string")throw(0,M.$5)("name");this.c=W}get id(){return this.c}};e.$CK=Et,e.$CK=Et=d=Ke([L],Et);function Ge(H){let W="";for(let ve=0;ve<H.length;ve++)W+=H[ve].replace(/,/g,",,")+",";return W}let zt=class{constructor(W,ve,Re){if(typeof W!="string")throw(0,M.$5)("process");this.e=[],this.c=W,ve!==void 0&&(Array.isArray(ve)?(this.e=ve,this.f=Re):this.f=ve)}get process(){return this.c}set process(W){if(typeof W!="string")throw(0,M.$5)("process");this.c=W}get args(){return this.e}set args(W){Array.isArray(W)||(W=[]),this.e=W}get options(){return this.f}set options(W){this.f=W}computeId(){const W=[];if(W.push("process"),this.c!==void 0&&W.push(this.c),this.e&&this.e.length>0)for(const ve of this.e)W.push(ve);return Ge(W)}};e.$DK=zt,e.$DK=zt=Ke([L],zt);let Me=class{constructor(W,ve,Re){if(this.f=[],Array.isArray(ve)){if(!W)throw(0,M.$5)("command can't be undefined or null");if(typeof W!="string"&&typeof W.value!="string")throw(0,M.$5)("command");this.e=W,this.f=ve,this.g=Re}else{if(typeof W!="string")throw(0,M.$5)("commandLine");this.c=W,this.g=ve}}get commandLine(){return this.c}set commandLine(W){if(typeof W!="string")throw(0,M.$5)("commandLine");this.c=W}get command(){return this.e?this.e:""}set command(W){if(typeof W!="string"&&typeof W.value!="string")throw(0,M.$5)("command");this.e=W}get args(){return this.f}set args(W){this.f=W||[]}get options(){return this.g}set options(W){this.g=W}computeId(){const W=[];if(W.push("shell"),this.c!==void 0&&W.push(this.c),this.e!==void 0&&W.push(typeof this.e=="string"?this.e:this.e.value),this.f&&this.f.length>0)for(const ve of this.f)W.push(typeof ve=="string"?ve:ve.value);return Ge(W)}};e.$EK=Me,e.$EK=Me=Ke([L],Me);var Te;(function(H){H[H.Escape=1]="Escape",H[H.Strong=2]="Strong",H[H.Weak=3]="Weak"})(Te||(e.ShellQuoting=Te={}));var Se;(function(H){H[H.Global=1]="Global",H[H.Workspace=2]="Workspace"})(Se||(e.TaskScope=Se={}));class te{constructor(W){this.c=W}computeId(){return"customExecution"+(0,P.$6e)()}set callback(W){this.c=W}get callback(){return this.c}}e.$FK=te;let Fe=class{static{v=this}static{this.c="customExecution"}static{this.e="process"}static{this.f="shell"}static{this.g="$empty"}constructor(W,ve,Re,Ze,tt,at){this.j=!1,this.k=this.definition=W;let ht;typeof ve=="string"?(this.m=this.name=ve,this.t=this.source=Re,this.execution=Ze,ht=tt,this.j=!0):ve===Se.Global||ve===Se.Workspace?(this.target=ve,this.m=this.name=Re,this.t=this.source=Ze,this.execution=tt,ht=at):(this.target=ve,this.m=this.name=Re,this.t=this.source=Ze,this.execution=tt,ht=at),typeof ht=="string"?(this.o=[ht],this.q=!0):Array.isArray(ht)?(this.o=ht,this.q=!0):(this.o=[],this.q=!1),this.r=!1,this.v=Object.create(null),this.w=Object.create(null)}get _id(){return this.h}set _id(W){this.h=W}get _deprecated(){return this.j}y(){this.h!==void 0&&(this.h=void 0,this.l=void 0,this.z())}z(){this.n instanceof zt?this.k={type:v.e,id:this.n.computeId()}:this.n instanceof Me?this.k={type:v.f,id:this.n.computeId()}:this.n instanceof te?this.k={type:v.c,id:this.n.computeId()}:this.k={type:v.g,id:(0,P.$6e)()}}get definition(){return this.k}set definition(W){if(W==null)throw(0,M.$5)("Kind can't be undefined or null");this.y(),this.k=W}get scope(){return this.l}set target(W){this.y(),this.l=W}get name(){return this.m}set name(W){if(typeof W!="string")throw(0,M.$5)("name");this.y(),this.m=W}get execution(){return this.n}set execution(W){W===null&&(W=void 0),this.y(),this.n=W;const ve=this.k.type;(v.g===ve||v.e===ve||v.f===ve||v.c===ve)&&this.z()}get problemMatchers(){return this.o}set problemMatchers(W){if(Array.isArray(W))this.y(),this.o=W,this.q=!0;else{this.y(),this.o=[],this.q=!1;return}}get hasDefinedMatchers(){return this.q}get isBackground(){return this.r}set isBackground(W){W!==!0&&W!==!1&&(W=!1),this.y(),this.r=W}get source(){return this.t}set source(W){if(typeof W!="string"||W.length===0)throw(0,M.$5)("source must be a string of length > 0");this.y(),this.t=W}get group(){return this.u}set group(W){W===null&&(W=void 0),this.y(),this.u=W}get detail(){return this.x}set detail(W){W===null&&(W=void 0),this.x=W}get presentationOptions(){return this.v}set presentationOptions(W){W==null&&(W=Object.create(null)),this.y(),this.v=W}get runOptions(){return this.w}set runOptions(W){W==null&&(W=Object.create(null)),this.y(),this.w=W}};e.$GK=Fe,e.$GK=Fe=v=Ke([L],Fe);var He;(function(H){H[H.SourceControl=1]="SourceControl",H[H.Window=10]="Window",H[H.Notification=15]="Notification"})(He||(e.ProgressLocation=He={}));var _e;(function(H){function W(ve){const Re=ve;return(0,E.$pe)(Re.value)?Re.tooltip&&!(0,E.$le)(Re.tooltip)?(console.log("INVALID view badge, invalid tooltip",Re.tooltip),!1):!0:(console.log("INVALID view badge, invalid value",Re.value),!1)}H.isViewBadge=W})(_e||(e.ViewBadge=_e={}));let Je=k=class{static isTreeItem(W,ve){const Re=W;if(Re.checkboxState!==void 0){const Ze=(0,E.$pe)(Re.checkboxState)?Re.checkboxState:(0,E.$ne)(Re.checkboxState)&&(0,E.$pe)(Re.checkboxState.state)?Re.checkboxState.state:void 0,tt=!(0,E.$pe)(Re.checkboxState)&&(0,E.$ne)(Re.checkboxState)?Re.checkboxState.tooltip:void 0;if(Ze===void 0||Ze!==pt.Checked&&Ze!==pt.Unchecked||tt!==void 0&&!(0,E.$le)(tt))return console.log("INVALID tree item, invalid checkboxState",Re.checkboxState),!1}if(W instanceof k)return!0;if(Re.label!==void 0&&!(0,E.$le)(Re.label)&&!Re.label?.label)return console.log("INVALID tree item, invalid label",Re.label),!1;if(Re.id!==void 0&&!(0,E.$le)(Re.id))return console.log("INVALID tree item, invalid id",Re.id),!1;if(Re.iconPath!==void 0&&!(0,E.$le)(Re.iconPath)&&!$.URI.isUri(Re.iconPath)&&(!Re.iconPath||!(0,E.$le)(Re.iconPath.id))){const Ze=Re.iconPath;if(!Ze||!(0,E.$le)(Ze.light)&&!$.URI.isUri(Ze.light)&&!(0,E.$le)(Ze.dark)&&!$.URI.isUri(Ze.dark))return console.log("INVALID tree item, invalid iconPath",Re.iconPath),!1}return Re.description!==void 0&&!(0,E.$le)(Re.description)&&typeof Re.description!="boolean"?(console.log("INVALID tree item, invalid description",Re.description),!1):Re.resourceUri!==void 0&&!$.URI.isUri(Re.resourceUri)?(console.log("INVALID tree item, invalid resourceUri",Re.resourceUri),!1):Re.tooltip!==void 0&&!(0,E.$le)(Re.tooltip)&&!(Re.tooltip instanceof Ye)?(console.log("INVALID tree item, invalid tooltip",Re.tooltip),!1):Re.command!==void 0&&!Re.command.command?(console.log("INVALID tree item, invalid command",Re.command),!1):Re.collapsibleState!==void 0&&Re.collapsibleState<rt.None&&Re.collapsibleState>rt.Expanded?(console.log("INVALID tree item, invalid collapsibleState",Re.collapsibleState),!1):Re.contextValue!==void 0&&!(0,E.$le)(Re.contextValue)?(console.log("INVALID tree item, invalid contextValue",Re.contextValue),!1):Re.accessibilityInformation!==void 0&&!Re.accessibilityInformation?.label?(console.log("INVALID tree item, invalid accessibilityInformation",Re.accessibilityInformation),!1):!0}constructor(W,ve=rt.None){this.collapsibleState=ve,$.URI.isUri(W)?this.resourceUri=W:this.label=W}};e.$HK=Je,e.$HK=Je=k=Ke([L],Je);var rt;(function(H){H[H.None=0]="None",H[H.Collapsed=1]="Collapsed",H[H.Expanded=2]="Expanded"})(rt||(e.TreeItemCollapsibleState=rt={}));var pt;(function(H){H[H.Unchecked=0]="Unchecked",H[H.Checked=1]="Checked"})(pt||(e.TreeItemCheckboxState=pt={}));let wt=class{async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}constructor(W){this.value=W}};e.$IK=wt,e.$IK=wt=Ke([L],wt);class ft extends wt{}e.$JK=ft;class gt extends ft{#e;constructor(W){super(""),this.#e=W}asFile(){return this.#e}}e.$KK=gt;class mt{constructor(W,ve,Re,Ze){this.name=W,this.uri=ve,this._itemId=Re,this.c=Ze}data(){return this.c()}}e.$LK=mt;let gi=class{#e=new Map;constructor(W){for(const[ve,Re]of W??[]){const Ze=this.#e.get(this.#t(ve));Ze?Ze.push(Re):this.#e.set(this.#t(ve),[Re])}}get(W){return this.#e.get(this.#t(W))?.[0]}set(W,ve){this.#e.set(this.#t(W),[ve])}forEach(W,ve){for(const[Re,Ze]of this.#e)for(const tt of Ze)W.call(ve,tt,Re,this)}*[Symbol.iterator](){for(const[W,ve]of this.#e)for(const Re of ve)yield[W,Re]}#t(W){return W.toLowerCase()}};e.$MK=gi,e.$MK=gi=Ke([L],gi);let Ht=class{constructor(W){this.insertText=W}};e.$NK=Ht,e.$NK=Ht=Ke([L],Ht);let Ei=class{constructor(W,ve){this.label=ve,this.insertText=W}};e.$OK=Ei,e.$OK=Ei=Ke([L],Ei);let Wt=class{constructor(W,ve){this.id=W,this.color=ve}static isThemeIcon(W){return typeof W.id!="string"?(console.log("INVALID ThemeIcon, invalid id",W.id),!1):!0}};e.$PK=Wt,e.$PK=Wt=Ke([L],Wt),Wt.File=new Wt("file"),Wt.Folder=new Wt("folder");let mi=class{constructor(W){this.id=W}};e.$QK=mi,e.$QK=mi=Ke([L],mi);var It;(function(H){H[H.Global=1]="Global",H[H.Workspace=2]="Workspace",H[H.WorkspaceFolder=3]="WorkspaceFolder"})(It||(e.ConfigurationTarget=It={}));let ki=class{get base(){return this.c}set base(W){this.c=W,this.e=$.URI.file(W)}get baseUri(){return this.e}set baseUri(W){this.e=W,this.c=W.fsPath}constructor(W,ve){if(typeof W!="string"&&(!W||!$.URI.isUri(W)&&!$.URI.isUri(W.uri)))throw(0,M.$5)("base");if(typeof ve!="string")throw(0,M.$5)("pattern");typeof W=="string"?this.baseUri=$.URI.file(W):$.URI.isUri(W)?this.baseUri=W:this.baseUri=W.uri,this.pattern=ve}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};e.$RK=ki,e.$RK=ki=Ke([L],ki);const Vi=new WeakMap;function St(H,W){Vi.set(H,W)}e.$SK=St;let ti=class{constructor(W,ve,Re,Ze){this.enabled=typeof W=="boolean"?W:!0,typeof ve=="string"&&(this.condition=ve),typeof Re=="string"&&(this.hitCondition=Re),typeof Ze=="string"&&(this.logMessage=Ze)}get id(){return this.c||(this.c=Vi.get(this)??(0,P.$6e)()),this.c}};e.$TK=ti,e.$TK=ti=Ke([L],ti);let $i=class extends ti{constructor(W,ve,Re,Ze,tt){if(super(ve,Re,Ze,tt),W===null)throw(0,M.$5)("location");this.location=W}};e.$UK=$i,e.$UK=$i=Ke([L],$i);let si=class extends ti{constructor(W,ve,Re,Ze,tt){super(ve,Re,Ze,tt),this.functionName=W}};e.$VK=si,e.$VK=si=Ke([L],si);let Si=class extends ti{constructor(W,ve,Re,Ze,tt,at,ht){if(super(Ze,tt,at,ht),!ve)throw(0,M.$5)("dataId");this.label=W,this.dataId=ve,this.canPersist=Re}};e.$WK=Si,e.$WK=Si=Ke([L],Si);let Di=class{constructor(W,ve,Re){this.command=W,this.args=ve||[],this.options=Re}};e.$XK=Di,e.$XK=Di=Ke([L],Di);let Lt=class{constructor(W,ve){this.port=W,this.host=ve}};e.$YK=Lt,e.$YK=Lt=Ke([L],Lt);let bi=class{constructor(W){this.path=W}};e.$ZK=bi,e.$ZK=bi=Ke([L],bi);let Ci=class{constructor(W){this.implementation=W}};e.$1K=Ci,e.$1K=Ci=Ke([L],Ci);let oi=class{constructor(W,ve,Re){this.session=W,this.threadId=ve,this.frameId=Re}};e.$2K=oi,e.$2K=oi=Ke([L],oi);let ai=class{constructor(W,ve){this.session=W,this.threadId=ve}};e.$3K=ai,e.$3K=ai=Ke([L],ai);let ut=class{constructor(W,ve){this.range=W,this.expression=ve}};e.$4K=ut,e.$4K=ut=Ke([L],ut);var qi;(function(H){H[H.Invoke=0]="Invoke",H[H.Automatic=1]="Automatic"})(qi||(e.InlineCompletionTriggerKind=qi={}));let Yt=class{constructor(W,ve){this.range=W,this.text=ve}};e.$5K=Yt,e.$5K=Yt=Ke([L],Yt);let ii=class{constructor(W,ve,Re=!0){this.range=W,this.variableName=ve,this.caseSensitiveLookup=Re}};e.$6K=ii,e.$6K=ii=Ke([L],ii);let pi=class{constructor(W,ve){this.range=W,this.expression=ve}};e.$7K=pi,e.$7K=pi=Ke([L],pi);let Ii=class{constructor(W,ve){this.frameId=W,this.stoppedLocation=ve}};e.$8K=Ii,e.$8K=Ii=Ke([L],Ii);var Hi;(function(H){H[H.Changed=1]="Changed",H[H.Created=2]="Created",H[H.Deleted=3]="Deleted"})(Hi||(e.FileChangeType=Hi={}));let Pi=u=class extends Error{static FileExists(W){return new u(W,b.FileSystemProviderErrorCode.FileExists,u.FileExists)}static FileNotFound(W){return new u(W,b.FileSystemProviderErrorCode.FileNotFound,u.FileNotFound)}static FileNotADirectory(W){return new u(W,b.FileSystemProviderErrorCode.FileNotADirectory,u.FileNotADirectory)}static FileIsADirectory(W){return new u(W,b.FileSystemProviderErrorCode.FileIsADirectory,u.FileIsADirectory)}static NoPermissions(W){return new u(W,b.FileSystemProviderErrorCode.NoPermissions,u.NoPermissions)}static Unavailable(W){return new u(W,b.FileSystemProviderErrorCode.Unavailable,u.Unavailable)}constructor(W,ve=b.FileSystemProviderErrorCode.Unknown,Re){super($.URI.isUri(W)?W.toString(!0):W),this.code=Re?.name??"Unknown",(0,b.$fk)(this,ve),Object.setPrototypeOf(this,u.prototype),typeof Error.captureStackTrace=="function"&&typeof Re=="function"&&Error.captureStackTrace(this,Re)}};e.$9K=Pi,e.$9K=Pi=u=Ke([L],Pi);let wi=class{constructor(W,ve,Re){this.start=W,this.end=ve,this.kind=Re}};e.$0K=wi,e.$0K=wi=Ke([L],wi);var Ki;(function(H){H[H.Comment=1]="Comment",H[H.Imports=2]="Imports",H[H.Region=3]="Region"})(Ki||(e.FoldingRangeKind=Ki={}));var Ai;(function(H){H[H.Collapsed=0]="Collapsed",H[H.Expanded=1]="Expanded"})(Ai||(e.CommentThreadCollapsibleState=Ai={}));var ci;(function(H){H[H.Editing=0]="Editing",H[H.Preview=1]="Preview"})(ci||(e.CommentMode=ci={}));var Ji;(function(H){H[H.Published=0]="Published",H[H.Draft=1]="Draft"})(Ji||(e.CommentState=Ji={}));var vi;(function(H){H[H.Unresolved=0]="Unresolved",H[H.Resolved=1]="Resolved"})(vi||(e.CommentThreadState=vi={}));class Ri{constructor(W,ve=[]){this.tokenTypes=W,this.tokenModifiers=ve}}e.$$K=Ri;function cn(H){return typeof H>"u"||(0,E.$me)(H)}class Li{constructor(W){if(this.c=0,this.e=0,this.f=!0,this.g=[],this.h=0,this.j=new Map,this.k=new Map,this.l=!1,W){this.l=!0;for(let ve=0,Re=W.tokenTypes.length;ve<Re;ve++)this.j.set(W.tokenTypes[ve],ve);for(let ve=0,Re=W.tokenModifiers.length;ve<Re;ve++)this.k.set(W.tokenModifiers[ve],ve)}}push(W,ve,Re,Ze,tt){if(typeof W=="number"&&typeof ve=="number"&&typeof Re=="number"&&typeof Ze=="number"&&(typeof tt=="number"||typeof tt>"u"))return typeof tt>"u"&&(tt=0),this.n(W,ve,Re,Ze,tt);if(B.isRange(W)&&typeof ve=="string"&&cn(Re))return this.m(W,ve,Re);throw(0,M.$5)()}m(W,ve,Re){if(!this.l)throw new Error("Legend must be provided in constructor");if(W.start.line!==W.end.line)throw new Error("`range` cannot span multiple lines");if(!this.j.has(ve))throw new Error("`tokenType` is not in the provided legend");const Ze=W.start.line,tt=W.start.character,at=W.end.character-W.start.character,ht=this.j.get(ve);let jt=0;if(Re)for(const Zt of Re){if(!this.k.has(Zt))throw new Error("`tokenModifier` is not in the provided legend");const _t=this.k.get(Zt);jt|=1<<_t>>>0}this.n(Ze,tt,at,ht,jt)}n(W,ve,Re,Ze,tt){if(this.f&&(W<this.c||W===this.c&&ve<this.e)){this.f=!1;const jt=this.g.length/5|0;let Zt=0,_t=0;for(let ei=0;ei<jt;ei++){let ri=this.g[5*ei],Bi=this.g[5*ei+1];ri===0?(ri=Zt,Bi+=_t):ri+=Zt,this.g[5*ei]=ri,this.g[5*ei+1]=Bi,Zt=ri,_t=Bi}}let at=W,ht=ve;this.f&&this.h>0&&(at-=this.c,at===0&&(ht-=this.e)),this.g[this.h++]=at,this.g[this.h++]=ht,this.g[this.h++]=Re,this.g[this.h++]=Ze,this.g[this.h++]=tt,this.c=W,this.e=ve}static o(W){const ve=[],Re=W.length/5|0;for(let ht=0;ht<Re;ht++)ve[ht]=ht;ve.sort((ht,jt)=>{const Zt=W[5*ht],_t=W[5*jt];if(Zt===_t){const ei=W[5*ht+1],ri=W[5*jt+1];return ei-ri}return Zt-_t});const Ze=new Uint32Array(W.length);let tt=0,at=0;for(let ht=0;ht<Re;ht++){const jt=5*ve[ht],Zt=W[jt+0],_t=W[jt+1],ei=W[jt+2],ri=W[jt+3],Bi=W[jt+4],vn=Zt-tt,Ln=vn===0?_t-at:_t,Wi=5*ht;Ze[Wi+0]=vn,Ze[Wi+1]=Ln,Ze[Wi+2]=ei,Ze[Wi+3]=ri,Ze[Wi+4]=Bi,tt=Zt,at=_t}return Ze}build(W){return this.f?new ni(new Uint32Array(this.g),W):new ni(Li.o(this.g),W)}}e.$_K=Li;class ni{constructor(W,ve){this.resultId=ve,this.data=W}}e.$aL=ni;class un{constructor(W,ve,Re){this.start=W,this.deleteCount=ve,this.data=Re}}e.$bL=un;class ln{constructor(W,ve){this.resultId=ve,this.edits=W}}e.$cL=ln;var Gi;(function(H){H[H.Separate=0]="Separate",H[H.MergeWithParent=1]="MergeWithParent"})(Gi||(e.DebugConsoleMode=Gi={}));let fi=class{static{this.Back={iconPath:new Wt("arrow-left")}}constructor(){}};e.$dL=fi,e.$dL=fi=Ke([L],fi);var Zi;(function(H){H[H.Separator=-1]="Separator",H[H.Default=0]="Default"})(Zi||(e.QuickPickItemKind=Zi={}));var Qi;(function(H){H[H.Info=1]="Info",H[H.Warning=2]="Warning",H[H.Error=3]="Error"})(Qi||(e.InputBoxValidationSeverity=Qi={}));var ui;(function(H){H[H.UI=1]="UI",H[H.Workspace=2]="Workspace"})(ui||(e.ExtensionKind=ui={}));class Yi{static validate(W){if(typeof W.badge=="string"){let ve=(0,g.$Yd)(W.badge,0);if(ve<W.badge.length&&(ve+=(0,g.$Yd)(W.badge,ve)),W.badge.length>ve)throw new Error("The 'badge'-property must be undefined or a short character")}else if(W.badge&&!Wt.isThemeIcon(W.badge))throw new Error("The 'badge'-property is not a valid ThemeIcon");if(!W.color&&!W.badge&&!W.tooltip)throw new Error("The decoration is empty");return!0}constructor(W,ve,Re){this.badge=W,this.tooltip=ve,this.color=Re}}e.$eL=Yi;let Mi=class{constructor(W){this.kind=W}};e.$fL=Mi,e.$fL=Mi=Ke([L],Mi);var Xi;(function(H){H[H.Light=1]="Light",H[H.Dark=2]="Dark",H[H.HighContrast=3]="HighContrast",H[H.HighContrastLight=4]="HighContrastLight"})(Xi||(e.ColorThemeKind=Xi={}));class Xt{static isNotebookRange(W){return W instanceof Xt?!0:W?typeof W.start=="number"&&typeof W.end=="number":!1}get start(){return this.c}get end(){return this.e}get isEmpty(){return this.c===this.e}constructor(W,ve){if(W<0)throw(0,M.$5)("start must be positive");if(ve<0)throw(0,M.$5)("end must be positive");W<=ve?(this.c=W,this.e=ve):(this.c=ve,this.e=W)}with(W){let ve=this.c,Re=this.e;return W.start!==void 0&&(ve=W.start),W.end!==void 0&&(Re=W.end),ve===this.c&&Re===this.e?this:new Xt(ve,Re)}}e.$gL=Xt;class yi{static validate(W){if(typeof W.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof W.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof W.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(W){return Array.isArray(W)&&W.every(ve=>yi.isNotebookCellData(ve))}static isNotebookCellData(W){return!0}constructor(W,ve,Re,Ze,tt,at,ht){this.kind=W,this.value=ve,this.languageId=Re,this.mime=Ze,this.outputs=tt??[],this.metadata=at,this.executionSummary=ht,yi.validate(this)}}e.$hL=yi;class hn{constructor(W){this.cells=W}}e.$iL=hn;class Gt{static isNotebookCellOutputItem(W){return W instanceof Gt?!0:W?typeof W.mime=="string"&&W.data instanceof Uint8Array:!1}static error(W){const ve={name:W.name,message:W.message,stack:W.stack};return Gt.json(ve,"application/vnd.code.notebook.error")}static stdout(W){return Gt.text(W,"application/vnd.code.notebook.stdout")}static stderr(W){return Gt.text(W,"application/vnd.code.notebook.stderr")}static bytes(W,ve="application/octet-stream"){return new Gt(W,ve)}static#e=new TextEncoder;static text(W,ve=A.$Er.text){const Re=Gt.#e.encode(String(W));return new Gt(Re,ve)}static json(W,ve="text/x-json"){const Re=JSON.stringify(W,void 0,"	");return Gt.text(Re,ve)}constructor(W,ve){this.data=W,this.mime=ve;const Re=(0,A.$Ir)(ve,!0);if(!Re)throw new Error(`INVALID mime type: ${ve}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=Re}}e.$jL=Gt;class li{static isNotebookCellOutput(W){return W instanceof li?!0:!W||typeof W!="object"?!1:typeof W.id=="string"&&Array.isArray(W.items)}static ensureUniqueMimeTypes(W,ve=!1){const Re=new Set,Ze=new Set;for(let tt=0;tt<W.length;tt++){const at=W[tt],ht=(0,A.$Ir)(at.mime);if(!Re.has(ht)||(0,C.$ZH)(ht)){Re.add(ht);continue}Ze.add(tt),ve&&console.warn(`DUPLICATED mime type '${at.mime}' will be dropped`)}return Ze.size===0?W:W.filter((tt,at)=>!Ze.has(at))}constructor(W,ve,Re){this.items=li.ensureUniqueMimeTypes(W,!0),typeof ve=="string"?(this.id=ve,this.metadata=Re):(this.id=(0,P.$6e)(),this.metadata=ve??Re)}}e.$kL=li;var Ti;(function(H){H[H.Markup=1]="Markup",H[H.Code=2]="Code"})(Ti||(e.NotebookCellKind=Ti={}));var Ue;(function(H){H[H.Idle=1]="Idle",H[H.Pending=2]="Pending",H[H.Executing=3]="Executing"})(Ue||(e.NotebookCellExecutionState=Ue={}));var xt;(function(H){H[H.Left=1]="Left",H[H.Right=2]="Right"})(xt||(e.NotebookCellStatusBarAlignment=xt={}));var Fi;(function(H){H[H.Default=0]="Default",H[H.InCenter=1]="InCenter",H[H.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",H[H.AtTop=3]="AtTop"})(Fi||(e.NotebookEditorRevealType=Fi={}));class $t{constructor(W,ve){this.text=W,this.alignment=ve}}e.$lL=$t;var xi;(function(H){H[H.Default=1]="Default",H[H.Preferred=2]="Preferred"})(xi||(e.NotebookControllerAffinity=xi={}));var _i;(function(H){H[H.Default=1]="Default",H[H.Preferred=2]="Preferred",H[H.Hidden=-1]="Hidden"})(_i||(e.NotebookControllerAffinity2=_i={}));class en{constructor(W,ve=[]){this.uri=W,this.provides=(0,D.$Vf)(ve)}}e.$mL=en;class dn{constructor(W){this.label=W}}e.$nL=dn;let hi=class{constructor(W,ve){this.label=W,this.timestamp=ve}};e.$oL=hi,e.$oL=hi=Ke([L],hi);var tn;(function(H){H[H.Production=1]="Production",H[H.Development=2]="Development",H[H.Test=3]="Test"})(tn||(e.ExtensionMode=tn={}));var nn;(function(H){H[H.Node=1]="Node",H[H.Webworker=2]="Webworker"})(nn||(e.ExtensionRuntime=nn={}));var rn;(function(H){H[H.Other=0]="Other",H[H.Comment=1]="Comment",H[H.String=2]="String",H[H.RegEx=3]="RegEx"})(rn||(e.StandardTokenType=rn={}));class sn{constructor(W,ve){this.ranges=W,this.wordPattern=ve}}e.$pL=sn;class fn{constructor(W){this.c=W}get autoForwardAction(){return this.c}}e.$qL=fn;var on;(function(H){H[H.Queued=1]="Queued",H[H.Running=2]="Running",H[H.Passed=3]="Passed",H[H.Failed=4]="Failed",H[H.Skipped=5]="Skipped",H[H.Errored=6]="Errored"})(on||(e.TestResultState=on={}));var an;(function(H){H[H.Run=1]="Run",H[H.Debug=2]="Debug",H[H.Coverage=3]="Coverage"})(an||(e.TestRunProfileKind=an={}));let Ni=class{constructor(W=void 0,ve=void 0,Re=void 0,Ze=!1){this.include=W,this.exclude=ve,this.profile=Re,this.continuous=Ze}};e.$rL=Ni,e.$rL=Ni=Ke([L],Ni);let Oi=l=class{static diff(W,ve,Re){const Ze=new l(W);return Ze.expectedOutput=ve,Ze.actualOutput=Re,Ze}constructor(W){this.message=W}};e.$sL=Oi,e.$sL=Oi=l=Ke([L],Oi);let zi=class{constructor(W){this.id=W}};e.$tL=zi,e.$tL=zi=Ke([L],zi);let di=class{constructor(W,ve){this.covered=W,this.total=ve}};e.$uL=di,e.$uL=di=Ke([L],di);let ji=w=class{static fromDetails(W,ve){const Re=new di(0,0),Ze=new di(0,0),tt=new di(0,0);for(const ht of ve)if("branches"in ht){Re.total+=1,Re.covered+=ht.executionCount>0?1:0;for(const jt of ht.branches)Ze.total+=1,Ze.covered+=jt.executionCount>0?1:0}else tt.total+=1,tt.covered+=ht.executionCount>0?1:0;const at=new w(W,Re,Ze.total>0?Ze:void 0,tt.total>0?tt:void 0);return at.detailedCoverage=ve,at}constructor(W,ve,Re,Ze){this.uri=W,this.statementCoverage=ve,this.branchCoverage=Re,this.functionCoverage=Ze}};e.$vL=ji,e.$vL=ji=w=Ke([L],ji);let Ui=class{constructor(W,ve,Re=[]){this.executionCount=W,this.location=ve,this.branches=Re}};e.$wL=Ui,e.$wL=Ui=Ke([L],Ui);let be=class{constructor(W,ve){this.executionCount=W,this.location=ve}};e.$xL=be,e.$xL=be=Ke([L],be);let ke=class{constructor(W,ve){this.executionCount=W,this.location=ve}};e.$yL=ke,e.$yL=ke=Ke([L],ke);var Oe;(function(H){H[H.None=0]="None",H[H.Option=1]="Option",H[H.Default=2]="Default",H[H.Preferred=3]="Preferred"})(Oe||(e.ExternalUriOpenerPriority=Oe={}));var st;(function(H){H[H.Untrusted=0]="Untrusted",H[H.Trusted=1]="Trusted",H[H.Unspecified=2]="Unspecified"})(st||(e.WorkspaceTrustState=st={}));var yt;(function(H){H[H.Notify=1]="Notify",H[H.OpenBrowser=2]="OpenBrowser",H[H.OpenPreview=3]="OpenPreview",H[H.Silent=4]="Silent",H[H.Ignore=5]="Ignore",H[H.OpenBrowserOnce=6]="OpenBrowserOnce"})(yt||(e.PortAutoForwardAction=yt={}));class Mt{constructor(W,ve,Re,Ze,tt,at){this.kind=W,this.name=ve,this.detail=Re,this.uri=Ze,this.range=tt,this.selectionRange=at}}e.$zL=Mt;class yn{constructor(W){this.uri=W}}e.$AL=yn;class En{constructor(W,ve){this.original=W,this.modified=ve}}e.$BL=En;class kn{constructor(W,ve,Re,Ze){this.base=W,this.input1=ve,this.input2=Re,this.result=Ze}}e.$CL=kn;class Sn{constructor(W,ve){this.uri=W,this.viewType=ve}}e.$DL=Sn;class Dn{constructor(W){this.viewType=W}}e.$EL=Dn;class Cn{constructor(W,ve){this.uri=W,this.notebookType=ve}}e.$FL=Cn;class In{constructor(W,ve,Re){this.original=W,this.modified=ve,this.notebookType=Re}}e.$GL=In;class Pn{constructor(){}}e.$HL=Pn;class An{constructor(W,ve){this.uri=W,this.inputBoxUri=ve}}e.$IL=An;var gn;(function(H){H[H.Up=1]="Up",H[H.Down=2]="Down"})(gn||(e.InteractiveSessionVoteDirection=gn={}));var mn;(function(H){H[H.Action=1]="Action",H[H.Toolbar=2]="Toolbar"})(mn||(e.InteractiveSessionCopyKind=mn={}));var $n;(function(H){H[H.Unhelpful=0]="Unhelpful",H[H.Helpful=1]="Helpful",H[H.Undone=2]="Undone",H[H.Accepted=3]="Accepted"})($n||(e.InteractiveEditorResponseFeedbackKind=$n={}));var bn;(function(H){H[H.System=0]="System",H[H.User=1]="User",H[H.Assistant=2]="Assistant",H[H.Function=3]="Function"})(bn||(e.ChatMessageRole=bn={}));var pn;(function(H){H[H.Short=1]="Short",H[H.Medium=2]="Medium",H[H.Full=3]="Full"})(pn||(e.ChatVariableLevel=pn={}));class Rn{constructor(W,ve){this.role=W,this.content=ve}}e.$JL=Rn;var wn;(function(H){H[H.SymbolInformation=1]="SymbolInformation",H[H.CommandInformation=2]="CommandInformation",H[H.SearchInformation=3]="SearchInformation",H[H.SettingInformation=4]="SettingInformation"})(wn||(e.RelatedInformationType=wn={}))}),define(De[140],Ce([1,0,54,16,15,169,123,7,19]),function($e,e,D,M,h,R,A,g,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$YL=e.$XL=e.$WL=void 0;const $=new Map;function P(C,y){y?$.set(C,y):$.delete(C)}e.$WL=P;function I(C){return $.get(C)}class b extends R.$Ju{constructor(y,r,i,a,m,p,f,t){super(r,i,a,m),this.c=y,this.m=p,this.q=f,this.notebook=t,this.b=!1}dispose(){(0,D.ok)(!this.b),this.b=!0,this.q=!1}equalLines(y){return(0,E.$of)(this.f,y)}get document(){if(!this.a){const y=this;this.a={get uri(){return y.d},get fileName(){return y.d.fsPath},get isUntitled(){return y.d.scheme===M.Schemas.untitled},get languageId(){return y.m},get version(){return y.h},get isClosed(){return y.b},get isDirty(){return y.q},save(){return y.r()},getText(r){return r?y.s(r):y.getText()},get eol(){return y.g===`
`?g.EndOfLine.LF:g.EndOfLine.CRLF},get lineCount(){return y.f.length},lineAt(r){return y.t(r)},offsetAt(r){return y.u(r)},positionAt(r){return y.v(r)},validateRange(r){return y.w(r)},validatePosition(r){return y.x(r)},getWordRangeAtPosition(r,i){return y.y(r,i)}}}return Object.freeze(this.a)}_acceptLanguageId(y){(0,D.ok)(!this.b),this.m=y}_acceptIsDirty(y){(0,D.ok)(!this.b),this.q=y}r(){return this.b?Promise.reject(new Error("Document has been closed")):this.c.$trySaveDocument(this.d)}s(y){const r=this.w(y);if(r.isEmpty)return"";if(r.isSingleLine)return this.f[r.start.line].substring(r.start.character,r.end.character);const i=this.g,a=r.start.line,m=r.end.line,p=[];p.push(this.f[a].substring(r.start.character));for(let f=a+1;f<m;f++)p.push(this.f[f]);return p.push(this.f[m].substring(0,r.end.character)),p.join(i)}t(y){let r;if(y instanceof g.$VJ?r=y.line:typeof y=="number"&&(r=y),typeof r!="number"||r<0||r>=this.f.length||Math.floor(r)!==r)throw new Error("Illegal value for `line`");return new S(r,this.f[r],r===this.f.length-1)}u(y){return y=this.x(y),this.l(),this.j.getPrefixSum(y.line-1)+y.character}v(y){y=Math.floor(y),y=Math.max(0,y),this.l();const r=this.j.getIndexOf(y),i=this.f[r.index].length;return new g.$VJ(r.index,Math.min(r.remainder,i))}w(y){if(!(y instanceof g.$WJ))throw new Error("Invalid argument");const r=this.x(y.start),i=this.x(y.end);return r===y.start&&i===y.end?y:new g.$WJ(r.line,r.character,i.line,i.character)}x(y){if(!(y instanceof g.$VJ))throw new Error("Invalid argument");if(this.f.length===0)return y.with(0,0);let{line:r,character:i}=y,a=!1;if(r<0)r=0,i=0,a=!0;else if(r>=this.f.length)r=this.f.length-1,i=this.f[r].length,a=!0;else{const m=this.f[r].length;i<0?(i=0,a=!0):i>m&&(i=m,a=!0)}return a?new g.$VJ(r,i):y}y(y,r){const i=this.x(y);if(!r)r=I(this.m);else if((0,h.$Bd)(r))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${r.source}' because it matches the empty string.`);const a=(0,A.$Wr)(i.character+1,(0,A.$Ur)(r),this.f[i.line],0);if(a)return new g.$WJ(i.line,a.startColumn-1,i.line,a.endColumn-1)}}e.$XL=b;class S{constructor(y,r,i){this.a=y,this.b=r,this.c=i}get lineNumber(){return this.a}get text(){return this.b}get range(){return new g.$WJ(this.a,0,this.a,this.b.length)}get rangeIncludingLineBreak(){return this.c?this.range:new g.$WJ(this.a,0,this.a+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this.b)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this.b.length}}e.$YL=S}),define(De[265],Ce([1,0,7,20,4]),function($e,e,D,M,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7bc=void 0;let R=class{constructor(g){this.a=new D.$fL(D.ColorThemeKind.Dark),this.b=new h.$hc}get activeColorTheme(){return this.a}$onColorThemeChange(g){let E;switch(g){case"light":E=D.ColorThemeKind.Light;break;case"hcDark":E=D.ColorThemeKind.HighContrast;break;case"hcLight":E=D.ColorThemeKind.HighContrastLight;break;default:E=D.ColorThemeKind.Dark}this.a=new D.$fL(E),this.b.fire(this.a)}get onDidChangeActiveColorTheme(){return this.b.event}};e.$7bc=R,e.$7bc=R=Ke([Ve(0,M.$UL)],R)}),define(De[266],Ce([1,0,6]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4H=e.CellExecutionUpdateType=void 0;var M;(function(h){h[h.Output=1]="Output",h[h.OutputItems=2]="OutputItems",h[h.ExecutionState=3]="ExecutionState"})(M||(e.CellExecutionUpdateType=M={})),e.$4H=(0,D.$zh)("INotebookExecutionService")}),define(De[63],Ce([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$FI=e.TestPosition=e.TestIdPathParts=void 0;var D;(function(R){R.Delimiter="\0"})(D||(e.TestIdPathParts=D={}));var M;(function(R){R[R.IsSame=0]="IsSame",R[R.Disconnected=1]="Disconnected",R[R.IsChild=2]="IsChild",R[R.IsParent=3]="IsParent"})(M||(e.TestPosition=M={}));class h{static fromExtHostTestItem(A,g,E=A.parent){if(A._isRoot)return new h([g]);const $=[A.id];for(let P=E;P&&P.id!==g;P=P.parent)$.push(P.id);return $.push(g),new h($.reverse())}static isRoot(A){return!A.includes("\0")}static root(A){const g=A.indexOf("\0");return g===-1?A:A.slice(0,g)}static fromString(A){return new h(A.split("\0"))}static join(A,g){return new h([...A.path,g])}static joinToString(A,g){return A.toString()+"\0"+g}static parentId(A){const g=A.lastIndexOf("\0");return g===-1?void 0:A.slice(0,g)}static localId(A){const g=A.lastIndexOf("\0");return g===-1?A:A.slice(g+1)}static isChild(A,g){return g.startsWith(A)&&g[A.length]==="\0"}static compare(A,g){return A===g?0:h.isChild(A,g)?2:h.isChild(g,A)?3:1}constructor(A,g=A.length){if(this.path=A,this.d=g,A.length===0||g<1)throw new Error("cannot create test with empty path")}get rootId(){return new h(this.path,1)}get parentId(){return this.d>1?new h(this.path,this.d-1):void 0}get localId(){return this.path[this.d-1]}get controllerId(){return this.path[0]}get isRoot(){return this.d===1}*idsFromRoot(){for(let A=1;A<=this.d;A++)yield new h(this.path,A)}*idsToRoot(){for(let A=this.d;A>0;A--)yield new h(this.path,A)}compare(A){if(typeof A=="string")return h.compare(this.toString(),A);for(let g=0;g<A.d&&g<this.d;g++)if(A.path[g]!==this.path[g])return 1;return A.d>this.d?2:A.d<this.d?3:0}toJSON(){return this.toString()}toString(){if(!this.c){this.c=this.path[0];for(let A=1;A<this.d;A++)this.c+="\0",this.c+=this.path[A]}return this.c}}e.$FI=h}),define(De[87],Ce([1,0,2,34,63]),function($e,e,D,M,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$MI=e.TestsDiffOp=e.TestDiffOpType=e.DetailType=e.TestResultItem=e.$LI=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.$KI=e.$JI=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.$II=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.$HI=e.$GI=e.TestRunProfileBitset=e.ExtTestRunProfileKind=e.TestResultState=void 0;var R;(function(k){k[k.Unset=0]="Unset",k[k.Queued=1]="Queued",k[k.Running=2]="Running",k[k.Passed=3]="Passed",k[k.Failed=4]="Failed",k[k.Skipped=5]="Skipped",k[k.Errored=6]="Errored"})(R||(e.TestResultState=R={}));var A;(function(k){k[k.Run=1]="Run",k[k.Debug=2]="Debug",k[k.Coverage=3]="Coverage"})(A||(e.ExtTestRunProfileKind=A={}));var g;(function(k){k[k.Run=2]="Run",k[k.Debug=4]="Debug",k[k.Coverage=8]="Coverage",k[k.HasNonDefaultProfile=16]="HasNonDefaultProfile",k[k.HasConfigurable=32]="HasConfigurable",k[k.SupportsContinuousRun=64]="SupportsContinuousRun"})(g||(e.TestRunProfileBitset=g={})),e.$GI=[2,4,8,16,32,64];const E=k=>"runId"in k;e.$HI=E;var $;(function(k){k.serialize=u=>({range:u.range.toJSON(),uri:u.uri.toJSON()}),k.deserialize=u=>({range:M.$hs.lift(u.range),uri:D.URI.revive(u.uri)})})($||(e.IRichLocation=$={}));var P;(function(k){k[k.Error=0]="Error",k[k.Output=1]="Output"})(P||(e.TestMessageType=P={}));var I;(function(k){k.serialize=u=>({message:u.message,type:0,expected:u.expected,actual:u.actual,contextValue:u.contextValue,location:u.location&&$.serialize(u.location)}),k.deserialize=u=>({message:u.message,type:0,expected:u.expected,actual:u.actual,contextValue:u.contextValue,location:u.location&&$.deserialize(u.location)})})(I||(e.ITestErrorMessage=I={}));const b=(k,u)=>`${u?"s":"e"}${k}`;e.$II=b;var S;(function(k){k.serialize=u=>({message:u.message,type:1,offset:u.offset,length:u.length,location:u.location&&$.serialize(u.location)}),k.deserialize=u=>({message:u.message,type:1,offset:u.offset,length:u.length,location:u.location&&$.deserialize(u.location)})})(S||(e.ITestOutputMessage=S={}));var C;(function(k){k.serialize=u=>u.type===0?I.serialize(u):S.serialize(u),k.deserialize=u=>u.type===0?I.deserialize(u):S.deserialize(u)})(C||(e.ITestMessage=C={}));var y;(function(k){k.serializeWithoutMessages=u=>({state:u.state,duration:u.duration,messages:[]}),k.serialize=u=>({state:u.state,duration:u.duration,messages:u.messages.map(C.serialize)}),k.deserialize=u=>({state:u.state,duration:u.duration,messages:u.messages.map(C.deserialize)})})(y||(e.ITestTaskState=y={}));const r="\0",i=(k,u)=>k+r+u;e.$JI=i;const a=k=>{const u=k.indexOf(r);return{ctrlId:k.slice(0,u),tagId:k.slice(u+1)}};e.$KI=a;var m;(function(k){k.serialize=u=>({extId:u.extId,label:u.label,tags:u.tags,busy:u.busy,children:void 0,uri:u.uri?.toJSON(),range:u.range?.toJSON()||null,description:u.description,error:u.error,sortText:u.sortText}),k.deserialize=u=>({extId:u.extId,label:u.label,tags:u.tags,busy:u.busy,children:void 0,uri:u.uri?D.URI.revive(u.uri):void 0,range:u.range?M.$hs.lift(u.range):null,description:u.description,error:u.error,sortText:u.sortText})})(m||(e.ITestItem=m={}));var p;(function(k){k[k.NotExpandable=0]="NotExpandable",k[k.Expandable=1]="Expandable",k[k.BusyExpanding=2]="BusyExpanding",k[k.Expanded=3]="Expanded"})(p||(e.TestItemExpandState=p={}));var f;(function(k){k.serialize=u=>({expand:u.expand,item:m.serialize(u.item)}),k.deserialize=u=>({controllerId:h.$FI.root(u.item.extId),expand:u.expand,item:m.deserialize(u.item)})})(f||(e.InternalTestItem=f={}));var t;(function(k){k.serialize=u=>{let l;return u.item&&(l={},u.item.label!==void 0&&(l.label=u.item.label),u.item.tags!==void 0&&(l.tags=u.item.tags),u.item.busy!==void 0&&(l.busy=u.item.busy),u.item.uri!==void 0&&(l.uri=u.item.uri?.toJSON()),u.item.range!==void 0&&(l.range=u.item.range?.toJSON()),u.item.description!==void 0&&(l.description=u.item.description),u.item.error!==void 0&&(l.error=u.item.error),u.item.sortText!==void 0&&(l.sortText=u.item.sortText)),{extId:u.extId,expand:u.expand,item:l}},k.deserialize=u=>{let l;return u.item&&(l={},u.item.label!==void 0&&(l.label=u.item.label),u.item.tags!==void 0&&(l.tags=u.item.tags),u.item.busy!==void 0&&(l.busy=u.item.busy),u.item.range!==void 0&&(l.range=u.item.range?M.$hs.lift(u.item.range):null),u.item.description!==void 0&&(l.description=u.item.description),u.item.error!==void 0&&(l.error=u.item.error),u.item.sortText!==void 0&&(l.sortText=u.item.sortText)),{extId:u.extId,expand:u.expand,item:l}}})(t||(e.ITestItemUpdate=t={}));const s=(k,u)=>{u.expand!==void 0&&(k.expand=u.expand),u.item!==void 0&&(k.item=k.item?Object.assign(k.item,u.item):u.item)};e.$LI=s;var o;(function(k){k.serializeWithoutMessages=u=>({...f.serialize(u),ownComputedState:u.ownComputedState,computedState:u.computedState,tasks:u.tasks.map(y.serializeWithoutMessages)}),k.serialize=u=>({...f.serialize(u),ownComputedState:u.ownComputedState,computedState:u.computedState,tasks:u.tasks.map(y.serialize)}),k.deserialize=u=>({...f.deserialize(u),ownComputedState:u.ownComputedState,computedState:u.computedState,tasks:u.tasks.map(y.deserialize),retired:!0})})(o||(e.TestResultItem=o={}));var n;(function(k){k[k.Function=0]="Function",k[k.Statement=1]="Statement"})(n||(e.DetailType=n={}));var c;(function(k){k[k.Add=0]="Add",k[k.Update=1]="Update",k[k.DocumentSynced=2]="DocumentSynced",k[k.Remove=3]="Remove",k[k.IncrementPendingExtHosts=4]="IncrementPendingExtHosts",k[k.Retire=5]="Retire",k[k.AddTag=6]="AddTag",k[k.RemoveTag=7]="RemoveTag"})(c||(e.TestDiffOpType=c={}));var d;(function(k){k.deserialize=u=>u.op===0?{op:u.op,item:f.deserialize(u.item)}:u.op===1?{op:u.op,item:t.deserialize(u.item)}:u.op===2?{op:u.op,uri:D.URI.revive(u.uri),docv:u.docv}:u,k.serialize=u=>u.op===0?{op:u.op,item:f.serialize(u.item)}:u.op===1?{op:u.op,item:t.serialize(u.item)}:u})(d||(e.TestsDiffOp=d={}));class v{constructor(){this.d=new Map,this.f=new Map,this.g=new Set,this.h=0,this.j=0,this.tags=this.d}apply(u){const l=this.p();for(const w of u)switch(w.op){case 0:this.k(f.deserialize(w.item),l);break;case 1:this.l(t.deserialize(w.item),l);break;case 3:this.m(w.itemId,l);break;case 5:this.o(w.itemId);break;case 4:this.updatePendingRoots(w.amount);break;case 6:this.d.set(w.tag.id,w.tag);break;case 7:this.d.delete(w.id);break}l.complete?.()}k(u,l){const w=h.$FI.parentId(u.item.extId)?.toString();let L;if(!w)L=this.q(u),this.g.add(L),this.f.set(u.item.extId,L);else if(this.f.has(w)){const N=this.f.get(w);N.children.add(u.item.extId),L=this.q(u,N),this.f.set(u.item.extId,L)}else{console.error(`Test with unknown parent ID: ${JSON.stringify(u)}`);return}return l.add?.(L),u.expand===2&&this.h++,L}l(u,l){const w=this.f.get(u.extId);if(w)return u.expand!==void 0&&(w.expand===2&&this.h--,u.expand===2&&this.h++),(0,e.$LI)(w,u),l.update?.(w),w}m(u,l){const w=this.f.get(u);if(!w)return;const L=h.$FI.parentId(w.item.extId)?.toString();L?this.f.get(L).children.delete(w.item.extId):this.g.delete(w);const N=[[u]];for(;N.length;)for(const j of N.pop()){const T=this.f.get(j);T&&(N.push(T.children),this.f.delete(j),l.remove?.(T,T!==w),T.expand===2&&this.h--)}}o(u){}updatePendingRoots(u){this.j+=u}p(){return{}}}e.$MI=v}),define(De[108],Ce([1,0,13,4,3,54,87,63]),function($e,e,D,M,h,R,A,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$OL=e.$NL=e.$ML=e.$LL=e.$KL=e.TestItemEventOp=void 0;var E;(function(a){a[a.Upsert=0]="Upsert",a[a.SetTags=1]="SetTags",a[a.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",a[a.RemoveChild=3]="RemoveChild",a[a.SetProp=4]="SetProp",a[a.Bulk=5]="Bulk",a[a.DocumentSynced=6]="DocumentSynced"})(E||(e.TestItemEventOp=E={}));const $=(a,m)=>a===m,I=Object.entries({range:(a,m)=>a===m?!0:!a||!m?!1:a.equalsRange(m),busy:$,label:$,description:$,error:$,sortText:$,tags:(a,m)=>!(a.length!==m.length||a.some(p=>!m.includes(p)))}),b=(a,m)=>{let p;for(const[f,t]of I)t(a[f],m[f])||(p?p[f]=m[f]:p={[f]:m[f]});return p};class S extends h.$mb{get root(){return this.m.root}constructor(m){super(),this.m=m,this.f=this.B(new D.$Qg(()=>this.flushDiff(),200)),this.g=this.B(new M.$hc),this.tree=new Map,this.j=new Map,this.k=[],this.onDidGenerateDiff=this.g.event,this.root.canResolveChildren=!0,this.u(this.root,void 0)}set resolveHandler(m){this.h=m;for(const p of this.tree.values())this.G(p)}get resolveHandler(){return this.h}collectDiff(){const m=this.k;return this.k=[],m}pushDiff(m){switch(m.op){case 2:{for(const p of this.k)if(p.op===2&&p.uri===m.uri){p.docv=m.docv;return}break}case 1:{const p=this.k[this.k.length-1];if(p){if(p.op===1&&p.item.extId===m.item.extId){(0,A.$LI)(p.item,m.item);return}if(p.op===0&&p.item.item.extId===m.item.extId){(0,A.$LI)(p.item,m.item);return}}break}}this.k.push(m),this.f.isScheduled()||this.f.schedule()}expand(m,p){const f=this.tree.get(m);if(f){if((f.expandLevels===void 0||p>f.expandLevels)&&(f.expandLevels=p),f.expand===1){const t=this.I(f);return t.isOpen()?this.H(f,p-1):t.wait().then(()=>this.H(f,p-1))}else if(f.expand===3)return f.resolveBarrier?.isOpen()===!1?f.resolveBarrier.wait().then(()=>this.H(f,p-1)):this.H(f,p-1)}}dispose(){for(const m of this.tree.values())this.m.getApiFor(m.actual).listener=void 0;this.tree.clear(),this.k=[],super.dispose()}p(m,p){switch(p.op){case 3:this.L(g.$FI.joinToString(m.fullId,p.id));break;case 0:this.u(p.item,m);break;case 5:for(const f of p.ops)this.p(m,f);break;case 1:this.w(p.new,p.old,m.fullId.toString());break;case 2:this.G(m);break;case 4:this.pushDiff({op:1,item:{extId:m.fullId.toString(),item:p.update}});break;case 6:this.s(m.actual.uri);break;default:(0,R.$xb)(p)}}s(m){m&&this.pushDiff({op:2,uri:m,docv:this.m.getDocumentVersion(m)})}u(m,p){const f=g.$FI.fromExtHostTestItem(m,this.root.id,p?.actual),t=this.m.getApiFor(m);t.parent&&t.parent!==p?.actual&&this.m.getChildren(t.parent).delete(m.id);let s=this.tree.get(f.toString());if(!s){s={fullId:f,actual:m,expandLevels:p?.expandLevels?p.expandLevels-1:void 0,expand:0},m.tags.forEach(this.y,this),this.tree.set(s.fullId.toString(),s),this.C(m,p),this.pushDiff({op:0,item:{controllerId:this.m.controllerId,expand:s.expand,item:this.m.toITestItem(m)}}),this.F(m,s,p);return}if(s.actual===m){this.D(m,s,p);return}if(s.actual.uri?.toString()!==m.uri?.toString())return this.L(f.toString()),this.u(m,p);const o=this.m.getChildren(s.actual),n=s.actual,c=b(this.m.toITestItem(n),this.m.toITestItem(m));this.m.getApiFor(n).listener=void 0,s.actual=m,s.expand=0,c&&(c.hasOwnProperty("tags")&&(this.w(m.tags,n.tags,f.toString()),delete c.tags),this.p(s,{op:4,update:c})),this.F(m,s,p);for(const[d,v]of o)this.m.getChildren(m).get(v.id)||this.L(g.$FI.joinToString(f,v.id));this.s(s.actual.uri)}w(m,p,f){const t=new Set(p.map(s=>s.id));for(const s of m)t.delete(s.id)||this.y(s);this.pushDiff({op:1,item:{extId:f,item:{tags:m.map(s=>(0,A.$JI)(this.m.controllerId,s.id))}}}),t.forEach(this.z,this)}y(m){const p=this.j.get(m.id);p?p.refCount++:(this.j.set(m.id,{refCount:1}),this.pushDiff({op:6,tag:{id:(0,A.$JI)(this.m.controllerId,m.id)}}))}z(m){const p=this.j.get(m);p&&!--p.refCount&&(this.j.delete(m),this.pushDiff({op:7,id:(0,A.$JI)(this.m.controllerId,m)}))}C(m,p){this.m.getApiFor(m).parent=p&&p.actual!==this.root?p.actual:void 0}D(m,p,f){this.C(m,f);const t=this.m.getApiFor(m);t.parent=f?.actual,t.listener=s=>this.p(p,s),this.G(p)}F(m,p,f){this.D(m,p,f);for(const[t,s]of this.m.getChildren(m))this.u(s,p)}G(m){let p;this.h?m.resolveBarrier?p=m.resolveBarrier.isOpen()?3:2:p=m.actual.canResolveChildren?1:0:p=0,p!==m.expand&&(m.expand=p,this.pushDiff({op:1,item:{extId:m.fullId.toString(),expand:p}}),p===1&&m.expandLevels!==void 0&&this.I(m))}H(m,p){if(p<0)return;const f=[];for(const[t,s]of this.m.getChildren(m.actual)){const o=this.expand(g.$FI.joinToString(m.fullId,s.id),p);(0,D.$rg)(o)&&f.push(o)}if(f.length)return Promise.all(f).then(()=>{})}I(m){if(m.resolveBarrier)return m.resolveBarrier;if(!this.h){const s=new D.$Dg;return s.open(),s}m.expand=2,this.J(m);const p=m.resolveBarrier=new D.$Dg,f=s=>{console.error(`Unhandled error in resolveHandler of test controller "${this.m.controllerId}"`,s)};let t;try{t=this.h(m.actual===this.root?void 0:m.actual)}catch(s){f(s)}return(0,D.$rg)(t)?t.catch(f).then(()=>{p.open(),this.G(m)}):(p.open(),this.G(m)),m.resolveBarrier}J(m){this.pushDiff({op:1,item:{extId:m.fullId.toString(),expand:m.expand}})}L(m){const p=this.tree.get(m);if(!p)throw new Error("attempting to remove non-existent child");this.pushDiff({op:3,itemId:m});const f=[p];for(;f.length;){const t=f.pop();if(t){this.m.getApiFor(t.actual).listener=void 0;for(const s of t.actual.tags)this.z(s.id);this.tree.delete(t.fullId.toString());for(const[s,o]of this.m.getChildren(t.actual))f.push(this.tree.get(g.$FI.joinToString(t.fullId,o.id)))}}}flushDiff(){const m=this.collectDiff();m.length&&this.g.fire(m)}}e.$KL=S;class C extends Error{constructor(m){super(`Attempted to insert a duplicate test item ID ${m}`)}}e.$LL=C;class y extends Error{constructor(m){super(`TestItem with ID "${m}" is invalid. Make sure to create it from the createTestItem method.`)}}e.$ML=y;class r extends Error{constructor(m,p,f){super(`TestItem with ID "${m}" is from controller "${p}" and cannot be added as a child of an item from controller "${f}".`)}}e.$NL=r;const i=(a,m,p)=>{let f=new Map;return{get size(){return f.size},forEach(t,s){for(const o of f.values())t.call(s,o,this)},[Symbol.iterator](){return f.entries()},replace(t){const s=new Map,o=new Set(f.keys()),n={op:5,ops:[]};for(const c of t){if(!(c instanceof p))throw new y(c.id);const d=m(c).controllerId;if(d!==a.controllerId)throw new r(c.id,d,a.controllerId);if(s.has(c.id))throw new C(c.id);s.set(c.id,c),o.delete(c.id),n.ops.push({op:0,item:c})}for(const c of o.keys())n.ops.push({op:3,id:c});a.listener?.(n),f=s},add(t){if(!(t instanceof p))throw new y(t.id);f.set(t.id,t),a.listener?.({op:0,item:t})},delete(t){f.delete(t)&&a.listener?.({op:3,id:t})},get(t){return f.get(t)},toJSON(){return Array.from(f.values())}}};e.$OL=i}),define(De[141],Ce([1,0,108]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$QL=e.$PL=void 0;const M=new WeakMap,h=(A,g)=>{const E={controllerId:g};return M.set(A,E),E};e.$PL=h;const R=A=>{const g=M.get(A);if(!g)throw new D.$ML(A?.id||"<unknown>");return g};e.$QL=R}),define(De[109],Ce([1,0,16,2]),function($e,e,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bob=e.$Aob=e.$zob=e.$yob=e.$xob=void 0,e.$xob="vscode-cdn.net",e.$yob=`vscode-resource.${e.$xob}`,e.$zob=`'self' https://*.${e.$xob}`;function h(g,E){return g.scheme===D.Schemas.http||g.scheme===D.Schemas.https?g:(E&&E.authority&&E.isRemote&&g.scheme===D.Schemas.file&&(g=M.URI.from({scheme:D.Schemas.vscodeRemote,authority:E.authority,path:g.path})),M.URI.from({scheme:D.Schemas.https,authority:`${g.scheme}+${R(g.authority)}.${e.$yob}`,path:g.path,fragment:g.fragment,query:g.query}))}e.$Aob=h;function R(g){return g.replace(/./g,E=>{const $=E.charCodeAt(0);return $>=97&&$<=122||$>=65&&$<=90||$>=48&&$<=57?E:"-"+$.toString(16).padStart(4,"0")})}function A(g){return g.replace(/-([0-9a-f]{4})/g,(E,$)=>String.fromCharCode(parseInt($,16)))}e.$Bob=A}),define(De[267],Ce([1,0,4,3,109]),function($e,e,D,M,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ebc=void 0;class R{constructor(g,E,$){this.d=g,this.e=E,this.f=$,this.a=0,this.b=new M.$lb,this.c=new Map,this.b.add(E.onDidChangeVisibleTextEditors(()=>{const P=E.getVisibleTextEditors();for(const I of this.c.values())P.indexOf(I.editor)<0&&I.inset.dispose()}))}dispose(){this.c.forEach(g=>g.inset.dispose()),this.b.dispose()}createWebviewEditorInset(g,E,$,P,I){let b;for(const m of this.e.getVisibleTextEditors(!0))if(m.value===g){b=m;break}if(!b)throw new Error("not a visible editor");const S=this,C=this.a++,y=new D.$hc,r=new D.$hc,i=new class{constructor(){this.a="",this.b=Object.create(null)}asWebviewUri(m){return(0,h.$Aob)(m,S.f)}get cspSource(){return h.$zob}set options(m){this.b=m,S.d.$setOptions(C,m)}get options(){return this.b}set html(m){this.a=m,S.d.$setHtml(C,m)}get html(){return this.a}get onDidReceiveMessage(){return y.event}postMessage(m){return S.d.$postMessage(C,m)}},a=new class{constructor(){this.editor=g,this.line=E,this.height=$,this.webview=i,this.onDidDispose=r.event}dispose(){S.c.has(C)&&(S.c.delete(C),S.d.$disposeEditorInset(C),r.fire(),r.dispose(),y.dispose())}};return this.d.$createEditorInset(C,b.id,b.value.document.uri,E+1,$,P||{},I.identifier,I.extensionLocation),this.c.set(C,{editor:g,inset:a,onDidReceiveMessage:y}),a}$onDidDispose(g){const E=this.c.get(g);E&&E.inset.dispose()}$onDidReceiveMessage(g,E){this.c.get(g)?.onDidReceiveMessage.fire(E)}}e.$Ebc=R}),define(De[268],Ce([1,0,6]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$HM=e.VariableKind=e.$GM=void 0,e.$GM=(0,D.$zh)("configurationResolverService");var M;(function(R){R.Unknown="unknown",R.Env="env",R.Config="config",R.Command="command",R.Input="input",R.ExtensionInstallFolder="extensionInstallFolder",R.WorkspaceFolder="workspaceFolder",R.Cwd="cwd",R.WorkspaceFolderBasename="workspaceFolderBasename",R.UserHome="userHome",R.LineNumber="lineNumber",R.SelectedText="selectedText",R.File="file",R.FileWorkspaceFolder="fileWorkspaceFolder",R.RelativeFile="relativeFile",R.RelativeFileDirname="relativeFileDirname",R.FileDirname="fileDirname",R.FileExtname="fileExtname",R.FileBasename="fileBasename",R.FileBasenameNoExtension="fileBasenameNoExtension",R.FileDirnameBasename="fileDirnameBasename",R.ExecPath="execPath",R.ExecInstallFolder="execInstallFolder",R.PathSeparator="pathSeparator"})(M||(e.VariableKind=M={}));class h extends Error{constructor(A,g){super(g),this.variable=A}}e.$HM=h}),define(De[269],Ce([1,0,14,45,18,23,9,127,218,268,15]),function($e,e,D,M,h,R,A,g,E,$,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$VM=void 0;class I{static{this.VARIABLE_LHS="${"}static{this.VARIABLE_REGEXP=/\$\{(.*?)\}/g}constructor(S,C,y,r){this.h=new Map,this.a=S,this.b=C,this.g=y,r&&(this.c=r.then(i=>this.i(i)))}i(S){if(A.$i){const C=Object.create(null);return Object.keys(S).forEach(y=>{C[y.toLowerCase()]=S[y]}),C}return S}resolveWithEnvironment(S,C,y){return this.l({env:this.i(S),userHome:void 0},C?C.uri:void 0,y)}async resolveAsync(S,C){const y={env:await this.c,userHome:await this.g};return this.l(y,S?S.uri:void 0,C)}async j(S,C,y,r){const i=R.$Tm(C);A.$i&&i.windows?Object.keys(i.windows).forEach(m=>i[m]=i.windows[m]):A.$j&&i.osx?Object.keys(i.osx).forEach(m=>i[m]=i.osx[m]):A.$k&&i.linux&&Object.keys(i.linux).forEach(m=>i[m]=i.linux[m]),delete i.windows,delete i.osx,delete i.linux;const a={env:await this.c,userHome:await this.g};return this.l(a,S?S.uri:void 0,i,y,r)}async resolveAnyAsync(S,C,y){return this.j(S,C,y)}async resolveAnyMap(S,C,y){const r=new Map;return{newConfig:await this.j(S,C,y,r),resolvedVariables:r}}resolveWithInteractionReplace(S,C,y,r){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(S,C,y,r){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(S,C){if(this.h.has(S))throw new Error("Variable "+S+" is contributed twice.");this.h.set(S,C)}async l(S,C,y,r,i){if(h.$le(y))return this.m(S,C,y,r,i);if(Array.isArray(y))return Promise.all(y.map(a=>this.l(S,C,a,r,i)));if(h.$ne(y)){const a=Object.create(null),m=await Promise.all(Object.keys(y).map(async p=>[await this.m(S,C,p,r,i),await this.l(S,C,y[p],r,i)]));for(const[p,f]of m)a[p]=f;return a}return y}m(S,C,y,r,i){return(0,P.$Gd)(y,I.VARIABLE_REGEXP,async(a,m)=>{if(m.includes(I.VARIABLE_LHS))return a;let p=await this.o(S,a,m,C,r);return i?.set(m,p),p!==a&&h.$le(p)&&p.match(I.VARIABLE_REGEXP)&&(p=await this.m(S,C,p,r,i)),p})}n(S){return this.b?this.b.getUriLabel(S,{noPrefix:!0}):S.fsPath}async o(S,C,y,r,i){let a;const m=y.split(":");m.length>1&&(y=m[0],a=m[1]);const p=s=>{const o=this.a.getFilePath();if(o)return(0,g.$bA)(o);throw new $.$HM(s,(0,E.localize)(0,null,C))},f=s=>{const o=p(s);if(this.a.getWorkspaceFolderPathForFile){const n=this.a.getWorkspaceFolderPathForFile();if(n)return(0,g.$bA)(n)}throw new $.$HM(s,(0,E.localize)(1,null,C,D.$cd(o)))},t=s=>{if(a){const o=this.a.getFolderUri(a);if(o)return o;throw new $.$HM(s,(0,E.localize)(2,null,C,a))}if(r)return r;throw this.a.getWorkspaceFolderCount()>1?new $.$HM(s,(0,E.localize)(3,null,C)):new $.$HM(s,(0,E.localize)(4,null,C))};switch(y){case"env":if(a){if(S.env){const s=S.env[A.$i?a.toLowerCase():a];if(h.$le(s))return s}return""}throw new $.$HM($.VariableKind.Env,(0,E.localize)(5,null,C));case"config":if(a){const s=this.a.getConfigurationValue(r,a);if(h.$ue(s))throw new $.$HM($.VariableKind.Config,(0,E.localize)(6,null,C,a));if(h.$ne(s))throw new $.$HM($.VariableKind.Config,(0,E.localize)(7,null,C,a));return s}throw new $.$HM($.VariableKind.Config,(0,E.localize)(8,null,C));case"command":return this.p($.VariableKind.Command,C,a,i,"command");case"input":return this.p($.VariableKind.Input,C,a,i,"input");case"extensionInstallFolder":if(a){const s=await this.a.getExtension(a);if(!s)throw new $.$HM($.VariableKind.ExtensionInstallFolder,(0,E.localize)(9,null,C,a));return this.n(s.extensionLocation)}throw new $.$HM($.VariableKind.ExtensionInstallFolder,(0,E.localize)(10,null,C));default:switch(y){case"workspaceRoot":case"workspaceFolder":return(0,g.$bA)(this.n(t($.VariableKind.WorkspaceFolder)));case"cwd":return r||a?(0,g.$bA)(this.n(t($.VariableKind.Cwd))):M.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return(0,g.$bA)(D.$cd(this.n(t($.VariableKind.WorkspaceFolderBasename))));case"userHome":{if(S.userHome)return S.userHome;throw new $.$HM($.VariableKind.UserHome,(0,E.localize)(11,null,C))}case"lineNumber":{const s=this.a.getLineNumber();if(s)return s;throw new $.$HM($.VariableKind.LineNumber,(0,E.localize)(12,null,C))}case"selectedText":{const s=this.a.getSelectedText();if(s)return s;throw new $.$HM($.VariableKind.SelectedText,(0,E.localize)(13,null,C))}case"file":return p($.VariableKind.File);case"fileWorkspaceFolder":return f($.VariableKind.FileWorkspaceFolder);case"relativeFile":return r||a?D.$ad(this.n(t($.VariableKind.RelativeFile)),p($.VariableKind.RelativeFile)):p($.VariableKind.RelativeFile);case"relativeFileDirname":{const s=D.$bd(p($.VariableKind.RelativeFileDirname));if(r||a){const o=D.$ad(this.n(t($.VariableKind.RelativeFileDirname)),s);return o.length===0?".":o}return s}case"fileDirname":return D.$bd(p($.VariableKind.FileDirname));case"fileExtname":return D.$dd(p($.VariableKind.FileExtname));case"fileBasename":return D.$cd(p($.VariableKind.FileBasename));case"fileBasenameNoExtension":{const s=D.$cd(p($.VariableKind.FileBasenameNoExtension));return s.slice(0,s.length-D.$dd(s).length)}case"fileDirnameBasename":return D.$cd(D.$bd(p($.VariableKind.FileDirnameBasename)));case"execPath":{const s=this.a.getExecPath();return s||C}case"execInstallFolder":{const s=this.a.getAppRoot();return s||C}case"pathSeparator":return D.sep;default:try{const s=a?`${y}:${a}`:y;return this.p($.VariableKind.Unknown,C,s,i,void 0)}catch{return C}}}}p(S,C,y,r,i){if(y&&r){const a=i===void 0?r[y]:r[i+":"+y];if(typeof a=="string")return a;throw new $.$HM(S,(0,E.localize)(14,null,C))}return C}}e.$VM=I}),define(De[142],Ce([1,0,6,138]),function($e,e,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4C=e.$3C=e.OpenEditorContext=e.GroupsOrder=e.$2C=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.$1C=void 0,e.$1C=(0,D.$zh)("editorGroupsService");var h;(function(C){C[C.UP=0]="UP",C[C.DOWN=1]="DOWN",C[C.LEFT=2]="LEFT",C[C.RIGHT=3]="RIGHT"})(h||(e.GroupDirection=h={}));var R;(function(C){C[C.HORIZONTAL=0]="HORIZONTAL",C[C.VERTICAL=1]="VERTICAL"})(R||(e.GroupOrientation=R={}));var A;(function(C){C[C.FIRST=0]="FIRST",C[C.LAST=1]="LAST",C[C.NEXT=2]="NEXT",C[C.PREVIOUS=3]="PREVIOUS"})(A||(e.GroupLocation=A={}));var g;(function(C){C[C.MAXIMIZE=0]="MAXIMIZE",C[C.EVEN=1]="EVEN",C[C.TOGGLE=2]="TOGGLE"})(g||(e.GroupsArrangement=g={}));var E;(function(C){C[C.COPY_EDITORS=0]="COPY_EDITORS",C[C.MOVE_EDITORS=1]="MOVE_EDITORS"})(E||(e.MergeGroupMode=E={}));function $(C){const y=C;return(0,M.$QE)(y?.editor)&&(0,M.$QE)(y?.replacement)}e.$2C=$;var P;(function(C){C[C.CREATION_TIME=0]="CREATION_TIME",C[C.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",C[C.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(P||(e.GroupsOrder=P={}));var I;(function(C){C[C.NEW_EDITOR=1]="NEW_EDITOR",C[C.MOVE_EDITOR=2]="MOVE_EDITOR",C[C.COPY_EDITOR=3]="COPY_EDITOR"})(I||(e.OpenEditorContext=I={}));function b(C){const y=C;return!!y&&typeof y.id=="number"&&Array.isArray(y.editors)}e.$3C=b;function S(C){return C.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.$4C=S}),define(De[270],Ce([1,0,6,142]),function($e,e,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8C=e.$7C=e.$6C=e.$5C=void 0,e.$5C=(0,D.$zh)("editorService"),e.$6C=-1,e.$7C=-2;function h(R){const A=R;return typeof R=="number"||(0,M.$3C)(A)}e.$8C=h}),define(De[10],Ce([1,0,19,21,160,71,78,28,156,77,97,23,18,2,34,81,132,141,138,107,63,87,270,7]),function($e,e,D,M,h,R,A,g,E,$,P,I,b,S,C,y,r,i,a,m,p,f,t,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalQuickFix=e.InteractiveEditorResponseFeedbackKind=e.ChatVariableLevel=e.ChatVariable=e.ChatMessageRole=e.ChatMessage=e.ChatFollowup=e.ChatReplyFollowup=e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookKernelSourceAction=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.MappedEditsContext=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.$TL=e.$SL=e.MarkdownString=e.$RL=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Range=e.Selection=void 0;var o;(function(Me){function Te(te){const{selectionStartLineNumber:Fe,selectionStartColumn:He,positionLineNumber:_e,positionColumn:Je}=te,rt=new s.$VJ(Fe-1,He-1),pt=new s.$VJ(_e-1,Je-1);return new s.$XJ(rt,pt)}Me.to=Te;function Se(te){const{anchor:Fe,active:He}=te;return{selectionStartLineNumber:Fe.line+1,selectionStartColumn:Fe.character+1,positionLineNumber:He.line+1,positionColumn:He.character+1}}Me.from=Se})(o||(e.Selection=o={}));var n;(function(Me){function Te(te){if(!te)return;const{start:Fe,end:He}=te;return{startLineNumber:Fe.line+1,startColumn:Fe.character+1,endLineNumber:He.line+1,endColumn:He.character+1}}Me.from=Te;function Se(te){if(!te)return;const{startLineNumber:Fe,startColumn:He,endLineNumber:_e,endColumn:Je}=te;return new s.$WJ(Fe-1,He-1,_e-1,Je-1)}Me.to=Se})(n||(e.Range=n={}));var c;(function(Me){function Te(Se){switch(Se){case 1:return s.StandardTokenType.Comment;case 0:return s.StandardTokenType.Other;case 3:return s.StandardTokenType.RegEx;case 2:return s.StandardTokenType.String}}Me.to=Te})(c||(e.TokenType=c={}));var d;(function(Me){function Te(te){return new s.$VJ(te.lineNumber-1,te.column-1)}Me.to=Te;function Se(te){return{lineNumber:te.line+1,column:te.character+1}}Me.from=Se})(d||(e.Position=d={}));var v;(function(Me){function Te(Fe,He,_e){return(0,D.$Af)((0,D.$Vf)(Fe).map(Je=>Se(Je,He,_e)))}Me.from=Te;function Se(Fe,He,_e){if(typeof Fe=="string")return{$serialized:!0,language:Fe,isBuiltin:_e?.isBuiltin};if(Fe)return{$serialized:!0,language:Fe.language,scheme:te(Fe.scheme,He),pattern:Qe.from(Fe.pattern)??void 0,exclusive:Fe.exclusive,notebookType:Fe.notebookType,isBuiltin:_e?.isBuiltin}}function te(Fe,He){return He&&typeof Fe=="string"?He.transformOutgoingScheme(Fe):Fe}})(v||(e.DocumentSelector=v={}));var k;(function(Me){function Te(te){switch(te){case s.DiagnosticTag.Unnecessary:return 1;case s.DiagnosticTag.Deprecated:return 2}}Me.from=Te;function Se(te){switch(te){case 1:return s.DiagnosticTag.Unnecessary;case 2:return s.DiagnosticTag.Deprecated;default:return}}Me.to=Se})(k||(e.DiagnosticTag=k={}));var u;(function(Me){function Te(te){let Fe;return te.code&&((0,b.$le)(te.code)||(0,b.$pe)(te.code)?Fe=String(te.code):Fe={value:String(te.code.value),target:te.code.target}),{...n.from(te.range),message:te.message,source:te.source,code:Fe,severity:w.from(te.severity),relatedInformation:te.relatedInformation&&te.relatedInformation.map(l.from),tags:Array.isArray(te.tags)?(0,D.$Af)(te.tags.map(k.from)):void 0}}Me.from=Te;function Se(te){const Fe=new s.$9J(n.to(te),te.message,w.to(te.severity));return Fe.source=te.source,Fe.code=(0,b.$le)(te.code)?te.code:te.code?.value,Fe.relatedInformation=te.relatedInformation&&te.relatedInformation.map(l.to),Fe.tags=te.tags&&(0,D.$Af)(te.tags.map(k.to)),Fe}Me.to=Se})(u||(e.Diagnostic=u={}));var l;(function(Me){function Te(te){return{...n.from(te.location.range),message:te.message,resource:te.location.uri}}Me.from=Te;function Se(te){return new s.$8J(new s.$7J(te.resource,n.to(te)),te.message)}Me.to=Se})(l||(e.DiagnosticRelatedInformation=l={}));var w;(function(Me){function Te(te){switch(te){case s.DiagnosticSeverity.Error:return r.MarkerSeverity.Error;case s.DiagnosticSeverity.Warning:return r.MarkerSeverity.Warning;case s.DiagnosticSeverity.Information:return r.MarkerSeverity.Info;case s.DiagnosticSeverity.Hint:return r.MarkerSeverity.Hint}return r.MarkerSeverity.Error}Me.from=Te;function Se(te){switch(te){case r.MarkerSeverity.Info:return s.DiagnosticSeverity.Information;case r.MarkerSeverity.Warning:return s.DiagnosticSeverity.Warning;case r.MarkerSeverity.Error:return s.DiagnosticSeverity.Error;case r.MarkerSeverity.Hint:return s.DiagnosticSeverity.Hint;default:return s.DiagnosticSeverity.Error}}Me.to=Se})(w||(e.DiagnosticSeverity=w={}));var L;(function(Me){function Te(te){return typeof te=="number"&&te>=s.ViewColumn.One?te-1:te===s.ViewColumn.Beside?t.$7C:t.$6C}Me.from=Te;function Se(te){if(typeof te=="number"&&te>=0)return te+1;throw new Error("invalid 'EditorGroupColumn'")}Me.to=Se})(L||(e.ViewColumn=L={}));function N(Me){return typeof Me.range<"u"}function j(Me){return Me.length===0?!0:!!N(Me[0])}e.$RL=j;var T;(function(Me){function Te(Je){return Je.map(Me.from)}Me.fromMany=Te;function Se(Je){return Je&&typeof Je=="object"&&typeof Je.language=="string"&&typeof Je.value=="string"}function te(Je){let rt;if(Se(Je)){const{language:gt,value:mt}=Je;rt={value:"```"+gt+`
`+mt+"\n```\n"}}else s.$jK.isMarkdownString(Je)?rt={value:Je.value,isTrusted:Je.isTrusted,supportThemeIcons:Je.supportThemeIcons,supportHtml:Je.supportHtml,baseUri:Je.baseUri}:typeof Je=="string"?rt={value:Je}:rt={value:""};const pt=Object.create(null);rt.uris=pt;const wt=gt=>{try{let mt=S.URI.parse(gt,!0);mt=mt.with({query:Fe(mt.query,pt)}),pt[gt]=mt}catch{}return""},ft=new E.marked.Renderer;return ft.link=wt,ft.image=gt=>typeof gt=="string"?wt(A.$3j(gt).href):"",(0,E.marked)(rt.value,{renderer:ft}),rt}Me.from=te;function Fe(Je,rt){if(!Je)return Je;let pt;try{pt=(0,$.$8g)(Je)}catch{}if(!pt)return Je;let wt=!1;return pt=(0,I.$Vm)(pt,ft=>{if(S.URI.isUri(ft)){const gt=`__uri_${Math.random().toString(16).slice(2,8)}`;return rt[gt]=ft,wt=!0,gt}else return}),wt?JSON.stringify(pt):Je}function He(Je){const rt=new s.$jK(Je.value,Je.supportThemeIcons);return rt.isTrusted=Je.isTrusted,rt.supportHtml=Je.supportHtml,rt.baseUri=Je.baseUri?S.URI.from(Je.baseUri):void 0,rt}Me.to=He;function _e(Je){if(Je)return typeof Je=="string"?Je:Me.from(Je)}Me.fromStrict=_e})(T||(e.MarkdownString=T={}));function O(Me){return j(Me)?Me.map(Te=>({range:n.from(Te.range),hoverMessage:Array.isArray(Te.hoverMessage)?T.fromMany(Te.hoverMessage):Te.hoverMessage?T.from(Te.hoverMessage):void 0,renderOptions:Te.renderOptions})):Me.map(Te=>({range:n.from(Te)}))}e.$SL=O;function B(Me){return typeof Me>"u"?Me:typeof Me=="string"?S.URI.file(Me):Me}e.$TL=B;var F;(function(Me){function Te(Se){return typeof Se>"u"?Se:{contentText:Se.contentText,contentIconPath:Se.contentIconPath?B(Se.contentIconPath):void 0,border:Se.border,borderColor:Se.borderColor,fontStyle:Se.fontStyle,fontWeight:Se.fontWeight,textDecoration:Se.textDecoration,color:Se.color,backgroundColor:Se.backgroundColor,margin:Se.margin,width:Se.width,height:Se.height}}Me.from=Te})(F||(e.ThemableDecorationAttachmentRenderOptions=F={}));var J;(function(Me){function Te(Se){return typeof Se>"u"?Se:{backgroundColor:Se.backgroundColor,outline:Se.outline,outlineColor:Se.outlineColor,outlineStyle:Se.outlineStyle,outlineWidth:Se.outlineWidth,border:Se.border,borderColor:Se.borderColor,borderRadius:Se.borderRadius,borderSpacing:Se.borderSpacing,borderStyle:Se.borderStyle,borderWidth:Se.borderWidth,fontStyle:Se.fontStyle,fontWeight:Se.fontWeight,textDecoration:Se.textDecoration,cursor:Se.cursor,color:Se.color,opacity:Se.opacity,letterSpacing:Se.letterSpacing,gutterIconPath:Se.gutterIconPath?B(Se.gutterIconPath):void 0,gutterIconSize:Se.gutterIconSize,overviewRulerColor:Se.overviewRulerColor,before:Se.before?F.from(Se.before):void 0,after:Se.after?F.from(Se.after):void 0}}Me.from=Te})(J||(e.ThemableDecorationRenderOptions=J={}));var K;(function(Me){function Te(Se){if(typeof Se>"u")return Se;switch(Se){case s.DecorationRangeBehavior.OpenOpen:return 0;case s.DecorationRangeBehavior.ClosedClosed:return 1;case s.DecorationRangeBehavior.OpenClosed:return 2;case s.DecorationRangeBehavior.ClosedOpen:return 3}}Me.from=Te})(K||(e.DecorationRangeBehavior=K={}));var me;(function(Me){function Te(Se){return{isWholeLine:Se.isWholeLine,rangeBehavior:Se.rangeBehavior?K.from(Se.rangeBehavior):void 0,overviewRulerLane:Se.overviewRulerLane,light:Se.light?J.from(Se.light):void 0,dark:Se.dark?J.from(Se.dark):void 0,backgroundColor:Se.backgroundColor,outline:Se.outline,outlineColor:Se.outlineColor,outlineStyle:Se.outlineStyle,outlineWidth:Se.outlineWidth,border:Se.border,borderColor:Se.borderColor,borderRadius:Se.borderRadius,borderSpacing:Se.borderSpacing,borderStyle:Se.borderStyle,borderWidth:Se.borderWidth,fontStyle:Se.fontStyle,fontWeight:Se.fontWeight,textDecoration:Se.textDecoration,cursor:Se.cursor,color:Se.color,opacity:Se.opacity,letterSpacing:Se.letterSpacing,gutterIconPath:Se.gutterIconPath?B(Se.gutterIconPath):void 0,gutterIconSize:Se.gutterIconSize,overviewRulerColor:Se.overviewRulerColor,before:Se.before?F.from(Se.before):void 0,after:Se.after?F.from(Se.after):void 0}}Me.from=Te})(me||(e.DecorationRenderOptions=me={}));var re;(function(Me){function Te(te){return{text:te.newText,eol:te.newEol&&et.from(te.newEol),range:n.from(te.range)}}Me.from=Te;function Se(te){const Fe=new s.$2J(n.to(te.range),te.text);return Fe.newEol=typeof te.eol>"u"?void 0:et.to(te.eol),Fe}Me.to=Se})(re||(e.TextEdit=re={}));var x;(function(Me){function Te(te,Fe){const He={edits:[]};if(te instanceof s.$5J){const _e=new g.$yi;for(const Je of te._allEntries())Je._type===1&&S.URI.isUri(Je.to)&&Je.from===void 0&&_e.add(Je.to);for(const Je of te._allEntries())if(Je._type===1){let rt;Je.options?.contents&&(ArrayBuffer.isView(Je.options.contents)?rt={type:"base64",value:(0,M.$2c)(M.$Hc.wrap(Je.options.contents))}:rt={type:"dataTransferItem",id:Je.options.contents._itemId}),He.edits.push({oldResource:Je.from,newResource:Je.to,options:{...Je.options,contents:rt},metadata:Je.metadata})}else Je._type===2?He.edits.push({resource:Je.uri,textEdit:re.from(Je.edit),versionId:_e.has(Je.uri)?void 0:Fe?.getTextDocumentVersion(Je.uri),metadata:Je.metadata}):Je._type===6?He.edits.push({resource:Je.uri,textEdit:{range:n.from(Je.range),text:Je.edit.value,insertAsSnippet:!0},versionId:_e.has(Je.uri)?void 0:Fe?.getTextDocumentVersion(Je.uri),metadata:Je.metadata}):Je._type===3?He.edits.push({metadata:Je.metadata,resource:Je.uri,cellEdit:Je.edit,notebookMetadata:Je.notebookMetadata,notebookVersionId:Fe?.getNotebookDocumentVersion(Je.uri)}):Je._type===5&&He.edits.push({metadata:Je.metadata,resource:Je.uri,notebookVersionId:Fe?.getNotebookDocumentVersion(Je.uri),cellEdit:{editType:1,index:Je.index,count:Je.count,cells:Je.cells.map(ot.from)}})}return He}Me.from=Te;function Se(te){const Fe=new s.$5J,He=new g.$xi;for(const _e of te.edits)if(_e.textEdit){const Je=_e,rt=S.URI.revive(Je.resource),pt=n.to(Je.textEdit.range),wt=Je.textEdit.text,ft=Je.textEdit.insertAsSnippet;let gt;ft?gt=s.$4J.replace(pt,new s.$6J(wt)):gt=s.$2J.replace(pt,wt);const mt=He.get(rt);mt?mt.push(gt):He.set(rt,[gt])}else Fe.renameFile(S.URI.revive(_e.oldResource),S.URI.revive(_e.newResource),_e.options);for(const[_e,Je]of He)Fe.set(_e,Je);return Fe}Me.to=Se})(x||(e.WorkspaceEdit=x={}));var q;(function(Me){const Te=Object.create(null);Te[s.SymbolKind.File]=0,Te[s.SymbolKind.Module]=1,Te[s.SymbolKind.Namespace]=2,Te[s.SymbolKind.Package]=3,Te[s.SymbolKind.Class]=4,Te[s.SymbolKind.Method]=5,Te[s.SymbolKind.Property]=6,Te[s.SymbolKind.Field]=7,Te[s.SymbolKind.Constructor]=8,Te[s.SymbolKind.Enum]=9,Te[s.SymbolKind.Interface]=10,Te[s.SymbolKind.Function]=11,Te[s.SymbolKind.Variable]=12,Te[s.SymbolKind.Constant]=13,Te[s.SymbolKind.String]=14,Te[s.SymbolKind.Number]=15,Te[s.SymbolKind.Boolean]=16,Te[s.SymbolKind.Array]=17,Te[s.SymbolKind.Object]=18,Te[s.SymbolKind.Key]=19,Te[s.SymbolKind.Null]=20,Te[s.SymbolKind.EnumMember]=21,Te[s.SymbolKind.Struct]=22,Te[s.SymbolKind.Event]=23,Te[s.SymbolKind.Operator]=24,Te[s.SymbolKind.TypeParameter]=25;function Se(Fe){return typeof Te[Fe]=="number"?Te[Fe]:6}Me.from=Se;function te(Fe){for(const He in Te)if(Te[He]===Fe)return Number(He);return s.SymbolKind.Property}Me.to=te})(q||(e.SymbolKind=q={}));var ee;(function(Me){function Te(te){switch(te){case s.SymbolTag.Deprecated:return 1}}Me.from=Te;function Se(te){switch(te){case 1:return s.SymbolTag.Deprecated}}Me.to=Se})(ee||(e.SymbolTag=ee={}));var pe;(function(Me){function Te(te){return{name:te.name,kind:q.from(te.kind),tags:te.tags&&te.tags.map(ee.from),containerName:te.containerName,location:V.from(te.location)}}Me.from=Te;function Se(te){const Fe=new s.$_J(te.name,q.to(te.kind),te.containerName,V.to(te.location));return Fe.tags=te.tags&&te.tags.map(ee.to),Fe}Me.to=Se})(pe||(e.WorkspaceSymbol=pe={}));var ce;(function(Me){function Te(te){const Fe={name:te.name||"!!MISSING: name!!",detail:te.detail,range:n.from(te.range),selectionRange:n.from(te.selectionRange),kind:q.from(te.kind),tags:te.tags?.map(ee.from)??[]};return te.children&&(Fe.children=te.children.map(Te)),Fe}Me.from=Te;function Se(te){const Fe=new s.$aK(te.name,te.detail,q.to(te.kind),n.to(te.range),n.to(te.selectionRange));return(0,D.$Ef)(te.tags)&&(Fe.tags=te.tags.map(ee.to)),te.children&&(Fe.children=te.children.map(Se)),Fe}Me.to=Se})(ce||(e.DocumentSymbol=ce={}));var _;(function(Me){function Te(te){const Fe=new s.$fK(q.to(te.kind),te.name,te.detail||"",S.URI.revive(te.uri),n.to(te.range),n.to(te.selectionRange));return Fe._sessionId=te._sessionId,Fe._itemId=te._itemId,Fe}Me.to=Te;function Se(te,Fe,He){if(Fe=Fe??te._sessionId,He=He??te._itemId,Fe===void 0||He===void 0)throw new Error("invalid item");return{_sessionId:Fe,_itemId:He,name:te.name,detail:te.detail,kind:q.from(te.kind),uri:te.uri,range:n.from(te.range),selectionRange:n.from(te.selectionRange),tags:te.tags?.map(ee.from)}}Me.from=Se})(_||(e.CallHierarchyItem=_={}));var Q;(function(Me){function Te(Se){return new s.$gK(_.to(Se.from),Se.fromRanges.map(te=>n.to(te)))}Me.to=Te})(Q||(e.CallHierarchyIncomingCall=Q={}));var z;(function(Me){function Te(Se){return new s.$hK(_.to(Se.to),Se.fromRanges.map(te=>n.to(te)))}Me.to=Te})(z||(e.CallHierarchyOutgoingCall=z={}));var V;(function(Me){function Te(te){return{range:te.range&&n.from(te.range),uri:te.uri}}Me.from=Te;function Se(te){return new s.$7J(S.URI.revive(te.uri),n.to(te.range))}Me.to=Se})(V||(e.location=V={}));var G;(function(Me){function Te(te){const Fe=te,He=te;return{originSelectionRange:Fe.originSelectionRange?n.from(Fe.originSelectionRange):void 0,uri:Fe.targetUri?Fe.targetUri:He.uri,range:n.from(Fe.targetRange?Fe.targetRange:He.range),targetSelectionRange:Fe.targetSelectionRange?n.from(Fe.targetSelectionRange):void 0}}Me.from=Te;function Se(te){return{targetUri:S.URI.revive(te.uri),targetRange:n.to(te.range),targetSelectionRange:te.targetSelectionRange?n.to(te.targetSelectionRange):void 0,originSelectionRange:te.originSelectionRange?n.to(te.originSelectionRange):void 0}}Me.to=Se})(G||(e.DefinitionLink=G={}));var ae;(function(Me){function Te(te){return{range:n.from(te.range),contents:T.fromMany(te.contents)}}Me.from=Te;function Se(te){return new s.$0J(te.contents.map(T.to),n.to(te.range))}Me.to=Se})(ae||(e.Hover=ae={}));var ne;(function(Me){function Te(te){return{range:n.from(te.range),expression:te.expression}}Me.from=Te;function Se(te){return new s.$4K(n.to(te.range),te.expression)}Me.to=Se})(ne||(e.EvaluatableExpression=ne={}));var he;(function(Me){function Te(te){if(te instanceof s.$5K)return{type:"text",range:n.from(te.range),text:te.text};if(te instanceof s.$6K)return{type:"variable",range:n.from(te.range),variableName:te.variableName,caseSensitiveLookup:te.caseSensitiveLookup};if(te instanceof s.$7K)return{type:"expression",range:n.from(te.range),expression:te.expression};throw new Error("Unknown 'InlineValue' type")}Me.from=Te;function Se(te){switch(te.type){case"text":return{range:n.to(te.range),text:te.text};case"variable":return{range:n.to(te.range),variableName:te.variableName,caseSensitiveLookup:te.caseSensitiveLookup};case"expression":return{range:n.to(te.range),expression:te.expression}}}Me.to=Se})(he||(e.InlineValue=he={}));var Ee;(function(Me){function Te(te){return{frameId:te.frameId,stoppedLocation:n.from(te.stoppedLocation)}}Me.from=Te;function Se(te){return new s.$8K(te.frameId,n.to(te.stoppedLocation))}Me.to=Se})(Ee||(e.InlineValueContext=Ee={}));var de;(function(Me){function Te(te){return{range:n.from(te.range),kind:te.kind}}Me.from=Te;function Se(te){return new s.$$J(n.to(te.range),te.kind)}Me.to=Se})(de||(e.DocumentHighlight=de={}));var ge;(function(Me){function Te(Se){switch(Se){case 1:return s.CompletionTriggerKind.TriggerCharacter;case 2:return s.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return s.CompletionTriggerKind.Invoke}}Me.to=Te})(ge||(e.CompletionTriggerKind=ge={}));var ie;(function(Me){function Te(Se){return{triggerKind:ge.to(Se.triggerKind),triggerCharacter:Se.triggerCharacter}}Me.to=Te})(ie||(e.CompletionContext=ie={}));var ue;(function(Me){function Te(te){switch(te){case s.CompletionItemTag.Deprecated:return 1}}Me.from=Te;function Se(te){switch(te){case 1:return s.CompletionItemTag.Deprecated}}Me.to=Se})(ue||(e.CompletionItemTag=ue={}));var we;(function(Me){const Te=new Map([[s.CompletionItemKind.Method,0],[s.CompletionItemKind.Function,1],[s.CompletionItemKind.Constructor,2],[s.CompletionItemKind.Field,3],[s.CompletionItemKind.Variable,4],[s.CompletionItemKind.Class,5],[s.CompletionItemKind.Interface,7],[s.CompletionItemKind.Struct,6],[s.CompletionItemKind.Module,8],[s.CompletionItemKind.Property,9],[s.CompletionItemKind.Unit,12],[s.CompletionItemKind.Value,13],[s.CompletionItemKind.Constant,14],[s.CompletionItemKind.Enum,15],[s.CompletionItemKind.EnumMember,16],[s.CompletionItemKind.Keyword,17],[s.CompletionItemKind.Snippet,27],[s.CompletionItemKind.Text,18],[s.CompletionItemKind.Color,19],[s.CompletionItemKind.File,20],[s.CompletionItemKind.Reference,21],[s.CompletionItemKind.Folder,23],[s.CompletionItemKind.Event,10],[s.CompletionItemKind.Operator,11],[s.CompletionItemKind.TypeParameter,24],[s.CompletionItemKind.Issue,26],[s.CompletionItemKind.User,25]]);function Se(He){return Te.get(He)??9}Me.from=Se;const te=new Map([[0,s.CompletionItemKind.Method],[1,s.CompletionItemKind.Function],[2,s.CompletionItemKind.Constructor],[3,s.CompletionItemKind.Field],[4,s.CompletionItemKind.Variable],[5,s.CompletionItemKind.Class],[7,s.CompletionItemKind.Interface],[6,s.CompletionItemKind.Struct],[8,s.CompletionItemKind.Module],[9,s.CompletionItemKind.Property],[12,s.CompletionItemKind.Unit],[13,s.CompletionItemKind.Value],[14,s.CompletionItemKind.Constant],[15,s.CompletionItemKind.Enum],[16,s.CompletionItemKind.EnumMember],[17,s.CompletionItemKind.Keyword],[27,s.CompletionItemKind.Snippet],[18,s.CompletionItemKind.Text],[19,s.CompletionItemKind.Color],[20,s.CompletionItemKind.File],[21,s.CompletionItemKind.Reference],[23,s.CompletionItemKind.Folder],[10,s.CompletionItemKind.Event],[11,s.CompletionItemKind.Operator],[24,s.CompletionItemKind.TypeParameter],[25,s.CompletionItemKind.User],[26,s.CompletionItemKind.Issue]]);function Fe(He){return te.get(He)??s.CompletionItemKind.Property}Me.to=Fe})(we||(e.CompletionItemKind=we={}));var Pe;(function(Me){function Te(Se,te){const Fe=new s.$pK(Se.label);return Fe.insertText=Se.insertText,Fe.kind=we.to(Se.kind),Fe.tags=Se.tags?.map(ue.to),Fe.detail=Se.detail,Fe.documentation=A.$Xj(Se.documentation)?T.to(Se.documentation):Se.documentation,Fe.sortText=Se.sortText,Fe.filterText=Se.filterText,Fe.preselect=Se.preselect,Fe.commitCharacters=Se.commitCharacters,C.$hs.isIRange(Se.range)?Fe.range=n.to(Se.range):typeof Se.range=="object"&&(Fe.range={inserting:n.to(Se.range.insert),replacing:n.to(Se.range.replace)}),Fe.keepWhitespace=typeof Se.insertTextRules>"u"?!1:!!(Se.insertTextRules&1),typeof Se.insertTextRules<"u"&&Se.insertTextRules&4?Fe.insertText=new s.$6J(Se.insertText):(Fe.insertText=Se.insertText,Fe.textEdit=Fe.range instanceof s.$WJ?new s.$2J(Fe.range,Fe.insertText):void 0),Se.additionalTextEdits&&Se.additionalTextEdits.length>0&&(Fe.additionalTextEdits=Se.additionalTextEdits.map(He=>re.to(He))),Fe.command=te&&Se.command?te.fromInternal(Se.command):void 0,Fe}Me.to=Te})(Pe||(e.CompletionItem=Pe={}));var U;(function(Me){function Te(te){if(typeof te.label!="string"&&!Array.isArray(te.label))throw new TypeError("Invalid label");return{label:te.label,documentation:T.fromStrict(te.documentation)}}Me.from=Te;function Se(te){return{label:te.label,documentation:A.$Xj(te.documentation)?T.to(te.documentation):te.documentation}}Me.to=Se})(U||(e.ParameterInformation=U={}));var Z;(function(Me){function Te(te){return{label:te.label,documentation:T.fromStrict(te.documentation),parameters:Array.isArray(te.parameters)?te.parameters.map(U.from):[],activeParameter:te.activeParameter}}Me.from=Te;function Se(te){return{label:te.label,documentation:A.$Xj(te.documentation)?T.to(te.documentation):te.documentation,parameters:Array.isArray(te.parameters)?te.parameters.map(U.to):[],activeParameter:te.activeParameter}}Me.to=Se})(Z||(e.SignatureInformation=Z={}));var X;(function(Me){function Te(te){return{activeSignature:te.activeSignature,activeParameter:te.activeParameter,signatures:Array.isArray(te.signatures)?te.signatures.map(Z.from):[]}}Me.from=Te;function Se(te){return{activeSignature:te.activeSignature,activeParameter:te.activeParameter,signatures:Array.isArray(te.signatures)?te.signatures.map(Z.to):[]}}Me.to=Se})(X||(e.SignatureHelp=X={}));var oe;(function(Me){function Te(Se,te){const Fe=new s.$oK(d.to(te.position),typeof te.label=="string"?te.label:te.label.map(Y.to.bind(void 0,Se)),te.kind&&fe.to(te.kind));return Fe.textEdits=te.textEdits&&te.textEdits.map(re.to),Fe.tooltip=A.$Xj(te.tooltip)?T.to(te.tooltip):te.tooltip,Fe.paddingLeft=te.paddingLeft,Fe.paddingRight=te.paddingRight,Fe}Me.to=Te})(oe||(e.InlayHint=oe={}));var Y;(function(Me){function Te(Se,te){const Fe=new s.$nK(te.label);return Fe.tooltip=A.$Xj(te.tooltip)?T.to(te.tooltip):te.tooltip,y.Command.is(te.command)&&(Fe.command=Se.fromInternal(te.command)),te.location&&(Fe.location=V.to(te.location)),Fe}Me.to=Te})(Y||(e.InlayHintLabelPart=Y={}));var fe;(function(Me){function Te(te){return te}Me.from=Te;function Se(te){return te}Me.to=Se})(fe||(e.InlayHintKind=fe={}));var ye;(function(Me){function Te(te){return{range:n.from(te.range),url:te.target,tooltip:te.tooltip}}Me.from=Te;function Se(te){let Fe;if(te.url)try{Fe=typeof te.url=="string"?S.URI.parse(te.url,!0):S.URI.revive(te.url)}catch{}return new s.$uK(n.to(te.range),Fe)}Me.to=Se})(ye||(e.DocumentLink=ye={}));var ze;(function(Me){function Te(te){const Fe=new s.$xK(te.label);return te.textEdit&&(Fe.textEdit=re.to(te.textEdit)),te.additionalTextEdits&&(Fe.additionalTextEdits=te.additionalTextEdits.map(He=>re.to(He))),Fe}Me.to=Te;function Se(te){return{label:te.label,textEdit:te.textEdit?re.from(te.textEdit):void 0,additionalTextEdits:te.additionalTextEdits?te.additionalTextEdits.map(Fe=>re.from(Fe)):void 0}}Me.from=Se})(ze||(e.ColorPresentation=ze={}));var Be;(function(Me){function Te(te){return new s.$vK(te[0],te[1],te[2],te[3])}Me.to=Te;function Se(te){return[te.red,te.green,te.blue,te.alpha]}Me.from=Se})(Be||(e.Color=Be={}));var xe;(function(Me){function Te(te){return{range:n.from(te.range)}}Me.from=Te;function Se(te){return new s.$eK(n.to(te.range))}Me.to=Se})(xe||(e.SelectionRange=xe={}));var Ye;(function(Me){function Te(Se){switch(Se){case 2:return s.TextDocumentSaveReason.AfterDelay;case 1:return s.TextDocumentSaveReason.Manual;case 3:case 4:return s.TextDocumentSaveReason.FocusOut}}Me.to=Te})(Ye||(e.TextDocumentSaveReason=Ye={}));var it;(function(Me){function Te(te){switch(te){case s.TextEditorLineNumbersStyle.Off:return 0;case s.TextEditorLineNumbersStyle.Relative:return 2;case s.TextEditorLineNumbersStyle.On:default:return 1}}Me.from=Te;function Se(te){switch(te){case 0:return s.TextEditorLineNumbersStyle.Off;case 2:return s.TextEditorLineNumbersStyle.Relative;case 1:default:return s.TextEditorLineNumbersStyle.On}}Me.to=Se})(it||(e.TextEditorLineNumbersStyle=it={}));var et;(function(Me){function Te(te){if(te===s.EndOfLine.CRLF)return 1;if(te===s.EndOfLine.LF)return 0}Me.from=Te;function Se(te){if(te===1)return s.EndOfLine.CRLF;if(te===0)return s.EndOfLine.LF}Me.to=Se})(et||(e.EndOfLine=et={}));var Ae;(function(Me){function Te(Se){if(typeof Se=="object")return Se.viewId;switch(Se){case s.ProgressLocation.SourceControl:return 3;case s.ProgressLocation.Window:return 10;case s.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}Me.from=Te})(Ae||(e.ProgressLocation=Ae={}));var Ne;(function(Me){function Te(te){const Fe={start:te.start+1,end:te.end+1};return te.kind&&(Fe.kind=We.from(te.kind)),Fe}Me.from=Te;function Se(te){const Fe={start:te.start-1,end:te.end-1};return te.kind&&(Fe.kind=We.to(te.kind)),Fe}Me.to=Se})(Ne||(e.FoldingRange=Ne={}));var We;(function(Me){function Te(te){if(te)switch(te){case s.FoldingRangeKind.Comment:return y.$9s.Comment;case s.FoldingRangeKind.Imports:return y.$9s.Imports;case s.FoldingRangeKind.Region:return y.$9s.Region}}Me.from=Te;function Se(te){if(te)switch(te.value){case y.$9s.Comment.value:return s.FoldingRangeKind.Comment;case y.$9s.Imports.value:return s.FoldingRangeKind.Imports;case y.$9s.Region.value:return s.FoldingRangeKind.Region}}Me.to=Se})(We||(e.FoldingRangeKind=We={}));var Le;(function(Me){function Te(Se){if(Se)return{pinned:typeof Se.preview=="boolean"?!Se.preview:void 0,inactive:Se.background,preserveFocus:Se.preserveFocus,selection:typeof Se.selection=="object"?n.from(Se.selection):void 0,override:typeof Se.override=="boolean"?a.$DE.id:void 0}}Me.from=Te})(Le||(e.TextEditorOpenOptions=Le={}));var Qe;(function(Me){function Te(He){return He instanceof s.$RK?He.toJSON():typeof He=="string"?He:Se(He)||te(He)?new s.$RK(He.baseUri??He.base,He.pattern).toJSON():He}Me.from=Te;function Se(He){const _e=He;return _e?S.URI.isUri(_e.baseUri)&&typeof _e.pattern=="string":!1}function te(He){const _e=He;return _e?typeof _e.base=="string"&&typeof _e.pattern=="string":!1}function Fe(He){return typeof He=="string"?He:new s.$RK(S.URI.revive(He.baseUri),He.pattern)}Me.to=Fe})(Qe||(e.GlobPattern=Qe={}));var le;(function(Me){function Te(Se){if(Se){if(Array.isArray(Se))return Se.map(Te);if(typeof Se=="string")return Se;{const te=Se;return{language:te.language,scheme:te.scheme,pattern:Qe.from(te.pattern),exclusive:te.exclusive,notebookType:te.notebookType}}}else return}Me.from=Te})(le||(e.LanguageSelector=le={}));var se;(function(Me){function Te(te){return!!te&&typeof te=="object"&&"selections"in te&&Array.isArray(te.selections)&&te.selections.every(Fe=>Fe instanceof s.$XJ)&&"related"in te&&Array.isArray(te.related)&&te.related.every(Fe=>Fe&&typeof Fe=="object"&&S.URI.isUri(Fe.uri)&&Fe.range instanceof s.$WJ)}Me.is=Te;function Se(te){return{selections:te.selections.map(Fe=>o.from(Fe)),related:te.related.map(Fe=>({uri:S.URI.from(Fe.uri),range:n.from(Fe.range)}))}}Me.from=Se})(se||(e.MappedEditsContext=se={}));var Ie;(function(Me){function Te(te){return{start:te.start,end:te.end}}Me.from=Te;function Se(te){return new s.$gL(te.start,te.end)}Me.to=Se})(Ie||(e.NotebookRange=Ie={}));var qe;(function(Me){function Te(te){return{timing:typeof te.runStartTime=="number"&&typeof te.runEndTime=="number"?{startTime:te.runStartTime,endTime:te.runEndTime}:void 0,executionOrder:te.executionOrder,success:te.lastRunSuccess}}Me.to=Te;function Se(te){return{lastRunSuccess:te.success,runStartTime:te.timing?.startTime,runEndTime:te.timing?.endTime,executionOrder:te.executionOrder}}Me.from=Se})(qe||(e.NotebookCellExecutionSummary=qe={}));var je;(function(Me){function Te(Se){if(Se===m.NotebookCellExecutionState.Unconfirmed)return s.NotebookCellExecutionState.Pending;if(Se===m.NotebookCellExecutionState.Pending)return;if(Se===m.NotebookCellExecutionState.Executing)return s.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${Se}`)}Me.to=Te})(je||(e.NotebookCellExecutionState=je={}));var Xe;(function(Me){function Te(te){switch(te){case s.NotebookCellKind.Markup:return m.CellKind.Markup;case s.NotebookCellKind.Code:default:return m.CellKind.Code}}Me.from=Te;function Se(te){switch(te){case m.CellKind.Markup:return s.NotebookCellKind.Markup;case m.CellKind.Code:default:return s.NotebookCellKind.Code}}Me.to=Se})(Xe||(e.NotebookCellKind=Xe={}));var nt;(function(Me){function Te(te){const Fe={metadata:te.metadata??Object.create(null),cells:[]};for(const He of te.cells)s.$hL.validate(He),Fe.cells.push(ot.from(He));return Fe}Me.from=Te;function Se(te){const Fe=new s.$iL(te.cells.map(ot.to));return(0,b.$ye)(te.metadata)||(Fe.metadata=te.metadata),Fe}Me.to=Se})(nt||(e.NotebookData=nt={}));var ot;(function(Me){function Te(te){return{cellKind:Xe.from(te.kind),language:te.languageId,mime:te.mime,source:te.value,metadata:te.metadata,internalMetadata:qe.from(te.executionSummary??{}),outputs:te.outputs?te.outputs.map(Dt.from):[]}}Me.from=Te;function Se(te){return new s.$hL(Xe.to(te.cellKind),te.source,te.language,te.mime,te.outputs?te.outputs.map(Dt.to):void 0,te.metadata,te.internalMetadata?qe.to(te.internalMetadata):void 0)}Me.to=Se})(ot||(e.NotebookCellData=ot={}));var bt;(function(Me){function Te(te){return{mime:te.mime,valueBytes:M.$Hc.wrap(te.data)}}Me.from=Te;function Se(te){return new s.$jL(te.valueBytes.buffer,te.mime)}Me.to=Se})(bt||(e.NotebookCellOutputItem=bt={}));var Dt;(function(Me){function Te(te){return{outputId:te.id,items:te.items.map(bt.from),metadata:te.metadata}}Me.from=Te;function Se(te){const Fe=te.items.map(bt.to);return new s.$kL(Fe,te.outputId,te.metadata)}Me.to=Se})(Dt||(e.NotebookCellOutput=Dt={}));var Qt;(function(Me){function Te(Fe){return te(Fe)?{include:Qe.from(Fe.include)??void 0,exclude:Qe.from(Fe.exclude)??void 0}:Qe.from(Fe)??void 0}Me.from=Te;function Se(Fe){return te(Fe)?{include:Qe.to(Fe.include),exclude:Qe.to(Fe.exclude)}:Qe.to(Fe)}Me.to=Se;function te(Fe){const He=Fe;return He?!(0,b.$ue)(He.include)&&!(0,b.$ue)(He.exclude):!1}})(Qt||(e.NotebookExclusiveDocumentPattern=Qt={}));var Vt;(function(Me){function Te(Se,te,Fe){const He=typeof Se.command=="string"?{title:"",command:Se.command}:Se.command;return{alignment:Se.alignment===s.NotebookCellStatusBarAlignment.Left?1:2,command:te.toInternal(He,Fe),text:Se.text,tooltip:Se.tooltip,accessibilityInformation:Se.accessibilityInformation,priority:Se.priority}}Me.from=Te})(Vt||(e.NotebookStatusBarItem=Vt={}));var vt;(function(Me){function Te(Se,te,Fe){const He=typeof Se.command=="string"?{title:"",command:Se.command}:Se.command;return{command:te.toInternal(He,Fe),label:Se.label,description:Se.description,detail:Se.detail,documentation:Se.documentation}}Me.from=Te})(vt||(e.NotebookKernelSourceAction=vt={}));var Tt;(function(Me){function Te(Se){return{transientOutputs:Se?.transientOutputs??!1,transientCellMetadata:Se?.transientCellMetadata??{},transientDocumentMetadata:Se?.transientDocumentMetadata??{},cellContentMetadata:Se?.cellContentMetadata??{}}}Me.from=Te})(Tt||(e.NotebookDocumentContentOptions=Tt={}));var Nt;(function(Me){function Te(te){return{uri:te.uri,provides:te.provides}}Me.from=Te;function Se(te){return new s.$mL(S.URI.revive(te.uri),te.provides)}Me.to=Se})(Nt||(e.NotebookRendererScript=Nt={}));var Kt;(function(Me){function Te(te){return{message:T.fromStrict(te.message)||"",type:0,expected:te.expectedOutput,actual:te.actualOutput,contextValue:te.contextValue,location:te.location&&{range:n.from(te.location.range),uri:te.location.uri}}}Me.from=Te;function Se(te){const Fe=new s.$sL(typeof te.message=="string"?te.message:T.to(te.message));return Fe.actualOutput=te.actual,Fe.expectedOutput=te.expected,Fe.contextValue=te.contextValue,Fe.location=te.location?V.to(te.location):void 0,Fe}Me.to=Se})(Kt||(e.TestMessage=Kt={}));var At;(function(Me){Me.namespace=f.$JI,Me.denamespace=f.$KI})(At||(e.TestTag=At={}));var Rt;(function(Me){function Te(te){const Fe=(0,i.$QL)(te).controllerId;return{extId:p.$FI.fromExtHostTestItem(te,Fe).toString(),label:te.label,uri:S.URI.revive(te.uri),busy:te.busy,tags:te.tags.map(He=>At.namespace(Fe,He.id)),range:C.$hs.lift(n.from(te.range)),description:te.description||null,sortText:te.sortText||null,error:te.error&&T.fromStrict(te.error)||null}}Me.from=Te;function Se(te){return{parent:void 0,error:void 0,id:p.$FI.fromString(te.extId).localId,label:te.label,uri:S.URI.revive(te.uri),tags:(te.tags||[]).map(Fe=>{const{tagId:He}=At.denamespace(Fe);return new s.$tL(He)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:n.to(te.range||void 0),canResolveChildren:!1,busy:te.busy,description:te.description||void 0,sortText:te.sortText||void 0}}Me.toPlain=Se})(Rt||(e.TestItem=Rt={})),function(Me){function Te(te){return{id:te.id}}Me.from=Te;function Se(te){return new s.$tL(te.id)}Me.to=Se}(At||(e.TestTag=At={}));var Ot;(function(Me){const Te=(te,Fe)=>{const He=[];for(const[Je,rt]of Fe)p.$FI.compare(rt.item.extId,Je)===2&&(Fe.delete(Je),He.push(rt));const _e={...Rt.toPlain(te.item),parent:void 0,taskStates:te.tasks.map(Je=>({state:Je.state,duration:Je.duration,messages:Je.messages.filter(rt=>rt.type===0).map(Kt.to)})),children:He.map(Je=>Te(Je,Fe))};for(const Je of _e.children)Je.parent=_e;return _e};function Se(te){const Fe=[],He=new Map;for(const _e of te.items){He.set(_e.item.extId,_e);const Je=p.$FI.root(_e.item.extId);te.request.targets.some(rt=>rt.controllerId===Je&&rt.testIds.includes(_e.item.extId))&&Fe.push(_e)}return{completedAt:te.completedAt,results:Fe.map(_e=>Te(_e,He))}}Me.to=Se})(Ot||(e.TestResults=Ot={}));var Ut;(function(Me){function Te(He){return{covered:He.covered,total:He.covered}}function Se(He){return"line"in He?d.from(He):n.from(He)}function te(He){return"branches"in He?{count:He.executionCount,location:Se(He.location),type:1,branches:He.branches.length?He.branches.map(_e=>({count:_e.executionCount,location:_e.location&&Se(_e.location)})):void 0}:{type:0,count:He.executionCount,location:Se(He.location)}}Me.fromDetailed=te;function Fe(He){return{uri:He.uri,statement:Te(He.statementCoverage),branch:He.branchCoverage&&Te(He.branchCoverage),function:He.functionCoverage&&Te(He.functionCoverage),details:He.detailedCoverage?.map(te)}}Me.fromFile=Fe})(Ut||(e.TestCoverage=Ut={}));var qt;(function(Me){function Te(Se){switch(Se){case 1:return s.CodeActionTriggerKind.Invoke;case 2:return s.CodeActionTriggerKind.Automatic}}Me.to=Te})(qt||(e.CodeActionTriggerKind=qt={}));var Bt;(function(Me){function Te(te){const Fe=new s.$zL(q.to(te.kind),te.name,te.detail||"",S.URI.revive(te.uri),n.to(te.range),n.to(te.selectionRange));return Fe._sessionId=te._sessionId,Fe._itemId=te._itemId,Fe}Me.to=Te;function Se(te,Fe,He){if(Fe=Fe??te._sessionId,He=He??te._itemId,Fe===void 0||He===void 0)throw new Error("invalid item");return{_sessionId:Fe,_itemId:He,kind:q.from(te.kind),name:te.name,detail:te.detail??"",uri:te.uri,range:n.from(te.range),selectionRange:n.from(te.selectionRange),tags:te.tags?.map(ee.from)}}Me.from=Se})(Bt||(e.TypeHierarchyItem=Bt={}));var ct;(function(Me){function Te(Se){if(Se)return{value:Se.value,tooltip:Se.tooltip}}Me.from=Te})(ct||(e.ViewBadge=ct={}));var lt;(function(Me){function Te(He,_e,Je){const rt=_e.fileData;return rt?new s.$KK(new s.$LK(rt.name,S.URI.revive(rt.uri),rt.id,(0,R.$bb)(()=>Je(rt.id)))):He===P.$Er.uriList&&_e.uriListData?new s.$JK(Fe(_e.uriListData)):new s.$JK(_e.asString)}Me.to=Te;async function Se(He,_e){const Je=await _e.asString();if(He===P.$Er.uriList)return{asString:Je,fileData:void 0,uriListData:te(Je)};const rt=_e.asFile();return{asString:Je,fileData:rt?{name:rt.name,uri:rt.uri,id:rt._itemId??rt.id}:void 0}}Me.from=Se;function te(He){return h.$Qs.split(He).map(_e=>{if(_e.startsWith("#"))return _e;try{return S.URI.parse(_e)}catch{}return _e})}function Fe(He){return h.$Qs.create(He.map(_e=>typeof _e=="string"?_e:S.URI.revive(_e)))}})(lt||(e.DataTransferItem=lt={}));var Jt;(function(Me){function Te(te,Fe){const He=te.items.map(([_e,Je])=>[_e,lt.to(_e,Je,Fe)]);return new s.$MK(He)}Me.toDataTransfer=Te;async function Se(te){const Fe={items:[]},He=[];for(const[_e,Je]of te)He.push((async()=>{Fe.items.push([_e,await lt.from(_e,Je)])})());return await Promise.all(He),Fe}Me.from=Se})(Jt||(e.DataTransfer=Jt={}));var Pt;(function(Me){function Te(te){return{message:te.message,metadata:te.metadata,title:te.title,tooltip:te.tooltip}}Me.to=Te;function Se(te){return{kind:"reply",message:te.message,metadata:te.metadata,title:te.title,tooltip:te.tooltip}}Me.from=Se})(Pt||(e.ChatReplyFollowup=Pt={}));var kt;(function(Me){function Te(Se){return typeof Se=="string"?{title:Se,message:Se,kind:"reply"}:"commandId"in Se?{kind:"command",title:Se.title??"",commandId:Se.commandId??"",when:Se.when??"",args:Se.args}:Pt.from(Se)}Me.from=Te})(kt||(e.ChatFollowup=kt={}));var dt;(function(Me){function Te(te){const Fe=new s.$JL(Ct.to(te.role),te.content);return Fe.name=te.name,Fe}Me.to=Te;function Se(te){return{role:Ct.from(te.role),content:te.content,name:te.name}}Me.from=Se})(dt||(e.ChatMessage=dt={}));var Ct;(function(Me){function Te(te){switch(te){case 0:return s.ChatMessageRole.System;case 1:return s.ChatMessageRole.User;case 2:return s.ChatMessageRole.Assistant;case 3:return s.ChatMessageRole.Function}}Me.to=Te;function Se(te){switch(te){case s.ChatMessageRole.System:return 0;case s.ChatMessageRole.Assistant:return 2;case s.ChatMessageRole.Function:return 3;case s.ChatMessageRole.User:default:return 1}}Me.from=Se})(Ct||(e.ChatMessageRole=Ct={}));var Ft;(function(Me){function Te(te){return{level:Et.to(te.level),value:te.value,description:te.description}}Me.to=Te;function Se(te){return{level:Et.from(te.level),value:te.value,description:te.description}}Me.from=Se})(Ft||(e.ChatVariable=Ft={}));var Et;(function(Me){function Te(te){switch(te){case"short":return s.ChatVariableLevel.Short;case"medium":return s.ChatVariableLevel.Medium;case"full":default:return s.ChatVariableLevel.Full}}Me.to=Te;function Se(te){switch(te){case s.ChatVariableLevel.Short:return"short";case s.ChatVariableLevel.Medium:return"medium";case s.ChatVariableLevel.Full:default:return"full"}}Me.from=Se})(Et||(e.ChatVariableLevel=Et={}));var Ge;(function(Me){function Te(Se){switch(Se){case 1:return s.InteractiveEditorResponseFeedbackKind.Helpful;case 0:return s.InteractiveEditorResponseFeedbackKind.Unhelpful;case 2:return s.InteractiveEditorResponseFeedbackKind.Undone;case 3:return s.InteractiveEditorResponseFeedbackKind.Accepted}}Me.to=Te})(Ge||(e.InteractiveEditorResponseFeedbackKind=Ge={}));var zt;(function(Me){function Te(Se,te,Fe){return"terminalCommand"in Se?{terminalCommand:Se.terminalCommand}:"uri"in Se?{uri:Se.uri}:te.toInternal(Se,Fe)}Me.from=Te})(zt||(e.TerminalQuickFix=zt={}))}),define(De[271],Ce([1,0,2,8,7,10,72]),function($e,e,D,M,h,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pac=void 0;class g{constructor($,P,I,b={timeout:1500,errors:3}){this.c=$,this.d=P,this.f=I,this.g=b,this.a=new A.$vb,this.b=new WeakMap}dispose(){this.a.clear()}getOnWillSaveTextDocumentEvent($){return(P,I,b)=>{const C={dispose:this.a.push([P,I,$])};return Array.isArray(b)&&b.push(C),C}}async $participateInSave($,P){const I=D.URI.revive($);let b=!1;const S=setTimeout(()=>b=!0,this.g.timeout),C=[];try{for(const y of[...this.a]){if(b)break;const r=this.d.getDocument(I),i=await this.h(y,{document:r,reason:R.TextDocumentSaveReason.to(P)});C.push(i)}}finally{clearTimeout(S)}return C}h([$,P,I],b){const S=this.b.get($);return typeof S=="number"&&S>this.g.errors?Promise.resolve(!1):this.i(I,$,P,b).then(()=>!0,C=>{if(this.c.error(`onWillSaveTextDocument-listener from extension '${I.identifier.value}' threw ERROR`),this.c.error(C),!(C instanceof Error)||C.message!=="concurrent_edits"){const y=this.b.get($);this.b.set($,y?y+1:1),typeof y=="number"&&y>this.g.errors&&this.c.info(`onWillSaveTextDocument-listener from extension '${I.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}i($,P,I,b){const S=[],C=Date.now(),{document:y,reason:r}=b,{version:i}=y,a=Object.freeze({document:y,reason:r,waitUntil(m){if(Object.isFrozen(S))throw(0,M.$6)("waitUntil can not be called async");S.push(Promise.resolve(m))}});try{P.apply(I,[a])}catch(m){return Promise.reject(m)}return Object.freeze(S),new Promise((m,p)=>{const f=setTimeout(()=>p(new Error("timeout")),this.g.timeout);return Promise.all(S).then(t=>{this.c.debug(`onWillSaveTextDocument-listener from extension '${$.identifier.value}' finished after ${Date.now()-C}ms`),clearTimeout(f),m(t)}).catch(t=>{clearTimeout(f),p(t)})}).then(m=>{const p={edits:[]};for(const f of m)if(Array.isArray(f)&&f.every(t=>t instanceof h.$2J))for(const{newText:t,newEol:s,range:o}of f)p.edits.push({resource:y.uri,versionId:void 0,textEdit:{range:o&&R.Range.from(o),text:t,eol:s&&R.EndOfLine.from(s)}});if(p.edits.length!==0)return i===y.version?this.f.$tryApplyWorkspaceEdit(p):Promise.reject(new Error("concurrent_edits"))})}}e.$Pac=g}),define(De[272],Ce([1,0,16,2,10,7,107]),function($e,e,D,M,h,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4bc=e.$3bc=void 0;class g{constructor(I,b,S,C){this.start=I,this.deletedCount=b,this.deletedItems=S,this.items=C}asApiEvent(){return{range:new R.$gL(this.start,this.start+this.deletedCount),addedCells:this.items.map(I=>I.apiCell),removedCells:this.deletedItems}}}class E{static asModelAddData(I,b){return{EOL:b.eol,lines:b.source,languageId:b.language,uri:b.uri,isDirty:!1,versionId:1,notebook:I}}constructor(I,b,S){this.notebook=I,this.h=b,this.j=S,this.handle=S.handle,this.uri=M.URI.revive(S.uri),this.cellKind=S.cellKind,this.a=S.outputs.map(h.NotebookCellOutput.to),this.e=S.internalMetadata??{},this.b=Object.freeze(S.metadata??{}),this.d=Object.freeze(h.NotebookCellExecutionSummary.to(S.internalMetadata??{}))}get internalMetadata(){return this.e}get apiCell(){if(!this.f){const I=this,b=this.h.getDocument(this.uri);if(!b)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);const S={get index(){return I.notebook.getCellIndex(I)},notebook:I.notebook.apiNotebook,kind:h.NotebookCellKind.to(this.j.cellKind),document:b.document,get mime(){return I.g},set mime(C){I.g=C},get outputs(){return I.a.slice(0)},get metadata(){return I.b},get executionSummary(){return I.d}};this.f=Object.freeze(S)}return this.f}setOutputs(I){this.a=I.map(h.NotebookCellOutput.to)}setOutputItems(I,b,S){const C=S.map(h.NotebookCellOutputItem.to),y=this.a.find(r=>r.id===I);if(y&&(b||(y.items.length=0),y.items.push(...C),y.items.length>1&&y.items.every(r=>A.$ZH(r.mime)))){const r=new Map,i=[];y.items.forEach(a=>{let m;r.has(a.mime)?m=r.get(a.mime):(m=[],r.set(a.mime,m),i.push(a.mime)),m.push(a.data)}),y.items.length=0,i.forEach(a=>{const m=A.$1H(r.get(a));y.items.push({mime:a,data:m.data.buffer})})}}setMetadata(I){this.b=Object.freeze(I)}setInternalMetadata(I){this.e=I,this.d=Object.freeze(h.NotebookCellExecutionSummary.to(I))}setMime(I){}}e.$3bc=E;class ${static{this.a=0}constructor(I,b,S,C,y){this.k=I,this.l=b,this.m=S,this.uri=C,this.handle=$.a++,this.b=[],this.g=0,this.h=!1,this.j=!1,this.d=y.viewType,this.f=Object.freeze(y.metadata??Object.create(null)),this.r([[0,0,y.cells]],!0,void 0),this.g=y.versionId}dispose(){this.j=!0}get versionId(){return this.g}get apiNotebook(){if(!this.e){const I=this,b={get uri(){return I.uri},get version(){return I.g},get notebookType(){return I.d},get isDirty(){return I.h},get isUntitled(){return I.uri.scheme===D.Schemas.untitled},get isClosed(){return I.j},get metadata(){return I.f},get cellCount(){return I.b.length},cellAt(S){return S=I.n(S),I.b[S].apiCell},getCells(S){return(S?I.p(S):I.b).map(y=>y.apiCell)},save(){return I.q()}};this.e=Object.freeze(b)}return this.e}acceptDocumentPropertiesChanged(I){I.metadata&&(this.f=Object.freeze({...this.f,...I.metadata}))}acceptDirty(I){this.h=I}acceptModelChanged(I,b,S){this.g=I.versionId,this.h=b,this.acceptDocumentPropertiesChanged({metadata:S});const C={notebook:this.apiNotebook,metadata:S,cellChanges:[],contentChanges:[]},y=[];for(const i of I.rawEvents)i.kind===A.NotebookCellsChangeType.ModelChange?this.r(i.changes,!1,C.contentChanges):i.kind===A.NotebookCellsChangeType.Move?this.s(i.index,i.length,i.newIdx,C.contentChanges):i.kind===A.NotebookCellsChangeType.Output?(this.t(i.index,i.outputs),y.push({cell:this.b[i.index].apiCell,outputs:this.b[i.index].apiCell.outputs})):i.kind===A.NotebookCellsChangeType.OutputItem?(this.u(i.index,i.outputId,i.append,i.outputItems),y.push({cell:this.b[i.index].apiCell,outputs:this.b[i.index].apiCell.outputs})):i.kind===A.NotebookCellsChangeType.ChangeCellLanguage?(this.v(i.index,i.language),y.push({cell:this.b[i.index].apiCell,document:this.b[i.index].apiCell.document})):i.kind===A.NotebookCellsChangeType.ChangeCellContent?y.push({cell:this.b[i.index].apiCell,document:this.b[i.index].apiCell.document}):i.kind===A.NotebookCellsChangeType.ChangeCellMime?this.w(i.index,i.mime):i.kind===A.NotebookCellsChangeType.ChangeCellMetadata?(this.x(i.index,i.metadata),y.push({cell:this.b[i.index].apiCell,metadata:this.b[i.index].apiCell.metadata})):i.kind===A.NotebookCellsChangeType.ChangeCellInternalMetadata&&(this.y(i.index,i.internalMetadata),y.push({cell:this.b[i.index].apiCell,executionSummary:this.b[i.index].apiCell.executionSummary}));const r=new Map;for(let i=0;i<y.length;i++){const a=y[i],m=r.get(a.cell);if(m===void 0){const p=C.cellChanges.push({document:void 0,executionSummary:void 0,metadata:void 0,outputs:void 0,...a});r.set(a.cell,p-1)}else C.cellChanges[m]={...C.cellChanges[m],...a}}return Object.freeze(C),Object.freeze(C.cellChanges),Object.freeze(C.contentChanges),C}n(I){return I=I|0,I<0?0:I>=this.b.length?this.b.length-1:I}o(I){let b=I.start|0,S=I.end|0;return b<0&&(b=0),S>this.b.length&&(S=this.b.length),I.with({start:b,end:S})}p(I){I=this.o(I);const b=[];for(let S=I.start;S<I.end;S++)b.push(this.b[S]);return b}async q(){return this.j?Promise.reject(new Error("Notebook has been closed")):this.k.$trySaveNotebook(this.uri)}r(I,b,S){if(this.j)return;const C=[],y=[],r=[];if(I.reverse().forEach(i=>{const m=i[2].map(t=>{const s=new E(this,this.l,t);return b||y.push(E.asModelAddData(this.apiNotebook,t)),s}),p=new g(i[0],i[1],[],m),f=this.b.splice(i[0],i[1],...m);for(const t of f)r.push(t.uri),p.deletedItems.push(t.apiCell);C.push(p)}),this.l.acceptDocumentsAndEditorsDelta({addedDocuments:y,removedDocuments:r}),S)for(const i of C)S.push(i.asApiEvent())}s(I,b,S,C){const y=this.b.splice(I,b);this.b.splice(S,0,...y);const r=[new g(I,b,y.map(i=>i.apiCell),[]),new g(S,0,[],y)];for(const i of r)C.push(i.asApiEvent())}t(I,b){this.b[I].setOutputs(b)}u(I,b,S,C){this.b[I].setOutputItems(b,S,C)}v(I,b){const S=this.b[I];S.apiCell.document.languageId!==b&&this.m.$acceptModelLanguageChanged(S.uri,b)}w(I,b){const S=this.b[I];S.apiCell.mime=b}x(I,b){this.b[I].setMetadata(b)}y(I,b){this.b[I].setInternalMetadata(b)}getCellFromApiCell(I){return this.b.find(b=>b.apiCell===I)}getCellFromIndex(I){return this.b[I]}getCell(I){return this.b.find(b=>b.handle===I)}getCellIndex(I){return this.b.indexOf(I)}}e.$4bc=$}),define(De[273],Ce([1,0,4,2,10,7]),function($e,e,D,M,h,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rcc=void 0;class A{constructor(E,$,P,I={timeout:1500,errors:3}){this.b=E,this.c=$,this.d=P,this.f=I,this.a=new D.$jc}dispose(){}getOnWillSaveNotebookDocumentEvent(E){return($,P,I)=>{const b=function(C){$.call(P,C)};return b.extension=E,this.a.event(b,void 0,I)}}async $participateInSave(E,$,P){const I=M.URI.revive(E),b=this.c.getNotebookDocument(I);if(!b)throw new Error("Unable to resolve notebook document");const S=[];if(await this.a.fireAsync({notebook:b.apiNotebook,reason:h.TextDocumentSaveReason.to($)},P,async(y,r)=>{const i=Date.now(),a=await await Promise.resolve(y);Date.now()-i>this.f.timeout&&this.b.warn("onWillSaveNotebookDocument-listener from extension",r.extension.identifier),!P.isCancellationRequested&&a&&(a instanceof R.$5J?S.push(a):this.b.warn("onWillSaveNotebookDocument-listener from extension",r.extension.identifier,"ignored due to invalid data"))}),P.isCancellationRequested)return!1;if(S.length===0)return!0;const C={edits:[]};for(const y of S){const{edits:r}=h.WorkspaceEdit.from(y);C.edits=C.edits.concat(r)}return this.d.$tryApplyWorkspaceEdit(C)}}e.$rcc=A}),define(De[143],Ce([1,0,8,10,7]),function($e,e,D,M,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5bc=void 0;class R{static{this.apiEditorsToExtHost=new WeakMap}constructor(g,E,$,P,I,b){this.id=g,this.f=E,this.notebookData=$,this.a=[],this.b=[],this.d=!1,this.a=I,this.b=P,this.c=b}get apiEditor(){if(!this.e){const g=this;this.e={get notebook(){return g.notebookData.apiNotebook},get selection(){return g.a[0]},set selection(E){this.selections=[E]},get selections(){return g.a},set selections(E){if(!Array.isArray(E)||!E.every(h.$gL.isNotebookRange))throw(0,D.$5)("selections");g.a=E,g.g(E)},get visibleRanges(){return g.b},revealRange(E,$){g.f.$tryRevealRange(g.id,M.NotebookRange.from(E),$??h.NotebookEditorRevealType.Default)},get viewColumn(){return g.c}},R.apiEditorsToExtHost.set(this.e,this)}return this.e}get visible(){return this.d}_acceptVisibility(g){this.d=g}_acceptVisibleRanges(g){this.b=g}_acceptSelections(g){this.a=g}g(g){this.f.$trySetSelections(this.id,g.map(M.NotebookRange.from))}_acceptViewColumn(g){this.c=g}}e.$5bc=R}),define(De[274],Ce([1,0,8,4,17,10]),function($e,e,D,M,h,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kcc=void 0;let A=class{constructor(E,$){this.c=E,this.d=$,this.a=new M.$hc({onListenerError:D.$Z}),this.b=new M.$hc({onListenerError:D.$Z}),this.onDidChangeNotebookEditorSelection=this.a.event,this.onDidChangeNotebookEditorVisibleRanges=this.b.event}$acceptEditorPropertiesChanged(E,$){this.c.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",E,$);const P=this.d.getEditorById(E);$.visibleRanges&&P._acceptVisibleRanges($.visibleRanges.ranges.map(R.NotebookRange.to)),$.selections&&P._acceptSelections($.selections.selections.map(R.NotebookRange.to)),$.visibleRanges&&this.b.fire({notebookEditor:P.apiEditor,visibleRanges:P.apiEditor.visibleRanges}),$.selections&&this.a.fire(Object.freeze({notebookEditor:P.apiEditor,selections:P.apiEditor.selections}))}$acceptEditorViewColumns(E){for(const $ in E)this.d.getEditorById($)._acceptViewColumn(R.ViewColumn.to(E[$]))}};e.$kcc=A,e.$kcc=A=Ke([Ve(0,h.$3i)],A)}),define(De[275],Ce([1,0,10,83,203,22,70,8]),function($e,e,D,M,h,R,A,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$obc=void 0;class E{constructor(b){this.b=0,this.c=new Map,this.a=b}async withProgress(b,S,C){const y=this.b++,{title:r,location:i,cancellable:a}=S,m={label:(0,h.localize)(0,null,b.displayName||b.name),id:b.identifier.value};return this.a.$startProgress(y,{location:D.ProgressLocation.from(i),title:r,source:m,cancellable:a},b.isUnderDevelopment?void 0:b.identifier.value).catch(g.$Z),this.d(y,C,!!a)}d(b,S,C){let y;C&&(y=new R.$rc,this.c.set(b,y));const r=a=>{this.a.$progressEnd(a),this.c.delete(a),y?.dispose()};let i;try{i=S(new P(this.a,b),C&&y?y.token:R.CancellationToken.None)}catch(a){throw r(b),a}return i.then(a=>r(b),a=>r(b)),i}$acceptProgressCanceled(b){const S=this.c.get(b);S&&(S.cancel(),this.c.delete(b))}}e.$obc=E;function $(I,b){return I.message=b.message,typeof b.increment=="number"&&(typeof I.increment=="number"?I.increment+=b.increment:I.increment=b.increment),I}class P extends M.$1u{constructor(b,S){super(C=>this.throttledReport(C)),this.f=b,this.g=S}throttledReport(b){this.f.$progressReport(this.g,b)}}Ke([(0,A.$6g)(100,(I,b)=>$(I,b),()=>Object.create(null))],P.prototype,"throttledReport",null)}),define(De[144],Ce([1,0,34,141,63,108,87,10,2]),function($e,e,D,M,h,R,A,g,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0L=e.$9L=e.$8L=e.$7L=void 0;const $=(m,p,f,t)=>{let s=p;return{enumerable:!0,configurable:!1,get(){return s},set(o){if(!f(s,o)){const n=s;s=o,m.listener?.(t(o,n))}}}},P=(m,p)=>m===p,I={range:(m,p)=>m===p?!0:!m||!p?!1:m.isEqual(p),label:P,description:P,sortText:P,busy:P,error:P,canResolveChildren:P,tags:(m,p)=>!(m.length!==p.length||m.some(f=>!p.find(t=>f.id===t.id)))},b=m=>p=>({op:4,update:m(p)}),S=(m,p)=>({range:(()=>{let f;const t=b(s=>({range:D.$hs.lift(g.Range.from(s))}));return{enumerable:!0,configurable:!1,get(){return f},set(s){m.listener?.({op:6}),I.range(f,s)||(f=s,m.listener?.(t(s)))}}})(),label:$(m,p,I.label,b(f=>({label:f}))),description:$(m,void 0,I.description,b(f=>({description:f}))),sortText:$(m,void 0,I.sortText,b(f=>({sortText:f}))),canResolveChildren:$(m,!1,I.canResolveChildren,f=>({op:2,state:f})),busy:$(m,!1,I.busy,b(f=>({busy:f}))),error:$(m,void 0,I.error,b(f=>({error:g.MarkdownString.fromStrict(f)||null}))),tags:$(m,[],I.tags,(f,t)=>({op:1,new:f.map(g.TestTag.from),old:t.map(g.TestTag.from)}))}),C=m=>{const p=h.$FI.fromString(m.extId),f=new r(p.controllerId,p.localId,m.label,E.URI.revive(m.uri)||void 0);return f.range=g.Range.to(m.range||void 0),f.description=m.description||void 0,f.sortText=m.sortText||void 0,f.tags=m.tags.map(t=>g.TestTag.to({id:(0,A.$KI)(t).tagId})),f},y=m=>{let p;for(const f of m.tests){const t=C(f.item);(0,M.$QL)(t).parent=p,p=t}return p};e.$7L=y;class r{constructor(p,f,t,s){if(f.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(f)} symbol`);const o=(0,M.$PL)(this,p);Object.defineProperties(this,{id:{value:f,enumerable:!0,writable:!1},uri:{value:s,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return o.parent instanceof i?void 0:o.parent}},children:{value:(0,R.$OL)(o,M.$QL,r),enumerable:!0,writable:!1},...S(o,t)})}}e.$8L=r;class i extends r{constructor(p,f){super(p,p,f,void 0),this._isRoot=!0}}e.$9L=i;class a extends R.$KL{constructor(p,f,t){super({controllerId:p,getDocumentVersion:s=>s&&t.getDocument(s)?.version,getApiFor:M.$QL,getChildren:s=>s.children,root:new i(p,f),toITestItem:g.TestItem.from})}}e.$0L=a}),define(De[145],Ce([1,0,54,8,118,10,7]),function($e,e,D,M,h,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4L=e.$3L=e.$2L=void 0;class g{static{this.c=new h.$ZL("TextEditorDecorationType")}constructor(b,S,C){const y=g.c.nextId();b.$registerTextEditorDecorationType(S.identifier,y,R.DecorationRenderOptions.from(C)),this.value=Object.freeze({key:y,dispose(){b.$removeTextEditorDecorationType(y)}})}}e.$2L=g;class E{constructor(b,S){this.g=[],this.h=void 0,this.j=!1,this.c=b,this.d=b.version,this.e=S.undoStopBefore,this.f=S.undoStopAfter}finalize(){return this.j=!0,{documentVersionId:this.d,edits:this.g,setEndOfLine:this.h,undoStopBefore:this.e,undoStopAfter:this.f}}k(){if(this.j)throw new Error("Edit is only valid while callback runs")}replace(b,S){this.k();let C=null;if(b instanceof A.$VJ)C=new A.$WJ(b,b);else if(b instanceof A.$WJ)C=b;else throw new Error("Unrecognized location");this.l(C,S,!1)}insert(b,S){this.k(),this.l(new A.$WJ(b,b),S,!0)}delete(b){this.k();let S=null;if(b instanceof A.$WJ)S=b;else throw new Error("Unrecognized location");this.l(S,null,!0)}l(b,S,C){const y=this.c.validateRange(b);this.g.push({range:y,text:S,forceMoveMarkers:C})}setEndOfLine(b){if(this.k(),b!==A.EndOfLine.LF&&b!==A.EndOfLine.CRLF)throw(0,M.$5)("endOfLine");this.h=b}}class ${constructor(b,S,C,y){this.c=b,this.d=S,this._accept(C),this.e=y;const r=this;this.value={get tabSize(){return r.f},set tabSize(i){r.m(i)},get indentSize(){return r.g},set indentSize(i){r.o(i)},get insertSpaces(){return r.h},set insertSpaces(i){r.q(i)},get cursorStyle(){return r.j},set cursorStyle(i){r.s(i)},get lineNumbers(){return r.k},set lineNumbers(i){r.t(i)}}}_accept(b){this.f=b.tabSize,this.g=b.indentSize,this.h=b.insertSpaces,this.j=b.cursorStyle,this.k=R.TextEditorLineNumbersStyle.to(b.lineNumbers)}l(b){if(b==="auto")return"auto";if(typeof b=="number"){const S=Math.floor(b);return S>0?S:null}if(typeof b=="string"){const S=parseInt(b,10);return isNaN(S)?null:S>0?S:null}return null}m(b){const S=this.l(b);if(S!==null){if(typeof S=="number"){if(this.f===S)return;this.f=S}this.u("setTabSize",this.c.$trySetOptions(this.d,{tabSize:S}))}}n(b){if(b==="tabSize")return"tabSize";if(typeof b=="number"){const S=Math.floor(b);return S>0?S:null}if(typeof b=="string"){const S=parseInt(b,10);return isNaN(S)?null:S>0?S:null}return null}o(b){const S=this.n(b);if(S!==null){if(typeof S=="number"){if(this.g===S)return;this.g=S}this.u("setIndentSize",this.c.$trySetOptions(this.d,{indentSize:S}))}}p(b){return b==="auto"?"auto":b==="false"?!1:!!b}q(b){const S=this.p(b);if(typeof S=="boolean"){if(this.h===S)return;this.h=S}this.u("setInsertSpaces",this.c.$trySetOptions(this.d,{insertSpaces:S}))}s(b){this.j!==b&&(this.j=b,this.u("setCursorStyle",this.c.$trySetOptions(this.d,{cursorStyle:b})))}t(b){this.k!==b&&(this.k=b,this.u("setLineNumbers",this.c.$trySetOptions(this.d,{lineNumbers:R.TextEditorLineNumbersStyle.from(b)})))}assign(b){const S={};let C=!1;if(typeof b.tabSize<"u"){const y=this.l(b.tabSize);y==="auto"?(C=!0,S.tabSize=y):typeof y=="number"&&this.f!==y&&(this.f=y,C=!0,S.tabSize=y)}if(typeof b.indentSize<"u"){const y=this.n(b.indentSize);y==="tabSize"?(C=!0,S.indentSize=y):typeof y=="number"&&this.g!==y&&(this.g=y,C=!0,S.indentSize=y)}if(typeof b.insertSpaces<"u"){const y=this.p(b.insertSpaces);y==="auto"?(C=!0,S.insertSpaces=y):this.h!==y&&(this.h=y,C=!0,S.insertSpaces=y)}typeof b.cursorStyle<"u"&&this.j!==b.cursorStyle&&(this.j=b.cursorStyle,C=!0,S.cursorStyle=b.cursorStyle),typeof b.lineNumbers<"u"&&this.k!==b.lineNumbers&&(this.k=b.lineNumbers,C=!0,S.lineNumbers=R.TextEditorLineNumbersStyle.from(b.lineNumbers)),C&&this.u("setOptions",this.c.$trySetOptions(this.d,S))}u(b,S){S.catch(C=>{this.e.warn(`ExtHostTextEditorOptions '${b}' failed:'`),this.e.warn(C)})}}e.$3L=$;class P{constructor(b,S,C,y,r,i,a,m){this.id=b,this.j=S,this.k=C,this.g=!1,this.h=new Set,this.c=r,this.d=new $(this.j,this.id,i,C),this.e=a,this.f=m;const p=this;this.value=Object.freeze({get document(){return y.value},set document(f){throw new M.$7("document")},get selection(){return p.c&&p.c[0]},set selection(f){if(!(f instanceof A.$XJ))throw(0,M.$5)("selection");p.c=[f],p.l()},get selections(){return p.c},set selections(f){if(!Array.isArray(f)||f.some(t=>!(t instanceof A.$XJ)))throw(0,M.$5)("selections");p.c=f,p.l()},get visibleRanges(){return p.e},set visibleRanges(f){throw new M.$7("visibleRanges")},get options(){return p.d.value},set options(f){p.g||p.d.assign(f)},get viewColumn(){return p.f},set viewColumn(f){throw new M.$7("viewColumn")},edit(f,t={undoStopBefore:!0,undoStopAfter:!0}){if(p.g)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const s=new E(y.value,t);return f(s),p.m(s)},insertSnippet(f,t,s={undoStopBefore:!0,undoStopAfter:!0}){if(p.g)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let o;if(!t||Array.isArray(t)&&t.length===0)o=p.c.map(n=>R.Range.from(n));else if(t instanceof A.$VJ){const{lineNumber:n,column:c}=R.Position.from(t);o=[{startLineNumber:n,startColumn:c,endLineNumber:n,endColumn:c}]}else if(t instanceof A.$WJ)o=[R.Range.from(t)];else{o=[];for(const n of t)if(n instanceof A.$WJ)o.push(R.Range.from(n));else{const{lineNumber:c,column:d}=R.Position.from(n);o.push({startLineNumber:c,startColumn:d,endLineNumber:c,endColumn:d})}}return S.$tryInsertSnippet(b,y.value.version,f.value,o,s)},setDecorations(f,t){const s=t.length===0;s&&!p.h.has(f.key)||(s?p.h.delete(f.key):p.h.add(f.key),p.n(()=>{if(R.$RL(t))return S.$trySetDecorations(b,f.key,R.$SL(t));{const o=new Array(4*t.length);for(let n=0,c=t.length;n<c;n++){const d=t[n];o[4*n]=d.start.line+1,o[4*n+1]=d.start.character+1,o[4*n+2]=d.end.line+1,o[4*n+3]=d.end.character+1}return S.$trySetDecorationsFast(b,f.key,o)}}))},revealRange(f,t){p.n(()=>S.$tryRevealRange(b,R.Range.from(f),t||A.TextEditorRevealType.Default))},show(f){S.$tryShowEditor(b,R.ViewColumn.from(f))},hide(){S.$tryHideEditor(b)}})}dispose(){(0,D.ok)(!this.g),this.g=!0}_acceptOptions(b){(0,D.ok)(!this.g),this.d._accept(b)}_acceptVisibleRanges(b){(0,D.ok)(!this.g),this.e=b}_acceptViewColumn(b){(0,D.ok)(!this.g),this.f=b}_acceptSelections(b){(0,D.ok)(!this.g),this.c=b}async l(){const b=this.c.map(R.Selection.from);return await this.n(()=>this.j.$trySetSelections(this.id,b)),this.value}m(b){const S=b.finalize();if(S.edits.length===0&&!S.setEndOfLine)return Promise.resolve(!0);const C=S.edits.map(r=>r.range);C.sort((r,i)=>r.end.line===i.end.line?r.end.character===i.end.character?r.start.line===i.start.line?r.start.character-i.start.character:r.start.line-i.start.line:r.end.character-i.end.character:r.end.line-i.end.line);for(let r=0,i=C.length-1;r<i;r++){const a=C[r].end;if(C[r+1].start.isBefore(a))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const y=S.edits.map(r=>({range:R.Range.from(r.range),text:r.text,forceMoveMarkers:r.forceMoveMarkers}));return this.j.$tryApplyEdits(this.id,S.documentVersionId,y,{setEndOfLine:typeof S.setEndOfLine=="number"?R.EndOfLine.from(S.setEndOfLine):void 0,undoStopBefore:S.undoStopBefore,undoStopAfter:S.undoStopAfter})}n(b){return this.g?(this.k.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):b().then(()=>this,S=>(S instanceof Error&&S.name==="DISPOSED"||this.k.warn(S),null))}}e.$4L=P}),define(De[276],Ce([1,0,6,224]),function($e,e,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0I=void 0,e.$0I=(0,D.$Ah)(M.$Gh)}),define(De[146],Ce([1,0,25,4,14,3]),function($e,e,D,M,h,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$42b=e.$32b=e.$22b=e.$12b=e.$Z2b=void 0;class A{constructor(r){this.removedDueToLooping=r}}e.$Z2b=A;class g{static isHostExtension(r,i,a){if(i.getExtensionDescription(r))return!1;const m=a.getExtensionDescription(r);return m?!!((m.main||m.browser)&&m.api==="none"):!1}constructor(r,i){this.h=r,this.c=new M.$hc,this.onDidChange=this.c.event,this.d=i,this.j()}j(){this.d.sort(S),this.e=new D.$Vl,this.f=[],this.g=new Map;for(const r of this.d){if(this.e.has(r.identifier)){console.error("Extension `"+r.identifier.value+"` is already registered");continue}this.e.set(r.identifier,r),this.f.push(r);const i=this.h.readActivationEvents(r);if(Array.isArray(i))for(let a of i)a==="onUri"&&(a=`onUri:${D.$Tl.toKey(r.identifier)}`),this.g.has(a)||this.g.set(a,[]),this.g.get(a).push(r)}}set(r){this.d=r,this.j(),this.c.fire(void 0)}deltaExtensions(r,i){this.d=C(this.d,i),this.d=this.d.concat(r);const a=g.k(this.d);return this.d=C(this.d,a.map(m=>m.identifier)),this.j(),this.c.fire(void 0),new A(a)}static k(r){const i=new class{constructor(){this.c=new Map,this.d=new Set,this.e=[]}addNode(t){this.d.has(t)||(this.d.add(t),this.e.push(t))}addArc(t,s){this.addNode(t),this.addNode(s),this.c.has(t)?this.c.get(t).push(s):this.c.set(t,[s])}getArcs(t){return this.c.has(t)?this.c.get(t):[]}hasOnlyGoodArcs(t,s){const o=i.getArcs(t);for(let n=0;n<o.length;n++)if(!s.has(o[n]))return!1;return!0}getNodes(){return this.e}},a=new D.$Vl;for(const t of r)if(a.set(t.identifier,t),t.extensionDependencies)for(const s of t.extensionDependencies)i.addArc(D.$Tl.toKey(t.identifier),D.$Tl.toKey(s));const m=new Set;i.getNodes().filter(t=>i.getArcs(t).length===0).forEach(t=>m.add(t));const p=i.getNodes().filter(t=>!m.has(t));let f;do{f=!1;for(let t=0;t<p.length;t++){const s=p[t];i.hasOnlyGoodArcs(s,m)&&(p.splice(t,1),t--,m.add(s),f=!0)}}while(f);return p.map(t=>a.get(t))}containsActivationEvent(r){return this.g.has(r)}containsExtension(r){return this.e.has(r)}getExtensionDescriptionsForActivationEvent(r){const i=this.g.get(r);return i?i.slice(0):[]}getAllExtensionDescriptions(){return this.f.slice(0)}getExtensionDescription(r){const i=this.e.get(r);return i||void 0}getExtensionDescriptionByUUID(r){for(const i of this.f)if(i.uuid===r)return i}getExtensionDescriptionByIdOrUUID(r,i){return this.getExtensionDescription(r)??(i?this.getExtensionDescriptionByUUID(i):void 0)}}e.$12b=g,e.$22b={readActivationEvents:y=>y.activationEvents};class E{constructor(r){this.d=new I,this.c=new g(r,[])}async acquireLock(r){const i=await this.d.acquire(r);return new $(this,i)}deltaExtensions(r,i,a){if(!r.isAcquiredFor(this))throw new Error("Lock is not held");return this.c.deltaExtensions(i,a)}containsActivationEvent(r){return this.c.containsActivationEvent(r)}containsExtension(r){return this.c.containsExtension(r)}getExtensionDescriptionsForActivationEvent(r){return this.c.getExtensionDescriptionsForActivationEvent(r)}getAllExtensionDescriptions(){return this.c.getAllExtensionDescriptions()}getExtensionDescription(r){return this.c.getExtensionDescription(r)}getExtensionDescriptionByUUID(r){return this.c.getExtensionDescriptionByUUID(r)}getExtensionDescriptionByIdOrUUID(r,i){return this.c.getExtensionDescriptionByIdOrUUID(r,i)}}e.$32b=E;class $ extends R.$mb{constructor(r,i){super(),this.f=r,this.c=!1,this.B(i)}isAcquiredFor(r){return!this.c&&this.f===r}}e.$42b=$;class P{constructor(r){this.name=r,this.promise=new Promise((i,a)=>{this.c=i})}resolve(r){this.c(r)}}class I{constructor(){this.c=[],this.d=!1}async acquire(r){const i=new P(r);return this.c.push(i),this.e(),i.promise}e(){if(this.d||this.c.length===0)return;const r=this.c.shift();this.d=!0;let i=!0;const a=setTimeout(()=>{i&&console.warn(`The customer named ${r.name} has been holding on to the lock for 30s. This might be a problem.`)},30*1e3),m=()=>{i&&(clearTimeout(a),i=!1,this.d=!1,this.e())};r.resolve((0,R.$kb)(m))}}var b;(function(y){y[y.Builtin=0]="Builtin",y[y.User=1]="User",y[y.Dev=2]="Dev"})(b||(b={}));function S(y,r){const i=y.isBuiltin?0:y.isUnderDevelopment?2:1,a=r.isBuiltin?0:r.isUnderDevelopment?2:1;if(i!==a)return i-a;const m=h.$8c.basename(y.extensionLocation.path),p=h.$8c.basename(r.extensionLocation.path);return m<p?-1:m>p?1:0}function C(y,r){const i=new D.$Ul(r);return y.filter(a=>!i.has(a.identifier))}}),define(De[277],Ce([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pm=e.$om=e.$nm=e.$mm=e.$lm=e.ExtHostConnectionType=void 0;var D;(function(P){P[P.IPC=1]="IPC",P[P.Socket=2]="Socket",P[P.MessagePort=3]="MessagePort"})(D||(e.ExtHostConnectionType=D={}));class M{static{this.ENV_KEY="VSCODE_EXTHOST_IPC_HOOK"}constructor(I){this.pipeName=I,this.type=1}serialize(I){I[M.ENV_KEY]=this.pipeName}}e.$lm=M;class h{constructor(){this.type=2}static{this.ENV_KEY="VSCODE_EXTHOST_WILL_SEND_SOCKET"}serialize(I){I[h.ENV_KEY]="1"}}e.$mm=h;class R{constructor(){this.type=3}static{this.ENV_KEY="VSCODE_WILL_SEND_MESSAGE_PORT"}serialize(I){I[R.ENV_KEY]="1"}}e.$nm=R;function A(P){delete P[M.ENV_KEY],delete P[h.ENV_KEY],delete P[R.ENV_KEY]}function g(P,I){A(I),P.serialize(I)}e.$om=g;function E(P){if(P[M.ENV_KEY])return $(P,new M(P[M.ENV_KEY]));if(P[h.ENV_KEY])return $(P,new h);if(P[R.ENV_KEY])return $(P,new R);throw new Error("No connection information defined in environment!")}e.$pm=E;function $(P,I){return A(P),I}}),define(De[110],Ce([1,0,21]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLogMarkers=e.$3l=e.$2l=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0;var M;(function($){$[$.Desktop=1]="Desktop",$[$.Web=2]="Web"})(M||(e.UIKind=M={}));var h;(function($){$[$.VersionMismatch=55]="VersionMismatch",$[$.UnexpectedError=81]="UnexpectedError"})(h||(e.ExtensionHostExitCode=h={}));var R;(function($){$[$.Initialized=0]="Initialized",$[$.Ready=1]="Ready",$[$.Terminate=2]="Terminate"})(R||(e.MessageType=R={}));function A($){const P=D.$Hc.alloc(1);switch($){case 0:P.writeUInt8(1,0);break;case 1:P.writeUInt8(2,0);break;case 2:P.writeUInt8(3,0);break}return P}e.$2l=A;function g($,P){if($.byteLength!==1)return!1;switch($.readUInt8(0)){case 1:return P===0;case 2:return P===1;case 3:return P===2;default:return!1}}e.$3l=g;var E;(function($){$.Start="START_NATIVE_LOG",$.End="END_NATIVE_LOG"})(E||(e.NativeLogMarkers=E={}))}),define(De[88],Ce([1,0,6,4,17,26,110,60,85,23,2,3,205]),function($e,e,D,M,h,R,A,g,E,$,P,I,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cM=e.$bM=e.$aM=e.$_L=void 0;let S=class extends I.$mb{constructor(i,a){super(),this.n=i,this.p=a,this.a=this.B(new M.$hc),this.onDidChangeTelemetryEnabled=this.a.event,this.b=this.B(new M.$hc),this.onDidChangeTelemetryConfiguration=this.b.event,this.c={usage:!0,error:!0},this.f=0,this.g=!1,this.i=!1,this.m=new Map,this.j=P.URI.revive(this.n.environment.extensionTelemetryLogResource),this.i=this.n.environment.isExtensionTelemetryLoggingOnly,this.k=a.createLogger(this.j,{id:E.$co,name:(0,b.localize)(0,null,this.i?" (Not Sent)":""),hidden:!0}),this.B(a.onDidChangeLogLevel(m=>{(0,h.$5i)(m)&&this.r()})),this.k.info("Below are logs for extension telemetry events sent to the telemetry output channel API once the log level is set to trace."),this.k.info("===========================================================")}r(){this.p.setVisibility(this.j,this.g&&this.p.getLogLevel()===h.LogLevel.Trace)}getTelemetryConfiguration(){return this.f===3}getTelemetryDetails(){return{isCrashEnabled:this.f>=1,isErrorsEnabled:this.c.error?this.f>=2:!1,isUsageEnabled:this.c.usage?this.f>=3:!1}}instantiateLogger(i,a,m){const p=this.getTelemetryDetails(),f=new C(a,m,i,this.k,this.i,this.getBuiltInCommonProperties(i),{isUsageEnabled:p.isUsageEnabled,isErrorsEnabled:p.isErrorsEnabled}),t=this.m.get(i.identifier.value)??[];return this.m.set(i.identifier.value,[...t,f]),f.apiTelemetryLogger}$initializeTelemetryLevel(i,a,m){this.f=i,this.g=a,this.c=m??{usage:!0,error:!0},this.r()}getBuiltInCommonProperties(i){const a=Object.create(null);switch(a["common.extname"]=`${i.publisher}.${i.name}`,a["common.extversion"]=i.version,a["common.vscodemachineid"]=this.n.telemetryInfo.machineId,a["common.vscodesessionid"]=this.n.telemetryInfo.sessionId,a["common.vscodeversion"]=this.n.version,a["common.isnewappinstall"]=y(this.n.telemetryInfo.firstSessionDate),a["common.product"]=this.n.environment.appHost,this.n.uiKind){case A.UIKind.Web:a["common.uikind"]="web";break;case A.UIKind.Desktop:a["common.uikind"]="desktop";break;default:a["common.uikind"]="unknown"}return a["common.remotename"]=(0,g.$Nk)((0,E.$jo)(this.n.remote.authority)),a}$onDidChangeTelemetryLevel(i){this.h=this.getTelemetryConfiguration(),this.f=i;const a=this.getTelemetryDetails();this.m.forEach((m,p)=>{const f=m.filter(t=>!t.isDisposed);f.length===0?this.m.delete(p):this.m.set(p,f)}),this.m.forEach(m=>{for(const p of m)p.updateTelemetryEnablements(a.isUsageEnabled,a.isErrorsEnabled)}),this.h!==this.getTelemetryConfiguration()&&this.a.fire(this.getTelemetryConfiguration()),this.b.fire(this.getTelemetryDetails()),this.r()}onExtensionError(i,a){const p=this.m.get(i.value)?.filter(t=>!t.isDisposed);if(!p)return this.m.delete(i.value),!1;let f=!1;for(const t of p)t.ignoreUnhandledExtHostErrors||(t.logError(a),f=!0);return f}};e.$_L=S,e.$_L=S=Ke([Ve(0,R.$$L),Ve(1,h.$4i)],S);class C{static validateSender(i){if(typeof i!="object")throw new TypeError("TelemetrySender argument is invalid");if(typeof i.sendEventData!="function")throw new TypeError("TelemetrySender.sendEventData must be a function");if(typeof i.sendErrorData!="function")throw new TypeError("TelemetrySender.sendErrorData must be a function");if(typeof i.flush<"u"&&typeof i.flush!="function")throw new TypeError("TelemetrySender.flush must be a function or undefined")}constructor(i,a,m,p,f,t,s){this.g=m,this.h=p,this.i=f,this.j=t,this.a=new M.$hc,this.ignoreUnhandledExtHostErrors=a?.ignoreUnhandledErrors??!1,this.b=a?.ignoreBuiltInCommonProperties??!1,this.c=a?.additionalCommonProperties,this.f=i,this.d={isUsageEnabled:s.isUsageEnabled,isErrorsEnabled:s.isErrorsEnabled}}updateTelemetryEnablements(i,a){this.e&&(this.d={isUsageEnabled:i,isErrorsEnabled:a},this.a.fire(this.e))}mixInCommonPropsAndCleanData(i){let a="properties"in i?i.properties??{}:i;return a=(0,E.$mo)(a,[]),this.c&&(a=(0,$.$Wm)(a,this.c)),this.b||(a=(0,$.$Wm)(a,this.j)),"properties"in i?i.properties=a:i=a,i}k(i,a){this.f&&(this.g.publisher==="vscode"?i=this.g.name+"/"+i:i=this.g.identifier.value+"/"+i,a=this.mixInCommonPropsAndCleanData(a||{}),this.i||this.f?.sendEventData(i,a),this.h.trace(i,a))}logUsage(i,a){this.d.isUsageEnabled&&this.k(i,a)}logError(i,a){if(!(!this.d.isErrorsEnabled||!this.f))if(typeof i=="string")this.k(i,a);else{const m={name:i.name,message:i.message,stack:i.stack,cause:i.cause},p=(0,E.$mo)(m,[]),f=new Error(p.message,{cause:p.cause});f.stack=p.stack,f.name=p.name,a=this.mixInCommonPropsAndCleanData(a||{}),this.i||this.f.sendErrorData(f,a),this.h.trace("exception",a)}}get apiTelemetryLogger(){if(!this.e){const i=this,a={logUsage:i.logUsage.bind(i),get isUsageEnabled(){return i.d.isUsageEnabled},get isErrorsEnabled(){return i.d.isErrorsEnabled},logError:i.logError.bind(i),dispose:i.dispose.bind(i),onDidChangeEnableStates:i.a.event.bind(i)};this.e=Object.freeze(a)}return this.e}get isDisposed(){return!this.f}dispose(){if(this.f?.flush){let i=this.f;this.f=void 0,Promise.resolve(i.flush()).then(i=void 0),this.e=void 0}else this.f=void 0}}e.$aM=C;function y(r){const i=Date.now()-new Date(r).getTime();return isNaN(i)?!1:i<1e3*60*60*24}e.$bM=y,e.$cM=(0,D.$zh)("IExtHostTelemetry")}),define(De[27],Ce([1,0,4,2,246,136,25,6]),function($e,e,D,M,h,R,A,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$RF=e.$QF=e.$PF=e.ActivationKind=e.$OF=e.$NF=e.$MF=e.$LF=e.$KF=e.ExtensionHostStartup=e.$JF=e.$IF=e.$HF=e.$GF=void 0,e.$GF=Object.freeze({identifier:new A.$Tl("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:M.URI.parse("void:location"),isBuiltin:!1,targetPlatform:"undefined",isUserBuiltin:!1,isUnderDevelopment:!1}),e.$HF="extensions.webWorker",e.$IF=(0,g.$zh)("extensionService");class E{constructor(f){this.dependency=f}}e.$JF=E;var $;(function(p){p[p.EagerAutoStart=1]="EagerAutoStart",p[p.EagerManualStart=2]="EagerManualStart",p[p.Lazy=3]="Lazy"})($||(e.ExtensionHostStartup=$={}));class P{constructor(){this.c=[],this.d=[]}toDelta(){return{toRemove:[],toAdd:this.c,addActivationEvents:R.$xF.createActivationEventsMap(this.c),myToRemove:[],myToAdd:this.d}}set(f,t){const s=[],o=[],n=[],c=[],d=I(this.c),v=I(f),k=(N,j)=>N.extensionLocation.toString()===j.extensionLocation.toString()||N.isBuiltin===j.isBuiltin||N.isUserBuiltin===j.isUserBuiltin||N.isUnderDevelopment===j.isUnderDevelopment;for(const N of this.c){const j=v.get(N.identifier);if(!j){s.push(N.identifier),d.delete(N.identifier);continue}if(!k(N,j)){s.push(N.identifier),d.delete(N.identifier);continue}}for(const N of f){const j=d.get(N.identifier);if(!j){o.push(N);continue}if(!k(j,N)){s.push(j.identifier),d.delete(j.identifier);continue}}const u=new A.$Ul(this.d),l=new A.$Ul(t);for(const N of this.d)l.has(N)||n.push(N);for(const N of t)u.has(N)||c.push(N);const w=R.$xF.createActivationEventsMap(o),L={toRemove:s,toAdd:o,addActivationEvents:w,myToRemove:n,myToAdd:c};return this.delta(L),L}delta(f){const{toRemove:t,toAdd:s,myToRemove:o,myToAdd:n}=f,c=new A.$Ul(t),d=new A.$Ul(o);for(let v=0;v<this.c.length;v++)c.has(this.c[v].identifier)&&(this.c.splice(v,1),v--);for(let v=0;v<this.d.length;v++)d.has(this.d[v])&&(this.d.splice(v,1),v--);for(const v of s)this.c.push(v);for(const v of n)this.d.push(v)}containsExtension(f){for(const t of this.d)if(A.$Tl.equals(t,f))return!0;return!1}}e.$KF=P;function I(p){const f=new A.$Vl;for(const t of p)f.set(t.identifier,t);return f}function b(p,f){return p.enabledApiProposals?p.enabledApiProposals.includes(f):!1}e.$LF=b;function S(p,f){if(!b(p,f))throw new Error(`Extension '${p.identifier.value}' CANNOT use API proposal: ${f}.
Its package.json#enabledApiProposals-property declares: ${p.enabledApiProposals?.join(", ")??"[]"} but NOT ${f}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${p.identifier.value}`)}e.$MF=S;class C{constructor(f,t,s,o){this.codeLoadingTime=f,this.activateCallTime=t,this.activateResolvedTime=s,this.activationReason=o}}e.$NF=C;class y{constructor(f,t){this.description=f,this.value=t}}e.$OF=y;var r;(function(p){p[p.Normal=0]="Normal",p[p.Immediate=1]="Immediate"})(r||(e.ActivationKind=r={}));function i(p){return{type:p.isBuiltin?0:1,isBuiltin:p.isBuiltin||p.isUserBuiltin,identifier:{id:(0,h.$so)(p.publisher,p.name),uuid:p.uuid},manifest:p,location:p.extensionLocation,targetPlatform:p.targetPlatform,validations:[],isValid:!0}}e.$PF=i;function a(p,f){return{identifier:new A.$Tl((0,h.$qo)(p.manifest.publisher,p.manifest.name)),isBuiltin:p.type===0,isUserBuiltin:p.type===1&&p.isBuiltin,isUnderDevelopment:!!f,extensionLocation:p.location,...p.manifest,uuid:p.identifier.uuid,targetPlatform:p.targetPlatform}}e.$QF=a;class m{constructor(){this.onDidRegisterExtensions=D.Event.None,this.onDidChangeExtensionsStatus=D.Event.None,this.onDidChangeExtensions=D.Event.None,this.onWillActivateByEvent=D.Event.None,this.onDidChangeResponsiveChange=D.Event.None,this.onWillStop=D.Event.None,this.extensions=[]}activateByEvent(f){return Promise.resolve(void 0)}activationEventIsDone(f){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(f){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPorts(f,t){return Promise.resolve([])}stopExtensionHosts(){}async startExtensionHosts(){}async setRemoteEnvironment(f){}canAddExtension(){return!1}canRemoveExtension(){return!1}}e.$RF=m}),define(De[278],Ce([1,0,8,146,25,27,17,13]),function($e,e,D,M,h,R,A,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vac=e.$Uac=e.$Tac=e.$Sac=e.$Rac=e.$Qac=void 0;class E{static{this.NONE=new E(!1,-1,-1,-1)}constructor(i,a,m,p){this.startup=i,this.codeLoadingTime=a,this.activateCallTime=m,this.activateResolvedTime=p}}e.$Qac=E;class ${constructor(i){this.a=i,this.b=-1,this.c=-1,this.d=-1,this.f=-1,this.g=-1,this.h=-1}j(i,a){return i===-1||a===-1?-1:a-i}build(){return new E(this.a,this.j(this.b,this.c),this.j(this.d,this.f),this.j(this.g,this.h))}codeLoadingStart(){this.b=Date.now()}codeLoadingStop(){this.c=Date.now()}activateCallStart(){this.d=Date.now()}activateCallStop(){this.f=Date.now()}activateResolveStart(){this.g=Date.now()}activateResolveStop(){this.h=Date.now()}}e.$Rac=$;class P{constructor(i,a,m,p,f,t){this.activationFailed=i,this.activationFailedError=a,this.activationTimes=m,this.module=p,this.exports=f,this.subscriptions=t}}e.$Sac=P;class I extends P{constructor(i){super(!1,null,i,{activate:void 0,deactivate:void 0},void 0,[])}}e.$Tac=I;class b extends P{constructor(){super(!1,null,E.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.$Uac=b;class S extends P{constructor(i){super(!0,i,E.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}let C=class{constructor(i,a,m,p){this.g=p,this.a=i,this.b=a,this.c=m,this.d=new h.$Vl,this.f=Object.create(null)}dispose(){for(const[i,a]of this.d)a.dispose()}async waitForActivatingExtensions(){const i=[];for(const[a,m]of this.d)i.push(m.wait());await Promise.all(i)}isActivated(i){const a=this.d.get(i);return!!(a&&a.value)}getActivatedExtension(i){const a=this.d.get(i);if(!a||!a.value)throw new Error(`Extension '${i.value}' is not known or not activated`);return a.value}async activateByEvent(i,a){if(this.f[i])return;const m=this.a.getExtensionDescriptionsForActivationEvent(i);await this.h(m.map(p=>({id:p.identifier,reason:{startup:a,extensionId:p.identifier,activationEvent:i}}))),this.f[i]=!0}activateById(i,a){const m=this.a.getExtensionDescription(i);if(!m)throw new Error(`Extension '${i}' is not known`);return this.h([{id:m.identifier,reason:a}])}async h(i){const a=i.filter(m=>!this.isActivated(m.id)).map(m=>this.j(m));await Promise.all(a.map(m=>m.wait()))}j(i){if(this.d.has(i.id))return this.d.get(i.id);if(this.l(i.id))return this.k(i,null,[],null);const a=this.a.getExtensionDescription(i.id);if(!a){const f=new Error(`Cannot activate unknown extension '${i.id.value}'`),t=this.k(i,null,[],new S(f));return this.c.onExtensionActivationError(i.id,f,new R.$JF(i.id.value)),t}const m=[],p=typeof a.extensionDependencies>"u"?[]:a.extensionDependencies;for(const f of p){if(this.m(f))continue;const t=this.d.get(f);if(t){m.push(t);continue}if(this.l(f)){m.push(this.j({id:this.b.getExtensionDescription(f).identifier,reason:i.reason}));continue}const s=this.a.getExtensionDescription(f);if(s){if(!s.main&&!s.browser)continue;m.push(this.j({id:s.identifier,reason:i.reason}));continue}const o=a.displayName||a.identifier.value,n=new Error(`Cannot activate the '${o}' extension because it depends on unknown extension '${f}'`),c=this.k(i,a.displayName,[],new S(n));return this.c.onExtensionActivationError(a.identifier,n,new R.$JF(f)),c}return this.k(i,a.displayName,m,null)}k(i,a,m,p){const f=new y(i.id,a,i.reason,m,p,this.c,this.g);return this.d.set(i.id,f),f}l(i){return M.$12b.isHostExtension(i,this.a,this.b)}m(i){const a=this.b.getExtensionDescription(i);return a?!a.main&&!a.browser:!1}};e.$Vac=C,e.$Vac=C=Ke([Ve(3,A.$3i)],C);let y=class{get value(){return this.h}get friendlyName(){return this.d||this.c.value}constructor(i,a,m,p,f,t,s){this.c=i,this.d=a,this.f=m,this.g=p,this.h=f,this.j=t,this.k=s,this.a=new g.$Dg,this.b=!1,this.l()}dispose(){this.b=!0}wait(){return this.a.wait()}async l(){await this.m(),this.a.open()}async m(){if(!this.h){for(;this.g.length>0;){for(let i=0;i<this.g.length;i++){const a=this.g[i];if(a.value&&!a.value.activationFailed){this.g.splice(i,1),i--;continue}if(a.value&&a.value.activationFailed){const m=new Error(`Cannot activate the '${this.friendlyName}' extension because its dependency '${a.friendlyName}' failed to activate`);m.detail=a.value.activationFailedError,this.h=new S(m),this.j.onExtensionActivationError(this.c,m,null);return}}this.g.length>0&&await Promise.race(this.g.map(i=>i.wait()))}await this.n()}}async n(){try{this.h=await this.j.actualActivateExtension(this.c,this.f)}catch(i){const a=new Error;if(i&&i.name&&(a.name=i.name),i&&i.message?a.message=`Activating extension '${this.c.value}' failed: ${i.message}.`:a.message=`Activating extension '${this.c.value}' failed: ${i}.`,i&&i.stack&&(a.stack=i.stack),this.h=new S(a),this.b&&D.$2(i))return;this.j.onExtensionActivationError(this.c,a,null),this.k.error(`Activating extension ${this.c.value} failed due to an error:`),this.k.error(i)}}};y=Ke([Ve(6,A.$3i)],y)}),define(De[279],Ce([1,0,207,24,2,4,3,260,13,7,18,19,10,78,22,171,27]),function($e,e,D,M,h,R,A,g,E,$,P,I,b,S,C,y,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vbc=void 0;function i(p,f){if((0,P.$le)(p))return{label:p};if(p&&typeof p=="object"&&typeof p.label=="string"){let t;return Array.isArray(p.highlights)&&(t=p.highlights.filter(s=>s.length===2&&typeof s[0]=="number"&&typeof s[1]=="number"),t=t.length?t:void 0),{label:p.label,highlights:t}}}class a extends A.$mb{constructor(f,t,s){super(),this.f=f,this.g=t,this.h=s,this.a=new Map,this.b=new y.$$6;function o(n){return n&&n.$treeViewId&&(n.$treeItemHandle||n.$selectedTreeItems||n.$focusedTreeItem)}t.registerArgumentProcessor({processArgument:n=>o(n)?this.k(n):Array.isArray(n)&&n.length>0?n.map(c=>o(c)?this.k(c):c):n})}registerTreeDataProvider(f,t,s){const o=this.createTreeView(f,{treeDataProvider:t},s);return{dispose:()=>o.dispose()}}createTreeView(f,t,s){if(!t||!t.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const o=t.dragAndDropController?.dropMimeTypes??[],n=t.dragAndDropController?.dragMimeTypes??[],c=!!t.dragAndDropController?.handleDrag,d=!!t.dragAndDropController?.handleDrop,v=this.j(f,t,s),k={showCollapseAll:!!t.showCollapseAll,canSelectMany:!!t.canSelectMany,dropMimeTypes:o,dragMimeTypes:n,hasHandleDrag:c,hasHandleDrop:d,manuallyManageCheckboxes:!!t.manageCheckboxStateManually},u=this.f.$registerTreeViewDataProvider(f,k),l={get onDidCollapseElement(){return v.onDidCollapseElement},get onDidExpandElement(){return v.onDidExpandElement},get selection(){return v.selectedElements},get onDidChangeSelection(){return v.onDidChangeSelection},get activeItem(){return(0,r.$MF)(s,"treeViewActiveItem"),v.focusedElement},get onDidChangeActiveItem(){return(0,r.$MF)(s,"treeViewActiveItem"),v.onDidChangeActiveItem},get visible(){return v.visible},get onDidChangeVisibility(){return v.onDidChangeVisibility},get onDidChangeCheckboxState(){return v.onDidChangeCheckboxState},get message(){return v.message},set message(w){(0,S.$Xj)(w)&&(0,r.$MF)(s,"treeViewMarkdownMessage"),v.message=w},get title(){return v.title},set title(w){v.title=w},get description(){return v.description},set description(w){v.description=w},get badge(){return v.badge},set badge(w){w!==void 0&&$.ViewBadge.isViewBadge(w)?v.badge={value:Math.floor(Math.abs(w.value)),tooltip:w.tooltip}:w===void 0&&(v.badge=void 0)},reveal:(w,L)=>v.reveal(w,L),dispose:async()=>{await u,this.a.delete(f),v.dispose()}};return this.B(l),l}$getChildren(f,t){const s=this.a.get(f);return s?s.getChildren(t):Promise.reject(new g.$0E(f))}async $handleDrop(f,t,s,o,n,c,d,v){const k=this.a.get(f);if(!k)return Promise.reject(new g.$0E(f));const u=b.DataTransfer.toDataTransfer(s,async l=>(await this.f.$resolveDropFileData(f,t,l)).buffer);return d===f&&v&&await this.i(u,k,v,n,c),k.onDrop(u,o,n)}async i(f,t,s,o,n){const c=this.b.removeDragOperationTransfer(n);if(c)(await c)?.forEach((d,v)=>{d&&f.set(v,d)});else if(n&&t.handleDrag){const d=t.handleDrag(s,f,o);this.b.addDragOperationTransfer(n,d),await d}return f}async $handleDrag(f,t,s,o){const n=this.a.get(f);if(!n)return Promise.reject(new g.$0E(f));const c=await this.i(new $.$MK,n,t,o,s);if(!(!c||o.isCancellationRequested))return b.DataTransfer.from(c)}async $hasResolve(f){const t=this.a.get(f);if(!t)throw new g.$0E(f);return t.hasResolve}$resolve(f,t,s){const o=this.a.get(f);if(!o)throw new g.$0E(f);return o.resolveTreeItem(t,s)}$setExpanded(f,t,s){const o=this.a.get(f);if(!o)throw new g.$0E(f);o.setExpanded(t,s)}$setSelectionAndFocus(f,t,s){const o=this.a.get(f);if(!o)throw new g.$0E(f);o.setSelectionAndFocus(t,s)}$setVisible(f,t){const s=this.a.get(f);if(!s){if(!t)return;throw new g.$0E(f)}s.setVisible(t)}$changeCheckboxState(f,t){const s=this.a.get(f);if(!s)throw new g.$0E(f);s.setCheckboxState(t)}j(f,t,s){const o=this.B(new m(f,t,this.f,this.g.converter,this.h,s));return this.a.set(f,o),o}k(f){const t=this.a.get(f.$treeViewId);return t&&"$treeItemHandle"in f?t.getExtensionElement(f.$treeItemHandle):t&&"$focusedTreeItem"in f&&f.$focusedTreeItem?t.focusedElement:null}}e.$vbc=a;class m extends A.$mb{static{this.a="0"}static{this.b="1"}get visible(){return this.k}get selectedElements(){return this.l.map(f=>this.getExtensionElement(f)).filter(f=>!(0,P.$ue)(f))}get focusedElement(){return this.m?this.getExtensionElement(this.m):void 0}constructor(f,t,s,o,n,c){if(super(),this.D=f,this.F=s,this.G=o,this.H=n,this.I=c,this.h=void 0,this.i=new Map,this.j=new Map,this.k=!1,this.l=[],this.m=void 0,this.r=this.B(new R.$hc),this.onDidExpandElement=this.r.event,this.s=this.B(new R.$hc),this.onDidCollapseElement=this.s.event,this.t=this.B(new R.$hc),this.onDidChangeSelection=this.t.event,this.u=this.B(new R.$hc),this.onDidChangeActiveItem=this.u.event,this.v=this.B(new R.$hc),this.onDidChangeVisibility=this.v.event,this.w=this.B(new R.$hc),this.onDidChangeCheckboxState=this.w.event,this.y=this.B(new R.$hc),this.z=Promise.resolve(),this.C=Promise.resolve(),this.J="",this.L="",this.U=new C.$rc,c.contributes&&c.contributes.views)for(const u in c.contributes.views)for(const l of c.contributes.views[u])l.id===f&&(this.L=l.name);this.f=t.treeDataProvider,this.g=t.dragAndDropController,this.f.onDidChangeTreeData&&this.B(this.f.onDidChangeTreeData(u=>this.y.fire({message:!1,element:u})));let d,v;const k=R.Event.debounce(this.y.event,(u,l)=>(u||(u={message:!1,elements:[]}),l.element!==!1&&(d||(d=new Promise(w=>v=w),this.z=this.z.then(()=>d)),Array.isArray(l.element)?u.elements.push(...l.element):u.elements.push(l.element)),l.message&&(u.message=!0),u),200,!0);this.B(k(({message:u,elements:l})=>{l.length&&(this.C=this.C.then(()=>{const w=v;return d=null,this.W(l).then(()=>w())})),u&&this.F.$setMessage(this.D,b.MarkdownString.fromStrict(this.J)??"")}))}async getChildren(f){const t=f?this.getExtensionElement(f):void 0;if(f&&!t)return this.H.error(`No tree item with id '${f}' found.`),Promise.resolve([]);let s=this.R(f);return s||(s=await this.S(t)),s?s.map(o=>o.item):void 0}getExtensionElement(f){return this.i.get(f)}reveal(f,t){t=t||{select:!0,focus:!1};const s=(0,P.$ue)(t.select)?!0:t.select,o=(0,P.$ue)(t.focus)?!1:t.focus,n=(0,P.$ue)(t.expand)?!1:t.expand;return typeof this.f.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):f?this.z.then(()=>this.O(f)).then(c=>this.Q(f,c[c.length-1]).then(d=>this.F.$reveal(this.D,{item:d.item,parentChain:c.map(v=>v.item)},{select:s,focus:o,expand:n})),c=>this.H.error(c)):this.F.$reveal(this.D,void 0,{select:s,focus:o,expand:n})}get message(){return this.J}set message(f){this.J=f,this.y.fire({message:!0,element:!1})}get title(){return this.L}set title(f){this.L=f,this.F.$setTitle(this.D,f,this.M)}get description(){return this.M}set description(f){this.M=f,this.F.$setTitle(this.D,this.L,f)}get badge(){return this.N}set badge(f){this.N?.value===f?.value&&this.N?.tooltip===f?.tooltip||(this.N=b.ViewBadge.from(f),this.F.$setBadge(this.D,f))}setExpanded(f,t){const s=this.getExtensionElement(f);s&&(t?this.r.fire(Object.freeze({element:s})):this.s.fire(Object.freeze({element:s})))}setSelectionAndFocus(f,t){const s=!(0,I.$of)(this.l,f);this.l=f;const o=this.m!==t;this.m=t,s&&this.t.fire(Object.freeze({selection:this.selectedElements})),o&&this.u.fire(Object.freeze({activeItem:this.focusedElement}))}setVisible(f){f!==this.k&&(this.k=f,this.v.fire(Object.freeze({visible:this.k})))}async setCheckboxState(f){const t=(await Promise.all(f.map(async s=>{const o=this.getExtensionElement(s.treeItemHandle);return o?{extensionItem:o,treeItem:await this.f.getTreeItem(o),newState:s.newState?$.TreeItemCheckboxState.Checked:$.TreeItemCheckboxState.Unchecked}:Promise.resolve(void 0)}))).filter(s=>s!==void 0);t.forEach(s=>{s.treeItem.checkboxState=s.newState?$.TreeItemCheckboxState.Checked:$.TreeItemCheckboxState.Unchecked}),this.w.fire({items:t.map(s=>[s.extensionItem,s.newState])})}async handleDrag(f,t,s){const o=[];for(const n of f){const c=this.getExtensionElement(n);c&&o.push(c)}if(!(!this.g?.handleDrag||o.length===0))return await this.g.handleDrag(o,t,s),t}get hasHandleDrag(){return!!this.g?.handleDrag}async onDrop(f,t,s){const o=t?this.getExtensionElement(t):void 0;if(!(!o&&t||!this.g?.handleDrop))return(0,E.$xg)(()=>this.g?.handleDrop?this.g.handleDrop(o,f,s):void 0)}get hasResolve(){return!!this.f.resolveTreeItem}async resolveTreeItem(f,t){if(!this.f.resolveTreeItem)return;const s=this.i.get(f);if(s){const o=this.j.get(s);if(o){const n=await this.f.resolveTreeItem(o.extensionItem,s,t)??o.extensionItem;return this.db(n),o.item.tooltip=this.ab(n.tooltip),o.item.command=this.bb(o.disposableStore,n.command),o.item}}}O(f){return this.P(f).then(t=>t?this.O(t).then(s=>this.Q(t,s[s.length-1]).then(o=>(s.push(o),s))):Promise.resolve([]))}P(f){const t=this.j.get(f);return t?Promise.resolve(t.parent?this.i.get(t.parent.item.handle):void 0):(0,E.$xg)(()=>this.f.getParent(f))}Q(f,t){const s=this.j.get(f);return s?Promise.resolve(s):(0,E.$xg)(()=>this.f.getTreeItem(f)).then(o=>this.gb(f,o,t,!0)).then(o=>this.getChildren(t?t.item.handle:void 0).then(()=>{const n=this.getExtensionElement(o);if(n){const c=this.j.get(n);if(c)return Promise.resolve(c)}throw new Error(`Cannot resolve tree item for element ${o} from extension ${this.I.identifier.value}`)}))}R(f){if(f){let t;if(typeof f=="string"){const s=this.getExtensionElement(f);t=s?this.j.get(s):void 0}else t=f;return t&&t.children||void 0}return this.h}async S(f){this.nb(f);const t=new C.$rc(this.U.token);try{const s=f?this.j.get(f):void 0,o=await this.f.getChildren(f);if(t.token.isCancellationRequested)return;const n=await Promise.all((0,I.$Af)(o||[]).map(async c=>{const d=await this.f.getTreeItem(c);return d&&!t.token.isCancellationRequested?this.$(c,d,s):null}));return t.token.isCancellationRequested?void 0:(0,I.$Af)(n)}finally{t.dispose()}}W(f){if(f.some(s=>!s))return this.U.dispose(!0),this.U=new C.$rc,this.pb(),this.F.$refresh(this.D);{const s=this.X(f);if(s.length)return this.Y(s)}return Promise.resolve(void 0)}X(f){const t=new Set,s=f.map(n=>this.j.get(n));for(const n of s)if(n&&!t.has(n.item.handle)){let c=n;for(;c&&c.parent&&s.findIndex(d=>c&&c.parent&&d&&d.item.handle===c.parent.item.handle)===-1;){const d=this.i.get(c.parent.item.handle);c=d?this.j.get(d):void 0}c&&!c.parent&&t.add(n.item.handle)}const o=[];return t.forEach(n=>{const c=this.i.get(n);if(c){const d=this.j.get(c);d&&(!d.parent||!t.has(d.parent.item.handle))&&o.push(n)}}),o}Y(f){const t={};return Promise.all(f.map(s=>this.Z(s).then(o=>{o&&(t[s]=o.item)}))).then(()=>Object.keys(t).length?this.F.$refresh(this.D,t):void 0)}Z(f){const t=this.getExtensionElement(f);if(t){const s=this.j.get(t);if(s)return this.nb(t),(0,E.$xg)(()=>this.f.getTreeItem(t)).then(o=>{if(o){const n=this.eb(t,o,s.parent);return this.lb(t,n,s,s.parent),s.dispose(),n}return null})}return Promise.resolve(null)}$(f,t,s){const o=this.eb(f,t,s);if(t.id&&this.i.has(o.item.handle))throw new Error((0,D.localize)(0,null,t.id));return this.kb(f,o),this.mb(o,s),o}ab(f){return $.$jK.isMarkdownString(f)?b.MarkdownString.from(f):f}bb(f,t){return t?{...this.G.toInternal(t,f),originalId:t.command}:void 0}cb(f){if(f.checkboxState===void 0)return;let t,s,o;return typeof f.checkboxState=="number"?t=f.checkboxState:(t=f.checkboxState.state,s=f.checkboxState.tooltip,o=f.checkboxState.accessibilityInformation),{isChecked:t===$.TreeItemCheckboxState.Checked,tooltip:s,accessibilityInformation:o}}db(f){if(!$.$HK.isTreeItem(f,this.I))throw new Error(`Extension ${this.I.identifier.value} has provided an invalid tree item.`)}eb(f,t,s){this.db(t);const o=this.B(new A.$lb),n=this.gb(f,t,s),c=this.hb(t);return{item:{handle:n,parentHandle:s?s.item.handle:void 0,label:i(t.label,this.I),description:t.description,resourceUri:t.resourceUri,tooltip:this.ab(t.tooltip),command:this.bb(o,t.command),contextValue:t.contextValue,icon:c,iconDark:this.ib(t)||c,themeIcon:this.fb(t),collapsibleState:(0,P.$ue)(t.collapsibleState)?$.TreeItemCollapsibleState.None:t.collapsibleState,accessibilityInformation:t.accessibilityInformation,checkbox:this.cb(t)},extensionItem:t,parent:s,children:void 0,disposableStore:o,dispose(){o.dispose()}}}fb(f){return f.iconPath instanceof $.$PK?f.iconPath:void 0}gb(f,{id:t,label:s,resourceUri:o},n,c){if(t)return`${m.b}/${t}`;const d=i(s,this.I),v=n?n.item.handle:m.a;let k=d?d.label:o?(0,M.$dg)(o):"";k=k.indexOf("/")!==-1?k.replace("/","//"):k;const u=this.j.has(f)?this.j.get(f).item.handle:void 0,l=this.R(n)||[];let w,L=0;do{if(w=`${v}/${L}:${k}`,c||!this.i.has(w)||u===w)break;L++}while(L<=l.length);return w}hb(f){if(f.iconPath&&!(f.iconPath instanceof $.$PK))return typeof f.iconPath=="string"||h.URI.isUri(f.iconPath)?this.jb(f.iconPath):this.jb(f.iconPath.light)}ib(f){if(f.iconPath&&!(f.iconPath instanceof $.$PK)&&f.iconPath.dark)return this.jb(f.iconPath.dark)}jb(f){return h.URI.isUri(f)?f:h.URI.file(f)}kb(f,t){this.i.set(t.item.handle,f),this.j.set(f,t)}lb(f,t,s,o){this.i.delete(t.item.handle),this.j.delete(f),t.item.handle!==s.item.handle&&this.i.delete(s.item.handle),this.kb(f,t);const n=this.R(o)||[],c=n.filter(d=>d.item.handle===s.item.handle)[0];c&&n.splice(n.indexOf(c),1,t)}mb(f,t){t?(t.children||(t.children=[]),t.children.push(f)):(this.h||(this.h=[]),this.h.push(f))}nb(f){if(f){const t=this.j.get(f);if(t){if(t.children)for(const s of t.children){const o=this.i.get(s.item.handle);o&&this.ob(o)}t.children=void 0}}else this.pb()}ob(f){const t=this.j.get(f);if(t){if(t.children)for(const s of t.children){const o=this.i.get(s.item.handle);o&&this.ob(o)}this.j.delete(f),this.i.delete(t.item.handle),t.dispose()}}pb(){this.h=void 0,this.i.clear(),this.j.forEach(f=>f.dispose()),this.j.clear()}dispose(){super.dispose(),this.U.dispose(),this.pb(),this.F.$disposeTree(this.D)}}}),define(De[280],Ce([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0,e.allApiProposals=Object.freeze({aiRelatedInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiRelatedInformation.d.ts",authGetSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authGetSessions.d.ts",authSession:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts",canonicalUriProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.canonicalUriProvider.d.ts",chat:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chat.d.ts",chatProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatProvider.d.ts",chatRequestAccess:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatRequestAccess.d.ts",chatSlashCommands:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatSlashCommands.d.ts",chatVariables:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatVariables.d.ts",codiconDecoration:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codiconDecoration.d.ts",commentsDraftState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentsDraftState.d.ts",contribCommentEditorActionsMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentEditorActionsMenu.d.ts",contribCommentPeekContext:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts",contribCommentThreadAdditionalMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentThreadAdditionalMenu.d.ts",contribEditSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts",contribEditorContentMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts",contribLabelFormatterWorkspaceTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts",contribMenuBarHome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts",contribMergeEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts",contribNotebookStaticPreloads:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribNotebookStaticPreloads.d.ts",contribRemoteHelp:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts",contribShareMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts",contribStatusBarItems:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribStatusBarItems.d.ts",contribViewsRemote:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts",contribViewsWelcome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts",customEditorMove:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts",debugFocus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.debugFocus.d.ts",diffCommand:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts",diffContentOptions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffContentOptions.d.ts",documentFiltersExclusive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts",documentPaste:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts",dropMetadata:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.dropMetadata.d.ts",editSessionIdentityProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts",editorInsets:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts",envShellEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.envShellEvent.d.ts",extensionRuntime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts",extensionsAny:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts",externalUriOpener:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts",fileComments:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileComments.d.ts",fileSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts",findTextInFiles:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts",fsChunks:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts",handleIssueUri:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.handleIssueUri.d.ts",idToken:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts",indentSize:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.indentSize.d.ts",inlineCompletionsAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts",interactive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactive.d.ts",interactiveUserActions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveUserActions.d.ts",interactiveWindow:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts",ipc:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts",languageConfigurationAutoClosingPairs:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageConfigurationAutoClosingPairs.d.ts",mappedEditsProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.mappedEditsProvider.d.ts",notebookCellExecutionState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts",notebookCodeActions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCodeActions.d.ts",notebookControllerAffinityHidden:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerAffinityHidden.d.ts",notebookDeprecated:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts",notebookExecution:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookExecution.d.ts",notebookKernelSource:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts",notebookLiveShare:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts",notebookMessaging:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts",notebookMime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts",portsAttributes:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts",profileContentHandlers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.profileContentHandlers.d.ts",quickDiffProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickDiffProvider.d.ts",quickPickItemTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickItemTooltip.d.ts",quickPickSortByLabel:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts",readonlyMessage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.readonlyMessage.d.ts",resolvers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts",saveEditor:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.saveEditor.d.ts",scmActionButton:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts",scmSelectedProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts",scmTextDocument:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmTextDocument.d.ts",scmValidation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts",shareProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.shareProvider.d.ts",showLocal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.showLocal.d.ts",tabInputTextMerge:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts",taskPresentationGroup:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts",telemetry:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts",terminalContextMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalContextMenu.d.ts",terminalDataWriteEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts",terminalDimensions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts",terminalExecuteCommandEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalExecuteCommandEvent.d.ts",terminalQuickFixProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalQuickFixProvider.d.ts",terminalSelection:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalSelection.d.ts",testCoverage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testCoverage.d.ts",testMessageContextValue:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testMessageContextValue.d.ts",testObserver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts",textSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts",timeline:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts",tokenInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts",treeViewActiveItem:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewActiveItem.d.ts",treeViewMarkdownMessage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewMarkdownMessage.d.ts",treeViewReveal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts",tunnelFactory:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnelFactory.d.ts",tunnels:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts",windowActivity:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.windowActivity.d.ts",workspaceTrust:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"})}),define(De[281],Ce([1,0,219,8,40,131,104,41,25,280,134,136]),function($e,e,D,M,h,R,A,g,E,$,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$XF=e.$WF=e.$VF=e.$UF=e.$TF=e.$SF=void 0;const b=g.$6m.as(A.$7m.JSONContribution);class S{constructor(f,t,s){this.a=f,this.b=t,this.c=s}d(f,t){this.a({type:f,message:t,extensionId:this.b.identifier,extensionPointId:this.c})}error(f){this.d(h.default.Error,f)}warn(f){this.d(h.default.Warning,f)}info(f){this.d(h.default.Info,f)}}e.$SF=S;class C{static a(f){const t=new E.$Ul;for(let s=0,o=f.length;s<o;s++)t.add(f[s].description.identifier);return t}static compute(f,t){if(!f||!f.length)return new C(t,[]);if(!t||!t.length)return new C([],f);const s=this.a(f),o=this.a(t),n=t.filter(d=>!s.has(d.description.identifier)),c=f.filter(d=>!o.has(d.description.identifier));return new C(n,c)}constructor(f,t){this.added=f,this.removed=t}}e.$TF=C;class y{constructor(f,t){this.name=f,this.defaultExtensionKind=t,this.a=null,this.b=null,this.c=null}setHandler(f){if(this.a!==null)throw new Error("Handler already set!");this.a=f,this.d()}acceptUsers(f){this.c=C.compute(this.b,f),this.b=f,this.d()}d(){if(!(this.a===null||this.b===null||this.c===null))try{this.a(this.b,this.c)}catch(f){(0,M.$Y)(f)}}}e.$UF=y;const r={type:"string",enum:["ui","workspace"],enumDescriptions:[D.localize(0,null),D.localize(1,null)]},i="vscode://schemas/vscode-extensions";e.$VF={properties:{engines:{type:"object",description:D.localize(2,null),properties:{vscode:{type:"string",description:D.localize(3,null),default:"^1.22.0"}}},publisher:{description:D.localize(4,null),type:"string"},displayName:{description:D.localize(5,null),type:"string"},categories:{description:D.localize(6,null),type:"array",uniqueItems:!0,items:{oneOf:[{type:"string",enum:E.$Sl},{type:"string",const:"Languages",deprecationMessage:D.localize(7,null)}]}},galleryBanner:{type:"object",description:D.localize(8,null),properties:{color:{description:D.localize(9,null),type:"string"},theme:{description:D.localize(10,null),type:"string",enum:["dark","light"]}}},contributes:{description:D.localize(11,null),type:"object",properties:{},default:{}},preview:{type:"boolean",description:D.localize(12,null)},enableProposedApi:{type:"boolean",deprecationMessage:D.localize(13,null)},enabledApiProposals:{markdownDescription:D.localize(14,null),type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys($.allApiProposals),markdownEnumDescriptions:Object.values($.allApiProposals)}},api:{markdownDescription:D.localize(15,null),type:"string",enum:["none"],enumDescriptions:[D.localize(16,null)]},activationEvents:{description:D.localize(17,null),type:"array",items:{type:"string",defaultSnippets:[{label:"onWebviewPanel",description:D.localize(18,null),body:"onWebviewPanel:viewType"},{label:"onLanguage",description:D.localize(19,null),body:"onLanguage:${1:languageId}"},{label:"onCommand",description:D.localize(20,null),body:"onCommand:${2:commandId}"},{label:"onDebug",description:D.localize(21,null),body:"onDebug"},{label:"onDebugInitialConfigurations",description:D.localize(22,null),body:"onDebugInitialConfigurations"},{label:"onDebugDynamicConfigurations",description:D.localize(23,null),body:"onDebugDynamicConfigurations"},{label:"onDebugResolve",description:D.localize(24,null),body:"onDebugResolve:${6:type}"},{label:"onDebugAdapterProtocolTracker",description:D.localize(25,null),body:"onDebugAdapterProtocolTracker:${6:type}"},{label:"workspaceContains",description:D.localize(26,null),body:"workspaceContains:${4:filePattern}"},{label:"onStartupFinished",description:D.localize(27,null),body:"onStartupFinished"},{label:"onTaskType",description:D.localize(28,null),body:"onTaskType:${1:taskType}"},{label:"onFileSystem",description:D.localize(29,null),body:"onFileSystem:${1:scheme}"},{label:"onEditSession",description:D.localize(30,null),body:"onEditSession:${1:scheme}"},{label:"onSearch",description:D.localize(31,null),body:"onSearch:${7:scheme}"},{label:"onView",body:"onView:${5:viewId}",description:D.localize(32,null)},{label:"onUri",body:"onUri",description:D.localize(33,null)},{label:"onOpenExternalUri",body:"onOpenExternalUri",description:D.localize(34,null)},{label:"onCustomEditor",body:"onCustomEditor:${9:viewType}",description:D.localize(35,null)},{label:"onNotebook",body:"onNotebook:${1:type}",description:D.localize(36,null)},{label:"onAuthenticationRequest",body:"onAuthenticationRequest:${11:authenticationProviderId}",description:D.localize(37,null)},{label:"onRenderer",description:D.localize(38,null),body:"onRenderer:${11:rendererId}"},{label:"onTerminalProfile",body:"onTerminalProfile:${1:terminalId}",description:D.localize(39,null)},{label:"onTerminalQuickFixRequest",body:"onTerminalQuickFixRequest:${1:quickFixId}",description:D.localize(40,null)},{label:"onWalkthrough",body:"onWalkthrough:${1:walkthroughID}",description:D.localize(41,null)},{label:"*",description:D.localize(42,null),body:"*"}]}},badges:{type:"array",description:D.localize(43,null),items:{type:"object",required:["url","href","description"],properties:{url:{type:"string",description:D.localize(44,null)},href:{type:"string",description:D.localize(45,null)},description:{type:"string",description:D.localize(46,null)}}}},markdown:{type:"string",description:D.localize(47,null),enum:["github","standard"],default:"github"},qna:{default:"marketplace",description:D.localize(48,null),anyOf:[{type:["string","boolean"],enum:["marketplace",!1]},{type:"string"}]},extensionDependencies:{description:D.localize(49,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:R.$Kn}},extensionPack:{description:D.localize(50,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:R.$Kn}},extensionKind:{description:D.localize(51,null),type:"array",items:r,default:["workspace"],defaultSnippets:[{body:["ui"],description:D.localize(52,null)},{body:["workspace"],description:D.localize(53,null)},{body:["ui","workspace"],description:D.localize(54,null)},{body:["workspace","ui"],description:D.localize(55,null)},{body:[],description:D.localize(56,null)}]},capabilities:{description:D.localize(57,null),type:"object",properties:{virtualWorkspaces:{description:D.localize(58,null),type:["boolean","object"],defaultSnippets:[{label:"limited",body:{supported:"${1:limited}",description:"${2}"}},{label:"false",body:{supported:!1,description:"${2}"}}],default:(!0).valueOf,properties:{supported:{markdownDescription:D.localize(59,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[D.localize(60,null),D.localize(61,null),D.localize(62,null)]},description:{type:"string",markdownDescription:D.localize(63,null)}}},untrustedWorkspaces:{description:D.localize(64,null),type:"object",required:["supported"],defaultSnippets:[{body:{supported:"${1:limited}",description:"${2}"}}],properties:{supported:{markdownDescription:D.localize(65,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[D.localize(66,null),D.localize(67,null),D.localize(68,null)]},restrictedConfigurations:{description:D.localize(69,null),type:"array",items:{type:"string"}},description:{type:"string",markdownDescription:D.localize(70,null)}}}}},sponsor:{description:D.localize(71,null),type:"object",defaultSnippets:[{body:{url:"${1:https:}"}}],properties:{url:{description:D.localize(72,null),type:"string"}}},scripts:{type:"object",properties:{"vscode:prepublish":{description:D.localize(73,null),type:"string"},"vscode:uninstall":{description:D.localize(74,null),type:"string"}}},icon:{type:"string",description:D.localize(75,null)},l10n:{type:"string",description:D.localize(76,null)},pricing:{type:"string",markdownDescription:D.localize(77,null),enum:["Free","Trial"],default:"Free"}}};class a{constructor(){this.a=new Map}registerExtensionPoint(f){if(this.a.has(f.extensionPoint))throw new Error("Duplicate extension point: "+f.extensionPoint);const t=new y(f.extensionPoint,f.defaultExtensionKind);return this.a.set(f.extensionPoint,t),f.activationEventsGenerator&&I.$xF.register(f.extensionPoint,f.activationEventsGenerator),e.$VF.properties.contributes.properties[f.extensionPoint]=f.jsonSchema,b.registerSchema(i,e.$VF),t}getExtensionPoints(){return Array.from(this.a.values())}}e.$WF=a;const m={ExtensionsRegistry:"ExtensionsRegistry"};g.$6m.add(m.ExtensionsRegistry,new a),e.$XF=g.$6m.as(m.ExtensionsRegistry),b.registerSchema(i,e.$VF),b.registerSchema(P.$jj,{properties:{extensionEnabledApiProposals:{description:D.localize(78,null),type:"object",properties:{},additionalProperties:{anyOf:[{type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys($.allApiProposals),markdownEnumDescriptions:Object.values($.allApiProposals)}}]}}}})}),define(De[282],Ce([1,0,216,18,23,281,47,4]),function($e,e,D,M,h,R,A,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7F=void 0;const E={type:"object",additionalProperties:!1,properties:{type:{type:"string",description:D.localize(0,null)},required:{type:"array",items:{type:"string"}},properties:{type:"object",description:D.localize(1,null),additionalProperties:{$ref:"http://json-schema.org/draft-07/schema#"}},when:{type:"string",markdownDescription:D.localize(2,null),default:""}}};var $;(function(b){function S(C,y,r){if(!C)return;const i=M.$le(C.type)?C.type:void 0;if(!i||i.length===0){r.error(D.localize(3,null));return}const a=[];if(Array.isArray(C.required))for(const m of C.required)M.$le(m)&&a.push(m);return{extensionId:y.value,taskType:i,required:a,properties:C.properties?h.$Tm(C.properties):{},when:C.when?A.$Gi.deserialize(C.when):void 0}}b.from=S})($||($={}));const P=R.$XF.registerExtensionPoint({extensionPoint:"taskDefinitions",activationEventsGenerator:(b,S)=>{for(const C of b)C.type&&S.push(`onTaskType:${C.type}`)},jsonSchema:{description:D.localize(4,null),type:"array",items:E}});class I{constructor(){this.d=new g.$hc,this.onDefinitionsChanged=this.d.event,this.a=Object.create(null),this.b=new Promise((S,C)=>{P.setHandler((y,r)=>{this.c=void 0;try{for(const i of r.removed){const a=i.value;for(const m of a)this.a&&m.type&&this.a[m.type]&&delete this.a[m.type]}for(const i of r.added){const a=i.value;for(const m of a){const p=$.from(m,i.description.identifier,i.collector);p&&(this.a[p.taskType]=p)}}(r.removed.length>0||r.added.length>0)&&this.d.fire()}catch{}S(void 0)})})}onReady(){return this.b}get(S){return this.a[S]}all(){return Object.keys(this.a).map(S=>this.a[S])}getJsonSchema(){if(this.c===void 0){const S=[];for(const C of this.all()){const y={type:"object",additionalProperties:!1};C.required.length>0&&(y.required=C.required.slice(0)),C.properties!==void 0?y.properties=h.$Tm(C.properties):y.properties=Object.create(null),y.properties.type={type:"string",enum:[C.taskType]},S.push(y)}this.c={oneOf:S}}return this.c}}e.$7F=new I}),define(De[283],Ce([1,0,217,18,24,23,47,282]),function($e,e,D,M,h,R,A,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinition=e.TasksSchemaProperties=e.TaskSettingId=e.KeyedTaskIdentifier=e.TaskEvent=e.TaskRunSource=e.TaskRunType=e.TaskEventKind=e.$eG=e.JsonSchemaVersion=e.ExecutionEngine=e.$dG=e.$cG=e.$bG=e.$aG=e.$_F=e.RunOptions=e.RunOnOptions=e.DependsOrder=e.TaskSourceKind=e.TaskScope=e.TaskGroup=e.CommandString=e.RuntimeType=e.PresentationOptions=e.PanelKind=e.RevealProblemKind=e.RevealKind=e.CommandOptions=e.$$F=e.ShellQuoting=e.$0F=e.$9F=e.$8F=void 0,e.$8F="settings",e.$9F=new A.$Zi("taskRunning",!1,D.localize(0,null)),e.$0F={value:D.localize(1,null),original:"Tasks"};var E;(function(B){B[B.Escape=1]="Escape",B[B.Strong=2]="Strong",B[B.Weak=3]="Weak"})(E||(e.ShellQuoting=E={})),e.$$F="$customized",function(B){function F(J){if(!J)return B.Strong;switch(J.toLowerCase()){case"escape":return B.Escape;case"strong":return B.Strong;case"weak":return B.Weak;default:return B.Strong}}B.from=F}(E||(e.ShellQuoting=E={}));var $;(function(B){B.defaults={cwd:"${workspaceFolder}"}})($||(e.CommandOptions=$={}));var P;(function(B){B[B.Always=1]="Always",B[B.Silent=2]="Silent",B[B.Never=3]="Never"})(P||(e.RevealKind=P={})),function(B){function F(J){switch(J.toLowerCase()){case"always":return B.Always;case"silent":return B.Silent;case"never":return B.Never;default:return B.Always}}B.fromString=F}(P||(e.RevealKind=P={}));var I;(function(B){B[B.Never=1]="Never",B[B.OnProblem=2]="OnProblem",B[B.Always=3]="Always"})(I||(e.RevealProblemKind=I={})),function(B){function F(J){switch(J.toLowerCase()){case"always":return B.Always;case"never":return B.Never;case"onproblem":return B.OnProblem;default:return B.OnProblem}}B.fromString=F}(I||(e.RevealProblemKind=I={}));var b;(function(B){B[B.Shared=1]="Shared",B[B.Dedicated=2]="Dedicated",B[B.New=3]="New"})(b||(e.PanelKind=b={})),function(B){function F(J){switch(J.toLowerCase()){case"shared":return B.Shared;case"dedicated":return B.Dedicated;case"new":return B.New;default:return B.Shared}}B.fromString=F}(b||(e.PanelKind=b={}));var S;(function(B){B.defaults={echo:!0,reveal:P.Always,revealProblems:I.Never,focus:!1,panel:b.Shared,showReuseMessage:!0,clear:!1}})(S||(e.PresentationOptions=S={}));var C;(function(B){B[B.Shell=1]="Shell",B[B.Process=2]="Process",B[B.CustomExecution=3]="CustomExecution"})(C||(e.RuntimeType=C={})),function(B){function F(K){switch(K.toLowerCase()){case"shell":return B.Shell;case"process":return B.Process;case"customExecution":return B.CustomExecution;default:return B.Process}}B.fromString=F;function J(K){switch(K){case B.Shell:return"shell";case B.Process:return"process";case B.CustomExecution:return"customExecution";default:return"process"}}B.toString=J}(C||(e.RuntimeType=C={}));var y;(function(B){function F(J){return M.$le(J)?J:J.value}B.value=F})(y||(e.CommandString=y={}));var r;(function(B){B.Clean={_id:"clean",isDefault:!1},B.Build={_id:"build",isDefault:!1},B.Rebuild={_id:"rebuild",isDefault:!1},B.Test={_id:"test",isDefault:!1};function F(K){return K===B.Clean._id||K===B.Build._id||K===B.Rebuild._id||K===B.Test._id}B.is=F;function J(K){if(K!==void 0)return M.$le(K)?F(K)?{_id:K,isDefault:!1}:void 0:K}B.from=J})(r||(e.TaskGroup=r={}));var i;(function(B){B[B.Global=1]="Global",B[B.Workspace=2]="Workspace",B[B.Folder=3]="Folder"})(i||(e.TaskScope=i={}));var a;(function(B){B.Workspace="workspace",B.Extension="extension",B.InMemory="inMemory",B.WorkspaceFile="workspaceFile",B.User="user";function F(J){switch(J){case B.User:return 2;case B.WorkspaceFile:return 5;default:return 6}}B.toConfigurationTarget=F})(a||(e.TaskSourceKind=a={}));var m;(function(B){B.parallel="parallel",B.sequence="sequence"})(m||(e.DependsOrder=m={}));var p;(function(B){B[B.default=1]="default",B[B.folderOpen=2]="folderOpen"})(p||(e.RunOnOptions=p={}));var f;(function(B){B.defaults={reevaluateOnRerun:!0,runOn:p.default,instanceLimit:1}})(f||(e.RunOptions=f={}));class t{constructor(F,J,K,me,re,x){this._label="",this._id=F,J&&(this._label=J),K&&(this.type=K),this.runOptions=me,this.configurationProperties=re,this._source=x}getDefinition(F){}getMapKey(){return this._id}getRecentlyUsedKey(){}getCommonTaskId(){const F={folder:this.d(),id:this._id};return JSON.stringify(F)}clone(){return this.f(Object.assign({},this))}getWorkspaceFolder(){}getWorkspaceFileName(){}getTelemetryKind(){return"unknown"}matches(F,J=!1){if(F===void 0)return!1;if(M.$le(F))return F===this._label||F===this.configurationProperties.identifier||J&&F===this._id;const K=this.getDefinition(!0);return K!==void 0&&K._key===F._key}getQualifiedLabel(){const F=this.getWorkspaceFolder();return F?`${this._label} (${F.name})`:this._label}getTaskExecution(){return{id:this._id,task:this}}addTaskLoadMessages(F){this.c===void 0&&(this.c=[]),F&&(this.c=this.c.concat(F))}get taskLoadMessages(){return this.c}}e.$_F=t;class s extends t{constructor(F,J,K,me,re,x,q,ee){super(F,K,void 0,q,ee,J),this.command={},this._source=J,this.hasDefinedMatchers=x,re&&(this.command=re)}clone(){return new s(this._id,this._source,this._label,this.type,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}customizes(){if(this._source&&this._source.customizes)return this._source.customizes}getDefinition(F=!1){if(F&&this._source.customizes!==void 0)return this._source.customizes;{let J;switch(this.command?this.command.runtime:void 0){case C.Shell:J="shell";break;case C.Process:J="process";break;case C.CustomExecution:J="customExecution";break;case void 0:J="$composite";break;default:throw new Error("Unexpected task runtime")}return{type:J,_key:this._id,id:this._id}}}static is(F){return F instanceof s}getMapKey(){const F=this._source.config.workspaceFolder;return F?`${F.uri.toString()}|${this._id}|${this.instance}`:`${this._id}|${this.instance}`}d(){return this._source.kind===a.User?e.$8F:this._source.config.workspaceFolder?.uri.toString()}getCommonTaskId(){return this._source.customizes?super.getCommonTaskId():this.getRecentlyUsedKey()??super.getCommonTaskId()}getRecentlyUsedKey(){const F=this.d();if(!F)return;let J=this.configurationProperties.identifier;this._source.kind!==a.Workspace&&(J+=this._source.kind);const K={type:e.$$F,folder:F,id:J};return JSON.stringify(K)}getWorkspaceFolder(){return this._source.config.workspaceFolder}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?h.$dg(this._source.config.workspace.configuration):void 0}getTelemetryKind(){return this._source.customizes?"workspace>extension":"workspace"}f(F){return new s(F._id,F._source,F._label,F.type,F.command,F.hasDefinedMatchers,F.runOptions,F.configurationProperties)}}e.$aG=s;class o extends t{constructor(F,J,K,me,re,x,q){super(F,K,me,x,q,J),this._source=J,this.configures=re}static is(F){return F instanceof o}f(F){return F}getDefinition(){return this.configures}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?h.$dg(this._source.config.workspace.configuration):void 0}getWorkspaceFolder(){return this._source.config.workspaceFolder}d(){return this._source.kind===a.User?e.$8F:this._source.config.workspaceFolder?.uri.toString()}getRecentlyUsedKey(){const F=this.d();if(!F)return;let J=this.configurationProperties.identifier;this._source.kind!==a.Workspace&&(J+=this._source.kind);const K={type:e.$$F,folder:F,id:J};return JSON.stringify(K)}}e.$bG=o;class n extends t{constructor(F,J,K,me,re,x,q,ee,pe){super(F,K,me,ee,pe,J),this.defines=re,this.hasDefinedMatchers=q,this.command=x,this.icon=pe.icon,this.hide=pe.hide}clone(){return new n(this._id,this._source,this._label,this.type,this.defines,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}getDefinition(){return this.defines}static is(F){return F instanceof n}getMapKey(){const F=this._source.workspaceFolder;return F?`${this._source.scope.toString()}|${F.uri.toString()}|${this._id}|${this.instance}`:`${this._source.scope.toString()}|${this._id}|${this.instance}`}d(){if(this._source.scope===3&&this._source.workspaceFolder)return this._source.workspaceFolder.uri.toString()}getRecentlyUsedKey(){const F={type:"contributed",scope:this._source.scope,id:this._id};return F.folder=this.d(),JSON.stringify(F)}getWorkspaceFolder(){return this._source.workspaceFolder}getTelemetryKind(){return"extension"}f(F){return new n(F._id,F._source,F._label,F.type,F.defines,F.command,F.hasDefinedMatchers,F.runOptions,F.configurationProperties)}}e.$cG=n;class c extends t{constructor(F,J,K,me,re,x){super(F,K,me,re,x,J),this._source=J}clone(){return new c(this._id,this._source,this._label,this.type,this.runOptions,this.configurationProperties)}static is(F){return F instanceof c}getTelemetryKind(){return"composite"}getMapKey(){return`${this._id}|${this.instance}`}d(){}f(F){return new c(F._id,F._source,F._label,F.type,F.runOptions,F.configurationProperties)}}e.$dG=c;var d;(function(B){B[B.Process=1]="Process",B[B.Terminal=2]="Terminal"})(d||(e.ExecutionEngine=d={})),function(B){B._default=B.Terminal}(d||(e.ExecutionEngine=d={}));var v;(function(B){B[B.V0_1_0=1]="V0_1_0",B[B.V2_0_0=2]="V2_0_0"})(v||(e.JsonSchemaVersion=v={}));class k{constructor(F){this.c=new Map;for(let J=0;J<F.length;J++)this.c.set(F[J].uri.toString(),J)}compare(F,J){const K=F.getWorkspaceFolder(),me=J.getWorkspaceFolder();if(K&&me){let re=this.c.get(K.uri.toString());re=re===void 0?0:re+1;let x=this.c.get(me.uri.toString());return x=x===void 0?0:x+1,re===x?F._label.localeCompare(J._label):re-x}else return!K&&me?-1:K&&!me?1:0}}e.$eG=k;var u;(function(B){B.DependsOnStarted="dependsOnStarted",B.AcquiredInput="acquiredInput",B.Start="start",B.ProcessStarted="processStarted",B.Active="active",B.Inactive="inactive",B.Changed="changed",B.Terminated="terminated",B.ProcessEnded="processEnded",B.End="end"})(u||(e.TaskEventKind=u={}));var l;(function(B){B.SingleRun="singleRun",B.Background="background"})(l||(e.TaskRunType=l={}));var w;(function(B){B[B.System=0]="System",B[B.User=1]="User",B[B.FolderOpen=2]="FolderOpen",B[B.ConfigurationChange=3]="ConfigurationChange",B[B.Reconnect=4]="Reconnect"})(w||(e.TaskRunSource=w={}));var L;(function(B){function F(ee){return{taskId:ee._id,taskName:ee.configurationProperties.name,runType:ee.configurationProperties.isBackground?"background":"singleRun",group:ee.configurationProperties.group,__task:ee}}function J(ee,pe,ce){return{...F(ee),kind:"start",terminalId:pe,resolvedVariables:ce}}B.start=J;function K(ee,pe,ce){return{...F(ee),kind:"processStarted",terminalId:pe,processId:ce}}B.processStarted=K;function me(ee,pe,ce){return{...F(ee),kind:"processEnded",terminalId:pe,exitCode:ce}}B.processEnded=me;function re(ee,pe,ce){return{...F(ee),kind:"terminated",exitReason:ce,terminalId:pe}}B.terminated=re;function x(ee,pe,ce){return{...F(pe),kind:ee,terminalId:ce}}B.general=x;function q(){return{kind:"changed"}}B.changed=q})(L||(e.TaskEvent=L={}));var N;(function(B){function F(K){const me=Object.keys(K).sort();let re="";for(const x of me){let q=K[x];q instanceof Object?q=F(q):typeof q=="string"&&(q=q.replace(/,/g,",,")),re+=x+","+q+","}return re}function J(K){const re={_key:F(K),type:K.taskType};return Object.assign(re,K),re}B.create=J})(N||(e.KeyedTaskIdentifier=N={}));var j;(function(B){B.AutoDetect="task.autoDetect",B.SaveBeforeRun="task.saveBeforeRun",B.ShowDecorations="task.showDecorations",B.ProblemMatchersNeverPrompt="task.problemMatchers.neverPrompt",B.SlowProviderWarning="task.slowProviderWarning",B.QuickOpenHistory="task.quickOpen.history",B.QuickOpenDetail="task.quickOpen.detail",B.QuickOpenSkip="task.quickOpen.skip",B.QuickOpenShowAll="task.quickOpen.showAll",B.AllowAutomaticTasks="task.allowAutomaticTasks",B.Reconnection="task.reconnection"})(j||(e.TaskSettingId=j={}));var T;(function(B){B.Tasks="tasks",B.SuppressTaskName="tasks.suppressTaskName",B.Windows="tasks.windows",B.Osx="tasks.osx",B.Linux="tasks.linux",B.ShowOutput="tasks.showOutput",B.IsShellCommand="tasks.isShellCommand",B.ServiceTestSetting="tasks.service.testSetting"})(T||(e.TasksSchemaProperties=T={}));var O;(function(B){function F(J,K){const me=g.$7F.get(J.type);if(me===void 0){const ee=R.$Tm(J);return delete ee._key,N.create(ee)}const re=Object.create(null);re.type=me.taskType;const x=new Set;me.required.forEach(ee=>x.add(ee));const q=me.properties;for(const ee of Object.keys(q)){const pe=J[ee];if(pe!=null)re[ee]=pe;else if(x.has(ee)){const ce=q[ee];if(ce.default!==void 0)re[ee]=R.$Tm(ce.default);else switch(ce.type){case"boolean":re[ee]=!1;break;case"number":case"integer":re[ee]=0;break;case"string":re[ee]="";break;default:K.error(D.localize(2,null,JSON.stringify(J,void 0,0),ee));return}}}return N.create(re)}B.createTaskIdentifier=F})(O||(e.TaskDefinition=O={}))}),define(De[284],Ce([1,0,8]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$62b=e.$52b=void 0;class M{constructor(){this.a=null,this.b=null,this.d=null,this.f=!1,this.g=null,this.h=!1,this.i=null}get[Symbol.toStringTag](){return this.toString()}j(){return this.a||(this.a=new Promise((A,g)=>{this.b=A,this.d=g,this.f&&this.b(this.g),this.h&&this.d(this.i)})),this.a}resolveOk(A){this.f||this.h||(this.f=!0,this.g=A,this.a&&this.b(A))}resolveErr(A){this.f||this.h||(this.h=!0,this.i=A,this.a?this.d(A):(0,D.$Y)(A))}then(A,g){return this.j().then(A,g)}catch(A){return this.j().then(void 0,A)}finally(A){return this.j().finally(A)}}e.$52b=M;class h extends M{constructor(){super(),this.h=!0,this.i=new D.$3}}e.$62b=h}),define(De[64],Ce([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_z=e.$$z=e.$0z=e.$9z=void 0;class D{static{this.count=0}constructor(E){this._proxyIdentifierBrand=void 0,this.sid=E,this.nid=++D.count}}e.$9z=D;const M=[];function h(g){const E=new D(g);return M[E.nid]=E,E}e.$0z=h;function R(g){return M[g].sid}e.$$z=R;class A{constructor(E){this.value=E}}e.$_z=A}),define(De[5],Ce([1,0,64]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$TJ=e.$SJ=e.ExtHostTestingResource=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.$RJ=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var M;(function(y){y[y.Default=0]="Default",y[y.InCenter=1]="InCenter",y[y.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",y[y.AtTop=3]="AtTop"})(M||(e.TextEditorRevealType=M={}));var h;(function(y){y[y.UnknownInput=0]="UnknownInput",y[y.TextInput=1]="TextInput",y[y.TextDiffInput=2]="TextDiffInput",y[y.TextMergeInput=3]="TextMergeInput",y[y.NotebookInput=4]="NotebookInput",y[y.NotebookDiffInput=5]="NotebookDiffInput",y[y.CustomEditorInput=6]="CustomEditorInput",y[y.WebviewEditorInput=7]="WebviewEditorInput",y[y.TerminalEditorInput=8]="TerminalEditorInput",y[y.InteractiveEditorInput=9]="InteractiveEditorInput"})(h||(e.TabInputKind=h={}));var R;(function(y){y[y.TAB_OPEN=0]="TAB_OPEN",y[y.TAB_CLOSE=1]="TAB_CLOSE",y[y.TAB_UPDATE=2]="TAB_UPDATE",y[y.TAB_MOVE=3]="TAB_MOVE"})(R||(e.TabModelOperationKind=R={}));var A;(function(y){y[y.Editable=0]="Editable",y[y.SupportsHotExit=1]="SupportsHotExit"})(A||(e.WebviewEditorCapabilities=A={}));var g;(function(y){y[y.Int8Array=1]="Int8Array",y[y.Uint8Array=2]="Uint8Array",y[y.Uint8ClampedArray=3]="Uint8ClampedArray",y[y.Int16Array=4]="Int16Array",y[y.Uint16Array=5]="Uint16Array",y[y.Int32Array=6]="Int32Array",y[y.Uint32Array=7]="Uint32Array",y[y.Float32Array=8]="Float32Array",y[y.Float64Array=9]="Float64Array",y[y.BigInt64Array=10]="BigInt64Array",y[y.BigUint64Array=11]="BigUint64Array"})(g||(e.WebviewMessageArrayBufferViewType=g={}));var E;(function(y){y[y.Text=1]="Text",y[y.Error=2]="Error",y[y.Rich=3]="Rich"})(E||(e.CellOutputKind=E={}));var $;(function(y){y[y.Default=0]="Default",y[y.InCenter=1]="InCenter",y[y.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",y[y.AtTop=3]="AtTop"})($||(e.NotebookEditorRevealType=$={}));var P;(function(y){y[y.None=0]="None",y[y.Process=1]="Process",y[y.Output=2]="Output"})(P||(e.CandidatePortSource=P={}));class I{static{this.a=0}static mixin(r){return r._id=I.a++,r}}e.$RJ=I;var b;(function(y){y.label="a",y.kind="b",y.detail="c",y.documentation="d",y.sortText="e",y.filterText="f",y.preselect="g",y.insertText="h",y.insertTextRules="i",y.range="j",y.commitCharacters="k",y.additionalTextEdits="l",y.kindModifier="m",y.commandIdent="n",y.commandId="o",y.commandArguments="p"})(b||(e.ISuggestDataDtoField=b={}));var S;(function(y){y.defaultRanges="a",y.completions="b",y.isIncomplete="c",y.duration="d"})(S||(e.ISuggestResultDtoField=S={}));var C;(function(y){y[y.Workspace=0]="Workspace",y[y.TextDocument=1]="TextDocument"})(C||(e.ExtHostTestingResource=C={})),e.$SJ={MainThreadAuthentication:(0,D.$0z)("MainThreadAuthentication"),MainThreadBulkEdits:(0,D.$0z)("MainThreadBulkEdits"),MainThreadChatProvider:(0,D.$0z)("MainThreadChatProvider"),MainThreadChatSlashCommands:(0,D.$0z)("MainThreadChatSlashCommands"),MainThreadChatVariables:(0,D.$0z)("MainThreadChatVariables"),MainThreadClipboard:(0,D.$0z)("MainThreadClipboard"),MainThreadCommands:(0,D.$0z)("MainThreadCommands"),MainThreadComments:(0,D.$0z)("MainThreadComments"),MainThreadConfiguration:(0,D.$0z)("MainThreadConfiguration"),MainThreadConsole:(0,D.$0z)("MainThreadConsole"),MainThreadDebugService:(0,D.$0z)("MainThreadDebugService"),MainThreadDecorations:(0,D.$0z)("MainThreadDecorations"),MainThreadDiagnostics:(0,D.$0z)("MainThreadDiagnostics"),MainThreadDialogs:(0,D.$0z)("MainThreadDiaglogs"),MainThreadDocuments:(0,D.$0z)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,D.$0z)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,D.$0z)("MainThreadTextEditors"),MainThreadEditorInsets:(0,D.$0z)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,D.$0z)("MainThreadEditorTabs"),MainThreadErrors:(0,D.$0z)("MainThreadErrors"),MainThreadTreeViews:(0,D.$0z)("MainThreadTreeViews"),MainThreadDownloadService:(0,D.$0z)("MainThreadDownloadService"),MainThreadLanguageFeatures:(0,D.$0z)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,D.$0z)("MainThreadLanguages"),MainThreadLogger:(0,D.$0z)("MainThreadLogger"),MainThreadMessageService:(0,D.$0z)("MainThreadMessageService"),MainThreadOutputService:(0,D.$0z)("MainThreadOutputService"),MainThreadProgress:(0,D.$0z)("MainThreadProgress"),MainThreadQuickDiff:(0,D.$0z)("MainThreadQuickDiff"),MainThreadQuickOpen:(0,D.$0z)("MainThreadQuickOpen"),MainThreadStatusBar:(0,D.$0z)("MainThreadStatusBar"),MainThreadSecretState:(0,D.$0z)("MainThreadSecretState"),MainThreadStorage:(0,D.$0z)("MainThreadStorage"),MainThreadTelemetry:(0,D.$0z)("MainThreadTelemetry"),MainThreadTerminalService:(0,D.$0z)("MainThreadTerminalService"),MainThreadWebviews:(0,D.$0z)("MainThreadWebviews"),MainThreadWebviewPanels:(0,D.$0z)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,D.$0z)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,D.$0z)("MainThreadCustomEditors"),MainThreadUrls:(0,D.$0z)("MainThreadUrls"),MainThreadUriOpeners:(0,D.$0z)("MainThreadUriOpeners"),MainThreadProfileContentHandlers:(0,D.$0z)("MainThreadProfileContentHandlers"),MainThreadWorkspace:(0,D.$0z)("MainThreadWorkspace"),MainThreadFileSystem:(0,D.$0z)("MainThreadFileSystem"),MainThreadExtensionService:(0,D.$0z)("MainThreadExtensionService"),MainThreadSCM:(0,D.$0z)("MainThreadSCM"),MainThreadSearch:(0,D.$0z)("MainThreadSearch"),MainThreadShare:(0,D.$0z)("MainThreadShare"),MainThreadTask:(0,D.$0z)("MainThreadTask"),MainThreadWindow:(0,D.$0z)("MainThreadWindow"),MainThreadLabelService:(0,D.$0z)("MainThreadLabelService"),MainThreadNotebook:(0,D.$0z)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,D.$0z)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,D.$0z)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,D.$0z)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,D.$0z)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,D.$0z)("MainThreadInteractive"),MainThreadChat:(0,D.$0z)("MainThreadChat"),MainThreadInlineChat:(0,D.$0z)("MainThreadInlineChatShape"),MainThreadTheming:(0,D.$0z)("MainThreadTheming"),MainThreadTunnelService:(0,D.$0z)("MainThreadTunnelService"),MainThreadManagedSockets:(0,D.$0z)("MainThreadManagedSockets"),MainThreadTimeline:(0,D.$0z)("MainThreadTimeline"),MainThreadTesting:(0,D.$0z)("MainThreadTesting"),MainThreadLocalization:(0,D.$0z)("MainThreadLocalizationShape"),MainThreadAiRelatedInformation:(0,D.$0z)("MainThreadAiRelatedInformation"),MainThreadAiEmbeddingVector:(0,D.$0z)("MainThreadAiEmbeddingVector"),MainThreadIssueReporter:(0,D.$0z)("MainThreadIssueReporter")},e.$TJ={ExtHostCommands:(0,D.$0z)("ExtHostCommands"),ExtHostConfiguration:(0,D.$0z)("ExtHostConfiguration"),ExtHostDiagnostics:(0,D.$0z)("ExtHostDiagnostics"),ExtHostDebugService:(0,D.$0z)("ExtHostDebugService"),ExtHostDecorations:(0,D.$0z)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,D.$0z)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,D.$0z)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,D.$0z)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,D.$0z)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,D.$0z)("ExtHostEditors"),ExtHostTreeViews:(0,D.$0z)("ExtHostTreeViews"),ExtHostFileSystem:(0,D.$0z)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,D.$0z)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,D.$0z)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,D.$0z)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,D.$0z)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,D.$0z)("ExtHostQuickOpen"),ExtHostQuickDiff:(0,D.$0z)("ExtHostQuickDiff"),ExtHostStatusBar:(0,D.$0z)("ExtHostStatusBar"),ExtHostShare:(0,D.$0z)("ExtHostShare"),ExtHostExtensionService:(0,D.$0z)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,D.$0z)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,D.$0z)("ExtHostTerminalService"),ExtHostSCM:(0,D.$0z)("ExtHostSCM"),ExtHostSearch:(0,D.$0z)("ExtHostSearch"),ExtHostTask:(0,D.$0z)("ExtHostTask"),ExtHostWorkspace:(0,D.$0z)("ExtHostWorkspace"),ExtHostWindow:(0,D.$0z)("ExtHostWindow"),ExtHostWebviews:(0,D.$0z)("ExtHostWebviews"),ExtHostWebviewPanels:(0,D.$0z)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,D.$0z)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,D.$0z)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,D.$0z)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,D.$0z)("ExtHostEditorTabs"),ExtHostProgress:(0,D.$0z)("ExtHostProgress"),ExtHostComments:(0,D.$0z)("ExtHostComments"),ExtHostSecretState:(0,D.$0z)("ExtHostSecretState"),ExtHostStorage:(0,D.$0z)("ExtHostStorage"),ExtHostUrls:(0,D.$0z)("ExtHostUrls"),ExtHostUriOpeners:(0,D.$0z)("ExtHostUriOpeners"),ExtHostProfileContentHandlers:(0,D.$0z)("ExtHostProfileContentHandlers"),ExtHostOutputService:(0,D.$0z)("ExtHostOutputService"),ExtHosLabelService:(0,D.$0z)("ExtHostLabelService"),ExtHostNotebook:(0,D.$0z)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,D.$0z)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,D.$0z)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,D.$0z)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,D.$0z)("ExtHostNotebookRenderers"),ExtHostNotebookDocumentSaveParticipant:(0,D.$0z)("ExtHostNotebookDocumentSaveParticipant"),ExtHostInteractive:(0,D.$0z)("ExtHostInteractive"),ExtHostInlineChat:(0,D.$0z)("ExtHostInlineChatShape"),ExtHostChat:(0,D.$0z)("ExtHostChat"),ExtHostChatSlashCommands:(0,D.$0z)("ExtHostChatSlashCommands"),ExtHostChatVariables:(0,D.$0z)("ExtHostChatVariables"),ExtHostChatProvider:(0,D.$0z)("ExtHostChatProvider"),ExtHostAiRelatedInformation:(0,D.$0z)("ExtHostAiRelatedInformation"),ExtHostAiEmbeddingVector:(0,D.$0z)("ExtHostAiEmbeddingVector"),ExtHostTheming:(0,D.$0z)("ExtHostTheming"),ExtHostTunnelService:(0,D.$0z)("ExtHostTunnelService"),ExtHostManagedSockets:(0,D.$0z)("ExtHostManagedSockets"),ExtHostAuthentication:(0,D.$0z)("ExtHostAuthentication"),ExtHostTimeline:(0,D.$0z)("ExtHostTimeline"),ExtHostTesting:(0,D.$0z)("ExtHostTesting"),ExtHostTelemetry:(0,D.$0z)("ExtHostTelemetry"),ExtHostLocalization:(0,D.$0z)("ExtHostLocalization"),ExtHostIssueReporter:(0,D.$0z)("ExtHostIssueReporter")}}),define(De[285],Ce([1,0,5,7]),function($e,e,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xcc=void 0;class h{constructor(A){this.a=new Map,this.b=0,this.c=A.getProxy(D.$SJ.MainThreadAiRelatedInformation)}async $provideAiRelatedInformation(A,g,E){if(this.a.size===0)throw new Error("No related information providers registered");const $=this.a.get(A);if(!$)throw new Error("related information provider not found");return await $.provideRelatedInformation(g,E)??[]}getRelatedInformation(A,g,E){return this.c.$getAiRelatedInformation(g,E)}registerRelatedInformationProvider(A,g,E){const $=this.b;return this.b++,this.a.set($,E),this.c.$registerAiRelatedInformationProvider($,g),new M.$UJ(()=>{this.c.$unregisterAiRelatedInformationProvider($),this.a.delete($)})}}e.$xcc=h}),define(De[89],Ce([1,0,6,17,5,20]),function($e,e,D,M,h,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bac=e.$Aac=e.$zac=void 0,e.$zac=(0,D.$zh)("IExtHostApiDeprecationService");let A=class{constructor(E,$){this.c=$,this.a=new Set,this.b=E.getProxy(h.$SJ.MainThreadTelemetry)}report(E,$,P){const I=this.d(E,$);this.a.has(I)||(this.a.add(I),$.isUnderDevelopment&&this.c.warn(`[Deprecation Warning] '${E}' is deprecated. ${P}`),this.b.$publicLog2("extHostDeprecatedApiUsage",{extensionId:$.identifier.value,apiId:E}))}d(E,$){return`${E}-${$.identifier.value}`}};e.$Aac=A,e.$Aac=A=Ke([Ve(0,R.$UL),Ve(1,M.$3i)],A),e.$Bac=Object.freeze(new class{report(g,E,$){}})}),define(De[286],Ce([1,0,4,5,7,25]),function($e,e,D,M,h,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8bc=void 0;class A{constructor($){this.b=new Map,this.c=[],this.d=new D.$hc,this.onDidChangeSessions=this.d.event,this.f=new g,this.g=new g,this.a=$.getProxy(M.$SJ.MainThreadAuthentication)}$setProviders($){return this.c=$,Promise.resolve()}async getSession($,P,I,b={}){const S=R.$Tl.toKey($.identifier),C=[...I].sort().join(" ");return await this.f.getOrCreate(`${S} ${P} ${C}`,async()=>{await this.a.$ensureProvider(P);const y=$.displayName||$.name;return this.a.$getSession(P,I,S,y,b)})}async getSessions($,P,I){const b=R.$Tl.toKey($.identifier),S=[...I].sort().join(" ");return await this.g.getOrCreate(`${b} ${S}`,async()=>{await this.a.$ensureProvider(P);const C=$.displayName||$.name;return this.a.$getSessions(P,I,b,C)})}async removeSession($,P){const I=this.b.get($);return I?I.provider.removeSession(P):this.a.$removeSession($,P)}registerAuthenticationProvider($,P,I,b){if(this.b.get($))throw new Error(`An authentication provider with id '${$}' is already registered.`);this.b.set($,{label:P,provider:I,options:b??{supportsMultipleAccounts:!1}}),this.c.find(C=>C.id===$)||this.c.push({id:$,label:P});const S=I.onDidChangeSessions(C=>{this.a.$sendDidChangeSessions($,{added:C.added??[],changed:C.changed??[],removed:C.removed??[]})});return this.a.$registerAuthenticationProvider($,P,b?.supportsMultipleAccounts??!1),new h.$UJ(()=>{S.dispose(),this.b.delete($);const C=this.c.findIndex(y=>y.id===$);C>-1&&this.c.splice(C),this.a.$unregisterAuthenticationProvider($)})}$createSession($,P,I){const b=this.b.get($);if(b)return Promise.resolve(b.provider.createSession(P,I));throw new Error(`Unable to find authentication provider with handle: ${$}`)}$removeSession($,P){const I=this.b.get($);if(I)return Promise.resolve(I.provider.removeSession(P));throw new Error(`Unable to find authentication provider with handle: ${$}`)}$getSessions($,P){const I=this.b.get($);if(I)return Promise.resolve(I.provider.getSessions(P));throw new Error(`Unable to find authentication provider with handle: ${$}`)}$onDidChangeAuthenticationSessions($,P){return this.d.fire({provider:{id:$,label:P}}),Promise.resolve()}}e.$8bc=A;class g{constructor(){this.a=new Map}getOrCreate($,P){const I=this.a.get($);if(I)return I;const b=P().finally(()=>this.a.delete($));return this.a.set($,b),b}}}),define(De[287],Ce([1,0,5,20,10]),function($e,e,D,M,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bcc=void 0;let R=class{constructor(g,E){this.a=g.getProxy(D.$SJ.MainThreadBulkEdits),this.b={getTextDocumentVersion:$=>E.getDocument($)?.version,getNotebookDocumentVersion:()=>{}}}applyWorkspaceEdit(g,E,$){const P=h.WorkspaceEdit.from(g,this.b);return this.a.$tryApplyWorkspaceEdit(P,void 0,$?.isRefactoring??!1)}};e.$bcc=R,e.$bcc=R=Ke([Ve(0,M.$UL)],R)}),define(De[288],Ce([1,0,13,4,48,3,37,197,5,10]),function($e,e,D,M,h,R,A,g,E,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pcc=void 0;class P{static{this.a=0}constructor(S,C){this.extension=S,this.provider=C,this.handle=P.a++}}class I{static{this.a=0}constructor(S,C){this.h=C,this.b=new Map,this.d=new Map,this.e=new M.$hc,this.onDidPerformUserAction=this.e.event,this.g=S.getProxy(E.$SJ.MainThreadChat)}registerChatProvider(S,C,y){const r=new P(S,y);return this.b.set(r.handle,r),this.g.$registerChatProvider(r.handle,C),(0,R.$kb)(()=>{this.g.$unregisterChatProvider(r.handle),this.b.delete(r.handle)})}transferChatSession(S,C){const y=h.Iterable.find(this.d.keys(),r=>this.d.get(r)===S)??0;typeof y=="number"&&this.g.$transferChatSession(y,C)}addChatRequest(S){this.g.$addRequest(S)}sendInteractiveRequestToProvider(S,C){this.g.$sendRequestToProvider(S,C)}async $prepareChat(S,C,y){const r=this.b.get(S);if(!r)return;const i=await r.provider.prepareSession(C,y);if(!i)return;const a=I.a++;return this.d.set(a,i),{id:a,requesterUsername:i.requester?.name,requesterAvatarIconUri:i.requester?.icon,responderUsername:i.responder?.name,responderAvatarIconUri:i.responder?.icon,inputPlaceholder:i.inputPlaceholder}}async $resolveRequest(S,C,y,r){const i=this.b.get(S);if(!i)return;const a=this.d.get(C);if(!a||!i.provider.resolveRequest)return;const m=await i.provider.resolveRequest(a,y,r);if(m)return{message:typeof m.message=="string"?m.message:$.ChatReplyFollowup.from(m.message)}}async $provideWelcomeMessage(S,C){const y=this.b.get(S);if(!y||!y.provider.provideWelcomeMessage)return;const r=await y.provider.provideWelcomeMessage(C);if(r)return r.map(i=>typeof i=="string"?i:i.map(a=>$.ChatReplyFollowup.from(a)))}async $provideFollowups(S,C,y){const r=this.b.get(S);if(!r)return;const i=this.d.get(C);return!i||!r.provider.provideFollowups?void 0:(await r.provider.provideFollowups(i,y))?.map(m=>$.ChatFollowup.from(m))}$removeRequest(S,C,y){const r=this.b.get(S);if(!r)return;const i=this.d.get(C);i&&r.provider.removeRequest&&r.provider.removeRequest(i,y)}async $provideReply(S,C,y,r){const i=this.b.get(S);if(!i)return;const a=this.d.get(C);if(!a)return;const m={session:a,message:typeof y.message=="string"?y.message:$.ChatReplyFollowup.to(y.message),variables:{}};if(y.variables)for(const n of Object.keys(y.variables))m.variables[n]=y.variables[n].map($.ChatVariable.to);const p=A.$dc.create(!1);let f;const t={report:n=>{if(!r.isCancellationRequested)if(typeof f>"u"&&(f=p.elapsed()),"responseId"in n)this.g.$acceptResponseProgress(S,C,{requestId:n.responseId});else if("placeholder"in n&&"resolvedContent"in n){const c=Promise.all([this.g.$acceptResponseProgress(S,C,{placeholder:n.placeholder}),n.resolvedContent]);(0,D.$tg)(c,r).then(d=>{if(!d)return;const[v,k]=d;this.g.$acceptResponseProgress(S,C,k,v??void 0)})}else"content"in n?this.g.$acceptResponseProgress(S,C,{content:typeof n.content=="string"?n.content:$.MarkdownString.from(n.content)}):this.g.$acceptResponseProgress(S,C,n)}};let s;try{s=await i.provider.provideResponseWithProgress(m,t,r),s||(s={errorDetails:{message:(0,g.localize)(0,null)}})}catch(n){s={errorDetails:{message:(0,g.localize)(1,null,n.message),responseIsIncomplete:!0}},this.h.error(n)}try{if(a.saveState&&this.d.has(C)){const n=a.saveState();this.g.$acceptChatState(C,n)}}catch(n){this.h.warn(n)}const o={firstProgress:f??0,totalElapsed:p.elapsed()};return{errorDetails:s.errorDetails,timings:o}}async $provideSlashCommands(S,C,y){const r=this.b.get(S);if(!r)return;const i=this.d.get(C);return!i||!r.provider.provideSlashCommands?void 0:(await r.provider.provideSlashCommands(i,y))?.map(m=>({...m,kind:$.CompletionItemKind.from(m.kind)}))}$releaseSession(S){this.d.delete(S)}async $onDidPerformUserAction(S){this.e.fire(S)}}e.$pcc=I}),define(De[289],Ce([1,0,3,5,10,83,25]),function($e,e,D,M,h,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ucc=void 0;class g{static{this.a=1}constructor($,P){this.d=P,this.c=new Map,this.e=new Map,this.f=new A.$Vl,this.b=$.getProxy(M.$SJ.MainThreadChatProvider)}registerProvider($,P,I,b){const S=g.a++;return this.c.set(S,{extension:$,provider:I}),this.b.$registerProvider(S,P,{extension:$,displayName:b.name??$.value}),(0,D.$kb)(()=>{this.b.$unregisterProvider(S),this.c.delete(S)})}async $provideChatResponse($,P,I,b,S){const C=this.c.get($);if(!C)return;const y=new R.$1u(async r=>{if(S.isCancellationRequested){this.d.warn(`[CHAT](${C.extension.value}) CANNOT send progress because the REQUEST IS CANCELLED`);return}await this.b.$handleProgressChunk(P,{index:r.index,part:r.part})},{async:!0});return C.provider.provideChatResponse(I.map(h.ChatMessage.to),b,y,S)}allowListExtensionWhile($,P){this.f.set($,P),P.finally(()=>this.f.delete($))}async requestChatResponseProvider($,P){if(!this.f.has($))throw new Error("Extension is NOT allowed to make chat requests");const I=this;return{get isRevoked(){return!I.f.has($)},async makeRequest(b,S,C,y){if(!I.f.has($))throw new Error("Access to chat has been revoked");const r=Math.random()*1e6|0;I.e.set(r,C);try{await I.b.$fetchResponse($,P,r,b.map(h.ChatMessage.from),S,y)}finally{I.e.delete(r)}}}}async $handleResponseFragment($,P){this.e.get($)?.report(P)}}e.$ucc=g}),define(De[290],Ce([1,0,3,5,7,10,83,13]),function($e,e,D,M,h,R,A,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vcc=void 0;class E{static{this.a=0}constructor(I,b,S){this.d=b,this.e=S,this.b=new Map,this.c=I.getProxy(M.$SJ.MainThreadChatSlashCommands)}registerCommand(I,b,S,C){const y=E.a++;return this.b.set(y,{extension:I,command:S}),this.c.$registerCommand(y,b,C.description),(0,D.$kb)(()=>{this.c.$unregisterCommand(y),this.b.delete(y)})}async $executeCommand(I,b,S,C,y){const r=this.b.get(I);if(!r){this.e.warn(`[CHAT](${I}) CANNOT execute command because the command is not registered`);return}let i=!1;function a(){if(i)throw new Error("Only valid while executing the command")}const m=new g.$Zg;y.onCancellationRequested(()=>m.complete()),setTimeout(()=>m.complete(),3*1e3),this.d.allowListExtensionWhile(r.extension,m.p);const p=r.command({role:h.ChatMessageRole.User,content:S},{history:C.history.map(R.ChatMessage.to)},new A.$1u(f=>{a(),this.c.$handleProgressChunk(b,{content:$(f.message)?f.message:f.message.value})}),y);try{return await(0,g.$tg)(Promise.resolve(p).then(f=>{if(f&&"followUp"in f)return{followUp:f?.followUp?.map(s=>R.ChatFollowup.from(s))}}),y)}finally{i=!0,m.complete()}}}e.$vcc=E;function $(P){return!!P&&typeof P=="object"&&"treeData"in P}}),define(De[291],Ce([1,0,3,5,8,10]),function($e,e,D,M,h,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wcc=void 0;class A{static{this.a=0}constructor(E){this.b=new Map,this.c=E.getProxy(M.$SJ.MainThreadChatVariables)}async $resolveVariable(E,$,P){const I=this.b.get(E);if(I)try{const b=await I.resolver.resolve(I.data.name,{message:$},P);if(b)return b.map(R.ChatVariable.from)}catch(b){(0,h.$Z)(b)}}registerVariableResolver(E,$,P,I){const b=A.a++;return this.b.set(b,{extension:E.identifier,data:{name:$,description:P},resolver:I}),this.c.$registerVariable(b,{name:$,description:P}),(0,D.$kb)(()=>{this.b.delete(b),this.c.$unregisterVariable(b)})}}e.$wcc=A}),define(De[292],Ce([1,0,5]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Eac=void 0;class M{constructor(R){const A=R.getProxy(D.$SJ.MainThreadClipboard);this.value=Object.freeze({readText(){return A.$readText()},writeText(g){return A.$writeText(g)}})}}e.$Eac=M}),define(De[33],Ce([1,0,18,7,10,23,5,19,17,77,34,58,2,3,6,20,144,21,64,44,37,85,88]),function($e,e,D,M,h,R,A,g,E,$,P,I,b,S,C,y,r,i,a,m,p,f,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iM=e.$hM=e.$gM=e.$fM=e.$eM=e.$dM=void 0;let s=class{#e;#t;#i;constructor(k,u,l){this.b=new Map,this.c=new Map,this.#e=k.getProxy(A.$SJ.MainThreadCommands),this.d=u,this.#i=l,this.#t=k.getProxy(A.$SJ.MainThreadTelemetry),this.converter=new o(this,w=>{const L=this.c.get(w);return L?.result===c.Void?L:void 0},u),this.f=[{processArgument(w){return(0,$.$9g)(w)}},{processArgument(w){return(0,R.$Vm)(w,function(L){if(P.$hs.isIRange(L))return h.Range.to(L);if(I.$gs.isIPosition(L))return h.Position.to(L);if(P.$hs.isIRange(L.range)&&b.URI.isUri(L.uri))return h.location.to(L);if(L instanceof i.$Hc)return L.buffer.buffer;if(!Array.isArray(L))return L})}}]}registerArgumentProcessor(k){this.f.push(k)}registerApiCommand(k){const u=this.registerCommand(!1,k.id,async(...l)=>{const w=k.args.map((N,j)=>{if(!N.validate(l[j]))throw new Error(`Invalid argument '${N.name}' when running '${k.id}', received: ${l[j]}`);return N.convert(l[j])}),L=await this.executeCommand(k.internalId,...w);return k.result.convert(L,l,this.converter)},void 0,{description:k.description,args:k.args,returns:k.result.description});return this.c.set(k.id,k),new M.$UJ(()=>{u.dispose(),this.c.delete(k.id)})}registerCommand(k,u,l,w,L,N){if(this.d.trace("ExtHostCommands#registerCommand",u),!u.trim().length)throw new Error("invalid id");if(this.b.has(u))throw new Error(`command '${u}' already exists`);return this.b.set(u,{callback:l,thisArg:w,description:L,extension:N}),k&&this.#e.$registerCommand(u),new M.$UJ(()=>{this.b.delete(u)&&k&&this.#e.$unregisterCommand(u)})}executeCommand(k,...u){return this.d.trace("ExtHostCommands#executeCommand",k),this.g(k,u,!0)}async g(k,u,l){if(this.b.has(k))return this.#e.$fireCommandActivationEvent(k),this.h(k,u,!1);{let w=!1;const L=(0,R.$Vm)(u,function(N){if(N instanceof M.$VJ)return h.Position.from(N);if(N instanceof M.$WJ)return h.Range.from(N);if(N instanceof M.$7J)return h.location.from(N);if(M.$gL.isNotebookRange(N))return h.NotebookRange.from(N);if(N instanceof ArrayBuffer)return w=!0,i.$Hc.wrap(new Uint8Array(N));if(N instanceof Uint8Array)return w=!0,i.$Hc.wrap(N);if(N instanceof i.$Hc)return w=!0,N;if(!Array.isArray(N))return N});try{const N=await this.#e.$executeCommand(k,w?new a.$_z(L):L,l);return(0,$.$9g)(N)}catch(N){if(N instanceof Error&&N.message==="$executeCommand:retry")return this.g(k,u,!1);throw N}}}async h(k,u,l){const w=this.b.get(k);if(!w)throw new Error("Unknown command");const{callback:L,thisArg:N,description:j}=w;if(j)for(let O=0;O<j.args.length;O++)try{(0,D.$Ce)(u[O],j.args[O].constraint)}catch{throw new Error(`Running the contributed command: '${k}' failed. Illegal argument '${j.args[O].name}' - ${j.args[O].description}`)}const T=p.$dc.create();try{return await L.apply(N,u)}catch(O){if(k===this.converter.delegatingCommandId){const B=this.converter.getActualCommand(...u);B&&(k=B.command)}if(this.d.error(O,k,w.extension?.identifier),!l)throw O;if(w.extension?.identifier){const B=this.#i.onExtensionError(w.extension.identifier,O);this.d.trace("forwarded error to extension?",B,w.extension?.identifier)}throw new class extends Error{constructor(){super((0,m.$ki)(O)),this.id=k,this.source=w.extension?.displayName??w.extension?.name}}}finally{this.j(w,k,T.elapsed())}}j(k,u,l){k.extension&&this.#t.$publicLog2("Extension:ActionExecuted",{extensionId:k.extension.identifier.value,id:new f.$0n(u),duration:l})}$executeContributedCommand(k,...u){this.d.trace("ExtHostCommands#$executeContributedCommand",k);const l=this.b.get(k);return l?(u=u.map(w=>this.f.reduce((L,N)=>N.processArgument(L,l.extension?.identifier),w)),this.h(k,u,!0)):Promise.reject(new Error(`Contributed command '${k}' does not exist.`))}getCommands(k=!1){return this.d.trace("ExtHostCommands#getCommands",k),this.#e.$getCommands().then(u=>(k&&(u=u.filter(l=>l[0]!=="_")),u))}$getContributedCommandHandlerDescriptions(){const k=Object.create(null);for(const[u,l]of this.b){const{description:w}=l;w&&(k[u]=w)}return Promise.resolve(k)}};e.$dM=s,e.$dM=s=Ke([Ve(0,y.$UL),Ve(1,E.$3i),Ve(2,t.$cM)],s),e.$eM=(0,C.$zh)("IExtHostCommands");class o{constructor(k,u,l){this.d=k,this.f=u,this.g=l,this.delegatingCommandId=`__vsc${Date.now().toString(36)}`,this.b=new Map,this.c=0,this.d.registerCommand(!0,this.delegatingCommandId,this.h,this)}toInternal(k,u){if(!k)return;const l={$ident:void 0,id:k.command,title:k.title,tooltip:k.tooltip};if(!k.command)return l;const w=this.f(k.command);if(w)l.id=w.internalId,l.arguments=w.args.map((L,N)=>L.convert(k.arguments&&k.arguments[N]));else if((0,g.$Ef)(k.arguments)){const L=`${k.command}/${++this.c}`;this.b.set(L,k),u.add((0,S.$kb)(()=>{this.b.delete(L),this.g.trace("CommandsConverter#DISPOSE",L)})),l.$ident=L,l.id=this.delegatingCommandId,l.arguments=[L],this.g.trace("CommandsConverter#CREATE",k.command,L)}return l}fromInternal(k){return typeof k.$ident=="string"?this.b.get(k.$ident):{command:k.id,title:k.title,arguments:k.arguments}}getActualCommand(...k){return this.b.get(k[0])}h(...k){const u=this.getActualCommand(...k);return this.g.trace("CommandsConverter#EXECUTE",k[0],u?u.command:"MISSING"),u?this.d.executeCommand(u.command,...u.arguments||[]):Promise.reject(`Actual command not found, wanted to execute ${k[0]}`)}}e.$fM=o;class n{static{this.Uri=new n("uri","Uri of a text document",k=>b.URI.isUri(k),k=>k)}static{this.Position=new n("position","A position in a text document",k=>M.$VJ.isPosition(k),h.Position.from)}static{this.Range=new n("range","A range in a text document",k=>M.$WJ.isRange(k),h.Range.from)}static{this.Selection=new n("selection","A selection in a text document",k=>M.$XJ.isSelection(k),h.Selection.from)}static{this.Number=new n("number","",k=>typeof k=="number",k=>k)}static{this.String=new n("string","",k=>typeof k=="string",k=>k)}static{this.StringArray=n.Arr(n.String)}static Arr(k){return new n(`${k.name}_array`,`Array of ${k.name}, ${k.description}`,u=>Array.isArray(u)&&u.every(l=>k.validate(l)),u=>u.map(l=>k.convert(l)))}static{this.CallHierarchyItem=new n("item","A call hierarchy item",k=>k instanceof M.$fK,h.CallHierarchyItem.from)}static{this.TypeHierarchyItem=new n("item","A type hierarchy item",k=>k instanceof M.$zL,h.TypeHierarchyItem.from)}static{this.TestItem=new n("testItem","A VS Code TestItem",k=>k instanceof r.$8L,h.TestItem.from)}constructor(k,u,l,w){this.name=k,this.description=u,this.validate=l,this.convert=w}optional(){return new n(this.name,`(optional) ${this.description}`,k=>k==null||this.validate(k),k=>k===void 0?void 0:k===null?null:this.convert(k))}with(k,u){return new n(k??this.name,u??this.description,this.validate,this.convert)}}e.$gM=n;class c{static{this.Void=new c("no result",k=>k)}constructor(k,u){this.description=k,this.convert=u}}e.$hM=c;class d{constructor(k,u,l,w,L){this.id=k,this.internalId=u,this.description=l,this.args=w,this.result=L}}e.$iM=d}),define(De[293],Ce([1,0,19,16,2,81,129,47,133,33,10,7]),function($e,e,D,M,h,R,A,g,E,$,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dac=void 0;const b=[new $.$iM("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[$.$gM.Uri,$.$gM.Position],new $.$hM("A promise that resolves to an array of DocumentHighlight-instances.",C(P.DocumentHighlight.to))),new $.$iM("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[$.$gM.Uri],new $.$hM("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(r,i)=>{if((0,D.$Df)(r))return;class a extends I.$_J{static to(p){const f=new a(p.name,P.SymbolKind.to(p.kind),p.containerName||"",new I.$7J(i[0],P.Range.to(p.range)));return f.detail=p.detail,f.range=f.location.range,f.selectionRange=P.Range.to(p.selectionRange),f.children=p.children?p.children.map(a.to):[],f}}return r.map(a.to)})),new $.$iM("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[$.$gM.Uri,new $.$gM("options","Formatting options",r=>!0,r=>r)],new $.$hM("A promise that resolves to an array of TextEdits.",C(P.TextEdit.to))),new $.$iM("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[$.$gM.Uri,$.$gM.Range,new $.$gM("options","Formatting options",r=>!0,r=>r)],new $.$hM("A promise that resolves to an array of TextEdits.",C(P.TextEdit.to))),new $.$iM("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[$.$gM.Uri,$.$gM.Position,new $.$gM("ch","Trigger character",r=>typeof r=="string",r=>r),new $.$gM("options","Formatting options",r=>!0,r=>r)],new $.$hM("A promise that resolves to an array of TextEdits.",C(P.TextEdit.to))),new $.$iM("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[$.$gM.Uri,$.$gM.Position],new $.$hM("A promise that resolves to an array of Location or LocationLink instances.",y)),new $.$iM("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[$.$gM.Uri,$.$gM.Position],new $.$hM("A promise that resolves to an array of Location or LocationLink instances.",y)),new $.$iM("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[$.$gM.Uri,$.$gM.Position],new $.$hM("A promise that resolves to an array of Location or LocationLink instances.",y)),new $.$iM("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[$.$gM.Uri,$.$gM.Position],new $.$hM("A promise that resolves to an array of Location or LocationLink instances.",y)),new $.$iM("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[$.$gM.Uri,$.$gM.Position],new $.$hM("A promise that resolves to an array of Location-instances.",C(P.location.to))),new $.$iM("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[$.$gM.Uri,$.$gM.Position],new $.$hM("A promise that resolves to an array of Hover-instances.",C(P.Hover.to))),new $.$iM("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[$.$gM.Uri,new $.$gM("position","A position in a text document",r=>Array.isArray(r)&&r.every(i=>I.$VJ.isPosition(i)),r=>r.map(P.Position.from))],new $.$hM("A promise that resolves to an array of ranges.",r=>r.map(i=>{let a;for(const m of i.reverse())a=new I.$eK(P.Range.to(m),a);return a}))),new $.$iM("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[$.$gM.String.with("query","Search string")],new $.$hM("A promise that resolves to an array of SymbolInformation-instances.",r=>r.map(P.WorkspaceSymbol.to))),new $.$iM("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[$.$gM.Uri,$.$gM.Position],new $.$hM("A promise that resolves to an array of CallHierarchyItem-instances",r=>r.map(P.CallHierarchyItem.to))),new $.$iM("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[$.$gM.CallHierarchyItem],new $.$hM("A promise that resolves to an array of CallHierarchyIncomingCall-instances",r=>r.map(P.CallHierarchyIncomingCall.to))),new $.$iM("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[$.$gM.CallHierarchyItem],new $.$hM("A promise that resolves to an array of CallHierarchyOutgoingCall-instances",r=>r.map(P.CallHierarchyOutgoingCall.to))),new $.$iM("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[$.$gM.Uri,$.$gM.Position],new $.$hM("A promise that resolves to a range and placeholder text.",r=>{if(r)return{range:P.Range.to(r.range),placeholder:r.text}})),new $.$iM("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[$.$gM.Uri,$.$gM.Position,$.$gM.String.with("newName","The new symbol name")],new $.$hM("A promise that resolves to a WorkspaceEdit.",r=>{if(r){if(r.rejectReason)throw new Error(r.rejectReason);return P.WorkspaceEdit.to(r)}})),new $.$iM("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[$.$gM.Uri,$.$gM.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new $.$hM("A promise that resolves to an array of DocumentLink-instances.",r=>r.map(P.DocumentLink.to))),new $.$iM("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[$.$gM.Uri],new $.$hM("A promise that resolves to SemanticTokensLegend.",r=>{if(r)return new I.$$K(r.tokenTypes,r.tokenModifiers)})),new $.$iM("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[$.$gM.Uri],new $.$hM("A promise that resolves to SemanticTokens.",r=>{if(!r)return;const i=(0,A.$j0)(r);if(i.type==="full")return new I.$aL(i.data,void 0)})),new $.$iM("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[$.$gM.Uri,$.$gM.Range.optional()],new $.$hM("A promise that resolves to SemanticTokensLegend.",r=>{if(r)return new I.$$K(r.tokenTypes,r.tokenModifiers)})),new $.$iM("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[$.$gM.Uri,$.$gM.Range],new $.$hM("A promise that resolves to SemanticTokens.",r=>{if(!r)return;const i=(0,A.$j0)(r);if(i.type==="full")return new I.$aL(i.data,void 0)})),new $.$iM("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[$.$gM.Uri,$.$gM.Position,$.$gM.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),$.$gM.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new $.$hM("A promise that resolves to a CompletionList-instance.",(r,i,a)=>{if(!r)return new I.$qK([]);const m=r.suggestions.map(p=>P.CompletionItem.to(p,a));return new I.$qK(m,r.incomplete)})),new $.$iM("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[$.$gM.Uri,$.$gM.Position,$.$gM.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new $.$hM("A promise that resolves to SignatureHelp.",r=>{if(r)return P.SignatureHelp.to(r)})),new $.$iM("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[$.$gM.Uri,$.$gM.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new $.$hM("A promise that resolves to an array of CodeLens-instances.",(r,i,a)=>C(m=>new I.$iK(P.Range.to(m.range),m.command&&a.fromInternal(m.command)))(r))),new $.$iM("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[$.$gM.Uri,new $.$gM("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",r=>I.$WJ.isRange(r),r=>I.$XJ.isSelection(r)?P.Selection.from(r):P.Range.from(r)),$.$gM.String.with("kind","Code action kind to return code actions for").optional(),$.$gM.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new $.$hM("A promise that resolves to an array of Command-instances.",(r,i,a)=>C(m=>{if(m._isSynthetic){if(!m.command)throw new Error("Synthetic code actions must have a command");return a.fromInternal(m.command)}else{const p=new I.$bK(m.title,m.kind?new I.$cK(m.kind):void 0);return m.edit&&(p.edit=P.WorkspaceEdit.to(m.edit)),m.command&&(p.command=a.fromInternal(m.command)),p.isPreferred=m.isPreferred,p}})(r))),new $.$iM("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[$.$gM.Uri],new $.$hM("A promise that resolves to an array of ColorInformation objects.",r=>r?r.map(i=>new I.$wK(P.Range.to(i.range),P.Color.to(i.color))):[])),new $.$iM("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new $.$gM("color","The color to show and insert",r=>r instanceof I.$vK,P.Color.from),new $.$gM("context","Context object with uri and range",r=>!0,r=>({uri:r.uri,range:P.Range.from(r.range)}))],new $.$hM("A promise that resolves to an array of ColorPresentation objects.",r=>r?r.map(P.ColorPresentation.to):[])),new $.$iM("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[$.$gM.Uri,$.$gM.Range],new $.$hM("A promise that resolves to an array of Inlay objects",(r,i,a)=>r.map(P.InlayHint.to.bind(void 0,a)))),new $.$iM("vscode.executeFoldingRangeProvider","_executeFoldingRangeProvider","Execute folding range provider",[$.$gM.Uri],new $.$hM("A promise that resolves to an array of FoldingRange objects",(r,i)=>{if(r)return r.map(P.FoldingRange.to)})),new $.$iM("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new $.$hM("A promise that resolves to an array of NotebookContentProvider static info objects.",C(r=>({viewType:r.viewType,displayName:r.displayName,options:{transientOutputs:r.options.transientOutputs,transientCellMetadata:r.options.transientCellMetadata,transientDocumentMetadata:r.options.transientDocumentMetadata},filenamePattern:r.filenamePattern.map(i=>P.NotebookExclusiveDocumentPattern.to(i))})))),new $.$iM("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[$.$gM.Uri,$.$gM.Range,new $.$gM("context","An InlineValueContext",r=>r&&typeof r.frameId=="number"&&r.stoppedLocation instanceof I.$WJ,r=>P.InlineValueContext.from(r))],new $.$hM("A promise that resolves to an array of InlineValue objects",r=>r.map(P.InlineValue.to))),new $.$iM("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[new $.$gM("uriOrString","Uri-instance or string (only http/https)",r=>h.URI.isUri(r)||typeof r=="string"&&(0,E.$DT)(r,M.Schemas.http,M.Schemas.https),r=>r),new $.$gM("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",r=>r===void 0||typeof r=="number"||typeof r=="object",r=>r&&(typeof r=="number"?[P.ViewColumn.from(r),void 0]:[P.ViewColumn.from(r.viewColumn),P.TextEditorOpenOptions.from(r)])).optional(),$.$gM.String.with("label","").optional()],$.$hM.Void),new $.$iM("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[$.$gM.Uri.with("resource","Resource to open"),$.$gM.String.with("viewId","Custom editor view id or 'default' to use VS Code's default editor"),new $.$gM("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",r=>r===void 0||typeof r=="number"||typeof r=="object",r=>r&&(typeof r=="number"?[P.ViewColumn.from(r),void 0]:[P.ViewColumn.from(r.viewColumn),P.TextEditorOpenOptions.from(r)])).optional()],$.$hM.Void),new $.$iM("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[$.$gM.Uri.with("left","Left-hand side resource of the diff editor"),$.$gM.Uri.with("right","Right-hand side resource of the diff editor"),$.$gM.String.with("title","Human readable title for the diff editor").optional(),new $.$gM("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",r=>r===void 0||typeof r=="object",r=>r&&[P.ViewColumn.from(r.viewColumn),P.TextEditorOpenOptions.from(r)]).optional()],$.$hM.Void),new $.$iM("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[$.$gM.Uri,$.$gM.Position],new $.$hM("A promise that resolves to an array of TypeHierarchyItem-instances",r=>r.map(P.TypeHierarchyItem.to))),new $.$iM("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[$.$gM.TypeHierarchyItem],new $.$hM("A promise that resolves to an array of TypeHierarchyItem-instances",r=>r.map(P.TypeHierarchyItem.to))),new $.$iM("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[$.$gM.TypeHierarchyItem],new $.$hM("A promise that resolves to an array of TypeHierarchyItem-instances",r=>r.map(P.TypeHierarchyItem.to))),new $.$iM("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[$.$gM.TestItem],$.$hM.Void),new $.$iM("vscode.experimental.editSession.continue","_workbench.editSessions.actions.continueEditSession","Continue the current edit session in a different workspace",[$.$gM.Uri.with("workspaceUri","The target workspace to continue the current edit session in")],$.$hM.Void),new $.$iM("setContext","_setContext","Set a custom context key value that can be used in when clauses.",[$.$gM.String.with("name","The context key name"),new $.$gM("value","The context key value",()=>!0,r=>r)],$.$hM.Void),new $.$iM("vscode.executeMappedEditsProvider","_executeMappedEditsProvider","Execute Mapped Edits Provider",[$.$gM.Uri,$.$gM.StringArray,new $.$gM("MappedEditsContext","Mapped Edits Context",r=>P.MappedEditsContext.is(r),r=>P.MappedEditsContext.from(r))],new $.$hM("A promise that resolves to a workspace edit or null",r=>r?P.WorkspaceEdit.to(r):null))];class S{static register(i){b.forEach(i.registerApiCommand,i),this.a(i)}static a(i){i.registerCommand(!1,"_validateWhenClauses",g.$Hi)}}e.$Dac=S;function C(r){return i=>{if(Array.isArray(i))return i.map(r)}}function y(r){if(!Array.isArray(r))return;const i=[];for(const a of r)R.$5s(a)?i.push(P.DefinitionLink.to(a)):i.push(P.location.to(a));return i}}),define(De[294],Ce([1,0,13,70,4,3,2,81,25,10,7,5,27]),function($e,e,D,M,h,R,A,g,E,$,P,I,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fac=void 0;function S(C,y,r){const i=C.getProxy(I.$SJ.MainThreadComments);class a{static{this.a=0}constructor(){this.b=new Map,this.c=new E.$Vl,y.registerArgumentProcessor({processArgument:d=>{if(d&&d.$mid===6){const v=this.b.get(d.handle);return v?v.value:d}else if(d&&d.$mid===7){const v=this.b.get(d.commentControlHandle);if(!v)return d;const k=v.getCommentThread(d.commentThreadHandle);return k?k.value:d}else if(d&&(d.$mid===9||d.$mid===8)){const v=this.b.get(d.thread.commentControlHandle);if(!v)return d;const k=v.getCommentThread(d.thread.commentThreadHandle);return k?d.$mid===8?k.value:{thread:k.value,text:d.text}:d}else if(d&&d.$mid===10){const v=this.b.get(d.thread.commentControlHandle);if(!v)return d;const k=v.getCommentThread(d.thread.commentThreadHandle);if(!k)return d;const u=d.commentUniqueId,l=k.getCommentByUniqueId(u);return l||d}else if(d&&d.$mid===11){const v=this.b.get(d.thread.commentControlHandle);if(!v)return d;const k=v.getCommentThread(d.thread.commentThreadHandle);if(!k)return d;const u=d.text,l=d.commentUniqueId,w=k.getCommentByUniqueId(l);return w?(typeof w.body=="string"?w.body=u:w.body=new P.$jK(u),w):d}return d}})}createCommentController(d,v,k){const u=a.a++,l=new p(d,u,v,k);this.b.set(l.handle,l);const w=this.c.get(d.identifier)||[];return w.push(l),this.c.set(d.identifier,w),l.value}$createCommentThreadTemplate(d,v,k){const u=this.b.get(d);u&&u.$createCommentThreadTemplate(v,k)}async $updateCommentThreadTemplate(d,v,k){const u=this.b.get(d);u&&u.$updateCommentThreadTemplate(v,k)}$deleteCommentThread(d,v){this.b.get(d)?.$deleteCommentThread(v)}$provideCommentingRanges(d,v,k){const u=this.b.get(d);if(!u||!u.commentingRangeProvider)return Promise.resolve(void 0);const l=r.getDocument(A.URI.revive(v));return(0,D.$xg)(async()=>{const w=await u.commentingRangeProvider.provideCommentingRanges(l,k);let L;return Array.isArray(w)?L={ranges:w,fileComments:!1}:w?L={ranges:w.ranges||[],fileComments:w.fileComments||!1}:L=w??void 0,L}).then(w=>{let L;return w&&(L={ranges:w.ranges.map(N=>$.Range.from(N)),fileComments:w.fileComments}),L})}$toggleReaction(d,v,k,u,l){const w=this.b.get(d);return!w||!w.reactionHandler?Promise.resolve(void 0):(0,D.$xg)(()=>{const L=w.getCommentThread(v);if(L){const N=L.getCommentByUniqueId(u.uniqueIdInThread);if(w!==void 0&&N&&w.reactionHandler)return w.reactionHandler(N,s(l))}return Promise.resolve(void 0)})}}class m{static{this.a=0}set threadId(d){this.n=d}get threadId(){return this.n}get id(){return this.n}get resource(){return this.o}get uri(){return this.o}set range(d){(d===void 0!=(this.p===void 0)||!d||!this.p||!d.isEqual(this.p))&&(this.p=d,this.b.range=d,this.c.fire())}get range(){return this.p}set canReply(d){this.d!==d&&(this.d=d,this.b.canReply=d,this.c.fire())}get canReply(){return this.d}get label(){return this.e}set label(d){this.e=d,this.b.label=d,this.c.fire()}get contextValue(){return this.f}set contextValue(d){this.f=d,this.b.contextValue=d,this.c.fire()}get comments(){return this.q}set comments(d){this.q=d,this.b.comments=d,this.c.fire()}get collapsibleState(){return this.g}set collapsibleState(d){this.g=d,this.b.collapsibleState=d,this.c.fire()}get state(){return this.h}set state(d){this.h=d,this.b.state=d,this.c.fire()}get isDisposed(){return this.j}constructor(d,v,k,u,l,w,L,N){this.m=v,this.n=k,this.o=u,this.p=l,this.q=w,this.extensionDescription=L,this.r=N,this.handle=m.a++,this.commentHandle=0,this.b=Object.create(null),this.c=new h.$hc,this.onDidUpdateCommentThread=this.c.event,this.d=!0,this.k=new Map,this.l=new R.$nb,this.l.value=new R.$lb,this.n===void 0&&(this.n=`${d}.${this.handle}`),i.$createCommentThread(v,this.handle,this.n,this.o,$.Range.from(this.p),L.identifier,this.r),this.i=[],this.j=!1,this.i.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=w,this.i.push({dispose:()=>{i.$deleteCommentThread(v,this.handle)}});const j=this;this.value={get uri(){return j.uri},get range(){return j.range},set range(T){j.range=T},get comments(){return j.comments},set comments(T){j.comments=T},get collapsibleState(){return j.collapsibleState},set collapsibleState(T){j.collapsibleState=T},get canReply(){return j.canReply},set canReply(T){j.canReply=T},get contextValue(){return j.contextValue},set contextValue(T){j.contextValue=T},get label(){return j.label},set label(T){j.label=T},get state(){return j.state},set state(T){j.state=T},dispose:()=>{j.dispose()}}}s(){this.r&&(this.r=!1,this.b.isTemplate=!1)}eventuallyUpdateCommentThread(){if(this.j)return;this.s(),this.l.value||(this.l.value=new R.$lb);const d=k=>Object.prototype.hasOwnProperty.call(this.b,k),v={};d("range")&&(v.range=$.Range.from(this.p)),d("label")&&(v.label=this.label),d("contextValue")&&(v.contextValue=this.contextValue??null),d("comments")&&(v.comments=this.q.map(k=>f(this,k,this.k,this.extensionDescription))),d("collapsibleState")&&(v.collapseState=o(this.g)),d("canReply")&&(v.canReply=this.canReply),d("state")&&(v.state=n(this.h)),d("isTemplate")&&(v.isTemplate=this.r),this.b={},i.$updateCommentThread(this.m,this.handle,this.n,this.o,v)}getCommentByUniqueId(d){for(const v of this.k){const k=v[0],u=v[1];if(d===u)return k}}dispose(){this.j=!0,this.l.dispose(),this.i.forEach(d=>d.dispose())}}Ke([(0,M.$5g)(100)],m.prototype,"eventuallyUpdateCommentThread",null);class p{get id(){return this.h}get label(){return this.i}get handle(){return this.g}get commentingRangeProvider(){return this.b}set commentingRangeProvider(d){this.b=d,i.$updateCommentingRanges(this.handle)}get reactionHandler(){return this.c}set reactionHandler(d){this.c=d,i.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!d})}get options(){return this.d}set options(d){this.d=d,i.$updateCommentControllerFeatures(this.handle,{options:this.d})}constructor(d,v,k,u){this.f=d,this.g=v,this.h=k,this.i=u,this.a=new Map,i.$registerCommentController(this.handle,k,u);const l=this;this.value=Object.freeze({id:l.id,label:l.label,get options(){return l.options},set options(w){l.options=w},get commentingRangeProvider(){return l.commentingRangeProvider},set commentingRangeProvider(w){l.commentingRangeProvider=w},get reactionHandler(){return l.reactionHandler},set reactionHandler(w){l.reactionHandler=w},createCommentThread(w,L,N){return l.createCommentThread(w,L,N).value},dispose:()=>{l.dispose()}}),this.e=[],this.e.push({dispose:()=>{i.$unregisterCommentController(this.handle)}})}createCommentThread(d,v,k){v===void 0&&(0,b.$MF)(this.f,"fileComments");const u=new m(this.id,this.handle,void 0,d,v,k,this.f,!1);return this.a.set(u.handle,u),u}$createCommentThreadTemplate(d,v){const k=new m(this.id,this.handle,void 0,A.URI.revive(d),$.Range.to(v),[],this.f,!0);return k.collapsibleState=g.CommentThreadCollapsibleState.Expanded,this.a.set(k.handle,k),k}$updateCommentThreadTemplate(d,v){const k=this.a.get(d);k&&(k.range=$.Range.to(v))}$deleteCommentThread(d){this.a.get(d)?.dispose(),this.a.delete(d)}getCommentThread(d){return this.a.get(d)}dispose(){this.a.forEach(d=>{d.dispose()}),this.e.forEach(d=>d.dispose())}}function f(c,d,v,k){let u=v.get(d);return u||(u=++c.commentHandle,v.set(d,u)),d.state!==void 0&&(0,b.$MF)(k,"commentsDraftState"),{mode:d.mode,contextValue:d.contextValue,uniqueIdInThread:u,body:typeof d.body=="string"?d.body:$.MarkdownString.from(d.body),userName:d.author.name,userIconPath:d.author.iconPath,label:d.label,commentReactions:d.reactions?d.reactions.map(l=>t(l)):void 0,state:d.state,timestamp:d.timestamp?.toJSON()}}function t(c){return{label:c.label,iconPath:c.iconPath?$.$TL(c.iconPath):void 0,count:c.count,hasReacted:c.authorHasReacted}}function s(c){return{label:c.label||"",count:c.count||0,iconPath:c.iconPath?A.URI.revive(c.iconPath):"",authorHasReacted:c.hasReacted||!1}}function o(c){if(c!==void 0)switch(c){case P.CommentThreadCollapsibleState.Expanded:return g.CommentThreadCollapsibleState.Expanded;case P.CommentThreadCollapsibleState.Collapsed:return g.CommentThreadCollapsibleState.Collapsed}return g.CommentThreadCollapsibleState.Collapsed}function n(c){if(c!==void 0)switch(c){case P.CommentThreadState.Unresolved:return g.CommentThreadState.Unresolved;case P.CommentThreadState.Resolved:return g.CommentThreadState.Resolved}return g.CommentThreadState.Unresolved}return new a}e.$Fac=S}),define(De[295],Ce([1,0,23,5,26,20]),function($e,e,D,M,h,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bcc=void 0;let A=class{constructor(P,I){this.a=P.getProxy(M.$SJ.MainThreadConsole),this.b=I.consoleForward.includeStack,this.c=I.consoleForward.logNative,this.d("info","log"),this.d("log","log"),this.d("warn","warn"),this.d("error","error")}d(P,I){const b=this,S=console[P];Object.defineProperty(console,P,{set:()=>{},get:()=>function(){b.e(P,I,S,arguments)}})}e(P,I,b,S){this.a.$logExtensionHostMessage({type:"__$console",severity:I,arguments:E(S,this.b)}),this.c&&this.f(P,b,S)}};e.$Bcc=A,e.$Bcc=A=Ke([Ve(0,R.$UL),Ve(1,h.$$L)],A);const g=1e5;function E($,P){const I=[];if($.length)for(let b=0;b<$.length;b++){let S=$[b];if(typeof S>"u")S="undefined";else if(S instanceof Error){const C=S;C.stack?S=C.stack:S=C.toString()}I.push(S)}if(P){const b=new Error().stack;b&&I.push({__$stack:b.split(`
`).slice(3).join(`
`)})}try{const b=(0,D.$Ym)(I);return b.length>g?"Output omitted for a large object that exceeds the limits":b}catch(b){return`Output omitted for an object that cannot be inspected ('${b.toString()}')`}}}),define(De[147],Ce([1,0,2,5,7,6,20,17,19,15,14,27]),function($e,e,D,M,h,R,A,g,E,$,P,I){"use strict";var b;Object.defineProperty(e,"__esModule",{value:!0}),e.$Hbc=e.$Gbc=void 0;let S=class{static{b=this}static{this.c=0}static{this.d=250}constructor(y,r){this.h=r,this.f=new Map,this.g=y.getProxy(M.$SJ.MainThreadDecorations)}registerFileDecorationProvider(y,r){const i=b.c++;this.f.set(i,{provider:y,extensionDescription:r}),this.g.$registerDecorationProvider(i,r.identifier.value);const a=y.onDidChangeFileDecorations&&y.onDidChangeFileDecorations(m=>{if(!m){this.g.$onDidChange(i,null);return}const p=(0,E.$Vf)(m);if(p.length<=b.d){this.g.$onDidChange(i,p);return}this.h.warn("[Decorations] CAPPING events from decorations provider",r.identifier.value,p.length);const f=p.map(o=>({uri:o,rank:(0,$.$td)(o.path,"/")})),t=(0,E.$tf)(f,(o,n)=>o.rank-n.rank||(0,$.$Hd)(o.uri.path,n.uri.path)),s=[];e:for(const o of t){let n;for(const c of o){const d=(0,P.$bd)(c.uri.path);if(n!==d&&(n=d,s.push(c.uri)>=b.d))break e}}this.g.$onDidChange(i,s)});return new h.$UJ(()=>{a?.dispose(),this.g.$unregisterDecorationProvider(i),this.f.delete(i)})}async $provideDecorations(y,r,i){if(!this.f.has(y))return Object.create(null);const a=Object.create(null),{provider:m,extensionDescription:p}=this.f.get(y);return await Promise.all(r.map(async f=>{try{const{uri:t,id:s}=f,o=await Promise.resolve(m.provideFileDecoration(D.URI.revive(t),i));if(!o)return;try{h.$eL.validate(o),o.badge&&typeof o.badge!="string"&&(0,I.$MF)(p,"codiconDecoration"),a[s]=[o.propagate,o.tooltip,o.badge,o.color]}catch(n){this.h.warn(`INVALID decoration from extension '${p.identifier.value}': ${n}`)}}catch(t){this.h.error(t)}})),a}};e.$Gbc=S,e.$Gbc=S=b=Ke([Ve(0,A.$UL),Ve(1,g.$3i)],S),e.$Hbc=(0,R.$zh)("IExtHostDecorations")}),define(De[296],Ce([1,0,198,132,2,5,7,10,4,17,28,52]),function($e,e,D,M,h,R,A,g,E,$,P,I){"use strict";var b;Object.defineProperty(e,"__esModule",{value:!0}),e.$yac=e.$xac=void 0;class S{#e;#t;#i;constructor(r,i,a,m,p,f,t,s){this.d=r,this.e=i,this.f=a,this.g=m,this.h=p,this.c=!1,this.f=Math.max(m,a),this.#i=new P.$xi(o=>f.getComparisonKey(o)),this.#e=t,this.#t=s}dispose(){this.c||(this.#t.fire([...this.#i.keys()]),this.#e?.$clear(this.e),this.#i.clear(),this.c=!0)}get name(){return this.j(),this.d}set(r,i){if(!r){this.clear();return}this.j();let a=[];if(h.URI.isUri(r)){if(!i){this.delete(r);return}this.#i.set(r,i.slice()),a=[r]}else if(Array.isArray(r)){a=[];let f;r=[...r].sort(S.k);for(const t of r){const[s,o]=t;if((!f||s.toString()!==f.toString())&&(f&&this.#i.get(f).length===0&&this.#i.delete(f),f=s,a.push(s),this.#i.set(s,[])),o)this.#i.get(s)?.push(...o);else{const n=this.#i.get(s);n&&(n.length=0)}}}if(this.#t.fire(a),!this.#e)return;const m=[];let p=0;for(const f of a){let t=[];const s=this.#i.get(f);if(s)if(s.length>this.g){t=[];const o=[A.DiagnosticSeverity.Error,A.DiagnosticSeverity.Warning,A.DiagnosticSeverity.Information,A.DiagnosticSeverity.Hint];e:for(let n=0;n<4;n++)for(const c of s)if(c.severity===o[n]&&t.push({...g.Diagnostic.from(c),modelVersionId:this.h(f)})===this.g)break e;t.push({severity:M.MarkerSeverity.Info,message:(0,D.localize)(0,null,s.length-this.g),startLineNumber:t[t.length-1].startLineNumber,startColumn:t[t.length-1].startColumn,endLineNumber:t[t.length-1].endLineNumber,endColumn:t[t.length-1].endColumn})}else t=s.map(o=>({...g.Diagnostic.from(o),modelVersionId:this.h(f)}));if(m.push([f,t]),p+=t.length,p>this.f)break}this.#e.$changeMany(this.e,m)}delete(r){this.j(),this.#t.fire([r]),this.#i.delete(r),this.#e?.$changeMany(this.e,[[r,void 0]])}clear(){this.j(),this.#t.fire([...this.#i.keys()]),this.#i.clear(),this.#e?.$clear(this.e)}forEach(r,i){this.j();for(const[a,m]of this)r.call(i,a,m,this)}*[Symbol.iterator](){this.j();for(const r of this.#i.keys())yield[r,this.get(r)]}get(r){this.j();const i=this.#i.get(r);return Array.isArray(i)?Object.freeze(i.slice(0)):[]}has(r){return this.j(),Array.isArray(this.#i.get(r))}j(){if(this.c)throw new Error("illegal state - object is disposed")}static k(r,i){return r[0].toString()<i[0].toString()?-1:r[0].toString()>i[0].toString()?1:0}}e.$xac=S;let C=class{static{b=this}static{this.c=0}static{this.d=1e3}static{this.e=1.1*b.d}static _mapper(r){const i=new P.$xi;for(const a of r)i.set(a,a);return{uris:Object.freeze(Array.from(i.values()))}}constructor(r,i,a,m){this.j=i,this.k=a,this.l=m,this.g=new Map,this.h=new E.$lc({merge:p=>p.flat(),delay:50}),this.onDidChangeDiagnostics=E.Event.map(this.h.event,b._mapper),this.f=r.getProxy(R.$SJ.MainThreadDiagnostics)}createDiagnosticCollection(r,i){const{g:a,f:m,h:p,j:f,k:t,l:s}=this,o=new class{$changeMany(d,v){m.$changeMany(d,v),f.trace("[DiagnosticCollection] change many (extension, owner, uris)",r.value,d,v.length===0?"CLEARING":v)}$clear(d){m.$clear(d),f.trace("[DiagnosticCollection] remove all (extension, owner)",r.value,d)}dispose(){m.dispose()}};let n;if(!i)i="_generated_diagnostic_collection_name_#"+b.c++,n=i;else if(!a.has(i))n=i;else{this.j.warn(`DiagnosticCollection with name '${i}' does already exist.`);do n=i+b.c++;while(a.has(n))}return new class extends S{constructor(){super(i,n,b.e,b.d,d=>s.getDocument(d)?.version,t.extUri,o,p),a.set(n,this)}dispose(){super.dispose(),a.delete(n)}}}getDiagnostics(r){if(r)return this.m(r);{const i=new Map,a=[];for(const m of this.g.values())m.forEach((p,f)=>{let t=i.get(p.toString());typeof t>"u"&&(t=a.length,i.set(p.toString(),t),a.push([p,[]])),a[t][1]=a[t][1].concat(...f)});return a}}m(r){let i=[];for(const a of this.g.values())a.has(r)&&(i=i.concat(a.get(r)));return i}$acceptMarkersChange(r){if(!this.n){const i="_generated_mirror",a=new S(i,i,Number.MAX_SAFE_INTEGER,Number.MAX_SAFE_INTEGER,m=>{},this.k.extUri,void 0,this.h);this.g.set(i,a),this.n=a}for(const[i,a]of r)this.n.set(h.URI.revive(i),a.map(g.Diagnostic.to))}};e.$yac=C,e.$yac=C=b=Ke([Ve(1,$.$3i),Ve(2,I.$wac)],C)}),define(De[297],Ce([1,0,2,5,27]),function($e,e,D,M,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nac=void 0;class R{constructor(g){this.a=g.getProxy(M.$SJ.MainThreadDialogs)}showOpenDialog(g,E){return E?.allowUIResources&&(0,h.$MF)(g,"showLocal"),this.a.$showOpenDialog(E).then($=>$?$.map(P=>D.URI.revive(P)):void 0)}showSaveDialog(g){return this.a.$showSaveDialog(g).then(E=>E?D.URI.revive(E):void 0)}}e.$Nac=R}),define(De[298],Ce([1,0,8,2,7,5,16,22,15]),function($e,e,D,M,h,R,A,g,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Oac=void 0;class ${static{this.a=0}constructor(I,b,S){this.d=b,this.e=S,this.b=new Map,this.c=I.getProxy(R.$SJ.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(I,b){if(Object.keys(A.Schemas).indexOf(I)>=0)throw new Error(`scheme '${I}' already registered`);const S=$.a++;this.b.set(S,b),this.c.$registerTextContentProvider(S,I);let C;return typeof b.onDidChange=="function"&&(C=b.onDidChange(y=>{if(y.scheme!==I){this.e.warn(`Provider for scheme '${I}' is firing event for schema '${y.scheme}' which will be IGNORED`);return}this.d.getDocument(y)&&this.$provideTextDocumentContent(S,y).then(r=>{if(!r&&typeof r!="string")return;const i=this.d.getDocument(y);if(!i)return;const a=(0,E.$Cd)(r);if(!i.equalLines(a))return this.c.$onVirtualDocumentChange(y,r)},D.$Y)})),new h.$UJ(()=>{this.b.delete(S)&&this.c.$unregisterTextContentProvider(S),C&&(C.dispose(),C=void 0)})}$provideTextDocumentContent(I,b){const S=this.b.get(I);return S?Promise.resolve(S.provideTextDocumentContent(M.URI.revive(b),g.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${b.scheme}`))}}e.$Oac=$}),define(De[299],Ce([1,0,4,3,2,5,140,10,18,23,7,8]),function($e,e,D,M,h,R,A,g,E,$,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uac=void 0;class b{constructor(C,y){this.a=new D.$hc({onListenerError:I.$Z}),this.b=new D.$hc({onListenerError:I.$Z}),this.c=new D.$hc({onListenerError:I.$Z}),this.d=new D.$hc({onListenerError:I.$Z}),this.onDidAddDocument=this.a.event,this.onDidRemoveDocument=this.b.event,this.onDidChangeDocument=this.c.event,this.onDidSaveDocument=this.d.event,this.e=new M.$lb,this.h=new Map,this.f=C.getProxy(R.$SJ.MainThreadDocuments),this.g=y,this.g.onDidRemoveDocuments(r=>{for(const i of r)this.b.fire(i.document)},void 0,this.e),this.g.onDidAddDocuments(r=>{for(const i of r)this.a.fire(i.document)},void 0,this.e)}dispose(){this.e.dispose()}getAllDocumentData(){return[...this.g.allDocuments()]}getDocumentData(C){if(!C)return;const y=this.g.getDocument(C);if(y)return y}getDocument(C){const y=this.getDocumentData(C);if(!y?.document)throw new Error(`Unable to retrieve document from URI '${C}'`);return y.document}ensureDocumentData(C){const y=this.g.getDocument(C);if(y)return Promise.resolve(y);let r=this.h.get(C.toString());return r||(r=this.f.$tryOpenDocument(C).then(i=>{this.h.delete(C.toString());const a=h.URI.revive(i);return(0,E.$we)(this.g.getDocument(a))},i=>(this.h.delete(C.toString()),Promise.reject(i))),this.h.set(C.toString(),r)),r}createDocumentData(C){return this.f.$tryCreateDocument(C).then(y=>h.URI.revive(y))}$acceptModelLanguageChanged(C,y){const r=h.URI.revive(C),i=this.g.getDocument(r);if(!i)throw new Error("unknown document");this.b.fire(i.document),i._acceptLanguageId(y),this.a.fire(i.document)}$acceptModelSaved(C){const y=h.URI.revive(C),r=this.g.getDocument(y);if(!r)throw new Error("unknown document");this.$acceptDirtyStateChanged(C,!1),this.d.fire(r.document)}$acceptDirtyStateChanged(C,y){const r=h.URI.revive(C),i=this.g.getDocument(r);if(!i)throw new Error("unknown document");i._acceptIsDirty(y),this.c.fire({document:i.document,contentChanges:[],reason:void 0})}$acceptModelChanged(C,y,r){const i=h.URI.revive(C),a=this.g.getDocument(i);if(!a)throw new Error("unknown document");a._acceptIsDirty(r),a.onEvents(y);let m;y.isUndoing?m=P.TextDocumentChangeReason.Undo:y.isRedoing&&(m=P.TextDocumentChangeReason.Redo),this.c.fire((0,$.$Um)({document:a.document,contentChanges:y.changes.map(p=>({range:g.Range.to(p.range),rangeOffset:p.rangeOffset,rangeLength:p.rangeLength,text:p.text})),reason:m}))}setWordDefinitionFor(C,y){(0,A.$WL)(C,y)}}e.$uac=b}),define(De[65],Ce([1,0,54,4,3,2,6,5,140,20,145,10,17,28,16,48,55]),function($e,e,D,M,h,R,A,g,E,$,P,I,b,S,C,y,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6L=e.$5L=void 0;class i{constructor(p){this.value=p,this.a=0}ref(){this.a++}unref(){return--this.a===0}}let a=class{constructor(p,f){this.h=p,this.i=f,this.a=null,this.b=new Map,this.c=new S.$xi,this.d=new M.$hc,this.e=new M.$hc,this.f=new M.$hc,this.g=new M.$hc,this.onDidAddDocuments=this.d.event,this.onDidRemoveDocuments=this.e.event,this.onDidChangeVisibleTextEditors=this.f.event,this.onDidChangeActiveTextEditor=this.g.event}$acceptDocumentsAndEditorsDelta(p){this.acceptDocumentsAndEditorsDelta(p)}acceptDocumentsAndEditorsDelta(p){const f=[],t=[],s=[];if(p.removedDocuments)for(const o of p.removedDocuments){const n=R.URI.revive(o),c=this.c.get(n);c?.unref()&&(this.c.delete(n),f.push(c.value))}if(p.addedDocuments)for(const o of p.addedDocuments){const n=R.URI.revive(o.uri);let c=this.c.get(n);if(c&&n.scheme!==C.Schemas.vscodeNotebookCell&&n.scheme!==C.Schemas.vscodeInteractiveInput)throw new Error(`document '${n} already exists!'`);c||(c=new i(new E.$XL(this.h.getProxy(g.$SJ.MainThreadDocuments),n,o.lines,o.EOL,o.versionId,o.languageId,o.isDirty,o.notebook)),this.c.set(n,c),t.push(c.value)),c.ref()}if(p.removedEditors)for(const o of p.removedEditors){const n=this.b.get(o);this.b.delete(o),n&&s.push(n)}if(p.addedEditors)for(const o of p.addedEditors){const n=R.URI.revive(o.documentUri);D.ok(this.c.has(n),`document '${n}' does not exist`),D.ok(!this.b.has(o.id),`editor '${o.id}' already exists!`);const c=this.c.get(n).value,d=new P.$4L(o.id,this.h.getProxy(g.$SJ.MainThreadTextEditors),this.i,new r.$T(()=>c.document),o.selections.map(I.Selection.to),o.options,o.visibleRanges.map(v=>I.Range.to(v)),typeof o.editorPosition=="number"?I.ViewColumn.to(o.editorPosition):void 0);this.b.set(o.id,d)}p.newActiveEditor!==void 0&&(D.ok(p.newActiveEditor===null||this.b.has(p.newActiveEditor),`active editor '${p.newActiveEditor}' does not exist`),this.a=p.newActiveEditor),(0,h.$hb)(f),(0,h.$hb)(s),p.removedDocuments&&this.e.fire(f),p.addedDocuments&&this.d.fire(t),(p.removedEditors||p.addedEditors)&&this.f.fire(this.allEditors().map(o=>o.value)),p.newActiveEditor!==void 0&&this.g.fire(this.activeEditor())}getDocument(p){return this.c.get(p)?.value}allDocuments(){return y.Iterable.map(this.c.values(),p=>p.value)}getEditor(p){return this.b.get(p)}activeEditor(p){if(!this.a)return;const f=this.b.get(this.a);return p?f:f?.value}allEditors(){return[...this.b.values()]}};e.$5L=a,e.$5L=a=Ke([Ve(0,$.$UL),Ve(1,b.$3i)],a),e.$6L=(0,A.$zh)("IExtHostDocumentsAndEditors")}),define(De[66],Ce([1,0,10,5,2,4,6,7,20,18,69]),function($e,e,D,M,h,R,A,g,E,$,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mbc=e.$Lbc=void 0,e.$Lbc=(0,A.$zh)("IExtHostEditorTabs");class I{constructor(r,i,a){this.e=a,this.d=i,this.acceptDtoUpdate(r)}get apiObject(){if(!this.a){const r=this,i={get isActive(){return r.b.id===r.e()},get label(){return r.b.label},get input(){return r.c},get isDirty(){return r.b.isDirty},get isPinned(){return r.b.isPinned},get isPreview(){return r.b.isPreview},get group(){return r.d.apiObject}};this.a=Object.freeze(i)}return this.a}get tabId(){return this.b.id}acceptDtoUpdate(r){this.b=r,this.c=this.f()}f(){switch(this.b.input.kind){case 1:return new g.$AL(h.URI.revive(this.b.input.uri));case 2:return new g.$BL(h.URI.revive(this.b.input.original),h.URI.revive(this.b.input.modified));case 3:return new g.$CL(h.URI.revive(this.b.input.base),h.URI.revive(this.b.input.input1),h.URI.revive(this.b.input.input2),h.URI.revive(this.b.input.result));case 6:return new g.$DL(h.URI.revive(this.b.input.uri),this.b.input.viewType);case 7:return new g.$EL(this.b.input.viewType);case 4:return new g.$FL(h.URI.revive(this.b.input.uri),this.b.input.notebookType);case 5:return new g.$GL(h.URI.revive(this.b.input.original),h.URI.revive(this.b.input.modified),this.b.input.notebookType);case 8:return new g.$HL;case 9:return new g.$IL(h.URI.revive(this.b.input.uri),h.URI.revive(this.b.input.inputBoxUri));default:return}}}class b{constructor(r,i){this.c=[],this.d="",this.b=r,this.e=i;for(const a of r.tabs)a.isActive&&(this.d=a.id),this.c.push(new I(a,this,()=>this.activeTabId()))}get apiObject(){if(!this.a){const r=this,i={get isActive(){return r.b.groupId===r.e()},get viewColumn(){return D.ViewColumn.to(r.b.viewColumn)},get activeTab(){return r.c.find(a=>a.tabId===r.d)?.apiObject},get tabs(){return Object.freeze(r.c.map(a=>a.apiObject))}};this.a=Object.freeze(i)}return this.a}get groupId(){return this.b.groupId}get tabs(){return this.c}acceptGroupDtoUpdate(r){this.b=r}acceptTabOperation(r){if(r.kind===0){const a=new I(r.tabDto,this,()=>this.activeTabId());return this.c.splice(r.index,0,a),r.tabDto.isActive&&(this.d=a.tabId),a}else if(r.kind===1){const a=this.c.splice(r.index,1)[0];if(!a)throw new Error(`Tab close updated received for index ${r.index} which does not exist`);return a.tabId===this.d&&(this.d=""),a}else if(r.kind===3){if(r.oldIndex===void 0)throw new Error("Invalid old index on move IPC");const a=this.c.splice(r.oldIndex,1)[0];if(!a)throw new Error(`Tab move updated received for index ${r.oldIndex} which does not exist`);return this.c.splice(r.index,0,a),a}const i=this.c.find(a=>a.tabId===r.tabDto.id);if(!i)throw new Error("INVALID tab");return r.tabDto.isActive?this.d=r.tabDto.id:this.d===r.tabDto.id&&!r.tabDto.isActive&&(this.d=""),i.acceptDtoUpdate(r.tabDto),i}activeTabId(){return this.d}}let S=class{constructor(r){this.b=new R.$hc,this.c=new R.$hc,this.e=[],this.a=r.getProxy(M.$SJ.MainThreadEditorTabs)}get tabGroups(){if(!this.f){const r=this,i={onDidChangeTabGroups:r.c.event,onDidChangeTabs:r.b.event,get all(){return Object.freeze(r.e.map(a=>a.apiObject))},get activeTabGroup(){const a=r.d;return(0,$.$we)(r.e.find(p=>p.groupId===a)?.apiObject)},close:async(a,m)=>{const p=Array.isArray(a)?a:[a];return p.length?C(p[0])?this.j(p,m):this.i(p,m):!0}};this.f=Object.freeze(i)}return this.f}$acceptEditorTabModel(r){const i=new Set(this.e.map(o=>o.groupId)),a=new Set(r.map(o=>o.groupId)),m=(0,P.$J)(i,a),p=this.e.filter(o=>m.removed.includes(o.groupId)).map(o=>o.apiObject),f=[],t=[];this.e=r.map(o=>{const n=new b(o,()=>this.d);return m.added.includes(n.groupId)?f.push(n.apiObject):t.push(n.apiObject),n});const s=(0,$.$we)(r.find(o=>o.isActive===!0)?.groupId);s!==void 0&&this.d!==s&&(this.d=s),this.c.fire(Object.freeze({opened:f,closed:p,changed:t}))}$acceptTabGroupUpdate(r){const i=this.e.find(a=>a.groupId===r.groupId);if(!i)throw new Error("Update Group IPC call received before group creation.");i.acceptGroupDtoUpdate(r),r.isActive&&(this.d=r.groupId),this.c.fire(Object.freeze({changed:[i.apiObject],opened:[],closed:[]}))}$acceptTabOperation(r){const i=this.e.find(m=>m.groupId===r.groupId);if(!i)throw new Error("Update Tabs IPC call received before group creation.");const a=i.acceptTabOperation(r);switch(r.kind){case 0:this.b.fire(Object.freeze({opened:[a.apiObject],closed:[],changed:[]}));return;case 1:this.b.fire(Object.freeze({opened:[],closed:[a.apiObject],changed:[]}));return;case 3:case 2:this.b.fire(Object.freeze({opened:[],closed:[],changed:[a.apiObject]}));return}}g(r){for(const i of this.e)for(const a of i.tabs)if(a.apiObject===r)return a}h(r){return this.e.find(i=>i.apiObject===r)}async i(r,i){const a=[];for(const m of r){const p=this.g(m);if(!p)throw new Error("Tab close: Invalid tab not found!");a.push(p.tabId)}return this.a.$closeTab(a,i)}async j(r,i){const a=[];for(const m of r){const p=this.h(m);if(!p)throw new Error("Group close: Invalid group not found!");a.push(p.groupId)}return this.a.$closeGroup(a,i)}};e.$Mbc=S,e.$Mbc=S=Ke([Ve(0,E.$UL)],S);function C(y){return y.tabs!==void 0}}),define(De[300],Ce([1,0,5,7]),function($e,e,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ycc=void 0;class h{constructor(A){this.a=new Map,this.b=0,this.c=A.getProxy(D.$SJ.MainThreadAiEmbeddingVector)}async $provideAiEmbeddingVector(A,g,E){if(this.a.size===0)throw new Error("No embedding vector providers registered");const $=this.a.get(A);if(!$)throw new Error("Embedding vector provider not found");const P=await $.provideEmbeddingVector(g,E);if(!P)throw new Error("Embedding vector provider returned undefined");return P}registerEmbeddingVectorProvider(A,g,E){const $=this.b;return this.b++,this.a.set($,E),this.c.$registerAiEmbeddingVectorProvider(g,$),new M.$UJ(()=>{this.c.$unregisterAiEmbeddingVectorProvider($),this.a.delete($)})}}e.$ycc=h}),define(De[301],Ce([1,0,2,5,3,7,10,167,15,21,27,78]),function($e,e,D,M,h,R,A,g,E,$,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ibc=void 0;class b{constructor(){this.a=[]}add(y){this.b=void 0,this.a.push(y)}delete(y){const r=this.a.indexOf(y);r>=0&&(this.a.splice(r,1),this.b=void 0)}c(){if(!this.b){const y=this.a.sort(),r=[];let i,a,m=14,p=14;for(const f of y){let t=i?(0,E.$Qd)(i,f):0;for(t===0?a=1:a=p;t<f.length;t++)t+1===f.length?(m=p,p=9):p+=1,r.push([a,f.toUpperCase().charCodeAt(t),p]),r.push([a,f.toLowerCase().charCodeAt(t),p]),a=p;i=f,p=m}r.push([9,58,10]),r.push([10,47,12]),this.b=new g.$mY(r)}}provideDocumentLinks(y){this.c();const r=[],i=g.$nY.computeLinks({getLineContent(a){return y.lineAt(a-1).text},getLineCount(){return y.lineCount}},this.b);for(const a of i){const m=A.DocumentLink.to(a);m.target&&r.push(m)}return r}}class S{constructor(y,r){this.i=r,this.b=new b,this.c=new Map,this.d=new Set,this.f=new Map,this.h=0,this.a=y.getProxy(M.$SJ.MainThreadFileSystem)}dispose(){this.g?.dispose()}registerFileSystemProvider(y,r,i,a={}){if(S.j(i),this.d.has(r))throw new Error(`a provider for the scheme '${r}' is already registered`);this.g||(this.g=this.i.registerDocumentLinkProvider(y,"*",this.b));const m=this.h++;this.b.add(r),this.d.add(r),this.c.set(m,i);let p=2;a.isCaseSensitive&&(p+=1024),a.isReadonly&&(p+=2048),typeof i.copy=="function"&&(p+=8),typeof i.open=="function"&&typeof i.close=="function"&&typeof i.read=="function"&&typeof i.write=="function"&&((0,P.$MF)(y,"fsChunks"),p+=4);let f;a.isReadonly&&(0,I.$Xj)(a.isReadonly)&&((0,P.$MF)(y,"readonlyMessage"),f={value:a.isReadonly.value,isTrusted:a.isReadonly.isTrusted,supportThemeIcons:a.isReadonly.supportThemeIcons,supportHtml:a.isReadonly.supportHtml,baseUri:a.isReadonly.baseUri,uris:a.isReadonly.uris}),this.a.$registerFileSystemProvider(m,r,p,f).catch(s=>{console.error(`FAILED to register filesystem provider of ${y.identifier.value}-extension for the scheme ${r}`),console.error(s)});const t=i.onDidChangeFile(s=>{const o=[];for(const n of s){const{uri:c,type:d}=n;if(c.scheme!==r)continue;let v;switch(d){case R.FileChangeType.Changed:v=0;break;case R.FileChangeType.Created:v=1;break;case R.FileChangeType.Deleted:v=2;break;default:throw new Error("Unknown FileChangeType")}o.push({resource:c,type:v})}this.a.$onFileSystemChange(m,o)});return(0,h.$kb)(()=>{t.dispose(),this.b.delete(r),this.d.delete(r),this.c.delete(m),this.a.$unregisterProvider(m)})}static j(y){if(!y)throw new Error("MISSING provider");if(typeof y.watch!="function")throw new Error("Provider does NOT implement watch");if(typeof y.stat!="function")throw new Error("Provider does NOT implement stat");if(typeof y.readDirectory!="function")throw new Error("Provider does NOT implement readDirectory");if(typeof y.createDirectory!="function")throw new Error("Provider does NOT implement createDirectory");if(typeof y.readFile!="function")throw new Error("Provider does NOT implement readFile");if(typeof y.writeFile!="function")throw new Error("Provider does NOT implement writeFile");if(typeof y.delete!="function")throw new Error("Provider does NOT implement delete");if(typeof y.rename!="function")throw new Error("Provider does NOT implement rename")}static k(y){const{type:r,ctime:i,mtime:a,size:m,permissions:p}=y;return{type:r,ctime:i,mtime:a,size:m,permissions:p}}$stat(y,r){return Promise.resolve(this.l(y).stat(D.URI.revive(r))).then(i=>S.k(i))}$readdir(y,r){return Promise.resolve(this.l(y).readDirectory(D.URI.revive(r)))}$readFile(y,r){return Promise.resolve(this.l(y).readFile(D.URI.revive(r))).then(i=>$.$Hc.wrap(i))}$writeFile(y,r,i,a){return Promise.resolve(this.l(y).writeFile(D.URI.revive(r),i.buffer,a))}$delete(y,r,i){return Promise.resolve(this.l(y).delete(D.URI.revive(r),i))}$rename(y,r,i,a){return Promise.resolve(this.l(y).rename(D.URI.revive(r),D.URI.revive(i),a))}$copy(y,r,i,a){const m=this.l(y);if(!m.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(m.copy(D.URI.revive(r),D.URI.revive(i),a))}$mkdir(y,r){return Promise.resolve(this.l(y).createDirectory(D.URI.revive(r)))}$watch(y,r,i,a){const m=this.l(y).watch(D.URI.revive(i),a);this.f.set(r,m)}$unwatch(y,r){const i=this.f.get(r);i&&(i.dispose(),this.f.delete(r))}$open(y,r,i){const a=this.l(y);if(!a.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(a.open(D.URI.revive(r),i))}$close(y,r){const i=this.l(y);if(!i.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(i.close(r))}$read(y,r,i,a){const m=this.l(y);if(!m.read)throw new Error('FileSystemProvider does not implement "read"');const p=$.$Hc.alloc(a);return Promise.resolve(m.read(r,i,p.buffer,0,a)).then(f=>p.slice(0,f))}$write(y,r,i,a){const m=this.l(y);if(!m.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(m.write(r,i,a.buffer,0,a.byteLength))}l(y){const r=this.c.get(y);if(!r){const i=new Error;throw i.name="ENOPRO",i.message="no provider",i}return r}}e.$ibc=S}),define(De[67],Ce([1,0,5,30,7,21,6,20,52,3,13,24,16]),function($e,e,D,M,h,R,A,g,E,$,P,I,b){"use strict";var S;Object.defineProperty(e,"__esModule",{value:!0}),e.$2ac=e.$1ac=void 0;let C=S=class{constructor(r,i){this.b=new Map,this.c=new P.$Ng,this.a=r.getProxy(D.$SJ.MainThreadFileSystem);const a=this;this.value=Object.freeze({async stat(m){try{let p;const f=a.b.get(m.scheme);return f?(await a.a.$ensureActivation(m.scheme),p=await f.impl.stat(m)):p=await a.a.$stat(m),{type:p.type,ctime:p.ctime,mtime:p.mtime,size:p.size,permissions:p.permissions===M.FilePermission.Readonly?1:void 0}}catch(p){S.e(p)}},async readDirectory(m){try{const p=a.b.get(m.scheme);return p?(await a.a.$ensureActivation(m.scheme),(await p.impl.readDirectory(m)).slice()):await a.a.$readdir(m)}catch(p){return S.e(p)}},async createDirectory(m){try{const p=a.b.get(m.scheme);return p&&!p.isReadonly?(await a.a.$ensureActivation(m.scheme),await a.d(p.impl,p.extUri,m)):await a.a.$mkdir(m)}catch(p){return S.e(p)}},async readFile(m){try{const p=a.b.get(m.scheme);return p?(await a.a.$ensureActivation(m.scheme),(await p.impl.readFile(m)).slice()):(await a.a.$readFile(m)).buffer}catch(p){return S.e(p)}},async writeFile(m,p){try{const f=a.b.get(m.scheme);return f&&!f.isReadonly?(await a.a.$ensureActivation(m.scheme),await a.d(f.impl,f.extUri,f.extUri.dirname(m)),await a.c.queueFor(m).queue(()=>Promise.resolve(f.impl.writeFile(m,p,{create:!0,overwrite:!0})))):await a.a.$writeFile(m,R.$Hc.wrap(p))}catch(f){return S.e(f)}},async delete(m,p){try{const f=a.b.get(m.scheme);return f&&!f.isReadonly?(await a.a.$ensureActivation(m.scheme),await f.impl.delete(m,{recursive:!1,...p})):await a.a.$delete(m,{recursive:!1,useTrash:!1,atomic:!1,...p})}catch(f){return S.e(f)}},async rename(m,p,f){try{return await a.a.$rename(m,p,{overwrite:!1,...f})}catch(t){return S.e(t)}},async copy(m,p,f){try{return await a.a.$copy(m,p,{overwrite:!1,...f})}catch(t){return S.e(t)}},isWritableFileSystem(m){const p=i.getCapabilities(m);if(typeof p=="number")return!(p&2048)}})}async d(r,i,a){const m=[];for(;!i.isEqual(a,i.dirname(a));)try{if(!((await r.stat(a)).type&M.FileType.Directory))throw h.$9K.FileExists(`Unable to create folder '${a.scheme===b.Schemas.file?a.fsPath:a.toString(!0)}' that already exists but is not a directory`);break}catch(p){if(M.$gk(p)!==M.FileSystemProviderErrorCode.FileNotFound)throw p;m.push(i.basename(a)),a=i.dirname(a)}for(let p=m.length-1;p>=0;p--){a=i.joinPath(a,m[p]);try{await r.createDirectory(a)}catch(f){if(M.$gk(f)!==M.FileSystemProviderErrorCode.FileExists)throw f}}}static e(r){if(r instanceof h.$9K)throw r;if(r instanceof M.$ck)switch(r.code){case M.FileSystemProviderErrorCode.FileExists:throw h.$9K.FileExists(r.message);case M.FileSystemProviderErrorCode.FileNotFound:throw h.$9K.FileNotFound(r.message);case M.FileSystemProviderErrorCode.FileNotADirectory:throw h.$9K.FileNotADirectory(r.message);case M.FileSystemProviderErrorCode.FileIsADirectory:throw h.$9K.FileIsADirectory(r.message);case M.FileSystemProviderErrorCode.NoPermissions:throw h.$9K.NoPermissions(r.message);case M.FileSystemProviderErrorCode.Unavailable:throw h.$9K.Unavailable(r.message);default:throw new h.$9K(r.message,r.name)}if(!(r instanceof Error))throw new h.$9K(String(r));if(r.name==="ENOPRO"||r.message.includes("ENOPRO"))throw h.$9K.Unavailable(r.message);switch(r.name){case M.FileSystemProviderErrorCode.FileExists:throw h.$9K.FileExists(r.message);case M.FileSystemProviderErrorCode.FileNotFound:throw h.$9K.FileNotFound(r.message);case M.FileSystemProviderErrorCode.FileNotADirectory:throw h.$9K.FileNotADirectory(r.message);case M.FileSystemProviderErrorCode.FileIsADirectory:throw h.$9K.FileIsADirectory(r.message);case M.FileSystemProviderErrorCode.NoPermissions:throw h.$9K.NoPermissions(r.message);case M.FileSystemProviderErrorCode.Unavailable:throw h.$9K.Unavailable(r.message);default:throw new h.$9K(r.message,r.name)}}addFileSystemProvider(r,i,a){return this.b.set(r,{impl:i,extUri:a?.isCaseSensitive?I.$9f:I.$$f,isReadonly:!!a?.isReadonly}),(0,$.$kb)(()=>this.b.delete(r))}getFileSystemProviderExtUri(r){return this.b.get(r)?.extUri??I.$9f}};e.$1ac=C,e.$1ac=C=S=Ke([Ve(0,g.$UL),Ve(1,E.$wac)],C),e.$2ac=(0,A.$zh)("IExtHostConsumerFileSystem")}),define(De[302],Ce([1,0,4,35,2,5,10,7]),function($e,e,D,M,h,R,A,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jbc=void 0;class E{get ignoreCreateEvents(){return!!(this.g&1)}get ignoreChangeEvents(){return!!(this.g&2)}get ignoreDeleteEvents(){return!!(this.g&4)}constructor(I,b,S,C,y,r,i,a){this.a=new D.$hc,this.b=new D.$hc,this.c=new D.$hc;const m=this.h(I,S,y);this.g=0,r&&(this.g+=1),i&&(this.g+=2),a&&(this.g+=4);const p=(0,M.$pj)(y),f=typeof y=="string",t=C(s=>{if(!r)for(const o of s.created){const n=h.URI.revive(o);p(n.fsPath)&&(!f||b.getWorkspaceFolder(n))&&this.a.fire(n)}if(!i)for(const o of s.changed){const n=h.URI.revive(o);p(n.fsPath)&&(!f||b.getWorkspaceFolder(n))&&this.b.fire(n)}if(!a)for(const o of s.deleted){const n=h.URI.revive(o);p(n.fsPath)&&(!f||b.getWorkspaceFolder(n))&&this.c.fire(n)}});this.d=g.$UJ.from(m,this.a,this.b,this.c,t)}h(I,b,S){const C=g.$UJ.from();if(typeof S=="string")return C;const y=I.getProxy(R.$SJ.MainThreadFileSystem);let r=!1;(S.pattern.includes(M.$lj)||S.pattern.includes(M.$mj))&&(r=!0);const i=Math.random();return y.$watch(b.identifier.value,i,S.baseUri,{recursive:r,excludes:[]}),g.$UJ.from({dispose:()=>y.$unwatch(i)})}dispose(){this.d.dispose()}get onDidCreate(){return this.a.event}get onDidChange(){return this.b.event}get onDidDelete(){return this.c.event}}class ${constructor(I,b,S){this.j=I,this.k=b,this.l=S,this.a=new D.$hc,this.b=new D.$hc,this.c=new D.$hc,this.d=new D.$hc,this.g=new D.$jc,this.h=new D.$jc,this.i=new D.$jc,this.onDidRenameFile=this.b.event,this.onDidCreateFile=this.c.event,this.onDidDeleteFile=this.d.event}createFileSystemWatcher(I,b,S,C,y,r){return new E(this.j,I,b,this.a.event,A.GlobPattern.from(S),C,y,r)}$onFileEvent(I){this.a.fire(I)}$onDidRunFileOperation(I,b){switch(I){case 2:this.b.fire(Object.freeze({files:b.map(S=>({oldUri:h.URI.revive(S.source),newUri:h.URI.revive(S.target)}))}));break;case 1:this.d.fire(Object.freeze({files:b.map(S=>h.URI.revive(S.target))}));break;case 0:case 3:this.c.fire(Object.freeze({files:b.map(S=>h.URI.revive(S.target))}));break;default:}}getOnWillRenameFileEvent(I){return this.m(I,this.g)}getOnWillCreateFileEvent(I){return this.m(I,this.h)}getOnWillDeleteFileEvent(I){return this.m(I,this.i)}m(I,b){return(S,C,y)=>{const r=function(a){S.call(C,a)};return r.extension=I,b.event(r,void 0,y)}}async $onWillRunFileOperation(I,b,S,C){switch(I){case 2:return await this.n(this.g,{files:b.map(y=>({oldUri:h.URI.revive(y.source),newUri:h.URI.revive(y.target)}))},S,C);case 1:return await this.n(this.i,{files:b.map(y=>h.URI.revive(y.target))},S,C);case 0:case 3:return await this.n(this.h,{files:b.map(y=>h.URI.revive(y.target))},S,C)}}async n(I,b,S,C){const y=new Set,r=[];if(await I.fireAsync(b,C,async(a,m)=>{const p=Date.now(),f=await Promise.resolve(a);f instanceof g.$5J&&(r.push([m.extension,f]),y.add(m.extension.displayName??m.extension.identifier.value)),Date.now()-p>S&&this.k.warn("SLOW file-participant",m.extension.identifier)}),C.isCancellationRequested||r.length===0)return;const i={edits:[]};for(const[,a]of r){const{edits:m}=A.WorkspaceEdit.from(a,{getTextDocumentVersion:p=>this.l.getDocument(p)?.version,getNotebookDocumentVersion:()=>{}});i.edits=i.edits.concat(m)}return{edit:i,extensionNames:Array.from(y)}}}e.$jbc=$}),define(De[303],Ce([1,0,3,2,5,10,7,33]),function($e,e,D,M,h,R,A,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qcc=void 0;class E{static{this.a=0}constructor(b,S){this.extension=b,this.provider=S,this.handle=E.a++}}class ${constructor(b){this.session=b,this.responses=[]}}class P{static{this.a=0}constructor(b,S,C,y){this.f=C,this.g=y,this.b=new Map,this.d=new Map,this.e=b.getProxy(h.$SJ.MainThreadInlineChat),S.registerApiCommand(new g.$iM("vscode.editorChat.start","inlineChat.start","Invoke a new editor chat session",[new g.$gM("Run arguments","",r=>!0,r=>{if(r)return{initialRange:r.initialRange?R.Range.from(r.initialRange):void 0,initialSelection:r.initialSelection?R.Selection.from(r.initialSelection):void 0,message:r.message,autoSend:r.autoSend,position:r.position?R.Position.from(r.position):void 0}})],g.$hM.Void))}registerProvider(b,S){const C=new E(b,S);return this.b.set(C.handle,C),this.e.$registerInteractiveEditorProvider(C.handle,S.label,b.identifier.value,typeof S.handleInteractiveEditorResponseFeedback=="function"),(0,D.$kb)(()=>{this.e.$unregisterInteractiveEditorProvider(C.handle),this.b.delete(C.handle)})}async $prepareSession(b,S,C,y){const r=this.b.get(b);if(!r){this.g.warn("CANNOT prepare session because the PROVIDER IS GONE");return}const i=this.f.getDocument(M.URI.revive(S)),a=R.Selection.to(C),m=await r.provider.prepareInteractiveEditorSession({document:i,selection:a},y);if(!m)return;if(m.wholeRange&&!m.wholeRange.contains(a))throw new Error("InteractiveEditorSessionProvider returned a wholeRange that does not contain the selection.");const p=P.a++;return this.d.set(p,new $(m)),{id:p,placeholder:m.placeholder,slashCommands:m.slashCommands?.map(f=>({command:f.command,detail:f.detail,refer:f.refer,executeImmediately:f.executeImmediately})),wholeRange:R.Range.from(m.wholeRange),message:m.message}}async $provideResponse(b,S,C,y){const r=this.b.get(b);if(!r)return;const i=this.d.get(S.id);if(!i)return;const a={session:i.session,prompt:C.prompt,selection:R.Selection.to(C.selection),wholeRange:R.Range.to(C.wholeRange),attempt:C.attempt,live:C.live};let m=!1;const p={report:s=>{if(!C.live)throw new Error("Progress reporting is only supported for live sessions");m||y.isCancellationRequested||!s.message&&!s.edits||this.e.$handleProgressChunk(C.requestId,{message:s.message,edits:s.edits?.map(R.TextEdit.from)})}},f=typeof r.provider.provideInteractiveEditorResponse2=="function"?r.provider.provideInteractiveEditorResponse2(a,p,y):r.provider.provideInteractiveEditorResponse(a,y);Promise.resolve(f).finally(()=>m=!0);const t=await f;if(t){const s=i.responses.push(t)-1,o={wholeRange:R.Range.from(t.wholeRange),placeholder:t.placeholder};if(P.h(t))return{...o,id:s,type:"message",message:R.MarkdownString.from(t.contents)};const{edits:n}=t;if(n instanceof A.$5J)return{...o,id:s,type:"bulkEdit",edits:R.WorkspaceEdit.from(n)};if(Array.isArray(n))return{...o,id:s,type:"editorEdit",edits:n.map(R.TextEdit.from)}}}$handleFeedback(b,S,C,y){const r=this.b.get(b),i=this.d.get(S),a=i?.responses[C];if(r&&a){const m=R.InteractiveEditorResponseFeedbackKind.to(y);r.provider.handleInteractiveEditorResponseFeedback?.(i.session,a,m)}}$releaseSession(b,S){const C=this.d.get(S),y=this.b.get(b);C&&y&&y.provider.releaseInteractiveEditorSession?.(C.session),this.d.delete(S)}static h(b){return typeof b=="object"&&typeof b.contents=="object"}}e.$qcc=P}),define(De[304],Ce([1,0,2,33]),function($e,e,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mcc=void 0;class h{constructor(A,g,E,$,P){this.a=g,this.b=E,this.c=$;const I=new M.$iM("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new M.$gM("showOptions","Show Options",b=>!0,b=>b),new M.$gM("resource","Interactive resource Uri",b=>!0,b=>b),new M.$gM("controllerId","Notebook controller Id",b=>!0,b=>b),new M.$gM("title","Interactive editor title",b=>!0,b=>b)],new M.$hM("Notebook and input URI",b=>{if(P.debug("[ExtHostInteractive] open iw with notebook editor id",b.notebookEditorId),b.notebookEditorId!==void 0){const S=this.a.getEditorById(b.notebookEditorId);return P.debug("[ExtHostInteractive] notebook editor found",S.id),{notebookUri:D.URI.revive(b.notebookUri),inputUri:D.URI.revive(b.inputUri),notebookEditor:S.apiEditor}}return P.debug("[ExtHostInteractive] notebook editor not found, uris for the interactive document",b.notebookUri,b.inputUri),{notebookUri:D.URI.revive(b.notebookUri),inputUri:D.URI.revive(b.inputUri)}}));this.c.registerApiCommand(I)}$willAddInteractiveDocument(A,g,E,$){this.b.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:g,lines:[""],languageId:E,uri:A,isDirty:!1,versionId:1,notebook:this.a.getNotebookDocument(D.URI.revive($))?.apiNotebook}]})}$willRemoveInteractiveDocument(A,g){this.b.acceptDocumentsAndEditorsDelta({removedDocuments:[A]})}}e.$mcc=h}),define(De[305],Ce([1,0,5,7]),function($e,e,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$scc=void 0;class h{constructor(A){this.a=new Map,this.b=A.getProxy(D.$SJ.MainThreadIssueReporter)}async $getIssueReporterUri(A,g){if(this.a.size===0)throw new Error("No issue request handlers registered");const E=this.a.get(A);if(!E)throw new Error("Issue request handler not found");const $=await E.handleIssueUrlRequest();if(!$)throw new Error("Issue request handler returned no result");return $}registerIssueUriRequestHandler(A,g){const E=A.identifier.value;return this.a.set(E,g),this.b.$registerIssueUriRequestHandler(E),new M.$UJ(()=>{this.b.$unregisterIssueUriRequestHandler(E),this.a.delete(E)})}}e.$scc=h}),define(De[306],Ce([1,0,3,5]),function($e,e,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fbc=void 0;class h{constructor(A){this.b=0,this.a=A.getProxy(M.$SJ.MainThreadLabelService)}$registerResourceLabelFormatter(A){const g=this.b++;return this.a.$registerResourceLabelFormatter(g,A),(0,D.$kb)(()=>{this.a.$unregisterResourceLabelFormatter(g)})}}e.$Fbc=h}),define(De[307],Ce([1,0,2,23,10,7,81,5,15,34,19,18,163,22,25,3,129,118,86,37,8,13,27,200]),function($e,e,D,M,h,R,A,g,E,$,P,I,b,S,C,y,r,i,a,m,p,f,t,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cac=void 0;class o{constructor(U,Z){this.d=U,this.e=Z}async provideDocumentSymbols(U,Z){const X=this.d.getDocument(U),oe=await this.e.provideDocumentSymbols(X,Z);if(!(0,P.$Df)(oe))return oe[0]instanceof R.$aK?oe.map(h.DocumentSymbol.from):o.f(oe)}static f(U){U=U.slice(0).sort((oe,Y)=>{let fe=oe.location.range.start.compareTo(Y.location.range.start);return fe===0&&(fe=Y.location.range.end.compareTo(oe.location.range.end)),fe});const Z=[],X=[];for(const oe of U){const Y={name:oe.name||"!!MISSING: name!!",kind:h.SymbolKind.from(oe.kind),tags:oe.tags?.map(h.SymbolTag.from)||[],detail:"",containerName:oe.containerName,range:h.Range.from(oe.location.range),selectionRange:h.Range.from(oe.location.range),children:[]};for(;;){if(X.length===0){X.push(Y),Z.push(Y);break}const fe=X[X.length-1];if($.$hs.containsRange(fe.range,Y.range)&&!$.$hs.equalsRange(fe.range,Y.range)){fe.children?.push(Y),X.push(Y);break}X.pop()}}return Z}}class n{static{this.d={command:"missing",title:"!!MISSING: command!!"}}constructor(U,Z,X){this.g=U,this.h=Z,this.j=X,this.e=new a.$tac("CodeLens"),this.f=new Map}async provideCodeLenses(U,Z){const X=this.g.getDocument(U),oe=await this.j.provideCodeLenses(X,Z);if(!oe||Z.isCancellationRequested)return;const Y=this.e.add(oe),fe=new y.$lb;this.f.set(Y,fe);const ye={cacheId:Y,lenses:[]};for(let ze=0;ze<oe.length;ze++)ye.lenses.push({cacheId:[Y,ze],range:h.Range.from(oe[ze].range),command:this.h.toInternal(oe[ze].command,fe)});return ye}async resolveCodeLens(U,Z){const X=U.cacheId&&this.e.get(...U.cacheId);if(!X)return;let oe;if(typeof this.j.resolveCodeLens!="function"||X.isResolved?oe=X:oe=await this.j.resolveCodeLens(X,Z),oe||(oe=X),Z.isCancellationRequested)return;const Y=U.cacheId&&this.f.get(U.cacheId[0]);if(Y)return U.command=this.h.toInternal(oe.command??n.d,Y),U}releaseCodeLenses(U){this.f.get(U)?.dispose(),this.f.delete(U),this.e.delete(U)}}function c(Pe){return Array.isArray(Pe)?Pe.map(h.DefinitionLink.from):Pe?[h.DefinitionLink.from(Pe)]:[]}class d{constructor(U,Z){this.d=U,this.e=Z}async provideDefinition(U,Z,X){const oe=this.d.getDocument(U),Y=h.Position.to(Z),fe=await this.e.provideDefinition(oe,Y,X);return c(fe)}}class v{constructor(U,Z){this.d=U,this.e=Z}async provideDeclaration(U,Z,X){const oe=this.d.getDocument(U),Y=h.Position.to(Z),fe=await this.e.provideDeclaration(oe,Y,X);return c(fe)}}class k{constructor(U,Z){this.d=U,this.e=Z}async provideImplementation(U,Z,X){const oe=this.d.getDocument(U),Y=h.Position.to(Z),fe=await this.e.provideImplementation(oe,Y,X);return c(fe)}}class u{constructor(U,Z){this.d=U,this.e=Z}async provideTypeDefinition(U,Z,X){const oe=this.d.getDocument(U),Y=h.Position.to(Z),fe=await this.e.provideTypeDefinition(oe,Y,X);return c(fe)}}class l{constructor(U,Z){this.d=U,this.e=Z}async provideHover(U,Z,X){const oe=this.d.getDocument(U),Y=h.Position.to(Z),fe=await this.e.provideHover(oe,Y,X);if(!(!fe||(0,P.$Df)(fe.contents)))return fe.range||(fe.range=oe.getWordRangeAtPosition(Y)),fe.range||(fe.range=new R.$WJ(Y,Y)),h.Hover.from(fe)}}class w{constructor(U,Z){this.d=U,this.e=Z}async provideEvaluatableExpression(U,Z,X){const oe=this.d.getDocument(U),Y=h.Position.to(Z),fe=await this.e.provideEvaluatableExpression(oe,Y,X);if(fe)return h.EvaluatableExpression.from(fe)}}class L{constructor(U,Z){this.d=U,this.e=Z}async provideInlineValues(U,Z,X,oe){const Y=this.d.getDocument(U),fe=await this.e.provideInlineValues(Y,h.Range.to(Z),h.InlineValueContext.to(X),oe);if(Array.isArray(fe))return fe.map(ye=>h.InlineValue.from(ye))}}class N{constructor(U,Z){this.d=U,this.e=Z}async provideDocumentHighlights(U,Z,X){const oe=this.d.getDocument(U),Y=h.Position.to(Z),fe=await this.e.provideDocumentHighlights(oe,Y,X);if(Array.isArray(fe))return fe.map(h.DocumentHighlight.from)}}class j{constructor(U,Z){this.d=U,this.e=Z}async provideLinkedEditingRanges(U,Z,X){const oe=this.d.getDocument(U),Y=h.Position.to(Z),fe=await this.e.provideLinkedEditingRanges(oe,Y,X);if(fe&&Array.isArray(fe.ranges))return{ranges:(0,P.$Af)(fe.ranges.map(h.Range.from)),wordPattern:fe.wordPattern}}}class T{constructor(U,Z){this.d=U,this.e=Z}async provideReferences(U,Z,X,oe){const Y=this.d.getDocument(U),fe=h.Position.to(Z),ye=await this.e.provideReferences(Y,fe,X,oe);if(Array.isArray(ye))return ye.map(h.location.from)}}class O{static{this.d=1e3}constructor(U,Z,X,oe,Y,fe,ye){this.h=U,this.j=Z,this.k=X,this.l=oe,this.m=Y,this.n=fe,this.o=ye,this.e=new a.$tac("CodeAction"),this.f=new Map,this.g=new R.$cK("notebook")}async provideCodeActions(U,Z,X,oe){const Y=this.h.getDocument(U),fe=b.$js.isISelection(Z)?h.Selection.to(Z):h.Range.to(Z),ye=[];for(const et of this.k.getDiagnostics(U))if(fe.intersection(et.range)&&ye.push(et)>O.d)break;const ze={diagnostics:ye,only:X.only?new R.$cK(X.only):void 0,triggerKind:h.CodeActionTriggerKind.to(X.trigger)},Be=await this.l.provideCodeActions(Y,fe,ze,oe);if(!(0,P.$Ef)(Be)||oe.isCancellationRequested)return;const xe=this.e.add(Be),Ye=new y.$lb;this.f.set(xe,Ye);const it=[];for(let et=0;et<Be.length;et++){const Ae=Be[et];if(Ae)if(O.p(Ae))this.o.report("CodeActionProvider.provideCodeActions - return commands",this.n,"Return 'CodeAction' instances instead."),it.push({_isSynthetic:!0,title:Ae.title,command:this.j.toInternal(Ae,Ye)});else{if(ze.triggerKind!==R.CodeActionTriggerKind.Invoke&&Ae.kind&&this.g.contains(Ae.kind))continue;ze.only&&(Ae.kind?ze.only.contains(Ae.kind)||this.m.warn(`${this.n.identifier.value} - Code actions of kind '${ze.only.value} 'requested but returned code action is of kind '${Ae.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this.m.warn(`${this.n.identifier.value} - Code actions of kind '${ze.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),it.push({cacheId:[xe,et],title:Ae.title,command:Ae.command&&this.j.toInternal(Ae.command,Ye),diagnostics:Ae.diagnostics&&Ae.diagnostics.map(h.Diagnostic.from),edit:Ae.edit&&h.WorkspaceEdit.from(Ae.edit,void 0),kind:Ae.kind&&Ae.kind.value,isPreferred:Ae.isPreferred,disabled:Ae.disabled?.reason})}}return{cacheId:xe,actions:it}}async resolveCodeAction(U,Z){const[X,oe]=U,Y=this.e.get(X,oe);if(!Y||O.p(Y))return{};if(!this.l.resolveCodeAction)return{};const fe=await this.l.resolveCodeAction(Y,Z)??Y;let ye;fe.edit&&(ye=h.WorkspaceEdit.from(fe.edit,void 0));let ze;if(fe.command){const Be=this.f.get(X);Be&&(ze=this.j.toInternal(fe.command,Be))}return{edit:ye,command:ze}}releaseCodeActions(U){this.f.get(U)?.dispose(),this.f.delete(U),this.e.delete(U)}static p(U){return typeof U.command=="string"&&typeof U.title=="string"}}class B{static toInternalProviderId(U,Z){return U+"."+Z}constructor(U,Z,X,oe,Y){this.d=U,this.e=Z,this.f=X,this.g=oe,this.h=Y}async prepareDocumentPaste(U,Z,X,oe){if(!this.f.prepareDocumentPaste)return;const Y=this.e.getDocument(U),fe=Z.map(Be=>h.Range.to(Be)),ye=h.DataTransfer.toDataTransfer(X,()=>{throw new p.$9});if(await this.f.prepareDocumentPaste(Y,fe,ye,oe),oe.isCancellationRequested)return;const ze=Array.from(ye).filter(([,Be])=>!(Be instanceof R.$JK));return h.DataTransfer.from(ze)}async providePasteEdits(U,Z,X,oe,Y){if(!this.f.provideDocumentPasteEdits)return;const fe=this.e.getDocument(Z),ye=X.map(xe=>h.Range.to(xe)),ze=h.DataTransfer.toDataTransfer(oe,async xe=>(await this.d.$resolvePasteFileData(this.g,U,xe)).buffer),Be=await this.f.provideDocumentPasteEdits(fe,ye,ze,Y);if(Be)return{label:Be.label??(0,s.localize)(0,null,this.h.displayName||this.h.name),detail:this.h.displayName||this.h.name,yieldTo:Be.yieldTo?.map(xe=>"mimeType"in xe?xe:{providerId:B.toInternalProviderId(xe.extensionId,xe.providerId)}),insertText:typeof Be.insertText=="string"?Be.insertText:{snippet:Be.insertText.value},additionalEdit:Be.additionalEdit?h.WorkspaceEdit.from(Be.additionalEdit,void 0):void 0}}}class F{constructor(U,Z){this.d=U,this.e=Z}async provideDocumentFormattingEdits(U,Z,X){const oe=this.d.getDocument(U),Y=await this.e.provideDocumentFormattingEdits(oe,Z,X);if(Array.isArray(Y))return Y.map(h.TextEdit.from)}}class J{constructor(U,Z){this.d=U,this.e=Z}async provideDocumentRangeFormattingEdits(U,Z,X,oe){const Y=this.d.getDocument(U),fe=h.Range.to(Z),ye=await this.e.provideDocumentRangeFormattingEdits(Y,fe,X,oe);if(Array.isArray(ye))return ye.map(h.TextEdit.from)}async provideDocumentRangesFormattingEdits(U,Z,X,oe){(0,I.$ve)(typeof this.e.provideDocumentRangesFormattingEdits=="function","INVALID invocation of `provideDocumentRangesFormattingEdits`");const Y=this.d.getDocument(U),fe=Z.map(h.Range.to),ye=await this.e.provideDocumentRangesFormattingEdits(Y,fe,X,oe);if(Array.isArray(ye))return ye.map(h.TextEdit.from)}}class K{constructor(U,Z){this.d=U,this.e=Z,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(U,Z,X,oe,Y){const fe=this.d.getDocument(U),ye=h.Position.to(Z),ze=await this.e.provideOnTypeFormattingEdits(fe,ye,X,oe,Y);if(Array.isArray(ze))return ze.map(h.TextEdit.from)}}class me{constructor(U,Z){this.e=U,this.f=Z,this.d=new a.$tac("WorkspaceSymbols")}async provideWorkspaceSymbols(U,Z){const X=await this.e.provideWorkspaceSymbols(U,Z);if(!(0,P.$Ef)(X))return{symbols:[]};const oe=this.d.add(X),Y={cacheId:oe,symbols:[]};for(let fe=0;fe<X.length;fe++){const ye=X[fe];if(!ye||!ye.name){this.f.warn("INVALID SymbolInformation",ye);continue}Y.symbols.push({...h.WorkspaceSymbol.from(ye),cacheId:[oe,fe]})}return Y}async resolveWorkspaceSymbol(U,Z){if(typeof this.e.resolveWorkspaceSymbol!="function"||!U.cacheId)return U;const X=this.d.get(...U.cacheId);if(X){const oe=await this.e.resolveWorkspaceSymbol(X,Z);return oe&&(0,M.$Wm)(U,h.WorkspaceSymbol.from(oe),!0)}}releaseWorkspaceSymbols(U){this.d.delete(U)}}class re{static supportsResolving(U){return typeof U.prepareRename=="function"}constructor(U,Z,X){this.d=U,this.e=Z,this.f=X}async provideRenameEdits(U,Z,X,oe){const Y=this.d.getDocument(U),fe=h.Position.to(Z);try{const ye=await this.e.provideRenameEdits(Y,fe,X,oe);return ye?h.WorkspaceEdit.from(ye):void 0}catch(ye){const ze=re.g(ye);return ze?{rejectReason:ze,edits:void 0}:Promise.reject(ye)}}async resolveRenameLocation(U,Z,X){if(typeof this.e.prepareRename!="function")return Promise.resolve(void 0);const oe=this.d.getDocument(U),Y=h.Position.to(Z);try{const fe=await this.e.prepareRename(oe,Y,X);let ye,ze;if(R.$WJ.isRange(fe)?(ye=fe,ze=oe.getText(fe)):(0,I.$ne)(fe)&&(ye=fe.range,ze=fe.placeholder),!ye||!ze)return;if(ye.start.line>Y.line||ye.end.line<Y.line){this.f.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:h.Range.from(ye),text:ze}}catch(fe){const ye=re.g(fe);return ye?{rejectReason:ye,range:void 0,text:void 0}:Promise.reject(fe)}}static g(U){return typeof U=="string"?U:U instanceof Error&&typeof U.message=="string"?U.message:void 0}}class x{constructor(U,Z){this.resultId=U,this.tokens=Z}}class q{constructor(U,Z){this.f=U,this.g=Z,this.e=1,this.d=new Map}async provideDocumentSemanticTokens(U,Z,X){const oe=this.f.getDocument(U),Y=Z!==0?this.d.get(Z):null;let fe=typeof Y?.resultId=="string"&&typeof this.g.provideDocumentSemanticTokensEdits=="function"?await this.g.provideDocumentSemanticTokensEdits(oe,Y.resultId,X):await this.g.provideDocumentSemanticTokens(oe,X);return Y&&this.d.delete(Z),fe?(fe=q.h(fe),this.o(q.n(Y,fe),fe)):null}async releaseDocumentSemanticColoring(U){this.d.delete(U)}static h(U){return q.j(U)?q.k(U)?U:new R.$aL(new Uint32Array(U.data),U.resultId):q.l(U)?q.m(U)?U:new R.$cL(U.edits.map(Z=>new R.$bL(Z.start,Z.deleteCount,Z.data?new Uint32Array(Z.data):Z.data)),U.resultId):U}static j(U){return U&&!!U.data}static k(U){return U.data instanceof Uint32Array}static l(U){return U&&Array.isArray(U.edits)}static m(U){for(const Z of U.edits)if(!(Z.data instanceof Uint32Array))return!1;return!0}static n(U,Z){if(!q.j(Z)||!U||!U.tokens)return Z;const X=U.tokens,oe=X.length,Y=Z.data,fe=Y.length;let ye=0;const ze=Math.min(oe,fe);for(;ye<ze&&X[ye]===Y[ye];)ye++;if(ye===oe&&ye===fe)return new R.$cL([],Z.resultId);let Be=0;const xe=ze-ye;for(;Be<xe&&X[oe-Be-1]===Y[fe-Be-1];)Be++;return new R.$cL([{start:ye,deleteCount:oe-ye-Be,data:Y.subarray(ye,fe-Be)}],Z.resultId)}o(U,Z){if(q.j(U)){const X=this.e++;return this.d.set(X,new x(U.resultId,U.data)),(0,r.$i0)({id:X,type:"full",data:U.data})}if(q.l(U)){const X=this.e++;return q.j(Z)?this.d.set(X,new x(Z.resultId,Z.data)):this.d.set(X,new x(U.resultId)),(0,r.$i0)({id:X,type:"delta",deltas:(U.edits||[]).map(oe=>({start:oe.start,deleteCount:oe.deleteCount,data:oe.data}))})}return null}}class ee{constructor(U,Z){this.d=U,this.e=Z}async provideDocumentRangeSemanticTokens(U,Z,X){const oe=this.d.getDocument(U),Y=await this.e.provideDocumentRangeSemanticTokens(oe,h.Range.to(Z),X);return Y?this.f(Y):null}f(U){return(0,r.$i0)({id:0,type:"full",data:U.data})}}class pe{static supportsResolving(U){return typeof U.resolveCompletionItem=="function"}constructor(U,Z,X,oe,Y){this.f=U,this.g=Z,this.h=X,this.j=oe,this.k=Y,this.d=new a.$tac("CompletionItem"),this.e=new Map}async provideCompletionItems(U,Z,X,oe){const Y=this.f.getDocument(U),fe=h.Position.to(Z),ye=Y.getWordRangeAtPosition(fe)||new R.$WJ(fe,fe),ze=ye.with({end:fe}),Be=new m.$dc,xe=await this.h.provideCompletionItems(Y,fe,oe,h.CompletionContext.to(X));if(!xe||oe.isCancellationRequested)return;const Ye=Array.isArray(xe)?new R.$qK(xe):xe,it=pe.supportsResolving(this.h)?this.d.add(Ye.items):this.d.add([]),et=new y.$lb;this.e.set(it,et);const Ae=[],Ne={x:it,b:Ae,a:{replace:h.Range.from(ye),insert:h.Range.from(ze)},c:Ye.isIncomplete||void 0,d:Be.elapsed()};for(let We=0;We<Ye.items.length;We++){const Le=Ye.items[We],Qe=this.l(Le,[it,We],ze,ye);Ae.push(Qe)}return Ne}async resolveCompletionItem(U,Z){if(typeof this.h.resolveCompletionItem!="function")return;const X=this.d.get(...U);if(!X)return;const oe=this.l(X,U),Y=await this.h.resolveCompletionItem(X,Z);if(!Y)return;const fe=this.l(Y,U);return(oe.h!==fe.h||oe.i!==fe.i)&&this.j.report("CompletionItem.insertText",this.k,"extension MAY NOT change 'insertText' of a CompletionItem during resolve"),(oe.n!==fe.n||oe.o!==fe.o||!(0,M.$Xm)(oe.p,fe.p))&&this.j.report("CompletionItem.command",this.k,"extension MAY NOT change 'command' of a CompletionItem during resolve"),{...oe,d:fe.d,c:fe.c,l:fe.l,h:fe.h,i:fe.i,n:fe.n,o:fe.o,p:fe.p}}releaseCompletionItems(U){this.e.get(U)?.dispose(),this.e.delete(U),this.d.delete(U)}l(U,Z,X,oe){const Y=this.e.get(Z[0]);if(!Y)throw Error("DisposableStore is missing...");const fe=this.g.toInternal(U.command,Y),ye={x:Z,a:U.label,b:U.kind!==void 0?h.CompletionItemKind.from(U.kind):void 0,m:U.tags&&U.tags.map(h.CompletionItemTag.from),c:U.detail,d:typeof U.documentation>"u"?void 0:h.MarkdownString.fromStrict(U.documentation),e:U.sortText!==U.label?U.sortText:void 0,f:U.filterText!==U.label?U.filterText:void 0,g:U.preselect||void 0,i:U.keepWhitespace?1:0,k:U.commitCharacters?.join(""),l:U.additionalTextEdits&&U.additionalTextEdits.map(h.TextEdit.from),n:fe?.$ident,o:fe?.id,p:fe?.$ident?void 0:fe?.arguments};U.textEdit?(this.j.report("CompletionItem.textEdit",this.k,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),ye.h=U.textEdit.newText):typeof U.insertText=="string"?ye.h=U.insertText:U.insertText instanceof R.$6J&&(ye.h=U.insertText.value,ye.i|=4);let ze;return U.textEdit?ze=U.textEdit.range:U.range&&(ze=U.range),R.$WJ.isRange(ze)?ye.j=h.Range.from(ze):ze&&(!X?.isEqual(ze.inserting)||!oe?.isEqual(ze.replacing))&&(ye.j={insert:h.Range.from(ze.inserting),replace:h.Range.from(ze.replacing)}),ye}}class ce{async provideInlineCompletions(U,Z,X,oe){}disposeCompletions(U){}handleDidShowCompletionItem(U,Z,X){}handlePartialAccept(U,Z,X){}}class _ extends ce{constructor(U,Z,X,oe){super(),this.f=U,this.g=Z,this.h=X,this.j=oe,this.d=new Q,this.e=(0,t.$LF)(this.f,"inlineCompletionsAdditions"),this.k={[A.InlineCompletionTriggerKind.Automatic]:R.InlineCompletionTriggerKind.Automatic,[A.InlineCompletionTriggerKind.Explicit]:R.InlineCompletionTriggerKind.Invoke}}get supportsHandleEvents(){return(0,t.$LF)(this.f,"inlineCompletionsAdditions")&&(typeof this.h.handleDidShowCompletionItem=="function"||typeof this.h.handleDidPartiallyAcceptCompletionItem=="function")}async provideInlineCompletions(U,Z,X,oe){const Y=this.g.getDocument(U),fe=h.Position.to(Z),ye=await this.h.provideInlineCompletionItems(Y,fe,{selectedCompletionInfo:X.selectedSuggestionInfo?{range:h.Range.to(X.selectedSuggestionInfo.range),text:X.selectedSuggestionInfo.text}:void 0,triggerKind:this.k[X.triggerKind]},oe);if(!ye||oe.isCancellationRequested)return;const ze=Array.isArray(ye)?ye:ye.items,Be=this.e?Array.isArray(ye)?[]:ye.commands||[]:[],xe=this.e&&!Array.isArray(ye)?ye.enableForwardStability:void 0;let Ye;return{pid:this.d.createReferenceId({dispose(){Ye?.dispose()},items:ze}),items:ze.map((et,Ae)=>{let Ne;et.command&&(Ye||(Ye=new y.$lb),Ne=this.j.toInternal(et.command,Ye));const We=et.insertText;return{insertText:typeof We=="string"?We:{snippet:We.value},filterText:et.filterText,range:et.range?h.Range.from(et.range):void 0,command:Ne,idx:Ae,completeBracketPairs:this.e?et.completeBracketPairs:!1}}),commands:Be.map(et=>(Ye||(Ye=new y.$lb),this.j.toInternal(et,Ye))),suppressSuggestions:!1,enableForwardStability:xe}}disposeCompletions(U){this.d.disposeReferenceId(U)?.dispose()}handleDidShowCompletionItem(U,Z,X){const oe=this.d.get(U)?.items[Z];oe&&this.h.handleDidShowCompletionItem&&this.e&&this.h.handleDidShowCompletionItem(oe,X)}handlePartialAccept(U,Z,X){const oe=this.d.get(U)?.items[Z];oe&&this.h.handleDidPartiallyAcceptCompletionItem&&this.e&&this.h.handleDidPartiallyAcceptCompletionItem(oe,X)}}class Q{constructor(){this.d=new Map,this.e=1}createReferenceId(U){const Z=this.e++;return this.d.set(Z,U),Z}disposeReferenceId(U){const Z=this.d.get(U);return this.d.delete(U),Z}get(U){return this.d.get(U)}}class z{constructor(U,Z){this.e=U,this.f=Z,this.d=new a.$tac("SignatureHelp")}async provideSignatureHelp(U,Z,X,oe){const Y=this.e.getDocument(U),fe=h.Position.to(Z),ye=this.g(X),ze=await this.f.provideSignatureHelp(Y,fe,oe,ye);if(ze){const Be=this.d.add([ze]);return{...h.SignatureHelp.from(ze),id:Be}}}g(U){let Z;if(U.activeSignatureHelp){const X=h.SignatureHelp.to(U.activeSignatureHelp),oe=this.d.get(U.activeSignatureHelp.id,0);oe?(Z=oe,Z.activeSignature=X.activeSignature,Z.activeParameter=X.activeParameter):Z=X}return{...U,activeSignatureHelp:Z}}releaseSignatureHelp(U){this.d.delete(U)}}class V{constructor(U,Z,X,oe,Y){this.f=U,this.g=Z,this.h=X,this.j=oe,this.k=Y,this.d=new a.$tac("InlayHints"),this.e=new Map}async provideInlayHints(U,Z,X){const oe=this.f.getDocument(U),Y=h.Range.to(Z),fe=await this.h.provideInlayHints(oe,Y,X);if(!Array.isArray(fe)||fe.length===0){this.j.trace(`[InlayHints] NO inlay hints from '${this.k.identifier.value}' for ${Z}`);return}if(X.isCancellationRequested)return;const ye=this.d.add(fe);this.e.set(ye,new y.$lb);const ze={hints:[],cacheId:ye};for(let Be=0;Be<fe.length;Be++)this.l(fe[Be],Y)&&ze.hints.push(this.m(fe[Be],[ye,Be]));return this.j.trace(`[InlayHints] ${ze.hints.length} inlay hints from '${this.k.identifier.value}' for ${Z}`),ze}async resolveInlayHint(U,Z){if(typeof this.h.resolveInlayHint!="function")return;const X=this.d.get(...U);if(!X)return;const oe=await this.h.resolveInlayHint(X,Z);if(oe&&this.l(oe))return this.m(oe,U)}releaseHints(U){this.e.get(U)?.dispose(),this.e.delete(U),this.d.delete(U)}l(U,Z){return U.label.length===0||Array.isArray(U.label)&&U.label.every(X=>X.value.length===0)?(console.log("INVALID inlay hint, empty label",U),!1):!(Z&&!Z.contains(U.position))}m(U,Z){const X=this.e.get(Z[0]);if(!X)throw Error("DisposableStore is missing...");const oe={label:"",cacheId:Z,tooltip:h.MarkdownString.fromStrict(U.tooltip),position:h.Position.from(U.position),textEdits:U.textEdits&&U.textEdits.map(h.TextEdit.from),kind:U.kind&&h.InlayHintKind.from(U.kind),paddingLeft:U.paddingLeft,paddingRight:U.paddingRight};return typeof U.label=="string"?oe.label=U.label:oe.label=U.label.map(Y=>{const fe={label:Y.value};return fe.tooltip=h.MarkdownString.fromStrict(Y.tooltip),R.$7J.isLocation(Y.location)&&(fe.location=h.location.from(Y.location)),Y.command&&(fe.command=this.g.toInternal(Y.command,X)),fe}),oe}}class G{constructor(U,Z){this.e=U,this.f=Z,this.d=new a.$tac("DocumentLink")}async provideLinks(U,Z){const X=this.e.getDocument(U),oe=await this.f.provideDocumentLinks(X,Z);if(!(!Array.isArray(oe)||oe.length===0)&&!Z.isCancellationRequested){if(typeof this.f.resolveDocumentLink!="function")return{links:oe.filter(G.g).map(h.DocumentLink.from)};{const Y=this.d.add(oe),fe={links:[],cacheId:Y};for(let ye=0;ye<oe.length;ye++){if(!G.g(oe[ye]))continue;const ze=h.DocumentLink.from(oe[ye]);ze.cacheId=[Y,ye],fe.links.push(ze)}return fe}}}static g(U){return U.target&&U.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(U,Z){if(typeof this.f.resolveDocumentLink!="function")return;const X=this.d.get(...U);if(!X)return;const oe=await this.f.resolveDocumentLink(X,Z);if(!(!oe||!G.g(oe)))return h.DocumentLink.from(oe)}releaseLinks(U){this.d.delete(U)}}class ae{constructor(U,Z){this.d=U,this.e=Z}async provideColors(U,Z){const X=this.d.getDocument(U),oe=await this.e.provideDocumentColors(X,Z);return Array.isArray(oe)?oe.map(fe=>({color:h.Color.from(fe.color),range:h.Range.from(fe.range)})):[]}async provideColorPresentations(U,Z,X){const oe=this.d.getDocument(U),Y=h.Range.to(Z.range),fe=h.Color.to(Z.color),ye=await this.e.provideColorPresentations(fe,{document:oe,range:Y},X);if(Array.isArray(ye))return ye.map(h.ColorPresentation.from)}}class ne{constructor(U,Z){this.d=U,this.e=Z}async provideFoldingRanges(U,Z,X){const oe=this.d.getDocument(U),Y=await this.e.provideFoldingRanges(oe,Z,X);if(Array.isArray(Y))return Y.map(h.FoldingRange.from)}}class he{constructor(U,Z,X){this.d=U,this.e=Z,this.f=X}async provideSelectionRanges(U,Z,X){const oe=this.d.getDocument(U),Y=Z.map(h.Position.to),fe=await this.e.provideSelectionRanges(oe,Y,X);if(!(0,P.$Ef)(fe))return[];if(fe.length!==Y.length)return this.f.warn("BAD selection ranges, provider must return ranges for each position"),[];const ye=[];for(let ze=0;ze<Y.length;ze++){const Be=[];ye.push(Be);let xe=Y[ze],Ye=fe[ze];for(;;){if(!Ye.range.contains(xe))throw new Error("INVALID selection range, must contain the previous range");if(Be.push(h.SelectionRange.from(Ye)),!Ye.parent)break;xe=Ye.range,Ye=Ye.parent}}return ye}}class Ee{constructor(U,Z){this.f=U,this.g=Z,this.d=new i.$ZL(""),this.e=new Map}async prepareSession(U,Z,X){const oe=this.f.getDocument(U),Y=h.Position.to(Z),fe=await this.g.prepareCallHierarchy(oe,Y,X);if(!fe)return;const ye=this.d.nextId();return this.e.set(ye,new Map),Array.isArray(fe)?fe.map(ze=>this.h(ye,ze)):[this.h(ye,fe)]}async provideCallsTo(U,Z,X){const oe=this.j(U,Z);if(!oe)throw new Error("missing call hierarchy item");const Y=await this.g.provideCallHierarchyIncomingCalls(oe,X);if(Y)return Y.map(fe=>({from:this.h(U,fe.from),fromRanges:fe.fromRanges.map(ye=>h.Range.from(ye))}))}async provideCallsFrom(U,Z,X){const oe=this.j(U,Z);if(!oe)throw new Error("missing call hierarchy item");const Y=await this.g.provideCallHierarchyOutgoingCalls(oe,X);if(Y)return Y.map(fe=>({to:this.h(U,fe.to),fromRanges:fe.fromRanges.map(ye=>h.Range.from(ye))}))}releaseSession(U){this.e.delete(U)}h(U,Z){const X=this.e.get(U),oe=h.CallHierarchyItem.from(Z,U,X.size.toString(36));return X.set(oe._itemId,Z),oe}j(U,Z){return this.e.get(U)?.get(Z)}}class de{constructor(U,Z){this.f=U,this.g=Z,this.d=new i.$ZL(""),this.e=new Map}async prepareSession(U,Z,X){const oe=this.f.getDocument(U),Y=h.Position.to(Z),fe=await this.g.prepareTypeHierarchy(oe,Y,X);if(!fe)return;const ye=this.d.nextId();return this.e.set(ye,new Map),Array.isArray(fe)?fe.map(ze=>this.h(ye,ze)):[this.h(ye,fe)]}async provideSupertypes(U,Z,X){const oe=this.j(U,Z);if(!oe)throw new Error("missing type hierarchy item");const Y=await this.g.provideTypeHierarchySupertypes(oe,X);if(Y)return Y.map(fe=>this.h(U,fe))}async provideSubtypes(U,Z,X){const oe=this.j(U,Z);if(!oe)throw new Error("missing type hierarchy item");const Y=await this.g.provideTypeHierarchySubtypes(oe,X);if(Y)return Y.map(fe=>this.h(U,fe))}releaseSession(U){this.e.delete(U)}h(U,Z){const X=this.e.get(U),oe=h.TypeHierarchyItem.from(Z,U,X.size.toString(36));return X.set(oe._itemId,Z),oe}j(U,Z){return this.e.get(U)?.get(Z)}}class ge{static toInternalProviderId(U,Z){return U+"."+Z}constructor(U,Z,X,oe,Y){this.d=U,this.e=Z,this.f=X,this.g=oe,this.h=Y}async provideDocumentOnDropEdits(U,Z,X,oe,Y){const fe=this.e.getDocument(Z),ye=h.Position.to(X),ze=h.DataTransfer.toDataTransfer(oe,async xe=>(await this.d.$resolveDocumentOnDropFileData(this.g,U,xe)).buffer),Be=await this.f.provideDocumentDropEdits(fe,ye,ze,Y);if(Be)return{label:Be.label??(0,s.localize)(1,null,this.h.displayName||this.h.name),yieldTo:Be.yieldTo?.map(xe=>"mimeType"in xe?xe:{providerId:ge.toInternalProviderId(xe.extensionId,xe.providerId)}),insertText:typeof Be.insertText=="string"?Be.insertText:{snippet:Be.insertText.value},additionalEdit:Be.additionalEdit?h.WorkspaceEdit.from(Be.additionalEdit,void 0):void 0}}}class ie{constructor(U,Z){this.d=U,this.e=Z}async provideMappedEdits(U,Z,X,oe){const Y=D.URI.revive(U),fe=this.d.getDocument(Y),ye={selections:X.selections.map(Be=>h.Selection.to(Be)),related:X.related.map(Be=>({uri:D.URI.revive(Be.uri),range:h.Range.to(Be.range)}))},ze=await this.e.provideMappedEdits(fe,Z,ye,oe);return ze?h.WorkspaceEdit.from(ze):null}}class ue{constructor(U,Z){this.adapter=U,this.extension=Z}}class we{static{this.d=0}constructor(U,Z,X,oe,Y,fe,ye,ze){this.g=Z,this.h=X,this.j=oe,this.k=Y,this.l=fe,this.m=ye,this.n=ze,this.f=new Map,this.e=U.getProxy(g.$SJ.MainThreadLanguageFeatures)}o(U,Z){return h.DocumentSelector.from(U,this.g,Z)}p(U){return new R.$UJ(()=>{this.f.delete(U),this.e.$unregister(U)})}q(){return we.d++}async t(U,Z,X,oe,Y,fe=!1){const ye=this.f.get(U);if(!ye||!(ye.adapter instanceof Z))return oe;const ze=Date.now();fe||this.l.trace(`[${ye.extension.identifier.value}] INVOKE provider '${X.toString().replace(/[\r\n]/g,"")}'`);const Be=X(ye.adapter,ye.extension);return Promise.resolve(Be).catch(xe=>{(0,p.$2)(xe)||(this.l.error(`[${ye.extension.identifier.value}] provider FAILED`),this.l.error(xe),this.n.onExtensionError(ye.extension.identifier,xe))}).finally(()=>{fe||this.l.trace(`[${ye.extension.identifier.value}] provider DONE after ${Date.now()-ze}ms`)}),S.CancellationToken.isCancellationToken(Y)?(0,f.$ug)(Be,Y):Be}u(U,Z){const X=this.q();return this.f.set(X,new ue(U,Z)),X}static w(U){return U.displayName||U.name}registerDocumentSymbolProvider(U,Z,X,oe){const Y=this.u(new o(this.h,X),U),fe=oe&&oe.label||we.w(U);return this.e.$registerDocumentSymbolProvider(Y,this.o(Z,U),fe),this.p(Y)}$provideDocumentSymbols(U,Z,X){return this.t(U,o,oe=>oe.provideDocumentSymbols(D.URI.revive(Z),X),void 0,X)}registerCodeLensProvider(U,Z,X){const oe=this.q(),Y=typeof X.onDidChangeCodeLenses=="function"?this.q():void 0;this.f.set(oe,new ue(new n(this.h,this.j.converter,X),U)),this.e.$registerCodeLensSupport(oe,this.o(Z,U),Y);let fe=this.p(oe);if(Y!==void 0){const ye=X.onDidChangeCodeLenses(ze=>this.e.$emitCodeLensEvent(Y));fe=R.$UJ.from(fe,ye)}return fe}$provideCodeLenses(U,Z,X){return this.t(U,n,oe=>oe.provideCodeLenses(D.URI.revive(Z),X),void 0,X)}$resolveCodeLens(U,Z,X){return this.t(U,n,oe=>oe.resolveCodeLens(Z,X),void 0,void 0)}$releaseCodeLenses(U,Z){this.t(U,n,X=>Promise.resolve(X.releaseCodeLenses(Z)),void 0,void 0)}registerDefinitionProvider(U,Z,X){const oe=this.u(new d(this.h,X),U);return this.e.$registerDefinitionSupport(oe,this.o(Z,U)),this.p(oe)}$provideDefinition(U,Z,X,oe){return this.t(U,d,Y=>Y.provideDefinition(D.URI.revive(Z),X,oe),[],oe)}registerDeclarationProvider(U,Z,X){const oe=this.u(new v(this.h,X),U);return this.e.$registerDeclarationSupport(oe,this.o(Z,U)),this.p(oe)}$provideDeclaration(U,Z,X,oe){return this.t(U,v,Y=>Y.provideDeclaration(D.URI.revive(Z),X,oe),[],oe)}registerImplementationProvider(U,Z,X){const oe=this.u(new k(this.h,X),U);return this.e.$registerImplementationSupport(oe,this.o(Z,U)),this.p(oe)}$provideImplementation(U,Z,X,oe){return this.t(U,k,Y=>Y.provideImplementation(D.URI.revive(Z),X,oe),[],oe)}registerTypeDefinitionProvider(U,Z,X){const oe=this.u(new u(this.h,X),U);return this.e.$registerTypeDefinitionSupport(oe,this.o(Z,U)),this.p(oe)}$provideTypeDefinition(U,Z,X,oe){return this.t(U,u,Y=>Y.provideTypeDefinition(D.URI.revive(Z),X,oe),[],oe)}registerHoverProvider(U,Z,X,oe){const Y=this.u(new l(this.h,X),U);return this.e.$registerHoverProvider(Y,this.o(Z,U)),this.p(Y)}$provideHover(U,Z,X,oe){return this.t(U,l,Y=>Y.provideHover(D.URI.revive(Z),X,oe),void 0,oe)}registerEvaluatableExpressionProvider(U,Z,X,oe){const Y=this.u(new w(this.h,X),U);return this.e.$registerEvaluatableExpressionProvider(Y,this.o(Z,U)),this.p(Y)}$provideEvaluatableExpression(U,Z,X,oe){return this.t(U,w,Y=>Y.provideEvaluatableExpression(D.URI.revive(Z),X,oe),void 0,oe)}registerInlineValuesProvider(U,Z,X,oe){const Y=typeof X.onDidChangeInlineValues=="function"?this.q():void 0,fe=this.u(new L(this.h,X),U);this.e.$registerInlineValuesProvider(fe,this.o(Z,U),Y);let ye=this.p(fe);if(Y!==void 0){const ze=X.onDidChangeInlineValues(Be=>this.e.$emitInlineValuesEvent(Y));ye=R.$UJ.from(ye,ze)}return ye}$provideInlineValues(U,Z,X,oe,Y){return this.t(U,L,fe=>fe.provideInlineValues(D.URI.revive(Z),X,oe,Y),void 0,Y)}registerDocumentHighlightProvider(U,Z,X){const oe=this.u(new N(this.h,X),U);return this.e.$registerDocumentHighlightProvider(oe,this.o(Z,U)),this.p(oe)}$provideDocumentHighlights(U,Z,X,oe){return this.t(U,N,Y=>Y.provideDocumentHighlights(D.URI.revive(Z),X,oe),void 0,oe)}registerLinkedEditingRangeProvider(U,Z,X){const oe=this.u(new j(this.h,X),U);return this.e.$registerLinkedEditingRangeProvider(oe,this.o(Z,U)),this.p(oe)}$provideLinkedEditingRanges(U,Z,X,oe){return this.t(U,j,async Y=>{const fe=await Y.provideLinkedEditingRanges(D.URI.revive(Z),X,oe);if(fe)return{ranges:fe.ranges,wordPattern:fe.wordPattern?we.y(fe.wordPattern):void 0}},void 0,oe)}registerReferenceProvider(U,Z,X){const oe=this.u(new T(this.h,X),U);return this.e.$registerReferenceSupport(oe,this.o(Z,U)),this.p(oe)}$provideReferences(U,Z,X,oe,Y){return this.t(U,T,fe=>fe.provideReferences(D.URI.revive(Z),X,oe,Y),void 0,Y)}registerCodeActionProvider(U,Z,X,oe){const Y=new y.$lb,fe=this.u(new O(this.h,this.j.converter,this.k,X,this.l,U,this.m),U);return this.e.$registerQuickFixSupport(fe,this.o(Z,U),{providedKinds:oe?.providedCodeActionKinds?.map(ye=>ye.value),documentation:oe?.documentation?.map(ye=>({kind:ye.kind.value,command:this.j.converter.toInternal(ye.command,Y)}))},we.w(U),!!X.resolveCodeAction),Y.add(this.p(fe)),Y}$provideCodeActions(U,Z,X,oe,Y){return this.t(U,O,fe=>fe.provideCodeActions(D.URI.revive(Z),X,oe,Y),void 0,Y)}$resolveCodeAction(U,Z,X){return this.t(U,O,oe=>oe.resolveCodeAction(Z,X),{},void 0)}$releaseCodeActions(U,Z){this.t(U,O,X=>Promise.resolve(X.releaseCodeActions(Z)),void 0,void 0)}registerDocumentFormattingEditProvider(U,Z,X){const oe=this.u(new F(this.h,X),U);return this.e.$registerDocumentFormattingSupport(oe,this.o(Z,U),U.identifier,U.displayName||U.name),this.p(oe)}$provideDocumentFormattingEdits(U,Z,X,oe){return this.t(U,F,Y=>Y.provideDocumentFormattingEdits(D.URI.revive(Z),X,oe),void 0,oe)}registerDocumentRangeFormattingEditProvider(U,Z,X){const oe=typeof X.provideDocumentRangesFormattingEdits=="function",Y=this.u(new J(this.h,X),U);return this.e.$registerRangeFormattingSupport(Y,this.o(Z,U),U.identifier,U.displayName||U.name,oe),this.p(Y)}$provideDocumentRangeFormattingEdits(U,Z,X,oe,Y){return this.t(U,J,fe=>fe.provideDocumentRangeFormattingEdits(D.URI.revive(Z),X,oe,Y),void 0,Y)}$provideDocumentRangesFormattingEdits(U,Z,X,oe,Y){return this.t(U,J,fe=>fe.provideDocumentRangesFormattingEdits(D.URI.revive(Z),X,oe,Y),void 0,Y)}registerOnTypeFormattingEditProvider(U,Z,X,oe){const Y=this.u(new K(this.h,X),U);return this.e.$registerOnTypeFormattingSupport(Y,this.o(Z,U),oe,U.identifier),this.p(Y)}$provideOnTypeFormattingEdits(U,Z,X,oe,Y,fe){return this.t(U,K,ye=>ye.provideOnTypeFormattingEdits(D.URI.revive(Z),X,oe,Y,fe),void 0,fe)}registerWorkspaceSymbolProvider(U,Z){const X=this.u(new me(Z,this.l),U);return this.e.$registerNavigateTypeSupport(X,typeof Z.resolveWorkspaceSymbol=="function"),this.p(X)}$provideWorkspaceSymbols(U,Z,X){return this.t(U,me,oe=>oe.provideWorkspaceSymbols(Z,X),{symbols:[]},X)}$resolveWorkspaceSymbol(U,Z,X){return this.t(U,me,oe=>oe.resolveWorkspaceSymbol(Z,X),void 0,void 0)}$releaseWorkspaceSymbols(U,Z){this.t(U,me,X=>X.releaseWorkspaceSymbols(Z),void 0,void 0)}registerRenameProvider(U,Z,X){const oe=this.u(new re(this.h,X,this.l),U);return this.e.$registerRenameSupport(oe,this.o(Z,U),re.supportsResolving(X)),this.p(oe)}$provideRenameEdits(U,Z,X,oe,Y){return this.t(U,re,fe=>fe.provideRenameEdits(D.URI.revive(Z),X,oe,Y),void 0,Y)}$resolveRenameLocation(U,Z,X,oe){return this.t(U,re,Y=>Y.resolveRenameLocation(D.URI.revive(Z),X,oe),void 0,oe)}registerDocumentSemanticTokensProvider(U,Z,X,oe){const Y=this.u(new q(this.h,X),U),fe=typeof X.onDidChangeSemanticTokens=="function"?this.q():void 0;this.e.$registerDocumentSemanticTokensProvider(Y,this.o(Z,U),oe,fe);let ye=this.p(Y);if(fe){const ze=X.onDidChangeSemanticTokens(Be=>this.e.$emitDocumentSemanticTokensEvent(fe));ye=R.$UJ.from(ye,ze)}return ye}$provideDocumentSemanticTokens(U,Z,X,oe){return this.t(U,q,Y=>Y.provideDocumentSemanticTokens(D.URI.revive(Z),X,oe),null,oe)}$releaseDocumentSemanticTokens(U,Z){this.t(U,q,X=>X.releaseDocumentSemanticColoring(Z),void 0,void 0)}registerDocumentRangeSemanticTokensProvider(U,Z,X,oe){const Y=this.u(new ee(this.h,X),U);return this.e.$registerDocumentRangeSemanticTokensProvider(Y,this.o(Z,U),oe),this.p(Y)}$provideDocumentRangeSemanticTokens(U,Z,X,oe){return this.t(U,ee,Y=>Y.provideDocumentRangeSemanticTokens(D.URI.revive(Z),X,oe),null,oe)}registerCompletionItemProvider(U,Z,X,oe){const Y=this.u(new pe(this.h,this.j.converter,X,this.m,U),U);return this.e.$registerCompletionsProvider(Y,this.o(Z,U),oe,pe.supportsResolving(X),U.identifier),this.p(Y)}$provideCompletionItems(U,Z,X,oe,Y){return this.t(U,pe,fe=>fe.provideCompletionItems(D.URI.revive(Z),X,oe,Y),void 0,Y)}$resolveCompletionItem(U,Z,X){return this.t(U,pe,oe=>oe.resolveCompletionItem(Z,X),void 0,X)}$releaseCompletionItems(U,Z){this.t(U,pe,X=>X.releaseCompletionItems(Z),void 0,void 0)}registerInlineCompletionsProvider(U,Z,X,oe){const Y=new _(U,this.h,X,this.j.converter),fe=this.u(Y,U);return this.e.$registerInlineCompletionsSupport(fe,this.o(Z,U),Y.supportsHandleEvents,C.$Tl.toKey(U.identifier.value),oe?.yieldTo?.map(ye=>C.$Tl.toKey(ye))||[]),this.p(fe)}$provideInlineCompletions(U,Z,X,oe,Y){return this.t(U,ce,fe=>fe.provideInlineCompletions(D.URI.revive(Z),X,oe,Y),void 0,Y)}$handleInlineCompletionDidShow(U,Z,X,oe){this.t(U,ce,async Y=>{Y.handleDidShowCompletionItem(Z,X,oe)},void 0,void 0)}$handleInlineCompletionPartialAccept(U,Z,X,oe){this.t(U,ce,async Y=>{Y.handlePartialAccept(Z,X,oe)},void 0,void 0)}$freeInlineCompletionsList(U,Z){this.t(U,ce,async X=>{X.disposeCompletions(Z)},void 0,void 0)}registerSignatureHelpProvider(U,Z,X,oe){const Y=Array.isArray(oe)?{triggerCharacters:oe,retriggerCharacters:[]}:oe,fe=this.u(new z(this.h,X),U);return this.e.$registerSignatureHelpProvider(fe,this.o(Z,U),Y),this.p(fe)}$provideSignatureHelp(U,Z,X,oe,Y){return this.t(U,z,fe=>fe.provideSignatureHelp(D.URI.revive(Z),X,oe,Y),void 0,Y)}$releaseSignatureHelp(U,Z){this.t(U,z,X=>X.releaseSignatureHelp(Z),void 0,void 0)}registerInlayHintsProvider(U,Z,X){const oe=typeof X.onDidChangeInlayHints=="function"?this.q():void 0,Y=this.u(new V(this.h,this.j.converter,X,this.l,U),U);this.e.$registerInlayHintsProvider(Y,this.o(Z,U),typeof X.resolveInlayHint=="function",oe,we.w(U));let fe=this.p(Y);if(oe!==void 0){const ye=X.onDidChangeInlayHints(ze=>this.e.$emitInlayHintsEvent(oe));fe=R.$UJ.from(fe,ye)}return fe}$provideInlayHints(U,Z,X,oe){return this.t(U,V,Y=>Y.provideInlayHints(D.URI.revive(Z),X,oe),void 0,oe)}$resolveInlayHint(U,Z,X){return this.t(U,V,oe=>oe.resolveInlayHint(Z,X),void 0,X)}$releaseInlayHints(U,Z){this.t(U,V,X=>X.releaseHints(Z),void 0,void 0)}registerDocumentLinkProvider(U,Z,X){const oe=this.u(new G(this.h,X),U);return this.e.$registerDocumentLinkProvider(oe,this.o(Z,U),typeof X.resolveDocumentLink=="function"),this.p(oe)}$provideDocumentLinks(U,Z,X){return this.t(U,G,oe=>oe.provideLinks(D.URI.revive(Z),X),void 0,X,Z.scheme==="output")}$resolveDocumentLink(U,Z,X){return this.t(U,G,oe=>oe.resolveLink(Z,X),void 0,void 0,!0)}$releaseDocumentLinks(U,Z){this.t(U,G,X=>X.releaseLinks(Z),void 0,void 0,!0)}registerColorProvider(U,Z,X){const oe=this.u(new ae(this.h,X),U);return this.e.$registerDocumentColorProvider(oe,this.o(Z,U)),this.p(oe)}$provideDocumentColors(U,Z,X){return this.t(U,ae,oe=>oe.provideColors(D.URI.revive(Z),X),[],X)}$provideColorPresentations(U,Z,X,oe){return this.t(U,ae,Y=>Y.provideColorPresentations(D.URI.revive(Z),X,oe),void 0,oe)}registerFoldingRangeProvider(U,Z,X){const oe=this.q(),Y=typeof X.onDidChangeFoldingRanges=="function"?this.q():void 0;this.f.set(oe,new ue(new ne(this.h,X),U)),this.e.$registerFoldingRangeProvider(oe,this.o(Z,U),U.identifier,Y);let fe=this.p(oe);if(Y!==void 0){const ye=X.onDidChangeFoldingRanges(()=>this.e.$emitFoldingRangeEvent(Y));fe=R.$UJ.from(fe,ye)}return fe}$provideFoldingRanges(U,Z,X,oe){return this.t(U,ne,Y=>Y.provideFoldingRanges(D.URI.revive(Z),X,oe),void 0,oe)}registerSelectionRangeProvider(U,Z,X){const oe=this.u(new he(this.h,X,this.l),U);return this.e.$registerSelectionRangeProvider(oe,this.o(Z,U)),this.p(oe)}$provideSelectionRanges(U,Z,X,oe){return this.t(U,he,Y=>Y.provideSelectionRanges(D.URI.revive(Z),X,oe),[],oe)}registerCallHierarchyProvider(U,Z,X){const oe=this.u(new Ee(this.h,X),U);return this.e.$registerCallHierarchyProvider(oe,this.o(Z,U)),this.p(oe)}$prepareCallHierarchy(U,Z,X,oe){return this.t(U,Ee,Y=>Promise.resolve(Y.prepareSession(D.URI.revive(Z),X,oe)),void 0,oe)}$provideCallHierarchyIncomingCalls(U,Z,X,oe){return this.t(U,Ee,Y=>Y.provideCallsTo(Z,X,oe),void 0,oe)}$provideCallHierarchyOutgoingCalls(U,Z,X,oe){return this.t(U,Ee,Y=>Y.provideCallsFrom(Z,X,oe),void 0,oe)}$releaseCallHierarchy(U,Z){this.t(U,Ee,X=>Promise.resolve(X.releaseSession(Z)),void 0,void 0)}registerTypeHierarchyProvider(U,Z,X){const oe=this.u(new de(this.h,X),U);return this.e.$registerTypeHierarchyProvider(oe,this.o(Z,U)),this.p(oe)}$prepareTypeHierarchy(U,Z,X,oe){return this.t(U,de,Y=>Promise.resolve(Y.prepareSession(D.URI.revive(Z),X,oe)),void 0,oe)}$provideTypeHierarchySupertypes(U,Z,X,oe){return this.t(U,de,Y=>Y.provideSupertypes(Z,X,oe),void 0,oe)}$provideTypeHierarchySubtypes(U,Z,X,oe){return this.t(U,de,Y=>Y.provideSubtypes(Z,X,oe),void 0,oe)}$releaseTypeHierarchy(U,Z){this.t(U,de,X=>Promise.resolve(X.releaseSession(Z)),void 0,void 0)}registerDocumentOnDropEditProvider(U,Z,X,oe){const Y=this.q();this.f.set(Y,new ue(new ge(this.e,this.h,X,Y,U),U));const fe=(0,t.$LF)(U,"dropMetadata")&&oe?ge.toInternalProviderId(U.identifier.value,oe.id):void 0;return this.e.$registerDocumentOnDropEditProvider(Y,this.o(Z,U),fe,(0,t.$LF)(U,"dropMetadata")?oe:void 0),this.p(Y)}$provideDocumentOnDropEdits(U,Z,X,oe,Y,fe){return this.t(U,ge,ye=>Promise.resolve(ye.provideDocumentOnDropEdits(Z,D.URI.revive(X),oe,Y,fe)),void 0,void 0)}registerMappedEditsProvider(U,Z,X){const oe=this.u(new ie(this.h,X),U);return this.e.$registerMappedEditsProvider(oe,this.o(Z,U)),this.p(oe)}$provideMappedEdits(U,Z,X,oe,Y){return this.t(U,ie,fe=>Promise.resolve(fe.provideMappedEdits(Z,X,oe,Y)),null,Y)}registerDocumentPasteEditProvider(U,Z,X,oe){const Y=this.q();this.f.set(Y,new ue(new B(this.e,this.h,X,Y,U),U));const fe=B.toInternalProviderId(U.identifier.value,oe.id);return this.e.$registerPasteEditProvider(Y,this.o(Z,U),fe,{supportsCopy:!!X.prepareDocumentPaste,supportsPaste:!!X.provideDocumentPasteEdits,copyMimeTypes:oe.copyMimeTypes,pasteMimeTypes:oe.pasteMimeTypes}),this.p(Y)}$prepareDocumentPaste(U,Z,X,oe,Y){return this.t(U,B,fe=>fe.prepareDocumentPaste(D.URI.revive(Z),X,oe,Y),void 0,Y)}$providePasteEdits(U,Z,X,oe,Y,fe){return this.t(U,B,ye=>ye.providePasteEdits(Z,D.URI.revive(X),oe,Y,fe),void 0,fe)}static y(U){return{pattern:U.source,flags:U.flags}}static z(U){return{decreaseIndentPattern:we.y(U.decreaseIndentPattern),increaseIndentPattern:we.y(U.increaseIndentPattern),indentNextLinePattern:U.indentNextLinePattern?we.y(U.indentNextLinePattern):void 0,unIndentedLinePattern:U.unIndentedLinePattern?we.y(U.unIndentedLinePattern):void 0}}static B(U){return{beforeText:we.y(U.beforeText),afterText:U.afterText?we.y(U.afterText):void 0,previousLineText:U.previousLineText?we.y(U.previousLineText):void 0,action:U.action}}static C(U){return U.map(we.B)}setLanguageConfiguration(U,Z,X){const{wordPattern:oe}=X;if(oe&&(0,E.$Bd)(oe))throw new Error(`Invalid language configuration: wordPattern '${oe}' is not allowed to match the empty string.`);oe?this.h.setWordDefinitionFor(Z,oe):this.h.setWordDefinitionFor(Z,void 0),X.__electricCharacterSupport&&this.m.report("LanguageConfiguration.__electricCharacterSupport",U,"Do not use."),X.__characterPairSupport&&this.m.report("LanguageConfiguration.__characterPairSupport",U,"Do not use."),X.autoClosingPairs&&(0,t.$MF)(U,"languageConfigurationAutoClosingPairs");const Y=this.q(),fe={comments:X.comments,brackets:X.brackets,wordPattern:X.wordPattern?we.y(X.wordPattern):void 0,indentationRules:X.indentationRules?we.z(X.indentationRules):void 0,onEnterRules:X.onEnterRules?we.C(X.onEnterRules):void 0,__electricCharacterSupport:X.__electricCharacterSupport,__characterPairSupport:X.__characterPairSupport,autoClosingPairs:X.autoClosingPairs};return this.e.$setLanguageConfiguration(Y,Z,fe),this.p(Y)}$setWordDefinitions(U){for(const Z of U)this.h.setWordDefinitionFor(Z.languageId,new RegExp(Z.regexSource,Z.regexFlags))}}e.$Cac=we}),define(De[308],Ce([1,0,5,10,7,40,13,3]),function($e,e,D,M,h,R,A,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kbc=void 0;class E{constructor(P,I,b,S){this.c=I,this.d=b,this.e=S,this.b=[],this.f=0,this.g=new Set,this.a=P.getProxy(D.$SJ.MainThreadLanguages)}$acceptLanguageIds(P){this.b=P}async getLanguages(){return this.b.slice(0)}async changeLanguage(P,I){await this.a.$changeLanguage(P,I);const b=this.c.getDocumentData(P);if(!b)throw new Error(`document '${P.toString()}' NOT found`);return b.document}async tokenAtPosition(P,I){const b=P.version,S=M.Position.from(I),C=await this.a.$tokensAtPosition(P.uri,S),y={type:h.StandardTokenType.Other,range:P.getWordRangeAtPosition(I)??new h.$WJ(I.line,I.character,I.line,I.character)};if(!C)return y;const r={range:M.Range.to(C.range),type:M.TokenType.to(C.type)};return!r.range.contains(I)||b!==P.version?y:r}createLanguageStatusItem(P,I,b){const S=this.f++,C=this.a,y=this.g,r=`${P.identifier.value}/${I}`;if(y.has(r))throw new Error(`LanguageStatusItem with id '${I}' ALREADY exists`);y.add(r);const i={selector:b,id:I,name:P.displayName??P.name,severity:h.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let a;const m=new g.$lb,p=()=>{if(a?.dispose(),!y.has(r)){console.warn(`LanguageStatusItem (${I}) from ${P.identifier.value} has been disposed and CANNOT be updated anymore`);return}a=(0,A.$Gg)(()=>{m.clear(),this.a.$setLanguageStatus(S,{id:r,name:i.name??P.displayName??P.name,source:P.displayName??P.name,selector:M.DocumentSelector.from(i.selector,this.e),label:i.text,detail:i.detail??"",severity:i.severity===h.LanguageStatusSeverity.Error?R.default.Error:i.severity===h.LanguageStatusSeverity.Warning?R.default.Warning:R.default.Info,command:i.command&&this.d.toInternal(i.command,m),accessibilityInfo:i.accessibilityInformation,busy:i.busy})},0)},f={dispose(){m.dispose(),a?.dispose(),C.$removeLanguageStatus(S),y.delete(r)},get id(){return i.id},get name(){return i.name},set name(t){i.name=t,p()},get selector(){return i.selector},set selector(t){i.selector=t,p()},get text(){return i.text},set text(t){i.text=t,p()},get detail(){return i.detail},set detail(t){i.detail=t,p()},get severity(){return i.severity},set severity(t){i.severity=t,p()},get accessibilityInformation(){return i.accessibilityInformation},set accessibilityInformation(t){i.accessibilityInformation=t,p()},get command(){return i.command},set command(t){i.command=t,p()},get busy(){return i.busy},set busy(t){i.busy=t,p()}};return p(),f}}e.$kbc=E}),define(De[111],Ce([1,0,9,15,2,6,17,5,26,20]),function($e,e,D,M,h,R,A,g,E,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$abc=e.$_ac=void 0;let P=class{constructor(b,S,C){this.f=C,this.d=new Map,this.a=S.getProxy(g.$SJ.MainThreadLocalization),this.b=b.environment.appLanguage,this.c=this.b===D.$f}getMessage(b,S){const{message:C,args:y,comment:r}=S;if(this.c)return(0,M.$qd)(C,y??{});let i=C;r&&r.length>0&&(i+=`/${Array.isArray(r)?r.join(""):r}`);const a=this.d.get(b)?.contents[i];return a||this.f.warn(`Using default string since no string found in i18n bundle that has the key: ${i}`),(0,M.$qd)(a??C,y??{})}getBundle(b){return this.d.get(b)?.contents}getBundleUri(b){return this.d.get(b)?.uri}async initializeLocalizedMessages(b){if(this.c||!b.l10n&&!b.isBuiltin||this.d.has(b.identifier.value))return;let S;const C=await this.g(b);if(!C){this.f.error(`No bundle location found for extension ${b.identifier.value}`);return}try{const y=await this.a.$fetchBundleContents(C),r=JSON.parse(y);S=b.isBuiltin?r.contents?.bundle:r}catch(y){this.f.error(`Failed to load translations for ${b.identifier.value} from ${C}: ${y.message}`);return}S&&this.d.set(b.identifier.value,{contents:S,uri:C})}async g(b){if(b.isBuiltin){const S=await this.a.$fetchBuiltInBundleUri(b.identifier.value,this.b);return h.URI.revive(S)}return b.l10n?h.URI.joinPath(b.extensionLocation,b.l10n,`bundle.l10n.${this.b}.json`):void 0}};e.$_ac=P,e.$_ac=P=Ke([Ve(0,E.$$L),Ve(1,$.$UL),Ve(2,A.$3i)],P),e.$abc=(0,R.$zh)("IExtHostLocalizationService")}),define(De[148],Ce([1,0,17,5,26,20,2,77]),function($e,e,D,M,h,R,A,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Acc=void 0;let E=class extends D.$bj{constructor(I,b){super(b.logLevel,b.logsLocation,b.loggers.map(S=>(0,g.$9g)(S))),this.n=I.getProxy(M.$SJ.MainThreadLogger)}$setLogLevel(I,b){b?this.setLogLevel(A.URI.revive(b),I):this.setLogLevel(I)}setVisibility(I,b){super.setVisibility(I,b),this.n.$setVisibility(I,b)}m(I,b,S){return new $(this.n,I,b,S)}};e.$Acc=E,e.$Acc=E=Ke([Ve(0,R.$UL),Ve(1,h.$$L)],E);class $ extends D.$9i{constructor(I,b,S,C){super(C?.logLevel==="always"),this.m=I,this.n=b,this.k=!1,this.l=[],this.setLevel(S),this.m.$createLogger(b,C).then(()=>{this.r(this.l),this.k=!0})}g(I,b){const S=[[I,b]];this.k?this.r(S):this.l.push(...S)}r(I){this.m.$log(this.n,I)}flush(){this.m.$flush(this.n)}}}),define(De[112],Ce([1,0,5,6,3,20,21]),function($e,e,D,M,h,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cbc=e.$bbc=void 0,e.$bbc=(0,M.$zh)("IExtHostManagedSockets");let g=class{constructor(I){this.b=0,this.c=null,this.d=new Map,this.a=I.getProxy(D.$SJ.MainThreadManagedSockets)}setFactory(I,b){for(const S of this.d.values())S.dispose();this.c&&this.a.$unregisterSocketFactory(this.c.socketFactoryId),this.c=new E(I,b),this.a.$registerSocketFactory(this.c.socketFactoryId)}async $openRemoteSocket(I){if(!this.c||this.c.socketFactoryId!==I)throw new Error(`No socket factory with id ${I}`);const b=++this.b,S=await this.c.makeConnection(),C=new h.$lb;return this.d.set(b,new $(b,S,C)),C.add((0,h.$kb)(()=>this.d.delete(b))),C.add(S.onDidEnd(()=>{this.a.$onDidManagedSocketEnd(b),C.dispose()})),C.add(S.onDidClose(y=>{this.a.$onDidManagedSocketClose(b,y?.stack??y?.message),C.dispose()})),C.add(S.onDidReceiveMessage(y=>this.a.$onDidManagedSocketHaveData(b,A.$Hc.wrap(y)))),b}$remoteSocketWrite(I,b){this.d.get(I)?.actual.send(b.buffer)}$remoteSocketEnd(I){const b=this.d.get(I);b&&(b.actual.end(),b.dispose())}async $remoteSocketDrain(I){await this.d.get(I)?.actual.drain?.()}};e.$cbc=g,e.$cbc=g=Ke([Ve(0,R.$UL)],g);class E{constructor(I,b){this.socketFactoryId=I,this.makeConnection=b}}class $ extends h.$mb{constructor(I,b,S){super(),this.socketId=I,this.actual=b,this.B(S)}}}),define(De[309],Ce([1,0,5,17,27]),function($e,e,D,M,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lbc=void 0;function R(g){return g&&g.title}let A=class{constructor(E,$){this.b=$,this.a=E.getProxy(D.$SJ.MainThreadMessageService)}showMessage(E,$,P,I,b){const S={source:{identifier:E.identifier,label:E.displayName||E.name}};let C;typeof I=="string"||R(I)?C=[I,...b]:(S.modal=I?.modal,S.useCustom=I?.useCustom,S.detail=I?.detail,C=b),S.useCustom&&(0,h.$MF)(E,"resolvers");const y=[];for(let r=0;r<C.length;r++){const i=C[r];if(typeof i=="string")y.push({title:i,handle:r,isCloseAffordance:!1});else if(typeof i=="object"){const{title:a,isCloseAffordance:m}=i;y.push({title:a,isCloseAffordance:!!m,handle:r})}else this.b.warn("Invalid message item:",i)}return this.a.$showMessage($,P,S,y).then(r=>{if(typeof r=="number")return C[r]})}};e.$lbc=A,e.$lbc=A=Ke([Ve(1,M.$3i)],A)}),define(De[310],Ce([1,0,202,21,4,3,28,15,18,2,30,86,5,33,10,7,64,272,143,8,23,16]),function($e,e,D,M,h,R,A,g,E,$,P,I,b,S,C,y,r,i,a,m,p,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6bc=void 0;class t{static{this.a=0}get activeNotebookEditor(){return this.k?.apiEditor}get visibleNotebookEditors(){return this.l.map(o=>o.apiEditor)}constructor(o,n,c,d,v){this.q=c,this.r=d,this.s=v,this.f=new Map,this.g=new A.$xi,this.h=new Map,this.j=new h.$hc({onListenerError:m.$Z}),this.onDidChangeActiveNotebookEditor=this.j.event,this.l=[],this.m=new h.$hc({onListenerError:m.$Z}),this.onDidOpenNotebookDocument=this.m.event,this.n=new h.$hc({onListenerError:m.$Z}),this.onDidCloseNotebookDocument=this.n.event,this.o=new h.$hc({onListenerError:m.$Z}),this.onDidChangeVisibleNotebookEditors=this.o.event,this.p=new I.$tac("NotebookCellStatusBarCache"),this.u=0,this.w=new Map,this.b=o.getProxy(b.$SJ.MainThreadNotebook),this.c=o.getProxy(b.$SJ.MainThreadNotebookDocuments),this.d=o.getProxy(b.$SJ.MainThreadNotebookEditors),this.i=n.converter,n.registerArgumentProcessor({processArgument:k=>{if(k&&k.$mid===13){const u=k.notebookEditor?.notebookUri,l=k.cell.handle,L=this.g.get(u)?.getCell(l);if(L)return L.apiCell}if(k&&k.$mid===14){const u=k.uri,l=this.g.get(u);if(l)return l.apiNotebook}return k}}),t.A(n)}getEditorById(o){const n=this.h.get(o);if(!n)throw new Error(`unknown text editor: ${o}. known editors: ${[...this.h.keys()]} `);return n}getIdByEditor(o){for(const[n,c]of this.h)if(c.apiEditor===o)return n}get notebookDocuments(){return[...this.g.values()]}getNotebookDocument(o,n){const c=this.g.get(o);if(!c&&!n)throw new Error(`NO notebook document for '${o}'`);return c}static t(o,n){if(!n)return;const c=n.filenamePattern.map(d=>C.NotebookExclusiveDocumentPattern.from(d)).filter(d=>d!==void 0);if(n.filenamePattern&&!c){console.warn(`Notebook content provider view options file name pattern is invalid ${n.filenamePattern}`);return}return{extension:o.identifier,providerDisplayName:o.displayName||o.name,displayName:n.displayName,filenamePattern:c,exclusive:n.exclusive||!1}}registerNotebookCellStatusBarItemProvider(o,n,c){const d=t.a++,v=typeof c.onDidChangeCellStatusBarItems=="function"?t.a++:void 0;this.f.set(d,c),this.b.$registerNotebookCellStatusBarItemProvider(d,v,n);let k;return v!==void 0&&(k=c.onDidChangeCellStatusBarItems(u=>this.b.$emitCellStatusBarEvent(v))),new y.$UJ(()=>{this.f.delete(d),this.b.$unregisterNotebookCellStatusBarItemProvider(d,v),k?.dispose()})}async createNotebookDocument(o){const n=await this.c.$tryCreateNotebook({viewType:o.viewType,content:o.content&&C.NotebookData.from(o.content)});return $.URI.revive(n)}async openNotebookDocument(o){const n=this.g.get(o);if(n)return n.apiNotebook;const c=await this.c.$tryOpenNotebook(o),d=this.g.get($.URI.revive(c));return(0,E.$we)(d?.apiNotebook)}async showNotebookDocument(o,n){$.URI.isUri(o)&&(o=await this.openNotebookDocument(o));let c;typeof n=="object"?c={position:C.ViewColumn.from(n.viewColumn),preserveFocus:n.preserveFocus,selections:n.selections&&n.selections.map(C.NotebookRange.from),pinned:typeof n.preview=="boolean"?!n.preview:void 0}:c={preserveFocus:!1};const d=await this.d.$tryShowNotebookDocument(o.uri,o.notebookType,c),v=d&&this.h.get(d)?.apiEditor;if(v)return v;throw d?new Error(`Could NOT open editor for "${o.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${o.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(o,n,c,d){const v=this.f.get(o),k=$.URI.revive(n),u=this.g.get(k);if(!u||!v)return;const l=u.getCellFromIndex(c);if(!l)return;const w=await v.provideCellStatusBarItems(l.apiCell,d);if(!w)return;const L=new R.$lb,N=this.p.add([L]),T=(Array.isArray(w)?w:[w]).map(O=>C.NotebookStatusBarItem.from(O,this.i,L));return{cacheId:N,items:T}}$releaseNotebookCellStatusBarItems(o){this.p.delete(o)}registerNotebookSerializer(o,n,c,d,v){if((0,g.$od)(n))throw new Error("viewType cannot be empty or just whitespace");const k=this.u++;return this.w.set(k,{viewType:n,serializer:c,options:d}),this.b.$registerNotebookSerializer(k,{id:o.identifier,location:o.extensionLocation},n,C.NotebookDocumentContentOptions.from(d),t.t(o,v)),(0,R.$kb)(()=>{this.b.$unregisterNotebookSerializer(k)})}async $dataToNotebook(o,n,c){const d=this.w.get(o);if(!d)throw new Error("NO serializer found");const v=await d.serializer.deserializeNotebook(n.buffer,c);return new r.$_z(C.NotebookData.from(v))}async $notebookToData(o,n,c){const d=this.w.get(o);if(!d)throw new Error("NO serializer found");const v=await d.serializer.serializeNotebook(C.NotebookData.to(n.value),c);return M.$Hc.wrap(v)}async $saveNotebook(o,n,c,d,v){const k=$.URI.revive(n),u=this.w.get(o);if(!u)throw new Error("NO serializer found");const l=this.g.get(k);if(!l)throw new Error("Document NOT found");if(l.versionId!==c)throw new Error("Document version mismatch");if(!this.s.value.isWritableFileSystem(k.scheme))throw new P.$lk((0,D.localize)(0,null,this.y(k)),6);await this.x(k,d);const w={metadata:(0,p.$2m)(l.apiNotebook.metadata,O=>!(u.options?.transientDocumentMetadata??{})[O]),cells:[]};for(const O of l.apiNotebook.getCells()){const B=new y.$hL(O.kind,O.document.getText(),O.document.languageId,O.mime,u.options?.transientOutputs?[]:[...O.outputs],O.metadata,O.executionSummary);B.metadata=(0,p.$2m)(O.metadata,F=>!(u.options?.transientCellMetadata??{})[F]),w.cells.push(B)}const L=await u.serializer.serializeNotebook(w,v);await this.s.value.writeFile(k,L);const N=this.s.getFileSystemProviderExtUri(k.scheme),j=await this.s.value.stat(k);return{name:N.basename(k),isFile:(j.type&P.FileType.File)!==0,isDirectory:(j.type&P.FileType.Directory)!==0,isSymbolicLink:(j.type&P.FileType.SymbolicLink)!==0,mtime:j.mtime,ctime:j.ctime,size:j.size,readonly:!!((j.permissions??0)&P.FilePermission.Readonly)||!this.s.value.isWritableFileSystem(k.scheme),locked:!!((j.permissions??0)&P.FilePermission.Locked),etag:P.$wk({mtime:j.mtime,size:j.size}),children:void 0}}async x(o,n){const c=await this.s.value.stat(o);if(typeof n?.mtime=="number"&&typeof n.etag=="string"&&n.etag!==P.$vk&&typeof c.mtime=="number"&&typeof c.size=="number"&&n.mtime<c.mtime&&n.etag!==P.$wk({mtime:n.mtime,size:c.size}))throw new P.$lk((0,D.localize)(1,null),3,n)}y(o){return o.scheme===f.Schemas.file?o.fsPath:o.toString()}z(o,n,c){if(this.h.has(n))throw new Error(`editor with id ALREADY EXSIST: ${n}`);const d=new a.$5bc(n,this.d,o,c.visibleRanges.map(C.NotebookRange.to),c.selections.map(C.NotebookRange.to),typeof c.viewColumn=="number"?C.ViewColumn.to(c.viewColumn):void 0);this.h.set(n,d)}$acceptDocumentAndEditorsDelta(o){if(o.value.removedDocuments)for(const c of o.value.removedDocuments){const d=$.URI.revive(c),v=this.g.get(d);v&&(v.dispose(),this.g.delete(d),this.q.$acceptDocumentsAndEditorsDelta({removedDocuments:v.apiNotebook.getCells().map(k=>k.document.uri)}),this.n.fire(v.apiNotebook));for(const k of this.h.values())k.notebookData.uri.toString()===d.toString()&&this.h.delete(k.id)}if(o.value.addedDocuments){const c=[];for(const d of o.value.addedDocuments){const v=$.URI.revive(d.uri);if(this.g.has(v))throw new Error(`adding EXISTING notebook ${v} `);const k=new i.$4bc(this.c,this.q,this.r,v,d);c.push(...d.cells.map(u=>i.$3bc.asModelAddData(k.apiNotebook,u))),this.g.get(v)?.dispose(),this.g.set(v,k),this.q.$acceptDocumentsAndEditorsDelta({addedDocuments:c}),this.m.fire(k.apiNotebook)}}if(o.value.addedEditors)for(const c of o.value.addedEditors){if(this.h.has(c.id))return;const d=$.URI.revive(c.documentUri),v=this.g.get(d);v&&this.z(v,c.id,c)}const n=[];if(o.value.removedEditors)for(const c of o.value.removedEditors){const d=this.h.get(c);d&&(this.h.delete(c),this.k?.id===d.id&&(this.k=void 0),n.push(d))}if(o.value.visibleEditors){this.l=o.value.visibleEditors.map(d=>this.h.get(d)).filter(d=>!!d);const c=new Set;this.l.forEach(d=>c.add(d.id));for(const d of this.h.values()){const v=c.has(d.id);d._acceptVisibility(v)}this.l=[...this.h.values()].map(d=>d).filter(d=>d.visible),this.o.fire(this.visibleNotebookEditors)}o.value.newActiveEditor===null?this.k=void 0:o.value.newActiveEditor&&(this.h.get(o.value.newActiveEditor)||console.error(`FAILED to find active notebook editor ${o.value.newActiveEditor}`),this.k=this.h.get(o.value.newActiveEditor)),o.value.newActiveEditor!==void 0&&this.j.fire(this.k?.apiEditor)}static A(o){const n=S.$gM.String.with("notebookType","A notebook type"),c=new S.$iM("vscode.executeDataToNotebook","_executeDataToNotebook","Invoke notebook serializer",[n,new S.$gM("data","Bytes to convert to data",v=>v instanceof Uint8Array,v=>M.$Hc.wrap(v))],new S.$hM("Notebook Data",v=>C.NotebookData.to(v.value))),d=new S.$iM("vscode.executeNotebookToData","_executeNotebookToData","Invoke notebook serializer",[n,new S.$gM("NotebookData","Notebook data to convert to bytes",v=>!0,v=>new r.$_z(C.NotebookData.from(v)))],new S.$hM("Bytes",v=>v.buffer));o.registerApiCommand(c),o.registerApiCommand(d)}}e.$6bc=t}),define(De[311],Ce([1,0,19,13,22,4,3,28,2,25,17,86,5,33,10,7,109,266,27,64]),function($e,e,D,M,h,R,A,g,E,$,P,I,b,S,C,y,r,i,a,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$icc=e.$hcc=void 0;let p=class{constructor(v,k,u,l,w){this.m=k,this.n=u,this.o=l,this.q=w,this.b=new g.$xi,this.c=new g.$xi,this.e=new Map,this.f=0,this.g=new Map,this.h=0,this.i=new I.$tac("NotebookKernelSourceActionProviderCache"),this.j=new Map,this.k=0,this.l=new R.$hc,this.onDidChangeNotebookCellExecutionState=this.l.event,this.a=v.getProxy(b.$SJ.MainThreadNotebookKernels);const L=new S.$iM("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new S.$gM("options","Select kernel options",N=>!0,N=>{if(N&&"notebookEditor"in N&&"id"in N){const j=this.n.getIdByEditor(N.notebookEditor);return{id:N.id,extension:N.extension,notebookEditorId:j}}else if(N&&"notebookEditor"in N){const j=this.n.getIdByEditor(N.notebookEditor);if(j===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${N.notebookEditor.notebook.uri.toString()}`);return{notebookEditorId:j}}return N})],S.$hM.Void);this.o.registerApiCommand(L)}createNotebookController(v,k,u,l,w,L){for(const pe of this.j.values())if(pe.controller.id===k&&$.$Tl.equals(v.identifier,pe.extensionId))throw new Error(`notebook controller with id '${k}' ALREADY exist`);const N=this.k++,j=this;this.q.trace(`NotebookController[${N}], CREATED by ${v.identifier.value}, ${k}`);const T=()=>console.warn(`NO execute handler from notebook controller '${J.id}' of extension: '${v.identifier}'`);let O=!1;const B=new R.$hc,F=new R.$hc,J={id:c(v.identifier,k),notebookType:u,extensionId:v.identifier,extensionLocation:v.extensionLocation,label:l||v.identifier.value,preloads:L?L.map(C.NotebookRendererScript.from):[]};let K=w??T,me;this.a.$addKernel(N,J).catch(pe=>{console.log(pe),O=!0});let re=0;const x=()=>{if(O)return;const pe=++re;Promise.resolve().then(()=>{pe===re&&this.a.$updateKernel(N,J)})},q=new g.$xi,ee={get id(){return k},get notebookType(){return J.notebookType},onDidChangeSelectedNotebooks:B.event,get label(){return J.label},set label(pe){J.label=pe??v.displayName??v.name,x()},get detail(){return J.detail??""},set detail(pe){J.detail=pe,x()},get description(){return J.description??""},set description(pe){J.description=pe,x()},get supportedLanguages(){return J.supportedLanguages},set supportedLanguages(pe){J.supportedLanguages=pe,x()},get supportsExecutionOrder(){return J.supportsExecutionOrder??!1},set supportsExecutionOrder(pe){J.supportsExecutionOrder=pe,x()},get rendererScripts(){return J.preloads?J.preloads.map(C.NotebookRendererScript.to):[]},get executeHandler(){return K},set executeHandler(pe){K=pe??T},get interruptHandler(){return me},set interruptHandler(pe){me=pe,J.supportsInterrupt=!!pe,x()},createNotebookCellExecution(pe){if(O)throw new Error("notebook controller is DISPOSED");if(!q.has(pe.notebook.uri))throw j.q.trace(`NotebookController[${N}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(q.keys()).map(ce=>ce.toString())),new Error(`notebook controller is NOT associated to notebook: ${pe.notebook.uri.toString()}`);return j._createNotebookCellExecution(pe,c(v.identifier,this.id))},createNotebookExecution(pe){if((0,a.$MF)(v,"notebookExecution"),O)throw new Error("notebook controller is DISPOSED");if(!q.has(pe.uri))throw j.q.trace(`NotebookController[${N}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(q.keys()).map(ce=>ce.toString())),new Error(`notebook controller is NOT associated to notebook: ${pe.uri.toString()}`);return j._createNotebookExecution(pe,c(v.identifier,this.id))},dispose:()=>{O||(this.q.trace(`NotebookController[${N}], DISPOSED`),O=!0,this.j.delete(N),B.dispose(),F.dispose(),this.a.$removeKernel(N))},updateNotebookAffinity(pe,ce){ce===y.NotebookControllerAffinity2.Hidden&&(0,a.$MF)(v,"notebookControllerAffinityHidden"),j.a.$updateNotebookPriority(N,pe.uri,ce)},onDidReceiveMessage:F.event,postMessage(pe,ce){return(0,a.$MF)(v,"notebookMessaging"),j.a.$postMessage(N,ce&&j.n.getIdByEditor(ce),pe)},asWebviewUri(pe){return(0,a.$MF)(v,"notebookMessaging"),(0,r.$Aob)(pe,j.m.remote)}};return this.j.set(N,{extensionId:v.identifier,controller:ee,onDidReceiveMessage:F,onDidChangeSelection:B,associatedNotebooks:q}),ee}getIdByController(v){for(const[k,u]of this.j)if(u.controller===v)return c(u.extensionId,v.id);return null}createNotebookControllerDetectionTask(v,k){const u=this.f++,l=this;this.q.trace(`NotebookControllerDetectionTask[${u}], CREATED by ${v.identifier.value}`),this.a.$addKernelDetectionTask(u,k);const w={dispose:()=>{this.e.delete(u),l.a.$removeKernelDetectionTask(u)}};return this.e.set(u,w),w}registerKernelSourceActionProvider(v,k,u){const l=this.h++,w=typeof u.onDidChangeNotebookKernelSourceActions=="function"?l:void 0,L=this;this.g.set(l,u),this.q.trace(`NotebookKernelSourceActionProvider[${l}], CREATED by ${v.identifier.value}`),this.a.$addKernelSourceActionProvider(l,l,k);let N;return w!==void 0&&(N=u.onDidChangeNotebookKernelSourceActions(j=>this.a.$emitNotebookKernelSourceActionsChangeEvent(w))),{dispose:()=>{this.g.delete(l),L.a.$removeKernelSourceActionProvider(l,l),N?.dispose()}}}async $provideKernelSourceActions(v,k){const u=this.g.get(v);if(u){const l=new A.$lb;return this.i.add([l]),(await u.provideNotebookKernelSourceActions(k)??[]).map(L=>C.NotebookKernelSourceAction.from(L,this.o.converter,l))}return[]}$acceptNotebookAssociation(v,k,u){const l=this.j.get(v);if(l){const w=this.n.getNotebookDocument(E.URI.revive(k));u?l.associatedNotebooks.set(w.uri,!0):l.associatedNotebooks.delete(w.uri),this.q.trace(`NotebookController[${v}] ASSOCIATE notebook`,w.uri.toString(),u),l.onDidChangeSelection.fire({selected:u,notebook:w.apiNotebook})}}async $executeCells(v,k,u){const l=this.j.get(v);if(!l)return;const w=this.n.getNotebookDocument(E.URI.revive(k)),L=[];for(const N of u){const j=w.getCell(N);j&&L.push(j.apiCell)}try{this.q.trace(`NotebookController[${v}] EXECUTE cells`,w.uri.toString(),L.length),await l.controller.executeHandler.call(l.controller,L,w.apiNotebook,l.controller)}catch(N){this.q.error(`NotebookController[${v}] execute cells FAILED`,N),console.error(N)}}async $cancelCells(v,k,u){const l=this.j.get(v);if(!l)return;const w=this.n.getNotebookDocument(E.URI.revive(k));if(l.controller.interruptHandler)await l.controller.interruptHandler.call(l.controller,w.apiNotebook);else for(const L of u){const N=w.getCell(L);N&&this.b.get(N.uri)?.cancel()}if(l.controller.interruptHandler){const L=this.c.get(w.uri);u.length&&Array.isArray(L)&&L.length&&L.forEach(N=>N.dispose())}}$acceptKernelMessageFromRenderer(v,k,u){const l=this.j.get(v);if(!l)return;const w=this.n.getEditorById(k);l.onDidReceiveMessage.fire(Object.freeze({editor:w.apiEditor,message:u}))}$cellExecutionChanged(v,k,u){const w=this.n.getNotebookDocument(E.URI.revive(v)).getCell(k);if(w){const L=u?C.NotebookCellExecutionState.to(u):y.NotebookCellExecutionState.Idle;L!==void 0&&this.l.fire({cell:w.apiCell,state:L})}}_createNotebookCellExecution(v,k){if(v.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const l=this.n.getNotebookDocument(v.notebook.uri).getCellFromApiCell(v);if(!l)throw new Error("invalid cell");if(this.b.has(l.uri))throw new Error(`duplicate execution for ${l.uri}`);const w=new t(k,l,this.a);this.b.set(l.uri,w);const L=w.onDidChangeState(()=>{w.state===f.Resolved&&(w.dispose(),L.dispose(),this.b.delete(l.uri))});return w.asApiObject()}_createNotebookExecution(v,k){const u=this.n.getNotebookDocument(v.uri),l=v.getCells().find(N=>{const j=u.getCellFromApiCell(N);return j&&this.b.has(j.uri)});if(l)throw new Error(`duplicate cell execution for ${l.document.uri}`);if(this.c.has(u.uri))throw new Error(`duplicate notebook execution for ${u.uri}`);const w=new o(k,u,this.a),L=w.onDidChangeState(()=>{w.state===s.Resolved&&(w.dispose(),L.dispose(),this.c.delete(u.uri))});return this.c.set(u.uri,[w,L]),w.asApiObject()}};e.$hcc=p,e.$hcc=p=Ke([Ve(4,P.$3i)],p);var f;(function(d){d[d.Init=0]="Init",d[d.Started=1]="Started",d[d.Resolved=2]="Resolved"})(f||(f={}));class t extends A.$mb{static{this.a=0}get state(){return this.f}constructor(v,k,u){super(),this.j=k,this.k=u,this.b=t.a++,this.c=new R.$hc,this.onDidChangeState=this.c.event,this.f=f.Init,this.g=this.B(new h.$rc),this.h=new n(10,l=>this.m(l)),this.i=k.internalMetadata.executionOrder,this.k.$createExecution(this.b,v,this.j.notebook.uri,this.j.handle)}cancel(){this.g.cancel()}async l(v){await this.h.addItem(v)}async m(v){const k=Array.isArray(v)?v:[v];return this.k.$updateExecution(this.b,new m.$_z(k))}n(){if(this.f===f.Init)throw new Error("Must call start before modifying cell output");if(this.f===f.Resolved)throw new Error("Cannot modify cell output after calling resolve")}r(v){let k=this.j;if(v&&(k=this.j.notebook.getCellFromApiCell(v)),!k)throw new Error("INVALID cell");return k.handle}s(v){return v.map(k=>{const u=y.$kL.ensureUniqueMimeTypes(k.items,!0);return u===k.items?C.NotebookCellOutput.from(k):C.NotebookCellOutput.from({items:u,id:k.id,metadata:k.metadata})})}async t(v,k,u){const l=this.r(k),w=this.s((0,D.$Vf)(v));return this.l({editType:i.CellExecutionUpdateType.Output,cellHandle:l,append:u,outputs:w})}async w(v,k,u){return v=y.$kL.ensureUniqueMimeTypes((0,D.$Vf)(v),!0),this.l({editType:i.CellExecutionUpdateType.OutputItems,items:v.map(C.NotebookCellOutputItem.from),outputId:k.id,append:u})}asApiObject(){const v=this;return Object.freeze({get token(){return v.g.token},get cell(){return v.j.apiCell},get executionOrder(){return v.i},set executionOrder(u){v.i=u,v.m([{editType:i.CellExecutionUpdateType.ExecutionState,executionOrder:v.i}])},start(u){if(v.f===f.Resolved||v.f===f.Started)throw new Error("Cannot call start again");v.f=f.Started,v.c.fire(),v.m({editType:i.CellExecutionUpdateType.ExecutionState,runStartTime:u})},end(u,l){if(v.f===f.Resolved)throw new Error("Cannot call resolve twice");v.f=f.Resolved,v.c.fire(),v.h.flush(),v.k.$completeExecution(v.b,new m.$_z({runEndTime:l,lastRunSuccess:u}))},clearOutput(u){return v.n(),v.t([],u,!1)},appendOutput(u,l){return v.n(),v.t(u,l,!0)},replaceOutput(u,l){return v.n(),v.t(u,l,!1)},appendOutputItems(u,l){return v.n(),v.w(u,l,!0)},replaceOutputItems(u,l){return v.n(),v.w(u,l,!1)}})}}var s;(function(d){d[d.Init=0]="Init",d[d.Started=1]="Started",d[d.Resolved=2]="Resolved"})(s||(s={}));class o extends A.$mb{static{this.a=0}get state(){return this.f}constructor(v,k,u){super(),this.h=k,this.i=u,this.b=o.a++,this.c=new R.$hc,this.onDidChangeState=this.c.event,this.f=s.Init,this.g=this.B(new h.$rc),this.i.$createNotebookExecution(this.b,v,this.h.uri)}cancel(){this.g.cancel()}asApiObject(){return Object.freeze({start:()=>{if(this.f===s.Resolved||this.f===s.Started)throw new Error("Cannot call start again");this.f=s.Started,this.c.fire(),this.i.$beginNotebookExecution(this.b)},end:()=>{if(this.f===s.Resolved)throw new Error("Cannot call resolve twice");this.f=s.Resolved,this.c.fire(),this.i.$completeNotebookExecution(this.b)}})}}class n{constructor(v,k){this.e=v,this.f=k,this.a=[],this.b=Date.now()}addItem(v){return this.a.push(v),this.c||(this.c=new M.$Zg,this.b=Date.now(),(0,M.$Fg)(this.e).then(()=>this.flush())),Date.now()-this.b>this.e?this.flush():this.c.p}flush(){if(this.a.length===0||!this.c)return Promise.resolve();const v=this.c;this.c=void 0;const k=this.a;return this.a=[],this.f(k).finally(()=>v.complete())}}function c(d,v){return`${d.value}/${v}`}e.$icc=c}),define(De[312],Ce([1,0,4,5,143]),function($e,e,D,M,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jcc=void 0;class R{constructor(g,E){this.c=E,this.a=new Map,this.b=g.getProxy(M.$SJ.MainThreadNotebookRenderers)}$postRendererMessage(g,E,$){const P=this.c.getEditorById(g);this.a.get(E)?.fire({editor:P.apiEditor,message:$})}createRendererMessaging(g,E){if(!g.contributes?.notebookRenderer?.some(P=>P.id===E))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${E})`);return{onDidReceiveMessage:(P,I,b)=>this.d(E).event(P,I,b),postMessage:(P,I)=>{h.$5bc.apiEditorsToExtHost.has(P)&&([P,I]=[I,P]);const b=I&&h.$5bc.apiEditorsToExtHost.get(I);return this.b.$postMessage(b?.id,E,P)}}}d(g){let E=this.a.get(g);return E||(E=new D.$hc({onDidRemoveLastListener:()=>{E?.dispose(),this.a.delete(g)}}),this.a.set(g,E),E)}}e.$jcc=R}),define(De[313],Ce([1,0,3,18,2,27,5]),function($e,e,D,M,h,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ncc=void 0;class g{constructor($){this.b=new Map,this.a=$.getProxy(A.$SJ.MainThreadProfileContentHandlers)}registrProfileContentHandler($,P,I){if((0,R.$MF)($,"profileContentHandlers"),this.b.has(P))throw new Error(`Handler with id '${P}' already registered`);return this.b.set(P,I),this.a.$registerProfileContentHandler(P,I.name,I.description,$.identifier.value),(0,D.$kb)(()=>{this.b.delete(P),this.a.$unregisterProfileContentHandler(P)})}async $saveProfile($,P,I,b){const S=this.b.get($);if(!S)throw new Error(`Unknown handler with id: ${$}`);return S.saveProfile(P,I,b)}async $readProfile($,P,I){const b=this.b.get($);if(!b)throw new Error(`Unknown handler with id: ${$}`);return b.readProfile((0,M.$le)(P)?P:h.URI.revive(P),I)}}e.$ncc=g}),define(De[314],Ce([1,0,2,5,13,10]),function($e,e,D,M,h,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$occ=void 0;class A{static{this.a=0}constructor(E,$){this.d=$,this.c=new Map,this.b=E.getProxy(M.$SJ.MainThreadQuickDiff)}$provideOriginalResource(E,$,P){const I=D.URI.revive($),b=this.c.get(E);return b?(0,h.$xg)(()=>b.provideOriginalResource(I,P)).then(S=>S||null):Promise.resolve(null)}registerQuickDiffProvider(E,$,P,I){const b=A.a++;return this.c.set(b,$),this.b.$registerQuickDiffProvider(b,R.DocumentSelector.from(E,this.d),P,I),{dispose:()=>{this.b.$unregisterQuickDiffProvider(b),this.c.delete(b)}}}}e.$occ=A}),define(De[315],Ce([1,0,22,4,3,5,2,7,8,19,40,56,27,10]),function($e,e,D,M,h,R,A,g,E,$,P,I,b,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pbc=void 0;function C(y,r,i){const a=y.getProxy(R.$SJ.MainThreadQuickOpen);class m{constructor(v,k){this.e=new Map,this.f=0,this.a=v,this.b=k}showQuickPick(v,k,u,l=D.CancellationToken.None){this.c=void 0;const w=Promise.resolve(k),L=++this.f,N=a.$show(L,{title:u?.title,placeHolder:u?.placeHolder,matchOnDescription:u?.matchOnDescription,matchOnDetail:u?.matchOnDetail,ignoreFocusLost:u?.ignoreFocusOut,canPickMany:u?.canPickMany},l),j={},T=N.then(()=>j);return Promise.race([T,w]).then(O=>{if(O===j)return;const B=(0,b.$LF)(v,"quickPickItemTooltip");return w.then(F=>{const J=[];for(let K=0;K<F.length;K++){const me=F[K];if(typeof me=="string")J.push({label:me,handle:K});else if(me.kind===g.QuickPickItemKind.Separator)J.push({type:"separator",label:me.label});else{me.tooltip&&!B&&console.warn(`Extension '${v.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${v.identifier.value}`);const re=me.iconPath?o(me.iconPath):void 0;J.push({label:me.label,iconPath:re?.iconPath,iconClass:re?.iconClass,description:me.description,detail:me.detail,picked:me.picked,alwaysShow:me.alwaysShow,tooltip:B?S.MarkdownString.fromStrict(me.tooltip):void 0,handle:K})}}return u&&typeof u.onDidSelectItem=="function"&&(this.c=K=>{u.onDidSelectItem(F[K])}),a.$setItems(L,J),N.then(K=>{if(typeof K=="number")return F[K];if(Array.isArray(K))return K.map(me=>F[me])})})}).then(void 0,O=>{if(!(0,E.$2)(O))return a.$setError(L,O),Promise.reject(O)})}$onItemSelected(v){this.c?.(v)}showInput(v,k=D.CancellationToken.None){return this.d=v?.validateInput,a.$input(v,typeof this.d=="function",k).then(void 0,u=>{if(!(0,E.$2)(u))return Promise.reject(u)})}async $validateInput(v){if(!this.d)return;const k=await this.d(v);if(!k||typeof k=="string")return k;let u;switch(k.severity){case g.InputBoxValidationSeverity.Info:u=P.default.Info;break;case g.InputBoxValidationSeverity.Warning:u=P.default.Warning;break;case g.InputBoxValidationSeverity.Error:u=P.default.Error;break;default:u=k.message?P.default.Error:P.default.Ignore;break}return{content:k.message,severity:u}}async showWorkspaceFolderPick(v,k=D.CancellationToken.None){const u=await this.b.executeCommand("_workbench.pickWorkspaceFolder",[v]);if(!u)return;const l=await this.a.getWorkspaceFolders2();if(l)return l.find(w=>w.uri.toString()===u.uri.toString())}createQuickPick(v){const k=new n(v,()=>this.e.delete(k._id));return this.e.set(k._id,k),k}createInputBox(v){const k=new c(v,()=>this.e.delete(k._id));return this.e.set(k._id,k),k}$onDidChangeValue(v,k){this.e.get(v)?._fireDidChangeValue(k)}$onDidAccept(v){this.e.get(v)?._fireDidAccept()}$onDidChangeActive(v,k){const u=this.e.get(v);u instanceof n&&u._fireDidChangeActive(k)}$onDidChangeSelection(v,k){const u=this.e.get(v);u instanceof n&&u._fireDidChangeSelection(k)}$onDidTriggerButton(v,k){this.e.get(v)?._fireDidTriggerButton(k)}$onDidTriggerItemButton(v,k,u){const l=this.e.get(v);l instanceof n&&l._fireDidTriggerItemButton(k,u)}$onDidHide(v){this.e.get(v)?._fireDidHide()}}class p{static{this.a=1}constructor(v,k){this.x=v,this.y=k,this._id=n.a++,this.e=!1,this.f=!1,this.g=!0,this.j=!1,this.k=!0,this.l="",this.n=[],this.o=new Map,this.p=new M.$hc,this.q=new M.$hc,this.r=new M.$hc,this.s=new M.$hc,this.u={id:this._id},this.v=!1,this.w=[this.r,this.s,this.p,this.q],this.onDidChangeValue=this.q.event,this.onDidAccept=this.p.event,this.onDidTriggerButton=this.r.event,this.onDidHide=this.s.event}get title(){return this.b}set title(v){this.b=v,this.z({title:v})}get step(){return this.c}set step(v){this.c=v,this.z({step:v})}get totalSteps(){return this.d}set totalSteps(v){this.d=v,this.z({totalSteps:v})}get enabled(){return this.g}set enabled(v){this.g=v,this.z({enabled:v})}get busy(){return this.j}set busy(v){this.j=v,this.z({busy:v})}get ignoreFocusOut(){return this.k}set ignoreFocusOut(v){this.k=v,this.z({ignoreFocusOut:v})}get value(){return this.l}set value(v){this.l=v,this.z({value:v})}get placeholder(){return this.m}set placeholder(v){this.m=v,this.z({placeholder:v})}get buttons(){return this.n}set buttons(v){this.n=v.slice(),this.o.clear(),v.forEach((k,u)=>{const l=k===g.$dL.Back?-1:u;this.o.set(l,k)}),this.z({buttons:v.map((k,u)=>({...o(k.iconPath),tooltip:k.tooltip,handle:k===g.$dL.Back?-1:u}))})}show(){this.e=!0,this.f=!0,this.z({visible:!0})}hide(){this.e=!1,this.z({visible:!1})}_fireDidAccept(){this.p.fire()}_fireDidChangeValue(v){this.l=v,this.q.fire(v)}_fireDidTriggerButton(v){const k=this.o.get(v);k&&this.r.fire(k)}_fireDidHide(){this.f&&(this.f=this.e,this.s.fire())}dispose(){this.v||(this.v=!0,this._fireDidHide(),this.w=(0,h.$hb)(this.w),this.t&&(clearTimeout(this.t),this.t=void 0),this.y(),a.$dispose(this._id))}z(v){if(!this.v){for(const k of Object.keys(v)){const u=v[k];this.u[k]=u===void 0?null:u}"visible"in this.u?(this.t&&(clearTimeout(this.t),this.t=void 0),this.A()):this.e&&!this.t&&(this.t=setTimeout(()=>{this.t=void 0,this.A()},0))}}A(){a.$createOrUpdate(this.u),this.u={id:this._id}}}function f(d){if(d instanceof g.$PK)return{id:d.id};const v=s(d),k=t(d);return{dark:typeof v=="string"?A.URI.file(v):v,light:typeof k=="string"?A.URI.file(k):k}}function t(d){return typeof d=="object"&&"light"in d?d.light:d}function s(d){return typeof d=="object"&&"dark"in d?d.dark:d}function o(d){const v=f(d);let k,u;return"id"in v?u=I.ThemeIcon.asClassName(v):k=v,{iconPath:k,iconClass:u}}class n extends p{constructor(v,k){super(v.identifier,k),this.O=v,this.B=[],this.C=new Map,this.D=new Map,this.E=!1,this.F=!0,this.G=!0,this.H=!0,this.I=!1,this.J=[],this.K=new M.$hc,this.L=[],this.M=new M.$hc,this.N=new M.$hc,this.onDidChangeActive=this.K.event,this.onDidChangeSelection=this.M.event,this.onDidTriggerItemButton=this.N.event,this.w.push(this.K,this.M,this.N),this.z({type:"quickPick"})}get items(){return this.B}set items(v){this.B=v.slice(),this.C.clear(),this.D.clear(),v.forEach((l,w)=>{this.C.set(w,l),this.D.set(l,w)});const k=(0,b.$LF)(this.O,"quickPickItemTooltip"),u=[];for(let l=0;l<v.length;l++){const w=v[l];if(w.kind===g.QuickPickItemKind.Separator)u.push({type:"separator",label:w.label});else{w.tooltip&&!k&&console.warn(`Extension '${this.O.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${this.O.identifier.value}`);const L=w.iconPath?o(w.iconPath):void 0;u.push({handle:l,label:w.label,iconPath:L?.iconPath,iconClass:L?.iconClass,description:w.description,detail:w.detail,picked:w.picked,alwaysShow:w.alwaysShow,tooltip:k?S.MarkdownString.fromStrict(w.tooltip):void 0,buttons:w.buttons?.map((N,j)=>({...o(N.iconPath),tooltip:N.tooltip,handle:j}))})}}this.z({items:u})}get canSelectMany(){return this.E}set canSelectMany(v){this.E=v,this.z({canSelectMany:v})}get matchOnDescription(){return this.F}set matchOnDescription(v){this.F=v,this.z({matchOnDescription:v})}get matchOnDetail(){return this.G}set matchOnDetail(v){this.G=v,this.z({matchOnDetail:v})}get sortByLabel(){return this.H}set sortByLabel(v){this.H=v,this.z({sortByLabel:v})}get keepScrollPosition(){return this.I}set keepScrollPosition(v){this.I=v,this.z({keepScrollPosition:v})}get activeItems(){return this.J}set activeItems(v){this.J=v.filter(k=>this.D.has(k)),this.z({activeItems:this.J.map(k=>this.D.get(k))})}get selectedItems(){return this.L}set selectedItems(v){this.L=v.filter(k=>this.D.has(k)),this.z({selectedItems:this.L.map(k=>this.D.get(k))})}_fireDidChangeActive(v){const k=(0,$.$Af)(v.map(u=>this.C.get(u)));this.J=k,this.K.fire(k)}_fireDidChangeSelection(v){const k=(0,$.$Af)(v.map(u=>this.C.get(u)));this.L=k,this.M.fire(k)}_fireDidTriggerItemButton(v,k){const u=this.C.get(v);if(!u||!u.buttons||!u.buttons.length)return;const l=u.buttons[k];l&&this.N.fire({button:l,item:u})}}class c extends p{constructor(v,k){super(v.identifier,k),this.B=!1,this.z({type:"inputBox"})}get password(){return this.B}set password(v){this.B=v,this.z({password:v})}get prompt(){return this.C}set prompt(v){this.C=v,this.z({prompt:v})}get valueSelection(){return this.D}set valueSelection(v){this.D=v,this.z({valueSelection:v})}get validationMessage(){return this.E}set validationMessage(v){this.E=v,v?typeof v=="string"?this.z({validationMessage:v,severity:P.default.Error}):this.z({validationMessage:v.message,severity:v.severity??P.default.Error}):this.z({validationMessage:void 0,severity:P.default.Ignore})}}return new m(r,i)}e.$pbc=C}),define(De[316],Ce([1,0,2,4,70,3,13,5,19,125,17,25,56,10,27,16]),function($e,e,D,M,h,R,A,g,E,$,P,I,b,S,C,y){"use strict";var r;Object.defineProperty(e,"__esModule",{value:!0}),e.$rbc=e.$qbc=void 0;function i(k){if(k)return typeof k.iconPath=="string"?D.URI.file(k.iconPath):D.URI.isUri(k.iconPath)||b.ThemeIcon.isThemeIcon(k.iconPath)?k.iconPath:void 0}function a(k,u){if(!k.iconPath&&!u.iconPath)return 0;if(k.iconPath){if(!u.iconPath)return 1}else return-1;const l=typeof k.iconPath=="string"?k.iconPath:D.URI.isUri(k.iconPath)?k.iconPath.fsPath:k.iconPath.id,w=typeof u.iconPath=="string"?u.iconPath:D.URI.isUri(u.iconPath)?u.iconPath.fsPath:u.iconPath.id;return(0,$.$eq)(l,w)}function m(k,u){let l=0;if(k.strikeThrough!==u.strikeThrough)return k.strikeThrough?1:-1;if(k.faded!==u.faded)return k.faded?1:-1;if(k.tooltip!==u.tooltip)return(k.tooltip||"").localeCompare(u.tooltip||"");if(l=a(k,u),l!==0)return l;if(k.light&&u.light)l=a(k.light,u.light);else{if(k.light)return 1;if(u.light)return-1}if(l!==0)return l;if(k.dark&&u.dark)l=a(k.dark,u.dark);else{if(k.dark)return 1;if(u.dark)return-1}return l}function p(k,u){if(k.command!==u.command)return k.command<u.command?-1:1;if(k.title!==u.title)return k.title<u.title?-1:1;if(k.tooltip!==u.tooltip){if(k.tooltip!==void 0&&u.tooltip!==void 0)return k.tooltip<u.tooltip?-1:1;if(k.tooltip!==void 0)return 1;if(u.tooltip!==void 0)return-1}if(k.arguments===u.arguments)return 0;if(k.arguments)if(u.arguments){if(k.arguments.length!==u.arguments.length)return k.arguments.length-u.arguments.length}else return 1;else return-1;for(let l=0;l<k.arguments.length;l++){const w=k.arguments[l],L=u.arguments[l];if(w!==L)return w<L?-1:1}return 0}function f(k,u){let l=(0,$.$eq)(k.resourceUri.fsPath,u.resourceUri.fsPath,!0);if(l!==0)return l;if(k.command&&u.command)l=p(k.command,u.command);else{if(k.command)return 1;if(u.command)return-1}if(l!==0)return l;if(k.decorations&&u.decorations)l=m(k.decorations,u.decorations);else{if(k.decorations)return 1;if(u.decorations)return-1}return l}function t(k,u){for(let l=0;l<k.length;l++)if(k[l]!==u[l])return!1;return!0}function s(k,u){return k.command===u.command&&k.title===u.title&&k.tooltip===u.tooltip&&(k.arguments&&u.arguments?t(k.arguments,u.arguments):k.arguments===u.arguments)}function o(k,u){return(0,E.$of)(k,u,s)}class n{#e;#t;get value(){return this.d}set value(u){u=u??"",this.#e.$setInputBoxValue(this.l,u),this.n(u)}get onDidChange(){return this.e.event}get placeholder(){return this.f}set placeholder(u){this.#e.$setInputBoxPlaceholder(this.l,u),this.f=u}get validateInput(){return(0,C.$MF)(this.k,"scmValidation"),this.g}set validateInput(u){if((0,C.$MF)(this.k,"scmValidation"),u&&typeof u!="function")throw new Error(`[${this.k.identifier.value}]: Invalid SCM input box validation function`);this.g=u,this.#e.$setValidationProviderIsEnabled(this.l,!!u)}get enabled(){return this.h}set enabled(u){u=!!u,this.h!==u&&(this.h=u,this.#e.$setInputBoxEnablement(this.l,u))}get visible(){return this.j}set visible(u){u=!!u,this.j!==u&&(this.j=u,this.#e.$setInputBoxVisibility(this.l,u))}get document(){return(0,C.$MF)(this.k,"scmTextDocument"),this.#t.getDocument(this.m)}constructor(u,l,w,L,N){this.k=u,this.l=L,this.m=N,this.d="",this.e=new M.$hc,this.f="",this.h=!0,this.j=!0,this.#t=l,this.#e=w}showValidationMessage(u,l){(0,C.$MF)(this.k,"scmValidation"),this.#e.$showValidationMessage(this.l,u,l)}$onInputBoxValueChange(u){this.n(u)}n(u){this.d=u,this.e.fire(u)}}e.$qbc=n;class c{static{this.d=0}get disposed(){return this.l}get id(){return this.u}get label(){return this.v}set label(u){this.v=u,this.q.$updateGroupLabel(this.t,this.handle,u)}get hideWhenEmpty(){return this.p}set hideWhenEmpty(u){this.p=u,this.q.$updateGroup(this.t,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this.f]}set resourceStates(u){this.f=[...u],this.k.fire()}constructor(u,l,w,L,N){this.q=u,this.s=l,this.t=w,this.u=L,this.v=N,this.e=0,this.f=[],this.g=new Map,this.h=new Map,this.j=new Map,this.k=new M.$hc,this.onDidUpdateResourceStates=this.k.event,this.l=!1,this.m=new M.$hc,this.onDidDispose=this.m.event,this.n=[],this.o=[],this.p=void 0,this.handle=c.d++}getResourceState(u){return this.g.get(u)}$executeResourceCommand(u,l){const w=this.h.get(u);return w?(0,A.$xg)(()=>this.s.executeCommand(w.command,...w.arguments||[],l)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const u=[...this.f].sort(f),w=(0,E.$wf)(this.o,u,f).map(j=>{const T=j.toInsert.map(O=>{const B=this.e++;this.g.set(B,O);const F=O.resourceUri;let J;if(O.command)if(O.command.command==="vscode.open"||O.command.command==="vscode.diff"){const Q=new R.$lb;J=this.s.converter.toInternal(O.command,Q),this.j.set(B,Q)}else this.h.set(B,O.command);const K=i(O.decorations),me=O.decorations&&i(O.decorations.light)||K,re=O.decorations&&i(O.decorations.dark)||K,x=[me,re],q=O.decorations&&O.decorations.tooltip||"",ee=O.decorations&&!!O.decorations.strikeThrough,pe=O.decorations&&!!O.decorations.faded,ce=O.contextValue||"";return{rawResource:[B,F,x,q,ee,pe,ce,J],handle:B}});return{start:j.start,deleteCount:j.deleteCount,toInsert:T}}),L=w.map(({start:j,deleteCount:T,toInsert:O})=>[j,T,O.map(B=>B.rawResource)]),N=w.reverse();for(const{start:j,deleteCount:T,toInsert:O}of N){const B=O.map(J=>J.handle),F=this.n.splice(j,T,...B);for(const J of F)this.g.delete(J),this.h.delete(J),this.j.get(J)?.dispose(),this.j.delete(J)}return this.o=u,L}dispose(){this.l=!0,this.m.fire()}}class d{static{this.d=0}#e;get id(){return this.w}get label(){return this.x}get rootUri(){return this.y}get inputBox(){return this.f}get count(){return this.g}set count(u){this.g!==u&&(this.g=u,this.#e.$updateSourceControl(this.t,{count:u}))}get quickDiffProvider(){return this.h}set quickDiffProvider(u){this.h=u;let l;(0,C.$LF)(this.u,"quickDiffProvider")&&(l=u?.label),this.#e.$updateSourceControl(this.t,{hasQuickDiffProvider:!!u,quickDiffLabel:l})}get commitTemplate(){return this.j}set commitTemplate(u){u!==this.j&&(this.j=u,this.#e.$updateSourceControl(this.t,{commitTemplate:u}))}get acceptInputCommand(){return this.l}set acceptInputCommand(u){this.k.value=new R.$lb,this.l=u;const l=this.v.converter.toInternal(u,this.k.value);this.#e.$updateSourceControl(this.t,{acceptInputCommand:l})}get actionButton(){return(0,C.$MF)(this.u,"scmActionButton"),this.n}set actionButton(u){(0,C.$MF)(this.u,"scmActionButton"),this.m.value=new R.$lb,this.n=u;const l=u!==void 0?{command:this.v.converter.toInternal(u.command,this.m.value),secondaryCommands:u.secondaryCommands?.map(w=>w.map(L=>this.v.converter.toInternal(L,this.m.value))),description:u.description,enabled:u.enabled}:void 0;this.#e.$updateSourceControl(this.t,{actionButton:l??null})}get statusBarCommands(){return this.p}set statusBarCommands(u){if(this.p&&u&&o(this.p,u))return;this.o.value=new R.$lb,this.p=u;const l=(u||[]).map(w=>this.v.converter.toInternal(w,this.o.value));this.#e.$updateSourceControl(this.t,{statusBarCommands:l})}get selected(){return this.q}constructor(u,l,w,L,N,j,T){this.u=u,this.v=L,this.w=N,this.x=j,this.y=T,this.e=new Map,this.g=void 0,this.h=void 0,this.j=void 0,this.k=new R.$nb,this.l=void 0,this.m=new R.$nb,this.o=new R.$nb,this.p=void 0,this.q=!1,this.s=new M.$hc,this.onDidChangeSelection=this.s.event,this.t=d.d++,this.z=new Map,this.A=new Set,this.#e=w;const O=D.URI.from({scheme:y.Schemas.vscodeSourceControl,path:`${N}/scm${this.t}/input`,query:T?`rootUri=${encodeURIComponent(T.toString())}`:void 0});this.f=new n(u,l,this.#e,this.t,O),this.#e.$registerSourceControl(this.t,N,j,T,O)}createResourceGroup(u,l){const w=new c(this.#e,this.v,this.t,u,l),L=M.Event.once(w.onDidDispose)(()=>this.z.delete(w));return this.z.set(w,L),this.eventuallyAddResourceGroups(),w}eventuallyAddResourceGroups(){const u=[],l=[];for(const[w,L]of this.z){L.dispose();const N=w.onDidUpdateResourceStates(()=>{this.A.add(w),this.eventuallyUpdateResourceStates()});M.Event.once(w.onDidDispose)(()=>{this.A.delete(w),N.dispose(),this.e.delete(w.handle),this.#e.$unregisterGroup(this.t,w.handle)}),u.push([w.handle,w.id,w.label,w.features]);const j=w._takeResourceStateSnapshot();j.length>0&&l.push([w.handle,j]),this.e.set(w.handle,w)}this.#e.$registerGroups(this.t,u,l),this.z.clear()}eventuallyUpdateResourceStates(){const u=[];this.A.forEach(l=>{const w=l._takeResourceStateSnapshot();w.length!==0&&u.push([l.handle,w])}),u.length>0&&this.#e.$spliceResourceStates(this.t,u),this.A.clear()}getResourceGroup(u){return this.e.get(u)}setSelectionState(u){this.q=u,this.s.fire(u)}dispose(){this.k.dispose(),this.m.dispose(),this.o.dispose(),this.e.forEach(u=>u.dispose()),this.#e.$unregisterSourceControl(this.t)}}Ke([(0,h.$5g)(100)],d.prototype,"eventuallyAddResourceGroups",null),Ke([(0,h.$5g)(100)],d.prototype,"eventuallyUpdateResourceStates",null);let v=class{static{r=this}static{this.d=0}get onDidChangeActiveProvider(){return this.j.event}constructor(u,l,w,L){this.l=l,this.m=w,this.n=L,this.g=new Map,this.h=new I.$Vl,this.j=new M.$hc,this.e=u.getProxy(g.$SJ.MainThreadSCM),this.f=u.getProxy(g.$SJ.MainThreadTelemetry),l.registerArgumentProcessor({processArgument:N=>{if(N&&N.$mid===3){const j=this.g.get(N.sourceControlHandle);if(!j)return N;const T=j.getResourceGroup(N.groupHandle);return T?T.getResourceState(N.handle):N}else if(N&&N.$mid===4){const j=this.g.get(N.sourceControlHandle);return j?j.getResourceGroup(N.groupHandle):N}else if(N&&N.$mid===5){const j=this.g.get(N.handle);return j||N}return N}})}createSourceControl(u,l,w,L){this.n.trace("ExtHostSCM#createSourceControl",u.identifier.value,l,w,L),this.f.$publicLog2("api/scm/createSourceControl",{extensionId:u.identifier.value});const N=r.d++,j=new d(u,this.m,this.e,this.l,l,w,L);this.g.set(N,j);const T=this.h.get(u.identifier)||[];return T.push(j),this.h.set(u.identifier,T),j}getLastInputBox(u){this.n.trace("ExtHostSCM#getLastInputBox",u.identifier.value);const l=this.h.get(u.identifier),w=l&&l[l.length-1];return w&&w.inputBox}$provideOriginalResource(u,l,w){const L=D.URI.revive(l);this.n.trace("ExtHostSCM#$provideOriginalResource",u,L.toString());const N=this.g.get(u);return!N||!N.quickDiffProvider||!N.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,A.$xg)(()=>N.quickDiffProvider.provideOriginalResource(L,w)).then(j=>j||null)}$onInputBoxValueChange(u,l){this.n.trace("ExtHostSCM#$onInputBoxValueChange",u);const w=this.g.get(u);return w&&w.inputBox.$onInputBoxValueChange(l),Promise.resolve(void 0)}$executeResourceCommand(u,l,w,L){this.n.trace("ExtHostSCM#$executeResourceCommand",u,l,w);const N=this.g.get(u);if(!N)return Promise.resolve(void 0);const j=N.getResourceGroup(l);return j?j.$executeResourceCommand(w,L):Promise.resolve(void 0)}$validateInput(u,l,w){this.n.trace("ExtHostSCM#$validateInput",u);const L=this.g.get(u);return!L||!L.inputBox.validateInput?Promise.resolve(void 0):(0,A.$xg)(()=>L.inputBox.validateInput(l,w)).then(N=>{if(!N)return Promise.resolve(void 0);const j=S.MarkdownString.fromStrict(N.message);return j?Promise.resolve([j,N.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(u){return this.n.trace("ExtHostSCM#$setSelectedSourceControl",u),u!==void 0&&this.g.get(u)?.setSelectionState(!0),this.k!==void 0&&this.g.get(this.k)?.setSelectionState(!1),this.k=u,Promise.resolve(void 0)}};e.$rbc=v,e.$rbc=v=r=Ke([Ve(3,P.$3i)],v)}),define(De[113],Ce([1,0,5,4,6]),function($e,e,D,M,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0ac=e.$9ac=void 0;class R{constructor(g){this.b=new M.$hc,this.onDidChangePassword=this.b.event,this.a=g.getProxy(D.$SJ.MainThreadSecretState)}async $onDidChangePassword(g){this.b.fire(g)}get(g,E){return this.a.$getPassword(g,E)}store(g,E,$){return this.a.$setPassword(g,E,$)}delete(g,E){return this.a.$deletePassword(g,E)}}e.$9ac=R,e.$0ac=(0,h.$zh)("IExtHostSecretState")}),define(De[317],Ce([1,0,5,10,2]),function($e,e,D,M,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tcc=void 0;class R{static{this.a=0}constructor(g,E){this.d=E,this.c=new Map,this.b=g.getProxy(D.$SJ.MainThreadShare)}async $provideShare(g,E,$){return await this.c.get(g)?.provideShare({selection:M.Range.to(E.selection),resourceUri:h.URI.revive(E.resourceUri)},$)??void 0}registerShareProvider(g,E){const $=R.a++;return this.c.set($,E),this.b.$registerShareProvider($,M.DocumentSelector.from(g,this.d),E.id,E.label,E.priority),{dispose:()=>{this.b.$unregisterShareProvider($),this.c.delete($)}}}}e.$tcc=R}),define(De[318],Ce([1,0,7,5,204,3,10,18]),function($e,e,D,M,h,R,A,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tbc=e.$sbc=void 0;class E{static{this.a=0}static{this.b=new Map([["statusBarItem.errorBackground",new D.$QK("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new D.$QK("statusBarItem.warningForeground")]])}#e;#t;constructor(b,S,C,y,r,i=D.StatusBarAlignment.Left,a){if(this.i=!1,this.k="",this.q=new R.$lb,this.#e=b,this.#t=S,r&&y){this.c=(0,D.$tK)(y.identifier,r);const m=C.get(this.c);m&&(i=m.alignLeft?D.StatusBarAlignment.Left:D.StatusBarAlignment.Right,a=m.priority,this.j=!0,this.name=m.name,this.text=m.text,this.tooltip=m.tooltip,this.command=m.command,this.accessibilityInformation=m.accessibilityInformation)}else this.c=String(E.a++);this.e=y,this.f=r,this.g=i,this.h=this.u(a)}u(b){if((0,g.$pe)(b))return b===Number.POSITIVE_INFINITY?Number.MAX_VALUE:b===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:b}get id(){return this.f??this.e.identifier.value}get alignment(){return this.g}get priority(){return this.h}get text(){return this.k}get name(){return this.m}get tooltip(){return this.l}get color(){return this.n}get backgroundColor(){return this.o}get command(){return this.r?.fromApi}get accessibilityInformation(){return this.t}set text(b){this.k=b,this.v()}set name(b){this.m=b,this.v()}set tooltip(b){this.l=b,this.v()}set color(b){this.n=b,this.v()}set backgroundColor(b){b&&!E.b.has(b.id)&&(b=void 0),this.o=b,this.v()}set command(b){this.r?.fromApi!==b&&(this.p&&this.q.add(this.p),this.p=new R.$lb,typeof b=="string"?this.r={fromApi:b,internal:this.#t.toInternal({title:"",command:b},this.p)}:b?this.r={fromApi:b,internal:this.#t.toInternal(b,this.p)}:this.r=void 0,this.v())}set accessibilityInformation(b){this.t=b,this.v()}show(){this.j=!0,this.v()}hide(){clearTimeout(this.s),this.j=!1,this.#e.$disposeEntry(this.c)}v(){this.i||!this.j||(clearTimeout(this.s),this.s=setTimeout(()=>{this.s=void 0;let b;this.e?this.f?b=`${this.e.identifier.value}.${this.f}`:b=this.e.identifier.value:b=this.f;let S;this.m?S=this.m:S=(0,h.localize)(0,null,this.e.displayName||this.e.name);let C=this.n;this.o&&(C=E.b.get(this.o.id));const y=A.MarkdownString.fromStrict(this.l);this.#e.$setEntry(this.c,b,this.e?.identifier.value,S,this.k,y,this.r?.internal,C,this.o,this.g===D.StatusBarAlignment.Left,this.h,this.t),this.q.clear()},0))}dispose(){this.hide(),this.i=!0}}e.$sbc=E;class ${constructor(b){this.b=[],this.a=b.createStatusBarEntry(void 0,"status.extensionMessage",D.StatusBarAlignment.Left,Number.MIN_VALUE),this.a.name=(0,h.localize)(1,null)}dispose(){this.b.length=0,this.a.dispose()}setMessage(b){const S={message:b};return this.b.unshift(S),this.c(),new D.$UJ(()=>{const C=this.b.indexOf(S);C>=0&&(this.b.splice(C,1),this.c())})}c(){this.b.length>0?(this.a.text=this.b[0].message,this.a.show()):this.a.hide()}}class P{constructor(b,S){this.e=new Map,this.a=b.getProxy(M.$SJ.MainThreadStatusBar),this.b=S,this.c=new $(this)}$acceptStaticEntries(b){for(const S of b)this.e.set(S.entryId,S)}createStatusBarEntry(b,S,C,y){return new E(this.a,this.b,this.e,b,S,C,y)}setStatusBarMessage(b,S){const C=this.c.setMessage(b);let y;return typeof S=="number"?y=setTimeout(()=>C.dispose(),S):typeof S<"u"&&S.then(()=>C.dispose(),()=>C.dispose()),new D.$UJ(()=>{C.dispose(),clearTimeout(y)})}}e.$tbc=P}),define(De[114],Ce([1,0,5,4,6]),function($e,e,D,M,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xac=e.$Wac=void 0;class R{constructor(g,E){this.c=E,this.b=new M.$hc,this.onDidChangeStorage=this.b.event,this.a=g.getProxy(D.$SJ.MainThreadStorage)}registerExtensionStorageKeysToSync(g,E){this.a.$registerExtensionStorageKeysToSync(g,E)}async initializeExtensionStorage(g,E,$){const P=await this.a.$initializeExtensionStorage(g,E);let I;return P&&(I=this.d(g,E,P)),I||$}setValue(g,E,$){return this.a.$setValue(g,E,$)}$acceptValue(g,E,$){const P=this.d(g,E,$);P&&this.b.fire({shared:g,key:E,value:P})}d(g,E,$){try{return JSON.parse($)}catch(P){this.c.error(`[extHostStorage] unexpected error parsing storage contents (extensionId: ${E}, global: ${g}): ${P}`)}}}e.$Wac=R,e.$Xac=(0,h.$zh)("IExtHostStorage")}),define(De[90],Ce([1,0,6,26,17,67,2]),function($e,e,D,M,h,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4ac=e.$3ac=void 0,e.$3ac=(0,D.$zh)("IExtensionStoragePaths");let g=class{constructor($,P,I){this.d=P,this.f=I,this.a=$.workspace??void 0,this.b=$.environment,this.whenReady=this.h().then(b=>this.c=b)}async g($){return A.URI.joinPath(this.b.workspaceStorageHome,$)}async h(){if(!this.a)return Promise.resolve(void 0);const $=this.a.id,P=await this.g($);try{return await this.f.value.stat(P),this.d.trace("[ExtHostStorage] storage dir already exists",P),P}catch{}try{return this.d.trace("[ExtHostStorage] creating dir and metadata-file",P),await this.f.value.createDirectory(P),await this.f.value.writeFile(A.URI.joinPath(P,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this.a.id,configuration:A.URI.revive(this.a.configuration)?.toString(),name:this.a.name},void 0,2))),P}catch(I){this.d.error("[ExtHostStorage]",I);return}}workspaceValue($){if(this.c)return A.URI.joinPath(this.c,$.identifier.value)}globalValue($){return A.URI.joinPath(this.b.globalStorageHome,$.identifier.value.toLowerCase())}onWillDeactivateAll(){}};e.$4ac=g,e.$4ac=g=Ke([Ve(0,M.$$L),Ve(1,h.$3i),Ve(2,R.$2ac)],g)}),define(De[42],Ce([1,0,4,5,6,2,20,3,7,206,8,247,22,31,248,56,13,10,33]),function($e,e,D,M,h,R,A,g,E,$,P,I,b,S,C,y,r,i,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8ac=e.$7ac=e.$6ac=e.$5ac=void 0,e.$5ac=(0,h.$zh)("IExtHostTerminalService");class m{constructor(u,l,w,L){this.k=u,this._id=l,this.l=w,this.m=L,this.a=!1,this.i={isInteractedWith:!1},this.isOpen=!1,this.l=Object.freeze(this.l),this.b=new Promise(j=>this.f=j);const N=this;this.value={get name(){return N.m||""},get processId(){return N.b},get creationOptions(){return N.l},get exitStatus(){return N.h},get state(){return N.i},get selection(){return N.j},sendText(j,T=!0){N.o(),N.k.$sendText(N._id,j,T)},show(j){N.o(),N.k.$show(N._id,j)},hide(){N.o(),N.k.$hide(N._id)},dispose(){N.a||(N.a=!0,N.k.$dispose(N._id))},get dimensions(){if(!(N.d===void 0||N.g===void 0))return{columns:N.d,rows:N.g}}}}async create(u,l){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this.k.$createTerminal(this._id,{name:u.name,shellPath:u.shellPath??void 0,shellArgs:u.shellArgs??void 0,cwd:u.cwd??void 0,env:u.env??void 0,icon:c(u.iconPath)??void 0,color:y.ThemeColor.isThemeColor(u.color)?u.color.id:void 0,initialText:u.message??void 0,strictEnv:u.strictEnv??void 0,hideFromUser:u.hideFromUser??void 0,isFeatureTerminal:l?.isFeatureTerminal??void 0,isExtensionOwnedTerminal:!0,useShellEnvironment:l?.useShellEnvironment??void 0,location:l?.location||this.n(u.location,l?.resolvedExtHostIdentifier),isTransient:u.isTransient??void 0})}async createExtensionTerminal(u,l,w,L){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this.k.$createTerminal(this._id,{name:this.m,isExtensionCustomPtyTerminal:!0,icon:w,color:y.ThemeColor.isThemeColor(L)?L.id:void 0,location:this.n(u,l),isTransient:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}n(u,l){return typeof u=="object"?"parentTerminal"in u&&u.parentTerminal&&l?{parentTerminal:l}:"viewColumn"in u?{viewColumn:i.ViewColumn.from(u.viewColumn),preserveFocus:u.preserveFocus}:void 0:u}o(){if(this.a)throw new Error("Terminal has already been disposed")}set name(u){this.m=u}setExitStatus(u,l){this.h=Object.freeze({code:u,reason:l})}setDimensions(u,l){return u===this.d&&l===this.g||u===0||l===0?!1:(this.d=u,this.g=l,!0)}setInteractedWith(){return this.i.isInteractedWith?!1:(this.i={isInteractedWith:!0},!0)}setSelection(u){this.j=u}_setProcessId(u){this.f?(this.f(u),this.f=void 0):this.b.then(l=>{l!==u&&(this.b=Promise.resolve(u))})}}e.$6ac=m;class p{get onProcessReady(){return this.b.event}constructor(u){this.g=u,this.id=0,this.shouldPersist=!1,this.a=new D.$hc,this.onProcessData=this.a.event,this.b=new D.$hc,this.d=new D.$hc,this.onDidChangeProperty=this.d.event,this.f=new D.$hc,this.onProcessExit=this.f.event}refreshProperty(u){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${u}`)}updateProperty(u,l){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${u}, value: ${l}`)}async start(){}shutdown(){this.g.close()}input(u){this.g.handleInput?.(u)}resize(u,l){this.g.setDimensions?.({columns:u,rows:l})}clearBuffer(){}async processBinary(u){}acknowledgeDataEvent(u){}async setUnicodeVersion(u){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}startSendingEvents(u){this.g.onDidWrite(l=>this.a.fire(l)),this.g.onDidClose?.((l=void 0)=>{this.f.fire(l===void 0?void 0:l)}),this.g.onDidOverrideDimensions?.(l=>{l&&this.d.fire({type:"overrideDimensions",value:{cols:l.columns,rows:l.rows}})}),this.g.onDidChangeName?.(l=>{this.d.fire({type:"title",value:l})}),this.g.open(u||void 0),u&&this.g.setDimensions?.(u),this.b.fire({pid:-1,cwd:"",windowsPty:void 0})}}let f=1,t=class extends g.$mb{get activeTerminal(){return this.b?.value}get terminals(){return this.f.map(u=>u.value)}constructor(u,l,w){super(),this.M=l,this.f=[],this.g=new Map,this.h={},this.i={},this.j={},this.k=new Map,this.n=this.B(new g.$nb),this.u=new Set,this.v=new Map,this.w=new Map,this.y=new Map,this.z=new Map,this.C=new D.$hc,this.onDidCloseTerminal=this.C.event,this.D=new D.$hc,this.onDidOpenTerminal=this.D.event,this.F=new D.$hc,this.onDidChangeActiveTerminal=this.F.event,this.G=new D.$hc,this.onDidChangeTerminalDimensions=this.G.event,this.H=new D.$hc,this.onDidChangeTerminalState=this.H.event,this.I=new D.$hc,this.onDidChangeShell=this.I.event,this.J=new D.$hc({onWillAddFirstListener:()=>this.a.$startSendingDataEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingDataEvents()}),this.onDidWriteTerminalData=this.J.event,this.L=new D.$hc({onWillAddFirstListener:()=>this.a.$startSendingCommandEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingCommandEvents()}),this.onDidExecuteTerminalCommand=this.L.event,this.a=w.getProxy(M.$SJ.MainThreadTerminalService),this.s=new C.$tkb(this.a.$sendProcessData),this.a.$registerProcessSupport(u),this.B({dispose:()=>{for(const[L,N]of this.g)N.shutdown(!0)}})}getDefaultShell(u){return(u?this.m:this.l)?.path||""}getDefaultShellArgs(u){return(u?this.m:this.l)?.args||[]}createExtensionTerminal(u,l){const w=new m(this.a,(0,S.$6e)(),u,u.name),L=new p(u.pty);return w.createExtensionTerminal(u.location,this.N(u,l).resolvedExtHostIdentifier,c(u.iconPath),d(u.color)).then(N=>{const j=this.O(N,L);this.h[N]=j}),this.f.push(w),w.value}N(u,l){if(l=l||{},u.location&&typeof u.location=="object"&&"parentTerminal"in u.location){const w=u.location.parentTerminal;if(w){const L=this.f.find(N=>N.value===w);L&&(l.resolvedExtHostIdentifier=L._id)}}else u.location&&typeof u.location!="object"?l.location=u.location:l.location&&typeof l.location=="object"&&"splitActiveTerminal"in l.location&&(l.location={splitActiveTerminal:!0});return l}attachPtyToTerminal(u,l){if(!this.Q(u))throw new Error(`Cannot resolve terminal with id ${u} for virtual process`);const L=new p(l),N=this.O(u,L);this.h[u]=N}async $acceptActiveTerminalChanged(u){const l=this.b;if(u===null){this.b=void 0,l!==this.b&&this.F.fire(this.b);return}const w=this.Q(u);w&&(this.b=w,l!==this.b&&this.F.fire(this.b.value))}async $acceptTerminalProcessData(u,l){const w=this.Q(u);w&&this.J.fire({terminal:w.value,data:l})}async $acceptTerminalDimensions(u,l,w){const L=this.Q(u);L&&L.setDimensions(l,w)&&this.G.fire({terminal:L.value,dimensions:L.value.dimensions})}async $acceptDidExecuteCommand(u,l){const w=this.Q(u);w&&this.L.fire({terminal:w.value,...l})}async $acceptTerminalMaximumDimensions(u,l,w){this.g.get(u)?.resize(l,w)}async $acceptTerminalTitleChange(u,l){const w=this.Q(u);w&&(w.name=l)}async $acceptTerminalClosed(u,l,w){const L=this.S(this.f,u);if(L!==null){const N=this.f.splice(L,1)[0];N.setExitStatus(l,w),this.C.fire(N.value)}}$acceptTerminalOpened(u,l,w,L){if(l){const T=this.S(this.f,l);if(T!==null){this.f[T]._id=u,this.D.fire(this.terminals[T]),this.f[T].isOpen=!0;return}}const N={name:L.name,shellPath:L.executable,shellArgs:L.args,cwd:typeof L.cwd=="string"?L.cwd:R.URI.revive(L.cwd),env:L.env,hideFromUser:L.hideFromUser},j=new m(this.a,u,N,w);this.f.push(j),this.D.fire(j.value),j.isOpen=!0}async $acceptTerminalProcessId(u,l){this.Q(u)?._setProcessId(l)}async $startExtensionTerminal(u,l){const w=this.Q(u);if(!w)return{message:(0,$.localize)(0,null,u)};w.isOpen||await new Promise(N=>{const j=this.onDidOpenTerminal(async T=>{T===w.value&&(j.dispose(),N())})});const L=this.g.get(u);L?L.startSendingEvents(l):this.i[u]={initialDimensions:l}}O(u,l){const w=new g.$lb;w.add(l.onProcessReady(N=>this.a.$sendProcessReady(u,N.pid,N.cwd,N.windowsPty))),w.add(l.onDidChangeProperty(N=>this.a.$sendProcessProperty(u,N))),this.s.startBuffering(u,l.onProcessData),w.add(l.onProcessExit(N=>this.P(u,N))),this.g.set(u,l);const L=this.i[u];return L&&l instanceof p&&(l.startSendingEvents(L.initialDimensions),delete this.i[u]),w}$acceptProcessAckDataEvent(u,l){this.g.get(u)?.acknowledgeDataEvent(l)}$acceptProcessInput(u,l){this.g.get(u)?.input(l)}$acceptTerminalInteraction(u){const l=this.Q(u);l?.setInteractedWith()&&this.H.fire(l.value)}$acceptTerminalSelection(u,l){this.Q(u)?.setSelection(l)}$acceptProcessResize(u,l,w){try{this.g.get(u)?.resize(l,w)}catch(L){if(L.code!=="EPIPE"&&L.code!=="ERR_IPC_CHANNEL_CLOSED")throw L}}$acceptProcessShutdown(u,l){this.g.get(u)?.shutdown(l)}$acceptProcessRequestInitialCwd(u){this.g.get(u)?.getInitialCwd().then(l=>this.a.$sendProcessProperty(u,{type:"initialCwd",value:l}))}$acceptProcessRequestCwd(u){this.g.get(u)?.getCwd().then(l=>this.a.$sendProcessProperty(u,{type:"cwd",value:l}))}$acceptProcessRequestLatency(u){return Promise.resolve(u)}registerLinkProvider(u){return this.u.add(u),this.u.size===1&&this.a.$startLinkProvider(),new E.$UJ(()=>{this.u.delete(u),this.u.size===0&&this.a.$stopLinkProvider()})}registerProfileProvider(u,l,w){if(this.v.has(l))throw new Error(`Terminal profile provider "${l}" already registered`);return this.v.set(l,w),this.a.$registerProfileProvider(l,u.identifier.value),new E.$UJ(()=>{this.v.delete(l),this.a.$unregisterProfileProvider(l)})}registerTerminalQuickFixProvider(u,l,w){if(this.w.has(u))throw new Error(`Terminal quick fix provider "${u}" is already registered`);return this.w.set(u,w),this.a.$registerQuickFixProvider(u,l),new E.$UJ(()=>{this.w.delete(u),this.a.$unregisterQuickFixProvider(u)})}async $provideTerminalQuickFixes(u,l){const w=new b.$rc().token;if(w.isCancellationRequested)return;const L=this.w.get(u);if(!L)return;const N=await L.provideTerminalQuickFixes(l,w);if(N===null||Array.isArray(N)&&N.length===0)return;const j=new g.$lb;if(this.n.value=j,!Array.isArray(N))return N?i.TerminalQuickFix.from(N,this.M.converter,j):void 0;const T=[];for(const O of N){const B=i.TerminalQuickFix.from(O,this.M.converter,j);B&&T.push(B)}return T}async $createContributedProfileTerminal(u,l){const w=new b.$rc().token;let L=await this.v.get(u)?.provideTerminalProfile(w);if(!w.isCancellationRequested){if(L&&!("options"in L)&&(L={options:L}),!L||!("options"in L))throw new Error(`No terminal profile options provided for id "${u}"`);if("pty"in L.options){this.createExtensionTerminal(L.options,l);return}this.createTerminalFromOptions(L.options,l)}}async $provideLinks(u,l){const w=this.Q(u);if(!w)return[];this.y.delete(u),this.z.get(u)?.dispose(!0);const N=new b.$rc;this.z.set(u,N);const j=[],T={terminal:w.value,line:l},O=[];for(const J of this.u)O.push(r.Promises.withAsyncBody(async K=>{N.token.onCancellationRequested(()=>K({provider:J,links:[]}));const me=await J.provideTerminalLinks(T,N.token)||[];N.token.isCancellationRequested||K({provider:J,links:me})}));const B=await Promise.all(O);if(N.token.isCancellationRequested)return[];const F=new Map;for(const J of B)J&&J.links.length>0&&j.push(...J.links.map(K=>{const me={id:f++,startIndex:K.startIndex,length:K.length,label:K.tooltip};return F.set(me.id,{provider:J.provider,link:K}),me}));return this.y.set(u,F),j}$activateLink(u,l){const w=this.y.get(u)?.get(l);w&&w.provider.handleTerminalLink(w.link)}P(u,l){this.s.stopBuffering(u),this.g.delete(u),delete this.i[u];const w=this.h[u];w&&(w.dispose(),delete this.h[u]),this.a.$sendProcessExit(u,l)}Q(u){return this.R(this.f,u)}R(u,l){const w=this.S(u,l);return w!==null?u[w]:null}S(u,l){const w=u.findIndex(L=>L._id===l);return w===-1?null:w}getEnvironmentVariableCollection(u){let l=this.k.get(u.identifier.value);return l||(l=new s,this.W(u.identifier.value,l)),l.getScopedEnvironmentVariableCollection(void 0)}U(u,l){const w=(0,I.$0q)(l.map),L=(0,I.$$q)(l.descriptionMap);this.a.$setEnvironmentVariableCollection(u,l.persistent,w.length===0?void 0:w,L)}$initEnvironmentVariableCollections(u){u.forEach(l=>{const w=l[0],L=new s(l[1]);this.W(w,L)})}$acceptDefaultProfile(u,l){const w=this.l;this.l=u,this.m=l,w?.path!==u.path&&this.I.fire(u.path)}W(u,l){this.k.set(u,l),l.onDidChangeCollection(()=>{this.U(u,l)})}};e.$7ac=t,e.$7ac=t=Ke([Ve(1,a.$eM),Ve(2,A.$UL)],t);class s{get persistent(){return this.b}set persistent(u){this.b=u,this.d.fire()}get onDidChangeCollection(){return this.d&&this.d.event}constructor(u){this.map=new Map,this.a=new Map,this.descriptionMap=new Map,this.b=!0,this.d=new D.$hc,this.map=new Map(u)}getScopedEnvironmentVariableCollection(u){const l=this.h(u);let w=this.a.get(l);return w||(w=new o(this,u),this.a.set(l,w),w.onDidChangeCollection(()=>this.d.fire())),w}replace(u,l,w,L){this.f(u,{value:l,type:E.EnvironmentVariableMutatorType.Replace,options:w??{applyAtProcessCreation:!0},scope:L})}append(u,l,w,L){this.f(u,{value:l,type:E.EnvironmentVariableMutatorType.Append,options:w??{applyAtProcessCreation:!0},scope:L})}prepend(u,l,w,L){this.f(u,{value:l,type:E.EnvironmentVariableMutatorType.Prepend,options:w??{applyAtProcessCreation:!0},scope:L})}f(u,l){if(l.options&&l.options.applyAtProcessCreation===!1&&!l.options.applyAtShellIntegration)throw new Error("EnvironmentVariableMutatorOptions must apply at either process creation or shell integration");const w=this.g(u,l.scope),L=this.map.get(w),N=l.options?{applyAtProcessCreation:l.options.applyAtProcessCreation??!1,applyAtShellIntegration:l.options.applyAtShellIntegration??!1}:{applyAtProcessCreation:!0};if(!L||L.value!==l.value||L.type!==l.type||L.options?.applyAtProcessCreation!==N.applyAtProcessCreation||L.options?.applyAtShellIntegration!==N.applyAtShellIntegration||L.scope?.workspaceFolder?.index!==l.scope?.workspaceFolder?.index){const j=this.g(u,l.scope),T={variable:u,...l,options:N};this.map.set(j,T),this.d.fire()}}get(u,l){const w=this.g(u,l),L=this.map.get(w);return L?v(L):void 0}g(u,l){const w=this.h(l);return w.length?`${u}:::${w}`:u}h(u){return this.i(u?.workspaceFolder)??""}i(u){return u?u.uri.toString():void 0}getVariableMap(u){const l=new Map;for(const[w,L]of this.map)this.h(L.scope)===this.h(u)&&l.set(L.variable,v(L));return l}delete(u,l){const w=this.g(u,l);this.map.delete(w),this.d.fire()}clear(u){if(u?.workspaceFolder){for(const[l,w]of this.map)w.scope?.workspaceFolder?.index===u.workspaceFolder.index&&this.map.delete(l);this.j(u)}else this.map.clear(),this.descriptionMap.clear();this.d.fire()}setDescription(u,l){const w=this.h(l),L=this.descriptionMap.get(w);if(!L||L.description!==u){let N;typeof u=="string"?N=u:N=u?.value.split(`

`)[0];const j={description:N,scope:l};this.descriptionMap.set(w,j),this.d.fire()}}getDescription(u){const l=this.h(u);return this.descriptionMap.get(l)?.description}j(u){const l=this.h(u);this.descriptionMap.delete(l)}}class o{get persistent(){return this.b.persistent}set persistent(u){this.b.persistent=u}get onDidChangeCollection(){return this.a&&this.a.event}constructor(u,l){this.b=u,this.d=l,this.a=new D.$hc}getScoped(u){return this.b.getScopedEnvironmentVariableCollection(u)}replace(u,l,w){this.b.replace(u,l,w,this.d)}append(u,l,w){this.b.append(u,l,w,this.d)}prepend(u,l,w){this.b.prepend(u,l,w,this.d)}get(u){return this.b.get(u,this.d)}forEach(u,l){this.b.getVariableMap(this.d).forEach((w,L)=>u.call(l,L,w,this),this.d)}[Symbol.iterator](){return this.b.getVariableMap(this.d).entries()}delete(u){this.b.delete(u,this.d),this.a.fire(void 0)}clear(){this.b.clear(this.d)}set description(u){this.b.setDescription(u,this.d)}get description(){return this.b.getDescription(this.d)}}let n=class extends t{constructor(u,l){super(!1,u,l)}createTerminal(u,l,w){throw new P.$0}createTerminalFromOptions(u,l){throw new P.$0}};e.$8ac=n,e.$8ac=n=Ke([Ve(0,a.$eM),Ve(1,A.$UL)],n);function c(k){if(!(!k||typeof k=="string"))return"id"in k?{id:k.id,color:k.color}:k}function d(k){return y.ThemeColor.isThemeColor(k)?k:void 0}function v(k){const u={...k};return delete u.scope,u.options=u.options??void 0,delete u.variable,u}}),define(De[319],Ce([1,0,117,13,21,22,4,71,74,3,23,18,31,5,20,144,10,7,63,108,87,27]),function($e,e,D,M,h,R,A,g,E,$,P,I,b,S,C,y,r,i,a,m,p,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fcc=e.$ecc=e.$dcc=e.$ccc=void 0;let t=class{constructor(T,O,B){this.k=B,this.d=new A.$hc,this.f=new Map,this.onResultsChanged=this.d.event,this.results=[],this.g=T.getProxy(S.$SJ.MainThreadTesting),this.j=new w(this.g),this.h=new c(this.g),O.registerArgumentProcessor({processArgument:F=>{switch(F?.$mid){case 15:{const J=F,K=J.tests[J.tests.length-1].item.extId;return this.f.get(a.$FI.root(K))?.collection.tree.get(K)?.actual??(0,y.$7L)(F)}case 17:{const{extId:J,message:K}=F;return{test:this.f.get(a.$FI.root(J))?.collection.tree.get(J)?.actual,message:r.TestMessage.to(K)}}default:return F}}}),O.registerCommand(!1,"testing.getExplorerSelection",async()=>{const F=await O.executeCommand("_testing.getExplorerSelection"),J=K=>{const me=this.f.get(a.$FI.root(K));if(me)return a.$FI.isRoot(K)?me.controller:me.collection.tree.get(K)?.actual};return{include:F?.include.map(J).filter(I.$te)||[],exclude:F?.exclude.map(J).filter(I.$te)||[]}})}createTestController(T,O,B,F){if(this.f.has(O))throw new Error(`Attempt to insert a duplicate controller with ID "${O}"`);const J=new $.$lb,K=J.add(new y.$0L(O,B,this.k));K.root.label=B;const me=new Map,re=this.g,x={items:K.root.children,get label(){return B},set label(ee){B=ee,K.root.label=ee,re.$updateController(O,{label:B})},get refreshHandler(){return F},set refreshHandler(ee){F=ee,re.$updateController(O,{canRefresh:!!ee})},get id(){return O},createRunProfile:(ee,pe,ce,_,Q,z)=>{let V=(0,E.$ni)(ee);for(;me.has(V);)V++;return new L(this.g,me,O,V,ee,pe,ce,_,Q,z)},createTestItem(ee,pe,ce){return new y.$8L(O,ee,pe,ce)},createTestRun:(ee,pe,ce=!0)=>this.h.createTestRun(T,O,K,ee,pe,ce),invalidateTestResults:ee=>{if(ee===void 0)this.g.$markTestRetired(void 0);else{const pe=ee instanceof Array?ee:[ee];this.g.$markTestRetired(pe.map(ce=>a.$FI.fromExtHostTestItem(ce,O).toString()))}},set resolveHandler(ee){K.resolveHandler=ee},get resolveHandler(){return K.resolveHandler},dispose:()=>{J.dispose()}};re.$registerTestController(O,B,!!F),J.add((0,$.$kb)(()=>re.$unregisterTestController(O)));const q={controller:x,collection:K,profiles:me,extension:T};return this.f.set(O,q),J.add((0,$.$kb)(()=>this.f.delete(O))),J.add(K.onDidGenerateDiff(ee=>re.$publishDiff(O,ee.map(p.TestsDiffOp.serialize)))),x}createTestObserver(){return this.j.checkout()}async runTests(T,O=R.CancellationToken.None){const B=d(T);if(!B)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const F=this.f.get(B.controllerId);if(!F)throw new Error("Controller not found");await this.g.$runTests({isUiTriggered:!1,targets:[{testIds:T.include?.map(J=>a.$FI.fromExtHostTestItem(J,F.collection.root.id).toString())??[F.collection.root.id],profileGroup:N[B.kind],profileId:B.profileId,controllerId:B.controllerId}],exclude:T.exclude?.map(J=>J.id)},O)}$syncTests(){for(const{collection:T}of this.f.values())T.flushDiff();return Promise.resolve()}$provideFileCoverage(T,O,B){return(0,D.$lf)(this.h.trackers,J=>J.id===T?J.getCoverage(O):void 0)?.provideFileCoverage(B)??Promise.resolve([])}$resolveFileCoverage(T,O,B,F){return(0,D.$lf)(this.h.trackers,K=>K.id===T?K.getCoverage(O):void 0)?.resolveFileCoverage(B,F)??Promise.resolve([])}$configureRunProfile(T,O){this.f.get(T)?.profiles.get(O)?.configureHandler?.()}async $refreshTests(T,O){await this.f.get(T)?.controller.refreshHandler?.(O)}$publishTestResults(T){this.results=Object.freeze(T.map(O=>(0,P.$Um)(r.TestResults.to(O))).concat(this.results).sort((O,B)=>B.completedAt-O.completedAt).slice(0,32)),this.d.fire()}async $expandTest(T,O){const B=this.f.get(a.$FI.fromString(T).controllerId)?.collection;B&&(await B.expand(T,O<0?1/0:O),B.flushDiff())}$acceptDiff(T){this.j.applyDiff(T.map(p.TestsDiffOp.deserialize))}async $runControllerTests(T,O){return Promise.all(T.map(B=>this.l(B,!1,O)))}async $startContinuousRun(T,O){const B=new R.$rc(O),F=await Promise.all(T.map(J=>this.l(J,!0,B.token)));return!O.isCancellationRequested&&!F.some(J=>J.error)&&await new Promise(J=>O.onCancellationRequested(J)),B.dispose(!0),F}async l(T,O,B){const F=this.f.get(T.controllerId);if(!F)return{};const{collection:J,profiles:K,extension:me}=F,re=K.get(T.profileId);if(!re)return{};const x=T.testIds.map(ce=>J.tree.get(ce)).filter(I.$te),q=T.excludeExtIds.map(ce=>F.collection.tree.get(ce)).filter(I.$te).filter(ce=>x.some(_=>_.fullId.compare(ce.fullId)===2));if(!x.length)return{};const ee=new i.$rL(x.some(ce=>ce.actual instanceof y.$9L)?void 0:x.map(ce=>ce.actual),q.map(ce=>ce.actual),re,O),pe=(0,p.$HI)(T)&&this.h.prepareForMainThreadTestRun(ee,v.fromInternal(T,F.collection),me,B);try{return await re.runHandler(ee,B),{}}catch(ce){return{error:String(ce)}}finally{pe&&(pe.hasRunningTasks&&!B.isCancellationRequested&&await A.Event.toPromise(pe.onEnd),pe.dispose())}}$cancelExtensionTestRun(T){T===void 0?this.h.cancelAllRuns():this.h.cancelRunById(T)}};e.$ccc=t,e.$ccc=t=Ke([Ve(0,C.$UL)],t);const s=1e4;var o;(function(j){j[j.Running=0]="Running",j[j.Cancelling=1]="Cancelling",j[j.Ended=2]="Ended"})(o||(o={}));class n extends $.$mb{get hasRunningTasks(){return this.g.size>0}get id(){return this.l.id}constructor(T,O,B,F){super(),this.l=T,this.m=O,this.p=B,this.f=0,this.g=new Map,this.h=new Set,this.k=this.B(new A.$hc),this.onEnd=this.k.event,this.j=this.B(new R.$rc(F));const J=this.B(new M.$Qg(()=>this.s(),s));this.B(this.j.token.onCancellationRequested(()=>J.schedule()))}cancel(){this.f===0?(this.j.cancel(),this.f=1):this.f===1&&this.s()}getCoverage(T){return this.g.get(T)?.coverage}createRun(T){const O=this.l.id,B=this.l.controllerId,F=(0,b.$6e)(),J=new k(this.m,O,F),K=q=>(ee,...pe)=>{if(re){console.warn(`Setting the state of test "${ee.id}" is a no-op after the run ends.`);return}this.l.isIncluded(ee)&&(this.v(ee),q(ee,...pe))},me=(q,ee)=>{const pe=ee instanceof Array?ee.map(r.TestMessage.from):[r.TestMessage.from(ee)];if(pe.some(ce=>ce.contextValue!==void 0)&&(0,f.$MF)(this.p,"testMessageContextValue"),q.uri&&q.range){const ce={range:r.Range.from(q.range),uri:q.uri};for(const _ of pe)_.location=_.location||ce}this.m.$appendTestMessagesInRun(O,F,a.$FI.fromExtHostTestItem(q,B).toString(),pe)};let re=!1;const x={isPersisted:this.l.isPersisted,token:this.j.token,name:T,get coverageProvider(){return J.coverageProvider},set coverageProvider(q){J.coverageProvider=q},enqueued:K(q=>{this.m.$updateTestStateInRun(O,F,a.$FI.fromExtHostTestItem(q,B).toString(),1)}),skipped:K(q=>{this.m.$updateTestStateInRun(O,F,a.$FI.fromExtHostTestItem(q,B).toString(),5)}),started:K(q=>{this.m.$updateTestStateInRun(O,F,a.$FI.fromExtHostTestItem(q,B).toString(),2)}),errored:K((q,ee,pe)=>{me(q,ee),this.m.$updateTestStateInRun(O,F,a.$FI.fromExtHostTestItem(q,B).toString(),6,pe)}),failed:K((q,ee,pe)=>{me(q,ee),this.m.$updateTestStateInRun(O,F,a.$FI.fromExtHostTestItem(q,B).toString(),4,pe)}),passed:K((q,ee)=>{this.m.$updateTestStateInRun(O,F,a.$FI.fromExtHostTestItem(q,this.l.controllerId).toString(),3,ee)}),appendOutput:(q,ee,pe)=>{re||(pe&&(this.l.isIncluded(pe)?this.v(pe):pe=void 0),this.m.$appendOutputToRun(O,F,h.$Hc.fromString(q),ee&&r.location.from(ee),pe&&a.$FI.fromExtHostTestItem(pe,B).toString()))},end:()=>{re||(re=!0,this.m.$finishedTestRunTask(O,F),this.g.delete(F),this.g.size||this.u())}};return this.g.set(F,{run:x,coverage:J}),this.m.$startedTestRunTask(O,{id:F,name:T,running:!0}),x}s(){for(const{run:T}of this.g.values())T.end()}u(){this.f!==2&&(this.f=2,this.k.fire())}v(T){if(!(T instanceof y.$8L))throw new m.$ML(T.id);if(this.h.has(a.$FI.fromExtHostTestItem(T,this.l.controllerId).toString()))return;const O=[],B=this.l.colllection.root;for(;;){const F=r.TestItem.from(T);if(O.unshift(F),this.h.has(F.extId)||(this.h.add(F.extId),T===B))break;T=T.parent||B}this.m.$addTestsToRun(this.l.controllerId,this.l.id,O)}dispose(){this.u(),super.dispose()}}class c{get trackers(){return this.d.values()}constructor(T){this.f=T,this.d=new Map}prepareForMainThreadTestRun(T,O,B,F){return this.g(T,O,B,F)}cancelRunById(T){for(const O of this.d.values())if(O.id===T){O.cancel();return}}cancelAllRuns(){for(const T of this.d.values())T.cancel()}createTestRun(T,O,B,F,J,K){const me=this.d.get(F);if(me)return me.createRun(J);const re=v.fromPublic(O,B,F,K),x=d(F);this.f.$startedExtensionTestRun({controllerId:O,continuous:!!F.continuous,profile:x&&{group:N[x.kind],id:x.profileId},exclude:F.exclude?.map(ee=>a.$FI.fromExtHostTestItem(ee,B.root.id).toString())??[],id:re.id,include:F.include?.map(ee=>a.$FI.fromExtHostTestItem(ee,B.root.id).toString())??[B.root.id],persist:K});const q=this.g(F,re,T);return A.Event.once(q.onEnd)(()=>{this.f.$finishedExtensionTestRun(re.id),q.dispose()}),q.createRun(J)}g(T,O,B,F){const J=new n(O,this.f,B,F);return this.d.set(T,J),A.Event.once(J.onEnd)(()=>this.d.delete(T)),J}}e.$dcc=c;const d=j=>{if(j.profile){if(!(j.profile instanceof L))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return j.profile}};class v{static fromPublic(T,O,B,F){return new v(T,(0,b.$6e)(),B.include?.map(J=>a.$FI.fromExtHostTestItem(J,T).toString())??[T],B.exclude?.map(J=>a.$FI.fromExtHostTestItem(J,T).toString())??[],F,O)}static fromInternal(T,O){return new v(T.controllerId,T.runId,T.testIds,T.excludeExtIds,!0,O)}constructor(T,O,B,F,J,K){this.controllerId=T,this.id=O,this.isPersisted=J,this.colllection=K,this.d=B.map(me=>me+"\0"),this.f=F.map(me=>me+"\0")}isIncluded(T){const O=a.$FI.fromExtHostTestItem(T,this.controllerId).toString()+"\0";for(const B of this.f)if(O===B||O.startsWith(B))return!1;for(const B of this.d)if(O===B||O.startsWith(B))return!0;return!1}}e.$ecc=v;class k{set coverageProvider(T){if(this.d)throw new Error("The TestCoverageProvider cannot be replaced after being provided");T&&(this.d=T,this.g.$signalCoverageAvailable(this.h,this.j))}get coverageProvider(){return this.d}constructor(T,O,B){this.g=T,this.h=O,this.j=B}async provideFileCoverage(T){if(!this.d)return[];this.f||(this.f=(async()=>this.d.provideFileCoverage(T))());try{return(await this.f)?.map(r.TestCoverage.fromFile)??[]}catch(O){throw this.f=void 0,O}}async resolveFileCoverage(T,O){const B=await this.f;let F=B?.[T];return!this.d||!B||!F?[]:(F.detailedCoverage||(F=B[T]=await this.d.resolveFileCoverage?.(F,O)??F),F.detailedCoverage?.map(r.TestCoverage.fromDetailed)??[])}}class u{get isEmpty(){return this.d.size===0&&this.g.size===0&&this.f.size===0}constructor(T){this.j=T,this.d=new Set,this.f=new Set,this.g=new Set,this.h=new Set}add(T){this.d.add(T)}update(T){Object.assign(T.revived,r.TestItem.toPlain(T.item)),this.d.has(T)||this.f.add(T)}remove(T){if(this.d.has(T)){this.d.delete(T);return}this.f.delete(T);const O=a.$FI.parentId(T.item.extId);if(O&&this.h.has(O.toString())){this.h.add(T.item.extId);return}this.g.add(T)}getChangeEvent(){const{d:T,f:O,g:B}=this;return{get added(){return[...T].map(F=>F.revived)},get updated(){return[...O].map(F=>F.revived)},get removed(){return[...B].map(F=>F.revived)}}}complete(){this.isEmpty||this.j.fire(this.getChangeEvent())}}class l extends p.$MI{constructor(){super(...arguments),this.s=new A.$hc,this.onDidChangeTests=this.s.event}get rootTests(){return super.g}getMirroredTestDataById(T){return this.f.get(T)}getMirroredTestDataByReference(T){return this.f.get(T.id)}q(T,O){return{...T,revived:r.TestItem.toPlain(T.item),depth:O?O.depth+1:0,children:new Set}}p(){return new u(this.s)}}class w{constructor(T){this.f=T}checkout(){this.d||(this.d=this.g());const T=this.d;return T.observers++,{onDidChangeTest:T.tests.onDidChangeTests,get tests(){return[...T.tests.rootTests].map(O=>O.revived)},dispose:(0,g.$bb)(()=>{--T.observers===0&&(this.f.$unsubscribeFromDiffs(),this.d=void 0)})}}getMirroredTestDataByReference(T){return this.d?.tests.getMirroredTestDataByReference(T)}applyDiff(T){this.d?.tests.apply(T)}g(){const T=new l;return this.f.$subscribeToDiffs(),{observers:0,tests:T}}}class L{#e;#t;get label(){return this.f}set label(T){T!==this.f&&(this.f=T,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{label:T}))}get supportsContinuousRun(){return this.h}set supportsContinuousRun(T){T!==this.h&&(this.h=T,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{supportsContinuousRun:T}))}get isDefault(){return this.g}set isDefault(T){T!==this.g&&(this.g=T,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{isDefault:T}))}get tag(){return this._tag}set tag(T){T?.id!==this._tag?.id&&(this._tag=T,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{tag:T?r.TestTag.namespace(this.controllerId,T.id):null}))}get configureHandler(){return this.d}set configureHandler(T){T!==this.d&&(this.d=T,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{hasConfigurationHandler:!!T}))}constructor(T,O,B,F,J,K,me,re=!1,x=void 0,q=!1){this.controllerId=B,this.profileId=F,this.f=J,this.kind=K,this.runHandler=me,this.g=re,this._tag=x,this.h=q,this.#e=T,this.#t=O,O.set(F,this);const ee=N[K];if(typeof ee!="number")throw new Error(`Unknown TestRunProfile.group ${K}`);this.#e.$publishTestRunProfile({profileId:F,controllerId:B,tag:x?r.TestTag.namespace(this.controllerId,x.id):null,label:J,group:ee,isDefault:re,hasConfigurationHandler:!1,supportsContinuousRun:q})}dispose(){this.#t?.delete(this.profileId)&&(this.#t=void 0,this.#e.$removeTestProfile(this.controllerId,this.profileId))}}e.$fcc=L;const N={[i.TestRunProfileKind.Coverage]:8,[i.TestRunProfileKind.Debug]:4,[i.TestRunProfileKind.Run]:2}}),define(De[320],Ce([1,0,19,8,4,5,145,10,7]),function($e,e,D,M,h,R,A,g,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ubc=void 0;class ${constructor(I,b){this.i=b,this.a=new h.$hc({onListenerError:M.$Z}),this.b=new h.$hc({onListenerError:M.$Z}),this.c=new h.$hc({onListenerError:M.$Z}),this.d=new h.$hc({onListenerError:M.$Z}),this.f=new h.$hc({onListenerError:M.$Z}),this.g=new h.$hc({onListenerError:M.$Z}),this.onDidChangeTextEditorSelection=this.a.event,this.onDidChangeTextEditorOptions=this.b.event,this.onDidChangeTextEditorVisibleRanges=this.c.event,this.onDidChangeTextEditorViewColumn=this.d.event,this.onDidChangeActiveTextEditor=this.f.event,this.onDidChangeVisibleTextEditors=this.g.event,this.h=I.getProxy(R.$SJ.MainThreadTextEditors),this.i.onDidChangeVisibleTextEditors(S=>this.g.fire(S)),this.i.onDidChangeActiveTextEditor(S=>this.f.fire(S))}getActiveTextEditor(){return this.i.activeEditor()}getVisibleTextEditors(I){const b=this.i.allEditors();return I?b:b.map(S=>S.value)}async showTextDocument(I,b,S){let C;typeof b=="number"?C={position:g.ViewColumn.from(b),preserveFocus:S}:typeof b=="object"?C={position:g.ViewColumn.from(b.viewColumn),preserveFocus:b.preserveFocus,selection:typeof b.selection=="object"?g.Range.from(b.selection):void 0,pinned:typeof b.preview=="boolean"?!b.preview:void 0}:C={preserveFocus:!1};const y=await this.h.$tryShowTextDocument(I.uri,C),r=y&&this.i.getEditor(y);if(r)return r.value;throw y?new Error(`Could NOT open editor for "${I.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${I.uri.toString()}".`)}createTextEditorDecorationType(I,b){return new A.$2L(this.h,I,b).value}$acceptEditorPropertiesChanged(I,b){const S=this.i.getEditor(I);if(!S)throw new Error("unknown text editor");if(b.options&&S._acceptOptions(b.options),b.selections){const C=b.selections.selections.map(g.Selection.to);S._acceptSelections(C)}if(b.visibleRanges){const C=D.$Af(b.visibleRanges.map(g.Range.to));S._acceptVisibleRanges(C)}if(b.options&&this.b.fire({textEditor:S.value,options:{...b.options,lineNumbers:g.TextEditorLineNumbersStyle.to(b.options.lineNumbers)}}),b.selections){const C=E.TextEditorSelectionChangeKind.fromValue(b.selections.source),y=b.selections.selections.map(g.Selection.to);this.a.fire({textEditor:S.value,selections:y,kind:C})}if(b.visibleRanges){const C=D.$Af(b.visibleRanges.map(g.Range.to));this.c.fire({textEditor:S.value,visibleRanges:C})}}$acceptEditorPositionData(I){for(const b in I){const S=this.i.getEditor(b);if(!S)throw new Error("Unknown text editor");const C=g.ViewColumn.to(I[b]);S.value.viewColumn!==C&&(S._acceptViewColumn(C),this.d.fire({textEditor:S.value,viewColumn:C}))}}getDiffInformation(I){return Promise.resolve(this.h.$getDiffInformation(I))}}e.$ubc=$}),define(De[321],Ce([1,0,2,6,5,3,7,10,25,18]),function($e,e,D,M,h,R,A,g,E,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0bc=e.$9bc=void 0,e.$9bc=(0,M.$zh)("IExtHostTimeline");class P{constructor(S,C){this.b=new Map,this.c=new Map,this.a=S.getProxy(h.$SJ.MainThreadTimeline),C.registerArgumentProcessor({processArgument:(y,r)=>{if(y&&y.$mid===12)if(this.b.get(y.source)&&E.$Tl.equals(r,this.b.get(y.source)?.extension)){const i=y.uri===void 0?void 0:D.URI.revive(y.uri);return this.c.get(y.source)?.get(I(i))?.get(y.handle)}else return;return y}})}async $getTimeline(S,C,y,r){return this.b.get(S)?.provider.provideTimeline(D.URI.revive(C),y,r)}registerTimelineProvider(S,C,y,r){const i=new R.$lb,a=this.d(C.id,r,i).bind(this);let m;C.onDidChange&&(m=C.onDidChange(f=>this.a.$emitTimelineChangeEvent({uri:void 0,reset:!0,...f,id:C.id}),this));const p=this.c;return this.f({...C,scheme:S,onDidChange:void 0,async provideTimeline(f,t,s){t?.resetCache&&(i.clear(),p.get(C.id)?.clear());const o=await C.provideTimeline(f,t,s);if(o==null)return;const n=a(f,t);return{...o,source:C.id,items:o.items.map(n)}},dispose(){for(const f of p.values())f.get(C.id)?.clear();m?.dispose(),i.dispose()}},y)}d(S,C,y){return(r,i)=>{let a;if(i?.cacheResults){let m=this.c.get(S);m===void 0&&(m=new Map,this.c.set(S,m));const p=I(r);a=m.get(p),a===void 0&&(a=new Map,m.set(p,a))}return m=>{const{iconPath:p,...f}=m,t=`${S}|${m.id??m.timestamp}`;a?.set(t,m);let s,o,n;m.iconPath&&(p instanceof A.$PK?n={id:p.id,color:p.color}:D.URI.isUri(p)?(s=p,o=p):{light:s,dark:o}=p);let c;return A.$jK.isMarkdownString(f.tooltip)?c=g.MarkdownString.from(f.tooltip):(0,$.$le)(f.tooltip)?c=f.tooltip:A.$jK.isMarkdownString(f.detail)?(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),c=g.MarkdownString.from(f.detail)):(0,$.$le)(f.detail)&&(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),c=f.detail),{...f,id:f.id??void 0,handle:t,source:S,command:m.command?C.toInternal(m.command,y):void 0,icon:s,iconDark:o,themeIcon:n,tooltip:c,accessibilityInformation:m.accessibilityInformation}}}}f(S,C){if(this.b.get(S.id))throw new Error(`Timeline Provider ${S.id} already exists.`);return this.a.$registerTimelineProvider({id:S.id,label:S.label,scheme:S.scheme}),this.b.set(S.id,{provider:S,extension:C}),(0,R.$kb)(()=>{for(const r of this.c.values())r.get(S.id)?.clear();this.b.delete(S.id),this.a.$unregisterTimelineProvider(S.id),S.dispose()})}}e.$0bc=P;function I(b){return b?.toString()}}),define(De[68],Ce([1,0,22,4,3,208,6,17,106,5,26,20,7]),function($e,e,D,M,h,R,A,g,E,$,P,I,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4rb=e.$3rb=e.TunnelDtoConverter=void 0;class S extends E.$2z{}var C;(function(r){function i(m){return{remoteAddress:m.remoteAddress,localAddress:m.localAddress,public:!!m.public,privacy:m.privacy??(m.public?E.TunnelPrivacyId.Public:E.TunnelPrivacyId.Private),protocol:m.protocol}}r.fromApiTunnel=i;function a(m){return{remoteAddress:{host:m.tunnelRemoteHost,port:m.tunnelRemotePort},localAddress:m.localAddress,public:m.privacy!==E.TunnelPrivacyId.ConstantPrivate&&m.privacy!==E.TunnelPrivacyId.ConstantPrivate,privacy:m.privacy,protocol:m.protocol}}r.fromServiceTunnel=a})(C||(e.TunnelDtoConverter=C={})),e.$3rb=(0,A.$zh)("IExtHostTunnelService");let y=class extends h.$mb{constructor(i,a,m){super(),this.n=m,this.f=()=>Promise.resolve(!0),this.g=new Map,this.h=new M.$hc,this.onDidChangeTunnels=this.h.event,this.k=0,this.l=new Map,this.a=i.getProxy($.$SJ.MainThreadTunnelService)}async openTunnel(i,a){this.n.trace(`ForwardedPorts: (ExtHostTunnelService) ${i.identifier.value} called openTunnel API for ${a.remoteAddress.host}:${a.remoteAddress.port}.`);const m=await this.a.$openTunnel(a,i.displayName);if(m){const p=new S(m.remoteAddress,m.localAddress,()=>this.a.$closeTunnel(m.remoteAddress));return this.B(p),p}}async getTunnels(){return this.a.$getTunnels()}p(){return this.k++}registerPortsAttributesProvider(i,a){const m=this.p();return this.l.set(m,{selector:i,provider:a}),this.a.$registerPortsAttributesProvider(i,m),new b.$UJ(()=>{this.l.delete(m),this.a.$unregisterPortsAttributesProvider(m)})}async $providePortAttributes(i,a,m,p,f){const t=[];for(const o of i){const n=this.l.get(o);if(!n)return[];t.push(...await Promise.all(a.map(async c=>{let d;try{d=await n.provider.providePortAttributes({port:c,pid:m,commandLine:p},f)}catch{d=await n.provider.providePortAttributes(c,m,p,f)}return{providedAttributes:d,port:c}})))}const s=t.filter(o=>!!o.providedAttributes);return s.length>0?s.map(o=>({autoForwardAction:o.providedAttributes.autoForwardAction,port:o.port})):[]}async $registerCandidateFinder(i){}registerTunnelProvider(i,a){if(this.b)throw new Error("A tunnel provider has already been registered. Only the first tunnel provider to be registered will be used.");this.b=async(p,f)=>await i.provideTunnel(p,f,new D.$rc().token)??void 0;const m=a.tunnelFeatures?{elevation:!!a.tunnelFeatures?.elevation,privacyOptions:a.tunnelFeatures?.privacyOptions}:void 0;return this.a.$setTunnelProvider(m),Promise.resolve((0,h.$kb)(()=>{this.b=void 0,this.a.$setTunnelProvider(void 0)}))}async setTunnelFactory(i,a){if(i){i.candidatePortSource!==void 0&&this.a.$setCandidatePortSource(i.candidatePortSource),i.showCandidatePort&&(this.f=i.showCandidatePort,this.a.$setCandidateFilter());const m=i.tunnelFactory??(a?this.r(a):void 0);if(m){this.b=m;let p=i.tunnelFeatures?.privacyOptions??[];i.tunnelFeatures?.public&&p.length===0&&(p=[{id:"private",label:R.localize(0,null),themeIcon:"lock"},{id:"public",label:R.localize(1,null),themeIcon:"eye"}]);const f=i.tunnelFeatures?{elevation:!!i.tunnelFeatures?.elevation,public:!!i.tunnelFeatures?.public,privacyOptions:p}:void 0;this.a.$setTunnelProvider(f)}}else this.b=void 0;return(0,h.$kb)(()=>{this.b=void 0})}r(i){}async $closeTunnel(i,a){if(this.g.has(i.host)){const m=this.g.get(i.host);m.has(i.port)&&(a&&m.get(i.port).disposeListener.dispose(),await m.get(i.port).tunnel.dispose(),m.delete(i.port))}}async $onDidTunnelsChange(){this.h.fire()}async $forwardPort(i,a){if(this.b)try{this.n.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const m=this.b(i,a);if(this.n.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),m!==void 0){const p=await m;if(this.n.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),p===void 0){this.n.error("ForwardedPorts: (ExtHostTunnelService) Resolved tunnel is undefined");return}this.g.has(i.remoteAddress.host)||this.g.set(i.remoteAddress.host,new Map);const f=this.B(p.onDidDispose(()=>(this.n.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this.a.$closeTunnel(p.remoteAddress))));return this.g.get(i.remoteAddress.host).set(i.remoteAddress.port,{tunnel:p,disposeListener:f}),C.fromApiTunnel(p)}else this.n.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch(m){if(this.n.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error"),m instanceof Error)return m.message}}async $applyCandidateFilter(i){const a=await Promise.all(i.map(p=>this.f(p.host,p.port,p.detail??""))),m=i.filter((p,f)=>a[f]);return this.n.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${i.map(p=>p.port).join(", ")} to ${m.map(p=>p.port).join(", ")}`),m}};e.$4rb=y,e.$4rb=y=Ke([Ve(0,I.$UL),Ve(1,P.$$L),Ve(2,g.$3i)],y)}),define(De[322],Ce([1,0,3,16,2,5]),function($e,e,D,M,h,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gcc=void 0;class A{static{this.a=new Set([M.Schemas.http,M.Schemas.https])}constructor(E){this.c=new Map,this.b=E.getProxy(R.$SJ.MainThreadUriOpeners)}registerExternalUriOpener(E,$,P,I){if(this.c.has($))throw new Error(`Opener with id '${$}' already registered`);const b=I.schemes.find(S=>!A.a.has(S));if(b)throw new Error(`Scheme '${b}' is not supported. Only http and https are currently supported.`);return this.c.set($,P),this.b.$registerUriOpener($,I.schemes,E,I.label),(0,D.$kb)(()=>{this.c.delete($),this.b.$unregisterUriOpener($)})}async $canOpenUri(E,$,P){const I=this.c.get(E);if(!I)throw new Error(`Unknown opener with id: ${E}`);const b=h.URI.revive($);return I.canOpenExternalUri(b,P)}async $openUri(E,$,P){const I=this.c.get(E);if(!I)throw new Error(`Unknown opener id: '${E}'`);return I.openExternalUri(h.URI.revive($.resolvedUri),{sourceUri:h.URI.revive($.sourceUri)},P)}}e.$gcc=A}),define(De[323],Ce([1,0,5,2,3,8,25]),function($e,e,D,M,h,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wbc=void 0;class g{static{this.a=0}constructor($){this.c=new A.$Ul,this.d=new Map,this.b=$.getProxy(D.$SJ.MainThreadUrls)}registerUriHandler($,P){const I=$.identifier;if(this.c.has(I))throw new Error(`Protocol handler already registered for extension ${I}`);const b=g.a++;return this.c.add(I),this.d.set(b,P),this.b.$registerUriHandler(b,I,$.displayName||$.name),(0,h.$kb)(()=>{this.c.delete(I),this.d.delete(b),this.b.$unregisterUriHandler(b)})}$handleExternalUri($,P){const I=this.d.get($);if(!I)return Promise.resolve(void 0);try{I.handleUri(M.URI.revive(P))}catch(b){(0,R.$Y)(b)}return Promise.resolve(void 0)}async createAppUri($){return M.URI.revive(await this.b.$createAppUri($))}}e.$wbc=g}),define(De[91],Ce([1,0,4,3,16,23,2,222,256,109,5]),function($e,e,D,M,h,R,A,g,E,$,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bbc=e.$Abc=e.$zbc=e.$ybc=e.$xbc=void 0;class I{#e;#t;#i;#l;#u;#n;#s;#r;#o;#a;#c;#d;constructor(p,f,t,s,o,n,c){this.#s="",this.#o=!1,this.#a=!1,this._onMessageEmitter=new D.$hc,this.onDidReceiveMessage=this._onMessageEmitter.event,this.#h=new D.$hc,this._onDidDispose=this.#h.event,this.#e=p,this.#t=f,this.#r=t,this.#l=s,this.#u=o,this.#n=n,this.#c=b(n),this.#d=S(n),this.#i=c}#h;dispose(){this.#o=!0,this.#h.fire(),this.#h.dispose(),this._onMessageEmitter.dispose()}asWebviewUri(p){return this.#a=!0,(0,$.$Aob)(p,this.#l)}get cspSource(){const p=this.#n.extensionLocation;if(p.scheme===h.Schemas.https||p.scheme===h.Schemas.http){let f=p.toString();return f.endsWith("/")||(f+="/"),f+" "+$.$zob}return $.$zob}get html(){return this.a(),this.#s}set html(p){this.a(),this.#s!==p&&(this.#s=p,this.#d&&!this.#a&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(p)&&(this.#a=!0,this.#i.report("Webview vscode-resource: uris",this.#n,"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),this.#t.$setHtml(this.#e,this.b(p)))}get options(){return this.a(),this.#r}set options(p){this.a(),R.$Xm(this.#r,p)||this.#t.$setOptions(this.#e,r(this.#n,this.#u,p)),this.#r=p}async postMessage(p){if(this.#o)return!1;const f=(0,E.$Obb)(p,{serializeBuffersForPostMessage:this.#c});return this.#t.$postMessage(this.#e,f.message,...f.buffers)}a(){if(this.#o)throw new Error("Webview is disposed")}b(p){if(!this.#d)return p;const f=this.#n.extensionLocation?.scheme===h.Schemas.vscodeRemote,t=this.#n.extensionLocation.scheme===h.Schemas.vscodeRemote?this.#n.extensionLocation.authority:void 0;return p.replace(/(["'])(?:vscode-resource):(\/\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(s,o,n,c,d,v)=>{const k=A.URI.from({scheme:c||"file",path:decodeURIComponent(d)}),u=(0,$.$Aob)(k,{isRemote:f,authority:t}).toString();return`${o}${u}${v}`}).replace(/(["'])(?:vscode-webview-resource):(\/\/[^\s\/'"]+\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(s,o,n,c,d,v)=>{const k=A.URI.from({scheme:c||"file",path:decodeURIComponent(d)}),u=(0,$.$Aob)(k,{isRemote:f,authority:t}).toString();return`${o}${u}${v}`})}}e.$xbc=I;function b(m){try{const p=(0,g.$Bo)((0,g.$Ao)(m.engines.vscode));return!!p&&p.majorBase>=1&&p.minorBase>=57}catch{return!1}}e.$ybc=b;function S(m){try{const p=(0,g.$Bo)((0,g.$Ao)(m.engines.vscode));return p?p.majorBase<1||p.majorBase===1&&p.minorBase<60:!1}catch{return!1}}class C extends M.$mb{constructor(p,f,t,s,o){super(),this.c=f,this.f=t,this.g=s,this.h=o,this.b=new Map,this.a=p.getProxy(P.$SJ.MainThreadWebviews)}dispose(){super.dispose();for(const p of this.b.values())p.dispose();this.b.clear()}$onMessage(p,f,t){const s=this.i(p);if(s){const{message:o}=(0,E.$Pbb)(f,t.value);s._onMessageEmitter.fire(o)}}$onMissingCsp(p,f){this.g.warn(`${f} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(p,f,t){const s=new I(p,this.a,i(f),this.c,this.f,t,this.h);this.b.set(p,s);const o=s._onDidDispose(()=>{o.dispose(),this.deleteWebview(p)});return s}deleteWebview(p){this.b.delete(p)}i(p){return this.b.get(p)}}e.$zbc=C;function y(m){return{id:m.identifier,location:m.extensionLocation}}e.$Abc=y;function r(m,p,f){return{enableCommandUris:f.enableCommandUris,enableScripts:f.enableScripts,enableForms:f.enableForms,portMapping:f.portMapping,localResourceRoots:f.localResourceRoots||a(m,p)}}e.$Bbc=r;function i(m){return{enableCommandUris:m.enableCommandUris,enableScripts:m.enableScripts,enableForms:m.enableForms,portMapping:m.portMapping,localResourceRoots:m.localResourceRoots?.map(p=>A.URI.from(p))}}function a(m,p){return[...(p?.getWorkspaceFolders()||[]).map(f=>f.uri),m.extensionLocation]}}),define(De[324],Ce([1,0,22,74,3,16,24,2,10,91,86,5,7]),function($e,e,D,M,h,R,A,g,E,$,P,I,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$acc=void 0;class S{constructor(s,o){this.document=s,this.b=o,this.a=1,this.c=new P.$tac("custom documents")}addEdit(s){return this.c.add([s])}async undo(s,o){await this.f(s).undo(),o||this.disposeBackup()}async redo(s,o){await this.f(s).redo(),o||this.disposeBackup()}disposeEdits(s){for(const o of s)this.c.delete(o)}getNewBackupUri(){if(!this.b)throw new Error("Backup requires a valid storage path");const s=f(this.document.uri)+this.a++;return(0,A.$gg)(this.b,s)}updateBackup(s){this.d?.delete(),this.d=s}disposeBackup(){this.d?.delete(),this.d=void 0}f(s){const o=this.c.get(s,0);if(!o)throw new Error("No edit found");return o}}class C{constructor(){this.a=new Map}get(s,o){return this.a.get(this.b(s,o))}add(s,o,n){const c=this.b(s,o.uri);if(this.a.has(c))throw new Error(`Document already exists for viewType:${s} resource:${o.uri}`);const d=new S(o,n);return this.a.set(c,d),d}delete(s,o){const n=this.b(s,o.uri);this.a.delete(n)}b(s,o){return`${s}@@@${o}`}}var y;(function(t){t[t.Text=0]="Text",t[t.Custom=1]="Custom"})(y||(y={}));class r{constructor(){this.a=new Map}addTextProvider(s,o,n){return this.b(0,s,o,n)}addCustomProvider(s,o,n){return this.b(1,s,o,n)}get(s){return this.a.get(s)}b(s,o,n,c){if(this.a.has(o))throw new Error(`Provider for viewType:${o} already registered`);return this.a.set(o,{type:s,extension:n,provider:c}),new b.$UJ(()=>this.a.delete(o))}}class i{constructor(s,o,n,c,d){this.d=o,this.f=n,this.g=c,this.h=d,this.b=new r,this.c=new C,this.a=s.getProxy(I.$SJ.MainThreadCustomEditors)}registerCustomEditorProvider(s,o,n,c){const d=new h.$lb;return m(n)?(d.add(this.b.addTextProvider(o,s,n)),this.a.$registerTextEditorProvider((0,$.$Abc)(s),o,c.webviewOptions||{},{supportsMove:!!n.moveCustomTextEditor},(0,$.$ybc)(s))):(d.add(this.b.addCustomProvider(o,s,n)),a(n)&&d.add(n.onDidChangeCustomDocument(v=>{const k=this.i(o,v.document.uri);if(p(v)){const u=k.addEdit(v);this.a.$onDidEdit(v.document.uri,o,u,v.label)}else this.a.$onContentChange(v.document.uri,o)})),this.a.$registerCustomEditorProvider((0,$.$Abc)(s),o,c.webviewOptions||{},!!c.supportsMultipleEditorsPerDocument,(0,$.$ybc)(s))),b.$UJ.from(d,new b.$UJ(()=>{this.a.$unregisterEditorProvider(o)}))}async $createCustomDocument(s,o,n,c,d){const v=this.b.get(o);if(!v)throw new Error(`No provider found for '${o}'`);if(v.type!==1)throw new Error(`Invalid provide type for '${o}'`);const k=g.URI.revive(s),u=await v.provider.openCustomDocument(k,{backupId:n,untitledDocumentData:c?.buffer},d);let l;return a(v.provider)&&this.f&&(l=this.f.workspaceValue(v.extension)??this.f.globalValue(v.extension)),this.c.add(o,u,l),{editable:a(v.provider)}}async $disposeCustomDocument(s,o){const n=this.b.get(o);if(!n)throw new Error(`No provider found for '${o}'`);if(n.type!==1)throw new Error(`Invalid provider type for '${o}'`);const c=g.URI.revive(s),{document:d}=this.i(o,c);this.c.delete(o,d),d.dispose()}async $resolveCustomEditor(s,o,n,c,d,v){const k=this.b.get(n);if(!k)throw new Error(`No provider found for '${n}'`);const u=E.ViewColumn.to(d),l=this.g.createNewWebview(o,c.contentOptions,k.extension),w=this.h.createNewWebviewPanel(o,n,c.title,u,c.options,l,c.active),L=g.URI.revive(s);switch(k.type){case 1:{const{document:N}=this.i(n,L);return k.provider.resolveCustomEditor(N,w,v)}case 0:{const N=this.d.getDocument(L);return k.provider.resolveCustomTextEditor(N,w,v)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(s,o,n){this.i(o,s).disposeEdits(n)}async $onMoveCustomEditor(s,o,n){const c=this.b.get(n);if(!c)throw new Error(`No provider found for '${n}'`);if(!c.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${n}'`);const d=this.h.getWebviewPanel(s);if(!d)throw new Error("No webview found");const v=g.URI.revive(o),k=this.d.getDocument(v);await c.provider.moveCustomTextEditor(k,d,D.CancellationToken.None)}async $undo(s,o,n,c){return this.i(o,s).undo(n,c)}async $redo(s,o,n,c){return this.i(o,s).redo(n,c)}async $revert(s,o,n){const c=this.i(o,s);await this.j(o).revertCustomDocument(c.document,n),c.disposeBackup()}async $onSave(s,o,n){const c=this.i(o,s);await this.j(o).saveCustomDocument(c.document,n),c.disposeBackup()}async $onSaveAs(s,o,n,c){const d=this.i(o,s);return this.j(o).saveCustomDocumentAs(d.document,g.URI.revive(n),c)}async $backup(s,o,n){const c=this.i(o,s),v=await this.j(o).backupCustomDocument(c.document,{destination:c.getNewBackupUri()},n);return c.updateBackup(v),v.id}i(s,o){const n=this.c.get(s,g.URI.revive(o));if(!n)throw new Error("No custom document found");return n}j(s){const n=this.b.get(s)?.provider;if(!n||!a(n))throw new Error("Custom document is not editable");return n}}e.$acc=i;function a(t){return!!t.onDidChangeCustomDocument}function m(t){return typeof t.resolveCustomTextEditor=="function"}function p(t){return typeof t.undo=="function"&&typeof t.redo=="function"}function f(t){const s=t.scheme===R.Schemas.file||t.scheme===R.Schemas.untitled?t.fsPath:t.toString();return(0,M.$ni)(s)+""}}),define(De[325],Ce([1,0,4,3,2,31,10,91,5,7]),function($e,e,D,M,h,R,A,g,E,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_bc=void 0;class P extends M.$mb{#e;#t;#i;#l;#u;#n;#s;#r;#o;#a;#c;#d;#h;constructor(C,y,r,i){super(),this.#r=void 0,this.#o=!0,this.#c=!1,this.#d=this.B(new D.$hc),this.onDidDispose=this.#d.event,this.#h=this.B(new D.$hc),this.onDidChangeViewState=this.#h.event,this.#e=C,this.#t=y,this.#l=r,this.#i=i.viewType,this.#u=i.panelOptions,this.#r=i.viewColumn,this.#n=i.title,this.#a=i.active}dispose(){this.#c||(this.#c=!0,this.#d.fire(),this.#t.$disposeWebview(this.#e),this.#l.dispose(),super.dispose())}get webview(){return this.c(),this.#l}get viewType(){return this.c(),this.#i}get title(){return this.c(),this.#n}set title(C){this.c(),this.#n!==C&&(this.#n=C,this.#t.$setTitle(this.#e,C))}get iconPath(){return this.c(),this.#s}set iconPath(C){this.c(),this.#s!==C&&(this.#s=C,this.#t.$setIconPath(this.#e,h.URI.isUri(C)?{light:C,dark:C}:C))}get options(){return this.#u}get viewColumn(){if(this.c(),!(typeof this.#r=="number"&&this.#r<0))return this.#r}get active(){return this.c(),this.#a}get visible(){return this.c(),this.#o}_updateViewState(C){this.#c||(this.active!==C.active||this.visible!==C.visible||this.viewColumn!==C.viewColumn)&&(this.#a=C.active,this.#o=C.visible,this.#r=C.viewColumn,this.#h.fire({webviewPanel:this}))}reveal(C,y){this.c(),this.#t.$reveal(this.#e,{viewColumn:typeof C>"u"?void 0:A.ViewColumn.from(C),preserveFocus:!!y})}c(){if(this.#c)throw new Error("Webview is disposed")}}class I extends M.$mb{static c(){return(0,R.$6e)()}constructor(C,y,r){super(),this.i=y,this.j=r,this.g=new Map,this.h=new Map,this.f=C.getProxy(E.$SJ.MainThreadWebviewPanels)}dispose(){super.dispose(),this.g.forEach(C=>C.dispose()),this.g.clear()}createWebviewPanel(C,y,r,i,a={}){const m=typeof i=="object"?i.viewColumn:i,p={viewColumn:A.ViewColumn.from(m),preserveFocus:typeof i=="object"&&!!i.preserveFocus},f=(0,g.$ybc)(C),t=I.c();this.f.$createWebviewPanel((0,g.$Abc)(C),t,y,{title:r,panelOptions:b(a),webviewOptions:(0,g.$Bbc)(C,this.j,a),serializeBuffersForPostMessage:f},p);const s=this.i.createNewWebview(t,a,C);return this.createNewWebviewPanel(t,y,r,m,a,s,!0)}$onDidChangeWebviewPanelViewStates(C){const y=Object.keys(C);y.sort((r,i)=>{const a=C[r],m=C[i];return a.active?1:m.active?-1:+a.visible-+m.visible});for(const r of y){const i=this.getWebviewPanel(r);if(!i)continue;const a=C[r];i._updateViewState({active:a.active,visible:a.visible,viewColumn:A.ViewColumn.to(a.position)})}}async $onDidDisposeWebviewPanel(C){this.getWebviewPanel(C)?.dispose(),this.g.delete(C),this.i.deleteWebview(C)}registerWebviewPanelSerializer(C,y,r){if(this.h.has(y))throw new Error(`Serializer for '${y}' already registered`);return this.h.set(y,{serializer:r,extension:C}),this.f.$registerSerializer(y,{serializeBuffersForPostMessage:(0,g.$ybc)(C)}),new $.$UJ(()=>{this.h.delete(y),this.f.$unregisterSerializer(y)})}async $deserializeWebviewPanel(C,y,r,i){const a=this.h.get(y);if(!a)throw new Error(`No serializer found for '${y}'`);const{serializer:m,extension:p}=a,f=this.i.createNewWebview(C,r.webviewOptions,p),t=this.createNewWebviewPanel(C,y,r.title,i,r.panelOptions,f,r.active);await m.deserializeWebviewPanel(t,r.state)}createNewWebviewPanel(C,y,r,i,a,m,p){const f=new P(C,this.f,m,{viewType:y,title:r,viewColumn:i,panelOptions:a,active:p});return this.g.set(C,f),f}getWebviewPanel(C){return this.g.get(C)}}e.$_bc=I;function b(S){return{enableFindWidget:S.enableFindWidget,retainContextWhenHidden:S.retainContextWhenHidden}}}),define(De[326],Ce([1,0,4,3,91,10,5,7]),function($e,e,D,M,h,R,A,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$bc=void 0;class E extends M.$mb{#e;#t;#i;#l;#u;#n;#s;#r;#o;constructor(I,b,S,C,y,r){super(),this.#u=!1,this.#a=this.B(new D.$hc),this.onDidChangeVisibility=this.#a.event,this.#c=this.B(new D.$hc),this.onDidDispose=this.#c.event,this.#i=S,this.#s=C,this.#e=I,this.#t=b,this.#l=y,this.#n=r}dispose(){this.#u||(this.#u=!0,this.#c.fire(),this.#l.dispose(),super.dispose())}#a;#c;get title(){return this.a(),this.#s}set title(I){this.a(),this.#s!==I&&(this.#s=I,this.#t.$setWebviewViewTitle(this.#e,I))}get description(){return this.a(),this.#r}set description(I){this.a(),this.#r!==I&&(this.#r=I,this.#t.$setWebviewViewDescription(this.#e,I))}get visible(){return this.#n}get webview(){return this.#l}get viewType(){return this.#i}_setVisible(I){I===this.#n||this.#u||(this.#n=I,this.#a.fire())}get badge(){return this.a(),this.#o}set badge(I){this.a(),!(I?.value===this.#o?.value&&I?.tooltip===this.#o?.tooltip)&&(this.#o=R.ViewBadge.from(I),this.#t.$setWebviewViewBadge(this.#e,I))}show(I){this.a(),this.#t.$show(this.#e,!!I)}a(){if(this.#u)throw new Error("Webview is disposed")}}class ${constructor(I,b){this.d=b,this.b=new Map,this.c=new Map,this.a=I.getProxy(A.$SJ.MainThreadWebviewViews)}registerWebviewViewProvider(I,b,S,C){if(this.b.has(b))throw new Error(`View provider for '${b}' already registered`);return this.b.set(b,{provider:S,extension:I}),this.a.$registerWebviewViewProvider((0,h.$Abc)(I),b,{retainContextWhenHidden:C?.retainContextWhenHidden,serializeBuffersForPostMessage:(0,h.$ybc)(I)}),new g.$UJ(()=>{this.b.delete(b),this.a.$unregisterWebviewViewProvider(b)})}async $resolveWebviewView(I,b,S,C,y){const r=this.b.get(b);if(!r)throw new Error(`No view provider found for '${b}'`);const{provider:i,extension:a}=r,m=this.d.createNewWebview(I,{},a),p=new E(I,this.a,b,S,m,!0);this.c.set(I,p),await i.resolveWebviewView(p,{state:C},y)}async $onDidChangeWebviewViewVisibility(I,b){this.e(I)._setVisible(b)}async $disposeWebviewView(I){const b=this.e(I);this.c.delete(I),b.dispose(),this.d.deleteWebview(I)}e(I){const b=this.c.get(I);if(!b)throw new Error("No webview found");return b}}e.$$bc=$}),define(De[149],Ce([1,0,4,5,2,16,15,6,20,27]),function($e,e,D,M,h,R,A,g,E,$){"use strict";var P;Object.defineProperty(e,"__esModule",{value:!0}),e.$Dbc=e.$Cbc=void 0;let I=class{static{P=this}static{this.a={focused:!0,active:!0}}getState(S){const C=this.d;return{get focused(){return C.focused},get active(){return(0,$.$MF)(S,"windowActivity"),C.active}}}constructor(S){this.c=new D.$hc,this.onDidChangeWindowState=this.c.event,this.d=P.a,this.b=S.getProxy(M.$SJ.MainThreadWindow),this.b.$getInitialState().then(({isFocused:C,isActive:y})=>{this.onDidChangeWindowProperty("focused",C),this.onDidChangeWindowProperty("active",y)})}$onDidChangeWindowFocus(S){this.onDidChangeWindowProperty("focused",S)}$onDidChangeWindowActive(S){this.onDidChangeWindowProperty("active",S)}onDidChangeWindowProperty(S,C){C!==this.d[S]&&(this.d={...this.d,[S]:C},this.c.fire(this.d))}openUri(S,C){let y;if(typeof S=="string"){y=S;try{S=h.URI.parse(S)}catch{return Promise.reject(`Invalid uri - '${S}'`)}}return(0,A.$od)(S.scheme)?Promise.reject("Invalid scheme - cannot be empty"):S.scheme===R.Schemas.command?Promise.reject(`Invalid scheme '${S.scheme}'`):this.b.$openUri(S,y,C)}async asExternalUri(S,C){if((0,A.$od)(S.scheme))return Promise.reject("Invalid scheme - cannot be empty");const y=await this.b.$asExternalUri(S,C);return h.URI.from(y)}};e.$Cbc=I,e.$Cbc=I=P=Ke([Ve(0,E.$UL)],I),e.$Dbc=(0,g.$zh)("IExtHostWindow")}),define(De[327],Ce([1,0,295,26,20]),function($e,e,D,M,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$adc=void 0;const R=1024*1024;let A=class extends D.$Bcc{constructor(E,$){super(E,$),this.g=!1,this.j("stderr","error"),this.j("stdout","log")}f(E,$,P){const I=E==="error"||E==="warn"?process.stderr:process.stdout;this.g=!0,I.write(`
START_NATIVE_LOG
`),$.apply(console,P),I.write(`
END_NATIVE_LOG
`),this.g=!1}j(E,$){const P=process[E],I=P.write;let b="";Object.defineProperty(P,"write",{set:()=>{},get:()=>(S,C,y)=>{if(!this.g){b+=S.toString(C);const r=b.length>R?b.length:b.lastIndexOf(`
`);r!==-1&&(console[$](b.slice(0,r)),b=b.slice(r+1))}I.call(P,S,C,y)}})}};e.$adc=A,e.$adc=A=Ke([Ve(0,h.$UL),Ve(1,M.$$L)],A)}),define(De[328],Ce([1,0,67,16,17,234,30,9]),function($e,e,D,M,h,R,A,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bdc=void 0;let E=class{constructor(I,b){I.addFileSystemProvider(M.Schemas.file,new $(b),{isCaseSensitive:g.$k})}};e.$bdc=E,e.$bdc=E=Ke([Ve(0,D.$2ac),Ve(1,h.$3i)],E);class ${constructor(I){this.b=I,this.a=new R.$Zp(this.b)}async stat(I){const b=await this.a.stat(I);return{type:b.type,ctime:b.ctime,mtime:b.mtime,size:b.size,permissions:b.permissions===A.FilePermission.Readonly?1:void 0}}readDirectory(I){return this.a.readdir(I)}createDirectory(I){return this.a.mkdir(I)}readFile(I){return this.a.readFile(I)}writeFile(I,b,S){return this.a.writeFile(I,b,{...S,unlock:!1,atomic:!1})}delete(I,b){return this.a.delete(I,{...b,useTrash:!1,atomic:!1})}rename(I,b,S){return this.a.rename(I,b,S)}copy(I,b,S){return this.a.copy(I,b,S)}get onDidChangeFile(){throw new Error("Method not implemented.")}watch(I,b){throw new Error("Method not implemented.")}}}),define(De[329],Ce([1,0,14,59,31,33,3,5,2,20]),function($e,e,D,M,h,R,A,g,E,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_cc=void 0;let P=class extends A.$mb{constructor(b,S){super();const C=b.getProxy(g.$SJ.MainThreadDownloadService);S.registerCommand(!1,"_workbench.downloadResource",async y=>{const r=E.URI.file((0,D.$$c)((0,M.tmpdir)(),(0,h.$6e)()));return await C.$download(y,r),r})}};e.$_cc=P,e.$_cc=P=Ke([Ve(0,$.$UL),Ve(1,R.$eM)],P)}),define(De[330],Ce([1,0,148,16,236,31]),function($e,e,D,M,h,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mdc=void 0;class A extends D.$Acc{m(E,$,P){return E.scheme===M.Schemas.file?new h.$7M(P?.name||(0,R.$6e)(),E.fsPath,!P?.donotRotate,!!P?.donotUseFormatters,$):super.m(E,$,P)}registerLogger(E){super.registerLogger(E),this.n.$registerLogger(E)}deregisterLogger(E){super.deregisterLogger(E),this.n.$deregisterLogger(E)}}e.$mdc=A}),define(De[331],Ce([1,0,49,14,2,90,3,16,13,29]),function($e,e,D,M,h,R,A,g,E,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ldc=void 0;class P extends R.$4ac{constructor(){super(...arguments),this.i=null}async g(t){const s=await super.g(t);if(s.scheme!==g.Schemas.file)return s;if(this.b.skipWorkspaceStorageLock)return this.d.info(`Skipping acquiring lock for ${s.fsPath}.`),s;const o=s.fsPath;let n=0;do{let c;n===0?c=o:c=/[/\\]$/.test(o)?`${o.substr(0,o.length-1)}-${n}`:`${o}-${n}`,await I(c);const d=M.$$c(c,"vscode.lock"),v=await y(this.d,d,!1);if(v)return this.i=v,process.on("exit",()=>{v.dispose()}),h.URI.file(c);n++}while(n<10);return s}onWillDeactivateAll(){this.i?.setWillRelease(6e3)}}e.$ldc=P;async function I(f){try{await $.Promises.stat(f);return}catch{}try{await $.Promises.mkdir(f,{recursive:!0})}catch{}}const b=1e3,S=10*60*1e3;class C extends A.$mb{constructor(t,s){super(),this.b=t,this.c=s,this.a=this.B(new E.$Pg),this.a.cancelAndSet(async()=>{const o=await r(t,s);(!o||o.pid!==process.pid)&&(t.info(`Lock '${s}': The lock was lost unexpectedly.`),this.a.cancel());try{await $.Promises.utimes(s,new Date,new Date)}catch(n){t.error(n),t.info(`Lock '${s}': Could not update mtime.`)}},b)}dispose(){super.dispose();try{D.unlinkSync(this.c)}catch{}}async setWillRelease(t){this.b.info(`Lock '${this.c}': Marking the lockfile as scheduled to be released in ${t} ms.`);try{const s={pid:process.pid,willReleaseAt:Date.now()+t};await $.Promises.writeFile(this.c,JSON.stringify(s),{flag:"w"})}catch(s){this.b.error(s)}}}async function y(f,t,s){try{const n={pid:process.pid,willReleaseAt:0};await $.Promises.writeFile(t,JSON.stringify(n),{flag:"wx"})}catch(n){f.error(n)}const o=await r(f,t);return!o||o.pid!==process.pid?s?(f.info(`Lock '${t}': Could not acquire lock, giving up.`),null):(f.info(`Lock '${t}': Could not acquire lock, checking if the file is stale.`),m(f,t)):(f.info(`Lock '${t}': Lock acquired.`),new C(f,t))}async function r(f,t){let s;try{s=await $.Promises.readFile(t)}catch(o){return f.error(o),null}try{return JSON.parse(String(s))}catch(o){return f.error(o),null}}async function i(f,t){let s;try{s=await $.Promises.stat(t)}catch(o){return f.error(o),0}return s.mtime.getTime()}function a(f){try{return process.kill(f,0),!0}catch{return!1}}async function m(f,t){const s=await r(f,t);if(!s)return f.info(`Lock '${t}': Could not read pid of lock holder.`),p(f,t);if(s.willReleaseAt){let v=s.willReleaseAt-Date.now();if(v<5e3){for(v>0?f.info(`Lock '${t}': The lockfile is scheduled to be released in ${v} ms.`):f.info(`Lock '${t}': The lockfile is scheduled to have been released.`);v>0;){if(await(0,E.$Fg)(Math.min(100,v)),await i(f,t)===0)return p(f,t);v=s.willReleaseAt-Date.now()}return p(f,t)}}if(!a(s.pid))return f.info(`Lock '${t}': The pid ${s.pid} appears to be gone.`),p(f,t);const o=await i(f,t),n=Date.now()-o;if(n<=S)return f.info(`Lock '${t}': The lock does not look stale, elapsed: ${n} ms, giving up.`),null;f.info(`Lock '${t}': The lock looks stale, waiting for 2s.`),await(0,E.$Fg)(2e3);const c=await i(f,t),d=Date.now()-c;return d<=S?(f.info(`Lock '${t}': The lock does not look stale, elapsed: ${d} ms, giving up.`),null):(f.info(`Lock '${t}': The lock looks stale even after waiting for 2s.`),p(f,t))}async function p(f,t){f.info(`Lock '${t}': Deleting a stale lock.`);try{await $.Promises.unlink(t)}catch{}return y(f,t,!0)}}),define(De[332],Ce([1,0,31,20,42,33]),function($e,e,D,M,h,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gcc=void 0;let A=class extends h.$7ac{constructor(E,$){super(!0,E,$)}createTerminal(E,$,P){return this.createTerminalFromOptions({name:E,shellPath:$,shellArgs:P})}createTerminalFromOptions(E,$){const P=new h.$6ac(this.a,(0,D.$6e)(),E,E.name);return this.f.push(P),P.create(E,this.N(E,$)),P.value}};e.$Gcc=A,e.$Gcc=A=Ke([Ve(0,R.$eM),Ve(1,M.$UL)],A)}),define(De[333],Ce([1,0,13,21,22,8,4,3,128,284,64]),function($e,e,D,M,h,R,A,g,E,$,P){"use strict";var I;Object.defineProperty(e,"__esModule",{value:!0}),e.$92b=e.ResponsiveState=e.RequestInitiator=e.$82b=e.$72b=void 0;function b(l,w){try{return JSON.stringify(l,w)}catch{return"null"}}const S="$$ref$$",C={[S]:-1};class y{constructor(w,L){this.jsonString=w,this.referencedBuffers=L}}function r(l,w=null,L=!1){const N=[];return{jsonString:(L?b:JSON.stringify)(l,(T,O)=>{if(typeof O>"u")return C;if(typeof O=="object"){if(O instanceof M.$Hc){const B=N.push(O)-1;return{[S]:B}}if(w)return w(T,O)}return O}),referencedBuffers:N}}e.$72b=r;function i(l,w,L){return JSON.parse(l,(N,j)=>{if(j){const T=j[S];if(typeof T=="number")return w[T];if(L&&j.$mid===1)return L.transformIncoming(j)}return j})}e.$82b=i;function a(l,w){return JSON.stringify(l,w)}function m(l){return l?(w,L)=>L&&L.$mid===1?l.transformOutgoing(L):L:null}var p;(function(l){l[l.LocalSide=0]="LocalSide",l[l.OtherSide=1]="OtherSide"})(p||(e.RequestInitiator=p={}));var f;(function(l){l[l.Responsive=0]="Responsive",l[l.Unresponsive=1]="Unresponsive"})(f||(e.ResponsiveState=f={}));const t=()=>{},s=Symbol.for("rpcProtocol"),o=Symbol.for("rpcProxy");class n extends g.$mb{static{I=s}static{this.a=3*1e3}constructor(w,L=null,N=null){super(),this[I]=!0,this.b=this.B(new A.$hc),this.onDidChangeResponsiveState=this.b.event,this.c=w,this.f=L,this.g=N,this.h=m(this.g),this.j=!1,this.k=[],this.l=[];for(let j=0,T=P.$9z.count;j<T;j++)this.k[j]=null,this.l[j]=null;this.m=0,this.p=Object.create(null),this.s={},this.t=0,this.u=0,this.v=0,this.w=this.B(new D.$Qg(()=>this.C(),1e3)),this.c.onMessage(j=>this.G(j))}dispose(){this.j=!0,Object.keys(this.s).forEach(w=>{this.s[w].resolveErr(R.$4())})}drain(){return typeof this.c.drain=="function"?this.c.drain():Promise.resolve()}y(w){this.u===0&&(this.v=Date.now()+n.a),this.u++,this.w.isScheduled()||this.w.schedule()}z(w){this.v=Date.now()+n.a,this.u--,this.u===0&&this.w.cancel(),this.D(0)}C(){this.u!==0&&(Date.now()>this.v?this.D(1):this.w.schedule())}D(w){this.t!==w&&(this.t=w,this.b.fire(this.t))}get responsiveState(){return this.t}transformIncomingURIs(w){return this.g?(0,E.$Cm)(w,this.g):w}getProxy(w){const{nid:L,sid:N}=w;return this.l[L]||(this.l[L]=this.F(L,N)),this.l[L]}F(w,L){const N={get:(j,T)=>(typeof T=="string"&&!j[T]&&T.charCodeAt(0)===36&&(j[T]=(...O)=>this.O(w,T,O)),T===o?L:j[T])};return new Proxy(Object.create(null),N)}set(w,L){return this.k[w.nid]=L,L}assertRegistered(w){for(let L=0,N=w.length;L<N;L++){const j=w[L];if(!this.k[j.nid])throw new Error(`Missing proxy instance ${j.sid}`)}}G(w){if(this.j)return;const L=w.byteLength,N=c.read(w,0),j=N.readUInt8(),T=N.readUInt32();switch(j){case 1:case 2:{let{rpcId:O,method:B,args:F}=v.deserializeRequestJSONArgs(N);this.g&&(F=(0,E.$Cm)(F,this.g)),this.H(L,T,O,B,F,j===2);break}case 3:case 4:{let{rpcId:O,method:B,args:F}=v.deserializeRequestMixedArgs(N);this.g&&(F=(0,E.$Cm)(F,this.g)),this.H(L,T,O,B,F,j===4);break}case 5:{this.f?.logIncoming(L,T,0,"ack"),this.z(T);break}case 6:{this.I(L,T);break}case 7:{this.J(L,T,void 0);break}case 9:{let O=v.deserializeReplyOKJSON(N);this.g&&(O=(0,E.$Cm)(O,this.g)),this.J(L,T,O);break}case 10:{const O=v.deserializeReplyOKJSONWithBuffers(N,this.g);this.J(L,T,O);break}case 8:{const O=v.deserializeReplyOKVSBuffer(N);this.J(L,T,O);break}case 11:{let O=v.deserializeReplyErrError(N);this.g&&(O=(0,E.$Cm)(O,this.g)),this.L(L,T,O);break}case 12:{this.L(L,T,void 0);break}default:console.error("received unexpected message"),console.error(w)}}H(w,L,N,j,T,O){this.f?.logIncoming(w,L,1,`receiveRequest ${(0,P.$$z)(N)}.${j}(`,T);const B=String(L);let F,J;if(O){const me=new h.$rc;T.push(me.token),F=this.M(N,j,T),J=()=>me.cancel()}else F=this.M(N,j,T),J=t;this.p[B]=J;const K=v.serializeAcknowledged(L);this.f?.logOutgoing(K.byteLength,L,1,"ack"),this.c.send(K),F.then(me=>{delete this.p[B];const re=v.serializeReplyOK(L,me,this.h);this.f?.logOutgoing(re.byteLength,L,1,"reply:",me),this.c.send(re)},me=>{delete this.p[B];const re=v.serializeReplyErr(L,me);this.f?.logOutgoing(re.byteLength,L,1,"replyErr:",me),this.c.send(re)})}I(w,L){this.f?.logIncoming(w,L,1,"receiveCancel");const N=String(L);this.p[N]?.()}J(w,L,N){this.f?.logIncoming(w,L,0,"receiveReply:",N);const j=String(L);if(!this.s.hasOwnProperty(j))return;const T=this.s[j];delete this.s[j],T.resolveOk(N)}L(w,L,N){this.f?.logIncoming(w,L,0,"receiveReplyErr:",N);const j=String(L);if(!this.s.hasOwnProperty(j))return;const T=this.s[j];delete this.s[j];let O;N&&(N.$isError?(O=new Error,O.name=N.name,O.message=N.message,O.stack=N.stack):O=N),T.resolveErr(O)}M(w,L,N){try{return Promise.resolve(this.N(w,L,N))}catch(j){return Promise.reject(j)}}N(w,L,N){const j=this.k[w];if(!j)throw new Error("Unknown actor "+(0,P.$$z)(w));const T=j[L];if(typeof T!="function")throw new Error("Unknown method "+L+" on actor "+(0,P.$$z)(w));return T.apply(j,N)}O(w,L,N){if(this.j)return new $.$62b;let j=null;if(N.length>0&&h.CancellationToken.isCancellationToken(N[N.length-1])&&(j=N.pop()),j&&j.isCancellationRequested)return Promise.reject(R.$4());const T=v.serializeRequestArguments(N,this.h),O=++this.m,B=String(O),F=new $.$52b;j&&j.onCancellationRequested(()=>{const K=v.serializeCancel(O);this.f?.logOutgoing(K.byteLength,O,0,"cancel"),this.c.send(v.serializeCancel(O))}),this.s[B]=F,this.y(O);const J=v.serializeRequest(O,w,L,T,!!j);return this.f?.logOutgoing(J.byteLength,O,0,`request: ${(0,P.$$z)(w)}.${L}(`,N),this.c.send(J),F}}e.$92b=n;class c{static alloc(w,L,N){const j=new c(M.$Hc.alloc(N+1+4),0);return j.writeUInt8(w),j.writeUInt32(L),j}static read(w,L){return new c(w,L)}get buffer(){return this.a}constructor(w,L){this.a=w,this.b=L}static sizeUInt8(){return 1}static{this.sizeUInt32=4}writeUInt8(w){this.a.writeUInt8(w,this.b),this.b+=1}readUInt8(){const w=this.a.readUInt8(this.b);return this.b+=1,w}writeUInt32(w){this.a.writeUInt32BE(w,this.b),this.b+=4}readUInt32(){const w=this.a.readUInt32BE(this.b);return this.b+=4,w}static sizeShortString(w){return 1+w.byteLength}writeShortString(w){this.a.writeUInt8(w.byteLength,this.b),this.b+=1,this.a.set(w,this.b),this.b+=w.byteLength}readShortString(){const w=this.a.readUInt8(this.b);this.b+=1;const N=this.a.slice(this.b,this.b+w).toString();return this.b+=w,N}static sizeLongString(w){return 4+w.byteLength}writeLongString(w){this.a.writeUInt32BE(w.byteLength,this.b),this.b+=4,this.a.set(w,this.b),this.b+=w.byteLength}readLongString(){const w=this.a.readUInt32BE(this.b);this.b+=4;const N=this.a.slice(this.b,this.b+w).toString();return this.b+=w,N}writeBuffer(w){this.a.writeUInt32BE(w.byteLength,this.b),this.b+=4,this.a.set(w,this.b),this.b+=w.byteLength}static sizeVSBuffer(w){return 4+w.byteLength}writeVSBuffer(w){this.a.writeUInt32BE(w.byteLength,this.b),this.b+=4,this.a.set(w,this.b),this.b+=w.byteLength}readVSBuffer(){const w=this.a.readUInt32BE(this.b);this.b+=4;const L=this.a.slice(this.b,this.b+w);return this.b+=w,L}static sizeMixedArray(w){let L=0;L+=1;for(let N=0,j=w.length;N<j;N++){const T=w[N];switch(L+=1,T.type){case 1:L+=this.sizeLongString(T.value);break;case 2:L+=this.sizeVSBuffer(T.value);break;case 3:L+=this.sizeUInt32,L+=this.sizeLongString(T.value);for(let O=0;O<T.buffers.length;++O)L+=this.sizeVSBuffer(T.buffers[O]);break;case 4:break}}return L}writeMixedArray(w){this.a.writeUInt8(w.length,this.b),this.b+=1;for(let L=0,N=w.length;L<N;L++){const j=w[L];switch(j.type){case 1:this.writeUInt8(1),this.writeLongString(j.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(j.value);break;case 3:this.writeUInt8(3),this.writeUInt32(j.buffers.length),this.writeLongString(j.value);for(let T=0;T<j.buffers.length;++T)this.writeBuffer(j.buffers[T]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const w=this.a.readUInt8(this.b);this.b+=1;const L=new Array(w);for(let N=0;N<w;N++)switch(this.readUInt8()){case 1:L[N]=this.readLongString();break;case 2:L[N]=this.readVSBuffer();break;case 3:{const T=this.readUInt32(),O=this.readLongString(),B=[];for(let F=0;F<T;++F)B.push(this.readVSBuffer());L[N]=new P.$_z(i(O,B,null));break}case 4:L[N]=void 0;break}return L}}var d;(function(l){l[l.Simple=0]="Simple",l[l.Mixed=1]="Mixed"})(d||(d={}));class v{static a(w){for(let L=0,N=w.length;L<N;L++)if(w[L]instanceof M.$Hc||w[L]instanceof P.$_z||typeof w[L]>"u")return!0;return!1}static serializeRequestArguments(w,L){if(this.a(w)){const N=[];for(let j=0,T=w.length;j<T;j++){const O=w[j];if(O instanceof M.$Hc)N[j]={type:2,value:O};else if(typeof O>"u")N[j]={type:4};else if(O instanceof P.$_z){const{jsonString:B,referencedBuffers:F}=r(O.value,L);N[j]={type:3,value:M.$Hc.fromString(B),buffers:F}}else N[j]={type:1,value:M.$Hc.fromString(a(O,L))}}return{type:1,args:N}}return{type:0,args:a(w,L)}}static serializeRequest(w,L,N,j,T){switch(j.type){case 0:return this.b(w,L,N,j.args,T);case 1:return this.c(w,L,N,j.args,T)}}static b(w,L,N,j,T){const O=M.$Hc.fromString(N),B=M.$Hc.fromString(j);let F=0;F+=c.sizeUInt8(),F+=c.sizeShortString(O),F+=c.sizeLongString(B);const J=c.alloc(T?2:1,w,F);return J.writeUInt8(L),J.writeShortString(O),J.writeLongString(B),J.buffer}static deserializeRequestJSONArgs(w){const L=w.readUInt8(),N=w.readShortString(),j=w.readLongString();return{rpcId:L,method:N,args:JSON.parse(j)}}static c(w,L,N,j,T){const O=M.$Hc.fromString(N);let B=0;B+=c.sizeUInt8(),B+=c.sizeShortString(O),B+=c.sizeMixedArray(j);const F=c.alloc(T?4:3,w,B);return F.writeUInt8(L),F.writeShortString(O),F.writeMixedArray(j),F.buffer}static deserializeRequestMixedArgs(w){const L=w.readUInt8(),N=w.readShortString(),j=w.readMixedArray(),T=new Array(j.length);for(let O=0,B=j.length;O<B;O++){const F=j[O];typeof F=="string"?T[O]=JSON.parse(F):T[O]=F}return{rpcId:L,method:N,args:T}}static serializeAcknowledged(w){return c.alloc(5,w,0).buffer}static serializeCancel(w){return c.alloc(6,w,0).buffer}static serializeReplyOK(w,L,N){if(typeof L>"u")return this.d(w);if(L instanceof M.$Hc)return this.e(w,L);if(L instanceof P.$_z){const{jsonString:j,referencedBuffers:T}=r(L.value,N,!0);return this.g(w,j,T)}else return this.f(w,b(L,N))}static d(w){return c.alloc(7,w,0).buffer}static e(w,L){let N=0;N+=c.sizeVSBuffer(L);const j=c.alloc(8,w,N);return j.writeVSBuffer(L),j.buffer}static deserializeReplyOKVSBuffer(w){return w.readVSBuffer()}static f(w,L){const N=M.$Hc.fromString(L);let j=0;j+=c.sizeLongString(N);const T=c.alloc(9,w,j);return T.writeLongString(N),T.buffer}static g(w,L,N){const j=M.$Hc.fromString(L);let T=0;T+=c.sizeUInt32,T+=c.sizeLongString(j);for(const B of N)T+=c.sizeVSBuffer(B);const O=c.alloc(10,w,T);O.writeUInt32(N.length),O.writeLongString(j);for(const B of N)O.writeBuffer(B);return O.buffer}static deserializeReplyOKJSON(w){const L=w.readLongString();return JSON.parse(L)}static deserializeReplyOKJSONWithBuffers(w,L){const N=w.readUInt32(),j=w.readLongString(),T=[];for(let O=0;O<N;++O)T.push(w.readVSBuffer());return new P.$_z(i(j,T,L))}static serializeReplyErr(w,L){const N=L?b(R.$1(L),null):void 0;if(typeof N!="string")return this.h(w);const j=M.$Hc.fromString(N);let T=0;T+=c.sizeLongString(j);const O=c.alloc(11,w,T);return O.writeLongString(j),O.buffer}static deserializeReplyErrError(w){const L=w.readLongString();return JSON.parse(L)}static h(w){return c.alloc(12,w,0).buffer}}var k;(function(l){l[l.RequestJSONArgs=1]="RequestJSONArgs",l[l.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",l[l.RequestMixedArgs=3]="RequestMixedArgs",l[l.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",l[l.Acknowledged=5]="Acknowledged",l[l.Cancel=6]="Cancel",l[l.ReplyOKEmpty=7]="ReplyOKEmpty",l[l.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",l[l.ReplyOKJSON=9]="ReplyOKJSON",l[l.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",l[l.ReplyErrError=11]="ReplyErrError",l[l.ReplyErrEmpty=12]="ReplyErrEmpty"})(k||(k={}));var u;(function(l){l[l.String=1]="String",l[l.VSBuffer=2]="VSBuffer",l[l.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",l[l.Undefined=4]="Undefined"})(u||(u={}))}),define(De[334],Ce([1,0,4,41,47,6]),function($e,e,D,M,h,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9I=e.$8I=e.OutputChannelUpdateMode=e.$7I=e.$6I=e.$5I=e.$4I=e.$3I=e.$2I=e.$1I=e.$ZI=e.$YI=e.$XI=e.$WI=void 0,e.$WI="text/x-code-output",e.$XI="output",e.$YI="Log",e.$ZI="text/x-code-log-output",e.$1I="log",e.$2I="log",e.$3I="workbench.panel.output",e.$4I=new h.$Zi("inOutput",!1),e.$5I=new h.$Zi("activeLogOutput",!1),e.$6I=new h.$Zi("outputView.scrollLock",!1),e.$7I=(0,R.$zh)("outputService");var A;(function(E){E[E.Append=1]="Append",E[E.Replace=2]="Replace",E[E.Clear=3]="Clear"})(A||(e.OutputChannelUpdateMode=A={})),e.$8I={OutputChannels:"workbench.contributions.outputChannels"};class g{constructor(){this.a=new Map,this.b=new D.$hc,this.onDidRegisterChannel=this.b.event,this.c=new D.$hc,this.onDidRemoveChannel=this.c.event}registerChannel($){this.a.has($.id)||(this.a.set($.id,$),this.b.fire($.id))}getChannels(){const $=[];return this.a.forEach(P=>$.push(P)),$}getChannel($){return this.a.get($)}removeChannel($){this.a.delete($),this.c.fire($)}}M.$6m.add(e.$8I.OutputChannels,new g),e.$9I=new h.$Zi("activeOutputChannel","")}),define(De[150],Ce([1,0,5,6,20,25,17,334,67,26,52,176,21,18,30,4,3]),function($e,e,D,M,h,R,A,g,E,$,P,I,b,S,C,y,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nbc=e.$mbc=void 0;class i extends A.$9i{get disposed(){return this.l}constructor(f,t,s,o,n){super(),this.id=f,this.name=t,this.m=s,this.n=o,this.extension=n,this.k=0,this.l=!1,this.visible=!1,this.setLevel(s.getLevel()),this.B(s.onDidChangeLogLevel(c=>this.setLevel(c)))}get logLevel(){return this.getLevel()}appendLine(f){this.append(f+`
`)}append(f){this.info(f)}clear(){const f=this.k;this.m.flush(),this.n.$update(this.id,g.OutputChannelUpdateMode.Clear,f)}replace(f){const t=this.k;this.info(f),this.n.$update(this.id,g.OutputChannelUpdateMode.Replace,t),this.visible&&this.m.flush()}show(f,t){this.m.flush(),this.n.$reveal(this.id,!!(typeof f=="boolean"?f:t))}hide(){this.n.$close(this.id)}g(f,t){this.k+=b.$Hc.fromString(t).byteLength,(0,A.log)(this.m,f,t),this.visible&&(this.m.flush(),this.n.$update(this.id,g.OutputChannelUpdateMode.Append))}dispose(){super.dispose(),this.l||(this.n.$dispose(this.id),this.l=!0)}}class a extends i{appendLine(f){this.append(f)}}let m=class{constructor(f,t,s,o,n,c){this.i=t,this.j=s,this.k=o,this.l=n,this.m=c,this.d=new Map,this.f=1,this.g=new Map,this.h=null,this.a=f.getProxy(D.$SJ.MainThreadOutputService),this.b=this.k.extUri.joinPath(t.logsLocation,`output_logging_${(0,I.$5l)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(f){this.h=f;for(const[t,s]of this.g)s.visible=t===this.h}createOutputChannel(f,t,s){if(f=f.trim(),!f)throw new Error("illegal argument `name`. must not be falsy");const o=typeof t=="object"&&t.log,n=(0,S.$le)(t)?t:void 0;if((0,S.$le)(n)&&!n.trim())throw new Error("illegal argument `languageId`. must not be empty");let c;const d=this.i.environment.extensionLogLevel?.find(([k])=>R.$Tl.equals(s.identifier,k))?.[1];d&&(c=(0,A.$gj)(d));const v=o?this.o(f,c,s):this.n(f,n,s);return v.then(k=>{this.g.set(k.id,k),k.visible=k.id===this.h}),o?this.r(f,c??this.m.getLevel(),v):this.q(f,v)}async n(f,t,s){this.c||(this.c=this.j.value.createDirectory(this.b).then(()=>this.b));const o=await this.c,n=this.k.extUri.joinPath(o,`${this.f++}-${f.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),c=this.l.createLogger(n,{logLevel:"always",donotRotate:!0,donotUseFormatters:!0,hidden:!0}),d=await this.a.$register(f,n,t,s.identifier.value);return new i(d,f,c,this.a,s)}async o(f,t,s){const o=await this.p(s),n=f.replace(/[\\/:\*\?"<>\|]/g,""),c=this.k.extUri.joinPath(o,`${n}.log`),d=`${s.identifier.value}.${n}`,v=this.l.createLogger(c,{id:d,name:f,logLevel:t,extensionId:s.identifier.value});return new a(d,f,v,this.a,s)}p(f){let t=this.d.get(f.identifier.value);if(!t){const s=this.k.extUri.joinPath(this.i.logsLocation,f.identifier.value);this.d.set(f.identifier.value,t=(async()=>{try{await this.j.value.createDirectory(s)}catch(o){if((0,C.$gk)(o)!==C.FileSystemProviderErrorCode.FileExists)throw o}return s})())}return t}q(f,t){let s=!1;const o=()=>{if(s)throw new Error("Channel has been closed")};return{get name(){return f},append(n){o(),t.then(c=>c.append(n))},appendLine(n){o(),t.then(c=>c.appendLine(n))},clear(){o(),t.then(n=>n.clear())},replace(n){o(),t.then(c=>c.replace(n))},show(n,c){o(),t.then(d=>d.show(n,c))},hide(){o(),t.then(n=>n.hide())},dispose(){s=!0,t.then(n=>n.dispose())}}}r(f,t,s){const o=new r.$lb,n=()=>{if(o.isDisposed)throw new Error("Channel has been closed")},c=o.add(new y.$hc);function d(v){t=v,c.fire(v)}return s.then(v=>{o.add(v),v.logLevel!==t&&d(v.logLevel),o.add(v.onDidChangeLogLevel(k=>d(k)))}),{...this.q(f,s),get logLevel(){return t},onDidChangeLogLevel:c.event,trace(v,...k){n(),s.then(u=>u.trace(v,...k))},debug(v,...k){n(),s.then(u=>u.debug(v,...k))},info(v,...k){n(),s.then(u=>u.info(v,...k))},warn(v,...k){n(),s.then(u=>u.warn(v,...k))},error(v,...k){n(),s.then(u=>u.error(v,...k))},dispose(){o.dispose()}}}};e.$mbc=m,e.$mbc=m=Ke([Ve(0,h.$UL),Ve(1,$.$$L),Ve(2,E.$2ac),Ve(3,P.$wac),Ve(4,A.$4i),Ve(5,A.$3i)],m),e.$nbc=(0,M.$zh)("IExtHostOutputService")}),define(De[335],Ce([1,0,6,13]),function($e,e,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$im=e.$hm=void 0,e.$hm=(0,D.$zh)("remoteAgentService"),e.$im=new class{constructor(){this.maxSampleCount=5,this.sampleDelay=2e3,this.initial=[],this.maxInitialCount=3,this.average=[],this.maxAverageCount=100,this.highLatencyMultiple=2,this.highLatencyMinThreshold=500,this.highLatencyMaxThreshold=1500,this.lastMeasurement=void 0}get latency(){return this.lastMeasurement}async measure(h){let R=1/0;for(let g=0;g<this.maxSampleCount;g++){const E=await h.getRoundTripTime();if(E===void 0)return;R=Math.min(R,E/2),await(0,M.$Fg)(this.sampleDelay)}this.average.push(R),this.average.length>this.maxAverageCount&&this.average.shift();let A;return this.initial.length<this.maxInitialCount?this.initial.push(R):A=this.initial.reduce((g,E)=>g+E,0)/this.initial.length,this.lastMeasurement={initial:A,current:R,average:this.average.reduce((g,E)=>g+E,0)/this.average.length,high:(()=>typeof A>"u"?!1:R>this.highLatencyMaxThreshold||R>this.highLatencyMinThreshold&&R>A*this.highLatencyMultiple)()},this.lastMeasurement}}}),define(De[336],Ce([1,0,32,16,14,9,24,2,6,251,51,276,335]),function($e,e,D,M,h,R,A,g,E,$,P,I,b){"use strict";var S;Object.defineProperty(e,"__esModule",{value:!0}),e.$pJ=e.$oJ=void 0,e.$oJ=(0,E.$zh)("pathService");let C=S=class{constructor(r,i,a,m){this.d=r,this.e=i,this.f=a,this.g=m,this.a=(async()=>(await this.e.getEnvironment())?.os||R.OS)(),this.b=(async()=>{const p=await this.e.getEnvironment();return this.c=p?.userHome??r})()}hasValidBasename(r,i,a){return typeof i=="string"||typeof i>"u"?this.a.then(m=>this.h(r,m,i)):this.h(r,i,a)}h(r,i,a){return r.scheme===M.Schemas.file||r.scheme===M.Schemas.vscodeRemote?(0,D.$Ie)(a??(0,A.$dg)(r),i===1):!0}get defaultUriScheme(){return S.findDefaultUriScheme(this.f,this.g)}static findDefaultUriScheme(r,i){if(r.remoteAuthority)return M.Schemas.vscodeRemote;const a=(0,$.$lJ)(i.getWorkspace());if(a)return a;const m=i.getWorkspace().folders[0];if(m)return m.uri.scheme;const p=i.getWorkspace().configuration;return p?p.scheme:M.Schemas.file}userHome(r){return r?.preferLocal?this.d:this.b}get resolvedUserHome(){return this.c}get path(){return this.a.then(r=>r===1?h.$7c:h.$8c)}async fileURI(r){let i="";if(await this.a===1&&(r=r.replace(/\\/g,"/")),r[0]==="/"&&r[1]==="/"){const m=r.indexOf("/",2);m===-1?(i=r.substring(2),r="/"):(i=r.substring(2,m),r=r.substring(m)||"/")}return g.URI.from({scheme:M.Schemas.file,authority:i,path:r,query:"",fragment:""})}};e.$pJ=C,e.$pJ=C=S=Ke([Ve(1,b.$hm),Ve(2,I.$0I),Ve(3,P.$Ih)],C)}),define(De[92],Ce([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.$$H=e.$0H=void 0;class D{constructor(A,g){this.line=A,this.character=g}isBefore(A){return!1}isBeforeOrEqual(A){return!1}isAfter(A){return!1}isAfterOrEqual(A){return!1}isEqual(A){return!1}compareTo(A){return 0}translate(A,g){return new D(0,0)}with(A){return new D(0,0)}}e.$0H=D;class M{constructor(A,g,E,$){this.isEmpty=!1,this.isSingleLine=!1,this.start=new D(A,g),this.end=new D(E,$)}contains(A){return!1}isEqual(A){return!1}intersection(A){}union(A){return new M(0,0,0,0)}with(A){return new M(0,0,0,0)}}e.$$H=M;var h;(function(R){R[R.Information=1]="Information",R[R.Warning=2]="Warning"})(h||(e.TextSearchCompleteMessageType=h={}))}),define(De[36],Ce([1,0,19,35,23,32,15,6,14,8,92,13]),function($e,e,D,M,h,R,A,g,E,$,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zI=e.$yI=e.$xI=e.$wI=e.$vI=e.$uI=e.$tI=e.$sI=e.$rI=e.$qI=e.$pI=e.$oI=e.SearchErrorCode=e.$nI=e.$mI=e.SearchSortOrder=e.ViewMode=e.$lI=e.$kI=e.$jI=e.$iI=e.SearchCompletionExitCode=e.$hI=e.$gI=e.$fI=e.QueryType=e.SearchProviderType=e.$eI=e.$dI=e.$cI=e.$bI=e.$aI=e.$_H=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return P.TextSearchCompleteMessageType}}),e.$_H="workbench.view.search",e.$aI="workbench.panel.search",e.$bI="workbench.view.search",e.$cI="search-result",e.$dI="search.exclude";const b="\u27EA ",S=" characters skipped \u27EB",C=(b.length+S.length+5)*2;e.$eI=(0,g.$zh)("searchService");var y;(function(q){q[q.file=0]="file",q[q.text=1]="text"})(y||(e.SearchProviderType=y={}));var r;(function(q){q[q.File=1]="File",q[q.Text=2]="Text"})(r||(e.QueryType=r={}));function i(q){return!!q.preview}e.$fI=i;function a(q){return!!q.resource}e.$gI=a;function m(q){return!!q.message}e.$hI=m;var p;(function(q){q[q.Normal=0]="Normal",q[q.NewSearchStarted=1]="NewSearchStarted"})(p||(e.SearchCompletionExitCode=p={}));class f{constructor(ee){this.resource=ee,this.results=[]}}e.$iI=f;class t{constructor(ee,pe,ce,_){this.ranges=pe,this.webviewIndex=_;const Q=Array.isArray(pe)?pe:[pe];if(ce&&ce.matchLines===1&&s(Q)){ee=(0,A.$ee)(ee,ce.matchLines);let z="",V=0,G=0;const ae=Math.floor(ce.charsPerLine/5),ne=[];for(const he of Q){const Ee=Math.max(he.startColumn-ae,0),de=he.startColumn+ce.charsPerLine;if(Ee>G+ae+C){const ge=b+(Ee-G)+S;z+=ge+ee.slice(Ee,de),V+=Ee-(G+ge.length)}else z+=ee.slice(G,de);ne.push(new n(0,he.startColumn-V,he.endColumn-V)),G=de}this.preview={text:z,matches:Array.isArray(this.ranges)?ne:ne[0]}}else{const z=Array.isArray(pe)?pe[0].startLineNumber:pe.startLineNumber;this.preview={text:ee,matches:(0,D.$Uf)(pe,V=>new o(V.startLineNumber-z,V.startColumn,V.endLineNumber-z,V.endColumn))}}}}e.$jI=t;function s(q){const ee=q[0].startLineNumber;for(const pe of q)if(pe.startLineNumber!==ee||pe.endLineNumber!==ee)return!1;return!0}class o{constructor(ee,pe,ce,_){this.startLineNumber=ee,this.startColumn=pe,this.endLineNumber=ce,this.endColumn=_}}e.$kI=o;class n extends o{constructor(ee,pe,ce){super(ee,pe,ee,ce)}}e.$lI=n;var c;(function(q){q.List="list",q.Tree="tree"})(c||(e.ViewMode=c={}));var d;(function(q){q.Default="default",q.FileNames="fileNames",q.Type="type",q.Modified="modified",q.CountDescending="countDescending",q.CountAscending="countAscending"})(d||(e.SearchSortOrder=d={}));function v(q,ee=!0){const pe=q&&q.files&&q.files.exclude,ce=ee&&q&&q.search&&q.search.exclude;if(!pe&&!ce)return;if(!pe||!ce)return pe||ce;let _=Object.create(null);return _=h.$Wm(_,h.$Tm(pe)),_=h.$Wm(_,h.$Tm(ce),!0),_}e.$mI=v;function k(q,ee){return q.excludePattern&&M.$oj(q.excludePattern,ee)?!1:q.includePattern||q.usingSearchPaths?q.includePattern&&M.$oj(q.includePattern,ee)?!0:q.usingSearchPaths?!!q.folderQueries&&q.folderQueries.some(pe=>{const ce=pe.folder.fsPath;if(R.$Ke(ee,ce)){const _=E.$ad(ce,ee);return!pe.includePattern||!!M.$oj(pe.includePattern,_)}else return!1}):!1:!0}e.$nI=k;var u;(function(q){q[q.unknownEncoding=1]="unknownEncoding",q[q.regexParseError=2]="regexParseError",q[q.globParseError=3]="globParseError",q[q.invalidLiteral=4]="invalidLiteral",q[q.rgProcessError=5]="rgProcessError",q[q.other=6]="other",q[q.canceled=7]="canceled"})(u||(e.SearchErrorCode=u={}));class l extends Error{constructor(ee,pe){super(ee),this.code=pe}}e.$oI=l;function w(q){const ee=q.message;if((0,$.$2)(q))return new l(ee,u.canceled);try{const pe=JSON.parse(ee);return new l(pe.message,pe.code)}catch{return new l(ee,u.other)}}e.$pI=w;function L(q){const ee={message:q.message,code:q.code};return new Error(JSON.stringify(ee))}e.$qI=L;function N(q){return q.type==="error"?!0:q.type==="success"}e.$rI=N;function j(q){return q.type==="success"}e.$sI=j;function T(q){return!!q.path}e.$tI=T;function O(q,ee){const pe=q.searchPath?q.searchPath:q.relativePath;return(0,A.$be)(pe,ee)}e.$uI=O;class B{constructor(ee){this.path=ee,this.results=[]}addMatch(ee){this.results.push(ee)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.$vI=B;function F(q,ee){const pe={...q||{},...ee||{}};return Object.keys(pe).filter(ce=>{const _=pe[ce];return typeof _=="boolean"&&_})}e.$wI=F;class J{constructor(ee,pe){this.c=null,this.a={...ee.excludePattern||{},...pe.excludePattern||{}},this.b=M.$pj(this.a);let ce=ee.includePattern;pe.includePattern&&(ce?ce={...ce,...pe.includePattern}:ce=pe.includePattern),ce&&(this.c=M.$pj(ce))}matchesExcludesSync(ee,pe,ce){return!!(this.b&&this.b(ee,pe,ce))}includedInQuerySync(ee,pe,ce){return!(this.b&&this.b(ee,pe,ce)||this.c&&!this.c(ee,pe,ce))}includedInQuery(ee,pe,ce){const _=this.b(ee,pe,ce),Q=()=>this.c?!!this.c(ee,pe,ce):!0;return(0,I.$rg)(_)?_.then(z=>z?!1:Q()):Q()}hasSiblingExcludeClauses(){return K(this.a)}}e.$xI=J;function K(q){for(const ee in q)if(typeof q[ee]!="boolean")return!0;return!1}function me(q){if(!q)return;let ee;return pe=>(ee||(ee=(q()||Promise.resolve([])).then(ce=>ce?x(ce):{})),ee.then(ce=>!!ce[pe]))}e.$yI=me;function re(q){if(!q)return;let ee;return pe=>{if(!ee){const ce=q();ee=ce?x(ce):{}}return!!ee[pe]}}e.$zI=re;function x(q){const ee={};for(const pe of q)ee[pe]=!0;return ee}}),define(De[38],Ce([1,0,19,13,22,4,3,75,16,119,24,15,2,209,6,17,237,51,52,26,20,10,7,62,36,5]),function($e,e,D,M,h,R,A,g,E,$,P,I,b,S,C,y,r,i,a,m,p,f,t,s,o,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jac=e.$Iac=void 0;function c(N,j,T){return new P.$8f(O=>u(O,T)).isEqual(N,j)}function d(N,j,T){return c(N.uri,j.uri,T)?0:(0,I.$Hd)(N.uri.toString(),j.uri.toString())}function v(N,j,T){return N.index!==j.index?N.index<j.index?-1:1:c(N.uri,j.uri,T)?(0,I.$Hd)(N.name,j.name):(0,I.$Hd)(N.uri.toString(),j.uri.toString())}function k(N,j,T,O){const B=N.slice(0).sort((J,K)=>T(J,K,O)),F=j.slice(0).sort((J,K)=>T(J,K,O));return(0,D.$xf)(B,F,(J,K)=>T(J,K,O))}function u(N,j){const T=j.getCapabilities(N.scheme);return!(T&&T&1024)}class l extends i.$Sh{static toExtHostWorkspace(j,T,O,B){if(!j)return{workspace:null,added:[],removed:[]};const{id:F,name:J,folders:K,configuration:me,transient:re,isUntitled:x}=j,q=[],ee=T;T?K.forEach((Q,z)=>{const V=b.URI.revive(Q.uri),G=l.o(O||T,V,B);G?(G.name=Q.name,G.index=Q.index,q.push(G)):q.push({uri:V,name:Q.name,index:z})}):q.push(...K.map(({uri:Q,name:z,index:V})=>({uri:b.URI.revive(Q),name:z,index:V}))),q.sort((Q,z)=>Q.index<z.index?-1:1);const pe=new l(F,J,q,!!re,me?b.URI.revive(me):null,!!x,Q=>u(Q,B)),{added:ce,removed:_}=k(ee?ee.workspaceFolders:[],pe.workspaceFolders,d,B);return{workspace:pe,added:ce,removed:_}}static o(j,T,O){for(let B=0;B<j.folders.length;B++){const F=j.workspaceFolders[B];if(c(F.uri,T,O))return F}}constructor(j,T,O,B,F,J,K){super(j,O.map(me=>new i.$Th(me)),B,F,K),this.t=T,this.u=J,this.q=[],this.s=g.$Fh.forUris(K),O.forEach(me=>{this.q.push(me),this.s.set(me.uri,me)})}get name(){return this.t}get isUntitled(){return this.u}get workspaceFolders(){return this.q.slice(0)}getWorkspaceFolder(j,T){return T&&this.s.get(j)&&(j=(0,P.$fg)(j)),this.s.findSubstr(j)}resolveWorkspaceFolder(j){return this.s.get(j)}}let w=class{constructor(j,T,O,B,F){this.c=new R.$hc,this.onDidChangeWorkspace=this.c.event,this.g=new R.$hc,this.onDidGrantWorkspaceTrust=this.g.event,this.u=[],this.v=!1,this.w=new Map,this.z=0,this.A=new R.$jc,this.B=new Map,this.h=B,this.s=O,this.t=F,this.j=new $.$Hl,this.k=new M.$Dg,this.o=j.getProxy(n.$SJ.MainThreadWorkspace),this.q=j.getProxy(n.$SJ.MainThreadMessageService);const J=T.workspace;this.l=J?new l(J.id,J.name,[],!!J.transient,J.configuration?b.URI.revive(J.configuration):null,!!J.isUntitled,K=>u(K,O)):void 0}$initializeWorkspace(j,T){this.v=T,this.$acceptWorkspaceData(j),this.k.open()}waitForInitializeCall(){return this.k.wait()}get workspace(){return this.x}get name(){return this.x?this.x.name:void 0}get workspaceFile(){if(this.x&&this.x.configuration)return this.x.isUntitled?b.URI.from({scheme:E.Schemas.untitled,path:(0,P.$dg)((0,P.$fg)(this.x.configuration))}):this.x.configuration}get x(){return this.n||this.l}getWorkspaceFolders(){if(this.x)return this.x.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this.k.wait(),!!this.x)return this.x.workspaceFolders.slice(0)}updateWorkspaceFolders(j,T,O,...B){const F=[];if(Array.isArray(B)&&B.forEach(x=>{b.URI.isUri(x.uri)&&!F.some(q=>c(q.uri,x.uri,this.s))&&F.push({uri:x.uri,name:x.name||(0,P.$cg)(x.uri)})}),this.n||[T,O].some(x=>typeof x!="number"||x<0)||O===0&&F.length===0)return!1;const J=this.x?this.x.workspaceFolders:[];if(T+O>J.length)return!1;const K=J.slice(0);K.splice(T,O,...F.map(x=>({uri:x.uri,name:x.name||(0,P.$cg)(x.uri),index:void 0})));for(let x=0;x<K.length;x++){const q=K[x];if(K.some((ee,pe)=>pe!==x&&c(q.uri,ee.uri,this.s)))return!1}K.forEach((x,q)=>x.index=q);const{added:me,removed:re}=k(J,K,v,this.s);if(me.length===0&&re.length===0)return!1;if(this.o){const x=j.displayName||j.name;this.o.$updateWorkspaceFolders(x,T,O,F).then(void 0,q=>{this.n=void 0;const ee={source:{identifier:j.identifier,label:j.displayName||j.name}};this.q.$showMessage(r.Severity.Error,(0,S.localize)(0,null,x,q.toString()),ee,[])})}return this.y(K),!0}getWorkspaceFolder(j,T){if(this.x)return this.x.getWorkspaceFolder(j,T)}async getWorkspaceFolder2(j,T){if(await this.k.wait(),!!this.x)return this.x.getWorkspaceFolder(j,T)}async resolveWorkspaceFolder(j){if(await this.k.wait(),!!this.x)return this.x.resolveWorkspaceFolder(j)}getPath(){if(!this.x)return;const{folders:j}=this.x;if(j.length!==0)return j[0].uri.fsPath}getRelativePath(j,T){let O,B="";if(typeof j=="string"?(O=b.URI.file(j),B=j):typeof j<"u"&&(O=j,B=j.fsPath),!O)return B;const F=this.getWorkspaceFolder(O,!0);if(!F)return B;typeof T>"u"&&this.x&&(T=this.x.folders.length>1);let J=(0,P.$ig)(F.uri,O);return T&&F.name&&(J=`${F.name}/${J}`),J}y(j){this.x&&(this.n=l.toExtHostWorkspace({id:this.x.id,name:this.x.name,configuration:this.x.configuration,folders:j,isUntitled:this.x.isUntitled},this.x,void 0,this.s).workspace||void 0)}$acceptWorkspaceData(j){const{workspace:T,added:O,removed:B}=l.toExtHostWorkspace(j,this.l,this.n,this.s);this.l=T||void 0,this.n=void 0,this.c.fire(Object.freeze({added:O,removed:B}))}findFiles(j,T,O,B,F=h.CancellationToken.None){this.h.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${B.value}, entryPoint: findFiles`);let J;if(T===null?J=!1:T&&(typeof T=="string"?J=T:J=T.pattern),F&&F.isCancellationRequested)return Promise.resolve([]);const{includePattern:K,folder:me}=L(f.GlobPattern.from(j));return this.o.$startFileSearch(K??null,me??null,J??null,O??null,F).then(re=>Array.isArray(re)?re.map(x=>b.URI.revive(x)):[])}async findTextInFiles(j,T,O,B,F=h.CancellationToken.None){this.h.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${B.value}, entryPoint: findTextInFiles`);const J=this.j.getNext(),K=typeof T.previewOptions>"u"?{matchLines:100,charsPerLine:1e4}:T.previewOptions,{includePattern:me,folder:re}=L(f.GlobPattern.from(T.include)),x=typeof T.exclude=="string"?T.exclude:T.exclude?T.exclude.pattern:void 0,q={ignoreSymlinks:typeof T.followSymlinks=="boolean"?!T.followSymlinks:void 0,disregardIgnoreFiles:typeof T.useIgnoreFiles=="boolean"?!T.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof T.useGlobalIgnoreFiles=="boolean"?!T.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof T.useParentIgnoreFiles=="boolean"?!T.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof T.useDefaultExcludes=="boolean"?!T.useDefaultExcludes:!0,fileEncoding:T.encoding,maxResults:T.maxResults,previewOptions:K,afterContext:T.afterContext,beforeContext:T.beforeContext,includePattern:me,excludePattern:x},ee=!1;if(this.u[J]=pe=>{if(ee)return;const ce=b.URI.revive(pe.resource);pe.results.forEach(_=>{(0,o.$fI)(_)?O({uri:ce,preview:{text:_.preview.text,matches:(0,D.$Uf)(_.preview.matches,Q=>new t.$WJ(Q.startLineNumber,Q.startColumn,Q.endLineNumber,Q.endColumn))},ranges:(0,D.$Uf)(_.ranges,Q=>new t.$WJ(Q.startLineNumber,Q.startColumn,Q.endLineNumber,Q.endColumn))}):O({uri:ce,text:_.text,lineNumber:_.lineNumber})})},F.isCancellationRequested)return{};try{const pe=await this.o.$startTextSearch(j,re??null,q,J,F);return delete this.u[J],pe||{}}catch(pe){throw delete this.u[J],pe}}$handleTextSearchResult(j,T){this.u[T]?.(j)}async save(j){const T=await this.o.$save(j,{saveAs:!1});return b.URI.revive(T)}async saveAs(j){const T=await this.o.$save(j,{saveAs:!0});return b.URI.revive(T)}saveAll(j){return this.o.$saveAll(j)}resolveProxy(j){return this.o.$resolveProxy(j)}get trusted(){return this.v}requestWorkspaceTrust(j){return this.o.$requestWorkspaceTrust(j)}$onDidGrantWorkspaceTrust(){this.v||(this.v=!0,this.g.fire())}registerEditSessionIdentityProvider(j,T){if(this.w.has(j))throw new Error(`A provider has already been registered for scheme ${j}`);this.w.set(j,T);const O=this.t.transformOutgoingScheme(j),B=this.z++;return this.o.$registerEditSessionIdentityProvider(B,O),(0,A.$kb)(()=>{this.w.delete(j),this.o.$unregisterEditSessionIdentityProvider(B)})}async $getEditSessionIdentifier(j,T){this.h.info("Getting edit session identifier for workspaceFolder",j);const O=await this.resolveWorkspaceFolder(b.URI.revive(j));if(!O){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",O);const B=this.w.get(O.uri.scheme);if(this.h.info(`Provider for scheme ${O.uri.scheme} is defined: `,!!B),!B)return;const F=await B.provideEditSessionIdentity(O,T);if(this.h.info("Provider returned edit session identifier: ",F),!!F)return F}async $provideEditSessionIdentityMatch(j,T,O,B){this.h.info("Getting edit session identifier for workspaceFolder",j);const F=await this.resolveWorkspaceFolder(b.URI.revive(j));if(!F){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",F);const J=this.w.get(F.uri.scheme);if(this.h.info(`Provider for scheme ${F.uri.scheme} is defined: `,!!J),!J)return;const K=await J.provideEditSessionIdentityMatch?.(T,O,B);if(this.h.info("Provider returned edit session identifier match result: ",K),!!K)return K}getOnWillCreateEditSessionIdentityEvent(j){return(T,O,B)=>{const F=function(K){T.call(O,K)};return F.extension=j,this.A.event(F,void 0,B)}}async $onWillCreateEditSessionIdentity(j,T,O){const B=await this.resolveWorkspaceFolder(b.URI.revive(j));if(B===void 0)throw new Error("Unable to resolve workspace folder");await this.A.fireAsync({workspaceFolder:B},T,async(F,J)=>{const K=Date.now();await Promise.resolve(F),Date.now()-K>O&&this.h.warn("SLOW edit session create-participant",J.extension.identifier)}),T.isCancellationRequested}registerCanonicalUriProvider(j,T){if(this.B.has(j))throw new Error(`A provider has already been registered for scheme ${j}`);this.B.set(j,T);const O=this.t.transformOutgoingScheme(j),B=this.z++;return this.o.$registerCanonicalUriProvider(B,O),(0,A.$kb)(()=>{this.B.delete(j),this.o.$unregisterCanonicalUriProvider(B)})}async provideCanonicalUri(j,T,O){const B=this.B.get(j.scheme);if(!B)return;const F=await B.provideCanonicalUri?.(b.URI.revive(j),T,O);if(F)return F}async $provideCanonicalUri(j,T,O){return this.provideCanonicalUri(b.URI.revive(j),{targetScheme:T},O)}};e.$Iac=w,e.$Iac=w=Ke([Ve(0,p.$UL),Ve(1,m.$$L),Ve(2,a.$wac),Ve(3,y.$3i),Ve(4,s.$Gac)],w),e.$Jac=(0,C.$zh)("IExtHostWorkspace");function L(N){let j,T;return N&&(typeof N=="string"?j=N:(j=N.pattern,T=b.URI.revive(N.baseUri))),{includePattern:j,folder:T}}}),define(De[39],Ce([1,0,23,4,38,5,7,239,135,18,13,6,20,17,2]),function($e,e,D,M,h,R,A,g,E,$,P,I,b,S,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mac=e.$Lac=e.$Kac=void 0;function y(s,o){if(o){const n=o.split(".");let c=s;for(let d=0;c&&d<n.length;d++)c=c[n[d]];return c}}function r(s){return s instanceof C.URI}function i(s){return s&&s.uri instanceof C.URI&&s.languageId&&typeof s.languageId=="string"}function a(s){return s&&!s.uri&&s.languageId&&typeof s.languageId=="string"}function m(s){return s&&s.uri instanceof C.URI&&(!s.name||typeof s.name=="string")&&(!s.index||typeof s.index=="number")}function p(s){if(r(s))return{resource:s};if(i(s))return{resource:s.uri,overrideIdentifier:s.languageId};if(a(s))return{overrideIdentifier:s.languageId};if(m(s))return{resource:s.uri};if(s===null)return{resource:null}}let f=class{constructor(o,n,c){this.a=o.getProxy(R.$SJ.MainThreadConfiguration),this.c=n,this.b=c,this.d=new P.$Dg,this.e=null}getConfigProvider(){return this.d.wait().then(o=>this.e)}$initializeConfiguration(o){this.e=new t(this.a,this.c,o,this.b),this.d.open()}$acceptConfigurationChanged(o,n){this.getConfigProvider().then(c=>c.$acceptConfigurationChanged(o,n))}};e.$Kac=f,e.$Kac=f=Ke([Ve(0,b.$UL),Ve(1,h.$Jac),Ve(2,S.$3i)],f);class t{constructor(o,n,c,d){this.a=new M.$hc,this.b=o,this.f=d,this.c=n,this.e=g.$rn.parse(c),this.d=this.k(c.configurationScopes)}get onDidChangeConfiguration(){return this.a&&this.a.event}$acceptConfigurationChanged(o,n){const c={data:this.e.toData(),workspace:this.c.workspace};this.e=g.$rn.parse(o),this.d=this.k(o.configurationScopes),this.a.fire(this.j(n,c))}getConfiguration(o,n,c){const d=p(n)||{},v=this.g(o?y(this.e.getValue(void 0,d,this.c.workspace),o):this.e.getValue(void 0,d,this.c.workspace));o&&this.h(o,d,c?.identifier);function k(l){if(l==null)return null;if(typeof l=="boolean")return l?2:5;switch(l){case A.ConfigurationTarget.Global:return 2;case A.ConfigurationTarget.Workspace:return 5;case A.ConfigurationTarget.WorkspaceFolder:return 6}}const u={has(l){return typeof y(v,l)<"u"},get:(l,w)=>{this.h(o?`${o}.${l}`:l,d,c?.identifier);let L=y(v,l);if(typeof L>"u")L=w;else{let N;const j=(T,O)=>{if((0,$.$ne)(T)){let B;const F=()=>{N=N||(0,D.$Tm)(v),B=B||y(N,O)};return new Proxy(T,{get:(J,K)=>{if(typeof K=="string"&&K.toLowerCase()==="tojson")return F(),()=>B;if(N)return B=B||y(N,O),B[K];const me=J[K];return typeof K=="string"?j(me,`${O}.${K}`):me},set:(J,K,me)=>(F(),B&&(B[K]=me),!0),deleteProperty:(J,K)=>(F(),B&&delete B[K],!0),defineProperty:(J,K,me)=>(F(),B&&Object.defineProperty(B,K,me),!0)})}return Array.isArray(T)?(0,D.$Tm)(T):T};L=j(L,l)}return L},update:(l,w,L,N)=>{l=o?`${o}.${l}`:l;const j=k(L);return w!==void 0?this.b.$updateConfigurationOption(j,l,w,d,N):this.b.$removeConfigurationOption(j,l,d,N)},inspect:l=>{l=o?`${o}.${l}`:l;const w=this.e.inspect(l,d,this.c.workspace);if(w)return{key:l,defaultValue:(0,D.$Tm)(w.policy?.value??w.default?.value),globalValue:(0,D.$Tm)(w.user?.value??w.application?.value),workspaceValue:(0,D.$Tm)(w.workspace?.value),workspaceFolderValue:(0,D.$Tm)(w.workspaceFolder?.value),defaultLanguageValue:(0,D.$Tm)(w.default?.override),globalLanguageValue:(0,D.$Tm)(w.user?.override??w.application?.override),workspaceLanguageValue:(0,D.$Tm)(w.workspace?.override),workspaceFolderLanguageValue:(0,D.$Tm)(w.workspaceFolder?.override),languageIds:(0,D.$Tm)(w.overrideIdentifiers)}}};return typeof v=="object"&&(0,D.$Wm)(u,v,!1),Object.freeze(u)}g(o){const n=c=>(0,$.$ne)(c)?new Proxy(c,{get:(d,v)=>n(d[v]),set:(d,v,k)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(v)}' of object`)},deleteProperty:(d,v)=>{throw new Error(`TypeError: Cannot delete read only property '${String(v)}' of object`)},defineProperty:(d,v)=>{throw new Error(`TypeError: Cannot define property '${String(v)}' for a readonly object`)},setPrototypeOf:d=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):c;return n(o)}h(o,n,c){const d=E.$in.test(o)?4:this.d.get(o),v=c?`[${c.value}] `:"";if(d===4){typeof n?.resource>"u"&&this.f.warn(`${v}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${o}', provide the URI of a resource or 'null' for any resource.`);return}if(d===3){n?.resource&&this.f.warn(`${v}Accessing a window scoped configuration for a resource is not expected. To associate '${o}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}j(o,n){const c=new g.$tn(o,n,this.e,this.c.workspace);return Object.freeze({affectsConfiguration:(d,v)=>c.affectsConfiguration(d,p(v))})}k(o){return o.reduce((n,c)=>(n.set(c[0],c[1]),n),new Map)}}e.$Lac=t,e.$Mac=(0,I.$zh)("IExtHostConfiguration")}),define(De[93],Ce([1,0,2,13,4,5,7,38,65,39,22,42,20,26,6,16,9,17,89,283,8]),function($e,e,D,M,h,R,A,g,E,$,P,I,b,S,C,y,r,i,a,m,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kbc=e.$Jbc=e.$Ibc=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=void 0;var f;(function(j){function T(B){if(B!=null)return B}j.from=T;function O(B){if(B!=null)return B}j.to=O})(f||(f={}));var t;(function(j){function T(B){if(B!=null)return B}j.from=T;function O(B){if(B!=null)return B}j.to=O})(t||(t={}));var s;(function(j){function T(B){if(B!=null)return B}j.from=T;function O(B){if(B!=null)return B}j.to=O})(s||(s={}));var o;(function(j){function T(F){if(F){const J=F;return J&&!!J.process}else return!1}j.is=T;function O(F){if(F==null)return;const J={process:F.process,args:F.args};return F.options&&(J.options=s.from(F.options)),J}j.from=O;function B(F){if(F!=null)return new A.$DK(F.process,F.args,F.options)}j.to=B})(o||(o={}));var n;(function(j){function T(B){if(B!=null)return B}j.from=T;function O(B){if(B!=null)return B}j.to=O})(n||(n={}));var c;(function(j){function T(F){if(F){const J=F;return J&&(!!J.commandLine||!!J.command)}else return!1}j.is=T;function O(F){if(F==null)return;const J={};return F.commandLine!==void 0?J.commandLine=F.commandLine:(J.command=F.command,J.args=F.args),F.options&&(J.options=n.from(F.options)),J}j.from=O;function B(F){if(!(F==null||F.command===void 0&&F.commandLine===void 0))return F.commandLine?new A.$EK(F.commandLine,F.options):new A.$EK(F.command,F.args?F.args:[],F.options)}j.to=B})(c||(c={}));var d;(function(j){function T(F){if(F){const J=F;return J&&J.customExecution==="customExecution"}else return!1}j.is=T;function O(F){return{customExecution:"customExecution"}}j.from=O;function B(F,J){return J.get(F)}j.to=B})(d||(e.CustomExecutionDTO=d={}));var v;(function(j){function T(O,B){let F;return O.scope!==void 0&&typeof O.scope!="number"?F=O.scope.uri:O.scope!==void 0&&typeof O.scope=="number"&&(O.scope===A.TaskScope.Workspace&&B&&B.workspaceFile?F=B.workspaceFile:F=m.$8F),{id:O._id,workspaceFolder:F}}j.from=T})(v||(e.TaskHandleDTO=v={}));var k;(function(j){function T(O){if(O!=null)return{_id:O.id,isDefault:O.isDefault}}j.from=T})(k||(k={}));var u;(function(j){function T(F,J){if(F==null)return[];const K=[];for(const me of F){const re=O(me,J);re&&K.push(re)}return K}j.fromMany=T;function O(F,J){if(F==null)return;let K;F.execution instanceof A.$DK?K=o.from(F.execution):F.execution instanceof A.$EK?K=c.from(F.execution):F.execution&&F.execution instanceof A.$FK&&(K=d.from(F.execution));const me=f.from(F.definition);let re;return F.scope?typeof F.scope=="number"?re=F.scope:re=F.scope.uri:re=A.TaskScope.Workspace,!me||!re?void 0:{_id:F._id,definition:me,name:F.name,source:{extensionId:J.identifier.value,label:F.source,scope:re},execution:K,isBackground:F.isBackground,group:k.from(F.group),presentationOptions:t.from(F.presentationOptions),problemMatchers:F.problemMatchers,hasDefinedMatchers:F.hasDefinedMatchers,runOptions:F.runOptions?F.runOptions:{reevaluateOnRerun:!0},detail:F.detail}}j.from=O;async function B(F,J,K){if(F==null)return;let me;o.is(F.execution)?me=o.to(F.execution):c.is(F.execution)?me=c.to(F.execution):d.is(F.execution)&&(me=d.to(F._id,K));const re=f.to(F.definition);let x;if(F.source&&(F.source.scope!==void 0?typeof F.source.scope=="number"?x=F.source.scope:x=await J.resolveWorkspaceFolder(D.URI.revive(F.source.scope)):x=A.TaskScope.Workspace),!re||!x)return;const q=new A.$GK(re,x,F.name,F.source.label,me,F.problemMatchers);return F.isBackground!==void 0&&(q.isBackground=F.isBackground),F.group!==void 0&&(q.group=A.$CK.from(F.group._id),q.group&&F.group.isDefault&&(q.group=new A.$CK(q.group.id,q.group.label),F.group.isDefault===!0&&(q.group.isDefault=F.group.isDefault))),F.presentationOptions&&(q.presentationOptions=t.to(F.presentationOptions)),F._id&&(q._id=F._id),F.detail&&(q.detail=F.detail),q}j.to=B})(u||(e.TaskDTO=u={}));var l;(function(j){function T(B){return B}j.from=T;function O(B){if(B)return Object.assign(Object.create(null),B)}j.to=O})(l||(l={}));class w{#e;constructor(T,O,B){this._id=O,this.a=B,this.#e=T}get task(){return this.a}terminate(){this.#e.terminateTask(this)}fireDidStartProcess(T){}fireDidEndProcess(T){}}let L=class{constructor(T,O,B,F,J,K,me,re){this.q=new h.$hc,this.r=new h.$hc,this.s=new h.$hc,this.t=new h.$hc,this.a=T.getProxy(R.$SJ.MainThreadTask),this.b=B,this.c=F,this.d=J,this.e=K,this.h=0,this.j=new Map,this.k=new Map,this.l=new Map,this.m=new Map,this.n=new Set,this.o=new Map,this.f=me,this.g=re,this.a.$registerSupportedExecutions(!0)}registerTaskProvider(T,O,B){if(!B)return new A.$UJ(()=>{});const F=this.w();return this.j.set(F,{type:O,provider:B,extension:T}),this.a.$registerTaskProvider(F,O),new A.$UJ(()=>{this.j.delete(F),this.a.$unregisterTaskProvider(F)})}registerTaskSystem(T,O){this.a.$registerTaskSystem(T,O)}fetchTasks(T){return this.a.$fetchTasks(l.from(T)).then(async O=>{const B=[];for(const F of O){const J=await u.to(F,this.b,this.m);J&&B.push(J)}return B})}get taskExecutions(){const T=[];return this.k.forEach(O=>T.push(O)),T}terminateTask(T){if(!(T instanceof w))throw new Error("No valid task execution provided");return this.a.$terminateTask(T._id)}get onDidStartTask(){return this.q.event}async $onDidStartTask(T,O,B){const F=this.m.get(T.id);F&&(this.o.set(T.id,F),this.e.attachPtyToTerminal(O,await F.callback(B))),this.p=T.id,this.q.fire({execution:await this.y(T)})}get onDidEndTask(){return this.r.event}async $OnDidEndTask(T){const O=await this.y(T);this.l.delete(T.id),this.k.delete(T.id),this.A(T),this.r.fire({execution:O})}get onDidStartTaskProcess(){return this.s.event}async $onDidStartTaskProcess(T){const O=await this.y(T.id);this.s.fire({execution:O,processId:T.processId})}get onDidEndTaskProcess(){return this.t.event}async $onDidEndTaskProcess(T){const O=await this.y(T.id);this.t.fire({execution:O,exitCode:T.exitCode})}$provideTasks(T,O){const B=this.j.get(T);if(!B)return Promise.reject(new Error("no handler found"));const F=[],J=(0,M.$xg)(()=>B.provider.provideTasks(P.CancellationToken.None)).then(K=>this.u(O,F,B,K));return new Promise(K=>{J.then(me=>{Promise.all(F).then(()=>{K(me)})})})}async $resolveTask(T,O){const B=this.j.get(T);if(!B)return Promise.reject(new Error("no handler found"));if(O.definition.type!==B.type)throw new Error(`Unexpected: Task of type [${O.definition.type}] cannot be resolved by provider of type [${B.type}].`);const F=await u.to(O,this.b,this.m);if(!F)throw new Error("Unexpected: Task cannot be resolved.");const J=await B.provider.resolveTask(F,P.CancellationToken.None);if(!J)return;this.z(J,B);const K=u.from(J,B.extension);if(!K)throw new Error("Unexpected: Task cannot be resolved.");if(J.definition!==F.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return d.is(K.execution)&&await this.x(K,J,!0),await this.v(K)}w(){return this.h++}async x(T,O,B){const F=await this.a.$createTaskId(T);!B&&!this.m.has(F)&&(this.n.add(F),this.o.set(F,O.execution)),this.m.set(F,O.execution)}async y(T,O){if(typeof T=="string"){const J=this.l.get(T);if(!J)throw new p.$_("Unexpected: The specified task is missing an execution");return J}const B=this.l.get(T.id);if(B)return B;const F=new Promise((J,K)=>{function me(re,x,q){q?J(new w(re,x.id,q)):K("Unexpected: Task does not exist.")}O?me(this,T,O):u.to(T.task,this.b,this.m).then(re=>me(this,T,re))});return this.l.set(T.id,F),F.then(J=>(this.k.set(T.id,J),J),J=>Promise.reject(J))}z(T,O){T._deprecated&&this.g.report("Task.constructor",O.extension,"Use the Task constructor that takes a `scope` instead.")}A(T){this.o.get(T.id)&&this.o.delete(T.id),this.n.has(T.id)&&this.p!==T.id&&(this.m.delete(T.id),this.n.delete(T.id));const B=this.n.values();let F=B.next();for(;!F.done;)!this.o.has(F.value)&&this.p!==F.value&&(this.m.delete(F.value),this.n.delete(F.value)),F=B.next()}};e.$Ibc=L,e.$Ibc=L=Ke([Ve(0,b.$UL),Ve(1,S.$$L),Ve(2,g.$Jac),Ve(3,E.$6L),Ve(4,$.$Mac),Ve(5,I.$5ac),Ve(6,i.$3i),Ve(7,a.$zac)],L);let N=class extends L{constructor(T,O,B,F,J,K,me,re){super(T,O,B,F,J,K,me,re),this.registerTaskSystem(y.Schemas.vscodeRemote,{scheme:y.Schemas.vscodeRemote,authority:"",platform:r.$h(0)})}async executeTask(T,O){if(!O.execution)throw new Error("Tasks to execute must include an execution");const B=u.from(O,T);if(B===void 0)throw new Error("Task is not valid");if(d.is(B.execution))await this.x(B,O,!1);else throw new p.$0;const F=await this.y(await this.a.$getTaskExecution(B),O);return this.a.$executeTask(B).catch(J=>{throw new Error(J)}),F}u(T,O,B,F){const J=[];if(F)for(const K of F){this.z(K,B),(!K.definition||!T[K.definition.type])&&this.f.warn(`The task [${K.source}, ${K.name}] uses an undefined task type. The task will be ignored in the future.`);const me=u.from(K,B.extension);me&&d.is(me.execution)?(J.push(me),O.push(this.x(me,K,!0))):this.f.warn("Only custom execution tasks supported.")}return{tasks:J,extension:B.extension}}async v(T){if(d.is(T.execution))return T;this.f.warn("Only custom execution tasks supported.")}async $resolveVariables(T,O){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(T,O,B){}};e.$Jbc=N,e.$Jbc=N=Ke([Ve(0,b.$UL),Ve(1,S.$$L),Ve(2,g.$Jac),Ve(3,E.$6L),Ve(4,$.$Mac),Ve(5,I.$5ac),Ve(6,i.$3i),Ve(7,a.$zac)],N),e.$Kbc=(0,C.$zh)("IExtHostTask")}),define(De[337],Ce([1,0,14,22,44,35,24,37,36]),function($e,e,D,M,h,R,A,g,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ubc=void 0;class ${constructor(b,S,C){this.k=b,this.l=S,this.o=C,this.e=!1,this.f=0,this.g=!1,this.a=b.filePattern,this.b=b.includePattern&&R.$pj(b.includePattern),this.c=b.maxResults||void 0,this.d=b.exists,this.h=new Set,this.j=b.excludePattern&&R.$pj(b.excludePattern)}cancel(){this.g=!0,this.h.forEach(b=>b.cancel()),this.h=new Set}search(b){const S=this.k.folderQueries||[];return new Promise((C,y)=>{const r=i=>{this.f++,b(i)};if(this.g)return C({limitHit:this.e});this.k.extraFileResources&&this.k.extraFileResources.forEach(i=>{const a=i.toString(),m=D.$cd(a);this.j&&this.j(a,m)||this.v(r,{base:i,basename:m})}),Promise.all(S.map(i=>this.p(i,r))).then(i=>{C({limitHit:this.e,stats:i[0]||void 0})},i=>{y(new Error((0,h.$ki)(i)))})})}async p(b,S){const C=new M.$rc,y=this.q(b),r=this.r(),i=new E.$xI(this.k,b),a=!i.hasSiblingExcludeClauses();let m;try{this.h.add(C),m=g.$dc.create();const p=await this.l.provideFileSearchResults({pattern:this.k.filePattern||""},y,C.token),f=m.elapsed(),t=g.$dc.create();return this.g&&!this.e||(p&&p.forEach(s=>{const o=D.$8c.relative(b.folder.path,s.path);if(a){const n=D.$cd(s.path);this.v(S,{base:b.folder,relativePath:o,basename:n});return}this.s(r,b.folder,o,S)}),this.g&&!this.e)?null:(this.u(r,i,S),{providerTime:f,postProcessTime:t.elapsed()})}finally{C.dispose(),this.h.delete(C)}}q(b){const S=(0,E.$wI)(this.k.includePattern,b.includePattern),C=(0,E.$wI)(this.k.excludePattern,b.excludePattern);return{folder:b.folder,excludes:C,includes:S,useIgnoreFiles:!b.disregardIgnoreFiles,useGlobalIgnoreFiles:!b.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!b.disregardParentIgnoreFiles,followSymlinks:!b.ignoreSymlinks,maxResults:this.k.maxResults,session:this.o}}r(){const b={rootEntries:[],pathToEntries:Object.create(null)};return b.pathToEntries["."]=b.rootEntries,b}s({pathToEntries:b},S,C,y){if(C===this.a){const i=D.$cd(this.a);this.v(y,{base:S,relativePath:this.a,basename:i})}function r(i){const a=D.$cd(i),m=D.$bd(i);let p=b[m];p||(p=b[m]=[],r(m)),p.push({base:S,relativePath:i,basename:a})}r(C)}u({rootEntries:b,pathToEntries:S},C,y){const r=this,i=this.a;function a(m){const p=(0,E.$zI)(()=>m.map(f=>f.basename));for(let f=0,t=m.length;f<t;f++){const s=m[f],{relativePath:o,basename:n}=s;if(C.matchesExcludesSync(o,n,i!==n?p:void 0))continue;const c=S[o];if(c)a(c);else{if(o===i)continue;r.v(y,s)}if(r.e)break}}a(b)}v(b,S){(!this.b||S.relativePath&&this.b(S.relativePath,S.basename))&&((this.d||this.c&&this.f>=this.c)&&(this.e=!0,this.cancel()),this.e||b(S))}}class P{constructor(){this.b=new Map}static{this.a=512}fileSearch(b,S,C,y){const r=this.c(b.cacheKey),i=new $(b,S,r&&r.token);let a=0;const m=p=>{a+=p.length,C(p.map(f=>this.d(f)))};return this.e(i,P.a,m,y).then(p=>({limitHit:p.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:a,detailStats:p.stats}}))}clearCache(b){this.c(b)?.cancel()}c(b){if(b)return this.b.has(b)||this.b.set(b,new M.$rc),this.b.get(b)}d(b){return b.relativePath?{resource:A.$gg(b.base,b.relativePath)}:{resource:b.base}}e(b,S,C,y){const r=y.onCancellationRequested(()=>{b.cancel()}),i=m=>{m&&(a.push(m),S>0&&a.length>=S&&(C(a),a=[]))};let a=[];return b.search(i).then(m=>(a.length&&C(a),r.dispose(),m),m=>(a.length&&C(a),r.dispose(),Promise.reject(m)))}}e.$Ubc=P}),define(De[338],Ce([1,0,19,69,35,127,28,16,14,24,15,18,2,170,220,50,17,51,142,336,36]),function($e,e,D,M,h,R,A,g,E,$,P,I,b,S,C,y,r,i,a,m,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rJ=e.$qJ=void 0;let f=class{constructor(l,w,L,N,j){this.a=l,this.b=w,this.c=L,this.d=N,this.e=j}text(l,w,L={}){l=this.f(l,L);const N=this.a.getValue(),j=w&&w.some(O=>!this.a.getValue({resource:O}).search.useRipgrep);return{...this.h(w?.map(i.$Uh),L),type:2,contentPattern:l,previewOptions:L.previewOptions,maxFileSize:L.maxFileSize,usePCRE2:N.search.usePCRE2||j||!1,beforeContext:L.beforeContext,afterContext:L.afterContext,userDisabledExcludesAndIgnoreFiles:L.disregardExcludeSettings&&L.disregardIgnoreFiles}}f(l,w){const L=this.a.getValue();l.isRegExp&&(l.pattern=l.pattern.replace(/\r?\n/g,"\\n"));const N={...l,wordSeparators:L.editor.wordSeparators};return this.j(l,w)&&(N.isCaseSensitive=!0),this.k(l)&&(N.isMultiline=!0),w.notebookSearchConfig?.includeMarkupInput&&(N.notebookInfo||(N.notebookInfo={}),N.notebookInfo.isInNotebookMarkdownInput=w.notebookSearchConfig.includeMarkupInput),w.notebookSearchConfig?.includeMarkupPreview&&(N.notebookInfo||(N.notebookInfo={}),N.notebookInfo.isInNotebookMarkdownPreview=w.notebookSearchConfig.includeMarkupPreview),w.notebookSearchConfig?.includeCodeInput&&(N.notebookInfo||(N.notebookInfo={}),N.notebookInfo.isInNotebookCellInput=w.notebookSearchConfig.includeCodeInput),w.notebookSearchConfig?.includeOutput&&(N.notebookInfo||(N.notebookInfo={}),N.notebookInfo.isInNotebookCellOutput=w.notebookSearchConfig.includeOutput),N}file(l,w={}){return{...this.h(l,w),type:1,filePattern:w.filePattern?w.filePattern.trim():w.filePattern,exists:w.exists,sortByScore:w.sortByScore,cacheKey:w.cacheKey}}g(l,w){return l?(l=Array.isArray(l)?l.map(c):c(l),w?this.parseSearchPaths(l):{pattern:s(...Array.isArray(l)?l:[l])}):{}}h(l=[],w={}){const L=this.g(w.includePattern,w.expandPatterns),N=this.g(w.excludePattern,w.expandPatterns),j=l.length>1,T=(L.searchPaths&&L.searchPaths.length?L.searchPaths.map(F=>this.q(F,w,N)):l.map(F=>this.r(F,w,N,j))).filter(F=>!!F),O={_reason:w._reason,folderQueries:T,usingSearchPaths:!!(L.searchPaths&&L.searchPaths.length),extraFileResources:w.extraFileResources,excludePattern:N.pattern,includePattern:L.pattern,onlyOpenEditors:w.onlyOpenEditors,maxResults:w.maxResults};if(w.onlyOpenEditors){const F=D.$Af(D.$Kf(this.c.groups.map(me=>me.editors.map(re=>re.resource))));this.d.trace("QueryBuilder#commonQuery - openEditor URIs",JSON.stringify(F));const J=F.filter(me=>(0,p.$nI)(O,me.fsPath)),K=this.i(J);return this.d.trace("QueryBuilder#commonQuery - openEditor Query",JSON.stringify(K)),{...O,...K}}const B=w.extraFileResources&&w.extraFileResources.filter(F=>(0,p.$nI)(O,F.fsPath));return O.extraFileResources=B&&B.length?B:void 0,O}i(l){const w=[],L=new A.$xi,N={};let j=!1;return l.forEach(T=>{if(T.scheme===g.Schemas.walkThrough)return;if((0,$.$kg)(T)){const B=this.b.getWorkspaceFolder(T)?.uri??T.with({path:E.$bd(T.fsPath)});let F=L.get(B);F||(j=!0,F={folder:B,includePattern:{}},w.push(F),L.set(B,F));const J=E.$ad(B.fsPath,T.fsPath);(0,I.$we)(F.includePattern)[J.replace(/\\/g,"/")]=!0}else T.fsPath&&(j=!0,N[T.fsPath]=!0)}),{folderQueries:w,includePattern:N,usingSearchPaths:!0,excludePattern:j?void 0:{"**/*":!0}}}j(l,w){if(w.isSmartCase){if(l.isRegExp){if(P.$ce(l.pattern,!0))return!0}else if(P.$ce(l.pattern))return!0}return!!l.isCaseSensitive}k(l){return l.isMultiline||l.isRegExp&&(0,S.$eC)(l.pattern)||l.pattern.indexOf(`
`)>=0?!0:!!l.isMultiline}parseSearchPaths(l){const w=K=>E.$0c(K)||/^\.\.?([\/\\]|$)/.test(K),N=(Array.isArray(l)?l:o(l)).map(K=>{const me=this.e.resolvedUserHome;return me?(0,R.$dA)(K,me.scheme===g.Schemas.file?me.fsPath:me.path):K}),j=M.$I(N,K=>w(K)?"searchPaths":"exprSegments"),T=(j.exprSegments||[]).map(K=>P.$xd(K,"/")).map(K=>P.$xd(K,"\\")).map(K=>(K[0]==="."&&(K="*"+K),n(K))),O={},B=this.m(j.searchPaths||[]);B&&B.length&&(O.searchPaths=B);const F=D.$Kf(T),J=s(...F);return J&&(O.pattern=J),O}l(l,w){return w.disregardExcludeSettings?void 0:(0,p.$mI)(l,!w.disregardSearchExcludeSettings)}m(l){if(!l||!l.length)return[];const w=l.flatMap(N=>{let{pathPortion:j,globPortion:T}=t(N);return T&&(T=d(T)),this.n(j).flatMap(B=>this.o(B,T))}),L=new Map;return w.forEach(N=>{const j=N.searchPath.toString(),T=L.get(j);T?N.pattern&&(T.pattern=T.pattern||{},T.pattern[N.pattern]=!0):L.set(j,{searchPath:N.searchPath,pattern:N.pattern?s(N.pattern):void 0})}),Array.from(L.values())}n(l){if(E.$0c(l)){const w=this.b.getWorkspace().folders;return w[0]&&w[0].uri.scheme!==g.Schemas.file?[{searchPath:w[0].uri.with({path:l})}]:[{searchPath:b.URI.file(E.$9c(l))}]}if(this.b.getWorkbenchState()===2){const w=this.b.getWorkspace().folders[0].uri;if(l=c(l),l.startsWith("../")||l===".."){const N=E.$8c.resolve(w.path,l);return[{searchPath:w.with({path:N})}]}const L=d(l);return[{searchPath:w,pattern:L}]}else{if(l==="./"||l===".\\")return[];{const w=l.replace(/^\.[\/\\]/,""),N=this.b.getWorkspace().folders.map(j=>{const T=w.match(new RegExp(`^${P.$sd(j.name)}(?:/(.*)|$)`));return T?{match:T,folder:j}:null}).filter(I.$te);if(N.length)return N.map(j=>{const T=j.match[1];return{searchPath:j.folder.uri,pattern:T&&d(T)}});{const j=l.match(/\.[\/\\](.+)[\/\\]?/),T=j?j[1]:l,O=C.localize(0,null,T);throw new Error(O)}}}}o(l,w){const L=l.pattern&&w?`${l.pattern}/${w}`:l.pattern||w,N=[{searchPath:l.searchPath,pattern:L}];return L&&!L.endsWith("**")&&N.push({searchPath:l.searchPath,pattern:L+"/**"}),N}q(l,w,L){const N=this.r((0,i.$Uh)(l.searchPath),w,L,!1);return N?{...N,includePattern:l.pattern}:null}r(l,w,L,N){let j;const T=b.URI.isUri(l)?l:l.uri;if(L.searchPaths){const K=L.searchPaths.filter(me=>(0,$.$_f)(me.searchPath,T))[0];if(K&&!K.pattern)return null;K&&(j=K.pattern)}const O=this.a.getValue({resource:T}),F={...this.l(O,w)||{},...j||{}},J=b.URI.isUri(l)?(0,$.$dg)(l):l.name;return{folder:T,folderName:N?J:void 0,excludePattern:Object.keys(F).length>0?F:void 0,fileEncoding:O.files&&O.files.encoding,disregardIgnoreFiles:typeof w.disregardIgnoreFiles=="boolean"?w.disregardIgnoreFiles:!O.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof w.disregardGlobalIgnoreFiles=="boolean"?w.disregardGlobalIgnoreFiles:!O.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof w.disregardParentIgnoreFiles=="boolean"?w.disregardParentIgnoreFiles:!O.search.useParentIgnoreFiles,ignoreSymlinks:typeof w.ignoreSymlinks=="boolean"?w.ignoreSymlinks:!O.search.followSymlinks}}};e.$qJ=f,e.$qJ=f=Ke([Ve(0,y.$6h),Ve(1,i.$Ih),Ve(2,a.$1C),Ve(3,r.$3i),Ve(4,m.$oJ)],f);function t(u){const l=u.match(/[\*\{\}\(\)\[\]\?]/);if(l){const w=l.index,L=u.substr(0,w).match(/[/|\\][^/\\]*$/);if(L){let N=u.substr(0,L.index);return N.match(/[/\\]/)||(N+="/"),{pathPortion:N,globPortion:u.substr((L.index||0)+1)}}}return{pathPortion:u}}function s(...u){return u.length?u.reduce((l,w)=>(l[w]=!0,l),Object.create(null)):void 0}function o(u){return h.$nj(u,",").map(l=>l.trim()).filter(l=>!!l.length)}function n(u){return[`**/${u}/**`,`**/${u}`].map(w=>w.replace(/\*\*\/\*\*/g,"**"))}function c(u){return u.replace(/\\/g,"/")}function d(u){return c(u).replace(/^\.\//,"").replace(/\/+$/g,"")}function v(u){return u.replace(/([?*[\]])/g,"[$1]")}function k(u,l){u=D.$Ff(u,N=>N.toString());const w=[],L=l.getWorkspace();return u&&u.forEach(N=>{let j;if(l.getWorkbenchState()===2)j=(0,$.$ig)(L.folders[0].uri,N),j&&j!=="."&&(j="./"+j);else{const T=l.getWorkspaceFolder(N);if(T){const O=T.name;if(L.folders.filter(F=>F.name===O).length===1){const F=(0,$.$ig)(T.uri,N);F===""?j=`./${T.name}`:j=`./${T.name}/${F}`}else j=N.fsPath}}j&&w.push(v(j))}),w}e.$rJ=k}),define(De[339],Ce([1,0,24,2,22,8,6,338,36,51]),function($e,e,D,M,h,R,A,g,E,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$blb=e.$alb=void 0;const P=7e3;function I(y,r){const i=r.activationEvents;if(!i)return Promise.resolve(void 0);const a=[],m=[];for(const n of i)if(/^workspaceContains:/.test(n)){const c=n.substr(18);c.indexOf("*")>=0||c.indexOf("?")>=0||y.forceUsingSearch?m.push(c):a.push(c)}if(a.length===0&&m.length===0)return Promise.resolve(void 0);let p;const f=new Promise((n,c)=>{p=n}),t=n=>p({activationEvent:n}),s=Promise.all(a.map(n=>b(y,n,t))).then(()=>{}),o=S(y,r.identifier,m,t);return Promise.all([s,o]).then(()=>{p(void 0)}),f}e.$alb=I;async function b(y,r,i){for(const a of y.folders)if(await y.exists(D.$gg(M.URI.revive(a),r))){i(`workspaceContains:${r}`);return}}async function S(y,r,i,a){if(i.length===0)return Promise.resolve(void 0);const m=new h.$rc,p=y.checkExists(y.folders,i,m.token),f=setTimeout(async()=>{m.cancel(),y.logService.info(`Not activating extension '${r.value}': Timed out while searching for 'workspaceContains' pattern ${i.join(",")}`)},P);let t=!1;try{t=await p}catch(s){R.$2(s)||R.$Y(s)}m.dispose(),clearTimeout(f),t&&a(`workspaceContains:${i.join(",")}`)}function C(y,r,i,a){const m=y.get(A.$yh),p=y.get(E.$eI),t=m.createInstance(g.$qJ).file(r.map(s=>(0,$.$Uh)(M.URI.revive(s))),{_reason:"checkExists",includePattern:i,exists:!0});return p.fileSearch(t,a).then(s=>!!s.limitHit,s=>R.$2(s)?!1:Promise.reject(s))}e.$blb=C}),define(De[43],Ce([1,0,199,14,61,24,13,3,75,2,17,5,39,278,114,38,27,146,8,25,21,253,7,84,6,26,90,20,103,68,42,4,339,113,255,16,111,37,9,112]),function($e,e,D,M,h,R,A,g,E,$,P,I,b,S,C,y,r,i,a,m,p,f,t,s,o,n,c,d,v,k,u,l,w,L,N,j,T,O,B,F){"use strict";var J;Object.defineProperty(e,"__esModule",{value:!0}),e.$hbc=e.$gbc=e.$fbc=e.$ebc=e.$dbc=void 0,e.$dbc=(0,o.$zh)("IHostUtils");let K=J=class extends g.$mb{constructor(_,Q,z,V,G,ae,ne,he,Ee,de,ge,ie){super(),this.R=ie,this.a=this.B(new l.$hc),this.onDidChangeRemoteConnectionData=this.a.event,this.P=!1,this.c=Q,this.g=z,this.f=ne,this.j=V,this.k=G,this.l=ae,this.m=Ee,this.p=de,this.s=ge,this.t=this.g.getProxy(I.$SJ.MainThreadWorkspace),this.u=this.g.getProxy(I.$SJ.MainThreadTelemetry),this.v=this.g.getProxy(I.$SJ.MainThreadExtensionService),this.w=new A.$Dg,this.y=new A.$Dg,this.z=new A.$Dg,this.C=new A.$Dg,this.D=new pe(this.f.activationEvents),this.G=new i.$12b(this.D,this.f.allExtensions);const ue=new m.$Ul(this.f.myExtensions);this.F=new i.$12b(this.D,q(this.G,ue)),this.H=new C.$Wac(this.g,this.l),this.I=new L.$9ac(this.g),this.J=he,this.h=_.createChild(new v.$xh([C.$Xac,this.H],[L.$0ac,this.I])),this.L=this.B(new S.$Vac(this.F,this.G,{onExtensionActivationError:(we,Pe,U)=>{this.v.$onExtensionActivationError(we,a.$1(Pe),U)},actualActivateExtension:async(we,Pe)=>{if(i.$12b.isHostExtension(we,this.F,this.G))return await this.v.$activateExtension(we,Pe),new S.$Uac;const U=this.F.getExtensionDescription(we);return this.$(U,Pe)}},this.l)),this.M=null,this.N=Object.create(null),this.O=!1,this.Q=this.f.remote.connectionData}getRemoteConnectionData(){return this.Q}async initialize(){try{await this.pb(),this.w.open(),await this.j.waitForInitializeCall(),h.mark("code/extHost/ready"),this.y.open(),this.f.autoStart&&this.nb()}catch(_){a.$Y(_)}}async S(){this.J.onWillDeactivateAll();let _=[];try{_=this.F.getAllExtensionDescriptions().map(G=>G.identifier).filter(G=>this.isActivated(G)).map(G=>this.Z(G))}catch{}await Promise.all(_)}terminate(_,Q=0){if(this.P)return;this.P=!0,this.l.info(`Extension host terminating: ${_}`),this.l.flush(),this.p.dispose(),this.L.dispose(),a.setUnexpectedErrorHandler(V=>{this.l.error(V)}),this.g.dispose();const z=this.S();Promise.race([(0,A.$Fg)(5e3),z]).finally(()=>{this.c.pid?this.l.info(`Extension host with pid ${this.c.pid} exiting with code ${Q}`):this.l.info(`Extension host exiting with code ${Q}`),this.l.flush(),this.l.dispose(),this.c.exit(Q)})}isActivated(_){return this.z.isOpen()?this.L.isActivated(_):!1}async getExtension(_){const Q=await this.v.$getExtension(_);return Q&&{...Q,identifier:new m.$Tl(Q.identifier.value),extensionLocation:$.URI.revive(Q.extensionLocation)}}U(_,Q){return this.L.activateByEvent(_,Q)}W(_,Q){return this.L.activateById(_,Q)}activateByIdWithErrors(_,Q){return this.W(_,Q).then(()=>{const z=this.L.getActivatedExtension(_);if(z.activationFailed)return Promise.reject(z.activationFailedError)})}getExtensionRegistry(){return this.z.wait().then(_=>this.F)}getExtensionExports(_){if(this.z.isOpen())return this.L.getActivatedExtension(_).exports;try{return this.L.getActivatedExtension(_).exports}catch{return null}}async X(_){if(_.scheme===j.Schemas.file&&this.c.fsRealpath){const Q=await this.c.fsRealpath(_.fsPath);return $.URI.file(Q)}return _}async getExtensionPathIndex(){return this.M||(this.M=this.Y(this.F.getAllExtensionDescriptions()).then(_=>new ee(_))),this.M}async Y(_){const Q=E.$Fh.forUris(z=>R.$0f.ignorePathCasing(z));return await Promise.all(_.map(async z=>{if(this.qb(z)){const V=await this.X(z.extensionLocation);Q.set(V,z)}})),Q}Z(_){let Q=Promise.resolve(void 0);if(!this.z.isOpen()||!this.L.isActivated(_))return Q;const z=this.L.getActivatedExtension(_);if(!z)return Q;try{typeof z.module.deactivate=="function"&&(Q=Promise.resolve(z.module.deactivate()).then(void 0,V=>(this.l.error(V),Promise.resolve(void 0))))}catch(V){this.l.error(`An error occurred when deactivating the extension '${_.value}':`),this.l.error(V)}try{(0,g.$hb)(z.subscriptions)}catch(V){this.l.error(`An error occurred when deactivating the subscriptions for extension '${_.value}':`),this.l.error(V)}return Q}async $(_,Q){return this.f.remote.isRemote?this.v.$onWillActivateExtension(_.identifier):await this.v.$onWillActivateExtension(_.identifier),this.bb(_,Q).then(z=>{const V=z.activationTimes;return this.v.$onDidActivateExtension(_.identifier,V.codeLoadingTime,V.activateCallTime,V.activateResolvedTime,Q),this.ab(_,Q,"success",V),z},z=>{throw this.ab(_,Q,"failure"),z})}ab(_,Q,z,V){const G=re(_,Q);this.u.$publicLog2("extensionActivationTimes",{...G,...V||{},outcome:z})}bb(_,Q){const z=re(_,Q);this.u.$publicLog2("activatePlugin",z);const V=this.qb(_);if(!V)return Promise.resolve(new S.$Tac(S.$Qac.NONE));this.l.info(`ExtensionService#_doActivateExtension ${_.identifier.value}, startup: ${Q.startup}, activationEvent: '${Q.activationEvent}'${_.identifier.value!==Q.extensionId.value?`, root cause: ${Q.extensionId.value}`:""}`),this.l.flush();const G=new S.$Rac(Q.startup);return Promise.all([this.rb(_,(0,R.$gg)(_.extensionLocation,V),G),this.cb(_)]).then(ae=>(h.mark(`code/extHost/willActivateExtension/${_.identifier.value}`),J.db(this.l,_.identifier,ae[0],ae[1],G))).then(ae=>(h.mark(`code/extHost/didActivateExtension/${_.identifier.value}`),ae))}cb(_){const Q=new f.$Zac(_,this.H),z=new f.$Yac(_.identifier.value,!1,this.H),V=new N.$$ac(_,this.I),G=_.isUnderDevelopment?this.f.environment.extensionTestsLocationURI?t.ExtensionMode.Test:t.ExtensionMode.Development:t.ExtensionMode.Production,ae=this.f.remote.isRemote?t.ExtensionKind.Workspace:t.ExtensionKind.UI;return this.l.trace(`ExtensionService#loadExtensionContext ${_.identifier.value}`),Promise.all([Q.whenReady,z.whenReady,this.J.whenReady]).then(()=>{const ne=this;let he,Ee;const de=(0,r.$LF)(_,"ipc")?this.f.messagePorts?.get(m.$Tl.toKey(_.identifier)):void 0;return Object.freeze({globalState:Q,workspaceState:z,secrets:V,subscriptions:[],get extensionUri(){return _.extensionLocation},get extensionPath(){return _.extensionLocation.fsPath},asAbsolutePath(ge){return M.$$c(_.extensionLocation.fsPath,ge)},get storagePath(){return ne.J.workspaceValue(_)?.fsPath},get globalStoragePath(){return ne.J.globalValue(_).fsPath},get logPath(){return M.$$c(ne.f.logsLocation.fsPath,_.identifier.value)},get logUri(){return $.URI.joinPath(ne.f.logsLocation,_.identifier.value)},get storageUri(){return ne.J.workspaceValue(_)},get globalStorageUri(){return ne.J.globalValue(_)},get extensionMode(){return G},get extension(){return he===void 0&&(he=new x(ne,_.identifier,_,ae,!1)),he},get extensionRuntime(){return(0,r.$MF)(_,"extensionRuntime"),ne.extensionRuntime},get environmentVariableCollection(){return ne.p.getEnvironmentVariableCollection(_)},get messagePassingProtocol(){if(!Ee){if(!de)return;const ge=l.Event.buffer(l.Event.fromDOMEventEmitter(de,"message",ie=>ie.data));de.start(),Ee={onDidReceiveMessage:ge,postMessage:de.postMessage.bind(de)}}return Ee}})})}static db(_,Q,z,V,G){return z=z||{activate:void 0,deactivate:void 0},this.eb(_,Q,z,V,G).then(ae=>new S.$Sac(!1,null,G.build(),z,ae,V.subscriptions))}static eb(_,Q,z,V,G){if(typeof z.activate=="function")try{G.activateCallStart(),_.trace(`ExtensionService#_callActivateOptional ${Q.value}`);const ae=typeof global=="object"?global:self,ne=z.activate.apply(ae,[V]);return G.activateCallStop(),G.activateResolveStart(),Promise.resolve(ne).then(he=>(G.activateResolveStop(),he))}catch(ae){return Promise.reject(ae)}else return Promise.resolve(z)}fb(_,Q){this.W(_.identifier,{startup:!1,extensionId:_.identifier,activationEvent:Q}).then(void 0,z=>{this.l.error(z)})}gb(_,Q=0){const V=Date.now();(0,B.$A)(()=>{for(let G=Q;G<_.length;G+=1){const ae=_[G];for(const ne of ae.activationEvents??[])if(ne==="onStartupFinished")if(Date.now()-V>50){this.gb(_,G);break}else this.fb(ae,ne)}})}hb(){this.v.$setPerformanceMarks(h.getMarks()),this.k.getConfigProvider().then(_=>{const Q=_.getConfiguration("extensions.experimental").get("deferredStartupFinishedActivation"),z=this.F.getAllExtensionDescriptions();if(Q)this.gb(z);else for(const V of z)if(V.activationEvents)for(const G of V.activationEvents)G==="onStartupFinished"&&this.fb(V,G)})}ib(){const _=this.U("*",!0).then(void 0,ae=>{this.l.error(ae)});this.B(this.j.onDidChangeWorkspace(ae=>this.jb(ae.added)));const Q=this.j.workspace?this.j.workspace.folders:[],z=this.jb(Q),V=this.lb(),G=Promise.all([V,_,z]).then(()=>{});return Promise.race([G,(0,A.$Fg)(1e4)]).then(()=>{this.hb()}),G}jb(_){return _.length===0?Promise.resolve(void 0):Promise.all(this.F.getAllExtensionDescriptions().map(Q=>this.kb(_,Q))).then(()=>{})}async kb(_,Q){if(this.isActivated(Q.identifier))return;const z=!this.f.remote.isRemote&&!!this.f.remote.authority,V={logService:this.l,folders:_.map(ae=>ae.uri),forceUsingSearch:z||!this.c.fsExists,exists:ae=>this.c.fsExists(ae.fsPath),checkExists:(ae,ne,he)=>this.t.$checkExists(ae,ne,he)},G=await(0,w.$alb)(V,Q);if(G)return this.W(Q.identifier,{startup:!0,extensionId:Q.identifier,activationEvent:G.activationEvent}).then(void 0,ae=>this.l.error(ae))}async lb(){if(this.f.remote.authority)return this.U(`onResolveRemoteAuthority:${this.f.remote.authority}`,!1)}async $extensionTestsExecute(){await this.C.wait();try{return await this.mb()}catch(_){throw console.error(_),_}}async mb(){const{extensionDevelopmentLocationURI:_,extensionTestsLocationURI:Q}=this.f.environment;if(!_||!Q)throw new Error(D.localize(0,null));const z=await this.rb(null,Q,new S.$Rac(!1));if(!z||typeof z.run!="function")throw new Error(D.localize(1,null,Q.toString()));return new Promise((V,G)=>{const ae=(Ee,de)=>{Ee?G(Ee):V(typeof de=="number"&&de>0?1:0)},ne=(0,R.$7f)(Q),he=z.run(ne,ae);he&&he.then&&he.then(()=>{V(0)}).catch(Ee=>{G(Ee instanceof Error&&Ee.stack?Ee.stack:String(Ee))})})}nb(){if(this.O)throw new Error("Extension host is already started!");return this.O=!0,this.y.wait().then(()=>this.z.open()).then(()=>Promise.race([this.L.waitForActivatingExtensions(),(0,A.$Fg)(1e3)])).then(()=>this.ib()).then(()=>{this.C.open(),this.l.info("Eager extensions activated")})}registerRemoteAuthorityResolver(_,Q){return this.N[_]=Q,(0,g.$kb)(()=>{delete this.N[_]})}async getRemoteExecServer(_){const{resolver:Q}=await this.ob(_);return Q?.resolveExecServer?.(_,{resolveAttempt:0})}async ob(_){const Q=_.indexOf("+");if(Q===-1)throw new t.$1J("Not an authority that can be resolved!",s.RemoteAuthorityResolverErrorCode.InvalidAuthority);const z=_.substr(0,Q);return await this.w.wait(),await this.U(`onResolveRemoteAuthority:${z}`,!1),{authorityPrefix:z,resolver:this.N[z]}}async $resolveAuthority(_,Q){const z=O.$dc.create(!1),V=()=>`[resolveAuthority(${(0,s.$Lk)(_)},${Q})][${z.elapsed()}ms] `,G=X=>this.l.info(`${V()}${X}`),ae=X=>this.l.warn(`${V()}${X}`),ne=(X,oe=void 0)=>this.l.error(`${V()}${X}`,oe),he=X=>{if(X instanceof t.$1J)return{type:"error",error:{code:X._code,message:X._message,detail:X._detail}};throw X},Ee=async X=>{G(`activating resolver for ${X}...`);const{resolver:oe,authorityPrefix:Y}=await this.ob(X);if(!oe)throw ne(`no resolver for ${Y}`),new t.$1J(`No remote extension installed to resolve ${Y}.`,s.RemoteAuthorityResolverErrorCode.NoResolverFound);return{resolver:oe,authorityPrefix:Y,remoteAuthority:X}},de=_.split(/@|%40/g).reverse();G(`activating remote resolvers ${de.join(" -> ")}`);let ge;try{ge=await Promise.all(de.map(Ee)).catch(async X=>{if(!(X instanceof t.$1J)||X._code!==s.RemoteAuthorityResolverErrorCode.InvalidAuthority)throw X;return ae(`resolving nested authorities failed: ${X.message}`),[await Ee(_)]})}catch(X){return he(X)}const ie=new A.$Pg;ie.cancelAndSet(()=>G("waiting..."),1e3);let ue,we;for(const[X,{authorityPrefix:oe,resolver:Y,remoteAuthority:fe}]of ge.entries())try{if(X===ge.length-1)G("invoking final resolve()..."),h.mark(`code/extHost/willResolveAuthority/${oe}`),ue=await Y.resolve(fe,{resolveAttempt:Q,execServer:we}),h.mark(`code/extHost/didResolveAuthorityOK/${oe}`),G("setting tunnel factory..."),this.B(await this.m.setTunnelFactory(Y,t.$ZJ.isManagedResolvedAuthority(ue)?ue:void 0));else{if(G(`invoking resolveExecServer() for ${fe}`),h.mark(`code/extHost/willResolveExecServer/${oe}`),we=await Y.resolveExecServer?.(fe,{resolveAttempt:Q,execServer:we}),!we)throw new t.$1J(`Exec server was not available for ${fe}`,s.RemoteAuthorityResolverErrorCode.NoResolverFound);h.mark(`code/extHost/didResolveExecServerOK/${oe}`)}}catch(ye){return h.mark(`code/extHost/didResolveAuthorityError/${oe}`),ne("returned an error",ye),ie.dispose(),he(ye)}ie.dispose();const Pe={environmentTunnels:ue.environmentTunnels,features:ue.tunnelFeatures},U={extensionHostEnv:ue.extensionHostEnv,isTrusted:ue.isTrusted,authenticationSession:ue.authenticationSessionForInitializingExtensions?{id:ue.authenticationSessionForInitializingExtensions.id,providerId:ue.authenticationSessionForInitializingExtensions.providerId}:void 0};G(`returned ${t.$ZJ.isManagedResolvedAuthority(ue)?"managed authority":`${ue.host}:${ue.port}`}`);let Z;if(t.$ZJ.isManagedResolvedAuthority(ue)){const X=Q;this.R.setFactory(X,ue.makeConnection),Z={authority:_,connectTo:new s.$Ik(X),connectionToken:ue.connectionToken}}else Z={authority:_,connectTo:new s.$Jk(ue.host,ue.port),connectionToken:ue.connectionToken};return{type:"ok",value:{authority:Z,options:U,tunnelInformation:Pe}}}async $getCanonicalURI(_,Q){this.l.info(`$getCanonicalURI invoked for authority (${(0,s.$Lk)(_)})`);const{resolver:z}=await this.ob(_);if(!z)return null;const V=$.URI.revive(Q);if(typeof z.getCanonicalURI>"u")return V;const G=await(0,A.$xg)(()=>z.getCanonicalURI(V));return G||V}$startExtensionHost(_){_.toAdd.forEach(V=>V.extensionLocation=$.URI.revive(V.extensionLocation));const{globalRegistry:Q,myExtensions:z}=me(this.D,this.G,this.F,_);return this.G.set(Q.getAllExtensionDescriptions()),this.F.set(z),this.nb()}$activateByEvent(_,Q){return Q===1?this.w.wait().then(z=>this.U(_,!1)):this.z.wait().then(z=>this.U(_,!1))}async $activate(_,Q){return await this.z.wait(),this.F.getExtensionDescription(_)?(await this.W(_,Q),!0):!1}async $deltaExtensions(_){_.toAdd.forEach(ae=>ae.extensionLocation=$.URI.revive(ae.extensionLocation));const{globalRegistry:Q,myExtensions:z}=me(this.D,this.G,this.F,_),V=await this.Y(z);return(await this.getExtensionPathIndex()).setSearchTree(V),this.G.set(Q.getAllExtensionDescriptions()),this.F.set(z),Promise.resolve(void 0)}async $test_latency(_){return _}async $test_up(_){return _.byteLength}async $test_down(_){const Q=p.$Hc.alloc(_),z=Math.random()%256;for(let V=0;V<_;V++)Q.writeUInt8(z,V);return Q}async $updateRemoteConnectionData(_){this.Q=_,this.a.fire()}};e.$ebc=K,e.$ebc=K=J=Ke([Ve(0,o.$yh),Ve(1,e.$dbc),Ve(2,d.$UL),Ve(3,y.$Jac),Ve(4,b.$Mac),Ve(5,P.$3i),Ve(6,n.$$L),Ve(7,c.$3ac),Ve(8,k.$3rb),Ve(9,u.$5ac),Ve(10,T.$abc),Ve(11,F.$bbc)],K);function me(ce,_,Q,z){ce.addActivationEvents(z.addActivationEvents);const V=new i.$12b(ce,_.getAllExtensionDescriptions());V.deltaExtensions(z.toAdd,z.toRemove);const G=new m.$Ul(Q.getAllExtensionDescriptions().map(ne=>ne.identifier));for(const ne of z.myToRemove)G.delete(ne);for(const ne of z.myToAdd)G.add(ne);const ae=q(V,G);return{globalRegistry:V,myExtensions:ae}}function re(ce,_){return{id:ce.identifier.value,name:ce.name,extensionVersion:ce.version,publisherDisplayName:ce.publisher,activationEvents:ce.activationEvents?ce.activationEvents.join(","):null,isBuiltin:ce.isBuiltin,reason:_.activationEvent,reasonId:_.extensionId.value}}e.$fbc=(0,o.$zh)("IExtHostExtensionService");class x{#e;#t;#i;constructor(_,Q,z,V,G){this.#e=_,this.#t=Q,this.#i=z.identifier,this.id=z.identifier.value,this.extensionUri=z.extensionLocation,this.extensionPath=M.$9c((0,R.$7f)(z.extensionLocation)),this.packageJSON=z,this.extensionKind=V,this.isFromDifferentExtensionHost=G}get isActive(){return this.#e.isActivated(this.#i)}get exports(){if(!(this.packageJSON.api==="none"||this.isFromDifferentExtensionHost))return this.#e.getExtensionExports(this.#i)}async activate(){if(this.isFromDifferentExtensionHost)throw new Error("Cannot activate foreign extension");return await this.#e.activateByIdWithErrors(this.#i,{startup:!1,extensionId:this.#t,activationEvent:"api"}),this.exports}}e.$gbc=x;function q(ce,_){return ce.getAllExtensionDescriptions().filter(Q=>_.has(Q.identifier))}class ee{constructor(_){this.a=_}setSearchTree(_){this.a=_}findSubstr(_){return this.a.findSubstr(_)}forEach(_){return this.a.forEach(_)}}e.$hbc=ee;class pe{constructor(_){this.a=new m.$Vl,this.addActivationEvents(_)}readActivationEvents(_){return this.a.get(_.identifier)}addActivationEvents(_){for(const Q of Object.keys(_))this.a.set(Q,_[Q])}}}),define(De[340],Ce([1,0,61,2,5,39,27,25,20,26,6,43,17,15]),function($e,e,D,M,h,R,A,g,E,$,P,I,b,S){"use strict";var C;Object.defineProperty(e,"__esModule",{value:!0}),e.$Dcc=void 0;let y=class{constructor(p,f,t,s,o,n,c){this.c=p,this.d=f,this.e=t,this.f=s,this.g=o,this.h=n,this.i=c,this.a=new Map,this.b=[]}async install(){this.j(),D.mark("code/extHost/willWaitForConfig");const p=await this.f.getConfigProvider();D.mark("code/extHost/didWaitForConfig");const f=await this.g.getExtensionPathIndex();this.register(new i(this.c,f,this.d,p,this.i)),this.register(this.e.createInstance(r)),this.h.remote.isRemote&&this.register(this.e.createInstance(a,f,this.h.environment.appUriScheme))}register(p){if("nodeModuleName"in p)if(Array.isArray(p.nodeModuleName))for(const f of p.nodeModuleName)this.a.set(f,p);else this.a.set(p.nodeModuleName,p);typeof p.alternativeModuleName=="function"&&this.b.push(f=>p.alternativeModuleName(f))}};e.$Dcc=y,e.$Dcc=y=Ke([Ve(2,P.$yh),Ve(3,R.$Mac),Ve(4,I.$fbc),Ve(5,$.$$L),Ve(6,b.$3i)],y);let r=class{static{C=this}static{this.a=new Map([["vscode-ripgrep","@vscode/ripgrep"],["vscode-windows-registry","@vscode/windows-registry"]])}constructor(p){if(p.environment.appRoot&&C.a.size){const f=(0,S.$sd)(this.c(p.environment.appRoot.fsPath)),t="[a-z0-9_.-]",s=`@${t}+\\/${t}+|${t}+`,o="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.b=new RegExp(`^(${f}/${o}\\/)(${s})(.*)$`,"i")}}alternativeModuleName(p){if(!this.b)return;const f=this.b.exec(this.c(p));if(!f)return;const[,t,s,o]=f,n=C.a.get(s);if(n!==void 0)return console.warn(`${s} as been renamed to ${n}, please update your imports`),t+n+o}c(p){return p.replace(/\\/g,"/")}};r=C=Ke([Ve(0,$.$$L)],r);class i{constructor(p,f,t,s,o){this.c=p,this.d=f,this.e=t,this.f=s,this.g=o,this.nodeModuleName="vscode",this.a=new g.$Vl}load(p,f){const t=this.d.findSubstr(f);if(t){let s=this.a.get(t.identifier);return s||(s=this.c(t,this.e,this.f),this.a.set(t.identifier,s)),s}if(!this.b){let s="";this.d.forEach((o,n)=>s+=`	${n} -> ${o.identifier.value}
`),this.g.warn(`Could not identify extension for 'vscode' require call from ${f}. These are the extension path mappings: 
${s}`),this.b=this.c(A.$GF,this.e,this.f)}return this.b}}let a=class{constructor(p,f,t){this.e=p,this.f=f,this.nodeModuleName=["open","opn"],this.d=t.getProxy(h.$SJ.MainThreadTelemetry);const s=t.getProxy(h.$SJ.MainThreadWindow);this.c=(o,n)=>{const c=M.URI.parse(o);return n?this.g(o,n):c.scheme==="http"||c.scheme==="https"?s.$openUri(c,o,{allowTunneling:!0}):c.scheme==="mailto"||c.scheme===this.f?s.$openUri(c,o,{}):this.g(o,n)}}load(p,f,t){const s=this.e.findSubstr(f);return s&&(this.a=s.identifier.value,this.h()),this.b=t(p),this.c}g(p,f){return this.i(),this.b(p,f)}h(){this.a&&this.d.$publicLog2("shimming.open",{extension:this.a})}i(){this.a&&this.d.$publicLog2("shimming.open.call.noForward",{extension:this.a})}};a=Ke([Ve(2,E.$UL)],a)}),define(De[53],Ce([1,0,55,3,14,45,6,65,66,43,7,38,269,39]),function($e,e,D,M,h,R,A,g,E,$,P,I,b,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Obc=e.$Nbc=void 0,e.$Nbc=(0,A.$zh)("IExtHostVariableResolverProvider");class C extends b.$VM{constructor(i,a,m,p,f,t,s){function o(){if(m){const n=m.activeEditor();if(n)return n.document.uri;const c=p.tabGroups.all.find(d=>d.isActive)?.activeTab;if(c!==void 0){if(c.input instanceof P.$BL||c.input instanceof P.$GL)return c.input.modified;if(c.input instanceof P.$AL||c.input instanceof P.$FL||c.input instanceof P.$DL)return c.input.uri}}}super({getFolderUri:n=>{const c=t.folders.filter(d=>d.name===n);if(c&&c.length>0)return c[0].uri},getWorkspaceFolderCount:()=>t.folders.length,getConfigurationValue:(n,c)=>f.getConfiguration(void 0,n).get(c),getAppRoot:()=>R.cwd(),getExecPath:()=>R.env.VSCODE_EXEC_PATH,getFilePath:()=>{const n=o();if(n)return h.$9c(n.fsPath)},getWorkspaceFolderPathForFile:()=>{if(a){const n=o();if(n){const c=a.getWorkspaceFolder(n);if(c)return h.$9c(c.uri.fsPath)}}},getSelectedText:()=>{if(m){const n=m.activeEditor();if(n&&!n.selection.isEmpty)return n.document.getText(n.selection)}},getLineNumber:()=>{if(m){const n=m.activeEditor();if(n)return String(n.selection.end.line+1)}},getExtension:n=>i.getExtension(n)},void 0,s?Promise.resolve(s):void 0,Promise.resolve(R.env))}}let y=class extends M.$mb{constructor(i,a,m,p,f){super(),this.b=i,this.c=a,this.g=m,this.h=p,this.i=f,this.a=new D.$T(async()=>{const t=await this.h.getConfigProvider(),o={folders:await this.c.getWorkspaceFolders2()||[]};return this.B(this.c.onDidChangeWorkspace(async n=>{o.folders=await this.c.getWorkspaceFolders2()||[]})),new C(this.b,this.c,this.g,this.i,t,o,this.j())})}getResolver(){return this.a.value}j(){}};e.$Obc=y,e.$Obc=y=Ke([Ve(0,$.$fbc),Ve(1,I.$Jac),Ve(2,g.$6L),Ve(3,S.$Mac),Ve(4,E.$Lbc)],y)}),define(De[94],Ce([1,0,13,4,2,6,5,66,43,20,7,38,139,262,39,53]),function($e,e,D,M,h,R,A,g,E,$,P,I,b,S,C,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tbc=e.$Sbc=e.$Rbc=e.$Qbc=e.$Pbc=void 0,e.$Pbc=(0,R.$zh)("IExtHostDebugService");let r=class{get onDidStartDebugSession(){return this.m.event}get onDidTerminateDebugSession(){return this.n.event}get onDidChangeActiveDebugSession(){return this.o.event}get activeDebugSession(){return this.q}get onDidReceiveDebugSessionCustomEvent(){return this.u.event}get activeDebugConsole(){return this.v.value}constructor(s,o,n,c,d,v){this.E=o,this.F=n,this.G=c,this.H=d,this.I=v,this.l=new Map,this.d=0,this.f=[],this.g=0,this.h=[],this.i=0,this.j=[],this.B=new Map,this.C=new Map,this.m=new M.$hc,this.n=new M.$hc,this.o=new M.$hc,this.u=new M.$hc,this.k=s.getProxy(A.$SJ.MainThreadDebugService),this.y=new M.$hc,this.A=new M.$hc,this.v=new a(this.k),this.w=new Map,this.F.getExtensionRegistry().then(k=>{k.onDidChange(u=>{this.J(k)}),this.J(k)})}asDebugSourceUri(s,o){const n=s;if(typeof n.sourceReference=="number"&&n.sourceReference>0){let c=`debug:${encodeURIComponent(n.path||"")}`,d="?";return o&&(c+=`${d}session=${encodeURIComponent(o.id)}`,d="&"),c+=`${d}ref=${n.sourceReference}`,h.URI.parse(c)}else{if(n.path)return h.URI.file(n.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}J(s){const o=[];for(const n of s.getAllExtensionDescriptions())if(n.contributes){const c=n.contributes.debuggers;if(c&&c.length>0)for(const d of c)(0,S.$iF)(d)&&o.push(d.type)}this.k.$registerDebugTypes(o)}get stackFrameFocus(){return this.z}get onDidChangeStackFrameFocus(){return this.A.event}get onDidChangeBreakpoints(){return this.y.event}get breakpoints(){const s=[];return this.w.forEach(o=>s.push(o)),s}addBreakpoints(s){const o=s.filter(d=>{const v=d.id;return this.w.has(v)?!1:(this.w.set(v,d),!0)});this.U(o,[],[]);const n=[],c=new Map;for(const d of o)if(d instanceof P.$UK){let v=c.get(d.location.uri.toString());v||(v={type:"sourceMulti",uri:d.location.uri,lines:[]},c.set(d.location.uri.toString(),v),n.push(v)),v.lines.push({id:d.id,enabled:d.enabled,condition:d.condition,hitCondition:d.hitCondition,logMessage:d.logMessage,line:d.location.range.start.line,character:d.location.range.start.character})}else d instanceof P.$VK&&n.push({type:"function",id:d.id,enabled:d.enabled,hitCondition:d.hitCondition,logMessage:d.logMessage,condition:d.condition,functionName:d.functionName});return this.k.$registerBreakpoints(n)}removeBreakpoints(s){const o=s.filter(v=>this.w.delete(v.id));this.U([],o,[]);const n=o.filter(v=>v instanceof P.$UK).map(v=>v.id),c=o.filter(v=>v instanceof P.$VK).map(v=>v.id),d=o.filter(v=>v instanceof P.$WK).map(v=>v.id);return this.k.$unregisterBreakpoints(n,c,d)}startDebugging(s,o,n){return this.k.$startDebugging(s?s.uri:void 0,o,{parentSessionID:n.parentSession?n.parentSession.id:void 0,lifecycleManagedByParent:n.lifecycleManagedByParent,repl:n.consoleMode===P.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:n.noDebug,compact:n.compact,suppressSaveBeforeStart:n.suppressSaveBeforeStart,suppressDebugStatusbar:n.suppressDebugStatusbar??n.debugUI?.simple,suppressDebugToolbar:n.suppressDebugToolbar??n.debugUI?.simple,suppressDebugView:n.suppressDebugView??n.debugUI?.simple})}stopDebugging(s){return this.k.$stopDebugging(s?s.id:void 0)}registerDebugConfigurationProvider(s,o,n){if(!o)return new P.$UJ(()=>{});const c=this.d++;return this.f.push({type:s,handle:c,provider:o}),this.k.$registerDebugConfigurationProvider(s,n,!!o.provideDebugConfigurations,!!o.resolveDebugConfiguration,!!o.resolveDebugConfigurationWithSubstitutedVariables,c),new P.$UJ(()=>{this.f=this.f.filter(d=>d.provider!==o),this.k.$unregisterDebugConfigurationProvider(c)})}registerDebugAdapterDescriptorFactory(s,o,n){if(!n)return new P.$UJ(()=>{});if(!this.Q(s,o))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${o}' debugger.`);if(this.N(o))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const c=this.g++;return this.h.push({type:o,handle:c,factory:n}),this.k.$registerDebugAdapterDescriptorFactory(o,c),new P.$UJ(()=>{this.h=this.h.filter(d=>d.factory!==n),this.k.$unregisterDebugAdapterDescriptorFactory(c)})}registerDebugAdapterTrackerFactory(s,o){if(!o)return new P.$UJ(()=>{});const n=this.i++;return this.j.push({type:s,handle:n,factory:o}),new P.$UJ(()=>{this.j=this.j.filter(c=>c.factory!==o)})}async $runInTerminal(s,o){return Promise.resolve(void 0)}async $substituteVariables(s,o){let n;const c=await this.W(s);return c&&(n={uri:c.uri,name:c.name,index:c.index,toResource:()=>{throw new Error("Not implemented")}}),(await this.I.getResolver()).resolveAnyAsync(n,o)}K(s,o){if(s.type==="implementation")return new p(s.implementation)}L(){}async $startDASession(s,o){const n=this,c=await this.V(o);return this.S(this.N(c.type),c).then(d=>{if(!d)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${c.type}' (extension might have failed to activate)`);const v=this.M(d),k=this.K(v,c);if(!k)throw new Error(`Couldn't create a debug adapter for type '${c.type}'.`);const u=k;return this.B.set(s,u),this.R(c).then(l=>(l&&this.C.set(s,l),u.onMessage(async w=>{if(w.type==="request"&&w.command==="handshake"){const L=w,N={type:"response",seq:0,command:L.command,request_seq:L.seq,success:!0};this.D||(this.D=this.L());try{if(this.D){const j=await this.D.sign(L.arguments.value);N.body={signature:j},u.sendResponse(N)}else throw new Error("no signer")}catch(j){N.success=!1,N.message=j.message,u.sendResponse(N)}}else l&&l.onDidSendMessage&&l.onDidSendMessage(w),w=(0,S.$nF)(w,!0),n.k.$acceptDAMessage(s,w)}),u.onError(w=>{l&&l.onError&&l.onError(w),this.k.$acceptDAError(s,w.name,w.message,w.stack)}),u.onExit(w=>{l&&l.onExit&&l.onExit(w??void 0,void 0),this.k.$acceptDAExit(s,w??void 0,void 0)}),l&&l.onWillStartSession&&l.onWillStartSession(),u.startSession()))})}$sendDAMessage(s,o){o=(0,S.$mF)(o,!1);const n=this.C.get(s);n&&n.onWillReceiveMessage&&n.onWillReceiveMessage(o),this.B.get(s)?.sendMessage(o)}$stopDASession(s){const o=this.C.get(s);this.C.delete(s),o&&o.onWillStopSession&&o.onWillStopSession();const n=this.B.get(s);return this.B.delete(s),n?n.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(s){const o=[],n=[],c=[];if(s.added)for(const d of s.added){const v=d.id;if(v&&!this.w.has(v)){let k;if(d.type==="function")k=new P.$VK(d.functionName,d.enabled,d.condition,d.hitCondition,d.logMessage);else if(d.type==="data")k=new P.$WK(d.label,d.dataId,d.canPersist,d.enabled,d.hitCondition,d.condition,d.logMessage);else{const u=h.URI.revive(d.uri);k=new P.$UK(new P.$7J(u,new P.$VJ(d.line,d.character)),d.enabled,d.condition,d.hitCondition,d.logMessage)}(0,P.$SK)(k,v),this.w.set(v,k),o.push(k)}}if(s.removed)for(const d of s.removed){const v=this.w.get(d);v&&(this.w.delete(d),n.push(v))}if(s.changed){for(const d of s.changed)if(d.id){const v=this.w.get(d.id);if(v){if(v instanceof P.$VK&&d.type==="function"){const k=v;k.enabled=d.enabled,k.condition=d.condition,k.hitCondition=d.hitCondition,k.logMessage=d.logMessage,k.functionName=d.functionName}else if(v instanceof P.$UK&&d.type==="source"){const k=v;k.enabled=d.enabled,k.condition=d.condition,k.hitCondition=d.hitCondition,k.logMessage=d.logMessage,k.location=new P.$7J(h.URI.revive(d.uri),new P.$VJ(d.line,d.character))}c.push(v)}}}this.U(o,n,c)}async $acceptStackFrameFocus(s){let o;const n=s.sessionId?await this.V(s.sessionId):void 0;if(!n)throw new Error("no DebugSession found for debug focus context");s.kind==="thread"?o=new P.$3K(n,s.threadId):o=new P.$2K(n,s.threadId,s.frameId),this.z=o,this.A.fire(this.z)}$provideDebugConfigurations(s,o,n){return(0,D.$xg)(async()=>{const c=this.P(s);if(!c)throw new Error("no DebugConfigurationProvider found");if(!c.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const d=await this.W(o);return c.provideDebugConfigurations(d,n)}).then(c=>{if(!c)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return c})}$resolveDebugConfiguration(s,o,n,c){return(0,D.$xg)(async()=>{const d=this.P(s);if(!d)throw new Error("no DebugConfigurationProvider found");if(!d.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const v=await this.W(o);return d.resolveDebugConfiguration(v,n,c)})}$resolveDebugConfigurationWithSubstitutedVariables(s,o,n,c){return(0,D.$xg)(async()=>{const d=this.P(s);if(!d)throw new Error("no DebugConfigurationProvider found");if(!d.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const v=await this.W(o);return d.resolveDebugConfigurationWithSubstitutedVariables(v,n,c)})}async $provideDebugAdapter(s,o){const n=this.O(s);if(!n)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const c=await this.V(o);return this.S(n,c).then(d=>{if(!d)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${c.type}'`);return this.M(d)})}async $acceptDebugSessionStarted(s){const o=await this.V(s);this.m.fire(o)}async $acceptDebugSessionTerminated(s){const o=await this.V(s);o&&(this.n.fire(o),this.l.delete(o.id))}async $acceptDebugSessionActiveChanged(s){this.q=s?await this.V(s):void 0,this.o.fire(this.q)}async $acceptDebugSessionNameChanged(s,o){(await this.V(s))?._acceptNameChanged(o)}async $acceptDebugSessionCustomEvent(s,o){const c={session:await this.V(s),event:o.event,body:o.body};this.u.fire(c)}M(s){if(s instanceof P.$XK)return{type:"executable",command:s.command,args:s.args,options:s.options};if(s instanceof P.$YK)return{type:"server",port:s.port,host:s.host};if(s instanceof P.$ZK)return{type:"pipeServer",path:s.path};if(s instanceof P.$1K)return{type:"implementation",implementation:s.implementation};throw new Error("convertToDto unexpected type")}N(s){const o=this.h.filter(n=>n.type===s);if(o.length>0)return o[0].factory}O(s){const o=this.h.filter(n=>n.handle===s);if(o.length>0)return o[0].factory}P(s){const o=this.f.filter(n=>n.handle===s);if(o.length>0)return o[0].provider}Q(s,o){if(s.contributes){const n=s.contributes.debuggers;if(n&&n.length>0){for(const c of n)if(c.label&&c.type&&c.type===o)return!0}}return!1}R(s){const n=s.configuration.type,c=this.j.filter(d=>d.type===n||d.type==="*").map(d=>(0,D.$xg)(()=>d.factory.createDebugAdapterTracker(s)).then(v=>v,v=>null));return Promise.race([Promise.all(c).then(d=>{const v=d.filter(k=>!!k);if(v.length>0)return new m(v)}),new Promise(d=>setTimeout(()=>d(void 0),1e3))]).catch(d=>{})}async S(s,o){const n=o.configuration.debugServer;if(typeof n=="number")return Promise.resolve(new P.$YK(n));if(s){const d=await this.F.getExtensionRegistry();return(0,D.$xg)(()=>s.createDebugAdapterDescriptor(o,this.T(o,d))).then(v=>{if(v)return v})}const c=await this.F.getExtensionRegistry();return Promise.resolve(this.T(o,c))}T(s,o){}U(s,o,n){(s.length>0||o.length>0||n.length>0)&&this.y.fire(Object.freeze({added:s,removed:o,changed:n}))}async V(s){if(s)if(typeof s=="string"){const o=this.l.get(s);if(o)return o}else{let o=this.l.get(s.id);if(!o){const n=await this.W(s.folderUri),c=s.parent?this.l.get(s.parent):void 0;o=new i(this.k,s.id,s.type,s.name,n,s.configuration,c),this.l.set(o.id,o),this.k.$sessionCached(o.id)}return o}throw new Error("cannot find session")}W(s){if(s){const o=h.URI.revive(s);return this.E.resolveWorkspaceFolder(o)}return Promise.resolve(void 0)}};e.$Qbc=r,e.$Qbc=r=Ke([Ve(0,$.$UL),Ve(1,I.$Jac),Ve(2,E.$fbc),Ve(3,C.$Mac),Ve(4,g.$Lbc),Ve(5,y.$Nbc)],r);class i{constructor(s,o,n,c,d,v,k){this.d=s,this.f=o,this.g=n,this.h=c,this.i=d,this.j=v,this.k=k}get id(){return this.f}get type(){return this.g}get name(){return this.h}set name(s){this.h=s,this.d.$setDebugSessionName(this.f,s)}get parentSession(){return this.k}_acceptNameChanged(s){this.h=s}get workspaceFolder(){return this.i}get configuration(){return this.j}customRequest(s,o){return this.d.$customDebugAdapterRequest(this.f,s,o)}getDebugProtocolBreakpoint(s){return this.d.$getDebugProtocolBreakpoint(this.f,s.id)}}e.$Rbc=i;class a{constructor(s){this.value=Object.freeze({append(o){s.$appendDebugConsole(o)},appendLine(o){this.append(o+`
`)}})}}e.$Sbc=a;class m{constructor(s){this.d=s}onWillStartSession(){this.d.forEach(s=>s.onWillStartSession?s.onWillStartSession():void 0)}onWillReceiveMessage(s){this.d.forEach(o=>o.onWillReceiveMessage?o.onWillReceiveMessage(s):void 0)}onDidSendMessage(s){this.d.forEach(o=>o.onDidSendMessage?o.onDidSendMessage(s):void 0)}onWillStopSession(){this.d.forEach(s=>s.onWillStopSession?s.onWillStopSession():void 0)}onError(s){this.d.forEach(o=>o.onError?o.onError(s):void 0)}onExit(s,o){this.d.forEach(n=>n.onExit?n.onExit(s,o):void 0)}}class p extends b.$icb{constructor(s){super(),this.h=s,s.onDidSendMessage(o=>{this.acceptMessage(o)})}startSession(){return Promise.resolve(void 0)}sendMessage(s){this.h.handleMessage(s)}stopSession(){return this.h.dispose(),Promise.resolve(void 0)}}let f=class extends r{constructor(s,o,n,c,d,v){super(s,o,n,c,d,v)}};e.$Tbc=f,e.$Tbc=f=Ke([Ve(0,$.$UL),Ve(1,I.$Jac),Ve(2,E.$fbc),Ve(3,C.$Mac),Ve(4,g.$Lbc),Ve(5,y.$Nbc)],f)}),define(De[341],Ce([1,0,8,61,2,5,333,17,102,103,26,232,20,62,43,88]),function($e,e,D,M,h,R,A,g,E,$,P,I,b,S,C,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fcc=e.$Ecc=void 0;class r{static async installEarlyHandler(m){Error.stackTraceLimit=100;const p=m.get(g.$3i),t=m.get(b.$UL).getProxy(R.$SJ.MainThreadErrors);D.setUnexpectedErrorHandler(s=>{p.error(s);const o=D.$1(s);t.$onUnexpectedError(o)})}static async installFullHandler(m){const p=m.get(g.$3i),f=m.get(b.$UL),t=m.get(C.$fbc),s=m.get(y.$cM),o=f.getProxy(R.$SJ.MainThreadExtensionService),n=f.getProxy(R.$SJ.MainThreadErrors),c=await t.getExtensionPathIndex(),d=new WeakMap;function v(l,w){if(d.has(l))return d.get(l).stack;let L="",N,j;for(const O of w)L+=`
	at ${O.toString()}`,j=O.getFileName(),!N&&j&&(N=c.findSubstr(h.URI.file(j)));const T=`${l.name||"Error"}: ${l.message||""}${L}`;return d.set(l,{extensionIdentifier:N?.identifier,stack:T}),T}const k=Symbol("prepareStackTrace wrapped");let u=v;Object.defineProperty(Error,"prepareStackTrace",{configurable:!1,get(){return u},set(l){if(l===v||!l||l[k]){u=l||v;return}u=function(w,L){return v(w,L),l.call(Error,w,L)},Object.assign(u,{[k]:!0})}}),D.setUnexpectedErrorHandler(l=>{p.error(l);const w=D.$1(l),L=d.get(l);if(!L?.extensionIdentifier){n.$onUnexpectedError(w);return}o.$onExtensionRuntimeError(L.extensionIdentifier,w);const N=s.onExtensionError(L.extensionIdentifier,l);p.trace("forwarded error to extension?",N,L)})}}e.$Ecc=r;class i{constructor(m,p,f,t,s){this.a=f,this.b=new A.$92b(m,null,t),p=i.e(p,this.b);const o=new $.$xh(...(0,E.$kr)());o.set(P.$$L,{_serviceBrand:void 0,...p,messagePorts:s}),o.set(b.$UL,new b.$VL(this.b)),o.set(S.$Gac,new S.$Hac(t)),o.set(C.$dbc,f);const n=new I.$3p(o,!0);n.invokeFunction(r.installEarlyHandler),this.d=n.invokeFunction(c=>c.get(g.$3i)),M.mark("code/extHost/didCreateServices"),this.a.pid?this.d.info(`Extension host with pid ${this.a.pid} started`):this.d.info("Extension host started"),this.d.trace("initData",p),this.c=n.invokeFunction(c=>c.get(C.$fbc)),this.c.initialize(),n.invokeFunction(r.installFullHandler)}async asBrowserUri(m){const p=this.b.getProxy(R.$SJ.MainThreadExtensionService);return h.URI.revive(await p.$asBrowserUri(m))}terminate(m){this.c.terminate(m)}static e(m,p){m.allExtensions.forEach(t=>{t.extensionLocation=h.URI.revive(p.transformIncomingURIs(t.extensionLocation))}),m.environment.appRoot=h.URI.revive(p.transformIncomingURIs(m.environment.appRoot));const f=m.environment.extensionDevelopmentLocationURI;return f&&(m.environment.extensionDevelopmentLocationURI=f.map(t=>h.URI.revive(p.transformIncomingURIs(t)))),m.environment.extensionTestsLocationURI=h.URI.revive(p.transformIncomingURIs(m.environment.extensionTestsLocationURI)),m.environment.globalStorageHome=h.URI.revive(p.transformIncomingURIs(m.environment.globalStorageHome)),m.environment.workspaceStorageHome=h.URI.revive(p.transformIncomingURIs(m.environment.workspaceStorageHome)),m.environment.extensionTelemetryLogResource=h.URI.revive(p.transformIncomingURIs(m.environment.extensionTelemetryLogResource)),m.nlsBaseUrl=h.URI.revive(p.transformIncomingURIs(m.nlsBaseUrl)),m.logsLocation=h.URI.revive(p.transformIncomingURIs(m.logsLocation)),m.workspace=p.transformIncomingURIs(m.workspace),m}}e.$Fcc=i}),define(De[342],Ce([1,0,13,9,210,226,137,94,66,43,20,42,7,53,38,263,264,39]),function($e,e,D,M,h,R,A,g,E,$,P,I,b,S,C,y,r,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pcc=void 0;let a=class extends g.$Qbc{constructor(s,o,n,c,d,v,k){super(s,o,n,c,v,k),this.Z=d,this.X=new f}K(s,o){switch(s.type){case"server":return new y.$Kcc(s);case"pipeServer":return new y.$Lcc(s);case"executable":return new y.$Mcc(s,o.type)}return super.K(s,o)}T(s,o){const n=y.$Mcc.platformAdapterExecutable(o.getAllExtensionDescriptions(),s.type);if(n)return new b.$XK(n.command,n.args,n.options)}L(){return new A.$K6b}async $runInTerminal(s,o){if(s.kind==="integrated"){this.Y||(this.Y=this.Z.onDidCloseTerminal(T=>{this.X.onTerminalClosed(T)}));const n=await this.G.getConfigProvider(),c=this.Z.getDefaultShell(!0),d=this.Z.getDefaultShellArgs(!0),v=s.title||h.localize(0,null),k=JSON.stringify({shell:c,shellArgs:d});let u=await this.X.checkout(k,v),l,w=!1;if(u)l=s.cwd;else{const T={shellPath:c,shellArgs:d,cwd:s.cwd,name:v,iconPath:new b.$PK("debug")};w=!0,u=this.Z.createTerminalFromOptions(T,{isFeatureTerminal:!0,useShellEnvironment:!0}),this.X.insert(u,k)}u.show(!0);const L=await u.processId;w?await new Promise(T=>setTimeout(T,1e3)):n.getConfiguration("debug.terminal").get("clearBeforeReusing")&&(c.indexOf("powershell")>=0||c.indexOf("pwsh")>=0||c.indexOf("cmd.exe")>=0?u.sendText("cls"):c.indexOf("bash")>=0?u.sendText("clear"):M.$i?u.sendText("cls"):u.sendText("clear"));const N=(0,r.$Occ)(c,s.args,!!s.argsCanBeInterpretedByShell,l,s.env);u.sendText(N);const j=this.onDidTerminateDebugSession(T=>{T.id===o&&(this.X.free(u),j.dispose())});return L}else if(s.kind==="external")return p(s,await this.G.getConfigProvider());return super.$runInTerminal(s,o)}};e.$Pcc=a,e.$Pcc=a=Ke([Ve(0,P.$UL),Ve(1,C.$Jac),Ve(2,$.$fbc),Ve(3,i.$Mac),Ve(4,I.$5ac),Ve(5,E.$Lbc),Ve(6,S.$Nbc)],a);let m;function p(t,s){if(!m)if(M.$i)m=new R.$t5b;else if(M.$j)m=new R.$u5b;else if(M.$k)m=new R.$v5b;else throw new Error("external terminals not supported on this platform");const o=s.getConfiguration("terminal");return m.runInTerminal(t.title,t.cwd,t.args,t.env||{},o.external||{})}class f{constructor(){this.b=new Map}static{this.a=1e3}async checkout(s,o){const c=[...this.b.entries()].map(([d,v])=>(0,D.$sg)(async k=>{if(d.name!==o||v.lastUsedAt!==-1&&await(0,r.$Ncc)(await d.processId))return null;const u=Date.now();return v.lastUsedAt+f.a>u||k.isCancellationRequested||v.config!==s?null:(v.lastUsedAt=u,d)}));return await(0,D.$Jg)(c,d=>!!d)}insert(s,o){this.b.set(s,{lastUsedAt:Date.now(),config:o})}free(s){const o=this.b.get(s);o&&(o.lastUsedAt=-1)}onTerminalClosed(s){this.b.delete(s)}}}),define(De[343],Ce([1,0,14,2,100,38,65,39,51,42,20,26,93,16,17,89,24,59,53]),function($e,e,D,M,h,R,A,g,E,$,P,I,b,S,C,y,r,i,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hcc=void 0;let m=class extends b.$Ibc{constructor(f,t,s,o,n,c,d,v,k){super(f,t,s,o,n,c,d,v),this.B=s,this.C=k,t.remote.isRemote&&t.remote.authority?this.registerTaskSystem(S.Schemas.vscodeRemote,{scheme:S.Schemas.vscodeRemote,authority:t.remote.authority,platform:process.platform}):this.registerTaskSystem(S.Schemas.file,{scheme:S.Schemas.file,authority:"",platform:process.platform}),this.a.$registerSupportedExecutions(!0,!0,!0)}async executeTask(f,t){const s=t;if(!t.execution&&s._id===void 0)throw new Error("Tasks to execute must include an execution");if(s._id!==void 0){const o=b.TaskHandleDTO.from(s,this.B),n=await this.a.$getTaskExecution(o);if(n.task===void 0)throw new Error("Task from execution DTO is undefined");const c=await this.y(n,t);return this.a.$executeTask(o).catch(()=>{}),c}else{const o=b.TaskDTO.from(t,f);if(o===void 0)return Promise.reject(new Error("Task is not valid"));b.CustomExecutionDTO.is(o.execution)&&await this.x(o,t,!1);const n=await this.y(await this.a.$getTaskExecution(o),t);return this.a.$executeTask(o).catch(()=>{}),n}}u(f,t,s,o){const n=[];if(o)for(const c of o){this.z(c,s),(!c.definition||!f[c.definition.type])&&this.f.warn(`The task [${c.source}, ${c.name}] uses an undefined task type. The task will be ignored in the future.`);const d=b.TaskDTO.from(c,s.extension);d&&(n.push(d),b.CustomExecutionDTO.is(d.execution)&&t.push(this.x(d,c,!0)))}return{tasks:n,extension:s.extension}}async v(f){return f}async F(f){let t=f&&f.length>0?f[0]:void 0;if(!t){const s=M.URI.file((0,i.homedir)());t=new E.$Th({uri:s,name:r.$dg(s),index:0})}return{uri:t.uri,name:t.name,index:t.index,toResource:()=>{throw new Error("Not implemented")}}}async $resolveVariables(f,t){const s=M.URI.revive(f),o={process:void 0,variables:Object.create(null)},n=await this.b.resolveWorkspaceFolder(s),c=await this.b.getWorkspaceFolders2()??[],d=await this.C.getResolver(),v=n?{uri:n.uri,name:n.name,index:n.index,toResource:()=>{throw new Error("Not implemented")}}:await this.F(c);for(const k of t.variables)o.variables[k]=await d.resolveAsync(v,k);if(t.process!==void 0){let k;if(t.process.path!==void 0){k=t.process.path.split(D.$id);for(let u=0;u<k.length;u++)k[u]=await d.resolveAsync(v,k[u])}o.process=await h.win32.findExecutable(await d.resolveAsync(v,t.process.name),t.process.cwd!==void 0?await d.resolveAsync(v,t.process.cwd):void 0,k)}return o}async $jsonTasksSupported(){return!0}async $findExecutable(f,t,s){return h.win32.findExecutable(f,t,s)}};e.$Hcc=m,e.$Hcc=m=Ke([Ve(0,P.$UL),Ve(1,I.$$L),Ve(2,R.$Jac),Ve(3,A.$6L),Ve(4,g.$Mac),Ve(5,$.$5ac),Ve(6,C.$3i),Ve(7,y.$zac),Ve(8,a.$Nbc)],m)}),define(De[344],Ce([1,0,59,53]),function($e,e,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ndc=void 0;class h extends M.$Obc{j(){return(0,D.homedir)()}}e.$ndc=h}),define(De[151],Ce([1,0,19,13,22,44,16,14,24,2,36]),function($e,e,D,M,h,R,A,g,E,$,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ybc=e.$Xbc=e.$Wbc=e.$Vbc=void 0;class I{constructor(a,m,p,f){this.d=a,this.e=m,this.f=p,this.g=f,this.a=null,this.b=!1,this.c=0}search(a,m){const p=this.d.folderQueries||[],f=new h.$rc(m);return new Promise((t,s)=>{this.a=new S(a);let o=!1;const n=(c,d)=>{if(!o&&!this.b){const v=this.h(c);y(c)&&typeof this.d.maxResults=="number"&&this.c+v>this.d.maxResults&&(this.b=!0,o=!0,f.cancel(),c=this.j(c,this.d.maxResults-this.c));const k=this.h(c);this.c+=k,(k>0||!y(c))&&this.a.add(c,d)}};Promise.all(p.map((c,d)=>this.k(c,v=>n(v,d),f.token))).then(c=>{f.dispose(),this.a.flush();const d=c.some(v=>!!v&&!!v.limitHit);t({limitHit:this.b||d,messages:(0,D.$Kf)(c.map(v=>v?.message?Array.isArray(v.message)?v.message:[v.message]:[])),stats:{type:this.g}})},c=>{f.dispose();const d=(0,R.$ki)(c);s(new Error(d))})})}h(a){return y(a)?Array.isArray(a.ranges)?a.ranges.length:1:0}j(a,m){const p=Array.isArray(a.ranges)?a.ranges:[a.ranges],f=Array.isArray(a.preview.matches)?a.preview.matches:[a.preview.matches];return{ranges:p.slice(0,m),preview:{matches:f.slice(0,m),text:a.preview.text},uri:a.uri}}async k(a,m,p){const f=new P.$xI(this.d,a),t=[],s={report:c=>{if(!this.l(c))return;const d=a.folder.scheme===A.Schemas.file?(0,P.$yI)(()=>this.f.readdir(E.$fg(c.uri))):void 0,v=E.$ig(a.folder,c.uri);if(v){const k=f.includedInQuery(v,g.$cd(v),d);(0,M.$rg)(k)?t.push(k.then(u=>{u&&m(c)})):k&&m(c)}}},o=this.n(a),n=await this.e.provideTextSearchResults(b(this.d.contentPattern),o,s,p);return t.length&&await Promise.all(t),n}l(a){if(y(a)){if(Array.isArray(a.ranges)){if(!Array.isArray(a.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(a.preview.matches.length!==a.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(a.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}n(a){const m=(0,P.$wI)(this.d.includePattern,a.includePattern),p=(0,P.$wI)(this.d.excludePattern,a.excludePattern),f={folder:$.URI.from(a.folder),excludes:p,includes:m,useIgnoreFiles:!a.disregardIgnoreFiles,useGlobalIgnoreFiles:!a.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!a.disregardParentIgnoreFiles,followSymlinks:!a.ignoreSymlinks,encoding:a.fileEncoding&&this.f.toCanonicalName(a.fileEncoding),maxFileSize:this.d.maxFileSize,maxResults:this.d.maxResults,previewOptions:this.d.previewOptions,afterContext:this.d.afterContext,beforeContext:this.d.beforeContext};return f.usePCRE2=this.d.usePCRE2,f}}e.$Vbc=I;function b(i){return{isCaseSensitive:i.isCaseSensitive||!1,isRegExp:i.isRegExp||!1,isWordMatch:i.isWordMatch||!1,isMultiline:i.isMultiline||!1,pattern:i.pattern}}class S{constructor(a){this.e=a,this.b=-1,this.d=null,this.a=new r(512,m=>this.g(m))}add(a,m){this.d&&(this.b!==m||!E.$_f(this.c,a.uri))&&(this.f(),this.d=null),this.d||(this.b=m,this.d={resource:a.uri,results:[]}),this.d.results.push(C(a))}f(){const a=this.d&&this.d.results?this.d.results.length:0;this.a.addItem(this.d,a)}flush(){this.f(),this.a.flush()}g(a){this.e(a)}}e.$Wbc=S;function C(i){return y(i)?{preview:{matches:(0,D.$Uf)(i.preview.matches,a=>({startLineNumber:a.start.line,startColumn:a.start.character,endLineNumber:a.end.line,endColumn:a.end.character})),text:i.preview.text},ranges:(0,D.$Uf)(i.ranges,a=>({startLineNumber:a.start.line,startColumn:a.start.character,endLineNumber:a.end.line,endColumn:a.end.character}))}:{text:i.text,lineNumber:i.lineNumber}}function y(i){return!!i.preview}e.$Xbc=y;class r{static{this.a=4e3}static{this.b=50}constructor(a,m){this.g=a,this.h=m,this.c=0,this.d=[],this.e=0}addItem(a,m){a&&this.j(a,m)}addItems(a,m){a&&this.k(a,m)}j(a,m){this.d.push(a),this.e+=m,this.l()}k(a,m){this.d=this.d.concat(a),this.e+=m,this.l()}l(){this.c<r.b?this.flush():this.e>=this.g?this.flush():this.f||(this.f=setTimeout(()=>{this.flush()},r.a))}flush(){this.e&&(this.c+=this.e,this.h(this.d),this.d=[],this.e=0,this.f&&(clearTimeout(this.f),this.f=0))}}e.$Ybc=r}),define(De[95],Ce([1,0,3,5,6,337,20,62,17,2,151]),function($e,e,D,M,h,R,A,g,E,$,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2bc=e.$1bc=e.$Zbc=void 0,e.$Zbc=(0,h.$zh)("IExtHostSearch");let I=class{constructor(y,r,i){this.k=y,this.l=r,this.n=i,this.c=this.k.getProxy(M.$SJ.MainThreadSearch),this.d=0,this.e=new Map,this.g=new Set,this.h=new Map,this.i=new Set,this.j=new R.$Ubc}o(y){return this.l.transformOutgoingScheme(y)}registerTextSearchProvider(y,r){if(this.g.has(y))throw new Error(`a text search provider for the scheme '${y}' is already registered`);this.g.add(y);const i=this.d++;return this.e.set(i,r),this.c.$registerTextSearchProvider(i,this.o(y)),(0,D.$kb)(()=>{this.g.delete(y),this.e.delete(i),this.c.$unregisterProvider(i)})}registerFileSearchProvider(y,r){if(this.i.has(y))throw new Error(`a file search provider for the scheme '${y}' is already registered`);this.i.add(y);const i=this.d++;return this.h.set(i,r),this.c.$registerFileSearchProvider(i,this.o(y)),(0,D.$kb)(()=>{this.i.delete(y),this.h.delete(i),this.c.$unregisterProvider(i)})}$provideFileSearchResults(y,r,i,a){const m=b(i),p=this.h.get(y);if(p)return this.j.fileSearch(m,p,f=>{this.c.$handleFileMatch(y,r,f.map(t=>t.resource))},a);throw new Error("unknown provider: "+y)}$clearCache(y){return this.j.clearCache(y),Promise.resolve(void 0)}$provideTextSearchResults(y,r,i,a){const m=this.e.get(y);if(!m||!m.provideTextSearchResults)throw new Error(`Unknown provider ${y}`);const p=b(i);return this.q(p,m).search(t=>this.c.$handleTextMatch(y,r,t),a)}$enableExtensionHostSearch(){}q(y,r){return new P.$Vbc(y,r,{readdir:i=>Promise.resolve([]),toCanonicalName:i=>i},"textSearchProvider")}};e.$1bc=I,e.$1bc=I=Ke([Ve(0,A.$UL),Ve(1,g.$Gac),Ve(2,E.$3i)],I);function b(C){return{...C,folderQueries:C.folderQueries&&C.folderQueries.map(S),extraFileResources:C.extraFileResources&&C.extraFileResources.map(y=>$.URI.revive(y))}}e.$2bc=b;function S(C){return{...C,folder:$.URI.revive(C.folder)}}}),define(De[345],Ce([1,0,22,8,4,40,2,130,124,166,182,30,5,110,293,292,33,294,39,296,297,298,271,299,65,43,301,302,307,308,309,150,275,315,316,318,114,42,320,279,10,7,85,323,91,149,38,25,267,306,60,147,93,94,95,17,62,20,26,310,265,68,89,286,321,90,67,326,324,325,287,52,319,322,113,66,88,311,92,312,16,133,274,254,304,3,27,261,111,250,313,314,288,303,273,305,112,317,289,290,291,285,300]),function($e,e,D,M,h,R,A,g,E,$,P,I,b,S,C,y,r,i,a,m,p,f,t,s,o,n,c,d,v,k,u,l,w,L,N,j,T,O,B,F,J,K,me,re,x,q,ee,pe,ce,_,Q,z,V,G,ae,ne,he,Ee,de,ge,ie,ue,we,Pe,U,Z,X,oe,Y,fe,ye,ze,Be,xe,Ye,it,et,Ae,Ne,We,Le,Qe,le,se,Ie,qe,je,Xe,nt,ot,bt,Dt,Qt,Vt,vt,Tt,Nt,Kt,At,Rt,Ot,Ut,qt){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zcc=void 0;function Bt(ct){const lt=ct.get(de.$$L),Jt=ct.get(ze.$wac),Pt=ct.get(X.$2ac),kt=ct.get(n.$fbc),dt=ct.get(ee.$Jac),Ct=ct.get(et.$cM),Ft=ct.get(a.$Mac),Et=ct.get(he.$Gac),Ge=ct.get(Ee.$UL),zt=ct.get(T.$Xac),Me=ct.get(Z.$3ac),Te=ct.get(ne.$4i),Se=ct.get(ne.$3i),te=ct.get(ue.$3rb),Fe=ct.get(we.$zac),He=ct.get(q.$Dbc),_e=ct.get(Ye.$0ac),Je=ct.get(it.$Lbc),rt=ct.get(Nt.$bbc);Ge.set(b.$TJ.ExtHostFileSystemInfo,Jt),Ge.set(b.$TJ.ExtHostLogLevelServiceShape,Te),Ge.set(b.$TJ.ExtHostWorkspace,dt),Ge.set(b.$TJ.ExtHostConfiguration,Ft),Ge.set(b.$TJ.ExtHostExtensionService,kt),Ge.set(b.$TJ.ExtHostStorage,zt),Ge.set(b.$TJ.ExtHostTunnelService,te),Ge.set(b.$TJ.ExtHostWindow,He),Ge.set(b.$TJ.ExtHostSecretState,_e),Ge.set(b.$TJ.ExtHostTelemetry,Ct),Ge.set(b.$TJ.ExtHostEditorTabs,Je),Ge.set(b.$TJ.ExtHostManagedSockets,rt);const pt=Ge.set(b.$TJ.ExtHostDecorations,ct.get(z.$Hbc)),wt=Ge.set(b.$TJ.ExtHostDocumentsAndEditors,ct.get(o.$6L)),ft=Ge.set(b.$TJ.ExtHostCommands,ct.get(r.$eM)),gt=Ge.set(b.$TJ.ExtHostTerminalService,ct.get(O.$5ac)),mt=Ge.set(b.$TJ.ExtHostDebugService,ct.get(G.$Pbc)),gi=Ge.set(b.$TJ.ExtHostSearch,ct.get(ae.$Zbc)),Ht=Ge.set(b.$TJ.ExtHostTask,ct.get(V.$Kbc)),Ei=Ge.set(b.$TJ.ExtHostOutputService,ct.get(l.$nbc)),Wt=Ge.set(b.$TJ.ExtHostLocalization,ct.get(nt.$abc)),mi=Ge.set(b.$TJ.ExtHostUrls,new re.$wbc(Ge)),It=Ge.set(b.$TJ.ExtHostDocuments,new s.$uac(Ge,wt)),ki=Ge.set(b.$TJ.ExtHostDocumentContentProviders,new f.$Oac(Ge,wt,Se)),Vi=Ge.set(b.$TJ.ExtHostDocumentSaveParticipant,new t.$Pac(Se,It,Ge.getProxy(b.$SJ.MainThreadBulkEdits))),St=Ge.set(b.$TJ.ExtHostNotebook,new ge.$6bc(Ge,ft,wt,It,Pt)),ti=Ge.set(b.$TJ.ExtHostNotebookDocuments,new se.$lcc(St)),$i=Ge.set(b.$TJ.ExtHostNotebookEditors,new le.$kcc(Se,St)),si=Ge.set(b.$TJ.ExtHostNotebookKernels,new Ae.$hcc(Ge,lt,St,ft,Se)),Si=Ge.set(b.$TJ.ExtHostNotebookRenderers,new We.$jcc(Ge,St)),Di=Ge.set(b.$TJ.ExtHostNotebookDocumentSaveParticipant,new vt.$rcc(Se,St,Ge.getProxy(b.$SJ.MainThreadBulkEdits))),Lt=Ge.set(b.$TJ.ExtHostEditors,new B.$ubc(Ge,wt)),bi=Ge.set(b.$TJ.ExtHostTreeViews,new F.$vbc(Ge.getProxy(b.$SJ.MainThreadTreeViews),ft,Se)),Ci=Ge.set(b.$TJ.ExtHostEditorInsets,new ce.$Ebc(Ge.getProxy(b.$SJ.MainThreadEditorInsets),Lt,lt.remote)),oi=Ge.set(b.$TJ.ExtHostDiagnostics,new m.$yac(Ge,Se,Jt,wt)),ai=Ge.set(b.$TJ.ExtHostLanguages,new k.$kbc(Ge,It,ft.converter,Et)),ut=Ge.set(b.$TJ.ExtHostLanguageFeatures,new v.$Cac(Ge,Et,It,ft,oi,Se,Fe,Ct)),qi=Ge.set(b.$TJ.ExtHostFileSystem,new c.$ibc(Ge,ut)),Yt=Ge.set(b.$TJ.ExtHostFileSystemEventService,new d.$jbc(Ge,Se,wt)),ii=Ge.set(b.$TJ.ExtHostQuickOpen,(0,L.$pbc)(Ge,dt,ft)),pi=Ge.set(b.$TJ.ExtHostSCM,new N.$rbc(Ge,ft,It,Se)),Ii=Ge.set(b.$TJ.ExtHostQuickDiff,new Dt.$occ(Ge,Et)),Hi=Ge.set(b.$TJ.ExtHostShare,new Kt.$tcc(Ge,Et)),Pi=Ge.set(b.$TJ.ExtHostComments,(0,i.$Fac)(Ge,ft,It)),wi=Ge.set(b.$TJ.ExtHostProgress,new w.$obc(Ge.getProxy(b.$SJ.MainThreadProgress))),Ki=Ge.set(b.$TJ.ExtHosLabelService,new _.$Fbc(Ge)),Ai=Ge.set(b.$TJ.ExtHostTheming,new ie.$7bc(Ge)),ci=Ge.set(b.$TJ.ExtHostAuthentication,new Pe.$8bc(Ge)),Ji=Ge.set(b.$TJ.ExtHostTimeline,new U.$0bc(Ge,ft)),vi=Ge.set(b.$TJ.ExtHostWebviews,new x.$zbc(Ge,lt.remote,dt,Se,Fe)),Ri=Ge.set(b.$TJ.ExtHostWebviewPanels,new fe.$_bc(Ge,vi,dt)),cn=Ge.set(b.$TJ.ExtHostCustomEditors,new Y.$acc(Ge,It,Me,vi,Ri)),Li=Ge.set(b.$TJ.ExtHostWebviewViews,new oe.$$bc(Ge,vi)),ni=Ge.set(b.$TJ.ExtHostTesting,new Be.$ccc(Ge,ft,wt)),un=Ge.set(b.$TJ.ExtHostUriOpeners,new xe.$gcc(Ge)),ln=Ge.set(b.$TJ.ExtHostProfileContentHandlers,new bt.$ncc(Ge));Ge.set(b.$TJ.ExtHostInteractive,new Ie.$mcc(Ge,St,wt,ft,Se));const Gi=Ge.set(b.$TJ.ExtHostInlineChat,new Vt.$qcc(Ge,ft,It,Se)),fi=Ge.set(b.$TJ.ExtHostChatProvider,new At.$ucc(Ge,Se)),Zi=Ge.set(b.$TJ.ExtHostChatSlashCommands,new Rt.$vcc(Ge,fi,Se)),Qi=Ge.set(b.$TJ.ExtHostChatVariables,new Ot.$wcc(Ge)),ui=Ge.set(b.$TJ.ExtHostChat,new Qt.$pcc(Ge,Se)),Yi=Ge.set(b.$TJ.ExtHostAiRelatedInformation,new Ut.$xcc(Ge)),Mi=Ge.set(b.$TJ.ExtHostAiEmbeddingVector,new qt.$ycc(Ge)),Xi=Ge.set(b.$TJ.ExtHostIssueReporter,new Tt.$scc(Ge)),Xt=Ge.set(b.$TJ.ExtHostStatusBar,new j.$tbc(Ge,ft.converter)),yi=Object.values(b.$TJ);Ge.assertRegistered(yi);const hn=new ye.$bcc(Ge,wt),Gt=new y.$Eac(Ge),li=new u.$lbc(Ge,Se),Ti=new p.$Nac(Ge);return C.$Dac.register(ft),function(Ue,xt,Fi){const $t=function(){let be=!Ue.isUnderDevelopment;function ke(){be||(Se.info(`Extension '${Ue.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),be=!0)}return function Oe(st){if(Array.isArray(st))st.forEach(Oe);else if(typeof st=="string")ke();else{const yt=st;typeof yt.scheme>"u"&&ke(),typeof yt.exclusive=="boolean"&&(0,je.$MF)(Ue,"documentFiltersExclusive")}return st}}(),xi={getSession(be,ke,Oe){return ci.getSession(Ue,be,ke,Oe)},getSessions(be,ke){return(0,je.$MF)(Ue,"authGetSessions"),ci.getSessions(Ue,be,ke)},async hasSession(be,ke){return(0,je.$MF)(Ue,"authSession"),!!await ci.getSession(Ue,be,ke,{silent:!0})},get onDidChangeSessions(){return ci.onDidChangeSessions},registerAuthenticationProvider(be,ke,Oe,st){return ci.registerAuthenticationProvider(be,ke,Oe,st)}},_i={registerCommand(be,ke,Oe){return ft.registerCommand(!0,be,ke,Oe,void 0,Ue)},registerTextEditorCommand(be,ke,Oe){return ft.registerCommand(!0,be,(...st)=>{const yt=Lt.getActiveTextEditor();if(!yt){Se.warn("Cannot execute "+be+" because there is no active text editor.");return}return yt.edit(Mt=>{ke.apply(Oe,[yt,Mt,...st])}).then(Mt=>{Mt||Se.warn("Edits from command "+be+" were not applied.")},Mt=>{Se.warn("An error occurred while running command "+be,Mt)})},void 0,void 0,Ue)},registerDiffInformationCommand:(be,ke,Oe)=>((0,je.$MF)(Ue,"diffCommand"),ft.registerCommand(!0,be,async(...st)=>{const yt=wt.activeEditor(!0);if(!yt){Se.warn("Cannot execute "+be+" because there is no active text editor.");return}const Mt=await Lt.getDiffInformation(yt.id);ke.apply(Oe,[Mt,...st])},void 0,void 0,Ue)),executeCommand(be,...ke){return ft.executeCommand(be,...ke)},getCommands(be=!1){return ft.getCommands(be)}},en={get machineId(){return lt.telemetryInfo.machineId},get sessionId(){return lt.telemetryInfo.sessionId},get language(){return lt.environment.appLanguage},get appName(){return lt.environment.appName},get appRoot(){return lt.environment.appRoot?.fsPath??""},get appHost(){return lt.environment.appHost},get uriScheme(){return lt.environment.appUriScheme},get clipboard(){return Gt.value},get shell(){return gt.getDefaultShell(!1)},get onDidChangeShell(){return(0,je.$MF)(Ue,"envShellEvent"),gt.onDidChangeShell},get isTelemetryEnabled(){return Ct.getTelemetryConfiguration()},get onDidChangeTelemetryEnabled(){return Ct.onDidChangeTelemetryEnabled},get telemetryConfiguration(){return(0,je.$MF)(Ue,"telemetry"),Ct.getTelemetryDetails()},get onDidChangeTelemetryConfiguration(){return(0,je.$MF)(Ue,"telemetry"),Ct.onDidChangeTelemetryConfiguration},get isNewAppInstall(){return(0,et.$bM)(lt.telemetryInfo.firstSessionDate)},createTelemetryLogger(be,ke){return et.$aM.validateSender(be),Ct.instantiateLogger(Ue,be,ke)},openExternal(be,ke){return He.openUri(be,{allowTunneling:!!lt.remote.authority,allowContributedOpeners:ke?.allowContributedOpeners})},async asExternalUri(be){if(be.scheme===lt.environment.appUriScheme)return mi.createAppUri(be);try{return await He.asExternalUri(be,{allowTunneling:!!lt.remote.authority})}catch(ke){if((0,Qe.$CT)(be,Le.Schemas.http)||(0,Qe.$CT)(be,Le.Schemas.https))return be;throw ke}},get remoteName(){return(0,Q.$Nk)(lt.remote.authority)},get remoteAuthority(){return(0,je.$MF)(Ue,"resolvers"),lt.remote.authority},get uiKind(){return lt.uiKind},get logLevel(){return Se.getLevel()},get onDidChangeLogLevel(){return Se.onDidChangeLogLevel},registerIssueUriRequestHandler(be){return(0,je.$MF)(Ue,"handleIssueUri"),Xi.registerIssueUriRequestHandler(Ue,be)},get appQuality(){return(0,je.$MF)(Ue,"resolvers"),lt.quality},get appCommit(){return(0,je.$MF)(Ue,"resolvers"),lt.commit}};lt.environment.extensionTestsLocationURI||Object.freeze(en);const dn={createTestController(be,ke,Oe){return ni.createTestController(Ue,be,ke,Oe)},createTestObserver(){return(0,je.$MF)(Ue,"testObserver"),ni.createTestObserver()},runTests(be){return(0,je.$MF)(Ue,"testObserver"),ni.runTests(be)},get onDidChangeTestResults(){return(0,je.$MF)(Ue,"testObserver"),ni.onResultsChanged},get testResults(){return(0,je.$MF)(Ue,"testObserver"),ni.results}},hi=lt.remote.isRemote?K.ExtensionKind.Workspace:K.ExtensionKind.UI,tn={getExtension(be,ke){(0,je.$LF)(Ue,"extensionsAny")||(ke=!1);const Oe=xt.mine.getExtensionDescription(be);if(Oe)return new n.$gbc(kt,Ue.identifier,Oe,hi,!1);if(ke){const st=xt.all.getExtensionDescription(be);if(st)return new n.$gbc(kt,Ue.identifier,st,hi,!0)}},get all(){const be=[];for(const ke of xt.mine.getAllExtensionDescriptions())be.push(new n.$gbc(kt,Ue.identifier,ke,hi,!1));return be},get allAcrossExtensionHosts(){(0,je.$MF)(Ue,"extensionsAny");const be=new pe.$Ul(xt.mine.getAllExtensionDescriptions().map(Oe=>Oe.identifier)),ke=[];for(const Oe of xt.all.getAllExtensionDescriptions()){const st=!be.has(Oe.identifier);ke.push(new n.$gbc(kt,Ue.identifier,Oe,hi,st))}return ke},get onDidChange(){return(0,je.$LF)(Ue,"extensionsAny")?h.Event.any(xt.mine.onDidChange,xt.all.onDidChange):xt.mine.onDidChange}},nn={createDiagnosticCollection(be){return oi.createDiagnosticCollection(Ue.identifier,be)},get onDidChangeDiagnostics(){return oi.onDidChangeDiagnostics},getDiagnostics:be=>oi.getDiagnostics(be),getLanguages(){return ai.getLanguages()},setTextDocumentLanguage(be,ke){return ai.changeLanguage(be.uri,ke)},match(be,ke){const Oe=It.getDocumentData(ke.uri)?.notebook;return(0,P.$$E)(J.LanguageSelector.from(be),ke.uri,ke.languageId,!0,Oe?.uri,Oe?.notebookType)},registerCodeActionsProvider(be,ke,Oe){return ut.registerCodeActionProvider(Ue,$t(be),ke,Oe)},registerDocumentPasteEditProvider(be,ke,Oe){return(0,je.$MF)(Ue,"documentPaste"),ut.registerDocumentPasteEditProvider(Ue,$t(be),ke,Oe)},registerCodeLensProvider(be,ke){return ut.registerCodeLensProvider(Ue,$t(be),ke)},registerDefinitionProvider(be,ke){return ut.registerDefinitionProvider(Ue,$t(be),ke)},registerDeclarationProvider(be,ke){return ut.registerDeclarationProvider(Ue,$t(be),ke)},registerImplementationProvider(be,ke){return ut.registerImplementationProvider(Ue,$t(be),ke)},registerTypeDefinitionProvider(be,ke){return ut.registerTypeDefinitionProvider(Ue,$t(be),ke)},registerHoverProvider(be,ke){return ut.registerHoverProvider(Ue,$t(be),ke,Ue.identifier)},registerEvaluatableExpressionProvider(be,ke){return ut.registerEvaluatableExpressionProvider(Ue,$t(be),ke,Ue.identifier)},registerInlineValuesProvider(be,ke){return ut.registerInlineValuesProvider(Ue,$t(be),ke,Ue.identifier)},registerDocumentHighlightProvider(be,ke){return ut.registerDocumentHighlightProvider(Ue,$t(be),ke)},registerLinkedEditingRangeProvider(be,ke){return ut.registerLinkedEditingRangeProvider(Ue,$t(be),ke)},registerReferenceProvider(be,ke){return ut.registerReferenceProvider(Ue,$t(be),ke)},registerRenameProvider(be,ke){return ut.registerRenameProvider(Ue,$t(be),ke)},registerDocumentSymbolProvider(be,ke,Oe){return ut.registerDocumentSymbolProvider(Ue,$t(be),ke,Oe)},registerWorkspaceSymbolProvider(be){return ut.registerWorkspaceSymbolProvider(Ue,be)},registerDocumentFormattingEditProvider(be,ke){return ut.registerDocumentFormattingEditProvider(Ue,$t(be),ke)},registerDocumentRangeFormattingEditProvider(be,ke){return ut.registerDocumentRangeFormattingEditProvider(Ue,$t(be),ke)},registerOnTypeFormattingEditProvider(be,ke,Oe,...st){return ut.registerOnTypeFormattingEditProvider(Ue,$t(be),ke,[Oe].concat(st))},registerDocumentSemanticTokensProvider(be,ke,Oe){return ut.registerDocumentSemanticTokensProvider(Ue,$t(be),ke,Oe)},registerDocumentRangeSemanticTokensProvider(be,ke,Oe){return ut.registerDocumentRangeSemanticTokensProvider(Ue,$t(be),ke,Oe)},registerSignatureHelpProvider(be,ke,Oe,...st){return typeof Oe=="object"?ut.registerSignatureHelpProvider(Ue,$t(be),ke,Oe):ut.registerSignatureHelpProvider(Ue,$t(be),ke,typeof Oe>"u"?[]:[Oe,...st])},registerCompletionItemProvider(be,ke,...Oe){return ut.registerCompletionItemProvider(Ue,$t(be),ke,Oe)},registerInlineCompletionItemProvider(be,ke,Oe){return ke.handleDidShowCompletionItem&&(0,je.$MF)(Ue,"inlineCompletionsAdditions"),ke.handleDidPartiallyAcceptCompletionItem&&(0,je.$MF)(Ue,"inlineCompletionsAdditions"),Oe&&(0,je.$MF)(Ue,"inlineCompletionsAdditions"),ut.registerInlineCompletionsProvider(Ue,$t(be),ke,Oe)},registerDocumentLinkProvider(be,ke){return ut.registerDocumentLinkProvider(Ue,$t(be),ke)},registerColorProvider(be,ke){return ut.registerColorProvider(Ue,$t(be),ke)},registerFoldingRangeProvider(be,ke){return ut.registerFoldingRangeProvider(Ue,$t(be),ke)},registerSelectionRangeProvider(be,ke){return ut.registerSelectionRangeProvider(Ue,be,ke)},registerCallHierarchyProvider(be,ke){return ut.registerCallHierarchyProvider(Ue,be,ke)},registerTypeHierarchyProvider(be,ke){return ut.registerTypeHierarchyProvider(Ue,be,ke)},setLanguageConfiguration:(be,ke)=>ut.setLanguageConfiguration(Ue,be,ke),getTokenInformationAtPosition(be,ke){return(0,je.$MF)(Ue,"tokenInformation"),ai.tokenAtPosition(be,ke)},registerInlayHintsProvider(be,ke){return ut.registerInlayHintsProvider(Ue,be,ke)},createLanguageStatusItem(be,ke){return ai.createLanguageStatusItem(Ue,be,ke)},registerDocumentDropEditProvider(be,ke,Oe){return ut.registerDocumentOnDropEditProvider(Ue,be,ke,(0,je.$LF)(Ue,"dropMetadata")?Oe:void 0)}},rn={get activeTextEditor(){return Lt.getActiveTextEditor()},get visibleTextEditors(){return Lt.getVisibleTextEditors()},get activeTerminal(){return gt.activeTerminal},get terminals(){return gt.terminals},async showTextDocument(be,ke,Oe){const st=await(A.URI.isUri(be)?Promise.resolve(sn.openTextDocument(be)):Promise.resolve(be));return Lt.showTextDocument(st,ke,Oe)},createTextEditorDecorationType(be){return Lt.createTextEditorDecorationType(Ue,be)},onDidChangeActiveTextEditor(be,ke,Oe){return Lt.onDidChangeActiveTextEditor(be,ke,Oe)},onDidChangeVisibleTextEditors(be,ke,Oe){return Lt.onDidChangeVisibleTextEditors(be,ke,Oe)},onDidChangeTextEditorSelection(be,ke,Oe){return Lt.onDidChangeTextEditorSelection(be,ke,Oe)},onDidChangeTextEditorOptions(be,ke,Oe){return Lt.onDidChangeTextEditorOptions(be,ke,Oe)},onDidChangeTextEditorVisibleRanges(be,ke,Oe){return Lt.onDidChangeTextEditorVisibleRanges(be,ke,Oe)},onDidChangeTextEditorViewColumn(be,ke,Oe){return Lt.onDidChangeTextEditorViewColumn(be,ke,Oe)},onDidCloseTerminal(be,ke,Oe){return gt.onDidCloseTerminal(be,ke,Oe)},onDidOpenTerminal(be,ke,Oe){return gt.onDidOpenTerminal(be,ke,Oe)},onDidChangeActiveTerminal(be,ke,Oe){return gt.onDidChangeActiveTerminal(be,ke,Oe)},onDidChangeTerminalDimensions(be,ke,Oe){return(0,je.$MF)(Ue,"terminalDimensions"),gt.onDidChangeTerminalDimensions(be,ke,Oe)},onDidChangeTerminalState(be,ke,Oe){return gt.onDidChangeTerminalState(be,ke,Oe)},onDidWriteTerminalData(be,ke,Oe){return(0,je.$MF)(Ue,"terminalDataWriteEvent"),gt.onDidWriteTerminalData(be,ke,Oe)},onDidExecuteTerminalCommand(be,ke,Oe){return(0,je.$MF)(Ue,"terminalExecuteCommandEvent"),gt.onDidExecuteTerminalCommand(be,ke,Oe)},get state(){return He.getState(Ue)},onDidChangeWindowState(be,ke,Oe){return He.onDidChangeWindowState(be,ke,Oe)},showInformationMessage(be,...ke){return li.showMessage(Ue,R.default.Info,be,ke[0],ke.slice(1))},showWarningMessage(be,...ke){return li.showMessage(Ue,R.default.Warning,be,ke[0],ke.slice(1))},showErrorMessage(be,...ke){return li.showMessage(Ue,R.default.Error,be,ke[0],ke.slice(1))},showQuickPick(be,ke,Oe){return ii.showQuickPick(Ue,be,ke,Oe)},showWorkspaceFolderPick(be){return ii.showWorkspaceFolderPick(be)},showInputBox(be,ke){return ii.showInput(be,ke)},showOpenDialog(be){return Ti.showOpenDialog(Ue,be)},showSaveDialog(be){return Ti.showSaveDialog(be)},createStatusBarItem(be,ke,Oe){let st,yt,Mt;return typeof be=="string"?(st=be,yt=ke,Mt=Oe):(yt=be,Mt=ke),Xt.createStatusBarEntry(Ue,st,yt,Mt)},setStatusBarMessage(be,ke){return Xt.setStatusBarMessage(be,ke)},withScmProgress(be){return Fe.report("window.withScmProgress",Ue,"Use 'withProgress' instead."),wi.withProgress(Ue,{location:K.ProgressLocation.SourceControl},(ke,Oe)=>be({report(st){}}))},withProgress(be,ke){return wi.withProgress(Ue,be,ke)},createOutputChannel(be,ke){return Ei.createOutputChannel(be,ke,Ue)},createWebviewPanel(be,ke,Oe,st){return Ri.createWebviewPanel(Ue,be,ke,Oe,st)},createWebviewTextEditorInset(be,ke,Oe,st){return(0,je.$MF)(Ue,"editorInsets"),Ci.createWebviewEditorInset(be,ke,Oe,st,Ue)},createTerminal(be,ke,Oe){return typeof be=="object"?"pty"in be?gt.createExtensionTerminal(be):gt.createTerminalFromOptions(be):gt.createTerminal(be,ke,Oe)},registerTerminalLinkProvider(be){return gt.registerLinkProvider(be)},registerTerminalProfileProvider(be,ke){return gt.registerProfileProvider(Ue,be,ke)},registerTerminalQuickFixProvider(be,ke){return(0,je.$MF)(Ue,"terminalQuickFixProvider"),gt.registerTerminalQuickFixProvider(be,Ue.identifier.value,ke)},registerTreeDataProvider(be,ke){return bi.registerTreeDataProvider(be,ke,Ue)},createTreeView(be,ke){return bi.createTreeView(be,ke,Ue)},registerWebviewPanelSerializer:(be,ke)=>Ri.registerWebviewPanelSerializer(Ue,be,ke),registerCustomEditorProvider:(be,ke,Oe={})=>cn.registerCustomEditorProvider(Ue,be,ke,Oe),registerFileDecorationProvider(be){return pt.registerFileDecorationProvider(be,Ue)},registerUriHandler(be){return mi.registerUriHandler(Ue,be)},createQuickPick(){return ii.createQuickPick(Ue)},createInputBox(){return ii.createInputBox(Ue)},get activeColorTheme(){return Ai.activeColorTheme},onDidChangeActiveColorTheme(be,ke,Oe){return Ai.onDidChangeActiveColorTheme(be,ke,Oe)},registerWebviewViewProvider(be,ke,Oe){return Li.registerWebviewViewProvider(Ue,be,ke,Oe?.webviewOptions)},get activeNotebookEditor(){return St.activeNotebookEditor},onDidChangeActiveNotebookEditor(be,ke,Oe){return St.onDidChangeActiveNotebookEditor(be,ke,Oe)},get visibleNotebookEditors(){return St.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return St.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(be,ke,Oe){return $i.onDidChangeNotebookEditorSelection(be,ke,Oe)},onDidChangeNotebookEditorVisibleRanges(be,ke,Oe){return $i.onDidChangeNotebookEditorVisibleRanges(be,ke,Oe)},showNotebookDocument(be,ke){return St.showNotebookDocument(be,ke)},registerExternalUriOpener(be,ke,Oe){return(0,je.$MF)(Ue,"externalUriOpener"),un.registerExternalUriOpener(Ue.identifier,be,ke,Oe)},registerProfileContentHandler(be,ke){return(0,je.$MF)(Ue,"profileContentHandlers"),ln.registrProfileContentHandler(Ue,be,ke)},registerQuickDiffProvider(be,ke,Oe,st){return(0,je.$MF)(Ue,"quickDiffProvider"),Ii.registerQuickDiffProvider($t(be),ke,Oe,st)},get tabGroups(){return Je.tabGroups},registerShareProvider(be,ke){return(0,je.$MF)(Ue,"shareProvider"),Hi.registerShareProvider($t(be),ke)}},sn={get rootPath(){return Fe.report("workspace.rootPath",Ue,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),dt.getPath()},set rootPath(be){throw new M.$7("rootPath")},getWorkspaceFolder(be){return dt.getWorkspaceFolder(be)},get workspaceFolders(){return dt.getWorkspaceFolders()},get name(){return dt.name},set name(be){throw new M.$7("name")},get workspaceFile(){return dt.workspaceFile},set workspaceFile(be){throw new M.$7("workspaceFile")},updateWorkspaceFolders:(be,ke,...Oe)=>dt.updateWorkspaceFolders(Ue,be,ke||0,...Oe),onDidChangeWorkspaceFolders:function(be,ke,Oe){return dt.onDidChangeWorkspace(be,ke,Oe)},asRelativePath:(be,ke)=>dt.getRelativePath(be,ke),findFiles:(be,ke,Oe,st)=>dt.findFiles(be,ke,Oe,Ue.identifier,st),findTextInFiles:(be,ke,Oe,st)=>{(0,je.$MF)(Ue,"findTextInFiles");let yt,Mt;return typeof ke=="object"?(yt=ke,Mt=Oe):(yt={},Mt=ke,st=Oe),dt.findTextInFiles(be,yt||{},Mt,Ue.identifier,st)},save:be=>((0,je.$MF)(Ue,"saveEditor"),dt.save(be)),saveAs:be=>((0,je.$MF)(Ue,"saveEditor"),dt.saveAs(be)),saveAll:be=>dt.saveAll(be),applyEdit(be,ke){return hn.applyWorkspaceEdit(be,Ue,ke)},createFileSystemWatcher:(be,ke,Oe,st)=>Yt.createFileSystemWatcher(dt,Ue,be,ke,Oe,st),get textDocuments(){return It.getAllDocumentData().map(be=>be.document)},set textDocuments(be){throw new M.$7("textDocuments")},openTextDocument(be){let ke;const Oe=be;if(typeof be=="string")ke=Promise.resolve(A.URI.file(be));else if(A.URI.isUri(be))ke=Promise.resolve(be);else if(!Oe||typeof Oe=="object")ke=It.createDocumentData(Oe);else throw new Error("illegal argument - uriOrFileNameOrOptions");return ke.then(st=>It.ensureDocumentData(st).then(yt=>yt.document))},onDidOpenTextDocument:(be,ke,Oe)=>It.onDidAddDocument(be,ke,Oe),onDidCloseTextDocument:(be,ke,Oe)=>It.onDidRemoveDocument(be,ke,Oe),onDidChangeTextDocument:(be,ke,Oe)=>It.onDidChangeDocument(be,ke,Oe),onDidSaveTextDocument:(be,ke,Oe)=>It.onDidSaveDocument(be,ke,Oe),onWillSaveTextDocument:(be,ke,Oe)=>Vi.getOnWillSaveTextDocumentEvent(Ue)(be,ke,Oe),get notebookDocuments(){return St.notebookDocuments.map(be=>be.apiNotebook)},async openNotebookDocument(be,ke){let Oe;if(A.URI.isUri(be))Oe=be,await St.openNotebookDocument(be);else if(typeof be=="string")Oe=A.URI.revive(await St.createNotebookDocument({viewType:be,content:ke}));else throw new Error("Invalid arguments");return St.getNotebookDocument(Oe).apiNotebook},onDidSaveNotebookDocument(be,ke,Oe){return ti.onDidSaveNotebookDocument(be,ke,Oe)},onDidChangeNotebookDocument(be,ke,Oe){return ti.onDidChangeNotebookDocument(be,ke,Oe)},onWillSaveNotebookDocument(be,ke,Oe){return Di.getOnWillSaveNotebookDocumentEvent(Ue)(be,ke,Oe)},get onDidOpenNotebookDocument(){return St.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return St.onDidCloseNotebookDocument},registerNotebookSerializer(be,ke,Oe,st){return St.registerNotebookSerializer(Ue,be,ke,Oe,(0,je.$LF)(Ue,"notebookLiveShare")?st:void 0)},onDidChangeConfiguration:(be,ke,Oe)=>Fi.onDidChangeConfiguration(be,ke,Oe),getConfiguration(be,ke){return ke=arguments.length===1?void 0:ke,Fi.getConfiguration(be,ke,Ue)},registerTextDocumentContentProvider(be,ke){return ki.registerTextDocumentContentProvider(be,ke)},registerTaskProvider:(be,ke)=>(Fe.report("window.registerTaskProvider",Ue,"Use the corresponding function on the 'tasks' namespace instead"),Ht.registerTaskProvider(Ue,be,ke)),registerFileSystemProvider(be,ke,Oe){return(0,qe.$jb)(qi.registerFileSystemProvider(Ue,be,ke,Oe),Pt.addFileSystemProvider(be,ke,Oe))},get fs(){return Pt.value},registerFileSearchProvider:(be,ke)=>((0,je.$MF)(Ue,"fileSearchProvider"),gi.registerFileSearchProvider(be,ke)),registerTextSearchProvider:(be,ke)=>((0,je.$MF)(Ue,"textSearchProvider"),gi.registerTextSearchProvider(be,ke)),registerRemoteAuthorityResolver:(be,ke)=>((0,je.$MF)(Ue,"resolvers"),kt.registerRemoteAuthorityResolver(be,ke)),registerResourceLabelFormatter:be=>((0,je.$MF)(Ue,"resolvers"),Ki.$registerResourceLabelFormatter(be)),getRemoteExecServer:be=>((0,je.$MF)(Ue,"resolvers"),kt.getRemoteExecServer(be)),onDidCreateFiles:(be,ke,Oe)=>Yt.onDidCreateFile(be,ke,Oe),onDidDeleteFiles:(be,ke,Oe)=>Yt.onDidDeleteFile(be,ke,Oe),onDidRenameFiles:(be,ke,Oe)=>Yt.onDidRenameFile(be,ke,Oe),onWillCreateFiles:(be,ke,Oe)=>Yt.getOnWillCreateFileEvent(Ue)(be,ke,Oe),onWillDeleteFiles:(be,ke,Oe)=>Yt.getOnWillDeleteFileEvent(Ue)(be,ke,Oe),onWillRenameFiles:(be,ke,Oe)=>Yt.getOnWillRenameFileEvent(Ue)(be,ke,Oe),openTunnel:be=>((0,je.$MF)(Ue,"tunnels"),te.openTunnel(Ue,be).then(ke=>{if(!ke)throw new Error("cannot open tunnel");return ke})),get tunnels(){return(0,je.$MF)(Ue,"tunnels"),te.getTunnels()},onDidChangeTunnels:(be,ke,Oe)=>((0,je.$MF)(Ue,"tunnels"),te.onDidChangeTunnels(be,ke,Oe)),registerPortAttributesProvider:(be,ke)=>((0,je.$MF)(Ue,"portsAttributes"),te.registerPortsAttributesProvider(be,ke)),registerTunnelProvider:(be,ke)=>((0,je.$MF)(Ue,"tunnelFactory"),te.registerTunnelProvider(be,ke)),registerTimelineProvider:(be,ke)=>((0,je.$MF)(Ue,"timeline"),Ji.registerTimelineProvider(be,ke,Ue.identifier,ft.converter)),get isTrusted(){return dt.trusted},requestWorkspaceTrust:be=>((0,je.$MF)(Ue,"workspaceTrust"),dt.requestWorkspaceTrust(be)),onDidGrantWorkspaceTrust:(be,ke,Oe)=>dt.onDidGrantWorkspaceTrust(be,ke,Oe),registerEditSessionIdentityProvider:(be,ke)=>((0,je.$MF)(Ue,"editSessionIdentityProvider"),dt.registerEditSessionIdentityProvider(be,ke)),onWillCreateEditSessionIdentity:(be,ke,Oe)=>((0,je.$MF)(Ue,"editSessionIdentityProvider"),dt.getOnWillCreateEditSessionIdentityEvent(Ue)(be,ke,Oe)),registerCanonicalUriProvider:(be,ke)=>((0,je.$MF)(Ue,"canonicalUriProvider"),dt.registerCanonicalUriProvider(be,ke)),getCanonicalUri:(be,ke,Oe)=>((0,je.$MF)(Ue,"canonicalUriProvider"),dt.provideCanonicalUri(be,ke,Oe))},fn={get inputBox(){return Fe.report("scm.inputBox",Ue,"Use 'SourceControl.inputBox' instead"),pi.getLastInputBox(Ue)},createSourceControl(be,ke,Oe){return pi.createSourceControl(Ue,be,ke,Oe)}},on={createCommentController(be,ke){return Pi.createCommentController(Ue,be,ke)}},an={get activeDebugSession(){return mt.activeDebugSession},get activeDebugConsole(){return mt.activeDebugConsole},get breakpoints(){return mt.breakpoints},get stackFrameFocus(){return mt.stackFrameFocus},onDidStartDebugSession(be,ke,Oe){return mt.onDidStartDebugSession(be,ke,Oe)},onDidTerminateDebugSession(be,ke,Oe){return mt.onDidTerminateDebugSession(be,ke,Oe)},onDidChangeActiveDebugSession(be,ke,Oe){return mt.onDidChangeActiveDebugSession(be,ke,Oe)},onDidReceiveDebugSessionCustomEvent(be,ke,Oe){return mt.onDidReceiveDebugSessionCustomEvent(be,ke,Oe)},onDidChangeBreakpoints(be,ke,Oe){return mt.onDidChangeBreakpoints(be,ke,Oe)},onDidChangeStackFrameFocus(be,ke,Oe){return(0,je.$MF)(Ue,"debugFocus"),mt.onDidChangeStackFrameFocus(be,ke,Oe)},registerDebugConfigurationProvider(be,ke,Oe){return mt.registerDebugConfigurationProvider(be,ke,Oe||Xe.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(be,ke){return mt.registerDebugAdapterDescriptorFactory(Ue,be,ke)},registerDebugAdapterTrackerFactory(be,ke){return mt.registerDebugAdapterTrackerFactory(be,ke)},startDebugging(be,ke,Oe){return!Oe||typeof Oe=="object"&&"configuration"in Oe?mt.startDebugging(be,ke,{parentSession:Oe}):mt.startDebugging(be,ke,Oe||{})},stopDebugging(be){return mt.stopDebugging(be)},addBreakpoints(be){return mt.addBreakpoints(be)},removeBreakpoints(be){return mt.removeBreakpoints(be)},asDebugSourceUri(be,ke){return mt.asDebugSourceUri(be,ke)}},Ni={registerTaskProvider:(be,ke)=>Ht.registerTaskProvider(Ue,be,ke),fetchTasks:be=>Ht.fetchTasks(be),executeTask:be=>Ht.executeTask(Ue,be),get taskExecutions(){return Ht.taskExecutions},onDidStartTask:(be,ke,Oe)=>Ht.onDidStartTask(be,ke,Oe),onDidEndTask:(be,ke,Oe)=>Ht.onDidEndTask(be,ke,Oe),onDidStartTaskProcess:(be,ke,Oe)=>Ht.onDidStartTaskProcess(be,ke,Oe),onDidEndTaskProcess:(be,ke,Oe)=>Ht.onDidEndTaskProcess(be,ke,Oe)},Oi={createNotebookController(be,ke,Oe,st,yt){return si.createNotebookController(Ue,be,ke,Oe,st,(0,je.$LF)(Ue,"notebookMessaging")?yt:void 0)},registerNotebookCellStatusBarItemProvider:(be,ke)=>St.registerNotebookCellStatusBarItemProvider(Ue,be,ke),createRendererMessaging(be){return Si.createRendererMessaging(Ue,be)},createNotebookControllerDetectionTask(be){return(0,je.$MF)(Ue,"notebookKernelSource"),si.createNotebookControllerDetectionTask(Ue,be)},registerKernelSourceActionProvider(be,ke){return(0,je.$MF)(Ue,"notebookKernelSource"),si.registerKernelSourceActionProvider(Ue,be,ke)},onDidChangeNotebookCellExecutionState(be,ke,Oe){return(0,je.$MF)(Ue,"notebookCellExecutionState"),si.onDidChangeNotebookCellExecutionState(be,ke,Oe)}},zi={t(...be){if(typeof be[0]=="string"){const ke=be.shift(),Oe=!be||typeof be[0]!="object"?be:be[0];return Wt.getMessage(Ue.identifier.value,{message:ke,args:Oe})}return Wt.getMessage(Ue.identifier.value,be[0])},get bundle(){return Wt.getBundle(Ue.identifier.value)},get uri(){return Wt.getBundleUri(Ue.identifier.value)}},di={_version:1,registerInteractiveEditorSessionProvider(be){return(0,je.$MF)(Ue,"interactive"),Gi.registerProvider(Ue,be)},registerInteractiveSessionProvider(be,ke){return(0,je.$MF)(Ue,"interactive"),ui.registerChatProvider(Ue,be,ke)},addInteractiveRequest(be){return(0,je.$MF)(Ue,"interactive"),ui.addChatRequest(be)},sendInteractiveRequestToProvider(be,ke){return(0,je.$MF)(Ue,"interactive"),ui.sendInteractiveRequestToProvider(be,ke)},get onDidPerformUserAction(){return(0,je.$MF)(Ue,"interactiveUserActions"),ui.onDidPerformUserAction},transferChatSession(be,ke){return(0,je.$MF)(Ue,"interactive"),ui.transferChatSession(be,ke)}},ji={getRelatedInformation(be,ke){return(0,je.$MF)(Ue,"aiRelatedInformation"),Yi.getRelatedInformation(Ue,be,ke)},registerRelatedInformationProvider(be,ke){return(0,je.$MF)(Ue,"aiRelatedInformation"),Yi.registerRelatedInformationProvider(Ue,be,ke)},registerEmbeddingVectorProvider(be,ke){return(0,je.$MF)(Ue,"aiRelatedInformation"),Mi.registerEmbeddingVectorProvider(Ue,be,ke)}},Ui={registerChatResponseProvider(be,ke,Oe){return(0,je.$MF)(Ue,"chatProvider"),fi.registerProvider(Ue.identifier,be,ke,Oe)},registerSlashCommand(be,ke,Oe){return(0,je.$MF)(Ue,"chatSlashCommands"),Zi.registerCommand(Ue.identifier,be,ke,Oe??{description:""})},requestChatAccess(be){return(0,je.$MF)(Ue,"chatRequestAccess"),fi.requestChatResponseProvider(Ue.identifier,be)},registerVariable(be,ke,Oe){return(0,je.$MF)(Ue,"chatVariables"),Qi.registerVariableResolver(Ue,be,ke,Oe)},registerMappedEditsProvider(be,ke){return(0,je.$MF)(Ue,"mappedEditsProvider"),ut.registerMappedEditsProvider(Ue,be,ke)}};return{version:lt.version,ai:ji,authentication:xi,commands:_i,comments:on,chat:Ui,debug:an,env:en,extensions:tn,interactive:di,l10n:zi,languages:nn,notebooks:Oi,scm:fn,tasks:Ni,tests:dn,window:rn,workspace:sn,Breakpoint:K.$TK,TerminalOutputAnchor:K.TerminalOutputAnchor,ChatMessage:K.$JL,ChatMessageRole:K.ChatMessageRole,ChatVariableLevel:K.ChatVariableLevel,CallHierarchyIncomingCall:K.$gK,CallHierarchyItem:K.$fK,CallHierarchyOutgoingCall:K.$hK,CancellationError:M.$3,CancellationTokenSource:D.$rc,CandidatePortSource:b.CandidatePortSource,CodeAction:K.$bK,CodeActionKind:K.$cK,CodeActionTriggerKind:K.CodeActionTriggerKind,CodeLens:K.$iK,Color:K.$vK,ColorInformation:K.$wK,ColorPresentation:K.$xK,ColorThemeKind:K.ColorThemeKind,CommentMode:K.CommentMode,CommentState:K.CommentState,CommentThreadCollapsibleState:K.CommentThreadCollapsibleState,CommentThreadState:K.CommentThreadState,CompletionItem:K.$pK,CompletionItemKind:K.CompletionItemKind,CompletionItemTag:K.CompletionItemTag,CompletionList:K.$qK,CompletionTriggerKind:K.CompletionTriggerKind,ConfigurationTarget:K.ConfigurationTarget,CustomExecution:K.$FK,DebugAdapterExecutable:K.$XK,DebugAdapterInlineImplementation:K.$1K,DebugAdapterNamedPipeServer:K.$ZK,DebugAdapterServer:K.$YK,DebugConfigurationProviderTriggerKind:Xe.DebugConfigurationProviderTriggerKind,DebugConsoleMode:K.DebugConsoleMode,DecorationRangeBehavior:K.DecorationRangeBehavior,Diagnostic:K.$9J,DiagnosticRelatedInformation:K.$8J,DiagnosticSeverity:K.DiagnosticSeverity,DiagnosticTag:K.DiagnosticTag,Disposable:K.$UJ,DocumentHighlight:K.$$J,DocumentHighlightKind:K.DocumentHighlightKind,DocumentLink:K.$uK,DocumentSymbol:K.$aK,EndOfLine:K.EndOfLine,EnvironmentVariableMutatorType:K.EnvironmentVariableMutatorType,EvaluatableExpression:K.$4K,InlineValueText:K.$5K,InlineValueVariableLookup:K.$6K,InlineValueEvaluatableExpression:K.$7K,InlineCompletionTriggerKind:K.InlineCompletionTriggerKind,EventEmitter:h.$hc,ExtensionKind:K.ExtensionKind,ExtensionMode:K.ExtensionMode,ExternalUriOpenerPriority:K.ExternalUriOpenerPriority,FileChangeType:K.FileChangeType,FileDecoration:K.$eL,FileDecoration2:K.$eL,FileSystemError:K.$9K,FileType:I.FileType,FilePermission:I.FilePermission,FoldingRange:K.$0K,FoldingRangeKind:K.FoldingRangeKind,FunctionBreakpoint:K.$VK,InlineCompletionItem:K.$rK,InlineCompletionList:K.$sK,Hover:K.$0J,IndentAction:$.IndentAction,Location:K.$7J,MarkdownString:K.$jK,OverviewRulerLane:E.OverviewRulerLane,ParameterInformation:K.$kK,PortAutoForwardAction:K.PortAutoForwardAction,Position:K.$VJ,ProcessExecution:K.$DK,ProgressLocation:K.ProgressLocation,QuickInputButtons:K.$dL,Range:K.$WJ,RelativePattern:K.$RK,Selection:K.$XJ,SelectionRange:K.$eK,SemanticTokens:K.$aL,SemanticTokensBuilder:K.$_K,SemanticTokensEdit:K.$bL,SemanticTokensEdits:K.$cL,SemanticTokensLegend:K.$$K,ShellExecution:K.$EK,ShellQuoting:K.ShellQuoting,SignatureHelp:K.$mK,SignatureHelpTriggerKind:K.SignatureHelpTriggerKind,SignatureInformation:K.$lK,SnippetString:K.$6J,SourceBreakpoint:K.$UK,StandardTokenType:K.StandardTokenType,StatusBarAlignment:K.StatusBarAlignment,SymbolInformation:K.$_J,SymbolKind:K.SymbolKind,SymbolTag:K.SymbolTag,Task:K.$GK,TaskGroup:K.$CK,TaskPanelKind:K.TaskPanelKind,TaskRevealKind:K.TaskRevealKind,TaskScope:K.TaskScope,TerminalLink:K.$yK,TerminalQuickFixExecuteTerminalCommand:K.$AK,TerminalQuickFixOpener:K.$zK,TerminalLocation:K.TerminalLocation,TerminalProfile:K.$BK,TerminalExitReason:K.TerminalExitReason,TextDocumentSaveReason:K.TextDocumentSaveReason,TextEdit:K.$2J,SnippetTextEdit:K.$4J,TextEditorCursorStyle:g.TextEditorCursorStyle,TextEditorLineNumbersStyle:K.TextEditorLineNumbersStyle,TextEditorRevealType:K.TextEditorRevealType,TextEditorSelectionChangeKind:K.TextEditorSelectionChangeKind,TextDocumentChangeReason:K.TextDocumentChangeReason,ThemeColor:K.$QK,ThemeIcon:K.$PK,TreeItem:K.$HK,TreeItemCheckboxState:K.TreeItemCheckboxState,TreeItemCollapsibleState:K.TreeItemCollapsibleState,TypeHierarchyItem:K.$zL,UIKind:S.UIKind,Uri:A.URI,ViewColumn:K.ViewColumn,WorkspaceEdit:K.$5J,DocumentDropEdit:K.$NK,DocumentPasteEdit:K.$OK,InlayHint:K.$oK,InlayHintLabelPart:K.$nK,InlayHintKind:K.InlayHintKind,RemoteAuthorityResolverError:K.$1J,ResolvedAuthority:K.$YJ,ManagedResolvedAuthority:K.$ZJ,SourceControlInputBoxValidationType:K.SourceControlInputBoxValidationType,ExtensionRuntime:K.ExtensionRuntime,TimelineItem:K.$oL,NotebookRange:K.$gL,NotebookCellKind:K.NotebookCellKind,NotebookCellExecutionState:K.NotebookCellExecutionState,NotebookCellData:K.$hL,NotebookData:K.$iL,NotebookRendererScript:K.$mL,NotebookCellStatusBarAlignment:K.NotebookCellStatusBarAlignment,NotebookEditorRevealType:K.NotebookEditorRevealType,NotebookCellOutput:K.$kL,NotebookCellOutputItem:K.$jL,NotebookCellStatusBarItem:K.$lL,NotebookControllerAffinity:K.NotebookControllerAffinity,NotebookControllerAffinity2:K.NotebookControllerAffinity2,NotebookEdit:K.$3J,NotebookKernelSourceAction:K.$nL,PortAttributes:K.$qL,LinkedEditingRanges:K.$pL,TestResultState:K.TestResultState,TestRunRequest:K.$rL,TestMessage:K.$sL,TestMessage2:K.$sL,TestTag:K.$tL,TestRunProfileKind:K.TestRunProfileKind,TextSearchCompleteMessageType:Ne.TextSearchCompleteMessageType,DataTransfer:K.$MK,DataTransferItem:K.$IK,CoveredCount:K.$uL,FileCoverage:K.$vL,StatementCoverage:K.$wL,BranchCoverage:K.$xL,FunctionCoverage:K.$yL,WorkspaceTrustState:K.WorkspaceTrustState,LanguageStatusSeverity:K.LanguageStatusSeverity,QuickPickItemKind:K.QuickPickItemKind,InputBoxValidationSeverity:K.InputBoxValidationSeverity,TabInputText:K.$AL,TabInputTextDiff:K.$BL,TabInputTextMerge:K.$CL,TabInputCustom:K.$DL,TabInputNotebook:K.$FL,TabInputNotebookDiff:K.$GL,TabInputWebview:K.$EL,TabInputTerminal:K.$HL,TabInputInteractiveWindow:K.$IL,TelemetryTrustedValue:me.$0n,LogLevel:ne.LogLevel,EditSessionIdentityMatch:ot.EditSessionIdentityMatch,InteractiveSessionVoteDirection:K.InteractiveSessionVoteDirection,InteractiveSessionCopyKind:K.InteractiveSessionCopyKind,InteractiveEditorResponseFeedbackKind:K.InteractiveEditorResponseFeedbackKind,StackFrameFocus:K.$2K,ThreadFocus:K.$3K,NotebookCodeActionKind:K.$dK,RelatedInformationType:K.RelatedInformationType}}}e.$zcc=Bt}),define(De[346],Ce([1,0,102,150,38,147,39,33,65,42,93,94,95,114,68,89,149,67,52,113,88,66,148,17,53,111,112]),function($e,e,D,M,h,R,A,g,E,$,P,I,b,S,C,y,r,i,a,m,p,f,t,s,o,n,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,D.$jr)(n.$abc,n.$_ac,1),(0,D.$jr)(s.$4i,t.$Acc,1),(0,D.$jr)(y.$zac,y.$Aac,1),(0,D.$jr)(g.$eM,g.$dM,0),(0,D.$jr)(A.$Mac,A.$Kac,0),(0,D.$jr)(i.$2ac,i.$1ac,0),(0,D.$jr)(I.$Pbc,I.$Tbc,0),(0,D.$jr)(R.$Hbc,R.$Gbc,0),(0,D.$jr)(E.$6L,E.$5L,0),(0,D.$jr)(c.$bbc,c.$cbc,0),(0,D.$jr)(a.$wac,a.$vac,0),(0,D.$jr)(M.$nbc,M.$mbc,1),(0,D.$jr)(b.$Zbc,b.$1bc,0),(0,D.$jr)(S.$Xac,S.$Wac,0),(0,D.$jr)(P.$Kbc,P.$Jbc,0),(0,D.$jr)($.$5ac,$.$8ac,0),(0,D.$jr)(C.$3rb,C.$4rb,0),(0,D.$jr)(r.$Dbc,r.$Cbc,0),(0,D.$jr)(h.$Jac,h.$Iac,0),(0,D.$jr)(m.$0ac,m.$9ac,0),(0,D.$jr)(p.$cM,p.$_L,0),(0,D.$jr)(f.$Lbc,f.$Mbc,0),(0,D.$jr)(o.$Nbc,o.$Obc,0)}),define(De[115],Ce([1,0,19,17,36,92]),function($e,e,D,M,h,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Scc=e.$Rcc=e.$Qcc=void 0;function A(I){return I.startsWith("**")||I.startsWith("/")?I:`/${I}`}e.$Qcc=A;function g(I,b,S,C){const y=(0,D.$Uf)(S,E),r=new h.$jI(b,y,C),i=r.preview.matches;return{ranges:(0,D.$Uf)(y,$),uri:I,preview:{text:r.preview.text,matches:(0,D.$Uf)(i,$)}}}e.$Rcc=g;function E(I){return new h.$kI(I.start.line,I.start.character,I.end.line,I.end.character)}function $(I){return new R.$$H(I.startLineNumber,I.startColumn,I.endLineNumber,I.endColumn)}let P=class{constructor(b,S){this.a=b,this.b=S}appendLine(b){this.b.debug(`${this.a}#search`,b)}};e.$Scc=P,e.$Scc=P=Ke([Ve(1,M.$3i)],P)}),define(De[347],Ce([1,0,46,14,73,32,9,15,115,348]),function($e,e,D,M,h,R,A,g,E,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vcc=e.$Ucc=e.$Tcc=void 0;const P=$.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");function I(m,p,f,t){const s=b(m,p,f,t),o=p.folder.fsPath;return{cmd:D.spawn(P,s.args,{cwd:o}),rgDiskPath:P,siblingClauses:s.siblingClauses,rgArgs:s,cwd:o}}e.$Tcc=I;function b(m,p,f,t){const s=["--files","--hidden","--case-sensitive","--no-require-git"];C([p],f,!1).forEach(n=>{const c=(0,E.$Qcc)(n);if(s.push("-g",c),A.$j){const d=(0,h.$gl)(c);d!==c&&s.push("-g",d)}});const o=S([p],t,void 0,!1);return o.globArgs.forEach(n=>{const c=`!${(0,E.$Qcc)(n)}`;if(s.push("-g",c),A.$j){const d=(0,h.$gl)(c);d!==c&&s.push("-g",d)}}),p.disregardIgnoreFiles!==!1?s.push("--no-ignore"):p.disregardParentIgnoreFiles!==!1&&s.push("--no-ignore-parent"),p.ignoreSymlinks||s.push("--follow"),m.exists&&s.push("--quiet"),s.push("--no-config"),p.disregardGlobalIgnoreFiles&&s.push("--no-ignore-global"),{args:s,siblingClauses:o.siblingClauses}}function S(m,p,f,t=!0){const s=[];let o={};return m.forEach(n=>{const c=Object.assign({},n.excludePattern||{},p||{}),d=y(c,t?n.folder.fsPath:void 0,f);s.push(...d.globArgs),d.siblingClauses&&(o=Object.assign(o,d.siblingClauses))}),{globArgs:s,siblingClauses:o}}function C(m,p,f=!0){const t=[];return m.forEach(s=>{const o=Object.assign({},p||{},s.includePattern||{}),n=y(o,f?s.folder.fsPath:void 0);t.push(...n.globArgs)}),t}function y(m,p,f){const t=[],s={};return Object.keys(m).forEach(o=>{if(f&&f.has(o)||!o)return;const n=m[o];o=i(p?r(p,o):o),o.startsWith("\\\\")?o="\\\\"+o.substr(2).replace(/\\/g,"/"):o=o.replace(/\\/g,"/"),typeof n=="boolean"&&n?(o.startsWith("\\\\")&&(o+="**"),t.push(a(o))):n&&n.when&&(s[o]=n)}),{globArgs:t,siblingClauses:s}}function r(m,p){return M.$0c(p)?p:M.$$c(m,p)}e.$Ucc=r;function i(m){return m=g.$xd(m,"\\"),g.$xd(m,"/")}function a(m){return R.$Ge(m).toLowerCase()==="c:/"?m.replace(/^c:[/\\]/i,"/"):m}e.$Vcc=a}),define(De[349],Ce([1,0,46,49,14,350,19,44,35,73,32,9,37,15,18,29,36,347,126]),function($e,e,D,M,h,R,A,g,E,$,P,I,b,S,C,y,r,i,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xcc=e.$Wcc=void 0;const m=new Set;process.on("exit",()=>{m.forEach(o=>o())});class p{constructor(n){this.c=null,this.h=null,this.l=!1,this.m=null,this.r=null,this.s=0,this.a=n,this.b=n.filePattern||"",this.d=n.includePattern&&E.$pj(n.includePattern),this.f=n.maxResults||null,this.g=!!n.exists,this.v=Object.create(null),this.k=0,this.j=!1,this.o=0,this.p=0,this.q=[],this.b&&(this.c=(0,a.$lq)(this.b).normalizedLowercase),this.u=n.excludePattern&&E.$pj(n.excludePattern),this.t=new Map,n.folderQueries.forEach(c=>{const d=Object.assign({},c.excludePattern||{},this.a.excludePattern||{}),v=c.folder.fsPath;n.folderQueries.map(k=>k.folder.fsPath).filter(k=>k!==v).forEach(k=>{(0,P.$Ke)(k,v)&&(d[h.$ad(v,k)]=!0)}),this.t.set(v,new t(d,v))})}cancel(){this.l=!0,m.forEach(n=>n())}walk(n,c,d,v,k){if(this.m=b.$dc.create(!1),this.l)return k(null,this.j);c.forEach(u=>{const l=h.$cd(u.fsPath);this.u&&this.u(u.fsPath,l)||this.J(d,{relativePath:u.fsPath,searchPath:void 0})}),this.r=b.$dc.create(!1),this.w(n,(u,l)=>{this.x(this.y,this,u,d,v,w=>{if(w){const L=(0,g.$ki)(w);console.error(L),this.q.push(L),l(w,void 0)}else l(null,void 0)})},(u,l)=>{this.m.stop();const w=u?A.$Af(u)[0]:null;k(w,this.j)})}w(n,c,d){const v=new Array(n.length),k=new Array(n.length);let u=!1,l=0;if(n.length===0)return d(null,[]);n.forEach((w,L)=>{c(w,(N,j)=>{if(N?(u=!0,v[L]=null,k[L]=N):(v[L]=j,k[L]=null),++l===n.length)return d(u?k:null,v)})})}x(n,c,...d){try{n.apply(c,d)}catch(v){d[d.length-1](v)}}y(n,c,d,v){const k=n.folder.fsPath,u=I.$j,l=()=>T&&T.kill();m.add(l);let w=J=>{m.delete(l),w=()=>{},v(J)},L="";const N=this.D(),j=(0,i.$Tcc)(this.a,n,this.a.includePattern,this.t.get(n.folder.fsPath).expression),T=j.cmd,O=!Object.keys(j.siblingClauses).length,B=j.rgArgs.args.map(J=>J.match(/^-/)?J:`'${J}'`).join(" ");let F=`${j.rgDiskPath} ${B}
 - cwd: ${j.cwd}`;j.rgArgs.siblingClauses&&(F+=`
 - Sibling clauses: ${JSON.stringify(j.rgArgs.siblingClauses)}`),d({message:F}),this.s=0,this.z(T,"utf8",d,(J,K,me)=>{if(J){w(J);return}if(this.j){w();return}const x=(L+(u?$.$fl(K||""):K)).split(`
`);if(me){const q=x.length;x[q-1]=x[q-1].trim(),x[q-1]||x.pop()}else L=x.pop()||"";if(x.length&&x[0].indexOf(`
`)!==-1){w(new Error("Splitting up files failed"));return}if(this.s+=x.length,O){for(const q of x)if(this.J(c,{base:k,relativePath:q,searchPath:this.N(n,q)}),this.j){l();break}(me||this.j)&&w();return}this.G(n,N,k,x,c),me&&(this.H(N,k,c),w())})}spawnFindCmd(n){const c=this.t.get(n.folder.fsPath),d=c.getBasenameTerms(),v=c.getPathTerms(),k=["-L","."];if(d.length||v.length){k.push("-not","(","(");for(const u of d)k.push("-name",u),k.push("-o");for(const u of v)k.push("-path",u),k.push("-o");k.pop(),k.push(")","-prune",")")}return k.push("-type","f"),D.spawn("find",k,{cwd:n.folder.fsPath})}readStdout(n,c,d){let v="";this.z(n,c,()=>{},(k,u,l)=>{if(k){d(k);return}v+=u,l&&d(null,v)})}z(n,c,d,v){let k=(w,L,N)=>{(w||N)&&(k=()=>{},this.r?.stop()),v(w,L,N)},u=!1;n.stdout?(this.A(n.stdout,c,k),n.stdout.once("data",()=>u=!0)):d({message:"stdout is null"});let l;n.stderr?l=this.B(n.stderr):d({message:"stderr is null"}),n.on("error",w=>{k(w)}),n.on("close",w=>{let L;!u&&(L=this.C(l,c))&&s(L)?k(new Error(`command failed with error code ${w}: ${this.C(l,c)}`)):(this.g&&w===0&&(this.j=!0),k(null,"",!0))})}A(n,c,d){const v=new R.StringDecoder(c);return n.on("data",k=>{d(null,v.write(k))}),v}B(n){const c=[];return n.on("data",d=>{c.push(d)}),c}C(n,c){const d=new R.StringDecoder(c);return n.map(v=>d.write(v)).join("")}D(){const n={rootEntries:[],pathToEntries:Object.create(null)};return n.pathToEntries["."]=n.rootEntries,n}G(n,{pathToEntries:c},d,v,k){v.indexOf(this.b)!==-1&&this.J(k,{base:d,relativePath:this.b,searchPath:this.N(n,this.b)});const u=l=>{const w=h.$cd(l),L=h.$bd(l);let N=c[L];N||(N=c[L]=[],u(L)),N.push({base:d,relativePath:l,basename:w,searchPath:this.N(n,l)})};v.forEach(u)}H({rootEntries:n,pathToEntries:c},d,v){const k=this,u=this.t.get(d),l=this.b;function w(L){k.o++;const N=(0,r.$zI)(()=>L.map(j=>j.basename));for(let j=0,T=L.length;j<T;j++){const O=L[j],{relativePath:B,basename:F}=O;if(u.test(B,F,l!==F?N:void 0))continue;const J=c[B];if(J)w(J);else{if(k.p++,B===l)continue;k.J(v,O)}if(k.j)break}}w(n)}getStats(){return{cmdTime:this.r.elapsed(),fileWalkTime:this.m.elapsed(),directoriesWalked:this.o,filesWalked:this.p,cmdResultCount:this.s}}I(n,c,d,v,k){const u=n.folder,l=(0,r.$zI)(()=>d);this.w(d,(w,L)=>{if(this.l||this.j)return L(null);const N=c?[c,w].join(h.sep):w;if(this.t.get(n.folder.fsPath).test(N,w,this.a.filePattern!==w?l:void 0))return L(null);const j=[u.fsPath,N].join(h.sep);M.lstat(j,(T,O)=>{if(T||this.l||this.j)return L(null);this.L(j,O,(B,F)=>B||this.l||this.j?L(null):F.isDirectory()?(this.o++,this.M(j,O,(J,K)=>J||this.l||this.j||(K=K||"",this.v[K])?L(null):(this.v[K]=!0,y.Promises.readdir(j).then(me=>{if(this.l||this.j)return L(null);this.I(n,N,me,v,re=>L(re||null))},me=>{L(null)})))):(this.p++,N===this.b||this.h&&C.$pe(F.size)&&F.size>this.h||this.J(v,{base:u.fsPath,relativePath:N,searchPath:this.N(n,N)}),L(null,void 0)))})},w=>{const L=w&&A.$Af(w);return k(L&&L.length>0?L[0]:void 0)})}J(n,c){this.K(c)&&(!this.d||this.d(c.relativePath,h.$cd(c.relativePath)))&&(this.k++,(this.g||this.f&&this.k>this.f)&&(this.j=!0),this.j||n(c))}K(n){if(this.b){if(this.b==="*")return!0;if(this.c)return(0,r.$uI)(n,this.c)}return!0}L(n,c,d){return c.isSymbolicLink()?M.stat(n,d):d(null,c)}M(n,c,d){return c.isSymbolicLink()?M.realpath(n,(v,k)=>v?d(v):d(null,k)):d(null,n)}N(n,c){return n.folderName?h.$$c(n.folderName,c):c}}e.$Wcc=p;class f{constructor(n){this.a=n.folderQueries,this.b=n.extraFileResources||[],this.c=new p(n)}search(n,c,d){this.c.walk(this.a,this.b,n,c,(v,k)=>{d(v,{limitHit:k,stats:this.c.getStats(),messages:[]})})}cancel(){this.c.cancel()}}e.$Xcc=f;class t{constructor(n,c){this.expression=n,this.c=c,this.d(n)}d(n){let c,d;Object.keys(n).filter(v=>n[v]).forEach(v=>{h.$0c(v)?(c=c||E.$kj(),c[v]=n[v]):(d=d||E.$kj(),d[v]=n[v])}),this.a=c&&E.$pj(c,{trimForExclusions:!0}),this.b=d&&E.$pj(d,{trimForExclusions:!0})}test(n,c,d){return this.b&&this.b(n,c,d)||this.a&&this.a(h.$$c(this.c,n),c,d)}getBasenameTerms(){const n=[];return this.a&&n.push(...E.$rj(this.a)),this.b&&n.push(...E.$rj(this.b)),n}getPathTerms(){const n=[];return this.a&&n.push(...E.$sj(this.a)),this.b&&n.push(...E.$sj(this.b)),n}}function s(o){const n=o.trim().split(`
`),c=n[0].trim();if(c.startsWith("Error parsing regex"))return c;if(c.startsWith("regex parse error"))return S.$de(n[n.length-1].trim());if(c.startsWith("error parsing glob")||c.startsWith("unsupported encoding"))return c.charAt(0).toUpperCase()+c.substr(1);if(c==="Literal '\\n' not allowed.")return"Literal '\\n' currently not supported";if(c.startsWith("Literal "))return c}}),define(De[351],Ce([1,0,96,21,180,22]),function($e,e,D,M,h,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nD=e.$mD=e.$lD=e.$kD=e.$jD=e.$iD=e.$hD=e.$gD=e.$fD=e.DecodeStreamErrorKind=e.$eD=e.$dD=e.$cD=e.$bD=e.$aD=e.$_C=e.$$C=e.$0C=void 0,e.$0C="utf8",e.$$C="utf8bom",e.$_C="utf16be",e.$aD="utf16le";function A(c){return[e.$0C,e.$$C,e.$_C,e.$aD].some(d=>d===c)}e.$bD=A,e.$cD=[254,255],e.$dD=[255,254],e.$eD=[239,187,191];const g=512,E=512,$=512*8,P=512*128;var I;(function(c){c[c.STREAM_IS_BINARY=1]="STREAM_IS_BINARY"})(I||(e.DecodeStreamErrorKind=I={}));class b extends Error{constructor(d,v){super(d),this.decodeStreamErrorKind=v}}e.$fD=b;class S{static async create(d){let v;if(d!==e.$0C)v=(await(0,h.$9C)("@vscode/iconv-lite-umd","lib/iconv-lite-umd.js")).getDecoder(i(d));else{const k=new TextDecoder;v={write(u){return k.decode(u,{stream:!0})},end(){return k.decode()}}}return new S(v)}constructor(d){this.a=d}write(d){return this.a.write(d)}end(){return this.a.end()}}function C(c,d){const v=d.minBytesRequiredForDetection??d.guessEncoding?$:E;return new Promise((k,u)=>{const l=(0,D.$vc)(O=>O.join("")),w=[];let L=0,N;const j=new R.$rc,T=async()=>{try{const O=await n({buffer:M.$Hc.concat(w),bytesRead:L},d.guessEncoding);if(O.seemsBinary&&d.acceptTextOnly)throw new b("Stream is binary but only text is accepted for decoding",1);O.encoding=await d.overwriteEncoding(O.encoding),N=await S.create(O.encoding);const B=N.write(M.$Hc.concat(w).buffer);l.write(B),w.length=0,L=0,k({stream:l,detected:O})}catch(O){j.cancel(),l.destroy(),u(O)}};(0,D.$zc)(c,{onData:async O=>{N?l.write(N.write(O.buffer)):(w.push(O),L+=O.byteLength,L>=v&&(c.pause(),await T(),setTimeout(()=>c.resume())))},onError:O=>l.error(O),onEnd:async()=>{N||await T(),l.end(N?.end())}},j.token)})}e.$gD=C;async function y(c,d,v){const u=(await(0,h.$9C)("@vscode/iconv-lite-umd","lib/iconv-lite-umd.js")).getEncoder(i(d),v);let l=!1,w=!1;return{read(){if(w)return null;const L=c.read();if(typeof L!="string"){if(w=!0,!l&&v?.addBOM)switch(d){case e.$0C:case e.$$C:return M.$Hc.wrap(Uint8Array.from(e.$eD));case e.$_C:return M.$Hc.wrap(Uint8Array.from(e.$cD));case e.$aD:return M.$Hc.wrap(Uint8Array.from(e.$dD))}const N=u.end();return N&&N.length>0?(l=!0,M.$Hc.wrap(N)):null}return l=!0,M.$Hc.wrap(u.write(L))}}}e.$hD=y;async function r(c){return(await(0,h.$9C)("@vscode/iconv-lite-umd","lib/iconv-lite-umd.js")).encodingExists(i(c))}e.$iD=r;function i(c){return c===e.$$C||c===null?e.$0C:c}e.$jD=i;function a(c,d){if(!c||d<e.$cD.length)return null;const v=c.readUInt8(0),k=c.readUInt8(1);if(v===e.$cD[0]&&k===e.$cD[1])return e.$_C;if(v===e.$dD[0]&&k===e.$dD[1])return e.$aD;if(d<e.$eD.length)return null;const u=c.readUInt8(2);return v===e.$eD[0]&&k===e.$eD[1]&&u===e.$eD[2]?e.$$C:null}e.$kD=a;const m=["ascii","utf-16","utf-32"];async function p(c){const d=await(0,h.$9C)("jschardet","dist/jschardet.min.js"),v=c.slice(0,P),k=s(v.buffer),u=d.detect(k);if(!u||!u.encoding)return null;const l=u.encoding.toLowerCase();return 0<=m.indexOf(l)?null:t(u.encoding)}const f={ibm866:"cp866",big5:"cp950"};function t(c){const d=c.replace(/[^a-zA-Z0-9]/g,"").toLowerCase();return f[d]||d}function s(c){let d="";for(let v=0;v<c.length;v++)d+=String.fromCharCode(c[v]);return d}function o(c){switch(c){case"shiftjis":return"shift-jis";case"utf16le":return"utf-16le";case"utf16be":return"utf-16be";case"big5hkscs":return"big5-hkscs";case"eucjp":return"euc-jp";case"euckr":return"euc-kr";case"koi8r":return"koi8-r";case"koi8u":return"koi8-u";case"macroman":return"x-mac-roman";case"utf8bom":return"utf8";default:{const d=c.match(/windows(\d+)/);return d?"windows-"+d[1]:c}}}e.$lD=o;function n({buffer:c,bytesRead:d},v){let k=a(c,d),u=!1;if(k!==e.$_C&&k!==e.$aD&&c){let l=!0,w=!0,L=!1;for(let N=0;N<d&&N<g;N++){const j=N%2===1,T=c.readUInt8(N)===0;if(T&&(L=!0),l&&(j&&!T||!j&&T)&&(l=!1),w&&(j&&T||!j&&!T)&&(w=!1),T&&!l&&!w)break}L&&(l?k=e.$aD:w?k=e.$_C:u=!0)}return v&&!u&&!k&&c?p(c.slice(0,d)).then(l=>({seemsBinary:!1,encoding:l})):{seemsBinary:u,encoding:k}}e.$mD=n,e.$nD={utf8:{labelLong:"UTF-8",labelShort:"UTF-8",order:1,alias:"utf8bom"},utf8bom:{labelLong:"UTF-8 with BOM",labelShort:"UTF-8 with BOM",encodeOnly:!0,order:2,alias:"utf8"},utf16le:{labelLong:"UTF-16 LE",labelShort:"UTF-16 LE",order:3},utf16be:{labelLong:"UTF-16 BE",labelShort:"UTF-16 BE",order:4},windows1252:{labelLong:"Western (Windows 1252)",labelShort:"Windows 1252",order:5},iso88591:{labelLong:"Western (ISO 8859-1)",labelShort:"ISO 8859-1",order:6},iso88593:{labelLong:"Western (ISO 8859-3)",labelShort:"ISO 8859-3",order:7},iso885915:{labelLong:"Western (ISO 8859-15)",labelShort:"ISO 8859-15",order:8},macroman:{labelLong:"Western (Mac Roman)",labelShort:"Mac Roman",order:9},cp437:{labelLong:"DOS (CP 437)",labelShort:"CP437",order:10},windows1256:{labelLong:"Arabic (Windows 1256)",labelShort:"Windows 1256",order:11},iso88596:{labelLong:"Arabic (ISO 8859-6)",labelShort:"ISO 8859-6",order:12},windows1257:{labelLong:"Baltic (Windows 1257)",labelShort:"Windows 1257",order:13},iso88594:{labelLong:"Baltic (ISO 8859-4)",labelShort:"ISO 8859-4",order:14},iso885914:{labelLong:"Celtic (ISO 8859-14)",labelShort:"ISO 8859-14",order:15},windows1250:{labelLong:"Central European (Windows 1250)",labelShort:"Windows 1250",order:16},iso88592:{labelLong:"Central European (ISO 8859-2)",labelShort:"ISO 8859-2",order:17},cp852:{labelLong:"Central European (CP 852)",labelShort:"CP 852",order:18},windows1251:{labelLong:"Cyrillic (Windows 1251)",labelShort:"Windows 1251",order:19},cp866:{labelLong:"Cyrillic (CP 866)",labelShort:"CP 866",order:20},iso88595:{labelLong:"Cyrillic (ISO 8859-5)",labelShort:"ISO 8859-5",order:21},koi8r:{labelLong:"Cyrillic (KOI8-R)",labelShort:"KOI8-R",order:22},koi8u:{labelLong:"Cyrillic (KOI8-U)",labelShort:"KOI8-U",order:23},iso885913:{labelLong:"Estonian (ISO 8859-13)",labelShort:"ISO 8859-13",order:24},windows1253:{labelLong:"Greek (Windows 1253)",labelShort:"Windows 1253",order:25},iso88597:{labelLong:"Greek (ISO 8859-7)",labelShort:"ISO 8859-7",order:26},windows1255:{labelLong:"Hebrew (Windows 1255)",labelShort:"Windows 1255",order:27},iso88598:{labelLong:"Hebrew (ISO 8859-8)",labelShort:"ISO 8859-8",order:28},iso885910:{labelLong:"Nordic (ISO 8859-10)",labelShort:"ISO 8859-10",order:29},iso885916:{labelLong:"Romanian (ISO 8859-16)",labelShort:"ISO 8859-16",order:30},windows1254:{labelLong:"Turkish (Windows 1254)",labelShort:"Windows 1254",order:31},iso88599:{labelLong:"Turkish (ISO 8859-9)",labelShort:"ISO 8859-9",order:32},windows1258:{labelLong:"Vietnamese (Windows 1258)",labelShort:"Windows 1258",order:33},gbk:{labelLong:"Simplified Chinese (GBK)",labelShort:"GBK",order:34},gb18030:{labelLong:"Simplified Chinese (GB18030)",labelShort:"GB18030",order:35},cp950:{labelLong:"Traditional Chinese (Big5)",labelShort:"Big5",order:36},big5hkscs:{labelLong:"Traditional Chinese (Big5-HKSCS)",labelShort:"Big5-HKSCS",order:37},shiftjis:{labelLong:"Japanese (Shift JIS)",labelShort:"Shift JIS",order:38},eucjp:{labelLong:"Japanese (EUC-JP)",labelShort:"EUC-JP",order:39},euckr:{labelLong:"Korean (EUC-KR)",labelShort:"EUC-KR",order:40},windows874:{labelLong:"Thai (Windows 874)",labelShort:"Windows 874",order:41},iso885911:{labelLong:"Latin/Thai (ISO 8859-11)",labelShort:"ISO 8859-11",order:42},koi8ru:{labelLong:"Cyrillic (KOI8-RU)",labelShort:"KOI8-RU",order:43},koi8t:{labelLong:"Tajik (KOI8-T)",labelShort:"KOI8-T",order:44},gb2312:{labelLong:"Simplified Chinese (GB 2312)",labelShort:"GB 2312",order:45},cp865:{labelLong:"Nordic DOS (CP 865)",labelShort:"CP 865",order:46},cp850:{labelLong:"Western European DOS (CP 850)",labelShort:"CP 850",order:47}}}),define(De[152],Ce([1,0,351,29,151]),function($e,e,D,M,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6cc=void 0;class R extends h.$Vbc{constructor(g,E,$=M,P="searchProcess"){super(g,E,{readdir:I=>$.Promises.readdir(I.fsPath),toCanonicalName:I=>(0,D.$lD)(I)},P)}}e.$6cc=R}),define(De[153],Ce([1,0,46,367,350,19,69,35,14,15,2,36,92,368,348,115]),function($e,e,D,M,h,R,A,g,E,$,P,I,b,S,C,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5cc=e.$4cc=e.$3cc=e.$2cc=e.$1cc=e.$Zcc=e.$Ycc=void 0;const r=C.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");class i{constructor(w){this.a=w}provideTextSearchResults(w,L,N,j){return this.a.appendLine(`provideTextSearchResults ${w.pattern}, ${JSON.stringify({...L,folder:L.folder.toString()})}`),new Promise((T,O)=>{j.onCancellationRequested(()=>q());const B=s(w,L),F=L.folder.fsPath,J=B.map(Q=>Q.match(/^-/)?Q:`'${Q}'`).join(" ");this.a.appendLine(`${r} ${J}
 - cwd: ${F}`);let K=D.spawn(r,B,{cwd:F});K.on("error",Q=>{console.error(Q),this.a.appendLine("Error: "+(Q&&Q.message)),O((0,I.$qI)(new I.$oI(Q&&Q.message,I.SearchErrorCode.rgProcessError)))});let me=!1;const re=new p(L.maxResults,F,L.previewOptions);re.on("result",Q=>{me=!0,pe="",N.report(Q)});let x=!1;const q=()=>{x=!0,K?.kill(),re?.cancel()};let ee=!1;re.on("hitLimit",()=>{ee=!0,q()});let pe="";K.stdout.on("data",Q=>{re.handleData(Q),me||(pe+=Q)});let ce=!1;K.stdout.once("data",()=>ce=!0);let _="";K.stderr.on("data",Q=>{const z=Q.toString();this.a.appendLine(z),_.length+z.length<1e6&&(_+=z)}),K.on("close",()=>{if(this.a.appendLine(ce?"Got data from stdout":"No data from stdout"),this.a.appendLine(me?"Got result from parser":"No result from parser"),pe&&this.a.appendLine(`Got data without result: ${pe}`),this.a.appendLine(""),x)T({limitHit:ee});else{re.flush(),K=null;let Q;_&&!ce&&(Q=a(_))?O((0,I.$qI)(new I.$oI(Q.message,Q.code))):T({limitHit:ee})}})})}}e.$Ycc=i;function a(l){const w=l.split(`
`),L=w[0].trim();if(w.some(j=>j.startsWith("regex parse error")))return new I.$oI(m(w),I.SearchErrorCode.regexParseError);const N=L.match(/grep config error: unknown encoding: (.*)/);if(N)return new I.$oI(`Unknown encoding: ${N[1]}`,I.SearchErrorCode.unknownEncoding);if(L.startsWith("error parsing glob"))return new I.$oI(L.charAt(0).toUpperCase()+L.substr(1),I.SearchErrorCode.globParseError);if(L.startsWith("the literal"))return new I.$oI(L.charAt(0).toUpperCase()+L.substr(1),I.SearchErrorCode.invalidLiteral);if(L.startsWith("PCRE2: error compiling pattern"))return new I.$oI(L,I.SearchErrorCode.regexParseError)}function m(l){const w=["Regex parse error"],L=l.filter(N=>N.startsWith("PCRE2:"));if(L.length>=1){const N=L[0].replace("PCRE2:","");if(N.indexOf(":")!==-1&&N.split(":").length>=2){const j=N.split(":")[1];w.push(":"+j)}}return w.join("")}class p extends M.EventEmitter{constructor(w,L,N){super(),this.g=w,this.h=L,this.j=N,this.a="",this.b=!1,this.c=!1,this.f=0,this.d=new h.StringDecoder}cancel(){this.b=!0}flush(){this.k(this.d.end())}on(w,L){return super.on(w,L),this}handleData(w){if(this.b)return;const L=typeof w=="string"?w:this.d.write(w);this.k(L)}k(w){let L=w.indexOf(`
`);const N=this.a+w;if(L>=0)L+=this.a.length;else{this.a=N;return}let j=0;for(;L>=0;)this.m(N.substring(j,L).trim()),j=L+1,L=N.indexOf(`
`,j);this.a=N.substring(j)}m(w){if(this.b||!w)return;let L;try{L=JSON.parse(w)}catch{throw new Error(`malformed line from rg: ${w}`)}if(L.type==="match"){const N=f(L.data.path),j=P.URI.file(E.$$c(this.h,N)),T=this.n(L.data,j);this.p(T),this.c&&(this.cancel(),this.emit("hitLimit"))}else if(L.type==="context"){const N=f(L.data.path),j=P.URI.file(E.$$c(this.h,N));this.o(L.data,j).forEach(O=>this.p(O))}}n(w,L){const N=w.line_number-1,j=f(w.lines),T=Buffer.from(j);let O=0,B=0,F=N;w.submatches.length===0&&w.submatches.push(j.length?{start:0,end:1,match:{text:j[0]}}:{start:0,end:0,match:{text:""}});const J=(0,R.$Af)(w.submatches.map((K,me)=>{if(this.c)return null;this.f++,this.f>=this.g&&(this.c=!0);const re=f(K.match),x=T.slice(O,K.start).toString(),q=t(x),ee=q.numLines>0?q.lastLineLength:q.lastLineLength+B,pe=t(re),ce=q.numLines+F,_=pe.numLines+ce,Q=pe.numLines>0?pe.lastLineLength:pe.lastLineLength+ee;return O=K.end,B=Q,F=_,new b.$$H(ce,ee,_,Q)}));return(0,y.$Rcc)(L,j,J,this.j)}o(w,L){const N=f(w.lines),j=w.line_number;return N.replace(/\r?\n$/,"").split(`
`).map((T,O)=>({text:T,uri:L,lineNumber:j+O}))}p(w){this.emit("result",w)}}e.$Zcc=p;function f(l){return l.bytes?Buffer.from(l.bytes,"base64").toString():l.text}function t(l){const w=/\n/g;let L=0,N=-1,j;for(;j=w.exec(l);)L++,N=j.index;const T=N>=0?l.length-N-1:l.length;return{numLines:L,lastLineLength:T}}function s(l,w){const L=["--hidden","--no-require-git"];L.push(l.isCaseSensitive?"--case-sensitive":"--ignore-case");const{doubleStarIncludes:N,otherIncludes:j}=(0,A.$I)(w.includes,O=>O.startsWith("**")?"doubleStarIncludes":"otherIncludes");if(j&&j.length){const O=new Set;j.forEach(B=>{O.add(B)}),L.push("-g","!*"),O.forEach(B=>{o(B).map(y.$Qcc).forEach(F=>{L.push("-g",F)})})}N&&N.length&&N.forEach(O=>{L.push("-g",O)}),w.excludes.map(y.$Qcc).forEach(O=>L.push("-g",`!${O}`)),w.maxFileSize&&L.push("--max-filesize",w.maxFileSize+""),w.useIgnoreFiles?w.useParentIgnoreFiles||L.push("--no-ignore-parent"):L.push("--no-ignore"),w.followSymlinks&&L.push("--follow"),w.encoding&&w.encoding!=="utf8"&&L.push("--encoding",w.encoding),l.pattern==="--"&&(l.isRegExp=!0,l.pattern="\\-\\-"),l.isMultiline&&!l.isRegExp&&(l.pattern=(0,$.$sd)(l.pattern),l.isRegExp=!0),w.usePCRE2&&L.push("--pcre2"),L.push("--crlf"),l.isRegExp&&(l.pattern=n(l.pattern),L.push("--engine","auto"));let T;if(l.isWordMatch){const B=(0,$.$Ad)(l.pattern,!!l.isRegExp,{wholeWord:l.isWordMatch}).source.replace(/\\\//g,"/");L.push("--regexp",B)}else if(l.isRegExp){let O=d(l.pattern);O=v(O),L.push("--regexp",O)}else T=l.pattern,L.push("--fixed-strings");return L.push("--no-config"),w.useGlobalIgnoreFiles||L.push("--no-ignore-global"),L.push("--json"),l.isMultiline&&L.push("--multiline"),w.beforeContext&&L.push("--before-context",w.beforeContext+""),w.afterContext&&L.push("--after-context",w.afterContext+""),L.push("--"),T&&L.push(T),L.push("."),L}e.$1cc=s;function o(l){return u(l).flatMap(L=>{const N=(0,g.$nj)(L,"/");return N.map((j,T)=>N.slice(0,T+1).join("/"))})}function n(l){const w=/((?:[^\\]|^)(?:\\\\)*)\\u([a-z0-9]{4})/gi;for(;l.match(w);)l=l.replace(w,"$1\\x{$2}");const L=/((?:[^\\]|^)(?:\\\\)*)\\u\{([a-z0-9]{4})\}/gi;for(;l.match(L);)l=l.replace(L,"$1\\x{$2}");return l}e.$2cc=n;const c=l=>l.type==="Assertion"&&l.kind==="lookbehind";function d(l){let w;try{w=new S.RegExpParser().parsePattern(l)}catch{return l}let L="",N=0;const j=(B,F,J)=>{L+=l.slice(N,B)+J,N=F},T=[];return new S.RegExpVisitor({onCharacterEnter(B){if(B.raw!=="\\n")return;const F=T[0];if(!F)j(B.start,B.end,"\\r?\\n");else if(!T.some(c))if(F.type==="CharacterClass")if(F.negate){const J=l.slice(F.start+2,B.start)+l.slice(B.end,F.end-1);F.parent?.type==="Quantifier"?j(F.start,F.end,J?`[^${J}]`:"."):j(F.start,F.end,"(?!\\r?\\n"+(J?`|[${J}]`:"")+")")}else{const J=l.slice(F.start+1,B.start)+l.slice(B.end,F.end-1);j(F.start,F.end,J===""?"\\r?\\n":`(?:[${J}]|\\r?\\n)`)}else F.type==="Quantifier"&&j(B.start,B.end,"(?:\\r?\\n)")},onQuantifierEnter(B){T.unshift(B)},onQuantifierLeave(){T.shift()},onCharacterClassRangeEnter(B){T.unshift(B)},onCharacterClassRangeLeave(){T.shift()},onCharacterClassEnter(B){T.unshift(B)},onCharacterClassLeave(){T.shift()},onAssertionEnter(B){c(B)&&T.push(B)},onAssertionLeave(B){T[0]===B&&T.shift()}}).visit(w),L+=l.slice(N),L}e.$3cc=d;function v(l){return l.replace(/\n/g,"\\r?\\n")}e.$4cc=v;function k(l){let w=!1,L=!1,N="",j="";for(let T=0;T<l.length;T++){const O=l[T];switch(O){case"\\":L?(w?j+="\\"+O:N+="\\"+O,L=!1):L=!0;break;case"{":if(L)w?j+=O:N+=O,L=!1;else{if(w)return{strInBraces:N+"{"+j+"{"+l.substring(T+1)};w=!0}break;case"}":if(L)w?j+=O:N+=O,L=!1;else{if(w)return{fixedStart:N,strInBraces:j,fixedEnd:l.substring(T+1)};N+=O}break;default:w?j+=(L?"\\":"")+O:N+=(L?"\\":"")+O,L=!1;break}}return{strInBraces:N+(w?"{"+j:"")}}function u(l){const{fixedStart:w,strInBraces:L,fixedEnd:N}=k(l);if(w===void 0||N===void 0)return[L];let j=(0,g.$nj)(L,",");j.length||(j=[""]);const T=u(N);return j.flatMap(O=>{const B=w+O;return T.map(F=>B+F)})}e.$5cc=u}),define(De[352],Ce([1,0,22,153,83,16]),function($e,e,D,M,h,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9cc=void 0;class A{constructor($){this.b=$,this.a=new Set,process.once("exit",()=>this.d())}provideTextSearchResults($,P,I,b){const S=new M.$Ycc(this.b);if(P.folder.scheme===R.Schemas.vscodeUserData){const C={...P,folder:P.folder.with({scheme:R.Schemas.file})},y=new h.$1u(r=>I.report({...r,uri:r.uri.with({scheme:P.folder.scheme})}));return this.c(b,r=>S.provideTextSearchResults($,C,y,r))}else return this.c(b,C=>S.provideTextSearchResults($,P,I,C))}async c($,P){const I=g($);this.a.add(I);const b=await P(I.token);return this.a.delete(I),b}d(){this.a.forEach($=>$.cancel())}}e.$9cc=A;function g(E){const $=new D.$rc;return E.onCancellationRequested(()=>$.cancel()),$}}),define(De[353],Ce([1,0,29,153,152]),function($e,e,D,M,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7cc=void 0;class R{constructor(E){this.a=E}search(E,$,P){if((!this.a.folderQueries||!this.a.folderQueries.length)&&(!this.a.extraFileResources||!this.a.extraFileResources.length))return Promise.resolve({type:"success",limitHit:!1,stats:{type:"searchProcess"}});const I={appendLine(S){P({message:S})}},b=new h.$6cc(this.a,new M.$Ycc(I),D);return new Promise((S,C)=>b.search(y=>{$(y.map(A))},E).then(y=>S({limitHit:y.limitHit,type:"success",stats:y.stats}),C))}}e.$7cc=R;function A(g){return{path:g.resource&&g.resource.fsPath,results:g.results,numMatches:(g.results||[]).reduce((E,$)=>{if($.ranges){const P=$;return E+(Array.isArray(P.ranges)?P.ranges.length:1)}else return E+1},0)}}}),define(De[354],Ce([1,0,19,13,8,4,126,14,37,2,30,36,349,353]),function($e,e,D,M,h,R,A,g,E,$,P,I,b,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8cc=void 0;class C{static{this.a=512}constructor(p="searchProcess"){this.d=p,this.b=Object.create(null)}fileSearch(p){let f;const t=i(p),s=new R.$hc({onDidAddFirstListener:()=>{f=(0,M.$sg)(o=>this.doFileSearchWithEngine(b.$Xcc,t,n=>s.fire(n),o)),f.then(o=>s.fire(o),o=>s.fire({type:"error",error:{message:o.message,stack:o.stack}}))},onDidRemoveLastListener:()=>{f.cancel()}});return s.event}textSearch(p){let f;const t=i(p),s=new R.$hc({onDidAddFirstListener:()=>{f=(0,M.$sg)(o=>this.f(t,n=>s.fire(n),o)),f.then(o=>s.fire(o),o=>s.fire({type:"error",error:{message:o.message,stack:o.stack}}))},onDidRemoveLastListener:()=>{f.cancel()}});return s.event}f(p,f,t){return p.maxFileSize=this.g().maxFileSize,new S.$7cc(p).search(t,f,f)}g(){return{maxFileSize:process.arch==="ia32"?300*P.$yk.MB:16*P.$yk.GB}}doFileSearch(p,f,t){return this.doFileSearchWithEngine(b.$Xcc,p,f,t)}doFileSearchWithEngine(p,f,t,s,o=C.a){let n=0;const c=v=>{Array.isArray(v)?(n+=v.length,t(v.map(k=>this.h(k)))):v.relativePath?(n++,t(this.h(v))):t(v)};if(f.sortByScore){let v=this.l(f,c,s);if(!v){const k=f.maxResults?Object.assign({},f,{maxResults:null}):f,u=new p(k);v=this.j(u,f,t,c,s)}return new Promise((k,u)=>{v.then(([l,w])=>{const L=w.map(N=>this.h(N));this.o(L,t,o),k(l)},u)})}const d=new p(f);return this.r(d,c,o,s).then(v=>({limitHit:v.limitHit,type:"success",stats:{detailStats:v.stats,type:this.d,fromCache:!1,resultCount:n,sortingTime:void 0}}))}h(p){return{path:p.base?(0,g.$$c)(p.base,p.relativePath):p.relativePath}}j(p,f,t,s,o){const n=new R.$hc;let c=(0,M.$sg)(v=>{let k=[];const u=l=>{Array.isArray(l)?k=l:(s(l),n.fire(l))};return this.r(p,u,-1,v).then(l=>[l,k])}),d;if(f.cacheKey){d=this.k(f.cacheKey);const v={promise:c,event:n.event,resolved:!1};d.resultsToSearchCache[f.filePattern||""]=v,c.then(()=>{v.resolved=!0},k=>{delete d.resultsToSearchCache[f.filePattern||""]}),c=this.s(c)}return c.then(([v,k])=>{const u=d?d.scorerCache:Object.create(null),l=(typeof f.maxResults!="number"||f.maxResults>0)&&E.$dc.create(!1);return this.n(f,k,u,o).then(w=>{const L=l?l.elapsed():-1;return[{type:"success",stats:{detailStats:v.stats,sortingTime:L,fromCache:!1,type:this.d,workspaceFolderCount:f.folderQueries.length,resultCount:w.length},messages:v.messages,limitHit:v.limitHit||typeof f.maxResults=="number"&&k.length>f.maxResults},w]})})}k(p){const f=this.b[p];return f||(this.b[p]=new y)}l(p,f,t){const s=p.cacheKey&&this.b[p.cacheKey];if(!s)return;const o=this.q(s,p.filePattern||"",f,t);if(o)return o.then(([n,c,d])=>{const v=E.$dc.create(!1);return this.n(p,c,s.scorerCache,t).then(k=>{const u=v.elapsed(),l={fromCache:!0,detailStats:d,type:this.d,resultCount:c.length,sortingTime:u};return[{type:"success",limitHit:n.limitHit||typeof p.maxResults=="number"&&c.length>p.maxResults,stats:l},k]})})}n(p,f,t,s){const o=(0,A.$lq)(p.filePattern||""),n=(d,v)=>(0,A.$kq)(d,v,o,!0,r,t),c=typeof p.maxResults=="number"?p.maxResults:Number.MAX_VALUE;return D.$zf(f,n,c,1e4,s)}o(p,f,t){if(t&&t>0)for(let s=0;s<p.length;s+=t)f(p.slice(s,s+t));else f(p)}q(p,f,t,s){const o=E.$dc.create(!1),n=f.indexOf(g.sep)>=0;let c;for(const u in p.resultsToSearchCache)if(f.startsWith(u)){if(n&&u.indexOf(g.sep)<0&&u!=="")continue;const l=p.resultsToSearchCache[u];c={promise:this.s(l.promise),event:l.event,resolved:l.resolved};break}if(!c)return null;const d=o.elapsed(),v=E.$dc.create(!1),k=c.event(t);return s&&s.onCancellationRequested(()=>{k.dispose()}),c.promise.then(([u,l])=>{if(s&&s.isCancellationRequested)throw(0,h.$4)();const w=[],L=(0,A.$lq)(f).normalizedLowercase;for(const N of l)(0,I.$uI)(N,L)&&w.push(N);return[u,w,{cacheWasResolved:c.resolved,cacheLookupTime:d,cacheFilterTime:v.elapsed(),cacheEntryCount:l.length}]})}r(p,f,t,s){return new Promise((o,n)=>{let c=[];s?.onCancellationRequested(()=>p.cancel()),p.search(d=>{d&&(t?(c.push(d),t>0&&c.length>=t&&(f(c),c=[])):f(d))},d=>{f(d)},(d,v)=>{c.length&&f(c),d?n(d):o(v)})})}clearCache(p){return delete this.b[p],Promise.resolve(void 0)}s(p){return new class{get[Symbol.toStringTag](){return this.toString()}cancel(){}then(f,t){return p.then(f,t)}catch(f){return this.then(void 0,f)}finally(f){return p.finally(f)}}}}e.$8cc=C;class y{constructor(){this.resultsToSearchCache=Object.create(null),this.scorerCache=Object.create(null)}}const r=new class{getItemLabel(m){return(0,g.$cd)(m.relativePath)}getItemDescription(m){return(0,g.$bd)(m.relativePath)}getItemPath(m){return m.relativePath}};function i(m){return{...m,folderQueries:m.folderQueries&&m.folderQueries.map(a),extraFileResources:m.extraFileResources&&m.extraFileResources.map(p=>$.URI.revive(p))}}function a(m){return{...m,folder:$.URI.revive(m.folder)}}}),define(De[355],Ce([1,0,3,16,2,29,17,26,20,95,62,36,354,352,115,152]),function($e,e,D,M,h,R,A,g,E,$,P,I,b,S,C,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0cc=void 0;let r=class extends $.$1bc{constructor(a,m,p,f){super(a,p,f),this.s=R,this.t=-1,this.v=null,this.w=!1,this.x=new D.$lb;const t=new C.$Scc("RipgrepSearchUD",this.n);this.x.add(this.registerTextSearchProvider(M.Schemas.vscodeUserData,new S.$9cc(t))),m.remote.isRemote&&m.remote.authority&&this.y()}dispose(){this.x.dispose()}$enableExtensionHostSearch(){this.y()}y(){if(this.w)return;this.w=!0;const a=new C.$Scc("RipgrepSearchEH",this.n);this.x.add(this.registerTextSearchProvider(M.Schemas.file,new S.$9cc(a))),this.x.add(this.z(M.Schemas.file,new b.$8cc("fileSearchProvider")))}z(a,m){const p=this.d++;return this.v=m,this.t=p,this.c.$registerFileSearchProvider(p,this.o(a)),(0,D.$kb)(()=>{this.v=null,this.c.$unregisterProvider(p)})}$provideFileSearchResults(a,m,p,f){const t=(0,$.$2bc)(p);return a===this.t?this.A(a,m,t,f):super.$provideFileSearchResults(a,m,p,f)}A(a,m,p,f){const t=s=>{if((0,I.$tI)(s)&&(s=[s]),Array.isArray(s)){this.c.$handleFileMatch(a,m,s.map(o=>h.URI.file(o.path)));return}s.message&&this.n.debug("ExtHostSearch",s.message)};if(!this.v)throw new Error("No internal file search handler");return this.v.doFileSearch(p,t,f)}$clearCache(a){return this.v?.clearCache(a),super.$clearCache(a)}q(a,m){return new y.$6cc(a,m,void 0,"textSearchProvider")}};e.$0cc=r,e.$0cc=r=Ke([Ve(0,E.$UL),Ve(1,g.$$L),Ve(2,P.$Gac),Ve(3,A.$3i)],r)}),define(De[116],Ce([1,0,369,57,59,370,21,8,4,3,14,9,31,79,80]),function($e,e,D,M,h,R,A,g,E,$,P,I,b,S,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vh=e.$uh=e.$th=e.$sh=e.$rh=e.$qh=e.$ph=e.$oh=void 0;class y{traceSocketEvent(l,w){C.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,l,w)}constructor(l,w=""){this.f=!0,this.debugLabel=w,this.socket=l,this.traceSocketEvent("created",{type:"NodeSocket"}),this.a=L=>{if(this.traceSocketEvent("error",{code:L?.code,message:L?.message}),L){if(L.code==="EPIPE")return;(0,g.$Y)(L)}},this.socket.on("error",this.a),this.b=L=>{this.traceSocketEvent("close",{hadError:L}),this.f=!1},this.socket.on("close",this.b),this.d=()=>{this.traceSocketEvent("nodeEndReceived"),this.f=!1},this.socket.on("end",this.d)}dispose(){this.socket.off("error",this.a),this.socket.off("close",this.b),this.socket.off("end",this.d),this.socket.destroy()}onData(l){const w=L=>{this.traceSocketEvent("read",L),l(A.$Hc.wrap(L))};return this.socket.on("data",w),{dispose:()=>this.socket.off("data",w)}}onClose(l){const w=L=>{l({type:0,hadError:L,error:void 0})};return this.socket.on("close",w),{dispose:()=>this.socket.off("close",w)}}onEnd(l){const w=()=>{l()};return this.socket.on("end",w),{dispose:()=>this.socket.off("end",w)}}write(l){if(!(this.socket.destroyed||!this.f))try{this.traceSocketEvent("write",l),this.socket.write(l.buffer,w=>{if(w){if(w.code==="EPIPE")return;(0,g.$Y)(w)}})}catch(w){if(w.code==="EPIPE")return;(0,g.$Y)(w)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((l,w)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),l();return}const L=()=>{this.socket.off("close",L),this.socket.off("end",L),this.socket.off("error",L),this.socket.off("timeout",L),this.socket.off("drain",L),this.traceSocketEvent("nodeDrainEnd"),l()};this.socket.on("close",L),this.socket.on("end",L),this.socket.on("error",L),this.socket.on("timeout",L),this.socket.on("drain",L)})}}e.$oh=y;var r;(function(u){u[u.MinHeaderByteSize=2]="MinHeaderByteSize",u[u.MaxWebSocketMessageLength=262144]="MaxWebSocketMessageLength"})(r||(r={}));var i;(function(u){u[u.PeekHeader=1]="PeekHeader",u[u.ReadHeader=2]="ReadHeader",u[u.ReadBody=3]="ReadBody",u[u.Fin=4]="Fin"})(i||(i={}));class a extends $.$mb{get permessageDeflate(){return this.a.permessageDeflate}get recordedInflateBytes(){return this.a.recordedInflateBytes}traceSocketEvent(l,w){this.socket.traceSocketEvent(l,w)}constructor(l,w,L,N){super(),this.f=this.B(new E.$hc),this.g=this.B(new E.$hc),this.h=!1,this.j={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0},this.socket=l,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:w,inflateBytesLength:L?.byteLength||0,recordInflateBytes:N}),this.a=this.B(new m(this,w,L,N,this.f,(j,T)=>this.k(j,T))),this.B(this.a.onError(j=>{console.error(j),(0,g.$Y)(j),this.g.fire({type:0,hadError:!0,error:j})})),this.b=new C.$jh,this.B(this.socket.onData(j=>this.l(j))),this.B(this.socket.onClose(async j=>{this.a.isProcessingReadQueue()&&await E.Event.toPromise(this.a.onDidFinishProcessingReadQueue),this.g.fire(j)}))}dispose(){this.a.isProcessingWriteQueue()?this.B(this.a.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(l){return this.f.event(l)}onClose(l){return this.g.event(l)}onEnd(l){return this.socket.onEnd(l)}write(l){let w=0;for(;w<l.byteLength;)this.a.writeMessage(l.slice(w,Math.min(w+262144,l.byteLength))),w+=262144}k(l,w){if(this.h)return;this.traceSocketEvent("webSocketNodeSocketWrite",l);let L=2;l.byteLength<126?L+=0:l.byteLength<2**16?L+=2:L+=8;const N=A.$Hc.alloc(L);if(w?N.writeUInt8(194,0):N.writeUInt8(130,0),l.byteLength<126)N.writeUInt8(l.byteLength,1);else if(l.byteLength<2**16){N.writeUInt8(126,1);let j=1;N.writeUInt8(l.byteLength>>>8&255,++j),N.writeUInt8(l.byteLength>>>0&255,++j)}else{N.writeUInt8(127,1);let j=1;N.writeUInt8(0,++j),N.writeUInt8(0,++j),N.writeUInt8(0,++j),N.writeUInt8(0,++j),N.writeUInt8(l.byteLength>>>24&255,++j),N.writeUInt8(l.byteLength>>>16&255,++j),N.writeUInt8(l.byteLength>>>8&255,++j),N.writeUInt8(l.byteLength>>>0&255,++j)}this.socket.write(A.$Hc.concat([N,l]))}end(){this.h=!0,this.socket.end()}l(l){if(l.byteLength!==0){for(this.b.acceptChunk(l);this.b.byteLength>=this.j.readLen;)if(this.j.state===1){const w=this.b.peek(this.j.readLen),L=w.readUInt8(0),N=(L&128)>>>7,j=(L&64)>>>6,T=w.readUInt8(1),O=(T&128)>>>7,B=T&127;this.j.state=2,this.j.readLen=2+(O?4:0)+(B===126?2:0)+(B===127?8:0),this.j.fin=N,this.j.firstFrameOfMessage&&(this.j.compressed=!!j),this.j.firstFrameOfMessage=!!N,this.j.mask=0,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin})}else if(this.j.state===2){const w=this.b.read(this.j.readLen),L=w.readUInt8(1),N=(L&128)>>>7;let j=L&127,T=1;j===126?j=w.readUInt8(++T)*2**8+w.readUInt8(++T):j===127&&(j=w.readUInt8(++T)*0+w.readUInt8(++T)*0+w.readUInt8(++T)*0+w.readUInt8(++T)*0+w.readUInt8(++T)*2**24+w.readUInt8(++T)*2**16+w.readUInt8(++T)*2**8+w.readUInt8(++T));let O=0;N&&(O=w.readUInt8(++T)*2**24+w.readUInt8(++T)*2**16+w.readUInt8(++T)*2**8+w.readUInt8(++T)),this.j.state=3,this.j.readLen=j,this.j.mask=O,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,mask:this.j.mask})}else if(this.j.state===3){const w=this.b.read(this.j.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",w),t(w,this.j.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",w),this.j.state=1,this.j.readLen=2,this.j.mask=0,this.a.acceptFrame(w,this.j.compressed,!!this.j.fin)}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this.a.isProcessingWriteQueue()&&await E.Event.toPromise(this.a.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.$ph=a;class m extends $.$mb{get permessageDeflate(){return!!(this.b&&this.f)}get recordedInflateBytes(){return this.b?this.b.recordedInflateBytes:A.$Hc.alloc(0)}constructor(l,w,L,N,j,T){super(),this.l=l,this.m=j,this.n=T,this.a=this.B(new E.$hc),this.onError=this.a.event,this.g=[],this.h=[],this.j=this.B(new E.$hc),this.onDidFinishProcessingReadQueue=this.j.event,this.k=this.B(new E.$hc),this.onDidFinishProcessingWriteQueue=this.k.event,this.p=!1,this.t=!1,w?(this.b=this.B(new p(this.l,N,L,{windowBits:15})),this.f=this.B(new f(this.l,{windowBits:15})),this.B(this.b.onError(O=>this.a.fire(O))),this.B(this.f.onError(O=>this.a.fire(O)))):(this.b=null,this.f=null)}writeMessage(l){this.g.push(l),this.r()}async r(){if(!this.p){for(this.p=!0;this.g.length>0;){const l=this.g.shift();if(this.f){const w=await this.s(this.f,l);this.n(w,!0)}else this.n(l,!1)}this.p=!1,this.k.fire()}}isProcessingWriteQueue(){return this.p}s(l,w){return new Promise((L,N)=>{l.write(w),l.flush(j=>L(j))})}acceptFrame(l,w,L){this.h.push({data:l,isCompressed:w,isLastFrameOfMessage:L}),this.u()}async u(){if(!this.t){for(this.t=!0;this.h.length>0;){const l=this.h.shift();if(this.b&&l.isCompressed){const w=await this.w(this.b,l.data,l.isLastFrameOfMessage);this.m.fire(w)}else this.m.fire(l.data)}this.t=!1,this.j.fire()}}isProcessingReadQueue(){return this.t}w(l,w,L){return new Promise((N,j)=>{l.write(w),L&&l.write(A.$Hc.fromByteArray([0,0,255,255])),l.flush(T=>N(T))})}}class p extends $.$mb{get recordedInflateBytes(){return this.j?A.$Hc.concat(this.f):A.$Hc.alloc(0)}constructor(l,w,L,N){super(),this.h=l,this.j=w,this.a=this.B(new E.$hc),this.onError=this.a.event,this.f=[],this.g=[],this.b=(0,R.createInflateRaw)(N),this.b.on("error",j=>{this.h.traceSocketEvent("zlibInflateError",{message:j?.message,code:j?.code}),this.a.fire(j)}),this.b.on("data",j=>{this.h.traceSocketEvent("zlibInflateData",j),this.g.push(A.$Hc.wrap(j))}),L&&(this.h.traceSocketEvent("zlibInflateInitialWrite",L.buffer),this.b.write(L.buffer),this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateInitialFlushFired"),this.g.length=0}))}write(l){this.j&&this.f.push(l.clone()),this.h.traceSocketEvent("zlibInflateWrite",l),this.b.write(l.buffer)}flush(l){this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateFlushFired");const w=A.$Hc.concat(this.g);this.g.length=0,l(w)})}}class f extends $.$mb{constructor(l,w){super(),this.g=l,this.a=this.B(new E.$hc),this.onError=this.a.event,this.f=[],this.b=(0,R.createDeflateRaw)({windowBits:15}),this.b.on("error",L=>{this.g.traceSocketEvent("zlibDeflateError",{message:L?.message,code:L?.code}),this.a.fire(L)}),this.b.on("data",L=>{this.g.traceSocketEvent("zlibDeflateData",L),this.f.push(A.$Hc.wrap(L))})}write(l){this.g.traceSocketEvent("zlibDeflateWrite",l.buffer),this.b.write(l.buffer)}flush(l){this.b.flush(2,()=>{this.g.traceSocketEvent("zlibDeflateFlushFired");let w=A.$Hc.concat(this.f);this.f.length=0,w=w.slice(0,w.byteLength-4),l(w)})}}function t(u,l){if(l===0)return;const w=u.byteLength>>>2;for(let B=0;B<w;B++){const F=u.readUInt32BE(B*4);u.writeUInt32BE(F^l,B*4)}const L=w*4,N=u.byteLength-L,j=l>>>24&255,T=l>>>16&255,O=l>>>8&255;N>=1&&u.writeUInt8(u.readUInt8(L)^j,L),N>=2&&u.writeUInt8(u.readUInt8(L+1)^T,L+1),N>=3&&u.writeUInt8(u.readUInt8(L+2)^O,L+2)}e.$qh=process.env.XDG_RUNTIME_DIR;const s={[2]:107,[1]:103};function o(){const u=(0,b.$6e)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${u}-sock`;const l=process.platform!=="darwin"&&e.$qh?e.$qh:(0,h.tmpdir)(),w=(0,P.$$c)(l,`vscode-ipc-${u}.sock`);return c(w),w}e.$rh=o;function n(u,l,w){const L=(0,D.createHash)("md5").update(u).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${L}-${w}-${l}-sock`;const N=w.substr(0,4),j=l.substr(0,6),T=L.substr(0,8);let O;return process.platform!=="darwin"&&e.$qh&&!process.env.VSCODE_PORTABLE?O=(0,P.$$c)(e.$qh,`vscode-${T}-${N}-${j}.sock`):O=(0,P.$$c)(u,`${N}-${j}.sock`),c(O),O}e.$sh=n;function c(u){const l=s[I.$t];typeof l=="number"&&u.length>=l&&console.warn(`WARNING: IPC handle "${u}" is longer than ${l} chars, try a shorter --user-data-dir`)}class d extends S.$dh{static b(l){const w=E.Event.fromNodeEventEmitter(l,"connection");return E.Event.map(w,L=>({protocol:new C.$kh(new y(L,"ipc-server-connection")),onDidClientDisconnect:E.Event.once(E.Event.fromNodeEventEmitter(L,"close"))}))}constructor(l){super(d.b(l)),this.d=l}dispose(){super.dispose(),this.d&&(this.d.close(),this.d=null)}}e.$th=d;function v(u){return new Promise((l,w)=>{const L=(0,M.createServer)();L.on("error",w),L.listen(u,()=>{L.removeListener("error",w),l(new d(L))})})}e.$uh=v;function k(u,l){return new Promise((w,L)=>{const N=(0,M.createConnection)(u,()=>{N.removeListener("error",L),w(C.$lh.fromSocket(new y(N,`ipc-client${l}`),l))});N.once("error",L)})}e.$vh=k}),define(De[356],Ce([1,0,57,59,161,116,13,3,9,50,17,134,241,242,105,106,21]),function($e,e,D,M,h,R,A,g,E,$,P,I,b,S,C,y,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$I6b=e.$H6b=e.$G6b=e.$F6b=void 0;async function i(t,s,o,n,c){let d;for(let v=3;v&&(d?.dispose(),d=await new a(t,s,o,n,c).waitForReady(),!(c&&h.$9e[c]||!h.$9e[d.tunnelLocalPort]));v--);return d}class a extends g.$mb{constructor(s,o,n,c,d){super(),this.j=o,this.k=d,this.privacy=y.TunnelPrivacyId.Private,this.i=new Map,this.a=s,this.b=D.createServer(),this.c=new A.$Dg,this.f=()=>this.c.open(),this.b.on("listening",this.f),this.g=v=>this.l(v),this.b.on("connection",this.g),this.h=()=>{},this.b.on("error",this.h),this.tunnelRemotePort=c,this.tunnelRemoteHost=n}async dispose(){super.dispose(),this.b.removeListener("listening",this.f),this.b.removeListener("connection",this.g),this.b.removeListener("error",this.h),this.b.close(),Array.from(this.i.values()).forEach(o=>{o()})}async waitForReady(){const s=this.k??this.tunnelRemotePort,o=(0,y.$Zz)(this.j)?"0.0.0.0":"127.0.0.1";let n=await(0,h.$0e)(s,2,1e3,o),c=null;return this.b.listen(n,this.j),await this.c.wait(),c=this.b.address(),c||(n=0,this.b.listen(n,this.j),await this.c.wait(),c=this.b.address()),this.tunnelLocalPort=c.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${c.port}`,this}async l(s){s.pause();const o=(0,y.$Xz)(this.tunnelRemoteHost)||(0,y.$Zz)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,n=await(0,b.$Xk)(this.a,o,this.tunnelRemotePort),c=n.getSocket(),d=n.readEntireBuffer();n.dispose(),d.byteLength>0&&s.write(d.buffer),s.on("end",()=>{s.localAddress&&this.i.delete(s.localAddress),c.end()}),s.on("close",()=>c.end()),s.on("error",()=>{s.localAddress&&this.i.delete(s.localAddress),c instanceof R.$oh?c.socket.destroy():c.end()}),c instanceof R.$oh?this.n(s,c):this.m(s,c),s.localAddress&&this.i.set(s.localAddress,()=>{s.end(),c.end()})}m(s,o){o.onClose(()=>s.destroy()),o.onEnd(()=>s.end()),o.onData(n=>s.write(n.buffer)),s.on("data",n=>o.write(r.$Hc.wrap(n))),s.resume()}n(s,o){const n=o.socket;n.on("end",()=>s.end()),n.on("close",()=>s.end()),n.on("error",()=>{s.destroy()}),n.pipe(s),s.pipe(n)}}e.$F6b=a;let m=class extends y.$3z{constructor(s,o,n,c,d){super(o,d),this.u=s,this.v=n,this.w=c}isPortPrivileged(s){return(0,y.$1z)(s,this.l,E.OS,M.release())}s(s,o,n,c,d,v,k,u){const l=this.r(o,n);if(l)return++l.refcount,l.value;if((0,y.$Uz)(s))return this.t(s,o,n,d,v,k,u);{this.j.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${o}:${n} on local port ${d}.`);const w={commit:this.w.commit,quality:this.w.quality,addressProvider:s,remoteSocketFactoryService:this.u,signService:this.v,logService:this.j,ipcLogger:null},L=i(w,c,o,n,d);return this.j.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.p(o,n,L),L}}};e.$G6b=m,e.$G6b=m=Ke([Ve(0,S.$Rk),Ve(1,P.$3i),Ve(2,C.$Uk),Ve(3,I.$ij),Ve(4,$.$6h)],m);let p=class extends m{constructor(s,o,n,c,d){super(s,o,n,c,d)}};e.$H6b=p,e.$H6b=p=Ke([Ve(0,S.$Rk),Ve(1,P.$3i),Ve(2,C.$Uk),Ve(3,I.$ij),Ve(4,$.$6h)],p);let f=class extends g.$mb{constructor(s,o,n,c,d){super(),this.b=s,this.c=o,this.f=n,this.g=c,this.h=d,this.a=new Map}async openTunnel(s,o,n,c,d,v,k,u,l){if(this.c.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${n}:${c} on local port ${v}.`),!this.a.has(s)){const w=new p(this.b,this.c,this.g,this.f,this.h);this.B(w),this.a.set(s,w),w.onTunnelClosed(async()=>{(await w.tunnels).length===0&&(w.dispose(),this.a.delete(s))})}return this.a.get(s).openTunnel(o,n,c,d,v,k,u,l)}};e.$I6b=f,e.$I6b=f=Ke([Ve(0,S.$Rk),Ve(1,P.$3i),Ve(2,I.$ij),Ve(3,C.$Uk),Ve(4,$.$6h)],f)}),define(De[357],Ce([1,0,116,258,49,33,2,17,51]),function($e,e,D,M,h,R,A,g,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kM=e.$jM=void 0;class ${constructor(b,S,C){this.b=b,this.c=S,this.f=C,this.a=M.createServer((y,r)=>this.h(y,r)),this.g().catch(y=>(S.error(y),""))}get ipcHandlePath(){return this.f}async g(){try{this.a.listen(this.ipcHandlePath),this.a.on("error",b=>this.c.error(b))}catch{this.c.error("Could not start open from terminal server.")}return this.f}h(b,S){const C=(r,i)=>{S.writeHead(r,{"content-type":"application/json"}),S.end(JSON.stringify(i||null),a=>a&&this.c.error(a))},y=[];b.setEncoding("utf8"),b.on("data",r=>y.push(r)),b.on("end",async()=>{try{const r=JSON.parse(y.join(""));let i;switch(r.type){case"open":i=await this.i(r);break;case"openExternal":i=await this.j(r);break;case"status":i=await this.l(r);break;case"extensionManagement":i=await this.k(r);break;default:C(404,`Unknown message type: ${r.type}`);break}C(200,i)}catch(r){const i=r instanceof Error?r.message:JSON.stringify(r);C(500,i),this.c.error("Error while processing pipe request",r)}})}async i(b){const{fileURIs:S,folderURIs:C,forceNewWindow:y,diffMode:r,mergeMode:i,addMode:a,forceReuseWindow:m,gotoLineMode:p,waitMarkerFilePath:f,remoteAuthority:t}=b,s=[];if(Array.isArray(C))for(const d of C)try{s.push({folderUri:A.URI.parse(d)})}catch{}if(Array.isArray(S))for(const d of S)try{(0,E.$5h)(d)?s.push({workspaceUri:A.URI.parse(d)}):s.push({fileUri:A.URI.parse(d)})}catch{}const o=f?A.URI.file(f):void 0,c={forceNewWindow:y,diffMode:r,mergeMode:i,addMode:a,gotoLineMode:p,forceReuseWindow:m,preferNewWindow:!m&&!o&&!a,waitMarkerFileURI:o,remoteAuthority:t};this.b.executeCommand("_remoteCLI.windowOpen",s,c)}async j(b){for(const S of b.uris){const C=A.URI.parse(S),y=C.scheme==="file"?C:S;await this.b.executeCommand("_remoteCLI.openExternal",y)}}async k(b){const S=y=>y?.map(r=>/\.vsix$/i.test(r)?A.URI.parse(r):r),C={list:b.list,install:S(b.install),uninstall:S(b.uninstall),force:b.force};return await this.b.executeCommand("_remoteCLI.manageExtensions",C)}async l(b){return await this.b.executeCommand("_remoteCLI.getSystemStatus")}dispose(){this.a.close(),this.f&&process.platform!=="win32"&&h.existsSync(this.f)&&h.unlinkSync(this.f)}}e.$jM=$;let P=class extends ${constructor(b,S){super(b,S,(0,D.$rh)())}};e.$kM=P,e.$kM=P=Ke([Ve(0,R.$eM),Ve(1,g.$3i)],P)}),define(De[358],Ce([1,0,61,345,340,257,43,329,2,16,7,357,99,327,328]),function($e,e,D,M,h,R,A,g,E,$,P,I,b,S,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cdc=void 0;class y extends h.$Dcc{j(){const a=this,m=globalThis._VSCODE_NODE_MODULES.module,p=m._load;m._load=function(o,n,c){return o=t(o),a.a.has(o)?a.a.get(o).load(o,E.URI.file((0,b.$Up)(n.filename)),d=>p.apply(this,[d,n,c])):p.apply(this,arguments)};const f=m._resolveLookupPaths;m._resolveLookupPaths=(s,o)=>f.call(this,t(s),o);const t=s=>{for(const o of a.b){const n=o(s);if(n){s=n;break}}return s}}}class r extends A.$ebc{constructor(){super(...arguments),this.extensionRuntime=P.ExtensionRuntime.Node}async pb(){this.h.createInstance(S.$adc);const a=this.h.invokeFunction(M.$zcc);if(this.h.createInstance(g.$_cc),this.f.remote.isRemote&&this.f.remote.authority){const f=this.h.createInstance(I.$kM);process.env.VSCODE_IPC_HOOK_CLI=f.ipcHandlePath}this.h.createInstance(C.$bdc),await this.h.createInstance(y,a,{mine:this.F,all:this.G}).install(),D.mark("code/extHost/didInitAPI");const p=await this.k.getConfigProvider();await(0,R.$$cc)(this.j,p,this,this.l,this.u,this.f),D.mark("code/extHost/didInitProxyResolver")}qb(a){return a.main}async rb(a,m,p){if(m.scheme!==$.Schemas.file)throw new Error(`Cannot load URI: '${m}', must be of file-scheme`);let f=null;p.codeLoadingStart(),this.l.trace(`ExtensionService#loadCommonJSModule ${m.toString(!0)}`),this.l.flush();const t=a?.identifier.value;a&&await this.s.initializeLocalizedMessages(a);try{t&&D.mark(`code/extHost/willLoadExtensionCode/${t}`),f=$e.__$__nodeRequire(m.fsPath)}finally{t&&D.mark(`code/extHost/didLoadExtensionCode/${t}`),p.codeLoadingStop()}return f}async $setRemoteEnvironment(a){if(this.f.remote.isRemote)for(const m in a){const p=a[m];p===null?delete process.env[m]:process.env[m]=p}}}e.$cdc=r}),define(De[359],Ce([1,0,46,21,4,3,119,9,24,2,29,17,240,84,105,106,356,26,20,68]),function($e,e,D,M,h,R,A,g,E,$,P,I,b,S,C,y,r,i,a,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kdc=e.$jdc=e.$idc=e.$hdc=e.$gdc=e.$fdc=e.$edc=e.$ddc=void 0;function p(u){const l=u.trim().split(`
`),w=[];return l.forEach(N=>{const j=/\/proc\/(\d+)\/fd\/\d+ -> socket:\[(\d+)\]/.exec(N);j&&j.length>=3&&w.push({pid:parseInt(j[1],10),socket:parseInt(j[2],10)})}),w.reduce((N,j)=>(N[j.socket]=j,N),{})}e.$ddc=p;function f(...u){const l=[].concat(...u.map(s));return[...new Map(l.filter(w=>w.st==="0A").map(w=>{const L=w.local_address.split(":");return{socket:parseInt(w.inode,10),ip:t(L[0]),port:parseInt(L[1],16)}}).map(w=>[w.ip+":"+w.port,w])).values()]}e.$edc=f;function t(u){let l="";if(u.length===8)for(let w=u.length-2;w>=0;w-=2)l+=parseInt(u.substr(w,2),16),w!==0&&(l+=".");else for(let w=0;w<u.length;w+=8){const L=u.substring(w,w+8);let N="";for(let j=8;j>=2;j-=2)N+=L.substring(j-2,j),(j===6||j===2)&&(N=parseInt(N,16).toString(16),l+=`${N}`,N="",w+j!==u.length-6&&(l+=":"))}return l}e.$fdc=t;function s(u){const l=u.trim().split(`
`),w=l.shift().trim().split(/\s+/).filter(N=>N!=="rx_queue"&&N!=="tm->when");return l.map(N=>N.trim().split(/\s+/).reduce((j,T,O)=>(j[w[O]||O]=T,j),{}))}e.$gdc=s;function o(u){return!!u.match(/.*\.vscode-server-[a-zA-Z]+\/bin.*/)||u.indexOf("out/server-main.js")!==-1||u.indexOf("_productName=VSCode")!==-1}function n(u){const l=u.trim().split(`
`),w=[];return l.forEach(L=>{const N=/^\d+\s+\D+\s+root\s+(\d+)\s+(\d+).+\d+\:\d+\:\d+\s+(.+)$/.exec(L);N&&N.length>=4&&w.push({pid:parseInt(N[1],10),ppid:parseInt(N[2]),cmd:N[3]})}),w}e.$hdc=n;async function c(u,l,w){const L=w.reduce((j,T)=>(j[T.pid]=T,j),{}),N=[];return u.forEach(({socket:j,ip:T,port:O})=>{const B=l[j]?l[j].pid:void 0,F=B?L[B]?.cmd:void 0;B&&F&&!o(F)&&N.push({host:T,port:O,detail:F,pid:B})}),N}e.$idc=c;function d(u,l,w){const L=new Map,N=n(l);for(const j of u){const T=w.get(j.port);if(T){L.set(j.port,T);continue}const O=N.find(B=>B.cmd.includes(`${j.port}`));if(O){let B=O,F;do F=N.find(J=>J.ppid===B.pid),F&&(B=F);while(F);L.set(j.port,{host:j.ip,port:j.port,pid:B.pid,detail:B.cmd,ppid:B.ppid})}else L.set(j.port,{host:j.ip,port:j.port,ppid:Number.MAX_VALUE})}return L}e.$jdc=d;let v=class extends m.$4rb{constructor(l,w,L,N){super(l,w,L),this.w=w,this.y=N,this.s=void 0,this.u=new Map,this.v=!1,g.$k&&w.remote.isRemote&&w.remote.authority&&(this.a.$setRemoteTunnelService(process.pid),this.C())}async $registerCandidateFinder(l){if(l&&this.v)return;this.v=l;let w;this.s&&(w=this.s,await this.a.$onFoundNewCandidates(this.s));const L=new A.$Il;let N=0;for(;this.v;){const j=new Date().getTime(),T=(await this.D()).filter(F=>(0,y.$Xz)(F.host)||(0,y.$Zz)(F.host));this.n.trace(`ForwardedPorts: (ExtHostTunnelService) found candidate ports ${T.map(F=>F.port).join(", ")}`);const O=new Date().getTime()-j;this.n.trace(`ForwardedPorts: (ExtHostTunnelService) candidate port scan took ${O} ms.`),N++>3&&L.update(O),(!w||JSON.stringify(w)!==JSON.stringify(T))&&(w=T,await this.a.$onFoundNewCandidates(w));const B=this.z(L.value);this.n.trace(`ForwardedPorts: (ExtHostTunnelService) next candidate port scan in ${B} ms.`),await new Promise(F=>setTimeout(()=>F(),B))}}z(l){return Math.max(l*20,2e3)}async C(){this.s=await this.D(),this.n.trace(`ForwardedPorts: (ExtHostTunnelService) Initial candidates found: ${this.s.map(l=>l.port).join(", ")}`)}async D(){let l="",w="";try{l=await P.Promises.readFile("/proc/net/tcp","utf8"),w=await P.Promises.readFile("/proc/net/tcp6","utf8")}catch{}const L=f(l,w),N=await new Promise(me=>{(0,D.exec)("ls -l /proc/[0-9]*/fd/[0-9]* | grep socket:",(re,x,q)=>{me(x)})}),j=p(N),T=await P.Promises.readdir("/proc"),O=[];for(const me of T)try{const re=Number(me),x=E.$gg($.URI.file("/proc"),me);if((await P.Promises.stat(x.fsPath)).isDirectory()&&!isNaN(re)){const ee=await P.Promises.readlink(E.$gg(x,"cwd").fsPath),pe=await P.Promises.readFile(E.$gg(x,"cmdline").fsPath,"utf8");O.push({pid:re,cwd:ee,cmd:pe})}}catch{}const B=[],F=L.filter(me=>{const re=j[me.socket];return re||B.push(me),re}),J=c(F,j,O);let K;if(this.n.trace(`ForwardedPorts: (ExtHostTunnelService) number of possible root ports ${B.length}`),B.length>0){const me=await new Promise(re=>{(0,D.exec)("ps -F -A -l | grep root",(x,q,ee)=>{re(q)})});this.u=d(B,me,this.u),K=Array.from(this.u.values()),this.n.trace(`ForwardedPorts: (ExtHostTunnelService) heuristic ports ${K.map(re=>re.port).join(", ")}`)}return J.then(me=>K?me.concat(K):me)}r(l){return async w=>{const L=new r.$F6b({commit:this.w.commit,quality:this.w.quality,logService:this.n,ipcLogger:null,remoteSocketFactoryService:{_serviceBrand:void 0,async connect(j,T,O,B){const F=await l.makeConnection();return k.connect(F,T,O,B)},register(){throw new Error("not implemented")}},addressProvider:{getAddress(){return Promise.resolve({connectTo:new S.$Ik(0),connectionToken:l.connectionToken})}},signService:this.y},"localhost",w.remoteAddress.host||"localhost",w.remoteAddress.port,w.localAddressPort);await L.waitForReady();const N=new h.$hc;return{localAddress:L.localAddress,remoteAddress:{port:L.tunnelRemotePort,host:L.tunnelRemoteHost},onDidDispose:N.event,dispose:()=>{L.dispose(),N.fire(),N.dispose()}}}}};e.$kdc=v,e.$kdc=v=Ke([Ve(0,a.$UL),Ve(1,i.$$L),Ve(2,I.$3i),Ve(3,C.$Uk)],v);class k extends b.$dkb{static connect(l,w,L,N){const j=new R.$lb,T={onClose:j.add(new h.$hc),onData:j.add(new h.$hc),onEnd:j.add(new h.$hc)};j.add(l.onDidReceiveMessage(B=>T.onData.fire(M.$Hc.wrap(B)))),j.add(l.onDidEnd(()=>T.onEnd.fire())),j.add(l.onDidClose(B=>T.onClose.fire({type:0,error:B,hadError:!!B})));const O=new k(l,N,T);return O.B(j),(0,b.$ckb)(O,w,L,N,T)}constructor(l,w,L){super(w,L),this.k=l}write(l){this.k.send(l.buffer)}h(){this.k.end()}async drain(){await this.k.drain?.()}}}),define(De[360],Ce([1,0,102,332,343,342,355,358,359,94,43,95,93,42,68,90,331,330,17,344,53,252,101,105,137]),function($e,e,D,M,h,R,A,g,E,$,P,I,b,S,C,y,r,i,a,m,p,f,t,s,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,D.$jr)(P.$fbc,g.$cdc,0),(0,D.$jr)(a.$4i,i.$mdc,1),(0,D.$jr)(a.$3i,new t.$wh(f.$Ccc,[!1],!0)),(0,D.$jr)(s.$Uk,o.$K6b,1),(0,D.$jr)(y.$3ac,r.$ldc,0),(0,D.$jr)($.$Pbc,R.$Pcc,0),(0,D.$jr)(I.$Zbc,A.$0cc,0),(0,D.$jr)(b.$Kbc,h.$Hcc,0),(0,D.$jr)(S.$5ac,M.$Gcc,0),(0,D.$jr)(C.$3rb,E.$kdc,0),(0,D.$jr)(p.$Nbc,m.$ndc,0)}),define(De[371],Ce([1,0,57,372,61,8,80,116,238,110,341,21,29,99,13,130,259,277,346,360]),function($e,e,D,M,h,R,A,g,E,$,P,I,b,S,C,y,r,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),function(){for(let d=0;d<process.execArgv.length;d++)process.execArgv[d]==="--inspect-port=0"&&(process.execArgv.splice(d,1),d--)}();const a=M(process.argv.slice(2),{boolean:["transformURIs","skipWorkspaceStorageLock"],string:["useHostProxy"]});(function(){const c=globalThis._VSCODE_NODE_MODULES.module,d=c._load;c._load=function(v){if(v==="natives")throw new Error('Either the extension or an NPM dependency is using the [unsupported "natives" node module](https://go.microsoft.com/fwlink/?linkid=871887).');return d.apply(this,arguments)}})();const m=process.exit.bind(process);function p(c){process.exit=function(d){if(c)m(d);else{const v=new Error("An extension called process.exit() and this was prevented.");console.warn(v.stack)}},process.crash=function(){const d=new Error("An extension called process.crash() and this was prevented.");console.warn(d.stack)},process.env.ELECTRON_RUN_AS_NODE="1"}let f=function(c){m()};function t(){const c=(0,i.$pm)(process.env);if(c.type===3)return new Promise((d,v)=>{const k=u=>{const l=u[0],w=new A.$mh;l.on("message",L=>w.fire(I.$Hc.wrap(L.data))),l.on("close",()=>{f("renderer closed the MessagePort")}),l.start(),d({onMessage:w.event,send:L=>l.postMessage(L.buffer)})};process.parentPort.on("message",u=>k(u.ports))});if(c.type===2)return new Promise((d,v)=>{let k=null;const u=setTimeout(()=>{f("VSCODE_EXTHOST_IPC_SOCKET timeout")},6e4),l=108e5,w=3e5,L=new C.$Rg(()=>f("renderer disconnected for too long (1)"),l),N=new C.$Rg(()=>f("renderer disconnected for too long (2)"),w);process.on("message",(T,O)=>{if(T&&T.type==="VSCODE_EXTHOST_IPC_SOCKET"){O.setNoDelay(!0);const B=I.$Hc.wrap(Buffer.from(T.initialDataChunk,"base64"));let F;if(T.skipWebSocketFrames)F=new g.$oh(O,"extHost-socket");else{const J=I.$Hc.wrap(Buffer.from(T.inflateBytes,"base64"));F=new g.$ph(new g.$oh(O,"extHost-socket"),T.permessageDeflate,J,!1)}k?(L.cancel(),N.cancel(),k.beginAcceptReconnection(F,B),k.endAcceptReconnection(),k.sendResume()):(clearTimeout(u),k=new A.$nh({socket:F,initialChunk:B}),k.sendResume(),k.onDidDispose(()=>f("renderer disconnected")),d(k),k.onSocketClose(()=>{L.schedule()}))}if(T&&T.type==="VSCODE_EXTHOST_IPC_REDUCE_GRACE_TIME"){if(N.isScheduled())return;L.isScheduled()&&N.schedule()}});const j={type:"VSCODE_EXTHOST_IPC_READY"};process.send?.(j)});{const d=c.pipeName;return new Promise((v,k)=>{const u=D.createConnection(d,()=>{u.removeListener("error",k);const l=new A.$nh({socket:new g.$oh(u,"extHost-renderer")});l.sendResume(),v(l)});u.once("error",k),u.on("close",()=>{f("renderer closed the socket")})})}}async function s(){const c=await t();return new class{constructor(){this.a=new A.$mh,this.onMessage=this.a.event,this.b=!1,c.onMessage(d=>{(0,$.$3l)(d,2)?(this.b=!0,f("received terminate message from renderer")):this.a.fire(d)})}send(d){this.b||c.send(d)}async drain(){if(c.drain)return c.drain()}}}function o(c){return new Promise(d=>{const v=c.onMessage(k=>{v.dispose();const u=JSON.parse(k.toString()),l=u.commit,w=E.default.commit;if(l&&w&&l!==w&&m(55),u.parentPid){let L=0;setInterval(function(){try{process.kill(u.parentPid,0),L=0}catch(j){j&&j.code==="EPERM"?(L++,L>=3&&f(`parent process ${u.parentPid} does not exist anymore (3 x EPERM): ${j.message} (code: ${j.code}) (errno: ${j.errno})`)):f(`parent process ${u.parentPid} does not exist anymore: ${j.message} (code: ${j.code}) (errno: ${j.errno})`)}},1e3);let N;try{N=globalThis._VSCODE_NODE_MODULES["native-watchdog"],N.start(u.parentPid)}catch(j){(0,R.$Y)(j)}}c.send((0,$.$2l)(0)),d({protocol:c,initData:u})});c.send((0,$.$2l)(1))})}async function n(){const c=[];process.on("unhandledRejection",(L,N)=>{c.push(N),setTimeout(()=>{const j=c.indexOf(N);j>=0&&N.catch(T=>{c.splice(j,1),(0,R.$2)(T)||(console.warn(`rejected promise not handled within 1 second: ${T}`),T&&T.stack&&console.warn(`stack trace: ${T.stack}`),L&&(0,R.$Y)(L))})},1e3)}),process.on("rejectionHandled",L=>{const N=c.indexOf(L);N>=0&&c.splice(N,1)}),process.on("uncaughtException",function(L){(0,R.$X)(L)||(0,R.$Y)(L)}),h.mark("code/extHost/willConnectToRenderer");const d=await s();h.mark("code/extHost/didConnectToRenderer");const v=await o(d);h.mark("code/extHost/didWaitForInitData");const{initData:k}=v;p(!!k.environment.extensionTestsLocationURI),k.environment.useHostProxy=a.useHostProxy!==void 0?a.useHostProxy!=="false":void 0,k.environment.skipWorkspaceStorageLock=(0,y.boolean)(a.skipWorkspaceStorageLock,!1);const u=new class{constructor(){this.pid=process.pid}exit(N){m(N)}fsExists(N){return b.Promises.exists(N)}fsRealpath(N){return(0,S.$Tp)(N)}};let l=null;k.remote.authority&&a.transformURIs&&(l=(0,r.$nr)(k.remote.authority));const w=new P.$Fcc(v.protocol,k,u,l);f=L=>w.terminate(L)}n().catch(c=>console.log(c))})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/3c133b63c6e17e2fe33f37db93a6d43e78a262c5/core/vs/workbench/api/node/extensionHostProcess.js.map
