/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Pe=["exports","require","vs/base/common/uri","vs/workbench/api/common/extHost.protocol","vs/platform/instantiation/common/instantiation","vs/base/common/event","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypes","vs/workbench/api/common/extHostTypeConverters","vs/base/common/errors","vs/nls","vs/nls!vs/workbench/api/worker/extensionHostWorker","vs/base/common/network","vs/base/common/async","vs/platform/log/common/log","vs/base/common/strings","vs/base/common/types","vs/workbench/api/common/extHostRpcService","vs/base/common/arrays","vs/base/common/path","vs/platform/extensions/common/extensions","vs/base/common/cancellation","vs/base/common/platform","vs/base/common/resources","vs/base/common/objects","vs/base/common/buffer","vs/workbench/services/extensions/common/extensions","vs/workbench/api/common/extHostInitDataService","vs/base/common/map","vs/base/common/severity","vs/platform/registry/common/platform","vs/workbench/api/common/extHostCommands","vs/platform/contextkey/common/contextkey","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/workbench/api/common/extHostExtensionService","vs/base/common/uuid","vs/base/common/glob","vs/platform/files/common/files","vs/workbench/api/common/extHostFileSystemInfo","vs/base/common/themables","vs/base/common/errorMessage","vs/base/common/extpath","vs/platform/configuration/common/configuration","vs/editor/common/core/range","vs/workbench/contrib/testing/common/testId","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/services/search/common/search","vs/base/common/ternarySearchTree","vs/base/common/htmlContent","vs/base/common/assert","vs/platform/remote/common/remoteHosts","vs/platform/telemetry/common/telemetryUtils","vs/platform/workspace/common/workspace","vs/workbench/api/common/cache","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/contrib/testing/common/testTypes","vs/workbench/api/common/extHostTelemetry","vs/base/common/stopwatch","vs/workbench/api/common/extHostDocumentsAndEditors","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostTerminalService","vs/workbench/api/common/extHostWebview","vs/base/common/decorators","vs/base/common/lazy","vs/base/common/iterator","vs/base/common/mime","vs/base/common/marshalling","vs/platform/instantiation/common/descriptors","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/serviceCollection","vs/platform/progress/common/progress","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/base/common/process","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/contrib/webview/common/webview","vs/editor/common/languages","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostLocalizationService","vs/workbench/api/common/extHostManagedSockets","vs/workbench/api/common/extHostSecretState","vs/workbench/api/common/extHostStorage","vs/workbench/api/common/extHostStoragePaths","vs/workbench/api/common/extHostTunnelService","vs/base/common/performance","vs/base/common/idGenerator","vs/base/common/codicons","vs/base/common/labels","vs/editor/common/services/semanticTokensDto","vs/platform/extensionManagement/common/extensionManagement","vs/base/common/hash","vs/platform/markers/common/markers","vs/platform/opener/common/opener","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/extensionManagement/common/implicitActivationEvents","vs/workbench/common/editor","vs/base/common/collections","vs/workbench/api/common/extHostDocumentData","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTestItem","vs/workbench/api/common/extHostTextEditor","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostWindow","vs/workbench/api/common/extHostOutput","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostVariableResolverService","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/json","vs/base/common/marked/marked","vs/base/common/numbers","vs/base/common/stream","vs/base/common/filters","vs/base/common/symbols","vs/base/common/iconLabels","vs/base/common/dataTransfer","vs/editor/common/core/textModelDefaults","vs/editor/common/languages/languageConfiguration","vs/editor/common/services/treeViewsDnd","vs/nls!vs/base/common/actions","vs/base/common/actions","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/base/common/comparers","vs/base/common/uriIpc","vs/editor/common/languageSelector","vs/nls!vs/editor/common/config/editorOptions","vs/editor/common/config/editorOptions","vs/editor/common/core/wordHelper","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/theme/common/iconRegistry","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/workbench/api/common/extHostChat","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostLanguageFeatures","vs/nls!vs/workbench/api/common/extHostLogService","vs/nls!vs/workbench/api/common/extHostNotebook","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTelemetry","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostTunnelService","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/common/views","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/common/debug","vs/nls!vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/nls!vs/workbench/contrib/tasks/common/tasks","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/extensions/common/extensionsRegistry","vs/nls!vs/workbench/services/search/common/queryBuilder","vs/platform/contextkey/common/scanner","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/platform/environment/common/environment","vs/platform/instantiation/common/instantiationService","vs/base/common/linkedList","vs/platform/log/common/logService","vs/platform/notification/common/notification","vs/platform/product/common/productService","vs/platform/configuration/common/configurationModels","vs/platform/telemetry/common/commonProperties","vs/platform/telemetry/common/telemetry","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/iconRegistry","vs/platform/tunnel/common/tunnel","vs/platform/workspace/common/editSessions","vs/platform/workspace/common/virtualWorkspace","vs/workbench/api/common/extHostLogService","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/common/views","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/contrib/debug/common/debug","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/api/common/extHostTheming","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/api/common/extHostCodeInsets","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/base/common/functional","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostProgress","vs/workbench/services/environment/common/environmentService","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/api/common/extHostTreeViews","vs/workbench/services/extensions/common/extensionsApiProposals","vs/workbench/services/extensions/common/extensionsRegistry","vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/workbench/contrib/tasks/common/tasks","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAiRelatedInformation","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostChat","vs/workbench/api/common/extHostChatProvider","vs/workbench/api/common/extHostChatSlashCommand","vs/workbench/api/common/extHostChatVariables","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostConsoleForwarder","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostEmbeddingVector","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostInlineChat","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostIssueReporter","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebook","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostProfileContentHandler","vs/workbench/api/common/extHostQuickDiff","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostShare","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/worker/extHostConsoleForwarder","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/extensions/worker/polyfillNestedWorker","vs/workbench/services/output/common/output","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/path/common/pathService","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/queryBuilder","vs/workbench/services/extensions/common/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/common/extensionHostMain","vs/workbench/services/search/common/textSearchManager","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/api/worker/extHostExtensionService","vs/workbench/api/worker/extHost.worker.services","vs/base/common/semver/semver","vs/editor/common/model/mirrorTextModel","vs/editor/common/core/position","vs/editor/common/languages/linkComputer","vs/editor/common/core/selection","vs/base/common/arraysFind","vs/editor/common/model/textModelSearch","vs/editor/common/model","vs/workbench/api/worker/extensionHostWorker"],Ae=function(pe){for(var e=[],y=0,R=pe.length;y<R;y++)e[y]=Pe[pe[y]];return e};define(Pe[64],Ae([1,0]),function(pe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6g=e.$5g=e.$4g=void 0;function y(A){return(h,S,g)=>{let P=null,D=null;if(typeof g.value=="function"?(P="value",D=g.value):typeof g.get=="function"&&(P="get",D=g.get),!D)throw new Error("not supported");g[P]=A(D,S)}}function R(A,h,S){let g=null,P=null;if(typeof S.value=="function"?(g="value",P=S.value,P.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof S.get=="function"&&(g="get",P=S.get),!P)throw new Error("not supported");const D=`$memoize$${h}`;S[g]=function(...u){return this.hasOwnProperty(D)||Object.defineProperty(this,D,{configurable:!1,enumerable:!1,writable:!1,value:P.apply(this,u)}),this[D]}}e.$4g=R;function C(A,h,S){return y((g,P)=>{const D=`$debounce$${P}`,u=`$debounce$result$${P}`;return function(...p){this[u]||(this[u]=S?S():void 0),clearTimeout(this[D]),h&&(this[u]=h(this[u],...p),p=[this[u]]),this[D]=setTimeout(()=>{g.apply(this,p),this[u]=S?S():void 0},A)}})}e.$5g=C;function L(A,h,S){return y((g,P)=>{const D=`$throttle$timer$${P}`,u=`$throttle$result$${P}`,p=`$throttle$lastRun$${P}`,$=`$throttle$pending$${P}`;return function(...d){if(this[u]||(this[u]=S?S():void 0),(this[p]===null||this[p]===void 0)&&(this[p]=-Number.MAX_VALUE),h&&(this[u]=h(this[u],...d)),this[$])return;const t=this[p]+A;t<=Date.now()?(this[p]=Date.now(),g.apply(this,[this[u]]),this[u]=S?S():void 0):(this[$]=!0,this[D]=setTimeout(()=>{this[$]=!1,this[p]=Date.now(),g.apply(this,[this[u]]),this[u]=S?S():void 0},t-Date.now()))}})}e.$6g=L}),define(Pe[88],Ae([1,0]),function(pe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1L=e.$ZL=void 0;class y{constructor(C){this.a=C,this.b=0}nextId(){return this.a+ ++this.b}}e.$ZL=y,e.$1L=new y("id#")}),define(Pe[116],Ae([1,0]),function(pe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sm=e.$Rm=e.$Qm=e.$Pm=e.$Om=e.$Nm=e.$Mm=e.$Lm=e.$Km=e.$Jm=e.$Im=e.$Hm=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var y;(function(n){n[n.None=0]="None",n[n.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",n[n.UnexpectedEndOfString=2]="UnexpectedEndOfString",n[n.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",n[n.InvalidUnicode=4]="InvalidUnicode",n[n.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",n[n.InvalidCharacter=6]="InvalidCharacter"})(y||(e.ScanError=y={}));var R;(function(n){n[n.OpenBraceToken=1]="OpenBraceToken",n[n.CloseBraceToken=2]="CloseBraceToken",n[n.OpenBracketToken=3]="OpenBracketToken",n[n.CloseBracketToken=4]="CloseBracketToken",n[n.CommaToken=5]="CommaToken",n[n.ColonToken=6]="ColonToken",n[n.NullKeyword=7]="NullKeyword",n[n.TrueKeyword=8]="TrueKeyword",n[n.FalseKeyword=9]="FalseKeyword",n[n.StringLiteral=10]="StringLiteral",n[n.NumericLiteral=11]="NumericLiteral",n[n.LineCommentTrivia=12]="LineCommentTrivia",n[n.BlockCommentTrivia=13]="BlockCommentTrivia",n[n.LineBreakTrivia=14]="LineBreakTrivia",n[n.Trivia=15]="Trivia",n[n.Unknown=16]="Unknown",n[n.EOF=17]="EOF"})(R||(e.SyntaxKind=R={}));var C;(function(n){n[n.InvalidSymbol=1]="InvalidSymbol",n[n.InvalidNumberFormat=2]="InvalidNumberFormat",n[n.PropertyNameExpected=3]="PropertyNameExpected",n[n.ValueExpected=4]="ValueExpected",n[n.ColonExpected=5]="ColonExpected",n[n.CommaExpected=6]="CommaExpected",n[n.CloseBraceExpected=7]="CloseBraceExpected",n[n.CloseBracketExpected=8]="CloseBracketExpected",n[n.EndOfFileExpected=9]="EndOfFileExpected",n[n.InvalidCommentToken=10]="InvalidCommentToken",n[n.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",n[n.UnexpectedEndOfString=12]="UnexpectedEndOfString",n[n.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",n[n.InvalidUnicode=14]="InvalidUnicode",n[n.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",n[n.InvalidCharacter=16]="InvalidCharacter"})(C||(e.ParseErrorCode=C={}));var L;(function(n){n.DEFAULT={allowTrailingComma:!0}})(L||(e.ParseOptions=L={}));function A(n,a=!1){let s=0;const o=n.length;let w="",v=0,I=16,k=0;function r(j){let U=0,z=0;for(;U<j;){const ie=n.charCodeAt(s);if(ie>=48&&ie<=57)z=z*16+ie-48;else if(ie>=65&&ie<=70)z=z*16+ie-65+10;else if(ie>=97&&ie<=102)z=z*16+ie-97+10;else break;s++,U++}return U<j&&(z=-1),z}function l(j){s=j,w="",v=0,I=16,k=0}function f(){const j=s;if(n.charCodeAt(s)===48)s++;else for(s++;s<n.length&&g(n.charCodeAt(s));)s++;if(s<n.length&&n.charCodeAt(s)===46)if(s++,s<n.length&&g(n.charCodeAt(s)))for(s++;s<n.length&&g(n.charCodeAt(s));)s++;else return k=3,n.substring(j,s);let U=s;if(s<n.length&&(n.charCodeAt(s)===69||n.charCodeAt(s)===101))if(s++,(s<n.length&&n.charCodeAt(s)===43||n.charCodeAt(s)===45)&&s++,s<n.length&&g(n.charCodeAt(s))){for(s++;s<n.length&&g(n.charCodeAt(s));)s++;U=s}else k=3;return n.substring(j,U)}function F(){let j="",U=s;for(;;){if(s>=o){j+=n.substring(U,s),k=2;break}const z=n.charCodeAt(s);if(z===34){j+=n.substring(U,s),s++;break}if(z===92){if(j+=n.substring(U,s),s++,s>=o){k=2;break}switch(n.charCodeAt(s++)){case 34:j+='"';break;case 92:j+="\\";break;case 47:j+="/";break;case 98:j+="\b";break;case 102:j+="\f";break;case 110:j+=`
`;break;case 114:j+="\r";break;case 116:j+="	";break;case 117:{const Y=r(4);Y>=0?j+=String.fromCharCode(Y):k=4;break}default:k=5}U=s;continue}if(z>=0&&z<=31)if(S(z)){j+=n.substring(U,s),k=2;break}else k=6;s++}return j}function W(){if(w="",k=0,v=s,s>=o)return v=o,I=17;let j=n.charCodeAt(s);if(h(j)){do s++,w+=String.fromCharCode(j),j=n.charCodeAt(s);while(h(j));return I=15}if(S(j))return s++,w+=String.fromCharCode(j),j===13&&n.charCodeAt(s)===10&&(s++,w+=`
`),I=14;switch(j){case 123:return s++,I=1;case 125:return s++,I=2;case 91:return s++,I=3;case 93:return s++,I=4;case 58:return s++,I=6;case 44:return s++,I=5;case 34:return s++,w=F(),I=10;case 47:{const U=s-1;if(n.charCodeAt(s+1)===47){for(s+=2;s<o&&!S(n.charCodeAt(s));)s++;return w=n.substring(U,s),I=12}if(n.charCodeAt(s+1)===42){s+=2;const z=o-1;let ie=!1;for(;s<z;){if(n.charCodeAt(s)===42&&n.charCodeAt(s+1)===47){s+=2,ie=!0;break}s++}return ie||(s++,k=1),w=n.substring(U,s),I=13}return w+=String.fromCharCode(j),s++,I=16}case 45:if(w+=String.fromCharCode(j),s++,s===o||!g(n.charCodeAt(s)))return I=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return w+=f(),I=11;default:for(;s<o&&V(j);)s++,j=n.charCodeAt(s);if(v!==s){switch(w=n.substring(v,s),w){case"true":return I=8;case"false":return I=9;case"null":return I=7}return I=16}return w+=String.fromCharCode(j),s++,I=16}}function V(j){if(h(j)||S(j))return!1;switch(j){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function B(){let j;do j=W();while(j>=12&&j<=15);return j}return{setPosition:l,getPosition:()=>s,scan:a?B:W,getToken:()=>I,getTokenValue:()=>w,getTokenOffset:()=>v,getTokenLength:()=>s-v,getTokenError:()=>k}}e.$Hm=A;function h(n){return n===32||n===9||n===11||n===12||n===160||n===5760||n>=8192&&n<=8203||n===8239||n===8287||n===12288||n===65279}function S(n){return n===10||n===13||n===8232||n===8233}function g(n){return n>=48&&n<=57}var P;(function(n){n[n.nullCharacter=0]="nullCharacter",n[n.maxAsciiCharacter=127]="maxAsciiCharacter",n[n.lineFeed=10]="lineFeed",n[n.carriageReturn=13]="carriageReturn",n[n.lineSeparator=8232]="lineSeparator",n[n.paragraphSeparator=8233]="paragraphSeparator",n[n.nextLine=133]="nextLine",n[n.space=32]="space",n[n.nonBreakingSpace=160]="nonBreakingSpace",n[n.enQuad=8192]="enQuad",n[n.emQuad=8193]="emQuad",n[n.enSpace=8194]="enSpace",n[n.emSpace=8195]="emSpace",n[n.threePerEmSpace=8196]="threePerEmSpace",n[n.fourPerEmSpace=8197]="fourPerEmSpace",n[n.sixPerEmSpace=8198]="sixPerEmSpace",n[n.figureSpace=8199]="figureSpace",n[n.punctuationSpace=8200]="punctuationSpace",n[n.thinSpace=8201]="thinSpace",n[n.hairSpace=8202]="hairSpace",n[n.zeroWidthSpace=8203]="zeroWidthSpace",n[n.narrowNoBreakSpace=8239]="narrowNoBreakSpace",n[n.ideographicSpace=12288]="ideographicSpace",n[n.mathematicalSpace=8287]="mathematicalSpace",n[n.ogham=5760]="ogham",n[n._=95]="_",n[n.$=36]="$",n[n._0=48]="_0",n[n._1=49]="_1",n[n._2=50]="_2",n[n._3=51]="_3",n[n._4=52]="_4",n[n._5=53]="_5",n[n._6=54]="_6",n[n._7=55]="_7",n[n._8=56]="_8",n[n._9=57]="_9",n[n.a=97]="a",n[n.b=98]="b",n[n.c=99]="c",n[n.d=100]="d",n[n.e=101]="e",n[n.f=102]="f",n[n.g=103]="g",n[n.h=104]="h",n[n.i=105]="i",n[n.j=106]="j",n[n.k=107]="k",n[n.l=108]="l",n[n.m=109]="m",n[n.n=110]="n",n[n.o=111]="o",n[n.p=112]="p",n[n.q=113]="q",n[n.r=114]="r",n[n.s=115]="s",n[n.t=116]="t",n[n.u=117]="u",n[n.v=118]="v",n[n.w=119]="w",n[n.x=120]="x",n[n.y=121]="y",n[n.z=122]="z",n[n.A=65]="A",n[n.B=66]="B",n[n.C=67]="C",n[n.D=68]="D",n[n.E=69]="E",n[n.F=70]="F",n[n.G=71]="G",n[n.H=72]="H",n[n.I=73]="I",n[n.J=74]="J",n[n.K=75]="K",n[n.L=76]="L",n[n.M=77]="M",n[n.N=78]="N",n[n.O=79]="O",n[n.P=80]="P",n[n.Q=81]="Q",n[n.R=82]="R",n[n.S=83]="S",n[n.T=84]="T",n[n.U=85]="U",n[n.V=86]="V",n[n.W=87]="W",n[n.X=88]="X",n[n.Y=89]="Y",n[n.Z=90]="Z",n[n.ampersand=38]="ampersand",n[n.asterisk=42]="asterisk",n[n.at=64]="at",n[n.backslash=92]="backslash",n[n.bar=124]="bar",n[n.caret=94]="caret",n[n.closeBrace=125]="closeBrace",n[n.closeBracket=93]="closeBracket",n[n.closeParen=41]="closeParen",n[n.colon=58]="colon",n[n.comma=44]="comma",n[n.dot=46]="dot",n[n.doubleQuote=34]="doubleQuote",n[n.equals=61]="equals",n[n.exclamation=33]="exclamation",n[n.greaterThan=62]="greaterThan",n[n.lessThan=60]="lessThan",n[n.minus=45]="minus",n[n.openBrace=123]="openBrace",n[n.openBracket=91]="openBracket",n[n.openParen=40]="openParen",n[n.percent=37]="percent",n[n.plus=43]="plus",n[n.question=63]="question",n[n.semicolon=59]="semicolon",n[n.singleQuote=39]="singleQuote",n[n.slash=47]="slash",n[n.tilde=126]="tilde",n[n.backspace=8]="backspace",n[n.formFeed=12]="formFeed",n[n.byteOrderMark=65279]="byteOrderMark",n[n.tab=9]="tab",n[n.verticalTab=11]="verticalTab"})(P||(P={}));function D(n,a){const s=[],o=new Object;let w;const v={value:{},offset:0,length:0,type:"object",parent:void 0};let I=!1;function k(r,l,f,F){v.value=r,v.offset=l,v.length=f,v.type=F,v.colonOffset=void 0,w=v}try{m(n,{onObjectBegin:(r,l)=>{if(a<=r)throw o;w=void 0,I=a>r,s.push("")},onObjectProperty:(r,l,f)=>{if(a<l||(k(r,l,f,"property"),s[s.length-1]=r,a<=l+f))throw o},onObjectEnd:(r,l)=>{if(a<=r)throw o;w=void 0,s.pop()},onArrayBegin:(r,l)=>{if(a<=r)throw o;w=void 0,s.push(0)},onArrayEnd:(r,l)=>{if(a<=r)throw o;w=void 0,s.pop()},onLiteralValue:(r,l,f)=>{if(a<l||(k(r,l,f,b(r)),a<=l+f))throw o},onSeparator:(r,l,f)=>{if(a<=l)throw o;if(r===":"&&w&&w.type==="property")w.colonOffset=l,I=!1,w=void 0;else if(r===","){const F=s[s.length-1];typeof F=="number"?s[s.length-1]=F+1:(I=!0,s[s.length-1]=""),w=void 0}}})}catch(r){if(r!==o)throw r}return{path:s,previousNode:w,isAtPropertyKey:I,matches:r=>{let l=0;for(let f=0;l<r.length&&f<s.length;f++)if(r[l]===s[f]||r[l]==="*")l++;else if(r[l]!=="**")return!1;return l===r.length}}}e.$Im=D;function u(n,a=[],s=L.DEFAULT){let o=null,w=[];const v=[];function I(r){Array.isArray(w)?w.push(r):o!==null&&(w[o]=r)}return m(n,{onObjectBegin:()=>{const r={};I(r),v.push(w),w=r,o=null},onObjectProperty:r=>{o=r},onObjectEnd:()=>{w=v.pop()},onArrayBegin:()=>{const r=[];I(r),v.push(w),w=r,o=null},onArrayEnd:()=>{w=v.pop()},onLiteralValue:I,onError:(r,l,f)=>{a.push({error:r,offset:l,length:f})}},s),w[0]}e.$Jm=u;function p(n,a=[],s=L.DEFAULT){let o={type:"array",offset:-1,length:-1,children:[],parent:void 0};function w(r){o.type==="property"&&(o.length=r-o.offset,o=o.parent)}function v(r){return o.children.push(r),r}m(n,{onObjectBegin:r=>{o=v({type:"object",offset:r,length:-1,parent:o,children:[]})},onObjectProperty:(r,l,f)=>{o=v({type:"property",offset:l,length:-1,parent:o,children:[]}),o.children.push({type:"string",value:r,offset:l,length:f,parent:o})},onObjectEnd:(r,l)=>{o.length=r+l-o.offset,o=o.parent,w(r+l)},onArrayBegin:(r,l)=>{o=v({type:"array",offset:r,length:-1,parent:o,children:[]})},onArrayEnd:(r,l)=>{o.length=r+l-o.offset,o=o.parent,w(r+l)},onLiteralValue:(r,l,f)=>{v({type:b(r),offset:l,length:f,parent:o,value:r}),w(l+f)},onSeparator:(r,l,f)=>{o.type==="property"&&(r===":"?o.colonOffset=l:r===","&&w(l))},onError:(r,l,f)=>{a.push({error:r,offset:l,length:f})}},s);const k=o.children[0];return k&&delete k.parent,k}e.$Km=p;function $(n,a){if(!n)return;let s=n;for(const o of a)if(typeof o=="string"){if(s.type!=="object"||!Array.isArray(s.children))return;let w=!1;for(const v of s.children)if(Array.isArray(v.children)&&v.children[0].value===o){s=v.children[1],w=!0;break}if(!w)return}else{const w=o;if(s.type!=="array"||w<0||!Array.isArray(s.children)||w>=s.children.length)return;s=s.children[w]}return s}e.$Lm=$;function d(n){if(!n.parent||!n.parent.children)return[];const a=d(n.parent);if(n.parent.type==="property"){const s=n.parent.children[0].value;a.push(s)}else if(n.parent.type==="array"){const s=n.parent.children.indexOf(n);s!==-1&&a.push(s)}return a}e.$Mm=d;function t(n){switch(n.type){case"array":return n.children.map(t);case"object":{const a=Object.create(null);for(const s of n.children){const o=s.children[1];o&&(a[s.children[0].value]=t(o))}return a}case"null":case"string":case"number":case"boolean":return n.value;default:return}}e.$Nm=t;function i(n,a,s=!1){return a>=n.offset&&a<n.offset+n.length||s&&a===n.offset+n.length}e.$Om=i;function c(n,a,s=!1){if(i(n,a,s)){const o=n.children;if(Array.isArray(o))for(let w=0;w<o.length&&o[w].offset<=a;w++){const v=c(o[w],a,s);if(v)return v}return n}}e.$Pm=c;function m(n,a,s=L.DEFAULT){const o=A(n,!1);function w(we){return we?()=>we(o.getTokenOffset(),o.getTokenLength()):()=>!0}function v(we){return we?ae=>we(ae,o.getTokenOffset(),o.getTokenLength()):()=>!0}const I=w(a.onObjectBegin),k=v(a.onObjectProperty),r=w(a.onObjectEnd),l=w(a.onArrayBegin),f=w(a.onArrayEnd),F=v(a.onLiteralValue),W=v(a.onSeparator),V=w(a.onComment),B=v(a.onError),j=s&&s.disallowComments,U=s&&s.allowTrailingComma;function z(){for(;;){const we=o.scan();switch(o.getTokenError()){case 4:ie(14);break;case 5:ie(15);break;case 3:ie(13);break;case 1:j||ie(11);break;case 2:ie(12);break;case 6:ie(16);break}switch(we){case 12:case 13:j?ie(10):V();break;case 16:ie(1);break;case 15:case 14:break;default:return we}}}function ie(we,ae=[],x=[]){if(B(we),ae.length+x.length>0){let ue=o.getToken();for(;ue!==17;){if(ae.indexOf(ue)!==-1){z();break}else if(x.indexOf(ue)!==-1)break;ue=z()}}}function Y(we){const ae=o.getTokenValue();return we?F(ae):k(ae),z(),!0}function ye(){switch(o.getToken()){case 11:{let we=0;try{we=JSON.parse(o.getTokenValue()),typeof we!="number"&&(ie(2),we=0)}catch{ie(2)}F(we);break}case 7:F(null);break;case 8:F(!0);break;case 9:F(!1);break;default:return!1}return z(),!0}function ke(){return o.getToken()!==10?(ie(3,[],[2,5]),!1):(Y(!1),o.getToken()===6?(W(":"),z(),le()||ie(4,[],[2,5])):ie(5,[],[2,5]),!0)}function Re(){I(),z();let we=!1;for(;o.getToken()!==2&&o.getToken()!==17;){if(o.getToken()===5){if(we||ie(4,[],[]),W(","),z(),o.getToken()===2&&U)break}else we&&ie(6,[],[]);ke()||ie(4,[],[2,5]),we=!0}return r(),o.getToken()!==2?ie(7,[2],[]):z(),!0}function X(){l(),z();let we=!1;for(;o.getToken()!==4&&o.getToken()!==17;){if(o.getToken()===5){if(we||ie(4,[],[]),W(","),z(),o.getToken()===4&&U)break}else we&&ie(6,[],[]);le()||ie(4,[],[4,5]),we=!0}return f(),o.getToken()!==4?ie(8,[4],[]):z(),!0}function le(){switch(o.getToken()){case 3:return X();case 1:return Re();case 10:return Y(!0);default:return ye()}}return z(),o.getToken()===17?s.allowEmptyContent?!0:(ie(4,[],[]),!1):le()?(o.getToken()!==17&&ie(9,[],[]),!0):(ie(4,[],[]),!1)}e.$Qm=m;function E(n,a){const s=A(n),o=[];let w,v=0,I;do switch(I=s.getPosition(),w=s.scan(),w){case 12:case 13:case 17:v!==I&&o.push(n.substring(v,I)),a!==void 0&&o.push(s.getTokenValue().replace(/[^\r\n]/g,a)),v=s.getPosition();break}while(w!==17);return o.join("")}e.$Rm=E;function b(n){switch(typeof n){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(n){if(Array.isArray(n))return"array"}else return"null";return"object"}default:return"null"}}e.$Sm=b}),define(Pe[28],Ae([1,0]),function(pe,e){"use strict";var y,R,C;Object.defineProperty(e,"__esModule",{value:!0}),e.$Ci=e.$Bi=e.$Ai=e.$zi=e.Touch=e.$yi=e.$xi=e.$wi=e.$vi=e.$ui=void 0;function L(t,i,c){let m=t.get(i);return m===void 0&&(m=c,t.set(i,m)),m}e.$ui=L;function A(t){const i=[];return t.forEach((c,m)=>{i.push(`${m} => ${c}`)}),`Map(${t.size}) {${i.join(", ")}}`}e.$vi=A;function h(t){const i=[];return t.forEach(c=>{i.push(c)}),`Set(${t.size}) {${i.join(", ")}}`}e.$wi=h;class S{constructor(i,c){this.uri=i,this.value=c}}class g{static{this.a=i=>i.toString()}constructor(i,c){this[y]="ResourceMap",i instanceof g?(this.b=new Map(i.b),this.c=c??g.a):(this.b=new Map,this.c=i??g.a)}set(i,c){return this.b.set(this.c(i),new S(i,c)),this}get(i){return this.b.get(this.c(i))?.value}has(i){return this.b.has(this.c(i))}get size(){return this.b.size}clear(){this.b.clear()}delete(i){return this.b.delete(this.c(i))}forEach(i,c){typeof c<"u"&&(i=i.bind(c));for(const[m,E]of this.b)i(E.value,E.uri,this)}*values(){for(const i of this.b.values())yield i.value}*keys(){for(const i of this.b.values())yield i.uri}*entries(){for(const i of this.b.values())yield[i.uri,i.value]}*[(y=Symbol.toStringTag,Symbol.iterator)](){for(const[,i]of this.b)yield[i.uri,i.value]}}e.$xi=g;class P{constructor(i,c){this[R]="ResourceSet",!i||typeof i=="function"?this.a=new g(i):(this.a=new g(c),i.forEach(this.add,this))}get size(){return this.a.size}add(i){return this.a.set(i,i),this}clear(){this.a.clear()}delete(i){return this.a.delete(i)}forEach(i,c){this.a.forEach((m,E)=>i.call(c,E,E,this))}has(i){return this.a.has(i)}entries(){return this.a.entries()}keys(){return this.a.keys()}values(){return this.a.keys()}[(R=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.$yi=P;var D;(function(t){t[t.None=0]="None",t[t.AsOld=1]="AsOld",t[t.AsNew=2]="AsNew"})(D||(e.Touch=D={}));class u{constructor(){this[C]="LinkedMap",this.a=new Map,this.b=void 0,this.c=void 0,this.d=0,this.e=0}clear(){this.a.clear(),this.b=void 0,this.c=void 0,this.d=0,this.e++}isEmpty(){return!this.b&&!this.c}get size(){return this.d}get first(){return this.b?.value}get last(){return this.c?.value}has(i){return this.a.has(i)}get(i,c=0){const m=this.a.get(i);if(m)return c!==0&&this.j(m,c),m.value}set(i,c,m=0){let E=this.a.get(i);if(E)E.value=c,m!==0&&this.j(E,m);else{switch(E={key:i,value:c,next:void 0,previous:void 0},m){case 0:this.h(E);break;case 1:this.g(E);break;case 2:this.h(E);break;default:this.h(E);break}this.a.set(i,E),this.d++}return this}delete(i){return!!this.remove(i)}remove(i){const c=this.a.get(i);if(c)return this.a.delete(i),this.i(c),this.d--,c.value}shift(){if(!this.b&&!this.c)return;if(!this.b||!this.c)throw new Error("Invalid list");const i=this.b;return this.a.delete(i.key),this.i(i),this.d--,i.value}forEach(i,c){const m=this.e;let E=this.b;for(;E;){if(c?i.bind(c)(E.value,E.key,this):i(E.value,E.key,this),this.e!==m)throw new Error("LinkedMap got modified during iteration.");E=E.next}}keys(){const i=this,c=this.e;let m=this.b;const E={[Symbol.iterator](){return E},next(){if(i.e!==c)throw new Error("LinkedMap got modified during iteration.");if(m){const b={value:m.key,done:!1};return m=m.next,b}else return{value:void 0,done:!0}}};return E}values(){const i=this,c=this.e;let m=this.b;const E={[Symbol.iterator](){return E},next(){if(i.e!==c)throw new Error("LinkedMap got modified during iteration.");if(m){const b={value:m.value,done:!1};return m=m.next,b}else return{value:void 0,done:!0}}};return E}entries(){const i=this,c=this.e;let m=this.b;const E={[Symbol.iterator](){return E},next(){if(i.e!==c)throw new Error("LinkedMap got modified during iteration.");if(m){const b={value:[m.key,m.value],done:!1};return m=m.next,b}else return{value:void 0,done:!0}}};return E}[(C=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}f(i){if(i>=this.size)return;if(i===0){this.clear();return}let c=this.b,m=this.size;for(;c&&m>i;)this.a.delete(c.key),c=c.next,m--;this.b=c,this.d=m,c&&(c.previous=void 0),this.e++}g(i){if(!this.b&&!this.c)this.c=i;else if(this.b)i.next=this.b,this.b.previous=i;else throw new Error("Invalid list");this.b=i,this.e++}h(i){if(!this.b&&!this.c)this.b=i;else if(this.c)i.previous=this.c,this.c.next=i;else throw new Error("Invalid list");this.c=i,this.e++}i(i){if(i===this.b&&i===this.c)this.b=void 0,this.c=void 0;else if(i===this.b){if(!i.next)throw new Error("Invalid list");i.next.previous=void 0,this.b=i.next}else if(i===this.c){if(!i.previous)throw new Error("Invalid list");i.previous.next=void 0,this.c=i.previous}else{const c=i.next,m=i.previous;if(!c||!m)throw new Error("Invalid list");c.previous=m,m.next=c}i.next=void 0,i.previous=void 0,this.e++}j(i,c){if(!this.b||!this.c)throw new Error("Invalid list");if(!(c!==1&&c!==2)){if(c===1){if(i===this.b)return;const m=i.next,E=i.previous;i===this.c?(E.next=void 0,this.c=E):(m.previous=E,E.next=m),i.previous=void 0,i.next=this.b,this.b.previous=i,this.b=i,this.e++}else if(c===2){if(i===this.c)return;const m=i.next,E=i.previous;i===this.b?(m.previous=void 0,this.b=m):(m.previous=E,E.next=m),i.next=void 0,i.previous=this.c,this.c.next=i,this.c=i,this.e++}}}toJSON(){const i=[];return this.forEach((c,m)=>{i.push([m,c])}),i}fromJSON(i){this.clear();for(const[c,m]of i)this.set(c,m)}}e.$zi=u;class p extends u{constructor(i,c=1){super(),this.k=i,this.l=Math.min(Math.max(0,c),1)}get limit(){return this.k}set limit(i){this.k=i,this.m()}get ratio(){return this.l}set ratio(i){this.l=Math.min(Math.max(0,i),1),this.m()}get(i,c=2){return super.get(i,c)}peek(i){return super.get(i,0)}set(i,c){return super.set(i,c,2),this.m(),this}m(){this.size>this.k&&this.f(Math.round(this.k*this.l))}}e.$Ai=p;class ${constructor(){this.a=new Map}add(i){return this.a.set(i,(this.a.get(i)||0)+1),this}delete(i){let c=this.a.get(i)||0;return c===0?!1:(c--,c===0?this.a.delete(i):this.a.set(i,c),!0)}has(i){return this.a.has(i)}}e.$Bi=$;class d{constructor(i){if(this.a=new Map,this.b=new Map,i)for(const[c,m]of i)this.set(c,m)}clear(){this.a.clear(),this.b.clear()}set(i,c){this.a.set(i,c),this.b.set(c,i)}get(i){return this.a.get(i)}getKey(i){return this.b.get(i)}delete(i){const c=this.a.get(i);return c===void 0?!1:(this.a.delete(i),this.b.delete(c),!0)}forEach(i,c){this.a.forEach((m,E)=>{i.call(c,m,E,this)})}keys(){return this.a.keys()}values(){return this.a.values()}}e.$Ci=d}),function(pe,e){typeof define=="function"&&define.amd?define(Pe[117],Ae([0]),e):typeof exports=="object"&&typeof module<"u"?e(exports):(pe=typeof globalThis<"u"?globalThis:pe||self,e(pe.marked={}))}(this,function(pe){"use strict";function e(ve,be){for(var De=0;De<be.length;De++){var oe=be[De];oe.enumerable=oe.enumerable||!1,oe.configurable=!0,"value"in oe&&(oe.writable=!0),Object.defineProperty(ve,oe.key,oe)}}function y(ve,be,De){return be&&e(ve.prototype,be),De&&e(ve,De),Object.defineProperty(ve,"prototype",{writable:!1}),ve}function R(ve,be){if(ve){if(typeof ve=="string")return C(ve,be);var De=Object.prototype.toString.call(ve).slice(8,-1);if(De==="Object"&&ve.constructor&&(De=ve.constructor.name),De==="Map"||De==="Set")return Array.from(ve);if(De==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(De))return C(ve,be)}}function C(ve,be){(be==null||be>ve.length)&&(be=ve.length);for(var De=0,oe=new Array(be);De<be;De++)oe[De]=ve[De];return oe}function L(ve,be){var De=typeof Symbol<"u"&&ve[Symbol.iterator]||ve["@@iterator"];if(De)return(De=De.call(ve)).next.bind(De);if(Array.isArray(ve)||(De=R(ve))||be&&ve&&typeof ve.length=="number"){De&&(ve=De);var oe=0;return function(){return oe>=ve.length?{done:!0}:{done:!1,value:ve[oe++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function A(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}pe.defaults=A();function h(ve){pe.defaults=ve}var S=/[&<>"']/,g=/[&<>"']/g,P=/[<>"']|&(?!#?\w+;)/,D=/[<>"']|&(?!#?\w+;)/g,u={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},p=function(be){return u[be]};function $(ve,be){if(be){if(S.test(ve))return ve.replace(g,p)}else if(P.test(ve))return ve.replace(D,p);return ve}var d=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function t(ve){return ve.replace(d,function(be,De){return De=De.toLowerCase(),De==="colon"?":":De.charAt(0)==="#"?De.charAt(1)==="x"?String.fromCharCode(parseInt(De.substring(2),16)):String.fromCharCode(+De.substring(1)):""})}var i=/(^|[^\[])\^/g;function c(ve,be){ve=typeof ve=="string"?ve:ve.source,be=be||"";var De={replace:function(de,se){return se=se.source||se,se=se.replace(i,"$1"),ve=ve.replace(de,se),De},getRegex:function(){return new RegExp(ve,be)}};return De}var m=/[^\w:]/g,E=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function b(ve,be,De){if(ve){var oe;try{oe=decodeURIComponent(t(De)).replace(m,"").toLowerCase()}catch{return null}if(oe.indexOf("javascript:")===0||oe.indexOf("vbscript:")===0||oe.indexOf("data:")===0)return null}be&&!E.test(De)&&(De=w(be,De));try{De=encodeURI(De).replace(/%25/g,"%")}catch{return null}return De}var n={},a=/^[^:]+:\/*[^/]*$/,s=/^([^:]+:)[\s\S]*$/,o=/^([^:]+:\/*[^/]*)[\s\S]*$/;function w(ve,be){n[" "+ve]||(a.test(ve)?n[" "+ve]=ve+"/":n[" "+ve]=r(ve,"/",!0)),ve=n[" "+ve];var De=ve.indexOf(":")===-1;return be.substring(0,2)==="//"?De?be:ve.replace(s,"$1")+be:be.charAt(0)==="/"?De?be:ve.replace(o,"$1")+be:ve+be}var v={exec:function(){}};function I(ve){for(var be=1,De,oe;be<arguments.length;be++){De=arguments[be];for(oe in De)Object.prototype.hasOwnProperty.call(De,oe)&&(ve[oe]=De[oe])}return ve}function k(ve,be){var De=ve.replace(/\|/g,function(se,ne,me){for(var Ce=!1,M=ne;--M>=0&&me[M]==="\\";)Ce=!Ce;return Ce?"|":" |"}),oe=De.split(/ \|/),de=0;if(oe[0].trim()||oe.shift(),oe.length>0&&!oe[oe.length-1].trim()&&oe.pop(),oe.length>be)oe.splice(be);else for(;oe.length<be;)oe.push("");for(;de<oe.length;de++)oe[de]=oe[de].trim().replace(/\\\|/g,"|");return oe}function r(ve,be,De){var oe=ve.length;if(oe===0)return"";for(var de=0;de<oe;){var se=ve.charAt(oe-de-1);if(se===be&&!De)de++;else if(se!==be&&De)de++;else break}return ve.slice(0,oe-de)}function l(ve,be){if(ve.indexOf(be[1])===-1)return-1;for(var De=ve.length,oe=0,de=0;de<De;de++)if(ve[de]==="\\")de++;else if(ve[de]===be[0])oe++;else if(ve[de]===be[1]&&(oe--,oe<0))return de;return-1}function f(ve){ve&&ve.sanitize&&!ve.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function F(ve,be){if(be<1)return"";for(var De="";be>1;)be&1&&(De+=ve),be>>=1,ve+=ve;return De+ve}function W(ve,be,De,oe){var de=be.href,se=be.title?$(be.title):null,ne=ve[1].replace(/\\([\[\]])/g,"$1");if(ve[0].charAt(0)!=="!"){oe.state.inLink=!0;var me={type:"link",raw:De,href:de,title:se,text:ne,tokens:oe.inlineTokens(ne)};return oe.state.inLink=!1,me}return{type:"image",raw:De,href:de,title:se,text:$(ne)}}function V(ve,be){var De=ve.match(/^(\s+)(?:```)/);if(De===null)return be;var oe=De[1];return be.split(`
`).map(function(de){var se=de.match(/^\s+/);if(se===null)return de;var ne=se[0];return ne.length>=oe.length?de.slice(oe.length):de}).join(`
`)}var B=function(){function ve(De){this.options=De||pe.defaults}var be=ve.prototype;return be.space=function(oe){var de=this.rules.block.newline.exec(oe);if(de&&de[0].length>0)return{type:"space",raw:de[0]}},be.code=function(oe){var de=this.rules.block.code.exec(oe);if(de){var se=de[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:de[0],codeBlockStyle:"indented",text:this.options.pedantic?se:r(se,`
`)}}},be.fences=function(oe){var de=this.rules.block.fences.exec(oe);if(de){var se=de[0],ne=V(se,de[3]||"");return{type:"code",raw:se,lang:de[2]?de[2].trim():de[2],text:ne}}},be.heading=function(oe){var de=this.rules.block.heading.exec(oe);if(de){var se=de[2].trim();if(/#$/.test(se)){var ne=r(se,"#");(this.options.pedantic||!ne||/ $/.test(ne))&&(se=ne.trim())}return{type:"heading",raw:de[0],depth:de[1].length,text:se,tokens:this.lexer.inline(se)}}},be.hr=function(oe){var de=this.rules.block.hr.exec(oe);if(de)return{type:"hr",raw:de[0]}},be.blockquote=function(oe){var de=this.rules.block.blockquote.exec(oe);if(de){var se=de[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:de[0],tokens:this.lexer.blockTokens(se,[]),text:se}}},be.list=function(oe){var de=this.rules.block.list.exec(oe);if(de){var se,ne,me,Ce,M,q,H,Z,K,ee,ce,ze,Ue=de[1].trim(),Ze=Ue.length>1,He={type:"list",raw:"",ordered:Ze,start:Ze?+Ue.slice(0,-1):"",loose:!1,items:[]};Ue=Ze?"\\d{1,9}\\"+Ue.slice(-1):"\\"+Ue,this.options.pedantic&&(Ue=Ze?Ue:"[*+-]");for(var et=new RegExp("^( {0,3}"+Ue+")((?:[	 ][^\\n]*)?(?:\\n|$))");oe&&(ze=!1,!(!(de=et.exec(oe))||this.rules.block.hr.test(oe)));){if(se=de[0],oe=oe.substring(se.length),Z=de[2].split(`
`,1)[0],K=oe.split(`
`,1)[0],this.options.pedantic?(Ce=2,ce=Z.trimLeft()):(Ce=de[2].search(/[^ ]/),Ce=Ce>4?1:Ce,ce=Z.slice(Ce),Ce+=de[1].length),q=!1,!Z&&/^ *$/.test(K)&&(se+=K+`
`,oe=oe.substring(K.length+1),ze=!0),!ze)for(var Ye=new RegExp("^ {0,"+Math.min(3,Ce-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),_e=new RegExp("^ {0,"+Math.min(3,Ce-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),it=new RegExp("^ {0,"+Math.min(3,Ce-1)+"}(?:```|~~~)"),tt=new RegExp("^ {0,"+Math.min(3,Ce-1)+"}#");oe&&(ee=oe.split(`
`,1)[0],Z=ee,this.options.pedantic&&(Z=Z.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(it.test(Z)||tt.test(Z)||Ye.test(Z)||_e.test(oe)));){if(Z.search(/[^ ]/)>=Ce||!Z.trim())ce+=`
`+Z.slice(Ce);else if(!q)ce+=`
`+Z;else break;!q&&!Z.trim()&&(q=!0),se+=ee+`
`,oe=oe.substring(ee.length+1)}He.loose||(H?He.loose=!0:/\n *\n *$/.test(se)&&(H=!0)),this.options.gfm&&(ne=/^\[[ xX]\] /.exec(ce),ne&&(me=ne[0]!=="[ ] ",ce=ce.replace(/^\[[ xX]\] +/,""))),He.items.push({type:"list_item",raw:se,task:!!ne,checked:me,loose:!1,text:ce}),He.raw+=se}He.items[He.items.length-1].raw=se.trimRight(),He.items[He.items.length-1].text=ce.trimRight(),He.raw=He.raw.trimRight();var Ne=He.items.length;for(M=0;M<Ne;M++){this.lexer.state.top=!1,He.items[M].tokens=this.lexer.blockTokens(He.items[M].text,[]);var st=He.items[M].tokens.filter(function(Q){return Q.type==="space"}),_=st.every(function(Q){for(var $e=Q.raw.split(""),je=0,Oe=L($e),Qe;!(Qe=Oe()).done;){var nt=Qe.value;if(nt===`
`&&(je+=1),je>1)return!0}return!1});!He.loose&&st.length&&_&&(He.loose=!0,He.items[M].loose=!0)}return He}},be.html=function(oe){var de=this.rules.block.html.exec(oe);if(de){var se={type:"html",raw:de[0],pre:!this.options.sanitizer&&(de[1]==="pre"||de[1]==="script"||de[1]==="style"),text:de[0]};if(this.options.sanitize){var ne=this.options.sanitizer?this.options.sanitizer(de[0]):$(de[0]);se.type="paragraph",se.text=ne,se.tokens=this.lexer.inline(ne)}return se}},be.def=function(oe){var de=this.rules.block.def.exec(oe);if(de){de[3]&&(de[3]=de[3].substring(1,de[3].length-1));var se=de[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:se,raw:de[0],href:de[2],title:de[3]}}},be.table=function(oe){var de=this.rules.block.table.exec(oe);if(de){var se={type:"table",header:k(de[1]).map(function(H){return{text:H}}),align:de[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:de[3]&&de[3].trim()?de[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(se.header.length===se.align.length){se.raw=de[0];var ne=se.align.length,me,Ce,M,q;for(me=0;me<ne;me++)/^ *-+: *$/.test(se.align[me])?se.align[me]="right":/^ *:-+: *$/.test(se.align[me])?se.align[me]="center":/^ *:-+ *$/.test(se.align[me])?se.align[me]="left":se.align[me]=null;for(ne=se.rows.length,me=0;me<ne;me++)se.rows[me]=k(se.rows[me],se.header.length).map(function(H){return{text:H}});for(ne=se.header.length,Ce=0;Ce<ne;Ce++)se.header[Ce].tokens=this.lexer.inline(se.header[Ce].text);for(ne=se.rows.length,Ce=0;Ce<ne;Ce++)for(q=se.rows[Ce],M=0;M<q.length;M++)q[M].tokens=this.lexer.inline(q[M].text);return se}}},be.lheading=function(oe){var de=this.rules.block.lheading.exec(oe);if(de)return{type:"heading",raw:de[0],depth:de[2].charAt(0)==="="?1:2,text:de[1],tokens:this.lexer.inline(de[1])}},be.paragraph=function(oe){var de=this.rules.block.paragraph.exec(oe);if(de){var se=de[1].charAt(de[1].length-1)===`
`?de[1].slice(0,-1):de[1];return{type:"paragraph",raw:de[0],text:se,tokens:this.lexer.inline(se)}}},be.text=function(oe){var de=this.rules.block.text.exec(oe);if(de)return{type:"text",raw:de[0],text:de[0],tokens:this.lexer.inline(de[0])}},be.escape=function(oe){var de=this.rules.inline.escape.exec(oe);if(de)return{type:"escape",raw:de[0],text:$(de[1])}},be.tag=function(oe){var de=this.rules.inline.tag.exec(oe);if(de)return!this.lexer.state.inLink&&/^<a /i.test(de[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(de[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(de[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(de[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:de[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(de[0]):$(de[0]):de[0]}},be.link=function(oe){var de=this.rules.inline.link.exec(oe);if(de){var se=de[2].trim();if(!this.options.pedantic&&/^</.test(se)){if(!/>$/.test(se))return;var ne=r(se.slice(0,-1),"\\");if((se.length-ne.length)%2===0)return}else{var me=l(de[2],"()");if(me>-1){var Ce=de[0].indexOf("!")===0?5:4,M=Ce+de[1].length+me;de[2]=de[2].substring(0,me),de[0]=de[0].substring(0,M).trim(),de[3]=""}}var q=de[2],H="";if(this.options.pedantic){var Z=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(q);Z&&(q=Z[1],H=Z[3])}else H=de[3]?de[3].slice(1,-1):"";return q=q.trim(),/^</.test(q)&&(this.options.pedantic&&!/>$/.test(se)?q=q.slice(1):q=q.slice(1,-1)),W(de,{href:q&&q.replace(this.rules.inline._escapes,"$1"),title:H&&H.replace(this.rules.inline._escapes,"$1")},de[0],this.lexer)}},be.reflink=function(oe,de){var se;if((se=this.rules.inline.reflink.exec(oe))||(se=this.rules.inline.nolink.exec(oe))){var ne=(se[2]||se[1]).replace(/\s+/g," ");if(ne=de[ne.toLowerCase()],!ne||!ne.href){var me=se[0].charAt(0);return{type:"text",raw:me,text:me}}return W(se,ne,se[0],this.lexer)}},be.emStrong=function(oe,de,se){se===void 0&&(se="");var ne=this.rules.inline.emStrong.lDelim.exec(oe);if(ne&&!(ne[3]&&se.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var me=ne[1]||ne[2]||"";if(!me||me&&(se===""||this.rules.inline.punctuation.exec(se))){var Ce=ne[0].length-1,M,q,H=Ce,Z=0,K=ne[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(K.lastIndex=0,de=de.slice(-1*oe.length+Ce);(ne=K.exec(de))!=null;)if(M=ne[1]||ne[2]||ne[3]||ne[4]||ne[5]||ne[6],!!M){if(q=M.length,ne[3]||ne[4]){H+=q;continue}else if((ne[5]||ne[6])&&Ce%3&&!((Ce+q)%3)){Z+=q;continue}if(H-=q,!(H>0)){if(q=Math.min(q,q+H+Z),Math.min(Ce,q)%2){var ee=oe.slice(1,Ce+ne.index+q);return{type:"em",raw:oe.slice(0,Ce+ne.index+q+1),text:ee,tokens:this.lexer.inlineTokens(ee)}}var ce=oe.slice(2,Ce+ne.index+q-1);return{type:"strong",raw:oe.slice(0,Ce+ne.index+q+1),text:ce,tokens:this.lexer.inlineTokens(ce)}}}}}},be.codespan=function(oe){var de=this.rules.inline.code.exec(oe);if(de){var se=de[2].replace(/\n/g," "),ne=/[^ ]/.test(se),me=/^ /.test(se)&&/ $/.test(se);return ne&&me&&(se=se.substring(1,se.length-1)),se=$(se,!0),{type:"codespan",raw:de[0],text:se}}},be.br=function(oe){var de=this.rules.inline.br.exec(oe);if(de)return{type:"br",raw:de[0]}},be.del=function(oe){var de=this.rules.inline.del.exec(oe);if(de)return{type:"del",raw:de[0],text:de[2],tokens:this.lexer.inlineTokens(de[2])}},be.autolink=function(oe,de){var se=this.rules.inline.autolink.exec(oe);if(se){var ne,me;return se[2]==="@"?(ne=$(this.options.mangle?de(se[1]):se[1]),me="mailto:"+ne):(ne=$(se[1]),me=ne),{type:"link",raw:se[0],text:ne,href:me,tokens:[{type:"text",raw:ne,text:ne}]}}},be.url=function(oe,de){var se;if(se=this.rules.inline.url.exec(oe)){var ne,me;if(se[2]==="@")ne=$(this.options.mangle?de(se[0]):se[0]),me="mailto:"+ne;else{var Ce;do Ce=se[0],se[0]=this.rules.inline._backpedal.exec(se[0])[0];while(Ce!==se[0]);ne=$(se[0]),se[1]==="www."?me="http://"+ne:me=ne}return{type:"link",raw:se[0],text:ne,href:me,tokens:[{type:"text",raw:ne,text:ne}]}}},be.inlineText=function(oe,de){var se=this.rules.inline.text.exec(oe);if(se){var ne;return this.lexer.state.inRawBlock?ne=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(se[0]):$(se[0]):se[0]:ne=$(this.options.smartypants?de(se[0]):se[0]),{type:"text",raw:se[0],text:ne}}},ve}(),j={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:v,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};j._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,j._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,j.def=c(j.def).replace("label",j._label).replace("title",j._title).getRegex(),j.bullet=/(?:[*+-]|\d{1,9}[.)])/,j.listItemStart=c(/^( *)(bull) */).replace("bull",j.bullet).getRegex(),j.list=c(j.list).replace(/bull/g,j.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+j.def.source+")").getRegex(),j._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",j._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,j.html=c(j.html,"i").replace("comment",j._comment).replace("tag",j._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),j.paragraph=c(j._paragraph).replace("hr",j.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",j._tag).getRegex(),j.blockquote=c(j.blockquote).replace("paragraph",j.paragraph).getRegex(),j.normal=I({},j),j.gfm=I({},j.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),j.gfm.table=c(j.gfm.table).replace("hr",j.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",j._tag).getRegex(),j.gfm.paragraph=c(j._paragraph).replace("hr",j.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",j.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",j._tag).getRegex(),j.pedantic=I({},j.normal,{html:c(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",j._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:v,paragraph:c(j.normal._paragraph).replace("hr",j.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",j.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var U={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:v,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:v,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};U._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",U.punctuation=c(U.punctuation).replace(/punctuation/g,U._punctuation).getRegex(),U.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,U.escapedEmSt=/\\\*|\\_/g,U._comment=c(j._comment).replace("(?:-->|$)","-->").getRegex(),U.emStrong.lDelim=c(U.emStrong.lDelim).replace(/punct/g,U._punctuation).getRegex(),U.emStrong.rDelimAst=c(U.emStrong.rDelimAst,"g").replace(/punct/g,U._punctuation).getRegex(),U.emStrong.rDelimUnd=c(U.emStrong.rDelimUnd,"g").replace(/punct/g,U._punctuation).getRegex(),U._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,U._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,U._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,U.autolink=c(U.autolink).replace("scheme",U._scheme).replace("email",U._email).getRegex(),U._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,U.tag=c(U.tag).replace("comment",U._comment).replace("attribute",U._attribute).getRegex(),U._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,U._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,U._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,U.link=c(U.link).replace("label",U._label).replace("href",U._href).replace("title",U._title).getRegex(),U.reflink=c(U.reflink).replace("label",U._label).replace("ref",j._label).getRegex(),U.nolink=c(U.nolink).replace("ref",j._label).getRegex(),U.reflinkSearch=c(U.reflinkSearch,"g").replace("reflink",U.reflink).replace("nolink",U.nolink).getRegex(),U.normal=I({},U),U.pedantic=I({},U.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:c(/^!?\[(label)\]\((.*?)\)/).replace("label",U._label).getRegex(),reflink:c(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",U._label).getRegex()}),U.gfm=I({},U.normal,{escape:c(U.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),U.gfm.url=c(U.gfm.url,"i").replace("email",U.gfm._extended_email).getRegex(),U.breaks=I({},U.gfm,{br:c(U.br).replace("{2,}","*").getRegex(),text:c(U.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function z(ve){return ve.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function ie(ve){var be="",De,oe,de=ve.length;for(De=0;De<de;De++)oe=ve.charCodeAt(De),Math.random()>.5&&(oe="x"+oe.toString(16)),be+="&#"+oe+";";return be}var Y=function(){function ve(De){this.tokens=[],this.tokens.links=Object.create(null),this.options=De||pe.defaults,this.options.tokenizer=this.options.tokenizer||new B,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var oe={block:j.normal,inline:U.normal};this.options.pedantic?(oe.block=j.pedantic,oe.inline=U.pedantic):this.options.gfm&&(oe.block=j.gfm,this.options.breaks?oe.inline=U.breaks:oe.inline=U.gfm),this.tokenizer.rules=oe}ve.lex=function(oe,de){var se=new ve(de);return se.lex(oe)},ve.lexInline=function(oe,de){var se=new ve(de);return se.inlineTokens(oe)};var be=ve.prototype;return be.lex=function(oe){oe=oe.replace(/\r\n|\r/g,`
`),this.blockTokens(oe,this.tokens);for(var de;de=this.inlineQueue.shift();)this.inlineTokens(de.src,de.tokens);return this.tokens},be.blockTokens=function(oe,de){var se=this;de===void 0&&(de=[]),this.options.pedantic?oe=oe.replace(/\t/g,"    ").replace(/^ +$/gm,""):oe=oe.replace(/^( *)(\t+)/gm,function(H,Z,K){return Z+"    ".repeat(K.length)});for(var ne,me,Ce,M;oe;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(H){return(ne=H.call({lexer:se},oe,de))?(oe=oe.substring(ne.raw.length),de.push(ne),!0):!1}))){if(ne=this.tokenizer.space(oe)){oe=oe.substring(ne.raw.length),ne.raw.length===1&&de.length>0?de[de.length-1].raw+=`
`:de.push(ne);continue}if(ne=this.tokenizer.code(oe)){oe=oe.substring(ne.raw.length),me=de[de.length-1],me&&(me.type==="paragraph"||me.type==="text")?(me.raw+=`
`+ne.raw,me.text+=`
`+ne.text,this.inlineQueue[this.inlineQueue.length-1].src=me.text):de.push(ne);continue}if(ne=this.tokenizer.fences(oe)){oe=oe.substring(ne.raw.length),de.push(ne);continue}if(ne=this.tokenizer.heading(oe)){oe=oe.substring(ne.raw.length),de.push(ne);continue}if(ne=this.tokenizer.hr(oe)){oe=oe.substring(ne.raw.length),de.push(ne);continue}if(ne=this.tokenizer.blockquote(oe)){oe=oe.substring(ne.raw.length),de.push(ne);continue}if(ne=this.tokenizer.list(oe)){oe=oe.substring(ne.raw.length),de.push(ne);continue}if(ne=this.tokenizer.html(oe)){oe=oe.substring(ne.raw.length),de.push(ne);continue}if(ne=this.tokenizer.def(oe)){oe=oe.substring(ne.raw.length),me=de[de.length-1],me&&(me.type==="paragraph"||me.type==="text")?(me.raw+=`
`+ne.raw,me.text+=`
`+ne.raw,this.inlineQueue[this.inlineQueue.length-1].src=me.text):this.tokens.links[ne.tag]||(this.tokens.links[ne.tag]={href:ne.href,title:ne.title});continue}if(ne=this.tokenizer.table(oe)){oe=oe.substring(ne.raw.length),de.push(ne);continue}if(ne=this.tokenizer.lheading(oe)){oe=oe.substring(ne.raw.length),de.push(ne);continue}if(Ce=oe,this.options.extensions&&this.options.extensions.startBlock&&function(){var H=1/0,Z=oe.slice(1),K=void 0;se.options.extensions.startBlock.forEach(function(ee){K=ee.call({lexer:this},Z),typeof K=="number"&&K>=0&&(H=Math.min(H,K))}),H<1/0&&H>=0&&(Ce=oe.substring(0,H+1))}(),this.state.top&&(ne=this.tokenizer.paragraph(Ce))){me=de[de.length-1],M&&me.type==="paragraph"?(me.raw+=`
`+ne.raw,me.text+=`
`+ne.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=me.text):de.push(ne),M=Ce.length!==oe.length,oe=oe.substring(ne.raw.length);continue}if(ne=this.tokenizer.text(oe)){oe=oe.substring(ne.raw.length),me=de[de.length-1],me&&me.type==="text"?(me.raw+=`
`+ne.raw,me.text+=`
`+ne.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=me.text):de.push(ne);continue}if(oe){var q="Infinite loop on byte: "+oe.charCodeAt(0);if(this.options.silent){console.error(q);break}else throw new Error(q)}}return this.state.top=!0,de},be.inline=function(oe,de){return de===void 0&&(de=[]),this.inlineQueue.push({src:oe,tokens:de}),de},be.inlineTokens=function(oe,de){var se=this;de===void 0&&(de=[]);var ne,me,Ce,M=oe,q,H,Z;if(this.tokens.links){var K=Object.keys(this.tokens.links);if(K.length>0)for(;(q=this.tokenizer.rules.inline.reflinkSearch.exec(M))!=null;)K.includes(q[0].slice(q[0].lastIndexOf("[")+1,-1))&&(M=M.slice(0,q.index)+"["+F("a",q[0].length-2)+"]"+M.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(q=this.tokenizer.rules.inline.blockSkip.exec(M))!=null;)M=M.slice(0,q.index)+"["+F("a",q[0].length-2)+"]"+M.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(q=this.tokenizer.rules.inline.escapedEmSt.exec(M))!=null;)M=M.slice(0,q.index)+"++"+M.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;oe;)if(H||(Z=""),H=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(ce){return(ne=ce.call({lexer:se},oe,de))?(oe=oe.substring(ne.raw.length),de.push(ne),!0):!1}))){if(ne=this.tokenizer.escape(oe)){oe=oe.substring(ne.raw.length),de.push(ne);continue}if(ne=this.tokenizer.tag(oe)){oe=oe.substring(ne.raw.length),me=de[de.length-1],me&&ne.type==="text"&&me.type==="text"?(me.raw+=ne.raw,me.text+=ne.text):de.push(ne);continue}if(ne=this.tokenizer.link(oe)){oe=oe.substring(ne.raw.length),de.push(ne);continue}if(ne=this.tokenizer.reflink(oe,this.tokens.links)){oe=oe.substring(ne.raw.length),me=de[de.length-1],me&&ne.type==="text"&&me.type==="text"?(me.raw+=ne.raw,me.text+=ne.text):de.push(ne);continue}if(ne=this.tokenizer.emStrong(oe,M,Z)){oe=oe.substring(ne.raw.length),de.push(ne);continue}if(ne=this.tokenizer.codespan(oe)){oe=oe.substring(ne.raw.length),de.push(ne);continue}if(ne=this.tokenizer.br(oe)){oe=oe.substring(ne.raw.length),de.push(ne);continue}if(ne=this.tokenizer.del(oe)){oe=oe.substring(ne.raw.length),de.push(ne);continue}if(ne=this.tokenizer.autolink(oe,ie)){oe=oe.substring(ne.raw.length),de.push(ne);continue}if(!this.state.inLink&&(ne=this.tokenizer.url(oe,ie))){oe=oe.substring(ne.raw.length),de.push(ne);continue}if(Ce=oe,this.options.extensions&&this.options.extensions.startInline&&function(){var ce=1/0,ze=oe.slice(1),Ue=void 0;se.options.extensions.startInline.forEach(function(Ze){Ue=Ze.call({lexer:this},ze),typeof Ue=="number"&&Ue>=0&&(ce=Math.min(ce,Ue))}),ce<1/0&&ce>=0&&(Ce=oe.substring(0,ce+1))}(),ne=this.tokenizer.inlineText(Ce,z)){oe=oe.substring(ne.raw.length),ne.raw.slice(-1)!=="_"&&(Z=ne.raw.slice(-1)),H=!0,me=de[de.length-1],me&&me.type==="text"?(me.raw+=ne.raw,me.text+=ne.text):de.push(ne);continue}if(oe){var ee="Infinite loop on byte: "+oe.charCodeAt(0);if(this.options.silent){console.error(ee);break}else throw new Error(ee)}}return de},y(ve,null,[{key:"rules",get:function(){return{block:j,inline:U}}}]),ve}(),ye=function(){function ve(De){this.options=De||pe.defaults}var be=ve.prototype;return be.code=function(oe,de,se){var ne=(de||"").match(/\S*/)[0];if(this.options.highlight){var me=this.options.highlight(oe,ne);me!=null&&me!==oe&&(se=!0,oe=me)}return oe=oe.replace(/\n$/,"")+`
`,ne?'<pre><code class="'+this.options.langPrefix+$(ne,!0)+'">'+(se?oe:$(oe,!0))+`</code></pre>
`:"<pre><code>"+(se?oe:$(oe,!0))+`</code></pre>
`},be.blockquote=function(oe){return`<blockquote>
`+oe+`</blockquote>
`},be.html=function(oe){return oe},be.heading=function(oe,de,se,ne){if(this.options.headerIds){var me=this.options.headerPrefix+ne.slug(se);return"<h"+de+' id="'+me+'">'+oe+"</h"+de+`>
`}return"<h"+de+">"+oe+"</h"+de+`>
`},be.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},be.list=function(oe,de,se){var ne=de?"ol":"ul",me=de&&se!==1?' start="'+se+'"':"";return"<"+ne+me+`>
`+oe+"</"+ne+`>
`},be.listitem=function(oe){return"<li>"+oe+`</li>
`},be.checkbox=function(oe){return"<input "+(oe?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},be.paragraph=function(oe){return"<p>"+oe+`</p>
`},be.table=function(oe,de){return de&&(de="<tbody>"+de+"</tbody>"),`<table>
<thead>
`+oe+`</thead>
`+de+`</table>
`},be.tablerow=function(oe){return`<tr>
`+oe+`</tr>
`},be.tablecell=function(oe,de){var se=de.header?"th":"td",ne=de.align?"<"+se+' align="'+de.align+'">':"<"+se+">";return ne+oe+("</"+se+`>
`)},be.strong=function(oe){return"<strong>"+oe+"</strong>"},be.em=function(oe){return"<em>"+oe+"</em>"},be.codespan=function(oe){return"<code>"+oe+"</code>"},be.br=function(){return this.options.xhtml?"<br/>":"<br>"},be.del=function(oe){return"<del>"+oe+"</del>"},be.link=function(oe,de,se){if(oe=b(this.options.sanitize,this.options.baseUrl,oe),oe===null)return se;var ne='<a href="'+$(oe)+'"';return de&&(ne+=' title="'+de+'"'),ne+=">"+se+"</a>",ne},be.image=function(oe,de,se){if(oe=b(this.options.sanitize,this.options.baseUrl,oe),oe===null)return se;var ne='<img src="'+oe+'" alt="'+se+'"';return de&&(ne+=' title="'+de+'"'),ne+=this.options.xhtml?"/>":">",ne},be.text=function(oe){return oe},ve}(),ke=function(){function ve(){}var be=ve.prototype;return be.strong=function(oe){return oe},be.em=function(oe){return oe},be.codespan=function(oe){return oe},be.del=function(oe){return oe},be.html=function(oe){return oe},be.text=function(oe){return oe},be.link=function(oe,de,se){return""+se},be.image=function(oe,de,se){return""+se},be.br=function(){return""},ve}(),Re=function(){function ve(){this.seen={}}var be=ve.prototype;return be.serialize=function(oe){return oe.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},be.getNextSafeSlug=function(oe,de){var se=oe,ne=0;if(this.seen.hasOwnProperty(se)){ne=this.seen[oe];do ne++,se=oe+"-"+ne;while(this.seen.hasOwnProperty(se))}return de||(this.seen[oe]=ne,this.seen[se]=0),se},be.slug=function(oe,de){de===void 0&&(de={});var se=this.serialize(oe);return this.getNextSafeSlug(se,de.dryrun)},ve}(),X=function(){function ve(De){this.options=De||pe.defaults,this.options.renderer=this.options.renderer||new ye,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new ke,this.slugger=new Re}ve.parse=function(oe,de){var se=new ve(de);return se.parse(oe)},ve.parseInline=function(oe,de){var se=new ve(de);return se.parseInline(oe)};var be=ve.prototype;return be.parse=function(oe,de){de===void 0&&(de=!0);var se="",ne,me,Ce,M,q,H,Z,K,ee,ce,ze,Ue,Ze,He,et,Ye,_e,it,tt,Ne=oe.length;for(ne=0;ne<Ne;ne++){if(ce=oe[ne],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[ce.type]&&(tt=this.options.extensions.renderers[ce.type].call({parser:this},ce),tt!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(ce.type))){se+=tt||"";continue}switch(ce.type){case"space":continue;case"hr":{se+=this.renderer.hr();continue}case"heading":{se+=this.renderer.heading(this.parseInline(ce.tokens),ce.depth,t(this.parseInline(ce.tokens,this.textRenderer)),this.slugger);continue}case"code":{se+=this.renderer.code(ce.text,ce.lang,ce.escaped);continue}case"table":{for(K="",Z="",M=ce.header.length,me=0;me<M;me++)Z+=this.renderer.tablecell(this.parseInline(ce.header[me].tokens),{header:!0,align:ce.align[me]});for(K+=this.renderer.tablerow(Z),ee="",M=ce.rows.length,me=0;me<M;me++){for(H=ce.rows[me],Z="",q=H.length,Ce=0;Ce<q;Ce++)Z+=this.renderer.tablecell(this.parseInline(H[Ce].tokens),{header:!1,align:ce.align[Ce]});ee+=this.renderer.tablerow(Z)}se+=this.renderer.table(K,ee);continue}case"blockquote":{ee=this.parse(ce.tokens),se+=this.renderer.blockquote(ee);continue}case"list":{for(ze=ce.ordered,Ue=ce.start,Ze=ce.loose,M=ce.items.length,ee="",me=0;me<M;me++)et=ce.items[me],Ye=et.checked,_e=et.task,He="",et.task&&(it=this.renderer.checkbox(Ye),Ze?et.tokens.length>0&&et.tokens[0].type==="paragraph"?(et.tokens[0].text=it+" "+et.tokens[0].text,et.tokens[0].tokens&&et.tokens[0].tokens.length>0&&et.tokens[0].tokens[0].type==="text"&&(et.tokens[0].tokens[0].text=it+" "+et.tokens[0].tokens[0].text)):et.tokens.unshift({type:"text",text:it}):He+=it),He+=this.parse(et.tokens,Ze),ee+=this.renderer.listitem(He,_e,Ye);se+=this.renderer.list(ee,ze,Ue);continue}case"html":{se+=this.renderer.html(ce.text);continue}case"paragraph":{se+=this.renderer.paragraph(this.parseInline(ce.tokens));continue}case"text":{for(ee=ce.tokens?this.parseInline(ce.tokens):ce.text;ne+1<Ne&&oe[ne+1].type==="text";)ce=oe[++ne],ee+=`
`+(ce.tokens?this.parseInline(ce.tokens):ce.text);se+=de?this.renderer.paragraph(ee):ee;continue}default:{var st='Token with "'+ce.type+'" type was not found.';if(this.options.silent){console.error(st);return}else throw new Error(st)}}}return se},be.parseInline=function(oe,de){de=de||this.renderer;var se="",ne,me,Ce,M=oe.length;for(ne=0;ne<M;ne++){if(me=oe[ne],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[me.type]&&(Ce=this.options.extensions.renderers[me.type].call({parser:this},me),Ce!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(me.type))){se+=Ce||"";continue}switch(me.type){case"escape":{se+=de.text(me.text);break}case"html":{se+=de.html(me.text);break}case"link":{se+=de.link(me.href,me.title,this.parseInline(me.tokens,de));break}case"image":{se+=de.image(me.href,me.title,me.text);break}case"strong":{se+=de.strong(this.parseInline(me.tokens,de));break}case"em":{se+=de.em(this.parseInline(me.tokens,de));break}case"codespan":{se+=de.codespan(me.text);break}case"br":{se+=de.br();break}case"del":{se+=de.del(this.parseInline(me.tokens,de));break}case"text":{se+=de.text(me.text);break}default:{var q='Token with "'+me.type+'" type was not found.';if(this.options.silent){console.error(q);return}else throw new Error(q)}}}return se},ve}();function le(ve,be,De){if(typeof ve>"u"||ve===null)throw new Error("marked(): input parameter is undefined or null");if(typeof ve!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(ve)+", string expected");if(typeof be=="function"&&(De=be,be=null),be=I({},le.defaults,be||{}),f(be),De){var oe=be.highlight,de;try{de=Y.lex(ve,be)}catch(M){return De(M)}var se=function(q){var H;if(!q)try{be.walkTokens&&le.walkTokens(de,be.walkTokens),H=X.parse(de,be)}catch(Z){q=Z}return be.highlight=oe,q?De(q):De(null,H)};if(!oe||oe.length<3||(delete be.highlight,!de.length))return se();var ne=0;le.walkTokens(de,function(M){M.type==="code"&&(ne++,setTimeout(function(){oe(M.text,M.lang,function(q,H){if(q)return se(q);H!=null&&H!==M.text&&(M.text=H,M.escaped=!0),ne--,ne===0&&se()})},0))}),ne===0&&se();return}function me(M){if(M.message+=`
Please report this to https://github.com/markedjs/marked.`,be.silent)return"<p>An error occurred:</p><pre>"+$(M.message+"",!0)+"</pre>";throw M}try{var Ce=Y.lex(ve,be);if(be.walkTokens){if(be.async)return Promise.all(le.walkTokens(Ce,be.walkTokens)).then(function(){return X.parse(Ce,be)}).catch(me);le.walkTokens(Ce,be.walkTokens)}return X.parse(Ce,be)}catch(M){me(M)}}le.options=le.setOptions=function(ve){return I(le.defaults,ve),h(le.defaults),le},le.getDefaults=A,le.defaults=pe.defaults,le.use=function(){for(var ve=arguments.length,be=new Array(ve),De=0;De<ve;De++)be[De]=arguments[De];var oe=I.apply(void 0,[{}].concat(be)),de=le.defaults.extensions||{renderers:{},childTokens:{}},se;be.forEach(function(ne){if(ne.extensions&&(se=!0,ne.extensions.forEach(function(Ce){if(!Ce.name)throw new Error("extension name required");if(Ce.renderer){var M=de.renderers?de.renderers[Ce.name]:null;M?de.renderers[Ce.name]=function(){for(var q=arguments.length,H=new Array(q),Z=0;Z<q;Z++)H[Z]=arguments[Z];var K=Ce.renderer.apply(this,H);return K===!1&&(K=M.apply(this,H)),K}:de.renderers[Ce.name]=Ce.renderer}if(Ce.tokenizer){if(!Ce.level||Ce.level!=="block"&&Ce.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");de[Ce.level]?de[Ce.level].unshift(Ce.tokenizer):de[Ce.level]=[Ce.tokenizer],Ce.start&&(Ce.level==="block"?de.startBlock?de.startBlock.push(Ce.start):de.startBlock=[Ce.start]:Ce.level==="inline"&&(de.startInline?de.startInline.push(Ce.start):de.startInline=[Ce.start]))}Ce.childTokens&&(de.childTokens[Ce.name]=Ce.childTokens)})),ne.renderer&&function(){var Ce=le.defaults.renderer||new ye,M=function(Z){var K=Ce[Z];Ce[Z]=function(){for(var ee=arguments.length,ce=new Array(ee),ze=0;ze<ee;ze++)ce[ze]=arguments[ze];var Ue=ne.renderer[Z].apply(Ce,ce);return Ue===!1&&(Ue=K.apply(Ce,ce)),Ue}};for(var q in ne.renderer)M(q);oe.renderer=Ce}(),ne.tokenizer&&function(){var Ce=le.defaults.tokenizer||new B,M=function(Z){var K=Ce[Z];Ce[Z]=function(){for(var ee=arguments.length,ce=new Array(ee),ze=0;ze<ee;ze++)ce[ze]=arguments[ze];var Ue=ne.tokenizer[Z].apply(Ce,ce);return Ue===!1&&(Ue=K.apply(Ce,ce)),Ue}};for(var q in ne.tokenizer)M(q);oe.tokenizer=Ce}(),ne.walkTokens){var me=le.defaults.walkTokens;oe.walkTokens=function(Ce){var M=[];return M.push(ne.walkTokens.call(this,Ce)),me&&(M=M.concat(me.call(this,Ce))),M}}se&&(oe.extensions=de),le.setOptions(oe)})},le.walkTokens=function(ve,be){for(var De=[],oe=function(){var me=se.value;switch(De=De.concat(be.call(le,me)),me.type){case"table":{for(var Ce=L(me.header),M;!(M=Ce()).done;){var q=M.value;De=De.concat(le.walkTokens(q.tokens,be))}for(var H=L(me.rows),Z;!(Z=H()).done;)for(var K=Z.value,ee=L(K),ce;!(ce=ee()).done;){var ze=ce.value;De=De.concat(le.walkTokens(ze.tokens,be))}break}case"list":{De=De.concat(le.walkTokens(me.items,be));break}default:le.defaults.extensions&&le.defaults.extensions.childTokens&&le.defaults.extensions.childTokens[me.type]?le.defaults.extensions.childTokens[me.type].forEach(function(Ue){De=De.concat(le.walkTokens(me[Ue],be))}):me.tokens&&(De=De.concat(le.walkTokens(me.tokens,be)))}},de=L(ve),se;!(se=de()).done;)oe();return De},le.parseInline=function(ve,be){if(typeof ve>"u"||ve===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof ve!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(ve)+", string expected");be=I({},le.defaults,be||{}),f(be);try{var De=Y.lexInline(ve,be);return be.walkTokens&&le.walkTokens(De,be.walkTokens),X.parseInline(De,be)}catch(oe){if(oe.message+=`
Please report this to https://github.com/markedjs/marked.`,be.silent)return"<p>An error occurred:</p><pre>"+$(oe.message+"",!0)+"</pre>";throw oe}},le.Parser=X,le.parser=X.parse,le.Renderer=ye,le.TextRenderer=ke,le.Lexer=Y,le.lexer=Y.lex,le.Tokenizer=B,le.Slugger=Re,le.parse=le;var we=le.options,ae=le.setOptions,x=le.use,ue=le.walkTokens,O=le.parseInline,J=le,he=X.parse,Ee=Y.lex;pe.Lexer=Y,pe.Parser=X,pe.Renderer=ye,pe.Slugger=Re,pe.TextRenderer=ke,pe.Tokenizer=B,pe.getDefaults=A,pe.lexer=Ee,pe.marked=le,pe.options=we,pe.parse=J,pe.parseInline=O,pe.parser=he,pe.setOptions=ae,pe.use=x,pe.walkTokens=ue,Object.defineProperty(pe,"__esModule",{value:!0})}),define(Pe[118],Ae([1,0]),function(pe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jl=e.$Il=e.$Hl=e.rot=e.$Fl=void 0;function y(h,S,g){return Math.min(Math.max(h,S),g)}e.$Fl=y;function R(h,S){return(S+h%S)%S}e.rot=R;class C{constructor(){this.a=0}getNext(){return this.a++}}e.$Hl=C;class L{constructor(){this.a=1,this.b=0}update(S){return this.b=this.b+(S-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.$Il=L;class A{constructor(S){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(S),this.c.fill(0,0,S)}update(S){const g=this.c[this.d];return this.c[this.d]=S,this.d=(this.d+1)%this.c.length,this.e-=g,this.e+=S,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.$Jl=A}),function(){function pe(C){const L=[];typeof C=="number"&&L.push("code/timeOrigin",C);function A(S){L.push(S,Date.now())}function h(){const S=[];for(let g=0;g<L.length;g+=2)S.push({name:L[g],startTime:L[g+1]});return S}return{mark:A,getMarks:h}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?pe():{mark(C){performance.mark(C)},getMarks(){let C=performance.timeOrigin;typeof C!="number"&&(C=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const L=[{name:"code/timeOrigin",startTime:Math.round(C)}];for(const A of performance.getEntriesByType("mark"))L.push({name:A.name,startTime:Math.round(C+A.startTime)});return L}};if(typeof process=="object"){const C=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return pe(C)}else return console.trace("perf-util loaded in UNKNOWN environment"),pe()}function y(C){return C.MonacoPerformanceMarks||(C.MonacoPerformanceMarks=e()),C.MonacoPerformanceMarks}var R;typeof global=="object"?R=global:typeof self=="object"?R=self:R={},typeof define=="function"?define("vs/base/common/performance",[],function(){return y(R)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=y(R):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),R.perf=y(R))}(),function(pe,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var y=e();for(var R in y)(typeof exports=="object"?exports:pe)[R]=y[R]}}(typeof self<"u"?self:this,function(){return function(pe){var e={};function y(R){if(e[R])return e[R].exports;var C=e[R]={i:R,l:!1,exports:{}};return pe[R].call(C.exports,C,C.exports,y),C.l=!0,C.exports}return y.m=pe,y.c=e,y.d=function(R,C,L){y.o(R,C)||Object.defineProperty(R,C,{enumerable:!0,get:L})},y.r=function(R){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(R,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(R,"__esModule",{value:!0})},y.t=function(R,C){if(1&C&&(R=y(R)),8&C||4&C&&typeof R=="object"&&R&&R.__esModule)return R;var L=Object.create(null);if(y.r(L),Object.defineProperty(L,"default",{enumerable:!0,value:R}),2&C&&typeof R!="string")for(var A in R)y.d(L,A,function(h){return R[h]}.bind(null,A));return L},y.n=function(R){var C=R&&R.__esModule?function(){return R.default}:function(){return R};return y.d(C,"a",C),C},y.o=function(R,C){return Object.prototype.hasOwnProperty.call(R,C)},y.p="",y(y.s=0)}([function(pe,e,y){(function(R){var C;e=pe.exports=x,C=typeof R=="object"&&R.env&&R.env.NODE_DEBUG&&/\bsemver\b/i.test(R.env.NODE_DEBUG)?function(){var K=Array.prototype.slice.call(arguments,0);K.unshift("SEMVER"),console.log.apply(console,K)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var L=256,A=Number.MAX_SAFE_INTEGER||9007199254740991,h=e.re=[],S=e.src=[],g=0,P=g++;S[P]="0|[1-9]\\d*";var D=g++;S[D]="[0-9]+";var u=g++;S[u]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var p=g++;S[p]="("+S[P]+")\\.("+S[P]+")\\.("+S[P]+")";var $=g++;S[$]="("+S[D]+")\\.("+S[D]+")\\.("+S[D]+")";var d=g++;S[d]="(?:"+S[P]+"|"+S[u]+")";var t=g++;S[t]="(?:"+S[D]+"|"+S[u]+")";var i=g++;S[i]="(?:-("+S[d]+"(?:\\."+S[d]+")*))";var c=g++;S[c]="(?:-?("+S[t]+"(?:\\."+S[t]+")*))";var m=g++;S[m]="[0-9A-Za-z-]+";var E=g++;S[E]="(?:\\+("+S[m]+"(?:\\."+S[m]+")*))";var b=g++,n="v?"+S[p]+S[i]+"?"+S[E]+"?";S[b]="^"+n+"$";var a="[v=\\s]*"+S[$]+S[c]+"?"+S[E]+"?",s=g++;S[s]="^"+a+"$";var o=g++;S[o]="((?:<|>)?=?)";var w=g++;S[w]=S[D]+"|x|X|\\*";var v=g++;S[v]=S[P]+"|x|X|\\*";var I=g++;S[I]="[v=\\s]*("+S[v]+")(?:\\.("+S[v]+")(?:\\.("+S[v]+")(?:"+S[i]+")?"+S[E]+"?)?)?";var k=g++;S[k]="[v=\\s]*("+S[w]+")(?:\\.("+S[w]+")(?:\\.("+S[w]+")(?:"+S[c]+")?"+S[E]+"?)?)?";var r=g++;S[r]="^"+S[o]+"\\s*"+S[I]+"$";var l=g++;S[l]="^"+S[o]+"\\s*"+S[k]+"$";var f=g++;S[f]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var F=g++;S[F]="(?:~>?)";var W=g++;S[W]="(\\s*)"+S[F]+"\\s+",h[W]=new RegExp(S[W],"g");var V=g++;S[V]="^"+S[F]+S[I]+"$";var B=g++;S[B]="^"+S[F]+S[k]+"$";var j=g++;S[j]="(?:\\^)";var U=g++;S[U]="(\\s*)"+S[j]+"\\s+",h[U]=new RegExp(S[U],"g");var z=g++;S[z]="^"+S[j]+S[I]+"$";var ie=g++;S[ie]="^"+S[j]+S[k]+"$";var Y=g++;S[Y]="^"+S[o]+"\\s*("+a+")$|^$";var ye=g++;S[ye]="^"+S[o]+"\\s*("+n+")$|^$";var ke=g++;S[ke]="(\\s*)"+S[o]+"\\s*("+a+"|"+S[I]+")",h[ke]=new RegExp(S[ke],"g");var Re=g++;S[Re]="^\\s*("+S[I]+")\\s+-\\s+("+S[I]+")\\s*$";var X=g++;S[X]="^\\s*("+S[k]+")\\s+-\\s+("+S[k]+")\\s*$";var le=g++;S[le]="(<|>)?=?\\s*\\*";for(var we=0;we<35;we++)C(we,S[we]),h[we]||(h[we]=new RegExp(S[we]));function ae(K,ee){if(K instanceof x)return K;if(typeof K!="string"||K.length>L||!(ee?h[s]:h[b]).test(K))return null;try{return new x(K,ee)}catch{return null}}function x(K,ee){if(K instanceof x){if(K.loose===ee)return K;K=K.version}else if(typeof K!="string")throw new TypeError("Invalid Version: "+K);if(K.length>L)throw new TypeError("version is longer than "+L+" characters");if(!(this instanceof x))return new x(K,ee);C("SemVer",K,ee),this.loose=ee;var ce=K.trim().match(ee?h[s]:h[b]);if(!ce)throw new TypeError("Invalid Version: "+K);if(this.raw=K,this.major=+ce[1],this.minor=+ce[2],this.patch=+ce[3],this.major>A||this.major<0)throw new TypeError("Invalid major version");if(this.minor>A||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>A||this.patch<0)throw new TypeError("Invalid patch version");ce[4]?this.prerelease=ce[4].split(".").map(function(ze){if(/^[0-9]+$/.test(ze)){var Ue=+ze;if(Ue>=0&&Ue<A)return Ue}return ze}):this.prerelease=[],this.build=ce[5]?ce[5].split("."):[],this.format()}e.parse=ae,e.valid=function(K,ee){var ce=ae(K,ee);return ce?ce.version:null},e.clean=function(K,ee){var ce=ae(K.trim().replace(/^[=v]+/,""),ee);return ce?ce.version:null},e.SemVer=x,x.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},x.prototype.toString=function(){return this.version},x.prototype.compare=function(K){return C("SemVer.compare",this.version,this.loose,K),K instanceof x||(K=new x(K,this.loose)),this.compareMain(K)||this.comparePre(K)},x.prototype.compareMain=function(K){return K instanceof x||(K=new x(K,this.loose)),O(this.major,K.major)||O(this.minor,K.minor)||O(this.patch,K.patch)},x.prototype.comparePre=function(K){if(K instanceof x||(K=new x(K,this.loose)),this.prerelease.length&&!K.prerelease.length)return-1;if(!this.prerelease.length&&K.prerelease.length)return 1;if(!this.prerelease.length&&!K.prerelease.length)return 0;var ee=0;do{var ce=this.prerelease[ee],ze=K.prerelease[ee];if(C("prerelease compare",ee,ce,ze),ce===void 0&&ze===void 0)return 0;if(ze===void 0)return 1;if(ce===void 0)return-1;if(ce!==ze)return O(ce,ze)}while(++ee)},x.prototype.inc=function(K,ee){switch(K){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",ee);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",ee);break;case"prepatch":this.prerelease.length=0,this.inc("patch",ee),this.inc("pre",ee);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",ee),this.inc("pre",ee);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var ce=this.prerelease.length;--ce>=0;)typeof this.prerelease[ce]=="number"&&(this.prerelease[ce]++,ce=-2);ce===-1&&this.prerelease.push(0)}ee&&(this.prerelease[0]===ee?isNaN(this.prerelease[1])&&(this.prerelease=[ee,0]):this.prerelease=[ee,0]);break;default:throw new Error("invalid increment argument: "+K)}return this.format(),this.raw=this.version,this},e.inc=function(K,ee,ce,ze){typeof ce=="string"&&(ze=ce,ce=void 0);try{return new x(K,ce).inc(ee,ze).version}catch{return null}},e.diff=function(K,ee){if(ve(K,ee))return null;var ce=ae(K),ze=ae(ee);if(ce.prerelease.length||ze.prerelease.length){for(var Ue in ce)if((Ue==="major"||Ue==="minor"||Ue==="patch")&&ce[Ue]!==ze[Ue])return"pre"+Ue;return"prerelease"}for(var Ue in ce)if((Ue==="major"||Ue==="minor"||Ue==="patch")&&ce[Ue]!==ze[Ue])return Ue},e.compareIdentifiers=O;var ue=/^[0-9]+$/;function O(K,ee){var ce=ue.test(K),ze=ue.test(ee);return ce&&ze&&(K=+K,ee=+ee),ce&&!ze?-1:ze&&!ce?1:K<ee?-1:K>ee?1:0}function J(K,ee,ce){return new x(K,ce).compare(new x(ee,ce))}function he(K,ee,ce){return J(K,ee,ce)>0}function Ee(K,ee,ce){return J(K,ee,ce)<0}function ve(K,ee,ce){return J(K,ee,ce)===0}function be(K,ee,ce){return J(K,ee,ce)!==0}function De(K,ee,ce){return J(K,ee,ce)>=0}function oe(K,ee,ce){return J(K,ee,ce)<=0}function de(K,ee,ce,ze){var Ue;switch(ee){case"===":typeof K=="object"&&(K=K.version),typeof ce=="object"&&(ce=ce.version),Ue=K===ce;break;case"!==":typeof K=="object"&&(K=K.version),typeof ce=="object"&&(ce=ce.version),Ue=K!==ce;break;case"":case"=":case"==":Ue=ve(K,ce,ze);break;case"!=":Ue=be(K,ce,ze);break;case">":Ue=he(K,ce,ze);break;case">=":Ue=De(K,ce,ze);break;case"<":Ue=Ee(K,ce,ze);break;case"<=":Ue=oe(K,ce,ze);break;default:throw new TypeError("Invalid operator: "+ee)}return Ue}function se(K,ee){if(K instanceof se){if(K.loose===ee)return K;K=K.value}if(!(this instanceof se))return new se(K,ee);C("comparator",K,ee),this.loose=ee,this.parse(K),this.semver===ne?this.value="":this.value=this.operator+this.semver.version,C("comp",this)}e.rcompareIdentifiers=function(K,ee){return O(ee,K)},e.major=function(K,ee){return new x(K,ee).major},e.minor=function(K,ee){return new x(K,ee).minor},e.patch=function(K,ee){return new x(K,ee).patch},e.compare=J,e.compareLoose=function(K,ee){return J(K,ee,!0)},e.rcompare=function(K,ee,ce){return J(ee,K,ce)},e.sort=function(K,ee){return K.sort(function(ce,ze){return e.compare(ce,ze,ee)})},e.rsort=function(K,ee){return K.sort(function(ce,ze){return e.rcompare(ce,ze,ee)})},e.gt=he,e.lt=Ee,e.eq=ve,e.neq=be,e.gte=De,e.lte=oe,e.cmp=de,e.Comparator=se;var ne={};function me(K,ee){if(K instanceof me)return K.loose===ee?K:new me(K.raw,ee);if(K instanceof se)return new me(K.value,ee);if(!(this instanceof me))return new me(K,ee);if(this.loose=ee,this.raw=K,this.set=K.split(/\s*\|\|\s*/).map(function(ce){return this.parseRange(ce.trim())},this).filter(function(ce){return ce.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+K);this.format()}function Ce(K){return!K||K.toLowerCase()==="x"||K==="*"}function M(K,ee,ce,ze,Ue,Ze,He,et,Ye,_e,it,tt,Ne){return((ee=Ce(ce)?"":Ce(ze)?">="+ce+".0.0":Ce(Ue)?">="+ce+"."+ze+".0":">="+ee)+" "+(et=Ce(Ye)?"":Ce(_e)?"<"+(+Ye+1)+".0.0":Ce(it)?"<"+Ye+"."+(+_e+1)+".0":tt?"<="+Ye+"."+_e+"."+it+"-"+tt:"<="+et)).trim()}function q(K,ee){for(var ce=0;ce<K.length;ce++)if(!K[ce].test(ee))return!1;if(ee.prerelease.length){for(ce=0;ce<K.length;ce++)if(C(K[ce].semver),K[ce].semver!==ne&&K[ce].semver.prerelease.length>0){var ze=K[ce].semver;if(ze.major===ee.major&&ze.minor===ee.minor&&ze.patch===ee.patch)return!0}return!1}return!0}function H(K,ee,ce){try{ee=new me(ee,ce)}catch{return!1}return ee.test(K)}function Z(K,ee,ce,ze){var Ue,Ze,He,et,Ye;switch(K=new x(K,ze),ee=new me(ee,ze),ce){case">":Ue=he,Ze=oe,He=Ee,et=">",Ye=">=";break;case"<":Ue=Ee,Ze=De,He=he,et="<",Ye="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(H(K,ee,ze))return!1;for(var _e=0;_e<ee.set.length;++_e){var it=ee.set[_e],tt=null,Ne=null;if(it.forEach(function(st){st.semver===ne&&(st=new se(">=0.0.0")),tt=tt||st,Ne=Ne||st,Ue(st.semver,tt.semver,ze)?tt=st:He(st.semver,Ne.semver,ze)&&(Ne=st)}),tt.operator===et||tt.operator===Ye||(!Ne.operator||Ne.operator===et)&&Ze(K,Ne.semver)||Ne.operator===Ye&&He(K,Ne.semver))return!1}return!0}se.prototype.parse=function(K){var ee=this.loose?h[Y]:h[ye],ce=K.match(ee);if(!ce)throw new TypeError("Invalid comparator: "+K);this.operator=ce[1],this.operator==="="&&(this.operator=""),ce[2]?this.semver=new x(ce[2],this.loose):this.semver=ne},se.prototype.toString=function(){return this.value},se.prototype.test=function(K){return C("Comparator.test",K,this.loose),this.semver===ne||(typeof K=="string"&&(K=new x(K,this.loose)),de(K,this.operator,this.semver,this.loose))},se.prototype.intersects=function(K,ee){if(!(K instanceof se))throw new TypeError("a Comparator is required");var ce;if(this.operator==="")return ce=new me(K.value,ee),H(this.value,ce,ee);if(K.operator==="")return ce=new me(this.value,ee),H(K.semver,ce,ee);var ze=!(this.operator!==">="&&this.operator!==">"||K.operator!==">="&&K.operator!==">"),Ue=!(this.operator!=="<="&&this.operator!=="<"||K.operator!=="<="&&K.operator!=="<"),Ze=this.semver.version===K.semver.version,He=!(this.operator!==">="&&this.operator!=="<="||K.operator!==">="&&K.operator!=="<="),et=de(this.semver,"<",K.semver,ee)&&(this.operator===">="||this.operator===">")&&(K.operator==="<="||K.operator==="<"),Ye=de(this.semver,">",K.semver,ee)&&(this.operator==="<="||this.operator==="<")&&(K.operator===">="||K.operator===">");return ze||Ue||Ze&&He||et||Ye},e.Range=me,me.prototype.format=function(){return this.range=this.set.map(function(K){return K.join(" ").trim()}).join("||").trim(),this.range},me.prototype.toString=function(){return this.range},me.prototype.parseRange=function(K){var ee=this.loose;K=K.trim(),C("range",K,ee);var ce=ee?h[X]:h[Re];K=K.replace(ce,M),C("hyphen replace",K),K=K.replace(h[ke],"$1$2$3"),C("comparator trim",K,h[ke]),K=(K=(K=K.replace(h[W],"$1~")).replace(h[U],"$1^")).split(/\s+/).join(" ");var ze=ee?h[Y]:h[ye],Ue=K.split(" ").map(function(Ze){return function(He,et){return C("comp",He),He=function(Ye,_e){return Ye.trim().split(/\s+/).map(function(it){return function(tt,Ne){C("caret",tt,Ne);var st=Ne?h[ie]:h[z];return tt.replace(st,function(_,Q,$e,je,Oe){var Qe;return C("caret",tt,_,Q,$e,je,Oe),Ce(Q)?Qe="":Ce($e)?Qe=">="+Q+".0.0 <"+(+Q+1)+".0.0":Ce(je)?Qe=Q==="0"?">="+Q+"."+$e+".0 <"+Q+"."+(+$e+1)+".0":">="+Q+"."+$e+".0 <"+(+Q+1)+".0.0":Oe?(C("replaceCaret pr",Oe),Oe.charAt(0)!=="-"&&(Oe="-"+Oe),Qe=Q==="0"?$e==="0"?">="+Q+"."+$e+"."+je+Oe+" <"+Q+"."+$e+"."+(+je+1):">="+Q+"."+$e+"."+je+Oe+" <"+Q+"."+(+$e+1)+".0":">="+Q+"."+$e+"."+je+Oe+" <"+(+Q+1)+".0.0"):(C("no pr"),Qe=Q==="0"?$e==="0"?">="+Q+"."+$e+"."+je+" <"+Q+"."+$e+"."+(+je+1):">="+Q+"."+$e+"."+je+" <"+Q+"."+(+$e+1)+".0":">="+Q+"."+$e+"."+je+" <"+(+Q+1)+".0.0"),C("caret return",Qe),Qe})}(it,_e)}).join(" ")}(He,et),C("caret",He),He=function(Ye,_e){return Ye.trim().split(/\s+/).map(function(it){return function(tt,Ne){var st=Ne?h[B]:h[V];return tt.replace(st,function(_,Q,$e,je,Oe){var Qe;return C("tilde",tt,_,Q,$e,je,Oe),Ce(Q)?Qe="":Ce($e)?Qe=">="+Q+".0.0 <"+(+Q+1)+".0.0":Ce(je)?Qe=">="+Q+"."+$e+".0 <"+Q+"."+(+$e+1)+".0":Oe?(C("replaceTilde pr",Oe),Oe.charAt(0)!=="-"&&(Oe="-"+Oe),Qe=">="+Q+"."+$e+"."+je+Oe+" <"+Q+"."+(+$e+1)+".0"):Qe=">="+Q+"."+$e+"."+je+" <"+Q+"."+(+$e+1)+".0",C("tilde return",Qe),Qe})}(it,_e)}).join(" ")}(He,et),C("tildes",He),He=function(Ye,_e){return C("replaceXRanges",Ye,_e),Ye.split(/\s+/).map(function(it){return function(tt,Ne){tt=tt.trim();var st=Ne?h[l]:h[r];return tt.replace(st,function(_,Q,$e,je,Oe,Qe){C("xRange",tt,_,Q,$e,je,Oe,Qe);var nt=Ce($e),gt=nt||Ce(je),vt=gt||Ce(Oe);return Q==="="&&vt&&(Q=""),nt?_=Q===">"||Q==="<"?"<0.0.0":"*":Q&&vt?(gt&&(je=0),vt&&(Oe=0),Q===">"?(Q=">=",gt?($e=+$e+1,je=0,Oe=0):vt&&(je=+je+1,Oe=0)):Q==="<="&&(Q="<",gt?$e=+$e+1:je=+je+1),_=Q+$e+"."+je+"."+Oe):gt?_=">="+$e+".0.0 <"+(+$e+1)+".0.0":vt&&(_=">="+$e+"."+je+".0 <"+$e+"."+(+je+1)+".0"),C("xRange return",_),_})}(it,_e)}).join(" ")}(He,et),C("xrange",He),He=function(Ye,_e){return C("replaceStars",Ye,_e),Ye.trim().replace(h[le],"")}(He,et),C("stars",He),He}(Ze,ee)}).join(" ").split(/\s+/);return this.loose&&(Ue=Ue.filter(function(Ze){return!!Ze.match(ze)})),Ue=Ue.map(function(Ze){return new se(Ze,ee)})},me.prototype.intersects=function(K,ee){if(!(K instanceof me))throw new TypeError("a Range is required");return this.set.some(function(ce){return ce.every(function(ze){return K.set.some(function(Ue){return Ue.every(function(Ze){return ze.intersects(Ze,ee)})})})})},e.toComparators=function(K,ee){return new me(K,ee).set.map(function(ce){return ce.map(function(ze){return ze.value}).join(" ").trim().split(" ")})},me.prototype.test=function(K){if(!K)return!1;typeof K=="string"&&(K=new x(K,this.loose));for(var ee=0;ee<this.set.length;ee++)if(q(this.set[ee],K))return!0;return!1},e.satisfies=H,e.maxSatisfying=function(K,ee,ce){var ze=null,Ue=null;try{var Ze=new me(ee,ce)}catch{return null}return K.forEach(function(He){Ze.test(He)&&(ze&&Ue.compare(He)!==-1||(Ue=new x(ze=He,ce)))}),ze},e.minSatisfying=function(K,ee,ce){var ze=null,Ue=null;try{var Ze=new me(ee,ce)}catch{return null}return K.forEach(function(He){Ze.test(He)&&(ze&&Ue.compare(He)!==1||(Ue=new x(ze=He,ce)))}),ze},e.validRange=function(K,ee){try{return new me(K,ee).range||"*"}catch{return null}},e.ltr=function(K,ee,ce){return Z(K,ee,"<",ce)},e.gtr=function(K,ee,ce){return Z(K,ee,">",ce)},e.outside=Z,e.prerelease=function(K,ee){var ce=ae(K,ee);return ce&&ce.prerelease.length?ce.prerelease:null},e.intersects=function(K,ee,ce){return K=new me(K,ce),ee=new me(ee,ce),K.intersects(ee)},e.coerce=function(K){if(K instanceof x)return K;if(typeof K!="string")return null;var ee=K.match(h[f]);return ee==null?null:ae((ee[1]||"0")+"."+(ee[2]||"0")+"."+(ee[3]||"0"))}}).call(this,y(1))},function(pe,e){var y,R,C=pe.exports={};function L(){throw new Error("setTimeout has not been defined")}function A(){throw new Error("clearTimeout has not been defined")}function h(t){if(y===setTimeout)return setTimeout(t,0);if((y===L||!y)&&setTimeout)return y=setTimeout,setTimeout(t,0);try{return y(t,0)}catch{try{return y.call(null,t,0)}catch{return y.call(this,t,0)}}}(function(){try{y=typeof setTimeout=="function"?setTimeout:L}catch{y=L}try{R=typeof clearTimeout=="function"?clearTimeout:A}catch{R=A}})();var S,g=[],P=!1,D=-1;function u(){P&&S&&(P=!1,S.length?g=S.concat(g):D=-1,g.length&&p())}function p(){if(!P){var t=h(u);P=!0;for(var i=g.length;i;){for(S=g,g=[];++D<i;)S&&S[D].run();D=-1,i=g.length}S=null,P=!1,function(c){if(R===clearTimeout)return clearTimeout(c);if((R===A||!R)&&clearTimeout)return R=clearTimeout,clearTimeout(c);try{R(c)}catch{try{return R.call(null,c)}catch{return R.call(this,c)}}}(t)}}function $(t,i){this.fun=t,this.array=i}function d(){}C.nextTick=function(t){var i=new Array(arguments.length-1);if(arguments.length>1)for(var c=1;c<arguments.length;c++)i[c-1]=arguments[c];g.push(new $(t,i)),g.length!==1||P||h(p)},$.prototype.run=function(){this.fun.apply(null,this.array)},C.title="browser",C.browser=!0,C.env={},C.argv=[],C.version="",C.versions={},C.on=d,C.addListener=d,C.once=d,C.off=d,C.removeListener=d,C.removeAllListeners=d,C.emit=d,C.prependListener=d,C.prependOnceListener=d,C.listeners=function(t){return[]},C.binding=function(t){throw new Error("process.binding is not supported")},C.cwd=function(){return"/"},C.chdir=function(t){throw new Error("process.chdir is not supported")},C.umask=function(){return 0}}])}),define(Pe[119],Ae([1,0,9,6]),function(pe,e,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gc=e.$Fc=e.$Ec=e.$Dc=e.$Cc=e.$Bc=e.$Ac=e.$zc=e.$yc=e.$xc=e.$wc=e.$vc=e.$uc=e.$tc=e.$sc=void 0;function C(E){const b=E;return b?typeof b.read=="function":!1}e.$sc=C;function L(E){const b=E;return b?[b.on,b.pause,b.resume,b.destroy].every(n=>typeof n=="function"):!1}e.$tc=L;function A(E){const b=E;return b?L(b.stream)&&Array.isArray(b.buffer)&&typeof b.ended=="boolean":!1}e.$uc=A;function h(E,b){return new S(E,b)}e.$vc=h;class S{constructor(b,n){this.e=b,this.f=n,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(b){if(!this.a.destroyed){if(this.a.flowing)this.g(b);else if(this.b.data.push(b),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(n=>this.d.push(n))}}error(b){this.a.destroyed||(this.a.flowing?this.h(b):this.b.error.push(b))}end(b){this.a.destroyed||(typeof b<"u"&&this.write(b),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(b){this.c.data.slice(0).forEach(n=>n(b))}h(b){this.c.error.length===0?(0,y.$Y)(b):this.c.error.slice(0).forEach(n=>n(b))}i(){this.c.end.slice(0).forEach(b=>b())}on(b,n){if(!this.a.destroyed)switch(b){case"data":this.c.data.push(n),this.resume();break;case"end":this.c.end.push(n),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(n),this.a.flowing&&this.k();break}}removeListener(b,n){if(this.a.destroyed)return;let a;switch(b){case"data":a=this.c.data;break;case"end":a=this.c.end;break;case"error":a=this.c.error;break}if(a){const s=a.indexOf(n);s>=0&&a.splice(s,1)}}j(){if(this.b.data.length>0){const b=this.e(this.b.data);this.g(b),this.b.data.length=0;const n=[...this.d];this.d.length=0,n.forEach(a=>a())}}k(){if(this.c.error.length>0){for(const b of this.b.error)this.h(b);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function g(E,b){const n=[];let a;for(;(a=E.read())!==null;)n.push(a);return b(n)}e.$wc=g;function P(E,b,n){const a=[];let s;for(;(s=E.read())!==null&&a.length<n;)a.push(s);return s===null&&a.length>0?b(a):{read:()=>{if(a.length>0)return a.shift();if(typeof s<"u"){const o=s;return s=void 0,o}return E.read()}}}e.$xc=P;function D(E,b){return new Promise((n,a)=>{const s=[];u(E,{onData:o=>{b&&s.push(o)},onError:o=>{b?a(o):n(void 0)},onEnd:()=>{n(b?b(s):void 0)}})})}e.$yc=D;function u(E,b,n){E.on("error",a=>{n?.isCancellationRequested||b.onError(a)}),E.on("end",()=>{n?.isCancellationRequested||b.onEnd()}),E.on("data",a=>{n?.isCancellationRequested||b.onData(a)})}e.$zc=u;function p(E,b){return new Promise((n,a)=>{const s=new R.$lb,o=[],w=k=>{if(o.push(k),o.length>b)return s.dispose(),E.pause(),n({stream:E,buffer:o,ended:!1})},v=k=>(s.dispose(),a(k)),I=()=>(s.dispose(),n({stream:E,buffer:o,ended:!0}));s.add((0,R.$kb)(()=>E.removeListener("error",v))),E.on("error",v),s.add((0,R.$kb)(()=>E.removeListener("end",I))),E.on("end",I),s.add((0,R.$kb)(()=>E.removeListener("data",w))),E.on("data",w)})}e.$Ac=p;function $(E,b){const n=h(b);return n.end(E),n}e.$Bc=$;function d(){const E=h(()=>{throw new Error("not supported")});return E.end(),E}e.$Cc=d;function t(E){let b=!1;return{read:()=>b?null:(b=!0,E)}}e.$Dc=t;function i(E,b,n){const a=h(n);return u(E,{onData:s=>a.write(b.data(s)),onError:s=>a.error(b.error?b.error(s):s),onEnd:()=>a.end()}),a}e.$Ec=i;function c(E,b,n){let a=!1;return{read:()=>{const s=b.read();return a?s:(a=!0,s!==null?n([E,s]):E)}}}e.$Fc=c;function m(E,b,n){let a=!1;const s=h(n);return u(b,{onData:o=>a?s.write(o):(a=!0,s.write(n([E,o]))),onError:o=>s.error(o),onEnd:()=>{a||(a=!0,s.write(E)),s.end()}}),s}e.$Gc=m}),define(Pe[25],Ae([1,0,65,119]),function(pe,e,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2c=e.$1c=e.$Zc=e.$Yc=e.$Xc=e.$Wc=e.$Vc=e.$Uc=e.$Tc=e.$Sc=e.$Rc=e.$Qc=e.$Pc=e.$Oc=e.$Nc=e.$Mc=e.$Lc=e.$Kc=e.$Jc=e.$Ic=e.$Hc=void 0;const C=typeof Buffer<"u",L=new y.$T(()=>new Uint8Array(256));let A,h;class S{static alloc(f){return C?new S(Buffer.allocUnsafe(f)):new S(new Uint8Array(f))}static wrap(f){return C&&!Buffer.isBuffer(f)&&(f=Buffer.from(f.buffer,f.byteOffset,f.byteLength)),new S(f)}static fromString(f,F){return!(F?.dontUseNodeBuffer||!1)&&C?new S(Buffer.from(f)):(A||(A=new TextEncoder),new S(A.encode(f)))}static fromByteArray(f){const F=S.alloc(f.length);for(let W=0,V=f.length;W<V;W++)F.buffer[W]=f[W];return F}static concat(f,F){if(typeof F>"u"){F=0;for(let B=0,j=f.length;B<j;B++)F+=f[B].byteLength}const W=S.alloc(F);let V=0;for(let B=0,j=f.length;B<j;B++){const U=f[B];W.set(U,V),V+=U.byteLength}return W}constructor(f){this.buffer=f,this.byteLength=this.buffer.byteLength}clone(){const f=S.alloc(this.byteLength);return f.set(this),f}toString(){return C?this.buffer.toString():(h||(h=new TextDecoder),h.decode(this.buffer))}slice(f,F){return new S(this.buffer.subarray(f,F))}set(f,F){if(f instanceof S)this.buffer.set(f.buffer,F);else if(f instanceof Uint8Array)this.buffer.set(f,F);else if(f instanceof ArrayBuffer)this.buffer.set(new Uint8Array(f),F);else if(ArrayBuffer.isView(f))this.buffer.set(new Uint8Array(f.buffer,f.byteOffset,f.byteLength),F);else throw new Error("Unknown argument 'array'")}readUInt32BE(f){return u(this.buffer,f)}writeUInt32BE(f,F){p(this.buffer,f,F)}readUInt32LE(f){return $(this.buffer,f)}writeUInt32LE(f,F){d(this.buffer,f,F)}readUInt8(f){return t(this.buffer,f)}writeUInt8(f,F){i(this.buffer,f,F)}indexOf(f,F=0){return g(this.buffer,f instanceof S?f.buffer:f,F)}}e.$Hc=S;function g(l,f,F=0){const W=f.byteLength,V=l.byteLength;if(W===0)return 0;if(W===1)return l.indexOf(f[0]);if(W>V-F)return-1;const B=L.value;B.fill(f.length);for(let ie=0;ie<f.length;ie++)B[f[ie]]=f.length-ie-1;let j=F+f.length-1,U=j,z=-1;for(;j<V;)if(l[j]===f[U]){if(U===0){z=j;break}j--,U--}else j+=Math.max(f.length-U,B[l[j]]),U=f.length-1;return z}e.$Ic=g;function P(l,f){return l[f+0]<<0>>>0|l[f+1]<<8>>>0}e.$Jc=P;function D(l,f,F){l[F+0]=f&255,f=f>>>8,l[F+1]=f&255}e.$Kc=D;function u(l,f){return l[f]*2**24+l[f+1]*2**16+l[f+2]*2**8+l[f+3]}e.$Lc=u;function p(l,f,F){l[F+3]=f,f=f>>>8,l[F+2]=f,f=f>>>8,l[F+1]=f,f=f>>>8,l[F]=f}e.$Mc=p;function $(l,f){return l[f+0]<<0>>>0|l[f+1]<<8>>>0|l[f+2]<<16>>>0|l[f+3]<<24>>>0}e.$Nc=$;function d(l,f,F){l[F+0]=f&255,f=f>>>8,l[F+1]=f&255,f=f>>>8,l[F+2]=f&255,f=f>>>8,l[F+3]=f&255}e.$Oc=d;function t(l,f){return l[f]}e.$Pc=t;function i(l,f,F){l[F]=f}e.$Qc=i;function c(l){return R.$wc(l,f=>S.concat(f))}e.$Rc=c;function m(l){return R.$Dc(l)}e.$Sc=m;function E(l){return R.$yc(l,f=>S.concat(f))}e.$Tc=E;async function b(l){return l.ended?S.concat(l.buffer):S.concat([...l.buffer,await E(l.stream)])}e.$Uc=b;function n(l){return R.$Bc(l,f=>S.concat(f))}e.$Vc=n;function a(l){return R.$Ec(l,{data:f=>typeof f=="string"?S.fromString(f):S.wrap(f)},f=>S.concat(f))}e.$Wc=a;function s(l){return R.$vc(f=>S.concat(f),l)}e.$Xc=s;function o(l,f){return R.$Fc(l,f,F=>S.concat(F))}e.$Yc=o;function w(l,f){return R.$Gc(l,f,F=>S.concat(F))}e.$Zc=w;function v(l){let f=0,F=0,W=0;const V=new Uint8Array(Math.floor(l.length/4*3)),B=U=>{switch(F){case 3:V[W++]=f|U,F=0;break;case 2:V[W++]=f|U>>>2,f=U<<6,F=3;break;case 1:V[W++]=f|U>>>4,f=U<<4,F=2;break;default:f=U<<2,F=1}};for(let U=0;U<l.length;U++){const z=l.charCodeAt(U);if(z>=65&&z<=90)B(z-65);else if(z>=97&&z<=122)B(z-97+26);else if(z>=48&&z<=57)B(z-48+52);else if(z===43||z===45)B(62);else if(z===47||z===95)B(63);else{if(z===61)break;throw new SyntaxError(`Unexpected base64 character ${l[U]}`)}}const j=W;for(;F>0;)B(0);return S.wrap(V).slice(0,j)}e.$1c=v;const I="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",k="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function r({buffer:l},f=!0,F=!1){const W=F?k:I;let V="";const B=l.byteLength%3;let j=0;for(;j<l.byteLength-B;j+=3){const U=l[j+0],z=l[j+1],ie=l[j+2];V+=W[U>>>2],V+=W[(U<<4|z>>>4)&63],V+=W[(z<<2|ie>>>6)&63],V+=W[ie&63]}if(B===1){const U=l[j+0];V+=W[U>>>2],V+=W[U<<4&63],f&&(V+="==")}else if(B===2){const U=l[j+0],z=l[j+1];V+=W[U>>>2],V+=W[(U<<4|z>>>4)&63],V+=W[z<<2&63],f&&(V+="=")}return V}e.$2c=r}),define(Pe[120],Ae([1,0,28,15]),function(pe,e,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kj=e.$Jj=e.$Ij=e.$Hj=e.FuzzyScore=e.$Gj=e.$Fj=e.$Ej=e.$Dj=e.$Cj=e.$Bj=e.$Aj=e.$zj=e.$yj=e.$xj=e.$wj=e.$vj=e.or=void 0;function C(...se){return function(ne,me){for(let Ce=0,M=se.length;Ce<M;Ce++){const q=se[Ce](ne,me);if(q)return q}return null}}e.or=C,e.$vj=L.bind(void 0,!1),e.$wj=L.bind(void 0,!0);function L(se,ne,me){if(!me||me.length<ne.length)return null;let Ce;return se?Ce=R.$Pd(me,ne):Ce=me.indexOf(ne)===0,Ce?ne.length>0?[{start:0,end:ne.length}]:[]:null}function A(se,ne){const me=ne.toLowerCase().indexOf(se.toLowerCase());return me===-1?null:[{start:me,end:me+se.length}]}e.$xj=A;function h(se,ne){return S(se.toLowerCase(),ne.toLowerCase(),0,0)}e.$yj=h;function S(se,ne,me,Ce){if(me===se.length)return[];if(Ce===ne.length)return null;if(se[me]===ne[Ce]){let M=null;return(M=S(se,ne,me+1,Ce+1))?i({start:Ce,end:Ce+1},M):null}return S(se,ne,me,Ce+1)}function g(se){return 97<=se&&se<=122}function P(se){return 65<=se&&se<=90}e.$zj=P;function D(se){return 48<=se&&se<=57}function u(se){return se===32||se===9||se===10||se===13}const p=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(se=>p.add(se.charCodeAt(0)));function $(se){return u(se)||p.has(se)}function d(se,ne){return se===ne||$(se)&&$(ne)}function t(se){return g(se)||P(se)||D(se)}function i(se,ne){return ne.length===0?ne=[se]:se.end===ne[0].start?ne[0].start=se.start:ne.unshift(se),ne}function c(se,ne){for(let me=ne;me<se.length;me++){const Ce=se.charCodeAt(me);if(P(Ce)||D(Ce)||me>0&&!t(se.charCodeAt(me-1)))return me}return se.length}function m(se,ne,me,Ce){if(me===se.length)return[];if(Ce===ne.length)return null;if(se[me]!==ne[Ce].toLowerCase())return null;{let M=null,q=Ce+1;for(M=m(se,ne,me+1,Ce+1);!M&&(q=c(ne,q))<ne.length;)M=m(se,ne,me+1,q),q++;return M===null?null:i({start:Ce,end:Ce+1},M)}}function E(se){let ne=0,me=0,Ce=0,M=0,q=0;for(let ce=0;ce<se.length;ce++)q=se.charCodeAt(ce),P(q)&&ne++,g(q)&&me++,t(q)&&Ce++,D(q)&&M++;const H=ne/se.length,Z=me/se.length,K=Ce/se.length,ee=M/se.length;return{upperPercent:H,lowerPercent:Z,alphaPercent:K,numericPercent:ee}}function b(se){const{upperPercent:ne,lowerPercent:me}=se;return me===0&&ne>.6}function n(se){const{upperPercent:ne,lowerPercent:me,alphaPercent:Ce,numericPercent:M}=se;return me>.2&&ne<.8&&Ce>.6&&M<.2}function a(se){let ne=0,me=0,Ce=0,M=0;for(let q=0;q<se.length;q++)Ce=se.charCodeAt(q),P(Ce)&&ne++,g(Ce)&&me++,u(Ce)&&M++;return(ne===0||me===0)&&M===0?se.length<=30:ne<=5}function s(se,ne){if(!ne||(ne=ne.trim(),ne.length===0)||!a(se)||ne.length>60)return null;const me=E(ne);if(!n(me)){if(!b(me))return null;ne=ne.toLowerCase()}let Ce=null,M=0;for(se=se.toLowerCase();M<ne.length&&(Ce=m(se,ne,0,M))===null;)M=c(ne,M+1);return Ce}e.$Aj=s;function o(se,ne,me=!1){if(!ne||ne.length===0)return null;let Ce=null,M=0;for(se=se.toLowerCase(),ne=ne.toLowerCase();M<ne.length&&(Ce=w(se,ne,0,M,me))===null;)M=v(ne,M+1);return Ce}e.$Bj=o;function w(se,ne,me,Ce,M){if(me===se.length)return[];if(Ce===ne.length)return null;if(d(se.charCodeAt(me),ne.charCodeAt(Ce))){let q=null,H=Ce+1;if(q=w(se,ne,me+1,Ce+1,M),!M)for(;!q&&(H=v(ne,H))<ne.length;)q=w(se,ne,me+1,H,M),H++;return q?se.charCodeAt(me)!==ne.charCodeAt(Ce)?q:i({start:Ce,end:Ce+1},q):null}else return null}function v(se,ne){for(let me=ne;me<se.length;me++)if($(se.charCodeAt(me))||me>0&&$(se.charCodeAt(me-1)))return me;return se.length}const I=C(e.$wj,s,A),k=C(e.$wj,s,h),r=new y.$Ai(1e4);function l(se,ne,me=!1){if(typeof se!="string"||typeof ne!="string")return null;let Ce=r.get(se);Ce||(Ce=new RegExp(R.$yd(se),"i"),r.set(se,Ce));const M=Ce.exec(ne);return M?[{start:M.index,end:M.index+M[0].length}]:me?k(se,ne):I(se,ne)}e.$Cj=l;function f(se,ne){const me=he(se,se.toLowerCase(),0,ne,ne.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return me?W(me):null}e.$Dj=f;function F(se,ne,me,Ce,M,q){const H=Math.min(13,se.length);for(;me<H;me++){const Z=he(se,ne,me,Ce,M,q,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(Z)return Z}return[0,q]}e.$Ej=F;function W(se){if(typeof se>"u")return[];const ne=[],me=se[1];for(let Ce=se.length-1;Ce>1;Ce--){const M=se[Ce]+me,q=ne[ne.length-1];q&&q.end===M?q.end=M+1:ne.push({start:M,end:M+1})}return ne}e.$Fj=W;const V=128;function B(){const se=[],ne=[];for(let me=0;me<=V;me++)ne[me]=0;for(let me=0;me<=V;me++)se.push(ne.slice(0));return se}function j(se){const ne=[];for(let me=0;me<=se;me++)ne[me]=0;return ne}const U=j(2*V),z=j(2*V),ie=B(),Y=B(),ye=B(),ke=!1;function Re(se,ne,me,Ce,M){function q(Z,K,ee=" "){for(;Z.length<K;)Z=ee+Z;return Z}let H=` |   |${Ce.split("").map(Z=>q(Z,3)).join("|")}
`;for(let Z=0;Z<=me;Z++)Z===0?H+=" |":H+=`${ne[Z-1]}|`,H+=se[Z].slice(0,M+1).map(K=>q(K.toString(),3)).join("|")+`
`;return H}function X(se,ne,me,Ce){se=se.substr(ne),me=me.substr(Ce),console.log(Re(Y,se,se.length,me,me.length)),console.log(Re(ye,se,se.length,me,me.length)),console.log(Re(ie,se,se.length,me,me.length))}function le(se,ne){if(ne<0||ne>=se.length)return!1;const me=se.codePointAt(ne);switch(me){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!R.$8d(me)}}function we(se,ne){if(ne<0||ne>=se.length)return!1;switch(se.charCodeAt(ne)){case 32:case 9:return!0;default:return!1}}function ae(se,ne,me){return ne[se]!==me[se]}function x(se,ne,me,Ce,M,q,H=!1){for(;ne<me&&M<q;)se[ne]===Ce[M]&&(H&&(U[ne]=M),ne+=1),M+=1;return ne===me}e.$Gj=x;var ue;(function(se){se[se.Diag=1]="Diag",se[se.Left=2]="Left",se[se.LeftLeft=3]="LeftLeft"})(ue||(ue={}));var O;(function(se){se.Default=[-100,0];function ne(me){return!me||me.length===2&&me[0]===-100&&me[1]===0}se.isDefault=ne})(O||(e.FuzzyScore=O={}));class J{static{this.default={boostFullMatch:!0,firstMatchCanBeWeak:!1}}constructor(ne,me){this.firstMatchCanBeWeak=ne,this.boostFullMatch=me}}e.$Hj=J;function he(se,ne,me,Ce,M,q,H=J.default){const Z=se.length>V?V:se.length,K=Ce.length>V?V:Ce.length;if(me>=Z||q>=K||Z-me>K-q||!x(ne,me,Z,M,q,K,!0))return;Ee(Z,K,me,q,ne,M);let ee=1,ce=1,ze=me,Ue=q;const Ze=[!1];for(ee=1,ze=me;ze<Z;ee++,ze++){const it=U[ze],tt=z[ze],Ne=ze+1<Z?z[ze+1]:K;for(ce=it-q+1,Ue=it;Ue<Ne;ce++,Ue++){let st=Number.MIN_SAFE_INTEGER,_=!1;Ue<=tt&&(st=ve(se,ne,ze,me,Ce,M,Ue,K,q,ie[ee-1][ce-1]===0,Ze));let Q=0;st!==Number.MAX_SAFE_INTEGER&&(_=!0,Q=st+Y[ee-1][ce-1]);const $e=Ue>it,je=$e?Y[ee][ce-1]+(ie[ee][ce-1]>0?-5:0):0,Oe=Ue>it+1&&ie[ee][ce-1]>0,Qe=Oe?Y[ee][ce-2]+(ie[ee][ce-2]>0?-5:0):0;if(Oe&&(!$e||Qe>=je)&&(!_||Qe>=Q))Y[ee][ce]=Qe,ye[ee][ce]=3,ie[ee][ce]=0;else if($e&&(!_||je>=Q))Y[ee][ce]=je,ye[ee][ce]=2,ie[ee][ce]=0;else if(_)Y[ee][ce]=Q,ye[ee][ce]=1,ie[ee][ce]=ie[ee-1][ce-1]+1;else throw new Error("not possible")}}if(ke&&X(se,me,Ce,q),!Ze[0]&&!H.firstMatchCanBeWeak)return;ee--,ce--;const He=[Y[ee][ce],q];let et=0,Ye=0;for(;ee>=1;){let it=ce;do{const tt=ye[ee][it];if(tt===3)it=it-2;else if(tt===2)it=it-1;else break}while(it>=1);et>1&&ne[me+ee-1]===M[q+ce-1]&&!ae(it+q-1,Ce,M)&&et+1>ie[ee][it]&&(it=ce),it===ce?et++:et=1,Ye||(Ye=it),ee--,ce=it-1,He.push(ce)}K===Z&&H.boostFullMatch&&(He[0]+=2);const _e=Ye-Z;return He[0]-=_e,He}e.$Ij=he;function Ee(se,ne,me,Ce,M,q){let H=se-1,Z=ne-1;for(;H>=me&&Z>=Ce;)M[H]===q[Z]&&(z[H]=Z,H--),Z--}function ve(se,ne,me,Ce,M,q,H,Z,K,ee,ce){if(ne[me]!==q[H])return Number.MIN_SAFE_INTEGER;let ze=1,Ue=!1;return H===me-Ce?ze=se[me]===M[H]?7:5:ae(H,M,q)&&(H===0||!ae(H-1,M,q))?(ze=se[me]===M[H]?7:5,Ue=!0):le(q,H)&&(H===0||!le(q,H-1))?ze=5:(le(q,H-1)||we(q,H-1))&&(ze=5,Ue=!0),ze>1&&me===Ce&&(ce[0]=!0),Ue||(Ue=ae(H,M,q)||le(q,H-1)||we(q,H-1)),me===Ce?H>K&&(ze-=Ue?3:5):ee?ze+=Ue?2:0:ze+=Ue?0:1,H+1===Z&&(ze-=Ue?3:5),ze}function be(se,ne,me,Ce,M,q,H){return oe(se,ne,me,Ce,M,q,!0,H)}e.$Jj=be;function De(se,ne,me,Ce,M,q,H){return oe(se,ne,me,Ce,M,q,!1,H)}e.$Kj=De;function oe(se,ne,me,Ce,M,q,H,Z){let K=he(se,ne,me,Ce,M,q,Z);if(K&&!H)return K;if(se.length>=3){const ee=Math.min(7,se.length-1);for(let ce=me+1;ce<ee;ce++){const ze=de(se,ce);if(ze){const Ue=he(ze,ze.toLowerCase(),me,Ce,M,q,Z);Ue&&(Ue[0]-=3,(!K||Ue[0]>K[0])&&(K=Ue))}}}return K}function de(se,ne){if(ne+1>=se.length)return;const me=se[ne],Ce=se[ne+1];if(me!==Ce)return se.slice(0,ne)+Ce+me+se.slice(ne+2)}}),define(Pe[29],Ae([1,0,15]),function(pe,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var R;(function(C){C[C.Ignore=0]="Ignore",C[C.Info=1]="Info",C[C.Warning=2]="Warning",C[C.Error=3]="Error"})(R||(R={})),function(C){const L="error",A="warning",h="warn",S="info",g="ignore";function P(u){return u?y.$Od(L,u)?C.Error:y.$Od(A,u)||y.$Od(h,u)?C.Warning:y.$Od(S,u)?C.Info:C.Ignore:C.Ignore}C.fromValue=P;function D(u){switch(u){case C.Error:return L;case C.Warning:return A;case C.Info:return S;default:return g}}C.toString=D}(R||(R={})),e.default=R}),define(Pe[121],Ae([1,0]),function(pe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ec=void 0,e.$ec=Symbol("MicrotaskDelay")}),define(Pe[48],Ae([1,0,18,15]),function(pe,e,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fh=e.$Eh=e.$Dh=e.$Ch=e.$Bh=void 0;class C{constructor(){this.b="",this.c=0}reset(p){return this.b=p,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(p){const $=p.charCodeAt(0),d=this.b.charCodeAt(this.c);return $-d}value(){return this.b[this.c]}}e.$Bh=C;class L{constructor(p=!0){this.e=p}reset(p){return this.b=p,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let p=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(p)this.c++;else break;else p=!1;return this}cmp(p){return this.e?(0,R.$Id)(p,this.b,0,p.length,this.c,this.d):(0,R.$Kd)(p,this.b,0,p.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$Ch=L;class A{constructor(p=!0,$=!0){this.f=p,this.g=$}reset(p){this.d=0,this.e=0,this.b=p,this.c=p.length;for(let $=p.length-1;$>=0;$--,this.c--){const d=this.b.charCodeAt($);if(!(d===47||this.f&&d===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let p=!0;for(;this.e<this.c;this.e++){const $=this.b.charCodeAt(this.e);if($===47||this.f&&$===92)if(p)this.d++;else break;else p=!1}return this}cmp(p){return this.g?(0,R.$Id)(p,this.b,0,p.length,this.d,this.e):(0,R.$Kd)(p,this.b,0,p.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$Dh=A;var h;(function(u){u[u.Scheme=1]="Scheme",u[u.Authority=2]="Authority",u[u.Path=3]="Path",u[u.Query=4]="Query",u[u.Fragment=5]="Fragment"})(h||(h={}));class S{constructor(p,$){this.f=p,this.g=$,this.d=[],this.e=0}reset(p){return this.c=p,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new A(!1,!this.f(p)),this.b.reset(p.path),this.b.value()&&this.d.push(3)),this.g(p)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(p){if(this.d[this.e]===1)return(0,R.$Jd)(p,this.c.scheme);if(this.d[this.e]===2)return(0,R.$Jd)(p,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(p);if(this.d[this.e]===4)return(0,R.$Hd)(p,this.c.query);if(this.d[this.e]===5)return(0,R.$Hd)(p,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.$Eh=S;class g{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const p=this.right;return this.right=p.left,p.left=this,this.updateHeight(),p.updateHeight(),p}rotateRight(){const p=this.left;return this.left=p.right,p.right=this,this.updateHeight(),p.updateHeight(),p}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var P;(function(u){u[u.Left=-1]="Left",u[u.Mid=0]="Mid",u[u.Right=1]="Right"})(P||(P={}));class D{static forUris(p=()=>!1,$=()=>!1){return new D(new S(p,$))}static forPaths(p=!1){return new D(new A(void 0,!p))}static forStrings(){return new D(new C)}static forConfigKeys(){return new D(new L)}constructor(p){this.b=p}clear(){this.c=void 0}fill(p,$){if($){const d=$.slice(0);(0,y.$Qf)(d);for(const t of d)this.set(t,p)}else{const d=p.slice(0);(0,y.$Qf)(d);for(const t of d)this.set(t[0],t[1])}}set(p,$){const d=this.b.reset(p);let t;this.c||(this.c=new g,this.c.segment=d.value());const i=[];for(t=this.c;;){const m=d.cmp(t.segment);if(m>0)t.left||(t.left=new g,t.left.segment=d.value()),i.push([-1,t]),t=t.left;else if(m<0)t.right||(t.right=new g,t.right.segment=d.value()),i.push([1,t]),t=t.right;else if(d.hasNext())d.next(),t.mid||(t.mid=new g,t.mid.segment=d.value()),i.push([0,t]),t=t.mid;else break}const c=t.value;t.value=$,t.key=p;for(let m=i.length-1;m>=0;m--){const E=i[m][1];E.updateHeight();const b=E.balanceFactor();if(b<-1||b>1){const n=i[m][0],a=i[m+1][0];if(n===1&&a===1)i[m][1]=E.rotateLeft();else if(n===-1&&a===-1)i[m][1]=E.rotateRight();else if(n===1&&a===-1)E.right=i[m+1][1]=i[m+1][1].rotateRight(),i[m][1]=E.rotateLeft();else if(n===-1&&a===1)E.left=i[m+1][1]=i[m+1][1].rotateLeft(),i[m][1]=E.rotateRight();else throw new Error;if(m>0)switch(i[m-1][0]){case-1:i[m-1][1].left=i[m][1];break;case 1:i[m-1][1].right=i[m][1];break;case 0:i[m-1][1].mid=i[m][1];break}else this.c=i[0][1]}}return c}get(p){return this.d(p)?.value}d(p){const $=this.b.reset(p);let d=this.c;for(;d;){const t=$.cmp(d.segment);if(t>0)d=d.left;else if(t<0)d=d.right;else if($.hasNext())$.next(),d=d.mid;else break}return d}has(p){const $=this.d(p);return!($?.value===void 0&&$?.mid===void 0)}delete(p){return this.e(p,!1)}deleteSuperstr(p){return this.e(p,!0)}e(p,$){const d=this.b.reset(p),t=[];let i=this.c;for(;i;){const c=d.cmp(i.segment);if(c>0)t.push([-1,i]),i=i.left;else if(c<0)t.push([1,i]),i=i.right;else if(d.hasNext())d.next(),t.push([0,i]),i=i.mid;else break}if(i){if($?(i.left=void 0,i.mid=void 0,i.right=void 0,i.height=1):(i.key=void 0,i.value=void 0),!i.mid&&!i.value)if(i.left&&i.right){const c=this.f(i.right);if(c.key){const{key:m,value:E,segment:b}=c;this.e(c.key,!1),i.key=m,i.value=E,i.segment=b}}else{const c=i.left??i.right;if(t.length>0){const[m,E]=t[t.length-1];switch(m){case-1:E.left=c;break;case 0:E.mid=c;break;case 1:E.right=c;break}}else this.c=c}for(let c=t.length-1;c>=0;c--){const m=t[c][1];m.updateHeight();const E=m.balanceFactor();if(E>1?(m.right.balanceFactor()>=0||(m.right=m.right.rotateRight()),t[c][1]=m.rotateLeft()):E<-1&&(m.left.balanceFactor()<=0||(m.left=m.left.rotateLeft()),t[c][1]=m.rotateRight()),c>0)switch(t[c-1][0]){case-1:t[c-1][1].left=t[c][1];break;case 1:t[c-1][1].right=t[c][1];break;case 0:t[c-1][1].mid=t[c][1];break}else this.c=t[0][1]}}}f(p){for(;p.left;)p=p.left;return p}findSubstr(p){const $=this.b.reset(p);let d=this.c,t;for(;d;){const i=$.cmp(d.segment);if(i>0)d=d.left;else if(i<0)d=d.right;else if($.hasNext())$.next(),t=d.value||t,d=d.mid;else break}return d&&d.value||t}findSuperstr(p){return this.g(p,!1)}g(p,$){const d=this.b.reset(p);let t=this.c;for(;t;){const i=d.cmp(t.segment);if(i>0)t=t.left;else if(i<0)t=t.right;else if(d.hasNext())d.next(),t=t.mid;else return t.mid?this.h(t.mid):$?t.value:void 0}}hasElementOrSubtree(p){return this.g(p,!0)!==void 0}forEach(p){for(const[$,d]of this)p(d,$)}*[Symbol.iterator](){yield*this.h(this.c)}h(p){const $=[];return this.j(p,$),$[Symbol.iterator]()}j(p,$){p&&(p.left&&this.j(p.left,$),p.value&&$.push([p.key,p.value]),p.mid&&this.j(p.mid,$),p.right&&this.j(p.right,$))}_isBalanced(){const p=$=>{if(!$)return!0;const d=$.balanceFactor();return d<-1||d>1?!1:p($.left)&&p($.right)};return p(this.c)}}e.$Fh=D}),define(Pe[40],Ae([1,0,89]),function(pe,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.$Oj=e.ThemeColor=void 0;var R;(function(A){function h(S){return S&&typeof S=="object"&&typeof S.id=="string"}A.isThemeColor=h})(R||(e.ThemeColor=R={}));function C(A){return{id:A}}e.$Oj=C;var L;(function(A){A.iconNameSegment="[A-Za-z0-9]+",A.iconNameExpression="[A-Za-z0-9-]+",A.iconModifierExpression="~[A-Za-z]+",A.iconNameCharacter="[A-Za-z0-9~-]";const h=new RegExp(`^(${A.iconNameExpression})(${A.iconModifierExpression})?$`);function S(c){const m=h.exec(c.id);if(!m)return S(y.$Nj.error);const[,E,b]=m,n=["codicon","codicon-"+E];return b&&n.push("codicon-modifier-"+b.substring(1)),n}A.asClassNameArray=S;function g(c){return S(c).join(" ")}A.asClassName=g;function P(c){return"."+S(c).join(".")}A.asCSSSelector=P;function D(c){return c&&typeof c=="object"&&typeof c.id=="string"&&(typeof c.color>"u"||R.isThemeColor(c.color))}A.isThemeIcon=D;const u=new RegExp(`^\\$\\((${A.iconNameExpression}(?:${A.iconModifierExpression})?)\\)$`);function p(c){const m=u.exec(c);if(!m)return;const[,E]=m;return{id:E}}A.fromString=p;function $(c){return{id:c}}A.fromId=$;function d(c,m){let E=c.id;const b=E.lastIndexOf("~");return b!==-1&&(E=E.substring(0,b)),m&&(E=`${E}~${m}`),{id:E}}A.modify=d;function t(c){const m=c.id.lastIndexOf("~");if(m!==-1)return c.id.substring(m+1)}A.getModifier=t;function i(c,m){return c.id===m.id&&c.color?.id===m.color?.id}A.isEqual=i})(L||(e.ThemeIcon=L={}))}),define(Pe[122],Ae([1,0,120,15,40]),function(pe,e,y,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uj=e.$Tj=e.$Sj=e.$Rj=e.$Qj=e.$Pj=void 0;const L="$(",A=new RegExp(`\\$\\(${C.ThemeIcon.iconNameExpression}(?:${C.ThemeIcon.iconModifierExpression})?\\)`,"g"),h=new RegExp(`(\\\\)?${A.source}`,"g");function S(i){return i.replace(h,(c,m)=>m?c:`\\${c}`)}e.$Pj=S;const g=new RegExp(`\\\\${A.source}`,"g");function P(i){return i.replace(g,c=>`\\${c}`)}e.$Qj=P;const D=new RegExp(`(\\s)?(\\\\)?${A.source}(\\s)?`,"g");function u(i){return i.indexOf(L)===-1?i:i.replace(D,(c,m,E,b)=>E?c:m||b||"")}e.$Rj=u;function p(i){return i?i.replace(/\$\((.*?)\)/g,(c,m)=>` ${m} `).trim():""}e.$Sj=p;const $=new RegExp(`\\$\\(${C.ThemeIcon.iconNameCharacter}+\\)`,"g");function d(i){$.lastIndex=0;let c="";const m=[];let E=0;for(;;){const b=$.lastIndex,n=$.exec(i),a=i.substring(b,n?.index);if(a.length>0){c+=a;for(let s=0;s<a.length;s++)m.push(E)}if(!n)break;E+=n[0].length}return{text:c,iconOffsets:m}}e.$Tj=d;function t(i,c,m=!1){const{text:E,iconOffsets:b}=c;if(!b||b.length===0)return(0,y.$Cj)(i,E,m);const n=(0,R.$wd)(E," "),a=E.length-n.length,s=(0,y.$Cj)(i,n,m);if(s)for(const o of s){const w=b[o.start+a]+a;o.start+=w,o.end+=w}return s}e.$Uj=t}),define(Pe[36],Ae([1,0]),function(pe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6e=e.$5e=void 0;const y=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function R(C){return y.test(C)}e.$5e=R,e.$6e=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let C;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?C=crypto.getRandomValues.bind(crypto):C=function(h){for(let S=0;S<h.length;S++)h[S]=Math.floor(Math.random()*256);return h};const L=new Uint8Array(16),A=[];for(let h=0;h<256;h++)A.push(h.toString(16).padStart(2,"0"));return function(){C(L),L[6]=L[6]&15|64,L[8]=L[8]&63|128;let S=0,g="";return g+=A[L[S++]],g+=A[L[S++]],g+=A[L[S++]],g+=A[L[S++]],g+="-",g+=A[L[S++]],g+=A[L[S++]],g+="-",g+=A[L[S++]],g+=A[L[S++]],g+="-",g+=A[L[S++]],g+=A[L[S++]],g+="-",g+=A[L[S++]],g+=A[L[S++]],g+=A[L[S++]],g+=A[L[S++]],g+=A[L[S++]],g+=A[L[S++]],g}}()}),define(Pe[123],Ae([1,0,18,66,36]),function(pe,e,y,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qs=e.$Ps=e.$Os=e.$Ns=e.$Ms=void 0;function L(D){return{asString:async()=>D,asFile:()=>{},value:typeof D=="string"?D:void 0}}e.$Ms=L;function A(D,u,p){const $={id:(0,C.$6e)(),name:D,uri:u,data:p};return{asString:async()=>"",asFile:()=>$,value:void 0}}e.$Ns=A;class h{constructor(){this.a=new Map}get size(){let u=0;for(const p of this.a)u++;return u}has(u){return this.a.has(this.b(u))}matches(u){const p=[...this.a.keys()];return R.Iterable.some(this,([$,d])=>d.asFile())&&p.push("files"),P(S(u),p)}get(u){return this.a.get(this.b(u))?.[0]}append(u,p){const $=this.a.get(u);$?$.push(p):this.a.set(this.b(u),[p])}replace(u,p){this.a.set(this.b(u),[p])}delete(u){this.a.delete(this.b(u))}*[Symbol.iterator](){for(const[u,p]of this.a)for(const $ of p)yield[u,$]}b(u){return S(u)}}e.$Os=h;function S(D){return D.toLowerCase()}function g(D,u){return P(S(D),u.map(S))}e.$Ps=g;function P(D,u){if(D==="*/*")return u.length>0;if(u.includes(D))return!0;const p=D.match(/^([a-z]+)\/([a-z]+|\*)$/i);if(!p)return!1;const[$,d,t]=p;return t==="*"?u.some(i=>i.startsWith(d+"/")):!1}e.$Qs=Object.freeze({create:D=>(0,y.$Ff)(D.map(u=>u.toString())).join(`\r
`),split:D=>D.split(`\r
`),parse:D=>e.$Qs.split(D).filter(u=>!u.startsWith("#"))})}),define(Pe[124],Ae([1,0]),function(pe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rr=void 0,e.$Rr={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!0,independentColorPoolPerBracketType:!1}}}),define(Pe[125],Ae([1,0]),function(pe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$et=e.$dt=e.IndentAction=void 0;var y;(function(A){A[A.None=0]="None",A[A.Indent=1]="Indent",A[A.IndentOutdent=2]="IndentOutdent",A[A.Outdent=3]="Outdent"})(y||(e.IndentAction=y={}));class R{constructor(h){if(this.e=null,this.f=!1,this.open=h.open,this.close=h.close,this.b=!0,this.c=!0,this.d=!0,Array.isArray(h.notIn))for(let S=0,g=h.notIn.length;S<g;S++)switch(h.notIn[S]){case"string":this.b=!1;break;case"comment":this.c=!1;break;case"regex":this.d=!1;break}}isOK(h){switch(h){case 0:return!0;case 1:return this.c;case 2:return this.b;case 3:return this.d}}shouldAutoClose(h,S){if(h.getTokenCount()===0)return!0;const g=h.findTokenIndexAtOffset(S-2),P=h.getStandardTokenType(g);return this.isOK(P)}g(h,S){for(let g=h;g<=S;g++){const P=String.fromCharCode(g);if(!this.open.includes(P)&&!this.close.includes(P))return P}return null}findNeutralCharacter(){return this.f||(this.f=!0,this.e||(this.e=this.g(48,57)),this.e||(this.e=this.g(97,122)),this.e||(this.e=this.g(65,90))),this.e}}e.$dt=R;class C{constructor(h){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const S of h)L(this.autoClosingPairsOpenByStart,S.open.charAt(0),S),L(this.autoClosingPairsOpenByEnd,S.open.charAt(S.open.length-1),S),L(this.autoClosingPairsCloseByStart,S.close.charAt(0),S),L(this.autoClosingPairsCloseByEnd,S.close.charAt(S.close.length-1),S),S.close.length===1&&S.open.length===1&&L(this.autoClosingPairsCloseSingleChar,S.close,S)}}e.$et=C;function L(A,h,S){A.has(h)?A.get(h).push(S):A.set(h,[S])}}),define(Pe[126],Ae([1,0]),function(pe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_6=e.$$6=void 0;class y{constructor(){this.a=new Map}removeDragOperationTransfer(L){if(L&&this.a.has(L)){const A=this.a.get(L);return this.a.delete(L),A}}addDragOperationTransfer(L,A){this.a.set(L,A)}}e.$$6=y;class R{constructor(L){this.identifier=L}}e.$_6=R}),define(Pe[127],Ae([10,11]),function(pe,e){return pe.create("vs/base/common/actions",e)}),define(Pe[128],Ae([1,0,5,6,127]),function(pe,e,y,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ji=e.$ii=e.$hi=e.$gi=e.$fi=e.$ei=void 0;class L extends R.$mb{constructor(u,p="",$="",d=!0,t){super(),this.h=this.B(new y.$hc),this.onDidChange=this.h.event,this.w=!0,this.j=u,this.m=p,this.u=$,this.w=d,this.C=t}get id(){return this.j}get label(){return this.m}set label(u){this.D(u)}D(u){this.m!==u&&(this.m=u,this.h.fire({label:u}))}get tooltip(){return this.n||""}set tooltip(u){this.F(u)}F(u){this.n!==u&&(this.n=u,this.h.fire({tooltip:u}))}get class(){return this.u}set class(u){this.G(u)}G(u){this.u!==u&&(this.u=u,this.h.fire({class:u}))}get enabled(){return this.w}set enabled(u){this.H(u)}H(u){this.w!==u&&(this.w=u,this.h.fire({enabled:u}))}get checked(){return this.z}set checked(u){this.I(u)}I(u){this.z!==u&&(this.z=u,this.h.fire({checked:u}))}async run(u,p){this.C&&await this.C(u)}}e.$ei=L;class A extends R.$mb{constructor(){super(...arguments),this.f=this.B(new y.$hc),this.onWillRun=this.f.event,this.k=this.B(new y.$hc),this.onDidRun=this.k.event}async run(u,p){if(!u.enabled)return;this.f.fire({action:u});let $;try{await this.l(u,p)}catch(d){$=d}this.k.fire({action:u,error:$})}async l(u,p){await u.run(p)}}e.$fi=A;class h{constructor(){this.id=h.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...u){let p=[];for(const $ of u)$.length&&(p.length?p=[...p,new h,...$]:p=$);return p}static{this.ID="vs.actions.separator"}async run(){}}e.$gi=h;class S{get actions(){return this.a}constructor(u,p,$,d){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=u,this.label=p,this.class=d,this.a=$}async run(){}}e.$hi=S;class g extends L{static{this.ID="vs.actions.empty"}constructor(){super(g.ID,C.localize(0,null),void 0,!1)}}e.$ii=g;function P(D){return{id:D.id,label:D.label,class:void 0,enabled:D.enabled??!0,checked:D.checked??!1,run:async()=>D.run(),tooltip:D.label}}e.$ji=P}),define(Pe[129],Ae([10,11]),function(pe,e){return pe.create("vs/base/common/date",e)}),define(Pe[130],Ae([1,0,129]),function(pe,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5l=e.$4l=void 0;const R=60,C=R*60,L=C*24,A=L*7,h=L*30,S=L*365;function g(D,u,p,$){typeof D!="number"&&(D=D.getTime());const d=Math.round((new Date().getTime()-D)/1e3);if(d<-30)return(0,y.localize)(0,null,g(new Date().getTime()+d*1e3,!1));if(!$&&d<30)return(0,y.localize)(1,null);let t;return d<R?(t=d,u?t===1?p?(0,y.localize)(2,null,t):(0,y.localize)(3,null,t):p?(0,y.localize)(4,null,t):(0,y.localize)(5,null,t):t===1?p?(0,y.localize)(6,null,t):(0,y.localize)(7,null,t):p?(0,y.localize)(8,null,t):(0,y.localize)(9,null,t)):d<C?(t=Math.floor(d/R),u?t===1?p?(0,y.localize)(10,null,t):(0,y.localize)(11,null,t):p?(0,y.localize)(12,null,t):(0,y.localize)(13,null,t):t===1?p?(0,y.localize)(14,null,t):(0,y.localize)(15,null,t):p?(0,y.localize)(16,null,t):(0,y.localize)(17,null,t)):d<L?(t=Math.floor(d/C),u?t===1?p?(0,y.localize)(18,null,t):(0,y.localize)(19,null,t):p?(0,y.localize)(20,null,t):(0,y.localize)(21,null,t):t===1?p?(0,y.localize)(22,null,t):(0,y.localize)(23,null,t):p?(0,y.localize)(24,null,t):(0,y.localize)(25,null,t)):d<A?(t=Math.floor(d/L),u?t===1?(0,y.localize)(26,null,t):(0,y.localize)(27,null,t):t===1?(0,y.localize)(28,null,t):(0,y.localize)(29,null,t)):d<h?(t=Math.floor(d/A),u?t===1?p?(0,y.localize)(30,null,t):(0,y.localize)(31,null,t):p?(0,y.localize)(32,null,t):(0,y.localize)(33,null,t):t===1?p?(0,y.localize)(34,null,t):(0,y.localize)(35,null,t):p?(0,y.localize)(36,null,t):(0,y.localize)(37,null,t)):d<S?(t=Math.floor(d/h),u?t===1?p?(0,y.localize)(38,null,t):(0,y.localize)(39,null,t):p?(0,y.localize)(40,null,t):(0,y.localize)(41,null,t):t===1?p?(0,y.localize)(42,null,t):(0,y.localize)(43,null,t):p?(0,y.localize)(44,null,t):(0,y.localize)(45,null,t)):(t=Math.floor(d/S),u?t===1?p?(0,y.localize)(46,null,t):(0,y.localize)(47,null,t):p?(0,y.localize)(48,null,t):(0,y.localize)(49,null,t):t===1?p?(0,y.localize)(50,null,t):(0,y.localize)(51,null,t):p?(0,y.localize)(52,null,t):(0,y.localize)(53,null,t))}e.$4l=g;function P(D){return D.getFullYear()+"-"+String(D.getMonth()+1).padStart(2,"0")+"-"+String(D.getDate()).padStart(2,"0")+"T"+String(D.getHours()).padStart(2,"0")+":"+String(D.getMinutes()).padStart(2,"0")+":"+String(D.getSeconds()).padStart(2,"0")+"."+(D.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.$5l=P}),define(Pe[131],Ae([10,11]),function(pe,e){return pe.create("vs/base/common/errorMessage",e)}),define(Pe[41],Ae([1,0,18,16,131]),function(pe,e,y,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mi=e.$li=e.$ki=void 0;function L(D,u){return u&&(D.stack||D.stacktrace)?C.localize(0,null,h(D),A(D.stack)||A(D.stacktrace)):h(D)}function A(D){return Array.isArray(D)?D.join(`
`):D}function h(D){return D.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${D.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof D.code=="string"&&typeof D.errno=="number"&&typeof D.syscall=="string"?C.localize(1,null,D.message):D.message||C.localize(2,null)}function S(D=null,u=!1){if(!D)return C.localize(3,null);if(Array.isArray(D)){const p=y.$Af(D),$=S(p[0],u);return p.length>1?C.localize(4,null,$,p.length):$}if(R.$le(D))return D;if(D.detail){const p=D.detail;if(p.error)return L(p.error,u);if(p.exception)return L(p.exception,u)}return D.stack?L(D,u):D.message?D.message:C.localize(5,null)}e.$ki=S;function g(D){const u=D;return u instanceof Error&&Array.isArray(u.actions)}e.$li=g;function P(D,u){let p;return typeof D=="string"?p=new Error(D):p=D,p.actions=u,p}e.$mi=P}),define(Pe[132],Ae([1,0,65,19]),function(pe,e,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gq=e.$fq=e.$eq=e.$dq=e.$cq=e.$bq=e.$aq=e.$_p=e.$$p=e.$0p=e.$9p=e.$8p=e.$7p=void 0;const C=new y.$T(()=>{const k=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:k,collatorIsNumeric:k.resolvedOptions().numeric}}),L=new y.$T(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),A=new y.$T(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function h(k,r,l=!1){const f=k||"",F=r||"",W=C.value.collator.compare(f,F);return C.value.collatorIsNumeric&&W===0&&f!==F?f<F?-1:1:W}e.$7p=h;function S(k,r){const l=L.value.collator;return k=k||"",r=r||"",E(l,k,r)}e.$8p=S;function g(k,r){const l=L.value.collator;return k=k||"",r=r||"",s(k,r)||E(l,k,r)}e.$9p=g;function P(k,r){const l=L.value.collator;return k=k||"",r=r||"",a(k,r)||E(l,k,r)}e.$0p=P;function D(k,r){return k=k||"",r=r||"",k===r?0:k<r?-1:1}e.$$p=D;function u(k,r){const[l,f]=c(k),[F,W]=c(r);let V=C.value.collator.compare(f,W);if(V===0){if(C.value.collatorIsNumeric&&f!==W)return f<W?-1:1;if(V=C.value.collator.compare(l,F),C.value.collatorIsNumeric&&V===0&&l!==F)return l<F?-1:1}return V}e.$_p=u;function p(k,r){k=k||"",r=r||"";const l=m(k),f=m(r),F=L.value.collator,W=A.value.collator;return E(W,l,f)||E(F,k,r)}e.$aq=p;function $(k,r){k=k||"",r=r||"";const l=m(k),f=m(r),F=L.value.collator,W=A.value.collator;return E(W,l,f)||s(k,r)||E(F,k,r)}e.$bq=$;function d(k,r){k=k||"",r=r||"";const l=m(k),f=m(r),F=L.value.collator,W=A.value.collator;return E(W,l,f)||a(k,r)||E(F,k,r)}e.$cq=d;function t(k,r){k=k||"",r=r||"";const l=m(k).toLowerCase(),f=m(r).toLowerCase();return l!==f?l<f?-1:1:k!==r?k<r?-1:1:0}e.$dq=t;const i=/^(.*?)(\.([^.]*))?$/;function c(k,r=!1){const l=k?i.exec(k):[];let f=[l&&l[1]||"",l&&l[3]||""];return r&&(!f[0]&&f[1]||f[0]&&f[0].charAt(0)===".")&&(f=[f[0]+"."+f[1],""]),f}function m(k){const r=k?i.exec(k):[];return r&&r[1]&&r[1].charAt(0)!=="."&&r[3]||""}function E(k,r,l){const f=k.compare(r,l);return f!==0?f:r.length!==l.length?r.length<l.length?-1:1:0}function b(k){const r=k.charAt(0);return r.toLocaleUpperCase()!==r}function n(k){const r=k.charAt(0);return r.toLocaleLowerCase()!==r}function a(k,r){return b(k)&&n(r)?-1:n(k)&&b(r)?1:0}function s(k,r){return n(k)&&b(r)?-1:b(k)&&n(r)?1:0}function o(k,r,l=!1){return l||(k=k&&k.toLowerCase(),r=r&&r.toLowerCase()),k===r?0:k<r?-1:1}function w(k,r,l=!1){const f=k.split(R.sep),F=r.split(R.sep),W=f.length-1,V=F.length-1;let B,j;for(let U=0;;U++){if(B=W===U,j=V===U,B&&j)return h(f[U],F[U],l);if(B)return-1;if(j)return 1;const z=o(f[U],F[U],l);if(z!==0)return z}}e.$eq=w;function v(k,r,l){const f=k.toLowerCase(),F=r.toLowerCase(),W=I(k,r,l);if(W)return W;const V=f.endsWith(l),B=F.endsWith(l);if(V!==B)return V?-1:1;const j=h(f,F);return j!==0?j:f.localeCompare(F)}e.$fq=v;function I(k,r,l){const f=k.toLowerCase(),F=r.toLowerCase(),W=f.startsWith(l),V=F.startsWith(l);if(W!==V)return W?-1:1;if(W&&V){if(f.length<F.length)return-1;if(f.length>F.length)return 1}return 0}e.$gq=I}),define(Pe[42],Ae([1,0,19,22,15,16]),function(pe,e,y,R,C,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Se=e.$Re=e.$Qe=e.$Pe=e.$Oe=e.$Ne=e.$Me=e.$Le=e.$Ke=e.$Je=e.$Ie=e.$He=e.$Ge=e.$Fe=e.$Ee=e.$De=void 0;function A(v){return v===47||v===92}e.$De=A;function h(v){return v.replace(/[\\/]/g,y.$8c.sep)}e.$Ee=h;function S(v){return v.indexOf("/")===-1&&(v=h(v)),/^[a-zA-Z]:(\/|$)/.test(v)&&(v="/"+v),v}e.$Fe=S;function g(v,I=y.$8c.sep){if(!v)return"";const k=v.length,r=v.charCodeAt(0);if(A(r)){if(A(v.charCodeAt(1))&&!A(v.charCodeAt(2))){let f=3;const F=f;for(;f<k&&!A(v.charCodeAt(f));f++);if(F!==f&&!A(v.charCodeAt(f+1))){for(f+=1;f<k;f++)if(A(v.charCodeAt(f)))return v.slice(0,f+1).replace(/[\\/]/g,I)}}return I}else if(i(r)&&v.charCodeAt(1)===58)return A(v.charCodeAt(2))?v.slice(0,2)+I:v.slice(0,2);let l=v.indexOf("://");if(l!==-1){for(l+=3;l<k;l++)if(A(v.charCodeAt(l)))return v.slice(0,l+1)}return""}e.$Ge=g;function P(v){if(!R.$i||!v||v.length<5)return!1;let I=v.charCodeAt(0);if(I!==92||(I=v.charCodeAt(1),I!==92))return!1;let k=2;const r=k;for(;k<v.length&&(I=v.charCodeAt(k),I!==92);k++);return!(r===k||(I=v.charCodeAt(k+1),isNaN(I)||I===92))}e.$He=P;const D=/[\\/:\*\?"<>\|]/g,u=/[\\/]/g,p=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function $(v,I=R.$i){const k=I?D:u;return!(!v||v.length===0||/^\s+$/.test(v)||(k.lastIndex=0,k.test(v))||I&&p.test(v)||v==="."||v===".."||I&&v[v.length-1]==="."||I&&v.length!==v.trim().length||v.length>255)}e.$Ie=$;function d(v,I,k){const r=v===I;return!k||r?r:!v||!I?!1:(0,C.$Od)(v,I)}e.$Je=d;function t(v,I,k,r=y.sep){if(v===I)return!0;if(!v||!I||I.length>v.length)return!1;if(k){if(!(0,C.$Pd)(v,I))return!1;if(I.length===v.length)return!0;let f=I.length;return I.charAt(I.length-1)===r&&f--,v.charAt(f)===r}return I.charAt(I.length-1)!==r&&(I+=r),v.indexOf(I)===0}e.$Ke=t;function i(v){return v>=65&&v<=90||v>=97&&v<=122}e.$Le=i;function c(v,I){return R.$i&&v.endsWith(":")&&(v+=y.sep),(0,y.$0c)(v)||(v=(0,y.$$c)(I,v)),v=(0,y.$9c)(v),R.$i?(v=(0,C.$xd)(v,y.sep),v.endsWith(":")&&(v+=y.sep)):(v=(0,C.$xd)(v,y.sep),v||(v=y.sep)),v}e.$Me=c;function m(v){const I=(0,y.$9c)(v);return R.$i?v.length>3?!1:E(I)&&(v.length===2||I.charCodeAt(2)===92):I===y.$8c.sep}e.$Ne=m;function E(v,I=R.$i){return I?i(v.charCodeAt(0))&&v.charCodeAt(1)===58:!1}e.$Oe=E;function b(v,I=R.$i){return E(v,I)?v[0]:void 0}e.$Pe=b;function n(v,I,k){return I.length>v.length?-1:v===I?0:(k&&(v=v.toLowerCase(),I=I.toLowerCase()),v.indexOf(I))}e.$Qe=n;function a(v){const I=v.split(":");let k,r,l;for(const f of I){const F=Number(f);(0,L.$pe)(F)?r===void 0?r=F:l===void 0&&(l=F):k=k?[k,f].join(":"):f}if(!k)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:k,line:r!==void 0?r:void 0,column:l!==void 0?l:r!==void 0?1:void 0}}e.$Re=a;const s="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",o="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function w(v,I,k=8){let r="";for(let f=0;f<k;f++){let F;f===0&&R.$i&&!I&&(k===3||k===4)?F=o:F=s,r+=F.charAt(Math.floor(Math.random()*F.length))}let l;return I?l=`${I}-${r}`:l=r,v?(0,y.$$c)(v,l):l}e.$Se=w}),define(Pe[67],Ae([1,0,19]),function(pe,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ir=e.$Hr=e.$Gr=e.$Fr=e.$Er=void 0,e.$Er=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const R={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},C={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function L(P){const D=(0,y.$dd)(P),u=R[D.toLowerCase()];return u!==void 0?u:A(P)}e.$Fr=L;function A(P){const D=(0,y.$dd)(P);return C[D.toLowerCase()]}e.$Gr=A;function h(P){for(const D in C)if(C[D]===P)return D}e.$Hr=h;const S=/^(.+)\/(.+?)(;.+)?$/;function g(P,D){const u=S.exec(P);return u?`${u[1].toLowerCase()}/${u[2].toLowerCase()}${u[3]??""}`:D?void 0:P}e.$Ir=g}),define(Pe[68],Ae([1,0,25,2]),function(pe,e,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9g=e.$8g=e.$7g=void 0;function C(S){return JSON.stringify(S,A)}e.$7g=C;function L(S){let g=JSON.parse(S);return g=h(g),g}e.$8g=L;function A(S,g){return g instanceof RegExp?{$mid:2,source:g.source,flags:g.flags}:g}function h(S,g=0){if(!S||g>200)return S;if(typeof S=="object"){switch(S.$mid){case 1:return R.URI.revive(S);case 2:return new RegExp(S.source,S.flags);case 16:return new Date(S.source)}if(S instanceof y.$Hc||S instanceof Uint8Array)return S;if(Array.isArray(S))for(let P=0;P<S.length;++P)S[P]=h(S[P],g+1);else for(const P in S)Object.hasOwnProperty.call(S,P)&&(S[P]=h(S[P],g+1))}return S}e.$9g=h}),define(Pe[12],Ae([1,0,9,22,2]),function(pe,e,y,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$4e=e.$3e=e.$2e=e.$1e=e.$Ze=e.$Ye=e.$Xe=e.$We=e.Schemas=void 0;var L;(function(g){g.inMemory="inmemory",g.vscode="vscode",g.internal="private",g.walkThrough="walkThrough",g.walkThroughSnippet="walkThroughSnippet",g.http="http",g.https="https",g.file="file",g.mailto="mailto",g.untitled="untitled",g.data="data",g.command="command",g.vscodeRemote="vscode-remote",g.vscodeRemoteResource="vscode-remote-resource",g.vscodeManagedRemoteResource="vscode-managed-remote-resource",g.vscodeUserData="vscode-userdata",g.vscodeCustomEditor="vscode-custom-editor",g.vscodeNotebookCell="vscode-notebook-cell",g.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",g.vscodeNotebookCellOutput="vscode-notebook-cell-output",g.vscodeInteractiveInput="vscode-interactive-input",g.vscodeSettings="vscode-settings",g.vscodeWorkspaceTrust="vscode-workspace-trust",g.vscodeTerminal="vscode-terminal",g.vscodeChatSesssion="vscode-chat-editor",g.webviewPanel="webview-panel",g.vscodeWebview="vscode-webview",g.extension="extension",g.vscodeFileResource="vscode-file",g.tmp="tmp",g.vsls="vsls",g.vscodeSourceControl="vscode-scm"})(L||(e.Schemas=L={})),e.$We="vscode-tkn",e.$Xe="tkn";class A{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f=`/${L.vscodeRemoteResource}`}setPreferredWebSchema(P){this.d=P}setDelegate(P){this.e=P}setServerRootPath(P){this.f=`${P}/${L.vscodeRemoteResource}`}set(P,D,u){this.a[P]=D,this.b[P]=u}setConnectionToken(P,D){this.c[P]=D}getPreferredWebSchema(){return this.d}rewrite(P){if(this.e)try{return this.e(P)}catch(t){return y.$Y(t),P}const D=P.authority;let u=this.a[D];u&&u.indexOf(":")!==-1&&u.indexOf("[")===-1&&(u=`[${u}]`);const p=this.b[D],$=this.c[D];let d=`path=${encodeURIComponent(P.path)}`;return typeof $=="string"&&(d+=`&${e.$Xe}=${encodeURIComponent($)}`),C.URI.from({scheme:R.$o?this.d:L.vscodeRemoteResource,authority:`${u}:${p}`,path:this.f,query:d})}}e.$Ye=new A,e.$Ze="vs/../../extensions",e.$1e="vs/../../node_modules",e.$2e="vs/../../node_modules.asar",e.$3e="vs/../../node_modules.asar.unpacked";class h{static{this.a="vscode-app"}asBrowserUri(P){const D=this.b(P,pe);return this.uriToBrowserUri(D)}uriToBrowserUri(P){return P.scheme===L.vscodeRemote?e.$Ye.rewrite(P):P.scheme===L.file&&(R.$m||R.$p&&R.$g.origin===`${L.vscodeFileResource}://${h.a}`)?P.with({scheme:L.vscodeFileResource,authority:P.authority||h.a,query:null,fragment:null}):P}asFileUri(P){const D=this.b(P,pe);return this.uriToFileUri(D)}uriToFileUri(P){return P.scheme===L.vscodeFileResource?P.with({scheme:L.file,authority:P.authority!==h.a?P.authority:null,query:null,fragment:null}):P}b(P,D){return C.URI.isUri(P)?P:C.URI.parse(D.toUrl(P))}}e.$4e=new h;var S;(function(g){const P=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);g.CoopAndCoep=Object.freeze(P.get("3"));const D="vscode-coi";function u($){let d;typeof $=="string"?d=new URL($).searchParams:$ instanceof URL?d=$.searchParams:C.URI.isUri($)&&(d=new URL($.toString(!0)).searchParams);const t=d?.get(D);if(t)return P.get(t)}g.getHeadersFromQuery=u;function p($,d,t){if(!globalThis.crossOriginIsolated)return;const i=d&&t?"3":t?"2":"1";$ instanceof URLSearchParams?$.set(D,i):$[D]=i}g.addSearchParam=p})(S||(e.COI=S={}))}),define(Pe[23],Ae([1,0,42,12,19,22,15,2]),function(pe,e,y,R,C,L,A,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qg=e.DataUri=e.$pg=e.$og=e.$ng=e.$mg=e.$lg=e.$kg=e.$jg=e.$ig=e.$hg=e.$gg=e.$fg=e.$eg=e.$dg=e.$cg=e.$bg=e.$ag=e.$_f=e.$$f=e.$0f=e.$9f=e.$8f=e.$7f=void 0;function S(p){return(0,h.$Ve)(p,!0)}e.$7f=S;class g{constructor($){this.a=$}compare($,d,t=!1){return $===d?0:(0,A.$Hd)(this.getComparisonKey($,t),this.getComparisonKey(d,t))}isEqual($,d,t=!1){return $===d?!0:!$||!d?!1:this.getComparisonKey($,t)===this.getComparisonKey(d,t)}getComparisonKey($,d=!1){return $.with({path:this.a($)?$.path.toLowerCase():void 0,fragment:d?null:void 0}).toString()}ignorePathCasing($){return this.a($)}isEqualOrParent($,d,t=!1){if($.scheme===d.scheme){if($.scheme===R.Schemas.file)return y.$Ke(S($),S(d),this.a($))&&$.query===d.query&&(t||$.fragment===d.fragment);if((0,e.$lg)($.authority,d.authority))return y.$Ke($.path,d.path,this.a($),"/")&&$.query===d.query&&(t||$.fragment===d.fragment)}return!1}joinPath($,...d){return h.URI.joinPath($,...d)}basenameOrAuthority($){return(0,e.$dg)($)||$.authority}basename($){return C.$8c.basename($.path)}extname($){return C.$8c.extname($.path)}dirname($){if($.path.length===0)return $;let d;return $.scheme===R.Schemas.file?d=h.URI.file(C.$bd(S($))).path:(d=C.$8c.dirname($.path),$.authority&&d.length&&d.charCodeAt(0)!==47&&(console.error(`dirname("${$.toString})) resulted in a relative path`),d="/")),$.with({path:d})}normalizePath($){if(!$.path.length)return $;let d;return $.scheme===R.Schemas.file?d=h.URI.file(C.$9c(S($))).path:d=C.$8c.normalize($.path),$.with({path:d})}relativePath($,d){if($.scheme!==d.scheme||!(0,e.$lg)($.authority,d.authority))return;if($.scheme===R.Schemas.file){const c=C.$ad(S($),S(d));return L.$i?y.$Ee(c):c}let t=$.path||"/";const i=d.path||"/";if(this.a($)){let c=0;for(const m=Math.min(t.length,i.length);c<m&&!(t.charCodeAt(c)!==i.charCodeAt(c)&&t.charAt(c).toLowerCase()!==i.charAt(c).toLowerCase());c++);t=i.substr(0,c)+t.substr(c)}return C.$8c.relative(t,i)}resolvePath($,d){if($.scheme===R.Schemas.file){const t=h.URI.file(C.$_c(S($),d));return $.with({authority:t.authority,path:t.path})}return d=y.$Fe(d),$.with({path:C.$8c.resolve($.path,d)})}isAbsolutePath($){return!!$.path&&$.path[0]==="/"}isEqualAuthority($,d){return $===d||$!==void 0&&d!==void 0&&(0,A.$Od)($,d)}hasTrailingPathSeparator($,d=C.sep){if($.scheme===R.Schemas.file){const t=S($);return t.length>y.$Ge(t).length&&t[t.length-1]===d}else{const t=$.path;return t.length>1&&t.charCodeAt(t.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test($.fsPath)}}removeTrailingPathSeparator($,d=C.sep){return(0,e.$mg)($,d)?$.with({path:$.path.substr(0,$.path.length-1)}):$}addTrailingPathSeparator($,d=C.sep){let t=!1;if($.scheme===R.Schemas.file){const i=S($);t=i!==void 0&&i.length===y.$Ge(i).length&&i[i.length-1]===d}else{d="/";const i=$.path;t=i.length===1&&i.charCodeAt(i.length-1)===47}return!t&&!(0,e.$mg)($,d)?$.with({path:$.path+"/"}):$}}e.$8f=g,e.$9f=new g(()=>!1),e.$0f=new g(p=>p.scheme===R.Schemas.file?!L.$k:!0),e.$$f=new g(p=>!0),e.$_f=e.$9f.isEqual.bind(e.$9f),e.$ag=e.$9f.isEqualOrParent.bind(e.$9f),e.$bg=e.$9f.getComparisonKey.bind(e.$9f),e.$cg=e.$9f.basenameOrAuthority.bind(e.$9f),e.$dg=e.$9f.basename.bind(e.$9f),e.$eg=e.$9f.extname.bind(e.$9f),e.$fg=e.$9f.dirname.bind(e.$9f),e.$gg=e.$9f.joinPath.bind(e.$9f),e.$hg=e.$9f.normalizePath.bind(e.$9f),e.$ig=e.$9f.relativePath.bind(e.$9f),e.$jg=e.$9f.resolvePath.bind(e.$9f),e.$kg=e.$9f.isAbsolutePath.bind(e.$9f),e.$lg=e.$9f.isEqualAuthority.bind(e.$9f),e.$mg=e.$9f.hasTrailingPathSeparator.bind(e.$9f),e.$ng=e.$9f.removeTrailingPathSeparator.bind(e.$9f),e.$og=e.$9f.addTrailingPathSeparator.bind(e.$9f);function P(p,$){const d=[];for(let t=0;t<p.length;t++){const i=$(p[t]);p.some((c,m)=>m===t?!1:(0,e.$ag)(i,$(c)))||d.push(p[t])}return d}e.$pg=P;var D;(function(p){p.META_DATA_LABEL="label",p.META_DATA_DESCRIPTION="description",p.META_DATA_SIZE="size",p.META_DATA_MIME="mime";function $(d){const t=new Map;d.path.substring(d.path.indexOf(";")+1,d.path.lastIndexOf(";")).split(";").forEach(m=>{const[E,b]=m.split(":");E&&b&&t.set(E,b)});const c=d.path.substring(0,d.path.indexOf(";"));return c&&t.set(p.META_DATA_MIME,c),t}p.parseMetaData=$})(D||(e.DataUri=D={}));function u(p,$,d){if($){let t=p.path;return t&&t[0]!==C.$8c.sep&&(t=C.$8c.sep+t),p.with({scheme:d,authority:$,path:t})}return p.with({scheme:d})}e.$qg=u}),define(Pe[13],Ae([1,0,21,9,5,6,23,22,121]),function(pe,e,y,R,C,L,A,h,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3g=e.$2g=e.$1g=e.Promises=e.$Zg=e.$Yg=e.$Xg=e.$Wg=e.$Vg=e.$Ug=e.$Tg=e.$Sg=e.$Rg=e.$Qg=e.$Pg=e.$Og=e.$Ng=e.$Mg=e.$Lg=e.$Kg=e.$Jg=e.$Ig=e.$Hg=e.$Gg=e.$Fg=e.$Eg=e.$Dg=e.$Cg=e.$Bg=e.$Ag=e.$zg=e.$yg=e.$xg=e.$wg=e.$vg=e.$ug=e.$tg=e.$sg=e.$rg=void 0;function g(O){return!!O&&typeof O.then=="function"}e.$rg=g;function P(O){const J=new y.$rc,he=O(J.token),Ee=new Promise((ve,be)=>{const De=J.token.onCancellationRequested(()=>{De.dispose(),J.dispose(),be(new R.$3)});Promise.resolve(he).then(oe=>{De.dispose(),J.dispose(),ve(oe)},oe=>{De.dispose(),J.dispose(),be(oe)})});return new class{cancel(){J.cancel()}then(ve,be){return Ee.then(ve,be)}catch(ve){return this.then(void 0,ve)}finally(ve){return Ee.finally(ve)}}}e.$sg=P;function D(O,J,he){return new Promise((Ee,ve)=>{const be=J.onCancellationRequested(()=>{be.dispose(),Ee(he)});O.then(Ee,ve).finally(()=>be.dispose())})}e.$tg=D;function u(O,J){return new Promise((he,Ee)=>{const ve=J.onCancellationRequested(()=>{ve.dispose(),Ee(new R.$3)});O.then(he,Ee).finally(()=>ve.dispose())})}e.$ug=u;async function p(O){let J=-1;const he=O.map((Ee,ve)=>Ee.then(be=>(J=ve,be)));try{return await Promise.race(he)}finally{O.forEach((Ee,ve)=>{ve!==J&&Ee.cancel()})}}e.$vg=p;function $(O,J,he){let Ee;const ve=setTimeout(()=>{Ee?.(void 0),he?.()},J);return Promise.race([O.finally(()=>clearTimeout(ve)),new Promise(be=>Ee=be)])}e.$wg=$;function d(O){return new Promise((J,he)=>{const Ee=O();g(Ee)?Ee.then(J,he):J(Ee)})}e.$xg=d;class t{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(J){if(this.f)throw new Error("Throttler is disposed");if(this.a){if(this.d=J,!this.b){const he=()=>{if(this.b=null,this.f)return;const Ee=this.queue(this.d);return this.d=null,Ee};this.b=new Promise(Ee=>{this.a.then(he,he).then(Ee)})}return new Promise((he,Ee)=>{this.b.then(he,Ee)})}return this.a=J(),new Promise((he,Ee)=>{this.a.then(ve=>{this.a=null,he(ve)},ve=>{this.a=null,Ee(ve)})})}dispose(){this.f=!0}}e.$yg=t;class i{constructor(){this.a=Promise.resolve(null)}queue(J){return this.a=this.a.then(()=>J(),()=>J())}}e.$zg=i;class c{constructor(){this.a=new Map}queue(J,he){const ve=(this.a.get(J)??Promise.resolve()).catch(()=>{}).then(he).finally(()=>{this.a.get(J)===ve&&this.a.delete(J)});return this.a.set(J,ve),ve}}e.$Ag=c;const m=(O,J)=>{let he=!0;const Ee=setTimeout(()=>{he=!1,J()},O);return{isTriggered:()=>he,dispose:()=>{clearTimeout(Ee),he=!1}}},E=O=>{let J=!0;return queueMicrotask(()=>{J&&(J=!1,O())}),{isTriggered:()=>J,dispose:()=>{J=!1}}};class b{constructor(J){this.defaultDelay=J,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(J,he=this.defaultDelay){this.g=J,this.h(),this.b||(this.b=new Promise((ve,be)=>{this.d=ve,this.f=be}).then(()=>{if(this.b=null,this.d=null,this.g){const ve=this.g;return this.g=null,ve()}}));const Ee=()=>{this.a=null,this.d?.(null)};return this.a=he===S.$ec?E(Ee):m(he,Ee),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new R.$3),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$Bg=b;class n{constructor(J){this.a=new b(J),this.b=new t}trigger(J,he){return this.a.trigger(()=>this.b.queue(J),he)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$Cg=n;class a{constructor(){this.a=!1,this.b=new Promise((J,he)=>{this.d=J})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$Dg=a;class s extends a{constructor(J){super(),this.f=setTimeout(()=>this.open(),J)}open(){clearTimeout(this.f),super.open()}}e.$Eg=s;function o(O,J){return J?new Promise((he,Ee)=>{const ve=setTimeout(()=>{be.dispose(),he()},O),be=J.onCancellationRequested(()=>{clearTimeout(ve),be.dispose(),Ee(new R.$3)})}):P(he=>o(O,he))}e.$Fg=o;function w(O,J=0){const he=setTimeout(O,J);return(0,L.$kb)(()=>clearTimeout(he))}e.$Gg=w;function v(O){const J=[];let he=0;const Ee=O.length;function ve(){return he<Ee?O[he++]():null}function be(De){De!=null&&J.push(De);const oe=ve();return oe?oe.then(be):Promise.resolve(J)}return Promise.resolve(null).then(be)}e.$Hg=v;function I(O,J=Ee=>!!Ee,he=null){let Ee=0;const ve=O.length,be=()=>{if(Ee>=ve)return Promise.resolve(he);const De=O[Ee++];return Promise.resolve(De()).then(de=>J(de)?Promise.resolve(de):be())};return be()}e.$Ig=I;function k(O,J=Ee=>!!Ee,he=null){if(O.length===0)return Promise.resolve(he);let Ee=O.length;const ve=()=>{Ee=-1;for(const be of O)be.cancel?.()};return new Promise((be,De)=>{for(const oe of O)oe.then(de=>{--Ee>=0&&J(de)?(ve(),be(de)):Ee===0&&be(he)}).catch(de=>{--Ee>=0&&(ve(),De(de))})})}e.$Jg=k;class r{constructor(J){this.a=0,this.d=J,this.f=[],this.b=0,this.g=new C.$hc}get onDrained(){return this.g.event}get size(){return this.a}queue(J){return this.a++,new Promise((he,Ee)=>{this.f.push({factory:J,c:he,e:Ee}),this.h()})}h(){for(;this.f.length&&this.b<this.d;){const J=this.f.shift();this.b++;const he=J.factory();he.then(J.c,J.e),he.then(()=>this.j(),()=>this.j())}}j(){this.a--,this.b--,this.f.length>0?this.h():this.g.fire()}dispose(){this.g.dispose()}}e.$Kg=r;class l extends r{constructor(){super(1)}}e.$Lg=l;class f{constructor(){this.a=new ye,this.b=0}queue(J){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,J())):this.a.run(this.b++,J())}}e.$Mg=f;class F{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const J=new X;return this.b.add(J),J.p}g(){for(const[,J]of this.a)if(J.size>0)return!1;return!0}queueFor(J,he=A.$9f){const Ee=he.getComparisonKey(J);let ve=this.a.get(Ee);if(!ve){ve=new l;const be=this.f++,De=C.Event.once(ve.onDrained)(()=>{ve?.dispose(),this.a.delete(Ee),this.h(),this.d?.deleteAndDispose(be),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new L.$ub),this.d.set(be,De),this.a.set(Ee,ve)}return ve}h(){this.g()&&this.j()}j(){for(const J of this.b)J.complete();this.b.clear()}dispose(){for(const[,J]of this.a)J.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$Ng=F;class W{constructor(J,he){this.a=-1,typeof J=="function"&&typeof he=="number"&&this.setIfNotSet(J,he)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(J,he){this.cancel(),this.a=setTimeout(()=>{this.a=-1,J()},he)}setIfNotSet(J,he){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,J()},he))}}e.$Og=W;class V{constructor(){this.a=-1}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearInterval(this.a),this.a=-1)}cancelAndSet(J,he){this.cancel(),this.a=setInterval(()=>{J()},he)}}e.$Pg=V;class B{constructor(J,he){this.b=-1,this.a=J,this.d=he,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(J=this.d){this.cancel(),this.b=setTimeout(this.f,J)}get delay(){return this.d}set delay(J){this.d=J}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$Qg=B;class j{constructor(J,he){he%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${he}ms is not a multiple of 1000ms.`),this.a=J,this.b=he,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(J=this.b){J%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${J}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(J/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$Rg=j;class U extends B{constructor(J,he){super(J,he),this.j=[]}work(J){this.j.push(J),this.isScheduled()||this.schedule()}h(){const J=this.j;this.j=[],this.a?.(J)}dispose(){this.j=[],super.dispose()}}e.$Sg=U;class z extends L.$mb{constructor(J,he){super(),this.g=J,this.h=he,this.a=[],this.b=this.B(new L.$nb),this.f=!1}get pending(){return this.a.length}work(J){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+J.length>this.g.maxBufferedWork)return!1}else if(this.pending+J.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const he of J)this.a.push(he);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new B(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$Tg=z,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.$Ug=O=>{(0,h.$A)(()=>{if(J)return;const he=Date.now()+15;O(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,he-Date.now())}}))});let J=!1;return{dispose(){J||(J=!0)}}}:e.$Ug=(O,J)=>{const he=requestIdleCallback(O,typeof J=="number"?{timeout:J}:void 0);let Ee=!1;return{dispose(){Ee||(Ee=!0,cancelIdleCallback(he))}}}}();class ie{constructor(J){this.d=!1,this.a=()=>{try{this.f=J()}catch(he){this.g=he}finally{this.d=!0}},this.b=(0,e.$Ug)(()=>this.a())}dispose(){this.b.dispose()}get value(){if(this.d||(this.b.dispose(),this.a()),this.g)throw this.g;return this.f}get isInitialized(){return this.d}}e.$Vg=ie;async function Y(O,J,he){let Ee;for(let ve=0;ve<he;ve++)try{return await O()}catch(be){Ee=be,await o(J)}throw Ee}e.$Wg=Y;class ye{isRunning(J){return typeof J=="number"?this.a?.taskId===J:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(J,he,Ee){return this.a={taskId:J,cancel:()=>Ee?.(),promise:he},he.then(()=>this.d(J),()=>this.d(J)),he}d(J){this.a&&J===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const J=this.b;this.b=void 0,J.run().then(J.promiseResolve,J.promiseReject)}}queue(J){if(this.b)this.b.run=J;else{let he,Ee;const ve=new Promise((be,De)=>{he=be,Ee=De});this.b={run:J,promise:ve,promiseResolve:he,promiseReject:Ee}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$Xg=ye;class ke{constructor(J,he=()=>Date.now()){this.d=J,this.f=he,this.a=0,this.b=0}increment(){const J=this.f();return J-this.a>this.d&&(this.a=J,this.b=0),this.b++,this.b}}e.$Yg=ke;var Re;(function(O){O[O.Resolved=0]="Resolved",O[O.Rejected=1]="Rejected"})(Re||(Re={}));class X{get isRejected(){return this.d?.outcome===1}get isResolved(){return this.d?.outcome===0}get isSettled(){return!!this.d}get value(){return this.d?.outcome===0?this.d?.value:void 0}constructor(){this.p=new Promise((J,he)=>{this.a=J,this.b=he})}complete(J){return new Promise(he=>{this.a(J),this.d={outcome:0,value:J},he()})}error(J){return new Promise(he=>{this.b(J),this.d={outcome:1,value:J},he()})}cancel(){return this.error(new R.$3)}}e.$Zg=X;var le;(function(O){async function J(Ee){let ve;const be=await Promise.all(Ee.map(De=>De.then(oe=>oe,oe=>{ve||(ve=oe)})));if(typeof ve<"u")throw ve;return be}O.settled=J;function he(Ee){return new Promise(async(ve,be)=>{try{await Ee(ve,be)}catch(De){be(De)}})}O.withAsyncBody=he})(le||(e.Promises=le={}));var we;(function(O){O[O.Initial=0]="Initial",O[O.DoneOK=1]="DoneOK",O[O.DoneError=2]="DoneError"})(we||(we={}));class ae{static fromArray(J){return new ae(he=>{he.emitMany(J)})}static fromPromise(J){return new ae(async he=>{he.emitMany(await J)})}static fromPromises(J){return new ae(async he=>{await Promise.all(J.map(async Ee=>he.emitOne(await Ee)))})}static merge(J){return new ae(async he=>{await Promise.all(J.map(async Ee=>{for await(const ve of Ee)he.emitOne(ve)}))})}static{this.EMPTY=ae.fromArray([])}constructor(J){this.a=0,this.b=[],this.d=null,this.f=new C.$hc,queueMicrotask(async()=>{const he={emitOne:Ee=>this.g(Ee),emitMany:Ee=>this.h(Ee),reject:Ee=>this.k(Ee)};try{await Promise.resolve(J(he)),this.j()}catch(Ee){this.k(Ee)}finally{he.emitOne=void 0,he.emitMany=void 0,he.reject=void 0}})}[Symbol.asyncIterator](){let J=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(J<this.b.length)return{done:!1,value:this.b[J++]};if(this.a===1)return{done:!0,value:void 0};await C.Event.toPromise(this.f.event)}while(!0)}}}static map(J,he){return new ae(async Ee=>{for await(const ve of J)Ee.emitOne(he(ve))})}map(J){return ae.map(this,J)}static filter(J,he){return new ae(async Ee=>{for await(const ve of J)he(ve)&&Ee.emitOne(ve)})}filter(J){return ae.filter(this,J)}static coalesce(J){return ae.filter(J,he=>!!he)}coalesce(){return ae.coalesce(this)}static async toPromise(J){const he=[];for await(const Ee of J)he.push(Ee);return he}toPromise(){return ae.toPromise(this)}g(J){this.a===0&&(this.b.push(J),this.f.fire())}h(J){this.a===0&&(this.b=this.b.concat(J),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(J){this.a===0&&(this.a=2,this.d=J,this.f.fire())}}e.$1g=ae;class x extends ae{constructor(J,he){super(he),this.l=J}cancel(){this.l.cancel()}}e.$2g=x;function ue(O){const J=new y.$rc,he=O(J.token);return new x(J,async Ee=>{const ve=J.token.onCancellationRequested(()=>{ve.dispose(),J.dispose(),Ee.reject(new R.$3)});try{for await(const be of he){if(J.token.isCancellationRequested)return;Ee.emitOne(be)}ve.dispose(),J.dispose()}catch(be){ve.dispose(),J.dispose(),Ee.reject(be)}})}e.$3g=ue}),define(Pe[37],Ae([1,0,18,13,42,28,19,22,15]),function(pe,e,y,R,C,L,A,h,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tj=e.$sj=e.$rj=e.$qj=e.$pj=e.$oj=e.$nj=e.$mj=e.$lj=e.$kj=void 0;function g(){return Object.create(null)}e.$kj=g,e.$lj="**",e.$mj="/";const P="[/\\\\]",D="[^/\\\\]",u=/\//g;function p(ye,ke){switch(ye){case 0:return"";case 1:return`${D}*?`;default:return`(?:${P}|${D}+${P}${ke?`|${P}${D}+`:""})*?`}}function $(ye,ke){if(!ye)return[];const Re=[];let X=!1,le=!1,we="";for(const ae of ye){switch(ae){case ke:if(!X&&!le){Re.push(we),we="";continue}break;case"{":X=!0;break;case"}":X=!1;break;case"[":le=!0;break;case"]":le=!1;break}we+=ae}return we&&Re.push(we),Re}e.$nj=$;function d(ye){if(!ye)return"";let ke="";const Re=$(ye,e.$mj);if(Re.every(X=>X===e.$lj))ke=".*";else{let X=!1;Re.forEach((le,we)=>{if(le===e.$lj){if(X)return;ke+=p(2,we===Re.length-1)}else{let ae=!1,x="",ue=!1,O="";for(const J of le){if(J!=="}"&&ae){x+=J;continue}if(ue&&(J!=="]"||!O)){let he;J==="-"?he=J:(J==="^"||J==="!")&&!O?he="^":J===e.$mj?he="":he=(0,S.$sd)(J),O+=he;continue}switch(J){case"{":ae=!0;continue;case"[":ue=!0;continue;case"}":{const Ee=`(?:${$(x,",").map(ve=>d(ve)).join("|")})`;ke+=Ee,ae=!1,x="";break}case"]":{ke+="["+O+"]",ue=!1,O="";break}case"?":ke+=D;continue;case"*":ke+=p(1);continue;default:ke+=(0,S.$sd)(J)}}we<Re.length-1&&(Re[we+1]!==e.$lj||we+2<Re.length)&&(ke+=P)}X=le===e.$lj})}return ke}const t=/^\*\*\/\*\.[\w\.-]+$/,i=/^\*\*\/([\w\.-]+)\/?$/,c=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,m=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,E=/^\*\*((\/[\w\.-]+)+)\/?$/,b=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,n=new L.$Ai(1e4),a=function(){return!1},s=function(){return null};function o(ye,ke){if(!ye)return s;let Re;typeof ye!="string"?Re=ye.pattern:Re=ye,Re=Re.trim();const X=`${Re}_${!!ke.trimForExclusions}`;let le=n.get(X);if(le)return w(le,ye);let we;return t.test(Re)?le=I(Re.substr(4),Re):(we=i.exec(v(Re,ke)))?le=k(we[1],Re):(ke.trimForExclusions?m:c).test(Re)?le=r(Re,ke):(we=E.exec(v(Re,ke)))?le=l(we[1].substr(1),Re,!0):(we=b.exec(v(Re,ke)))?le=l(we[1],Re,!1):le=f(Re),n.set(X,le),w(le,ye)}function w(ye,ke){if(typeof ke=="string")return ye;const Re=function(X,le){return(0,C.$Ke)(X,ke.base,!h.$k)?ye((0,S.$wd)(X.substr(ke.base.length),A.sep),le):null};return Re.allBasenames=ye.allBasenames,Re.allPaths=ye.allPaths,Re.basenames=ye.basenames,Re.patterns=ye.patterns,Re}function v(ye,ke){return ke.trimForExclusions&&ye.endsWith("/**")?ye.substr(0,ye.length-2):ye}function I(ye,ke){return function(Re,X){return typeof Re=="string"&&Re.endsWith(ye)?ke:null}}function k(ye,ke){const Re=`/${ye}`,X=`\\${ye}`,le=function(ae,x){return typeof ae!="string"?null:x?x===ye?ke:null:ae===ye||ae.endsWith(Re)||ae.endsWith(X)?ke:null},we=[ye];return le.basenames=we,le.patterns=[ke],le.allBasenames=we,le}function r(ye,ke){const Re=ie(ye.slice(1,-1).split(",").map(x=>o(x,ke)).filter(x=>x!==s),ye),X=Re.length;if(!X)return s;if(X===1)return Re[0];const le=function(x,ue){for(let O=0,J=Re.length;O<J;O++)if(Re[O](x,ue))return ye;return null},we=Re.find(x=>!!x.allBasenames);we&&(le.allBasenames=we.allBasenames);const ae=Re.reduce((x,ue)=>ue.allPaths?x.concat(ue.allPaths):x,[]);return ae.length&&(le.allPaths=ae),le}function l(ye,ke,Re){const X=A.sep===A.$8c.sep,le=X?ye:ye.replace(u,A.sep),we=A.sep+le,ae=A.$8c.sep+ye;let x;return Re?x=function(ue,O){return typeof ue=="string"&&(ue===le||ue.endsWith(we)||!X&&(ue===ye||ue.endsWith(ae)))?ke:null}:x=function(ue,O){return typeof ue=="string"&&(ue===le||!X&&ue===ye)?ke:null},x.allPaths=[(Re?"*/":"./")+ye],x}function f(ye){try{const ke=new RegExp(`^${d(ye)}$`);return function(Re){return ke.lastIndex=0,typeof Re=="string"&&ke.test(Re)?ye:null}}catch{return s}}function F(ye,ke,Re){return!ye||typeof ke!="string"?!1:W(ye)(ke,void 0,Re)}e.$oj=F;function W(ye,ke={}){if(!ye)return a;if(typeof ye=="string"||V(ye)){const Re=o(ye,ke);if(Re===s)return a;const X=function(le,we){return!!Re(le,we)};return Re.allBasenames&&(X.allBasenames=Re.allBasenames),Re.allPaths&&(X.allPaths=Re.allPaths),X}return U(ye,ke)}e.$pj=W;function V(ye){const ke=ye;return ke?typeof ke.base=="string"&&typeof ke.pattern=="string":!1}e.$qj=V;function B(ye){return ye.allBasenames||[]}e.$rj=B;function j(ye){return ye.allPaths||[]}e.$sj=j;function U(ye,ke){const Re=ie(Object.getOwnPropertyNames(ye).map(x=>z(x,ye[x],ke)).filter(x=>x!==s)),X=Re.length;if(!X)return s;if(!Re.some(x=>!!x.requiresSiblings)){if(X===1)return Re[0];const x=function(J,he){let Ee;for(let ve=0,be=Re.length;ve<be;ve++){const De=Re[ve](J,he);if(typeof De=="string")return De;(0,R.$rg)(De)&&(Ee||(Ee=[]),Ee.push(De))}return Ee?(async()=>{for(const ve of Ee){const be=await ve;if(typeof be=="string")return be}return null})():null},ue=Re.find(J=>!!J.allBasenames);ue&&(x.allBasenames=ue.allBasenames);const O=Re.reduce((J,he)=>he.allPaths?J.concat(he.allPaths):J,[]);return O.length&&(x.allPaths=O),x}const le=function(x,ue,O){let J,he;for(let Ee=0,ve=Re.length;Ee<ve;Ee++){const be=Re[Ee];be.requiresSiblings&&O&&(ue||(ue=(0,A.$cd)(x)),J||(J=ue.substr(0,ue.length-(0,A.$dd)(x).length)));const De=be(x,ue,J,O);if(typeof De=="string")return De;(0,R.$rg)(De)&&(he||(he=[]),he.push(De))}return he?(async()=>{for(const Ee of he){const ve=await Ee;if(typeof ve=="string")return ve}return null})():null},we=Re.find(x=>!!x.allBasenames);we&&(le.allBasenames=we.allBasenames);const ae=Re.reduce((x,ue)=>ue.allPaths?x.concat(ue.allPaths):x,[]);return ae.length&&(le.allPaths=ae),le}function z(ye,ke,Re){if(ke===!1)return s;const X=o(ye,Re);if(X===s)return s;if(typeof ke=="boolean")return X;if(ke){const le=ke.when;if(typeof le=="string"){const we=(ae,x,ue,O)=>{if(!O||!X(ae,x))return null;const J=le.replace("$(basename)",()=>ue),he=O(J);return(0,R.$rg)(he)?he.then(Ee=>Ee?ye:null):he?ye:null};return we.requiresSiblings=!0,we}}return X}function ie(ye,ke){const Re=ye.filter(x=>!!x.basenames);if(Re.length<2)return ye;const X=Re.reduce((x,ue)=>{const O=ue.basenames;return O?x.concat(O):x},[]);let le;if(ke){le=[];for(let x=0,ue=X.length;x<ue;x++)le.push(ke)}else le=Re.reduce((x,ue)=>{const O=ue.patterns;return O?x.concat(O):x},[]);const we=function(x,ue){if(typeof x!="string")return null;if(!ue){let J;for(J=x.length;J>0;J--){const he=x.charCodeAt(J-1);if(he===47||he===92)break}ue=x.substr(J)}const O=X.indexOf(ue);return O!==-1?le[O]:null};we.basenames=X,we.patterns=le,we.allBasenames=X;const ae=ye.filter(x=>!x.basenames);return ae.push(we),ae}function Y(ye,ke){return(0,y.$of)(ye,ke,(Re,X)=>typeof Re=="string"&&typeof X=="string"?Re===X:typeof Re!="string"&&typeof X!="string"?Re.base===X.base&&Re.pattern===X.pattern:!1)}e.$tj=Y}),define(Pe[49],Ae([1,0,9,122,23,15,2]),function(pe,e,y,R,C,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3j=e.$2j=e.$1j=e.$Zj=e.$Yj=e.$Xj=e.$Wj=e.$Vj=e.MarkdownStringTextNewlineStyle=void 0;var h;(function(t){t[t.Paragraph=0]="Paragraph",t[t.Break=1]="Break"})(h||(e.MarkdownStringTextNewlineStyle=h={}));class S{constructor(i="",c=!1){if(this.value=i,typeof this.value!="string")throw(0,y.$5)("value");typeof c=="boolean"?(this.isTrusted=c,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=c.isTrusted??void 0,this.supportThemeIcons=c.supportThemeIcons??!1,this.supportHtml=c.supportHtml??!1)}appendText(i,c=0){return this.value+=u(this.supportThemeIcons?(0,R.$Pj)(i):i).replace(/([ \t]+)/g,(m,E)=>"&nbsp;".repeat(E.length)).replace(/\>/gm,"\\>").replace(/\n/g,c===1?`\\
`:`

`),this}appendMarkdown(i){return this.value+=i,this}appendCodeblock(i,c){return this.value+="\n```",this.value+=i,this.value+=`
`,this.value+=c,this.value+="\n```\n",this}appendLink(i,c,m){return this.value+="[",this.value+=this.c(c,"]"),this.value+="](",this.value+=this.c(String(i),")"),m&&(this.value+=` "${this.c(this.c(m,'"'),")")}"`),this.value+=")",this}c(i,c){const m=new RegExp((0,L.$sd)(c),"g");return i.replace(m,(E,b)=>i.charAt(b-1)!=="\\"?`\\${E}`:E)}}e.$Vj=S;function g(t){return P(t)?!t.value:Array.isArray(t)?t.every(g):!0}e.$Wj=g;function P(t){return t instanceof S?!0:t&&typeof t=="object"?typeof t.value=="string"&&(typeof t.isTrusted=="boolean"||typeof t.isTrusted=="object"||t.isTrusted===void 0)&&(typeof t.supportThemeIcons=="boolean"||t.supportThemeIcons===void 0):!1}e.$Xj=P;function D(t,i){return t===i?!0:!t||!i?!1:t.value===i.value&&t.isTrusted===i.isTrusted&&t.supportThemeIcons===i.supportThemeIcons&&t.supportHtml===i.supportHtml&&(t.baseUri===i.baseUri||!!t.baseUri&&!!i.baseUri&&(0,C.$_f)(A.URI.from(t.baseUri),A.URI.from(i.baseUri)))}e.$Yj=D;function u(t){return t.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}e.$Zj=u;function p(t){return t.replace(/"/g,"&quot;")}e.$1j=p;function $(t){return t&&t.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}e.$2j=$;function d(t){const i=[],c=t.split("|").map(E=>E.trim());t=c[0];const m=c[1];if(m){const E=/height=(\d+)/.exec(m),b=/width=(\d+)/.exec(m),n=E?E[1]:"",a=b?b[1]:"",s=isFinite(parseInt(a)),o=isFinite(parseInt(n));s&&i.push(`width="${a}"`),o&&i.push(`height="${n}"`)}return{href:t,dimensions:i}}e.$3j=d}),define(Pe[90],Ae([1,0,18,42,19,22,23,15]),function(pe,e,y,R,C,L,A,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jA=e.$iA=e.$hA=e.$gA=e.$fA=e.$eA=e.$dA=e.$cA=e.$bA=e.$aA=void 0;function S(o,w){const{os:v,tildify:I,relative:k}=w;if(k){const f=g(o,k,v);if(typeof f=="string")return f}let r=o.fsPath;if(v===1&&!L.$i?r=r.replace(/\//g,"\\"):v!==1&&L.$i&&(r=r.replace(/\\/g,"/")),v!==1&&I?.userHome){const f=I.userHome.fsPath;let F;o.scheme!==I.userHome.scheme&&o.path.startsWith(C.$8c.sep)?F=I.userHome.with({path:o.path}).fsPath:F=o.fsPath,r=u(F,f,v)}return(v===1?C.$7c:C.$8c).normalize(P(r,v===1))}e.$aA=S;function g(o,w,v){const I=v===1?C.$7c:C.$8c,k=v===3?A.$9f:A.$$f,r=w.getWorkspace(),l=(0,y.$Hf)(r.folders);if(!l)return;o.scheme!==l.uri.scheme&&o.path.startsWith(C.$8c.sep)&&(o=l.uri.with({path:o.path}));const f=w.getWorkspaceFolder(o);if(!f)return;let F;if(k.isEqual(f.uri,o)?F="":F=k.relativePath(f.uri,o)??"",F&&(F=I.normalize(F)),r.folders.length>1&&!w.noPrefix){const W=f.name?f.name:k.basenameOrAuthority(f.uri);F=F?`${W} \u2022 ${F}`:W}return F}function P(o,w=L.$i){return(0,R.$Oe)(o,w)?o.charAt(0).toUpperCase()+o.slice(1):o}e.$bA=P;let D=Object.create(null);function u(o,w,v=L.OS){if(v===1||!o||!w)return o;let I=D.original===w?D.normalized:void 0;I||(I=w,L.$i&&(I=(0,R.$Ee)(I)),I=`${(0,h.$xd)(I,C.$8c.sep)}${C.$8c.sep}`,D={original:w,normalized:I});let k=o;return L.$i&&(k=(0,R.$Ee)(k)),(v===3?k.startsWith(I):(0,h.$Pd)(k,I))?`~/${k.substr(I.length)}`:o}e.$cA=u;function p(o,w){return o.replace(/^~($|\/|\\)/,`${w}$1`)}e.$dA=p;const $="\u2026",d="\\\\",t="~";function i(o,w=C.sep){const v=new Array(o.length);let I=!1;for(let k=0;k<o.length;k++){const r=o[k];if(r===""){v[k]=`.${w}`;continue}if(!r){v[k]=r;continue}I=!0;let l="",f=r;f.indexOf(d)===0?(l=f.substr(0,f.indexOf(d)+d.length),f=f.substr(f.indexOf(d)+d.length)):f.indexOf(w)===0?(l=f.substr(0,f.indexOf(w)+w.length),f=f.substr(f.indexOf(w)+w.length)):f.indexOf(t)===0&&(l=f.substr(0,f.indexOf(t)+t.length),f=f.substr(f.indexOf(t)+t.length));const F=f.split(w);for(let W=1;I&&W<=F.length;W++)for(let V=F.length-W;I&&V>=0;V--){I=!1;let B=F.slice(V,V+W).join(w);for(let j=0;!I&&j<o.length;j++)if(j!==k&&o[j]&&o[j].indexOf(B)>-1){const U=V+W===F.length,z=V>0&&o[j].indexOf(w)>-1?w+B:B,ie=o[j].endsWith(z);I=!U||ie}if(!I){let j="";(F[0].endsWith(":")||l!=="")&&(V===1&&(V=0,W++,B=F[0]+w+B),V>0&&(j=F[0]+w),j=l+j),V>0&&(j=j+$+w),j=j+B,V+W<F.length&&(j=j+w+$),v[k]=j}}I&&(v[k]=r)}return v}e.$eA=i;var c;(function(o){o[o.TEXT=0]="TEXT",o[o.VARIABLE=1]="VARIABLE",o[o.SEPARATOR=2]="SEPARATOR"})(c||(c={}));function m(o,w=Object.create(null)){const v=[];let I=!1,k="";for(const r of o)if(r==="$"||I&&r==="{")k&&v.push({value:k,type:c.TEXT}),k="",I=!0;else if(r==="}"&&I){const l=w[k];if(typeof l=="string")l.length&&v.push({value:l,type:c.VARIABLE});else if(l){const f=v[v.length-1];(!f||f.type!==c.SEPARATOR)&&v.push({value:l.label,type:c.SEPARATOR})}k="",I=!1}else k+=r;return k&&!I&&v.push({value:k,type:c.TEXT}),v.filter((r,l)=>{if(r.type===c.SEPARATOR){const f=v[l-1],F=v[l+1];return[f,F].every(W=>W&&(W.type===c.VARIABLE||W.type===c.TEXT)&&W.value.length>0)}return!0}).map(r=>r.value).join("")}e.$fA=m;function E(o,w){return L.$j||w?o.replace(/\(&&\w\)|&&/g,"").replace(/&/g,L.$j?"&":"&&"):o.replace(/&&|&/g,v=>v==="&"?"&&":"&")}e.$gA=E;function b(o,w){return L.$j||w?o.replace(/\(&&\w\)|&&/g,""):L.$i?o.replace(/&&|&/g,v=>v==="&"?"&&":"&"):o.replace(/&&/g,"_")}e.$hA=b;function n(o){return o.replace(/&/g,"&&")}e.$iA=n;function a(o){if(o.endsWith("]")){const w=o.lastIndexOf(" [",o.length-2);if(w!==-1){const v=s(o.substring(0,w));return{name:v.name,parentPath:v.parentPath+o.substring(w)}}}return s(o)}e.$jA=a;function s(o){const w=o.indexOf("/")!==-1?C.$8c:C.$7c,v=w.basename(o),I=w.dirname(o);return v.length?{name:v,parentPath:I}:{name:I,parentPath:""}}}),define(Pe[133],Ae([1,0,25,2]),function(pe,e,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dm=e.$Cm=e.$Bm=e.$Am=e.$zm=void 0;function C(D){return D.toJSON()}class L{constructor(u){this.a=u}transformIncoming(u){const p=this.a.transformIncoming(u);return p===u?u:C(R.URI.from(p))}transformOutgoing(u){const p=this.a.transformOutgoing(u);return p===u?u:C(R.URI.from(p))}transformOutgoingURI(u){const p=this.a.transformOutgoing(u);return p===u?u:R.URI.from(p)}transformOutgoingScheme(u){return this.a.transformOutgoingScheme(u)}}e.$zm=L,e.$Am=new class{transformIncoming(D){return D}transformOutgoing(D){return D}transformOutgoingURI(D){return D}transformOutgoingScheme(D){return D}};function A(D,u,p){if(!D||p>200)return null;if(typeof D=="object"){if(D instanceof R.URI)return u.transformOutgoing(D);for(const $ in D)if(Object.hasOwnProperty.call(D,$)){const d=A(D[$],u,p+1);d!==null&&(D[$]=d)}}return null}function h(D,u){const p=A(D,u,0);return p===null?D:p}e.$Bm=h;function S(D,u,p,$){if(!D||$>200)return null;if(typeof D=="object"){if(D.$mid===1)return p?R.URI.revive(u.transformIncoming(D)):u.transformIncoming(D);if(D instanceof y.$Hc)return null;for(const d in D)if(Object.hasOwnProperty.call(D,d)){const t=S(D[d],u,p,$+1);t!==null&&(D[d]=t)}}return null}function g(D,u){const p=S(D,u,!1,0);return p===null?D:p}e.$Cm=g;function P(D,u){const p=S(D,u,!0,0);return p===null?D:p}e.$Dm=P}),define(Pe[134],Ae([1,0,37,19]),function(pe,e,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$E=void 0;function C(L,A,h,S,g,P){if(Array.isArray(L)){let D=0;for(const u of L){const p=C(u,A,h,S,g,P);if(p===10)return p;p>D&&(D=p)}return D}else{if(typeof L=="string")return S?L==="*"?5:L===h?10:0:0;if(L){const{language:D,pattern:u,scheme:p,hasAccessToAllModels:$,notebookType:d}=L;if(!S&&!$)return 0;d&&g&&(A=g);let t=0;if(p)if(p===A.scheme)t=10;else if(p==="*")t=5;else return 0;if(D)if(D===h)t=10;else if(D==="*")t=Math.max(t,5);else return 0;if(d)if(d===P)t=10;else if(d==="*"&&P!==void 0)t=Math.max(t,5);else return 0;if(u){let i;if(typeof u=="string"?i=u:i={...u,base:(0,R.$9c)(u.base)},i===A.fsPath||(0,y.$oj)(i,A.fsPath))t=10;else return 0}return t}else return 0}}e.$$E=C}),define(Pe[91],Ae([1,0,25,22]),function(pe,e,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$j0=e.$i0=void 0;var C;(function(D){D[D.Full=1]="Full",D[D.Delta=2]="Delta"})(C||(C={}));function L(D){for(let u=0,p=D.length;u<p;u+=4){const $=D[u+0],d=D[u+1],t=D[u+2],i=D[u+3];D[u+0]=i,D[u+1]=t,D[u+2]=d,D[u+3]=$}}function A(D){const u=new Uint8Array(D.buffer,D.byteOffset,D.length*4);return R.$C()||L(u),y.$Hc.wrap(u)}function h(D){const u=D.buffer;if(R.$C()||L(u),u.byteOffset%4===0)return new Uint32Array(u.buffer,u.byteOffset,u.length/4);{const p=new Uint8Array(u.byteLength);return p.set(u),new Uint32Array(p.buffer,p.byteOffset,p.length/4)}}function S(D){const u=new Uint32Array(g(D));let p=0;if(u[p++]=D.id,D.type==="full")u[p++]=1,u[p++]=D.data.length,u.set(D.data,p),p+=D.data.length;else{u[p++]=2,u[p++]=D.deltas.length;for(const $ of D.deltas)u[p++]=$.start,u[p++]=$.deleteCount,$.data?(u[p++]=$.data.length,u.set($.data,p),p+=$.data.length):u[p++]=0}return A(u)}e.$i0=S;function g(D){let u=0;if(u+=1+1,D.type==="full")u+=1+D.data.length;else{u+=1,u+=(1+1+1)*D.deltas.length;for(const p of D.deltas)p.data&&(u+=p.data.length)}return u}function P(D){const u=h(D);let p=0;const $=u[p++];if(u[p++]===1){const c=u[p++],m=u.subarray(p,p+c);return p+=c,{id:$,type:"full",data:m}}const t=u[p++],i=[];for(let c=0;c<t;c++){const m=u[p++],E=u[p++],b=u[p++];let n;b>0&&(n=u.subarray(p,p+b),p+=b),i[c]={start:m,deleteCount:E,data:n}}return{id:$,type:"delta",deltas:i}}e.$j0=P}),define(Pe[135],Ae([10,11]),function(pe,e){return pe.create("vs/editor/common/config/editorOptions",e)}),define(Pe[136],Ae([1,0,18,24,22,124,137,135]),function(pe,e,y,R,C,L,A,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontVariations=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.clampedFloat=e.clampedInt=e.boolean=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var S;(function(_){_[_.None=0]="None",_[_.Keep=1]="Keep",_[_.Brackets=2]="Brackets",_[_.Advanced=3]="Advanced",_[_.Full=4]="Full"})(S||(e.EditorAutoIndentStrategy=S={})),e.MINIMAP_GUTTER_WIDTH=8;class g{constructor(Q){this.c=Q}hasChanged(Q){return this.c[Q]}}e.ConfigurationChangedEvent=g;class P{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=P;class D{constructor(Q,$e,je,Oe){this.id=Q,this.name=$e,this.defaultValue=je,this.schema=Oe}applyUpdate(Q,$e){return p(Q,$e)}compute(Q,$e,je){return je}}class u{constructor(Q,$e){this.newValue=Q,this.didChange=$e}}e.ApplyUpdateResult=u;function p(_,Q){if(typeof _!="object"||typeof Q!="object"||!_||!Q)return new u(Q,_!==Q);if(Array.isArray(_)||Array.isArray(Q)){const je=Array.isArray(_)&&Array.isArray(Q)&&y.$of(_,Q);return new u(Q,!je)}let $e=!1;for(const je in Q)if(Q.hasOwnProperty(je)){const Oe=p(_[je],Q[je]);Oe.didChange&&(_[je]=Oe.newValue,$e=!0)}return new u(_,$e)}class ${constructor(Q){this.schema=void 0,this.id=Q,this.name="_never_",this.defaultValue=void 0}applyUpdate(Q,$e){return p(Q,$e)}validate(Q){return this.defaultValue}}class d{constructor(Q,$e,je,Oe){this.id=Q,this.name=$e,this.defaultValue=je,this.schema=Oe}applyUpdate(Q,$e){return p(Q,$e)}validate(Q){return typeof Q>"u"?this.defaultValue:Q}compute(Q,$e,je){return je}}function t(_,Q){return typeof _>"u"?Q:_==="false"?!1:!!_}e.boolean=t;class i extends d{constructor(Q,$e,je,Oe=void 0){typeof Oe<"u"&&(Oe.type="boolean",Oe.default=je),super(Q,$e,je,Oe)}validate(Q){return t(Q,this.defaultValue)}}function c(_,Q,$e,je){if(typeof _>"u")return Q;let Oe=parseInt(_,10);return isNaN(Oe)?Q:(Oe=Math.max($e,Oe),Oe=Math.min(je,Oe),Oe|0)}e.clampedInt=c;class m extends d{static clampedInt(Q,$e,je,Oe){return c(Q,$e,je,Oe)}constructor(Q,$e,je,Oe,Qe,nt=void 0){typeof nt<"u"&&(nt.type="integer",nt.default=je,nt.minimum=Oe,nt.maximum=Qe),super(Q,$e,je,nt),this.minimum=Oe,this.maximum=Qe}validate(Q){return m.clampedInt(Q,this.defaultValue,this.minimum,this.maximum)}}function E(_,Q,$e,je){if(typeof _>"u")return Q;const Oe=b.float(_,Q);return b.clamp(Oe,$e,je)}e.clampedFloat=E;class b extends d{static clamp(Q,$e,je){return Q<$e?$e:Q>je?je:Q}static float(Q,$e){if(typeof Q=="number")return Q;if(typeof Q>"u")return $e;const je=parseFloat(Q);return isNaN(je)?$e:je}constructor(Q,$e,je,Oe,Qe){typeof Qe<"u"&&(Qe.type="number",Qe.default=je),super(Q,$e,je,Qe),this.validationFn=Oe}validate(Q){return this.validationFn(b.float(Q,this.defaultValue))}}class n extends d{static string(Q,$e){return typeof Q!="string"?$e:Q}constructor(Q,$e,je,Oe=void 0){typeof Oe<"u"&&(Oe.type="string",Oe.default=je),super(Q,$e,je,Oe)}validate(Q){return n.string(Q,this.defaultValue)}}function a(_,Q,$e,je){return typeof _!="string"?Q:je&&_ in je?je[_]:$e.indexOf(_)===-1?Q:_}e.stringSet=a;class s extends d{constructor(Q,$e,je,Oe,Qe=void 0){typeof Qe<"u"&&(Qe.type="string",Qe.enum=Oe,Qe.default=je),super(Q,$e,je,Qe),this.c=Oe}validate(Q){return a(Q,this.defaultValue,this.c)}}class o extends D{constructor(Q,$e,je,Oe,Qe,nt,gt=void 0){typeof gt<"u"&&(gt.type="string",gt.enum=Qe,gt.default=Oe),super(Q,$e,je,gt),this.c=Qe,this.d=nt}validate(Q){return typeof Q!="string"?this.defaultValue:this.c.indexOf(Q)===-1?this.defaultValue:this.d(Q)}}function w(_){switch(_){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class v extends D{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[h.localize(0,null),h.localize(1,null),h.localize(2,null)],default:"auto",tags:["accessibility"],description:h.localize(3,null)})}validate(Q){switch(Q){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(Q,$e,je){return je===0?Q.accessibilitySupport:je}}class I extends D{constructor(){const Q={insertSpace:!0,ignoreEmptyLines:!0};super(23,"comments",Q,{"editor.comments.insertSpace":{type:"boolean",default:Q.insertSpace,description:h.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:Q.ignoreEmptyLines,description:h.localize(5,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const $e=Q;return{insertSpace:t($e.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:t($e.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var k;(function(_){_[_.Hidden=0]="Hidden",_[_.Blink=1]="Blink",_[_.Smooth=2]="Smooth",_[_.Phase=3]="Phase",_[_.Expand=4]="Expand",_[_.Solid=5]="Solid"})(k||(e.TextEditorCursorBlinkingStyle=k={}));function r(_){switch(_){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var l;(function(_){_[_.Line=1]="Line",_[_.Block=2]="Block",_[_.Underline=3]="Underline",_[_.LineThin=4]="LineThin",_[_.BlockOutline=5]="BlockOutline",_[_.UnderlineThin=6]="UnderlineThin"})(l||(e.TextEditorCursorStyle=l={}));function f(_){switch(_){case l.Line:return"line";case l.Block:return"block";case l.Underline:return"underline";case l.LineThin:return"line-thin";case l.BlockOutline:return"block-outline";case l.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=f;function F(_){switch(_){case"line":return l.Line;case"block":return l.Block;case"underline":return l.Underline;case"line-thin":return l.LineThin;case"block-outline":return l.BlockOutline;case"underline-thin":return l.UnderlineThin}}class W extends ${constructor(){super(140)}compute(Q,$e,je){const Oe=["monaco-editor"];return $e.get(39)&&Oe.push($e.get(39)),Q.extraEditorClassName&&Oe.push(Q.extraEditorClassName),$e.get(73)==="default"?Oe.push("mouse-default"):$e.get(73)==="copy"&&Oe.push("mouse-copy"),$e.get(110)&&Oe.push("showUnused"),$e.get(138)&&Oe.push("showDeprecated"),Oe.join(" ")}}class V extends i{constructor(){super(37,"emptySelectionClipboard",!0,{description:h.localize(6,null)})}compute(Q,$e,je){return je&&Q.emptySelectionClipboard}}class B extends D{constructor(){const Q={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(41,"find",Q,{"editor.find.cursorMoveOnType":{type:"boolean",default:Q.cursorMoveOnType,description:h.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:Q.seedSearchStringFromSelection,enumDescriptions:[h.localize(8,null),h.localize(9,null),h.localize(10,null)],description:h.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:Q.autoFindInSelection,enumDescriptions:[h.localize(12,null),h.localize(13,null),h.localize(14,null)],description:h.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:Q.globalFindClipboard,description:h.localize(16,null),included:C.$j},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:Q.addExtraSpaceOnTop,description:h.localize(17,null)},"editor.find.loop":{type:"boolean",default:Q.loop,description:h.localize(18,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const $e=Q;return{cursorMoveOnType:t($e.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof Q.seedSearchStringFromSelection=="boolean"?Q.seedSearchStringFromSelection?"always":"never":a($e.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof Q.autoFindInSelection=="boolean"?Q.autoFindInSelection?"always":"never":a($e.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:t($e.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:t($e.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:t($e.loop,this.defaultValue.loop)}}}class j extends D{static{this.OFF='"liga" off, "calt" off'}static{this.ON='"liga" on, "calt" on'}constructor(){super(51,"fontLigatures",j.OFF,{anyOf:[{type:"boolean",description:h.localize(19,null)},{type:"string",description:h.localize(20,null)}],description:h.localize(21,null),default:!1})}validate(Q){return typeof Q>"u"?this.defaultValue:typeof Q=="string"?Q==="false"?j.OFF:Q==="true"?j.ON:Q:Q?j.ON:j.OFF}}e.EditorFontLigatures=j;class U extends D{static{this.OFF="normal"}static{this.TRANSLATE="translate"}constructor(){super(54,"fontVariations",U.OFF,{anyOf:[{type:"boolean",description:h.localize(22,null)},{type:"string",description:h.localize(23,null)}],description:h.localize(24,null),default:!1})}validate(Q){return typeof Q>"u"?this.defaultValue:typeof Q=="string"?Q==="false"?U.OFF:Q==="true"?U.TRANSLATE:Q:Q?U.TRANSLATE:U.OFF}compute(Q,$e,je){return Q.fontInfo.fontVariationSettings}}e.EditorFontVariations=U;class z extends ${constructor(){super(50)}compute(Q,$e,je){return Q.fontInfo}}class ie extends d{constructor(){super(52,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:h.localize(25,null)})}validate(Q){const $e=b.float(Q,this.defaultValue);return $e===0?e.EDITOR_FONT_DEFAULTS.fontSize:b.clamp($e,6,100)}compute(Q,$e,je){return Q.fontInfo.fontSize}}class Y extends D{static{this.c=["normal","bold","100","200","300","400","500","600","700","800","900"]}static{this.d=1}static{this.e=1e3}constructor(){super(53,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:Y.d,maximum:Y.e,errorMessage:h.localize(26,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:Y.c}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:h.localize(27,null)})}validate(Q){return Q==="normal"||Q==="bold"?Q:String(m.clampedInt(Q,e.EDITOR_FONT_DEFAULTS.fontWeight,Y.d,Y.e))}}class ye extends D{constructor(){const Q={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},$e={type:"string",enum:["peek","gotoAndPeek","goto"],default:Q.multiple,enumDescriptions:[h.localize(28,null),h.localize(29,null),h.localize(30,null)]},je=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(58,"gotoLocation",Q,{"editor.gotoLocation.multiple":{deprecationMessage:h.localize(31,null)},"editor.gotoLocation.multipleDefinitions":{description:h.localize(32,null),...$e},"editor.gotoLocation.multipleTypeDefinitions":{description:h.localize(33,null),...$e},"editor.gotoLocation.multipleDeclarations":{description:h.localize(34,null),...$e},"editor.gotoLocation.multipleImplementations":{description:h.localize(35,null),...$e},"editor.gotoLocation.multipleReferences":{description:h.localize(36,null),...$e},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:Q.alternativeDefinitionCommand,enum:je,description:h.localize(37,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:Q.alternativeTypeDefinitionCommand,enum:je,description:h.localize(38,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:Q.alternativeDeclarationCommand,enum:je,description:h.localize(39,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:Q.alternativeImplementationCommand,enum:je,description:h.localize(40,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:Q.alternativeReferenceCommand,enum:je,description:h.localize(41,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const $e=Q;return{multiple:a($e.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:$e.multipleDefinitions??a($e.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:$e.multipleTypeDefinitions??a($e.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:$e.multipleDeclarations??a($e.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:$e.multipleImplementations??a($e.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:$e.multipleReferences??a($e.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:n.string($e.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:n.string($e.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:n.string($e.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:n.string($e.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:n.string($e.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class ke extends D{constructor(){const Q={enabled:!0,delay:300,sticky:!0,above:!0};super(60,"hover",Q,{"editor.hover.enabled":{type:"boolean",default:Q.enabled,description:h.localize(42,null)},"editor.hover.delay":{type:"number",default:Q.delay,minimum:0,maximum:1e4,description:h.localize(43,null)},"editor.hover.sticky":{type:"boolean",default:Q.sticky,description:h.localize(44,null)},"editor.hover.above":{type:"boolean",default:Q.above,description:h.localize(45,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const $e=Q;return{enabled:t($e.enabled,this.defaultValue.enabled),delay:m.clampedInt($e.delay,this.defaultValue.delay,0,1e4),sticky:t($e.sticky,this.defaultValue.sticky),above:t($e.above,this.defaultValue.above)}}}var Re;(function(_){_[_.None=0]="None",_[_.Text=1]="Text",_[_.Blocks=2]="Blocks"})(Re||(e.RenderMinimap=Re={}));class X extends ${constructor(){super(143)}compute(Q,$e,je){return X.computeLayout($e,{memory:Q.memory,outerWidth:Q.outerWidth,outerHeight:Q.outerHeight,isDominatedByLongLines:Q.isDominatedByLongLines,lineHeight:Q.fontInfo.lineHeight,viewLineCount:Q.viewLineCount,lineNumbersDigitCount:Q.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:Q.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:Q.fontInfo.maxDigitWidth,pixelRatio:Q.pixelRatio,glyphMarginDecorationLaneCount:Q.glyphMarginDecorationLaneCount})}static computeContainedMinimapLineCount(Q){const $e=Q.height/Q.lineHeight,je=Math.floor(Q.paddingTop/Q.lineHeight);let Oe=Math.floor(Q.paddingBottom/Q.lineHeight);Q.scrollBeyondLastLine&&(Oe=Math.max(Oe,$e-1));const Qe=(je+Q.viewLineCount+Oe)/(Q.pixelRatio*Q.height),nt=Math.floor(Q.viewLineCount/Qe);return{typicalViewportLineCount:$e,extraLinesBeforeFirstLine:je,extraLinesBeyondLastLine:Oe,desiredRatio:Qe,minimapLineCount:nt}}static c(Q,$e){const je=Q.outerWidth,Oe=Q.outerHeight,Qe=Q.pixelRatio;if(!Q.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(Qe*Oe),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:Oe};const nt=$e.stableMinimapLayoutInput,gt=nt&&Q.outerHeight===nt.outerHeight&&Q.lineHeight===nt.lineHeight&&Q.typicalHalfwidthCharacterWidth===nt.typicalHalfwidthCharacterWidth&&Q.pixelRatio===nt.pixelRatio&&Q.scrollBeyondLastLine===nt.scrollBeyondLastLine&&Q.paddingTop===nt.paddingTop&&Q.paddingBottom===nt.paddingBottom&&Q.minimap.enabled===nt.minimap.enabled&&Q.minimap.side===nt.minimap.side&&Q.minimap.size===nt.minimap.size&&Q.minimap.showSlider===nt.minimap.showSlider&&Q.minimap.renderCharacters===nt.minimap.renderCharacters&&Q.minimap.maxColumn===nt.minimap.maxColumn&&Q.minimap.scale===nt.minimap.scale&&Q.verticalScrollbarWidth===nt.verticalScrollbarWidth&&Q.isViewportWrapping===nt.isViewportWrapping,vt=Q.lineHeight,Ft=Q.typicalHalfwidthCharacterWidth,Qt=Q.scrollBeyondLastLine,Vt=Q.minimap.renderCharacters;let wt=Qe>=2?Math.round(Q.minimap.scale*2):Q.minimap.scale;const Tt=Q.minimap.maxColumn,zt=Q.minimap.size,Jt=Q.minimap.side,Pt=Q.verticalScrollbarWidth,At=Q.viewLineCount,Ot=Q.remainingWidth,jt=Q.isViewportWrapping,qt=Vt?2:3;let Bt=Math.floor(Qe*Oe);const at=Bt/Qe;let ut=!1,Ht=!1,Ct=qt*wt,kt=wt/Qe,ht=1;if(zt==="fill"||zt==="fit"){const{typicalViewportLineCount:Me,extraLinesBeforeFirstLine:ge,extraLinesBeyondLastLine:G,desiredRatio:Fe,minimapLineCount:Be}=X.computeContainedMinimapLineCount({viewLineCount:At,scrollBeyondLastLine:Qt,paddingTop:Q.paddingTop,paddingBottom:Q.paddingBottom,height:Oe,lineHeight:vt,pixelRatio:Qe});if(At/Be>1)ut=!0,Ht=!0,wt=1,Ct=1,kt=wt/Qe;else{let We=!1,xe=wt+1;if(zt==="fit"){const pt=Math.ceil((ge+At+G)*Ct);jt&&gt&&Ot<=$e.stableFitRemainingWidth?(We=!0,xe=$e.stableFitMaxMinimapScale):We=pt>Bt}if(zt==="fill"||We){ut=!0;const pt=wt;Ct=Math.min(vt*Qe,Math.max(1,Math.floor(1/Fe))),jt&&gt&&Ot<=$e.stableFitRemainingWidth&&(xe=$e.stableFitMaxMinimapScale),wt=Math.min(xe,Math.max(1,Math.floor(Ct/qt))),wt>pt&&(ht=Math.min(2,wt/pt)),kt=wt/Qe/ht,Bt=Math.ceil(Math.max(Me,ge+At+G)*Ct),jt?($e.stableMinimapLayoutInput=Q,$e.stableFitRemainingWidth=Ot,$e.stableFitMaxMinimapScale=wt):($e.stableMinimapLayoutInput=null,$e.stableFitRemainingWidth=0)}}}const St=Math.floor(Tt*kt),Lt=Math.min(St,Math.max(0,Math.floor((Ot-Pt-2)*kt/(Ft+kt)))+e.MINIMAP_GUTTER_WIDTH);let Et=Math.floor(Qe*Lt);const qe=Et/Qe;Et=Math.floor(Et*ht);const Nt=Vt?1:2,Ie=Jt==="left"?0:je-Lt-Pt;return{renderMinimap:Nt,minimapLeft:Ie,minimapWidth:Lt,minimapHeightIsEditorHeight:ut,minimapIsSampling:Ht,minimapScale:wt,minimapLineHeight:Ct,minimapCanvasInnerWidth:Et,minimapCanvasInnerHeight:Bt,minimapCanvasOuterWidth:qe,minimapCanvasOuterHeight:at}}static computeLayout(Q,$e){const je=$e.outerWidth|0,Oe=$e.outerHeight|0,Qe=$e.lineHeight|0,nt=$e.lineNumbersDigitCount|0,gt=$e.typicalHalfwidthCharacterWidth,vt=$e.maxDigitWidth,Ft=$e.pixelRatio,Qt=$e.viewLineCount,Vt=Q.get(135),wt=Vt==="inherit"?Q.get(134):Vt,Tt=wt==="inherit"?Q.get(130):wt,zt=Q.get(133),Jt=$e.isDominatedByLongLines,Pt=Q.get(57),At=Q.get(67).renderType!==0,Ot=Q.get(68),jt=Q.get(104),qt=Q.get(83),Bt=Q.get(72),at=Q.get(102),ut=at.verticalScrollbarSize,Ht=at.verticalHasArrows,Ct=at.arrowSize,kt=at.horizontalScrollbarSize,ht=Q.get(43),St=Q.get(109)!=="never";let Lt=Q.get(65);ht&&St&&(Lt+=16);let Et=0;if(At){const dt=Math.max(nt,Ot);Et=Math.round(dt*vt)}let qe=0;Pt&&(qe=Qe*$e.glyphMarginDecorationLaneCount);let Nt=0,Ie=Nt+qe,Me=Ie+Et,ge=Me+Lt;const G=je-qe-Et-Lt;let Fe=!1,Be=!1,Ge=-1;wt==="inherit"&&Jt?(Fe=!0,Be=!0):Tt==="on"||Tt==="bounded"?Be=!0:Tt==="wordWrapColumn"&&(Ge=zt);const We=X.c({outerWidth:je,outerHeight:Oe,lineHeight:Qe,typicalHalfwidthCharacterWidth:gt,pixelRatio:Ft,scrollBeyondLastLine:jt,paddingTop:qt.top,paddingBottom:qt.bottom,minimap:Bt,verticalScrollbarWidth:ut,viewLineCount:Qt,remainingWidth:G,isViewportWrapping:Be},$e.memory||new P);We.renderMinimap!==0&&We.minimapLeft===0&&(Nt+=We.minimapWidth,Ie+=We.minimapWidth,Me+=We.minimapWidth,ge+=We.minimapWidth);const xe=G-We.minimapWidth,pt=Math.max(1,Math.floor((xe-ut-2)/gt)),bt=Ht?Ct:0;return Be&&(Ge=Math.max(1,pt),Tt==="bounded"&&(Ge=Math.min(Ge,zt))),{width:je,height:Oe,glyphMarginLeft:Nt,glyphMarginWidth:qe,glyphMarginDecorationLaneCount:$e.glyphMarginDecorationLaneCount,lineNumbersLeft:Ie,lineNumbersWidth:Et,decorationsLeft:Me,decorationsWidth:Lt,contentLeft:ge,contentWidth:xe,minimap:We,viewportColumn:pt,isWordWrapMinified:Fe,isViewportWrapping:Be,wrappingColumn:Ge,verticalScrollbarWidth:ut,horizontalScrollbarHeight:kt,overviewRuler:{top:bt,width:ut,height:Oe-2*bt,right:0}}}}e.EditorLayoutInfoComputer=X;class le extends D{constructor(){super(137,"wrappingStrategy","simple",{"editor.wrappingStrategy":{enumDescriptions:[h.localize(46,null),h.localize(47,null)],type:"string",enum:["simple","advanced"],default:"simple",description:h.localize(48,null)}})}validate(Q){return a(Q,"simple",["simple","advanced"])}compute(Q,$e,je){return $e.get(2)===2?"advanced":je}}class we extends D{constructor(){const Q={enabled:!0};super(64,"lightbulb",Q,{"editor.lightbulb.enabled":{type:"boolean",default:Q.enabled,description:h.localize(49,null)}})}validate(Q){return!Q||typeof Q!="object"?this.defaultValue:{enabled:t(Q.enabled,this.defaultValue.enabled)}}}class ae extends D{constructor(){const Q={enabled:!1,maxLineCount:5,defaultModel:"outlineModel",scrollWithEditor:!0};super(114,"stickyScroll",Q,{"editor.stickyScroll.enabled":{type:"boolean",default:Q.enabled,description:h.localize(50,null)},"editor.stickyScroll.maxLineCount":{type:"number",default:Q.maxLineCount,minimum:1,maximum:10,description:h.localize(51,null)},"editor.stickyScroll.defaultModel":{type:"string",enum:["outlineModel","foldingProviderModel","indentationModel"],default:Q.defaultModel,description:h.localize(52,null)},"editor.stickyScroll.scrollWithEditor":{type:"boolean",default:Q.scrollWithEditor,description:h.localize(53,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const $e=Q;return{enabled:t($e.enabled,this.defaultValue.enabled),maxLineCount:m.clampedInt($e.maxLineCount,this.defaultValue.maxLineCount,1,10),defaultModel:a($e.defaultModel,this.defaultValue.defaultModel,["outlineModel","foldingProviderModel","indentationModel"]),scrollWithEditor:t($e.scrollWithEditor,this.defaultValue.scrollWithEditor)}}}class x extends D{constructor(){const Q={enabled:"on",fontSize:0,fontFamily:"",padding:!1};super(139,"inlayHints",Q,{"editor.inlayHints.enabled":{type:"string",default:Q.enabled,description:h.localize(54,null),enum:["on","onUnlessPressed","offUnlessPressed","off"],markdownEnumDescriptions:[h.localize(55,null),h.localize(56,null,C.$j?"Ctrl+Option":"Ctrl+Alt"),h.localize(57,null,C.$j?"Ctrl+Option":"Ctrl+Alt"),h.localize(58,null)]},"editor.inlayHints.fontSize":{type:"number",default:Q.fontSize,markdownDescription:h.localize(59,null,"`#editor.fontSize#`","`5`")},"editor.inlayHints.fontFamily":{type:"string",default:Q.fontFamily,markdownDescription:h.localize(60,null,"`#editor.fontFamily#`")},"editor.inlayHints.padding":{type:"boolean",default:Q.padding,description:h.localize(61,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const $e=Q;return typeof $e.enabled=="boolean"&&($e.enabled=$e.enabled?"on":"off"),{enabled:a($e.enabled,this.defaultValue.enabled,["on","off","offUnlessPressed","onUnlessPressed"]),fontSize:m.clampedInt($e.fontSize,this.defaultValue.fontSize,0,100),fontFamily:n.string($e.fontFamily,this.defaultValue.fontFamily),padding:t($e.padding,this.defaultValue.padding)}}}class ue extends D{constructor(){super(65,"lineDecorationsWidth",10)}validate(Q){return typeof Q=="string"&&/^\d+(\.\d+)?ch$/.test(Q)?-parseFloat(Q.substring(0,Q.length-2)):m.clampedInt(Q,this.defaultValue,0,1e3)}compute(Q,$e,je){return je<0?m.clampedInt(-je*Q.fontInfo.typicalHalfwidthCharacterWidth,this.defaultValue,0,1e3):je}}class O extends b{constructor(){super(66,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,Q=>b.clamp(Q,0,150),{markdownDescription:h.localize(62,null)})}compute(Q,$e,je){return Q.fontInfo.lineHeight}}class J extends D{constructor(){const Q={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",autohide:!1,renderCharacters:!0,maxColumn:120,scale:1};super(72,"minimap",Q,{"editor.minimap.enabled":{type:"boolean",default:Q.enabled,description:h.localize(63,null)},"editor.minimap.autohide":{type:"boolean",default:Q.autohide,description:h.localize(64,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[h.localize(65,null),h.localize(66,null),h.localize(67,null)],default:Q.size,description:h.localize(68,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:Q.side,description:h.localize(69,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:Q.showSlider,description:h.localize(70,null)},"editor.minimap.scale":{type:"number",default:Q.scale,minimum:1,maximum:3,enum:[1,2,3],description:h.localize(71,null)},"editor.minimap.renderCharacters":{type:"boolean",default:Q.renderCharacters,description:h.localize(72,null)},"editor.minimap.maxColumn":{type:"number",default:Q.maxColumn,description:h.localize(73,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const $e=Q;return{enabled:t($e.enabled,this.defaultValue.enabled),autohide:t($e.autohide,this.defaultValue.autohide),size:a($e.size,this.defaultValue.size,["proportional","fill","fit"]),side:a($e.side,this.defaultValue.side,["right","left"]),showSlider:a($e.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:t($e.renderCharacters,this.defaultValue.renderCharacters),scale:m.clampedInt($e.scale,1,1,3),maxColumn:m.clampedInt($e.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function he(_){return _==="ctrlCmd"?C.$j?"metaKey":"ctrlKey":"altKey"}class Ee extends D{constructor(){super(83,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:h.localize(74,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:h.localize(75,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const $e=Q;return{top:m.clampedInt($e.top,0,0,1e3),bottom:m.clampedInt($e.bottom,0,0,1e3)}}}class ve extends D{constructor(){const Q={enabled:!0,cycle:!0};super(85,"parameterHints",Q,{"editor.parameterHints.enabled":{type:"boolean",default:Q.enabled,description:h.localize(76,null)},"editor.parameterHints.cycle":{type:"boolean",default:Q.cycle,description:h.localize(77,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const $e=Q;return{enabled:t($e.enabled,this.defaultValue.enabled),cycle:t($e.cycle,this.defaultValue.cycle)}}}class be extends ${constructor(){super(141)}compute(Q,$e,je){return Q.pixelRatio}}class De extends D{constructor(){const Q={other:"on",comments:"off",strings:"off"},$e=[{type:"boolean"},{type:"string",enum:["on","inline","off"],enumDescriptions:[h.localize(78,null),h.localize(79,null),h.localize(80,null)]}];super(88,"quickSuggestions",Q,{type:"object",additionalProperties:!1,properties:{strings:{anyOf:$e,default:Q.strings,description:h.localize(81,null)},comments:{anyOf:$e,default:Q.comments,description:h.localize(82,null)},other:{anyOf:$e,default:Q.other,description:h.localize(83,null)}},default:Q,markdownDescription:h.localize(84,null,"#editor.suggestOnTriggerCharacters#")}),this.defaultValue=Q}validate(Q){if(typeof Q=="boolean"){const Ft=Q?"on":"off";return{comments:Ft,strings:Ft,other:Ft}}if(!Q||typeof Q!="object")return this.defaultValue;const{other:$e,comments:je,strings:Oe}=Q,Qe=["on","inline","off"];let nt,gt,vt;return typeof $e=="boolean"?nt=$e?"on":"off":nt=a($e,this.defaultValue.other,Qe),typeof je=="boolean"?gt=je?"on":"off":gt=a(je,this.defaultValue.comments,Qe),typeof Oe=="boolean"?vt=Oe?"on":"off":vt=a(Oe,this.defaultValue.strings,Qe),{other:nt,comments:gt,strings:vt}}}var oe;(function(_){_[_.Off=0]="Off",_[_.On=1]="On",_[_.Relative=2]="Relative",_[_.Interval=3]="Interval",_[_.Custom=4]="Custom"})(oe||(e.RenderLineNumbersType=oe={}));class de extends D{constructor(){super(67,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[h.localize(85,null),h.localize(86,null),h.localize(87,null),h.localize(88,null)],default:"on",description:h.localize(89,null)})}validate(Q){let $e=this.defaultValue.renderType,je=this.defaultValue.renderFn;return typeof Q<"u"&&(typeof Q=="function"?($e=4,je=Q):Q==="interval"?$e=3:Q==="relative"?$e=2:Q==="on"?$e=1:$e=0),{renderType:$e,renderFn:je}}}function se(_){const Q=_.get(97);return Q==="editable"?_.get(90):Q!=="on"}e.filterValidationDecorations=se;class ne extends D{constructor(){const Q=[],$e={type:"number",description:h.localize(90,null)};super(101,"rulers",Q,{type:"array",items:{anyOf:[$e,{type:["object"],properties:{column:$e,color:{type:"string",description:h.localize(91,null),format:"color-hex"}}}]},default:Q,description:h.localize(92,null)})}validate(Q){if(Array.isArray(Q)){const $e=[];for(const je of Q)if(typeof je=="number")$e.push({column:m.clampedInt(je,0,0,1e4),color:null});else if(je&&typeof je=="object"){const Oe=je;$e.push({column:m.clampedInt(Oe.column,0,0,1e4),color:Oe.color})}return $e.sort((je,Oe)=>je.column-Oe.column),$e}return this.defaultValue}}class me extends D{constructor(){super(91,"readOnlyMessage",void 0)}validate(Q){return!Q||typeof Q!="object"?this.defaultValue:Q}}function Ce(_,Q){if(typeof _!="string")return Q;switch(_){case"hidden":return 2;case"visible":return 3;default:return 1}}class M extends D{constructor(){const Q={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1};super(102,"scrollbar",Q,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[h.localize(93,null),h.localize(94,null),h.localize(95,null)],default:"auto",description:h.localize(96,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[h.localize(97,null),h.localize(98,null),h.localize(99,null)],default:"auto",description:h.localize(100,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:Q.verticalScrollbarSize,description:h.localize(101,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:Q.horizontalScrollbarSize,description:h.localize(102,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:Q.scrollByPage,description:h.localize(103,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const $e=Q,je=m.clampedInt($e.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),Oe=m.clampedInt($e.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:m.clampedInt($e.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:Ce($e.vertical,this.defaultValue.vertical),horizontal:Ce($e.horizontal,this.defaultValue.horizontal),useShadows:t($e.useShadows,this.defaultValue.useShadows),verticalHasArrows:t($e.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:t($e.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:t($e.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:t($e.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:je,horizontalSliderSize:m.clampedInt($e.horizontalSliderSize,je,0,1e3),verticalScrollbarSize:Oe,verticalSliderSize:m.clampedInt($e.verticalSliderSize,Oe,0,1e3),scrollByPage:t($e.scrollByPage,this.defaultValue.scrollByPage)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class q extends D{constructor(){const Q={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(124,"unicodeHighlight",Q,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:Q.nonBasicASCII,description:h.localize(104,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:Q.invisibleCharacters,description:h.localize(105,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:Q.ambiguousCharacters,description:h.localize(106,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:Q.includeComments,description:h.localize(107,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:Q.includeStrings,description:h.localize(108,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:Q.allowedCharacters,description:h.localize(109,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:Q.allowedLocales,description:h.localize(110,null)}})}applyUpdate(Q,$e){let je=!1;$e.allowedCharacters&&Q&&(R.$Xm(Q.allowedCharacters,$e.allowedCharacters)||(Q={...Q,allowedCharacters:$e.allowedCharacters},je=!0)),$e.allowedLocales&&Q&&(R.$Xm(Q.allowedLocales,$e.allowedLocales)||(Q={...Q,allowedLocales:$e.allowedLocales},je=!0));const Oe=super.applyUpdate(Q,$e);return je?new u(Oe.newValue,!0):Oe}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const $e=Q;return{nonBasicASCII:ee($e.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:t($e.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:t($e.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:ee($e.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:ee($e.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.c(Q.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.c(Q.allowedLocales,this.defaultValue.allowedLocales)}}c(Q,$e){if(typeof Q!="object"||!Q)return $e;const je={};for(const[Oe,Qe]of Object.entries(Q))Qe===!0&&(je[Oe]=!0);return je}}class H extends D{constructor(){const Q={enabled:!0,mode:"subwordSmart",showToolbar:"onHover",suppressSuggestions:!1,keepOnBlur:!1};super(62,"inlineSuggest",Q,{"editor.inlineSuggest.enabled":{type:"boolean",default:Q.enabled,description:h.localize(111,null)},"editor.inlineSuggest.showToolbar":{type:"string",default:Q.showToolbar,enum:["always","onHover"],enumDescriptions:[h.localize(112,null),h.localize(113,null)],description:h.localize(114,null)},"editor.inlineSuggest.suppressSuggestions":{type:"boolean",default:Q.suppressSuggestions,description:h.localize(115,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const $e=Q;return{enabled:t($e.enabled,this.defaultValue.enabled),mode:a($e.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"]),showToolbar:a($e.showToolbar,this.defaultValue.showToolbar,["always","onHover"]),suppressSuggestions:t($e.suppressSuggestions,this.defaultValue.suppressSuggestions),keepOnBlur:t($e.keepOnBlur,this.defaultValue.keepOnBlur)}}}class Z extends D{constructor(){const Q={enabled:L.$Rr.bracketPairColorizationOptions.enabled,independentColorPoolPerBracketType:L.$Rr.bracketPairColorizationOptions.independentColorPoolPerBracketType};super(15,"bracketPairColorization",Q,{"editor.bracketPairColorization.enabled":{type:"boolean",default:Q.enabled,markdownDescription:h.localize(116,null,"`#workbench.colorCustomizations#`")},"editor.bracketPairColorization.independentColorPoolPerBracketType":{type:"boolean",default:Q.independentColorPoolPerBracketType,description:h.localize(117,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const $e=Q;return{enabled:t($e.enabled,this.defaultValue.enabled),independentColorPoolPerBracketType:t($e.independentColorPoolPerBracketType,this.defaultValue.independentColorPoolPerBracketType)}}}class K extends D{constructor(){const Q={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(16,"guides",Q,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[h.localize(118,null),h.localize(119,null),h.localize(120,null)],default:Q.bracketPairs,description:h.localize(121,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[h.localize(122,null),h.localize(123,null),h.localize(124,null)],default:Q.bracketPairsHorizontal,description:h.localize(125,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:Q.highlightActiveBracketPair,description:h.localize(126,null)},"editor.guides.indentation":{type:"boolean",default:Q.indentation,description:h.localize(127,null)},"editor.guides.highlightActiveIndentation":{type:["boolean","string"],enum:[!0,"always",!1],enumDescriptions:[h.localize(128,null),h.localize(129,null),h.localize(130,null)],default:Q.highlightActiveIndentation,description:h.localize(131,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const $e=Q;return{bracketPairs:ee($e.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:ee($e.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:t($e.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:t($e.indentation,this.defaultValue.indentation),highlightActiveIndentation:ee($e.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation,[!0,!1,"always"])}}}function ee(_,Q,$e){const je=$e.indexOf(_);return je===-1?Q:$e[je]}class ce extends D{constructor(){const Q={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!1,localityBonus:!1,shareSuggestSelections:!1,selectionMode:"always",showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,matchOnWordStartOnly:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(117,"suggest",Q,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[h.localize(132,null),h.localize(133,null)],default:Q.insertMode,description:h.localize(134,null)},"editor.suggest.filterGraceful":{type:"boolean",default:Q.filterGraceful,description:h.localize(135,null)},"editor.suggest.localityBonus":{type:"boolean",default:Q.localityBonus,description:h.localize(136,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:Q.shareSuggestSelections,markdownDescription:h.localize(137,null)},"editor.suggest.selectionMode":{type:"string",enum:["always","never","whenTriggerCharacter","whenQuickSuggestion"],enumDescriptions:[h.localize(138,null),h.localize(139,null),h.localize(140,null),h.localize(141,null)],default:Q.selectionMode,markdownDescription:h.localize(142,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:Q.snippetsPreventQuickSuggestions,description:h.localize(143,null)},"editor.suggest.showIcons":{type:"boolean",default:Q.showIcons,description:h.localize(144,null)},"editor.suggest.showStatusBar":{type:"boolean",default:Q.showStatusBar,description:h.localize(145,null)},"editor.suggest.preview":{type:"boolean",default:Q.preview,description:h.localize(146,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:Q.showInlineDetails,description:h.localize(147,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:h.localize(148,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:h.localize(149,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:h.localize(150,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:h.localize(151,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:h.localize(152,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:h.localize(153,null)},"editor.suggest.matchOnWordStartOnly":{type:"boolean",default:!0,markdownDescription:h.localize(154,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:h.localize(155,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:h.localize(156,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:h.localize(157,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:h.localize(158,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:h.localize(159,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:h.localize(160,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:h.localize(161,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:h.localize(162,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:h.localize(163,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:h.localize(164,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:h.localize(165,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:h.localize(166,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:h.localize(167,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:h.localize(168,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:h.localize(169,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:h.localize(170,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:h.localize(171,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:h.localize(172,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:h.localize(173,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:h.localize(174,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:h.localize(175,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:h.localize(176,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:h.localize(177,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:h.localize(178,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:h.localize(179,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const $e=Q;return{insertMode:a($e.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:t($e.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:t($e.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:t($e.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:t($e.shareSuggestSelections,this.defaultValue.shareSuggestSelections),selectionMode:a($e.selectionMode,this.defaultValue.selectionMode,["always","never","whenQuickSuggestion","whenTriggerCharacter"]),showIcons:t($e.showIcons,this.defaultValue.showIcons),showStatusBar:t($e.showStatusBar,this.defaultValue.showStatusBar),preview:t($e.preview,this.defaultValue.preview),previewMode:a($e.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:t($e.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:t($e.showMethods,this.defaultValue.showMethods),showFunctions:t($e.showFunctions,this.defaultValue.showFunctions),showConstructors:t($e.showConstructors,this.defaultValue.showConstructors),showDeprecated:t($e.showDeprecated,this.defaultValue.showDeprecated),matchOnWordStartOnly:t($e.matchOnWordStartOnly,this.defaultValue.matchOnWordStartOnly),showFields:t($e.showFields,this.defaultValue.showFields),showVariables:t($e.showVariables,this.defaultValue.showVariables),showClasses:t($e.showClasses,this.defaultValue.showClasses),showStructs:t($e.showStructs,this.defaultValue.showStructs),showInterfaces:t($e.showInterfaces,this.defaultValue.showInterfaces),showModules:t($e.showModules,this.defaultValue.showModules),showProperties:t($e.showProperties,this.defaultValue.showProperties),showEvents:t($e.showEvents,this.defaultValue.showEvents),showOperators:t($e.showOperators,this.defaultValue.showOperators),showUnits:t($e.showUnits,this.defaultValue.showUnits),showValues:t($e.showValues,this.defaultValue.showValues),showConstants:t($e.showConstants,this.defaultValue.showConstants),showEnums:t($e.showEnums,this.defaultValue.showEnums),showEnumMembers:t($e.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:t($e.showKeywords,this.defaultValue.showKeywords),showWords:t($e.showWords,this.defaultValue.showWords),showColors:t($e.showColors,this.defaultValue.showColors),showFiles:t($e.showFiles,this.defaultValue.showFiles),showReferences:t($e.showReferences,this.defaultValue.showReferences),showFolders:t($e.showFolders,this.defaultValue.showFolders),showTypeParameters:t($e.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:t($e.showSnippets,this.defaultValue.showSnippets),showUsers:t($e.showUsers,this.defaultValue.showUsers),showIssues:t($e.showIssues,this.defaultValue.showIssues)}}}class ze extends D{constructor(){super(112,"smartSelect",{selectLeadingAndTrailingWhitespace:!0,selectSubwords:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:h.localize(180,null),default:!0,type:"boolean"},"editor.smartSelect.selectSubwords":{description:h.localize(181,null),default:!0,type:"boolean"}})}validate(Q){return!Q||typeof Q!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:t(Q.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace),selectSubwords:t(Q.selectSubwords,this.defaultValue.selectSubwords)}}}var Ue;(function(_){_[_.None=0]="None",_[_.Same=1]="Same",_[_.Indent=2]="Indent",_[_.DeepIndent=3]="DeepIndent"})(Ue||(e.WrappingIndent=Ue={}));class Ze extends D{constructor(){super(136,"wrappingIndent",1,{"editor.wrappingIndent":{type:"string",enum:["none","same","indent","deepIndent"],enumDescriptions:[h.localize(182,null),h.localize(183,null),h.localize(184,null),h.localize(185,null)],description:h.localize(186,null),default:"same"}})}validate(Q){switch(Q){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}return 1}compute(Q,$e,je){return $e.get(2)===2?0:je}}class He extends ${constructor(){super(144)}compute(Q,$e,je){const Oe=$e.get(143);return{isDominatedByLongLines:Q.isDominatedByLongLines,isWordWrapMinified:Oe.isWordWrapMinified,isViewportWrapping:Oe.isViewportWrapping,wrappingColumn:Oe.wrappingColumn}}}class et extends D{constructor(){const Q={enabled:!0,showDropSelector:"afterDrop"};super(36,"dropIntoEditor",Q,{"editor.dropIntoEditor.enabled":{type:"boolean",default:Q.enabled,markdownDescription:h.localize(187,null)},"editor.dropIntoEditor.showDropSelector":{type:"string",markdownDescription:h.localize(188,null),enum:["afterDrop","never"],enumDescriptions:[h.localize(189,null),h.localize(190,null)],default:"afterDrop"}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const $e=Q;return{enabled:t($e.enabled,this.defaultValue.enabled),showDropSelector:a($e.showDropSelector,this.defaultValue.showDropSelector,["afterDrop","never"])}}}class Ye extends D{constructor(){const Q={enabled:!0,showPasteSelector:"afterPaste"};super(84,"pasteAs",Q,{"editor.pasteAs.enabled":{type:"boolean",default:Q.enabled,markdownDescription:h.localize(191,null)},"editor.pasteAs.showPasteSelector":{type:"string",markdownDescription:h.localize(192,null),enum:["afterPaste","never"],enumDescriptions:[h.localize(193,null),h.localize(194,null)],default:"afterPaste"}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const $e=Q;return{enabled:t($e.enabled,this.defaultValue.enabled),showPasteSelector:a($e.showPasteSelector,this.defaultValue.showPasteSelector,["afterPaste","never"])}}}const _e="Consolas, 'Courier New', monospace",it="Menlo, Monaco, 'Courier New', monospace",tt="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:C.$j?it:C.$k?tt:_e,fontWeight:"normal",fontSize:C.$j?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function Ne(_){return e.editorOptionsRegistry[_.id]=_,_}var st;(function(_){_[_.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",_[_.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",_[_.accessibilitySupport=2]="accessibilitySupport",_[_.accessibilityPageSize=3]="accessibilityPageSize",_[_.ariaLabel=4]="ariaLabel",_[_.ariaRequired=5]="ariaRequired",_[_.autoClosingBrackets=6]="autoClosingBrackets",_[_.autoClosingComments=7]="autoClosingComments",_[_.screenReaderAnnounceInlineSuggestion=8]="screenReaderAnnounceInlineSuggestion",_[_.autoClosingDelete=9]="autoClosingDelete",_[_.autoClosingOvertype=10]="autoClosingOvertype",_[_.autoClosingQuotes=11]="autoClosingQuotes",_[_.autoIndent=12]="autoIndent",_[_.automaticLayout=13]="automaticLayout",_[_.autoSurround=14]="autoSurround",_[_.bracketPairColorization=15]="bracketPairColorization",_[_.guides=16]="guides",_[_.codeLens=17]="codeLens",_[_.codeLensFontFamily=18]="codeLensFontFamily",_[_.codeLensFontSize=19]="codeLensFontSize",_[_.colorDecorators=20]="colorDecorators",_[_.colorDecoratorsLimit=21]="colorDecoratorsLimit",_[_.columnSelection=22]="columnSelection",_[_.comments=23]="comments",_[_.contextmenu=24]="contextmenu",_[_.copyWithSyntaxHighlighting=25]="copyWithSyntaxHighlighting",_[_.cursorBlinking=26]="cursorBlinking",_[_.cursorSmoothCaretAnimation=27]="cursorSmoothCaretAnimation",_[_.cursorStyle=28]="cursorStyle",_[_.cursorSurroundingLines=29]="cursorSurroundingLines",_[_.cursorSurroundingLinesStyle=30]="cursorSurroundingLinesStyle",_[_.cursorWidth=31]="cursorWidth",_[_.disableLayerHinting=32]="disableLayerHinting",_[_.disableMonospaceOptimizations=33]="disableMonospaceOptimizations",_[_.domReadOnly=34]="domReadOnly",_[_.dragAndDrop=35]="dragAndDrop",_[_.dropIntoEditor=36]="dropIntoEditor",_[_.emptySelectionClipboard=37]="emptySelectionClipboard",_[_.experimentalWhitespaceRendering=38]="experimentalWhitespaceRendering",_[_.extraEditorClassName=39]="extraEditorClassName",_[_.fastScrollSensitivity=40]="fastScrollSensitivity",_[_.find=41]="find",_[_.fixedOverflowWidgets=42]="fixedOverflowWidgets",_[_.folding=43]="folding",_[_.foldingStrategy=44]="foldingStrategy",_[_.foldingHighlight=45]="foldingHighlight",_[_.foldingImportsByDefault=46]="foldingImportsByDefault",_[_.foldingMaximumRegions=47]="foldingMaximumRegions",_[_.unfoldOnClickAfterEndOfLine=48]="unfoldOnClickAfterEndOfLine",_[_.fontFamily=49]="fontFamily",_[_.fontInfo=50]="fontInfo",_[_.fontLigatures=51]="fontLigatures",_[_.fontSize=52]="fontSize",_[_.fontWeight=53]="fontWeight",_[_.fontVariations=54]="fontVariations",_[_.formatOnPaste=55]="formatOnPaste",_[_.formatOnType=56]="formatOnType",_[_.glyphMargin=57]="glyphMargin",_[_.gotoLocation=58]="gotoLocation",_[_.hideCursorInOverviewRuler=59]="hideCursorInOverviewRuler",_[_.hover=60]="hover",_[_.inDiffEditor=61]="inDiffEditor",_[_.inlineSuggest=62]="inlineSuggest",_[_.letterSpacing=63]="letterSpacing",_[_.lightbulb=64]="lightbulb",_[_.lineDecorationsWidth=65]="lineDecorationsWidth",_[_.lineHeight=66]="lineHeight",_[_.lineNumbers=67]="lineNumbers",_[_.lineNumbersMinChars=68]="lineNumbersMinChars",_[_.linkedEditing=69]="linkedEditing",_[_.links=70]="links",_[_.matchBrackets=71]="matchBrackets",_[_.minimap=72]="minimap",_[_.mouseStyle=73]="mouseStyle",_[_.mouseWheelScrollSensitivity=74]="mouseWheelScrollSensitivity",_[_.mouseWheelZoom=75]="mouseWheelZoom",_[_.multiCursorMergeOverlapping=76]="multiCursorMergeOverlapping",_[_.multiCursorModifier=77]="multiCursorModifier",_[_.multiCursorPaste=78]="multiCursorPaste",_[_.multiCursorLimit=79]="multiCursorLimit",_[_.occurrencesHighlight=80]="occurrencesHighlight",_[_.overviewRulerBorder=81]="overviewRulerBorder",_[_.overviewRulerLanes=82]="overviewRulerLanes",_[_.padding=83]="padding",_[_.pasteAs=84]="pasteAs",_[_.parameterHints=85]="parameterHints",_[_.peekWidgetDefaultFocus=86]="peekWidgetDefaultFocus",_[_.definitionLinkOpensInPeek=87]="definitionLinkOpensInPeek",_[_.quickSuggestions=88]="quickSuggestions",_[_.quickSuggestionsDelay=89]="quickSuggestionsDelay",_[_.readOnly=90]="readOnly",_[_.readOnlyMessage=91]="readOnlyMessage",_[_.renameOnType=92]="renameOnType",_[_.renderControlCharacters=93]="renderControlCharacters",_[_.renderFinalNewline=94]="renderFinalNewline",_[_.renderLineHighlight=95]="renderLineHighlight",_[_.renderLineHighlightOnlyWhenFocus=96]="renderLineHighlightOnlyWhenFocus",_[_.renderValidationDecorations=97]="renderValidationDecorations",_[_.renderWhitespace=98]="renderWhitespace",_[_.revealHorizontalRightPadding=99]="revealHorizontalRightPadding",_[_.roundedSelection=100]="roundedSelection",_[_.rulers=101]="rulers",_[_.scrollbar=102]="scrollbar",_[_.scrollBeyondLastColumn=103]="scrollBeyondLastColumn",_[_.scrollBeyondLastLine=104]="scrollBeyondLastLine",_[_.scrollPredominantAxis=105]="scrollPredominantAxis",_[_.selectionClipboard=106]="selectionClipboard",_[_.selectionHighlight=107]="selectionHighlight",_[_.selectOnLineNumbers=108]="selectOnLineNumbers",_[_.showFoldingControls=109]="showFoldingControls",_[_.showUnused=110]="showUnused",_[_.snippetSuggestions=111]="snippetSuggestions",_[_.smartSelect=112]="smartSelect",_[_.smoothScrolling=113]="smoothScrolling",_[_.stickyScroll=114]="stickyScroll",_[_.stickyTabStops=115]="stickyTabStops",_[_.stopRenderingLineAfter=116]="stopRenderingLineAfter",_[_.suggest=117]="suggest",_[_.suggestFontSize=118]="suggestFontSize",_[_.suggestLineHeight=119]="suggestLineHeight",_[_.suggestOnTriggerCharacters=120]="suggestOnTriggerCharacters",_[_.suggestSelection=121]="suggestSelection",_[_.tabCompletion=122]="tabCompletion",_[_.tabIndex=123]="tabIndex",_[_.unicodeHighlighting=124]="unicodeHighlighting",_[_.unusualLineTerminators=125]="unusualLineTerminators",_[_.useShadowDOM=126]="useShadowDOM",_[_.useTabStops=127]="useTabStops",_[_.wordBreak=128]="wordBreak",_[_.wordSeparators=129]="wordSeparators",_[_.wordWrap=130]="wordWrap",_[_.wordWrapBreakAfterCharacters=131]="wordWrapBreakAfterCharacters",_[_.wordWrapBreakBeforeCharacters=132]="wordWrapBreakBeforeCharacters",_[_.wordWrapColumn=133]="wordWrapColumn",_[_.wordWrapOverride1=134]="wordWrapOverride1",_[_.wordWrapOverride2=135]="wordWrapOverride2",_[_.wrappingIndent=136]="wrappingIndent",_[_.wrappingStrategy=137]="wrappingStrategy",_[_.showDeprecated=138]="showDeprecated",_[_.inlayHints=139]="inlayHints",_[_.editorClassName=140]="editorClassName",_[_.pixelRatio=141]="pixelRatio",_[_.tabFocusMode=142]="tabFocusMode",_[_.layoutInfo=143]="layoutInfo",_[_.wrappingInfo=144]="wrappingInfo",_[_.defaultColorDecorators=145]="defaultColorDecorators",_[_.colorDecoratorsActivatedOn=146]="colorDecoratorsActivatedOn",_[_.inlineCompletionsAccessibilityVerbose=147]="inlineCompletionsAccessibilityVerbose"})(st||(e.EditorOption=st={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:Ne(new i(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:h.localize(195,null)})),acceptSuggestionOnEnter:Ne(new s(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",h.localize(196,null),""],markdownDescription:h.localize(197,null)})),accessibilitySupport:Ne(new v),accessibilityPageSize:Ne(new m(3,"accessibilityPageSize",10,1,1073741824,{description:h.localize(198,null),tags:["accessibility"]})),ariaLabel:Ne(new n(4,"ariaLabel",h.localize(199,null))),ariaRequired:Ne(new i(5,"ariaRequired",!1,void 0)),screenReaderAnnounceInlineSuggestion:Ne(new i(8,"screenReaderAnnounceInlineSuggestion",!0,{description:h.localize(200,null),tags:["accessibility"]})),autoClosingBrackets:Ne(new s(6,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",h.localize(201,null),h.localize(202,null),""],description:h.localize(203,null)})),autoClosingComments:Ne(new s(7,"autoClosingComments","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",h.localize(204,null),h.localize(205,null),""],description:h.localize(206,null)})),autoClosingDelete:Ne(new s(9,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",h.localize(207,null),""],description:h.localize(208,null)})),autoClosingOvertype:Ne(new s(10,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",h.localize(209,null),""],description:h.localize(210,null)})),autoClosingQuotes:Ne(new s(11,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",h.localize(211,null),h.localize(212,null),""],description:h.localize(213,null)})),autoIndent:Ne(new o(12,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],w,{enumDescriptions:[h.localize(214,null),h.localize(215,null),h.localize(216,null),h.localize(217,null),h.localize(218,null)],description:h.localize(219,null)})),automaticLayout:Ne(new i(13,"automaticLayout",!1)),autoSurround:Ne(new s(14,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[h.localize(220,null),h.localize(221,null),h.localize(222,null),""],description:h.localize(223,null)})),bracketPairColorization:Ne(new Z),bracketPairGuides:Ne(new K),stickyTabStops:Ne(new i(115,"stickyTabStops",!1,{description:h.localize(224,null)})),codeLens:Ne(new i(17,"codeLens",!0,{description:h.localize(225,null)})),codeLensFontFamily:Ne(new n(18,"codeLensFontFamily","",{description:h.localize(226,null)})),codeLensFontSize:Ne(new m(19,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:h.localize(227,null)})),colorDecorators:Ne(new i(20,"colorDecorators",!0,{description:h.localize(228,null)})),colorDecoratorActivatedOn:Ne(new s(146,"colorDecoratorsActivatedOn","clickAndHover",["clickAndHover","hover","click"],{enumDescriptions:[h.localize(229,null),h.localize(230,null),h.localize(231,null)],description:h.localize(232,null)})),colorDecoratorsLimit:Ne(new m(21,"colorDecoratorsLimit",500,1,1e6,{markdownDescription:h.localize(233,null)})),columnSelection:Ne(new i(22,"columnSelection",!1,{description:h.localize(234,null)})),comments:Ne(new I),contextmenu:Ne(new i(24,"contextmenu",!0)),copyWithSyntaxHighlighting:Ne(new i(25,"copyWithSyntaxHighlighting",!0,{description:h.localize(235,null)})),cursorBlinking:Ne(new o(26,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],r,{description:h.localize(236,null)})),cursorSmoothCaretAnimation:Ne(new s(27,"cursorSmoothCaretAnimation","off",["off","explicit","on"],{enumDescriptions:[h.localize(237,null),h.localize(238,null),h.localize(239,null)],description:h.localize(240,null)})),cursorStyle:Ne(new o(28,"cursorStyle",l.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],F,{description:h.localize(241,null)})),cursorSurroundingLines:Ne(new m(29,"cursorSurroundingLines",0,0,1073741824,{description:h.localize(242,null)})),cursorSurroundingLinesStyle:Ne(new s(30,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[h.localize(243,null),h.localize(244,null)],markdownDescription:h.localize(245,null)})),cursorWidth:Ne(new m(31,"cursorWidth",0,0,1073741824,{markdownDescription:h.localize(246,null)})),disableLayerHinting:Ne(new i(32,"disableLayerHinting",!1)),disableMonospaceOptimizations:Ne(new i(33,"disableMonospaceOptimizations",!1)),domReadOnly:Ne(new i(34,"domReadOnly",!1)),dragAndDrop:Ne(new i(35,"dragAndDrop",!0,{description:h.localize(247,null)})),emptySelectionClipboard:Ne(new V),dropIntoEditor:Ne(new et),stickyScroll:Ne(new ae),experimentalWhitespaceRendering:Ne(new s(38,"experimentalWhitespaceRendering","svg",["svg","font","off"],{enumDescriptions:[h.localize(248,null),h.localize(249,null),h.localize(250,null)],description:h.localize(251,null)})),extraEditorClassName:Ne(new n(39,"extraEditorClassName","")),fastScrollSensitivity:Ne(new b(40,"fastScrollSensitivity",5,_=>_<=0?5:_,{markdownDescription:h.localize(252,null)})),find:Ne(new B),fixedOverflowWidgets:Ne(new i(42,"fixedOverflowWidgets",!1)),folding:Ne(new i(43,"folding",!0,{description:h.localize(253,null)})),foldingStrategy:Ne(new s(44,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[h.localize(254,null),h.localize(255,null)],description:h.localize(256,null)})),foldingHighlight:Ne(new i(45,"foldingHighlight",!0,{description:h.localize(257,null)})),foldingImportsByDefault:Ne(new i(46,"foldingImportsByDefault",!1,{description:h.localize(258,null)})),foldingMaximumRegions:Ne(new m(47,"foldingMaximumRegions",5e3,10,65e3,{description:h.localize(259,null)})),unfoldOnClickAfterEndOfLine:Ne(new i(48,"unfoldOnClickAfterEndOfLine",!1,{description:h.localize(260,null)})),fontFamily:Ne(new n(49,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:h.localize(261,null)})),fontInfo:Ne(new z),fontLigatures2:Ne(new j),fontSize:Ne(new ie),fontWeight:Ne(new Y),fontVariations:Ne(new U),formatOnPaste:Ne(new i(55,"formatOnPaste",!1,{description:h.localize(262,null)})),formatOnType:Ne(new i(56,"formatOnType",!1,{description:h.localize(263,null)})),glyphMargin:Ne(new i(57,"glyphMargin",!0,{description:h.localize(264,null)})),gotoLocation:Ne(new ye),hideCursorInOverviewRuler:Ne(new i(59,"hideCursorInOverviewRuler",!1,{description:h.localize(265,null)})),hover:Ne(new ke),inDiffEditor:Ne(new i(61,"inDiffEditor",!1)),letterSpacing:Ne(new b(63,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,_=>b.clamp(_,-5,20),{description:h.localize(266,null)})),lightbulb:Ne(new we),lineDecorationsWidth:Ne(new ue),lineHeight:Ne(new O),lineNumbers:Ne(new de),lineNumbersMinChars:Ne(new m(68,"lineNumbersMinChars",5,1,300)),linkedEditing:Ne(new i(69,"linkedEditing",!1,{description:h.localize(267,null)})),links:Ne(new i(70,"links",!0,{description:h.localize(268,null)})),matchBrackets:Ne(new s(71,"matchBrackets","always",["always","near","never"],{description:h.localize(269,null)})),minimap:Ne(new J),mouseStyle:Ne(new s(73,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:Ne(new b(74,"mouseWheelScrollSensitivity",1,_=>_===0?1:_,{markdownDescription:h.localize(270,null)})),mouseWheelZoom:Ne(new i(75,"mouseWheelZoom",!1,{markdownDescription:h.localize(271,null)})),multiCursorMergeOverlapping:Ne(new i(76,"multiCursorMergeOverlapping",!0,{description:h.localize(272,null)})),multiCursorModifier:Ne(new o(77,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],he,{markdownEnumDescriptions:[h.localize(273,null),h.localize(274,null)],markdownDescription:h.localize(275,null)})),multiCursorPaste:Ne(new s(78,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[h.localize(276,null),h.localize(277,null)],markdownDescription:h.localize(278,null)})),multiCursorLimit:Ne(new m(79,"multiCursorLimit",1e4,1,1e5,{markdownDescription:h.localize(279,null)})),occurrencesHighlight:Ne(new i(80,"occurrencesHighlight",!0,{description:h.localize(280,null)})),overviewRulerBorder:Ne(new i(81,"overviewRulerBorder",!0,{description:h.localize(281,null)})),overviewRulerLanes:Ne(new m(82,"overviewRulerLanes",3,0,3)),padding:Ne(new Ee),pasteAs:Ne(new Ye),parameterHints:Ne(new ve),peekWidgetDefaultFocus:Ne(new s(86,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[h.localize(282,null),h.localize(283,null)],description:h.localize(284,null)})),definitionLinkOpensInPeek:Ne(new i(87,"definitionLinkOpensInPeek",!1,{description:h.localize(285,null)})),quickSuggestions:Ne(new De),quickSuggestionsDelay:Ne(new m(89,"quickSuggestionsDelay",10,0,1073741824,{description:h.localize(286,null)})),readOnly:Ne(new i(90,"readOnly",!1)),readOnlyMessage:Ne(new me),renameOnType:Ne(new i(92,"renameOnType",!1,{description:h.localize(287,null),markdownDeprecationMessage:h.localize(288,null)})),renderControlCharacters:Ne(new i(93,"renderControlCharacters",!0,{description:h.localize(289,null),restricted:!0})),renderFinalNewline:Ne(new s(94,"renderFinalNewline",C.$k?"dimmed":"on",["off","on","dimmed"],{description:h.localize(290,null)})),renderLineHighlight:Ne(new s(95,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",h.localize(291,null)],description:h.localize(292,null)})),renderLineHighlightOnlyWhenFocus:Ne(new i(96,"renderLineHighlightOnlyWhenFocus",!1,{description:h.localize(293,null)})),renderValidationDecorations:Ne(new s(97,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:Ne(new s(98,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",h.localize(294,null),h.localize(295,null),h.localize(296,null),""],description:h.localize(297,null)})),revealHorizontalRightPadding:Ne(new m(99,"revealHorizontalRightPadding",15,0,1e3)),roundedSelection:Ne(new i(100,"roundedSelection",!0,{description:h.localize(298,null)})),rulers:Ne(new ne),scrollbar:Ne(new M),scrollBeyondLastColumn:Ne(new m(103,"scrollBeyondLastColumn",4,0,1073741824,{description:h.localize(299,null)})),scrollBeyondLastLine:Ne(new i(104,"scrollBeyondLastLine",!0,{description:h.localize(300,null)})),scrollPredominantAxis:Ne(new i(105,"scrollPredominantAxis",!0,{description:h.localize(301,null)})),selectionClipboard:Ne(new i(106,"selectionClipboard",!0,{description:h.localize(302,null),included:C.$k})),selectionHighlight:Ne(new i(107,"selectionHighlight",!0,{description:h.localize(303,null)})),selectOnLineNumbers:Ne(new i(108,"selectOnLineNumbers",!0)),showFoldingControls:Ne(new s(109,"showFoldingControls","mouseover",["always","never","mouseover"],{enumDescriptions:[h.localize(304,null),h.localize(305,null),h.localize(306,null)],description:h.localize(307,null)})),showUnused:Ne(new i(110,"showUnused",!0,{description:h.localize(308,null)})),showDeprecated:Ne(new i(138,"showDeprecated",!0,{description:h.localize(309,null)})),inlayHints:Ne(new x),snippetSuggestions:Ne(new s(111,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[h.localize(310,null),h.localize(311,null),h.localize(312,null),h.localize(313,null)],description:h.localize(314,null)})),smartSelect:Ne(new ze),smoothScrolling:Ne(new i(113,"smoothScrolling",!1,{description:h.localize(315,null)})),stopRenderingLineAfter:Ne(new m(116,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:Ne(new ce),inlineSuggest:Ne(new H),inlineCompletionsAccessibilityVerbose:Ne(new i(147,"inlineCompletionsAccessibilityVerbose",!1,{description:h.localize(316,null)})),suggestFontSize:Ne(new m(118,"suggestFontSize",0,0,1e3,{markdownDescription:h.localize(317,null,"`0`","`#editor.fontSize#`")})),suggestLineHeight:Ne(new m(119,"suggestLineHeight",0,0,1e3,{markdownDescription:h.localize(318,null,"`0`","`#editor.lineHeight#`")})),suggestOnTriggerCharacters:Ne(new i(120,"suggestOnTriggerCharacters",!0,{description:h.localize(319,null)})),suggestSelection:Ne(new s(121,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[h.localize(320,null),h.localize(321,null),h.localize(322,null)],description:h.localize(323,null)})),tabCompletion:Ne(new s(122,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[h.localize(324,null),h.localize(325,null),h.localize(326,null)],description:h.localize(327,null)})),tabIndex:Ne(new m(123,"tabIndex",0,-1,1073741824)),unicodeHighlight:Ne(new q),unusualLineTerminators:Ne(new s(125,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[h.localize(328,null),h.localize(329,null),h.localize(330,null)],description:h.localize(331,null)})),useShadowDOM:Ne(new i(126,"useShadowDOM",!0)),useTabStops:Ne(new i(127,"useTabStops",!0,{description:h.localize(332,null)})),wordBreak:Ne(new s(128,"wordBreak","normal",["normal","keepAll"],{markdownEnumDescriptions:[h.localize(333,null),h.localize(334,null)],description:h.localize(335,null)})),wordSeparators:Ne(new n(129,"wordSeparators",A.$Sr,{description:h.localize(336,null)})),wordWrap:Ne(new s(130,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[h.localize(337,null),h.localize(338,null),h.localize(339,null),h.localize(340,null)],description:h.localize(341,null)})),wordWrapBreakAfterCharacters:Ne(new n(131,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:Ne(new n(132,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:Ne(new m(133,"wordWrapColumn",80,1,1073741824,{markdownDescription:h.localize(342,null)})),wordWrapOverride1:Ne(new s(134,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:Ne(new s(135,"wordWrapOverride2","inherit",["off","on","inherit"])),editorClassName:Ne(new W),defaultColorDecorators:Ne(new i(145,"defaultColorDecorators",!1,{markdownDescription:h.localize(343,null)})),pixelRatio:Ne(new be),tabFocusMode:Ne(new i(142,"tabFocusMode",!1,{markdownDescription:h.localize(344,null)})),layoutInfo:Ne(new X),wrappingInfo:Ne(new He),wrappingIndent:Ne(new Ze),wrappingStrategy:Ne(new le)}}),define(Pe[138],Ae([10,11]),function(pe,e){return pe.create("vs/platform/configuration/common/configurationRegistry",e)}),define(Pe[139],Ae([10,11]),function(pe,e){return pe.create("vs/platform/contextkey/common/contextkey",e)}),define(Pe[140],Ae([10,11]),function(pe,e){return pe.create("vs/platform/contextkey/common/scanner",e)}),define(Pe[141],Ae([10,11]),function(pe,e){return pe.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(Pe[142],Ae([10,11]),function(pe,e){return pe.create("vs/platform/extensions/common/extensionValidator",e)}),define(Pe[143],Ae([10,11]),function(pe,e){return pe.create("vs/platform/files/common/files",e)}),define(Pe[144],Ae([10,11]),function(pe,e){return pe.create("vs/platform/markers/common/markers",e)}),define(Pe[145],Ae([10,11]),function(pe,e){return pe.create("vs/platform/theme/common/iconRegistry",e)}),define(Pe[146],Ae([10,11]),function(pe,e){return pe.create("vs/platform/workspace/common/workspace",e)}),define(Pe[147],Ae([10,11]),function(pe,e){return pe.create("vs/workbench/api/common/extHostChat",e)}),define(Pe[148],Ae([10,11]),function(pe,e){return pe.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(Pe[149],Ae([10,11]),function(pe,e){return pe.create("vs/workbench/api/common/extHostExtensionService",e)}),define(Pe[150],Ae([10,11]),function(pe,e){return pe.create("vs/workbench/api/common/extHostLanguageFeatures",e)}),define(Pe[151],Ae([10,11]),function(pe,e){return pe.create("vs/workbench/api/common/extHostLogService",e)}),define(Pe[152],Ae([10,11]),function(pe,e){return pe.create("vs/workbench/api/common/extHostNotebook",e)}),define(Pe[153],Ae([10,11]),function(pe,e){return pe.create("vs/workbench/api/common/extHostProgress",e)}),define(Pe[154],Ae([10,11]),function(pe,e){return pe.create("vs/workbench/api/common/extHostStatusBar",e)}),define(Pe[155],Ae([10,11]),function(pe,e){return pe.create("vs/workbench/api/common/extHostTelemetry",e)}),define(Pe[156],Ae([10,11]),function(pe,e){return pe.create("vs/workbench/api/common/extHostTerminalService",e)}),define(Pe[157],Ae([10,11]),function(pe,e){return pe.create("vs/workbench/api/common/extHostTreeViews",e)}),define(Pe[158],Ae([10,11]),function(pe,e){return pe.create("vs/workbench/api/common/extHostTunnelService",e)}),define(Pe[159],Ae([10,11]),function(pe,e){return pe.create("vs/workbench/api/common/extHostWorkspace",e)}),define(Pe[160],Ae([10,11]),function(pe,e){return pe.create("vs/workbench/common/editor",e)}),define(Pe[161],Ae([10,11]),function(pe,e){return pe.create("vs/workbench/common/views",e)}),define(Pe[162],Ae([10,11]),function(pe,e){return pe.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(Pe[163],Ae([10,11]),function(pe,e){return pe.create("vs/workbench/contrib/debug/common/debug",e)}),define(Pe[164],Ae([10,11]),function(pe,e){return pe.create("vs/workbench/contrib/tasks/common/taskDefinitionRegistry",e)}),define(Pe[165],Ae([10,11]),function(pe,e){return pe.create("vs/workbench/contrib/tasks/common/tasks",e)}),define(Pe[166],Ae([10,11]),function(pe,e){return pe.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(Pe[167],Ae([10,11]),function(pe,e){return pe.create("vs/workbench/services/extensions/common/extensionsRegistry",e)}),define(Pe[168],Ae([10,11]),function(pe,e){return pe.create("vs/workbench/services/search/common/queryBuilder",e)}),define(Pe[169],Ae([1,0,9,140]),function(pe,e,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Di=e.TokenType=void 0;var C;(function(g){g[g.LParen=0]="LParen",g[g.RParen=1]="RParen",g[g.Neg=2]="Neg",g[g.Eq=3]="Eq",g[g.NotEq=4]="NotEq",g[g.Lt=5]="Lt",g[g.LtEq=6]="LtEq",g[g.Gt=7]="Gt",g[g.GtEq=8]="GtEq",g[g.RegexOp=9]="RegexOp",g[g.RegexStr=10]="RegexStr",g[g.True=11]="True",g[g.False=12]="False",g[g.In=13]="In",g[g.Not=14]="Not",g[g.And=15]="And",g[g.Or=16]="Or",g[g.Str=17]="Str",g[g.QuotedStr=18]="QuotedStr",g[g.Error=19]="Error",g[g.EOF=20]="EOF"})(C||(e.TokenType=C={}));function L(...g){switch(g.length){case 1:return(0,R.localize)(0,null,g[0]);case 2:return(0,R.localize)(1,null,g[0],g[1]);case 3:return(0,R.localize)(2,null,g[0],g[1],g[2]);default:return}}const A=(0,R.localize)(3,null),h=(0,R.localize)(4,null);class S{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(P){switch(P.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return P.isTripleEq?"===":"==";case 4:return P.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return P.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return P.lexeme;case 18:return P.lexeme;case 19:return P.lexeme;case 20:return"EOF";default:throw(0,y.$6)(`unhandled token type: ${JSON.stringify(P)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(P=>P.charCodeAt(0)))}static{this.b=new Map([["not",14],["in",13],["false",12],["true",11]])}get errors(){return this.g}reset(P){return this.c=P,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case 40:this.k(0);break;case 41:this.k(1);break;case 33:if(this.h(61)){const D=this.h(61);this.f.push({type:4,offset:this.d,isTripleEq:D})}else this.k(2);break;case 39:this.o();break;case 47:this.q();break;case 61:if(this.h(61)){const D=this.h(61);this.f.push({type:3,offset:this.d,isTripleEq:D})}else this.h(126)?this.k(9):this.l(L("==","=~"));break;case 60:this.k(this.h(61)?6:5);break;case 62:this.k(this.h(61)?8:7);break;case 38:this.h(38)?this.k(15):this.l(L("&&"));break;case 124:this.h(124)?this.k(16):this.l(L("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this.n()}return this.d=this.e,this.k(20),Array.from(this.f)}h(P){return this.r()||this.c.charCodeAt(this.e)!==P?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?0:this.c.charCodeAt(this.e)}k(P){this.f.push({type:P,offset:this.d})}l(P){const D=this.d,u=this.c.substring(this.d,this.e),p={type:19,offset:this.d,lexeme:u};this.g.push({offset:D,lexeme:u,additionalInfo:P}),this.f.push(p)}n(){this.m.lastIndex=this.d;const P=this.m.exec(this.c);if(P){this.e=this.d+P[0].length;const D=this.c.substring(this.d,this.e),u=S.b.get(D);u?this.k(u):this.f.push({type:17,lexeme:D,offset:this.d})}}o(){for(;this.j()!==39&&!this.r();)this.i();if(this.r()){this.l(A);return}this.i(),this.f.push({type:18,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let P=this.e,D=!1,u=!1;for(;;){if(P>=this.c.length){this.e=P,this.l(h);return}const $=this.c.charCodeAt(P);if(D)D=!1;else if($===47&&!u){P++;break}else $===91?u=!0:$===92?D=!0:$===93&&(u=!1);P++}for(;P<this.c.length&&S.a.has(this.c.charCodeAt(P));)P++;this.e=P;const p=this.c.substring(this.d,this.e);this.f.push({type:10,lexeme:p,offset:this.d})}r(){return this.e>=this.c.length}}e.$Di=S}),define(Pe[170],Ae([1,0,23,29,142,276]),function(pe,e,y,R,C,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fo=e.$Eo=e.$Do=e.$Co=e.$Bo=e.$Ao=e.$zo=void 0;const A=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,h=/^-(\d{4})(\d{2})(\d{2})$/;function S(i){return i=i.trim(),i==="*"||A.test(i)}e.$zo=S;function g(i){if(!S(i))return null;if(i=i.trim(),i==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const c=i.match(A);return c?{hasCaret:c[1]==="^",hasGreaterEquals:c[1]===">=",majorBase:c[2]==="x"?0:parseInt(c[2],10),majorMustEqual:c[2]!=="x",minorBase:c[4]==="x"?0:parseInt(c[4],10),minorMustEqual:c[4]!=="x",patchBase:c[6]==="x"?0:parseInt(c[6],10),patchMustEqual:c[6]!=="x",preRelease:c[8]||null}:null}e.$Ao=g;function P(i){if(!i)return null;const c=i.majorBase,m=i.majorMustEqual,E=i.minorBase;let b=i.minorMustEqual;const n=i.patchBase;let a=i.patchMustEqual;i.hasCaret&&(c===0||(b=!1),a=!1);let s=0;if(i.preRelease){const o=h.exec(i.preRelease);if(o){const[,w,v,I]=o;s=Date.UTC(Number(w),Number(v)-1,Number(I))}}return{majorBase:c,majorMustEqual:m,minorBase:E,minorMustEqual:b,patchBase:n,patchMustEqual:a,isMinimum:i.hasGreaterEquals,notBefore:s}}e.$Bo=P;function D(i,c,m){let E;typeof i=="string"?E=P(g(i)):E=i;let b;c instanceof Date?b=c.getTime():typeof c=="string"&&(b=new Date(c).getTime());let n;if(typeof m=="string"?n=P(g(m)):n=m,!E||!n)return!1;const a=E.majorBase,s=E.minorBase,o=E.patchBase;let w=n.majorBase,v=n.minorBase,I=n.patchBase;const k=n.notBefore;let r=n.majorMustEqual,l=n.minorMustEqual,f=n.patchMustEqual;return n.isMinimum?a>w?!0:a<w?!1:s>v?!0:s<v||b&&b<k?!1:o>=I:(a===1&&w===0&&(!r||!l||!f)&&(w=1,v=0,I=0,r=!0,l=!1,f=!1),a<w?!1:a>w?!r:s<v?!1:s>v?!l:o<I?!1:o>I?!f:!(b&&b<k))}e.$Co=D;function u(i,c,m,E,b){const n=[];if(typeof E.publisher<"u"&&typeof E.publisher!="string")return n.push([R.default.Error,C.localize(0,null)]),n;if(typeof E.name!="string")return n.push([R.default.Error,C.localize(1,null,"name")]),n;if(typeof E.version!="string")return n.push([R.default.Error,C.localize(2,null,"version")]),n;if(!E.engines)return n.push([R.default.Error,C.localize(3,null,"engines")]),n;if(typeof E.engines.vscode!="string")return n.push([R.default.Error,C.localize(4,null,"engines.vscode")]),n;if(typeof E.extensionDependencies<"u"&&!t(E.extensionDependencies))return n.push([R.default.Error,C.localize(5,null,"extensionDependencies")]),n;if(typeof E.activationEvents<"u"){if(!t(E.activationEvents))return n.push([R.default.Error,C.localize(6,null,"activationEvents")]),n;if(typeof E.main>"u"&&typeof E.browser>"u")return n.push([R.default.Error,C.localize(7,null,"activationEvents","main","browser")]),n}if(typeof E.extensionKind<"u"&&typeof E.main>"u"&&n.push([R.default.Warning,C.localize(8,null,"extensionKind")]),typeof E.main<"u"){if(typeof E.main!="string")return n.push([R.default.Error,C.localize(9,null,"main")]),n;{const o=(0,y.$gg)(m,E.main);(0,y.$ag)(o,m)||n.push([R.default.Warning,C.localize(10,null,o.path,m.path)])}}if(typeof E.browser<"u"){if(typeof E.browser!="string")return n.push([R.default.Error,C.localize(11,null,"browser")]),n;{const o=(0,y.$gg)(m,E.browser);(0,y.$ag)(o,m)||n.push([R.default.Warning,C.localize(12,null,o.path,m.path)])}}if(!L.valid(E.version))return n.push([R.default.Error,C.localize(13,null)]),n;const a=[];if(!p(i,c,E,b,a))for(const o of a)n.push([R.default.Error,o]);return n}e.$Do=u;function p(i,c,m,E,b){return E||typeof m.main>"u"&&typeof m.browser>"u"?!0:d(i,c,m.engines.vscode,b)}e.$Eo=p;function $(i,c,m){return i==="*"||d(c,m,i)}e.$Fo=$;function d(i,c,m,E=[]){const b=P(g(m));if(!b)return E.push(C.localize(14,null,m)),!1;if(b.majorBase===0){if(!b.majorMustEqual||!b.minorMustEqual)return E.push(C.localize(15,null,m)),!1}else if(!b.majorMustEqual)return E.push(C.localize(16,null,m)),!1;return D(i,c,b)?!0:(E.push(C.localize(17,null,i,m)),!1)}function t(i){if(!Array.isArray(i))return!1;for(let c=0,m=i.length;c<m;c++)if(typeof i[c]!="string")return!1;return!0}}),define(Pe[69],Ae([1,0]),function(pe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wh=void 0;class y{constructor(C,L=[],A=!1){this.ctor=C,this.staticArguments=L,this.supportsDelayedInstantiation=A}}e.$wh=y}),define(Pe[70],Ae([1,0,69]),function(pe,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kr=e.$jr=e.InstantiationType=void 0;const R=[];var C;(function(h){h[h.Eager=0]="Eager",h[h.Delayed=1]="Delayed"})(C||(e.InstantiationType=C={}));function L(h,S,g){S instanceof y.$wh||(S=new y.$wh(S,[],!!g)),R.push([h,S])}e.$jr=L;function A(){return R}e.$kr=A}),define(Pe[171],Ae([1,0]),function(pe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2p=e.$1p=void 0;class y{constructor(L,A){this.key=L,this.data=A,this.incoming=new Map,this.outgoing=new Map}}e.$1p=y;class R{constructor(L){this.b=L,this.a=new Map}roots(){const L=[];for(const A of this.a.values())A.outgoing.size===0&&L.push(A);return L}insertEdge(L,A){const h=this.lookupOrInsertNode(L),S=this.lookupOrInsertNode(A);h.outgoing.set(S.key,S),S.incoming.set(h.key,h)}removeNode(L){const A=this.b(L);this.a.delete(A);for(const h of this.a.values())h.outgoing.delete(A),h.incoming.delete(A)}lookupOrInsertNode(L){const A=this.b(L);let h=this.a.get(A);return h||(h=new y(A,L),this.a.set(A,h)),h}lookup(L){return this.a.get(this.b(L))}isEmpty(){return this.a.size===0}toString(){const L=[];for(const[A,h]of this.a)L.push(`${A}
	(-> incoming)[${[...h.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...h.outgoing.keys()].join(",")}]
`);return L.join(`
`)}findCycleSlow(){for(const[L,A]of this.a){const h=new Set([L]),S=this.c(A,h);if(S)return S}}c(L,A){for(const[h,S]of L.outgoing){if(A.has(h))return[...A,h].join(" -> ");A.add(h);const g=this.c(S,A);if(g)return g;A.delete(h)}}}e.$2p=R}),define(Pe[4],Ae([1,0]),function(pe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ah=e.$zh=e.$yh=e._util=void 0;var y;(function(A){A.serviceIds=new Map,A.DI_TARGET="$di$target",A.DI_DEPENDENCIES="$di$dependencies";function h(S){return S[A.DI_DEPENDENCIES]||[]}A.getServiceDependencies=h})(y||(e._util=y={})),e.$yh=C("instantiationService");function R(A,h,S){h[y.DI_TARGET]===h?h[y.DI_DEPENDENCIES].push({id:A,index:S}):(h[y.DI_DEPENDENCIES]=[{id:A,index:S}],h[y.DI_TARGET]=h)}function C(A){if(y.serviceIds.has(A))return y.serviceIds.get(A);const h=function(S,g,P){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");R(h,S,P)};return h.toString=()=>A,y.serviceIds.set(A,h),h}e.$zh=C;function L(A){return A}e.$Ah=L}),define(Pe[43],Ae([1,0,16,2,4]),function(pe,e,y,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$di=e.$ci=e.$bi=e.$ai=e.$_h=e.$$h=e.$0h=e.$9h=e.ConfigurationTarget=e.$8h=e.$7h=e.$6h=void 0,e.$6h=(0,C.$zh)("configurationService");function L(i){return i&&typeof i=="object"&&(!i.overrideIdentifier||typeof i.overrideIdentifier=="string")&&(!i.resource||i.resource instanceof R.URI)}e.$7h=L;function A(i){return i&&typeof i=="object"&&(!i.overrideIdentifiers||Array.isArray(i.overrideIdentifiers))&&!i.overrideIdentifier&&(!i.resource||i.resource instanceof R.URI)}e.$8h=A;var h;(function(i){i[i.APPLICATION=1]="APPLICATION",i[i.USER=2]="USER",i[i.USER_LOCAL=3]="USER_LOCAL",i[i.USER_REMOTE=4]="USER_REMOTE",i[i.WORKSPACE=5]="WORKSPACE",i[i.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",i[i.DEFAULT=7]="DEFAULT",i[i.MEMORY=8]="MEMORY"})(h||(e.ConfigurationTarget=h={}));function S(i){switch(i){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.$9h=S;function g(i){return i.applicationValue!==void 0||i.userValue!==void 0||i.userLocalValue!==void 0||i.userRemoteValue!==void 0||i.workspaceValue!==void 0||i.workspaceFolderValue!==void 0}e.$0h=g;function P(i,c){const m=Object.create(null);for(const E in i)D(m,E,i[E],c);return m}e.$$h=P;function D(i,c,m,E){const b=c.split("."),n=b.pop();let a=i;for(let s=0;s<b.length;s++){const o=b[s];let w=a[o];switch(typeof w){case"undefined":w=a[o]=Object.create(null);break;case"object":break;default:E(`Ignoring ${c} as ${b.slice(0,s+1).join(".")} is ${JSON.stringify(w)}`);return}a=w}if(typeof a=="object"&&a!==null)try{a[n]=m}catch{E(`Ignoring ${c} as ${b.join(".")} is ${JSON.stringify(a)}`)}else E(`Ignoring ${c} as ${b.join(".")} is ${JSON.stringify(a)}`)}e.$_h=D;function u(i,c){const m=c.split(".");p(i,m)}e.$ai=u;function p(i,c){const m=c.shift();if(c.length===0){delete i[m];return}if(Object.keys(i).indexOf(m)!==-1){const E=i[m];typeof E=="object"&&!Array.isArray(E)&&(p(E,c),Object.keys(E).length===0&&delete i[m])}}function $(i,c,m){function E(a,s){let o=a;for(const w of s){if(typeof o!="object"||o===null)return;o=o[w]}return o}const b=c.split("."),n=E(i,b);return typeof n>"u"?m:n}e.$bi=$;function d(i,c,m){Object.keys(c).forEach(E=>{E!=="__proto__"&&(E in i?y.$ne(i[E])&&y.$ne(c[E])?d(i[E],c[E],m):m&&(i[E]=c[E]):i[E]=c[E])})}e.$ci=d;function t(i){return i.replace(/[\[\]]/g,"")}e.$di=t}),define(Pe[32],Ae([1,0,22,15,169,4,139,9]),function(pe,e,y,R,C,L,A,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2i=e.$1i=e.$Zi=e.$Yi=e.$Xi=e.$Wi=e.$Vi=e.$Ui=e.$Ti=e.$Si=e.$Ri=e.$Qi=e.$Pi=e.$Oi=e.$Ni=e.$Mi=e.$Li=e.$Ki=e.$Ji=e.$Ii=e.$Hi=e.$Gi=e.$Fi=e.ContextKeyExprType=e.$Ei=void 0;const S=new Map;S.set("false",!1),S.set("true",!0),S.set("isMac",y.$j),S.set("isLinux",y.$k),S.set("isWindows",y.$i),S.set("isWeb",y.$o),S.set("isMacNative",y.$j&&!y.$o),S.set("isEdge",y.$G),S.set("isFirefox",y.$E),S.set("isChrome",y.$D),S.set("isSafari",y.$F);function g(ue,O){if(S.get(ue)!==void 0)throw(0,h.$5)("contextkey.setConstant(k, v) invoked with already set constant `k`");S.set(ue,O)}e.$Ei=g;const P=Object.prototype.hasOwnProperty;var D;(function(ue){ue[ue.False=0]="False",ue[ue.True=1]="True",ue[ue.Defined=2]="Defined",ue[ue.Not=3]="Not",ue[ue.Equals=4]="Equals",ue[ue.NotEquals=5]="NotEquals",ue[ue.And=6]="And",ue[ue.Regex=7]="Regex",ue[ue.NotRegex=8]="NotRegex",ue[ue.Or=9]="Or",ue[ue.In=10]="In",ue[ue.NotIn=11]="NotIn",ue[ue.Greater=12]="Greater",ue[ue.GreaterEquals=13]="GreaterEquals",ue[ue.Smaller=14]="Smaller",ue[ue.SmallerEquals=15]="SmallerEquals"})(D||(e.ContextKeyExprType=D={}));const u={regexParsingWithErrorRecovery:!0},p=(0,A.localize)(0,null),$=(0,A.localize)(1,null),d=(0,A.localize)(2,null),t=(0,A.localize)(3,null),i=(0,A.localize)(4,null),c=(0,A.localize)(5,null),m=(0,A.localize)(6,null),E=(0,A.localize)(7,null);class b{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(O=u){this.k=O,this.d=new C.$Di,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(O){if(O===""){this.h.push({message:p,offset:0,lexeme:"",additionalInfo:$});return}this.f=this.d.reset(O).scan(),this.g=0,this.h=[];try{const J=this.l();if(!this.E()){const he=this.D(),Ee=he.type===17?c:void 0;throw this.h.push({message:i,offset:he.offset,lexeme:C.$Di.getLexeme(he),additionalInfo:Ee}),b.c}return J}catch(J){if(J!==b.c)throw J;return}}l(){return this.m()}m(){const O=[this.o()];for(;this.y(16);){const J=this.o();O.push(J)}return O.length===1?O[0]:n.or(...O)}o(){const O=[this.s()];for(;this.y(15);){const J=this.s();O.push(J)}return O.length===1?O[0]:n.and(...O)}s(){if(this.y(2)){const O=this.D();switch(O.type){case 11:return this.z(),w.INSTANCE;case 12:return this.z(),v.INSTANCE;case 0:{this.z();const J=this.l();return this.A(1,t),J?.negate()}case 17:return this.z(),F.create(O.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",O)}}return this.t()}t(){const O=this.D();switch(O.type){case 11:return this.z(),n.true();case 12:return this.z(),n.false();case 0:{this.z();const J=this.l();return this.A(1,t),J}case 17:{const J=O.lexeme;if(this.z(),this.y(9)){const Ee=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),Ee.type!==10)throw this.B("REGEX",Ee);const ve=Ee.lexeme,be=ve.lastIndexOf("/"),De=be===ve.length-1?void 0:this.w(ve.substring(be+1));let oe;try{oe=new RegExp(ve.substring(1,be),De)}catch{throw this.B("REGEX",Ee)}return z.create(J,oe)}switch(Ee.type){case 10:case 19:{const ve=[Ee.lexeme];this.z();let be=this.D(),De=0;for(let me=0;me<Ee.lexeme.length;me++)Ee.lexeme.charCodeAt(me)===40?De++:Ee.lexeme.charCodeAt(me)===41&&De--;for(;!this.E()&&be.type!==15&&be.type!==16;){switch(be.type){case 0:De++;break;case 1:De--;break;case 10:case 18:for(let me=0;me<be.lexeme.length;me++)be.lexeme.charCodeAt(me)===40?De++:Ee.lexeme.charCodeAt(me)===41&&De--}if(De<0)break;ve.push(C.$Di.getLexeme(be)),this.z(),be=this.D()}const oe=ve.join(""),de=oe.lastIndexOf("/"),se=de===oe.length-1?void 0:this.w(oe.substring(de+1));let ne;try{ne=new RegExp(oe.substring(1,de),se)}catch{throw this.B("REGEX",Ee)}return n.regex(J,ne)}case 18:{const ve=Ee.lexeme;this.z();let be=null;if(!(0,R.$od)(ve)){const De=ve.indexOf("/"),oe=ve.lastIndexOf("/");if(De!==oe&&De>=0){const de=ve.slice(De+1,oe),se=ve[oe+1]==="i"?"i":"";try{be=new RegExp(de,se)}catch{throw this.B("REGEX",Ee)}}}if(be===null)throw this.B("REGEX",Ee);return z.create(J,be)}default:throw this.B("REGEX",this.D())}}if(this.y(14)){this.A(13,d);const Ee=this.u();return n.notIn(J,Ee)}switch(this.D().type){case 3:{this.z();const Ee=this.u();if(this.x().type===18)return n.equals(J,Ee);switch(Ee){case"true":return n.has(J);case"false":return n.not(J);default:return n.equals(J,Ee)}}case 4:{this.z();const Ee=this.u();if(this.x().type===18)return n.notEquals(J,Ee);switch(Ee){case"true":return n.not(J);case"false":return n.has(J);default:return n.notEquals(J,Ee)}}case 5:return this.z(),j.create(J,this.u());case 6:return this.z(),U.create(J,this.u());case 7:return this.z(),V.create(J,this.u());case 8:return this.z(),B.create(J,this.u());case 13:return this.z(),n.in(J,this.u());default:return n.has(J)}}case 20:throw this.h.push({message:m,offset:O.offset,lexeme:"",additionalInfo:E}),b.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const O=this.D();switch(O.type){case 17:case 18:return this.z(),O.lexeme;case 11:return this.z(),"true";case 12:return this.z(),"false";case 13:return this.z(),"in";default:return""}}w(O){return O.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(O){return this.C(O)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(O,J){if(this.C(O))return this.z();throw this.B(J,this.D())}B(O,J,he){const Ee=(0,A.localize)(8,null,O,C.$Di.getLexeme(J)),ve=J.offset,be=C.$Di.getLexeme(J);return this.h.push({message:Ee,offset:ve,lexeme:be,additionalInfo:he}),b.c}C(O){return this.D().type===O}D(){return this.f[this.g]}E(){return this.D().type===20}}e.$Fi=b;class n{static false(){return w.INSTANCE}static true(){return v.INSTANCE}static has(O){return I.create(O)}static equals(O,J){return k.create(O,J)}static notEquals(O,J){return f.create(O,J)}static regex(O,J){return z.create(O,J)}static in(O,J){return r.create(O,J)}static notIn(O,J){return l.create(O,J)}static not(O){return F.create(O)}static and(...O){return ye.create(O,null,!0)}static or(...O){return ke.create(O,null,!0)}static greater(O,J){return V.create(O,J)}static greaterEquals(O,J){return B.create(O,J)}static smaller(O,J){return j.create(O,J)}static smallerEquals(O,J){return U.create(O,J)}static{this.c=new b({regexParsingWithErrorRecovery:!1})}static deserialize(O){return O==null?void 0:this.c.parse(O)}}e.$Gi=n;function a(ue){const O=new b({regexParsingWithErrorRecovery:!1});return ue.map(J=>(O.parse(J),O.lexingErrors.length>0?O.lexingErrors.map(he=>({errorMessage:he.additionalInfo?(0,A.localize)(9,null,he.additionalInfo):(0,A.localize)(10,null),offset:he.offset,length:he.lexeme.length})):O.parsingErrors.length>0?O.parsingErrors.map(he=>({errorMessage:he.additionalInfo?`${he.message}. ${he.additionalInfo}`:he.message,offset:he.offset,length:he.lexeme.length})):[]))}e.$Hi=a;function s(ue,O){const J=ue?ue.substituteConstants():void 0,he=O?O.substituteConstants():void 0;return!J&&!he?!0:!J||!he?!1:J.equals(he)}e.$Ii=s;function o(ue,O){return ue.cmp(O)}class w{static{this.INSTANCE=new w}constructor(){this.type=0}cmp(O){return this.type-O.type}equals(O){return O.type===this.type}substituteConstants(){return this}evaluate(O){return!1}serialize(){return"false"}keys(){return[]}map(O){return this}negate(){return v.INSTANCE}}e.$Ji=w;class v{static{this.INSTANCE=new v}constructor(){this.type=1}cmp(O){return this.type-O.type}equals(O){return O.type===this.type}substituteConstants(){return this}evaluate(O){return!0}serialize(){return"true"}keys(){return[]}map(O){return this}negate(){return w.INSTANCE}}e.$Ki=v;class I{static create(O,J=null){const he=S.get(O);return typeof he=="boolean"?he?v.INSTANCE:w.INSTANCE:new I(O,J)}constructor(O,J){this.key=O,this.c=J,this.type=2}cmp(O){return O.type!==this.type?this.type-O.type:X(this.key,O.key)}equals(O){return O.type===this.type?this.key===O.key:!1}substituteConstants(){const O=S.get(this.key);return typeof O=="boolean"?O?v.INSTANCE:w.INSTANCE:this}evaluate(O){return!!O.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(O){return O.mapDefined(this.key)}negate(){return this.c||(this.c=F.create(this.key,this)),this.c}}e.$Li=I;class k{static create(O,J,he=null){if(typeof J=="boolean")return J?I.create(O,he):F.create(O,he);const Ee=S.get(O);return typeof Ee=="boolean"?J===(Ee?"true":"false")?v.INSTANCE:w.INSTANCE:new k(O,J,he)}constructor(O,J,he){this.c=O,this.d=J,this.f=he,this.type=4}cmp(O){return O.type!==this.type?this.type-O.type:le(this.c,this.d,O.c,O.d)}equals(O){return O.type===this.type?this.c===O.c&&this.d===O.d:!1}substituteConstants(){const O=S.get(this.c);if(typeof O=="boolean"){const J=O?"true":"false";return this.d===J?v.INSTANCE:w.INSTANCE}return this}evaluate(O){return O.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(O){return O.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=f.create(this.c,this.d,this)),this.f}}e.$Mi=k;class r{static create(O,J){return new r(O,J)}constructor(O,J){this.d=O,this.f=J,this.type=10,this.c=null}cmp(O){return O.type!==this.type?this.type-O.type:le(this.d,this.f,O.d,O.f)}equals(O){return O.type===this.type?this.d===O.d&&this.f===O.f:!1}substituteConstants(){return this}evaluate(O){const J=O.getValue(this.f),he=O.getValue(this.d);return Array.isArray(J)?J.includes(he):typeof he=="string"&&typeof J=="object"&&J!==null?P.call(J,he):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(O){return O.mapIn(this.d,this.f)}negate(){return this.c||(this.c=l.create(this.d,this.f)),this.c}}e.$Ni=r;class l{static create(O,J){return new l(O,J)}constructor(O,J){this.d=O,this.f=J,this.type=11,this.c=r.create(O,J)}cmp(O){return O.type!==this.type?this.type-O.type:this.c.cmp(O.c)}equals(O){return O.type===this.type?this.c.equals(O.c):!1}substituteConstants(){return this}evaluate(O){return!this.c.evaluate(O)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(O){return O.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$Oi=l;class f{static create(O,J,he=null){if(typeof J=="boolean")return J?F.create(O,he):I.create(O,he);const Ee=S.get(O);return typeof Ee=="boolean"?J===(Ee?"true":"false")?w.INSTANCE:v.INSTANCE:new f(O,J,he)}constructor(O,J,he){this.c=O,this.d=J,this.f=he,this.type=5}cmp(O){return O.type!==this.type?this.type-O.type:le(this.c,this.d,O.c,O.d)}equals(O){return O.type===this.type?this.c===O.c&&this.d===O.d:!1}substituteConstants(){const O=S.get(this.c);if(typeof O=="boolean"){const J=O?"true":"false";return this.d===J?w.INSTANCE:v.INSTANCE}return this}evaluate(O){return O.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(O){return O.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=k.create(this.c,this.d,this)),this.f}}e.$Pi=f;class F{static create(O,J=null){const he=S.get(O);return typeof he=="boolean"?he?w.INSTANCE:v.INSTANCE:new F(O,J)}constructor(O,J){this.c=O,this.d=J,this.type=3}cmp(O){return O.type!==this.type?this.type-O.type:X(this.c,O.c)}equals(O){return O.type===this.type?this.c===O.c:!1}substituteConstants(){const O=S.get(this.c);return typeof O=="boolean"?O?w.INSTANCE:v.INSTANCE:this}evaluate(O){return!O.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(O){return O.mapNot(this.c)}negate(){return this.d||(this.d=I.create(this.c,this)),this.d}}e.$Qi=F;function W(ue,O){if(typeof ue=="string"){const J=parseFloat(ue);isNaN(J)||(ue=J)}return typeof ue=="string"||typeof ue=="number"?O(ue):w.INSTANCE}class V{static create(O,J,he=null){return W(J,Ee=>new V(O,Ee,he))}constructor(O,J,he){this.c=O,this.d=J,this.f=he,this.type=12}cmp(O){return O.type!==this.type?this.type-O.type:le(this.c,this.d,O.c,O.d)}equals(O){return O.type===this.type?this.c===O.c&&this.d===O.d:!1}substituteConstants(){return this}evaluate(O){return typeof this.d=="string"?!1:parseFloat(O.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(O){return O.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=U.create(this.c,this.d,this)),this.f}}e.$Ri=V;class B{static create(O,J,he=null){return W(J,Ee=>new B(O,Ee,he))}constructor(O,J,he){this.c=O,this.d=J,this.f=he,this.type=13}cmp(O){return O.type!==this.type?this.type-O.type:le(this.c,this.d,O.c,O.d)}equals(O){return O.type===this.type?this.c===O.c&&this.d===O.d:!1}substituteConstants(){return this}evaluate(O){return typeof this.d=="string"?!1:parseFloat(O.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(O){return O.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=j.create(this.c,this.d,this)),this.f}}e.$Si=B;class j{static create(O,J,he=null){return W(J,Ee=>new j(O,Ee,he))}constructor(O,J,he){this.c=O,this.d=J,this.f=he,this.type=14}cmp(O){return O.type!==this.type?this.type-O.type:le(this.c,this.d,O.c,O.d)}equals(O){return O.type===this.type?this.c===O.c&&this.d===O.d:!1}substituteConstants(){return this}evaluate(O){return typeof this.d=="string"?!1:parseFloat(O.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(O){return O.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=B.create(this.c,this.d,this)),this.f}}e.$Ti=j;class U{static create(O,J,he=null){return W(J,Ee=>new U(O,Ee,he))}constructor(O,J,he){this.c=O,this.d=J,this.f=he,this.type=15}cmp(O){return O.type!==this.type?this.type-O.type:le(this.c,this.d,O.c,O.d)}equals(O){return O.type===this.type?this.c===O.c&&this.d===O.d:!1}substituteConstants(){return this}evaluate(O){return typeof this.d=="string"?!1:parseFloat(O.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(O){return O.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=V.create(this.c,this.d,this)),this.f}}e.$Ui=U;class z{static create(O,J){return new z(O,J)}constructor(O,J){this.d=O,this.f=J,this.type=7,this.c=null}cmp(O){if(O.type!==this.type)return this.type-O.type;if(this.d<O.d)return-1;if(this.d>O.d)return 1;const J=this.f?this.f.source:"",he=O.f?O.f.source:"";return J<he?-1:J>he?1:0}equals(O){if(O.type===this.type){const J=this.f?this.f.source:"",he=O.f?O.f.source:"";return this.d===O.d&&J===he}return!1}substituteConstants(){return this}evaluate(O){const J=O.getValue(this.d);return this.f?this.f.test(J):!1}serialize(){const O=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${O}`}keys(){return[this.d]}map(O){return O.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=ie.create(this)),this.c}}e.$Vi=z;class ie{static create(O){return new ie(O)}constructor(O){this.c=O,this.type=8}cmp(O){return O.type!==this.type?this.type-O.type:this.c.cmp(O.c)}equals(O){return O.type===this.type?this.c.equals(O.c):!1}substituteConstants(){return this}evaluate(O){return!this.c.evaluate(O)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(O){return new ie(this.c.map(O))}negate(){return this.c}}e.$Wi=ie;function Y(ue){let O=null;for(let J=0,he=ue.length;J<he;J++){const Ee=ue[J].substituteConstants();if(ue[J]!==Ee&&O===null){O=[];for(let ve=0;ve<J;ve++)O[ve]=ue[ve]}O!==null&&(O[J]=Ee)}return O===null?ue:O}class ye{static create(O,J,he){return ye.d(O,J,he)}constructor(O,J){this.expr=O,this.c=J,this.type=6}cmp(O){if(O.type!==this.type)return this.type-O.type;if(this.expr.length<O.expr.length)return-1;if(this.expr.length>O.expr.length)return 1;for(let J=0,he=this.expr.length;J<he;J++){const Ee=o(this.expr[J],O.expr[J]);if(Ee!==0)return Ee}return 0}equals(O){if(O.type===this.type){if(this.expr.length!==O.expr.length)return!1;for(let J=0,he=this.expr.length;J<he;J++)if(!this.expr[J].equals(O.expr[J]))return!1;return!0}return!1}substituteConstants(){const O=Y(this.expr);return O===this.expr?this:ye.create(O,this.c,!1)}evaluate(O){for(let J=0,he=this.expr.length;J<he;J++)if(!this.expr[J].evaluate(O))return!1;return!0}static d(O,J,he){const Ee=[];let ve=!1;for(const be of O)if(be){if(be.type===1){ve=!0;continue}if(be.type===0)return w.INSTANCE;if(be.type===6){Ee.push(...be.expr);continue}Ee.push(be)}if(Ee.length===0&&ve)return v.INSTANCE;if(Ee.length!==0){if(Ee.length===1)return Ee[0];Ee.sort(o);for(let be=1;be<Ee.length;be++)Ee[be-1].equals(Ee[be])&&(Ee.splice(be,1),be--);if(Ee.length===1)return Ee[0];for(;Ee.length>1;){const be=Ee[Ee.length-1];if(be.type!==9)break;Ee.pop();const De=Ee.pop(),oe=Ee.length===0,de=ke.create(be.expr.map(se=>ye.create([se,De],null,he)),null,oe);de&&(Ee.push(de),Ee.sort(o))}if(Ee.length===1)return Ee[0];if(he){for(let be=0;be<Ee.length;be++)for(let De=be+1;De<Ee.length;De++)if(Ee[be].negate().equals(Ee[De]))return w.INSTANCE;if(Ee.length===1)return Ee[0]}return new ye(Ee,J)}}serialize(){return this.expr.map(O=>O.serialize()).join(" && ")}keys(){const O=[];for(const J of this.expr)O.push(...J.keys());return O}map(O){return new ye(this.expr.map(J=>J.map(O)),null)}negate(){if(!this.c){const O=[];for(const J of this.expr)O.push(J.negate());this.c=ke.create(O,this,!0)}return this.c}}e.$Xi=ye;class ke{static create(O,J,he){return ke.d(O,J,he)}constructor(O,J){this.expr=O,this.c=J,this.type=9}cmp(O){if(O.type!==this.type)return this.type-O.type;if(this.expr.length<O.expr.length)return-1;if(this.expr.length>O.expr.length)return 1;for(let J=0,he=this.expr.length;J<he;J++){const Ee=o(this.expr[J],O.expr[J]);if(Ee!==0)return Ee}return 0}equals(O){if(O.type===this.type){if(this.expr.length!==O.expr.length)return!1;for(let J=0,he=this.expr.length;J<he;J++)if(!this.expr[J].equals(O.expr[J]))return!1;return!0}return!1}substituteConstants(){const O=Y(this.expr);return O===this.expr?this:ke.create(O,this.c,!1)}evaluate(O){for(let J=0,he=this.expr.length;J<he;J++)if(this.expr[J].evaluate(O))return!0;return!1}static d(O,J,he){let Ee=[],ve=!1;if(O){for(let be=0,De=O.length;be<De;be++){const oe=O[be];if(oe){if(oe.type===0){ve=!0;continue}if(oe.type===1)return v.INSTANCE;if(oe.type===9){Ee=Ee.concat(oe.expr);continue}Ee.push(oe)}}if(Ee.length===0&&ve)return w.INSTANCE;Ee.sort(o)}if(Ee.length!==0){if(Ee.length===1)return Ee[0];for(let be=1;be<Ee.length;be++)Ee[be-1].equals(Ee[be])&&(Ee.splice(be,1),be--);if(Ee.length===1)return Ee[0];if(he){for(let be=0;be<Ee.length;be++)for(let De=be+1;De<Ee.length;De++)if(Ee[be].negate().equals(Ee[De]))return v.INSTANCE;if(Ee.length===1)return Ee[0]}return new ke(Ee,J)}}serialize(){return this.expr.map(O=>O.serialize()).join(" || ")}keys(){const O=[];for(const J of this.expr)O.push(...J.keys());return O}map(O){return new ke(this.expr.map(J=>J.map(O)),null)}negate(){if(!this.c){const O=[];for(const J of this.expr)O.push(J.negate());for(;O.length>1;){const J=O.shift(),he=O.shift(),Ee=[];for(const ve of x(J))for(const be of x(he))Ee.push(ye.create([ve,be],null,!1));O.unshift(ke.create(Ee,null,!1))}this.c=ke.create(O,this,!0)}return this.c}}e.$Yi=ke;class Re extends I{static{this.d=[]}static all(){return Re.d.values()}constructor(O,J,he){super(O,null),this.f=J,typeof he=="object"?Re.d.push({...he,key:O}):he!==!0&&Re.d.push({key:O,description:he,type:J!=null?typeof J:void 0})}bindTo(O){return O.createKey(this.key,this.f)}getValue(O){return O.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(O){return k.create(this.key,O)}notEqualsTo(O){return f.create(this.key,O)}}e.$Zi=Re,e.$1i=(0,L.$zh)("contextKeyService");function X(ue,O){return ue<O?-1:ue>O?1:0}function le(ue,O,J,he){return ue<J?-1:ue>J?1:O<he?-1:O>he?1:0}function we(ue,O){if(ue.type===0||O.type===1)return!0;if(ue.type===9)return O.type===9?ae(ue.expr,O.expr):!1;if(O.type===9){for(const J of O.expr)if(we(ue,J))return!0;return!1}if(ue.type===6){if(O.type===6)return ae(O.expr,ue.expr);for(const J of ue.expr)if(we(J,O))return!0;return!1}return ue.equals(O)}e.$2i=we;function ae(ue,O){let J=0,he=0;for(;J<ue.length&&he<O.length;){const Ee=ue[J].cmp(O[he]);if(Ee<0)return!1;Ee===0&&J++,he++}return J===ue.length}function x(ue){return ue.type===9?ue.expr:[ue]}}),define(Pe[172],Ae([1,0,4]),function(pe,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hh=e.$Gh=void 0,e.$Gh=(0,y.$zh)("environmentService"),e.$Hh=(0,y.$Ah)(e.$Gh)}),define(Pe[92],Ae([1,0,141,4]),function(pe,e,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7n=e.$6n=e.$5n=e.$4n=e.$3n=e.$2n=e.$1n=e.$Zn=e.$Yn=e.ExtensionSignaturetErrorCode=e.ExtensionManagementErrorCode=e.$Xn=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.$Wn=e.$Vn=e.$Un=e.$Tn=e.$Sn=e.$Rn=e.$Qn=e.$Pn=e.$On=e.$Nn=e.$Mn=e.$Ln=e.$Kn=void 0,e.$Kn="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$Ln=new RegExp(e.$Kn),e.$Mn="__web_extension",e.$Nn="skipWalkthrough",e.$On="extensionsSync",e.$Pn="dependecyOrPackExtensionInstall";function C(c){switch(c){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.$Qn=C;function L(c){switch(c){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.$Rn=L;function A(c,m){switch(c){case 3:return m==="x64"?"win32-x64":m==="ia32"?"win32-ia32":m==="arm64"?"win32-arm64":"unknown";case 2:return m==="x64"?"linux-x64":m==="arm64"?"linux-arm64":m==="arm"?"linux-armhf":"unknown";case"alpine":return m==="x64"?"alpine-x64":m==="arm64"?"alpine-arm64":"unknown";case 1:return m==="x64"?"darwin-x64":m==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.$Sn=A;function h(c,m){return m==="web"&&!c.includes("web")}e.$Tn=h;function S(c,m,E){return h(m,E)?!1:c==="undefined"||c==="universal"?!0:c==="unknown"?!1:c===E?!0:g(E).includes(c)}e.$Un=S;function g(c){switch(c){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.$Vn=g;function P(c){return c&&typeof c=="object"&&typeof c.id=="string"&&(!c.uuid||typeof c.uuid=="string")}e.$Wn=P;var D;(function(c){c[c.NoneOrRelevance=0]="NoneOrRelevance",c[c.LastUpdatedDate=1]="LastUpdatedDate",c[c.Title=2]="Title",c[c.PublisherName=3]="PublisherName",c[c.InstallCount=4]="InstallCount",c[c.PublishedDate=10]="PublishedDate",c[c.AverageRating=6]="AverageRating",c[c.WeightedRating=12]="WeightedRating"})(D||(e.SortBy=D={}));var u;(function(c){c[c.Default=0]="Default",c[c.Ascending=1]="Ascending",c[c.Descending=2]="Descending"})(u||(e.SortOrder=u={}));var p;(function(c){c.Install="install",c.Uninstall="uninstall"})(p||(e.StatisticType=p={}));var $;(function(c){c[c.None=1]="None",c[c.Install=2]="Install",c[c.Update=3]="Update",c[c.Migrate=4]="Migrate"})($||(e.InstallOperation=$={})),e.$Xn=(0,R.$zh)("extensionGalleryService");var d;(function(c){c.Unsupported="Unsupported",c.Deprecated="Deprecated",c.Malicious="Malicious",c.Incompatible="Incompatible",c.IncompatibleTargetPlatform="IncompatibleTargetPlatform",c.ReleaseVersionNotFound="ReleaseVersionNotFound",c.Invalid="Invalid",c.Download="Download",c.Extract="Extract",c.Delete="Delete",c.Rename="Rename",c.CorruptZip="CorruptZip",c.IncompleteZip="IncompleteZip",c.Signature="Signature",c.Internal="Internal"})(d||(e.ExtensionManagementErrorCode=d={}));var t;(function(c){c.UnknownError="UnknownError",c.PackageIsInvalidZip="PackageIsInvalidZip",c.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip"})(t||(e.ExtensionSignaturetErrorCode=t={}));class i extends Error{constructor(m,E){super(m),this.code=E,this.name=E}}e.$Yn=i,e.$Zn=(0,R.$zh)("extensionManagementService"),e.$1n="extensionsIdentifiers/disabled",e.$2n="extensionsIdentifiers/enabled",e.$3n=(0,R.$zh)("IGlobalExtensionEnablementService"),e.$4n=(0,R.$zh)("IExtensionTipsService"),e.$5n=(0,y.localize)(0,null),e.$6n={value:e.$5n,original:"Extensions"},e.$7n={value:(0,y.localize)(1,null),original:"Preferences"}}),define(Pe[38],Ae([1,0,48,19,15,16,2,143,4,22,12]),function(pe,e,y,R,C,L,A,h,S,g,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zk=e.$yk=e.$xk=e.$wk=e.$vk=e.FileKind=e.$uk=e.$tk=e.$sk=e.$rk=e.$qk=e.$pk=e.$ok=e.FileOperationResult=e.$nk=e.$mk=e.$lk=e.$kk=e.$jk=e.FileChangeType=e.$ik=e.FileOperation=e.$hk=e.$gk=e.$fk=e.$ek=e.$dk=e.$ck=e.FileSystemProviderErrorCode=e.$bk=e.$ak=e.$_j=e.$$j=e.$0j=e.$9j=e.$8j=e.$7j=e.$6j=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.$5j=e.$4j=void 0,e.$4j=(0,S.$zh)("fileService");function D(X){return X.create===!0}e.$5j=D;var u;(function(X){X[X.Unknown=0]="Unknown",X[X.File=1]="File",X[X.Directory=2]="Directory",X[X.SymbolicLink=64]="SymbolicLink"})(u||(e.FileType=u={}));var p;(function(X){X[X.Readonly=1]="Readonly",X[X.Locked=2]="Locked"})(p||(e.FilePermission=p={}));var $;(function(X){X[X.None=0]="None",X[X.FileReadWrite=2]="FileReadWrite",X[X.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",X[X.FileReadStream=16]="FileReadStream",X[X.FileFolderCopy=8]="FileFolderCopy",X[X.PathCaseSensitive=1024]="PathCaseSensitive",X[X.Readonly=2048]="Readonly",X[X.Trash=4096]="Trash",X[X.FileWriteUnlock=8192]="FileWriteUnlock",X[X.FileAtomicRead=16384]="FileAtomicRead",X[X.FileAtomicWrite=32768]="FileAtomicWrite",X[X.FileAtomicDelete=65536]="FileAtomicDelete",X[X.FileClone=131072]="FileClone"})($||(e.FileSystemProviderCapabilities=$={}));function d(X){return!!(X.capabilities&2)}e.$6j=d;function t(X){return!!(X.capabilities&8)}e.$7j=t;function i(X){return!!(X.capabilities&131072)}e.$8j=i;function c(X){return!!(X.capabilities&4)}e.$9j=c;function m(X){return!!(X.capabilities&16)}e.$0j=m;function E(X){return d(X)?!!(X.capabilities&16384):!1}e.$$j=E;function b(X){return d(X)?!!(X.capabilities&32768):!1}e.$_j=b;function n(X){return!!(X.capabilities&65536)}e.$ak=n;function a(X){return!!(X.capabilities&2048)}e.$bk=a;var s;(function(X){X.FileExists="EntryExists",X.FileNotFound="EntryNotFound",X.FileNotADirectory="EntryNotADirectory",X.FileIsADirectory="EntryIsADirectory",X.FileExceedsStorageQuota="EntryExceedsStorageQuota",X.FileTooLarge="EntryTooLarge",X.FileWriteLocked="EntryWriteLocked",X.NoPermissions="NoPermissions",X.Unavailable="Unavailable",X.Unknown="Unknown"})(s||(e.FileSystemProviderErrorCode=s={}));class o extends Error{static create(le,we){const ae=new o(le.toString(),we);return I(ae,we),ae}constructor(le,we){super(le),this.code=we}}e.$ck=o;function w(X,le){return o.create(X,le)}e.$dk=w;function v(X){return X||w((0,h.localize)(0,null),s.Unknown)}e.$ek=v;function I(X,le){return X.name=le?`${le} (FileSystemError)`:"FileSystemError",X}e.$fk=I;function k(X){if(!X)return s.Unknown;if(X instanceof o)return X.code;const le=/^(.+) \(FileSystemError\)$/.exec(X.name);if(!le)return s.Unknown;switch(le[1]){case s.FileExists:return s.FileExists;case s.FileIsADirectory:return s.FileIsADirectory;case s.FileNotADirectory:return s.FileNotADirectory;case s.FileNotFound:return s.FileNotFound;case s.FileTooLarge:return s.FileTooLarge;case s.FileWriteLocked:return s.FileWriteLocked;case s.NoPermissions:return s.NoPermissions;case s.Unavailable:return s.Unavailable}return s.Unknown}e.$gk=k;function r(X){if(X instanceof B)return X.fileOperationResult;switch(k(X)){case s.FileNotFound:return 1;case s.FileIsADirectory:return 0;case s.FileNotADirectory:return 9;case s.FileWriteLocked:return 5;case s.NoPermissions:return 6;case s.FileExists:return 4;case s.FileTooLarge:return 7;default:return 10}}e.$hk=r;var l;(function(X){X[X.CREATE=0]="CREATE",X[X.DELETE=1]="DELETE",X[X.MOVE=2]="MOVE",X[X.COPY=3]="COPY",X[X.WRITE=4]="WRITE"})(l||(e.FileOperation=l={}));class f{constructor(le,we,ae){this.resource=le,this.operation=we,this.target=ae}isOperation(le){return this.operation===le}}e.$ik=f;var F;(function(X){X[X.UPDATED=0]="UPDATED",X[X.ADDED=1]="ADDED",X[X.DELETED=2]="DELETED"})(F||(e.FileChangeType=F={}));class W{constructor(le,we){this.a=void 0,this.b=void 0,this.c=void 0,this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];const ae=new Map;for(const x of le){const ue=ae.get(x.type);switch(ue?ue.push([x.resource,x]):ae.set(x.type,[[x.resource,x]]),x.type){case 1:this.rawAdded.push(x.resource);break;case 0:this.rawUpdated.push(x.resource);break;case 2:this.rawDeleted.push(x.resource);break}}for(const[x,ue]of ae)switch(x){case 1:this.a=y.$Fh.forUris(()=>we),this.a.fill(ue);break;case 0:this.b=y.$Fh.forUris(()=>we),this.b.fill(ue);break;case 2:this.c=y.$Fh.forUris(()=>we),this.c.fill(ue);break}}contains(le,...we){return this.d(le,{includeChildren:!1},...we)}affects(le,...we){return this.d(le,{includeChildren:!0},...we)}d(le,we,...ae){if(!le)return!1;const x=ae.length>0;return!!((!x||ae.includes(1))&&(this.a?.get(le)||we.includeChildren&&this.a?.findSuperstr(le))||(!x||ae.includes(0))&&(this.b?.get(le)||we.includeChildren&&this.b?.findSuperstr(le))||(!x||ae.includes(2))&&(this.c?.findSubstr(le)||we.includeChildren&&this.c?.findSuperstr(le)))}gotAdded(){return!!this.a}gotDeleted(){return!!this.c}gotUpdated(){return!!this.b}}e.$jk=W;function V(X,le,we){return!X||!le||X===le||le.length>X.length?!1:(le.charAt(le.length-1)!==R.sep&&(le+=R.sep),we?(0,C.$Pd)(X,le):X.indexOf(le)===0)}e.$kk=V;class B extends Error{constructor(le,we,ae){super(le),this.fileOperationResult=we,this.options=ae}}e.$lk=B;class j extends B{constructor(le,we,ae,x){super(le,we,x),this.fileOperationResult=we,this.size=ae}}e.$mk=j;class U extends B{constructor(le,we,ae){super(le,2,ae),this.stat=we}}e.$nk=U;var z;(function(X){X[X.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",X[X.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",X[X.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",X[X.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",X[X.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",X[X.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",X[X.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",X[X.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",X[X.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",X[X.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",X[X.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(z||(e.FileOperationResult=z={})),e.$ok={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$pk={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$qk="files.associations",e.$rk="files.exclude",e.$sk="files.readonlyInclude",e.$tk="files.readonlyExclude",e.$uk="files.readonlyFromPermissions";var ie;(function(X){X[X.FILE=0]="FILE",X[X.FOLDER=1]="FOLDER",X[X.ROOT_FOLDER=2]="ROOT_FOLDER"})(ie||(e.FileKind=ie={})),e.$vk="";function Y(X){if(!(typeof X.size!="number"||typeof X.mtime!="number"))return X.mtime.toString(29)+X.size.toString(31)}e.$wk=Y;async function ye(X,le){if(!le.hasProvider(A.URI.from({scheme:X.scheme})))return new Promise(we=>{const ae=le.onDidChangeFileSystemProviderRegistrations(x=>{x.scheme===X.scheme&&x.added&&(ae.dispose(),we())})})}e.$xk=ye;class ke{static{this.KB=1024}static{this.MB=ke.KB*ke.KB}static{this.GB=ke.MB*ke.KB}static{this.TB=ke.GB*ke.KB}static formatSize(le){return(0,L.$pe)(le)||(le=0),le<ke.KB?(0,h.localize)(1,null,le.toFixed(0)):le<ke.MB?(0,h.localize)(2,null,(le/ke.KB).toFixed(2)):le<ke.GB?(0,h.localize)(3,null,(le/ke.MB).toFixed(2)):le<ke.TB?(0,h.localize)(4,null,(le/ke.GB).toFixed(2)):(0,h.localize)(5,null,(le/ke.TB).toFixed(2))}}e.$yk=ke;function Re(X){const le=typeof X=="string"||X?.scheme===P.Schemas.vscodeRemote;return typeof X!="string"&&X?.scheme===P.Schemas.file?1024*ke.MB:le?10*ke.MB:g.$o?50*ke.MB:1024*ke.MB}e.$zk=Re}),define(Pe[71],Ae([1,0]),function(pe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xh=void 0;class y{constructor(...C){this.a=new Map;for(const[L,A]of C)this.set(L,A)}set(C,L){const A=this.a.get(C);return this.a.set(C,L),A}has(C){return this.a.has(C)}get(C){return this.a.get(C)}}e.$xh=y}),define(Pe[173],Ae([1,0,13,9,6,69,171,4,71,174]),function(pe,e,y,R,C,L,A,h,S,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4p=e.$3p=void 0;const P=!1;class D extends Error{constructor(t){super("cyclic dependency between services"),this.message=t.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${t.toString()}`}}class u{constructor(t=new S.$xh,i=!1,c,m=P){this.f=t,this.g=i,this.h=c,this.i=m,this.o=new Set,this.f.set(h.$yh,this),this._globalGraph=m?c?._globalGraph??new A.$2p(E=>E):void 0}createChild(t){return new u(t,this.g,this,this.i)}invokeFunction(t,...i){const c=$.traceInvocation(this.i,t);let m=!1;try{return t({get:b=>{if(m)throw(0,R.$6)("service accessor is only valid during the invocation of its target method");const n=this.m(b,c);if(!n)throw new Error(`[invokeFunction] unknown service '${b}'`);return n}},...i)}finally{m=!0,c.stop()}}createInstance(t,...i){let c,m;return t instanceof L.$wh?(c=$.traceCreation(this.i,t.ctor),m=this.j(t.ctor,t.staticArguments.concat(i),c)):(c=$.traceCreation(this.i,t),m=this.j(t,i,c)),c.stop(),m}j(t,i=[],c){const m=h._util.getServiceDependencies(t).sort((n,a)=>n.index-a.index),E=[];for(const n of m){const a=this.m(n.id,c);a||this.u(`[createInstance] ${t.name} depends on UNKNOWN service ${n.id}.`,!1),E.push(a)}const b=m.length>0?m[0].index:i.length;if(i.length!==b){console.trace(`[createInstance] First service dependency of ${t.name} at position ${b+1} conflicts with ${i.length} static arguments`);const n=b-i.length;n>0?i=i.concat(new Array(n)):i=i.slice(0,b)}return Reflect.construct(t,i.concat(E))}k(t,i){if(this.f.get(t)instanceof L.$wh)this.f.set(t,i);else if(this.h)this.h.k(t,i);else throw new Error("illegalState - setting UNKNOWN service instance")}l(t){const i=this.f.get(t);return!i&&this.h?this.h.l(t):i}m(t,i){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(t));const c=this.l(t);return c instanceof L.$wh?this.q(t,c,i.branch(t,!0)):(i.branch(t,!1),c)}q(t,i,c){if(this.o.has(t))throw new Error(`illegal state - RECURSIVELY instantiating service '${t}'`);this.o.add(t);try{return this.r(t,i,c)}finally{this.o.delete(t)}}r(t,i,c){const m=new A.$2p(n=>n.id.toString());let E=0;const b=[{id:t,desc:i,_trace:c}];for(;b.length;){const n=b.pop();if(m.lookupOrInsertNode(n),E++>1e3)throw new D(m);for(const a of h._util.getServiceDependencies(n.desc.ctor)){const s=this.l(a.id);if(s||this.u(`[createInstance] ${t} depends on ${a.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(n.id),String(a.id)),s instanceof L.$wh){const o={id:a.id,desc:s,_trace:n._trace.branch(a.id,!0)};m.insertEdge(n,o),b.push(o)}}}for(;;){const n=m.roots();if(n.length===0){if(!m.isEmpty())throw new D(m);break}for(const{data:a}of n){if(this.l(a.id)instanceof L.$wh){const o=this.s(a.id,a.desc.ctor,a.desc.staticArguments,a.desc.supportsDelayedInstantiation,a._trace);this.k(a.id,o)}m.removeNode(a)}}return this.l(t)}s(t,i,c=[],m,E){if(this.f.get(t)instanceof L.$wh)return this.t(t,i,c,m,E);if(this.h)return this.h.s(t,i,c,m,E);throw new Error(`illegalState - creating UNKNOWN service instance ${i.name}`)}t(t,i,c=[],m,E){if(m){const b=new u(void 0,this.g,this,this.i);b.c=String(t);const n=new Map,a=new y.$Vg(()=>{const s=b.j(i,c,E);for(const[o,w]of n){const v=s[o];if(typeof v=="function")for(const I of w)v.apply(s,I)}return n.clear(),s});return new Proxy(Object.create(null),{get(s,o){if(!a.isInitialized&&typeof o=="string"&&(o.startsWith("onDid")||o.startsWith("onWill"))){let I=n.get(o);return I||(I=new g.$vb,n.set(o,I)),(r,l,f)=>{const F=I.push([r,l,f]);return(0,C.$kb)(F)}}if(o in s)return s[o];const w=a.value;let v=w[o];return typeof v!="function"||(v=v.bind(w),s[o]=v),v},set(s,o,w){return a.value[o]=w,!0},getPrototypeOf(s){return i.prototype}})}else return this.j(i,c,E)}u(t,i){if(i&&console.warn(t),this.g)throw new Error(t)}}e.$3p=u;var p;(function(d){d[d.None=0]="None",d[d.Creation=1]="Creation",d[d.Invocation=2]="Invocation",d[d.Branch=3]="Branch"})(p||(p={}));class ${static{this.all=new Set}static{this.c=new class extends ${constructor(){super(0,null)}stop(){}branch(){return this}}}static traceInvocation(t,i){return t?new $(2,i.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):$.c}static traceCreation(t,i){return t?new $(1,i.name):$.c}static{this.f=0}constructor(t,i){this.type=t,this.name=i,this.g=Date.now(),this.h=[]}branch(t,i){const c=new $(3,t.toString());return this.h.push([t,i,c]),c}stop(){const t=Date.now()-this.g;$.f+=t;let i=!1;function c(E,b){const n=[],a=new Array(E+1).join("	");for(const[s,o,w]of b.h)if(o&&w){i=!0,n.push(`${a}CREATES -> ${s}`);const v=c(E+1,w);v&&n.push(v)}else n.push(`${a}uses -> ${s}`);return n.join(`
`)}const m=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${c(1,this)}`,`DONE, took ${t.toFixed(2)}ms (grand total ${$.f.toFixed(2)}ms)`];(t>2||i)&&$.all.add(m.join(`
`))}}e.$4p=$}),define(Pe[14],Ae([1,0,41,5,93,6,28,22,23,16,2,32,4]),function(pe,e,y,R,C,L,A,h,S,g,P,D,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hj=e.$gj=e.$fj=e.$ej=e.$dj=e.$cj=e.$bj=e.$aj=e.$_i=e.$$i=e.$0i=e.$9i=e.$8i=e.log=e.$6i=e.LogLevel=e.$5i=e.$4i=e.$3i=void 0,e.$3i=(0,u.$zh)("logService"),e.$4i=(0,u.$zh)("loggerService");function p(){return new Date().toISOString()}function $(r){return(0,g.$pe)(r)}e.$5i=$;var d;(function(r){r[r.Off=0]="Off",r[r.Trace=1]="Trace",r[r.Debug=2]="Debug",r[r.Info=3]="Info",r[r.Warning=4]="Warning",r[r.Error=5]="Error"})(d||(e.LogLevel=d={})),e.$6i=d.Info;function t(r,l,f){switch(l){case d.Trace:r.trace(f);break;case d.Debug:r.debug(f);break;case d.Info:r.info(f);break;case d.Warning:r.warn(f);break;case d.Error:r.error(f);break;case d.Off:break;default:throw new Error(`Invalid log level ${l}`)}}e.log=t;function i(r,l=!1){let f="";for(let F=0;F<r.length;F++){let W=r[F];if(W instanceof Error&&(W=(0,y.$ki)(W,l)),typeof W=="object")try{W=JSON.stringify(W)}catch{}f+=(F>0?" ":"")+W}return f}class c extends L.$mb{constructor(){super(...arguments),this.b=e.$6i,this.c=this.B(new R.$hc),this.onDidChangeLogLevel=this.c.event}setLevel(l){this.b!==l&&(this.b=l,this.c.fire(this.b))}getLevel(){return this.b}f(l){return this.b!==d.Off&&this.b<=l}}e.$8i=c;class m extends c{constructor(l){super(),this.h=l}f(l){return this.h||super.f(l)}trace(l,...f){this.f(d.Trace)&&this.g(d.Trace,i([l,...f],!0))}debug(l,...f){this.f(d.Debug)&&this.g(d.Debug,i([l,...f]))}info(l,...f){this.f(d.Info)&&this.g(d.Info,i([l,...f]))}warn(l,...f){this.f(d.Warning)&&this.g(d.Warning,i([l,...f]))}error(l,...f){if(this.f(d.Error))if(l instanceof Error){const F=Array.prototype.slice.call(arguments);F[0]=l.stack,this.g(d.Error,i(F))}else this.g(d.Error,i([l,...f]))}flush(){}}e.$9i=m;class E extends c{constructor(l=e.$6i){super(),this.setLevel(l),this.g=!h.$i}trace(l,...f){this.f(d.Trace)&&(this.g?console.log(`\x1B[90m[main ${p()}]\x1B[0m`,l,...f):console.log(`[main ${p()}]`,l,...f))}debug(l,...f){this.f(d.Debug)&&(this.g?console.log(`\x1B[90m[main ${p()}]\x1B[0m`,l,...f):console.log(`[main ${p()}]`,l,...f))}info(l,...f){this.f(d.Info)&&(this.g?console.log(`\x1B[90m[main ${p()}]\x1B[0m`,l,...f):console.log(`[main ${p()}]`,l,...f))}warn(l,...f){this.f(d.Warning)&&(this.g?console.warn(`\x1B[93m[main ${p()}]\x1B[0m`,l,...f):console.warn(`[main ${p()}]`,l,...f))}error(l,...f){this.f(d.Error)&&(this.g?console.error(`\x1B[91m[main ${p()}]\x1B[0m`,l,...f):console.error(`[main ${p()}]`,l,...f))}dispose(){}flush(){}}e.$0i=E;class b extends c{constructor(l=e.$6i,f=!0){super(),this.g=f,this.setLevel(l)}trace(l,...f){this.f(d.Trace)&&(this.g?console.log("%cTRACE","color: #888",l,...f):console.log(l,...f))}debug(l,...f){this.f(d.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",l,...f):console.log(l,...f))}info(l,...f){this.f(d.Info)&&(this.g?console.log("%c INFO","color: #33f",l,...f):console.log(l,...f))}warn(l,...f){this.f(d.Warning)&&(this.g?console.log("%c WARN","color: #993",l,...f):console.log(l,...f))}error(l,...f){this.f(d.Error)&&(this.g?console.log("%c  ERR","color: #f33",l,...f):console.error(l,...f))}dispose(){}flush(){}}e.$$i=b;class n extends c{constructor(l,f=e.$6i){super(),this.g=l,this.setLevel(f)}trace(l,...f){this.f(d.Trace)&&this.g.log(d.Trace,[this.h(l),...f])}debug(l,...f){this.f(d.Debug)&&this.g.log(d.Debug,[this.h(l),...f])}info(l,...f){this.f(d.Info)&&this.g.log(d.Info,[this.h(l),...f])}warn(l,...f){this.f(d.Warning)&&this.g.log(d.Warning,[this.h(l),...f])}error(l,...f){this.f(d.Error)&&this.g.log(d.Error,[this.h(l),...f])}h(l){return typeof l=="string"?l:(0,y.$ki)(l,this.f(d.Trace))}dispose(){}flush(){}}e.$_i=n;class a extends c{constructor(l){super(),this.g=l,l.length&&this.setLevel(l[0].getLevel())}setLevel(l){for(const f of this.g)f.setLevel(l);super.setLevel(l)}trace(l,...f){for(const F of this.g)F.trace(l,...f)}debug(l,...f){for(const F of this.g)F.debug(l,...f)}info(l,...f){for(const F of this.g)F.info(l,...f)}warn(l,...f){for(const F of this.g)F.warn(l,...f)}error(l,...f){for(const F of this.g)F.error(l,...f)}flush(){for(const l of this.g)l.flush()}dispose(){for(const l of this.g)l.dispose()}}e.$aj=a;class s extends L.$mb{constructor(l,f,F){if(super(),this.h=l,this.j=f,this.b=new A.$xi,this.c=this.B(new R.$hc),this.onDidChangeLoggers=this.c.event,this.f=this.B(new R.$hc),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new R.$hc),this.onDidChangeVisibility=this.g.event,F)for(const W of F)this.b.set(W.resource,{logger:void 0,info:W})}k(l){return(0,g.$le)(l)?[...this.b.values()].find(f=>f.info.id===l):this.b.get(l)}getLogger(l){return this.k(l)?.logger}createLogger(l,f){const F=this.l(l),W=(0,g.$le)(l)?l:f?.id??(0,C.$ni)(F.toString()).toString(16);let V=this.b.get(F)?.logger;const B=f?.logLevel==="always"?d.Trace:f?.logLevel;V||(V=this.m(F,B??this.getLogLevel(F)??this.h,{...f,id:W}));const j={logger:V,info:{resource:F,id:W,logLevel:B,name:f?.name,hidden:f?.hidden,extensionId:f?.extensionId,when:f?.when}};return this.registerLogger(j.info),this.b.set(F,j),V}l(l){return(0,g.$le)(l)?(0,S.$gg)(this.j,`${l}.log`):l}setLogLevel(l,f){if(P.URI.isUri(l)){const F=l,W=f,V=this.b.get(F);V&&W!==V.info.logLevel&&(V.info.logLevel=W===this.h?void 0:W,V.logger?.setLevel(W),this.b.set(V.info.resource,V),this.f.fire([F,W]))}else{this.h=l;for(const[F,W]of this.b.entries())this.b.get(F)?.info.logLevel===void 0&&W.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(l,f){const F=this.k(l);F&&f!==!F.info.hidden&&(F.info.hidden=!f,this.b.set(F.info.resource,F),this.g.fire([F.info.resource,f]))}getLogLevel(l){let f;return l&&(f=this.b.get(l)?.info.logLevel),f??this.h}registerLogger(l){const f=this.b.get(l.resource);f?f.info.hidden!==l.hidden&&this.setVisibility(l.resource,!l.hidden):(this.b.set(l.resource,{info:l,logger:void 0}),this.c.fire({added:[l],removed:[]}))}deregisterLogger(l){const f=this.b.get(l);f&&(f.logger&&f.logger.dispose(),this.b.delete(l),this.c.fire({added:[],removed:[f.info]}))}*getRegisteredLoggers(){for(const l of this.b.values())yield l.info}getRegisteredLogger(l){return this.b.get(l)?.info}dispose(){this.b.forEach(l=>l.logger?.dispose()),this.b.clear(),super.dispose()}}e.$bj=s;class o{constructor(){this.onDidChangeLogLevel=new R.$hc().event}setLevel(l){}getLevel(){return d.Info}trace(l,...f){}debug(l,...f){}info(l,...f){}warn(l,...f){}error(l,...f){}critical(l,...f){}dispose(){}flush(){}}e.$cj=o;class w extends o{}e.$dj=w;function v(r){if(r.verbose)return d.Trace;if(typeof r.logLevel=="string"){const l=k(r.logLevel.toLowerCase());if(l!==void 0)return l}return e.$6i}e.$ej=v;function I(r){switch(r){case d.Trace:return"trace";case d.Debug:return"debug";case d.Info:return"info";case d.Warning:return"warn";case d.Error:return"error";case d.Off:return"off"}}e.$fj=I;function k(r){switch(r){case"trace":return d.Trace;case"debug":return d.Debug;case"info":return d.Info;case"warn":return d.Warning;case"error":return d.Error;case"critical":return d.Error;case"off":return d.Off}}e.$gj=k,e.$hj=new D.$Zi("logLevel",I(d.Info))}),define(Pe[175],Ae([1,0,6,14]),function(pe,e,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fN=void 0;class C extends y.$mb{constructor(A,h=[]){super(),this.a=new R.$aj([A,...h]),this.B(A.onDidChangeLogLevel(S=>this.setLevel(S)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(A){this.a.setLevel(A)}getLevel(){return this.a.getLevel()}trace(A,...h){this.a.trace(A,...h)}debug(A,...h){this.a.debug(A,...h)}info(A,...h){this.a.info(A,...h)}warn(A,...h){this.a.warn(A,...h)}error(A,...h){this.a.error(A,...h)}flush(){this.a.flush()}}e.$fN=C}),define(Pe[94],Ae([1,0,29,144,4]),function(pe,e,y,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zs=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var L;(function(S){S[S.Unnecessary=1]="Unnecessary",S[S.Deprecated=2]="Deprecated"})(L||(e.MarkerTag=L={}));var A;(function(S){S[S.Hint=1]="Hint",S[S.Info=2]="Info",S[S.Warning=4]="Warning",S[S.Error=8]="Error"})(A||(e.MarkerSeverity=A={})),function(S){function g($,d){return d-$}S.compare=g;const P=Object.create(null);P[S.Error]=(0,R.localize)(0,null),P[S.Warning]=(0,R.localize)(1,null),P[S.Info]=(0,R.localize)(2,null);function D($){return P[$]||""}S.toString=D;function u($){switch($){case y.default.Error:return S.Error;case y.default.Warning:return S.Warning;case y.default.Info:return S.Info;case y.default.Ignore:return S.Hint}}S.fromSeverity=u;function p($){switch($){case S.Error:return y.default.Error;case S.Warning:return y.default.Warning;case S.Info:return y.default.Info;case S.Hint:return y.default.Ignore}}S.toSeverity=p}(A||(e.MarkerSeverity=A={}));var h;(function(S){const g="";function P(u){return D(u,!0)}S.makeKey=P;function D(u,p){const $=[g];return u.source?$.push(u.source.replace("\xA6","\\\xA6")):$.push(g),u.code?typeof u.code=="string"?$.push(u.code.replace("\xA6","\\\xA6")):$.push(u.code.value.replace("\xA6","\\\xA6")):$.push(g),u.severity!==void 0&&u.severity!==null?$.push(A.toString(u.severity)):$.push(g),u.message&&p?$.push(u.message.replace("\xA6","\\\xA6")):$.push(g),u.startLineNumber!==void 0&&u.startLineNumber!==null?$.push(u.startLineNumber.toString()):$.push(g),u.startColumn!==void 0&&u.startColumn!==null?$.push(u.startColumn.toString()):$.push(g),u.endLineNumber!==void 0&&u.endLineNumber!==null?$.push(u.endLineNumber.toString()):$.push(g),u.endColumn!==void 0&&u.endColumn!==null?$.push(u.endColumn.toString()):$.push(g),$.push(g),$.join("\xA6")}S.makeKeyOptionalMessage=D})(h||(e.IMarkerData=h={})),e.$Zs=(0,C.$zh)("markerService")}),define(Pe[176],Ae([1,0,5,29,4]),function(pe,e,y,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xu=e.$Wu=e.NotificationsFilter=e.NeverShowAgainScope=e.NotificationPriority=e.$Vu=e.Severity=void 0,e.Severity=R.default,e.$Vu=(0,C.$zh)("notificationService");var L;(function(P){P[P.DEFAULT=0]="DEFAULT",P[P.SILENT=1]="SILENT",P[P.URGENT=2]="URGENT"})(L||(e.NotificationPriority=L={}));var A;(function(P){P[P.WORKSPACE=0]="WORKSPACE",P[P.PROFILE=1]="PROFILE",P[P.APPLICATION=2]="APPLICATION"})(A||(e.NeverShowAgainScope=A={}));var h;(function(P){P[P.OFF=0]="OFF",P[P.SILENT=1]="SILENT",P[P.ERROR=2]="ERROR"})(h||(e.NotificationsFilter=h={}));class S{constructor(){this.progress=new g,this.onDidClose=y.Event.None,this.onDidChangeVisibility=y.Event.None}updateSeverity(D){}updateMessage(D){}updateActions(D){}close(){}}e.$Wu=S;class g{infinite(){}done(){}total(D){}worked(D){}}e.$Xu=g}),define(Pe[95],Ae([1,0,15,2,4]),function(pe,e,y,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$FT=e.$ET=e.$DT=e.$CT=e.$BT=void 0,e.$BT=(0,C.$zh)("openerService");function L(g,P){return R.URI.isUri(g)?(0,y.$Od)(g.scheme,P):(0,y.$Pd)(g,P+":")}e.$CT=L;function A(g,...P){return P.some(D=>L(g,D))}e.$DT=A;function h(g,P){return g.with({fragment:`${P.startLineNumber},${P.startColumn}${P.endLineNumber?`-${P.endLineNumber}${P.endColumn?`,${P.endColumn}`:""}`:""}`})}e.$ET=h;function S(g){let P;const D=/^L?(\d+)(?:,(\d+))?(-L?(\d+)(?:,(\d+))?)?/.exec(g.fragment);return D&&(P={startLineNumber:parseInt(D[1]),startColumn:D[2]?parseInt(D[2]):1,endLineNumber:D[4]?parseInt(D[4]):void 0,endColumn:D[4]?D[5]?parseInt(D[5]):1:void 0},g=g.with({fragment:""})),{selection:P,uri:g}}e.$FT=S}),define(Pe[177],Ae([1,0,4]),function(pe,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jj=e.$ij=void 0,e.$ij=(0,y.$zh)("productService"),e.$jj="vscode://schemas/vscode-product"});var Ke=this&&this.__decorate||function(pe,e,y,R){var C=arguments.length,L=C<3?e:R===null?R=Object.getOwnPropertyDescriptor(e,y):R,A;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")L=Reflect.decorate(pe,e,y,R);else for(var h=pe.length-1;h>=0;h--)(A=pe[h])&&(L=(C<3?A(L):C>3?A(e,y,L):A(e,y))||L);return C>3&&L&&Object.defineProperty(e,y,L),L},Ve=this&&this.__param||function(pe,e){return function(y,R){e(y,R,pe)}};define(Pe[72],Ae([1,0,13,21,6,4]),function(pe,e,y,R,C,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4u=e.$3u=e.$2u=e.$1u=e.$Zu=e.ProgressLocation=e.$Yu=void 0,e.$Yu=(0,L.$zh)("progressService");var A;(function(P){P[P.Explorer=1]="Explorer",P[P.Scm=3]="Scm",P[P.Extensions=5]="Extensions",P[P.Window=10]="Window",P[P.Notification=15]="Notification",P[P.Dialog=20]="Dialog"})(A||(e.ProgressLocation=A={})),e.$Zu=Object.freeze({total(){},worked(){},done(){}});class h{static{this.None=Object.freeze({report(){}})}get value(){return this.a}constructor(D,u){this.c=D,this.report=u?.async?this.e.bind(this):this.d.bind(this)}d(D){this.a=D,this.c(this.a)}e(D){Promise.resolve(this.b).finally(()=>{this.a=D;const u=this.c(this.a);this.b=Promise.resolve(u).finally(()=>this.b=void 0)})}}e.$1u=h;let S=class extends C.$mb{constructor(D,u){super(),this.a=new y.$Zg,u.withProgress(D,p=>(this.b=p,this.c&&p.report(this.c),this.a.p)),this.B((0,C.$kb)(()=>this.a.complete()))}report(D){this.b?this.b.report(D):this.c=D}};e.$2u=S,e.$2u=S=Ke([Ve(1,e.$Yu)],S);class g extends C.$mb{constructor(D){super(),this.g=D,this.a=0,this.b=this.B(new C.$lb)}start(D){this.stop();const u=++this.a,p=new R.$rc;return this.f=setTimeout(()=>{u===this.a&&(this.c=this.g.show(!0))},D),this.b.add((0,C.$kb)(()=>clearTimeout(this.f))),this.b.add((0,C.$kb)(()=>p.cancel())),this.b.add((0,C.$kb)(()=>this.c?this.c.done():void 0)),{id:u,token:p.token,stop:()=>this.h(u),isCurrent:()=>this.a===u}}stop(){this.h(this.a)}h(D){this.a===D&&this.b.clear()}}e.$3u=g,e.$4u=(0,L.$zh)("editorProgressService")}),define(Pe[30],Ae([1,0,50,16]),function(pe,e,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6m=void 0;class C{constructor(){this.a=new Map}add(A,h){y.ok(R.$le(A)),y.ok(R.$ne(h)),y.ok(!this.a.has(A),"There is already an extension with this id"),this.a.set(A,h)}knows(A){return this.a.has(A)}as(A){return this.a.get(A)||null}}e.$6m=new C}),define(Pe[73],Ae([1,0,5,30]),function(pe,e,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7m=void 0,e.$7m={JSONContribution:"base.contributions.json"};function C(h){return h.length>0&&h.charAt(h.length-1)==="#"?h.substring(0,h.length-1):h}class L{constructor(){this.b=new y.$hc,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(S,g){this.a[C(S)]=g,this.b.fire(S)}notifySchemaChanged(S){this.b.fire(S)}getSchemaContributions(){return{schemas:this.a}}}const A=new L;R.$6m.add(e.$7m.JSONContribution,A)}),define(Pe[96],Ae([1,0,18,5,16,138,43,73,30]),function(pe,e,y,R,C,L,A,h,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nn=e.$mn=e.$ln=e.$kn=e.$jn=e.$in=e.$hn=e.$gn=e.$fn=e.$en=e.$dn=e.$cn=e.$bn=e.$an=e.$_m=e.ConfigurationScope=e.$$m=e.EditPresentationTypes=void 0;var g;(function(b){b.Multiline="multilineText",b.Singleline="singlelineText"})(g||(e.EditPresentationTypes=g={})),e.$$m={Configuration:"base.contributions.configuration"};var P;(function(b){b[b.APPLICATION=1]="APPLICATION",b[b.MACHINE=2]="MACHINE",b[b.WINDOW=3]="WINDOW",b[b.RESOURCE=4]="RESOURCE",b[b.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",b[b.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(P||(e.ConfigurationScope=P={})),e.$_m={properties:{},patternProperties:{}},e.$an={properties:{},patternProperties:{}},e.$bn={properties:{},patternProperties:{}},e.$cn={properties:{},patternProperties:{}},e.$dn={properties:{},patternProperties:{}},e.$en={properties:{},patternProperties:{}},e.$fn="vscode://schemas/settings/resourceLanguage",e.$gn="vscode://schemas/settings/configurationDefaults";const D=S.$6m.as(h.$7m.JSONContribution);class u{constructor(){this.h=new Set,this.i=new R.$hc,this.onDidSchemaChange=this.i.event,this.j=new R.$hc,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:L.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},D.registerSchema(e.$fn,this.g),this.v()}registerConfiguration(n,a=!0){this.registerConfigurations([n],a)}registerConfigurations(n,a=!0){const s=new Set;this.n(n,a,s),D.registerSchema(e.$fn,this.g),this.i.fire(),this.j.fire({properties:s})}deregisterConfigurations(n){const a=new Set;this.o(n,a),D.registerSchema(e.$fn,this.g),this.i.fire(),this.j.fire({properties:a})}updateConfigurations({add:n,remove:a}){const s=new Set;this.o(a,s),this.n(n,!1,s),D.registerSchema(e.$fn,this.g),this.i.fire(),this.j.fire({properties:s})}registerDefaultConfigurations(n){const a=new Set;this.k(n,a),this.i.fire(),this.j.fire({properties:a,defaultsOverrides:!0})}k(n,a){const s=[];for(const{overrides:o,source:w}of n)for(const v in o)if(a.add(v),e.$in.test(v)){const I=this.a.get(v),k=I?.valuesSources??new Map;if(w)for(const F of Object.keys(o[v]))k.set(F,w);const r={...I?.value||{},...o[v]};this.a.set(v,{source:w,value:r,valuesSources:k});const l=(0,A.$di)(v),f={type:"object",default:r,description:L.localize(1,null,l),$ref:e.$fn,defaultDefaultValue:r,source:C.$le(w)?void 0:w,defaultValueSource:w};s.push(...d(v)),this.d[v]=f,this.b.properties[v]=f}else{this.a.set(v,{value:o[v],source:w});const I=this.d[v];I&&(this.w(v,I),this.r(v,I))}this.m(s)}deregisterDefaultConfigurations(n){const a=new Set;this.l(n,a),this.i.fire(),this.j.fire({properties:a,defaultsOverrides:!0})}l(n,a){for(const{overrides:s,source:o}of n)for(const w in s){const v=this.a.get(w),I=C.$le(o)?o:o?.id,k=C.$le(v?.source)?v?.source:v?.source?.id;if(I===k)if(a.add(w),this.a.delete(w),e.$in.test(w))delete this.d[w],delete this.b.properties[w];else{const r=this.d[w];r&&(this.w(w,r),this.r(w,r))}}this.u()}deltaConfiguration(n){let a=!1;const s=new Set;n.removedDefaults&&(this.l(n.removedDefaults,s),a=!0),n.addedDefaults&&(this.k(n.addedDefaults,s),a=!0),n.removedConfigurations&&this.o(n.removedConfigurations,s),n.addedConfigurations&&this.n(n.addedConfigurations,!1,s),this.i.fire(),this.j.fire({properties:s,defaultsOverrides:a})}notifyConfigurationSchemaUpdated(...n){this.i.fire()}registerOverrideIdentifiers(n){this.m(n),this.i.fire()}m(n){for(const a of n)this.h.add(a);this.u()}n(n,a,s){n.forEach(o=>{this.p(o,a,o.extensionInfo,o.restrictedProperties,void 0,s),this.c.push(o),this.q(o)})}o(n,a){const s=o=>{if(o.properties)for(const w in o.properties){a.add(w);const v=this.d[w];v?.policy?.name&&this.e.delete(v.policy.name),delete this.d[w],this.s(w,o.properties[w])}o.allOf?.forEach(w=>s(w))};for(const o of n){s(o);const w=this.c.indexOf(o);w!==-1&&this.c.splice(w,1)}}p(n,a=!0,s,o,w=3,v){w=C.$ue(n.scope)?w:n.scope;const I=n.properties;if(I)for(const r in I){const l=I[r];if(a&&m(r,l)){delete I[r];continue}if(l.source=s,l.defaultDefaultValue=I[r].default,this.w(r,l),e.$in.test(r)?l.scope=void 0:(l.scope=C.$ue(l.scope)?w:l.scope,l.restricted=C.$ue(l.restricted)?!!o?.includes(r):l.restricted),I[r].hasOwnProperty("included")&&!I[r].included){this.f[r]=I[r],delete I[r];continue}else this.d[r]=I[r],I[r].policy?.name&&this.e.set(I[r].policy.name,r);!I[r].deprecationMessage&&I[r].markdownDeprecationMessage&&(I[r].deprecationMessage=I[r].markdownDeprecationMessage),v.add(r)}const k=n.allOf;if(k)for(const r of k)this.p(r,a,s,o,w,v)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(n){const a=s=>{const o=s.properties;if(o)for(const v in o)this.r(v,o[v]);s.allOf?.forEach(a)};a(n)}r(n,a){switch(e.$_m.properties[n]=a,a.scope){case 1:e.$an.properties[n]=a;break;case 2:e.$bn.properties[n]=a;break;case 6:e.$cn.properties[n]=a;break;case 3:e.$dn.properties[n]=a;break;case 4:e.$en.properties[n]=a;break;case 5:e.$en.properties[n]=a,this.g.properties[n]=a;break}}s(n,a){switch(delete e.$_m.properties[n],a.scope){case 1:delete e.$an.properties[n];break;case 2:delete e.$bn.properties[n];break;case 6:delete e.$cn.properties[n];break;case 3:delete e.$dn.properties[n];break;case 4:case 5:delete e.$en.properties[n],delete this.g.properties[n];break}}u(){for(const n of this.h.values()){const a=`[${n}]`,s={type:"object",description:L.localize(2,null),errorMessage:L.localize(3,null),$ref:e.$fn};this.w(a,s),e.$_m.properties[a]=s,e.$an.properties[a]=s,e.$bn.properties[a]=s,e.$cn.properties[a]=s,e.$dn.properties[a]=s,e.$en.properties[a]=s}}v(){const n={type:"object",description:L.localize(4,null),errorMessage:L.localize(5,null),$ref:e.$fn};e.$_m.patternProperties[e.$hn]=n,e.$an.patternProperties[e.$hn]=n,e.$bn.patternProperties[e.$hn]=n,e.$cn.patternProperties[e.$hn]=n,e.$dn.patternProperties[e.$hn]=n,e.$en.patternProperties[e.$hn]=n,this.i.fire()}w(n,a){const s=this.a.get(n);let o=s?.value,w=s?.source;C.$se(o)&&(o=a.defaultDefaultValue,w=void 0),C.$se(o)&&(o=i(a.type)),a.default=o,a.defaultValueSource=w}}const p="\\[([^\\]]+)\\]",$=new RegExp(p,"g");e.$hn=`^(${p})+$`,e.$in=new RegExp(e.$hn);function d(b){const n=[];if(e.$in.test(b)){let a=$.exec(b);for(;a?.length;){const s=a[1].trim();s&&n.push(s),a=$.exec(b)}}return(0,y.$Ff)(n)}e.$jn=d;function t(b){return b.reduce((n,a)=>`${n}[${a}]`,"")}e.$kn=t;function i(b){switch(Array.isArray(b)?b[0]:b){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.$ln=i;const c=new u;S.$6m.add(e.$$m.Configuration,c);function m(b,n){return b.trim()?e.$in.test(b)?L.localize(7,null,b):c.getConfigurationProperties()[b]!==void 0?L.localize(8,null,b):n.policy?.name&&c.getPolicyConfigurations().get(n.policy?.name)!==void 0?L.localize(9,null,b,n.policy?.name,c.getPolicyConfigurations().get(n.policy?.name)):null:L.localize(6,null)}e.$mn=m;function E(){const b=[],n=c.getConfigurationProperties();for(const a of Object.keys(n))b.push([a,n[a].scope]);return b.push(["launch",4]),b.push(["task",4]),b}e.$nn=E}),define(Pe[178],Ae([1,0,18,5,116,6,28,24,16,2,43,96,30]),function(pe,e,y,R,C,L,A,h,S,g,P,D,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tn=e.$sn=e.$rn=e.$qn=e.$pn=e.$on=void 0;function p(a){return Object.isFrozen(a)?a:h.$Um(a)}class ${constructor(s={},o=[],w=[],v){this.b=s,this.c=o,this.d=w,this.raw=v,this.a=new Map}get rawConfiguration(){if(!this.f)if(this.raw?.length){const s=this.raw.map(o=>{if(o instanceof $)return o;const w=new d("");return w.parseRaw(o),w.configurationModel});this.f=s.reduce((o,w)=>w===o?w:o.merge(w),s[0])}else this.f=this;return this.f}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(s){return s?(0,P.$bi)(this.contents,s):this.contents}inspect(s,o){const w=this.rawConfiguration.getValue(s),v=o?this.rawConfiguration.getOverrideValue(s,o):void 0,I=o?this.rawConfiguration.override(o).getValue(s):w;return{value:w,override:v,merged:I}}getOverrideValue(s,o){const w=this.i(o);return w?s?(0,P.$bi)(w,s):w:void 0}getKeysForOverrideIdentifier(s){const o=[];for(const w of this.overrides)w.identifiers.includes(s)&&o.push(...w.keys);return y.$Ff(o)}getAllOverrideIdentifiers(){const s=[];for(const o of this.overrides)s.push(...o.identifiers);return y.$Ff(s)}override(s){let o=this.a.get(s);return o||(o=this.g(s),this.a.set(s,o)),o}merge(...s){const o=h.$Tm(this.contents),w=h.$Tm(this.overrides),v=[...this.keys],I=this.raw?.length?[...this.raw]:[this];for(const k of s)if(I.push(...k.raw?.length?k.raw:[k]),!k.isEmpty()){this.h(o,k.contents);for(const r of k.overrides){const[l]=w.filter(f=>y.$of(f.identifiers,r.identifiers));l?(this.h(l.contents,r.contents),l.keys.push(...r.keys),l.keys=y.$Ff(l.keys)):w.push(h.$Tm(r))}for(const r of k.keys)v.indexOf(r)===-1&&v.push(r)}return new $(o,v,w,I.every(k=>k instanceof $)?void 0:I)}g(s){const o=this.i(s);if(!o||typeof o!="object"||!Object.keys(o).length)return this;const w={};for(const v of y.$Ff([...Object.keys(this.contents),...Object.keys(o)])){let I=this.contents[v];const k=o[v];k&&(typeof I=="object"&&typeof k=="object"?(I=h.$Tm(I),this.h(I,k)):I=k),w[v]=I}return new $(w,this.keys,this.overrides)}h(s,o){for(const w of Object.keys(o)){if(w in s&&S.$ne(s[w])&&S.$ne(o[w])){this.h(s[w],o[w]);continue}s[w]=h.$Tm(o[w])}}i(s){let o=null,w=null;const v=I=>{I&&(w?this.h(w,I):w=h.$Tm(I))};for(const I of this.overrides)I.identifiers.length===1&&I.identifiers[0]===s?o=I.contents:I.identifiers.includes(s)&&v(I.contents);return v(o),w}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(s,o){this.j(s,o,!0)}setValue(s,o){this.j(s,o,!1)}removeValue(s){const o=this.keys.indexOf(s);o!==-1&&(this.keys.splice(o,1),(0,P.$ai)(this.contents,s),D.$in.test(s)&&this.overrides.splice(this.overrides.findIndex(w=>y.$of(w.identifiers,(0,D.$jn)(s))),1))}j(s,o,w){(0,P.$_h)(this.contents,s,o,v=>console.error(v)),w=w||this.keys.indexOf(s)===-1,w&&this.keys.push(s),D.$in.test(s)&&this.overrides.push({identifiers:(0,D.$jn)(s),keys:Object.keys(this.contents[s]),contents:(0,P.$$h)(this.contents[s],v=>console.error(v))})}}e.$on=$;class d{constructor(s){this.f=s,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new $}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(s,o){if(!S.$ue(s)){const w=this.g(s);this.parseRaw(w,o)}}reparse(s){this.a&&this.parseRaw(this.a,s)}parseRaw(s,o){this.a=s;const{contents:w,keys:v,overrides:I,restricted:k,hasExcludedProperties:r}=this.h(s,o);this.b=new $(w,v,I,r?[s]:void 0),this.c=k||[]}g(s){let o={},w=null,v=[];const I=[],k=[];function r(f){Array.isArray(v)?v.push(f):w!==null&&(v[w]=f)}const l={onObjectBegin:()=>{const f={};r(f),I.push(v),v=f,w=null},onObjectProperty:f=>{w=f},onObjectEnd:()=>{v=I.pop()},onArrayBegin:()=>{const f=[];r(f),I.push(v),v=f,w=null},onArrayEnd:()=>{v=I.pop()},onLiteralValue:r,onError:(f,F,W)=>{k.push({error:f,offset:F,length:W})}};if(s)try{C.$Qm(s,l),o=v[0]||{}}catch(f){console.error(`Error while parsing settings file ${this.f}: ${f}`),this.d=[f]}return o}h(s,o){const w=u.$6m.as(D.$$m.Configuration).getConfigurationProperties(),v=this.i(s,w,!0,o);s=v.raw;const I=(0,P.$$h)(s,l=>console.error(`Conflict in settings file ${this.f}: ${l}`)),k=Object.keys(s),r=this.j(s,l=>console.error(`Conflict in settings file ${this.f}: ${l}`));return{contents:I,keys:k,overrides:r,restricted:v.restricted,hasExcludedProperties:v.hasExcludedProperties}}i(s,o,w,v){let I=!1;if(!v?.scopes&&!v?.skipRestricted&&!v?.exclude?.length)return{raw:s,restricted:[],hasExcludedProperties:I};const k={},r=[];for(const l in s)if(D.$in.test(l)&&w){const f=this.i(s[l],o,!1,v);k[l]=f.raw,I=I||f.hasExcludedProperties,r.push(...f.restricted)}else{const f=o[l],F=f?typeof f.scope<"u"?f.scope:3:void 0;f?.restricted&&r.push(l),!v.exclude?.includes(l)&&(v.include?.includes(l)||(F===void 0||v.scopes===void 0||v.scopes.includes(F))&&!(v.skipRestricted&&f?.restricted))?k[l]=s[l]:I=!0}return{raw:k,restricted:r,hasExcludedProperties:I}}j(s,o){const w=[];for(const v of Object.keys(s))if(D.$in.test(v)){const I={};for(const k in s[v])I[k]=s[v][k];w.push({identifiers:(0,D.$jn)(v),keys:Object.keys(I),contents:(0,P.$$h)(I,o)})}return w}}e.$pn=d;class t extends L.$mb{constructor(s,o,w,v){super(),this.c=s,this.f=o,this.g=v,this.b=this.B(new R.$hc),this.onDidChange=this.b.event,this.a=new d(this.c.toString()),this.B(this.g.watch(w.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(R.Event.any(R.Event.filter(this.g.onDidFilesChange,I=>I.contains(this.c)),R.Event.filter(this.g.onDidRunOperation,I=>(I.isOperation(0)||I.isOperation(3)||I.isOperation(1)||I.isOperation(4))&&w.isEqual(I.resource,s)))(()=>this.b.fire()))}async loadConfiguration(){try{const s=await this.g.readFile(this.c);return this.a.parse(s.value.toString()||"{}",this.f),this.a.configurationModel}catch{return new $}}reparse(s){return s&&(this.f=s),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$qn=t;class i{constructor(s,o,w,v,I,k,r,l,f,F,W,V,B){this.a=s,this.b=o,this.c=w,this.overrideIdentifiers=v,this.d=I,this.f=k,this.g=r,this.h=l,this.i=f,this.j=F,this.k=W,this.l=V,this.m=B}get value(){return p(this.c)}n(s,o,w){const v=s.inspect(o,w);return{get value(){return p(v.value)},get override(){return p(v.override)},get merged(){return p(v.merged)}}}get q(){return this.p||(this.p=this.n(this.d,this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.q.value!==void 0||this.q.override!==void 0?{value:this.q.value,override:this.q.override}:void 0}get s(){return this.r===void 0&&(this.r=this.f?this.n(this.f,this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.n(this.g,this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.u?.value!==void 0||this.u?.override!==void 0?{value:this.u.value,override:this.u.override}:void 0}get w(){return this.v||(this.v=this.n(this.h,this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.w.value!==void 0||this.w.override!==void 0?{value:this.w.value,override:this.w.override}:void 0}get y(){return this.x||(this.x=this.n(this.i,this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.y.value!==void 0||this.y.override!==void 0?{value:this.y.value,override:this.y.override}:void 0}get A(){return this.z||(this.z=this.n(this.j,this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.A.value!==void 0||this.A.override!==void 0?{value:this.A.value,override:this.A.override}:void 0}get D(){return this.B===void 0&&(this.B=this.k?this.n(this.k,this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.D?.value!==void 0||this.D?.override!==void 0?{value:this.D.value,override:this.D.override}:void 0}get F(){return this.E===void 0&&(this.E=this.l?this.n(this.l,this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.F?.value!==void 0||this.F?.override!==void 0?{value:this.F.value,override:this.F.override}:void 0}get H(){return this.G===void 0&&(this.G=this.n(this.m,this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.H.value!==void 0||this.H.override!==void 0?{value:this.H.value,override:this.H.override}:void 0}}class c{constructor(s,o,w,v,I=new $,k=new $,r=new A.$xi,l=new $,f=new A.$xi){this.c=s,this.d=o,this.f=w,this.g=v,this.h=I,this.i=k,this.j=r,this.l=l,this.m=f,this.a=null,this.b=new A.$xi,this.n=null}getValue(s,o,w){return this.q(s,o,w).getValue(s)}updateValue(s,o,w={}){let v;w.resource?(v=this.m.get(w.resource),v||(v=new $,this.m.set(w.resource,v))):v=this.l,o===void 0?v.removeValue(s):v.setValue(s,o),w.resource||(this.a=null)}inspect(s,o,w){const v=this.q(s,o,w),I=this.u(o.resource,w),k=o.resource?this.m.get(o.resource)||this.l:this.l,r=new Set;for(const l of v.overrides)for(const f of l.identifiers)v.getOverrideValue(s,f)!==void 0&&r.add(f);return new i(s,o,v.getValue(s),r.size?[...r]:void 0,this.c,this.d.isEmpty()?void 0:this.d,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,w?this.i:void 0,I||void 0,k)}keys(s){const o=this.u(void 0,s);return{default:this.c.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.i.keys.slice(0),workspaceFolder:o?o.keys.slice(0):[]}}updateDefaultConfiguration(s){this.c=s,this.a=null,this.b.clear()}updatePolicyConfiguration(s){this.d=s}updateApplicationConfiguration(s){this.f=s,this.a=null,this.b.clear()}updateLocalUserConfiguration(s){this.g=s,this.n=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(s){this.h=s,this.n=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(s){this.i=s,this.a=null,this.b.clear()}updateFolderConfiguration(s,o){this.j.set(s,o),this.b.delete(s)}deleteFolderConfiguration(s){this.p.delete(s),this.b.delete(s)}compareAndUpdateDefaultConfiguration(s,o){const w=[];if(!o){const{added:v,updated:I,removed:k}=b(this.c,s);o=[...v,...I,...k]}for(const v of o)for(const I of(0,D.$jn)(v)){const k=this.c.getKeysForOverrideIdentifier(I),r=s.getKeysForOverrideIdentifier(I),l=[...r.filter(f=>k.indexOf(f)===-1),...k.filter(f=>r.indexOf(f)===-1),...k.filter(f=>!h.$Xm(this.c.override(I).getValue(f),s.override(I).getValue(f)))];w.push([I,l])}return this.updateDefaultConfiguration(s),{keys:o,overrides:w}}compareAndUpdatePolicyConfiguration(s){const{added:o,updated:w,removed:v}=b(this.d,s),I=[...o,...w,...v];return I.length&&this.updatePolicyConfiguration(s),{keys:I,overrides:[]}}compareAndUpdateApplicationConfiguration(s){const{added:o,updated:w,removed:v,overrides:I}=b(this.applicationConfiguration,s),k=[...o,...w,...v];return k.length&&this.updateApplicationConfiguration(s),{keys:k,overrides:I}}compareAndUpdateLocalUserConfiguration(s){const{added:o,updated:w,removed:v,overrides:I}=b(this.localUserConfiguration,s),k=[...o,...w,...v];return k.length&&this.updateLocalUserConfiguration(s),{keys:k,overrides:I}}compareAndUpdateRemoteUserConfiguration(s){const{added:o,updated:w,removed:v,overrides:I}=b(this.remoteUserConfiguration,s),k=[...o,...w,...v];return k.length&&this.updateRemoteUserConfiguration(s),{keys:k,overrides:I}}compareAndUpdateWorkspaceConfiguration(s){const{added:o,updated:w,removed:v,overrides:I}=b(this.workspaceConfiguration,s),k=[...o,...w,...v];return k.length&&this.updateWorkspaceConfiguration(s),{keys:k,overrides:I}}compareAndUpdateFolderConfiguration(s,o){const w=this.p.get(s),{added:v,updated:I,removed:k,overrides:r}=b(w,o),l=[...v,...I,...k];return(l.length||!w)&&this.updateFolderConfiguration(s,o),{keys:l,overrides:r}}compareAndDeleteFolderConfiguration(s){const o=this.p.get(s);if(!o)throw new Error("Unknown folder");this.deleteFolderConfiguration(s);const{added:w,updated:v,removed:I,overrides:k}=b(o,void 0);return{keys:[...w,...v,...I],overrides:k}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.n||(this.n=this.h.isEmpty()?this.g:this.g.merge(this.h)),this.n}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.i}get p(){return this.j}q(s,o,w){let v=this.r(o,w);return o.overrideIdentifier&&(v=v.override(o.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(s)!==void 0&&(v=v.merge(this.d)),v}r({resource:s},o){let w=this.s();if(o&&s){const v=o.getFolder(s);v&&(w=this.t(v.uri)||w);const I=this.m.get(s);I&&(w=w.merge(I))}return w}s(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.i,this.l)),this.a}t(s){let o=this.b.get(s);if(!o){const w=this.s(),v=this.j.get(s);v?(o=w.merge(v),this.b.set(s,o)):o=w}return o}u(s,o){if(o&&s){const w=o.getFolder(s);if(w)return this.j.get(w.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.i.contents,overrides:this.i.overrides,keys:this.i.keys},folders:[...this.j.keys()].reduce((s,o)=>{const{contents:w,overrides:v,keys:I}=this.j.get(o);return s.push([o,{contents:w,overrides:v,keys:I}]),s},[])}}allKeys(){const s=new Set;return this.c.keys.forEach(o=>s.add(o)),this.userConfiguration.keys.forEach(o=>s.add(o)),this.i.keys.forEach(o=>s.add(o)),this.j.forEach(o=>o.keys.forEach(w=>s.add(w))),[...s.values()]}v(){const s=new Set;return this.c.getAllOverrideIdentifiers().forEach(o=>s.add(o)),this.userConfiguration.getAllOverrideIdentifiers().forEach(o=>s.add(o)),this.i.getAllOverrideIdentifiers().forEach(o=>s.add(o)),this.j.forEach(o=>o.getAllOverrideIdentifiers().forEach(w=>s.add(w))),[...s.values()]}w(s){const o=new Set;return this.c.getKeysForOverrideIdentifier(s).forEach(w=>o.add(w)),this.userConfiguration.getKeysForOverrideIdentifier(s).forEach(w=>o.add(w)),this.i.getKeysForOverrideIdentifier(s).forEach(w=>o.add(w)),this.j.forEach(w=>w.getKeysForOverrideIdentifier(s).forEach(v=>o.add(v))),[...o.values()]}static parse(s){const o=this.x(s.defaults),w=this.x(s.policy),v=this.x(s.application),I=this.x(s.user),k=this.x(s.workspace),r=s.folders.reduce((l,f)=>(l.set(g.URI.revive(f[0]),this.x(f[1])),l),new A.$xi);return new c(o,w,v,I,new $,k,r,new $,new A.$xi)}static x(s){return new $(s.contents,s.keys,s.overrides)}}e.$rn=c;function m(...a){if(a.length===0)return{keys:[],overrides:[]};if(a.length===1)return a[0];const s=new Set,o=new Map;for(const v of a)v.keys.forEach(I=>s.add(I)),v.overrides.forEach(([I,k])=>{const r=(0,A.$ui)(o,I,new Set);k.forEach(l=>r.add(l))});const w=[];return o.forEach((v,I)=>w.push([I,[...v.values()]])),{keys:[...s.values()],overrides:w}}e.$sn=m;class E{constructor(s,o,w,v){this.change=s,this.f=o,this.g=w,this.h=v,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=".".charCodeAt(0),this.affectedKeys=new Set,this.i=void 0;for(const I of s.keys)this.affectedKeys.add(I);for(const[,I]of s.overrides)for(const k of I)this.affectedKeys.add(k);this.d=this.a;for(const I of this.affectedKeys)this.d+=I+this.a}get previousConfiguration(){return!this.i&&this.f&&(this.i=c.parse(this.f.data)),this.i}affectsConfiguration(s,o){const w=this.a+s,v=this.d.indexOf(w);if(v<0)return!1;const I=v+w.length;if(I>=this.d.length)return!1;const k=this.d.charCodeAt(I);if(k!==this.b&&k!==this.c)return!1;if(o){const r=this.previousConfiguration?this.previousConfiguration.getValue(s,o,this.f?.workspace):void 0,l=this.g.getValue(s,o,this.h);return!h.$Xm(r,l)}return!0}}e.$tn=E;function b(a,s){const{added:o,removed:w,updated:v}=n(s?.rawConfiguration,a?.rawConfiguration),I=[],k=a?.getAllOverrideIdentifiers()||[],r=s?.getAllOverrideIdentifiers()||[];if(s){const l=r.filter(f=>!k.includes(f));for(const f of l)I.push([f,s.getKeysForOverrideIdentifier(f)])}if(a){const l=k.filter(f=>!r.includes(f));for(const f of l)I.push([f,a.getKeysForOverrideIdentifier(f)])}if(s&&a){for(const l of k)if(r.includes(l)){const f=n({contents:a.getOverrideValue(void 0,l)||{},keys:a.getKeysForOverrideIdentifier(l)},{contents:s.getOverrideValue(void 0,l)||{},keys:s.getKeysForOverrideIdentifier(l)});I.push([l,[...f.added,...f.removed,...f.updated]])}}return{added:o,removed:w,updated:v,overrides:I}}function n(a,s){const o=a?s?a.keys.filter(I=>s.keys.indexOf(I)===-1):[...a.keys]:[],w=s?a?s.keys.filter(I=>a.keys.indexOf(I)===-1):[...s.keys]:[],v=[];if(a&&s){for(const I of s.keys)if(a.keys.indexOf(I)!==-1){const k=(0,P.$bi)(s.contents,I),r=(0,P.$bi)(a.contents,I);h.$Xm(k,r)||v.push(I)}}return{added:o,removed:w,updated:v}}}),define(Pe[97],Ae([1,0,9,4]),function(pe,e,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lk=e.$Kk=e.RemoteAuthorityResolverErrorCode=e.$Jk=e.$Ik=e.RemoteConnectionType=e.$Hk=void 0,e.$Hk=(0,R.$zh)("remoteAuthorityResolverService");var C;(function(P){P[P.WebSocket=0]="WebSocket",P[P.Managed=1]="Managed"})(C||(e.RemoteConnectionType=C={}));class L{constructor(D){this.id=D,this.type=1}toString(){return`Managed(${this.id})`}}e.$Ik=L;class A{constructor(D,u){this.host=D,this.port=u,this.type=0}toString(){return`WebSocket(${this.host}:${this.port})`}}e.$Jk=A;var h;(function(P){P.Unknown="Unknown",P.NotAvailable="NotAvailable",P.TemporarilyNotAvailable="TemporarilyNotAvailable",P.NoResolverFound="NoResolverFound",P.InvalidAuthority="InvalidAuthority"})(h||(e.RemoteAuthorityResolverErrorCode=h={}));class S extends y.$_{static isNotAvailable(D){return D instanceof S&&D._code===h.NotAvailable}static isTemporarilyNotAvailable(D){return D instanceof S&&D._code===h.TemporarilyNotAvailable}static isNoResolverFound(D){return D instanceof S&&D._code===h.NoResolverFound}static isInvalidAuthority(D){return D instanceof S&&D._code===h.InvalidAuthority}static isHandled(D){return D instanceof S&&D.isHandled}constructor(D,u=h.Unknown,p){super(D),this._message=D,this._code=u,this._detail=p,this.isHandled=u===h.NotAvailable&&p===!0,Object.setPrototypeOf(this,S.prototype)}}e.$Kk=S;function g(P){const D=P.indexOf("+");return D===-1?P:P.substring(0,D)}e.$Lk=g}),define(Pe[51],Ae([1,0,12]),function(pe,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qk=e.$Pk=e.$Ok=e.$Nk=e.$Mk=void 0;function R(g){return g.scheme===y.Schemas.vscodeRemote?g.authority:void 0}e.$Mk=R;function C(g){if(!g)return;const P=g.indexOf("+");return P<0?g:g.substr(0,P)}e.$Nk=C;function L(g){return`/${g.quality??"oss"}-${g.commit??"dev"}`}e.$Ok=L;function A(g){const{host:P,port:D}=S(g);if(typeof D>"u")throw new Error("Remote authority doesn't contain a port!");return{host:P,port:D}}e.$Pk=A;function h(g,P){let{host:D,port:u}=S(g);return typeof u>"u"&&(u=P),{host:D,port:u}}e.$Qk=h;function S(g){const P=g.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(P)return{host:P[1],port:parseInt(P[2],10)};const D=g.match(/^(\[[0-9a-z:]+\])$/);if(D)return{host:D[1],port:void 0};const u=g.match(/(.*):(\d+)$/);return u?{host:u[1],port:parseInt(u[2],10)}:{host:g,port:void 0}}}),define(Pe[20],Ae([1,0,15,4,51]),function(pe,e,y,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1l=e.$Zl=e.$Yl=e.$Xl=e.$Wl=e.$Vl=e.$Ul=e.$Tl=e.TargetPlatform=e.ExtensionType=e.$Sl=e.$Rl=e.$Ql=e.$Pl=e.$Ol=e.$Nl=void 0,e.$Nl="extensions.user.cache",e.$Ol="extensions.builtin.cache",e.$Pl="undefined_publisher",e.$Ql=["ui","workspace","web"];function L(d){if(typeof d=="object"&&d!==null&&d.supported!==!0)return d.description}e.$Rl=L,e.$Sl=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var A;(function(d){d[d.System=0]="System",d[d.User=1]="User"})(A||(e.ExtensionType=A={}));var h;(function(d){d.WIN32_X64="win32-x64",d.WIN32_IA32="win32-ia32",d.WIN32_ARM64="win32-arm64",d.LINUX_X64="linux-x64",d.LINUX_ARM64="linux-arm64",d.LINUX_ARMHF="linux-armhf",d.ALPINE_X64="alpine-x64",d.ALPINE_ARM64="alpine-arm64",d.DARWIN_X64="darwin-x64",d.DARWIN_ARM64="darwin-arm64",d.WEB="web",d.UNIVERSAL="universal",d.UNKNOWN="unknown",d.UNDEFINED="undefined"})(h||(e.TargetPlatform=h={}));class S{constructor(t){this.value=t,this._lower=t.toLowerCase()}static equals(t,i){if(typeof t>"u"||t===null)return typeof i>"u"||i===null;if(typeof i>"u"||i===null)return!1;if(typeof t=="string"||typeof i=="string"){const c=typeof t=="string"?t:t.value,m=typeof i=="string"?i:i.value;return y.$Od(c,m)}return t._lower===i._lower}static toKey(t){return typeof t=="string"?t.toLowerCase():t._lower}}e.$Tl=S;class g{get size(){return this.c.size}constructor(t){if(this.c=new Set,t)for(const i of t)this.add(i)}add(t){this.c.add(S.toKey(t))}delete(t){return this.c.delete(S.toKey(t))}has(t){return this.c.has(S.toKey(t))}}e.$Ul=g;class P{constructor(){this.c=new Map}clear(){this.c.clear()}delete(t){this.c.delete(S.toKey(t))}get(t){return this.c.get(S.toKey(t))}has(t){return this.c.has(S.toKey(t))}set(t,i){this.c.set(S.toKey(t),i)}values(){return this.c.values()}forEach(t){this.c.forEach(t)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$Vl=P;function D(d){return u(d)}e.$Wl=D;function u(d){return d.contributes&&d.contributes.localizations?d.contributes.localizations.length>0:!1}e.$Xl=u;function p(d){return d.contributes&&d.contributes.authentication?d.contributes.authentication.length>0:!1}e.$Yl=p;function $(d,t){if(t){const i=`onResolveRemoteAuthority:${(0,C.$Nk)(t)}`;return!!d.activationEvents?.includes(i)}return!1}e.$Zl=$,e.$1l=(0,R.$zh)("IBuiltinExtensionsScannerService")}),define(Pe[98],Ae([1,0,9,20]),function(pe,e,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xF=e.$wF=void 0;class C{constructor(){this.a=new Map,this.b=new WeakMap}register(A,h){this.a.set(A,h)}readActivationEvents(A){return this.b.has(A)||this.b.set(A,this.c(A)),this.b.get(A)}createActivationEventsMap(A){const h=Object.create(null);for(const S of A){const g=this.readActivationEvents(S);g.length>0&&(h[R.$Tl.toKey(S.identifier)]=g)}return h}c(A){if(typeof A.main>"u"&&typeof A.browser>"u")return[];const h=Array.isArray(A.activationEvents)?A.activationEvents.slice(0):[];if(!A.contributes)return h;for(const S in A.contributes){const g=this.a.get(S);if(!g)continue;const P=A.contributes[S],D=Array.isArray(P)?P:[P];try{g(D,h)}catch(u){(0,y.$Y)(u)}}return h}}e.$wF=C,e.$xF=new C}),define(Pe[179],Ae([1,0,22,74,36]),function(pe,e,y,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9n=e.$8n=void 0;function L(S){if(y.$t===2&&/^penguin(\.|$)/i.test(S))return"chromebook"}function A(S,g,P,D,u,p,$,d){const t=Object.create(null);t["common.machineId"]=p,t.sessionID=(0,C.$6e)()+Date.now(),t.commitHash=D,t.version=u,t["common.platformVersion"]=(S||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),t["common.platform"]=(0,y.$h)(y.$t),t["common.nodePlatform"]=R.$5c,t["common.nodeArch"]=P,t["common.product"]=d||"desktop",$&&(t["common.msftInternal"]=$);let i=0;const c=Date.now();Object.defineProperties(t,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-c,enumerable:!0},"common.sequence":{get:()=>i++,enumerable:!0}}),y.$l&&(t["common.snap"]="true");const m=L(g);return m&&(t["common.platformDetail"]=m),t}e.$8n=A;function h(S){const g=R.env.USERDNSDOMAIN;if(!g)return!1;const P=g.toLowerCase();return S.some(D=>P===D)}e.$9n=h}),define(Pe[180],Ae([1,0,4]),function(pe,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$dl=e.$cl=e.$bl=e.$al=e.$_k=e.$$k=e.$0k=e.$9k=e.$8k=e.$7k=void 0,e.$7k=(0,y.$zh)("telemetryService"),e.$8k=(0,y.$zh)("customEndpointTelemetryService"),e.$9k="telemetry.currentSessionDate",e.$0k="telemetry.firstSessionDate",e.$$k="telemetry.lastSessionDate",e.$_k="telemetry.machineId",e.$al="telemetry",e.$bl="telemetry.telemetryLevel",e.$cl="telemetry.enableCrashReporter",e.$dl="telemetry.enableTelemetry";var R;(function(L){L[L.NONE=0]="NONE",L[L.CRASH=1]="CRASH",L[L.ERROR=2]="ERROR",L[L.USAGE=3]="USAGE"})(R||(e.TelemetryLevel=R={}));var C;(function(L){L.OFF="off",L.CRASH="crash",L.ERROR="error",L.ON="all"})(C||(e.TelemetryConfiguration=C={}))}),define(Pe[52],Ae([1,0,24,16,5,43,51,179,180]),function(pe,e,y,R,C,L,A,h,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mo=e.$lo=e.$ko=e.$jo=e.$io=e.$ho=e.$go=e.$fo=e.$eo=e.$do=e.$co=e.$bo=e.$ao=e.$_n=e.$$n=e.$0n=void 0;class g{constructor(w){this.value=w,this.isTrustedTelemetryValue=!0}}e.$0n=g;class P{constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$$n=P,e.$_n=new P;class D{async publicLog(w,v,I){}async publicLogError(w,v,I){}}e.$ao=D,e.$bo="telemetry",e.$co="extensionTelemetryLog",e.$do={log:()=>null,flush:()=>Promise.resolve(null)};function u(o,w){return C.Event.debounce(w.onDidChangeConfiguration,(I,k)=>{const r=I?new Set([...I.affectedKeys,...k.affectedKeys]):k.affectedKeys;return{...k,affectedKeys:r}},1e3,!0)(I=>{I.source!==7&&o.publicLog2("updateConfiguration",{configurationSource:(0,L.$9h)(I.source),configurationKeys:Array.from(I.affectedKeys)})})}e.$eo=u;function p(o,w){return!w.isBuilt&&!w.disableTelemetry?!0:!(w.disableTelemetry||!o.enableTelemetry||w.extensionTestsLocationURI)}e.$fo=p;function $(o,w){return!(w.isBuilt||w.disableTelemetry||o.enableTelemetry&&o.aiConfig?.ariaKey)}e.$go=$;function d(o){const w=o.getValue(S.$bl),v=o.getValue(S.$cl);if(o.getValue(S.$dl)===!1||v===!1)return 0;switch(w??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.$ho=d;function t(o){const w={},v={},I={};m(o,I);for(let k in I){k=k.length>150?k.substr(k.length-149):k;const r=I[k];typeof r=="number"?v[k]=r:typeof r=="boolean"?v[k]=r?1:0:typeof r=="string"?(r.length>8192&&console.warn(`Telemetry property: ${k} has been trimmed to 8192, the original length is ${r.length}`),w[k]=r.substring(0,8191)):typeof r<"u"&&r!==null&&(w[k]=r)}return{properties:w,measurements:v}}e.$io=t;const i=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function c(o){if(!o)return"none";const w=(0,A.$Nk)(o);return i.has(w)?w:"other"}e.$jo=c;function m(o,w,v=0,I){if(o)for(const k of Object.getOwnPropertyNames(o)){const r=o[k],l=I?I+k:k;Array.isArray(r)?w[l]=(0,y.$Ym)(r):r instanceof Date?w[l]=r.toISOString():(0,R.$ne)(r)?v<2?m(r,w,v+1,l+"."):w[l]=(0,y.$Ym)(r):w[l]=r}}function E(o,w){const v=o.msftInternalDomains||[],I=w.getValue("telemetry.internalTesting");return(0,h.$9n)(v)||I}e.$ko=E;function b(o){return[o.appRoot,o.extensionsPath,o.userHome.fsPath,o.tmpDir.fsPath,o.userDataPath]}e.$lo=b;function n(o,w){if(!o||!o.includes("/")&&!o.includes("\\"))return o;let v=o;const I=[];for(const f of w)for(;;){const F=f.exec(o);if(!F)break;I.push([F.index,f.lastIndex])}const k=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,r=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let l=0;for(v="";;){const f=r.exec(o);if(!f)break;const F=I.some(([W,V])=>f.index<V&&W<r.lastIndex);!k.test(f[0])&&!F&&(v+=o.substring(l,f.index)+"<REDACTED: user-file-path>",l=r.lastIndex)}return l<o.length&&(v+=o.substr(l)),v}function a(o){if(!o)return o;const w=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const v of w)if(v.regex.test(o))return`<REDACTED: ${v.label}>`;return o}function s(o,w){return(0,y.$Vm)(o,v=>{if(v instanceof g||Object.hasOwnProperty.call(v,"isTrustedTelemetryValue"))return v.value;if(typeof v=="string"){let I=v.replaceAll("%20"," ");I=n(I,w);for(const k of w)I=I.replace(k,"");return I=a(I),I}})}e.$mo=s}),define(Pe[181],Ae([1,0,15,92,20,22,2,9,74,52]),function(pe,e,y,R,C,L,A,h,S,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yo=e.$xo=e.$wo=e.$vo=e.$uo=e.$to=e.$so=e.$ro=e.$qo=e.$po=e.$oo=e.$no=void 0;function P(s,o){return s.uuid&&o.uuid?s.uuid===o.uuid:s.id===o.id?!0:(0,y.$Jd)(s.id,o.id)===0}e.$no=P;const D=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class u{static create(o){const w=o.manifest?o.manifest.version:o.version,v=o.manifest?o.targetPlatform:o.properties.targetPlatform;return new u(o.identifier,w,v)}static parse(o){const w=D.exec(o);return w&&w[1]&&w[2]?new u({id:w[1]},w[2],w[4]||void 0):null}constructor(o,w,v="undefined"){this.version=w,this.targetPlatform=v,this.id=o.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(o){return o instanceof u?P(this,o)&&this.version===o.version&&this.targetPlatform===o.targetPlatform:!1}}e.$oo=u;const p=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function $(s){const o=p.exec(s);return o&&o[1]?[t(o[1]),o[2]]:[t(s),void 0]}e.$po=$;function d(s,o){return`${s}.${o}`}e.$qo=d;function t(s){return s.toLowerCase()}e.$ro=t;function i(s,o){return t(d(s??C.$Pl,o))}e.$so=i;function c(s,o){const w=[],v=I=>{for(const k of w)if(k.some(r=>P(o(r),o(I))))return k;return null};for(const I of s){const k=v(I);k?k.push(I):w.push([I])}return w}e.$to=c;function m(s){return{id:s.identifier.id,name:s.manifest.name,galleryId:null,publisherId:s.publisherId,publisherName:s.manifest.publisher,publisherDisplayName:s.publisherDisplayName,dependencies:s.manifest.extensionDependencies&&s.manifest.extensionDependencies.length>0}}e.$uo=m;function E(s){return{id:new g.$0n(s.identifier.id),name:new g.$0n(s.name),galleryId:s.identifier.uuid,publisherId:s.publisherId,publisherName:s.publisher,publisherDisplayName:s.publisherDisplayName,isPreReleaseVersion:s.properties.isPreReleaseVersion,dependencies:!!(s.properties.dependencies&&s.properties.dependencies.length>0),isSigned:s.isSigned,...s.telemetryData}}e.$vo=E,e.$wo=new C.$Tl("pprice.better-merge");function b(s,o){const w=[],v=o.manifest.extensionDependencies?.slice(0)??[];for(;v.length;){const I=v.shift();if(I&&w.every(k=>!P(k.identifier,{id:I}))){const k=s.filter(r=>P(r.identifier,{id:I}));k.length===1&&(w.push(k[0]),v.push(...k[0].manifest.extensionDependencies?.slice(0)??[]))}}return w}e.$xo=b;async function n(s,o){if(!L.$k)return!1;let w;try{w=(await s.readFile(A.URI.file("/etc/os-release"))).value.toString()}catch{try{w=(await s.readFile(A.URI.file("/usr/lib/os-release"))).value.toString()}catch(I){o.debug("Error while getting the os-release file.",(0,h.$8)(I))}}return!!w&&(w.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function a(s,o){const w=await n(s,o),v=(0,R.$Sn)(w?"alpine":L.$t,S.$6c);return o.debug("ComputeTargetPlatform:",v),v}e.$yo=a}),define(Pe[182],Ae([1,0]),function(pe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cr=e.$br=e.$ar=e.$_q=e.$$q=e.$0q=void 0;function y(S){return[...S.entries()]}e.$0q=y;function R(S){return S?[...S.entries()]:[]}e.$$q=R;function C(S){return new Map(S)}e.$_q=C;function L(S){return new Map(S??[])}e.$ar=L;function A(S){return Array.from(S.entries()).map(g=>[g[0],y(g[1].map),R(g[1].descriptionMap)])}e.$br=A;function h(S){return new Map(S.map(g=>[g[0],{map:C(g[1]),descriptionMap:L(g[2])}]))}e.$cr=h}),define(Pe[183],Ae([1,0]),function(pe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tkb=void 0;class y{constructor(C){this.b=C,this.a=new Map}dispose(){for(const C of this.a.values())C.dispose()}startBuffering(C,L,A=5){const h=L(S=>{const g=typeof S=="string"?S:S.data;let P=this.a.get(C);if(P){P.data.push(g);return}const D=setTimeout(()=>this.flushBuffer(C),A);P={data:[g],timeoutId:D,dispose:()=>{clearTimeout(D),this.flushBuffer(C),h.dispose()}},this.a.set(C,P)});return h}stopBuffering(C){this.a.get(C)?.dispose()}flushBuffer(C){const L=this.a.get(C);L&&(this.a.delete(C),this.b(C,L.data.join("")))}}e.$tkb=y}),define(Pe[184],Ae([1,0,13,89,40,5,16,2,145,73,30]),function(pe,e,y,R,C,L,A,h,S,g,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$av=e.$_u=e.$$u=e.$0u=e.$9u=e.$8u=e.$7u=e.$6u=e.IconFontDefinition=e.IconContribution=e.$5u=void 0,e.$5u={IconContribution:"base.contributions.icons"};var D;(function(E){function b(n,a){let s=n.defaults;for(;C.ThemeIcon.isThemeIcon(s);){const o=$.getIcon(s.id);if(!o)return;s=o.defaults}return s}E.getDefinition=b})(D||(e.IconContribution=D={}));var u;(function(E){function b(a){return{weight:a.weight,style:a.style,src:a.src.map(s=>({format:s.format,location:s.location.toString()}))}}E.toJSONObject=b;function n(a){const s=o=>(0,A.$le)(o)?o:void 0;if(a&&Array.isArray(a.src)&&a.src.every(o=>(0,A.$le)(o.format)&&(0,A.$le)(o.location)))return{weight:s(a.weight),style:s(a.style),src:a.src.map(o=>({format:o.format,location:h.URI.parse(o.location)}))}}E.fromJSONObject=n})(u||(e.IconFontDefinition=u={}));class p{constructor(){this.a=new L.$hc,this.onDidChange=this.a.event,this.d={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,S.localize)(0,null)},fontCharacter:{type:"string",description:(0,S.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.e={type:"string",pattern:`^${C.ThemeIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.b={},this.f={}}registerIcon(b,n,a,s){const o=this.b[b];if(o){if(a&&!o.description){o.description=a,this.d.properties[b].markdownDescription=`${a} $(${b})`;const I=this.e.enum.indexOf(b);I!==-1&&(this.e.enumDescriptions[I]=a),this.a.fire()}return o}const w={id:b,description:a,defaults:n,deprecationMessage:s};this.b[b]=w;const v={$ref:"#/definitions/icons"};return s&&(v.deprecationMessage=s),a&&(v.markdownDescription=`${a}: $(${b})`),this.d.properties[b]=v,this.e.enum.push(b),this.e.enumDescriptions.push(a||""),this.a.fire(),{id:b}}deregisterIcon(b){delete this.b[b],delete this.d.properties[b];const n=this.e.enum.indexOf(b);n!==-1&&(this.e.enum.splice(n,1),this.e.enumDescriptions.splice(n,1)),this.a.fire()}getIcons(){return Object.keys(this.b).map(b=>this.b[b])}getIcon(b){return this.b[b]}getIconSchema(){return this.d}getIconReferenceSchema(){return this.e}registerIconFont(b,n){const a=this.f[b];return a||(this.f[b]=n,this.a.fire(),n)}deregisterIconFont(b){delete this.f[b]}getIconFont(b){return this.f[b]}toString(){const b=(o,w)=>o.id.localeCompare(w.id),n=o=>{for(;C.ThemeIcon.isThemeIcon(o.defaults);)o=this.b[o.defaults.id];return`codicon codicon-${o?o.id:""}`},a=[];a.push("| preview     | identifier                        | default codicon ID                | description"),a.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const s=Object.keys(this.b).map(o=>this.b[o]);for(const o of s.filter(w=>!!w.description).sort(b))a.push(`|<i class="${n(o)}"></i>|${o.id}|${C.ThemeIcon.isThemeIcon(o.defaults)?o.defaults.id:o.id}|${o.description||""}|`);a.push("| preview     | identifier                        "),a.push("| ----------- | --------------------------------- |");for(const o of s.filter(w=>!C.ThemeIcon.isThemeIcon(w.defaults)).sort(b))a.push(`|<i class="${n(o)}"></i>|${o.id}|`);return a.join(`
`)}}const $=new p;P.$6m.add(e.$5u.IconContribution,$);function d(E,b,n,a){return $.registerIcon(E,b,n,a)}e.$6u=d;function t(){return $}e.$7u=t;function i(){const E=(0,R.$Lj)();for(const b in E){const n="\\"+E[b].toString(16);$.registerIcon(b,{fontCharacter:n})}}i(),e.$8u="vscode://schemas/icons";const c=P.$6m.as(g.$7m.JSONContribution);c.registerSchema(e.$8u,$.getIconSchema());const m=new y.$Qg(()=>c.notifySchemaChanged(e.$8u),200);$.onDidChange(()=>{m.isScheduled()||m.schedule()}),e.$9u=d("widget-close",R.$Nj.close,(0,S.localize)(2,null)),e.$0u=d("goto-previous-location",R.$Nj.arrowUp,(0,S.localize)(3,null)),e.$$u=d("goto-next-location",R.$Nj.arrowDown,(0,S.localize)(4,null)),e.$_u=C.ThemeIcon.modify(R.$Nj.sync,"spin"),e.$av=C.ThemeIcon.modify(R.$Nj.loading,"spin")}),define(Pe[185],Ae([1,0,5,43,4,14]),function(pe,e,y,R,C,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3z=e.$2z=e.$1z=e.$Zz=e.$Yz=e.$Xz=e.$Wz=e.$Vz=e.ProvidedOnAutoForward=e.$Uz=e.TunnelPrivacyId=e.TunnelProtocol=e.$Tz=e.$Sz=void 0,e.$Sz=(0,C.$zh)("tunnelService"),e.$Tz=(0,C.$zh)("sharedTunnelsService");var A;(function(t){t.Http="http",t.Https="https"})(A||(e.TunnelProtocol=A={}));var h;(function(t){t.ConstantPrivate="constantPrivate",t.Private="private",t.Public="public"})(h||(e.TunnelPrivacyId=h={}));function S(t){return!!t.forwardPort}e.$Uz=S;var g;(function(t){t[t.Notify=1]="Notify",t[t.OpenBrowser=2]="OpenBrowser",t[t.OpenPreview=3]="OpenPreview",t[t.Silent=4]="Silent",t[t.Ignore=5]="Ignore",t[t.OpenBrowserOnce=6]="OpenBrowserOnce"})(g||(e.ProvidedOnAutoForward=g={}));function P(t){if(t.scheme!=="http"&&t.scheme!=="https")return;const i=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(t.authority);if(i)return{address:i[1],port:+i[2]}}e.$Vz=P,e.$Wz=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function D(t){return e.$Wz.indexOf(t)>=0}e.$Xz=D,e.$Yz=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function u(t){return e.$Yz.indexOf(t)>=0}e.$Zz=u;function p(t,i,c,m){if(c===1)return!1;if(c===2&&u(i)){const E=/(\d+)\.(\d+)\.(\d+)/g.exec(m);if(E?.length===4&&parseInt(E[1])>=18)return!1}return t<1024}e.$1z=p;class ${constructor(i,c,m){this.remoteAddress=i,this.localAddress=c,this.b=m,this.a=new y.$hc,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.$2z=$;let d=class{constructor(i,c){this.j=i,this.k=c,this.a=new y.$hc,this.onTunnelOpened=this.a.event,this.b=new y.$hc,this.onTunnelClosed=this.b.event,this.c=new y.$hc,this.onAddedTunnelProvider=this.c.event,this.e=new Map,this.g=!1,this.h=[],this.i=new Set}get hasTunnelProvider(){return!!this.f}get l(){const i=this.k.getValue("remote.localPortHost");return!i||i==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(i){return this.f=i,i?(this.c.fire(),{dispose:()=>{this.f=void 0,this.g=!1,this.h=[]}}):(this.g=!1,this.h=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(i){this.g=i.elevation,this.h=i.privacyOptions}get canElevate(){return this.g}get canChangePrivacy(){return this.h.length>0}get privacyOptions(){return this.h}get tunnels(){return this.m()}async m(){const i=[],c=Array.from(this.e.values());for(const m of c){const E=Array.from(m.values());for(const b of E){const n=await b.value;n&&typeof n!="string"&&i.push(n)}}return i}async dispose(){for(const i of this.e.values()){for(const{value:c}of i.values())await c.then(m=>typeof m!="string"?m?.dispose():void 0);i.clear()}this.e.clear()}setEnvironmentTunnel(i,c,m,E,b){this.p(i,c,Promise.resolve({tunnelRemoteHost:i,tunnelRemotePort:c,localAddress:m,privacy:E,protocol:b,dispose:()=>Promise.resolve()}))}async getExistingTunnel(i,c){(u(i)||D(i))&&(i=e.$Wz[0]);const m=this.r(i,c);if(m)return++m.refcount,m.value}openTunnel(i,c,m,E,b,n=!1,a,s){this.j.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${c}:${m} on local port ${b}.`);const o=this.f??i;if(!o)return;if(c||(c="localhost"),E||(E=this.l),this.f&&this.i.has(m)){this.j.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const w=this.s(o,c,m,E,b,n,a,s);return w?w.then(v=>{if(v){if(typeof v=="string")return this.j.trace("ForwardedPorts: (TunnelService) The tunnel provider returned an error when creating the tunnel."),this.q(c,m),v}else{this.j.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.q(c,m);return}this.j.trace("ForwardedPorts: (TunnelService) New tunnel established.");const I=this.n(v);return(v.tunnelRemoteHost!==c||v.tunnelRemotePort!==m)&&this.j.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),a&&v.privacy!==a&&this.j.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this.a.fire(I),I}):(this.j.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),w)}n(i){return{tunnelRemotePort:i.tunnelRemotePort,tunnelRemoteHost:i.tunnelRemoteHost,tunnelLocalPort:i.tunnelLocalPort,localAddress:i.localAddress,privacy:i.privacy,protocol:i.protocol,dispose:async()=>{this.j.trace(`ForwardedPorts: (TunnelService) dispose request for ${i.tunnelRemoteHost}:${i.tunnelRemotePort} `);const c=this.e.get(i.tunnelRemoteHost);if(c){const m=c.get(i.tunnelRemotePort);m&&(m.refcount--,await this.o(i.tunnelRemoteHost,i.tunnelRemotePort,m))}}}}async o(i,c,m){if(m.refcount<=0){this.j.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${i}:${c}.`);const E=m.value.then(async b=>{b&&typeof b!="string"&&(await b.dispose(!0),this.b.fire({host:b.tunnelRemoteHost,port:b.tunnelRemotePort}))});return this.e.has(i)&&this.e.get(i).delete(c),E}}async closeTunnel(i,c){this.j.trace(`ForwardedPorts: (TunnelService) close request for ${i}:${c} `);const m=this.e.get(i);if(m&&m.has(c)){const E=m.get(c);E.refcount=0,await this.o(i,c,E)}}p(i,c,m){this.e.has(i)||this.e.set(i,new Map),this.e.get(i).set(c,{refcount:1,value:m})}async q(i,c){const m=this.e.get(i);if(m){const E=m.get(c),b=E?await E.value:void 0;(!b||typeof b=="string")&&m.delete(c),m.size===0&&this.e.delete(i)}}r(i,c){const m=[i];D(i)?(m.push(...e.$Wz),m.push(...e.$Yz)):u(i)&&m.push(...e.$Yz);const E=m.map(b=>this.e.get(b));for(const b of E){const n=b?.get(c);if(n)return n}}canTunnel(i){return!!P(i)}t(i,c,m,E,b,n,a){this.j.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${c}:${m} on local port ${E}.`);const s=m;this.i.add(s);const o=E===void 0?m:E,w={elevationRequired:b?this.isPortPrivileged(o):!1},v={remoteAddress:{host:c,port:m},localAddressPort:E,privacy:n,public:n?n!==h.Private:void 0,protocol:a},I=i.forwardPort(v,w);return I?(this.p(c,m,I),I.finally(()=>{this.j.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.i.delete(s)})):this.i.delete(s),I}};e.$3z=d,e.$3z=d=Ke([Ve(0,L.$3i),Ve(1,R.$6h)],d)}),define(Pe[186],Ae([1,0,4]),function(pe,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditSessionIdentityMatch=e.$4z=void 0,e.$4z=(0,y.$zh)("editSessionIdentityService");var R;(function(C){C[C.Complete=100]="Complete",C[C.Partial=50]="Partial",C[C.None=0]="None"})(R||(e.EditSessionIdentityMatch=R={}))}),define(Pe[187],Ae([1,0,12]),function(pe,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nJ=e.$mJ=e.$lJ=e.$kJ=e.$jJ=void 0;function R(S){return S.scheme!==y.Schemas.file&&S.scheme!==y.Schemas.vscodeRemote}e.$jJ=R;function C(S){if(S.folders.length)return S.folders.every(g=>R(g.uri))?S.folders[0].uri:void 0;if(S.configuration&&R(S.configuration))return S.configuration}e.$kJ=C;function L(S){return C(S)?.scheme}e.$lJ=L;function A(S){return C(S)?.authority}e.$mJ=A;function h(S){return C(S)!==void 0}e.$nJ=h}),define(Pe[53],Ae([1,0,146,19,48,23,2,4,12]),function(pe,e,y,R,C,L,A,h,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5h=e.$4h=e.$3h=e.$2h=e.$1h=e.$Zh=e.$Yh=e.$Xh=e.$Wh=e.$Vh=e.$Uh=e.$Th=e.$Sh=e.$Rh=e.$Qh=e.WorkbenchState=e.$Ph=e.$Oh=e.$Nh=e.$Mh=e.$Lh=e.$Kh=e.$Jh=e.$Ih=void 0,e.$Ih=(0,h.$zh)("contextService");function g(o){const w=o;return typeof w?.id=="string"&&A.URI.isUri(w.uri)}e.$Jh=g;function P(o){return typeof o?.id=="string"&&!g(o)&&!u(o)}e.$Kh=P,e.$Lh={id:"ext-dev"},e.$Mh={id:"empty-window"};function D(o,w){if(typeof o=="string"||typeof o>"u")return typeof o=="string"?{id:(0,R.$cd)(o)}:w?e.$Lh:e.$Mh;const v=o;return v.configuration?{id:v.id,configPath:v.configuration}:v.folders.length===1?{id:v.id,uri:v.folders[0].uri}:{id:v.id}}e.$Nh=D;function u(o){const w=o;return typeof w?.id=="string"&&A.URI.isUri(w.configPath)}e.$Oh=u;function p(o){const w=o;if(w?.uri)return{id:w.id,uri:A.URI.revive(w.uri)};const v=o;if(v?.configPath)return{id:v.id,configPath:A.URI.revive(v.configPath)};if(o?.id)return{id:o.id}}e.$Ph=p;var $;(function(o){o[o.EMPTY=1]="EMPTY",o[o.FOLDER=2]="FOLDER",o[o.WORKSPACE=3]="WORKSPACE"})($||(e.WorkbenchState=$={}));function d(o){const w=o;return!!(w&&typeof w=="object"&&typeof w.id=="string"&&Array.isArray(w.folders))}e.$Qh=d;function t(o){const w=o;return!!(w&&typeof w=="object"&&A.URI.isUri(w.uri)&&typeof w.name=="string"&&typeof w.toResource=="function")}e.$Rh=t;class i{constructor(w,v,I,k,r){this.h=w,this.j=I,this.k=k,this.l=r,this.c=C.$Fh.forUris(this.l,()=>!0),this.folders=v}update(w){this.h=w.id,this.k=w.configuration,this.j=w.transient,this.l=w.l,this.folders=w.folders}get folders(){return this.g}set folders(w){this.g=w,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(w){this.k=w}getFolder(w){return w&&this.c.findSubstr(w)||null}n(){this.c=C.$Fh.forUris(this.l,()=>!0);for(const w of this.folders)this.c.set(w.uri,w)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$Sh=i;class c{constructor(w,v){this.raw=v,this.uri=w.uri,this.index=w.index,this.name=w.name}toResource(w){return(0,L.$gg)(this.uri,w)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$Th=c;function m(o){return new c({uri:o,index:0,name:(0,L.$cg)(o)},{uri:o.toString()})}e.$Uh=m,e.$Vh="code-workspace",e.$Wh=`.${e.$Vh}`,e.$Xh=[{name:(0,y.localize)(0,null),extensions:[e.$Vh]}],e.$Yh="workspace.json";function E(o,w){return L.$0f.isEqualOrParent(o,w.untitledWorkspacesHome)}e.$Zh=E;function b(o){let w;return A.URI.isUri(o)?w=o:w=o.configuration,w?.scheme===S.Schemas.tmp}e.$1h=b,e.$2h="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function n(o){return o.id===e.$2h}e.$3h=n;function a(o,w){return!E(o,w)&&!b(o)}e.$4h=a;function s(o){return(typeof o=="string"?(0,R.$dd)(o):(0,L.$eg)(o))===e.$Wh}e.$5h=s}),define(Pe[54],Ae([1,0]),function(pe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tac=void 0;class y{static{this.a=!1}constructor(C){this.d=C,this.b=new Map,this.c=1}add(C){const L=this.c++;return this.b.set(L,C),this.e(),L}get(C,L){return this.b.has(C)?this.b.get(C)[L]:void 0}delete(C){this.b.delete(C),this.e()}e(){y.a&&console.log(`${this.d} cache size - ${this.b.size}`)}}e.$tac=y}),define(Pe[39],Ae([1,0,12,23,4]),function(pe,e,y,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wac=e.$vac=void 0;class L{constructor(){this.a=new Set(Object.keys(y.Schemas)),this.b=new Map,this.extUri=new R.$8f(h=>{const S=this.b.get(h.scheme);return!(S===void 0||S&1024)})}$acceptProviderInfos(h,S){S===null?this.b.delete(h.scheme):this.b.set(h.scheme,S)}isFreeScheme(h){return!this.b.has(h)&&!this.a.has(h)}getCapabilities(h){return this.b.get(h)}}e.$vac=L,e.$wac=(0,C.$zh)("IExtHostFileSystemInfo")}),define(Pe[27],Ae([1,0,4]),function(pe,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$L=void 0,e.$$L=(0,y.$zh)("IExtHostInitDataService")}),define(Pe[188],Ae([1,0,151,14,175,27]),function(pe,e,y,R,C,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ccc=void 0;let A=class extends C.$fN{constructor(S,g,P){const D=P.remote.isRemote?"remoteexthost":S?"workerexthost":"exthost",u=P.remote.isRemote?(0,y.localize)(0,null):S?(0,y.localize)(1,null):(0,y.localize)(2,null);super(g.createLogger(D,{name:u}))}};e.$Ccc=A,e.$Ccc=A=Ke([Ve(1,R.$4i),Ve(2,L.$$L)],A)}),define(Pe[189],Ae([1,0,13]),function(pe,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zac=e.$Yac=void 0;class R{constructor(A,h,S){this.h=new Map,this.a=A,this.b=h,this.c=S,this.d=this.c.initializeExtensionStorage(this.b,this.a,Object.create(null)).then(g=>(this.f=g,this)),this.g=this.c.onDidChangeStorage(g=>{g.shared===this.b&&g.key===this.a&&(this.f=g.value)}),this.i=new y.$Qg(()=>{const g=this.h;this.h=new Map,(async()=>{try{await this.c.setValue(this.b,this.a,this.f);for(const P of g.values())P.complete()}catch(P){for(const D of g.values())D.error(P)}})()},0)}keys(){return Object.entries(this.f??{}).filter(([,A])=>A!==void 0).map(([A])=>A)}get whenReady(){return this.d}get(A,h){let S=this.f[A];return typeof S>"u"&&(S=h),S}update(A,h){this.f[A]=h;const S=this.h.get(A);if(S!==void 0)return S.p;const g=new y.$Zg;return this.h.set(A,g),this.i.isScheduled()||this.i.schedule(),g.p}dispose(){this.g.dispose()}}e.$Yac=R;class C extends R{setKeysForSync(A){this.c.registerExtensionStorageKeysToSync({id:this.a,version:this.j.version},A)}constructor(A,h){super(A.identifier.value,!0,h),this.j=A}}e.$Zac=C}),define(Pe[190],Ae([1,0,5,2]),function(pe,e,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lcc=void 0;class C{constructor(A){this.c=A,this.a=new y.$hc,this.onDidSaveNotebookDocument=this.a.event,this.b=new y.$hc,this.onDidChangeNotebookDocument=this.b.event}$acceptModelChanged(A,h,S,g){const D=this.c.getNotebookDocument(R.URI.revive(A)).acceptModelChanged(h.value,S,g);this.b.fire(D)}$acceptDirtyStateChanged(A,h){this.c.getNotebookDocument(R.URI.revive(A)).acceptDirty(h)}$acceptModelSaved(A){const h=this.c.getNotebookDocument(R.URI.revive(A));this.a.fire(h.apiNotebook)}}e.$lcc=C}),define(Pe[17],Ae([1,0,4]),function(pe,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$VL=e.$UL=void 0,e.$UL=(0,y.$zh)("IExtHostRpcService");class R{constructor(L){this.getProxy=L.getProxy.bind(L),this.set=L.set.bind(L),this.dispose=L.dispose.bind(L),this.assertRegistered=L.assertRegistered.bind(L),this.drain=L.drain.bind(L)}}e.$VL=R}),define(Pe[191],Ae([1,0,20,5]),function(pe,e,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$ac=void 0;class C{#e;constructor(A,h){this.b=new R.$hc,this.onDidChange=this.b.event,this.a=y.$Tl.toKey(A.identifier),this.#e=h,this.#e.onDidChangePassword(S=>{S.extensionId===this.a&&this.b.fire({key:S.key})})}get(A){return this.#e.get(this.a,A)}store(A,h){return this.#e.store(this.a,A,h)}delete(A){return this.#e.delete(this.a,A)}}e.$$ac=C}),define(Pe[55],Ae([1,0,4]),function(pe,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hac=e.$Gac=void 0,e.$Gac=(0,y.$zh)("IURITransformerService");class R{constructor(L){L?(this.transformIncoming=L.transformIncoming.bind(L),this.transformOutgoing=L.transformOutgoing.bind(L),this.transformOutgoingURI=L.transformOutgoingURI.bind(L),this.transformOutgoingScheme=L.transformOutgoingScheme.bind(L)):(this.transformIncoming=A=>A,this.transformOutgoing=A=>A,this.transformOutgoingURI=A=>A,this.transformOutgoingScheme=A=>A)}}e.$Hac=R}),define(Pe[192],Ae([1,0,25]),function(pe,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pbb=e.$Obb=void 0;class R{constructor(){this.buffers=[]}add(S){let g=this.buffers.indexOf(S);return g<0&&(g=this.buffers.length,this.buffers.push(S)),g}}function C(h,S){if(S.serializeBuffersForPostMessage){const g=new R,D=JSON.stringify(h,(p,$)=>{if($ instanceof ArrayBuffer)return{$$vscode_array_buffer_reference$$:!0,index:g.add($)};if(ArrayBuffer.isView($)){const d=L($);if(d)return{$$vscode_array_buffer_reference$$:!0,index:g.add($.buffer),view:{type:d,byteLength:$.byteLength,byteOffset:$.byteOffset}}}return $}),u=g.buffers.map(p=>{const $=new Uint8Array(p);return y.$Hc.wrap($)});return{message:D,buffers:u}}else return{message:JSON.stringify(h),buffers:[]}}e.$Obb=C;function L(h){switch(h.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function A(h,S){const g=S.map(u=>{const p=new ArrayBuffer(u.byteLength);return new Uint8Array(p).set(u.buffer),p}),P=S.length?(u,p)=>{if(p&&typeof p=="object"&&p.$$vscode_array_buffer_reference$$){const $=p,{index:d}=$,t=g[d];if($.view)switch($.view.type){case 1:return new Int8Array(t,$.view.byteOffset,$.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(t,$.view.byteOffset,$.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(t,$.view.byteOffset,$.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(t,$.view.byteOffset,$.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(t,$.view.byteOffset,$.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(t,$.view.byteOffset,$.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(t,$.view.byteOffset,$.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(t,$.view.byteOffset,$.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(t,$.view.byteOffset,$.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(t,$.view.byteOffset,$.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(t,$.view.byteOffset,$.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return t}return p}:void 0;return{message:JSON.parse(h,P),arrayBuffers:g}}e.$Pbb=A}),define(Pe[99],Ae([1,0,160,16,2,6,4,30,38,12,41,128,29]),function(pe,e,y,R,C,L,A,h,S,g,P,D,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3E=e.$2E=e.$1E=e.EditorsOrder=e.$ZE=e.CloseDirection=e.$YE=e.$XE=e.EditorCloseMethod=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.$WE=e.$VE=e.$UE=e.$TE=e.$SE=e.$RE=e.$QE=e.$PE=e.EditorInputCapabilities=e.$OE=e.SaveReason=e.Verbosity=e.$NE=e.$ME=e.$LE=e.$KE=e.$JE=e.$IE=e.$HE=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.$GE=e.$FE=e.$EE=e.$DE=e.$CE=void 0,e.$CE={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.$DE={id:"default",displayName:(0,y.localize)(0,null),providerDisplayName:(0,y.localize)(1,null)},e.$EE="workbench.editor.sidebysideEditor",e.$FE="workbench.editors.textDiffEditor",e.$GE="workbench.editors.binaryResourceDiffEditor";var p;(function(ae){ae[ae.PROGRAMMATIC=1]="PROGRAMMATIC",ae[ae.USER=2]="USER",ae[ae.EDIT=3]="EDIT",ae[ae.NAVIGATION=4]="NAVIGATION",ae[ae.JUMP=5]="JUMP"})(p||(e.EditorPaneSelectionChangeReason=p={}));var $;(function(ae){ae[ae.IDENTICAL=1]="IDENTICAL",ae[ae.SIMILAR=2]="SIMILAR",ae[ae.DIFFERENT=3]="DIFFERENT"})($||(e.EditorPaneSelectionCompareResult=$={}));function d(ae){const x=ae;return!!x&&typeof x.getSelection=="function"&&!!x.onDidChangeSelection}e.$HE=d;function t(ae,x,ue){for(const O of ue.visibleEditorPanes)if(O.group.id===x&&ae.matches(O.input))return O.getViewState()}e.$IE=t;function i(ae){if(v(ae))return!1;const x=ae;return C.URI.isUri(x?.resource)}e.$JE=i;function c(ae){if(v(ae))return!1;const x=ae;return x?.original!==void 0&&x.modified!==void 0}e.$KE=c;function m(ae){if(v(ae)||c(ae))return!1;const x=ae;return x?.primary!==void 0&&x.secondary!==void 0}e.$LE=m;function E(ae){if(v(ae))return!1;const x=ae;return x?x.resource===void 0||x.resource.scheme===g.Schemas.untitled||x.forceUntitled===!0:!1}e.$ME=E;function b(ae){if(v(ae))return!1;const x=ae;return C.URI.isUri(x?.base?.resource)&&C.URI.isUri(x?.input1?.resource)&&C.URI.isUri(x?.input2?.resource)&&C.URI.isUri(x?.result?.resource)}e.$NE=b;var n;(function(ae){ae[ae.SHORT=0]="SHORT",ae[ae.MEDIUM=1]="MEDIUM",ae[ae.LONG=2]="LONG"})(n||(e.Verbosity=n={}));var a;(function(ae){ae[ae.EXPLICIT=1]="EXPLICIT",ae[ae.AUTO=2]="AUTO",ae[ae.FOCUS_CHANGE=3]="FOCUS_CHANGE",ae[ae.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(a||(e.SaveReason=a={}));class s{constructor(){this.a=new Map}registerSource(x,ue){let O=this.a.get(x);return O||(O={source:x,label:ue},this.a.set(x,O)),O.source}getSourceLabel(x){return this.a.get(x)?.label??x}}e.$OE=new s;var o;(function(ae){ae[ae.None=0]="None",ae[ae.Readonly=2]="Readonly",ae[ae.Untitled=4]="Untitled",ae[ae.Singleton=8]="Singleton",ae[ae.RequiresTrust=16]="RequiresTrust",ae[ae.CanSplitInGroup=32]="CanSplitInGroup",ae[ae.ForceDescription=64]="ForceDescription",ae[ae.CanDropIntoEditor=128]="CanDropIntoEditor",ae[ae.MultipleEditors=256]="MultipleEditors",ae[ae.Scratchpad=512]="Scratchpad"})(o||(e.EditorInputCapabilities=o={}));class w extends L.$mb{}e.$PE=w;function v(ae){return ae instanceof w}e.$QE=v;function I(ae){const x=ae;return C.URI.isUri(x?.preferredResource)}function k(ae){const x=ae;return v(x?.primary)&&v(x?.secondary)}e.$RE=k;function r(ae){const x=ae;return v(x?.modified)&&v(x?.original)}e.$SE=r;function l(ae,x,ue,O,J){return we(O,[(0,D.$ji)({id:"workbench.action.openLargeFile",label:(0,y.localize)(2,null),run:()=>{const he={...ue,limits:{size:Number.MAX_VALUE}};ae.openEditor(x,he)}}),(0,D.$ji)({id:"workbench.action.configureEditorLargeFileConfirmation",label:(0,y.localize)(3,null),run:()=>J.openUserSettings({query:"workbench.editorLargeFileConfirmation"})})],{forceMessage:!0,forceSeverity:u.default.Warning})}e.$TE=l;function f(ae){return v(ae?.editor)}e.$UE=f;function F(ae){const x=ae;return f(ae)&&x?.group!==void 0}e.$VE=F;function W(ae){const x=ae;return typeof x?.groupId=="number"&&v(x.editor)}e.$WE=W;var V;(function(ae){ae[ae.UNKNOWN=0]="UNKNOWN",ae[ae.REPLACE=1]="REPLACE",ae[ae.MOVE=2]="MOVE",ae[ae.UNPIN=3]="UNPIN"})(V||(e.EditorCloseContext=V={}));var B;(function(ae){ae[ae.GROUP_ACTIVE=0]="GROUP_ACTIVE",ae[ae.GROUP_INDEX=1]="GROUP_INDEX",ae[ae.GROUP_LOCKED=2]="GROUP_LOCKED",ae[ae.EDITOR_OPEN=3]="EDITOR_OPEN",ae[ae.EDITOR_CLOSE=4]="EDITOR_CLOSE",ae[ae.EDITOR_MOVE=5]="EDITOR_MOVE",ae[ae.EDITOR_ACTIVE=6]="EDITOR_ACTIVE",ae[ae.EDITOR_LABEL=7]="EDITOR_LABEL",ae[ae.EDITOR_CAPABILITIES=8]="EDITOR_CAPABILITIES",ae[ae.EDITOR_PIN=9]="EDITOR_PIN",ae[ae.EDITOR_STICKY=10]="EDITOR_STICKY",ae[ae.EDITOR_DIRTY=11]="EDITOR_DIRTY",ae[ae.EDITOR_WILL_DISPOSE=12]="EDITOR_WILL_DISPOSE"})(B||(e.GroupModelChangeKind=B={}));var j;(function(ae){ae[ae.PRIMARY=1]="PRIMARY",ae[ae.SECONDARY=2]="SECONDARY",ae[ae.BOTH=3]="BOTH",ae[ae.ANY=4]="ANY"})(j||(e.SideBySideEditor=j={}));class U{getOriginalUri(x,ue){if(!x)return;if(b(x))return e.$YE.getOriginalUri(x.result,ue);if(ue?.supportSideBySide){const{primary:J,secondary:he}=this.a(x);if(J&&he){if(ue?.supportSideBySide===j.BOTH)return{primary:this.getOriginalUri(J,{filterByScheme:ue.filterByScheme}),secondary:this.getOriginalUri(he,{filterByScheme:ue.filterByScheme})};if(ue?.supportSideBySide===j.ANY)return this.getOriginalUri(J,{filterByScheme:ue.filterByScheme})??this.getOriginalUri(he,{filterByScheme:ue.filterByScheme});x=ue.supportSideBySide===j.PRIMARY?J:he}}if(c(x)||m(x)||b(x))return;const O=I(x)?x.preferredResource:x.resource;return!O||!ue||!ue.filterByScheme?O:this.b(O,ue.filterByScheme)}a(x){return k(x)||m(x)?{primary:x.primary,secondary:x.secondary}:r(x)||c(x)?{primary:x.modified,secondary:x.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(x,ue){if(!x)return;if(b(x))return e.$YE.getCanonicalUri(x.result,ue);if(ue?.supportSideBySide){const{primary:J,secondary:he}=this.a(x);if(J&&he){if(ue?.supportSideBySide===j.BOTH)return{primary:this.getCanonicalUri(J,{filterByScheme:ue.filterByScheme}),secondary:this.getCanonicalUri(he,{filterByScheme:ue.filterByScheme})};if(ue?.supportSideBySide===j.ANY)return this.getCanonicalUri(J,{filterByScheme:ue.filterByScheme})??this.getCanonicalUri(he,{filterByScheme:ue.filterByScheme});x=ue.supportSideBySide===j.PRIMARY?J:he}}if(c(x)||m(x)||b(x))return;const O=x.resource;return!O||!ue||!ue.filterByScheme?O:this.b(O,ue.filterByScheme)}b(x,ue){if(Array.isArray(ue)){if(ue.some(O=>x.scheme===O))return x}else if(ue===x.scheme)return x}}var z;(function(ae){ae[ae.UNKNOWN=0]="UNKNOWN",ae[ae.KEYBOARD=1]="KEYBOARD",ae[ae.MOUSE=2]="MOUSE"})(z||(e.EditorCloseMethod=z={}));function ie(ae,x,ue,O){if(!ae.isSticky(x))return!1;switch(O.preventPinnedEditorClose){case"keyboardAndMouse":return ue===z.MOUSE||ue===z.KEYBOARD;case"mouse":return ue===z.MOUSE;case"keyboard":return ue===z.KEYBOARD}return!1}e.$XE=ie,e.$YE=new U;var Y;(function(ae){ae[ae.LEFT=0]="LEFT",ae[ae.RIGHT=1]="RIGHT"})(Y||(e.CloseDirection=Y={}));class ye{constructor(){this.c=new Map,this.d=new Map}start(x){const ue=this.a=x.get(A.$yh);for(const[O,J]of this.c)this.e(O,J,ue);this.c.clear()}e(x,ue,O){const J=O.createInstance(ue);this.d.set(x,J)}registerFileEditorFactory(x){if(this.b)throw new Error("Can only register one file editor factory.");this.b=x}getFileEditorFactory(){return(0,R.$we)(this.b)}registerEditorSerializer(x,ue){if(this.c.has(x)||this.d.has(x))throw new Error(`A editor serializer with type ID '${x}' was already registered.`);return this.a?this.e(x,ue,this.a):this.c.set(x,ue),(0,L.$kb)(()=>{this.c.delete(x),this.d.delete(x)})}getEditorSerializer(x){return this.d.get(typeof x=="string"?x:x.typeId)}}h.$6m.add(e.$CE.EditorFactory,new ye);async function ke(ae,x,ue){return!ae||!ae.length?[]:await Promise.all(ae.map(async O=>{const J=C.URI.revive(O.fileUri);if(!J){ue.info("Cannot resolve the path because it is not valid.",O);return}if(!await x.canHandleResource(J)){ue.info("Cannot resolve the path because it cannot be handled",O);return}let Ee=O.exists,ve=O.type;if(typeof Ee!="boolean"||typeof ve!="number")try{ve=(await x.stat(J)).isDirectory?S.FileType.Directory:S.FileType.Unknown,Ee=!0}catch(De){ue.error(De),Ee=!1}if(!Ee&&O.openOnlyIfExists){ue.info("Cannot resolve the path because it does not exist",O);return}if(ve===S.FileType.Directory){ue.info("Cannot resolve the path because it is a directory",O);return}const be={...O.options,pinned:!0};return Ee?{resource:J,options:be}:{resource:J,options:be,forceUntitled:!0}}))}e.$ZE=ke;var Re;(function(ae){ae[ae.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",ae[ae.SEQUENTIAL=1]="SEQUENTIAL"})(Re||(e.EditorsOrder=Re={}));function X(ae){const x=ae;if(!x)return!1;const ue=x;if(ue.modified)return X(ue.modified);const O=x;return!!(O.contributionsState&&O.viewState&&Array.isArray(O.cursorState))}e.$1E=X;function le(ae){return(0,P.$li)(ae)}e.$2E=le;function we(ae,x,ue){const O=(0,P.$mi)(ae,x);return O.forceMessage=ue?.forceMessage,O.forceSeverity=ue?.forceSeverity,O.allowDialog=ue?.allowDialog,O}e.$3E=we}),define(Pe[193],Ae([1,0,5,161,4,6,28,30,18,100,24,89,184]),function(pe,e,y,R,C,L,A,h,S,g,P,D,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0E=e.$9E=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.$8E=e.$7E=e.ViewContentGroups=e.$6E=e.$5E=e.ViewContainerLocation=e.Extensions=e.$4E=void 0,e.$4E=(0,u.$6u)("default-view-icon",D.$Nj.window,(0,R.localize)(0,null));var p;(function(s){s.ViewContainersRegistry="workbench.registry.view.containers",s.ViewsRegistry="workbench.registry.view"})(p||(e.Extensions=p={}));var $;(function(s){s[s.Sidebar=0]="Sidebar",s[s.Panel=1]="Panel",s[s.AuxiliaryBar=2]="AuxiliaryBar"})($||(e.ViewContainerLocation=$={})),e.$5E=[0,1,2];function d(s){switch(s){case 0:return"sidebar";case 1:return"panel";case 2:return"auxiliarybar"}}e.$6E=d;class t extends L.$mb{constructor(){super(...arguments),this.c=this.B(new y.$hc),this.onDidRegister=this.c.event,this.f=this.B(new y.$hc),this.onDidDeregister=this.f.event,this.g=new Map,this.h=[]}get all(){return(0,S.$Kf)([...this.g.values()])}registerViewContainer(o,w,v){const I=this.get(o.id);if(I)return I;const k=o;return k.openCommandActionDescriptor=v?.doNotRegisterOpenCommand?void 0:k.openCommandActionDescriptor??{id:k.id},(0,A.$ui)(this.g,w,[]).push(k),v?.isDefault&&this.h.push(k),this.c.fire({viewContainer:k,viewContainerLocation:w}),k}deregisterViewContainer(o){for(const w of this.g.keys()){const v=this.g.get(w),I=v?.indexOf(o);if(I!==-1){v?.splice(I,1),v.length===0&&this.g.delete(w),this.f.fire({viewContainer:o,viewContainerLocation:w});return}}}get(o){return this.all.filter(w=>w.id===o)[0]}getViewContainers(o){return[...this.g.get(o)||[]]}getViewContainerLocation(o){return[...this.g.keys()].filter(w=>this.getViewContainers(w).filter(v=>v?.id===o.id).length>0)[0]}getDefaultViewContainer(o){return this.h.find(w=>this.getViewContainerLocation(w)===o)}}h.$6m.add(p.ViewContainersRegistry,new t);var i;(function(s){s.Open="2_open",s.Debug="4_debug",s.SCM="5_scm",s.More="9_more"})(i||(e.ViewContentGroups=i={}));function c(s,o){const w=s.group??i.More,v=o.group??i.More;return w!==v?w.localeCompare(v):(s.order??5)-(o.order??5)}class m extends L.$mb{constructor(){super(...arguments),this.c=this.B(new y.$hc),this.onViewsRegistered=this.c.event,this.f=this.B(new y.$hc),this.onViewsDeregistered=this.f.event,this.g=this.B(new y.$hc),this.onDidChangeContainer=this.g.event,this.h=this.B(new y.$hc),this.onDidChangeViewWelcomeContent=this.h.event,this.i=[],this.j=new Map,this.k=new g.$L}registerViews(o,w){this.registerViews2([{views:o,viewContainer:w}])}registerViews2(o){o.forEach(({views:w,viewContainer:v})=>this.l(w,v)),this.c.fire(o)}deregisterViews(o,w){const v=this.m(o,w);v.length&&this.f.fire({views:v,viewContainer:w})}moveViews(o,w){for(const v of this.j.keys())if(v!==w){const I=this.m(o,v);I.length&&(this.l(I,w),this.g.fire({views:I,from:v,to:w}))}}getViews(o){return this.j.get(o)||[]}getView(o){for(const w of this.i){const v=(this.j.get(w)||[]).filter(I=>I.id===o)[0];if(v)return v}return null}getViewContainer(o){for(const w of this.i)if((this.j.get(w)||[]).filter(I=>I.id===o)[0])return w;return null}registerViewWelcomeContent(o,w){return this.k.add(o,w),this.h.fire(o),(0,L.$kb)(()=>{this.k.delete(o,w),this.h.fire(o)})}registerViewWelcomeContent2(o,w){const v=new Map;for(const[I,k]of w)this.k.add(o,k),v.set(I,(0,L.$kb)(()=>{this.k.delete(o,k),this.h.fire(o)}));return this.h.fire(o),v}getViewWelcomeContent(o){const w=[];return this.k.forEach(o,v=>w.push(v)),w.sort(c)}l(o,w){let v=this.j.get(w);v||(v=[],this.j.set(w,v),this.i.push(w));for(const I of o){if(this.getView(I.id)!==null)throw new Error((0,R.localize)(1,null,I.id));v.push(I)}}m(o,w){const v=this.j.get(w);if(!v)return[];const I=[],k=[];for(const r of v)o.includes(r)?I.push(r):k.push(r);return I.length&&(k.length?this.j.set(w,k):(this.j.delete(w),this.i.splice(this.i.indexOf(w),1))),I}}h.$6m.add(p.ViewsRegistry,new m),e.$7E=(0,C.$zh)("viewsService"),e.$8E=(0,C.$zh)("viewDescriptorService");var E;(function(s){s[s.Default=0]="Default",s[s.Expand=1]="Expand"})(E||(e.ViewVisibilityState=E={}));var b;(function(s){s[s.None=0]="None",s[s.Collapsed=1]="Collapsed",s[s.Expanded=2]="Expanded"})(b||(e.TreeItemCollapsibleState=b={}));class n{constructor(o,w){this.c=!1,this.d=!1,(0,P.$Wm)(this,o),this.d=!!w,this.resolve=async v=>{if(w&&!this.c){const I=await w(v);I&&(this.tooltip=this.tooltip??I.tooltip,this.command=this.command??I.command)}v.isCancellationRequested||(this.c=!0)}}get hasResolve(){return this.d}resetResolve(){this.c=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.$9E=n;class a extends Error{constructor(o){super((0,R.localize)(2,null,o)),this.name="NoTreeViewError"}static is(o){return o.name==="NoTreeViewError"}}e.$0E=a}),define(Pe[194],Ae([1,0,5,13,162]),function(pe,e,y,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$icb=void 0;class L{constructor(){this.f=new Map,this.k=[],this.m=new y.$hc,this.n=new y.$hc,this.d=1}get onError(){return this.m.event}get onExit(){return this.n.event}onMessage(h){this.j&&this.m.fire(new Error("attempt to set more than one 'Message' callback")),this.j=h}onEvent(h){this.i&&this.m.fire(new Error("attempt to set more than one 'Event' callback")),this.i=h}onRequest(h){this.g&&this.m.fire(new Error("attempt to set more than one 'Request' callback")),this.g=h}sendResponse(h){h.seq>0?this.m.fire(new Error(`attempt to send more than one response for command ${h.command}`)):this.s("response",h)}sendRequest(h,S,g,P){const D={command:h};if(S&&Object.keys(S).length>0&&(D.arguments=S),this.s("request",D),typeof P=="number"){const u=setTimeout(()=>{clearTimeout(u);const p=this.f.get(D.seq);if(p){this.f.delete(D.seq);const $={type:"response",seq:0,request_seq:D.seq,success:!1,command:h,message:(0,C.localize)(0,null,P,h)};p($)}},P)}return g&&this.f.set(D.seq,g),D.seq}acceptMessage(h){this.j?this.j(h):(this.k.push(h),this.k.length===1&&this.q())}o(h,S){return h.type!=="event"||S.type!=="event"}async q(){let h;for(;this.k.length;){if((!h||this.o(this.k[0],h))&&await(0,R.$Fg)(0),h=this.k.shift(),!h)return;switch(h.type){case"event":this.i?.(h);break;case"request":this.g?.(h);break;case"response":{const S=h,g=this.f.get(S.request_seq);g&&(this.f.delete(S.request_seq),g(S));break}}}}s(h,S){S.type=h,S.seq=this.d++,this.sendMessage(S)}async u(){if(this.f.size===0)return Promise.resolve();const h=new Map;this.f.forEach((S,g)=>h.set(g,S)),await(0,R.$Fg)(500),h.forEach((S,g)=>{S({type:"response",seq:0,request_seq:g,success:!1,command:"canceled",message:"canceled"}),this.f.delete(g)})}getPendingRequestIds(){return Array.from(this.f.keys())}dispose(){this.k=[]}}e.$icb=L}),define(Pe[195],Ae([1,0,163,32,4]),function(pe,e,y,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BreakpointWidgetContext=e.$jH=e.DebuggerString=e.DebugConfigurationProviderTriggerKind=e.$iH=e.MemoryRangeType=e.$hH=e.State=e.$gH=e.$fH=e.$eH=e.$dH=e.$cH=e.$bH=e.$aH=e.$_G=e.$$G=e.$0G=e.$9G=e.$8G=e.$7G=e.$6G=e.$5G=e.$4G=e.$3G=e.$2G=e.$1G=e.$ZG=e.$YG=e.$XG=e.$WG=e.$VG=e.$UG=e.$TG=e.$SG=e.$RG=e.$QG=e.$PG=e.$OG=e.$NG=e.$MG=e.$LG=e.$KG=e.$JG=e.$IG=e.$HG=e.$GG=e.$FG=e.$EG=e.$DG=e.$CG=e.$BG=e.$AG=e.$zG=e.$yG=e.$xG=e.$wG=e.$vG=e.$uG=e.$tG=e.$sG=e.$rG=e.$qG=e.$pG=e.$oG=e.$nG=e.$mG=e.$lG=e.$kG=e.$jG=e.$iG=e.$hG=e.$gG=e.$fG=void 0,e.$fG="workbench.view.debug",e.$gG="workbench.debug.variablesView",e.$hG="workbench.debug.watchExpressionsView",e.$iG="workbench.debug.callStackView",e.$jG="workbench.debug.loadedScriptsView",e.$kG="workbench.debug.breakPointsView",e.$lG="workbench.debug.disassemblyView",e.$mG="workbench.panel.repl",e.$nG="workbench.panel.repl.view",e.$oG=new R.$Zi("debugType",void 0,{type:"string",description:y.localize(0,null)}),e.$pG=new R.$Zi("debugConfigurationType",void 0,{type:"string",description:y.localize(1,null)}),e.$qG=new R.$Zi("debugState","inactive",{type:"string",description:y.localize(2,null)}),e.$rG="debugUx",e.$sG=new R.$Zi(e.$rG,"default",{type:"string",description:y.localize(3,null)}),e.$tG=new R.$Zi("hasDebugged",!1,{type:"boolean",description:y.localize(4,null)}),e.$uG=new R.$Zi("inDebugMode",!1,{type:"boolean",description:y.localize(5,null)}),e.$vG=new R.$Zi("inDebugRepl",!1,{type:"boolean",description:y.localize(6,null)}),e.$wG=new R.$Zi("breakpointWidgetVisible",!1,{type:"boolean",description:y.localize(7,null)}),e.$xG=new R.$Zi("inBreakpointWidget",!1,{type:"boolean",description:y.localize(8,null)}),e.$yG=new R.$Zi("breakpointsFocused",!0,{type:"boolean",description:y.localize(9,null)}),e.$zG=new R.$Zi("watchExpressionsFocused",!0,{type:"boolean",description:y.localize(10,null)}),e.$AG=new R.$Zi("watchExpressionsExist",!1,{type:"boolean",description:y.localize(11,null)}),e.$BG=new R.$Zi("variablesFocused",!0,{type:"boolean",description:y.localize(12,null)}),e.$CG=new R.$Zi("expressionSelected",!1,{type:"boolean",description:y.localize(13,null)}),e.$DG=new R.$Zi("breakpointInputFocused",!1,{type:"boolean",description:y.localize(14,null)}),e.$EG=new R.$Zi("callStackItemType",void 0,{type:"string",description:y.localize(15,null)}),e.$FG=new R.$Zi("callStackSessionIsAttach",!1,{type:"boolean",description:y.localize(16,null)}),e.$GG=new R.$Zi("callStackItemStopped",!1,{type:"boolean",description:y.localize(17,null)}),e.$HG=new R.$Zi("callStackSessionHasOneThread",!1,{type:"boolean",description:y.localize(18,null)}),e.$IG=new R.$Zi("watchItemType",void 0,{type:"string",description:y.localize(19,null)}),e.$JG=new R.$Zi("canViewMemory",void 0,{type:"boolean",description:y.localize(20,null)}),e.$KG=new R.$Zi("breakpointItemType",void 0,{type:"string",description:y.localize(21,null)}),e.$LG=new R.$Zi("breakpointSupportsCondition",!1,{type:"boolean",description:y.localize(22,null)}),e.$MG=new R.$Zi("loadedScriptsSupported",!1,{type:"boolean",description:y.localize(23,null)}),e.$NG=new R.$Zi("loadedScriptsItemType",void 0,{type:"string",description:y.localize(24,null)}),e.$OG=new R.$Zi("focusedSessionIsAttach",!1,{type:"boolean",description:y.localize(25,null)}),e.$PG=new R.$Zi("stepBackSupported",!1,{type:"boolean",description:y.localize(26,null)}),e.$QG=new R.$Zi("restartFrameSupported",!1,{type:"boolean",description:y.localize(27,null)}),e.$RG=new R.$Zi("stackFrameSupportsRestart",!1,{type:"boolean",description:y.localize(28,null)}),e.$SG=new R.$Zi("jumpToCursorSupported",!1,{type:"boolean",description:y.localize(29,null)}),e.$TG=new R.$Zi("stepIntoTargetsSupported",!1,{type:"boolean",description:y.localize(30,null)}),e.$UG=new R.$Zi("breakpointsExist",!1,{type:"boolean",description:y.localize(31,null)}),e.$VG=new R.$Zi("debuggersAvailable",!1,{type:"boolean",description:y.localize(32,null)}),e.$WG=new R.$Zi("debugExtensionAvailable",!0,{type:"boolean",description:y.localize(33,null)}),e.$XG=new R.$Zi("debugProtocolVariableMenuContext",void 0,{type:"string",description:y.localize(34,null)}),e.$YG=new R.$Zi("debugSetVariableSupported",!1,{type:"boolean",description:y.localize(35,null)}),e.$ZG=new R.$Zi("debugSetExpressionSupported",!1,{type:"boolean",description:y.localize(36,null)}),e.$1G=new R.$Zi("breakWhenValueChangesSupported",!1,{type:"boolean",description:y.localize(37,null)}),e.$2G=new R.$Zi("breakWhenValueIsAccessedSupported",!1,{type:"boolean",description:y.localize(38,null)}),e.$3G=new R.$Zi("breakWhenValueIsReadSupported",!1,{type:"boolean",description:y.localize(39,null)}),e.$4G=new R.$Zi("terminateDebuggeeSupported",!1,{type:"boolean",description:y.localize(40,null)}),e.$5G=new R.$Zi("suspendDebuggeeSupported",!1,{type:"boolean",description:y.localize(41,null)}),e.$6G=new R.$Zi("variableEvaluateNamePresent",!1,{type:"boolean",description:y.localize(42,null)}),e.$7G=new R.$Zi("variableIsReadonly",!1,{type:"boolean",description:y.localize(43,null)}),e.$8G=new R.$Zi("exceptionWidgetVisible",!1,{type:"boolean",description:y.localize(44,null)}),e.$9G=new R.$Zi("multiSessionRepl",!1,{type:"boolean",description:y.localize(45,null)}),e.$0G=new R.$Zi("multiSessionDebug",!1,{type:"boolean",description:y.localize(46,null)}),e.$$G=new R.$Zi("disassembleRequestSupported",!1,{type:"boolean",description:y.localize(47,null)}),e.$_G=new R.$Zi("disassemblyViewFocus",!1,{type:"boolean",description:y.localize(48,null)}),e.$aH=new R.$Zi("languageSupportsDisassembleRequest",!1,{type:"boolean",description:y.localize(49,null)}),e.$bH=new R.$Zi("focusedStackFrameHasInstructionReference",!1,{type:"boolean",description:y.localize(50,null)});const L=u=>y.localize(51,null,u);e.$cH=L,e.$dH="editor.contrib.debug",e.$eH="editor.contrib.breakpoint",e.$fH="debug",e.$gH={enum:["neverOpen","openOnSessionStart","openOnFirstSessionStart"],default:"openOnFirstSessionStart",description:y.localize(52,null)};var A;(function(u){u[u.Inactive=0]="Inactive",u[u.Initializing=1]="Initializing",u[u.Stopped=2]="Stopped",u[u.Running=3]="Running"})(A||(e.State=A={}));function h(u){switch(u){case 1:return"initializing";case 2:return"stopped";case 3:return"running";default:return"inactive"}}e.$hH=h;var S;(function(u){u[u.Valid=0]="Valid",u[u.Unreadable=1]="Unreadable",u[u.Error=2]="Error"})(S||(e.MemoryRangeType=S={})),e.$iH="vscode-debug-memory";var g;(function(u){u[u.Initial=1]="Initial",u[u.Dynamic=2]="Dynamic"})(g||(e.DebugConfigurationProviderTriggerKind=g={}));var P;(function(u){u.UnverifiedBreakpoints="unverifiedBreakpoints"})(P||(e.DebuggerString=P={})),e.$jH=(0,C.$zh)("debugService");var D;(function(u){u[u.CONDITION=0]="CONDITION",u[u.HIT_COUNT=1]="HIT_COUNT",u[u.LOG_MESSAGE=2]="LOG_MESSAGE"})(D||(e.BreakpointWidgetContext=D={}))}),define(Pe[196],Ae([1,0,15,2,19,24,12,44,21,18]),function(pe,e,y,R,C,L,A,h,S,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qF=e.$pF=e.$oF=e.$nF=e.$mF=e.$lF=e.$kF=e.$jF=e.$iF=e.$hF=e.$gF=e.$fF=e.$eF=void 0;const P=/{([^}]+)}/g;function D(k,r,l){return k.replace(P,function(f,F){return r&&F.length>0&&F[0]!=="_"?f:l&&l.hasOwnProperty(F)?l[F]:f})}e.$eF=D;function u(k){const r={};for(const l of Object.keys(k))l.startsWith("!")||(r[l]=k[l]);return r}e.$fF=u;function p(k){return k.configuration.request==="attach"&&!$(k)&&(!k.parentSession||p(k.parentSession))}e.$gF=p;function $(k){let r=k.configuration.type;if(r)return r==="vslsShare"&&(r=k.configuration.adapterProxy.configuration.type),(0,y.$Od)(r,"extensionhost")||(0,y.$Od)(r,"pwa-extensionhost")?k:k.parentSession?$(k.parentSession):void 0}e.$hF=$;function d(k){return k.type&&(k.label||k.program||k.runtime)}e.$iF=d;function t(k,r,l){let f,F=0;const W=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let V=null;for(;V=W.exec(k);){const B=V.index+1,j=B+V[0].length;if(B<=r&&j>=l){f=V[0],F=B;break}}if(f){const B=/\w+/g;let j=null;for(;(j=B.exec(f))&&!(j.index+1+F+j[0].length>=l););j&&(f=f.substring(0,B.lastIndex))}return f?{start:F,end:F+f.length-1}:{start:0,end:0}}e.$jF=t;async function i(k,r,l,f){if(k.evaluatableExpressionProvider.has(r)){const F=k.evaluatableExpressionProvider.ordered(r),W=(0,g.$Af)(await Promise.all(F.map(async V=>{try{return await V.provideEvaluatableExpression(r,l,f??S.CancellationToken.None)}catch{return}})));if(W.length>0){let V=W[0].expression;const B=W[0].range;return V||(V=r.getLineContent(l.lineNumber).substring(B.startColumn-1,B.endColumn-1)),{range:B,matchingExpression:V}}}else{const F=r.getLineContent(l.lineNumber),{start:W,end:V}=t(F,l.column,l.column),B=F.substring(W-1,V);return{matchingExpression:B,range:new h.$hs(l.lineNumber,W,l.lineNumber,W+B.length)}}return null}e.$kF=i;const c=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function m(k){return!!(k&&k.match(c))}e.$lF=m;function E(k){if(typeof k.path=="string"&&!(typeof k.sourceReference=="number"&&k.sourceReference>0)){if(m(k.path))return R.URI.parse(k.path);if((0,C.$0c)(k.path))return R.URI.file(k.path)}return k.path}function b(k){if(typeof k.path=="object"){const r=R.URI.revive(k.path);if(r)return r.scheme===A.Schemas.file?r.fsPath:r.toString()}return k.path}function n(k,r){const l=r?E:b,f=(0,L.$Tm)(k);return s(f,(F,W)=>{F&&W&&(W.path=l(W))}),f}e.$mF=n;function a(k,r){const l=r?E:b,f=(0,L.$Tm)(k);return s(f,(F,W)=>{!F&&W&&(W.path=l(W))}),f}e.$nF=a;function s(k,r){switch(k.type){case"event":{const l=k;switch(l.event){case"output":r(!1,l.body.source);break;case"loadedSource":r(!1,l.body.source);break;case"breakpoint":r(!1,l.body.breakpoint.source);break;default:break}break}case"request":{const l=k;switch(l.command){case"setBreakpoints":r(!0,l.arguments.source);break;case"breakpointLocations":r(!0,l.arguments.source);break;case"source":r(!0,l.arguments.source);break;case"gotoTargets":r(!0,l.arguments.source);break;case"launchVSCode":l.arguments.args.forEach(f=>r(!1,f));break;default:break}break}case"response":{const l=k;if(l.success&&l.body)switch(l.command){case"stackTrace":l.body.stackFrames.forEach(f=>r(!1,f.source));break;case"loadedSources":l.body.sources.forEach(f=>r(!1,f));break;case"scopes":l.body.scopes.forEach(f=>r(!1,f.source));break;case"setFunctionBreakpoints":l.body.breakpoints.forEach(f=>r(!1,f.source));break;case"setBreakpoints":l.body.breakpoints.forEach(f=>r(!1,f.source));break;case"disassemble":l.body?.instructions.forEach(F=>r(!1,F.location));break;default:break}break}}}function o(k){return k.filter(r=>!r.presentation?.hidden).sort((r,l)=>r.presentation?l.presentation?r.presentation.group?l.presentation.group?r.presentation.group!==l.presentation.group?r.presentation.group.localeCompare(l.presentation.group):w(r.presentation.order,l.presentation.order):-1:l.presentation.group?1:w(r.presentation.order,l.presentation.order):-1:l.presentation?1:0)}e.$oF=o;function w(k,r){return typeof k!="number"?typeof r!="number"?0:1:typeof r!="number"?-1:k-r}async function v(k,r){const l=k.getValue("debug.saveBeforeStart",{overrideIdentifier:r.activeTextEditorLanguageId});if(l!=="none"&&(await r.saveAll(),l==="allEditorsInActiveGroup")){const f=r.activeEditorPane;f&&f.input.resource?.scheme===A.Schemas.untitled&&await r.save({editor:f.input,groupId:f.group.id})}await k.reloadConfiguration()}e.$pF=v;const I=(k,r)=>!k||!r?k===r:k.name===r.name&&k.path===r.path&&k.sourceReference===r.sourceReference;e.$qF=I}),define(Pe[75],Ae([1,0,25,37,66,67,12,19,22,32]),function(pe,e,y,R,C,L,A,h,S,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2H=e.$1H=e.$ZH=e.$YH=e.CellStatusbarAlignment=e.$XH=e.$WH=e.$VH=e.NotebookEditorPriority=e.$UH=e.$TH=e.$SH=e.$RH=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookExecutionState=e.NotebookCellExecutionState=e.NotebookRunState=e.$QH=e.$PH=e.$OH=e.$NH=e.CellKind=e.$MH=e.$LH=e.$KH=void 0,e.$KH="workbench.editor.notebook",e.$LH="workbench.editor.notebookTextDiffEditor",e.$MH="workbench.editor.interactive";var P;(function(z){z[z.Markup=1]="Markup",z[z.Code=2]="Code"})(P||(e.CellKind=P={})),e.$NH=["application/json","application/javascript","text/html","image/svg+xml",L.$Er.latex,L.$Er.markdown,"image/png","image/jpeg",L.$Er.text],e.$OH=[L.$Er.latex,L.$Er.markdown,"application/json","text/html","image/svg+xml","image/png","image/jpeg",L.$Er.text],e.$PH=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.$QH="_notAvailable";var D;(function(z){z[z.Running=1]="Running",z[z.Idle=2]="Idle"})(D||(e.NotebookRunState=D={}));var u;(function(z){z[z.Unconfirmed=1]="Unconfirmed",z[z.Pending=2]="Pending",z[z.Executing=3]="Executing"})(u||(e.NotebookCellExecutionState=u={}));var p;(function(z){z[z.Unconfirmed=1]="Unconfirmed",z[z.Pending=2]="Pending",z[z.Executing=3]="Executing"})(p||(e.NotebookExecutionState=p={}));var $;(function(z){z[z.WithHardKernelDependency=0]="WithHardKernelDependency",z[z.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",z[z.Pure=2]="Pure",z[z.Never=3]="Never"})($||(e.NotebookRendererMatch=$={}));var d;(function(z){z.Always="always",z.Never="never",z.Optional="optional"})(d||(e.RendererMessagingSpec=d={}));var t;(function(z){z[z.ModelChange=1]="ModelChange",z[z.Move=2]="Move",z[z.ChangeCellLanguage=5]="ChangeCellLanguage",z[z.Initialize=6]="Initialize",z[z.ChangeCellMetadata=7]="ChangeCellMetadata",z[z.Output=8]="Output",z[z.OutputItem=9]="OutputItem",z[z.ChangeCellContent=10]="ChangeCellContent",z[z.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",z[z.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",z[z.ChangeCellMime=13]="ChangeCellMime",z[z.Unknown=100]="Unknown"})(t||(e.NotebookCellsChangeType=t={}));var i;(function(z){z[z.Handle=0]="Handle",z[z.Index=1]="Index"})(i||(e.SelectionStateType=i={}));var c;(function(z){z[z.Replace=1]="Replace",z[z.Output=2]="Output",z[z.Metadata=3]="Metadata",z[z.CellLanguage=4]="CellLanguage",z[z.DocumentMetadata=5]="DocumentMetadata",z[z.Move=6]="Move",z[z.OutputItems=7]="OutputItems",z[z.PartialMetadata=8]="PartialMetadata",z[z.PartialInternalMetadata=9]="PartialInternalMetadata"})(c||(e.CellEditType=c={}));var m;(function(z){z.scheme=A.Schemas.vscodeNotebookCell;const ie=["W","X","Y","Z","a","b","c","d","e","f"],Y=new RegExp(`^[${ie.join("")}]+`),ye=7;function ke(x,ue){const O=ue.toString(ye),he=`${O.length<ie.length?ie[O.length-1]:"z"}${O}s${(0,y.$2c)(y.$Hc.fromString(x.scheme),!0,!0)}`;return x.with({scheme:z.scheme,fragment:he})}z.generate=ke;function Re(x){if(x.scheme!==z.scheme)return;const ue=x.fragment.indexOf("s");if(ue<0)return;const O=parseInt(x.fragment.substring(0,ue).replace(Y,""),ye),J=(0,y.$1c)(x.fragment.substring(ue+1)).toString();if(!isNaN(O))return{handle:O,notebook:x.with({scheme:J,fragment:null})}}z.parse=Re;function X(x,ue){return x.with({scheme:A.Schemas.vscodeNotebookCellOutput,fragment:`op${ue??""},${x.scheme!==A.Schemas.file?x.scheme:""}`})}z.generateCellOutputUri=X;function le(x){if(x.scheme!==A.Schemas.vscodeNotebookCellOutput)return;const ue=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(x.fragment);if(!ue)return;const O=ue[1]&&ue[1]!==""?ue[1]:void 0,J=ue[2];return{outputId:O,notebook:x.with({scheme:J||A.Schemas.file,fragment:null})}}z.parseCellOutputUri=le;function we(x,ue,O){return z.generate(x,ue).with({scheme:O})}z.generateCellPropertyUri=we;function ae(x,ue){if(x.scheme===ue)return z.parse(x.with({scheme:z.scheme}))}z.parseCellPropertyUri=ae})(m||(e.CellUri=m={}));const E=z=>S.$i?z.replace(/\//g,"\\"):z;class b{constructor(ie=[],Y=e.$NH){this.e=Y,this.d=[...new Set(ie)].map(ye=>({pattern:ye,matches:R.$pj(E(ye))}))}sort(ie){const Y=new Map(C.Iterable.map(ie,ke=>[ke,E(ke)]));let ye=[];for(const{matches:ke}of this.d)for(const[Re,X]of Y)if(ke(X)){ye.push(Re),Y.delete(Re);break}return Y.size&&(ye=ye.concat([...Y.keys()].sort((ke,Re)=>this.e.indexOf(ke)-this.e.indexOf(Re)))),ye}prioritize(ie,Y){const ye=this.f(ie);if(ye===-1){this.d.unshift({pattern:ie,matches:R.$pj(E(ie))});return}const ke=new Set(Y.map(X=>this.f(X,ye)));ke.delete(-1);const Re=Array.from(ke).sort();this.d.splice(ye+1,0,...Re.map(X=>this.d[X]));for(let X=Re.length-1;X>=0;X--)this.d.splice(Re[X],1)}toArray(){return this.d.map(ie=>ie.pattern)}f(ie,Y=this.d.length){const ye=E(ie);for(let ke=0;ke<Y;ke++)if(this.d[ke].matches(ye))return ke;return-1}}e.$RH=b;function n(z,ie,Y,ye=(ke,Re)=>ke===Re){const ke=[];function Re(we,ae,x){if(ae===0&&x.length===0)return;const ue=ke[ke.length-1];ue&&ue.start+ue.deleteCount===we?(ue.deleteCount+=ae,ue.toInsert.push(...x)):ke.push({start:we,deleteCount:ae,toInsert:x})}let X=0,le=0;for(;;){if(X===z.length){Re(X,0,ie.slice(le));break}if(le===ie.length){Re(X,z.length-X,[]);break}const we=z[X],ae=ie[le];if(ye(we,ae)){X+=1,le+=1;continue}Y(ae)?(Re(X,1,[]),X+=1):(Re(X,0,[ae]),le+=1)}return ke}e.$SH=n,e.$TH=new g.$Zi("notebookEditorCursorAtBoundary","none"),e.$UH=new g.$Zi("notebookEditorCursorAtLineBoundary","none");var a;(function(z){z.default="default",z.option="option"})(a||(e.NotebookEditorPriority=a={}));function s(z){const ie=z;return!!((typeof ie.include=="string"||R.$qj(ie.include))&&(typeof ie.exclude=="string"||R.$qj(ie.exclude)))}e.$VH=s;function o(z,ie,Y){if(Array.isArray(z.viewType)&&z.viewType.indexOf(ie)>=0||z.viewType===ie)return!0;if(z.filenamePattern){const ye=s(z.filenamePattern)?z.filenamePattern.include:z.filenamePattern,ke=s(z.filenamePattern)?z.filenamePattern.exclude:void 0;if(R.$oj(ye,(0,h.$cd)(Y.fsPath).toLowerCase()))return!(ke&&R.$oj(ke,(0,h.$cd)(Y.fsPath).toLowerCase()))}return!1}e.$WH=o,e.$XH={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",diffOverviewRuler:"notebook.diff.overviewRuler",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",stickyScroll:"notebook.stickyScroll.enabled",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputScrollingDeprecated:"notebook.experimental.outputScrolling",outputScrolling:"notebook.output.scrolling",textOutputLineLimit:"notebook.output.textLineLimit",formatOnSave:"notebook.formatOnSave.enabled",formatOnCellExecution:"notebook.formatOnCellExecution",codeActionsOnSave:"notebook.codeActionsOnSave",outputWordWrap:"notebook.output.wordWrap",outputLineHeightDeprecated:"notebook.outputLineHeight",outputLineHeight:"notebook.output.lineHeight",outputFontSizeDeprecated:"notebook.outputFontSize",outputFontSize:"notebook.output.fontSize",outputFontFamilyDeprecated:"notebook.outputFontFamily",outputFontFamily:"notebook.output.fontFamily",findScope:"notebook.find.scope",logging:"notebook.logging",confirmDeleteRunningCell:"notebook.confirmDeleteRunningCell",remoteSaving:"notebook.experimental.remoteSave"};var w;(function(z){z[z.Left=1]="Left",z[z.Right=2]="Right"})(w||(e.CellStatusbarAlignment=w={}));class v{static{this.d="notebook/"}static create(ie){return`${v.d}${ie}`}static parse(ie){if(ie.startsWith(v.d))return ie.substring(v.d.length)}}e.$YH=v;function I(z){return["application/vnd.code.notebook.stdout","application/vnd.code.notebook.stderr"].includes(z)}e.$ZH=I;const k=new TextDecoder;function r(z){const ie=[];let Y=!1;for(const X of z)(ie.length===0||Y)&&(ie.push(X),Y=!0);let ye=F(ie);const ke=y.$Hc.concat(ie.map(X=>y.$Hc.wrap(X))),Re=U(ke);return ye=ye||Re.byteLength!==ke.byteLength,{data:Re,didCompression:ye}}e.$1H=r,e.$2H=`${String.fromCharCode(27)}[A`;const l=e.$2H.split("").map(z=>z.charCodeAt(0)),f=10;function F(z){let ie=!1;return z.forEach((Y,ye)=>{if(ye===0||Y.length<e.$2H.length)return;const ke=z[ye-1],Re=Y.subarray(0,e.$2H.length);if(Re[0]===l[0]&&Re[1]===l[1]&&Re[2]===l[2]){const X=ke.lastIndexOf(f);if(X===-1)return;ie=!0,z[ye-1]=ke.subarray(0,X),z[ye]=Y.subarray(e.$2H.length)}}),ie}function W(z){let ie=z;do z=ie,ie=z.replace(/[^\n]\x08/gm,"");while(ie.length<z.length);return z}function V(z){for(z=z.replace(/\r+\n/gm,`
`);z.search(/\r[^$]/g)>-1;){const ie=z.match(/^(.*)\r+/m)[1];let Y=z.match(/\r+(.*)$/m)[1];Y=Y+ie.slice(Y.length,ie.length),z=z.replace(/\r+.*$/m,"\r").replace(/^.*\r/m,Y)}return z}const B="\b".charCodeAt(0),j="\r".charCodeAt(0);function U(z){return!z.buffer.includes(B)&&!z.buffer.includes(j)?z:y.$Hc.fromString(V(W(k.decode(z.buffer))))}}),define(Pe[7],Ae([1,0,18,9,49,28,67,15,16,2,36,20,38,97,75]),function(pe,e,y,R,C,L,A,h,S,g,P,D,u,p,$){"use strict";var d,t,i,c,m,E,b,n,a,s,o,w,v,I,k,r,l,f;Object.defineProperty(e,"__esModule",{value:!0}),e.RelatedInformationType=e.$JL=e.ChatVariableLevel=e.ChatMessageRole=e.InteractiveEditorResponseFeedbackKind=e.InteractiveSessionCopyKind=e.InteractiveSessionVoteDirection=e.$IL=e.$HL=e.$GL=e.$FL=e.$EL=e.$DL=e.$CL=e.$BL=e.$AL=e.$zL=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.$yL=e.$xL=e.$wL=e.$vL=e.$uL=e.$tL=e.$sL=e.$rL=e.TestRunProfileKind=e.TestResultState=e.$qL=e.$pL=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.$oL=e.$nL=e.$mL=e.NotebookControllerAffinity2=e.NotebookControllerAffinity=e.$lL=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.$kL=e.$jL=e.$iL=e.$hL=e.$gL=e.ColorThemeKind=e.$fL=e.$eL=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.$dL=e.DebugConsoleMode=e.$cL=e.$bL=e.$aL=e.$_K=e.$$K=e.CommentThreadState=e.CommentState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.$0K=e.$9K=e.FileChangeType=e.$8K=e.$7K=e.$6K=e.$5K=e.InlineCompletionTriggerKind=e.$4K=e.$3K=e.$2K=e.$1K=e.$ZK=e.$YK=e.$XK=e.$WK=e.$VK=e.$UK=e.$TK=e.$SK=e.$RK=e.ConfigurationTarget=e.$QK=e.$PK=e.$OK=e.$NK=e.$MK=e.$LK=e.$KK=e.$JK=e.$IK=e.TreeItemCheckboxState=e.TreeItemCollapsibleState=e.$HK=e.ViewBadge=e.ProgressLocation=e.$GK=e.$FK=e.TaskScope=e.ShellQuoting=e.$EK=e.$DK=e.$CK=e.TaskPanelKind=e.TaskRevealKind=e.$BK=e.TerminalLocation=e.$AK=e.$zK=e.$yK=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.$xK=e.$wK=e.$vK=e.$uK=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.$tK=e.StatusBarAlignment=e.ViewColumn=e.$sK=e.$rK=e.$qK=e.$pK=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.$oK=e.$nK=e.InlayHintKind=e.SignatureHelpTriggerKind=e.$mK=e.$lK=e.$kK=e.$jK=e.$iK=e.LanguageStatusSeverity=e.$hK=e.$gK=e.$fK=e.$eK=e.$dK=e.$cK=e.$bK=e.CodeActionTriggerKind=e.$aK=e.$_J=e.SymbolTag=e.SymbolKind=e.$$J=e.DocumentHighlightKind=e.$0J=e.$9J=e.$8J=e.$7J=e.DiagnosticSeverity=e.DiagnosticTag=e.$6J=e.$5J=e.FileEditType=e.$4J=e.$3J=e.$2J=e.EnvironmentVariableMutatorType=e.EndOfLine=e.$1J=e.$ZJ=e.$YJ=e.$XJ=e.$WJ=e.$VJ=e.$UJ=e.TerminalQuickFixType=e.TerminalOutputAnchor=void 0;function F(N){return Object.assign(N,{apply:function(...re){if(re.length===0)return Reflect.construct(N,[]);{const Se=re.length===1?[]:re[1];return Reflect.construct(N,Se,re[0].constructor)}},call:function(...re){if(re.length===0)return Reflect.construct(N,[]);{const[Se,...Je]=re;return Reflect.construct(N,Je,Se.constructor)}}})}var W;(function(N){N[N.Top=0]="Top",N[N.Bottom=1]="Bottom"})(W||(e.TerminalOutputAnchor=W={}));var V;(function(N){N[N.TerminalCommand=0]="TerminalCommand",N[N.Opener=1]="Opener",N[N.Command=3]="Command"})(V||(e.TerminalQuickFixType=V={}));let B=d=class{static from(...T){let re=T;return new d(function(){if(re){for(const Se of re)Se&&typeof Se.dispose=="function"&&Se.dispose();re=void 0}})}#e;constructor(T){this.#e=T}dispose(){typeof this.#e=="function"&&(this.#e(),this.#e=void 0)}};e.$UJ=B,e.$UJ=B=d=Ke([F],B);let j=t=class{static Min(...T){if(T.length===0)throw new TypeError;let re=T[0];for(let Se=1;Se<T.length;Se++){const Je=T[Se];Je.isBefore(re)&&(re=Je)}return re}static Max(...T){if(T.length===0)throw new TypeError;let re=T[0];for(let Se=1;Se<T.length;Se++){const Je=T[Se];Je.isAfter(re)&&(re=Je)}return re}static isPosition(T){if(!T)return!1;if(T instanceof t)return!0;const{line:re,character:Se}=T;return typeof re=="number"&&typeof Se=="number"}static of(T){if(T instanceof t)return T;if(this.isPosition(T))return new t(T.line,T.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this.c}get character(){return this.e}constructor(T,re){if(T<0)throw(0,R.$5)("line must be non-negative");if(re<0)throw(0,R.$5)("character must be non-negative");this.c=T,this.e=re}isBefore(T){return this.c<T.c?!0:T.c<this.c?!1:this.e<T.e}isBeforeOrEqual(T){return this.c<T.c?!0:T.c<this.c?!1:this.e<=T.e}isAfter(T){return!this.isBeforeOrEqual(T)}isAfterOrEqual(T){return!this.isBefore(T)}isEqual(T){return this.c===T.c&&this.e===T.e}compareTo(T){return this.c<T.c?-1:this.c>T.line?1:this.e<T.e?-1:this.e>T.e?1:0}translate(T,re=0){if(T===null||re===null)throw(0,R.$5)();let Se;return typeof T>"u"?Se=0:typeof T=="number"?Se=T:(Se=typeof T.lineDelta=="number"?T.lineDelta:0,re=typeof T.characterDelta=="number"?T.characterDelta:0),Se===0&&re===0?this:new t(this.line+Se,this.character+re)}with(T,re=this.character){if(T===null||re===null)throw(0,R.$5)();let Se;return typeof T>"u"?Se=this.line:typeof T=="number"?Se=T:(Se=typeof T.line=="number"?T.line:this.line,re=typeof T.character=="number"?T.character:this.character),Se===this.line&&re===this.character?this:new t(Se,re)}toJSON(){return{line:this.line,character:this.character}}};e.$VJ=j,e.$VJ=j=t=Ke([F],j);let U=i=class{static isRange(T){return T instanceof i?!0:T?j.isPosition(T.start)&&j.isPosition(T.end):!1}static of(T){if(T instanceof i)return T;if(this.isRange(T))return new i(T.start,T.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this.c}get end(){return this.e}constructor(T,re,Se,Je){let Xe,ot;if(typeof T=="number"&&typeof re=="number"&&typeof Se=="number"&&typeof Je=="number"?(Xe=new j(T,re),ot=new j(Se,Je)):j.isPosition(T)&&j.isPosition(re)&&(Xe=j.of(T),ot=j.of(re)),!Xe||!ot)throw new Error("Invalid arguments");Xe.isBefore(ot)?(this.c=Xe,this.e=ot):(this.c=ot,this.e=Xe)}contains(T){return i.isRange(T)?this.contains(T.start)&&this.contains(T.end):j.isPosition(T)?!(j.of(T).isBefore(this.c)||this.e.isBefore(T)):!1}isEqual(T){return this.c.isEqual(T.c)&&this.e.isEqual(T.e)}intersection(T){const re=j.Max(T.start,this.c),Se=j.Min(T.end,this.e);if(!re.isAfter(Se))return new i(re,Se)}union(T){if(this.contains(T))return this;if(T.contains(this))return T;const re=j.Min(T.start,this.c),Se=j.Max(T.end,this.end);return new i(re,Se)}get isEmpty(){return this.c.isEqual(this.e)}get isSingleLine(){return this.c.line===this.e.line}with(T,re=this.end){if(T===null||re===null)throw(0,R.$5)();let Se;return T?j.isPosition(T)?Se=T:(Se=T.start||this.start,re=T.end||this.end):Se=this.start,Se.isEqual(this.c)&&re.isEqual(this.end)?this:new i(Se,re)}toJSON(){return[this.start,this.end]}};e.$WJ=U,e.$WJ=U=i=Ke([F],U);let z=c=class extends U{static isSelection(T){return T instanceof c?!0:T?U.isRange(T)&&j.isPosition(T.anchor)&&j.isPosition(T.active)&&typeof T.isReversed=="boolean":!1}get anchor(){return this.f}get active(){return this.g}constructor(T,re,Se,Je){let Xe,ot;if(typeof T=="number"&&typeof re=="number"&&typeof Se=="number"&&typeof Je=="number"?(Xe=new j(T,re),ot=new j(Se,Je)):j.isPosition(T)&&j.isPosition(re)&&(Xe=j.of(T),ot=j.of(re)),!Xe||!ot)throw new Error("Invalid arguments");super(Xe,ot),this.f=Xe,this.g=ot}get isReversed(){return this.f===this.e}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};e.$XJ=z,e.$XJ=z=c=Ke([F],z);const ie=N=>{if(typeof N!="string"||N.length===0||!/^[0-9A-Za-z_\-]+$/.test(N))throw(0,R.$5)("connectionToken")};class Y{static isResolvedAuthority(T){return T&&typeof T=="object"&&typeof T.host=="string"&&typeof T.port=="number"&&(T.connectionToken===void 0||typeof T.connectionToken=="string")}constructor(T,re,Se){if(typeof T!="string"||T.length===0)throw(0,R.$5)("host");if(typeof re!="number"||re===0||Math.round(re)!==re)throw(0,R.$5)("port");typeof Se<"u"&&ie(Se),this.host=T,this.port=Math.round(re),this.connectionToken=Se}}e.$YJ=Y;class ye{static isManagedResolvedAuthority(T){return T&&typeof T=="object"&&typeof T.makeConnection=="function"&&(T.connectionToken===void 0||typeof T.connectionToken=="string")}constructor(T,re){this.makeConnection=T,this.connectionToken=re,typeof re<"u"&&ie(re)}}e.$ZJ=ye;class ke extends Error{static NotAvailable(T,re){return new ke(T,p.RemoteAuthorityResolverErrorCode.NotAvailable,re)}static TemporarilyNotAvailable(T){return new ke(T,p.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}constructor(T,re=p.RemoteAuthorityResolverErrorCode.Unknown,Se){super(T),this._message=T,this._code=re,this._detail=Se,Object.setPrototypeOf(this,ke.prototype)}}e.$1J=ke;var Re;(function(N){N[N.LF=1]="LF",N[N.CRLF=2]="CRLF"})(Re||(e.EndOfLine=Re={}));var X;(function(N){N[N.Replace=1]="Replace",N[N.Append=2]="Append",N[N.Prepend=3]="Prepend"})(X||(e.EnvironmentVariableMutatorType=X={}));let le=m=class{static isTextEdit(T){return T instanceof m?!0:T?U.isRange(T)&&typeof T.newText=="string":!1}static replace(T,re){return new m(T,re)}static insert(T,re){return m.replace(new U(T,T),re)}static delete(T){return m.replace(T,"")}static setEndOfLine(T){const re=new m(new U(new j(0,0),new j(0,0)),"");return re.newEol=T,re}get range(){return this.c}set range(T){if(T&&!U.isRange(T))throw(0,R.$5)("range");this.c=T}get newText(){return this.e||""}set newText(T){if(T&&typeof T!="string")throw(0,R.$5)("newText");this.e=T}get newEol(){return this.f}set newEol(T){if(T&&typeof T!="number")throw(0,R.$5)("newEol");this.f=T}constructor(T,re){this.c=T,this.e=re}toJSON(){return{range:this.range,newText:this.newText,newEol:this.f}}};e.$2J=le,e.$2J=le=m=Ke([F],le);let we=E=class{static isNotebookCellEdit(T){return T instanceof E?!0:T?Yt.isNotebookRange(T)&&Array.isArray(T.newCells):!1}static replaceCells(T,re){return new E(T,re)}static insertCells(T,re){return new E(new Yt(T,T),re)}static deleteCells(T){return new E(T,[])}static updateCellMetadata(T,re){const Se=new E(new Yt(T,T),[]);return Se.newCellMetadata=re,Se}static updateNotebookMetadata(T){const re=new E(new Yt(0,0),[]);return re.newNotebookMetadata=T,re}constructor(T,re){this.range=T,this.newCells=re}};e.$3J=we,e.$3J=we=E=Ke([F],we);class ae{static isSnippetTextEdit(T){return T instanceof ae?!0:T?U.isRange(T.range)&&O.isSnippetString(T.snippet):!1}static replace(T,re){return new ae(T,re)}static insert(T,re){return ae.replace(new U(T,T),re)}constructor(T,re){this.range=T,this.snippet=re}}e.$4J=ae;var x;(function(N){N[N.File=1]="File",N[N.Text=2]="Text",N[N.Cell=3]="Cell",N[N.CellReplace=5]="CellReplace",N[N.Snippet=6]="Snippet"})(x||(e.FileEditType=x={}));let ue=class{constructor(){this.c=[]}_allEntries(){return this.c}renameFile(T,re,Se,Je){this.c.push({_type:1,from:T,to:re,options:Se,metadata:Je})}createFile(T,re,Se){this.c.push({_type:1,from:void 0,to:T,options:re,metadata:Se})}deleteFile(T,re,Se){this.c.push({_type:1,from:T,to:void 0,options:re,metadata:Se})}e(T,re,Se){this.c.push({_type:3,metadata:Se,uri:T,edit:{editType:5,metadata:re},notebookMetadata:re})}f(T,re,Se,Je){const Xe=re.start,ot=re.end;(Xe!==ot||Se.length>0)&&this.c.push({_type:5,uri:T,index:Xe,count:ot-Xe,cells:Se,metadata:Je})}g(T,re,Se,Je){this.c.push({_type:3,metadata:Je,uri:T,edit:{editType:3,index:re,metadata:Se}})}replace(T,re,Se,Je){this.c.push({_type:2,uri:T,edit:new le(re,Se),metadata:Je})}insert(T,re,Se,Je){this.replace(T,new U(re,re),Se,Je)}delete(T,re,Se){this.replace(T,re,"",Se)}has(T){return this.c.some(re=>re._type===2&&re.uri.toString()===T.toString())}set(T,re){if(re)for(const Se of re){if(!Se)continue;let Je,Xe;Array.isArray(Se)?(Je=Se[0],Xe=Se[1]):Je=Se,we.isNotebookCellEdit(Je)?Je.newCellMetadata?this.g(T,Je.range.start,Je.newCellMetadata,Xe):Je.newNotebookMetadata?this.e(T,Je.newNotebookMetadata,Xe):this.f(T,Je.range,Je.newCells,Xe):ae.isSnippetTextEdit(Je)?this.c.push({_type:6,uri:T,range:Je.range,edit:Je.snippet,metadata:Xe}):this.c.push({_type:2,uri:T,edit:Je,metadata:Xe})}else{for(let Se=0;Se<this.c.length;Se++){const Je=this.c[Se];switch(Je._type){case 2:case 6:case 3:case 5:Je.uri.toString()===T.toString()&&(this.c[Se]=void 0);break}}(0,y.$Bf)(this.c)}}get(T){const re=[];for(const Se of this.c)Se._type===2&&Se.uri.toString()===T.toString()&&re.push(Se.edit);return re}entries(){const T=new L.$xi;for(const re of this.c)if(re._type===2){let Se=T.get(re.uri);Se||(Se=[re.uri,[]],T.set(re.uri,Se)),Se[1].push(re.edit)}return[...T.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};e.$5J=ue,e.$5J=ue=Ke([F],ue);let O=b=class{static isSnippetString(T){return T instanceof b?!0:T?typeof T.value=="string":!1}static c(T){return T.replace(/\$|}|\\/g,"\\$&")}constructor(T){this.e=1,this.value=T||""}appendText(T){return this.value+=b.c(T),this}appendTabstop(T=this.e++){return this.value+="$",this.value+=T,this}appendPlaceholder(T,re=this.e++){if(typeof T=="function"){const Se=new b;Se.e=this.e,T(Se),this.e=Se.e,T=Se.value}else T=b.c(T);return this.value+="${",this.value+=re,this.value+=":",this.value+=T,this.value+="}",this}appendChoice(T,re=this.e++){const Se=T.map(Je=>Je.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=re,this.value+="|",this.value+=Se,this.value+="|}",this}appendVariable(T,re){if(typeof re=="function"){const Se=new b;Se.e=this.e,re(Se),this.e=Se.e,re=Se.value}else typeof re=="string"&&(re=re.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=T,re&&(this.value+=":",this.value+=re),this.value+="}",this}};e.$6J=O,e.$6J=O=b=Ke([F],O);var J;(function(N){N[N.Unnecessary=1]="Unnecessary",N[N.Deprecated=2]="Deprecated"})(J||(e.DiagnosticTag=J={}));var he;(function(N){N[N.Hint=3]="Hint",N[N.Information=2]="Information",N[N.Warning=1]="Warning",N[N.Error=0]="Error"})(he||(e.DiagnosticSeverity=he={}));let Ee=n=class{static isLocation(T){return T instanceof n?!0:T?U.isRange(T.range)&&g.URI.isUri(T.uri):!1}constructor(T,re){if(this.uri=T,re)if(U.isRange(re))this.range=U.of(re);else if(j.isPosition(re))this.range=new U(re,re);else throw new Error("Illegal argument")}toJSON(){return{uri:this.uri,range:this.range}}};e.$7J=Ee,e.$7J=Ee=n=Ke([F],Ee);let ve=class{static is(T){return T?typeof T.message=="string"&&T.location&&U.isRange(T.location.range)&&g.URI.isUri(T.location.uri):!1}constructor(T,re){this.location=T,this.message=re}static isEqual(T,re){return T===re?!0:!T||!re?!1:T.message===re.message&&T.location.range.isEqual(re.location.range)&&T.location.uri.toString()===re.location.uri.toString()}};e.$8J=ve,e.$8J=ve=Ke([F],ve);let be=class{constructor(T,re,Se=he.Error){if(!U.isRange(T))throw new TypeError("range must be set");if(!re)throw new TypeError("message must be set");this.range=T,this.message=re,this.severity=Se}toJSON(){return{severity:he[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(T,re){return T===re?!0:!T||!re?!1:T.message===re.message&&T.severity===re.severity&&T.code===re.code&&T.severity===re.severity&&T.source===re.source&&T.range.isEqual(re.range)&&(0,y.$of)(T.tags,re.tags)&&(0,y.$of)(T.relatedInformation,re.relatedInformation,ve.isEqual)}};e.$9J=be,e.$9J=be=Ke([F],be);let De=class{constructor(T,re){if(!T)throw new Error("Illegal argument, contents must be defined");Array.isArray(T)?this.contents=T:this.contents=[T],this.range=re}};e.$0J=De,e.$0J=De=Ke([F],De);var oe;(function(N){N[N.Text=0]="Text",N[N.Read=1]="Read",N[N.Write=2]="Write"})(oe||(e.DocumentHighlightKind=oe={}));let de=class{constructor(T,re=oe.Text){this.range=T,this.kind=re}toJSON(){return{range:this.range,kind:oe[this.kind]}}};e.$$J=de,e.$$J=de=Ke([F],de);var se;(function(N){N[N.File=0]="File",N[N.Module=1]="Module",N[N.Namespace=2]="Namespace",N[N.Package=3]="Package",N[N.Class=4]="Class",N[N.Method=5]="Method",N[N.Property=6]="Property",N[N.Field=7]="Field",N[N.Constructor=8]="Constructor",N[N.Enum=9]="Enum",N[N.Interface=10]="Interface",N[N.Function=11]="Function",N[N.Variable=12]="Variable",N[N.Constant=13]="Constant",N[N.String=14]="String",N[N.Number=15]="Number",N[N.Boolean=16]="Boolean",N[N.Array=17]="Array",N[N.Object=18]="Object",N[N.Key=19]="Key",N[N.Null=20]="Null",N[N.EnumMember=21]="EnumMember",N[N.Struct=22]="Struct",N[N.Event=23]="Event",N[N.Operator=24]="Operator",N[N.TypeParameter=25]="TypeParameter"})(se||(e.SymbolKind=se={}));var ne;(function(N){N[N.Deprecated=1]="Deprecated"})(ne||(e.SymbolTag=ne={}));let me=a=class{static validate(T){if(!T.name)throw new Error("name must not be falsy")}constructor(T,re,Se,Je,Xe){this.name=T,this.kind=re,this.containerName=Xe,typeof Se=="string"&&(this.containerName=Se),Je instanceof Ee?this.location=Je:Se instanceof U&&(this.location=new Ee(Je,Se)),a.validate(this)}toJSON(){return{name:this.name,kind:se[this.kind],location:this.location,containerName:this.containerName}}};e.$_J=me,e.$_J=me=a=Ke([F],me);let Ce=s=class{static validate(T){if(!T.name)throw new Error("name must not be falsy");if(!T.range.contains(T.selectionRange))throw new Error("selectionRange must be contained in fullRange");T.children?.forEach(s.validate)}constructor(T,re,Se,Je,Xe){this.name=T,this.detail=re,this.kind=Se,this.range=Je,this.selectionRange=Xe,this.children=[],s.validate(this)}};e.$aK=Ce,e.$aK=Ce=s=Ke([F],Ce);var M;(function(N){N[N.Invoke=1]="Invoke",N[N.Automatic=2]="Automatic"})(M||(e.CodeActionTriggerKind=M={}));let q=class{constructor(T,re){this.title=T,this.kind=re}};e.$bK=q,e.$bK=q=Ke([F],q);let H=class{static{o=this}static{this.c="."}constructor(T){this.value=T}append(T){return new o(this.value?this.value+o.c+T:T)}intersects(T){return this.contains(T)||T.contains(this)}contains(T){return this.value===T.value||T.value.startsWith(this.value+o.c)}};e.$cK=H,e.$cK=H=o=Ke([F],H);class Z extends H{constructor(T){super(T),this.value=T}}e.$dK=Z,H.Empty=new H(""),H.QuickFix=H.Empty.append("quickfix"),H.Refactor=H.Empty.append("refactor"),H.RefactorExtract=H.Refactor.append("extract"),H.RefactorInline=H.Refactor.append("inline"),H.RefactorMove=H.Refactor.append("move"),H.RefactorRewrite=H.Refactor.append("rewrite"),H.Source=H.Empty.append("source"),H.SourceOrganizeImports=H.Source.append("organizeImports"),H.SourceFixAll=H.Source.append("fixAll"),H.Notebook=H.Empty.append("notebook");let K=class{constructor(T,re){if(this.range=T,this.parent=re,re&&!re.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};e.$eK=K,e.$eK=K=Ke([F],K);class ee{constructor(T,re,Se,Je,Xe,ot){this.kind=T,this.name=re,this.detail=Se,this.uri=Je,this.range=Xe,this.selectionRange=ot}}e.$fK=ee;class ce{constructor(T,re){this.fromRanges=re,this.from=T}}e.$gK=ce;class ze{constructor(T,re){this.fromRanges=re,this.to=T}}e.$hK=ze;var Ue;(function(N){N[N.Information=0]="Information",N[N.Warning=1]="Warning",N[N.Error=2]="Error"})(Ue||(e.LanguageStatusSeverity=Ue={}));let Ze=class{constructor(T,re){this.range=T,this.command=re}get isResolved(){return!!this.command}};e.$iK=Ze,e.$iK=Ze=Ke([F],Ze);let He=w=class{#e;static isMarkdownString(T){return T instanceof w?!0:T&&T.appendCodeblock&&T.appendMarkdown&&T.appendText&&T.value!==void 0}constructor(T,re=!1){this.#e=new C.$Vj(T,{supportThemeIcons:re})}get value(){return this.#e.value}set value(T){this.#e.value=T}get isTrusted(){return this.#e.isTrusted}set isTrusted(T){this.#e.isTrusted=T}get supportThemeIcons(){return this.#e.supportThemeIcons}set supportThemeIcons(T){this.#e.supportThemeIcons=T}get supportHtml(){return this.#e.supportHtml}set supportHtml(T){this.#e.supportHtml=T}get baseUri(){return this.#e.baseUri}set baseUri(T){this.#e.baseUri=T}appendText(T){return this.#e.appendText(T),this}appendMarkdown(T){return this.#e.appendMarkdown(T),this}appendCodeblock(T,re){return this.#e.appendCodeblock(re??"",T),this}};e.$jK=He,e.$jK=He=w=Ke([F],He);let et=class{constructor(T,re){this.label=T,this.documentation=re}};e.$kK=et,e.$kK=et=Ke([F],et);let Ye=class{constructor(T,re){this.label=T,this.documentation=re,this.parameters=[]}};e.$lK=Ye,e.$lK=Ye=Ke([F],Ye);let _e=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};e.$mK=_e,e.$mK=_e=Ke([F],_e);var it;(function(N){N[N.Invoke=1]="Invoke",N[N.TriggerCharacter=2]="TriggerCharacter",N[N.ContentChange=3]="ContentChange"})(it||(e.SignatureHelpTriggerKind=it={}));var tt;(function(N){N[N.Type=1]="Type",N[N.Parameter=2]="Parameter"})(tt||(e.InlayHintKind=tt={}));let Ne=class{constructor(T){this.value=T}};e.$nK=Ne,e.$nK=Ne=Ke([F],Ne);let st=class{constructor(T,re,Se){this.position=T,this.label=re,this.kind=Se}};e.$oK=st,e.$oK=st=Ke([F],st);var _;(function(N){N[N.Invoke=0]="Invoke",N[N.TriggerCharacter=1]="TriggerCharacter",N[N.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(_||(e.CompletionTriggerKind=_={}));var Q;(function(N){N[N.Text=0]="Text",N[N.Method=1]="Method",N[N.Function=2]="Function",N[N.Constructor=3]="Constructor",N[N.Field=4]="Field",N[N.Variable=5]="Variable",N[N.Class=6]="Class",N[N.Interface=7]="Interface",N[N.Module=8]="Module",N[N.Property=9]="Property",N[N.Unit=10]="Unit",N[N.Value=11]="Value",N[N.Enum=12]="Enum",N[N.Keyword=13]="Keyword",N[N.Snippet=14]="Snippet",N[N.Color=15]="Color",N[N.File=16]="File",N[N.Reference=17]="Reference",N[N.Folder=18]="Folder",N[N.EnumMember=19]="EnumMember",N[N.Constant=20]="Constant",N[N.Struct=21]="Struct",N[N.Event=22]="Event",N[N.Operator=23]="Operator",N[N.TypeParameter=24]="TypeParameter",N[N.User=25]="User",N[N.Issue=26]="Issue"})(Q||(e.CompletionItemKind=Q={}));var $e;(function(N){N[N.Deprecated=1]="Deprecated"})($e||(e.CompletionItemTag=$e={}));let je=class{constructor(T,re){this.label=T,this.kind=re}toJSON(){return{label:this.label,kind:this.kind&&Q[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};e.$pK=je,e.$pK=je=Ke([F],je);let Oe=class{constructor(T=[],re=!1){this.items=T,this.isIncomplete=re}};e.$qK=Oe,e.$qK=Oe=Ke([F],Oe);let Qe=class{constructor(T,re,Se){this.insertText=T,this.range=re,this.command=Se}};e.$rK=Qe,e.$rK=Qe=Ke([F],Qe);let nt=class{constructor(T){this.commands=void 0,this.suppressSuggestions=void 0,this.items=T}};e.$sK=nt,e.$sK=nt=Ke([F],nt);var gt;(function(N){N[N.Active=-1]="Active",N[N.Beside=-2]="Beside",N[N.One=1]="One",N[N.Two=2]="Two",N[N.Three=3]="Three",N[N.Four=4]="Four",N[N.Five=5]="Five",N[N.Six=6]="Six",N[N.Seven=7]="Seven",N[N.Eight=8]="Eight",N[N.Nine=9]="Nine"})(gt||(e.ViewColumn=gt={}));var vt;(function(N){N[N.Left=1]="Left",N[N.Right=2]="Right"})(vt||(e.StatusBarAlignment=vt={}));function Ft(N,T){return`${D.$Tl.toKey(N)}.${T}`}e.$tK=Ft;var Qt;(function(N){N[N.Off=0]="Off",N[N.On=1]="On",N[N.Relative=2]="Relative"})(Qt||(e.TextEditorLineNumbersStyle=Qt={}));var Vt;(function(N){N[N.Manual=1]="Manual",N[N.AfterDelay=2]="AfterDelay",N[N.FocusOut=3]="FocusOut"})(Vt||(e.TextDocumentSaveReason=Vt={}));var wt;(function(N){N[N.Default=0]="Default",N[N.InCenter=1]="InCenter",N[N.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",N[N.AtTop=3]="AtTop"})(wt||(e.TextEditorRevealType=wt={}));var Tt;(function(N){N[N.Keyboard=1]="Keyboard",N[N.Mouse=2]="Mouse",N[N.Command=3]="Command"})(Tt||(e.TextEditorSelectionChangeKind=Tt={}));var zt;(function(N){N[N.Undo=1]="Undo",N[N.Redo=2]="Redo"})(zt||(e.TextDocumentChangeReason=zt={}));var Jt;(function(N){N[N.OpenOpen=0]="OpenOpen",N[N.ClosedClosed=1]="ClosedClosed",N[N.OpenClosed=2]="OpenClosed",N[N.ClosedOpen=3]="ClosedOpen"})(Jt||(e.DecorationRangeBehavior=Jt={})),function(N){function T(re){switch(re){case"keyboard":return N.Keyboard;case"mouse":return N.Mouse;case"api":return N.Command}}N.fromValue=T}(Tt||(e.TextEditorSelectionChangeKind=Tt={}));let Pt=class{constructor(T,re){if(re&&!g.URI.isUri(re))throw(0,R.$5)("target");if(!U.isRange(T)||T.isEmpty)throw(0,R.$5)("range");this.range=T,this.target=re}};e.$uK=Pt,e.$uK=Pt=Ke([F],Pt);let At=class{constructor(T,re,Se,Je){this.red=T,this.green=re,this.blue=Se,this.alpha=Je}};e.$vK=At,e.$vK=At=Ke([F],At);let Ot=class{constructor(T,re){if(re&&!(re instanceof At))throw(0,R.$5)("color");if(!U.isRange(T)||T.isEmpty)throw(0,R.$5)("range");this.range=T,this.color=re}};e.$wK=Ot,e.$wK=Ot=Ke([F],Ot);let jt=class{constructor(T){if(!T||typeof T!="string")throw(0,R.$5)("label");this.label=T}};e.$xK=jt,e.$xK=jt=Ke([F],jt);var qt;(function(N){N[N.RGB=0]="RGB",N[N.HEX=1]="HEX",N[N.HSL=2]="HSL"})(qt||(e.ColorFormat=qt={}));var Bt;(function(N){N[N.Error=0]="Error",N[N.Warning=1]="Warning",N[N.Information=2]="Information"})(Bt||(e.SourceControlInputBoxValidationType=Bt={}));var at;(function(N){N[N.Unknown=0]="Unknown",N[N.Shutdown=1]="Shutdown",N[N.Process=2]="Process",N[N.User=3]="User",N[N.Extension=4]="Extension"})(at||(e.TerminalExitReason=at={}));class ut{constructor(T,re,Se){if(this.startIndex=T,this.length=re,this.tooltip=Se,typeof T!="number"||T<0)throw(0,R.$5)("startIndex");if(typeof re!="number"||re<1)throw(0,R.$5)("length");if(Se!==void 0&&typeof Se!="string")throw(0,R.$5)("tooltip")}}e.$yK=ut;class Ht{constructor(T){this.uri=T}}e.$zK=Ht;class Ct{constructor(T){this.terminalCommand=T}}e.$AK=Ct;var kt;(function(N){N[N.Panel=1]="Panel",N[N.Editor=2]="Editor"})(kt||(e.TerminalLocation=kt={}));class ht{constructor(T){if(this.options=T,typeof T!="object")throw(0,R.$5)("options")}}e.$BK=ht;var St;(function(N){N[N.Always=1]="Always",N[N.Silent=2]="Silent",N[N.Never=3]="Never"})(St||(e.TaskRevealKind=St={}));var Lt;(function(N){N[N.Shared=1]="Shared",N[N.Dedicated=2]="Dedicated",N[N.New=3]="New"})(Lt||(e.TaskPanelKind=Lt={}));let Et=class{static{v=this}static{this.Clean=new v("clean","Clean")}static{this.Build=new v("build","Build")}static{this.Rebuild=new v("rebuild","Rebuild")}static{this.Test=new v("test","Test")}static from(T){switch(T){case"clean":return v.Clean;case"build":return v.Build;case"rebuild":return v.Rebuild;case"test":return v.Test;default:return}}constructor(T,re){if(this.label=re,typeof T!="string"||typeof re!="string")throw(0,R.$5)("name");this.c=T}get id(){return this.c}};e.$CK=Et,e.$CK=Et=v=Ke([F],Et);function qe(N){let T="";for(let re=0;re<N.length;re++)T+=N[re].replace(/,/g,",,")+",";return T}let Nt=class{constructor(T,re,Se){if(typeof T!="string")throw(0,R.$5)("process");this.e=[],this.c=T,re!==void 0&&(Array.isArray(re)?(this.e=re,this.f=Se):this.f=re)}get process(){return this.c}set process(T){if(typeof T!="string")throw(0,R.$5)("process");this.c=T}get args(){return this.e}set args(T){Array.isArray(T)||(T=[]),this.e=T}get options(){return this.f}set options(T){this.f=T}computeId(){const T=[];if(T.push("process"),this.c!==void 0&&T.push(this.c),this.e&&this.e.length>0)for(const re of this.e)T.push(re);return qe(T)}};e.$DK=Nt,e.$DK=Nt=Ke([F],Nt);let Ie=class{constructor(T,re,Se){if(this.f=[],Array.isArray(re)){if(!T)throw(0,R.$5)("command can't be undefined or null");if(typeof T!="string"&&typeof T.value!="string")throw(0,R.$5)("command");this.e=T,this.f=re,this.g=Se}else{if(typeof T!="string")throw(0,R.$5)("commandLine");this.c=T,this.g=re}}get commandLine(){return this.c}set commandLine(T){if(typeof T!="string")throw(0,R.$5)("commandLine");this.c=T}get command(){return this.e?this.e:""}set command(T){if(typeof T!="string"&&typeof T.value!="string")throw(0,R.$5)("command");this.e=T}get args(){return this.f}set args(T){this.f=T||[]}get options(){return this.g}set options(T){this.g=T}computeId(){const T=[];if(T.push("shell"),this.c!==void 0&&T.push(this.c),this.e!==void 0&&T.push(typeof this.e=="string"?this.e:this.e.value),this.f&&this.f.length>0)for(const re of this.f)T.push(typeof re=="string"?re:re.value);return qe(T)}};e.$EK=Ie,e.$EK=Ie=Ke([F],Ie);var Me;(function(N){N[N.Escape=1]="Escape",N[N.Strong=2]="Strong",N[N.Weak=3]="Weak"})(Me||(e.ShellQuoting=Me={}));var ge;(function(N){N[N.Global=1]="Global",N[N.Workspace=2]="Workspace"})(ge||(e.TaskScope=ge={}));class G{constructor(T){this.c=T}computeId(){return"customExecution"+(0,P.$6e)()}set callback(T){this.c=T}get callback(){return this.c}}e.$FK=G;let Fe=class{static{I=this}static{this.c="customExecution"}static{this.e="process"}static{this.f="shell"}static{this.g="$empty"}constructor(T,re,Se,Je,Xe,ot){this.j=!1,this.k=this.definition=T;let lt;typeof re=="string"?(this.m=this.name=re,this.t=this.source=Se,this.execution=Je,lt=Xe,this.j=!0):re===ge.Global||re===ge.Workspace?(this.target=re,this.m=this.name=Se,this.t=this.source=Je,this.execution=Xe,lt=ot):(this.target=re,this.m=this.name=Se,this.t=this.source=Je,this.execution=Xe,lt=ot),typeof lt=="string"?(this.o=[lt],this.q=!0):Array.isArray(lt)?(this.o=lt,this.q=!0):(this.o=[],this.q=!1),this.r=!1,this.v=Object.create(null),this.w=Object.create(null)}get _id(){return this.h}set _id(T){this.h=T}get _deprecated(){return this.j}y(){this.h!==void 0&&(this.h=void 0,this.l=void 0,this.z())}z(){this.n instanceof Nt?this.k={type:I.e,id:this.n.computeId()}:this.n instanceof Ie?this.k={type:I.f,id:this.n.computeId()}:this.n instanceof G?this.k={type:I.c,id:this.n.computeId()}:this.k={type:I.g,id:(0,P.$6e)()}}get definition(){return this.k}set definition(T){if(T==null)throw(0,R.$5)("Kind can't be undefined or null");this.y(),this.k=T}get scope(){return this.l}set target(T){this.y(),this.l=T}get name(){return this.m}set name(T){if(typeof T!="string")throw(0,R.$5)("name");this.y(),this.m=T}get execution(){return this.n}set execution(T){T===null&&(T=void 0),this.y(),this.n=T;const re=this.k.type;(I.g===re||I.e===re||I.f===re||I.c===re)&&this.z()}get problemMatchers(){return this.o}set problemMatchers(T){if(Array.isArray(T))this.y(),this.o=T,this.q=!0;else{this.y(),this.o=[],this.q=!1;return}}get hasDefinedMatchers(){return this.q}get isBackground(){return this.r}set isBackground(T){T!==!0&&T!==!1&&(T=!1),this.y(),this.r=T}get source(){return this.t}set source(T){if(typeof T!="string"||T.length===0)throw(0,R.$5)("source must be a string of length > 0");this.y(),this.t=T}get group(){return this.u}set group(T){T===null&&(T=void 0),this.y(),this.u=T}get detail(){return this.x}set detail(T){T===null&&(T=void 0),this.x=T}get presentationOptions(){return this.v}set presentationOptions(T){T==null&&(T=Object.create(null)),this.y(),this.v=T}get runOptions(){return this.w}set runOptions(T){T==null&&(T=Object.create(null)),this.y(),this.w=T}};e.$GK=Fe,e.$GK=Fe=I=Ke([F],Fe);var Be;(function(N){N[N.SourceControl=1]="SourceControl",N[N.Window=10]="Window",N[N.Notification=15]="Notification"})(Be||(e.ProgressLocation=Be={}));var Ge;(function(N){function T(re){const Se=re;return(0,S.$pe)(Se.value)?Se.tooltip&&!(0,S.$le)(Se.tooltip)?(console.log("INVALID view badge, invalid tooltip",Se.tooltip),!1):!0:(console.log("INVALID view badge, invalid value",Se.value),!1)}N.isViewBadge=T})(Ge||(e.ViewBadge=Ge={}));let We=k=class{static isTreeItem(T,re){const Se=T;if(Se.checkboxState!==void 0){const Je=(0,S.$pe)(Se.checkboxState)?Se.checkboxState:(0,S.$ne)(Se.checkboxState)&&(0,S.$pe)(Se.checkboxState.state)?Se.checkboxState.state:void 0,Xe=!(0,S.$pe)(Se.checkboxState)&&(0,S.$ne)(Se.checkboxState)?Se.checkboxState.tooltip:void 0;if(Je===void 0||Je!==pt.Checked&&Je!==pt.Unchecked||Xe!==void 0&&!(0,S.$le)(Xe))return console.log("INVALID tree item, invalid checkboxState",Se.checkboxState),!1}if(T instanceof k)return!0;if(Se.label!==void 0&&!(0,S.$le)(Se.label)&&!Se.label?.label)return console.log("INVALID tree item, invalid label",Se.label),!1;if(Se.id!==void 0&&!(0,S.$le)(Se.id))return console.log("INVALID tree item, invalid id",Se.id),!1;if(Se.iconPath!==void 0&&!(0,S.$le)(Se.iconPath)&&!g.URI.isUri(Se.iconPath)&&(!Se.iconPath||!(0,S.$le)(Se.iconPath.id))){const Je=Se.iconPath;if(!Je||!(0,S.$le)(Je.light)&&!g.URI.isUri(Je.light)&&!(0,S.$le)(Je.dark)&&!g.URI.isUri(Je.dark))return console.log("INVALID tree item, invalid iconPath",Se.iconPath),!1}return Se.description!==void 0&&!(0,S.$le)(Se.description)&&typeof Se.description!="boolean"?(console.log("INVALID tree item, invalid description",Se.description),!1):Se.resourceUri!==void 0&&!g.URI.isUri(Se.resourceUri)?(console.log("INVALID tree item, invalid resourceUri",Se.resourceUri),!1):Se.tooltip!==void 0&&!(0,S.$le)(Se.tooltip)&&!(Se.tooltip instanceof He)?(console.log("INVALID tree item, invalid tooltip",Se.tooltip),!1):Se.command!==void 0&&!Se.command.command?(console.log("INVALID tree item, invalid command",Se.command),!1):Se.collapsibleState!==void 0&&Se.collapsibleState<xe.None&&Se.collapsibleState>xe.Expanded?(console.log("INVALID tree item, invalid collapsibleState",Se.collapsibleState),!1):Se.contextValue!==void 0&&!(0,S.$le)(Se.contextValue)?(console.log("INVALID tree item, invalid contextValue",Se.contextValue),!1):Se.accessibilityInformation!==void 0&&!Se.accessibilityInformation?.label?(console.log("INVALID tree item, invalid accessibilityInformation",Se.accessibilityInformation),!1):!0}constructor(T,re=xe.None){this.collapsibleState=re,g.URI.isUri(T)?this.resourceUri=T:this.label=T}};e.$HK=We,e.$HK=We=k=Ke([F],We);var xe;(function(N){N[N.None=0]="None",N[N.Collapsed=1]="Collapsed",N[N.Expanded=2]="Expanded"})(xe||(e.TreeItemCollapsibleState=xe={}));var pt;(function(N){N[N.Unchecked=0]="Unchecked",N[N.Checked=1]="Checked"})(pt||(e.TreeItemCheckboxState=pt={}));let bt=class{async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}constructor(T){this.value=T}};e.$IK=bt,e.$IK=bt=Ke([F],bt);class dt extends bt{}e.$JK=dt;class ft extends dt{#e;constructor(T){super(""),this.#e=T}asFile(){return this.#e}}e.$KK=ft;class mt{constructor(T,re,Se,Je){this.name=T,this.uri=re,this._itemId=Se,this.c=Je}data(){return this.c()}}e.$LK=mt;let gi=class{#e=new Map;constructor(T){for(const[re,Se]of T??[]){const Je=this.#e.get(this.#t(re));Je?Je.push(Se):this.#e.set(this.#t(re),[Se])}}get(T){return this.#e.get(this.#t(T))?.[0]}set(T,re){this.#e.set(this.#t(T),[re])}forEach(T,re){for(const[Se,Je]of this.#e)for(const Xe of Je)T.call(re,Xe,Se,this)}*[Symbol.iterator](){for(const[T,re]of this.#e)for(const Se of re)yield[T,Se]}#t(T){return T.toLowerCase()}};e.$MK=gi,e.$MK=gi=Ke([F],gi);let Kt=class{constructor(T){this.insertText=T}};e.$NK=Kt,e.$NK=Kt=Ke([F],Kt);let Ei=class{constructor(T,re){this.label=re,this.insertText=T}};e.$OK=Ei,e.$OK=Ei=Ke([F],Ei);let Wt=class{constructor(T,re){this.id=T,this.color=re}static isThemeIcon(T){return typeof T.id!="string"?(console.log("INVALID ThemeIcon, invalid id",T.id),!1):!0}};e.$PK=Wt,e.$PK=Wt=Ke([F],Wt),Wt.File=new Wt("file"),Wt.Folder=new Wt("folder");let mi=class{constructor(T){this.id=T}};e.$QK=mi,e.$QK=mi=Ke([F],mi);var It;(function(N){N[N.Global=1]="Global",N[N.Workspace=2]="Workspace",N[N.WorkspaceFolder=3]="WorkspaceFolder"})(It||(e.ConfigurationTarget=It={}));let ki=class{get base(){return this.c}set base(T){this.c=T,this.e=g.URI.file(T)}get baseUri(){return this.e}set baseUri(T){this.e=T,this.c=T.fsPath}constructor(T,re){if(typeof T!="string"&&(!T||!g.URI.isUri(T)&&!g.URI.isUri(T.uri)))throw(0,R.$5)("base");if(typeof re!="string")throw(0,R.$5)("pattern");typeof T=="string"?this.baseUri=g.URI.file(T):g.URI.isUri(T)?this.baseUri=T:this.baseUri=T.uri,this.pattern=re}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};e.$RK=ki,e.$RK=ki=Ke([F],ki);const Vi=new WeakMap;function Dt(N,T){Vi.set(N,T)}e.$SK=Dt;let ti=class{constructor(T,re,Se,Je){this.enabled=typeof T=="boolean"?T:!0,typeof re=="string"&&(this.condition=re),typeof Se=="string"&&(this.hitCondition=Se),typeof Je=="string"&&(this.logMessage=Je)}get id(){return this.c||(this.c=Vi.get(this)??(0,P.$6e)()),this.c}};e.$TK=ti,e.$TK=ti=Ke([F],ti);let $i=class extends ti{constructor(T,re,Se,Je,Xe){if(super(re,Se,Je,Xe),T===null)throw(0,R.$5)("location");this.location=T}};e.$UK=$i,e.$UK=$i=Ke([F],$i);let si=class extends ti{constructor(T,re,Se,Je,Xe){super(re,Se,Je,Xe),this.functionName=T}};e.$VK=si,e.$VK=si=Ke([F],si);let Di=class extends ti{constructor(T,re,Se,Je,Xe,ot,lt){if(super(Je,Xe,ot,lt),!re)throw(0,R.$5)("dataId");this.label=T,this.dataId=re,this.canPersist=Se}};e.$WK=Di,e.$WK=Di=Ke([F],Di);let Si=class{constructor(T,re,Se){this.command=T,this.args=re||[],this.options=Se}};e.$XK=Si,e.$XK=Si=Ke([F],Si);let Rt=class{constructor(T,re){this.port=T,this.host=re}};e.$YK=Rt,e.$YK=Rt=Ke([F],Rt);let pi=class{constructor(T){this.path=T}};e.$ZK=pi,e.$ZK=pi=Ke([F],pi);let Ii=class{constructor(T){this.implementation=T}};e.$1K=Ii,e.$1K=Ii=Ke([F],Ii);let oi=class{constructor(T,re,Se){this.session=T,this.threadId=re,this.frameId=Se}};e.$2K=oi,e.$2K=oi=Ke([F],oi);let ai=class{constructor(T,re){this.session=T,this.threadId=re}};e.$3K=ai,e.$3K=ai=Ke([F],ai);let ct=class{constructor(T,re){this.range=T,this.expression=re}};e.$4K=ct,e.$4K=ct=Ke([F],ct);var qi;(function(N){N[N.Invoke=0]="Invoke",N[N.Automatic=1]="Automatic"})(qi||(e.InlineCompletionTriggerKind=qi={}));let Xt=class{constructor(T,re){this.range=T,this.text=re}};e.$5K=Xt,e.$5K=Xt=Ke([F],Xt);let ii=class{constructor(T,re,Se=!0){this.range=T,this.variableName=re,this.caseSensitiveLookup=Se}};e.$6K=ii,e.$6K=ii=Ke([F],ii);let bi=class{constructor(T,re){this.range=T,this.expression=re}};e.$7K=bi,e.$7K=bi=Ke([F],bi);let Ci=class{constructor(T,re){this.frameId=T,this.stoppedLocation=re}};e.$8K=Ci,e.$8K=Ci=Ke([F],Ci);var Ki;(function(N){N[N.Changed=1]="Changed",N[N.Created=2]="Created",N[N.Deleted=3]="Deleted"})(Ki||(e.FileChangeType=Ki={}));let Pi=r=class extends Error{static FileExists(T){return new r(T,u.FileSystemProviderErrorCode.FileExists,r.FileExists)}static FileNotFound(T){return new r(T,u.FileSystemProviderErrorCode.FileNotFound,r.FileNotFound)}static FileNotADirectory(T){return new r(T,u.FileSystemProviderErrorCode.FileNotADirectory,r.FileNotADirectory)}static FileIsADirectory(T){return new r(T,u.FileSystemProviderErrorCode.FileIsADirectory,r.FileIsADirectory)}static NoPermissions(T){return new r(T,u.FileSystemProviderErrorCode.NoPermissions,r.NoPermissions)}static Unavailable(T){return new r(T,u.FileSystemProviderErrorCode.Unavailable,r.Unavailable)}constructor(T,re=u.FileSystemProviderErrorCode.Unknown,Se){super(g.URI.isUri(T)?T.toString(!0):T),this.code=Se?.name??"Unknown",(0,u.$fk)(this,re),Object.setPrototypeOf(this,r.prototype),typeof Error.captureStackTrace=="function"&&typeof Se=="function"&&Error.captureStackTrace(this,Se)}};e.$9K=Pi,e.$9K=Pi=r=Ke([F],Pi);let vi=class{constructor(T,re,Se){this.start=T,this.end=re,this.kind=Se}};e.$0K=vi,e.$0K=vi=Ke([F],vi);var Ji;(function(N){N[N.Comment=1]="Comment",N[N.Imports=2]="Imports",N[N.Region=3]="Region"})(Ji||(e.FoldingRangeKind=Ji={}));var Ai;(function(N){N[N.Collapsed=0]="Collapsed",N[N.Expanded=1]="Expanded"})(Ai||(e.CommentThreadCollapsibleState=Ai={}));var ci;(function(N){N[N.Editing=0]="Editing",N[N.Preview=1]="Preview"})(ci||(e.CommentMode=ci={}));var Hi;(function(N){N[N.Published=0]="Published",N[N.Draft=1]="Draft"})(Hi||(e.CommentState=Hi={}));var wi;(function(N){N[N.Unresolved=0]="Unresolved",N[N.Resolved=1]="Resolved"})(wi||(e.CommentThreadState=wi={}));class Ri{constructor(T,re=[]){this.tokenTypes=T,this.tokenModifiers=re}}e.$$K=Ri;function cn(N){return typeof N>"u"||(0,S.$me)(N)}class Mi{constructor(T){if(this.c=0,this.e=0,this.f=!0,this.g=[],this.h=0,this.j=new Map,this.k=new Map,this.l=!1,T){this.l=!0;for(let re=0,Se=T.tokenTypes.length;re<Se;re++)this.j.set(T.tokenTypes[re],re);for(let re=0,Se=T.tokenModifiers.length;re<Se;re++)this.k.set(T.tokenModifiers[re],re)}}push(T,re,Se,Je,Xe){if(typeof T=="number"&&typeof re=="number"&&typeof Se=="number"&&typeof Je=="number"&&(typeof Xe=="number"||typeof Xe>"u"))return typeof Xe>"u"&&(Xe=0),this.n(T,re,Se,Je,Xe);if(U.isRange(T)&&typeof re=="string"&&cn(Se))return this.m(T,re,Se);throw(0,R.$5)()}m(T,re,Se){if(!this.l)throw new Error("Legend must be provided in constructor");if(T.start.line!==T.end.line)throw new Error("`range` cannot span multiple lines");if(!this.j.has(re))throw new Error("`tokenType` is not in the provided legend");const Je=T.start.line,Xe=T.start.character,ot=T.end.character-T.start.character,lt=this.j.get(re);let Ut=0;if(Se)for(const Zt of Se){if(!this.k.has(Zt))throw new Error("`tokenModifier` is not in the provided legend");const xt=this.k.get(Zt);Ut|=1<<xt>>>0}this.n(Je,Xe,ot,lt,Ut)}n(T,re,Se,Je,Xe){if(this.f&&(T<this.c||T===this.c&&re<this.e)){this.f=!1;const Ut=this.g.length/5|0;let Zt=0,xt=0;for(let ei=0;ei<Ut;ei++){let ri=this.g[5*ei],Bi=this.g[5*ei+1];ri===0?(ri=Zt,Bi+=xt):ri+=Zt,this.g[5*ei]=ri,this.g[5*ei+1]=Bi,Zt=ri,xt=Bi}}let ot=T,lt=re;this.f&&this.h>0&&(ot-=this.c,ot===0&&(lt-=this.e)),this.g[this.h++]=ot,this.g[this.h++]=lt,this.g[this.h++]=Se,this.g[this.h++]=Je,this.g[this.h++]=Xe,this.c=T,this.e=re}static o(T){const re=[],Se=T.length/5|0;for(let lt=0;lt<Se;lt++)re[lt]=lt;re.sort((lt,Ut)=>{const Zt=T[5*lt],xt=T[5*Ut];if(Zt===xt){const ei=T[5*lt+1],ri=T[5*Ut+1];return ei-ri}return Zt-xt});const Je=new Uint32Array(T.length);let Xe=0,ot=0;for(let lt=0;lt<Se;lt++){const Ut=5*re[lt],Zt=T[Ut+0],xt=T[Ut+1],ei=T[Ut+2],ri=T[Ut+3],Bi=T[Ut+4],wn=Zt-Xe,Mn=wn===0?xt-ot:xt,Wi=5*lt;Je[Wi+0]=wn,Je[Wi+1]=Mn,Je[Wi+2]=ei,Je[Wi+3]=ri,Je[Wi+4]=Bi,Xe=Zt,ot=xt}return Je}build(T){return this.f?new ni(new Uint32Array(this.g),T):new ni(Mi.o(this.g),T)}}e.$_K=Mi;class ni{constructor(T,re){this.resultId=re,this.data=T}}e.$aL=ni;class un{constructor(T,re,Se){this.start=T,this.deleteCount=re,this.data=Se}}e.$bL=un;class ln{constructor(T,re){this.resultId=re,this.edits=T}}e.$cL=ln;var Gi;(function(N){N[N.Separate=0]="Separate",N[N.MergeWithParent=1]="MergeWithParent"})(Gi||(e.DebugConsoleMode=Gi={}));let fi=class{static{this.Back={iconPath:new Wt("arrow-left")}}constructor(){}};e.$dL=fi,e.$dL=fi=Ke([F],fi);var Zi;(function(N){N[N.Separator=-1]="Separator",N[N.Default=0]="Default"})(Zi||(e.QuickPickItemKind=Zi={}));var Qi;(function(N){N[N.Info=1]="Info",N[N.Warning=2]="Warning",N[N.Error=3]="Error"})(Qi||(e.InputBoxValidationSeverity=Qi={}));var ui;(function(N){N[N.UI=1]="UI",N[N.Workspace=2]="Workspace"})(ui||(e.ExtensionKind=ui={}));class Xi{static validate(T){if(typeof T.badge=="string"){let re=(0,h.$Yd)(T.badge,0);if(re<T.badge.length&&(re+=(0,h.$Yd)(T.badge,re)),T.badge.length>re)throw new Error("The 'badge'-property must be undefined or a short character")}else if(T.badge&&!Wt.isThemeIcon(T.badge))throw new Error("The 'badge'-property is not a valid ThemeIcon");if(!T.color&&!T.badge&&!T.tooltip)throw new Error("The decoration is empty");return!0}constructor(T,re,Se){this.badge=T,this.tooltip=re,this.color=Se}}e.$eL=Xi;let Fi=class{constructor(T){this.kind=T}};e.$fL=Fi,e.$fL=Fi=Ke([F],Fi);var Yi;(function(N){N[N.Light=1]="Light",N[N.Dark=2]="Dark",N[N.HighContrast=3]="HighContrast",N[N.HighContrastLight=4]="HighContrastLight"})(Yi||(e.ColorThemeKind=Yi={}));class Yt{static isNotebookRange(T){return T instanceof Yt?!0:T?typeof T.start=="number"&&typeof T.end=="number":!1}get start(){return this.c}get end(){return this.e}get isEmpty(){return this.c===this.e}constructor(T,re){if(T<0)throw(0,R.$5)("start must be positive");if(re<0)throw(0,R.$5)("end must be positive");T<=re?(this.c=T,this.e=re):(this.c=re,this.e=T)}with(T){let re=this.c,Se=this.e;return T.start!==void 0&&(re=T.start),T.end!==void 0&&(Se=T.end),re===this.c&&Se===this.e?this:new Yt(re,Se)}}e.$gL=Yt;class yi{static validate(T){if(typeof T.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof T.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof T.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(T){return Array.isArray(T)&&T.every(re=>yi.isNotebookCellData(re))}static isNotebookCellData(T){return!0}constructor(T,re,Se,Je,Xe,ot,lt){this.kind=T,this.value=re,this.languageId=Se,this.mime=Je,this.outputs=Xe??[],this.metadata=ot,this.executionSummary=lt,yi.validate(this)}}e.$hL=yi;class hn{constructor(T){this.cells=T}}e.$iL=hn;class Gt{static isNotebookCellOutputItem(T){return T instanceof Gt?!0:T?typeof T.mime=="string"&&T.data instanceof Uint8Array:!1}static error(T){const re={name:T.name,message:T.message,stack:T.stack};return Gt.json(re,"application/vnd.code.notebook.error")}static stdout(T){return Gt.text(T,"application/vnd.code.notebook.stdout")}static stderr(T){return Gt.text(T,"application/vnd.code.notebook.stderr")}static bytes(T,re="application/octet-stream"){return new Gt(T,re)}static#e=new TextEncoder;static text(T,re=A.$Er.text){const Se=Gt.#e.encode(String(T));return new Gt(Se,re)}static json(T,re="text/x-json"){const Se=JSON.stringify(T,void 0,"	");return Gt.text(Se,re)}constructor(T,re){this.data=T,this.mime=re;const Se=(0,A.$Ir)(re,!0);if(!Se)throw new Error(`INVALID mime type: ${re}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=Se}}e.$jL=Gt;class li{static isNotebookCellOutput(T){return T instanceof li?!0:!T||typeof T!="object"?!1:typeof T.id=="string"&&Array.isArray(T.items)}static ensureUniqueMimeTypes(T,re=!1){const Se=new Set,Je=new Set;for(let Xe=0;Xe<T.length;Xe++){const ot=T[Xe],lt=(0,A.$Ir)(ot.mime);if(!Se.has(lt)||(0,$.$ZH)(lt)){Se.add(lt);continue}Je.add(Xe),re&&console.warn(`DUPLICATED mime type '${ot.mime}' will be dropped`)}return Je.size===0?T:T.filter((Xe,ot)=>!Je.has(ot))}constructor(T,re,Se){this.items=li.ensureUniqueMimeTypes(T,!0),typeof re=="string"?(this.id=re,this.metadata=Se):(this.id=(0,P.$6e)(),this.metadata=re??Se)}}e.$kL=li;var Ti;(function(N){N[N.Markup=1]="Markup",N[N.Code=2]="Code"})(Ti||(e.NotebookCellKind=Ti={}));var Le;(function(N){N[N.Idle=1]="Idle",N[N.Pending=2]="Pending",N[N.Executing=3]="Executing"})(Le||(e.NotebookCellExecutionState=Le={}));var _t;(function(N){N[N.Left=1]="Left",N[N.Right=2]="Right"})(_t||(e.NotebookCellStatusBarAlignment=_t={}));var Li;(function(N){N[N.Default=0]="Default",N[N.InCenter=1]="InCenter",N[N.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",N[N.AtTop=3]="AtTop"})(Li||(e.NotebookEditorRevealType=Li={}));class $t{constructor(T,re){this.text=T,this.alignment=re}}e.$lL=$t;var _i;(function(N){N[N.Default=1]="Default",N[N.Preferred=2]="Preferred"})(_i||(e.NotebookControllerAffinity=_i={}));var xi;(function(N){N[N.Default=1]="Default",N[N.Preferred=2]="Preferred",N[N.Hidden=-1]="Hidden"})(xi||(e.NotebookControllerAffinity2=xi={}));class en{constructor(T,re=[]){this.uri=T,this.provides=(0,y.$Vf)(re)}}e.$mL=en;class dn{constructor(T){this.label=T}}e.$nL=dn;let hi=class{constructor(T,re){this.label=T,this.timestamp=re}};e.$oL=hi,e.$oL=hi=Ke([F],hi);var tn;(function(N){N[N.Production=1]="Production",N[N.Development=2]="Development",N[N.Test=3]="Test"})(tn||(e.ExtensionMode=tn={}));var nn;(function(N){N[N.Node=1]="Node",N[N.Webworker=2]="Webworker"})(nn||(e.ExtensionRuntime=nn={}));var rn;(function(N){N[N.Other=0]="Other",N[N.Comment=1]="Comment",N[N.String=2]="String",N[N.RegEx=3]="RegEx"})(rn||(e.StandardTokenType=rn={}));class sn{constructor(T,re){this.ranges=T,this.wordPattern=re}}e.$pL=sn;class fn{constructor(T){this.c=T}get autoForwardAction(){return this.c}}e.$qL=fn;var on;(function(N){N[N.Queued=1]="Queued",N[N.Running=2]="Running",N[N.Passed=3]="Passed",N[N.Failed=4]="Failed",N[N.Skipped=5]="Skipped",N[N.Errored=6]="Errored"})(on||(e.TestResultState=on={}));var an;(function(N){N[N.Run=1]="Run",N[N.Debug=2]="Debug",N[N.Coverage=3]="Coverage"})(an||(e.TestRunProfileKind=an={}));let zi=class{constructor(T=void 0,re=void 0,Se=void 0,Je=!1){this.include=T,this.exclude=re,this.profile=Se,this.continuous=Je}};e.$rL=zi,e.$rL=zi=Ke([F],zi);let Oi=l=class{static diff(T,re,Se){const Je=new l(T);return Je.expectedOutput=re,Je.actualOutput=Se,Je}constructor(T){this.message=T}};e.$sL=Oi,e.$sL=Oi=l=Ke([F],Oi);let Ni=class{constructor(T){this.id=T}};e.$tL=Ni,e.$tL=Ni=Ke([F],Ni);let di=class{constructor(T,re){this.covered=T,this.total=re}};e.$uL=di,e.$uL=di=Ke([F],di);let Ui=f=class{static fromDetails(T,re){const Se=new di(0,0),Je=new di(0,0),Xe=new di(0,0);for(const lt of re)if("branches"in lt){Se.total+=1,Se.covered+=lt.executionCount>0?1:0;for(const Ut of lt.branches)Je.total+=1,Je.covered+=Ut.executionCount>0?1:0}else Xe.total+=1,Xe.covered+=lt.executionCount>0?1:0;const ot=new f(T,Se,Je.total>0?Je:void 0,Xe.total>0?Xe:void 0);return ot.detailedCoverage=re,ot}constructor(T,re,Se,Je){this.uri=T,this.statementCoverage=re,this.branchCoverage=Se,this.functionCoverage=Je}};e.$vL=Ui,e.$vL=Ui=f=Ke([F],Ui);let ji=class{constructor(T,re,Se=[]){this.executionCount=T,this.location=re,this.branches=Se}};e.$wL=ji,e.$wL=ji=Ke([F],ji);let te=class{constructor(T,re){this.executionCount=T,this.location=re}};e.$xL=te,e.$xL=te=Ke([F],te);let fe=class{constructor(T,re){this.executionCount=T,this.location=re}};e.$yL=fe,e.$yL=fe=Ke([F],fe);var Te;(function(N){N[N.None=0]="None",N[N.Option=1]="Option",N[N.Default=2]="Default",N[N.Preferred=3]="Preferred"})(Te||(e.ExternalUriOpenerPriority=Te={}));var rt;(function(N){N[N.Untrusted=0]="Untrusted",N[N.Trusted=1]="Trusted",N[N.Unspecified=2]="Unspecified"})(rt||(e.WorkspaceTrustState=rt={}));var yt;(function(N){N[N.Notify=1]="Notify",N[N.OpenBrowser=2]="OpenBrowser",N[N.OpenPreview=3]="OpenPreview",N[N.Silent=4]="Silent",N[N.Ignore=5]="Ignore",N[N.OpenBrowserOnce=6]="OpenBrowserOnce"})(yt||(e.PortAutoForwardAction=yt={}));class Mt{constructor(T,re,Se,Je,Xe,ot){this.kind=T,this.name=re,this.detail=Se,this.uri=Je,this.range=Xe,this.selectionRange=ot}}e.$zL=Mt;class yn{constructor(T){this.uri=T}}e.$AL=yn;class En{constructor(T,re){this.original=T,this.modified=re}}e.$BL=En;class kn{constructor(T,re,Se,Je){this.base=T,this.input1=re,this.input2=Se,this.result=Je}}e.$CL=kn;class Dn{constructor(T,re){this.uri=T,this.viewType=re}}e.$DL=Dn;class Sn{constructor(T){this.viewType=T}}e.$EL=Sn;class In{constructor(T,re){this.uri=T,this.notebookType=re}}e.$FL=In;class Cn{constructor(T,re,Se){this.original=T,this.modified=re,this.notebookType=Se}}e.$GL=Cn;class Pn{constructor(){}}e.$HL=Pn;class An{constructor(T,re){this.uri=T,this.inputBoxUri=re}}e.$IL=An;var gn;(function(N){N[N.Up=1]="Up",N[N.Down=2]="Down"})(gn||(e.InteractiveSessionVoteDirection=gn={}));var mn;(function(N){N[N.Action=1]="Action",N[N.Toolbar=2]="Toolbar"})(mn||(e.InteractiveSessionCopyKind=mn={}));var $n;(function(N){N[N.Unhelpful=0]="Unhelpful",N[N.Helpful=1]="Helpful",N[N.Undone=2]="Undone",N[N.Accepted=3]="Accepted"})($n||(e.InteractiveEditorResponseFeedbackKind=$n={}));var pn;(function(N){N[N.System=0]="System",N[N.User=1]="User",N[N.Assistant=2]="Assistant",N[N.Function=3]="Function"})(pn||(e.ChatMessageRole=pn={}));var bn;(function(N){N[N.Short=1]="Short",N[N.Medium=2]="Medium",N[N.Full=3]="Full"})(bn||(e.ChatVariableLevel=bn={}));class Rn{constructor(T,re){this.role=T,this.content=re}}e.$JL=Rn;var vn;(function(N){N[N.SymbolInformation=1]="SymbolInformation",N[N.CommandInformation=2]="CommandInformation",N[N.SearchInformation=3]="SearchInformation",N[N.SettingInformation=4]="SettingInformation"})(vn||(e.RelatedInformationType=vn={}))}),define(Pe[101],Ae([1,0,50,12,15,277,137,7,18]),function(pe,e,y,R,C,L,A,h,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$YL=e.$XL=e.$WL=void 0;const g=new Map;function P($,d){d?g.set($,d):g.delete($)}e.$WL=P;function D($){return g.get($)}class u extends L.$Ju{constructor(d,t,i,c,m,E,b,n){super(t,i,c,m),this.c=d,this.m=E,this.q=b,this.notebook=n,this.b=!1}dispose(){(0,y.ok)(!this.b),this.b=!0,this.q=!1}equalLines(d){return(0,S.$of)(this.f,d)}get document(){if(!this.a){const d=this;this.a={get uri(){return d.d},get fileName(){return d.d.fsPath},get isUntitled(){return d.d.scheme===R.Schemas.untitled},get languageId(){return d.m},get version(){return d.h},get isClosed(){return d.b},get isDirty(){return d.q},save(){return d.r()},getText(t){return t?d.s(t):d.getText()},get eol(){return d.g===`
`?h.EndOfLine.LF:h.EndOfLine.CRLF},get lineCount(){return d.f.length},lineAt(t){return d.t(t)},offsetAt(t){return d.u(t)},positionAt(t){return d.v(t)},validateRange(t){return d.w(t)},validatePosition(t){return d.x(t)},getWordRangeAtPosition(t,i){return d.y(t,i)}}}return Object.freeze(this.a)}_acceptLanguageId(d){(0,y.ok)(!this.b),this.m=d}_acceptIsDirty(d){(0,y.ok)(!this.b),this.q=d}r(){return this.b?Promise.reject(new Error("Document has been closed")):this.c.$trySaveDocument(this.d)}s(d){const t=this.w(d);if(t.isEmpty)return"";if(t.isSingleLine)return this.f[t.start.line].substring(t.start.character,t.end.character);const i=this.g,c=t.start.line,m=t.end.line,E=[];E.push(this.f[c].substring(t.start.character));for(let b=c+1;b<m;b++)E.push(this.f[b]);return E.push(this.f[m].substring(0,t.end.character)),E.join(i)}t(d){let t;if(d instanceof h.$VJ?t=d.line:typeof d=="number"&&(t=d),typeof t!="number"||t<0||t>=this.f.length||Math.floor(t)!==t)throw new Error("Illegal value for `line`");return new p(t,this.f[t],t===this.f.length-1)}u(d){return d=this.x(d),this.l(),this.j.getPrefixSum(d.line-1)+d.character}v(d){d=Math.floor(d),d=Math.max(0,d),this.l();const t=this.j.getIndexOf(d),i=this.f[t.index].length;return new h.$VJ(t.index,Math.min(t.remainder,i))}w(d){if(!(d instanceof h.$WJ))throw new Error("Invalid argument");const t=this.x(d.start),i=this.x(d.end);return t===d.start&&i===d.end?d:new h.$WJ(t.line,t.character,i.line,i.character)}x(d){if(!(d instanceof h.$VJ))throw new Error("Invalid argument");if(this.f.length===0)return d.with(0,0);let{line:t,character:i}=d,c=!1;if(t<0)t=0,i=0,c=!0;else if(t>=this.f.length)t=this.f.length-1,i=this.f[t].length,c=!0;else{const m=this.f[t].length;i<0?(i=0,c=!0):i>m&&(i=m,c=!0)}return c?new h.$VJ(t,i):d}y(d,t){const i=this.x(d);if(!t)t=D(this.m);else if((0,C.$Bd)(t))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${t.source}' because it matches the empty string.`);const c=(0,A.$Wr)(i.character+1,(0,A.$Ur)(t),this.f[i.line],0);if(c)return new h.$WJ(i.line,c.startColumn-1,i.line,c.endColumn-1)}}e.$XL=u;class p{constructor(d,t,i){this.a=d,this.b=t,this.c=i}get lineNumber(){return this.a}get text(){return this.b}get range(){return new h.$WJ(this.a,0,this.a,this.b.length)}get rangeIncludingLineBreak(){return this.c?this.range:new h.$WJ(this.a,0,this.a+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this.b)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this.b.length}}e.$YL=p}),define(Pe[197],Ae([1,0,7,17,5]),function(pe,e,y,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7bc=void 0;let L=class{constructor(h){this.a=new y.$fL(y.ColorThemeKind.Dark),this.b=new C.$hc}get activeColorTheme(){return this.a}$onColorThemeChange(h){let S;switch(h){case"light":S=y.ColorThemeKind.Light;break;case"hcDark":S=y.ColorThemeKind.HighContrast;break;case"hcLight":S=y.ColorThemeKind.HighContrastLight;break;default:S=y.ColorThemeKind.Dark}this.a=new y.$fL(S),this.b.fire(this.a)}get onDidChangeActiveColorTheme(){return this.b.event}};e.$7bc=L,e.$7bc=L=Ke([Ve(0,R.$UL)],L)}),define(Pe[198],Ae([1,0,4]),function(pe,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4H=e.CellExecutionUpdateType=void 0;var R;(function(C){C[C.Output=1]="Output",C[C.OutputItems=2]="OutputItems",C[C.ExecutionState=3]="ExecutionState"})(R||(e.CellExecutionUpdateType=R={})),e.$4H=(0,y.$zh)("INotebookExecutionService")}),define(Pe[45],Ae([1,0]),function(pe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$FI=e.TestPosition=e.TestIdPathParts=void 0;var y;(function(L){L.Delimiter="\0"})(y||(e.TestIdPathParts=y={}));var R;(function(L){L[L.IsSame=0]="IsSame",L[L.Disconnected=1]="Disconnected",L[L.IsChild=2]="IsChild",L[L.IsParent=3]="IsParent"})(R||(e.TestPosition=R={}));class C{static fromExtHostTestItem(A,h,S=A.parent){if(A._isRoot)return new C([h]);const g=[A.id];for(let P=S;P&&P.id!==h;P=P.parent)g.push(P.id);return g.push(h),new C(g.reverse())}static isRoot(A){return!A.includes("\0")}static root(A){const h=A.indexOf("\0");return h===-1?A:A.slice(0,h)}static fromString(A){return new C(A.split("\0"))}static join(A,h){return new C([...A.path,h])}static joinToString(A,h){return A.toString()+"\0"+h}static parentId(A){const h=A.lastIndexOf("\0");return h===-1?void 0:A.slice(0,h)}static localId(A){const h=A.lastIndexOf("\0");return h===-1?A:A.slice(h+1)}static isChild(A,h){return h.startsWith(A)&&h[A.length]==="\0"}static compare(A,h){return A===h?0:C.isChild(A,h)?2:C.isChild(h,A)?3:1}constructor(A,h=A.length){if(this.path=A,this.d=h,A.length===0||h<1)throw new Error("cannot create test with empty path")}get rootId(){return new C(this.path,1)}get parentId(){return this.d>1?new C(this.path,this.d-1):void 0}get localId(){return this.path[this.d-1]}get controllerId(){return this.path[0]}get isRoot(){return this.d===1}*idsFromRoot(){for(let A=1;A<=this.d;A++)yield new C(this.path,A)}*idsToRoot(){for(let A=this.d;A>0;A--)yield new C(this.path,A)}compare(A){if(typeof A=="string")return C.compare(this.toString(),A);for(let h=0;h<A.d&&h<this.d;h++)if(A.path[h]!==this.path[h])return 1;return A.d>this.d?2:A.d<this.d?3:0}toJSON(){return this.toString()}toString(){if(!this.c){this.c=this.path[0];for(let A=1;A<this.d;A++)this.c+="\0",this.c+=this.path[A]}return this.c}}e.$FI=C}),define(Pe[56],Ae([1,0,2,44,45]),function(pe,e,y,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$MI=e.TestsDiffOp=e.TestDiffOpType=e.DetailType=e.TestResultItem=e.$LI=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.$KI=e.$JI=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.$II=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.$HI=e.$GI=e.TestRunProfileBitset=e.ExtTestRunProfileKind=e.TestResultState=void 0;var L;(function(k){k[k.Unset=0]="Unset",k[k.Queued=1]="Queued",k[k.Running=2]="Running",k[k.Passed=3]="Passed",k[k.Failed=4]="Failed",k[k.Skipped=5]="Skipped",k[k.Errored=6]="Errored"})(L||(e.TestResultState=L={}));var A;(function(k){k[k.Run=1]="Run",k[k.Debug=2]="Debug",k[k.Coverage=3]="Coverage"})(A||(e.ExtTestRunProfileKind=A={}));var h;(function(k){k[k.Run=2]="Run",k[k.Debug=4]="Debug",k[k.Coverage=8]="Coverage",k[k.HasNonDefaultProfile=16]="HasNonDefaultProfile",k[k.HasConfigurable=32]="HasConfigurable",k[k.SupportsContinuousRun=64]="SupportsContinuousRun"})(h||(e.TestRunProfileBitset=h={})),e.$GI=[2,4,8,16,32,64];const S=k=>"runId"in k;e.$HI=S;var g;(function(k){k.serialize=r=>({range:r.range.toJSON(),uri:r.uri.toJSON()}),k.deserialize=r=>({range:R.$hs.lift(r.range),uri:y.URI.revive(r.uri)})})(g||(e.IRichLocation=g={}));var P;(function(k){k[k.Error=0]="Error",k[k.Output=1]="Output"})(P||(e.TestMessageType=P={}));var D;(function(k){k.serialize=r=>({message:r.message,type:0,expected:r.expected,actual:r.actual,contextValue:r.contextValue,location:r.location&&g.serialize(r.location)}),k.deserialize=r=>({message:r.message,type:0,expected:r.expected,actual:r.actual,contextValue:r.contextValue,location:r.location&&g.deserialize(r.location)})})(D||(e.ITestErrorMessage=D={}));const u=(k,r)=>`${r?"s":"e"}${k}`;e.$II=u;var p;(function(k){k.serialize=r=>({message:r.message,type:1,offset:r.offset,length:r.length,location:r.location&&g.serialize(r.location)}),k.deserialize=r=>({message:r.message,type:1,offset:r.offset,length:r.length,location:r.location&&g.deserialize(r.location)})})(p||(e.ITestOutputMessage=p={}));var $;(function(k){k.serialize=r=>r.type===0?D.serialize(r):p.serialize(r),k.deserialize=r=>r.type===0?D.deserialize(r):p.deserialize(r)})($||(e.ITestMessage=$={}));var d;(function(k){k.serializeWithoutMessages=r=>({state:r.state,duration:r.duration,messages:[]}),k.serialize=r=>({state:r.state,duration:r.duration,messages:r.messages.map($.serialize)}),k.deserialize=r=>({state:r.state,duration:r.duration,messages:r.messages.map($.deserialize)})})(d||(e.ITestTaskState=d={}));const t="\0",i=(k,r)=>k+t+r;e.$JI=i;const c=k=>{const r=k.indexOf(t);return{ctrlId:k.slice(0,r),tagId:k.slice(r+1)}};e.$KI=c;var m;(function(k){k.serialize=r=>({extId:r.extId,label:r.label,tags:r.tags,busy:r.busy,children:void 0,uri:r.uri?.toJSON(),range:r.range?.toJSON()||null,description:r.description,error:r.error,sortText:r.sortText}),k.deserialize=r=>({extId:r.extId,label:r.label,tags:r.tags,busy:r.busy,children:void 0,uri:r.uri?y.URI.revive(r.uri):void 0,range:r.range?R.$hs.lift(r.range):null,description:r.description,error:r.error,sortText:r.sortText})})(m||(e.ITestItem=m={}));var E;(function(k){k[k.NotExpandable=0]="NotExpandable",k[k.Expandable=1]="Expandable",k[k.BusyExpanding=2]="BusyExpanding",k[k.Expanded=3]="Expanded"})(E||(e.TestItemExpandState=E={}));var b;(function(k){k.serialize=r=>({expand:r.expand,item:m.serialize(r.item)}),k.deserialize=r=>({controllerId:C.$FI.root(r.item.extId),expand:r.expand,item:m.deserialize(r.item)})})(b||(e.InternalTestItem=b={}));var n;(function(k){k.serialize=r=>{let l;return r.item&&(l={},r.item.label!==void 0&&(l.label=r.item.label),r.item.tags!==void 0&&(l.tags=r.item.tags),r.item.busy!==void 0&&(l.busy=r.item.busy),r.item.uri!==void 0&&(l.uri=r.item.uri?.toJSON()),r.item.range!==void 0&&(l.range=r.item.range?.toJSON()),r.item.description!==void 0&&(l.description=r.item.description),r.item.error!==void 0&&(l.error=r.item.error),r.item.sortText!==void 0&&(l.sortText=r.item.sortText)),{extId:r.extId,expand:r.expand,item:l}},k.deserialize=r=>{let l;return r.item&&(l={},r.item.label!==void 0&&(l.label=r.item.label),r.item.tags!==void 0&&(l.tags=r.item.tags),r.item.busy!==void 0&&(l.busy=r.item.busy),r.item.range!==void 0&&(l.range=r.item.range?R.$hs.lift(r.item.range):null),r.item.description!==void 0&&(l.description=r.item.description),r.item.error!==void 0&&(l.error=r.item.error),r.item.sortText!==void 0&&(l.sortText=r.item.sortText)),{extId:r.extId,expand:r.expand,item:l}}})(n||(e.ITestItemUpdate=n={}));const a=(k,r)=>{r.expand!==void 0&&(k.expand=r.expand),r.item!==void 0&&(k.item=k.item?Object.assign(k.item,r.item):r.item)};e.$LI=a;var s;(function(k){k.serializeWithoutMessages=r=>({...b.serialize(r),ownComputedState:r.ownComputedState,computedState:r.computedState,tasks:r.tasks.map(d.serializeWithoutMessages)}),k.serialize=r=>({...b.serialize(r),ownComputedState:r.ownComputedState,computedState:r.computedState,tasks:r.tasks.map(d.serialize)}),k.deserialize=r=>({...b.deserialize(r),ownComputedState:r.ownComputedState,computedState:r.computedState,tasks:r.tasks.map(d.deserialize),retired:!0})})(s||(e.TestResultItem=s={}));var o;(function(k){k[k.Function=0]="Function",k[k.Statement=1]="Statement"})(o||(e.DetailType=o={}));var w;(function(k){k[k.Add=0]="Add",k[k.Update=1]="Update",k[k.DocumentSynced=2]="DocumentSynced",k[k.Remove=3]="Remove",k[k.IncrementPendingExtHosts=4]="IncrementPendingExtHosts",k[k.Retire=5]="Retire",k[k.AddTag=6]="AddTag",k[k.RemoveTag=7]="RemoveTag"})(w||(e.TestDiffOpType=w={}));var v;(function(k){k.deserialize=r=>r.op===0?{op:r.op,item:b.deserialize(r.item)}:r.op===1?{op:r.op,item:n.deserialize(r.item)}:r.op===2?{op:r.op,uri:y.URI.revive(r.uri),docv:r.docv}:r,k.serialize=r=>r.op===0?{op:r.op,item:b.serialize(r.item)}:r.op===1?{op:r.op,item:n.serialize(r.item)}:r})(v||(e.TestsDiffOp=v={}));class I{constructor(){this.d=new Map,this.f=new Map,this.g=new Set,this.h=0,this.j=0,this.tags=this.d}apply(r){const l=this.p();for(const f of r)switch(f.op){case 0:this.k(b.deserialize(f.item),l);break;case 1:this.l(n.deserialize(f.item),l);break;case 3:this.m(f.itemId,l);break;case 5:this.o(f.itemId);break;case 4:this.updatePendingRoots(f.amount);break;case 6:this.d.set(f.tag.id,f.tag);break;case 7:this.d.delete(f.id);break}l.complete?.()}k(r,l){const f=C.$FI.parentId(r.item.extId)?.toString();let F;if(!f)F=this.q(r),this.g.add(F),this.f.set(r.item.extId,F);else if(this.f.has(f)){const W=this.f.get(f);W.children.add(r.item.extId),F=this.q(r,W),this.f.set(r.item.extId,F)}else{console.error(`Test with unknown parent ID: ${JSON.stringify(r)}`);return}return l.add?.(F),r.expand===2&&this.h++,F}l(r,l){const f=this.f.get(r.extId);if(f)return r.expand!==void 0&&(f.expand===2&&this.h--,r.expand===2&&this.h++),(0,e.$LI)(f,r),l.update?.(f),f}m(r,l){const f=this.f.get(r);if(!f)return;const F=C.$FI.parentId(f.item.extId)?.toString();F?this.f.get(F).children.delete(f.item.extId):this.g.delete(f);const W=[[r]];for(;W.length;)for(const V of W.pop()){const B=this.f.get(V);B&&(W.push(B.children),this.f.delete(V),l.remove?.(B,B!==f),B.expand===2&&this.h--)}}o(r){}updatePendingRoots(r){this.j+=r}p(){return{}}}e.$MI=I}),define(Pe[76],Ae([1,0,13,5,6,50,56,45]),function(pe,e,y,R,C,L,A,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$OL=e.$NL=e.$ML=e.$LL=e.$KL=e.TestItemEventOp=void 0;var S;(function(c){c[c.Upsert=0]="Upsert",c[c.SetTags=1]="SetTags",c[c.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",c[c.RemoveChild=3]="RemoveChild",c[c.SetProp=4]="SetProp",c[c.Bulk=5]="Bulk",c[c.DocumentSynced=6]="DocumentSynced"})(S||(e.TestItemEventOp=S={}));const g=(c,m)=>c===m,D=Object.entries({range:(c,m)=>c===m?!0:!c||!m?!1:c.equalsRange(m),busy:g,label:g,description:g,error:g,sortText:g,tags:(c,m)=>!(c.length!==m.length||c.some(E=>!m.includes(E)))}),u=(c,m)=>{let E;for(const[b,n]of D)n(c[b],m[b])||(E?E[b]=m[b]:E={[b]:m[b]});return E};class p extends C.$mb{get root(){return this.m.root}constructor(m){super(),this.m=m,this.f=this.B(new y.$Qg(()=>this.flushDiff(),200)),this.g=this.B(new R.$hc),this.tree=new Map,this.j=new Map,this.k=[],this.onDidGenerateDiff=this.g.event,this.root.canResolveChildren=!0,this.u(this.root,void 0)}set resolveHandler(m){this.h=m;for(const E of this.tree.values())this.G(E)}get resolveHandler(){return this.h}collectDiff(){const m=this.k;return this.k=[],m}pushDiff(m){switch(m.op){case 2:{for(const E of this.k)if(E.op===2&&E.uri===m.uri){E.docv=m.docv;return}break}case 1:{const E=this.k[this.k.length-1];if(E){if(E.op===1&&E.item.extId===m.item.extId){(0,A.$LI)(E.item,m.item);return}if(E.op===0&&E.item.item.extId===m.item.extId){(0,A.$LI)(E.item,m.item);return}}break}}this.k.push(m),this.f.isScheduled()||this.f.schedule()}expand(m,E){const b=this.tree.get(m);if(b){if((b.expandLevels===void 0||E>b.expandLevels)&&(b.expandLevels=E),b.expand===1){const n=this.I(b);return n.isOpen()?this.H(b,E-1):n.wait().then(()=>this.H(b,E-1))}else if(b.expand===3)return b.resolveBarrier?.isOpen()===!1?b.resolveBarrier.wait().then(()=>this.H(b,E-1)):this.H(b,E-1)}}dispose(){for(const m of this.tree.values())this.m.getApiFor(m.actual).listener=void 0;this.tree.clear(),this.k=[],super.dispose()}p(m,E){switch(E.op){case 3:this.L(h.$FI.joinToString(m.fullId,E.id));break;case 0:this.u(E.item,m);break;case 5:for(const b of E.ops)this.p(m,b);break;case 1:this.w(E.new,E.old,m.fullId.toString());break;case 2:this.G(m);break;case 4:this.pushDiff({op:1,item:{extId:m.fullId.toString(),item:E.update}});break;case 6:this.s(m.actual.uri);break;default:(0,L.$xb)(E)}}s(m){m&&this.pushDiff({op:2,uri:m,docv:this.m.getDocumentVersion(m)})}u(m,E){const b=h.$FI.fromExtHostTestItem(m,this.root.id,E?.actual),n=this.m.getApiFor(m);n.parent&&n.parent!==E?.actual&&this.m.getChildren(n.parent).delete(m.id);let a=this.tree.get(b.toString());if(!a){a={fullId:b,actual:m,expandLevels:E?.expandLevels?E.expandLevels-1:void 0,expand:0},m.tags.forEach(this.y,this),this.tree.set(a.fullId.toString(),a),this.C(m,E),this.pushDiff({op:0,item:{controllerId:this.m.controllerId,expand:a.expand,item:this.m.toITestItem(m)}}),this.F(m,a,E);return}if(a.actual===m){this.D(m,a,E);return}if(a.actual.uri?.toString()!==m.uri?.toString())return this.L(b.toString()),this.u(m,E);const s=this.m.getChildren(a.actual),o=a.actual,w=u(this.m.toITestItem(o),this.m.toITestItem(m));this.m.getApiFor(o).listener=void 0,a.actual=m,a.expand=0,w&&(w.hasOwnProperty("tags")&&(this.w(m.tags,o.tags,b.toString()),delete w.tags),this.p(a,{op:4,update:w})),this.F(m,a,E);for(const[v,I]of s)this.m.getChildren(m).get(I.id)||this.L(h.$FI.joinToString(b,I.id));this.s(a.actual.uri)}w(m,E,b){const n=new Set(E.map(a=>a.id));for(const a of m)n.delete(a.id)||this.y(a);this.pushDiff({op:1,item:{extId:b,item:{tags:m.map(a=>(0,A.$JI)(this.m.controllerId,a.id))}}}),n.forEach(this.z,this)}y(m){const E=this.j.get(m.id);E?E.refCount++:(this.j.set(m.id,{refCount:1}),this.pushDiff({op:6,tag:{id:(0,A.$JI)(this.m.controllerId,m.id)}}))}z(m){const E=this.j.get(m);E&&!--E.refCount&&(this.j.delete(m),this.pushDiff({op:7,id:(0,A.$JI)(this.m.controllerId,m)}))}C(m,E){this.m.getApiFor(m).parent=E&&E.actual!==this.root?E.actual:void 0}D(m,E,b){this.C(m,b);const n=this.m.getApiFor(m);n.parent=b?.actual,n.listener=a=>this.p(E,a),this.G(E)}F(m,E,b){this.D(m,E,b);for(const[n,a]of this.m.getChildren(m))this.u(a,E)}G(m){let E;this.h?m.resolveBarrier?E=m.resolveBarrier.isOpen()?3:2:E=m.actual.canResolveChildren?1:0:E=0,E!==m.expand&&(m.expand=E,this.pushDiff({op:1,item:{extId:m.fullId.toString(),expand:E}}),E===1&&m.expandLevels!==void 0&&this.I(m))}H(m,E){if(E<0)return;const b=[];for(const[n,a]of this.m.getChildren(m.actual)){const s=this.expand(h.$FI.joinToString(m.fullId,a.id),E);(0,y.$rg)(s)&&b.push(s)}if(b.length)return Promise.all(b).then(()=>{})}I(m){if(m.resolveBarrier)return m.resolveBarrier;if(!this.h){const a=new y.$Dg;return a.open(),a}m.expand=2,this.J(m);const E=m.resolveBarrier=new y.$Dg,b=a=>{console.error(`Unhandled error in resolveHandler of test controller "${this.m.controllerId}"`,a)};let n;try{n=this.h(m.actual===this.root?void 0:m.actual)}catch(a){b(a)}return(0,y.$rg)(n)?n.catch(b).then(()=>{E.open(),this.G(m)}):(E.open(),this.G(m)),m.resolveBarrier}J(m){this.pushDiff({op:1,item:{extId:m.fullId.toString(),expand:m.expand}})}L(m){const E=this.tree.get(m);if(!E)throw new Error("attempting to remove non-existent child");this.pushDiff({op:3,itemId:m});const b=[E];for(;b.length;){const n=b.pop();if(n){this.m.getApiFor(n.actual).listener=void 0;for(const a of n.actual.tags)this.z(a.id);this.tree.delete(n.fullId.toString());for(const[a,s]of this.m.getChildren(n.actual))b.push(this.tree.get(h.$FI.joinToString(n.fullId,s.id)))}}}flushDiff(){const m=this.collectDiff();m.length&&this.g.fire(m)}}e.$KL=p;class $ extends Error{constructor(m){super(`Attempted to insert a duplicate test item ID ${m}`)}}e.$LL=$;class d extends Error{constructor(m){super(`TestItem with ID "${m}" is invalid. Make sure to create it from the createTestItem method.`)}}e.$ML=d;class t extends Error{constructor(m,E,b){super(`TestItem with ID "${m}" is from controller "${E}" and cannot be added as a child of an item from controller "${b}".`)}}e.$NL=t;const i=(c,m,E)=>{let b=new Map;return{get size(){return b.size},forEach(n,a){for(const s of b.values())n.call(a,s,this)},[Symbol.iterator](){return b.entries()},replace(n){const a=new Map,s=new Set(b.keys()),o={op:5,ops:[]};for(const w of n){if(!(w instanceof E))throw new d(w.id);const v=m(w).controllerId;if(v!==c.controllerId)throw new t(w.id,v,c.controllerId);if(a.has(w.id))throw new $(w.id);a.set(w.id,w),s.delete(w.id),o.ops.push({op:0,item:w})}for(const w of s.keys())o.ops.push({op:3,id:w});c.listener?.(o),b=a},add(n){if(!(n instanceof E))throw new d(n.id);b.set(n.id,n),c.listener?.({op:0,item:n})},delete(n){b.delete(n)&&c.listener?.({op:3,id:n})},get(n){return b.get(n)},toJSON(){return Array.from(b.values())}}};e.$OL=i}),define(Pe[102],Ae([1,0,76]),function(pe,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$QL=e.$PL=void 0;const R=new WeakMap,C=(A,h)=>{const S={controllerId:h};return R.set(A,S),S};e.$PL=C;const L=A=>{const h=R.get(A);if(!h)throw new y.$ML(A?.id||"<unknown>");return h};e.$QL=L}),define(Pe[77],Ae([1,0,12,2]),function(pe,e,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bob=e.$Aob=e.$zob=e.$yob=e.$xob=void 0,e.$xob="vscode-cdn.net",e.$yob=`vscode-resource.${e.$xob}`,e.$zob=`'self' https://*.${e.$xob}`;function C(h,S){return h.scheme===y.Schemas.http||h.scheme===y.Schemas.https?h:(S&&S.authority&&S.isRemote&&h.scheme===y.Schemas.file&&(h=R.URI.from({scheme:y.Schemas.vscodeRemote,authority:S.authority,path:h.path})),R.URI.from({scheme:y.Schemas.https,authority:`${h.scheme}+${L(h.authority)}.${e.$yob}`,path:h.path,fragment:h.fragment,query:h.query}))}e.$Aob=C;function L(h){return h.replace(/./g,S=>{const g=S.charCodeAt(0);return g>=97&&g<=122||g>=65&&g<=90||g>=48&&g<=57?S:"-"+g.toString(16).padStart(4,"0")})}function A(h){return h.replace(/-([0-9a-f]{4})/g,(S,g)=>String.fromCharCode(parseInt(g,16)))}e.$Bob=A}),define(Pe[199],Ae([1,0,5,6,77]),function(pe,e,y,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ebc=void 0;class L{constructor(h,S,g){this.d=h,this.e=S,this.f=g,this.a=0,this.b=new R.$lb,this.c=new Map,this.b.add(S.onDidChangeVisibleTextEditors(()=>{const P=S.getVisibleTextEditors();for(const D of this.c.values())P.indexOf(D.editor)<0&&D.inset.dispose()}))}dispose(){this.c.forEach(h=>h.inset.dispose()),this.b.dispose()}createWebviewEditorInset(h,S,g,P,D){let u;for(const m of this.e.getVisibleTextEditors(!0))if(m.value===h){u=m;break}if(!u)throw new Error("not a visible editor");const p=this,$=this.a++,d=new y.$hc,t=new y.$hc,i=new class{constructor(){this.a="",this.b=Object.create(null)}asWebviewUri(m){return(0,C.$Aob)(m,p.f)}get cspSource(){return C.$zob}set options(m){this.b=m,p.d.$setOptions($,m)}get options(){return this.b}set html(m){this.a=m,p.d.$setHtml($,m)}get html(){return this.a}get onDidReceiveMessage(){return d.event}postMessage(m){return p.d.$postMessage($,m)}},c=new class{constructor(){this.editor=h,this.line=S,this.height=g,this.webview=i,this.onDidDispose=t.event}dispose(){p.c.has($)&&(p.c.delete($),p.d.$disposeEditorInset($),t.fire(),t.dispose(),d.dispose())}};return this.d.$createEditorInset($,u.id,u.value.document.uri,S+1,g,P||{},D.identifier,D.extensionLocation),this.c.set($,{editor:h,inset:c,onDidReceiveMessage:d}),c}$onDidDispose(h){const S=this.c.get(h);S&&S.inset.dispose()}$onDidReceiveMessage(h,S){this.c.get(h)?.onDidReceiveMessage.fire(S)}}e.$Ebc=L}),define(Pe[200],Ae([1,0,4]),function(pe,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$HM=e.VariableKind=e.$GM=void 0,e.$GM=(0,y.$zh)("configurationResolverService");var R;(function(L){L.Unknown="unknown",L.Env="env",L.Config="config",L.Command="command",L.Input="input",L.ExtensionInstallFolder="extensionInstallFolder",L.WorkspaceFolder="workspaceFolder",L.Cwd="cwd",L.WorkspaceFolderBasename="workspaceFolderBasename",L.UserHome="userHome",L.LineNumber="lineNumber",L.SelectedText="selectedText",L.File="file",L.FileWorkspaceFolder="fileWorkspaceFolder",L.RelativeFile="relativeFile",L.RelativeFileDirname="relativeFileDirname",L.FileDirname="fileDirname",L.FileExtname="fileExtname",L.FileBasename="fileBasename",L.FileBasenameNoExtension="fileBasenameNoExtension",L.FileDirnameBasename="fileDirnameBasename",L.ExecPath="execPath",L.ExecInstallFolder="execInstallFolder",L.PathSeparator="pathSeparator"})(R||(e.VariableKind=R={}));class C extends Error{constructor(A,h){super(h),this.variable=A}}e.$HM=C}),define(Pe[201],Ae([1,0,19,74,16,24,22,90,166,200,15]),function(pe,e,y,R,C,L,A,h,S,g,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$VM=void 0;class D{static{this.VARIABLE_LHS="${"}static{this.VARIABLE_REGEXP=/\$\{(.*?)\}/g}constructor(p,$,d,t){this.h=new Map,this.a=p,this.b=$,this.g=d,t&&(this.c=t.then(i=>this.i(i)))}i(p){if(A.$i){const $=Object.create(null);return Object.keys(p).forEach(d=>{$[d.toLowerCase()]=p[d]}),$}return p}resolveWithEnvironment(p,$,d){return this.l({env:this.i(p),userHome:void 0},$?$.uri:void 0,d)}async resolveAsync(p,$){const d={env:await this.c,userHome:await this.g};return this.l(d,p?p.uri:void 0,$)}async j(p,$,d,t){const i=L.$Tm($);A.$i&&i.windows?Object.keys(i.windows).forEach(m=>i[m]=i.windows[m]):A.$j&&i.osx?Object.keys(i.osx).forEach(m=>i[m]=i.osx[m]):A.$k&&i.linux&&Object.keys(i.linux).forEach(m=>i[m]=i.linux[m]),delete i.windows,delete i.osx,delete i.linux;const c={env:await this.c,userHome:await this.g};return this.l(c,p?p.uri:void 0,i,d,t)}async resolveAnyAsync(p,$,d){return this.j(p,$,d)}async resolveAnyMap(p,$,d){const t=new Map;return{newConfig:await this.j(p,$,d,t),resolvedVariables:t}}resolveWithInteractionReplace(p,$,d,t){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(p,$,d,t){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(p,$){if(this.h.has(p))throw new Error("Variable "+p+" is contributed twice.");this.h.set(p,$)}async l(p,$,d,t,i){if(C.$le(d))return this.m(p,$,d,t,i);if(Array.isArray(d))return Promise.all(d.map(c=>this.l(p,$,c,t,i)));if(C.$ne(d)){const c=Object.create(null),m=await Promise.all(Object.keys(d).map(async E=>[await this.m(p,$,E,t,i),await this.l(p,$,d[E],t,i)]));for(const[E,b]of m)c[E]=b;return c}return d}m(p,$,d,t,i){return(0,P.$Gd)(d,D.VARIABLE_REGEXP,async(c,m)=>{if(m.includes(D.VARIABLE_LHS))return c;let E=await this.o(p,c,m,$,t);return i?.set(m,E),E!==c&&C.$le(E)&&E.match(D.VARIABLE_REGEXP)&&(E=await this.m(p,$,E,t,i)),E})}n(p){return this.b?this.b.getUriLabel(p,{noPrefix:!0}):p.fsPath}async o(p,$,d,t,i){let c;const m=d.split(":");m.length>1&&(d=m[0],c=m[1]);const E=a=>{const s=this.a.getFilePath();if(s)return(0,h.$bA)(s);throw new g.$HM(a,(0,S.localize)(0,null,$))},b=a=>{const s=E(a);if(this.a.getWorkspaceFolderPathForFile){const o=this.a.getWorkspaceFolderPathForFile();if(o)return(0,h.$bA)(o)}throw new g.$HM(a,(0,S.localize)(1,null,$,y.$cd(s)))},n=a=>{if(c){const s=this.a.getFolderUri(c);if(s)return s;throw new g.$HM(a,(0,S.localize)(2,null,$,c))}if(t)return t;throw this.a.getWorkspaceFolderCount()>1?new g.$HM(a,(0,S.localize)(3,null,$)):new g.$HM(a,(0,S.localize)(4,null,$))};switch(d){case"env":if(c){if(p.env){const a=p.env[A.$i?c.toLowerCase():c];if(C.$le(a))return a}return""}throw new g.$HM(g.VariableKind.Env,(0,S.localize)(5,null,$));case"config":if(c){const a=this.a.getConfigurationValue(t,c);if(C.$ue(a))throw new g.$HM(g.VariableKind.Config,(0,S.localize)(6,null,$,c));if(C.$ne(a))throw new g.$HM(g.VariableKind.Config,(0,S.localize)(7,null,$,c));return a}throw new g.$HM(g.VariableKind.Config,(0,S.localize)(8,null,$));case"command":return this.p(g.VariableKind.Command,$,c,i,"command");case"input":return this.p(g.VariableKind.Input,$,c,i,"input");case"extensionInstallFolder":if(c){const a=await this.a.getExtension(c);if(!a)throw new g.$HM(g.VariableKind.ExtensionInstallFolder,(0,S.localize)(9,null,$,c));return this.n(a.extensionLocation)}throw new g.$HM(g.VariableKind.ExtensionInstallFolder,(0,S.localize)(10,null,$));default:switch(d){case"workspaceRoot":case"workspaceFolder":return(0,h.$bA)(this.n(n(g.VariableKind.WorkspaceFolder)));case"cwd":return t||c?(0,h.$bA)(this.n(n(g.VariableKind.Cwd))):R.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return(0,h.$bA)(y.$cd(this.n(n(g.VariableKind.WorkspaceFolderBasename))));case"userHome":{if(p.userHome)return p.userHome;throw new g.$HM(g.VariableKind.UserHome,(0,S.localize)(11,null,$))}case"lineNumber":{const a=this.a.getLineNumber();if(a)return a;throw new g.$HM(g.VariableKind.LineNumber,(0,S.localize)(12,null,$))}case"selectedText":{const a=this.a.getSelectedText();if(a)return a;throw new g.$HM(g.VariableKind.SelectedText,(0,S.localize)(13,null,$))}case"file":return E(g.VariableKind.File);case"fileWorkspaceFolder":return b(g.VariableKind.FileWorkspaceFolder);case"relativeFile":return t||c?y.$ad(this.n(n(g.VariableKind.RelativeFile)),E(g.VariableKind.RelativeFile)):E(g.VariableKind.RelativeFile);case"relativeFileDirname":{const a=y.$bd(E(g.VariableKind.RelativeFileDirname));if(t||c){const s=y.$ad(this.n(n(g.VariableKind.RelativeFileDirname)),a);return s.length===0?".":s}return a}case"fileDirname":return y.$bd(E(g.VariableKind.FileDirname));case"fileExtname":return y.$dd(E(g.VariableKind.FileExtname));case"fileBasename":return y.$cd(E(g.VariableKind.FileBasename));case"fileBasenameNoExtension":{const a=y.$cd(E(g.VariableKind.FileBasenameNoExtension));return a.slice(0,a.length-y.$dd(a).length)}case"fileDirnameBasename":return y.$cd(y.$bd(E(g.VariableKind.FileDirnameBasename)));case"execPath":{const a=this.a.getExecPath();return a||$}case"execInstallFolder":{const a=this.a.getAppRoot();return a||$}case"pathSeparator":return y.sep;default:try{const a=c?`${d}:${c}`:d;return this.p(g.VariableKind.Unknown,$,a,i,void 0)}catch{return $}}}}p(p,$,d,t,i){if(d&&t){const c=i===void 0?t[d]:t[i+":"+d];if(typeof c=="string")return c;throw new g.$HM(p,(0,S.localize)(14,null,$))}return $}}e.$VM=D}),define(Pe[103],Ae([1,0,4,99]),function(pe,e,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4C=e.$3C=e.OpenEditorContext=e.GroupsOrder=e.$2C=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.$1C=void 0,e.$1C=(0,y.$zh)("editorGroupsService");var C;(function($){$[$.UP=0]="UP",$[$.DOWN=1]="DOWN",$[$.LEFT=2]="LEFT",$[$.RIGHT=3]="RIGHT"})(C||(e.GroupDirection=C={}));var L;(function($){$[$.HORIZONTAL=0]="HORIZONTAL",$[$.VERTICAL=1]="VERTICAL"})(L||(e.GroupOrientation=L={}));var A;(function($){$[$.FIRST=0]="FIRST",$[$.LAST=1]="LAST",$[$.NEXT=2]="NEXT",$[$.PREVIOUS=3]="PREVIOUS"})(A||(e.GroupLocation=A={}));var h;(function($){$[$.MAXIMIZE=0]="MAXIMIZE",$[$.EVEN=1]="EVEN",$[$.TOGGLE=2]="TOGGLE"})(h||(e.GroupsArrangement=h={}));var S;(function($){$[$.COPY_EDITORS=0]="COPY_EDITORS",$[$.MOVE_EDITORS=1]="MOVE_EDITORS"})(S||(e.MergeGroupMode=S={}));function g($){const d=$;return(0,R.$QE)(d?.editor)&&(0,R.$QE)(d?.replacement)}e.$2C=g;var P;(function($){$[$.CREATION_TIME=0]="CREATION_TIME",$[$.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",$[$.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(P||(e.GroupsOrder=P={}));var D;(function($){$[$.NEW_EDITOR=1]="NEW_EDITOR",$[$.MOVE_EDITOR=2]="MOVE_EDITOR",$[$.COPY_EDITOR=3]="COPY_EDITOR"})(D||(e.OpenEditorContext=D={}));function u($){const d=$;return!!d&&typeof d.id=="number"&&Array.isArray(d.editors)}e.$3C=u;function p($){return $.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.$4C=p}),define(Pe[202],Ae([1,0,4,103]),function(pe,e,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8C=e.$7C=e.$6C=e.$5C=void 0,e.$5C=(0,y.$zh)("editorService"),e.$6C=-1,e.$7C=-2;function C(L){const A=L;return typeof L=="number"||(0,R.$3C)(A)}e.$8C=C}),define(Pe[8],Ae([1,0,18,25,123,203,49,28,117,68,67,24,16,2,44,78,94,102,99,75,45,56,202,7]),function(pe,e,y,R,C,L,A,h,S,g,P,D,u,p,$,d,t,i,c,m,E,b,n,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalQuickFix=e.InteractiveEditorResponseFeedbackKind=e.ChatVariableLevel=e.ChatVariable=e.ChatMessageRole=e.ChatMessage=e.ChatFollowup=e.ChatReplyFollowup=e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookKernelSourceAction=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.MappedEditsContext=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.$TL=e.$SL=e.MarkdownString=e.$RL=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Range=e.Selection=void 0;var s;(function(Ie){function Me(G){const{selectionStartLineNumber:Fe,selectionStartColumn:Be,positionLineNumber:Ge,positionColumn:We}=G,xe=new a.$VJ(Fe-1,Be-1),pt=new a.$VJ(Ge-1,We-1);return new a.$XJ(xe,pt)}Ie.to=Me;function ge(G){const{anchor:Fe,active:Be}=G;return{selectionStartLineNumber:Fe.line+1,selectionStartColumn:Fe.character+1,positionLineNumber:Be.line+1,positionColumn:Be.character+1}}Ie.from=ge})(s||(e.Selection=s={}));var o;(function(Ie){function Me(G){if(!G)return;const{start:Fe,end:Be}=G;return{startLineNumber:Fe.line+1,startColumn:Fe.character+1,endLineNumber:Be.line+1,endColumn:Be.character+1}}Ie.from=Me;function ge(G){if(!G)return;const{startLineNumber:Fe,startColumn:Be,endLineNumber:Ge,endColumn:We}=G;return new a.$WJ(Fe-1,Be-1,Ge-1,We-1)}Ie.to=ge})(o||(e.Range=o={}));var w;(function(Ie){function Me(ge){switch(ge){case 1:return a.StandardTokenType.Comment;case 0:return a.StandardTokenType.Other;case 3:return a.StandardTokenType.RegEx;case 2:return a.StandardTokenType.String}}Ie.to=Me})(w||(e.TokenType=w={}));var v;(function(Ie){function Me(G){return new a.$VJ(G.lineNumber-1,G.column-1)}Ie.to=Me;function ge(G){return{lineNumber:G.line+1,column:G.character+1}}Ie.from=ge})(v||(e.Position=v={}));var I;(function(Ie){function Me(Fe,Be,Ge){return(0,y.$Af)((0,y.$Vf)(Fe).map(We=>ge(We,Be,Ge)))}Ie.from=Me;function ge(Fe,Be,Ge){if(typeof Fe=="string")return{$serialized:!0,language:Fe,isBuiltin:Ge?.isBuiltin};if(Fe)return{$serialized:!0,language:Fe.language,scheme:G(Fe.scheme,Be),pattern:st.from(Fe.pattern)??void 0,exclusive:Fe.exclusive,notebookType:Fe.notebookType,isBuiltin:Ge?.isBuiltin}}function G(Fe,Be){return Be&&typeof Fe=="string"?Be.transformOutgoingScheme(Fe):Fe}})(I||(e.DocumentSelector=I={}));var k;(function(Ie){function Me(G){switch(G){case a.DiagnosticTag.Unnecessary:return 1;case a.DiagnosticTag.Deprecated:return 2}}Ie.from=Me;function ge(G){switch(G){case 1:return a.DiagnosticTag.Unnecessary;case 2:return a.DiagnosticTag.Deprecated;default:return}}Ie.to=ge})(k||(e.DiagnosticTag=k={}));var r;(function(Ie){function Me(G){let Fe;return G.code&&((0,u.$le)(G.code)||(0,u.$pe)(G.code)?Fe=String(G.code):Fe={value:String(G.code.value),target:G.code.target}),{...o.from(G.range),message:G.message,source:G.source,code:Fe,severity:f.from(G.severity),relatedInformation:G.relatedInformation&&G.relatedInformation.map(l.from),tags:Array.isArray(G.tags)?(0,y.$Af)(G.tags.map(k.from)):void 0}}Ie.from=Me;function ge(G){const Fe=new a.$9J(o.to(G),G.message,f.to(G.severity));return Fe.source=G.source,Fe.code=(0,u.$le)(G.code)?G.code:G.code?.value,Fe.relatedInformation=G.relatedInformation&&G.relatedInformation.map(l.to),Fe.tags=G.tags&&(0,y.$Af)(G.tags.map(k.to)),Fe}Ie.to=ge})(r||(e.Diagnostic=r={}));var l;(function(Ie){function Me(G){return{...o.from(G.location.range),message:G.message,resource:G.location.uri}}Ie.from=Me;function ge(G){return new a.$8J(new a.$7J(G.resource,o.to(G)),G.message)}Ie.to=ge})(l||(e.DiagnosticRelatedInformation=l={}));var f;(function(Ie){function Me(G){switch(G){case a.DiagnosticSeverity.Error:return t.MarkerSeverity.Error;case a.DiagnosticSeverity.Warning:return t.MarkerSeverity.Warning;case a.DiagnosticSeverity.Information:return t.MarkerSeverity.Info;case a.DiagnosticSeverity.Hint:return t.MarkerSeverity.Hint}return t.MarkerSeverity.Error}Ie.from=Me;function ge(G){switch(G){case t.MarkerSeverity.Info:return a.DiagnosticSeverity.Information;case t.MarkerSeverity.Warning:return a.DiagnosticSeverity.Warning;case t.MarkerSeverity.Error:return a.DiagnosticSeverity.Error;case t.MarkerSeverity.Hint:return a.DiagnosticSeverity.Hint;default:return a.DiagnosticSeverity.Error}}Ie.to=ge})(f||(e.DiagnosticSeverity=f={}));var F;(function(Ie){function Me(G){return typeof G=="number"&&G>=a.ViewColumn.One?G-1:G===a.ViewColumn.Beside?n.$7C:n.$6C}Ie.from=Me;function ge(G){if(typeof G=="number"&&G>=0)return G+1;throw new Error("invalid 'EditorGroupColumn'")}Ie.to=ge})(F||(e.ViewColumn=F={}));function W(Ie){return typeof Ie.range<"u"}function V(Ie){return Ie.length===0?!0:!!W(Ie[0])}e.$RL=V;var B;(function(Ie){function Me(We){return We.map(Ie.from)}Ie.fromMany=Me;function ge(We){return We&&typeof We=="object"&&typeof We.language=="string"&&typeof We.value=="string"}function G(We){let xe;if(ge(We)){const{language:ft,value:mt}=We;xe={value:"```"+ft+`
`+mt+"\n```\n"}}else a.$jK.isMarkdownString(We)?xe={value:We.value,isTrusted:We.isTrusted,supportThemeIcons:We.supportThemeIcons,supportHtml:We.supportHtml,baseUri:We.baseUri}:typeof We=="string"?xe={value:We}:xe={value:""};const pt=Object.create(null);xe.uris=pt;const bt=ft=>{try{let mt=p.URI.parse(ft,!0);mt=mt.with({query:Fe(mt.query,pt)}),pt[ft]=mt}catch{}return""},dt=new S.marked.Renderer;return dt.link=bt,dt.image=ft=>typeof ft=="string"?bt(A.$3j(ft).href):"",(0,S.marked)(xe.value,{renderer:dt}),xe}Ie.from=G;function Fe(We,xe){if(!We)return We;let pt;try{pt=(0,g.$8g)(We)}catch{}if(!pt)return We;let bt=!1;return pt=(0,D.$Vm)(pt,dt=>{if(p.URI.isUri(dt)){const ft=`__uri_${Math.random().toString(16).slice(2,8)}`;return xe[ft]=dt,bt=!0,ft}else return}),bt?JSON.stringify(pt):We}function Be(We){const xe=new a.$jK(We.value,We.supportThemeIcons);return xe.isTrusted=We.isTrusted,xe.supportHtml=We.supportHtml,xe.baseUri=We.baseUri?p.URI.from(We.baseUri):void 0,xe}Ie.to=Be;function Ge(We){if(We)return typeof We=="string"?We:Ie.from(We)}Ie.fromStrict=Ge})(B||(e.MarkdownString=B={}));function j(Ie){return V(Ie)?Ie.map(Me=>({range:o.from(Me.range),hoverMessage:Array.isArray(Me.hoverMessage)?B.fromMany(Me.hoverMessage):Me.hoverMessage?B.from(Me.hoverMessage):void 0,renderOptions:Me.renderOptions})):Ie.map(Me=>({range:o.from(Me)}))}e.$SL=j;function U(Ie){return typeof Ie>"u"?Ie:typeof Ie=="string"?p.URI.file(Ie):Ie}e.$TL=U;var z;(function(Ie){function Me(ge){return typeof ge>"u"?ge:{contentText:ge.contentText,contentIconPath:ge.contentIconPath?U(ge.contentIconPath):void 0,border:ge.border,borderColor:ge.borderColor,fontStyle:ge.fontStyle,fontWeight:ge.fontWeight,textDecoration:ge.textDecoration,color:ge.color,backgroundColor:ge.backgroundColor,margin:ge.margin,width:ge.width,height:ge.height}}Ie.from=Me})(z||(e.ThemableDecorationAttachmentRenderOptions=z={}));var ie;(function(Ie){function Me(ge){return typeof ge>"u"?ge:{backgroundColor:ge.backgroundColor,outline:ge.outline,outlineColor:ge.outlineColor,outlineStyle:ge.outlineStyle,outlineWidth:ge.outlineWidth,border:ge.border,borderColor:ge.borderColor,borderRadius:ge.borderRadius,borderSpacing:ge.borderSpacing,borderStyle:ge.borderStyle,borderWidth:ge.borderWidth,fontStyle:ge.fontStyle,fontWeight:ge.fontWeight,textDecoration:ge.textDecoration,cursor:ge.cursor,color:ge.color,opacity:ge.opacity,letterSpacing:ge.letterSpacing,gutterIconPath:ge.gutterIconPath?U(ge.gutterIconPath):void 0,gutterIconSize:ge.gutterIconSize,overviewRulerColor:ge.overviewRulerColor,before:ge.before?z.from(ge.before):void 0,after:ge.after?z.from(ge.after):void 0}}Ie.from=Me})(ie||(e.ThemableDecorationRenderOptions=ie={}));var Y;(function(Ie){function Me(ge){if(typeof ge>"u")return ge;switch(ge){case a.DecorationRangeBehavior.OpenOpen:return 0;case a.DecorationRangeBehavior.ClosedClosed:return 1;case a.DecorationRangeBehavior.OpenClosed:return 2;case a.DecorationRangeBehavior.ClosedOpen:return 3}}Ie.from=Me})(Y||(e.DecorationRangeBehavior=Y={}));var ye;(function(Ie){function Me(ge){return{isWholeLine:ge.isWholeLine,rangeBehavior:ge.rangeBehavior?Y.from(ge.rangeBehavior):void 0,overviewRulerLane:ge.overviewRulerLane,light:ge.light?ie.from(ge.light):void 0,dark:ge.dark?ie.from(ge.dark):void 0,backgroundColor:ge.backgroundColor,outline:ge.outline,outlineColor:ge.outlineColor,outlineStyle:ge.outlineStyle,outlineWidth:ge.outlineWidth,border:ge.border,borderColor:ge.borderColor,borderRadius:ge.borderRadius,borderSpacing:ge.borderSpacing,borderStyle:ge.borderStyle,borderWidth:ge.borderWidth,fontStyle:ge.fontStyle,fontWeight:ge.fontWeight,textDecoration:ge.textDecoration,cursor:ge.cursor,color:ge.color,opacity:ge.opacity,letterSpacing:ge.letterSpacing,gutterIconPath:ge.gutterIconPath?U(ge.gutterIconPath):void 0,gutterIconSize:ge.gutterIconSize,overviewRulerColor:ge.overviewRulerColor,before:ge.before?z.from(ge.before):void 0,after:ge.after?z.from(ge.after):void 0}}Ie.from=Me})(ye||(e.DecorationRenderOptions=ye={}));var ke;(function(Ie){function Me(G){return{text:G.newText,eol:G.newEol&&Ye.from(G.newEol),range:o.from(G.range)}}Ie.from=Me;function ge(G){const Fe=new a.$2J(o.to(G.range),G.text);return Fe.newEol=typeof G.eol>"u"?void 0:Ye.to(G.eol),Fe}Ie.to=ge})(ke||(e.TextEdit=ke={}));var Re;(function(Ie){function Me(G,Fe){const Be={edits:[]};if(G instanceof a.$5J){const Ge=new h.$yi;for(const We of G._allEntries())We._type===1&&p.URI.isUri(We.to)&&We.from===void 0&&Ge.add(We.to);for(const We of G._allEntries())if(We._type===1){let xe;We.options?.contents&&(ArrayBuffer.isView(We.options.contents)?xe={type:"base64",value:(0,R.$2c)(R.$Hc.wrap(We.options.contents))}:xe={type:"dataTransferItem",id:We.options.contents._itemId}),Be.edits.push({oldResource:We.from,newResource:We.to,options:{...We.options,contents:xe},metadata:We.metadata})}else We._type===2?Be.edits.push({resource:We.uri,textEdit:ke.from(We.edit),versionId:Ge.has(We.uri)?void 0:Fe?.getTextDocumentVersion(We.uri),metadata:We.metadata}):We._type===6?Be.edits.push({resource:We.uri,textEdit:{range:o.from(We.range),text:We.edit.value,insertAsSnippet:!0},versionId:Ge.has(We.uri)?void 0:Fe?.getTextDocumentVersion(We.uri),metadata:We.metadata}):We._type===3?Be.edits.push({metadata:We.metadata,resource:We.uri,cellEdit:We.edit,notebookMetadata:We.notebookMetadata,notebookVersionId:Fe?.getNotebookDocumentVersion(We.uri)}):We._type===5&&Be.edits.push({metadata:We.metadata,resource:We.uri,notebookVersionId:Fe?.getNotebookDocumentVersion(We.uri),cellEdit:{editType:1,index:We.index,count:We.count,cells:We.cells.map(gt.from)}})}return Be}Ie.from=Me;function ge(G){const Fe=new a.$5J,Be=new h.$xi;for(const Ge of G.edits)if(Ge.textEdit){const We=Ge,xe=p.URI.revive(We.resource),pt=o.to(We.textEdit.range),bt=We.textEdit.text,dt=We.textEdit.insertAsSnippet;let ft;dt?ft=a.$4J.replace(pt,new a.$6J(bt)):ft=a.$2J.replace(pt,bt);const mt=Be.get(xe);mt?mt.push(ft):Be.set(xe,[ft])}else Fe.renameFile(p.URI.revive(Ge.oldResource),p.URI.revive(Ge.newResource),Ge.options);for(const[Ge,We]of Be)Fe.set(Ge,We);return Fe}Ie.to=ge})(Re||(e.WorkspaceEdit=Re={}));var X;(function(Ie){const Me=Object.create(null);Me[a.SymbolKind.File]=0,Me[a.SymbolKind.Module]=1,Me[a.SymbolKind.Namespace]=2,Me[a.SymbolKind.Package]=3,Me[a.SymbolKind.Class]=4,Me[a.SymbolKind.Method]=5,Me[a.SymbolKind.Property]=6,Me[a.SymbolKind.Field]=7,Me[a.SymbolKind.Constructor]=8,Me[a.SymbolKind.Enum]=9,Me[a.SymbolKind.Interface]=10,Me[a.SymbolKind.Function]=11,Me[a.SymbolKind.Variable]=12,Me[a.SymbolKind.Constant]=13,Me[a.SymbolKind.String]=14,Me[a.SymbolKind.Number]=15,Me[a.SymbolKind.Boolean]=16,Me[a.SymbolKind.Array]=17,Me[a.SymbolKind.Object]=18,Me[a.SymbolKind.Key]=19,Me[a.SymbolKind.Null]=20,Me[a.SymbolKind.EnumMember]=21,Me[a.SymbolKind.Struct]=22,Me[a.SymbolKind.Event]=23,Me[a.SymbolKind.Operator]=24,Me[a.SymbolKind.TypeParameter]=25;function ge(Fe){return typeof Me[Fe]=="number"?Me[Fe]:6}Ie.from=ge;function G(Fe){for(const Be in Me)if(Me[Be]===Fe)return Number(Be);return a.SymbolKind.Property}Ie.to=G})(X||(e.SymbolKind=X={}));var le;(function(Ie){function Me(G){switch(G){case a.SymbolTag.Deprecated:return 1}}Ie.from=Me;function ge(G){switch(G){case 1:return a.SymbolTag.Deprecated}}Ie.to=ge})(le||(e.SymbolTag=le={}));var we;(function(Ie){function Me(G){return{name:G.name,kind:X.from(G.kind),tags:G.tags&&G.tags.map(le.from),containerName:G.containerName,location:J.from(G.location)}}Ie.from=Me;function ge(G){const Fe=new a.$_J(G.name,X.to(G.kind),G.containerName,J.to(G.location));return Fe.tags=G.tags&&G.tags.map(le.to),Fe}Ie.to=ge})(we||(e.WorkspaceSymbol=we={}));var ae;(function(Ie){function Me(G){const Fe={name:G.name||"!!MISSING: name!!",detail:G.detail,range:o.from(G.range),selectionRange:o.from(G.selectionRange),kind:X.from(G.kind),tags:G.tags?.map(le.from)??[]};return G.children&&(Fe.children=G.children.map(Me)),Fe}Ie.from=Me;function ge(G){const Fe=new a.$aK(G.name,G.detail,X.to(G.kind),o.to(G.range),o.to(G.selectionRange));return(0,y.$Ef)(G.tags)&&(Fe.tags=G.tags.map(le.to)),G.children&&(Fe.children=G.children.map(ge)),Fe}Ie.to=ge})(ae||(e.DocumentSymbol=ae={}));var x;(function(Ie){function Me(G){const Fe=new a.$fK(X.to(G.kind),G.name,G.detail||"",p.URI.revive(G.uri),o.to(G.range),o.to(G.selectionRange));return Fe._sessionId=G._sessionId,Fe._itemId=G._itemId,Fe}Ie.to=Me;function ge(G,Fe,Be){if(Fe=Fe??G._sessionId,Be=Be??G._itemId,Fe===void 0||Be===void 0)throw new Error("invalid item");return{_sessionId:Fe,_itemId:Be,name:G.name,detail:G.detail,kind:X.from(G.kind),uri:G.uri,range:o.from(G.range),selectionRange:o.from(G.selectionRange),tags:G.tags?.map(le.from)}}Ie.from=ge})(x||(e.CallHierarchyItem=x={}));var ue;(function(Ie){function Me(ge){return new a.$gK(x.to(ge.from),ge.fromRanges.map(G=>o.to(G)))}Ie.to=Me})(ue||(e.CallHierarchyIncomingCall=ue={}));var O;(function(Ie){function Me(ge){return new a.$hK(x.to(ge.to),ge.fromRanges.map(G=>o.to(G)))}Ie.to=Me})(O||(e.CallHierarchyOutgoingCall=O={}));var J;(function(Ie){function Me(G){return{range:G.range&&o.from(G.range),uri:G.uri}}Ie.from=Me;function ge(G){return new a.$7J(p.URI.revive(G.uri),o.to(G.range))}Ie.to=ge})(J||(e.location=J={}));var he;(function(Ie){function Me(G){const Fe=G,Be=G;return{originSelectionRange:Fe.originSelectionRange?o.from(Fe.originSelectionRange):void 0,uri:Fe.targetUri?Fe.targetUri:Be.uri,range:o.from(Fe.targetRange?Fe.targetRange:Be.range),targetSelectionRange:Fe.targetSelectionRange?o.from(Fe.targetSelectionRange):void 0}}Ie.from=Me;function ge(G){return{targetUri:p.URI.revive(G.uri),targetRange:o.to(G.range),targetSelectionRange:G.targetSelectionRange?o.to(G.targetSelectionRange):void 0,originSelectionRange:G.originSelectionRange?o.to(G.originSelectionRange):void 0}}Ie.to=ge})(he||(e.DefinitionLink=he={}));var Ee;(function(Ie){function Me(G){return{range:o.from(G.range),contents:B.fromMany(G.contents)}}Ie.from=Me;function ge(G){return new a.$0J(G.contents.map(B.to),o.to(G.range))}Ie.to=ge})(Ee||(e.Hover=Ee={}));var ve;(function(Ie){function Me(G){return{range:o.from(G.range),expression:G.expression}}Ie.from=Me;function ge(G){return new a.$4K(o.to(G.range),G.expression)}Ie.to=ge})(ve||(e.EvaluatableExpression=ve={}));var be;(function(Ie){function Me(G){if(G instanceof a.$5K)return{type:"text",range:o.from(G.range),text:G.text};if(G instanceof a.$6K)return{type:"variable",range:o.from(G.range),variableName:G.variableName,caseSensitiveLookup:G.caseSensitiveLookup};if(G instanceof a.$7K)return{type:"expression",range:o.from(G.range),expression:G.expression};throw new Error("Unknown 'InlineValue' type")}Ie.from=Me;function ge(G){switch(G.type){case"text":return{range:o.to(G.range),text:G.text};case"variable":return{range:o.to(G.range),variableName:G.variableName,caseSensitiveLookup:G.caseSensitiveLookup};case"expression":return{range:o.to(G.range),expression:G.expression}}}Ie.to=ge})(be||(e.InlineValue=be={}));var De;(function(Ie){function Me(G){return{frameId:G.frameId,stoppedLocation:o.from(G.stoppedLocation)}}Ie.from=Me;function ge(G){return new a.$8K(G.frameId,o.to(G.stoppedLocation))}Ie.to=ge})(De||(e.InlineValueContext=De={}));var oe;(function(Ie){function Me(G){return{range:o.from(G.range),kind:G.kind}}Ie.from=Me;function ge(G){return new a.$$J(o.to(G.range),G.kind)}Ie.to=ge})(oe||(e.DocumentHighlight=oe={}));var de;(function(Ie){function Me(ge){switch(ge){case 1:return a.CompletionTriggerKind.TriggerCharacter;case 2:return a.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return a.CompletionTriggerKind.Invoke}}Ie.to=Me})(de||(e.CompletionTriggerKind=de={}));var se;(function(Ie){function Me(ge){return{triggerKind:de.to(ge.triggerKind),triggerCharacter:ge.triggerCharacter}}Ie.to=Me})(se||(e.CompletionContext=se={}));var ne;(function(Ie){function Me(G){switch(G){case a.CompletionItemTag.Deprecated:return 1}}Ie.from=Me;function ge(G){switch(G){case 1:return a.CompletionItemTag.Deprecated}}Ie.to=ge})(ne||(e.CompletionItemTag=ne={}));var me;(function(Ie){const Me=new Map([[a.CompletionItemKind.Method,0],[a.CompletionItemKind.Function,1],[a.CompletionItemKind.Constructor,2],[a.CompletionItemKind.Field,3],[a.CompletionItemKind.Variable,4],[a.CompletionItemKind.Class,5],[a.CompletionItemKind.Interface,7],[a.CompletionItemKind.Struct,6],[a.CompletionItemKind.Module,8],[a.CompletionItemKind.Property,9],[a.CompletionItemKind.Unit,12],[a.CompletionItemKind.Value,13],[a.CompletionItemKind.Constant,14],[a.CompletionItemKind.Enum,15],[a.CompletionItemKind.EnumMember,16],[a.CompletionItemKind.Keyword,17],[a.CompletionItemKind.Snippet,27],[a.CompletionItemKind.Text,18],[a.CompletionItemKind.Color,19],[a.CompletionItemKind.File,20],[a.CompletionItemKind.Reference,21],[a.CompletionItemKind.Folder,23],[a.CompletionItemKind.Event,10],[a.CompletionItemKind.Operator,11],[a.CompletionItemKind.TypeParameter,24],[a.CompletionItemKind.Issue,26],[a.CompletionItemKind.User,25]]);function ge(Be){return Me.get(Be)??9}Ie.from=ge;const G=new Map([[0,a.CompletionItemKind.Method],[1,a.CompletionItemKind.Function],[2,a.CompletionItemKind.Constructor],[3,a.CompletionItemKind.Field],[4,a.CompletionItemKind.Variable],[5,a.CompletionItemKind.Class],[7,a.CompletionItemKind.Interface],[6,a.CompletionItemKind.Struct],[8,a.CompletionItemKind.Module],[9,a.CompletionItemKind.Property],[12,a.CompletionItemKind.Unit],[13,a.CompletionItemKind.Value],[14,a.CompletionItemKind.Constant],[15,a.CompletionItemKind.Enum],[16,a.CompletionItemKind.EnumMember],[17,a.CompletionItemKind.Keyword],[27,a.CompletionItemKind.Snippet],[18,a.CompletionItemKind.Text],[19,a.CompletionItemKind.Color],[20,a.CompletionItemKind.File],[21,a.CompletionItemKind.Reference],[23,a.CompletionItemKind.Folder],[10,a.CompletionItemKind.Event],[11,a.CompletionItemKind.Operator],[24,a.CompletionItemKind.TypeParameter],[25,a.CompletionItemKind.User],[26,a.CompletionItemKind.Issue]]);function Fe(Be){return G.get(Be)??a.CompletionItemKind.Property}Ie.to=Fe})(me||(e.CompletionItemKind=me={}));var Ce;(function(Ie){function Me(ge,G){const Fe=new a.$pK(ge.label);return Fe.insertText=ge.insertText,Fe.kind=me.to(ge.kind),Fe.tags=ge.tags?.map(ne.to),Fe.detail=ge.detail,Fe.documentation=A.$Xj(ge.documentation)?B.to(ge.documentation):ge.documentation,Fe.sortText=ge.sortText,Fe.filterText=ge.filterText,Fe.preselect=ge.preselect,Fe.commitCharacters=ge.commitCharacters,$.$hs.isIRange(ge.range)?Fe.range=o.to(ge.range):typeof ge.range=="object"&&(Fe.range={inserting:o.to(ge.range.insert),replacing:o.to(ge.range.replace)}),Fe.keepWhitespace=typeof ge.insertTextRules>"u"?!1:!!(ge.insertTextRules&1),typeof ge.insertTextRules<"u"&&ge.insertTextRules&4?Fe.insertText=new a.$6J(ge.insertText):(Fe.insertText=ge.insertText,Fe.textEdit=Fe.range instanceof a.$WJ?new a.$2J(Fe.range,Fe.insertText):void 0),ge.additionalTextEdits&&ge.additionalTextEdits.length>0&&(Fe.additionalTextEdits=ge.additionalTextEdits.map(Be=>ke.to(Be))),Fe.command=G&&ge.command?G.fromInternal(ge.command):void 0,Fe}Ie.to=Me})(Ce||(e.CompletionItem=Ce={}));var M;(function(Ie){function Me(G){if(typeof G.label!="string"&&!Array.isArray(G.label))throw new TypeError("Invalid label");return{label:G.label,documentation:B.fromStrict(G.documentation)}}Ie.from=Me;function ge(G){return{label:G.label,documentation:A.$Xj(G.documentation)?B.to(G.documentation):G.documentation}}Ie.to=ge})(M||(e.ParameterInformation=M={}));var q;(function(Ie){function Me(G){return{label:G.label,documentation:B.fromStrict(G.documentation),parameters:Array.isArray(G.parameters)?G.parameters.map(M.from):[],activeParameter:G.activeParameter}}Ie.from=Me;function ge(G){return{label:G.label,documentation:A.$Xj(G.documentation)?B.to(G.documentation):G.documentation,parameters:Array.isArray(G.parameters)?G.parameters.map(M.to):[],activeParameter:G.activeParameter}}Ie.to=ge})(q||(e.SignatureInformation=q={}));var H;(function(Ie){function Me(G){return{activeSignature:G.activeSignature,activeParameter:G.activeParameter,signatures:Array.isArray(G.signatures)?G.signatures.map(q.from):[]}}Ie.from=Me;function ge(G){return{activeSignature:G.activeSignature,activeParameter:G.activeParameter,signatures:Array.isArray(G.signatures)?G.signatures.map(q.to):[]}}Ie.to=ge})(H||(e.SignatureHelp=H={}));var Z;(function(Ie){function Me(ge,G){const Fe=new a.$oK(v.to(G.position),typeof G.label=="string"?G.label:G.label.map(K.to.bind(void 0,ge)),G.kind&&ee.to(G.kind));return Fe.textEdits=G.textEdits&&G.textEdits.map(ke.to),Fe.tooltip=A.$Xj(G.tooltip)?B.to(G.tooltip):G.tooltip,Fe.paddingLeft=G.paddingLeft,Fe.paddingRight=G.paddingRight,Fe}Ie.to=Me})(Z||(e.InlayHint=Z={}));var K;(function(Ie){function Me(ge,G){const Fe=new a.$nK(G.label);return Fe.tooltip=A.$Xj(G.tooltip)?B.to(G.tooltip):G.tooltip,d.Command.is(G.command)&&(Fe.command=ge.fromInternal(G.command)),G.location&&(Fe.location=J.to(G.location)),Fe}Ie.to=Me})(K||(e.InlayHintLabelPart=K={}));var ee;(function(Ie){function Me(G){return G}Ie.from=Me;function ge(G){return G}Ie.to=ge})(ee||(e.InlayHintKind=ee={}));var ce;(function(Ie){function Me(G){return{range:o.from(G.range),url:G.target,tooltip:G.tooltip}}Ie.from=Me;function ge(G){let Fe;if(G.url)try{Fe=typeof G.url=="string"?p.URI.parse(G.url,!0):p.URI.revive(G.url)}catch{}return new a.$uK(o.to(G.range),Fe)}Ie.to=ge})(ce||(e.DocumentLink=ce={}));var ze;(function(Ie){function Me(G){const Fe=new a.$xK(G.label);return G.textEdit&&(Fe.textEdit=ke.to(G.textEdit)),G.additionalTextEdits&&(Fe.additionalTextEdits=G.additionalTextEdits.map(Be=>ke.to(Be))),Fe}Ie.to=Me;function ge(G){return{label:G.label,textEdit:G.textEdit?ke.from(G.textEdit):void 0,additionalTextEdits:G.additionalTextEdits?G.additionalTextEdits.map(Fe=>ke.from(Fe)):void 0}}Ie.from=ge})(ze||(e.ColorPresentation=ze={}));var Ue;(function(Ie){function Me(G){return new a.$vK(G[0],G[1],G[2],G[3])}Ie.to=Me;function ge(G){return[G.red,G.green,G.blue,G.alpha]}Ie.from=ge})(Ue||(e.Color=Ue={}));var Ze;(function(Ie){function Me(G){return{range:o.from(G.range)}}Ie.from=Me;function ge(G){return new a.$eK(o.to(G.range))}Ie.to=ge})(Ze||(e.SelectionRange=Ze={}));var He;(function(Ie){function Me(ge){switch(ge){case 2:return a.TextDocumentSaveReason.AfterDelay;case 1:return a.TextDocumentSaveReason.Manual;case 3:case 4:return a.TextDocumentSaveReason.FocusOut}}Ie.to=Me})(He||(e.TextDocumentSaveReason=He={}));var et;(function(Ie){function Me(G){switch(G){case a.TextEditorLineNumbersStyle.Off:return 0;case a.TextEditorLineNumbersStyle.Relative:return 2;case a.TextEditorLineNumbersStyle.On:default:return 1}}Ie.from=Me;function ge(G){switch(G){case 0:return a.TextEditorLineNumbersStyle.Off;case 2:return a.TextEditorLineNumbersStyle.Relative;case 1:default:return a.TextEditorLineNumbersStyle.On}}Ie.to=ge})(et||(e.TextEditorLineNumbersStyle=et={}));var Ye;(function(Ie){function Me(G){if(G===a.EndOfLine.CRLF)return 1;if(G===a.EndOfLine.LF)return 0}Ie.from=Me;function ge(G){if(G===1)return a.EndOfLine.CRLF;if(G===0)return a.EndOfLine.LF}Ie.to=ge})(Ye||(e.EndOfLine=Ye={}));var _e;(function(Ie){function Me(ge){if(typeof ge=="object")return ge.viewId;switch(ge){case a.ProgressLocation.SourceControl:return 3;case a.ProgressLocation.Window:return 10;case a.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}Ie.from=Me})(_e||(e.ProgressLocation=_e={}));var it;(function(Ie){function Me(G){const Fe={start:G.start+1,end:G.end+1};return G.kind&&(Fe.kind=tt.from(G.kind)),Fe}Ie.from=Me;function ge(G){const Fe={start:G.start-1,end:G.end-1};return G.kind&&(Fe.kind=tt.to(G.kind)),Fe}Ie.to=ge})(it||(e.FoldingRange=it={}));var tt;(function(Ie){function Me(G){if(G)switch(G){case a.FoldingRangeKind.Comment:return d.$9s.Comment;case a.FoldingRangeKind.Imports:return d.$9s.Imports;case a.FoldingRangeKind.Region:return d.$9s.Region}}Ie.from=Me;function ge(G){if(G)switch(G.value){case d.$9s.Comment.value:return a.FoldingRangeKind.Comment;case d.$9s.Imports.value:return a.FoldingRangeKind.Imports;case d.$9s.Region.value:return a.FoldingRangeKind.Region}}Ie.to=ge})(tt||(e.FoldingRangeKind=tt={}));var Ne;(function(Ie){function Me(ge){if(ge)return{pinned:typeof ge.preview=="boolean"?!ge.preview:void 0,inactive:ge.background,preserveFocus:ge.preserveFocus,selection:typeof ge.selection=="object"?o.from(ge.selection):void 0,override:typeof ge.override=="boolean"?c.$DE.id:void 0}}Ie.from=Me})(Ne||(e.TextEditorOpenOptions=Ne={}));var st;(function(Ie){function Me(Be){return Be instanceof a.$RK?Be.toJSON():typeof Be=="string"?Be:ge(Be)||G(Be)?new a.$RK(Be.baseUri??Be.base,Be.pattern).toJSON():Be}Ie.from=Me;function ge(Be){const Ge=Be;return Ge?p.URI.isUri(Ge.baseUri)&&typeof Ge.pattern=="string":!1}function G(Be){const Ge=Be;return Ge?typeof Ge.base=="string"&&typeof Ge.pattern=="string":!1}function Fe(Be){return typeof Be=="string"?Be:new a.$RK(p.URI.revive(Be.baseUri),Be.pattern)}Ie.to=Fe})(st||(e.GlobPattern=st={}));var _;(function(Ie){function Me(ge){if(ge){if(Array.isArray(ge))return ge.map(Me);if(typeof ge=="string")return ge;{const G=ge;return{language:G.language,scheme:G.scheme,pattern:st.from(G.pattern),exclusive:G.exclusive,notebookType:G.notebookType}}}else return}Ie.from=Me})(_||(e.LanguageSelector=_={}));var Q;(function(Ie){function Me(G){return!!G&&typeof G=="object"&&"selections"in G&&Array.isArray(G.selections)&&G.selections.every(Fe=>Fe instanceof a.$XJ)&&"related"in G&&Array.isArray(G.related)&&G.related.every(Fe=>Fe&&typeof Fe=="object"&&p.URI.isUri(Fe.uri)&&Fe.range instanceof a.$WJ)}Ie.is=Me;function ge(G){return{selections:G.selections.map(Fe=>s.from(Fe)),related:G.related.map(Fe=>({uri:p.URI.from(Fe.uri),range:o.from(Fe.range)}))}}Ie.from=ge})(Q||(e.MappedEditsContext=Q={}));var $e;(function(Ie){function Me(G){return{start:G.start,end:G.end}}Ie.from=Me;function ge(G){return new a.$gL(G.start,G.end)}Ie.to=ge})($e||(e.NotebookRange=$e={}));var je;(function(Ie){function Me(G){return{timing:typeof G.runStartTime=="number"&&typeof G.runEndTime=="number"?{startTime:G.runStartTime,endTime:G.runEndTime}:void 0,executionOrder:G.executionOrder,success:G.lastRunSuccess}}Ie.to=Me;function ge(G){return{lastRunSuccess:G.success,runStartTime:G.timing?.startTime,runEndTime:G.timing?.endTime,executionOrder:G.executionOrder}}Ie.from=ge})(je||(e.NotebookCellExecutionSummary=je={}));var Oe;(function(Ie){function Me(ge){if(ge===m.NotebookCellExecutionState.Unconfirmed)return a.NotebookCellExecutionState.Pending;if(ge===m.NotebookCellExecutionState.Pending)return;if(ge===m.NotebookCellExecutionState.Executing)return a.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${ge}`)}Ie.to=Me})(Oe||(e.NotebookCellExecutionState=Oe={}));var Qe;(function(Ie){function Me(G){switch(G){case a.NotebookCellKind.Markup:return m.CellKind.Markup;case a.NotebookCellKind.Code:default:return m.CellKind.Code}}Ie.from=Me;function ge(G){switch(G){case m.CellKind.Markup:return a.NotebookCellKind.Markup;case m.CellKind.Code:default:return a.NotebookCellKind.Code}}Ie.to=ge})(Qe||(e.NotebookCellKind=Qe={}));var nt;(function(Ie){function Me(G){const Fe={metadata:G.metadata??Object.create(null),cells:[]};for(const Be of G.cells)a.$hL.validate(Be),Fe.cells.push(gt.from(Be));return Fe}Ie.from=Me;function ge(G){const Fe=new a.$iL(G.cells.map(gt.to));return(0,u.$ye)(G.metadata)||(Fe.metadata=G.metadata),Fe}Ie.to=ge})(nt||(e.NotebookData=nt={}));var gt;(function(Ie){function Me(G){return{cellKind:Qe.from(G.kind),language:G.languageId,mime:G.mime,source:G.value,metadata:G.metadata,internalMetadata:je.from(G.executionSummary??{}),outputs:G.outputs?G.outputs.map(Ft.from):[]}}Ie.from=Me;function ge(G){return new a.$hL(Qe.to(G.cellKind),G.source,G.language,G.mime,G.outputs?G.outputs.map(Ft.to):void 0,G.metadata,G.internalMetadata?je.to(G.internalMetadata):void 0)}Ie.to=ge})(gt||(e.NotebookCellData=gt={}));var vt;(function(Ie){function Me(G){return{mime:G.mime,valueBytes:R.$Hc.wrap(G.data)}}Ie.from=Me;function ge(G){return new a.$jL(G.valueBytes.buffer,G.mime)}Ie.to=ge})(vt||(e.NotebookCellOutputItem=vt={}));var Ft;(function(Ie){function Me(G){return{outputId:G.id,items:G.items.map(vt.from),metadata:G.metadata}}Ie.from=Me;function ge(G){const Fe=G.items.map(vt.to);return new a.$kL(Fe,G.outputId,G.metadata)}Ie.to=ge})(Ft||(e.NotebookCellOutput=Ft={}));var Qt;(function(Ie){function Me(Fe){return G(Fe)?{include:st.from(Fe.include)??void 0,exclude:st.from(Fe.exclude)??void 0}:st.from(Fe)??void 0}Ie.from=Me;function ge(Fe){return G(Fe)?{include:st.to(Fe.include),exclude:st.to(Fe.exclude)}:st.to(Fe)}Ie.to=ge;function G(Fe){const Be=Fe;return Be?!(0,u.$ue)(Be.include)&&!(0,u.$ue)(Be.exclude):!1}})(Qt||(e.NotebookExclusiveDocumentPattern=Qt={}));var Vt;(function(Ie){function Me(ge,G,Fe){const Be=typeof ge.command=="string"?{title:"",command:ge.command}:ge.command;return{alignment:ge.alignment===a.NotebookCellStatusBarAlignment.Left?1:2,command:G.toInternal(Be,Fe),text:ge.text,tooltip:ge.tooltip,accessibilityInformation:ge.accessibilityInformation,priority:ge.priority}}Ie.from=Me})(Vt||(e.NotebookStatusBarItem=Vt={}));var wt;(function(Ie){function Me(ge,G,Fe){const Be=typeof ge.command=="string"?{title:"",command:ge.command}:ge.command;return{command:G.toInternal(Be,Fe),label:ge.label,description:ge.description,detail:ge.detail,documentation:ge.documentation}}Ie.from=Me})(wt||(e.NotebookKernelSourceAction=wt={}));var Tt;(function(Ie){function Me(ge){return{transientOutputs:ge?.transientOutputs??!1,transientCellMetadata:ge?.transientCellMetadata??{},transientDocumentMetadata:ge?.transientDocumentMetadata??{},cellContentMetadata:ge?.cellContentMetadata??{}}}Ie.from=Me})(Tt||(e.NotebookDocumentContentOptions=Tt={}));var zt;(function(Ie){function Me(G){return{uri:G.uri,provides:G.provides}}Ie.from=Me;function ge(G){return new a.$mL(p.URI.revive(G.uri),G.provides)}Ie.to=ge})(zt||(e.NotebookRendererScript=zt={}));var Jt;(function(Ie){function Me(G){return{message:B.fromStrict(G.message)||"",type:0,expected:G.expectedOutput,actual:G.actualOutput,contextValue:G.contextValue,location:G.location&&{range:o.from(G.location.range),uri:G.location.uri}}}Ie.from=Me;function ge(G){const Fe=new a.$sL(typeof G.message=="string"?G.message:B.to(G.message));return Fe.actualOutput=G.actual,Fe.expectedOutput=G.expected,Fe.contextValue=G.contextValue,Fe.location=G.location?J.to(G.location):void 0,Fe}Ie.to=ge})(Jt||(e.TestMessage=Jt={}));var Pt;(function(Ie){Ie.namespace=b.$JI,Ie.denamespace=b.$KI})(Pt||(e.TestTag=Pt={}));var At;(function(Ie){function Me(G){const Fe=(0,i.$QL)(G).controllerId;return{extId:E.$FI.fromExtHostTestItem(G,Fe).toString(),label:G.label,uri:p.URI.revive(G.uri),busy:G.busy,tags:G.tags.map(Be=>Pt.namespace(Fe,Be.id)),range:$.$hs.lift(o.from(G.range)),description:G.description||null,sortText:G.sortText||null,error:G.error&&B.fromStrict(G.error)||null}}Ie.from=Me;function ge(G){return{parent:void 0,error:void 0,id:E.$FI.fromString(G.extId).localId,label:G.label,uri:p.URI.revive(G.uri),tags:(G.tags||[]).map(Fe=>{const{tagId:Be}=Pt.denamespace(Fe);return new a.$tL(Be)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:o.to(G.range||void 0),canResolveChildren:!1,busy:G.busy,description:G.description||void 0,sortText:G.sortText||void 0}}Ie.toPlain=ge})(At||(e.TestItem=At={})),function(Ie){function Me(G){return{id:G.id}}Ie.from=Me;function ge(G){return new a.$tL(G.id)}Ie.to=ge}(Pt||(e.TestTag=Pt={}));var Ot;(function(Ie){const Me=(G,Fe)=>{const Be=[];for(const[We,xe]of Fe)E.$FI.compare(xe.item.extId,We)===2&&(Fe.delete(We),Be.push(xe));const Ge={...At.toPlain(G.item),parent:void 0,taskStates:G.tasks.map(We=>({state:We.state,duration:We.duration,messages:We.messages.filter(xe=>xe.type===0).map(Jt.to)})),children:Be.map(We=>Me(We,Fe))};for(const We of Ge.children)We.parent=Ge;return Ge};function ge(G){const Fe=[],Be=new Map;for(const Ge of G.items){Be.set(Ge.item.extId,Ge);const We=E.$FI.root(Ge.item.extId);G.request.targets.some(xe=>xe.controllerId===We&&xe.testIds.includes(Ge.item.extId))&&Fe.push(Ge)}return{completedAt:G.completedAt,results:Fe.map(Ge=>Me(Ge,Be))}}Ie.to=ge})(Ot||(e.TestResults=Ot={}));var jt;(function(Ie){function Me(Be){return{covered:Be.covered,total:Be.covered}}function ge(Be){return"line"in Be?v.from(Be):o.from(Be)}function G(Be){return"branches"in Be?{count:Be.executionCount,location:ge(Be.location),type:1,branches:Be.branches.length?Be.branches.map(Ge=>({count:Ge.executionCount,location:Ge.location&&ge(Ge.location)})):void 0}:{type:0,count:Be.executionCount,location:ge(Be.location)}}Ie.fromDetailed=G;function Fe(Be){return{uri:Be.uri,statement:Me(Be.statementCoverage),branch:Be.branchCoverage&&Me(Be.branchCoverage),function:Be.functionCoverage&&Me(Be.functionCoverage),details:Be.detailedCoverage?.map(G)}}Ie.fromFile=Fe})(jt||(e.TestCoverage=jt={}));var qt;(function(Ie){function Me(ge){switch(ge){case 1:return a.CodeActionTriggerKind.Invoke;case 2:return a.CodeActionTriggerKind.Automatic}}Ie.to=Me})(qt||(e.CodeActionTriggerKind=qt={}));var Bt;(function(Ie){function Me(G){const Fe=new a.$zL(X.to(G.kind),G.name,G.detail||"",p.URI.revive(G.uri),o.to(G.range),o.to(G.selectionRange));return Fe._sessionId=G._sessionId,Fe._itemId=G._itemId,Fe}Ie.to=Me;function ge(G,Fe,Be){if(Fe=Fe??G._sessionId,Be=Be??G._itemId,Fe===void 0||Be===void 0)throw new Error("invalid item");return{_sessionId:Fe,_itemId:Be,kind:X.from(G.kind),name:G.name,detail:G.detail??"",uri:G.uri,range:o.from(G.range),selectionRange:o.from(G.selectionRange),tags:G.tags?.map(le.from)}}Ie.from=ge})(Bt||(e.TypeHierarchyItem=Bt={}));var at;(function(Ie){function Me(ge){if(ge)return{value:ge.value,tooltip:ge.tooltip}}Ie.from=Me})(at||(e.ViewBadge=at={}));var ut;(function(Ie){function Me(Be,Ge,We){const xe=Ge.fileData;return xe?new a.$KK(new a.$LK(xe.name,p.URI.revive(xe.uri),xe.id,(0,L.$bb)(()=>We(xe.id)))):Be===P.$Er.uriList&&Ge.uriListData?new a.$JK(Fe(Ge.uriListData)):new a.$JK(Ge.asString)}Ie.to=Me;async function ge(Be,Ge){const We=await Ge.asString();if(Be===P.$Er.uriList)return{asString:We,fileData:void 0,uriListData:G(We)};const xe=Ge.asFile();return{asString:We,fileData:xe?{name:xe.name,uri:xe.uri,id:xe._itemId??xe.id}:void 0}}Ie.from=ge;function G(Be){return C.$Qs.split(Be).map(Ge=>{if(Ge.startsWith("#"))return Ge;try{return p.URI.parse(Ge)}catch{}return Ge})}function Fe(Be){return C.$Qs.create(Be.map(Ge=>typeof Ge=="string"?Ge:p.URI.revive(Ge)))}})(ut||(e.DataTransferItem=ut={}));var Ht;(function(Ie){function Me(G,Fe){const Be=G.items.map(([Ge,We])=>[Ge,ut.to(Ge,We,Fe)]);return new a.$MK(Be)}Ie.toDataTransfer=Me;async function ge(G){const Fe={items:[]},Be=[];for(const[Ge,We]of G)Be.push((async()=>{Fe.items.push([Ge,await ut.from(Ge,We)])})());return await Promise.all(Be),Fe}Ie.from=ge})(Ht||(e.DataTransfer=Ht={}));var Ct;(function(Ie){function Me(G){return{message:G.message,metadata:G.metadata,title:G.title,tooltip:G.tooltip}}Ie.to=Me;function ge(G){return{kind:"reply",message:G.message,metadata:G.metadata,title:G.title,tooltip:G.tooltip}}Ie.from=ge})(Ct||(e.ChatReplyFollowup=Ct={}));var kt;(function(Ie){function Me(ge){return typeof ge=="string"?{title:ge,message:ge,kind:"reply"}:"commandId"in ge?{kind:"command",title:ge.title??"",commandId:ge.commandId??"",when:ge.when??"",args:ge.args}:Ct.from(ge)}Ie.from=Me})(kt||(e.ChatFollowup=kt={}));var ht;(function(Ie){function Me(G){const Fe=new a.$JL(St.to(G.role),G.content);return Fe.name=G.name,Fe}Ie.to=Me;function ge(G){return{role:St.from(G.role),content:G.content,name:G.name}}Ie.from=ge})(ht||(e.ChatMessage=ht={}));var St;(function(Ie){function Me(G){switch(G){case 0:return a.ChatMessageRole.System;case 1:return a.ChatMessageRole.User;case 2:return a.ChatMessageRole.Assistant;case 3:return a.ChatMessageRole.Function}}Ie.to=Me;function ge(G){switch(G){case a.ChatMessageRole.System:return 0;case a.ChatMessageRole.Assistant:return 2;case a.ChatMessageRole.Function:return 3;case a.ChatMessageRole.User:default:return 1}}Ie.from=ge})(St||(e.ChatMessageRole=St={}));var Lt;(function(Ie){function Me(G){return{level:Et.to(G.level),value:G.value,description:G.description}}Ie.to=Me;function ge(G){return{level:Et.from(G.level),value:G.value,description:G.description}}Ie.from=ge})(Lt||(e.ChatVariable=Lt={}));var Et;(function(Ie){function Me(G){switch(G){case"short":return a.ChatVariableLevel.Short;case"medium":return a.ChatVariableLevel.Medium;case"full":default:return a.ChatVariableLevel.Full}}Ie.to=Me;function ge(G){switch(G){case a.ChatVariableLevel.Short:return"short";case a.ChatVariableLevel.Medium:return"medium";case a.ChatVariableLevel.Full:default:return"full"}}Ie.from=ge})(Et||(e.ChatVariableLevel=Et={}));var qe;(function(Ie){function Me(ge){switch(ge){case 1:return a.InteractiveEditorResponseFeedbackKind.Helpful;case 0:return a.InteractiveEditorResponseFeedbackKind.Unhelpful;case 2:return a.InteractiveEditorResponseFeedbackKind.Undone;case 3:return a.InteractiveEditorResponseFeedbackKind.Accepted}}Ie.to=Me})(qe||(e.InteractiveEditorResponseFeedbackKind=qe={}));var Nt;(function(Ie){function Me(ge,G,Fe){return"terminalCommand"in ge?{terminalCommand:ge.terminalCommand}:"uri"in ge?{uri:ge.uri}:G.toInternal(ge,Fe)}Ie.from=Me})(Nt||(e.TerminalQuickFix=Nt={}))}),define(Pe[204],Ae([1,0,2,9,7,8,174]),function(pe,e,y,R,C,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pac=void 0;class h{constructor(g,P,D,u={timeout:1500,errors:3}){this.c=g,this.d=P,this.f=D,this.g=u,this.a=new A.$vb,this.b=new WeakMap}dispose(){this.a.clear()}getOnWillSaveTextDocumentEvent(g){return(P,D,u)=>{const $={dispose:this.a.push([P,D,g])};return Array.isArray(u)&&u.push($),$}}async $participateInSave(g,P){const D=y.URI.revive(g);let u=!1;const p=setTimeout(()=>u=!0,this.g.timeout),$=[];try{for(const d of[...this.a]){if(u)break;const t=this.d.getDocument(D),i=await this.h(d,{document:t,reason:L.TextDocumentSaveReason.to(P)});$.push(i)}}finally{clearTimeout(p)}return $}h([g,P,D],u){const p=this.b.get(g);return typeof p=="number"&&p>this.g.errors?Promise.resolve(!1):this.i(D,g,P,u).then(()=>!0,$=>{if(this.c.error(`onWillSaveTextDocument-listener from extension '${D.identifier.value}' threw ERROR`),this.c.error($),!($ instanceof Error)||$.message!=="concurrent_edits"){const d=this.b.get(g);this.b.set(g,d?d+1:1),typeof d=="number"&&d>this.g.errors&&this.c.info(`onWillSaveTextDocument-listener from extension '${D.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}i(g,P,D,u){const p=[],$=Date.now(),{document:d,reason:t}=u,{version:i}=d,c=Object.freeze({document:d,reason:t,waitUntil(m){if(Object.isFrozen(p))throw(0,R.$6)("waitUntil can not be called async");p.push(Promise.resolve(m))}});try{P.apply(D,[c])}catch(m){return Promise.reject(m)}return Object.freeze(p),new Promise((m,E)=>{const b=setTimeout(()=>E(new Error("timeout")),this.g.timeout);return Promise.all(p).then(n=>{this.c.debug(`onWillSaveTextDocument-listener from extension '${g.identifier.value}' finished after ${Date.now()-$}ms`),clearTimeout(b),m(n)}).catch(n=>{clearTimeout(b),E(n)})}).then(m=>{const E={edits:[]};for(const b of m)if(Array.isArray(b)&&b.every(n=>n instanceof C.$2J))for(const{newText:n,newEol:a,range:s}of b)E.edits.push({resource:d.uri,versionId:void 0,textEdit:{range:s&&L.Range.from(s),text:n,eol:a&&L.EndOfLine.from(a)}});if(E.edits.length!==0)return i===d.version?this.f.$tryApplyWorkspaceEdit(E):Promise.reject(new Error("concurrent_edits"))})}}e.$Pac=h}),define(Pe[205],Ae([1,0,12,2,8,7,75]),function(pe,e,y,R,C,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4bc=e.$3bc=void 0;class h{constructor(D,u,p,$){this.start=D,this.deletedCount=u,this.deletedItems=p,this.items=$}asApiEvent(){return{range:new L.$gL(this.start,this.start+this.deletedCount),addedCells:this.items.map(D=>D.apiCell),removedCells:this.deletedItems}}}class S{static asModelAddData(D,u){return{EOL:u.eol,lines:u.source,languageId:u.language,uri:u.uri,isDirty:!1,versionId:1,notebook:D}}constructor(D,u,p){this.notebook=D,this.h=u,this.j=p,this.handle=p.handle,this.uri=R.URI.revive(p.uri),this.cellKind=p.cellKind,this.a=p.outputs.map(C.NotebookCellOutput.to),this.e=p.internalMetadata??{},this.b=Object.freeze(p.metadata??{}),this.d=Object.freeze(C.NotebookCellExecutionSummary.to(p.internalMetadata??{}))}get internalMetadata(){return this.e}get apiCell(){if(!this.f){const D=this,u=this.h.getDocument(this.uri);if(!u)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);const p={get index(){return D.notebook.getCellIndex(D)},notebook:D.notebook.apiNotebook,kind:C.NotebookCellKind.to(this.j.cellKind),document:u.document,get mime(){return D.g},set mime($){D.g=$},get outputs(){return D.a.slice(0)},get metadata(){return D.b},get executionSummary(){return D.d}};this.f=Object.freeze(p)}return this.f}setOutputs(D){this.a=D.map(C.NotebookCellOutput.to)}setOutputItems(D,u,p){const $=p.map(C.NotebookCellOutputItem.to),d=this.a.find(t=>t.id===D);if(d&&(u||(d.items.length=0),d.items.push(...$),d.items.length>1&&d.items.every(t=>A.$ZH(t.mime)))){const t=new Map,i=[];d.items.forEach(c=>{let m;t.has(c.mime)?m=t.get(c.mime):(m=[],t.set(c.mime,m),i.push(c.mime)),m.push(c.data)}),d.items.length=0,i.forEach(c=>{const m=A.$1H(t.get(c));d.items.push({mime:c,data:m.data.buffer})})}}setMetadata(D){this.b=Object.freeze(D)}setInternalMetadata(D){this.e=D,this.d=Object.freeze(C.NotebookCellExecutionSummary.to(D))}setMime(D){}}e.$3bc=S;class g{static{this.a=0}constructor(D,u,p,$,d){this.k=D,this.l=u,this.m=p,this.uri=$,this.handle=g.a++,this.b=[],this.g=0,this.h=!1,this.j=!1,this.d=d.viewType,this.f=Object.freeze(d.metadata??Object.create(null)),this.r([[0,0,d.cells]],!0,void 0),this.g=d.versionId}dispose(){this.j=!0}get versionId(){return this.g}get apiNotebook(){if(!this.e){const D=this,u={get uri(){return D.uri},get version(){return D.g},get notebookType(){return D.d},get isDirty(){return D.h},get isUntitled(){return D.uri.scheme===y.Schemas.untitled},get isClosed(){return D.j},get metadata(){return D.f},get cellCount(){return D.b.length},cellAt(p){return p=D.n(p),D.b[p].apiCell},getCells(p){return(p?D.p(p):D.b).map(d=>d.apiCell)},save(){return D.q()}};this.e=Object.freeze(u)}return this.e}acceptDocumentPropertiesChanged(D){D.metadata&&(this.f=Object.freeze({...this.f,...D.metadata}))}acceptDirty(D){this.h=D}acceptModelChanged(D,u,p){this.g=D.versionId,this.h=u,this.acceptDocumentPropertiesChanged({metadata:p});const $={notebook:this.apiNotebook,metadata:p,cellChanges:[],contentChanges:[]},d=[];for(const i of D.rawEvents)i.kind===A.NotebookCellsChangeType.ModelChange?this.r(i.changes,!1,$.contentChanges):i.kind===A.NotebookCellsChangeType.Move?this.s(i.index,i.length,i.newIdx,$.contentChanges):i.kind===A.NotebookCellsChangeType.Output?(this.t(i.index,i.outputs),d.push({cell:this.b[i.index].apiCell,outputs:this.b[i.index].apiCell.outputs})):i.kind===A.NotebookCellsChangeType.OutputItem?(this.u(i.index,i.outputId,i.append,i.outputItems),d.push({cell:this.b[i.index].apiCell,outputs:this.b[i.index].apiCell.outputs})):i.kind===A.NotebookCellsChangeType.ChangeCellLanguage?(this.v(i.index,i.language),d.push({cell:this.b[i.index].apiCell,document:this.b[i.index].apiCell.document})):i.kind===A.NotebookCellsChangeType.ChangeCellContent?d.push({cell:this.b[i.index].apiCell,document:this.b[i.index].apiCell.document}):i.kind===A.NotebookCellsChangeType.ChangeCellMime?this.w(i.index,i.mime):i.kind===A.NotebookCellsChangeType.ChangeCellMetadata?(this.x(i.index,i.metadata),d.push({cell:this.b[i.index].apiCell,metadata:this.b[i.index].apiCell.metadata})):i.kind===A.NotebookCellsChangeType.ChangeCellInternalMetadata&&(this.y(i.index,i.internalMetadata),d.push({cell:this.b[i.index].apiCell,executionSummary:this.b[i.index].apiCell.executionSummary}));const t=new Map;for(let i=0;i<d.length;i++){const c=d[i],m=t.get(c.cell);if(m===void 0){const E=$.cellChanges.push({document:void 0,executionSummary:void 0,metadata:void 0,outputs:void 0,...c});t.set(c.cell,E-1)}else $.cellChanges[m]={...$.cellChanges[m],...c}}return Object.freeze($),Object.freeze($.cellChanges),Object.freeze($.contentChanges),$}n(D){return D=D|0,D<0?0:D>=this.b.length?this.b.length-1:D}o(D){let u=D.start|0,p=D.end|0;return u<0&&(u=0),p>this.b.length&&(p=this.b.length),D.with({start:u,end:p})}p(D){D=this.o(D);const u=[];for(let p=D.start;p<D.end;p++)u.push(this.b[p]);return u}async q(){return this.j?Promise.reject(new Error("Notebook has been closed")):this.k.$trySaveNotebook(this.uri)}r(D,u,p){if(this.j)return;const $=[],d=[],t=[];if(D.reverse().forEach(i=>{const m=i[2].map(n=>{const a=new S(this,this.l,n);return u||d.push(S.asModelAddData(this.apiNotebook,n)),a}),E=new h(i[0],i[1],[],m),b=this.b.splice(i[0],i[1],...m);for(const n of b)t.push(n.uri),E.deletedItems.push(n.apiCell);$.push(E)}),this.l.acceptDocumentsAndEditorsDelta({addedDocuments:d,removedDocuments:t}),p)for(const i of $)p.push(i.asApiEvent())}s(D,u,p,$){const d=this.b.splice(D,u);this.b.splice(p,0,...d);const t=[new h(D,u,d.map(i=>i.apiCell),[]),new h(p,0,[],d)];for(const i of t)$.push(i.asApiEvent())}t(D,u){this.b[D].setOutputs(u)}u(D,u,p,$){this.b[D].setOutputItems(u,p,$)}v(D,u){const p=this.b[D];p.apiCell.document.languageId!==u&&this.m.$acceptModelLanguageChanged(p.uri,u)}w(D,u){const p=this.b[D];p.apiCell.mime=u}x(D,u){this.b[D].setMetadata(u)}y(D,u){this.b[D].setInternalMetadata(u)}getCellFromApiCell(D){return this.b.find(u=>u.apiCell===D)}getCellFromIndex(D){return this.b[D]}getCell(D){return this.b.find(u=>u.handle===D)}getCellIndex(D){return this.b.indexOf(D)}}e.$4bc=g}),define(Pe[206],Ae([1,0,5,2,8,7]),function(pe,e,y,R,C,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rcc=void 0;class A{constructor(S,g,P,D={timeout:1500,errors:3}){this.b=S,this.c=g,this.d=P,this.f=D,this.a=new y.$jc}dispose(){}getOnWillSaveNotebookDocumentEvent(S){return(g,P,D)=>{const u=function($){g.call(P,$)};return u.extension=S,this.a.event(u,void 0,D)}}async $participateInSave(S,g,P){const D=R.URI.revive(S),u=this.c.getNotebookDocument(D);if(!u)throw new Error("Unable to resolve notebook document");const p=[];if(await this.a.fireAsync({notebook:u.apiNotebook,reason:C.TextDocumentSaveReason.to(g)},P,async(d,t)=>{const i=Date.now(),c=await await Promise.resolve(d);Date.now()-i>this.f.timeout&&this.b.warn("onWillSaveNotebookDocument-listener from extension",t.extension.identifier),!P.isCancellationRequested&&c&&(c instanceof L.$5J?p.push(c):this.b.warn("onWillSaveNotebookDocument-listener from extension",t.extension.identifier,"ignored due to invalid data"))}),P.isCancellationRequested)return!1;if(p.length===0)return!0;const $={edits:[]};for(const d of p){const{edits:t}=C.WorkspaceEdit.from(d);$.edits=$.edits.concat(t)}return this.d.$tryApplyWorkspaceEdit($)}}e.$rcc=A}),define(Pe[104],Ae([1,0,9,8,7]),function(pe,e,y,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5bc=void 0;class L{static{this.apiEditorsToExtHost=new WeakMap}constructor(h,S,g,P,D,u){this.id=h,this.f=S,this.notebookData=g,this.a=[],this.b=[],this.d=!1,this.a=D,this.b=P,this.c=u}get apiEditor(){if(!this.e){const h=this;this.e={get notebook(){return h.notebookData.apiNotebook},get selection(){return h.a[0]},set selection(S){this.selections=[S]},get selections(){return h.a},set selections(S){if(!Array.isArray(S)||!S.every(C.$gL.isNotebookRange))throw(0,y.$5)("selections");h.a=S,h.g(S)},get visibleRanges(){return h.b},revealRange(S,g){h.f.$tryRevealRange(h.id,R.NotebookRange.from(S),g??C.NotebookEditorRevealType.Default)},get viewColumn(){return h.c}},L.apiEditorsToExtHost.set(this.e,this)}return this.e}get visible(){return this.d}_acceptVisibility(h){this.d=h}_acceptVisibleRanges(h){this.b=h}_acceptSelections(h){this.a=h}g(h){this.f.$trySetSelections(this.id,h.map(R.NotebookRange.from))}_acceptViewColumn(h){this.c=h}}e.$5bc=L}),define(Pe[207],Ae([1,0,9,5,14,8]),function(pe,e,y,R,C,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kcc=void 0;let A=class{constructor(S,g){this.c=S,this.d=g,this.a=new R.$hc({onListenerError:y.$Z}),this.b=new R.$hc({onListenerError:y.$Z}),this.onDidChangeNotebookEditorSelection=this.a.event,this.onDidChangeNotebookEditorVisibleRanges=this.b.event}$acceptEditorPropertiesChanged(S,g){this.c.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",S,g);const P=this.d.getEditorById(S);g.visibleRanges&&P._acceptVisibleRanges(g.visibleRanges.ranges.map(L.NotebookRange.to)),g.selections&&P._acceptSelections(g.selections.selections.map(L.NotebookRange.to)),g.visibleRanges&&this.b.fire({notebookEditor:P.apiEditor,visibleRanges:P.apiEditor.visibleRanges}),g.selections&&this.a.fire(Object.freeze({notebookEditor:P.apiEditor,selections:P.apiEditor.selections}))}$acceptEditorViewColumns(S){for(const g in S)this.d.getEditorById(g)._acceptViewColumn(L.ViewColumn.to(S[g]))}};e.$kcc=A,e.$kcc=A=Ke([Ve(0,C.$3i)],A)}),define(Pe[208],Ae([1,0,8,72,153,21,64,9]),function(pe,e,y,R,C,L,A,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$obc=void 0;class S{constructor(u){this.b=0,this.c=new Map,this.a=u}async withProgress(u,p,$){const d=this.b++,{title:t,location:i,cancellable:c}=p,m={label:(0,C.localize)(0,null,u.displayName||u.name),id:u.identifier.value};return this.a.$startProgress(d,{location:y.ProgressLocation.from(i),title:t,source:m,cancellable:c},u.isUnderDevelopment?void 0:u.identifier.value).catch(h.$Z),this.d(d,$,!!c)}d(u,p,$){let d;$&&(d=new L.$rc,this.c.set(u,d));const t=c=>{this.a.$progressEnd(c),this.c.delete(c),d?.dispose()};let i;try{i=p(new P(this.a,u),$&&d?d.token:L.CancellationToken.None)}catch(c){throw t(u),c}return i.then(c=>t(u),c=>t(u)),i}$acceptProgressCanceled(u){const p=this.c.get(u);p&&(p.cancel(),this.c.delete(u))}}e.$obc=S;function g(D,u){return D.message=u.message,typeof u.increment=="number"&&(typeof D.increment=="number"?D.increment+=u.increment:D.increment=u.increment),D}class P extends R.$1u{constructor(u,p){super($=>this.throttledReport($)),this.f=u,this.g=p}throttledReport(u){this.f.$progressReport(this.g,u)}}Ke([(0,A.$6g)(100,(D,u)=>g(D,u),()=>Object.create(null))],P.prototype,"throttledReport",null)}),define(Pe[105],Ae([1,0,44,102,45,76,56,8,2]),function(pe,e,y,R,C,L,A,h,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0L=e.$9L=e.$8L=e.$7L=void 0;const g=(m,E,b,n)=>{let a=E;return{enumerable:!0,configurable:!1,get(){return a},set(s){if(!b(a,s)){const o=a;a=s,m.listener?.(n(s,o))}}}},P=(m,E)=>m===E,D={range:(m,E)=>m===E?!0:!m||!E?!1:m.isEqual(E),label:P,description:P,sortText:P,busy:P,error:P,canResolveChildren:P,tags:(m,E)=>!(m.length!==E.length||m.some(b=>!E.find(n=>b.id===n.id)))},u=m=>E=>({op:4,update:m(E)}),p=(m,E)=>({range:(()=>{let b;const n=u(a=>({range:y.$hs.lift(h.Range.from(a))}));return{enumerable:!0,configurable:!1,get(){return b},set(a){m.listener?.({op:6}),D.range(b,a)||(b=a,m.listener?.(n(a)))}}})(),label:g(m,E,D.label,u(b=>({label:b}))),description:g(m,void 0,D.description,u(b=>({description:b}))),sortText:g(m,void 0,D.sortText,u(b=>({sortText:b}))),canResolveChildren:g(m,!1,D.canResolveChildren,b=>({op:2,state:b})),busy:g(m,!1,D.busy,u(b=>({busy:b}))),error:g(m,void 0,D.error,u(b=>({error:h.MarkdownString.fromStrict(b)||null}))),tags:g(m,[],D.tags,(b,n)=>({op:1,new:b.map(h.TestTag.from),old:n.map(h.TestTag.from)}))}),$=m=>{const E=C.$FI.fromString(m.extId),b=new t(E.controllerId,E.localId,m.label,S.URI.revive(m.uri)||void 0);return b.range=h.Range.to(m.range||void 0),b.description=m.description||void 0,b.sortText=m.sortText||void 0,b.tags=m.tags.map(n=>h.TestTag.to({id:(0,A.$KI)(n).tagId})),b},d=m=>{let E;for(const b of m.tests){const n=$(b.item);(0,R.$QL)(n).parent=E,E=n}return E};e.$7L=d;class t{constructor(E,b,n,a){if(b.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(b)} symbol`);const s=(0,R.$PL)(this,E);Object.defineProperties(this,{id:{value:b,enumerable:!0,writable:!1},uri:{value:a,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return s.parent instanceof i?void 0:s.parent}},children:{value:(0,L.$OL)(s,R.$QL,t),enumerable:!0,writable:!1},...p(s,n)})}}e.$8L=t;class i extends t{constructor(E,b){super(E,E,b,void 0),this._isRoot=!0}}e.$9L=i;class c extends L.$KL{constructor(E,b,n){super({controllerId:E,getDocumentVersion:a=>a&&n.getDocument(a)?.version,getApiFor:R.$QL,getChildren:a=>a.children,root:new i(E,b),toITestItem:h.TestItem.from})}}e.$0L=c}),define(Pe[106],Ae([1,0,50,9,88,8,7]),function(pe,e,y,R,C,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4L=e.$3L=e.$2L=void 0;class h{static{this.c=new C.$ZL("TextEditorDecorationType")}constructor(u,p,$){const d=h.c.nextId();u.$registerTextEditorDecorationType(p.identifier,d,L.DecorationRenderOptions.from($)),this.value=Object.freeze({key:d,dispose(){u.$removeTextEditorDecorationType(d)}})}}e.$2L=h;class S{constructor(u,p){this.g=[],this.h=void 0,this.j=!1,this.c=u,this.d=u.version,this.e=p.undoStopBefore,this.f=p.undoStopAfter}finalize(){return this.j=!0,{documentVersionId:this.d,edits:this.g,setEndOfLine:this.h,undoStopBefore:this.e,undoStopAfter:this.f}}k(){if(this.j)throw new Error("Edit is only valid while callback runs")}replace(u,p){this.k();let $=null;if(u instanceof A.$VJ)$=new A.$WJ(u,u);else if(u instanceof A.$WJ)$=u;else throw new Error("Unrecognized location");this.l($,p,!1)}insert(u,p){this.k(),this.l(new A.$WJ(u,u),p,!0)}delete(u){this.k();let p=null;if(u instanceof A.$WJ)p=u;else throw new Error("Unrecognized location");this.l(p,null,!0)}l(u,p,$){const d=this.c.validateRange(u);this.g.push({range:d,text:p,forceMoveMarkers:$})}setEndOfLine(u){if(this.k(),u!==A.EndOfLine.LF&&u!==A.EndOfLine.CRLF)throw(0,R.$5)("endOfLine");this.h=u}}class g{constructor(u,p,$,d){this.c=u,this.d=p,this._accept($),this.e=d;const t=this;this.value={get tabSize(){return t.f},set tabSize(i){t.m(i)},get indentSize(){return t.g},set indentSize(i){t.o(i)},get insertSpaces(){return t.h},set insertSpaces(i){t.q(i)},get cursorStyle(){return t.j},set cursorStyle(i){t.s(i)},get lineNumbers(){return t.k},set lineNumbers(i){t.t(i)}}}_accept(u){this.f=u.tabSize,this.g=u.indentSize,this.h=u.insertSpaces,this.j=u.cursorStyle,this.k=L.TextEditorLineNumbersStyle.to(u.lineNumbers)}l(u){if(u==="auto")return"auto";if(typeof u=="number"){const p=Math.floor(u);return p>0?p:null}if(typeof u=="string"){const p=parseInt(u,10);return isNaN(p)?null:p>0?p:null}return null}m(u){const p=this.l(u);if(p!==null){if(typeof p=="number"){if(this.f===p)return;this.f=p}this.u("setTabSize",this.c.$trySetOptions(this.d,{tabSize:p}))}}n(u){if(u==="tabSize")return"tabSize";if(typeof u=="number"){const p=Math.floor(u);return p>0?p:null}if(typeof u=="string"){const p=parseInt(u,10);return isNaN(p)?null:p>0?p:null}return null}o(u){const p=this.n(u);if(p!==null){if(typeof p=="number"){if(this.g===p)return;this.g=p}this.u("setIndentSize",this.c.$trySetOptions(this.d,{indentSize:p}))}}p(u){return u==="auto"?"auto":u==="false"?!1:!!u}q(u){const p=this.p(u);if(typeof p=="boolean"){if(this.h===p)return;this.h=p}this.u("setInsertSpaces",this.c.$trySetOptions(this.d,{insertSpaces:p}))}s(u){this.j!==u&&(this.j=u,this.u("setCursorStyle",this.c.$trySetOptions(this.d,{cursorStyle:u})))}t(u){this.k!==u&&(this.k=u,this.u("setLineNumbers",this.c.$trySetOptions(this.d,{lineNumbers:L.TextEditorLineNumbersStyle.from(u)})))}assign(u){const p={};let $=!1;if(typeof u.tabSize<"u"){const d=this.l(u.tabSize);d==="auto"?($=!0,p.tabSize=d):typeof d=="number"&&this.f!==d&&(this.f=d,$=!0,p.tabSize=d)}if(typeof u.indentSize<"u"){const d=this.n(u.indentSize);d==="tabSize"?($=!0,p.indentSize=d):typeof d=="number"&&this.g!==d&&(this.g=d,$=!0,p.indentSize=d)}if(typeof u.insertSpaces<"u"){const d=this.p(u.insertSpaces);d==="auto"?($=!0,p.insertSpaces=d):this.h!==d&&(this.h=d,$=!0,p.insertSpaces=d)}typeof u.cursorStyle<"u"&&this.j!==u.cursorStyle&&(this.j=u.cursorStyle,$=!0,p.cursorStyle=u.cursorStyle),typeof u.lineNumbers<"u"&&this.k!==u.lineNumbers&&(this.k=u.lineNumbers,$=!0,p.lineNumbers=L.TextEditorLineNumbersStyle.from(u.lineNumbers)),$&&this.u("setOptions",this.c.$trySetOptions(this.d,p))}u(u,p){p.catch($=>{this.e.warn(`ExtHostTextEditorOptions '${u}' failed:'`),this.e.warn($)})}}e.$3L=g;class P{constructor(u,p,$,d,t,i,c,m){this.id=u,this.j=p,this.k=$,this.g=!1,this.h=new Set,this.c=t,this.d=new g(this.j,this.id,i,$),this.e=c,this.f=m;const E=this;this.value=Object.freeze({get document(){return d.value},set document(b){throw new R.$7("document")},get selection(){return E.c&&E.c[0]},set selection(b){if(!(b instanceof A.$XJ))throw(0,R.$5)("selection");E.c=[b],E.l()},get selections(){return E.c},set selections(b){if(!Array.isArray(b)||b.some(n=>!(n instanceof A.$XJ)))throw(0,R.$5)("selections");E.c=b,E.l()},get visibleRanges(){return E.e},set visibleRanges(b){throw new R.$7("visibleRanges")},get options(){return E.d.value},set options(b){E.g||E.d.assign(b)},get viewColumn(){return E.f},set viewColumn(b){throw new R.$7("viewColumn")},edit(b,n={undoStopBefore:!0,undoStopAfter:!0}){if(E.g)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const a=new S(d.value,n);return b(a),E.m(a)},insertSnippet(b,n,a={undoStopBefore:!0,undoStopAfter:!0}){if(E.g)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let s;if(!n||Array.isArray(n)&&n.length===0)s=E.c.map(o=>L.Range.from(o));else if(n instanceof A.$VJ){const{lineNumber:o,column:w}=L.Position.from(n);s=[{startLineNumber:o,startColumn:w,endLineNumber:o,endColumn:w}]}else if(n instanceof A.$WJ)s=[L.Range.from(n)];else{s=[];for(const o of n)if(o instanceof A.$WJ)s.push(L.Range.from(o));else{const{lineNumber:w,column:v}=L.Position.from(o);s.push({startLineNumber:w,startColumn:v,endLineNumber:w,endColumn:v})}}return p.$tryInsertSnippet(u,d.value.version,b.value,s,a)},setDecorations(b,n){const a=n.length===0;a&&!E.h.has(b.key)||(a?E.h.delete(b.key):E.h.add(b.key),E.n(()=>{if(L.$RL(n))return p.$trySetDecorations(u,b.key,L.$SL(n));{const s=new Array(4*n.length);for(let o=0,w=n.length;o<w;o++){const v=n[o];s[4*o]=v.start.line+1,s[4*o+1]=v.start.character+1,s[4*o+2]=v.end.line+1,s[4*o+3]=v.end.character+1}return p.$trySetDecorationsFast(u,b.key,s)}}))},revealRange(b,n){E.n(()=>p.$tryRevealRange(u,L.Range.from(b),n||A.TextEditorRevealType.Default))},show(b){p.$tryShowEditor(u,L.ViewColumn.from(b))},hide(){p.$tryHideEditor(u)}})}dispose(){(0,y.ok)(!this.g),this.g=!0}_acceptOptions(u){(0,y.ok)(!this.g),this.d._accept(u)}_acceptVisibleRanges(u){(0,y.ok)(!this.g),this.e=u}_acceptViewColumn(u){(0,y.ok)(!this.g),this.f=u}_acceptSelections(u){(0,y.ok)(!this.g),this.c=u}async l(){const u=this.c.map(L.Selection.from);return await this.n(()=>this.j.$trySetSelections(this.id,u)),this.value}m(u){const p=u.finalize();if(p.edits.length===0&&!p.setEndOfLine)return Promise.resolve(!0);const $=p.edits.map(t=>t.range);$.sort((t,i)=>t.end.line===i.end.line?t.end.character===i.end.character?t.start.line===i.start.line?t.start.character-i.start.character:t.start.line-i.start.line:t.end.character-i.end.character:t.end.line-i.end.line);for(let t=0,i=$.length-1;t<i;t++){const c=$[t].end;if($[t+1].start.isBefore(c))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const d=p.edits.map(t=>({range:L.Range.from(t.range),text:t.text,forceMoveMarkers:t.forceMoveMarkers}));return this.j.$tryApplyEdits(this.id,p.documentVersionId,d,{setEndOfLine:typeof p.setEndOfLine=="number"?L.EndOfLine.from(p.setEndOfLine):void 0,undoStopBefore:p.undoStopBefore,undoStopAfter:p.undoStopAfter})}n(u){return this.g?(this.k.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):u().then(()=>this,p=>(p instanceof Error&&p.name==="DISPOSED"||this.k.warn(p),null))}}e.$4L=P}),define(Pe[209],Ae([1,0,4,172]),function(pe,e,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0I=void 0,e.$0I=(0,y.$Ah)(R.$Gh)}),define(Pe[107],Ae([1,0,20,5,19,6]),function(pe,e,y,R,C,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$42b=e.$32b=e.$22b=e.$12b=e.$Z2b=void 0;class A{constructor(t){this.removedDueToLooping=t}}e.$Z2b=A;class h{static isHostExtension(t,i,c){if(i.getExtensionDescription(t))return!1;const m=c.getExtensionDescription(t);return m?!!((m.main||m.browser)&&m.api==="none"):!1}constructor(t,i){this.h=t,this.c=new R.$hc,this.onDidChange=this.c.event,this.d=i,this.j()}j(){this.d.sort(p),this.e=new y.$Vl,this.f=[],this.g=new Map;for(const t of this.d){if(this.e.has(t.identifier)){console.error("Extension `"+t.identifier.value+"` is already registered");continue}this.e.set(t.identifier,t),this.f.push(t);const i=this.h.readActivationEvents(t);if(Array.isArray(i))for(let c of i)c==="onUri"&&(c=`onUri:${y.$Tl.toKey(t.identifier)}`),this.g.has(c)||this.g.set(c,[]),this.g.get(c).push(t)}}set(t){this.d=t,this.j(),this.c.fire(void 0)}deltaExtensions(t,i){this.d=$(this.d,i),this.d=this.d.concat(t);const c=h.k(this.d);return this.d=$(this.d,c.map(m=>m.identifier)),this.j(),this.c.fire(void 0),new A(c)}static k(t){const i=new class{constructor(){this.c=new Map,this.d=new Set,this.e=[]}addNode(n){this.d.has(n)||(this.d.add(n),this.e.push(n))}addArc(n,a){this.addNode(n),this.addNode(a),this.c.has(n)?this.c.get(n).push(a):this.c.set(n,[a])}getArcs(n){return this.c.has(n)?this.c.get(n):[]}hasOnlyGoodArcs(n,a){const s=i.getArcs(n);for(let o=0;o<s.length;o++)if(!a.has(s[o]))return!1;return!0}getNodes(){return this.e}},c=new y.$Vl;for(const n of t)if(c.set(n.identifier,n),n.extensionDependencies)for(const a of n.extensionDependencies)i.addArc(y.$Tl.toKey(n.identifier),y.$Tl.toKey(a));const m=new Set;i.getNodes().filter(n=>i.getArcs(n).length===0).forEach(n=>m.add(n));const E=i.getNodes().filter(n=>!m.has(n));let b;do{b=!1;for(let n=0;n<E.length;n++){const a=E[n];i.hasOnlyGoodArcs(a,m)&&(E.splice(n,1),n--,m.add(a),b=!0)}}while(b);return E.map(n=>c.get(n))}containsActivationEvent(t){return this.g.has(t)}containsExtension(t){return this.e.has(t)}getExtensionDescriptionsForActivationEvent(t){const i=this.g.get(t);return i?i.slice(0):[]}getAllExtensionDescriptions(){return this.f.slice(0)}getExtensionDescription(t){const i=this.e.get(t);return i||void 0}getExtensionDescriptionByUUID(t){for(const i of this.f)if(i.uuid===t)return i}getExtensionDescriptionByIdOrUUID(t,i){return this.getExtensionDescription(t)??(i?this.getExtensionDescriptionByUUID(i):void 0)}}e.$12b=h,e.$22b={readActivationEvents:d=>d.activationEvents};class S{constructor(t){this.d=new D,this.c=new h(t,[])}async acquireLock(t){const i=await this.d.acquire(t);return new g(this,i)}deltaExtensions(t,i,c){if(!t.isAcquiredFor(this))throw new Error("Lock is not held");return this.c.deltaExtensions(i,c)}containsActivationEvent(t){return this.c.containsActivationEvent(t)}containsExtension(t){return this.c.containsExtension(t)}getExtensionDescriptionsForActivationEvent(t){return this.c.getExtensionDescriptionsForActivationEvent(t)}getAllExtensionDescriptions(){return this.c.getAllExtensionDescriptions()}getExtensionDescription(t){return this.c.getExtensionDescription(t)}getExtensionDescriptionByUUID(t){return this.c.getExtensionDescriptionByUUID(t)}getExtensionDescriptionByIdOrUUID(t,i){return this.c.getExtensionDescriptionByIdOrUUID(t,i)}}e.$32b=S;class g extends L.$mb{constructor(t,i){super(),this.f=t,this.c=!1,this.B(i)}isAcquiredFor(t){return!this.c&&this.f===t}}e.$42b=g;class P{constructor(t){this.name=t,this.promise=new Promise((i,c)=>{this.c=i})}resolve(t){this.c(t)}}class D{constructor(){this.c=[],this.d=!1}async acquire(t){const i=new P(t);return this.c.push(i),this.e(),i.promise}e(){if(this.d||this.c.length===0)return;const t=this.c.shift();this.d=!0;let i=!0;const c=setTimeout(()=>{i&&console.warn(`The customer named ${t.name} has been holding on to the lock for 30s. This might be a problem.`)},30*1e3),m=()=>{i&&(clearTimeout(c),i=!1,this.d=!1,this.e())};t.resolve((0,L.$kb)(m))}}var u;(function(d){d[d.Builtin=0]="Builtin",d[d.User=1]="User",d[d.Dev=2]="Dev"})(u||(u={}));function p(d,t){const i=d.isBuiltin?0:d.isUnderDevelopment?2:1,c=t.isBuiltin?0:t.isUnderDevelopment?2:1;if(i!==c)return i-c;const m=C.$8c.basename(d.extensionLocation.path),E=C.$8c.basename(t.extensionLocation.path);return m<E?-1:m>E?1:0}function $(d,t){const i=new y.$Ul(t);return d.filter(c=>!i.has(c.identifier))}}),define(Pe[79],Ae([1,0,25]),function(pe,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLogMarkers=e.$3l=e.$2l=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0;var R;(function(g){g[g.Desktop=1]="Desktop",g[g.Web=2]="Web"})(R||(e.UIKind=R={}));var C;(function(g){g[g.VersionMismatch=55]="VersionMismatch",g[g.UnexpectedError=81]="UnexpectedError"})(C||(e.ExtensionHostExitCode=C={}));var L;(function(g){g[g.Initialized=0]="Initialized",g[g.Ready=1]="Ready",g[g.Terminate=2]="Terminate"})(L||(e.MessageType=L={}));function A(g){const P=y.$Hc.alloc(1);switch(g){case 0:P.writeUInt8(1,0);break;case 1:P.writeUInt8(2,0);break;case 2:P.writeUInt8(3,0);break}return P}e.$2l=A;function h(g,P){if(g.byteLength!==1)return!1;switch(g.readUInt8(0)){case 1:return P===0;case 2:return P===1;case 3:return P===2;default:return!1}}e.$3l=h;var S;(function(g){g.Start="START_NATIVE_LOG",g.End="END_NATIVE_LOG"})(S||(e.NativeLogMarkers=S={}))}),define(Pe[57],Ae([1,0,4,5,14,27,79,51,52,24,2,6,155]),function(pe,e,y,R,C,L,A,h,S,g,P,D,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cM=e.$bM=e.$aM=e.$_L=void 0;let p=class extends D.$mb{constructor(i,c){super(),this.n=i,this.p=c,this.a=this.B(new R.$hc),this.onDidChangeTelemetryEnabled=this.a.event,this.b=this.B(new R.$hc),this.onDidChangeTelemetryConfiguration=this.b.event,this.c={usage:!0,error:!0},this.f=0,this.g=!1,this.i=!1,this.m=new Map,this.j=P.URI.revive(this.n.environment.extensionTelemetryLogResource),this.i=this.n.environment.isExtensionTelemetryLoggingOnly,this.k=c.createLogger(this.j,{id:S.$co,name:(0,u.localize)(0,null,this.i?" (Not Sent)":""),hidden:!0}),this.B(c.onDidChangeLogLevel(m=>{(0,C.$5i)(m)&&this.r()})),this.k.info("Below are logs for extension telemetry events sent to the telemetry output channel API once the log level is set to trace."),this.k.info("===========================================================")}r(){this.p.setVisibility(this.j,this.g&&this.p.getLogLevel()===C.LogLevel.Trace)}getTelemetryConfiguration(){return this.f===3}getTelemetryDetails(){return{isCrashEnabled:this.f>=1,isErrorsEnabled:this.c.error?this.f>=2:!1,isUsageEnabled:this.c.usage?this.f>=3:!1}}instantiateLogger(i,c,m){const E=this.getTelemetryDetails(),b=new $(c,m,i,this.k,this.i,this.getBuiltInCommonProperties(i),{isUsageEnabled:E.isUsageEnabled,isErrorsEnabled:E.isErrorsEnabled}),n=this.m.get(i.identifier.value)??[];return this.m.set(i.identifier.value,[...n,b]),b.apiTelemetryLogger}$initializeTelemetryLevel(i,c,m){this.f=i,this.g=c,this.c=m??{usage:!0,error:!0},this.r()}getBuiltInCommonProperties(i){const c=Object.create(null);switch(c["common.extname"]=`${i.publisher}.${i.name}`,c["common.extversion"]=i.version,c["common.vscodemachineid"]=this.n.telemetryInfo.machineId,c["common.vscodesessionid"]=this.n.telemetryInfo.sessionId,c["common.vscodeversion"]=this.n.version,c["common.isnewappinstall"]=d(this.n.telemetryInfo.firstSessionDate),c["common.product"]=this.n.environment.appHost,this.n.uiKind){case A.UIKind.Web:c["common.uikind"]="web";break;case A.UIKind.Desktop:c["common.uikind"]="desktop";break;default:c["common.uikind"]="unknown"}return c["common.remotename"]=(0,h.$Nk)((0,S.$jo)(this.n.remote.authority)),c}$onDidChangeTelemetryLevel(i){this.h=this.getTelemetryConfiguration(),this.f=i;const c=this.getTelemetryDetails();this.m.forEach((m,E)=>{const b=m.filter(n=>!n.isDisposed);b.length===0?this.m.delete(E):this.m.set(E,b)}),this.m.forEach(m=>{for(const E of m)E.updateTelemetryEnablements(c.isUsageEnabled,c.isErrorsEnabled)}),this.h!==this.getTelemetryConfiguration()&&this.a.fire(this.getTelemetryConfiguration()),this.b.fire(this.getTelemetryDetails()),this.r()}onExtensionError(i,c){const E=this.m.get(i.value)?.filter(n=>!n.isDisposed);if(!E)return this.m.delete(i.value),!1;let b=!1;for(const n of E)n.ignoreUnhandledExtHostErrors||(n.logError(c),b=!0);return b}};e.$_L=p,e.$_L=p=Ke([Ve(0,L.$$L),Ve(1,C.$4i)],p);class ${static validateSender(i){if(typeof i!="object")throw new TypeError("TelemetrySender argument is invalid");if(typeof i.sendEventData!="function")throw new TypeError("TelemetrySender.sendEventData must be a function");if(typeof i.sendErrorData!="function")throw new TypeError("TelemetrySender.sendErrorData must be a function");if(typeof i.flush<"u"&&typeof i.flush!="function")throw new TypeError("TelemetrySender.flush must be a function or undefined")}constructor(i,c,m,E,b,n,a){this.g=m,this.h=E,this.i=b,this.j=n,this.a=new R.$hc,this.ignoreUnhandledExtHostErrors=c?.ignoreUnhandledErrors??!1,this.b=c?.ignoreBuiltInCommonProperties??!1,this.c=c?.additionalCommonProperties,this.f=i,this.d={isUsageEnabled:a.isUsageEnabled,isErrorsEnabled:a.isErrorsEnabled}}updateTelemetryEnablements(i,c){this.e&&(this.d={isUsageEnabled:i,isErrorsEnabled:c},this.a.fire(this.e))}mixInCommonPropsAndCleanData(i){let c="properties"in i?i.properties??{}:i;return c=(0,S.$mo)(c,[]),this.c&&(c=(0,g.$Wm)(c,this.c)),this.b||(c=(0,g.$Wm)(c,this.j)),"properties"in i?i.properties=c:i=c,i}k(i,c){this.f&&(this.g.publisher==="vscode"?i=this.g.name+"/"+i:i=this.g.identifier.value+"/"+i,c=this.mixInCommonPropsAndCleanData(c||{}),this.i||this.f?.sendEventData(i,c),this.h.trace(i,c))}logUsage(i,c){this.d.isUsageEnabled&&this.k(i,c)}logError(i,c){if(!(!this.d.isErrorsEnabled||!this.f))if(typeof i=="string")this.k(i,c);else{const m={name:i.name,message:i.message,stack:i.stack,cause:i.cause},E=(0,S.$mo)(m,[]),b=new Error(E.message,{cause:E.cause});b.stack=E.stack,b.name=E.name,c=this.mixInCommonPropsAndCleanData(c||{}),this.i||this.f.sendErrorData(b,c),this.h.trace("exception",c)}}get apiTelemetryLogger(){if(!this.e){const i=this,c={logUsage:i.logUsage.bind(i),get isUsageEnabled(){return i.d.isUsageEnabled},get isErrorsEnabled(){return i.d.isErrorsEnabled},logError:i.logError.bind(i),dispose:i.dispose.bind(i),onDidChangeEnableStates:i.a.event.bind(i)};this.e=Object.freeze(c)}return this.e}get isDisposed(){return!this.f}dispose(){if(this.f?.flush){let i=this.f;this.f=void 0,Promise.resolve(i.flush()).then(i=void 0),this.e=void 0}else this.f=void 0}}e.$aM=$;function d(t){const i=Date.now()-new Date(t).getTime();return isNaN(i)?!1:i<1e3*60*60*24}e.$bM=d,e.$cM=(0,y.$zh)("IExtHostTelemetry")}),define(Pe[26],Ae([1,0,5,2,181,98,20,4]),function(pe,e,y,R,C,L,A,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$RF=e.$QF=e.$PF=e.ActivationKind=e.$OF=e.$NF=e.$MF=e.$LF=e.$KF=e.ExtensionHostStartup=e.$JF=e.$IF=e.$HF=e.$GF=void 0,e.$GF=Object.freeze({identifier:new A.$Tl("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:R.URI.parse("void:location"),isBuiltin:!1,targetPlatform:"undefined",isUserBuiltin:!1,isUnderDevelopment:!1}),e.$HF="extensions.webWorker",e.$IF=(0,h.$zh)("extensionService");class S{constructor(b){this.dependency=b}}e.$JF=S;var g;(function(E){E[E.EagerAutoStart=1]="EagerAutoStart",E[E.EagerManualStart=2]="EagerManualStart",E[E.Lazy=3]="Lazy"})(g||(e.ExtensionHostStartup=g={}));class P{constructor(){this.c=[],this.d=[]}toDelta(){return{toRemove:[],toAdd:this.c,addActivationEvents:L.$xF.createActivationEventsMap(this.c),myToRemove:[],myToAdd:this.d}}set(b,n){const a=[],s=[],o=[],w=[],v=D(this.c),I=D(b),k=(W,V)=>W.extensionLocation.toString()===V.extensionLocation.toString()||W.isBuiltin===V.isBuiltin||W.isUserBuiltin===V.isUserBuiltin||W.isUnderDevelopment===V.isUnderDevelopment;for(const W of this.c){const V=I.get(W.identifier);if(!V){a.push(W.identifier),v.delete(W.identifier);continue}if(!k(W,V)){a.push(W.identifier),v.delete(W.identifier);continue}}for(const W of b){const V=v.get(W.identifier);if(!V){s.push(W);continue}if(!k(V,W)){a.push(V.identifier),v.delete(V.identifier);continue}}const r=new A.$Ul(this.d),l=new A.$Ul(n);for(const W of this.d)l.has(W)||o.push(W);for(const W of n)r.has(W)||w.push(W);const f=L.$xF.createActivationEventsMap(s),F={toRemove:a,toAdd:s,addActivationEvents:f,myToRemove:o,myToAdd:w};return this.delta(F),F}delta(b){const{toRemove:n,toAdd:a,myToRemove:s,myToAdd:o}=b,w=new A.$Ul(n),v=new A.$Ul(s);for(let I=0;I<this.c.length;I++)w.has(this.c[I].identifier)&&(this.c.splice(I,1),I--);for(let I=0;I<this.d.length;I++)v.has(this.d[I])&&(this.d.splice(I,1),I--);for(const I of a)this.c.push(I);for(const I of o)this.d.push(I)}containsExtension(b){for(const n of this.d)if(A.$Tl.equals(n,b))return!0;return!1}}e.$KF=P;function D(E){const b=new A.$Vl;for(const n of E)b.set(n.identifier,n);return b}function u(E,b){return E.enabledApiProposals?E.enabledApiProposals.includes(b):!1}e.$LF=u;function p(E,b){if(!u(E,b))throw new Error(`Extension '${E.identifier.value}' CANNOT use API proposal: ${b}.
Its package.json#enabledApiProposals-property declares: ${E.enabledApiProposals?.join(", ")??"[]"} but NOT ${b}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${E.identifier.value}`)}e.$MF=p;class ${constructor(b,n,a,s){this.codeLoadingTime=b,this.activateCallTime=n,this.activateResolvedTime=a,this.activationReason=s}}e.$NF=$;class d{constructor(b,n){this.description=b,this.value=n}}e.$OF=d;var t;(function(E){E[E.Normal=0]="Normal",E[E.Immediate=1]="Immediate"})(t||(e.ActivationKind=t={}));function i(E){return{type:E.isBuiltin?0:1,isBuiltin:E.isBuiltin||E.isUserBuiltin,identifier:{id:(0,C.$so)(E.publisher,E.name),uuid:E.uuid},manifest:E,location:E.extensionLocation,targetPlatform:E.targetPlatform,validations:[],isValid:!0}}e.$PF=i;function c(E,b){return{identifier:new A.$Tl((0,C.$qo)(E.manifest.publisher,E.manifest.name)),isBuiltin:E.type===0,isUserBuiltin:E.type===1&&E.isBuiltin,isUnderDevelopment:!!b,extensionLocation:E.location,...E.manifest,uuid:E.identifier.uuid,targetPlatform:E.targetPlatform}}e.$QF=c;class m{constructor(){this.onDidRegisterExtensions=y.Event.None,this.onDidChangeExtensionsStatus=y.Event.None,this.onDidChangeExtensions=y.Event.None,this.onWillActivateByEvent=y.Event.None,this.onDidChangeResponsiveChange=y.Event.None,this.onWillStop=y.Event.None,this.extensions=[]}activateByEvent(b){return Promise.resolve(void 0)}activationEventIsDone(b){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(b){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPorts(b,n){return Promise.resolve([])}stopExtensionHosts(){}async startExtensionHosts(){}async setRemoteEnvironment(b){}canAddExtension(){return!1}canRemoveExtension(){return!1}}e.$RF=m}),define(Pe[210],Ae([1,0,9,107,20,26,14,13]),function(pe,e,y,R,C,L,A,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vac=e.$Uac=e.$Tac=e.$Sac=e.$Rac=e.$Qac=void 0;class S{static{this.NONE=new S(!1,-1,-1,-1)}constructor(i,c,m,E){this.startup=i,this.codeLoadingTime=c,this.activateCallTime=m,this.activateResolvedTime=E}}e.$Qac=S;class g{constructor(i){this.a=i,this.b=-1,this.c=-1,this.d=-1,this.f=-1,this.g=-1,this.h=-1}j(i,c){return i===-1||c===-1?-1:c-i}build(){return new S(this.a,this.j(this.b,this.c),this.j(this.d,this.f),this.j(this.g,this.h))}codeLoadingStart(){this.b=Date.now()}codeLoadingStop(){this.c=Date.now()}activateCallStart(){this.d=Date.now()}activateCallStop(){this.f=Date.now()}activateResolveStart(){this.g=Date.now()}activateResolveStop(){this.h=Date.now()}}e.$Rac=g;class P{constructor(i,c,m,E,b,n){this.activationFailed=i,this.activationFailedError=c,this.activationTimes=m,this.module=E,this.exports=b,this.subscriptions=n}}e.$Sac=P;class D extends P{constructor(i){super(!1,null,i,{activate:void 0,deactivate:void 0},void 0,[])}}e.$Tac=D;class u extends P{constructor(){super(!1,null,S.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.$Uac=u;class p extends P{constructor(i){super(!0,i,S.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}let $=class{constructor(i,c,m,E){this.g=E,this.a=i,this.b=c,this.c=m,this.d=new C.$Vl,this.f=Object.create(null)}dispose(){for(const[i,c]of this.d)c.dispose()}async waitForActivatingExtensions(){const i=[];for(const[c,m]of this.d)i.push(m.wait());await Promise.all(i)}isActivated(i){const c=this.d.get(i);return!!(c&&c.value)}getActivatedExtension(i){const c=this.d.get(i);if(!c||!c.value)throw new Error(`Extension '${i.value}' is not known or not activated`);return c.value}async activateByEvent(i,c){if(this.f[i])return;const m=this.a.getExtensionDescriptionsForActivationEvent(i);await this.h(m.map(E=>({id:E.identifier,reason:{startup:c,extensionId:E.identifier,activationEvent:i}}))),this.f[i]=!0}activateById(i,c){const m=this.a.getExtensionDescription(i);if(!m)throw new Error(`Extension '${i}' is not known`);return this.h([{id:m.identifier,reason:c}])}async h(i){const c=i.filter(m=>!this.isActivated(m.id)).map(m=>this.j(m));await Promise.all(c.map(m=>m.wait()))}j(i){if(this.d.has(i.id))return this.d.get(i.id);if(this.l(i.id))return this.k(i,null,[],null);const c=this.a.getExtensionDescription(i.id);if(!c){const b=new Error(`Cannot activate unknown extension '${i.id.value}'`),n=this.k(i,null,[],new p(b));return this.c.onExtensionActivationError(i.id,b,new L.$JF(i.id.value)),n}const m=[],E=typeof c.extensionDependencies>"u"?[]:c.extensionDependencies;for(const b of E){if(this.m(b))continue;const n=this.d.get(b);if(n){m.push(n);continue}if(this.l(b)){m.push(this.j({id:this.b.getExtensionDescription(b).identifier,reason:i.reason}));continue}const a=this.a.getExtensionDescription(b);if(a){if(!a.main&&!a.browser)continue;m.push(this.j({id:a.identifier,reason:i.reason}));continue}const s=c.displayName||c.identifier.value,o=new Error(`Cannot activate the '${s}' extension because it depends on unknown extension '${b}'`),w=this.k(i,c.displayName,[],new p(o));return this.c.onExtensionActivationError(c.identifier,o,new L.$JF(b)),w}return this.k(i,c.displayName,m,null)}k(i,c,m,E){const b=new d(i.id,c,i.reason,m,E,this.c,this.g);return this.d.set(i.id,b),b}l(i){return R.$12b.isHostExtension(i,this.a,this.b)}m(i){const c=this.b.getExtensionDescription(i);return c?!c.main&&!c.browser:!1}};e.$Vac=$,e.$Vac=$=Ke([Ve(3,A.$3i)],$);let d=class{get value(){return this.h}get friendlyName(){return this.d||this.c.value}constructor(i,c,m,E,b,n,a){this.c=i,this.d=c,this.f=m,this.g=E,this.h=b,this.j=n,this.k=a,this.a=new h.$Dg,this.b=!1,this.l()}dispose(){this.b=!0}wait(){return this.a.wait()}async l(){await this.m(),this.a.open()}async m(){if(!this.h){for(;this.g.length>0;){for(let i=0;i<this.g.length;i++){const c=this.g[i];if(c.value&&!c.value.activationFailed){this.g.splice(i,1),i--;continue}if(c.value&&c.value.activationFailed){const m=new Error(`Cannot activate the '${this.friendlyName}' extension because its dependency '${c.friendlyName}' failed to activate`);m.detail=c.value.activationFailedError,this.h=new p(m),this.j.onExtensionActivationError(this.c,m,null);return}}this.g.length>0&&await Promise.race(this.g.map(i=>i.wait()))}await this.n()}}async n(){try{this.h=await this.j.actualActivateExtension(this.c,this.f)}catch(i){const c=new Error;if(i&&i.name&&(c.name=i.name),i&&i.message?c.message=`Activating extension '${this.c.value}' failed: ${i.message}.`:c.message=`Activating extension '${this.c.value}' failed: ${i}.`,i&&i.stack&&(c.stack=i.stack),this.h=new p(c),this.b&&y.$2(i))return;this.j.onExtensionActivationError(this.c,c,null),this.k.error(`Activating extension ${this.c.value} failed due to an error:`),this.k.error(i)}}};d=Ke([Ve(6,A.$3i)],d)}),define(Pe[211],Ae([1,0,157,23,2,5,6,193,13,7,16,18,8,49,21,126,26]),function(pe,e,y,R,C,L,A,h,S,g,P,D,u,p,$,d,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vbc=void 0;function i(E,b){if((0,P.$le)(E))return{label:E};if(E&&typeof E=="object"&&typeof E.label=="string"){let n;return Array.isArray(E.highlights)&&(n=E.highlights.filter(a=>a.length===2&&typeof a[0]=="number"&&typeof a[1]=="number"),n=n.length?n:void 0),{label:E.label,highlights:n}}}class c extends A.$mb{constructor(b,n,a){super(),this.f=b,this.g=n,this.h=a,this.a=new Map,this.b=new d.$$6;function s(o){return o&&o.$treeViewId&&(o.$treeItemHandle||o.$selectedTreeItems||o.$focusedTreeItem)}n.registerArgumentProcessor({processArgument:o=>s(o)?this.k(o):Array.isArray(o)&&o.length>0?o.map(w=>s(w)?this.k(w):w):o})}registerTreeDataProvider(b,n,a){const s=this.createTreeView(b,{treeDataProvider:n},a);return{dispose:()=>s.dispose()}}createTreeView(b,n,a){if(!n||!n.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const s=n.dragAndDropController?.dropMimeTypes??[],o=n.dragAndDropController?.dragMimeTypes??[],w=!!n.dragAndDropController?.handleDrag,v=!!n.dragAndDropController?.handleDrop,I=this.j(b,n,a),k={showCollapseAll:!!n.showCollapseAll,canSelectMany:!!n.canSelectMany,dropMimeTypes:s,dragMimeTypes:o,hasHandleDrag:w,hasHandleDrop:v,manuallyManageCheckboxes:!!n.manageCheckboxStateManually},r=this.f.$registerTreeViewDataProvider(b,k),l={get onDidCollapseElement(){return I.onDidCollapseElement},get onDidExpandElement(){return I.onDidExpandElement},get selection(){return I.selectedElements},get onDidChangeSelection(){return I.onDidChangeSelection},get activeItem(){return(0,t.$MF)(a,"treeViewActiveItem"),I.focusedElement},get onDidChangeActiveItem(){return(0,t.$MF)(a,"treeViewActiveItem"),I.onDidChangeActiveItem},get visible(){return I.visible},get onDidChangeVisibility(){return I.onDidChangeVisibility},get onDidChangeCheckboxState(){return I.onDidChangeCheckboxState},get message(){return I.message},set message(f){(0,p.$Xj)(f)&&(0,t.$MF)(a,"treeViewMarkdownMessage"),I.message=f},get title(){return I.title},set title(f){I.title=f},get description(){return I.description},set description(f){I.description=f},get badge(){return I.badge},set badge(f){f!==void 0&&g.ViewBadge.isViewBadge(f)?I.badge={value:Math.floor(Math.abs(f.value)),tooltip:f.tooltip}:f===void 0&&(I.badge=void 0)},reveal:(f,F)=>I.reveal(f,F),dispose:async()=>{await r,this.a.delete(b),I.dispose()}};return this.B(l),l}$getChildren(b,n){const a=this.a.get(b);return a?a.getChildren(n):Promise.reject(new h.$0E(b))}async $handleDrop(b,n,a,s,o,w,v,I){const k=this.a.get(b);if(!k)return Promise.reject(new h.$0E(b));const r=u.DataTransfer.toDataTransfer(a,async l=>(await this.f.$resolveDropFileData(b,n,l)).buffer);return v===b&&I&&await this.i(r,k,I,o,w),k.onDrop(r,s,o)}async i(b,n,a,s,o){const w=this.b.removeDragOperationTransfer(o);if(w)(await w)?.forEach((v,I)=>{v&&b.set(I,v)});else if(o&&n.handleDrag){const v=n.handleDrag(a,b,s);this.b.addDragOperationTransfer(o,v),await v}return b}async $handleDrag(b,n,a,s){const o=this.a.get(b);if(!o)return Promise.reject(new h.$0E(b));const w=await this.i(new g.$MK,o,n,s,a);if(!(!w||s.isCancellationRequested))return u.DataTransfer.from(w)}async $hasResolve(b){const n=this.a.get(b);if(!n)throw new h.$0E(b);return n.hasResolve}$resolve(b,n,a){const s=this.a.get(b);if(!s)throw new h.$0E(b);return s.resolveTreeItem(n,a)}$setExpanded(b,n,a){const s=this.a.get(b);if(!s)throw new h.$0E(b);s.setExpanded(n,a)}$setSelectionAndFocus(b,n,a){const s=this.a.get(b);if(!s)throw new h.$0E(b);s.setSelectionAndFocus(n,a)}$setVisible(b,n){const a=this.a.get(b);if(!a){if(!n)return;throw new h.$0E(b)}a.setVisible(n)}$changeCheckboxState(b,n){const a=this.a.get(b);if(!a)throw new h.$0E(b);a.setCheckboxState(n)}j(b,n,a){const s=this.B(new m(b,n,this.f,this.g.converter,this.h,a));return this.a.set(b,s),s}k(b){const n=this.a.get(b.$treeViewId);return n&&"$treeItemHandle"in b?n.getExtensionElement(b.$treeItemHandle):n&&"$focusedTreeItem"in b&&b.$focusedTreeItem?n.focusedElement:null}}e.$vbc=c;class m extends A.$mb{static{this.a="0"}static{this.b="1"}get visible(){return this.k}get selectedElements(){return this.l.map(b=>this.getExtensionElement(b)).filter(b=>!(0,P.$ue)(b))}get focusedElement(){return this.m?this.getExtensionElement(this.m):void 0}constructor(b,n,a,s,o,w){if(super(),this.D=b,this.F=a,this.G=s,this.H=o,this.I=w,this.h=void 0,this.i=new Map,this.j=new Map,this.k=!1,this.l=[],this.m=void 0,this.r=this.B(new L.$hc),this.onDidExpandElement=this.r.event,this.s=this.B(new L.$hc),this.onDidCollapseElement=this.s.event,this.t=this.B(new L.$hc),this.onDidChangeSelection=this.t.event,this.u=this.B(new L.$hc),this.onDidChangeActiveItem=this.u.event,this.v=this.B(new L.$hc),this.onDidChangeVisibility=this.v.event,this.w=this.B(new L.$hc),this.onDidChangeCheckboxState=this.w.event,this.y=this.B(new L.$hc),this.z=Promise.resolve(),this.C=Promise.resolve(),this.J="",this.L="",this.U=new $.$rc,w.contributes&&w.contributes.views)for(const r in w.contributes.views)for(const l of w.contributes.views[r])l.id===b&&(this.L=l.name);this.f=n.treeDataProvider,this.g=n.dragAndDropController,this.f.onDidChangeTreeData&&this.B(this.f.onDidChangeTreeData(r=>this.y.fire({message:!1,element:r})));let v,I;const k=L.Event.debounce(this.y.event,(r,l)=>(r||(r={message:!1,elements:[]}),l.element!==!1&&(v||(v=new Promise(f=>I=f),this.z=this.z.then(()=>v)),Array.isArray(l.element)?r.elements.push(...l.element):r.elements.push(l.element)),l.message&&(r.message=!0),r),200,!0);this.B(k(({message:r,elements:l})=>{l.length&&(this.C=this.C.then(()=>{const f=I;return v=null,this.W(l).then(()=>f())})),r&&this.F.$setMessage(this.D,u.MarkdownString.fromStrict(this.J)??"")}))}async getChildren(b){const n=b?this.getExtensionElement(b):void 0;if(b&&!n)return this.H.error(`No tree item with id '${b}' found.`),Promise.resolve([]);let a=this.R(b);return a||(a=await this.S(n)),a?a.map(s=>s.item):void 0}getExtensionElement(b){return this.i.get(b)}reveal(b,n){n=n||{select:!0,focus:!1};const a=(0,P.$ue)(n.select)?!0:n.select,s=(0,P.$ue)(n.focus)?!1:n.focus,o=(0,P.$ue)(n.expand)?!1:n.expand;return typeof this.f.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):b?this.z.then(()=>this.O(b)).then(w=>this.Q(b,w[w.length-1]).then(v=>this.F.$reveal(this.D,{item:v.item,parentChain:w.map(I=>I.item)},{select:a,focus:s,expand:o})),w=>this.H.error(w)):this.F.$reveal(this.D,void 0,{select:a,focus:s,expand:o})}get message(){return this.J}set message(b){this.J=b,this.y.fire({message:!0,element:!1})}get title(){return this.L}set title(b){this.L=b,this.F.$setTitle(this.D,b,this.M)}get description(){return this.M}set description(b){this.M=b,this.F.$setTitle(this.D,this.L,b)}get badge(){return this.N}set badge(b){this.N?.value===b?.value&&this.N?.tooltip===b?.tooltip||(this.N=u.ViewBadge.from(b),this.F.$setBadge(this.D,b))}setExpanded(b,n){const a=this.getExtensionElement(b);a&&(n?this.r.fire(Object.freeze({element:a})):this.s.fire(Object.freeze({element:a})))}setSelectionAndFocus(b,n){const a=!(0,D.$of)(this.l,b);this.l=b;const s=this.m!==n;this.m=n,a&&this.t.fire(Object.freeze({selection:this.selectedElements})),s&&this.u.fire(Object.freeze({activeItem:this.focusedElement}))}setVisible(b){b!==this.k&&(this.k=b,this.v.fire(Object.freeze({visible:this.k})))}async setCheckboxState(b){const n=(await Promise.all(b.map(async a=>{const s=this.getExtensionElement(a.treeItemHandle);return s?{extensionItem:s,treeItem:await this.f.getTreeItem(s),newState:a.newState?g.TreeItemCheckboxState.Checked:g.TreeItemCheckboxState.Unchecked}:Promise.resolve(void 0)}))).filter(a=>a!==void 0);n.forEach(a=>{a.treeItem.checkboxState=a.newState?g.TreeItemCheckboxState.Checked:g.TreeItemCheckboxState.Unchecked}),this.w.fire({items:n.map(a=>[a.extensionItem,a.newState])})}async handleDrag(b,n,a){const s=[];for(const o of b){const w=this.getExtensionElement(o);w&&s.push(w)}if(!(!this.g?.handleDrag||s.length===0))return await this.g.handleDrag(s,n,a),n}get hasHandleDrag(){return!!this.g?.handleDrag}async onDrop(b,n,a){const s=n?this.getExtensionElement(n):void 0;if(!(!s&&n||!this.g?.handleDrop))return(0,S.$xg)(()=>this.g?.handleDrop?this.g.handleDrop(s,b,a):void 0)}get hasResolve(){return!!this.f.resolveTreeItem}async resolveTreeItem(b,n){if(!this.f.resolveTreeItem)return;const a=this.i.get(b);if(a){const s=this.j.get(a);if(s){const o=await this.f.resolveTreeItem(s.extensionItem,a,n)??s.extensionItem;return this.db(o),s.item.tooltip=this.ab(o.tooltip),s.item.command=this.bb(s.disposableStore,o.command),s.item}}}O(b){return this.P(b).then(n=>n?this.O(n).then(a=>this.Q(n,a[a.length-1]).then(s=>(a.push(s),a))):Promise.resolve([]))}P(b){const n=this.j.get(b);return n?Promise.resolve(n.parent?this.i.get(n.parent.item.handle):void 0):(0,S.$xg)(()=>this.f.getParent(b))}Q(b,n){const a=this.j.get(b);return a?Promise.resolve(a):(0,S.$xg)(()=>this.f.getTreeItem(b)).then(s=>this.gb(b,s,n,!0)).then(s=>this.getChildren(n?n.item.handle:void 0).then(()=>{const o=this.getExtensionElement(s);if(o){const w=this.j.get(o);if(w)return Promise.resolve(w)}throw new Error(`Cannot resolve tree item for element ${s} from extension ${this.I.identifier.value}`)}))}R(b){if(b){let n;if(typeof b=="string"){const a=this.getExtensionElement(b);n=a?this.j.get(a):void 0}else n=b;return n&&n.children||void 0}return this.h}async S(b){this.nb(b);const n=new $.$rc(this.U.token);try{const a=b?this.j.get(b):void 0,s=await this.f.getChildren(b);if(n.token.isCancellationRequested)return;const o=await Promise.all((0,D.$Af)(s||[]).map(async w=>{const v=await this.f.getTreeItem(w);return v&&!n.token.isCancellationRequested?this.$(w,v,a):null}));return n.token.isCancellationRequested?void 0:(0,D.$Af)(o)}finally{n.dispose()}}W(b){if(b.some(a=>!a))return this.U.dispose(!0),this.U=new $.$rc,this.pb(),this.F.$refresh(this.D);{const a=this.X(b);if(a.length)return this.Y(a)}return Promise.resolve(void 0)}X(b){const n=new Set,a=b.map(o=>this.j.get(o));for(const o of a)if(o&&!n.has(o.item.handle)){let w=o;for(;w&&w.parent&&a.findIndex(v=>w&&w.parent&&v&&v.item.handle===w.parent.item.handle)===-1;){const v=this.i.get(w.parent.item.handle);w=v?this.j.get(v):void 0}w&&!w.parent&&n.add(o.item.handle)}const s=[];return n.forEach(o=>{const w=this.i.get(o);if(w){const v=this.j.get(w);v&&(!v.parent||!n.has(v.parent.item.handle))&&s.push(o)}}),s}Y(b){const n={};return Promise.all(b.map(a=>this.Z(a).then(s=>{s&&(n[a]=s.item)}))).then(()=>Object.keys(n).length?this.F.$refresh(this.D,n):void 0)}Z(b){const n=this.getExtensionElement(b);if(n){const a=this.j.get(n);if(a)return this.nb(n),(0,S.$xg)(()=>this.f.getTreeItem(n)).then(s=>{if(s){const o=this.eb(n,s,a.parent);return this.lb(n,o,a,a.parent),a.dispose(),o}return null})}return Promise.resolve(null)}$(b,n,a){const s=this.eb(b,n,a);if(n.id&&this.i.has(s.item.handle))throw new Error((0,y.localize)(0,null,n.id));return this.kb(b,s),this.mb(s,a),s}ab(b){return g.$jK.isMarkdownString(b)?u.MarkdownString.from(b):b}bb(b,n){return n?{...this.G.toInternal(n,b),originalId:n.command}:void 0}cb(b){if(b.checkboxState===void 0)return;let n,a,s;return typeof b.checkboxState=="number"?n=b.checkboxState:(n=b.checkboxState.state,a=b.checkboxState.tooltip,s=b.checkboxState.accessibilityInformation),{isChecked:n===g.TreeItemCheckboxState.Checked,tooltip:a,accessibilityInformation:s}}db(b){if(!g.$HK.isTreeItem(b,this.I))throw new Error(`Extension ${this.I.identifier.value} has provided an invalid tree item.`)}eb(b,n,a){this.db(n);const s=this.B(new A.$lb),o=this.gb(b,n,a),w=this.hb(n);return{item:{handle:o,parentHandle:a?a.item.handle:void 0,label:i(n.label,this.I),description:n.description,resourceUri:n.resourceUri,tooltip:this.ab(n.tooltip),command:this.bb(s,n.command),contextValue:n.contextValue,icon:w,iconDark:this.ib(n)||w,themeIcon:this.fb(n),collapsibleState:(0,P.$ue)(n.collapsibleState)?g.TreeItemCollapsibleState.None:n.collapsibleState,accessibilityInformation:n.accessibilityInformation,checkbox:this.cb(n)},extensionItem:n,parent:a,children:void 0,disposableStore:s,dispose(){s.dispose()}}}fb(b){return b.iconPath instanceof g.$PK?b.iconPath:void 0}gb(b,{id:n,label:a,resourceUri:s},o,w){if(n)return`${m.b}/${n}`;const v=i(a,this.I),I=o?o.item.handle:m.a;let k=v?v.label:s?(0,R.$dg)(s):"";k=k.indexOf("/")!==-1?k.replace("/","//"):k;const r=this.j.has(b)?this.j.get(b).item.handle:void 0,l=this.R(o)||[];let f,F=0;do{if(f=`${I}/${F}:${k}`,w||!this.i.has(f)||r===f)break;F++}while(F<=l.length);return f}hb(b){if(b.iconPath&&!(b.iconPath instanceof g.$PK))return typeof b.iconPath=="string"||C.URI.isUri(b.iconPath)?this.jb(b.iconPath):this.jb(b.iconPath.light)}ib(b){if(b.iconPath&&!(b.iconPath instanceof g.$PK)&&b.iconPath.dark)return this.jb(b.iconPath.dark)}jb(b){return C.URI.isUri(b)?b:C.URI.file(b)}kb(b,n){this.i.set(n.item.handle,b),this.j.set(b,n)}lb(b,n,a,s){this.i.delete(n.item.handle),this.j.delete(b),n.item.handle!==a.item.handle&&this.i.delete(a.item.handle),this.kb(b,n);const o=this.R(s)||[],w=o.filter(v=>v.item.handle===a.item.handle)[0];w&&o.splice(o.indexOf(w),1,n)}mb(b,n){n?(n.children||(n.children=[]),n.children.push(b)):(this.h||(this.h=[]),this.h.push(b))}nb(b){if(b){const n=this.j.get(b);if(n){if(n.children)for(const a of n.children){const s=this.i.get(a.item.handle);s&&this.ob(s)}n.children=void 0}}else this.pb()}ob(b){const n=this.j.get(b);if(n){if(n.children)for(const a of n.children){const s=this.i.get(a.item.handle);s&&this.ob(s)}this.j.delete(b),this.i.delete(n.item.handle),n.dispose()}}pb(){this.h=void 0,this.i.clear(),this.j.forEach(b=>b.dispose()),this.j.clear()}dispose(){super.dispose(),this.U.dispose(),this.pb(),this.F.$disposeTree(this.D)}}}),define(Pe[212],Ae([1,0]),function(pe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0,e.allApiProposals=Object.freeze({aiRelatedInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiRelatedInformation.d.ts",authGetSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authGetSessions.d.ts",authSession:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts",canonicalUriProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.canonicalUriProvider.d.ts",chat:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chat.d.ts",chatProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatProvider.d.ts",chatRequestAccess:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatRequestAccess.d.ts",chatSlashCommands:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatSlashCommands.d.ts",chatVariables:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatVariables.d.ts",codiconDecoration:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codiconDecoration.d.ts",commentsDraftState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentsDraftState.d.ts",contribCommentEditorActionsMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentEditorActionsMenu.d.ts",contribCommentPeekContext:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts",contribCommentThreadAdditionalMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentThreadAdditionalMenu.d.ts",contribEditSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts",contribEditorContentMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts",contribLabelFormatterWorkspaceTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts",contribMenuBarHome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts",contribMergeEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts",contribNotebookStaticPreloads:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribNotebookStaticPreloads.d.ts",contribRemoteHelp:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts",contribShareMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts",contribStatusBarItems:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribStatusBarItems.d.ts",contribViewsRemote:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts",contribViewsWelcome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts",customEditorMove:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts",debugFocus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.debugFocus.d.ts",diffCommand:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts",diffContentOptions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffContentOptions.d.ts",documentFiltersExclusive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts",documentPaste:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts",dropMetadata:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.dropMetadata.d.ts",editSessionIdentityProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts",editorInsets:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts",envShellEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.envShellEvent.d.ts",extensionRuntime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts",extensionsAny:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts",externalUriOpener:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts",fileComments:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileComments.d.ts",fileSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts",findTextInFiles:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts",fsChunks:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts",handleIssueUri:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.handleIssueUri.d.ts",idToken:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts",indentSize:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.indentSize.d.ts",inlineCompletionsAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts",interactive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactive.d.ts",interactiveUserActions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveUserActions.d.ts",interactiveWindow:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts",ipc:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts",languageConfigurationAutoClosingPairs:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageConfigurationAutoClosingPairs.d.ts",mappedEditsProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.mappedEditsProvider.d.ts",notebookCellExecutionState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts",notebookCodeActions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCodeActions.d.ts",notebookControllerAffinityHidden:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerAffinityHidden.d.ts",notebookDeprecated:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts",notebookExecution:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookExecution.d.ts",notebookKernelSource:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts",notebookLiveShare:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts",notebookMessaging:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts",notebookMime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts",portsAttributes:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts",profileContentHandlers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.profileContentHandlers.d.ts",quickDiffProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickDiffProvider.d.ts",quickPickItemTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickItemTooltip.d.ts",quickPickSortByLabel:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts",readonlyMessage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.readonlyMessage.d.ts",resolvers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts",saveEditor:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.saveEditor.d.ts",scmActionButton:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts",scmSelectedProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts",scmTextDocument:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmTextDocument.d.ts",scmValidation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts",shareProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.shareProvider.d.ts",showLocal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.showLocal.d.ts",tabInputTextMerge:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts",taskPresentationGroup:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts",telemetry:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts",terminalContextMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalContextMenu.d.ts",terminalDataWriteEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts",terminalDimensions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts",terminalExecuteCommandEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalExecuteCommandEvent.d.ts",terminalQuickFixProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalQuickFixProvider.d.ts",terminalSelection:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalSelection.d.ts",testCoverage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testCoverage.d.ts",testMessageContextValue:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testMessageContextValue.d.ts",testObserver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts",textSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts",timeline:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts",tokenInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts",treeViewActiveItem:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewActiveItem.d.ts",treeViewMarkdownMessage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewMarkdownMessage.d.ts",treeViewReveal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts",tunnelFactory:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnelFactory.d.ts",tunnels:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts",windowActivity:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.windowActivity.d.ts",workspaceTrust:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"})}),define(Pe[213],Ae([1,0,167,9,29,92,73,30,20,212,177,98]),function(pe,e,y,R,C,L,A,h,S,g,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$XF=e.$WF=e.$VF=e.$UF=e.$TF=e.$SF=void 0;const u=h.$6m.as(A.$7m.JSONContribution);class p{constructor(b,n,a){this.a=b,this.b=n,this.c=a}d(b,n){this.a({type:b,message:n,extensionId:this.b.identifier,extensionPointId:this.c})}error(b){this.d(C.default.Error,b)}warn(b){this.d(C.default.Warning,b)}info(b){this.d(C.default.Info,b)}}e.$SF=p;class ${static a(b){const n=new S.$Ul;for(let a=0,s=b.length;a<s;a++)n.add(b[a].description.identifier);return n}static compute(b,n){if(!b||!b.length)return new $(n,[]);if(!n||!n.length)return new $([],b);const a=this.a(b),s=this.a(n),o=n.filter(v=>!a.has(v.description.identifier)),w=b.filter(v=>!s.has(v.description.identifier));return new $(o,w)}constructor(b,n){this.added=b,this.removed=n}}e.$TF=$;class d{constructor(b,n){this.name=b,this.defaultExtensionKind=n,this.a=null,this.b=null,this.c=null}setHandler(b){if(this.a!==null)throw new Error("Handler already set!");this.a=b,this.d()}acceptUsers(b){this.c=$.compute(this.b,b),this.b=b,this.d()}d(){if(!(this.a===null||this.b===null||this.c===null))try{this.a(this.b,this.c)}catch(b){(0,R.$Y)(b)}}}e.$UF=d;const t={type:"string",enum:["ui","workspace"],enumDescriptions:[y.localize(0,null),y.localize(1,null)]},i="vscode://schemas/vscode-extensions";e.$VF={properties:{engines:{type:"object",description:y.localize(2,null),properties:{vscode:{type:"string",description:y.localize(3,null),default:"^1.22.0"}}},publisher:{description:y.localize(4,null),type:"string"},displayName:{description:y.localize(5,null),type:"string"},categories:{description:y.localize(6,null),type:"array",uniqueItems:!0,items:{oneOf:[{type:"string",enum:S.$Sl},{type:"string",const:"Languages",deprecationMessage:y.localize(7,null)}]}},galleryBanner:{type:"object",description:y.localize(8,null),properties:{color:{description:y.localize(9,null),type:"string"},theme:{description:y.localize(10,null),type:"string",enum:["dark","light"]}}},contributes:{description:y.localize(11,null),type:"object",properties:{},default:{}},preview:{type:"boolean",description:y.localize(12,null)},enableProposedApi:{type:"boolean",deprecationMessage:y.localize(13,null)},enabledApiProposals:{markdownDescription:y.localize(14,null),type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(g.allApiProposals),markdownEnumDescriptions:Object.values(g.allApiProposals)}},api:{markdownDescription:y.localize(15,null),type:"string",enum:["none"],enumDescriptions:[y.localize(16,null)]},activationEvents:{description:y.localize(17,null),type:"array",items:{type:"string",defaultSnippets:[{label:"onWebviewPanel",description:y.localize(18,null),body:"onWebviewPanel:viewType"},{label:"onLanguage",description:y.localize(19,null),body:"onLanguage:${1:languageId}"},{label:"onCommand",description:y.localize(20,null),body:"onCommand:${2:commandId}"},{label:"onDebug",description:y.localize(21,null),body:"onDebug"},{label:"onDebugInitialConfigurations",description:y.localize(22,null),body:"onDebugInitialConfigurations"},{label:"onDebugDynamicConfigurations",description:y.localize(23,null),body:"onDebugDynamicConfigurations"},{label:"onDebugResolve",description:y.localize(24,null),body:"onDebugResolve:${6:type}"},{label:"onDebugAdapterProtocolTracker",description:y.localize(25,null),body:"onDebugAdapterProtocolTracker:${6:type}"},{label:"workspaceContains",description:y.localize(26,null),body:"workspaceContains:${4:filePattern}"},{label:"onStartupFinished",description:y.localize(27,null),body:"onStartupFinished"},{label:"onTaskType",description:y.localize(28,null),body:"onTaskType:${1:taskType}"},{label:"onFileSystem",description:y.localize(29,null),body:"onFileSystem:${1:scheme}"},{label:"onEditSession",description:y.localize(30,null),body:"onEditSession:${1:scheme}"},{label:"onSearch",description:y.localize(31,null),body:"onSearch:${7:scheme}"},{label:"onView",body:"onView:${5:viewId}",description:y.localize(32,null)},{label:"onUri",body:"onUri",description:y.localize(33,null)},{label:"onOpenExternalUri",body:"onOpenExternalUri",description:y.localize(34,null)},{label:"onCustomEditor",body:"onCustomEditor:${9:viewType}",description:y.localize(35,null)},{label:"onNotebook",body:"onNotebook:${1:type}",description:y.localize(36,null)},{label:"onAuthenticationRequest",body:"onAuthenticationRequest:${11:authenticationProviderId}",description:y.localize(37,null)},{label:"onRenderer",description:y.localize(38,null),body:"onRenderer:${11:rendererId}"},{label:"onTerminalProfile",body:"onTerminalProfile:${1:terminalId}",description:y.localize(39,null)},{label:"onTerminalQuickFixRequest",body:"onTerminalQuickFixRequest:${1:quickFixId}",description:y.localize(40,null)},{label:"onWalkthrough",body:"onWalkthrough:${1:walkthroughID}",description:y.localize(41,null)},{label:"*",description:y.localize(42,null),body:"*"}]}},badges:{type:"array",description:y.localize(43,null),items:{type:"object",required:["url","href","description"],properties:{url:{type:"string",description:y.localize(44,null)},href:{type:"string",description:y.localize(45,null)},description:{type:"string",description:y.localize(46,null)}}}},markdown:{type:"string",description:y.localize(47,null),enum:["github","standard"],default:"github"},qna:{default:"marketplace",description:y.localize(48,null),anyOf:[{type:["string","boolean"],enum:["marketplace",!1]},{type:"string"}]},extensionDependencies:{description:y.localize(49,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:L.$Kn}},extensionPack:{description:y.localize(50,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:L.$Kn}},extensionKind:{description:y.localize(51,null),type:"array",items:t,default:["workspace"],defaultSnippets:[{body:["ui"],description:y.localize(52,null)},{body:["workspace"],description:y.localize(53,null)},{body:["ui","workspace"],description:y.localize(54,null)},{body:["workspace","ui"],description:y.localize(55,null)},{body:[],description:y.localize(56,null)}]},capabilities:{description:y.localize(57,null),type:"object",properties:{virtualWorkspaces:{description:y.localize(58,null),type:["boolean","object"],defaultSnippets:[{label:"limited",body:{supported:"${1:limited}",description:"${2}"}},{label:"false",body:{supported:!1,description:"${2}"}}],default:(!0).valueOf,properties:{supported:{markdownDescription:y.localize(59,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[y.localize(60,null),y.localize(61,null),y.localize(62,null)]},description:{type:"string",markdownDescription:y.localize(63,null)}}},untrustedWorkspaces:{description:y.localize(64,null),type:"object",required:["supported"],defaultSnippets:[{body:{supported:"${1:limited}",description:"${2}"}}],properties:{supported:{markdownDescription:y.localize(65,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[y.localize(66,null),y.localize(67,null),y.localize(68,null)]},restrictedConfigurations:{description:y.localize(69,null),type:"array",items:{type:"string"}},description:{type:"string",markdownDescription:y.localize(70,null)}}}}},sponsor:{description:y.localize(71,null),type:"object",defaultSnippets:[{body:{url:"${1:https:}"}}],properties:{url:{description:y.localize(72,null),type:"string"}}},scripts:{type:"object",properties:{"vscode:prepublish":{description:y.localize(73,null),type:"string"},"vscode:uninstall":{description:y.localize(74,null),type:"string"}}},icon:{type:"string",description:y.localize(75,null)},l10n:{type:"string",description:y.localize(76,null)},pricing:{type:"string",markdownDescription:y.localize(77,null),enum:["Free","Trial"],default:"Free"}}};class c{constructor(){this.a=new Map}registerExtensionPoint(b){if(this.a.has(b.extensionPoint))throw new Error("Duplicate extension point: "+b.extensionPoint);const n=new d(b.extensionPoint,b.defaultExtensionKind);return this.a.set(b.extensionPoint,n),b.activationEventsGenerator&&D.$xF.register(b.extensionPoint,b.activationEventsGenerator),e.$VF.properties.contributes.properties[b.extensionPoint]=b.jsonSchema,u.registerSchema(i,e.$VF),n}getExtensionPoints(){return Array.from(this.a.values())}}e.$WF=c;const m={ExtensionsRegistry:"ExtensionsRegistry"};h.$6m.add(m.ExtensionsRegistry,new c),e.$XF=h.$6m.as(m.ExtensionsRegistry),u.registerSchema(i,e.$VF),u.registerSchema(P.$jj,{properties:{extensionEnabledApiProposals:{description:y.localize(78,null),type:"object",properties:{},additionalProperties:{anyOf:[{type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(g.allApiProposals),markdownEnumDescriptions:Object.values(g.allApiProposals)}}]}}}})}),define(Pe[214],Ae([1,0,164,16,24,213,32,5]),function(pe,e,y,R,C,L,A,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7F=void 0;const S={type:"object",additionalProperties:!1,properties:{type:{type:"string",description:y.localize(0,null)},required:{type:"array",items:{type:"string"}},properties:{type:"object",description:y.localize(1,null),additionalProperties:{$ref:"http://json-schema.org/draft-07/schema#"}},when:{type:"string",markdownDescription:y.localize(2,null),default:""}}};var g;(function(u){function p($,d,t){if(!$)return;const i=R.$le($.type)?$.type:void 0;if(!i||i.length===0){t.error(y.localize(3,null));return}const c=[];if(Array.isArray($.required))for(const m of $.required)R.$le(m)&&c.push(m);return{extensionId:d.value,taskType:i,required:c,properties:$.properties?C.$Tm($.properties):{},when:$.when?A.$Gi.deserialize($.when):void 0}}u.from=p})(g||(g={}));const P=L.$XF.registerExtensionPoint({extensionPoint:"taskDefinitions",activationEventsGenerator:(u,p)=>{for(const $ of u)$.type&&p.push(`onTaskType:${$.type}`)},jsonSchema:{description:y.localize(4,null),type:"array",items:S}});class D{constructor(){this.d=new h.$hc,this.onDefinitionsChanged=this.d.event,this.a=Object.create(null),this.b=new Promise((p,$)=>{P.setHandler((d,t)=>{this.c=void 0;try{for(const i of t.removed){const c=i.value;for(const m of c)this.a&&m.type&&this.a[m.type]&&delete this.a[m.type]}for(const i of t.added){const c=i.value;for(const m of c){const E=g.from(m,i.description.identifier,i.collector);E&&(this.a[E.taskType]=E)}}(t.removed.length>0||t.added.length>0)&&this.d.fire()}catch{}p(void 0)})})}onReady(){return this.b}get(p){return this.a[p]}all(){return Object.keys(this.a).map(p=>this.a[p])}getJsonSchema(){if(this.c===void 0){const p=[];for(const $ of this.all()){const d={type:"object",additionalProperties:!1};$.required.length>0&&(d.required=$.required.slice(0)),$.properties!==void 0?d.properties=C.$Tm($.properties):d.properties=Object.create(null),d.properties.type={type:"string",enum:[$.taskType]},p.push(d)}this.c={oneOf:p}}return this.c}}e.$7F=new D}),define(Pe[215],Ae([1,0,165,16,23,24,32,214]),function(pe,e,y,R,C,L,A,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinition=e.TasksSchemaProperties=e.TaskSettingId=e.KeyedTaskIdentifier=e.TaskEvent=e.TaskRunSource=e.TaskRunType=e.TaskEventKind=e.$eG=e.JsonSchemaVersion=e.ExecutionEngine=e.$dG=e.$cG=e.$bG=e.$aG=e.$_F=e.RunOptions=e.RunOnOptions=e.DependsOrder=e.TaskSourceKind=e.TaskScope=e.TaskGroup=e.CommandString=e.RuntimeType=e.PresentationOptions=e.PanelKind=e.RevealProblemKind=e.RevealKind=e.CommandOptions=e.$$F=e.ShellQuoting=e.$0F=e.$9F=e.$8F=void 0,e.$8F="settings",e.$9F=new A.$Zi("taskRunning",!1,y.localize(0,null)),e.$0F={value:y.localize(1,null),original:"Tasks"};var S;(function(U){U[U.Escape=1]="Escape",U[U.Strong=2]="Strong",U[U.Weak=3]="Weak"})(S||(e.ShellQuoting=S={})),e.$$F="$customized",function(U){function z(ie){if(!ie)return U.Strong;switch(ie.toLowerCase()){case"escape":return U.Escape;case"strong":return U.Strong;case"weak":return U.Weak;default:return U.Strong}}U.from=z}(S||(e.ShellQuoting=S={}));var g;(function(U){U.defaults={cwd:"${workspaceFolder}"}})(g||(e.CommandOptions=g={}));var P;(function(U){U[U.Always=1]="Always",U[U.Silent=2]="Silent",U[U.Never=3]="Never"})(P||(e.RevealKind=P={})),function(U){function z(ie){switch(ie.toLowerCase()){case"always":return U.Always;case"silent":return U.Silent;case"never":return U.Never;default:return U.Always}}U.fromString=z}(P||(e.RevealKind=P={}));var D;(function(U){U[U.Never=1]="Never",U[U.OnProblem=2]="OnProblem",U[U.Always=3]="Always"})(D||(e.RevealProblemKind=D={})),function(U){function z(ie){switch(ie.toLowerCase()){case"always":return U.Always;case"never":return U.Never;case"onproblem":return U.OnProblem;default:return U.OnProblem}}U.fromString=z}(D||(e.RevealProblemKind=D={}));var u;(function(U){U[U.Shared=1]="Shared",U[U.Dedicated=2]="Dedicated",U[U.New=3]="New"})(u||(e.PanelKind=u={})),function(U){function z(ie){switch(ie.toLowerCase()){case"shared":return U.Shared;case"dedicated":return U.Dedicated;case"new":return U.New;default:return U.Shared}}U.fromString=z}(u||(e.PanelKind=u={}));var p;(function(U){U.defaults={echo:!0,reveal:P.Always,revealProblems:D.Never,focus:!1,panel:u.Shared,showReuseMessage:!0,clear:!1}})(p||(e.PresentationOptions=p={}));var $;(function(U){U[U.Shell=1]="Shell",U[U.Process=2]="Process",U[U.CustomExecution=3]="CustomExecution"})($||(e.RuntimeType=$={})),function(U){function z(Y){switch(Y.toLowerCase()){case"shell":return U.Shell;case"process":return U.Process;case"customExecution":return U.CustomExecution;default:return U.Process}}U.fromString=z;function ie(Y){switch(Y){case U.Shell:return"shell";case U.Process:return"process";case U.CustomExecution:return"customExecution";default:return"process"}}U.toString=ie}($||(e.RuntimeType=$={}));var d;(function(U){function z(ie){return R.$le(ie)?ie:ie.value}U.value=z})(d||(e.CommandString=d={}));var t;(function(U){U.Clean={_id:"clean",isDefault:!1},U.Build={_id:"build",isDefault:!1},U.Rebuild={_id:"rebuild",isDefault:!1},U.Test={_id:"test",isDefault:!1};function z(Y){return Y===U.Clean._id||Y===U.Build._id||Y===U.Rebuild._id||Y===U.Test._id}U.is=z;function ie(Y){if(Y!==void 0)return R.$le(Y)?z(Y)?{_id:Y,isDefault:!1}:void 0:Y}U.from=ie})(t||(e.TaskGroup=t={}));var i;(function(U){U[U.Global=1]="Global",U[U.Workspace=2]="Workspace",U[U.Folder=3]="Folder"})(i||(e.TaskScope=i={}));var c;(function(U){U.Workspace="workspace",U.Extension="extension",U.InMemory="inMemory",U.WorkspaceFile="workspaceFile",U.User="user";function z(ie){switch(ie){case U.User:return 2;case U.WorkspaceFile:return 5;default:return 6}}U.toConfigurationTarget=z})(c||(e.TaskSourceKind=c={}));var m;(function(U){U.parallel="parallel",U.sequence="sequence"})(m||(e.DependsOrder=m={}));var E;(function(U){U[U.default=1]="default",U[U.folderOpen=2]="folderOpen"})(E||(e.RunOnOptions=E={}));var b;(function(U){U.defaults={reevaluateOnRerun:!0,runOn:E.default,instanceLimit:1}})(b||(e.RunOptions=b={}));class n{constructor(z,ie,Y,ye,ke,Re){this._label="",this._id=z,ie&&(this._label=ie),Y&&(this.type=Y),this.runOptions=ye,this.configurationProperties=ke,this._source=Re}getDefinition(z){}getMapKey(){return this._id}getRecentlyUsedKey(){}getCommonTaskId(){const z={folder:this.d(),id:this._id};return JSON.stringify(z)}clone(){return this.f(Object.assign({},this))}getWorkspaceFolder(){}getWorkspaceFileName(){}getTelemetryKind(){return"unknown"}matches(z,ie=!1){if(z===void 0)return!1;if(R.$le(z))return z===this._label||z===this.configurationProperties.identifier||ie&&z===this._id;const Y=this.getDefinition(!0);return Y!==void 0&&Y._key===z._key}getQualifiedLabel(){const z=this.getWorkspaceFolder();return z?`${this._label} (${z.name})`:this._label}getTaskExecution(){return{id:this._id,task:this}}addTaskLoadMessages(z){this.c===void 0&&(this.c=[]),z&&(this.c=this.c.concat(z))}get taskLoadMessages(){return this.c}}e.$_F=n;class a extends n{constructor(z,ie,Y,ye,ke,Re,X,le){super(z,Y,void 0,X,le,ie),this.command={},this._source=ie,this.hasDefinedMatchers=Re,ke&&(this.command=ke)}clone(){return new a(this._id,this._source,this._label,this.type,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}customizes(){if(this._source&&this._source.customizes)return this._source.customizes}getDefinition(z=!1){if(z&&this._source.customizes!==void 0)return this._source.customizes;{let ie;switch(this.command?this.command.runtime:void 0){case $.Shell:ie="shell";break;case $.Process:ie="process";break;case $.CustomExecution:ie="customExecution";break;case void 0:ie="$composite";break;default:throw new Error("Unexpected task runtime")}return{type:ie,_key:this._id,id:this._id}}}static is(z){return z instanceof a}getMapKey(){const z=this._source.config.workspaceFolder;return z?`${z.uri.toString()}|${this._id}|${this.instance}`:`${this._id}|${this.instance}`}d(){return this._source.kind===c.User?e.$8F:this._source.config.workspaceFolder?.uri.toString()}getCommonTaskId(){return this._source.customizes?super.getCommonTaskId():this.getRecentlyUsedKey()??super.getCommonTaskId()}getRecentlyUsedKey(){const z=this.d();if(!z)return;let ie=this.configurationProperties.identifier;this._source.kind!==c.Workspace&&(ie+=this._source.kind);const Y={type:e.$$F,folder:z,id:ie};return JSON.stringify(Y)}getWorkspaceFolder(){return this._source.config.workspaceFolder}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?C.$dg(this._source.config.workspace.configuration):void 0}getTelemetryKind(){return this._source.customizes?"workspace>extension":"workspace"}f(z){return new a(z._id,z._source,z._label,z.type,z.command,z.hasDefinedMatchers,z.runOptions,z.configurationProperties)}}e.$aG=a;class s extends n{constructor(z,ie,Y,ye,ke,Re,X){super(z,Y,ye,Re,X,ie),this._source=ie,this.configures=ke}static is(z){return z instanceof s}f(z){return z}getDefinition(){return this.configures}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?C.$dg(this._source.config.workspace.configuration):void 0}getWorkspaceFolder(){return this._source.config.workspaceFolder}d(){return this._source.kind===c.User?e.$8F:this._source.config.workspaceFolder?.uri.toString()}getRecentlyUsedKey(){const z=this.d();if(!z)return;let ie=this.configurationProperties.identifier;this._source.kind!==c.Workspace&&(ie+=this._source.kind);const Y={type:e.$$F,folder:z,id:ie};return JSON.stringify(Y)}}e.$bG=s;class o extends n{constructor(z,ie,Y,ye,ke,Re,X,le,we){super(z,Y,ye,le,we,ie),this.defines=ke,this.hasDefinedMatchers=X,this.command=Re,this.icon=we.icon,this.hide=we.hide}clone(){return new o(this._id,this._source,this._label,this.type,this.defines,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}getDefinition(){return this.defines}static is(z){return z instanceof o}getMapKey(){const z=this._source.workspaceFolder;return z?`${this._source.scope.toString()}|${z.uri.toString()}|${this._id}|${this.instance}`:`${this._source.scope.toString()}|${this._id}|${this.instance}`}d(){if(this._source.scope===3&&this._source.workspaceFolder)return this._source.workspaceFolder.uri.toString()}getRecentlyUsedKey(){const z={type:"contributed",scope:this._source.scope,id:this._id};return z.folder=this.d(),JSON.stringify(z)}getWorkspaceFolder(){return this._source.workspaceFolder}getTelemetryKind(){return"extension"}f(z){return new o(z._id,z._source,z._label,z.type,z.defines,z.command,z.hasDefinedMatchers,z.runOptions,z.configurationProperties)}}e.$cG=o;class w extends n{constructor(z,ie,Y,ye,ke,Re){super(z,Y,ye,ke,Re,ie),this._source=ie}clone(){return new w(this._id,this._source,this._label,this.type,this.runOptions,this.configurationProperties)}static is(z){return z instanceof w}getTelemetryKind(){return"composite"}getMapKey(){return`${this._id}|${this.instance}`}d(){}f(z){return new w(z._id,z._source,z._label,z.type,z.runOptions,z.configurationProperties)}}e.$dG=w;var v;(function(U){U[U.Process=1]="Process",U[U.Terminal=2]="Terminal"})(v||(e.ExecutionEngine=v={})),function(U){U._default=U.Terminal}(v||(e.ExecutionEngine=v={}));var I;(function(U){U[U.V0_1_0=1]="V0_1_0",U[U.V2_0_0=2]="V2_0_0"})(I||(e.JsonSchemaVersion=I={}));class k{constructor(z){this.c=new Map;for(let ie=0;ie<z.length;ie++)this.c.set(z[ie].uri.toString(),ie)}compare(z,ie){const Y=z.getWorkspaceFolder(),ye=ie.getWorkspaceFolder();if(Y&&ye){let ke=this.c.get(Y.uri.toString());ke=ke===void 0?0:ke+1;let Re=this.c.get(ye.uri.toString());return Re=Re===void 0?0:Re+1,ke===Re?z._label.localeCompare(ie._label):ke-Re}else return!Y&&ye?-1:Y&&!ye?1:0}}e.$eG=k;var r;(function(U){U.DependsOnStarted="dependsOnStarted",U.AcquiredInput="acquiredInput",U.Start="start",U.ProcessStarted="processStarted",U.Active="active",U.Inactive="inactive",U.Changed="changed",U.Terminated="terminated",U.ProcessEnded="processEnded",U.End="end"})(r||(e.TaskEventKind=r={}));var l;(function(U){U.SingleRun="singleRun",U.Background="background"})(l||(e.TaskRunType=l={}));var f;(function(U){U[U.System=0]="System",U[U.User=1]="User",U[U.FolderOpen=2]="FolderOpen",U[U.ConfigurationChange=3]="ConfigurationChange",U[U.Reconnect=4]="Reconnect"})(f||(e.TaskRunSource=f={}));var F;(function(U){function z(le){return{taskId:le._id,taskName:le.configurationProperties.name,runType:le.configurationProperties.isBackground?"background":"singleRun",group:le.configurationProperties.group,__task:le}}function ie(le,we,ae){return{...z(le),kind:"start",terminalId:we,resolvedVariables:ae}}U.start=ie;function Y(le,we,ae){return{...z(le),kind:"processStarted",terminalId:we,processId:ae}}U.processStarted=Y;function ye(le,we,ae){return{...z(le),kind:"processEnded",terminalId:we,exitCode:ae}}U.processEnded=ye;function ke(le,we,ae){return{...z(le),kind:"terminated",exitReason:ae,terminalId:we}}U.terminated=ke;function Re(le,we,ae){return{...z(we),kind:le,terminalId:ae}}U.general=Re;function X(){return{kind:"changed"}}U.changed=X})(F||(e.TaskEvent=F={}));var W;(function(U){function z(Y){const ye=Object.keys(Y).sort();let ke="";for(const Re of ye){let X=Y[Re];X instanceof Object?X=z(X):typeof X=="string"&&(X=X.replace(/,/g,",,")),ke+=Re+","+X+","}return ke}function ie(Y){const ke={_key:z(Y),type:Y.taskType};return Object.assign(ke,Y),ke}U.create=ie})(W||(e.KeyedTaskIdentifier=W={}));var V;(function(U){U.AutoDetect="task.autoDetect",U.SaveBeforeRun="task.saveBeforeRun",U.ShowDecorations="task.showDecorations",U.ProblemMatchersNeverPrompt="task.problemMatchers.neverPrompt",U.SlowProviderWarning="task.slowProviderWarning",U.QuickOpenHistory="task.quickOpen.history",U.QuickOpenDetail="task.quickOpen.detail",U.QuickOpenSkip="task.quickOpen.skip",U.QuickOpenShowAll="task.quickOpen.showAll",U.AllowAutomaticTasks="task.allowAutomaticTasks",U.Reconnection="task.reconnection"})(V||(e.TaskSettingId=V={}));var B;(function(U){U.Tasks="tasks",U.SuppressTaskName="tasks.suppressTaskName",U.Windows="tasks.windows",U.Osx="tasks.osx",U.Linux="tasks.linux",U.ShowOutput="tasks.showOutput",U.IsShellCommand="tasks.isShellCommand",U.ServiceTestSetting="tasks.service.testSetting"})(B||(e.TasksSchemaProperties=B={}));var j;(function(U){function z(ie,Y){const ye=h.$7F.get(ie.type);if(ye===void 0){const le=L.$Tm(ie);return delete le._key,W.create(le)}const ke=Object.create(null);ke.type=ye.taskType;const Re=new Set;ye.required.forEach(le=>Re.add(le));const X=ye.properties;for(const le of Object.keys(X)){const we=ie[le];if(we!=null)ke[le]=we;else if(Re.has(le)){const ae=X[le];if(ae.default!==void 0)ke[le]=L.$Tm(ae.default);else switch(ae.type){case"boolean":ke[le]=!1;break;case"number":case"integer":ke[le]=0;break;case"string":ke[le]="";break;default:Y.error(y.localize(2,null,JSON.stringify(ie,void 0,0),le));return}}}return W.create(ke)}U.createTaskIdentifier=z})(j||(e.TaskDefinition=j={}))}),define(Pe[216],Ae([1,0,9]),function(pe,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$62b=e.$52b=void 0;class R{constructor(){this.a=null,this.b=null,this.d=null,this.f=!1,this.g=null,this.h=!1,this.i=null}get[Symbol.toStringTag](){return this.toString()}j(){return this.a||(this.a=new Promise((A,h)=>{this.b=A,this.d=h,this.f&&this.b(this.g),this.h&&this.d(this.i)})),this.a}resolveOk(A){this.f||this.h||(this.f=!0,this.g=A,this.a&&this.b(A))}resolveErr(A){this.f||this.h||(this.h=!0,this.i=A,this.a?this.d(A):(0,y.$Y)(A))}then(A,h){return this.j().then(A,h)}catch(A){return this.j().then(void 0,A)}finally(A){return this.j().finally(A)}}e.$52b=R;class C extends R{constructor(){super(),this.h=!0,this.i=new y.$3}}e.$62b=C}),define(Pe[46],Ae([1,0]),function(pe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_z=e.$$z=e.$0z=e.$9z=void 0;class y{static{this.count=0}constructor(S){this._proxyIdentifierBrand=void 0,this.sid=S,this.nid=++y.count}}e.$9z=y;const R=[];function C(h){const S=new y(h);return R[S.nid]=S,S}e.$0z=C;function L(h){return R[h].sid}e.$$z=L;class A{constructor(S){this.value=S}}e.$_z=A}),define(Pe[3],Ae([1,0,46]),function(pe,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$TJ=e.$SJ=e.ExtHostTestingResource=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.$RJ=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var R;(function(d){d[d.Default=0]="Default",d[d.InCenter=1]="InCenter",d[d.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",d[d.AtTop=3]="AtTop"})(R||(e.TextEditorRevealType=R={}));var C;(function(d){d[d.UnknownInput=0]="UnknownInput",d[d.TextInput=1]="TextInput",d[d.TextDiffInput=2]="TextDiffInput",d[d.TextMergeInput=3]="TextMergeInput",d[d.NotebookInput=4]="NotebookInput",d[d.NotebookDiffInput=5]="NotebookDiffInput",d[d.CustomEditorInput=6]="CustomEditorInput",d[d.WebviewEditorInput=7]="WebviewEditorInput",d[d.TerminalEditorInput=8]="TerminalEditorInput",d[d.InteractiveEditorInput=9]="InteractiveEditorInput"})(C||(e.TabInputKind=C={}));var L;(function(d){d[d.TAB_OPEN=0]="TAB_OPEN",d[d.TAB_CLOSE=1]="TAB_CLOSE",d[d.TAB_UPDATE=2]="TAB_UPDATE",d[d.TAB_MOVE=3]="TAB_MOVE"})(L||(e.TabModelOperationKind=L={}));var A;(function(d){d[d.Editable=0]="Editable",d[d.SupportsHotExit=1]="SupportsHotExit"})(A||(e.WebviewEditorCapabilities=A={}));var h;(function(d){d[d.Int8Array=1]="Int8Array",d[d.Uint8Array=2]="Uint8Array",d[d.Uint8ClampedArray=3]="Uint8ClampedArray",d[d.Int16Array=4]="Int16Array",d[d.Uint16Array=5]="Uint16Array",d[d.Int32Array=6]="Int32Array",d[d.Uint32Array=7]="Uint32Array",d[d.Float32Array=8]="Float32Array",d[d.Float64Array=9]="Float64Array",d[d.BigInt64Array=10]="BigInt64Array",d[d.BigUint64Array=11]="BigUint64Array"})(h||(e.WebviewMessageArrayBufferViewType=h={}));var S;(function(d){d[d.Text=1]="Text",d[d.Error=2]="Error",d[d.Rich=3]="Rich"})(S||(e.CellOutputKind=S={}));var g;(function(d){d[d.Default=0]="Default",d[d.InCenter=1]="InCenter",d[d.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",d[d.AtTop=3]="AtTop"})(g||(e.NotebookEditorRevealType=g={}));var P;(function(d){d[d.None=0]="None",d[d.Process=1]="Process",d[d.Output=2]="Output"})(P||(e.CandidatePortSource=P={}));class D{static{this.a=0}static mixin(t){return t._id=D.a++,t}}e.$RJ=D;var u;(function(d){d.label="a",d.kind="b",d.detail="c",d.documentation="d",d.sortText="e",d.filterText="f",d.preselect="g",d.insertText="h",d.insertTextRules="i",d.range="j",d.commitCharacters="k",d.additionalTextEdits="l",d.kindModifier="m",d.commandIdent="n",d.commandId="o",d.commandArguments="p"})(u||(e.ISuggestDataDtoField=u={}));var p;(function(d){d.defaultRanges="a",d.completions="b",d.isIncomplete="c",d.duration="d"})(p||(e.ISuggestResultDtoField=p={}));var $;(function(d){d[d.Workspace=0]="Workspace",d[d.TextDocument=1]="TextDocument"})($||(e.ExtHostTestingResource=$={})),e.$SJ={MainThreadAuthentication:(0,y.$0z)("MainThreadAuthentication"),MainThreadBulkEdits:(0,y.$0z)("MainThreadBulkEdits"),MainThreadChatProvider:(0,y.$0z)("MainThreadChatProvider"),MainThreadChatSlashCommands:(0,y.$0z)("MainThreadChatSlashCommands"),MainThreadChatVariables:(0,y.$0z)("MainThreadChatVariables"),MainThreadClipboard:(0,y.$0z)("MainThreadClipboard"),MainThreadCommands:(0,y.$0z)("MainThreadCommands"),MainThreadComments:(0,y.$0z)("MainThreadComments"),MainThreadConfiguration:(0,y.$0z)("MainThreadConfiguration"),MainThreadConsole:(0,y.$0z)("MainThreadConsole"),MainThreadDebugService:(0,y.$0z)("MainThreadDebugService"),MainThreadDecorations:(0,y.$0z)("MainThreadDecorations"),MainThreadDiagnostics:(0,y.$0z)("MainThreadDiagnostics"),MainThreadDialogs:(0,y.$0z)("MainThreadDiaglogs"),MainThreadDocuments:(0,y.$0z)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,y.$0z)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,y.$0z)("MainThreadTextEditors"),MainThreadEditorInsets:(0,y.$0z)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,y.$0z)("MainThreadEditorTabs"),MainThreadErrors:(0,y.$0z)("MainThreadErrors"),MainThreadTreeViews:(0,y.$0z)("MainThreadTreeViews"),MainThreadDownloadService:(0,y.$0z)("MainThreadDownloadService"),MainThreadLanguageFeatures:(0,y.$0z)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,y.$0z)("MainThreadLanguages"),MainThreadLogger:(0,y.$0z)("MainThreadLogger"),MainThreadMessageService:(0,y.$0z)("MainThreadMessageService"),MainThreadOutputService:(0,y.$0z)("MainThreadOutputService"),MainThreadProgress:(0,y.$0z)("MainThreadProgress"),MainThreadQuickDiff:(0,y.$0z)("MainThreadQuickDiff"),MainThreadQuickOpen:(0,y.$0z)("MainThreadQuickOpen"),MainThreadStatusBar:(0,y.$0z)("MainThreadStatusBar"),MainThreadSecretState:(0,y.$0z)("MainThreadSecretState"),MainThreadStorage:(0,y.$0z)("MainThreadStorage"),MainThreadTelemetry:(0,y.$0z)("MainThreadTelemetry"),MainThreadTerminalService:(0,y.$0z)("MainThreadTerminalService"),MainThreadWebviews:(0,y.$0z)("MainThreadWebviews"),MainThreadWebviewPanels:(0,y.$0z)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,y.$0z)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,y.$0z)("MainThreadCustomEditors"),MainThreadUrls:(0,y.$0z)("MainThreadUrls"),MainThreadUriOpeners:(0,y.$0z)("MainThreadUriOpeners"),MainThreadProfileContentHandlers:(0,y.$0z)("MainThreadProfileContentHandlers"),MainThreadWorkspace:(0,y.$0z)("MainThreadWorkspace"),MainThreadFileSystem:(0,y.$0z)("MainThreadFileSystem"),MainThreadExtensionService:(0,y.$0z)("MainThreadExtensionService"),MainThreadSCM:(0,y.$0z)("MainThreadSCM"),MainThreadSearch:(0,y.$0z)("MainThreadSearch"),MainThreadShare:(0,y.$0z)("MainThreadShare"),MainThreadTask:(0,y.$0z)("MainThreadTask"),MainThreadWindow:(0,y.$0z)("MainThreadWindow"),MainThreadLabelService:(0,y.$0z)("MainThreadLabelService"),MainThreadNotebook:(0,y.$0z)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,y.$0z)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,y.$0z)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,y.$0z)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,y.$0z)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,y.$0z)("MainThreadInteractive"),MainThreadChat:(0,y.$0z)("MainThreadChat"),MainThreadInlineChat:(0,y.$0z)("MainThreadInlineChatShape"),MainThreadTheming:(0,y.$0z)("MainThreadTheming"),MainThreadTunnelService:(0,y.$0z)("MainThreadTunnelService"),MainThreadManagedSockets:(0,y.$0z)("MainThreadManagedSockets"),MainThreadTimeline:(0,y.$0z)("MainThreadTimeline"),MainThreadTesting:(0,y.$0z)("MainThreadTesting"),MainThreadLocalization:(0,y.$0z)("MainThreadLocalizationShape"),MainThreadAiRelatedInformation:(0,y.$0z)("MainThreadAiRelatedInformation"),MainThreadAiEmbeddingVector:(0,y.$0z)("MainThreadAiEmbeddingVector"),MainThreadIssueReporter:(0,y.$0z)("MainThreadIssueReporter")},e.$TJ={ExtHostCommands:(0,y.$0z)("ExtHostCommands"),ExtHostConfiguration:(0,y.$0z)("ExtHostConfiguration"),ExtHostDiagnostics:(0,y.$0z)("ExtHostDiagnostics"),ExtHostDebugService:(0,y.$0z)("ExtHostDebugService"),ExtHostDecorations:(0,y.$0z)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,y.$0z)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,y.$0z)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,y.$0z)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,y.$0z)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,y.$0z)("ExtHostEditors"),ExtHostTreeViews:(0,y.$0z)("ExtHostTreeViews"),ExtHostFileSystem:(0,y.$0z)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,y.$0z)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,y.$0z)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,y.$0z)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,y.$0z)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,y.$0z)("ExtHostQuickOpen"),ExtHostQuickDiff:(0,y.$0z)("ExtHostQuickDiff"),ExtHostStatusBar:(0,y.$0z)("ExtHostStatusBar"),ExtHostShare:(0,y.$0z)("ExtHostShare"),ExtHostExtensionService:(0,y.$0z)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,y.$0z)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,y.$0z)("ExtHostTerminalService"),ExtHostSCM:(0,y.$0z)("ExtHostSCM"),ExtHostSearch:(0,y.$0z)("ExtHostSearch"),ExtHostTask:(0,y.$0z)("ExtHostTask"),ExtHostWorkspace:(0,y.$0z)("ExtHostWorkspace"),ExtHostWindow:(0,y.$0z)("ExtHostWindow"),ExtHostWebviews:(0,y.$0z)("ExtHostWebviews"),ExtHostWebviewPanels:(0,y.$0z)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,y.$0z)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,y.$0z)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,y.$0z)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,y.$0z)("ExtHostEditorTabs"),ExtHostProgress:(0,y.$0z)("ExtHostProgress"),ExtHostComments:(0,y.$0z)("ExtHostComments"),ExtHostSecretState:(0,y.$0z)("ExtHostSecretState"),ExtHostStorage:(0,y.$0z)("ExtHostStorage"),ExtHostUrls:(0,y.$0z)("ExtHostUrls"),ExtHostUriOpeners:(0,y.$0z)("ExtHostUriOpeners"),ExtHostProfileContentHandlers:(0,y.$0z)("ExtHostProfileContentHandlers"),ExtHostOutputService:(0,y.$0z)("ExtHostOutputService"),ExtHosLabelService:(0,y.$0z)("ExtHostLabelService"),ExtHostNotebook:(0,y.$0z)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,y.$0z)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,y.$0z)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,y.$0z)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,y.$0z)("ExtHostNotebookRenderers"),ExtHostNotebookDocumentSaveParticipant:(0,y.$0z)("ExtHostNotebookDocumentSaveParticipant"),ExtHostInteractive:(0,y.$0z)("ExtHostInteractive"),ExtHostInlineChat:(0,y.$0z)("ExtHostInlineChatShape"),ExtHostChat:(0,y.$0z)("ExtHostChat"),ExtHostChatSlashCommands:(0,y.$0z)("ExtHostChatSlashCommands"),ExtHostChatVariables:(0,y.$0z)("ExtHostChatVariables"),ExtHostChatProvider:(0,y.$0z)("ExtHostChatProvider"),ExtHostAiRelatedInformation:(0,y.$0z)("ExtHostAiRelatedInformation"),ExtHostAiEmbeddingVector:(0,y.$0z)("ExtHostAiEmbeddingVector"),ExtHostTheming:(0,y.$0z)("ExtHostTheming"),ExtHostTunnelService:(0,y.$0z)("ExtHostTunnelService"),ExtHostManagedSockets:(0,y.$0z)("ExtHostManagedSockets"),ExtHostAuthentication:(0,y.$0z)("ExtHostAuthentication"),ExtHostTimeline:(0,y.$0z)("ExtHostTimeline"),ExtHostTesting:(0,y.$0z)("ExtHostTesting"),ExtHostTelemetry:(0,y.$0z)("ExtHostTelemetry"),ExtHostLocalization:(0,y.$0z)("ExtHostLocalization"),ExtHostIssueReporter:(0,y.$0z)("ExtHostIssueReporter")}}),define(Pe[217],Ae([1,0,3,7]),function(pe,e,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xcc=void 0;class C{constructor(A){this.a=new Map,this.b=0,this.c=A.getProxy(y.$SJ.MainThreadAiRelatedInformation)}async $provideAiRelatedInformation(A,h,S){if(this.a.size===0)throw new Error("No related information providers registered");const g=this.a.get(A);if(!g)throw new Error("related information provider not found");return await g.provideRelatedInformation(h,S)??[]}getRelatedInformation(A,h,S){return this.c.$getAiRelatedInformation(h,S)}registerRelatedInformationProvider(A,h,S){const g=this.b;return this.b++,this.a.set(g,S),this.c.$registerAiRelatedInformationProvider(g,h),new R.$UJ(()=>{this.c.$unregisterAiRelatedInformationProvider(g),this.a.delete(g)})}}e.$xcc=C}),define(Pe[80],Ae([1,0,4,14,3,17]),function(pe,e,y,R,C,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bac=e.$Aac=e.$zac=void 0,e.$zac=(0,y.$zh)("IExtHostApiDeprecationService");let A=class{constructor(S,g){this.c=g,this.a=new Set,this.b=S.getProxy(C.$SJ.MainThreadTelemetry)}report(S,g,P){const D=this.d(S,g);this.a.has(D)||(this.a.add(D),g.isUnderDevelopment&&this.c.warn(`[Deprecation Warning] '${S}' is deprecated. ${P}`),this.b.$publicLog2("extHostDeprecatedApiUsage",{extensionId:g.identifier.value,apiId:S}))}d(S,g){return`${S}-${g.identifier.value}`}};e.$Aac=A,e.$Aac=A=Ke([Ve(0,L.$UL),Ve(1,R.$3i)],A),e.$Bac=Object.freeze(new class{report(h,S,g){}})}),define(Pe[218],Ae([1,0,5,3,7,20]),function(pe,e,y,R,C,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8bc=void 0;class A{constructor(g){this.b=new Map,this.c=[],this.d=new y.$hc,this.onDidChangeSessions=this.d.event,this.f=new h,this.g=new h,this.a=g.getProxy(R.$SJ.MainThreadAuthentication)}$setProviders(g){return this.c=g,Promise.resolve()}async getSession(g,P,D,u={}){const p=L.$Tl.toKey(g.identifier),$=[...D].sort().join(" ");return await this.f.getOrCreate(`${p} ${P} ${$}`,async()=>{await this.a.$ensureProvider(P);const d=g.displayName||g.name;return this.a.$getSession(P,D,p,d,u)})}async getSessions(g,P,D){const u=L.$Tl.toKey(g.identifier),p=[...D].sort().join(" ");return await this.g.getOrCreate(`${u} ${p}`,async()=>{await this.a.$ensureProvider(P);const $=g.displayName||g.name;return this.a.$getSessions(P,D,u,$)})}async removeSession(g,P){const D=this.b.get(g);return D?D.provider.removeSession(P):this.a.$removeSession(g,P)}registerAuthenticationProvider(g,P,D,u){if(this.b.get(g))throw new Error(`An authentication provider with id '${g}' is already registered.`);this.b.set(g,{label:P,provider:D,options:u??{supportsMultipleAccounts:!1}}),this.c.find($=>$.id===g)||this.c.push({id:g,label:P});const p=D.onDidChangeSessions($=>{this.a.$sendDidChangeSessions(g,{added:$.added??[],changed:$.changed??[],removed:$.removed??[]})});return this.a.$registerAuthenticationProvider(g,P,u?.supportsMultipleAccounts??!1),new C.$UJ(()=>{p.dispose(),this.b.delete(g);const $=this.c.findIndex(d=>d.id===g);$>-1&&this.c.splice($),this.a.$unregisterAuthenticationProvider(g)})}$createSession(g,P,D){const u=this.b.get(g);if(u)return Promise.resolve(u.provider.createSession(P,D));throw new Error(`Unable to find authentication provider with handle: ${g}`)}$removeSession(g,P){const D=this.b.get(g);if(D)return Promise.resolve(D.provider.removeSession(P));throw new Error(`Unable to find authentication provider with handle: ${g}`)}$getSessions(g,P){const D=this.b.get(g);if(D)return Promise.resolve(D.provider.getSessions(P));throw new Error(`Unable to find authentication provider with handle: ${g}`)}$onDidChangeAuthenticationSessions(g,P){return this.d.fire({provider:{id:g,label:P}}),Promise.resolve()}}e.$8bc=A;class h{constructor(){this.a=new Map}getOrCreate(g,P){const D=this.a.get(g);if(D)return D;const u=P().finally(()=>this.a.delete(g));return this.a.set(g,u),u}}}),define(Pe[219],Ae([1,0,3,17,8]),function(pe,e,y,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bcc=void 0;let L=class{constructor(h,S){this.a=h.getProxy(y.$SJ.MainThreadBulkEdits),this.b={getTextDocumentVersion:g=>S.getDocument(g)?.version,getNotebookDocumentVersion:()=>{}}}applyWorkspaceEdit(h,S,g){const P=C.WorkspaceEdit.from(h,this.b);return this.a.$tryApplyWorkspaceEdit(P,void 0,g?.isRefactoring??!1)}};e.$bcc=L,e.$bcc=L=Ke([Ve(0,R.$UL)],L)}),define(Pe[220],Ae([1,0,13,5,66,6,58,147,3,8]),function(pe,e,y,R,C,L,A,h,S,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pcc=void 0;class P{static{this.a=0}constructor(p,$){this.extension=p,this.provider=$,this.handle=P.a++}}class D{static{this.a=0}constructor(p,$){this.h=$,this.b=new Map,this.d=new Map,this.e=new R.$hc,this.onDidPerformUserAction=this.e.event,this.g=p.getProxy(S.$SJ.MainThreadChat)}registerChatProvider(p,$,d){const t=new P(p,d);return this.b.set(t.handle,t),this.g.$registerChatProvider(t.handle,$),(0,L.$kb)(()=>{this.g.$unregisterChatProvider(t.handle),this.b.delete(t.handle)})}transferChatSession(p,$){const d=C.Iterable.find(this.d.keys(),t=>this.d.get(t)===p)??0;typeof d=="number"&&this.g.$transferChatSession(d,$)}addChatRequest(p){this.g.$addRequest(p)}sendInteractiveRequestToProvider(p,$){this.g.$sendRequestToProvider(p,$)}async $prepareChat(p,$,d){const t=this.b.get(p);if(!t)return;const i=await t.provider.prepareSession($,d);if(!i)return;const c=D.a++;return this.d.set(c,i),{id:c,requesterUsername:i.requester?.name,requesterAvatarIconUri:i.requester?.icon,responderUsername:i.responder?.name,responderAvatarIconUri:i.responder?.icon,inputPlaceholder:i.inputPlaceholder}}async $resolveRequest(p,$,d,t){const i=this.b.get(p);if(!i)return;const c=this.d.get($);if(!c||!i.provider.resolveRequest)return;const m=await i.provider.resolveRequest(c,d,t);if(m)return{message:typeof m.message=="string"?m.message:g.ChatReplyFollowup.from(m.message)}}async $provideWelcomeMessage(p,$){const d=this.b.get(p);if(!d||!d.provider.provideWelcomeMessage)return;const t=await d.provider.provideWelcomeMessage($);if(t)return t.map(i=>typeof i=="string"?i:i.map(c=>g.ChatReplyFollowup.from(c)))}async $provideFollowups(p,$,d){const t=this.b.get(p);if(!t)return;const i=this.d.get($);return!i||!t.provider.provideFollowups?void 0:(await t.provider.provideFollowups(i,d))?.map(m=>g.ChatFollowup.from(m))}$removeRequest(p,$,d){const t=this.b.get(p);if(!t)return;const i=this.d.get($);i&&t.provider.removeRequest&&t.provider.removeRequest(i,d)}async $provideReply(p,$,d,t){const i=this.b.get(p);if(!i)return;const c=this.d.get($);if(!c)return;const m={session:c,message:typeof d.message=="string"?d.message:g.ChatReplyFollowup.to(d.message),variables:{}};if(d.variables)for(const o of Object.keys(d.variables))m.variables[o]=d.variables[o].map(g.ChatVariable.to);const E=A.$dc.create(!1);let b;const n={report:o=>{if(!t.isCancellationRequested)if(typeof b>"u"&&(b=E.elapsed()),"responseId"in o)this.g.$acceptResponseProgress(p,$,{requestId:o.responseId});else if("placeholder"in o&&"resolvedContent"in o){const w=Promise.all([this.g.$acceptResponseProgress(p,$,{placeholder:o.placeholder}),o.resolvedContent]);(0,y.$tg)(w,t).then(v=>{if(!v)return;const[I,k]=v;this.g.$acceptResponseProgress(p,$,k,I??void 0)})}else"content"in o?this.g.$acceptResponseProgress(p,$,{content:typeof o.content=="string"?o.content:g.MarkdownString.from(o.content)}):this.g.$acceptResponseProgress(p,$,o)}};let a;try{a=await i.provider.provideResponseWithProgress(m,n,t),a||(a={errorDetails:{message:(0,h.localize)(0,null)}})}catch(o){a={errorDetails:{message:(0,h.localize)(1,null,o.message),responseIsIncomplete:!0}},this.h.error(o)}try{if(c.saveState&&this.d.has($)){const o=c.saveState();this.g.$acceptChatState($,o)}}catch(o){this.h.warn(o)}const s={firstProgress:b??0,totalElapsed:E.elapsed()};return{errorDetails:a.errorDetails,timings:s}}async $provideSlashCommands(p,$,d){const t=this.b.get(p);if(!t)return;const i=this.d.get($);return!i||!t.provider.provideSlashCommands?void 0:(await t.provider.provideSlashCommands(i,d))?.map(m=>({...m,kind:g.CompletionItemKind.from(m.kind)}))}$releaseSession(p){this.d.delete(p)}async $onDidPerformUserAction(p){this.e.fire(p)}}e.$pcc=D}),define(Pe[221],Ae([1,0,6,3,8,72,20]),function(pe,e,y,R,C,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ucc=void 0;class h{static{this.a=1}constructor(g,P){this.d=P,this.c=new Map,this.e=new Map,this.f=new A.$Vl,this.b=g.getProxy(R.$SJ.MainThreadChatProvider)}registerProvider(g,P,D,u){const p=h.a++;return this.c.set(p,{extension:g,provider:D}),this.b.$registerProvider(p,P,{extension:g,displayName:u.name??g.value}),(0,y.$kb)(()=>{this.b.$unregisterProvider(p),this.c.delete(p)})}async $provideChatResponse(g,P,D,u,p){const $=this.c.get(g);if(!$)return;const d=new L.$1u(async t=>{if(p.isCancellationRequested){this.d.warn(`[CHAT](${$.extension.value}) CANNOT send progress because the REQUEST IS CANCELLED`);return}await this.b.$handleProgressChunk(P,{index:t.index,part:t.part})},{async:!0});return $.provider.provideChatResponse(D.map(C.ChatMessage.to),u,d,p)}allowListExtensionWhile(g,P){this.f.set(g,P),P.finally(()=>this.f.delete(g))}async requestChatResponseProvider(g,P){if(!this.f.has(g))throw new Error("Extension is NOT allowed to make chat requests");const D=this;return{get isRevoked(){return!D.f.has(g)},async makeRequest(u,p,$,d){if(!D.f.has(g))throw new Error("Access to chat has been revoked");const t=Math.random()*1e6|0;D.e.set(t,$);try{await D.b.$fetchResponse(g,P,t,u.map(C.ChatMessage.from),p,d)}finally{D.e.delete(t)}}}}async $handleResponseFragment(g,P){this.e.get(g)?.report(P)}}e.$ucc=h}),define(Pe[222],Ae([1,0,6,3,7,8,72,13]),function(pe,e,y,R,C,L,A,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vcc=void 0;class S{static{this.a=0}constructor(D,u,p){this.d=u,this.e=p,this.b=new Map,this.c=D.getProxy(R.$SJ.MainThreadChatSlashCommands)}registerCommand(D,u,p,$){const d=S.a++;return this.b.set(d,{extension:D,command:p}),this.c.$registerCommand(d,u,$.description),(0,y.$kb)(()=>{this.c.$unregisterCommand(d),this.b.delete(d)})}async $executeCommand(D,u,p,$,d){const t=this.b.get(D);if(!t){this.e.warn(`[CHAT](${D}) CANNOT execute command because the command is not registered`);return}let i=!1;function c(){if(i)throw new Error("Only valid while executing the command")}const m=new h.$Zg;d.onCancellationRequested(()=>m.complete()),setTimeout(()=>m.complete(),3*1e3),this.d.allowListExtensionWhile(t.extension,m.p);const E=t.command({role:C.ChatMessageRole.User,content:p},{history:$.history.map(L.ChatMessage.to)},new A.$1u(b=>{c(),this.c.$handleProgressChunk(u,{content:g(b.message)?b.message:b.message.value})}),d);try{return await(0,h.$tg)(Promise.resolve(E).then(b=>{if(b&&"followUp"in b)return{followUp:b?.followUp?.map(a=>L.ChatFollowup.from(a))}}),d)}finally{i=!0,m.complete()}}}e.$vcc=S;function g(P){return!!P&&typeof P=="object"&&"treeData"in P}}),define(Pe[223],Ae([1,0,6,3,9,8]),function(pe,e,y,R,C,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wcc=void 0;class A{static{this.a=0}constructor(S){this.b=new Map,this.c=S.getProxy(R.$SJ.MainThreadChatVariables)}async $resolveVariable(S,g,P){const D=this.b.get(S);if(D)try{const u=await D.resolver.resolve(D.data.name,{message:g},P);if(u)return u.map(L.ChatVariable.from)}catch(u){(0,C.$Z)(u)}}registerVariableResolver(S,g,P,D){const u=A.a++;return this.b.set(u,{extension:S.identifier,data:{name:g,description:P},resolver:D}),this.c.$registerVariable(u,{name:g,description:P}),(0,y.$kb)(()=>{this.b.delete(u),this.c.$unregisterVariable(u)})}}e.$wcc=A}),define(Pe[224],Ae([1,0,3]),function(pe,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Eac=void 0;class R{constructor(L){const A=L.getProxy(y.$SJ.MainThreadClipboard);this.value=Object.freeze({readText(){return A.$readText()},writeText(h){return A.$writeText(h)}})}}e.$Eac=R}),define(Pe[31],Ae([1,0,16,7,8,24,3,18,14,68,44,278,2,6,4,17,105,25,46,41,58,52,57]),function(pe,e,y,R,C,L,A,h,S,g,P,D,u,p,$,d,t,i,c,m,E,b,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iM=e.$hM=e.$gM=e.$fM=e.$eM=e.$dM=void 0;let a=class{#e;#t;#i;constructor(k,r,l){this.b=new Map,this.c=new Map,this.#e=k.getProxy(A.$SJ.MainThreadCommands),this.d=r,this.#i=l,this.#t=k.getProxy(A.$SJ.MainThreadTelemetry),this.converter=new s(this,f=>{const F=this.c.get(f);return F?.result===w.Void?F:void 0},r),this.f=[{processArgument(f){return(0,g.$9g)(f)}},{processArgument(f){return(0,L.$Vm)(f,function(F){if(P.$hs.isIRange(F))return C.Range.to(F);if(D.$gs.isIPosition(F))return C.Position.to(F);if(P.$hs.isIRange(F.range)&&u.URI.isUri(F.uri))return C.location.to(F);if(F instanceof i.$Hc)return F.buffer.buffer;if(!Array.isArray(F))return F})}}]}registerArgumentProcessor(k){this.f.push(k)}registerApiCommand(k){const r=this.registerCommand(!1,k.id,async(...l)=>{const f=k.args.map((W,V)=>{if(!W.validate(l[V]))throw new Error(`Invalid argument '${W.name}' when running '${k.id}', received: ${l[V]}`);return W.convert(l[V])}),F=await this.executeCommand(k.internalId,...f);return k.result.convert(F,l,this.converter)},void 0,{description:k.description,args:k.args,returns:k.result.description});return this.c.set(k.id,k),new R.$UJ(()=>{r.dispose(),this.c.delete(k.id)})}registerCommand(k,r,l,f,F,W){if(this.d.trace("ExtHostCommands#registerCommand",r),!r.trim().length)throw new Error("invalid id");if(this.b.has(r))throw new Error(`command '${r}' already exists`);return this.b.set(r,{callback:l,thisArg:f,description:F,extension:W}),k&&this.#e.$registerCommand(r),new R.$UJ(()=>{this.b.delete(r)&&k&&this.#e.$unregisterCommand(r)})}executeCommand(k,...r){return this.d.trace("ExtHostCommands#executeCommand",k),this.g(k,r,!0)}async g(k,r,l){if(this.b.has(k))return this.#e.$fireCommandActivationEvent(k),this.h(k,r,!1);{let f=!1;const F=(0,L.$Vm)(r,function(W){if(W instanceof R.$VJ)return C.Position.from(W);if(W instanceof R.$WJ)return C.Range.from(W);if(W instanceof R.$7J)return C.location.from(W);if(R.$gL.isNotebookRange(W))return C.NotebookRange.from(W);if(W instanceof ArrayBuffer)return f=!0,i.$Hc.wrap(new Uint8Array(W));if(W instanceof Uint8Array)return f=!0,i.$Hc.wrap(W);if(W instanceof i.$Hc)return f=!0,W;if(!Array.isArray(W))return W});try{const W=await this.#e.$executeCommand(k,f?new c.$_z(F):F,l);return(0,g.$9g)(W)}catch(W){if(W instanceof Error&&W.message==="$executeCommand:retry")return this.g(k,r,!1);throw W}}}async h(k,r,l){const f=this.b.get(k);if(!f)throw new Error("Unknown command");const{callback:F,thisArg:W,description:V}=f;if(V)for(let j=0;j<V.args.length;j++)try{(0,y.$Ce)(r[j],V.args[j].constraint)}catch{throw new Error(`Running the contributed command: '${k}' failed. Illegal argument '${V.args[j].name}' - ${V.args[j].description}`)}const B=E.$dc.create();try{return await F.apply(W,r)}catch(j){if(k===this.converter.delegatingCommandId){const U=this.converter.getActualCommand(...r);U&&(k=U.command)}if(this.d.error(j,k,f.extension?.identifier),!l)throw j;if(f.extension?.identifier){const U=this.#i.onExtensionError(f.extension.identifier,j);this.d.trace("forwarded error to extension?",U,f.extension?.identifier)}throw new class extends Error{constructor(){super((0,m.$ki)(j)),this.id=k,this.source=f.extension?.displayName??f.extension?.name}}}finally{this.j(f,k,B.elapsed())}}j(k,r,l){k.extension&&this.#t.$publicLog2("Extension:ActionExecuted",{extensionId:k.extension.identifier.value,id:new b.$0n(r),duration:l})}$executeContributedCommand(k,...r){this.d.trace("ExtHostCommands#$executeContributedCommand",k);const l=this.b.get(k);return l?(r=r.map(f=>this.f.reduce((F,W)=>W.processArgument(F,l.extension?.identifier),f)),this.h(k,r,!0)):Promise.reject(new Error(`Contributed command '${k}' does not exist.`))}getCommands(k=!1){return this.d.trace("ExtHostCommands#getCommands",k),this.#e.$getCommands().then(r=>(k&&(r=r.filter(l=>l[0]!=="_")),r))}$getContributedCommandHandlerDescriptions(){const k=Object.create(null);for(const[r,l]of this.b){const{description:f}=l;f&&(k[r]=f)}return Promise.resolve(k)}};e.$dM=a,e.$dM=a=Ke([Ve(0,d.$UL),Ve(1,S.$3i),Ve(2,n.$cM)],a),e.$eM=(0,$.$zh)("IExtHostCommands");class s{constructor(k,r,l){this.d=k,this.f=r,this.g=l,this.delegatingCommandId=`__vsc${Date.now().toString(36)}`,this.b=new Map,this.c=0,this.d.registerCommand(!0,this.delegatingCommandId,this.h,this)}toInternal(k,r){if(!k)return;const l={$ident:void 0,id:k.command,title:k.title,tooltip:k.tooltip};if(!k.command)return l;const f=this.f(k.command);if(f)l.id=f.internalId,l.arguments=f.args.map((F,W)=>F.convert(k.arguments&&k.arguments[W]));else if((0,h.$Ef)(k.arguments)){const F=`${k.command}/${++this.c}`;this.b.set(F,k),r.add((0,p.$kb)(()=>{this.b.delete(F),this.g.trace("CommandsConverter#DISPOSE",F)})),l.$ident=F,l.id=this.delegatingCommandId,l.arguments=[F],this.g.trace("CommandsConverter#CREATE",k.command,F)}return l}fromInternal(k){return typeof k.$ident=="string"?this.b.get(k.$ident):{command:k.id,title:k.title,arguments:k.arguments}}getActualCommand(...k){return this.b.get(k[0])}h(...k){const r=this.getActualCommand(...k);return this.g.trace("CommandsConverter#EXECUTE",k[0],r?r.command:"MISSING"),r?this.d.executeCommand(r.command,...r.arguments||[]):Promise.reject(`Actual command not found, wanted to execute ${k[0]}`)}}e.$fM=s;class o{static{this.Uri=new o("uri","Uri of a text document",k=>u.URI.isUri(k),k=>k)}static{this.Position=new o("position","A position in a text document",k=>R.$VJ.isPosition(k),C.Position.from)}static{this.Range=new o("range","A range in a text document",k=>R.$WJ.isRange(k),C.Range.from)}static{this.Selection=new o("selection","A selection in a text document",k=>R.$XJ.isSelection(k),C.Selection.from)}static{this.Number=new o("number","",k=>typeof k=="number",k=>k)}static{this.String=new o("string","",k=>typeof k=="string",k=>k)}static{this.StringArray=o.Arr(o.String)}static Arr(k){return new o(`${k.name}_array`,`Array of ${k.name}, ${k.description}`,r=>Array.isArray(r)&&r.every(l=>k.validate(l)),r=>r.map(l=>k.convert(l)))}static{this.CallHierarchyItem=new o("item","A call hierarchy item",k=>k instanceof R.$fK,C.CallHierarchyItem.from)}static{this.TypeHierarchyItem=new o("item","A type hierarchy item",k=>k instanceof R.$zL,C.TypeHierarchyItem.from)}static{this.TestItem=new o("testItem","A VS Code TestItem",k=>k instanceof t.$8L,C.TestItem.from)}constructor(k,r,l,f){this.name=k,this.description=r,this.validate=l,this.convert=f}optional(){return new o(this.name,`(optional) ${this.description}`,k=>k==null||this.validate(k),k=>k===void 0?void 0:k===null?null:this.convert(k))}with(k,r){return new o(k??this.name,r??this.description,this.validate,this.convert)}}e.$gM=o;class w{static{this.Void=new w("no result",k=>k)}constructor(k,r){this.description=k,this.convert=r}}e.$hM=w;class v{constructor(k,r,l,f,F){this.id=k,this.internalId=r,this.description=l,this.args=f,this.result=F}}e.$iM=v}),define(Pe[225],Ae([1,0,18,12,2,78,91,32,95,31,8,7]),function(pe,e,y,R,C,L,A,h,S,g,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dac=void 0;const u=[new g.$iM("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[g.$gM.Uri,g.$gM.Position],new g.$hM("A promise that resolves to an array of DocumentHighlight-instances.",$(P.DocumentHighlight.to))),new g.$iM("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[g.$gM.Uri],new g.$hM("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(t,i)=>{if((0,y.$Df)(t))return;class c extends D.$_J{static to(E){const b=new c(E.name,P.SymbolKind.to(E.kind),E.containerName||"",new D.$7J(i[0],P.Range.to(E.range)));return b.detail=E.detail,b.range=b.location.range,b.selectionRange=P.Range.to(E.selectionRange),b.children=E.children?E.children.map(c.to):[],b}}return t.map(c.to)})),new g.$iM("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[g.$gM.Uri,new g.$gM("options","Formatting options",t=>!0,t=>t)],new g.$hM("A promise that resolves to an array of TextEdits.",$(P.TextEdit.to))),new g.$iM("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[g.$gM.Uri,g.$gM.Range,new g.$gM("options","Formatting options",t=>!0,t=>t)],new g.$hM("A promise that resolves to an array of TextEdits.",$(P.TextEdit.to))),new g.$iM("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[g.$gM.Uri,g.$gM.Position,new g.$gM("ch","Trigger character",t=>typeof t=="string",t=>t),new g.$gM("options","Formatting options",t=>!0,t=>t)],new g.$hM("A promise that resolves to an array of TextEdits.",$(P.TextEdit.to))),new g.$iM("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[g.$gM.Uri,g.$gM.Position],new g.$hM("A promise that resolves to an array of Location or LocationLink instances.",d)),new g.$iM("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[g.$gM.Uri,g.$gM.Position],new g.$hM("A promise that resolves to an array of Location or LocationLink instances.",d)),new g.$iM("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[g.$gM.Uri,g.$gM.Position],new g.$hM("A promise that resolves to an array of Location or LocationLink instances.",d)),new g.$iM("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[g.$gM.Uri,g.$gM.Position],new g.$hM("A promise that resolves to an array of Location or LocationLink instances.",d)),new g.$iM("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[g.$gM.Uri,g.$gM.Position],new g.$hM("A promise that resolves to an array of Location-instances.",$(P.location.to))),new g.$iM("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[g.$gM.Uri,g.$gM.Position],new g.$hM("A promise that resolves to an array of Hover-instances.",$(P.Hover.to))),new g.$iM("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[g.$gM.Uri,new g.$gM("position","A position in a text document",t=>Array.isArray(t)&&t.every(i=>D.$VJ.isPosition(i)),t=>t.map(P.Position.from))],new g.$hM("A promise that resolves to an array of ranges.",t=>t.map(i=>{let c;for(const m of i.reverse())c=new D.$eK(P.Range.to(m),c);return c}))),new g.$iM("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[g.$gM.String.with("query","Search string")],new g.$hM("A promise that resolves to an array of SymbolInformation-instances.",t=>t.map(P.WorkspaceSymbol.to))),new g.$iM("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[g.$gM.Uri,g.$gM.Position],new g.$hM("A promise that resolves to an array of CallHierarchyItem-instances",t=>t.map(P.CallHierarchyItem.to))),new g.$iM("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[g.$gM.CallHierarchyItem],new g.$hM("A promise that resolves to an array of CallHierarchyIncomingCall-instances",t=>t.map(P.CallHierarchyIncomingCall.to))),new g.$iM("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[g.$gM.CallHierarchyItem],new g.$hM("A promise that resolves to an array of CallHierarchyOutgoingCall-instances",t=>t.map(P.CallHierarchyOutgoingCall.to))),new g.$iM("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[g.$gM.Uri,g.$gM.Position],new g.$hM("A promise that resolves to a range and placeholder text.",t=>{if(t)return{range:P.Range.to(t.range),placeholder:t.text}})),new g.$iM("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[g.$gM.Uri,g.$gM.Position,g.$gM.String.with("newName","The new symbol name")],new g.$hM("A promise that resolves to a WorkspaceEdit.",t=>{if(t){if(t.rejectReason)throw new Error(t.rejectReason);return P.WorkspaceEdit.to(t)}})),new g.$iM("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[g.$gM.Uri,g.$gM.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new g.$hM("A promise that resolves to an array of DocumentLink-instances.",t=>t.map(P.DocumentLink.to))),new g.$iM("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[g.$gM.Uri],new g.$hM("A promise that resolves to SemanticTokensLegend.",t=>{if(t)return new D.$$K(t.tokenTypes,t.tokenModifiers)})),new g.$iM("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[g.$gM.Uri],new g.$hM("A promise that resolves to SemanticTokens.",t=>{if(!t)return;const i=(0,A.$j0)(t);if(i.type==="full")return new D.$aL(i.data,void 0)})),new g.$iM("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[g.$gM.Uri,g.$gM.Range.optional()],new g.$hM("A promise that resolves to SemanticTokensLegend.",t=>{if(t)return new D.$$K(t.tokenTypes,t.tokenModifiers)})),new g.$iM("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[g.$gM.Uri,g.$gM.Range],new g.$hM("A promise that resolves to SemanticTokens.",t=>{if(!t)return;const i=(0,A.$j0)(t);if(i.type==="full")return new D.$aL(i.data,void 0)})),new g.$iM("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[g.$gM.Uri,g.$gM.Position,g.$gM.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),g.$gM.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new g.$hM("A promise that resolves to a CompletionList-instance.",(t,i,c)=>{if(!t)return new D.$qK([]);const m=t.suggestions.map(E=>P.CompletionItem.to(E,c));return new D.$qK(m,t.incomplete)})),new g.$iM("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[g.$gM.Uri,g.$gM.Position,g.$gM.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new g.$hM("A promise that resolves to SignatureHelp.",t=>{if(t)return P.SignatureHelp.to(t)})),new g.$iM("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[g.$gM.Uri,g.$gM.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new g.$hM("A promise that resolves to an array of CodeLens-instances.",(t,i,c)=>$(m=>new D.$iK(P.Range.to(m.range),m.command&&c.fromInternal(m.command)))(t))),new g.$iM("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[g.$gM.Uri,new g.$gM("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",t=>D.$WJ.isRange(t),t=>D.$XJ.isSelection(t)?P.Selection.from(t):P.Range.from(t)),g.$gM.String.with("kind","Code action kind to return code actions for").optional(),g.$gM.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new g.$hM("A promise that resolves to an array of Command-instances.",(t,i,c)=>$(m=>{if(m._isSynthetic){if(!m.command)throw new Error("Synthetic code actions must have a command");return c.fromInternal(m.command)}else{const E=new D.$bK(m.title,m.kind?new D.$cK(m.kind):void 0);return m.edit&&(E.edit=P.WorkspaceEdit.to(m.edit)),m.command&&(E.command=c.fromInternal(m.command)),E.isPreferred=m.isPreferred,E}})(t))),new g.$iM("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[g.$gM.Uri],new g.$hM("A promise that resolves to an array of ColorInformation objects.",t=>t?t.map(i=>new D.$wK(P.Range.to(i.range),P.Color.to(i.color))):[])),new g.$iM("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new g.$gM("color","The color to show and insert",t=>t instanceof D.$vK,P.Color.from),new g.$gM("context","Context object with uri and range",t=>!0,t=>({uri:t.uri,range:P.Range.from(t.range)}))],new g.$hM("A promise that resolves to an array of ColorPresentation objects.",t=>t?t.map(P.ColorPresentation.to):[])),new g.$iM("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[g.$gM.Uri,g.$gM.Range],new g.$hM("A promise that resolves to an array of Inlay objects",(t,i,c)=>t.map(P.InlayHint.to.bind(void 0,c)))),new g.$iM("vscode.executeFoldingRangeProvider","_executeFoldingRangeProvider","Execute folding range provider",[g.$gM.Uri],new g.$hM("A promise that resolves to an array of FoldingRange objects",(t,i)=>{if(t)return t.map(P.FoldingRange.to)})),new g.$iM("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new g.$hM("A promise that resolves to an array of NotebookContentProvider static info objects.",$(t=>({viewType:t.viewType,displayName:t.displayName,options:{transientOutputs:t.options.transientOutputs,transientCellMetadata:t.options.transientCellMetadata,transientDocumentMetadata:t.options.transientDocumentMetadata},filenamePattern:t.filenamePattern.map(i=>P.NotebookExclusiveDocumentPattern.to(i))})))),new g.$iM("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[g.$gM.Uri,g.$gM.Range,new g.$gM("context","An InlineValueContext",t=>t&&typeof t.frameId=="number"&&t.stoppedLocation instanceof D.$WJ,t=>P.InlineValueContext.from(t))],new g.$hM("A promise that resolves to an array of InlineValue objects",t=>t.map(P.InlineValue.to))),new g.$iM("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[new g.$gM("uriOrString","Uri-instance or string (only http/https)",t=>C.URI.isUri(t)||typeof t=="string"&&(0,S.$DT)(t,R.Schemas.http,R.Schemas.https),t=>t),new g.$gM("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",t=>t===void 0||typeof t=="number"||typeof t=="object",t=>t&&(typeof t=="number"?[P.ViewColumn.from(t),void 0]:[P.ViewColumn.from(t.viewColumn),P.TextEditorOpenOptions.from(t)])).optional(),g.$gM.String.with("label","").optional()],g.$hM.Void),new g.$iM("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[g.$gM.Uri.with("resource","Resource to open"),g.$gM.String.with("viewId","Custom editor view id or 'default' to use VS Code's default editor"),new g.$gM("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",t=>t===void 0||typeof t=="number"||typeof t=="object",t=>t&&(typeof t=="number"?[P.ViewColumn.from(t),void 0]:[P.ViewColumn.from(t.viewColumn),P.TextEditorOpenOptions.from(t)])).optional()],g.$hM.Void),new g.$iM("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[g.$gM.Uri.with("left","Left-hand side resource of the diff editor"),g.$gM.Uri.with("right","Right-hand side resource of the diff editor"),g.$gM.String.with("title","Human readable title for the diff editor").optional(),new g.$gM("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",t=>t===void 0||typeof t=="object",t=>t&&[P.ViewColumn.from(t.viewColumn),P.TextEditorOpenOptions.from(t)]).optional()],g.$hM.Void),new g.$iM("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[g.$gM.Uri,g.$gM.Position],new g.$hM("A promise that resolves to an array of TypeHierarchyItem-instances",t=>t.map(P.TypeHierarchyItem.to))),new g.$iM("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[g.$gM.TypeHierarchyItem],new g.$hM("A promise that resolves to an array of TypeHierarchyItem-instances",t=>t.map(P.TypeHierarchyItem.to))),new g.$iM("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[g.$gM.TypeHierarchyItem],new g.$hM("A promise that resolves to an array of TypeHierarchyItem-instances",t=>t.map(P.TypeHierarchyItem.to))),new g.$iM("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[g.$gM.TestItem],g.$hM.Void),new g.$iM("vscode.experimental.editSession.continue","_workbench.editSessions.actions.continueEditSession","Continue the current edit session in a different workspace",[g.$gM.Uri.with("workspaceUri","The target workspace to continue the current edit session in")],g.$hM.Void),new g.$iM("setContext","_setContext","Set a custom context key value that can be used in when clauses.",[g.$gM.String.with("name","The context key name"),new g.$gM("value","The context key value",()=>!0,t=>t)],g.$hM.Void),new g.$iM("vscode.executeMappedEditsProvider","_executeMappedEditsProvider","Execute Mapped Edits Provider",[g.$gM.Uri,g.$gM.StringArray,new g.$gM("MappedEditsContext","Mapped Edits Context",t=>P.MappedEditsContext.is(t),t=>P.MappedEditsContext.from(t))],new g.$hM("A promise that resolves to a workspace edit or null",t=>t?P.WorkspaceEdit.to(t):null))];class p{static register(i){u.forEach(i.registerApiCommand,i),this.a(i)}static a(i){i.registerCommand(!1,"_validateWhenClauses",h.$Hi)}}e.$Dac=p;function $(t){return i=>{if(Array.isArray(i))return i.map(t)}}function d(t){if(!Array.isArray(t))return;const i=[];for(const c of t)L.$5s(c)?i.push(P.DefinitionLink.to(c)):i.push(P.location.to(c));return i}}),define(Pe[226],Ae([1,0,13,64,5,6,2,78,20,8,7,3,26]),function(pe,e,y,R,C,L,A,h,S,g,P,D,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fac=void 0;function p($,d,t){const i=$.getProxy(D.$SJ.MainThreadComments);class c{static{this.a=0}constructor(){this.b=new Map,this.c=new S.$Vl,d.registerArgumentProcessor({processArgument:v=>{if(v&&v.$mid===6){const I=this.b.get(v.handle);return I?I.value:v}else if(v&&v.$mid===7){const I=this.b.get(v.commentControlHandle);if(!I)return v;const k=I.getCommentThread(v.commentThreadHandle);return k?k.value:v}else if(v&&(v.$mid===9||v.$mid===8)){const I=this.b.get(v.thread.commentControlHandle);if(!I)return v;const k=I.getCommentThread(v.thread.commentThreadHandle);return k?v.$mid===8?k.value:{thread:k.value,text:v.text}:v}else if(v&&v.$mid===10){const I=this.b.get(v.thread.commentControlHandle);if(!I)return v;const k=I.getCommentThread(v.thread.commentThreadHandle);if(!k)return v;const r=v.commentUniqueId,l=k.getCommentByUniqueId(r);return l||v}else if(v&&v.$mid===11){const I=this.b.get(v.thread.commentControlHandle);if(!I)return v;const k=I.getCommentThread(v.thread.commentThreadHandle);if(!k)return v;const r=v.text,l=v.commentUniqueId,f=k.getCommentByUniqueId(l);return f?(typeof f.body=="string"?f.body=r:f.body=new P.$jK(r),f):v}return v}})}createCommentController(v,I,k){const r=c.a++,l=new E(v,r,I,k);this.b.set(l.handle,l);const f=this.c.get(v.identifier)||[];return f.push(l),this.c.set(v.identifier,f),l.value}$createCommentThreadTemplate(v,I,k){const r=this.b.get(v);r&&r.$createCommentThreadTemplate(I,k)}async $updateCommentThreadTemplate(v,I,k){const r=this.b.get(v);r&&r.$updateCommentThreadTemplate(I,k)}$deleteCommentThread(v,I){this.b.get(v)?.$deleteCommentThread(I)}$provideCommentingRanges(v,I,k){const r=this.b.get(v);if(!r||!r.commentingRangeProvider)return Promise.resolve(void 0);const l=t.getDocument(A.URI.revive(I));return(0,y.$xg)(async()=>{const f=await r.commentingRangeProvider.provideCommentingRanges(l,k);let F;return Array.isArray(f)?F={ranges:f,fileComments:!1}:f?F={ranges:f.ranges||[],fileComments:f.fileComments||!1}:F=f??void 0,F}).then(f=>{let F;return f&&(F={ranges:f.ranges.map(W=>g.Range.from(W)),fileComments:f.fileComments}),F})}$toggleReaction(v,I,k,r,l){const f=this.b.get(v);return!f||!f.reactionHandler?Promise.resolve(void 0):(0,y.$xg)(()=>{const F=f.getCommentThread(I);if(F){const W=F.getCommentByUniqueId(r.uniqueIdInThread);if(f!==void 0&&W&&f.reactionHandler)return f.reactionHandler(W,a(l))}return Promise.resolve(void 0)})}}class m{static{this.a=0}set threadId(v){this.n=v}get threadId(){return this.n}get id(){return this.n}get resource(){return this.o}get uri(){return this.o}set range(v){(v===void 0!=(this.p===void 0)||!v||!this.p||!v.isEqual(this.p))&&(this.p=v,this.b.range=v,this.c.fire())}get range(){return this.p}set canReply(v){this.d!==v&&(this.d=v,this.b.canReply=v,this.c.fire())}get canReply(){return this.d}get label(){return this.e}set label(v){this.e=v,this.b.label=v,this.c.fire()}get contextValue(){return this.f}set contextValue(v){this.f=v,this.b.contextValue=v,this.c.fire()}get comments(){return this.q}set comments(v){this.q=v,this.b.comments=v,this.c.fire()}get collapsibleState(){return this.g}set collapsibleState(v){this.g=v,this.b.collapsibleState=v,this.c.fire()}get state(){return this.h}set state(v){this.h=v,this.b.state=v,this.c.fire()}get isDisposed(){return this.j}constructor(v,I,k,r,l,f,F,W){this.m=I,this.n=k,this.o=r,this.p=l,this.q=f,this.extensionDescription=F,this.r=W,this.handle=m.a++,this.commentHandle=0,this.b=Object.create(null),this.c=new C.$hc,this.onDidUpdateCommentThread=this.c.event,this.d=!0,this.k=new Map,this.l=new L.$nb,this.l.value=new L.$lb,this.n===void 0&&(this.n=`${v}.${this.handle}`),i.$createCommentThread(I,this.handle,this.n,this.o,g.Range.from(this.p),F.identifier,this.r),this.i=[],this.j=!1,this.i.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=f,this.i.push({dispose:()=>{i.$deleteCommentThread(I,this.handle)}});const V=this;this.value={get uri(){return V.uri},get range(){return V.range},set range(B){V.range=B},get comments(){return V.comments},set comments(B){V.comments=B},get collapsibleState(){return V.collapsibleState},set collapsibleState(B){V.collapsibleState=B},get canReply(){return V.canReply},set canReply(B){V.canReply=B},get contextValue(){return V.contextValue},set contextValue(B){V.contextValue=B},get label(){return V.label},set label(B){V.label=B},get state(){return V.state},set state(B){V.state=B},dispose:()=>{V.dispose()}}}s(){this.r&&(this.r=!1,this.b.isTemplate=!1)}eventuallyUpdateCommentThread(){if(this.j)return;this.s(),this.l.value||(this.l.value=new L.$lb);const v=k=>Object.prototype.hasOwnProperty.call(this.b,k),I={};v("range")&&(I.range=g.Range.from(this.p)),v("label")&&(I.label=this.label),v("contextValue")&&(I.contextValue=this.contextValue??null),v("comments")&&(I.comments=this.q.map(k=>b(this,k,this.k,this.extensionDescription))),v("collapsibleState")&&(I.collapseState=s(this.g)),v("canReply")&&(I.canReply=this.canReply),v("state")&&(I.state=o(this.h)),v("isTemplate")&&(I.isTemplate=this.r),this.b={},i.$updateCommentThread(this.m,this.handle,this.n,this.o,I)}getCommentByUniqueId(v){for(const I of this.k){const k=I[0],r=I[1];if(v===r)return k}}dispose(){this.j=!0,this.l.dispose(),this.i.forEach(v=>v.dispose())}}Ke([(0,R.$5g)(100)],m.prototype,"eventuallyUpdateCommentThread",null);class E{get id(){return this.h}get label(){return this.i}get handle(){return this.g}get commentingRangeProvider(){return this.b}set commentingRangeProvider(v){this.b=v,i.$updateCommentingRanges(this.handle)}get reactionHandler(){return this.c}set reactionHandler(v){this.c=v,i.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!v})}get options(){return this.d}set options(v){this.d=v,i.$updateCommentControllerFeatures(this.handle,{options:this.d})}constructor(v,I,k,r){this.f=v,this.g=I,this.h=k,this.i=r,this.a=new Map,i.$registerCommentController(this.handle,k,r);const l=this;this.value=Object.freeze({id:l.id,label:l.label,get options(){return l.options},set options(f){l.options=f},get commentingRangeProvider(){return l.commentingRangeProvider},set commentingRangeProvider(f){l.commentingRangeProvider=f},get reactionHandler(){return l.reactionHandler},set reactionHandler(f){l.reactionHandler=f},createCommentThread(f,F,W){return l.createCommentThread(f,F,W).value},dispose:()=>{l.dispose()}}),this.e=[],this.e.push({dispose:()=>{i.$unregisterCommentController(this.handle)}})}createCommentThread(v,I,k){I===void 0&&(0,u.$MF)(this.f,"fileComments");const r=new m(this.id,this.handle,void 0,v,I,k,this.f,!1);return this.a.set(r.handle,r),r}$createCommentThreadTemplate(v,I){const k=new m(this.id,this.handle,void 0,A.URI.revive(v),g.Range.to(I),[],this.f,!0);return k.collapsibleState=h.CommentThreadCollapsibleState.Expanded,this.a.set(k.handle,k),k}$updateCommentThreadTemplate(v,I){const k=this.a.get(v);k&&(k.range=g.Range.to(I))}$deleteCommentThread(v){this.a.get(v)?.dispose(),this.a.delete(v)}getCommentThread(v){return this.a.get(v)}dispose(){this.a.forEach(v=>{v.dispose()}),this.e.forEach(v=>v.dispose())}}function b(w,v,I,k){let r=I.get(v);return r||(r=++w.commentHandle,I.set(v,r)),v.state!==void 0&&(0,u.$MF)(k,"commentsDraftState"),{mode:v.mode,contextValue:v.contextValue,uniqueIdInThread:r,body:typeof v.body=="string"?v.body:g.MarkdownString.from(v.body),userName:v.author.name,userIconPath:v.author.iconPath,label:v.label,commentReactions:v.reactions?v.reactions.map(l=>n(l)):void 0,state:v.state,timestamp:v.timestamp?.toJSON()}}function n(w){return{label:w.label,iconPath:w.iconPath?g.$TL(w.iconPath):void 0,count:w.count,hasReacted:w.authorHasReacted}}function a(w){return{label:w.label||"",count:w.count||0,iconPath:w.iconPath?A.URI.revive(w.iconPath):"",authorHasReacted:w.hasReacted||!1}}function s(w){if(w!==void 0)switch(w){case P.CommentThreadCollapsibleState.Expanded:return h.CommentThreadCollapsibleState.Expanded;case P.CommentThreadCollapsibleState.Collapsed:return h.CommentThreadCollapsibleState.Collapsed}return h.CommentThreadCollapsibleState.Collapsed}function o(w){if(w!==void 0)switch(w){case P.CommentThreadState.Unresolved:return h.CommentThreadState.Unresolved;case P.CommentThreadState.Resolved:return h.CommentThreadState.Resolved}return h.CommentThreadState.Unresolved}return new c}e.$Fac=p}),define(Pe[227],Ae([1,0,24,3,27,17]),function(pe,e,y,R,C,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bcc=void 0;let A=class{constructor(P,D){this.a=P.getProxy(R.$SJ.MainThreadConsole),this.b=D.consoleForward.includeStack,this.c=D.consoleForward.logNative,this.d("info","log"),this.d("log","log"),this.d("warn","warn"),this.d("error","error")}d(P,D){const u=this,p=console[P];Object.defineProperty(console,P,{set:()=>{},get:()=>function(){u.e(P,D,p,arguments)}})}e(P,D,u,p){this.a.$logExtensionHostMessage({type:"__$console",severity:D,arguments:S(p,this.b)}),this.c&&this.f(P,u,p)}};e.$Bcc=A,e.$Bcc=A=Ke([Ve(0,L.$UL),Ve(1,C.$$L)],A);const h=1e5;function S(g,P){const D=[];if(g.length)for(let u=0;u<g.length;u++){let p=g[u];if(typeof p>"u")p="undefined";else if(p instanceof Error){const $=p;$.stack?p=$.stack:p=$.toString()}D.push(p)}if(P){const u=new Error().stack;u&&D.push({__$stack:u.split(`
`).slice(3).join(`
`)})}try{const u=(0,y.$Ym)(D);return u.length>h?"Output omitted for a large object that exceeds the limits":u}catch(u){return`Output omitted for an object that cannot be inspected ('${u.toString()}')`}}}),define(Pe[108],Ae([1,0,2,3,7,4,17,14,18,15,19,26]),function(pe,e,y,R,C,L,A,h,S,g,P,D){"use strict";var u;Object.defineProperty(e,"__esModule",{value:!0}),e.$Hbc=e.$Gbc=void 0;let p=class{static{u=this}static{this.c=0}static{this.d=250}constructor(d,t){this.h=t,this.f=new Map,this.g=d.getProxy(R.$SJ.MainThreadDecorations)}registerFileDecorationProvider(d,t){const i=u.c++;this.f.set(i,{provider:d,extensionDescription:t}),this.g.$registerDecorationProvider(i,t.identifier.value);const c=d.onDidChangeFileDecorations&&d.onDidChangeFileDecorations(m=>{if(!m){this.g.$onDidChange(i,null);return}const E=(0,S.$Vf)(m);if(E.length<=u.d){this.g.$onDidChange(i,E);return}this.h.warn("[Decorations] CAPPING events from decorations provider",t.identifier.value,E.length);const b=E.map(s=>({uri:s,rank:(0,g.$td)(s.path,"/")})),n=(0,S.$tf)(b,(s,o)=>s.rank-o.rank||(0,g.$Hd)(s.uri.path,o.uri.path)),a=[];e:for(const s of n){let o;for(const w of s){const v=(0,P.$bd)(w.uri.path);if(o!==v&&(o=v,a.push(w.uri)>=u.d))break e}}this.g.$onDidChange(i,a)});return new C.$UJ(()=>{c?.dispose(),this.g.$unregisterDecorationProvider(i),this.f.delete(i)})}async $provideDecorations(d,t,i){if(!this.f.has(d))return Object.create(null);const c=Object.create(null),{provider:m,extensionDescription:E}=this.f.get(d);return await Promise.all(t.map(async b=>{try{const{uri:n,id:a}=b,s=await Promise.resolve(m.provideFileDecoration(y.URI.revive(n),i));if(!s)return;try{C.$eL.validate(s),s.badge&&typeof s.badge!="string"&&(0,D.$MF)(E,"codiconDecoration"),c[a]=[s.propagate,s.tooltip,s.badge,s.color]}catch(o){this.h.warn(`INVALID decoration from extension '${E.identifier.value}': ${o}`)}}catch(n){this.h.error(n)}})),c}};e.$Gbc=p,e.$Gbc=p=u=Ke([Ve(0,A.$UL),Ve(1,h.$3i)],p),e.$Hbc=(0,L.$zh)("IExtHostDecorations")}),define(Pe[228],Ae([1,0,148,94,2,3,7,8,5,14,28,39]),function(pe,e,y,R,C,L,A,h,S,g,P,D){"use strict";var u;Object.defineProperty(e,"__esModule",{value:!0}),e.$yac=e.$xac=void 0;class p{#e;#t;#i;constructor(t,i,c,m,E,b,n,a){this.d=t,this.e=i,this.f=c,this.g=m,this.h=E,this.c=!1,this.f=Math.max(m,c),this.#i=new P.$xi(s=>b.getComparisonKey(s)),this.#e=n,this.#t=a}dispose(){this.c||(this.#t.fire([...this.#i.keys()]),this.#e?.$clear(this.e),this.#i.clear(),this.c=!0)}get name(){return this.j(),this.d}set(t,i){if(!t){this.clear();return}this.j();let c=[];if(C.URI.isUri(t)){if(!i){this.delete(t);return}this.#i.set(t,i.slice()),c=[t]}else if(Array.isArray(t)){c=[];let b;t=[...t].sort(p.k);for(const n of t){const[a,s]=n;if((!b||a.toString()!==b.toString())&&(b&&this.#i.get(b).length===0&&this.#i.delete(b),b=a,c.push(a),this.#i.set(a,[])),s)this.#i.get(a)?.push(...s);else{const o=this.#i.get(a);o&&(o.length=0)}}}if(this.#t.fire(c),!this.#e)return;const m=[];let E=0;for(const b of c){let n=[];const a=this.#i.get(b);if(a)if(a.length>this.g){n=[];const s=[A.DiagnosticSeverity.Error,A.DiagnosticSeverity.Warning,A.DiagnosticSeverity.Information,A.DiagnosticSeverity.Hint];e:for(let o=0;o<4;o++)for(const w of a)if(w.severity===s[o]&&n.push({...h.Diagnostic.from(w),modelVersionId:this.h(b)})===this.g)break e;n.push({severity:R.MarkerSeverity.Info,message:(0,y.localize)(0,null,a.length-this.g),startLineNumber:n[n.length-1].startLineNumber,startColumn:n[n.length-1].startColumn,endLineNumber:n[n.length-1].endLineNumber,endColumn:n[n.length-1].endColumn})}else n=a.map(s=>({...h.Diagnostic.from(s),modelVersionId:this.h(b)}));if(m.push([b,n]),E+=n.length,E>this.f)break}this.#e.$changeMany(this.e,m)}delete(t){this.j(),this.#t.fire([t]),this.#i.delete(t),this.#e?.$changeMany(this.e,[[t,void 0]])}clear(){this.j(),this.#t.fire([...this.#i.keys()]),this.#i.clear(),this.#e?.$clear(this.e)}forEach(t,i){this.j();for(const[c,m]of this)t.call(i,c,m,this)}*[Symbol.iterator](){this.j();for(const t of this.#i.keys())yield[t,this.get(t)]}get(t){this.j();const i=this.#i.get(t);return Array.isArray(i)?Object.freeze(i.slice(0)):[]}has(t){return this.j(),Array.isArray(this.#i.get(t))}j(){if(this.c)throw new Error("illegal state - object is disposed")}static k(t,i){return t[0].toString()<i[0].toString()?-1:t[0].toString()>i[0].toString()?1:0}}e.$xac=p;let $=class{static{u=this}static{this.c=0}static{this.d=1e3}static{this.e=1.1*u.d}static _mapper(t){const i=new P.$xi;for(const c of t)i.set(c,c);return{uris:Object.freeze(Array.from(i.values()))}}constructor(t,i,c,m){this.j=i,this.k=c,this.l=m,this.g=new Map,this.h=new S.$lc({merge:E=>E.flat(),delay:50}),this.onDidChangeDiagnostics=S.Event.map(this.h.event,u._mapper),this.f=t.getProxy(L.$SJ.MainThreadDiagnostics)}createDiagnosticCollection(t,i){const{g:c,f:m,h:E,j:b,k:n,l:a}=this,s=new class{$changeMany(v,I){m.$changeMany(v,I),b.trace("[DiagnosticCollection] change many (extension, owner, uris)",t.value,v,I.length===0?"CLEARING":I)}$clear(v){m.$clear(v),b.trace("[DiagnosticCollection] remove all (extension, owner)",t.value,v)}dispose(){m.dispose()}};let o;if(!i)i="_generated_diagnostic_collection_name_#"+u.c++,o=i;else if(!c.has(i))o=i;else{this.j.warn(`DiagnosticCollection with name '${i}' does already exist.`);do o=i+u.c++;while(c.has(o))}return new class extends p{constructor(){super(i,o,u.e,u.d,v=>a.getDocument(v)?.version,n.extUri,s,E),c.set(o,this)}dispose(){super.dispose(),c.delete(o)}}}getDiagnostics(t){if(t)return this.m(t);{const i=new Map,c=[];for(const m of this.g.values())m.forEach((E,b)=>{let n=i.get(E.toString());typeof n>"u"&&(n=c.length,i.set(E.toString(),n),c.push([E,[]])),c[n][1]=c[n][1].concat(...b)});return c}}m(t){let i=[];for(const c of this.g.values())c.has(t)&&(i=i.concat(c.get(t)));return i}$acceptMarkersChange(t){if(!this.n){const i="_generated_mirror",c=new p(i,i,Number.MAX_SAFE_INTEGER,Number.MAX_SAFE_INTEGER,m=>{},this.k.extUri,void 0,this.h);this.g.set(i,c),this.n=c}for(const[i,c]of t)this.n.set(C.URI.revive(i),c.map(h.Diagnostic.to))}};e.$yac=$,e.$yac=$=u=Ke([Ve(1,g.$3i),Ve(2,D.$wac)],$)}),define(Pe[229],Ae([1,0,2,3,26]),function(pe,e,y,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nac=void 0;class L{constructor(h){this.a=h.getProxy(R.$SJ.MainThreadDialogs)}showOpenDialog(h,S){return S?.allowUIResources&&(0,C.$MF)(h,"showLocal"),this.a.$showOpenDialog(S).then(g=>g?g.map(P=>y.URI.revive(P)):void 0)}showSaveDialog(h){return this.a.$showSaveDialog(h).then(S=>S?y.URI.revive(S):void 0)}}e.$Nac=L}),define(Pe[230],Ae([1,0,9,2,7,3,12,21,15]),function(pe,e,y,R,C,L,A,h,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Oac=void 0;class g{static{this.a=0}constructor(D,u,p){this.d=u,this.e=p,this.b=new Map,this.c=D.getProxy(L.$SJ.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(D,u){if(Object.keys(A.Schemas).indexOf(D)>=0)throw new Error(`scheme '${D}' already registered`);const p=g.a++;this.b.set(p,u),this.c.$registerTextContentProvider(p,D);let $;return typeof u.onDidChange=="function"&&($=u.onDidChange(d=>{if(d.scheme!==D){this.e.warn(`Provider for scheme '${D}' is firing event for schema '${d.scheme}' which will be IGNORED`);return}this.d.getDocument(d)&&this.$provideTextDocumentContent(p,d).then(t=>{if(!t&&typeof t!="string")return;const i=this.d.getDocument(d);if(!i)return;const c=(0,S.$Cd)(t);if(!i.equalLines(c))return this.c.$onVirtualDocumentChange(d,t)},y.$Y)})),new C.$UJ(()=>{this.b.delete(p)&&this.c.$unregisterTextContentProvider(p),$&&($.dispose(),$=void 0)})}$provideTextDocumentContent(D,u){const p=this.b.get(D);return p?Promise.resolve(p.provideTextDocumentContent(R.URI.revive(u),h.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${u.scheme}`))}}e.$Oac=g}),define(Pe[231],Ae([1,0,5,6,2,3,101,8,16,24,7,9]),function(pe,e,y,R,C,L,A,h,S,g,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uac=void 0;class u{constructor($,d){this.a=new y.$hc({onListenerError:D.$Z}),this.b=new y.$hc({onListenerError:D.$Z}),this.c=new y.$hc({onListenerError:D.$Z}),this.d=new y.$hc({onListenerError:D.$Z}),this.onDidAddDocument=this.a.event,this.onDidRemoveDocument=this.b.event,this.onDidChangeDocument=this.c.event,this.onDidSaveDocument=this.d.event,this.e=new R.$lb,this.h=new Map,this.f=$.getProxy(L.$SJ.MainThreadDocuments),this.g=d,this.g.onDidRemoveDocuments(t=>{for(const i of t)this.b.fire(i.document)},void 0,this.e),this.g.onDidAddDocuments(t=>{for(const i of t)this.a.fire(i.document)},void 0,this.e)}dispose(){this.e.dispose()}getAllDocumentData(){return[...this.g.allDocuments()]}getDocumentData($){if(!$)return;const d=this.g.getDocument($);if(d)return d}getDocument($){const d=this.getDocumentData($);if(!d?.document)throw new Error(`Unable to retrieve document from URI '${$}'`);return d.document}ensureDocumentData($){const d=this.g.getDocument($);if(d)return Promise.resolve(d);let t=this.h.get($.toString());return t||(t=this.f.$tryOpenDocument($).then(i=>{this.h.delete($.toString());const c=C.URI.revive(i);return(0,S.$we)(this.g.getDocument(c))},i=>(this.h.delete($.toString()),Promise.reject(i))),this.h.set($.toString(),t)),t}createDocumentData($){return this.f.$tryCreateDocument($).then(d=>C.URI.revive(d))}$acceptModelLanguageChanged($,d){const t=C.URI.revive($),i=this.g.getDocument(t);if(!i)throw new Error("unknown document");this.b.fire(i.document),i._acceptLanguageId(d),this.a.fire(i.document)}$acceptModelSaved($){const d=C.URI.revive($),t=this.g.getDocument(d);if(!t)throw new Error("unknown document");this.$acceptDirtyStateChanged($,!1),this.d.fire(t.document)}$acceptDirtyStateChanged($,d){const t=C.URI.revive($),i=this.g.getDocument(t);if(!i)throw new Error("unknown document");i._acceptIsDirty(d),this.c.fire({document:i.document,contentChanges:[],reason:void 0})}$acceptModelChanged($,d,t){const i=C.URI.revive($),c=this.g.getDocument(i);if(!c)throw new Error("unknown document");c._acceptIsDirty(t),c.onEvents(d);let m;d.isUndoing?m=P.TextDocumentChangeReason.Undo:d.isRedoing&&(m=P.TextDocumentChangeReason.Redo),this.c.fire((0,g.$Um)({document:c.document,contentChanges:d.changes.map(E=>({range:h.Range.to(E.range),rangeOffset:E.rangeOffset,rangeLength:E.rangeLength,text:E.text})),reason:m}))}setWordDefinitionFor($,d){(0,A.$WL)($,d)}}e.$uac=u}),define(Pe[59],Ae([1,0,50,5,6,2,4,3,101,17,106,8,14,28,12,66,65]),function(pe,e,y,R,C,L,A,h,S,g,P,D,u,p,$,d,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6L=e.$5L=void 0;class i{constructor(E){this.value=E,this.a=0}ref(){this.a++}unref(){return--this.a===0}}let c=class{constructor(E,b){this.h=E,this.i=b,this.a=null,this.b=new Map,this.c=new p.$xi,this.d=new R.$hc,this.e=new R.$hc,this.f=new R.$hc,this.g=new R.$hc,this.onDidAddDocuments=this.d.event,this.onDidRemoveDocuments=this.e.event,this.onDidChangeVisibleTextEditors=this.f.event,this.onDidChangeActiveTextEditor=this.g.event}$acceptDocumentsAndEditorsDelta(E){this.acceptDocumentsAndEditorsDelta(E)}acceptDocumentsAndEditorsDelta(E){const b=[],n=[],a=[];if(E.removedDocuments)for(const s of E.removedDocuments){const o=L.URI.revive(s),w=this.c.get(o);w?.unref()&&(this.c.delete(o),b.push(w.value))}if(E.addedDocuments)for(const s of E.addedDocuments){const o=L.URI.revive(s.uri);let w=this.c.get(o);if(w&&o.scheme!==$.Schemas.vscodeNotebookCell&&o.scheme!==$.Schemas.vscodeInteractiveInput)throw new Error(`document '${o} already exists!'`);w||(w=new i(new S.$XL(this.h.getProxy(h.$SJ.MainThreadDocuments),o,s.lines,s.EOL,s.versionId,s.languageId,s.isDirty,s.notebook)),this.c.set(o,w),n.push(w.value)),w.ref()}if(E.removedEditors)for(const s of E.removedEditors){const o=this.b.get(s);this.b.delete(s),o&&a.push(o)}if(E.addedEditors)for(const s of E.addedEditors){const o=L.URI.revive(s.documentUri);y.ok(this.c.has(o),`document '${o}' does not exist`),y.ok(!this.b.has(s.id),`editor '${s.id}' already exists!`);const w=this.c.get(o).value,v=new P.$4L(s.id,this.h.getProxy(h.$SJ.MainThreadTextEditors),this.i,new t.$T(()=>w.document),s.selections.map(D.Selection.to),s.options,s.visibleRanges.map(I=>D.Range.to(I)),typeof s.editorPosition=="number"?D.ViewColumn.to(s.editorPosition):void 0);this.b.set(s.id,v)}E.newActiveEditor!==void 0&&(y.ok(E.newActiveEditor===null||this.b.has(E.newActiveEditor),`active editor '${E.newActiveEditor}' does not exist`),this.a=E.newActiveEditor),(0,C.$hb)(b),(0,C.$hb)(a),E.removedDocuments&&this.e.fire(b),E.addedDocuments&&this.d.fire(n),(E.removedEditors||E.addedEditors)&&this.f.fire(this.allEditors().map(s=>s.value)),E.newActiveEditor!==void 0&&this.g.fire(this.activeEditor())}getDocument(E){return this.c.get(E)?.value}allDocuments(){return d.Iterable.map(this.c.values(),E=>E.value)}getEditor(E){return this.b.get(E)}activeEditor(E){if(!this.a)return;const b=this.b.get(this.a);return E?b:b?.value}allEditors(){return[...this.b.values()]}};e.$5L=c,e.$5L=c=Ke([Ve(0,g.$UL),Ve(1,u.$3i)],c),e.$6L=(0,A.$zh)("IExtHostDocumentsAndEditors")}),define(Pe[60],Ae([1,0,8,3,2,5,4,7,17,16,100]),function(pe,e,y,R,C,L,A,h,S,g,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mbc=e.$Lbc=void 0,e.$Lbc=(0,A.$zh)("IExtHostEditorTabs");class D{constructor(t,i,c){this.e=c,this.d=i,this.acceptDtoUpdate(t)}get apiObject(){if(!this.a){const t=this,i={get isActive(){return t.b.id===t.e()},get label(){return t.b.label},get input(){return t.c},get isDirty(){return t.b.isDirty},get isPinned(){return t.b.isPinned},get isPreview(){return t.b.isPreview},get group(){return t.d.apiObject}};this.a=Object.freeze(i)}return this.a}get tabId(){return this.b.id}acceptDtoUpdate(t){this.b=t,this.c=this.f()}f(){switch(this.b.input.kind){case 1:return new h.$AL(C.URI.revive(this.b.input.uri));case 2:return new h.$BL(C.URI.revive(this.b.input.original),C.URI.revive(this.b.input.modified));case 3:return new h.$CL(C.URI.revive(this.b.input.base),C.URI.revive(this.b.input.input1),C.URI.revive(this.b.input.input2),C.URI.revive(this.b.input.result));case 6:return new h.$DL(C.URI.revive(this.b.input.uri),this.b.input.viewType);case 7:return new h.$EL(this.b.input.viewType);case 4:return new h.$FL(C.URI.revive(this.b.input.uri),this.b.input.notebookType);case 5:return new h.$GL(C.URI.revive(this.b.input.original),C.URI.revive(this.b.input.modified),this.b.input.notebookType);case 8:return new h.$HL;case 9:return new h.$IL(C.URI.revive(this.b.input.uri),C.URI.revive(this.b.input.inputBoxUri));default:return}}}class u{constructor(t,i){this.c=[],this.d="",this.b=t,this.e=i;for(const c of t.tabs)c.isActive&&(this.d=c.id),this.c.push(new D(c,this,()=>this.activeTabId()))}get apiObject(){if(!this.a){const t=this,i={get isActive(){return t.b.groupId===t.e()},get viewColumn(){return y.ViewColumn.to(t.b.viewColumn)},get activeTab(){return t.c.find(c=>c.tabId===t.d)?.apiObject},get tabs(){return Object.freeze(t.c.map(c=>c.apiObject))}};this.a=Object.freeze(i)}return this.a}get groupId(){return this.b.groupId}get tabs(){return this.c}acceptGroupDtoUpdate(t){this.b=t}acceptTabOperation(t){if(t.kind===0){const c=new D(t.tabDto,this,()=>this.activeTabId());return this.c.splice(t.index,0,c),t.tabDto.isActive&&(this.d=c.tabId),c}else if(t.kind===1){const c=this.c.splice(t.index,1)[0];if(!c)throw new Error(`Tab close updated received for index ${t.index} which does not exist`);return c.tabId===this.d&&(this.d=""),c}else if(t.kind===3){if(t.oldIndex===void 0)throw new Error("Invalid old index on move IPC");const c=this.c.splice(t.oldIndex,1)[0];if(!c)throw new Error(`Tab move updated received for index ${t.oldIndex} which does not exist`);return this.c.splice(t.index,0,c),c}const i=this.c.find(c=>c.tabId===t.tabDto.id);if(!i)throw new Error("INVALID tab");return t.tabDto.isActive?this.d=t.tabDto.id:this.d===t.tabDto.id&&!t.tabDto.isActive&&(this.d=""),i.acceptDtoUpdate(t.tabDto),i}activeTabId(){return this.d}}let p=class{constructor(t){this.b=new L.$hc,this.c=new L.$hc,this.e=[],this.a=t.getProxy(R.$SJ.MainThreadEditorTabs)}get tabGroups(){if(!this.f){const t=this,i={onDidChangeTabGroups:t.c.event,onDidChangeTabs:t.b.event,get all(){return Object.freeze(t.e.map(c=>c.apiObject))},get activeTabGroup(){const c=t.d;return(0,g.$we)(t.e.find(E=>E.groupId===c)?.apiObject)},close:async(c,m)=>{const E=Array.isArray(c)?c:[c];return E.length?$(E[0])?this.j(E,m):this.i(E,m):!0}};this.f=Object.freeze(i)}return this.f}$acceptEditorTabModel(t){const i=new Set(this.e.map(s=>s.groupId)),c=new Set(t.map(s=>s.groupId)),m=(0,P.$J)(i,c),E=this.e.filter(s=>m.removed.includes(s.groupId)).map(s=>s.apiObject),b=[],n=[];this.e=t.map(s=>{const o=new u(s,()=>this.d);return m.added.includes(o.groupId)?b.push(o.apiObject):n.push(o.apiObject),o});const a=(0,g.$we)(t.find(s=>s.isActive===!0)?.groupId);a!==void 0&&this.d!==a&&(this.d=a),this.c.fire(Object.freeze({opened:b,closed:E,changed:n}))}$acceptTabGroupUpdate(t){const i=this.e.find(c=>c.groupId===t.groupId);if(!i)throw new Error("Update Group IPC call received before group creation.");i.acceptGroupDtoUpdate(t),t.isActive&&(this.d=t.groupId),this.c.fire(Object.freeze({changed:[i.apiObject],opened:[],closed:[]}))}$acceptTabOperation(t){const i=this.e.find(m=>m.groupId===t.groupId);if(!i)throw new Error("Update Tabs IPC call received before group creation.");const c=i.acceptTabOperation(t);switch(t.kind){case 0:this.b.fire(Object.freeze({opened:[c.apiObject],closed:[],changed:[]}));return;case 1:this.b.fire(Object.freeze({opened:[],closed:[c.apiObject],changed:[]}));return;case 3:case 2:this.b.fire(Object.freeze({opened:[],closed:[],changed:[c.apiObject]}));return}}g(t){for(const i of this.e)for(const c of i.tabs)if(c.apiObject===t)return c}h(t){return this.e.find(i=>i.apiObject===t)}async i(t,i){const c=[];for(const m of t){const E=this.g(m);if(!E)throw new Error("Tab close: Invalid tab not found!");c.push(E.tabId)}return this.a.$closeTab(c,i)}async j(t,i){const c=[];for(const m of t){const E=this.h(m);if(!E)throw new Error("Group close: Invalid group not found!");c.push(E.groupId)}return this.a.$closeGroup(c,i)}};e.$Mbc=p,e.$Mbc=p=Ke([Ve(0,S.$UL)],p);function $(d){return d.tabs!==void 0}}),define(Pe[232],Ae([1,0,3,7]),function(pe,e,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ycc=void 0;class C{constructor(A){this.a=new Map,this.b=0,this.c=A.getProxy(y.$SJ.MainThreadAiEmbeddingVector)}async $provideAiEmbeddingVector(A,h,S){if(this.a.size===0)throw new Error("No embedding vector providers registered");const g=this.a.get(A);if(!g)throw new Error("Embedding vector provider not found");const P=await g.provideEmbeddingVector(h,S);if(!P)throw new Error("Embedding vector provider returned undefined");return P}registerEmbeddingVectorProvider(A,h,S){const g=this.b;return this.b++,this.a.set(g,S),this.c.$registerAiEmbeddingVectorProvider(h,g),new R.$UJ(()=>{this.c.$unregisterAiEmbeddingVectorProvider(g),this.a.delete(g)})}}e.$ycc=C}),define(Pe[233],Ae([1,0,2,3,6,7,8,279,15,25,26,49]),function(pe,e,y,R,C,L,A,h,S,g,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ibc=void 0;class u{constructor(){this.a=[]}add(d){this.b=void 0,this.a.push(d)}delete(d){const t=this.a.indexOf(d);t>=0&&(this.a.splice(t,1),this.b=void 0)}c(){if(!this.b){const d=this.a.sort(),t=[];let i,c,m=14,E=14;for(const b of d){let n=i?(0,S.$Qd)(i,b):0;for(n===0?c=1:c=E;n<b.length;n++)n+1===b.length?(m=E,E=9):E+=1,t.push([c,b.toUpperCase().charCodeAt(n),E]),t.push([c,b.toLowerCase().charCodeAt(n),E]),c=E;i=b,E=m}t.push([9,58,10]),t.push([10,47,12]),this.b=new h.$mY(t)}}provideDocumentLinks(d){this.c();const t=[],i=h.$nY.computeLinks({getLineContent(c){return d.lineAt(c-1).text},getLineCount(){return d.lineCount}},this.b);for(const c of i){const m=A.DocumentLink.to(c);m.target&&t.push(m)}return t}}class p{constructor(d,t){this.i=t,this.b=new u,this.c=new Map,this.d=new Set,this.f=new Map,this.h=0,this.a=d.getProxy(R.$SJ.MainThreadFileSystem)}dispose(){this.g?.dispose()}registerFileSystemProvider(d,t,i,c={}){if(p.j(i),this.d.has(t))throw new Error(`a provider for the scheme '${t}' is already registered`);this.g||(this.g=this.i.registerDocumentLinkProvider(d,"*",this.b));const m=this.h++;this.b.add(t),this.d.add(t),this.c.set(m,i);let E=2;c.isCaseSensitive&&(E+=1024),c.isReadonly&&(E+=2048),typeof i.copy=="function"&&(E+=8),typeof i.open=="function"&&typeof i.close=="function"&&typeof i.read=="function"&&typeof i.write=="function"&&((0,P.$MF)(d,"fsChunks"),E+=4);let b;c.isReadonly&&(0,D.$Xj)(c.isReadonly)&&((0,P.$MF)(d,"readonlyMessage"),b={value:c.isReadonly.value,isTrusted:c.isReadonly.isTrusted,supportThemeIcons:c.isReadonly.supportThemeIcons,supportHtml:c.isReadonly.supportHtml,baseUri:c.isReadonly.baseUri,uris:c.isReadonly.uris}),this.a.$registerFileSystemProvider(m,t,E,b).catch(a=>{console.error(`FAILED to register filesystem provider of ${d.identifier.value}-extension for the scheme ${t}`),console.error(a)});const n=i.onDidChangeFile(a=>{const s=[];for(const o of a){const{uri:w,type:v}=o;if(w.scheme!==t)continue;let I;switch(v){case L.FileChangeType.Changed:I=0;break;case L.FileChangeType.Created:I=1;break;case L.FileChangeType.Deleted:I=2;break;default:throw new Error("Unknown FileChangeType")}s.push({resource:w,type:I})}this.a.$onFileSystemChange(m,s)});return(0,C.$kb)(()=>{n.dispose(),this.b.delete(t),this.d.delete(t),this.c.delete(m),this.a.$unregisterProvider(m)})}static j(d){if(!d)throw new Error("MISSING provider");if(typeof d.watch!="function")throw new Error("Provider does NOT implement watch");if(typeof d.stat!="function")throw new Error("Provider does NOT implement stat");if(typeof d.readDirectory!="function")throw new Error("Provider does NOT implement readDirectory");if(typeof d.createDirectory!="function")throw new Error("Provider does NOT implement createDirectory");if(typeof d.readFile!="function")throw new Error("Provider does NOT implement readFile");if(typeof d.writeFile!="function")throw new Error("Provider does NOT implement writeFile");if(typeof d.delete!="function")throw new Error("Provider does NOT implement delete");if(typeof d.rename!="function")throw new Error("Provider does NOT implement rename")}static k(d){const{type:t,ctime:i,mtime:c,size:m,permissions:E}=d;return{type:t,ctime:i,mtime:c,size:m,permissions:E}}$stat(d,t){return Promise.resolve(this.l(d).stat(y.URI.revive(t))).then(i=>p.k(i))}$readdir(d,t){return Promise.resolve(this.l(d).readDirectory(y.URI.revive(t)))}$readFile(d,t){return Promise.resolve(this.l(d).readFile(y.URI.revive(t))).then(i=>g.$Hc.wrap(i))}$writeFile(d,t,i,c){return Promise.resolve(this.l(d).writeFile(y.URI.revive(t),i.buffer,c))}$delete(d,t,i){return Promise.resolve(this.l(d).delete(y.URI.revive(t),i))}$rename(d,t,i,c){return Promise.resolve(this.l(d).rename(y.URI.revive(t),y.URI.revive(i),c))}$copy(d,t,i,c){const m=this.l(d);if(!m.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(m.copy(y.URI.revive(t),y.URI.revive(i),c))}$mkdir(d,t){return Promise.resolve(this.l(d).createDirectory(y.URI.revive(t)))}$watch(d,t,i,c){const m=this.l(d).watch(y.URI.revive(i),c);this.f.set(t,m)}$unwatch(d,t){const i=this.f.get(t);i&&(i.dispose(),this.f.delete(t))}$open(d,t,i){const c=this.l(d);if(!c.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(c.open(y.URI.revive(t),i))}$close(d,t){const i=this.l(d);if(!i.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(i.close(t))}$read(d,t,i,c){const m=this.l(d);if(!m.read)throw new Error('FileSystemProvider does not implement "read"');const E=g.$Hc.alloc(c);return Promise.resolve(m.read(t,i,E.buffer,0,c)).then(b=>E.slice(0,b))}$write(d,t,i,c){const m=this.l(d);if(!m.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(m.write(t,i,c.buffer,0,c.byteLength))}l(d){const t=this.c.get(d);if(!t){const i=new Error;throw i.name="ENOPRO",i.message="no provider",i}return t}}e.$ibc=p}),define(Pe[61],Ae([1,0,3,38,7,25,4,17,39,6,13,23,12]),function(pe,e,y,R,C,L,A,h,S,g,P,D,u){"use strict";var p;Object.defineProperty(e,"__esModule",{value:!0}),e.$2ac=e.$1ac=void 0;let $=p=class{constructor(t,i){this.b=new Map,this.c=new P.$Ng,this.a=t.getProxy(y.$SJ.MainThreadFileSystem);const c=this;this.value=Object.freeze({async stat(m){try{let E;const b=c.b.get(m.scheme);return b?(await c.a.$ensureActivation(m.scheme),E=await b.impl.stat(m)):E=await c.a.$stat(m),{type:E.type,ctime:E.ctime,mtime:E.mtime,size:E.size,permissions:E.permissions===R.FilePermission.Readonly?1:void 0}}catch(E){p.e(E)}},async readDirectory(m){try{const E=c.b.get(m.scheme);return E?(await c.a.$ensureActivation(m.scheme),(await E.impl.readDirectory(m)).slice()):await c.a.$readdir(m)}catch(E){return p.e(E)}},async createDirectory(m){try{const E=c.b.get(m.scheme);return E&&!E.isReadonly?(await c.a.$ensureActivation(m.scheme),await c.d(E.impl,E.extUri,m)):await c.a.$mkdir(m)}catch(E){return p.e(E)}},async readFile(m){try{const E=c.b.get(m.scheme);return E?(await c.a.$ensureActivation(m.scheme),(await E.impl.readFile(m)).slice()):(await c.a.$readFile(m)).buffer}catch(E){return p.e(E)}},async writeFile(m,E){try{const b=c.b.get(m.scheme);return b&&!b.isReadonly?(await c.a.$ensureActivation(m.scheme),await c.d(b.impl,b.extUri,b.extUri.dirname(m)),await c.c.queueFor(m).queue(()=>Promise.resolve(b.impl.writeFile(m,E,{create:!0,overwrite:!0})))):await c.a.$writeFile(m,L.$Hc.wrap(E))}catch(b){return p.e(b)}},async delete(m,E){try{const b=c.b.get(m.scheme);return b&&!b.isReadonly?(await c.a.$ensureActivation(m.scheme),await b.impl.delete(m,{recursive:!1,...E})):await c.a.$delete(m,{recursive:!1,useTrash:!1,atomic:!1,...E})}catch(b){return p.e(b)}},async rename(m,E,b){try{return await c.a.$rename(m,E,{overwrite:!1,...b})}catch(n){return p.e(n)}},async copy(m,E,b){try{return await c.a.$copy(m,E,{overwrite:!1,...b})}catch(n){return p.e(n)}},isWritableFileSystem(m){const E=i.getCapabilities(m);if(typeof E=="number")return!(E&2048)}})}async d(t,i,c){const m=[];for(;!i.isEqual(c,i.dirname(c));)try{if(!((await t.stat(c)).type&R.FileType.Directory))throw C.$9K.FileExists(`Unable to create folder '${c.scheme===u.Schemas.file?c.fsPath:c.toString(!0)}' that already exists but is not a directory`);break}catch(E){if(R.$gk(E)!==R.FileSystemProviderErrorCode.FileNotFound)throw E;m.push(i.basename(c)),c=i.dirname(c)}for(let E=m.length-1;E>=0;E--){c=i.joinPath(c,m[E]);try{await t.createDirectory(c)}catch(b){if(R.$gk(b)!==R.FileSystemProviderErrorCode.FileExists)throw b}}}static e(t){if(t instanceof C.$9K)throw t;if(t instanceof R.$ck)switch(t.code){case R.FileSystemProviderErrorCode.FileExists:throw C.$9K.FileExists(t.message);case R.FileSystemProviderErrorCode.FileNotFound:throw C.$9K.FileNotFound(t.message);case R.FileSystemProviderErrorCode.FileNotADirectory:throw C.$9K.FileNotADirectory(t.message);case R.FileSystemProviderErrorCode.FileIsADirectory:throw C.$9K.FileIsADirectory(t.message);case R.FileSystemProviderErrorCode.NoPermissions:throw C.$9K.NoPermissions(t.message);case R.FileSystemProviderErrorCode.Unavailable:throw C.$9K.Unavailable(t.message);default:throw new C.$9K(t.message,t.name)}if(!(t instanceof Error))throw new C.$9K(String(t));if(t.name==="ENOPRO"||t.message.includes("ENOPRO"))throw C.$9K.Unavailable(t.message);switch(t.name){case R.FileSystemProviderErrorCode.FileExists:throw C.$9K.FileExists(t.message);case R.FileSystemProviderErrorCode.FileNotFound:throw C.$9K.FileNotFound(t.message);case R.FileSystemProviderErrorCode.FileNotADirectory:throw C.$9K.FileNotADirectory(t.message);case R.FileSystemProviderErrorCode.FileIsADirectory:throw C.$9K.FileIsADirectory(t.message);case R.FileSystemProviderErrorCode.NoPermissions:throw C.$9K.NoPermissions(t.message);case R.FileSystemProviderErrorCode.Unavailable:throw C.$9K.Unavailable(t.message);default:throw new C.$9K(t.message,t.name)}}addFileSystemProvider(t,i,c){return this.b.set(t,{impl:i,extUri:c?.isCaseSensitive?D.$9f:D.$$f,isReadonly:!!c?.isReadonly}),(0,g.$kb)(()=>this.b.delete(t))}getFileSystemProviderExtUri(t){return this.b.get(t)?.extUri??D.$9f}};e.$1ac=$,e.$1ac=$=p=Ke([Ve(0,h.$UL),Ve(1,S.$wac)],$),e.$2ac=(0,A.$zh)("IExtHostConsumerFileSystem")}),define(Pe[234],Ae([1,0,5,37,2,3,8,7]),function(pe,e,y,R,C,L,A,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jbc=void 0;class S{get ignoreCreateEvents(){return!!(this.g&1)}get ignoreChangeEvents(){return!!(this.g&2)}get ignoreDeleteEvents(){return!!(this.g&4)}constructor(D,u,p,$,d,t,i,c){this.a=new y.$hc,this.b=new y.$hc,this.c=new y.$hc;const m=this.h(D,p,d);this.g=0,t&&(this.g+=1),i&&(this.g+=2),c&&(this.g+=4);const E=(0,R.$pj)(d),b=typeof d=="string",n=$(a=>{if(!t)for(const s of a.created){const o=C.URI.revive(s);E(o.fsPath)&&(!b||u.getWorkspaceFolder(o))&&this.a.fire(o)}if(!i)for(const s of a.changed){const o=C.URI.revive(s);E(o.fsPath)&&(!b||u.getWorkspaceFolder(o))&&this.b.fire(o)}if(!c)for(const s of a.deleted){const o=C.URI.revive(s);E(o.fsPath)&&(!b||u.getWorkspaceFolder(o))&&this.c.fire(o)}});this.d=h.$UJ.from(m,this.a,this.b,this.c,n)}h(D,u,p){const $=h.$UJ.from();if(typeof p=="string")return $;const d=D.getProxy(L.$SJ.MainThreadFileSystem);let t=!1;(p.pattern.includes(R.$lj)||p.pattern.includes(R.$mj))&&(t=!0);const i=Math.random();return d.$watch(u.identifier.value,i,p.baseUri,{recursive:t,excludes:[]}),h.$UJ.from({dispose:()=>d.$unwatch(i)})}dispose(){this.d.dispose()}get onDidCreate(){return this.a.event}get onDidChange(){return this.b.event}get onDidDelete(){return this.c.event}}class g{constructor(D,u,p){this.j=D,this.k=u,this.l=p,this.a=new y.$hc,this.b=new y.$hc,this.c=new y.$hc,this.d=new y.$hc,this.g=new y.$jc,this.h=new y.$jc,this.i=new y.$jc,this.onDidRenameFile=this.b.event,this.onDidCreateFile=this.c.event,this.onDidDeleteFile=this.d.event}createFileSystemWatcher(D,u,p,$,d,t){return new S(this.j,D,u,this.a.event,A.GlobPattern.from(p),$,d,t)}$onFileEvent(D){this.a.fire(D)}$onDidRunFileOperation(D,u){switch(D){case 2:this.b.fire(Object.freeze({files:u.map(p=>({oldUri:C.URI.revive(p.source),newUri:C.URI.revive(p.target)}))}));break;case 1:this.d.fire(Object.freeze({files:u.map(p=>C.URI.revive(p.target))}));break;case 0:case 3:this.c.fire(Object.freeze({files:u.map(p=>C.URI.revive(p.target))}));break;default:}}getOnWillRenameFileEvent(D){return this.m(D,this.g)}getOnWillCreateFileEvent(D){return this.m(D,this.h)}getOnWillDeleteFileEvent(D){return this.m(D,this.i)}m(D,u){return(p,$,d)=>{const t=function(c){p.call($,c)};return t.extension=D,u.event(t,void 0,d)}}async $onWillRunFileOperation(D,u,p,$){switch(D){case 2:return await this.n(this.g,{files:u.map(d=>({oldUri:C.URI.revive(d.source),newUri:C.URI.revive(d.target)}))},p,$);case 1:return await this.n(this.i,{files:u.map(d=>C.URI.revive(d.target))},p,$);case 0:case 3:return await this.n(this.h,{files:u.map(d=>C.URI.revive(d.target))},p,$)}}async n(D,u,p,$){const d=new Set,t=[];if(await D.fireAsync(u,$,async(c,m)=>{const E=Date.now(),b=await Promise.resolve(c);b instanceof h.$5J&&(t.push([m.extension,b]),d.add(m.extension.displayName??m.extension.identifier.value)),Date.now()-E>p&&this.k.warn("SLOW file-participant",m.extension.identifier)}),$.isCancellationRequested||t.length===0)return;const i={edits:[]};for(const[,c]of t){const{edits:m}=A.WorkspaceEdit.from(c,{getTextDocumentVersion:E=>this.l.getDocument(E)?.version,getNotebookDocumentVersion:()=>{}});i.edits=i.edits.concat(m)}return{edit:i,extensionNames:Array.from(d)}}}e.$jbc=g}),define(Pe[235],Ae([1,0,6,2,3,8,7,31]),function(pe,e,y,R,C,L,A,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qcc=void 0;class S{static{this.a=0}constructor(u,p){this.extension=u,this.provider=p,this.handle=S.a++}}class g{constructor(u){this.session=u,this.responses=[]}}class P{static{this.a=0}constructor(u,p,$,d){this.f=$,this.g=d,this.b=new Map,this.d=new Map,this.e=u.getProxy(C.$SJ.MainThreadInlineChat),p.registerApiCommand(new h.$iM("vscode.editorChat.start","inlineChat.start","Invoke a new editor chat session",[new h.$gM("Run arguments","",t=>!0,t=>{if(t)return{initialRange:t.initialRange?L.Range.from(t.initialRange):void 0,initialSelection:t.initialSelection?L.Selection.from(t.initialSelection):void 0,message:t.message,autoSend:t.autoSend,position:t.position?L.Position.from(t.position):void 0}})],h.$hM.Void))}registerProvider(u,p){const $=new S(u,p);return this.b.set($.handle,$),this.e.$registerInteractiveEditorProvider($.handle,p.label,u.identifier.value,typeof p.handleInteractiveEditorResponseFeedback=="function"),(0,y.$kb)(()=>{this.e.$unregisterInteractiveEditorProvider($.handle),this.b.delete($.handle)})}async $prepareSession(u,p,$,d){const t=this.b.get(u);if(!t){this.g.warn("CANNOT prepare session because the PROVIDER IS GONE");return}const i=this.f.getDocument(R.URI.revive(p)),c=L.Selection.to($),m=await t.provider.prepareInteractiveEditorSession({document:i,selection:c},d);if(!m)return;if(m.wholeRange&&!m.wholeRange.contains(c))throw new Error("InteractiveEditorSessionProvider returned a wholeRange that does not contain the selection.");const E=P.a++;return this.d.set(E,new g(m)),{id:E,placeholder:m.placeholder,slashCommands:m.slashCommands?.map(b=>({command:b.command,detail:b.detail,refer:b.refer,executeImmediately:b.executeImmediately})),wholeRange:L.Range.from(m.wholeRange),message:m.message}}async $provideResponse(u,p,$,d){const t=this.b.get(u);if(!t)return;const i=this.d.get(p.id);if(!i)return;const c={session:i.session,prompt:$.prompt,selection:L.Selection.to($.selection),wholeRange:L.Range.to($.wholeRange),attempt:$.attempt,live:$.live};let m=!1;const E={report:a=>{if(!$.live)throw new Error("Progress reporting is only supported for live sessions");m||d.isCancellationRequested||!a.message&&!a.edits||this.e.$handleProgressChunk($.requestId,{message:a.message,edits:a.edits?.map(L.TextEdit.from)})}},b=typeof t.provider.provideInteractiveEditorResponse2=="function"?t.provider.provideInteractiveEditorResponse2(c,E,d):t.provider.provideInteractiveEditorResponse(c,d);Promise.resolve(b).finally(()=>m=!0);const n=await b;if(n){const a=i.responses.push(n)-1,s={wholeRange:L.Range.from(n.wholeRange),placeholder:n.placeholder};if(P.h(n))return{...s,id:a,type:"message",message:L.MarkdownString.from(n.contents)};const{edits:o}=n;if(o instanceof A.$5J)return{...s,id:a,type:"bulkEdit",edits:L.WorkspaceEdit.from(o)};if(Array.isArray(o))return{...s,id:a,type:"editorEdit",edits:o.map(L.TextEdit.from)}}}$handleFeedback(u,p,$,d){const t=this.b.get(u),i=this.d.get(p),c=i?.responses[$];if(t&&c){const m=L.InteractiveEditorResponseFeedbackKind.to(d);t.provider.handleInteractiveEditorResponseFeedback?.(i.session,c,m)}}$releaseSession(u,p){const $=this.d.get(p),d=this.b.get(u);$&&d&&d.provider.releaseInteractiveEditorSession?.($.session),this.d.delete(p)}static h(u){return typeof u=="object"&&typeof u.contents=="object"}}e.$qcc=P}),define(Pe[236],Ae([1,0,2,31]),function(pe,e,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mcc=void 0;class C{constructor(A,h,S,g,P){this.a=h,this.b=S,this.c=g;const D=new R.$iM("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new R.$gM("showOptions","Show Options",u=>!0,u=>u),new R.$gM("resource","Interactive resource Uri",u=>!0,u=>u),new R.$gM("controllerId","Notebook controller Id",u=>!0,u=>u),new R.$gM("title","Interactive editor title",u=>!0,u=>u)],new R.$hM("Notebook and input URI",u=>{if(P.debug("[ExtHostInteractive] open iw with notebook editor id",u.notebookEditorId),u.notebookEditorId!==void 0){const p=this.a.getEditorById(u.notebookEditorId);return P.debug("[ExtHostInteractive] notebook editor found",p.id),{notebookUri:y.URI.revive(u.notebookUri),inputUri:y.URI.revive(u.inputUri),notebookEditor:p.apiEditor}}return P.debug("[ExtHostInteractive] notebook editor not found, uris for the interactive document",u.notebookUri,u.inputUri),{notebookUri:y.URI.revive(u.notebookUri),inputUri:y.URI.revive(u.inputUri)}}));this.c.registerApiCommand(D)}$willAddInteractiveDocument(A,h,S,g){this.b.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:h,lines:[""],languageId:S,uri:A,isDirty:!1,versionId:1,notebook:this.a.getNotebookDocument(y.URI.revive(g))?.apiNotebook}]})}$willRemoveInteractiveDocument(A,h){this.b.acceptDocumentsAndEditorsDelta({removedDocuments:[A]})}}e.$mcc=C}),define(Pe[237],Ae([1,0,3,7]),function(pe,e,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$scc=void 0;class C{constructor(A){this.a=new Map,this.b=A.getProxy(y.$SJ.MainThreadIssueReporter)}async $getIssueReporterUri(A,h){if(this.a.size===0)throw new Error("No issue request handlers registered");const S=this.a.get(A);if(!S)throw new Error("Issue request handler not found");const g=await S.handleIssueUrlRequest();if(!g)throw new Error("Issue request handler returned no result");return g}registerIssueUriRequestHandler(A,h){const S=A.identifier.value;return this.a.set(S,h),this.b.$registerIssueUriRequestHandler(S),new R.$UJ(()=>{this.b.$unregisterIssueUriRequestHandler(S),this.a.delete(S)})}}e.$scc=C}),define(Pe[238],Ae([1,0,6,3]),function(pe,e,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fbc=void 0;class C{constructor(A){this.b=0,this.a=A.getProxy(R.$SJ.MainThreadLabelService)}$registerResourceLabelFormatter(A){const h=this.b++;return this.a.$registerResourceLabelFormatter(h,A),(0,y.$kb)(()=>{this.a.$unregisterResourceLabelFormatter(h)})}}e.$Fbc=C}),define(Pe[239],Ae([1,0,2,24,8,7,78,3,15,44,18,16,280,21,20,6,91,88,54,58,9,13,26,150]),function(pe,e,y,R,C,L,A,h,S,g,P,D,u,p,$,d,t,i,c,m,E,b,n,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cac=void 0;class s{constructor(M,q){this.d=M,this.e=q}async provideDocumentSymbols(M,q){const H=this.d.getDocument(M),Z=await this.e.provideDocumentSymbols(H,q);if(!(0,P.$Df)(Z))return Z[0]instanceof L.$aK?Z.map(C.DocumentSymbol.from):s.f(Z)}static f(M){M=M.slice(0).sort((Z,K)=>{let ee=Z.location.range.start.compareTo(K.location.range.start);return ee===0&&(ee=K.location.range.end.compareTo(Z.location.range.end)),ee});const q=[],H=[];for(const Z of M){const K={name:Z.name||"!!MISSING: name!!",kind:C.SymbolKind.from(Z.kind),tags:Z.tags?.map(C.SymbolTag.from)||[],detail:"",containerName:Z.containerName,range:C.Range.from(Z.location.range),selectionRange:C.Range.from(Z.location.range),children:[]};for(;;){if(H.length===0){H.push(K),q.push(K);break}const ee=H[H.length-1];if(g.$hs.containsRange(ee.range,K.range)&&!g.$hs.equalsRange(ee.range,K.range)){ee.children?.push(K),H.push(K);break}H.pop()}}return q}}class o{static{this.d={command:"missing",title:"!!MISSING: command!!"}}constructor(M,q,H){this.g=M,this.h=q,this.j=H,this.e=new c.$tac("CodeLens"),this.f=new Map}async provideCodeLenses(M,q){const H=this.g.getDocument(M),Z=await this.j.provideCodeLenses(H,q);if(!Z||q.isCancellationRequested)return;const K=this.e.add(Z),ee=new d.$lb;this.f.set(K,ee);const ce={cacheId:K,lenses:[]};for(let ze=0;ze<Z.length;ze++)ce.lenses.push({cacheId:[K,ze],range:C.Range.from(Z[ze].range),command:this.h.toInternal(Z[ze].command,ee)});return ce}async resolveCodeLens(M,q){const H=M.cacheId&&this.e.get(...M.cacheId);if(!H)return;let Z;if(typeof this.j.resolveCodeLens!="function"||H.isResolved?Z=H:Z=await this.j.resolveCodeLens(H,q),Z||(Z=H),q.isCancellationRequested)return;const K=M.cacheId&&this.f.get(M.cacheId[0]);if(K)return M.command=this.h.toInternal(Z.command??o.d,K),M}releaseCodeLenses(M){this.f.get(M)?.dispose(),this.f.delete(M),this.e.delete(M)}}function w(Ce){return Array.isArray(Ce)?Ce.map(C.DefinitionLink.from):Ce?[C.DefinitionLink.from(Ce)]:[]}class v{constructor(M,q){this.d=M,this.e=q}async provideDefinition(M,q,H){const Z=this.d.getDocument(M),K=C.Position.to(q),ee=await this.e.provideDefinition(Z,K,H);return w(ee)}}class I{constructor(M,q){this.d=M,this.e=q}async provideDeclaration(M,q,H){const Z=this.d.getDocument(M),K=C.Position.to(q),ee=await this.e.provideDeclaration(Z,K,H);return w(ee)}}class k{constructor(M,q){this.d=M,this.e=q}async provideImplementation(M,q,H){const Z=this.d.getDocument(M),K=C.Position.to(q),ee=await this.e.provideImplementation(Z,K,H);return w(ee)}}class r{constructor(M,q){this.d=M,this.e=q}async provideTypeDefinition(M,q,H){const Z=this.d.getDocument(M),K=C.Position.to(q),ee=await this.e.provideTypeDefinition(Z,K,H);return w(ee)}}class l{constructor(M,q){this.d=M,this.e=q}async provideHover(M,q,H){const Z=this.d.getDocument(M),K=C.Position.to(q),ee=await this.e.provideHover(Z,K,H);if(!(!ee||(0,P.$Df)(ee.contents)))return ee.range||(ee.range=Z.getWordRangeAtPosition(K)),ee.range||(ee.range=new L.$WJ(K,K)),C.Hover.from(ee)}}class f{constructor(M,q){this.d=M,this.e=q}async provideEvaluatableExpression(M,q,H){const Z=this.d.getDocument(M),K=C.Position.to(q),ee=await this.e.provideEvaluatableExpression(Z,K,H);if(ee)return C.EvaluatableExpression.from(ee)}}class F{constructor(M,q){this.d=M,this.e=q}async provideInlineValues(M,q,H,Z){const K=this.d.getDocument(M),ee=await this.e.provideInlineValues(K,C.Range.to(q),C.InlineValueContext.to(H),Z);if(Array.isArray(ee))return ee.map(ce=>C.InlineValue.from(ce))}}class W{constructor(M,q){this.d=M,this.e=q}async provideDocumentHighlights(M,q,H){const Z=this.d.getDocument(M),K=C.Position.to(q),ee=await this.e.provideDocumentHighlights(Z,K,H);if(Array.isArray(ee))return ee.map(C.DocumentHighlight.from)}}class V{constructor(M,q){this.d=M,this.e=q}async provideLinkedEditingRanges(M,q,H){const Z=this.d.getDocument(M),K=C.Position.to(q),ee=await this.e.provideLinkedEditingRanges(Z,K,H);if(ee&&Array.isArray(ee.ranges))return{ranges:(0,P.$Af)(ee.ranges.map(C.Range.from)),wordPattern:ee.wordPattern}}}class B{constructor(M,q){this.d=M,this.e=q}async provideReferences(M,q,H,Z){const K=this.d.getDocument(M),ee=C.Position.to(q),ce=await this.e.provideReferences(K,ee,H,Z);if(Array.isArray(ce))return ce.map(C.location.from)}}class j{static{this.d=1e3}constructor(M,q,H,Z,K,ee,ce){this.h=M,this.j=q,this.k=H,this.l=Z,this.m=K,this.n=ee,this.o=ce,this.e=new c.$tac("CodeAction"),this.f=new Map,this.g=new L.$cK("notebook")}async provideCodeActions(M,q,H,Z){const K=this.h.getDocument(M),ee=u.$js.isISelection(q)?C.Selection.to(q):C.Range.to(q),ce=[];for(const Ye of this.k.getDiagnostics(M))if(ee.intersection(Ye.range)&&ce.push(Ye)>j.d)break;const ze={diagnostics:ce,only:H.only?new L.$cK(H.only):void 0,triggerKind:C.CodeActionTriggerKind.to(H.trigger)},Ue=await this.l.provideCodeActions(K,ee,ze,Z);if(!(0,P.$Ef)(Ue)||Z.isCancellationRequested)return;const Ze=this.e.add(Ue),He=new d.$lb;this.f.set(Ze,He);const et=[];for(let Ye=0;Ye<Ue.length;Ye++){const _e=Ue[Ye];if(_e)if(j.p(_e))this.o.report("CodeActionProvider.provideCodeActions - return commands",this.n,"Return 'CodeAction' instances instead."),et.push({_isSynthetic:!0,title:_e.title,command:this.j.toInternal(_e,He)});else{if(ze.triggerKind!==L.CodeActionTriggerKind.Invoke&&_e.kind&&this.g.contains(_e.kind))continue;ze.only&&(_e.kind?ze.only.contains(_e.kind)||this.m.warn(`${this.n.identifier.value} - Code actions of kind '${ze.only.value} 'requested but returned code action is of kind '${_e.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this.m.warn(`${this.n.identifier.value} - Code actions of kind '${ze.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),et.push({cacheId:[Ze,Ye],title:_e.title,command:_e.command&&this.j.toInternal(_e.command,He),diagnostics:_e.diagnostics&&_e.diagnostics.map(C.Diagnostic.from),edit:_e.edit&&C.WorkspaceEdit.from(_e.edit,void 0),kind:_e.kind&&_e.kind.value,isPreferred:_e.isPreferred,disabled:_e.disabled?.reason})}}return{cacheId:Ze,actions:et}}async resolveCodeAction(M,q){const[H,Z]=M,K=this.e.get(H,Z);if(!K||j.p(K))return{};if(!this.l.resolveCodeAction)return{};const ee=await this.l.resolveCodeAction(K,q)??K;let ce;ee.edit&&(ce=C.WorkspaceEdit.from(ee.edit,void 0));let ze;if(ee.command){const Ue=this.f.get(H);Ue&&(ze=this.j.toInternal(ee.command,Ue))}return{edit:ce,command:ze}}releaseCodeActions(M){this.f.get(M)?.dispose(),this.f.delete(M),this.e.delete(M)}static p(M){return typeof M.command=="string"&&typeof M.title=="string"}}class U{static toInternalProviderId(M,q){return M+"."+q}constructor(M,q,H,Z,K){this.d=M,this.e=q,this.f=H,this.g=Z,this.h=K}async prepareDocumentPaste(M,q,H,Z){if(!this.f.prepareDocumentPaste)return;const K=this.e.getDocument(M),ee=q.map(Ue=>C.Range.to(Ue)),ce=C.DataTransfer.toDataTransfer(H,()=>{throw new E.$9});if(await this.f.prepareDocumentPaste(K,ee,ce,Z),Z.isCancellationRequested)return;const ze=Array.from(ce).filter(([,Ue])=>!(Ue instanceof L.$JK));return C.DataTransfer.from(ze)}async providePasteEdits(M,q,H,Z,K){if(!this.f.provideDocumentPasteEdits)return;const ee=this.e.getDocument(q),ce=H.map(Ze=>C.Range.to(Ze)),ze=C.DataTransfer.toDataTransfer(Z,async Ze=>(await this.d.$resolvePasteFileData(this.g,M,Ze)).buffer),Ue=await this.f.provideDocumentPasteEdits(ee,ce,ze,K);if(Ue)return{label:Ue.label??(0,a.localize)(0,null,this.h.displayName||this.h.name),detail:this.h.displayName||this.h.name,yieldTo:Ue.yieldTo?.map(Ze=>"mimeType"in Ze?Ze:{providerId:U.toInternalProviderId(Ze.extensionId,Ze.providerId)}),insertText:typeof Ue.insertText=="string"?Ue.insertText:{snippet:Ue.insertText.value},additionalEdit:Ue.additionalEdit?C.WorkspaceEdit.from(Ue.additionalEdit,void 0):void 0}}}class z{constructor(M,q){this.d=M,this.e=q}async provideDocumentFormattingEdits(M,q,H){const Z=this.d.getDocument(M),K=await this.e.provideDocumentFormattingEdits(Z,q,H);if(Array.isArray(K))return K.map(C.TextEdit.from)}}class ie{constructor(M,q){this.d=M,this.e=q}async provideDocumentRangeFormattingEdits(M,q,H,Z){const K=this.d.getDocument(M),ee=C.Range.to(q),ce=await this.e.provideDocumentRangeFormattingEdits(K,ee,H,Z);if(Array.isArray(ce))return ce.map(C.TextEdit.from)}async provideDocumentRangesFormattingEdits(M,q,H,Z){(0,D.$ve)(typeof this.e.provideDocumentRangesFormattingEdits=="function","INVALID invocation of `provideDocumentRangesFormattingEdits`");const K=this.d.getDocument(M),ee=q.map(C.Range.to),ce=await this.e.provideDocumentRangesFormattingEdits(K,ee,H,Z);if(Array.isArray(ce))return ce.map(C.TextEdit.from)}}class Y{constructor(M,q){this.d=M,this.e=q,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(M,q,H,Z,K){const ee=this.d.getDocument(M),ce=C.Position.to(q),ze=await this.e.provideOnTypeFormattingEdits(ee,ce,H,Z,K);if(Array.isArray(ze))return ze.map(C.TextEdit.from)}}class ye{constructor(M,q){this.e=M,this.f=q,this.d=new c.$tac("WorkspaceSymbols")}async provideWorkspaceSymbols(M,q){const H=await this.e.provideWorkspaceSymbols(M,q);if(!(0,P.$Ef)(H))return{symbols:[]};const Z=this.d.add(H),K={cacheId:Z,symbols:[]};for(let ee=0;ee<H.length;ee++){const ce=H[ee];if(!ce||!ce.name){this.f.warn("INVALID SymbolInformation",ce);continue}K.symbols.push({...C.WorkspaceSymbol.from(ce),cacheId:[Z,ee]})}return K}async resolveWorkspaceSymbol(M,q){if(typeof this.e.resolveWorkspaceSymbol!="function"||!M.cacheId)return M;const H=this.d.get(...M.cacheId);if(H){const Z=await this.e.resolveWorkspaceSymbol(H,q);return Z&&(0,R.$Wm)(M,C.WorkspaceSymbol.from(Z),!0)}}releaseWorkspaceSymbols(M){this.d.delete(M)}}class ke{static supportsResolving(M){return typeof M.prepareRename=="function"}constructor(M,q,H){this.d=M,this.e=q,this.f=H}async provideRenameEdits(M,q,H,Z){const K=this.d.getDocument(M),ee=C.Position.to(q);try{const ce=await this.e.provideRenameEdits(K,ee,H,Z);return ce?C.WorkspaceEdit.from(ce):void 0}catch(ce){const ze=ke.g(ce);return ze?{rejectReason:ze,edits:void 0}:Promise.reject(ce)}}async resolveRenameLocation(M,q,H){if(typeof this.e.prepareRename!="function")return Promise.resolve(void 0);const Z=this.d.getDocument(M),K=C.Position.to(q);try{const ee=await this.e.prepareRename(Z,K,H);let ce,ze;if(L.$WJ.isRange(ee)?(ce=ee,ze=Z.getText(ee)):(0,D.$ne)(ee)&&(ce=ee.range,ze=ee.placeholder),!ce||!ze)return;if(ce.start.line>K.line||ce.end.line<K.line){this.f.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:C.Range.from(ce),text:ze}}catch(ee){const ce=ke.g(ee);return ce?{rejectReason:ce,range:void 0,text:void 0}:Promise.reject(ee)}}static g(M){return typeof M=="string"?M:M instanceof Error&&typeof M.message=="string"?M.message:void 0}}class Re{constructor(M,q){this.resultId=M,this.tokens=q}}class X{constructor(M,q){this.f=M,this.g=q,this.e=1,this.d=new Map}async provideDocumentSemanticTokens(M,q,H){const Z=this.f.getDocument(M),K=q!==0?this.d.get(q):null;let ee=typeof K?.resultId=="string"&&typeof this.g.provideDocumentSemanticTokensEdits=="function"?await this.g.provideDocumentSemanticTokensEdits(Z,K.resultId,H):await this.g.provideDocumentSemanticTokens(Z,H);return K&&this.d.delete(q),ee?(ee=X.h(ee),this.o(X.n(K,ee),ee)):null}async releaseDocumentSemanticColoring(M){this.d.delete(M)}static h(M){return X.j(M)?X.k(M)?M:new L.$aL(new Uint32Array(M.data),M.resultId):X.l(M)?X.m(M)?M:new L.$cL(M.edits.map(q=>new L.$bL(q.start,q.deleteCount,q.data?new Uint32Array(q.data):q.data)),M.resultId):M}static j(M){return M&&!!M.data}static k(M){return M.data instanceof Uint32Array}static l(M){return M&&Array.isArray(M.edits)}static m(M){for(const q of M.edits)if(!(q.data instanceof Uint32Array))return!1;return!0}static n(M,q){if(!X.j(q)||!M||!M.tokens)return q;const H=M.tokens,Z=H.length,K=q.data,ee=K.length;let ce=0;const ze=Math.min(Z,ee);for(;ce<ze&&H[ce]===K[ce];)ce++;if(ce===Z&&ce===ee)return new L.$cL([],q.resultId);let Ue=0;const Ze=ze-ce;for(;Ue<Ze&&H[Z-Ue-1]===K[ee-Ue-1];)Ue++;return new L.$cL([{start:ce,deleteCount:Z-ce-Ue,data:K.subarray(ce,ee-Ue)}],q.resultId)}o(M,q){if(X.j(M)){const H=this.e++;return this.d.set(H,new Re(M.resultId,M.data)),(0,t.$i0)({id:H,type:"full",data:M.data})}if(X.l(M)){const H=this.e++;return X.j(q)?this.d.set(H,new Re(q.resultId,q.data)):this.d.set(H,new Re(M.resultId)),(0,t.$i0)({id:H,type:"delta",deltas:(M.edits||[]).map(Z=>({start:Z.start,deleteCount:Z.deleteCount,data:Z.data}))})}return null}}class le{constructor(M,q){this.d=M,this.e=q}async provideDocumentRangeSemanticTokens(M,q,H){const Z=this.d.getDocument(M),K=await this.e.provideDocumentRangeSemanticTokens(Z,C.Range.to(q),H);return K?this.f(K):null}f(M){return(0,t.$i0)({id:0,type:"full",data:M.data})}}class we{static supportsResolving(M){return typeof M.resolveCompletionItem=="function"}constructor(M,q,H,Z,K){this.f=M,this.g=q,this.h=H,this.j=Z,this.k=K,this.d=new c.$tac("CompletionItem"),this.e=new Map}async provideCompletionItems(M,q,H,Z){const K=this.f.getDocument(M),ee=C.Position.to(q),ce=K.getWordRangeAtPosition(ee)||new L.$WJ(ee,ee),ze=ce.with({end:ee}),Ue=new m.$dc,Ze=await this.h.provideCompletionItems(K,ee,Z,C.CompletionContext.to(H));if(!Ze||Z.isCancellationRequested)return;const He=Array.isArray(Ze)?new L.$qK(Ze):Ze,et=we.supportsResolving(this.h)?this.d.add(He.items):this.d.add([]),Ye=new d.$lb;this.e.set(et,Ye);const _e=[],it={x:et,b:_e,a:{replace:C.Range.from(ce),insert:C.Range.from(ze)},c:He.isIncomplete||void 0,d:Ue.elapsed()};for(let tt=0;tt<He.items.length;tt++){const Ne=He.items[tt],st=this.l(Ne,[et,tt],ze,ce);_e.push(st)}return it}async resolveCompletionItem(M,q){if(typeof this.h.resolveCompletionItem!="function")return;const H=this.d.get(...M);if(!H)return;const Z=this.l(H,M),K=await this.h.resolveCompletionItem(H,q);if(!K)return;const ee=this.l(K,M);return(Z.h!==ee.h||Z.i!==ee.i)&&this.j.report("CompletionItem.insertText",this.k,"extension MAY NOT change 'insertText' of a CompletionItem during resolve"),(Z.n!==ee.n||Z.o!==ee.o||!(0,R.$Xm)(Z.p,ee.p))&&this.j.report("CompletionItem.command",this.k,"extension MAY NOT change 'command' of a CompletionItem during resolve"),{...Z,d:ee.d,c:ee.c,l:ee.l,h:ee.h,i:ee.i,n:ee.n,o:ee.o,p:ee.p}}releaseCompletionItems(M){this.e.get(M)?.dispose(),this.e.delete(M),this.d.delete(M)}l(M,q,H,Z){const K=this.e.get(q[0]);if(!K)throw Error("DisposableStore is missing...");const ee=this.g.toInternal(M.command,K),ce={x:q,a:M.label,b:M.kind!==void 0?C.CompletionItemKind.from(M.kind):void 0,m:M.tags&&M.tags.map(C.CompletionItemTag.from),c:M.detail,d:typeof M.documentation>"u"?void 0:C.MarkdownString.fromStrict(M.documentation),e:M.sortText!==M.label?M.sortText:void 0,f:M.filterText!==M.label?M.filterText:void 0,g:M.preselect||void 0,i:M.keepWhitespace?1:0,k:M.commitCharacters?.join(""),l:M.additionalTextEdits&&M.additionalTextEdits.map(C.TextEdit.from),n:ee?.$ident,o:ee?.id,p:ee?.$ident?void 0:ee?.arguments};M.textEdit?(this.j.report("CompletionItem.textEdit",this.k,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),ce.h=M.textEdit.newText):typeof M.insertText=="string"?ce.h=M.insertText:M.insertText instanceof L.$6J&&(ce.h=M.insertText.value,ce.i|=4);let ze;return M.textEdit?ze=M.textEdit.range:M.range&&(ze=M.range),L.$WJ.isRange(ze)?ce.j=C.Range.from(ze):ze&&(!H?.isEqual(ze.inserting)||!Z?.isEqual(ze.replacing))&&(ce.j={insert:C.Range.from(ze.inserting),replace:C.Range.from(ze.replacing)}),ce}}class ae{async provideInlineCompletions(M,q,H,Z){}disposeCompletions(M){}handleDidShowCompletionItem(M,q,H){}handlePartialAccept(M,q,H){}}class x extends ae{constructor(M,q,H,Z){super(),this.f=M,this.g=q,this.h=H,this.j=Z,this.d=new ue,this.e=(0,n.$LF)(this.f,"inlineCompletionsAdditions"),this.k={[A.InlineCompletionTriggerKind.Automatic]:L.InlineCompletionTriggerKind.Automatic,[A.InlineCompletionTriggerKind.Explicit]:L.InlineCompletionTriggerKind.Invoke}}get supportsHandleEvents(){return(0,n.$LF)(this.f,"inlineCompletionsAdditions")&&(typeof this.h.handleDidShowCompletionItem=="function"||typeof this.h.handleDidPartiallyAcceptCompletionItem=="function")}async provideInlineCompletions(M,q,H,Z){const K=this.g.getDocument(M),ee=C.Position.to(q),ce=await this.h.provideInlineCompletionItems(K,ee,{selectedCompletionInfo:H.selectedSuggestionInfo?{range:C.Range.to(H.selectedSuggestionInfo.range),text:H.selectedSuggestionInfo.text}:void 0,triggerKind:this.k[H.triggerKind]},Z);if(!ce||Z.isCancellationRequested)return;const ze=Array.isArray(ce)?ce:ce.items,Ue=this.e?Array.isArray(ce)?[]:ce.commands||[]:[],Ze=this.e&&!Array.isArray(ce)?ce.enableForwardStability:void 0;let He;return{pid:this.d.createReferenceId({dispose(){He?.dispose()},items:ze}),items:ze.map((Ye,_e)=>{let it;Ye.command&&(He||(He=new d.$lb),it=this.j.toInternal(Ye.command,He));const tt=Ye.insertText;return{insertText:typeof tt=="string"?tt:{snippet:tt.value},filterText:Ye.filterText,range:Ye.range?C.Range.from(Ye.range):void 0,command:it,idx:_e,completeBracketPairs:this.e?Ye.completeBracketPairs:!1}}),commands:Ue.map(Ye=>(He||(He=new d.$lb),this.j.toInternal(Ye,He))),suppressSuggestions:!1,enableForwardStability:Ze}}disposeCompletions(M){this.d.disposeReferenceId(M)?.dispose()}handleDidShowCompletionItem(M,q,H){const Z=this.d.get(M)?.items[q];Z&&this.h.handleDidShowCompletionItem&&this.e&&this.h.handleDidShowCompletionItem(Z,H)}handlePartialAccept(M,q,H){const Z=this.d.get(M)?.items[q];Z&&this.h.handleDidPartiallyAcceptCompletionItem&&this.e&&this.h.handleDidPartiallyAcceptCompletionItem(Z,H)}}class ue{constructor(){this.d=new Map,this.e=1}createReferenceId(M){const q=this.e++;return this.d.set(q,M),q}disposeReferenceId(M){const q=this.d.get(M);return this.d.delete(M),q}get(M){return this.d.get(M)}}class O{constructor(M,q){this.e=M,this.f=q,this.d=new c.$tac("SignatureHelp")}async provideSignatureHelp(M,q,H,Z){const K=this.e.getDocument(M),ee=C.Position.to(q),ce=this.g(H),ze=await this.f.provideSignatureHelp(K,ee,Z,ce);if(ze){const Ue=this.d.add([ze]);return{...C.SignatureHelp.from(ze),id:Ue}}}g(M){let q;if(M.activeSignatureHelp){const H=C.SignatureHelp.to(M.activeSignatureHelp),Z=this.d.get(M.activeSignatureHelp.id,0);Z?(q=Z,q.activeSignature=H.activeSignature,q.activeParameter=H.activeParameter):q=H}return{...M,activeSignatureHelp:q}}releaseSignatureHelp(M){this.d.delete(M)}}class J{constructor(M,q,H,Z,K){this.f=M,this.g=q,this.h=H,this.j=Z,this.k=K,this.d=new c.$tac("InlayHints"),this.e=new Map}async provideInlayHints(M,q,H){const Z=this.f.getDocument(M),K=C.Range.to(q),ee=await this.h.provideInlayHints(Z,K,H);if(!Array.isArray(ee)||ee.length===0){this.j.trace(`[InlayHints] NO inlay hints from '${this.k.identifier.value}' for ${q}`);return}if(H.isCancellationRequested)return;const ce=this.d.add(ee);this.e.set(ce,new d.$lb);const ze={hints:[],cacheId:ce};for(let Ue=0;Ue<ee.length;Ue++)this.l(ee[Ue],K)&&ze.hints.push(this.m(ee[Ue],[ce,Ue]));return this.j.trace(`[InlayHints] ${ze.hints.length} inlay hints from '${this.k.identifier.value}' for ${q}`),ze}async resolveInlayHint(M,q){if(typeof this.h.resolveInlayHint!="function")return;const H=this.d.get(...M);if(!H)return;const Z=await this.h.resolveInlayHint(H,q);if(Z&&this.l(Z))return this.m(Z,M)}releaseHints(M){this.e.get(M)?.dispose(),this.e.delete(M),this.d.delete(M)}l(M,q){return M.label.length===0||Array.isArray(M.label)&&M.label.every(H=>H.value.length===0)?(console.log("INVALID inlay hint, empty label",M),!1):!(q&&!q.contains(M.position))}m(M,q){const H=this.e.get(q[0]);if(!H)throw Error("DisposableStore is missing...");const Z={label:"",cacheId:q,tooltip:C.MarkdownString.fromStrict(M.tooltip),position:C.Position.from(M.position),textEdits:M.textEdits&&M.textEdits.map(C.TextEdit.from),kind:M.kind&&C.InlayHintKind.from(M.kind),paddingLeft:M.paddingLeft,paddingRight:M.paddingRight};return typeof M.label=="string"?Z.label=M.label:Z.label=M.label.map(K=>{const ee={label:K.value};return ee.tooltip=C.MarkdownString.fromStrict(K.tooltip),L.$7J.isLocation(K.location)&&(ee.location=C.location.from(K.location)),K.command&&(ee.command=this.g.toInternal(K.command,H)),ee}),Z}}class he{constructor(M,q){this.e=M,this.f=q,this.d=new c.$tac("DocumentLink")}async provideLinks(M,q){const H=this.e.getDocument(M),Z=await this.f.provideDocumentLinks(H,q);if(!(!Array.isArray(Z)||Z.length===0)&&!q.isCancellationRequested){if(typeof this.f.resolveDocumentLink!="function")return{links:Z.filter(he.g).map(C.DocumentLink.from)};{const K=this.d.add(Z),ee={links:[],cacheId:K};for(let ce=0;ce<Z.length;ce++){if(!he.g(Z[ce]))continue;const ze=C.DocumentLink.from(Z[ce]);ze.cacheId=[K,ce],ee.links.push(ze)}return ee}}}static g(M){return M.target&&M.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(M,q){if(typeof this.f.resolveDocumentLink!="function")return;const H=this.d.get(...M);if(!H)return;const Z=await this.f.resolveDocumentLink(H,q);if(!(!Z||!he.g(Z)))return C.DocumentLink.from(Z)}releaseLinks(M){this.d.delete(M)}}class Ee{constructor(M,q){this.d=M,this.e=q}async provideColors(M,q){const H=this.d.getDocument(M),Z=await this.e.provideDocumentColors(H,q);return Array.isArray(Z)?Z.map(ee=>({color:C.Color.from(ee.color),range:C.Range.from(ee.range)})):[]}async provideColorPresentations(M,q,H){const Z=this.d.getDocument(M),K=C.Range.to(q.range),ee=C.Color.to(q.color),ce=await this.e.provideColorPresentations(ee,{document:Z,range:K},H);if(Array.isArray(ce))return ce.map(C.ColorPresentation.from)}}class ve{constructor(M,q){this.d=M,this.e=q}async provideFoldingRanges(M,q,H){const Z=this.d.getDocument(M),K=await this.e.provideFoldingRanges(Z,q,H);if(Array.isArray(K))return K.map(C.FoldingRange.from)}}class be{constructor(M,q,H){this.d=M,this.e=q,this.f=H}async provideSelectionRanges(M,q,H){const Z=this.d.getDocument(M),K=q.map(C.Position.to),ee=await this.e.provideSelectionRanges(Z,K,H);if(!(0,P.$Ef)(ee))return[];if(ee.length!==K.length)return this.f.warn("BAD selection ranges, provider must return ranges for each position"),[];const ce=[];for(let ze=0;ze<K.length;ze++){const Ue=[];ce.push(Ue);let Ze=K[ze],He=ee[ze];for(;;){if(!He.range.contains(Ze))throw new Error("INVALID selection range, must contain the previous range");if(Ue.push(C.SelectionRange.from(He)),!He.parent)break;Ze=He.range,He=He.parent}}return ce}}class De{constructor(M,q){this.f=M,this.g=q,this.d=new i.$ZL(""),this.e=new Map}async prepareSession(M,q,H){const Z=this.f.getDocument(M),K=C.Position.to(q),ee=await this.g.prepareCallHierarchy(Z,K,H);if(!ee)return;const ce=this.d.nextId();return this.e.set(ce,new Map),Array.isArray(ee)?ee.map(ze=>this.h(ce,ze)):[this.h(ce,ee)]}async provideCallsTo(M,q,H){const Z=this.j(M,q);if(!Z)throw new Error("missing call hierarchy item");const K=await this.g.provideCallHierarchyIncomingCalls(Z,H);if(K)return K.map(ee=>({from:this.h(M,ee.from),fromRanges:ee.fromRanges.map(ce=>C.Range.from(ce))}))}async provideCallsFrom(M,q,H){const Z=this.j(M,q);if(!Z)throw new Error("missing call hierarchy item");const K=await this.g.provideCallHierarchyOutgoingCalls(Z,H);if(K)return K.map(ee=>({to:this.h(M,ee.to),fromRanges:ee.fromRanges.map(ce=>C.Range.from(ce))}))}releaseSession(M){this.e.delete(M)}h(M,q){const H=this.e.get(M),Z=C.CallHierarchyItem.from(q,M,H.size.toString(36));return H.set(Z._itemId,q),Z}j(M,q){return this.e.get(M)?.get(q)}}class oe{constructor(M,q){this.f=M,this.g=q,this.d=new i.$ZL(""),this.e=new Map}async prepareSession(M,q,H){const Z=this.f.getDocument(M),K=C.Position.to(q),ee=await this.g.prepareTypeHierarchy(Z,K,H);if(!ee)return;const ce=this.d.nextId();return this.e.set(ce,new Map),Array.isArray(ee)?ee.map(ze=>this.h(ce,ze)):[this.h(ce,ee)]}async provideSupertypes(M,q,H){const Z=this.j(M,q);if(!Z)throw new Error("missing type hierarchy item");const K=await this.g.provideTypeHierarchySupertypes(Z,H);if(K)return K.map(ee=>this.h(M,ee))}async provideSubtypes(M,q,H){const Z=this.j(M,q);if(!Z)throw new Error("missing type hierarchy item");const K=await this.g.provideTypeHierarchySubtypes(Z,H);if(K)return K.map(ee=>this.h(M,ee))}releaseSession(M){this.e.delete(M)}h(M,q){const H=this.e.get(M),Z=C.TypeHierarchyItem.from(q,M,H.size.toString(36));return H.set(Z._itemId,q),Z}j(M,q){return this.e.get(M)?.get(q)}}class de{static toInternalProviderId(M,q){return M+"."+q}constructor(M,q,H,Z,K){this.d=M,this.e=q,this.f=H,this.g=Z,this.h=K}async provideDocumentOnDropEdits(M,q,H,Z,K){const ee=this.e.getDocument(q),ce=C.Position.to(H),ze=C.DataTransfer.toDataTransfer(Z,async Ze=>(await this.d.$resolveDocumentOnDropFileData(this.g,M,Ze)).buffer),Ue=await this.f.provideDocumentDropEdits(ee,ce,ze,K);if(Ue)return{label:Ue.label??(0,a.localize)(1,null,this.h.displayName||this.h.name),yieldTo:Ue.yieldTo?.map(Ze=>"mimeType"in Ze?Ze:{providerId:de.toInternalProviderId(Ze.extensionId,Ze.providerId)}),insertText:typeof Ue.insertText=="string"?Ue.insertText:{snippet:Ue.insertText.value},additionalEdit:Ue.additionalEdit?C.WorkspaceEdit.from(Ue.additionalEdit,void 0):void 0}}}class se{constructor(M,q){this.d=M,this.e=q}async provideMappedEdits(M,q,H,Z){const K=y.URI.revive(M),ee=this.d.getDocument(K),ce={selections:H.selections.map(Ue=>C.Selection.to(Ue)),related:H.related.map(Ue=>({uri:y.URI.revive(Ue.uri),range:C.Range.to(Ue.range)}))},ze=await this.e.provideMappedEdits(ee,q,ce,Z);return ze?C.WorkspaceEdit.from(ze):null}}class ne{constructor(M,q){this.adapter=M,this.extension=q}}class me{static{this.d=0}constructor(M,q,H,Z,K,ee,ce,ze){this.g=q,this.h=H,this.j=Z,this.k=K,this.l=ee,this.m=ce,this.n=ze,this.f=new Map,this.e=M.getProxy(h.$SJ.MainThreadLanguageFeatures)}o(M,q){return C.DocumentSelector.from(M,this.g,q)}p(M){return new L.$UJ(()=>{this.f.delete(M),this.e.$unregister(M)})}q(){return me.d++}async t(M,q,H,Z,K,ee=!1){const ce=this.f.get(M);if(!ce||!(ce.adapter instanceof q))return Z;const ze=Date.now();ee||this.l.trace(`[${ce.extension.identifier.value}] INVOKE provider '${H.toString().replace(/[\r\n]/g,"")}'`);const Ue=H(ce.adapter,ce.extension);return Promise.resolve(Ue).catch(Ze=>{(0,E.$2)(Ze)||(this.l.error(`[${ce.extension.identifier.value}] provider FAILED`),this.l.error(Ze),this.n.onExtensionError(ce.extension.identifier,Ze))}).finally(()=>{ee||this.l.trace(`[${ce.extension.identifier.value}] provider DONE after ${Date.now()-ze}ms`)}),p.CancellationToken.isCancellationToken(K)?(0,b.$ug)(Ue,K):Ue}u(M,q){const H=this.q();return this.f.set(H,new ne(M,q)),H}static w(M){return M.displayName||M.name}registerDocumentSymbolProvider(M,q,H,Z){const K=this.u(new s(this.h,H),M),ee=Z&&Z.label||me.w(M);return this.e.$registerDocumentSymbolProvider(K,this.o(q,M),ee),this.p(K)}$provideDocumentSymbols(M,q,H){return this.t(M,s,Z=>Z.provideDocumentSymbols(y.URI.revive(q),H),void 0,H)}registerCodeLensProvider(M,q,H){const Z=this.q(),K=typeof H.onDidChangeCodeLenses=="function"?this.q():void 0;this.f.set(Z,new ne(new o(this.h,this.j.converter,H),M)),this.e.$registerCodeLensSupport(Z,this.o(q,M),K);let ee=this.p(Z);if(K!==void 0){const ce=H.onDidChangeCodeLenses(ze=>this.e.$emitCodeLensEvent(K));ee=L.$UJ.from(ee,ce)}return ee}$provideCodeLenses(M,q,H){return this.t(M,o,Z=>Z.provideCodeLenses(y.URI.revive(q),H),void 0,H)}$resolveCodeLens(M,q,H){return this.t(M,o,Z=>Z.resolveCodeLens(q,H),void 0,void 0)}$releaseCodeLenses(M,q){this.t(M,o,H=>Promise.resolve(H.releaseCodeLenses(q)),void 0,void 0)}registerDefinitionProvider(M,q,H){const Z=this.u(new v(this.h,H),M);return this.e.$registerDefinitionSupport(Z,this.o(q,M)),this.p(Z)}$provideDefinition(M,q,H,Z){return this.t(M,v,K=>K.provideDefinition(y.URI.revive(q),H,Z),[],Z)}registerDeclarationProvider(M,q,H){const Z=this.u(new I(this.h,H),M);return this.e.$registerDeclarationSupport(Z,this.o(q,M)),this.p(Z)}$provideDeclaration(M,q,H,Z){return this.t(M,I,K=>K.provideDeclaration(y.URI.revive(q),H,Z),[],Z)}registerImplementationProvider(M,q,H){const Z=this.u(new k(this.h,H),M);return this.e.$registerImplementationSupport(Z,this.o(q,M)),this.p(Z)}$provideImplementation(M,q,H,Z){return this.t(M,k,K=>K.provideImplementation(y.URI.revive(q),H,Z),[],Z)}registerTypeDefinitionProvider(M,q,H){const Z=this.u(new r(this.h,H),M);return this.e.$registerTypeDefinitionSupport(Z,this.o(q,M)),this.p(Z)}$provideTypeDefinition(M,q,H,Z){return this.t(M,r,K=>K.provideTypeDefinition(y.URI.revive(q),H,Z),[],Z)}registerHoverProvider(M,q,H,Z){const K=this.u(new l(this.h,H),M);return this.e.$registerHoverProvider(K,this.o(q,M)),this.p(K)}$provideHover(M,q,H,Z){return this.t(M,l,K=>K.provideHover(y.URI.revive(q),H,Z),void 0,Z)}registerEvaluatableExpressionProvider(M,q,H,Z){const K=this.u(new f(this.h,H),M);return this.e.$registerEvaluatableExpressionProvider(K,this.o(q,M)),this.p(K)}$provideEvaluatableExpression(M,q,H,Z){return this.t(M,f,K=>K.provideEvaluatableExpression(y.URI.revive(q),H,Z),void 0,Z)}registerInlineValuesProvider(M,q,H,Z){const K=typeof H.onDidChangeInlineValues=="function"?this.q():void 0,ee=this.u(new F(this.h,H),M);this.e.$registerInlineValuesProvider(ee,this.o(q,M),K);let ce=this.p(ee);if(K!==void 0){const ze=H.onDidChangeInlineValues(Ue=>this.e.$emitInlineValuesEvent(K));ce=L.$UJ.from(ce,ze)}return ce}$provideInlineValues(M,q,H,Z,K){return this.t(M,F,ee=>ee.provideInlineValues(y.URI.revive(q),H,Z,K),void 0,K)}registerDocumentHighlightProvider(M,q,H){const Z=this.u(new W(this.h,H),M);return this.e.$registerDocumentHighlightProvider(Z,this.o(q,M)),this.p(Z)}$provideDocumentHighlights(M,q,H,Z){return this.t(M,W,K=>K.provideDocumentHighlights(y.URI.revive(q),H,Z),void 0,Z)}registerLinkedEditingRangeProvider(M,q,H){const Z=this.u(new V(this.h,H),M);return this.e.$registerLinkedEditingRangeProvider(Z,this.o(q,M)),this.p(Z)}$provideLinkedEditingRanges(M,q,H,Z){return this.t(M,V,async K=>{const ee=await K.provideLinkedEditingRanges(y.URI.revive(q),H,Z);if(ee)return{ranges:ee.ranges,wordPattern:ee.wordPattern?me.y(ee.wordPattern):void 0}},void 0,Z)}registerReferenceProvider(M,q,H){const Z=this.u(new B(this.h,H),M);return this.e.$registerReferenceSupport(Z,this.o(q,M)),this.p(Z)}$provideReferences(M,q,H,Z,K){return this.t(M,B,ee=>ee.provideReferences(y.URI.revive(q),H,Z,K),void 0,K)}registerCodeActionProvider(M,q,H,Z){const K=new d.$lb,ee=this.u(new j(this.h,this.j.converter,this.k,H,this.l,M,this.m),M);return this.e.$registerQuickFixSupport(ee,this.o(q,M),{providedKinds:Z?.providedCodeActionKinds?.map(ce=>ce.value),documentation:Z?.documentation?.map(ce=>({kind:ce.kind.value,command:this.j.converter.toInternal(ce.command,K)}))},me.w(M),!!H.resolveCodeAction),K.add(this.p(ee)),K}$provideCodeActions(M,q,H,Z,K){return this.t(M,j,ee=>ee.provideCodeActions(y.URI.revive(q),H,Z,K),void 0,K)}$resolveCodeAction(M,q,H){return this.t(M,j,Z=>Z.resolveCodeAction(q,H),{},void 0)}$releaseCodeActions(M,q){this.t(M,j,H=>Promise.resolve(H.releaseCodeActions(q)),void 0,void 0)}registerDocumentFormattingEditProvider(M,q,H){const Z=this.u(new z(this.h,H),M);return this.e.$registerDocumentFormattingSupport(Z,this.o(q,M),M.identifier,M.displayName||M.name),this.p(Z)}$provideDocumentFormattingEdits(M,q,H,Z){return this.t(M,z,K=>K.provideDocumentFormattingEdits(y.URI.revive(q),H,Z),void 0,Z)}registerDocumentRangeFormattingEditProvider(M,q,H){const Z=typeof H.provideDocumentRangesFormattingEdits=="function",K=this.u(new ie(this.h,H),M);return this.e.$registerRangeFormattingSupport(K,this.o(q,M),M.identifier,M.displayName||M.name,Z),this.p(K)}$provideDocumentRangeFormattingEdits(M,q,H,Z,K){return this.t(M,ie,ee=>ee.provideDocumentRangeFormattingEdits(y.URI.revive(q),H,Z,K),void 0,K)}$provideDocumentRangesFormattingEdits(M,q,H,Z,K){return this.t(M,ie,ee=>ee.provideDocumentRangesFormattingEdits(y.URI.revive(q),H,Z,K),void 0,K)}registerOnTypeFormattingEditProvider(M,q,H,Z){const K=this.u(new Y(this.h,H),M);return this.e.$registerOnTypeFormattingSupport(K,this.o(q,M),Z,M.identifier),this.p(K)}$provideOnTypeFormattingEdits(M,q,H,Z,K,ee){return this.t(M,Y,ce=>ce.provideOnTypeFormattingEdits(y.URI.revive(q),H,Z,K,ee),void 0,ee)}registerWorkspaceSymbolProvider(M,q){const H=this.u(new ye(q,this.l),M);return this.e.$registerNavigateTypeSupport(H,typeof q.resolveWorkspaceSymbol=="function"),this.p(H)}$provideWorkspaceSymbols(M,q,H){return this.t(M,ye,Z=>Z.provideWorkspaceSymbols(q,H),{symbols:[]},H)}$resolveWorkspaceSymbol(M,q,H){return this.t(M,ye,Z=>Z.resolveWorkspaceSymbol(q,H),void 0,void 0)}$releaseWorkspaceSymbols(M,q){this.t(M,ye,H=>H.releaseWorkspaceSymbols(q),void 0,void 0)}registerRenameProvider(M,q,H){const Z=this.u(new ke(this.h,H,this.l),M);return this.e.$registerRenameSupport(Z,this.o(q,M),ke.supportsResolving(H)),this.p(Z)}$provideRenameEdits(M,q,H,Z,K){return this.t(M,ke,ee=>ee.provideRenameEdits(y.URI.revive(q),H,Z,K),void 0,K)}$resolveRenameLocation(M,q,H,Z){return this.t(M,ke,K=>K.resolveRenameLocation(y.URI.revive(q),H,Z),void 0,Z)}registerDocumentSemanticTokensProvider(M,q,H,Z){const K=this.u(new X(this.h,H),M),ee=typeof H.onDidChangeSemanticTokens=="function"?this.q():void 0;this.e.$registerDocumentSemanticTokensProvider(K,this.o(q,M),Z,ee);let ce=this.p(K);if(ee){const ze=H.onDidChangeSemanticTokens(Ue=>this.e.$emitDocumentSemanticTokensEvent(ee));ce=L.$UJ.from(ce,ze)}return ce}$provideDocumentSemanticTokens(M,q,H,Z){return this.t(M,X,K=>K.provideDocumentSemanticTokens(y.URI.revive(q),H,Z),null,Z)}$releaseDocumentSemanticTokens(M,q){this.t(M,X,H=>H.releaseDocumentSemanticColoring(q),void 0,void 0)}registerDocumentRangeSemanticTokensProvider(M,q,H,Z){const K=this.u(new le(this.h,H),M);return this.e.$registerDocumentRangeSemanticTokensProvider(K,this.o(q,M),Z),this.p(K)}$provideDocumentRangeSemanticTokens(M,q,H,Z){return this.t(M,le,K=>K.provideDocumentRangeSemanticTokens(y.URI.revive(q),H,Z),null,Z)}registerCompletionItemProvider(M,q,H,Z){const K=this.u(new we(this.h,this.j.converter,H,this.m,M),M);return this.e.$registerCompletionsProvider(K,this.o(q,M),Z,we.supportsResolving(H),M.identifier),this.p(K)}$provideCompletionItems(M,q,H,Z,K){return this.t(M,we,ee=>ee.provideCompletionItems(y.URI.revive(q),H,Z,K),void 0,K)}$resolveCompletionItem(M,q,H){return this.t(M,we,Z=>Z.resolveCompletionItem(q,H),void 0,H)}$releaseCompletionItems(M,q){this.t(M,we,H=>H.releaseCompletionItems(q),void 0,void 0)}registerInlineCompletionsProvider(M,q,H,Z){const K=new x(M,this.h,H,this.j.converter),ee=this.u(K,M);return this.e.$registerInlineCompletionsSupport(ee,this.o(q,M),K.supportsHandleEvents,$.$Tl.toKey(M.identifier.value),Z?.yieldTo?.map(ce=>$.$Tl.toKey(ce))||[]),this.p(ee)}$provideInlineCompletions(M,q,H,Z,K){return this.t(M,ae,ee=>ee.provideInlineCompletions(y.URI.revive(q),H,Z,K),void 0,K)}$handleInlineCompletionDidShow(M,q,H,Z){this.t(M,ae,async K=>{K.handleDidShowCompletionItem(q,H,Z)},void 0,void 0)}$handleInlineCompletionPartialAccept(M,q,H,Z){this.t(M,ae,async K=>{K.handlePartialAccept(q,H,Z)},void 0,void 0)}$freeInlineCompletionsList(M,q){this.t(M,ae,async H=>{H.disposeCompletions(q)},void 0,void 0)}registerSignatureHelpProvider(M,q,H,Z){const K=Array.isArray(Z)?{triggerCharacters:Z,retriggerCharacters:[]}:Z,ee=this.u(new O(this.h,H),M);return this.e.$registerSignatureHelpProvider(ee,this.o(q,M),K),this.p(ee)}$provideSignatureHelp(M,q,H,Z,K){return this.t(M,O,ee=>ee.provideSignatureHelp(y.URI.revive(q),H,Z,K),void 0,K)}$releaseSignatureHelp(M,q){this.t(M,O,H=>H.releaseSignatureHelp(q),void 0,void 0)}registerInlayHintsProvider(M,q,H){const Z=typeof H.onDidChangeInlayHints=="function"?this.q():void 0,K=this.u(new J(this.h,this.j.converter,H,this.l,M),M);this.e.$registerInlayHintsProvider(K,this.o(q,M),typeof H.resolveInlayHint=="function",Z,me.w(M));let ee=this.p(K);if(Z!==void 0){const ce=H.onDidChangeInlayHints(ze=>this.e.$emitInlayHintsEvent(Z));ee=L.$UJ.from(ee,ce)}return ee}$provideInlayHints(M,q,H,Z){return this.t(M,J,K=>K.provideInlayHints(y.URI.revive(q),H,Z),void 0,Z)}$resolveInlayHint(M,q,H){return this.t(M,J,Z=>Z.resolveInlayHint(q,H),void 0,H)}$releaseInlayHints(M,q){this.t(M,J,H=>H.releaseHints(q),void 0,void 0)}registerDocumentLinkProvider(M,q,H){const Z=this.u(new he(this.h,H),M);return this.e.$registerDocumentLinkProvider(Z,this.o(q,M),typeof H.resolveDocumentLink=="function"),this.p(Z)}$provideDocumentLinks(M,q,H){return this.t(M,he,Z=>Z.provideLinks(y.URI.revive(q),H),void 0,H,q.scheme==="output")}$resolveDocumentLink(M,q,H){return this.t(M,he,Z=>Z.resolveLink(q,H),void 0,void 0,!0)}$releaseDocumentLinks(M,q){this.t(M,he,H=>H.releaseLinks(q),void 0,void 0,!0)}registerColorProvider(M,q,H){const Z=this.u(new Ee(this.h,H),M);return this.e.$registerDocumentColorProvider(Z,this.o(q,M)),this.p(Z)}$provideDocumentColors(M,q,H){return this.t(M,Ee,Z=>Z.provideColors(y.URI.revive(q),H),[],H)}$provideColorPresentations(M,q,H,Z){return this.t(M,Ee,K=>K.provideColorPresentations(y.URI.revive(q),H,Z),void 0,Z)}registerFoldingRangeProvider(M,q,H){const Z=this.q(),K=typeof H.onDidChangeFoldingRanges=="function"?this.q():void 0;this.f.set(Z,new ne(new ve(this.h,H),M)),this.e.$registerFoldingRangeProvider(Z,this.o(q,M),M.identifier,K);let ee=this.p(Z);if(K!==void 0){const ce=H.onDidChangeFoldingRanges(()=>this.e.$emitFoldingRangeEvent(K));ee=L.$UJ.from(ee,ce)}return ee}$provideFoldingRanges(M,q,H,Z){return this.t(M,ve,K=>K.provideFoldingRanges(y.URI.revive(q),H,Z),void 0,Z)}registerSelectionRangeProvider(M,q,H){const Z=this.u(new be(this.h,H,this.l),M);return this.e.$registerSelectionRangeProvider(Z,this.o(q,M)),this.p(Z)}$provideSelectionRanges(M,q,H,Z){return this.t(M,be,K=>K.provideSelectionRanges(y.URI.revive(q),H,Z),[],Z)}registerCallHierarchyProvider(M,q,H){const Z=this.u(new De(this.h,H),M);return this.e.$registerCallHierarchyProvider(Z,this.o(q,M)),this.p(Z)}$prepareCallHierarchy(M,q,H,Z){return this.t(M,De,K=>Promise.resolve(K.prepareSession(y.URI.revive(q),H,Z)),void 0,Z)}$provideCallHierarchyIncomingCalls(M,q,H,Z){return this.t(M,De,K=>K.provideCallsTo(q,H,Z),void 0,Z)}$provideCallHierarchyOutgoingCalls(M,q,H,Z){return this.t(M,De,K=>K.provideCallsFrom(q,H,Z),void 0,Z)}$releaseCallHierarchy(M,q){this.t(M,De,H=>Promise.resolve(H.releaseSession(q)),void 0,void 0)}registerTypeHierarchyProvider(M,q,H){const Z=this.u(new oe(this.h,H),M);return this.e.$registerTypeHierarchyProvider(Z,this.o(q,M)),this.p(Z)}$prepareTypeHierarchy(M,q,H,Z){return this.t(M,oe,K=>Promise.resolve(K.prepareSession(y.URI.revive(q),H,Z)),void 0,Z)}$provideTypeHierarchySupertypes(M,q,H,Z){return this.t(M,oe,K=>K.provideSupertypes(q,H,Z),void 0,Z)}$provideTypeHierarchySubtypes(M,q,H,Z){return this.t(M,oe,K=>K.provideSubtypes(q,H,Z),void 0,Z)}$releaseTypeHierarchy(M,q){this.t(M,oe,H=>Promise.resolve(H.releaseSession(q)),void 0,void 0)}registerDocumentOnDropEditProvider(M,q,H,Z){const K=this.q();this.f.set(K,new ne(new de(this.e,this.h,H,K,M),M));const ee=(0,n.$LF)(M,"dropMetadata")&&Z?de.toInternalProviderId(M.identifier.value,Z.id):void 0;return this.e.$registerDocumentOnDropEditProvider(K,this.o(q,M),ee,(0,n.$LF)(M,"dropMetadata")?Z:void 0),this.p(K)}$provideDocumentOnDropEdits(M,q,H,Z,K,ee){return this.t(M,de,ce=>Promise.resolve(ce.provideDocumentOnDropEdits(q,y.URI.revive(H),Z,K,ee)),void 0,void 0)}registerMappedEditsProvider(M,q,H){const Z=this.u(new se(this.h,H),M);return this.e.$registerMappedEditsProvider(Z,this.o(q,M)),this.p(Z)}$provideMappedEdits(M,q,H,Z,K){return this.t(M,se,ee=>Promise.resolve(ee.provideMappedEdits(q,H,Z,K)),null,K)}registerDocumentPasteEditProvider(M,q,H,Z){const K=this.q();this.f.set(K,new ne(new U(this.e,this.h,H,K,M),M));const ee=U.toInternalProviderId(M.identifier.value,Z.id);return this.e.$registerPasteEditProvider(K,this.o(q,M),ee,{supportsCopy:!!H.prepareDocumentPaste,supportsPaste:!!H.provideDocumentPasteEdits,copyMimeTypes:Z.copyMimeTypes,pasteMimeTypes:Z.pasteMimeTypes}),this.p(K)}$prepareDocumentPaste(M,q,H,Z,K){return this.t(M,U,ee=>ee.prepareDocumentPaste(y.URI.revive(q),H,Z,K),void 0,K)}$providePasteEdits(M,q,H,Z,K,ee){return this.t(M,U,ce=>ce.providePasteEdits(q,y.URI.revive(H),Z,K,ee),void 0,ee)}static y(M){return{pattern:M.source,flags:M.flags}}static z(M){return{decreaseIndentPattern:me.y(M.decreaseIndentPattern),increaseIndentPattern:me.y(M.increaseIndentPattern),indentNextLinePattern:M.indentNextLinePattern?me.y(M.indentNextLinePattern):void 0,unIndentedLinePattern:M.unIndentedLinePattern?me.y(M.unIndentedLinePattern):void 0}}static B(M){return{beforeText:me.y(M.beforeText),afterText:M.afterText?me.y(M.afterText):void 0,previousLineText:M.previousLineText?me.y(M.previousLineText):void 0,action:M.action}}static C(M){return M.map(me.B)}setLanguageConfiguration(M,q,H){const{wordPattern:Z}=H;if(Z&&(0,S.$Bd)(Z))throw new Error(`Invalid language configuration: wordPattern '${Z}' is not allowed to match the empty string.`);Z?this.h.setWordDefinitionFor(q,Z):this.h.setWordDefinitionFor(q,void 0),H.__electricCharacterSupport&&this.m.report("LanguageConfiguration.__electricCharacterSupport",M,"Do not use."),H.__characterPairSupport&&this.m.report("LanguageConfiguration.__characterPairSupport",M,"Do not use."),H.autoClosingPairs&&(0,n.$MF)(M,"languageConfigurationAutoClosingPairs");const K=this.q(),ee={comments:H.comments,brackets:H.brackets,wordPattern:H.wordPattern?me.y(H.wordPattern):void 0,indentationRules:H.indentationRules?me.z(H.indentationRules):void 0,onEnterRules:H.onEnterRules?me.C(H.onEnterRules):void 0,__electricCharacterSupport:H.__electricCharacterSupport,__characterPairSupport:H.__characterPairSupport,autoClosingPairs:H.autoClosingPairs};return this.e.$setLanguageConfiguration(K,q,ee),this.p(K)}$setWordDefinitions(M){for(const q of M)this.h.setWordDefinitionFor(q.languageId,new RegExp(q.regexSource,q.regexFlags))}}e.$Cac=me}),define(Pe[240],Ae([1,0,3,8,7,29,13,6]),function(pe,e,y,R,C,L,A,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kbc=void 0;class S{constructor(P,D,u,p){this.c=D,this.d=u,this.e=p,this.b=[],this.f=0,this.g=new Set,this.a=P.getProxy(y.$SJ.MainThreadLanguages)}$acceptLanguageIds(P){this.b=P}async getLanguages(){return this.b.slice(0)}async changeLanguage(P,D){await this.a.$changeLanguage(P,D);const u=this.c.getDocumentData(P);if(!u)throw new Error(`document '${P.toString()}' NOT found`);return u.document}async tokenAtPosition(P,D){const u=P.version,p=R.Position.from(D),$=await this.a.$tokensAtPosition(P.uri,p),d={type:C.StandardTokenType.Other,range:P.getWordRangeAtPosition(D)??new C.$WJ(D.line,D.character,D.line,D.character)};if(!$)return d;const t={range:R.Range.to($.range),type:R.TokenType.to($.type)};return!t.range.contains(D)||u!==P.version?d:t}createLanguageStatusItem(P,D,u){const p=this.f++,$=this.a,d=this.g,t=`${P.identifier.value}/${D}`;if(d.has(t))throw new Error(`LanguageStatusItem with id '${D}' ALREADY exists`);d.add(t);const i={selector:u,id:D,name:P.displayName??P.name,severity:C.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let c;const m=new h.$lb,E=()=>{if(c?.dispose(),!d.has(t)){console.warn(`LanguageStatusItem (${D}) from ${P.identifier.value} has been disposed and CANNOT be updated anymore`);return}c=(0,A.$Gg)(()=>{m.clear(),this.a.$setLanguageStatus(p,{id:t,name:i.name??P.displayName??P.name,source:P.displayName??P.name,selector:R.DocumentSelector.from(i.selector,this.e),label:i.text,detail:i.detail??"",severity:i.severity===C.LanguageStatusSeverity.Error?L.default.Error:i.severity===C.LanguageStatusSeverity.Warning?L.default.Warning:L.default.Info,command:i.command&&this.d.toInternal(i.command,m),accessibilityInfo:i.accessibilityInformation,busy:i.busy})},0)},b={dispose(){m.dispose(),c?.dispose(),$.$removeLanguageStatus(p),d.delete(t)},get id(){return i.id},get name(){return i.name},set name(n){i.name=n,E()},get selector(){return i.selector},set selector(n){i.selector=n,E()},get text(){return i.text},set text(n){i.text=n,E()},get detail(){return i.detail},set detail(n){i.detail=n,E()},get severity(){return i.severity},set severity(n){i.severity=n,E()},get accessibilityInformation(){return i.accessibilityInformation},set accessibilityInformation(n){i.accessibilityInformation=n,E()},get command(){return i.command},set command(n){i.command=n,E()},get busy(){return i.busy},set busy(n){i.busy=n,E()}};return E(),b}}e.$kbc=S}),define(Pe[81],Ae([1,0,22,15,2,4,14,3,27,17]),function(pe,e,y,R,C,L,A,h,S,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$abc=e.$_ac=void 0;let P=class{constructor(u,p,$){this.f=$,this.d=new Map,this.a=p.getProxy(h.$SJ.MainThreadLocalization),this.b=u.environment.appLanguage,this.c=this.b===y.$f}getMessage(u,p){const{message:$,args:d,comment:t}=p;if(this.c)return(0,R.$qd)($,d??{});let i=$;t&&t.length>0&&(i+=`/${Array.isArray(t)?t.join(""):t}`);const c=this.d.get(u)?.contents[i];return c||this.f.warn(`Using default string since no string found in i18n bundle that has the key: ${i}`),(0,R.$qd)(c??$,d??{})}getBundle(u){return this.d.get(u)?.contents}getBundleUri(u){return this.d.get(u)?.uri}async initializeLocalizedMessages(u){if(this.c||!u.l10n&&!u.isBuiltin||this.d.has(u.identifier.value))return;let p;const $=await this.g(u);if(!$){this.f.error(`No bundle location found for extension ${u.identifier.value}`);return}try{const d=await this.a.$fetchBundleContents($),t=JSON.parse(d);p=u.isBuiltin?t.contents?.bundle:t}catch(d){this.f.error(`Failed to load translations for ${u.identifier.value} from ${$}: ${d.message}`);return}p&&this.d.set(u.identifier.value,{contents:p,uri:$})}async g(u){if(u.isBuiltin){const p=await this.a.$fetchBuiltInBundleUri(u.identifier.value,this.b);return C.URI.revive(p)}return u.l10n?C.URI.joinPath(u.extensionLocation,u.l10n,`bundle.l10n.${this.b}.json`):void 0}};e.$_ac=P,e.$_ac=P=Ke([Ve(0,S.$$L),Ve(1,g.$UL),Ve(2,A.$3i)],P),e.$abc=(0,L.$zh)("IExtHostLocalizationService")}),define(Pe[241],Ae([1,0,14,3,27,17,2,68]),function(pe,e,y,R,C,L,A,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Acc=void 0;let S=class extends y.$bj{constructor(D,u){super(u.logLevel,u.logsLocation,u.loggers.map(p=>(0,h.$9g)(p))),this.n=D.getProxy(R.$SJ.MainThreadLogger)}$setLogLevel(D,u){u?this.setLogLevel(A.URI.revive(u),D):this.setLogLevel(D)}setVisibility(D,u){super.setVisibility(D,u),this.n.$setVisibility(D,u)}m(D,u,p){return new g(this.n,D,u,p)}};e.$Acc=S,e.$Acc=S=Ke([Ve(0,L.$UL),Ve(1,C.$$L)],S);class g extends y.$9i{constructor(D,u,p,$){super($?.logLevel==="always"),this.m=D,this.n=u,this.k=!1,this.l=[],this.setLevel(p),this.m.$createLogger(u,$).then(()=>{this.r(this.l),this.k=!0})}g(D,u){const p=[[D,u]];this.k?this.r(p):this.l.push(...p)}r(D){this.m.$log(this.n,D)}flush(){this.m.$flush(this.n)}}}),define(Pe[82],Ae([1,0,3,4,6,17,25]),function(pe,e,y,R,C,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cbc=e.$bbc=void 0,e.$bbc=(0,R.$zh)("IExtHostManagedSockets");let h=class{constructor(D){this.b=0,this.c=null,this.d=new Map,this.a=D.getProxy(y.$SJ.MainThreadManagedSockets)}setFactory(D,u){for(const p of this.d.values())p.dispose();this.c&&this.a.$unregisterSocketFactory(this.c.socketFactoryId),this.c=new S(D,u),this.a.$registerSocketFactory(this.c.socketFactoryId)}async $openRemoteSocket(D){if(!this.c||this.c.socketFactoryId!==D)throw new Error(`No socket factory with id ${D}`);const u=++this.b,p=await this.c.makeConnection(),$=new C.$lb;return this.d.set(u,new g(u,p,$)),$.add((0,C.$kb)(()=>this.d.delete(u))),$.add(p.onDidEnd(()=>{this.a.$onDidManagedSocketEnd(u),$.dispose()})),$.add(p.onDidClose(d=>{this.a.$onDidManagedSocketClose(u,d?.stack??d?.message),$.dispose()})),$.add(p.onDidReceiveMessage(d=>this.a.$onDidManagedSocketHaveData(u,A.$Hc.wrap(d)))),u}$remoteSocketWrite(D,u){this.d.get(D)?.actual.send(u.buffer)}$remoteSocketEnd(D){const u=this.d.get(D);u&&(u.actual.end(),u.dispose())}async $remoteSocketDrain(D){await this.d.get(D)?.actual.drain?.()}};e.$cbc=h,e.$cbc=h=Ke([Ve(0,L.$UL)],h);class S{constructor(D,u){this.socketFactoryId=D,this.makeConnection=u}}class g extends C.$mb{constructor(D,u,p){super(),this.socketId=D,this.actual=u,this.B(p)}}}),define(Pe[242],Ae([1,0,3,14,26]),function(pe,e,y,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lbc=void 0;function L(h){return h&&h.title}let A=class{constructor(S,g){this.b=g,this.a=S.getProxy(y.$SJ.MainThreadMessageService)}showMessage(S,g,P,D,u){const p={source:{identifier:S.identifier,label:S.displayName||S.name}};let $;typeof D=="string"||L(D)?$=[D,...u]:(p.modal=D?.modal,p.useCustom=D?.useCustom,p.detail=D?.detail,$=u),p.useCustom&&(0,C.$MF)(S,"resolvers");const d=[];for(let t=0;t<$.length;t++){const i=$[t];if(typeof i=="string")d.push({title:i,handle:t,isCloseAffordance:!1});else if(typeof i=="object"){const{title:c,isCloseAffordance:m}=i;d.push({title:c,isCloseAffordance:!!m,handle:t})}else this.b.warn("Invalid message item:",i)}return this.a.$showMessage(g,P,p,d).then(t=>{if(typeof t=="number")return $[t]})}};e.$lbc=A,e.$lbc=A=Ke([Ve(1,R.$3i)],A)}),define(Pe[243],Ae([1,0,152,25,5,6,28,15,16,2,38,54,3,31,8,7,46,205,104,9,24,12]),function(pe,e,y,R,C,L,A,h,S,g,P,D,u,p,$,d,t,i,c,m,E,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6bc=void 0;class n{static{this.a=0}get activeNotebookEditor(){return this.k?.apiEditor}get visibleNotebookEditors(){return this.l.map(s=>s.apiEditor)}constructor(s,o,w,v,I){this.q=w,this.r=v,this.s=I,this.f=new Map,this.g=new A.$xi,this.h=new Map,this.j=new C.$hc({onListenerError:m.$Z}),this.onDidChangeActiveNotebookEditor=this.j.event,this.l=[],this.m=new C.$hc({onListenerError:m.$Z}),this.onDidOpenNotebookDocument=this.m.event,this.n=new C.$hc({onListenerError:m.$Z}),this.onDidCloseNotebookDocument=this.n.event,this.o=new C.$hc({onListenerError:m.$Z}),this.onDidChangeVisibleNotebookEditors=this.o.event,this.p=new D.$tac("NotebookCellStatusBarCache"),this.u=0,this.w=new Map,this.b=s.getProxy(u.$SJ.MainThreadNotebook),this.c=s.getProxy(u.$SJ.MainThreadNotebookDocuments),this.d=s.getProxy(u.$SJ.MainThreadNotebookEditors),this.i=o.converter,o.registerArgumentProcessor({processArgument:k=>{if(k&&k.$mid===13){const r=k.notebookEditor?.notebookUri,l=k.cell.handle,F=this.g.get(r)?.getCell(l);if(F)return F.apiCell}if(k&&k.$mid===14){const r=k.uri,l=this.g.get(r);if(l)return l.apiNotebook}return k}}),n.A(o)}getEditorById(s){const o=this.h.get(s);if(!o)throw new Error(`unknown text editor: ${s}. known editors: ${[...this.h.keys()]} `);return o}getIdByEditor(s){for(const[o,w]of this.h)if(w.apiEditor===s)return o}get notebookDocuments(){return[...this.g.values()]}getNotebookDocument(s,o){const w=this.g.get(s);if(!w&&!o)throw new Error(`NO notebook document for '${s}'`);return w}static t(s,o){if(!o)return;const w=o.filenamePattern.map(v=>$.NotebookExclusiveDocumentPattern.from(v)).filter(v=>v!==void 0);if(o.filenamePattern&&!w){console.warn(`Notebook content provider view options file name pattern is invalid ${o.filenamePattern}`);return}return{extension:s.identifier,providerDisplayName:s.displayName||s.name,displayName:o.displayName,filenamePattern:w,exclusive:o.exclusive||!1}}registerNotebookCellStatusBarItemProvider(s,o,w){const v=n.a++,I=typeof w.onDidChangeCellStatusBarItems=="function"?n.a++:void 0;this.f.set(v,w),this.b.$registerNotebookCellStatusBarItemProvider(v,I,o);let k;return I!==void 0&&(k=w.onDidChangeCellStatusBarItems(r=>this.b.$emitCellStatusBarEvent(I))),new d.$UJ(()=>{this.f.delete(v),this.b.$unregisterNotebookCellStatusBarItemProvider(v,I),k?.dispose()})}async createNotebookDocument(s){const o=await this.c.$tryCreateNotebook({viewType:s.viewType,content:s.content&&$.NotebookData.from(s.content)});return g.URI.revive(o)}async openNotebookDocument(s){const o=this.g.get(s);if(o)return o.apiNotebook;const w=await this.c.$tryOpenNotebook(s),v=this.g.get(g.URI.revive(w));return(0,S.$we)(v?.apiNotebook)}async showNotebookDocument(s,o){g.URI.isUri(s)&&(s=await this.openNotebookDocument(s));let w;typeof o=="object"?w={position:$.ViewColumn.from(o.viewColumn),preserveFocus:o.preserveFocus,selections:o.selections&&o.selections.map($.NotebookRange.from),pinned:typeof o.preview=="boolean"?!o.preview:void 0}:w={preserveFocus:!1};const v=await this.d.$tryShowNotebookDocument(s.uri,s.notebookType,w),I=v&&this.h.get(v)?.apiEditor;if(I)return I;throw v?new Error(`Could NOT open editor for "${s.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${s.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(s,o,w,v){const I=this.f.get(s),k=g.URI.revive(o),r=this.g.get(k);if(!r||!I)return;const l=r.getCellFromIndex(w);if(!l)return;const f=await I.provideCellStatusBarItems(l.apiCell,v);if(!f)return;const F=new L.$lb,W=this.p.add([F]),B=(Array.isArray(f)?f:[f]).map(j=>$.NotebookStatusBarItem.from(j,this.i,F));return{cacheId:W,items:B}}$releaseNotebookCellStatusBarItems(s){this.p.delete(s)}registerNotebookSerializer(s,o,w,v,I){if((0,h.$od)(o))throw new Error("viewType cannot be empty or just whitespace");const k=this.u++;return this.w.set(k,{viewType:o,serializer:w,options:v}),this.b.$registerNotebookSerializer(k,{id:s.identifier,location:s.extensionLocation},o,$.NotebookDocumentContentOptions.from(v),n.t(s,I)),(0,L.$kb)(()=>{this.b.$unregisterNotebookSerializer(k)})}async $dataToNotebook(s,o,w){const v=this.w.get(s);if(!v)throw new Error("NO serializer found");const I=await v.serializer.deserializeNotebook(o.buffer,w);return new t.$_z($.NotebookData.from(I))}async $notebookToData(s,o,w){const v=this.w.get(s);if(!v)throw new Error("NO serializer found");const I=await v.serializer.serializeNotebook($.NotebookData.to(o.value),w);return R.$Hc.wrap(I)}async $saveNotebook(s,o,w,v,I){const k=g.URI.revive(o),r=this.w.get(s);if(!r)throw new Error("NO serializer found");const l=this.g.get(k);if(!l)throw new Error("Document NOT found");if(l.versionId!==w)throw new Error("Document version mismatch");if(!this.s.value.isWritableFileSystem(k.scheme))throw new P.$lk((0,y.localize)(0,null,this.y(k)),6);await this.x(k,v);const f={metadata:(0,E.$2m)(l.apiNotebook.metadata,j=>!(r.options?.transientDocumentMetadata??{})[j]),cells:[]};for(const j of l.apiNotebook.getCells()){const U=new d.$hL(j.kind,j.document.getText(),j.document.languageId,j.mime,r.options?.transientOutputs?[]:[...j.outputs],j.metadata,j.executionSummary);U.metadata=(0,E.$2m)(j.metadata,z=>!(r.options?.transientCellMetadata??{})[z]),f.cells.push(U)}const F=await r.serializer.serializeNotebook(f,I);await this.s.value.writeFile(k,F);const W=this.s.getFileSystemProviderExtUri(k.scheme),V=await this.s.value.stat(k);return{name:W.basename(k),isFile:(V.type&P.FileType.File)!==0,isDirectory:(V.type&P.FileType.Directory)!==0,isSymbolicLink:(V.type&P.FileType.SymbolicLink)!==0,mtime:V.mtime,ctime:V.ctime,size:V.size,readonly:!!((V.permissions??0)&P.FilePermission.Readonly)||!this.s.value.isWritableFileSystem(k.scheme),locked:!!((V.permissions??0)&P.FilePermission.Locked),etag:P.$wk({mtime:V.mtime,size:V.size}),children:void 0}}async x(s,o){const w=await this.s.value.stat(s);if(typeof o?.mtime=="number"&&typeof o.etag=="string"&&o.etag!==P.$vk&&typeof w.mtime=="number"&&typeof w.size=="number"&&o.mtime<w.mtime&&o.etag!==P.$wk({mtime:o.mtime,size:w.size}))throw new P.$lk((0,y.localize)(1,null),3,o)}y(s){return s.scheme===b.Schemas.file?s.fsPath:s.toString()}z(s,o,w){if(this.h.has(o))throw new Error(`editor with id ALREADY EXSIST: ${o}`);const v=new c.$5bc(o,this.d,s,w.visibleRanges.map($.NotebookRange.to),w.selections.map($.NotebookRange.to),typeof w.viewColumn=="number"?$.ViewColumn.to(w.viewColumn):void 0);this.h.set(o,v)}$acceptDocumentAndEditorsDelta(s){if(s.value.removedDocuments)for(const w of s.value.removedDocuments){const v=g.URI.revive(w),I=this.g.get(v);I&&(I.dispose(),this.g.delete(v),this.q.$acceptDocumentsAndEditorsDelta({removedDocuments:I.apiNotebook.getCells().map(k=>k.document.uri)}),this.n.fire(I.apiNotebook));for(const k of this.h.values())k.notebookData.uri.toString()===v.toString()&&this.h.delete(k.id)}if(s.value.addedDocuments){const w=[];for(const v of s.value.addedDocuments){const I=g.URI.revive(v.uri);if(this.g.has(I))throw new Error(`adding EXISTING notebook ${I} `);const k=new i.$4bc(this.c,this.q,this.r,I,v);w.push(...v.cells.map(r=>i.$3bc.asModelAddData(k.apiNotebook,r))),this.g.get(I)?.dispose(),this.g.set(I,k),this.q.$acceptDocumentsAndEditorsDelta({addedDocuments:w}),this.m.fire(k.apiNotebook)}}if(s.value.addedEditors)for(const w of s.value.addedEditors){if(this.h.has(w.id))return;const v=g.URI.revive(w.documentUri),I=this.g.get(v);I&&this.z(I,w.id,w)}const o=[];if(s.value.removedEditors)for(const w of s.value.removedEditors){const v=this.h.get(w);v&&(this.h.delete(w),this.k?.id===v.id&&(this.k=void 0),o.push(v))}if(s.value.visibleEditors){this.l=s.value.visibleEditors.map(v=>this.h.get(v)).filter(v=>!!v);const w=new Set;this.l.forEach(v=>w.add(v.id));for(const v of this.h.values()){const I=w.has(v.id);v._acceptVisibility(I)}this.l=[...this.h.values()].map(v=>v).filter(v=>v.visible),this.o.fire(this.visibleNotebookEditors)}s.value.newActiveEditor===null?this.k=void 0:s.value.newActiveEditor&&(this.h.get(s.value.newActiveEditor)||console.error(`FAILED to find active notebook editor ${s.value.newActiveEditor}`),this.k=this.h.get(s.value.newActiveEditor)),s.value.newActiveEditor!==void 0&&this.j.fire(this.k?.apiEditor)}static A(s){const o=p.$gM.String.with("notebookType","A notebook type"),w=new p.$iM("vscode.executeDataToNotebook","_executeDataToNotebook","Invoke notebook serializer",[o,new p.$gM("data","Bytes to convert to data",I=>I instanceof Uint8Array,I=>R.$Hc.wrap(I))],new p.$hM("Notebook Data",I=>$.NotebookData.to(I.value))),v=new p.$iM("vscode.executeNotebookToData","_executeNotebookToData","Invoke notebook serializer",[o,new p.$gM("NotebookData","Notebook data to convert to bytes",I=>!0,I=>new t.$_z($.NotebookData.from(I)))],new p.$hM("Bytes",I=>I.buffer));s.registerApiCommand(w),s.registerApiCommand(v)}}e.$6bc=n}),define(Pe[244],Ae([1,0,18,13,21,5,6,28,2,20,14,54,3,31,8,7,77,198,26,46]),function(pe,e,y,R,C,L,A,h,S,g,P,D,u,p,$,d,t,i,c,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$icc=e.$hcc=void 0;let E=class{constructor(I,k,r,l,f){this.m=k,this.n=r,this.o=l,this.q=f,this.b=new h.$xi,this.c=new h.$xi,this.e=new Map,this.f=0,this.g=new Map,this.h=0,this.i=new D.$tac("NotebookKernelSourceActionProviderCache"),this.j=new Map,this.k=0,this.l=new L.$hc,this.onDidChangeNotebookCellExecutionState=this.l.event,this.a=I.getProxy(u.$SJ.MainThreadNotebookKernels);const F=new p.$iM("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new p.$gM("options","Select kernel options",W=>!0,W=>{if(W&&"notebookEditor"in W&&"id"in W){const V=this.n.getIdByEditor(W.notebookEditor);return{id:W.id,extension:W.extension,notebookEditorId:V}}else if(W&&"notebookEditor"in W){const V=this.n.getIdByEditor(W.notebookEditor);if(V===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${W.notebookEditor.notebook.uri.toString()}`);return{notebookEditorId:V}}return W})],p.$hM.Void);this.o.registerApiCommand(F)}createNotebookController(I,k,r,l,f,F){for(const we of this.j.values())if(we.controller.id===k&&g.$Tl.equals(I.identifier,we.extensionId))throw new Error(`notebook controller with id '${k}' ALREADY exist`);const W=this.k++,V=this;this.q.trace(`NotebookController[${W}], CREATED by ${I.identifier.value}, ${k}`);const B=()=>console.warn(`NO execute handler from notebook controller '${ie.id}' of extension: '${I.identifier}'`);let j=!1;const U=new L.$hc,z=new L.$hc,ie={id:w(I.identifier,k),notebookType:r,extensionId:I.identifier,extensionLocation:I.extensionLocation,label:l||I.identifier.value,preloads:F?F.map($.NotebookRendererScript.from):[]};let Y=f??B,ye;this.a.$addKernel(W,ie).catch(we=>{console.log(we),j=!0});let ke=0;const Re=()=>{if(j)return;const we=++ke;Promise.resolve().then(()=>{we===ke&&this.a.$updateKernel(W,ie)})},X=new h.$xi,le={get id(){return k},get notebookType(){return ie.notebookType},onDidChangeSelectedNotebooks:U.event,get label(){return ie.label},set label(we){ie.label=we??I.displayName??I.name,Re()},get detail(){return ie.detail??""},set detail(we){ie.detail=we,Re()},get description(){return ie.description??""},set description(we){ie.description=we,Re()},get supportedLanguages(){return ie.supportedLanguages},set supportedLanguages(we){ie.supportedLanguages=we,Re()},get supportsExecutionOrder(){return ie.supportsExecutionOrder??!1},set supportsExecutionOrder(we){ie.supportsExecutionOrder=we,Re()},get rendererScripts(){return ie.preloads?ie.preloads.map($.NotebookRendererScript.to):[]},get executeHandler(){return Y},set executeHandler(we){Y=we??B},get interruptHandler(){return ye},set interruptHandler(we){ye=we,ie.supportsInterrupt=!!we,Re()},createNotebookCellExecution(we){if(j)throw new Error("notebook controller is DISPOSED");if(!X.has(we.notebook.uri))throw V.q.trace(`NotebookController[${W}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(X.keys()).map(ae=>ae.toString())),new Error(`notebook controller is NOT associated to notebook: ${we.notebook.uri.toString()}`);return V._createNotebookCellExecution(we,w(I.identifier,this.id))},createNotebookExecution(we){if((0,c.$MF)(I,"notebookExecution"),j)throw new Error("notebook controller is DISPOSED");if(!X.has(we.uri))throw V.q.trace(`NotebookController[${W}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(X.keys()).map(ae=>ae.toString())),new Error(`notebook controller is NOT associated to notebook: ${we.uri.toString()}`);return V._createNotebookExecution(we,w(I.identifier,this.id))},dispose:()=>{j||(this.q.trace(`NotebookController[${W}], DISPOSED`),j=!0,this.j.delete(W),U.dispose(),z.dispose(),this.a.$removeKernel(W))},updateNotebookAffinity(we,ae){ae===d.NotebookControllerAffinity2.Hidden&&(0,c.$MF)(I,"notebookControllerAffinityHidden"),V.a.$updateNotebookPriority(W,we.uri,ae)},onDidReceiveMessage:z.event,postMessage(we,ae){return(0,c.$MF)(I,"notebookMessaging"),V.a.$postMessage(W,ae&&V.n.getIdByEditor(ae),we)},asWebviewUri(we){return(0,c.$MF)(I,"notebookMessaging"),(0,t.$Aob)(we,V.m.remote)}};return this.j.set(W,{extensionId:I.identifier,controller:le,onDidReceiveMessage:z,onDidChangeSelection:U,associatedNotebooks:X}),le}getIdByController(I){for(const[k,r]of this.j)if(r.controller===I)return w(r.extensionId,I.id);return null}createNotebookControllerDetectionTask(I,k){const r=this.f++,l=this;this.q.trace(`NotebookControllerDetectionTask[${r}], CREATED by ${I.identifier.value}`),this.a.$addKernelDetectionTask(r,k);const f={dispose:()=>{this.e.delete(r),l.a.$removeKernelDetectionTask(r)}};return this.e.set(r,f),f}registerKernelSourceActionProvider(I,k,r){const l=this.h++,f=typeof r.onDidChangeNotebookKernelSourceActions=="function"?l:void 0,F=this;this.g.set(l,r),this.q.trace(`NotebookKernelSourceActionProvider[${l}], CREATED by ${I.identifier.value}`),this.a.$addKernelSourceActionProvider(l,l,k);let W;return f!==void 0&&(W=r.onDidChangeNotebookKernelSourceActions(V=>this.a.$emitNotebookKernelSourceActionsChangeEvent(f))),{dispose:()=>{this.g.delete(l),F.a.$removeKernelSourceActionProvider(l,l),W?.dispose()}}}async $provideKernelSourceActions(I,k){const r=this.g.get(I);if(r){const l=new A.$lb;return this.i.add([l]),(await r.provideNotebookKernelSourceActions(k)??[]).map(F=>$.NotebookKernelSourceAction.from(F,this.o.converter,l))}return[]}$acceptNotebookAssociation(I,k,r){const l=this.j.get(I);if(l){const f=this.n.getNotebookDocument(S.URI.revive(k));r?l.associatedNotebooks.set(f.uri,!0):l.associatedNotebooks.delete(f.uri),this.q.trace(`NotebookController[${I}] ASSOCIATE notebook`,f.uri.toString(),r),l.onDidChangeSelection.fire({selected:r,notebook:f.apiNotebook})}}async $executeCells(I,k,r){const l=this.j.get(I);if(!l)return;const f=this.n.getNotebookDocument(S.URI.revive(k)),F=[];for(const W of r){const V=f.getCell(W);V&&F.push(V.apiCell)}try{this.q.trace(`NotebookController[${I}] EXECUTE cells`,f.uri.toString(),F.length),await l.controller.executeHandler.call(l.controller,F,f.apiNotebook,l.controller)}catch(W){this.q.error(`NotebookController[${I}] execute cells FAILED`,W),console.error(W)}}async $cancelCells(I,k,r){const l=this.j.get(I);if(!l)return;const f=this.n.getNotebookDocument(S.URI.revive(k));if(l.controller.interruptHandler)await l.controller.interruptHandler.call(l.controller,f.apiNotebook);else for(const F of r){const W=f.getCell(F);W&&this.b.get(W.uri)?.cancel()}if(l.controller.interruptHandler){const F=this.c.get(f.uri);r.length&&Array.isArray(F)&&F.length&&F.forEach(W=>W.dispose())}}$acceptKernelMessageFromRenderer(I,k,r){const l=this.j.get(I);if(!l)return;const f=this.n.getEditorById(k);l.onDidReceiveMessage.fire(Object.freeze({editor:f.apiEditor,message:r}))}$cellExecutionChanged(I,k,r){const f=this.n.getNotebookDocument(S.URI.revive(I)).getCell(k);if(f){const F=r?$.NotebookCellExecutionState.to(r):d.NotebookCellExecutionState.Idle;F!==void 0&&this.l.fire({cell:f.apiCell,state:F})}}_createNotebookCellExecution(I,k){if(I.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const l=this.n.getNotebookDocument(I.notebook.uri).getCellFromApiCell(I);if(!l)throw new Error("invalid cell");if(this.b.has(l.uri))throw new Error(`duplicate execution for ${l.uri}`);const f=new n(k,l,this.a);this.b.set(l.uri,f);const F=f.onDidChangeState(()=>{f.state===b.Resolved&&(f.dispose(),F.dispose(),this.b.delete(l.uri))});return f.asApiObject()}_createNotebookExecution(I,k){const r=this.n.getNotebookDocument(I.uri),l=I.getCells().find(W=>{const V=r.getCellFromApiCell(W);return V&&this.b.has(V.uri)});if(l)throw new Error(`duplicate cell execution for ${l.document.uri}`);if(this.c.has(r.uri))throw new Error(`duplicate notebook execution for ${r.uri}`);const f=new s(k,r,this.a),F=f.onDidChangeState(()=>{f.state===a.Resolved&&(f.dispose(),F.dispose(),this.c.delete(r.uri))});return this.c.set(r.uri,[f,F]),f.asApiObject()}};e.$hcc=E,e.$hcc=E=Ke([Ve(4,P.$3i)],E);var b;(function(v){v[v.Init=0]="Init",v[v.Started=1]="Started",v[v.Resolved=2]="Resolved"})(b||(b={}));class n extends A.$mb{static{this.a=0}get state(){return this.f}constructor(I,k,r){super(),this.j=k,this.k=r,this.b=n.a++,this.c=new L.$hc,this.onDidChangeState=this.c.event,this.f=b.Init,this.g=this.B(new C.$rc),this.h=new o(10,l=>this.m(l)),this.i=k.internalMetadata.executionOrder,this.k.$createExecution(this.b,I,this.j.notebook.uri,this.j.handle)}cancel(){this.g.cancel()}async l(I){await this.h.addItem(I)}async m(I){const k=Array.isArray(I)?I:[I];return this.k.$updateExecution(this.b,new m.$_z(k))}n(){if(this.f===b.Init)throw new Error("Must call start before modifying cell output");if(this.f===b.Resolved)throw new Error("Cannot modify cell output after calling resolve")}r(I){let k=this.j;if(I&&(k=this.j.notebook.getCellFromApiCell(I)),!k)throw new Error("INVALID cell");return k.handle}s(I){return I.map(k=>{const r=d.$kL.ensureUniqueMimeTypes(k.items,!0);return r===k.items?$.NotebookCellOutput.from(k):$.NotebookCellOutput.from({items:r,id:k.id,metadata:k.metadata})})}async t(I,k,r){const l=this.r(k),f=this.s((0,y.$Vf)(I));return this.l({editType:i.CellExecutionUpdateType.Output,cellHandle:l,append:r,outputs:f})}async w(I,k,r){return I=d.$kL.ensureUniqueMimeTypes((0,y.$Vf)(I),!0),this.l({editType:i.CellExecutionUpdateType.OutputItems,items:I.map($.NotebookCellOutputItem.from),outputId:k.id,append:r})}asApiObject(){const I=this;return Object.freeze({get token(){return I.g.token},get cell(){return I.j.apiCell},get executionOrder(){return I.i},set executionOrder(r){I.i=r,I.m([{editType:i.CellExecutionUpdateType.ExecutionState,executionOrder:I.i}])},start(r){if(I.f===b.Resolved||I.f===b.Started)throw new Error("Cannot call start again");I.f=b.Started,I.c.fire(),I.m({editType:i.CellExecutionUpdateType.ExecutionState,runStartTime:r})},end(r,l){if(I.f===b.Resolved)throw new Error("Cannot call resolve twice");I.f=b.Resolved,I.c.fire(),I.h.flush(),I.k.$completeExecution(I.b,new m.$_z({runEndTime:l,lastRunSuccess:r}))},clearOutput(r){return I.n(),I.t([],r,!1)},appendOutput(r,l){return I.n(),I.t(r,l,!0)},replaceOutput(r,l){return I.n(),I.t(r,l,!1)},appendOutputItems(r,l){return I.n(),I.w(r,l,!0)},replaceOutputItems(r,l){return I.n(),I.w(r,l,!1)}})}}var a;(function(v){v[v.Init=0]="Init",v[v.Started=1]="Started",v[v.Resolved=2]="Resolved"})(a||(a={}));class s extends A.$mb{static{this.a=0}get state(){return this.f}constructor(I,k,r){super(),this.h=k,this.i=r,this.b=s.a++,this.c=new L.$hc,this.onDidChangeState=this.c.event,this.f=a.Init,this.g=this.B(new C.$rc),this.i.$createNotebookExecution(this.b,I,this.h.uri)}cancel(){this.g.cancel()}asApiObject(){return Object.freeze({start:()=>{if(this.f===a.Resolved||this.f===a.Started)throw new Error("Cannot call start again");this.f=a.Started,this.c.fire(),this.i.$beginNotebookExecution(this.b)},end:()=>{if(this.f===a.Resolved)throw new Error("Cannot call resolve twice");this.f=a.Resolved,this.c.fire(),this.i.$completeNotebookExecution(this.b)}})}}class o{constructor(I,k){this.e=I,this.f=k,this.a=[],this.b=Date.now()}addItem(I){return this.a.push(I),this.c||(this.c=new R.$Zg,this.b=Date.now(),(0,R.$Fg)(this.e).then(()=>this.flush())),Date.now()-this.b>this.e?this.flush():this.c.p}flush(){if(this.a.length===0||!this.c)return Promise.resolve();const I=this.c;this.c=void 0;const k=this.a;return this.a=[],this.f(k).finally(()=>I.complete())}}function w(v,I){return`${v.value}/${I}`}e.$icc=w}),define(Pe[245],Ae([1,0,5,3,104]),function(pe,e,y,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jcc=void 0;class L{constructor(h,S){this.c=S,this.a=new Map,this.b=h.getProxy(R.$SJ.MainThreadNotebookRenderers)}$postRendererMessage(h,S,g){const P=this.c.getEditorById(h);this.a.get(S)?.fire({editor:P.apiEditor,message:g})}createRendererMessaging(h,S){if(!h.contributes?.notebookRenderer?.some(P=>P.id===S))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${S})`);return{onDidReceiveMessage:(P,D,u)=>this.d(S).event(P,D,u),postMessage:(P,D)=>{C.$5bc.apiEditorsToExtHost.has(P)&&([P,D]=[D,P]);const u=D&&C.$5bc.apiEditorsToExtHost.get(D);return this.b.$postMessage(u?.id,S,P)}}}d(h){let S=this.a.get(h);return S||(S=new y.$hc({onDidRemoveLastListener:()=>{S?.dispose(),this.a.delete(h)}}),this.a.set(h,S),S)}}e.$jcc=L}),define(Pe[246],Ae([1,0,6,16,2,26,3]),function(pe,e,y,R,C,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ncc=void 0;class h{constructor(g){this.b=new Map,this.a=g.getProxy(A.$SJ.MainThreadProfileContentHandlers)}registrProfileContentHandler(g,P,D){if((0,L.$MF)(g,"profileContentHandlers"),this.b.has(P))throw new Error(`Handler with id '${P}' already registered`);return this.b.set(P,D),this.a.$registerProfileContentHandler(P,D.name,D.description,g.identifier.value),(0,y.$kb)(()=>{this.b.delete(P),this.a.$unregisterProfileContentHandler(P)})}async $saveProfile(g,P,D,u){const p=this.b.get(g);if(!p)throw new Error(`Unknown handler with id: ${g}`);return p.saveProfile(P,D,u)}async $readProfile(g,P,D){const u=this.b.get(g);if(!u)throw new Error(`Unknown handler with id: ${g}`);return u.readProfile((0,R.$le)(P)?P:C.URI.revive(P),D)}}e.$ncc=h}),define(Pe[247],Ae([1,0,2,3,13,8]),function(pe,e,y,R,C,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$occ=void 0;class A{static{this.a=0}constructor(S,g){this.d=g,this.c=new Map,this.b=S.getProxy(R.$SJ.MainThreadQuickDiff)}$provideOriginalResource(S,g,P){const D=y.URI.revive(g),u=this.c.get(S);return u?(0,C.$xg)(()=>u.provideOriginalResource(D,P)).then(p=>p||null):Promise.resolve(null)}registerQuickDiffProvider(S,g,P,D){const u=A.a++;return this.c.set(u,g),this.b.$registerQuickDiffProvider(u,L.DocumentSelector.from(S,this.d),P,D),{dispose:()=>{this.b.$unregisterQuickDiffProvider(u),this.c.delete(u)}}}}e.$occ=A}),define(Pe[248],Ae([1,0,21,5,6,3,2,7,9,18,29,40,26,8]),function(pe,e,y,R,C,L,A,h,S,g,P,D,u,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pbc=void 0;function $(d,t,i){const c=d.getProxy(L.$SJ.MainThreadQuickOpen);class m{constructor(I,k){this.e=new Map,this.f=0,this.a=I,this.b=k}showQuickPick(I,k,r,l=y.CancellationToken.None){this.c=void 0;const f=Promise.resolve(k),F=++this.f,W=c.$show(F,{title:r?.title,placeHolder:r?.placeHolder,matchOnDescription:r?.matchOnDescription,matchOnDetail:r?.matchOnDetail,ignoreFocusLost:r?.ignoreFocusOut,canPickMany:r?.canPickMany},l),V={},B=W.then(()=>V);return Promise.race([B,f]).then(j=>{if(j===V)return;const U=(0,u.$LF)(I,"quickPickItemTooltip");return f.then(z=>{const ie=[];for(let Y=0;Y<z.length;Y++){const ye=z[Y];if(typeof ye=="string")ie.push({label:ye,handle:Y});else if(ye.kind===h.QuickPickItemKind.Separator)ie.push({type:"separator",label:ye.label});else{ye.tooltip&&!U&&console.warn(`Extension '${I.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${I.identifier.value}`);const ke=ye.iconPath?s(ye.iconPath):void 0;ie.push({label:ye.label,iconPath:ke?.iconPath,iconClass:ke?.iconClass,description:ye.description,detail:ye.detail,picked:ye.picked,alwaysShow:ye.alwaysShow,tooltip:U?p.MarkdownString.fromStrict(ye.tooltip):void 0,handle:Y})}}return r&&typeof r.onDidSelectItem=="function"&&(this.c=Y=>{r.onDidSelectItem(z[Y])}),c.$setItems(F,ie),W.then(Y=>{if(typeof Y=="number")return z[Y];if(Array.isArray(Y))return Y.map(ye=>z[ye])})})}).then(void 0,j=>{if(!(0,S.$2)(j))return c.$setError(F,j),Promise.reject(j)})}$onItemSelected(I){this.c?.(I)}showInput(I,k=y.CancellationToken.None){return this.d=I?.validateInput,c.$input(I,typeof this.d=="function",k).then(void 0,r=>{if(!(0,S.$2)(r))return Promise.reject(r)})}async $validateInput(I){if(!this.d)return;const k=await this.d(I);if(!k||typeof k=="string")return k;let r;switch(k.severity){case h.InputBoxValidationSeverity.Info:r=P.default.Info;break;case h.InputBoxValidationSeverity.Warning:r=P.default.Warning;break;case h.InputBoxValidationSeverity.Error:r=P.default.Error;break;default:r=k.message?P.default.Error:P.default.Ignore;break}return{content:k.message,severity:r}}async showWorkspaceFolderPick(I,k=y.CancellationToken.None){const r=await this.b.executeCommand("_workbench.pickWorkspaceFolder",[I]);if(!r)return;const l=await this.a.getWorkspaceFolders2();if(l)return l.find(f=>f.uri.toString()===r.uri.toString())}createQuickPick(I){const k=new o(I,()=>this.e.delete(k._id));return this.e.set(k._id,k),k}createInputBox(I){const k=new w(I,()=>this.e.delete(k._id));return this.e.set(k._id,k),k}$onDidChangeValue(I,k){this.e.get(I)?._fireDidChangeValue(k)}$onDidAccept(I){this.e.get(I)?._fireDidAccept()}$onDidChangeActive(I,k){const r=this.e.get(I);r instanceof o&&r._fireDidChangeActive(k)}$onDidChangeSelection(I,k){const r=this.e.get(I);r instanceof o&&r._fireDidChangeSelection(k)}$onDidTriggerButton(I,k){this.e.get(I)?._fireDidTriggerButton(k)}$onDidTriggerItemButton(I,k,r){const l=this.e.get(I);l instanceof o&&l._fireDidTriggerItemButton(k,r)}$onDidHide(I){this.e.get(I)?._fireDidHide()}}class E{static{this.a=1}constructor(I,k){this.x=I,this.y=k,this._id=o.a++,this.e=!1,this.f=!1,this.g=!0,this.j=!1,this.k=!0,this.l="",this.n=[],this.o=new Map,this.p=new R.$hc,this.q=new R.$hc,this.r=new R.$hc,this.s=new R.$hc,this.u={id:this._id},this.v=!1,this.w=[this.r,this.s,this.p,this.q],this.onDidChangeValue=this.q.event,this.onDidAccept=this.p.event,this.onDidTriggerButton=this.r.event,this.onDidHide=this.s.event}get title(){return this.b}set title(I){this.b=I,this.z({title:I})}get step(){return this.c}set step(I){this.c=I,this.z({step:I})}get totalSteps(){return this.d}set totalSteps(I){this.d=I,this.z({totalSteps:I})}get enabled(){return this.g}set enabled(I){this.g=I,this.z({enabled:I})}get busy(){return this.j}set busy(I){this.j=I,this.z({busy:I})}get ignoreFocusOut(){return this.k}set ignoreFocusOut(I){this.k=I,this.z({ignoreFocusOut:I})}get value(){return this.l}set value(I){this.l=I,this.z({value:I})}get placeholder(){return this.m}set placeholder(I){this.m=I,this.z({placeholder:I})}get buttons(){return this.n}set buttons(I){this.n=I.slice(),this.o.clear(),I.forEach((k,r)=>{const l=k===h.$dL.Back?-1:r;this.o.set(l,k)}),this.z({buttons:I.map((k,r)=>({...s(k.iconPath),tooltip:k.tooltip,handle:k===h.$dL.Back?-1:r}))})}show(){this.e=!0,this.f=!0,this.z({visible:!0})}hide(){this.e=!1,this.z({visible:!1})}_fireDidAccept(){this.p.fire()}_fireDidChangeValue(I){this.l=I,this.q.fire(I)}_fireDidTriggerButton(I){const k=this.o.get(I);k&&this.r.fire(k)}_fireDidHide(){this.f&&(this.f=this.e,this.s.fire())}dispose(){this.v||(this.v=!0,this._fireDidHide(),this.w=(0,C.$hb)(this.w),this.t&&(clearTimeout(this.t),this.t=void 0),this.y(),c.$dispose(this._id))}z(I){if(!this.v){for(const k of Object.keys(I)){const r=I[k];this.u[k]=r===void 0?null:r}"visible"in this.u?(this.t&&(clearTimeout(this.t),this.t=void 0),this.A()):this.e&&!this.t&&(this.t=setTimeout(()=>{this.t=void 0,this.A()},0))}}A(){c.$createOrUpdate(this.u),this.u={id:this._id}}}function b(v){if(v instanceof h.$PK)return{id:v.id};const I=a(v),k=n(v);return{dark:typeof I=="string"?A.URI.file(I):I,light:typeof k=="string"?A.URI.file(k):k}}function n(v){return typeof v=="object"&&"light"in v?v.light:v}function a(v){return typeof v=="object"&&"dark"in v?v.dark:v}function s(v){const I=b(v);let k,r;return"id"in I?r=D.ThemeIcon.asClassName(I):k=I,{iconPath:k,iconClass:r}}class o extends E{constructor(I,k){super(I.identifier,k),this.O=I,this.B=[],this.C=new Map,this.D=new Map,this.E=!1,this.F=!0,this.G=!0,this.H=!0,this.I=!1,this.J=[],this.K=new R.$hc,this.L=[],this.M=new R.$hc,this.N=new R.$hc,this.onDidChangeActive=this.K.event,this.onDidChangeSelection=this.M.event,this.onDidTriggerItemButton=this.N.event,this.w.push(this.K,this.M,this.N),this.z({type:"quickPick"})}get items(){return this.B}set items(I){this.B=I.slice(),this.C.clear(),this.D.clear(),I.forEach((l,f)=>{this.C.set(f,l),this.D.set(l,f)});const k=(0,u.$LF)(this.O,"quickPickItemTooltip"),r=[];for(let l=0;l<I.length;l++){const f=I[l];if(f.kind===h.QuickPickItemKind.Separator)r.push({type:"separator",label:f.label});else{f.tooltip&&!k&&console.warn(`Extension '${this.O.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${this.O.identifier.value}`);const F=f.iconPath?s(f.iconPath):void 0;r.push({handle:l,label:f.label,iconPath:F?.iconPath,iconClass:F?.iconClass,description:f.description,detail:f.detail,picked:f.picked,alwaysShow:f.alwaysShow,tooltip:k?p.MarkdownString.fromStrict(f.tooltip):void 0,buttons:f.buttons?.map((W,V)=>({...s(W.iconPath),tooltip:W.tooltip,handle:V}))})}}this.z({items:r})}get canSelectMany(){return this.E}set canSelectMany(I){this.E=I,this.z({canSelectMany:I})}get matchOnDescription(){return this.F}set matchOnDescription(I){this.F=I,this.z({matchOnDescription:I})}get matchOnDetail(){return this.G}set matchOnDetail(I){this.G=I,this.z({matchOnDetail:I})}get sortByLabel(){return this.H}set sortByLabel(I){this.H=I,this.z({sortByLabel:I})}get keepScrollPosition(){return this.I}set keepScrollPosition(I){this.I=I,this.z({keepScrollPosition:I})}get activeItems(){return this.J}set activeItems(I){this.J=I.filter(k=>this.D.has(k)),this.z({activeItems:this.J.map(k=>this.D.get(k))})}get selectedItems(){return this.L}set selectedItems(I){this.L=I.filter(k=>this.D.has(k)),this.z({selectedItems:this.L.map(k=>this.D.get(k))})}_fireDidChangeActive(I){const k=(0,g.$Af)(I.map(r=>this.C.get(r)));this.J=k,this.K.fire(k)}_fireDidChangeSelection(I){const k=(0,g.$Af)(I.map(r=>this.C.get(r)));this.L=k,this.M.fire(k)}_fireDidTriggerItemButton(I,k){const r=this.C.get(I);if(!r||!r.buttons||!r.buttons.length)return;const l=r.buttons[k];l&&this.N.fire({button:l,item:r})}}class w extends E{constructor(I,k){super(I.identifier,k),this.B=!1,this.z({type:"inputBox"})}get password(){return this.B}set password(I){this.B=I,this.z({password:I})}get prompt(){return this.C}set prompt(I){this.C=I,this.z({prompt:I})}get valueSelection(){return this.D}set valueSelection(I){this.D=I,this.z({valueSelection:I})}get validationMessage(){return this.E}set validationMessage(I){this.E=I,I?typeof I=="string"?this.z({validationMessage:I,severity:P.default.Error}):this.z({validationMessage:I.message,severity:I.severity??P.default.Error}):this.z({validationMessage:void 0,severity:P.default.Ignore})}}return new m(t,i)}e.$pbc=$}),define(Pe[249],Ae([1,0,2,5,64,6,13,3,18,132,14,20,40,8,26,12]),function(pe,e,y,R,C,L,A,h,S,g,P,D,u,p,$,d){"use strict";var t;Object.defineProperty(e,"__esModule",{value:!0}),e.$rbc=e.$qbc=void 0;function i(k){if(k)return typeof k.iconPath=="string"?y.URI.file(k.iconPath):y.URI.isUri(k.iconPath)||u.ThemeIcon.isThemeIcon(k.iconPath)?k.iconPath:void 0}function c(k,r){if(!k.iconPath&&!r.iconPath)return 0;if(k.iconPath){if(!r.iconPath)return 1}else return-1;const l=typeof k.iconPath=="string"?k.iconPath:y.URI.isUri(k.iconPath)?k.iconPath.fsPath:k.iconPath.id,f=typeof r.iconPath=="string"?r.iconPath:y.URI.isUri(r.iconPath)?r.iconPath.fsPath:r.iconPath.id;return(0,g.$eq)(l,f)}function m(k,r){let l=0;if(k.strikeThrough!==r.strikeThrough)return k.strikeThrough?1:-1;if(k.faded!==r.faded)return k.faded?1:-1;if(k.tooltip!==r.tooltip)return(k.tooltip||"").localeCompare(r.tooltip||"");if(l=c(k,r),l!==0)return l;if(k.light&&r.light)l=c(k.light,r.light);else{if(k.light)return 1;if(r.light)return-1}if(l!==0)return l;if(k.dark&&r.dark)l=c(k.dark,r.dark);else{if(k.dark)return 1;if(r.dark)return-1}return l}function E(k,r){if(k.command!==r.command)return k.command<r.command?-1:1;if(k.title!==r.title)return k.title<r.title?-1:1;if(k.tooltip!==r.tooltip){if(k.tooltip!==void 0&&r.tooltip!==void 0)return k.tooltip<r.tooltip?-1:1;if(k.tooltip!==void 0)return 1;if(r.tooltip!==void 0)return-1}if(k.arguments===r.arguments)return 0;if(k.arguments)if(r.arguments){if(k.arguments.length!==r.arguments.length)return k.arguments.length-r.arguments.length}else return 1;else return-1;for(let l=0;l<k.arguments.length;l++){const f=k.arguments[l],F=r.arguments[l];if(f!==F)return f<F?-1:1}return 0}function b(k,r){let l=(0,g.$eq)(k.resourceUri.fsPath,r.resourceUri.fsPath,!0);if(l!==0)return l;if(k.command&&r.command)l=E(k.command,r.command);else{if(k.command)return 1;if(r.command)return-1}if(l!==0)return l;if(k.decorations&&r.decorations)l=m(k.decorations,r.decorations);else{if(k.decorations)return 1;if(r.decorations)return-1}return l}function n(k,r){for(let l=0;l<k.length;l++)if(k[l]!==r[l])return!1;return!0}function a(k,r){return k.command===r.command&&k.title===r.title&&k.tooltip===r.tooltip&&(k.arguments&&r.arguments?n(k.arguments,r.arguments):k.arguments===r.arguments)}function s(k,r){return(0,S.$of)(k,r,a)}class o{#e;#t;get value(){return this.d}set value(r){r=r??"",this.#e.$setInputBoxValue(this.l,r),this.n(r)}get onDidChange(){return this.e.event}get placeholder(){return this.f}set placeholder(r){this.#e.$setInputBoxPlaceholder(this.l,r),this.f=r}get validateInput(){return(0,$.$MF)(this.k,"scmValidation"),this.g}set validateInput(r){if((0,$.$MF)(this.k,"scmValidation"),r&&typeof r!="function")throw new Error(`[${this.k.identifier.value}]: Invalid SCM input box validation function`);this.g=r,this.#e.$setValidationProviderIsEnabled(this.l,!!r)}get enabled(){return this.h}set enabled(r){r=!!r,this.h!==r&&(this.h=r,this.#e.$setInputBoxEnablement(this.l,r))}get visible(){return this.j}set visible(r){r=!!r,this.j!==r&&(this.j=r,this.#e.$setInputBoxVisibility(this.l,r))}get document(){return(0,$.$MF)(this.k,"scmTextDocument"),this.#t.getDocument(this.m)}constructor(r,l,f,F,W){this.k=r,this.l=F,this.m=W,this.d="",this.e=new R.$hc,this.f="",this.h=!0,this.j=!0,this.#t=l,this.#e=f}showValidationMessage(r,l){(0,$.$MF)(this.k,"scmValidation"),this.#e.$showValidationMessage(this.l,r,l)}$onInputBoxValueChange(r){this.n(r)}n(r){this.d=r,this.e.fire(r)}}e.$qbc=o;class w{static{this.d=0}get disposed(){return this.l}get id(){return this.u}get label(){return this.v}set label(r){this.v=r,this.q.$updateGroupLabel(this.t,this.handle,r)}get hideWhenEmpty(){return this.p}set hideWhenEmpty(r){this.p=r,this.q.$updateGroup(this.t,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this.f]}set resourceStates(r){this.f=[...r],this.k.fire()}constructor(r,l,f,F,W){this.q=r,this.s=l,this.t=f,this.u=F,this.v=W,this.e=0,this.f=[],this.g=new Map,this.h=new Map,this.j=new Map,this.k=new R.$hc,this.onDidUpdateResourceStates=this.k.event,this.l=!1,this.m=new R.$hc,this.onDidDispose=this.m.event,this.n=[],this.o=[],this.p=void 0,this.handle=w.d++}getResourceState(r){return this.g.get(r)}$executeResourceCommand(r,l){const f=this.h.get(r);return f?(0,A.$xg)(()=>this.s.executeCommand(f.command,...f.arguments||[],l)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const r=[...this.f].sort(b),f=(0,S.$wf)(this.o,r,b).map(V=>{const B=V.toInsert.map(j=>{const U=this.e++;this.g.set(U,j);const z=j.resourceUri;let ie;if(j.command)if(j.command.command==="vscode.open"||j.command.command==="vscode.diff"){const ue=new L.$lb;ie=this.s.converter.toInternal(j.command,ue),this.j.set(U,ue)}else this.h.set(U,j.command);const Y=i(j.decorations),ye=j.decorations&&i(j.decorations.light)||Y,ke=j.decorations&&i(j.decorations.dark)||Y,Re=[ye,ke],X=j.decorations&&j.decorations.tooltip||"",le=j.decorations&&!!j.decorations.strikeThrough,we=j.decorations&&!!j.decorations.faded,ae=j.contextValue||"";return{rawResource:[U,z,Re,X,le,we,ae,ie],handle:U}});return{start:V.start,deleteCount:V.deleteCount,toInsert:B}}),F=f.map(({start:V,deleteCount:B,toInsert:j})=>[V,B,j.map(U=>U.rawResource)]),W=f.reverse();for(const{start:V,deleteCount:B,toInsert:j}of W){const U=j.map(ie=>ie.handle),z=this.n.splice(V,B,...U);for(const ie of z)this.g.delete(ie),this.h.delete(ie),this.j.get(ie)?.dispose(),this.j.delete(ie)}return this.o=r,F}dispose(){this.l=!0,this.m.fire()}}class v{static{this.d=0}#e;get id(){return this.w}get label(){return this.x}get rootUri(){return this.y}get inputBox(){return this.f}get count(){return this.g}set count(r){this.g!==r&&(this.g=r,this.#e.$updateSourceControl(this.t,{count:r}))}get quickDiffProvider(){return this.h}set quickDiffProvider(r){this.h=r;let l;(0,$.$LF)(this.u,"quickDiffProvider")&&(l=r?.label),this.#e.$updateSourceControl(this.t,{hasQuickDiffProvider:!!r,quickDiffLabel:l})}get commitTemplate(){return this.j}set commitTemplate(r){r!==this.j&&(this.j=r,this.#e.$updateSourceControl(this.t,{commitTemplate:r}))}get acceptInputCommand(){return this.l}set acceptInputCommand(r){this.k.value=new L.$lb,this.l=r;const l=this.v.converter.toInternal(r,this.k.value);this.#e.$updateSourceControl(this.t,{acceptInputCommand:l})}get actionButton(){return(0,$.$MF)(this.u,"scmActionButton"),this.n}set actionButton(r){(0,$.$MF)(this.u,"scmActionButton"),this.m.value=new L.$lb,this.n=r;const l=r!==void 0?{command:this.v.converter.toInternal(r.command,this.m.value),secondaryCommands:r.secondaryCommands?.map(f=>f.map(F=>this.v.converter.toInternal(F,this.m.value))),description:r.description,enabled:r.enabled}:void 0;this.#e.$updateSourceControl(this.t,{actionButton:l??null})}get statusBarCommands(){return this.p}set statusBarCommands(r){if(this.p&&r&&s(this.p,r))return;this.o.value=new L.$lb,this.p=r;const l=(r||[]).map(f=>this.v.converter.toInternal(f,this.o.value));this.#e.$updateSourceControl(this.t,{statusBarCommands:l})}get selected(){return this.q}constructor(r,l,f,F,W,V,B){this.u=r,this.v=F,this.w=W,this.x=V,this.y=B,this.e=new Map,this.g=void 0,this.h=void 0,this.j=void 0,this.k=new L.$nb,this.l=void 0,this.m=new L.$nb,this.o=new L.$nb,this.p=void 0,this.q=!1,this.s=new R.$hc,this.onDidChangeSelection=this.s.event,this.t=v.d++,this.z=new Map,this.A=new Set,this.#e=f;const j=y.URI.from({scheme:d.Schemas.vscodeSourceControl,path:`${W}/scm${this.t}/input`,query:B?`rootUri=${encodeURIComponent(B.toString())}`:void 0});this.f=new o(r,l,this.#e,this.t,j),this.#e.$registerSourceControl(this.t,W,V,B,j)}createResourceGroup(r,l){const f=new w(this.#e,this.v,this.t,r,l),F=R.Event.once(f.onDidDispose)(()=>this.z.delete(f));return this.z.set(f,F),this.eventuallyAddResourceGroups(),f}eventuallyAddResourceGroups(){const r=[],l=[];for(const[f,F]of this.z){F.dispose();const W=f.onDidUpdateResourceStates(()=>{this.A.add(f),this.eventuallyUpdateResourceStates()});R.Event.once(f.onDidDispose)(()=>{this.A.delete(f),W.dispose(),this.e.delete(f.handle),this.#e.$unregisterGroup(this.t,f.handle)}),r.push([f.handle,f.id,f.label,f.features]);const V=f._takeResourceStateSnapshot();V.length>0&&l.push([f.handle,V]),this.e.set(f.handle,f)}this.#e.$registerGroups(this.t,r,l),this.z.clear()}eventuallyUpdateResourceStates(){const r=[];this.A.forEach(l=>{const f=l._takeResourceStateSnapshot();f.length!==0&&r.push([l.handle,f])}),r.length>0&&this.#e.$spliceResourceStates(this.t,r),this.A.clear()}getResourceGroup(r){return this.e.get(r)}setSelectionState(r){this.q=r,this.s.fire(r)}dispose(){this.k.dispose(),this.m.dispose(),this.o.dispose(),this.e.forEach(r=>r.dispose()),this.#e.$unregisterSourceControl(this.t)}}Ke([(0,C.$5g)(100)],v.prototype,"eventuallyAddResourceGroups",null),Ke([(0,C.$5g)(100)],v.prototype,"eventuallyUpdateResourceStates",null);let I=class{static{t=this}static{this.d=0}get onDidChangeActiveProvider(){return this.j.event}constructor(r,l,f,F){this.l=l,this.m=f,this.n=F,this.g=new Map,this.h=new D.$Vl,this.j=new R.$hc,this.e=r.getProxy(h.$SJ.MainThreadSCM),this.f=r.getProxy(h.$SJ.MainThreadTelemetry),l.registerArgumentProcessor({processArgument:W=>{if(W&&W.$mid===3){const V=this.g.get(W.sourceControlHandle);if(!V)return W;const B=V.getResourceGroup(W.groupHandle);return B?B.getResourceState(W.handle):W}else if(W&&W.$mid===4){const V=this.g.get(W.sourceControlHandle);return V?V.getResourceGroup(W.groupHandle):W}else if(W&&W.$mid===5){const V=this.g.get(W.handle);return V||W}return W}})}createSourceControl(r,l,f,F){this.n.trace("ExtHostSCM#createSourceControl",r.identifier.value,l,f,F),this.f.$publicLog2("api/scm/createSourceControl",{extensionId:r.identifier.value});const W=t.d++,V=new v(r,this.m,this.e,this.l,l,f,F);this.g.set(W,V);const B=this.h.get(r.identifier)||[];return B.push(V),this.h.set(r.identifier,B),V}getLastInputBox(r){this.n.trace("ExtHostSCM#getLastInputBox",r.identifier.value);const l=this.h.get(r.identifier),f=l&&l[l.length-1];return f&&f.inputBox}$provideOriginalResource(r,l,f){const F=y.URI.revive(l);this.n.trace("ExtHostSCM#$provideOriginalResource",r,F.toString());const W=this.g.get(r);return!W||!W.quickDiffProvider||!W.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,A.$xg)(()=>W.quickDiffProvider.provideOriginalResource(F,f)).then(V=>V||null)}$onInputBoxValueChange(r,l){this.n.trace("ExtHostSCM#$onInputBoxValueChange",r);const f=this.g.get(r);return f&&f.inputBox.$onInputBoxValueChange(l),Promise.resolve(void 0)}$executeResourceCommand(r,l,f,F){this.n.trace("ExtHostSCM#$executeResourceCommand",r,l,f);const W=this.g.get(r);if(!W)return Promise.resolve(void 0);const V=W.getResourceGroup(l);return V?V.$executeResourceCommand(f,F):Promise.resolve(void 0)}$validateInput(r,l,f){this.n.trace("ExtHostSCM#$validateInput",r);const F=this.g.get(r);return!F||!F.inputBox.validateInput?Promise.resolve(void 0):(0,A.$xg)(()=>F.inputBox.validateInput(l,f)).then(W=>{if(!W)return Promise.resolve(void 0);const V=p.MarkdownString.fromStrict(W.message);return V?Promise.resolve([V,W.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(r){return this.n.trace("ExtHostSCM#$setSelectedSourceControl",r),r!==void 0&&this.g.get(r)?.setSelectionState(!0),this.k!==void 0&&this.g.get(this.k)?.setSelectionState(!1),this.k=r,Promise.resolve(void 0)}};e.$rbc=I,e.$rbc=I=t=Ke([Ve(3,P.$3i)],I)}),define(Pe[83],Ae([1,0,3,5,4]),function(pe,e,y,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0ac=e.$9ac=void 0;class L{constructor(h){this.b=new R.$hc,this.onDidChangePassword=this.b.event,this.a=h.getProxy(y.$SJ.MainThreadSecretState)}async $onDidChangePassword(h){this.b.fire(h)}get(h,S){return this.a.$getPassword(h,S)}store(h,S,g){return this.a.$setPassword(h,S,g)}delete(h,S){return this.a.$deletePassword(h,S)}}e.$9ac=L,e.$0ac=(0,C.$zh)("IExtHostSecretState")}),define(Pe[250],Ae([1,0,3,8,2]),function(pe,e,y,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tcc=void 0;class L{static{this.a=0}constructor(h,S){this.d=S,this.c=new Map,this.b=h.getProxy(y.$SJ.MainThreadShare)}async $provideShare(h,S,g){return await this.c.get(h)?.provideShare({selection:R.Range.to(S.selection),resourceUri:C.URI.revive(S.resourceUri)},g)??void 0}registerShareProvider(h,S){const g=L.a++;return this.c.set(g,S),this.b.$registerShareProvider(g,R.DocumentSelector.from(h,this.d),S.id,S.label,S.priority),{dispose:()=>{this.b.$unregisterShareProvider(g),this.c.delete(g)}}}}e.$tcc=L}),define(Pe[251],Ae([1,0,7,3,154,6,8,16]),function(pe,e,y,R,C,L,A,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tbc=e.$sbc=void 0;class S{static{this.a=0}static{this.b=new Map([["statusBarItem.errorBackground",new y.$QK("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new y.$QK("statusBarItem.warningForeground")]])}#e;#t;constructor(u,p,$,d,t,i=y.StatusBarAlignment.Left,c){if(this.i=!1,this.k="",this.q=new L.$lb,this.#e=u,this.#t=p,t&&d){this.c=(0,y.$tK)(d.identifier,t);const m=$.get(this.c);m&&(i=m.alignLeft?y.StatusBarAlignment.Left:y.StatusBarAlignment.Right,c=m.priority,this.j=!0,this.name=m.name,this.text=m.text,this.tooltip=m.tooltip,this.command=m.command,this.accessibilityInformation=m.accessibilityInformation)}else this.c=String(S.a++);this.e=d,this.f=t,this.g=i,this.h=this.u(c)}u(u){if((0,h.$pe)(u))return u===Number.POSITIVE_INFINITY?Number.MAX_VALUE:u===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:u}get id(){return this.f??this.e.identifier.value}get alignment(){return this.g}get priority(){return this.h}get text(){return this.k}get name(){return this.m}get tooltip(){return this.l}get color(){return this.n}get backgroundColor(){return this.o}get command(){return this.r?.fromApi}get accessibilityInformation(){return this.t}set text(u){this.k=u,this.v()}set name(u){this.m=u,this.v()}set tooltip(u){this.l=u,this.v()}set color(u){this.n=u,this.v()}set backgroundColor(u){u&&!S.b.has(u.id)&&(u=void 0),this.o=u,this.v()}set command(u){this.r?.fromApi!==u&&(this.p&&this.q.add(this.p),this.p=new L.$lb,typeof u=="string"?this.r={fromApi:u,internal:this.#t.toInternal({title:"",command:u},this.p)}:u?this.r={fromApi:u,internal:this.#t.toInternal(u,this.p)}:this.r=void 0,this.v())}set accessibilityInformation(u){this.t=u,this.v()}show(){this.j=!0,this.v()}hide(){clearTimeout(this.s),this.j=!1,this.#e.$disposeEntry(this.c)}v(){this.i||!this.j||(clearTimeout(this.s),this.s=setTimeout(()=>{this.s=void 0;let u;this.e?this.f?u=`${this.e.identifier.value}.${this.f}`:u=this.e.identifier.value:u=this.f;let p;this.m?p=this.m:p=(0,C.localize)(0,null,this.e.displayName||this.e.name);let $=this.n;this.o&&($=S.b.get(this.o.id));const d=A.MarkdownString.fromStrict(this.l);this.#e.$setEntry(this.c,u,this.e?.identifier.value,p,this.k,d,this.r?.internal,$,this.o,this.g===y.StatusBarAlignment.Left,this.h,this.t),this.q.clear()},0))}dispose(){this.hide(),this.i=!0}}e.$sbc=S;class g{constructor(u){this.b=[],this.a=u.createStatusBarEntry(void 0,"status.extensionMessage",y.StatusBarAlignment.Left,Number.MIN_VALUE),this.a.name=(0,C.localize)(1,null)}dispose(){this.b.length=0,this.a.dispose()}setMessage(u){const p={message:u};return this.b.unshift(p),this.c(),new y.$UJ(()=>{const $=this.b.indexOf(p);$>=0&&(this.b.splice($,1),this.c())})}c(){this.b.length>0?(this.a.text=this.b[0].message,this.a.show()):this.a.hide()}}class P{constructor(u,p){this.e=new Map,this.a=u.getProxy(R.$SJ.MainThreadStatusBar),this.b=p,this.c=new g(this)}$acceptStaticEntries(u){for(const p of u)this.e.set(p.entryId,p)}createStatusBarEntry(u,p,$,d){return new S(this.a,this.b,this.e,u,p,$,d)}setStatusBarMessage(u,p){const $=this.c.setMessage(u);let d;return typeof p=="number"?d=setTimeout(()=>$.dispose(),p):typeof p<"u"&&p.then(()=>$.dispose(),()=>$.dispose()),new y.$UJ(()=>{$.dispose(),clearTimeout(d)})}}e.$tbc=P}),define(Pe[84],Ae([1,0,3,5,4]),function(pe,e,y,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xac=e.$Wac=void 0;class L{constructor(h,S){this.c=S,this.b=new R.$hc,this.onDidChangeStorage=this.b.event,this.a=h.getProxy(y.$SJ.MainThreadStorage)}registerExtensionStorageKeysToSync(h,S){this.a.$registerExtensionStorageKeysToSync(h,S)}async initializeExtensionStorage(h,S,g){const P=await this.a.$initializeExtensionStorage(h,S);let D;return P&&(D=this.d(h,S,P)),D||g}setValue(h,S,g){return this.a.$setValue(h,S,g)}$acceptValue(h,S,g){const P=this.d(h,S,g);P&&this.b.fire({shared:h,key:S,value:P})}d(h,S,g){try{return JSON.parse(g)}catch(P){this.c.error(`[extHostStorage] unexpected error parsing storage contents (extensionId: ${S}, global: ${h}): ${P}`)}}}e.$Wac=L,e.$Xac=(0,C.$zh)("IExtHostStorage")}),define(Pe[85],Ae([1,0,4,27,14,61,2]),function(pe,e,y,R,C,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4ac=e.$3ac=void 0,e.$3ac=(0,y.$zh)("IExtensionStoragePaths");let h=class{constructor(g,P,D){this.d=P,this.f=D,this.a=g.workspace??void 0,this.b=g.environment,this.whenReady=this.h().then(u=>this.c=u)}async g(g){return A.URI.joinPath(this.b.workspaceStorageHome,g)}async h(){if(!this.a)return Promise.resolve(void 0);const g=this.a.id,P=await this.g(g);try{return await this.f.value.stat(P),this.d.trace("[ExtHostStorage] storage dir already exists",P),P}catch{}try{return this.d.trace("[ExtHostStorage] creating dir and metadata-file",P),await this.f.value.createDirectory(P),await this.f.value.writeFile(A.URI.joinPath(P,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this.a.id,configuration:A.URI.revive(this.a.configuration)?.toString(),name:this.a.name},void 0,2))),P}catch(D){this.d.error("[ExtHostStorage]",D);return}}workspaceValue(g){if(this.c)return A.URI.joinPath(this.c,g.identifier.value)}globalValue(g){return A.URI.joinPath(this.b.globalStorageHome,g.identifier.value.toLowerCase())}onWillDeactivateAll(){}};e.$4ac=h,e.$4ac=h=Ke([Ve(0,R.$$L),Ve(1,C.$3i),Ve(2,L.$2ac)],h)}),define(Pe[62],Ae([1,0,5,3,4,2,17,6,7,156,9,182,21,36,183,40,13,8,31]),function(pe,e,y,R,C,L,A,h,S,g,P,D,u,p,$,d,t,i,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8ac=e.$7ac=e.$6ac=e.$5ac=void 0,e.$5ac=(0,C.$zh)("IExtHostTerminalService");class m{constructor(r,l,f,F){this.k=r,this._id=l,this.l=f,this.m=F,this.a=!1,this.i={isInteractedWith:!1},this.isOpen=!1,this.l=Object.freeze(this.l),this.b=new Promise(V=>this.f=V);const W=this;this.value={get name(){return W.m||""},get processId(){return W.b},get creationOptions(){return W.l},get exitStatus(){return W.h},get state(){return W.i},get selection(){return W.j},sendText(V,B=!0){W.o(),W.k.$sendText(W._id,V,B)},show(V){W.o(),W.k.$show(W._id,V)},hide(){W.o(),W.k.$hide(W._id)},dispose(){W.a||(W.a=!0,W.k.$dispose(W._id))},get dimensions(){if(!(W.d===void 0||W.g===void 0))return{columns:W.d,rows:W.g}}}}async create(r,l){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this.k.$createTerminal(this._id,{name:r.name,shellPath:r.shellPath??void 0,shellArgs:r.shellArgs??void 0,cwd:r.cwd??void 0,env:r.env??void 0,icon:w(r.iconPath)??void 0,color:d.ThemeColor.isThemeColor(r.color)?r.color.id:void 0,initialText:r.message??void 0,strictEnv:r.strictEnv??void 0,hideFromUser:r.hideFromUser??void 0,isFeatureTerminal:l?.isFeatureTerminal??void 0,isExtensionOwnedTerminal:!0,useShellEnvironment:l?.useShellEnvironment??void 0,location:l?.location||this.n(r.location,l?.resolvedExtHostIdentifier),isTransient:r.isTransient??void 0})}async createExtensionTerminal(r,l,f,F){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this.k.$createTerminal(this._id,{name:this.m,isExtensionCustomPtyTerminal:!0,icon:f,color:d.ThemeColor.isThemeColor(F)?F.id:void 0,location:this.n(r,l),isTransient:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}n(r,l){return typeof r=="object"?"parentTerminal"in r&&r.parentTerminal&&l?{parentTerminal:l}:"viewColumn"in r?{viewColumn:i.ViewColumn.from(r.viewColumn),preserveFocus:r.preserveFocus}:void 0:r}o(){if(this.a)throw new Error("Terminal has already been disposed")}set name(r){this.m=r}setExitStatus(r,l){this.h=Object.freeze({code:r,reason:l})}setDimensions(r,l){return r===this.d&&l===this.g||r===0||l===0?!1:(this.d=r,this.g=l,!0)}setInteractedWith(){return this.i.isInteractedWith?!1:(this.i={isInteractedWith:!0},!0)}setSelection(r){this.j=r}_setProcessId(r){this.f?(this.f(r),this.f=void 0):this.b.then(l=>{l!==r&&(this.b=Promise.resolve(r))})}}e.$6ac=m;class E{get onProcessReady(){return this.b.event}constructor(r){this.g=r,this.id=0,this.shouldPersist=!1,this.a=new y.$hc,this.onProcessData=this.a.event,this.b=new y.$hc,this.d=new y.$hc,this.onDidChangeProperty=this.d.event,this.f=new y.$hc,this.onProcessExit=this.f.event}refreshProperty(r){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${r}`)}updateProperty(r,l){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${r}, value: ${l}`)}async start(){}shutdown(){this.g.close()}input(r){this.g.handleInput?.(r)}resize(r,l){this.g.setDimensions?.({columns:r,rows:l})}clearBuffer(){}async processBinary(r){}acknowledgeDataEvent(r){}async setUnicodeVersion(r){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}startSendingEvents(r){this.g.onDidWrite(l=>this.a.fire(l)),this.g.onDidClose?.((l=void 0)=>{this.f.fire(l===void 0?void 0:l)}),this.g.onDidOverrideDimensions?.(l=>{l&&this.d.fire({type:"overrideDimensions",value:{cols:l.columns,rows:l.rows}})}),this.g.onDidChangeName?.(l=>{this.d.fire({type:"title",value:l})}),this.g.open(r||void 0),r&&this.g.setDimensions?.(r),this.b.fire({pid:-1,cwd:"",windowsPty:void 0})}}let b=1,n=class extends h.$mb{get activeTerminal(){return this.b?.value}get terminals(){return this.f.map(r=>r.value)}constructor(r,l,f){super(),this.M=l,this.f=[],this.g=new Map,this.h={},this.i={},this.j={},this.k=new Map,this.n=this.B(new h.$nb),this.u=new Set,this.v=new Map,this.w=new Map,this.y=new Map,this.z=new Map,this.C=new y.$hc,this.onDidCloseTerminal=this.C.event,this.D=new y.$hc,this.onDidOpenTerminal=this.D.event,this.F=new y.$hc,this.onDidChangeActiveTerminal=this.F.event,this.G=new y.$hc,this.onDidChangeTerminalDimensions=this.G.event,this.H=new y.$hc,this.onDidChangeTerminalState=this.H.event,this.I=new y.$hc,this.onDidChangeShell=this.I.event,this.J=new y.$hc({onWillAddFirstListener:()=>this.a.$startSendingDataEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingDataEvents()}),this.onDidWriteTerminalData=this.J.event,this.L=new y.$hc({onWillAddFirstListener:()=>this.a.$startSendingCommandEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingCommandEvents()}),this.onDidExecuteTerminalCommand=this.L.event,this.a=f.getProxy(R.$SJ.MainThreadTerminalService),this.s=new $.$tkb(this.a.$sendProcessData),this.a.$registerProcessSupport(r),this.B({dispose:()=>{for(const[F,W]of this.g)W.shutdown(!0)}})}getDefaultShell(r){return(r?this.m:this.l)?.path||""}getDefaultShellArgs(r){return(r?this.m:this.l)?.args||[]}createExtensionTerminal(r,l){const f=new m(this.a,(0,p.$6e)(),r,r.name),F=new E(r.pty);return f.createExtensionTerminal(r.location,this.N(r,l).resolvedExtHostIdentifier,w(r.iconPath),v(r.color)).then(W=>{const V=this.O(W,F);this.h[W]=V}),this.f.push(f),f.value}N(r,l){if(l=l||{},r.location&&typeof r.location=="object"&&"parentTerminal"in r.location){const f=r.location.parentTerminal;if(f){const F=this.f.find(W=>W.value===f);F&&(l.resolvedExtHostIdentifier=F._id)}}else r.location&&typeof r.location!="object"?l.location=r.location:l.location&&typeof l.location=="object"&&"splitActiveTerminal"in l.location&&(l.location={splitActiveTerminal:!0});return l}attachPtyToTerminal(r,l){if(!this.Q(r))throw new Error(`Cannot resolve terminal with id ${r} for virtual process`);const F=new E(l),W=this.O(r,F);this.h[r]=W}async $acceptActiveTerminalChanged(r){const l=this.b;if(r===null){this.b=void 0,l!==this.b&&this.F.fire(this.b);return}const f=this.Q(r);f&&(this.b=f,l!==this.b&&this.F.fire(this.b.value))}async $acceptTerminalProcessData(r,l){const f=this.Q(r);f&&this.J.fire({terminal:f.value,data:l})}async $acceptTerminalDimensions(r,l,f){const F=this.Q(r);F&&F.setDimensions(l,f)&&this.G.fire({terminal:F.value,dimensions:F.value.dimensions})}async $acceptDidExecuteCommand(r,l){const f=this.Q(r);f&&this.L.fire({terminal:f.value,...l})}async $acceptTerminalMaximumDimensions(r,l,f){this.g.get(r)?.resize(l,f)}async $acceptTerminalTitleChange(r,l){const f=this.Q(r);f&&(f.name=l)}async $acceptTerminalClosed(r,l,f){const F=this.S(this.f,r);if(F!==null){const W=this.f.splice(F,1)[0];W.setExitStatus(l,f),this.C.fire(W.value)}}$acceptTerminalOpened(r,l,f,F){if(l){const B=this.S(this.f,l);if(B!==null){this.f[B]._id=r,this.D.fire(this.terminals[B]),this.f[B].isOpen=!0;return}}const W={name:F.name,shellPath:F.executable,shellArgs:F.args,cwd:typeof F.cwd=="string"?F.cwd:L.URI.revive(F.cwd),env:F.env,hideFromUser:F.hideFromUser},V=new m(this.a,r,W,f);this.f.push(V),this.D.fire(V.value),V.isOpen=!0}async $acceptTerminalProcessId(r,l){this.Q(r)?._setProcessId(l)}async $startExtensionTerminal(r,l){const f=this.Q(r);if(!f)return{message:(0,g.localize)(0,null,r)};f.isOpen||await new Promise(W=>{const V=this.onDidOpenTerminal(async B=>{B===f.value&&(V.dispose(),W())})});const F=this.g.get(r);F?F.startSendingEvents(l):this.i[r]={initialDimensions:l}}O(r,l){const f=new h.$lb;f.add(l.onProcessReady(W=>this.a.$sendProcessReady(r,W.pid,W.cwd,W.windowsPty))),f.add(l.onDidChangeProperty(W=>this.a.$sendProcessProperty(r,W))),this.s.startBuffering(r,l.onProcessData),f.add(l.onProcessExit(W=>this.P(r,W))),this.g.set(r,l);const F=this.i[r];return F&&l instanceof E&&(l.startSendingEvents(F.initialDimensions),delete this.i[r]),f}$acceptProcessAckDataEvent(r,l){this.g.get(r)?.acknowledgeDataEvent(l)}$acceptProcessInput(r,l){this.g.get(r)?.input(l)}$acceptTerminalInteraction(r){const l=this.Q(r);l?.setInteractedWith()&&this.H.fire(l.value)}$acceptTerminalSelection(r,l){this.Q(r)?.setSelection(l)}$acceptProcessResize(r,l,f){try{this.g.get(r)?.resize(l,f)}catch(F){if(F.code!=="EPIPE"&&F.code!=="ERR_IPC_CHANNEL_CLOSED")throw F}}$acceptProcessShutdown(r,l){this.g.get(r)?.shutdown(l)}$acceptProcessRequestInitialCwd(r){this.g.get(r)?.getInitialCwd().then(l=>this.a.$sendProcessProperty(r,{type:"initialCwd",value:l}))}$acceptProcessRequestCwd(r){this.g.get(r)?.getCwd().then(l=>this.a.$sendProcessProperty(r,{type:"cwd",value:l}))}$acceptProcessRequestLatency(r){return Promise.resolve(r)}registerLinkProvider(r){return this.u.add(r),this.u.size===1&&this.a.$startLinkProvider(),new S.$UJ(()=>{this.u.delete(r),this.u.size===0&&this.a.$stopLinkProvider()})}registerProfileProvider(r,l,f){if(this.v.has(l))throw new Error(`Terminal profile provider "${l}" already registered`);return this.v.set(l,f),this.a.$registerProfileProvider(l,r.identifier.value),new S.$UJ(()=>{this.v.delete(l),this.a.$unregisterProfileProvider(l)})}registerTerminalQuickFixProvider(r,l,f){if(this.w.has(r))throw new Error(`Terminal quick fix provider "${r}" is already registered`);return this.w.set(r,f),this.a.$registerQuickFixProvider(r,l),new S.$UJ(()=>{this.w.delete(r),this.a.$unregisterQuickFixProvider(r)})}async $provideTerminalQuickFixes(r,l){const f=new u.$rc().token;if(f.isCancellationRequested)return;const F=this.w.get(r);if(!F)return;const W=await F.provideTerminalQuickFixes(l,f);if(W===null||Array.isArray(W)&&W.length===0)return;const V=new h.$lb;if(this.n.value=V,!Array.isArray(W))return W?i.TerminalQuickFix.from(W,this.M.converter,V):void 0;const B=[];for(const j of W){const U=i.TerminalQuickFix.from(j,this.M.converter,V);U&&B.push(U)}return B}async $createContributedProfileTerminal(r,l){const f=new u.$rc().token;let F=await this.v.get(r)?.provideTerminalProfile(f);if(!f.isCancellationRequested){if(F&&!("options"in F)&&(F={options:F}),!F||!("options"in F))throw new Error(`No terminal profile options provided for id "${r}"`);if("pty"in F.options){this.createExtensionTerminal(F.options,l);return}this.createTerminalFromOptions(F.options,l)}}async $provideLinks(r,l){const f=this.Q(r);if(!f)return[];this.y.delete(r),this.z.get(r)?.dispose(!0);const W=new u.$rc;this.z.set(r,W);const V=[],B={terminal:f.value,line:l},j=[];for(const ie of this.u)j.push(t.Promises.withAsyncBody(async Y=>{W.token.onCancellationRequested(()=>Y({provider:ie,links:[]}));const ye=await ie.provideTerminalLinks(B,W.token)||[];W.token.isCancellationRequested||Y({provider:ie,links:ye})}));const U=await Promise.all(j);if(W.token.isCancellationRequested)return[];const z=new Map;for(const ie of U)ie&&ie.links.length>0&&V.push(...ie.links.map(Y=>{const ye={id:b++,startIndex:Y.startIndex,length:Y.length,label:Y.tooltip};return z.set(ye.id,{provider:ie.provider,link:Y}),ye}));return this.y.set(r,z),V}$activateLink(r,l){const f=this.y.get(r)?.get(l);f&&f.provider.handleTerminalLink(f.link)}P(r,l){this.s.stopBuffering(r),this.g.delete(r),delete this.i[r];const f=this.h[r];f&&(f.dispose(),delete this.h[r]),this.a.$sendProcessExit(r,l)}Q(r){return this.R(this.f,r)}R(r,l){const f=this.S(r,l);return f!==null?r[f]:null}S(r,l){const f=r.findIndex(F=>F._id===l);return f===-1?null:f}getEnvironmentVariableCollection(r){let l=this.k.get(r.identifier.value);return l||(l=new a,this.W(r.identifier.value,l)),l.getScopedEnvironmentVariableCollection(void 0)}U(r,l){const f=(0,D.$0q)(l.map),F=(0,D.$$q)(l.descriptionMap);this.a.$setEnvironmentVariableCollection(r,l.persistent,f.length===0?void 0:f,F)}$initEnvironmentVariableCollections(r){r.forEach(l=>{const f=l[0],F=new a(l[1]);this.W(f,F)})}$acceptDefaultProfile(r,l){const f=this.l;this.l=r,this.m=l,f?.path!==r.path&&this.I.fire(r.path)}W(r,l){this.k.set(r,l),l.onDidChangeCollection(()=>{this.U(r,l)})}};e.$7ac=n,e.$7ac=n=Ke([Ve(1,c.$eM),Ve(2,A.$UL)],n);class a{get persistent(){return this.b}set persistent(r){this.b=r,this.d.fire()}get onDidChangeCollection(){return this.d&&this.d.event}constructor(r){this.map=new Map,this.a=new Map,this.descriptionMap=new Map,this.b=!0,this.d=new y.$hc,this.map=new Map(r)}getScopedEnvironmentVariableCollection(r){const l=this.h(r);let f=this.a.get(l);return f||(f=new s(this,r),this.a.set(l,f),f.onDidChangeCollection(()=>this.d.fire())),f}replace(r,l,f,F){this.f(r,{value:l,type:S.EnvironmentVariableMutatorType.Replace,options:f??{applyAtProcessCreation:!0},scope:F})}append(r,l,f,F){this.f(r,{value:l,type:S.EnvironmentVariableMutatorType.Append,options:f??{applyAtProcessCreation:!0},scope:F})}prepend(r,l,f,F){this.f(r,{value:l,type:S.EnvironmentVariableMutatorType.Prepend,options:f??{applyAtProcessCreation:!0},scope:F})}f(r,l){if(l.options&&l.options.applyAtProcessCreation===!1&&!l.options.applyAtShellIntegration)throw new Error("EnvironmentVariableMutatorOptions must apply at either process creation or shell integration");const f=this.g(r,l.scope),F=this.map.get(f),W=l.options?{applyAtProcessCreation:l.options.applyAtProcessCreation??!1,applyAtShellIntegration:l.options.applyAtShellIntegration??!1}:{applyAtProcessCreation:!0};if(!F||F.value!==l.value||F.type!==l.type||F.options?.applyAtProcessCreation!==W.applyAtProcessCreation||F.options?.applyAtShellIntegration!==W.applyAtShellIntegration||F.scope?.workspaceFolder?.index!==l.scope?.workspaceFolder?.index){const V=this.g(r,l.scope),B={variable:r,...l,options:W};this.map.set(V,B),this.d.fire()}}get(r,l){const f=this.g(r,l),F=this.map.get(f);return F?I(F):void 0}g(r,l){const f=this.h(l);return f.length?`${r}:::${f}`:r}h(r){return this.i(r?.workspaceFolder)??""}i(r){return r?r.uri.toString():void 0}getVariableMap(r){const l=new Map;for(const[f,F]of this.map)this.h(F.scope)===this.h(r)&&l.set(F.variable,I(F));return l}delete(r,l){const f=this.g(r,l);this.map.delete(f),this.d.fire()}clear(r){if(r?.workspaceFolder){for(const[l,f]of this.map)f.scope?.workspaceFolder?.index===r.workspaceFolder.index&&this.map.delete(l);this.j(r)}else this.map.clear(),this.descriptionMap.clear();this.d.fire()}setDescription(r,l){const f=this.h(l),F=this.descriptionMap.get(f);if(!F||F.description!==r){let W;typeof r=="string"?W=r:W=r?.value.split(`

`)[0];const V={description:W,scope:l};this.descriptionMap.set(f,V),this.d.fire()}}getDescription(r){const l=this.h(r);return this.descriptionMap.get(l)?.description}j(r){const l=this.h(r);this.descriptionMap.delete(l)}}class s{get persistent(){return this.b.persistent}set persistent(r){this.b.persistent=r}get onDidChangeCollection(){return this.a&&this.a.event}constructor(r,l){this.b=r,this.d=l,this.a=new y.$hc}getScoped(r){return this.b.getScopedEnvironmentVariableCollection(r)}replace(r,l,f){this.b.replace(r,l,f,this.d)}append(r,l,f){this.b.append(r,l,f,this.d)}prepend(r,l,f){this.b.prepend(r,l,f,this.d)}get(r){return this.b.get(r,this.d)}forEach(r,l){this.b.getVariableMap(this.d).forEach((f,F)=>r.call(l,F,f,this),this.d)}[Symbol.iterator](){return this.b.getVariableMap(this.d).entries()}delete(r){this.b.delete(r,this.d),this.a.fire(void 0)}clear(){this.b.clear(this.d)}set description(r){this.b.setDescription(r,this.d)}get description(){return this.b.getDescription(this.d)}}let o=class extends n{constructor(r,l){super(!1,r,l)}createTerminal(r,l,f){throw new P.$0}createTerminalFromOptions(r,l){throw new P.$0}};e.$8ac=o,e.$8ac=o=Ke([Ve(0,c.$eM),Ve(1,A.$UL)],o);function w(k){if(!(!k||typeof k=="string"))return"id"in k?{id:k.id,color:k.color}:k}function v(k){return d.ThemeColor.isThemeColor(k)?k:void 0}function I(k){const r={...k};return delete r.scope,r.options=r.options??void 0,delete r.variable,r}}),define(Pe[252],Ae([1,0,281,13,25,21,5,203,93,6,24,16,36,3,17,105,8,7,45,76,56,26]),function(pe,e,y,R,C,L,A,h,S,g,P,D,u,p,$,d,t,i,c,m,E,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fcc=e.$ecc=e.$dcc=e.$ccc=void 0;let n=class{constructor(B,j,U){this.k=U,this.d=new A.$hc,this.f=new Map,this.onResultsChanged=this.d.event,this.results=[],this.g=B.getProxy(p.$SJ.MainThreadTesting),this.j=new f(this.g),this.h=new w(this.g),j.registerArgumentProcessor({processArgument:z=>{switch(z?.$mid){case 15:{const ie=z,Y=ie.tests[ie.tests.length-1].item.extId;return this.f.get(c.$FI.root(Y))?.collection.tree.get(Y)?.actual??(0,d.$7L)(z)}case 17:{const{extId:ie,message:Y}=z;return{test:this.f.get(c.$FI.root(ie))?.collection.tree.get(ie)?.actual,message:t.TestMessage.to(Y)}}default:return z}}}),j.registerCommand(!1,"testing.getExplorerSelection",async()=>{const z=await j.executeCommand("_testing.getExplorerSelection"),ie=Y=>{const ye=this.f.get(c.$FI.root(Y));if(ye)return c.$FI.isRoot(Y)?ye.controller:ye.collection.tree.get(Y)?.actual};return{include:z?.include.map(ie).filter(D.$te)||[],exclude:z?.exclude.map(ie).filter(D.$te)||[]}})}createTestController(B,j,U,z){if(this.f.has(j))throw new Error(`Attempt to insert a duplicate controller with ID "${j}"`);const ie=new g.$lb,Y=ie.add(new d.$0L(j,U,this.k));Y.root.label=U;const ye=new Map,ke=this.g,Re={items:Y.root.children,get label(){return U},set label(le){U=le,Y.root.label=le,ke.$updateController(j,{label:U})},get refreshHandler(){return z},set refreshHandler(le){z=le,ke.$updateController(j,{canRefresh:!!le})},get id(){return j},createRunProfile:(le,we,ae,x,ue,O)=>{let J=(0,S.$ni)(le);for(;ye.has(J);)J++;return new F(this.g,ye,j,J,le,we,ae,x,ue,O)},createTestItem(le,we,ae){return new d.$8L(j,le,we,ae)},createTestRun:(le,we,ae=!0)=>this.h.createTestRun(B,j,Y,le,we,ae),invalidateTestResults:le=>{if(le===void 0)this.g.$markTestRetired(void 0);else{const we=le instanceof Array?le:[le];this.g.$markTestRetired(we.map(ae=>c.$FI.fromExtHostTestItem(ae,j).toString()))}},set resolveHandler(le){Y.resolveHandler=le},get resolveHandler(){return Y.resolveHandler},dispose:()=>{ie.dispose()}};ke.$registerTestController(j,U,!!z),ie.add((0,g.$kb)(()=>ke.$unregisterTestController(j)));const X={controller:Re,collection:Y,profiles:ye,extension:B};return this.f.set(j,X),ie.add((0,g.$kb)(()=>this.f.delete(j))),ie.add(Y.onDidGenerateDiff(le=>ke.$publishDiff(j,le.map(E.TestsDiffOp.serialize)))),Re}createTestObserver(){return this.j.checkout()}async runTests(B,j=L.CancellationToken.None){const U=v(B);if(!U)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const z=this.f.get(U.controllerId);if(!z)throw new Error("Controller not found");await this.g.$runTests({isUiTriggered:!1,targets:[{testIds:B.include?.map(ie=>c.$FI.fromExtHostTestItem(ie,z.collection.root.id).toString())??[z.collection.root.id],profileGroup:W[U.kind],profileId:U.profileId,controllerId:U.controllerId}],exclude:B.exclude?.map(ie=>ie.id)},j)}$syncTests(){for(const{collection:B}of this.f.values())B.flushDiff();return Promise.resolve()}$provideFileCoverage(B,j,U){return(0,y.$lf)(this.h.trackers,ie=>ie.id===B?ie.getCoverage(j):void 0)?.provideFileCoverage(U)??Promise.resolve([])}$resolveFileCoverage(B,j,U,z){return(0,y.$lf)(this.h.trackers,Y=>Y.id===B?Y.getCoverage(j):void 0)?.resolveFileCoverage(U,z)??Promise.resolve([])}$configureRunProfile(B,j){this.f.get(B)?.profiles.get(j)?.configureHandler?.()}async $refreshTests(B,j){await this.f.get(B)?.controller.refreshHandler?.(j)}$publishTestResults(B){this.results=Object.freeze(B.map(j=>(0,P.$Um)(t.TestResults.to(j))).concat(this.results).sort((j,U)=>U.completedAt-j.completedAt).slice(0,32)),this.d.fire()}async $expandTest(B,j){const U=this.f.get(c.$FI.fromString(B).controllerId)?.collection;U&&(await U.expand(B,j<0?1/0:j),U.flushDiff())}$acceptDiff(B){this.j.applyDiff(B.map(E.TestsDiffOp.deserialize))}async $runControllerTests(B,j){return Promise.all(B.map(U=>this.l(U,!1,j)))}async $startContinuousRun(B,j){const U=new L.$rc(j),z=await Promise.all(B.map(ie=>this.l(ie,!0,U.token)));return!j.isCancellationRequested&&!z.some(ie=>ie.error)&&await new Promise(ie=>j.onCancellationRequested(ie)),U.dispose(!0),z}async l(B,j,U){const z=this.f.get(B.controllerId);if(!z)return{};const{collection:ie,profiles:Y,extension:ye}=z,ke=Y.get(B.profileId);if(!ke)return{};const Re=B.testIds.map(ae=>ie.tree.get(ae)).filter(D.$te),X=B.excludeExtIds.map(ae=>z.collection.tree.get(ae)).filter(D.$te).filter(ae=>Re.some(x=>x.fullId.compare(ae.fullId)===2));if(!Re.length)return{};const le=new i.$rL(Re.some(ae=>ae.actual instanceof d.$9L)?void 0:Re.map(ae=>ae.actual),X.map(ae=>ae.actual),ke,j),we=(0,E.$HI)(B)&&this.h.prepareForMainThreadTestRun(le,I.fromInternal(B,z.collection),ye,U);try{return await ke.runHandler(le,U),{}}catch(ae){return{error:String(ae)}}finally{we&&(we.hasRunningTasks&&!U.isCancellationRequested&&await A.Event.toPromise(we.onEnd),we.dispose())}}$cancelExtensionTestRun(B){B===void 0?this.h.cancelAllRuns():this.h.cancelRunById(B)}};e.$ccc=n,e.$ccc=n=Ke([Ve(0,$.$UL)],n);const a=1e4;var s;(function(V){V[V.Running=0]="Running",V[V.Cancelling=1]="Cancelling",V[V.Ended=2]="Ended"})(s||(s={}));class o extends g.$mb{get hasRunningTasks(){return this.g.size>0}get id(){return this.l.id}constructor(B,j,U,z){super(),this.l=B,this.m=j,this.p=U,this.f=0,this.g=new Map,this.h=new Set,this.k=this.B(new A.$hc),this.onEnd=this.k.event,this.j=this.B(new L.$rc(z));const ie=this.B(new R.$Qg(()=>this.s(),a));this.B(this.j.token.onCancellationRequested(()=>ie.schedule()))}cancel(){this.f===0?(this.j.cancel(),this.f=1):this.f===1&&this.s()}getCoverage(B){return this.g.get(B)?.coverage}createRun(B){const j=this.l.id,U=this.l.controllerId,z=(0,u.$6e)(),ie=new k(this.m,j,z),Y=X=>(le,...we)=>{if(ke){console.warn(`Setting the state of test "${le.id}" is a no-op after the run ends.`);return}this.l.isIncluded(le)&&(this.v(le),X(le,...we))},ye=(X,le)=>{const we=le instanceof Array?le.map(t.TestMessage.from):[t.TestMessage.from(le)];if(we.some(ae=>ae.contextValue!==void 0)&&(0,b.$MF)(this.p,"testMessageContextValue"),X.uri&&X.range){const ae={range:t.Range.from(X.range),uri:X.uri};for(const x of we)x.location=x.location||ae}this.m.$appendTestMessagesInRun(j,z,c.$FI.fromExtHostTestItem(X,U).toString(),we)};let ke=!1;const Re={isPersisted:this.l.isPersisted,token:this.j.token,name:B,get coverageProvider(){return ie.coverageProvider},set coverageProvider(X){ie.coverageProvider=X},enqueued:Y(X=>{this.m.$updateTestStateInRun(j,z,c.$FI.fromExtHostTestItem(X,U).toString(),1)}),skipped:Y(X=>{this.m.$updateTestStateInRun(j,z,c.$FI.fromExtHostTestItem(X,U).toString(),5)}),started:Y(X=>{this.m.$updateTestStateInRun(j,z,c.$FI.fromExtHostTestItem(X,U).toString(),2)}),errored:Y((X,le,we)=>{ye(X,le),this.m.$updateTestStateInRun(j,z,c.$FI.fromExtHostTestItem(X,U).toString(),6,we)}),failed:Y((X,le,we)=>{ye(X,le),this.m.$updateTestStateInRun(j,z,c.$FI.fromExtHostTestItem(X,U).toString(),4,we)}),passed:Y((X,le)=>{this.m.$updateTestStateInRun(j,z,c.$FI.fromExtHostTestItem(X,this.l.controllerId).toString(),3,le)}),appendOutput:(X,le,we)=>{ke||(we&&(this.l.isIncluded(we)?this.v(we):we=void 0),this.m.$appendOutputToRun(j,z,C.$Hc.fromString(X),le&&t.location.from(le),we&&c.$FI.fromExtHostTestItem(we,U).toString()))},end:()=>{ke||(ke=!0,this.m.$finishedTestRunTask(j,z),this.g.delete(z),this.g.size||this.u())}};return this.g.set(z,{run:Re,coverage:ie}),this.m.$startedTestRunTask(j,{id:z,name:B,running:!0}),Re}s(){for(const{run:B}of this.g.values())B.end()}u(){this.f!==2&&(this.f=2,this.k.fire())}v(B){if(!(B instanceof d.$8L))throw new m.$ML(B.id);if(this.h.has(c.$FI.fromExtHostTestItem(B,this.l.controllerId).toString()))return;const j=[],U=this.l.colllection.root;for(;;){const z=t.TestItem.from(B);if(j.unshift(z),this.h.has(z.extId)||(this.h.add(z.extId),B===U))break;B=B.parent||U}this.m.$addTestsToRun(this.l.controllerId,this.l.id,j)}dispose(){this.u(),super.dispose()}}class w{get trackers(){return this.d.values()}constructor(B){this.f=B,this.d=new Map}prepareForMainThreadTestRun(B,j,U,z){return this.g(B,j,U,z)}cancelRunById(B){for(const j of this.d.values())if(j.id===B){j.cancel();return}}cancelAllRuns(){for(const B of this.d.values())B.cancel()}createTestRun(B,j,U,z,ie,Y){const ye=this.d.get(z);if(ye)return ye.createRun(ie);const ke=I.fromPublic(j,U,z,Y),Re=v(z);this.f.$startedExtensionTestRun({controllerId:j,continuous:!!z.continuous,profile:Re&&{group:W[Re.kind],id:Re.profileId},exclude:z.exclude?.map(le=>c.$FI.fromExtHostTestItem(le,U.root.id).toString())??[],id:ke.id,include:z.include?.map(le=>c.$FI.fromExtHostTestItem(le,U.root.id).toString())??[U.root.id],persist:Y});const X=this.g(z,ke,B);return A.Event.once(X.onEnd)(()=>{this.f.$finishedExtensionTestRun(ke.id),X.dispose()}),X.createRun(ie)}g(B,j,U,z){const ie=new o(j,this.f,U,z);return this.d.set(B,ie),A.Event.once(ie.onEnd)(()=>this.d.delete(B)),ie}}e.$dcc=w;const v=V=>{if(V.profile){if(!(V.profile instanceof F))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return V.profile}};class I{static fromPublic(B,j,U,z){return new I(B,(0,u.$6e)(),U.include?.map(ie=>c.$FI.fromExtHostTestItem(ie,B).toString())??[B],U.exclude?.map(ie=>c.$FI.fromExtHostTestItem(ie,B).toString())??[],z,j)}static fromInternal(B,j){return new I(B.controllerId,B.runId,B.testIds,B.excludeExtIds,!0,j)}constructor(B,j,U,z,ie,Y){this.controllerId=B,this.id=j,this.isPersisted=ie,this.colllection=Y,this.d=U.map(ye=>ye+"\0"),this.f=z.map(ye=>ye+"\0")}isIncluded(B){const j=c.$FI.fromExtHostTestItem(B,this.controllerId).toString()+"\0";for(const U of this.f)if(j===U||j.startsWith(U))return!1;for(const U of this.d)if(j===U||j.startsWith(U))return!0;return!1}}e.$ecc=I;class k{set coverageProvider(B){if(this.d)throw new Error("The TestCoverageProvider cannot be replaced after being provided");B&&(this.d=B,this.g.$signalCoverageAvailable(this.h,this.j))}get coverageProvider(){return this.d}constructor(B,j,U){this.g=B,this.h=j,this.j=U}async provideFileCoverage(B){if(!this.d)return[];this.f||(this.f=(async()=>this.d.provideFileCoverage(B))());try{return(await this.f)?.map(t.TestCoverage.fromFile)??[]}catch(j){throw this.f=void 0,j}}async resolveFileCoverage(B,j){const U=await this.f;let z=U?.[B];return!this.d||!U||!z?[]:(z.detailedCoverage||(z=U[B]=await this.d.resolveFileCoverage?.(z,j)??z),z.detailedCoverage?.map(t.TestCoverage.fromDetailed)??[])}}class r{get isEmpty(){return this.d.size===0&&this.g.size===0&&this.f.size===0}constructor(B){this.j=B,this.d=new Set,this.f=new Set,this.g=new Set,this.h=new Set}add(B){this.d.add(B)}update(B){Object.assign(B.revived,t.TestItem.toPlain(B.item)),this.d.has(B)||this.f.add(B)}remove(B){if(this.d.has(B)){this.d.delete(B);return}this.f.delete(B);const j=c.$FI.parentId(B.item.extId);if(j&&this.h.has(j.toString())){this.h.add(B.item.extId);return}this.g.add(B)}getChangeEvent(){const{d:B,f:j,g:U}=this;return{get added(){return[...B].map(z=>z.revived)},get updated(){return[...j].map(z=>z.revived)},get removed(){return[...U].map(z=>z.revived)}}}complete(){this.isEmpty||this.j.fire(this.getChangeEvent())}}class l extends E.$MI{constructor(){super(...arguments),this.s=new A.$hc,this.onDidChangeTests=this.s.event}get rootTests(){return super.g}getMirroredTestDataById(B){return this.f.get(B)}getMirroredTestDataByReference(B){return this.f.get(B.id)}q(B,j){return{...B,revived:t.TestItem.toPlain(B.item),depth:j?j.depth+1:0,children:new Set}}p(){return new r(this.s)}}class f{constructor(B){this.f=B}checkout(){this.d||(this.d=this.g());const B=this.d;return B.observers++,{onDidChangeTest:B.tests.onDidChangeTests,get tests(){return[...B.tests.rootTests].map(j=>j.revived)},dispose:(0,h.$bb)(()=>{--B.observers===0&&(this.f.$unsubscribeFromDiffs(),this.d=void 0)})}}getMirroredTestDataByReference(B){return this.d?.tests.getMirroredTestDataByReference(B)}applyDiff(B){this.d?.tests.apply(B)}g(){const B=new l;return this.f.$subscribeToDiffs(),{observers:0,tests:B}}}class F{#e;#t;get label(){return this.f}set label(B){B!==this.f&&(this.f=B,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{label:B}))}get supportsContinuousRun(){return this.h}set supportsContinuousRun(B){B!==this.h&&(this.h=B,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{supportsContinuousRun:B}))}get isDefault(){return this.g}set isDefault(B){B!==this.g&&(this.g=B,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{isDefault:B}))}get tag(){return this._tag}set tag(B){B?.id!==this._tag?.id&&(this._tag=B,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{tag:B?t.TestTag.namespace(this.controllerId,B.id):null}))}get configureHandler(){return this.d}set configureHandler(B){B!==this.d&&(this.d=B,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{hasConfigurationHandler:!!B}))}constructor(B,j,U,z,ie,Y,ye,ke=!1,Re=void 0,X=!1){this.controllerId=U,this.profileId=z,this.f=ie,this.kind=Y,this.runHandler=ye,this.g=ke,this._tag=Re,this.h=X,this.#e=B,this.#t=j,j.set(z,this);const le=W[Y];if(typeof le!="number")throw new Error(`Unknown TestRunProfile.group ${Y}`);this.#e.$publishTestRunProfile({profileId:z,controllerId:U,tag:Re?t.TestTag.namespace(this.controllerId,Re.id):null,label:ie,group:le,isDefault:ke,hasConfigurationHandler:!1,supportsContinuousRun:X})}dispose(){this.#t?.delete(this.profileId)&&(this.#t=void 0,this.#e.$removeTestProfile(this.controllerId,this.profileId))}}e.$fcc=F;const W={[i.TestRunProfileKind.Coverage]:8,[i.TestRunProfileKind.Debug]:4,[i.TestRunProfileKind.Run]:2}}),define(Pe[253],Ae([1,0,18,9,5,3,106,8,7]),function(pe,e,y,R,C,L,A,h,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ubc=void 0;class g{constructor(D,u){this.i=u,this.a=new C.$hc({onListenerError:R.$Z}),this.b=new C.$hc({onListenerError:R.$Z}),this.c=new C.$hc({onListenerError:R.$Z}),this.d=new C.$hc({onListenerError:R.$Z}),this.f=new C.$hc({onListenerError:R.$Z}),this.g=new C.$hc({onListenerError:R.$Z}),this.onDidChangeTextEditorSelection=this.a.event,this.onDidChangeTextEditorOptions=this.b.event,this.onDidChangeTextEditorVisibleRanges=this.c.event,this.onDidChangeTextEditorViewColumn=this.d.event,this.onDidChangeActiveTextEditor=this.f.event,this.onDidChangeVisibleTextEditors=this.g.event,this.h=D.getProxy(L.$SJ.MainThreadTextEditors),this.i.onDidChangeVisibleTextEditors(p=>this.g.fire(p)),this.i.onDidChangeActiveTextEditor(p=>this.f.fire(p))}getActiveTextEditor(){return this.i.activeEditor()}getVisibleTextEditors(D){const u=this.i.allEditors();return D?u:u.map(p=>p.value)}async showTextDocument(D,u,p){let $;typeof u=="number"?$={position:h.ViewColumn.from(u),preserveFocus:p}:typeof u=="object"?$={position:h.ViewColumn.from(u.viewColumn),preserveFocus:u.preserveFocus,selection:typeof u.selection=="object"?h.Range.from(u.selection):void 0,pinned:typeof u.preview=="boolean"?!u.preview:void 0}:$={preserveFocus:!1};const d=await this.h.$tryShowTextDocument(D.uri,$),t=d&&this.i.getEditor(d);if(t)return t.value;throw d?new Error(`Could NOT open editor for "${D.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${D.uri.toString()}".`)}createTextEditorDecorationType(D,u){return new A.$2L(this.h,D,u).value}$acceptEditorPropertiesChanged(D,u){const p=this.i.getEditor(D);if(!p)throw new Error("unknown text editor");if(u.options&&p._acceptOptions(u.options),u.selections){const $=u.selections.selections.map(h.Selection.to);p._acceptSelections($)}if(u.visibleRanges){const $=y.$Af(u.visibleRanges.map(h.Range.to));p._acceptVisibleRanges($)}if(u.options&&this.b.fire({textEditor:p.value,options:{...u.options,lineNumbers:h.TextEditorLineNumbersStyle.to(u.options.lineNumbers)}}),u.selections){const $=S.TextEditorSelectionChangeKind.fromValue(u.selections.source),d=u.selections.selections.map(h.Selection.to);this.a.fire({textEditor:p.value,selections:d,kind:$})}if(u.visibleRanges){const $=y.$Af(u.visibleRanges.map(h.Range.to));this.c.fire({textEditor:p.value,visibleRanges:$})}}$acceptEditorPositionData(D){for(const u in D){const p=this.i.getEditor(u);if(!p)throw new Error("Unknown text editor");const $=h.ViewColumn.to(D[u]);p.value.viewColumn!==$&&(p._acceptViewColumn($),this.d.fire({textEditor:p.value,viewColumn:$}))}}getDiffInformation(D){return Promise.resolve(this.h.$getDiffInformation(D))}}e.$ubc=g}),define(Pe[254],Ae([1,0,2,4,3,6,7,8,20,16]),function(pe,e,y,R,C,L,A,h,S,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0bc=e.$9bc=void 0,e.$9bc=(0,R.$zh)("IExtHostTimeline");class P{constructor(p,$){this.b=new Map,this.c=new Map,this.a=p.getProxy(C.$SJ.MainThreadTimeline),$.registerArgumentProcessor({processArgument:(d,t)=>{if(d&&d.$mid===12)if(this.b.get(d.source)&&S.$Tl.equals(t,this.b.get(d.source)?.extension)){const i=d.uri===void 0?void 0:y.URI.revive(d.uri);return this.c.get(d.source)?.get(D(i))?.get(d.handle)}else return;return d}})}async $getTimeline(p,$,d,t){return this.b.get(p)?.provider.provideTimeline(y.URI.revive($),d,t)}registerTimelineProvider(p,$,d,t){const i=new L.$lb,c=this.d($.id,t,i).bind(this);let m;$.onDidChange&&(m=$.onDidChange(b=>this.a.$emitTimelineChangeEvent({uri:void 0,reset:!0,...b,id:$.id}),this));const E=this.c;return this.f({...$,scheme:p,onDidChange:void 0,async provideTimeline(b,n,a){n?.resetCache&&(i.clear(),E.get($.id)?.clear());const s=await $.provideTimeline(b,n,a);if(s==null)return;const o=c(b,n);return{...s,source:$.id,items:s.items.map(o)}},dispose(){for(const b of E.values())b.get($.id)?.clear();m?.dispose(),i.dispose()}},d)}d(p,$,d){return(t,i)=>{let c;if(i?.cacheResults){let m=this.c.get(p);m===void 0&&(m=new Map,this.c.set(p,m));const E=D(t);c=m.get(E),c===void 0&&(c=new Map,m.set(E,c))}return m=>{const{iconPath:E,...b}=m,n=`${p}|${m.id??m.timestamp}`;c?.set(n,m);let a,s,o;m.iconPath&&(E instanceof A.$PK?o={id:E.id,color:E.color}:y.URI.isUri(E)?(a=E,s=E):{light:a,dark:s}=E);let w;return A.$jK.isMarkdownString(b.tooltip)?w=h.MarkdownString.from(b.tooltip):(0,g.$le)(b.tooltip)?w=b.tooltip:A.$jK.isMarkdownString(b.detail)?(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),w=h.MarkdownString.from(b.detail)):(0,g.$le)(b.detail)&&(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),w=b.detail),{...b,id:b.id??void 0,handle:n,source:p,command:m.command?$.toInternal(m.command,d):void 0,icon:a,iconDark:s,themeIcon:o,tooltip:w,accessibilityInformation:m.accessibilityInformation}}}}f(p,$){if(this.b.get(p.id))throw new Error(`Timeline Provider ${p.id} already exists.`);return this.a.$registerTimelineProvider({id:p.id,label:p.label,scheme:p.scheme}),this.b.set(p.id,{provider:p,extension:$}),(0,L.$kb)(()=>{for(const t of this.c.values())t.get(p.id)?.clear();this.b.delete(p.id),this.a.$unregisterTimelineProvider(p.id),p.dispose()})}}e.$0bc=P;function D(u){return u?.toString()}}),define(Pe[86],Ae([1,0,21,5,6,158,4,14,185,3,27,17,7]),function(pe,e,y,R,C,L,A,h,S,g,P,D,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4rb=e.$3rb=e.TunnelDtoConverter=void 0;class p extends S.$2z{}var $;(function(t){function i(m){return{remoteAddress:m.remoteAddress,localAddress:m.localAddress,public:!!m.public,privacy:m.privacy??(m.public?S.TunnelPrivacyId.Public:S.TunnelPrivacyId.Private),protocol:m.protocol}}t.fromApiTunnel=i;function c(m){return{remoteAddress:{host:m.tunnelRemoteHost,port:m.tunnelRemotePort},localAddress:m.localAddress,public:m.privacy!==S.TunnelPrivacyId.ConstantPrivate&&m.privacy!==S.TunnelPrivacyId.ConstantPrivate,privacy:m.privacy,protocol:m.protocol}}t.fromServiceTunnel=c})($||(e.TunnelDtoConverter=$={})),e.$3rb=(0,A.$zh)("IExtHostTunnelService");let d=class extends C.$mb{constructor(i,c,m){super(),this.n=m,this.f=()=>Promise.resolve(!0),this.g=new Map,this.h=new R.$hc,this.onDidChangeTunnels=this.h.event,this.k=0,this.l=new Map,this.a=i.getProxy(g.$SJ.MainThreadTunnelService)}async openTunnel(i,c){this.n.trace(`ForwardedPorts: (ExtHostTunnelService) ${i.identifier.value} called openTunnel API for ${c.remoteAddress.host}:${c.remoteAddress.port}.`);const m=await this.a.$openTunnel(c,i.displayName);if(m){const E=new p(m.remoteAddress,m.localAddress,()=>this.a.$closeTunnel(m.remoteAddress));return this.B(E),E}}async getTunnels(){return this.a.$getTunnels()}p(){return this.k++}registerPortsAttributesProvider(i,c){const m=this.p();return this.l.set(m,{selector:i,provider:c}),this.a.$registerPortsAttributesProvider(i,m),new u.$UJ(()=>{this.l.delete(m),this.a.$unregisterPortsAttributesProvider(m)})}async $providePortAttributes(i,c,m,E,b){const n=[];for(const s of i){const o=this.l.get(s);if(!o)return[];n.push(...await Promise.all(c.map(async w=>{let v;try{v=await o.provider.providePortAttributes({port:w,pid:m,commandLine:E},b)}catch{v=await o.provider.providePortAttributes(w,m,E,b)}return{providedAttributes:v,port:w}})))}const a=n.filter(s=>!!s.providedAttributes);return a.length>0?a.map(s=>({autoForwardAction:s.providedAttributes.autoForwardAction,port:s.port})):[]}async $registerCandidateFinder(i){}registerTunnelProvider(i,c){if(this.b)throw new Error("A tunnel provider has already been registered. Only the first tunnel provider to be registered will be used.");this.b=async(E,b)=>await i.provideTunnel(E,b,new y.$rc().token)??void 0;const m=c.tunnelFeatures?{elevation:!!c.tunnelFeatures?.elevation,privacyOptions:c.tunnelFeatures?.privacyOptions}:void 0;return this.a.$setTunnelProvider(m),Promise.resolve((0,C.$kb)(()=>{this.b=void 0,this.a.$setTunnelProvider(void 0)}))}async setTunnelFactory(i,c){if(i){i.candidatePortSource!==void 0&&this.a.$setCandidatePortSource(i.candidatePortSource),i.showCandidatePort&&(this.f=i.showCandidatePort,this.a.$setCandidateFilter());const m=i.tunnelFactory??(c?this.r(c):void 0);if(m){this.b=m;let E=i.tunnelFeatures?.privacyOptions??[];i.tunnelFeatures?.public&&E.length===0&&(E=[{id:"private",label:L.localize(0,null),themeIcon:"lock"},{id:"public",label:L.localize(1,null),themeIcon:"eye"}]);const b=i.tunnelFeatures?{elevation:!!i.tunnelFeatures?.elevation,public:!!i.tunnelFeatures?.public,privacyOptions:E}:void 0;this.a.$setTunnelProvider(b)}}else this.b=void 0;return(0,C.$kb)(()=>{this.b=void 0})}r(i){}async $closeTunnel(i,c){if(this.g.has(i.host)){const m=this.g.get(i.host);m.has(i.port)&&(c&&m.get(i.port).disposeListener.dispose(),await m.get(i.port).tunnel.dispose(),m.delete(i.port))}}async $onDidTunnelsChange(){this.h.fire()}async $forwardPort(i,c){if(this.b)try{this.n.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const m=this.b(i,c);if(this.n.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),m!==void 0){const E=await m;if(this.n.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),E===void 0){this.n.error("ForwardedPorts: (ExtHostTunnelService) Resolved tunnel is undefined");return}this.g.has(i.remoteAddress.host)||this.g.set(i.remoteAddress.host,new Map);const b=this.B(E.onDidDispose(()=>(this.n.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this.a.$closeTunnel(E.remoteAddress))));return this.g.get(i.remoteAddress.host).set(i.remoteAddress.port,{tunnel:E,disposeListener:b}),$.fromApiTunnel(E)}else this.n.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch(m){if(this.n.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error"),m instanceof Error)return m.message}}async $applyCandidateFilter(i){const c=await Promise.all(i.map(E=>this.f(E.host,E.port,E.detail??""))),m=i.filter((E,b)=>c[b]);return this.n.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${i.map(E=>E.port).join(", ")} to ${m.map(E=>E.port).join(", ")}`),m}};e.$4rb=d,e.$4rb=d=Ke([Ve(0,D.$UL),Ve(1,P.$$L),Ve(2,h.$3i)],d)}),define(Pe[255],Ae([1,0,6,12,2,3]),function(pe,e,y,R,C,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gcc=void 0;class A{static{this.a=new Set([R.Schemas.http,R.Schemas.https])}constructor(S){this.c=new Map,this.b=S.getProxy(L.$SJ.MainThreadUriOpeners)}registerExternalUriOpener(S,g,P,D){if(this.c.has(g))throw new Error(`Opener with id '${g}' already registered`);const u=D.schemes.find(p=>!A.a.has(p));if(u)throw new Error(`Scheme '${u}' is not supported. Only http and https are currently supported.`);return this.c.set(g,P),this.b.$registerUriOpener(g,D.schemes,S,D.label),(0,y.$kb)(()=>{this.c.delete(g),this.b.$unregisterUriOpener(g)})}async $canOpenUri(S,g,P){const D=this.c.get(S);if(!D)throw new Error(`Unknown opener with id: ${S}`);const u=C.URI.revive(g);return D.canOpenExternalUri(u,P)}async $openUri(S,g,P){const D=this.c.get(S);if(!D)throw new Error(`Unknown opener id: '${S}'`);return D.openExternalUri(C.URI.revive(g.resolvedUri),{sourceUri:C.URI.revive(g.sourceUri)},P)}}e.$gcc=A}),define(Pe[256],Ae([1,0,3,2,6,9,20]),function(pe,e,y,R,C,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wbc=void 0;class h{static{this.a=0}constructor(g){this.c=new A.$Ul,this.d=new Map,this.b=g.getProxy(y.$SJ.MainThreadUrls)}registerUriHandler(g,P){const D=g.identifier;if(this.c.has(D))throw new Error(`Protocol handler already registered for extension ${D}`);const u=h.a++;return this.c.add(D),this.d.set(u,P),this.b.$registerUriHandler(u,D,g.displayName||g.name),(0,C.$kb)(()=>{this.c.delete(D),this.d.delete(u),this.b.$unregisterUriHandler(u)})}$handleExternalUri(g,P){const D=this.d.get(g);if(!D)return Promise.resolve(void 0);try{D.handleUri(R.URI.revive(P))}catch(u){(0,L.$Y)(u)}return Promise.resolve(void 0)}async createAppUri(g){return R.URI.revive(await this.b.$createAppUri(g))}}e.$wbc=h}),define(Pe[63],Ae([1,0,5,6,12,24,2,170,192,77,3]),function(pe,e,y,R,C,L,A,h,S,g,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bbc=e.$Abc=e.$zbc=e.$ybc=e.$xbc=void 0;class D{#e;#t;#i;#l;#u;#n;#s;#r;#o;#a;#c;#d;constructor(E,b,n,a,s,o,w){this.#s="",this.#o=!1,this.#a=!1,this._onMessageEmitter=new y.$hc,this.onDidReceiveMessage=this._onMessageEmitter.event,this.#h=new y.$hc,this._onDidDispose=this.#h.event,this.#e=E,this.#t=b,this.#r=n,this.#l=a,this.#u=s,this.#n=o,this.#c=u(o),this.#d=p(o),this.#i=w}#h;dispose(){this.#o=!0,this.#h.fire(),this.#h.dispose(),this._onMessageEmitter.dispose()}asWebviewUri(E){return this.#a=!0,(0,g.$Aob)(E,this.#l)}get cspSource(){const E=this.#n.extensionLocation;if(E.scheme===C.Schemas.https||E.scheme===C.Schemas.http){let b=E.toString();return b.endsWith("/")||(b+="/"),b+" "+g.$zob}return g.$zob}get html(){return this.a(),this.#s}set html(E){this.a(),this.#s!==E&&(this.#s=E,this.#d&&!this.#a&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(E)&&(this.#a=!0,this.#i.report("Webview vscode-resource: uris",this.#n,"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),this.#t.$setHtml(this.#e,this.b(E)))}get options(){return this.a(),this.#r}set options(E){this.a(),L.$Xm(this.#r,E)||this.#t.$setOptions(this.#e,t(this.#n,this.#u,E)),this.#r=E}async postMessage(E){if(this.#o)return!1;const b=(0,S.$Obb)(E,{serializeBuffersForPostMessage:this.#c});return this.#t.$postMessage(this.#e,b.message,...b.buffers)}a(){if(this.#o)throw new Error("Webview is disposed")}b(E){if(!this.#d)return E;const b=this.#n.extensionLocation?.scheme===C.Schemas.vscodeRemote,n=this.#n.extensionLocation.scheme===C.Schemas.vscodeRemote?this.#n.extensionLocation.authority:void 0;return E.replace(/(["'])(?:vscode-resource):(\/\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(a,s,o,w,v,I)=>{const k=A.URI.from({scheme:w||"file",path:decodeURIComponent(v)}),r=(0,g.$Aob)(k,{isRemote:b,authority:n}).toString();return`${s}${r}${I}`}).replace(/(["'])(?:vscode-webview-resource):(\/\/[^\s\/'"]+\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(a,s,o,w,v,I)=>{const k=A.URI.from({scheme:w||"file",path:decodeURIComponent(v)}),r=(0,g.$Aob)(k,{isRemote:b,authority:n}).toString();return`${s}${r}${I}`})}}e.$xbc=D;function u(m){try{const E=(0,h.$Bo)((0,h.$Ao)(m.engines.vscode));return!!E&&E.majorBase>=1&&E.minorBase>=57}catch{return!1}}e.$ybc=u;function p(m){try{const E=(0,h.$Bo)((0,h.$Ao)(m.engines.vscode));return E?E.majorBase<1||E.majorBase===1&&E.minorBase<60:!1}catch{return!1}}class $ extends R.$mb{constructor(E,b,n,a,s){super(),this.c=b,this.f=n,this.g=a,this.h=s,this.b=new Map,this.a=E.getProxy(P.$SJ.MainThreadWebviews)}dispose(){super.dispose();for(const E of this.b.values())E.dispose();this.b.clear()}$onMessage(E,b,n){const a=this.i(E);if(a){const{message:s}=(0,S.$Pbb)(b,n.value);a._onMessageEmitter.fire(s)}}$onMissingCsp(E,b){this.g.warn(`${b} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(E,b,n){const a=new D(E,this.a,i(b),this.c,this.f,n,this.h);this.b.set(E,a);const s=a._onDidDispose(()=>{s.dispose(),this.deleteWebview(E)});return a}deleteWebview(E){this.b.delete(E)}i(E){return this.b.get(E)}}e.$zbc=$;function d(m){return{id:m.identifier,location:m.extensionLocation}}e.$Abc=d;function t(m,E,b){return{enableCommandUris:b.enableCommandUris,enableScripts:b.enableScripts,enableForms:b.enableForms,portMapping:b.portMapping,localResourceRoots:b.localResourceRoots||c(m,E)}}e.$Bbc=t;function i(m){return{enableCommandUris:m.enableCommandUris,enableScripts:m.enableScripts,enableForms:m.enableForms,portMapping:m.portMapping,localResourceRoots:m.localResourceRoots?.map(E=>A.URI.from(E))}}function c(m,E){return[...(E?.getWorkspaceFolders()||[]).map(b=>b.uri),m.extensionLocation]}}),define(Pe[257],Ae([1,0,21,93,6,12,23,2,8,63,54,3,7]),function(pe,e,y,R,C,L,A,h,S,g,P,D,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$acc=void 0;class p{constructor(a,s){this.document=a,this.b=s,this.a=1,this.c=new P.$tac("custom documents")}addEdit(a){return this.c.add([a])}async undo(a,s){await this.f(a).undo(),s||this.disposeBackup()}async redo(a,s){await this.f(a).redo(),s||this.disposeBackup()}disposeEdits(a){for(const s of a)this.c.delete(s)}getNewBackupUri(){if(!this.b)throw new Error("Backup requires a valid storage path");const a=b(this.document.uri)+this.a++;return(0,A.$gg)(this.b,a)}updateBackup(a){this.d?.delete(),this.d=a}disposeBackup(){this.d?.delete(),this.d=void 0}f(a){const s=this.c.get(a,0);if(!s)throw new Error("No edit found");return s}}class ${constructor(){this.a=new Map}get(a,s){return this.a.get(this.b(a,s))}add(a,s,o){const w=this.b(a,s.uri);if(this.a.has(w))throw new Error(`Document already exists for viewType:${a} resource:${s.uri}`);const v=new p(s,o);return this.a.set(w,v),v}delete(a,s){const o=this.b(a,s.uri);this.a.delete(o)}b(a,s){return`${a}@@@${s}`}}var d;(function(n){n[n.Text=0]="Text",n[n.Custom=1]="Custom"})(d||(d={}));class t{constructor(){this.a=new Map}addTextProvider(a,s,o){return this.b(0,a,s,o)}addCustomProvider(a,s,o){return this.b(1,a,s,o)}get(a){return this.a.get(a)}b(a,s,o,w){if(this.a.has(s))throw new Error(`Provider for viewType:${s} already registered`);return this.a.set(s,{type:a,extension:o,provider:w}),new u.$UJ(()=>this.a.delete(s))}}class i{constructor(a,s,o,w,v){this.d=s,this.f=o,this.g=w,this.h=v,this.b=new t,this.c=new $,this.a=a.getProxy(D.$SJ.MainThreadCustomEditors)}registerCustomEditorProvider(a,s,o,w){const v=new C.$lb;return m(o)?(v.add(this.b.addTextProvider(s,a,o)),this.a.$registerTextEditorProvider((0,g.$Abc)(a),s,w.webviewOptions||{},{supportsMove:!!o.moveCustomTextEditor},(0,g.$ybc)(a))):(v.add(this.b.addCustomProvider(s,a,o)),c(o)&&v.add(o.onDidChangeCustomDocument(I=>{const k=this.i(s,I.document.uri);if(E(I)){const r=k.addEdit(I);this.a.$onDidEdit(I.document.uri,s,r,I.label)}else this.a.$onContentChange(I.document.uri,s)})),this.a.$registerCustomEditorProvider((0,g.$Abc)(a),s,w.webviewOptions||{},!!w.supportsMultipleEditorsPerDocument,(0,g.$ybc)(a))),u.$UJ.from(v,new u.$UJ(()=>{this.a.$unregisterEditorProvider(s)}))}async $createCustomDocument(a,s,o,w,v){const I=this.b.get(s);if(!I)throw new Error(`No provider found for '${s}'`);if(I.type!==1)throw new Error(`Invalid provide type for '${s}'`);const k=h.URI.revive(a),r=await I.provider.openCustomDocument(k,{backupId:o,untitledDocumentData:w?.buffer},v);let l;return c(I.provider)&&this.f&&(l=this.f.workspaceValue(I.extension)??this.f.globalValue(I.extension)),this.c.add(s,r,l),{editable:c(I.provider)}}async $disposeCustomDocument(a,s){const o=this.b.get(s);if(!o)throw new Error(`No provider found for '${s}'`);if(o.type!==1)throw new Error(`Invalid provider type for '${s}'`);const w=h.URI.revive(a),{document:v}=this.i(s,w);this.c.delete(s,v),v.dispose()}async $resolveCustomEditor(a,s,o,w,v,I){const k=this.b.get(o);if(!k)throw new Error(`No provider found for '${o}'`);const r=S.ViewColumn.to(v),l=this.g.createNewWebview(s,w.contentOptions,k.extension),f=this.h.createNewWebviewPanel(s,o,w.title,r,w.options,l,w.active),F=h.URI.revive(a);switch(k.type){case 1:{const{document:W}=this.i(o,F);return k.provider.resolveCustomEditor(W,f,I)}case 0:{const W=this.d.getDocument(F);return k.provider.resolveCustomTextEditor(W,f,I)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(a,s,o){this.i(s,a).disposeEdits(o)}async $onMoveCustomEditor(a,s,o){const w=this.b.get(o);if(!w)throw new Error(`No provider found for '${o}'`);if(!w.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${o}'`);const v=this.h.getWebviewPanel(a);if(!v)throw new Error("No webview found");const I=h.URI.revive(s),k=this.d.getDocument(I);await w.provider.moveCustomTextEditor(k,v,y.CancellationToken.None)}async $undo(a,s,o,w){return this.i(s,a).undo(o,w)}async $redo(a,s,o,w){return this.i(s,a).redo(o,w)}async $revert(a,s,o){const w=this.i(s,a);await this.j(s).revertCustomDocument(w.document,o),w.disposeBackup()}async $onSave(a,s,o){const w=this.i(s,a);await this.j(s).saveCustomDocument(w.document,o),w.disposeBackup()}async $onSaveAs(a,s,o,w){const v=this.i(s,a);return this.j(s).saveCustomDocumentAs(v.document,h.URI.revive(o),w)}async $backup(a,s,o){const w=this.i(s,a),I=await this.j(s).backupCustomDocument(w.document,{destination:w.getNewBackupUri()},o);return w.updateBackup(I),I.id}i(a,s){const o=this.c.get(a,h.URI.revive(s));if(!o)throw new Error("No custom document found");return o}j(a){const o=this.b.get(a)?.provider;if(!o||!c(o))throw new Error("Custom document is not editable");return o}}e.$acc=i;function c(n){return!!n.onDidChangeCustomDocument}function m(n){return typeof n.resolveCustomTextEditor=="function"}function E(n){return typeof n.undo=="function"&&typeof n.redo=="function"}function b(n){const a=n.scheme===L.Schemas.file||n.scheme===L.Schemas.untitled?n.fsPath:n.toString();return(0,R.$ni)(a)+""}}),define(Pe[258],Ae([1,0,5,6,2,36,8,63,3,7]),function(pe,e,y,R,C,L,A,h,S,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_bc=void 0;class P extends R.$mb{#e;#t;#i;#l;#u;#n;#s;#r;#o;#a;#c;#d;#h;constructor($,d,t,i){super(),this.#r=void 0,this.#o=!0,this.#c=!1,this.#d=this.B(new y.$hc),this.onDidDispose=this.#d.event,this.#h=this.B(new y.$hc),this.onDidChangeViewState=this.#h.event,this.#e=$,this.#t=d,this.#l=t,this.#i=i.viewType,this.#u=i.panelOptions,this.#r=i.viewColumn,this.#n=i.title,this.#a=i.active}dispose(){this.#c||(this.#c=!0,this.#d.fire(),this.#t.$disposeWebview(this.#e),this.#l.dispose(),super.dispose())}get webview(){return this.c(),this.#l}get viewType(){return this.c(),this.#i}get title(){return this.c(),this.#n}set title($){this.c(),this.#n!==$&&(this.#n=$,this.#t.$setTitle(this.#e,$))}get iconPath(){return this.c(),this.#s}set iconPath($){this.c(),this.#s!==$&&(this.#s=$,this.#t.$setIconPath(this.#e,C.URI.isUri($)?{light:$,dark:$}:$))}get options(){return this.#u}get viewColumn(){if(this.c(),!(typeof this.#r=="number"&&this.#r<0))return this.#r}get active(){return this.c(),this.#a}get visible(){return this.c(),this.#o}_updateViewState($){this.#c||(this.active!==$.active||this.visible!==$.visible||this.viewColumn!==$.viewColumn)&&(this.#a=$.active,this.#o=$.visible,this.#r=$.viewColumn,this.#h.fire({webviewPanel:this}))}reveal($,d){this.c(),this.#t.$reveal(this.#e,{viewColumn:typeof $>"u"?void 0:A.ViewColumn.from($),preserveFocus:!!d})}c(){if(this.#c)throw new Error("Webview is disposed")}}class D extends R.$mb{static c(){return(0,L.$6e)()}constructor($,d,t){super(),this.i=d,this.j=t,this.g=new Map,this.h=new Map,this.f=$.getProxy(S.$SJ.MainThreadWebviewPanels)}dispose(){super.dispose(),this.g.forEach($=>$.dispose()),this.g.clear()}createWebviewPanel($,d,t,i,c={}){const m=typeof i=="object"?i.viewColumn:i,E={viewColumn:A.ViewColumn.from(m),preserveFocus:typeof i=="object"&&!!i.preserveFocus},b=(0,h.$ybc)($),n=D.c();this.f.$createWebviewPanel((0,h.$Abc)($),n,d,{title:t,panelOptions:u(c),webviewOptions:(0,h.$Bbc)($,this.j,c),serializeBuffersForPostMessage:b},E);const a=this.i.createNewWebview(n,c,$);return this.createNewWebviewPanel(n,d,t,m,c,a,!0)}$onDidChangeWebviewPanelViewStates($){const d=Object.keys($);d.sort((t,i)=>{const c=$[t],m=$[i];return c.active?1:m.active?-1:+c.visible-+m.visible});for(const t of d){const i=this.getWebviewPanel(t);if(!i)continue;const c=$[t];i._updateViewState({active:c.active,visible:c.visible,viewColumn:A.ViewColumn.to(c.position)})}}async $onDidDisposeWebviewPanel($){this.getWebviewPanel($)?.dispose(),this.g.delete($),this.i.deleteWebview($)}registerWebviewPanelSerializer($,d,t){if(this.h.has(d))throw new Error(`Serializer for '${d}' already registered`);return this.h.set(d,{serializer:t,extension:$}),this.f.$registerSerializer(d,{serializeBuffersForPostMessage:(0,h.$ybc)($)}),new g.$UJ(()=>{this.h.delete(d),this.f.$unregisterSerializer(d)})}async $deserializeWebviewPanel($,d,t,i){const c=this.h.get(d);if(!c)throw new Error(`No serializer found for '${d}'`);const{serializer:m,extension:E}=c,b=this.i.createNewWebview($,t.webviewOptions,E),n=this.createNewWebviewPanel($,d,t.title,i,t.panelOptions,b,t.active);await m.deserializeWebviewPanel(n,t.state)}createNewWebviewPanel($,d,t,i,c,m,E){const b=new P($,this.f,m,{viewType:d,title:t,viewColumn:i,panelOptions:c,active:E});return this.g.set($,b),b}getWebviewPanel($){return this.g.get($)}}e.$_bc=D;function u(p){return{enableFindWidget:p.enableFindWidget,retainContextWhenHidden:p.retainContextWhenHidden}}}),define(Pe[259],Ae([1,0,5,6,63,8,3,7]),function(pe,e,y,R,C,L,A,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$bc=void 0;class S extends R.$mb{#e;#t;#i;#l;#u;#n;#s;#r;#o;constructor(D,u,p,$,d,t){super(),this.#u=!1,this.#a=this.B(new y.$hc),this.onDidChangeVisibility=this.#a.event,this.#c=this.B(new y.$hc),this.onDidDispose=this.#c.event,this.#i=p,this.#s=$,this.#e=D,this.#t=u,this.#l=d,this.#n=t}dispose(){this.#u||(this.#u=!0,this.#c.fire(),this.#l.dispose(),super.dispose())}#a;#c;get title(){return this.a(),this.#s}set title(D){this.a(),this.#s!==D&&(this.#s=D,this.#t.$setWebviewViewTitle(this.#e,D))}get description(){return this.a(),this.#r}set description(D){this.a(),this.#r!==D&&(this.#r=D,this.#t.$setWebviewViewDescription(this.#e,D))}get visible(){return this.#n}get webview(){return this.#l}get viewType(){return this.#i}_setVisible(D){D===this.#n||this.#u||(this.#n=D,this.#a.fire())}get badge(){return this.a(),this.#o}set badge(D){this.a(),!(D?.value===this.#o?.value&&D?.tooltip===this.#o?.tooltip)&&(this.#o=L.ViewBadge.from(D),this.#t.$setWebviewViewBadge(this.#e,D))}show(D){this.a(),this.#t.$show(this.#e,!!D)}a(){if(this.#u)throw new Error("Webview is disposed")}}class g{constructor(D,u){this.d=u,this.b=new Map,this.c=new Map,this.a=D.getProxy(A.$SJ.MainThreadWebviewViews)}registerWebviewViewProvider(D,u,p,$){if(this.b.has(u))throw new Error(`View provider for '${u}' already registered`);return this.b.set(u,{provider:p,extension:D}),this.a.$registerWebviewViewProvider((0,C.$Abc)(D),u,{retainContextWhenHidden:$?.retainContextWhenHidden,serializeBuffersForPostMessage:(0,C.$ybc)(D)}),new h.$UJ(()=>{this.b.delete(u),this.a.$unregisterWebviewViewProvider(u)})}async $resolveWebviewView(D,u,p,$,d){const t=this.b.get(u);if(!t)throw new Error(`No view provider found for '${u}'`);const{provider:i,extension:c}=t,m=this.d.createNewWebview(D,{},c),E=new S(D,this.a,u,p,m,!0);this.c.set(D,E),await i.resolveWebviewView(E,{state:$},d)}async $onDidChangeWebviewViewVisibility(D,u){this.e(D)._setVisible(u)}async $disposeWebviewView(D){const u=this.e(D);this.c.delete(D),u.dispose(),this.d.deleteWebview(D)}e(D){const u=this.c.get(D);if(!u)throw new Error("No webview found");return u}}e.$$bc=g}),define(Pe[109],Ae([1,0,5,3,2,12,15,4,17,26]),function(pe,e,y,R,C,L,A,h,S,g){"use strict";var P;Object.defineProperty(e,"__esModule",{value:!0}),e.$Dbc=e.$Cbc=void 0;let D=class{static{P=this}static{this.a={focused:!0,active:!0}}getState(p){const $=this.d;return{get focused(){return $.focused},get active(){return(0,g.$MF)(p,"windowActivity"),$.active}}}constructor(p){this.c=new y.$hc,this.onDidChangeWindowState=this.c.event,this.d=P.a,this.b=p.getProxy(R.$SJ.MainThreadWindow),this.b.$getInitialState().then(({isFocused:$,isActive:d})=>{this.onDidChangeWindowProperty("focused",$),this.onDidChangeWindowProperty("active",d)})}$onDidChangeWindowFocus(p){this.onDidChangeWindowProperty("focused",p)}$onDidChangeWindowActive(p){this.onDidChangeWindowProperty("active",p)}onDidChangeWindowProperty(p,$){$!==this.d[p]&&(this.d={...this.d,[p]:$},this.c.fire(this.d))}openUri(p,$){let d;if(typeof p=="string"){d=p;try{p=C.URI.parse(p)}catch{return Promise.reject(`Invalid uri - '${p}'`)}}return(0,A.$od)(p.scheme)?Promise.reject("Invalid scheme - cannot be empty"):p.scheme===L.Schemas.command?Promise.reject(`Invalid scheme '${p.scheme}'`):this.b.$openUri(p,d,$)}async asExternalUri(p,$){if((0,A.$od)(p.scheme))return Promise.reject("Invalid scheme - cannot be empty");const d=await this.b.$asExternalUri(p,$);return C.URI.from(d)}};e.$Cbc=D,e.$Cbc=D=P=Ke([Ve(0,S.$UL)],D),e.$Dbc=(0,h.$zh)("IExtHostWindow")}),define(Pe[260],Ae([1,0,227,27,17]),function(pe,e,y,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Iec=void 0;let L=class extends y.$Bcc{constructor(h,S){super(h,S)}f(h,S,g){S.apply(console,g)}};e.$Iec=L,e.$Iec=L=Ke([Ve(0,C.$UL),Ve(1,R.$$L)],L)}),define(Pe[261],Ae([1,0,13,25,21,9,5,6,133,216,46]),function(pe,e,y,R,C,L,A,h,S,g,P){"use strict";var D;Object.defineProperty(e,"__esModule",{value:!0}),e.$92b=e.ResponsiveState=e.RequestInitiator=e.$82b=e.$72b=void 0;function u(l,f){try{return JSON.stringify(l,f)}catch{return"null"}}const p="$$ref$$",$={[p]:-1};class d{constructor(f,F){this.jsonString=f,this.referencedBuffers=F}}function t(l,f=null,F=!1){const W=[];return{jsonString:(F?u:JSON.stringify)(l,(B,j)=>{if(typeof j>"u")return $;if(typeof j=="object"){if(j instanceof R.$Hc){const U=W.push(j)-1;return{[p]:U}}if(f)return f(B,j)}return j}),referencedBuffers:W}}e.$72b=t;function i(l,f,F){return JSON.parse(l,(W,V)=>{if(V){const B=V[p];if(typeof B=="number")return f[B];if(F&&V.$mid===1)return F.transformIncoming(V)}return V})}e.$82b=i;function c(l,f){return JSON.stringify(l,f)}function m(l){return l?(f,F)=>F&&F.$mid===1?l.transformOutgoing(F):F:null}var E;(function(l){l[l.LocalSide=0]="LocalSide",l[l.OtherSide=1]="OtherSide"})(E||(e.RequestInitiator=E={}));var b;(function(l){l[l.Responsive=0]="Responsive",l[l.Unresponsive=1]="Unresponsive"})(b||(e.ResponsiveState=b={}));const n=()=>{},a=Symbol.for("rpcProtocol"),s=Symbol.for("rpcProxy");class o extends h.$mb{static{D=a}static{this.a=3*1e3}constructor(f,F=null,W=null){super(),this[D]=!0,this.b=this.B(new A.$hc),this.onDidChangeResponsiveState=this.b.event,this.c=f,this.f=F,this.g=W,this.h=m(this.g),this.j=!1,this.k=[],this.l=[];for(let V=0,B=P.$9z.count;V<B;V++)this.k[V]=null,this.l[V]=null;this.m=0,this.p=Object.create(null),this.s={},this.t=0,this.u=0,this.v=0,this.w=this.B(new y.$Qg(()=>this.C(),1e3)),this.c.onMessage(V=>this.G(V))}dispose(){this.j=!0,Object.keys(this.s).forEach(f=>{this.s[f].resolveErr(L.$4())})}drain(){return typeof this.c.drain=="function"?this.c.drain():Promise.resolve()}y(f){this.u===0&&(this.v=Date.now()+o.a),this.u++,this.w.isScheduled()||this.w.schedule()}z(f){this.v=Date.now()+o.a,this.u--,this.u===0&&this.w.cancel(),this.D(0)}C(){this.u!==0&&(Date.now()>this.v?this.D(1):this.w.schedule())}D(f){this.t!==f&&(this.t=f,this.b.fire(this.t))}get responsiveState(){return this.t}transformIncomingURIs(f){return this.g?(0,S.$Cm)(f,this.g):f}getProxy(f){const{nid:F,sid:W}=f;return this.l[F]||(this.l[F]=this.F(F,W)),this.l[F]}F(f,F){const W={get:(V,B)=>(typeof B=="string"&&!V[B]&&B.charCodeAt(0)===36&&(V[B]=(...j)=>this.O(f,B,j)),B===s?F:V[B])};return new Proxy(Object.create(null),W)}set(f,F){return this.k[f.nid]=F,F}assertRegistered(f){for(let F=0,W=f.length;F<W;F++){const V=f[F];if(!this.k[V.nid])throw new Error(`Missing proxy instance ${V.sid}`)}}G(f){if(this.j)return;const F=f.byteLength,W=w.read(f,0),V=W.readUInt8(),B=W.readUInt32();switch(V){case 1:case 2:{let{rpcId:j,method:U,args:z}=I.deserializeRequestJSONArgs(W);this.g&&(z=(0,S.$Cm)(z,this.g)),this.H(F,B,j,U,z,V===2);break}case 3:case 4:{let{rpcId:j,method:U,args:z}=I.deserializeRequestMixedArgs(W);this.g&&(z=(0,S.$Cm)(z,this.g)),this.H(F,B,j,U,z,V===4);break}case 5:{this.f?.logIncoming(F,B,0,"ack"),this.z(B);break}case 6:{this.I(F,B);break}case 7:{this.J(F,B,void 0);break}case 9:{let j=I.deserializeReplyOKJSON(W);this.g&&(j=(0,S.$Cm)(j,this.g)),this.J(F,B,j);break}case 10:{const j=I.deserializeReplyOKJSONWithBuffers(W,this.g);this.J(F,B,j);break}case 8:{const j=I.deserializeReplyOKVSBuffer(W);this.J(F,B,j);break}case 11:{let j=I.deserializeReplyErrError(W);this.g&&(j=(0,S.$Cm)(j,this.g)),this.L(F,B,j);break}case 12:{this.L(F,B,void 0);break}default:console.error("received unexpected message"),console.error(f)}}H(f,F,W,V,B,j){this.f?.logIncoming(f,F,1,`receiveRequest ${(0,P.$$z)(W)}.${V}(`,B);const U=String(F);let z,ie;if(j){const ye=new C.$rc;B.push(ye.token),z=this.M(W,V,B),ie=()=>ye.cancel()}else z=this.M(W,V,B),ie=n;this.p[U]=ie;const Y=I.serializeAcknowledged(F);this.f?.logOutgoing(Y.byteLength,F,1,"ack"),this.c.send(Y),z.then(ye=>{delete this.p[U];const ke=I.serializeReplyOK(F,ye,this.h);this.f?.logOutgoing(ke.byteLength,F,1,"reply:",ye),this.c.send(ke)},ye=>{delete this.p[U];const ke=I.serializeReplyErr(F,ye);this.f?.logOutgoing(ke.byteLength,F,1,"replyErr:",ye),this.c.send(ke)})}I(f,F){this.f?.logIncoming(f,F,1,"receiveCancel");const W=String(F);this.p[W]?.()}J(f,F,W){this.f?.logIncoming(f,F,0,"receiveReply:",W);const V=String(F);if(!this.s.hasOwnProperty(V))return;const B=this.s[V];delete this.s[V],B.resolveOk(W)}L(f,F,W){this.f?.logIncoming(f,F,0,"receiveReplyErr:",W);const V=String(F);if(!this.s.hasOwnProperty(V))return;const B=this.s[V];delete this.s[V];let j;W&&(W.$isError?(j=new Error,j.name=W.name,j.message=W.message,j.stack=W.stack):j=W),B.resolveErr(j)}M(f,F,W){try{return Promise.resolve(this.N(f,F,W))}catch(V){return Promise.reject(V)}}N(f,F,W){const V=this.k[f];if(!V)throw new Error("Unknown actor "+(0,P.$$z)(f));const B=V[F];if(typeof B!="function")throw new Error("Unknown method "+F+" on actor "+(0,P.$$z)(f));return B.apply(V,W)}O(f,F,W){if(this.j)return new g.$62b;let V=null;if(W.length>0&&C.CancellationToken.isCancellationToken(W[W.length-1])&&(V=W.pop()),V&&V.isCancellationRequested)return Promise.reject(L.$4());const B=I.serializeRequestArguments(W,this.h),j=++this.m,U=String(j),z=new g.$52b;V&&V.onCancellationRequested(()=>{const Y=I.serializeCancel(j);this.f?.logOutgoing(Y.byteLength,j,0,"cancel"),this.c.send(I.serializeCancel(j))}),this.s[U]=z,this.y(j);const ie=I.serializeRequest(j,f,F,B,!!V);return this.f?.logOutgoing(ie.byteLength,j,0,`request: ${(0,P.$$z)(f)}.${F}(`,W),this.c.send(ie),z}}e.$92b=o;class w{static alloc(f,F,W){const V=new w(R.$Hc.alloc(W+1+4),0);return V.writeUInt8(f),V.writeUInt32(F),V}static read(f,F){return new w(f,F)}get buffer(){return this.a}constructor(f,F){this.a=f,this.b=F}static sizeUInt8(){return 1}static{this.sizeUInt32=4}writeUInt8(f){this.a.writeUInt8(f,this.b),this.b+=1}readUInt8(){const f=this.a.readUInt8(this.b);return this.b+=1,f}writeUInt32(f){this.a.writeUInt32BE(f,this.b),this.b+=4}readUInt32(){const f=this.a.readUInt32BE(this.b);return this.b+=4,f}static sizeShortString(f){return 1+f.byteLength}writeShortString(f){this.a.writeUInt8(f.byteLength,this.b),this.b+=1,this.a.set(f,this.b),this.b+=f.byteLength}readShortString(){const f=this.a.readUInt8(this.b);this.b+=1;const W=this.a.slice(this.b,this.b+f).toString();return this.b+=f,W}static sizeLongString(f){return 4+f.byteLength}writeLongString(f){this.a.writeUInt32BE(f.byteLength,this.b),this.b+=4,this.a.set(f,this.b),this.b+=f.byteLength}readLongString(){const f=this.a.readUInt32BE(this.b);this.b+=4;const W=this.a.slice(this.b,this.b+f).toString();return this.b+=f,W}writeBuffer(f){this.a.writeUInt32BE(f.byteLength,this.b),this.b+=4,this.a.set(f,this.b),this.b+=f.byteLength}static sizeVSBuffer(f){return 4+f.byteLength}writeVSBuffer(f){this.a.writeUInt32BE(f.byteLength,this.b),this.b+=4,this.a.set(f,this.b),this.b+=f.byteLength}readVSBuffer(){const f=this.a.readUInt32BE(this.b);this.b+=4;const F=this.a.slice(this.b,this.b+f);return this.b+=f,F}static sizeMixedArray(f){let F=0;F+=1;for(let W=0,V=f.length;W<V;W++){const B=f[W];switch(F+=1,B.type){case 1:F+=this.sizeLongString(B.value);break;case 2:F+=this.sizeVSBuffer(B.value);break;case 3:F+=this.sizeUInt32,F+=this.sizeLongString(B.value);for(let j=0;j<B.buffers.length;++j)F+=this.sizeVSBuffer(B.buffers[j]);break;case 4:break}}return F}writeMixedArray(f){this.a.writeUInt8(f.length,this.b),this.b+=1;for(let F=0,W=f.length;F<W;F++){const V=f[F];switch(V.type){case 1:this.writeUInt8(1),this.writeLongString(V.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(V.value);break;case 3:this.writeUInt8(3),this.writeUInt32(V.buffers.length),this.writeLongString(V.value);for(let B=0;B<V.buffers.length;++B)this.writeBuffer(V.buffers[B]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const f=this.a.readUInt8(this.b);this.b+=1;const F=new Array(f);for(let W=0;W<f;W++)switch(this.readUInt8()){case 1:F[W]=this.readLongString();break;case 2:F[W]=this.readVSBuffer();break;case 3:{const B=this.readUInt32(),j=this.readLongString(),U=[];for(let z=0;z<B;++z)U.push(this.readVSBuffer());F[W]=new P.$_z(i(j,U,null));break}case 4:F[W]=void 0;break}return F}}var v;(function(l){l[l.Simple=0]="Simple",l[l.Mixed=1]="Mixed"})(v||(v={}));class I{static a(f){for(let F=0,W=f.length;F<W;F++)if(f[F]instanceof R.$Hc||f[F]instanceof P.$_z||typeof f[F]>"u")return!0;return!1}static serializeRequestArguments(f,F){if(this.a(f)){const W=[];for(let V=0,B=f.length;V<B;V++){const j=f[V];if(j instanceof R.$Hc)W[V]={type:2,value:j};else if(typeof j>"u")W[V]={type:4};else if(j instanceof P.$_z){const{jsonString:U,referencedBuffers:z}=t(j.value,F);W[V]={type:3,value:R.$Hc.fromString(U),buffers:z}}else W[V]={type:1,value:R.$Hc.fromString(c(j,F))}}return{type:1,args:W}}return{type:0,args:c(f,F)}}static serializeRequest(f,F,W,V,B){switch(V.type){case 0:return this.b(f,F,W,V.args,B);case 1:return this.c(f,F,W,V.args,B)}}static b(f,F,W,V,B){const j=R.$Hc.fromString(W),U=R.$Hc.fromString(V);let z=0;z+=w.sizeUInt8(),z+=w.sizeShortString(j),z+=w.sizeLongString(U);const ie=w.alloc(B?2:1,f,z);return ie.writeUInt8(F),ie.writeShortString(j),ie.writeLongString(U),ie.buffer}static deserializeRequestJSONArgs(f){const F=f.readUInt8(),W=f.readShortString(),V=f.readLongString();return{rpcId:F,method:W,args:JSON.parse(V)}}static c(f,F,W,V,B){const j=R.$Hc.fromString(W);let U=0;U+=w.sizeUInt8(),U+=w.sizeShortString(j),U+=w.sizeMixedArray(V);const z=w.alloc(B?4:3,f,U);return z.writeUInt8(F),z.writeShortString(j),z.writeMixedArray(V),z.buffer}static deserializeRequestMixedArgs(f){const F=f.readUInt8(),W=f.readShortString(),V=f.readMixedArray(),B=new Array(V.length);for(let j=0,U=V.length;j<U;j++){const z=V[j];typeof z=="string"?B[j]=JSON.parse(z):B[j]=z}return{rpcId:F,method:W,args:B}}static serializeAcknowledged(f){return w.alloc(5,f,0).buffer}static serializeCancel(f){return w.alloc(6,f,0).buffer}static serializeReplyOK(f,F,W){if(typeof F>"u")return this.d(f);if(F instanceof R.$Hc)return this.e(f,F);if(F instanceof P.$_z){const{jsonString:V,referencedBuffers:B}=t(F.value,W,!0);return this.g(f,V,B)}else return this.f(f,u(F,W))}static d(f){return w.alloc(7,f,0).buffer}static e(f,F){let W=0;W+=w.sizeVSBuffer(F);const V=w.alloc(8,f,W);return V.writeVSBuffer(F),V.buffer}static deserializeReplyOKVSBuffer(f){return f.readVSBuffer()}static f(f,F){const W=R.$Hc.fromString(F);let V=0;V+=w.sizeLongString(W);const B=w.alloc(9,f,V);return B.writeLongString(W),B.buffer}static g(f,F,W){const V=R.$Hc.fromString(F);let B=0;B+=w.sizeUInt32,B+=w.sizeLongString(V);for(const U of W)B+=w.sizeVSBuffer(U);const j=w.alloc(10,f,B);j.writeUInt32(W.length),j.writeLongString(V);for(const U of W)j.writeBuffer(U);return j.buffer}static deserializeReplyOKJSON(f){const F=f.readLongString();return JSON.parse(F)}static deserializeReplyOKJSONWithBuffers(f,F){const W=f.readUInt32(),V=f.readLongString(),B=[];for(let j=0;j<W;++j)B.push(f.readVSBuffer());return new P.$_z(i(V,B,F))}static serializeReplyErr(f,F){const W=F?u(L.$1(F),null):void 0;if(typeof W!="string")return this.h(f);const V=R.$Hc.fromString(W);let B=0;B+=w.sizeLongString(V);const j=w.alloc(11,f,B);return j.writeLongString(V),j.buffer}static deserializeReplyErrError(f){const F=f.readLongString();return JSON.parse(F)}static h(f){return w.alloc(12,f,0).buffer}}var k;(function(l){l[l.RequestJSONArgs=1]="RequestJSONArgs",l[l.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",l[l.RequestMixedArgs=3]="RequestMixedArgs",l[l.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",l[l.Acknowledged=5]="Acknowledged",l[l.Cancel=6]="Cancel",l[l.ReplyOKEmpty=7]="ReplyOKEmpty",l[l.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",l[l.ReplyOKJSON=9]="ReplyOKJSON",l[l.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",l[l.ReplyErrError=11]="ReplyErrError",l[l.ReplyErrEmpty=12]="ReplyErrEmpty"})(k||(k={}));var r;(function(l){l[l.String=1]="String",l[l.VSBuffer=2]="VSBuffer",l[l.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",l[l.Undefined=4]="Undefined"})(r||(r={}))}),define(Pe[262],Ae([1,0]),function(pe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kec=void 0;const y=function(L){const A=h=>{globalThis.removeEventListener("message",A);const S=h.data;Object.defineProperties(globalThis,{postMessage:{value(g,P){S.postMessage(g,P)}},onmessage:{get(){return S.onmessage},set(g){S.onmessage=g}}}),S.addEventListener("message",g=>{globalThis.dispatchEvent(new MessageEvent("message",{data:g.data,ports:g.ports?[...g.ports]:void 0}))}),S.start(),globalThis.Worker=class{constructor(){throw new TypeError("Nested workers from within nested worker are NOT supported.")}},importScripts(L)};globalThis.addEventListener("message",A)}.toString();class R extends EventTarget{constructor(L,A,h){super(),this.onmessage=null,this.onmessageerror=null,this.onerror=null;const S=`((${y})('${A}'))`,g=new Blob([S],{type:"application/javascript"}),P=URL.createObjectURL(g),D=new MessageChannel,u=P,p={type:"_newWorker",id:u,port:D.port2,url:P,options:h};L(p,[D.port2]),this.postMessage=D.port1.postMessage.bind(D.port1),this.terminate=()=>{L({type:"_terminateWorker",id:u}),URL.revokeObjectURL(P),D.port1.close(),D.port2.close()},Object.defineProperties(this,{onmessage:{get(){return D.port1.onmessage},set($){D.port1.onmessage=$}},onmessageerror:{get(){return D.port1.onmessageerror},set($){D.port1.onmessageerror=$}}}),D.port1.addEventListener("messageerror",$=>{const d=new MessageEvent("messageerror",{data:$.data});this.dispatchEvent(d)}),D.port1.addEventListener("message",$=>{const d=new MessageEvent("message",{data:$.data});this.dispatchEvent(d)}),D.port1.start()}}e.$Kec=R}),define(Pe[263],Ae([1,0,5,30,32,4]),function(pe,e,y,R,C,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9I=e.$8I=e.OutputChannelUpdateMode=e.$7I=e.$6I=e.$5I=e.$4I=e.$3I=e.$2I=e.$1I=e.$ZI=e.$YI=e.$XI=e.$WI=void 0,e.$WI="text/x-code-output",e.$XI="output",e.$YI="Log",e.$ZI="text/x-code-log-output",e.$1I="log",e.$2I="log",e.$3I="workbench.panel.output",e.$4I=new C.$Zi("inOutput",!1),e.$5I=new C.$Zi("activeLogOutput",!1),e.$6I=new C.$Zi("outputView.scrollLock",!1),e.$7I=(0,L.$zh)("outputService");var A;(function(S){S[S.Append=1]="Append",S[S.Replace=2]="Replace",S[S.Clear=3]="Clear"})(A||(e.OutputChannelUpdateMode=A={})),e.$8I={OutputChannels:"workbench.contributions.outputChannels"};class h{constructor(){this.a=new Map,this.b=new y.$hc,this.onDidRegisterChannel=this.b.event,this.c=new y.$hc,this.onDidRemoveChannel=this.c.event}registerChannel(g){this.a.has(g.id)||(this.a.set(g.id,g),this.b.fire(g.id))}getChannels(){const g=[];return this.a.forEach(P=>g.push(P)),g}getChannel(g){return this.a.get(g)}removeChannel(g){this.a.delete(g),this.c.fire(g)}}R.$6m.add(e.$8I.OutputChannels,new h),e.$9I=new C.$Zi("activeOutputChannel","")}),define(Pe[110],Ae([1,0,3,4,17,20,14,263,61,27,39,130,25,16,38,5,6]),function(pe,e,y,R,C,L,A,h,S,g,P,D,u,p,$,d,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nbc=e.$mbc=void 0;class i extends A.$9i{get disposed(){return this.l}constructor(b,n,a,s,o){super(),this.id=b,this.name=n,this.m=a,this.n=s,this.extension=o,this.k=0,this.l=!1,this.visible=!1,this.setLevel(a.getLevel()),this.B(a.onDidChangeLogLevel(w=>this.setLevel(w)))}get logLevel(){return this.getLevel()}appendLine(b){this.append(b+`
`)}append(b){this.info(b)}clear(){const b=this.k;this.m.flush(),this.n.$update(this.id,h.OutputChannelUpdateMode.Clear,b)}replace(b){const n=this.k;this.info(b),this.n.$update(this.id,h.OutputChannelUpdateMode.Replace,n),this.visible&&this.m.flush()}show(b,n){this.m.flush(),this.n.$reveal(this.id,!!(typeof b=="boolean"?b:n))}hide(){this.n.$close(this.id)}g(b,n){this.k+=u.$Hc.fromString(n).byteLength,(0,A.log)(this.m,b,n),this.visible&&(this.m.flush(),this.n.$update(this.id,h.OutputChannelUpdateMode.Append))}dispose(){super.dispose(),this.l||(this.n.$dispose(this.id),this.l=!0)}}class c extends i{appendLine(b){this.append(b)}}let m=class{constructor(b,n,a,s,o,w){this.i=n,this.j=a,this.k=s,this.l=o,this.m=w,this.d=new Map,this.f=1,this.g=new Map,this.h=null,this.a=b.getProxy(y.$SJ.MainThreadOutputService),this.b=this.k.extUri.joinPath(n.logsLocation,`output_logging_${(0,D.$5l)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(b){this.h=b;for(const[n,a]of this.g)a.visible=n===this.h}createOutputChannel(b,n,a){if(b=b.trim(),!b)throw new Error("illegal argument `name`. must not be falsy");const s=typeof n=="object"&&n.log,o=(0,p.$le)(n)?n:void 0;if((0,p.$le)(o)&&!o.trim())throw new Error("illegal argument `languageId`. must not be empty");let w;const v=this.i.environment.extensionLogLevel?.find(([k])=>L.$Tl.equals(a.identifier,k))?.[1];v&&(w=(0,A.$gj)(v));const I=s?this.o(b,w,a):this.n(b,o,a);return I.then(k=>{this.g.set(k.id,k),k.visible=k.id===this.h}),s?this.r(b,w??this.m.getLevel(),I):this.q(b,I)}async n(b,n,a){this.c||(this.c=this.j.value.createDirectory(this.b).then(()=>this.b));const s=await this.c,o=this.k.extUri.joinPath(s,`${this.f++}-${b.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),w=this.l.createLogger(o,{logLevel:"always",donotRotate:!0,donotUseFormatters:!0,hidden:!0}),v=await this.a.$register(b,o,n,a.identifier.value);return new i(v,b,w,this.a,a)}async o(b,n,a){const s=await this.p(a),o=b.replace(/[\\/:\*\?"<>\|]/g,""),w=this.k.extUri.joinPath(s,`${o}.log`),v=`${a.identifier.value}.${o}`,I=this.l.createLogger(w,{id:v,name:b,logLevel:n,extensionId:a.identifier.value});return new c(v,b,I,this.a,a)}p(b){let n=this.d.get(b.identifier.value);if(!n){const a=this.k.extUri.joinPath(this.i.logsLocation,b.identifier.value);this.d.set(b.identifier.value,n=(async()=>{try{await this.j.value.createDirectory(a)}catch(s){if((0,$.$gk)(s)!==$.FileSystemProviderErrorCode.FileExists)throw s}return a})())}return n}q(b,n){let a=!1;const s=()=>{if(a)throw new Error("Channel has been closed")};return{get name(){return b},append(o){s(),n.then(w=>w.append(o))},appendLine(o){s(),n.then(w=>w.appendLine(o))},clear(){s(),n.then(o=>o.clear())},replace(o){s(),n.then(w=>w.replace(o))},show(o,w){s(),n.then(v=>v.show(o,w))},hide(){s(),n.then(o=>o.hide())},dispose(){a=!0,n.then(o=>o.dispose())}}}r(b,n,a){const s=new t.$lb,o=()=>{if(s.isDisposed)throw new Error("Channel has been closed")},w=s.add(new d.$hc);function v(I){n=I,w.fire(I)}return a.then(I=>{s.add(I),I.logLevel!==n&&v(I.logLevel),s.add(I.onDidChangeLogLevel(k=>v(k)))}),{...this.q(b,a),get logLevel(){return n},onDidChangeLogLevel:w.event,trace(I,...k){o(),a.then(r=>r.trace(I,...k))},debug(I,...k){o(),a.then(r=>r.debug(I,...k))},info(I,...k){o(),a.then(r=>r.info(I,...k))},warn(I,...k){o(),a.then(r=>r.warn(I,...k))},error(I,...k){o(),a.then(r=>r.error(I,...k))},dispose(){s.dispose()}}}};e.$mbc=m,e.$mbc=m=Ke([Ve(0,C.$UL),Ve(1,g.$$L),Ve(2,S.$2ac),Ve(3,P.$wac),Ve(4,A.$4i),Ve(5,A.$3i)],m),e.$nbc=(0,R.$zh)("IExtHostOutputService")}),define(Pe[264],Ae([1,0,4,13]),function(pe,e,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$im=e.$hm=void 0,e.$hm=(0,y.$zh)("remoteAgentService"),e.$im=new class{constructor(){this.maxSampleCount=5,this.sampleDelay=2e3,this.initial=[],this.maxInitialCount=3,this.average=[],this.maxAverageCount=100,this.highLatencyMultiple=2,this.highLatencyMinThreshold=500,this.highLatencyMaxThreshold=1500,this.lastMeasurement=void 0}get latency(){return this.lastMeasurement}async measure(C){let L=1/0;for(let h=0;h<this.maxSampleCount;h++){const S=await C.getRoundTripTime();if(S===void 0)return;L=Math.min(L,S/2),await(0,R.$Fg)(this.sampleDelay)}this.average.push(L),this.average.length>this.maxAverageCount&&this.average.shift();let A;return this.initial.length<this.maxInitialCount?this.initial.push(L):A=this.initial.reduce((h,S)=>h+S,0)/this.initial.length,this.lastMeasurement={initial:A,current:L,average:this.average.reduce((h,S)=>h+S,0)/this.average.length,high:(()=>typeof A>"u"?!1:L>this.highLatencyMaxThreshold||L>this.highLatencyMinThreshold&&L>A*this.highLatencyMultiple)()},this.lastMeasurement}}}),define(Pe[265],Ae([1,0,42,12,19,22,23,2,4,187,53,209,264]),function(pe,e,y,R,C,L,A,h,S,g,P,D,u){"use strict";var p;Object.defineProperty(e,"__esModule",{value:!0}),e.$pJ=e.$oJ=void 0,e.$oJ=(0,S.$zh)("pathService");let $=p=class{constructor(t,i,c,m){this.d=t,this.e=i,this.f=c,this.g=m,this.a=(async()=>(await this.e.getEnvironment())?.os||L.OS)(),this.b=(async()=>{const E=await this.e.getEnvironment();return this.c=E?.userHome??t})()}hasValidBasename(t,i,c){return typeof i=="string"||typeof i>"u"?this.a.then(m=>this.h(t,m,i)):this.h(t,i,c)}h(t,i,c){return t.scheme===R.Schemas.file||t.scheme===R.Schemas.vscodeRemote?(0,y.$Ie)(c??(0,A.$dg)(t),i===1):!0}get defaultUriScheme(){return p.findDefaultUriScheme(this.f,this.g)}static findDefaultUriScheme(t,i){if(t.remoteAuthority)return R.Schemas.vscodeRemote;const c=(0,g.$lJ)(i.getWorkspace());if(c)return c;const m=i.getWorkspace().folders[0];if(m)return m.uri.scheme;const E=i.getWorkspace().configuration;return E?E.scheme:R.Schemas.file}userHome(t){return t?.preferLocal?this.d:this.b}get resolvedUserHome(){return this.c}get path(){return this.a.then(t=>t===1?C.$7c:C.$8c)}async fileURI(t){let i="";if(await this.a===1&&(t=t.replace(/\\/g,"/")),t[0]==="/"&&t[1]==="/"){const m=t.indexOf("/",2);m===-1?(i=t.substring(2),t="/"):(i=t.substring(2,m),t=t.substring(m)||"/")}return h.URI.from({scheme:R.Schemas.file,authority:i,path:t,query:"",fragment:""})}};e.$pJ=$,e.$pJ=$=p=Ke([Ve(1,u.$hm),Ve(2,D.$0I),Ve(3,P.$Ih)],$)}),define(Pe[111],Ae([1,0]),function(pe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.$$H=e.$0H=void 0;class y{constructor(A,h){this.line=A,this.character=h}isBefore(A){return!1}isBeforeOrEqual(A){return!1}isAfter(A){return!1}isAfterOrEqual(A){return!1}isEqual(A){return!1}compareTo(A){return 0}translate(A,h){return new y(0,0)}with(A){return new y(0,0)}}e.$0H=y;class R{constructor(A,h,S,g){this.isEmpty=!1,this.isSingleLine=!1,this.start=new y(A,h),this.end=new y(S,g)}contains(A){return!1}isEqual(A){return!1}intersection(A){}union(A){return new R(0,0,0,0)}with(A){return new R(0,0,0,0)}}e.$$H=R;var C;(function(L){L[L.Information=1]="Information",L[L.Warning=2]="Warning"})(C||(e.TextSearchCompleteMessageType=C={}))}),define(Pe[47],Ae([1,0,18,37,24,42,15,4,19,9,111,13]),function(pe,e,y,R,C,L,A,h,S,g,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zI=e.$yI=e.$xI=e.$wI=e.$vI=e.$uI=e.$tI=e.$sI=e.$rI=e.$qI=e.$pI=e.$oI=e.SearchErrorCode=e.$nI=e.$mI=e.SearchSortOrder=e.ViewMode=e.$lI=e.$kI=e.$jI=e.$iI=e.SearchCompletionExitCode=e.$hI=e.$gI=e.$fI=e.QueryType=e.SearchProviderType=e.$eI=e.$dI=e.$cI=e.$bI=e.$aI=e.$_H=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return P.TextSearchCompleteMessageType}}),e.$_H="workbench.view.search",e.$aI="workbench.panel.search",e.$bI="workbench.view.search",e.$cI="search-result",e.$dI="search.exclude";const u="\u27EA ",p=" characters skipped \u27EB",$=(u.length+p.length+5)*2;e.$eI=(0,h.$zh)("searchService");var d;(function(X){X[X.file=0]="file",X[X.text=1]="text"})(d||(e.SearchProviderType=d={}));var t;(function(X){X[X.File=1]="File",X[X.Text=2]="Text"})(t||(e.QueryType=t={}));function i(X){return!!X.preview}e.$fI=i;function c(X){return!!X.resource}e.$gI=c;function m(X){return!!X.message}e.$hI=m;var E;(function(X){X[X.Normal=0]="Normal",X[X.NewSearchStarted=1]="NewSearchStarted"})(E||(e.SearchCompletionExitCode=E={}));class b{constructor(le){this.resource=le,this.results=[]}}e.$iI=b;class n{constructor(le,we,ae,x){this.ranges=we,this.webviewIndex=x;const ue=Array.isArray(we)?we:[we];if(ae&&ae.matchLines===1&&a(ue)){le=(0,A.$ee)(le,ae.matchLines);let O="",J=0,he=0;const Ee=Math.floor(ae.charsPerLine/5),ve=[];for(const be of ue){const De=Math.max(be.startColumn-Ee,0),oe=be.startColumn+ae.charsPerLine;if(De>he+Ee+$){const de=u+(De-he)+p;O+=de+le.slice(De,oe),J+=De-(he+de.length)}else O+=le.slice(he,oe);ve.push(new o(0,be.startColumn-J,be.endColumn-J)),he=oe}this.preview={text:O,matches:Array.isArray(this.ranges)?ve:ve[0]}}else{const O=Array.isArray(we)?we[0].startLineNumber:we.startLineNumber;this.preview={text:le,matches:(0,y.$Uf)(we,J=>new s(J.startLineNumber-O,J.startColumn,J.endLineNumber-O,J.endColumn))}}}}e.$jI=n;function a(X){const le=X[0].startLineNumber;for(const we of X)if(we.startLineNumber!==le||we.endLineNumber!==le)return!1;return!0}class s{constructor(le,we,ae,x){this.startLineNumber=le,this.startColumn=we,this.endLineNumber=ae,this.endColumn=x}}e.$kI=s;class o extends s{constructor(le,we,ae){super(le,we,le,ae)}}e.$lI=o;var w;(function(X){X.List="list",X.Tree="tree"})(w||(e.ViewMode=w={}));var v;(function(X){X.Default="default",X.FileNames="fileNames",X.Type="type",X.Modified="modified",X.CountDescending="countDescending",X.CountAscending="countAscending"})(v||(e.SearchSortOrder=v={}));function I(X,le=!0){const we=X&&X.files&&X.files.exclude,ae=le&&X&&X.search&&X.search.exclude;if(!we&&!ae)return;if(!we||!ae)return we||ae;let x=Object.create(null);return x=C.$Wm(x,C.$Tm(we)),x=C.$Wm(x,C.$Tm(ae),!0),x}e.$mI=I;function k(X,le){return X.excludePattern&&R.$oj(X.excludePattern,le)?!1:X.includePattern||X.usingSearchPaths?X.includePattern&&R.$oj(X.includePattern,le)?!0:X.usingSearchPaths?!!X.folderQueries&&X.folderQueries.some(we=>{const ae=we.folder.fsPath;if(L.$Ke(le,ae)){const x=S.$ad(ae,le);return!we.includePattern||!!R.$oj(we.includePattern,x)}else return!1}):!1:!0}e.$nI=k;var r;(function(X){X[X.unknownEncoding=1]="unknownEncoding",X[X.regexParseError=2]="regexParseError",X[X.globParseError=3]="globParseError",X[X.invalidLiteral=4]="invalidLiteral",X[X.rgProcessError=5]="rgProcessError",X[X.other=6]="other",X[X.canceled=7]="canceled"})(r||(e.SearchErrorCode=r={}));class l extends Error{constructor(le,we){super(le),this.code=we}}e.$oI=l;function f(X){const le=X.message;if((0,g.$2)(X))return new l(le,r.canceled);try{const we=JSON.parse(le);return new l(we.message,we.code)}catch{return new l(le,r.other)}}e.$pI=f;function F(X){const le={message:X.message,code:X.code};return new Error(JSON.stringify(le))}e.$qI=F;function W(X){return X.type==="error"?!0:X.type==="success"}e.$rI=W;function V(X){return X.type==="success"}e.$sI=V;function B(X){return!!X.path}e.$tI=B;function j(X,le){const we=X.searchPath?X.searchPath:X.relativePath;return(0,A.$be)(we,le)}e.$uI=j;class U{constructor(le){this.path=le,this.results=[]}addMatch(le){this.results.push(le)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.$vI=U;function z(X,le){const we={...X||{},...le||{}};return Object.keys(we).filter(ae=>{const x=we[ae];return typeof x=="boolean"&&x})}e.$wI=z;class ie{constructor(le,we){this.c=null,this.a={...le.excludePattern||{},...we.excludePattern||{}},this.b=R.$pj(this.a);let ae=le.includePattern;we.includePattern&&(ae?ae={...ae,...we.includePattern}:ae=we.includePattern),ae&&(this.c=R.$pj(ae))}matchesExcludesSync(le,we,ae){return!!(this.b&&this.b(le,we,ae))}includedInQuerySync(le,we,ae){return!(this.b&&this.b(le,we,ae)||this.c&&!this.c(le,we,ae))}includedInQuery(le,we,ae){const x=this.b(le,we,ae),ue=()=>this.c?!!this.c(le,we,ae):!0;return(0,D.$rg)(x)?x.then(O=>O?!1:ue()):ue()}hasSiblingExcludeClauses(){return Y(this.a)}}e.$xI=ie;function Y(X){for(const le in X)if(typeof X[le]!="boolean")return!0;return!1}function ye(X){if(!X)return;let le;return we=>(le||(le=(X()||Promise.resolve([])).then(ae=>ae?Re(ae):{})),le.then(ae=>!!ae[we]))}e.$yI=ye;function ke(X){if(!X)return;let le;return we=>{if(!le){const ae=X();le=ae?Re(ae):{}}return!!le[we]}}e.$zI=ke;function Re(X){const le={};for(const we of X)le[we]=!0;return le}}),define(Pe[33],Ae([1,0,18,13,21,5,6,48,12,118,23,15,2,159,4,14,176,53,39,27,17,8,7,55,47,3]),function(pe,e,y,R,C,L,A,h,S,g,P,D,u,p,$,d,t,i,c,m,E,b,n,a,s,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jac=e.$Iac=void 0;function w(W,V,B){return new P.$8f(j=>r(j,B)).isEqual(W,V)}function v(W,V,B){return w(W.uri,V.uri,B)?0:(0,D.$Hd)(W.uri.toString(),V.uri.toString())}function I(W,V,B){return W.index!==V.index?W.index<V.index?-1:1:w(W.uri,V.uri,B)?(0,D.$Hd)(W.name,V.name):(0,D.$Hd)(W.uri.toString(),V.uri.toString())}function k(W,V,B,j){const U=W.slice(0).sort((ie,Y)=>B(ie,Y,j)),z=V.slice(0).sort((ie,Y)=>B(ie,Y,j));return(0,y.$xf)(U,z,(ie,Y)=>B(ie,Y,j))}function r(W,V){const B=V.getCapabilities(W.scheme);return!(B&&B&1024)}class l extends i.$Sh{static toExtHostWorkspace(V,B,j,U){if(!V)return{workspace:null,added:[],removed:[]};const{id:z,name:ie,folders:Y,configuration:ye,transient:ke,isUntitled:Re}=V,X=[],le=B;B?Y.forEach((ue,O)=>{const J=u.URI.revive(ue.uri),he=l.o(j||B,J,U);he?(he.name=ue.name,he.index=ue.index,X.push(he)):X.push({uri:J,name:ue.name,index:O})}):X.push(...Y.map(({uri:ue,name:O,index:J})=>({uri:u.URI.revive(ue),name:O,index:J}))),X.sort((ue,O)=>ue.index<O.index?-1:1);const we=new l(z,ie,X,!!ke,ye?u.URI.revive(ye):null,!!Re,ue=>r(ue,U)),{added:ae,removed:x}=k(le?le.workspaceFolders:[],we.workspaceFolders,v,U);return{workspace:we,added:ae,removed:x}}static o(V,B,j){for(let U=0;U<V.folders.length;U++){const z=V.workspaceFolders[U];if(w(z.uri,B,j))return z}}constructor(V,B,j,U,z,ie,Y){super(V,j.map(ye=>new i.$Th(ye)),U,z,Y),this.t=B,this.u=ie,this.q=[],this.s=h.$Fh.forUris(Y),j.forEach(ye=>{this.q.push(ye),this.s.set(ye.uri,ye)})}get name(){return this.t}get isUntitled(){return this.u}get workspaceFolders(){return this.q.slice(0)}getWorkspaceFolder(V,B){return B&&this.s.get(V)&&(V=(0,P.$fg)(V)),this.s.findSubstr(V)}resolveWorkspaceFolder(V){return this.s.get(V)}}let f=class{constructor(V,B,j,U,z){this.c=new L.$hc,this.onDidChangeWorkspace=this.c.event,this.g=new L.$hc,this.onDidGrantWorkspaceTrust=this.g.event,this.u=[],this.v=!1,this.w=new Map,this.z=0,this.A=new L.$jc,this.B=new Map,this.h=U,this.s=j,this.t=z,this.j=new g.$Hl,this.k=new R.$Dg,this.o=V.getProxy(o.$SJ.MainThreadWorkspace),this.q=V.getProxy(o.$SJ.MainThreadMessageService);const ie=B.workspace;this.l=ie?new l(ie.id,ie.name,[],!!ie.transient,ie.configuration?u.URI.revive(ie.configuration):null,!!ie.isUntitled,Y=>r(Y,j)):void 0}$initializeWorkspace(V,B){this.v=B,this.$acceptWorkspaceData(V),this.k.open()}waitForInitializeCall(){return this.k.wait()}get workspace(){return this.x}get name(){return this.x?this.x.name:void 0}get workspaceFile(){if(this.x&&this.x.configuration)return this.x.isUntitled?u.URI.from({scheme:S.Schemas.untitled,path:(0,P.$dg)((0,P.$fg)(this.x.configuration))}):this.x.configuration}get x(){return this.n||this.l}getWorkspaceFolders(){if(this.x)return this.x.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this.k.wait(),!!this.x)return this.x.workspaceFolders.slice(0)}updateWorkspaceFolders(V,B,j,...U){const z=[];if(Array.isArray(U)&&U.forEach(Re=>{u.URI.isUri(Re.uri)&&!z.some(X=>w(X.uri,Re.uri,this.s))&&z.push({uri:Re.uri,name:Re.name||(0,P.$cg)(Re.uri)})}),this.n||[B,j].some(Re=>typeof Re!="number"||Re<0)||j===0&&z.length===0)return!1;const ie=this.x?this.x.workspaceFolders:[];if(B+j>ie.length)return!1;const Y=ie.slice(0);Y.splice(B,j,...z.map(Re=>({uri:Re.uri,name:Re.name||(0,P.$cg)(Re.uri),index:void 0})));for(let Re=0;Re<Y.length;Re++){const X=Y[Re];if(Y.some((le,we)=>we!==Re&&w(X.uri,le.uri,this.s)))return!1}Y.forEach((Re,X)=>Re.index=X);const{added:ye,removed:ke}=k(ie,Y,I,this.s);if(ye.length===0&&ke.length===0)return!1;if(this.o){const Re=V.displayName||V.name;this.o.$updateWorkspaceFolders(Re,B,j,z).then(void 0,X=>{this.n=void 0;const le={source:{identifier:V.identifier,label:V.displayName||V.name}};this.q.$showMessage(t.Severity.Error,(0,p.localize)(0,null,Re,X.toString()),le,[])})}return this.y(Y),!0}getWorkspaceFolder(V,B){if(this.x)return this.x.getWorkspaceFolder(V,B)}async getWorkspaceFolder2(V,B){if(await this.k.wait(),!!this.x)return this.x.getWorkspaceFolder(V,B)}async resolveWorkspaceFolder(V){if(await this.k.wait(),!!this.x)return this.x.resolveWorkspaceFolder(V)}getPath(){if(!this.x)return;const{folders:V}=this.x;if(V.length!==0)return V[0].uri.fsPath}getRelativePath(V,B){let j,U="";if(typeof V=="string"?(j=u.URI.file(V),U=V):typeof V<"u"&&(j=V,U=V.fsPath),!j)return U;const z=this.getWorkspaceFolder(j,!0);if(!z)return U;typeof B>"u"&&this.x&&(B=this.x.folders.length>1);let ie=(0,P.$ig)(z.uri,j);return B&&z.name&&(ie=`${z.name}/${ie}`),ie}y(V){this.x&&(this.n=l.toExtHostWorkspace({id:this.x.id,name:this.x.name,configuration:this.x.configuration,folders:V,isUntitled:this.x.isUntitled},this.x,void 0,this.s).workspace||void 0)}$acceptWorkspaceData(V){const{workspace:B,added:j,removed:U}=l.toExtHostWorkspace(V,this.l,this.n,this.s);this.l=B||void 0,this.n=void 0,this.c.fire(Object.freeze({added:j,removed:U}))}findFiles(V,B,j,U,z=C.CancellationToken.None){this.h.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${U.value}, entryPoint: findFiles`);let ie;if(B===null?ie=!1:B&&(typeof B=="string"?ie=B:ie=B.pattern),z&&z.isCancellationRequested)return Promise.resolve([]);const{includePattern:Y,folder:ye}=F(b.GlobPattern.from(V));return this.o.$startFileSearch(Y??null,ye??null,ie??null,j??null,z).then(ke=>Array.isArray(ke)?ke.map(Re=>u.URI.revive(Re)):[])}async findTextInFiles(V,B,j,U,z=C.CancellationToken.None){this.h.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${U.value}, entryPoint: findTextInFiles`);const ie=this.j.getNext(),Y=typeof B.previewOptions>"u"?{matchLines:100,charsPerLine:1e4}:B.previewOptions,{includePattern:ye,folder:ke}=F(b.GlobPattern.from(B.include)),Re=typeof B.exclude=="string"?B.exclude:B.exclude?B.exclude.pattern:void 0,X={ignoreSymlinks:typeof B.followSymlinks=="boolean"?!B.followSymlinks:void 0,disregardIgnoreFiles:typeof B.useIgnoreFiles=="boolean"?!B.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof B.useGlobalIgnoreFiles=="boolean"?!B.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof B.useParentIgnoreFiles=="boolean"?!B.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof B.useDefaultExcludes=="boolean"?!B.useDefaultExcludes:!0,fileEncoding:B.encoding,maxResults:B.maxResults,previewOptions:Y,afterContext:B.afterContext,beforeContext:B.beforeContext,includePattern:ye,excludePattern:Re},le=!1;if(this.u[ie]=we=>{if(le)return;const ae=u.URI.revive(we.resource);we.results.forEach(x=>{(0,s.$fI)(x)?j({uri:ae,preview:{text:x.preview.text,matches:(0,y.$Uf)(x.preview.matches,ue=>new n.$WJ(ue.startLineNumber,ue.startColumn,ue.endLineNumber,ue.endColumn))},ranges:(0,y.$Uf)(x.ranges,ue=>new n.$WJ(ue.startLineNumber,ue.startColumn,ue.endLineNumber,ue.endColumn))}):j({uri:ae,text:x.text,lineNumber:x.lineNumber})})},z.isCancellationRequested)return{};try{const we=await this.o.$startTextSearch(V,ke??null,X,ie,z);return delete this.u[ie],we||{}}catch(we){throw delete this.u[ie],we}}$handleTextSearchResult(V,B){this.u[B]?.(V)}async save(V){const B=await this.o.$save(V,{saveAs:!1});return u.URI.revive(B)}async saveAs(V){const B=await this.o.$save(V,{saveAs:!0});return u.URI.revive(B)}saveAll(V){return this.o.$saveAll(V)}resolveProxy(V){return this.o.$resolveProxy(V)}get trusted(){return this.v}requestWorkspaceTrust(V){return this.o.$requestWorkspaceTrust(V)}$onDidGrantWorkspaceTrust(){this.v||(this.v=!0,this.g.fire())}registerEditSessionIdentityProvider(V,B){if(this.w.has(V))throw new Error(`A provider has already been registered for scheme ${V}`);this.w.set(V,B);const j=this.t.transformOutgoingScheme(V),U=this.z++;return this.o.$registerEditSessionIdentityProvider(U,j),(0,A.$kb)(()=>{this.w.delete(V),this.o.$unregisterEditSessionIdentityProvider(U)})}async $getEditSessionIdentifier(V,B){this.h.info("Getting edit session identifier for workspaceFolder",V);const j=await this.resolveWorkspaceFolder(u.URI.revive(V));if(!j){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",j);const U=this.w.get(j.uri.scheme);if(this.h.info(`Provider for scheme ${j.uri.scheme} is defined: `,!!U),!U)return;const z=await U.provideEditSessionIdentity(j,B);if(this.h.info("Provider returned edit session identifier: ",z),!!z)return z}async $provideEditSessionIdentityMatch(V,B,j,U){this.h.info("Getting edit session identifier for workspaceFolder",V);const z=await this.resolveWorkspaceFolder(u.URI.revive(V));if(!z){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",z);const ie=this.w.get(z.uri.scheme);if(this.h.info(`Provider for scheme ${z.uri.scheme} is defined: `,!!ie),!ie)return;const Y=await ie.provideEditSessionIdentityMatch?.(B,j,U);if(this.h.info("Provider returned edit session identifier match result: ",Y),!!Y)return Y}getOnWillCreateEditSessionIdentityEvent(V){return(B,j,U)=>{const z=function(Y){B.call(j,Y)};return z.extension=V,this.A.event(z,void 0,U)}}async $onWillCreateEditSessionIdentity(V,B,j){const U=await this.resolveWorkspaceFolder(u.URI.revive(V));if(U===void 0)throw new Error("Unable to resolve workspace folder");await this.A.fireAsync({workspaceFolder:U},B,async(z,ie)=>{const Y=Date.now();await Promise.resolve(z),Date.now()-Y>j&&this.h.warn("SLOW edit session create-participant",ie.extension.identifier)}),B.isCancellationRequested}registerCanonicalUriProvider(V,B){if(this.B.has(V))throw new Error(`A provider has already been registered for scheme ${V}`);this.B.set(V,B);const j=this.t.transformOutgoingScheme(V),U=this.z++;return this.o.$registerCanonicalUriProvider(U,j),(0,A.$kb)(()=>{this.B.delete(V),this.o.$unregisterCanonicalUriProvider(U)})}async provideCanonicalUri(V,B,j){const U=this.B.get(V.scheme);if(!U)return;const z=await U.provideCanonicalUri?.(u.URI.revive(V),B,j);if(z)return z}async $provideCanonicalUri(V,B,j){return this.provideCanonicalUri(u.URI.revive(V),{targetScheme:B},j)}};e.$Iac=f,e.$Iac=f=Ke([Ve(0,E.$UL),Ve(1,m.$$L),Ve(2,c.$wac),Ve(3,d.$3i),Ve(4,a.$Gac)],f),e.$Jac=(0,$.$zh)("IExtHostWorkspace");function F(W){let V,B;return W&&(typeof W=="string"?V=W:(V=W.pattern,B=u.URI.revive(W.baseUri))),{includePattern:V,folder:B}}}),define(Pe[34],Ae([1,0,24,5,33,3,7,178,96,16,13,4,17,14,2]),function(pe,e,y,R,C,L,A,h,S,g,P,D,u,p,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mac=e.$Lac=e.$Kac=void 0;function d(a,s){if(s){const o=s.split(".");let w=a;for(let v=0;w&&v<o.length;v++)w=w[o[v]];return w}}function t(a){return a instanceof $.URI}function i(a){return a&&a.uri instanceof $.URI&&a.languageId&&typeof a.languageId=="string"}function c(a){return a&&!a.uri&&a.languageId&&typeof a.languageId=="string"}function m(a){return a&&a.uri instanceof $.URI&&(!a.name||typeof a.name=="string")&&(!a.index||typeof a.index=="number")}function E(a){if(t(a))return{resource:a};if(i(a))return{resource:a.uri,overrideIdentifier:a.languageId};if(c(a))return{overrideIdentifier:a.languageId};if(m(a))return{resource:a.uri};if(a===null)return{resource:null}}let b=class{constructor(s,o,w){this.a=s.getProxy(L.$SJ.MainThreadConfiguration),this.c=o,this.b=w,this.d=new P.$Dg,this.e=null}getConfigProvider(){return this.d.wait().then(s=>this.e)}$initializeConfiguration(s){this.e=new n(this.a,this.c,s,this.b),this.d.open()}$acceptConfigurationChanged(s,o){this.getConfigProvider().then(w=>w.$acceptConfigurationChanged(s,o))}};e.$Kac=b,e.$Kac=b=Ke([Ve(0,u.$UL),Ve(1,C.$Jac),Ve(2,p.$3i)],b);class n{constructor(s,o,w,v){this.a=new R.$hc,this.b=s,this.f=v,this.c=o,this.e=h.$rn.parse(w),this.d=this.k(w.configurationScopes)}get onDidChangeConfiguration(){return this.a&&this.a.event}$acceptConfigurationChanged(s,o){const w={data:this.e.toData(),workspace:this.c.workspace};this.e=h.$rn.parse(s),this.d=this.k(s.configurationScopes),this.a.fire(this.j(o,w))}getConfiguration(s,o,w){const v=E(o)||{},I=this.g(s?d(this.e.getValue(void 0,v,this.c.workspace),s):this.e.getValue(void 0,v,this.c.workspace));s&&this.h(s,v,w?.identifier);function k(l){if(l==null)return null;if(typeof l=="boolean")return l?2:5;switch(l){case A.ConfigurationTarget.Global:return 2;case A.ConfigurationTarget.Workspace:return 5;case A.ConfigurationTarget.WorkspaceFolder:return 6}}const r={has(l){return typeof d(I,l)<"u"},get:(l,f)=>{this.h(s?`${s}.${l}`:l,v,w?.identifier);let F=d(I,l);if(typeof F>"u")F=f;else{let W;const V=(B,j)=>{if((0,g.$ne)(B)){let U;const z=()=>{W=W||(0,y.$Tm)(I),U=U||d(W,j)};return new Proxy(B,{get:(ie,Y)=>{if(typeof Y=="string"&&Y.toLowerCase()==="tojson")return z(),()=>U;if(W)return U=U||d(W,j),U[Y];const ye=ie[Y];return typeof Y=="string"?V(ye,`${j}.${Y}`):ye},set:(ie,Y,ye)=>(z(),U&&(U[Y]=ye),!0),deleteProperty:(ie,Y)=>(z(),U&&delete U[Y],!0),defineProperty:(ie,Y,ye)=>(z(),U&&Object.defineProperty(U,Y,ye),!0)})}return Array.isArray(B)?(0,y.$Tm)(B):B};F=V(F,l)}return F},update:(l,f,F,W)=>{l=s?`${s}.${l}`:l;const V=k(F);return f!==void 0?this.b.$updateConfigurationOption(V,l,f,v,W):this.b.$removeConfigurationOption(V,l,v,W)},inspect:l=>{l=s?`${s}.${l}`:l;const f=this.e.inspect(l,v,this.c.workspace);if(f)return{key:l,defaultValue:(0,y.$Tm)(f.policy?.value??f.default?.value),globalValue:(0,y.$Tm)(f.user?.value??f.application?.value),workspaceValue:(0,y.$Tm)(f.workspace?.value),workspaceFolderValue:(0,y.$Tm)(f.workspaceFolder?.value),defaultLanguageValue:(0,y.$Tm)(f.default?.override),globalLanguageValue:(0,y.$Tm)(f.user?.override??f.application?.override),workspaceLanguageValue:(0,y.$Tm)(f.workspace?.override),workspaceFolderLanguageValue:(0,y.$Tm)(f.workspaceFolder?.override),languageIds:(0,y.$Tm)(f.overrideIdentifiers)}}};return typeof I=="object"&&(0,y.$Wm)(r,I,!1),Object.freeze(r)}g(s){const o=w=>(0,g.$ne)(w)?new Proxy(w,{get:(v,I)=>o(v[I]),set:(v,I,k)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(I)}' of object`)},deleteProperty:(v,I)=>{throw new Error(`TypeError: Cannot delete read only property '${String(I)}' of object`)},defineProperty:(v,I)=>{throw new Error(`TypeError: Cannot define property '${String(I)}' for a readonly object`)},setPrototypeOf:v=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):w;return o(s)}h(s,o,w){const v=S.$in.test(s)?4:this.d.get(s),I=w?`[${w.value}] `:"";if(v===4){typeof o?.resource>"u"&&this.f.warn(`${I}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${s}', provide the URI of a resource or 'null' for any resource.`);return}if(v===3){o?.resource&&this.f.warn(`${I}Accessing a window scoped configuration for a resource is not expected. To associate '${s}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}j(s,o){const w=new h.$tn(s,o,this.e,this.c.workspace);return Object.freeze({affectsConfiguration:(v,I)=>w.affectsConfiguration(v,E(I))})}k(s){return s.reduce((o,w)=>(o.set(w[0],w[1]),o),new Map)}}e.$Lac=n,e.$Mac=(0,D.$zh)("IExtHostConfiguration")}),define(Pe[112],Ae([1,0,2,13,5,3,7,33,59,34,21,62,17,27,4,12,22,14,80,215,9]),function(pe,e,y,R,C,L,A,h,S,g,P,D,u,p,$,d,t,i,c,m,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kbc=e.$Jbc=e.$Ibc=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=void 0;var b;(function(V){function B(U){if(U!=null)return U}V.from=B;function j(U){if(U!=null)return U}V.to=j})(b||(b={}));var n;(function(V){function B(U){if(U!=null)return U}V.from=B;function j(U){if(U!=null)return U}V.to=j})(n||(n={}));var a;(function(V){function B(U){if(U!=null)return U}V.from=B;function j(U){if(U!=null)return U}V.to=j})(a||(a={}));var s;(function(V){function B(z){if(z){const ie=z;return ie&&!!ie.process}else return!1}V.is=B;function j(z){if(z==null)return;const ie={process:z.process,args:z.args};return z.options&&(ie.options=a.from(z.options)),ie}V.from=j;function U(z){if(z!=null)return new A.$DK(z.process,z.args,z.options)}V.to=U})(s||(s={}));var o;(function(V){function B(U){if(U!=null)return U}V.from=B;function j(U){if(U!=null)return U}V.to=j})(o||(o={}));var w;(function(V){function B(z){if(z){const ie=z;return ie&&(!!ie.commandLine||!!ie.command)}else return!1}V.is=B;function j(z){if(z==null)return;const ie={};return z.commandLine!==void 0?ie.commandLine=z.commandLine:(ie.command=z.command,ie.args=z.args),z.options&&(ie.options=o.from(z.options)),ie}V.from=j;function U(z){if(!(z==null||z.command===void 0&&z.commandLine===void 0))return z.commandLine?new A.$EK(z.commandLine,z.options):new A.$EK(z.command,z.args?z.args:[],z.options)}V.to=U})(w||(w={}));var v;(function(V){function B(z){if(z){const ie=z;return ie&&ie.customExecution==="customExecution"}else return!1}V.is=B;function j(z){return{customExecution:"customExecution"}}V.from=j;function U(z,ie){return ie.get(z)}V.to=U})(v||(e.CustomExecutionDTO=v={}));var I;(function(V){function B(j,U){let z;return j.scope!==void 0&&typeof j.scope!="number"?z=j.scope.uri:j.scope!==void 0&&typeof j.scope=="number"&&(j.scope===A.TaskScope.Workspace&&U&&U.workspaceFile?z=U.workspaceFile:z=m.$8F),{id:j._id,workspaceFolder:z}}V.from=B})(I||(e.TaskHandleDTO=I={}));var k;(function(V){function B(j){if(j!=null)return{_id:j.id,isDefault:j.isDefault}}V.from=B})(k||(k={}));var r;(function(V){function B(z,ie){if(z==null)return[];const Y=[];for(const ye of z){const ke=j(ye,ie);ke&&Y.push(ke)}return Y}V.fromMany=B;function j(z,ie){if(z==null)return;let Y;z.execution instanceof A.$DK?Y=s.from(z.execution):z.execution instanceof A.$EK?Y=w.from(z.execution):z.execution&&z.execution instanceof A.$FK&&(Y=v.from(z.execution));const ye=b.from(z.definition);let ke;return z.scope?typeof z.scope=="number"?ke=z.scope:ke=z.scope.uri:ke=A.TaskScope.Workspace,!ye||!ke?void 0:{_id:z._id,definition:ye,name:z.name,source:{extensionId:ie.identifier.value,label:z.source,scope:ke},execution:Y,isBackground:z.isBackground,group:k.from(z.group),presentationOptions:n.from(z.presentationOptions),problemMatchers:z.problemMatchers,hasDefinedMatchers:z.hasDefinedMatchers,runOptions:z.runOptions?z.runOptions:{reevaluateOnRerun:!0},detail:z.detail}}V.from=j;async function U(z,ie,Y){if(z==null)return;let ye;s.is(z.execution)?ye=s.to(z.execution):w.is(z.execution)?ye=w.to(z.execution):v.is(z.execution)&&(ye=v.to(z._id,Y));const ke=b.to(z.definition);let Re;if(z.source&&(z.source.scope!==void 0?typeof z.source.scope=="number"?Re=z.source.scope:Re=await ie.resolveWorkspaceFolder(y.URI.revive(z.source.scope)):Re=A.TaskScope.Workspace),!ke||!Re)return;const X=new A.$GK(ke,Re,z.name,z.source.label,ye,z.problemMatchers);return z.isBackground!==void 0&&(X.isBackground=z.isBackground),z.group!==void 0&&(X.group=A.$CK.from(z.group._id),X.group&&z.group.isDefault&&(X.group=new A.$CK(X.group.id,X.group.label),z.group.isDefault===!0&&(X.group.isDefault=z.group.isDefault))),z.presentationOptions&&(X.presentationOptions=n.to(z.presentationOptions)),z._id&&(X._id=z._id),z.detail&&(X.detail=z.detail),X}V.to=U})(r||(e.TaskDTO=r={}));var l;(function(V){function B(U){return U}V.from=B;function j(U){if(U)return Object.assign(Object.create(null),U)}V.to=j})(l||(l={}));class f{#e;constructor(B,j,U){this._id=j,this.a=U,this.#e=B}get task(){return this.a}terminate(){this.#e.terminateTask(this)}fireDidStartProcess(B){}fireDidEndProcess(B){}}let F=class{constructor(B,j,U,z,ie,Y,ye,ke){this.q=new C.$hc,this.r=new C.$hc,this.s=new C.$hc,this.t=new C.$hc,this.a=B.getProxy(L.$SJ.MainThreadTask),this.b=U,this.c=z,this.d=ie,this.e=Y,this.h=0,this.j=new Map,this.k=new Map,this.l=new Map,this.m=new Map,this.n=new Set,this.o=new Map,this.f=ye,this.g=ke,this.a.$registerSupportedExecutions(!0)}registerTaskProvider(B,j,U){if(!U)return new A.$UJ(()=>{});const z=this.w();return this.j.set(z,{type:j,provider:U,extension:B}),this.a.$registerTaskProvider(z,j),new A.$UJ(()=>{this.j.delete(z),this.a.$unregisterTaskProvider(z)})}registerTaskSystem(B,j){this.a.$registerTaskSystem(B,j)}fetchTasks(B){return this.a.$fetchTasks(l.from(B)).then(async j=>{const U=[];for(const z of j){const ie=await r.to(z,this.b,this.m);ie&&U.push(ie)}return U})}get taskExecutions(){const B=[];return this.k.forEach(j=>B.push(j)),B}terminateTask(B){if(!(B instanceof f))throw new Error("No valid task execution provided");return this.a.$terminateTask(B._id)}get onDidStartTask(){return this.q.event}async $onDidStartTask(B,j,U){const z=this.m.get(B.id);z&&(this.o.set(B.id,z),this.e.attachPtyToTerminal(j,await z.callback(U))),this.p=B.id,this.q.fire({execution:await this.y(B)})}get onDidEndTask(){return this.r.event}async $OnDidEndTask(B){const j=await this.y(B);this.l.delete(B.id),this.k.delete(B.id),this.A(B),this.r.fire({execution:j})}get onDidStartTaskProcess(){return this.s.event}async $onDidStartTaskProcess(B){const j=await this.y(B.id);this.s.fire({execution:j,processId:B.processId})}get onDidEndTaskProcess(){return this.t.event}async $onDidEndTaskProcess(B){const j=await this.y(B.id);this.t.fire({execution:j,exitCode:B.exitCode})}$provideTasks(B,j){const U=this.j.get(B);if(!U)return Promise.reject(new Error("no handler found"));const z=[],ie=(0,R.$xg)(()=>U.provider.provideTasks(P.CancellationToken.None)).then(Y=>this.u(j,z,U,Y));return new Promise(Y=>{ie.then(ye=>{Promise.all(z).then(()=>{Y(ye)})})})}async $resolveTask(B,j){const U=this.j.get(B);if(!U)return Promise.reject(new Error("no handler found"));if(j.definition.type!==U.type)throw new Error(`Unexpected: Task of type [${j.definition.type}] cannot be resolved by provider of type [${U.type}].`);const z=await r.to(j,this.b,this.m);if(!z)throw new Error("Unexpected: Task cannot be resolved.");const ie=await U.provider.resolveTask(z,P.CancellationToken.None);if(!ie)return;this.z(ie,U);const Y=r.from(ie,U.extension);if(!Y)throw new Error("Unexpected: Task cannot be resolved.");if(ie.definition!==z.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return v.is(Y.execution)&&await this.x(Y,ie,!0),await this.v(Y)}w(){return this.h++}async x(B,j,U){const z=await this.a.$createTaskId(B);!U&&!this.m.has(z)&&(this.n.add(z),this.o.set(z,j.execution)),this.m.set(z,j.execution)}async y(B,j){if(typeof B=="string"){const ie=this.l.get(B);if(!ie)throw new E.$_("Unexpected: The specified task is missing an execution");return ie}const U=this.l.get(B.id);if(U)return U;const z=new Promise((ie,Y)=>{function ye(ke,Re,X){X?ie(new f(ke,Re.id,X)):Y("Unexpected: Task does not exist.")}j?ye(this,B,j):r.to(B.task,this.b,this.m).then(ke=>ye(this,B,ke))});return this.l.set(B.id,z),z.then(ie=>(this.k.set(B.id,ie),ie),ie=>Promise.reject(ie))}z(B,j){B._deprecated&&this.g.report("Task.constructor",j.extension,"Use the Task constructor that takes a `scope` instead.")}A(B){this.o.get(B.id)&&this.o.delete(B.id),this.n.has(B.id)&&this.p!==B.id&&(this.m.delete(B.id),this.n.delete(B.id));const U=this.n.values();let z=U.next();for(;!z.done;)!this.o.has(z.value)&&this.p!==z.value&&(this.m.delete(z.value),this.n.delete(z.value)),z=U.next()}};e.$Ibc=F,e.$Ibc=F=Ke([Ve(0,u.$UL),Ve(1,p.$$L),Ve(2,h.$Jac),Ve(3,S.$6L),Ve(4,g.$Mac),Ve(5,D.$5ac),Ve(6,i.$3i),Ve(7,c.$zac)],F);let W=class extends F{constructor(B,j,U,z,ie,Y,ye,ke){super(B,j,U,z,ie,Y,ye,ke),this.registerTaskSystem(d.Schemas.vscodeRemote,{scheme:d.Schemas.vscodeRemote,authority:"",platform:t.$h(0)})}async executeTask(B,j){if(!j.execution)throw new Error("Tasks to execute must include an execution");const U=r.from(j,B);if(U===void 0)throw new Error("Task is not valid");if(v.is(U.execution))await this.x(U,j,!1);else throw new E.$0;const z=await this.y(await this.a.$getTaskExecution(U),j);return this.a.$executeTask(U).catch(ie=>{throw new Error(ie)}),z}u(B,j,U,z){const ie=[];if(z)for(const Y of z){this.z(Y,U),(!Y.definition||!B[Y.definition.type])&&this.f.warn(`The task [${Y.source}, ${Y.name}] uses an undefined task type. The task will be ignored in the future.`);const ye=r.from(Y,U.extension);ye&&v.is(ye.execution)?(ie.push(ye),j.push(this.x(ye,Y,!0))):this.f.warn("Only custom execution tasks supported.")}return{tasks:ie,extension:U.extension}}async v(B){if(v.is(B.execution))return B;this.f.warn("Only custom execution tasks supported.")}async $resolveVariables(B,j){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(B,j,U){}};e.$Jbc=W,e.$Jbc=W=Ke([Ve(0,u.$UL),Ve(1,p.$$L),Ve(2,h.$Jac),Ve(3,S.$6L),Ve(4,g.$Mac),Ve(5,D.$5ac),Ve(6,i.$3i),Ve(7,c.$zac)],W),e.$Kbc=(0,$.$zh)("IExtHostTask")}),define(Pe[266],Ae([1,0,19,21,41,37,23,58,47]),function(pe,e,y,R,C,L,A,h,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ubc=void 0;class g{constructor(u,p,$){this.k=u,this.l=p,this.o=$,this.e=!1,this.f=0,this.g=!1,this.a=u.filePattern,this.b=u.includePattern&&L.$pj(u.includePattern),this.c=u.maxResults||void 0,this.d=u.exists,this.h=new Set,this.j=u.excludePattern&&L.$pj(u.excludePattern)}cancel(){this.g=!0,this.h.forEach(u=>u.cancel()),this.h=new Set}search(u){const p=this.k.folderQueries||[];return new Promise(($,d)=>{const t=i=>{this.f++,u(i)};if(this.g)return $({limitHit:this.e});this.k.extraFileResources&&this.k.extraFileResources.forEach(i=>{const c=i.toString(),m=y.$cd(c);this.j&&this.j(c,m)||this.v(t,{base:i,basename:m})}),Promise.all(p.map(i=>this.p(i,t))).then(i=>{$({limitHit:this.e,stats:i[0]||void 0})},i=>{d(new Error((0,C.$ki)(i)))})})}async p(u,p){const $=new R.$rc,d=this.q(u),t=this.r(),i=new S.$xI(this.k,u),c=!i.hasSiblingExcludeClauses();let m;try{this.h.add($),m=h.$dc.create();const E=await this.l.provideFileSearchResults({pattern:this.k.filePattern||""},d,$.token),b=m.elapsed(),n=h.$dc.create();return this.g&&!this.e||(E&&E.forEach(a=>{const s=y.$8c.relative(u.folder.path,a.path);if(c){const o=y.$cd(a.path);this.v(p,{base:u.folder,relativePath:s,basename:o});return}this.s(t,u.folder,s,p)}),this.g&&!this.e)?null:(this.u(t,i,p),{providerTime:b,postProcessTime:n.elapsed()})}finally{$.dispose(),this.h.delete($)}}q(u){const p=(0,S.$wI)(this.k.includePattern,u.includePattern),$=(0,S.$wI)(this.k.excludePattern,u.excludePattern);return{folder:u.folder,excludes:$,includes:p,useIgnoreFiles:!u.disregardIgnoreFiles,useGlobalIgnoreFiles:!u.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!u.disregardParentIgnoreFiles,followSymlinks:!u.ignoreSymlinks,maxResults:this.k.maxResults,session:this.o}}r(){const u={rootEntries:[],pathToEntries:Object.create(null)};return u.pathToEntries["."]=u.rootEntries,u}s({pathToEntries:u},p,$,d){if($===this.a){const i=y.$cd(this.a);this.v(d,{base:p,relativePath:this.a,basename:i})}function t(i){const c=y.$cd(i),m=y.$bd(i);let E=u[m];E||(E=u[m]=[],t(m)),E.push({base:p,relativePath:i,basename:c})}t($)}u({rootEntries:u,pathToEntries:p},$,d){const t=this,i=this.a;function c(m){const E=(0,S.$zI)(()=>m.map(b=>b.basename));for(let b=0,n=m.length;b<n;b++){const a=m[b],{relativePath:s,basename:o}=a;if($.matchesExcludesSync(s,o,i!==o?E:void 0))continue;const w=p[s];if(w)c(w);else{if(s===i)continue;t.v(d,a)}if(t.e)break}}c(u)}v(u,p){(!this.b||p.relativePath&&this.b(p.relativePath,p.basename))&&((this.d||this.c&&this.f>=this.c)&&(this.e=!0,this.cancel()),this.e||u(p))}}class P{constructor(){this.b=new Map}static{this.a=512}fileSearch(u,p,$,d){const t=this.c(u.cacheKey),i=new g(u,p,t&&t.token);let c=0;const m=E=>{c+=E.length,$(E.map(b=>this.d(b)))};return this.e(i,P.a,m,d).then(E=>({limitHit:E.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:c,detailStats:E.stats}}))}clearCache(u){this.c(u)?.cancel()}c(u){if(u)return this.b.has(u)||this.b.set(u,new R.$rc),this.b.get(u)}d(u){return u.relativePath?{resource:A.$gg(u.base,u.relativePath)}:{resource:u.base}}e(u,p,$,d){const t=d.onCancellationRequested(()=>{u.cancel()}),i=m=>{m&&(c.push(m),p>0&&c.length>=p&&($(c),c=[]))};let c=[];return u.search(i).then(m=>(c.length&&$(c),t.dispose(),m),m=>(c.length&&$(c),t.dispose(),Promise.reject(m)))}}e.$Ubc=P}),define(Pe[267],Ae([1,0,18,100,37,90,28,12,19,23,15,16,2,282,168,43,14,53,103,265,47]),function(pe,e,y,R,C,L,A,h,S,g,P,D,u,p,$,d,t,i,c,m,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rJ=e.$qJ=void 0;let b=class{constructor(l,f,F,W,V){this.a=l,this.b=f,this.c=F,this.d=W,this.e=V}text(l,f,F={}){l=this.f(l,F);const W=this.a.getValue(),V=f&&f.some(j=>!this.a.getValue({resource:j}).search.useRipgrep);return{...this.h(f?.map(i.$Uh),F),type:2,contentPattern:l,previewOptions:F.previewOptions,maxFileSize:F.maxFileSize,usePCRE2:W.search.usePCRE2||V||!1,beforeContext:F.beforeContext,afterContext:F.afterContext,userDisabledExcludesAndIgnoreFiles:F.disregardExcludeSettings&&F.disregardIgnoreFiles}}f(l,f){const F=this.a.getValue();l.isRegExp&&(l.pattern=l.pattern.replace(/\r?\n/g,"\\n"));const W={...l,wordSeparators:F.editor.wordSeparators};return this.j(l,f)&&(W.isCaseSensitive=!0),this.k(l)&&(W.isMultiline=!0),f.notebookSearchConfig?.includeMarkupInput&&(W.notebookInfo||(W.notebookInfo={}),W.notebookInfo.isInNotebookMarkdownInput=f.notebookSearchConfig.includeMarkupInput),f.notebookSearchConfig?.includeMarkupPreview&&(W.notebookInfo||(W.notebookInfo={}),W.notebookInfo.isInNotebookMarkdownPreview=f.notebookSearchConfig.includeMarkupPreview),f.notebookSearchConfig?.includeCodeInput&&(W.notebookInfo||(W.notebookInfo={}),W.notebookInfo.isInNotebookCellInput=f.notebookSearchConfig.includeCodeInput),f.notebookSearchConfig?.includeOutput&&(W.notebookInfo||(W.notebookInfo={}),W.notebookInfo.isInNotebookCellOutput=f.notebookSearchConfig.includeOutput),W}file(l,f={}){return{...this.h(l,f),type:1,filePattern:f.filePattern?f.filePattern.trim():f.filePattern,exists:f.exists,sortByScore:f.sortByScore,cacheKey:f.cacheKey}}g(l,f){return l?(l=Array.isArray(l)?l.map(w):w(l),f?this.parseSearchPaths(l):{pattern:a(...Array.isArray(l)?l:[l])}):{}}h(l=[],f={}){const F=this.g(f.includePattern,f.expandPatterns),W=this.g(f.excludePattern,f.expandPatterns),V=l.length>1,B=(F.searchPaths&&F.searchPaths.length?F.searchPaths.map(z=>this.q(z,f,W)):l.map(z=>this.r(z,f,W,V))).filter(z=>!!z),j={_reason:f._reason,folderQueries:B,usingSearchPaths:!!(F.searchPaths&&F.searchPaths.length),extraFileResources:f.extraFileResources,excludePattern:W.pattern,includePattern:F.pattern,onlyOpenEditors:f.onlyOpenEditors,maxResults:f.maxResults};if(f.onlyOpenEditors){const z=y.$Af(y.$Kf(this.c.groups.map(ye=>ye.editors.map(ke=>ke.resource))));this.d.trace("QueryBuilder#commonQuery - openEditor URIs",JSON.stringify(z));const ie=z.filter(ye=>(0,E.$nI)(j,ye.fsPath)),Y=this.i(ie);return this.d.trace("QueryBuilder#commonQuery - openEditor Query",JSON.stringify(Y)),{...j,...Y}}const U=f.extraFileResources&&f.extraFileResources.filter(z=>(0,E.$nI)(j,z.fsPath));return j.extraFileResources=U&&U.length?U:void 0,j}i(l){const f=[],F=new A.$xi,W={};let V=!1;return l.forEach(B=>{if(B.scheme===h.Schemas.walkThrough)return;if((0,g.$kg)(B)){const U=this.b.getWorkspaceFolder(B)?.uri??B.with({path:S.$bd(B.fsPath)});let z=F.get(U);z||(V=!0,z={folder:U,includePattern:{}},f.push(z),F.set(U,z));const ie=S.$ad(U.fsPath,B.fsPath);(0,D.$we)(z.includePattern)[ie.replace(/\\/g,"/")]=!0}else B.fsPath&&(V=!0,W[B.fsPath]=!0)}),{folderQueries:f,includePattern:W,usingSearchPaths:!0,excludePattern:V?void 0:{"**/*":!0}}}j(l,f){if(f.isSmartCase){if(l.isRegExp){if(P.$ce(l.pattern,!0))return!0}else if(P.$ce(l.pattern))return!0}return!!l.isCaseSensitive}k(l){return l.isMultiline||l.isRegExp&&(0,p.$eC)(l.pattern)||l.pattern.indexOf(`
`)>=0?!0:!!l.isMultiline}parseSearchPaths(l){const f=Y=>S.$0c(Y)||/^\.\.?([\/\\]|$)/.test(Y),W=(Array.isArray(l)?l:s(l)).map(Y=>{const ye=this.e.resolvedUserHome;return ye?(0,L.$dA)(Y,ye.scheme===h.Schemas.file?ye.fsPath:ye.path):Y}),V=R.$I(W,Y=>f(Y)?"searchPaths":"exprSegments"),B=(V.exprSegments||[]).map(Y=>P.$xd(Y,"/")).map(Y=>P.$xd(Y,"\\")).map(Y=>(Y[0]==="."&&(Y="*"+Y),o(Y))),j={},U=this.m(V.searchPaths||[]);U&&U.length&&(j.searchPaths=U);const z=y.$Kf(B),ie=a(...z);return ie&&(j.pattern=ie),j}l(l,f){return f.disregardExcludeSettings?void 0:(0,E.$mI)(l,!f.disregardSearchExcludeSettings)}m(l){if(!l||!l.length)return[];const f=l.flatMap(W=>{let{pathPortion:V,globPortion:B}=n(W);return B&&(B=v(B)),this.n(V).flatMap(U=>this.o(U,B))}),F=new Map;return f.forEach(W=>{const V=W.searchPath.toString(),B=F.get(V);B?W.pattern&&(B.pattern=B.pattern||{},B.pattern[W.pattern]=!0):F.set(V,{searchPath:W.searchPath,pattern:W.pattern?a(W.pattern):void 0})}),Array.from(F.values())}n(l){if(S.$0c(l)){const f=this.b.getWorkspace().folders;return f[0]&&f[0].uri.scheme!==h.Schemas.file?[{searchPath:f[0].uri.with({path:l})}]:[{searchPath:u.URI.file(S.$9c(l))}]}if(this.b.getWorkbenchState()===2){const f=this.b.getWorkspace().folders[0].uri;if(l=w(l),l.startsWith("../")||l===".."){const W=S.$8c.resolve(f.path,l);return[{searchPath:f.with({path:W})}]}const F=v(l);return[{searchPath:f,pattern:F}]}else{if(l==="./"||l===".\\")return[];{const f=l.replace(/^\.[\/\\]/,""),W=this.b.getWorkspace().folders.map(V=>{const B=f.match(new RegExp(`^${P.$sd(V.name)}(?:/(.*)|$)`));return B?{match:B,folder:V}:null}).filter(D.$te);if(W.length)return W.map(V=>{const B=V.match[1];return{searchPath:V.folder.uri,pattern:B&&v(B)}});{const V=l.match(/\.[\/\\](.+)[\/\\]?/),B=V?V[1]:l,j=$.localize(0,null,B);throw new Error(j)}}}}o(l,f){const F=l.pattern&&f?`${l.pattern}/${f}`:l.pattern||f,W=[{searchPath:l.searchPath,pattern:F}];return F&&!F.endsWith("**")&&W.push({searchPath:l.searchPath,pattern:F+"/**"}),W}q(l,f,F){const W=this.r((0,i.$Uh)(l.searchPath),f,F,!1);return W?{...W,includePattern:l.pattern}:null}r(l,f,F,W){let V;const B=u.URI.isUri(l)?l:l.uri;if(F.searchPaths){const Y=F.searchPaths.filter(ye=>(0,g.$_f)(ye.searchPath,B))[0];if(Y&&!Y.pattern)return null;Y&&(V=Y.pattern)}const j=this.a.getValue({resource:B}),z={...this.l(j,f)||{},...V||{}},ie=u.URI.isUri(l)?(0,g.$dg)(l):l.name;return{folder:B,folderName:W?ie:void 0,excludePattern:Object.keys(z).length>0?z:void 0,fileEncoding:j.files&&j.files.encoding,disregardIgnoreFiles:typeof f.disregardIgnoreFiles=="boolean"?f.disregardIgnoreFiles:!j.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof f.disregardGlobalIgnoreFiles=="boolean"?f.disregardGlobalIgnoreFiles:!j.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof f.disregardParentIgnoreFiles=="boolean"?f.disregardParentIgnoreFiles:!j.search.useParentIgnoreFiles,ignoreSymlinks:typeof f.ignoreSymlinks=="boolean"?f.ignoreSymlinks:!j.search.followSymlinks}}};e.$qJ=b,e.$qJ=b=Ke([Ve(0,d.$6h),Ve(1,i.$Ih),Ve(2,c.$1C),Ve(3,t.$3i),Ve(4,m.$oJ)],b);function n(r){const l=r.match(/[\*\{\}\(\)\[\]\?]/);if(l){const f=l.index,F=r.substr(0,f).match(/[/|\\][^/\\]*$/);if(F){let W=r.substr(0,F.index);return W.match(/[/\\]/)||(W+="/"),{pathPortion:W,globPortion:r.substr((F.index||0)+1)}}}return{pathPortion:r}}function a(...r){return r.length?r.reduce((l,f)=>(l[f]=!0,l),Object.create(null)):void 0}function s(r){return C.$nj(r,",").map(l=>l.trim()).filter(l=>!!l.length)}function o(r){return[`**/${r}/**`,`**/${r}`].map(f=>f.replace(/\*\*\/\*\*/g,"**"))}function w(r){return r.replace(/\\/g,"/")}function v(r){return w(r).replace(/^\.\//,"").replace(/\/+$/g,"")}function I(r){return r.replace(/([?*[\]])/g,"[$1]")}function k(r,l){r=y.$Ff(r,W=>W.toString());const f=[],F=l.getWorkspace();return r&&r.forEach(W=>{let V;if(l.getWorkbenchState()===2)V=(0,g.$ig)(F.folders[0].uri,W),V&&V!=="."&&(V="./"+V);else{const B=l.getWorkspaceFolder(W);if(B){const j=B.name;if(F.folders.filter(z=>z.name===j).length===1){const z=(0,g.$ig)(B.uri,W);z===""?V=`./${B.name}`:V=`./${B.name}/${z}`}else V=W.fsPath}}V&&f.push(I(V))}),f}e.$rJ=k}),define(Pe[268],Ae([1,0,23,2,21,9,4,267,47,53]),function(pe,e,y,R,C,L,A,h,S,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$blb=e.$alb=void 0;const P=7e3;function D(d,t){const i=t.activationEvents;if(!i)return Promise.resolve(void 0);const c=[],m=[];for(const o of i)if(/^workspaceContains:/.test(o)){const w=o.substr(18);w.indexOf("*")>=0||w.indexOf("?")>=0||d.forceUsingSearch?m.push(w):c.push(w)}if(c.length===0&&m.length===0)return Promise.resolve(void 0);let E;const b=new Promise((o,w)=>{E=o}),n=o=>E({activationEvent:o}),a=Promise.all(c.map(o=>u(d,o,n))).then(()=>{}),s=p(d,t.identifier,m,n);return Promise.all([a,s]).then(()=>{E(void 0)}),b}e.$alb=D;async function u(d,t,i){for(const c of d.folders)if(await d.exists(y.$gg(R.URI.revive(c),t))){i(`workspaceContains:${t}`);return}}async function p(d,t,i,c){if(i.length===0)return Promise.resolve(void 0);const m=new C.$rc,E=d.checkExists(d.folders,i,m.token),b=setTimeout(async()=>{m.cancel(),d.logService.info(`Not activating extension '${t.value}': Timed out while searching for 'workspaceContains' pattern ${i.join(",")}`)},P);let n=!1;try{n=await E}catch(a){L.$2(a)||L.$Y(a)}m.dispose(),clearTimeout(b),n&&c(`workspaceContains:${i.join(",")}`)}function $(d,t,i,c){const m=d.get(A.$yh),E=d.get(S.$eI),n=m.createInstance(h.$qJ).file(t.map(a=>(0,g.$Uh)(R.URI.revive(a))),{_reason:"checkExists",includePattern:i,exists:!0});return E.fileSearch(n,c).then(a=>!!a.limitHit,a=>L.$2(a)?!1:Promise.reject(a))}e.$blb=$}),define(Pe[35],Ae([1,0,149,19,87,23,13,6,48,2,14,3,34,210,84,33,26,107,9,20,25,189,7,97,4,27,85,17,71,86,62,5,268,83,191,12,81,58,22,82]),function(pe,e,y,R,C,L,A,h,S,g,P,D,u,p,$,d,t,i,c,m,E,b,n,a,s,o,w,v,I,k,r,l,f,F,W,V,B,j,U,z){"use strict";var ie;Object.defineProperty(e,"__esModule",{value:!0}),e.$hbc=e.$gbc=e.$fbc=e.$ebc=e.$dbc=void 0,e.$dbc=(0,s.$zh)("IHostUtils");let Y=ie=class extends h.$mb{constructor(x,ue,O,J,he,Ee,ve,be,De,oe,de,se){super(),this.R=se,this.a=this.B(new l.$hc),this.onDidChangeRemoteConnectionData=this.a.event,this.P=!1,this.c=ue,this.g=O,this.f=ve,this.j=J,this.k=he,this.l=Ee,this.m=De,this.p=oe,this.s=de,this.t=this.g.getProxy(D.$SJ.MainThreadWorkspace),this.u=this.g.getProxy(D.$SJ.MainThreadTelemetry),this.v=this.g.getProxy(D.$SJ.MainThreadExtensionService),this.w=new A.$Dg,this.y=new A.$Dg,this.z=new A.$Dg,this.C=new A.$Dg,this.D=new we(this.f.activationEvents),this.G=new i.$12b(this.D,this.f.allExtensions);const ne=new m.$Ul(this.f.myExtensions);this.F=new i.$12b(this.D,X(this.G,ne)),this.H=new $.$Wac(this.g,this.l),this.I=new F.$9ac(this.g),this.J=be,this.h=x.createChild(new I.$xh([$.$Xac,this.H],[F.$0ac,this.I])),this.L=this.B(new p.$Vac(this.F,this.G,{onExtensionActivationError:(me,Ce,M)=>{this.v.$onExtensionActivationError(me,c.$1(Ce),M)},actualActivateExtension:async(me,Ce)=>{if(i.$12b.isHostExtension(me,this.F,this.G))return await this.v.$activateExtension(me,Ce),new p.$Uac;const M=this.F.getExtensionDescription(me);return this.$(M,Ce)}},this.l)),this.M=null,this.N=Object.create(null),this.O=!1,this.Q=this.f.remote.connectionData}getRemoteConnectionData(){return this.Q}async initialize(){try{await this.pb(),this.w.open(),await this.j.waitForInitializeCall(),C.mark("code/extHost/ready"),this.y.open(),this.f.autoStart&&this.nb()}catch(x){c.$Y(x)}}async S(){this.J.onWillDeactivateAll();let x=[];try{x=this.F.getAllExtensionDescriptions().map(he=>he.identifier).filter(he=>this.isActivated(he)).map(he=>this.Z(he))}catch{}await Promise.all(x)}terminate(x,ue=0){if(this.P)return;this.P=!0,this.l.info(`Extension host terminating: ${x}`),this.l.flush(),this.p.dispose(),this.L.dispose(),c.setUnexpectedErrorHandler(J=>{this.l.error(J)}),this.g.dispose();const O=this.S();Promise.race([(0,A.$Fg)(5e3),O]).finally(()=>{this.c.pid?this.l.info(`Extension host with pid ${this.c.pid} exiting with code ${ue}`):this.l.info(`Extension host exiting with code ${ue}`),this.l.flush(),this.l.dispose(),this.c.exit(ue)})}isActivated(x){return this.z.isOpen()?this.L.isActivated(x):!1}async getExtension(x){const ue=await this.v.$getExtension(x);return ue&&{...ue,identifier:new m.$Tl(ue.identifier.value),extensionLocation:g.URI.revive(ue.extensionLocation)}}U(x,ue){return this.L.activateByEvent(x,ue)}W(x,ue){return this.L.activateById(x,ue)}activateByIdWithErrors(x,ue){return this.W(x,ue).then(()=>{const O=this.L.getActivatedExtension(x);if(O.activationFailed)return Promise.reject(O.activationFailedError)})}getExtensionRegistry(){return this.z.wait().then(x=>this.F)}getExtensionExports(x){if(this.z.isOpen())return this.L.getActivatedExtension(x).exports;try{return this.L.getActivatedExtension(x).exports}catch{return null}}async X(x){if(x.scheme===V.Schemas.file&&this.c.fsRealpath){const ue=await this.c.fsRealpath(x.fsPath);return g.URI.file(ue)}return x}async getExtensionPathIndex(){return this.M||(this.M=this.Y(this.F.getAllExtensionDescriptions()).then(x=>new le(x))),this.M}async Y(x){const ue=S.$Fh.forUris(O=>L.$0f.ignorePathCasing(O));return await Promise.all(x.map(async O=>{if(this.qb(O)){const J=await this.X(O.extensionLocation);ue.set(J,O)}})),ue}Z(x){let ue=Promise.resolve(void 0);if(!this.z.isOpen()||!this.L.isActivated(x))return ue;const O=this.L.getActivatedExtension(x);if(!O)return ue;try{typeof O.module.deactivate=="function"&&(ue=Promise.resolve(O.module.deactivate()).then(void 0,J=>(this.l.error(J),Promise.resolve(void 0))))}catch(J){this.l.error(`An error occurred when deactivating the extension '${x.value}':`),this.l.error(J)}try{(0,h.$hb)(O.subscriptions)}catch(J){this.l.error(`An error occurred when deactivating the subscriptions for extension '${x.value}':`),this.l.error(J)}return ue}async $(x,ue){return this.f.remote.isRemote?this.v.$onWillActivateExtension(x.identifier):await this.v.$onWillActivateExtension(x.identifier),this.bb(x,ue).then(O=>{const J=O.activationTimes;return this.v.$onDidActivateExtension(x.identifier,J.codeLoadingTime,J.activateCallTime,J.activateResolvedTime,ue),this.ab(x,ue,"success",J),O},O=>{throw this.ab(x,ue,"failure"),O})}ab(x,ue,O,J){const he=ke(x,ue);this.u.$publicLog2("extensionActivationTimes",{...he,...J||{},outcome:O})}bb(x,ue){const O=ke(x,ue);this.u.$publicLog2("activatePlugin",O);const J=this.qb(x);if(!J)return Promise.resolve(new p.$Tac(p.$Qac.NONE));this.l.info(`ExtensionService#_doActivateExtension ${x.identifier.value}, startup: ${ue.startup}, activationEvent: '${ue.activationEvent}'${x.identifier.value!==ue.extensionId.value?`, root cause: ${ue.extensionId.value}`:""}`),this.l.flush();const he=new p.$Rac(ue.startup);return Promise.all([this.rb(x,(0,L.$gg)(x.extensionLocation,J),he),this.cb(x)]).then(Ee=>(C.mark(`code/extHost/willActivateExtension/${x.identifier.value}`),ie.db(this.l,x.identifier,Ee[0],Ee[1],he))).then(Ee=>(C.mark(`code/extHost/didActivateExtension/${x.identifier.value}`),Ee))}cb(x){const ue=new b.$Zac(x,this.H),O=new b.$Yac(x.identifier.value,!1,this.H),J=new W.$$ac(x,this.I),he=x.isUnderDevelopment?this.f.environment.extensionTestsLocationURI?n.ExtensionMode.Test:n.ExtensionMode.Development:n.ExtensionMode.Production,Ee=this.f.remote.isRemote?n.ExtensionKind.Workspace:n.ExtensionKind.UI;return this.l.trace(`ExtensionService#loadExtensionContext ${x.identifier.value}`),Promise.all([ue.whenReady,O.whenReady,this.J.whenReady]).then(()=>{const ve=this;let be,De;const oe=(0,t.$LF)(x,"ipc")?this.f.messagePorts?.get(m.$Tl.toKey(x.identifier)):void 0;return Object.freeze({globalState:ue,workspaceState:O,secrets:J,subscriptions:[],get extensionUri(){return x.extensionLocation},get extensionPath(){return x.extensionLocation.fsPath},asAbsolutePath(de){return R.$$c(x.extensionLocation.fsPath,de)},get storagePath(){return ve.J.workspaceValue(x)?.fsPath},get globalStoragePath(){return ve.J.globalValue(x).fsPath},get logPath(){return R.$$c(ve.f.logsLocation.fsPath,x.identifier.value)},get logUri(){return g.URI.joinPath(ve.f.logsLocation,x.identifier.value)},get storageUri(){return ve.J.workspaceValue(x)},get globalStorageUri(){return ve.J.globalValue(x)},get extensionMode(){return he},get extension(){return be===void 0&&(be=new Re(ve,x.identifier,x,Ee,!1)),be},get extensionRuntime(){return(0,t.$MF)(x,"extensionRuntime"),ve.extensionRuntime},get environmentVariableCollection(){return ve.p.getEnvironmentVariableCollection(x)},get messagePassingProtocol(){if(!De){if(!oe)return;const de=l.Event.buffer(l.Event.fromDOMEventEmitter(oe,"message",se=>se.data));oe.start(),De={onDidReceiveMessage:de,postMessage:oe.postMessage.bind(oe)}}return De}})})}static db(x,ue,O,J,he){return O=O||{activate:void 0,deactivate:void 0},this.eb(x,ue,O,J,he).then(Ee=>new p.$Sac(!1,null,he.build(),O,Ee,J.subscriptions))}static eb(x,ue,O,J,he){if(typeof O.activate=="function")try{he.activateCallStart(),x.trace(`ExtensionService#_callActivateOptional ${ue.value}`);const Ee=typeof global=="object"?global:self,ve=O.activate.apply(Ee,[J]);return he.activateCallStop(),he.activateResolveStart(),Promise.resolve(ve).then(be=>(he.activateResolveStop(),be))}catch(Ee){return Promise.reject(Ee)}else return Promise.resolve(O)}fb(x,ue){this.W(x.identifier,{startup:!1,extensionId:x.identifier,activationEvent:ue}).then(void 0,O=>{this.l.error(O)})}gb(x,ue=0){const J=Date.now();(0,U.$A)(()=>{for(let he=ue;he<x.length;he+=1){const Ee=x[he];for(const ve of Ee.activationEvents??[])if(ve==="onStartupFinished")if(Date.now()-J>50){this.gb(x,he);break}else this.fb(Ee,ve)}})}hb(){this.v.$setPerformanceMarks(C.getMarks()),this.k.getConfigProvider().then(x=>{const ue=x.getConfiguration("extensions.experimental").get("deferredStartupFinishedActivation"),O=this.F.getAllExtensionDescriptions();if(ue)this.gb(O);else for(const J of O)if(J.activationEvents)for(const he of J.activationEvents)he==="onStartupFinished"&&this.fb(J,he)})}ib(){const x=this.U("*",!0).then(void 0,Ee=>{this.l.error(Ee)});this.B(this.j.onDidChangeWorkspace(Ee=>this.jb(Ee.added)));const ue=this.j.workspace?this.j.workspace.folders:[],O=this.jb(ue),J=this.lb(),he=Promise.all([J,x,O]).then(()=>{});return Promise.race([he,(0,A.$Fg)(1e4)]).then(()=>{this.hb()}),he}jb(x){return x.length===0?Promise.resolve(void 0):Promise.all(this.F.getAllExtensionDescriptions().map(ue=>this.kb(x,ue))).then(()=>{})}async kb(x,ue){if(this.isActivated(ue.identifier))return;const O=!this.f.remote.isRemote&&!!this.f.remote.authority,J={logService:this.l,folders:x.map(Ee=>Ee.uri),forceUsingSearch:O||!this.c.fsExists,exists:Ee=>this.c.fsExists(Ee.fsPath),checkExists:(Ee,ve,be)=>this.t.$checkExists(Ee,ve,be)},he=await(0,f.$alb)(J,ue);if(he)return this.W(ue.identifier,{startup:!0,extensionId:ue.identifier,activationEvent:he.activationEvent}).then(void 0,Ee=>this.l.error(Ee))}async lb(){if(this.f.remote.authority)return this.U(`onResolveRemoteAuthority:${this.f.remote.authority}`,!1)}async $extensionTestsExecute(){await this.C.wait();try{return await this.mb()}catch(x){throw console.error(x),x}}async mb(){const{extensionDevelopmentLocationURI:x,extensionTestsLocationURI:ue}=this.f.environment;if(!x||!ue)throw new Error(y.localize(0,null));const O=await this.rb(null,ue,new p.$Rac(!1));if(!O||typeof O.run!="function")throw new Error(y.localize(1,null,ue.toString()));return new Promise((J,he)=>{const Ee=(De,oe)=>{De?he(De):J(typeof oe=="number"&&oe>0?1:0)},ve=(0,L.$7f)(ue),be=O.run(ve,Ee);be&&be.then&&be.then(()=>{J(0)}).catch(De=>{he(De instanceof Error&&De.stack?De.stack:String(De))})})}nb(){if(this.O)throw new Error("Extension host is already started!");return this.O=!0,this.y.wait().then(()=>this.z.open()).then(()=>Promise.race([this.L.waitForActivatingExtensions(),(0,A.$Fg)(1e3)])).then(()=>this.ib()).then(()=>{this.C.open(),this.l.info("Eager extensions activated")})}registerRemoteAuthorityResolver(x,ue){return this.N[x]=ue,(0,h.$kb)(()=>{delete this.N[x]})}async getRemoteExecServer(x){const{resolver:ue}=await this.ob(x);return ue?.resolveExecServer?.(x,{resolveAttempt:0})}async ob(x){const ue=x.indexOf("+");if(ue===-1)throw new n.$1J("Not an authority that can be resolved!",a.RemoteAuthorityResolverErrorCode.InvalidAuthority);const O=x.substr(0,ue);return await this.w.wait(),await this.U(`onResolveRemoteAuthority:${O}`,!1),{authorityPrefix:O,resolver:this.N[O]}}async $resolveAuthority(x,ue){const O=j.$dc.create(!1),J=()=>`[resolveAuthority(${(0,a.$Lk)(x)},${ue})][${O.elapsed()}ms] `,he=H=>this.l.info(`${J()}${H}`),Ee=H=>this.l.warn(`${J()}${H}`),ve=(H,Z=void 0)=>this.l.error(`${J()}${H}`,Z),be=H=>{if(H instanceof n.$1J)return{type:"error",error:{code:H._code,message:H._message,detail:H._detail}};throw H},De=async H=>{he(`activating resolver for ${H}...`);const{resolver:Z,authorityPrefix:K}=await this.ob(H);if(!Z)throw ve(`no resolver for ${K}`),new n.$1J(`No remote extension installed to resolve ${K}.`,a.RemoteAuthorityResolverErrorCode.NoResolverFound);return{resolver:Z,authorityPrefix:K,remoteAuthority:H}},oe=x.split(/@|%40/g).reverse();he(`activating remote resolvers ${oe.join(" -> ")}`);let de;try{de=await Promise.all(oe.map(De)).catch(async H=>{if(!(H instanceof n.$1J)||H._code!==a.RemoteAuthorityResolverErrorCode.InvalidAuthority)throw H;return Ee(`resolving nested authorities failed: ${H.message}`),[await De(x)]})}catch(H){return be(H)}const se=new A.$Pg;se.cancelAndSet(()=>he("waiting..."),1e3);let ne,me;for(const[H,{authorityPrefix:Z,resolver:K,remoteAuthority:ee}]of de.entries())try{if(H===de.length-1)he("invoking final resolve()..."),C.mark(`code/extHost/willResolveAuthority/${Z}`),ne=await K.resolve(ee,{resolveAttempt:ue,execServer:me}),C.mark(`code/extHost/didResolveAuthorityOK/${Z}`),he("setting tunnel factory..."),this.B(await this.m.setTunnelFactory(K,n.$ZJ.isManagedResolvedAuthority(ne)?ne:void 0));else{if(he(`invoking resolveExecServer() for ${ee}`),C.mark(`code/extHost/willResolveExecServer/${Z}`),me=await K.resolveExecServer?.(ee,{resolveAttempt:ue,execServer:me}),!me)throw new n.$1J(`Exec server was not available for ${ee}`,a.RemoteAuthorityResolverErrorCode.NoResolverFound);C.mark(`code/extHost/didResolveExecServerOK/${Z}`)}}catch(ce){return C.mark(`code/extHost/didResolveAuthorityError/${Z}`),ve("returned an error",ce),se.dispose(),be(ce)}se.dispose();const Ce={environmentTunnels:ne.environmentTunnels,features:ne.tunnelFeatures},M={extensionHostEnv:ne.extensionHostEnv,isTrusted:ne.isTrusted,authenticationSession:ne.authenticationSessionForInitializingExtensions?{id:ne.authenticationSessionForInitializingExtensions.id,providerId:ne.authenticationSessionForInitializingExtensions.providerId}:void 0};he(`returned ${n.$ZJ.isManagedResolvedAuthority(ne)?"managed authority":`${ne.host}:${ne.port}`}`);let q;if(n.$ZJ.isManagedResolvedAuthority(ne)){const H=ue;this.R.setFactory(H,ne.makeConnection),q={authority:x,connectTo:new a.$Ik(H),connectionToken:ne.connectionToken}}else q={authority:x,connectTo:new a.$Jk(ne.host,ne.port),connectionToken:ne.connectionToken};return{type:"ok",value:{authority:q,options:M,tunnelInformation:Ce}}}async $getCanonicalURI(x,ue){this.l.info(`$getCanonicalURI invoked for authority (${(0,a.$Lk)(x)})`);const{resolver:O}=await this.ob(x);if(!O)return null;const J=g.URI.revive(ue);if(typeof O.getCanonicalURI>"u")return J;const he=await(0,A.$xg)(()=>O.getCanonicalURI(J));return he||J}$startExtensionHost(x){x.toAdd.forEach(J=>J.extensionLocation=g.URI.revive(J.extensionLocation));const{globalRegistry:ue,myExtensions:O}=ye(this.D,this.G,this.F,x);return this.G.set(ue.getAllExtensionDescriptions()),this.F.set(O),this.nb()}$activateByEvent(x,ue){return ue===1?this.w.wait().then(O=>this.U(x,!1)):this.z.wait().then(O=>this.U(x,!1))}async $activate(x,ue){return await this.z.wait(),this.F.getExtensionDescription(x)?(await this.W(x,ue),!0):!1}async $deltaExtensions(x){x.toAdd.forEach(Ee=>Ee.extensionLocation=g.URI.revive(Ee.extensionLocation));const{globalRegistry:ue,myExtensions:O}=ye(this.D,this.G,this.F,x),J=await this.Y(O);return(await this.getExtensionPathIndex()).setSearchTree(J),this.G.set(ue.getAllExtensionDescriptions()),this.F.set(O),Promise.resolve(void 0)}async $test_latency(x){return x}async $test_up(x){return x.byteLength}async $test_down(x){const ue=E.$Hc.alloc(x),O=Math.random()%256;for(let J=0;J<x;J++)ue.writeUInt8(O,J);return ue}async $updateRemoteConnectionData(x){this.Q=x,this.a.fire()}};e.$ebc=Y,e.$ebc=Y=ie=Ke([Ve(0,s.$yh),Ve(1,e.$dbc),Ve(2,v.$UL),Ve(3,d.$Jac),Ve(4,u.$Mac),Ve(5,P.$3i),Ve(6,o.$$L),Ve(7,w.$3ac),Ve(8,k.$3rb),Ve(9,r.$5ac),Ve(10,B.$abc),Ve(11,z.$bbc)],Y);function ye(ae,x,ue,O){ae.addActivationEvents(O.addActivationEvents);const J=new i.$12b(ae,x.getAllExtensionDescriptions());J.deltaExtensions(O.toAdd,O.toRemove);const he=new m.$Ul(ue.getAllExtensionDescriptions().map(ve=>ve.identifier));for(const ve of O.myToRemove)he.delete(ve);for(const ve of O.myToAdd)he.add(ve);const Ee=X(J,he);return{globalRegistry:J,myExtensions:Ee}}function ke(ae,x){return{id:ae.identifier.value,name:ae.name,extensionVersion:ae.version,publisherDisplayName:ae.publisher,activationEvents:ae.activationEvents?ae.activationEvents.join(","):null,isBuiltin:ae.isBuiltin,reason:x.activationEvent,reasonId:x.extensionId.value}}e.$fbc=(0,s.$zh)("IExtHostExtensionService");class Re{#e;#t;#i;constructor(x,ue,O,J,he){this.#e=x,this.#t=ue,this.#i=O.identifier,this.id=O.identifier.value,this.extensionUri=O.extensionLocation,this.extensionPath=R.$9c((0,L.$7f)(O.extensionLocation)),this.packageJSON=O,this.extensionKind=J,this.isFromDifferentExtensionHost=he}get isActive(){return this.#e.isActivated(this.#i)}get exports(){if(!(this.packageJSON.api==="none"||this.isFromDifferentExtensionHost))return this.#e.getExtensionExports(this.#i)}async activate(){if(this.isFromDifferentExtensionHost)throw new Error("Cannot activate foreign extension");return await this.#e.activateByIdWithErrors(this.#i,{startup:!1,extensionId:this.#t,activationEvent:"api"}),this.exports}}e.$gbc=Re;function X(ae,x){return ae.getAllExtensionDescriptions().filter(ue=>x.has(ue.identifier))}class le{constructor(x){this.a=x}setSearchTree(x){this.a=x}findSubstr(x){return this.a.findSubstr(x)}forEach(x){return this.a.forEach(x)}}e.$hbc=le;class we{constructor(x){this.a=new m.$Vl,this.addActivationEvents(x)}readActivationEvents(x){return this.a.get(x.identifier)}addActivationEvents(x){for(const ue of Object.keys(x))this.a.set(ue,x[ue])}}}),define(Pe[269],Ae([1,0,87,2,3,34,26,20,17,27,4,35,14,15]),function(pe,e,y,R,C,L,A,h,S,g,P,D,u,p){"use strict";var $;Object.defineProperty(e,"__esModule",{value:!0}),e.$Dcc=void 0;let d=class{constructor(E,b,n,a,s,o,w){this.c=E,this.d=b,this.e=n,this.f=a,this.g=s,this.h=o,this.i=w,this.a=new Map,this.b=[]}async install(){this.j(),y.mark("code/extHost/willWaitForConfig");const E=await this.f.getConfigProvider();y.mark("code/extHost/didWaitForConfig");const b=await this.g.getExtensionPathIndex();this.register(new i(this.c,b,this.d,E,this.i)),this.register(this.e.createInstance(t)),this.h.remote.isRemote&&this.register(this.e.createInstance(c,b,this.h.environment.appUriScheme))}register(E){if("nodeModuleName"in E)if(Array.isArray(E.nodeModuleName))for(const b of E.nodeModuleName)this.a.set(b,E);else this.a.set(E.nodeModuleName,E);typeof E.alternativeModuleName=="function"&&this.b.push(b=>E.alternativeModuleName(b))}};e.$Dcc=d,e.$Dcc=d=Ke([Ve(2,P.$yh),Ve(3,L.$Mac),Ve(4,D.$fbc),Ve(5,g.$$L),Ve(6,u.$3i)],d);let t=class{static{$=this}static{this.a=new Map([["vscode-ripgrep","@vscode/ripgrep"],["vscode-windows-registry","@vscode/windows-registry"]])}constructor(E){if(E.environment.appRoot&&$.a.size){const b=(0,p.$sd)(this.c(E.environment.appRoot.fsPath)),n="[a-z0-9_.-]",a=`@${n}+\\/${n}+|${n}+`,s="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.b=new RegExp(`^(${b}/${s}\\/)(${a})(.*)$`,"i")}}alternativeModuleName(E){if(!this.b)return;const b=this.b.exec(this.c(E));if(!b)return;const[,n,a,s]=b,o=$.a.get(a);if(o!==void 0)return console.warn(`${a} as been renamed to ${o}, please update your imports`),n+o+s}c(E){return E.replace(/\\/g,"/")}};t=$=Ke([Ve(0,g.$$L)],t);class i{constructor(E,b,n,a,s){this.c=E,this.d=b,this.e=n,this.f=a,this.g=s,this.nodeModuleName="vscode",this.a=new h.$Vl}load(E,b){const n=this.d.findSubstr(b);if(n){let a=this.a.get(n.identifier);return a||(a=this.c(n,this.e,this.f),this.a.set(n.identifier,a)),a}if(!this.b){let a="";this.d.forEach((s,o)=>a+=`	${o} -> ${s.identifier.value}
`),this.g.warn(`Could not identify extension for 'vscode' require call from ${b}. These are the extension path mappings: 
${a}`),this.b=this.c(A.$GF,this.e,this.f)}return this.b}}let c=class{constructor(E,b,n){this.e=E,this.f=b,this.nodeModuleName=["open","opn"],this.d=n.getProxy(C.$SJ.MainThreadTelemetry);const a=n.getProxy(C.$SJ.MainThreadWindow);this.c=(s,o)=>{const w=R.URI.parse(s);return o?this.g(s,o):w.scheme==="http"||w.scheme==="https"?a.$openUri(w,s,{allowTunneling:!0}):w.scheme==="mailto"||w.scheme===this.f?a.$openUri(w,s,{}):this.g(s,o)}}load(E,b,n){const a=this.e.findSubstr(b);return a&&(this.a=a.identifier.value,this.h()),this.b=n(E),this.c}g(E,b){return this.i(),this.b(E,b)}h(){this.a&&this.d.$publicLog2("shimming.open",{extension:this.a})}i(){this.a&&this.d.$publicLog2("shimming.open.call.noForward",{extension:this.a})}};c=Ke([Ve(2,S.$UL)],c)}),define(Pe[113],Ae([1,0,65,6,19,74,4,59,60,35,7,33,201,34]),function(pe,e,y,R,C,L,A,h,S,g,P,D,u,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Obc=e.$Nbc=void 0,e.$Nbc=(0,A.$zh)("IExtHostVariableResolverProvider");class $ extends u.$VM{constructor(i,c,m,E,b,n,a){function s(){if(m){const o=m.activeEditor();if(o)return o.document.uri;const w=E.tabGroups.all.find(v=>v.isActive)?.activeTab;if(w!==void 0){if(w.input instanceof P.$BL||w.input instanceof P.$GL)return w.input.modified;if(w.input instanceof P.$AL||w.input instanceof P.$FL||w.input instanceof P.$DL)return w.input.uri}}}super({getFolderUri:o=>{const w=n.folders.filter(v=>v.name===o);if(w&&w.length>0)return w[0].uri},getWorkspaceFolderCount:()=>n.folders.length,getConfigurationValue:(o,w)=>b.getConfiguration(void 0,o).get(w),getAppRoot:()=>L.cwd(),getExecPath:()=>L.env.VSCODE_EXEC_PATH,getFilePath:()=>{const o=s();if(o)return C.$9c(o.fsPath)},getWorkspaceFolderPathForFile:()=>{if(c){const o=s();if(o){const w=c.getWorkspaceFolder(o);if(w)return C.$9c(w.uri.fsPath)}}},getSelectedText:()=>{if(m){const o=m.activeEditor();if(o&&!o.selection.isEmpty)return o.document.getText(o.selection)}},getLineNumber:()=>{if(m){const o=m.activeEditor();if(o)return String(o.selection.end.line+1)}},getExtension:o=>i.getExtension(o)},void 0,a?Promise.resolve(a):void 0,Promise.resolve(L.env))}}let d=class extends R.$mb{constructor(i,c,m,E,b){super(),this.b=i,this.c=c,this.g=m,this.h=E,this.i=b,this.a=new y.$T(async()=>{const n=await this.h.getConfigProvider(),s={folders:await this.c.getWorkspaceFolders2()||[]};return this.B(this.c.onDidChangeWorkspace(async o=>{s.folders=await this.c.getWorkspaceFolders2()||[]})),new $(this.b,this.c,this.g,this.i,n,s,this.j())})}getResolver(){return this.a.value}j(){}};e.$Obc=d,e.$Obc=d=Ke([Ve(0,g.$fbc),Ve(1,D.$Jac),Ve(2,h.$6L),Ve(3,p.$Mac),Ve(4,S.$Lbc)],d)}),define(Pe[114],Ae([1,0,13,5,2,4,3,60,35,17,7,33,194,196,34,113]),function(pe,e,y,R,C,L,A,h,S,g,P,D,u,p,$,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tbc=e.$Sbc=e.$Rbc=e.$Qbc=e.$Pbc=void 0,e.$Pbc=(0,L.$zh)("IExtHostDebugService");let t=class{get onDidStartDebugSession(){return this.m.event}get onDidTerminateDebugSession(){return this.n.event}get onDidChangeActiveDebugSession(){return this.o.event}get activeDebugSession(){return this.q}get onDidReceiveDebugSessionCustomEvent(){return this.u.event}get activeDebugConsole(){return this.v.value}constructor(a,s,o,w,v,I){this.E=s,this.F=o,this.G=w,this.H=v,this.I=I,this.l=new Map,this.d=0,this.f=[],this.g=0,this.h=[],this.i=0,this.j=[],this.B=new Map,this.C=new Map,this.m=new R.$hc,this.n=new R.$hc,this.o=new R.$hc,this.u=new R.$hc,this.k=a.getProxy(A.$SJ.MainThreadDebugService),this.y=new R.$hc,this.A=new R.$hc,this.v=new c(this.k),this.w=new Map,this.F.getExtensionRegistry().then(k=>{k.onDidChange(r=>{this.J(k)}),this.J(k)})}asDebugSourceUri(a,s){const o=a;if(typeof o.sourceReference=="number"&&o.sourceReference>0){let w=`debug:${encodeURIComponent(o.path||"")}`,v="?";return s&&(w+=`${v}session=${encodeURIComponent(s.id)}`,v="&"),w+=`${v}ref=${o.sourceReference}`,C.URI.parse(w)}else{if(o.path)return C.URI.file(o.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}J(a){const s=[];for(const o of a.getAllExtensionDescriptions())if(o.contributes){const w=o.contributes.debuggers;if(w&&w.length>0)for(const v of w)(0,p.$iF)(v)&&s.push(v.type)}this.k.$registerDebugTypes(s)}get stackFrameFocus(){return this.z}get onDidChangeStackFrameFocus(){return this.A.event}get onDidChangeBreakpoints(){return this.y.event}get breakpoints(){const a=[];return this.w.forEach(s=>a.push(s)),a}addBreakpoints(a){const s=a.filter(v=>{const I=v.id;return this.w.has(I)?!1:(this.w.set(I,v),!0)});this.U(s,[],[]);const o=[],w=new Map;for(const v of s)if(v instanceof P.$UK){let I=w.get(v.location.uri.toString());I||(I={type:"sourceMulti",uri:v.location.uri,lines:[]},w.set(v.location.uri.toString(),I),o.push(I)),I.lines.push({id:v.id,enabled:v.enabled,condition:v.condition,hitCondition:v.hitCondition,logMessage:v.logMessage,line:v.location.range.start.line,character:v.location.range.start.character})}else v instanceof P.$VK&&o.push({type:"function",id:v.id,enabled:v.enabled,hitCondition:v.hitCondition,logMessage:v.logMessage,condition:v.condition,functionName:v.functionName});return this.k.$registerBreakpoints(o)}removeBreakpoints(a){const s=a.filter(I=>this.w.delete(I.id));this.U([],s,[]);const o=s.filter(I=>I instanceof P.$UK).map(I=>I.id),w=s.filter(I=>I instanceof P.$VK).map(I=>I.id),v=s.filter(I=>I instanceof P.$WK).map(I=>I.id);return this.k.$unregisterBreakpoints(o,w,v)}startDebugging(a,s,o){return this.k.$startDebugging(a?a.uri:void 0,s,{parentSessionID:o.parentSession?o.parentSession.id:void 0,lifecycleManagedByParent:o.lifecycleManagedByParent,repl:o.consoleMode===P.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:o.noDebug,compact:o.compact,suppressSaveBeforeStart:o.suppressSaveBeforeStart,suppressDebugStatusbar:o.suppressDebugStatusbar??o.debugUI?.simple,suppressDebugToolbar:o.suppressDebugToolbar??o.debugUI?.simple,suppressDebugView:o.suppressDebugView??o.debugUI?.simple})}stopDebugging(a){return this.k.$stopDebugging(a?a.id:void 0)}registerDebugConfigurationProvider(a,s,o){if(!s)return new P.$UJ(()=>{});const w=this.d++;return this.f.push({type:a,handle:w,provider:s}),this.k.$registerDebugConfigurationProvider(a,o,!!s.provideDebugConfigurations,!!s.resolveDebugConfiguration,!!s.resolveDebugConfigurationWithSubstitutedVariables,w),new P.$UJ(()=>{this.f=this.f.filter(v=>v.provider!==s),this.k.$unregisterDebugConfigurationProvider(w)})}registerDebugAdapterDescriptorFactory(a,s,o){if(!o)return new P.$UJ(()=>{});if(!this.Q(a,s))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${s}' debugger.`);if(this.N(s))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const w=this.g++;return this.h.push({type:s,handle:w,factory:o}),this.k.$registerDebugAdapterDescriptorFactory(s,w),new P.$UJ(()=>{this.h=this.h.filter(v=>v.factory!==o),this.k.$unregisterDebugAdapterDescriptorFactory(w)})}registerDebugAdapterTrackerFactory(a,s){if(!s)return new P.$UJ(()=>{});const o=this.i++;return this.j.push({type:a,handle:o,factory:s}),new P.$UJ(()=>{this.j=this.j.filter(w=>w.factory!==s)})}async $runInTerminal(a,s){return Promise.resolve(void 0)}async $substituteVariables(a,s){let o;const w=await this.W(a);return w&&(o={uri:w.uri,name:w.name,index:w.index,toResource:()=>{throw new Error("Not implemented")}}),(await this.I.getResolver()).resolveAnyAsync(o,s)}K(a,s){if(a.type==="implementation")return new E(a.implementation)}L(){}async $startDASession(a,s){const o=this,w=await this.V(s);return this.S(this.N(w.type),w).then(v=>{if(!v)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${w.type}' (extension might have failed to activate)`);const I=this.M(v),k=this.K(I,w);if(!k)throw new Error(`Couldn't create a debug adapter for type '${w.type}'.`);const r=k;return this.B.set(a,r),this.R(w).then(l=>(l&&this.C.set(a,l),r.onMessage(async f=>{if(f.type==="request"&&f.command==="handshake"){const F=f,W={type:"response",seq:0,command:F.command,request_seq:F.seq,success:!0};this.D||(this.D=this.L());try{if(this.D){const V=await this.D.sign(F.arguments.value);W.body={signature:V},r.sendResponse(W)}else throw new Error("no signer")}catch(V){W.success=!1,W.message=V.message,r.sendResponse(W)}}else l&&l.onDidSendMessage&&l.onDidSendMessage(f),f=(0,p.$nF)(f,!0),o.k.$acceptDAMessage(a,f)}),r.onError(f=>{l&&l.onError&&l.onError(f),this.k.$acceptDAError(a,f.name,f.message,f.stack)}),r.onExit(f=>{l&&l.onExit&&l.onExit(f??void 0,void 0),this.k.$acceptDAExit(a,f??void 0,void 0)}),l&&l.onWillStartSession&&l.onWillStartSession(),r.startSession()))})}$sendDAMessage(a,s){s=(0,p.$mF)(s,!1);const o=this.C.get(a);o&&o.onWillReceiveMessage&&o.onWillReceiveMessage(s),this.B.get(a)?.sendMessage(s)}$stopDASession(a){const s=this.C.get(a);this.C.delete(a),s&&s.onWillStopSession&&s.onWillStopSession();const o=this.B.get(a);return this.B.delete(a),o?o.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(a){const s=[],o=[],w=[];if(a.added)for(const v of a.added){const I=v.id;if(I&&!this.w.has(I)){let k;if(v.type==="function")k=new P.$VK(v.functionName,v.enabled,v.condition,v.hitCondition,v.logMessage);else if(v.type==="data")k=new P.$WK(v.label,v.dataId,v.canPersist,v.enabled,v.hitCondition,v.condition,v.logMessage);else{const r=C.URI.revive(v.uri);k=new P.$UK(new P.$7J(r,new P.$VJ(v.line,v.character)),v.enabled,v.condition,v.hitCondition,v.logMessage)}(0,P.$SK)(k,I),this.w.set(I,k),s.push(k)}}if(a.removed)for(const v of a.removed){const I=this.w.get(v);I&&(this.w.delete(v),o.push(I))}if(a.changed){for(const v of a.changed)if(v.id){const I=this.w.get(v.id);if(I){if(I instanceof P.$VK&&v.type==="function"){const k=I;k.enabled=v.enabled,k.condition=v.condition,k.hitCondition=v.hitCondition,k.logMessage=v.logMessage,k.functionName=v.functionName}else if(I instanceof P.$UK&&v.type==="source"){const k=I;k.enabled=v.enabled,k.condition=v.condition,k.hitCondition=v.hitCondition,k.logMessage=v.logMessage,k.location=new P.$7J(C.URI.revive(v.uri),new P.$VJ(v.line,v.character))}w.push(I)}}}this.U(s,o,w)}async $acceptStackFrameFocus(a){let s;const o=a.sessionId?await this.V(a.sessionId):void 0;if(!o)throw new Error("no DebugSession found for debug focus context");a.kind==="thread"?s=new P.$3K(o,a.threadId):s=new P.$2K(o,a.threadId,a.frameId),this.z=s,this.A.fire(this.z)}$provideDebugConfigurations(a,s,o){return(0,y.$xg)(async()=>{const w=this.P(a);if(!w)throw new Error("no DebugConfigurationProvider found");if(!w.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const v=await this.W(s);return w.provideDebugConfigurations(v,o)}).then(w=>{if(!w)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return w})}$resolveDebugConfiguration(a,s,o,w){return(0,y.$xg)(async()=>{const v=this.P(a);if(!v)throw new Error("no DebugConfigurationProvider found");if(!v.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const I=await this.W(s);return v.resolveDebugConfiguration(I,o,w)})}$resolveDebugConfigurationWithSubstitutedVariables(a,s,o,w){return(0,y.$xg)(async()=>{const v=this.P(a);if(!v)throw new Error("no DebugConfigurationProvider found");if(!v.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const I=await this.W(s);return v.resolveDebugConfigurationWithSubstitutedVariables(I,o,w)})}async $provideDebugAdapter(a,s){const o=this.O(a);if(!o)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const w=await this.V(s);return this.S(o,w).then(v=>{if(!v)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${w.type}'`);return this.M(v)})}async $acceptDebugSessionStarted(a){const s=await this.V(a);this.m.fire(s)}async $acceptDebugSessionTerminated(a){const s=await this.V(a);s&&(this.n.fire(s),this.l.delete(s.id))}async $acceptDebugSessionActiveChanged(a){this.q=a?await this.V(a):void 0,this.o.fire(this.q)}async $acceptDebugSessionNameChanged(a,s){(await this.V(a))?._acceptNameChanged(s)}async $acceptDebugSessionCustomEvent(a,s){const w={session:await this.V(a),event:s.event,body:s.body};this.u.fire(w)}M(a){if(a instanceof P.$XK)return{type:"executable",command:a.command,args:a.args,options:a.options};if(a instanceof P.$YK)return{type:"server",port:a.port,host:a.host};if(a instanceof P.$ZK)return{type:"pipeServer",path:a.path};if(a instanceof P.$1K)return{type:"implementation",implementation:a.implementation};throw new Error("convertToDto unexpected type")}N(a){const s=this.h.filter(o=>o.type===a);if(s.length>0)return s[0].factory}O(a){const s=this.h.filter(o=>o.handle===a);if(s.length>0)return s[0].factory}P(a){const s=this.f.filter(o=>o.handle===a);if(s.length>0)return s[0].provider}Q(a,s){if(a.contributes){const o=a.contributes.debuggers;if(o&&o.length>0){for(const w of o)if(w.label&&w.type&&w.type===s)return!0}}return!1}R(a){const o=a.configuration.type,w=this.j.filter(v=>v.type===o||v.type==="*").map(v=>(0,y.$xg)(()=>v.factory.createDebugAdapterTracker(a)).then(I=>I,I=>null));return Promise.race([Promise.all(w).then(v=>{const I=v.filter(k=>!!k);if(I.length>0)return new m(I)}),new Promise(v=>setTimeout(()=>v(void 0),1e3))]).catch(v=>{})}async S(a,s){const o=s.configuration.debugServer;if(typeof o=="number")return Promise.resolve(new P.$YK(o));if(a){const v=await this.F.getExtensionRegistry();return(0,y.$xg)(()=>a.createDebugAdapterDescriptor(s,this.T(s,v))).then(I=>{if(I)return I})}const w=await this.F.getExtensionRegistry();return Promise.resolve(this.T(s,w))}T(a,s){}U(a,s,o){(a.length>0||s.length>0||o.length>0)&&this.y.fire(Object.freeze({added:a,removed:s,changed:o}))}async V(a){if(a)if(typeof a=="string"){const s=this.l.get(a);if(s)return s}else{let s=this.l.get(a.id);if(!s){const o=await this.W(a.folderUri),w=a.parent?this.l.get(a.parent):void 0;s=new i(this.k,a.id,a.type,a.name,o,a.configuration,w),this.l.set(s.id,s),this.k.$sessionCached(s.id)}return s}throw new Error("cannot find session")}W(a){if(a){const s=C.URI.revive(a);return this.E.resolveWorkspaceFolder(s)}return Promise.resolve(void 0)}};e.$Qbc=t,e.$Qbc=t=Ke([Ve(0,g.$UL),Ve(1,D.$Jac),Ve(2,S.$fbc),Ve(3,$.$Mac),Ve(4,h.$Lbc),Ve(5,d.$Nbc)],t);class i{constructor(a,s,o,w,v,I,k){this.d=a,this.f=s,this.g=o,this.h=w,this.i=v,this.j=I,this.k=k}get id(){return this.f}get type(){return this.g}get name(){return this.h}set name(a){this.h=a,this.d.$setDebugSessionName(this.f,a)}get parentSession(){return this.k}_acceptNameChanged(a){this.h=a}get workspaceFolder(){return this.i}get configuration(){return this.j}customRequest(a,s){return this.d.$customDebugAdapterRequest(this.f,a,s)}getDebugProtocolBreakpoint(a){return this.d.$getDebugProtocolBreakpoint(this.f,a.id)}}e.$Rbc=i;class c{constructor(a){this.value=Object.freeze({append(s){a.$appendDebugConsole(s)},appendLine(s){this.append(s+`
`)}})}}e.$Sbc=c;class m{constructor(a){this.d=a}onWillStartSession(){this.d.forEach(a=>a.onWillStartSession?a.onWillStartSession():void 0)}onWillReceiveMessage(a){this.d.forEach(s=>s.onWillReceiveMessage?s.onWillReceiveMessage(a):void 0)}onDidSendMessage(a){this.d.forEach(s=>s.onDidSendMessage?s.onDidSendMessage(a):void 0)}onWillStopSession(){this.d.forEach(a=>a.onWillStopSession?a.onWillStopSession():void 0)}onError(a){this.d.forEach(s=>s.onError?s.onError(a):void 0)}onExit(a,s){this.d.forEach(o=>o.onExit?o.onExit(a,s):void 0)}}class E extends u.$icb{constructor(a){super(),this.h=a,a.onDidSendMessage(s=>{this.acceptMessage(s)})}startSession(){return Promise.resolve(void 0)}sendMessage(a){this.h.handleMessage(a)}stopSession(){return this.h.dispose(),Promise.resolve(void 0)}}let b=class extends t{constructor(a,s,o,w,v,I){super(a,s,o,w,v,I)}};e.$Tbc=b,e.$Tbc=b=Ke([Ve(0,g.$UL),Ve(1,D.$Jac),Ve(2,S.$fbc),Ve(3,$.$Mac),Ve(4,h.$Lbc),Ve(5,d.$Nbc)],b)}),define(Pe[270],Ae([1,0,9,87,2,3,261,14,70,71,27,173,17,55,35,57]),function(pe,e,y,R,C,L,A,h,S,g,P,D,u,p,$,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fcc=e.$Ecc=void 0;class t{static async installEarlyHandler(m){Error.stackTraceLimit=100;const E=m.get(h.$3i),n=m.get(u.$UL).getProxy(L.$SJ.MainThreadErrors);y.setUnexpectedErrorHandler(a=>{E.error(a);const s=y.$1(a);n.$onUnexpectedError(s)})}static async installFullHandler(m){const E=m.get(h.$3i),b=m.get(u.$UL),n=m.get($.$fbc),a=m.get(d.$cM),s=b.getProxy(L.$SJ.MainThreadExtensionService),o=b.getProxy(L.$SJ.MainThreadErrors),w=await n.getExtensionPathIndex(),v=new WeakMap;function I(l,f){if(v.has(l))return v.get(l).stack;let F="",W,V;for(const j of f)F+=`
	at ${j.toString()}`,V=j.getFileName(),!W&&V&&(W=w.findSubstr(C.URI.file(V)));const B=`${l.name||"Error"}: ${l.message||""}${F}`;return v.set(l,{extensionIdentifier:W?.identifier,stack:B}),B}const k=Symbol("prepareStackTrace wrapped");let r=I;Object.defineProperty(Error,"prepareStackTrace",{configurable:!1,get(){return r},set(l){if(l===I||!l||l[k]){r=l||I;return}r=function(f,F){return I(f,F),l.call(Error,f,F)},Object.assign(r,{[k]:!0})}}),y.setUnexpectedErrorHandler(l=>{E.error(l);const f=y.$1(l),F=v.get(l);if(!F?.extensionIdentifier){o.$onUnexpectedError(f);return}s.$onExtensionRuntimeError(F.extensionIdentifier,f);const W=a.onExtensionError(F.extensionIdentifier,l);E.trace("forwarded error to extension?",W,F)})}}e.$Ecc=t;class i{constructor(m,E,b,n,a){this.a=b,this.b=new A.$92b(m,null,n),E=i.e(E,this.b);const s=new g.$xh(...(0,S.$kr)());s.set(P.$$L,{_serviceBrand:void 0,...E,messagePorts:a}),s.set(u.$UL,new u.$VL(this.b)),s.set(p.$Gac,new p.$Hac(n)),s.set($.$dbc,b);const o=new D.$3p(s,!0);o.invokeFunction(t.installEarlyHandler),this.d=o.invokeFunction(w=>w.get(h.$3i)),R.mark("code/extHost/didCreateServices"),this.a.pid?this.d.info(`Extension host with pid ${this.a.pid} started`):this.d.info("Extension host started"),this.d.trace("initData",E),this.c=o.invokeFunction(w=>w.get($.$fbc)),this.c.initialize(),o.invokeFunction(t.installFullHandler)}async asBrowserUri(m){const E=this.b.getProxy(L.$SJ.MainThreadExtensionService);return C.URI.revive(await E.$asBrowserUri(m))}terminate(m){this.c.terminate(m)}static e(m,E){m.allExtensions.forEach(n=>{n.extensionLocation=C.URI.revive(E.transformIncomingURIs(n.extensionLocation))}),m.environment.appRoot=C.URI.revive(E.transformIncomingURIs(m.environment.appRoot));const b=m.environment.extensionDevelopmentLocationURI;return b&&(m.environment.extensionDevelopmentLocationURI=b.map(n=>C.URI.revive(E.transformIncomingURIs(n)))),m.environment.extensionTestsLocationURI=C.URI.revive(E.transformIncomingURIs(m.environment.extensionTestsLocationURI)),m.environment.globalStorageHome=C.URI.revive(E.transformIncomingURIs(m.environment.globalStorageHome)),m.environment.workspaceStorageHome=C.URI.revive(E.transformIncomingURIs(m.environment.workspaceStorageHome)),m.environment.extensionTelemetryLogResource=C.URI.revive(E.transformIncomingURIs(m.environment.extensionTelemetryLogResource)),m.nlsBaseUrl=C.URI.revive(E.transformIncomingURIs(m.nlsBaseUrl)),m.logsLocation=C.URI.revive(E.transformIncomingURIs(m.logsLocation)),m.workspace=E.transformIncomingURIs(m.workspace),m}}e.$Fcc=i}),define(Pe[271],Ae([1,0,18,13,21,41,12,19,23,2,47]),function(pe,e,y,R,C,L,A,h,S,g,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ybc=e.$Xbc=e.$Wbc=e.$Vbc=void 0;class D{constructor(c,m,E,b){this.d=c,this.e=m,this.f=E,this.g=b,this.a=null,this.b=!1,this.c=0}search(c,m){const E=this.d.folderQueries||[],b=new C.$rc(m);return new Promise((n,a)=>{this.a=new p(c);let s=!1;const o=(w,v)=>{if(!s&&!this.b){const I=this.h(w);d(w)&&typeof this.d.maxResults=="number"&&this.c+I>this.d.maxResults&&(this.b=!0,s=!0,b.cancel(),w=this.j(w,this.d.maxResults-this.c));const k=this.h(w);this.c+=k,(k>0||!d(w))&&this.a.add(w,v)}};Promise.all(E.map((w,v)=>this.k(w,I=>o(I,v),b.token))).then(w=>{b.dispose(),this.a.flush();const v=w.some(I=>!!I&&!!I.limitHit);n({limitHit:this.b||v,messages:(0,y.$Kf)(w.map(I=>I?.message?Array.isArray(I.message)?I.message:[I.message]:[])),stats:{type:this.g}})},w=>{b.dispose();const v=(0,L.$ki)(w);a(new Error(v))})})}h(c){return d(c)?Array.isArray(c.ranges)?c.ranges.length:1:0}j(c,m){const E=Array.isArray(c.ranges)?c.ranges:[c.ranges],b=Array.isArray(c.preview.matches)?c.preview.matches:[c.preview.matches];return{ranges:E.slice(0,m),preview:{matches:b.slice(0,m),text:c.preview.text},uri:c.uri}}async k(c,m,E){const b=new P.$xI(this.d,c),n=[],a={report:w=>{if(!this.l(w))return;const v=c.folder.scheme===A.Schemas.file?(0,P.$yI)(()=>this.f.readdir(S.$fg(w.uri))):void 0,I=S.$ig(c.folder,w.uri);if(I){const k=b.includedInQuery(I,h.$cd(I),v);(0,R.$rg)(k)?n.push(k.then(r=>{r&&m(w)})):k&&m(w)}}},s=this.n(c),o=await this.e.provideTextSearchResults(u(this.d.contentPattern),s,a,E);return n.length&&await Promise.all(n),o}l(c){if(d(c)){if(Array.isArray(c.ranges)){if(!Array.isArray(c.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(c.preview.matches.length!==c.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(c.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}n(c){const m=(0,P.$wI)(this.d.includePattern,c.includePattern),E=(0,P.$wI)(this.d.excludePattern,c.excludePattern),b={folder:g.URI.from(c.folder),excludes:E,includes:m,useIgnoreFiles:!c.disregardIgnoreFiles,useGlobalIgnoreFiles:!c.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!c.disregardParentIgnoreFiles,followSymlinks:!c.ignoreSymlinks,encoding:c.fileEncoding&&this.f.toCanonicalName(c.fileEncoding),maxFileSize:this.d.maxFileSize,maxResults:this.d.maxResults,previewOptions:this.d.previewOptions,afterContext:this.d.afterContext,beforeContext:this.d.beforeContext};return b.usePCRE2=this.d.usePCRE2,b}}e.$Vbc=D;function u(i){return{isCaseSensitive:i.isCaseSensitive||!1,isRegExp:i.isRegExp||!1,isWordMatch:i.isWordMatch||!1,isMultiline:i.isMultiline||!1,pattern:i.pattern}}class p{constructor(c){this.e=c,this.b=-1,this.d=null,this.a=new t(512,m=>this.g(m))}add(c,m){this.d&&(this.b!==m||!S.$_f(this.c,c.uri))&&(this.f(),this.d=null),this.d||(this.b=m,this.d={resource:c.uri,results:[]}),this.d.results.push($(c))}f(){const c=this.d&&this.d.results?this.d.results.length:0;this.a.addItem(this.d,c)}flush(){this.f(),this.a.flush()}g(c){this.e(c)}}e.$Wbc=p;function $(i){return d(i)?{preview:{matches:(0,y.$Uf)(i.preview.matches,c=>({startLineNumber:c.start.line,startColumn:c.start.character,endLineNumber:c.end.line,endColumn:c.end.character})),text:i.preview.text},ranges:(0,y.$Uf)(i.ranges,c=>({startLineNumber:c.start.line,startColumn:c.start.character,endLineNumber:c.end.line,endColumn:c.end.character}))}:{text:i.text,lineNumber:i.lineNumber}}function d(i){return!!i.preview}e.$Xbc=d;class t{static{this.a=4e3}static{this.b=50}constructor(c,m){this.g=c,this.h=m,this.c=0,this.d=[],this.e=0}addItem(c,m){c&&this.j(c,m)}addItems(c,m){c&&this.k(c,m)}j(c,m){this.d.push(c),this.e+=m,this.l()}k(c,m){this.d=this.d.concat(c),this.e+=m,this.l()}l(){this.c<t.b?this.flush():this.e>=this.g?this.flush():this.f||(this.f=setTimeout(()=>{this.flush()},t.a))}flush(){this.e&&(this.c+=this.e,this.h(this.d),this.d=[],this.e=0,this.f&&(clearTimeout(this.f),this.f=0))}}e.$Ybc=t}),define(Pe[115],Ae([1,0,6,3,4,266,17,55,14,2,271]),function(pe,e,y,R,C,L,A,h,S,g,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2bc=e.$1bc=e.$Zbc=void 0,e.$Zbc=(0,C.$zh)("IExtHostSearch");let D=class{constructor(d,t,i){this.k=d,this.l=t,this.n=i,this.c=this.k.getProxy(R.$SJ.MainThreadSearch),this.d=0,this.e=new Map,this.g=new Set,this.h=new Map,this.i=new Set,this.j=new L.$Ubc}o(d){return this.l.transformOutgoingScheme(d)}registerTextSearchProvider(d,t){if(this.g.has(d))throw new Error(`a text search provider for the scheme '${d}' is already registered`);this.g.add(d);const i=this.d++;return this.e.set(i,t),this.c.$registerTextSearchProvider(i,this.o(d)),(0,y.$kb)(()=>{this.g.delete(d),this.e.delete(i),this.c.$unregisterProvider(i)})}registerFileSearchProvider(d,t){if(this.i.has(d))throw new Error(`a file search provider for the scheme '${d}' is already registered`);this.i.add(d);const i=this.d++;return this.h.set(i,t),this.c.$registerFileSearchProvider(i,this.o(d)),(0,y.$kb)(()=>{this.i.delete(d),this.h.delete(i),this.c.$unregisterProvider(i)})}$provideFileSearchResults(d,t,i,c){const m=u(i),E=this.h.get(d);if(E)return this.j.fileSearch(m,E,b=>{this.c.$handleFileMatch(d,t,b.map(n=>n.resource))},c);throw new Error("unknown provider: "+d)}$clearCache(d){return this.j.clearCache(d),Promise.resolve(void 0)}$provideTextSearchResults(d,t,i,c){const m=this.e.get(d);if(!m||!m.provideTextSearchResults)throw new Error(`Unknown provider ${d}`);const E=u(i);return this.q(E,m).search(n=>this.c.$handleTextMatch(d,t,n),c)}$enableExtensionHostSearch(){}q(d,t){return new P.$Vbc(d,t,{readdir:i=>Promise.resolve([]),toCanonicalName:i=>i},"textSearchProvider")}};e.$1bc=D,e.$1bc=D=Ke([Ve(0,A.$UL),Ve(1,h.$Gac),Ve(2,S.$3i)],D);function u($){return{...$,folderQueries:$.folderQueries&&$.folderQueries.map(p),extraFileResources:$.extraFileResources&&$.extraFileResources.map(d=>g.URI.revive(d))}}e.$2bc=u;function p($){return{...$,folder:g.URI.revive($.folder)}}}),define(Pe[272],Ae([1,0,21,9,5,29,2,136,283,125,134,38,3,79,225,224,31,226,34,228,229,230,204,231,59,35,233,234,239,240,242,110,208,248,249,251,84,62,253,211,8,7,52,256,63,109,33,20,199,238,51,108,112,114,115,14,55,17,27,243,197,86,80,218,254,85,61,259,257,258,219,39,252,255,83,60,57,244,111,245,12,95,207,190,236,6,26,195,81,186,246,247,220,235,206,237,82,250,221,222,223,217,232]),function(pe,e,y,R,C,L,A,h,S,g,P,D,u,p,$,d,t,i,c,m,E,b,n,a,s,o,w,v,I,k,r,l,f,F,W,V,B,j,U,z,ie,Y,ye,ke,Re,X,le,we,ae,x,ue,O,J,he,Ee,ve,be,De,oe,de,se,ne,me,Ce,M,q,H,Z,K,ee,ce,ze,Ue,Ze,He,et,Ye,_e,it,tt,Ne,st,_,Q,$e,je,Oe,Qe,nt,gt,vt,Ft,Qt,Vt,wt,Tt,zt,Jt,Pt,At,Ot,jt,qt){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zcc=void 0;function Bt(at){const ut=at.get(oe.$$L),Ht=at.get(ze.$wac),Ct=at.get(H.$2ac),kt=at.get(o.$fbc),ht=at.get(le.$Jac),St=at.get(Ye.$cM),Lt=at.get(c.$Mac),Et=at.get(be.$Gac),qe=at.get(De.$UL),Nt=at.get(B.$Xac),Ie=at.get(q.$3ac),Me=at.get(ve.$4i),ge=at.get(ve.$3i),G=at.get(ne.$3rb),Fe=at.get(me.$zac),Be=at.get(X.$Dbc),Ge=at.get(He.$0ac),We=at.get(et.$Lbc),xe=at.get(zt.$bbc);qe.set(u.$TJ.ExtHostFileSystemInfo,Ht),qe.set(u.$TJ.ExtHostLogLevelServiceShape,Me),qe.set(u.$TJ.ExtHostWorkspace,ht),qe.set(u.$TJ.ExtHostConfiguration,Lt),qe.set(u.$TJ.ExtHostExtensionService,kt),qe.set(u.$TJ.ExtHostStorage,Nt),qe.set(u.$TJ.ExtHostTunnelService,G),qe.set(u.$TJ.ExtHostWindow,Be),qe.set(u.$TJ.ExtHostSecretState,Ge),qe.set(u.$TJ.ExtHostTelemetry,St),qe.set(u.$TJ.ExtHostEditorTabs,We),qe.set(u.$TJ.ExtHostManagedSockets,xe);const pt=qe.set(u.$TJ.ExtHostDecorations,at.get(O.$Hbc)),bt=qe.set(u.$TJ.ExtHostDocumentsAndEditors,at.get(s.$6L)),dt=qe.set(u.$TJ.ExtHostCommands,at.get(t.$eM)),ft=qe.set(u.$TJ.ExtHostTerminalService,at.get(j.$5ac)),mt=qe.set(u.$TJ.ExtHostDebugService,at.get(he.$Pbc)),gi=qe.set(u.$TJ.ExtHostSearch,at.get(Ee.$Zbc)),Kt=qe.set(u.$TJ.ExtHostTask,at.get(J.$Kbc)),Ei=qe.set(u.$TJ.ExtHostOutputService,at.get(l.$nbc)),Wt=qe.set(u.$TJ.ExtHostLocalization,at.get(nt.$abc)),mi=qe.set(u.$TJ.ExtHostUrls,new ke.$wbc(qe)),It=qe.set(u.$TJ.ExtHostDocuments,new a.$uac(qe,bt)),ki=qe.set(u.$TJ.ExtHostDocumentContentProviders,new b.$Oac(qe,bt,ge)),Vi=qe.set(u.$TJ.ExtHostDocumentSaveParticipant,new n.$Pac(ge,It,qe.getProxy(u.$SJ.MainThreadBulkEdits))),Dt=qe.set(u.$TJ.ExtHostNotebook,new de.$6bc(qe,dt,bt,It,Ct)),ti=qe.set(u.$TJ.ExtHostNotebookDocuments,new Q.$lcc(Dt)),$i=qe.set(u.$TJ.ExtHostNotebookEditors,new _.$kcc(ge,Dt)),si=qe.set(u.$TJ.ExtHostNotebookKernels,new _e.$hcc(qe,ut,Dt,dt,ge)),Di=qe.set(u.$TJ.ExtHostNotebookRenderers,new tt.$jcc(qe,Dt)),Si=qe.set(u.$TJ.ExtHostNotebookDocumentSaveParticipant,new wt.$rcc(ge,Dt,qe.getProxy(u.$SJ.MainThreadBulkEdits))),Rt=qe.set(u.$TJ.ExtHostEditors,new U.$ubc(qe,bt)),pi=qe.set(u.$TJ.ExtHostTreeViews,new z.$vbc(qe.getProxy(u.$SJ.MainThreadTreeViews),dt,ge)),Ii=qe.set(u.$TJ.ExtHostEditorInsets,new ae.$Ebc(qe.getProxy(u.$SJ.MainThreadEditorInsets),Rt,ut.remote)),oi=qe.set(u.$TJ.ExtHostDiagnostics,new m.$yac(qe,ge,Ht,bt)),ai=qe.set(u.$TJ.ExtHostLanguages,new k.$kbc(qe,It,dt.converter,Et)),ct=qe.set(u.$TJ.ExtHostLanguageFeatures,new I.$Cac(qe,Et,It,dt,oi,ge,Fe,St)),qi=qe.set(u.$TJ.ExtHostFileSystem,new w.$ibc(qe,ct)),Xt=qe.set(u.$TJ.ExtHostFileSystemEventService,new v.$jbc(qe,ge,bt)),ii=qe.set(u.$TJ.ExtHostQuickOpen,(0,F.$pbc)(qe,ht,dt)),bi=qe.set(u.$TJ.ExtHostSCM,new W.$rbc(qe,dt,It,ge)),Ci=qe.set(u.$TJ.ExtHostQuickDiff,new Ft.$occ(qe,Et)),Ki=qe.set(u.$TJ.ExtHostShare,new Jt.$tcc(qe,Et)),Pi=qe.set(u.$TJ.ExtHostComments,(0,i.$Fac)(qe,dt,It)),vi=qe.set(u.$TJ.ExtHostProgress,new f.$obc(qe.getProxy(u.$SJ.MainThreadProgress))),Ji=qe.set(u.$TJ.ExtHosLabelService,new x.$Fbc(qe)),Ai=qe.set(u.$TJ.ExtHostTheming,new se.$7bc(qe)),ci=qe.set(u.$TJ.ExtHostAuthentication,new Ce.$8bc(qe)),Hi=qe.set(u.$TJ.ExtHostTimeline,new M.$0bc(qe,dt)),wi=qe.set(u.$TJ.ExtHostWebviews,new Re.$zbc(qe,ut.remote,ht,ge,Fe)),Ri=qe.set(u.$TJ.ExtHostWebviewPanels,new ee.$_bc(qe,wi,ht)),cn=qe.set(u.$TJ.ExtHostCustomEditors,new K.$acc(qe,It,Ie,wi,Ri)),Mi=qe.set(u.$TJ.ExtHostWebviewViews,new Z.$$bc(qe,wi)),ni=qe.set(u.$TJ.ExtHostTesting,new Ue.$ccc(qe,dt,bt)),un=qe.set(u.$TJ.ExtHostUriOpeners,new Ze.$gcc(qe)),ln=qe.set(u.$TJ.ExtHostProfileContentHandlers,new vt.$ncc(qe));qe.set(u.$TJ.ExtHostInteractive,new $e.$mcc(qe,Dt,bt,dt,ge));const Gi=qe.set(u.$TJ.ExtHostInlineChat,new Vt.$qcc(qe,dt,It,ge)),fi=qe.set(u.$TJ.ExtHostChatProvider,new Pt.$ucc(qe,ge)),Zi=qe.set(u.$TJ.ExtHostChatSlashCommands,new At.$vcc(qe,fi,ge)),Qi=qe.set(u.$TJ.ExtHostChatVariables,new Ot.$wcc(qe)),ui=qe.set(u.$TJ.ExtHostChat,new Qt.$pcc(qe,ge)),Xi=qe.set(u.$TJ.ExtHostAiRelatedInformation,new jt.$xcc(qe)),Fi=qe.set(u.$TJ.ExtHostAiEmbeddingVector,new qt.$ycc(qe)),Yi=qe.set(u.$TJ.ExtHostIssueReporter,new Tt.$scc(qe)),Yt=qe.set(u.$TJ.ExtHostStatusBar,new V.$tbc(qe,dt.converter)),yi=Object.values(u.$TJ);qe.assertRegistered(yi);const hn=new ce.$bcc(qe,bt),Gt=new d.$Eac(qe),li=new r.$lbc(qe,ge),Ti=new E.$Nac(qe);return $.$Dac.register(dt),function(Le,_t,Li){const $t=function(){let te=!Le.isUnderDevelopment;function fe(){te||(ge.info(`Extension '${Le.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),te=!0)}return function Te(rt){if(Array.isArray(rt))rt.forEach(Te);else if(typeof rt=="string")fe();else{const yt=rt;typeof yt.scheme>"u"&&fe(),typeof yt.exclusive=="boolean"&&(0,Oe.$MF)(Le,"documentFiltersExclusive")}return rt}}(),_i={getSession(te,fe,Te){return ci.getSession(Le,te,fe,Te)},getSessions(te,fe){return(0,Oe.$MF)(Le,"authGetSessions"),ci.getSessions(Le,te,fe)},async hasSession(te,fe){return(0,Oe.$MF)(Le,"authSession"),!!await ci.getSession(Le,te,fe,{silent:!0})},get onDidChangeSessions(){return ci.onDidChangeSessions},registerAuthenticationProvider(te,fe,Te,rt){return ci.registerAuthenticationProvider(te,fe,Te,rt)}},xi={registerCommand(te,fe,Te){return dt.registerCommand(!0,te,fe,Te,void 0,Le)},registerTextEditorCommand(te,fe,Te){return dt.registerCommand(!0,te,(...rt)=>{const yt=Rt.getActiveTextEditor();if(!yt){ge.warn("Cannot execute "+te+" because there is no active text editor.");return}return yt.edit(Mt=>{fe.apply(Te,[yt,Mt,...rt])}).then(Mt=>{Mt||ge.warn("Edits from command "+te+" were not applied.")},Mt=>{ge.warn("An error occurred while running command "+te,Mt)})},void 0,void 0,Le)},registerDiffInformationCommand:(te,fe,Te)=>((0,Oe.$MF)(Le,"diffCommand"),dt.registerCommand(!0,te,async(...rt)=>{const yt=bt.activeEditor(!0);if(!yt){ge.warn("Cannot execute "+te+" because there is no active text editor.");return}const Mt=await Rt.getDiffInformation(yt.id);fe.apply(Te,[Mt,...rt])},void 0,void 0,Le)),executeCommand(te,...fe){return dt.executeCommand(te,...fe)},getCommands(te=!1){return dt.getCommands(te)}},en={get machineId(){return ut.telemetryInfo.machineId},get sessionId(){return ut.telemetryInfo.sessionId},get language(){return ut.environment.appLanguage},get appName(){return ut.environment.appName},get appRoot(){return ut.environment.appRoot?.fsPath??""},get appHost(){return ut.environment.appHost},get uriScheme(){return ut.environment.appUriScheme},get clipboard(){return Gt.value},get shell(){return ft.getDefaultShell(!1)},get onDidChangeShell(){return(0,Oe.$MF)(Le,"envShellEvent"),ft.onDidChangeShell},get isTelemetryEnabled(){return St.getTelemetryConfiguration()},get onDidChangeTelemetryEnabled(){return St.onDidChangeTelemetryEnabled},get telemetryConfiguration(){return(0,Oe.$MF)(Le,"telemetry"),St.getTelemetryDetails()},get onDidChangeTelemetryConfiguration(){return(0,Oe.$MF)(Le,"telemetry"),St.onDidChangeTelemetryConfiguration},get isNewAppInstall(){return(0,Ye.$bM)(ut.telemetryInfo.firstSessionDate)},createTelemetryLogger(te,fe){return Ye.$aM.validateSender(te),St.instantiateLogger(Le,te,fe)},openExternal(te,fe){return Be.openUri(te,{allowTunneling:!!ut.remote.authority,allowContributedOpeners:fe?.allowContributedOpeners})},async asExternalUri(te){if(te.scheme===ut.environment.appUriScheme)return mi.createAppUri(te);try{return await Be.asExternalUri(te,{allowTunneling:!!ut.remote.authority})}catch(fe){if((0,st.$CT)(te,Ne.Schemas.http)||(0,st.$CT)(te,Ne.Schemas.https))return te;throw fe}},get remoteName(){return(0,ue.$Nk)(ut.remote.authority)},get remoteAuthority(){return(0,Oe.$MF)(Le,"resolvers"),ut.remote.authority},get uiKind(){return ut.uiKind},get logLevel(){return ge.getLevel()},get onDidChangeLogLevel(){return ge.onDidChangeLogLevel},registerIssueUriRequestHandler(te){return(0,Oe.$MF)(Le,"handleIssueUri"),Yi.registerIssueUriRequestHandler(Le,te)},get appQuality(){return(0,Oe.$MF)(Le,"resolvers"),ut.quality},get appCommit(){return(0,Oe.$MF)(Le,"resolvers"),ut.commit}};ut.environment.extensionTestsLocationURI||Object.freeze(en);const dn={createTestController(te,fe,Te){return ni.createTestController(Le,te,fe,Te)},createTestObserver(){return(0,Oe.$MF)(Le,"testObserver"),ni.createTestObserver()},runTests(te){return(0,Oe.$MF)(Le,"testObserver"),ni.runTests(te)},get onDidChangeTestResults(){return(0,Oe.$MF)(Le,"testObserver"),ni.onResultsChanged},get testResults(){return(0,Oe.$MF)(Le,"testObserver"),ni.results}},hi=ut.remote.isRemote?Y.ExtensionKind.Workspace:Y.ExtensionKind.UI,tn={getExtension(te,fe){(0,Oe.$LF)(Le,"extensionsAny")||(fe=!1);const Te=_t.mine.getExtensionDescription(te);if(Te)return new o.$gbc(kt,Le.identifier,Te,hi,!1);if(fe){const rt=_t.all.getExtensionDescription(te);if(rt)return new o.$gbc(kt,Le.identifier,rt,hi,!0)}},get all(){const te=[];for(const fe of _t.mine.getAllExtensionDescriptions())te.push(new o.$gbc(kt,Le.identifier,fe,hi,!1));return te},get allAcrossExtensionHosts(){(0,Oe.$MF)(Le,"extensionsAny");const te=new we.$Ul(_t.mine.getAllExtensionDescriptions().map(Te=>Te.identifier)),fe=[];for(const Te of _t.all.getAllExtensionDescriptions()){const rt=!te.has(Te.identifier);fe.push(new o.$gbc(kt,Le.identifier,Te,hi,rt))}return fe},get onDidChange(){return(0,Oe.$LF)(Le,"extensionsAny")?C.Event.any(_t.mine.onDidChange,_t.all.onDidChange):_t.mine.onDidChange}},nn={createDiagnosticCollection(te){return oi.createDiagnosticCollection(Le.identifier,te)},get onDidChangeDiagnostics(){return oi.onDidChangeDiagnostics},getDiagnostics:te=>oi.getDiagnostics(te),getLanguages(){return ai.getLanguages()},setTextDocumentLanguage(te,fe){return ai.changeLanguage(te.uri,fe)},match(te,fe){const Te=It.getDocumentData(fe.uri)?.notebook;return(0,P.$$E)(ie.LanguageSelector.from(te),fe.uri,fe.languageId,!0,Te?.uri,Te?.notebookType)},registerCodeActionsProvider(te,fe,Te){return ct.registerCodeActionProvider(Le,$t(te),fe,Te)},registerDocumentPasteEditProvider(te,fe,Te){return(0,Oe.$MF)(Le,"documentPaste"),ct.registerDocumentPasteEditProvider(Le,$t(te),fe,Te)},registerCodeLensProvider(te,fe){return ct.registerCodeLensProvider(Le,$t(te),fe)},registerDefinitionProvider(te,fe){return ct.registerDefinitionProvider(Le,$t(te),fe)},registerDeclarationProvider(te,fe){return ct.registerDeclarationProvider(Le,$t(te),fe)},registerImplementationProvider(te,fe){return ct.registerImplementationProvider(Le,$t(te),fe)},registerTypeDefinitionProvider(te,fe){return ct.registerTypeDefinitionProvider(Le,$t(te),fe)},registerHoverProvider(te,fe){return ct.registerHoverProvider(Le,$t(te),fe,Le.identifier)},registerEvaluatableExpressionProvider(te,fe){return ct.registerEvaluatableExpressionProvider(Le,$t(te),fe,Le.identifier)},registerInlineValuesProvider(te,fe){return ct.registerInlineValuesProvider(Le,$t(te),fe,Le.identifier)},registerDocumentHighlightProvider(te,fe){return ct.registerDocumentHighlightProvider(Le,$t(te),fe)},registerLinkedEditingRangeProvider(te,fe){return ct.registerLinkedEditingRangeProvider(Le,$t(te),fe)},registerReferenceProvider(te,fe){return ct.registerReferenceProvider(Le,$t(te),fe)},registerRenameProvider(te,fe){return ct.registerRenameProvider(Le,$t(te),fe)},registerDocumentSymbolProvider(te,fe,Te){return ct.registerDocumentSymbolProvider(Le,$t(te),fe,Te)},registerWorkspaceSymbolProvider(te){return ct.registerWorkspaceSymbolProvider(Le,te)},registerDocumentFormattingEditProvider(te,fe){return ct.registerDocumentFormattingEditProvider(Le,$t(te),fe)},registerDocumentRangeFormattingEditProvider(te,fe){return ct.registerDocumentRangeFormattingEditProvider(Le,$t(te),fe)},registerOnTypeFormattingEditProvider(te,fe,Te,...rt){return ct.registerOnTypeFormattingEditProvider(Le,$t(te),fe,[Te].concat(rt))},registerDocumentSemanticTokensProvider(te,fe,Te){return ct.registerDocumentSemanticTokensProvider(Le,$t(te),fe,Te)},registerDocumentRangeSemanticTokensProvider(te,fe,Te){return ct.registerDocumentRangeSemanticTokensProvider(Le,$t(te),fe,Te)},registerSignatureHelpProvider(te,fe,Te,...rt){return typeof Te=="object"?ct.registerSignatureHelpProvider(Le,$t(te),fe,Te):ct.registerSignatureHelpProvider(Le,$t(te),fe,typeof Te>"u"?[]:[Te,...rt])},registerCompletionItemProvider(te,fe,...Te){return ct.registerCompletionItemProvider(Le,$t(te),fe,Te)},registerInlineCompletionItemProvider(te,fe,Te){return fe.handleDidShowCompletionItem&&(0,Oe.$MF)(Le,"inlineCompletionsAdditions"),fe.handleDidPartiallyAcceptCompletionItem&&(0,Oe.$MF)(Le,"inlineCompletionsAdditions"),Te&&(0,Oe.$MF)(Le,"inlineCompletionsAdditions"),ct.registerInlineCompletionsProvider(Le,$t(te),fe,Te)},registerDocumentLinkProvider(te,fe){return ct.registerDocumentLinkProvider(Le,$t(te),fe)},registerColorProvider(te,fe){return ct.registerColorProvider(Le,$t(te),fe)},registerFoldingRangeProvider(te,fe){return ct.registerFoldingRangeProvider(Le,$t(te),fe)},registerSelectionRangeProvider(te,fe){return ct.registerSelectionRangeProvider(Le,te,fe)},registerCallHierarchyProvider(te,fe){return ct.registerCallHierarchyProvider(Le,te,fe)},registerTypeHierarchyProvider(te,fe){return ct.registerTypeHierarchyProvider(Le,te,fe)},setLanguageConfiguration:(te,fe)=>ct.setLanguageConfiguration(Le,te,fe),getTokenInformationAtPosition(te,fe){return(0,Oe.$MF)(Le,"tokenInformation"),ai.tokenAtPosition(te,fe)},registerInlayHintsProvider(te,fe){return ct.registerInlayHintsProvider(Le,te,fe)},createLanguageStatusItem(te,fe){return ai.createLanguageStatusItem(Le,te,fe)},registerDocumentDropEditProvider(te,fe,Te){return ct.registerDocumentOnDropEditProvider(Le,te,fe,(0,Oe.$LF)(Le,"dropMetadata")?Te:void 0)}},rn={get activeTextEditor(){return Rt.getActiveTextEditor()},get visibleTextEditors(){return Rt.getVisibleTextEditors()},get activeTerminal(){return ft.activeTerminal},get terminals(){return ft.terminals},async showTextDocument(te,fe,Te){const rt=await(A.URI.isUri(te)?Promise.resolve(sn.openTextDocument(te)):Promise.resolve(te));return Rt.showTextDocument(rt,fe,Te)},createTextEditorDecorationType(te){return Rt.createTextEditorDecorationType(Le,te)},onDidChangeActiveTextEditor(te,fe,Te){return Rt.onDidChangeActiveTextEditor(te,fe,Te)},onDidChangeVisibleTextEditors(te,fe,Te){return Rt.onDidChangeVisibleTextEditors(te,fe,Te)},onDidChangeTextEditorSelection(te,fe,Te){return Rt.onDidChangeTextEditorSelection(te,fe,Te)},onDidChangeTextEditorOptions(te,fe,Te){return Rt.onDidChangeTextEditorOptions(te,fe,Te)},onDidChangeTextEditorVisibleRanges(te,fe,Te){return Rt.onDidChangeTextEditorVisibleRanges(te,fe,Te)},onDidChangeTextEditorViewColumn(te,fe,Te){return Rt.onDidChangeTextEditorViewColumn(te,fe,Te)},onDidCloseTerminal(te,fe,Te){return ft.onDidCloseTerminal(te,fe,Te)},onDidOpenTerminal(te,fe,Te){return ft.onDidOpenTerminal(te,fe,Te)},onDidChangeActiveTerminal(te,fe,Te){return ft.onDidChangeActiveTerminal(te,fe,Te)},onDidChangeTerminalDimensions(te,fe,Te){return(0,Oe.$MF)(Le,"terminalDimensions"),ft.onDidChangeTerminalDimensions(te,fe,Te)},onDidChangeTerminalState(te,fe,Te){return ft.onDidChangeTerminalState(te,fe,Te)},onDidWriteTerminalData(te,fe,Te){return(0,Oe.$MF)(Le,"terminalDataWriteEvent"),ft.onDidWriteTerminalData(te,fe,Te)},onDidExecuteTerminalCommand(te,fe,Te){return(0,Oe.$MF)(Le,"terminalExecuteCommandEvent"),ft.onDidExecuteTerminalCommand(te,fe,Te)},get state(){return Be.getState(Le)},onDidChangeWindowState(te,fe,Te){return Be.onDidChangeWindowState(te,fe,Te)},showInformationMessage(te,...fe){return li.showMessage(Le,L.default.Info,te,fe[0],fe.slice(1))},showWarningMessage(te,...fe){return li.showMessage(Le,L.default.Warning,te,fe[0],fe.slice(1))},showErrorMessage(te,...fe){return li.showMessage(Le,L.default.Error,te,fe[0],fe.slice(1))},showQuickPick(te,fe,Te){return ii.showQuickPick(Le,te,fe,Te)},showWorkspaceFolderPick(te){return ii.showWorkspaceFolderPick(te)},showInputBox(te,fe){return ii.showInput(te,fe)},showOpenDialog(te){return Ti.showOpenDialog(Le,te)},showSaveDialog(te){return Ti.showSaveDialog(te)},createStatusBarItem(te,fe,Te){let rt,yt,Mt;return typeof te=="string"?(rt=te,yt=fe,Mt=Te):(yt=te,Mt=fe),Yt.createStatusBarEntry(Le,rt,yt,Mt)},setStatusBarMessage(te,fe){return Yt.setStatusBarMessage(te,fe)},withScmProgress(te){return Fe.report("window.withScmProgress",Le,"Use 'withProgress' instead."),vi.withProgress(Le,{location:Y.ProgressLocation.SourceControl},(fe,Te)=>te({report(rt){}}))},withProgress(te,fe){return vi.withProgress(Le,te,fe)},createOutputChannel(te,fe){return Ei.createOutputChannel(te,fe,Le)},createWebviewPanel(te,fe,Te,rt){return Ri.createWebviewPanel(Le,te,fe,Te,rt)},createWebviewTextEditorInset(te,fe,Te,rt){return(0,Oe.$MF)(Le,"editorInsets"),Ii.createWebviewEditorInset(te,fe,Te,rt,Le)},createTerminal(te,fe,Te){return typeof te=="object"?"pty"in te?ft.createExtensionTerminal(te):ft.createTerminalFromOptions(te):ft.createTerminal(te,fe,Te)},registerTerminalLinkProvider(te){return ft.registerLinkProvider(te)},registerTerminalProfileProvider(te,fe){return ft.registerProfileProvider(Le,te,fe)},registerTerminalQuickFixProvider(te,fe){return(0,Oe.$MF)(Le,"terminalQuickFixProvider"),ft.registerTerminalQuickFixProvider(te,Le.identifier.value,fe)},registerTreeDataProvider(te,fe){return pi.registerTreeDataProvider(te,fe,Le)},createTreeView(te,fe){return pi.createTreeView(te,fe,Le)},registerWebviewPanelSerializer:(te,fe)=>Ri.registerWebviewPanelSerializer(Le,te,fe),registerCustomEditorProvider:(te,fe,Te={})=>cn.registerCustomEditorProvider(Le,te,fe,Te),registerFileDecorationProvider(te){return pt.registerFileDecorationProvider(te,Le)},registerUriHandler(te){return mi.registerUriHandler(Le,te)},createQuickPick(){return ii.createQuickPick(Le)},createInputBox(){return ii.createInputBox(Le)},get activeColorTheme(){return Ai.activeColorTheme},onDidChangeActiveColorTheme(te,fe,Te){return Ai.onDidChangeActiveColorTheme(te,fe,Te)},registerWebviewViewProvider(te,fe,Te){return Mi.registerWebviewViewProvider(Le,te,fe,Te?.webviewOptions)},get activeNotebookEditor(){return Dt.activeNotebookEditor},onDidChangeActiveNotebookEditor(te,fe,Te){return Dt.onDidChangeActiveNotebookEditor(te,fe,Te)},get visibleNotebookEditors(){return Dt.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return Dt.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(te,fe,Te){return $i.onDidChangeNotebookEditorSelection(te,fe,Te)},onDidChangeNotebookEditorVisibleRanges(te,fe,Te){return $i.onDidChangeNotebookEditorVisibleRanges(te,fe,Te)},showNotebookDocument(te,fe){return Dt.showNotebookDocument(te,fe)},registerExternalUriOpener(te,fe,Te){return(0,Oe.$MF)(Le,"externalUriOpener"),un.registerExternalUriOpener(Le.identifier,te,fe,Te)},registerProfileContentHandler(te,fe){return(0,Oe.$MF)(Le,"profileContentHandlers"),ln.registrProfileContentHandler(Le,te,fe)},registerQuickDiffProvider(te,fe,Te,rt){return(0,Oe.$MF)(Le,"quickDiffProvider"),Ci.registerQuickDiffProvider($t(te),fe,Te,rt)},get tabGroups(){return We.tabGroups},registerShareProvider(te,fe){return(0,Oe.$MF)(Le,"shareProvider"),Ki.registerShareProvider($t(te),fe)}},sn={get rootPath(){return Fe.report("workspace.rootPath",Le,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),ht.getPath()},set rootPath(te){throw new R.$7("rootPath")},getWorkspaceFolder(te){return ht.getWorkspaceFolder(te)},get workspaceFolders(){return ht.getWorkspaceFolders()},get name(){return ht.name},set name(te){throw new R.$7("name")},get workspaceFile(){return ht.workspaceFile},set workspaceFile(te){throw new R.$7("workspaceFile")},updateWorkspaceFolders:(te,fe,...Te)=>ht.updateWorkspaceFolders(Le,te,fe||0,...Te),onDidChangeWorkspaceFolders:function(te,fe,Te){return ht.onDidChangeWorkspace(te,fe,Te)},asRelativePath:(te,fe)=>ht.getRelativePath(te,fe),findFiles:(te,fe,Te,rt)=>ht.findFiles(te,fe,Te,Le.identifier,rt),findTextInFiles:(te,fe,Te,rt)=>{(0,Oe.$MF)(Le,"findTextInFiles");let yt,Mt;return typeof fe=="object"?(yt=fe,Mt=Te):(yt={},Mt=fe,rt=Te),ht.findTextInFiles(te,yt||{},Mt,Le.identifier,rt)},save:te=>((0,Oe.$MF)(Le,"saveEditor"),ht.save(te)),saveAs:te=>((0,Oe.$MF)(Le,"saveEditor"),ht.saveAs(te)),saveAll:te=>ht.saveAll(te),applyEdit(te,fe){return hn.applyWorkspaceEdit(te,Le,fe)},createFileSystemWatcher:(te,fe,Te,rt)=>Xt.createFileSystemWatcher(ht,Le,te,fe,Te,rt),get textDocuments(){return It.getAllDocumentData().map(te=>te.document)},set textDocuments(te){throw new R.$7("textDocuments")},openTextDocument(te){let fe;const Te=te;if(typeof te=="string")fe=Promise.resolve(A.URI.file(te));else if(A.URI.isUri(te))fe=Promise.resolve(te);else if(!Te||typeof Te=="object")fe=It.createDocumentData(Te);else throw new Error("illegal argument - uriOrFileNameOrOptions");return fe.then(rt=>It.ensureDocumentData(rt).then(yt=>yt.document))},onDidOpenTextDocument:(te,fe,Te)=>It.onDidAddDocument(te,fe,Te),onDidCloseTextDocument:(te,fe,Te)=>It.onDidRemoveDocument(te,fe,Te),onDidChangeTextDocument:(te,fe,Te)=>It.onDidChangeDocument(te,fe,Te),onDidSaveTextDocument:(te,fe,Te)=>It.onDidSaveDocument(te,fe,Te),onWillSaveTextDocument:(te,fe,Te)=>Vi.getOnWillSaveTextDocumentEvent(Le)(te,fe,Te),get notebookDocuments(){return Dt.notebookDocuments.map(te=>te.apiNotebook)},async openNotebookDocument(te,fe){let Te;if(A.URI.isUri(te))Te=te,await Dt.openNotebookDocument(te);else if(typeof te=="string")Te=A.URI.revive(await Dt.createNotebookDocument({viewType:te,content:fe}));else throw new Error("Invalid arguments");return Dt.getNotebookDocument(Te).apiNotebook},onDidSaveNotebookDocument(te,fe,Te){return ti.onDidSaveNotebookDocument(te,fe,Te)},onDidChangeNotebookDocument(te,fe,Te){return ti.onDidChangeNotebookDocument(te,fe,Te)},onWillSaveNotebookDocument(te,fe,Te){return Si.getOnWillSaveNotebookDocumentEvent(Le)(te,fe,Te)},get onDidOpenNotebookDocument(){return Dt.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return Dt.onDidCloseNotebookDocument},registerNotebookSerializer(te,fe,Te,rt){return Dt.registerNotebookSerializer(Le,te,fe,Te,(0,Oe.$LF)(Le,"notebookLiveShare")?rt:void 0)},onDidChangeConfiguration:(te,fe,Te)=>Li.onDidChangeConfiguration(te,fe,Te),getConfiguration(te,fe){return fe=arguments.length===1?void 0:fe,Li.getConfiguration(te,fe,Le)},registerTextDocumentContentProvider(te,fe){return ki.registerTextDocumentContentProvider(te,fe)},registerTaskProvider:(te,fe)=>(Fe.report("window.registerTaskProvider",Le,"Use the corresponding function on the 'tasks' namespace instead"),Kt.registerTaskProvider(Le,te,fe)),registerFileSystemProvider(te,fe,Te){return(0,je.$jb)(qi.registerFileSystemProvider(Le,te,fe,Te),Ct.addFileSystemProvider(te,fe,Te))},get fs(){return Ct.value},registerFileSearchProvider:(te,fe)=>((0,Oe.$MF)(Le,"fileSearchProvider"),gi.registerFileSearchProvider(te,fe)),registerTextSearchProvider:(te,fe)=>((0,Oe.$MF)(Le,"textSearchProvider"),gi.registerTextSearchProvider(te,fe)),registerRemoteAuthorityResolver:(te,fe)=>((0,Oe.$MF)(Le,"resolvers"),kt.registerRemoteAuthorityResolver(te,fe)),registerResourceLabelFormatter:te=>((0,Oe.$MF)(Le,"resolvers"),Ji.$registerResourceLabelFormatter(te)),getRemoteExecServer:te=>((0,Oe.$MF)(Le,"resolvers"),kt.getRemoteExecServer(te)),onDidCreateFiles:(te,fe,Te)=>Xt.onDidCreateFile(te,fe,Te),onDidDeleteFiles:(te,fe,Te)=>Xt.onDidDeleteFile(te,fe,Te),onDidRenameFiles:(te,fe,Te)=>Xt.onDidRenameFile(te,fe,Te),onWillCreateFiles:(te,fe,Te)=>Xt.getOnWillCreateFileEvent(Le)(te,fe,Te),onWillDeleteFiles:(te,fe,Te)=>Xt.getOnWillDeleteFileEvent(Le)(te,fe,Te),onWillRenameFiles:(te,fe,Te)=>Xt.getOnWillRenameFileEvent(Le)(te,fe,Te),openTunnel:te=>((0,Oe.$MF)(Le,"tunnels"),G.openTunnel(Le,te).then(fe=>{if(!fe)throw new Error("cannot open tunnel");return fe})),get tunnels(){return(0,Oe.$MF)(Le,"tunnels"),G.getTunnels()},onDidChangeTunnels:(te,fe,Te)=>((0,Oe.$MF)(Le,"tunnels"),G.onDidChangeTunnels(te,fe,Te)),registerPortAttributesProvider:(te,fe)=>((0,Oe.$MF)(Le,"portsAttributes"),G.registerPortsAttributesProvider(te,fe)),registerTunnelProvider:(te,fe)=>((0,Oe.$MF)(Le,"tunnelFactory"),G.registerTunnelProvider(te,fe)),registerTimelineProvider:(te,fe)=>((0,Oe.$MF)(Le,"timeline"),Hi.registerTimelineProvider(te,fe,Le.identifier,dt.converter)),get isTrusted(){return ht.trusted},requestWorkspaceTrust:te=>((0,Oe.$MF)(Le,"workspaceTrust"),ht.requestWorkspaceTrust(te)),onDidGrantWorkspaceTrust:(te,fe,Te)=>ht.onDidGrantWorkspaceTrust(te,fe,Te),registerEditSessionIdentityProvider:(te,fe)=>((0,Oe.$MF)(Le,"editSessionIdentityProvider"),ht.registerEditSessionIdentityProvider(te,fe)),onWillCreateEditSessionIdentity:(te,fe,Te)=>((0,Oe.$MF)(Le,"editSessionIdentityProvider"),ht.getOnWillCreateEditSessionIdentityEvent(Le)(te,fe,Te)),registerCanonicalUriProvider:(te,fe)=>((0,Oe.$MF)(Le,"canonicalUriProvider"),ht.registerCanonicalUriProvider(te,fe)),getCanonicalUri:(te,fe,Te)=>((0,Oe.$MF)(Le,"canonicalUriProvider"),ht.provideCanonicalUri(te,fe,Te))},fn={get inputBox(){return Fe.report("scm.inputBox",Le,"Use 'SourceControl.inputBox' instead"),bi.getLastInputBox(Le)},createSourceControl(te,fe,Te){return bi.createSourceControl(Le,te,fe,Te)}},on={createCommentController(te,fe){return Pi.createCommentController(Le,te,fe)}},an={get activeDebugSession(){return mt.activeDebugSession},get activeDebugConsole(){return mt.activeDebugConsole},get breakpoints(){return mt.breakpoints},get stackFrameFocus(){return mt.stackFrameFocus},onDidStartDebugSession(te,fe,Te){return mt.onDidStartDebugSession(te,fe,Te)},onDidTerminateDebugSession(te,fe,Te){return mt.onDidTerminateDebugSession(te,fe,Te)},onDidChangeActiveDebugSession(te,fe,Te){return mt.onDidChangeActiveDebugSession(te,fe,Te)},onDidReceiveDebugSessionCustomEvent(te,fe,Te){return mt.onDidReceiveDebugSessionCustomEvent(te,fe,Te)},onDidChangeBreakpoints(te,fe,Te){return mt.onDidChangeBreakpoints(te,fe,Te)},onDidChangeStackFrameFocus(te,fe,Te){return(0,Oe.$MF)(Le,"debugFocus"),mt.onDidChangeStackFrameFocus(te,fe,Te)},registerDebugConfigurationProvider(te,fe,Te){return mt.registerDebugConfigurationProvider(te,fe,Te||Qe.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(te,fe){return mt.registerDebugAdapterDescriptorFactory(Le,te,fe)},registerDebugAdapterTrackerFactory(te,fe){return mt.registerDebugAdapterTrackerFactory(te,fe)},startDebugging(te,fe,Te){return!Te||typeof Te=="object"&&"configuration"in Te?mt.startDebugging(te,fe,{parentSession:Te}):mt.startDebugging(te,fe,Te||{})},stopDebugging(te){return mt.stopDebugging(te)},addBreakpoints(te){return mt.addBreakpoints(te)},removeBreakpoints(te){return mt.removeBreakpoints(te)},asDebugSourceUri(te,fe){return mt.asDebugSourceUri(te,fe)}},zi={registerTaskProvider:(te,fe)=>Kt.registerTaskProvider(Le,te,fe),fetchTasks:te=>Kt.fetchTasks(te),executeTask:te=>Kt.executeTask(Le,te),get taskExecutions(){return Kt.taskExecutions},onDidStartTask:(te,fe,Te)=>Kt.onDidStartTask(te,fe,Te),onDidEndTask:(te,fe,Te)=>Kt.onDidEndTask(te,fe,Te),onDidStartTaskProcess:(te,fe,Te)=>Kt.onDidStartTaskProcess(te,fe,Te),onDidEndTaskProcess:(te,fe,Te)=>Kt.onDidEndTaskProcess(te,fe,Te)},Oi={createNotebookController(te,fe,Te,rt,yt){return si.createNotebookController(Le,te,fe,Te,rt,(0,Oe.$LF)(Le,"notebookMessaging")?yt:void 0)},registerNotebookCellStatusBarItemProvider:(te,fe)=>Dt.registerNotebookCellStatusBarItemProvider(Le,te,fe),createRendererMessaging(te){return Di.createRendererMessaging(Le,te)},createNotebookControllerDetectionTask(te){return(0,Oe.$MF)(Le,"notebookKernelSource"),si.createNotebookControllerDetectionTask(Le,te)},registerKernelSourceActionProvider(te,fe){return(0,Oe.$MF)(Le,"notebookKernelSource"),si.registerKernelSourceActionProvider(Le,te,fe)},onDidChangeNotebookCellExecutionState(te,fe,Te){return(0,Oe.$MF)(Le,"notebookCellExecutionState"),si.onDidChangeNotebookCellExecutionState(te,fe,Te)}},Ni={t(...te){if(typeof te[0]=="string"){const fe=te.shift(),Te=!te||typeof te[0]!="object"?te:te[0];return Wt.getMessage(Le.identifier.value,{message:fe,args:Te})}return Wt.getMessage(Le.identifier.value,te[0])},get bundle(){return Wt.getBundle(Le.identifier.value)},get uri(){return Wt.getBundleUri(Le.identifier.value)}},di={_version:1,registerInteractiveEditorSessionProvider(te){return(0,Oe.$MF)(Le,"interactive"),Gi.registerProvider(Le,te)},registerInteractiveSessionProvider(te,fe){return(0,Oe.$MF)(Le,"interactive"),ui.registerChatProvider(Le,te,fe)},addInteractiveRequest(te){return(0,Oe.$MF)(Le,"interactive"),ui.addChatRequest(te)},sendInteractiveRequestToProvider(te,fe){return(0,Oe.$MF)(Le,"interactive"),ui.sendInteractiveRequestToProvider(te,fe)},get onDidPerformUserAction(){return(0,Oe.$MF)(Le,"interactiveUserActions"),ui.onDidPerformUserAction},transferChatSession(te,fe){return(0,Oe.$MF)(Le,"interactive"),ui.transferChatSession(te,fe)}},Ui={getRelatedInformation(te,fe){return(0,Oe.$MF)(Le,"aiRelatedInformation"),Xi.getRelatedInformation(Le,te,fe)},registerRelatedInformationProvider(te,fe){return(0,Oe.$MF)(Le,"aiRelatedInformation"),Xi.registerRelatedInformationProvider(Le,te,fe)},registerEmbeddingVectorProvider(te,fe){return(0,Oe.$MF)(Le,"aiRelatedInformation"),Fi.registerEmbeddingVectorProvider(Le,te,fe)}},ji={registerChatResponseProvider(te,fe,Te){return(0,Oe.$MF)(Le,"chatProvider"),fi.registerProvider(Le.identifier,te,fe,Te)},registerSlashCommand(te,fe,Te){return(0,Oe.$MF)(Le,"chatSlashCommands"),Zi.registerCommand(Le.identifier,te,fe,Te??{description:""})},requestChatAccess(te){return(0,Oe.$MF)(Le,"chatRequestAccess"),fi.requestChatResponseProvider(Le.identifier,te)},registerVariable(te,fe,Te){return(0,Oe.$MF)(Le,"chatVariables"),Qi.registerVariableResolver(Le,te,fe,Te)},registerMappedEditsProvider(te,fe){return(0,Oe.$MF)(Le,"mappedEditsProvider"),ct.registerMappedEditsProvider(Le,te,fe)}};return{version:ut.version,ai:Ui,authentication:_i,commands:xi,comments:on,chat:ji,debug:an,env:en,extensions:tn,interactive:di,l10n:Ni,languages:nn,notebooks:Oi,scm:fn,tasks:zi,tests:dn,window:rn,workspace:sn,Breakpoint:Y.$TK,TerminalOutputAnchor:Y.TerminalOutputAnchor,ChatMessage:Y.$JL,ChatMessageRole:Y.ChatMessageRole,ChatVariableLevel:Y.ChatVariableLevel,CallHierarchyIncomingCall:Y.$gK,CallHierarchyItem:Y.$fK,CallHierarchyOutgoingCall:Y.$hK,CancellationError:R.$3,CancellationTokenSource:y.$rc,CandidatePortSource:u.CandidatePortSource,CodeAction:Y.$bK,CodeActionKind:Y.$cK,CodeActionTriggerKind:Y.CodeActionTriggerKind,CodeLens:Y.$iK,Color:Y.$vK,ColorInformation:Y.$wK,ColorPresentation:Y.$xK,ColorThemeKind:Y.ColorThemeKind,CommentMode:Y.CommentMode,CommentState:Y.CommentState,CommentThreadCollapsibleState:Y.CommentThreadCollapsibleState,CommentThreadState:Y.CommentThreadState,CompletionItem:Y.$pK,CompletionItemKind:Y.CompletionItemKind,CompletionItemTag:Y.CompletionItemTag,CompletionList:Y.$qK,CompletionTriggerKind:Y.CompletionTriggerKind,ConfigurationTarget:Y.ConfigurationTarget,CustomExecution:Y.$FK,DebugAdapterExecutable:Y.$XK,DebugAdapterInlineImplementation:Y.$1K,DebugAdapterNamedPipeServer:Y.$ZK,DebugAdapterServer:Y.$YK,DebugConfigurationProviderTriggerKind:Qe.DebugConfigurationProviderTriggerKind,DebugConsoleMode:Y.DebugConsoleMode,DecorationRangeBehavior:Y.DecorationRangeBehavior,Diagnostic:Y.$9J,DiagnosticRelatedInformation:Y.$8J,DiagnosticSeverity:Y.DiagnosticSeverity,DiagnosticTag:Y.DiagnosticTag,Disposable:Y.$UJ,DocumentHighlight:Y.$$J,DocumentHighlightKind:Y.DocumentHighlightKind,DocumentLink:Y.$uK,DocumentSymbol:Y.$aK,EndOfLine:Y.EndOfLine,EnvironmentVariableMutatorType:Y.EnvironmentVariableMutatorType,EvaluatableExpression:Y.$4K,InlineValueText:Y.$5K,InlineValueVariableLookup:Y.$6K,InlineValueEvaluatableExpression:Y.$7K,InlineCompletionTriggerKind:Y.InlineCompletionTriggerKind,EventEmitter:C.$hc,ExtensionKind:Y.ExtensionKind,ExtensionMode:Y.ExtensionMode,ExternalUriOpenerPriority:Y.ExternalUriOpenerPriority,FileChangeType:Y.FileChangeType,FileDecoration:Y.$eL,FileDecoration2:Y.$eL,FileSystemError:Y.$9K,FileType:D.FileType,FilePermission:D.FilePermission,FoldingRange:Y.$0K,FoldingRangeKind:Y.FoldingRangeKind,FunctionBreakpoint:Y.$VK,InlineCompletionItem:Y.$rK,InlineCompletionList:Y.$sK,Hover:Y.$0J,IndentAction:g.IndentAction,Location:Y.$7J,MarkdownString:Y.$jK,OverviewRulerLane:S.OverviewRulerLane,ParameterInformation:Y.$kK,PortAutoForwardAction:Y.PortAutoForwardAction,Position:Y.$VJ,ProcessExecution:Y.$DK,ProgressLocation:Y.ProgressLocation,QuickInputButtons:Y.$dL,Range:Y.$WJ,RelativePattern:Y.$RK,Selection:Y.$XJ,SelectionRange:Y.$eK,SemanticTokens:Y.$aL,SemanticTokensBuilder:Y.$_K,SemanticTokensEdit:Y.$bL,SemanticTokensEdits:Y.$cL,SemanticTokensLegend:Y.$$K,ShellExecution:Y.$EK,ShellQuoting:Y.ShellQuoting,SignatureHelp:Y.$mK,SignatureHelpTriggerKind:Y.SignatureHelpTriggerKind,SignatureInformation:Y.$lK,SnippetString:Y.$6J,SourceBreakpoint:Y.$UK,StandardTokenType:Y.StandardTokenType,StatusBarAlignment:Y.StatusBarAlignment,SymbolInformation:Y.$_J,SymbolKind:Y.SymbolKind,SymbolTag:Y.SymbolTag,Task:Y.$GK,TaskGroup:Y.$CK,TaskPanelKind:Y.TaskPanelKind,TaskRevealKind:Y.TaskRevealKind,TaskScope:Y.TaskScope,TerminalLink:Y.$yK,TerminalQuickFixExecuteTerminalCommand:Y.$AK,TerminalQuickFixOpener:Y.$zK,TerminalLocation:Y.TerminalLocation,TerminalProfile:Y.$BK,TerminalExitReason:Y.TerminalExitReason,TextDocumentSaveReason:Y.TextDocumentSaveReason,TextEdit:Y.$2J,SnippetTextEdit:Y.$4J,TextEditorCursorStyle:h.TextEditorCursorStyle,TextEditorLineNumbersStyle:Y.TextEditorLineNumbersStyle,TextEditorRevealType:Y.TextEditorRevealType,TextEditorSelectionChangeKind:Y.TextEditorSelectionChangeKind,TextDocumentChangeReason:Y.TextDocumentChangeReason,ThemeColor:Y.$QK,ThemeIcon:Y.$PK,TreeItem:Y.$HK,TreeItemCheckboxState:Y.TreeItemCheckboxState,TreeItemCollapsibleState:Y.TreeItemCollapsibleState,TypeHierarchyItem:Y.$zL,UIKind:p.UIKind,Uri:A.URI,ViewColumn:Y.ViewColumn,WorkspaceEdit:Y.$5J,DocumentDropEdit:Y.$NK,DocumentPasteEdit:Y.$OK,InlayHint:Y.$oK,InlayHintLabelPart:Y.$nK,InlayHintKind:Y.InlayHintKind,RemoteAuthorityResolverError:Y.$1J,ResolvedAuthority:Y.$YJ,ManagedResolvedAuthority:Y.$ZJ,SourceControlInputBoxValidationType:Y.SourceControlInputBoxValidationType,ExtensionRuntime:Y.ExtensionRuntime,TimelineItem:Y.$oL,NotebookRange:Y.$gL,NotebookCellKind:Y.NotebookCellKind,NotebookCellExecutionState:Y.NotebookCellExecutionState,NotebookCellData:Y.$hL,NotebookData:Y.$iL,NotebookRendererScript:Y.$mL,NotebookCellStatusBarAlignment:Y.NotebookCellStatusBarAlignment,NotebookEditorRevealType:Y.NotebookEditorRevealType,NotebookCellOutput:Y.$kL,NotebookCellOutputItem:Y.$jL,NotebookCellStatusBarItem:Y.$lL,NotebookControllerAffinity:Y.NotebookControllerAffinity,NotebookControllerAffinity2:Y.NotebookControllerAffinity2,NotebookEdit:Y.$3J,NotebookKernelSourceAction:Y.$nL,PortAttributes:Y.$qL,LinkedEditingRanges:Y.$pL,TestResultState:Y.TestResultState,TestRunRequest:Y.$rL,TestMessage:Y.$sL,TestMessage2:Y.$sL,TestTag:Y.$tL,TestRunProfileKind:Y.TestRunProfileKind,TextSearchCompleteMessageType:it.TextSearchCompleteMessageType,DataTransfer:Y.$MK,DataTransferItem:Y.$IK,CoveredCount:Y.$uL,FileCoverage:Y.$vL,StatementCoverage:Y.$wL,BranchCoverage:Y.$xL,FunctionCoverage:Y.$yL,WorkspaceTrustState:Y.WorkspaceTrustState,LanguageStatusSeverity:Y.LanguageStatusSeverity,QuickPickItemKind:Y.QuickPickItemKind,InputBoxValidationSeverity:Y.InputBoxValidationSeverity,TabInputText:Y.$AL,TabInputTextDiff:Y.$BL,TabInputTextMerge:Y.$CL,TabInputCustom:Y.$DL,TabInputNotebook:Y.$FL,TabInputNotebookDiff:Y.$GL,TabInputWebview:Y.$EL,TabInputTerminal:Y.$HL,TabInputInteractiveWindow:Y.$IL,TelemetryTrustedValue:ye.$0n,LogLevel:ve.LogLevel,EditSessionIdentityMatch:gt.EditSessionIdentityMatch,InteractiveSessionVoteDirection:Y.InteractiveSessionVoteDirection,InteractiveSessionCopyKind:Y.InteractiveSessionCopyKind,InteractiveEditorResponseFeedbackKind:Y.InteractiveEditorResponseFeedbackKind,StackFrameFocus:Y.$2K,ThreadFocus:Y.$3K,NotebookCodeActionKind:Y.$dK,RelatedInformationType:Y.RelatedInformationType}}}e.$zcc=Bt}),define(Pe[273],Ae([1,0,70,110,33,108,34,31,59,62,112,114,115,84,86,80,109,61,39,83,57,60,241,14,113,81,82]),function(pe,e,y,R,C,L,A,h,S,g,P,D,u,p,$,d,t,i,c,m,E,b,n,a,s,o,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,y.$jr)(o.$abc,o.$_ac,1),(0,y.$jr)(a.$4i,n.$Acc,1),(0,y.$jr)(d.$zac,d.$Aac,1),(0,y.$jr)(h.$eM,h.$dM,0),(0,y.$jr)(A.$Mac,A.$Kac,0),(0,y.$jr)(i.$2ac,i.$1ac,0),(0,y.$jr)(D.$Pbc,D.$Tbc,0),(0,y.$jr)(L.$Hbc,L.$Gbc,0),(0,y.$jr)(S.$6L,S.$5L,0),(0,y.$jr)(w.$bbc,w.$cbc,0),(0,y.$jr)(c.$wac,c.$vac,0),(0,y.$jr)(R.$nbc,R.$mbc,1),(0,y.$jr)(u.$Zbc,u.$1bc,0),(0,y.$jr)(p.$Xac,p.$Wac,0),(0,y.$jr)(P.$Kbc,P.$Jbc,0),(0,y.$jr)(g.$5ac,g.$8ac,0),(0,y.$jr)($.$3rb,$.$4rb,0),(0,y.$jr)(t.$Dbc,t.$Cbc,0),(0,y.$jr)(C.$Jac,C.$Iac,0),(0,y.$jr)(m.$0ac,m.$9ac,0),(0,y.$jr)(E.$cM,E.$_L,0),(0,y.$jr)(b.$Lbc,b.$Mbc,0),(0,y.$jr)(s.$Nbc,s.$Obc,0)}),define(Pe[274],Ae([1,0,272,35,2,269,7,13,260]),function(pe,e,y,R,C,L,A,h,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jec=void 0;class g extends L.$Dcc{j(){}getModule(p,$){for(const d of this.b){const t=d(p);if(t){p=t;break}}if(this.a.has(p))return this.a.get(p).load(p,$,()=>{throw new Error("CANNOT LOAD MODULE from here.")})}}class P extends R.$ebc{constructor(){super(...arguments),this.extensionRuntime=A.ExtensionRuntime.Webworker}async pb(){this.h.createInstance(S.$Iec);const p=this.h.invokeFunction(y.$zcc);this.r=this.h.createInstance(g,p,{mine:this.F,all:this.G}),await this.r.install(),performance.mark("code/extHost/didInitAPI"),await this.vb()}qb(p){return p.browser}async rb(p,$,d){$=$.with({path:D($.path,".js")});const t=p?.identifier.value;t&&performance.mark(`code/extHost/willFetchExtensionCode/${t}`);const i=C.URI.revive(await this.v.$asBrowserUri($)),c=await fetch(i.toString(!0));if(t&&performance.mark(`code/extHost/didFetchExtensionCode/${t}`),c.status!==200)throw new Error(c.statusText);const m=await c.text(),E=`${$.toString(!0)}#vscode-extension`,b=`${m}
//# sourceURL=${E}`;let n;try{n=new Function("module","exports","require",b)}catch(w){throw console.error(t?`Loading code for extension ${t} failed: ${w.message}`:`Loading code failed: ${w.message}`),console.error(`${$.toString(!0)}${typeof w.line=="number"?` line ${w.line}`:""}${typeof w.column=="number"?` column ${w.column}`:""}`),console.error(w),w}p&&await this.s.initializeLocalizedMessages(p);const a={},s={exports:a},o=w=>{const v=this.r.getModule(w,$);if(v===void 0)throw new Error(`Cannot load module '${w}'`);return v};try{return d.codeLoadingStart(),t&&performance.mark(`code/extHost/willLoadExtensionCode/${t}`),n(s,a,o),s.exports!==a?s.exports:a}finally{t&&performance.mark(`code/extHost/didLoadExtensionCode/${t}`),d.codeLoadingStop()}}async $setRemoteEnvironment(p){}async vb(p=5e3){if(!this.f.environment.isExtensionDevelopmentDebug)return;const $=Date.now()+p;for(;Date.now()<$&&!("__jsDebugIsReady"in globalThis);)await(0,h.$Fg)(10)}}e.$Jec=P;function D(u,p){return u.endsWith(p)?u:u+p}}),define(Pe[275],Ae([1,0,69,70,14,35,188,85,274]),function(pe,e,y,R,C,L,A,h,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,R.$jr)(C.$3i,new y.$wh(A.$Ccc,[!0],!0)),(0,R.$jr)(L.$fbc,S.$Jec,0),(0,R.$jr)(h.$3ac,h.$4ac,0)}),define(Pe[284],Ae([1,0,25,5,79,270,262,19,87,12,2,273,275]),function(pe,e,y,R,C,L,A,h,S,g,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.create=void 0;const D=self.close.bind(self);self.close=()=>console.trace("'close' has been blocked");const u=postMessage.bind(self);self.postMessage=()=>console.trace("'postMessage' has been blocked");function p(n){return/^(file|vscode-remote):/i.test(n)}const $=fetch.bind(self);function d(n){self.fetch=async function(a,s){return a instanceof Request||p(String(a))&&(a=(await n(P.URI.parse(String(a)))).toString(!0)),$(a,s)},self.XMLHttpRequest=class extends XMLHttpRequest{open(a,s,o,w,v){(async()=>(p(s.toString())&&(s=(await n(P.URI.parse(s.toString()))).toString(!0)),super.open(a,s,o??!0,w,v)))()}}}if(self.importScripts=()=>{throw new Error("'importScripts' has been blocked")},self.addEventListener=()=>console.trace("'addEventListener' has been blocked"),self.AMDLoader=void 0,self.NLSLoaderPlugin=void 0,self.define=void 0,self.require=void 0,self.webkitRequestFileSystem=void 0,self.webkitRequestFileSystemSync=void 0,self.webkitResolveLocalFileSystemSyncURL=void 0,self.webkitResolveLocalFileSystemURL=void 0,self.Worker){const n=self.Worker;Worker=function(a,s){if(/^file:/i.test(a.toString()))a=g.$4e.uriToBrowserUri(P.URI.parse(a.toString())).toString(!0);else if(/^vscode-remote:/i.test(a.toString()))throw new Error("Creating workers from remote extensions is currently not supported.");const w=`(${function(r){function l(W){return typeof W=="string"||W instanceof URL?String(W).replace(/^file:\/\//i,"vscode-file://vscode-app"):W}const f=fetch.bind(self);self.fetch=function(W,V){return W instanceof Request?f(W,V):f(l(W),V)},self.XMLHttpRequest=class extends XMLHttpRequest{open(W,V,B,j,U){return super.open(W,l(V),B??!0,j,U)}};const F=importScripts.bind(self);self.importScripts=(...W)=>{F(...W.map(l))},F(r)}.toString()}('${a}'))`;s=s||{},s.name=s.name||h.$cd(a.toString());const v=new Blob([w],{type:"application/javascript"}),I=URL.createObjectURL(v);return new n(I,s)}}else self.Worker=class extends A.$Kec{constructor(n,a){super(u,n,{name:h.$cd(n.toString()),...a})}};const t=new class{constructor(){this.pid=void 0}exit(n){D()}};class i{constructor(){const a=new MessageChannel,s=new R.$hc;let o=!1;u(a.port2,[a.port2]),a.port1.onmessage=w=>{const{data:v}=w;if(!(v instanceof ArrayBuffer)){console.warn("UNKNOWN data received",v);return}const I=y.$Hc.wrap(new Uint8Array(v,0,v.byteLength));if((0,C.$3l)(I,2)){o=!0,m("received terminate message from renderer");return}s.fire(I)},this.protocol={onMessage:s.event,send:w=>{if(!o){const v=w.buffer.buffer.slice(w.buffer.byteOffset,w.buffer.byteOffset+w.buffer.byteLength);a.port1.postMessage(v,[v])}}}}}function c(n){return new Promise(a=>{const s=n.onMessage(o=>{s.dispose();const w=JSON.parse(o.toString());n.send((0,C.$2l)(0)),a({protocol:n,initData:w})});n.send((0,C.$2l)(1))})}let m=n=>D();function E(n){return!!n&&typeof n=="object"&&n.type==="vscode.init"&&n.data instanceof Map}function b(){S.mark("code/extHost/willConnectToRenderer");const n=new i;return{onmessage(a){E(a)&&c(n.protocol).then(s=>{S.mark("code/extHost/didWaitForInitData");const o=new L.$Fcc(s.protocol,s.initData,t,null,a.data);d(w=>o.asBrowserUri(w)),m=w=>o.terminate(w)})}}}e.create=b})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/3c133b63c6e17e2fe33f37db93a6d43e78a262c5/core/vs/workbench/api/worker/extensionHostWorker.js.map
